// the url of the main doc tree, for compact url
// representation (see also the UncompactUrl function)
plt_main_url = "../";

// classes to be used for compact representation of html strings in
// plt_search_data below (see also the UncompactHtml function)
plt_span_classes = [
  "RktSym",
  "RktStxLink",
  "RktValLink",
  "RktInBG",
  "hspace",
  "RktIn",
  "stt",
  "RktVal",
  "RktPn",
  "RktModLink",
  "RktMod",
  "nobreak",
  "plainlink",
  "RktMeta",
  "smaller",
  "noborder",
  "RktVar"];

// this array has an entry of four items for each index link:
// - text is a string holding the indexed text
// - url holds the link (">" prefix means relative to plt_main_url)
// - html holds either a string, or [idx, html] where idx is an
//   index into plt_span_classes (note: this is recursive)
// - from_lib is an array of module names for bound identifiers,
//   or the string "module" for a module entry
plt_search_data = [
["!",">datalog/interop.html#(form._((lib._datalog/main..rkt)._!))",[0,[1,"!"]],["datalog"]],
["!",">lazy/index.html#(def._((lib._lazy/force..rkt)._!))",[0,[2,"!"]],["lazy/force"]],
["!",">racklog/glossary.html#(form._((lib._racklog/main..rkt)._!))",[0,[1,"!"]],["racklog"]],
["!!",">lazy/index.html#(def._((lib._lazy/force..rkt)._!!))",[0,[2,"!!"]],["lazy/force"]],
["!!list",">lazy/index.html#(def._((lib._lazy/force..rkt)._!!list))",[0,[2,"!!list"]],["lazy/force"]],
["!list",">lazy/index.html#(def._((lib._lazy/force..rkt)._!list))",[0,[2,"!list"]],["lazy/force"]],
["\"",">reference/reader.html#(idx._(gentag._34._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"\""],[4,""]]],false],
["\".plt\"",">raco/plt.html#(idx._(gentag._3._(lib._scribblings/raco/raco..scrbl)))",[6,"\".plt\""],false],
["\"escheme.h\"",">inside/overview.html#(idx._(gentag._4._(lib._scribblings/inside/inside..scrbl)))",[6,"\"escheme.h\""],false],
["\"hello world\" server",">more/index.html#(part.__.Hello_.World__.Server)","&ldquo;Hello World&rdquo; Server",false],
["\"info.rkt\" file format",">raco/info_rkt.html",[[6,"\"info.rkt\""]," File Format"],false],
["\"libmzgc.a\"",">inside/overview.html#(idx._(gentag._18._(lib._scribblings/inside/inside..scrbl)))",[6,"\"libmzgc.a\""],false],
["\"libmzgc.la\"",">inside/overview.html#(idx._(gentag._22._(lib._scribblings/inside/inside..scrbl)))",[6,"\"libmzgc.la\""],false],
["\"libmzgc.so\"",">inside/overview.html#(idx._(gentag._20._(lib._scribblings/inside/inside..scrbl)))",[6,"\"libmzgc.so\""],false],
["\"libracket.a\"",">inside/overview.html#(idx._(gentag._17._(lib._scribblings/inside/inside..scrbl)))",[6,"\"libracket.a\""],false],
["\"libracket.la\"",">inside/overview.html#(idx._(gentag._21._(lib._scribblings/inside/inside..scrbl)))",[6,"\"libracket.la\""],false],
["\"libracket.so\"",">inside/overview.html#(idx._(gentag._19._(lib._scribblings/inside/inside..scrbl)))",[6,"\"libracket.so\""],false],
["\"libracket3m.a\"",">inside/overview.html#(idx._(gentag._25._(lib._scribblings/inside/inside..scrbl)))",[6,"\"libracket3m.a\""],false],
["\"libracket3m.la\"",">inside/overview.html#(idx._(gentag._27._(lib._scribblings/inside/inside..scrbl)))",[6,"\"libracket3m.la\""],false],
["\"libracket3m.so\"",">inside/overview.html#(idx._(gentag._26._(lib._scribblings/inside/inside..scrbl)))",[6,"\"libracket3m.so\""],false],
["\"mzdyn.o\"",">inside/overview.html#(idx._(gentag._8._(lib._scribblings/inside/inside..scrbl)))",[6,"\"mzdyn.o\""],false],
["\"mzdyn.obj\"",">inside/overview.html#(idx._(gentag._9._(lib._scribblings/inside/inside..scrbl)))",[6,"\"mzdyn.obj\""],false],
["\"mzdyn3m.o\"",">inside/overview.html#(idx._(gentag._14._(lib._scribblings/inside/inside..scrbl)))",[6,"\"mzdyn3m.o\""],false],
["\"mzdyn3m.obj\"",">inside/overview.html#(idx._(gentag._15._(lib._scribblings/inside/inside..scrbl)))",[6,"\"mzdyn3m.obj\""],false],
["\"scheme\" versus \"racket\"",">inside/overview.html#(part.__.Scheme__versus__.Racket_)","&ldquo;Scheme&rdquo; versus &ldquo;Racket&rdquo;",false],
["\"scheme.h\"",">inside/overview.html#(idx._(gentag._23._(lib._scribblings/inside/inside..scrbl)))",[6,"\"scheme.h\""],false],
["\"unsafe context\"",">web-server/stateless.html#(idx._(gentag._1._(lib._web-server/scribblings/web-server..scrbl)))","\"unsafe context\"",false],
["#!",">reference/reader.html#(idx._(gentag._66._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"#!"],[4,"&nbsp;"]]],false],
["#!",">guide/scripts.html#(idx._(gentag._7._(lib._scribblings/guide/guide..scrbl)))",[6,"#!"],false],
["#!",">reference/reader.html#(idx._(gentag._80._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"#!"],[4,""]]],false],
["#!/",">reference/reader.html#(idx._(gentag._67._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"#!/"],[4,""]]],false],
["#\"",">reference/reader.html#(idx._(gentag._52._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"#\""],[4,""]]],false],
["#%",">reference/reader.html#(idx._(gentag._4._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"#%"],[4,""]]],false],
["#%#",">web-server/formlets.html#(form._((lib._web-server/formlets/syntax..rkt)._~23~25~23))",[0,[1,"#%#"]],["web-server/formlets/syntax"]],
["#%app",">reference/application.html#(form._((lib._racket/private/base..rkt)._~23~25app))",[0,[1,"#%app"]],["racket/base","racket"]],
["#%app",">mzscheme/Old_Syntactic_Forms.html#(form._((lib._mzscheme/main..rkt)._~23~25app))",[0,[1,"#%app"]],["mzscheme"]],
["#%datum",">reference/quote.html#(form._((quote._~23~25kernel)._~23~25datum))",[0,[1,"#%datum"]],["racket/base","racket"]],
["#%datum",">mzscheme/Old_Syntactic_Forms.html#(form._((lib._mzscheme/main..rkt)._~23~25datum))",[0,[1,"#%datum"]],["mzscheme"]],
["#%expression",">reference/__expression.html#(form._((quote._~23~25kernel)._~23~25expression))",[0,[1,"#%expression"]],["racket/base","racket"]],
["#%kernel",">reference/running-sa.html#(idx._(gentag._347._(lib._scribblings/reference/reference..scrbl)))",[7,"'#%kernel"],false],
["#%kernel",">reference/running-sa.html#(idx._(gentag._348._(lib._scribblings/reference/reference..scrbl)))",[7,"'#%kernel"],false],
["#%module-begin",">reference/module.html#(form._((lib._racket/private/base..rkt)._~23~25module-begin))",[0,[1,"#%module-begin"]],["racket/base","racket"]],
["#%module-begin",">r6rs/r6rs-mod.html#(form._((lib._r6rs/main..rkt)._~23~25module-begin))",[0,[1,"#%module-begin"]],["r6rs"]],
["#%module-begin",">mzscheme/Old_Syntactic_Forms.html#(form._((lib._mzscheme/main..rkt)._~23~25module-begin))",[0,[1,"#%module-begin"]],["mzscheme"]],
["#%module-begin",">syntax/reader-helpers.html#(form._((lib._syntax/module-reader..rkt)._~23~25module-begin))",[0,[1,"#%module-begin"]],["syntax/module-reader"]],
["#%module-begin",">ts-reference/special-forms.html#(form._((lib._typed-racket/typed-racket..rkt)._~23~25module-begin))",[0,[1,"#%module-begin"]],["typed/racket/base","typed/racket"]],
["#%plain-app",">reference/application.html#(form._((lib._racket/private/base..rkt)._~23~25plain-app))",[0,[1,"#%plain-app"]],["racket/base","racket"]],
["#%plain-app",">mzscheme/Old_Syntactic_Forms.html#(form._((lib._mzscheme/main..rkt)._~23~25plain-app))",[0,[1,"#%plain-app"]],["mzscheme"]],
["#%plain-lambda",">reference/lambda.html#(form._((lib._racket/private/base..rkt)._~23~25plain-lambda))",[0,[1,"#%plain-lambda"]],["racket/base","racket"]],
["#%plain-lambda",">mzscheme/Old_Syntactic_Forms.html#(form._((lib._mzscheme/main..rkt)._~23~25plain-lambda))",[0,[1,"#%plain-lambda"]],["mzscheme"]],
["#%plain-module-begin",">reference/module.html#(form._((lib._racket/private/base..rkt)._~23~25plain-module-begin))",[0,[1,"#%plain-module-begin"]],["racket/base","racket"]],
["#%plain-module-begin",">mzscheme/Old_Syntactic_Forms.html#(form._((lib._mzscheme/main..rkt)._~23~25plain-module-begin))",[0,[1,"#%plain-module-begin"]],["mzscheme"]],
["#%provide",">reference/require.html#(form._((quote._~23~25kernel)._~23~25provide))",[0,[1,"#%provide"]],["racket/base","racket"]],
["#%require",">reference/require.html#(form._((quote._~23~25kernel)._~23~25require))",[0,[1,"#%require"]],["racket/base","racket"]],
["#%stratified-body",">reference/stratified-body.html#(form._((quote._~23~25kernel)._~23~25stratified-body))",[0,[1,"#%stratified-body"]],["racket/base","racket"]],
["#%top",">reference/__top.html#(form._((quote._~23~25kernel)._~23~25top))",[0,[1,"#%top"]],["racket/base","racket"]],
["#%top-interaction",">reference/__top-interaction.html#(form._((lib._racket/private/base..rkt)._~23~25top-interaction))",[0,[1,"#%top-interaction"]],["racket/base","racket"]],
["#%top-interaction",">mzscheme/Old_Syntactic_Forms.html#(form._((lib._mzscheme/main..rkt)._~23~25top-interaction))",[0,[1,"#%top-interaction"]],["mzscheme"]],
["#%top-interaction",">ts-reference/special-forms.html#(form._((lib._typed-racket/typed-racket..rkt)._~23~25top-interaction))",[0,[1,"#%top-interaction"]],["typed/racket/base","typed/racket"]],
["#%variable-reference",">reference/Locations____variable-reference.html#(form._((quote._~23~25kernel)._~23~25variable-reference))",[0,[1,"#%variable-reference"]],["racket/base","racket"]],
["#%variable-reference",">inside/im_env.html#(idx._(gentag._274._(lib._scribblings/inside/inside..scrbl)))",[0,[1,"#%variable-reference"]],false],
["#&",">reference/reader.html#(idx._(gentag._71._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"#&"],[4,""]]],false],
["#'",">reference/reader.html#(idx._(gentag._59._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"#'"],[4,""]]],false],
["#,",">reference/reader.html#(idx._(gentag._61._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"#,"],[4,""]]],false],
["#,@",">reference/reader.html#(idx._(gentag._62._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"#,@"],[4,""]]],false],
["#0#",">reference/reader.html#(idx._(gentag._76._(lib._scribblings/reference/reference..scrbl)))","#0#",false],
["#0=",">reference/reader.html#(idx._(gentag._77._(lib._scribblings/reference/reference..scrbl)))","#0=",false],
["#:",">reference/reader.html#(idx._(gentag._73._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"#:"],[4,""]]],false],
["#:all-keys",">mzlib/mzlib_kw.html#(idx._(gentag._4._(lib._mzlib/scribblings/mzlib..scrbl)))",[8,"#:all-keys"],false],
["#:allow-anything",">mzlib/mzlib_kw.html#(idx._(gentag._11._(lib._mzlib/scribblings/mzlib..scrbl)))",[8,"#:allow-anything"],false],
["#:allow-body",">mzlib/mzlib_kw.html#(idx._(gentag._9._(lib._mzlib/scribblings/mzlib..scrbl)))",[8,"#:allow-body"],false],
["#:allow-duplicate-keys",">mzlib/mzlib_kw.html#(idx._(gentag._7._(lib._mzlib/scribblings/mzlib..scrbl)))",[8,"#:allow-duplicate-keys"],false],
["#:allow-other-keys",">mzlib/mzlib_kw.html#(idx._(gentag._5._(lib._mzlib/scribblings/mzlib..scrbl)))",[8,"#:allow-other-keys"],false],
["#:body",">mzlib/mzlib_kw.html#(idx._(gentag._3._(lib._mzlib/scribblings/mzlib..scrbl)))",[8,"#:body"],false],
["#:forbid-anything",">mzlib/mzlib_kw.html#(idx._(gentag._12._(lib._mzlib/scribblings/mzlib..scrbl)))",[8,"#:forbid-anything"],false],
["#:forbid-body",">mzlib/mzlib_kw.html#(idx._(gentag._10._(lib._mzlib/scribblings/mzlib..scrbl)))",[8,"#:forbid-body"],false],
["#:forbid-duplicate-keys",">mzlib/mzlib_kw.html#(idx._(gentag._8._(lib._mzlib/scribblings/mzlib..scrbl)))",[8,"#:forbid-duplicate-keys"],false],
["#:forbid-other-keys",">mzlib/mzlib_kw.html#(idx._(gentag._6._(lib._mzlib/scribblings/mzlib..scrbl)))",[8,"#:forbid-other-keys"],false],
["#:key",">mzlib/mzlib_kw.html#(idx._(gentag._1._(lib._mzlib/scribblings/mzlib..scrbl)))",[8,"#:key"],false],
["#:optional",">mzlib/mzlib_kw.html#(idx._(gentag._0._(lib._mzlib/scribblings/mzlib..scrbl)))",[8,"#:optional"],false],
["#:rest",">mzlib/mzlib_kw.html#(idx._(gentag._2._(lib._mzlib/scribblings/mzlib..scrbl)))",[8,"#:rest"],false],
["#;",">reference/reader.html#(idx._(gentag._65._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"#;"],[4,""]]],false],
["#<<",">reference/reader.html#(idx._(gentag._53._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"#<<"],[4,""]]],false],
["#\\",">reference/reader.html#(idx._(gentag._72._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"#\\"],[4,""]]],false],
["#`",">reference/reader.html#(idx._(gentag._60._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"#`"],[4,""]]],false],
["#b",">reference/reader.html#(idx._(gentag._12._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"#b"],[4,""]]],false],
["#ci",">reference/reader.html#(idx._(gentag._7._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"#ci"],[4,""]]],false],
["#cs",">reference/reader.html#(idx._(gentag._8._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"#cs"],[4,""]]],false],
["#d",">reference/reader.html#(idx._(gentag._14._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"#d"],[4,""]]],false],
["#e",">reference/reader.html#(idx._(gentag._10._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"#e"],[4,""]]],false],
["#f",">reference/reader.html#(idx._(gentag._21._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"#F"],[4,""]]],false],
["#f",">deinprogramm/_t_and__f.html#(idx._(gentag._1._(lib._deinprogramm/scribblings/deinprogramm..scrbl)))",[3,[[4,""],[5,"#f"],[4,""]]],false],
["#f",">reference/reader.html#(idx._(gentag._20._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"#f"],[4,""]]],false],
["#false",">reference/reader.html#(idx._(gentag._19._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"#false"],[4,""]]],false],
["#hash",">reference/reader.html#(idx._(gentag._68._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"#hash"],[4,""]]],false],
["#hasheq",">reference/reader.html#(idx._(gentag._69._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"#hasheq"],[4,""]]],false],
["#hasheqv",">reference/reader.html#(idx._(gentag._70._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"#hasheqv"],[4,""]]],false],
["#i",">reference/reader.html#(idx._(gentag._11._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"#i"],[4,""]]],false],
["#lang",">reference/reader.html#(idx._(gentag._79._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"#lang"],[4,""]]],false],
["#lang-based languages in drracket",">tools/adding-languages.html#(part.__lang-based_.Languages_in_.Dr.Racket)",[[6,"#lang"],"-based Languages in DrRacket"],false],
["#lang-specified code",">scribble/scribble_manual_code.html#(part._all-code)",[[9,[10,"#lang"]],"-Specified Code"],false],
["#o",">reference/reader.html#(idx._(gentag._13._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"#o"],[4,""]]],false],
["#px",">reference/reader.html#(idx._(gentag._75._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"#px"],[4,""]]],false],
["#reader",">reference/reader.html#(idx._(gentag._78._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"#reader"],[4,""]]],false],
["#rx",">reference/reader.html#(idx._(gentag._74._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"#rx"],[4,""]]],false],
["#t",">reference/reader.html#(idx._(gentag._18._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"#T"],[4,""]]],false],
["#t",">deinprogramm/_t_and__f.html#(idx._(gentag._0._(lib._deinprogramm/scribblings/deinprogramm..scrbl)))",[3,[[4,""],[5,"#t"],[4,""]]],false],
["#t",">reference/reader.html#(idx._(gentag._17._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"#t"],[4,""]]],false],
["#t and #f",">deinprogramm/_t_and__f.html",[[7,"#t"]," and ",[7,"#f"]],false],
["#true",">reference/reader.html#(idx._(gentag._16._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"#true"],[4,""]]],false],
["#x",">reference/reader.html#(idx._(gentag._15._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"#x"],[4,""]]],false],
["#|",">reference/reader.html#(idx._(gentag._64._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"#|"],[4,""]]],false],
["%",">reference/cont.html#(form._((lib._racket/control..rkt)._~25))",[0,[1,"%"]],["racket/control"]],
["%/=",">racklog/glossary.html#(def._((lib._racklog/main..rkt)._~25/~3d))",[0,[2,"%/="]],["racklog"]],
["%/==",">racklog/glossary.html#(def._((lib._racklog/main..rkt)._~25/~3d~3d))",[0,[2,"%/=="]],["racklog"]],
["%<",">racklog/glossary.html#(def._((lib._racklog/main..rkt)._~25~3c))",[0,[2,"%<"]],["racklog"]],
["%<=",">racklog/glossary.html#(def._((lib._racklog/main..rkt)._~25~3c~3d))",[0,[2,"%<="]],["racklog"]],
["%=",">racklog/glossary.html#(def._((lib._racklog/main..rkt)._~25~3d))",[0,[2,"%="]],["racklog"]],
["%=/=",">racklog/glossary.html#(def._((lib._racklog/main..rkt)._~25~3d/~3d))",[0,[2,"%=/="]],["racklog"]],
["%=:=",">racklog/glossary.html#(def._((lib._racklog/main..rkt)._~25~3d~3a~3d))",[0,[2,"%=:="]],["racklog"]],
["%==",">racklog/glossary.html#(def._((lib._racklog/main..rkt)._~25~3d~3d))",[0,[2,"%=="]],["racklog"]],
["%>",">racklog/glossary.html#(def._((lib._racklog/main..rkt)._~25~3e))",[0,[2,"%>"]],["racklog"]],
["%>=",">racklog/glossary.html#(def._((lib._racklog/main..rkt)._~25~3e~3d))",[0,[2,"%>="]],["racklog"]],
["%and",">racklog/glossary.html#(form._((lib._racklog/main..rkt)._~25and))",[0,[1,"%and"]],["racklog"]],
["%append",">racklog/glossary.html#(def._((lib._racklog/main..rkt)._~25append))",[0,[2,"%append"]],["racklog"]],
["%assert!",">racklog/glossary.html#(form._((lib._racklog/main..rkt)._~25assert!))",[0,[1,"%assert!"]],["racklog"]],
["%assert-after!",">racklog/glossary.html#(form._((lib._racklog/main..rkt)._~25assert-after!))",[0,[1,"%assert-after!"]],["racklog"]],
["%bag-of",">racklog/glossary.html#(def._((lib._racklog/main..rkt)._~25bag-of))",[0,[2,"%bag-of"]],["racklog"]],
["%bag-of-1",">racklog/glossary.html#(def._((lib._racklog/main..rkt)._~25bag-of-1))",[0,[2,"%bag-of-1"]],["racklog"]],
["%compound",">racklog/glossary.html#(def._((lib._racklog/main..rkt)._~25compound))",[0,[2,"%compound"]],["racklog"]],
["%constant",">racklog/glossary.html#(def._((lib._racklog/main..rkt)._~25constant))",[0,[2,"%constant"]],["racklog"]],
["%copy",">racklog/glossary.html#(def._((lib._racklog/main..rkt)._~25copy))",[0,[2,"%copy"]],["racklog"]],
["%cut-delimiter",">racklog/glossary.html#(form._((lib._racklog/main..rkt)._~25cut-delimiter))",[0,[1,"%cut-delimiter"]],["racklog"]],
["%empty-rel",">racklog/glossary.html#(def._((lib._racklog/main..rkt)._~25empty-rel))",[0,[2,"%empty-rel"]],["racklog"]],
["%fail",">racklog/glossary.html#(def._((lib._racklog/main..rkt)._~25fail))",[0,[2,"%fail"]],["racklog"]],
["%find-all",">racklog/glossary.html#(form._((lib._racklog/main..rkt)._~25find-all))",[0,[1,"%find-all"]],["racklog"]],
["%free-vars",">racklog/glossary.html#(form._((lib._racklog/main..rkt)._~25free-vars))",[0,[1,"%free-vars"]],["racklog"]],
["%freeze",">racklog/glossary.html#(def._((lib._racklog/main..rkt)._~25freeze))",[0,[2,"%freeze"]],["racklog"]],
["%if-then-else",">racklog/glossary.html#(def._((lib._racklog/main..rkt)._~25if-then-else))",[0,[2,"%if-then-else"]],["racklog"]],
["%is",">racklog/racket-w-logic.html#(part._is)",[0,[1,"%is"]],false],
["%is",">racklog/glossary.html#(form._((lib._racklog/main..rkt)._~25is))",[0,[1,"%is"]],["racklog"]],
["%let",">racklog/glossary.html#(form._((lib._racklog/main..rkt)._~25let))",[0,[1,"%let"]],["racklog"]],
["%melt",">racklog/glossary.html#(def._((lib._racklog/main..rkt)._~25melt))",[0,[2,"%melt"]],["racklog"]],
["%melt-new",">racklog/glossary.html#(def._((lib._racklog/main..rkt)._~25melt-new))",[0,[2,"%melt-new"]],["racklog"]],
["%member",">racklog/glossary.html#(def._((lib._racklog/main..rkt)._~25member))",[0,[2,"%member"]],["racklog"]],
["%more",">racklog/glossary.html#(def._((lib._racklog/main..rkt)._~25more))",[0,[2,"%more"]],["racklog"]],
["%nonvar",">racklog/glossary.html#(def._((lib._racklog/main..rkt)._~25nonvar))",[0,[2,"%nonvar"]],["racklog"]],
["%not",">racklog/glossary.html#(def._((lib._racklog/main..rkt)._~25not))",[0,[2,"%not"]],["racklog"]],
["%or",">racklog/glossary.html#(form._((lib._racklog/main..rkt)._~25or))",[0,[1,"%or"]],["racklog"]],
["%rel",">racklog/glossary.html#(form._((lib._racklog/main..rkt)._~25rel))",[0,[1,"%rel"]],["racklog"]],
["%repeat",">racklog/glossary.html#(def._((lib._racklog/main..rkt)._~25repeat))",[0,[2,"%repeat"]],["racklog"]],
["%set-of",">racklog/glossary.html#(def._((lib._racklog/main..rkt)._~25set-of))",[0,[2,"%set-of"]],["racklog"]],
["%set-of-1",">racklog/glossary.html#(def._((lib._racklog/main..rkt)._~25set-of-1))",[0,[2,"%set-of-1"]],["racklog"]],
["%true",">racklog/glossary.html#(def._((lib._racklog/main..rkt)._~25true))",[0,[2,"%true"]],["racklog"]],
["%var",">racklog/glossary.html#(def._((lib._racklog/main..rkt)._~25var))",[0,[2,"%var"]],["racklog"]],
["%which",">racklog/glossary.html#(form._((lib._racklog/main..rkt)._~25which))",[0,[1,"%which"]],["racklog"]],
["&",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex-sre..rkt)._~26))",[0,[1,"&"]],["parser-tools/lex-sre"]],
["&assertion",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_438",[0,[2,"&assertion"]],["rnrs/conditions-6"]],
["&condition",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_392",[0,[2,"&condition"]],["rnrs/conditions-6"]],
["&error",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_426",[0,[2,"&error"]],["rnrs/conditions-6"]],
["&i/o",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_494",[0,[2,"&i/o"]],["rnrs/io/ports-6"]],
["&i/o-decoding",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_600",[0,[2,"&i/o-decoding"]],["rnrs/io/ports-6"]],
["&i/o-encoding",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_606",[0,[2,"&i/o-encoding"]],["rnrs/io/ports-6"]],
["&i/o-file-already-exists",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_540",[0,[2,"&i/o-file-already-exists"]],["rnrs/io/ports-6"]],
["&i/o-file-does-not-exist",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_546",[0,[2,"&i/o-file-does-not-exist"]],["rnrs/io/ports-6"]],
["&i/o-file-is-read-only",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_534",[0,[2,"&i/o-file-is-read-only"]],["rnrs/io/ports-6"]],
["&i/o-file-protection",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_528",[0,[2,"&i/o-file-protection"]],["rnrs/io/ports-6"]],
["&i/o-filename",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_520",[0,[2,"&i/o-filename"]],["rnrs/io/ports-6"]],
["&i/o-invalid-position",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_512",[0,[2,"&i/o-invalid-position"]],["rnrs/io/ports-6"]],
["&i/o-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_552",[0,[2,"&i/o-port"]],["rnrs/io/ports-6"]],
["&i/o-read",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_500",[0,[2,"&i/o-read"]],["rnrs/io/ports-6"]],
["&i/o-write",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_506",[0,[2,"&i/o-write"]],["rnrs/io/ports-6"]],
["&implementation-restriction",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_466",[0,[2,"&implementation-restriction"]],["rnrs/conditions-6"]],
["&irritants",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_444",[0,[2,"&irritants"]],["rnrs/conditions-6"]],
["&lexical",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_472",[0,[2,"&lexical"]],["rnrs/conditions-6"]],
["&message",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_406",[0,[2,"&message"]],["rnrs/conditions-6"]],
["&no-infinities",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1048",[0,[2,"&no-infinities"]],["rnrs/arithmetic/flonums-6"]],
["&no-nans",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1054",[0,[2,"&no-nans"]],["rnrs/arithmetic/flonums-6"]],
["&non-continuable",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_460",[0,[2,"&non-continuable"]],["rnrs/conditions-6"]],
["&serious",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_420",[0,[2,"&serious"]],["rnrs/conditions-6"]],
["&syntax",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_478",[0,[2,"&syntax"]],["rnrs/conditions-6"]],
["&undefined",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_488",[0,[2,"&undefined"]],["rnrs/conditions-6"]],
["&violation",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_432",[0,[2,"&violation"]],["rnrs/conditions-6"]],
["&warning",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_414",[0,[2,"&warning"]],["rnrs/conditions-6"]],
["&who",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_452",[0,[2,"&who"]],["rnrs/conditions-6"]],
["'",">reference/reader.html#(idx._(gentag._55._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"'"],[4,""]]],false],
["'framework:backup-files?",">framework/Editor.html#(idx._(gentag._2._(lib._scribblings/framework/framework..scrbl)))","'framework:backup-files?",false],
["'framework:basic-canvas-background",">framework/Canvas.html#(idx._(gentag._1._(lib._scribblings/framework/framework..scrbl)))","'framework:basic-canvas-background",false],
["(",">reference/reader.html#(idx._(gentag._22._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"("],[4,""]]],false],
["(define ...) button",">drracket/buttons.html#(idx._(gentag._2._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">(define ...)</span>\nbutton",false],
["(rnrs arithmetic bitwise (6)): arithmetic: bitwise",">r6rs/R6RS_Libraries.html#(part._rnrs/arithmetic/bitwise-6)",[[8,"("],[0,"rnrs"],[6," "],[0,"arithmetic"],[6," "],[0,"bitwise"],[6," "],[8,"("],[7,"6"],[8,"))"],": Arithmetic: Bitwise"],false],
["(rnrs arithmetic fixnums (6)): arithmetic: fixnums",">r6rs/R6RS_Libraries.html#(part._rnrs/arithmetic/fixnums-6)",[[8,"("],[0,"rnrs"],[6," "],[0,"arithmetic"],[6," "],[0,"fixnums"],[6," "],[8,"("],[7,"6"],[8,"))"],": Arithmetic: Fixnums"],false],
["(rnrs arithmetic flonums (6)): arithmetic: flonums",">r6rs/R6RS_Libraries.html#(part._rnrs/arithmetic/flonums-6)",[[8,"("],[0,"rnrs"],[6," "],[0,"arithmetic"],[6," "],[0,"flonums"],[6," "],[8,"("],[7,"6"],[8,"))"],": Arithmetic: Flonums"],false],
["(rnrs base (6)): base",">r6rs/R6RS_Libraries.html#(part._rnrs/base-6)",[[8,"("],[0,"rnrs"],[6," "],[0,"base"],[6," "],[8,"("],[7,"6"],[8,"))"],": Base"],false],
["(rnrs bytevectors (6)): bytevectors",">r6rs/R6RS_Libraries.html#(part._rnrs/bytevectors-6)",[[8,"("],[0,"rnrs"],[6," "],[0,"bytevectors"],[6," "],[8,"("],[7,"6"],[8,"))"],": Bytevectors"],false],
["(rnrs conditions (6)): conditions",">r6rs/R6RS_Libraries.html#(part._rnrs/conditions-6)",[[8,"("],[0,"rnrs"],[6," "],[0,"conditions"],[6," "],[8,"("],[7,"6"],[8,"))"],": Conditions"],false],
["(rnrs control (6)): control structures",">r6rs/R6RS_Libraries.html#(part._rnrs/control-6)",[[8,"("],[0,"rnrs"],[6," "],[0,"control"],[6," "],[8,"("],[7,"6"],[8,"))"],": Control Structures"],false],
["(rnrs enums (6)): enumerations",">r6rs/R6RS_Libraries.html#(part._rnrs/enums-6)",[[8,"("],[0,"rnrs"],[6," "],[0,"enums"],[6," "],[8,"("],[7,"6"],[8,"))"],": Enumerations"],false],
["(rnrs eval (6)): eval",">r6rs/R6RS_Libraries.html#(part._rnrs/eval-6)",[[8,"("],[0,"rnrs"],[6," "],[0,"eval"],[6," "],[8,"("],[7,"6"],[8,"))"],": Eval"],false],
["(rnrs exceptions (6)): exceptions",">r6rs/R6RS_Libraries.html#(part._rnrs/exceptions-6)",[[8,"("],[0,"rnrs"],[6," "],[0,"exceptions"],[6," "],[8,"("],[7,"6"],[8,"))"],": Exceptions"],false],
["(rnrs files (6)): file system",">r6rs/R6RS_Libraries.html#(part._rnrs/files-6)",[[8,"("],[0,"rnrs"],[6," "],[0,"files"],[6," "],[8,"("],[7,"6"],[8,"))"],": File System"],false],
["(rnrs hashtables (6)): hashtables",">r6rs/R6RS_Libraries.html#(part._rnrs/hashtables-6)",[[8,"("],[0,"rnrs"],[6," "],[0,"hashtables"],[6," "],[8,"("],[7,"6"],[8,"))"],": Hashtables"],false],
["(rnrs io ports (6)): i/o: ports",">r6rs/R6RS_Libraries.html#(part._rnrs/io/ports-6)",[[8,"("],[0,"rnrs"],[6," "],[0,"io"],[6," "],[0,"ports"],[6," "],[8,"("],[7,"6"],[8,"))"],": I/O: Ports"],false],
["(rnrs io simple (6)): i/o: simple",">r6rs/R6RS_Libraries.html#(part._rnrs/io/simple-6)",[[8,"("],[0,"rnrs"],[6," "],[0,"io"],[6," "],[0,"simple"],[6," "],[8,"("],[7,"6"],[8,"))"],": I/O: Simple"],false],
["(rnrs lists (6)): list utilities",">r6rs/R6RS_Libraries.html#(part._rnrs/lists-6)",[[8,"("],[0,"rnrs"],[6," "],[0,"lists"],[6," "],[8,"("],[7,"6"],[8,"))"],": List utilities"],false],
["(rnrs mutable-pairs (6)): mutable pairs",">r6rs/R6RS_Libraries.html#(part._rnrs/mutable-pairs-6)",[[8,"("],[0,"rnrs"],[6," "],[0,"mutable-pairs"],[6," "],[8,"("],[7,"6"],[8,"))"],": Mutable Pairs"],false],
["(rnrs mutable-strings (6)): mutable strings",">r6rs/R6RS_Libraries.html#(part._rnrs/mutable-strings-6)",[[8,"("],[0,"rnrs"],[6," "],[0,"mutable-strings"],[6," "],[8,"("],[7,"6"],[8,"))"],": Mutable Strings"],false],
["(rnrs programs (6)): command-line access and exit values",">r6rs/R6RS_Libraries.html#(part._rnrs/programs-6)",[[8,"("],[0,"rnrs"],[6," "],[0,"programs"],[6," "],[8,"("],[7,"6"],[8,"))"],": Command-line Access and Exit Values"],false],
["(rnrs r5rs (6)): r5rs compatibility",">r6rs/R6RS_Libraries.html#(part._rnrs/r5rs-6)",[[8,"("],[0,"rnrs"],[6," "],[0,"r5rs"],[6," "],[8,"("],[7,"6"],[8,"))"],": R5RS Compatibility"],false],
["(rnrs records inspection (6)): records: inspection",">r6rs/R6RS_Libraries.html#(part._rnrs/records/inspection-6)",[[8,"("],[0,"rnrs"],[6," "],[0,"records"],[6," "],[0,"inspection"],[6," "],[8,"("],[7,"6"],[8,"))"],": Records: Inspection"],false],
["(rnrs records procedural (6)): records: procedural",">r6rs/R6RS_Libraries.html#(part._rnrs/records/procedural-6)",[[8,"("],[0,"rnrs"],[6," "],[0,"records"],[6," "],[0,"procedural"],[6," "],[8,"("],[7,"6"],[8,"))"],": Records: Procedural"],false],
["(rnrs records syntactic (6)): records: syntactic",">r6rs/R6RS_Libraries.html#(part._rnrs/records/syntactic-6)",[[8,"("],[0,"rnrs"],[6," "],[0,"records"],[6," "],[0,"syntactic"],[6," "],[8,"("],[7,"6"],[8,"))"],": Records: Syntactic"],false],
["(rnrs sorting (6)): sorting",">r6rs/R6RS_Libraries.html#(part._rnrs/sorting-6)",[[8,"("],[0,"rnrs"],[6," "],[0,"sorting"],[6," "],[8,"("],[7,"6"],[8,"))"],": Sorting"],false],
["(rnrs syntax-case (6)): syntax-case",">r6rs/R6RS_Libraries.html#(part._rnrs/syntax-case-6)",[[8,"("],[0,"rnrs"],[6," "],[0,"syntax-case"],[6," "],[8,"("],[7,"6"],[8,"))"],": Syntax-Case"],false],
["(rnrs unicode (6)): unicode",">r6rs/R6RS_Libraries.html#(part._rnrs/unicode-6)",[[8,"("],[0,"rnrs"],[6," "],[0,"unicode"],[6," "],[8,"("],[7,"6"],[8,"))"],": Unicode"],false],
[")",">reference/reader.html#(idx._(gentag._25._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,")"],[4,""]]],false],
["*",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._*))",[0,[2,"*"]],["racket/base","racket"]],
["*",">r5rs-std/r5rs-Z-H-9.html#%_idx_284",[0,[2,"*"]],["r5rs"]],
["*",">r6rs-std/r6rs-Z-H-14.html#node_idx_496",[0,[2,"*"]],["rnrs/base-6"]],
["*",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._*))",[0,[2,"*"]],["lang/htdp-advanced"]],
["*",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._*))",[0,[2,"*"]],["lang/htdp-beginner"]],
["*",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._*))",[0,[2,"*"]],["lang/htdp-beginner-abbr"]],
["*",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._*))",[0,[2,"*"]],["lang/htdp-intermediate"]],
["*",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._*))",[0,[2,"*"]],["lang/htdp-intermediate-lambda"]],
["*",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._*))",[0,[2,"*"]],["deinprogramm/DMdA-advanced"]],
["*",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._*))",[0,[2,"*"]],["deinprogramm/DMdA-assignments"]],
["*",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._*))",[0,[2,"*"]],["deinprogramm/DMdA-beginner"]],
["*",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._*))",[0,[2,"*"]],["deinprogramm/DMdA-vanilla"]],
["*",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex-sre..rkt)._*))",[0,[1,"*"]],["parser-tools/lex-sre"]],
["*",">plai/mutator.html#(form._((lib._plai/mutator..rkt)._*))",[0,[2,"*"]],["plai/mutator"]],
["**",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex-sre..rkt)._**))",[0,[1,"**"]],["parser-tools/lex-sre"]],
["*channel-get",">reference/distributed-places.html#(def._((lib._racket/place/distributed..rkt)._*channel-get))",[0,[2,"*channel-get"]],["racket/place/distributed"]],
["*channel-put",">reference/distributed-places.html#(def._((lib._racket/place/distributed..rkt)._*channel-put))",[0,[2,"*channel-put"]],["racket/place/distributed"]],
["*channel?",">reference/distributed-places.html#(def._((lib._racket/place/distributed..rkt)._*channel~3f))",[0,[2,"*channel?"]],["racket/place/distributed"]],
["+",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._+))",[0,[2,"+"]],["racket/base","racket"]],
["+",">r5rs-std/r5rs-Z-H-9.html#%_idx_282",[0,[2,"+"]],["r5rs"]],
["+",">r6rs-std/r6rs-Z-H-14.html#node_idx_494",[0,[2,"+"]],["rnrs/base-6"]],
["+",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._+))",[0,[2,"+"]],["lang/htdp-advanced"]],
["+",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._+))",[0,[2,"+"]],["lang/htdp-beginner"]],
["+",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._+))",[0,[2,"+"]],["lang/htdp-beginner-abbr"]],
["+",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._+))",[0,[2,"+"]],["lang/htdp-intermediate"]],
["+",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._+))",[0,[2,"+"]],["lang/htdp-intermediate-lambda"]],
["+",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._+))",[0,[2,"+"]],["deinprogramm/DMdA-advanced"]],
["+",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._+))",[0,[2,"+"]],["deinprogramm/DMdA-assignments"]],
["+",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._+))",[0,[2,"+"]],["deinprogramm/DMdA-beginner"]],
["+",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._+))",[0,[2,"+"]],["deinprogramm/DMdA-vanilla"]],
["+",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex-sre..rkt)._+))",[0,[1,"+"]],["parser-tools/lex-sre"]],
["+",">plai/mutator.html#(form._((lib._plai/mutator..rkt)._+))",[0,[2,"+"]],["plai/mutator"]],
["++copy-collects",">raco/exe-dist.html#(idx._(gentag._1._(lib._scribblings/raco/raco..scrbl)))",[11,[6,"++copy-collects"]],false],
["++cppf",">raco/cc.html#(idx._(gentag._25._(lib._scribblings/raco/raco..scrbl)))",[11,[6,"++cppf"]],false],
["++cppf",">raco/cc.html#(idx._(gentag._26._(lib._scribblings/raco/raco..scrbl)))",[11,[6,"++cppf"]],false],
["++cppf-clear",">raco/cc.html#(idx._(gentag._27._(lib._scribblings/raco/raco..scrbl)))",[11,[6,"++cppf-clear"]],false],
["++extra",">scribble/config.html#(idx._(gentag._16._(lib._scribblings/scribble/scribble..scrbl)))",[11,[6,"++extra"]],false],
["++ldf",">raco/cc.html#(idx._(gentag._19._(lib._scribblings/raco/raco..scrbl)))",[11,[6,"++ldf"]],false],
["++ldl",">raco/cc.html#(idx._(gentag._23._(lib._scribblings/raco/raco..scrbl)))",[11,[6,"++ldl"]],false],
["++path",">r6rs/Installing_Libraries.html#(idx._(gentag._0._(lib._r6rs/scribblings/r6rs..scrbl)))",[11,[6,"++path"]],false],
["++setup",">raco/plt.html#(idx._(gentag._8._(lib._scribblings/raco/raco..scrbl)))",[11,[6,"++setup"]],false],
["++style",">scribble/config.html#(idx._(gentag._15._(lib._scribblings/scribble/scribble..scrbl)))",[11,[6,"++style"]],false],
["+inf.0",">reference/numbers.html#(idx._(gentag._90._(lib._scribblings/reference/reference..scrbl)))",[7,"+inf.0"],false],
["+inf.f",">reference/numbers.html#(idx._(gentag._92._(lib._scribblings/reference/reference..scrbl)))",[7,"+inf.f"],false],
["+max.0",">unstable/flonum.html#(def._((lib._unstable/flonum..rkt)._+max..0))",[0,[2,"+max.0"]],["unstable/flonum"]],
["+min.0",">unstable/flonum.html#(def._((lib._unstable/flonum..rkt)._+min..0))",[0,[2,"+min.0"]],["unstable/flonum"]],
["+nan.0",">reference/numbers.html#(idx._(gentag._95._(lib._scribblings/reference/reference..scrbl)))",[7,"+nan.0"],false],
["+nan.f",">reference/numbers.html#(idx._(gentag._97._(lib._scribblings/reference/reference..scrbl)))",[7,"+nan.f"],false],
["+rv",">reference/running-sa.html#(idx._(gentag._421._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"+rv"]],false],
[",",">reference/reader.html#(idx._(gentag._57._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,","],[4,""]]],false],
[",@",">reference/reader.html#(idx._(gentag._58._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,",@"],[4,""]]],false],
[",apropos",">xrepl/index.html#(xrepl._apropos)",[12,[3,[[4,""],[5,",apropos"],[4,""]]]],false],
[",backtrace",">xrepl/index.html#(xrepl._backtrace)",[12,[3,[[4,""],[5,",backtrace"],[4,""]]]],false],
[",cd",">xrepl/index.html#(xrepl._cd)",[12,[3,[[4,""],[5,",cd"],[4,""]]]],false],
[",check-requires",">xrepl/index.html#(xrepl._check-requires)",[12,[3,[[4,""],[5,",check-requires"],[4,""]]]],false],
[",coverage",">xrepl/index.html#(xrepl._coverage)",[12,[3,[[4,""],[5,",coverage"],[4,""]]]],false],
[",describe",">xrepl/index.html#(xrepl._describe)",[12,[3,[[4,""],[5,",describe"],[4,""]]]],false],
[",doc",">xrepl/index.html#(xrepl._doc)",[12,[3,[[4,""],[5,",doc"],[4,""]]]],false],
[",drracket",">xrepl/index.html#(xrepl._drracket)",[12,[3,[[4,""],[5,",drracket"],[4,""]]]],false],
[",edit",">xrepl/index.html#(xrepl._edit)",[12,[3,[[4,""],[5,",edit"],[4,""]]]],false],
[",enter",">xrepl/index.html#(xrepl._enter)",[12,[3,[[4,""],[5,",enter"],[4,""]]]],false],
[",errortrace",">xrepl/index.html#(xrepl._errortrace)",[12,[3,[[4,""],[5,",errortrace"],[4,""]]]],false],
[",execution-counts",">xrepl/index.html#(xrepl._execution-counts)",[12,[3,[[4,""],[5,",execution-counts"],[4,""]]]],false],
[",exit",">xrepl/index.html#(xrepl._exit)",[12,[3,[[4,""],[5,",exit"],[4,""]]]],false],
[",help",">xrepl/index.html#(xrepl._help)",[12,[3,[[4,""],[5,",help"],[4,""]]]],false],
[",install!",">xrepl/index.html#(xrepl._install!)",[12,[3,[[4,""],[5,",install!"],[4,""]]]],false],
[",load",">xrepl/index.html#(xrepl._load)",[12,[3,[[4,""],[5,",load"],[4,""]]]],false],
[",log",">xrepl/index.html#(xrepl._log)",[12,[3,[[4,""],[5,",log"],[4,""]]]],false],
[",profile",">xrepl/index.html#(xrepl._profile)",[12,[3,[[4,""],[5,",profile"],[4,""]]]],false],
[",pwd",">xrepl/index.html#(xrepl._pwd)",[12,[3,[[4,""],[5,",pwd"],[4,""]]]],false],
[",require",">xrepl/index.html#(xrepl._require)",[12,[3,[[4,""],[5,",require"],[4,""]]]],false],
[",require-reloadable",">xrepl/index.html#(xrepl._require-reloadable)",[12,[3,[[4,""],[5,",require-reloadable"],[4,""]]]],false],
[",shell",">xrepl/index.html#(xrepl._shell)",[12,[3,[[4,""],[5,",shell"],[4,""]]]],false],
[",switch-namespace",">xrepl/index.html#(xrepl._switch-namespace)",[12,[3,[[4,""],[5,",switch-namespace"],[4,""]]]],false],
[",syntax",">xrepl/index.html#(xrepl._syntax)",[12,[3,[[4,""],[5,",syntax"],[4,""]]]],false],
[",time",">xrepl/index.html#(xrepl._time)",[12,[3,[[4,""],[5,",time"],[4,""]]]],false],
[",toplevel",">xrepl/index.html#(xrepl._toplevel)",[12,[3,[[4,""],[5,",toplevel"],[4,""]]]],false],
[",trace",">xrepl/index.html#(xrepl._trace)",[12,[3,[[4,""],[5,",trace"],[4,""]]]],false],
[",untrace",">xrepl/index.html#(xrepl._untrace)",[12,[3,[[4,""],[5,",untrace"],[4,""]]]],false],
["-",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._-))",[0,[2,[11,"-"]]],["racket/base","racket"]],
["-",">r5rs-std/r5rs-Z-H-9.html#%_idx_290",[0,[2,"-"]],["r5rs"]],
["-",">r6rs-std/r6rs-Z-H-14.html#node_idx_498",[0,[2,"-"]],["rnrs/base-6"]],
["-",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._-))",[0,[2,[11,"-"]]],["lang/htdp-advanced"]],
["-",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._-))",[0,[2,[11,"-"]]],["lang/htdp-beginner"]],
["-",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._-))",[0,[2,[11,"-"]]],["lang/htdp-beginner-abbr"]],
["-",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._-))",[0,[2,[11,"-"]]],["lang/htdp-intermediate"]],
["-",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._-))",[0,[2,[11,"-"]]],["lang/htdp-intermediate-lambda"]],
["-",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._-))",[0,[2,[11,"-"]]],["deinprogramm/DMdA-advanced"]],
["-",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._-))",[0,[2,[11,"-"]]],["deinprogramm/DMdA-assignments"]],
["-",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._-))",[0,[2,[11,"-"]]],["deinprogramm/DMdA-beginner"]],
["-",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._-))",[0,[2,[11,"-"]]],["deinprogramm/DMdA-vanilla"]],
["-",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex-sre..rkt)._-))",[0,[1,[11,"-"]]],["parser-tools/lex-sre"]],
["-",">plai/mutator.html#(form._((lib._plai/mutator..rkt)._-))",[0,[2,[11,"-"]]],["plai/mutator"]],
["--",">reference/running-sa.html#(idx._(gentag._406._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"--"]],false],
["--3m",">inside/overview.html#(idx._(gentag._13._(lib._scribblings/inside/inside..scrbl)))",[11,[6,"--3m"]],false],
["--3m",">raco/cc.html#(idx._(gentag._29._(lib._scribblings/raco/raco..scrbl)))",[11,[6,"--3m"]],false],
["-->",">redex/The_Redex_Reference.html#(form._((lib._redex/reduction-semantics..rkt)._--~3e))",[0,[1,[11,"-->"]]],["redex/reduction-semantics","redex"]],
["--addon",">reference/running-sa.html#(idx._(gentag._387._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"--addon"]],false],
["--all-users",">raco/plt.html#(idx._(gentag._6._(lib._scribblings/raco/raco..scrbl)))",[11,[6,"--all-users"]],false],
["--at-plt",">raco/plt.html#(idx._(gentag._4._(lib._scribblings/raco/raco..scrbl)))",[11,[6,"--at-plt"]],false],
["--back",">reference/running-sa.html#(idx._(gentag._372._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"--back"]],false],
["--binary",">reference/running-sa.html#(idx._(gentag._401._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"--binary"]],false],
["--cc",">inside/overview.html#(idx._(gentag._6._(lib._scribblings/inside/inside..scrbl)))",[11,[6,"--cc"]],false],
["--ccf",">raco/cc.html#(idx._(gentag._14._(lib._scribblings/raco/raco..scrbl)))",[11,[6,"--ccf"]],false],
["--ccf",">raco/cc.html#(idx._(gentag._15._(lib._scribblings/raco/raco..scrbl)))",[11,[6,"--ccf"]],false],
["--ccf-clear",">raco/cc.html#(idx._(gentag._16._(lib._scribblings/raco/raco..scrbl)))",[11,[6,"--ccf-clear"]],false],
["--ccf-show",">raco/cc.html#(idx._(gentag._17._(lib._scribblings/raco/raco..scrbl)))",[11,[6,"--ccf-show"]],false],
["--cgc",">raco/cc.html#(idx._(gentag._30._(lib._scribblings/raco/raco..scrbl)))",[11,[6,"--cgc"]],false],
["--cgc",">inside/overview.html#(idx._(gentag._7._(lib._scribblings/inside/inside..scrbl)))",[11,[6,"--cgc"]],false],
["--collection-plt",">raco/plt.html#(idx._(gentag._5._(lib._scribblings/raco/raco..scrbl)))",[11,[6,"--collection-plt"]],false],
["--collects",">reference/running-sa.html#(idx._(gentag._383._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"--collects"]],false],
["--collects-dest",">raco/exe-dist.html#(idx._(gentag._2._(lib._scribblings/raco/raco..scrbl)))",[11,[6,"--collects-dest"]],false],
["--compiler",">raco/cc.html#(idx._(gentag._13._(lib._scribblings/raco/raco..scrbl)))",[11,[6,"--compiler"]],false],
["--cppf-show",">raco/cc.html#(idx._(gentag._28._(lib._scribblings/raco/raco..scrbl)))",[11,[6,"--cppf-show"]],false],
["--eval",">reference/running-sa.html#(idx._(gentag._350._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"--eval"]],false],
["--help",">reference/running-sa.html#(idx._(gentag._408._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"--help"]],false],
["--ld",">inside/overview.html#(idx._(gentag._10._(lib._scribblings/inside/inside..scrbl)))",[11,[6,"--ld"]],false],
["--ldf",">raco/cc.html#(idx._(gentag._20._(lib._scribblings/raco/raco..scrbl)))",[11,[6,"--ldf"]],false],
["--ldf-clear",">raco/cc.html#(idx._(gentag._21._(lib._scribblings/raco/raco..scrbl)))",[11,[6,"--ldf-clear"]],false],
["--ldf-show",">raco/cc.html#(idx._(gentag._22._(lib._scribblings/raco/raco..scrbl)))",[11,[6,"--ldf-show"]],false],
["--ldl-show",">raco/cc.html#(idx._(gentag._24._(lib._scribblings/raco/raco..scrbl)))",[11,[6,"--ldl-show"]],false],
["--lib",">reference/running-sa.html#(idx._(gentag._356._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"--lib"]],false],
["--linker",">raco/cc.html#(idx._(gentag._18._(lib._scribblings/raco/raco..scrbl)))",[11,[6,"--linker"]],false],
["--links",">reference/running-sa.html#(idx._(gentag._389._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"--links"]],false],
["--load",">reference/running-sa.html#(idx._(gentag._352._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"--load"]],false],
["--main",">reference/running-sa.html#(idx._(gentag._364._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"--main"]],false],
["--name",">reference/running-sa.html#(idx._(gentag._393._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"--name"]],false],
["--no-compiled",">reference/running-sa.html#(idx._(gentag._376._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"--no-compiled"]],false],
["--no-delay",">reference/running-sa.html#(idx._(gentag._399._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"--no-delay"]],false],
["--no-init-file",">reference/running-sa.html#(idx._(gentag._378._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"--no-init-file"]],false],
["--no-jit",">reference/running-sa.html#(idx._(gentag._397._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"--no-jit"]],false],
["--no-lib",">reference/running-sa.html#(idx._(gentag._368._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"--no-lib"]],false],
["--no-prim",">r5rs/plt-r5rs.html#(idx._(gentag._0._(lib._r5rs/r5rs..scrbl)))",[11,[6,"--no-prim"]],false],
["--no-user-path",">reference/running-sa.html#(idx._(gentag._391._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"--no-user-path"]],false],
["--no-yield",">reference/running-sa.html#(idx._(gentag._374._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"--no-yield"]],false],
["--plt-name",">raco/plt.html#(idx._(gentag._9._(lib._scribblings/raco/raco..scrbl)))",[11,[6,"--plt-name"]],false],
["--prefix",">scribble/config.html#(idx._(gentag._13._(lib._scribblings/scribble/scribble..scrbl)))",[11,[6,"--prefix"]],false],
["--repl",">reference/running-sa.html#(idx._(gentag._366._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"--repl"]],false],
["--replace",">raco/plt.html#(idx._(gentag._7._(lib._scribblings/raco/raco..scrbl)))",[11,[6,"--replace"]],false],
["--require",">reference/running-sa.html#(idx._(gentag._354._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"--require"]],false],
["--require-script",">reference/running-sa.html#(idx._(gentag._361._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"--require-script"]],false],
["--script",">reference/running-sa.html#(idx._(gentag._359._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"--script"]],false],
["--search",">reference/running-sa.html#(idx._(gentag._385._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"--search"]],false],
["--style",">scribble/config.html#(idx._(gentag._14._(lib._scribblings/scribble/scribble..scrbl)))",[11,[6,"--style"]],false],
["--syslog",">reference/running-sa.html#(idx._(gentag._405._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"--syslog"]],false],
["--text-repl",">reference/running-sa.html#(idx._(gentag._380._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"--text-repl"]],false],
["--tool",">raco/cc.html#(idx._(gentag._12._(lib._scribblings/raco/raco..scrbl)))",[11,[6,"--tool"]],false],
["--version",">reference/running-sa.html#(idx._(gentag._370._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"--version"]],false],
["--warn",">reference/running-sa.html#(idx._(gentag._403._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"--warn"]],false],
["--wm-class",">reference/running-sa.html#(idx._(gentag._395._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"--wm-class"]],false],
["--xform",">inside/overview.html#(idx._(gentag._12._(lib._scribblings/inside/inside..scrbl)))",[11,[6,"--xform"]],false],
["->",">reference/function-contracts.html#(form._((lib._racket/contract/base..rkt)._-~3e))",[0,[1,[11,"->"]]],["racket/contract/base","racket/contract","racket"]],
["->",">deinprogramm/Signaturen.html#(form._((lib._deinprogramm/.D.Md.A..rkt)._-~3e))",[0,[1,[11,"->"]]],["deinprogramm/DMdA-beginner"]],
["->",">foreign/foreign_procedures.html#(form._((lib._ffi/unsafe..rkt)._-~3e))",[0,[1,[11,"->"]]],["ffi/unsafe"]],
["->",">mzlib/mzlib_contract.html#(form._((lib._mzlib/contract..rkt)._-~3e))",[0,[1,[11,"->"]]],["mzlib/contract"]],
["->",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types-extra..rkt)._-~3e))",[0,[1,[11,"->"]]],["typed/racket/base","typed/racket"]],
["->*",">reference/function-contracts.html#(form._((lib._racket/contract/base..rkt)._-~3e*))",[0,[1,[[11,"->"],"*"]]],["racket/contract/base","racket/contract","racket"]],
["->*",">mzlib/mzlib_contract.html#(form._((lib._mzlib/contract..rkt)._-~3e*))",[0,[1,[[11,"->"],"*"]]],["mzlib/contract"]],
["->*m",">reference/Object_and_Class_Contracts.html#(form._((lib._racket/private/class-internal..rkt)._-~3e*m))",[0,[1,[[11,"->"],"*m"]]],["racket/class","racket"]],
["->brush-color",">plot/utils.html#(def._((lib._plot/utils..rkt)._-~3ebrush-color))",[0,[2,[[11,"->"],"brush-color"]]],["plot/utils"]],
["->brush-style",">plot/utils.html#(def._((lib._plot/utils..rkt)._-~3ebrush-style))",[0,[2,[[11,"->"],"brush-style"]]],["plot/utils"]],
["->char-set",">srfi-std/srfi-14.html#->char-set",[0,[2,"->char-set"]],["srfi/14"]],
["->color",">plot/utils.html#(def._((lib._plot/utils..rkt)._-~3ecolor))",[0,[2,[[11,"->"],"color"]]],["plot/utils"]],
["->d",">reference/function-contracts.html#(form._((lib._racket/contract/base..rkt)._-~3ed))",[0,[1,[[11,"->"],"d"]]],["racket/contract/base","racket/contract","racket"]],
["->d",">mzlib/mzlib_contract.html#(form._((lib._mzlib/contract..rkt)._-~3ed))",[0,[1,[[11,"->"],"d"]]],["mzlib/contract"]],
["->d*",">mzlib/mzlib_contract.html#(form._((lib._mzlib/contract..rkt)._-~3ed*))",[0,[1,[[11,"->"],"d*"]]],["mzlib/contract"]],
["->dm",">reference/Object_and_Class_Contracts.html#(form._((lib._racket/private/class-internal..rkt)._-~3edm))",[0,[1,[[11,"->"],"dm"]]],["racket/class","racket"]],
["->fl",">reference/flonums.html#(def._((lib._racket/flonum..rkt)._-~3efl))",[0,[2,[[11,"->"],"fl"]]],["racket/flonum"]],
["->i",">reference/function-contracts.html#(form._((lib._racket/contract/base..rkt)._-~3ei))",[0,[1,[[11,"->"],"i"]]],["racket/contract/base","racket/contract","racket"]],
["->m",">reference/Object_and_Class_Contracts.html#(form._((lib._racket/private/class-internal..rkt)._-~3em))",[0,[1,[[11,"->"],"m"]]],["racket/class","racket"]],
["->pen-color",">plot/utils.html#(def._((lib._plot/utils..rkt)._-~3epen-color))",[0,[2,[[11,"->"],"pen-color"]]],["plot/utils"]],
["->pen-style",">plot/utils.html#(def._((lib._plot/utils..rkt)._-~3epen-style))",[0,[2,[[11,"->"],"pen-style"]]],["plot/utils"]],
["->plot-label",">plot/utils.html#(def._((lib._plot/utils..rkt)._-~3eplot-label))",[0,[2,[[11,"->"],"plot-label"]]],["plot/utils"]],
["->pp",">mzlib/mzlib_contract.html#(form._((lib._mzlib/contract..rkt)._-~3epp))",[0,[1,[[11,"->"],"pp"]]],["mzlib/contract"]],
["->pp-rest",">mzlib/mzlib_contract.html#(form._((lib._mzlib/contract..rkt)._-~3epp-rest))",[0,[1,[[11,"->"],"pp-rest"]]],["mzlib/contract"]],
["->r",">mzlib/mzlib_contract.html#(form._((lib._mzlib/contract..rkt)._-~3er))",[0,[1,[[11,"->"],"r"]]],["mzlib/contract"]],
["-a",">reference/running-sa.html#(idx._(gentag._386._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"-A"]],false],
["-b",">reference/running-sa.html#(idx._(gentag._400._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"-b"]],false],
["-background",">reference/running-sa.html#(idx._(gentag._412._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"-background"]],false],
["-bg",">reference/running-sa.html#(idx._(gentag._411._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"-bg"]],false],
["-c",">reference/running-sa.html#(idx._(gentag._388._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"-C"]],false],
["-c",">reference/running-sa.html#(idx._(gentag._375._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"-c"]],false],
["-d",">reference/running-sa.html#(idx._(gentag._398._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"-d"]],false],
["-display",">reference/running-sa.html#(idx._(gentag._409._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"-display"]],false],
["-e",">reference/running-sa.html#(idx._(gentag._349._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"-e"]],false],
["-f",">reference/running-sa.html#(idx._(gentag._351._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"-f"]],false],
["-fg",">reference/running-sa.html#(idx._(gentag._413._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"-fg"]],false],
["-fn",">reference/running-sa.html#(idx._(gentag._415._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"-fn"]],false],
["-font",">reference/running-sa.html#(idx._(gentag._416._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"-font"]],false],
["-foreground",">reference/running-sa.html#(idx._(gentag._414._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"-foreground"]],false],
["-geometry",">reference/running-sa.html#(idx._(gentag._410._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"-geometry"]],false],
["-h",">reference/running-sa.html#(idx._(gentag._407._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"-h"]],false],
["-i",">reference/running-sa.html#(idx._(gentag._381._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"-I"]],false],
["-i",">reference/running-sa.html#(idx._(gentag._365._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"-i"]],false],
["-iconic",">reference/running-sa.html#(idx._(gentag._417._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"-iconic"]],false],
["-inf.0",">reference/numbers.html#(idx._(gentag._93._(lib._scribblings/reference/reference..scrbl)))",[7,[[11,"-i"],"nf.0"]],false],
["-inf.f",">reference/numbers.html#(idx._(gentag._94._(lib._scribblings/reference/reference..scrbl)))",[7,[[11,"-i"],"nf.f"]],false],
["-j",">reference/running-sa.html#(idx._(gentag._394._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"-J"]],false],
["-j",">reference/running-sa.html#(idx._(gentag._396._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"-j"]],false],
["-k",">reference/running-sa.html#(idx._(gentag._371._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"-K"]],false],
["-k",">reference/running-sa.html#(idx._(gentag._362._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"-k"]],false],
["-l",">reference/running-sa.html#(idx._(gentag._404._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"-L"]],false],
["-l",">reference/running-sa.html#(idx._(gentag._355._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"-l"]],false],
["-m",">reference/running-sa.html#(idx._(gentag._363._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"-m"]],false],
["-map",">html/index.html#(def._((lib._html/main..rkt)._-map))",[0,[2,"-map"]],["html"]],
["-map?",">html/index.html#(def._((lib._html/main..rkt)._-map~3f))",[0,[2,"-map?"]],["html"]],
["-max.0",">unstable/flonum.html#(def._((lib._unstable/flonum..rkt)._-max..0))",[0,[2,[[11,"-m"],"ax.0"]]],["unstable/flonum"]],
["-min.0",">unstable/flonum.html#(def._((lib._unstable/flonum..rkt)._-min..0))",[0,[2,[[11,"-m"],"in.0"]]],["unstable/flonum"]],
["-n",">reference/running-sa.html#(idx._(gentag._392._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"-N"]],false],
["-n",">reference/running-sa.html#(idx._(gentag._367._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"-n"]],false],
["-name",">reference/running-sa.html#(idx._(gentag._418._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"-name"]],false],
["-p",">reference/running-sa.html#(idx._(gentag._357._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"-p"]],false],
["-printable signature",">net/qp.html#(part._-.Printable_.Signature)","-Printable Signature",false],
["-psn_",">reference/running-sa.html#(idx._(gentag._428._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"-psn_"]],false],
["-q",">reference/running-sa.html#(idx._(gentag._377._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"-q"]],false],
["-r",">reference/running-sa.html#(idx._(gentag._358._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"-r"]],false],
["-reverse",">reference/running-sa.html#(idx._(gentag._420._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"-reverse"]],false],
["-rv",">reference/running-sa.html#(idx._(gentag._419._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"-rv"]],false],
["-s",">reference/running-sa.html#(idx._(gentag._384._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"-S"]],false],
["-selectiontimeout",">reference/running-sa.html#(idx._(gentag._422._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"-selectionTimeout"]],false],
["-singleinstance",">reference/running-sa.html#(idx._(gentag._427._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"-singleInstance"]],false],
["-synchronous",">reference/running-sa.html#(idx._(gentag._423._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"-synchronous"]],false],
["-t",">reference/running-sa.html#(idx._(gentag._353._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"-t"]],false],
["-title",">reference/running-sa.html#(idx._(gentag._424._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"-title"]],false],
["-u",">reference/running-sa.html#(idx._(gentag._390._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"-U"]],false],
["-u",">reference/running-sa.html#(idx._(gentag._360._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"-u"]],false],
["-v",">reference/running-sa.html#(idx._(gentag._373._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"-V"]],false],
["-v",">reference/running-sa.html#(idx._(gentag._369._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"-v"]],false],
["-w",">reference/running-sa.html#(idx._(gentag._402._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"-W"]],false],
["-x",">reference/running-sa.html#(idx._(gentag._382._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"-X"]],false],
["-xnllanguage",">reference/running-sa.html#(idx._(gentag._425._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"-xnllanguage"]],false],
["-xrm",">reference/running-sa.html#(idx._(gentag._426._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"-xrm"]],false],
["-z",">reference/running-sa.html#(idx._(gentag._379._(lib._scribblings/reference/reference..scrbl)))",[11,[6,"-z"]],false],
["-~-",">scribble/base.html#(def._((lib._scribble/base..rkt)._-~7e-))",[0,[2,[[11,"-~"],"-"]]],["scribble/base"]],
[".",">reference/reader.html#(idx._(gentag._28._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"."],[4,""]]],false],
["..",">htdp-langs/advanced.html#(form._((lib._lang/htdp-advanced..rkt)._....))",[0,[1,".."]],["lang/htdp-advanced"]],
["..",">htdp-langs/beginner.html#(form._((lib._lang/htdp-beginner..rkt)._....))",[0,[1,".."]],["lang/htdp-beginner"]],
["..",">htdp-langs/beginner-abbr.html#(form._((lib._lang/htdp-beginner-abbr..rkt)._....))",[0,[1,".."]],["lang/htdp-beginner-abbr"]],
["..",">htdp-langs/intermediate.html#(form._((lib._lang/htdp-intermediate..rkt)._....))",[0,[1,".."]],["lang/htdp-intermediate"]],
["..",">htdp-langs/intermediate-lam.html#(form._((lib._lang/htdp-intermediate-lambda..rkt)._....))",[0,[1,".."]],["lang/htdp-intermediate-lambda"]],
["...",">reference/stx-patterns.html#(form._((lib._racket/private/stxcase-scheme..rkt)._......))",[13,[1,"..."]],["racket/base","racket"]],
["...",">r6rs-std/r6rs-Z-H-14.html#node_idx_784",[0,[1,"..."]],["r6rs/private/base-for-syntax"]],
["...",">r6rs-lib-std/r6rs-lib-Z-H-13.html#node_idx_1128",[0,[1,"..."]],["rnrs/syntax-case-6"]],
["...",">htdp-langs/advanced.html#(form._((lib._lang/htdp-advanced..rkt)._......))",[13,[1,"..."]],["lang/htdp-advanced"]],
["...",">htdp-langs/beginner.html#(form._((lib._lang/htdp-beginner..rkt)._......))",[13,[1,"..."]],["lang/htdp-beginner"]],
["...",">htdp-langs/beginner-abbr.html#(form._((lib._lang/htdp-beginner-abbr..rkt)._......))",[13,[1,"..."]],["lang/htdp-beginner-abbr"]],
["...",">htdp-langs/intermediate.html#(form._((lib._lang/htdp-intermediate..rkt)._......))",[13,[1,"..."]],["lang/htdp-intermediate"]],
["...",">htdp-langs/intermediate-lam.html#(form._((lib._lang/htdp-intermediate-lambda..rkt)._......))",[13,[1,"..."]],["lang/htdp-intermediate-lambda"]],
["...+",">syntax/stxparse-patterns.html#(form._((lib._syntax/parse..rkt)._......+))",[0,[1,"...+"]],["syntax/parse"]],
["....",">htdp-langs/advanced.html#(form._((lib._lang/htdp-advanced..rkt)._........))",[0,[1,"...."]],["lang/htdp-advanced"]],
["....",">htdp-langs/beginner.html#(form._((lib._lang/htdp-beginner..rkt)._........))",[0,[1,"...."]],["lang/htdp-beginner"]],
["....",">htdp-langs/beginner-abbr.html#(form._((lib._lang/htdp-beginner-abbr..rkt)._........))",[0,[1,"...."]],["lang/htdp-beginner-abbr"]],
["....",">htdp-langs/intermediate.html#(form._((lib._lang/htdp-intermediate..rkt)._........))",[0,[1,"...."]],["lang/htdp-intermediate"]],
["....",">htdp-langs/intermediate-lam.html#(form._((lib._lang/htdp-intermediate-lambda..rkt)._........))",[0,[1,"...."]],["lang/htdp-intermediate-lambda"]],
[".....",">htdp-langs/advanced.html#(form._((lib._lang/htdp-advanced..rkt)._..........))",[0,[1,"....."]],["lang/htdp-advanced"]],
[".....",">htdp-langs/beginner.html#(form._((lib._lang/htdp-beginner..rkt)._..........))",[0,[1,"....."]],["lang/htdp-beginner"]],
[".....",">htdp-langs/beginner-abbr.html#(form._((lib._lang/htdp-beginner-abbr..rkt)._..........))",[0,[1,"....."]],["lang/htdp-beginner-abbr"]],
[".....",">htdp-langs/intermediate.html#(form._((lib._lang/htdp-intermediate..rkt)._..........))",[0,[1,"....."]],["lang/htdp-intermediate"]],
[".....",">htdp-langs/intermediate-lam.html#(form._((lib._lang/htdp-intermediate-lambda..rkt)._..........))",[0,[1,"....."]],["lang/htdp-intermediate-lambda"]],
["......",">htdp-langs/advanced.html#(form._((lib._lang/htdp-advanced..rkt)._............))",[0,[1,"......"]],["lang/htdp-advanced"]],
["......",">htdp-langs/beginner.html#(form._((lib._lang/htdp-beginner..rkt)._............))",[0,[1,"......"]],["lang/htdp-beginner"]],
["......",">htdp-langs/beginner-abbr.html#(form._((lib._lang/htdp-beginner-abbr..rkt)._............))",[0,[1,"......"]],["lang/htdp-beginner-abbr"]],
["......",">htdp-langs/intermediate.html#(form._((lib._lang/htdp-intermediate..rkt)._............))",[0,[1,"......"]],["lang/htdp-intermediate"]],
["......",">htdp-langs/intermediate-lam.html#(form._((lib._lang/htdp-intermediate-lambda..rkt)._............))",[0,[1,"......"]],["lang/htdp-intermediate-lambda"]],
["._",">scribble/base.html#(def._((lib._scribble/base..rkt)._.._))",[0,[2,"._"]],["scribble/base"]],
[".__",">scribble/base.html#(def._((lib._scribble/base..rkt)._..__))",[0,[2,".__"]],["scribble/base"]],
[".bak",">drracket/prefs-explanation.html#(idx._(gentag._152._(lib._scribblings/drracket/drracket..scrbl)))",[6,"\".bak\""],false],
[".bat",">guide/scripts.html#(idx._(gentag._8._(lib._scribblings/guide/guide..scrbl)))",[6,".bat"],false],
[".gracketrc",">gui/Windowing_Functions.html#(idx._(gentag._148._(lib._scribblings/gui/gui..scrbl)))",[6,"\".gracketrc\""],false],
[".lock.org.racket-lang.prefs.rktd",">drracket/drracket-files.html#(idx._(gentag._381._(lib._scribblings/drracket/drracket..scrbl)))",[6,"\".LOCK.org.racket-lang.prefs.rktd\""],false],
[".lock.racket-prefs.rktd",">drracket/drracket-files.html#(idx._(gentag._380._(lib._scribblings/drracket/drracket..scrbl)))",[6,"\".LOCK.racket-prefs.rktd\""],false],
[".racket",">drracket/drracket-files.html#(idx._(gentag._373._(lib._scribblings/drracket/drracket..scrbl)))",[6,"\".racket\""],false],
[".racketrc",">reference/Filesystem.html#(idx._(gentag._276._(lib._scribblings/reference/reference..scrbl)))",[6,"\".racketrc\""],false],
[".rkt",">drracket/drracket-files.html#(idx._(gentag._369._(lib._scribblings/drracket/drracket..scrbl)))",[6,"\".rkt\""],false],
[".sch",">drracket/drracket-files.html#(idx._(gentag._372._(lib._scribblings/drracket/drracket..scrbl)))",[6,"\".sch\""],false],
[".scm",">drracket/drracket-files.html#(idx._(gentag._371._(lib._scribblings/drracket/drracket..scrbl)))",[6,"\".scm\""],false],
[".ss",">drracket/drracket-files.html#(idx._(gentag._370._(lib._scribblings/drracket/drracket..scrbl)))",[6,"\".ss\""],false],
[".zo",">guide/cmdline-tools.html#(idx._(gentag._9._(lib._scribblings/guide/guide..scrbl)))",".zo",false],
["/",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._/))",[0,[2,"/"]],["racket/base","racket"]],
["/",">r5rs-std/r5rs-Z-H-9.html#%_idx_296",[0,[2,"/"]],["r5rs"]],
["/",">r6rs-std/r6rs-Z-H-14.html#node_idx_502",[0,[2,"/"]],["rnrs/base-6"]],
["/",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._/))",[0,[2,"/"]],["lang/htdp-advanced"]],
["/",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._/))",[0,[2,"/"]],["lang/htdp-beginner"]],
["/",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._/))",[0,[2,"/"]],["lang/htdp-beginner-abbr"]],
["/",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._/))",[0,[2,"/"]],["lang/htdp-intermediate"]],
["/",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._/))",[0,[2,"/"]],["lang/htdp-intermediate-lambda"]],
["/",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._/))",[0,[2,"/"]],["deinprogramm/DMdA-advanced"]],
["/",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._/))",[0,[2,"/"]],["deinprogramm/DMdA-assignments"]],
["/",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._/))",[0,[2,"/"]],["deinprogramm/DMdA-beginner"]],
["/",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._/))",[0,[2,"/"]],["deinprogramm/DMdA-vanilla"]],
["/",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex-sre..rkt)._/))",[0,[1,"/"]],["parser-tools/lex-sre"]],
["/",">plai/mutator.html#(form._((lib._plai/mutator..rkt)._/))",[0,[2,"/"]],["plai/mutator"]],
["1+",">mzlib/mzlib_compat.html#(def._((lib._mzlib/compat..rkt)._1+))",[0,[2,"1+"]],["mzlib/compat"]],
["1-",">mzlib/mzlib_compat.html#(def._((lib._mzlib/compat..rkt)._1-))",[0,[2,"1-"]],["mzlib/compat"]],
["10pt",">scribble/SIGPLAN_Paper_Format.html#(form._((lib._scribble/sigplan..rkt)._10pt))",[0,[1,"10pt"]],["scribble/sigplan"]],
["12h-descending-date-ticks-formats",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._12h-descending-date-ticks-formats))",[0,[2,"12h-descending-date-ticks-formats"]],["plot"]],
["12h-descending-time-ticks-formats",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._12h-descending-time-ticks-formats))",[0,[2,"12h-descending-time-ticks-formats"]],["plot"]],
["24h-descending-date-ticks-formats",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._24h-descending-date-ticks-formats))",[0,[2,"24h-descending-date-ticks-formats"]],["plot"]],
["24h-descending-time-ticks-formats",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._24h-descending-time-ticks-formats))",[0,[2,"24h-descending-time-ticks-formats"]],["plot"]],
["2d contour (isoline) renderers",">plot/renderer2d.html#(part._2.D_.Contour__.Isoline__.Renderers)","2D Contour (Isoline) Renderers",false],
["2d interval renderers",">plot/renderer2d.html#(part._2.D_.Interval_.Renderers)","2D Interval Renderers",false],
["2d line renderers",">plot/renderer2d.html#(part._2.D_.Line_.Renderers)","2D Line Renderers",false],
["2d plot decoration renderers",">plot/renderer2d.html#(part._2.D_.Plot_.Decoration_.Renderers)","2D Plot Decoration Renderers",false],
["2d plot procedures",">plot/plot2d.html","2D Plot Procedures",false],
["2d point renderers",">plot/renderer2d.html#(part._2.D_.Point_.Renderers)","2D Point Renderers",false],
["2d rectangle renderers",">plot/renderer2d.html#(part._2.D_.Rectangle_.Renderers)","2D Rectangle Renderers",false],
["2d renderer function arguments",">plot/renderer2d.html#(part._renderer2d-function-arguments)","2D Renderer Function Arguments",false],
["2d renderers",">plot/renderer2d.html","2D Renderers",false],
["2htdp/batch-io",">teachpack/2htdpbatch-io.html",[9,[0,"2htdp/batch-io"]],"module"],
["2htdp/image",">teachpack/2htdpimage.html",[9,[0,"2htdp/image"]],"module"],
["2htdp/planetcute",">teachpack/2htdpPlanet_Cute_Images.html",[9,[0,"2htdp/planetcute"]],"module"],
["2htdp/universe",">teachpack/2htdpuniverse.html",[9,[0,"2htdp/universe"]],"module"],
["3d contour (isoline) renderers",">plot/renderer3d.html#(part._3.D_.Contour__.Isoline__.Renderers)","3D Contour (Isoline) Renderers",false],
["3d general appearance",">plot/params.html#(part._3.D_.General_.Appearance)","3D General Appearance",false],
["3d isosurface renderers",">plot/renderer3d.html#(part._3.D_.Isosurface_.Renderers)","3D Isosurface Renderers",false],
["3d line renderers",">plot/renderer3d.html#(part._3.D_.Line_.Renderers)","3D Line Renderers",false],
["3d plot procedures",">plot/plot3d.html","3D Plot Procedures",false],
["3d point renderers",">plot/renderer3d.html#(part._3.D_.Point_.Renderers)","3D Point Renderers",false],
["3d rectangle renderers",">plot/renderer3d.html#(part._3.D_.Rectangle_.Renderers)","3D Rectangle Renderers",false],
["3d renderer function arguments",">plot/renderer3d.html#(part._3.D_.Renderer_.Function_.Arguments)","3D Renderer Function Arguments",false],
["3d renderers",">plot/renderer3d.html","3D Renderers",false],
["3d surface renderers",">plot/renderer3d.html#(part._3.D_.Surface_.Renderers)","3D Surface Renderers",false],
["3d-linie",">deinprogramm/line3d.html#(tech._3d._linie)","<span style=\"font-style: italic\">3d-Linie</span>",false],
["3d-linien",">deinprogramm/line3d.html#(part._3dline)","3d-Linien",false],
["3d-liniengraphik: \"line3d.ss\"",">deinprogramm/line3d.html",["3D-Liniengraphik: ",[6,"\"line3d.ss\""],"<a name=\"(idx._(gentag._6._(lib._deinprogramm/scribblings/deinprogramm..scrbl)))\"></a>"],false],
["3d-polar->3d-cartesian",">plot/utils.html#(def._((lib._plot/utils..rkt)._3d-polar-~3e3d-cartesian))",[0,[2,"3d-polar->3d-cartesian"]],["plot/utils"]],
["3d-vektor",">deinprogramm/line3d.html#(tech._3d._vektor)","<span style=\"font-style: italic\">3D-Vektor</span>",false],
["3d-vektoren",">deinprogramm/line3d.html#(part._3.Dvectors)","3D-Vektoren",false],
["3m",">inside/overview.html#(idx._(gentag._0._(lib._scribblings/inside/inside..scrbl)))","3m",false],
["3m",">reference/runtime.html#(idx._(gentag._329._(lib._scribblings/reference/reference..scrbl)))",[7,"'3m"],false],
["3m",">guide/performance.html#(tech._3m)","<span style=\"font-style: italic\">3m</span>",false],
["3m embedding",">inside/overview.html#(part._3m_.Embedding)","3m Embedding",false],
["3m extensions",">inside/overview.html#(part._3m_.Extensions)","3m Extensions",false],
["3m-suffix",">config/index.html#(def._((lib._config/main..rkt)._3m-suffix))",[0,[2,"3m-suffix"]],["config"]],
["4d-vektor",">deinprogramm/line3d.html#(tech._4d._vektor)","<span style=\"font-style: italic\">4D-Vektor</span>",false],
["4d-vektoren",">deinprogramm/line3d.html#(part._4.Dvectors)","4D-Vektoren",false],
["4x4 matrizen",">deinprogramm/line3d.html#(part._4x4matrix)","4x4 Matrizen",false],
[":",">deinprogramm/Signaturen.html#(form._((lib._deinprogramm/.D.Md.A..rkt)._~3a))",[0,[1,":"]],["deinprogramm/DMdA-beginner"]],
[":",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex-sre..rkt)._~3a))",[0,[1,":"]],["parser-tools/lex-sre"]],
[":",">srfi-std/srfi-42.html#:",[0,[1,":"]],["srfi/42"]],
[":",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._~3a))",[0,[1,":"]],["typed/racket/base","typed/racket"]],
[":-",">datalog/interop.html#(form._((lib._datalog/main..rkt)._~3a-))",[0,[1,":-"]],["datalog"]],
["::=",">redex/The_Redex_Reference.html#(form._((lib._redex/reduction-semantics..rkt)._~3a~3a~3d))",[0,[1,"::="]],["redex/reduction-semantics","redex"]],
[":char-range",">srfi-std/srfi-42.html#:char-range",[0,[1,":char-range"]],["srfi/42"]],
[":dispatched",">srfi-std/srfi-42.html#",[0,[1,":dispatched"]],["srfi/42"]],
[":do",">srfi-std/srfi-42.html#:do",[0,[1,":do"]],["srfi/42"]],
[":do-in",">reference/for.html#(form._((lib._racket/private/base..rkt)._~3ado-in))",[0,[1,":do-in"]],["racket/base","racket"]],
[":generator-proc",">srfi-std/srfi-42.html#:generator-proc",[0,[1,":generator-proc"]],["srfi/42"]],
[":integers",">srfi-std/srfi-42.html#:integers",[0,[1,":integers"]],["srfi/42"]],
[":let",">srfi-std/srfi-42.html#:let",[0,[1,":let"]],["srfi/42"]],
[":list",">srfi-std/srfi-42.html#:list",[0,[1,":list"]],["srfi/42"]],
[":parallel",">srfi-std/srfi-42.html#:parallel",[0,[1,":parallel"]],["srfi/42"]],
[":port",">srfi-std/srfi-42.html#:port",[0,[1,":port"]],["srfi/42"]],
[":print-type",">ts-reference/Experimental_Features.html#(form._((lib._typed-racket/base-env/prims..rkt)._~3aprint-type))",[0,[1,":print-type"]],["typed/racket/base","typed/racket"]],
[":query-result-type",">ts-reference/Experimental_Features.html#(form._((lib._typed-racket/base-env/prims..rkt)._~3aquery-result-type))",[0,[1,":query-result-type"]],["typed/racket/base","typed/racket"]],
[":range",">srfi-std/srfi-42.html#:range",[0,[1,":range"]],["srfi/42"]],
[":real-range",">srfi-std/srfi-42.html#:real-range",[0,[1,":real-range"]],["srfi/42"]],
[":string",">srfi-std/srfi-42.html#:string",[0,[1,":string"]],["srfi/42"]],
[":type",">ts-reference/Experimental_Features.html#(form._((lib._typed-racket/base-env/prims..rkt)._~3atype))",[0,[1,":type"]],["typed/racket/base","typed/racket"]],
[":until",">srfi-std/srfi-42.html#:until",[0,[1,":until"]],["srfi/42"]],
[":vector",">srfi-std/srfi-42.html#:vector",[0,[1,":vector"]],["srfi/42"]],
[":while",">srfi-std/srfi-42.html#:while",[0,[1,":while"]],["srfi/42"]],
[";",">reference/reader.html#(idx._(gentag._63._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,";"],[4,""]]],false],
["<",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._~3c))",[0,[2,"<"]],["racket/base","racket"]],
["<",">r5rs-std/r5rs-Z-H-9.html#%_idx_260",[0,[2,"<"]],["r5rs"]],
["<",">r6rs-std/r6rs-Z-H-14.html#node_idx_466",[0,[2,"<"]],["rnrs/base-6"]],
["<",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._~3c))",[0,[2,"<"]],["lang/htdp-advanced"]],
["<",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._~3c))",[0,[2,"<"]],["lang/htdp-beginner"]],
["<",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._~3c))",[0,[2,"<"]],["lang/htdp-beginner-abbr"]],
["<",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._~3c))",[0,[2,"<"]],["lang/htdp-intermediate"]],
["<",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._~3c))",[0,[2,"<"]],["lang/htdp-intermediate-lambda"]],
["<",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._~3c))",[0,[2,"<"]],["deinprogramm/DMdA-advanced"]],
["<",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._~3c))",[0,[2,"<"]],["deinprogramm/DMdA-assignments"]],
["<",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._~3c))",[0,[2,"<"]],["deinprogramm/DMdA-beginner"]],
["<",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._~3c))",[0,[2,"<"]],["deinprogramm/DMdA-vanilla"]],
["<",">plai/mutator.html#(form._((lib._plai/mutator..rkt)._~3c))",[0,[2,"<"]],["plai/mutator"]],
["</c",">reference/data-structure-contracts.html#(def._((lib._racket/contract/private/misc..rkt)._~3c/c))",[0,[2,"</c"]],["racket/contract/base","racket/contract","racket"]],
["<=",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._~3c~3d))",[0,[2,"<="]],["racket/base","racket"]],
["<=",">r5rs-std/r5rs-Z-H-9.html#%_idx_264",[0,[2,"<="]],["r5rs"]],
["<=",">r6rs-std/r6rs-Z-H-14.html#node_idx_470",[0,[2,"<="]],["rnrs/base-6"]],
["<=",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._~3c~3d))",[0,[2,"<="]],["lang/htdp-advanced"]],
["<=",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._~3c~3d))",[0,[2,"<="]],["lang/htdp-beginner"]],
["<=",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._~3c~3d))",[0,[2,"<="]],["lang/htdp-beginner-abbr"]],
["<=",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._~3c~3d))",[0,[2,"<="]],["lang/htdp-intermediate"]],
["<=",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._~3c~3d))",[0,[2,"<="]],["lang/htdp-intermediate-lambda"]],
["<=",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._~3c~3d))",[0,[2,"<="]],["deinprogramm/DMdA-advanced"]],
["<=",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._~3c~3d))",[0,[2,"<="]],["deinprogramm/DMdA-assignments"]],
["<=",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._~3c~3d))",[0,[2,"<="]],["deinprogramm/DMdA-beginner"]],
["<=",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._~3c~3d))",[0,[2,"<="]],["deinprogramm/DMdA-vanilla"]],
["<=",">plai/mutator.html#(form._((lib._plai/mutator..rkt)._~3c~3d))",[0,[2,"<="]],["plai/mutator"]],
["<=/c",">reference/data-structure-contracts.html#(def._((lib._racket/contract/private/misc..rkt)._~3c~3d/c))",[0,[2,"<=/c"]],["racket/contract/base","racket/contract","racket"]],
["<=?",">mzlib/mzlib_compat.html#(def._((lib._mzlib/compat..rkt)._~3c~3d~3f))",[0,[2,"<=?"]],["mzlib/compat"]],
["<?",">mzlib/mzlib_compat.html#(def._((lib._mzlib/compat..rkt)._~3c~3f))",[0,[2,"<?"]],["mzlib/compat"]],
["=",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._~3d))",[0,[2,"="]],["racket/base","racket"]],
["=",">r5rs-std/r5rs-Z-H-9.html#%_idx_258",[0,[2,"="]],["r5rs"]],
["=",">r6rs-std/r6rs-Z-H-14.html#node_idx_464",[0,[2,"="]],["rnrs/base-6"]],
["=",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._~3d))",[0,[2,"="]],["lang/htdp-advanced"]],
["=",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._~3d))",[0,[2,"="]],["lang/htdp-beginner"]],
["=",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._~3d))",[0,[2,"="]],["lang/htdp-beginner-abbr"]],
["=",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._~3d))",[0,[2,"="]],["lang/htdp-intermediate"]],
["=",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._~3d))",[0,[2,"="]],["lang/htdp-intermediate-lambda"]],
["=",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._~3d))",[0,[2,"="]],["deinprogramm/DMdA-advanced"]],
["=",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._~3d))",[0,[2,"="]],["deinprogramm/DMdA-assignments"]],
["=",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._~3d))",[0,[2,"="]],["deinprogramm/DMdA-beginner"]],
["=",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._~3d))",[0,[2,"="]],["deinprogramm/DMdA-vanilla"]],
["=",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex-sre..rkt)._~3d))",[0,[1,"="]],["parser-tools/lex-sre"]],
["=",">plai/mutator.html#(form._((lib._plai/mutator..rkt)._~3d))",[0,[2,"="]],["plai/mutator"]],
["=#>",">frtime/index.html#(def._((lib._frtime/main..rkt)._~3d~23~3e))",[0,[2,"=#>"]],["frtime"]],
["=/c",">reference/data-structure-contracts.html#(def._((lib._racket/contract/private/misc..rkt)._~3d/c))",[0,[2,"=/c"]],["racket/contract/base","racket/contract","racket"]],
["==",">reference/match.html#(form._((lib._racket/match..rkt)._~3d~3d))",[0,[1,"=="]],["racket/match","racket"]],
["==>",">deinprogramm/Eigenschaften.html#(form._((lib._deinprogramm/.D.Md.A..rkt)._~3d~3d~3e))",[0,[1,"==>"]],["deinprogramm/DMdA-beginner"]],
["==>",">frtime/index.html#(def._((lib._frtime/main..rkt)._~3d~3d~3e))",[0,[2,"==>"]],["frtime"]],
["=>",">reference/if.html#(form._((lib._racket/private/letstx-scheme..rkt)._~3d~3e))",[0,[1,"=>"]],["racket/base","racket"]],
["=>",">r6rs-std/r6rs-Z-H-14.html#node_idx_378",[0,[1,"=>"]],["rnrs/base-6"]],
["=>",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_372",[0,[1,"=>"]],["rnrs/exceptions-6"]],
["=>*",">web-server/formlets.html#(form._((lib._web-server/formlets/dyn-syntax..rkt)._~3d~3e*))",[0,[1,"=>*"]],["web-server/formlets/dyn-syntax"]],
["=?",">mzlib/mzlib_compat.html#(def._((lib._mzlib/compat..rkt)._~3d~3f))",[0,[2,"=?"]],["mzlib/compat"]],
["=~",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._~3d~7e))",[0,[2,"=~"]],["lang/htdp-advanced"]],
["=~",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._~3d~7e))",[0,[2,"=~"]],["lang/htdp-beginner"]],
["=~",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._~3d~7e))",[0,[2,"=~"]],["lang/htdp-beginner-abbr"]],
["=~",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._~3d~7e))",[0,[2,"=~"]],["lang/htdp-intermediate"]],
["=~",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._~3d~7e))",[0,[2,"=~"]],["lang/htdp-intermediate-lambda"]],
[">",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._~3e))",[0,[2,">"]],["racket/base","racket"]],
[">",">r5rs-std/r5rs-Z-H-9.html#%_idx_262",[0,[2,">"]],["r5rs"]],
[">",">r6rs-std/r6rs-Z-H-14.html#node_idx_468",[0,[2,">"]],["rnrs/base-6"]],
[">",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._~3e))",[0,[2,">"]],["lang/htdp-advanced"]],
[">",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._~3e))",[0,[2,">"]],["lang/htdp-beginner"]],
[">",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._~3e))",[0,[2,">"]],["lang/htdp-beginner-abbr"]],
[">",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._~3e))",[0,[2,">"]],["lang/htdp-intermediate"]],
[">",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._~3e))",[0,[2,">"]],["lang/htdp-intermediate-lambda"]],
[">",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._~3e))",[0,[2,">"]],["deinprogramm/DMdA-advanced"]],
[">",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._~3e))",[0,[2,">"]],["deinprogramm/DMdA-assignments"]],
[">",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._~3e))",[0,[2,">"]],["deinprogramm/DMdA-beginner"]],
[">",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._~3e))",[0,[2,">"]],["deinprogramm/DMdA-vanilla"]],
[">",">plai/mutator.html#(form._((lib._plai/mutator..rkt)._~3e))",[0,[2,">"]],["plai/mutator"]],
["> prompt",">drracket/interactions-window.html#(idx._(gentag._23._(lib._scribblings/drracket/drracket..scrbl)))","> prompt",false],
[">/c",">reference/data-structure-contracts.html#(def._((lib._racket/contract/private/misc..rkt)._~3e/c))",[0,[2,">/c"]],["racket/contract/base","racket/contract","racket"]],
[">=",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._~3e~3d))",[0,[2,">="]],["racket/base","racket"]],
[">=",">r5rs-std/r5rs-Z-H-9.html#%_idx_266",[0,[2,">="]],["r5rs"]],
[">=",">r6rs-std/r6rs-Z-H-14.html#node_idx_472",[0,[2,">="]],["rnrs/base-6"]],
[">=",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._~3e~3d))",[0,[2,">="]],["lang/htdp-advanced"]],
[">=",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._~3e~3d))",[0,[2,">="]],["lang/htdp-beginner"]],
[">=",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._~3e~3d))",[0,[2,">="]],["lang/htdp-beginner-abbr"]],
[">=",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._~3e~3d))",[0,[2,">="]],["lang/htdp-intermediate"]],
[">=",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._~3e~3d))",[0,[2,">="]],["lang/htdp-intermediate-lambda"]],
[">=",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._~3e~3d))",[0,[2,">="]],["deinprogramm/DMdA-advanced"]],
[">=",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._~3e~3d))",[0,[2,">="]],["deinprogramm/DMdA-assignments"]],
[">=",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._~3e~3d))",[0,[2,">="]],["deinprogramm/DMdA-beginner"]],
[">=",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._~3e~3d))",[0,[2,">="]],["deinprogramm/DMdA-vanilla"]],
[">=",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex-sre..rkt)._~3e~3d))",[0,[1,">="]],["parser-tools/lex-sre"]],
[">=",">plai/mutator.html#(form._((lib._plai/mutator..rkt)._~3e~3d))",[0,[2,">="]],["plai/mutator"]],
[">=/c",">reference/data-structure-contracts.html#(def._((lib._racket/contract/private/misc..rkt)._~3e~3d/c))",[0,[2,">=/c"]],["racket/contract/base","racket/contract","racket"]],
[">=?",">mzlib/mzlib_compat.html#(def._((lib._mzlib/compat..rkt)._~3e~3d~3f))",[0,[2,">=?"]],["mzlib/compat"]],
[">?",">mzlib/mzlib_compat.html#(def._((lib._mzlib/compat..rkt)._~3e~3f))",[0,[2,">?"]],["mzlib/compat"]],
["?",">datalog/interop.html#(form._((lib._datalog/main..rkt)._~3f))",[0,[1,"?"]],["datalog"]],
["?",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex-sre..rkt)._~3f))",[0,[1,"?"]],["parser-tools/lex-sre"]],
["?-",">scribble/base.html#(def._((lib._scribble/base..rkt)._~3f-))",[0,[2,"?-"]],["scribble/base"]],
["??",">syntax/Experimental.html#(form._((lib._syntax/parse/experimental/template..rkt)._~3f~3f))",[0,[1,"??"]],["syntax/parse/experimental/template"]],
["?@",">syntax/Experimental.html#(form._((lib._syntax/parse/experimental/template..rkt)._~3f~40))",[0,[1,"?@"]],["syntax/parse/experimental/template"]],
["@ reader internals",">scribble/reader-internals.html","@ Reader Internals",false],
["@ syntax",">scribble/reader.html","@ Syntax",false],
["@ syntax basics",">scribble/getting-started.html#(part._how-to~3areader)","@ Syntax Basics",false],
["[",">reference/reader.html#(idx._(gentag._23._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"["],[4,""]]],false],
["\\",">reference/reader.html#(idx._(gentag._3._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"\\"],[4,""]]],false],
["\\\"",">reference/reader.html#(idx._(gentag._43._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"\\\""],[4,""]]],false],
["\\'",">reference/reader.html#(idx._(gentag._44._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"\\'"],[4,""]]],false],
["\\<digit8>{1,3}",">reference/reader.html#(idx._(gentag._46._(lib._scribblings/reference/reference..scrbl)))",[[3,[[4,""],[5,"\\"],[4,""]]],"&#8249;","<span style=\"font-style: italic\">digit<span style=\"vertical-align: sub; font-size: 80%\">8</span></span>","&#8250;","<span style=\"vertical-align: super; font-size: 80%\">{1,3}</span>"],false],
["\\<newline>",">reference/reader.html#(idx._(gentag._51._(lib._scribblings/reference/reference..scrbl)))",[[3,[[4,""],[5,"\\"],[4,""]]],"&#8249;","<span style=\"font-style: italic\">newline</span>","&#8250;"],false],
["\\\\",">reference/reader.html#(idx._(gentag._45._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"\\\\"],[4,""]]],false],
["\\a",">reference/reader.html#(idx._(gentag._35._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"\\a"],[4,""]]],false],
["\\aleph keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._236._(lib._scribblings/drracket/drracket..scrbl)))","\\aleph keyboard shortcut",false],
["\\alpha keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._254._(lib._scribblings/drracket/drracket..scrbl)))","\\alpha keyboard shortcut",false],
["\\amalg keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._321._(lib._scribblings/drracket/drracket..scrbl)))","\\amalg keyboard shortcut",false],
["\\approx keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._341._(lib._scribblings/drracket/drracket..scrbl)))","\\approx keyboard shortcut",false],
["\\ast keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._310._(lib._scribblings/drracket/drracket..scrbl)))","\\ast keyboard shortcut",false],
["\\asymp keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._337._(lib._scribblings/drracket/drracket..scrbl)))","\\asymp keyboard shortcut",false],
["\\b",">reference/reader.html#(idx._(gentag._36._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"\\b"],[4,""]]],false],
["\\beta keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._257._(lib._scribblings/drracket/drracket..scrbl)))","\\beta keyboard shortcut",false],
["\\bigtriangledown keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._304._(lib._scribblings/drracket/drracket..scrbl)))","\\bigtriangledown keyboard shortcut",false],
["\\bigtriangleup keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._300._(lib._scribblings/drracket/drracket..scrbl)))","\\bigtriangleup keyboard shortcut",false],
["\\blacksmiley keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._363._(lib._scribblings/drracket/drracket..scrbl)))","\\blacksmiley keyboard shortcut",false],
["\\bot keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._330._(lib._scribblings/drracket/drracket..scrbl)))","\\bot keyboard shortcut",false],
["\\bowtie keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._342._(lib._scribblings/drracket/drracket..scrbl)))","\\bowtie keyboard shortcut",false],
["\\bullet keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._318._(lib._scribblings/drracket/drracket..scrbl)))","\\bullet keyboard shortcut",false],
["\\cap keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._295._(lib._scribblings/drracket/drracket..scrbl)))","\\cap keyboard shortcut",false],
["\\cdot keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._359._(lib._scribblings/drracket/drracket..scrbl)))","\\cdot keyboard shortcut",false],
["\\chi keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._271._(lib._scribblings/drracket/drracket..scrbl)))","\\chi keyboard shortcut",false],
["\\circ keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._253._(lib._scribblings/drracket/drracket..scrbl)))","\\circ keyboard shortcut",false],
["\\clubsuit keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._242._(lib._scribblings/drracket/drracket..scrbl)))","\\clubsuit keyboard shortcut",false],
["\\cong keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._345._(lib._scribblings/drracket/drracket..scrbl)))","\\cong keyboard shortcut",false],
["\\cup keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._299._(lib._scribblings/drracket/drracket..scrbl)))","\\cup keyboard shortcut",false],
["\\dagger keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._317._(lib._scribblings/drracket/drracket..scrbl)))","\\dagger keyboard shortcut",false],
["\\dashv keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._358._(lib._scribblings/drracket/drracket..scrbl)))","\\dashv keyboard shortcut",false],
["\\ddagger keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._319._(lib._scribblings/drracket/drracket..scrbl)))","\\ddagger keyboard shortcut",false],
["\\delta keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._287._(lib._scribblings/drracket/drracket..scrbl)))","\\Delta keyboard shortcut",false],
["\\delta keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._264._(lib._scribblings/drracket/drracket..scrbl)))","\\delta keyboard shortcut",false],
["\\diamond keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._296._(lib._scribblings/drracket/drracket..scrbl)))","\\diamond keyboard shortcut",false],
["\\diamondsuit keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._240._(lib._scribblings/drracket/drracket..scrbl)))","\\diamondsuit keyboard shortcut",false],
["\\div keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._306._(lib._scribblings/drracket/drracket..scrbl)))","\\div keyboard shortcut",false],
["\\doteq keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._352._(lib._scribblings/drracket/drracket..scrbl)))","\\doteq keyboard shortcut",false],
["\\downarrow keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._218._(lib._scribblings/drracket/drracket..scrbl)))","\\Downarrow keyboard shortcut",false],
["\\downarrow keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._220._(lib._scribblings/drracket/drracket..scrbl)))","\\downarrow keyboard shortcut",false],
["\\e",">reference/reader.html#(idx._(gentag._42._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"\\e"],[4,""]]],false],
["\\emptyset keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._238._(lib._scribblings/drracket/drracket..scrbl)))","\\emptyset keyboard shortcut",false],
["\\epsilon keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._268._(lib._scribblings/drracket/drracket..scrbl)))","\\epsilon keyboard shortcut",false],
["\\equiv keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._324._(lib._scribblings/drracket/drracket..scrbl)))","\\equiv keyboard shortcut",false],
["\\eta keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._280._(lib._scribblings/drracket/drracket..scrbl)))","\\eta keyboard shortcut",false],
["\\exists keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._251._(lib._scribblings/drracket/drracket..scrbl)))","\\exists keyboard shortcut",false],
["\\f",">reference/reader.html#(idx._(gentag._40._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"\\f"],[4,""]]],false],
["\\flat keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._245._(lib._scribblings/drracket/drracket..scrbl)))","\\flat keyboard shortcut",false],
["\\forall keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._250._(lib._scribblings/drracket/drracket..scrbl)))","\\forall keyboard shortcut",false],
["\\frown keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._353._(lib._scribblings/drracket/drracket..scrbl)))","\\frown keyboard shortcut",false],
["\\frownie keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._364._(lib._scribblings/drracket/drracket..scrbl)))","\\frownie keyboard shortcut",false],
["\\gamma keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._283._(lib._scribblings/drracket/drracket..scrbl)))","\\Gamma keyboard shortcut",false],
["\\gamma keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._261._(lib._scribblings/drracket/drracket..scrbl)))","\\gamma keyboard shortcut",false],
["\\geq keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._323._(lib._scribblings/drracket/drracket..scrbl)))","\\geq keyboard shortcut",false],
["\\gg keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._336._(lib._scribblings/drracket/drracket..scrbl)))","\\gg keyboard shortcut",false],
["\\heartsuit keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._243._(lib._scribblings/drracket/drracket..scrbl)))","\\heartsuit keyboard shortcut",false],
["\\in keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._354._(lib._scribblings/drracket/drracket..scrbl)))","\\in keyboard shortcut",false],
["\\infty keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._252._(lib._scribblings/drracket/drracket..scrbl)))","\\infty keyboard shortcut",false],
["\\iota keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._282._(lib._scribblings/drracket/drracket..scrbl)))","\\iota keyboard shortcut",false],
["\\kappa keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._265._(lib._scribblings/drracket/drracket..scrbl)))","\\kappa keyboard shortcut",false],
["\\lambda keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._284._(lib._scribblings/drracket/drracket..scrbl)))","\\Lambda keyboard shortcut",false],
["\\lambda keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._269._(lib._scribblings/drracket/drracket..scrbl)))","\\lambda keyboard shortcut",false],
["\\leftarrow keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._228._(lib._scribblings/drracket/drracket..scrbl)))","\\Leftarrow keyboard shortcut",false],
["\\leftarrow keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._226._(lib._scribblings/drracket/drracket..scrbl)))","\\leftarrow keyboard shortcut",false],
["\\leftrightarrow keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._231._(lib._scribblings/drracket/drracket..scrbl)))","\\Leftrightarrow keyboard shortcut",false],
["\\leftrightarrow keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._233._(lib._scribblings/drracket/drracket..scrbl)))","\\leftrightarrow keyboard shortcut",false],
["\\leq keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._322._(lib._scribblings/drracket/drracket..scrbl)))","\\leq keyboard shortcut",false],
["\\ll keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._335._(lib._scribblings/drracket/drracket..scrbl)))","\\ll keyboard shortcut",false],
["\\longrightarrow keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._229._(lib._scribblings/drracket/drracket..scrbl)))","\\longrightarrow keyboard shortcut",false],
["\\mapsto keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._223._(lib._scribblings/drracket/drracket..scrbl)))","\\mapsto keyboard shortcut",false],
["\\models keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._325._(lib._scribblings/drracket/drracket..scrbl)))","\\models keyboard shortcut",false],
["\\mp keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._298._(lib._scribblings/drracket/drracket..scrbl)))","\\mp keyboard shortcut",false],
["\\mu keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._273._(lib._scribblings/drracket/drracket..scrbl)))","\\mu keyboard shortcut",false],
["\\n",">reference/reader.html#(idx._(gentag._38._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"\\n"],[4,""]]],false],
["\\nabla keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._239._(lib._scribblings/drracket/drracket..scrbl)))","\\nabla keyboard shortcut",false],
["\\natural keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._246._(lib._scribblings/drracket/drracket..scrbl)))","\\natural keyboard shortcut",false],
["\\nearrow keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._234._(lib._scribblings/drracket/drracket..scrbl)))","\\nearrow keyboard shortcut",false],
["\\neg keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._248._(lib._scribblings/drracket/drracket..scrbl)))","\\neg keyboard shortcut",false],
["\\neq keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._348._(lib._scribblings/drracket/drracket..scrbl)))","\\neq keyboard shortcut",false],
["\\newpage keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._366._(lib._scribblings/drracket/drracket..scrbl)))","\\newpage keyboard shortcut",false],
["\\ni keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._355._(lib._scribblings/drracket/drracket..scrbl)))","\\ni keyboard shortcut",false],
["\\nu keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._277._(lib._scribblings/drracket/drracket..scrbl)))","\\nu keyboard shortcut",false],
["\\nwarrow keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._219._(lib._scribblings/drracket/drracket..scrbl)))","\\nwarrow keyboard shortcut",false],
["\\odot keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._315._(lib._scribblings/drracket/drracket..scrbl)))","\\odot keyboard shortcut",false],
["\\omega keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._290._(lib._scribblings/drracket/drracket..scrbl)))","\\Omega keyboard shortcut",false],
["\\omega keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._279._(lib._scribblings/drracket/drracket..scrbl)))","\\omega keyboard shortcut",false],
["\\ominus keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._301._(lib._scribblings/drracket/drracket..scrbl)))","\\ominus keyboard shortcut",false],
["\\oplus keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._297._(lib._scribblings/drracket/drracket..scrbl)))","\\oplus keyboard shortcut",false],
["\\oslash keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._309._(lib._scribblings/drracket/drracket..scrbl)))","\\oslash keyboard shortcut",false],
["\\otimes keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._305._(lib._scribblings/drracket/drracket..scrbl)))","\\otimes keyboard shortcut",false],
["\\parallel keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._338._(lib._scribblings/drracket/drracket..scrbl)))","\\parallel keyboard shortcut",false],
["\\perp keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._329._(lib._scribblings/drracket/drracket..scrbl)))","\\perp keyboard shortcut",false],
["\\phi keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._293._(lib._scribblings/drracket/drracket..scrbl)))","\\Phi keyboard shortcut",false],
["\\phi keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._263._(lib._scribblings/drracket/drracket..scrbl)))","\\phi keyboard shortcut",false],
["\\pi keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._292._(lib._scribblings/drracket/drracket..scrbl)))","\\Pi keyboard shortcut",false],
["\\pi keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._259._(lib._scribblings/drracket/drracket..scrbl)))","\\pi keyboard shortcut",false],
["\\pm keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._294._(lib._scribblings/drracket/drracket..scrbl)))","\\pm keyboard shortcut",false],
["\\prec keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._326._(lib._scribblings/drracket/drracket..scrbl)))","\\prec keyboard shortcut",false],
["\\preceq keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._332._(lib._scribblings/drracket/drracket..scrbl)))","\\preceq keyboard shortcut",false],
["\\prime keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._237._(lib._scribblings/drracket/drracket..scrbl)))","\\prime keyboard shortcut",false],
["\\propto keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._356._(lib._scribblings/drracket/drracket..scrbl)))","\\propto keyboard shortcut",false],
["\\psi keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._286._(lib._scribblings/drracket/drracket..scrbl)))","\\Psi keyboard shortcut",false],
["\\psi keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._275._(lib._scribblings/drracket/drracket..scrbl)))","\\psi keyboard shortcut",false],
["\\r",">reference/reader.html#(idx._(gentag._41._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"\\r"],[4,""]]],false],
["\\rho keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._266._(lib._scribblings/drracket/drracket..scrbl)))","\\rho keyboard shortcut",false],
["\\rightarrow keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._221._(lib._scribblings/drracket/drracket..scrbl)))","\\Rightarrow keyboard shortcut",false],
["\\rightarrow keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._222._(lib._scribblings/drracket/drracket..scrbl)))","\\rightarrow keyboard shortcut",false],
["\\s keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._365._(lib._scribblings/drracket/drracket..scrbl)))","\\S keyboard shortcut",false],
["\\searrow keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._224._(lib._scribblings/drracket/drracket..scrbl)))","\\searrow keyboard shortcut",false],
["\\sharp keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._244._(lib._scribblings/drracket/drracket..scrbl)))","\\sharp keyboard shortcut",false],
["\\sigma keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._285._(lib._scribblings/drracket/drracket..scrbl)))","\\Sigma keyboard shortcut",false],
["\\sigma keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._274._(lib._scribblings/drracket/drracket..scrbl)))","\\sigma keyboard shortcut",false],
["\\sim keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._328._(lib._scribblings/drracket/drracket..scrbl)))","\\sim keyboard shortcut",false],
["\\simeq keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._334._(lib._scribblings/drracket/drracket..scrbl)))","\\simeq keyboard shortcut",false],
["\\skull keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._361._(lib._scribblings/drracket/drracket..scrbl)))","\\skull keyboard shortcut",false],
["\\smile keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._349._(lib._scribblings/drracket/drracket..scrbl)))","\\smile keyboard shortcut",false],
["\\smiley keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._362._(lib._scribblings/drracket/drracket..scrbl)))","\\smiley keyboard shortcut",false],
["\\spadesuit keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._241._(lib._scribblings/drracket/drracket..scrbl)))","\\spadesuit keyboard shortcut",false],
["\\sqcap keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._307._(lib._scribblings/drracket/drracket..scrbl)))","\\sqcap keyboard shortcut",false],
["\\sqcup keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._311._(lib._scribblings/drracket/drracket..scrbl)))","\\sqcup keyboard shortcut",false],
["\\sqrt keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._360._(lib._scribblings/drracket/drracket..scrbl)))","\\sqrt keyboard shortcut",false],
["\\sqsubsetb keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._346._(lib._scribblings/drracket/drracket..scrbl)))","\\sqsubsetb keyboard shortcut",false],
["\\sqsubseteq keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._350._(lib._scribblings/drracket/drracket..scrbl)))","\\sqsubseteq keyboard shortcut",false],
["\\sqsupsetb keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._347._(lib._scribblings/drracket/drracket..scrbl)))","\\sqsupsetb keyboard shortcut",false],
["\\sqsupseteq keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._351._(lib._scribblings/drracket/drracket..scrbl)))","\\sqsupseteq keyboard shortcut",false],
["\\star keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._316._(lib._scribblings/drracket/drracket..scrbl)))","\\star keyboard shortcut",false],
["\\subset keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._339._(lib._scribblings/drracket/drracket..scrbl)))","\\subset keyboard shortcut",false],
["\\subseteq keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._343._(lib._scribblings/drracket/drracket..scrbl)))","\\subseteq keyboard shortcut",false],
["\\succ keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._327._(lib._scribblings/drracket/drracket..scrbl)))","\\succ keyboard shortcut",false],
["\\succeq keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._333._(lib._scribblings/drracket/drracket..scrbl)))","\\succeq keyboard shortcut",false],
["\\supset keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._340._(lib._scribblings/drracket/drracket..scrbl)))","\\supset keyboard shortcut",false],
["\\supseteq keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._344._(lib._scribblings/drracket/drracket..scrbl)))","\\supseteq keyboard shortcut",false],
["\\surd keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._247._(lib._scribblings/drracket/drracket..scrbl)))","\\surd keyboard shortcut",false],
["\\swarrow keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._225._(lib._scribblings/drracket/drracket..scrbl)))","\\swarrow keyboard shortcut",false],
["\\t",">reference/reader.html#(idx._(gentag._37._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"\\t"],[4,""]]],false],
["\\tau keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._256._(lib._scribblings/drracket/drracket..scrbl)))","\\tau keyboard shortcut",false],
["\\theta keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._291._(lib._scribblings/drracket/drracket..scrbl)))","\\Theta keyboard shortcut",false],
["\\theta keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._255._(lib._scribblings/drracket/drracket..scrbl)))","\\theta keyboard shortcut",false],
["\\times keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._302._(lib._scribblings/drracket/drracket..scrbl)))","\\times keyboard shortcut",false],
["\\top keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._331._(lib._scribblings/drracket/drracket..scrbl)))","\\top keyboard shortcut",false],
["\\triangle keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._249._(lib._scribblings/drracket/drracket..scrbl)))","\\triangle keyboard shortcut",false],
["\\triangleleft keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._314._(lib._scribblings/drracket/drracket..scrbl)))","\\triangleleft keyboard shortcut",false],
["\\triangleright keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._308._(lib._scribblings/drracket/drracket..scrbl)))","\\triangleright keyboard shortcut",false],
["\\u<digit16>{1,4}",">reference/reader.html#(idx._(gentag._48._(lib._scribblings/reference/reference..scrbl)))",[[3,[[4,""],[5,"\\u"],[4,""]]],"&#8249;","<span style=\"font-style: italic\">digit<span style=\"vertical-align: sub; font-size: 80%\">16</span></span>","&#8250;","<span style=\"vertical-align: super; font-size: 80%\">{1,4}</span>"],false],
["\\u<digit16>{1,8}",">reference/reader.html#(idx._(gentag._50._(lib._scribblings/reference/reference..scrbl)))",[[3,[[4,""],[5,"\\U"],[4,""]]],"&#8249;","<span style=\"font-style: italic\">digit<span style=\"vertical-align: sub; font-size: 80%\">16</span></span>","&#8250;","<span style=\"vertical-align: super; font-size: 80%\">{1,8}</span>"],false],
["\\u<digit16>{4,4}\\u<digit16>{4,4}",">reference/reader.html#(idx._(gentag._49._(lib._scribblings/reference/reference..scrbl)))",[[3,[[4,""],[5,"\\u"],[4,""]]],"&#8249;","<span style=\"font-style: italic\">digit<span style=\"vertical-align: sub; font-size: 80%\">16</span></span>","&#8250;","<span style=\"vertical-align: super; font-size: 80%\">{4,4}</span>",[3,[[4,""],[5,"\\u"],[4,""]]],"&#8249;","<span style=\"font-style: italic\">digit<span style=\"vertical-align: sub; font-size: 80%\">16</span></span>","&#8250;","<span style=\"vertical-align: super; font-size: 80%\">{4,4}</span>"],false],
["\\uparrow keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._230._(lib._scribblings/drracket/drracket..scrbl)))","\\Uparrow keyboard shortcut",false],
["\\uparrow keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._227._(lib._scribblings/drracket/drracket..scrbl)))","\\uparrow keyboard shortcut",false],
["\\updownarrow keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._235._(lib._scribblings/drracket/drracket..scrbl)))","\\Updownarrow keyboard shortcut",false],
["\\updownarrow keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._232._(lib._scribblings/drracket/drracket..scrbl)))","\\updownarrow keyboard shortcut",false],
["\\uplus keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._303._(lib._scribblings/drracket/drracket..scrbl)))","\\uplus keyboard shortcut",false],
["\\upsilon keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._289._(lib._scribblings/drracket/drracket..scrbl)))","\\Upsilon keyboard shortcut",false],
["\\upsilon keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._260._(lib._scribblings/drracket/drracket..scrbl)))","\\upsilon keyboard shortcut",false],
["\\v",">reference/reader.html#(idx._(gentag._39._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"\\v"],[4,""]]],false],
["\\varepsilon keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._272._(lib._scribblings/drracket/drracket..scrbl)))","\\varepsilon keyboard shortcut",false],
["\\varphi keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._267._(lib._scribblings/drracket/drracket..scrbl)))","\\varphi keyboard shortcut",false],
["\\varpi keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._262._(lib._scribblings/drracket/drracket..scrbl)))","\\varpi keyboard shortcut",false],
["\\varrho keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._270._(lib._scribblings/drracket/drracket..scrbl)))","\\varrho keyboard shortcut",false],
["\\varsigma keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._278._(lib._scribblings/drracket/drracket..scrbl)))","\\varsigma keyboard shortcut",false],
["\\vartheta keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._258._(lib._scribblings/drracket/drracket..scrbl)))","\\vartheta keyboard shortcut",false],
["\\vdash keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._357._(lib._scribblings/drracket/drracket..scrbl)))","\\vdash keyboard shortcut",false],
["\\vee keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._312._(lib._scribblings/drracket/drracket..scrbl)))","\\vee keyboard shortcut",false],
["\\wedge keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._313._(lib._scribblings/drracket/drracket..scrbl)))","\\wedge keyboard shortcut",false],
["\\wr keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._320._(lib._scribblings/drracket/drracket..scrbl)))","\\wr keyboard shortcut",false],
["\\x<digit16>{1,2}",">reference/reader.html#(idx._(gentag._47._(lib._scribblings/reference/reference..scrbl)))",[[3,[[4,""],[5,"\\x"],[4,""]]],"&#8249;","<span style=\"font-style: italic\">digit<span style=\"vertical-align: sub; font-size: 80%\">16</span></span>","&#8250;","<span style=\"vertical-align: super; font-size: 80%\">{1,2}</span>"],false],
["\\xi keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._288._(lib._scribblings/drracket/drracket..scrbl)))","\\Xi keyboard shortcut",false],
["\\xi keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._281._(lib._scribblings/drracket/drracket..scrbl)))","\\xi keyboard shortcut",false],
["\\zeta keyboard shortcut",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._276._(lib._scribblings/drracket/drracket..scrbl)))","\\zeta keyboard shortcut",false],
["]",">reference/reader.html#(idx._(gentag._26._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"]"],[4,""]]],false],
["_",">reference/stx-patterns.html#(form._((lib._racket/private/stxcase-scheme..rkt).__))",[0,[1,"_"]],["racket/base","racket"]],
["_",">r6rs-std/r6rs-Z-H-14.html#node_idx_788",[0,[1,"_"]],["r6rs/private/base-for-syntax"]],
["_",">r6rs-lib-std/r6rs-lib-Z-H-13.html#node_idx_1126",[0,[1,"_"]],["rnrs/syntax-case-6"]],
["_",">racklog/glossary.html#(def._((lib._racklog/main..rkt).__))",[0,[2,"_"]],["racklog"]],
["_?",">foreign/foreign_procedures.html#(form._((lib._ffi/unsafe..rkt).__~3f))",[0,[1,"_?"]],["ffi/unsafe"]],
["_array",">foreign/C_Array_Types.html#(def._((lib._ffi/unsafe..rkt).__array))",[0,[2,"_array"]],["ffi/unsafe"]],
["_array/list",">foreign/C_Array_Types.html#(def._((lib._ffi/unsafe..rkt).__array/list))",[0,[2,"_array/list"]],["ffi/unsafe"]],
["_array/vector",">foreign/C_Array_Types.html#(def._((lib._ffi/unsafe..rkt).__array/vector))",[0,[2,"_array/vector"]],["ffi/unsafe"]],
["_bitmask",">foreign/Enumerations_and_Masks.html#(def._((lib._ffi/unsafe..rkt).__bitmask))",[0,[2,"_bitmask"]],["ffi/unsafe"]],
["_bool",">foreign/Other_Atomic_Types.html#(def._((quote._~23~25foreign).__bool))",[0,[2,"_bool"]],["ffi/unsafe"]],
["_bool",">foreign/Objective-C_FFI.html#(def._((lib._ffi/unsafe/objc..rkt).__.B.O.O.L))",[0,[2,"_BOOL"]],["ffi/unsafe/objc"]],
["_box",">foreign/foreign_procedures.html#(form._((lib._ffi/unsafe..rkt).__box))",[0,[1,"_box"]],["ffi/unsafe"]],
["_byte",">foreign/Numeric_Types.html#(def._((lib._ffi/unsafe..rkt).__byte))",[0,[2,"_byte"]],["ffi/unsafe"]],
["_bytes",">foreign/foreign_procedures.html#(form._((lib._ffi/unsafe..rkt).__bytes))",[0,[1,"_bytes"]],["ffi/unsafe"]],
["_bytes/eof",">foreign/String_Types.html#(def._((lib._ffi/unsafe..rkt).__bytes/eof))",[0,[2,"_bytes/eof"]],["ffi/unsafe"]],
["_class",">foreign/Objective-C_FFI.html#(def._((lib._ffi/unsafe/objc..rkt).__.Class))",[0,[2,"_Class"]],["ffi/unsafe/objc"]],
["_cpointer",">foreign/foreign_tagged-pointers.html#(def._((lib._ffi/unsafe..rkt).__cpointer))",[0,[2,"_cpointer"]],["ffi/unsafe"]],
["_cpointer/null",">foreign/foreign_tagged-pointers.html#(def._((lib._ffi/unsafe..rkt).__cpointer/null))",[0,[2,"_cpointer/null"]],["ffi/unsafe"]],
["_cprocedure",">foreign/foreign_procedures.html#(def._((lib._ffi/unsafe..rkt).__cprocedure))",[0,[2,"_cprocedure"]],["ffi/unsafe"]],
["_cvector",">foreign/foreign_cvector.html#(form._((lib._ffi/unsafe/cvector..rkt).__cvector))",[0,[1,"_cvector"]],["ffi/cvector","ffi/unsafe/cvector"]],
["_double",">foreign/Numeric_Types.html#(def._((quote._~23~25foreign).__double))",[0,[2,"_double"]],["ffi/unsafe"]],
["_double*",">foreign/Numeric_Types.html#(def._((quote._~23~25foreign).__double*))",[0,[2,"_double*"]],["ffi/unsafe"]],
["_enum",">foreign/Enumerations_and_Masks.html#(def._((lib._ffi/unsafe..rkt).__enum))",[0,[2,"_enum"]],["ffi/unsafe"]],
["_f32vector",">foreign/homogeneous-vectors.html#(form._((lib._ffi/vector..rkt).__f32vector))",[0,[1,"_f32vector"]],["ffi/vector"]],
["_f64vector",">foreign/homogeneous-vectors.html#(form._((lib._ffi/vector..rkt).__f64vector))",[0,[1,"_f64vector"]],["ffi/vector"]],
["_file",">foreign/String_Types.html#(def._((lib._ffi/unsafe..rkt).__file))",[0,[2,"_file"]],["ffi/unsafe"]],
["_file/guard",">foreign/file-security-guard-checks.html#(def._((lib._ffi/file..rkt).__file/guard))",[0,[2,"_file/guard"]],["ffi/file"]],
["_file/r",">foreign/file-security-guard-checks.html#(def._((lib._ffi/file..rkt).__file/r))",[0,[2,"_file/r"]],["ffi/file"]],
["_file/rw",">foreign/file-security-guard-checks.html#(def._((lib._ffi/file..rkt).__file/rw))",[0,[2,"_file/rw"]],["ffi/file"]],
["_fixint",">foreign/Numeric_Types.html#(def._((quote._~23~25foreign).__fixint))",[0,[2,"_fixint"]],["ffi/unsafe"]],
["_fixnum",">foreign/Numeric_Types.html#(def._((quote._~23~25foreign).__fixnum))",[0,[2,"_fixnum"]],["ffi/unsafe"]],
["_float",">foreign/Numeric_Types.html#(def._((quote._~23~25foreign).__float))",[0,[2,"_float"]],["ffi/unsafe"]],
["_fpointer",">foreign/Pointer_Types.html#(def._((quote._~23~25foreign).__fpointer))",[0,[2,"_fpointer"]],["ffi/unsafe"]],
["_fun",">foreign/foreign_procedures.html#(form._((lib._ffi/unsafe..rkt).__fun))",[0,[1,"_fun"]],["ffi/unsafe"]],
["_gcable",">foreign/Pointer_Types.html#(def._((lib._ffi/unsafe..rkt).__gcable))",[0,[2,"_gcable"]],["ffi/unsafe"]],
["_gcpointer",">foreign/Pointer_Types.html#(def._((quote._~23~25foreign).__gcpointer))",[0,[2,"_gcpointer"]],["ffi/unsafe"]],
["_guid",">foreign/com-intf.html#(def._((lib._ffi/unsafe/com..rkt).__.G.U.I.D))",[0,[2,"_GUID"]],["ffi/unsafe/com"]],
["_guid-pointer",">foreign/com-intf.html#(def._((lib._ffi/unsafe/com..rkt).__.G.U.I.D-pointer))",[0,[2,"_GUID-pointer"]],["ffi/unsafe/com"]],
["_hfun",">foreign/com-intf.html#(form._((lib._ffi/unsafe/com..rkt).__hfun))",[0,[1,"_hfun"]],["ffi/unsafe/com"]],
["_hmfun",">foreign/com-intf.html#(form._((lib._ffi/unsafe/com..rkt).__hmfun))",[0,[1,"_hmfun"]],["ffi/unsafe/com"]],
["_hresult",">foreign/com-intf.html#(def._((lib._ffi/unsafe/com..rkt).__.H.R.E.S.U.L.T))",[0,[2,"_HRESULT"]],["ffi/unsafe/com"]],
["_id",">foreign/Objective-C_FFI.html#(def._((lib._ffi/unsafe/objc..rkt).__id))",[0,[2,"_id"]],["ffi/unsafe/objc"]],
["_int",">foreign/Numeric_Types.html#(def._((lib._ffi/unsafe..rkt).__int))",[0,[2,"_int"]],["ffi/unsafe"]],
["_int16",">foreign/Numeric_Types.html#(def._((quote._~23~25foreign).__int16))",[0,[2,"_int16"]],["ffi/unsafe"]],
["_int32",">foreign/Numeric_Types.html#(def._((quote._~23~25foreign).__int32))",[0,[2,"_int32"]],["ffi/unsafe"]],
["_int64",">foreign/Numeric_Types.html#(def._((quote._~23~25foreign).__int64))",[0,[2,"_int64"]],["ffi/unsafe"]],
["_int8",">foreign/Numeric_Types.html#(def._((quote._~23~25foreign).__int8))",[0,[2,"_int8"]],["ffi/unsafe"]],
["_intptr",">foreign/Numeric_Types.html#(def._((lib._ffi/unsafe..rkt).__intptr))",[0,[2,"_intptr"]],["ffi/unsafe"]],
["_iunknown",">foreign/com-intf.html#(def._((lib._ffi/unsafe/com..rkt).__.I.Unknown))",[0,[2,"_IUnknown"]],["ffi/unsafe/com"]],
["_iunknown-pointer",">foreign/com-intf.html#(def._((lib._ffi/unsafe/com..rkt).__.I.Unknown-pointer))",[0,[2,"_IUnknown-pointer"]],["ffi/unsafe/com"]],
["_iunknown_vt",">foreign/com-intf.html#(def._((lib._ffi/unsafe/com..rkt).__.I.Unknown_vt))",[0,[2,"_IUnknown_vt"]],["ffi/unsafe/com"]],
["_ivar",">foreign/Objective-C_FFI.html#(def._((lib._ffi/unsafe/objc..rkt).__.Ivar))",[0,[2,"_Ivar"]],["ffi/unsafe/objc"]],
["_lcid",">foreign/com-intf.html#(def._((lib._ffi/unsafe/com..rkt).__.L.C.I.D))",[0,[2,"_LCID"]],["ffi/unsafe/com"]],
["_list",">foreign/foreign_procedures.html#(form._((lib._ffi/unsafe..rkt).__list))",[0,[1,"_list"]],["ffi/unsafe"]],
["_list-struct",">foreign/C_Struct_Types.html#(def._((lib._ffi/unsafe..rkt).__list-struct))",[0,[2,"_list-struct"]],["ffi/unsafe"]],
["_llong",">foreign/Numeric_Types.html#(def._((lib._ffi/unsafe..rkt).__llong))",[0,[2,"_llong"]],["ffi/unsafe"]],
["_lockracket-prefs.rktd",">drracket/drracket-files.html#(idx._(gentag._379._(lib._scribblings/drracket/drracket..scrbl)))",[6,"\"_LOCKracket-prefs.rktd\""],false],
["_long",">foreign/Numeric_Types.html#(def._((lib._ffi/unsafe..rkt).__long))",[0,[2,"_long"]],["ffi/unsafe"]],
["_mfun",">foreign/com-intf.html#(form._((lib._ffi/unsafe/com..rkt).__mfun))",[0,[1,"_mfun"]],["ffi/unsafe/com"]],
["_objc_super",">foreign/Objective-C_FFI.html#(def._((lib._ffi/unsafe/objc..rkt).__objc_super))",[0,[2,"_objc_super"]],["ffi/unsafe/objc"]],
["_or-null",">foreign/Pointer_Types.html#(def._((lib._ffi/unsafe..rkt).__or-null))",[0,[2,"_or-null"]],["ffi/unsafe"]],
["_path",">foreign/String_Types.html#(def._((quote._~23~25foreign).__path))",[0,[2,"_path"]],["ffi/unsafe"]],
["_pointer",">foreign/Pointer_Types.html#(def._((quote._~23~25foreign).__pointer))",[0,[2,"_pointer"]],["ffi/unsafe"]],
["_protocol",">foreign/Objective-C_FFI.html#(def._((lib._ffi/unsafe/objc..rkt).__.Protocol))",[0,[2,"_Protocol"]],["ffi/unsafe/objc"]],
["_ptr",">foreign/foreign_procedures.html#(form._((lib._ffi/unsafe..rkt).__ptr))",[0,[1,"_ptr"]],["ffi/unsafe"]],
["_racket",">foreign/Pointer_Types.html#(def._((lib._ffi/unsafe..rkt).__racket))",[0,[2,"_racket"]],["ffi/unsafe"]],
["_s16vector",">foreign/homogeneous-vectors.html#(form._((lib._ffi/vector..rkt).__s16vector))",[0,[1,"_s16vector"]],["ffi/vector"]],
["_s32vector",">foreign/homogeneous-vectors.html#(form._((lib._ffi/vector..rkt).__s32vector))",[0,[1,"_s32vector"]],["ffi/vector"]],
["_s64vector",">foreign/homogeneous-vectors.html#(form._((lib._ffi/vector..rkt).__s64vector))",[0,[1,"_s64vector"]],["ffi/vector"]],
["_s8vector",">foreign/homogeneous-vectors.html#(form._((lib._ffi/vector..rkt).__s8vector))",[0,[1,"_s8vector"]],["ffi/vector"]],
["_sbyte",">foreign/Numeric_Types.html#(def._((lib._ffi/unsafe..rkt).__sbyte))",[0,[2,"_sbyte"]],["ffi/unsafe"]],
["_scheme",">foreign/Pointer_Types.html#(def._((quote._~23~25foreign).__scheme))",[0,[2,"_scheme"]],["ffi/unsafe"]],
["_scheme_apply",">inside/Evaluation.html#(idx._(gentag._303._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"_scheme_apply"]],false],
["_scheme_apply_multi",">inside/Evaluation.html#(idx._(gentag._304._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"_scheme_apply_multi"]],false],
["_scheme_eval_compiled",">inside/Evaluation.html#(idx._(gentag._297._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"_scheme_eval_compiled"]],false],
["_scheme_eval_compiled_multi",">inside/Evaluation.html#(idx._(gentag._298._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"_scheme_eval_compiled_multi"]],false],
["_sel",">foreign/Objective-C_FFI.html#(def._((lib._ffi/unsafe/objc..rkt).__.S.E.L))",[0,[2,"_SEL"]],["ffi/unsafe/objc"]],
["_short",">foreign/Numeric_Types.html#(def._((lib._ffi/unsafe..rkt).__short))",[0,[2,"_short"]],["ffi/unsafe"]],
["_sint",">foreign/Numeric_Types.html#(def._((lib._ffi/unsafe..rkt).__sint))",[0,[2,"_sint"]],["ffi/unsafe"]],
["_sint16",">foreign/Numeric_Types.html#(def._((lib._ffi/unsafe..rkt).__sint16))",[0,[2,"_sint16"]],["ffi/unsafe"]],
["_sint32",">foreign/Numeric_Types.html#(def._((lib._ffi/unsafe..rkt).__sint32))",[0,[2,"_sint32"]],["ffi/unsafe"]],
["_sint64",">foreign/Numeric_Types.html#(def._((lib._ffi/unsafe..rkt).__sint64))",[0,[2,"_sint64"]],["ffi/unsafe"]],
["_sint8",">foreign/Numeric_Types.html#(def._((lib._ffi/unsafe..rkt).__sint8))",[0,[2,"_sint8"]],["ffi/unsafe"]],
["_sintptr",">foreign/Numeric_Types.html#(def._((lib._ffi/unsafe..rkt).__sintptr))",[0,[2,"_sintptr"]],["ffi/unsafe"]],
["_sllong",">foreign/Numeric_Types.html#(def._((lib._ffi/unsafe..rkt).__sllong))",[0,[2,"_sllong"]],["ffi/unsafe"]],
["_slong",">foreign/Numeric_Types.html#(def._((lib._ffi/unsafe..rkt).__slong))",[0,[2,"_slong"]],["ffi/unsafe"]],
["_sshort",">foreign/Numeric_Types.html#(def._((lib._ffi/unsafe..rkt).__sshort))",[0,[2,"_sshort"]],["ffi/unsafe"]],
["_string",">foreign/String_Types.html#(def._((lib._ffi/unsafe..rkt).__string))",[0,[2,"_string"]],["ffi/unsafe"]],
["_string*/latin-1",">foreign/String_Types.html#(def._((lib._ffi/unsafe..rkt).__string*/latin-1))",[0,[2,"_string*/latin-1"]],["ffi/unsafe"]],
["_string*/locale",">foreign/String_Types.html#(def._((lib._ffi/unsafe..rkt).__string*/locale))",[0,[2,"_string*/locale"]],["ffi/unsafe"]],
["_string*/utf-8",">foreign/String_Types.html#(def._((lib._ffi/unsafe..rkt).__string*/utf-8))",[0,[2,"_string*/utf-8"]],["ffi/unsafe"]],
["_string/eof",">foreign/String_Types.html#(def._((lib._ffi/unsafe..rkt).__string/eof))",[0,[2,"_string/eof"]],["ffi/unsafe"]],
["_string/latin-1",">foreign/String_Types.html#(def._((lib._ffi/unsafe..rkt).__string/latin-1))",[0,[2,"_string/latin-1"]],["ffi/unsafe"]],
["_string/locale",">foreign/String_Types.html#(def._((lib._ffi/unsafe..rkt).__string/locale))",[0,[2,"_string/locale"]],["ffi/unsafe"]],
["_string/ucs-4",">foreign/String_Types.html#(def._((quote._~23~25foreign).__string/ucs-4))",[0,[2,"_string/ucs-4"]],["ffi/unsafe"]],
["_string/utf-16",">foreign/String_Types.html#(def._((quote._~23~25foreign).__string/utf-16))",[0,[2,"_string/utf-16"]],["ffi/unsafe"]],
["_string/utf-8",">foreign/String_Types.html#(def._((lib._ffi/unsafe..rkt).__string/utf-8))",[0,[2,"_string/utf-8"]],["ffi/unsafe"]],
["_sword",">foreign/Numeric_Types.html#(def._((lib._ffi/unsafe..rkt).__sword))",[0,[2,"_sword"]],["ffi/unsafe"]],
["_symbol",">foreign/String_Types.html#(def._((quote._~23~25foreign).__symbol))",[0,[2,"_symbol"]],["ffi/unsafe"]],
["_u16vector",">foreign/homogeneous-vectors.html#(form._((lib._ffi/vector..rkt).__u16vector))",[0,[1,"_u16vector"]],["ffi/vector"]],
["_u32vector",">foreign/homogeneous-vectors.html#(form._((lib._ffi/vector..rkt).__u32vector))",[0,[1,"_u32vector"]],["ffi/vector"]],
["_u64vector",">foreign/homogeneous-vectors.html#(form._((lib._ffi/vector..rkt).__u64vector))",[0,[1,"_u64vector"]],["ffi/vector"]],
["_u8vector",">foreign/homogeneous-vectors.html#(form._((lib._ffi/vector..rkt).__u8vector))",[0,[1,"_u8vector"]],["ffi/vector"]],
["_ubyte",">foreign/Numeric_Types.html#(def._((lib._ffi/unsafe..rkt).__ubyte))",[0,[2,"_ubyte"]],["ffi/unsafe"]],
["_ufixint",">foreign/Numeric_Types.html#(def._((quote._~23~25foreign).__ufixint))",[0,[2,"_ufixint"]],["ffi/unsafe"]],
["_ufixnum",">foreign/Numeric_Types.html#(def._((quote._~23~25foreign).__ufixnum))",[0,[2,"_ufixnum"]],["ffi/unsafe"]],
["_uint",">foreign/Numeric_Types.html#(def._((lib._ffi/unsafe..rkt).__uint))",[0,[2,"_uint"]],["ffi/unsafe"]],
["_uint16",">foreign/Numeric_Types.html#(def._((quote._~23~25foreign).__uint16))",[0,[2,"_uint16"]],["ffi/unsafe"]],
["_uint32",">foreign/Numeric_Types.html#(def._((quote._~23~25foreign).__uint32))",[0,[2,"_uint32"]],["ffi/unsafe"]],
["_uint64",">foreign/Numeric_Types.html#(def._((quote._~23~25foreign).__uint64))",[0,[2,"_uint64"]],["ffi/unsafe"]],
["_uint8",">foreign/Numeric_Types.html#(def._((quote._~23~25foreign).__uint8))",[0,[2,"_uint8"]],["ffi/unsafe"]],
["_uintptr",">foreign/Numeric_Types.html#(def._((lib._ffi/unsafe..rkt).__uintptr))",[0,[2,"_uintptr"]],["ffi/unsafe"]],
["_ullong",">foreign/Numeric_Types.html#(def._((lib._ffi/unsafe..rkt).__ullong))",[0,[2,"_ullong"]],["ffi/unsafe"]],
["_ulong",">foreign/Numeric_Types.html#(def._((lib._ffi/unsafe..rkt).__ulong))",[0,[2,"_ulong"]],["ffi/unsafe"]],
["_union",">foreign/C_Union_Types.html#(def._((lib._ffi/unsafe..rkt).__union))",[0,[2,"_union"]],["ffi/unsafe"]],
["_ushort",">foreign/Numeric_Types.html#(def._((lib._ffi/unsafe..rkt).__ushort))",[0,[2,"_ushort"]],["ffi/unsafe"]],
["_uword",">foreign/Numeric_Types.html#(def._((lib._ffi/unsafe..rkt).__uword))",[0,[2,"_uword"]],["ffi/unsafe"]],
["_vector",">foreign/foreign_procedures.html#(form._((lib._ffi/unsafe..rkt).__vector))",[0,[1,"_vector"]],["ffi/unsafe"]],
["_void",">foreign/Other_Atomic_Types.html#(def._((quote._~23~25foreign).__void))",[0,[2,"_void"]],["ffi/unsafe"]],
["_wfun",">foreign/com-intf.html#(form._((lib._ffi/unsafe/com..rkt).__wfun))",[0,[1,"_wfun"]],["ffi/unsafe/com"]],
["_word",">foreign/Numeric_Types.html#(def._((lib._ffi/unsafe..rkt).__word))",[0,[2,"_word"]],["ffi/unsafe"]],
["`",">reference/reader.html#(idx._(gentag._56._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"`"],[4,""]]],false],
["a",">html/index.html#(def._((lib._html/main..rkt)._a))",[0,[2,"a"]],["html"]],
["a customer-manager component",">guide/contracts-examples.html#(part._.A_.Customer-.Manager_.Component)","A Customer-Manager Component",false],
["a dictionary",">guide/contracts-examples.html#(part._.A_.Dictionary)","A Dictionary",false],
["a first example",">scribble/getting-started.html#(part._first-example)","A First Example",false],
["a first example",">teachpack/world.html#(part._example)","A First Example",false],
["a first sample universe",">teachpack/2htdpuniverse.html#(part._universe-sample)","A First Sample Universe",false],
["a first sample world",">teachpack/2htdpuniverse.html#(part._world-example)","A First Sample World",false],
["a more complicated example",">graphics/A_More_Complicated_Example.html","A More Complicated Example",false],
["a note to readers with lisp/scheme experience",">guide/intro.html#(part._use-module)","A Note to Readers with Lisp/Scheme Experience",false],
["a parameteric (simple) stack",">guide/contracts-examples.html#(part._.A_.Parameteric__.Simple__.Stack)","A Parameteric (Simple) Stack",false],
["a persistent model",">continue/index.html#(part._.A_.Persistent_.Model)","A Persistent Model",false],
["a queue",">guide/contracts-examples.html#(part._.A_.Queue)","A Queue",false],
["a word about design",">json/index.html#(part._.A_.Word_.About_.Design)","A Word About Design",false],
["a-c-down keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._181._(lib._scribblings/drracket/drracket..scrbl)))","A-C-down keybinding",false],
["a-c-left keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._175._(lib._scribblings/drracket/drracket..scrbl)))","A-C-left keybinding",false],
["a-c-right keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._177._(lib._scribblings/drracket/drracket..scrbl)))","A-C-right keybinding",false],
["a-c-up keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._179._(lib._scribblings/drracket/drracket..scrbl)))","A-C-up keybinding",false],
["a?",">html/index.html#(def._((lib._html/main..rkt)._a~3f))",[0,[2,"a?"]],["html"]],
["abbr",">html/index.html#(def._((lib._html/main..rkt)._abbr))",[0,[2,"abbr"]],["html"]],
["abbr?",">html/index.html#(def._((lib._html/main..rkt)._abbr~3f))",[0,[2,"abbr?"]],["html"]],
["abbreviate-cons-as-list",">mzlib/mzlib_pconvert.html#(def._((lib._mzlib/pconvert..rkt)._abbreviate-cons-as-list))",[0,[2,"abbreviate-cons-as-list"]],["mzlib/pconvert"]],
["abbreviating quote with '",">guide/Pairs__Lists__and_Racket_Syntax.html#(part._.Abbreviating_quote_with__)",["Abbreviating ",[0,[1,"quote"]]," with ",[7,"&rsquo;"]],false],
["abort",">reference/cont.html#(def._((lib._racket/control..rkt)._abort))",[0,[2,"abort"]],["racket/control"]],
["abort-current-continuation",">reference/cont.html#(def._((quote._~23~25kernel)._abort-current-continuation))",[0,[2,"abort-current-continuation"]],["racket/base","racket"]],
["abort/cc",">reference/cont.html#(def._((lib._racket/control..rkt)._abort/cc))",[0,[2,"abort/cc"]],["racket/control"]],
["aborts",">reference/bytestrings.html#(idx._(gentag._117._(lib._scribblings/reference/reference..scrbl)))",[7,"'aborts"],false],
["aborts",">guide/prompt.html#(tech._abort)","<span style=\"font-style: italic\">aborts</span>",false],
["about com method",">mzcom/index.html#(idx._(gentag._0._(lib._mzcom/mzcom..scrbl)))",[[6,"About"]," COM method"],false],
["about drracket... menu item",">drracket/Menus.html#(idx._(gentag._148._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">About DrRacket...</span> menu item",false],
["about these icons",">images/Icons.html#(part._.About_.These_.Icons)","About These Icons",false],
["about this teachpack",">picturing-programs/index.html#(part._.About_.This_.Teachpack)","About This Teachpack",false],
["above",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._above))",[0,[2,"above"]],["2htdp/image"]],
["above",">deinprogramm/image.html#(def._((lib._deinprogramm/image..rkt)._above))",[0,[2,"above"]],["teachpack/deinprogramm/image"]],
["above/align",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._above/align))",[0,[2,"above/align"]],["2htdp/image"]],
["abridged-test-output",">plai/plai-scheme.html#(def._((lib._plai/main..rkt)._abridged-test-output))",[0,[2,"abridged-test-output"]],["plai"]],
["abs",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._abs))",[0,[2,"abs"]],["racket/base","racket"]],
["abs",">r5rs-std/r5rs-Z-H-9.html#%_idx_298",[0,[2,"abs"]],["r5rs"]],
["abs",">r6rs-std/r6rs-Z-H-14.html#node_idx_506",[0,[2,"abs"]],["rnrs/base-6"]],
["abs",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._abs))",[0,[2,"abs"]],["lang/htdp-advanced"]],
["abs",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._abs))",[0,[2,"abs"]],["lang/htdp-beginner"]],
["abs",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._abs))",[0,[2,"abs"]],["lang/htdp-beginner-abbr"]],
["abs",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._abs))",[0,[2,"abs"]],["lang/htdp-intermediate"]],
["abs",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._abs))",[0,[2,"abs"]],["lang/htdp-intermediate-lambda"]],
["abs",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._abs))",[0,[2,"abs"]],["deinprogramm/DMdA-advanced"]],
["abs",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._abs))",[0,[2,"abs"]],["deinprogramm/DMdA-assignments"]],
["abs",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._abs))",[0,[2,"abs"]],["deinprogramm/DMdA-beginner"]],
["abs",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._abs))",[0,[2,"abs"]],["deinprogramm/DMdA-vanilla"]],
["absent",">reference/Object_and_Class_Contracts.html#(form._((lib._racket/private/class-internal..rkt)._absent))",[0,[1,"absent"]],["racket/class","racket"]],
["absolute-installation?",">config/index.html#(def._((lib._config/main..rkt)._absolute-installation~3f))",[0,[2,"absolute-installation?"]],["config"]],
["absolute-installation?",">raco/dirs.html#(def._((lib._setup/dirs..rkt)._absolute-installation~3f))",[0,[2,"absolute-installation?"]],["setup/dirs"]],
["absolute-path?",">reference/Manipulating_Paths.html#(def._((quote._~23~25kernel)._absolute-path~3f))",[0,[2,"absolute-path?"]],["racket/base","racket"]],
["abspielen von audio-dateien: \"sound.ss\"",">deinprogramm/sound.html",["Abspielen von Audio-Dateien: ",[6,"\"sound.ss\""],"<a name=\"(idx._(gentag._5._(lib._deinprogramm/scribblings/deinprogramm..scrbl)))\"></a>"],false],
["abstract",">reference/createclass.html#(form._((lib._racket/private/class-internal..rkt)._abstract))",[0,[1,"abstract"]],["racket/class","racket"]],
["abstract",">scribble/JFP_Paper_Format.html#(def._((lib._scribble/jfp..rkt)._abstract))",[0,[2,"abstract"]],["scribble/jfp"]],
["abstract",">scribble/LNCS_Paper_Format.html#(def._((lib._scribble/lncs/lang..rkt)._abstract))",[0,[2,"abstract"]],["scribble/lncs"]],
["abstract",">scribble/SIGPLAN_Paper_Format.html#(def._((lib._scribble/sigplan..rkt)._abstract))",[0,[2,"abstract"]],["scribble/sigplan"]],
["abstract contracts using #:exists and #:\u2203",">guide/contracts-exists.html",["Abstract Contracts using ",[8,"#:exists"]," and ",[8,"#:&#8707;"]],false],
["abstracting the model",">continue/index.html#(part._.Abstracting_the_.Model)","Abstracting the Model",false],
["accept-drop-files",">gui/window___.html#(meth._(((lib._mred/main..rkt)._window~3c~25~3e)._accept-drop-files))",[[0,[2,"accept-drop-files"]],[14,[" (method of ",[0,[2,"window<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["accept-tab-focus",">gui/canvas___.html#(meth._(((lib._mred/main..rkt)._canvas~3c~25~3e)._accept-tab-focus))",[[0,[2,"accept-tab-focus"]],[14,[" (method of ",[0,[2,"canvas<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["acceptable local package",">planet/search-order.html#(part._.Acceptable_.Local_.Package)","Acceptable Local Package",false],
["acceptable remote package",">planet/search-order.html#(part._.Acceptable_.Remote_.Package)","Acceptable Remote Package",false],
["accessing check syntax programmatically",">tools/Check_Syntax.html#(part._.Accessing_.Check_.Syntax_.Programmatically)","Accessing Check Syntax Programmatically",false],
["accessor",">guide/define-struct.html#(tech._accessor)","<span style=\"font-style: italic\">accessor</span>",false],
["accessor",">reference/define-struct.html#(tech._accessor)","<span style=\"font-style: italic\">accessor</span>",false],
["accum-b",">frtime/index.html#(def._((lib._frtime/main..rkt)._accum-b))",[0,[2,"accum-b"]],["frtime"]],
["accum-e",">frtime/index.html#(def._((lib._frtime/main..rkt)._accum-e))",[0,[2,"accum-e"]],["frtime"]],
["aces --- solitaire card game",">games/aces.html",[[15,"<img src=\"aces.png\" alt=\"\" />"]," ","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Aces</span>"," ","&#8212;","<wbr></wbr>"," Solitaire Card Game"],false],
["acknowledgements",">acks/index.html","Acknowledgements",false],
["acknowledgments",">datalog/Acknowledgments.html","Acknowledgments",false],
["acknowledgments",">mrlib/Acknowledgments.html","Acknowledgments",false],
["acknowledgments",">mzcom/index.html#(part._.Acknowledgments)","Acknowledgments",false],
["acknowlegements",">rackunit/Acknowlegements.html","Acknowlegements",false],
["acos",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._acos))",[0,[2,"acos"]],["racket/base","racket"]],
["acos",">r5rs-std/r5rs-Z-H-9.html#%_idx_338",[0,[2,"acos"]],["r5rs"]],
["acos",">r6rs-std/r6rs-Z-H-14.html#node_idx_554",[0,[2,"acos"]],["rnrs/base-6"]],
["acos",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._acos))",[0,[2,"acos"]],["lang/htdp-advanced"]],
["acos",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._acos))",[0,[2,"acos"]],["lang/htdp-beginner"]],
["acos",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._acos))",[0,[2,"acos"]],["lang/htdp-beginner-abbr"]],
["acos",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._acos))",[0,[2,"acos"]],["lang/htdp-intermediate"]],
["acos",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._acos))",[0,[2,"acos"]],["lang/htdp-intermediate-lambda"]],
["acos",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._acos))",[0,[2,"acos"]],["deinprogramm/DMdA-advanced"]],
["acos",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._acos))",[0,[2,"acos"]],["deinprogramm/DMdA-assignments"]],
["acos",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._acos))",[0,[2,"acos"]],["deinprogramm/DMdA-beginner"]],
["acos",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._acos))",[0,[2,"acos"]],["deinprogramm/DMdA-vanilla"]],
["acronym",">html/index.html#(def._((lib._html/main..rkt)._acronym))",[0,[2,"acronym"]],["html"]],
["acronym?",">html/index.html#(def._((lib._html/main..rkt)._acronym~3f))",[0,[2,"acronym?"]],["html"]],
["action pattern",">syntax/stxparse-patterns.html#(tech._action._pattern)","<span style=\"font-style: italic\">action pattern</span>",false],
["action patterns",">syntax/stxparse-patterns.html#(part._.Action_.Patterns)","Action Patterns",false],
["actions and completeness",">framework/Test.html#(part._test~3aactions-completeness)","Actions and completeness",false],
["active frame",">framework/Test.html#(part._.Active_.Frame)","Active Frame",false],
["active-child",">framework/Panel.html#(meth._(((lib._framework/main..rkt)._panel~3asingle~3c~25~3e)._active-child))",[[0,[2,"active-child"]],[14,[" (method of ",[0,[2,"panel:single<%>"]],")"]]],["framework"]],
["activex",">mysterx/index.html#(idx._(gentag._0._(lib._mysterx/scribblings/mysterx..scrbl)))","ActiveX",false],
["add",">gui/editor-data-class-list___.html#(meth._(((lib._mred/main..rkt)._editor-data-class-list~3c~25~3e)._add))",[[0,[2,"add"]],[14,[" (method of ",[0,[2,"editor-data-class-list<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["add",">gui/snip-class-list___.html#(meth._(((lib._racket/snip..rkt)._snip-class-list~3c~25~3e)._add))",[[0,[2,"add"]],[14,[" (method of ",[0,[2,"snip-class-list<%>"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["add",">htdp-langs/beginner-abbr.html#(idx._htdp-beginner-abbr._(gentag._19._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-beginner-abbr))","add",false],
["add",">htdp-langs/beginner.html#(idx._htdp-beginner._(gentag._4._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-beginner))","add",false],
["add",">gui/key-event_.html#(idx._(gentag._75._(lib._scribblings/gui/gui..scrbl)))",[7,"'add"],false],
["add teachpack... menu item",">drracket/Menus.html#(idx._(gentag._120._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Add Teachpack...</span> menu item",false],
["add user-defined keybindings... menu item",">drracket/Menus.html#(idx._(gentag._89._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Add User-defined Keybindings...</span> menu item",false],
["add-area",">browser/index.html#(meth._(((lib._browser/browser..rkt)._image-map-snip~25)._add-area))",[[0,[2,"add-area"]],[14,[" (method of ",[0,[2,"image-map-snip%"]],")"]]],["browser/browser","browser"]],
["add-between",">reference/pairs.html#(def._((lib._racket/list..rkt)._add-between))",[0,[2,"add-between"]],["racket/list","racket"]],
["add-bkg-running-color",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3atab~3c~25~3e)._add-bkg-running-color))",[[0,[2,"add-bkg-running-color"]],[14,[" (method of ",[0,[2,"drracket:unit:tab<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["add-canvas",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._add-canvas))",[[0,[2,"add-canvas"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["add-card",">cards/index.html#(meth._(((lib._games/cards..rkt)._table~3c~25~3e)._add-card))",[[0,[2,"add-card"]],[14,[" (method of ",[0,[2,"table<%>"]],")"]]],["games/cards"]],
["add-cards",">cards/index.html#(meth._(((lib._games/cards..rkt)._table~3c~25~3e)._add-cards))",[[0,[2,"add-cards"]],[14,[" (method of ",[0,[2,"table<%>"]],")"]]],["games/cards"]],
["add-cards-to-region",">cards/index.html#(meth._(((lib._games/cards..rkt)._table~3c~25~3e)._add-cards-to-region))",[[0,[2,"add-cards-to-region"]],[14,[" (method of ",[0,[2,"table<%>"]],")"]]],["games/cards"]],
["add-child",">gui/area-container___.html#(meth._(((lib._mred/main..rkt)._area-container~3c~25~3e)._add-child))",[[0,[2,"add-child"]],[14,[" (method of ",[0,[2,"area-container<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["add-child",">embedded-gui/alignment-parent___.html#(meth._(((lib._embedded-gui/main..rkt)._alignment-parent~3c~25~3e)._add-child))",[[0,[2,"add-child"]],[14,[" (method of ",[0,[2,"alignment-parent<%>"]],")"]]],["embedded-gui"]],
["add-child",">mrlib/graph-snip___.html#(meth._(((lib._mrlib/graph..rkt)._graph-snip~3c~25~3e)._add-child))",[[0,[2,"add-child"]],[14,[" (method of ",[0,[2,"graph-snip<%>"]],")"]]],["mrlib/graph"]],
["add-color<%>",">gui/add-color___.html",[0,[2,"add-color<%>"]],["racket/snip","racket/gui/base","racket/gui"]],
["add-curve",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._add-curve))",[0,[2,"add-curve"]],["2htdp/image"]],
["add-duration",">srfi-std/srfi-19.html#add-duration",[0,[2,"add-duration"]],["srfi/19"]],
["add-duration!",">srfi-std/srfi-19.html#add-duration!",[0,[2,"add-duration!"]],["srfi/19"]],
["add-editor-keymap-functions",">gui/Editor_Functions.html#(def._((lib._mred/main..rkt)._add-editor-keymap-functions))",[0,[2,"add-editor-keymap-functions"]],["racket/gui/base","racket/gui"]],
["add-function",">gui/keymap_.html#(meth._(((lib._mred/main..rkt)._keymap~25)._add-function))",[[0,[2,"add-function"]],[14,[" (method of ",[0,[2,"keymap%"]],")"]]],["racket/gui/base","racket/gui"]],
["add-hard-link",">planet/Utility_Libraries.html#(def._((lib._planet/util..rkt)._add-hard-link))",[0,[2,"add-hard-link"]],["planet/util"]],
["add-heads-up",">gl-board-game/index.html#(meth._(((lib._games/gl-board-game..rkt)._gl-board~25)._add-heads-up))",[[0,[2,"add-heads-up"]],[14,[" (method of ",[0,[2,"gl-board%"]],")"]]],["games/gl-board-game"]],
["add-help-button",">cards/index.html#(meth._(((lib._games/cards..rkt)._table~3c~25~3e)._add-help-button))",[[0,[2,"add-help-button"]],[14,[" (method of ",[0,[2,"table<%>"]],")"]]],["games/cards"]],
["add-history",">readline/index.html#(def._((lib._readline/readline..rkt)._add-history))",[0,[2,"add-history"]],["readline/readline"]],
["add-history-bytes",">readline/index.html#(def._((lib._readline/readline..rkt)._add-history-bytes))",[0,[2,"add-history-bytes"]],["readline/readline"]],
["add-line",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._add-line))",[0,[2,"add-line"]],["2htdp/image"]],
["add-line",">teachpack/image.html#(def._((lib._htdp/image..rkt)._add-line))",[0,[2,"add-line"]],["htdp/image"]],
["add-line-number-menu-items",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3atext-info~3c~25~3e)._add-line-number-menu-items))",[[0,[2,"add-line-number-menu-items"]],[14,[" (method of ",[0,[2,"frame:text-info<%>"]],")"]]],["framework"]],
["add-link",">browser/index.html#(meth._(((lib._browser/browser..rkt)._hyper-text-mixin)._add-link))",[[0,[2,"add-link"]],[14,[" (method of ",[0,[2,"hyper-text-mixin"]],")"]]],["browser/browser","browser"]],
["add-link",">browser/index.html#(meth._(((lib._browser/htmltext..rkt)._html-text~3c~25~3e)._add-link))",[[0,[2,"add-link"]],[14,[" (method of ",[0,[2,"html-text<%>"]],")"]]],["browser/htmltext"]],
["add-links",">mrlib/Graph_Functions.html#(def._((lib._mrlib/graph..rkt)._add-links))",[0,[2,"add-links"]],["mrlib/graph"]],
["add-links/text-colors",">mrlib/Graph_Functions.html#(def._((lib._mrlib/graph..rkt)._add-links/text-colors))",[0,[2,"add-links/text-colors"]],["mrlib/graph"]],
["add-make-prefix-to-constructor",">mzlib/mzlib_pconvert.html#(def._((lib._mzlib/pconvert..rkt)._add-make-prefix-to-constructor))",[0,[2,"add-make-prefix-to-constructor"]],["mzlib/pconvert"]],
["add-parent",">mrlib/graph-snip___.html#(meth._(((lib._mrlib/graph..rkt)._graph-snip~3c~25~3e)._add-parent))",[[0,[2,"add-parent"]],[14,[" (method of ",[0,[2,"graph-snip<%>"]],")"]]],["mrlib/graph"]],
["add-pasteboard-keymap-functions",">gui/Editor_Functions.html#(def._((lib._mred/main..rkt)._add-pasteboard-keymap-functions))",[0,[2,"add-pasteboard-keymap-functions"]],["racket/gui/base","racket/gui"]],
["add-piece",">gl-board-game/index.html#(meth._(((lib._games/gl-board-game..rkt)._gl-board~25)._add-piece))",[[0,[2,"add-piece"]],[14,[" (method of ",[0,[2,"gl-board%"]],")"]]],["games/gl-board-game"]],
["add-racket-callback",">browser/index.html#(meth._(((lib._browser/browser..rkt)._hyper-text-mixin)._add-racket-callback))",[[0,[2,"add-racket-callback"]],[14,[" (method of ",[0,[2,"hyper-text-mixin"]],")"]]],["browser/browser","browser"]],
["add-racket-callback",">browser/index.html#(meth._(((lib._browser/htmltext..rkt)._html-text~3c~25~3e)._add-racket-callback))",[[0,[2,"add-racket-callback"]],[14,[" (method of ",[0,[2,"html-text<%>"]],")"]]],["browser/htmltext"]],
["add-region",">cards/index.html#(meth._(((lib._games/cards..rkt)._table~3c~25~3e)._add-region))",[[0,[2,"add-region"]],[14,[" (method of ",[0,[2,"table<%>"]],")"]]],["games/cards"]],
["add-scribble-button",">cards/index.html#(meth._(((lib._games/cards..rkt)._table~3c~25~3e)._add-scribble-button))",[[0,[2,"add-scribble-button"]],[14,[" (method of ",[0,[2,"table<%>"]],")"]]],["games/cards"]],
["add-selected",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._add-selected))",[[0,[2,"add-selected"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["add-show-menu-items",">tools/drracket_frame.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aframe~3a~3c~25~3e)._add-show-menu-items))",[[0,[2,"add-show-menu-items"]],[14,[" (method of ",[0,[2,"drracket:frame:<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["add-show-menu-items",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aframe~25)._add-show-menu-items))",[[0,[2,"add-show-menu-items"]],[14,[" (method of ",[0,[2,"drracket:unit:frame%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["add-space",">gl-board-game/index.html#(meth._(((lib._games/gl-board-game..rkt)._gl-board~25)._add-space))",[[0,[2,"add-space"]],[14,[" (method of ",[0,[2,"gl-board%"]],")"]]],["games/gl-board-game"]],
["add-splash-icon",">framework/Splash.html#(def._((lib._framework/splash..rkt)._add-splash-icon))",[0,[2,"add-splash-icon"]],["framework/splash"]],
["add-tag",">browser/index.html#(meth._(((lib._browser/browser..rkt)._hyper-text-mixin)._add-tag))",[[0,[2,"add-tag"]],[14,[" (method of ",[0,[2,"hyper-text-mixin"]],")"]]],["browser/browser","browser"]],
["add-tag",">browser/index.html#(meth._(((lib._browser/htmltext..rkt)._html-text~3c~25~3e)._add-tag))",[[0,[2,"add-tag"]],[14,[" (method of ",[0,[2,"html-text<%>"]],")"]]],["browser/htmltext"]],
["add-tall-snip",">framework/Canvas.html#(meth._(((lib._framework/main..rkt)._canvas~3awide-snip~3c~25~3e)._add-tall-snip))",[[0,[2,"add-tall-snip"]],[14,[" (method of ",[0,[2,"canvas:wide-snip<%>"]],")"]]],["framework"]],
["add-tall-snip",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3awide-snip~3c~25~3e)._add-tall-snip))",[[0,[2,"add-tall-snip"]],[14,[" (method of ",[0,[2,"text:wide-snip<%>"]],")"]]],["framework"]],
["add-text-keymap-functions",">gui/Editor_Functions.html#(def._((lib._mred/main..rkt)._add-text-keymap-functions))",[0,[2,"add-text-keymap-functions"]],["racket/gui/base","racket/gui"]],
["add-thunk-callback",">browser/index.html#(meth._(((lib._browser/browser..rkt)._hyper-text-mixin)._add-thunk-callback))",[[0,[2,"add-thunk-callback"]],[14,[" (method of ",[0,[2,"hyper-text-mixin"]],")"]]],["browser/browser","browser"]],
["add-thunk-callback",">browser/index.html#(meth._(((lib._browser/htmltext..rkt)._html-text~3c~25~3e)._add-thunk-callback))",[[0,[2,"add-thunk-callback"]],[14,[" (method of ",[0,[2,"html-text<%>"]],")"]]],["browser/htmltext"]],
["add-to-browser-prefs-panel",">browser/index.html#(def._((lib._browser/external..rkt)._add-to-browser-prefs-panel))",[0,[2,"add-to-browser-prefs-panel"]],["browser/external"]],
["add-to-input",">preprocessor/mztext.html#(def._((lib._preprocessor/mztext..rkt)._add-to-input))",[0,[2,"add-to-input"]],["preprocessor/mztext"]],
["add-type",">gui/clipboard-client_.html#(meth._(((lib._mred/main..rkt)._clipboard-client~25)._add-type))",[[0,[2,"add-type"]],[14,[" (method of ",[0,[2,"clipboard-client%"]],")"]]],["racket/gui/base","racket/gui"]],
["add-undo",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._add-undo))",[[0,[2,"add-undo"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["add-vec3",">deinprogramm/line3d.html#(def._((lib._teachpack/deinprogramm/line3d..rkt)._add-vec3))",[0,[2,"add-vec3"]],["teachpack/deinprogramm/line3d"]],
["add-vec4",">deinprogramm/line3d.html#(def._((lib._teachpack/deinprogramm/line3d..rkt)._add-vec4))",[0,[2,"add-vec4"]],["teachpack/deinprogramm/line3d"]],
["add-wide-snip",">framework/Canvas.html#(meth._(((lib._framework/main..rkt)._canvas~3awide-snip~3c~25~3e)._add-wide-snip))",[[0,[2,"add-wide-snip"]],[14,[" (method of ",[0,[2,"canvas:wide-snip<%>"]],")"]]],["framework"]],
["add-wide-snip",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3awide-snip~3c~25~3e)._add-wide-snip))",[[0,[2,"add-wide-snip"]],[14,[" (method of ",[0,[2,"text:wide-snip<%>"]],")"]]],["framework"]],
["add1",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._add1))",[0,[2,"add1"]],["racket/base","racket"]],
["add1",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._add1))",[0,[2,"add1"]],["lang/htdp-advanced"]],
["add1",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._add1))",[0,[2,"add1"]],["lang/htdp-beginner"]],
["add1",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._add1))",[0,[2,"add1"]],["lang/htdp-beginner-abbr"]],
["add1",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._add1))",[0,[2,"add1"]],["lang/htdp-intermediate"]],
["add1",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._add1))",[0,[2,"add1"]],["lang/htdp-intermediate-lambda"]],
["add1",">plai/mutator.html#(form._((lib._plai/mutator..rkt)._add1))",[0,[2,"add1"]],["plai/mutator"]],
["adding @-expressions to a language",">scribble/reader-internals.html#(part._at-exp-lang)","Adding @-expressions to a Language",false],
["adding a back button",">continue/index.html#(part._.Adding_a_.Back_.Button)","Adding a Back Button",false],
["adding a raco command",">raco/command.html",["Adding a ",[6,"raco"]," Command"],false],
["adding arbitrary languages to drracket",">tools/adding-languages.html#(part._.Adding_.Arbitrary_.Languages_to_.Dr.Racket)","Adding Arbitrary Languages to DrRacket",false],
["adding collections",">guide/module-basics.html#(part._link-collection)","Adding Collections",false],
["adding contracts to signatures",">guide/Contracts_for_Units.html#(part._.Adding_.Contracts_to_.Signatures)","Adding Contracts to Signatures",false],
["adding contracts to units",">guide/Contracts_for_Units.html#(part._.Adding_.Contracts_to_.Units)","Adding Contracts to Units",false],
["adding languages to drracket",">tools/adding-languages.html","Adding Languages to DrRacket",false],
["adding languages to drracket",">tools/adding-languages.html#(idx._(gentag._8._(lib._scribblings/tools/tools..scrbl)))","adding languages to DrRacket",false],
["adding module-based languages to drracket",">tools/adding-languages.html#(part._.Adding_.Module-based_.Languages_to_.Dr.Racket)","Adding Module-based Languages to DrRacket",false],
["adding string constants",">string-constants/index.html#(part._.Adding_.String_.Constants)","Adding String Constants",false],
["additional byte string functions",">reference/bytestrings.html#(part._.Additional_.Byte_.String_.Functions)","Additional Byte String Functions",false],
["additional control operators",">reference/cont.html#(part._.Additional_.Control_.Operators)","Additional Control Operators",false],
["additional custom-output support",">reference/pretty-print.html#(part._.Additional_.Custom-.Output_.Support)","Additional Custom-Output Support",false],
["additional examples",">guide/contracts-examples.html","Additional Examples",false],
["additional higher-order functions",">reference/procedures.html#(part._.Additional_.Higher-.Order_.Functions)","Additional Higher-Order Functions",false],
["additional list functions and synonyms",">reference/pairs.html#(part._.Additional_.List_.Functions_and_.Synonyms)","Additional List Functions and Synonyms",false],
["additional matching forms",">reference/match.html#(part._.Additional_.Matching_.Forms)","Additional Matching Forms",false],
["additional promise kinds",">reference/Delayed_Evaluation.html#(part._.Additional_.Promise_.Kinds)","Additional Promise Kinds",false],
["additional provide forms",">reference/require.html#(part._.Additional_provide_.Forms)",["Additional ",[0,[1,"provide"]]," Forms"],false],
["additional require forms",">reference/require.html#(part._.Additional_require_.Forms)",["Additional ",[0,[1,"require"]]," Forms"],false],
["additional string functions",">reference/strings.html#(part._.Additional_.String_.Functions)","Additional String Functions",false],
["additional syntactic constraints",">reference/regexp.html#(part._.Additional_.Syntactic_.Constraints)","Additional Syntactic Constraints",false],
["additional vector functions",">reference/vectors.html#(part._.Additional_.Vector_.Functions)","Additional Vector Functions",false],
["addon-dir",">reference/Filesystem.html#(idx._(gentag._280._(lib._scribblings/reference/reference..scrbl)))",[7,"'addon-dir"],false],
["addref",">foreign/com-intf.html#(def._((lib._ffi/unsafe/com..rkt)._.Add.Ref))",[0,[2,"AddRef"]],["ffi/unsafe/com"]],
["address",">html/index.html#(def._((lib._html/main..rkt)._address))",[0,[2,"address"]],["html"]],
["address?",">html/index.html#(def._((lib._html/main..rkt)._address~3f))",[0,[2,"address?"]],["html"]],
["adjust-connection-timeout!",">web-server-internal/connection-manager.html#(def._((lib._web-server/private/connection-manager..rkt)._adjust-connection-timeout!))",[0,[2,"adjust-connection-timeout!"]],["web-server/private/connection-manager"]],
["adjust-cursor",">gui/editor-snip_.html#(meth._(((lib._mred/main..rkt)._editor-snip~25)._adjust-cursor))",[[0,[2,"adjust-cursor"]],[14,[" (method of ",[0,[2,"editor-snip%"]],")"]]],["racket/gui/base","racket/gui"]],
["adjust-cursor",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._adjust-cursor))",[[0,[2,"adjust-cursor"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["adjust-cursor",">gui/snip_.html#(meth._(((lib._racket/snip..rkt)._snip~25)._adjust-cursor))",[[0,[2,"adjust-cursor"]],[14,[" (method of ",[0,[2,"snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["adjust-timeout!",">web-server/servlet.html#(def._((lib._web-server/servlet/web..rkt)._adjust-timeout!))",[0,[2,"adjust-timeout!"]],["web-server/servlet/web"]],
["adjustable-skip-list?",">data/skip-list.html#(def._((lib._data/skip-list..rkt)._adjustable-skip-list~3f))",[0,[2,"adjustable-skip-list?"]],["data/skip-list"]],
["adjustable-splay-tree?",">data/Splay_Trees.html#(def._((lib._data/splay-tree..rkt)._adjustable-splay-tree~3f))",[0,[2,"adjustable-splay-tree?"]],["data/splay-tree"]],
["administrators",">gui/editor-overview.html#(part._editoradministrators)","Administrators",false],
["advanced control flow",">continue/index.html#(part._.Advanced_.Control_.Flow)","Advanced Control Flow",false],
["advanced student",">htdp-langs/advanced.html","Advanced Student",false],
["advanced student language",">drracket/htdp-langs.html#(idx._(gentag._47._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Advanced Student</span> language",false],
["affiliation",">scribble/JFP_Paper_Format.html#(def._((lib._scribble/jfp..rkt)._affiliation))",[0,[2,"affiliation"]],["scribble/jfp"]],
["affiliation-mark",">scribble/JFP_Paper_Format.html#(def._((lib._scribble/jfp..rkt)._affiliation-mark))",[0,[2,"affiliation-mark"]],["scribble/jfp"]],
["affiliation-sep",">scribble/JFP_Paper_Format.html#(def._((lib._scribble/jfp..rkt)._affiliation-sep))",[0,[2,"affiliation-sep"]],["scribble/jfp"]],
["after",">rackunit/api.html#(form._((lib._rackunit/main..rkt)._after))",[0,[1,"after"]],["rackunit"]],
["after refreshing my stateful servlet, old captured continuations don't change or old global effects are gone. why?",">web-server/faq.html#(part._refresh-servlets)","After refreshing my stateful servlet, old captured continuations don&rsquo;t change or old global effects are gone. Why?",false],
["after-change-style",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._after-change-style))",[[0,[2,"after-change-style"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["after-change-style",">framework/Color.html#(meth._(((lib._framework/main..rkt)._color~3atext-mixin)._after-change-style))",[[0,[2,"after-change-style"]],[14,[" (method of ",[0,[2,"color:text-mixin"]],")"]]],["framework"]],
["after-change-style",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3ahost-text-mixin)._after-change-style))",[[0,[2,"after-change-style"]],[14,[" (method of ",[0,[2,"mode:host-text-mixin"]],")"]]],["framework"]],
["after-change-style",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3asurrogate-text~25)._after-change-style))",[[0,[2,"after-change-style"]],[14,[" (method of ",[0,[2,"mode:surrogate-text%"]],")"]]],["framework"]],
["after-change-style",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3adelegate-mixin)._after-change-style))",[[0,[2,"after-change-style"]],[14,[" (method of ",[0,[2,"text:delegate-mixin"]],")"]]],["framework"]],
["after-delete",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._after-delete))",[[0,[2,"after-delete"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["after-delete",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._after-delete))",[[0,[2,"after-delete"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["after-delete",">tools/drracket_rep.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3arep~3atext~25)._after-delete))",[[0,[2,"after-delete"]],[14,[" (method of ",[0,[2,"drracket:rep:text%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["after-delete",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aprogram-editor-mixin)._after-delete))",[[0,[2,"after-delete"]],[14,[" (method of ",[0,[2,"drracket:unit:program-editor-mixin"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["after-delete",">framework/Color.html#(meth._(((lib._framework/main..rkt)._color~3atext-mixin)._after-delete))",[[0,[2,"after-delete"]],[14,[" (method of ",[0,[2,"color:text-mixin"]],")"]]],["framework"]],
["after-delete",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3ahost-text-mixin)._after-delete))",[[0,[2,"after-delete"]],[14,[" (method of ",[0,[2,"mode:host-text-mixin"]],")"]]],["framework"]],
["after-delete",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3asurrogate-text~25)._after-delete))",[[0,[2,"after-delete"]],[14,[" (method of ",[0,[2,"mode:surrogate-text%"]],")"]]],["framework"]],
["after-delete",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3adelegate-mixin)._after-delete))",[[0,[2,"after-delete"]],[14,[" (method of ",[0,[2,"text:delegate-mixin"]],")"]]],["framework"]],
["after-delete",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3ainfo-mixin)._after-delete))",[[0,[2,"after-delete"]],[14,[" (method of ",[0,[2,"text:info-mixin"]],")"]]],["framework"]],
["after-delete",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3asearching-mixin)._after-delete))",[[0,[2,"after-delete"]],[14,[" (method of ",[0,[2,"text:searching-mixin"]],")"]]],["framework"]],
["after-delete",">mrlib/horizontal-pasteboard_.html#(meth._(((lib._mrlib/aligned-pasteboard..rkt)._horizontal-pasteboard~25)._after-delete))",[[0,[2,"after-delete"]],[14,[" (method of ",[0,[2,"horizontal-pasteboard%"]],")"]]],["mrlib/aligned-pasteboard"]],
["after-delete",">mrlib/vertical-pasteboard_.html#(meth._(((lib._mrlib/aligned-pasteboard..rkt)._vertical-pasteboard~25)._after-delete))",[[0,[2,"after-delete"]],[14,[" (method of ",[0,[2,"vertical-pasteboard%"]],")"]]],["mrlib/aligned-pasteboard"]],
["after-edit-sequence",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._after-edit-sequence))",[[0,[2,"after-edit-sequence"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["after-edit-sequence",">framework/Color.html#(meth._(((lib._framework/main..rkt)._color~3atext-mixin)._after-edit-sequence))",[[0,[2,"after-edit-sequence"]],[14,[" (method of ",[0,[2,"color:text-mixin"]],")"]]],["framework"]],
["after-edit-sequence",">framework/Editor.html#(meth._(((lib._framework/main..rkt)._editor~3abasic-mixin)._after-edit-sequence))",[[0,[2,"after-edit-sequence"]],[14,[" (method of ",[0,[2,"editor:basic-mixin"]],")"]]],["framework"]],
["after-edit-sequence",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3ahost-text-mixin)._after-edit-sequence))",[[0,[2,"after-edit-sequence"]],[14,[" (method of ",[0,[2,"mode:host-text-mixin"]],")"]]],["framework"]],
["after-edit-sequence",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3asurrogate-text~25)._after-edit-sequence))",[[0,[2,"after-edit-sequence"]],[14,[" (method of ",[0,[2,"mode:surrogate-text%"]],")"]]],["framework"]],
["after-edit-sequence",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3adelegate-mixin)._after-edit-sequence))",[[0,[2,"after-edit-sequence"]],[14,[" (method of ",[0,[2,"text:delegate-mixin"]],")"]]],["framework"]],
["after-insert",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._after-insert))",[[0,[2,"after-insert"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["after-insert",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._after-insert))",[[0,[2,"after-insert"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["after-insert",">tools/drracket_rep.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3arep~3atext~25)._after-insert))",[[0,[2,"after-insert"]],[14,[" (method of ",[0,[2,"drracket:rep:text%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["after-insert",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aprogram-editor-mixin)._after-insert))",[[0,[2,"after-insert"]],[14,[" (method of ",[0,[2,"drracket:unit:program-editor-mixin"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["after-insert",">framework/Color.html#(meth._(((lib._framework/main..rkt)._color~3atext-mixin)._after-insert))",[[0,[2,"after-insert"]],[14,[" (method of ",[0,[2,"color:text-mixin"]],")"]]],["framework"]],
["after-insert",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3ahost-text-mixin)._after-insert))",[[0,[2,"after-insert"]],[14,[" (method of ",[0,[2,"mode:host-text-mixin"]],")"]]],["framework"]],
["after-insert",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3asurrogate-text~25)._after-insert))",[[0,[2,"after-insert"]],[14,[" (method of ",[0,[2,"mode:surrogate-text%"]],")"]]],["framework"]],
["after-insert",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3abasic-mixin)._after-insert))",[[0,[2,"after-insert"]],[14,[" (method of ",[0,[2,"text:basic-mixin"]],")"]]],["framework"]],
["after-insert",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3adelegate-mixin)._after-insert))",[[0,[2,"after-insert"]],[14,[" (method of ",[0,[2,"text:delegate-mixin"]],")"]]],["framework"]],
["after-insert",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3ainfo-mixin)._after-insert))",[[0,[2,"after-insert"]],[14,[" (method of ",[0,[2,"text:info-mixin"]],")"]]],["framework"]],
["after-insert",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3anbsp-~3espace-mixin)._after-insert))",[[0,[2,"after-insert"]],[14,[" (method of ",[0,[2,"text:nbsp->space-mixin"]],")"]]],["framework"]],
["after-insert",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3anormalize-paste-mixin)._after-insert))",[[0,[2,"after-insert"]],[14,[" (method of ",[0,[2,"text:normalize-paste-mixin"]],")"]]],["framework"]],
["after-insert",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3asearching-mixin)._after-insert))",[[0,[2,"after-insert"]],[14,[" (method of ",[0,[2,"text:searching-mixin"]],")"]]],["framework"]],
["after-insert",">mrlib/horizontal-pasteboard_.html#(meth._(((lib._mrlib/aligned-pasteboard..rkt)._horizontal-pasteboard~25)._after-insert))",[[0,[2,"after-insert"]],[14,[" (method of ",[0,[2,"horizontal-pasteboard%"]],")"]]],["mrlib/aligned-pasteboard"]],
["after-insert",">mrlib/vertical-pasteboard_.html#(meth._(((lib._mrlib/aligned-pasteboard..rkt)._vertical-pasteboard~25)._after-insert))",[[0,[2,"after-insert"]],[14,[" (method of ",[0,[2,"vertical-pasteboard%"]],")"]]],["mrlib/aligned-pasteboard"]],
["after-interactive-move",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._after-interactive-move))",[[0,[2,"after-interactive-move"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["after-interactive-resize",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._after-interactive-resize))",[[0,[2,"after-interactive-resize"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["after-io-insertion",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3aports~3c~25~3e)._after-io-insertion))",[[0,[2,"after-io-insertion"]],[14,[" (method of ",[0,[2,"text:ports<%>"]],")"]]],["framework"]],
["after-load-file",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._after-load-file))",[[0,[2,"after-load-file"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["after-load-file",">framework/Editor.html#(meth._(((lib._framework/main..rkt)._editor~3abasic-mixin)._after-load-file))",[[0,[2,"after-load-file"]],[14,[" (method of ",[0,[2,"editor:basic-mixin"]],")"]]],["framework"]],
["after-load-file",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3ahost-text-mixin)._after-load-file))",[[0,[2,"after-load-file"]],[14,[" (method of ",[0,[2,"mode:host-text-mixin"]],")"]]],["framework"]],
["after-load-file",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3asurrogate-text~25)._after-load-file))",[[0,[2,"after-load-file"]],[14,[" (method of ",[0,[2,"mode:surrogate-text%"]],")"]]],["framework"]],
["after-load-file",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3acrlf-line-endings-mixin)._after-load-file))",[[0,[2,"after-load-file"]],[14,[" (method of ",[0,[2,"text:crlf-line-endings-mixin"]],")"]]],["framework"]],
["after-load-file",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3adelegate-mixin)._after-load-file))",[[0,[2,"after-load-file"]],[14,[" (method of ",[0,[2,"text:delegate-mixin"]],")"]]],["framework"]],
["after-load-file",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3afile-mixin)._after-load-file))",[[0,[2,"after-load-file"]],[14,[" (method of ",[0,[2,"text:file-mixin"]],")"]]],["framework"]],
["after-many-evals",">tools/drracket_rep.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3arep~3atext~25)._after-many-evals))",[[0,[2,"after-many-evals"]],[14,[" (method of ",[0,[2,"drracket:rep:text%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["after-merge-snips",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._after-merge-snips))",[[0,[2,"after-merge-snips"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["after-move-to",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._after-move-to))",[[0,[2,"after-move-to"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["after-new-child",">gui/area-container___.html#(meth._(((lib._mred/main..rkt)._area-container~3c~25~3e)._after-new-child))",[[0,[2,"after-new-child"]],[14,[" (method of ",[0,[2,"area-container<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["after-new-child",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3abasic-mixin)._after-new-child))",[[0,[2,"after-new-child"]],[14,[" (method of ",[0,[2,"frame:basic-mixin"]],")"]]],["framework"]],
["after-new-child",">framework/Panel.html#(meth._(((lib._framework/main..rkt)._panel~3adragable-mixin)._after-new-child))",[[0,[2,"after-new-child"]],[14,[" (method of ",[0,[2,"panel:dragable-mixin"]],")"]]],["framework"]],
["after-new-child",">framework/Panel.html#(meth._(((lib._framework/main..rkt)._panel~3asingle-mixin)._after-new-child))",[[0,[2,"after-new-child"]],[14,[" (method of ",[0,[2,"panel:single-mixin"]],")"]]],["framework"]],
["after-percentage-change",">framework/Panel.html#(meth._(((lib._framework/main..rkt)._panel~3adragable~3c~25~3e)._after-percentage-change))",[[0,[2,"after-percentage-change"]],[14,[" (method of ",[0,[2,"panel:dragable<%>"]],")"]]],["framework"]],
["after-reorder",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._after-reorder))",[[0,[2,"after-reorder"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["after-reorder",">mrlib/horizontal-pasteboard_.html#(meth._(((lib._mrlib/aligned-pasteboard..rkt)._horizontal-pasteboard~25)._after-reorder))",[[0,[2,"after-reorder"]],[14,[" (method of ",[0,[2,"horizontal-pasteboard%"]],")"]]],["mrlib/aligned-pasteboard"]],
["after-reorder",">mrlib/vertical-pasteboard_.html#(meth._(((lib._mrlib/aligned-pasteboard..rkt)._vertical-pasteboard~25)._after-reorder))",[[0,[2,"after-reorder"]],[14,[" (method of ",[0,[2,"vertical-pasteboard%"]],")"]]],["mrlib/aligned-pasteboard"]],
["after-resize",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._after-resize))",[[0,[2,"after-resize"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["after-save-file",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._after-save-file))",[[0,[2,"after-save-file"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["after-save-file",">framework/Editor.html#(meth._(((lib._framework/main..rkt)._editor~3abasic-mixin)._after-save-file))",[[0,[2,"after-save-file"]],[14,[" (method of ",[0,[2,"editor:basic-mixin"]],")"]]],["framework"]],
["after-save-file",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3ahost-text-mixin)._after-save-file))",[[0,[2,"after-save-file"]],[14,[" (method of ",[0,[2,"mode:host-text-mixin"]],")"]]],["framework"]],
["after-save-file",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3asurrogate-text~25)._after-save-file))",[[0,[2,"after-save-file"]],[14,[" (method of ",[0,[2,"mode:surrogate-text%"]],")"]]],["framework"]],
["after-save-file",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3afile-mixin)._after-save-file))",[[0,[2,"after-save-file"]],[14,[" (method of ",[0,[2,"text:file-mixin"]],")"]]],["framework"]],
["after-seconds",">reference/distributed-places.html#(form._((lib._racket/place/distributed..rkt)._after-seconds))",[0,[1,"after-seconds"]],["racket/place/distributed"]],
["after-seconds%",">reference/distributed-places.html#(def._((lib._racket/place/distributed..rkt)._after-seconds~25))",[0,[2,"after-seconds%"]],["racket/place/distributed"]],
["after-select",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._after-select))",[[0,[2,"after-select"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["after-set-next-settings",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3adefinitions-text~3c~25~3e)._after-set-next-settings))",[[0,[2,"after-set-next-settings"]],[14,[" (method of ",[0,[2,"drracket:unit:definitions-text<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["after-set-page",">browser/index.html#(meth._(((lib._browser/browser..rkt)._hyper-canvas-mixin)._after-set-page))",[[0,[2,"after-set-page"]],[14,[" (method of ",[0,[2,"hyper-canvas-mixin"]],")"]]],["browser/browser","browser"]],
["after-set-position",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._after-set-position))",[[0,[2,"after-set-position"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["after-set-position",">framework/Color.html#(meth._(((lib._framework/main..rkt)._color~3atext-mixin)._after-set-position))",[[0,[2,"after-set-position"]],[14,[" (method of ",[0,[2,"color:text-mixin"]],")"]]],["framework"]],
["after-set-position",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3ahost-text-mixin)._after-set-position))",[[0,[2,"after-set-position"]],[14,[" (method of ",[0,[2,"mode:host-text-mixin"]],")"]]],["framework"]],
["after-set-position",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3asurrogate-text~25)._after-set-position))",[[0,[2,"after-set-position"]],[14,[" (method of ",[0,[2,"mode:surrogate-text%"]],")"]]],["framework"]],
["after-set-position",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3ahide-caret/selection-mixin)._after-set-position))",[[0,[2,"after-set-position"]],[14,[" (method of ",[0,[2,"text:hide-caret/selection-mixin"]],")"]]],["framework"]],
["after-set-position",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3ainfo-mixin)._after-set-position))",[[0,[2,"after-set-position"]],[14,[" (method of ",[0,[2,"text:info-mixin"]],")"]]],["framework"]],
["after-set-size-constraint",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._after-set-size-constraint))",[[0,[2,"after-set-size-constraint"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["after-set-size-constraint",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3ahost-text-mixin)._after-set-size-constraint))",[[0,[2,"after-set-size-constraint"]],[14,[" (method of ",[0,[2,"mode:host-text-mixin"]],")"]]],["framework"]],
["after-set-size-constraint",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3asurrogate-text~25)._after-set-size-constraint))",[[0,[2,"after-set-size-constraint"]],[14,[" (method of ",[0,[2,"mode:surrogate-text%"]],")"]]],["framework"]],
["after-split-snip",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._after-split-snip))",[[0,[2,"after-split-snip"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["alarm-evt",">reference/sync.html#(def._((quote._~23~25kernel)._alarm-evt))",[0,[2,"alarm-evt"]],["racket/base","racket"]],
["algol 60",">algol60/index.html","Algol 60",false],
["algol60/algol60",">algol60/index.html#(mod-path._algol60/algol60)",[9,[0,"algol60/algol60"]],"module"],
["align",">embedded-gui/alignment___.html#(meth._(((lib._embedded-gui/main..rkt)._alignment~3c~25~3e)._align))",[[0,[2,"align"]],[14,[" (method of ",[0,[2,"alignment<%>"]],")"]]],["embedded-gui"]],
["aligned",">draw/font_.html#(idx._(gentag._46._(lib._scribblings/draw/draw..scrbl)))",[7,"'aligned"],false],
["aligned pasteboard",">mrlib/Aligned_Pasteboard.html","Aligned Pasteboard",false],
["aligned-editor-canvas%",">mrlib/aligned-editor-canvas_.html",[0,[2,"aligned-editor-canvas%"]],["mrlib/aligned-pasteboard"]],
["aligned-editor-snip%",">mrlib/aligned-editor-snip_.html",[0,[2,"aligned-editor-snip%"]],["mrlib/aligned-pasteboard"]],
["aligned-pasteboard%",">embedded-gui/aligned-pasteboard_.html",[0,[2,"aligned-pasteboard%"]],["embedded-gui"]],
["aligned-pasteboard-parent<%>",">mrlib/aligned-pasteboard-parent___.html",[0,[2,"aligned-pasteboard-parent<%>"]],["mrlib/aligned-pasteboard"]],
["aligned-pasteboard<%>",">mrlib/aligned-pasteboard___.html",[0,[2,"aligned-pasteboard<%>"]],["mrlib/aligned-pasteboard"]],
["alignment",">gui/area-container___.html#(idx._(gentag._19._(lib._scribblings/gui/gui..scrbl)))",[0,"alignment"],false],
["alignment-parent<%>",">embedded-gui/alignment-parent___.html",[0,[2,"alignment-parent<%>"]],["embedded-gui"]],
["alignment<%>",">embedded-gui/alignment___.html",[0,[2,"alignment<%>"]],["embedded-gui"]],
["alink",">html/index.html#(def._((lib._html/main..rkt)._alink))",[0,[2,"alink"]],["html"]],
["alink?",">html/index.html#(def._((lib._html/main..rkt)._alink~3f))",[0,[2,"alink?"]],["html"]],
["alist->form-urlencoded",">net/uri-codec.html#(def._((lib._net/uri-codec..rkt)._alist-~3eform-urlencoded))",[0,[2,"alist->form-urlencoded"]],["net/uri-codec"]],
["alist-cons",">srfi-std/srfi-1.html#alist-cons",[0,[2,"alist-cons"]],["srfi/1"]],
["alist-copy",">srfi-std/srfi-1.html#alist-copy",[0,[2,"alist-copy"]],["srfi/1"]],
["alist-delete",">srfi-std/srfi-1.html#alist-delete",[0,[2,"alist-delete"]],["srfi/1"]],
["alist-delete!",">srfi-std/srfi-1.html#alist-delete!",[0,[2,"alist-delete!"]],["srfi/1"]],
["all",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types-extra..rkt)._.All))",[0,[1,"All"]],["typed/racket/base","typed/racket"]],
["all",">planet/Developing_Packages_for_PLaneT.html#(idx._(gentag._17._(lib._planet/planet..scrbl)))",[7,"'all"],false],
["all",">planet/Developing_Packages_for_PLaneT.html#(idx._(gentag._20._(lib._planet/planet..scrbl)))",[7,"'all"],false],
["all-cards",">cards/index.html#(meth._(((lib._games/cards..rkt)._table~3c~25~3e)._all-cards))",[[0,[2,"all-cards"]],[14,[" (method of ",[0,[2,"table<%>"]],")"]]],["games/cards"]],
["all-defined-out",">reference/require.html#(form._((lib._racket/private/base..rkt)._all-defined-out))",[0,[1,"all-defined-out"]],["racket/base","racket"]],
["all-from-module",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._all-from-module))",[0,[2,"all-from-module"]],["compiler/zo-structs"]],
["all-from-module-context",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._all-from-module-context))",[0,[2,"all-from-module-context"]],["compiler/zo-structs"]],
["all-from-module-exceptions",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._all-from-module-exceptions))",[0,[2,"all-from-module-exceptions"]],["compiler/zo-structs"]],
["all-from-module-path",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._all-from-module-path))",[0,[2,"all-from-module-path"]],["compiler/zo-structs"]],
["all-from-module-phase",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._all-from-module-phase))",[0,[2,"all-from-module-phase"]],["compiler/zo-structs"]],
["all-from-module-prefix",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._all-from-module-prefix))",[0,[2,"all-from-module-prefix"]],["compiler/zo-structs"]],
["all-from-module-src-phase",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._all-from-module-src-phase))",[0,[2,"all-from-module-src-phase"]],["compiler/zo-structs"]],
["all-from-module?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._all-from-module~3f))",[0,[2,"all-from-module?"]],["compiler/zo-structs"]],
["all-from-out",">reference/require.html#(form._((lib._racket/private/base..rkt)._all-from-out))",[0,[1,"all-from-out"]],["racket/base","racket"]],
["all-languages",">string-constants/index.html#(form._((lib._string-constants/string-constant..rkt)._all-languages))",[0,[1,"all-languages"]],["string-constants/string-constant","string-constants"]],
["allocation",">inside/overview.html#(idx._(gentag._11._(lib._scribblings/inside/inside..scrbl)))","allocation",false],
["allocation",">inside/overview.html#(idx._(gentag._24._(lib._scribblings/inside/inside..scrbl)))","allocation",false],
["allocation and finalization",">foreign/Allocation_and_Finalization.html","Allocation and Finalization",false],
["allocator",">foreign/Allocation_and_Finalization.html#(def._((lib._ffi/unsafe/alloc..rkt)._allocator))",[0,[2,"allocator"]],["ffi/unsafe/alloc"]],
["allocator-setup",">plai/mutator.html#(form._((lib._plai/scribblings/fake-mutator..rkt)._allocator-setup))",[0,[1,"allocator-setup"]],[]],
["allow-close-with-no-filename?",">framework/Editor.html#(meth._(((lib._framework/main..rkt)._editor~3afile~3c~25~3e)._allow-close-with-no-filename~3f))",[[0,[2,"allow-close-with-no-filename?"]],[14,[" (method of ",[0,[2,"editor:file<%>"]],")"]]],["framework"]],
["allow-deselect",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..rkt)._hierarchical-list~25)._allow-deselect))",[[0,[2,"allow-deselect"]],[14,[" (method of ",[0,[2,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["allow-scroll-to-last",">gui/editor-canvas_.html#(meth._(((lib._mred/main..rkt)._editor-canvas~25)._allow-scroll-to-last))",[[0,[2,"allow-scroll-to-last"]],[14,[" (method of ",[0,[2,"editor-canvas%"]],")"]]],["racket/gui/base","racket/gui"]],
["allow-tab-exit",">gui/editor-canvas_.html#(meth._(((lib._mred/main..rkt)._editor-canvas~25)._allow-tab-exit))",[[0,[2,"allow-tab-exit"]],[14,[" (method of ",[0,[2,"editor-canvas%"]],")"]]],["racket/gui/base","racket/gui"]],
["allowing thread switches",">inside/threads.html#(part._usefuel)","Allowing Thread Switches",false],
["alpha",">draw/color_.html#(meth._(((lib._racket/draw..rkt)._color~25)._alpha))",[[0,[2,"alpha"]],[14,[" (method of ",[0,[2,"color%"]],")"]]],["racket/draw"]],
["alpha blending",">draw/overview.html#(tech._alpha._blending)","<span style=\"font-style: italic\">alpha blending</span>",false],
["alpha channel",">draw/overview.html#(tech._alpha._channel)","<span style=\"font-style: italic\">alpha channel</span>",false],
["alpha channels and alpha blending",">draw/overview.html#(part._.Alpha_.Channels_and_.Alpha_.Blending)","Alpha Channels and Alpha Blending",false],
["alpha renaming",">drracket/buttons.html#(idx._(gentag._11._(lib._scribblings/drracket/drracket..scrbl)))","alpha renaming",false],
["alpha-color",">htdp/index.html#(def._((lib._htdp/color-structs..rkt)._alpha-color))",[0,[2,"alpha-color"]],["htdp/color-structs"]],
["alpha-color",">teachpack/image.html#(def._((lib._htdp/image..rkt)._alpha-color))",[0,[2,"alpha-color"]],["htdp/image"]],
["alpha-color-alpha",">htdp/index.html#(def._((lib._htdp/color-structs..rkt)._alpha-color-alpha))",[0,[2,"alpha-color-alpha"]],["htdp/color-structs"]],
["alpha-color-alpha",">teachpack/image.html#(def._((lib._htdp/image..rkt)._alpha-color-alpha))",[0,[2,"alpha-color-alpha"]],["htdp/image"]],
["alpha-color-alpha",">deinprogramm/image.html#(def._((lib._deinprogramm/image..rkt)._alpha-color-alpha))",[0,[2,"alpha-color-alpha"]],["teachpack/deinprogramm/image"]],
["alpha-color-blue",">htdp/index.html#(def._((lib._htdp/color-structs..rkt)._alpha-color-blue))",[0,[2,"alpha-color-blue"]],["htdp/color-structs"]],
["alpha-color-blue",">teachpack/image.html#(def._((lib._htdp/image..rkt)._alpha-color-blue))",[0,[2,"alpha-color-blue"]],["htdp/image"]],
["alpha-color-blue",">deinprogramm/image.html#(def._((lib._deinprogramm/image..rkt)._alpha-color-blue))",[0,[2,"alpha-color-blue"]],["teachpack/deinprogramm/image"]],
["alpha-color-green",">htdp/index.html#(def._((lib._htdp/color-structs..rkt)._alpha-color-green))",[0,[2,"alpha-color-green"]],["htdp/color-structs"]],
["alpha-color-green",">teachpack/image.html#(def._((lib._htdp/image..rkt)._alpha-color-green))",[0,[2,"alpha-color-green"]],["htdp/image"]],
["alpha-color-green",">deinprogramm/image.html#(def._((lib._deinprogramm/image..rkt)._alpha-color-green))",[0,[2,"alpha-color-green"]],["teachpack/deinprogramm/image"]],
["alpha-color-list->image",">teachpack/image.html#(def._((lib._htdp/image..rkt)._alpha-color-list-~3eimage))",[0,[2,"alpha-color-list->image"]],["htdp/image"]],
["alpha-color-list->image",">deinprogramm/image.html#(def._((lib._deinprogramm/image..rkt)._alpha-color-list-~3eimage))",[0,[2,"alpha-color-list->image"]],["teachpack/deinprogramm/image"]],
["alpha-color-red",">htdp/index.html#(def._((lib._htdp/color-structs..rkt)._alpha-color-red))",[0,[2,"alpha-color-red"]],["htdp/color-structs"]],
["alpha-color-red",">teachpack/image.html#(def._((lib._htdp/image..rkt)._alpha-color-red))",[0,[2,"alpha-color-red"]],["htdp/image"]],
["alpha-color-red",">deinprogramm/image.html#(def._((lib._deinprogramm/image..rkt)._alpha-color-red))",[0,[2,"alpha-color-red"]],["teachpack/deinprogramm/image"]],
["alpha-color?",">htdp/index.html#(def._((lib._htdp/color-structs..rkt)._alpha-color~3f))",[0,[2,"alpha-color?"]],["htdp/color-structs"]],
["alpha-color?",">teachpack/image.html#(def._((lib._htdp/image..rkt)._alpha-color~3f))",[0,[2,"alpha-color?"]],["htdp/image"]],
["alpha-color?",">deinprogramm/image.html#(def._((lib._deinprogramm/image..rkt)._alpha-color~3f))",[0,[2,"alpha-color?"]],["teachpack/deinprogramm/image"]],
["alpha-rgb-color",">deinprogramm/image.html#(def._((lib._deinprogramm/image..rkt)._alpha-rgb-color))",[0,[2,"alpha-rgb-color"]],["teachpack/deinprogramm/image"]],
["alpha-version?",">version/index.html#(def._((lib._version/utils..rkt)._alpha-version~3f))",[0,[2,"alpha-version?"]],["version/utils"]],
["alpha/rgb-farbe",">deinprogramm/image.html#(tech._alpha/rgb._farbe)","<span style=\"font-style: italic\">Alpha/RGB-Farbe</span>",false],
["alphabetic",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex..rkt)._alphabetic))",[0,[1,"alphabetic"]],["parser-tools/lex"]],
["alphas/c",">plot/contracts.html#(def._((lib._plot/utils..rkt)._alphas/c))",[0,[2,"alphas/c"]],["plot/utils"]],
["alt-tag",">scribble/core.html#(def._((lib._scribble/html-properties..rkt)._alt-tag))",[0,[2,"alt-tag"]],["scribble/html-properties"]],
["alt-tag-name",">scribble/core.html#(def._((lib._scribble/html-properties..rkt)._alt-tag-name))",[0,[2,"alt-tag-name"]],["scribble/html-properties"]],
["alt-tag?",">scribble/core.html#(def._((lib._scribble/html-properties..rkt)._alt-tag~3f))",[0,[2,"alt-tag?"]],["scribble/html-properties"]],
["alternation",">guide/regexp-alternation.html","Alternation",false],
["alternative body syntax",">scribble/reader.html#(part._alt-body-syntax)","Alternative Body Syntax",false],
["always-evt",">reference/sync.html#(def._((quote._~23~25kernel)._always-evt))",[0,[2,"always-evt"]],["racket/base","racket"]],
["always?",">eopl/index.html#(def._((lib._eopl/eopl..rkt)._always~3f))",[0,[2,"always?"]],["eopl"]],
["amb: a redex tutorial",">redex/tutorial.html","Amb: A Redex Tutorial",false],
["an arrow gui: \"arrow-gui.ss\"",">teachpack/arrow-gui.html",["An Arrow GUI: ",[6,"\"arrow-gui.ss\""],"<a name=\"(idx._(gentag._14._(lib._teachpack/teachpack..scrbl)))\"></a>"],false],
["an aside on indenting code",">guide/syntax-overview.html#(part._indentation)","An Aside on Indenting Code",false],
["an example",">graphics/An_Example.html","An Example",false],
["an extended example",">guide/An_Extended_Example.html","An Extended Example",false],
["analyze-samples",">profile/index.html#(def._((lib._profile/analyzer..rkt)._analyze-samples))",[0,[2,"analyze-samples"]],["profile/analyzer"]],
["analyzing profile data",">profile/index.html#(part._analyzer)","Analyzing Profile Data",false],
["anchor-status-changed",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3atext-info~3c~25~3e)._anchor-status-changed))",[[0,[2,"anchor-status-changed"]],[14,[" (method of ",[0,[2,"frame:text-info<%>"]],")"]]],["framework"]],
["anchor/c",">plot/contracts.html#(def._((lib._plot/utils..rkt)._anchor/c))",[0,[2,"anchor/c"]],["plot/utils"]],
["and",">deinprogramm/and.html",[0,[1,"and"]],false],
["and",">reference/if.html#(form._((lib._racket/private/letstx-scheme..rkt)._and))",[0,[1,"and"]],["racket/base","racket"]],
["and",">r5rs-std/r5rs-Z-H-7.html#%_idx_120",[0,[1,"and"]],["r5rs"]],
["and",">r6rs-std/r6rs-Z-H-14.html#node_idx_388",[0,[1,"and"]],["rnrs/base-6"]],
["and",">htdp-langs/advanced.html#(form._((lib._lang/htdp-advanced..rkt)._and))",[0,[1,"and"]],["lang/htdp-advanced"]],
["and",">htdp-langs/beginner.html#(form._((lib._lang/htdp-beginner..rkt)._and))",[0,[1,"and"]],["lang/htdp-beginner"]],
["and",">htdp-langs/beginner-abbr.html#(form._((lib._lang/htdp-beginner-abbr..rkt)._and))",[0,[1,"and"]],["lang/htdp-beginner-abbr"]],
["and",">htdp-langs/intermediate.html#(form._((lib._lang/htdp-intermediate..rkt)._and))",[0,[1,"and"]],["lang/htdp-intermediate"]],
["and",">htdp-langs/intermediate-lam.html#(form._((lib._lang/htdp-intermediate-lambda..rkt)._and))",[0,[1,"and"]],["lang/htdp-intermediate-lambda"]],
["and",">deinprogramm/and.html#(form._((lib._deinprogramm/.D.Md.A..rkt)._and))",[0,[1,"and"]],["deinprogramm/DMdA-beginner"]],
["and",">lazy/index.html#(def._((lib._lazy/main..rkt)._and))",[0,[2,"and"]],["lazy"]],
["and",">plai/mutator.html#(form._((lib._plai/mutator..rkt)._and))",[0,[1,"and"]],["plai/mutator"]],
["and",">srfi-std/srfi-42.html#and",[0,[1,"and"]],["srfi/42"]],
["and more",">guide/More_Libraries.html#(part._.And_.More)","And More",false],
["and-let*",">srfi-std/srfi-2.html#and-let",[0,[1,"and-let*"]],["srfi/2"]],
["and/c",">reference/data-structure-contracts.html#(def._((lib._racket/contract/private/misc..rkt)._and/c))",[0,[2,"and/c"]],["racket/contract/base","racket/contract","racket"]],
["andmap",">reference/pairs.html#(def._((lib._racket/private/map..rkt)._andmap))",[0,[2,"andmap"]],["racket/base","racket"]],
["andmap",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._andmap))",[0,[2,"andmap"]],["lang/htdp-advanced"]],
["andmap",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._andmap))",[0,[2,"andmap"]],["lang/htdp-intermediate"]],
["andmap",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._andmap))",[0,[2,"andmap"]],["lang/htdp-intermediate-lambda"]],
["andmap",">lazy/index.html#(def._((lib._lazy/main..rkt)._andmap))",[0,[2,"andmap"]],["lazy"]],
["angel-wing",">slideshow/More_Pict_Constructors.html#(def._((lib._slideshow/pict..rkt)._angel-wing))",[0,[2,"angel-wing"]],["slideshow/pict","slideshow"]],
["angle",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._angle))",[0,[2,"angle"]],["racket/base","racket"]],
["angle",">r5rs-std/r5rs-Z-H-9.html#%_idx_358",[0,[2,"angle"]],["r5rs"]],
["angle",">r6rs-std/r6rs-Z-H-14.html#node_idx_576",[0,[2,"angle"]],["rnrs/base-6"]],
["angle",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._angle))",[0,[2,"angle"]],["lang/htdp-advanced"]],
["angle",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._angle))",[0,[2,"angle"]],["lang/htdp-beginner"]],
["angle",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._angle))",[0,[2,"angle"]],["lang/htdp-beginner-abbr"]],
["angle",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._angle))",[0,[2,"angle"]],["lang/htdp-intermediate"]],
["angle",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._angle))",[0,[2,"angle"]],["lang/htdp-intermediate-lambda"]],
["angle",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._angle))",[0,[2,"angle"]],["deinprogramm/DMdA-advanced"]],
["angle",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._angle))",[0,[2,"angle"]],["deinprogramm/DMdA-assignments"]],
["angle",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._angle))",[0,[2,"angle"]],["deinprogramm/DMdA-beginner"]],
["angle",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._angle))",[0,[2,"angle"]],["deinprogramm/DMdA-vanilla"]],
["angle?",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._angle~3f))",[0,[2,"angle?"]],["2htdp/image"]],
["animate",">teachpack/2htdpuniverse.html#(def._((lib._2htdp/universe..rkt)._animate))",[0,[2,"animate"]],["2htdp/universe"]],
["animate-slide",">slideshow/play.html#(def._((lib._slideshow/play..rkt)._animate-slide))",[0,[2,"animate-slide"]],["slideshow/play"]],
["animated",">cards/index.html#(meth._(((lib._games/cards..rkt)._table~3c~25~3e)._animated))",[[0,[2,"animated"]],[14,[" (method of ",[0,[2,"table<%>"]],")"]]],["games/cards"]],
["animated-samples",">plot/params.html#(def._((lib._plot/main..rkt)._animated-samples))",[0,[2,"animated-samples"]],["plot"]],
["animation helpers",">slideshow/play.html#(part._.Animation_.Helpers)","Animation Helpers",false],
["animation in canvases",">gui/windowing-overview.html#(part._animation)","Animation in Canvases",false],
["animation support",">picturing-programs/index.html#(part._.Animation_support)","Animation support",false],
["animationen: \"world.ss\"",">deinprogramm/world.html",["Animationen: ",[6,"\"world.ss\""],"<a name=\"(idx._(gentag._3._(lib._deinprogramm/scribblings/deinprogramm..scrbl)))\"></a>"],false],
["animations",">slideshow/play.html","Animations",false],
["ann",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._ann))",[0,[1,"ann"]],["typed/racket/base","typed/racket"]],
["annotate",">errortrace/stacktrace.html#(sig-val._((lib._errortrace/stacktrace..rkt)._stacktrace~5e._annotate))",[0,[2,"annotate"]],["errortrace/stacktrace"]],
["annotate",">trace/index.html#(def._((lib._trace/calltrace-lib..rkt)._annotate))",[0,"annotate"],["trace/calltrace-lib"]],
["annotate-covered-file",">errortrace/using-errortrace.html#(def._((lib._errortrace/errortrace-lib..rkt)._annotate-covered-file))",[0,[2,"annotate-covered-file"]],["errortrace"]],
["annotate-executed-file",">errortrace/using-errortrace.html#(def._((lib._errortrace/errortrace-lib..rkt)._annotate-executed-file))",[0,[2,"annotate-executed-file"]],["errortrace"]],
["annotate-top",">errortrace/errortrace-library.html#(def._((lib._errortrace/errortrace-lib..rkt)._annotate-top))",[0,[2,"annotate-top"]],["errortrace/errortrace-lib"]],
["annotate-top",">errortrace/stacktrace.html#(sig-val._((lib._errortrace/stacktrace..rkt)._stacktrace~5e._annotate-top))",[0,[2,"annotate-top"]],["errortrace/stacktrace"]],
["annotated pattern variable",">syntax/stxparse-patterns.html#(tech._annotated._pattern._variable)","<span style=\"font-style: italic\">annotated pattern variable</span>",false],
["annotating definitions",">ts-guide/more.html#(part._.Annotating_.Definitions)","Annotating Definitions",false],
["annotating expressions",">ts-guide/more.html#(part._.Annotating_.Expressions)","Annotating Expressions",false],
["annotating functions",">ts-guide/more.html#(part._.Annotating_.Functions)","Annotating Functions",false],
["annotating local binding",">ts-guide/more.html#(part._.Annotating_.Local_.Binding)","Annotating Local Binding",false],
["annotating single variables",">ts-guide/more.html#(part._.Annotating_.Single_.Variables)","Annotating Single Variables",false],
["annotation",">teachpack/docs.html#(tech._annotation)","<span style=\"font-style: italic\">Annotation</span>",false],
["annotation?",">teachpack/docs.html#(def._((lib._htdp/docs..rkt)._annotation~3f))",[0,[2,"annotation?"]],["htdp/docs"]],
["annotations-mixin",">tools/Check_Syntax.html#(def._((lib._drracket/check-syntax..rkt)._annotations-mixin))",[0,[2,"annotations-mixin"]],["drracket/check-syntax"]],
["anonymous functions",">ts-reference/special-forms.html#(part._.Anonymous_.Functions)","Anonymous Functions",false],
["anonymous functions with lambda",">guide/syntax-overview.html#(part._.Anonymous_.Functions_with_lambda)",["Anonymous Functions with ",[0,[1,"lambda"]]],false],
["answer-value?",">racklog/glossary.html#(def._((lib._racklog/main..rkt)._answer-value~3f))",[0,[2,"answer-value?"]],["racklog"]],
["answer?",">racklog/glossary.html#(def._((lib._racklog/main..rkt)._answer~3f))",[0,[2,"answer?"]],["racklog"]],
["any",">reference/data-structure-contracts.html#(form._((lib._racket/contract/private/misc..rkt)._any))",[0,[1,"any"]],["racket/contract/base","racket/contract","racket"]],
["any",">deinprogramm/Signaturen.html#(form._((lib._deinprogramm/.D.Md.A..rkt)._any))",[0,[1,"any"]],["deinprogramm/DMdA-beginner"]],
["any",">srfi-std/srfi-1.html#any",[0,[2,"any"]],["srfi/1"]],
["any",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Any))",[0,[1,"Any"]],["typed/racket/base","typed/racket"]],
["any",">reference/Byte_and_String_Input.html#(idx._(gentag._216._(lib._scribblings/reference/reference..scrbl)))",[7,"'any"],false],
["any",">redex/The_Redex_Reference.html#(tech._any)",[0,[1,"any"]],false],
["any and any/c",">guide/contract-func.html#(part._any_and_any_c)",[[0,[1,"any"]]," and ",[0,[2,"any/c"]]],false],
["any->response",">web-server/servlet.html#(def._((lib._web-server/servlet/servlet-structs..rkt)._any-~3eresponse))",[0,[2,"any->response"]],["web-server/servlet/servlet-structs"]],
["any-char",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex..rkt)._any-char))",[0,[1,"any-char"]],["parser-tools/lex"]],
["any-one",">reference/Byte_and_String_Input.html#(idx._(gentag._217._(lib._scribblings/reference/reference..scrbl)))",[7,"'any-one"],false],
["any-string",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex..rkt)._any-string))",[0,[1,"any-string"]],["parser-tools/lex"]],
["any/c",">reference/data-structure-contracts.html#(def._((lib._racket/contract/private/misc..rkt)._any/c))",[0,[2,"any/c"]],["racket/contract/base","racket/contract","racket"]],
["any?-ec",">srfi-std/srfi-42.html#any?-ec",[0,[1,"any?-ec"]],["srfi/42"]],
["apache-default-format",">web-server-internal/dispatch-log.html#(def._((lib._web-server/dispatchers/dispatch-log..rkt)._apache-default-format))",[0,[2,"apache-default-format"]],["web-server/dispatchers/dispatch-log"]],
["api details",">web-server/templates.html#(part._.A.P.I_.Details)","API Details",false],
["api for 3m transformation",">raco/cc.html#(part._xform-api)","API for 3m Transformation",false],
["api for bundling distributions",">raco/exe-dist.html#(part._.A.P.I_for_.Bundling_.Distributions)","API for Bundling Distributions",false],
["api for collection links",">raco/link.html#(part._.A.P.I_for_.Collection_.Links)","API for Collection Links",false],
["api for creating executables",">raco/exe.html#(part._.A.P.I_for_.Creating_.Executables)","API for Creating Executables",false],
["api for cross-references for installed manuals",">raco/xref.html","API for Cross-References for Installed Manuals",false],
["api for decompiling",">raco/decompile.html#(part._.A.P.I_for_.Decompiling)","API for Decompiling",false],
["api for distributing executables",">raco/exe-dist.html#(part._.A.P.I_for_.Distributing_.Executables)","API for Distributing Executables",false],
["api for finding installation directories",">raco/dirs.html","API for Finding Installation Directories",false],
["api for installation",">raco/setup-plt-plt.html","API for Installation",false],
["api for installing \".plt\" archives",">raco/_plt-archives.html",["API for Installing ",[6,"\".plt\""]," Archives"],false],
["api for making bytecode",">raco/make.html#(part._.A.P.I_for_.Making_.Bytecode)","API for Making Bytecode",false],
["api for marshaling bytecode",">raco/decompile.html#(part._.A.P.I_for_.Marshaling_.Bytecode)","API for Marshaling Bytecode",false],
["api for packing",">raco/plt.html#(part._.A.P.I_for_.Packing)","API for Packing",false],
["api for parallel builds",">raco/make.html#(part._api~3aparallel-build)","API for Parallel Builds",false],
["api for parsing bytecode",">raco/decompile.html#(part._.A.P.I_for_.Parsing_.Bytecode)","API for Parsing Bytecode",false],
["api for raw compilation",">raco/API_for_Raw_Compilation.html","API for Raw Compilation",false],
["api for reading \"info.rkt\" files",">raco/getinfo.html",["API for Reading ",[6,"\"info.rkt\""]," Files"],false],
["api for relative paths",">raco/relative-paths.html","API for Relative Paths",false],
["api reference",">web-server/dispatch.html#(part._.A.P.I_.Reference)","API Reference",false],
["app",">gui/message_.html#(idx._(gentag._118._(lib._scribblings/gui/gui..scrbl)))",[7,"'app"],false],
["appearance argument contracts",">plot/contracts.html#(part._.Appearance_.Argument_.Contracts)","Appearance Argument Contracts",false],
["appearance argument list contracts",">plot/contracts.html#(part._.Appearance_.Argument_.List_.Contracts)","Appearance Argument List Contracts",false],
["append",">reference/pairs.html#(def._((quote._~23~25kernel)._append))",[0,[2,"append"]],["racket/base","racket"]],
["append",">draw/dc-path_.html#(meth._(((lib._racket/draw..rkt)._dc-path~25)._append))",[[0,[2,"append"]],[14,[" (method of ",[0,[2,"dc-path%"]],")"]]],["racket/draw"]],
["append",">gui/combo-field_.html#(meth._(((lib._mred/main..rkt)._combo-field~25)._append))",[[0,[2,"append"]],[14,[" (method of ",[0,[2,"combo-field%"]],")"]]],["racket/gui/base","racket/gui"]],
["append",">gui/list-box_.html#(meth._(((lib._mred/main..rkt)._list-box~25)._append))",[[0,[2,"append"]],[14,[" (method of ",[0,[2,"list-box%"]],")"]]],["racket/gui/base","racket/gui"]],
["append",">gui/list-control___.html#(meth._(((lib._mred/main..rkt)._list-control~3c~25~3e)._append))",[[0,[2,"append"]],[14,[" (method of ",[0,[2,"list-control<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["append",">gui/tab-panel_.html#(meth._(((lib._mred/main..rkt)._tab-panel~25)._append))",[[0,[2,"append"]],[14,[" (method of ",[0,[2,"tab-panel%"]],")"]]],["racket/gui/base","racket/gui"]],
["append",">r5rs-std/r5rs-Z-H-9.html#%_idx_438",[0,[2,"append"]],["r5rs"]],
["append",">r6rs-std/r6rs-Z-H-14.html#node_idx_634",[0,[2,"append"]],["rnrs/base-6"]],
["append",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._append))",[0,[2,"append"]],["lang/htdp-advanced"]],
["append",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._append))",[0,[2,"append"]],["lang/htdp-beginner"]],
["append",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._append))",[0,[2,"append"]],["lang/htdp-beginner-abbr"]],
["append",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._append))",[0,[2,"append"]],["lang/htdp-intermediate"]],
["append",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._append))",[0,[2,"append"]],["lang/htdp-intermediate-lambda"]],
["append",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._append))",[0,[2,"append"]],["deinprogramm/DMdA-advanced"]],
["append",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._append))",[0,[2,"append"]],["deinprogramm/DMdA-assignments"]],
["append",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._append))",[0,[2,"append"]],["deinprogramm/DMdA-vanilla"]],
["append",">lazy/index.html#(def._((lib._lazy/main..rkt)._append))",[0,[2,"append"]],["lazy"]],
["append",">srfi-std/srfi-1.html#append",[0,[2,"append"]],["srfi/1"]],
["append",">reference/file-ports.html#(idx._(gentag._210._(lib._scribblings/reference/reference..scrbl)))",[7,"'append"],false],
["append!",">srfi-std/srfi-1.html#append!",[0,[2,"append!"]],["srfi/1"]],
["append*",">reference/pairs.html#(def._((lib._racket/list..rkt)._append*))",[0,[2,"append*"]],["racket/list","racket"]],
["append-c-suffix",">dynext/Filenames.html#(def._((lib._dynext/file..rkt)._append-c-suffix))",[0,[2,"append-c-suffix"]],["dynext/file"]],
["append-column",">gui/list-box_.html#(meth._(((lib._mred/main..rkt)._list-box~25)._append-column))",[[0,[2,"append-column"]],[14,[" (method of ",[0,[2,"list-box%"]],")"]]],["racket/gui/base","racket/gui"]],
["append-constant-pool-suffix",">dynext/Filenames.html#(def._((lib._dynext/file..rkt)._append-constant-pool-suffix))",[0,[2,"append-constant-pool-suffix"]],["dynext/file"]],
["append-ec",">srfi-std/srfi-42.html#append-ec",[0,[1,"append-ec"]],["srfi/42"]],
["append-editor-font-menu-items",">gui/Editor_Functions.html#(def._((lib._mred/main..rkt)._append-editor-font-menu-items))",[0,[2,"append-editor-font-menu-items"]],["racket/gui/base","racket/gui"]],
["append-editor-operation-menu-items",">gui/Editor_Functions.html#(def._((lib._mred/main..rkt)._append-editor-operation-menu-items))",[0,[2,"append-editor-operation-menu-items"]],["racket/gui/base","racket/gui"]],
["append-extension-suffix",">dynext/Filenames.html#(def._((lib._dynext/file..rkt)._append-extension-suffix))",[0,[2,"append-extension-suffix"]],["dynext/file"]],
["append-headers",">net/head.html#(def._((lib._net/head..rkt)._append-headers))",[0,[2,"append-headers"]],["net/head"]],
["append-map",">reference/pairs.html#(def._((lib._racket/list..rkt)._append-map))",[0,[2,"append-map"]],["racket/list","racket"]],
["append-map",">srfi-std/srfi-1.html#append-map",[0,[2,"append-map"]],["srfi/1"]],
["append-map!",">srfi-std/srfi-1.html#append-map!",[0,[2,"append-map!"]],["srfi/1"]],
["append-object-suffix",">dynext/Filenames.html#(def._((lib._dynext/file..rkt)._append-object-suffix))",[0,[2,"append-object-suffix"]],["dynext/file"]],
["append-reverse",">srfi-std/srfi-1.html#append-reverse",[0,[2,"append-reverse"]],["srfi/1"]],
["append-reverse!",">srfi-std/srfi-1.html#append-reverse!",[0,[2,"append-reverse!"]],["srfi/1"]],
["append-zo-suffix",">dynext/Filenames.html#(def._((lib._dynext/file..rkt)._append-zo-suffix))",[0,[2,"append-zo-suffix"]],["dynext/file"]],
["applet",">html/index.html#(def._((lib._html/main..rkt)._applet))",[0,[2,"applet"]],["html"]],
["applet?",">html/index.html#(def._((lib._html/main..rkt)._applet~3f))",[0,[2,"applet?"]],["html"]],
["applicable structure",">reference/define-struct.html#(idx._(gentag._162._(lib._scribblings/reference/reference..scrbl)))","applicable structure",false],
["application",">framework/Application.html","Application",false],
["application",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._application))",[0,[2,"application"]],["compiler/zo-structs"]],
["application data",">drracket/drracket-files.html#(idx._(gentag._377._(lib._scribblings/drracket/drracket..scrbl)))",[6,"\"Application Data\""],false],
["application-about-handler",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._application-about-handler))",[0,[2,"application-about-handler"]],["racket/gui/base","racket/gui"]],
["application-file-handler",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._application-file-handler))",[0,[2,"application-file-handler"]],["racket/gui/base","racket/gui"]],
["application-preferences-handler",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._application-preferences-handler))",[0,[2,"application-preferences-handler"]],["racket/gui/base","racket/gui"]],
["application-quit-handler",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._application-quit-handler))",[0,[2,"application-quit-handler"]],["racket/gui/base","racket/gui"]],
["application-rands",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._application-rands))",[0,[2,"application-rands"]],["compiler/zo-structs"]],
["application-rator",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._application-rator))",[0,[2,"application-rator"]],["compiler/zo-structs"]],
["application-start-empty-handler",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._application-start-empty-handler))",[0,[2,"application-start-empty-handler"]],["racket/gui/base","racket/gui"]],
["application:current-app-name",">framework/Application.html#(def._((lib._framework/main..rkt)._application~3acurrent-app-name))",[0,[2,"application:current-app-name"]],["framework"]],
["application?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._application~3f))",[0,[2,"application?"]],["compiler/zo-structs"]],
["apply",">reference/procedures.html#(def._((lib._racket/private/base..rkt)._apply))",[0,[2,"apply"]],["racket/base","racket"]],
["apply",">r5rs-std/r5rs-Z-H-9.html#%_idx_578",[0,[2,"apply"]],["r5rs"]],
["apply",">r6rs-std/r6rs-Z-H-14.html#node_idx_752",[0,[2,"apply"]],["rnrs/base-6"]],
["apply",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._apply))",[0,[2,"apply"]],["lang/htdp-advanced"]],
["apply",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._apply))",[0,[2,"apply"]],["lang/htdp-intermediate"]],
["apply",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._apply))",[0,[2,"apply"]],["lang/htdp-intermediate-lambda"]],
["apply",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._apply))",[0,[2,"apply"]],["deinprogramm/DMdA-advanced"]],
["apply",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._apply))",[0,[2,"apply"]],["deinprogramm/DMdA-assignments"]],
["apply",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..rkt)._apply))",[0,[2,"apply"]],["mzscheme"]],
["apply-axis-transform",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._apply-axis-transform))",[0,[2,"apply-axis-transform"]],["plot"]],
["apply-reduction-relation",">redex/The_Redex_Reference.html#(def._((lib._redex/reduction-semantics..rkt)._apply-reduction-relation))",[0,[2,"apply-reduction-relation"]],["redex/reduction-semantics","redex"]],
["apply-reduction-relation*",">redex/The_Redex_Reference.html#(def._((lib._redex/reduction-semantics..rkt)._apply-reduction-relation*))",[0,[2,"apply-reduction-relation*"]],["redex/reduction-semantics","redex"]],
["apply-reduction-relation/tag-with-names",">redex/The_Redex_Reference.html#(def._((lib._redex/reduction-semantics..rkt)._apply-reduction-relation/tag-with-names))",[0,[2,"apply-reduction-relation/tag-with-names"]],["redex/reduction-semantics","redex"]],
["apply-values",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._apply-values))",[0,[2,"apply-values"]],["compiler/zo-structs"]],
["apply-values-args-expr",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._apply-values-args-expr))",[0,[2,"apply-values-args-expr"]],["compiler/zo-structs"]],
["apply-values-proc",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._apply-values-proc))",[0,[2,"apply-values-proc"]],["compiler/zo-structs"]],
["apply-values?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._apply-values~3f))",[0,[2,"apply-values?"]],["compiler/zo-structs"]],
["arc",">draw/dc-path_.html#(meth._(((lib._racket/draw..rkt)._dc-path~25)._arc))",[[0,[2,"arc"]],[14,[" (method of ",[0,[2,"dc-path%"]],")"]]],["racket/draw"]],
["arch",">unstable/pict.html#(def._((lib._unstable/gui/pict..rkt)._arch))",[0,[2,"arch"]],["unstable/gui/pict"]],
["archive-implies-reindex",">raco/setup-plt-plt.html#(sig-val._((lib._setup/option-sig..rkt)._setup-option~5e._archive-implies-reindex))",[0,[2,"archive-implies-reindex"]],["setup/option-sig"]],
["archives",">raco/setup-plt-plt.html#(sig-val._((lib._setup/option-sig..rkt)._setup-option~5e._archives))",[0,[2,"archives"]],["setup/option-sig"]],
["area",">html/index.html#(def._((lib._html/main..rkt)._area))",[0,[2,"area"]],["html"]],
["area",">gui/windowing-overview.html#(tech._area)","<span style=\"font-style: italic\">area</span>",false],
["area-container-window<%>",">gui/area-container-window___.html",[0,[2,"area-container-window<%>"]],["racket/gui/base","racket/gui"]],
["area-container<%>",">gui/area-container___.html",[0,[2,"area-container<%>"]],["racket/gui/base","racket/gui"]],
["area-histogram",">plot/renderer2d.html#(def._((lib._plot/main..rkt)._area-histogram))",[0,[2,"area-histogram"]],["plot"]],
["area<%>",">gui/area___.html",[0,[2,"area<%>"]],["racket/gui/base","racket/gui"]],
["area?",">html/index.html#(def._((lib._html/main..rkt)._area~3f))",[0,[2,"area?"]],["html"]],
["argb->bitmap",">mrlib/Cache-image_Snip.html#(def._((lib._mrlib/cache-image-snip..rkt)._argb-~3ebitmap))",[0,[2,"argb->bitmap"]],["mrlib/cache-image-snip"]],
["argb->cache-image-snip",">mrlib/Cache-image_Snip.html#(def._((lib._mrlib/cache-image-snip..rkt)._argb-~3ecache-image-snip))",[0,[2,"argb->cache-image-snip"]],["mrlib/cache-image-snip"]],
["argb->ico",">file/ico.html#(def._((lib._file/ico..rkt)._argb-~3eico))",[0,[2,"argb->ico"]],["file/ico"]],
["argb-height",">mrlib/Cache-image_Snip.html#(def._((lib._mrlib/cache-image-snip..rkt)._argb-height))",[0,[2,"argb-height"]],["mrlib/cache-image-snip"]],
["argb-vector",">mrlib/Cache-image_Snip.html#(def._((lib._mrlib/cache-image-snip..rkt)._argb-vector))",[0,[2,"argb-vector"]],["mrlib/cache-image-snip"]],
["argb-width",">mrlib/Cache-image_Snip.html#(def._((lib._mrlib/cache-image-snip..rkt)._argb-width))",[0,[2,"argb-width"]],["mrlib/cache-image-snip"]],
["argb?",">mrlib/Cache-image_Snip.html#(def._((lib._mrlib/cache-image-snip..rkt)._argb~3f))",[0,[2,"argb?"]],["mrlib/cache-image-snip"]],
["argmax",">reference/pairs.html#(def._((lib._racket/list..rkt)._argmax))",[0,[2,"argmax"]],["racket/list","racket"]],
["argmax",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._argmax))",[0,[2,"argmax"]],["lang/htdp-advanced"]],
["argmax",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._argmax))",[0,[2,"argmax"]],["lang/htdp-intermediate"]],
["argmax",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._argmax))",[0,[2,"argmax"]],["lang/htdp-intermediate-lambda"]],
["argmin",">reference/pairs.html#(def._((lib._racket/list..rkt)._argmin))",[0,[2,"argmin"]],["racket/list","racket"]],
["argmin",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._argmin))",[0,[2,"argmin"]],["lang/htdp-advanced"]],
["argmin",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._argmin))",[0,[2,"argmin"]],["lang/htdp-intermediate"]],
["argmin",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._argmin))",[0,[2,"argmin"]],["lang/htdp-intermediate-lambda"]],
["argument and result dependencies",">guide/contracts-general-functions.html#(part._contracts-arrow-d)","Argument and Result Dependencies",false],
["arithmetic",">reference/generic-numbers.html#(part._.Arithmetic)","Arithmetic",false],
["arithmetic-shift",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._arithmetic-shift))",[0,[2,"arithmetic-shift"]],["racket/base","racket"]],
["arity",">inside/Procedures.html#(idx._(gentag._286._(lib._scribblings/inside/inside..scrbl)))",[0,"arity"],false],
["arity-at-least",">reference/procedures.html#(def._((lib._racket/private/base..rkt)._arity-at-least))",[0,[2,"arity-at-least"]],["racket/base","racket"]],
["arity-at-least-value",">reference/procedures.html#(def._((quote._~23~25kernel)._arity-at-least-value))",[0,[2,"arity-at-least-value"]],["racket/base","racket"]],
["arity-at-least?",">reference/procedures.html#(def._((quote._~23~25kernel)._arity-at-least~3f))",[0,[2,"arity-at-least?"]],["racket/base","racket"]],
["arity-sensitive functions: case-lambda",">guide/lambda.html#(part._case-lambda)",["Arity-Sensitive Functions: ",[0,[1,"case-lambda"]]],false],
["armed",">reference/stxcerts.html#(tech._armed)","<span style=\"font-style: italic\">armed</span>",false],
["arms",">guide/stx-certs.html#(tech._arm)","<span style=\"font-style: italic\">arms</span>",false],
["around",">rackunit/api.html#(form._((lib._rackunit/main..rkt)._around))",[0,[1,"around"]],["rackunit"]],
["arrange files into a directory",">planet/Developing_Packages_for_PLaneT.html#(part._.Arrange_.Files_.Into_a_.Directory)","Arrange Files Into a Directory",false],
["array",">srfi-std/srfi-25.html#array",[0,[2,"array"]],["srfi/25"]],
["array-end",">srfi-std/srfi-25.html#array-end",[0,[2,"array-end"]],["srfi/25"]],
["array-length",">foreign/C_Array_Types.html#(def._((lib._ffi/unsafe..rkt)._array-length))",[0,[2,"array-length"]],["ffi/unsafe"]],
["array-ptr",">foreign/C_Array_Types.html#(def._((lib._ffi/unsafe..rkt)._array-ptr))",[0,[2,"array-ptr"]],["ffi/unsafe"]],
["array-rank",">srfi-std/srfi-25.html#array-rank",[0,[2,"array-rank"]],["srfi/25"]],
["array-ref",">foreign/C_Array_Types.html#(def._((lib._ffi/unsafe..rkt)._array-ref))",[0,[2,"array-ref"]],["ffi/unsafe"]],
["array-ref",">srfi-std/srfi-25.html#array-ref",[0,[2,"array-ref"]],["srfi/25"]],
["array-set!",">foreign/C_Array_Types.html#(def._((lib._ffi/unsafe..rkt)._array-set!))",[0,[2,"array-set!"]],["ffi/unsafe"]],
["array-set!",">srfi-std/srfi-25.html#array-set!",[0,[2,"array-set!"]],["srfi/25"]],
["array-start",">srfi-std/srfi-25.html#array-start",[0,[2,"array-start"]],["srfi/25"]],
["array?",">foreign/C_Array_Types.html#(def._((lib._ffi/unsafe..rkt)._array~3f))",[0,[2,"array?"]],["ffi/unsafe"]],
["array?",">srfi-std/srfi-25.html#array-p",[0,[2,"array?"]],["srfi/25"]],
["arrow",">slideshow/Basic_Pict_Constructors.html#(def._((lib._slideshow/pict..rkt)._arrow))",[0,[2,"arrow"]],["slideshow/pict","slideshow"]],
["arrow icons",">images/Icons.html#(part._arrows)","Arrow Icons",false],
["arrow teachpack",">teachpack/arrow.html#(idx._(gentag._9._(lib._teachpack/teachpack..scrbl)))","arrow teachpack",false],
["arrow->pict",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._arrow-~3epict))",[0,[2,"arrow->pict"]],["redex/pict","redex"]],
["arrow-gui teachpack",">teachpack/arrow-gui.html#(idx._(gentag._14._(lib._teachpack/teachpack..scrbl)))","arrow-gui teachpack",false],
["arrow-space",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._arrow-space))",[0,[2,"arrow-space"]],["redex/pict","redex"]],
["arrowhead",">slideshow/Basic_Pict_Constructors.html#(def._((lib._slideshow/pict..rkt)._arrowhead))",[0,[2,"arrowhead"]],["slideshow/pict","slideshow"]],
["article-not-found",">net/nntp.html#(def._((lib._net/nntp..rkt)._article-not-found))",[0,[2,"article-not-found"]],["net/nntp"]],
["article-not-found-article",">net/nntp.html#(def._((lib._net/nntp..rkt)._article-not-found-article))",[0,[2,"article-not-found-article"]],["net/nntp"]],
["article-not-found?",">net/nntp.html#(def._((lib._net/nntp..rkt)._article-not-found~3f))",[0,[2,"article-not-found?"]],["net/nntp"]],
["article-not-in-group",">net/nntp.html#(def._((lib._net/nntp..rkt)._article-not-in-group))",[0,[2,"article-not-in-group"]],["net/nntp"]],
["article-not-in-group-article",">net/nntp.html#(def._((lib._net/nntp..rkt)._article-not-in-group-article))",[0,[2,"article-not-in-group-article"]],["net/nntp"]],
["article-not-in-group?",">net/nntp.html#(def._((lib._net/nntp..rkt)._article-not-in-group~3f))",[0,[2,"article-not-in-group?"]],["net/nntp"]],
["as",">unstable/match.html#(form._((lib._unstable/match..rkt)._as))",[0,[1,"as"]],["unstable/match"]],
["as-index",">scribble/base.html#(def._((lib._scribble/base..rkt)._as-index))",[0,[2,"as-index"]],["scribble/base"]],
["asin",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._asin))",[0,[2,"asin"]],["racket/base","racket"]],
["asin",">r5rs-std/r5rs-Z-H-9.html#%_idx_336",[0,[2,"asin"]],["r5rs"]],
["asin",">r6rs-std/r6rs-Z-H-14.html#node_idx_552",[0,[2,"asin"]],["rnrs/base-6"]],
["asin",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._asin))",[0,[2,"asin"]],["lang/htdp-advanced"]],
["asin",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._asin))",[0,[2,"asin"]],["lang/htdp-beginner"]],
["asin",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._asin))",[0,[2,"asin"]],["lang/htdp-beginner-abbr"]],
["asin",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._asin))",[0,[2,"asin"]],["lang/htdp-intermediate"]],
["asin",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._asin))",[0,[2,"asin"]],["lang/htdp-intermediate-lambda"]],
["asin",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._asin))",[0,[2,"asin"]],["deinprogramm/DMdA-advanced"]],
["asin",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._asin))",[0,[2,"asin"]],["deinprogramm/DMdA-assignments"]],
["asin",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._asin))",[0,[2,"asin"]],["deinprogramm/DMdA-beginner"]],
["asin",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._asin))",[0,[2,"asin"]],["deinprogramm/DMdA-vanilla"]],
["ask-normalize?",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3anormalize-paste~3c~25~3e)._ask-normalize~3f))",[[0,[2,"ask-normalize?"]],[14,[" (method of ",[0,[2,"text:normalize-paste<%>"]],")"]]],["framework"]],
["assemble-address-field",">net/head.html#(def._((lib._net/head..rkt)._assemble-address-field))",[0,[2,"assemble-address-field"]],["net/head"]],
["assemble-distribution",">raco/exe-dist.html#(def._((lib._compiler/distribute..rkt)._assemble-distribution))",[0,[2,"assemble-distribution"]],["compiler/distribute"]],
["assert",">r6rs-std/r6rs-Z-H-14.html#node_idx_750",[0,[1,"assert"]],["rnrs/base-6"]],
["assert",">ts-reference/Utilities.html#(def._((lib._typed-racket/base-env/extra-procs..rkt)._assert))",[0,[2,"assert"]],["typed/racket/base","typed/racket"]],
["asserting extra clauses",">racklog/predicates.html#(part._assert)","Asserting Extra Clauses",false],
["assertion-violation",">r6rs-std/r6rs-Z-H-14.html#node_idx_748",[0,[2,"assertion-violation"]],["rnrs/base-6"]],
["assertion-violation?",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_442",[0,[2,"assertion-violation?"]],["rnrs/conditions-6"]],
["assertions",">guide/regexp-assert.html#(tech._assertion)","<span style=\"font-style: italic\">assertions</span>",false],
["assf",">reference/pairs.html#(def._((lib._racket/private/list..rkt)._assf))",[0,[2,"assf"]],["racket/base","racket"]],
["assf",">lazy/index.html#(def._((lib._lazy/main..rkt)._assf))",[0,[2,"assf"]],["lazy"]],
["assign",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._assign))",[0,[2,"assign"]],["compiler/zo-structs"]],
["assign-id",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._assign-id))",[0,[2,"assign-id"]],["compiler/zo-structs"]],
["assign-rhs",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._assign-rhs))",[0,[2,"assign-rhs"]],["compiler/zo-structs"]],
["assign-undef-ok?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._assign-undef-ok~3f))",[0,[2,"assign-undef-ok?"]],["compiler/zo-structs"]],
["assign?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._assign~3f))",[0,[2,"assign?"]],["compiler/zo-structs"]],
["assignment and redefinition",">guide/module-set.html","Assignment and Redefinition",false],
["assignment transformers",">reference/syntax-model.html#(tech._assignment._transformer)","<span style=\"font-style: italic\">assignment transformers</span>",false],
["assignment: set!",">guide/set_.html",["Assignment: ",[0,[1,"set!"]]],false],
["assignment: set! and set!-values",">reference/set_.html",["Assignment: ",[0,[1,"set!"]]," and ",[0,[1,"set!-values"]]],false],
["assoc",">reference/pairs.html#(def._((lib._racket/private/list..rkt)._assoc))",[0,[2,"assoc"]],["racket/base","racket"]],
["assoc",">r5rs-std/r5rs-Z-H-9.html#%_idx_456",[0,[2,"assoc"]],["r5rs"]],
["assoc",">r6rs-lib-std/r6rs-lib-Z-H-4.html#node_idx_234",[0,[2,"assoc"]],["rnrs/lists-6"]],
["assoc",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._assoc))",[0,[2,"assoc"]],["lang/htdp-advanced"]],
["assoc",">lazy/index.html#(def._((lib._lazy/main..rkt)._assoc))",[0,[2,"assoc"]],["lazy"]],
["assoc",">srfi-std/srfi-1.html#assoc",[0,[2,"assoc"]],["srfi/1"]],
["association list",">reference/dicts.html#(tech._association._list)","<span style=\"font-style: italic\">association\nlist</span>",false],
["assp",">r6rs-lib-std/r6rs-lib-Z-H-4.html#node_idx_232",[0,[2,"assp"]],["rnrs/lists-6"]],
["assq",">reference/pairs.html#(def._((lib._racket/private/list..rkt)._assq))",[0,[2,"assq"]],["racket/base","racket"]],
["assq",">r5rs-std/r5rs-Z-H-9.html#%_idx_452",[0,[2,"assq"]],["r5rs"]],
["assq",">r6rs-lib-std/r6rs-lib-Z-H-4.html#node_idx_238",[0,[2,"assq"]],["rnrs/lists-6"]],
["assq",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._assq))",[0,[2,"assq"]],["lang/htdp-advanced"]],
["assq",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._assq))",[0,[2,"assq"]],["lang/htdp-beginner"]],
["assq",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._assq))",[0,[2,"assq"]],["lang/htdp-beginner-abbr"]],
["assq",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._assq))",[0,[2,"assq"]],["lang/htdp-intermediate"]],
["assq",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._assq))",[0,[2,"assq"]],["lang/htdp-intermediate-lambda"]],
["assq",">lazy/index.html#(def._((lib._lazy/main..rkt)._assq))",[0,[2,"assq"]],["lazy"]],
["assq",">srfi-std/srfi-1.html#assq",[0,[2,"assq"]],["srfi/1"]],
["assv",">reference/pairs.html#(def._((lib._racket/private/list..rkt)._assv))",[0,[2,"assv"]],["racket/base","racket"]],
["assv",">r5rs-std/r5rs-Z-H-9.html#%_idx_454",[0,[2,"assv"]],["r5rs"]],
["assv",">r6rs-lib-std/r6rs-lib-Z-H-4.html#node_idx_236",[0,[2,"assv"]],["rnrs/lists-6"]],
["assv",">lazy/index.html#(def._((lib._lazy/main..rkt)._assv))",[0,[2,"assv"]],["lazy"]],
["assv",">srfi-std/srfi-1.html#assv",[0,[2,"assv"]],["srfi/1"]],
["async bidirectional channels",">reference/distributed-places.html#(part._.Async_.Bidirectional_.Channels)","Async Bidirectional Channels",false],
["async-bi-channel-get",">reference/distributed-places.html#(def._((lib._racket/place/private/async-bi-channel..rkt)._async-bi-channel-get))",[0,[2,"async-bi-channel-get"]],["racket/place/private/async-bi-channel"]],
["async-bi-channel-put",">reference/distributed-places.html#(def._((lib._racket/place/private/async-bi-channel..rkt)._async-bi-channel-put))",[0,[2,"async-bi-channel-put"]],["racket/place/private/async-bi-channel"]],
["async-bi-channel?",">reference/distributed-places.html#(def._((lib._racket/place/private/async-bi-channel..rkt)._async-bi-channel~3f))",[0,[2,"async-bi-channel?"]],["racket/place/private/async-bi-channel"]],
["async-channel-get",">reference/async-channel.html#(def._((lib._racket/async-channel..rkt)._async-channel-get))",[0,[2,"async-channel-get"]],["racket/async-channel"]],
["async-channel-put",">reference/async-channel.html#(def._((lib._racket/async-channel..rkt)._async-channel-put))",[0,[2,"async-channel-put"]],["racket/async-channel"]],
["async-channel-put-evt",">reference/async-channel.html#(def._((lib._racket/async-channel..rkt)._async-channel-put-evt))",[0,[2,"async-channel-put-evt"]],["racket/async-channel"]],
["async-channel-try-get",">reference/async-channel.html#(def._((lib._racket/async-channel..rkt)._async-channel-try-get))",[0,[2,"async-channel-try-get"]],["racket/async-channel"]],
["async-channel?",">reference/async-channel.html#(def._((lib._racket/async-channel..rkt)._async-channel~3f))",[0,[2,"async-channel?"]],["racket/async-channel"]],
["at-end",">unstable/Definitions.html#(form._((lib._unstable/define..rkt)._at-end))",[0,[1,"at-end"]],["unstable/define"]],
["at-exp",">scribble/reader-internals.html#(mod-path._at-exp)",[9,[0,"at-exp"]],"module"],
["at-find-pict",">unstable/ppict.html#(def._((lib._unstable/gui/ppict..rkt)._at-find-pict))",[0,[2,"at-find-pict"]],["unstable/gui/ppict"]],
["atan",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._atan))",[0,[2,"atan"]],["racket/base","racket"]],
["atan",">r5rs-std/r5rs-Z-H-9.html#%_idx_342",[0,[2,"atan"]],["r5rs"]],
["atan",">r6rs-std/r6rs-Z-H-14.html#node_idx_556",[0,[2,"atan"]],["rnrs/base-6"]],
["atan",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._atan))",[0,[2,"atan"]],["lang/htdp-advanced"]],
["atan",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._atan))",[0,[2,"atan"]],["lang/htdp-beginner"]],
["atan",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._atan))",[0,[2,"atan"]],["lang/htdp-beginner-abbr"]],
["atan",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._atan))",[0,[2,"atan"]],["lang/htdp-intermediate"]],
["atan",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._atan))",[0,[2,"atan"]],["lang/htdp-intermediate-lambda"]],
["atan",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._atan))",[0,[2,"atan"]],["deinprogramm/DMdA-advanced"]],
["atan",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._atan))",[0,[2,"atan"]],["deinprogramm/DMdA-assignments"]],
["atan",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._atan))",[0,[2,"atan"]],["deinprogramm/DMdA-beginner"]],
["atan",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._atan))",[0,[2,"atan"]],["deinprogramm/DMdA-vanilla"]],
["atom?",">teachpack/docs.html#(def._((lib._htdp/docs..rkt)._atom~3f))",[0,[2,"atom?"]],["htdp/docs"]],
["atom?",">mzlib/mzlib_compat.html#(def._((lib._mzlib/compat..rkt)._atom~3f))",[0,[2,"atom?"]],["mzlib/compat"]],
["atom?",">racklog/glossary.html#(def._((lib._racklog/main..rkt)._atom~3f))",[0,[2,"atom?"]],["racklog"]],
["atomic",">foreign/foreign_pointer-funcs.html#(idx._(gentag._6._(lib._scribblings/foreign/foreign..scrbl)))",[7,"'atomic"],false],
["atomic",">draw/region_.html#(tech._atomic)","<span style=\"font-style: italic\">atomic</span>",false],
["atomic execution",">foreign/Atomic_Execution.html","Atomic Execution",false],
["atomic-interior",">foreign/foreign_pointer-funcs.html#(idx._(gentag._11._(lib._scribblings/foreign/foreign..scrbl)))",[7,"'atomic-interior"],false],
["atomic-struct?",">racklog/glossary.html#(def._((lib._racklog/main..rkt)._atomic-struct~3f))",[0,[2,"atomic-struct?"]],["racklog"]],
["attached",">guide/mk-namespace.html#(tech._attached)","<span style=\"font-style: italic\">attached</span>",false],
["attaching contracts to values",">reference/attaching-contracts-to-values.html","Attaching Contracts to Values",false],
["attaching documentation to exports",">syntax/docprovide.html","Attaching Documentation to Exports",false],
["attribute",">syntax/stxparse-specifying.html#(form._((lib._syntax/parse..rkt)._attribute))",[0,[1,"attribute"]],["syntax/parse"]],
["attribute",">xml/index.html#(def._((lib._xml/main..rkt)._attribute))",[0,[2,"attribute"]],["xml"]],
["attribute",">syntax/stxparse-specifying.html#(tech._attribute)","<span style=\"font-style: italic\">attribute</span>",false],
["attribute-name",">xml/index.html#(def._((lib._xml/main..rkt)._attribute-name))",[0,[2,"attribute-name"]],["xml"]],
["attribute-value",">xml/index.html#(def._((lib._xml/main..rkt)._attribute-value))",[0,[2,"attribute-value"]],["xml"]],
["attribute?",">xml/index.html#(def._((lib._xml/main..rkt)._attribute~3f))",[0,[2,"attribute?"]],["xml"]],
["attributes",">scribble/core.html#(def._((lib._scribble/html-properties..rkt)._attributes))",[0,[2,"attributes"]],["scribble/html-properties"]],
["attributes-assoc",">scribble/core.html#(def._((lib._scribble/html-properties..rkt)._attributes-assoc))",[0,[2,"attributes-assoc"]],["scribble/html-properties"]],
["attributes?",">scribble/core.html#(def._((lib._scribble/html-properties..rkt)._attributes~3f))",[0,[2,"attributes?"]],["scribble/html-properties"]],
["augment",">reference/createclass.html#(form._((lib._racket/private/class-internal..rkt)._augment))",[0,[1,"augment"]],["racket/class","racket"]],
["augment*",">reference/createclass.html#(form._((lib._racket/private/class-internal..rkt)._augment*))",[0,[1,"augment*"]],["racket/class","racket"]],
["augment-final",">reference/createclass.html#(form._((lib._racket/private/class-internal..rkt)._augment-final))",[0,[1,"augment-final"]],["racket/class","racket"]],
["augment-final*",">reference/createclass.html#(form._((lib._racket/private/class-internal..rkt)._augment-final*))",[0,[1,"augment-final*"]],["racket/class","racket"]],
["augmenting",">reference/mzlib_class.html#(tech._augmenting)","<span style=\"font-style: italic\">augmenting</span>",false],
["augmenting information on check failure",">rackunit/api.html#(part._.Augmenting_.Information_on_.Check_.Failure)","Augmenting Information on Check Failure",false],
["augride",">reference/createclass.html#(form._((lib._racket/private/class-internal..rkt)._augride))",[0,[1,"augride"]],["racket/class","racket"]],
["augride*",">reference/createclass.html#(form._((lib._racket/private/class-internal..rkt)._augride*))",[0,[1,"augride*"]],["racket/class","racket"]],
["authenticate-user",">net/nntp.html#(def._((lib._net/nntp..rkt)._authenticate-user))",[0,[2,"authenticate-user"]],["net/nntp"]],
["authenticate/plain-text",">net/pop3.html#(def._((lib._net/pop3..rkt)._authenticate/plain-text))",[0,[2,"authenticate/plain-text"]],["net/pop3"]],
["authentication-message",">web-server-internal/Web_Servers.html#(idx._(gentag._11._(lib._web-server/scribblings/web-server-internal..scrbl)))","authentication-message",false],
["authentication-rejected",">net/nntp.html#(def._((lib._net/nntp..rkt)._authentication-rejected))",[0,[2,"authentication-rejected"]],["net/nntp"]],
["authentication-rejected?",">net/nntp.html#(def._((lib._net/nntp..rkt)._authentication-rejected~3f))",[0,[2,"authentication-rejected?"]],["net/nntp"]],
["author",">scribble/base.html#(def._((lib._scribble/base..rkt)._author))",[0,[2,"author"]],["scribble/base"]],
["author",">scribble/JFP_Paper_Format.html#(def._((lib._scribble/jfp..rkt)._author))",[0,[2,"author"]],["scribble/jfp"]],
["author+date-style",">scriblib/autobib.html#(def._((lib._scriblib/autobib..rkt)._author+date-style))",[0,[2,"author+date-style"]],["scriblib/autobib"]],
["author+email",">scribble/base.html#(def._((lib._scribble/base..rkt)._author+email))",[0,[2,"author+email"]],["scribble/base"]],
["author-name",">scriblib/autobib.html#(def._((lib._scriblib/autobib..rkt)._author-name))",[0,[2,"author-name"]],["scriblib/autobib"]],
["author/short",">scribble/JFP_Paper_Format.html#(def._((lib._scribble/jfp..rkt)._author/short))",[0,[2,"author/short"]],["scribble/jfp"]],
["authorinfo",">scribble/SIGPLAN_Paper_Format.html#(def._((lib._scribble/sigplan..rkt)._authorinfo))",[0,[2,"authorinfo"]],["scribble/sigplan"]],
["authorized?/c",">web-server-internal/dispatch-passwords.html#(def._((lib._web-server/dispatchers/dispatch-passwords..rkt)._authorized~3f/c))",[0,[2,"authorized?/c"]],["web-server/dispatchers/dispatch-passwords"]],
["authors",">scribble/LNCS_Paper_Format.html#(form._((lib._scribble/lncs/lang..rkt)._authors))",[0,[1,"authors"]],["scribble/lncs"]],
["authors",">scriblib/autobib.html#(def._((lib._scriblib/autobib..rkt)._authors))",[0,[2,"authors"]],["scriblib/autobib"]],
["auto-complete",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3aautocomplete~3c~25~3e)._auto-complete))",[[0,[2,"auto-complete"]],[14,[" (method of ",[0,[2,"text:autocomplete<%>"]],")"]]],["framework"]],
["auto-play",">games/gobblet.html#(part._.Auto-.Play)","Auto-Play",false],
["auto-resize",">gui/message_.html#(meth._(((lib._mred/main..rkt)._message~25)._auto-resize))",[[0,[2,"auto-resize"]],[14,[" (method of ",[0,[2,"message%"]],")"]]],["racket/gui/base","racket/gui"]],
["auto-wrap",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._auto-wrap))",[[0,[2,"auto-wrap"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["automata: compiling state machines",">unstable/Automata__Compiling_State_Machines.html","Automata: Compiling State Machines",false],
["automatic fields",">reference/structures.html#(tech._automatic._field)","<span style=\"font-style: italic\">automatic fields</span>",false],
["automatic parenthesis",">drracket/editor.html#(idx._(gentag._22._(lib._scribblings/drracket/drracket..scrbl)))","automatic\nparenthesis",false],
["autosave",">framework/Autosave.html","Autosave",false],
["autosave:autosavable<%>",">framework/Autosave.html#(def._((lib._framework/main..rkt)._autosave~3aautosavable~3c~25~3e))",[0,[2,"autosave:autosavable<%>"]],["framework"]],
["autosave:register",">framework/Autosave.html#(def._((lib._framework/main..rkt)._autosave~3aregister))",[0,[2,"autosave:register"]],["framework"]],
["autosave:restore-autosave-files/gui",">framework/Autosave.html#(def._((lib._framework/main..rkt)._autosave~3arestore-autosave-files/gui))",[0,[2,"autosave:restore-autosave-files/gui"]],["framework"]],
["autosave:toc-path",">framework/Autosave.html#(def._((lib._framework/main..rkt)._autosave~3atoc-path))",[0,[2,"autosave:toc-path"]],["framework"]],
["autosave?",">framework/Editor.html#(meth._(((lib._framework/main..rkt)._editor~3abackup-autosave~3c~25~3e)._autosave~3f))",[[0,[2,"autosave?"]],[14,[" (method of ",[0,[2,"editor:backup-autosave<%>"]],")"]]],["framework"]],
["aux",">reference/windowspaths.html#(idx._(gentag._242._(lib._scribblings/reference/reference..scrbl)))",[6,"\"AUX\""],false],
["aux-elem",">scribble/doc-strings.html#(def._((lib._scribble/manual..rkt)._aux-elem))",[0,[2,"aux-elem"]],["scribble/manual"]],
["auxiliary-table?",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._auxiliary-table~3f))",[0,[2,"auxiliary-table?"]],["scribble/struct"]],
["available",">reference/eval-model.html#(tech._available)","<span style=\"font-style: italic\">available</span>",false],
["available-gracket-variants",">raco/exe.html#(def._((lib._launcher/launcher..rkt)._available-gracket-variants))",[0,[2,"available-gracket-variants"]],["launcher/launcher"]],
["available-mred-variants",">raco/exe.html#(def._((lib._launcher/launcher..rkt)._available-mred-variants))",[0,[2,"available-mred-variants"]],["launcher/launcher"]],
["available-mzscheme-variants",">raco/exe.html#(def._((lib._launcher/launcher..rkt)._available-mzscheme-variants))",[0,[2,"available-mzscheme-variants"]],["launcher/launcher"]],
["available-racket-variants",">raco/exe.html#(def._((lib._launcher/launcher..rkt)._available-racket-variants))",[0,[2,"available-racket-variants"]],["launcher/launcher"]],
["avoid-main-installation",">raco/setup-plt-plt.html#(sig-val._((lib._setup/option-sig..rkt)._setup-option~5e._avoid-main-installation))",[0,[2,"avoid-main-installation"]],["setup/option-sig"]],
["awk",">mzlib/mzlib_awk.html#(form._((lib._mzlib/awk..rkt)._awk))",[0,[1,"awk"]],["mzlib/awk"]],
["axes",">plot/renderer2d.html#(def._((lib._plot/main..rkt)._axes))",[0,[2,"axes"]],["plot"]],
["axis ticks",">plot/ticks_and_transforms.html#(part._ticks)","Axis Ticks",false],
["axis transforms",">plot/ticks_and_transforms.html#(part._transforms)","Axis Transforms",false],
["axis transforms and ticks",">plot/ticks_and_transforms.html","Axis Transforms and Ticks",false],
["axis-transform-append",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._axis-transform-append))",[0,[2,"axis-transform-append"]],["plot"]],
["axis-transform-bound",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._axis-transform-bound))",[0,[2,"axis-transform-bound"]],["plot"]],
["axis-transform-compose",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._axis-transform-compose))",[0,[2,"axis-transform-compose"]],["plot"]],
["axis-transform/c",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._axis-transform/c))",[0,[2,"axis-transform/c"]],["plot"]],
["b",">html/index.html#(def._((lib._html/main..rkt)._b))",[0,[2,"b"]],["html"]],
["b?",">html/index.html#(def._((lib._html/main..rkt)._b~3f))",[0,[2,"b?"]],["html"]],
["back-icon",">images/Icons.html#(def._((lib._images/icons/control..rkt)._back-icon))",[0,[2,"back-icon"]],["images/icons/control"]],
["background",">teachpack/2htdpuniverse.html#(part._scene)","Background",false],
["background color",">framework/Canvas.html#(idx._(gentag._0._(lib._scribblings/framework/framework..scrbl)))","background color",false],
["background-color-property",">scribble/core.html#(def._((lib._scribble/core..rkt)._background-color-property))",[0,[2,"background-color-property"]],["scribble/core"]],
["background-color-property-color",">scribble/core.html#(def._((lib._scribble/core..rkt)._background-color-property-color))",[0,[2,"background-color-property-color"]],["scribble/core"]],
["background-color-property?",">scribble/core.html#(def._((lib._scribble/core..rkt)._background-color-property~3f))",[0,[2,"background-color-property?"]],["scribble/core"]],
["background-play-sound-file",">deinprogramm/sound.html#(def._((lib._teachpack/deinprogramm/sound..rkt)._background-play-sound-file))",[0,[2,"background-play-sound-file"]],["teachpack/deinprogramm/sound"]],
["backreference",">guide/regexp-clusters.html#(tech._backreference)","<span style=\"font-style: italic\">backreference</span>",false],
["backreferences",">guide/regexp-clusters.html#(part._.Backreferences)","Backreferences",false],
["backtracking",">racklog/backtracking.html","Backtracking",false],
["backtracking",">guide/Backtracking.html","Backtracking",false],
["backtracking",">guide/Backtracking.html#(tech._backtracking)","<span style=\"font-style: italic\">backtracking</span>",false],
["backup and autosave files",">drracket/drracket-files.html#(part._drracket-autosave-files)","Backup and Autosave Files",false],
["backup?",">framework/Editor.html#(meth._(((lib._framework/main..rkt)._editor~3abackup-autosave~3c~25~3e)._backup~3f))",[[0,[2,"backup?"]],[14,[" (method of ",[0,[2,"editor:backup-autosave<%>"]],")"]]],["framework"]],
["backward-containing-sexp",">framework/Color.html#(meth._(((lib._framework/main..rkt)._color~3atext~3c~25~3e)._backward-containing-sexp))",[[0,[2,"backward-containing-sexp"]],[14,[" (method of ",[0,[2,"color:text<%>"]],")"]]],["framework"]],
["backward-kill-word",">framework/Keymap.html#(idx._(gentag._27._(lib._scribblings/framework/framework..scrbl)))","backward-kill-word",false],
["backward-match",">framework/Color.html#(meth._(((lib._framework/main..rkt)._color~3atext~3c~25~3e)._backward-match))",[[0,[2,"backward-match"]],[14,[" (method of ",[0,[2,"color:text<%>"]],")"]]],["framework"]],
["backward-sexp",">framework/Racket.html#(meth._(((lib._framework/main..rkt)._racket~3atext~3c~25~3e)._backward-sexp))",[[0,[2,"backward-sexp"]],[14,[" (method of ",[0,[2,"racket:text<%>"]],")"]]],["framework"]],
["backwards compatibility",">framework/Backwards_Compatibility.html","Backwards Compatibility",false],
["backwards compatibility",">tools/Backwards_compatibility.html","Backwards compatibility",false],
["bad-newsgroup-line",">net/nntp.html#(def._((lib._net/nntp..rkt)._bad-newsgroup-line))",[0,[2,"bad-newsgroup-line"]],["net/nntp"]],
["bad-newsgroup-line-line",">net/nntp.html#(def._((lib._net/nntp..rkt)._bad-newsgroup-line-line))",[0,[2,"bad-newsgroup-line-line"]],["net/nntp"]],
["bad-newsgroup-line?",">net/nntp.html#(def._((lib._net/nntp..rkt)._bad-newsgroup-line~3f))",[0,[2,"bad-newsgroup-line?"]],["net/nntp"]],
["bad-status-line",">net/nntp.html#(def._((lib._net/nntp..rkt)._bad-status-line))",[0,[2,"bad-status-line"]],["net/nntp"]],
["bad-status-line-line",">net/nntp.html#(def._((lib._net/nntp..rkt)._bad-status-line-line))",[0,[2,"bad-status-line-line"]],["net/nntp"]],
["bad-status-line?",">net/nntp.html#(def._((lib._net/nntp..rkt)._bad-status-line~3f))",[0,[2,"bad-status-line?"]],["net/nntp"]],
["bad?",">gui/editor-stream-in-base_.html#(meth._(((lib._mred/main..rkt)._editor-stream-in-base~25)._bad~3f))",[[0,[2,"bad?"]],[14,[" (method of ",[0,[2,"editor-stream-in-base%"]],")"]]],["racket/gui/base","racket/gui"]],
["bad?",">gui/editor-stream-out-base_.html#(meth._(((lib._mred/main..rkt)._editor-stream-out-base~25)._bad~3f))",[[0,[2,"bad?"]],[14,[" (method of ",[0,[2,"editor-stream-out-base%"]],")"]]],["racket/gui/base","racket/gui"]],
["balance-parens",">framework/Racket.html#(meth._(((lib._framework/main..rkt)._racket~3atext~3c~25~3e)._balance-parens))",[[0,[2,"balance-parens"]],[14,[" (method of ",[0,[2,"racket:text<%>"]],")"]]],["framework"]],
["balloon",">slideshow/More_Pict_Constructors.html#(def._((lib._slideshow/balloon..rkt)._balloon))",[0,[2,"balloon"]],["slideshow/balloon"]],
["balloon annotations",">slideshow/More_Pict_Constructors.html#(part._.Balloon_.Annotations)","Balloon Annotations",false],
["balloon-color",">slideshow/More_Pict_Constructors.html#(def._((lib._slideshow/balloon..rkt)._balloon-color))",[0,[2,"balloon-color"]],["slideshow/balloon"]],
["balloon-pict",">slideshow/More_Pict_Constructors.html#(def._((lib._slideshow/balloon..rkt)._balloon-pict))",[0,[2,"balloon-pict"]],["slideshow/balloon"]],
["balloon-point-x",">slideshow/More_Pict_Constructors.html#(def._((lib._slideshow/balloon..rkt)._balloon-point-x))",[0,[2,"balloon-point-x"]],["slideshow/balloon"]],
["balloon-point-y",">slideshow/More_Pict_Constructors.html#(def._((lib._slideshow/balloon..rkt)._balloon-point-y))",[0,[2,"balloon-point-y"]],["slideshow/balloon"]],
["balloon?",">slideshow/More_Pict_Constructors.html#(def._((lib._slideshow/balloon..rkt)._balloon~3f))",[0,[2,"balloon?"]],["slideshow/balloon"]],
["banner",">reference/runtime.html#(def._((quote._~23~25kernel)._banner))",[0,[2,"banner"]],["racket/base","racket"]],
["bar-icon",">images/Icons.html#(def._((lib._images/icons/control..rkt)._bar-icon))",[0,[2,"bar-icon"]],["images/icons/control"]],
["base",">html/index.html#(def._((lib._html/main..rkt)._base))",[0,[2,"base"]],["html"]],
["base",">gui/style-delta_.html#(idx._(gentag._175._(lib._scribblings/gui/gui..scrbl)))",[7,"'base"],false],
["base",">gui/style-delta_.html#(idx._(gentag._179._(lib._scribblings/gui/gui..scrbl)))",[7,"'base"],false],
["base",">gui/style-delta_.html#(idx._(gentag._183._(lib._scribblings/gui/gui..scrbl)))",[7,"'base"],false],
["base",">gui/style-delta_.html#(idx._(gentag._188._(lib._scribblings/gui/gui..scrbl)))",[7,"'base"],false],
["base",">gui/style-delta_.html#(idx._(gentag._192._(lib._scribblings/gui/gui..scrbl)))",[7,"'base"],false],
["base",">gui/style-delta_.html#(idx._(gentag._193._(lib._scribblings/gui/gui..scrbl)))",[7,"'base"],false],
["base",">gui/style-delta_.html#(idx._(gentag._194._(lib._scribblings/gui/gui..scrbl)))",[7,"'base"],false],
["base 64: encoding and decoding",">net/base64.html","Base 64: Encoding and Decoding",false],
["base connections",">db/connect.html#(part._creating-connections)","Base Connections",false],
["base document format",">scribble/base.html","Base Document Format",false],
["base environment",">reference/syntax-model.html#(tech._base._environment)","<span style=\"font-style: italic\">base environment</span>",false],
["base phase",">reference/syntax-model.html#(tech._base._phase)","<span style=\"font-style: italic\">base phase</span>",false],
["base renderer",">scribble/renderer.html#(part._.Base_.Renderer)","Base Renderer",false],
["base types",">ts-reference/type-ref.html#(part._.Base_.Types)","Base Types",false],
["base64 encoding",">web-server/stateless.html#(part._.Base64_.Encoding)","Base64 Encoding",false],
["base64 signature",">net/base64.html#(part._.Base64_.Signature)","Base64 Signature",false],
["base64 unit",">net/base64.html#(part._.Base64_.Unit)","Base64 Unit",false],
["base64-decode",">net/base64.html#(def._((lib._net/base64..rkt)._base64-decode))",[0,[2,"base64-decode"]],["net/base64"]],
["base64-decode-stream",">net/base64.html#(def._((lib._net/base64..rkt)._base64-decode-stream))",[0,[2,"base64-decode-stream"]],["net/base64"]],
["base64-encode",">net/base64.html#(def._((lib._net/base64..rkt)._base64-encode))",[0,[2,"base64-encode"]],["net/base64"]],
["base64-encode-stream",">net/base64.html#(def._((lib._net/base64..rkt)._base64-encode-stream))",[0,[2,"base64-encode-stream"]],["net/base64"]],
["base64-stuffer",">web-server/stateless.html#(def._((lib._web-server/stuffers/base64..rkt)._base64-stuffer))",[0,[2,"base64-stuffer"]],["web-server/stuffers/base64"]],
["base64@",">net/base64.html#(def._((lib._net/base64-unit..rkt)._base64~40))",[0,[2,"base64@"]],["net/base64-unit"]],
["base64^",">net/base64.html#(form._((lib._net/base64-sig..rkt)._base64~5e))",[0,[1,"base64^"]],["net/base64-sig"]],
["base?",">html/index.html#(def._((lib._html/main..rkt)._base~3f))",[0,[2,"base?"]],["html"]],
["basefont",">html/index.html#(def._((lib._html/main..rkt)._basefont))",[0,[2,"basefont"]],["html"]],
["basefont?",">html/index.html#(def._((lib._html/main..rkt)._basefont~3f))",[0,[2,"basefont?"]],["html"]],
["baseless",">slideshow/Bounding_Box_Adjusters.html#(def._((lib._slideshow/pict..rkt)._baseless))",[0,[2,"baseless"]],["slideshow/pict","slideshow"]],
["bash completion",">guide/cmdline-tools.html#(part._.Bash_completion)","Bash completion",false],
["basic assertions",">guide/regexp-assert.html","Basic Assertions",false],
["basic authentication",">web-server/http.html#(part._basic-auth)","Basic Authentication",false],
["basic blog",">continue/index.html#(part._.Basic_.Blog)","Basic Blog",false],
["basic combinators",">web-server/stateless.html#(part._.Basic_.Combinators)","Basic Combinators",false],
["basic commands",">graphics/Basic_Commands.html","Basic Commands",false],
["basic formlet usage",">web-server/formlets.html#(part._.Basic_.Formlet_.Usage)","Basic Formlet Usage",false],
["basic image properties",">teachpack/image.html#(part._properties)","Basic Image Properties",false],
["basic images",">teachpack/2htdpimage.html#(part._.Basic_.Images)","Basic Images",false],
["basic pict constructors",">slideshow/Basic_Pict_Constructors.html","Basic Pict Constructors",false],
["basic pretty-print options",">reference/pretty-print.html#(part._.Basic_.Pretty-.Print_.Options)","Basic Pretty-Print Options",false],
["basic style",">gui/editor-overview.html#(idx._(gentag._152._(lib._scribblings/gui/gui..scrbl)))",[[7,"\"Basic\""],"\nstyle"],false],
["basic types",">ts-guide/types.html#(part._.Basic_.Types)","Basic Types",false],
["basic-style",">gui/style-list_.html#(meth._(((lib._racket/snip..rkt)._style-list~25)._basic-style))",[[0,[2,"basic-style"]],[14,[" (method of ",[0,[2,"style-list%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["batch input/output: \"batch-io.ss\"",">teachpack/2htdpbatch-io.html",["Batch Input/Output: ",[6,"\"batch-io.ss\""],"<a name=\"(idx._(gentag._20._(lib._teachpack/teachpack..scrbl)._2htdp))\"></a>"],false],
["batch-io teachpack",">teachpack/2htdpbatch-io.html#(idx._(gentag._20._(lib._teachpack/teachpack..scrbl)._2htdp))","batch-io teachpack",false],
["bdiagonal-hatch",">draw/brush_.html#(idx._(gentag._17._(lib._scribblings/draw/draw..scrbl)))",[7,"'bdiagonal-hatch"],false],
["bdo",">html/index.html#(def._((lib._html/main..rkt)._bdo))",[0,[2,"bdo"]],["html"]],
["bdo?",">html/index.html#(def._((lib._html/main..rkt)._bdo~3f))",[0,[2,"bdo?"]],["html"]],
["before",">rackunit/api.html#(form._((lib._rackunit/main..rkt)._before))",[0,[1,"before"]],["rackunit"]],
["beg-mark",">preprocessor/mzpp.html#(def._((lib._preprocessor/mzpp..rkt)._beg-mark))",[0,[2,"beg-mark"]],["preprocessor/mzpp"]],
["beg0",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._beg0))",[0,[2,"beg0"]],["compiler/zo-structs"]],
["beg0-seq",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._beg0-seq))",[0,[2,"beg0-seq"]],["compiler/zo-structs"]],
["beg0?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._beg0~3f))",[0,[2,"beg0?"]],["compiler/zo-structs"]],
["begin",">deinprogramm/begin.html",[0,[1,"begin"]],false],
["begin",">reference/begin.html#(form._((quote._~23~25kernel)._begin))",[0,[1,"begin"]],["racket/base","racket"]],
["begin",">r5rs-std/r5rs-Z-H-7.html#%_idx_138",[0,[1,"begin"]],["r5rs"]],
["begin",">r6rs-std/r6rs-Z-H-14.html#node_idx_418",[0,[1,"begin"]],["rnrs/base-6"]],
["begin",">htdp-langs/advanced.html#(form._((lib._lang/htdp-advanced..rkt)._begin))",[0,[1,"begin"]],["lang/htdp-advanced"]],
["begin",">deinprogramm/begin.html#(form._((lib._deinprogramm/.D.Md.A..rkt)._begin))",[0,[1,"begin"]],["deinprogramm/DMdA"]],
["begin",">lazy/index.html#(form._((lib._lazy/main..rkt)._begin))",[0,[1,"begin"]],["lazy"]],
["begin",">plai/mutator.html#(form._((lib._plai/mutator..rkt)._begin))",[0,[1,"begin"]],["plai/mutator"]],
["begin",">srfi-std/srfi-42.html#begin",[0,[1,"begin"]],["srfi/42"]],
["begin-busy-cursor",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._begin-busy-cursor))",[0,[2,"begin-busy-cursor"]],["racket/gui/base","racket/gui"]],
["begin-card-sequence",">cards/index.html#(meth._(((lib._games/cards..rkt)._table~3c~25~3e)._begin-card-sequence))",[[0,[2,"begin-card-sequence"]],[14,[" (method of ",[0,[2,"table<%>"]],")"]]],["games/cards"]],
["begin-container-sequence",">gui/area-container___.html#(meth._(((lib._mred/main..rkt)._area-container~3c~25~3e)._begin-container-sequence))",[[0,[2,"begin-container-sequence"]],[14,[" (method of ",[0,[2,"area-container<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["begin-edit-sequence",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._begin-edit-sequence))",[[0,[2,"begin-edit-sequence"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["begin-encourage-inline",">reference/performance-hint.html#(form._((lib._racket/performance-hint..rkt)._begin-encourage-inline))",[0,[1,"begin-encourage-inline"]],["racket/performance-hint"]],
["begin-for-syntax",">reference/begin.html#(form._((quote._~23~25kernel)._begin-for-syntax))",[0,[1,"begin-for-syntax"]],["racket/base","racket"]],
["begin-lifted",">mzlib/mzlib_etc.html#(form._((lib._mzlib/etc..rkt)._begin-lifted))",[0,[1,"begin-lifted"]],["mzlib/etc"]],
["begin-metadata-changes",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3adefinitions-text~3c~25~3e)._begin-metadata-changes))",[[0,[2,"begin-metadata-changes"]],[14,[" (method of ",[0,[2,"drracket:unit:definitions-text<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["begin-on-demand",">unstable/lazy-require.html#(form._((lib._unstable/lazy-require..rkt)._begin-on-demand))",[0,[1,"begin-on-demand"]],["unstable/lazy-require"]],
["begin-with-definitions",">mzlib/mzlib_etc.html#(form._((lib._mzlib/etc..rkt)._begin-with-definitions))",[0,[1,"begin-with-definitions"]],["mzlib/etc"]],
["begin-write-header-footer-to-file",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._begin-write-header-footer-to-file))",[[0,[2,"begin-write-header-footer-to-file"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["begin/debug",">unstable/Debugging.html#(form._((lib._unstable/debug..rkt)._begin/debug))",[0,[1,"begin/debug"]],["unstable/debug"]],
["begin0",">reference/begin.html#(form._((quote._~23~25kernel)._begin0))",[0,[1,"begin0"]],["racket/base","racket"]],
["begin0",">htdp-langs/advanced.html#(form._((lib._lang/htdp-advanced..rkt)._begin0))",[0,[1,"begin0"]],["lang/htdp-advanced"]],
["begin0",">lazy/index.html#(form._((lib._lazy/main..rkt)._begin0))",[0,[1,"begin0"]],["lazy"]],
["beginning student",">htdp-langs/beginner.html","Beginning Student",false],
["beginning student language",">drracket/htdp-langs.html#(idx._(gentag._43._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Beginning Student</span> language",false],
["beginning student with list abbreviations",">htdp-langs/beginner-abbr.html","Beginning Student with List Abbreviations",false],
["beginning student with list abbreviations languages",">drracket/htdp-langs.html#(idx._(gentag._44._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Beginning Student with List\nAbbreviations</span> languages",false],
["beginning typed racket",">ts-guide/beginning.html","Beginning Typed Racket",false],
["behavior?",">frtime/index.html#(def._((lib._frtime/main..rkt)._behavior~3f))",[0,[2,"behavior?"]],["frtime"]],
["bell",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._bell))",[0,[2,"bell"]],["racket/gui/base","racket/gui"]],
["benchmarking",">guide/performance.html","benchmarking",false],
["beside",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._beside))",[0,[2,"beside"]],["2htdp/image"]],
["beside",">deinprogramm/image.html#(def._((lib._deinprogramm/image..rkt)._beside))",[0,[2,"beside"]],["teachpack/deinprogramm/image"]],
["beside/align",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._beside/align))",[0,[2,"beside/align"]],["2htdp/image"]],
["between/c",">reference/data-structure-contracts.html#(def._((lib._racket/contract/private/misc..rkt)._between/c))",[0,[2,"between/c"]],["racket/contract/base","racket/contract","racket"]],
["bezeichner",">deinprogramm/id.html","Bezeichner",false],
["bi-directional match expander",">web-server/dispatch.html#(tech._bi._directional._match._expander)","<span style=\"font-style: italic\">bi-directional match expander</span>",false],
["bib-entry",">scribble/Bibliography.html#(def._((lib._scribble/manual..rkt)._bib-entry))",[0,[2,"bib-entry"]],["scribble/manual"]],
["bib-entry?",">scribble/Bibliography.html#(def._((lib._scribble/manual..rkt)._bib-entry~3f))",[0,[2,"bib-entry?"]],["scribble/manual"]],
["bib?",">scriblib/autobib.html#(def._((lib._scriblib/autobib..rkt)._bib~3f))",[0,[2,"bib?"]],["scriblib/autobib"]],
["bibdb",">scriblib/bibtex.html#(def._((lib._scriblib/bibtex..rkt)._bibdb))",[0,[2,"bibdb"]],["scriblib/bibtex"]],
["bibdb-bibs",">scriblib/bibtex.html#(def._((lib._scriblib/bibtex..rkt)._bibdb-bibs))",[0,[2,"bibdb-bibs"]],["scriblib/bibtex"]],
["bibdb-raw",">scriblib/bibtex.html#(def._((lib._scriblib/bibtex..rkt)._bibdb-raw))",[0,[2,"bibdb-raw"]],["scriblib/bibtex"]],
["bibdb?",">scriblib/bibtex.html#(def._((lib._scriblib/bibtex..rkt)._bibdb~3f))",[0,[2,"bibdb?"]],["scriblib/bibtex"]],
["bibliographies",">scriblib/autobib.html","Bibliographies",false],
["bibliography",">scribble/Bibliography.html","Bibliography",false],
["bibliography",">scribble/Bibliography.html#(def._((lib._scribble/manual..rkt)._bibliography))",[0,[2,"bibliography"]],["scribble/manual"]],
["bibtex bibliographies",">scriblib/bibtex.html","BibTeX Bibliographies",false],
["bibtex-parse",">scriblib/bibtex.html#(def._((lib._scriblib/bibtex..rkt)._bibtex-parse))",[0,[2,"bibtex-parse"]],["scriblib/bibtex"]],
["bidi-match-going-in?",">web-server/dispatch.html#(form._((lib._web-server/dispatch/extend..rkt)._bidi-match-going-in~3f))",[0,[1,"bidi-match-going-in?"]],["web-server/dispatch/extend"]],
["big",">html/index.html#(def._((lib._html/main..rkt)._big))",[0,[2,"big"]],["html"]],
["big",">unstable/Slideshow_Presentations.html#(form._((lib._unstable/gui/slideshow..rkt)._big))",[0,[1,"big"]],["unstable/gui/slideshow"]],
["big-bang",">teachpack/2htdpuniverse.html#(form._((lib._2htdp/universe..rkt)._big-bang))",[0,[1,"big-bang"]],["2htdp/universe"]],
["big-bang",">teachpack/draw.html#(def._((lib._htdp/big-draw..rkt)._big-bang))",[0,[2,"big-bang"]],["htdp/draw"]],
["big-bang",">teachpack/world.html#(def._((lib._htdp/world..rkt)._big-bang))",[0,[2,"big-bang"]],["htdp/world"]],
["big-bang",">deinprogramm/world.html#(def._((lib._deinprogramm/world..rkt)._big-bang))",[0,[2,"big-bang"]],["teachpack/deinprogramm/world"]],
["big?",">html/index.html#(def._((lib._html/main..rkt)._big~3f))",[0,[2,"big?"]],["html"]],
["bignums, rationals, and complex numbers",">inside/Bignums__Rationals__and_Complex_Numbers.html","Bignums, Rationals, and Complex Numbers",false],
["bild",">deinprogramm/image.html#(tech._bild)","<span style=\"font-style: italic\">Bild</span>",false],
["bilder",">deinprogramm/image.html#(part._.Bilder)","Bilder",false],
["bilder aus pixeln konstruieren",">deinprogramm/image.html#(part._from-pixels)","Bilder aus Pixeln konstruieren",false],
["bilder konstruieren: \"image.ss\"",">deinprogramm/image.html",["Bilder konstruieren: ",[6,"\"image.ss\""],"<a name=\"(idx._(gentag._2._(lib._deinprogramm/scribblings/deinprogramm..scrbl)))\"></a>"],false],
["bilder zusammensetzen",">deinprogramm/image.html#(part._composition)","Bilder zusammensetzen",false],
["bin-dir",">config/index.html#(def._((lib._config/main..rkt)._bin-dir))",[0,[2,"bin-dir"]],["config"]],
["binary",">reference/file-ports.html#(idx._(gentag._201._(lib._scribblings/reference/reference..scrbl)))",[7,"'binary"],false],
["binary heaps",">data/Binary_Heaps.html","Binary Heaps",false],
["binary-port?",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_648",[0,[2,"binary-port?"]],["rnrs/io/ports-6"]],
["bind",">redex/The_Redex_Reference.html#(def._((lib._redex/reduction-semantics..rkt)._bind))",[0,[2,"bind"]],["redex/reduction-semantics","redex"]],
["bind-exp",">redex/The_Redex_Reference.html#(def._((lib._redex/reduction-semantics..rkt)._bind-exp))",[0,[2,"bind-exp"]],["redex/reduction-semantics","redex"]],
["bind-name",">redex/The_Redex_Reference.html#(def._((lib._redex/reduction-semantics..rkt)._bind-name))",[0,[2,"bind-name"]],["redex/reduction-semantics","redex"]],
["bind-prepared-statement",">db/query-api.html#(def._((lib._db/base..rkt)._bind-prepared-statement))",[0,[2,"bind-prepared-statement"]],["db","db/base"]],
["bind?",">redex/The_Redex_Reference.html#(def._((lib._redex/reduction-semantics..rkt)._bind~3f))",[0,[2,"bind?"]],["redex/reduction-semantics","redex"]],
["binding",">web-server/http.html#(def._((lib._web-server/http/request-structs..rkt)._binding))",[0,[2,"binding"]],["web-server/http/request-structs"]],
["binding",">net/cgi.html#(tech._binding)","<span style=\"font-style: italic\">binding</span>",false],
["binding",">reference/syntax-model.html#(tech._binding)","<span style=\"font-style: italic\">binding</span>",false],
["binding forms",">ts-reference/special-forms.html#(part._.Binding_.Forms)","Binding Forms",false],
["binding information",">xrepl/index.html#(part._.Binding_.Information)","Binding Information",false],
["binding-format/c",">web-server/page.html#(def._((lib._web-server/page..rkt)._binding-format/c))",[0,[2,"binding-format/c"]],["web-server/page"]],
["binding-id",">web-server/http.html#(def._((lib._web-server/http/request-structs..rkt)._binding-id))",[0,[2,"binding-id"]],["web-server/http/request-structs"]],
["binding-id/c",">web-server/page.html#(def._((lib._web-server/page..rkt)._binding-id/c))",[0,[2,"binding-id/c"]],["web-server/page"]],
["binding:file",">web-server/http.html#(def._((lib._web-server/http/request-structs..rkt)._binding~3afile))",[0,[2,"binding:file"]],["web-server/http/request-structs"]],
["binding:file-content",">web-server/http.html#(def._((lib._web-server/http/request-structs..rkt)._binding~3afile-content))",[0,[2,"binding:file-content"]],["web-server/http/request-structs"]],
["binding:file-filename",">web-server/http.html#(def._((lib._web-server/http/request-structs..rkt)._binding~3afile-filename))",[0,[2,"binding:file-filename"]],["web-server/http/request-structs"]],
["binding:file-headers",">web-server/http.html#(def._((lib._web-server/http/request-structs..rkt)._binding~3afile-headers))",[0,[2,"binding:file-headers"]],["web-server/http/request-structs"]],
["binding:file?",">web-server/http.html#(def._((lib._web-server/http/request-structs..rkt)._binding~3afile~3f))",[0,[2,"binding:file?"]],["web-server/http/request-structs"]],
["binding:form",">web-server/http.html#(def._((lib._web-server/http/request-structs..rkt)._binding~3aform))",[0,[2,"binding:form"]],["web-server/http/request-structs"]],
["binding:form-value",">web-server/http.html#(def._((lib._web-server/http/request-structs..rkt)._binding~3aform-value))",[0,[2,"binding:form-value"]],["web-server/http/request-structs"]],
["binding:form?",">web-server/http.html#(def._((lib._web-server/http/request-structs..rkt)._binding~3aform~3f))",[0,[2,"binding:form?"]],["web-server/http/request-structs"]],
["binding?",">web-server/http.html#(def._((lib._web-server/http/request-structs..rkt)._binding~3f))",[0,[2,"binding?"]],["web-server/http/request-structs"]],
["bindings",">web-server/http.html#(part._bindings)","Bindings",false],
["bindings-as-html",">net/cgi.html#(def._((lib._net/cgi..rkt)._bindings-as-html))",[0,[2,"bindings-as-html"]],["net/cgi"]],
["bindings-assq",">web-server/http.html#(def._((lib._web-server/http/request-structs..rkt)._bindings-assq))",[0,[2,"bindings-assq"]],["web-server/http/request-structs"]],
["bindings-assq-all",">web-server/http.html#(def._((lib._web-server/http/request-structs..rkt)._bindings-assq-all))",[0,[2,"bindings-assq-all"]],["web-server/http/request-structs"]],
["binds",">reference/syntax-model.html#(tech._bind)","<span style=\"font-style: italic\">binds</span>",false],
["bit",">slideshow/Primary_Slide_Functions.html#(def._((lib._slideshow/base..rkt)._bit))",[0,[2,"bit"]],["slideshow/base","slideshow"]],
["bit-field->flonum",">unstable/flonum.html#(def._((lib._unstable/flonum..rkt)._bit-field-~3eflonum))",[0,[2,"bit-field->flonum"]],["unstable/flonum"]],
["bit/byte-ticks",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._bit/byte-ticks))",[0,[2,"bit/byte-ticks"]],["plot"]],
["bit/byte-ticks-format",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._bit/byte-ticks-format))",[0,[2,"bit/byte-ticks-format"]],["plot"]],
["bitmap",">teachpack/2htdpimage.html#(form._((lib._2htdp/image..rkt)._bitmap))",[0,[1,"bitmap"]],["2htdp/image"]],
["bitmap",">slideshow/Basic_Pict_Constructors.html#(def._((lib._slideshow/pict..rkt)._bitmap))",[0,[2,"bitmap"]],["slideshow/pict","slideshow"]],
["bitmap label",">mrlib/Bitmap_Label.html","Bitmap Label",false],
["bitmap%",">draw/bitmap_.html",[0,[2,"bitmap%"]],["racket/draw"]],
["bitmap->flomap",">images/Conversion_and_Construction.html#(def._((lib._images/flomap..rkt)._bitmap-~3eflomap))",[0,[2,"bitmap->flomap"]],["images/flomap"]],
["bitmap->gl-list",">sgl/bitmaps.html#(def._((lib._sgl/bitmap..rkt)._bitmap-~3egl-list))",[0,"bitmap->gl-list"],["sgl/bitmap"]],
["bitmap-dc%",">draw/bitmap-dc_.html",[0,[2,"bitmap-dc%"]],["racket/draw"]],
["bitmap-draft-mode",">slideshow/Basic_Pict_Constructors.html#(def._((lib._slideshow/pict..rkt)._bitmap-draft-mode))",[0,[2,"bitmap-draft-mode"]],["slideshow/pict","slideshow"]],
["bitmap-label-maker",">mrlib/Bitmap_Label.html#(def._((lib._mrlib/bitmap-label..rkt)._bitmap-label-maker))",[0,[2,"bitmap-label-maker"]],["mrlib/bitmap-label"]],
["bitmap-render-icon",">images/Icons.html#(def._((lib._images/icons/style..rkt)._bitmap-render-icon))",[0,[2,"bitmap-render-icon"]],["images/icons/style"]],
["bitmap/file",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._bitmap/file))",[0,[2,"bitmap/file"]],["2htdp/image"]],
["bitmap/url",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._bitmap/url))",[0,[2,"bitmap/url"]],["2htdp/image"]],
["bitmaps",">sgl/bitmaps.html","Bitmaps",false],
["bitmaps",">teachpack/2htdpimage.html#(part._.Bitmaps)","Bitmaps",false],
["bits",">db/sql-types.html#(part._.Bits)","Bits",false],
["bitwise operations",">reference/generic-numbers.html#(part._.Bitwise_.Operations)","Bitwise Operations",false],
["bitwise-and",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._bitwise-and))",[0,[2,"bitwise-and"]],["racket/base","racket"]],
["bitwise-and",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1066",[0,[2,"bitwise-and"]],["rnrs/arithmetic/bitwise-6"]],
["bitwise-arithmetic-shift",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1088",[0,[2,"bitwise-arithmetic-shift"]],["rnrs/arithmetic/bitwise-6"]],
["bitwise-arithmetic-shift-left",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1090",[0,[2,"bitwise-arithmetic-shift-left"]],["rnrs/arithmetic/bitwise-6"]],
["bitwise-arithmetic-shift-right",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1092",[0,[2,"bitwise-arithmetic-shift-right"]],["rnrs/arithmetic/bitwise-6"]],
["bitwise-bit-count",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1074",[0,[2,"bitwise-bit-count"]],["rnrs/arithmetic/bitwise-6"]],
["bitwise-bit-field",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._bitwise-bit-field))",[0,[2,"bitwise-bit-field"]],["racket/base","racket"]],
["bitwise-bit-field",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1084",[0,[2,"bitwise-bit-field"]],["rnrs/arithmetic/bitwise-6"]],
["bitwise-bit-set?",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._bitwise-bit-set~3f))",[0,[2,"bitwise-bit-set?"]],["racket/base","racket"]],
["bitwise-bit-set?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1080",[0,[2,"bitwise-bit-set?"]],["rnrs/arithmetic/bitwise-6"]],
["bitwise-copy-bit",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1082",[0,[2,"bitwise-copy-bit"]],["rnrs/arithmetic/bitwise-6"]],
["bitwise-copy-bit-field",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1086",[0,[2,"bitwise-copy-bit-field"]],["rnrs/arithmetic/bitwise-6"]],
["bitwise-first-bit-set",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1078",[0,[2,"bitwise-first-bit-set"]],["rnrs/arithmetic/bitwise-6"]],
["bitwise-if",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1072",[0,[2,"bitwise-if"]],["rnrs/arithmetic/bitwise-6"]],
["bitwise-ior",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._bitwise-ior))",[0,[2,"bitwise-ior"]],["racket/base","racket"]],
["bitwise-ior",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1068",[0,[2,"bitwise-ior"]],["rnrs/arithmetic/bitwise-6"]],
["bitwise-length",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1076",[0,[2,"bitwise-length"]],["rnrs/arithmetic/bitwise-6"]],
["bitwise-not",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._bitwise-not))",[0,[2,"bitwise-not"]],["racket/base","racket"]],
["bitwise-not",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1064",[0,[2,"bitwise-not"]],["rnrs/arithmetic/bitwise-6"]],
["bitwise-reverse-bit-field",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1096",[0,[2,"bitwise-reverse-bit-field"]],["rnrs/arithmetic/bitwise-6"]],
["bitwise-rotate-bit-field",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1094",[0,[2,"bitwise-rotate-bit-field"]],["rnrs/arithmetic/bitwise-6"]],
["bitwise-xor",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._bitwise-xor))",[0,[2,"bitwise-xor"]],["racket/base","racket"]],
["bitwise-xor",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1070",[0,[2,"bitwise-xor"]],["rnrs/arithmetic/bitwise-6"]],
["black",">unstable/pict.html#(def._((lib._unstable/gui/pict..rkt)._black))",[0,[2,"black"]],["unstable/gui/pict"]],
["black-and-white",">slideshow/Pict_Drawing_Adjusters.html#(def._((lib._slideshow/pict..rkt)._black-and-white))",[0,[2,"black-and-white"]],["slideshow/pict","slideshow"]],
["blackjack --- 21 card game",">games/blackjack.html",[[15,"<img src=\"blackjack.png\" alt=\"\" />"]," ","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Blackjack</span>"," ","&#8212;","<wbr></wbr>"," 21 Card Game"],false],
["blame object",">reference/Building_New_Contract_Combinators.html#(tech._blame._object)","<span style=\"font-style: italic\">blame object</span>",false],
["blame objects",">reference/Building_New_Contract_Combinators.html#(part._.Blame_.Objects)","Blame Objects",false],
["blame-add-context",">reference/Building_New_Contract_Combinators.html#(def._((lib._racket/contract/private/blame..rkt)._blame-add-context))",[0,[2,"blame-add-context"]],["racket/contract/combinator","racket/contract","racket"]],
["blame-contract",">reference/Building_New_Contract_Combinators.html#(def._((lib._racket/contract/private/blame..rkt)._blame-contract))",[0,[2,"blame-contract"]],["racket/contract/combinator","racket/contract","racket"]],
["blame-negative",">reference/Building_New_Contract_Combinators.html#(def._((lib._racket/contract/private/blame..rkt)._blame-negative))",[0,[2,"blame-negative"]],["racket/contract/combinator","racket/contract","racket"]],
["blame-original?",">reference/Building_New_Contract_Combinators.html#(def._((lib._racket/contract/private/blame..rkt)._blame-original~3f))",[0,[2,"blame-original?"]],["racket/contract/combinator","racket/contract","racket"]],
["blame-positive",">reference/Building_New_Contract_Combinators.html#(def._((lib._racket/contract/private/blame..rkt)._blame-positive))",[0,[2,"blame-positive"]],["racket/contract/combinator","racket/contract","racket"]],
["blame-replace-negative",">reference/Building_New_Contract_Combinators.html#(def._((lib._racket/contract/private/blame..rkt)._blame-replace-negative))",[0,[2,"blame-replace-negative"]],["racket/contract/combinator","racket/contract","racket"]],
["blame-source",">reference/Building_New_Contract_Combinators.html#(def._((lib._racket/contract/private/blame..rkt)._blame-source))",[0,[2,"blame-source"]],["racket/contract/combinator","racket/contract","racket"]],
["blame-swap",">reference/Building_New_Contract_Combinators.html#(def._((lib._racket/contract/private/blame..rkt)._blame-swap))",[0,[2,"blame-swap"]],["racket/contract/combinator","racket/contract","racket"]],
["blame-swapped?",">reference/Building_New_Contract_Combinators.html#(def._((lib._racket/contract/private/blame..rkt)._blame-swapped~3f))",[0,[2,"blame-swapped?"]],["racket/contract/combinator","racket/contract","racket"]],
["blame-value",">reference/Building_New_Contract_Combinators.html#(def._((lib._racket/contract/private/blame..rkt)._blame-value))",[0,[2,"blame-value"]],["racket/contract/combinator","racket/contract","racket"]],
["blame?",">reference/Building_New_Contract_Combinators.html#(def._((lib._racket/contract/private/blame..rkt)._blame~3f))",[0,[2,"blame?"]],["racket/contract/combinator","racket/contract","racket"]],
["blank",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex..rkt)._blank))",[0,[1,"blank"]],["parser-tools/lex"]],
["blank",">slideshow/Basic_Pict_Constructors.html#(def._((lib._slideshow/pict..rkt)._blank))",[0,[2,"blank"]],["slideshow/pict","slideshow"]],
["blank-line",">unstable/Slideshow_Presentations.html#(def._((lib._unstable/gui/slideshow..rkt)._blank-line))",[0,[2,"blank-line"]],["unstable/gui/slideshow"]],
["blink-caret",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._blink-caret))",[[0,[2,"blink-caret"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["blink-caret",">gui/snip_.html#(meth._(((lib._racket/snip..rkt)._snip~25)._blink-caret))",[[0,[2,"blink-caret"]],[14,[" (method of ",[0,[2,"snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["block",">reference/block.html#(form._((lib._racket/block..rkt)._block))",[0,[1,"block"]],["racket/block"]],
["block",">reference/port-buffers.html#(idx._(gentag._197._(lib._scribblings/reference/reference..scrbl)))",[7,"'block"],false],
["block",">scribble/core.html#(tech._block)","<span style=\"font-style: italic\">block</span>",false],
["block-color",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._block-color))",[0,[2,"block-color"]],["scribble/racket","scribble/scheme"]],
["block-traverse-procedure/c",">scribble/core.html#(def._((lib._scribble/core..rkt)._block-traverse-procedure/c))",[0,[2,"block-traverse-procedure/c"]],["scribble/core"]],
["block-width",">scribble/core.html#(def._((lib._scribble/core..rkt)._block-width))",[0,[2,"block-width"]],["scribble/core"]],
["block?",">scribble/core.html#(def._((lib._scribble/core..rkt)._block~3f))",[0,[2,"block?"]],["scribble/core"]],
["blocking",">guide/performance.html#(tech._blocking)","<span style=\"font-style: italic\">blocking</span>",false],
["blocking the current thread",">inside/threads.html#(part._threadblock)","Blocking the Current Thread",false],
["blockquote",">html/index.html#(def._((lib._html/main..rkt)._blockquote))",[0,[2,"blockquote"]],["html"]],
["blockquote?",">html/index.html#(def._((lib._html/main..rkt)._blockquote~3f))",[0,[2,"blockquote?"]],["html"]],
["blocks",">scribble/base.html#(part._.Blocks)","Blocks",false],
["blocks",">teachpack/2htdpPlanet_Cute_Images.html#(part._pc~3a.Blocks)","Blocks",false],
["blocks: block",">reference/block.html",["Blocks: ",[0,[1,"block"]]],false],
["blog",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/dummy-10..rkt)._blog))",[0,[2,"blog"]],[]],
["blog",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-1..rkt)._blog))",[0,"blog"],[]],
["blog",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-4..rkt)._blog))",[0,[2,"blog"]],[]],
["blog",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-9..rkt)._blog))",[0,[2,"blog"]],[]],
["blog-db",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/dummy-10..rkt)._blog-db))",[0,[2,"blog-db"]],[]],
["blog-home",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-9..rkt)._blog-home))",[0,[2,"blog-home"]],[]],
["blog-insert-post!",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-4..rkt)._blog-insert-post!))",[0,"blog-insert-post!"],[]],
["blog-insert-post!",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-9..rkt)._blog-insert-post!))",[0,"blog-insert-post!"],[]],
["blog-posts",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-4..rkt)._blog-posts))",[0,[2,"blog-posts"]],[]],
["blog-posts",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-9..rkt)._blog-posts))",[0,[2,"blog-posts"]],[]],
["blog?",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/dummy-10..rkt)._blog~3f))",[0,[2,"blog?"]],[]],
["blog?",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-4..rkt)._blog~3f))",[0,[2,"blog?"]],[]],
["blog?",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-9..rkt)._blog~3f))",[0,[2,"blog?"]],[]],
["blue",">draw/color_.html#(meth._(((lib._racket/draw..rkt)._color~25)._blue))",[[0,[2,"blue"]],[14,[" (method of ",[0,[2,"color%"]],")"]]],["racket/draw"]],
["blue",">unstable/pict.html#(def._((lib._unstable/gui/pict..rkt)._blue))",[0,[2,"blue"]],["unstable/gui/pict"]],
["blur",">images/Blur.html","Blur",false],
["blur",">unstable/pict.html#(part._.Blur)","Blur",false],
["blur",">unstable/pict.html#(def._((lib._unstable/gui/pict..rkt)._blur))",[0,[2,"blur"]],["unstable/gui/pict"]],
["blur-bitmap!",">unstable/pict.html#(def._((lib._unstable/gui/pict..rkt)._blur-bitmap!))",[0,[2,"blur-bitmap!"]],["unstable/gui/pict"]],
["blurb",">planet/Developing_Packages_for_PLaneT.html#(idx._(gentag._1._(lib._planet/planet..scrbl)))",[7,"'blurb"],false],
["bnf",">scribble/bnf.html#(def._((lib._scribble/bnf..rkt)._.B.N.F))",[0,[2,"BNF"]],["scribble/bnf"]],
["bnf grammars",">scribble/bnf.html","BNF Grammars",false],
["bnf-alt",">scribble/bnf.html#(def._((lib._scribble/bnf..rkt)._.B.N.F-alt))",[0,[2,"BNF-alt"]],["scribble/bnf"]],
["bnf-etc",">scribble/bnf.html#(def._((lib._scribble/bnf..rkt)._.B.N.F-etc))",[0,[2,"BNF-etc"]],["scribble/bnf"]],
["bnf-group",">scribble/bnf.html#(def._((lib._scribble/bnf..rkt)._.B.N.F-group))",[0,[2,"BNF-group"]],["scribble/bnf"]],
["bnf-seq",">scribble/bnf.html#(def._((lib._scribble/bnf..rkt)._.B.N.F-seq))",[0,[2,"BNF-seq"]],["scribble/bnf"]],
["bnf-seq-lines",">scribble/bnf.html#(def._((lib._scribble/bnf..rkt)._.B.N.F-seq-lines))",[0,[2,"BNF-seq-lines"]],["scribble/bnf"]],
["board to graph",">games/Board_to_Graph.html","Board to Graph",false],
["body",">html/index.html#(def._((lib._html/main..rkt)._body))",[0,[2,"body"]],["html"]],
["body argument",">mzlib/mzlib_kw.html#(part._kw-body)","Body Argument",false],
["body-id",">scribble/core.html#(def._((lib._scribble/html-properties..rkt)._body-id))",[0,[2,"body-id"]],["scribble/html-properties"]],
["body-id-value",">scribble/core.html#(def._((lib._scribble/html-properties..rkt)._body-id-value))",[0,[2,"body-id-value"]],["scribble/html-properties"]],
["body-id?",">scribble/core.html#(def._((lib._scribble/html-properties..rkt)._body-id~3f))",[0,[2,"body-id?"]],["scribble/html-properties"]],
["body-of-message",">net/nntp.html#(def._((lib._net/nntp..rkt)._body-of-message))",[0,[2,"body-of-message"]],["net/nntp"]],
["body?",">html/index.html#(def._((lib._html/main..rkt)._body~3f))",[0,[2,"body?"]],["html"]],
["bold",">scribble/base.html#(def._((lib._scribble/base..rkt)._bold))",[0,[2,"bold"]],["scribble/base"]],
["bold",">unstable/Slideshow_Presentations.html#(form._((lib._unstable/gui/slideshow..rkt)._bold))",[0,[1,"bold"]],["unstable/gui/slideshow"]],
["bold",">gui/style-delta_.html#(idx._(gentag._190._(lib._scribblings/gui/gui..scrbl)))",[7,"'bold"],false],
["bold",">draw/font_.html#(idx._(gentag._41._(lib._scribblings/draw/draw..scrbl)))",[7,"'bold"],false],
["bomb-icon",">images/Icons.html#(def._((lib._images/icons/misc..rkt)._bomb-icon))",[0,[2,"bomb-icon"]],["images/icons/misc"]],
["book-location",">scriblib/autobib.html#(def._((lib._scriblib/autobib..rkt)._book-location))",[0,[2,"book-location"]],["scriblib/autobib"]],
["bookref",">scribble/config.html#(idx._(gentag._22._(lib._scribblings/scribble/scribble..scrbl)))","BookRef",false],
["boolean",">deinprogramm/Signaturen.html#(form._((lib._deinprogramm/.D.Md.A..rkt)._boolean))",[0,[1,"boolean"]],["deinprogramm/DMdA-beginner"]],
["boolean",">syntax/Library_Syntax_Classes_and_Literal_Sets.html#(form._((lib._syntax/parse..rkt)._boolean))",[0,[1,"boolean"]],["syntax/parse"]],
["boolean",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Boolean))",[0,[1,"Boolean"]],["typed/racket/base","typed/racket"]],
["boolean aliases",">reference/booleans.html#(part._.Boolean_.Aliases)","Boolean Aliases",false],
["boolean=?",">reference/booleans.html#(def._((lib._racket/bool..rkt)._boolean~3d~3f))",[0,[2,"boolean=?"]],["racket/bool","racket"]],
["boolean=?",">r6rs-std/r6rs-Z-H-14.html#node_idx_598",[0,[2,"boolean=?"]],["rnrs/base-6"]],
["boolean=?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._boolean~3d~3f))",[0,[2,"boolean=?"]],["lang/htdp-advanced"]],
["boolean=?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._boolean~3d~3f))",[0,[2,"boolean=?"]],["lang/htdp-beginner"]],
["boolean=?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._boolean~3d~3f))",[0,[2,"boolean=?"]],["lang/htdp-beginner-abbr"]],
["boolean=?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._boolean~3d~3f))",[0,[2,"boolean=?"]],["lang/htdp-intermediate"]],
["boolean=?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._boolean~3d~3f))",[0,[2,"boolean=?"]],["lang/htdp-intermediate-lambda"]],
["boolean=?",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._boolean~3d~3f))",[0,[2,"boolean=?"]],["deinprogramm/DMdA-advanced"]],
["boolean=?",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._boolean~3d~3f))",[0,[2,"boolean=?"]],["deinprogramm/DMdA-assignments"]],
["boolean=?",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._boolean~3d~3f))",[0,[2,"boolean=?"]],["deinprogramm/DMdA-beginner"]],
["boolean=?",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._boolean~3d~3f))",[0,[2,"boolean=?"]],["deinprogramm/DMdA-vanilla"]],
["boolean=?",">lazy/index.html#(def._((lib._lazy/main..rkt)._boolean~3d~3f))",[0,[2,"boolean=?"]],["lazy"]],
["boolean?",">reference/booleans.html#(def._((quote._~23~25kernel)._boolean~3f))",[0,[2,"boolean?"]],["racket/base","racket"]],
["boolean?",">r5rs-std/r5rs-Z-H-9.html#%_idx_388",[0,[2,"boolean?"]],["r5rs"]],
["boolean?",">r6rs-std/r6rs-Z-H-14.html#node_idx_596",[0,[2,"boolean?"]],["rnrs/base-6"]],
["boolean?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._boolean~3f))",[0,[2,"boolean?"]],["lang/htdp-advanced"]],
["boolean?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._boolean~3f))",[0,[2,"boolean?"]],["lang/htdp-beginner"]],
["boolean?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._boolean~3f))",[0,[2,"boolean?"]],["lang/htdp-beginner-abbr"]],
["boolean?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._boolean~3f))",[0,[2,"boolean?"]],["lang/htdp-intermediate"]],
["boolean?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._boolean~3f))",[0,[2,"boolean?"]],["lang/htdp-intermediate-lambda"]],
["boolean?",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._boolean~3f))",[0,[2,"boolean?"]],["deinprogramm/DMdA-advanced"]],
["boolean?",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._boolean~3f))",[0,[2,"boolean?"]],["deinprogramm/DMdA-assignments"]],
["boolean?",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._boolean~3f))",[0,[2,"boolean?"]],["deinprogramm/DMdA-beginner"]],
["boolean?",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._boolean~3f))",[0,[2,"boolean?"]],["deinprogramm/DMdA-vanilla"]],
["boolean?",">plai/mutator.html#(form._((lib._plai/mutator..rkt)._boolean~3f))",[0,[2,"boolean?"]],["plai/mutator"]],
["booleans",">guide/booleans.html","Booleans",false],
["booleans",">htdp-langs/advanced.html#(part._htdp-advanced._.Booleans)","Booleans",false],
["booleans",">htdp-langs/beginner.html#(part._htdp-beginner._.Booleans)","Booleans",false],
["booleans",">htdp-langs/beginner-abbr.html#(part._htdp-beginner-abbr._.Booleans)","Booleans",false],
["booleans",">htdp-langs/intermediate.html#(part._htdp-intermediate._.Booleans)","Booleans",false],
["booleans",">htdp-langs/intermediate-lam.html#(part._htdp-intermediate-lambda._.Booleans)","Booleans",false],
["booleans",">reference/booleans.html#(tech._boolean)","<span style=\"font-style: italic\">booleans</span>",false],
["booleans and equality",">reference/booleans.html","Booleans and Equality",false],
["booleans-as-true/false",">mzlib/mzlib_pconvert.html#(def._((lib._mzlib/pconvert..rkt)._booleans-as-true/false))",[0,[2,"booleans-as-true/false"]],["mzlib/pconvert"]],
["border",">gui/area-container___.html#(meth._(((lib._mred/main..rkt)._area-container~3c~25~3e)._border))",[[0,[2,"border"]],[14,[" (method of ",[0,[2,"area-container<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["border",">gui/area-container___.html#(idx._(gentag._17._(lib._scribblings/gui/gui..scrbl)))",[0,"border"],false],
["border-visible?",">gui/editor-snip_.html#(meth._(((lib._mred/main..rkt)._editor-snip~25)._border-visible~3f))",[[0,[2,"border-visible?"]],[14,[" (method of ",[0,[2,"editor-snip%"]],")"]]],["racket/gui/base","racket/gui"]],
["bottom",">gui/style-delta_.html#(idx._(gentag._178._(lib._scribblings/gui/gui..scrbl)))",[7,"'bottom"],false],
["bound",">reference/syntax-model.html#(tech._bound)","<span style=\"font-style: italic\">bound</span>",false],
["bound-id-table-count",">syntax/syntax-helpers.html#(def._((lib._syntax/id-table..rkt)._bound-id-table-count))",[0,[2,"bound-id-table-count"]],["syntax/id-table"]],
["bound-id-table-for-each",">syntax/syntax-helpers.html#(def._((lib._syntax/id-table..rkt)._bound-id-table-for-each))",[0,[2,"bound-id-table-for-each"]],["syntax/id-table"]],
["bound-id-table-map",">syntax/syntax-helpers.html#(def._((lib._syntax/id-table..rkt)._bound-id-table-map))",[0,[2,"bound-id-table-map"]],["syntax/id-table"]],
["bound-id-table-ref",">syntax/syntax-helpers.html#(def._((lib._syntax/id-table..rkt)._bound-id-table-ref))",[0,[2,"bound-id-table-ref"]],["syntax/id-table"]],
["bound-id-table-remove",">syntax/syntax-helpers.html#(def._((lib._syntax/id-table..rkt)._bound-id-table-remove))",[0,[2,"bound-id-table-remove"]],["syntax/id-table"]],
["bound-id-table-remove!",">syntax/syntax-helpers.html#(def._((lib._syntax/id-table..rkt)._bound-id-table-remove!))",[0,[2,"bound-id-table-remove!"]],["syntax/id-table"]],
["bound-id-table-set",">syntax/syntax-helpers.html#(def._((lib._syntax/id-table..rkt)._bound-id-table-set))",[0,[2,"bound-id-table-set"]],["syntax/id-table"]],
["bound-id-table-set!",">syntax/syntax-helpers.html#(def._((lib._syntax/id-table..rkt)._bound-id-table-set!))",[0,[2,"bound-id-table-set!"]],["syntax/id-table"]],
["bound-id-table?",">syntax/syntax-helpers.html#(def._((lib._syntax/id-table..rkt)._bound-id-table~3f))",[0,[2,"bound-id-table?"]],["syntax/id-table"]],
["bound-identifier-mapping-for-each",">syntax/syntax-helpers.html#(def._((lib._syntax/boundmap..rkt)._bound-identifier-mapping-for-each))",[0,[2,"bound-identifier-mapping-for-each"]],["syntax/boundmap"]],
["bound-identifier-mapping-get",">syntax/syntax-helpers.html#(def._((lib._syntax/boundmap..rkt)._bound-identifier-mapping-get))",[0,[2,"bound-identifier-mapping-get"]],["syntax/boundmap"]],
["bound-identifier-mapping-map",">syntax/syntax-helpers.html#(def._((lib._syntax/boundmap..rkt)._bound-identifier-mapping-map))",[0,[2,"bound-identifier-mapping-map"]],["syntax/boundmap"]],
["bound-identifier-mapping-put!",">syntax/syntax-helpers.html#(def._((lib._syntax/boundmap..rkt)._bound-identifier-mapping-put!))",[0,[2,"bound-identifier-mapping-put!"]],["syntax/boundmap"]],
["bound-identifier-mapping?",">syntax/syntax-helpers.html#(def._((lib._syntax/boundmap..rkt)._bound-identifier-mapping~3f))",[0,[2,"bound-identifier-mapping?"]],["syntax/boundmap"]],
["bound-identifier=?",">reference/stxcmp.html#(def._((quote._~23~25kernel)._bound-identifier~3d~3f))",[0,[2,"bound-identifier=?"]],["racket/base","racket"]],
["bound-identifier=?",">r6rs-lib-std/r6rs-lib-Z-H-13.html#node_idx_1140",[0,[2,"bound-identifier=?"]],["rnrs/syntax-case-6"]],
["bounding box",">slideshow/Pict_Datatype.html#(tech._bounding._box)","<span style=\"font-style: italic\">bounding box</span>",false],
["bounding box adjusters",">slideshow/Bounding_Box_Adjusters.html","Bounding Box Adjusters",false],
["bounds",">plot/intro.html#(tech._bound)","<span style=\"font-style: italic\">bounds</span>",false],
["bounds->intervals",">plot/utils.html#(def._((lib._plot/utils..rkt)._bounds-~3eintervals))",[0,[2,"bounds->intervals"]],["plot/utils"]],
["box",">reference/boxes.html#(def._((quote._~23~25kernel)._box))",[0,[2,"box"]],["racket/base","racket"]],
["box",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._box))",[0,[2,"box"]],["lang/htdp-advanced"]],
["box",">lazy/index.html#(def._((lib._lazy/main..rkt)._box))",[0,[2,"box"]],["lazy"]],
["box",">guide/boxes.html#(tech._box)","<span style=\"font-style: italic\">box</span>",false],
["box",">reference/boxes.html#(tech._box)","<span style=\"font-style: italic\">box</span>",false],
["box-cas!",">reference/boxes.html#(def._((quote._~23~25kernel)._box-cas!))",[0,[2,"box-cas!"]],["racket/base","racket"]],
["box-comment-out-selection",">framework/Racket.html#(meth._(((lib._framework/main..rkt)._racket~3atext~3c~25~3e)._box-comment-out-selection))",[[0,[2,"box-comment-out-selection"]],[14,[" (method of ",[0,[2,"racket:text<%>"]],")"]]],["framework"]],
["box-immutable",">reference/boxes.html#(def._((quote._~23~25kernel)._box-immutable))",[0,[2,"box-immutable"]],["racket/base","racket"]],
["box-immutable/c",">reference/data-structure-contracts.html#(def._((lib._racket/contract/private/box..rkt)._box-immutable/c))",[0,[2,"box-immutable/c"]],["racket/contract/base","racket/contract","racket"]],
["box-mode",">scribble/core.html#(def._((lib._scribble/core..rkt)._box-mode))",[0,[2,"box-mode"]],["scribble/core"]],
["box-mode*",">scribble/core.html#(def._((lib._scribble/core..rkt)._box-mode*))",[0,[2,"box-mode*"]],["scribble/core"]],
["box-mode-bottom-name",">scribble/core.html#(def._((lib._scribble/core..rkt)._box-mode-bottom-name))",[0,[2,"box-mode-bottom-name"]],["scribble/core"]],
["box-mode-center-name",">scribble/core.html#(def._((lib._scribble/core..rkt)._box-mode-center-name))",[0,[2,"box-mode-center-name"]],["scribble/core"]],
["box-mode-top-name",">scribble/core.html#(def._((lib._scribble/core..rkt)._box-mode-top-name))",[0,[2,"box-mode-top-name"]],["scribble/core"]],
["box-mode?",">scribble/core.html#(def._((lib._scribble/core..rkt)._box-mode~3f))",[0,[2,"box-mode?"]],["scribble/core"]],
["box/c",">reference/data-structure-contracts.html#(def._((lib._racket/contract/private/box..rkt)._box/c))",[0,[2,"box/c"]],["racket/contract/base","racket/contract","racket"]],
["box/c",">mzlib/mzlib_contract.html#(def._((lib._mzlib/contract..rkt)._box/c))",[0,[2,"box/c"]],["mzlib/contract"]],
["box?",">reference/boxes.html#(def._((quote._~23~25kernel)._box~3f))",[0,[2,"box?"]],["racket/base","racket"]],
["box?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._box~3f))",[0,[2,"box?"]],["lang/htdp-advanced"]],
["boxable",">scribble/core.html#(tech._boxable)","<span style=\"font-style: italic\">boxable</span>",false],
["boxenv",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._boxenv))",[0,[2,"boxenv"]],["compiler/zo-structs"]],
["boxenv-body",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._boxenv-body))",[0,[2,"boxenv-body"]],["compiler/zo-structs"]],
["boxenv-pos",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._boxenv-pos))",[0,[2,"boxenv-pos"]],["compiler/zo-structs"]],
["boxenv?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._boxenv~3f))",[0,[2,"boxenv?"]],["compiler/zo-structs"]],
["boxes",">guide/boxes.html","Boxes",false],
["boxes",">htdp-langs/advanced.html#(part._htdp-advanced._.Boxes)","Boxes",false],
["boxes",">reference/boxes.html","Boxes",false],
["boxing context",">scribble/core.html#(tech._boxing._context)","<span style=\"font-style: italic\">boxing context</span>",false],
["boxof",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Boxof))",[0,[1,"Boxof"]],["typed/racket/base","typed/racket"]],
["br",">html/index.html#(def._((lib._html/main..rkt)._br))",[0,[2,"br"]],["html"]],
["br?",">html/index.html#(def._((lib._html/main..rkt)._br~3f))",[0,[2,"br?"]],["html"]],
["bracketed character class",">guide/regexp-chars.html#(tech._bracketed._character._clas)","<span style=\"font-style: italic\">bracketed\ncharacter class</span>",false],
["branch",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._branch))",[0,[2,"branch"]],["compiler/zo-structs"]],
["branch-else",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._branch-else))",[0,[2,"branch-else"]],["compiler/zo-structs"]],
["branch-test",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._branch-test))",[0,[2,"branch-test"]],["compiler/zo-structs"]],
["branch-then",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._branch-then))",[0,[2,"branch-then"]],["compiler/zo-structs"]],
["branch?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._branch~3f))",[0,[2,"branch?"]],["compiler/zo-structs"]],
["breadth-first search",">games/Breadth-first_Search.html","Breadth-first Search",false],
["break",">srfi-std/srfi-1.html#break",[0,[2,"break"]],["srfi/1"]],
["break",">reference/breakhandler.html#(tech._break)","<span style=\"font-style: italic\">break</span>",false],
["break button",">drracket/buttons.html#(idx._(gentag._15._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Break</span> button",false],
["break button",">tools/Expanding_and_Breaking.html#(idx._(gentag._25._(lib._scribblings/tools/tools..scrbl)))","break button",false],
["break menu item",">drracket/Menus.html#(idx._(gentag._123._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Break</span> menu item",false],
["break!",">srfi-std/srfi-1.html#break!",[0,[2,"break!"]],["srfi/1"]],
["break-callback",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aframe~25)._break-callback))",[[0,[2,"break-callback"]],[14,[" (method of ",[0,[2,"drracket:unit:frame%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["break-callback",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3atab~3c~25~3e)._break-callback))",[[0,[2,"break-callback"]],[14,[" (method of ",[0,[2,"drracket:unit:tab<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["break-enabled",">reference/breakhandler.html#(def._((quote._~23~25kernel)._break-enabled))",[0,[2,"break-enabled"]],["racket/base","racket"]],
["break-evaluator",">reference/Sandboxed_Evaluation.html#(def._((lib._racket/sandbox..rkt)._break-evaluator))",[0,[2,"break-evaluator"]],["racket/sandbox"]],
["break-lines",">unstable/Pretty-Printing.html#(def._((lib._unstable/pretty..rkt)._break-lines))",[0,[2,"break-lines"]],["unstable/pretty"]],
["break-sequence",">gui/keymap_.html#(meth._(((lib._mred/main..rkt)._keymap~25)._break-sequence))",[[0,[2,"break-sequence"]],[14,[" (method of ",[0,[2,"keymap%"]],")"]]],["racket/gui/base","racket/gui"]],
["break-thread",">reference/threads.html#(def._((quote._~23~25kernel)._break-thread))",[0,[2,"break-thread"]],["racket/base","racket"]],
["breaking",">tools/Expanding_and_Breaking.html#(idx._(gentag._24._(lib._scribblings/tools/tools..scrbl)))","breaking",false],
["breaking up the display",">continue/index.html#(part._.Breaking_.Up_the_.Display)","Breaking Up the Display",false],
["breaks",">reference/breakhandler.html","Breaks",false],
["brinfo",">tools/Documentation_Utilities.html#(def._((lib._help/bug-report..rkt)._brinfo))",[0,[2,"brinfo"]],["help/bug-report"]],
["brinfo-id",">tools/Documentation_Utilities.html#(def._((lib._help/bug-report..rkt)._brinfo-id))",[0,[2,"brinfo-id"]],["help/bug-report"]],
["brinfo-title",">tools/Documentation_Utilities.html#(def._((lib._help/bug-report..rkt)._brinfo-title))",[0,[2,"brinfo-title"]],["help/bug-report"]],
["brinfo?",">tools/Documentation_Utilities.html#(def._((lib._help/bug-report..rkt)._brinfo~3f))",[0,[2,"brinfo?"]],["help/bug-report"]],
["bring frame to front... menu item",">drracket/Menus.html#(idx._(gentag._145._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Bring Frame to Front...</span> menu item",false],
["broken-wxme-big-endian?",">gui/WXME_Decoding.html#(def._((lib._wxme/main..rkt)._broken-wxme-big-endian~3f))",[0,[2,"broken-wxme-big-endian?"]],["wxme"]],
["brown",">unstable/pict.html#(def._((lib._unstable/gui/pict..rkt)._brown))",[0,[2,"brown"]],["unstable/gui/pict"]],
["brown-block",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._brown-block))",[0,[2,"brown-block"]],["2htdp/planetcute"]],
["browse-syntax",">macro-debugger/index.html#(def._((lib._macro-debugger/syntax-browser..rkt)._browse-syntax))",[0,[2,"browse-syntax"]],["macro-debugger/syntax-browser"]],
["browse-syntaxes",">macro-debugger/index.html#(def._((lib._macro-debugger/syntax-browser..rkt)._browse-syntaxes))",[0,[2,"browse-syntaxes"]],["macro-debugger/syntax-browser"]],
["browser",">browser/index.html#(part._browser)","Browser",false],
["browser",">drracket/prefs-explanation.html#(part._.Browser)","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Browser</span>",false],
["browser",">browser/index.html#(mod-path._browser)",[9,[0,"browser"]],"module"],
["browser signature",">browser/index.html#(part._browser-sig)","Browser Signature",false],
["browser unit",">browser/index.html#(part._browser-unit)","Browser Unit",false],
["browser-preference?",">browser/index.html#(def._((lib._browser/external..rkt)._browser-preference~3f))",[0,[2,"browser-preference?"]],["browser/external"]],
["browser-preference?",">net/sendurl.html#(def._((lib._net/sendurl..rkt)._browser-preference~3f))",[0,[2,"browser-preference?"]],["net/sendurl"]],
["browser/browser-sig",">browser/index.html#(mod-path._browser/browser-sig)",[9,[0,"browser/browser-sig"]],"module"],
["browser/browser-unit",">browser/index.html#(mod-path._browser/browser-unit)",[9,[0,"browser/browser-unit"]],"module"],
["browser/external",">browser/index.html#(mod-path._browser/external)",[9,[0,"browser/external"]],"module"],
["browser/htmltext",">browser/index.html#(mod-path._browser/htmltext)",[9,[0,"browser/htmltext"]],"module"],
["browser/tool",">browser/index.html#(mod-path._browser/tool)",[9,[0,"browser/tool"]],"module"],
["browser: simple html rendering",">browser/index.html","Browser: Simple HTML Rendering",false],
["browser@",">browser/index.html#(def._((lib._browser/browser-unit..rkt)._browser~40))",[0,[2,"browser@"]],["browser/browser-unit"]],
["browser^",">browser/index.html#(form._((lib._browser/browser-sig..rkt)._browser~5e))",[0,[1,"browser^"]],["browser/browser-sig"]],
["brush",">draw/overview.html#(tech._brush)","<span style=\"font-style: italic\">brush</span>",false],
["brush stipple",">draw/brush_.html#(tech._brush._stipple)","<span style=\"font-style: italic\">brush stipple</span>",false],
["brush style",">draw/brush_.html#(tech._brush._style)","<span style=\"font-style: italic\">brush style</span>",false],
["brush transformation",">draw/brush_.html#(tech._brush._transformation)","<span style=\"font-style: italic\">brush transformation</span>",false],
["brush%",">draw/brush_.html",[0,[2,"brush%"]],["racket/draw"]],
["brush-list%",">draw/brush-list_.html",[0,[2,"brush-list%"]],["racket/draw"]],
["bt",">slideshow/Primary_Slide_Functions.html#(def._((lib._slideshow/base..rkt)._bt))",[0,[2,"bt"]],["slideshow/base","slideshow"]],
["buffer-mode",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_576",[0,[1,"buffer-mode"]],["rnrs/io/ports-6"]],
["buffer-mode?",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_578",[0,[2,"buffer-mode?"]],["rnrs/io/ports-6"]],
["buffered asynchronous channels",">reference/async-channel.html","Buffered Asynchronous Channels",false],
["bug reporting",">tools/Documentation_Utilities.html#(part._.Bug_.Reporting)","Bug Reporting",false],
["build a distribution archive",">planet/Developing_Packages_for_PLaneT.html#(part._.Build_a_.Distribution_.Archive)","Build a Distribution Archive",false],
["build-absolute-path",">mzlib/mzlib_file.html#(def._((lib._mzlib/file..rkt)._build-absolute-path))",[0,[2,"build-absolute-path"]],["mzlib/file"]],
["build-aux-from-path",">raco/exe.html#(def._((lib._launcher/launcher..rkt)._build-aux-from-path))",[0,[2,"build-aux-from-path"]],["launcher/launcher"]],
["build-bitmap",">mrlib/Cache-image_Snip.html#(def._((lib._mrlib/cache-image-snip..rkt)._build-bitmap))",[0,[2,"build-bitmap"]],["mrlib/cache-image-snip"]],
["build-chaperone-contract-property",">reference/Building_New_Contract_Combinators.html#(def._((lib._racket/contract/private/prop..rkt)._build-chaperone-contract-property))",[0,[2,"build-chaperone-contract-property"]],["racket/contract/combinator","racket/contract","racket"]],
["build-compound-type-name",">reference/Building_New_Contract_Combinators.html#(def._((lib._racket/contract/private/guts..rkt)._build-compound-type-name))",[0,[2,"build-compound-type-name"]],["racket/contract/combinator","racket/contract","racket"]],
["build-contract-property",">reference/Building_New_Contract_Combinators.html#(def._((lib._racket/contract/private/prop..rkt)._build-contract-property))",[0,[2,"build-contract-property"]],["racket/contract/combinator","racket/contract","racket"]],
["build-distributed-launch-path",">reference/distributed-places.html#(def._((lib._racket/place/distributed..rkt)._build-distributed-launch-path))",[0,[2,"build-distributed-launch-path"]],["racket/place/distributed"]],
["build-expand-context",">syntax/transformer-helpers.html#(def._((lib._syntax/context..rkt)._build-expand-context))",[0,[2,"build-expand-context"]],["syntax/context"]],
["build-flat-contract",">mzlib/mzlib_contract.html#(def._((lib._mzlib/contract..rkt)._build-flat-contract))",[0,[2,"build-flat-contract"]],["mzlib/contract"]],
["build-flat-contract-property",">reference/Building_New_Contract_Combinators.html#(def._((lib._racket/contract/private/prop..rkt)._build-flat-contract-property))",[0,[2,"build-flat-contract-property"]],["racket/contract/combinator","racket/contract","racket"]],
["build-flomap",">images/Conversion_and_Construction.html#(def._((lib._images/flomap..rkt)._build-flomap))",[0,[2,"build-flomap"]],["images/flomap"]],
["build-flomap*",">images/Conversion_and_Construction.html#(def._((lib._images/flomap..rkt)._build-flomap*))",[0,[2,"build-flomap*"]],["images/flomap"]],
["build-image",">picturing-programs/index.html#(def._((lib._picturing-programs/private/map-image..rkt)._build-image))",[0,[2,"build-image"]],["picturing-programs/private/map-image","picturing-programs"]],
["build-image/extra",">picturing-programs/index.html#(def._((lib._picturing-programs/private/map-image..rkt)._build-image/extra))",[0,[2,"build-image/extra"]],["picturing-programs/private/map-image","picturing-programs"]],
["build-list",">reference/pairs.html#(def._((lib._racket/private/list..rkt)._build-list))",[0,[2,"build-list"]],["racket/base","racket"]],
["build-list",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._build-list))",[0,[2,"build-list"]],["lang/htdp-advanced"]],
["build-list",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._build-list))",[0,[2,"build-list"]],["lang/htdp-intermediate"]],
["build-list",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._build-list))",[0,[2,"build-list"]],["lang/htdp-intermediate-lambda"]],
["build-list",">lazy/index.html#(def._((lib._lazy/main..rkt)._build-list))",[0,[2,"build-list"]],["lazy"]],
["build-lw",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._build-lw))",[0,[2,"build-lw"]],["redex/pict","redex"]],
["build-matrix",">teachpack/matrix.html#(def._((lib._htdp/matrix..rkt)._build-matrix))",[0,[2,"build-matrix"]],["htdp/matrix"]],
["build-path",">reference/Manipulating_Paths.html#(def._((quote._~23~25kernel)._build-path))",[0,[2,"build-path"]],["racket/base","racket"]],
["build-path-unless-absolute",">web-server-internal/misc-util.html#(def._((lib._web-server/private/util..rkt)._build-path-unless-absolute))",[0,[2,"build-path-unless-absolute"]],["web-server/private/util"]],
["build-path/convention-type",">reference/Manipulating_Paths.html#(def._((quote._~23~25kernel)._build-path/convention-type))",[0,[2,"build-path/convention-type"]],["racket/base","racket"]],
["build-relative-path",">mzlib/mzlib_file.html#(def._((lib._mzlib/file..rkt)._build-relative-path))",[0,[2,"build-relative-path"]],["mzlib/file"]],
["build-scribble-docs?",">planet/Utility_Libraries.html#(def._((lib._planet/util..rkt)._build-scribble-docs~3f))",[0,[2,"build-scribble-docs?"]],["planet/util"]],
["build-share",">mzlib/mzlib_pconvert.html#(def._((lib._mzlib/pconvert..rkt)._build-share))",[0,[2,"build-share"]],["mzlib/pconvert"]],
["build-source-location",">syntax/Source_Locations.html#(def._((lib._syntax/srcloc..rkt)._build-source-location))",[0,[2,"build-source-location"]],["syntax/srcloc"]],
["build-source-location-list",">syntax/Source_Locations.html#(def._((lib._syntax/srcloc..rkt)._build-source-location-list))",[0,[2,"build-source-location-list"]],["syntax/srcloc"]],
["build-source-location-syntax",">syntax/Source_Locations.html#(def._((lib._syntax/srcloc..rkt)._build-source-location-syntax))",[0,[2,"build-source-location-syntax"]],["syntax/srcloc"]],
["build-source-location-vector",">syntax/Source_Locations.html#(def._((lib._syntax/srcloc..rkt)._build-source-location-vector))",[0,[2,"build-source-location-vector"]],["syntax/srcloc"]],
["build-string",">reference/strings.html#(def._((lib._racket/private/list..rkt)._build-string))",[0,[2,"build-string"]],["racket/base","racket"]],
["build-string",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._build-string))",[0,[2,"build-string"]],["lang/htdp-advanced"]],
["build-string",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._build-string))",[0,[2,"build-string"]],["lang/htdp-intermediate"]],
["build-string",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._build-string))",[0,[2,"build-string"]],["lang/htdp-intermediate-lambda"]],
["build-struct-expand-info",">syntax/transformer-helpers.html#(def._((lib._syntax/struct..rkt)._build-struct-expand-info))",[0,[2,"build-struct-expand-info"]],["syntax/struct"]],
["build-struct-generation",">syntax/transformer-helpers.html#(def._((lib._syntax/struct..rkt)._build-struct-generation))",[0,[2,"build-struct-generation"]],["syntax/struct"]],
["build-struct-generation*",">syntax/transformer-helpers.html#(def._((lib._syntax/struct..rkt)._build-struct-generation*))",[0,[2,"build-struct-generation*"]],["syntax/struct"]],
["build-struct-names",">syntax/transformer-helpers.html#(def._((lib._syntax/struct..rkt)._build-struct-names))",[0,[2,"build-struct-names"]],["syntax/struct"]],
["build-test-engine",">htdp/index.html#(def._((lib._test-engine/racket-tests..rkt)._build-test-engine))",[0,[2,"build-test-engine"]],["htdp/testing"]],
["build-vector",">reference/vectors.html#(def._((lib._racket/private/list..rkt)._build-vector))",[0,[2,"build-vector"]],["racket/base","racket"]],
["build-vector",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._build-vector))",[0,[2,"build-vector"]],["lang/htdp-advanced"]],
["build3-image",">picturing-programs/index.html#(def._((lib._picturing-programs/private/map-image..rkt)._build3-image))",[0,[2,"build3-image"]],["picturing-programs/private/map-image","picturing-programs"]],
["build4-image",">picturing-programs/index.html#(def._((lib._picturing-programs/private/map-image..rkt)._build4-image))",[0,[2,"build4-image"]],["picturing-programs/private/map-image","picturing-programs"]],
["builder",">htdp/index.html#(def._((lib._test-engine/racket-tests..rkt)._builder))",[0,[2,"builder"]],["htdp/testing"]],
["building mutators",">plai/mutator.html#(part._.Building_.Mutators)","Building Mutators",false],
["building native-code extensions",">make/setup-extension.html","Building Native-Code Extensions",false],
["building new contract combinators",">reference/Building_New_Contract_Combinators.html","Building New Contract Combinators",false],
["buildings",">teachpack/2htdpPlanet_Cute_Images.html#(part._pc~3a.Buildings)","Buildings",false],
["built-in datatypes",">guide/datatypes.html","Built-In Datatypes",false],
["built-in exception types",">reference/exns.html#(part._.Built-in_.Exception_.Types)","Built-in Exception Types",false],
["built-in url patterns",">web-server/dispatch.html#(part._.Built-in_.U.R.L_patterns)","Built-in URL patterns",false],
["bullet",">slideshow/Constants_and_Layout_Variables.html#(def._((lib._slideshow/base..rkt)._bullet))",[0,[2,"bullet"]],["slideshow/base","slideshow"]],
["bullet-size",">browser/index.html#(def._((lib._browser/browser..rkt)._bullet-size))",[0,[2,"bullet-size"]],["browser/browser","browser"]],
["bundle-directory",">raco/exe-dist.html#(def._((lib._compiler/bundle-dist..rkt)._bundle-directory))",[0,[2,"bundle-directory"]],["compiler/bundle-dist"]],
["bundle-put-file-extension+style+filters",">raco/exe-dist.html#(def._((lib._compiler/bundle-dist..rkt)._bundle-put-file-extension+style+filters))",[0,[2,"bundle-put-file-extension+style+filters"]],["compiler/bundle-dist"]],
["bundle?",">teachpack/2htdpuniverse.html#(def._((lib._2htdp/universe..rkt)._bundle~3f))",[0,[2,"bundle?"]],["2htdp/universe"]],
["bundled games",">games/bundled.html","Bundled Games",false],
["butterfly attractor",">turtles/Traditional_Turtles.html#(idx._(gentag._3._(lib._graphics/scribblings/turtles..scrbl)))","butterfly attractor",false],
["button",">html/index.html#(def._((lib._html/main..rkt)._button))",[0,[2,"button"]],["html"]],
["button",">web-server/formlets.html#(def._((lib._web-server/formlets/input..rkt)._button))",[0,[2,"button"]],["web-server/formlets/input"]],
["button",">gui/button_.html#(idx._(gentag._20._(lib._scribblings/gui/gui..scrbl)))",[7,"'button"],false],
["button",">gui/windowing-overview.html#(tech._button)","<span style=\"font-style: italic\">button</span>",false],
["button%",">gui/button_.html",[0,[2,"button%"]],["racket/gui/base","racket/gui"]],
["button-changed?",">gui/mouse-event_.html#(meth._(((lib._mred/main..rkt)._mouse-event~25)._button-changed~3f))",[[0,[2,"button-changed?"]],[14,[" (method of ",[0,[2,"mouse-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["button-down?",">gui/mouse-event_.html#(meth._(((lib._mred/main..rkt)._mouse-event~25)._button-down~3f))",[[0,[2,"button-down?"]],[14,[" (method of ",[0,[2,"mouse-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["button-snip%",">embedded-gui/button-snip_.html",[0,[2,"button-snip%"]],["embedded-gui"]],
["button-up?",">gui/mouse-event_.html#(meth._(((lib._mred/main..rkt)._mouse-event~25)._button-up~3f))",[[0,[2,"button-up?"]],[14,[" (method of ",[0,[2,"mouse-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["button?",">html/index.html#(def._((lib._html/main..rkt)._button~3f))",[0,[2,"button?"]],["html"]],
["buttons",">drracket/buttons.html","Buttons",false],
["by-reference arguments",">foreign/intro.html#(part._.By-.Reference_.Arguments)","By-Reference Arguments",false],
["byte",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Byte))",[0,[1,"Byte"]],["typed/racket/base","typed/racket"]],
["byte",">guide/bytestrings.html#(tech._byte)","<span style=\"font-style: italic\">byte</span>",false],
["byte and string input",">reference/Byte_and_String_Input.html","Byte and String Input",false],
["byte and string output",">reference/Byte_and_String_Output.html","Byte and String Output",false],
["byte converter",">reference/bytestrings.html#(tech._byte._converter)","<span style=\"font-style: italic\">byte converter</span>",false],
["byte string",">guide/bytestrings.html#(tech._byte._string)","<span style=\"font-style: italic\">byte string</span>",false],
["byte string",">reference/bytestrings.html#(tech._byte._string)","<span style=\"font-style: italic\">byte string</span>",false],
["byte string comparisons",">reference/bytestrings.html#(part._.Byte_.String_.Comparisons)","Byte String Comparisons",false],
["byte string constructors, selectors, and mutators",">reference/bytestrings.html#(part._.Byte_.String_.Constructors__.Selectors__and_.Mutators)","Byte String Constructors, Selectors, and Mutators",false],
["byte strings parsing",">reference/reader.html#(idx._(gentag._32._(lib._scribblings/reference/reference..scrbl)))","byte strings, parsing",false],
["byte strings immutable",">reference/bytestrings.html#(idx._(gentag._112._(lib._scribblings/reference/reference..scrbl)))","byte strings, immutable",false],
["byte strings concatenate",">reference/bytestrings.html#(idx._(gentag._113._(lib._scribblings/reference/reference..scrbl)))","byte strings, concatenate",false],
["byte strings",">reference/bytestrings.html","Byte Strings",false],
["byte-pregexp",">reference/regexp.html#(def._((quote._~23~25kernel)._byte-pregexp))",[0,[2,"byte-pregexp"]],["racket/base","racket"]],
["byte-pregexp",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Byte-.P.Regexp))",[0,[1,"Byte-PRegexp"]],["typed/racket/base","typed/racket"]],
["byte-pregexp?",">reference/regexp.html#(def._((quote._~23~25kernel)._byte-pregexp~3f))",[0,[2,"byte-pregexp?"]],["racket/base","racket"]],
["byte-ready?",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._byte-ready~3f))",[0,[2,"byte-ready?"]],["racket/base","racket"]],
["byte-regexp",">reference/regexp.html#(def._((quote._~23~25kernel)._byte-regexp))",[0,[2,"byte-regexp"]],["racket/base","racket"]],
["byte-regexp",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Byte-.Regexp))",[0,[1,"Byte-Regexp"]],["typed/racket/base","typed/racket"]],
["byte-regexp?",">reference/regexp.html#(def._((quote._~23~25kernel)._byte-regexp~3f))",[0,[2,"byte-regexp?"]],["racket/base","racket"]],
["byte?",">reference/bytestrings.html#(def._((quote._~23~25kernel)._byte~3f))",[0,[2,"byte?"]],["racket/base","racket"]],
["bytecode compilation",">raco/API_for_Raw_Compilation.html#(part._api~3azo)","Bytecode Compilation",false],
["bytecode files",">raco/make.html#(part._.Bytecode_.Files)","Bytecode Files",false],
["bytecode representation",">raco/decompile.html#(part._.Bytecode_.Representation)","Bytecode Representation",false],
["bytes",">unstable/bytes.html","Bytes",false],
["bytes",">reference/bytestrings.html#(def._((quote._~23~25kernel)._bytes))",[0,[2,"bytes"]],["racket/base","racket"]],
["bytes",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Bytes))",[0,[1,"Bytes"]],["typed/racket/base","typed/racket"]],
["bytes",">reference/bytestrings.html#(idx._(gentag._111._(lib._scribblings/reference/reference..scrbl)))","bytes",false],
["bytes and byte strings",">guide/bytestrings.html","Bytes and Byte Strings",false],
["bytes to bytes encoding conversion",">reference/bytestrings.html#(part._.Bytes_to_.Bytes_.Encoding_.Conversion)","Bytes to Bytes Encoding Conversion",false],
["bytes to/from characters, decoding and encoding",">reference/bytestrings.html#(part._.Bytes_to_from_.Characters__.Decoding_and_.Encoding)","Bytes to/from Characters, Decoding and Encoding",false],
["bytes, characters, and encodings",">guide/encodings.html","Bytes, Characters, and Encodings",false],
["bytes->hex-string",">file/sha1b.html#(def._((lib._file/sha1..rkt)._bytes-~3ehex-string))",[0,[2,"bytes->hex-string"]],["file/sha1"]],
["bytes->hex-string",">openssl/index.html#(def._((lib._openssl/sha1..rkt)._bytes-~3ehex-string))",[0,[2,"bytes->hex-string"]],["openssl/sha1"]],
["bytes->immutable-bytes",">reference/bytestrings.html#(def._((quote._~23~25kernel)._bytes-~3eimmutable-bytes))",[0,[2,"bytes->immutable-bytes"]],["racket/base","racket"]],
["bytes->jsexpr",">json/index.html#(def._((lib._json/main..rkt)._bytes-~3ejsexpr))",[0,[2,"bytes->jsexpr"]],["json"]],
["bytes->list",">reference/bytestrings.html#(def._((quote._~23~25kernel)._bytes-~3elist))",[0,[2,"bytes->list"]],["racket/base","racket"]],
["bytes->path",">reference/Manipulating_Paths.html#(def._((quote._~23~25kernel)._bytes-~3epath))",[0,[2,"bytes->path"]],["racket/base","racket"]],
["bytes->path-element",">reference/Manipulating_Paths.html#(def._((quote._~23~25kernel)._bytes-~3epath-element))",[0,[2,"bytes->path-element"]],["racket/base","racket"]],
["bytes->string/latin-1",">reference/bytestrings.html#(def._((quote._~23~25kernel)._bytes-~3estring/latin-1))",[0,[2,"bytes->string/latin-1"]],["racket/base","racket"]],
["bytes->string/locale",">reference/bytestrings.html#(def._((quote._~23~25kernel)._bytes-~3estring/locale))",[0,[2,"bytes->string/locale"]],["racket/base","racket"]],
["bytes->string/utf-8",">reference/bytestrings.html#(def._((quote._~23~25kernel)._bytes-~3estring/utf-8))",[0,[2,"bytes->string/utf-8"]],["racket/base","racket"]],
["bytes-append",">reference/bytestrings.html#(def._((quote._~23~25kernel)._bytes-append))",[0,[2,"bytes-append"]],["racket/base","racket"]],
["bytes-append*",">reference/bytestrings.html#(def._((lib._racket/bytes..rkt)._bytes-append*))",[0,[2,"bytes-append*"]],["racket/bytes","racket"]],
["bytes-ci=?",">web-server-internal/misc-util.html#(def._((lib._web-server/private/util..rkt)._bytes-ci~3d~3f))",[0,[2,"bytes-ci=?"]],["web-server/private/util"]],
["bytes-close-converter",">reference/bytestrings.html#(def._((quote._~23~25kernel)._bytes-close-converter))",[0,[2,"bytes-close-converter"]],["racket/base","racket"]],
["bytes-convert",">reference/bytestrings.html#(def._((quote._~23~25kernel)._bytes-convert))",[0,[2,"bytes-convert"]],["racket/base","racket"]],
["bytes-convert-end",">reference/bytestrings.html#(def._((quote._~23~25kernel)._bytes-convert-end))",[0,[2,"bytes-convert-end"]],["racket/base","racket"]],
["bytes-converter",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Bytes-.Converter))",[0,[1,"Bytes-Converter"]],["typed/racket/base","typed/racket"]],
["bytes-converter?",">reference/bytestrings.html#(def._((quote._~23~25kernel)._bytes-converter~3f))",[0,[2,"bytes-converter?"]],["racket/base","racket"]],
["bytes-copy",">reference/bytestrings.html#(def._((quote._~23~25kernel)._bytes-copy))",[0,[2,"bytes-copy"]],["racket/base","racket"]],
["bytes-copy!",">reference/bytestrings.html#(def._((quote._~23~25kernel)._bytes-copy!))",[0,[2,"bytes-copy!"]],["racket/base","racket"]],
["bytes-fill!",">reference/bytestrings.html#(def._((quote._~23~25kernel)._bytes-fill!))",[0,[2,"bytes-fill!"]],["racket/base","racket"]],
["bytes-join",">reference/bytestrings.html#(def._((lib._racket/bytes..rkt)._bytes-join))",[0,[2,"bytes-join"]],["racket/bytes","racket"]],
["bytes-length",">reference/bytestrings.html#(def._((quote._~23~25kernel)._bytes-length))",[0,[2,"bytes-length"]],["racket/base","racket"]],
["bytes-no-nuls?",">reference/subprocess.html#(def._((lib._racket/system..rkt)._bytes-no-nuls~3f))",[0,[2,"bytes-no-nuls?"]],["racket/system","racket"]],
["bytes-open-converter",">reference/bytestrings.html#(def._((quote._~23~25kernel)._bytes-open-converter))",[0,[2,"bytes-open-converter"]],["racket/base","racket"]],
["bytes-ref",">reference/bytestrings.html#(def._((quote._~23~25kernel)._bytes-ref))",[0,[2,"bytes-ref"]],["racket/base","racket"]],
["bytes-set!",">reference/bytestrings.html#(def._((quote._~23~25kernel)._bytes-set!))",[0,[2,"bytes-set!"]],["racket/base","racket"]],
["bytes-utf-8-index",">reference/bytestrings.html#(def._((quote._~23~25kernel)._bytes-utf-8-index))",[0,[2,"bytes-utf-8-index"]],["racket/base","racket"]],
["bytes-utf-8-length",">reference/bytestrings.html#(def._((quote._~23~25kernel)._bytes-utf-8-length))",[0,[2,"bytes-utf-8-length"]],["racket/base","racket"]],
["bytes-utf-8-ref",">reference/bytestrings.html#(def._((quote._~23~25kernel)._bytes-utf-8-ref))",[0,[2,"bytes-utf-8-ref"]],["racket/base","racket"]],
["bytes<?",">reference/bytestrings.html#(def._((quote._~23~25kernel)._bytes~3c~3f))",[0,[2,"bytes<?"]],["racket/base","racket"]],
["bytes=?",">reference/bytestrings.html#(def._((quote._~23~25kernel)._bytes~3d~3f))",[0,[2,"bytes=?"]],["racket/base","racket"]],
["bytes>?",">reference/bytestrings.html#(def._((quote._~23~25kernel)._bytes~3e~3f))",[0,[2,"bytes>?"]],["racket/base","racket"]],
["bytes?",">reference/bytestrings.html#(def._((quote._~23~25kernel)._bytes~3f))",[0,[2,"bytes?"]],["racket/base","racket"]],
["bytevector->sint-list",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_118",[0,[2,"bytevector->sint-list"]],["rnrs/bytevectors-6"]],
["bytevector->string",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_630",[0,[2,"bytevector->string"]],["rnrs/io/ports-6"]],
["bytevector->u8-list",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_104",[0,[2,"bytevector->u8-list"]],["rnrs/bytevectors-6"]],
["bytevector->uint-list",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_116",[0,[2,"bytevector->uint-list"]],["rnrs/bytevectors-6"]],
["bytevector-copy",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_94",[0,[2,"bytevector-copy"]],["rnrs/bytevectors-6"]],
["bytevector-copy!",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_92",[0,[2,"bytevector-copy!"]],["rnrs/bytevectors-6"]],
["bytevector-fill!",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_90",[0,[2,"bytevector-fill!"]],["rnrs/bytevectors-6"]],
["bytevector-ieee-double-native-ref",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_176",[0,[2,"bytevector-ieee-double-native-ref"]],["rnrs/bytevectors-6"]],
["bytevector-ieee-double-native-set!",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_182",[0,[2,"bytevector-ieee-double-native-set!"]],["rnrs/bytevectors-6"]],
["bytevector-ieee-double-ref",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_178",[0,[2,"bytevector-ieee-double-ref"]],["rnrs/bytevectors-6"]],
["bytevector-ieee-single-native-ref",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_172",[0,[2,"bytevector-ieee-single-native-ref"]],["rnrs/bytevectors-6"]],
["bytevector-ieee-single-native-set!",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_180",[0,[2,"bytevector-ieee-single-native-set!"]],["rnrs/bytevectors-6"]],
["bytevector-ieee-single-ref",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_174",[0,[2,"bytevector-ieee-single-ref"]],["rnrs/bytevectors-6"]],
["bytevector-length",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_86",[0,[2,"bytevector-length"]],["rnrs/bytevectors-6"]],
["bytevector-s16-native-ref",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_130",[0,[2,"bytevector-s16-native-ref"]],["rnrs/bytevectors-6"]],
["bytevector-s16-native-set!",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_138",[0,[2,"bytevector-s16-native-set!"]],["rnrs/bytevectors-6"]],
["bytevector-s16-ref",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_126",[0,[2,"bytevector-s16-ref"]],["rnrs/bytevectors-6"]],
["bytevector-s16-set!",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_134",[0,[2,"bytevector-s16-set!"]],["rnrs/bytevectors-6"]],
["bytevector-s32-native-ref",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_146",[0,[2,"bytevector-s32-native-ref"]],["rnrs/bytevectors-6"]],
["bytevector-s32-native-set!",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_154",[0,[2,"bytevector-s32-native-set!"]],["rnrs/bytevectors-6"]],
["bytevector-s32-ref",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_142",[0,[2,"bytevector-s32-ref"]],["rnrs/bytevectors-6"]],
["bytevector-s32-set!",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_150",[0,[2,"bytevector-s32-set!"]],["rnrs/bytevectors-6"]],
["bytevector-s64-native-ref",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_162",[0,[2,"bytevector-s64-native-ref"]],["rnrs/bytevectors-6"]],
["bytevector-s64-native-set!",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_170",[0,[2,"bytevector-s64-native-set!"]],["rnrs/bytevectors-6"]],
["bytevector-s64-ref",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_158",[0,[2,"bytevector-s64-ref"]],["rnrs/bytevectors-6"]],
["bytevector-s64-set!",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_166",[0,[2,"bytevector-s64-set!"]],["rnrs/bytevectors-6"]],
["bytevector-s8-ref",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_98",[0,[2,"bytevector-s8-ref"]],["rnrs/bytevectors-6"]],
["bytevector-s8-set!",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_102",[0,[2,"bytevector-s8-set!"]],["rnrs/bytevectors-6"]],
["bytevector-sint-ref",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_110",[0,[2,"bytevector-sint-ref"]],["rnrs/bytevectors-6"]],
["bytevector-sint-set!",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_114",[0,[2,"bytevector-sint-set!"]],["rnrs/bytevectors-6"]],
["bytevector-u16-native-ref",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_128",[0,[2,"bytevector-u16-native-ref"]],["rnrs/bytevectors-6"]],
["bytevector-u16-native-set!",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_136",[0,[2,"bytevector-u16-native-set!"]],["rnrs/bytevectors-6"]],
["bytevector-u16-ref",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_124",[0,[2,"bytevector-u16-ref"]],["rnrs/bytevectors-6"]],
["bytevector-u16-set!",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_132",[0,[2,"bytevector-u16-set!"]],["rnrs/bytevectors-6"]],
["bytevector-u32-native-ref",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_144",[0,[2,"bytevector-u32-native-ref"]],["rnrs/bytevectors-6"]],
["bytevector-u32-native-set!",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_152",[0,[2,"bytevector-u32-native-set!"]],["rnrs/bytevectors-6"]],
["bytevector-u32-ref",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_140",[0,[2,"bytevector-u32-ref"]],["rnrs/bytevectors-6"]],
["bytevector-u32-set!",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_148",[0,[2,"bytevector-u32-set!"]],["rnrs/bytevectors-6"]],
["bytevector-u64-native-ref",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_160",[0,[2,"bytevector-u64-native-ref"]],["rnrs/bytevectors-6"]],
["bytevector-u64-native-set!",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_168",[0,[2,"bytevector-u64-native-set!"]],["rnrs/bytevectors-6"]],
["bytevector-u64-ref",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_156",[0,[2,"bytevector-u64-ref"]],["rnrs/bytevectors-6"]],
["bytevector-u64-set!",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_164",[0,[2,"bytevector-u64-set!"]],["rnrs/bytevectors-6"]],
["bytevector-u8-ref",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_96",[0,[2,"bytevector-u8-ref"]],["rnrs/bytevectors-6"]],
["bytevector-u8-set!",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_100",[0,[2,"bytevector-u8-set!"]],["rnrs/bytevectors-6"]],
["bytevector-uint-ref",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_108",[0,[2,"bytevector-uint-ref"]],["rnrs/bytevectors-6"]],
["bytevector-uint-set!",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_112",[0,[2,"bytevector-uint-set!"]],["rnrs/bytevectors-6"]],
["bytevector=?",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_88",[0,[2,"bytevector=?"]],["rnrs/bytevectors-6"]],
["bytevector?",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_80",[0,[2,"bytevector?"]],["rnrs/bytevectors-6"]],
["c array types",">foreign/C_Array_Types.html","C Array Types",false],
["c pointer",">foreign/Pointer_Types.html#(tech._c._pointer)","<span style=\"font-style: italic\">C pointer</span>",false],
["c struct types",">foreign/C_Struct_Types.html","C Struct Types",false],
["c structs",">foreign/intro.html#(part._.C_.Structs)","C Structs",false],
["c types",">foreign/types.html","C Types",false],
["c types",">foreign/types.html#(tech._c._type)","<span style=\"font-style: italic\">C types</span>",false],
["c union types",">foreign/C_Union_Types.html","C Union Types",false],
["c-+ keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._184._(lib._scribblings/drracket/drracket..scrbl)))","C-+ keybinding",false],
["c-\\ keybinding m-\\ keybinding c:x;l keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._216._(lib._scribblings/drracket/drracket..scrbl)))","C-\\ keybinding, M-\\ keybinding, c:x;l keybinding",false],
["c-_ keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._183._(lib._scribblings/drracket/drracket..scrbl)))","C-_ keybinding",false],
["c-a keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._164._(lib._scribblings/drracket/drracket..scrbl)))","C-a keybinding",false],
["c-b keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._157._(lib._scribblings/drracket/drracket..scrbl)))","C-b keybinding",false],
["c-c c-e keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._205._(lib._scribblings/drracket/drracket..scrbl)))","C-c C-e keybinding",false],
["c-c c-l keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._206._(lib._scribblings/drracket/drracket..scrbl)))","C-c C-l keybinding",false],
["c-c c-o keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._204._(lib._scribblings/drracket/drracket..scrbl)))","C-c C-o keybinding",false],
["c-c c-z keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._182._(lib._scribblings/drracket/drracket..scrbl)))","C-C C-Z keybinding",false],
["c-d keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._186._(lib._scribblings/drracket/drracket..scrbl)))","C-d keybinding",false],
["c-e keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._165._(lib._scribblings/drracket/drracket..scrbl)))","C-e keybinding",false],
["c-f keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._156._(lib._scribblings/drracket/drracket..scrbl)))","C-f keybinding",false],
["c-h keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._187._(lib._scribblings/drracket/drracket..scrbl)))","C-h keybinding",false],
["c-k keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._190._(lib._scribblings/drracket/drracket..scrbl)))","C-k keybinding",false],
["c-n keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._166._(lib._scribblings/drracket/drracket..scrbl)))","C-n keybinding",false],
["c-p keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._167._(lib._scribblings/drracket/drracket..scrbl)))","C-p keybinding",false],
["c-r keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._212._(lib._scribblings/drracket/drracket..scrbl)))","C-r keybinding",false],
["c-s keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._211._(lib._scribblings/drracket/drracket..scrbl)))","C-s keybinding",false],
["c-style opengl",">sgl/gl.html","C-Style OpenGL",false],
["c-t keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._195._(lib._scribblings/drracket/drracket..scrbl)))","C-t keybinding",false],
["c-v keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._160._(lib._scribblings/drracket/drracket..scrbl)))","C-v keybinding",false],
["c-w keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._193._(lib._scribblings/drracket/drracket..scrbl)))","C-w keybinding",false],
["c-x c-s keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._209._(lib._scribblings/drracket/drracket..scrbl)))","C-x C-s keybinding",false],
["c-x c-w keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._210._(lib._scribblings/drracket/drracket..scrbl)))","C-x C-w keybinding",false],
["c-x u keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._185._(lib._scribblings/drracket/drracket..scrbl)))","C-x u keybinding",false],
["c-y keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._194._(lib._scribblings/drracket/drracket..scrbl)))","C-y keybinding",false],
["caaaar",">reference/pairs.html#(def._((quote._~23~25kernel)._caaaar))",[0,[2,"caaaar"]],["racket/base","racket"]],
["caaaar",">lazy/index.html#(def._((lib._lazy/main..rkt)._caaaar))",[0,[2,"caaaar"]],["lazy"]],
["caaadr",">reference/pairs.html#(def._((quote._~23~25kernel)._caaadr))",[0,[2,"caaadr"]],["racket/base","racket"]],
["caaadr",">lazy/index.html#(def._((lib._lazy/main..rkt)._caaadr))",[0,[2,"caaadr"]],["lazy"]],
["caaar",">reference/pairs.html#(def._((quote._~23~25kernel)._caaar))",[0,[2,"caaar"]],["racket/base","racket"]],
["caaar",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._caaar))",[0,[2,"caaar"]],["lang/htdp-advanced"]],
["caaar",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._caaar))",[0,[2,"caaar"]],["lang/htdp-beginner"]],
["caaar",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._caaar))",[0,[2,"caaar"]],["lang/htdp-beginner-abbr"]],
["caaar",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._caaar))",[0,[2,"caaar"]],["lang/htdp-intermediate"]],
["caaar",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._caaar))",[0,[2,"caaar"]],["lang/htdp-intermediate-lambda"]],
["caaar",">lazy/index.html#(def._((lib._lazy/main..rkt)._caaar))",[0,[2,"caaar"]],["lazy"]],
["caadar",">reference/pairs.html#(def._((quote._~23~25kernel)._caadar))",[0,[2,"caadar"]],["racket/base","racket"]],
["caadar",">lazy/index.html#(def._((lib._lazy/main..rkt)._caadar))",[0,[2,"caadar"]],["lazy"]],
["caaddr",">reference/pairs.html#(def._((quote._~23~25kernel)._caaddr))",[0,[2,"caaddr"]],["racket/base","racket"]],
["caaddr",">lazy/index.html#(def._((lib._lazy/main..rkt)._caaddr))",[0,[2,"caaddr"]],["lazy"]],
["caadr",">reference/pairs.html#(def._((quote._~23~25kernel)._caadr))",[0,[2,"caadr"]],["racket/base","racket"]],
["caadr",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._caadr))",[0,[2,"caadr"]],["lang/htdp-advanced"]],
["caadr",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._caadr))",[0,[2,"caadr"]],["lang/htdp-beginner"]],
["caadr",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._caadr))",[0,[2,"caadr"]],["lang/htdp-beginner-abbr"]],
["caadr",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._caadr))",[0,[2,"caadr"]],["lang/htdp-intermediate"]],
["caadr",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._caadr))",[0,[2,"caadr"]],["lang/htdp-intermediate-lambda"]],
["caadr",">lazy/index.html#(def._((lib._lazy/main..rkt)._caadr))",[0,[2,"caadr"]],["lazy"]],
["caar",">reference/pairs.html#(def._((quote._~23~25kernel)._caar))",[0,[2,"caar"]],["racket/base","racket"]],
["caar",">r5rs-std/r5rs-Z-H-9.html#%_idx_420",[0,[2,"caar"]],["r5rs"]],
["caar",">r6rs-std/r6rs-Z-H-14.html#node_idx_616",[0,[2,"caar"]],["rnrs/base-6"]],
["caar",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._caar))",[0,[2,"caar"]],["lang/htdp-advanced"]],
["caar",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._caar))",[0,[2,"caar"]],["lang/htdp-beginner"]],
["caar",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._caar))",[0,[2,"caar"]],["lang/htdp-beginner-abbr"]],
["caar",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._caar))",[0,[2,"caar"]],["lang/htdp-intermediate"]],
["caar",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._caar))",[0,[2,"caar"]],["lang/htdp-intermediate-lambda"]],
["caar",">lazy/index.html#(def._((lib._lazy/main..rkt)._caar))",[0,[2,"caar"]],["lazy"]],
["cache table",">web-server-internal/cache-table.html","Cache Table",false],
["cache-dir",">planet/Utility_Libraries.html#(def._((lib._planet/config..rkt)._.C.A.C.H.E-.D.I.R))",[0,[2,"CACHE-DIR"]],["planet/config"]],
["cache-font-metrics-key",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._cache-font-metrics-key))",[[0,[2,"cache-font-metrics-key"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["cache-image snip",">mrlib/Cache-image_Snip.html","Cache-image Snip",false],
["cache-image%",">gui/WXME_Decoding.html#(def._((lib._wxme/cache-image..rkt)._cache-image~25))",[0,[2,"cache-image%"]],["wxme/cache-image"]],
["cache-image-snip%",">mrlib/Cache-image_Snip.html#(def._((lib._mrlib/cache-image-snip..rkt)._cache-image-snip~25))",[0,[2,"cache-image-snip%"]],["mrlib/cache-image-snip"]],
["cache-table-clear!",">web-server-internal/cache-table.html#(def._((lib._web-server/private/cache-table..rkt)._cache-table-clear!))",[0,[2,"cache-table-clear!"]],["web-server/private/cache-table"]],
["cache-table-lookup!",">web-server-internal/cache-table.html#(def._((lib._web-server/private/cache-table..rkt)._cache-table-lookup!))",[0,[2,"cache-table-lookup!"]],["web-server/private/cache-table"]],
["cache-table?",">web-server-internal/cache-table.html#(def._((lib._web-server/private/cache-table..rkt)._cache-table~3f))",[0,[2,"cache-table?"]],["web-server/private/cache-table"]],
["cached installation archive",">planet/search-order.html#(part._.Cached_.Installation_.Archive)","Cached Installation Archive",false],
["caching-enabled?",">redex/The_Redex_Reference.html#(def._((lib._redex/reduction-semantics..rkt)._caching-enabled~3f))",[0,[2,"caching-enabled?"]],["redex/reduction-semantics","redex"]],
["cadaar",">reference/pairs.html#(def._((quote._~23~25kernel)._cadaar))",[0,[2,"cadaar"]],["racket/base","racket"]],
["cadaar",">lazy/index.html#(def._((lib._lazy/main..rkt)._cadaar))",[0,[2,"cadaar"]],["lazy"]],
["cadadr",">reference/pairs.html#(def._((quote._~23~25kernel)._cadadr))",[0,[2,"cadadr"]],["racket/base","racket"]],
["cadadr",">lazy/index.html#(def._((lib._lazy/main..rkt)._cadadr))",[0,[2,"cadadr"]],["lazy"]],
["cadar",">reference/pairs.html#(def._((quote._~23~25kernel)._cadar))",[0,[2,"cadar"]],["racket/base","racket"]],
["cadar",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._cadar))",[0,[2,"cadar"]],["lang/htdp-advanced"]],
["cadar",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._cadar))",[0,[2,"cadar"]],["lang/htdp-beginner"]],
["cadar",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._cadar))",[0,[2,"cadar"]],["lang/htdp-beginner-abbr"]],
["cadar",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._cadar))",[0,[2,"cadar"]],["lang/htdp-intermediate"]],
["cadar",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._cadar))",[0,[2,"cadar"]],["lang/htdp-intermediate-lambda"]],
["cadar",">lazy/index.html#(def._((lib._lazy/main..rkt)._cadar))",[0,[2,"cadar"]],["lazy"]],
["caddar",">reference/pairs.html#(def._((quote._~23~25kernel)._caddar))",[0,[2,"caddar"]],["racket/base","racket"]],
["caddar",">lazy/index.html#(def._((lib._lazy/main..rkt)._caddar))",[0,[2,"caddar"]],["lazy"]],
["cadddr",">reference/pairs.html#(def._((quote._~23~25kernel)._cadddr))",[0,[2,"cadddr"]],["racket/base","racket"]],
["cadddr",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._cadddr))",[0,[2,"cadddr"]],["lang/htdp-advanced"]],
["cadddr",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._cadddr))",[0,[2,"cadddr"]],["lang/htdp-beginner"]],
["cadddr",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._cadddr))",[0,[2,"cadddr"]],["lang/htdp-beginner-abbr"]],
["cadddr",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._cadddr))",[0,[2,"cadddr"]],["lang/htdp-intermediate"]],
["cadddr",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._cadddr))",[0,[2,"cadddr"]],["lang/htdp-intermediate-lambda"]],
["cadddr",">lazy/index.html#(def._((lib._lazy/main..rkt)._cadddr))",[0,[2,"cadddr"]],["lazy"]],
["caddr",">reference/pairs.html#(def._((quote._~23~25kernel)._caddr))",[0,[2,"caddr"]],["racket/base","racket"]],
["caddr",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._caddr))",[0,[2,"caddr"]],["lang/htdp-advanced"]],
["caddr",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._caddr))",[0,[2,"caddr"]],["lang/htdp-beginner"]],
["caddr",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._caddr))",[0,[2,"caddr"]],["lang/htdp-beginner-abbr"]],
["caddr",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._caddr))",[0,[2,"caddr"]],["lang/htdp-intermediate"]],
["caddr",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._caddr))",[0,[2,"caddr"]],["lang/htdp-intermediate-lambda"]],
["caddr",">lazy/index.html#(def._((lib._lazy/main..rkt)._caddr))",[0,[2,"caddr"]],["lazy"]],
["cadr",">reference/pairs.html#(def._((quote._~23~25kernel)._cadr))",[0,[2,"cadr"]],["racket/base","racket"]],
["cadr",">r5rs-std/r5rs-Z-H-9.html#%_idx_422",[0,[2,"cadr"]],["r5rs"]],
["cadr",">r6rs-std/r6rs-Z-H-14.html#node_idx_618",[0,[2,"cadr"]],["rnrs/base-6"]],
["cadr",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._cadr))",[0,[2,"cadr"]],["lang/htdp-advanced"]],
["cadr",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._cadr))",[0,[2,"cadr"]],["lang/htdp-beginner"]],
["cadr",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._cadr))",[0,[2,"cadr"]],["lang/htdp-beginner-abbr"]],
["cadr",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._cadr))",[0,[2,"cadr"]],["lang/htdp-intermediate"]],
["cadr",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._cadr))",[0,[2,"cadr"]],["lang/htdp-intermediate-lambda"]],
["cadr",">lazy/index.html#(def._((lib._lazy/main..rkt)._cadr))",[0,[2,"cadr"]],["lazy"]],
["cairo library",">draw/unsafe.html#(part._.Cairo_.Library)","Cairo Library",false],
["cairo-lib",">draw/unsafe.html#(def._((lib._racket/draw/unsafe/cairo-lib..rkt)._cairo-lib))",[0,[2,"cairo-lib"]],["racket/draw/unsafe/cairo-lib"]],
["calc-button-min-sizes",">mrlib/Name_Message.html#(def._((lib._mrlib/name-message..rkt)._calc-button-min-sizes))",[0,[2,"calc-button-min-sizes"]],["mrlib/name-message"]],
["call",">unstable/temp-c.html#(form._((lib._unstable/temp-c/dsl..rkt)._call))",[0,[1,"call"]],["unstable/temp-c/dsl"]],
["call-as-atomic",">foreign/Atomic_Execution.html#(def._((lib._ffi/unsafe/atomic..rkt)._call-as-atomic))",[0,[2,"call-as-atomic"]],["ffi/unsafe/atomic"]],
["call-as-current",">draw/gl-context___.html#(meth._(((lib._racket/draw..rkt)._gl-context~3c~25~3e)._call-as-current))",[[0,[2,"call-as-current"]],[14,[" (method of ",[0,[2,"gl-context<%>"]],")"]]],["racket/draw"]],
["call-as-nonatomic",">foreign/Atomic_Execution.html#(def._((lib._ffi/unsafe/atomic..rkt)._call-as-nonatomic))",[0,[2,"call-as-nonatomic"]],["ffi/unsafe/atomic"]],
["call-as-nonatomic-retry-point",">foreign/Speculatively_Atomic_Execution.html#(def._((lib._ffi/unsafe/try-atomic..rkt)._call-as-nonatomic-retry-point))",[0,[2,"call-as-nonatomic-retry-point"]],["ffi/unsafe/try-atomic"]],
["call-as-primary-owner",">gui/editor-canvas_.html#(meth._(((lib._mred/main..rkt)._editor-canvas~25)._call-as-primary-owner))",[[0,[2,"call-as-primary-owner"]],[14,[" (method of ",[0,[2,"editor-canvas%"]],")"]]],["racket/gui/base","racket/gui"]],
["call-by-reference",">guide/pattern-macros.html#(tech._call._by._reference)","<span style=\"font-style: italic\">call-by-reference</span>",false],
["call-by-value",">reference/eval-model.html#(tech._call._by._value)","<span style=\"font-style: italic\">call-by-value</span>",false],
["call-clickback",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._call-clickback))",[[0,[2,"call-clickback"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["call-function",">gui/keymap_.html#(meth._(((lib._mred/main..rkt)._keymap~25)._call-function))",[[0,[2,"call-function"]],[14,[" (method of ",[0,[2,"keymap%"]],")"]]],["racket/gui/base","racket/gui"]],
["call-in-nested-thread",">reference/threads.html#(def._((quote._~23~25kernel)._call-in-nested-thread))",[0,[2,"call-in-nested-thread"]],["racket/base","racket"]],
["call-in-sandbox-context",">reference/Sandboxed_Evaluation.html#(def._((lib._racket/sandbox..rkt)._call-in-sandbox-context))",[0,[2,"call-in-sandbox-context"]],["racket/sandbox"]],
["call-install",">raco/setup-plt-plt.html#(sig-val._((lib._setup/option-sig..rkt)._setup-option~5e._call-install))",[0,[2,"call-install"]],["setup/option-sig"]],
["call-post-install",">raco/setup-plt-plt.html#(sig-val._((lib._setup/option-sig..rkt)._setup-option~5e._call-post-install))",[0,[2,"call-post-install"]],["setup/option-sig"]],
["call-with-break-parameterization",">reference/breakhandler.html#(def._((lib._racket/private/more-scheme..rkt)._call-with-break-parameterization))",[0,[2,"call-with-break-parameterization"]],["racket/base","racket"]],
["call-with-busy-cursor",">gui/snip-admin_.html#(meth._(((lib._racket/snip..rkt)._snip-admin~25)._call-with-busy-cursor))",[[0,[2,"call-with-busy-cursor"]],[14,[" (method of ",[0,[2,"snip-admin%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["call-with-bytevector-output-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_724",[0,[2,"call-with-bytevector-output-port"]],["rnrs/io/ports-6"]],
["call-with-composable-continuation",">reference/cont.html#(def._((quote._~23~25kernel)._call-with-composable-continuation))",[0,[2,"call-with-composable-continuation"]],["racket/base","racket"]],
["call-with-continuation-barrier",">reference/cont.html#(def._((quote._~23~25kernel)._call-with-continuation-barrier))",[0,[2,"call-with-continuation-barrier"]],["racket/base","racket"]],
["call-with-continuation-prompt",">reference/cont.html#(def._((quote._~23~25kernel)._call-with-continuation-prompt))",[0,[2,"call-with-continuation-prompt"]],["racket/base","racket"]],
["call-with-current-continuation",">reference/cont.html#(def._((quote._~23~25kernel)._call-with-current-continuation))",[0,[2,"call-with-current-continuation"]],["racket/base","racket"]],
["call-with-current-continuation",">r5rs-std/r5rs-Z-H-9.html#%_idx_588",[0,[2,"call-with-current-continuation"]],["r5rs"]],
["call-with-current-continuation",">r6rs-std/r6rs-Z-H-14.html#node_idx_754",[0,[2,"call-with-current-continuation"]],["rnrs/base-6"]],
["call-with-custodian-shutdown",">reference/Sandboxed_Evaluation.html#(def._((lib._racket/sandbox..rkt)._call-with-custodian-shutdown))",[0,[2,"call-with-custodian-shutdown"]],["racket/sandbox"]],
["call-with-escape-continuation",">reference/cont.html#(def._((quote._~23~25kernel)._call-with-escape-continuation))",[0,[2,"call-with-escape-continuation"]],["racket/base","racket"]],
["call-with-exception-handler",">reference/exns.html#(def._((lib._racket/private/more-scheme..rkt)._call-with-exception-handler))",[0,[2,"call-with-exception-handler"]],["racket/base","racket"]],
["call-with-file-lock/timeout",">reference/Filesystem.html#(def._((lib._racket/file..rkt)._call-with-file-lock/timeout))",[0,[2,"call-with-file-lock/timeout"]],["racket/file","racket"]],
["call-with-immediate-continuation-mark",">reference/contmarks.html#(def._((quote._~23~25kernel)._call-with-immediate-continuation-mark))",[0,[2,"call-with-immediate-continuation-mark"]],["racket/base","racket"]],
["call-with-input-bytes",">reference/port-lib.html#(def._((lib._racket/port..rkt)._call-with-input-bytes))",[0,[2,"call-with-input-bytes"]],["racket/port","racket"]],
["call-with-input-file",">reference/file-ports.html#(def._((lib._racket/private/base..rkt)._call-with-input-file))",[0,[2,"call-with-input-file"]],["racket/base","racket"]],
["call-with-input-file",">r5rs-std/r5rs-Z-H-9.html#%_idx_610",[0,[2,"call-with-input-file"]],["r5rs"]],
["call-with-input-file",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_776",[0,[2,"call-with-input-file"]],["rnrs/io/simple-6"]],
["call-with-input-file",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..rkt)._call-with-input-file))",[0,[2,"call-with-input-file"]],["mzscheme"]],
["call-with-input-file*",">reference/file-ports.html#(def._((lib._racket/private/base..rkt)._call-with-input-file*))",[0,[2,"call-with-input-file*"]],["racket/base","racket"]],
["call-with-input-file*",">mzlib/mzlib_file.html#(def._((lib._mzlib/file..rkt)._call-with-input-file*))",[0,[2,"call-with-input-file*"]],["mzlib/file"]],
["call-with-input-string",">reference/port-lib.html#(def._((lib._racket/port..rkt)._call-with-input-string))",[0,[2,"call-with-input-string"]],["racket/port","racket"]],
["call-with-killing-threads",">reference/Sandboxed_Evaluation.html#(def._((lib._racket/sandbox..rkt)._call-with-killing-threads))",[0,[2,"call-with-killing-threads"]],["racket/sandbox"]],
["call-with-limits",">reference/Sandboxed_Evaluation.html#(def._((lib._racket/sandbox..rkt)._call-with-limits))",[0,[2,"call-with-limits"]],["racket/sandbox"]],
["call-with-output-bytes",">reference/port-lib.html#(def._((lib._racket/port..rkt)._call-with-output-bytes))",[0,[2,"call-with-output-bytes"]],["racket/port","racket"]],
["call-with-output-file",">reference/file-ports.html#(def._((lib._racket/private/base..rkt)._call-with-output-file))",[0,[2,"call-with-output-file"]],["racket/base","racket"]],
["call-with-output-file",">r5rs-std/r5rs-Z-H-9.html#%_idx_612",[0,[2,"call-with-output-file"]],["r5rs"]],
["call-with-output-file",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_778",[0,[2,"call-with-output-file"]],["rnrs/io/simple-6"]],
["call-with-output-file",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..rkt)._call-with-output-file))",[0,[2,"call-with-output-file"]],["mzscheme"]],
["call-with-output-file*",">reference/file-ports.html#(def._((lib._racket/private/base..rkt)._call-with-output-file*))",[0,[2,"call-with-output-file*"]],["racket/base","racket"]],
["call-with-output-file*",">mzlib/mzlib_file.html#(def._((lib._mzlib/file..rkt)._call-with-output-file*))",[0,[2,"call-with-output-file*"]],["mzlib/file"]],
["call-with-output-string",">reference/port-lib.html#(def._((lib._racket/port..rkt)._call-with-output-string))",[0,[2,"call-with-output-string"]],["racket/port","racket"]],
["call-with-parameterization",">reference/parameters.html#(def._((lib._racket/private/more-scheme..rkt)._call-with-parameterization))",[0,[2,"call-with-parameterization"]],["racket/base","racket"]],
["call-with-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_662",[0,[2,"call-with-port"]],["rnrs/io/ports-6"]],
["call-with-semaphore",">reference/semaphore.html#(def._((quote._~23~25kernel)._call-with-semaphore))",[0,[2,"call-with-semaphore"]],["racket/base","racket"]],
["call-with-semaphore/enable-break",">reference/semaphore.html#(def._((quote._~23~25kernel)._call-with-semaphore/enable-break))",[0,[2,"call-with-semaphore/enable-break"]],["racket/base","racket"]],
["call-with-serializable-current-continuation",">web-server/stateless.html#(def._((lib._web-server/lang/abort-resume..rkt)._call-with-serializable-current-continuation))",[0,[2,"call-with-serializable-current-continuation"]],["web-server/lang/abort-resume"]],
["call-with-string-output-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_728",[0,[2,"call-with-string-output-port"]],["rnrs/io/ports-6"]],
["call-with-transaction",">db/query-api.html#(def._((lib._db/base..rkt)._call-with-transaction))",[0,[2,"call-with-transaction"]],["db","db/base"]],
["call-with-trusted-sandbox-configuration",">reference/Sandboxed_Evaluation.html#(def._((lib._racket/sandbox..rkt)._call-with-trusted-sandbox-configuration))",[0,[2,"call-with-trusted-sandbox-configuration"]],["racket/sandbox"]],
["call-with-values",">reference/values.html#(def._((quote._~23~25kernel)._call-with-values))",[0,[2,"call-with-values"]],["racket/base","racket"]],
["call-with-values",">r5rs-std/r5rs-Z-H-9.html#%_idx_596",[0,[2,"call-with-values"]],["r5rs"]],
["call-with-values",">r6rs-std/r6rs-Z-H-14.html#node_idx_762",[0,[2,"call-with-values"]],["rnrs/base-6"]],
["call/cc",">reference/cont.html#(def._((quote._~23~25kernel)._call/cc))",[0,[2,"call/cc"]],["racket/base","racket"]],
["call/cc",">r6rs-std/r6rs-Z-H-14.html#node_idx_756",[0,[2,"call/cc"]],["rnrs/base-6"]],
["call/comp",">reference/cont.html#(def._((lib._racket/control..rkt)._call/comp))",[0,[2,"call/comp"]],["racket/control"]],
["call/ec",">reference/cont.html#(def._((quote._~23~25kernel)._call/ec))",[0,[2,"call/ec"]],["racket/base","racket"]],
["call/input-url",">net/url.html#(def._((lib._net/url..rkt)._call/input-url))",[0,[2,"call/input-url"]],["net/url"]],
["call/prompt",">reference/cont.html#(def._((lib._racket/control..rkt)._call/prompt))",[0,[2,"call/prompt"]],["racket/control"]],
["callbacks for blocked threads",">inside/threads.html#(part._blockednonmainel)","Callbacks for Blocked Threads",false],
["calltrace library",">trace/index.html#(part._.Calltrace_.Library)","Calltrace Library",false],
["calltrace-eval-handler",">trace/index.html#(def._((lib._trace/calltrace-lib..rkt)._calltrace-eval-handler))",[0,"calltrace-eval-handler"],["trace/calltrace-lib"]],
["can the server create a pid file?",">web-server-internal/Troubleshooting_and_Tips.html#(part._.Can_the_server_create_a_.P.I.D_file_)","Can the server create a PID file?",false],
["can-append",">gui/snip_.html#(idx._(gentag._161._(lib._scribblings/gui/gui..scrbl)))",[7,"'can-append"],false],
["can-append",">gui/snip_.html#(idx._(gentag._172._(lib._scribblings/gui/gui..scrbl)))",[7,"'can-append"],false],
["can-be-loaded-with",">planet/Developing_Packages_for_PLaneT.html#(idx._(gentag._16._(lib._planet/planet..scrbl)))",[7,"'can-be-loaded-with"],false],
["can-be-response?",">web-server/servlet.html#(def._((lib._web-server/servlet/servlet-structs..rkt)._can-be-response~3f))",[0,[2,"can-be-response?"]],["web-server/servlet/servlet-structs"]],
["can-change-style?",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._can-change-style~3f))",[[0,[2,"can-change-style?"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["can-change-style?",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3ahost-text-mixin)._can-change-style~3f))",[[0,[2,"can-change-style?"]],[14,[" (method of ",[0,[2,"mode:host-text-mixin"]],")"]]],["framework"]],
["can-change-style?",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3asurrogate-text~25)._can-change-style~3f))",[[0,[2,"can-change-style?"]],[14,[" (method of ",[0,[2,"mode:surrogate-text%"]],")"]]],["framework"]],
["can-close-all?",">framework/Group.html#(meth._(((lib._framework/main..rkt)._group~3a~25)._can-close-all~3f))",[[0,[2,"can-close-all?"]],[14,[" (method of ",[0,[2,"group:%"]],")"]]],["framework"]],
["can-close?",">gui/top-level-window___.html#(meth._(((lib._mred/main..rkt)._top-level-window~3c~25~3e)._can-close~3f))",[[0,[2,"can-close?"]],[14,[" (method of ",[0,[2,"top-level-window<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["can-close?",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3atab~3c~25~3e)._can-close~3f))",[[0,[2,"can-close?"]],[14,[" (method of ",[0,[2,"drracket:unit:tab<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["can-close?",">framework/Editor.html#(meth._(((lib._framework/main..rkt)._editor~3abasic~3c~25~3e)._can-close~3f))",[[0,[2,"can-close?"]],[14,[" (method of ",[0,[2,"editor:basic<%>"]],")"]]],["framework"]],
["can-close?",">framework/Editor.html#(meth._(((lib._framework/main..rkt)._editor~3afile-mixin)._can-close~3f))",[[0,[2,"can-close?"]],[14,[" (method of ",[0,[2,"editor:file-mixin"]],")"]]],["framework"]],
["can-close?",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3aeditor-mixin)._can-close~3f))",[[0,[2,"can-close?"]],[14,[" (method of ",[0,[2,"frame:editor-mixin"]],")"]]],["framework"]],
["can-close?",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3aregister-group-mixin)._can-close~3f))",[[0,[2,"can-close?"]],[14,[" (method of ",[0,[2,"frame:register-group-mixin"]],")"]]],["framework"]],
["can-delete?",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._can-delete~3f))",[[0,[2,"can-delete?"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["can-delete?",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._can-delete~3f))",[[0,[2,"can-delete?"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["can-delete?",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3ahost-text-mixin)._can-delete~3f))",[[0,[2,"can-delete?"]],[14,[" (method of ",[0,[2,"mode:host-text-mixin"]],")"]]],["framework"]],
["can-delete?",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3asurrogate-text~25)._can-delete~3f))",[[0,[2,"can-delete?"]],[14,[" (method of ",[0,[2,"mode:surrogate-text%"]],")"]]],["framework"]],
["can-delete?",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3afile-mixin)._can-delete~3f))",[[0,[2,"can-delete?"]],[14,[" (method of ",[0,[2,"text:file-mixin"]],")"]]],["framework"]],
["can-delete?",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3aports-mixin)._can-delete~3f))",[[0,[2,"can-delete?"]],[14,[" (method of ",[0,[2,"text:ports-mixin"]],")"]]],["framework"]],
["can-do-edit-operation?",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._can-do-edit-operation~3f))",[[0,[2,"can-do-edit-operation?"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["can-do-edit-operation?",">gui/snip_.html#(meth._(((lib._racket/snip..rkt)._snip~25)._can-do-edit-operation~3f))",[[0,[2,"can-do-edit-operation?"]],[14,[" (method of ",[0,[2,"snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["can-do-edit-operation?",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3ahost-text-mixin)._can-do-edit-operation~3f))",[[0,[2,"can-do-edit-operation?"]],[14,[" (method of ",[0,[2,"mode:host-text-mixin"]],")"]]],["framework"]],
["can-do-edit-operation?",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3asurrogate-text~25)._can-do-edit-operation~3f))",[[0,[2,"can-do-edit-operation?"]],[14,[" (method of ",[0,[2,"mode:surrogate-text%"]],")"]]],["framework"]],
["can-do-edit-operation?",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..rkt)._hierarchical-list~25)._can-do-edit-operation~3f))",[[0,[2,"can-do-edit-operation?"]],[14,[" (method of ",[0,[2,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["can-exit?",">gui/top-level-window___.html#(meth._(((lib._mred/main..rkt)._top-level-window~3c~25~3e)._can-exit~3f))",[[0,[2,"can-exit?"]],[14,[" (method of ",[0,[2,"top-level-window<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["can-exit?",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3abasic-mixin)._can-exit~3f))",[[0,[2,"can-exit?"]],[14,[" (method of ",[0,[2,"frame:basic-mixin"]],")"]]],["framework"]],
["can-get-page-setup-from-user?",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._can-get-page-setup-from-user~3f))",[0,[2,"can-get-page-setup-from-user?"]],["racket/gui/base","racket/gui"]],
["can-insert?",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._can-insert~3f))",[[0,[2,"can-insert?"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["can-insert?",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._can-insert~3f))",[[0,[2,"can-insert?"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["can-insert?",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3ahost-text-mixin)._can-insert~3f))",[[0,[2,"can-insert?"]],[14,[" (method of ",[0,[2,"mode:host-text-mixin"]],")"]]],["framework"]],
["can-insert?",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3asurrogate-text~25)._can-insert~3f))",[[0,[2,"can-insert?"]],[14,[" (method of ",[0,[2,"mode:surrogate-text%"]],")"]]],["framework"]],
["can-insert?",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3afile-mixin)._can-insert~3f))",[[0,[2,"can-insert?"]],[14,[" (method of ",[0,[2,"text:file-mixin"]],")"]]],["framework"]],
["can-insert?",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3aports-mixin)._can-insert~3f))",[[0,[2,"can-insert?"]],[14,[" (method of ",[0,[2,"text:ports-mixin"]],")"]]],["framework"]],
["can-interactive-move?",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._can-interactive-move~3f))",[[0,[2,"can-interactive-move?"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["can-interactive-resize?",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._can-interactive-resize~3f))",[[0,[2,"can-interactive-resize?"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["can-load-file?",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._can-load-file~3f))",[[0,[2,"can-load-file?"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["can-load-file?",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3ahost-text-mixin)._can-load-file~3f))",[[0,[2,"can-load-file?"]],[14,[" (method of ",[0,[2,"mode:host-text-mixin"]],")"]]],["framework"]],
["can-load-file?",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3asurrogate-text~25)._can-load-file~3f))",[[0,[2,"can-load-file?"]],[14,[" (method of ",[0,[2,"mode:surrogate-text%"]],")"]]],["framework"]],
["can-move-to?",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._can-move-to~3f))",[[0,[2,"can-move-to?"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["can-parse-post?",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-2..rkt)._can-parse-post~3f))",[0,"can-parse-post?"],[]],
["can-reorder?",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._can-reorder~3f))",[[0,[2,"can-reorder?"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["can-resize?",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._can-resize~3f))",[[0,[2,"can-resize?"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["can-save-file?",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._can-save-file~3f))",[[0,[2,"can-save-file?"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["can-save-file?",">framework/Editor.html#(meth._(((lib._framework/main..rkt)._editor~3abasic-mixin)._can-save-file~3f))",[[0,[2,"can-save-file?"]],[14,[" (method of ",[0,[2,"editor:basic-mixin"]],")"]]],["framework"]],
["can-save-file?",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3ahost-text-mixin)._can-save-file~3f))",[[0,[2,"can-save-file?"]],[14,[" (method of ",[0,[2,"mode:host-text-mixin"]],")"]]],["framework"]],
["can-save-file?",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3asurrogate-text~25)._can-save-file~3f))",[[0,[2,"can-save-file?"]],[14,[" (method of ",[0,[2,"mode:surrogate-text%"]],")"]]],["framework"]],
["can-select?",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._can-select~3f))",[[0,[2,"can-select?"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["can-set-size-constraint?",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._can-set-size-constraint~3f))",[[0,[2,"can-set-size-constraint?"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["can-set-size-constraint?",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3ahost-text-mixin)._can-set-size-constraint~3f))",[[0,[2,"can-set-size-constraint?"]],[14,[" (method of ",[0,[2,"mode:host-text-mixin"]],")"]]],["framework"]],
["can-set-size-constraint?",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3asurrogate-text~25)._can-set-size-constraint~3f))",[[0,[2,"can-set-size-constraint?"]],[14,[" (method of ",[0,[2,"mode:surrogate-text%"]],")"]]],["framework"]],
["can-update",">reference/file-ports.html#(idx._(gentag._209._(lib._scribblings/reference/reference..scrbl)))",[7,"'can-update"],false],
["cancel",">gui/key-event_.html#(idx._(gentag._39._(lib._scribblings/gui/gui..scrbl)))",[7,"'cancel"],false],
["cancel-timer!",">web-server-internal/timer.html#(def._((lib._web-server/private/timer..rkt)._cancel-timer!))",[0,[2,"cancel-timer!"]],["web-server/private/timer"]],
["cannot-connect",">net/pop3.html#(def._((lib._net/pop3..rkt)._cannot-connect))",[0,[2,"cannot-connect"]],["net/pop3"]],
["cannot-connect?",">net/pop3.html#(def._((lib._net/pop3..rkt)._cannot-connect~3f))",[0,[2,"cannot-connect?"]],["net/pop3"]],
["cannot-delete-message",">net/pop3.html#(def._((lib._net/pop3..rkt)._cannot-delete-message))",[0,[2,"cannot-delete-message"]],["net/pop3"]],
["cannot-delete-message-communicator",">net/pop3.html#(def._((lib._net/pop3..rkt)._cannot-delete-message-communicator))",[0,[2,"cannot-delete-message-communicator"]],["net/pop3"]],
["cannot-delete-message-message",">net/pop3.html#(def._((lib._net/pop3..rkt)._cannot-delete-message-message))",[0,[2,"cannot-delete-message-message"]],["net/pop3"]],
["cannot-delete-message?",">net/pop3.html#(def._((lib._net/pop3..rkt)._cannot-delete-message~3f))",[0,[2,"cannot-delete-message?"]],["net/pop3"]],
["canvas",">framework/Canvas.html","Canvas",false],
["canvas",">gui/windowing-overview.html#(tech._canva)","<span style=\"font-style: italic\">canvas</span>",false],
["canvas%",">gui/canvas_.html",[0,[2,"canvas%"]],["racket/gui/base","racket/gui"]],
["canvas:basic%",">framework/Canvas.html#(def._((lib._framework/main..rkt)._canvas~3abasic~25))",[0,[2,"canvas:basic%"]],["framework"]],
["canvas:basic-mixin",">framework/Canvas.html#(def._((lib._framework/main..rkt)._canvas~3abasic-mixin))",[0,[2,"canvas:basic-mixin"]],["framework"]],
["canvas:basic<%>",">framework/Canvas.html#(def._((lib._framework/main..rkt)._canvas~3abasic~3c~25~3e))",[0,[2,"canvas:basic<%>"]],["framework"]],
["canvas:color%",">framework/Canvas.html#(def._((lib._framework/main..rkt)._canvas~3acolor~25))",[0,[2,"canvas:color%"]],["framework"]],
["canvas:color-mixin",">framework/Canvas.html#(def._((lib._framework/main..rkt)._canvas~3acolor-mixin))",[0,[2,"canvas:color-mixin"]],["framework"]],
["canvas:color<%>",">framework/Canvas.html#(def._((lib._framework/main..rkt)._canvas~3acolor~3c~25~3e))",[0,[2,"canvas:color<%>"]],["framework"]],
["canvas:delegate%",">framework/Canvas.html#(def._((lib._framework/main..rkt)._canvas~3adelegate~25))",[0,[2,"canvas:delegate%"]],["framework"]],
["canvas:delegate-mixin",">framework/Canvas.html#(def._((lib._framework/main..rkt)._canvas~3adelegate-mixin))",[0,[2,"canvas:delegate-mixin"]],["framework"]],
["canvas:delegate<%>",">framework/Canvas.html#(def._((lib._framework/main..rkt)._canvas~3adelegate~3c~25~3e))",[0,[2,"canvas:delegate<%>"]],["framework"]],
["canvas:info%",">framework/Canvas.html#(def._((lib._framework/main..rkt)._canvas~3ainfo~25))",[0,[2,"canvas:info%"]],["framework"]],
["canvas:info-mixin",">framework/Canvas.html#(def._((lib._framework/main..rkt)._canvas~3ainfo-mixin))",[0,[2,"canvas:info-mixin"]],["framework"]],
["canvas:info<%>",">framework/Canvas.html#(def._((lib._framework/main..rkt)._canvas~3ainfo~3c~25~3e))",[0,[2,"canvas:info<%>"]],["framework"]],
["canvas:wide-snip%",">framework/Canvas.html#(def._((lib._framework/main..rkt)._canvas~3awide-snip~25))",[0,[2,"canvas:wide-snip%"]],["framework"]],
["canvas:wide-snip-mixin",">framework/Canvas.html#(def._((lib._framework/main..rkt)._canvas~3awide-snip-mixin))",[0,[2,"canvas:wide-snip-mixin"]],["framework"]],
["canvas:wide-snip<%>",">framework/Canvas.html#(def._((lib._framework/main..rkt)._canvas~3awide-snip~3c~25~3e))",[0,[2,"canvas:wide-snip<%>"]],["framework"]],
["canvas<%>",">gui/canvas___.html",[0,[2,"canvas<%>"]],["racket/gui/base","racket/gui"]],
["cap style",">draw/pen_.html#(tech._cap._style)","<span style=\"font-style: italic\">cap style</span>",false],
["capability-value",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3alanguage~3c~25~3e)._capability-value))",[[0,[2,"capability-value"]],[14,[" (method of ",[0,[2,"drracket:language:language<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["capital",">gui/key-event_.html#(idx._(gentag._47._(lib._scribblings/gui/gui..scrbl)))",[7,"'capital"],false],
["capitalize-word",">framework/Keymap.html#(idx._(gentag._23._(lib._scribblings/framework/framework..scrbl)))","capitalize-word",false],
["caps",">unstable/Slideshow_Presentations.html#(form._((lib._unstable/gui/slideshow..rkt)._caps))",[0,[1,"caps"]],["unstable/gui/slideshow"]],
["caption",">html/index.html#(def._((lib._html/main..rkt)._caption))",[0,[2,"caption"]],["html"]],
["caption?",">html/index.html#(def._((lib._html/main..rkt)._caption~3f))",[0,[2,"caption?"]],["html"]],
["car",">reference/pairs.html#(def._((quote._~23~25kernel)._car))",[0,[2,"car"]],["racket/base","racket"]],
["car",">r5rs-std/r5rs-Z-H-9.html#%_idx_410",[0,[2,"car"]],["r5rs"]],
["car",">r6rs-std/r6rs-Z-H-14.html#node_idx_612",[0,[2,"car"]],["rnrs/base-6"]],
["car",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._car))",[0,[2,"car"]],["lang/htdp-advanced"]],
["car",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._car))",[0,[2,"car"]],["lang/htdp-beginner"]],
["car",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._car))",[0,[2,"car"]],["lang/htdp-beginner-abbr"]],
["car",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._car))",[0,[2,"car"]],["lang/htdp-intermediate"]],
["car",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._car))",[0,[2,"car"]],["lang/htdp-intermediate-lambda"]],
["car",">srfi-std/srfi-1.html#car",[0,[2,"car"]],["srfi/1"]],
["car+cdr",">srfi-std/srfi-1.html#car+cdr",[0,[2,"car+cdr"]],["srfi/1"]],
["card",">mzlib/mzlib_integer-set.html#(def._((lib._mzlib/integer-set..rkt)._card))",[0,[2,"card"]],["mzlib/integer-set"]],
["card methods",">cards/index.html#(part._.Card_.Methods)","Card Methods",false],
["card-face-down",">cards/index.html#(meth._(((lib._games/cards..rkt)._table~3c~25~3e)._card-face-down))",[[0,[2,"card-face-down"]],[14,[" (method of ",[0,[2,"table<%>"]],")"]]],["games/cards"]],
["card-face-up",">cards/index.html#(meth._(((lib._games/cards..rkt)._table~3c~25~3e)._card-face-up))",[[0,[2,"card-face-up"]],[14,[" (method of ",[0,[2,"table<%>"]],")"]]],["games/cards"]],
["card-height",">cards/index.html#(meth._(((lib._games/cards..rkt)._card~3c~25~3e)._card-height))",[[0,[2,"card-height"]],[14,[" (method of ",[0,[2,"card<%>"]],")"]]],["games/cards"]],
["card-location",">cards/index.html#(meth._(((lib._games/cards..rkt)._table~3c~25~3e)._card-location))",[[0,[2,"card-location"]],[14,[" (method of ",[0,[2,"table<%>"]],")"]]],["games/cards"]],
["card-to-back",">cards/index.html#(meth._(((lib._games/cards..rkt)._table~3c~25~3e)._card-to-back))",[[0,[2,"card-to-back"]],[14,[" (method of ",[0,[2,"table<%>"]],")"]]],["games/cards"]],
["card-to-front",">cards/index.html#(meth._(((lib._games/cards..rkt)._table~3c~25~3e)._card-to-front))",[[0,[2,"card-to-front"]],[14,[" (method of ",[0,[2,"table<%>"]],")"]]],["games/cards"]],
["card-width",">cards/index.html#(meth._(((lib._games/cards..rkt)._card~3c~25~3e)._card-width))",[[0,[2,"card-width"]],[14,[" (method of ",[0,[2,"card<%>"]],")"]]],["games/cards"]],
["card<%>",">cards/index.html#(def._((lib._games/cards..rkt)._card~3c~25~3e))",[0,[2,"card<%>"]],["games/cards"]],
["cards-face-down",">cards/index.html#(meth._(((lib._games/cards..rkt)._table~3c~25~3e)._cards-face-down))",[[0,[2,"cards-face-down"]],[14,[" (method of ",[0,[2,"table<%>"]],")"]]],["games/cards"]],
["cards-face-up",">cards/index.html#(meth._(((lib._games/cards..rkt)._table~3c~25~3e)._cards-face-up))",[[0,[2,"cards-face-up"]],[14,[" (method of ",[0,[2,"table<%>"]],")"]]],["games/cards"]],
["cards: virtual playing cards library",">cards/index.html","Cards: Virtual Playing Cards Library",false],
["caret",">gui/editor-wordbreak-map_.html#(idx._(gentag._212._(lib._scribblings/gui/gui..scrbl)))",[7,"'caret"],false],
["caret",">gui/editor-overview.html#(tech._caret)","<span style=\"font-style: italic\">caret</span>",false],
["caret ownership",">gui/editor-overview.html#(part._drawcaretinfo)","Caret Ownership",false],
["caret-hidden?",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._caret-hidden~3f))",[[0,[2,"caret-hidden?"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["cascade",">unstable/ppict.html#(def._((lib._unstable/gui/ppict..rkt)._cascade))",[0,[2,"cascade"]],["unstable/gui/ppict"]],
["case",">reference/case.html#(form._((lib._racket/private/more-scheme..rkt)._case))",[0,[1,"case"]],["racket/base","racket"]],
["case",">r5rs-std/r5rs-Z-H-7.html#%_idx_116",[0,[1,"case"]],["r5rs"]],
["case",">r6rs-std/r6rs-Z-H-14.html#node_idx_384",[0,[2,"case"]],["rnrs/base-6"]],
["case",">htdp-langs/advanced.html#(form._((lib._lang/htdp-advanced..rkt)._case))",[0,[1,"case"]],["lang/htdp-advanced"]],
["case",">lazy/index.html#(form._((lib._lazy/main..rkt)._case))",[0,[1,"case"]],["lazy"]],
["case",">mzscheme/Old_Syntactic_Forms.html#(form._((lib._mzscheme/main..rkt)._case))",[0,[1,"case"]],["mzscheme"]],
["case",">plai/mutator.html#(form._((lib._plai/mutator..rkt)._case))",[0,[1,"case"]],["plai/mutator"]],
["case->",">reference/function-contracts.html#(form._((lib._racket/contract/base..rkt)._case-~3e))",[0,[1,"case->"]],["racket/contract/base","racket/contract","racket"]],
["case->",">mzlib/mzlib_contract.html#(form._((lib._mzlib/contract..rkt)._case-~3e))",[0,[1,"case->"]],["mzlib/contract"]],
["case->",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types-extra..rkt)._case-~3e))",[0,[1,"case->"]],["typed/racket/base","typed/racket"]],
["case->m",">reference/Object_and_Class_Contracts.html#(form._((lib._racket/private/class-internal..rkt)._case-~3em))",[0,[1,"case->m"]],["racket/class","racket"]],
["case-insensitive",">reference/reader.html#(idx._(gentag._6._(lib._scribblings/reference/reference..scrbl)))","case-insensitive",false],
["case-lam",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._case-lam))",[0,[2,"case-lam"]],["compiler/zo-structs"]],
["case-lam-clauses",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._case-lam-clauses))",[0,[2,"case-lam-clauses"]],["compiler/zo-structs"]],
["case-lam-name",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._case-lam-name))",[0,[2,"case-lam-name"]],["compiler/zo-structs"]],
["case-lam?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._case-lam~3f))",[0,[2,"case-lam?"]],["compiler/zo-structs"]],
["case-lambda",">reference/lambda.html#(form._((quote._~23~25kernel)._case-lambda))",[0,[1,"case-lambda"]],["racket/base","racket"]],
["case-lambda",">r6rs-lib-std/r6rs-lib-Z-H-6.html#node_idx_262",[0,[1,"case-lambda"]],["rnrs/control-6"]],
["case-lambda",">srfi-std/srfi-16.html#case-lambda",[0,[1,"case-lambda"]],["srfi/16"]],
["case-lambda:",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._case-lambda~3a))",[0,[1,"case-lambda:"]],["typed/racket/base","typed/racket"]],
["case-sensitivity",">reference/reader.html#(idx._(gentag._5._(lib._scribblings/reference/reference..scrbl)))","case-sensitivity",false],
["cases",">eopl/index.html#(form._((lib._eopl/eopl..rkt)._cases))",[0,[1,"cases"]],["eopl"]],
["case\u2192",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types-extra..rkt)._case~e2~86~92))",[0,[1,"case&#8594;"]],["typed/racket/base","typed/racket"]],
["cast",">foreign/Miscellaneous_Support.html#(def._((lib._ffi/unsafe..rkt)._cast))",[0,[2,"cast"]],["ffi/unsafe"]],
["cat",">unstable/cat.html#(def._((lib._unstable/cat..rkt)._cat))",[0,[2,"cat"]],["unstable/cat"]],
["categories",">planet/Developing_Packages_for_PLaneT.html#(idx._(gentag._3._(lib._planet/planet..scrbl)))",[7,"'categories"],false],
["category",">scribble/SIGPLAN_Paper_Format.html#(def._((lib._scribble/sigplan..rkt)._category))",[0,[2,"category"]],["scribble/sigplan"]],
["catn",">unstable/cat.html#(def._((lib._unstable/cat..rkt)._catn))",[0,[2,"catn"]],["unstable/cat"]],
["catne",">unstable/cat.html#(def._((lib._unstable/cat..rkt)._catne))",[0,[2,"catne"]],["unstable/cat"]],
["catnp",">unstable/cat.html#(def._((lib._unstable/cat..rkt)._catnp))",[0,[2,"catnp"]],["unstable/cat"]],
["catp",">unstable/cat.html#(def._((lib._unstable/cat..rkt)._catp))",[0,[2,"catp"]],["unstable/cat"]],
["catw",">unstable/cat.html#(def._((lib._unstable/cat..rkt)._catw))",[0,[2,"catw"]],["unstable/cat"]],
["caution",">gui/message_.html#(idx._(gentag._119._(lib._scribblings/gui/gui..scrbl)))",[7,"'caution"],false],
["cb-find",">slideshow/Pict_Finders.html#(def._((lib._slideshow/pict..rkt)._cb-find))",[0,[2,"cb-find"]],["slideshow/pict","slideshow"]],
["cb-superimpose",">slideshow/Pict_Combiners.html#(def._((lib._slideshow/pict..rkt)._cb-superimpose))",[0,[2,"cb-superimpose"]],["slideshow/pict","slideshow"]],
["cbl-find",">slideshow/Pict_Finders.html#(def._((lib._slideshow/pict..rkt)._cbl-find))",[0,[2,"cbl-find"]],["slideshow/pict","slideshow"]],
["cbl-superimpose",">slideshow/Pict_Combiners.html#(def._((lib._slideshow/pict..rkt)._cbl-superimpose))",[0,[2,"cbl-superimpose"]],["slideshow/pict","slideshow"]],
["cblock->list",">foreign/Miscellaneous_Support.html#(def._((lib._ffi/unsafe..rkt)._cblock-~3elist))",[0,[2,"cblock->list"]],["ffi/unsafe"]],
["cblock->vector",">foreign/Miscellaneous_Support.html#(def._((lib._ffi/unsafe..rkt)._cblock-~3evector))",[0,[2,"cblock->vector"]],["ffi/unsafe"]],
["cbrt-transform",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._cbrt-transform))",[0,[2,"cbrt-transform"]],["plot"]],
["cc",">reference/characters.html#(idx._(gentag._148._(lib._scribblings/reference/reference..scrbl)))",[7,"'cc"],false],
["cc-find",">slideshow/Pict_Finders.html#(def._((lib._slideshow/pict..rkt)._cc-find))",[0,[2,"cc-find"]],["slideshow/pict","slideshow"]],
["cc-superimpose",">slideshow/Pict_Combiners.html#(def._((lib._slideshow/pict..rkt)._cc-superimpose))",[0,[2,"cc-superimpose"]],["slideshow/pict","slideshow"]],
["cci/coclass",">mysterx/methprop.html#(def._((lib._mysterx/main..rkt)._cci/coclass))",[0,[2,"cci/coclass"]],["mysterx"]],
["cci/progid",">mysterx/methprop.html#(def._((lib._mysterx/main..rkt)._cci/progid))",[0,[2,"cci/progid"]],["mysterx"]],
["cd",">preprocessor/mzpp.html#(def._((lib._preprocessor/mzpp..rkt)._cd))",[0,[2,"cd"]],["preprocessor/mzpp"]],
["cd",">preprocessor/mztext.html#(def._((lib._preprocessor/mztext..rkt)._cd))",[0,[2,"cd"]],["preprocessor/mztext"]],
["cdaaar",">reference/pairs.html#(def._((quote._~23~25kernel)._cdaaar))",[0,[2,"cdaaar"]],["racket/base","racket"]],
["cdaaar",">lazy/index.html#(def._((lib._lazy/main..rkt)._cdaaar))",[0,[2,"cdaaar"]],["lazy"]],
["cdaadr",">reference/pairs.html#(def._((quote._~23~25kernel)._cdaadr))",[0,[2,"cdaadr"]],["racket/base","racket"]],
["cdaadr",">lazy/index.html#(def._((lib._lazy/main..rkt)._cdaadr))",[0,[2,"cdaadr"]],["lazy"]],
["cdaar",">reference/pairs.html#(def._((quote._~23~25kernel)._cdaar))",[0,[2,"cdaar"]],["racket/base","racket"]],
["cdaar",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._cdaar))",[0,[2,"cdaar"]],["lang/htdp-advanced"]],
["cdaar",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._cdaar))",[0,[2,"cdaar"]],["lang/htdp-beginner"]],
["cdaar",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._cdaar))",[0,[2,"cdaar"]],["lang/htdp-beginner-abbr"]],
["cdaar",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._cdaar))",[0,[2,"cdaar"]],["lang/htdp-intermediate"]],
["cdaar",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._cdaar))",[0,[2,"cdaar"]],["lang/htdp-intermediate-lambda"]],
["cdaar",">lazy/index.html#(def._((lib._lazy/main..rkt)._cdaar))",[0,[2,"cdaar"]],["lazy"]],
["cdadar",">reference/pairs.html#(def._((quote._~23~25kernel)._cdadar))",[0,[2,"cdadar"]],["racket/base","racket"]],
["cdadar",">lazy/index.html#(def._((lib._lazy/main..rkt)._cdadar))",[0,[2,"cdadar"]],["lazy"]],
["cdaddr",">reference/pairs.html#(def._((quote._~23~25kernel)._cdaddr))",[0,[2,"cdaddr"]],["racket/base","racket"]],
["cdaddr",">lazy/index.html#(def._((lib._lazy/main..rkt)._cdaddr))",[0,[2,"cdaddr"]],["lazy"]],
["cdadr",">reference/pairs.html#(def._((quote._~23~25kernel)._cdadr))",[0,[2,"cdadr"]],["racket/base","racket"]],
["cdadr",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._cdadr))",[0,[2,"cdadr"]],["lang/htdp-advanced"]],
["cdadr",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._cdadr))",[0,[2,"cdadr"]],["lang/htdp-beginner"]],
["cdadr",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._cdadr))",[0,[2,"cdadr"]],["lang/htdp-beginner-abbr"]],
["cdadr",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._cdadr))",[0,[2,"cdadr"]],["lang/htdp-intermediate"]],
["cdadr",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._cdadr))",[0,[2,"cdadr"]],["lang/htdp-intermediate-lambda"]],
["cdadr",">lazy/index.html#(def._((lib._lazy/main..rkt)._cdadr))",[0,[2,"cdadr"]],["lazy"]],
["cdar",">reference/pairs.html#(def._((quote._~23~25kernel)._cdar))",[0,[2,"cdar"]],["racket/base","racket"]],
["cdar",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._cdar))",[0,[2,"cdar"]],["lang/htdp-advanced"]],
["cdar",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._cdar))",[0,[2,"cdar"]],["lang/htdp-beginner"]],
["cdar",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._cdar))",[0,[2,"cdar"]],["lang/htdp-beginner-abbr"]],
["cdar",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._cdar))",[0,[2,"cdar"]],["lang/htdp-intermediate"]],
["cdar",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._cdar))",[0,[2,"cdar"]],["lang/htdp-intermediate-lambda"]],
["cdar",">lazy/index.html#(def._((lib._lazy/main..rkt)._cdar))",[0,[2,"cdar"]],["lazy"]],
["cdata",">xml/index.html#(def._((lib._xml/main..rkt)._cdata))",[0,[2,"cdata"]],["xml"]],
["cdata-string",">xml/index.html#(def._((lib._xml/main..rkt)._cdata-string))",[0,[2,"cdata-string"]],["xml"]],
["cdata?",">xml/index.html#(def._((lib._xml/main..rkt)._cdata~3f))",[0,[2,"cdata?"]],["xml"]],
["cddaar",">reference/pairs.html#(def._((quote._~23~25kernel)._cddaar))",[0,[2,"cddaar"]],["racket/base","racket"]],
["cddaar",">lazy/index.html#(def._((lib._lazy/main..rkt)._cddaar))",[0,[2,"cddaar"]],["lazy"]],
["cddadr",">reference/pairs.html#(def._((quote._~23~25kernel)._cddadr))",[0,[2,"cddadr"]],["racket/base","racket"]],
["cddadr",">lazy/index.html#(def._((lib._lazy/main..rkt)._cddadr))",[0,[2,"cddadr"]],["lazy"]],
["cddadr",">srfi-std/srfi-1.html#cddadr",[0,[2,"cddadr"]],["srfi/1"]],
["cddar",">reference/pairs.html#(def._((quote._~23~25kernel)._cddar))",[0,[2,"cddar"]],["racket/base","racket"]],
["cddar",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._cddar))",[0,[2,"cddar"]],["lang/htdp-advanced"]],
["cddar",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._cddar))",[0,[2,"cddar"]],["lang/htdp-beginner"]],
["cddar",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._cddar))",[0,[2,"cddar"]],["lang/htdp-beginner-abbr"]],
["cddar",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._cddar))",[0,[2,"cddar"]],["lang/htdp-intermediate"]],
["cddar",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._cddar))",[0,[2,"cddar"]],["lang/htdp-intermediate-lambda"]],
["cddar",">lazy/index.html#(def._((lib._lazy/main..rkt)._cddar))",[0,[2,"cddar"]],["lazy"]],
["cdddar",">reference/pairs.html#(def._((quote._~23~25kernel)._cdddar))",[0,[2,"cdddar"]],["racket/base","racket"]],
["cdddar",">r5rs-std/r5rs-Z-H-9.html#%_idx_424",[0,[2,"cdddar"]],["r5rs"]],
["cdddar",">r6rs-std/r6rs-Z-H-14.html#node_idx_620",[0,[2,"cdddar"]],["rnrs/base-6"]],
["cdddar",">lazy/index.html#(def._((lib._lazy/main..rkt)._cdddar))",[0,[2,"cdddar"]],["lazy"]],
["cddddr",">reference/pairs.html#(def._((quote._~23~25kernel)._cddddr))",[0,[2,"cddddr"]],["racket/base","racket"]],
["cddddr",">r5rs-std/r5rs-Z-H-9.html#%_idx_426",[0,[2,"cddddr"]],["r5rs"]],
["cddddr",">r6rs-std/r6rs-Z-H-14.html#node_idx_622",[0,[2,"cddddr"]],["rnrs/base-6"]],
["cddddr",">lazy/index.html#(def._((lib._lazy/main..rkt)._cddddr))",[0,[2,"cddddr"]],["lazy"]],
["cddddr",">srfi-std/srfi-1.html#cddddr",[0,[2,"cddddr"]],["srfi/1"]],
["cdddr",">reference/pairs.html#(def._((quote._~23~25kernel)._cdddr))",[0,[2,"cdddr"]],["racket/base","racket"]],
["cdddr",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._cdddr))",[0,[2,"cdddr"]],["lang/htdp-advanced"]],
["cdddr",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._cdddr))",[0,[2,"cdddr"]],["lang/htdp-beginner"]],
["cdddr",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._cdddr))",[0,[2,"cdddr"]],["lang/htdp-beginner-abbr"]],
["cdddr",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._cdddr))",[0,[2,"cdddr"]],["lang/htdp-intermediate"]],
["cdddr",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._cdddr))",[0,[2,"cdddr"]],["lang/htdp-intermediate-lambda"]],
["cdddr",">lazy/index.html#(def._((lib._lazy/main..rkt)._cdddr))",[0,[2,"cdddr"]],["lazy"]],
["cddr",">reference/pairs.html#(def._((quote._~23~25kernel)._cddr))",[0,[2,"cddr"]],["racket/base","racket"]],
["cddr",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._cddr))",[0,[2,"cddr"]],["lang/htdp-advanced"]],
["cddr",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._cddr))",[0,[2,"cddr"]],["lang/htdp-beginner"]],
["cddr",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._cddr))",[0,[2,"cddr"]],["lang/htdp-beginner-abbr"]],
["cddr",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._cddr))",[0,[2,"cddr"]],["lang/htdp-intermediate"]],
["cddr",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._cddr))",[0,[2,"cddr"]],["lang/htdp-intermediate-lambda"]],
["cddr",">lazy/index.html#(def._((lib._lazy/main..rkt)._cddr))",[0,[2,"cddr"]],["lazy"]],
["cdr",">reference/pairs.html#(def._((quote._~23~25kernel)._cdr))",[0,[2,"cdr"]],["racket/base","racket"]],
["cdr",">r5rs-std/r5rs-Z-H-9.html#%_idx_414",[0,[2,"cdr"]],["r5rs"]],
["cdr",">r6rs-std/r6rs-Z-H-14.html#node_idx_614",[0,[2,"cdr"]],["rnrs/base-6"]],
["cdr",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._cdr))",[0,[2,"cdr"]],["lang/htdp-advanced"]],
["cdr",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._cdr))",[0,[2,"cdr"]],["lang/htdp-beginner"]],
["cdr",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._cdr))",[0,[2,"cdr"]],["lang/htdp-beginner-abbr"]],
["cdr",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._cdr))",[0,[2,"cdr"]],["lang/htdp-intermediate"]],
["cdr",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._cdr))",[0,[2,"cdr"]],["lang/htdp-intermediate-lambda"]],
["cdr",">srfi-std/srfi-1.html#cdr",[0,[2,"cdr"]],["srfi/1"]],
["ceiling",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._ceiling))",[0,[2,"ceiling"]],["racket/base","racket"]],
["ceiling",">r5rs-std/r5rs-Z-H-9.html#%_idx_316",[0,[2,"ceiling"]],["r5rs"]],
["ceiling",">r6rs-std/r6rs-Z-H-14.html#node_idx_530",[0,[2,"ceiling"]],["rnrs/base-6"]],
["ceiling",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._ceiling))",[0,[2,"ceiling"]],["lang/htdp-advanced"]],
["ceiling",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._ceiling))",[0,[2,"ceiling"]],["lang/htdp-beginner"]],
["ceiling",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._ceiling))",[0,[2,"ceiling"]],["lang/htdp-beginner-abbr"]],
["ceiling",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._ceiling))",[0,[2,"ceiling"]],["lang/htdp-intermediate"]],
["ceiling",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._ceiling))",[0,[2,"ceiling"]],["lang/htdp-intermediate-lambda"]],
["ceiling",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._ceiling))",[0,[2,"ceiling"]],["deinprogramm/DMdA-advanced"]],
["ceiling",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._ceiling))",[0,[2,"ceiling"]],["deinprogramm/DMdA-assignments"]],
["ceiling",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._ceiling))",[0,[2,"ceiling"]],["deinprogramm/DMdA-beginner"]],
["ceiling",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._ceiling))",[0,[2,"ceiling"]],["deinprogramm/DMdA-vanilla"]],
["ceiling-log/base",">plot/utils.html#(def._((lib._plot/utils..rkt)._ceiling-log/base))",[0,[2,"ceiling-log/base"]],["plot/utils"]],
["cellophane",">slideshow/Pict_Drawing_Adjusters.html#(def._((lib._slideshow/pict..rkt)._cellophane))",[0,[2,"cellophane"]],["slideshow/pict","slideshow"]],
["center",">gui/top-level-window___.html#(meth._(((lib._mred/main..rkt)._top-level-window~3c~25~3e)._center))",[[0,[2,"center"]],[14,[" (method of ",[0,[2,"top-level-window<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["center",">html/index.html#(def._((lib._html/main..rkt)._center))",[0,[2,"center"]],["html"]],
["center",">gui/windowing-overview.html#(idx._(gentag._1._(lib._scribblings/gui/gui..scrbl)))",[7,"'center"],false],
["center",">gui/style-delta_.html#(idx._(gentag._177._(lib._scribblings/gui/gui..scrbl)))",[7,"'center"],false],
["center-pinhole",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._center-pinhole))",[0,[2,"center-pinhole"]],["2htdp/image"]],
["center-view-on-line",">framework/Keymap.html#(idx._(gentag._16._(lib._scribblings/framework/framework..scrbl)))","center-view-on-line",false],
["center?",">html/index.html#(def._((lib._html/main..rkt)._center~3f))",[0,[2,"center?"]],["html"]],
["centered",">scribble/base.html#(def._((lib._scribble/base..rkt)._centered))",[0,[2,"centered"]],["scribble/base"]],
["centerline",">scribble/Miscellaneous.html#(def._((lib._scribble/manual..rkt)._centerline))",[0,[2,"centerline"]],["scribble/manual"]],
["certify-mode",">reference/stxcerts.html#(idx._(gentag._187._(lib._scribblings/reference/reference..scrbl)))",[7,"'certify-mode"],false],
["cf",">reference/characters.html#(idx._(gentag._149._(lib._scribblings/reference/reference..scrbl)))",[7,"'cf"],false],
["cgc",">inside/overview.html#(idx._(gentag._1._(lib._scribblings/inside/inside..scrbl)))","CGC",false],
["cgc",">guide/performance.html#(tech._cgc)","<span style=\"font-style: italic\">CGC</span>",false],
["cgc",">reference/runtime.html#(idx._(gentag._328._(lib._scribblings/reference/reference..scrbl)))",[7,"'cgc"],false],
["cgc embedding",">inside/overview.html#(part._.C.G.C_.Embedding)","CGC Embedding",false],
["cgc extensions",">inside/overview.html#(part._.C.G.C_.Extensions)","CGC Extensions",false],
["cgc versus 3m",">inside/overview.html#(part._.C.G.C_versus_3m)","CGC versus 3m",false],
["cgc-suffix",">config/index.html#(def._((lib._config/main..rkt)._cgc-suffix))",[0,[2,"cgc-suffix"]],["config"]],
["cgi functions",">net/cgi.html#(part._.C.G.I_.Functions)","CGI Functions",false],
["cgi scripts",">net/cgi.html","CGI Scripts",false],
["cgi signature",">net/cgi.html#(part._.C.G.I_.Signature)","CGI Signature",false],
["cgi unit",">net/cgi.html#(part._.C.G.I_.Unit)","CGI Unit",false],
["cgi@",">net/cgi.html#(def._((lib._net/cgi-unit..rkt)._cgi~40))",[0,[2,"cgi@"]],["net/cgi-unit"]],
["cgi^",">net/cgi.html#(form._((lib._net/cgi-sig..rkt)._cgi~5e))",[0,[1,"cgi^"]],["net/cgi-sig"]],
["chain-to-keymap",">gui/keymap_.html#(meth._(((lib._mred/main..rkt)._keymap~25)._chain-to-keymap))",[[0,[2,"chain-to-keymap"]],[14,[" (method of ",[0,[2,"keymap%"]],")"]]],["racket/gui/base","racket/gui"]],
["chain-to-keymap",">framework/Keymap.html#(meth._(((lib._framework/main..rkt)._keymap~3aaug-keymap-mixin)._chain-to-keymap))",[[0,[2,"chain-to-keymap"]],[14,[" (method of ",[0,[2,"keymap:aug-keymap-mixin"]],")"]]],["framework"]],
["chaining reader language",">reference/reader.html#(part._.Chaining_.Reader_.Language)","Chaining Reader Language",false],
["chaining tests: cond",">guide/conditionals.html#(part._cond)",["Chaining Tests: ",[0,[1,"cond"]]],false],
["change-children",">gui/area-container___.html#(meth._(((lib._mred/main..rkt)._area-container~3c~25~3e)._change-children))",[[0,[2,"change-children"]],[14,[" (method of ",[0,[2,"area-container<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["change-color",">graphics/Color_Operations.html#(def._((lib._graphics/graphics..rkt)._change-color))",[0,[2,"change-color"]],["graphics/graphics"]],
["change-style",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._change-style))",[[0,[2,"change-style"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["change-style",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._change-style))",[[0,[2,"change-style"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["change-to-file",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aframe~25)._change-to-file))",[[0,[2,"change-to-file"]],[14,[" (method of ",[0,[2,"drracket:unit:frame%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["changes",">frtime/index.html#(def._((lib._frtime/main..rkt)._changes))",[0,[2,"changes"]],["frtime"]],
["changing a parenthesis as you type",">drracket/editor.html#(idx._(gentag._21._(lib._scribblings/drracket/drracket..scrbl)))","changing a parenthesis as you type",false],
["changing keyword arguments",">plot/porting.html#(part._.Changing_.Keyword_.Arguments)","Changing Keyword Arguments",false],
["channel",">mzlib/mzlib_cml.html#(def._((lib._mzlib/cml..rkt)._channel))",[0,[2,"channel"]],["mzlib/cml"]],
["channel",">reference/channel.html#(tech._channel)","<span style=\"font-style: italic\">channel</span>",false],
["channel-get",">reference/channel.html#(def._((lib._racket/private/misc..rkt)._channel-get))",[0,[2,"channel-get"]],["racket/base","racket"]],
["channel-put",">reference/channel.html#(def._((lib._racket/private/misc..rkt)._channel-put))",[0,[2,"channel-put"]],["racket/base","racket"]],
["channel-put-evt",">reference/channel.html#(def._((quote._~23~25kernel)._channel-put-evt))",[0,[2,"channel-put-evt"]],["racket/base","racket"]],
["channel-put-evt?",">reference/channel.html#(def._((quote._~23~25kernel)._channel-put-evt~3f))",[0,[2,"channel-put-evt?"]],["racket/base","racket"]],
["channel-recv-evt",">mzlib/mzlib_cml.html#(def._((lib._mzlib/cml..rkt)._channel-recv-evt))",[0,[2,"channel-recv-evt"]],["mzlib/cml"]],
["channel-send-evt",">mzlib/mzlib_cml.html#(def._((lib._mzlib/cml..rkt)._channel-send-evt))",[0,[2,"channel-send-evt"]],["mzlib/cml"]],
["channel-try-get",">reference/channel.html#(def._((lib._racket/private/misc..rkt)._channel-try-get))",[0,[2,"channel-try-get"]],["racket/base","racket"]],
["channel?",">reference/channel.html#(def._((quote._~23~25kernel)._channel~3f))",[0,[2,"channel?"]],["racket/base","racket"]],
["channelof",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Channelof))",[0,[1,"Channelof"]],["typed/racket/base","typed/racket"]],
["channels",">reference/channel.html","Channels",false],
["chaperone",">reference/chaperones.html#(tech._chaperone)","<span style=\"font-style: italic\">chaperone</span>",false],
["chaperone constructors",">reference/chaperones.html#(part._.Chaperone_.Constructors)","Chaperone Constructors",false],
["chaperone contract property",">reference/Building_New_Contract_Combinators.html#(tech._chaperone._contract._property)","<span style=\"font-style: italic\">chaperone contract property</span>",false],
["chaperone-box",">reference/chaperones.html#(def._((quote._~23~25kernel)._chaperone-box))",[0,[2,"chaperone-box"]],["racket/base","racket"]],
["chaperone-continuation-mark-key",">reference/chaperones.html#(def._((quote._~23~25kernel)._chaperone-continuation-mark-key))",[0,[2,"chaperone-continuation-mark-key"]],["racket/base","racket"]],
["chaperone-contract-property?",">reference/Building_New_Contract_Combinators.html#(def._((lib._racket/contract/private/prop..rkt)._chaperone-contract-property~3f))",[0,[2,"chaperone-contract-property?"]],["racket/contract/combinator","racket/contract","racket"]],
["chaperone-contract?",">reference/contract-utilities.html#(def._((lib._racket/contract/private/misc..rkt)._chaperone-contract~3f))",[0,[2,"chaperone-contract?"]],["racket/contract/base","racket/contract","racket"]],
["chaperone-evt",">reference/chaperones.html#(def._((quote._~23~25kernel)._chaperone-evt))",[0,[2,"chaperone-evt"]],["racket/base","racket"]],
["chaperone-hash",">reference/chaperones.html#(def._((quote._~23~25kernel)._chaperone-hash))",[0,[2,"chaperone-hash"]],["racket/base","racket"]],
["chaperone-of?",">reference/chaperones.html#(def._((quote._~23~25kernel)._chaperone-of~3f))",[0,[2,"chaperone-of?"]],["racket/base","racket"]],
["chaperone-procedure",">reference/chaperones.html#(def._((lib._racket/private/base..rkt)._chaperone-procedure))",[0,[2,"chaperone-procedure"]],["racket/base","racket"]],
["chaperone-prompt-tag",">reference/chaperones.html#(def._((quote._~23~25kernel)._chaperone-prompt-tag))",[0,[2,"chaperone-prompt-tag"]],["racket/base","racket"]],
["chaperone-struct",">reference/chaperones.html#(def._((quote._~23~25kernel)._chaperone-struct))",[0,[2,"chaperone-struct"]],["racket/base","racket"]],
["chaperone-struct-type",">reference/chaperones.html#(def._((quote._~23~25kernel)._chaperone-struct-type))",[0,[2,"chaperone-struct-type"]],["racket/base","racket"]],
["chaperone-vector",">reference/chaperones.html#(def._((quote._~23~25kernel)._chaperone-vector))",[0,[2,"chaperone-vector"]],["racket/base","racket"]],
["chaperone?",">reference/chaperones.html#(def._((quote._~23~25kernel)._chaperone~3f))",[0,[2,"chaperone?"]],["racket/base","racket"]],
["chapref",">scribble/config.html#(idx._(gentag._21._(lib._scribblings/scribble/scribble..scrbl)))","ChapRef",false],
["chaprefuc",">scribble/config.html#(idx._(gentag._24._(lib._scribblings/scribble/scribble..scrbl)))","ChapRefUC",false],
["char",">syntax/Library_Syntax_Classes_and_Literal_Sets.html#(form._((lib._syntax/parse..rkt)._char))",[0,[1,"char"]],["syntax/parse"]],
["char",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Char))",[0,[1,"Char"]],["typed/racket/base","typed/racket"]],
["char->integer",">reference/characters.html#(def._((quote._~23~25kernel)._char-~3einteger))",[0,[2,"char->integer"]],["racket/base","racket"]],
["char->integer",">r5rs-std/r5rs-Z-H-9.html#%_idx_498",[0,[2,"char->integer"]],["r5rs"]],
["char->integer",">r6rs-std/r6rs-Z-H-14.html#node_idx_670",[0,[2,"char->integer"]],["rnrs/base-6"]],
["char->integer",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._char-~3einteger))",[0,[2,"char->integer"]],["lang/htdp-advanced"]],
["char->integer",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._char-~3einteger))",[0,[2,"char->integer"]],["lang/htdp-beginner"]],
["char->integer",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._char-~3einteger))",[0,[2,"char->integer"]],["lang/htdp-beginner-abbr"]],
["char->integer",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._char-~3einteger))",[0,[2,"char->integer"]],["lang/htdp-intermediate"]],
["char->integer",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._char-~3einteger))",[0,[2,"char->integer"]],["lang/htdp-intermediate-lambda"]],
["char-alphabetic?",">reference/characters.html#(def._((quote._~23~25kernel)._char-alphabetic~3f))",[0,[2,"char-alphabetic?"]],["racket/base","racket"]],
["char-alphabetic?",">r5rs-std/r5rs-Z-H-9.html#%_idx_488",[0,[2,"char-alphabetic?"]],["r5rs"]],
["char-alphabetic?",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_22",[0,[2,"char-alphabetic?"]],["rnrs/unicode-6"]],
["char-alphabetic?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._char-alphabetic~3f))",[0,[2,"char-alphabetic?"]],["lang/htdp-advanced"]],
["char-alphabetic?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._char-alphabetic~3f))",[0,[2,"char-alphabetic?"]],["lang/htdp-beginner"]],
["char-alphabetic?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._char-alphabetic~3f))",[0,[2,"char-alphabetic?"]],["lang/htdp-beginner-abbr"]],
["char-alphabetic?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._char-alphabetic~3f))",[0,[2,"char-alphabetic?"]],["lang/htdp-intermediate"]],
["char-alphabetic?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._char-alphabetic~3f))",[0,[2,"char-alphabetic?"]],["lang/htdp-intermediate-lambda"]],
["char-blank?",">reference/characters.html#(def._((quote._~23~25kernel)._char-blank~3f))",[0,[2,"char-blank?"]],["racket/base","racket"]],
["char-ci<=?",">reference/characters.html#(def._((quote._~23~25kernel)._char-ci~3c~3d~3f))",[0,[2,"char-ci<=?"]],["racket/base","racket"]],
["char-ci<=?",">r5rs-std/r5rs-Z-H-9.html#%_idx_484",[0,[2,"char-ci<=?"]],["r5rs"]],
["char-ci<=?",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_18",[0,[2,"char-ci<=?"]],["rnrs/unicode-6"]],
["char-ci<=?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._char-ci~3c~3d~3f))",[0,[2,"char-ci<=?"]],["lang/htdp-advanced"]],
["char-ci<=?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._char-ci~3c~3d~3f))",[0,[2,"char-ci<=?"]],["lang/htdp-beginner"]],
["char-ci<=?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._char-ci~3c~3d~3f))",[0,[2,"char-ci<=?"]],["lang/htdp-beginner-abbr"]],
["char-ci<=?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._char-ci~3c~3d~3f))",[0,[2,"char-ci<=?"]],["lang/htdp-intermediate"]],
["char-ci<=?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._char-ci~3c~3d~3f))",[0,[2,"char-ci<=?"]],["lang/htdp-intermediate-lambda"]],
["char-ci<?",">reference/characters.html#(def._((quote._~23~25kernel)._char-ci~3c~3f))",[0,[2,"char-ci<?"]],["racket/base","racket"]],
["char-ci<?",">r5rs-std/r5rs-Z-H-9.html#%_idx_480",[0,[2,"char-ci<?"]],["r5rs"]],
["char-ci<?",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_14",[0,[2,"char-ci<?"]],["rnrs/unicode-6"]],
["char-ci<?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._char-ci~3c~3f))",[0,[2,"char-ci<?"]],["lang/htdp-advanced"]],
["char-ci<?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._char-ci~3c~3f))",[0,[2,"char-ci<?"]],["lang/htdp-beginner"]],
["char-ci<?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._char-ci~3c~3f))",[0,[2,"char-ci<?"]],["lang/htdp-beginner-abbr"]],
["char-ci<?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._char-ci~3c~3f))",[0,[2,"char-ci<?"]],["lang/htdp-intermediate"]],
["char-ci<?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._char-ci~3c~3f))",[0,[2,"char-ci<?"]],["lang/htdp-intermediate-lambda"]],
["char-ci=?",">reference/characters.html#(def._((quote._~23~25kernel)._char-ci~3d~3f))",[0,[2,"char-ci=?"]],["racket/base","racket"]],
["char-ci=?",">r5rs-std/r5rs-Z-H-9.html#%_idx_478",[0,[2,"char-ci=?"]],["r5rs"]],
["char-ci=?",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_12",[0,[2,"char-ci=?"]],["rnrs/unicode-6"]],
["char-ci=?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._char-ci~3d~3f))",[0,[2,"char-ci=?"]],["lang/htdp-advanced"]],
["char-ci=?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._char-ci~3d~3f))",[0,[2,"char-ci=?"]],["lang/htdp-beginner"]],
["char-ci=?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._char-ci~3d~3f))",[0,[2,"char-ci=?"]],["lang/htdp-beginner-abbr"]],
["char-ci=?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._char-ci~3d~3f))",[0,[2,"char-ci=?"]],["lang/htdp-intermediate"]],
["char-ci=?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._char-ci~3d~3f))",[0,[2,"char-ci=?"]],["lang/htdp-intermediate-lambda"]],
["char-ci>=?",">reference/characters.html#(def._((quote._~23~25kernel)._char-ci~3e~3d~3f))",[0,[2,"char-ci>=?"]],["racket/base","racket"]],
["char-ci>=?",">r5rs-std/r5rs-Z-H-9.html#%_idx_486",[0,[2,"char-ci>=?"]],["r5rs"]],
["char-ci>=?",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_20",[0,[2,"char-ci>=?"]],["rnrs/unicode-6"]],
["char-ci>=?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._char-ci~3e~3d~3f))",[0,[2,"char-ci>=?"]],["lang/htdp-advanced"]],
["char-ci>=?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._char-ci~3e~3d~3f))",[0,[2,"char-ci>=?"]],["lang/htdp-beginner"]],
["char-ci>=?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._char-ci~3e~3d~3f))",[0,[2,"char-ci>=?"]],["lang/htdp-beginner-abbr"]],
["char-ci>=?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._char-ci~3e~3d~3f))",[0,[2,"char-ci>=?"]],["lang/htdp-intermediate"]],
["char-ci>=?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._char-ci~3e~3d~3f))",[0,[2,"char-ci>=?"]],["lang/htdp-intermediate-lambda"]],
["char-ci>?",">reference/characters.html#(def._((quote._~23~25kernel)._char-ci~3e~3f))",[0,[2,"char-ci>?"]],["racket/base","racket"]],
["char-ci>?",">r5rs-std/r5rs-Z-H-9.html#%_idx_482",[0,[2,"char-ci>?"]],["r5rs"]],
["char-ci>?",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_16",[0,[2,"char-ci>?"]],["rnrs/unicode-6"]],
["char-ci>?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._char-ci~3e~3f))",[0,[2,"char-ci>?"]],["lang/htdp-advanced"]],
["char-ci>?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._char-ci~3e~3f))",[0,[2,"char-ci>?"]],["lang/htdp-beginner"]],
["char-ci>?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._char-ci~3e~3f))",[0,[2,"char-ci>?"]],["lang/htdp-beginner-abbr"]],
["char-ci>?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._char-ci~3e~3f))",[0,[2,"char-ci>?"]],["lang/htdp-intermediate"]],
["char-ci>?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._char-ci~3e~3f))",[0,[2,"char-ci>?"]],["lang/htdp-intermediate-lambda"]],
["char-downcase",">reference/characters.html#(def._((quote._~23~25kernel)._char-downcase))",[0,[2,"char-downcase"]],["racket/base","racket"]],
["char-downcase",">r5rs-std/r5rs-Z-H-9.html#%_idx_504",[0,[2,"char-downcase"]],["r5rs"]],
["char-downcase",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_6",[0,[2,"char-downcase"]],["rnrs/unicode-6"]],
["char-downcase",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._char-downcase))",[0,[2,"char-downcase"]],["lang/htdp-advanced"]],
["char-downcase",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._char-downcase))",[0,[2,"char-downcase"]],["lang/htdp-beginner"]],
["char-downcase",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._char-downcase))",[0,[2,"char-downcase"]],["lang/htdp-beginner-abbr"]],
["char-downcase",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._char-downcase))",[0,[2,"char-downcase"]],["lang/htdp-intermediate"]],
["char-downcase",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._char-downcase))",[0,[2,"char-downcase"]],["lang/htdp-intermediate-lambda"]],
["char-foldcase",">reference/characters.html#(def._((quote._~23~25kernel)._char-foldcase))",[0,[2,"char-foldcase"]],["racket/base","racket"]],
["char-foldcase",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_10",[0,[2,"char-foldcase"]],["rnrs/unicode-6"]],
["char-general-category",">reference/characters.html#(def._((quote._~23~25kernel)._char-general-category))",[0,[2,"char-general-category"]],["racket/base","racket"]],
["char-general-category",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_34",[0,[2,"char-general-category"]],["rnrs/unicode-6"]],
["char-graphic?",">reference/characters.html#(def._((quote._~23~25kernel)._char-graphic~3f))",[0,[2,"char-graphic?"]],["racket/base","racket"]],
["char-iso-control?",">reference/characters.html#(def._((quote._~23~25kernel)._char-iso-control~3f))",[0,[2,"char-iso-control?"]],["racket/base","racket"]],
["char-lower-case?",">reference/characters.html#(def._((quote._~23~25kernel)._char-lower-case~3f))",[0,[2,"char-lower-case?"]],["racket/base","racket"]],
["char-lower-case?",">r5rs-std/r5rs-Z-H-9.html#%_idx_496",[0,[2,"char-lower-case?"]],["r5rs"]],
["char-lower-case?",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_30",[0,[2,"char-lower-case?"]],["rnrs/unicode-6"]],
["char-lower-case?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._char-lower-case~3f))",[0,[2,"char-lower-case?"]],["lang/htdp-advanced"]],
["char-lower-case?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._char-lower-case~3f))",[0,[2,"char-lower-case?"]],["lang/htdp-beginner"]],
["char-lower-case?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._char-lower-case~3f))",[0,[2,"char-lower-case?"]],["lang/htdp-beginner-abbr"]],
["char-lower-case?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._char-lower-case~3f))",[0,[2,"char-lower-case?"]],["lang/htdp-intermediate"]],
["char-lower-case?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._char-lower-case~3f))",[0,[2,"char-lower-case?"]],["lang/htdp-intermediate-lambda"]],
["char-numeric?",">reference/characters.html#(def._((quote._~23~25kernel)._char-numeric~3f))",[0,[2,"char-numeric?"]],["racket/base","racket"]],
["char-numeric?",">r5rs-std/r5rs-Z-H-9.html#%_idx_490",[0,[2,"char-numeric?"]],["r5rs"]],
["char-numeric?",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_24",[0,[2,"char-numeric?"]],["rnrs/unicode-6"]],
["char-numeric?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._char-numeric~3f))",[0,[2,"char-numeric?"]],["lang/htdp-advanced"]],
["char-numeric?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._char-numeric~3f))",[0,[2,"char-numeric?"]],["lang/htdp-beginner"]],
["char-numeric?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._char-numeric~3f))",[0,[2,"char-numeric?"]],["lang/htdp-beginner-abbr"]],
["char-numeric?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._char-numeric~3f))",[0,[2,"char-numeric?"]],["lang/htdp-intermediate"]],
["char-numeric?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._char-numeric~3f))",[0,[2,"char-numeric?"]],["lang/htdp-intermediate-lambda"]],
["char-punctuation?",">reference/characters.html#(def._((quote._~23~25kernel)._char-punctuation~3f))",[0,[2,"char-punctuation?"]],["racket/base","racket"]],
["char-ready?",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._char-ready~3f))",[0,[2,"char-ready?"]],["racket/base","racket"]],
["char-ready?",">r5rs-std/r5rs-Z-H-9.html#%_idx_650",[0,[2,"char-ready?"]],["r5rs"]],
["char-set",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex..rkt)._char-set))",[0,[1,"char-set"]],["parser-tools/lex"]],
["char-set",">srfi-std/srfi-14.html#char-set",[0,[2,"char-set"]],["srfi/14"]],
["char-set->list",">srfi-std/srfi-14.html#char-set->list",[0,[2,"char-set->list"]],["srfi/14"]],
["char-set->string",">srfi-std/srfi-14.html#char-set->string",[0,[2,"char-set->string"]],["srfi/14"]],
["char-set-adjoin",">srfi-std/srfi-14.html#char-set-adjoin",[0,[2,"char-set-adjoin"]],["srfi/14"]],
["char-set-adjoin!",">srfi-std/srfi-14.html#char-set-adjoin!",[0,[2,"char-set-adjoin!"]],["srfi/14"]],
["char-set-any",">srfi-std/srfi-14.html#char-set-any",[0,[2,"char-set-any"]],["srfi/14"]],
["char-set-complement",">srfi-std/srfi-14.html#char-set-complement",[0,[2,"char-set-complement"]],["srfi/14"]],
["char-set-complement!",">srfi-std/srfi-14.html#char-set-complement!",[0,[2,"char-set-complement!"]],["srfi/14"]],
["char-set-contains?",">srfi-std/srfi-14.html#char-set-contains-p",[0,[2,"char-set-contains?"]],["srfi/14"]],
["char-set-copy",">srfi-std/srfi-14.html#char-set-copy",[0,[2,"char-set-copy"]],["srfi/14"]],
["char-set-count",">srfi-std/srfi-14.html#char-set-count",[0,[2,"char-set-count"]],["srfi/14"]],
["char-set-cursor",">srfi-std/srfi-14.html#char-set-cursor",[0,[2,"char-set-cursor"]],["srfi/14"]],
["char-set-cursor-next",">srfi-std/srfi-14.html#char-set-cursor-next",[0,[2,"char-set-cursor-next"]],["srfi/14"]],
["char-set-delete",">srfi-std/srfi-14.html#char-set-delete",[0,[2,"char-set-delete"]],["srfi/14"]],
["char-set-delete!",">srfi-std/srfi-14.html#char-set-delete!",[0,[2,"char-set-delete!"]],["srfi/14"]],
["char-set-diff+intersection",">srfi-std/srfi-14.html#char-set-diff+intersection",[0,[2,"char-set-diff+intersection"]],["srfi/14"]],
["char-set-diff+intersection!",">srfi-std/srfi-14.html#char-set-diff+intersection!",[0,[2,"char-set-diff+intersection!"]],["srfi/14"]],
["char-set-difference",">srfi-std/srfi-14.html#char-set-difference",[0,[2,"char-set-difference"]],["srfi/14"]],
["char-set-difference!",">srfi-std/srfi-14.html#char-set-difference!",[0,[2,"char-set-difference!"]],["srfi/14"]],
["char-set-every",">srfi-std/srfi-14.html#char-set-every",[0,[2,"char-set-every"]],["srfi/14"]],
["char-set-filter",">srfi-std/srfi-14.html#char-set-filter",[0,[2,"char-set-filter"]],["srfi/14"]],
["char-set-filter!",">srfi-std/srfi-14.html#char-set-filter!",[0,[2,"char-set-filter!"]],["srfi/14"]],
["char-set-fold",">srfi-std/srfi-14.html#char-set-fold",[0,[2,"char-set-fold"]],["srfi/14"]],
["char-set-for-each",">srfi-std/srfi-14.html#char-set-for-each",[0,[2,"char-set-for-each"]],["srfi/14"]],
["char-set-hash",">srfi-std/srfi-14.html#char-set-hash",[0,[2,"char-set-hash"]],["srfi/14"]],
["char-set-intersection",">srfi-std/srfi-14.html#char-set-intersection",[0,[2,"char-set-intersection"]],["srfi/14"]],
["char-set-intersection!",">srfi-std/srfi-14.html#char-set-intersection!",[0,[2,"char-set-intersection!"]],["srfi/14"]],
["char-set-map",">srfi-std/srfi-14.html#char-set-map",[0,[2,"char-set-map"]],["srfi/14"]],
["char-set-ref",">srfi-std/srfi-14.html#char-set-ref",[0,[2,"char-set-ref"]],["srfi/14"]],
["char-set-size",">srfi-std/srfi-14.html#char-set-size",[0,[2,"char-set-size"]],["srfi/14"]],
["char-set-unfold",">srfi-std/srfi-14.html#char-set-unfold",[0,[2,"char-set-unfold"]],["srfi/14"]],
["char-set-unfold!",">srfi-std/srfi-14.html#char-set-unfold!",[0,[2,"char-set-unfold!"]],["srfi/14"]],
["char-set-union",">srfi-std/srfi-14.html#char-set-union",[0,[2,"char-set-union"]],["srfi/14"]],
["char-set-union!",">srfi-std/srfi-14.html#char-set-union!",[0,[2,"char-set-union!"]],["srfi/14"]],
["char-set-xor",">srfi-std/srfi-14.html#char-set-xor",[0,[2,"char-set-xor"]],["srfi/14"]],
["char-set-xor!",">srfi-std/srfi-14.html#char-set-xor!",[0,[2,"char-set-xor!"]],["srfi/14"]],
["char-set:ascii",">srfi-std/srfi-14.html#char-set:ascii",[0,[2,"char-set:ascii"]],["srfi/14"]],
["char-set:blank",">srfi-std/srfi-14.html#char-set:blank",[0,[2,"char-set:blank"]],["srfi/14"]],
["char-set:digit",">srfi-std/srfi-14.html#char-set:digit",[0,[2,"char-set:digit"]],["srfi/14"]],
["char-set:empty",">srfi-std/srfi-14.html#char-set:empty",[0,[2,"char-set:empty"]],["srfi/14"]],
["char-set:full",">srfi-std/srfi-14.html#char-set:full",[0,[2,"char-set:full"]],["srfi/14"]],
["char-set:graphic",">srfi-std/srfi-14.html#char-set:graphic",[0,[2,"char-set:graphic"]],["srfi/14"]],
["char-set:hex-digit",">srfi-std/srfi-14.html#char-set:hex-digit",[0,[2,"char-set:hex-digit"]],["srfi/14"]],
["char-set:iso-control",">srfi-std/srfi-14.html#char-set:iso-control",[0,[2,"char-set:iso-control"]],["srfi/14"]],
["char-set:letter",">srfi-std/srfi-14.html#char-set:letter",[0,[2,"char-set:letter"]],["srfi/14"]],
["char-set:letter+digit",">srfi-std/srfi-14.html#char-set:letter+digit",[0,[2,"char-set:letter+digit"]],["srfi/14"]],
["char-set:lower-case",">srfi-std/srfi-14.html#char-set:lower-case",[0,[2,"char-set:lower-case"]],["srfi/14"]],
["char-set:printing",">srfi-std/srfi-14.html#char-set:printing",[0,[2,"char-set:printing"]],["srfi/14"]],
["char-set:punctuation",">srfi-std/srfi-14.html#char-set:punctuation",[0,[2,"char-set:punctuation"]],["srfi/14"]],
["char-set:symbol",">srfi-std/srfi-14.html#char-set:symbol",[0,[2,"char-set:symbol"]],["srfi/14"]],
["char-set:title-case",">srfi-std/srfi-14.html#char-set:title-case",[0,[2,"char-set:title-case"]],["srfi/14"]],
["char-set:upper-case",">srfi-std/srfi-14.html#char-set:upper-case",[0,[2,"char-set:upper-case"]],["srfi/14"]],
["char-set:whitespace",">srfi-std/srfi-14.html#char-set:whitespace",[0,[2,"char-set:whitespace"]],["srfi/14"]],
["char-set<=",">srfi-std/srfi-14.html#char-set<=",[0,[2,"char-set<="]],["srfi/14"]],
["char-set=",">srfi-std/srfi-14.html#char-set=",[0,[2,"char-set="]],["srfi/14"]],
["char-set?",">srfi-std/srfi-14.html#char-set-p",[0,[2,"char-set?"]],["srfi/14"]],
["char-symbolic?",">reference/characters.html#(def._((quote._~23~25kernel)._char-symbolic~3f))",[0,[2,"char-symbolic?"]],["racket/base","racket"]],
["char-title-case?",">reference/characters.html#(def._((quote._~23~25kernel)._char-title-case~3f))",[0,[2,"char-title-case?"]],["racket/base","racket"]],
["char-title-case?",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_32",[0,[2,"char-title-case?"]],["rnrs/unicode-6"]],
["char-titlecase",">reference/characters.html#(def._((quote._~23~25kernel)._char-titlecase))",[0,[2,"char-titlecase"]],["racket/base","racket"]],
["char-titlecase",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_8",[0,[2,"char-titlecase"]],["rnrs/unicode-6"]],
["char-upcase",">reference/characters.html#(def._((quote._~23~25kernel)._char-upcase))",[0,[2,"char-upcase"]],["racket/base","racket"]],
["char-upcase",">r5rs-std/r5rs-Z-H-9.html#%_idx_502",[0,[2,"char-upcase"]],["r5rs"]],
["char-upcase",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_4",[0,[2,"char-upcase"]],["rnrs/unicode-6"]],
["char-upcase",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._char-upcase))",[0,[2,"char-upcase"]],["lang/htdp-advanced"]],
["char-upcase",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._char-upcase))",[0,[2,"char-upcase"]],["lang/htdp-beginner"]],
["char-upcase",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._char-upcase))",[0,[2,"char-upcase"]],["lang/htdp-beginner-abbr"]],
["char-upcase",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._char-upcase))",[0,[2,"char-upcase"]],["lang/htdp-intermediate"]],
["char-upcase",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._char-upcase))",[0,[2,"char-upcase"]],["lang/htdp-intermediate-lambda"]],
["char-upper-case?",">reference/characters.html#(def._((quote._~23~25kernel)._char-upper-case~3f))",[0,[2,"char-upper-case?"]],["racket/base","racket"]],
["char-upper-case?",">r5rs-std/r5rs-Z-H-9.html#%_idx_494",[0,[2,"char-upper-case?"]],["r5rs"]],
["char-upper-case?",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_28",[0,[2,"char-upper-case?"]],["rnrs/unicode-6"]],
["char-upper-case?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._char-upper-case~3f))",[0,[2,"char-upper-case?"]],["lang/htdp-advanced"]],
["char-upper-case?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._char-upper-case~3f))",[0,[2,"char-upper-case?"]],["lang/htdp-beginner"]],
["char-upper-case?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._char-upper-case~3f))",[0,[2,"char-upper-case?"]],["lang/htdp-beginner-abbr"]],
["char-upper-case?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._char-upper-case~3f))",[0,[2,"char-upper-case?"]],["lang/htdp-intermediate"]],
["char-upper-case?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._char-upper-case~3f))",[0,[2,"char-upper-case?"]],["lang/htdp-intermediate-lambda"]],
["char-utf-8-length",">reference/characters.html#(def._((quote._~23~25kernel)._char-utf-8-length))",[0,[2,"char-utf-8-length"]],["racket/base","racket"]],
["char-whitespace?",">reference/characters.html#(def._((quote._~23~25kernel)._char-whitespace~3f))",[0,[2,"char-whitespace?"]],["racket/base","racket"]],
["char-whitespace?",">r5rs-std/r5rs-Z-H-9.html#%_idx_492",[0,[2,"char-whitespace?"]],["r5rs"]],
["char-whitespace?",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_26",[0,[2,"char-whitespace?"]],["rnrs/unicode-6"]],
["char-whitespace?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._char-whitespace~3f))",[0,[2,"char-whitespace?"]],["lang/htdp-advanced"]],
["char-whitespace?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._char-whitespace~3f))",[0,[2,"char-whitespace?"]],["lang/htdp-beginner"]],
["char-whitespace?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._char-whitespace~3f))",[0,[2,"char-whitespace?"]],["lang/htdp-beginner-abbr"]],
["char-whitespace?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._char-whitespace~3f))",[0,[2,"char-whitespace?"]],["lang/htdp-intermediate"]],
["char-whitespace?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._char-whitespace~3f))",[0,[2,"char-whitespace?"]],["lang/htdp-intermediate-lambda"]],
["char<=?",">reference/characters.html#(def._((quote._~23~25kernel)._char~3c~3d~3f))",[0,[2,"char<=?"]],["racket/base","racket"]],
["char<=?",">r5rs-std/r5rs-Z-H-9.html#%_idx_474",[0,[2,"char<=?"]],["r5rs"]],
["char<=?",">r6rs-std/r6rs-Z-H-14.html#node_idx_680",[0,[2,"char<=?"]],["rnrs/base-6"]],
["char<=?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._char~3c~3d~3f))",[0,[2,"char<=?"]],["lang/htdp-advanced"]],
["char<=?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._char~3c~3d~3f))",[0,[2,"char<=?"]],["lang/htdp-beginner"]],
["char<=?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._char~3c~3d~3f))",[0,[2,"char<=?"]],["lang/htdp-beginner-abbr"]],
["char<=?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._char~3c~3d~3f))",[0,[2,"char<=?"]],["lang/htdp-intermediate"]],
["char<=?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._char~3c~3d~3f))",[0,[2,"char<=?"]],["lang/htdp-intermediate-lambda"]],
["char<?",">reference/characters.html#(def._((quote._~23~25kernel)._char~3c~3f))",[0,[2,"char<?"]],["racket/base","racket"]],
["char<?",">r5rs-std/r5rs-Z-H-9.html#%_idx_470",[0,[2,"char<?"]],["r5rs"]],
["char<?",">r6rs-std/r6rs-Z-H-14.html#node_idx_676",[0,[2,"char<?"]],["rnrs/base-6"]],
["char<?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._char~3c~3f))",[0,[2,"char<?"]],["lang/htdp-advanced"]],
["char<?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._char~3c~3f))",[0,[2,"char<?"]],["lang/htdp-beginner"]],
["char<?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._char~3c~3f))",[0,[2,"char<?"]],["lang/htdp-beginner-abbr"]],
["char<?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._char~3c~3f))",[0,[2,"char<?"]],["lang/htdp-intermediate"]],
["char<?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._char~3c~3f))",[0,[2,"char<?"]],["lang/htdp-intermediate-lambda"]],
["char=?",">reference/characters.html#(def._((quote._~23~25kernel)._char~3d~3f))",[0,[2,"char=?"]],["racket/base","racket"]],
["char=?",">r5rs-std/r5rs-Z-H-9.html#%_idx_468",[0,[2,"char=?"]],["r5rs"]],
["char=?",">r6rs-std/r6rs-Z-H-14.html#node_idx_674",[0,[2,"char=?"]],["rnrs/base-6"]],
["char=?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._char~3d~3f))",[0,[2,"char=?"]],["lang/htdp-advanced"]],
["char=?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._char~3d~3f))",[0,[2,"char=?"]],["lang/htdp-beginner"]],
["char=?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._char~3d~3f))",[0,[2,"char=?"]],["lang/htdp-beginner-abbr"]],
["char=?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._char~3d~3f))",[0,[2,"char=?"]],["lang/htdp-intermediate"]],
["char=?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._char~3d~3f))",[0,[2,"char=?"]],["lang/htdp-intermediate-lambda"]],
["char>=?",">reference/characters.html#(def._((quote._~23~25kernel)._char~3e~3d~3f))",[0,[2,"char>=?"]],["racket/base","racket"]],
["char>=?",">r5rs-std/r5rs-Z-H-9.html#%_idx_476",[0,[2,"char>=?"]],["r5rs"]],
["char>=?",">r6rs-std/r6rs-Z-H-14.html#node_idx_682",[0,[2,"char>=?"]],["rnrs/base-6"]],
["char>=?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._char~3e~3d~3f))",[0,[2,"char>=?"]],["lang/htdp-advanced"]],
["char>=?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._char~3e~3d~3f))",[0,[2,"char>=?"]],["lang/htdp-beginner"]],
["char>=?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._char~3e~3d~3f))",[0,[2,"char>=?"]],["lang/htdp-beginner-abbr"]],
["char>=?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._char~3e~3d~3f))",[0,[2,"char>=?"]],["lang/htdp-intermediate"]],
["char>=?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._char~3e~3d~3f))",[0,[2,"char>=?"]],["lang/htdp-intermediate-lambda"]],
["char>?",">reference/characters.html#(def._((quote._~23~25kernel)._char~3e~3f))",[0,[2,"char>?"]],["racket/base","racket"]],
["char>?",">r5rs-std/r5rs-Z-H-9.html#%_idx_472",[0,[2,"char>?"]],["r5rs"]],
["char>?",">r6rs-std/r6rs-Z-H-14.html#node_idx_678",[0,[2,"char>?"]],["rnrs/base-6"]],
["char>?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._char~3e~3f))",[0,[2,"char>?"]],["lang/htdp-advanced"]],
["char>?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._char~3e~3f))",[0,[2,"char>?"]],["lang/htdp-beginner"]],
["char>?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._char~3e~3f))",[0,[2,"char>?"]],["lang/htdp-beginner-abbr"]],
["char>?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._char~3e~3f))",[0,[2,"char>?"]],["lang/htdp-intermediate"]],
["char>?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._char~3e~3f))",[0,[2,"char>?"]],["lang/htdp-intermediate-lambda"]],
["char?",">reference/characters.html#(def._((quote._~23~25kernel)._char~3f))",[0,[2,"char?"]],["racket/base","racket"]],
["char?",">r5rs-std/r5rs-Z-H-9.html#%_idx_466",[0,[2,"char?"]],["r5rs"]],
["char?",">r6rs-std/r6rs-Z-H-14.html#node_idx_668",[0,[2,"char?"]],["rnrs/base-6"]],
["char?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._char~3f))",[0,[2,"char?"]],["lang/htdp-advanced"]],
["char?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._char~3f))",[0,[2,"char?"]],["lang/htdp-beginner"]],
["char?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._char~3f))",[0,[2,"char?"]],["lang/htdp-beginner-abbr"]],
["char?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._char~3f))",[0,[2,"char?"]],["lang/htdp-intermediate"]],
["char?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._char~3f))",[0,[2,"char?"]],["lang/htdp-intermediate-lambda"]],
["character",">guide/characters.html#(tech._character)","<span style=\"font-style: italic\">character</span>",false],
["character class",">guide/regexp-chars.html#(tech._character._clas)","<span style=\"font-style: italic\">character class</span>",false],
["character comparisons",">reference/characters.html#(part._.Character_.Comparisons)","Character Comparisons",false],
["character conversions",">reference/characters.html#(part._.Character_.Conversions)","Character Conversions",false],
["character-boy",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._character-boy))",[0,[2,"character-boy"]],["2htdp/planetcute"]],
["character-cat-girl",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._character-cat-girl))",[0,[2,"character-cat-girl"]],["2htdp/planetcute"]],
["character-horn-girl",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._character-horn-girl))",[0,[2,"character-horn-girl"]],["2htdp/planetcute"]],
["character-pink-girl",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._character-pink-girl))",[0,[2,"character-pink-girl"]],["2htdp/planetcute"]],
["character-princess-girl",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._character-princess-girl))",[0,[2,"character-princess-girl"]],["2htdp/planetcute"]],
["characters",">guide/characters.html","Characters",false],
["characters",">htdp-langs/advanced.html#(part._htdp-advanced._.Characters)","Characters",false],
["characters",">htdp-langs/beginner.html#(part._htdp-beginner._.Characters)","Characters",false],
["characters",">htdp-langs/beginner-abbr.html#(part._htdp-beginner-abbr._.Characters)","Characters",false],
["characters",">htdp-langs/intermediate.html#(part._htdp-intermediate._.Characters)","Characters",false],
["characters",">htdp-langs/intermediate-lam.html#(part._htdp-intermediate-lambda._.Characters)","Characters",false],
["characters",">reference/characters.html","Characters",false],
["characters",">teachpack/2htdpPlanet_Cute_Images.html#(part._pc~3a.Characters)","Characters",false],
["characters",">reference/characters.html#(tech._character)","<span style=\"font-style: italic\">Characters</span>",false],
["characters and character classes",">guide/regexp-chars.html","Characters and Character Classes",false],
["characters and scalar values",">reference/characters.html#(part._.Characters_and_.Scalar_.Values)","Characters and Scalar Values",false],
["chat noir --- puzzle game",">games/chat-noir.html",[[15,"<img src=\"chat-noir.png\" alt=\"\" />"]," ","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Chat Noir</span>"," ","&#8212;","<wbr></wbr>"," Puzzle Game"],false],
["check",">gui/checkable-menu-item_.html#(meth._(((lib._mred/main..rkt)._checkable-menu-item~25)._check))",[[0,[2,"check"]],[14,[" (method of ",[0,[2,"checkable-menu-item%"]],")"]]],["racket/gui/base","racket/gui"]],
["check",">rackunit/api.html#(def._((lib._rackunit/main..rkt)._check))",[0,[2,"check"]],["rackunit"]],
["check box",">gui/windowing-overview.html#(tech._check._box)","<span style=\"font-style: italic\">check box</span>",false],
["check syntax question-mark arrows",">drracket/buttons.html#(idx._(gentag._10._(lib._scribblings/drracket/drracket..scrbl)))","Check\n       syntax, question-mark arrows",false],
["check syntax purple arrows",">drracket/buttons.html#(idx._(gentag._9._(lib._scribblings/drracket/drracket..scrbl)))","Check syntax, purple arrows",false],
["check syntax",">tools/Check_Syntax.html","Check Syntax",false],
["check syntax button",">tools/Check_Syntax.html#(part._.Check_.Syntax_.Button)","Check Syntax Button",false],
["check syntax button",">drracket/buttons.html#(idx._(gentag._8._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Check Syntax</span> button",false],
["check-=",">rackunit/api.html#(def._((lib._rackunit/main..rkt)._check-~3d))",[0,[2,"check-="]],["rackunit"]],
["check-arg",">htdp/index.html#(def._((lib._htdp/error..rkt)._check-arg))",[0,[2,"check-arg"]],["htdp/error"]],
["check-arity",">htdp/index.html#(def._((lib._htdp/error..rkt)._check-arity))",[0,[2,"check-arity"]],["htdp/error"]],
["check-box",">gui/check-box_.html#(idx._(gentag._28._(lib._scribblings/gui/gui..scrbl)))",[7,"'check-box"],false],
["check-box%",">gui/check-box_.html",[0,[2,"check-box%"]],["racket/gui/base","racket/gui"]],
["check-box/notify-box",">unstable/gui-notify.html#(def._((lib._unstable/gui/notify..rkt)._check-box/notify-box))",[0,[2,"check-box/notify-box"]],["unstable/gui/notify"]],
["check-color",">htdp/index.html#(def._((lib._htdp/error..rkt)._check-color))",[0,[2,"check-color"]],["htdp/error"]],
["check-dependencies",">htdp/index.html#(def._((lib._htdp/error..rkt)._check-dependencies))",[0,[2,"check-dependencies"]],["htdp/error"]],
["check-docs",">rackunit/Testing_Utilities.html#(def._((lib._rackunit/docs-complete..rkt)._check-docs))",[0,"check-docs"],["rackunit/docs-complete"]],
["check-duplicate",">unstable/list.html#(def._((lib._unstable/list..rkt)._check-duplicate))",[0,[2,"check-duplicate"]],["unstable/list"]],
["check-duplicate-identifier",">reference/stxcmp.html#(def._((lib._racket/private/stxcase-scheme..rkt)._check-duplicate-identifier))",[0,[2,"check-duplicate-identifier"]],["racket/base","racket"]],
["check-eq?",">rackunit/api.html#(def._((lib._rackunit/main..rkt)._check-eq~3f))",[0,[2,"check-eq?"]],["rackunit"]],
["check-equal?",">rackunit/api.html#(def._((lib._rackunit/main..rkt)._check-equal~3f))",[0,[2,"check-equal?"]],["rackunit"]],
["check-eqv?",">rackunit/api.html#(def._((lib._rackunit/main..rkt)._check-eqv~3f))",[0,[2,"check-eqv?"]],["rackunit"]],
["check-error",">htdp-langs/advanced.html#(form._((lib._lang/htdp-advanced..rkt)._check-error))",[0,[1,"check-error"]],["lang/htdp-advanced"]],
["check-error",">htdp-langs/beginner.html#(form._((lib._lang/htdp-beginner..rkt)._check-error))",[0,[1,"check-error"]],["lang/htdp-beginner"]],
["check-error",">htdp-langs/beginner-abbr.html#(form._((lib._lang/htdp-beginner-abbr..rkt)._check-error))",[0,[1,"check-error"]],["lang/htdp-beginner-abbr"]],
["check-error",">htdp-langs/intermediate.html#(form._((lib._lang/htdp-intermediate..rkt)._check-error))",[0,[1,"check-error"]],["lang/htdp-intermediate"]],
["check-error",">htdp-langs/intermediate-lam.html#(form._((lib._lang/htdp-intermediate-lambda..rkt)._check-error))",[0,[1,"check-error"]],["lang/htdp-intermediate-lambda"]],
["check-error",">deinprogramm/Testf_lle.html#(form._((lib._deinprogramm/.D.Md.A..rkt)._check-error))",[0,[1,"check-error"]],["deinprogramm/DMdA-beginner"]],
["check-error",">test-engine/index.html#(form._((lib._test-engine/racket-tests..rkt)._check-error))",[0,[1,"check-error"]],["test-engine/racket-tests"]],
["check-exn",">rackunit/api.html#(def._((lib._rackunit/main..rkt)._check-exn))",[0,[2,"check-exn"]],["rackunit"]],
["check-expect",">htdp-langs/advanced.html#(form._((lib._lang/htdp-advanced..rkt)._check-expect))",[0,[1,"check-expect"]],["lang/htdp-advanced"]],
["check-expect",">htdp-langs/beginner.html#(form._((lib._lang/htdp-beginner..rkt)._check-expect))",[0,[1,"check-expect"]],["lang/htdp-beginner"]],
["check-expect",">htdp-langs/beginner-abbr.html#(form._((lib._lang/htdp-beginner-abbr..rkt)._check-expect))",[0,[1,"check-expect"]],["lang/htdp-beginner-abbr"]],
["check-expect",">htdp-langs/intermediate.html#(form._((lib._lang/htdp-intermediate..rkt)._check-expect))",[0,[1,"check-expect"]],["lang/htdp-intermediate"]],
["check-expect",">htdp-langs/intermediate-lam.html#(form._((lib._lang/htdp-intermediate-lambda..rkt)._check-expect))",[0,[1,"check-expect"]],["lang/htdp-intermediate-lambda"]],
["check-expect",">deinprogramm/Testf_lle.html#(form._((lib._deinprogramm/.D.Md.A..rkt)._check-expect))",[0,[1,"check-expect"]],["deinprogramm/DMdA-beginner"]],
["check-expect",">test-engine/index.html#(form._((lib._test-engine/racket-tests..rkt)._check-expect))",[0,[1,"check-expect"]],["test-engine/racket-tests"]],
["check-expression",">syntax/syntax-helpers.html#(def._((lib._syntax/keyword..rkt)._check-expression))",[0,[2,"check-expression"]],["syntax/keyword"]],
["check-false",">rackunit/api.html#(def._((lib._rackunit/main..rkt)._check-false))",[0,[2,"check-false"]],["rackunit"]],
["check-for-break",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._check-for-break))",[0,[2,"check-for-break"]],["racket/gui/base","racket/gui"]],
["check-fun-res",">htdp/index.html#(def._((lib._htdp/error..rkt)._check-fun-res))",[0,[2,"check-fun-res"]],["htdp/error"]],
["check-icon",">images/Icons.html#(def._((lib._images/icons/symbol..rkt)._check-icon))",[0,[2,"check-icon"]],["images/icons/symbol"]],
["check-identifier",">syntax/syntax-helpers.html#(def._((lib._syntax/keyword..rkt)._check-identifier))",[0,[2,"check-identifier"]],["syntax/keyword"]],
["check-info",">rackunit/api.html#(def._((lib._rackunit/main..rkt)._check-info))",[0,[2,"check-info"]],["rackunit"]],
["check-info-name",">rackunit/api.html#(def._((lib._rackunit/main..rkt)._check-info-name))",[0,[2,"check-info-name"]],["rackunit"]],
["check-info-value",">rackunit/api.html#(def._((lib._rackunit/main..rkt)._check-info-value))",[0,[2,"check-info-value"]],["rackunit"]],
["check-info?",">rackunit/api.html#(def._((lib._rackunit/main..rkt)._check-info~3f))",[0,[2,"check-info?"]],["rackunit"]],
["check-list-list",">htdp/index.html#(def._((lib._htdp/error..rkt)._check-list-list))",[0,[2,"check-list-list"]],["htdp/error"]],
["check-member-of",">htdp-langs/advanced.html#(form._((lib._lang/htdp-advanced..rkt)._check-member-of))",[0,[1,"check-member-of"]],["lang/htdp-advanced"]],
["check-member-of",">htdp-langs/beginner.html#(form._((lib._lang/htdp-beginner..rkt)._check-member-of))",[0,[1,"check-member-of"]],["lang/htdp-beginner"]],
["check-member-of",">htdp-langs/beginner-abbr.html#(form._((lib._lang/htdp-beginner-abbr..rkt)._check-member-of))",[0,[1,"check-member-of"]],["lang/htdp-beginner-abbr"]],
["check-member-of",">htdp-langs/intermediate.html#(form._((lib._lang/htdp-intermediate..rkt)._check-member-of))",[0,[1,"check-member-of"]],["lang/htdp-intermediate"]],
["check-member-of",">htdp-langs/intermediate-lam.html#(form._((lib._lang/htdp-intermediate-lambda..rkt)._check-member-of))",[0,[1,"check-member-of"]],["lang/htdp-intermediate-lambda"]],
["check-member-of",">deinprogramm/Testf_lle.html#(form._((lib._deinprogramm/.D.Md.A..rkt)._check-member-of))",[0,[1,"check-member-of"]],["deinprogramm/DMdA-beginner"]],
["check-member-of",">test-engine/index.html#(form._((lib._test-engine/racket-tests..rkt)._check-member-of))",[0,[1,"check-member-of"]],["test-engine/racket-tests"]],
["check-metafunction",">redex/The_Redex_Reference.html#(form._((lib._redex/reduction-semantics..rkt)._check-metafunction))",[0,[1,"check-metafunction"]],["redex/reduction-semantics","redex"]],
["check-module-form",">syntax/module-helpers.html#(def._((lib._syntax/modread..rkt)._check-module-form))",[0,[2,"check-module-form"]],["syntax/modread"]],
["check-not-eq?",">rackunit/api.html#(def._((lib._rackunit/main..rkt)._check-not-eq~3f))",[0,[2,"check-not-eq?"]],["rackunit"]],
["check-not-equal?",">rackunit/api.html#(def._((lib._rackunit/main..rkt)._check-not-equal~3f))",[0,[2,"check-not-equal?"]],["rackunit"]],
["check-not-eqv?",">rackunit/api.html#(def._((lib._rackunit/main..rkt)._check-not-eqv~3f))",[0,[2,"check-not-eqv?"]],["rackunit"]],
["check-not-exn",">rackunit/api.html#(def._((lib._rackunit/main..rkt)._check-not-exn))",[0,[2,"check-not-exn"]],["rackunit"]],
["check-not-false",">rackunit/api.html#(def._((lib._rackunit/main..rkt)._check-not-false))",[0,[2,"check-not-false"]],["rackunit"]],
["check-pred",">rackunit/api.html#(def._((lib._rackunit/main..rkt)._check-pred))",[0,[2,"check-pred"]],["rackunit"]],
["check-proc",">htdp/index.html#(def._((lib._htdp/error..rkt)._check-proc))",[0,[2,"check-proc"]],["htdp/error"]],
["check-procedure",">syntax/syntax-helpers.html#(tech._check._procedure)","<span style=\"font-style: italic\">check-procedure</span>",false],
["check-property",">deinprogramm/Testf_lle.html#(form._((lib._deinprogramm/.D.Md.A..rkt)._check-property))",[0,[1,"check-property"]],["deinprogramm/DMdA-beginner"]],
["check-range",">htdp-langs/advanced.html#(form._((lib._lang/htdp-advanced..rkt)._check-range))",[0,[1,"check-range"]],["lang/htdp-advanced"]],
["check-range",">htdp-langs/beginner.html#(form._((lib._lang/htdp-beginner..rkt)._check-range))",[0,[1,"check-range"]],["lang/htdp-beginner"]],
["check-range",">htdp-langs/beginner-abbr.html#(form._((lib._lang/htdp-beginner-abbr..rkt)._check-range))",[0,[1,"check-range"]],["lang/htdp-beginner-abbr"]],
["check-range",">htdp-langs/intermediate.html#(form._((lib._lang/htdp-intermediate..rkt)._check-range))",[0,[1,"check-range"]],["lang/htdp-intermediate"]],
["check-range",">htdp-langs/intermediate-lam.html#(form._((lib._lang/htdp-intermediate-lambda..rkt)._check-range))",[0,[1,"check-range"]],["lang/htdp-intermediate-lambda"]],
["check-range",">deinprogramm/Testf_lle.html#(form._((lib._deinprogramm/.D.Md.A..rkt)._check-range))",[0,[1,"check-range"]],["deinprogramm/DMdA-beginner"]],
["check-range",">test-engine/index.html#(form._((lib._test-engine/racket-tests..rkt)._check-range))",[0,[1,"check-range"]],["test-engine/racket-tests"]],
["check-reduction-relation",">redex/The_Redex_Reference.html#(form._((lib._redex/reduction-semantics..rkt)._check-reduction-relation))",[0,[1,"check-reduction-relation"]],["redex/reduction-semantics","redex"]],
["check-redudancy",">redex/The_Redex_Reference.html#(def._((lib._redex/reduction-semantics..rkt)._check-redudancy))",[0,[2,"check-redudancy"]],["redex/reduction-semantics","redex"]],
["check-regexp-match",">rackunit/api.html#(def._((lib._rackunit/main..rkt)._check-regexp-match))",[0,[2,"check-regexp-match"]],["rackunit"]],
["check-requires",">macro-debugger/index.html#(def._((lib._macro-debugger/analysis/check-requires..rkt)._check-requires))",[0,[2,"check-requires"]],["macro-debugger/analysis/check-requires"]],
["check-result",">htdp/index.html#(def._((lib._htdp/error..rkt)._check-result))",[0,[2,"check-result"]],["htdp/error"]],
["check-source-location!",">syntax/Source_Locations.html#(def._((lib._syntax/srcloc..rkt)._check-source-location!))",[0,[2,"check-source-location!"]],["syntax/srcloc"]],
["check-stx-boolean",">syntax/syntax-helpers.html#(def._((lib._syntax/keyword..rkt)._check-stx-boolean))",[0,[2,"check-stx-boolean"]],["syntax/keyword"]],
["check-stx-listof",">syntax/syntax-helpers.html#(def._((lib._syntax/keyword..rkt)._check-stx-listof))",[0,[2,"check-stx-listof"]],["syntax/keyword"]],
["check-stx-string",">syntax/syntax-helpers.html#(def._((lib._syntax/keyword..rkt)._check-stx-string))",[0,[2,"check-stx-string"]],["syntax/keyword"]],
["check-substring-spec",">srfi-std/srfi-13.html#check-substring-spec",[0,[2,"check-substring-spec"]],["srfi/13"]],
["check-syntax-icon",">images/Icons.html#(def._((lib._images/icons/tool..rkt)._check-syntax-icon))",[0,[2,"check-syntax-icon"]],["images/icons/tool"]],
["check-true",">rackunit/api.html#(def._((lib._rackunit/main..rkt)._check-true))",[0,[2,"check-true"]],["rackunit"]],
["check-version",">version/index.html#(def._((lib._version/check..rkt)._check-version))",[0,[2,"check-version"]],["version/check"]],
["check-with",">teachpack/2htdpuniverse.html#(form._((lib._2htdp/universe..rkt)._check-with))",[0,[1,"check-with"]],["2htdp/universe"]],
["check-within",">htdp-langs/advanced.html#(form._((lib._lang/htdp-advanced..rkt)._check-within))",[0,[1,"check-within"]],["lang/htdp-advanced"]],
["check-within",">htdp-langs/beginner.html#(form._((lib._lang/htdp-beginner..rkt)._check-within))",[0,[1,"check-within"]],["lang/htdp-beginner"]],
["check-within",">htdp-langs/beginner-abbr.html#(form._((lib._lang/htdp-beginner-abbr..rkt)._check-within))",[0,[1,"check-within"]],["lang/htdp-beginner-abbr"]],
["check-within",">htdp-langs/intermediate.html#(form._((lib._lang/htdp-intermediate..rkt)._check-within))",[0,[1,"check-within"]],["lang/htdp-intermediate"]],
["check-within",">htdp-langs/intermediate-lam.html#(form._((lib._lang/htdp-intermediate-lambda..rkt)._check-within))",[0,[1,"check-within"]],["lang/htdp-intermediate-lambda"]],
["check-within",">deinprogramm/Testf_lle.html#(form._((lib._deinprogramm/.D.Md.A..rkt)._check-within))",[0,[1,"check-within"]],["deinprogramm/DMdA-beginner"]],
["check-within",">test-engine/index.html#(form._((lib._test-engine/racket-tests..rkt)._check-within))",[0,[1,"check-within"]],["test-engine/racket-tests"]],
["checkable menu item",">gui/windowing-overview.html#(tech._checkable._menu._item)","<span style=\"font-style: italic\">checkable menu\nitem</span>",false],
["checkable-menu-item%",">gui/checkable-menu-item_.html",[0,[2,"checkable-menu-item%"]],["racket/gui/base","racket/gui"]],
["checkbox",">web-server/formlets.html#(def._((lib._web-server/formlets/input..rkt)._checkbox))",[0,[2,"checkbox"]],["web-server/formlets/input"]],
["checkbox-group",">web-server/formlets.html#(def._((lib._web-server/formlets/input..rkt)._checkbox-group))",[0,[2,"checkbox-group"]],["web-server/formlets/input"]],
["checked-procedure-check-and-extract",">reference/procedures.html#(def._((quote._~23~25kernel)._checked-procedure-check-and-extract))",[0,[2,"checked-procedure-check-and-extract"]],["racket/base","racket"]],
["checked-struct-info?",">reference/structinfo.html#(def._((lib._racket/struct-info..rkt)._checked-struct-info~3f))",[0,[2,"checked-struct-info?"]],["racket/struct-info"]],
["checkers --- board game",">games/checkers.html",[[15,"<img src=\"checkers.png\" alt=\"\" />"]," ","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Checkers</span>"," ","&#8212;","<wbr></wbr>"," Board Game"],false],
["checking available versions",">version/index.html#(part._.Checking_.Available_.Versions)","Checking Available Versions",false],
["checking documentation completeness",">rackunit/Testing_Utilities.html#(part._.Checking_documentation_completeness)","Checking documentation completeness",false],
["checking for variables",">racklog/lv-manip.html#(part._var)","Checking for Variables",false],
["checking properties of data structures",">guide/contracts-struct.html#(part._contracts-lazy-contracts)","Checking Properties of Data Structures",false],
["checking state changes",">guide/contracts-general-functions.html#(part._contracts-arrow-d-eval-order)","Checking State Changes",false],
["checks",">rackunit/api.html#(part._.Checks)","Checks",false],
["chest-closed",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._chest-closed))",[0,[2,"chest-closed"]],["2htdp/planetcute"]],
["chest-lid",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._chest-lid))",[0,[2,"chest-lid"]],["2htdp/planetcute"]],
["chest-open",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._chest-open))",[0,[2,"chest-open"]],["2htdp/planetcute"]],
["child",">slideshow/Pict_Datatype.html#(def._((lib._slideshow/pict..rkt)._child))",[0,[2,"child"]],["slideshow/pict","slideshow"]],
["child-dx",">slideshow/Pict_Datatype.html#(def._((lib._slideshow/pict..rkt)._child-dx))",[0,[2,"child-dx"]],["slideshow/pict","slideshow"]],
["child-dy",">slideshow/Pict_Datatype.html#(def._((lib._slideshow/pict..rkt)._child-dy))",[0,[2,"child-dy"]],["slideshow/pict","slideshow"]],
["child-pict",">slideshow/Pict_Datatype.html#(def._((lib._slideshow/pict..rkt)._child-pict))",[0,[2,"child-pict"]],["slideshow/pict","slideshow"]],
["child-sx",">slideshow/Pict_Datatype.html#(def._((lib._slideshow/pict..rkt)._child-sx))",[0,[2,"child-sx"]],["slideshow/pict","slideshow"]],
["child-sxy",">slideshow/Pict_Datatype.html#(def._((lib._slideshow/pict..rkt)._child-sxy))",[0,[2,"child-sxy"]],["slideshow/pict","slideshow"]],
["child-sy",">slideshow/Pict_Datatype.html#(def._((lib._slideshow/pict..rkt)._child-sy))",[0,[2,"child-sy"]],["slideshow/pict","slideshow"]],
["child-syx",">slideshow/Pict_Datatype.html#(def._((lib._slideshow/pict..rkt)._child-syx))",[0,[2,"child-syx"]],["slideshow/pict","slideshow"]],
["child?",">slideshow/Pict_Datatype.html#(def._((lib._slideshow/pict..rkt)._child~3f))",[0,[2,"child?"]],["slideshow/pict","slideshow"]],
["chocolate-cookie",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._chocolate-cookie))",[0,[2,"chocolate-cookie"]],["deinprogramm/DMdA-advanced"]],
["chocolate-cookie",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._chocolate-cookie))",[0,[2,"chocolate-cookie"]],["deinprogramm/DMdA-assignments"]],
["chocolate-cookie",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._chocolate-cookie))",[0,[2,"chocolate-cookie"]],["deinprogramm/DMdA-beginner"]],
["chocolate-cookie",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._chocolate-cookie))",[0,[2,"chocolate-cookie"]],["deinprogramm/DMdA-vanilla"]],
["chocolate-cookie-chocolate",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._chocolate-cookie-chocolate))",[0,[2,"chocolate-cookie-chocolate"]],["deinprogramm/DMdA-advanced"]],
["chocolate-cookie-chocolate",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._chocolate-cookie-chocolate))",[0,[2,"chocolate-cookie-chocolate"]],["deinprogramm/DMdA-assignments"]],
["chocolate-cookie-chocolate",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._chocolate-cookie-chocolate))",[0,[2,"chocolate-cookie-chocolate"]],["deinprogramm/DMdA-beginner"]],
["chocolate-cookie-chocolate",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._chocolate-cookie-chocolate))",[0,[2,"chocolate-cookie-chocolate"]],["deinprogramm/DMdA-vanilla"]],
["chocolate-cookie-cookie",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._chocolate-cookie-cookie))",[0,[2,"chocolate-cookie-cookie"]],["deinprogramm/DMdA-advanced"]],
["chocolate-cookie-cookie",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._chocolate-cookie-cookie))",[0,[2,"chocolate-cookie-cookie"]],["deinprogramm/DMdA-assignments"]],
["chocolate-cookie-cookie",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._chocolate-cookie-cookie))",[0,[2,"chocolate-cookie-cookie"]],["deinprogramm/DMdA-beginner"]],
["chocolate-cookie-cookie",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._chocolate-cookie-cookie))",[0,[2,"chocolate-cookie-cookie"]],["deinprogramm/DMdA-vanilla"]],
["chocolate-cookie?",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._chocolate-cookie~3f))",[0,[2,"chocolate-cookie?"]],["deinprogramm/DMdA-advanced"]],
["chocolate-cookie?",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._chocolate-cookie~3f))",[0,[2,"chocolate-cookie?"]],["deinprogramm/DMdA-assignments"]],
["chocolate-cookie?",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._chocolate-cookie~3f))",[0,[2,"chocolate-cookie?"]],["deinprogramm/DMdA-beginner"]],
["chocolate-cookie?",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._chocolate-cookie~3f))",[0,[2,"chocolate-cookie?"]],["deinprogramm/DMdA-vanilla"]],
["choice",">gui/choice_.html#(idx._(gentag._30._(lib._scribblings/gui/gui..scrbl)))",[7,"'choice"],false],
["choice item",">gui/windowing-overview.html#(tech._choice._item)","<span style=\"font-style: italic\">choice item</span>",false],
["choice%",">gui/choice_.html",[0,[2,"choice%"]],["racket/gui/base","racket/gui"]],
["choice-evt",">reference/sync.html#(def._((quote._~23~25kernel)._choice-evt))",[0,[2,"choice-evt"]],["racket/base","racket"]],
["choice-index",">teachpack/gui.html#(def._((lib._htdp/gui..rkt)._choice-index))",[0,[2,"choice-index"]],["htdp/gui"]],
["choice/notify-box",">unstable/gui-notify.html#(def._((lib._unstable/gui/notify..rkt)._choice/notify-box))",[0,[2,"choice/notify-box"]],["unstable/gui/notify"]],
["choose language... menu item",">drracket/Menus.html#(idx._(gentag._119._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Choose Language...</span> menu item",false],
["choosing a language",">drracket/choose-language.html","Choosing a Language",false],
["chunk",">scribble/lp.html#(form._((lib._scribble/lp..rkt)._chunk))",[0,[1,"chunk"]],["scribble/lp"]],
["circle",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._circle))",[0,[2,"circle"]],["2htdp/image"]],
["circle",">teachpack/image.html#(def._((lib._htdp/image..rkt)._circle))",[0,[2,"circle"]],["htdp/image"]],
["circle",">slideshow/Basic_Pict_Constructors.html#(def._((lib._slideshow/pict..rkt)._circle))",[0,[2,"circle"]],["slideshow/pict","slideshow"]],
["circle",">deinprogramm/image.html#(def._((lib._deinprogramm/image..rkt)._circle))",[0,[2,"circle"]],["teachpack/deinprogramm/image"]],
["circle/border",">unstable/pict.html#(def._((lib._unstable/gui/pict..rkt)._circle/border))",[0,[2,"circle/border"]],["unstable/gui/pict"]],
["circular-list",">srfi-std/srfi-1.html#circular-list",[0,[2,"circular-list"]],["srfi/1"]],
["circular-list?",">srfi-std/srfi-1.html#circular-list-p",[0,[2,"circular-list?"]],["srfi/1"]],
["cite",">html/index.html#(def._((lib._html/main..rkt)._cite))",[0,[2,"cite"]],["html"]],
["cite",">scribble/Bibliography.html#(def._((lib._scribble/manual..rkt)._cite))",[0,[2,"cite"]],["scribble/manual"]],
["cite?",">html/index.html#(def._((lib._html/main..rkt)._cite~3f))",[0,[2,"cite?"]],["html"]],
["clamp-real",">plot/utils.html#(def._((lib._plot/utils..rkt)._clamp-real))",[0,[2,"clamp-real"]],["plot/utils"]],
["class",">reference/createclass.html#(form._((lib._racket/private/class-internal..rkt)._class))",[0,[1,"class"]],["racket/class","racket"]],
["class",">ts-reference/Experimental_Features.html#(form._((lib._typed-racket/base-env/base-types-extra..rkt)._.Class))",[0,[1,"Class"]],["typed/racket/base","typed/racket"]],
["class",">reference/mzlib_class.html#(tech._clas)","<span style=\"font-style: italic\">class</span>",false],
["class contracts",">guide/classes.html#(part._.Class_.Contracts)","Class Contracts",false],
["class display names",">foreign/com-auto.html#(part._.Class_.Display_.Names)","Class Display Names",false],
["class*",">reference/createclass.html#(form._((lib._racket/private/class-internal..rkt)._class*))",[0,[1,"class*"]],["racket/class","racket"]],
["class->interface",">reference/objectutils.html#(def._((lib._racket/private/class-internal..rkt)._class-~3einterface))",[0,[2,"class->interface"]],["racket/class","racket"]],
["class-field-accessor",">reference/ivaraccess.html#(form._((lib._racket/private/class-internal..rkt)._class-field-accessor))",[0,[1,"class-field-accessor"]],["racket/class","racket"]],
["class-field-mutator",">reference/ivaraccess.html#(form._((lib._racket/private/class-internal..rkt)._class-field-mutator))",[0,[1,"class-field-mutator"]],["racket/class","racket"]],
["class-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..rkt)._class-index-desc))",[0,[2,"class-index-desc"]],["scribble/manual-struct"]],
["class-index-desc?",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..rkt)._class-index-desc~3f))",[0,[2,"class-index-desc?"]],["scribble/manual-struct"]],
["class-info",">reference/objectutils.html#(def._((lib._racket/private/class-internal..rkt)._class-info))",[0,[2,"class-info"]],["racket/class","racket"]],
["class/c",">reference/Object_and_Class_Contracts.html#(form._((lib._racket/private/class-internal..rkt)._class/c))",[0,[1,"class/c"]],["racket/class","racket"]],
["class/derived",">reference/createclass.html#(form._((lib._racket/private/class-internal..rkt)._class/derived))",[0,[1,"class/derived"]],["racket/class","racket"]],
["class100",">mzlib/mzlib_class100.html#(form._((lib._mzlib/class100..rkt)._class100))",[0,[1,"class100"]],["mzlib/class100"]],
["class100*",">mzlib/mzlib_class100.html#(form._((lib._mzlib/class100..rkt)._class100*))",[0,[1,"class100*"]],["mzlib/class100"]],
["class100*-asi",">mzlib/mzlib_class100.html#(form._((lib._mzlib/class100..rkt)._class100*-asi))",[0,[1,"class100*-asi"]],["mzlib/class100"]],
["class100-asi",">mzlib/mzlib_class100.html#(form._((lib._mzlib/class100..rkt)._class100-asi))",[0,[1,"class100-asi"]],["mzlib/class100"]],
["class?",">reference/objectutils.html#(def._((lib._racket/private/class-internal..rkt)._class~3f))",[0,[2,"class?"]],["racket/class","racket"]],
["class_addivar",">foreign/Objective-C_FFI.html#(def._((lib._ffi/unsafe/objc..rkt)._class_add.Ivar))",[0,[2,"class_addIvar"]],["ffi/unsafe/objc"]],
["class_addmethod",">foreign/Objective-C_FFI.html#(def._((lib._ffi/unsafe/objc..rkt)._class_add.Method))",[0,"class_addMethod"],["ffi/unsafe/objc"]],
["classes and objects",">guide/classes.html","Classes and Objects",false],
["classes and objects",">reference/mzlib_class.html","Classes and Objects",false],
["classifications",">reference/characters.html#(part._.Classifications)","Classifications",false],
["classify-position",">framework/Color.html#(meth._(((lib._framework/main..rkt)._color~3atext~3c~25~3e)._classify-position))",[[0,[2,"classify-position"]],[14,[" (method of ",[0,[2,"color:text<%>"]],")"]]],["framework"]],
["clean",">turtles/Value_Turtles.html#(def._((lib._graphics/value-turtles..rkt)._clean))",[0,[2,"clean"]],["graphics/value-turtles"]],
["clean",">raco/setup-plt-plt.html#(sig-val._((lib._setup/option-sig..rkt)._setup-option~5e._clean))",[0,[2,"clean"]],["setup/option-sig"]],
["clean-planet-package",">raco/_plt-archives.html#(def._((lib._setup/plt-single-installer..rkt)._clean-planet-package))",[0,[2,"clean-planet-package"]],["setup/plt-single-installer"]],
["clean-up-index-string",">scribble/decode.html#(def._((lib._scribble/decode..rkt)._clean-up-index-string))",[0,[2,"clean-up-index-string"]],["scribble/decode"]],
["cleanse",">reference/pathutils.html#(tech._cleanse)","<span style=\"font-style: italic\">cleanse</span>",false],
["cleanse-path",">reference/Manipulating_Paths.html#(def._((quote._~23~25kernel)._cleanse-path))",[0,[2,"cleanse-path"]],["racket/base","racket"]],
["clear",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._clear))",[[0,[2,"clear"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["clear",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._clear))",[[0,[2,"clear"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["clear",">gui/list-control___.html#(meth._(((lib._mred/main..rkt)._list-control~3c~25~3e)._clear))",[[0,[2,"clear"]],[14,[" (method of ",[0,[2,"list-control<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["clear",">framework/Group.html#(meth._(((lib._framework/main..rkt)._group~3a~25)._clear))",[[0,[2,"clear"]],[14,[" (method of ",[0,[2,"group:%"]],")"]]],["framework"]],
["clear",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtles..rkt)._clear))",[0,[2,"clear"]],["graphics/turtles"]],
["clear",">gui/key-event_.html#(idx._(gentag._40._(lib._scribblings/gui/gui..scrbl)))",[7,"'clear"],false],
["clear all teachpacks menu item",">drracket/Menus.html#(idx._(gentag._121._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Clear All Teachpacks</span> menu item",false],
["clear error highlight menu item",">drracket/Menus.html#(idx._(gentag._126._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Clear Error Highlight</span> menu item",false],
["clear menu item",">drracket/Menus.html#(idx._(gentag._77._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Clear</span> menu item",false],
["clear-all",">teachpack/draw.html#(def._((lib._htdp/big-draw..rkt)._clear-all))",[0,[2,"clear-all"]],["htdp/draw"]],
["clear-annotations",">tools/drracket_rep.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3arep~3acontext~3c~25~3e)._clear-annotations))",[[0,[2,"clear-annotations"]],[14,[" (method of ",[0,[2,"drracket:rep:context<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["clear-annotations",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3atab~25)._clear-annotations))",[[0,[2,"clear-annotations"]],[14,[" (method of ",[0,[2,"drracket:unit:tab%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["clear-box-input-port",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3aports~3c~25~3e)._clear-box-input-port))",[[0,[2,"clear-box-input-port"]],[14,[" (method of ",[0,[2,"text:ports<%>"]],")"]]],["framework"]],
["clear-circle",">teachpack/draw.html#(def._((lib._htdp/big-draw..rkt)._clear-circle))",[0,[2,"clear-circle"]],["htdp/draw"]],
["clear-continuation-table!",">web-server/servlet.html#(def._((lib._web-server/servlet/web..rkt)._clear-continuation-table!))",[0,[2,"clear-continuation-table!"]],["web-server/servlet/web"]],
["clear-cue-text",">embedded-gui/Helpers.html#(meth._(((lib._embedded-gui/main..rkt)._cue-text~25)._clear-cue-text))",[[0,[2,"clear-cue-text"]],[14,[" (method of ",[0,[2,"cue-text%"]],")"]]],["embedded-gui"]],
["clear-ellipse",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..rkt)._clear-ellipse))",[0,[2,"clear-ellipse"]],["graphics/graphics"]],
["clear-input-port",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3aports~3c~25~3e)._clear-input-port))",[[0,[2,"clear-input-port"]],[14,[" (method of ",[0,[2,"text:ports<%>"]],")"]]],["framework"]],
["clear-line",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..rkt)._clear-line))",[0,[2,"clear-line"]],["graphics/graphics"]],
["clear-output-ports",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3aports~3c~25~3e)._clear-output-ports))",[[0,[2,"clear-output-ports"]],[14,[" (method of ",[0,[2,"text:ports<%>"]],")"]]],["framework"]],
["clear-pinhole",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._clear-pinhole))",[0,[2,"clear-pinhole"]],["2htdp/image"]],
["clear-pixel",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..rkt)._clear-pixel))",[0,[2,"clear-pixel"]],["graphics/graphics"]],
["clear-polygon",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..rkt)._clear-polygon))",[0,[2,"clear-polygon"]],["graphics/graphics"]],
["clear-profile-results",">errortrace/using-errortrace.html#(def._((lib._errortrace/errortrace-lib..rkt)._clear-profile-results))",[0,[2,"clear-profile-results"]],["errortrace"]],
["clear-rectangle",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..rkt)._clear-rectangle))",[0,[2,"clear-rectangle"]],["graphics/graphics"]],
["clear-solid-disk",">teachpack/draw.html#(def._((lib._htdp/big-draw..rkt)._clear-solid-disk))",[0,[2,"clear-solid-disk"]],["htdp/draw"]],
["clear-solid-ellipse",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..rkt)._clear-solid-ellipse))",[0,[2,"clear-solid-ellipse"]],["graphics/graphics"]],
["clear-solid-line",">teachpack/draw.html#(def._((lib._htdp/big-draw..rkt)._clear-solid-line))",[0,[2,"clear-solid-line"]],["htdp/draw"]],
["clear-solid-polygon",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..rkt)._clear-solid-polygon))",[0,[2,"clear-solid-polygon"]],["graphics/graphics"]],
["clear-solid-rect",">teachpack/draw.html#(def._((lib._htdp/big-draw..rkt)._clear-solid-rect))",[0,[2,"clear-solid-rect"]],["htdp/draw"]],
["clear-solid-rectangle",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..rkt)._clear-solid-rectangle))",[0,[2,"clear-solid-rectangle"]],["graphics/graphics"]],
["clear-solid-string",">teachpack/draw.html#(def._((lib._htdp/big-draw..rkt)._clear-solid-string))",[0,[2,"clear-solid-string"]],["htdp/draw"]],
["clear-string",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..rkt)._clear-string))",[0,[2,"clear-string"]],["graphics/graphics"]],
["clear-undos",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._clear-undos))",[[0,[2,"clear-undos"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["clear-viewport",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..rkt)._clear-viewport))",[0,[2,"clear-viewport"]],["graphics/graphics"]],
["clearlinks",">planet/cmdline.html#(part._clearlinks)",[6,"clearlinks"],false],
["click-select",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..rkt)._hierarchical-list~25)._click-select))",[[0,[2,"click-select"]],[14,[" (method of ",[0,[2,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["click-select",">mrlib/hierarchical-list-item___.html#(meth._(((lib._mrlib/hierlist..rkt)._hierarchical-list-item~3c~25~3e)._click-select))",[[0,[2,"click-select"]],[14,[" (method of ",[0,[2,"hierarchical-list-item<%>"]],")"]]],["mrlib/hierlist"]],
["clickback",">slideshow/Primary_Slide_Functions.html#(def._((lib._slideshow/base..rkt)._clickback))",[0,[2,"clickback"]],["slideshow/base","slideshow"]],
["clickbacks",">gui/editor-overview.html#(part._editorclickback)","Clickbacks",false],
["clickbacks",">gui/editor-overview.html#(tech._clickback)","<span style=\"font-style: italic\">Clickbacks</span>",false],
["client",">reference/securityguards.html#(idx._(gentag._232._(lib._scribblings/reference/reference..scrbl)))",[7,"'client"],false],
["client api",">net/websocket.html#(part._.Client_.A.P.I)","Client API",false],
["client configuration",">planet/Utility_Libraries.html#(part._.Client_.Configuration)","Client Configuration",false],
["client->screen",">gui/window___.html#(meth._(((lib._mred/main..rkt)._window~3c~25~3e)._client-~3escreen))",[[0,[2,"client->screen"]],[14,[" (method of ",[0,[2,"window<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["client-cookie",">web-server/http.html#(def._((lib._web-server/http/cookie-parse..rkt)._client-cookie))",[0,[2,"client-cookie"]],["web-server/http/cookie-parse"]],
["client-cookie-domain",">web-server/http.html#(def._((lib._web-server/http/cookie-parse..rkt)._client-cookie-domain))",[0,[2,"client-cookie-domain"]],["web-server/http/cookie-parse"]],
["client-cookie-name",">web-server/http.html#(def._((lib._web-server/http/cookie-parse..rkt)._client-cookie-name))",[0,[2,"client-cookie-name"]],["web-server/http/cookie-parse"]],
["client-cookie-path",">web-server/http.html#(def._((lib._web-server/http/cookie-parse..rkt)._client-cookie-path))",[0,[2,"client-cookie-path"]],["web-server/http/cookie-parse"]],
["client-cookie-value",">web-server/http.html#(def._((lib._web-server/http/cookie-parse..rkt)._client-cookie-value))",[0,[2,"client-cookie-value"]],["web-server/http/cookie-parse"]],
["client-cookie?",">web-server/http.html#(def._((lib._web-server/http/cookie-parse..rkt)._client-cookie~3f))",[0,[2,"client-cookie?"]],["web-server/http/cookie-parse"]],
["client-h",">slideshow/Constants_and_Layout_Variables.html#(form._((lib._slideshow/base..rkt)._client-h))",[0,[1,"client-h"]],["slideshow/base","slideshow"]],
["client-w",">slideshow/Constants_and_Layout_Variables.html#(form._((lib._slideshow/base..rkt)._client-w))",[0,[1,"client-w"]],["slideshow/base","slideshow"]],
["clip",">slideshow/Pict_Drawing_Adjusters.html#(def._((lib._slideshow/pict..rkt)._clip))",[0,[2,"clip"]],["slideshow/pict","slideshow"]],
["clip",">deinprogramm/image.html#(def._((lib._deinprogramm/image..rkt)._clip))",[0,[2,"clip"]],["teachpack/deinprogramm/image"]],
["clip-descent",">slideshow/Bounding_Box_Adjusters.html#(def._((lib._slideshow/pict..rkt)._clip-descent))",[0,[2,"clip-descent"]],["slideshow/pict","slideshow"]],
["clipboard-client%",">gui/clipboard-client_.html",[0,[2,"clipboard-client%"]],["racket/gui/base","racket/gui"]],
["clipboard<%>",">gui/clipboard___.html",[0,[2,"clipboard<%>"]],["racket/gui/base","racket/gui"]],
["clipping",">draw/overview.html#(part._.Clipping)","Clipping",false],
["clipping region",">draw/overview.html#(tech._clipping._region)","<span style=\"font-style: italic\">clipping region</span>",false],
["clock-icon",">images/Icons.html#(def._((lib._images/icons/misc..rkt)._clock-icon))",[0,[2,"clock-icon"]],["images/icons/misc"]],
["cloister",">guide/regexp-clusters.html#(tech._cloister)","<span style=\"font-style: italic\">cloister</span>",false],
["cloisters",">guide/regexp-clusters.html#(part._regexp-cloister)","Cloisters",false],
["close",">draw/dc-path_.html#(meth._(((lib._racket/draw..rkt)._dc-path~25)._close))",[[0,[2,"close"]],[14,[" (method of ",[0,[2,"dc-path%"]],")"]]],["racket/draw"]],
["close",">framework/Editor.html#(meth._(((lib._framework/main..rkt)._editor~3abasic~3c~25~3e)._close))",[[0,[2,"close"]],[14,[" (method of ",[0,[2,"editor:basic<%>"]],")"]]],["framework"]],
["close",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3abasic~3c~25~3e)._close))",[[0,[2,"close"]],[14,[" (method of ",[0,[2,"frame:basic<%>"]],")"]]],["framework"]],
["close",">mrlib/hierarchical-list-compound-item___.html#(meth._(((lib._mrlib/hierlist..rkt)._hierarchical-list-compound-item~3c~25~3e)._close))",[[0,[2,"close"]],[14,[" (method of ",[0,[2,"hierarchical-list-compound-item<%>"]],")"]]],["mrlib/hierlist"]],
["close icon",">mrlib/Close_Icon.html","Close Icon",false],
["close menu item",">drracket/Menus.html#(idx._(gentag._70._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Close</span> menu item",false],
["close-current-tab",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aframe~3c~25~3e)._close-current-tab))",[[0,[2,"close-current-tab"]],[14,[" (method of ",[0,[2,"drracket:unit:frame<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["close-eval",">scribble/eval.html#(def._((lib._scribble/eval..rkt)._close-eval))",[0,[2,"close-eval"]],["scribble/eval"]],
["close-graphics",">graphics/Basic_Commands.html#(def._((lib._graphics/graphics..rkt)._close-graphics))",[0,[2,"close-graphics"]],["graphics/graphics"]],
["close-icon%",">mrlib/Close_Icon.html#(def._((lib._mrlib/close-icon..rkt)._close-icon~25))",[0,[2,"close-icon%"]],["mrlib/close-icon"]],
["close-input-port",">reference/port-ops.html#(def._((quote._~23~25kernel)._close-input-port))",[0,[2,"close-input-port"]],["racket/base","racket"]],
["close-input-port",">r5rs-std/r5rs-Z-H-9.html#%_idx_630",[0,[2,"close-input-port"]],["r5rs"]],
["close-input-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_804",[0,[2,"close-input-port"]],["rnrs/io/simple-6"]],
["close-output-port",">reference/port-ops.html#(def._((quote._~23~25kernel)._close-output-port))",[0,[2,"close-output-port"]],["racket/base","racket"]],
["close-output-port",">r5rs-std/r5rs-Z-H-9.html#%_idx_632",[0,[2,"close-output-port"]],["r5rs"]],
["close-output-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_806",[0,[2,"close-output-port"]],["rnrs/io/simple-6"]],
["close-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_660",[0,[2,"close-port"]],["rnrs/io/ports-6"]],
["close-splash",">framework/Splash.html#(def._((lib._framework/splash..rkt)._close-splash))",[0,[2,"close-splash"]],["framework/splash"]],
["close-status-line",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astatus-line~3c~25~3e)._close-status-line))",[[0,[2,"close-status-line"]],[14,[" (method of ",[0,[2,"frame:status-line<%>"]],")"]]],["framework"]],
["close-viewport",">graphics/Basic_Commands.html#(def._((lib._graphics/graphics..rkt)._close-viewport))",[0,[2,"close-viewport"]],["graphics/graphics"]],
["closed sub-paths",">draw/dc-path_.html#(tech._closed._sub._path)","<span style=\"font-style: italic\">closed sub-paths</span>",false],
["closure",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._closure))",[0,[2,"closure"]],["compiler/zo-structs"]],
["closure-code",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._closure-code))",[0,[2,"closure-code"]],["compiler/zo-structs"]],
["closure-gen-id",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._closure-gen-id))",[0,[2,"closure-gen-id"]],["compiler/zo-structs"]],
["closure?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._closure~3f))",[0,[2,"closure?"]],["compiler/zo-structs"]],
["closures",">guide/performance.html#(tech._closure)","<span style=\"font-style: italic\">closures</span>",false],
["cloud",">slideshow/More_Pict_Constructors.html#(def._((lib._slideshow/pict..rkt)._cloud))",[0,[2,"cloud"]],["slideshow/pict","slideshow"]],
["clsid",">foreign/com.html#(tech._clsid)","<span style=\"font-style: italic\">CLSID</span>",false],
["clsid->coclass",">foreign/com-auto.html#(def._((lib._ffi/com-registry..rkt)._clsid-~3ecoclass))",[0,[2,"clsid->coclass"]],["ffi/com-registry"]],
["clsid->progid",">foreign/com-auto.html#(def._((lib._ffi/unsafe/com..rkt)._clsid-~3eprogid))",[0,[2,"clsid->progid"]],["ffi/com"]],
["clsid?",">foreign/com-auto.html#(def._((lib._ffi/unsafe/com..rkt)._clsid~3f))",[0,[2,"clsid?"]],["ffi/com"]],
["clustering",">guide/regexp-clusters.html#(tech._clustering)","<span style=\"font-style: italic\">Clustering</span>",false],
["clusters",">guide/regexp-clusters.html","Clusters",false],
["cn",">reference/characters.html#(idx._(gentag._152._(lib._scribblings/reference/reference..scrbl)))",[7,"'cn"],false],
["co",">reference/characters.html#(idx._(gentag._151._(lib._scribblings/reference/reference..scrbl)))",[7,"'co"],false],
["coclass",">mysterx/methprop.html#(def._((lib._mysterx/main..rkt)._coclass))",[0,[2,"coclass"]],["mysterx"]],
["coclass",">foreign/com-auto.html#(tech._coclas)","<span style=\"font-style: italic\">coclass</span>",false],
["coclass->clsid",">foreign/com-auto.html#(def._((lib._ffi/com-registry..rkt)._coclass-~3eclsid))",[0,[2,"coclass->clsid"]],["ffi/com-registry"]],
["cocreate-instance-from-coclass",">mysterx/methprop.html#(def._((lib._mysterx/main..rkt)._cocreate-instance-from-coclass))",[0,[2,"cocreate-instance-from-coclass"]],["mysterx"]],
["cocreate-instance-from-progid",">mysterx/methprop.html#(def._((lib._mysterx/main..rkt)._cocreate-instance-from-progid))",[0,[2,"cocreate-instance-from-progid"]],["mysterx"]],
["code",">html/index.html#(def._((lib._html/main..rkt)._code))",[0,[2,"code"]],["html"]],
["code",">scribble/scribble_manual_code.html#(form._((lib._scribble/manual..rkt)._code))",[0,[1,"code"]],["scribble/manual"]],
["code",">slideshow/Typesetting_Racket_Code.html#(form._((lib._slideshow/code..rkt)._code))",[0,[1,"code"]],["slideshow/code"]],
["code fonts and styles",">scribble/scribble_manual_code.html#(part._.Code_.Fonts_and_.Styles)","Code Fonts and Styles",false],
["code inspectors",">reference/modprotect.html","Code Inspectors",false],
["code inspectors",">guide/stx-certs.html#(tech._code._inspector)","<span style=\"font-style: italic\">code inspectors</span>",false],
["code point",">reference/characters.html#(idx._(gentag._122._(lib._scribblings/reference/reference..scrbl)))","code point",false],
["code-align",">slideshow/Typesetting_Racket_Code.html#(def._((lib._slideshow/code..rkt)._code-align))",[0,[2,"code-align"]],["slideshow/code"]],
["code-colorize-enabled",">slideshow/Typesetting_Racket_Code.html#(def._((lib._slideshow/code..rkt)._code-colorize-enabled))",[0,[2,"code-colorize-enabled"]],["slideshow/code"]],
["code-colorize-quote-enabled",">slideshow/Typesetting_Racket_Code.html#(def._((lib._slideshow/code..rkt)._code-colorize-quote-enabled))",[0,[2,"code-colorize-quote-enabled"]],["slideshow/code"]],
["code-italic-underscore-enabled",">slideshow/Typesetting_Racket_Code.html#(def._((lib._slideshow/code..rkt)._code-italic-underscore-enabled))",[0,[2,"code-italic-underscore-enabled"]],["slideshow/code"]],
["code-pict-bottom-line-pict",">slideshow/Typesetting_Racket_Code.html#(def._((lib._slideshow/code..rkt)._code-pict-bottom-line-pict))",[0,[2,"code-pict-bottom-line-pict"]],["slideshow/code"]],
["code-scripts-enabled",">slideshow/Typesetting_Racket_Code.html#(def._((lib._slideshow/code..rkt)._code-scripts-enabled))",[0,[2,"code-scripts-enabled"]],["slideshow/code"]],
["code:blank",">slideshow/Typesetting_Racket_Code.html#(idx._(gentag._1._(lib._scribblings/slideshow/slideshow..scrbl)))",[0,"code:blank"],false],
["code:blank",">scribble/scribble_manual_code.html#(idx._(gentag._2._(lib._scribblings/scribble/scribble..scrbl)))","",false],
["code:comment",">scribble/scribble_manual_code.html#(idx._(gentag._1._(lib._scribblings/scribble/scribble..scrbl)))",[0,"code:comment"],false],
["code:comment",">slideshow/Typesetting_Racket_Code.html#(idx._(gentag._2._(lib._scribblings/slideshow/slideshow..scrbl)))",[0,"code:comment"],false],
["code:contract",">slideshow/Typesetting_Racket_Code.html#(idx._(gentag._4._(lib._scribblings/slideshow/slideshow..scrbl)))",[0,"code:contract"],false],
["code:hilite",">scribble/scribble_manual_code.html#(idx._(gentag._3._(lib._scribblings/scribble/scribble..scrbl)))",[0,"code:hilite"],false],
["code:line",">scribble/scribble_manual_code.html#(idx._(gentag._0._(lib._scribblings/scribble/scribble..scrbl)))",[0,"code:line"],false],
["code:line",">slideshow/Typesetting_Racket_Code.html#(idx._(gentag._3._(lib._scribblings/slideshow/slideshow..scrbl)))",[0,"code:line"],false],
["code:line",">scribble/eval.html#(idx._(gentag._5._(lib._scribblings/scribble/scribble..scrbl)))",[0,"code:line"],false],
["code:quote",">scribble/scribble_manual_code.html#(idx._(gentag._4._(lib._scribblings/scribble/scribble..scrbl)))",[0,"code:quote"],false],
["code:template",">slideshow/Typesetting_Racket_Code.html#(idx._(gentag._5._(lib._scribblings/slideshow/slideshow..scrbl)))",[0,"code:template"],false],
["code?",">html/index.html#(def._((lib._html/main..rkt)._code~3f))",[0,[2,"code?"]],["html"]],
["codeblock",">scribble/scribble_manual_code.html#(form._((lib._scribble/manual..rkt)._codeblock))",[0,[1,"codeblock"]],["scribble/manual"]],
["codeblock0",">scribble/scribble_manual_code.html#(form._((lib._scribble/manual..rkt)._codeblock0))",[0,[1,"codeblock0"]],["scribble/manual"]],
["coerce-chaperone-contract",">reference/Building_New_Contract_Combinators.html#(def._((lib._racket/contract/private/guts..rkt)._coerce-chaperone-contract))",[0,[2,"coerce-chaperone-contract"]],["racket/contract/combinator","racket/contract","racket"]],
["coerce-chaperone-contracts",">reference/Building_New_Contract_Combinators.html#(def._((lib._racket/contract/private/guts..rkt)._coerce-chaperone-contracts))",[0,[2,"coerce-chaperone-contracts"]],["racket/contract/combinator","racket/contract","racket"]],
["coerce-contract",">reference/Building_New_Contract_Combinators.html#(def._((lib._racket/contract/private/guts..rkt)._coerce-contract))",[0,[2,"coerce-contract"]],["racket/contract/combinator","racket/contract","racket"]],
["coerce-contract/f",">reference/Building_New_Contract_Combinators.html#(def._((lib._racket/contract/private/guts..rkt)._coerce-contract/f))",[0,[2,"coerce-contract/f"]],["racket/contract/combinator","racket/contract","racket"]],
["coerce-contracts",">reference/Building_New_Contract_Combinators.html#(def._((lib._racket/contract/private/guts..rkt)._coerce-contracts))",[0,[2,"coerce-contracts"]],["racket/contract/combinator","racket/contract","racket"]],
["coerce-flat-contract",">reference/Building_New_Contract_Combinators.html#(def._((lib._racket/contract/private/guts..rkt)._coerce-flat-contract))",[0,[2,"coerce-flat-contract"]],["racket/contract/combinator","racket/contract","racket"]],
["coerce-flat-contracts",">reference/Building_New_Contract_Combinators.html#(def._((lib._racket/contract/private/guts..rkt)._coerce-flat-contracts))",[0,[2,"coerce-flat-contracts"]],["racket/contract/combinator","racket/contract","racket"]],
["col",">html/index.html#(def._((lib._html/main..rkt)._col))",[0,[2,"col"]],["html"]],
["col?",">html/index.html#(def._((lib._html/main..rkt)._col~3f))",[0,[2,"col?"]],["html"]],
["colgroup",">html/index.html#(def._((lib._html/main..rkt)._colgroup))",[0,[2,"colgroup"]],["html"]],
["colgroup?",">html/index.html#(def._((lib._html/main..rkt)._colgroup~3f))",[0,[2,"colgroup?"]],["html"]],
["collapse",">gui/style-delta_.html#(meth._(((lib._racket/snip..rkt)._style-delta~25)._collapse))",[[0,[2,"collapse"]],[14,[" (method of ",[0,[2,"style-delta%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["collapse",">framework/Panel.html#(meth._(((lib._framework/main..rkt)._panel~3asplitter-mixin)._collapse))",[[0,[2,"collapse"]],[14,[" (method of ",[0,[2,"panel:splitter-mixin"]],")"]]],["framework"]],
["collapse menu item",">drracket/Menus.html#(idx._(gentag._98._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Collapse</span> menu item",false],
["collapse-module-path",">syntax/module-helpers.html#(def._((lib._syntax/modcollapse..rkt)._collapse-module-path))",[0,[2,"collapse-module-path"]],["syntax/modcollapse"]],
["collapse-module-path-index",">syntax/module-helpers.html#(def._((lib._syntax/modcollapse..rkt)._collapse-module-path-index))",[0,[2,"collapse-module-path-index"]],["syntax/modcollapse"]],
["collapse-newline",">framework/Keymap.html#(idx._(gentag._19._(lib._scribblings/framework/framework..scrbl)))","collapse-newline",false],
["collapse-space",">framework/Keymap.html#(idx._(gentag._17._(lib._scribblings/framework/framework..scrbl)))","collapse-space",false],
["collapse-transform",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._collapse-transform))",[0,[2,"collapse-transform"]],["plot"]],
["collapse-whitespace",">xml/index.html#(def._((lib._xml/main..rkt)._collapse-whitespace))",[0,[2,"collapse-whitespace"]],["xml"]],
["collect",">scribble/renderer.html#(meth._(((lib._scribble/base-render..rkt)._render~25)._collect))",[[0,[2,"collect"]],[14,[" (method of ",[0,[2,"render%"]],")"]]],["scribble/base-render"]],
["collect pass",">scribble/core.html#(tech._collect._pas)","<span style=\"font-style: italic\">collect pass</span>",false],
["collect-b",">frtime/index.html#(def._((lib._frtime/main..rkt)._collect-b))",[0,[2,"collect-b"]],["frtime"]],
["collect-e",">frtime/index.html#(def._((lib._frtime/main..rkt)._collect-e))",[0,[2,"collect-e"]],["frtime"]],
["collect-element",">scribble/core.html#(def._((lib._scribble/core..rkt)._collect-element))",[0,[2,"collect-element"]],["scribble/core"]],
["collect-element-collect",">scribble/core.html#(def._((lib._scribble/core..rkt)._collect-element-collect))",[0,[2,"collect-element-collect"]],["scribble/core"]],
["collect-element?",">scribble/core.html#(def._((lib._scribble/core..rkt)._collect-element~3f))",[0,[2,"collect-element?"]],["scribble/core"]],
["collect-garbage",">reference/garbagecollection.html#(def._((quote._~23~25kernel)._collect-garbage))",[0,[2,"collect-garbage"]],["racket/base","racket"]],
["collect-garbage",">eopl/index.html#(def._((lib._eopl/eopl..rkt)._collect-garbage))",[0,[2,"collect-garbage"]],["eopl"]],
["collect-garbage",">web-server-internal/Web_Servers.html#(idx._(gentag._16._(lib._web-server/scribblings/web-server-internal..scrbl)))","collect-garbage",false],
["collect-info",">scribble/core.html#(def._((lib._scribble/core..rkt)._collect-info))",[0,[2,"collect-info"]],["scribble/core"]],
["collect-info-ext-ht",">scribble/core.html#(def._((lib._scribble/core..rkt)._collect-info-ext-ht))",[0,[2,"collect-info-ext-ht"]],["scribble/core"]],
["collect-info-gen-prefix",">scribble/core.html#(def._((lib._scribble/core..rkt)._collect-info-gen-prefix))",[0,[2,"collect-info-gen-prefix"]],["scribble/core"]],
["collect-info-ht",">scribble/core.html#(def._((lib._scribble/core..rkt)._collect-info-ht))",[0,[2,"collect-info-ht"]],["scribble/core"]],
["collect-info-parents",">scribble/core.html#(def._((lib._scribble/core..rkt)._collect-info-parents))",[0,[2,"collect-info-parents"]],["scribble/core"]],
["collect-info-parts",">scribble/core.html#(def._((lib._scribble/core..rkt)._collect-info-parts))",[0,[2,"collect-info-parts"]],["scribble/core"]],
["collect-info-relatives",">scribble/core.html#(def._((lib._scribble/core..rkt)._collect-info-relatives))",[0,[2,"collect-info-relatives"]],["scribble/core"]],
["collect-info-tags",">scribble/core.html#(def._((lib._scribble/core..rkt)._collect-info-tags))",[0,[2,"collect-info-tags"]],["scribble/core"]],
["collect-info?",">scribble/core.html#(def._((lib._scribble/core..rkt)._collect-info~3f))",[0,[2,"collect-info?"]],["scribble/core"]],
["collect-put!",">scribble/core.html#(def._((lib._scribble/core..rkt)._collect-put!))",[0,[2,"collect-put!"]],["scribble/core"]],
["collected and resolved information",">scribble/core.html#(part._passes)","Collected and Resolved Information",false],
["collected-info",">scribble/core.html#(def._((lib._scribble/core..rkt)._collected-info))",[0,[2,"collected-info"]],["scribble/core"]],
["collected-info-info",">scribble/core.html#(def._((lib._scribble/core..rkt)._collected-info-info))",[0,[2,"collected-info-info"]],["scribble/core"]],
["collected-info-number",">scribble/core.html#(def._((lib._scribble/core..rkt)._collected-info-number))",[0,[2,"collected-info-number"]],["scribble/core"]],
["collected-info-parent",">scribble/core.html#(def._((lib._scribble/core..rkt)._collected-info-parent))",[0,[2,"collected-info-parent"]],["scribble/core"]],
["collected-info?",">scribble/core.html#(def._((lib._scribble/core..rkt)._collected-info~3f))",[0,[2,"collected-info?"]],["scribble/core"]],
["collecting profile information",">profile/index.html#(part._sampler)","Collecting Profile Information",false],
["collection",">guide/module-basics.html#(tech._collection)","<span style=\"font-style: italic\">collection</span>",false],
["collection links",">reference/collects.html#(part._links-file)","Collection Links",false],
["collection links files",">reference/collects.html#(tech._collection._links._file)","<span style=\"font-style: italic\">collection links files</span>",false],
["collection-file-path",">reference/collects.html#(def._((lib._racket/private/base..rkt)._collection-file-path))",[0,[2,"collection-file-path"]],["racket/base","racket"]],
["collection-file-path",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..rkt)._collection-file-path))",[0,[2,"collection-file-path"]],["mzscheme"]],
["collection-path",">reference/collects.html#(def._((lib._racket/private/base..rkt)._collection-path))",[0,[2,"collection-path"]],["racket/base","racket"]],
["collection-path",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..rkt)._collection-path))",[0,[2,"collection-path"]],["mzscheme"]],
["collections",">reference/collects.html#(tech._collection)","<span style=\"font-style: italic\">collections</span>",false],
["collects-dir",">reference/Filesystem.html#(idx._(gentag._287._(lib._scribblings/reference/reference..scrbl)))",[7,"'collects-dir"],false],
["color",">framework/Color.html","Color",false],
["color",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._color))",[0,[2,"color"]],["2htdp/image"]],
["color",">htdp/index.html#(def._((lib._htdp/color-structs..rkt)._color))",[0,[2,"color"]],["htdp/color-structs"]],
["color",">teachpack/image.html#(def._((lib._htdp/image..rkt)._color))",[0,[2,"color"]],["htdp/image"]],
["color",">unstable/pict.html#(def._((lib._unstable/gui/pict..rkt)._color))",[0,[2,"color"]],["unstable/gui/pict"]],
["color",">teachpack/image.html#(tech._color)","<span style=\"font-style: italic\">Color</span>",false],
["color and alpha color structs",">htdp/index.html#(part._.Color_and_.Alpha_.Color_.Structs)","Color and Alpha Color Structs",false],
["color model",">framework/Color_Model.html","Color Model",false],
["color operations",">graphics/Color_Operations.html","Color Operations",false],
["color prefs",">framework/Color_Prefs.html","Color Prefs",false],
["color%",">draw/color_.html",[0,[2,"color%"]],["racket/draw"]],
["color-alpha",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._color-alpha))",[0,[2,"color-alpha"]],["2htdp/image"]],
["color-blue",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._color-blue))",[0,[2,"color-blue"]],["2htdp/image"]],
["color-blue",">htdp/index.html#(def._((lib._htdp/color-structs..rkt)._color-blue))",[0,[2,"color-blue"]],["htdp/color-structs"]],
["color-blue",">teachpack/image.html#(def._((lib._htdp/image..rkt)._color-blue))",[0,[2,"color-blue"]],["htdp/image"]],
["color-blue",">deinprogramm/image.html#(def._((lib._deinprogramm/image..rkt)._color-blue))",[0,[2,"color-blue"]],["teachpack/deinprogramm/image"]],
["color-database<%>",">draw/color-database___.html",[0,[2,"color-database<%>"]],["racket/draw"]],
["color-green",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._color-green))",[0,[2,"color-green"]],["2htdp/image"]],
["color-green",">htdp/index.html#(def._((lib._htdp/color-structs..rkt)._color-green))",[0,[2,"color-green"]],["htdp/color-structs"]],
["color-green",">teachpack/image.html#(def._((lib._htdp/image..rkt)._color-green))",[0,[2,"color-green"]],["htdp/image"]],
["color-green",">deinprogramm/image.html#(def._((lib._deinprogramm/image..rkt)._color-green))",[0,[2,"color-green"]],["teachpack/deinprogramm/image"]],
["color-list->bitmap",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._color-list-~3ebitmap))",[0,[2,"color-list->bitmap"]],["2htdp/image"]],
["color-list->image",">teachpack/image.html#(def._((lib._htdp/image..rkt)._color-list-~3eimage))",[0,[2,"color-list->image"]],["htdp/image"]],
["color-list->image",">deinprogramm/image.html#(def._((lib._deinprogramm/image..rkt)._color-list-~3eimage))",[0,[2,"color-list->image"]],["teachpack/deinprogramm/image"]],
["color-model:rgb->xyz",">framework/Color_Model.html#(def._((lib._framework/main..rkt)._color-model~3argb-~3exyz))",[0,[2,"color-model:rgb->xyz"]],["framework"]],
["color-model:rgb-color-distance",">framework/Color_Model.html#(def._((lib._framework/main..rkt)._color-model~3argb-color-distance))",[0,[2,"color-model:rgb-color-distance"]],["framework"]],
["color-model:xyz->rgb",">framework/Color_Model.html#(def._((lib._framework/main..rkt)._color-model~3axyz-~3ergb))",[0,[2,"color-model:xyz->rgb"]],["framework"]],
["color-model:xyz-x",">framework/Color_Model.html#(def._((lib._framework/main..rkt)._color-model~3axyz-x))",[0,[2,"color-model:xyz-x"]],["framework"]],
["color-model:xyz-y",">framework/Color_Model.html#(def._((lib._framework/main..rkt)._color-model~3axyz-y))",[0,[2,"color-model:xyz-y"]],["framework"]],
["color-model:xyz-z",">framework/Color_Model.html#(def._((lib._framework/main..rkt)._color-model~3axyz-z))",[0,[2,"color-model:xyz-z"]],["framework"]],
["color-model:xyz?",">framework/Color_Model.html#(def._((lib._framework/main..rkt)._color-model~3axyz~3f))",[0,[2,"color-model:xyz?"]],["framework"]],
["color-prefs:add-background-preferences-panel",">framework/Color_Prefs.html#(def._((lib._framework/main..rkt)._color-prefs~3aadd-background-preferences-panel))",[0,[2,"color-prefs:add-background-preferences-panel"]],["framework"]],
["color-prefs:add-to-preferences-panel",">framework/Color_Prefs.html#(def._((lib._framework/main..rkt)._color-prefs~3aadd-to-preferences-panel))",[0,[2,"color-prefs:add-to-preferences-panel"]],["framework"]],
["color-prefs:black-on-white",">framework/Color_Prefs.html#(def._((lib._framework/main..rkt)._color-prefs~3ablack-on-white))",[0,[2,"color-prefs:black-on-white"]],["framework"]],
["color-prefs:build-color-selection-panel",">framework/Color_Prefs.html#(def._((lib._framework/main..rkt)._color-prefs~3abuild-color-selection-panel))",[0,[2,"color-prefs:build-color-selection-panel"]],["framework"]],
["color-prefs:marshall-style-delta",">framework/Color_Prefs.html#(def._((lib._framework/main..rkt)._color-prefs~3amarshall-style-delta))",[0,[2,"color-prefs:marshall-style-delta"]],["framework"]],
["color-prefs:register-color-preference",">framework/Color_Prefs.html#(def._((lib._framework/main..rkt)._color-prefs~3aregister-color-preference))",[0,[2,"color-prefs:register-color-preference"]],["framework"]],
["color-prefs:set-default/color-scheme",">framework/Color_Prefs.html#(def._((lib._framework/main..rkt)._color-prefs~3aset-default/color-scheme))",[0,[2,"color-prefs:set-default/color-scheme"]],["framework"]],
["color-prefs:unmarshall-style-delta",">framework/Color_Prefs.html#(def._((lib._framework/main..rkt)._color-prefs~3aunmarshall-style-delta))",[0,[2,"color-prefs:unmarshall-style-delta"]],["framework"]],
["color-prefs:white-on-black",">framework/Color_Prefs.html#(def._((lib._framework/main..rkt)._color-prefs~3awhite-on-black))",[0,[2,"color-prefs:white-on-black"]],["framework"]],
["color-property",">scribble/core.html#(def._((lib._scribble/core..rkt)._color-property))",[0,[2,"color-property"]],["scribble/core"]],
["color-property-color",">scribble/core.html#(def._((lib._scribble/core..rkt)._color-property-color))",[0,[2,"color-property-color"]],["scribble/core"]],
["color-property?",">scribble/core.html#(def._((lib._scribble/core..rkt)._color-property~3f))",[0,[2,"color-property?"]],["scribble/core"]],
["color-red",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._color-red))",[0,[2,"color-red"]],["2htdp/image"]],
["color-red",">htdp/index.html#(def._((lib._htdp/color-structs..rkt)._color-red))",[0,[2,"color-red"]],["htdp/color-structs"]],
["color-red",">teachpack/image.html#(def._((lib._htdp/image..rkt)._color-red))",[0,[2,"color-red"]],["htdp/image"]],
["color-red",">deinprogramm/image.html#(def._((lib._deinprogramm/image..rkt)._color-red))",[0,[2,"color-red"]],["teachpack/deinprogramm/image"]],
["color-seq",">plot/utils.html#(def._((lib._plot/utils..rkt)._color-seq))",[0,[2,"color-seq"]],["plot/utils"]],
["color-seq*",">plot/utils.html#(def._((lib._plot/utils..rkt)._color-seq*))",[0,[2,"color-seq*"]],["plot/utils"]],
["color-series",">slideshow/Miscellaneous.html#(def._((lib._slideshow/pict..rkt)._color-series))",[0,[2,"color-series"]],["slideshow/pict","slideshow"]],
["color/c",">plot/contracts.html#(def._((lib._plot/utils..rkt)._color/c))",[0,[2,"color/c"]],["plot/utils"]],
["color/c",">unstable/pict.html#(def._((lib._unstable/gui/pict..rkt)._color/c))",[0,[2,"color/c"]],["unstable/gui/pict"]],
["color:get-parenthesis-colors-table",">framework/Color.html#(def._((lib._framework/main..rkt)._color~3aget-parenthesis-colors-table))",[0,[2,"color:get-parenthesis-colors-table"]],["framework"]],
["color:text%",">framework/Color.html#(def._((lib._framework/main..rkt)._color~3atext~25))",[0,[2,"color:text%"]],["framework"]],
["color:text-mixin",">framework/Color.html#(def._((lib._framework/main..rkt)._color~3atext-mixin))",[0,[2,"color:text-mixin"]],["framework"]],
["color:text-mode%",">framework/Color.html#(def._((lib._framework/main..rkt)._color~3atext-mode~25))",[0,[2,"color:text-mode%"]],["framework"]],
["color:text-mode-mixin",">framework/Color.html#(def._((lib._framework/main..rkt)._color~3atext-mode-mixin))",[0,[2,"color:text-mode-mixin"]],["framework"]],
["color:text-mode<%>",">framework/Color.html#(def._((lib._framework/main..rkt)._color~3atext-mode~3c~25~3e))",[0,[2,"color:text-mode<%>"]],["framework"]],
["color:text<%>",">framework/Color.html#(def._((lib._framework/main..rkt)._color~3atext~3c~25~3e))",[0,[2,"color:text<%>"]],["framework"]],
["color=?",">picturing-programs/index.html#(def._((lib._picturing-programs/private/map-image..rkt)._color~3d~3f))",[0,[2,"color=?"]],["picturing-programs/private/map-image","picturing-programs"]],
["color?",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._color~3f))",[0,[2,"color?"]],["2htdp/image"]],
["color?",">file/gif.html#(def._((lib._file/gif..rkt)._color~3f))",[0,[2,"color?"]],["file/gif"]],
["color?",">htdp/index.html#(def._((lib._htdp/color-structs..rkt)._color~3f))",[0,[2,"color?"]],["htdp/color-structs"]],
["color?",">teachpack/image.html#(def._((lib._htdp/image..rkt)._color~3f))",[0,[2,"color?"]],["htdp/image"]],
["color?",">deinprogramm/image.html#(def._((lib._deinprogramm/image..rkt)._color~3f))",[0,[2,"color?"]],["teachpack/deinprogramm/image"]],
["colorize",">picturing-programs/index.html#(def._((lib._picturing-programs/private/map-image..rkt)._colorize))",[0,[2,"colorize"]],["picturing-programs/private/map-image","picturing-programs"]],
["colorize",">slideshow/Pict_Drawing_Adjusters.html#(def._((lib._slideshow/pict..rkt)._colorize))",[0,[2,"colorize"]],["slideshow/pict","slideshow"]],
["colors",">drracket/prefs-explanation.html#(part._.Colors)","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Colors</span>",false],
["colors and pixels",">picturing-programs/index.html#(part._.Colors_and_pixels)","Colors and pixels",false],
["colors and styles",">plot/intro.html#(part._.Colors_and_.Styles)","Colors and Styles",false],
["column",">unstable/Slideshow_Presentations.html#(form._((lib._unstable/gui/slideshow..rkt)._column))",[0,[1,"column"]],["unstable/gui/slideshow"]],
["column locations",">reference/linecol.html#(tech._column._location)","<span style=\"font-style: italic\">column\nlocations</span>",false],
["column numbers",">reference/linecol.html","column numbers",false],
["column-attributes",">scribble/core.html#(def._((lib._scribble/html-properties..rkt)._column-attributes))",[0,[2,"column-attributes"]],["scribble/html-properties"]],
["column-attributes-assoc",">scribble/core.html#(def._((lib._scribble/html-properties..rkt)._column-attributes-assoc))",[0,[2,"column-attributes-assoc"]],["scribble/html-properties"]],
["column-attributes?",">scribble/core.html#(def._((lib._scribble/html-properties..rkt)._column-attributes~3f))",[0,[2,"column-attributes?"]],["scribble/html-properties"]],
["column-control-event%",">gui/column-control-event_.html",[0,[2,"column-control-event%"]],["racket/gui/base","racket/gui"]],
["column-size",">unstable/Slideshow_Presentations.html#(def._((lib._unstable/gui/slideshow..rkt)._column-size))",[0,[2,"column-size"]],["unstable/gui/slideshow"]],
["columns",">unstable/Slideshow_Presentations.html#(def._((lib._unstable/gui/slideshow..rkt)._columns))",[0,[2,"columns"]],["unstable/gui/slideshow"]],
["com (common object model)",">foreign/com.html","COM (Common Object Model)",false],
["com automation",">foreign/com-auto.html","COM Automation",false],
["com class",">foreign/com.html#(tech._com._clas)","<span style=\"font-style: italic\">COM\nclass</span>",false],
["com classes and interfaces",">foreign/com-intf.html","COM Classes and Interfaces",false],
["com event executor",">foreign/com-auto.html#(tech._com._event._executor)","<span style=\"font-style: italic\">COM event executor</span>",false],
["com events",">mysterx/com-events.html","COM Events",false],
["com events",">foreign/com-auto.html#(part._.C.O.M_.Events)","COM Events",false],
["com ffi helpers",">foreign/com-intf.html#(part._.C.O.M_.F.F.I_.Helpers)","COM FFI Helpers",false],
["com interface example",">foreign/com-intf.html#(part._com-intf-example)","COM Interface Example",false],
["com interfaces",">foreign/com.html#(tech._com._interface)","<span style=\"font-style: italic\">COM\ninterfaces</span>",false],
["com methods",">foreign/com-auto.html#(part._.C.O.M_.Methods)","COM Methods",false],
["com methods and properties",">mysterx/methprop.html","COM Methods and Properties",false],
["com object",">foreign/com.html#(tech._com._object)","<span style=\"font-style: italic\">COM object</span>",false],
["com objects",">foreign/com-auto.html#(part._.C.O.M_.Objects)","COM Objects",false],
["com properties",">foreign/com-auto.html#(part._.C.O.M_.Properties)","COM Properties",false],
["com types",">mysterx/com-types.html","COM Types",false],
["com types",">foreign/com-auto.html#(part._com-types)","COM Types",false],
["com-all-coclasses",">foreign/com-auto.html#(def._((lib._ffi/com-registry..rkt)._com-all-coclasses))",[0,[2,"com-all-coclasses"]],["ffi/com-registry"]],
["com-all-coclasses",">mysterx/methprop.html#(def._((lib._mysterx/main..rkt)._com-all-coclasses))",[0,[2,"com-all-coclasses"]],["mysterx"]],
["com-all-controls",">foreign/com-auto.html#(def._((lib._ffi/com-registry..rkt)._com-all-controls))",[0,[2,"com-all-controls"]],["ffi/com-registry"]],
["com-all-controls",">mysterx/methprop.html#(def._((lib._mysterx/main..rkt)._com-all-controls))",[0,[2,"com-all-controls"]],["mysterx"]],
["com-create-instance",">foreign/com-auto.html#(def._((lib._ffi/unsafe/com..rkt)._com-create-instance))",[0,[2,"com-create-instance"]],["ffi/com"]],
["com-currency->number",">mysterx/com-types.html#(def._((lib._mysterx/main..rkt)._com-currency-~3enumber))",[0,[2,"com-currency->number"]],["mysterx"]],
["com-currency?",">mysterx/com-types.html#(def._((lib._mysterx/main..rkt)._com-currency~3f))",[0,[2,"com-currency?"]],["mysterx"]],
["com-date->date",">mysterx/com-types.html#(def._((lib._mysterx/main..rkt)._com-date-~3edate))",[0,[2,"com-date->date"]],["mysterx"]],
["com-date?",">mysterx/com-types.html#(def._((lib._mysterx/main..rkt)._com-date~3f))",[0,[2,"com-date?"]],["mysterx"]],
["com-event-executor?",">foreign/com-auto.html#(def._((lib._ffi/unsafe/com..rkt)._com-event-executor~3f))",[0,[2,"com-event-executor?"]],["ffi/com"]],
["com-event-type",">foreign/com-auto.html#(def._((lib._ffi/unsafe/com..rkt)._com-event-type))",[0,[2,"com-event-type"]],["ffi/com"]],
["com-event-type",">mysterx/com-events.html#(def._((lib._mysterx/main..rkt)._com-event-type))",[0,[2,"com-event-type"]],["mysterx"]],
["com-events",">foreign/com-auto.html#(def._((lib._ffi/unsafe/com..rkt)._com-events))",[0,[2,"com-events"]],["ffi/com"]],
["com-events",">mysterx/com-events.html#(def._((lib._mysterx/main..rkt)._com-events))",[0,[2,"com-events"]],["mysterx"]],
["com-get-active-object",">foreign/com-auto.html#(def._((lib._ffi/unsafe/com..rkt)._com-get-active-object))",[0,[2,"com-get-active-object"]],["ffi/com"]],
["com-get-active-object-from-coclass",">mysterx/methprop.html#(def._((lib._mysterx/main..rkt)._com-get-active-object-from-coclass))",[0,"com-get-active-object-from-coclass"],["mysterx"]],
["com-get-properties",">foreign/com-auto.html#(def._((lib._ffi/unsafe/com..rkt)._com-get-properties))",[0,[2,"com-get-properties"]],["ffi/com"]],
["com-get-properties",">mysterx/methprop.html#(def._((lib._mysterx/main..rkt)._com-get-properties))",[0,[2,"com-get-properties"]],["mysterx"]],
["com-get-property",">foreign/com-auto.html#(def._((lib._ffi/unsafe/com..rkt)._com-get-property))",[0,[2,"com-get-property"]],["ffi/com"]],
["com-get-property",">mysterx/methprop.html#(def._((lib._mysterx/main..rkt)._com-get-property))",[0,[2,"com-get-property"]],["mysterx"]],
["com-get-property-type",">foreign/com-auto.html#(def._((lib._ffi/unsafe/com..rkt)._com-get-property-type))",[0,[2,"com-get-property-type"]],["ffi/com"]],
["com-get-property-type",">mysterx/methprop.html#(def._((lib._mysterx/main..rkt)._com-get-property-type))",[0,[2,"com-get-property-type"]],["mysterx"]],
["com-help",">mysterx/methprop.html#(def._((lib._mysterx/main..rkt)._com-help))",[0,[2,"com-help"]],["mysterx"]],
["com-idispatch?",">foreign/com-auto.html#(def._((lib._ffi/unsafe/com..rkt)._com-idispatch~3f))",[0,[2,"com-idispatch?"]],["ffi/com"]],
["com-invoke",">foreign/com-auto.html#(def._((lib._ffi/unsafe/com..rkt)._com-invoke))",[0,[2,"com-invoke"]],["ffi/com"]],
["com-invoke",">mysterx/methprop.html#(def._((lib._mysterx/main..rkt)._com-invoke))",[0,[2,"com-invoke"]],["mysterx"]],
["com-is-a?",">mysterx/com-types.html#(def._((lib._mysterx/main..rkt)._com-is-a~3f))",[0,[2,"com-is-a?"]],["mysterx"]],
["com-iunknown?",">foreign/com-auto.html#(def._((lib._ffi/unsafe/com..rkt)._com-iunknown~3f))",[0,[2,"com-iunknown?"]],["ffi/com"]],
["com-iunknown?",">mysterx/com-types.html#(def._((lib._mysterx/main..rkt)._com-iunknown~3f))",[0,[2,"com-iunknown?"]],["mysterx"]],
["com-make-event-executor",">foreign/com-auto.html#(def._((lib._ffi/unsafe/com..rkt)._com-make-event-executor))",[0,[2,"com-make-event-executor"]],["ffi/com"]],
["com-method-type",">foreign/com-auto.html#(def._((lib._ffi/unsafe/com..rkt)._com-method-type))",[0,[2,"com-method-type"]],["ffi/com"]],
["com-method-type",">mysterx/methprop.html#(def._((lib._mysterx/main..rkt)._com-method-type))",[0,[2,"com-method-type"]],["mysterx"]],
["com-methods",">foreign/com-auto.html#(def._((lib._ffi/unsafe/com..rkt)._com-methods))",[0,[2,"com-methods"]],["ffi/com"]],
["com-methods",">mysterx/methprop.html#(def._((lib._mysterx/main..rkt)._com-methods))",[0,[2,"com-methods"]],["mysterx"]],
["com-object-clsid",">foreign/com-auto.html#(def._((lib._ffi/unsafe/com..rkt)._com-object-clsid))",[0,[2,"com-object-clsid"]],["ffi/com"]],
["com-object-eq?",">foreign/com-auto.html#(def._((lib._ffi/unsafe/com..rkt)._com-object-eq~3f))",[0,[2,"com-object-eq?"]],["ffi/com"]],
["com-object-eq?",">mysterx/methprop.html#(def._((lib._mysterx/main..rkt)._com-object-eq~3f))",[0,[2,"com-object-eq?"]],["mysterx"]],
["com-object-get-idispatch",">foreign/com-auto.html#(def._((lib._ffi/unsafe/com..rkt)._com-object-get-idispatch))",[0,[2,"com-object-get-idispatch"]],["ffi/com"]],
["com-object-get-iunknown",">foreign/com-auto.html#(def._((lib._ffi/unsafe/com..rkt)._com-object-get-iunknown))",[0,[2,"com-object-get-iunknown"]],["ffi/com"]],
["com-object-set-clsid!",">foreign/com-auto.html#(def._((lib._ffi/unsafe/com..rkt)._com-object-set-clsid!))",[0,[2,"com-object-set-clsid!"]],["ffi/com"]],
["com-object-type",">foreign/com-auto.html#(def._((lib._ffi/unsafe/com..rkt)._com-object-type))",[0,[2,"com-object-type"]],["ffi/com"]],
["com-object-type",">mysterx/com-types.html#(def._((lib._mysterx/main..rkt)._com-object-type))",[0,[2,"com-object-type"]],["mysterx"]],
["com-object?",">foreign/com-auto.html#(def._((lib._ffi/unsafe/com..rkt)._com-object~3f))",[0,[2,"com-object?"]],["ffi/com"]],
["com-object?",">mysterx/methprop.html#(def._((lib._mysterx/main..rkt)._com-object~3f))",[0,[2,"com-object?"]],["mysterx"]],
["com-omit",">foreign/com-auto.html#(def._((lib._ffi/unsafe/com..rkt)._com-omit))",[0,[2,"com-omit"]],["ffi/com"]],
["com-omit",">mysterx/com-types.html#(def._((lib._mysterx/main..rkt)._com-omit))",[0,[2,"com-omit"]],["mysterx"]],
["com-register-event-callback",">foreign/com-auto.html#(def._((lib._ffi/unsafe/com..rkt)._com-register-event-callback))",[0,[2,"com-register-event-callback"]],["ffi/com"]],
["com-register-event-handler",">mysterx/com-events.html#(def._((lib._mysterx/main..rkt)._com-register-event-handler))",[0,[2,"com-register-event-handler"]],["mysterx"]],
["com-release",">foreign/com-auto.html#(def._((lib._ffi/unsafe/com..rkt)._com-release))",[0,[2,"com-release"]],["ffi/com"]],
["com-scode->number",">mysterx/com-types.html#(def._((lib._mysterx/main..rkt)._com-scode-~3enumber))",[0,[2,"com-scode->number"]],["mysterx"]],
["com-scode?",">mysterx/com-types.html#(def._((lib._mysterx/main..rkt)._com-scode~3f))",[0,[2,"com-scode?"]],["mysterx"]],
["com-set-properties",">foreign/com-auto.html#(def._((lib._ffi/unsafe/com..rkt)._com-set-properties))",[0,[2,"com-set-properties"]],["ffi/com"]],
["com-set-properties",">mysterx/methprop.html#(def._((lib._mysterx/main..rkt)._com-set-properties))",[0,[2,"com-set-properties"]],["mysterx"]],
["com-set-property!",">foreign/com-auto.html#(def._((lib._ffi/unsafe/com..rkt)._com-set-property!))",[0,[2,"com-set-property!"]],["ffi/com"]],
["com-set-property!",">mysterx/methprop.html#(def._((lib._mysterx/main..rkt)._com-set-property!))",[0,[2,"com-set-property!"]],["mysterx"]],
["com-set-property-type",">foreign/com-auto.html#(def._((lib._ffi/unsafe/com..rkt)._com-set-property-type))",[0,[2,"com-set-property-type"]],["ffi/com"]],
["com-set-property-type",">mysterx/methprop.html#(def._((lib._mysterx/main..rkt)._com-set-property-type))",[0,[2,"com-set-property-type"]],["mysterx"]],
["com-type=?",">foreign/com-auto.html#(def._((lib._ffi/unsafe/com..rkt)._com-type~3d~3f))",[0,[2,"com-type=?"]],["ffi/com"]],
["com-type?",">foreign/com-auto.html#(def._((lib._ffi/unsafe/com..rkt)._com-type~3f))",[0,[2,"com-type?"]],["ffi/com"]],
["com-unregister-event-callback",">foreign/com-auto.html#(def._((lib._ffi/unsafe/com..rkt)._com-unregister-event-callback))",[0,[2,"com-unregister-event-callback"]],["ffi/com"]],
["com-unregister-event-handler",">mysterx/com-events.html#(def._((lib._mysterx/main..rkt)._com-unregister-event-handler))",[0,[2,"com-unregister-event-handler"]],["mysterx"]],
["com1",">reference/windowspaths.html#(idx._(gentag._243._(lib._scribblings/reference/reference..scrbl)))",[6,"\"COM1\""],false],
["com2",">reference/windowspaths.html#(idx._(gentag._244._(lib._scribblings/reference/reference..scrbl)))",[6,"\"COM2\""],false],
["com3",">reference/windowspaths.html#(idx._(gentag._245._(lib._scribblings/reference/reference..scrbl)))",[6,"\"COM3\""],false],
["com4",">reference/windowspaths.html#(idx._(gentag._246._(lib._scribblings/reference/reference..scrbl)))",[6,"\"COM4\""],false],
["com5",">reference/windowspaths.html#(idx._(gentag._247._(lib._scribblings/reference/reference..scrbl)))",[6,"\"COM5\""],false],
["com6",">reference/windowspaths.html#(idx._(gentag._248._(lib._scribblings/reference/reference..scrbl)))",[6,"\"COM6\""],false],
["com7",">reference/windowspaths.html#(idx._(gentag._249._(lib._scribblings/reference/reference..scrbl)))",[6,"\"COM7\""],false],
["com8",">reference/windowspaths.html#(idx._(gentag._250._(lib._scribblings/reference/reference..scrbl)))",[6,"\"COM8\""],false],
["com9",">reference/windowspaths.html#(idx._(gentag._251._(lib._scribblings/reference/reference..scrbl)))",[6,"\"COM9\""],false],
["combine-in",">reference/require.html#(form._((lib._racket/private/base..rkt)._combine-in))",[0,[1,"combine-in"]],["racket/base","racket"]],
["combine-out",">reference/require.html#(form._((lib._racket/private/base..rkt)._combine-out))",[0,[1,"combine-out"]],["racket/base","racket"]],
["combine-url/relative",">net/url.html#(def._((lib._net/url..rkt)._combine-url/relative))",[0,[2,"combine-url/relative"]],["net/url"]],
["combined",">deinprogramm/Signaturen.html#(part._combined)",[0,[1,"combined"]],false],
["combined",">deinprogramm/Signaturen.html#(form._((lib._deinprogramm/.D.Md.A..rkt)._combined))",[0,[1,"combined"]],["deinprogramm/DMdA-beginner"]],
["combining tests: and and or",">guide/conditionals.html#(part._and+or)",["Combining Tests: ",[0,[1,"and"]]," and ",[0,[1,"or"]]],false],
["combo field",">gui/windowing-overview.html#(tech._combo._field)","<span style=\"font-style: italic\">combo field</span>",false],
["combo-field%",">gui/combo-field_.html",[0,[2,"combo-field%"]],["racket/gui/base","racket/gui"]],
["command",">gui/control___.html#(meth._(((lib._mred/main..rkt)._control~3c~25~3e)._command))",[[0,[2,"command"]],[14,[" (method of ",[0,[2,"control<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["command",">gui/selectable-menu-item___.html#(meth._(((lib._mred/main..rkt)._selectable-menu-item~3c~25~3e)._command))",[[0,[2,"command"]],[14,[" (method of ",[0,[2,"selectable-menu-item<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["command",">mrlib/Switchable_Button.html#(meth._(((lib._mrlib/switchable-button..rkt)._switchable-button~25)._command))",[[0,[2,"command"]],[14,[" (method of ",[0,[2,"switchable-button%"]],")"]]],["mrlib/switchable-button"]],
["command argument parsing",">raco/command.html#(part._.Command_.Argument_.Parsing)","Command Argument Parsing",false],
["command line",">reference/running-sa.html#(part._mz-cmdline)","Command Line",false],
["command-line",">reference/Command-Line_Parsing.html#(form._((lib._racket/cmdline..rkt)._command-line))",[0,[1,"command-line"]],["racket/cmdline","racket"]],
["command-line",">r6rs-lib-std/r6rs-lib-Z-H-11.html#node_idx_844",[0,[2,"command-line"]],["rnrs/programs-6"]],
["command-line",">mzlib/mzlib_cmdline.html#(form._((lib._mzlib/cmdline..rkt)._command-line))",[0,[1,"command-line"]],["mzlib/cmdline"]],
["command-line options",">slideshow/Creating_Slide_Presentations.html#(part._.Command-line_.Options)","Command-line Options",false],
["command-line parsing",">reference/Command-Line_Parsing.html","Command-Line Parsing",false],
["command-line tools",">guide/cmdline-tools.html","Command-Line Tools",false],
["command-line tools",">web-server/run.html#(part._command-line-tools)","Command-line Tools",false],
["command-line tools and your editor of choice",">guide/other-editors.html","Command-Line Tools and Your Editor of Choice",false],
["command-marker",">preprocessor/mztext.html#(def._((lib._preprocessor/mztext..rkt)._command-marker))",[0,[2,"command-marker"]],["preprocessor/mztext"]],
["commandline",">scribble/Miscellaneous.html#(def._((lib._scribble/manual..rkt)._commandline))",[0,[2,"commandline"]],["scribble/manual"]],
["comment",">slideshow/Primary_Slide_Functions.html#(def._((lib._slideshow/base..rkt)._comment))",[0,[2,"comment"]],["slideshow/base","slideshow"]],
["comment",">xml/index.html#(def._((lib._xml/main..rkt)._comment))",[0,[2,"comment"]],["xml"]],
["comment",">tools/adding-languages.html#(idx._(gentag._11._(lib._scribblings/tools/tools..scrbl)))",[7,"'comment"],false],
["comment box",">framework/Comment_Box.html","Comment Box",false],
["comment out with a box menu item",">drracket/Menus.html#(idx._(gentag._133._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Comment Out with a Box</span> menu item",false],
["comment out with semicolons menu item",">drracket/Menus.html#(idx._(gentag._132._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Comment Out with Semicolons</span> menu item",false],
["comment-box:snip%",">framework/Comment_Box.html#(def._((lib._framework/main..rkt)._comment-box~3asnip~25))",[0,[2,"comment-box:snip%"]],["framework"]],
["comment-box:snipclass",">framework/Comment_Box.html#(def._((lib._framework/main..rkt)._comment-box~3asnipclass))",[0,[2,"comment-box:snipclass"]],["framework"]],
["comment-color",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._comment-color))",[0,[2,"comment-color"]],["scribble/racket","scribble/scheme"]],
["comment-color",">slideshow/Typesetting_Racket_Code.html#(def._((lib._slideshow/code..rkt)._comment-color))",[0,[2,"comment-color"]],["slideshow/code"]],
["comment-editor%",">gui/WXME_Decoding.html#(def._((lib._wxme/comment..rkt)._comment-editor~25))",[0,[2,"comment-editor%"]],["wxme/comment"]],
["comment-out-selection",">framework/Racket.html#(meth._(((lib._framework/main..rkt)._racket~3atext~3c~25~3e)._comment-out-selection))",[[0,[2,"comment-out-selection"]],[14,[" (method of ",[0,[2,"racket:text<%>"]],")"]]],["framework"]],
["comment-text",">xml/index.html#(def._((lib._xml/main..rkt)._comment-text))",[0,[2,"comment-text"]],["xml"]],
["comment?",">slideshow/Primary_Slide_Functions.html#(def._((lib._slideshow/base..rkt)._comment~3f))",[0,[2,"comment?"]],["slideshow/base","slideshow"]],
["comment?",">xml/index.html#(def._((lib._xml/main..rkt)._comment~3f))",[0,[2,"comment?"]],["xml"]],
["comments",">scribble/reader.html#(part._.Comments)","Comments",false],
["comments",">guide/syntax-overview.html#(idx._(gentag._0._(lib._scribblings/guide/guide..scrbl)))","comments",false],
["commit-transaction",">db/query-api.html#(def._((lib._db/base..rkt)._commit-transaction))",[0,[2,"commit-transaction"]],["db","db/base"]],
["common syntaxes",">htdp-langs/advanced.html#(part._advanced-common-syntax)","Common Syntaxes",false],
["common syntaxes",">htdp-langs/beginner-abbr.html#(part._beginner-abbr-common-syntax)","Common Syntaxes",false],
["common syntaxes",">htdp-langs/intermediate.html#(part._intermediate-common-syntax)","Common Syntaxes",false],
["common syntaxes",">htdp-langs/intermediate-lam.html#(part._intm-w-lambda-common-syntax)","Common Syntaxes",false],
["communicator",">net/nntp.html#(def._((lib._net/nntp..rkt)._communicator))",[0,[2,"communicator"]],["net/nntp"]],
["communicator",">net/pop3.html#(def._((lib._net/pop3..rkt)._communicator))",[0,[2,"communicator"]],["net/pop3"]],
["communicator-port",">net/nntp.html#(def._((lib._net/nntp..rkt)._communicator-port))",[0,[2,"communicator-port"]],["net/nntp"]],
["communicator-port",">net/pop3.html#(def._((lib._net/pop3..rkt)._communicator-port))",[0,[2,"communicator-port"]],["net/pop3"]],
["communicator-receiver",">net/nntp.html#(def._((lib._net/nntp..rkt)._communicator-receiver))",[0,[2,"communicator-receiver"]],["net/nntp"]],
["communicator-receiver",">net/pop3.html#(def._((lib._net/pop3..rkt)._communicator-receiver))",[0,[2,"communicator-receiver"]],["net/pop3"]],
["communicator-sender",">net/nntp.html#(def._((lib._net/nntp..rkt)._communicator-sender))",[0,[2,"communicator-sender"]],["net/nntp"]],
["communicator-sender",">net/pop3.html#(def._((lib._net/pop3..rkt)._communicator-sender))",[0,[2,"communicator-sender"]],["net/pop3"]],
["communicator-server",">net/nntp.html#(def._((lib._net/nntp..rkt)._communicator-server))",[0,[2,"communicator-server"]],["net/nntp"]],
["communicator-server",">net/pop3.html#(def._((lib._net/pop3..rkt)._communicator-server))",[0,[2,"communicator-server"]],["net/pop3"]],
["communicator-state",">net/pop3.html#(def._((lib._net/pop3..rkt)._communicator-state))",[0,[2,"communicator-state"]],["net/pop3"]],
["communicator?",">net/nntp.html#(def._((lib._net/nntp..rkt)._communicator~3f))",[0,[2,"communicator?"]],["net/nntp"]],
["communicator?",">net/pop3.html#(def._((lib._net/pop3..rkt)._communicator~3f))",[0,[2,"communicator?"]],["net/pop3"]],
["compatibility",">plot/params.html#(part._.Compatibility)","Compatibility",false],
["compatibility basic functions",">scribble/Compatibility_Libraries.html#(part._basic)","Compatibility Basic Functions",false],
["compatibility executables",">scheme/compat-exe.html","Compatibility Executables",false],
["compatibility languages",">ts-reference/Compatibility_Languages.html","Compatibility Languages",false],
["compatibility libraries",">scribble/Compatibility_Libraries.html","Compatibility Libraries",false],
["compatibility module",">plot/compat.html","Compatibility Module",false],
["compatibility structures and processing",">scribble/Compatibility_Libraries.html#(part._struct)","Compatibility Structures And Processing",false],
["compatible-closure",">redex/The_Redex_Reference.html#(form._((lib._redex/reduction-semantics..rkt)._compatible-closure))",[0,[1,"compatible-closure"]],["redex/reduction-semantics","redex"]],
["compilation",">dynext/Compilation.html","Compilation",false],
["compilation",">reference/syntax-model.html#(part._compilation-model)","Compilation",false],
["compilation and configuration: raco",">guide/cmdline-tools.html#(part._compile)",["Compilation and Configuration: ",[6,"raco"]],false],
["compilation handler",">reference/eval.html#(tech._compilation._handler)","<span style=\"font-style: italic\">compilation handler</span>",false],
["compilation manager hook for syntax transformers",">raco/make.html#(part._.Compilation_.Manager_.Hook_for_.Syntax_.Transformers)","Compilation Manager Hook for Syntax Transformers",false],
["compilation parameters",">dynext/Compilation.html#(part._compile-params)","Compilation Parameters",false],
["compilation-top",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._compilation-top))",[0,[2,"compilation-top"]],["compiler/zo-structs"]],
["compilation-top-code",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._compilation-top-code))",[0,[2,"compilation-top-code"]],["compiler/zo-structs"]],
["compilation-top-max-let-depth",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._compilation-top-max-let-depth))",[0,[2,"compilation-top-max-let-depth"]],["compiler/zo-structs"]],
["compilation-top-prefix",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._compilation-top-prefix))",[0,[2,"compilation-top-prefix"]],["compiler/zo-structs"]],
["compilation-top?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._compilation-top~3f))",[0,[2,"compilation-top?"]],["compiler/zo-structs"]],
["compile",">reference/eval.html#(def._((quote._~23~25kernel)._compile))",[0,[2,"compile"]],["racket/base","racket"]],
["compile and run-time phases",">guide/stx-phases.html","Compile and Run-Time Phases",false],
["compile-allow-set!-undefined",">reference/eval.html#(def._((quote._~23~25kernel)._compile-allow-set!-undefined))",[0,[2,"compile-allow-set!-undefined"]],["racket/base","racket"]],
["compile-collection-zos",">raco/API_for_Raw_Compilation.html#(def._((lib._compiler/compiler..rkt)._compile-collection-zos))",[0,[2,"compile-collection-zos"]],["compiler/compiler"]],
["compile-context-preservation-enabled",">reference/eval.html#(def._((quote._~23~25kernel)._compile-context-preservation-enabled))",[0,[2,"compile-context-preservation-enabled"]],["racket/base","racket"]],
["compile-directory-zos",">raco/API_for_Raw_Compilation.html#(def._((lib._compiler/compiler..rkt)._compile-directory-zos))",[0,[2,"compile-directory-zos"]],["compiler/compiler"]],
["compile-enforce-module-constants",">reference/eval.html#(def._((quote._~23~25kernel)._compile-enforce-module-constants))",[0,[2,"compile-enforce-module-constants"]],["racket/base","racket"]],
["compile-extension",">dynext/Compilation.html#(def._((lib._dynext/compile..rkt)._compile-extension))",[0,[2,"compile-extension"]],["dynext/compile"]],
["compile-file",">mzlib/mzlib_compile.html#(def._((lib._mzlib/compile..rkt)._compile-file))",[0,[2,"compile-file"]],["mzlib/compile"]],
["compile-lock->parallel-lock-client",">raco/make.html#(def._((lib._compiler/cm..rkt)._compile-lock-~3eparallel-lock-client))",[0,[2,"compile-lock->parallel-lock-client"]],["compiler/cm"]],
["compile-mode",">raco/setup-plt-plt.html#(sig-val._((lib._setup/option-sig..rkt)._setup-option~5e._compile-mode))",[0,[2,"compile-mode"]],["setup/option-sig"]],
["compile-omit-files",">raco/API_for_Raw_Compilation.html#(idx._(gentag._33._(lib._scribblings/raco/raco..scrbl)))",[0,"compile-omit-files"],false],
["compile-omit-paths",">raco/API_for_Raw_Compilation.html#(idx._(gentag._32._(lib._scribblings/raco/raco..scrbl)))",[0,"compile-omit-paths"],false],
["compile-subcollections",">raco/API_for_Raw_Compilation.html#(def._((lib._compiler/option..rkt)._compile-subcollections))",[0,[2,"compile-subcollections"]],["compiler/option"]],
["compile-syntax",">reference/eval.html#(def._((quote._~23~25kernel)._compile-syntax))",[0,[2,"compile-syntax"]],["racket/base","racket"]],
["compile-variant",">dynext/Compilation.html#(def._((lib._dynext/compile..rkt)._compile-variant))",[0,[2,"compile-variant"]],["dynext/compile"]],
["compile-zos",">raco/API_for_Raw_Compilation.html#(def._((lib._compiler/compiler..rkt)._compile-zos))",[0,[2,"compile-zos"]],["compiler/compiler"]],
["compiled",">reference/syntax-model.html#(tech._compiled)","<span style=\"font-style: italic\">compiled</span>",false],
["compiled modules and references",">reference/Module_Names_and_Loading.html#(part._modpathidx)","Compiled Modules and References",false],
["compiled-bitmap",">images/Embedding_Bitmaps_in_Compiled_Files.html#(form._((lib._images/compile-time..rkt)._compiled-bitmap))",[0,[1,"compiled-bitmap"]],["images/compile-time"]],
["compiled-bitmap-list",">images/Embedding_Bitmaps_in_Compiled_Files.html#(form._((lib._images/compile-time..rkt)._compiled-bitmap-list))",[0,[1,"compiled-bitmap-list"]],["images/compile-time"]],
["compiled-expression",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Compiled-.Expression))",[0,[1,"Compiled-Expression"]],["typed/racket/base","typed/racket"]],
["compiled-expression?",">reference/eval.html#(def._((quote._~23~25kernel)._compiled-expression~3f))",[0,[2,"compiled-expression?"]],["racket/base","racket"]],
["compiled-lang?",">redex/The_Redex_Reference.html#(def._((lib._redex/reduction-semantics..rkt)._compiled-lang~3f))",[0,[2,"compiled-lang?"]],["redex/reduction-semantics","redex"]],
["compiled-load handler",">reference/eval.html#(tech._compiled._load._handler)","<span style=\"font-style: italic\">compiled-load\nhandler</span>",false],
["compiled-module-expression",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Compiled-.Module-.Expression))",[0,[1,"Compiled-Module-Expression"]],["typed/racket/base","typed/racket"]],
["compiled-module-expression?",">reference/Module_Names_and_Loading.html#(def._((quote._~23~25kernel)._compiled-module-expression~3f))",[0,[2,"compiled-module-expression?"]],["racket/base","racket"]],
["compiler-hint:cross-module-inline",">reference/define.html#(idx._(gentag._89._(lib._scribblings/reference/reference..scrbl)))",[7,"'compiler-hint:cross-module-inline"],false],
["compiler-sizeof",">foreign/ctype.html#(def._((quote._~23~25foreign)._compiler-sizeof))",[0,[2,"compiler-sizeof"]],["ffi/unsafe"]],
["compiler-verbose",">raco/setup-plt-plt.html#(sig-val._((lib._setup/option-sig..rkt)._setup-option~5e._compiler-verbose))",[0,[2,"compiler-verbose"]],["setup/option-sig"]],
["compiler/bundle-dist",">raco/exe-dist.html#(mod-path._compiler/bundle-dist)",[9,[0,"compiler/bundle-dist"]],"module"],
["compiler/cm",">raco/make.html#(mod-path._compiler/cm)",[9,[0,"compiler/cm"]],"module"],
["compiler/cm-accomplice",">raco/make.html#(mod-path._compiler/cm-accomplice)",[9,[0,"compiler/cm-accomplice"]],"module"],
["compiler/compiler",">raco/API_for_Raw_Compilation.html",[9,[0,"compiler/compiler"]],"module"],
["compiler/compiler-unit",">raco/API_for_Raw_Compilation.html#(mod-path._compiler/compiler-unit)",[9,[0,"compiler/compiler-unit"]],"module"],
["compiler/decompile",">raco/decompile.html#(mod-path._compiler/decompile)",[9,[0,"compiler/decompile"]],"module"],
["compiler/distribute",">raco/exe-dist.html#(mod-path._compiler/distribute)",[9,[0,"compiler/distribute"]],"module"],
["compiler/embed",">raco/exe.html#(mod-path._compiler/embed)",[9,[0,"compiler/embed"]],"module"],
["compiler/embed-sig",">raco/exe.html#(mod-path._compiler/embed-sig)",[9,[0,"compiler/embed-sig"]],"module"],
["compiler/embed-unit",">raco/exe.html#(mod-path._compiler/embed-unit)",[9,[0,"compiler/embed-unit"]],"module"],
["compiler/find-exe",">raco/exe.html#(mod-path._compiler/find-exe)",[9,[0,"compiler/find-exe"]],"module"],
["compiler/option",">raco/API_for_Raw_Compilation.html#(mod-path._compiler/option)",[9,[0,"compiler/option"]],"module"],
["compiler/option-unit",">raco/API_for_Raw_Compilation.html#(mod-path._compiler/option-unit)",[9,[0,"compiler/option-unit"]],"module"],
["compiler/sig",">raco/API_for_Raw_Compilation.html#(mod-path._compiler/sig)",[9,[0,"compiler/sig"]],"module"],
["compiler/xform",">raco/cc.html#(mod-path._compiler/xform)",[9,[0,"compiler/xform"]],"module"],
["compiler/zo-marshal",">raco/decompile.html#(mod-path._compiler/zo-marshal)",[9,[0,"compiler/zo-marshal"]],"module"],
["compiler/zo-parse",">raco/decompile.html#(mod-path._compiler/zo-parse)",[9,[0,"compiler/zo-parse"]],"module"],
["compiler/zo-structs",">raco/decompile.html#(mod-path._compiler/zo-structs)",[9,[0,"compiler/zo-structs"]],"module"],
["compiler:embed@",">raco/exe.html#(def._((lib._compiler/embed-unit..rkt)._compiler~3aembed~40))",[0,[2,"compiler:embed@"]],["compiler/embed-unit"]],
["compiler:embed^",">raco/exe.html#(form._((lib._compiler/embed-sig..rkt)._compiler~3aembed~5e))",[0,[1,"compiler:embed^"]],["compiler/embed-sig"]],
["compiler:option@",">raco/API_for_Raw_Compilation.html#(def._((lib._compiler/option-unit..rkt)._compiler~3aoption~40))",[0,[2,"compiler:option@"]],["compiler/option-unit"]],
["compiler:option^",">raco/API_for_Raw_Compilation.html#(form._((lib._compiler/sig..rkt)._compiler~3aoption~5e))",[0,[1,"compiler:option^"]],["compiler/sig"]],
["compiler@",">raco/API_for_Raw_Compilation.html#(def._((lib._compiler/compiler-unit..rkt)._compiler~40))",[0,[2,"compiler@"]],["compiler/compiler-unit"]],
["compiler^",">raco/API_for_Raw_Compilation.html#(form._((lib._compiler/sig..rkt)._compiler~5e))",[0,[1,"compiler^"]],["compiler/sig"]],
["compiling and linking c extensions",">raco/cc.html","Compiling and Linking C Extensions",false],
["compiling to raw bytecode",">raco/make.html#(part._zo)","Compiling to Raw Bytecode",false],
["complement",">mzlib/mzlib_integer-set.html#(def._((lib._mzlib/integer-set..rkt)._complement))",[0,[2,"complement"]],["mzlib/integer-set"]],
["complement",">unstable/Automata__Compiling_State_Machines.html#(form._((lib._unstable/automata/re..rkt)._complement))",[0,[1,"complement"]],["unstable/automata/re"]],
["complete",">reference/bytestrings.html#(idx._(gentag._115._(lib._scribblings/reference/reference..scrbl)))",[7,"'complete"],false],
["complete",">reference/bytestrings.html#(idx._(gentag._119._(lib._scribblings/reference/reference..scrbl)))",[7,"'complete"],false],
["complete word menu item",">drracket/Menus.html#(idx._(gentag._90._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Complete Word</span> menu item",false],
["complete-path?",">reference/Manipulating_Paths.html#(def._((quote._~23~25kernel)._complete-path~3f))",[0,[2,"complete-path?"]],["racket/base","racket"]],
["completion value",">reference/places.html#(tech._completion._value)","<span style=\"font-style: italic\">completion value</span>",false],
["completion-mode-key-event?",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3aautocomplete~3c~25~3e)._completion-mode-key-event~3f))",[[0,[2,"completion-mode-key-event?"]],[14,[" (method of ",[0,[2,"text:autocomplete<%>"]],")"]]],["framework"]],
["complex",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Complex))",[0,[1,"Complex"]],["typed/racket/base","typed/racket"]],
["complex",">guide/numbers.html#(tech._complex)","<span style=\"font-style: italic\">complex</span>",false],
["complex numbers",">reference/generic-numbers.html#(part._.Complex_.Numbers)","Complex Numbers",false],
["complex numbers",">reference/numbers.html#(tech._complex._number)","<span style=\"font-style: italic\">complex numbers</span>",false],
["complex?",">reference/number-types.html#(def._((quote._~23~25kernel)._complex~3f))",[0,[2,"complex?"]],["racket/base","racket"]],
["complex?",">r5rs-std/r5rs-Z-H-9.html#%_idx_246",[0,[2,"complex?"]],["r5rs"]],
["complex?",">r6rs-std/r6rs-Z-H-14.html#node_idx_442",[0,[2,"complex?"]],["rnrs/base-6"]],
["complex?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._complex~3f))",[0,[2,"complex?"]],["lang/htdp-advanced"]],
["complex?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._complex~3f))",[0,[2,"complex?"]],["lang/htdp-beginner"]],
["complex?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._complex~3f))",[0,[2,"complex?"]],["lang/htdp-beginner-abbr"]],
["complex?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._complex~3f))",[0,[2,"complex?"]],["lang/htdp-intermediate"]],
["complex?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._complex~3f))",[0,[2,"complex?"]],["lang/htdp-intermediate-lambda"]],
["complex?",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._complex~3f))",[0,[2,"complex?"]],["deinprogramm/DMdA-advanced"]],
["complex?",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._complex~3f))",[0,[2,"complex?"]],["deinprogramm/DMdA-assignments"]],
["complex?",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._complex~3f))",[0,[2,"complex?"]],["deinprogramm/DMdA-beginner"]],
["complex?",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._complex~3f))",[0,[2,"complex?"]],["deinprogramm/DMdA-vanilla"]],
["component operations",">images/Component_Operations.html","Component Operations",false],
["components",">guide/units.html#(tech._component)","<span style=\"font-style: italic\">components</span>",false],
["composable continuation",">reference/eval-model.html#(tech._composable._continuation)","<span style=\"font-style: italic\">composable continuation</span>",false],
["composable continuations",">guide/Continuations.html#(tech._composable._continuation)","<span style=\"font-style: italic\">composable continuations</span>",false],
["compose",">reference/procedures.html#(def._((lib._racket/private/list..rkt)._compose))",[0,[2,"compose"]],["racket/base","racket"]],
["compose",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._compose))",[0,[2,"compose"]],["lang/htdp-advanced"]],
["compose",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._compose))",[0,[2,"compose"]],["lang/htdp-intermediate"]],
["compose",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._compose))",[0,[2,"compose"]],["lang/htdp-intermediate-lambda"]],
["compose",">lazy/index.html#(def._((lib._lazy/main..rkt)._compose))",[0,[2,"compose"]],["lazy"]],
["compose1",">reference/procedures.html#(def._((lib._racket/private/list..rkt)._compose1))",[0,[2,"compose1"]],["racket/base","racket"]],
["composing images",">teachpack/image.html#(part._composition)","Composing Images",false],
["composite input port",">preprocessor/mztext.html#(tech._composite._input._port)","<span style=\"font-style: italic\">composite input port</span>",false],
["compositing",">images/Compositing.html","Compositing",false],
["compound paragraph",">scribble/core.html#(tech._compound._paragraph)","<span style=\"font-style: italic\">compound paragraph</span>",false],
["compound testing forms",">rackunit/api.html#(part._.Compound_.Testing_.Forms)","Compound Testing Forms",false],
["compound-paragraph",">scribble/core.html#(def._((lib._scribble/core..rkt)._compound-paragraph))",[0,[2,"compound-paragraph"]],["scribble/core"]],
["compound-paragraph-blocks",">scribble/core.html#(def._((lib._scribble/core..rkt)._compound-paragraph-blocks))",[0,[2,"compound-paragraph-blocks"]],["scribble/core"]],
["compound-paragraph-style",">scribble/core.html#(def._((lib._scribble/core..rkt)._compound-paragraph-style))",[0,[2,"compound-paragraph-style"]],["scribble/core"]],
["compound-paragraph?",">scribble/core.html#(def._((lib._scribble/core..rkt)._compound-paragraph~3f))",[0,[2,"compound-paragraph?"]],["scribble/core"]],
["compound-struct?",">racklog/glossary.html#(def._((lib._racklog/main..rkt)._compound-struct~3f))",[0,[2,"compound-struct?"]],["racklog"]],
["compound-unit",">reference/compoundunits.html#(form._((lib._mzlib/unit..rkt)._compound-unit))",[0,[1,"compound-unit"]],["racket/unit","racket"]],
["compound-unit/infer",">reference/linkinference.html#(form._((lib._mzlib/unit..rkt)._compound-unit/infer))",[0,[1,"compound-unit/infer"]],["racket/unit","racket"]],
["compound?",">racklog/glossary.html#(def._((lib._racklog/main..rkt)._compound~3f))",[0,[2,"compound?"]],["racklog"]],
["compress-serial",">web-server-internal/mod-map.html#(def._((lib._web-server/private/mod-map..rkt)._compress-serial))",[0,[2,"compress-serial"]],["web-server/private/mod-map"]],
["compute-image-cache",">mrlib/Image_Core.html#(def._((lib._mrlib/image-core..rkt)._compute-image-cache))",[0,[2,"compute-image-cache"]],["mrlib/image-core"]],
["computer",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._computer))",[0,[2,"computer"]],["deinprogramm/DMdA-advanced"]],
["computer",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._computer))",[0,[2,"computer"]],["deinprogramm/DMdA-assignments"]],
["computer",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._computer))",[0,[2,"computer"]],["deinprogramm/DMdA-beginner"]],
["computer",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._computer))",[0,[2,"computer"]],["deinprogramm/DMdA-vanilla"]],
["computer-hard-drive",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._computer-hard-drive))",[0,[2,"computer-hard-drive"]],["deinprogramm/DMdA-advanced"]],
["computer-hard-drive",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._computer-hard-drive))",[0,[2,"computer-hard-drive"]],["deinprogramm/DMdA-assignments"]],
["computer-hard-drive",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._computer-hard-drive))",[0,[2,"computer-hard-drive"]],["deinprogramm/DMdA-beginner"]],
["computer-hard-drive",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._computer-hard-drive))",[0,[2,"computer-hard-drive"]],["deinprogramm/DMdA-vanilla"]],
["computer-processor",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._computer-processor))",[0,[2,"computer-processor"]],["deinprogramm/DMdA-advanced"]],
["computer-processor",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._computer-processor))",[0,[2,"computer-processor"]],["deinprogramm/DMdA-assignments"]],
["computer-processor",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._computer-processor))",[0,[2,"computer-processor"]],["deinprogramm/DMdA-beginner"]],
["computer-processor",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._computer-processor))",[0,[2,"computer-processor"]],["deinprogramm/DMdA-vanilla"]],
["computer-ram",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._computer-ram))",[0,[2,"computer-ram"]],["deinprogramm/DMdA-advanced"]],
["computer-ram",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._computer-ram))",[0,[2,"computer-ram"]],["deinprogramm/DMdA-assignments"]],
["computer-ram",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._computer-ram))",[0,[2,"computer-ram"]],["deinprogramm/DMdA-beginner"]],
["computer-ram",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._computer-ram))",[0,[2,"computer-ram"]],["deinprogramm/DMdA-vanilla"]],
["computer?",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._computer~3f))",[0,[2,"computer?"]],["deinprogramm/DMdA-advanced"]],
["computer?",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._computer~3f))",[0,[2,"computer?"]],["deinprogramm/DMdA-assignments"]],
["computer?",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._computer~3f))",[0,[2,"computer?"]],["deinprogramm/DMdA-beginner"]],
["computer?",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._computer~3f))",[0,[2,"computer?"]],["deinprogramm/DMdA-vanilla"]],
["computing the free variables of an expression",">syntax/syntax-helpers.html#(part._free-vars)","Computing the Free Variables of an Expression",false],
["con",">reference/windowspaths.html#(idx._(gentag._240._(lib._scribblings/reference/reference..scrbl)))",[6,"\"CON\""],false],
["concatenate",">srfi-std/srfi-1.html#concatenate",[0,[2,"concatenate"]],["srfi/1"]],
["concatenate!",">srfi-std/srfi-1.html#concatenate!",[0,[2,"concatenate!"]],["srfi/1"]],
["conceptual model",">images/Overview.html#(part._flomap~3aconceptual)","Conceptual Model",false],
["concurrency and parallelism",">reference/concurrency.html","Concurrency and Parallelism",false],
["cond",">deinprogramm/cond.html",[0,[1,"cond"]],false],
["cond",">reference/if.html#(form._((lib._racket/private/letstx-scheme..rkt)._cond))",[0,[1,"cond"]],["racket/base","racket"]],
["cond",">r5rs-std/r5rs-Z-H-7.html#%_idx_108",[0,[1,"cond"]],["r5rs"]],
["cond",">r6rs-std/r6rs-Z-H-14.html#node_idx_376",[0,[2,"cond"]],["rnrs/base-6"]],
["cond",">htdp-langs/advanced.html#(form._((lib._lang/htdp-advanced..rkt)._cond))",[0,[1,"cond"]],["lang/htdp-advanced"]],
["cond",">htdp-langs/beginner.html#(form._((lib._lang/htdp-beginner..rkt)._cond))",[0,[1,"cond"]],["lang/htdp-beginner"]],
["cond",">htdp-langs/beginner-abbr.html#(form._((lib._lang/htdp-beginner-abbr..rkt)._cond))",[0,[1,"cond"]],["lang/htdp-beginner-abbr"]],
["cond",">htdp-langs/intermediate.html#(form._((lib._lang/htdp-intermediate..rkt)._cond))",[0,[1,"cond"]],["lang/htdp-intermediate"]],
["cond",">htdp-langs/intermediate-lam.html#(form._((lib._lang/htdp-intermediate-lambda..rkt)._cond))",[0,[1,"cond"]],["lang/htdp-intermediate-lambda"]],
["cond",">deinprogramm/cond.html#(form._((lib._deinprogramm/.D.Md.A..rkt)._cond))",[0,[1,"cond"]],["deinprogramm/DMdA-beginner"]],
["cond",">lazy/index.html#(form._((lib._lazy/main..rkt)._cond))",[0,[1,"cond"]],["lazy"]],
["cond",">mzscheme/Old_Syntactic_Forms.html#(form._((lib._mzscheme/main..rkt)._cond))",[0,[1,"cond"]],["mzscheme"]],
["cond",">plai/mutator.html#(form._((lib._plai/mutator..rkt)._cond))",[0,[1,"cond"]],["plai/mutator"]],
["cond-block",">scriblib/render-cond.html#(form._((lib._scriblib/render-cond..rkt)._cond-block))",[0,[1,"cond-block"]],["scriblib/render-cond"]],
["cond-element",">scriblib/render-cond.html#(form._((lib._scriblib/render-cond..rkt)._cond-element))",[0,[1,"cond-element"]],["scriblib/render-cond"]],
["condense?",">slideshow/Constants_and_Layout_Variables.html#(def._((lib._slideshow/base..rkt)._condense~3f))",[0,[2,"condense?"]],["slideshow/base","slideshow"]],
["condition",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_394",[0,[2,"condition"]],["rnrs/conditions-6"]],
["condition-accessor",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_402",[0,[2,"condition-accessor"]],["rnrs/conditions-6"]],
["condition-irritants",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_450",[0,[2,"condition-irritants"]],["rnrs/conditions-6"]],
["condition-message",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_412",[0,[2,"condition-message"]],["rnrs/conditions-6"]],
["condition-predicate",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_400",[0,[2,"condition-predicate"]],["rnrs/conditions-6"]],
["condition-who",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_458",[0,[2,"condition-who"]],["rnrs/conditions-6"]],
["condition?",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_398",[0,[2,"condition?"]],["rnrs/conditions-6"]],
["conditional combinations",">unstable/pict.html#(part._.Conditional_.Combinations)","Conditional Combinations",false],
["conditional content",">scriblib/render-cond.html","Conditional Content",false],
["conditional goals",">racklog/cut.html#(part._if-then-else)","Conditional Goals",false],
["conditional manipulations",">unstable/pict.html#(part._.Conditional_.Manipulations)","Conditional Manipulations",false],
["conditionals",">guide/conditionals.html","Conditionals",false],
["conditionals with if, and, or, and cond",">guide/syntax-overview.html#(part._.Conditionals_with_if__and__or__and_cond)",["Conditionals with ",[0,[1,"if"]],", ",[0,[1,"and"]],", ",[0,[1,"or"]],", and ",[0,[1,"cond"]]],false],
["conditionals: if, cond, and, and or",">reference/if.html",["Conditionals: ",[0,[1,"if"]],", ",[0,[1,"cond"]],", ",[0,[1,"and"]],", and ",[0,[1,"or"]]],false],
["conferenceinfo",">scribble/SIGPLAN_Paper_Format.html#(def._((lib._scribble/sigplan..rkt)._conferenceinfo))",[0,[2,"conferenceinfo"]],["scribble/sigplan"]],
["config",">config/index.html#(mod-path._config)",[9,[0,"config"]],"module"],
["config-panel",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3alanguage~3c~25~3e)._config-panel))",[[0,[2,"config-panel"]],[14,[" (method of ",[0,[2,"drracket:language:language<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["config-panel",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3amodule-based-language~3c~25~3e)._config-panel))",[[0,[2,"config-panel"]],[14,[" (method of ",[0,[2,"drracket:language:module-based-language<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["config-panel",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3asimple-module-based-language-~3emodule-based-language-mixin)._config-panel))",[[0,[2,"config-panel"]],[14,[" (method of ",[0,[2,"drracket:language:simple-module-based-language->module-based-language-mixin"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["config: installation and search paths",">config/index.html","Config: Installation and Search Paths",false],
["configuration",">slideshow/Configuration.html","Configuration",false],
["configuration language",">config/index.html#(part._.Configuration_.Language)","Configuration Language",false],
["configuration options",">reference/running-sa.html#(tech._configuration._option)","<span style=\"font-style: italic\">Configuration options</span>",false],
["configuration table",">web-server-internal/Web_Servers.html#(part._configuration-table)","Configuration Table",false],
["configuration table structure",">web-server-internal/Web_Servers.html#(part._configuration-table-structs)","Configuration Table Structure",false],
["configuration units",">web-server-internal/Web_Servers.html#(part._web-config._web-config-unit)","Configuration Units",false],
["configuration-root",">web-server-internal/Web_Servers.html#(idx._(gentag._24._(lib._web-server/scribblings/web-server-internal..scrbl)))","configuration-root",false],
["configuration-table",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._configuration-table))",[0,[2,"configuration-table"]],["web-server/configuration/configuration-table-structs"]],
["configuration-table->sexpr",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table..rkt)._configuration-table-~3esexpr))",[0,[2,"configuration-table->sexpr"]],["web-server/configuration/configuration-table"]],
["configuration-table->web-config@",">web-server-internal/Web_Servers.html#(def._web-config._((lib._web-server/web-config-unit..rkt)._configuration-table-~3eweb-config~40))",[0,[2,"configuration-table->web-config@"]],["web-server/web-config-unit"]],
["configuration-table-default-host",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._configuration-table-default-host))",[0,[2,"configuration-table-default-host"]],["web-server/configuration/configuration-table-structs"]],
["configuration-table-initial-connection-timeout",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._configuration-table-initial-connection-timeout))",[0,[2,"configuration-table-initial-connection-timeout"]],["web-server/configuration/configuration-table-structs"]],
["configuration-table-max-waiting",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._configuration-table-max-waiting))",[0,[2,"configuration-table-max-waiting"]],["web-server/configuration/configuration-table-structs"]],
["configuration-table-port",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._configuration-table-port))",[0,[2,"configuration-table-port"]],["web-server/configuration/configuration-table-structs"]],
["configuration-table-sexpr->web-config@",">web-server-internal/Web_Servers.html#(def._web-config._((lib._web-server/web-config-unit..rkt)._configuration-table-sexpr-~3eweb-config~40))",[0,[2,"configuration-table-sexpr->web-config@"]],["web-server/web-config-unit"]],
["configuration-table-sexpr?",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table..rkt)._configuration-table-sexpr~3f))",[0,[2,"configuration-table-sexpr?"]],["web-server/configuration/configuration-table"]],
["configuration-table-virtual-hosts",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._configuration-table-virtual-hosts))",[0,[2,"configuration-table-virtual-hosts"]],["web-server/configuration/configuration-table-structs"]],
["configuration-table?",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._configuration-table~3f))",[0,[2,"configuration-table?"]],["web-server/configuration/configuration-table-structs"]],
["configure-runtime",">reference/running-sa.html#(idx._(gentag._430._(lib._scribblings/reference/reference..scrbl)))",[7,"'configure-runtime"],false],
["configuring default handling",">reference/exns.html#(part._.Configuring_.Default_.Handling)","Configuring Default Handling",false],
["configuring directories and search paths",">config/index.html#(part._.Configuring_.Directories_and_.Search_.Paths)","Configuring Directories and Search Paths",false],
["configuring output",">scribble/config.html#(part._config-style)","Configuring Output",false],
["conjoin",">unstable/Functions.html#(def._((lib._unstable/function..rkt)._conjoin))",[0,[2,"conjoin"]],["unstable/function"]],
["conjuctions and disjunctions",">racklog/and-or.html","Conjuctions and Disjunctions",false],
["conjugate",">reference/generic-numbers.html#(def._((lib._racket/math..rkt)._conjugate))",[0,[2,"conjugate"]],["racket/math","racket"]],
["conjugate",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._conjugate))",[0,[2,"conjugate"]],["lang/htdp-advanced"]],
["conjugate",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._conjugate))",[0,[2,"conjugate"]],["lang/htdp-beginner"]],
["conjugate",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._conjugate))",[0,[2,"conjugate"]],["lang/htdp-beginner-abbr"]],
["conjugate",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._conjugate))",[0,[2,"conjugate"]],["lang/htdp-intermediate"]],
["conjugate",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._conjugate))",[0,[2,"conjugate"]],["lang/htdp-intermediate-lambda"]],
["connect",">teachpack/arrow-gui.html#(def._((lib._htdp/arrow-gui..rkt)._connect))",[0,[2,"connect"]],["htdp/arrow-gui"]],
["connect",">teachpack/guess-gui.html#(def._((lib._htdp/guess-gui..rkt)._connect))",[0,[2,"connect"]],["htdp/guess-gui"]],
["connect",">teachpack/lkup-gui.html#(def._((lib._htdp/lkup-gui..rkt)._connect))",[0,[2,"connect"]],["htdp/lkup-gui"]],
["connect-to-named-place",">reference/distributed-places.html#(def._((lib._racket/place/distributed..rkt)._connect-to-named-place))",[0,[2,"connect-to-named-place"]],["racket/place/distributed"]],
["connect-to-server",">net/nntp.html#(def._((lib._net/nntp..rkt)._connect-to-server))",[0,[2,"connect-to-server"]],["net/nntp"]],
["connect-to-server",">net/pop3.html#(def._((lib._net/pop3..rkt)._connect-to-server))",[0,[2,"connect-to-server"]],["net/pop3"]],
["connected?",">db/connect.html#(def._((lib._db/base..rkt)._connected~3f))",[0,[2,"connected?"]],["db","db/base"]],
["connecting and selecting mailboxes",">net/imap.html#(part._.Connecting_and_.Selecting_.Mailboxes)","Connecting and Selecting Mailboxes",false],
["connecting to \"racket\"",">scribble/Connecting_to__racket_.html",["Connecting to ",[6,"\"racket\""]],false],
["connecting with the universe",">teachpack/2htdpuniverse.html#(part._.Connecting_with_the_.Universe)","Connecting with the Universe",false],
["connection",">web-server-internal/connection-manager.html#(def._((lib._web-server/private/connection-manager..rkt)._connection))",[0,[2,"connection"]],["web-server/private/connection-manager"]],
["connection and operations",">net/nntp.html#(part._.Connection_and_.Operations)","Connection and Operations",false],
["connection manager",">web-server-internal/connection-manager.html","Connection Manager",false],
["connection pool",">db/connect.html#(tech._connection._pool)","<span style=\"font-style: italic\">connection pool</span>",false],
["connection pooling",">db/connect.html#(part._.Connection_.Pooling)","Connection Pooling",false],
["connection threads",">more/index.html#(part._.Connection_.Threads)","Connection Threads",false],
["connection%",">reference/distributed-places.html#(def._((lib._racket/place/distributed..rkt)._connection~25))",[0,[2,"connection%"]],["racket/place/distributed"]],
["connection-close?",">web-server-internal/connection-manager.html#(def._((lib._web-server/private/connection-manager..rkt)._connection-close~3f))",[0,[2,"connection-close?"]],["web-server/private/connection-manager"]],
["connection-custodian",">web-server-internal/connection-manager.html#(def._((lib._web-server/private/connection-manager..rkt)._connection-custodian))",[0,[2,"connection-custodian"]],["web-server/private/connection-manager"]],
["connection-dbsystem",">db/connect.html#(def._((lib._db/base..rkt)._connection-dbsystem))",[0,[2,"connection-dbsystem"]],["db","db/base"]],
["connection-i-port",">web-server-internal/connection-manager.html#(def._((lib._web-server/private/connection-manager..rkt)._connection-i-port))",[0,[2,"connection-i-port"]],["web-server/private/connection-manager"]],
["connection-o-port",">web-server-internal/connection-manager.html#(def._((lib._web-server/private/connection-manager..rkt)._connection-o-port))",[0,[2,"connection-o-port"]],["web-server/private/connection-manager"]],
["connection-pool",">db/connect.html#(def._((lib._db/base..rkt)._connection-pool))",[0,[2,"connection-pool"]],["db","db/base"]],
["connection-pool-lease",">db/connect.html#(def._((lib._db/base..rkt)._connection-pool-lease))",[0,[2,"connection-pool-lease"]],["db","db/base"]],
["connection-pool?",">db/connect.html#(def._((lib._db/base..rkt)._connection-pool~3f))",[0,[2,"connection-pool?"]],["db","db/base"]],
["connection-timer",">web-server-internal/connection-manager.html#(def._((lib._web-server/private/connection-manager..rkt)._connection-timer))",[0,[2,"connection-timer"]],["web-server/private/connection-manager"]],
["connection?",">db/connect.html#(def._((lib._db/base..rkt)._connection~3f))",[0,[2,"connection?"]],["db","db/base"]],
["connection?",">web-server-internal/connection-manager.html#(def._((lib._web-server/private/connection-manager..rkt)._connection~3f))",[0,[2,"connection?"]],["web-server/private/connection-manager"]],
["connections",">db/connect.html","Connections",false],
["connections",">net/websocket.html#(part._.Connections)","Connections",false],
["cons",">reference/pairs.html#(def._((quote._~23~25kernel)._cons))",[0,[2,"cons"]],["racket/base","racket"]],
["cons",">r5rs-std/r5rs-Z-H-9.html#%_idx_408",[0,[2,"cons"]],["r5rs"]],
["cons",">r6rs-std/r6rs-Z-H-14.html#node_idx_610",[0,[2,"cons"]],["rnrs/base-6"]],
["cons",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._cons))",[0,[2,"cons"]],["lang/htdp-advanced"]],
["cons",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._cons))",[0,[2,"cons"]],["lang/htdp-beginner"]],
["cons",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._cons))",[0,[2,"cons"]],["lang/htdp-beginner-abbr"]],
["cons",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._cons))",[0,[2,"cons"]],["lang/htdp-intermediate"]],
["cons",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._cons))",[0,[2,"cons"]],["lang/htdp-intermediate-lambda"]],
["cons",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._cons))",[0,[2,"cons"]],["deinprogramm/DMdA-advanced"]],
["cons",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._cons))",[0,[2,"cons"]],["deinprogramm/DMdA-assignments"]],
["cons",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._cons))",[0,[2,"cons"]],["deinprogramm/DMdA-beginner"]],
["cons",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._cons))",[0,[2,"cons"]],["deinprogramm/DMdA-vanilla"]],
["cons",">lazy/index.html#(def._((lib._lazy/main..rkt)._cons))",[0,[2,"cons"]],["lazy"]],
["cons",">plai/mutator.html#(def._((lib._plai/mutator..rkt)._cons))",[0,[2,"cons"]],["plai/mutator"]],
["cons",">srfi-std/srfi-1.html#cons",[0,[2,"cons"]],["srfi/1"]],
["cons*",">r6rs-lib-std/r6rs-lib-Z-H-4.html#node_idx_240",[0,[2,"cons*"]],["rnrs/lists-6"]],
["cons*",">srfi-std/srfi-1.html#cons*",[0,[2,"cons*"]],["srfi/1"]],
["cons/c",">reference/data-structure-contracts.html#(def._((lib._racket/contract/private/misc..rkt)._cons/c))",[0,[2,"cons/c"]],["racket/contract/base","racket/contract","racket"]],
["cons?",">reference/pairs.html#(def._((lib._racket/list..rkt)._cons~3f))",[0,[2,"cons?"]],["racket/list","racket"]],
["cons?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._cons~3f))",[0,[2,"cons?"]],["lang/htdp-advanced"]],
["cons?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._cons~3f))",[0,[2,"cons?"]],["lang/htdp-beginner"]],
["cons?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._cons~3f))",[0,[2,"cons?"]],["lang/htdp-beginner-abbr"]],
["cons?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._cons~3f))",[0,[2,"cons?"]],["lang/htdp-intermediate"]],
["cons?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._cons~3f))",[0,[2,"cons?"]],["lang/htdp-intermediate-lambda"]],
["cons?",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._cons~3f))",[0,[2,"cons?"]],["deinprogramm/DMdA-advanced"]],
["cons?",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._cons~3f))",[0,[2,"cons?"]],["deinprogramm/DMdA-assignments"]],
["cons?",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._cons~3f))",[0,[2,"cons?"]],["deinprogramm/DMdA-vanilla"]],
["cons?",">lazy/index.html#(def._((lib._lazy/main..rkt)._cons~3f))",[0,[2,"cons?"]],["lazy"]],
["cons?",">plai/mutator.html#(def._((lib._plai/mutator..rkt)._cons~3f))",[0,[2,"cons?"]],["plai/mutator"]],
["conservative garbage collector",">guide/performance.html#(tech._conservative._garbage._collector)","<span style=\"font-style: italic\">conservative garbage collector</span>",false],
["const",">reference/procedures.html#(def._((lib._racket/function..rkt)._const))",[0,[2,"const"]],["racket/function","racket"]],
["constant",">tools/adding-languages.html#(idx._(gentag._13._(lib._scribblings/tools/tools..scrbl)))",[7,"'constant"],false],
["constants and layout variables",">slideshow/Constants_and_Layout_Variables.html","Constants and Layout Variables",false],
["constructing graphs: shared",">reference/shared.html",["Constructing Graphs: ",[0,[1,"shared"]]],false],
["constructor",">guide/define-struct.html#(tech._constructor)","<span style=\"font-style: italic\">constructor</span>",false],
["constructor",">reference/define-struct.html#(tech._constructor)","<span style=\"font-style: italic\">constructor</span>",false],
["constructor guard",">guide/define-struct.html#(tech._constructor._guard)","<span style=\"font-style: italic\">constructor guard</span>",false],
["constructor output",">drracket/output-syntax.html#(idx._(gentag._49._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Constructor</span> output",false],
["constructor-style-printing",">mzlib/mzlib_pconvert.html#(def._((lib._mzlib/pconvert..rkt)._constructor-style-printing))",[0,[2,"constructor-style-printing"]],["mzlib/pconvert"]],
["constructors",">racklog/racket-w-logic.html#(part._constructors)","Constructors",false],
["consumer-thread",">mzlib/mzlib_thread.html#(def._((lib._mzlib/thread..rkt)._consumer-thread))",[0,[2,"consumer-thread"]],["mzlib/thread"]],
["containees",">gui/windowing-overview.html#(part._containees)","Containees",false],
["containees",">gui/windowing-overview.html#(tech._containee)","<span style=\"font-style: italic\">Containees</span>",false],
["container-flow-modified",">gui/area-container___.html#(meth._(((lib._mred/main..rkt)._area-container~3c~25~3e)._container-flow-modified))",[[0,[2,"container-flow-modified"]],[14,[" (method of ",[0,[2,"area-container<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["container-size",">gui/area-container___.html#(meth._(((lib._mred/main..rkt)._area-container~3c~25~3e)._container-size))",[[0,[2,"container-size"]],[14,[" (method of ",[0,[2,"area-container<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["container-size",">framework/Panel.html#(meth._(((lib._framework/main..rkt)._panel~3adragable-mixin)._container-size))",[[0,[2,"container-size"]],[14,[" (method of ",[0,[2,"panel:dragable-mixin"]],")"]]],["framework"]],
["container-size",">framework/Panel.html#(meth._(((lib._framework/main..rkt)._panel~3asingle-mixin)._container-size))",[[0,[2,"container-size"]],[14,[" (method of ",[0,[2,"panel:single-mixin"]],")"]]],["framework"]],
["container-size",">framework/Panel.html#(meth._(((lib._framework/main..rkt)._panel~3asingle-window-mixin)._container-size))",[[0,[2,"container-size"]],[14,[" (method of ",[0,[2,"panel:single-window-mixin"]],")"]]],["framework"]],
["container?",">web-server/dispatch.html#(def._((lib._web-server/dispatch..rkt)._container~3f))",[0,[2,"container?"]],["web-server/dispatch"]],
["containers",">embedded-gui/containers.html","Containers",false],
["containers",">gui/windowing-overview.html#(part._containers)","Containers",false],
["containers",">ts-reference/type-ref.html#(part._.Containers)","Containers",false],
["containers",">gui/windowing-overview.html#(tech._container)","<span style=\"font-style: italic\">Containers</span>",false],
["containers",">web-server/dispatch.html#(tech._container)","<span style=\"font-style: italic\">Containers</span>",false],
["content",">scribble/core.html#(tech._content)","<span style=\"font-style: italic\">content</span>",false],
["content->string",">scribble/core.html#(def._((lib._scribble/core..rkt)._content-~3estring))",[0,[2,"content->string"]],["scribble/core"]],
["content-width",">scribble/core.html#(def._((lib._scribble/core..rkt)._content-width))",[0,[2,"content-width"]],["scribble/core"]],
["content/c",">xml/index.html#(def._((lib._xml/main..rkt)._content/c))",[0,[2,"content/c"]],["xml"]],
["content?",">scribble/core.html#(def._((lib._scribble/core..rkt)._content~3f))",[0,[2,"content?"]],["scribble/core"]],
["context",">reference/syntax-model.html#(tech._context)","<span style=\"font-style: italic\">context</span>",false],
["context procedures",">openssl/index.html#(part._cert-procs)","Context Procedures",false],
["context-closure",">redex/The_Redex_Reference.html#(form._((lib._redex/reduction-semantics..rkt)._context-closure))",[0,[1,"context-closure"]],["redex/reduction-semantics","redex"]],
["continuation",">guide/Continuations.html#(tech._continuation)","<span style=\"font-style: italic\">continuation</span>",false],
["continuation",">reference/eval-model.html#(tech._continuation)","<span style=\"font-style: italic\">continuation</span>",false],
["continuation barrier",">reference/eval-model.html#(tech._continuation._barrier)","<span style=\"font-style: italic\">continuation barrier</span>",false],
["continuation frames",">reference/eval-model.html#(tech._continuation._frame)","<span style=\"font-style: italic\">continuation frames</span>",false],
["continuation frames and marks",">reference/eval-model.html#(part._mark-model)","Continuation Frames and Marks",false],
["continuation managers",">web-server/servlet.html#(part._managers)","Continuation Managers",false],
["continuation marks",">inside/contmarks.html","Continuation Marks",false],
["continuation marks",">reference/contmarks.html","Continuation Marks",false],
["continuation marks",">reference/eval-model.html#(tech._continuation._mark)","<span style=\"font-style: italic\">continuation marks</span>",false],
["continuation marks: with-continuation-mark",">reference/wcm.html",["Continuation Marks: ",[0,[1,"with-continuation-mark"]]],false],
["continuation prompt",">gui/windowing-overview.html#(tech._continuation._prompt)","<span style=\"font-style: italic\">continuation prompt</span>",false],
["continuation-mark-key/c",">reference/data-structure-contracts.html#(def._((lib._racket/contract/private/misc..rkt)._continuation-mark-key/c))",[0,[2,"continuation-mark-key/c"]],["racket/contract/base","racket/contract","racket"]],
["continuation-mark-key?",">reference/contmarks.html#(def._((quote._~23~25kernel)._continuation-mark-key~3f))",[0,[2,"continuation-mark-key?"]],["racket/base","racket"]],
["continuation-mark-set",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Continuation-.Mark-.Set))",[0,[1,"Continuation-Mark-Set"]],["typed/racket/base","typed/racket"]],
["continuation-mark-set->context",">reference/contmarks.html#(def._((quote._~23~25kernel)._continuation-mark-set-~3econtext))",[0,[2,"continuation-mark-set->context"]],["racket/base","racket"]],
["continuation-mark-set->list",">reference/contmarks.html#(def._((quote._~23~25kernel)._continuation-mark-set-~3elist))",[0,[2,"continuation-mark-set->list"]],["racket/base","racket"]],
["continuation-mark-set->list*",">reference/contmarks.html#(def._((quote._~23~25kernel)._continuation-mark-set-~3elist*))",[0,[2,"continuation-mark-set->list*"]],["racket/base","racket"]],
["continuation-mark-set-first",">reference/contmarks.html#(def._((quote._~23~25kernel)._continuation-mark-set-first))",[0,[2,"continuation-mark-set-first"]],["racket/base","racket"]],
["continuation-mark-set?",">reference/contmarks.html#(def._((quote._~23~25kernel)._continuation-mark-set~3f))",[0,[2,"continuation-mark-set?"]],["racket/base","racket"]],
["continuation-marks",">reference/contmarks.html#(def._((quote._~23~25kernel)._continuation-marks))",[0,[2,"continuation-marks"]],["racket/base","racket"]],
["continuation-prompt-available?",">reference/cont.html#(def._((quote._~23~25kernel)._continuation-prompt-available~3f))",[0,[2,"continuation-prompt-available?"]],["racket/base","racket"]],
["continuation-prompt-tag?",">reference/cont.html#(def._((quote._~23~25kernel)._continuation-prompt-tag~3f))",[0,[2,"continuation-prompt-tag?"]],["racket/base","racket"]],
["continuation-url?",">web-server/servlet.html#(def._((lib._web-server/servlet/web..rkt)._continuation-url~3f))",[0,[2,"continuation-url?"]],["web-server/servlet/web"]],
["continuation?",">reference/cont.html#(def._((quote._~23~25kernel)._continuation~3f))",[0,[2,"continuation?"]],["racket/base","racket"]],
["continuations",">guide/Continuations.html","Continuations",false],
["continuations",">more/index.html#(part._.Continuations)","Continuations",false],
["continuations",">reference/cont.html","Continuations",false],
["continuations",">inside/exceptions.html#(idx._(gentag._316._(lib._scribblings/inside/inside..scrbl)))","continuations",false],
["continuations and event dispatch",">gui/windowing-overview.html#(part._evtcontjump)","Continuations and Event Dispatch",false],
["continue-backward-icon",">images/Icons.html#(def._((lib._images/icons/control..rkt)._continue-backward-icon))",[0,[2,"continue-backward-icon"]],["images/icons/control"]],
["continue-forward-icon",">images/Icons.html#(def._((lib._images/icons/control..rkt)._continue-forward-icon))",[0,[2,"continue-forward-icon"]],["images/icons/control"]],
["continue: web applications in racket",">continue/index.html","Continue: Web Applications in Racket",false],
["continues",">reference/bytestrings.html#(idx._(gentag._116._(lib._scribblings/reference/reference..scrbl)))",[7,"'continues"],false],
["continues",">reference/bytestrings.html#(idx._(gentag._120._(lib._scribblings/reference/reference..scrbl)))",[7,"'continues"],false],
["contour",">plot/porting.html#(def._((lib._plot/main..rkt)._contour))",[0,[2,"contour"]],["plot"]],
["contour",">plot/compat.html#(def._((lib._plot/compat..rkt)._contour))",[0,[2,"contour"]],["plot/compat"]],
["contour surfaces",">plot/params.html#(part._.Contour_.Surfaces)","Contour Surfaces",false],
["contour-alphas",">plot/params.html#(def._((lib._plot/main..rkt)._contour-alphas))",[0,[2,"contour-alphas"]],["plot"]],
["contour-colors",">plot/params.html#(def._((lib._plot/main..rkt)._contour-colors))",[0,[2,"contour-colors"]],["plot"]],
["contour-interval-alphas",">plot/params.html#(def._((lib._plot/main..rkt)._contour-interval-alphas))",[0,[2,"contour-interval-alphas"]],["plot"]],
["contour-interval-colors",">plot/params.html#(def._((lib._plot/main..rkt)._contour-interval-colors))",[0,[2,"contour-interval-colors"]],["plot"]],
["contour-interval-line-colors",">plot/params.html#(def._((lib._plot/main..rkt)._contour-interval-line-colors))",[0,[2,"contour-interval-line-colors"]],["plot"]],
["contour-interval-line-styles",">plot/params.html#(def._((lib._plot/main..rkt)._contour-interval-line-styles))",[0,[2,"contour-interval-line-styles"]],["plot"]],
["contour-interval-line-widths",">plot/params.html#(def._((lib._plot/main..rkt)._contour-interval-line-widths))",[0,[2,"contour-interval-line-widths"]],["plot"]],
["contour-interval-styles",">plot/params.html#(def._((lib._plot/main..rkt)._contour-interval-styles))",[0,[2,"contour-interval-styles"]],["plot"]],
["contour-intervals",">plot/renderer2d.html#(def._((lib._plot/main..rkt)._contour-intervals))",[0,[2,"contour-intervals"]],["plot"]],
["contour-intervals3d",">plot/renderer3d.html#(def._((lib._plot/main..rkt)._contour-intervals3d))",[0,[2,"contour-intervals3d"]],["plot"]],
["contour-levels",">plot/params.html#(def._((lib._plot/main..rkt)._contour-levels))",[0,[2,"contour-levels"]],["plot"]],
["contour-samples",">plot/params.html#(def._((lib._plot/main..rkt)._contour-samples))",[0,[2,"contour-samples"]],["plot"]],
["contour-styles",">plot/params.html#(def._((lib._plot/main..rkt)._contour-styles))",[0,[2,"contour-styles"]],["plot"]],
["contour-ticks",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._contour-ticks))",[0,[2,"contour-ticks"]],["plot"]],
["contour-widths",">plot/params.html#(def._((lib._plot/main..rkt)._contour-widths))",[0,[2,"contour-widths"]],["plot"]],
["contours",">plot/renderer2d.html#(def._((lib._plot/main..rkt)._contours))",[0,[2,"contours"]],["plot"]],
["contours and contour intervals",">plot/params.html#(part._.Contours_and_.Contour_.Intervals)","Contours and Contour Intervals",false],
["contours3d",">plot/renderer3d.html#(def._((lib._plot/main..rkt)._contours3d))",[0,[2,"contours3d"]],["plot"]],
["contract",">reference/attaching-contracts-to-values.html#(form._((lib._racket/contract/private/base..rkt)._contract))",[0,[1,"contract"]],["racket/contract/base","racket/contract","racket"]],
["contract combinator",">guide/contract-func.html#(tech._contract._combinator)","<span style=\"font-style: italic\">contract\ncombinator</span>",false],
["contract messages with \"???\"",">guide/contract-func.html#(part._contracts-flat-named-contracts)","Contract Messages with &ldquo;???&rdquo;",false],
["contract property",">reference/Building_New_Contract_Combinators.html#(tech._contract._property)","<span style=\"font-style: italic\">contract property</span>",false],
["contract utilities",">reference/contract-utilities.html","Contract Utilities",false],
["contract violations",">guide/contract-boundaries.html#(part._contracts-amount0)","Contract Violations",false],
["contract-first-order",">reference/Building_New_Contract_Combinators.html#(def._((lib._racket/contract/private/guts..rkt)._contract-first-order))",[0,[2,"contract-first-order"]],["racket/contract/combinator","racket/contract","racket"]],
["contract-first-order-passes?",">reference/Building_New_Contract_Combinators.html#(def._((lib._racket/contract/private/guts..rkt)._contract-first-order-passes~3f))",[0,[2,"contract-first-order-passes?"]],["racket/contract/combinator","racket/contract","racket"]],
["contract-name",">reference/contract-utilities.html#(def._((lib._racket/contract/private/misc..rkt)._contract-name))",[0,[2,"contract-name"]],["racket/contract/base","racket/contract","racket"]],
["contract-out",">reference/attaching-contracts-to-values.html#(form._((lib._racket/contract/base..rkt)._contract-out))",[0,[1,"contract-out"]],["racket/contract/base","racket/contract","racket"]],
["contract-proc",">reference/Legacy_Contracts.html#(def._((lib._racket/contract..rkt)._contract-proc))",[0,[2,"contract-proc"]],["racket/contract","racket"]],
["contract-projection",">reference/contract-utilities.html#(def._((lib._racket/contract/private/misc..rkt)._contract-projection))",[0,[2,"contract-projection"]],["racket/contract/base","racket/contract","racket"]],
["contract-property?",">reference/Building_New_Contract_Combinators.html#(def._((lib._racket/contract/private/prop..rkt)._contract-property~3f))",[0,[2,"contract-property?"]],["racket/contract/combinator","racket/contract","racket"]],
["contract-random-generate",">reference/Random_generation.html#(def._((lib._racket/contract..rkt)._contract-random-generate))",[0,[2,"contract-random-generate"]],["racket/contract","racket"]],
["contract-stronger?",">reference/Building_New_Contract_Combinators.html#(def._((lib._racket/contract/private/guts..rkt)._contract-stronger~3f))",[0,[2,"contract-stronger?"]],["racket/contract/combinator","racket/contract","racket"]],
["contract-struct",">reference/Lazy_Data-structure_Contracts.html#(form._((lib._racket/contract/private/ds..rkt)._contract-struct))",[0,[1,"contract-struct"]],["racket/contract","racket"]],
["contract?",">reference/contract-utilities.html#(def._((lib._racket/contract/private/misc..rkt)._contract~3f))",[0,[2,"contract?"]],["racket/contract/base","racket/contract","racket"]],
["contracted",">reference/creatingunits.html#(form._((lib._mzlib/unit..rkt)._contracted))",[0,[1,"contracted"]],["racket/unit","racket"]],
["contracts",">guide/contracts.html","Contracts",false],
["contracts",">reference/contracts.html","Contracts",false],
["contracts",">unstable/contract.html","Contracts",false],
["contracts",">reference/contracts.html#(tech._contract)","<span style=\"font-style: italic\">Contracts</span>",false],
["contracts and boundaries",">guide/contract-boundaries.html","Contracts and Boundaries",false],
["contracts and eq?",">guide/contracts-gotchas.html#(part._.Contracts_and_eq_)",["Contracts and ",[0,[2,"eq?"]]],false],
["contracts as structs",">reference/Building_New_Contract_Combinators.html#(part._.Contracts_as_structs)","Contracts as structs",false],
["contracts for case-lambda",">guide/contracts-general-functions.html#(part._contracts-case-lambda)",["Contracts for ",[0,[1,"case-lambda"]]],false],
["contracts for macro sub-expressions",">syntax/Experimental.html#(part._.Contracts_for_.Macro_.Sub-expressions)","Contracts for Macro Sub-expressions",false],
["contracts for macro subexpressions",">unstable/wrapc.html","Contracts for Macro Subexpressions",false],
["contracts for syntax classes",">syntax/Experimental.html#(part._.Contracts_for_.Syntax_.Classes)","Contracts for Syntax Classes",false],
["contracts for units",">guide/Contracts_for_Units.html","Contracts for Units",false],
["contracts on functions in general",">guide/contracts-general-functions.html","Contracts on Functions in General",false],
["contracts on higher-order functions",">guide/contract-func.html#(part._.Contracts_on_.Higher-order_.Functions)","Contracts on Higher-order Functions",false],
["contracts on macro sub-expressions",">syntax/exprc.html","Contracts on Macro Sub-expressions",false],
["contracts on structures",">guide/contracts-struct.html","Contracts on Structures",false],
["contracts: a thorough example",">guide/contracts-first.html","Contracts: A Thorough Example",false],
["control",">reference/cont.html#(form._((lib._racket/control..rkt)._control))",[0,[1,"control"]],["racket/control"]],
["control",">teachpack/arrow.html#(def._((lib._htdp/arrow..rkt)._control))",[0,[2,"control"]],["htdp/arrow"]],
["control",">teachpack/arrow-gui.html#(def._((lib._htdp/arrow-gui..rkt)._control))",[0,[2,"control"]],["htdp/arrow-gui"]],
["control",">teachpack/guess-gui.html#(def._((lib._htdp/guess-gui..rkt)._control))",[0,[2,"control"]],["htdp/guess-gui"]],
["control",">teachpack/lkup-gui.html#(def._((lib._htdp/lkup-gui..rkt)._control))",[0,[2,"control"]],["htdp/lkup-gui"]],
["control",">gui/key-event_.html#(idx._(gentag._43._(lib._scribblings/gui/gui..scrbl)))",[7,"'control"],false],
["control flow",">reference/control.html","Control Flow",false],
["control icons",">images/Icons.html#(part._control)","Control Icons",false],
["control snips",">embedded-gui/control-snips.html","Control Snips",false],
["control-at",">reference/cont.html#(form._((lib._racket/control..rkt)._control-at))",[0,[1,"control-at"]],["racket/control"]],
["control-event%",">gui/control-event_.html",[0,[2,"control-event%"]],["racket/gui/base","racket/gui"]],
["control-left-right",">teachpack/arrow.html#(def._((lib._htdp/arrow..rkt)._control-left-right))",[0,[2,"control-left-right"]],["htdp/arrow"]],
["control-up-down",">teachpack/arrow.html#(def._((lib._htdp/arrow..rkt)._control-up-down))",[0,[2,"control-up-down"]],["htdp/arrow"]],
["control0",">reference/cont.html#(form._((lib._racket/control..rkt)._control0))",[0,[1,"control0"]],["racket/control"]],
["control0-at",">reference/cont.html#(form._((lib._racket/control..rkt)._control0-at))",[0,[1,"control0-at"]],["racket/control"]],
["control<%>",">gui/control___.html",[0,[2,"control<%>"]],["racket/gui/base","racket/gui"]],
["controlling an elevator: \"elevator.ss\"",">teachpack/elevator.html",["Controlling an Elevator: ",[6,"\"elevator.ss\""],"<a name=\"(idx._(gentag._15._(lib._teachpack/teachpack..scrbl)))\"></a>"],false],
["controlling raco setup with \"info.rkt\" files",">raco/running.html#(part._setup-info)",["Controlling ",[6,"raco setup"]," with ",[6,"\"info.rkt\""]," Files"],false],
["controlling syntax templates",">syntax/transformer-helpers.html#(part._template)","Controlling Syntax Templates",false],
["controlling the scope of external names",">guide/classes.html#(part._extnames)","Controlling the Scope of External Names",false],
["controls",">embedded-gui/controls.html","Controls",false],
["controls",">games/gobblet.html#(part._.Controls)","Controls",false],
["controls",">gui/windowing-overview.html#(tech._control)","<span style=\"font-style: italic\">Controls</span>",false],
["conventions",">syntax/Literal_Sets_and_Conventions.html#(tech._convention)","<span style=\"font-style: italic\">conventions</span>",false],
["conversion and construction",">images/Conversion_and_Construction.html","Conversion and Construction",false],
["conversion example",">web-server/templates.html#(part._.Conversion_.Example)","Conversion Example",false],
["conversion to picts",">slideshow/Conversion_to_Picts.html","Conversion to Picts",false],
["convert",">gui/style-list_.html#(meth._(((lib._racket/snip..rkt)._style-list~25)._convert))",[[0,[2,"convert"]],[14,[" (method of ",[0,[2,"style-list%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["convert",">file/convertible.html#(def._((lib._file/convertible..rkt)._convert))",[0,[2,"convert"]],["file/convertible"]],
["convert teachpack",">teachpack/convert.html#(idx._(gentag._2._(lib._teachpack/teachpack..scrbl)))","convert teachpack",false],
["convert-file",">teachpack/convert.html#(def._((lib._htdp/convert..rkt)._convert-file))",[0,[2,"convert-file"]],["htdp/convert"]],
["convert-gui",">teachpack/convert.html#(def._((lib._htdp/convert..rkt)._convert-gui))",[0,[2,"convert-gui"]],["htdp/convert"]],
["convert-relative-module-path",">reference/stxtrans.html#(def._((lib._racket/require-transform..rkt)._convert-relative-module-path))",[0,[2,"convert-relative-module-path"]],["racket/require-transform"]],
["convert-repl",">teachpack/convert.html#(def._((lib._htdp/convert..rkt)._convert-repl))",[0,[2,"convert-repl"]],["htdp/convert"]],
["convert-stream",">reference/port-lib.html#(def._((lib._racket/port..rkt)._convert-stream))",[0,[2,"convert-stream"]],["racket/port","racket"]],
["convertible: data-conversion protocol",">file/convertible.html","Convertible: Data-Conversion Protocol",false],
["convertible?",">file/convertible.html#(def._((lib._file/convertible..rkt)._convertible~3f))",[0,[2,"convertible?"]],["file/convertible"]],
["converting temperatures: \"convert.ss\"",">teachpack/convert.html",["Converting Temperatures: ",[6,"\"convert.ss\""],"<a name=\"(idx._(gentag._2._(lib._teachpack/teachpack..scrbl)))\"></a>"],false],
["converting values to strings",">unstable/cat.html","Converting Values to Strings",false],
["converting yacc or bison grammars",">parser-tools/Converting_yacc_or_bison_Grammars.html",["Converting ",[6,"yacc"]," or ",[6,"bison"]," Grammars"],false],
["cookie signature",">net/cookie.html#(part._.Cookie_.Signature)","Cookie Signature",false],
["cookie unit",">net/cookie.html#(part._.Cookie_.Unit)","Cookie Unit",false],
["cookie->header",">web-server/http.html#(def._((lib._web-server/http/cookie..rkt)._cookie-~3eheader))",[0,[2,"cookie->header"]],["web-server/http/cookie"]],
["cookie-error",">net/cookie.html#(def._((lib._net/cookie..rkt)._cookie-error))",[0,[2,"cookie-error"]],["net/cookie"]],
["cookie-error?",">net/cookie.html#(def._((lib._net/cookie..rkt)._cookie-error~3f))",[0,[2,"cookie-error?"]],["net/cookie"]],
["cookie-name?",">net/cookie.html#(def._((lib._net/cookie..rkt)._cookie-name~3f))",[0,[2,"cookie-name?"]],["net/cookie"]],
["cookie-value?",">net/cookie.html#(def._((lib._net/cookie..rkt)._cookie-value~3f))",[0,[2,"cookie-value?"]],["net/cookie"]],
["cookie: http client storage",">net/cookie.html","Cookie: HTTP Client Storage",false],
["cookie:add-comment",">net/cookie.html#(def._((lib._net/cookie..rkt)._cookie~3aadd-comment))",[0,[2,"cookie:add-comment"]],["net/cookie"]],
["cookie:add-domain",">net/cookie.html#(def._((lib._net/cookie..rkt)._cookie~3aadd-domain))",[0,[2,"cookie:add-domain"]],["net/cookie"]],
["cookie:add-max-age",">net/cookie.html#(def._((lib._net/cookie..rkt)._cookie~3aadd-max-age))",[0,[2,"cookie:add-max-age"]],["net/cookie"]],
["cookie:add-path",">net/cookie.html#(def._((lib._net/cookie..rkt)._cookie~3aadd-path))",[0,[2,"cookie:add-path"]],["net/cookie"]],
["cookie:secure",">net/cookie.html#(def._((lib._net/cookie..rkt)._cookie~3asecure))",[0,[2,"cookie:secure"]],["net/cookie"]],
["cookie:version",">net/cookie.html#(def._((lib._net/cookie..rkt)._cookie~3aversion))",[0,[2,"cookie:version"]],["net/cookie"]],
["cookie?",">net/cookie.html#(def._((lib._net/cookie..rkt)._cookie~3f))",[0,[2,"cookie?"]],["net/cookie"]],
["cookie@",">net/cookie.html#(def._((lib._net/cookie-unit..rkt)._cookie~40))",[0,[2,"cookie@"]],["net/cookie-unit"]],
["cookie^",">net/cookie.html#(form._((lib._net/cookie-sig..rkt)._cookie~5e))",[0,[1,"cookie^"]],["net/cookie-sig"]],
["cooperating with 3m",">inside/im_memoryalloc.html#(part._im~3a3m)","Cooperating with 3m",false],
["coord",">unstable/ppict.html#(def._((lib._unstable/gui/ppict..rkt)._coord))",[0,[2,"coord"]],["unstable/gui/ppict"]],
["coords->index",">images/Struct_Type_and_Accessors.html#(def._((lib._images/flomap..rkt)._coords-~3eindex))",[0,[2,"coords->index"]],["images/flomap"]],
["copy",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._copy))",[[0,[2,"copy"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["copy",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._copy))",[[0,[2,"copy"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["copy",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._copy))",[[0,[2,"copy"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["copy",">gui/snip_.html#(meth._(((lib._racket/snip..rkt)._snip~25)._copy))",[[0,[2,"copy"]],[14,[" (method of ",[0,[2,"snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["copy",">gui/style-delta_.html#(meth._(((lib._racket/snip..rkt)._style-delta~25)._copy))",[[0,[2,"copy"]],[14,[" (method of ",[0,[2,"style-delta%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["copy",">framework/editor-snip.html#(meth._(((lib._framework/main..rkt)._editor-snip~3adecorated~25)._copy))",[[0,[2,"copy"]],[14,[" (method of ",[0,[2,"editor-snip:decorated%"]],")"]]],["framework"]],
["copy",">framework/Racket.html#(meth._(((lib._framework/main..rkt)._racket~3asexp-snip~25)._copy))",[[0,[2,"copy"]],[14,[" (method of ",[0,[2,"racket:sexp-snip%"]],")"]]],["framework"]],
["copy",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3a1-pixel-string-snip~25)._copy))",[[0,[2,"copy"]],[14,[" (method of ",[0,[2,"text:1-pixel-string-snip%"]],")"]]],["framework"]],
["copy",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3a1-pixel-tab-snip~25)._copy))",[[0,[2,"copy"]],[14,[" (method of ",[0,[2,"text:1-pixel-tab-snip%"]],")"]]],["framework"]],
["copy",">cards/index.html#(meth._(((lib._games/cards..rkt)._card~3c~25~3e)._copy))",[[0,[2,"copy"]],[14,[" (method of ",[0,[2,"card<%>"]],")"]]],["games/cards"]],
["copy menu item",">drracket/Menus.html#(idx._(gentag._74._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Copy</span> menu item",false],
["copy-click-region",">framework/Keymap.html#(idx._(gentag._33._(lib._scribblings/framework/framework..scrbl)))","copy-click-region",false],
["copy-clipboard",">framework/Keymap.html#(idx._(gentag._30._(lib._scribblings/framework/framework..scrbl)))","copy-clipboard",false],
["copy-directory/files",">reference/Filesystem.html#(def._((lib._racket/file..rkt)._copy-directory/files))",[0,[2,"copy-directory/files"]],["racket/file","racket"]],
["copy-file",">reference/Filesystem.html#(def._((quote._~23~25kernel)._copy-file))",[0,[2,"copy-file"]],["racket/base","racket"]],
["copy-from",">draw/color_.html#(meth._(((lib._racket/draw..rkt)._color~25)._copy-from))",[[0,[2,"copy-from"]],[14,[" (method of ",[0,[2,"color%"]],")"]]],["racket/draw"]],
["copy-from",">draw/ps-setup_.html#(meth._(((lib._racket/draw..rkt)._ps-setup~25)._copy-from))",[[0,[2,"copy-from"]],[14,[" (method of ",[0,[2,"ps-setup%"]],")"]]],["racket/draw"]],
["copy-port",">reference/port-lib.html#(def._((lib._racket/port..rkt)._copy-port))",[0,[2,"copy-port"]],["racket/port","racket"]],
["copy-self",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._copy-self))",[[0,[2,"copy-self"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["copy-self-to",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._copy-self-to))",[[0,[2,"copy-self-to"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["copy-self-to",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._copy-self-to))",[[0,[2,"copy-self-to"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["copy-self-to",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._copy-self-to))",[[0,[2,"copy-self-to"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["copy-struct",">mzlib/mzlib_struct.html#(form._((lib._mzlib/struct..rkt)._copy-struct))",[0,[1,"copy-struct"]],["mzlib/struct"]],
["copy-time",">srfi-std/srfi-19.html#copy-time",[0,[2,"copy-time"]],["srfi/19"]],
["copy-viewport",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..rkt)._copy-viewport))",[0,[2,"copy-viewport"]],["graphics/graphics"]],
["copying and update",">guide/define-struct.html#(part._struct-copy)","Copying and Update",false],
["copying and updating structures",">reference/struct-copy.html","Copying and Updating Structures",false],
["copying streams",">reference/port-lib.html#(part._.Copying_.Streams)","Copying Streams",false],
["copyrightdata",">scribble/SIGPLAN_Paper_Format.html#(def._((lib._scribble/sigplan..rkt)._copyrightdata))",[0,[2,"copyrightdata"]],["scribble/sigplan"]],
["copyrightyear",">scribble/SIGPLAN_Paper_Format.html#(def._((lib._scribble/sigplan..rkt)._copyrightyear))",[0,[2,"copyrightyear"]],["scribble/sigplan"]],
["core windowing classes",">gui/windowing-overview.html#(part._.Core_.Windowing_.Classes)","Core Windowing Classes",false],
["coroutine",">mzlib/mzlib_thread.html#(def._((lib._mzlib/thread..rkt)._coroutine))",[0,[2,"coroutine"]],["mzlib/thread"]],
["coroutine-kill",">mzlib/mzlib_thread.html#(def._((lib._mzlib/thread..rkt)._coroutine-kill))",[0,[2,"coroutine-kill"]],["mzlib/thread"]],
["coroutine-result",">mzlib/mzlib_thread.html#(def._((lib._mzlib/thread..rkt)._coroutine-result))",[0,[2,"coroutine-result"]],["mzlib/thread"]],
["coroutine-run",">mzlib/mzlib_thread.html#(def._((lib._mzlib/thread..rkt)._coroutine-run))",[0,[2,"coroutine-run"]],["mzlib/thread"]],
["coroutine?",">mzlib/mzlib_thread.html#(def._((lib._mzlib/thread..rkt)._coroutine~3f))",[0,[2,"coroutine?"]],["mzlib/thread"]],
["correct-xexpr?",">xml/index.html#(def._((lib._xml/main..rkt)._correct-xexpr~3f))",[0,[2,"correct-xexpr?"]],["xml"]],
["cos",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._cos))",[0,[2,"cos"]],["racket/base","racket"]],
["cos",">r5rs-std/r5rs-Z-H-9.html#%_idx_332",[0,[2,"cos"]],["r5rs"]],
["cos",">r6rs-std/r6rs-Z-H-14.html#node_idx_548",[0,[2,"cos"]],["rnrs/base-6"]],
["cos",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._cos))",[0,[2,"cos"]],["lang/htdp-advanced"]],
["cos",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._cos))",[0,[2,"cos"]],["lang/htdp-beginner"]],
["cos",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._cos))",[0,[2,"cos"]],["lang/htdp-beginner-abbr"]],
["cos",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._cos))",[0,[2,"cos"]],["lang/htdp-intermediate"]],
["cos",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._cos))",[0,[2,"cos"]],["lang/htdp-intermediate-lambda"]],
["cos",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._cos))",[0,[2,"cos"]],["deinprogramm/DMdA-advanced"]],
["cos",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._cos))",[0,[2,"cos"]],["deinprogramm/DMdA-assignments"]],
["cos",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._cos))",[0,[2,"cos"]],["deinprogramm/DMdA-beginner"]],
["cos",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._cos))",[0,[2,"cos"]],["deinprogramm/DMdA-vanilla"]],
["cosh",">reference/generic-numbers.html#(def._((lib._racket/math..rkt)._cosh))",[0,[2,"cosh"]],["racket/math","racket"]],
["cosh",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._cosh))",[0,[2,"cosh"]],["lang/htdp-advanced"]],
["cosh",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._cosh))",[0,[2,"cosh"]],["lang/htdp-beginner"]],
["cosh",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._cosh))",[0,[2,"cosh"]],["lang/htdp-beginner-abbr"]],
["cosh",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._cosh))",[0,[2,"cosh"]],["lang/htdp-intermediate"]],
["cosh",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._cosh))",[0,[2,"cosh"]],["lang/htdp-intermediate-lambda"]],
["cosine",">htdp-langs/beginner-abbr.html#(idx._htdp-beginner-abbr._(gentag._22._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-beginner-abbr))","cosine",false],
["cosine",">htdp-langs/intermediate.html#(idx._htdp-intermediate._(gentag._31._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-intermediate))","cosine",false],
["cosine",">htdp-langs/intermediate-lam.html#(idx._htdp-intermediate-lambda._(gentag._40._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-intermediate-lambda))","cosine",false],
["cosine",">htdp-langs/advanced.html#(idx._htdp-advanced._(gentag._49._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-advanced))","cosine",false],
["cosine",">htdp-langs/beginner.html#(idx._htdp-beginner._(gentag._7._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-beginner))","cosine",false],
["count",">reference/pairs.html#(def._((lib._racket/list..rkt)._count))",[0,[2,"count"]],["racket/list","racket"]],
["count",">srfi-std/srfi-1.html#count",[0,[2,"count"]],["srfi/1"]],
["count",">gui/editor-overview.html#(tech._count)","<span style=\"font-style: italic\">count</span>",false],
["counterexample",">redex/The_Redex_Reference.html#(def._((lib._redex/reduction-semantics..rkt)._counterexample))",[0,[2,"counterexample"]],["redex/reduction-semantics","redex"]],
["counterexample-term",">redex/The_Redex_Reference.html#(def._((lib._redex/reduction-semantics..rkt)._counterexample-term))",[0,[2,"counterexample-term"]],["redex/reduction-semantics","redex"]],
["counterexample?",">redex/The_Redex_Reference.html#(def._((lib._redex/reduction-semantics..rkt)._counterexample~3f))",[0,[2,"counterexample?"]],["redex/reduction-semantics","redex"]],
["counting positions, lines, and columns",">reference/linecol.html","Counting Positions, Lines, and Columns",false],
["coverage",">errortrace/using-errortrace.html#(part._coverage)","Coverage",false],
["coverage-counts-enabled",">errortrace/using-errortrace.html#(def._((lib._errortrace/errortrace-lib..rkt)._coverage-counts-enabled))",[0,[2,"coverage-counts-enabled"]],["errortrace"]],
["coverage?",">redex/The_Redex_Reference.html#(def._((lib._redex/reduction-semantics..rkt)._coverage~3f))",[0,"coverage?"],["redex/reduction-semantics","redex"]],
["covered-cases",">redex/The_Redex_Reference.html#(def._((lib._redex/reduction-semantics..rkt)._covered-cases))",[0,[2,"covered-cases"]],["redex/reduction-semantics","redex"]],
["cpointer-has-tag?",">foreign/foreign_tagged-pointers.html#(def._((lib._ffi/unsafe..rkt)._cpointer-has-tag~3f))",[0,[2,"cpointer-has-tag?"]],["ffi/unsafe"]],
["cpointer-push-tag!",">foreign/foreign_tagged-pointers.html#(def._((lib._ffi/unsafe..rkt)._cpointer-push-tag!))",[0,[2,"cpointer-push-tag!"]],["ffi/unsafe"]],
["cpointer-tag",">foreign/foreign_pointer-funcs.html#(def._((quote._~23~25foreign)._cpointer-tag))",[0,[2,"cpointer-tag"]],["ffi/unsafe"]],
["cpointer?",">foreign/foreign_pointer-funcs.html#(def._((quote._~23~25foreign)._cpointer~3f))",[0,[2,"cpointer?"]],["ffi/unsafe"]],
["crazy 8s --- card game",">games/crazy8s.html",[[15,"<img src=\"crazy8s.png\" alt=\"\" />"]," ","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Crazy 8s</span>"," ","&#8212;","<wbr></wbr>"," Card Game"],false],
["create",">planet/cmdline.html#(part._create)",[6,"create"],false],
["create an \"info.rkt\" file [optional]",">planet/Developing_Packages_for_PLaneT.html#(part._.Create_an__info_rkt__.File__.Optional_)",["Create an ",[6,"\"info.rkt\""]," File [Optional]"],false],
["create documentation [optional]",">planet/Developing_Packages_for_PLaneT.html#(part._.Create_.Documentation__.Optional_)","Create Documentation [Optional]",false],
["create executable... menu item",">drracket/Menus.html#(idx._(gentag._127._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Create Executable...</span> menu item",false],
["create-box",">deinprogramm/line3d.html#(def._((lib._teachpack/deinprogramm/line3d..rkt)._create-box))",[0,[2,"create-box"]],["teachpack/deinprogramm/line3d"]],
["create-camera-matrix",">deinprogramm/line3d.html#(def._((lib._teachpack/deinprogramm/line3d..rkt)._create-camera-matrix))",[0,[2,"create-camera-matrix"]],["teachpack/deinprogramm/line3d"]],
["create-dir",">teachpack/dir.html#(def._((lib._htdp/dir..rkt)._create-dir))",[0,[2,"create-dir"]],["htdp/dir"]],
["create-embedding-executable",">raco/exe.html#(def._((lib._compiler/embed..rkt)._create-embedding-executable))",[0,[2,"create-embedding-executable"]],["compiler/embed"]],
["create-executable",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3alanguage~3c~25~3e)._create-executable))",[[0,[2,"create-executable"]],[14,[" (method of ",[0,[2,"drracket:language:language<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["create-lookat-matrix",">deinprogramm/line3d.html#(def._((lib._teachpack/deinprogramm/line3d..rkt)._create-lookat-matrix))",[0,[2,"create-lookat-matrix"]],["teachpack/deinprogramm/line3d"]],
["create-lru-manager",">web-server/servlet.html#(def._((lib._web-server/managers/lru..rkt)._create-.L.R.U-manager))",[0,[2,"create-LRU-manager"]],["web-server/managers/lru"]],
["create-matrix4x4",">deinprogramm/line3d.html#(def._((lib._teachpack/deinprogramm/line3d..rkt)._create-matrix4x4))",[0,[2,"create-matrix4x4"]],["teachpack/deinprogramm/line3d"]],
["create-new-tab",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aframe~3c~25~3e)._create-new-tab))",[[0,[2,"create-new-tab"]],[14,[" (method of ",[0,[2,"drracket:unit:frame<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["create-none-manager",">web-server/servlet.html#(def._((lib._web-server/managers/none..rkt)._create-none-manager))",[0,[2,"create-none-manager"]],["web-server/managers/none"]],
["create-place-node",">reference/distributed-places.html#(def._((lib._racket/place/distributed..rkt)._create-place-node))",[0,[2,"create-place-node"]],["racket/place/distributed"]],
["create-projection-matrix",">deinprogramm/line3d.html#(def._((lib._teachpack/deinprogramm/line3d..rkt)._create-projection-matrix))",[0,[2,"create-projection-matrix"]],["teachpack/deinprogramm/line3d"]],
["create-rotation-x-matrix",">deinprogramm/line3d.html#(def._((lib._teachpack/deinprogramm/line3d..rkt)._create-rotation-x-matrix))",[0,[2,"create-rotation-x-matrix"]],["teachpack/deinprogramm/line3d"]],
["create-rotation-y-matrix",">deinprogramm/line3d.html#(def._((lib._teachpack/deinprogramm/line3d..rkt)._create-rotation-y-matrix))",[0,[2,"create-rotation-y-matrix"]],["teachpack/deinprogramm/line3d"]],
["create-rotation-z-matrix",">deinprogramm/line3d.html#(def._((lib._teachpack/deinprogramm/line3d..rkt)._create-rotation-z-matrix))",[0,[2,"create-rotation-z-matrix"]],["teachpack/deinprogramm/line3d"]],
["create-sampler",">profile/index.html#(def._((lib._profile/sampler..rkt)._create-sampler))",[0,[2,"create-sampler"]],["profile/sampler"]],
["create-status-line",">gui/frame_.html#(meth._(((lib._mred/main..rkt)._frame~25)._create-status-line))",[[0,[2,"create-status-line"]],[14,[" (method of ",[0,[2,"frame%"]],")"]]],["racket/gui/base","racket/gui"]],
["create-status-pane",">cards/index.html#(meth._(((lib._games/cards..rkt)._table~3c~25~3e)._create-status-pane))",[[0,[2,"create-status-pane"]],[14,[" (method of ",[0,[2,"table<%>"]],")"]]],["games/cards"]],
["create-timeout-manager",">web-server/servlet.html#(def._((lib._web-server/managers/timeouts..rkt)._create-timeout-manager))",[0,[2,"create-timeout-manager"]],["web-server/managers/timeouts"]],
["create-translation-matrix",">deinprogramm/line3d.html#(def._((lib._teachpack/deinprogramm/line3d..rkt)._create-translation-matrix))",[0,[2,"create-translation-matrix"]],["teachpack/deinprogramm/line3d"]],
["create-viewport-matrix",">deinprogramm/line3d.html#(def._((lib._teachpack/deinprogramm/line3d..rkt)._create-viewport-matrix))",[0,[2,"create-viewport-matrix"]],["teachpack/deinprogramm/line3d"]],
["create-window",">teachpack/gui.html#(def._((lib._htdp/gui..rkt)._create-window))",[0,[2,"create-window"]],["htdp/gui"]],
["creating a cookie",">net/cookie.html#(part._.Creating_a_cookie)","Creating a cookie",false],
["creating a lexer",">parser-tools/Lexers.html#(part._.Creating_a_.Lexer)","Creating a Lexer",false],
["creating and installing namespaces",">guide/mk-namespace.html#(part._.Creating_and_.Installing_.Namespaces)","Creating and Installing Namespaces",false],
["creating and setting the eventspace",">gui/windowing-overview.html#(part._currenteventspace)","Creating and Setting the Eventspace",false],
["creating basic shapes",">teachpack/image.html#(part._creational)","Creating Basic Shapes",false],
["creating classes",">reference/createclass.html","Creating Classes",false],
["creating executables",">drracket/create-exe.html","Creating Executables",false],
["creating executables",">guide/intro.html#(part._.Creating_.Executables)","Creating Executables",false],
["creating formatted identifiers",">reference/syntax-util.html#(part._.Creating_formatted_identifiers)","Creating formatted identifiers",false],
["creating interfaces",">reference/createinterface.html","Creating Interfaces",false],
["creating languages",">guide/languages.html","Creating Languages",false],
["creating launchers",">raco/exe.html#(part._.Creating_.Launchers)","Creating Launchers",false],
["creating loggers",">reference/logging.html#(part._.Creating_.Loggers)","Creating Loggers",false],
["creating new kinds of drracket frames",">tools/Creating_New_Kinds_of_DrRacket_Frames.html","Creating New Kinds of DrRacket Frames",false],
["creating new kinds of statements",">db/query-api.html#(part._.Creating_.New_.Kinds_of_.Statements)","Creating New Kinds of Statements",false],
["creating objects",">reference/objcreation.html","Creating Objects",false],
["creating ports",">reference/port-lib.html#(part._.Creating_.Ports)","Creating Ports",false],
["creating slide presentations",">slideshow/Creating_Slide_Presentations.html","Creating Slide Presentations",false],
["creating stand-alone executables",">guide/exe.html","Creating Stand-Alone Executables",false],
["creating structure types",">reference/creatingmorestructs.html","Creating Structure Types",false],
["creating tables and cards",">cards/index.html#(part._.Creating_.Tables_and_.Cards)","Creating Tables and Cards",false],
["creating threads",">reference/threads.html#(part._.Creating_.Threads)","Creating Threads",false],
["creating units",">reference/creatingunits.html","Creating Units",false],
["creating windows",">gui/windowing-overview.html#(part._.Creating_.Windows)","Creating Windows",false],
["creation tree",">reference/futures-visualizer.html#(tech._creation._tree)","<span style=\"font-style: italic\">creation tree</span>",false],
["creation-tree-pict",">reference/futures-visualizer.html#(def._((lib._future-visualizer/main..rkt)._creation-tree-pict))",[0,"creation-tree-pict"],["future-visualizer"]],
["crop",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._crop))",[0,[2,"crop"]],["2htdp/image"]],
["crop-bottom",">picturing-programs/index.html#(def._((lib._picturing-programs/private/tiles..rkt)._crop-bottom))",[0,[2,"crop-bottom"]],["picturing-programs/private/tiles","picturing-programs"]],
["crop-left",">picturing-programs/index.html#(def._((lib._picturing-programs/private/tiles..rkt)._crop-left))",[0,[2,"crop-left"]],["picturing-programs/private/tiles","picturing-programs"]],
["crop-right",">picturing-programs/index.html#(def._((lib._picturing-programs/private/tiles..rkt)._crop-right))",[0,[2,"crop-right"]],["picturing-programs/private/tiles","picturing-programs"]],
["crop-top",">picturing-programs/index.html#(def._((lib._picturing-programs/private/tiles..rkt)._crop-top))",[0,[2,"crop-top"]],["picturing-programs/private/tiles","picturing-programs"]],
["cross",">web-server/formlets.html#(def._((lib._web-server/formlets/lib..rkt)._cross))",[0,[2,"cross"]],["web-server/formlets/lib"]],
["cross",">redex/The_Redex_Reference.html#(tech._cros)",[0,"cross"],false],
["cross*",">web-server/formlets.html#(def._((lib._web-server/formlets/lib..rkt)._cross*))",[0,[2,"cross*"]],["web-server/formlets/lib"]],
["cross-hatch",">draw/brush_.html#(idx._(gentag._20._(lib._scribblings/draw/draw..scrbl)))",[7,"'cross-hatch"],false],
["cross-reference utilities",">scribble/xref.html","Cross-Reference Utilities",false],
["cross-site scripting (xss)",">db/using-db.html#(part._dbsec-xss)","Cross-site Scripting (XSS)",false],
["crossdiag-hatch",">draw/brush_.html#(idx._(gentag._18._(lib._scribblings/draw/draw..scrbl)))",[7,"'crossdiag-hatch"],false],
["crossproduct-vec3",">deinprogramm/line3d.html#(def._((lib._teachpack/deinprogramm/line3d..rkt)._crossproduct-vec3))",[0,[2,"crossproduct-vec3"]],["teachpack/deinprogramm/line3d"]],
["cs",">reference/characters.html#(idx._(gentag._150._(lib._scribblings/reference/reference..scrbl)))",[7,"'cs"],false],
["css-addition",">scribble/core.html#(def._((lib._scribble/html-properties..rkt)._css-addition))",[0,[2,"css-addition"]],["scribble/html-properties"]],
["css-addition-path",">scribble/core.html#(def._((lib._scribble/html-properties..rkt)._css-addition-path))",[0,[2,"css-addition-path"]],["scribble/html-properties"]],
["css-addition?",">scribble/core.html#(def._((lib._scribble/html-properties..rkt)._css-addition~3f))",[0,[2,"css-addition?"]],["scribble/html-properties"]],
["ct-find",">slideshow/Pict_Finders.html#(def._((lib._slideshow/pict..rkt)._ct-find))",[0,[2,"ct-find"]],["slideshow/pict","slideshow"]],
["ct-superimpose",">slideshow/Pict_Combiners.html#(def._((lib._slideshow/pict..rkt)._ct-superimpose))",[0,[2,"ct-superimpose"]],["slideshow/pict","slideshow"]],
["ctl-find",">slideshow/Pict_Finders.html#(def._((lib._slideshow/pict..rkt)._ctl-find))",[0,[2,"ctl-find"]],["slideshow/pict","slideshow"]],
["ctl-superimpose",">slideshow/Pict_Combiners.html#(def._((lib._slideshow/pict..rkt)._ctl-superimpose))",[0,[2,"ctl-superimpose"]],["slideshow/pict","slideshow"]],
["ctype->layout",">foreign/ctype.html#(def._((lib._ffi/unsafe..rkt)._ctype-~3elayout))",[0,[2,"ctype->layout"]],["ffi/unsafe"]],
["ctype-alignof",">foreign/ctype.html#(def._((quote._~23~25foreign)._ctype-alignof))",[0,[2,"ctype-alignof"]],["ffi/unsafe"]],
["ctype-basetype",">foreign/foreign_c-only.html#(def._((quote._~23~25foreign)._ctype-basetype))",[0,[2,"ctype-basetype"]],["'#%foreign"]],
["ctype-c->scheme",">foreign/foreign_c-only.html#(def._((quote._~23~25foreign)._ctype-c-~3escheme))",[0,[2,"ctype-c->scheme"]],["'#%foreign"]],
["ctype-scheme->c",">foreign/foreign_c-only.html#(def._((quote._~23~25foreign)._ctype-scheme-~3ec))",[0,[2,"ctype-scheme->c"]],["'#%foreign"]],
["ctype-sizeof",">foreign/ctype.html#(def._((quote._~23~25foreign)._ctype-sizeof))",[0,[2,"ctype-sizeof"]],["ffi/unsafe"]],
["ctype?",">foreign/ctype.html#(def._((quote._~23~25foreign)._ctype~3f))",[0,[2,"ctype?"]],["ffi/unsafe"]],
["cube operations",">games/gcalc.html#(part._.Cube_operations)","Cube operations",false],
["cue-text%",">embedded-gui/Helpers.html#(def._((lib._embedded-gui/main..rkt)._cue-text~25))",[0,[2,"cue-text%"]],["embedded-gui"]],
["cue-text-mixin",">embedded-gui/Helpers.html#(def._((lib._embedded-gui/main..rkt)._cue-text-mixin))",[0,[2,"cue-text-mixin"]],["embedded-gui"]],
["cupto",">reference/cont.html#(form._((lib._racket/control..rkt)._cupto))",[0,[1,"cupto"]],["racket/control"]],
["curly-quotes-for-strings",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._curly-quotes-for-strings))",[0,[2,"curly-quotes-for-strings"]],["redex/pict","redex"]],
["currency ticks",">plot/ticks_and_transforms.html#(part._.Currency_.Ticks)","Currency Ticks",false],
["currency-ticks",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._currency-ticks))",[0,[2,"currency-ticks"]],["plot"]],
["currency-ticks-format",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._currency-ticks-format))",[0,[2,"currency-ticks-format"]],["plot"]],
["currency-ticks-formats",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._currency-ticks-formats))",[0,[2,"currency-ticks-formats"]],["plot"]],
["currency-ticks-scales",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._currency-ticks-scales))",[0,[2,"currency-ticks-scales"]],["plot"]],
["current continuation",">guide/Continuations.html#(tech._current._continuation)","<span style=\"font-style: italic\">current continuation</span>",false],
["current custodian",">reference/eval-model.html#(tech._current._custodian)","<span style=\"font-style: italic\">current\ncustodian</span>",false],
["current eventspace",">gui/windowing-overview.html#(tech._current._eventspace)","<span style=\"font-style: italic\">current eventspace</span>",false],
["current logger",">reference/logging.html#(tech._current._logger)","<span style=\"font-style: italic\">current logger</span>",false],
["current namespace",">guide/eval.html#(tech._current._namespace)","<span style=\"font-style: italic\">current namespace</span>",false],
["current namespace",">reference/syntax-model.html#(tech._current._namespace)","<span style=\"font-style: italic\">current namespace</span>",false],
["current working directory",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._518._(lib._scribblings/inside/inside..scrbl)))","current working directory",false],
["current-alist-separator-mode",">net/uri-codec.html#(def._((lib._net/uri-codec..rkt)._current-alist-separator-mode))",[0,[2,"current-alist-separator-mode"]],["net/uri-codec"]],
["current-annotations",">tools/Check_Syntax.html#(def._((lib._drracket/check-syntax..rkt)._current-annotations))",[0,[2,"current-annotations"]],["drracket/check-syntax"]],
["current-base-color",">slideshow/Typesetting_Racket_Code.html#(def._((lib._slideshow/code..rkt)._current-base-color))",[0,[2,"current-base-color"]],["slideshow/code"]],
["current-blame-format",">reference/Building_New_Contract_Combinators.html#(def._((lib._racket/contract/private/blame..rkt)._current-blame-format))",[0,[2,"current-blame-format"]],["racket/contract/combinator","racket/contract","racket"]],
["current-break-parameterization",">reference/breakhandler.html#(def._((lib._racket/private/more-scheme..rkt)._current-break-parameterization))",[0,[2,"current-break-parameterization"]],["racket/base","racket"]],
["current-build-share-hook",">mzlib/mzlib_pconvert.html#(def._((lib._mzlib/pconvert..rkt)._current-build-share-hook))",[0,[2,"current-build-share-hook"]],["mzlib/pconvert"]],
["current-build-share-name-hook",">mzlib/mzlib_pconvert.html#(def._((lib._mzlib/pconvert..rkt)._current-build-share-name-hook))",[0,[2,"current-build-share-name-hook"]],["mzlib/pconvert"]],
["current-cache-all?",">redex/The_Redex_Reference.html#(def._((lib._redex/reduction-semantics..rkt)._current-cache-all~3f))",[0,[2,"current-cache-all?"]],["redex/reduction-semantics","redex"]],
["current-cache-contents",">planet/Utility_Libraries.html#(def._((lib._planet/util..rkt)._current-cache-contents))",[0,[2,"current-cache-contents"]],["planet/util"]],
["current-check-around",">rackunit/internals.html#(def._((lib._rackunit/main..rkt)._current-check-around))",[0,[2,"current-check-around"]],["rackunit"]],
["current-check-handler",">rackunit/internals.html#(def._((lib._rackunit/main..rkt)._current-check-handler))",[0,[2,"current-check-handler"]],["rackunit"]],
["current-code-font",">slideshow/Typesetting_Racket_Code.html#(def._((lib._slideshow/code..rkt)._current-code-font))",[0,[2,"current-code-font"]],["slideshow/code"]],
["current-code-inspector",">reference/modprotect.html#(def._((quote._~23~25kernel)._current-code-inspector))",[0,[2,"current-code-inspector"]],["racket/base","racket"]],
["current-code-line-sep",">slideshow/Typesetting_Racket_Code.html#(def._((lib._slideshow/code..rkt)._current-code-line-sep))",[0,[2,"current-code-line-sep"]],["slideshow/code"]],
["current-code-tt",">slideshow/Typesetting_Racket_Code.html#(def._((lib._slideshow/code..rkt)._current-code-tt))",[0,[2,"current-code-tt"]],["slideshow/code"]],
["current-command-line-arguments",">reference/runtime.html#(def._((quote._~23~25kernel)._current-command-line-arguments))",[0,[2,"current-command-line-arguments"]],["racket/base","racket"]],
["current-command-line-arguments",">reference/running-sa.html#(idx._(gentag._429._(lib._scribblings/reference/reference..scrbl)))",[0,[2,"current-command-line-arguments"]],false],
["current-command-name",">raco/command.html#(def._((lib._raco/command-name..rkt)._current-command-name))",[0,[2,"current-command-name"]],["raco/command-name"]],
["current-comment-color",">slideshow/Typesetting_Racket_Code.html#(def._((lib._slideshow/code..rkt)._current-comment-color))",[0,[2,"current-comment-color"]],["slideshow/code"]],
["current-compile",">reference/eval.html#(def._((quote._~23~25kernel)._current-compile))",[0,[2,"current-compile"]],["racket/base","racket"]],
["current-compiler-dynamic-require-wrapper",">raco/API_for_Raw_Compilation.html#(def._((lib._compiler/compiler..rkt)._current-compiler-dynamic-require-wrapper))",[0,[2,"current-compiler-dynamic-require-wrapper"]],["compiler/compiler"]],
["current-const-color",">slideshow/Typesetting_Racket_Code.html#(def._((lib._slideshow/code..rkt)._current-const-color))",[0,[2,"current-const-color"]],["slideshow/code"]],
["current-const-list",">slideshow/Typesetting_Racket_Code.html#(def._((lib._slideshow/code..rkt)._current-const-list))",[0,[2,"current-const-list"]],["slideshow/code"]],
["current-continuation-marks",">reference/contmarks.html#(def._((quote._~23~25kernel)._current-continuation-marks))",[0,[2,"current-continuation-marks"]],["racket/base","racket"]],
["current-contract-region",">reference/attaching-contracts-to-values.html#(form._((lib._racket/contract/private/base..rkt)._current-contract-region))",[0,[1,"current-contract-region"]],["racket/contract/region","racket/contract","racket"]],
["current-country",">srfi-std/srfi-29.html#current-country",[0,[2,"current-country"]],["srfi/29"]],
["current-custodian",">reference/custodians.html#(def._((quote._~23~25kernel)._current-custodian))",[0,[2,"current-custodian"]],["racket/base","racket"]],
["current-date",">reference/time.html#(def._((lib._racket/date..rkt)._current-date))",[0,[2,"current-date"]],["racket/date"]],
["current-date",">srfi-std/srfi-19.html#",[0,[2,"current-date"]],["srfi/19"]],
["current-directory",">reference/Filesystem.html#(def._((quote._~23~25kernel)._current-directory))",[0,[2,"current-directory"]],["racket/base","racket"]],
["current-display-width",">scribble/doc-forms.html#(def._((lib._scribble/manual..rkt)._current-display-width))",[0,[2,"current-display-width"]],["scribble/manual"]],
["current-drive",">reference/Filesystem.html#(def._((quote._~23~25kernel)._current-drive))",[0,[2,"current-drive"]],["racket/base","racket"]],
["current-dsn-file",">db/connect.html#(def._((lib._db/base..rkt)._current-dsn-file))",[0,[2,"current-dsn-file"]],["db","db/base"]],
["current-error-port",">reference/port-ops.html#(def._((quote._~23~25kernel)._current-error-port))",[0,[2,"current-error-port"]],["racket/base","racket"]],
["current-error-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_736",[0,[2,"current-error-port"]],["rnrs/io/ports-6"]],
["current-eval",">reference/eval.html#(def._((quote._~23~25kernel)._current-eval))",[0,[2,"current-eval"]],["racket/base","racket"]],
["current-eventspace",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._current-eventspace))",[0,[2,"current-eventspace"]],["racket/gui/base","racket/gui"]],
["current-eventspace-has-menu-root?",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._current-eventspace-has-menu-root~3f))",[0,[2,"current-eventspace-has-menu-root?"]],["racket/gui/base","racket/gui"]],
["current-eventspace-has-standard-menus?",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._current-eventspace-has-standard-menus~3f))",[0,[2,"current-eventspace-has-standard-menus?"]],["racket/gui/base","racket/gui"]],
["current-evt-pseudo-random-generator",">reference/sync.html#(def._((quote._~23~25kernel)._current-evt-pseudo-random-generator))",[0,[2,"current-evt-pseudo-random-generator"]],["racket/base","racket"]],
["current-expected-text-scale",">slideshow/Rendering.html#(def._((lib._slideshow/pict..rkt)._current-expected-text-scale))",[0,[2,"current-expected-text-scale"]],["slideshow/pict","slideshow"]],
["current-extension-compiler",">dynext/Compilation.html#(def._((lib._dynext/compile..rkt)._current-extension-compiler))",[0,[2,"current-extension-compiler"]],["dynext/compile"]],
["current-extension-compiler-flags",">dynext/Compilation.html#(def._((lib._dynext/compile..rkt)._current-extension-compiler-flags))",[0,[2,"current-extension-compiler-flags"]],["dynext/compile"]],
["current-extension-linker",">dynext/Linking.html#(def._((lib._dynext/link..rkt)._current-extension-linker))",[0,[2,"current-extension-linker"]],["dynext/link"]],
["current-extension-linker-flags",">dynext/Linking.html#(def._((lib._dynext/link..rkt)._current-extension-linker-flags))",[0,[2,"current-extension-linker-flags"]],["dynext/link"]],
["current-extension-preprocess-flags",">dynext/Compilation.html#(def._((lib._dynext/compile..rkt)._current-extension-preprocess-flags))",[0,[2,"current-extension-preprocess-flags"]],["dynext/compile"]],
["current-file",">preprocessor/mzpp.html#(def._((lib._preprocessor/mzpp..rkt)._current-file))",[0,[2,"current-file"]],["preprocessor/mzpp"]],
["current-file",">preprocessor/mztext.html#(def._((lib._preprocessor/mztext..rkt)._current-file))",[0,[2,"current-file"]],["preprocessor/mztext"]],
["current-font-size",">slideshow/Configuration.html#(def._((lib._slideshow/base..rkt)._current-font-size))",[0,[2,"current-font-size"]],["slideshow/base","slideshow"]],
["current-future",">reference/futures.html#(def._((lib._racket/future..rkt)._current-future))",[0,[2,"current-future"]],["racket/future","racket"]],
["current-gap-size",">slideshow/Constants_and_Layout_Variables.html#(def._((lib._slideshow/base..rkt)._current-gap-size))",[0,[2,"current-gap-size"]],["slideshow/base","slideshow"]],
["current-gc-milliseconds",">reference/time.html#(def._((quote._~23~25kernel)._current-gc-milliseconds))",[0,[2,"current-gc-milliseconds"]],["racket/base","racket"]],
["current-get-interaction-input-port",">reference/eval.html#(def._((quote._~23~25kernel)._current-get-interaction-input-port))",[0,[2,"current-get-interaction-input-port"]],["racket/base","racket"]],
["current-https-protocol",">net/url.html#(def._((lib._net/url-connect..rkt)._current-https-protocol))",[0,[2,"current-https-protocol"]],["net/url-connect"]],
["current-id-color",">slideshow/Typesetting_Racket_Code.html#(def._((lib._slideshow/code..rkt)._current-id-color))",[0,[2,"current-id-color"]],["slideshow/code"]],
["current-inexact-milliseconds",">reference/time.html#(def._((quote._~23~25kernel)._current-inexact-milliseconds))",[0,[2,"current-inexact-milliseconds"]],["racket/base","racket"]],
["current-input-port",">reference/port-ops.html#(def._((quote._~23~25kernel)._current-input-port))",[0,[2,"current-input-port"]],["racket/base","racket"]],
["current-input-port",">r5rs-std/r5rs-Z-H-9.html#%_idx_618",[0,[2,"current-input-port"]],["r5rs"]],
["current-input-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_678",[0,[2,"current-input-port"]],["rnrs/io/ports-6"]],
["current-inspector",">reference/inspectors.html#(def._((quote._~23~25kernel)._current-inspector))",[0,[2,"current-inspector"]],["racket/base","racket"]],
["current-julian-day",">srfi-std/srfi-19.html#current-julian-day",[0,[2,"current-julian-day"]],["srfi/19"]],
["current-keyword-color",">slideshow/Typesetting_Racket_Code.html#(def._((lib._slideshow/code..rkt)._current-keyword-color))",[0,[2,"current-keyword-color"]],["slideshow/code"]],
["current-keyword-list",">slideshow/Typesetting_Racket_Code.html#(def._((lib._slideshow/code..rkt)._current-keyword-list))",[0,[2,"current-keyword-list"]],["slideshow/code"]],
["current-language",">srfi-std/srfi-29.html#current-language",[0,[2,"current-language"]],["srfi/29"]],
["current-launcher-variant",">raco/exe.html#(def._((lib._launcher/launcher..rkt)._current-launcher-variant))",[0,[2,"current-launcher-variant"]],["launcher/launcher"]],
["current-library-collection-paths",">reference/collects.html#(def._((quote._~23~25kernel)._current-library-collection-paths))",[0,[2,"current-library-collection-paths"]],["racket/base","racket"]],
["current-line-sep",">slideshow/Configuration.html#(def._((lib._slideshow/base..rkt)._current-line-sep))",[0,[2,"current-line-sep"]],["slideshow/base","slideshow"]],
["current-linkage",">planet/Utility_Libraries.html#(def._((lib._planet/util..rkt)._current-linkage))",[0,[2,"current-linkage"]],["planet/util"]],
["current-literal-color",">slideshow/Typesetting_Racket_Code.html#(def._((lib._slideshow/code..rkt)._current-literal-color))",[0,[2,"current-literal-color"]],["slideshow/code"]],
["current-literal-list",">slideshow/Typesetting_Racket_Code.html#(def._((lib._slideshow/code..rkt)._current-literal-list))",[0,[2,"current-literal-list"]],["slideshow/code"]],
["current-load",">reference/eval.html#(def._((quote._~23~25kernel)._current-load))",[0,[2,"current-load"]],["racket/base","racket"]],
["current-load-extension",">reference/eval.html#(def._((quote._~23~25kernel)._current-load-extension))",[0,[2,"current-load-extension"]],["racket/base","racket"]],
["current-load-relative-directory",">reference/eval.html#(def._((quote._~23~25kernel)._current-load-relative-directory))",[0,[2,"current-load-relative-directory"]],["racket/base","racket"]],
["current-load/use-compiled",">reference/eval.html#(def._((quote._~23~25kernel)._current-load/use-compiled))",[0,[2,"current-load/use-compiled"]],["racket/base","racket"]],
["current-locale",">reference/encodings.html#(def._((quote._~23~25kernel)._current-locale))",[0,[2,"current-locale"]],["racket/base","racket"]],
["current-locale-details",">srfi-std/srfi-29.html#current-locale-details",[0,[2,"current-locale-details"]],["srfi/29"]],
["current-logger",">reference/logging.html#(def._((quote._~23~25kernel)._current-logger))",[0,[2,"current-logger"]],["racket/base","racket"]],
["current-main-font",">slideshow/Configuration.html#(def._((lib._slideshow/base..rkt)._current-main-font))",[0,[2,"current-main-font"]],["slideshow/base","slideshow"]],
["current-make-compile-include-strings",">dynext/Compilation.html#(def._((lib._dynext/compile..rkt)._current-make-compile-include-strings))",[0,[2,"current-make-compile-include-strings"]],["dynext/compile"]],
["current-make-compile-input-strings",">dynext/Compilation.html#(def._((lib._dynext/compile..rkt)._current-make-compile-input-strings))",[0,[2,"current-make-compile-input-strings"]],["dynext/compile"]],
["current-make-compile-output-strings",">dynext/Compilation.html#(def._((lib._dynext/compile..rkt)._current-make-compile-output-strings))",[0,[2,"current-make-compile-output-strings"]],["dynext/compile"]],
["current-make-link-input-strings",">dynext/Linking.html#(def._((lib._dynext/link..rkt)._current-make-link-input-strings))",[0,[2,"current-make-link-input-strings"]],["dynext/link"]],
["current-make-link-output-strings",">dynext/Linking.html#(def._((lib._dynext/link..rkt)._current-make-link-output-strings))",[0,[2,"current-make-link-output-strings"]],["dynext/link"]],
["current-memory-use",">reference/garbagecollection.html#(def._((quote._~23~25kernel)._current-memory-use))",[0,[2,"current-memory-use"]],["racket/base","racket"]],
["current-milliseconds",">reference/time.html#(def._((quote._~23~25kernel)._current-milliseconds))",[0,[2,"current-milliseconds"]],["racket/base","racket"]],
["current-milliseconds",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._current-milliseconds))",[0,[2,"current-milliseconds"]],["lang/htdp-advanced"]],
["current-modified-julian-day",">srfi-std/srfi-19.html#current-modified-julian-day",[0,[2,"current-modified-julian-day"]],["srfi/19"]],
["current-module-declare-name",">reference/Module_Names_and_Loading.html#(def._((quote._~23~25kernel)._current-module-declare-name))",[0,[2,"current-module-declare-name"]],["racket/base","racket"]],
["current-module-declare-source",">reference/Module_Names_and_Loading.html#(def._((quote._~23~25kernel)._current-module-declare-source))",[0,[2,"current-module-declare-source"]],["racket/base","racket"]],
["current-module-name-resolver",">reference/Module_Names_and_Loading.html#(def._((quote._~23~25kernel)._current-module-name-resolver))",[0,[2,"current-module-name-resolver"]],["racket/base","racket"]],
["current-namespace",">reference/Namespaces.html#(def._((quote._~23~25kernel)._current-namespace))",[0,[2,"current-namespace"]],["racket/base","racket"]],
["current-output-port",">reference/port-ops.html#(def._((quote._~23~25kernel)._current-output-port))",[0,[2,"current-output-port"]],["racket/base","racket"]],
["current-output-port",">r5rs-std/r5rs-Z-H-9.html#%_idx_620",[0,[2,"current-output-port"]],["r5rs"]],
["current-output-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_734",[0,[2,"current-output-port"]],["rnrs/io/ports-6"]],
["current-page",">browser/index.html#(meth._(((lib._browser/browser..rkt)._hyper-canvas-mixin)._current-page))",[[0,[2,"current-page"]],[14,[" (method of ",[0,[2,"hyper-canvas-mixin"]],")"]]],["browser/browser","browser"]],
["current-page-number-adjust",">slideshow/Viewer_Control.html#(def._((lib._slideshow/base..rkt)._current-page-number-adjust))",[0,[2,"current-page-number-adjust"]],["slideshow/base","slideshow"]],
["current-page-number-color",">slideshow/Viewer_Control.html#(def._((lib._slideshow/base..rkt)._current-page-number-color))",[0,[2,"current-page-number-color"]],["slideshow/base","slideshow"]],
["current-page-number-font",">slideshow/Viewer_Control.html#(def._((lib._slideshow/base..rkt)._current-page-number-font))",[0,[2,"current-page-number-font"]],["slideshow/base","slideshow"]],
["current-para-width",">slideshow/Configuration.html#(def._((lib._slideshow/base..rkt)._current-para-width))",[0,[2,"current-para-width"]],["slideshow/base","slideshow"]],
["current-parameterization",">reference/parameters.html#(def._((lib._racket/private/more-scheme..rkt)._current-parameterization))",[0,[2,"current-parameterization"]],["racket/base","racket"]],
["current-prefix-in",">reference/debugging.html#(def._((lib._racket/trace..rkt)._current-prefix-in))",[0,[2,"current-prefix-in"]],["racket/trace"]],
["current-prefix-out",">reference/debugging.html#(def._((lib._racket/trace..rkt)._current-prefix-out))",[0,[2,"current-prefix-out"]],["racket/trace"]],
["current-preserved-thread-cell-values",">reference/threadcells.html#(def._((quote._~23~25kernel)._current-preserved-thread-cell-values))",[0,[2,"current-preserved-thread-cell-values"]],["racket/base","racket"]],
["current-print",">reference/eval.html#(def._((quote._~23~25kernel)._current-print))",[0,[2,"current-print"]],["racket/base","racket"]],
["current-print-convert-hook",">mzlib/mzlib_pconvert.html#(def._((lib._mzlib/pconvert..rkt)._current-print-convert-hook))",[0,[2,"current-print-convert-hook"]],["mzlib/pconvert"]],
["current-process-milliseconds",">reference/time.html#(def._((quote._~23~25kernel)._current-process-milliseconds))",[0,[2,"current-process-milliseconds"]],["racket/base","racket"]],
["current-prompt",">readline/index.html#(def._((lib._readline/pread..rkt)._current-prompt))",[0,[2,"current-prompt"]],["readline/pread"]],
["current-prompt-read",">reference/eval.html#(def._((quote._~23~25kernel)._current-prompt-read))",[0,[2,"current-prompt-read"]],["racket/base","racket"]],
["current-proxy-servers",">net/url.html#(def._((lib._net/url..rkt)._current-proxy-servers))",[0,[2,"current-proxy-servers"]],["net/url"]],
["current-ps-setup",">draw/Drawing_Functions.html#(def._((lib._racket/draw..rkt)._current-ps-setup))",[0,[2,"current-ps-setup"]],["racket/draw"]],
["current-pseudo-random-generator",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._current-pseudo-random-generator))",[0,[2,"current-pseudo-random-generator"]],["racket/base","racket"]],
["current-read-eval-convert-print-prompt",">mzlib/mzlib_pconvert.html#(def._((lib._mzlib/pconvert..rkt)._current-read-eval-convert-print-prompt))",[0,[2,"current-read-eval-convert-print-prompt"]],["mzlib/pconvert"]],
["current-read-interaction",">reference/eval.html#(def._((quote._~23~25kernel)._current-read-interaction))",[0,[2,"current-read-interaction"]],["racket/base","racket"]],
["current-reader-forms",">slideshow/Typesetting_Racket_Code.html#(def._((lib._slideshow/code..rkt)._current-reader-forms))",[0,[2,"current-reader-forms"]],["slideshow/code"]],
["current-reader-guard",">reference/Reading.html#(def._((quote._~23~25kernel)._current-reader-guard))",[0,[2,"current-reader-guard"]],["racket/base","racket"]],
["current-readtable",">reference/Reading.html#(def._((quote._~23~25kernel)._current-readtable))",[0,[2,"current-readtable"]],["racket/base","racket"]],
["current-recorded-disappeared-uses",">reference/syntax-util.html#(def._((lib._racket/syntax..rkt)._current-recorded-disappeared-uses))",[0,[2,"current-recorded-disappeared-uses"]],["racket/syntax"]],
["current-request",">web-server/page.html#(def._((lib._web-server/page..rkt)._current-request))",[0,[2,"current-request"]],["web-server/page"]],
["current-require-module-path",">reference/stxtrans.html#(def._((lib._racket/require-transform..rkt)._current-require-module-path))",[0,[2,"current-require-module-path"]],["racket/require-transform"]],
["current-seconds",">reference/time.html#(def._((quote._~23~25kernel)._current-seconds))",[0,[2,"current-seconds"]],["racket/base","racket"]],
["current-seconds",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._current-seconds))",[0,[2,"current-seconds"]],["lang/htdp-advanced"]],
["current-seconds",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._current-seconds))",[0,[2,"current-seconds"]],["lang/htdp-beginner"]],
["current-seconds",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._current-seconds))",[0,[2,"current-seconds"]],["lang/htdp-beginner-abbr"]],
["current-seconds",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._current-seconds))",[0,[2,"current-seconds"]],["lang/htdp-intermediate"]],
["current-seconds",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._current-seconds))",[0,[2,"current-seconds"]],["lang/htdp-intermediate-lambda"]],
["current-seconds",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._current-seconds))",[0,[2,"current-seconds"]],["deinprogramm/DMdA-advanced"]],
["current-seconds",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._current-seconds))",[0,[2,"current-seconds"]],["deinprogramm/DMdA-assignments"]],
["current-seconds",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._current-seconds))",[0,[2,"current-seconds"]],["deinprogramm/DMdA-beginner"]],
["current-seconds",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._current-seconds))",[0,[2,"current-seconds"]],["deinprogramm/DMdA-vanilla"]],
["current-security-guard",">reference/securityguards.html#(def._((quote._~23~25kernel)._current-security-guard))",[0,[2,"current-security-guard"]],["racket/base","racket"]],
["current-servlet-continuation-expiration-handler",">web-server/servlet.html#(def._((lib._web-server/servlet/web..rkt)._current-servlet-continuation-expiration-handler))",[0,[2,"current-servlet-continuation-expiration-handler"]],["web-server/servlet/web"]],
["current-slide-assembler",">slideshow/Configuration.html#(def._((lib._slideshow/base..rkt)._current-slide-assembler))",[0,[2,"current-slide-assembler"]],["slideshow/base","slideshow"]],
["current-standard-link-libraries",">dynext/Linking.html#(def._((lib._dynext/link..rkt)._current-standard-link-libraries))",[0,[2,"current-standard-link-libraries"]],["dynext/link"]],
["current-subprocess-custodian-mode",">reference/subprocess.html#(def._((quote._~23~25kernel)._current-subprocess-custodian-mode))",[0,[2,"current-subprocess-custodian-mode"]],["racket/base","racket"]],
["current-syntax-context",">reference/syntax-util.html#(def._((lib._racket/syntax..rkt)._current-syntax-context))",[0,[2,"current-syntax-context"]],["racket/syntax"]],
["current-target-directory-getter",">raco/setup-plt-plt.html#(sig-val._((lib._setup/option-sig..rkt)._setup-option~5e._current-target-directory-getter))",[0,[2,"current-target-directory-getter"]],["setup/option-sig"]],
["current-target-plt-directory-getter",">raco/setup-plt-plt.html#(sig-val._((lib._setup/option-sig..rkt)._setup-option~5e._current-target-plt-directory-getter))",[0,[2,"current-target-plt-directory-getter"]],["setup/option-sig"]],
["current-test-case-around",">rackunit/internals.html#(def._((lib._rackunit/main..rkt)._current-test-case-around))",[0,[2,"current-test-case-around"]],["rackunit"]],
["current-test-name",">rackunit/internals.html#(def._((lib._rackunit/main..rkt)._current-test-name))",[0,[2,"current-test-name"]],["rackunit"]],
["current-text",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._current-text))",[0,[2,"current-text"]],["redex/pict","redex"]],
["current-text-keymap-initializer",">gui/Editor_Functions.html#(def._((lib._mred/main..rkt)._current-text-keymap-initializer))",[0,[2,"current-text-keymap-initializer"]],["racket/gui/base","racket/gui"]],
["current-thread",">reference/threads.html#(def._((quote._~23~25kernel)._current-thread))",[0,[2,"current-thread"]],["racket/base","racket"]],
["current-thread-group",">reference/threadgroups.html#(def._((quote._~23~25kernel)._current-thread-group))",[0,[2,"current-thread-group"]],["racket/base","racket"]],
["current-thread-initial-stack-size",">reference/runtime.html#(def._((quote._~23~25kernel)._current-thread-initial-stack-size))",[0,[2,"current-thread-initial-stack-size"]],["racket/base","racket"]],
["current-time",">mzlib/mzlib_cml.html#(def._((lib._mzlib/cml..rkt)._current-time))",[0,[2,"current-time"]],["mzlib/cml"]],
["current-time",">srfi-std/srfi-19.html#current-time",[0,[2,"current-time"]],["srfi/19"]],
["current-title-color",">slideshow/Configuration.html#(def._((lib._slideshow/base..rkt)._current-title-color))",[0,[2,"current-title-color"]],["slideshow/base","slideshow"]],
["current-titlet",">slideshow/Configuration.html#(def._((lib._slideshow/base..rkt)._current-titlet))",[0,[2,"current-titlet"]],["slideshow/base","slideshow"]],
["current-trace-notify",">reference/debugging.html#(def._((lib._racket/trace..rkt)._current-trace-notify))",[0,[2,"current-trace-notify"]],["racket/trace"]],
["current-trace-print-args",">reference/debugging.html#(def._((lib._racket/trace..rkt)._current-trace-print-args))",[0,[2,"current-trace-print-args"]],["racket/trace"]],
["current-trace-print-results",">reference/debugging.html#(def._((lib._racket/trace..rkt)._current-trace-print-results))",[0,[2,"current-trace-print-results"]],["racket/trace"]],
["current-traced-metafunctions",">redex/The_Redex_Reference.html#(def._((lib._redex/reduction-semantics..rkt)._current-traced-metafunctions))",[0,[2,"current-traced-metafunctions"]],["redex/reduction-semantics","redex"]],
["current-use-mzdyn",">dynext/Linking.html#(def._((lib._dynext/link..rkt)._current-use-mzdyn))",[0,[2,"current-use-mzdyn"]],["dynext/link"]],
["current-write-relative-directory",">reference/Writing.html#(def._((quote._~23~25kernel)._current-write-relative-directory))",[0,[2,"current-write-relative-directory"]],["racket/base","racket"]],
["curried function shorthand",">guide/define.html#(part._.Curried_.Function_.Shorthand)","Curried Function Shorthand",false],
["curry",">reference/procedures.html#(def._((lib._racket/function..rkt)._curry))",[0,[2,"curry"]],["racket/function","racket"]],
["curryr",">reference/procedures.html#(def._((lib._racket/function..rkt)._curryr))",[0,[2,"curryr"]],["racket/function","racket"]],
["cursor",">db/query-api.html#(tech._cursor)","<span style=\"font-style: italic\">cursor</span>",false],
["cursor%",">gui/cursor_.html",[0,[2,"cursor%"]],["racket/gui/base","racket/gui"]],
["curve-to",">draw/dc-path_.html#(meth._(((lib._racket/draw..rkt)._dc-path~25)._curve-to))",[[0,[2,"curve-to"]],[14,[" (method of ",[0,[2,"dc-path%"]],")"]]],["racket/draw"]],
["custodian",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Custodian))",[0,[1,"Custodian"]],["typed/racket/base","typed/racket"]],
["custodian",">reference/eval-model.html#(tech._custodian)","<span style=\"font-style: italic\">custodian</span>",false],
["custodian box",">reference/eval-model.html#(tech._custodian._box)","<span style=\"font-style: italic\">custodian box</span>",false],
["custodian-box-value",">reference/custodians.html#(def._((quote._~23~25kernel)._custodian-box-value))",[0,[2,"custodian-box-value"]],["racket/base","racket"]],
["custodian-box?",">reference/custodians.html#(def._((quote._~23~25kernel)._custodian-box~3f))",[0,[2,"custodian-box?"]],["racket/base","racket"]],
["custodian-boxof",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Custodian-.Boxof))",[0,[1,"Custodian-Boxof"]],["typed/racket/base","typed/racket"]],
["custodian-limit-memory",">reference/custodians.html#(def._((quote._~23~25kernel)._custodian-limit-memory))",[0,[2,"custodian-limit-memory"]],["racket/base","racket"]],
["custodian-managed-list",">reference/custodians.html#(def._((quote._~23~25kernel)._custodian-managed-list))",[0,[2,"custodian-managed-list"]],["racket/base","racket"]],
["custodian-memory-accounting-available?",">reference/custodians.html#(def._((quote._~23~25kernel)._custodian-memory-accounting-available~3f))",[0,[2,"custodian-memory-accounting-available?"]],["racket/base","racket"]],
["custodian-require-memory",">reference/custodians.html#(def._((quote._~23~25kernel)._custodian-require-memory))",[0,[2,"custodian-require-memory"]],["racket/base","racket"]],
["custodian-shutdown-all",">reference/custodians.html#(def._((quote._~23~25kernel)._custodian-shutdown-all))",[0,[2,"custodian-shutdown-all"]],["racket/base","racket"]],
["custodian?",">reference/custodians.html#(def._((quote._~23~25kernel)._custodian~3f))",[0,[2,"custodian?"]],["racket/base","racket"]],
["custodians",">inside/Custodians.html","Custodians",false],
["custodians",">reference/eval-model.html#(part._custodian-model)","Custodians",false],
["custodians",">reference/custodians.html","Custodians",false],
["custom checks",">rackunit/api.html#(part._.Custom_.Checks)","Custom Checks",false],
["custom function types",">foreign/foreign_procedures.html#(part._foreign~3acustom-types)","Custom Function Types",false],
["custom function types",">foreign/foreign_procedures.html#(tech._custom._function._type)","<span style=\"font-style: italic\">custom function types</span>",false],
["custom ports",">reference/customport.html","Custom Ports",false],
["custom ports",">reference/customport.html#(tech._custom._port)","<span style=\"font-style: italic\">custom ports</span>",false],
["custom-print-quotable-accessor",">reference/Printer_Extension.html#(def._((quote._~23~25kernel)._custom-print-quotable-accessor))",[0,[2,"custom-print-quotable-accessor"]],["racket/base","racket"]],
["custom-print-quotable?",">reference/Printer_Extension.html#(def._((quote._~23~25kernel)._custom-print-quotable~3f))",[0,[2,"custom-print-quotable?"]],["racket/base","racket"]],
["custom-write-accessor",">reference/Printer_Extension.html#(def._((quote._~23~25kernel)._custom-write-accessor))",[0,[2,"custom-write-accessor"]],["racket/base","racket"]],
["custom-write?",">reference/Printer_Extension.html#(def._((quote._~23~25kernel)._custom-write~3f))",[0,[2,"custom-write?"]],["racket/base","racket"]],
["customization",">redex/The_Redex_Reference.html#(part._.Customization)","Customization",false],
["customizing check evaluation",">rackunit/internals.html#(part._.Customizing_.Check_.Evaluation)","Customizing Check Evaluation",false],
["customizing drracket's behavior",">tools/Language-specific_capabilities.html#(part._drracket~3alang-languages-customization)","Customizing DrRacket&rsquo;s behavior",false],
["customizing drracket's gui",">tools/Language-specific_capabilities.html#(part._.Customizing_.Dr.Racket_s_.G.U.I)","Customizing DrRacket&rsquo;s GUI",false],
["customizing evaluators",">reference/Sandboxed_Evaluation.html#(part._.Customizing_.Evaluators)","Customizing Evaluators",false],
["customizing test evaluation",">rackunit/internals.html#(part._.Customizing_.Test_.Evaluation)","Customizing Test Evaluation",false],
["cut",">racklog/glossary.html#(part._.Cut)","Cut",false],
["cut",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._cut))",[[0,[2,"cut"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["cut",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._cut))",[[0,[2,"cut"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["cut",">srfi-std/srfi-26.html#cut",[0,[1,"cut"]],["srfi/26"]],
["cut",">syntax/stxparse-patterns.html#(tech._cut)","<span style=\"font-style: italic\">cut</span>",false],
["cut and paste time stamps",">gui/editor-overview.html#(part._editorcutandpastetime)","Cut and Paste Time Stamps",false],
["cut menu item",">drracket/Menus.html#(idx._(gentag._73._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Cut</span> menu item",false],
["cut-click-region",">framework/Keymap.html#(idx._(gentag._34._(lib._scribblings/framework/framework..scrbl)))","cut-click-region",false],
["cut-clipboard",">framework/Keymap.html#(idx._(gentag._31._(lib._scribblings/framework/framework..scrbl)))","cut-clipboard",false],
["cute",">srfi-std/srfi-26.html#cute",[0,[1,"cute"]],["srfi/26"]],
["cvector",">foreign/foreign_cvector.html#(def._((lib._ffi/unsafe/cvector..rkt)._cvector))",[0,[2,"cvector"]],["ffi/cvector","ffi/unsafe/cvector"]],
["cvector->list",">foreign/foreign_cvector.html#(def._((lib._ffi/unsafe/cvector..rkt)._cvector-~3elist))",[0,[2,"cvector->list"]],["ffi/cvector","ffi/unsafe/cvector"]],
["cvector-length",">foreign/foreign_cvector.html#(def._((lib._ffi/unsafe/cvector..rkt)._cvector-length))",[0,[2,"cvector-length"]],["ffi/cvector","ffi/unsafe/cvector"]],
["cvector-ptr",">foreign/foreign_cvector.html#(def._((lib._ffi/unsafe/cvector..rkt)._cvector-ptr))",[0,[2,"cvector-ptr"]],["ffi/cvector","ffi/unsafe/cvector"]],
["cvector-ref",">foreign/foreign_cvector.html#(def._((lib._ffi/unsafe/cvector..rkt)._cvector-ref))",[0,[2,"cvector-ref"]],["ffi/cvector","ffi/unsafe/cvector"]],
["cvector-set!",">foreign/foreign_cvector.html#(def._((lib._ffi/unsafe/cvector..rkt)._cvector-set!))",[0,[2,"cvector-set!"]],["ffi/cvector","ffi/unsafe/cvector"]],
["cvector-type",">foreign/foreign_cvector.html#(def._((lib._ffi/unsafe/cvector..rkt)._cvector-type))",[0,[2,"cvector-type"]],["ffi/cvector","ffi/unsafe/cvector"]],
["cvector?",">foreign/foreign_cvector.html#(def._((lib._ffi/unsafe/cvector..rkt)._cvector~3f))",[0,[2,"cvector?"]],["ffi/cvector","ffi/unsafe/cvector"]],
["cyan",">unstable/pict.html#(def._((lib._unstable/gui/pict..rkt)._cyan))",[0,[2,"cyan"]],["unstable/gui/pict"]],
["cycle",">lazy/index.html#(def._((lib._lazy/main..rkt)._cycle))",[0,[2,"cycle"]],["lazy"]],
["cycle back through old expressions",">drracket/interactions-window.html#(idx._(gentag._26._(lib._scribblings/drracket/drracket..scrbl)))","cycle back through old expressions",false],
["d",">teachpack/world.html#(tech._d)","<span style=\"font-style: italic\">D</span>",false],
["dark",">unstable/pict.html#(def._((lib._unstable/gui/pict..rkt)._dark))",[0,[2,"dark"]],["unstable/gui/pict"]],
["dark-brush-color",">redex/The_Redex_Reference.html#(def._((lib._redex/gui..rkt)._dark-brush-color))",[0,[2,"dark-brush-color"]],["redex/gui","redex"]],
["dark-metal-icon-color",">images/Icons.html#(def._((lib._images/icons/style..rkt)._dark-metal-icon-color))",[0,[2,"dark-metal-icon-color"]],["images/icons/style"]],
["dark-pen-color",">redex/The_Redex_Reference.html#(def._((lib._redex/gui..rkt)._dark-pen-color))",[0,[2,"dark-pen-color"]],["redex/gui","redex"]],
["dark-text-color",">redex/The_Redex_Reference.html#(def._((lib._redex/gui..rkt)._dark-text-color))",[0,[2,"dark-text-color"]],["redex/gui","redex"]],
["data",">data/index.html",[9,[0,"data"]],"module"],
["data layout",">images/Overview.html#(part._flomap~3alayout)","Data Layout",false],
["data source names",">db/connect.html#(part._.Data_.Source_.Names)","Data Source Names",false],
["data-lines->data",">net/head.html#(def._((lib._net/head..rkt)._data-lines-~3edata))",[0,[2,"data-lines->data"]],["net/head"]],
["data-set",">mrlib/Plot.html#(def._((lib._mrlib/plot..rkt)._data-set))",[0,[2,"data-set"]],["mrlib/plot"]],
["data-set-connected?",">mrlib/Plot.html#(def._((lib._mrlib/plot..rkt)._data-set-connected~3f))",[0,[2,"data-set-connected?"]],["mrlib/plot"]],
["data-set-max-x",">mrlib/Plot.html#(def._((lib._mrlib/plot..rkt)._data-set-max-x))",[0,[2,"data-set-max-x"]],["mrlib/plot"]],
["data-set-max-y",">mrlib/Plot.html#(def._((lib._mrlib/plot..rkt)._data-set-max-y))",[0,[2,"data-set-max-y"]],["mrlib/plot"]],
["data-set-min-x",">mrlib/Plot.html#(def._((lib._mrlib/plot..rkt)._data-set-min-x))",[0,[2,"data-set-min-x"]],["mrlib/plot"]],
["data-set-min-y",">mrlib/Plot.html#(def._((lib._mrlib/plot..rkt)._data-set-min-y))",[0,[2,"data-set-min-y"]],["mrlib/plot"]],
["data-set-pen",">mrlib/Plot.html#(def._((lib._mrlib/plot..rkt)._data-set-pen))",[0,[2,"data-set-pen"]],["mrlib/plot"]],
["data-set-points",">mrlib/Plot.html#(def._((lib._mrlib/plot..rkt)._data-set-points))",[0,[2,"data-set-points"]],["mrlib/plot"]],
["data-set?",">mrlib/Plot.html#(def._((lib._mrlib/plot..rkt)._data-set~3f))",[0,[2,"data-set?"]],["mrlib/plot"]],
["data-source",">db/connect.html#(def._((lib._db/base..rkt)._data-source))",[0,[2,"data-source"]],["db","db/base"]],
["data-source-args",">db/connect.html#(def._((lib._db/base..rkt)._data-source-args))",[0,[2,"data-source-args"]],["db","db/base"]],
["data-source-connector",">db/connect.html#(def._((lib._db/base..rkt)._data-source-connector))",[0,[2,"data-source-connector"]],["db","db/base"]],
["data-source-extensions",">db/connect.html#(def._((lib._db/base..rkt)._data-source-extensions))",[0,[2,"data-source-extensions"]],["db","db/base"]],
["data-source?",">db/connect.html#(def._((lib._db/base..rkt)._data-source~3f))",[0,[2,"data-source?"]],["db","db/base"]],
["data-structure contracts",">reference/data-structure-contracts.html","Data-structure Contracts",false],
["data/gvector",">data/gvector.html",[9,[0,"data/gvector"]],"module"],
["data/heap",">data/Binary_Heaps.html",[9,[0,"data/heap"]],"module"],
["data/interval-map",">data/interval-map.html",[9,[0,"data/interval-map"]],"module"],
["data/order",">data/Orders_and_Ordered_Dictionaries.html",[9,[0,"data/order"]],"module"],
["data/queue",">data/Imperative_Queues.html",[9,[0,"data/queue"]],"module"],
["data/skip-list",">data/skip-list.html",[9,[0,"data/skip-list"]],"module"],
["data/splay-tree",">data/Splay_Trees.html",[9,[0,"data/splay-tree"]],"module"],
["data: data structures",">data/index.html","Data: Data Structures",false],
["database",">db/index.html","database",false],
["database catalog information",">db/query-api.html#(part._.Database_.Catalog_.Information)","Database Catalog Information",false],
["database performance",">db/using-db.html#(part._dbperf)","Database Performance",false],
["database security",">db/using-db.html#(part._dbsec)","Database Security",false],
["databases and web servlets",">db/using-db.html#(part._intro-servlets)","Databases and Web Servlets",false],
["datalog",">datalog/interop.html",[9,[0,"datalog"]],"module"],
["datalog",">datalog/datalog.html",[9,[0,"datalog"]],"module"],
["datalog",">datalog/interop.html#(form._((lib._datalog/main..rkt)._datalog))",[0,[1,"datalog"]],["datalog"]],
["datalog module language",">datalog/datalog.html","Datalog Module Language",false],
["datalog!",">datalog/interop.html#(form._((lib._datalog/main..rkt)._datalog!))",[0,[1,"datalog!"]],["datalog"]],
["datalog/sexp",">datalog/Parenthetical_Datalog_Module_Language.html",[9,[0,"datalog/sexp"]],"module"],
["datalog: deductive database programming",">datalog/index.html","Datalog: Deductive Database Programming",false],
["datastructures",">planet/Developing_Packages_for_PLaneT.html#(idx._(gentag._8._(lib._planet/planet..scrbl)))",[7,"'datastructures"],false],
["datatypes",">reference/data.html","Datatypes",false],
["datatypes",">xml/index.html#(part._.Datatypes)","Datatypes",false],
["datatypes and serialization",">guide/serialization.html","Datatypes and Serialization",false],
["datatypes and unions",">ts-guide/beginning.html#(part._.Datatypes_and_.Unions)","Datatypes and Unions",false],
["date",">reference/time.html#(def._((lib._racket/private/base..rkt)._date))",[0,[2,"date"]],["racket/base","racket"]],
["date ticks",">plot/ticks_and_transforms.html#(part._.Date_.Ticks)","Date Ticks",false],
["date utilities",">reference/time.html#(part._date-string)","Date Utilities",false],
["date*",">reference/time.html#(def._((lib._racket/private/base..rkt)._date*))",[0,[2,"date*"]],["racket/base","racket"]],
["date*-nanosecond",">reference/time.html#(def._((quote._~23~25kernel)._date*-nanosecond))",[0,[2,"date*-nanosecond"]],["racket/base","racket"]],
["date*-time-zone-name",">reference/time.html#(def._((quote._~23~25kernel)._date*-time-zone-name))",[0,[2,"date*-time-zone-name"]],["racket/base","racket"]],
["date*?",">reference/time.html#(def._((quote._~23~25kernel)._date*~3f))",[0,[2,"date*?"]],["racket/base","racket"]],
["date->com-date",">mysterx/com-types.html#(def._((lib._mysterx/main..rkt)._date-~3ecom-date))",[0,[2,"date->com-date"]],["mysterx"]],
["date->julian-day",">srfi-std/srfi-19.html#date->julian-day",[0,[2,"date->julian-day"]],["srfi/19"]],
["date->julian/scalinger",">reference/time.html#(def._((lib._racket/date..rkt)._date-~3ejulian/scalinger))",[0,[2,"date->julian/scalinger"]],["racket/date"]],
["date->modified-julian-day",">srfi-std/srfi-19.html#date->modified-julian-day",[0,[2,"date->modified-julian-day"]],["srfi/19"]],
["date->seconds",">reference/time.html#(def._((lib._racket/date..rkt)._date-~3eseconds))",[0,[2,"date->seconds"]],["racket/date"]],
["date->string",">reference/time.html#(def._((lib._racket/date..rkt)._date-~3estring))",[0,[2,"date->string"]],["racket/date"]],
["date->string",">srfi-std/srfi-19.html#date->string",[0,[2,"date->string"]],["srfi/19"]],
["date->time-monotonic",">srfi-std/srfi-19.html#date->time-monotonic",[0,[2,"date->time-monotonic"]],["srfi/19"]],
["date->time-tai",">srfi-std/srfi-19.html#date->time-tai",[0,[2,"date->time-tai"]],["srfi/19"]],
["date->time-utc",">srfi-std/srfi-19.html#date->time-utc",[0,[2,"date->time-utc"]],["srfi/19"]],
["date-day",">reference/time.html#(def._((quote._~23~25kernel)._date-day))",[0,[2,"date-day"]],["racket/base","racket"]],
["date-day",">srfi-std/srfi-19.html#date-day",[0,[2,"date-day"]],["srfi/19"]],
["date-display-format",">reference/time.html#(def._((lib._racket/date..rkt)._date-display-format))",[0,[2,"date-display-format"]],["racket/date"]],
["date-dst?",">reference/time.html#(def._((quote._~23~25kernel)._date-dst~3f))",[0,[2,"date-dst?"]],["racket/base","racket"]],
["date-hour",">reference/time.html#(def._((quote._~23~25kernel)._date-hour))",[0,[2,"date-hour"]],["racket/base","racket"]],
["date-hour",">srfi-std/srfi-19.html#date-hour",[0,[2,"date-hour"]],["srfi/19"]],
["date-minute",">reference/time.html#(def._((quote._~23~25kernel)._date-minute))",[0,[2,"date-minute"]],["racket/base","racket"]],
["date-minute",">srfi-std/srfi-19.html#date-minute",[0,[2,"date-minute"]],["srfi/19"]],
["date-month",">reference/time.html#(def._((quote._~23~25kernel)._date-month))",[0,[2,"date-month"]],["racket/base","racket"]],
["date-month",">srfi-std/srfi-19.html#date-month",[0,[2,"date-month"]],["srfi/19"]],
["date-nanosecond",">srfi-std/srfi-19.html#date-nanosecond",[0,[2,"date-nanosecond"]],["srfi/19"]],
["date-second",">reference/time.html#(def._((quote._~23~25kernel)._date-second))",[0,[2,"date-second"]],["racket/base","racket"]],
["date-second",">srfi-std/srfi-19.html#date-second",[0,[2,"date-second"]],["srfi/19"]],
["date-ticks",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._date-ticks))",[0,[2,"date-ticks"]],["plot"]],
["date-ticks-format",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._date-ticks-format))",[0,[2,"date-ticks-format"]],["plot"]],
["date-ticks-formats",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._date-ticks-formats))",[0,[2,"date-ticks-formats"]],["plot"]],
["date-ticks-layout",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._date-ticks-layout))",[0,[2,"date-ticks-layout"]],["plot"]],
["date-time-zone-offset",">reference/time.html#(def._((quote._~23~25kernel)._date-time-zone-offset))",[0,[2,"date-time-zone-offset"]],["racket/base","racket"]],
["date-week-day",">reference/time.html#(def._((quote._~23~25kernel)._date-week-day))",[0,[2,"date-week-day"]],["racket/base","racket"]],
["date-week-day",">srfi-std/srfi-19.html#date-week-day",[0,[2,"date-week-day"]],["srfi/19"]],
["date-week-number",">srfi-std/srfi-19.html#date-week-number",[0,[2,"date-week-number"]],["srfi/19"]],
["date-year",">reference/time.html#(def._((quote._~23~25kernel)._date-year))",[0,[2,"date-year"]],["racket/base","racket"]],
["date-year",">srfi-std/srfi-19.html#date-year",[0,[2,"date-year"]],["srfi/19"]],
["date-year-day",">reference/time.html#(def._((quote._~23~25kernel)._date-year-day))",[0,[2,"date-year-day"]],["racket/base","racket"]],
["date-year-day",">srfi-std/srfi-19.html#date-year-day",[0,[2,"date-year-day"]],["srfi/19"]],
["date-zone-offset",">srfi-std/srfi-19.html#date-zone-offset",[0,[2,"date-zone-offset"]],["srfi/19"]],
["date?",">reference/time.html#(def._((quote._~23~25kernel)._date~3f))",[0,[2,"date?"]],["racket/base","racket"]],
["date?",">srfi-std/srfi-19.html#date-p",[0,[2,"date?"]],["srfi/19"]],
["dates and times",">db/sql-types.html#(part._.Dates_and_.Times)","Dates and Times",false],
["dates and times",">plot/utils.html#(part._.Dates_and_.Times)","Dates and Times",false],
["datetime type utilities",">db/util.html#(part._datetime-util)","Datetime Type Utilities",false],
["datetime->real",">plot/utils.html#(def._((lib._plot/utils..rkt)._datetime-~3ereal))",[0,[2,"datetime->real"]],["plot/utils"]],
["datum",">syntax/Datum_Pattern_Matching.html#(form._((lib._syntax/datum..rkt)._datum))",[0,[1,"datum"]],["syntax/datum"]],
["datum",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Datum))",[0,[1,"Datum"]],["typed/racket/base","typed/racket"]],
["datum",">reference/reader.html#(tech._datum)","<span style=\"font-style: italic\">datum</span>",false],
["datum pattern matching",">syntax/Datum_Pattern_Matching.html","Datum Pattern Matching",false],
["datum->syntax",">reference/stxops.html#(def._((quote._~23~25kernel)._datum-~3esyntax))",[0,[2,"datum->syntax"]],["racket/base","racket"]],
["datum->syntax",">r6rs-lib-std/r6rs-lib-Z-H-13.html#node_idx_1146",[0,[2,"datum->syntax"]],["rnrs/syntax-case-6"]],
["datum->syntax-object",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..rkt)._datum-~3esyntax-object))",[0,[2,"datum->syntax-object"]],["mzscheme"]],
["datum-case",">syntax/Datum_Pattern_Matching.html#(form._((lib._syntax/datum..rkt)._datum-case))",[0,[1,"datum-case"]],["syntax/datum"]],
["datum-intern-literal",">reference/stxops.html#(def._((quote._~23~25kernel)._datum-intern-literal))",[0,[2,"datum-intern-literal"]],["racket/base","racket"]],
["datum-order",">data/Orders_and_Ordered_Dictionaries.html#(def._((lib._data/order..rkt)._datum-order))",[0,[2,"datum-order"]],["data/order"]],
["db",">db/index.html",[9,[0,"db"]],"module"],
["db/base",">db/connect.html#(mod-path._db/base)",[9,[0,"db/base"]],"module"],
["db/mysql",">db/connect.html#(mod-path._db/mysql)",[9,[0,"db/mysql"]],"module"],
["db/odbc",">db/connect.html#(mod-path._db/odbc)",[9,[0,"db/odbc"]],"module"],
["db/postgresql",">db/connect.html#(mod-path._db/postgresql)",[9,[0,"db/postgresql"]],"module"],
["db/sqlite3",">db/connect.html#(mod-path._db/sqlite3)",[9,[0,"db/sqlite3"]],"module"],
["db/util/datetime",">db/util.html#(mod-path._db/util/datetime)",[9,[0,"db/util/datetime"]],"module"],
["db/util/geometry",">db/util.html#(mod-path._db/util/geometry)",[9,[0,"db/util/geometry"]],"module"],
["db/util/postgresql",">db/util.html#(mod-path._db/util/postgresql)",[9,[0,"db/util/postgresql"]],"module"],
["db/util/testing",">db/util.html#(mod-path._db/util/testing)",[9,[0,"db/util/testing"]],"module"],
["db2",">db/index.html#(idx._(gentag._5._(lib._db/scribblings/db..scrbl)))","DB2",false],
["db2 odbc driver",">db/notes.html#(part._.D.B2_.O.D.B.C_.Driver)","DB2 ODBC Driver",false],
["db: database connectivity",">db/index.html","DB: Database Connectivity",false],
["dbsystem-name",">db/connect.html#(def._((lib._db/base..rkt)._dbsystem-name))",[0,[2,"dbsystem-name"]],["db","db/base"]],
["dbsystem-supported-types",">db/connect.html#(def._((lib._db/base..rkt)._dbsystem-supported-types))",[0,[2,"dbsystem-supported-types"]],["db","db/base"]],
["dbsystem?",">db/connect.html#(def._((lib._db/base..rkt)._dbsystem~3f))",[0,[2,"dbsystem?"]],["db","db/base"]],
["dc",">slideshow/Basic_Pict_Constructors.html#(def._((lib._slideshow/pict..rkt)._dc))",[0,[2,"dc"]],["slideshow/pict","slideshow"]],
["dc",">draw/overview.html#(tech._dc)","<span style=\"font-style: italic\">DC</span>",false],
["dc-for-text-size",">slideshow/Rendering.html#(def._((lib._slideshow/pict..rkt)._dc-for-text-size))",[0,[2,"dc-for-text-size"]],["slideshow/pict","slideshow"]],
["dc-location-to-editor-location",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._dc-location-to-editor-location))",[[0,[2,"dc-location-to-editor-location"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["dc-path%",">draw/dc-path_.html",[0,[2,"dc-path%"]],["racket/draw"]],
["dc<%>",">draw/dc___.html",[0,[2,"dc<%>"]],["racket/draw"]],
["dcom",">foreign/com.html#(tech._dcom)","<span style=\"font-style: italic\">DCOM</span>",false],
["dd",">html/index.html#(def._((lib._html/main..rkt)._dd))",[0,[2,"dd"]],["html"]],
["dd?",">html/index.html#(def._((lib._html/main..rkt)._dd~3f))",[0,[2,"dd?"]],["html"]],
["deallocator",">foreign/Allocation_and_Finalization.html#(def._((lib._ffi/unsafe/alloc..rkt)._deallocator))",[0,[2,"deallocator"]],["ffi/unsafe/alloc"]],
["debug",">unstable/Debugging.html#(form._((lib._unstable/debug..rkt)._debug))",[0,[1,"debug"]],["unstable/debug"]],
["debug button",">drracket/debugger.html#(idx._(gentag._33._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Debug</span> button",false],
["debug button",">drracket/buttons.html#(idx._(gentag._6._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Debug</span> button",false],
["debug-parse",">syntax/Debugging_and_Inspection_Tools.html#(form._((lib._syntax/parse/debug..rkt)._debug-parse))",[0,[1,"debug-parse"]],["syntax/parse/debug"]],
["debug?",">preprocessor/mzpp.html#(def._((lib._preprocessor/mzpp..rkt)._debug~3f))",[0,[2,"debug?"]],["preprocessor/mzpp"]],
["debugf",">unstable/Debugging.html#(form._((lib._unstable/debug..rkt)._debugf))",[0,[1,"debugf"]],["unstable/debug"]],
["debugger",">drracket/buttons.html#(idx._(gentag._7._(lib._scribblings/drracket/drracket..scrbl)))","debugger",false],
["debugger buttons",">drracket/debugger.html#(part._.Debugger_.Buttons)","Debugger Buttons",false],
["debugger-bomb-color",">images/Icons.html#(def._((lib._images/icons/tool..rkt)._debugger-bomb-color))",[0,[2,"debugger-bomb-color"]],["images/icons/tool"]],
["debugger-icon",">images/Icons.html#(def._((lib._images/icons/tool..rkt)._debugger-icon))",[0,[2,"debugger-icon"]],["images/icons/tool"]],
["debugging",">reference/debugging.html","Debugging",false],
["debugging",">unstable/Debugging.html","Debugging",false],
["debugging",">xrepl/index.html#(part._.Debugging)","Debugging",false],
["debugging and inspection tools",">syntax/Debugging_and_Inspection_Tools.html","Debugging and Inspection Tools",false],
["debugging multiple files",">drracket/debugger.html#(part._.Debugging_.Multiple_.Files)","Debugging Multiple Files",false],
["debugging plt redex programs",">redex/The_Redex_Reference.html#(tech._debugging._plt._redex._program)","<span style=\"font-style: italic\">Debugging PLT Redex Programs</span>",false],
["decimal",">gui/key-event_.html#(idx._(gentag._78._(lib._scribblings/gui/gui..scrbl)))",[7,"'decimal"],false],
["declare-bundle!",">srfi-std/srfi-29.html#declare-bundle!",[0,[2,"declare-bundle!"]],["srfi/29"]],
["declare-exporting",">scribble/doc-modules.html#(form._((lib._scribble/manual..rkt)._declare-exporting))",[0,[1,"declare-exporting"]],["scribble/manual"]],
["declare-exporting/this-package",">planet/Utility_Libraries.html#(form._((lib._planet/scribble..rkt)._declare-exporting/this-package))",[0,[1,"declare-exporting/this-package"]],["planet/scribble"]],
["declare-refinement",">ts-reference/Experimental_Features.html#(form._((lib._typed-racket/base-env/prims..rkt)._declare-refinement))",[0,[1,"declare-refinement"]],["typed/racket/base","typed/racket"]],
["declaring a module in an extension",">inside/overview.html#(part._.Declaring_a_.Module_in_an_.Extension)","Declaring a Module in an Extension",false],
["declaring a rest argument",">guide/lambda.html#(part._rest-args)","Declaring a Rest Argument",false],
["declaring keyword arguments",">guide/lambda.html#(part._lambda-keywords)","Declaring Keyword Arguments",false],
["declaring optional arguments",">guide/lambda.html#(part._.Declaring_.Optional_.Arguments)","Declaring Optional Arguments",false],
["declaring paths needed at run time",">reference/Filesystem.html#(part._runtime-path)","Declaring Paths Needed at Run Time",false],
["decode",">scribble/decode.html#(def._((lib._scribble/decode..rkt)._decode))",[0,[2,"decode"]],["scribble/decode"]],
["decode",">scribble/decode.html#(tech._decode)","<span style=\"font-style: italic\">decode</span>",false],
["decode-compound-paragraph",">scribble/decode.html#(def._((lib._scribble/decode..rkt)._decode-compound-paragraph))",[0,[2,"decode-compound-paragraph"]],["scribble/decode"]],
["decode-content",">scribble/decode.html#(def._((lib._scribble/decode..rkt)._decode-content))",[0,[2,"decode-content"]],["scribble/decode"]],
["decode-elements",">scribble/decode.html#(def._((lib._scribble/decode..rkt)._decode-elements))",[0,[2,"decode-elements"]],["scribble/decode"]],
["decode-flow",">scribble/decode.html#(def._((lib._scribble/decode..rkt)._decode-flow))",[0,[2,"decode-flow"]],["scribble/decode"]],
["decode-paragraph",">scribble/decode.html#(def._((lib._scribble/decode..rkt)._decode-paragraph))",[0,[2,"decode-paragraph"]],["scribble/decode"]],
["decode-part",">scribble/decode.html#(def._((lib._scribble/decode..rkt)._decode-part))",[0,[2,"decode-part"]],["scribble/decode"]],
["decode-string",">scribble/decode.html#(def._((lib._scribble/decode..rkt)._decode-string))",[0,[2,"decode-string"]],["scribble/decode"]],
["decoding sequences",">scribble/getting-started.html#(part._.Decoding_.Sequences)","Decoding Sequences",false],
["decoding text",">scribble/decode.html","Decoding Text",false],
["decompile",">raco/decompile.html#(def._((lib._compiler/decompile..rkt)._decompile))",[0,[2,"decompile"]],["compiler/decompile"]],
["decompress-serial",">web-server-internal/mod-map.html#(def._((lib._web-server/private/mod-map..rkt)._decompress-serial))",[0,[2,"decompress-serial"]],["web-server/private/mod-map"]],
["deconstructing data structures: type-case",">plai/plai-scheme.html#(part._type-case)",["Deconstructing Data Structures: ",[0,[1,"type-case"]]],false],
["deconstructing syntax objects",">syntax/syntax-helpers.html#(part._stx)","Deconstructing Syntax Objects",false],
["decorated editor snip",">framework/Decorated_Editor_Snip.html","Decorated Editor Snip",false],
["decorated-editor-snip%",">framework/Decorated_Editor_Snip.html#(form._((lib._framework/decorated-editor-snip..rkt)._decorated-editor-snip~25))",[0,[1,"decorated-editor-snip%"]],["framework/decorated-editor-snip"]],
["decorated-editor-snip-mixin",">framework/Decorated_Editor_Snip.html#(form._((lib._framework/decorated-editor-snip..rkt)._decorated-editor-snip-mixin))",[0,[1,"decorated-editor-snip-mixin"]],["framework/decorated-editor-snip"]],
["decorated-editor-snip<%>",">framework/Decorated_Editor_Snip.html#(form._((lib._framework/decorated-editor-snip..rkt)._decorated-editor-snip~3c~25~3e))",[0,[1,"decorated-editor-snip<%>"]],["framework/decorated-editor-snip"]],
["decorated-editor-snipclass%",">framework/Decorated_Editor_Snip.html#(form._((lib._framework/decorated-editor-snip..rkt)._decorated-editor-snipclass~25))",[0,[1,"decorated-editor-snipclass%"]],["framework/decorated-editor-snip"]],
["decorating with style!",">continue/index.html#(part._.Decorating_.With_.Style_)","Decorating With Style!",false],
["decorations",">plot/params.html#(part._.Decorations)","Decorations",false],
["decorative",">gui/style-delta_.html#(idx._(gentag._196._(lib._scribblings/gui/gui..scrbl)))",[7,"'decorative"],false],
["decorative",">draw/font_.html#(idx._(gentag._29._(lib._scribblings/draw/draw..scrbl)))",[7,"'decorative"],false],
["def+int",">scribble/eval.html#(form._((lib._scribble/eval..rkt)._def+int))",[0,[1,"def+int"]],["scribble/eval"]],
["def-syntaxes",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._def-syntaxes))",[0,[2,"def-syntaxes"]],["compiler/zo-structs"]],
["def-syntaxes-dummy",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._def-syntaxes-dummy))",[0,[2,"def-syntaxes-dummy"]],["compiler/zo-structs"]],
["def-syntaxes-ids",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._def-syntaxes-ids))",[0,[2,"def-syntaxes-ids"]],["compiler/zo-structs"]],
["def-syntaxes-max-let-depth",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._def-syntaxes-max-let-depth))",[0,[2,"def-syntaxes-max-let-depth"]],["compiler/zo-structs"]],
["def-syntaxes-prefix",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._def-syntaxes-prefix))",[0,[2,"def-syntaxes-prefix"]],["compiler/zo-structs"]],
["def-syntaxes-rhs",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._def-syntaxes-rhs))",[0,[2,"def-syntaxes-rhs"]],["compiler/zo-structs"]],
["def-syntaxes?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._def-syntaxes~3f))",[0,[2,"def-syntaxes?"]],["compiler/zo-structs"]],
["def-values",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._def-values))",[0,[2,"def-values"]],["compiler/zo-structs"]],
["def-values-ids",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._def-values-ids))",[0,[2,"def-values-ids"]],["compiler/zo-structs"]],
["def-values-rhs",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._def-values-rhs))",[0,[2,"def-values-rhs"]],["compiler/zo-structs"]],
["def-values?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._def-values~3f))",[0,[2,"def-values?"]],["compiler/zo-structs"]],
["default",">web-server/formlets.html#(def._((lib._web-server/formlets/input..rkt)._default))",[0,[2,"default"]],["web-server/formlets/input"]],
["default",">gui/style-delta_.html#(idx._(gentag._184._(lib._scribblings/gui/gui..scrbl)))",[7,"'default"],false],
["default",">gui/style-delta_.html#(idx._(gentag._195._(lib._scribblings/gui/gui..scrbl)))",[7,"'default"],false],
["default",">draw/font_.html#(idx._(gentag._28._(lib._scribblings/draw/draw..scrbl)))",[7,"'default"],false],
["default",">draw/font_.html#(idx._(gentag._42._(lib._scribblings/draw/draw..scrbl)))",[7,"'default"],false],
["default lexer",">syntax-color/index.html#(part._.Default_lexer)","Default lexer",false],
["default ports",">guide/default-ports.html","Default Ports",false],
["default prompt tag",">guide/prompt.html#(tech._default._prompt._tag)","<span style=\"font-style: italic\">default\nprompt tag</span>",false],
["default-_string-type",">foreign/String_Types.html#(def._((lib._ffi/unsafe..rkt)._default-_string-type))",[0,[2,"default-_string-type"]],["ffi/unsafe"]],
["default-attempt-size",">redex/The_Redex_Reference.html#(def._((lib._redex/reduction-semantics..rkt)._default-attempt-size))",[0,[2,"default-attempt-size"]],["redex/reduction-semantics","redex"]],
["default-check-attempts",">redex/The_Redex_Reference.html#(def._((lib._redex/reduction-semantics..rkt)._default-check-attempts))",[0,[2,"default-check-attempts"]],["redex/reduction-semantics","redex"]],
["default-configuration-table-path",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table..rkt)._default-configuration-table-path))",[0,[2,"default-configuration-table-path"]],["web-server/configuration/configuration-table"]],
["default-continuation-prompt-tag",">reference/cont.html#(def._((quote._~23~25kernel)._default-continuation-prompt-tag))",[0,[2,"default-continuation-prompt-tag"]],["racket/base","racket"]],
["default-contour-colors",">plot/params.html#(def._((lib._plot/main..rkt)._default-contour-colors))",[0,[2,"default-contour-colors"]],["plot"]],
["default-contour-fill-colors",">plot/params.html#(def._((lib._plot/main..rkt)._default-contour-fill-colors))",[0,[2,"default-contour-fill-colors"]],["plot"]],
["default-display-is-color?",">graphics/Color_Operations.html#(def._((lib._graphics/graphics..rkt)._default-display-is-color~3f))",[0,[2,"default-display-is-color?"]],["graphics/graphics"]],
["default-face-color",">slideshow/More_Pict_Constructors.html#(def._((lib._slideshow/face..rkt)._default-face-color))",[0,[2,"default-face-color"]],["slideshow/face"]],
["default-font-size",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._default-font-size))",[0,[2,"default-font-size"]],["redex/pict","redex"]],
["default-host-table",">web-server-internal/Web_Servers.html#(idx._(gentag._4._(lib._web-server/scribblings/web-server-internal..scrbl)))","default-host-table",false],
["default-icon-height",">images/Icons.html#(def._((lib._images/icons/style..rkt)._default-icon-height))",[0,[2,"default-icon-height"]],["images/icons/style"]],
["default-icon-material",">images/Icons.html#(def._((lib._images/icons/style..rkt)._default-icon-material))",[0,[2,"default-icon-material"]],["images/icons/style"]],
["default-indices",">web-server-internal/Web_Servers.html#(idx._(gentag._7._(lib._web-server/scribblings/web-server-internal..scrbl)))","default-indices",false],
["default-isosurface-colors",">plot/params.html#(def._((lib._plot/main..rkt)._default-isosurface-colors))",[0,[2,"default-isosurface-colors"]],["plot"]],
["default-isosurface-line-colors",">plot/params.html#(def._((lib._plot/main..rkt)._default-isosurface-line-colors))",[0,[2,"default-isosurface-line-colors"]],["plot"]],
["default-lexer",">syntax-color/index.html#(def._((lib._syntax-color/default-lexer..rkt)._default-lexer))",[0,[2,"default-lexer"]],["syntax-color/default-lexer"]],
["default-module-specs",">web-server-internal/dispatch-servlets.html#(def._((lib._web-server/servlet/setup..rkt)._default-module-specs))",[0,[2,"default-module-specs"]],["web-server/servlet/setup"]],
["default-package-language",">planet/Utility_Libraries.html#(def._((lib._planet/config..rkt)._.D.E.F.A.U.L.T-.P.A.C.K.A.G.E-.L.A.N.G.U.A.G.E))",[0,[2,"DEFAULT-PACKAGE-LANGUAGE"]],["planet/config"]],
["default-pretty-printer",">redex/The_Redex_Reference.html#(def._((lib._redex/gui..rkt)._default-pretty-printer))",[0,[2,"default-pretty-printer"]],["redex/gui","redex"]],
["default-random-source",">srfi-std/srfi-27.html#default-random-source",[0,[2,"default-random-source"]],["srfi/27"]],
["default-router-port",">reference/distributed-places.html#(def._((lib._racket/place/distributed..rkt)._.D.E.F.A.U.L.T-.R.O.U.T.E.R-.P.O.R.T))",[0,[2,"DEFAULT-ROUTER-PORT"]],["racket/place/distributed"]],
["default-servlet-timeout",">web-server-internal/Web_Servers.html#(idx._(gentag._18._(lib._web-server/scribblings/web-server-internal..scrbl)))","default-servlet-timeout",false],
["default-settings",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3alanguage~3c~25~3e)._default-settings))",[[0,[2,"default-settings"]],[14,[" (method of ",[0,[2,"drracket:language:language<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["default-settings",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3amodule-based-language~3c~25~3e)._default-settings))",[[0,[2,"default-settings"]],[14,[" (method of ",[0,[2,"drracket:language:module-based-language<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["default-settings",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3asimple-module-based-language-~3emodule-based-language-mixin)._default-settings))",[[0,[2,"default-settings"]],[14,[" (method of ",[0,[2,"drracket:language:simple-module-based-language->module-based-language-mixin"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["default-settings?",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3alanguage~3c~25~3e)._default-settings~3f))",[[0,[2,"default-settings?"]],[14,[" (method of ",[0,[2,"drracket:language:language<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["default-settings?",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3amodule-based-language~3c~25~3e)._default-settings~3f))",[[0,[2,"default-settings?"]],[14,[" (method of ",[0,[2,"drracket:language:module-based-language<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["default-settings?",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3asimple-module-based-language-~3emodule-based-language-mixin)._default-settings~3f))",[[0,[2,"default-settings?"]],[14,[" (method of ",[0,[2,"drracket:language:simple-module-based-language->module-based-language-mixin"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["default-stuffer",">web-server/stateless.html#(def._((lib._web-server/lang/stuff-url..rkt)._default-stuffer))",[0,[2,"default-stuffer"]],["web-server/lang/stuff-url"]],
["default-style",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._default-style))",[0,[2,"default-style"]],["redex/pict","redex"]],
["default-style-name",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._default-style-name))",[[0,[2,"default-style-name"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["default-style-name",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3aforeground-color-mixin)._default-style-name))",[[0,[2,"default-style-name"]],[14,[" (method of ",[0,[2,"text:foreground-color-mixin"]],")"]]],["framework"]],
["defboolparam",">scribble/doc-forms.html#(form._((lib._scribble/manual..rkt)._defboolparam))",[0,[1,"defboolparam"]],["scribble/manual"]],
["defclass",">scribble/doc-classes.html#(form._((lib._scribble/manual..rkt)._defclass))",[0,[1,"defclass"]],["scribble/manual"]],
["defclass/title",">scribble/doc-classes.html#(form._((lib._scribble/manual..rkt)._defclass/title))",[0,[1,"defclass/title"]],["scribble/manual"]],
["defcommand",">preprocessor/mztext.html#(def._((lib._preprocessor/mztext..rkt)._defcommand))",[0,[2,"defcommand"]],["preprocessor/mztext"]],
["defconstructor",">scribble/doc-classes.html#(form._((lib._scribble/manual..rkt)._defconstructor))",[0,[1,"defconstructor"]],["scribble/manual"]],
["defconstructor*/make",">scribble/doc-classes.html#(form._((lib._scribble/manual..rkt)._defconstructor*/make))",[0,[1,"defconstructor*/make"]],["scribble/manual"]],
["defconstructor/auto-super",">scribble/doc-classes.html#(form._((lib._scribble/manual..rkt)._defconstructor/auto-super))",[0,[1,"defconstructor/auto-super"]],["scribble/manual"]],
["defconstructor/make",">scribble/doc-classes.html#(form._((lib._scribble/manual..rkt)._defconstructor/make))",[0,[1,"defconstructor/make"]],["scribble/manual"]],
["defexamples",">scribble/eval.html#(form._((lib._scribble/eval..rkt)._defexamples))",[0,[1,"defexamples"]],["scribble/eval"]],
["defform",">scribble/doc-forms.html#(form._((lib._scribble/manual..rkt)._defform))",[0,[1,"defform"]],["scribble/manual"]],
["defform*",">scribble/doc-forms.html#(form._((lib._scribble/manual..rkt)._defform*))",[0,[1,"defform*"]],["scribble/manual"]],
["defform*/subs",">scribble/doc-forms.html#(form._((lib._scribble/manual..rkt)._defform*/subs))",[0,[1,"defform*/subs"]],["scribble/manual"]],
["defform/none",">scribble/doc-forms.html#(form._((lib._scribble/manual..rkt)._defform/none))",[0,[1,"defform/none"]],["scribble/manual"]],
["defform/subs",">scribble/doc-forms.html#(form._((lib._scribble/manual..rkt)._defform/subs))",[0,[1,"defform/subs"]],["scribble/manual"]],
["defidentifier",">scribble/doc-forms.html#(def._((lib._scribble/manual..rkt)._defidentifier))",[0,[2,"defidentifier"]],["scribble/manual"]],
["defidform",">scribble/doc-forms.html#(form._((lib._scribble/manual..rkt)._defidform))",[0,[1,"defidform"]],["scribble/manual"]],
["defidform/inline",">scribble/doc-forms.html#(form._((lib._scribble/manual..rkt)._defidform/inline))",[0,[1,"defidform/inline"]],["scribble/manual"]],
["define",">reference/define.html#(form._((lib._racket/private/base..rkt)._define))",[0,[1,"define"]],["racket/base","racket"]],
["define",">r5rs-std/r5rs-Z-H-8.html#%_idx_194",[0,[1,"define"]],["r5rs"]],
["define",">r6rs-std/r6rs-Z-H-14.html#node_idx_352",[0,[1,"define"]],["rnrs/base-6"]],
["define",">htdp-langs/advanced.html#(form._((lib._lang/htdp-advanced..rkt)._define))",[0,[1,"define"]],["lang/htdp-advanced"]],
["define",">htdp-langs/beginner.html#(form._((lib._lang/htdp-beginner..rkt)._define))",[0,[1,"define"]],["lang/htdp-beginner"]],
["define",">htdp-langs/beginner-abbr.html#(form._((lib._lang/htdp-beginner-abbr..rkt)._define))",[0,[1,"define"]],["lang/htdp-beginner-abbr"]],
["define",">htdp-langs/intermediate.html#(form._((lib._lang/htdp-intermediate..rkt)._define))",[0,[1,"define"]],["lang/htdp-intermediate"]],
["define",">htdp-langs/intermediate-lam.html#(form._((lib._lang/htdp-intermediate-lambda..rkt)._define))",[0,[1,"define"]],["lang/htdp-intermediate-lambda"]],
["define",">deinprogramm/Definitionen.html#(form._((lib._deinprogramm/.D.Md.A..rkt)._define))",[0,[1,"define"]],["deinprogramm/DMdA-beginner"]],
["define",">deinprogramm/advanced-definitions.html#(form._((lib._deinprogramm/.D.Md.A-deflam..rkt)._define))",[0,[1,"define"]],["deinprogramm/DMdA-deflam"]],
["define",">lazy/index.html#(form._((lib._lazy/main..rkt)._define))",[0,[1,"define"]],["lazy"]],
["define",">mzscheme/Old_Syntactic_Forms.html#(form._((lib._mzscheme/main..rkt)._define))",[0,[1,"define"]],["mzscheme"]],
["define",">plai/mutator.html#(form._((lib._plai/mutator..rkt)._define))",[0,[1,"define"]],["plai/mutator"]],
["define",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._define))",[0,[1,"define"]],["typed/racket/base","typed/racket"]],
["define remote server",">reference/distributed-places.html#(part._.Define_.Remote_.Server)","Define Remote Server",false],
["define*",">reference/package.html#(form._((lib._racket/package..rkt)._define*))",[0,[1,"define*"]],["racket/package"]],
["define*-syntax",">reference/package.html#(form._((lib._racket/package..rkt)._define*-syntax))",[0,[1,"define*-syntax"]],["racket/package"]],
["define*-syntaxes",">reference/package.html#(form._((lib._racket/package..rkt)._define*-syntaxes))",[0,[1,"define*-syntaxes"]],["racket/package"]],
["define*-values",">reference/package.html#(form._((lib._racket/package..rkt)._define*-values))",[0,[1,"define*-values"]],["racket/package"]],
["define-bibtex-cite",">scriblib/bibtex.html#(form._((lib._scriblib/bibtex..rkt)._define-bibtex-cite))",[0,[1,"define-bibtex-cite"]],["scriblib/bibtex"]],
["define-bidi-match-expander",">web-server/dispatch.html#(form._((lib._web-server/dispatch/extend..rkt)._define-bidi-match-expander))",[0,[1,"define-bidi-match-expander"]],["web-server/dispatch/extend"]],
["define-binary-check",">rackunit/api.html#(form._((lib._rackunit/main..rkt)._define-binary-check))",[0,[1,"define-binary-check"]],["rackunit"]],
["define-c",">foreign/Loading_Foreign_Libraries.html#(form._((lib._ffi/unsafe..rkt)._define-c))",[0,[1,"define-c"]],["ffi/unsafe"]],
["define-cast",">reference/distributed-places.html#(form._((lib._racket/place/define-remote-server..rkt)._define-cast))",[0,"define-cast"],["racket/place/define-remote-server"]],
["define-check",">rackunit/api.html#(form._((lib._rackunit/main..rkt)._define-check))",[0,[1,"define-check"]],["rackunit"]],
["define-cite",">scriblib/autobib.html#(form._((lib._scriblib/autobib..rkt)._define-cite))",[0,[1,"define-cite"]],["scriblib/autobib"]],
["define-closure",">web-server-internal/closure.html#(form._((lib._web-server/private/define-closure..rkt)._define-closure))",[0,[1,"define-closure"]],["web-server/private/define-closure"]],
["define-code",">scribble/scheme.html#(form._((lib._scribble/racket..rkt)._define-code))",[0,[1,"define-code"]],["scribble/racket","scribble/scheme"]],
["define-code",">slideshow/Typesetting_Racket_Code.html#(form._((lib._slideshow/code..rkt)._define-code))",[0,[1,"define-code"]],["slideshow/code"]],
["define-coercion-match-expander",">web-server/dispatch.html#(form._((lib._web-server/dispatch/extend..rkt)._define-coercion-match-expander))",[0,[1,"define-coercion-match-expander"]],["web-server/dispatch/extend"]],
["define-com-interface",">foreign/com-intf.html#(form._((lib._ffi/unsafe/com..rkt)._define-com-interface))",[0,[1,"define-com-interface"]],["ffi/unsafe/com"]],
["define-compound-unit",">reference/linkinference.html#(form._((lib._mzlib/unit..rkt)._define-compound-unit))",[0,[1,"define-compound-unit"]],["racket/unit","racket"]],
["define-compound-unit/infer",">reference/linkinference.html#(form._((lib._mzlib/unit..rkt)._define-compound-unit/infer))",[0,[1,"define-compound-unit/infer"]],["racket/unit","racket"]],
["define-condition-type",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_404",[0,[1,"define-condition-type"]],["rnrs/conditions-6"]],
["define-container",">web-server/dispatch.html#(form._((lib._web-server/dispatch..rkt)._define-container))",[0,[1,"define-container"]],["web-server/dispatch"]],
["define-contract-struct",">reference/Lazy_Data-structure_Contracts.html#(form._((lib._racket/contract/private/ds..rkt)._define-contract-struct))",[0,[1,"define-contract-struct"]],["racket/contract","racket"]],
["define-conventions",">syntax/Literal_Sets_and_Conventions.html#(form._((lib._syntax/parse..rkt)._define-conventions))",[0,[1,"define-conventions"]],["syntax/parse"]],
["define-cpointer-type",">foreign/foreign_tagged-pointers.html#(form._((lib._ffi/unsafe..rkt)._define-cpointer-type))",[0,[1,"define-cpointer-type"]],["ffi/unsafe"]],
["define-cstruct",">foreign/C_Struct_Types.html#(form._((lib._ffi/unsafe..rkt)._define-cstruct))",[0,[1,"define-cstruct"]],["ffi/unsafe"]],
["define-datatype",">htdp-langs/advanced.html#(form._((lib._lang/htdp-advanced..rkt)._define-datatype))",[0,[1,"define-datatype"]],["lang/htdp-advanced"]],
["define-datatype",">eopl/index.html#(form._((lib._eopl/eopl..rkt)._define-datatype))",[0,[1,"define-datatype"]],["eopl"]],
["define-eh-alternative-set",">syntax/Experimental.html#(form._((lib._syntax/parse/experimental/eh..rkt)._define-eh-alternative-set))",[0,[1,"define-eh-alternative-set"]],["syntax/parse/experimental/eh"]],
["define-empty-tokens",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex..rkt)._define-empty-tokens))",[0,[1,"define-empty-tokens"]],["parser-tools/lex"]],
["define-enumeration",">r6rs-lib-std/r6rs-lib-Z-H-15.html#node_idx_1262",[0,[1,"define-enumeration"]],["rnrs/enums-6"]],
["define-exec-code",">slideshow/Typesetting_Racket_Code.html#(form._((lib._slideshow/code..rkt)._define-exec-code))",[0,[1,"define-exec-code"]],["slideshow/code"]],
["define-exec-code/scale",">slideshow/Typesetting_Racket_Code.html#(form._((lib._slideshow/code..rkt)._define-exec-code/scale))",[0,[1,"define-exec-code/scale"]],["slideshow/code"]],
["define-extended-judgment-form",">redex/The_Redex_Reference.html#(form._((lib._redex/reduction-semantics..rkt)._define-extended-judgment-form))",[0,[1,"define-extended-judgment-form"]],["redex/reduction-semantics","redex"]],
["define-extended-language",">redex/The_Redex_Reference.html#(form._((lib._redex/reduction-semantics..rkt)._define-extended-language))",[0,[1,"define-extended-language"]],["redex/reduction-semantics","redex"]],
["define-ffi-definer",">foreign/Defining_Bindings.html#(form._((lib._ffi/unsafe/define..rkt)._define-ffi-definer))",[0,[1,"define-ffi-definer"]],["ffi/unsafe/define"]],
["define-footnote",">scriblib/footnotes.html#(form._((lib._scriblib/footnote..rkt)._define-footnote))",[0,[1,"define-footnote"]],["scriblib/footnote"]],
["define-for-syntax",">reference/define.html#(form._((lib._racket/private/base..rkt)._define-for-syntax))",[0,[1,"define-for-syntax"]],["racket/base","racket"]],
["define-for-syntax",">mzscheme/Old_Syntactic_Forms.html#(form._((lib._mzscheme/main..rkt)._define-for-syntax))",[0,[1,"define-for-syntax"]],["mzscheme"]],
["define-fun-syntax",">foreign/foreign_procedures.html#(form._((lib._ffi/unsafe..rkt)._define-fun-syntax))",[0,[1,"define-fun-syntax"]],["ffi/unsafe"]],
["define-generics",">reference/struct-generics.html#(form._((lib._racket/generic..rkt)._define-generics))",[0,[1,"define-generics"]],["racket/generic"]],
["define-higher-order-primitive",">htdp/index.html#(form._((lib._lang/prim..rkt)._define-higher-order-primitive))",[0,[1,"define-higher-order-primitive"]],["lang/prim"]],
["define-interface",">unstable/class-iop.html#(form._((lib._unstable/class-iop..rkt)._define-interface))",[0,[1,"define-interface"]],["unstable/class-iop"]],
["define-interface-expander",">unstable/class-iop.html#(form._((lib._unstable/class-iop..rkt)._define-interface-expander))",[0,[1,"define-interface-expander"]],["unstable/class-iop"]],
["define-interface/dynamic",">unstable/class-iop.html#(form._((lib._unstable/class-iop..rkt)._define-interface/dynamic))",[0,[1,"define-interface/dynamic"]],["unstable/class-iop"]],
["define-judgment-form",">redex/The_Redex_Reference.html#(form._((lib._redex/reduction-semantics..rkt)._define-judgment-form))",[0,[1,"define-judgment-form"]],["redex/reduction-semantics","redex"]],
["define-language",">redex/The_Redex_Reference.html#(form._((lib._redex/reduction-semantics..rkt)._define-language))",[0,[1,"define-language"]],["redex/reduction-semantics","redex"]],
["define-lex-abbrev",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex..rkt)._define-lex-abbrev))",[0,[1,"define-lex-abbrev"]],["parser-tools/lex"]],
["define-lex-abbrevs",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex..rkt)._define-lex-abbrevs))",[0,[1,"define-lex-abbrevs"]],["parser-tools/lex"]],
["define-lex-trans",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex..rkt)._define-lex-trans))",[0,[1,"define-lex-trans"]],["parser-tools/lex"]],
["define-literal-set",">syntax/Literal_Sets_and_Conventions.html#(form._((lib._syntax/parse..rkt)._define-literal-set))",[0,[1,"define-literal-set"]],["syntax/parse"]],
["define-local-member-name",">reference/createclass.html#(form._((lib._racket/private/class-internal..rkt)._define-local-member-name))",[0,[1,"define-local-member-name"]],["racket/class","racket"]],
["define-macro",">mzlib/mzlib_defmacro.html#(form._((lib._mzlib/defmacro..rkt)._define-macro))",[0,[1,"define-macro"]],["mzlib/defmacro"]],
["define-match-expander",">reference/match.html#(form._((lib._racket/match..rkt)._define-match-expander))",[0,[1,"define-match-expander"]],["racket/match","racket"]],
["define-match-expander",">mzlib/mzlib_match.html#(form._((lib._mzlib/match..rkt)._define-match-expander))",[0,[1,"define-match-expander"]],["mzlib/match"]],
["define-match-expander",">mzlib/mzlib_plt-match.html#(form._((lib._mzlib/plt-match..rkt)._define-match-expander))",[0,[1,"define-match-expander"]],["mzlib/plt-match"]],
["define-member-name",">reference/createclass.html#(form._((lib._racket/private/class-internal..rkt)._define-member-name))",[0,[1,"define-member-name"]],["racket/class","racket"]],
["define-metafunction",">redex/The_Redex_Reference.html#(form._((lib._redex/reduction-semantics..rkt)._define-metafunction))",[0,[1,"define-metafunction"]],["redex/reduction-semantics","redex"]],
["define-metafunction/extension",">redex/The_Redex_Reference.html#(form._((lib._redex/reduction-semantics..rkt)._define-metafunction/extension))",[0,[1,"define-metafunction/extension"]],["redex/reduction-semantics","redex"]],
["define-named-remote-server",">reference/distributed-places.html#(form._((lib._racket/place/define-remote-server..rkt)._define-named-remote-server))",[0,[1,"define-named-remote-server"]],["racket/place/define-remote-server"]],
["define-namespace-anchor",">reference/Namespaces.html#(form._((lib._racket/private/base..rkt)._define-namespace-anchor))",[0,[1,"define-namespace-anchor"]],["racket/base","racket"]],
["define-native",">web-server/stateless.html#(form._((lib._web-server/lang/native..rkt)._define-native))",[0,[1,"define-native"]],["web-server/lang/native"]],
["define-notify",">unstable/gui-notify.html#(form._((lib._unstable/gui/notify..rkt)._define-notify))",[0,[1,"define-notify"]],["unstable/gui/notify"]],
["define-objc-class",">foreign/Objective-C_FFI.html#(form._((lib._ffi/unsafe/objc..rkt)._define-objc-class))",[0,[1,"define-objc-class"]],["ffi/unsafe/objc"]],
["define-objc-mixin",">foreign/Objective-C_FFI.html#(form._((lib._ffi/unsafe/objc..rkt)._define-objc-mixin))",[0,[1,"define-objc-mixin"]],["ffi/unsafe/objc"]],
["define-opt/c",">reference/contract-utilities.html#(form._((lib._racket/contract/private/opt..rkt)._define-opt/c))",[0,[1,"define-opt/c"]],["racket/contract/base","racket/contract","racket"]],
["define-package",">reference/package.html#(form._((lib._racket/package..rkt)._define-package))",[0,[1,"define-package"]],["racket/package"]],
["define-parameter-group",">unstable/Parameter_Groups.html#(form._((lib._unstable/parameter-group..rkt)._define-parameter-group))",[0,[1,"define-parameter-group"]],["unstable/parameter-group"]],
["define-predicate",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._define-predicate))",[0,[1,"define-predicate"]],["typed/racket/base","typed/racket"]],
["define-primitive",">htdp/index.html#(form._((lib._lang/prim..rkt)._define-primitive))",[0,[1,"define-primitive"]],["lang/prim"]],
["define-primitive-splicing-syntax-class",">syntax/Experimental.html#(form._((lib._syntax/parse/experimental/splicing..rkt)._define-primitive-splicing-syntax-class))",[0,[1,"define-primitive-splicing-syntax-class"]],["syntax/parse/experimental/splicing"]],
["define-provide-syntax",">reference/define.html#(form._((lib._racket/provide-syntax..rkt)._define-provide-syntax))",[0,[1,"define-provide-syntax"]],["racket/provide-syntax"]],
["define-re-transformer",">unstable/Automata__Compiling_State_Machines.html#(form._((lib._unstable/automata/re..rkt)._define-re-transformer))",[0,[1,"define-re-transformer"]],["unstable/automata/re"]],
["define-record-procedures",">deinprogramm/Record-Typ-Definitionen.html#(form._((lib._deinprogramm/.D.Md.A..rkt)._define-record-procedures))",[0,[1,"define-record-procedures"]],["deinprogramm/DMdA-beginner"]],
["define-record-procedures-2",">deinprogramm/define-record-procedures-2.html",[0,[1,"define-record-procedures-2"]],false],
["define-record-procedures-2",">deinprogramm/define-record-procedures-2.html#(form._((lib._deinprogramm/.D.Md.A..rkt)._define-record-procedures-2))",[0,[1,"define-record-procedures-2"]],["deinprogramm/DMdA"]],
["define-record-procedures-parametric",">deinprogramm/Parametrische_Record-Typ-Definitionen.html#(form._((lib._deinprogramm/.D.Md.A..rkt)._define-record-procedures-parametric))",[0,[1,"define-record-procedures-parametric"]],["deinprogramm/DMdA-beginner"]],
["define-record-procedures-parametric-2",">deinprogramm/define-record-procedures-parametric-2.html",[0,[1,"define-record-procedures-parametric-2"]],false],
["define-record-procedures-parametric-2",">deinprogramm/define-record-procedures-parametric-2.html#(form._((lib._deinprogramm/.D.Md.A..rkt)._define-record-procedures-parametric-2))",[0,[1,"define-record-procedures-parametric-2"]],["deinprogramm/DMdA"]],
["define-record-type",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_288",[0,[1,"define-record-type"]],["rnrs/records/syntactic-6"]],
["define-record-type",">srfi-std/srfi-9.html#define-record-type",[0,[1,"define-record-type"]],["srfi/9"]],
["define-relation",">redex/The_Redex_Reference.html#(form._((lib._redex/reduction-semantics..rkt)._define-relation))",[0,[1,"define-relation"]],["redex/reduction-semantics","redex"]],
["define-remote-server",">reference/distributed-places.html#(form._((lib._racket/place/define-remote-server..rkt)._define-remote-server))",[0,[1,"define-remote-server"]],["racket/place/define-remote-server"]],
["define-require-syntax",">reference/define.html#(form._((lib._racket/require-syntax..rkt)._define-require-syntax))",[0,[1,"define-require-syntax"]],["racket/require-syntax"]],
["define-rpc",">reference/distributed-places.html#(form._((lib._racket/place/define-remote-server..rkt)._define-rpc))",[0,"define-rpc"],["racket/place/define-remote-server"]],
["define-runtime-module-path",">reference/Filesystem.html#(form._((lib._racket/runtime-path..rkt)._define-runtime-module-path))",[0,[1,"define-runtime-module-path"]],["racket/runtime-path"]],
["define-runtime-module-path-index",">reference/Filesystem.html#(form._((lib._racket/runtime-path..rkt)._define-runtime-module-path-index))",[0,[1,"define-runtime-module-path-index"]],["racket/runtime-path"]],
["define-runtime-path",">reference/Filesystem.html#(form._((lib._racket/runtime-path..rkt)._define-runtime-path))",[0,[1,"define-runtime-path"]],["racket/runtime-path"]],
["define-runtime-path-list",">reference/Filesystem.html#(form._((lib._racket/runtime-path..rkt)._define-runtime-path-list))",[0,[1,"define-runtime-path-list"]],["racket/runtime-path"]],
["define-runtime-paths",">reference/Filesystem.html#(form._((lib._racket/runtime-path..rkt)._define-runtime-paths))",[0,[1,"define-runtime-paths"]],["racket/runtime-path"]],
["define-sequence-syntax",">reference/for.html#(form._((lib._racket/private/base..rkt)._define-sequence-syntax))",[0,[1,"define-sequence-syntax"]],["racket/base","racket"]],
["define-serializable-class",">reference/objectserialize.html#(form._((lib._racket/private/class-internal..rkt)._define-serializable-class))",[0,[1,"define-serializable-class"]],["racket/class","racket"]],
["define-serializable-class*",">reference/objectserialize.html#(form._((lib._racket/private/class-internal..rkt)._define-serializable-class*))",[0,[1,"define-serializable-class*"]],["racket/class","racket"]],
["define-serializable-struct",">reference/serialization.html#(form._((lib._racket/serialize..rkt)._define-serializable-struct))",[0,[1,"define-serializable-struct"]],["racket/serialize"]],
["define-serializable-struct",">mzlib/mzlib_serialize.html#(form._((lib._mzlib/serialize..rkt)._define-serializable-struct))",[0,[1,"define-serializable-struct"]],["mzlib/serialize"]],
["define-serializable-struct/versions",">reference/serialization.html#(form._((lib._racket/serialize..rkt)._define-serializable-struct/versions))",[0,[1,"define-serializable-struct/versions"]],["racket/serialize"]],
["define-serializable-struct/versions",">mzlib/mzlib_serialize.html#(form._((lib._mzlib/serialize..rkt)._define-serializable-struct/versions))",[0,[1,"define-serializable-struct/versions"]],["mzlib/serialize"]],
["define-signature",">reference/creatingunits.html#(form._((lib._mzlib/unit..rkt)._define-signature))",[0,[1,"define-signature"]],["racket/unit","racket"]],
["define-signature-form",">reference/define-sig-form.html#(form._((lib._mzlib/unit..rkt)._define-signature-form))",[0,[1,"define-signature-form"]],["racket/unit","racket"]],
["define-simple-check",">rackunit/api.html#(form._((lib._rackunit/main..rkt)._define-simple-check))",[0,[1,"define-simple-check"]],["rackunit"]],
["define-simple-macro",">syntax/Defining_Simple_Macros.html#(form._((lib._syntax/parse/define..rkt)._define-simple-macro))",[0,[1,"define-simple-macro"]],["syntax/parse/define"]],
["define-splicing-syntax-class",">syntax/stxparse-specifying.html#(form._((lib._syntax/parse..rkt)._define-splicing-syntax-class))",[0,[1,"define-splicing-syntax-class"]],["syntax/parse"]],
["define-state",">reference/distributed-places.html#(form._((lib._racket/place/define-remote-server..rkt)._define-state))",[0,"define-state"],["racket/place/define-remote-server"]],
["define-stream",">srfi-std/srfi-41/srfi-41.html#define-stream",[0,[1,"define-stream"]],["srfi/41"]],
["define-struct",">reference/define-struct.html#(form._((lib._racket/private/base..rkt)._define-struct))",[0,[1,"define-struct"]],["racket/base","racket"]],
["define-struct",">htdp-langs/advanced.html#(form._((lib._lang/htdp-advanced..rkt)._define-struct))",[0,[1,"define-struct"]],["lang/htdp-advanced"]],
["define-struct",">htdp-langs/beginner.html#(form._((lib._lang/htdp-beginner..rkt)._define-struct))",[0,[1,"define-struct"]],["lang/htdp-beginner"]],
["define-struct",">htdp-langs/beginner-abbr.html#(form._((lib._lang/htdp-beginner-abbr..rkt)._define-struct))",[0,[1,"define-struct"]],["lang/htdp-beginner-abbr"]],
["define-struct",">htdp-langs/intermediate.html#(form._((lib._lang/htdp-intermediate..rkt)._define-struct))",[0,[1,"define-struct"]],["lang/htdp-intermediate"]],
["define-struct",">htdp-langs/intermediate-lam.html#(form._((lib._lang/htdp-intermediate-lambda..rkt)._define-struct))",[0,[1,"define-struct"]],["lang/htdp-intermediate-lambda"]],
["define-struct",">mzscheme/Old_Syntactic_Forms.html#(form._((lib._mzscheme/main..rkt)._define-struct))",[0,[1,"define-struct"]],["mzscheme"]],
["define-struct/contract",">reference/attaching-contracts-to-values.html#(form._((lib._racket/contract/region..rkt)._define-struct/contract))",[0,[1,"define-struct/contract"]],["racket/contract/region","racket/contract","racket"]],
["define-struct/derived",">reference/define-struct.html#(form._((lib._racket/private/base..rkt)._define-struct/derived))",[0,[1,"define-struct/derived"]],["racket/base","racket"]],
["define-struct/exec:",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._define-struct/exec~3a))",[0,[1,"define-struct/exec:"]],["typed/racket/base","typed/racket"]],
["define-struct/properties",">mzlib/mzlib_struct.html#(form._((lib._mzlib/struct..rkt)._define-struct/properties))",[0,[1,"define-struct/properties"]],["mzlib/struct"]],
["define-struct:",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._define-struct~3a))",[0,[1,"define-struct:"]],["typed/racket/base","typed/racket"]],
["define-structure",">mzlib/mzlib_compat.html#(form._((lib._mzlib/compat..rkt)._define-structure))",[0,[1,"define-structure"]],["mzlib/compat"]],
["define-syntax",">reference/define.html#(form._((lib._racket/private/base..rkt)._define-syntax))",[0,[1,"define-syntax"]],["racket/base","racket"]],
["define-syntax",">r5rs-std/r5rs-Z-H-8.html#%_idx_202",[0,[1,"define-syntax"]],["r5rs"]],
["define-syntax",">r6rs-std/r6rs-Z-H-14.html#node_idx_358",[0,[1,"define-syntax"]],["rnrs/base-6"]],
["define-syntax",">mzscheme/Old_Syntactic_Forms.html#(form._((lib._mzscheme/main..rkt)._define-syntax))",[0,[1,"define-syntax"]],["mzscheme"]],
["define-syntax and syntax-rules",">guide/pattern-macros.html#(part._define-syntax_and_syntax-rules)",[[0,[1,"define-syntax"]]," and ",[0,[1,"syntax-rules"]]],false],
["define-syntax-class",">syntax/stxparse-specifying.html#(form._((lib._syntax/parse..rkt)._define-syntax-class))",[0,[1,"define-syntax-class"]],["syntax/parse"]],
["define-syntax-class/specialize",">syntax/Experimental.html#(form._((lib._syntax/parse/experimental/specialize..rkt)._define-syntax-class/specialize))",[0,[1,"define-syntax-class/specialize"]],["syntax/parse/experimental/specialize"]],
["define-syntax-parameter",">reference/stxparam.html#(form._((lib._racket/stxparam..rkt)._define-syntax-parameter))",[0,[1,"define-syntax-parameter"]],["racket/stxparam"]],
["define-syntax-rule",">guide/pattern-macros.html#(part._define-syntax-rule)",[0,[1,"define-syntax-rule"]],false],
["define-syntax-rule",">reference/stx-patterns.html#(form._((lib._racket/private/misc..rkt)._define-syntax-rule))",[0,[1,"define-syntax-rule"]],["racket/base","racket"]],
["define-syntax-set",">mzlib/mzlib_etc.html#(form._((lib._mzlib/etc..rkt)._define-syntax-set))",[0,[1,"define-syntax-set"]],["mzlib/etc"]],
["define-syntaxes",">reference/define.html#(form._((quote._~23~25kernel)._define-syntaxes))",[0,[1,"define-syntaxes"]],["racket/base","racket"]],
["define-template-metafunction",">syntax/Experimental.html#(form._((lib._syntax/parse/experimental/template..rkt)._define-template-metafunction))",[0,[1,"define-template-metafunction"]],["syntax/parse/experimental/template"]],
["define-term",">redex/The_Redex_Reference.html#(form._((lib._redex/reduction-semantics..rkt)._define-term))",[0,[1,"define-term"]],["redex/reduction-semantics","redex"]],
["define-test-suite",">rackunit/api.html#(form._((lib._rackunit/main..rkt)._define-test-suite))",[0,[1,"define-test-suite"]],["rackunit"]],
["define-tokens",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex..rkt)._define-tokens))",[0,[1,"define-tokens"]],["parser-tools/lex"]],
["define-type",">plai/plai-scheme.html#(form._((lib._plai/main..rkt)._define-type))",[0,[1,"define-type"]],["plai"]],
["define-type",">ts-reference/special-forms.html#(form._((lib._typed/racket/base..rkt)._define-type))",[0,[1,"define-type"]],["typed/racket/base","typed/racket"]],
["define-type-alias",">ts-reference/Legacy_Forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._define-type-alias))",[0,[1,"define-type-alias"]],["typed/racket/base","typed/racket"]],
["define-typed-struct",">ts-reference/Legacy_Forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._define-typed-struct))",[0,[1,"define-typed-struct"]],["typed/racket/base","typed/racket"]],
["define-typed-struct/exec",">ts-reference/Experimental_Features.html#(form._((lib._typed-racket/base-env/prims..rkt)._define-typed-struct/exec))",[0,[1,"define-typed-struct/exec"]],["typed/racket/base","typed/racket"]],
["define-union-language",">redex/The_Redex_Reference.html#(form._((lib._redex/reduction-semantics..rkt)._define-union-language))",[0,[1,"define-union-language"]],["redex/reduction-semantics","redex"]],
["define-unit",">reference/linkinference.html#(form._((lib._mzlib/unit..rkt)._define-unit))",[0,[1,"define-unit"]],["racket/unit","racket"]],
["define-unit-binding",">reference/linkinference.html#(form._((lib._mzlib/unit..rkt)._define-unit-binding))",[0,[1,"define-unit-binding"]],["racket/unit","racket"]],
["define-unit-from-context",">reference/Generating_A_Unit_from_Context.html#(form._((lib._mzlib/unit..rkt)._define-unit-from-context))",[0,[1,"define-unit-from-context"]],["racket/unit","racket"]],
["define-unit/contract",">reference/unitcontracts.html#(form._((lib._mzlib/unit..rkt)._define-unit/contract))",[0,[1,"define-unit/contract"]],["racket/unit","racket"]],
["define-unit/new-import-export",">reference/Structural_Matching.html#(form._((lib._mzlib/unit..rkt)._define-unit/new-import-export))",[0,[1,"define-unit/new-import-export"]],["racket/unit","racket"]],
["define-unit/s",">reference/Structural_Matching.html#(form._((lib._mzlib/unit..rkt)._define-unit/s))",[0,[1,"define-unit/s"]],["racket/unit","racket"]],
["define-unsafer",">scheme/scheme_foreign.html#(form._((lib._scheme/foreign..rkt)._define-unsafer))",[0,[1,"define-unsafer"]],["scheme/foreign"]],
["define-values",">reference/define.html#(form._((quote._~23~25kernel)._define-values))",[0,[1,"define-values"]],["racket/base","racket"]],
["define-values",">lazy/index.html#(form._((lib._lazy/main..rkt)._define-values))",[0,[1,"define-values"]],["lazy"]],
["define-values",">plai/mutator.html#(form._((lib._plai/mutator..rkt)._define-values))",[0,[1,"define-values"]],["plai/mutator"]],
["define-values-for-export",">reference/creatingunits.html#(form._((lib._mzlib/unit..rkt)._define-values-for-export))",[0,[1,"define-values-for-export"]],["racket/unit","racket"]],
["define-values-for-syntax",">reference/define.html#(form._((lib._racket/private/define..rkt)._define-values-for-syntax))",[0,[1,"define-values-for-syntax"]],["racket/base","racket"]],
["define-values/invoke-unit",">reference/invokingunits.html#(form._((lib._mzlib/unit..rkt)._define-values/invoke-unit))",[0,[1,"define-values/invoke-unit"]],["racket/unit","racket"]],
["define-values/invoke-unit/infer",">reference/linkinference.html#(form._((lib._mzlib/unit..rkt)._define-values/invoke-unit/infer))",[0,[1,"define-values/invoke-unit/infer"]],["racket/unit","racket"]],
["define/augment",">reference/createclass.html#(form._((lib._racket/private/class-internal..rkt)._define/augment))",[0,[1,"define/augment"]],["racket/class","racket"]],
["define/augment-final",">reference/createclass.html#(form._((lib._racket/private/class-internal..rkt)._define/augment-final))",[0,[1,"define/augment-final"]],["racket/class","racket"]],
["define/augment/debug",">unstable/Debugging.html#(form._((lib._unstable/debug..rkt)._define/augment/debug))",[0,[1,"define/augment/debug"]],["unstable/debug"]],
["define/augride",">reference/createclass.html#(form._((lib._racket/private/class-internal..rkt)._define/augride))",[0,[1,"define/augride"]],["racket/class","racket"]],
["define/contract",">reference/attaching-contracts-to-values.html#(form._((lib._racket/contract/region..rkt)._define/contract))",[0,[1,"define/contract"]],["racket/contract/region","racket/contract","racket"]],
["define/contract",">mzlib/mzlib_contract.html#(form._((lib._mzlib/contract..rkt)._define/contract))",[0,[1,"define/contract"]],["mzlib/contract"]],
["define/debug",">unstable/Debugging.html#(form._((lib._unstable/debug..rkt)._define/debug))",[0,[1,"define/debug"]],["unstable/debug"]],
["define/final-prop",">reference/Building_New_Contract_Combinators.html#(form._((lib._racket/contract/private/guts..rkt)._define/final-prop))",[0,[1,"define/final-prop"]],["racket/contract/combinator","racket/contract","racket"]],
["define/generic",">reference/struct-generics.html#(form._((lib._racket/generic..rkt)._define/generic))",[0,[1,"define/generic"]],["racket/generic"]],
["define/i",">unstable/class-iop.html#(form._((lib._unstable/class-iop..rkt)._define/i))",[0,[1,"define/i"]],["unstable/class-iop"]],
["define/kw",">mzlib/mzlib_kw.html#(form._((lib._mzlib/kw..rkt)._define/kw))",[0,[1,"define/kw"]],["mzlib/kw"]],
["define/overment",">reference/createclass.html#(form._((lib._racket/private/class-internal..rkt)._define/overment))",[0,[1,"define/overment"]],["racket/class","racket"]],
["define/override",">reference/createclass.html#(form._((lib._racket/private/class-internal..rkt)._define/override))",[0,[1,"define/override"]],["racket/class","racket"]],
["define/override-final",">reference/createclass.html#(form._((lib._racket/private/class-internal..rkt)._define/override-final))",[0,[1,"define/override-final"]],["racket/class","racket"]],
["define/override/debug",">unstable/Debugging.html#(form._((lib._unstable/debug..rkt)._define/override/debug))",[0,[1,"define/override/debug"]],["unstable/debug"]],
["define/page",">web-server/page.html#(form._((lib._web-server/page..rkt)._define/page))",[0,[1,"define/page"]],["web-server/page"]],
["define/private",">reference/createclass.html#(form._((lib._racket/private/class-internal..rkt)._define/private))",[0,[1,"define/private"]],["racket/class","racket"]],
["define/private/debug",">unstable/Debugging.html#(form._((lib._unstable/debug..rkt)._define/private/debug))",[0,[1,"define/private/debug"]],["unstable/debug"]],
["define/provide-test-suite",">rackunit/api.html#(form._((lib._rackunit/main..rkt)._define/provide-test-suite))",[0,[1,"define/provide-test-suite"]],["rackunit"]],
["define/public",">reference/createclass.html#(form._((lib._racket/private/class-internal..rkt)._define/public))",[0,[1,"define/public"]],["racket/class","racket"]],
["define/public-final",">reference/createclass.html#(form._((lib._racket/private/class-internal..rkt)._define/public-final))",[0,[1,"define/public-final"]],["racket/class","racket"]],
["define/public/debug",">unstable/Debugging.html#(form._((lib._unstable/debug..rkt)._define/public/debug))",[0,[1,"define/public/debug"]],["unstable/debug"]],
["define/pubment",">reference/createclass.html#(form._((lib._racket/private/class-internal..rkt)._define/pubment))",[0,[1,"define/pubment"]],["racket/class","racket"]],
["define/subexpression-pos-prop",">reference/Building_New_Contract_Combinators.html#(form._((lib._racket/contract/private/guts..rkt)._define/subexpression-pos-prop))",[0,[1,"define/subexpression-pos-prop"]],["racket/contract/combinator","racket/contract","racket"]],
["define/syntax-parse",">syntax/Parsing_Syntax.html#(form._((lib._syntax/parse..rkt)._define/syntax-parse))",[0,[1,"define/syntax-parse"]],["syntax/parse"]],
["define/with-syntax",">reference/syntax-util.html#(form._((lib._racket/syntax..rkt)._define/with-syntax))",[0,[1,"define/with-syntax"]],["racket/syntax"]],
["define:",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._define~3a))",[0,[1,"define:"]],["typed/racket/base","typed/racket"]],
["defined?",">ts-reference/Utilities.html#(def._((lib._typed-racket/base-env/extra-procs..rkt)._defined~3f))",[0,[2,"defined?"]],["typed/racket/base","typed/racket"]],
["defining a language",">redex/tutorial.html#(part._.Defining_a_.Language)","Defining a Language",false],
["defining a reduction relation",">redex/tutorial.html#(part._.Defining_a_.Reduction_.Relation)","Defining a Reduction Relation",false],
["defining bindings",">foreign/Defining_Bindings.html","Defining Bindings",false],
["defining custom input signals",">frtime/index.html#(part._.Defining_.Custom_.Input_.Signals)","Defining Custom Input Signals",false],
["defining custom shortcuts",">drracket/Keyboard_Shortcuts.html#(part._defining-shortcuts)","Defining Custom Shortcuts",false],
["defining functions and more",">scribble/text.html#(part._.Defining_.Functions_and_.More)","Defining Functions and More",false],
["defining new #lang languages",">guide/hash-languages.html",["Defining new ",[9,[10,"#lang"]]," Languages"],false],
["defining new types of containers",">gui/windowing-overview.html#(part._new-containers)","Defining New Types of Containers",false],
["defining racket bindings",">scribble/how-to-doc.html#(part._.Defining_.Racket_.Bindings)","Defining Racket Bindings",false],
["defining recursive contracts",">guide/contracts-gotchas.html#(part._.Defining_.Recursive_.Contracts)","Defining Recursive Contracts",false],
["defining simple macros",">syntax/Defining_Simple_Macros.html","Defining Simple Macros",false],
["defining structure types: struct",">reference/define-struct.html",["Defining Structure Types: ",[0,[1,"struct"]]],false],
["defining types: define-type",">plai/plai-scheme.html#(part._define-type)",["Defining Types: ",[0,[1,"define-type"]]],false],
["definitionen",">deinprogramm/Definitionen.html","Definitionen",false],
["definitionen",">deinprogramm/advanced-definitions.html","Definitionen",false],
["definitions",">guide/syntax-overview.html#(part._.Definitions)","Definitions",false],
["definitions",">quick/index.html#(part._.Definitions)","Definitions",false],
["definitions",">ts-reference/special-forms.html#(part._.Definitions)","Definitions",false],
["definitions",">unstable/Definitions.html","Definitions",false],
["definitions and interactions",">guide/intro.html#(part._.Definitions_and_.Interactions)","Definitions and Interactions",false],
["definitions area",">guide/intro.html#(tech._definitions._area)","<span style=\"font-style: italic\">definitions area</span>",false],
["definitions window",">drracket/interface-essentials.html#(tech._definitions._window)","<span style=\"font-style: italic\">definitions window</span>",false],
["definitions window actions",">drracket/debugger.html#(part._.Definitions_.Window_.Actions)","Definitions Window Actions",false],
["definitions: define",">guide/define.html",["Definitions: ",[0,[1,"define"]]],false],
["definitions: define, define-syntax, ...",">reference/define.html",["Definitions: ",[0,[1,"define"]],", ",[0,[1,"define-syntax"]],", ..."],false],
["definterface",">scribble/doc-classes.html#(form._((lib._scribble/manual..rkt)._definterface))",[0,[1,"definterface"]],["scribble/manual"]],
["definterface/title",">scribble/doc-classes.html#(form._((lib._scribble/manual..rkt)._definterface/title))",[0,[1,"definterface/title"]],["scribble/manual"]],
["deflate",">file/gzip.html#(def._((lib._file/gzip..rkt)._deflate))",[0,[2,"deflate"]],["file/gzip"]],
["defmacro",">mzlib/mzlib_defmacro.html#(form._((lib._mzlib/defmacro..rkt)._defmacro))",[0,[1,"defmacro"]],["mzlib/defmacro"]],
["defmethod",">scribble/doc-classes.html#(form._((lib._scribble/manual..rkt)._defmethod))",[0,[1,"defmethod"]],["scribble/manual"]],
["defmethod*",">scribble/doc-classes.html#(form._((lib._scribble/manual..rkt)._defmethod*))",[0,[1,"defmethod*"]],["scribble/manual"]],
["defmixin",">scribble/doc-classes.html#(form._((lib._scribble/manual..rkt)._defmixin))",[0,[1,"defmixin"]],["scribble/manual"]],
["defmixin/title",">scribble/doc-classes.html#(form._((lib._scribble/manual..rkt)._defmixin/title))",[0,[1,"defmixin/title"]],["scribble/manual"]],
["defmodule",">scribble/doc-modules.html#(form._((lib._scribble/manual..rkt)._defmodule))",[0,[1,"defmodule"]],["scribble/manual"]],
["defmodule*",">scribble/doc-modules.html#(form._((lib._scribble/manual..rkt)._defmodule*))",[0,[1,"defmodule*"]],["scribble/manual"]],
["defmodule*/no-declare",">scribble/doc-modules.html#(form._((lib._scribble/manual..rkt)._defmodule*/no-declare))",[0,[1,"defmodule*/no-declare"]],["scribble/manual"]],
["defmodule*/no-declare/this-package",">planet/Utility_Libraries.html#(form._((lib._planet/scribble..rkt)._defmodule*/no-declare/this-package))",[0,[1,"defmodule*/no-declare/this-package"]],["planet/scribble"]],
["defmodule*/this-package",">planet/Utility_Libraries.html#(form._((lib._planet/scribble..rkt)._defmodule*/this-package))",[0,[1,"defmodule*/this-package"]],["planet/scribble"]],
["defmodule/this-package",">planet/Utility_Libraries.html#(form._((lib._planet/scribble..rkt)._defmodule/this-package))",[0,[1,"defmodule/this-package"]],["planet/scribble"]],
["defmodulelang",">scribble/doc-modules.html#(form._((lib._scribble/manual..rkt)._defmodulelang))",[0,[1,"defmodulelang"]],["scribble/manual"]],
["defmodulelang*",">scribble/doc-modules.html#(form._((lib._scribble/manual..rkt)._defmodulelang*))",[0,[1,"defmodulelang*"]],["scribble/manual"]],
["defmodulelang*/no-declare",">scribble/doc-modules.html#(form._((lib._scribble/manual..rkt)._defmodulelang*/no-declare))",[0,[1,"defmodulelang*/no-declare"]],["scribble/manual"]],
["defmodulelang*/no-declare/this-package",">planet/Utility_Libraries.html#(form._((lib._planet/scribble..rkt)._defmodulelang*/no-declare/this-package))",[0,[1,"defmodulelang*/no-declare/this-package"]],["planet/scribble"]],
["defmodulelang*/this-package",">planet/Utility_Libraries.html#(form._((lib._planet/scribble..rkt)._defmodulelang*/this-package))",[0,[1,"defmodulelang*/this-package"]],["planet/scribble"]],
["defmodulelang/this-package",">planet/Utility_Libraries.html#(form._((lib._planet/scribble..rkt)._defmodulelang/this-package))",[0,[1,"defmodulelang/this-package"]],["planet/scribble"]],
["defmodulereader",">scribble/doc-modules.html#(form._((lib._scribble/manual..rkt)._defmodulereader))",[0,[1,"defmodulereader"]],["scribble/manual"]],
["defmodulereader*",">scribble/doc-modules.html#(form._((lib._scribble/manual..rkt)._defmodulereader*))",[0,[1,"defmodulereader*"]],["scribble/manual"]],
["defmodulereader*/no-declare",">scribble/doc-modules.html#(form._((lib._scribble/manual..rkt)._defmodulereader*/no-declare))",[0,[1,"defmodulereader*/no-declare"]],["scribble/manual"]],
["defmodulereader*/no-declare/this-package",">planet/Utility_Libraries.html#(form._((lib._planet/scribble..rkt)._defmodulereader*/no-declare/this-package))",[0,[1,"defmodulereader*/no-declare/this-package"]],["planet/scribble"]],
["defmodulereader*/this-package",">planet/Utility_Libraries.html#(form._((lib._planet/scribble..rkt)._defmodulereader*/this-package))",[0,[1,"defmodulereader*/this-package"]],["planet/scribble"]],
["defmodulereader/this-package",">planet/Utility_Libraries.html#(form._((lib._planet/scribble..rkt)._defmodulereader/this-package))",[0,[1,"defmodulereader/this-package"]],["planet/scribble"]],
["defparam",">scribble/doc-forms.html#(form._((lib._scribble/manual..rkt)._defparam))",[0,[1,"defparam"]],["scribble/manual"]],
["defproc",">scribble/doc-forms.html#(form._((lib._scribble/manual..rkt)._defproc))",[0,[1,"defproc"]],["scribble/manual"]],
["defproc*",">scribble/doc-forms.html#(form._((lib._scribble/manual..rkt)._defproc*))",[0,[1,"defproc*"]],["scribble/manual"]],
["defs+int",">scribble/eval.html#(form._((lib._scribble/eval..rkt)._defs+int))",[0,[1,"defs+int"]],["scribble/eval"]],
["defsignature",">scribble/doc-signatures.html#(form._((lib._scribble/manual..rkt)._defsignature))",[0,[1,"defsignature"]],["scribble/manual"]],
["defsignature/splice",">scribble/doc-signatures.html#(form._((lib._scribble/manual..rkt)._defsignature/splice))",[0,[1,"defsignature/splice"]],["scribble/manual"]],
["defstruct",">scribble/doc-forms.html#(form._((lib._scribble/manual..rkt)._defstruct))",[0,[1,"defstruct"]],["scribble/manual"]],
["defstruct*",">scribble/doc-forms.html#(form._((lib._scribble/manual..rkt)._defstruct*))",[0,[1,"defstruct*"]],["scribble/manual"]],
["deftech",">scribble/section-links.html#(def._((lib._scribble/manual..rkt)._deftech))",[0,[2,"deftech"]],["scribble/manual"]],
["defterm",">scribble/doc-strings.html#(def._((lib._scribble/manual..rkt)._defterm))",[0,[2,"defterm"]],["scribble/manual"]],
["defthing",">scribble/doc-forms.html#(form._((lib._scribble/manual..rkt)._defthing))",[0,[1,"defthing"]],["scribble/manual"]],
["deftogether",">scribble/doc-forms.html#(form._((lib._scribble/manual..rkt)._deftogether))",[0,[1,"deftogether"]],["scribble/manual"]],
["degrees->radians",">reference/generic-numbers.html#(def._((lib._racket/math..rkt)._degrees-~3eradians))",[0,[2,"degrees->radians"]],["racket/math","racket"]],
["deinprogramm/dmda-advanced",">deinprogramm/DMdA__Sprachen_als_Libraries.html#(mod-path._deinprogramm/.D.Md.A-advanced)",[9,[0,"deinprogramm/DMdA-advanced"]],"module"],
["deinprogramm/dmda-assignments",">deinprogramm/DMdA__Sprachen_als_Libraries.html#(mod-path._deinprogramm/.D.Md.A-assignments)",[9,[0,"deinprogramm/DMdA-assignments"]],"module"],
["deinprogramm/dmda-beginner",">deinprogramm/DMdA__Sprachen_als_Libraries.html#(mod-path._deinprogramm/.D.Md.A-beginner)",[9,[0,"deinprogramm/DMdA-beginner"]],"module"],
["deinprogramm/dmda-vanilla",">deinprogramm/DMdA__Sprachen_als_Libraries.html#(mod-path._deinprogramm/.D.Md.A-vanilla)",[9,[0,"deinprogramm/DMdA-vanilla"]],"module"],
["del",">html/index.html#(def._((lib._html/main..rkt)._del))",[0,[2,"del"]],["html"]],
["del?",">html/index.html#(def._((lib._html/main..rkt)._del~3f))",[0,[2,"del?"]],["html"]],
["delay",">reference/Delayed_Evaluation.html#(form._((lib._racket/promise..rkt)._delay))",[0,[1,"delay"]],["racket/promise","racket"]],
["delay",">r5rs-std/r5rs-Z-H-7.html#%_idx_146",[0,[1,"delay"]],["r5rs"]],
["delay",">r6rs-lib-std/r6rs-lib-Z-H-20.html#node_idx_1296",[0,[1,"delay"]],["rnrs/r5rs-6"]],
["delay",">htdp-langs/advanced.html#(form._((lib._lang/htdp-advanced..rkt)._delay))",[0,[1,"delay"]],["lang/htdp-advanced"]],
["delay",">srfi-std/srfi-45.html#delay",[0,[1,"delay"]],["srfi/45"]],
["delay-by",">frtime/index.html#(def._((lib._frtime/main..rkt)._delay-by))",[0,[2,"delay-by"]],["frtime"]],
["delay-test",">rackunit/api.html#(form._((lib._rackunit/main..rkt)._delay-test))",[0,[1,"delay-test"]],["rackunit"]],
["delay/idle",">reference/Delayed_Evaluation.html#(form._((lib._racket/promise..rkt)._delay/idle))",[0,[1,"delay/idle"]],["racket/promise","racket"]],
["delay/name",">reference/Delayed_Evaluation.html#(form._((lib._racket/promise..rkt)._delay/name))",[0,[1,"delay/name"]],["racket/promise","racket"]],
["delay/strict",">reference/Delayed_Evaluation.html#(form._((lib._racket/promise..rkt)._delay/strict))",[0,[1,"delay/strict"]],["racket/promise","racket"]],
["delay/sync",">reference/Delayed_Evaluation.html#(form._((lib._racket/promise..rkt)._delay/sync))",[0,[1,"delay/sync"]],["racket/promise","racket"]],
["delay/thread",">reference/Delayed_Evaluation.html#(form._((lib._racket/promise..rkt)._delay/thread))",[0,[1,"delay/thread"]],["racket/promise","racket"]],
["delayed block",">scribble/core.html#(tech._delayed._block)","<span style=\"font-style: italic\">delayed block</span>",false],
["delayed element",">scribble/core.html#(tech._delayed._element)","<span style=\"font-style: italic\">delayed element</span>",false],
["delayed evaluation",">reference/Delayed_Evaluation.html","Delayed Evaluation",false],
["delayed-block",">scribble/core.html#(def._((lib._scribble/core..rkt)._delayed-block))",[0,[2,"delayed-block"]],["scribble/core"]],
["delayed-block-resolve",">scribble/core.html#(def._((lib._scribble/core..rkt)._delayed-block-resolve))",[0,[2,"delayed-block-resolve"]],["scribble/core"]],
["delayed-block?",">scribble/core.html#(def._((lib._scribble/core..rkt)._delayed-block~3f))",[0,[2,"delayed-block?"]],["scribble/core"]],
["delayed-element",">scribble/core.html#(def._((lib._scribble/core..rkt)._delayed-element))",[0,[2,"delayed-element"]],["scribble/core"]],
["delayed-element-plain",">scribble/core.html#(def._((lib._scribble/core..rkt)._delayed-element-plain))",[0,[2,"delayed-element-plain"]],["scribble/core"]],
["delayed-element-resolve",">scribble/core.html#(def._((lib._scribble/core..rkt)._delayed-element-resolve))",[0,[2,"delayed-element-resolve"]],["scribble/core"]],
["delayed-element-sizer",">scribble/core.html#(def._((lib._scribble/core..rkt)._delayed-element-sizer))",[0,[2,"delayed-element-sizer"]],["scribble/core"]],
["delayed-element?",">scribble/core.html#(def._((lib._scribble/core..rkt)._delayed-element~3f))",[0,[2,"delayed-element?"]],["scribble/core"]],
["delegate-moved",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3adelegate~3c~25~3e)._delegate-moved))",[[0,[2,"delegate-moved"]],[14,[" (method of ",[0,[2,"frame:delegate<%>"]],")"]]],["framework"]],
["delegated-text-shown?",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3adelegate~3c~25~3e)._delegated-text-shown~3f))",[[0,[2,"delegated-text-shown?"]],[14,[" (method of ",[0,[2,"frame:delegate<%>"]],")"]]],["framework"]],
["delete",">gui/list-box_.html#(meth._(((lib._mred/main..rkt)._list-box~25)._delete))",[[0,[2,"delete"]],[14,[" (method of ",[0,[2,"list-box%"]],")"]]],["racket/gui/base","racket/gui"]],
["delete",">gui/menu-item___.html#(meth._(((lib._mred/main..rkt)._menu-item~3c~25~3e)._delete))",[[0,[2,"delete"]],[14,[" (method of ",[0,[2,"menu-item<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["delete",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._delete))",[[0,[2,"delete"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["delete",">gui/tab-panel_.html#(meth._(((lib._mred/main..rkt)._tab-panel~25)._delete))",[[0,[2,"delete"]],[14,[" (method of ",[0,[2,"tab-panel%"]],")"]]],["racket/gui/base","racket/gui"]],
["delete",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._delete))",[[0,[2,"delete"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["delete",">srfi-std/srfi-1.html#delete",[0,[2,"delete"]],["srfi/1"]],
["delete",">reference/securityguards.html#(idx._(gentag._230._(lib._scribblings/reference/reference..scrbl)))",[7,"'delete"],false],
["delete menu item",">drracket/Menus.html#(idx._(gentag._76._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Delete</span> menu item",false],
["delete!",">srfi-std/srfi-1.html#delete!",[0,[2,"delete!"]],["srfi/1"]],
["delete-child",">gui/area-container___.html#(meth._(((lib._mred/main..rkt)._area-container~3c~25~3e)._delete-child))",[[0,[2,"delete-child"]],[14,[" (method of ",[0,[2,"area-container<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["delete-child",">embedded-gui/alignment-parent___.html#(meth._(((lib._embedded-gui/main..rkt)._alignment-parent~3c~25~3e)._delete-child))",[[0,[2,"delete-child"]],[14,[" (method of ",[0,[2,"alignment-parent<%>"]],")"]]],["embedded-gui"]],
["delete-column",">gui/list-box_.html#(meth._(((lib._mred/main..rkt)._list-box~25)._delete-column))",[[0,[2,"delete-column"]],[14,[" (method of ",[0,[2,"list-box%"]],")"]]],["racket/gui/base","racket/gui"]],
["delete-directory",">reference/Filesystem.html#(def._((quote._~23~25kernel)._delete-directory))",[0,[2,"delete-directory"]],["racket/base","racket"]],
["delete-directory/files",">reference/Filesystem.html#(def._((lib._racket/file..rkt)._delete-directory/files))",[0,[2,"delete-directory/files"]],["racket/file","racket"]],
["delete-duplicates",">srfi-std/srfi-1.html#delete-duplicates",[0,[2,"delete-duplicates"]],["srfi/1"]],
["delete-duplicates!",">srfi-std/srfi-1.html#delete-duplicates!",[0,[2,"delete-duplicates!"]],["srfi/1"]],
["delete-file",">reference/Filesystem.html#(def._((quote._~23~25kernel)._delete-file))",[0,[2,"delete-file"]],["racket/base","racket"]],
["delete-file",">r6rs-lib-std/r6rs-lib-Z-H-10.html#node_idx_840",[0,[2,"delete-file"]],["rnrs/files-6"]],
["delete-impure-port",">net/url.html#(def._((lib._net/url..rkt)._delete-impure-port))",[0,[2,"delete-impure-port"]],["net/url"]],
["delete-item",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..rkt)._hierarchical-list~25)._delete-item))",[[0,[2,"delete-item"]],[14,[" (method of ",[0,[2,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["delete-item",">mrlib/hierarchical-list-compound-item___.html#(meth._(((lib._mrlib/hierlist..rkt)._hierarchical-list-compound-item~3c~25~3e)._delete-item))",[[0,[2,"delete-item"]],[14,[" (method of ",[0,[2,"hierarchical-list-compound-item<%>"]],")"]]],["mrlib/hierlist"]],
["delete-message",">net/pop3.html#(def._((lib._net/pop3..rkt)._delete-message))",[0,[2,"delete-message"]],["net/pop3"]],
["delete-pure-port",">net/url.html#(def._((lib._net/url..rkt)._delete-pure-port))",[0,[2,"delete-pure-port"]],["net/url"]],
["delete/io",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3aports~3c~25~3e)._delete/io))",[[0,[2,"delete/io"]],[14,[" (method of ",[0,[2,"text:ports<%>"]],")"]]],["framework"]],
["deleted",">gui/windowing-overview.html#(tech._deleted)","<span style=\"font-style: italic\">deleted</span>",false],
["delimit-ellipsis-arguments?",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._delimit-ellipsis-arguments~3f))",[0,[2,"delimit-ellipsis-arguments?"]],["redex/pict","redex"]],
["delimited continuation",">reference/eval-model.html#(tech._delimited._continuation)","<span style=\"font-style: italic\">delimited continuation</span>",false],
["delimited continuations",">guide/Continuations.html#(tech._delimited._continuation)","<span style=\"font-style: italic\">delimited continuations</span>",false],
["delimiters and dispatch",">reference/reader.html#(part._default-readtable-dispatch)","Delimiters and Dispatch",false],
["delta",">gui/editor-overview.html#(tech._delta)","<span style=\"font-style: italic\">delta</span>",false],
["denied?/c",">web-server-internal/dispatch-passwords.html#(def._((lib._web-server/dispatchers/dispatch-passwords..rkt)._denied~3f/c))",[0,[2,"denied?/c"]],["web-server/dispatchers/dispatch-passwords"]],
["denominator",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._denominator))",[0,[2,"denominator"]],["racket/base","racket"]],
["denominator",">r5rs-std/r5rs-Z-H-9.html#%_idx_312",[0,[2,"denominator"]],["r5rs"]],
["denominator",">r6rs-std/r6rs-Z-H-14.html#node_idx_526",[0,[2,"denominator"]],["rnrs/base-6"]],
["denominator",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._denominator))",[0,[2,"denominator"]],["lang/htdp-advanced"]],
["denominator",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._denominator))",[0,[2,"denominator"]],["lang/htdp-beginner"]],
["denominator",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._denominator))",[0,[2,"denominator"]],["lang/htdp-beginner-abbr"]],
["denominator",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._denominator))",[0,[2,"denominator"]],["lang/htdp-intermediate"]],
["denominator",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._denominator))",[0,[2,"denominator"]],["lang/htdp-intermediate-lambda"]],
["denominator",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._denominator))",[0,[2,"denominator"]],["deinprogramm/DMdA-advanced"]],
["denominator",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._denominator))",[0,[2,"denominator"]],["deinprogramm/DMdA-assignments"]],
["denominator",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._denominator))",[0,[2,"denominator"]],["deinprogramm/DMdA-beginner"]],
["denominator",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._denominator))",[0,[2,"denominator"]],["deinprogramm/DMdA-vanilla"]],
["density",">plot/renderer2d.html#(def._((lib._plot/main..rkt)._density))",[0,[2,"density"]],["plot"]],
["dependency files",">raco/make.html#(part._.Dependency_.Files)","Dependency Files",false],
["deprecated",">scribble/doc-modules.html#(form._((lib._scribble/manual..rkt)._deprecated))",[0,[1,"deprecated"]],["scribble/manual"]],
["deprecated functions",">plot/porting.html#(part._.Deprecated_.Functions)","Deprecated Functions",false],
["depth marker",">reference/stx-patterns.html#(tech._depth._marker)","<span style=\"font-style: italic\">depth marker</span>",false],
["dequeue!",">data/Imperative_Queues.html#(def._((lib._data/queue..rkt)._dequeue!))",[0,[2,"dequeue!"]],["data/queue"]],
["derivative",">frtime/index.html#(def._((lib._frtime/main..rkt)._derivative))",[0,[2,"derivative"]],["frtime"]],
["derivative",">plot/compat.html#(def._((lib._plot/compat..rkt)._derivative))",[0,[2,"derivative"]],["plot/compat"]],
["derived class",">reference/mzlib_class.html#(tech._derived._clas)","<span style=\"font-style: italic\">derived class</span>",false],
["derived style",">gui/editor-overview.html#(tech._derived._style)","<span style=\"font-style: italic\">derived style</span>",false],
["derived utilities",">foreign/Derived_Utilities.html","Derived Utilities",false],
["deriving new iteration forms",">reference/for.html#(part._.Deriving_.New_.Iteration_.Forms)","Deriving New Iteration Forms",false],
["describing com interfaces",">foreign/com-intf.html#(part._.Describing_.C.O.M_.Interfaces)","Describing COM Interfaces",false],
["deserialize",">reference/serialization.html#(def._((lib._racket/private/serialize..rkt)._deserialize))",[0,[2,"deserialize"]],["racket/serialize"]],
["deserialize-info",">scribble/renderer.html#(meth._(((lib._scribble/base-render..rkt)._render~25)._deserialize-info))",[[0,[2,"deserialize-info"]],[14,[" (method of ",[0,[2,"render%"]],")"]]],["scribble/base-render"]],
["deserialize-module-guard",">reference/serialization.html#(def._((lib._racket/private/serialize..rkt)._deserialize-module-guard))",[0,[2,"deserialize-module-guard"]],["racket/serialize"]],
["designating a #lang language",">guide/hash-lang_syntax.html",["Designating a ",[9,[10,"#lang"]]," Language"],false],
["designing the ball server",">teachpack/2htdpuniverse.html#(part._.Designing_the_.Ball_.Server)","Designing the Ball Server",false],
["designing the ball universe",">teachpack/2htdpuniverse.html#(part._.Designing_the_.Ball_.Universe)","Designing the Ball Universe",false],
["designing the ball world",">teachpack/2htdpuniverse.html#(part._.Designing_the_.Ball_.World)","Designing the Ball World",false],
["desk-dir",">reference/Filesystem.html#(idx._(gentag._283._(lib._scribblings/reference/reference..scrbl)))",[7,"'desk-dir"],false],
["desktop-machine",">slideshow/More_Pict_Constructors.html#(def._((lib._slideshow/pict..rkt)._desktop-machine))",[0,[2,"desktop-machine"]],["slideshow/pict","slideshow"]],
["destructing bind",">guide/match.html#(idx._(gentag._2._(lib._scribblings/guide/guide..scrbl)))","destructing\nbind",false],
["determine your package's backwards-compatibility",">planet/Developing_Packages_for_PLaneT.html#(part._backwards-compatibility)","Determine Your Package&rsquo;s Backwards-Compatibility",false],
["determine-width",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3ainfo~3c~25~3e)._determine-width))",[[0,[2,"determine-width"]],[14,[" (method of ",[0,[2,"frame:info<%>"]],")"]]],["framework"]],
["deterministic finite automata",">unstable/Automata__Compiling_State_Machines.html#(part._dfa)","Deterministic Finite Automata",false],
["developing packages for planet",">planet/Developing_Packages_for_PLaneT.html","Developing Packages for PLaneT",false],
["development links",">planet/Developing_Packages_for_PLaneT.html#(part._devlinks)","Development Links",false],
["devtools",">planet/Developing_Packages_for_PLaneT.html#(idx._(gentag._4._(lib._planet/planet..scrbl)))",[7,"'devtools"],false],
["dfa",">unstable/Automata__Compiling_State_Machines.html#(form._((lib._unstable/automata/dfa..rkt)._dfa))",[0,[1,"dfa"]],["unstable/automata/dfa"]],
["dflag",">scribble/doc-strings.html#(def._((lib._scribble/manual..rkt)._.D.Flag))",[0,[2,"DFlag"]],["scribble/manual"]],
["dfn",">html/index.html#(def._((lib._html/main..rkt)._dfn))",[0,[2,"dfn"]],["html"]],
["dfn?",">html/index.html#(def._((lib._html/main..rkt)._dfn~3f))",[0,[2,"dfn?"]],["html"]],
["dialects of racket and scheme",">guide/dialects.html","Dialects of Racket and Scheme",false],
["dialog",">gui/windowing-overview.html#(tech._dialog)","<span style=\"font-style: italic\">dialog</span>",false],
["dialog%",">gui/dialog_.html",[0,[2,"dialog%"]],["racket/gui/base","racket/gui"]],
["dialogs modal",">gui/windowing-overview.html#(idx._(gentag._10._(lib._scribblings/gui/gui..scrbl)))","dialogs, modal",false],
["dialogs",">gui/Windowing_Functions.html#(part._.Dialogs)","Dialogs",false],
["dict->list",">reference/dicts.html#(def._((lib._racket/dict..rkt)._dict-~3elist))",[0,[2,"dict->list"]],["racket/dict","racket"]],
["dict-can-functional-set?",">reference/dicts.html#(def._((lib._racket/dict..rkt)._dict-can-functional-set~3f))",[0,[2,"dict-can-functional-set?"]],["racket/dict","racket"]],
["dict-can-remove-keys?",">reference/dicts.html#(def._((lib._racket/dict..rkt)._dict-can-remove-keys~3f))",[0,[2,"dict-can-remove-keys?"]],["racket/dict","racket"]],
["dict-count",">reference/dicts.html#(def._((lib._racket/dict..rkt)._dict-count))",[0,[2,"dict-count"]],["racket/dict","racket"]],
["dict-for-each",">reference/dicts.html#(def._((lib._racket/dict..rkt)._dict-for-each))",[0,[2,"dict-for-each"]],["racket/dict","racket"]],
["dict-has-key?",">reference/dicts.html#(def._((lib._racket/dict..rkt)._dict-has-key~3f))",[0,[2,"dict-has-key?"]],["racket/dict","racket"]],
["dict-iter-contract",">reference/dicts.html#(def._((lib._racket/dict..rkt)._dict-iter-contract))",[0,[2,"dict-iter-contract"]],["racket/dict","racket"]],
["dict-iterate-first",">reference/dicts.html#(def._((lib._racket/dict..rkt)._dict-iterate-first))",[0,[2,"dict-iterate-first"]],["racket/dict","racket"]],
["dict-iterate-greatest",">data/Orders_and_Ordered_Dictionaries.html#(def._((lib._data/order..rkt)._dict-iterate-greatest))",[0,[2,"dict-iterate-greatest"]],["data/order"]],
["dict-iterate-greatest/<=?",">data/Orders_and_Ordered_Dictionaries.html#(def._((lib._data/order..rkt)._dict-iterate-greatest/~3c~3d~3f))",[0,[2,"dict-iterate-greatest/<=?"]],["data/order"]],
["dict-iterate-greatest/<?",">data/Orders_and_Ordered_Dictionaries.html#(def._((lib._data/order..rkt)._dict-iterate-greatest/~3c~3f))",[0,[2,"dict-iterate-greatest/<?"]],["data/order"]],
["dict-iterate-key",">reference/dicts.html#(def._((lib._racket/dict..rkt)._dict-iterate-key))",[0,[2,"dict-iterate-key"]],["racket/dict","racket"]],
["dict-iterate-least",">data/Orders_and_Ordered_Dictionaries.html#(def._((lib._data/order..rkt)._dict-iterate-least))",[0,[2,"dict-iterate-least"]],["data/order"]],
["dict-iterate-least/>=?",">data/Orders_and_Ordered_Dictionaries.html#(def._((lib._data/order..rkt)._dict-iterate-least/~3e~3d~3f))",[0,[2,"dict-iterate-least/>=?"]],["data/order"]],
["dict-iterate-least/>?",">data/Orders_and_Ordered_Dictionaries.html#(def._((lib._data/order..rkt)._dict-iterate-least/~3e~3f))",[0,[2,"dict-iterate-least/>?"]],["data/order"]],
["dict-iterate-next",">reference/dicts.html#(def._((lib._racket/dict..rkt)._dict-iterate-next))",[0,[2,"dict-iterate-next"]],["racket/dict","racket"]],
["dict-iterate-value",">reference/dicts.html#(def._((lib._racket/dict..rkt)._dict-iterate-value))",[0,[2,"dict-iterate-value"]],["racket/dict","racket"]],
["dict-key-contract",">reference/dicts.html#(def._((lib._racket/dict..rkt)._dict-key-contract))",[0,[2,"dict-key-contract"]],["racket/dict","racket"]],
["dict-keys",">reference/dicts.html#(def._((lib._racket/dict..rkt)._dict-keys))",[0,[2,"dict-keys"]],["racket/dict","racket"]],
["dict-map",">reference/dicts.html#(def._((lib._racket/dict..rkt)._dict-map))",[0,[2,"dict-map"]],["racket/dict","racket"]],
["dict-mutable?",">reference/dicts.html#(def._((lib._racket/dict..rkt)._dict-mutable~3f))",[0,[2,"dict-mutable?"]],["racket/dict","racket"]],
["dict-ref",">reference/dicts.html#(def._((lib._racket/dict..rkt)._dict-ref))",[0,[2,"dict-ref"]],["racket/dict","racket"]],
["dict-ref!",">reference/dicts.html#(def._((lib._racket/dict..rkt)._dict-ref!))",[0,[2,"dict-ref!"]],["racket/dict","racket"]],
["dict-remove",">reference/dicts.html#(def._((lib._racket/dict..rkt)._dict-remove))",[0,[2,"dict-remove"]],["racket/dict","racket"]],
["dict-remove!",">reference/dicts.html#(def._((lib._racket/dict..rkt)._dict-remove!))",[0,[2,"dict-remove!"]],["racket/dict","racket"]],
["dict-set",">reference/dicts.html#(def._((lib._racket/dict..rkt)._dict-set))",[0,[2,"dict-set"]],["racket/dict","racket"]],
["dict-set!",">reference/dicts.html#(def._((lib._racket/dict..rkt)._dict-set!))",[0,[2,"dict-set!"]],["racket/dict","racket"]],
["dict-set*",">reference/dicts.html#(def._((lib._racket/dict..rkt)._dict-set*))",[0,[2,"dict-set*"]],["racket/dict","racket"]],
["dict-set*!",">reference/dicts.html#(def._((lib._racket/dict..rkt)._dict-set*!))",[0,[2,"dict-set*!"]],["racket/dict","racket"]],
["dict-update",">reference/dicts.html#(def._((lib._racket/dict..rkt)._dict-update))",[0,[2,"dict-update"]],["racket/dict","racket"]],
["dict-update!",">reference/dicts.html#(def._((lib._racket/dict..rkt)._dict-update!))",[0,[2,"dict-update!"]],["racket/dict","racket"]],
["dict-value-contract",">reference/dicts.html#(def._((lib._racket/dict..rkt)._dict-value-contract))",[0,[2,"dict-value-contract"]],["racket/dict","racket"]],
["dict-values",">reference/dicts.html#(def._((lib._racket/dict..rkt)._dict-values))",[0,[2,"dict-values"]],["racket/dict","racket"]],
["dict?",">reference/dicts.html#(def._((lib._racket/dict..rkt)._dict~3f))",[0,[2,"dict?"]],["racket/dict","racket"]],
["dictionaries",">reference/dicts.html","Dictionaries",false],
["dictionaries for bound-identifier=?",">syntax/syntax-helpers.html#(part._.Dictionaries_for_bound-identifier~3d_)",["Dictionaries for ",[0,[2,"bound-identifier=?"]]],false],
["dictionaries for free-identifier=?",">syntax/syntax-helpers.html#(part._.Dictionaries_for_free-identifier~3d_)",["Dictionaries for ",[0,[2,"free-identifier=?"]]],false],
["dictionaries with identifier keys",">syntax/syntax-helpers.html#(part._idtable)","Dictionaries with Identifier Keys",false],
["dictionary",">reference/dicts.html#(tech._dictionary)","<span style=\"font-style: italic\">dictionary</span>",false],
["die macht der abstraktion",">deinprogramm/DMdA-vanilla.html","Die Macht der Abstraktion",false],
["die macht der abstraktion",">deinprogramm/DMdA__Sprachen_als_Libraries.html#(part._.Die_.Macht_der_.Abstraktion)","<span style=\"font-style: italic\">Die Macht der Abstraktion</span>",false],
["die macht der abstraktion - anf\u00e4nger",">deinprogramm/DMdA-beginner.html","Die Macht der Abstraktion - Anf&#228;nger",false],
["die macht der abstraktion - anf\u00e4nger",">deinprogramm/DMdA__Sprachen_als_Libraries.html#(part._.Die_.Macht_der_.Abstraktion_-_.Anf_nger)","<span style=\"font-style: italic\">Die Macht der Abstraktion</span> - Anf&#228;nger",false],
["die macht der abstraktion - fortgeschritten",">deinprogramm/DMdA__Sprachen_als_Libraries.html#(part._.Die_.Macht_der_.Abstraktion_-_fortgeschritten)","<span style=\"font-style: italic\">Die Macht der Abstraktion</span> - fortgeschritten",false],
["die macht der abstraktion fortgeschritten",">deinprogramm/DMdA-advanced.html","Die Macht der Abstraktion fortgeschritten",false],
["die macht der abstraktion mit zuweisungen",">deinprogramm/DMdA-assignments.html","Die Macht der Abstraktion mit Zuweisungen",false],
["die macht der abstraktion mit zuweisungen",">deinprogramm/DMdA__Sprachen_als_Libraries.html#(part._.Die_.Macht_der_.Abstraktion_mit_.Zuweisungen)","<span style=\"font-style: italic\">Die Macht der Abstraktion</span> mit Zuweisungen",false],
["difference",">mzlib/mzlib_integer-set.html#(def._((lib._mzlib/integer-set..rkt)._difference))",[0,[2,"difference"]],["mzlib/integer-set"]],
["difference",">unstable/Automata__Compiling_State_Machines.html#(form._((lib._unstable/automata/re-ext..rkt)._difference))",[0,[1,"difference"]],["unstable/automata/re-ext"]],
["digest authentication",">web-server/http.html#(part._digest-auth)","Digest Authentication",false],
["digits-for-range",">plot/utils.html#(def._((lib._plot/utils..rkt)._digits-for-range))",[0,[2,"digits-for-range"]],["plot/utils"]],
["dim",">cards/index.html#(meth._(((lib._games/cards..rkt)._card~3c~25~3e)._dim))",[[0,[2,"dim"]],[14,[" (method of ",[0,[2,"card<%>"]],")"]]],["games/cards"]],
["dimension?",">file/gif.html#(def._((lib._file/gif..rkt)._dimension~3f))",[0,[2,"dimension?"]],["file/gif"]],
["dingbats",">slideshow/More_Pict_Constructors.html#(part._.Dingbats)","Dingbats",false],
["dir",">teachpack/dir.html#(def._((lib._htdp/dir..rkt)._dir))",[0,[2,"dir"]],["htdp/dir"]],
["dir",">html/index.html#(def._((lib._html/main..rkt)._dir))",[0,[2,"dir"]],["html"]],
["dir teachpack",">teachpack/dir.html#(idx._(gentag._11._(lib._teachpack/teachpack..scrbl)))","dir teachpack",false],
["dir-dirs",">teachpack/dir.html#(def._((lib._htdp/dir..rkt)._dir-dirs))",[0,[2,"dir-dirs"]],["htdp/dir"]],
["dir-files",">teachpack/dir.html#(def._((lib._htdp/dir..rkt)._dir-files))",[0,[2,"dir-files"]],["htdp/dir"]],
["dir-name",">teachpack/dir.html#(def._((lib._htdp/dir..rkt)._dir-name))",[0,[2,"dir-name"]],["htdp/dir"]],
["dir-store",">web-server/stateless.html#(def._((lib._web-server/stuffers/store..rkt)._dir-store))",[0,[2,"dir-store"]],["web-server/stuffers/store"]],
["dir?",">teachpack/dir.html#(def._((lib._htdp/dir..rkt)._dir~3f))",[0,[2,"dir?"]],["htdp/dir"]],
["dir?",">html/index.html#(def._((lib._html/main..rkt)._dir~3f))",[0,[2,"dir?"]],["html"]],
["direct bindings for readline hackers",">readline/index.html#(part._.Direct_.Bindings_for_.Readline_.Hackers)","Direct Bindings for Readline Hackers",false],
["directories",">reference/Filesystem.html#(part._directories)","Directories",false],
["directory-exists?",">reference/Filesystem.html#(def._((quote._~23~25kernel)._directory-exists~3f))",[0,[2,"directory-exists?"]],["racket/base","racket"]],
["directory-list",">reference/Filesystem.html#(def._((lib._racket/private/base..rkt)._directory-list))",[0,[2,"directory-list"]],["racket/base","racket"]],
["directory-part",">web-server-internal/misc-util.html#(def._((lib._web-server/private/util..rkt)._directory-part))",[0,[2,"directory-part"]],["web-server/private/util"]],
["directory-record",">raco/getinfo.html#(def._((lib._setup/getinfo..rkt)._directory-record))",[0,[2,"directory-record"]],["setup/getinfo"]],
["directory-record-maj",">raco/getinfo.html#(def._((lib._setup/getinfo..rkt)._directory-record-maj))",[0,[2,"directory-record-maj"]],["setup/getinfo"]],
["directory-record-min",">raco/getinfo.html#(def._((lib._setup/getinfo..rkt)._directory-record-min))",[0,[2,"directory-record-min"]],["setup/getinfo"]],
["directory-record-path",">raco/getinfo.html#(def._((lib._setup/getinfo..rkt)._directory-record-path))",[0,[2,"directory-record-path"]],["setup/getinfo"]],
["directory-record-spec",">raco/getinfo.html#(def._((lib._setup/getinfo..rkt)._directory-record-spec))",[0,[2,"directory-record-spec"]],["setup/getinfo"]],
["directory-record-syms",">raco/getinfo.html#(def._((lib._setup/getinfo..rkt)._directory-record-syms))",[0,[2,"directory-record-syms"]],["setup/getinfo"]],
["directory-record?",">raco/getinfo.html#(def._((lib._setup/getinfo..rkt)._directory-record~3f))",[0,[2,"directory-record?"]],["setup/getinfo"]],
["dirt-block",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._dirt-block))",[0,[2,"dirt-block"]],["2htdp/planetcute"]],
["disable tests menu item",">drracket/Menus.html#(idx._(gentag._135._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Disable Tests</span> menu item",false],
["disable-evaluation",">tools/drracket_rep.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3arep~3acontext~3c~25~3e)._disable-evaluation))",[[0,[2,"disable-evaluation"]],[14,[" (method of ",[0,[2,"drracket:rep:context<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["disable-evaluation",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3atab~3c~25~3e)._disable-evaluation))",[[0,[2,"disable-evaluation"]],[14,[" (method of ",[0,[2,"drracket:unit:tab<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["disappeared uses and bindings",">tools/Check_Syntax.html#(part._.Disappeared_uses_and_bindings)","Disappeared uses and bindings",false],
["disappeared-binding",">reference/stxprops.html#(idx._(gentag._178._(lib._scribblings/reference/reference..scrbl)))",[7,"'disappeared-binding"],false],
["disappeared-use disappeared-binding",">tools/Check_Syntax.html#(idx._(gentag._29._(lib._scribblings/tools/tools..scrbl)))","disappeared-use, disappeared-binding",false],
["disappeared-use",">reference/stxprops.html#(idx._(gentag._179._(lib._scribblings/reference/reference..scrbl)))",[7,"'disappeared-use"],false],
["disarm",">guide/stx-certs.html#(tech._disarm)","<span style=\"font-style: italic\">disarm</span>",false],
["disarm",">reference/stxcerts.html#(tech._disarm)","<span style=\"font-style: italic\">disarm</span>",false],
["discard-all-saved-bug-reports",">tools/Documentation_Utilities.html#(def._((lib._help/bug-report..rkt)._discard-all-saved-bug-reports))",[0,"discard-all-saved-bug-reports"],["help/bug-report"]],
["discard-output null-output null-output-port dev-null /dev/null",">reference/port-lib.html#(idx._(gentag._212._(lib._scribblings/reference/reference..scrbl)))","Opening a null output port",false],
["disconnect",">db/connect.html#(def._((lib._db/base..rkt)._disconnect))",[0,[2,"disconnect"]],["db","db/base"]],
["disconnect-from-server",">net/nntp.html#(def._((lib._net/nntp..rkt)._disconnect-from-server))",[0,[2,"disconnect-from-server"]],["net/nntp"]],
["disconnect-from-server",">net/pop3.html#(def._((lib._net/pop3..rkt)._disconnect-from-server))",[0,[2,"disconnect-from-server"]],["net/pop3"]],
["disconnect-not-quiet",">net/pop3.html#(def._((lib._net/pop3..rkt)._disconnect-not-quiet))",[0,[2,"disconnect-not-quiet"]],["net/pop3"]],
["disconnect-not-quiet-communicator",">net/pop3.html#(def._((lib._net/pop3..rkt)._disconnect-not-quiet-communicator))",[0,[2,"disconnect-not-quiet-communicator"]],["net/pop3"]],
["disconnect-not-quiet?",">net/pop3.html#(def._((lib._net/pop3..rkt)._disconnect-not-quiet~3f))",[0,[2,"disconnect-not-quiet?"]],["net/pop3"]],
["discrete-histogram",">plot/renderer2d.html#(def._((lib._plot/main..rkt)._discrete-histogram))",[0,[2,"discrete-histogram"]],["plot"]],
["discrete-histogram-gap",">plot/params.html#(def._((lib._plot/main..rkt)._discrete-histogram-gap))",[0,[2,"discrete-histogram-gap"]],["plot"]],
["discrete-histogram-invert?",">plot/params.html#(def._((lib._plot/main..rkt)._discrete-histogram-invert~3f))",[0,[2,"discrete-histogram-invert?"]],["plot"]],
["discrete-histogram-skip",">plot/params.html#(def._((lib._plot/main..rkt)._discrete-histogram-skip))",[0,[2,"discrete-histogram-skip"]],["plot"]],
["discrete-histogram3d",">plot/renderer3d.html#(def._((lib._plot/main..rkt)._discrete-histogram3d))",[0,[2,"discrete-histogram3d"]],["plot"]],
["disjoin",">unstable/Functions.html#(def._((lib._unstable/function..rkt)._disjoin))",[0,[2,"disjoin"]],["unstable/function"]],
["disk",">slideshow/Basic_Pict_Constructors.html#(def._((lib._slideshow/pict..rkt)._disk))",[0,[2,"disk"]],["slideshow/pict","slideshow"]],
["dispatch",">web-server-internal/dispatch-server-unit.html#(sig-val._((lib._web-server/private/dispatch-server-sig..rkt)._dispatch-server-config~5e._dispatch))",[0,[2,"dispatch"]],["web-server/private/dispatch-server-sig"]],
["dispatch-case",">web-server/dispatch.html#(form._((lib._web-server/dispatch..rkt)._dispatch-case))",[0,[1,"dispatch-case"]],["web-server/dispatch"]],
["dispatch-macro",">reference/readtables.html#(idx._(gentag._222._(lib._scribblings/reference/reference..scrbl)))",[7,"'dispatch-macro"],false],
["dispatch-rules",">web-server/dispatch.html#(form._((lib._web-server/dispatch..rkt)._dispatch-rules))",[0,[1,"dispatch-rules"]],["web-server/dispatch"]],
["dispatch-rules!",">web-server/dispatch.html#(form._((lib._web-server/dispatch..rkt)._dispatch-rules!))",[0,[1,"dispatch-rules!"]],["web-server/dispatch"]],
["dispatch-rules+applies",">web-server/dispatch.html#(form._((lib._web-server/dispatch..rkt)._dispatch-rules+applies))",[0,[1,"dispatch-rules+applies"]],["web-server/dispatch"]],
["dispatch-server-config^",">web-server-internal/dispatch-server-unit.html#(form._((lib._web-server/private/dispatch-server-sig..rkt)._dispatch-server-config~5e))",[0,[1,"dispatch-server-config^"]],["web-server/private/dispatch-server-sig"]],
["dispatch-server@",">web-server-internal/dispatch-server-unit.html#(def._((lib._web-server/private/dispatch-server-unit..rkt)._dispatch-server~40))",[0,[2,"dispatch-server@"]],["web-server/private/dispatch-server-unit"]],
["dispatch-server^",">web-server-internal/dispatch-server-unit.html#(form._((lib._web-server/private/dispatch-server-sig..rkt)._dispatch-server~5e))",[0,[1,"dispatch-server^"]],["web-server/private/dispatch-server-sig"]],
["dispatch-url",">web-server/dispatch.html#(form._((lib._web-server/dispatch..rkt)._dispatch-url))",[0,[1,"dispatch-url"]],["web-server/dispatch"]],
["dispatch/servlet",">web-server-internal/web-server.html#(def._((lib._web-server/servlet-dispatch..rkt)._dispatch/servlet))",[0,[2,"dispatch/servlet"]],["web-server/servlet-dispatch"]],
["dispatch: case",">reference/case.html",["Dispatch: ",[0,[1,"case"]]],false],
["dispatcher-interface-version/c",">web-server-internal/dispatch.html#(def._((lib._web-server/dispatchers/dispatch..rkt)._dispatcher-interface-version/c))",[0,[2,"dispatcher-interface-version/c"]],["web-server/dispatchers/dispatch"]],
["dispatcher/c",">web-server-internal/dispatch.html#(def._((lib._web-server/dispatchers/dispatch..rkt)._dispatcher/c))",[0,[2,"dispatcher/c"]],["web-server/dispatchers/dispatch"]],
["dispatchers",">web-server-internal/dispatchers.html","Dispatchers",false],
["dispatchers",">preprocessor/mztext.html#(def._((lib._preprocessor/mztext..rkt)._dispatchers))",[0,[2,"dispatchers"]],["preprocessor/mztext"]],
["dispatching",">more/index.html#(part._.Dispatching)","Dispatching",false],
["dispatching server",">web-server-internal/dispatch-server-unit.html","Dispatching Server",false],
["dispatching server signatures",">web-server-internal/dispatch-server-unit.html#(part._.Dispatching_.Server_.Signatures)","Dispatching Server Signatures",false],
["dispatching server unit",">web-server-internal/dispatch-server-unit.html#(part._.Dispatching_.Server_.Unit)","Dispatching Server Unit",false],
["display",">reference/Writing.html#(def._((quote._~23~25kernel)._display))",[0,[2,"display"]],["racket/base","racket"]],
["display",">r5rs-std/r5rs-Z-H-9.html#%_idx_658",[0,[2,"display"]],["r5rs"]],
["display",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_828",[0,[2,"display"]],["rnrs/io/simple-6"]],
["display",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._display))",[0,[2,"display"]],["lang/htdp-advanced"]],
["display",">lazy/index.html#(def._((lib._lazy/main..rkt)._display))",[0,[2,"display"]],["lazy"]],
["display",">drracket/interactions-window.html#(idx._(gentag._30._(lib._scribblings/drracket/drracket..scrbl)))",[0,[2,"display"]],false],
["display",">gui/editor-overview.html#(tech._display)","<span style=\"font-style: italic\">display</span>",false],
["display size and fonts",">slideshow/Creating_Slide_Presentations.html#(part._display-size)","Display Size and Fonts",false],
["display-lines",">reference/port-lib.html#(def._((lib._racket/port..rkt)._display-lines))",[0,[2,"display-lines"]],["racket/port","racket"]],
["display-lines-to-file",">reference/Filesystem.html#(def._((lib._racket/file..rkt)._display-lines-to-file))",[0,[2,"display-lines-to-file"]],["racket/file","racket"]],
["display-plt-archived-file",">planet/Utility_Libraries.html#(def._((lib._planet/util..rkt)._display-plt-archived-file))",[0,[2,"display-plt-archived-file"]],["planet/util"]],
["display-plt-file-structure",">planet/Utility_Libraries.html#(def._((lib._planet/util..rkt)._display-plt-file-structure))",[0,[2,"display-plt-file-structure"]],["planet/util"]],
["display-pure-port",">net/url.html#(def._((lib._net/url..rkt)._display-pure-port))",[0,[2,"display-pure-port"]],["net/url"]],
["display-results",">tools/drracket_rep.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3arep~3atext~25)._display-results))",[[0,[2,"display-results"]],[14,[" (method of ",[0,[2,"drracket:rep:text%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["display-results",">htdp/index.html#(def._((lib._test-engine/racket-tests..rkt)._display-results))",[0,[2,"display-results"]],["htdp/testing"]],
["display-to-file",">reference/Filesystem.html#(def._((lib._racket/file..rkt)._display-to-file))",[0,[2,"display-to-file"]],["racket/file","racket"]],
["display-xml",">xml/index.html#(def._((lib._xml/main..rkt)._display-xml))",[0,[2,"display-xml"]],["xml"]],
["display-xml/content",">xml/index.html#(def._((lib._xml/main..rkt)._display-xml/content))",[0,[2,"display-xml/content"]],["xml"]],
["displaying paths relative to a common root",">raco/relative-paths.html#(part._.Displaying_paths_relative_to_a_common_root)","Displaying paths relative to a common root",false],
["displayln",">reference/Writing.html#(def._((lib._racket/private/misc..rkt)._displayln))",[0,[2,"displayln"]],["racket/base","racket"]],
["displayln/f",">reference/distributed-places.html#(def._((lib._racket/place/distributed..rkt)._displayln/f))",[0,[2,"displayln/f"]],["racket/place/distributed"]],
["disposition",">net/mime.html#(def._((lib._net/mime..rkt)._disposition))",[0,[2,"disposition"]],["net/mime"]],
["disposition-creation",">net/mime.html#(def._((lib._net/mime..rkt)._disposition-creation))",[0,[2,"disposition-creation"]],["net/mime"]],
["disposition-filename",">net/mime.html#(def._((lib._net/mime..rkt)._disposition-filename))",[0,[2,"disposition-filename"]],["net/mime"]],
["disposition-modification",">net/mime.html#(def._((lib._net/mime..rkt)._disposition-modification))",[0,[2,"disposition-modification"]],["net/mime"]],
["disposition-params",">net/mime.html#(def._((lib._net/mime..rkt)._disposition-params))",[0,[2,"disposition-params"]],["net/mime"]],
["disposition-read",">net/mime.html#(def._((lib._net/mime..rkt)._disposition-read))",[0,[2,"disposition-read"]],["net/mime"]],
["disposition-size",">net/mime.html#(def._((lib._net/mime..rkt)._disposition-size))",[0,[2,"disposition-size"]],["net/mime"]],
["disposition-type",">net/mime.html#(def._((lib._net/mime..rkt)._disposition-type))",[0,[2,"disposition-type"]],["net/mime"]],
["disposition?",">net/mime.html#(def._((lib._net/mime..rkt)._disposition~3f))",[0,[2,"disposition?"]],["net/mime"]],
["dissecting a contract error message",">guide/contract-func.html#(part._contracts-dissecting-contract-errors)","Dissecting a contract error message",false],
["dissertation-location",">scriblib/autobib.html#(def._((lib._scriblib/autobib..rkt)._dissertation-location))",[0,[2,"dissertation-location"]],["scriblib/autobib"]],
["distributed places",">guide/performance.html#(part._distributed-places)","Distributed Places",false],
["distributed places",">reference/distributed-places.html","Distributed Places",false],
["distributed places mpi",">reference/distributed-places.html#(part._distributed-places-.M.P.I)","Distributed Places MPI",false],
["distributed-launch-path",">reference/distributed-places.html#(def._((lib._racket/place/distributed..rkt)._distributed-launch-path))",[0,[2,"distributed-launch-path"]],["racket/place/distributed"]],
["distributed-place-wait",">reference/distributed-places.html#(def._((lib._racket/place/distributed..rkt)._distributed-place-wait))",[0,[2,"distributed-place-wait"]],["racket/place/distributed"]],
["distribution archive",">drracket/create-exe.html#(tech._distribution._archive)","<span style=\"font-style: italic\">distribution archive</span>",false],
["div",">r6rs-std/r6rs-Z-H-14.html#node_idx_510",[0,[2,"div"]],["rnrs/base-6"]],
["div",">html/index.html#(def._((lib._html/main..rkt)._div))",[0,[2,"div"]],["html"]],
["div-and-mod",">r6rs-std/r6rs-Z-H-14.html#node_idx_508",[0,[2,"div-and-mod"]],["rnrs/base-6"]],
["div-vec3",">deinprogramm/line3d.html#(def._((lib._teachpack/deinprogramm/line3d..rkt)._div-vec3))",[0,[2,"div-vec3"]],["teachpack/deinprogramm/line3d"]],
["div-vec4",">deinprogramm/line3d.html#(def._((lib._teachpack/deinprogramm/line3d..rkt)._div-vec4))",[0,[2,"div-vec4"]],["teachpack/deinprogramm/line3d"]],
["div0",">r6rs-std/r6rs-Z-H-14.html#node_idx_516",[0,[2,"div0"]],["rnrs/base-6"]],
["div0-and-mod0",">r6rs-std/r6rs-Z-H-14.html#node_idx_514",[0,[2,"div0-and-mod0"]],["rnrs/base-6"]],
["div?",">html/index.html#(def._((lib._html/main..rkt)._div~3f))",[0,[2,"div?"]],["html"]],
["divide remainder",">htdp-langs/beginner.html#(idx._htdp-beginner._(gentag._11._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-beginner))","divide, remainder",false],
["divide remainder",">htdp-langs/beginner-abbr.html#(idx._htdp-beginner-abbr._(gentag._26._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-beginner-abbr))","divide, remainder",false],
["divide remainder",">htdp-langs/intermediate.html#(idx._htdp-intermediate._(gentag._35._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-intermediate))","divide, remainder",false],
["divide remainder",">htdp-langs/intermediate-lam.html#(idx._htdp-intermediate-lambda._(gentag._44._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-intermediate-lambda))","divide, remainder",false],
["divide remainder",">htdp-langs/advanced.html#(idx._htdp-advanced._(gentag._53._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-advanced))","divide, remainder",false],
["divide quotient",">htdp-langs/beginner.html#(idx._htdp-beginner._(gentag._10._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-beginner))","divide, quotient",false],
["divide quotient",">htdp-langs/beginner-abbr.html#(idx._htdp-beginner-abbr._(gentag._25._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-beginner-abbr))","divide, quotient",false],
["divide quotient",">htdp-langs/intermediate.html#(idx._htdp-intermediate._(gentag._34._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-intermediate))","divide, quotient",false],
["divide quotient",">htdp-langs/intermediate-lam.html#(idx._htdp-intermediate-lambda._(gentag._43._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-intermediate-lambda))","divide, quotient",false],
["divide quotient",">htdp-langs/advanced.html#(idx._htdp-advanced._(gentag._52._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-advanced))","divide, quotient",false],
["divide",">htdp-langs/beginner-abbr.html#(idx._htdp-beginner-abbr._(gentag._21._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-beginner-abbr))","divide",false],
["divide",">htdp-langs/beginner.html#(idx._htdp-beginner._(gentag._6._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-beginner))","divide",false],
["divide",">gui/key-event_.html#(idx._(gentag._79._(lib._scribblings/gui/gui..scrbl)))",[7,"'divide"],false],
["division by inexact zero",">reference/numbers.html#(idx._(gentag._99._(lib._scribblings/reference/reference..scrbl)))","division by inexact zero",false],
["dl",">html/index.html#(def._((lib._html/main..rkt)._dl))",[0,[2,"dl"]],["html"]],
["dl?",">html/index.html#(def._((lib._html/main..rkt)._dl~3f))",[0,[2,"dl?"]],["html"]],
["dll",">reference/runtime.html#(idx._(gentag._333._(lib._scribblings/reference/reference..scrbl)))",[7,"'dll"],false],
["dll-dir",">config/index.html#(def._((lib._config/main..rkt)._dll-dir))",[0,[2,"dll-dir"]],["config"]],
["dllist<%>",">embedded-gui/dllist___.html",[0,[2,"dllist<%>"]],["embedded-gui"]],
["dmda: sprachen als libraries",">deinprogramm/DMdA__Sprachen_als_Libraries.html","<span style=\"font-weight: bold\">DMdA</span>: Sprachen als Libraries",false],
["dns signature",">net/dns.html#(part._.D.N.S_.Signature)","DNS Signature",false],
["dns unit",">net/dns.html#(part._.D.N.S_.Unit)","DNS Unit",false],
["dns-find-nameserver",">net/dns.html#(def._((lib._net/dns..rkt)._dns-find-nameserver))",[0,[2,"dns-find-nameserver"]],["net/dns"]],
["dns-get-address",">net/dns.html#(def._((lib._net/dns..rkt)._dns-get-address))",[0,[2,"dns-get-address"]],["net/dns"]],
["dns-get-mail-exchanger",">net/dns.html#(def._((lib._net/dns..rkt)._dns-get-mail-exchanger))",[0,[2,"dns-get-mail-exchanger"]],["net/dns"]],
["dns-get-name",">net/dns.html#(def._((lib._net/dns..rkt)._dns-get-name))",[0,[2,"dns-get-name"]],["net/dns"]],
["dns: domain name service queries",">net/dns.html","DNS: Domain Name Service Queries",false],
["dns@",">net/dns.html#(def._((lib._net/dns-unit..rkt)._dns~40))",[0,[2,"dns@"]],["net/dns-unit"]],
["dns^",">net/dns.html#(form._((lib._net/dns-sig..rkt)._dns~5e))",[0,[1,"dns^"]],["net/dns-sig"]],
["do",">reference/for.html#(form._((lib._racket/private/more-scheme..rkt)._do))",[0,[1,"do"]],["racket/base","racket"]],
["do",">r5rs-std/r5rs-Z-H-7.html#%_idx_140",[0,[1,"do"]],["r5rs"]],
["do",">r6rs-lib-std/r6rs-lib-Z-H-6.html#node_idx_258",[0,[1,"do"]],["rnrs/control-6"]],
["do loops",">reference/for.html#(part._.Do_.Loops)","Do Loops",false],
["do-autosave",">framework/Autosave.html#(meth._(((lib._framework/main..rkt)._autosave~3aautosavable~3c~25~3e)._do-autosave))",[[0,[2,"do-autosave"]],[14,[" (method of ",[0,[2,"autosave:autosavable<%>"]],")"]]],["framework"]],
["do-autosave",">framework/Editor.html#(meth._(((lib._framework/main..rkt)._editor~3abackup-autosave~3c~25~3e)._do-autosave))",[[0,[2,"do-autosave"]],[14,[" (method of ",[0,[2,"editor:backup-autosave<%>"]],")"]]],["framework"]],
["do-copy",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._do-copy))",[[0,[2,"do-copy"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["do-copy",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._do-copy))",[[0,[2,"do-copy"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["do-ec",">srfi-std/srfi-42.html#do-ec",[0,[1,"do-ec"]],["srfi/42"]],
["do-edit-operation",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._do-edit-operation))",[[0,[2,"do-edit-operation"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["do-edit-operation",">gui/snip_.html#(meth._(((lib._racket/snip..rkt)._snip~25)._do-edit-operation))",[[0,[2,"do-edit-operation"]],[14,[" (method of ",[0,[2,"snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["do-edit-operation",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..rkt)._hierarchical-list~25)._do-edit-operation))",[[0,[2,"do-edit-operation"]],[14,[" (method of ",[0,[2,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["do-macro",">framework/Keymap.html#(idx._(gentag._40._(lib._scribblings/framework/framework..scrbl)))","do-macro",false],
["do-many-evals",">tools/drracket_rep.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3arep~3atext~25)._do-many-evals))",[[0,[2,"do-many-evals"]],[14,[" (method of ",[0,[2,"drracket:rep:text%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["do-many-text-evals",">tools/drracket_rep.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3arep~3atext~25)._do-many-text-evals))",[[0,[2,"do-many-text-evals"]],[14,[" (method of ",[0,[2,"drracket:rep:text%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["do-not-return",">web-server-internal/web-server.html#(def._((lib._web-server/web-server..rkt)._do-not-return))",[0,[2,"do-not-return"]],["web-server/web-server"]],
["do-paste",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._do-paste))",[[0,[2,"do-paste"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["do-paste",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._do-paste))",[[0,[2,"do-paste"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["do-paste",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3anormalize-paste-mixin)._do-paste))",[[0,[2,"do-paste"]],[14,[" (method of ",[0,[2,"text:normalize-paste-mixin"]],")"]]],["framework"]],
["do-paste-x-selection",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._do-paste-x-selection))",[[0,[2,"do-paste-x-selection"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["do-paste-x-selection",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._do-paste-x-selection))",[[0,[2,"do-paste-x-selection"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["do-submission",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3aports~3c~25~3e)._do-submission))",[[0,[2,"do-submission"]],[14,[" (method of ",[0,[2,"text:ports<%>"]],")"]]],["framework"]],
["do:",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._do~3a))",[0,[1,"do:"]],["typed/racket/base","typed/racket"]],
["doc-dir",">config/index.html#(def._((lib._config/main..rkt)._doc-dir))",[0,[2,"doc-dir"]],["config"]],
["doc-dir",">reference/Filesystem.html#(idx._(gentag._282._(lib._scribblings/reference/reference..scrbl)))",[7,"'doc-dir"],false],
["doc-search-dirs",">config/index.html#(def._((lib._config/main..rkt)._doc-search-dirs))",[0,[2,"doc-search-dirs"]],["config"]],
["docs teachpack",">teachpack/docs.html#(idx._(gentag._10._(lib._teachpack/teachpack..scrbl)))","docs teachpack",false],
["document",">xml/index.html#(def._((lib._xml/main..rkt)._document))",[0,[2,"document"]],["xml"]],
["document language",">scribble/doclang.html","Document Language",false],
["document reader",">scribble/docreader.html","Document Reader",false],
["document structure",">scribble/base.html#(part._.Document_.Structure)","Document Structure",false],
["document styles",">scribble/getting-started.html#(part._.Document_.Styles)","Document Styles",false],
["document-date",">scribble/core.html#(def._((lib._scribble/core..rkt)._document-date))",[0,[2,"document-date"]],["scribble/core"]],
["document-date-text",">scribble/core.html#(def._((lib._scribble/core..rkt)._document-date-text))",[0,[2,"document-date-text"]],["scribble/core"]],
["document-date?",">scribble/core.html#(def._((lib._scribble/core..rkt)._document-date~3f))",[0,[2,"document-date?"]],["scribble/core"]],
["document-element",">xml/index.html#(def._((lib._xml/main..rkt)._document-element))",[0,[2,"document-element"]],["xml"]],
["document-misc",">xml/index.html#(def._((lib._xml/main..rkt)._document-misc))",[0,[2,"document-misc"]],["xml"]],
["document-prolog",">xml/index.html#(def._((lib._xml/main..rkt)._document-prolog))",[0,[2,"document-prolog"]],["xml"]],
["document-type",">xml/index.html#(def._((lib._xml/main..rkt)._document-type))",[0,[2,"document-type"]],["xml"]],
["document-type-external",">xml/index.html#(def._((lib._xml/main..rkt)._document-type-external))",[0,[2,"document-type-external"]],["xml"]],
["document-type-inlined",">xml/index.html#(def._((lib._xml/main..rkt)._document-type-inlined))",[0,[2,"document-type-inlined"]],["xml"]],
["document-type-name",">xml/index.html#(def._((lib._xml/main..rkt)._document-type-name))",[0,[2,"document-type-name"]],["xml"]],
["document-type?",">xml/index.html#(def._((lib._xml/main..rkt)._document-type~3f))",[0,[2,"document-type?"]],["xml"]],
["document-version",">scribble/core.html#(def._((lib._scribble/core..rkt)._document-version))",[0,[2,"document-version"]],["scribble/core"]],
["document-version-text",">scribble/core.html#(def._((lib._scribble/core..rkt)._document-version-text))",[0,[2,"document-version-text"]],["scribble/core"]],
["document-version?",">scribble/core.html#(def._((lib._scribble/core..rkt)._document-version~3f))",[0,[2,"document-version?"]],["scribble/core"]],
["document?",">xml/index.html#(def._((lib._xml/main..rkt)._document~3f))",[0,[2,"document?"]],["xml"]],
["documentation utilities",">tools/Documentation_Utilities.html","Documentation Utilities",false],
["documenting classes and interfaces",">scribble/doc-classes.html","Documenting Classes and Interfaces",false],
["documenting forms, functions, structure types, and values",">scribble/doc-forms.html","Documenting Forms, Functions, Structure Types, and Values",false],
["documenting modules",">scribble/doc-modules.html","Documenting Modules",false],
["documenting signatures",">scribble/doc-signatures.html","Documenting Signatures",false],
["domain",">guide/contract-func.html#(tech._domain)","<span style=\"font-style: italic\">domain</span>",false],
["domain specific language",">unstable/temp-c.html#(part._dsl)","Domain Specific Language",false],
["door-tall-closed",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._door-tall-closed))",[0,[2,"door-tall-closed"]],["2htdp/planetcute"]],
["door-tall-open",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._door-tall-open))",[0,[2,"door-tall-open"]],["2htdp/planetcute"]],
["dot",">draw/pen_.html#(idx._(gentag._56._(lib._scribblings/draw/draw..scrbl)))",[7,"'dot"],false],
["dot-dash",">draw/pen_.html#(idx._(gentag._59._(lib._scribblings/draw/draw..scrbl)))",[7,"'dot-dash"],false],
["dotproduct-vec3",">deinprogramm/line3d.html#(def._((lib._teachpack/deinprogramm/line3d..rkt)._dotproduct-vec3))",[0,[2,"dotproduct-vec3"]],["teachpack/deinprogramm/line3d"]],
["dotproduct-vec4",">deinprogramm/line3d.html#(def._((lib._teachpack/deinprogramm/line3d..rkt)._dotproduct-vec4))",[0,[2,"dotproduct-vec4"]],["teachpack/deinprogramm/line3d"]],
["dotted-list?",">srfi-std/srfi-1.html#dotted-list-p",[0,[2,"dotted-list?"]],["srfi/1"]],
["double-flonum?",">reference/number-types.html#(def._((lib._racket/private/base..rkt)._double-flonum~3f))",[0,[2,"double-flonum?"]],["racket/base","racket"]],
["down",">teachpack/2htdpuniverse.html#(form._((lib._2htdp/universe..rkt)._down))",[0,[1,"down"]],["2htdp/universe"]],
["down",">gui/key-event_.html#(idx._(gentag._55._(lib._scribblings/gui/gui..scrbl)))",[7,"'down"],false],
["down-arrow-icon",">images/Icons.html#(def._((lib._images/icons/arrow..rkt)._down-arrow-icon))",[0,[2,"down-arrow-icon"]],["images/icons/arrow"]],
["down-sexp",">framework/Racket.html#(meth._(((lib._framework/main..rkt)._racket~3atext~3c~25~3e)._down-sexp))",[[0,[2,"down-sexp"]],[14,[" (method of ",[0,[2,"racket:text<%>"]],")"]]],["framework"]],
["downcase-word",">framework/Keymap.html#(idx._(gentag._25._(lib._scribblings/framework/framework..scrbl)))","downcase-word",false],
["download-package",">planet/Utility_Libraries.html#(def._((lib._planet/util..rkt)._download-package))",[0,[2,"download-package"]],["planet/util"]],
["download/install-pkg",">planet/Utility_Libraries.html#(def._((lib._planet/util..rkt)._download/install-pkg))",[0,[2,"download/install-pkg"]],["planet/util"]],
["download?",">planet/Utility_Libraries.html#(def._((lib._planet/resolver..rkt)._download~3f))",[0,[2,"download?"]],["planet/resolver"]],
["dpflag",">scribble/doc-strings.html#(def._((lib._scribble/manual..rkt)._.D.P.Flag))",[0,[2,"DPFlag"]],["scribble/manual"]],
["dprintf",">unstable/Debugging.html#(def._((lib._unstable/debug..rkt)._dprintf))",[0,[2,"dprintf"]],["unstable/debug"]],
["drag-and-drop",">gui/top-level-window___.html#(idx._(gentag._134._(lib._scribblings/gui/gui..scrbl)))","drag-and-drop",false],
["drag-and-drop",">gui/window___.html#(idx._(gentag._137._(lib._scribblings/gui/gui..scrbl)))","drag-and-drop",false],
["drag-and-drop",">gui/window___.html#(idx._(gentag._140._(lib._scribblings/gui/gui..scrbl)))","drag-and-drop",false],
["drag-and-drop",">gui/Windowing_Functions.html#(idx._(gentag._151._(lib._scribblings/gui/gui..scrbl)))","drag-and-drop",false],
["dragging?",">gui/mouse-event_.html#(meth._(((lib._mred/main..rkt)._mouse-event~25)._dragging~3f))",[[0,[2,"dragging?"]],[14,[" (method of ",[0,[2,"mouse-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["draw",">gui/snip_.html#(meth._(((lib._racket/snip..rkt)._snip~25)._draw))",[[0,[2,"draw"]],[14,[" (method of ",[0,[2,"snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["draw",">framework/Racket.html#(meth._(((lib._framework/main..rkt)._racket~3asexp-snip~25)._draw))",[[0,[2,"draw"]],[14,[" (method of ",[0,[2,"racket:sexp-snip%"]],")"]]],["framework"]],
["draw",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3a1-pixel-string-snip~25)._draw))",[[0,[2,"draw"]],[14,[" (method of ",[0,[2,"text:1-pixel-string-snip%"]],")"]]],["framework"]],
["draw",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3a1-pixel-tab-snip~25)._draw))",[[0,[2,"draw"]],[14,[" (method of ",[0,[2,"text:1-pixel-tab-snip%"]],")"]]],["framework"]],
["draw",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtles..rkt)._draw))",[0,[2,"draw"]],["graphics/turtles"]],
["draw",">turtles/Value_Turtles.html#(def._((lib._graphics/value-turtles..rkt)._draw))",[0,[2,"draw"]],["graphics/value-turtles"]],
["draw",">deinprogramm/turtle.html#(def._((lib._teachpack/deinprogramm/turtle..rkt)._draw))",[0,[2,"draw"]],["teachpack/deinprogramm/turtle"]],
["draw signature",">draw/Signature_and_Unit.html#(part._.Draw_.Signature)","Draw Signature",false],
["draw teachpack",">teachpack/draw.html#(idx._(gentag._6._(lib._teachpack/teachpack..scrbl)))","draw teachpack",false],
["draw unit",">draw/Signature_and_Unit.html#(part._.Draw_.Unit)","Draw Unit",false],
["draw, clear, and flip operations",">graphics/Draw__Clear__and_Flip_Operations.html","Draw, Clear, and Flip Operations",false],
["draw-arc",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._draw-arc))",[[0,[2,"draw-arc"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["draw-bitmap",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._draw-bitmap))",[[0,[2,"draw-bitmap"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["draw-bitmap-section",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._draw-bitmap-section))",[[0,[2,"draw-bitmap-section"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["draw-bitmap-section-smooth",">draw/bitmap-dc_.html#(meth._(((lib._racket/draw..rkt)._bitmap-dc~25)._draw-bitmap-section-smooth))",[[0,[2,"draw-bitmap-section-smooth"]],[14,[" (method of ",[0,[2,"bitmap-dc%"]],")"]]],["racket/draw"]],
["draw-button-label",">mrlib/Name_Message.html#(def._((lib._mrlib/name-message..rkt)._draw-button-label))",[0,[2,"draw-button-label"]],["mrlib/name-message"]],
["draw-circle",">teachpack/draw.html#(def._((lib._htdp/big-draw..rkt)._draw-circle))",[0,[2,"draw-circle"]],["htdp/draw"]],
["draw-edges",">mrlib/graph-pasteboard___.html#(meth._(((lib._mrlib/graph..rkt)._graph-pasteboard~3c~25~3e)._draw-edges))",[[0,[2,"draw-edges"]],[14,[" (method of ",[0,[2,"graph-pasteboard<%>"]],")"]]],["mrlib/graph"]],
["draw-ellipse",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._draw-ellipse))",[[0,[2,"draw-ellipse"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["draw-ellipse",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..rkt)._draw-ellipse))",[0,[2,"draw-ellipse"]],["graphics/graphics"]],
["draw-flomap",">images/Conversion_and_Construction.html#(def._((lib._images/flomap..rkt)._draw-flomap))",[0,[2,"draw-flomap"]],["images/flomap"]],
["draw-line",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._draw-line))",[[0,[2,"draw-line"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["draw-line",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..rkt)._draw-line))",[0,[2,"draw-line"]],["graphics/graphics"]],
["draw-lines",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._draw-lines))",[[0,[2,"draw-lines"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["draw-message",">teachpack/gui.html#(def._((lib._htdp/gui..rkt)._draw-message))",[0,[2,"draw-message"]],["htdp/gui"]],
["draw-offset",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtles..rkt)._draw-offset))",[0,[2,"draw-offset"]],["graphics/turtles"]],
["draw-offset",">turtles/Value_Turtles.html#(def._((lib._graphics/value-turtles..rkt)._draw-offset))",[0,"draw-offset"],["graphics/value-turtles"]],
["draw-path",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._draw-path))",[[0,[2,"draw-path"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["draw-pict",">slideshow/Rendering.html#(def._((lib._slideshow/pict..rkt)._draw-pict))",[0,[2,"draw-pict"]],["slideshow/pict","slideshow"]],
["draw-pixel",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..rkt)._draw-pixel))",[0,[2,"draw-pixel"]],["graphics/graphics"]],
["draw-pixmap",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..rkt)._draw-pixmap))",[0,[2,"draw-pixmap"]],["graphics/graphics"]],
["draw-pixmap-posn",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..rkt)._draw-pixmap-posn))",[0,[2,"draw-pixmap-posn"]],["graphics/graphics"]],
["draw-point",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._draw-point))",[[0,[2,"draw-point"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["draw-polygon",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._draw-polygon))",[[0,[2,"draw-polygon"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["draw-polygon",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..rkt)._draw-polygon))",[0,[2,"draw-polygon"]],["graphics/graphics"]],
["draw-rectangle",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._draw-rectangle))",[[0,[2,"draw-rectangle"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["draw-rectangle",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..rkt)._draw-rectangle))",[0,[2,"draw-rectangle"]],["graphics/graphics"]],
["draw-rounded-rectangle",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._draw-rounded-rectangle))",[[0,[2,"draw-rounded-rectangle"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["draw-single-edge",">mrlib/graph-pasteboard___.html#(meth._(((lib._mrlib/graph..rkt)._graph-pasteboard~3c~25~3e)._draw-single-edge))",[[0,[2,"draw-single-edge"]],[14,[" (method of ",[0,[2,"graph-pasteboard<%>"]],")"]]],["mrlib/graph"]],
["draw-solid-disk",">teachpack/draw.html#(def._((lib._htdp/big-draw..rkt)._draw-solid-disk))",[0,[2,"draw-solid-disk"]],["htdp/draw"]],
["draw-solid-ellipse",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..rkt)._draw-solid-ellipse))",[0,[2,"draw-solid-ellipse"]],["graphics/graphics"]],
["draw-solid-line",">teachpack/draw.html#(def._((lib._htdp/big-draw..rkt)._draw-solid-line))",[0,[2,"draw-solid-line"]],["htdp/draw"]],
["draw-solid-polygon",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..rkt)._draw-solid-polygon))",[0,[2,"draw-solid-polygon"]],["graphics/graphics"]],
["draw-solid-rect",">teachpack/draw.html#(def._((lib._htdp/big-draw..rkt)._draw-solid-rect))",[0,[2,"draw-solid-rect"]],["htdp/draw"]],
["draw-solid-rectangle",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..rkt)._draw-solid-rectangle))",[0,[2,"draw-solid-rectangle"]],["graphics/graphics"]],
["draw-solid-string",">teachpack/draw.html#(def._((lib._htdp/big-draw..rkt)._draw-solid-string))",[0,[2,"draw-solid-string"]],["htdp/draw"]],
["draw-spline",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._draw-spline))",[[0,[2,"draw-spline"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["draw-string",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..rkt)._draw-string))",[0,[2,"draw-string"]],["graphics/graphics"]],
["draw-text",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._draw-text))",[[0,[2,"draw-text"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["draw-viewport",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..rkt)._draw-viewport))",[0,[2,"draw-viewport"]],["graphics/graphics"]],
["draw@",">draw/Signature_and_Unit.html#(def._((lib._racket/draw/draw-unit..rkt)._draw~40))",[0,[2,"draw@"]],["racket/draw/draw-unit"]],
["draw^",">draw/Signature_and_Unit.html#(form._((lib._racket/draw/draw-sig..rkt)._draw~5e))",[0,[1,"draw^"]],["racket/draw/draw-sig"]],
["drawcolor",">teachpack/draw.html#(tech._drawcolor)","<span style=\"font-style: italic\">DrawColor</span>",false],
["drawing outlines",">draw/brush_.html#(idx._(gentag._23._(lib._scribblings/draw/draw..scrbl)))","drawing, outlines",false],
["drawing context",">draw/overview.html#(tech._drawing._context)","<span style=\"font-style: italic\">drawing context</span>",false],
["drawing curves",">draw/dc___.html#(idx._(gentag._26._(lib._scribblings/draw/draw..scrbl)))","drawing curves",false],
["drawing functions",">draw/Drawing_Functions.html","Drawing Functions",false],
["drawing in canvases",">gui/windowing-overview.html#(part._canvas-drawing)","Drawing in Canvases",false],
["drawing on a canvas",">teachpack/draw.html#(part._drawing)","Drawing on a Canvas",false],
["drawing paths",">draw/overview.html#(part._.Drawing_.Paths)","Drawing Paths",false],
["drawing the cat",">games/Drawing_the_Cat.html","Drawing the Cat",false],
["drawing the world",">games/Drawing_the_World.html","Drawing the World",false],
["drawkeyevent",">teachpack/draw.html#(tech._drawkeyevent)","<span style=\"font-style: italic\">DrawKeyEvent</span>",false],
["drawworld",">teachpack/draw.html#(tech._drawworld)","<span style=\"font-style: italic\">DrawWorld</span>",false],
["drop",">reference/pairs.html#(def._((lib._racket/list..rkt)._drop))",[0,[2,"drop"]],["racket/list","racket"]],
["drop",">srfi-std/srfi-1.html#drop",[0,[2,"drop"]],["srfi/1"]],
["drop-below-ascent",">slideshow/Bounding_Box_Adjusters.html#(def._((lib._slideshow/pict..rkt)._drop-below-ascent))",[0,[2,"drop-below-ascent"]],["slideshow/pict","slideshow"]],
["drop-common-prefix",">unstable/list.html#(def._((lib._unstable/list..rkt)._drop-common-prefix))",[0,[2,"drop-common-prefix"]],["unstable/list"]],
["drop-right",">reference/pairs.html#(def._((lib._racket/list..rkt)._drop-right))",[0,[2,"drop-right"]],["racket/list","racket"]],
["drop-right",">srfi-std/srfi-1.html#drop-right",[0,[2,"drop-right"]],["srfi/1"]],
["drop-right!",">srfi-std/srfi-1.html#drop-right!",[0,[2,"drop-right!"]],["srfi/1"]],
["drop-while",">srfi-std/srfi-1.html#drop-while",[0,[2,"drop-while"]],["srfi/1"]],
["drracket browser preference panel",">browser/index.html#(part._tool)","DrRacket Browser Preference Panel",false],
["drracket comment boxes",">gui/WXME_Decoding.html#(part._.Dr.Racket_.Comment_.Boxes)","DrRacket Comment Boxes",false],
["drracket files",">drracket/drracket-files.html","DrRacket Files",false],
["drracket fractions",">gui/WXME_Decoding.html#(part._.Dr.Racket_.Fractions)","DrRacket Fractions",false],
["drracket plugins",">tools/index.html","DrRacket Plugins",false],
["drracket racket boxes",">gui/WXME_Decoding.html#(part._.Dr.Racket_.Racket_.Boxes)","DrRacket Racket Boxes",false],
["drracket teachpack images",">gui/WXME_Decoding.html#(part._.Dr.Racket_.Teachpack_.Images)","DrRacket Teachpack Images",false],
["drracket teachpacks",">drracket/extending-drracket.html#(idx._(gentag._384._(lib._scribblings/drracket/drracket..scrbl)))","DrRacket\n  Teachpacks",false],
["drracket test-case boxes",">gui/WXME_Decoding.html#(part._.Dr.Racket_.Test-.Case_.Boxes)","DrRacket Test-Case Boxes",false],
["drracket text boxes",">gui/WXME_Decoding.html#(part._.Dr.Racket_.Text_.Boxes)","DrRacket Text Boxes",false],
["drracket version tool",">version/index.html#(part._.Dr.Racket_.Version_.Tool)","DrRacket Version Tool",false],
["drracket xml boxes",">gui/WXME_Decoding.html#(part._.Dr.Racket_.X.M.L_.Boxes)","DrRacket XML Boxes",false],
["drracket-tool-icons",">tools/implementing-tools.html#(idx._(gentag._2._(lib._scribblings/tools/tools..scrbl)))",[0,"drracket-tool-icons"],false],
["drracket-tool-names",">tools/implementing-tools.html#(idx._(gentag._1._(lib._scribblings/tools/tools..scrbl)))",[0,"drracket-tool-names"],false],
["drracket-tool-urls",">tools/implementing-tools.html#(idx._(gentag._3._(lib._scribblings/tools/tools..scrbl)))",[0,"drracket-tool-urls"],false],
["drracket-tools",">tools/implementing-tools.html#(idx._(gentag._0._(lib._scribblings/tools/tools..scrbl)))",[0,"drracket-tools"],false],
["drracket/check-syntax",">tools/Check_Syntax.html#(mod-path._drracket/check-syntax)",[9,[0,"drracket/check-syntax"]],"module"],
["drracket/syncheck-drracket-button",">tools/Check_Syntax.html#(mod-path._drracket/syncheck-drracket-button)",[9,[0,"drracket/syncheck-drracket-button"]],"module"],
["drracket/tool-lib",">tools/index.html",[9,[0,"drracket/tool-lib"]],"module"],
["drracket: the racket programming environment",">drracket/index.html","DrRacket: The Racket Programming Environment",false],
["drracket:debug",">tools/drracket_debug.html",[6,"drracket:debug"],false],
["drracket:debug:add-prefs-panel",">tools/drracket_debug.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3adebug~3aadd-prefs-panel))",[0,[2,"drracket:debug:add-prefs-panel"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:debug:error-display-handler/stacktrace",">tools/drracket_debug.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3adebug~3aerror-display-handler/stacktrace))",[0,[2,"drracket:debug:error-display-handler/stacktrace"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:debug:hide-backtrace-window",">tools/drracket_debug.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3adebug~3ahide-backtrace-window))",[0,[2,"drracket:debug:hide-backtrace-window"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:debug:make-debug-error-display-handler",">tools/drracket_debug.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3adebug~3amake-debug-error-display-handler))",[0,[2,"drracket:debug:make-debug-error-display-handler"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:debug:open-and-highlight-in-file",">tools/drracket_debug.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3adebug~3aopen-and-highlight-in-file))",[0,[2,"drracket:debug:open-and-highlight-in-file"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:debug:profile-definitions-text-mixin",">tools/drracket_debug.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3adebug~3aprofile-definitions-text-mixin))",[0,[2,"drracket:debug:profile-definitions-text-mixin"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:debug:profile-interactions-text-mixin",">tools/drracket_debug.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3adebug~3aprofile-interactions-text-mixin))",[0,"drracket:debug:profile-interactions-text-mixin"],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:debug:profile-unit-frame-mixin",">tools/drracket_debug.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3adebug~3aprofile-unit-frame-mixin))",[0,[2,"drracket:debug:profile-unit-frame-mixin"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:debug:show-backtrace-window",">tools/drracket_debug.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3adebug~3ashow-backtrace-window))",[0,[2,"drracket:debug:show-backtrace-window"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:debug:show-backtrace-window/edition-pairs",">tools/drracket_debug.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3adebug~3ashow-backtrace-window/edition-pairs))",[0,[2,"drracket:debug:show-backtrace-window/edition-pairs"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:debug:show-backtrace-window/edition-pairs/two",">tools/drracket_debug.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3adebug~3ashow-backtrace-window/edition-pairs/two))",[0,[2,"drracket:debug:show-backtrace-window/edition-pairs/two"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:debug:srcloc->edition/pair",">tools/drracket_debug.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3adebug~3asrcloc-~3eedition/pair))",[0,[2,"drracket:debug:srcloc->edition/pair"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:eval",">tools/drracket_eval.html",[6,"drracket:eval"],false],
["drracket:eval:build-user-eventspace/custodian",">tools/drracket_eval.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3aeval~3abuild-user-eventspace/custodian))",[0,[2,"drracket:eval:build-user-eventspace/custodian"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:eval:expand-program",">tools/drracket_eval.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3aeval~3aexpand-program))",[0,[2,"drracket:eval:expand-program"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:eval:expand-program/multiple",">tools/drracket_eval.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3aeval~3aexpand-program/multiple))",[0,[2,"drracket:eval:expand-program/multiple"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:eval:get-snip-classes",">tools/drracket_eval.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3aeval~3aget-snip-classes))",[0,[2,"drracket:eval:get-snip-classes"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:eval:set-basic-parameters",">tools/drracket_eval.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3aeval~3aset-basic-parameters))",[0,[2,"drracket:eval:set-basic-parameters"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:eval:traverse-program/multiple",">tools/drracket_eval.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3aeval~3atraverse-program/multiple))",[0,[2,"drracket:eval:traverse-program/multiple"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:frame",">tools/drracket_frame.html",[6,"drracket:frame"],false],
["drracket:frame:<%>",">tools/drracket_frame.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3aframe~3a~3c~25~3e))",[0,[2,"drracket:frame:<%>"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:frame:basics-mixin",">tools/drracket_frame.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3aframe~3abasics-mixin))",[0,[2,"drracket:frame:basics-mixin"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:frame:basics<%>",">tools/drracket_frame.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3aframe~3abasics~3c~25~3e))",[0,[2,"drracket:frame:basics<%>"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:frame:mixin",">tools/drracket_frame.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3aframe~3amixin))",[0,[2,"drracket:frame:mixin"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:frame:name-message%",">tools/drracket_frame.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3aframe~3aname-message~25))",[0,"drracket:frame:name-message%"],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:get/extend",">tools/drracket_get_extend.html",[6,"drracket:get/extend"],false],
["drracket:get/extend:extend-definitions-canvas",">tools/drracket_get_extend.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3aget/extend~3aextend-definitions-canvas))",[0,[2,"drracket:get/extend:extend-definitions-canvas"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:get/extend:extend-definitions-text",">tools/drracket_get_extend.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3aget/extend~3aextend-definitions-text))",[0,[2,"drracket:get/extend:extend-definitions-text"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:get/extend:extend-interactions-canvas",">tools/drracket_get_extend.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3aget/extend~3aextend-interactions-canvas))",[0,[2,"drracket:get/extend:extend-interactions-canvas"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:get/extend:extend-interactions-text",">tools/drracket_get_extend.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3aget/extend~3aextend-interactions-text))",[0,[2,"drracket:get/extend:extend-interactions-text"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:get/extend:extend-tab",">tools/drracket_get_extend.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3aget/extend~3aextend-tab))",[0,[2,"drracket:get/extend:extend-tab"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:get/extend:extend-unit-frame",">tools/drracket_get_extend.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3aget/extend~3aextend-unit-frame))",[0,[2,"drracket:get/extend:extend-unit-frame"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:get/extend:get-definitions-canvas",">tools/drracket_get_extend.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3aget/extend~3aget-definitions-canvas))",[0,[2,"drracket:get/extend:get-definitions-canvas"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:get/extend:get-definitions-text",">tools/drracket_get_extend.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3aget/extend~3aget-definitions-text))",[0,[2,"drracket:get/extend:get-definitions-text"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:get/extend:get-interactions-canvas",">tools/drracket_get_extend.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3aget/extend~3aget-interactions-canvas))",[0,[2,"drracket:get/extend:get-interactions-canvas"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:get/extend:get-interactions-text",">tools/drracket_get_extend.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3aget/extend~3aget-interactions-text))",[0,[2,"drracket:get/extend:get-interactions-text"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:get/extend:get-unit-frame",">tools/drracket_get_extend.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3aget/extend~3aget-unit-frame))",[0,[2,"drracket:get/extend:get-unit-frame"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:help-desk",">tools/drracket_help-desk.html",[6,"drracket:help-desk"],false],
["drracket:help-desk:help-desk",">tools/drracket_help-desk.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3ahelp-desk~3ahelp-desk))",[0,[2,"drracket:help-desk:help-desk"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:language",">tools/drracket_language.html",[6,"drracket:language"],false],
["drracket:language-configuration",">tools/drracket_language-configuration.html",[6,"drracket:language-configuration"],false],
["drracket:language-configuration:add-language",">tools/drracket_language-configuration.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3alanguage-configuration~3aadd-language))",[0,[2,"drracket:language-configuration:add-language"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:language-configuration:fill-language-dialog",">tools/drracket_language-configuration.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3alanguage-configuration~3afill-language-dialog))",[0,[2,"drracket:language-configuration:fill-language-dialog"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:language-configuration:get-languages",">tools/drracket_language-configuration.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3alanguage-configuration~3aget-languages))",[0,[2,"drracket:language-configuration:get-languages"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:language-configuration:get-settings-preferences-symbol",">tools/drracket_language-configuration.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3alanguage-configuration~3aget-settings-preferences-symbol))",[0,[2,"drracket:language-configuration:get-settings-preferences-symbol"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:language-configuration:language-dialog",">tools/drracket_language-configuration.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3alanguage-configuration~3alanguage-dialog))",[0,[2,"drracket:language-configuration:language-dialog"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:language-configuration:language-settings",">tools/drracket_language-configuration.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3alanguage-configuration~3alanguage-settings))",[0,[2,"drracket:language-configuration:language-settings"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:language-configuration:language-settings-language",">tools/drracket_language-configuration.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3alanguage-configuration~3alanguage-settings-language))",[0,[2,"drracket:language-configuration:language-settings-language"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:language-configuration:language-settings-settings",">tools/drracket_language-configuration.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3alanguage-configuration~3alanguage-settings-settings))",[0,[2,"drracket:language-configuration:language-settings-settings"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:language-configuration:language-settings?",">tools/drracket_language-configuration.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3alanguage-configuration~3alanguage-settings~3f))",[0,[2,"drracket:language-configuration:language-settings?"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:language:add-snip-value",">tools/drracket_language.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3aadd-snip-value))",[0,[2,"drracket:language:add-snip-value"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:language:capability-registered?",">tools/drracket_language.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3acapability-registered~3f))",[0,[2,"drracket:language:capability-registered?"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:language:create-distribution-for-executable",">tools/drracket_language.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3acreate-distribution-for-executable))",[0,[2,"drracket:language:create-distribution-for-executable"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:language:create-executable-gui",">tools/drracket_language.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3acreate-executable-gui))",[0,[2,"drracket:language:create-executable-gui"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:language:create-module-based-distribution",">tools/drracket_language.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3acreate-module-based-distribution))",[0,[2,"drracket:language:create-module-based-distribution"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:language:create-module-based-launcher",">tools/drracket_language.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3acreate-module-based-launcher))",[0,[2,"drracket:language:create-module-based-launcher"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:language:create-module-based-stand-alone-executable",">tools/drracket_language.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3acreate-module-based-stand-alone-executable))",[0,[2,"drracket:language:create-module-based-stand-alone-executable"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:language:extend-language-interface",">tools/drracket_language.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3aextend-language-interface))",[0,[2,"drracket:language:extend-language-interface"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:language:get-capability-contract",">tools/drracket_language.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3aget-capability-contract))",[0,[2,"drracket:language:get-capability-contract"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:language:get-capability-default",">tools/drracket_language.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3aget-capability-default))",[0,[2,"drracket:language:get-capability-default"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:language:get-default-mixin",">tools/drracket_language.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3aget-default-mixin))",[0,[2,"drracket:language:get-default-mixin"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:language:get-language-extensions",">tools/drracket_language.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3aget-language-extensions))",[0,[2,"drracket:language:get-language-extensions"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:language:language<%>",">tools/drracket_language.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3alanguage~3c~25~3e))",[0,[2,"drracket:language:language<%>"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:language:make-setup-printing-parameters",">tools/drracket_language.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3amake-setup-printing-parameters))",[0,[2,"drracket:language:make-setup-printing-parameters"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:language:make-simple-settings",">tools/drracket_language.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3amake-simple-settings))",[0,[2,"drracket:language:make-simple-settings"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:language:make-text/pos",">tools/drracket_language.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3amake-text/pos))",[0,[2,"drracket:language:make-text/pos"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:language:module-based-language->language-mixin",">tools/drracket_language.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3amodule-based-language-~3elanguage-mixin))",[0,[2,"drracket:language:module-based-language->language-mixin"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:language:module-based-language<%>",">tools/drracket_language.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3amodule-based-language~3c~25~3e))",[0,[2,"drracket:language:module-based-language<%>"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:language:module-language<%>",">tools/drracket_module-language.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3amodule-language~3c~25~3e))",[0,"drracket:language:module-language<%>"],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:language:object/c",">tools/drracket_language.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3aobject/c))",[0,[2,"drracket:language:object/c"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:language:put-executable",">tools/drracket_language.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3aput-executable))",[0,[2,"drracket:language:put-executable"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:language:register-capability",">tools/drracket_language.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3aregister-capability))",[0,[2,"drracket:language:register-capability"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:language:setup-printing-parameters",">tools/drracket_language.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3asetup-printing-parameters))",[0,[2,"drracket:language:setup-printing-parameters"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:language:simple-module-based-language%",">tools/drracket_language.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3asimple-module-based-language~25))",[0,[2,"drracket:language:simple-module-based-language%"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:language:simple-module-based-language->module-based-language-mixin",">tools/drracket_language.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3asimple-module-based-language-~3emodule-based-language-mixin))",[0,[2,"drracket:language:simple-module-based-language->module-based-language-mixin"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:language:simple-module-based-language-convert-value",">tools/drracket_language.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3asimple-module-based-language-convert-value))",[0,[2,"drracket:language:simple-module-based-language-convert-value"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:language:simple-module-based-language<%>",">tools/drracket_language.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3asimple-module-based-language~3c~25~3e))",[0,[2,"drracket:language:simple-module-based-language<%>"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:language:simple-settings",">tools/drracket_language.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3asimple-settings))",[0,[2,"drracket:language:simple-settings"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:language:simple-settings",">tools/drracket_language.html#(idx._(gentag._30._(lib._scribblings/tools/tools..scrbl)))","drracket:language:simple-settings",false],
["drracket:language:simple-settings->vector",">tools/drracket_language.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3asimple-settings-~3evector))",[0,[2,"drracket:language:simple-settings->vector"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:language:simple-settings-annotations",">tools/drracket_language.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3asimple-settings-annotations))",[0,[2,"drracket:language:simple-settings-annotations"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:language:simple-settings-case-sensitive",">tools/drracket_language.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3asimple-settings-case-sensitive))",[0,[2,"drracket:language:simple-settings-case-sensitive"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:language:simple-settings-fraction-style",">tools/drracket_language.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3asimple-settings-fraction-style))",[0,[2,"drracket:language:simple-settings-fraction-style"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:language:simple-settings-insert-newlines",">tools/drracket_language.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3asimple-settings-insert-newlines))",[0,[2,"drracket:language:simple-settings-insert-newlines"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:language:simple-settings-printing-style",">tools/drracket_language.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3asimple-settings-printing-style))",[0,[2,"drracket:language:simple-settings-printing-style"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:language:simple-settings-show-sharing",">tools/drracket_language.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3asimple-settings-show-sharing))",[0,[2,"drracket:language:simple-settings-show-sharing"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:language:simple-settings?",">tools/drracket_language.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3asimple-settings~3f))",[0,[2,"drracket:language:simple-settings?"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:language:text/pos",">tools/drracket_language.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3atext/pos))",[0,[2,"drracket:language:text/pos"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:language:text/pos-end",">tools/drracket_language.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3atext/pos-end))",[0,[2,"drracket:language:text/pos-end"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:language:text/pos-start",">tools/drracket_language.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3atext/pos-start))",[0,[2,"drracket:language:text/pos-start"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:language:text/pos-text",">tools/drracket_language.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3atext/pos-text))",[0,[2,"drracket:language:text/pos-text"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:language:text/pos?",">tools/drracket_language.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3atext/pos~3f))",[0,[2,"drracket:language:text/pos?"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:modes",">tools/drracket_modes.html",[6,"drracket:modes"],false],
["drracket:modes:add-mode",">tools/drracket_modes.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3amodes~3aadd-mode))",[0,[2,"drracket:modes:add-mode"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:modes:get-modes",">tools/drracket_modes.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3amodes~3aget-modes))",[0,[2,"drracket:modes:get-modes"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:modes:mode-matches-language",">tools/drracket_modes.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3amodes~3amode-matches-language))",[0,[2,"drracket:modes:mode-matches-language"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:modes:mode-name",">tools/drracket_modes.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3amodes~3amode-name))",[0,[2,"drracket:modes:mode-name"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:modes:mode-repl-submit",">tools/drracket_modes.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3amodes~3amode-repl-submit))",[0,[2,"drracket:modes:mode-repl-submit"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:modes:mode-surrogate",">tools/drracket_modes.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3amodes~3amode-surrogate))",[0,[2,"drracket:modes:mode-surrogate"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:modes:mode?",">tools/drracket_modes.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3amodes~3amode~3f))",[0,[2,"drracket:modes:mode?"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:module-language",">tools/drracket_module-language.html",[6,"drracket:module-language"],false],
["drracket:module-language-tools",">tools/drracket_module-language-tools.html",[6,"drracket:module-language-tools"],false],
["drracket:module-language-tools:add-online-expansion-handler",">tools/drracket_module-language-tools.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3amodule-language-tools~3aadd-online-expansion-handler))",[0,[2,"drracket:module-language-tools:add-online-expansion-handler"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:module-language-tools:add-opt-out-toolbar-button",">tools/drracket_module-language-tools.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3amodule-language-tools~3aadd-opt-out-toolbar-button))",[0,[2,"drracket:module-language-tools:add-opt-out-toolbar-button"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:module-language:add-module-language",">tools/drracket_module-language.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3amodule-language~3aadd-module-language))",[0,[2,"drracket:module-language:add-module-language"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:module-language:module-language-put-file-mixin",">tools/drracket_module-language.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3amodule-language~3amodule-language-put-file-mixin))",[0,[2,"drracket:module-language:module-language-put-file-mixin"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:rep",">tools/drracket_rep.html",[6,"drracket:rep"],false],
["drracket:rep:after-expression",">tools/drracket_rep.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3arep~3aafter-expression))",[0,[2,"drracket:rep:after-expression"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:rep:context<%>",">tools/drracket_rep.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3arep~3acontext~3c~25~3e))",[0,[2,"drracket:rep:context<%>"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:rep:current-rep",">tools/drracket_rep.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3arep~3acurrent-rep))",[0,[2,"drracket:rep:current-rep"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:rep:current-value-port",">tools/drracket_rep.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3arep~3acurrent-value-port))",[0,[2,"drracket:rep:current-value-port"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:rep:drs-bindings-keymap-mixin",">tools/drracket_rep.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3arep~3adrs-bindings-keymap-mixin))",[0,[2,"drracket:rep:drs-bindings-keymap-mixin"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:rep:get-dark-green-delta",">tools/drracket_rep.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3arep~3aget-dark-green-delta))",[0,[2,"drracket:rep:get-dark-green-delta"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:rep:get-drs-bindings-keymap",">tools/drracket_rep.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3arep~3aget-drs-bindings-keymap))",[0,[2,"drracket:rep:get-drs-bindings-keymap"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:rep:get-welcome-delta",">tools/drracket_rep.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3arep~3aget-welcome-delta))",[0,[2,"drracket:rep:get-welcome-delta"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:rep:text%",">tools/drracket_rep.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3arep~3atext~25))",[0,[2,"drracket:rep:text%"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:rep:text<%>",">tools/drracket_rep.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3arep~3atext~3c~25~3e))",[0,[2,"drracket:rep:text<%>"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:tool-exports^",">tools/implementing-tools.html#(idx._(gentag._7._(lib._scribblings/tools/tools..scrbl)))",[0,"drracket:tool-exports^"],false],
["drracket:tool^",">tools/implementing-tools.html#(idx._(gentag._6._(lib._scribblings/tools/tools..scrbl)))",[0,"drracket:tool^"],false],
["drracket:toolbar-buttons",">tools/drracket_module-language-tools.html#(idx._(gentag._32._(lib._scribblings/tools/tools..scrbl)))",[7,"'drracket:toolbar-buttons"],false],
["drracket:unit",">tools/drracket_unit.html",[6,"drracket:unit"],false],
["drracket:unit:add-search-help-desk-menu-item",">tools/drracket_unit.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aadd-search-help-desk-menu-item))",[0,[2,"drracket:unit:add-search-help-desk-menu-item"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:unit:add-to-program-editor-mixin",">tools/drracket_unit.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aadd-to-program-editor-mixin))",[0,[2,"drracket:unit:add-to-program-editor-mixin"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:unit:definitions-canvas%",">tools/drracket_unit.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3aunit~3adefinitions-canvas~25))",[0,[2,"drracket:unit:definitions-canvas%"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:unit:definitions-text%",">tools/drracket_unit.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3aunit~3adefinitions-text~25))",[0,"drracket:unit:definitions-text%"],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:unit:definitions-text<%>",">tools/drracket_unit.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3aunit~3adefinitions-text~3c~25~3e))",[0,[2,"drracket:unit:definitions-text<%>"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:unit:frame%",">tools/drracket_unit.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aframe~25))",[0,[2,"drracket:unit:frame%"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:unit:frame<%>",">tools/drracket_unit.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aframe~3c~25~3e))",[0,[2,"drracket:unit:frame<%>"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:unit:get-program-editor-mixin",">tools/drracket_unit.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aget-program-editor-mixin))",[0,[2,"drracket:unit:get-program-editor-mixin"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:unit:interactions-canvas%",">tools/drracket_unit.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3aunit~3ainteractions-canvas~25))",[0,[2,"drracket:unit:interactions-canvas%"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:unit:open-drscheme-window",">tools/drracket_unit.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aopen-drscheme-window))",[0,[2,"drracket:unit:open-drscheme-window"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:unit:program-editor-mixin",">tools/drracket_unit.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aprogram-editor-mixin))",[0,[2,"drracket:unit:program-editor-mixin"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:unit:tab%",">tools/drracket_unit.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3aunit~3atab~25))",[0,[2,"drracket:unit:tab%"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drracket:unit:tab<%>",">tools/drracket_unit.html#(def._((lib._drracket/tool-lib..rkt)._drracket~3aunit~3atab~3c~25~3e))",[0,[2,"drracket:unit:tab<%>"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme",">scheme/compat-exe.html#(idx._(gentag._2._(lib._scribblings/scheme/scheme..scrbl)))",[6,"drscheme"],false],
["drscheme-language-modules",">tools/adding-languages.html#(idx._(gentag._17._(lib._scribblings/tools/tools..scrbl)))",[0,"drscheme-language-modules"],false],
["drscheme-language-numbers",">tools/adding-languages.html#(idx._(gentag._19._(lib._scribblings/tools/tools..scrbl)))",[0,"drscheme-language-numbers"],false],
["drscheme-language-one-line-summaries",">tools/adding-languages.html#(idx._(gentag._20._(lib._scribblings/tools/tools..scrbl)))",[0,"drscheme-language-one-line-summaries"],false],
["drscheme-language-positions",">tools/adding-languages.html#(idx._(gentag._18._(lib._scribblings/tools/tools..scrbl)))",[0,"drscheme-language-positions"],false],
["drscheme-language-readers",">tools/adding-languages.html#(idx._(gentag._22._(lib._scribblings/tools/tools..scrbl)))",[0,"drscheme-language-readers"],false],
["drscheme-language-urls",">tools/adding-languages.html#(idx._(gentag._21._(lib._scribblings/tools/tools..scrbl)))",[0,"drscheme-language-urls"],false],
["drscheme/tool-lib",">tools/index.html",[9,[0,"drscheme/tool-lib"]],"module"],
["drscheme:debug:add-prefs-panel",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3adebug~3aadd-prefs-panel))",[0,[2,"drscheme:debug:add-prefs-panel"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:debug:error-display-handler/stacktrace",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3adebug~3aerror-display-handler/stacktrace))",[0,[2,"drscheme:debug:error-display-handler/stacktrace"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:debug:hide-backtrace-window",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3adebug~3ahide-backtrace-window))",[0,[2,"drscheme:debug:hide-backtrace-window"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:debug:make-debug-error-display-handler",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3adebug~3amake-debug-error-display-handler))",[0,[2,"drscheme:debug:make-debug-error-display-handler"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:debug:open-and-highlight-in-file",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3adebug~3aopen-and-highlight-in-file))",[0,[2,"drscheme:debug:open-and-highlight-in-file"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:debug:profile-definitions-text-mixin",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3adebug~3aprofile-definitions-text-mixin))",[0,"drscheme:debug:profile-definitions-text-mixin"],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:debug:profile-tab-mixin",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3adebug~3aprofile-tab-mixin))",[0,"drscheme:debug:profile-tab-mixin"],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:debug:profile-unit-frame-mixin",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3adebug~3aprofile-unit-frame-mixin))",[0,"drscheme:debug:profile-unit-frame-mixin"],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:debug:show-backtrace-window",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3adebug~3ashow-backtrace-window))",[0,[2,"drscheme:debug:show-backtrace-window"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:debug:show-backtrace-window/edition-pairs",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3adebug~3ashow-backtrace-window/edition-pairs))",[0,[2,"drscheme:debug:show-backtrace-window/edition-pairs"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:debug:show-backtrace-window/edition-pairs/two",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3adebug~3ashow-backtrace-window/edition-pairs/two))",[0,[2,"drscheme:debug:show-backtrace-window/edition-pairs/two"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:debug:srcloc->edition/pair",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3adebug~3asrcloc-~3eedition/pair))",[0,[2,"drscheme:debug:srcloc->edition/pair"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:debug:test-coverage-definitions-text-mixin",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3adebug~3atest-coverage-definitions-text-mixin))",[0,"drscheme:debug:test-coverage-definitions-text-mixin"],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:debug:test-coverage-interactions-text-mixin",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3adebug~3atest-coverage-interactions-text-mixin))",[0,"drscheme:debug:test-coverage-interactions-text-mixin"],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:debug:test-coverage-tab-mixin",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3adebug~3atest-coverage-tab-mixin))",[0,"drscheme:debug:test-coverage-tab-mixin"],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:eval:build-user-eventspace/custodian",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3aeval~3abuild-user-eventspace/custodian))",[0,[2,"drscheme:eval:build-user-eventspace/custodian"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:eval:expand-program",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3aeval~3aexpand-program))",[0,[2,"drscheme:eval:expand-program"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:eval:expand-program/multiple",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3aeval~3aexpand-program/multiple))",[0,[2,"drscheme:eval:expand-program/multiple"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:eval:get-snip-classes",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3aeval~3aget-snip-classes))",[0,[2,"drscheme:eval:get-snip-classes"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:eval:set-basic-parameters",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3aeval~3aset-basic-parameters))",[0,[2,"drscheme:eval:set-basic-parameters"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:eval:traverse-program/multiple",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3aeval~3atraverse-program/multiple))",[0,[2,"drscheme:eval:traverse-program/multiple"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:frame:<%>",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3aframe~3a~3c~25~3e))",[0,"drscheme:frame:<%>"],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:frame:basics-mixin",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3aframe~3abasics-mixin))",[0,"drscheme:frame:basics-mixin"],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:frame:basics<%>",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3aframe~3abasics~3c~25~3e))",[0,"drscheme:frame:basics<%>"],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:frame:mixin",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3aframe~3amixin))",[0,"drscheme:frame:mixin"],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:get/extend:extend-definitions-canvas",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3aget/extend~3aextend-definitions-canvas))",[0,[2,"drscheme:get/extend:extend-definitions-canvas"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:get/extend:extend-definitions-text",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3aget/extend~3aextend-definitions-text))",[0,[2,"drscheme:get/extend:extend-definitions-text"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:get/extend:extend-interactions-canvas",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3aget/extend~3aextend-interactions-canvas))",[0,[2,"drscheme:get/extend:extend-interactions-canvas"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:get/extend:extend-interactions-text",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3aget/extend~3aextend-interactions-text))",[0,[2,"drscheme:get/extend:extend-interactions-text"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:get/extend:extend-tab",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3aget/extend~3aextend-tab))",[0,[2,"drscheme:get/extend:extend-tab"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:get/extend:extend-unit-frame",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3aget/extend~3aextend-unit-frame))",[0,[2,"drscheme:get/extend:extend-unit-frame"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:get/extend:get-definitions-canvas",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3aget/extend~3aget-definitions-canvas))",[0,[2,"drscheme:get/extend:get-definitions-canvas"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:get/extend:get-definitions-text",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3aget/extend~3aget-definitions-text))",[0,[2,"drscheme:get/extend:get-definitions-text"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:get/extend:get-interactions-canvas",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3aget/extend~3aget-interactions-canvas))",[0,[2,"drscheme:get/extend:get-interactions-canvas"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:get/extend:get-interactions-text",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3aget/extend~3aget-interactions-text))",[0,[2,"drscheme:get/extend:get-interactions-text"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:get/extend:get-unit-frame",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3aget/extend~3aget-unit-frame))",[0,[2,"drscheme:get/extend:get-unit-frame"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:help-desk:help-desk",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3ahelp-desk~3ahelp-desk))",[0,[2,"drscheme:help-desk:help-desk"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:language-configuration:add-language",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3alanguage-configuration~3aadd-language))",[0,[2,"drscheme:language-configuration:add-language"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:language-configuration:fill-language-dialog",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3alanguage-configuration~3afill-language-dialog))",[0,[2,"drscheme:language-configuration:fill-language-dialog"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:language-configuration:get-languages",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3alanguage-configuration~3aget-languages))",[0,[2,"drscheme:language-configuration:get-languages"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:language-configuration:get-settings-preferences-symbol",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3alanguage-configuration~3aget-settings-preferences-symbol))",[0,[2,"drscheme:language-configuration:get-settings-preferences-symbol"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:language-configuration:language-dialog",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3alanguage-configuration~3alanguage-dialog))",[0,[2,"drscheme:language-configuration:language-dialog"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:language-configuration:language-settings",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3alanguage-configuration~3alanguage-settings))",[0,[2,"drscheme:language-configuration:language-settings"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:language-configuration:language-settings-language",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3alanguage-configuration~3alanguage-settings-language))",[0,[2,"drscheme:language-configuration:language-settings-language"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:language-configuration:language-settings-settings",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3alanguage-configuration~3alanguage-settings-settings))",[0,[2,"drscheme:language-configuration:language-settings-settings"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:language-configuration:language-settings?",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3alanguage-configuration~3alanguage-settings~3f))",[0,[2,"drscheme:language-configuration:language-settings?"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:language:add-snip-value",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3alanguage~3aadd-snip-value))",[0,[2,"drscheme:language:add-snip-value"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:language:capability-registered?",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3alanguage~3acapability-registered~3f))",[0,[2,"drscheme:language:capability-registered?"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:language:create-distribution-for-executable",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3alanguage~3acreate-distribution-for-executable))",[0,[2,"drscheme:language:create-distribution-for-executable"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:language:create-executable-gui",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3alanguage~3acreate-executable-gui))",[0,[2,"drscheme:language:create-executable-gui"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:language:create-module-based-distribution",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3alanguage~3acreate-module-based-distribution))",[0,[2,"drscheme:language:create-module-based-distribution"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:language:create-module-based-launcher",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3alanguage~3acreate-module-based-launcher))",[0,[2,"drscheme:language:create-module-based-launcher"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:language:create-module-based-stand-alone-executable",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3alanguage~3acreate-module-based-stand-alone-executable))",[0,[2,"drscheme:language:create-module-based-stand-alone-executable"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:language:extend-language-interface",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3alanguage~3aextend-language-interface))",[0,[2,"drscheme:language:extend-language-interface"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:language:get-capability-contract",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3alanguage~3aget-capability-contract))",[0,[2,"drscheme:language:get-capability-contract"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:language:get-capability-default",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3alanguage~3aget-capability-default))",[0,[2,"drscheme:language:get-capability-default"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:language:get-default-mixin",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3alanguage~3aget-default-mixin))",[0,[2,"drscheme:language:get-default-mixin"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:language:get-language-extensions",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3alanguage~3aget-language-extensions))",[0,[2,"drscheme:language:get-language-extensions"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:language:language<%>",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3alanguage~3alanguage~3c~25~3e))",[0,"drscheme:language:language<%>"],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:language:make-setup-printing-parameters",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3alanguage~3amake-setup-printing-parameters))",[0,[2,"drscheme:language:make-setup-printing-parameters"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:language:make-simple-settings",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3alanguage~3amake-simple-settings))",[0,[2,"drscheme:language:make-simple-settings"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:language:make-text/pos",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3alanguage~3amake-text/pos))",[0,[2,"drscheme:language:make-text/pos"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:language:module-based-language->language-mixin",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3alanguage~3amodule-based-language-~3elanguage-mixin))",[0,"drscheme:language:module-based-language->language-mixin"],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:language:module-based-language<%>",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3alanguage~3amodule-based-language~3c~25~3e))",[0,"drscheme:language:module-based-language<%>"],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:language:put-executable",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3alanguage~3aput-executable))",[0,[2,"drscheme:language:put-executable"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:language:register-capability",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3alanguage~3aregister-capability))",[0,[2,"drscheme:language:register-capability"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:language:setup-printing-parameters",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3alanguage~3asetup-printing-parameters))",[0,[2,"drscheme:language:setup-printing-parameters"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:language:simple-module-based-language%",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3alanguage~3asimple-module-based-language~25))",[0,"drscheme:language:simple-module-based-language%"],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:language:simple-module-based-language->module-based-language-mixin",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3alanguage~3asimple-module-based-language-~3emodule-based-language-mixin))",[0,"drscheme:language:simple-module-based-language->module-based-language-mixin"],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:language:simple-module-based-language-convert-value",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3alanguage~3asimple-module-based-language-convert-value))",[0,[2,"drscheme:language:simple-module-based-language-convert-value"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:language:simple-module-based-language<%>",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3alanguage~3asimple-module-based-language~3c~25~3e))",[0,"drscheme:language:simple-module-based-language<%>"],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:language:simple-settings",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3alanguage~3asimple-settings))",[0,[2,"drscheme:language:simple-settings"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:language:simple-settings->vector",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3alanguage~3asimple-settings-~3evector))",[0,[2,"drscheme:language:simple-settings->vector"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:language:simple-settings-annotations",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3alanguage~3asimple-settings-annotations))",[0,[2,"drscheme:language:simple-settings-annotations"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:language:simple-settings-case-sensitive",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3alanguage~3asimple-settings-case-sensitive))",[0,[2,"drscheme:language:simple-settings-case-sensitive"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:language:simple-settings-fraction-style",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3alanguage~3asimple-settings-fraction-style))",[0,[2,"drscheme:language:simple-settings-fraction-style"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:language:simple-settings-insert-newlines",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3alanguage~3asimple-settings-insert-newlines))",[0,[2,"drscheme:language:simple-settings-insert-newlines"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:language:simple-settings-printing-style",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3alanguage~3asimple-settings-printing-style))",[0,[2,"drscheme:language:simple-settings-printing-style"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:language:simple-settings-show-sharing",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3alanguage~3asimple-settings-show-sharing))",[0,[2,"drscheme:language:simple-settings-show-sharing"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:language:simple-settings?",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3alanguage~3asimple-settings~3f))",[0,[2,"drscheme:language:simple-settings?"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:language:text/pos",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3alanguage~3atext/pos))",[0,[2,"drscheme:language:text/pos"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:language:text/pos-end",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3alanguage~3atext/pos-end))",[0,[2,"drscheme:language:text/pos-end"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:language:text/pos-start",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3alanguage~3atext/pos-start))",[0,[2,"drscheme:language:text/pos-start"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:language:text/pos-text",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3alanguage~3atext/pos-text))",[0,[2,"drscheme:language:text/pos-text"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:language:text/pos?",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3alanguage~3atext/pos~3f))",[0,[2,"drscheme:language:text/pos?"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:modes:add-mode",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3amodes~3aadd-mode))",[0,[2,"drscheme:modes:add-mode"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:modes:get-modes",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3amodes~3aget-modes))",[0,[2,"drscheme:modes:get-modes"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:modes:mode-matches-language",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3amodes~3amode-matches-language))",[0,[2,"drscheme:modes:mode-matches-language"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:modes:mode-name",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3amodes~3amode-name))",[0,[2,"drscheme:modes:mode-name"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:modes:mode-repl-submit",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3amodes~3amode-repl-submit))",[0,[2,"drscheme:modes:mode-repl-submit"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:modes:mode-surrogate",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3amodes~3amode-surrogate))",[0,[2,"drscheme:modes:mode-surrogate"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:modes:mode?",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3amodes~3amode~3f))",[0,[2,"drscheme:modes:mode?"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:module-language-tools:add-online-expansion-handler",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3amodule-language-tools~3aadd-online-expansion-handler))",[0,[2,"drscheme:module-language-tools:add-online-expansion-handler"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:module-language-tools:add-opt-out-toolbar-button",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3amodule-language-tools~3aadd-opt-out-toolbar-button))",[0,[2,"drscheme:module-language-tools:add-opt-out-toolbar-button"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:module-language-tools:definitions-text-mixin",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3amodule-language-tools~3adefinitions-text-mixin))",[0,"drscheme:module-language-tools:definitions-text-mixin"],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:module-language-tools:definitions-text<%>",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3amodule-language-tools~3adefinitions-text~3c~25~3e))",[0,"drscheme:module-language-tools:definitions-text<%>"],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:module-language-tools:frame-mixin",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3amodule-language-tools~3aframe-mixin))",[0,"drscheme:module-language-tools:frame-mixin"],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:module-language-tools:frame<%>",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3amodule-language-tools~3aframe~3c~25~3e))",[0,"drscheme:module-language-tools:frame<%>"],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:module-language-tools:tab-mixin",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3amodule-language-tools~3atab-mixin))",[0,"drscheme:module-language-tools:tab-mixin"],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:module-language-tools:tab<%>",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3amodule-language-tools~3atab~3c~25~3e))",[0,"drscheme:module-language-tools:tab<%>"],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:module-language:add-module-language",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3amodule-language~3aadd-module-language))",[0,[2,"drscheme:module-language:add-module-language"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:module-language:module-language-put-file-mixin",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3amodule-language~3amodule-language-put-file-mixin))",[0,[2,"drscheme:module-language:module-language-put-file-mixin"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:module-language:module-language<%>",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3amodule-language~3amodule-language~3c~25~3e))",[0,"drscheme:module-language:module-language<%>"],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:opt-out-toolbar-buttons",">tools/drracket_module-language-tools.html#(idx._(gentag._34._(lib._scribblings/tools/tools..scrbl)))",[7,"'drscheme:opt-out-toolbar-buttons"],false],
["drscheme:rep:after-expression",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3arep~3aafter-expression))",[0,[2,"drscheme:rep:after-expression"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:rep:context<%>",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3arep~3acontext~3c~25~3e))",[0,"drscheme:rep:context<%>"],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:rep:current-rep",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3arep~3acurrent-rep))",[0,[2,"drscheme:rep:current-rep"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:rep:current-value-port",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3arep~3acurrent-value-port))",[0,[2,"drscheme:rep:current-value-port"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:rep:drs-bindings-keymap-mixin",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3arep~3adrs-bindings-keymap-mixin))",[0,"drscheme:rep:drs-bindings-keymap-mixin"],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:rep:get-dark-green-delta",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3arep~3aget-dark-green-delta))",[0,[2,"drscheme:rep:get-dark-green-delta"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:rep:get-drs-bindings-keymap",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3arep~3aget-drs-bindings-keymap))",[0,[2,"drscheme:rep:get-drs-bindings-keymap"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:rep:get-welcome-delta",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3arep~3aget-welcome-delta))",[0,[2,"drscheme:rep:get-welcome-delta"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:rep:text%",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3arep~3atext~25))",[0,"drscheme:rep:text%"],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:rep:text<%>",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3arep~3atext~3c~25~3e))",[0,"drscheme:rep:text<%>"],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:toolbar-buttons",">tools/drracket_module-language-tools.html#(idx._(gentag._33._(lib._scribblings/tools/tools..scrbl)))",[7,"'drscheme:toolbar-buttons"],false],
["drscheme:tracing:frame-mixin",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3atracing~3aframe-mixin))",[0,"drscheme:tracing:frame-mixin"],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:tracing:tab-mixin",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3atracing~3atab-mixin))",[0,"drscheme:tracing:tab-mixin"],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:unit:add-search-help-desk-menu-item",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3aunit~3aadd-search-help-desk-menu-item))",[0,[2,"drscheme:unit:add-search-help-desk-menu-item"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:unit:add-to-program-editor-mixin",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3aunit~3aadd-to-program-editor-mixin))",[0,[2,"drscheme:unit:add-to-program-editor-mixin"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:unit:definitions-canvas%",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3aunit~3adefinitions-canvas~25))",[0,"drscheme:unit:definitions-canvas%"],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:unit:definitions-text<%>",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3aunit~3adefinitions-text~3c~25~3e))",[0,"drscheme:unit:definitions-text<%>"],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:unit:frame%",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3aunit~3aframe~25))",[0,"drscheme:unit:frame%"],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:unit:frame<%>",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3aunit~3aframe~3c~25~3e))",[0,"drscheme:unit:frame<%>"],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:unit:get-definitions-text%",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3aunit~3aget-definitions-text~25))",[0,"drscheme:unit:get-definitions-text%"],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:unit:get-program-editor-mixin",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3aunit~3aget-program-editor-mixin))",[0,[2,"drscheme:unit:get-program-editor-mixin"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:unit:interactions-canvas%",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3aunit~3ainteractions-canvas~25))",[0,"drscheme:unit:interactions-canvas%"],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:unit:open-drscheme-window",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3aunit~3aopen-drscheme-window))",[0,[2,"drscheme:unit:open-drscheme-window"]],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:unit:tab%",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3aunit~3atab~25))",[0,"drscheme:unit:tab%"],["drracket/tool-lib","drscheme/tool-lib"]],
["drscheme:unit:tab<%>",">tools/Backwards_compatibility.html#(def._((lib._drracket/tool-lib..rkt)._drscheme~3aunit~3atab~3c~25~3e))",[0,"drscheme:unit:tab<%>"],["drracket/tool-lib","drscheme/tool-lib"]],
["dseq",">unstable/Automata__Compiling_State_Machines.html#(form._((lib._unstable/automata/re..rkt)._dseq))",[0,[1,"dseq"]],["unstable/automata/re"]],
["dsn-connect",">db/connect.html#(def._((lib._db/base..rkt)._dsn-connect))",[0,[2,"dsn-connect"]],["db","db/base"]],
["dt",">html/index.html#(def._((lib._html/main..rkt)._dt))",[0,[2,"dt"]],["html"]],
["dt?",">html/index.html#(def._((lib._html/main..rkt)._dt~3f))",[0,[2,"dt?"]],["html"]],
["dump-memory-stats",">reference/garbagecollection.html#(def._((quote._~23~25kernel)._dump-memory-stats))",[0,[2,"dump-memory-stats"]],["racket/base","racket"]],
["dup-input-port",">reference/port-lib.html#(def._((lib._racket/port..rkt)._dup-input-port))",[0,[2,"dup-input-port"]],["racket/port","racket"]],
["dup-output-port",">reference/port-lib.html#(def._((lib._racket/port..rkt)._dup-output-port))",[0,[2,"dup-output-port"]],["racket/port","racket"]],
["dye pack",">guide/stx-certs.html#(tech._dye._pack)","<span style=\"font-style: italic\">dye pack</span>",false],
["dye packs",">reference/stxcerts.html#(tech._dye._pack)","<span style=\"font-style: italic\">dye packs</span>",false],
["dynamic",">web-server/templates.html#(part._.Dynamic)","Dynamic",false],
["dynamic binding: parameterize",">guide/parameterize.html",["Dynamic Binding: ",[0,[1,"parameterize"]]],false],
["dynamic extension",">raco/cc.html#(tech._dynamic._extension)","<span style=\"font-style: italic\">dynamic extension</span>",false],
["dynamic extension",">reference/eval.html#(tech._dynamic._extension)","<span style=\"font-style: italic\">dynamic extension</span>",false],
["dynamic extent",">reference/eval-model.html#(tech._dynamic._extent)","<span style=\"font-style: italic\">dynamic extent</span>",false],
["dynamic loading",">gui/Dynamic_Loading.html","Dynamic Loading",false],
["dynamic module access",">reference/Module_Names_and_Loading.html#(part._dynreq)","Dynamic Module Access",false],
["dynamic syntactic shorthand",">web-server/formlets.html#(part._.Dynamic_.Syntactic_.Shorthand)","Dynamic Syntactic Shorthand",false],
["dynamic-place",">reference/places.html#(def._((lib._racket/place..rkt)._dynamic-place))",[0,[2,"dynamic-place"]],["racket/place","racket"]],
["dynamic-place*",">reference/places.html#(def._((lib._racket/place..rkt)._dynamic-place*))",[0,[2,"dynamic-place*"]],["racket/place","racket"]],
["dynamic-require",">reference/Module_Names_and_Loading.html#(def._((quote._~23~25kernel)._dynamic-require))",[0,[2,"dynamic-require"]],["racket/base","racket"]],
["dynamic-require-for-syntax",">reference/Module_Names_and_Loading.html#(def._((quote._~23~25kernel)._dynamic-require-for-syntax))",[0,[2,"dynamic-require-for-syntax"]],["racket/base","racket"]],
["dynamic-send",">reference/ivaraccess.html#(def._((lib._racket/private/class-internal..rkt)._dynamic-send))",[0,[2,"dynamic-send"]],["racket/class","racket"]],
["dynamic-wind",">reference/cont.html#(def._((quote._~23~25kernel)._dynamic-wind))",[0,[2,"dynamic-wind"]],["racket/base","racket"]],
["dynamic-wind",">r5rs-std/r5rs-Z-H-9.html#%_idx_598",[0,[2,"dynamic-wind"]],["r5rs"]],
["dynamic-wind",">r6rs-std/r6rs-Z-H-14.html#node_idx_764",[0,[2,"dynamic-wind"]],["rnrs/base-6"]],
["dynamically loaded libraries",">foreign/Loading_Foreign_Libraries.html#(idx._(gentag._2._(lib._scribblings/foreign/foreign..scrbl)))","dynamically loaded libraries",false],
["dynext/compile",">dynext/Compilation.html",[9,[0,"dynext/compile"]],"module"],
["dynext/compile-sig",">dynext/Compilation.html#(mod-path._dynext/compile-sig)",[9,[0,"dynext/compile-sig"]],"module"],
["dynext/compile-unit",">dynext/Compilation.html#(mod-path._dynext/compile-unit)",[9,[0,"dynext/compile-unit"]],"module"],
["dynext/file",">dynext/Filenames.html",[9,[0,"dynext/file"]],"module"],
["dynext/file-sig",">dynext/Filenames.html#(mod-path._dynext/file-sig)",[9,[0,"dynext/file-sig"]],"module"],
["dynext/file-unit",">dynext/Filenames.html#(mod-path._dynext/file-unit)",[9,[0,"dynext/file-unit"]],"module"],
["dynext/link",">dynext/Linking.html",[9,[0,"dynext/link"]],"module"],
["dynext/link-sig",">dynext/Linking.html#(mod-path._dynext/link-sig)",[9,[0,"dynext/link-sig"]],"module"],
["dynext/link-unit",">dynext/Linking.html#(mod-path._dynext/link-unit)",[9,[0,"dynext/link-unit"]],"module"],
["dynext: running a c compiler/linker",">dynext/index.html","Dynext: Running a C Compiler/Linker",false],
["dynext:compile@",">dynext/Compilation.html#(def._((lib._dynext/compile-unit..rkt)._dynext~3acompile~40))",[0,[2,"dynext:compile@"]],["dynext/compile-unit"]],
["dynext:compile^",">dynext/Compilation.html#(form._((lib._dynext/compile-sig..rkt)._dynext~3acompile~5e))",[0,[1,"dynext:compile^"]],["dynext/compile-sig"]],
["dynext:file@",">dynext/Filenames.html#(def._((lib._dynext/file-unit..rkt)._dynext~3afile~40))",[0,[2,"dynext:file@"]],["dynext/file-unit"]],
["dynext:file^",">dynext/Filenames.html#(form._((lib._dynext/file-sig..rkt)._dynext~3afile~5e))",[0,[1,"dynext:file^"]],["dynext/file-sig"]],
["dynext:link@",">dynext/Linking.html#(def._((lib._dynext/link-unit..rkt)._dynext~3alink~40))",[0,[2,"dynext:link@"]],["dynext/link-unit"]],
["dynext:link^",">dynext/Linking.html#(form._((lib._dynext/link-sig..rkt)._dynext~3alink~5e))",[0,[1,"dynext:link^"]],["dynext/link-sig"]],
["e",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._e))",[0,[2,"e"]],["lang/htdp-advanced"]],
["e",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._e))",[0,[2,"e"]],["lang/htdp-beginner"]],
["e",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._e))",[0,[2,"e"]],["lang/htdp-beginner-abbr"]],
["e",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._e))",[0,[2,"e"]],["lang/htdp-intermediate"]],
["e",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._e))",[0,[2,"e"]],["lang/htdp-intermediate-lambda"]],
["e",">mzlib/mzlib_math.html#(def._((lib._mzlib/math..rkt)._e))",[0,[2,"e"]],["mzlib/math"]],
["eager",">srfi-std/srfi-45.html#eager",[0,[2,"eager"]],["srfi/45"]],
["edge",">profile/index.html#(def._((lib._profile/analyzer..rkt)._edge))",[0,[2,"edge"]],["profile/analyzer"]],
["edge-callee",">profile/index.html#(def._((lib._profile/analyzer..rkt)._edge-callee))",[0,[2,"edge-callee"]],["profile/analyzer"]],
["edge-callee-time",">profile/index.html#(def._((lib._profile/analyzer..rkt)._edge-callee-time))",[0,[2,"edge-callee-time"]],["profile/analyzer"]],
["edge-caller",">profile/index.html#(def._((lib._profile/analyzer..rkt)._edge-caller))",[0,[2,"edge-caller"]],["profile/analyzer"]],
["edge-caller-time",">profile/index.html#(def._((lib._profile/analyzer..rkt)._edge-caller-time))",[0,[2,"edge-caller-time"]],["profile/analyzer"]],
["edge-total",">profile/index.html#(def._((lib._profile/analyzer..rkt)._edge-total))",[0,[2,"edge-total"]],["profile/analyzer"]],
["edge?",">profile/index.html#(def._((lib._profile/analyzer..rkt)._edge~3f))",[0,[2,"edge?"]],["profile/analyzer"]],
["edit",">drracket/Menus.html#(part._.Edit)","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Edit</span>",false],
["edit sequence",">gui/editor-overview.html#(tech._edit._sequence)","<span style=\"font-style: italic\">edit sequence</span>",false],
["edit-menu:after-preferences",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aafter-preferences))",[[0,[2,"edit-menu:after-preferences"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:between-clear-and-select-all",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3abetween-clear-and-select-all))",[[0,[2,"edit-menu:between-clear-and-select-all"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:between-copy-and-paste",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3abetween-copy-and-paste))",[[0,[2,"edit-menu:between-copy-and-paste"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:between-cut-and-copy",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3abetween-cut-and-copy))",[[0,[2,"edit-menu:between-cut-and-copy"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:between-find-and-preferences",">tools/drracket_frame.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aframe~3abasics-mixin)._edit-menu~3abetween-find-and-preferences))",[[0,[2,"edit-menu:between-find-and-preferences"]],[14,[" (method of ",[0,[2,"drracket:frame:basics-mixin"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["edit-menu:between-find-and-preferences",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3abetween-find-and-preferences))",[[0,[2,"edit-menu:between-find-and-preferences"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:between-paste-and-clear",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3abetween-paste-and-clear))",[[0,[2,"edit-menu:between-paste-and-clear"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:between-redo-and-cut",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3abetween-redo-and-cut))",[[0,[2,"edit-menu:between-redo-and-cut"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:between-select-all-and-find",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aframe~25)._edit-menu~3abetween-select-all-and-find))",[[0,[2,"edit-menu:between-select-all-and-find"]],[14,[" (method of ",[0,[2,"drracket:unit:frame%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["edit-menu:between-select-all-and-find",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3aeditor-mixin)._edit-menu~3abetween-select-all-and-find))",[[0,[2,"edit-menu:between-select-all-and-find"]],[14,[" (method of ",[0,[2,"frame:editor-mixin"]],")"]]],["framework"]],
["edit-menu:between-select-all-and-find",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3abetween-select-all-and-find))",[[0,[2,"edit-menu:between-select-all-and-find"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:clear-callback",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aclear-callback))",[[0,[2,"edit-menu:clear-callback"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:clear-help-string",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aclear-help-string))",[[0,[2,"edit-menu:clear-help-string"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:clear-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aclear-on-demand))",[[0,[2,"edit-menu:clear-on-demand"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:clear-string",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aclear-string))",[[0,[2,"edit-menu:clear-string"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:copy-callback",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3acopy-callback))",[[0,[2,"edit-menu:copy-callback"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:copy-help-string",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3acopy-help-string))",[[0,[2,"edit-menu:copy-help-string"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:copy-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3acopy-on-demand))",[[0,[2,"edit-menu:copy-on-demand"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:copy-string",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3acopy-string))",[[0,[2,"edit-menu:copy-string"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:create-clear?",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3acreate-clear~3f))",[[0,[2,"edit-menu:create-clear?"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:create-copy?",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3acreate-copy~3f))",[[0,[2,"edit-menu:create-copy?"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:create-cut?",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3acreate-cut~3f))",[[0,[2,"edit-menu:create-cut?"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:create-find-again-backwards?",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3asearchable-mixin)._edit-menu~3acreate-find-again-backwards~3f))",[[0,[2,"edit-menu:create-find-again-backwards?"]],[14,[" (method of ",[0,[2,"frame:searchable-mixin"]],")"]]],["framework"]],
["edit-menu:create-find-again?",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3asearchable-mixin)._edit-menu~3acreate-find-again~3f))",[[0,[2,"edit-menu:create-find-again?"]],[14,[" (method of ",[0,[2,"frame:searchable-mixin"]],")"]]],["framework"]],
["edit-menu:create-find-case-sensitive?",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3asearchable-mixin)._edit-menu~3acreate-find-case-sensitive~3f))",[[0,[2,"edit-menu:create-find-case-sensitive?"]],[14,[" (method of ",[0,[2,"frame:searchable-mixin"]],")"]]],["framework"]],
["edit-menu:create-find-case-sensitive?",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3acreate-find-case-sensitive~3f))",[[0,[2,"edit-menu:create-find-case-sensitive?"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:create-find-next?",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3acreate-find-next~3f))",[[0,[2,"edit-menu:create-find-next?"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:create-find-previous?",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3acreate-find-previous~3f))",[[0,[2,"edit-menu:create-find-previous?"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:create-find?",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3asearchable-mixin)._edit-menu~3acreate-find~3f))",[[0,[2,"edit-menu:create-find?"]],[14,[" (method of ",[0,[2,"frame:searchable-mixin"]],")"]]],["framework"]],
["edit-menu:create-find?",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3acreate-find~3f))",[[0,[2,"edit-menu:create-find?"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:create-paste?",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3acreate-paste~3f))",[[0,[2,"edit-menu:create-paste?"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:create-preferences?",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3acreate-preferences~3f))",[[0,[2,"edit-menu:create-preferences?"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:create-redo?",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3acreate-redo~3f))",[[0,[2,"edit-menu:create-redo?"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:create-replace-all?",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3asearchable-mixin)._edit-menu~3acreate-replace-all~3f))",[[0,[2,"edit-menu:create-replace-all?"]],[14,[" (method of ",[0,[2,"frame:searchable-mixin"]],")"]]],["framework"]],
["edit-menu:create-replace-all?",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3acreate-replace-all~3f))",[[0,[2,"edit-menu:create-replace-all?"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:create-replace?",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3acreate-replace~3f))",[[0,[2,"edit-menu:create-replace?"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:create-select-all?",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3acreate-select-all~3f))",[[0,[2,"edit-menu:create-select-all?"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:create-show/hide-replace?",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3acreate-show/hide-replace~3f))",[[0,[2,"edit-menu:create-show/hide-replace?"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:create-undo?",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3acreate-undo~3f))",[[0,[2,"edit-menu:create-undo?"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:cut-callback",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3acut-callback))",[[0,[2,"edit-menu:cut-callback"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:cut-help-string",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3acut-help-string))",[[0,[2,"edit-menu:cut-help-string"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:cut-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3acut-on-demand))",[[0,[2,"edit-menu:cut-on-demand"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:cut-string",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3acut-string))",[[0,[2,"edit-menu:cut-string"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:find-again-backwards-callback",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3asearchable-mixin)._edit-menu~3afind-again-backwards-callback))",[[0,[2,"edit-menu:find-again-backwards-callback"]],[14,[" (method of ",[0,[2,"frame:searchable-mixin"]],")"]]],["framework"]],
["edit-menu:find-again-callback",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3asearchable-mixin)._edit-menu~3afind-again-callback))",[[0,[2,"edit-menu:find-again-callback"]],[14,[" (method of ",[0,[2,"frame:searchable-mixin"]],")"]]],["framework"]],
["edit-menu:find-callback",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3asearchable-mixin)._edit-menu~3afind-callback))",[[0,[2,"edit-menu:find-callback"]],[14,[" (method of ",[0,[2,"frame:searchable-mixin"]],")"]]],["framework"]],
["edit-menu:find-callback",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3afind-callback))",[[0,[2,"edit-menu:find-callback"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:find-case-sensitive-callback",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3asearchable-mixin)._edit-menu~3afind-case-sensitive-callback))",[[0,[2,"edit-menu:find-case-sensitive-callback"]],[14,[" (method of ",[0,[2,"frame:searchable-mixin"]],")"]]],["framework"]],
["edit-menu:find-case-sensitive-callback",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3afind-case-sensitive-callback))",[[0,[2,"edit-menu:find-case-sensitive-callback"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:find-case-sensitive-help-string",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3afind-case-sensitive-help-string))",[[0,[2,"edit-menu:find-case-sensitive-help-string"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:find-case-sensitive-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3asearchable-mixin)._edit-menu~3afind-case-sensitive-on-demand))",[[0,[2,"edit-menu:find-case-sensitive-on-demand"]],[14,[" (method of ",[0,[2,"frame:searchable-mixin"]],")"]]],["framework"]],
["edit-menu:find-case-sensitive-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3afind-case-sensitive-on-demand))",[[0,[2,"edit-menu:find-case-sensitive-on-demand"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:find-case-sensitive-string",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3afind-case-sensitive-string))",[[0,[2,"edit-menu:find-case-sensitive-string"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:find-help-string",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3afind-help-string))",[[0,[2,"edit-menu:find-help-string"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:find-next-callback",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3afind-next-callback))",[[0,[2,"edit-menu:find-next-callback"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:find-next-help-string",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3afind-next-help-string))",[[0,[2,"edit-menu:find-next-help-string"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:find-next-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3afind-next-on-demand))",[[0,[2,"edit-menu:find-next-on-demand"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:find-next-string",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3afind-next-string))",[[0,[2,"edit-menu:find-next-string"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:find-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3afind-on-demand))",[[0,[2,"edit-menu:find-on-demand"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:find-previous-callback",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3afind-previous-callback))",[[0,[2,"edit-menu:find-previous-callback"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:find-previous-help-string",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3afind-previous-help-string))",[[0,[2,"edit-menu:find-previous-help-string"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:find-previous-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3afind-previous-on-demand))",[[0,[2,"edit-menu:find-previous-on-demand"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:find-previous-string",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3afind-previous-string))",[[0,[2,"edit-menu:find-previous-string"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:find-string",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3afind-string))",[[0,[2,"edit-menu:find-string"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:get-clear-item",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aget-clear-item))",[[0,[2,"edit-menu:get-clear-item"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:get-copy-item",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aget-copy-item))",[[0,[2,"edit-menu:get-copy-item"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:get-cut-item",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aget-cut-item))",[[0,[2,"edit-menu:get-cut-item"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:get-find-case-sensitive-item",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aget-find-case-sensitive-item))",[[0,[2,"edit-menu:get-find-case-sensitive-item"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:get-find-item",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aget-find-item))",[[0,[2,"edit-menu:get-find-item"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:get-find-next-item",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aget-find-next-item))",[[0,[2,"edit-menu:get-find-next-item"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:get-find-previous-item",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aget-find-previous-item))",[[0,[2,"edit-menu:get-find-previous-item"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:get-paste-item",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aget-paste-item))",[[0,[2,"edit-menu:get-paste-item"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:get-preferences-item",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aget-preferences-item))",[[0,[2,"edit-menu:get-preferences-item"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:get-redo-item",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aget-redo-item))",[[0,[2,"edit-menu:get-redo-item"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:get-replace-all-item",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aget-replace-all-item))",[[0,[2,"edit-menu:get-replace-all-item"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:get-replace-item",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aget-replace-item))",[[0,[2,"edit-menu:get-replace-item"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:get-select-all-item",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aget-select-all-item))",[[0,[2,"edit-menu:get-select-all-item"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:get-show/hide-replace-item",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aget-show/hide-replace-item))",[[0,[2,"edit-menu:get-show/hide-replace-item"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:get-undo-item",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aget-undo-item))",[[0,[2,"edit-menu:get-undo-item"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:paste-callback",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3apaste-callback))",[[0,[2,"edit-menu:paste-callback"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:paste-help-string",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3apaste-help-string))",[[0,[2,"edit-menu:paste-help-string"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:paste-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3apaste-on-demand))",[[0,[2,"edit-menu:paste-on-demand"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:paste-string",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3apaste-string))",[[0,[2,"edit-menu:paste-string"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:preferences-callback",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3apreferences-callback))",[[0,[2,"edit-menu:preferences-callback"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:preferences-help-string",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3apreferences-help-string))",[[0,[2,"edit-menu:preferences-help-string"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:preferences-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3apreferences-on-demand))",[[0,[2,"edit-menu:preferences-on-demand"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:preferences-string",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3apreferences-string))",[[0,[2,"edit-menu:preferences-string"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:redo-callback",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aredo-callback))",[[0,[2,"edit-menu:redo-callback"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:redo-help-string",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aredo-help-string))",[[0,[2,"edit-menu:redo-help-string"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:redo-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aredo-on-demand))",[[0,[2,"edit-menu:redo-on-demand"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:redo-string",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aredo-string))",[[0,[2,"edit-menu:redo-string"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:replace-all-callback",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3asearchable-mixin)._edit-menu~3areplace-all-callback))",[[0,[2,"edit-menu:replace-all-callback"]],[14,[" (method of ",[0,[2,"frame:searchable-mixin"]],")"]]],["framework"]],
["edit-menu:replace-all-callback",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3areplace-all-callback))",[[0,[2,"edit-menu:replace-all-callback"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:replace-all-help-string",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3areplace-all-help-string))",[[0,[2,"edit-menu:replace-all-help-string"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:replace-all-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3asearchable-mixin)._edit-menu~3areplace-all-on-demand))",[[0,[2,"edit-menu:replace-all-on-demand"]],[14,[" (method of ",[0,[2,"frame:searchable-mixin"]],")"]]],["framework"]],
["edit-menu:replace-all-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3areplace-all-on-demand))",[[0,[2,"edit-menu:replace-all-on-demand"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:replace-all-string",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3areplace-all-string))",[[0,[2,"edit-menu:replace-all-string"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:replace-callback",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3areplace-callback))",[[0,[2,"edit-menu:replace-callback"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:replace-help-string",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3areplace-help-string))",[[0,[2,"edit-menu:replace-help-string"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:replace-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3areplace-on-demand))",[[0,[2,"edit-menu:replace-on-demand"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:replace-string",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3areplace-string))",[[0,[2,"edit-menu:replace-string"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:select-all-callback",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aselect-all-callback))",[[0,[2,"edit-menu:select-all-callback"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:select-all-help-string",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aselect-all-help-string))",[[0,[2,"edit-menu:select-all-help-string"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:select-all-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aselect-all-on-demand))",[[0,[2,"edit-menu:select-all-on-demand"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:select-all-string",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aselect-all-string))",[[0,[2,"edit-menu:select-all-string"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:show/hide-replace-callback",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3ashow/hide-replace-callback))",[[0,[2,"edit-menu:show/hide-replace-callback"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:show/hide-replace-help-string",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3ashow/hide-replace-help-string))",[[0,[2,"edit-menu:show/hide-replace-help-string"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:show/hide-replace-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3ashow/hide-replace-on-demand))",[[0,[2,"edit-menu:show/hide-replace-on-demand"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:show/hide-replace-string",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3ashow/hide-replace-string))",[[0,[2,"edit-menu:show/hide-replace-string"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:undo-callback",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aundo-callback))",[[0,[2,"edit-menu:undo-callback"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:undo-help-string",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aundo-help-string))",[[0,[2,"edit-menu:undo-help-string"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:undo-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aundo-on-demand))",[[0,[2,"edit-menu:undo-on-demand"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["edit-menu:undo-string",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aundo-string))",[[0,[2,"edit-menu:undo-string"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["editing",">drracket/prefs-explanation.html#(part._.Editing)","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Editing</span>",false],
["editing operations",">drracket/Keyboard_Shortcuts.html#(part._.Editing_.Operations)","Editing Operations",false],
["editing with parentheses",">drracket/editor.html","Editing with Parentheses",false],
["editing-this-file?",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3abasic~3c~25~3e)._editing-this-file~3f))",[[0,[2,"editing-this-file?"]],[14,[" (method of ",[0,[2,"frame:basic<%>"]],")"]]],["framework"]],
["editing-this-file?",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3aeditor-mixin)._editing-this-file~3f))",[[0,[2,"editing-this-file?"]],[14,[" (method of ",[0,[2,"frame:editor-mixin"]],")"]]],["framework"]],
["editor",">framework/Editor.html","Editor",false],
["editor",">scriblib/autobib.html#(def._((lib._scriblib/autobib..rkt)._editor))",[0,[2,"editor"]],["scriblib/autobib"]],
["editor",">gui/editor-overview.html#(tech._editor)","<span style=\"font-style: italic\">editor</span>",false],
["editor administrator",">gui/editor-overview.html#(tech._editor._administrator)","<span style=\"font-style: italic\">editor\nadministrator</span>",false],
["editor canvas",">gui/windowing-overview.html#(tech._editor._canva)","<span style=\"font-style: italic\">editor canvas</span>",false],
["editor classes",">gui/Editor_Classes.html","Editor Classes",false],
["editor data",">gui/editor-overview.html#(part._editordata)","Editor Data",false],
["editor data",">gui/editor-overview.html#(tech._editor._data)","<span style=\"font-style: italic\">editor data</span>",false],
["editor data class",">gui/editor-overview.html#(tech._editor._data._clas)","<span style=\"font-style: italic\">editor data class</span>",false],
["editor data class list",">gui/editor-overview.html#(tech._editor._data._class._list)","<span style=\"font-style: italic\">editor data class list</span>",false],
["editor functions",">gui/Editor_Functions.html","Editor Functions",false],
["editor modes",">tools/Editor_Modes.html","Editor Modes",false],
["editor snip",">framework/editor-snip.html","Editor Snip",false],
["editor structure and terminology",">gui/editor-overview.html#(part._tb~3amiaoverview)","Editor Structure and Terminology",false],
["editor toolbox",">gui/index.html#(tech._editor._toolbox)","<span style=\"font-style: italic\">editor toolbox</span>",false],
["editor%",">gui/WXME_Decoding.html#(def._((lib._wxme/editor..rkt)._editor~25))",[0,[2,"editor%"]],["wxme/editor"]],
["editor->page",">browser/index.html#(def._((lib._browser/browser..rkt)._editor-~3epage))",[0,[2,"editor->page"]],["browser/browser","browser"]],
["editor-admin%",">gui/editor-admin_.html",[0,[2,"editor-admin%"]],["racket/gui/base","racket/gui"]],
["editor-canvas%",">gui/editor-canvas_.html",[0,[2,"editor-canvas%"]],["racket/gui/base","racket/gui"]],
["editor-data%",">gui/editor-data_.html",[0,[2,"editor-data%"]],["racket/gui/base","racket/gui"]],
["editor-data-class%",">gui/editor-data-class_.html",[0,[2,"editor-data-class%"]],["racket/gui/base","racket/gui"]],
["editor-data-class-list<%>",">gui/editor-data-class-list___.html",[0,[2,"editor-data-class-list<%>"]],["racket/gui/base","racket/gui"]],
["editor-location-to-dc-location",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._editor-location-to-dc-location))",[[0,[2,"editor-location-to-dc-location"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["editor-position-changed",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3atext-info~3c~25~3e)._editor-position-changed))",[[0,[2,"editor-position-changed"]],[14,[" (method of ",[0,[2,"frame:text-info<%>"]],")"]]],["framework"]],
["editor-set-x-selection-mode",">gui/Editor_Functions.html#(def._((lib._mred/main..rkt)._editor-set-x-selection-mode))",[0,[2,"editor-set-x-selection-mode"]],["racket/gui/base","racket/gui"]],
["editor-snip%",">gui/editor-snip_.html",[0,[2,"editor-snip%"]],["racket/gui/base","racket/gui"]],
["editor-snip-editor-admin<%>",">gui/editor-snip-editor-admin___.html",[0,[2,"editor-snip-editor-admin<%>"]],["racket/gui/base","racket/gui"]],
["editor-snip:decorated%",">framework/editor-snip.html#(def._((lib._framework/main..rkt)._editor-snip~3adecorated~25))",[0,[2,"editor-snip:decorated%"]],["framework"]],
["editor-snip:decorated-mixin",">framework/editor-snip.html#(def._((lib._framework/main..rkt)._editor-snip~3adecorated-mixin))",[0,[2,"editor-snip:decorated-mixin"]],["framework"]],
["editor-snip:decorated-snipclass%",">framework/editor-snip.html#(def._((lib._framework/main..rkt)._editor-snip~3adecorated-snipclass~25))",[0,[2,"editor-snip:decorated-snipclass%"]],["framework"]],
["editor-snip:decorated<%>",">framework/editor-snip.html#(def._((lib._framework/main..rkt)._editor-snip~3adecorated~3c~25~3e))",[0,[2,"editor-snip:decorated<%>"]],["framework"]],
["editor-stream-in%",">gui/editor-stream-in_.html",[0,[2,"editor-stream-in%"]],["racket/gui/base","racket/gui"]],
["editor-stream-in-base%",">gui/editor-stream-in-base_.html",[0,[2,"editor-stream-in-base%"]],["racket/gui/base","racket/gui"]],
["editor-stream-in-bytes-base%",">gui/editor-stream-in-bytes-base_.html",[0,[2,"editor-stream-in-bytes-base%"]],["racket/gui/base","racket/gui"]],
["editor-stream-out%",">gui/editor-stream-out_.html",[0,[2,"editor-stream-out%"]],["racket/gui/base","racket/gui"]],
["editor-stream-out-base%",">gui/editor-stream-out-base_.html",[0,[2,"editor-stream-out-base%"]],["racket/gui/base","racket/gui"]],
["editor-stream-out-bytes-base%",">gui/editor-stream-out-bytes-base_.html",[0,[2,"editor-stream-out-bytes-base%"]],["racket/gui/base","racket/gui"]],
["editor-wordbreak-map%",">gui/editor-wordbreak-map_.html",[0,[2,"editor-wordbreak-map%"]],["racket/gui/base","racket/gui"]],
["editor:add-after-user-keymap",">framework/Editor.html#(def._((lib._framework/main..rkt)._editor~3aadd-after-user-keymap))",[0,[2,"editor:add-after-user-keymap"]],["framework"]],
["editor:autowrap-mixin",">framework/Editor.html#(def._((lib._framework/main..rkt)._editor~3aautowrap-mixin))",[0,[2,"editor:autowrap-mixin"]],["framework"]],
["editor:autowrap<%>",">framework/Editor.html#(def._((lib._framework/main..rkt)._editor~3aautowrap~3c~25~3e))",[0,[2,"editor:autowrap<%>"]],["framework"]],
["editor:backup-autosave-mixin",">framework/Editor.html#(def._((lib._framework/main..rkt)._editor~3abackup-autosave-mixin))",[0,[2,"editor:backup-autosave-mixin"]],["framework"]],
["editor:backup-autosave<%>",">framework/Editor.html#(def._((lib._framework/main..rkt)._editor~3abackup-autosave~3c~25~3e))",[0,[2,"editor:backup-autosave<%>"]],["framework"]],
["editor:basic-mixin",">framework/Editor.html#(def._((lib._framework/main..rkt)._editor~3abasic-mixin))",[0,[2,"editor:basic-mixin"]],["framework"]],
["editor:basic<%>",">framework/Editor.html#(def._((lib._framework/main..rkt)._editor~3abasic~3c~25~3e))",[0,[2,"editor:basic<%>"]],["framework"]],
["editor:file-mixin",">framework/Editor.html#(def._((lib._framework/main..rkt)._editor~3afile-mixin))",[0,[2,"editor:file-mixin"]],["framework"]],
["editor:file<%>",">framework/Editor.html#(def._((lib._framework/main..rkt)._editor~3afile~3c~25~3e))",[0,[2,"editor:file<%>"]],["framework"]],
["editor:get-default-color-style-name",">framework/Editor.html#(def._((lib._framework/main..rkt)._editor~3aget-default-color-style-name))",[0,[2,"editor:get-default-color-style-name"]],["framework"]],
["editor:get-standard-style-list",">framework/Editor.html#(def._((lib._framework/main..rkt)._editor~3aget-standard-style-list))",[0,[2,"editor:get-standard-style-list"]],["framework"]],
["editor:info-mixin",">framework/Editor.html#(def._((lib._framework/main..rkt)._editor~3ainfo-mixin))",[0,[2,"editor:info-mixin"]],["framework"]],
["editor:info<%>",">framework/Editor.html#(def._((lib._framework/main..rkt)._editor~3ainfo~3c~25~3e))",[0,[2,"editor:info<%>"]],["framework"]],
["editor:keymap-mixin",">framework/Editor.html#(def._((lib._framework/main..rkt)._editor~3akeymap-mixin))",[0,[2,"editor:keymap-mixin"]],["framework"]],
["editor:keymap<%>",">framework/Editor.html#(def._((lib._framework/main..rkt)._editor~3akeymap~3c~25~3e))",[0,[2,"editor:keymap<%>"]],["framework"]],
["editor:set-default-font-color",">framework/Editor.html#(def._((lib._framework/main..rkt)._editor~3aset-default-font-color))",[0,[2,"editor:set-default-font-color"]],["framework"]],
["editor:set-standard-style-list-delta",">framework/Editor.html#(def._((lib._framework/main..rkt)._editor~3aset-standard-style-list-delta))",[0,[2,"editor:set-standard-style-list-delta"]],["framework"]],
["editor:set-standard-style-list-pref-callbacks",">framework/Editor.html#(def._((lib._framework/main..rkt)._editor~3aset-standard-style-list-pref-callbacks))",[0,[2,"editor:set-standard-style-list-pref-callbacks"]],["framework"]],
["editor:standard-style-list-mixin",">framework/Editor.html#(def._((lib._framework/main..rkt)._editor~3astandard-style-list-mixin))",[0,[2,"editor:standard-style-list-mixin"]],["framework"]],
["editor:standard-style-list<%>",">framework/Editor.html#(def._((lib._framework/main..rkt)._editor~3astandard-style-list~3c~25~3e))",[0,[2,"editor:standard-style-list<%>"]],["framework"]],
["editor<%>",">gui/editor___.html",[0,[2,"editor<%>"]],["racket/gui/base","racket/gui"]],
["editors",">gui/editor-overview.html","Editors",false],
["editors and threads",">gui/editor-overview.html#(part._editorthreads)","Editors and Threads",false],
["effects",">images/Effects.html","Effects",false],
["effects after: begin0",">guide/begin.html#(part._.Effects_.After__begin0)",["Effects After: ",[0,[1,"begin0"]]],false],
["effects before: begin",">guide/begin.html#(part._.Effects_.Before__begin)",["Effects Before: ",[0,[1,"begin"]]],false],
["effects if...: when and unless",">guide/begin.html#(part._when+unless)",["Effects If...: ",[0,[1,"when"]]," and ",[0,[1,"unless"]]],false],
["eigenschaft",">deinprogramm/Eigenschaften.html#(tech._eigenschaft)","<span style=\"font-style: italic\">Eigenschaft</span>",false],
["eigenschaften",">deinprogramm/Eigenschaften.html","Eigenschaften",false],
["eigenschaften von bildern",">deinprogramm/image.html#(part._properties)","Eigenschaften von Bildern",false],
["eighth",">reference/pairs.html#(def._((lib._racket/list..rkt)._eighth))",[0,[2,"eighth"]],["racket/list","racket"]],
["eighth",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._eighth))",[0,[2,"eighth"]],["lang/htdp-advanced"]],
["eighth",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._eighth))",[0,[2,"eighth"]],["lang/htdp-beginner"]],
["eighth",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._eighth))",[0,[2,"eighth"]],["lang/htdp-beginner-abbr"]],
["eighth",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._eighth))",[0,[2,"eighth"]],["lang/htdp-intermediate"]],
["eighth",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._eighth))",[0,[2,"eighth"]],["lang/htdp-intermediate-lambda"]],
["eighth",">lazy/index.html#(def._((lib._lazy/main..rkt)._eighth))",[0,[2,"eighth"]],["lazy"]],
["eighth",">mzlib/mzlib_list.html#(def._((lib._mzlib/list..rkt)._eighth))",[0,[2,"eighth"]],["mzlib/list"]],
["eighth",">srfi-std/srfi-1.html#eighth",[0,[2,"eighth"]],["srfi/1"]],
["einfache geometrische figuren",">deinprogramm/image.html#(part._creational)","Einfache geometrische Figuren",false],
["eingebaute signaturen",">deinprogramm/Signaturen.html#(part._.Eingebaute_.Signaturen)","Eingebaute Signaturen",false],
["elem",">scribble/base.html#(def._((lib._scribble/base..rkt)._elem))",[0,[2,"elem"]],["scribble/base"]],
["element",">scribble/core.html#(def._((lib._scribble/core..rkt)._element))",[0,[2,"element"]],["scribble/core"]],
["element",">xml/index.html#(def._((lib._xml/main..rkt)._element))",[0,[2,"element"]],["xml"]],
["element transformer",">scribble/scheme.html#(tech._element._transformer)","<span style=\"font-style: italic\">element\ntransformer</span>",false],
["element->string",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._element-~3estring))",[0,[2,"element->string"]],["scribble/struct"]],
["element-attributes",">xml/index.html#(def._((lib._xml/main..rkt)._element-attributes))",[0,[2,"element-attributes"]],["xml"]],
["element-content",">scribble/core.html#(def._((lib._scribble/core..rkt)._element-content))",[0,[2,"element-content"]],["scribble/core"]],
["element-content",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._element-content))",[0,[2,"element-content"]],["scribble/struct"]],
["element-content",">xml/index.html#(def._((lib._xml/main..rkt)._element-content))",[0,[2,"element-content"]],["xml"]],
["element-id-transformer?",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._element-id-transformer~3f))",[0,[2,"element-id-transformer?"]],["scribble/racket","scribble/scheme"]],
["element-name",">xml/index.html#(def._((lib._xml/main..rkt)._element-name))",[0,[2,"element-name"]],["xml"]],
["element-style",">scribble/core.html#(def._((lib._scribble/core..rkt)._element-style))",[0,[2,"element-style"]],["scribble/core"]],
["element-style",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._element-style))",[0,[2,"element-style"]],["scribble/struct"]],
["element-style?",">scribble/core.html#(def._((lib._scribble/core..rkt)._element-style~3f))",[0,[2,"element-style?"]],["scribble/core"]],
["element-traverse-procedure/c",">scribble/core.html#(def._((lib._scribble/core..rkt)._element-traverse-procedure/c))",[0,[2,"element-traverse-procedure/c"]],["scribble/core"]],
["element?",">scribble/core.html#(def._((lib._scribble/core..rkt)._element~3f))",[0,[2,"element?"]],["scribble/core"]],
["element?",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._element~3f))",[0,[2,"element?"]],["scribble/struct"]],
["element?",">xml/index.html#(def._((lib._xml/main..rkt)._element~3f))",[0,[2,"element?"]],["xml"]],
["elemref",">scribble/base.html#(def._((lib._scribble/base..rkt)._elemref))",[0,[2,"elemref"]],["scribble/base"]],
["elemtag",">scribble/base.html#(def._((lib._scribble/base..rkt)._elemtag))",[0,[2,"elemtag"]],["scribble/base"]],
["elevator teachpack",">teachpack/elevator.html#(idx._(gentag._15._(lib._teachpack/teachpack..scrbl)))","elevator teachpack",false],
["eliminate-whitespace",">xml/index.html#(def._((lib._xml/main..rkt)._eliminate-whitespace))",[0,[2,"eliminate-whitespace"]],["xml"]],
["ellipse",">draw/dc-path_.html#(meth._(((lib._racket/draw..rkt)._dc-path~25)._ellipse))",[[0,[2,"ellipse"]],[14,[" (method of ",[0,[2,"dc-path%"]],")"]]],["racket/draw"]],
["ellipse",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._ellipse))",[0,[2,"ellipse"]],["2htdp/image"]],
["ellipse",">teachpack/image.html#(def._((lib._htdp/image..rkt)._ellipse))",[0,[2,"ellipse"]],["htdp/image"]],
["ellipse",">slideshow/Basic_Pict_Constructors.html#(def._((lib._slideshow/pict..rkt)._ellipse))",[0,[2,"ellipse"]],["slideshow/pict","slideshow"]],
["ellipse",">deinprogramm/image.html#(def._((lib._deinprogramm/image..rkt)._ellipse))",[0,[2,"ellipse"]],["teachpack/deinprogramm/image"]],
["ellipse/border",">unstable/pict.html#(def._((lib._unstable/gui/pict..rkt)._ellipse/border))",[0,[2,"ellipse/border"]],["unstable/gui/pict"]],
["ellipses",">graphics/Draw__Clear__and_Flip_Operations.html#(part._.Ellipses)","Ellipses",false],
["ellipsis depth",">syntax/stxparse-specifying.html#(tech._ellipsis._depth)","<span style=\"font-style: italic\">ellipsis depth</span>",false],
["ellipsis-head alternative sets",">syntax/Experimental.html#(part._.Ellipsis-head_.Alternative_.Sets)","Ellipsis-head Alternative Sets",false],
["ellipsis-head alternative sets",">syntax/Experimental.html#(tech._ellipsis._head._alternative._set)","<span style=\"font-style: italic\">ellipsis-head alternative sets</span>",false],
["ellipsis-head pattern",">syntax/stxparse-patterns.html#(tech._ellipsis._head._pattern)","<span style=\"font-style: italic\">ellipsis-head pattern</span>",false],
["ellipsis-head patterns",">syntax/stxparse-patterns.html#(part._.Ellipsis-head_.Patterns)","Ellipsis-head Patterns",false],
["else",">reference/if.html#(form._((lib._racket/private/letstx-scheme..rkt)._else))",[0,[1,"else"]],["racket/base","racket"]],
["else",">r6rs-std/r6rs-Z-H-14.html#node_idx_380",[0,[1,"else"]],["rnrs/base-6"]],
["else",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_374",[0,[1,"else"]],["rnrs/exceptions-6"]],
["else",">htdp-langs/advanced.html#(form._((lib._lang/htdp-advanced..rkt)._else))",[0,[1,"else"]],["lang/htdp-advanced"]],
["else",">htdp-langs/beginner.html#(form._((lib._lang/htdp-beginner..rkt)._else))",[0,[1,"else"]],["lang/htdp-beginner"]],
["else",">htdp-langs/beginner-abbr.html#(form._((lib._lang/htdp-beginner-abbr..rkt)._else))",[0,[1,"else"]],["lang/htdp-beginner-abbr"]],
["else",">htdp-langs/intermediate.html#(form._((lib._lang/htdp-intermediate..rkt)._else))",[0,[1,"else"]],["lang/htdp-intermediate"]],
["else",">htdp-langs/intermediate-lam.html#(form._((lib._lang/htdp-intermediate-lambda..rkt)._else))",[0,[1,"else"]],["lang/htdp-intermediate-lambda"]],
["else",">deinprogramm/cond.html#(form._((lib._deinprogramm/.D.Md.A..rkt)._else))",[0,[1,"else"]],["deinprogramm/DMdA-beginner"]],
["em",">html/index.html#(def._((lib._html/main..rkt)._em))",[0,[2,"em"]],["html"]],
["em?",">html/index.html#(def._((lib._html/main..rkt)._em~3f))",[0,[2,"em?"]],["html"]],
["emacs",">guide/Emacs.html","Emacs",false],
["emacs keybindings",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._155._(lib._scribblings/drracket/drracket..scrbl)))","Emacs keybindings",false],
["emacs keybindings",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._367._(lib._scribblings/drracket/drracket..scrbl)))","Emacs keybindings",false],
["email",">scribble/LNCS_Paper_Format.html#(form._((lib._scribble/lncs/lang..rkt)._email))",[0,[1,"email"]],["scribble/lncs"]],
["embed-formlet",">web-server/formlets.html#(def._((lib._web-server/formlets/servlet..rkt)._embed-formlet))",[0,[2,"embed-formlet"]],["web-server/formlets/servlet"]],
["embed/url",">web-server/page.html#(form._((lib._web-server/page..rkt)._embed/url))",[0,[1,"embed/url"]],["web-server/page"]],
["embedded gui: widgets within editors",">embedded-gui/index.html","Embedded GUI: Widgets Within Editors",false],
["embedded-button%",">embedded-gui/embedded-button_.html",[0,[2,"embedded-button%"]],["embedded-gui"]],
["embedded-gui",">embedded-gui/index.html",[9,[0,"embedded-gui"]],"module"],
["embedded-message%",">embedded-gui/embedded-message_.html",[0,[2,"embedded-message%"]],["embedded-gui"]],
["embedded-text-button%",">embedded-gui/embedded-text-button_.html",[0,[2,"embedded-text-button%"]],["embedded-gui"]],
["embedded-toggle-button%",">embedded-gui/embedded-toggle-button_.html",[0,[2,"embedded-toggle-button%"]],["embedded-gui"]],
["embedding bitmaps in compiled files",">images/Embedding_Bitmaps_in_Compiled_Files.html","Embedding Bitmaps in Compiled Files",false],
["embedding modules via c",">raco/c-mods.html","Embedding Modules via C",false],
["embedding racket",">inside/overview.html#(idx._(gentag._16._(lib._scribblings/inside/inside..scrbl)))","embedding Racket",false],
["embedding racket into a program",">inside/overview.html#(part._embedding)","Embedding Racket into a Program",false],
["embedding-executable-add-suffix",">raco/exe.html#(def._((lib._compiler/embed..rkt)._embedding-executable-add-suffix))",[0,[2,"embedding-executable-add-suffix"]],["compiler/embed"]],
["embedding-executable-is-actually-directory?",">raco/exe.html#(def._((lib._compiler/embed..rkt)._embedding-executable-is-actually-directory~3f))",[0,[2,"embedding-executable-is-actually-directory?"]],["compiler/embed"]],
["embedding-executable-is-directory?",">raco/exe.html#(def._((lib._compiler/embed..rkt)._embedding-executable-is-directory~3f))",[0,[2,"embedding-executable-is-directory?"]],["compiler/embed"]],
["embedding-executable-put-file-extension+style+filters",">raco/exe.html#(def._((lib._compiler/embed..rkt)._embedding-executable-put-file-extension+style+filters))",[0,[2,"embedding-executable-put-file-extension+style+filters"]],["compiler/embed"]],
["emit-local-step",">macro-debugger/index.html#(def._((lib._macro-debugger/emit..rkt)._emit-local-step))",[0,[2,"emit-local-step"]],["macro-debugger/emit"]],
["emit-remark",">macro-debugger/index.html#(def._((lib._macro-debugger/emit..rkt)._emit-remark))",[0,[2,"emit-remark"]],["macro-debugger/emit"]],
["emph",">scribble/base.html#(def._((lib._scribble/base..rkt)._emph))",[0,[2,"emph"]],["scribble/base"]],
["empty",">reference/pairs.html#(def._((lib._racket/list..rkt)._empty))",[0,[2,"empty"]],["racket/list","racket"]],
["empty",">htdp-langs/advanced.html#(def._((lib._lang/htdp-advanced..rkt)._empty))",[0,[2,"empty"]],["lang/htdp-advanced"]],
["empty",">htdp-langs/beginner.html#(def._((lib._lang/htdp-beginner..rkt)._empty))",[0,[2,"empty"]],["lang/htdp-beginner"]],
["empty",">htdp-langs/beginner-abbr.html#(def._((lib._lang/htdp-beginner-abbr..rkt)._empty))",[0,[2,"empty"]],["lang/htdp-beginner-abbr"]],
["empty",">htdp-langs/intermediate.html#(def._((lib._lang/htdp-intermediate..rkt)._empty))",[0,[2,"empty"]],["lang/htdp-intermediate"]],
["empty",">htdp-langs/intermediate-lam.html#(def._((lib._lang/htdp-intermediate-lambda..rkt)._empty))",[0,[2,"empty"]],["lang/htdp-intermediate-lambda"]],
["empty",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._empty))",[0,[2,"empty"]],["deinprogramm/DMdA-advanced"]],
["empty",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._empty))",[0,[2,"empty"]],["deinprogramm/DMdA-assignments"]],
["empty",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._empty))",[0,[2,"empty"]],["deinprogramm/DMdA-beginner"]],
["empty",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._empty))",[0,[2,"empty"]],["deinprogramm/DMdA-vanilla"]],
["empty",">eopl/index.html#(def._((lib._eopl/eopl..rkt)._empty))",[0,[2,"empty"]],["eopl"]],
["empty",">lazy/index.html#(def._((lib._lazy/main..rkt)._empty))",[0,[2,"empty"]],["lazy"]],
["empty",">plai/mutator.html#(form._((lib._plai/mutator..rkt)._empty))",[0,[2,"empty"]],["plai/mutator"]],
["empty-disposition-type",">net/mime.html#(def._((lib._net/mime..rkt)._empty-disposition-type))",[0,[2,"empty-disposition-type"]],["net/mime"]],
["empty-disposition-type?",">net/mime.html#(def._((lib._net/mime..rkt)._empty-disposition-type~3f))",[0,[2,"empty-disposition-type?"]],["net/mime"]],
["empty-gif-stream?",">file/gif.html#(def._((lib._file/gif..rkt)._empty-gif-stream~3f))",[0,[2,"empty-gif-stream?"]],["file/gif"]],
["empty-header",">net/head.html#(def._((lib._net/head..rkt)._empty-header))",[0,[2,"empty-header"]],["net/head"]],
["empty-image",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._empty-image))",[0,[2,"empty-image"]],["2htdp/image"]],
["empty-image",">deinprogramm/image.html#(def._((lib._deinprogramm/image..rkt)._empty-image))",[0,[2,"empty-image"]],["teachpack/deinprogramm/image"]],
["empty-list",">deinprogramm/Signaturen.html#(form._((lib._deinprogramm/.D.Md.A..rkt)._empty-list))",[0,[1,"empty-list"]],["deinprogramm/DMdA-beginner"]],
["empty-mechanism",">net/mime.html#(def._((lib._net/mime..rkt)._empty-mechanism))",[0,[2,"empty-mechanism"]],["net/mime"]],
["empty-mechanism?",">net/mime.html#(def._((lib._net/mime..rkt)._empty-mechanism~3f))",[0,[2,"empty-mechanism?"]],["net/mime"]],
["empty-scene",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._empty-scene))",[0,[2,"empty-scene"]],["2htdp/image"]],
["empty-scene",">teachpack/image.html#(def._((lib._htdp/image..rkt)._empty-scene))",[0,[2,"empty-scene"]],["htdp/image"]],
["empty-sequence",">reference/sequences.html#(def._((lib._racket/sequence..rkt)._empty-sequence))",[0,[2,"empty-sequence"]],["racket/sequence","racket"]],
["empty-stream",">reference/streams.html#(def._((lib._racket/stream..rkt)._empty-stream))",[0,[2,"empty-stream"]],["racket/stream","racket"]],
["empty-subtype",">net/mime.html#(def._((lib._net/mime..rkt)._empty-subtype))",[0,[2,"empty-subtype"]],["net/mime"]],
["empty-subtype?",">net/mime.html#(def._((lib._net/mime..rkt)._empty-subtype~3f))",[0,[2,"empty-subtype?"]],["net/mime"]],
["empty-tag-shorthand",">xml/index.html#(def._((lib._xml/main..rkt)._empty-tag-shorthand))",[0,[2,"empty-tag-shorthand"]],["xml"]],
["empty-type",">net/mime.html#(def._((lib._net/mime..rkt)._empty-type))",[0,[2,"empty-type"]],["net/mime"]],
["empty-type?",">net/mime.html#(def._((lib._net/mime..rkt)._empty-type~3f))",[0,[2,"empty-type?"]],["net/mime"]],
["empty?",">reference/pairs.html#(def._((lib._racket/list..rkt)._empty~3f))",[0,[2,"empty?"]],["racket/list","racket"]],
["empty?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._empty~3f))",[0,[2,"empty?"]],["lang/htdp-advanced"]],
["empty?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._empty~3f))",[0,[2,"empty?"]],["lang/htdp-beginner"]],
["empty?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._empty~3f))",[0,[2,"empty?"]],["lang/htdp-beginner-abbr"]],
["empty?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._empty~3f))",[0,[2,"empty?"]],["lang/htdp-intermediate"]],
["empty?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._empty~3f))",[0,[2,"empty?"]],["lang/htdp-intermediate-lambda"]],
["empty?",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._empty~3f))",[0,[2,"empty?"]],["deinprogramm/DMdA-advanced"]],
["empty?",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._empty~3f))",[0,[2,"empty?"]],["deinprogramm/DMdA-assignments"]],
["empty?",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._empty~3f))",[0,[2,"empty?"]],["deinprogramm/DMdA-beginner"]],
["empty?",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._empty~3f))",[0,[2,"empty?"]],["deinprogramm/DMdA-vanilla"]],
["empty?",">lazy/index.html#(def._((lib._lazy/main..rkt)._empty~3f))",[0,[2,"empty?"]],["lazy"]],
["empty?",">plai/mutator.html#(form._((lib._plai/mutator..rkt)._empty~3f))",[0,[2,"empty?"]],["plai/mutator"]],
["enable",">gui/labelled-menu-item___.html#(meth._(((lib._mred/main..rkt)._labelled-menu-item~3c~25~3e)._enable))",[[0,[2,"enable"]],[14,[" (method of ",[0,[2,"labelled-menu-item<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["enable",">gui/menu-bar_.html#(meth._(((lib._mred/main..rkt)._menu-bar~25)._enable))",[[0,[2,"enable"]],[14,[" (method of ",[0,[2,"menu-bar%"]],")"]]],["racket/gui/base","racket/gui"]],
["enable",">gui/radio-box_.html#(meth._(((lib._mred/main..rkt)._radio-box~25)._enable))",[[0,[2,"enable"]],[14,[" (method of ",[0,[2,"radio-box%"]],")"]]],["racket/gui/base","racket/gui"]],
["enable",">gui/window___.html#(meth._(((lib._mred/main..rkt)._window~3c~25~3e)._enable))",[[0,[2,"enable"]],[14,[" (method of ",[0,[2,"window<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["enable tests menu item",">drracket/Menus.html#(idx._(gentag._136._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Enable Tests</span> menu item",false],
["enable-click-advance!",">slideshow/Viewer_Control.html#(def._((lib._slideshow/base..rkt)._enable-click-advance!))",[0,[2,"enable-click-advance!"]],["slideshow/base","slideshow"]],
["enable-evaluation",">tools/drracket_rep.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3arep~3acontext~3c~25~3e)._enable-evaluation))",[[0,[2,"enable-evaluation"]],[14,[" (method of ",[0,[2,"drracket:rep:context<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["enable-evaluation",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3atab~3c~25~3e)._enable-evaluation))",[[0,[2,"enable-evaluation"]],[14,[" (method of ",[0,[2,"drracket:unit:tab<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["enable-piece",">gl-board-game/index.html#(meth._(((lib._games/gl-board-game..rkt)._gl-board~25)._enable-piece))",[[0,[2,"enable-piece"]],[14,[" (method of ",[0,[2,"gl-board%"]],")"]]],["games/gl-board-game"]],
["enabled",">gui/window___.html#(idx._(gentag._136._(lib._scribblings/gui/gui..scrbl)))",[0,"enabled"],false],
["enabled?",">gl-board-game/index.html#(meth._(((lib._games/gl-board-game..rkt)._gl-board~25)._enabled~3f))",[[0,[2,"enabled?"]],[14,[" (method of ",[0,[2,"gl-board%"]],")"]]],["games/gl-board-game"]],
["enabling and disabling breaks",">inside/exceptions.html#(part._.Enabling_and_.Disabling_.Breaks)","Enabling and Disabling Breaks",false],
["encapsulated postscript (eps)",">draw/post-script-dc_.html#(idx._(gentag._66._(lib._scribblings/draw/draw..scrbl)))","Encapsulated PostScript (EPS)",false],
["enclosing-module-name",">reference/module.html#(idx._(gentag._81._(lib._scribblings/reference/reference..scrbl)))",[7,"'enclosing-module-name"],false],
["encoding snips",">gui/editor-overview.html#(part._.Encoding_.Snips)","Encoding Snips",false],
["encodings and locales",">reference/encodings.html","Encodings and Locales",false],
["end",">gui/key-event_.html#(idx._(gentag._50._(lib._scribblings/gui/gui..scrbl)))",[7,"'end"],false],
["end of line ambiguity",">gui/editor-overview.html#(part._editoreol)","End of Line Ambiguity",false],
["end-annotation",">teachpack/docs.html#(def._((lib._htdp/docs..rkt)._end-annotation))",[0,[2,"end-annotation"]],["htdp/docs"]],
["end-atomic",">foreign/Atomic_Execution.html#(def._((lib._ffi/unsafe/atomic..rkt)._end-atomic))",[0,[2,"end-atomic"]],["ffi/unsafe/atomic"]],
["end-breakable-atomic",">foreign/Atomic_Execution.html#(def._((lib._ffi/unsafe/atomic..rkt)._end-breakable-atomic))",[0,[2,"end-breakable-atomic"]],["ffi/unsafe/atomic"]],
["end-busy-cursor",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._end-busy-cursor))",[0,[2,"end-busy-cursor"]],["racket/gui/base","racket/gui"]],
["end-card-sequence",">cards/index.html#(meth._(((lib._games/cards..rkt)._table~3c~25~3e)._end-card-sequence))",[[0,[2,"end-card-sequence"]],[14,[" (method of ",[0,[2,"table<%>"]],")"]]],["games/cards"]],
["end-container-sequence",">gui/area-container___.html#(meth._(((lib._mred/main..rkt)._area-container~3c~25~3e)._end-container-sequence))",[[0,[2,"end-container-sequence"]],[14,[" (method of ",[0,[2,"area-container<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["end-doc",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._end-doc))",[[0,[2,"end-doc"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["end-edit-sequence",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._end-edit-sequence))",[[0,[2,"end-edit-sequence"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["end-macro",">framework/Keymap.html#(idx._(gentag._39._(lib._scribblings/framework/framework..scrbl)))","end-macro",false],
["end-mark",">preprocessor/mzpp.html#(def._((lib._preprocessor/mzpp..rkt)._end-mark))",[0,[2,"end-mark"]],["preprocessor/mzpp"]],
["end-metadata-changes",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3adefinitions-text~3c~25~3e)._end-metadata-changes))",[[0,[2,"end-metadata-changes"]],[14,[" (method of ",[0,[2,"drracket:unit:definitions-text<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["end-of-char-set?",">srfi-std/srfi-14.html#end-of-char-set-p",[0,[2,"end-of-char-set?"]],["srfi/14"]],
["end-of-time",">teachpack/draw.html#(def._((lib._htdp/big-draw..rkt)._end-of-time))",[0,[2,"end-of-time"]],["htdp/draw"]],
["end-of-time",">deinprogramm/world.html#(def._((lib._deinprogramm/world..rkt)._end-of-time))",[0,[2,"end-of-time"]],["teachpack/deinprogramm/world"]],
["end-page",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._end-page))",[[0,[2,"end-page"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["end-pos",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex..rkt)._end-pos))",[0,[1,"end-pos"]],["parser-tools/lex"]],
["end-stubborn-change",">foreign/foreign_pointer-funcs.html#(def._((quote._~23~25foreign)._end-stubborn-change))",[0,[2,"end-stubborn-change"]],["ffi/unsafe"]],
["end-write-header-footer-to-file",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._end-write-header-footer-to-file))",[[0,[2,"end-write-header-footer-to-file"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["endianness",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_76",[0,[1,"endianness"]],["rnrs/bytevectors-6"]],
["enemy-bug",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._enemy-bug))",[0,[2,"enemy-bug"]],["2htdp/planetcute"]],
["enqueue!",">data/Imperative_Queues.html#(def._((lib._data/queue..rkt)._enqueue!))",[0,[2,"enqueue!"]],["data/queue"]],
["ensure-defs-shown",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aframe~3c~25~3e)._ensure-defs-shown))",[[0,[2,"ensure-defs-shown"]],[14,[" (method of ",[0,[2,"drracket:unit:frame<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["ensure-rep-hidden",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aframe~3c~25~3e)._ensure-rep-hidden))",[[0,[2,"ensure-rep-hidden"]],[14,[" (method of ",[0,[2,"drracket:unit:frame<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["ensure-rep-shown",">tools/drracket_rep.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3arep~3acontext~3c~25~3e)._ensure-rep-shown))",[[0,[2,"ensure-rep-shown"]],[14,[" (method of ",[0,[2,"drracket:rep:context<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["ensure-rep-shown",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aframe~3c~25~3e)._ensure-rep-shown))",[[0,[2,"ensure-rep-shown"]],[14,[" (method of ",[0,[2,"drracket:unit:frame<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["ensuring that plots have bounds",">plot/porting.html#(part._.Ensuring_.That_.Plots_.Have_.Bounds)","Ensuring That Plots Have Bounds",false],
["enter!",">reference/enter.html#(form._((lib._racket/enter..rkt)._enter!))",[0,[1,"enter!"]],["racket/enter","racket/init"]],
["entering?",">gui/mouse-event_.html#(meth._(((lib._mred/main..rkt)._mouse-event~25)._entering~3f))",[[0,[2,"entering?"]],[14,[" (method of ",[0,[2,"mouse-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["entity",">net/mime.html#(def._((lib._net/mime..rkt)._entity))",[0,[2,"entity"]],["net/mime"]],
["entity",">xml/index.html#(def._((lib._xml/main..rkt)._entity))",[0,[2,"entity"]],["xml"]],
["entity-body",">net/mime.html#(def._((lib._net/mime..rkt)._entity-body))",[0,[2,"entity-body"]],["net/mime"]],
["entity-charset",">net/mime.html#(def._((lib._net/mime..rkt)._entity-charset))",[0,[2,"entity-charset"]],["net/mime"]],
["entity-description",">net/mime.html#(def._((lib._net/mime..rkt)._entity-description))",[0,[2,"entity-description"]],["net/mime"]],
["entity-disposition",">net/mime.html#(def._((lib._net/mime..rkt)._entity-disposition))",[0,[2,"entity-disposition"]],["net/mime"]],
["entity-encoding",">net/mime.html#(def._((lib._net/mime..rkt)._entity-encoding))",[0,[2,"entity-encoding"]],["net/mime"]],
["entity-fields",">net/mime.html#(def._((lib._net/mime..rkt)._entity-fields))",[0,[2,"entity-fields"]],["net/mime"]],
["entity-id",">net/mime.html#(def._((lib._net/mime..rkt)._entity-id))",[0,[2,"entity-id"]],["net/mime"]],
["entity-other",">net/mime.html#(def._((lib._net/mime..rkt)._entity-other))",[0,[2,"entity-other"]],["net/mime"]],
["entity-params",">net/mime.html#(def._((lib._net/mime..rkt)._entity-params))",[0,[2,"entity-params"]],["net/mime"]],
["entity-parts",">net/mime.html#(def._((lib._net/mime..rkt)._entity-parts))",[0,[2,"entity-parts"]],["net/mime"]],
["entity-subtype",">net/mime.html#(def._((lib._net/mime..rkt)._entity-subtype))",[0,[2,"entity-subtype"]],["net/mime"]],
["entity-text",">xml/index.html#(def._((lib._xml/main..rkt)._entity-text))",[0,[2,"entity-text"]],["xml"]],
["entity-type",">net/mime.html#(def._((lib._net/mime..rkt)._entity-type))",[0,[2,"entity-type"]],["net/mime"]],
["entity?",">net/mime.html#(def._((lib._net/mime..rkt)._entity~3f))",[0,[2,"entity?"]],["net/mime"]],
["entity?",">xml/index.html#(def._((lib._xml/main..rkt)._entity~3f))",[0,[2,"entity?"]],["xml"]],
["entry",">scribble/xref.html#(def._((lib._scribble/xref..rkt)._entry))",[0,[2,"entry"]],["scribble/xref"]],
["entry-content",">scribble/xref.html#(def._((lib._scribble/xref..rkt)._entry-content))",[0,[2,"entry-content"]],["scribble/xref"]],
["entry-desc",">scribble/xref.html#(def._((lib._scribble/xref..rkt)._entry-desc))",[0,[2,"entry-desc"]],["scribble/xref"]],
["entry-tag",">scribble/xref.html#(def._((lib._scribble/xref..rkt)._entry-tag))",[0,[2,"entry-tag"]],["scribble/xref"]],
["entry-words",">scribble/xref.html#(def._((lib._scribble/xref..rkt)._entry-words))",[0,[2,"entry-words"]],["scribble/xref"]],
["entry?",">scribble/xref.html#(def._((lib._scribble/xref..rkt)._entry~3f))",[0,[2,"entry?"]],["scribble/xref"]],
["enum-set->list",">r6rs-lib-std/r6rs-lib-Z-H-15.html#node_idx_1244",[0,[2,"enum-set->list"]],["rnrs/enums-6"]],
["enum-set-complement",">r6rs-lib-std/r6rs-lib-Z-H-15.html#node_idx_1258",[0,[2,"enum-set-complement"]],["rnrs/enums-6"]],
["enum-set-constructor",">r6rs-lib-std/r6rs-lib-Z-H-15.html#node_idx_1242",[0,[2,"enum-set-constructor"]],["rnrs/enums-6"]],
["enum-set-difference",">r6rs-lib-std/r6rs-lib-Z-H-15.html#node_idx_1256",[0,[2,"enum-set-difference"]],["rnrs/enums-6"]],
["enum-set-indexer",">r6rs-lib-std/r6rs-lib-Z-H-15.html#node_idx_1240",[0,[2,"enum-set-indexer"]],["rnrs/enums-6"]],
["enum-set-intersection",">r6rs-lib-std/r6rs-lib-Z-H-15.html#node_idx_1254",[0,[2,"enum-set-intersection"]],["rnrs/enums-6"]],
["enum-set-member?",">r6rs-lib-std/r6rs-lib-Z-H-15.html#node_idx_1246",[0,[2,"enum-set-member?"]],["rnrs/enums-6"]],
["enum-set-projection",">r6rs-lib-std/r6rs-lib-Z-H-15.html#node_idx_1260",[0,[2,"enum-set-projection"]],["rnrs/enums-6"]],
["enum-set-subset?",">r6rs-lib-std/r6rs-lib-Z-H-15.html#node_idx_1248",[0,[2,"enum-set-subset?"]],["rnrs/enums-6"]],
["enum-set-union",">r6rs-lib-std/r6rs-lib-Z-H-15.html#node_idx_1252",[0,[2,"enum-set-union"]],["rnrs/enums-6"]],
["enum-set-universe",">r6rs-lib-std/r6rs-lib-Z-H-15.html#node_idx_1238",[0,[2,"enum-set-universe"]],["rnrs/enums-6"]],
["enum-set=?",">r6rs-lib-std/r6rs-lib-Z-H-15.html#node_idx_1250",[0,[2,"enum-set=?"]],["rnrs/enums-6"]],
["enumerations and masks",">foreign/Enumerations_and_Masks.html","Enumerations and Masks",false],
["environment",">r6rs-lib-std/r6rs-lib-Z-H-17.html#node_idx_1270",[0,[2,"environment"]],["rnrs/eval-6"]],
["environment",">reference/syntax-model.html#(tech._environment)","<span style=\"font-style: italic\">environment</span>",false],
["environment and runtime information",">reference/runtime.html","Environment and Runtime Information",false],
["environment variables",">drracket/extending-drracket.html#(part._environment-variables)","Environment Variables",false],
["envvar",">scribble/doc-strings.html#(def._((lib._scribble/manual..rkt)._envvar))",[0,[2,"envvar"]],["scribble/manual"]],
["eof",">reference/port-ops.html#(def._((quote._~23~25kernel)._eof))",[0,[2,"eof"]],["racket/base","racket"]],
["eof",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._eof))",[0,[2,"eof"]],["lang/htdp-advanced"]],
["eof",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._eof))",[0,[2,"eof"]],["lang/htdp-beginner"]],
["eof",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._eof))",[0,[2,"eof"]],["lang/htdp-beginner-abbr"]],
["eof",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._eof))",[0,[2,"eof"]],["lang/htdp-intermediate"]],
["eof",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._eof))",[0,[2,"eof"]],["lang/htdp-intermediate-lambda"]],
["eof",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.E.O.F))",[0,[1,"EOF"]],["typed/racket/base","typed/racket"]],
["eof-evt",">reference/port-lib.html#(def._((lib._racket/port..rkt)._eof-evt))",[0,[2,"eof-evt"]],["racket/port","racket"]],
["eof-object",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_636",[0,[2,"eof-object"]],["rnrs/io/ports-6"]],
["eof-object?",">reference/port-ops.html#(def._((quote._~23~25kernel)._eof-object~3f))",[0,[2,"eof-object?"]],["racket/base","racket"]],
["eof-object?",">r5rs-std/r5rs-Z-H-9.html#%_idx_646",[0,[2,"eof-object?"]],["r5rs"]],
["eof-object?",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_638",[0,[2,"eof-object?"]],["rnrs/io/ports-6"]],
["eof-object?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._eof-object~3f))",[0,[2,"eof-object?"]],["lang/htdp-advanced"]],
["eof-object?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._eof-object~3f))",[0,[2,"eof-object?"]],["lang/htdp-beginner"]],
["eof-object?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._eof-object~3f))",[0,[2,"eof-object?"]],["lang/htdp-beginner-abbr"]],
["eof-object?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._eof-object~3f))",[0,[2,"eof-object?"]],["lang/htdp-intermediate"]],
["eof-object?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._eof-object~3f))",[0,[2,"eof-object?"]],["lang/htdp-intermediate-lambda"]],
["eol-style",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_596",[0,[1,"eol-style"]],["rnrs/io/ports-6"]],
["eopl",">eopl/index.html",[9,[0,"eopl"]],"module"],
["eopl:error",">eopl/index.html#(def._((lib._eopl/eopl..rkt)._eopl~3aerror))",[0,[2,"eopl:error"]],["eopl"]],
["eopl:error-stop",">eopl/index.html#(def._((lib._eopl/eopl..rkt)._eopl~3aerror-stop))",[0,"eopl:error-stop"],["eopl"]],
["eopl:pretty-print",">eopl/index.html#(def._((lib._eopl/eopl..rkt)._eopl~3apretty-print))",[0,[2,"eopl:pretty-print"]],["eopl"]],
["eopl:printf",">eopl/index.html#(def._((lib._eopl/eopl..rkt)._eopl~3aprintf))",[0,[2,"eopl:printf"]],["eopl"]],
["ephemeron",">reference/ephemerons.html#(tech._ephemeron)","<span style=\"font-style: italic\">ephemeron</span>",false],
["ephemeron-value",">reference/ephemerons.html#(def._((quote._~23~25kernel)._ephemeron-value))",[0,[2,"ephemeron-value"]],["racket/base","racket"]],
["ephemeron?",">reference/ephemerons.html#(def._((quote._~23~25kernel)._ephemeron~3f))",[0,[2,"ephemeron?"]],["racket/base","racket"]],
["ephemeronof",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Ephemeronof))",[0,[1,"Ephemeronof"]],["typed/racket/base","typed/racket"]],
["ephemerons",">reference/ephemerons.html","Ephemerons",false],
["eprintf",">reference/Writing.html#(def._((quote._~23~25kernel)._eprintf))",[0,[2,"eprintf"]],["racket/base","racket"]],
["epsilon",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex-plt-v200..rkt)._epsilon))",[0,[1,"epsilon"]],["parser-tools/lex-plt-v200"]],
["epsilon",">unstable/Automata__Compiling_State_Machines.html#(form._((lib._unstable/automata/nfa-ep..rkt)._epsilon))",[0,[1,"epsilon"]],["unstable/automata/nfa-ep"]],
["epsilon",">unstable/Automata__Compiling_State_Machines.html#(form._((lib._unstable/automata/re..rkt)._epsilon))",[0,[1,"epsilon"]],["unstable/automata/re"]],
["eq-hash-code",">reference/hashtables.html#(def._((quote._~23~25kernel)._eq-hash-code))",[0,[2,"eq-hash-code"]],["racket/base","racket"]],
["eq?",">reference/booleans.html#(def._((quote._~23~25kernel)._eq~3f))",[0,[2,"eq?"]],["racket/base","racket"]],
["eq?",">r5rs-std/r5rs-Z-H-9.html#%_idx_220",[0,[2,"eq?"]],["r5rs"]],
["eq?",">r6rs-std/r6rs-Z-H-14.html#node_idx_434",[0,[2,"eq?"]],["rnrs/base-6"]],
["eq?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._eq~3f))",[0,[2,"eq?"]],["lang/htdp-advanced"]],
["eq?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._eq~3f))",[0,[2,"eq?"]],["lang/htdp-beginner"]],
["eq?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._eq~3f))",[0,[2,"eq?"]],["lang/htdp-beginner-abbr"]],
["eq?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._eq~3f))",[0,[2,"eq?"]],["lang/htdp-intermediate"]],
["eq?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._eq~3f))",[0,[2,"eq?"]],["lang/htdp-intermediate-lambda"]],
["eq?",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._eq~3f))",[0,[2,"eq?"]],["deinprogramm/DMdA-advanced"]],
["eq?",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._eq~3f))",[0,[2,"eq?"]],["deinprogramm/DMdA-assignments"]],
["eq?",">lazy/index.html#(def._((lib._lazy/main..rkt)._eq~3f))",[0,[2,"eq?"]],["lazy"]],
["eq?",">plai/mutator.html#(form._((lib._plai/mutator..rkt)._eq~3f))",[0,[2,"eq?"]],["plai/mutator"]],
["equal",">mzscheme/Old_Functions.html#(idx._(gentag._1._(lib._mzscheme/mzscheme..scrbl)))",[7,"'equal"],false],
["equal-area-projection",">images/Spatial_Transformations.html#(def._((lib._images/flomap..rkt)._equal-area-projection))",[0,[2,"equal-area-projection"]],["images/flomap"]],
["equal-hash",">r6rs-lib-std/r6rs-lib-Z-H-14.html#node_idx_1218",[0,[2,"equal-hash"]],["rnrs/hashtables-6"]],
["equal-hash-code",">reference/hashtables.html#(def._((quote._~23~25kernel)._equal-hash-code))",[0,[2,"equal-hash-code"]],["racket/base","racket"]],
["equal-hash-code-of",">gui/image-snip_.html#(meth._(((lib._racket/snip..rkt)._image-snip~25)._equal-hash-code-of))",[[0,[2,"equal-hash-code-of"]],[14,[" (method of ",[0,[2,"image-snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["equal-hash-code-of",">gui/snip_.html#(meth._(((lib._racket/snip..rkt)._snip~25)._equal-hash-code-of))",[[0,[2,"equal-hash-code-of"]],[14,[" (method of ",[0,[2,"snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["equal-secondary-hash-code",">reference/hashtables.html#(def._((quote._~23~25kernel)._equal-secondary-hash-code))",[0,[2,"equal-secondary-hash-code"]],["racket/base","racket"]],
["equal-secondary-hash-code-of",">gui/image-snip_.html#(meth._(((lib._racket/snip..rkt)._image-snip~25)._equal-secondary-hash-code-of))",[[0,[2,"equal-secondary-hash-code-of"]],[14,[" (method of ",[0,[2,"image-snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["equal-secondary-hash-code-of",">gui/snip_.html#(meth._(((lib._racket/snip..rkt)._snip~25)._equal-secondary-hash-code-of))",[[0,[2,"equal-secondary-hash-code-of"]],[14,[" (method of ",[0,[2,"snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["equal-to?",">gui/snip_.html#(meth._(((lib._racket/snip..rkt)._snip~25)._equal-to~3f))",[[0,[2,"equal-to?"]],[14,[" (method of ",[0,[2,"snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["equal-to?",">mrlib/Cache-image_Snip.html#(meth._(((lib._mrlib/cache-image-snip..rkt)._cache-image-snip~25)._equal-to~3f))",[[0,[2,"equal-to?"]],[14,[" (method of ",[0,[2,"cache-image-snip%"]],")"]]],["mrlib/cache-image-snip"]],
["equal<%>",">reference/objectequality.html#(def._((lib._racket/private/class-internal..rkt)._equal~3c~25~3e))",[0,[2,"equal<%>"]],["racket/class","racket"]],
["equal?",">reference/booleans.html#(def._((quote._~23~25kernel)._equal~3f))",[0,[2,"equal?"]],["racket/base","racket"]],
["equal?",">gui/style-delta_.html#(meth._(((lib._racket/snip..rkt)._style-delta~25)._equal~3f))",[[0,[2,"equal?"]],[14,[" (method of ",[0,[2,"style-delta%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["equal?",">r5rs-std/r5rs-Z-H-9.html#%_idx_222",[0,[2,"equal?"]],["r5rs"]],
["equal?",">r6rs-std/r6rs-Z-H-14.html#node_idx_436",[0,[2,"equal?"]],["rnrs/base-6"]],
["equal?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._equal~3f))",[0,[2,"equal?"]],["lang/htdp-advanced"]],
["equal?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._equal~3f))",[0,[2,"equal?"]],["lang/htdp-beginner"]],
["equal?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._equal~3f))",[0,[2,"equal?"]],["lang/htdp-beginner-abbr"]],
["equal?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._equal~3f))",[0,[2,"equal?"]],["lang/htdp-intermediate"]],
["equal?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._equal~3f))",[0,[2,"equal?"]],["lang/htdp-intermediate-lambda"]],
["equal?",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._equal~3f))",[0,[2,"equal?"]],["deinprogramm/DMdA-advanced"]],
["equal?",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._equal~3f))",[0,[2,"equal?"]],["deinprogramm/DMdA-assignments"]],
["equal?",">lazy/index.html#(def._((lib._lazy/main..rkt)._equal~3f))",[0,[2,"equal?"]],["lazy"]],
["equal?/recur",">reference/booleans.html#(def._((quote._~23~25kernel)._equal~3f/recur))",[0,[2,"equal?/recur"]],["racket/base","racket"]],
["equality testing of images",">teachpack/2htdpimage.html#(part._.Equality_.Testing_of_.Images)","Equality Testing of Images",false],
["equal~?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._equal~7e~3f))",[0,[2,"equal~?"]],["lang/htdp-advanced"]],
["equal~?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._equal~7e~3f))",[0,[2,"equal~?"]],["lang/htdp-beginner"]],
["equal~?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._equal~7e~3f))",[0,[2,"equal~?"]],["lang/htdp-beginner-abbr"]],
["equal~?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._equal~7e~3f))",[0,[2,"equal~?"]],["lang/htdp-intermediate"]],
["equal~?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._equal~7e~3f))",[0,[2,"equal~?"]],["lang/htdp-intermediate-lambda"]],
["eqv",">mzscheme/Old_Functions.html#(idx._(gentag._2._(lib._mzscheme/mzscheme..scrbl)))",[7,"'eqv"],false],
["eqv-hash-code",">reference/hashtables.html#(def._((quote._~23~25kernel)._eqv-hash-code))",[0,[2,"eqv-hash-code"]],["racket/base","racket"]],
["eqv?",">reference/booleans.html#(def._((quote._~23~25kernel)._eqv~3f))",[0,[2,"eqv?"]],["racket/base","racket"]],
["eqv?",">r5rs-std/r5rs-Z-H-9.html#%_idx_214",[0,[2,"eqv?"]],["r5rs"]],
["eqv?",">r6rs-std/r6rs-Z-H-14.html#node_idx_428",[0,[2,"eqv?"]],["rnrs/base-6"]],
["eqv?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._eqv~3f))",[0,[2,"eqv?"]],["lang/htdp-advanced"]],
["eqv?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._eqv~3f))",[0,[2,"eqv?"]],["lang/htdp-beginner"]],
["eqv?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._eqv~3f))",[0,[2,"eqv?"]],["lang/htdp-beginner-abbr"]],
["eqv?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._eqv~3f))",[0,[2,"eqv?"]],["lang/htdp-intermediate"]],
["eqv?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._eqv~3f))",[0,[2,"eqv?"]],["lang/htdp-intermediate-lambda"]],
["eqv?",">lazy/index.html#(def._((lib._lazy/main..rkt)._eqv~3f))",[0,[2,"eqv?"]],["lazy"]],
["erase",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._erase))",[[0,[2,"erase"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["erase",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._erase))",[[0,[2,"erase"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["erase",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._erase))",[[0,[2,"erase"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["erase",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtles..rkt)._erase))",[0,[2,"erase"]],["graphics/turtles"]],
["erase",">turtles/Value_Turtles.html#(def._((lib._graphics/value-turtles..rkt)._erase))",[0,"erase"],["graphics/value-turtles"]],
["erase-offset",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtles..rkt)._erase-offset))",[0,[2,"erase-offset"]],["graphics/turtles"]],
["erase-offset",">turtles/Value_Turtles.html#(def._((lib._graphics/value-turtles..rkt)._erase-offset))",[0,"erase-offset"],["graphics/value-turtles"]],
["erase-pkg",">planet/Utility_Libraries.html#(def._((lib._planet/util..rkt)._erase-pkg))",[0,[2,"erase-pkg"]],["planet/util"]],
["erase-underscores",">framework/Menu.html#(meth._(((lib._framework/main..rkt)._menu~3acan-restore-underscore~3c~25~3e)._erase-underscores))",[[0,[2,"erase-underscores"]],[14,[" (method of ",[0,[2,"menu:can-restore-underscore<%>"]],")"]]],["framework"]],
["errno",">foreign/foreign_procedures.html#(idx._(gentag._3._(lib._scribblings/foreign/foreign..scrbl)))",[6,"errno"],false],
["error",">reference/exns.html#(def._((quote._~23~25kernel)._error))",[0,[2,"error"]],["racket/base","racket"]],
["error",">r6rs-std/r6rs-Z-H-14.html#node_idx_746",[0,[2,"error"]],["rnrs/base-6"]],
["error",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._error))",[0,[2,"error"]],["lang/htdp-advanced"]],
["error",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._error))",[0,[2,"error"]],["lang/htdp-beginner"]],
["error",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._error))",[0,[2,"error"]],["lang/htdp-beginner-abbr"]],
["error",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._error))",[0,[2,"error"]],["lang/htdp-intermediate"]],
["error",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._error))",[0,[2,"error"]],["lang/htdp-intermediate-lambda"]],
["error",">lazy/index.html#(def._((lib._lazy/main..rkt)._error))",[0,[2,"error"]],["lazy"]],
["error",">plai/plai-scheme.html#(def._((lib._plai/main..rkt)._error))",[0,[2,"error"]],["plai"]],
["error",">plai/mutator.html#(form._((lib._plai/mutator..rkt)._error))",[0,[2,"error"]],["plai/mutator"]],
["error",">srfi-std/srfi-23.html#error",[0,[2,"error"]],["srfi/23"]],
["error",">reference/bytestrings.html#(idx._(gentag._118._(lib._scribblings/reference/reference..scrbl)))",[7,"'error"],false],
["error",">tools/adding-languages.html#(idx._(gentag._15._(lib._scribblings/tools/tools..scrbl)))",[7,"'error"],false],
["error",">reference/file-ports.html#(idx._(gentag._203._(lib._scribblings/reference/reference..scrbl)))",[7,"'error"],false],
["error bars",">plot/params.html#(part._.Error_.Bars)","Error Bars",false],
["error display handler",">reference/exns.html#(tech._error._display._handler)","<span style=\"font-style: italic\">error display handler</span>",false],
["error escape handler",">reference/exns.html#(tech._error._escape._handler)","<span style=\"font-style: italic\">error escape handler</span>",false],
["error highlighting",">drracket/interactions-window.html#(idx._(gentag._27._(lib._scribblings/drracket/drracket..scrbl)))","error highlighting",false],
["error message composition guidelines",">htdp/index.html#(part._error-guidelines)","Error Message Composition Guidelines",false],
["error message convention",">reference/exns.html#(tech._error._message._convention)","<span style=\"font-style: italic\">error message convention</span>",false],
["error message conventions",">reference/exns.html#(part._.Error_.Message_.Conventions)","Error Message Conventions",false],
["error reporting",">reference/syntax-util.html#(part._.Error_reporting)","Error reporting",false],
["error reporting functions",">htdp/index.html#(part._error-reporting)","Error Reporting Functions",false],
["error value conversion handler",">reference/exns.html#(tech._error._value._conversion._handler)","<span style=\"font-style: italic\">error value conversion\nhandler</span>",false],
["error-bar-alpha",">plot/params.html#(def._((lib._plot/main..rkt)._error-bar-alpha))",[0,[2,"error-bar-alpha"]],["plot"]],
["error-bar-color",">plot/params.html#(def._((lib._plot/main..rkt)._error-bar-color))",[0,[2,"error-bar-color"]],["plot"]],
["error-bar-line-style",">plot/params.html#(def._((lib._plot/main..rkt)._error-bar-line-style))",[0,[2,"error-bar-line-style"]],["plot"]],
["error-bar-line-width",">plot/params.html#(def._((lib._plot/main..rkt)._error-bar-line-width))",[0,[2,"error-bar-line-width"]],["plot"]],
["error-bar-width",">plot/params.html#(def._((lib._plot/main..rkt)._error-bar-width))",[0,[2,"error-bar-width"]],["plot"]],
["error-bars",">plot/renderer2d.html#(def._((lib._plot/main..rkt)._error-bars))",[0,[2,"error-bars"]],["plot"]],
["error-bars",">plot/compat.html#(def._((lib._plot/compat..rkt)._error-bars))",[0,[2,"error-bars"]],["plot/compat"]],
["error-color",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._error-color))",[0,[2,"error-color"]],["scribble/racket","scribble/scheme"]],
["error-context-display-depth",">errortrace/using-errortrace.html#(def._((lib._errortrace/errortrace-lib..rkt)._error-context-display-depth))",[0,[2,"error-context-display-depth"]],["errortrace"]],
["error-display-handler",">reference/exns.html#(def._((quote._~23~25kernel)._error-display-handler))",[0,[2,"error-display-handler"]],["racket/base","racket"]],
["error-escape-handler",">reference/exns.html#(def._((quote._~23~25kernel)._error-escape-handler))",[0,[2,"error-escape-handler"]],["racket/base","racket"]],
["error-handler",">htdp/index.html#(def._((lib._test-engine/racket-tests..rkt)._error-handler))",[0,[2,"error-handler"]],["htdp/testing"]],
["error-handling-mode",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_614",[0,[1,"error-handling-mode"]],["rnrs/io/ports-6"]],
["error-print-context-length",">reference/exns.html#(def._((quote._~23~25kernel)._error-print-context-length))",[0,[2,"error-print-context-length"]],["racket/base","racket"]],
["error-print-source-location",">reference/exns.html#(def._((quote._~23~25kernel)._error-print-source-location))",[0,[2,"error-print-source-location"]],["racket/base","racket"]],
["error-print-width",">reference/exns.html#(def._((quote._~23~25kernel)._error-print-width))",[0,[2,"error-print-width"]],["racket/base","racket"]],
["error-value->string-handler",">reference/exns.html#(def._((quote._~23~25kernel)._error-value-~3estring-handler))",[0,[2,"error-value->string-handler"]],["racket/base","racket"]],
["error?",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_430",[0,[2,"error?"]],["rnrs/conditions-6"]],
["errors",">mzcom/index.html#(part._.Errors)","Errors",false],
["errors",">drracket/interactions-window.html#(part._.Errors)","Errors",false],
["errors",">framework/Test.html#(part._test~3aerrors)","Errors",false],
["errortrace",">errortrace/using-errortrace.html",[9,[0,"errortrace"]],"module"],
["errortrace key",">errortrace/Errortrace_Key.html","Errortrace Key",false],
["errortrace library",">errortrace/errortrace-library.html","Errortrace Library",false],
["errortrace-annotate",">errortrace/errortrace-library.html#(def._((lib._errortrace/errortrace-lib..rkt)._errortrace-annotate))",[0,[2,"errortrace-annotate"]],["errortrace/errortrace-lib"]],
["errortrace-compile-handler",">errortrace/errortrace-library.html#(def._((lib._errortrace/errortrace-lib..rkt)._errortrace-compile-handler))",[0,[2,"errortrace-compile-handler"]],["errortrace/errortrace-lib"]],
["errortrace-error-display-handler",">errortrace/errortrace-library.html#(def._((lib._errortrace/errortrace-lib..rkt)._errortrace-error-display-handler))",[0,[2,"errortrace-error-display-handler"]],["errortrace/errortrace-lib"]],
["errortrace-key",">errortrace/Errortrace_Key.html#(def._((lib._errortrace/errortrace-key..rkt)._errortrace-key))",[0,"errortrace-key"],["errortrace/errortrace-key"]],
["errortrace/errortrace-key",">errortrace/Errortrace_Key.html",[9,[0,"errortrace/errortrace-key"]],"module"],
["errortrace/errortrace-lib",">errortrace/errortrace-library.html",[9,[0,"errortrace/errortrace-lib"]],"module"],
["errortrace/stacktrace",">errortrace/stacktrace.html",[9,[0,"errortrace/stacktrace"]],"module"],
["errortrace: debugging and profiling",">errortrace/index.html","Errortrace: Debugging and Profiling",false],
["escape",">gui/key-event_.html#(idx._(gentag._56._(lib._scribblings/gui/gui..scrbl)))",[7,"'escape"],false],
["escape continuation",">reference/eval-model.html#(tech._escape._continuation)","<span style=\"font-style: italic\">escape continuation</span>",false],
["escaping",">web-server/templates.html#(part._.Escaping)","Escaping",false],
["essentials of programming languages language",">eopl/index.html","<span style=\"font-style: italic\">Essentials of Programming Languages</span> Language",false],
["etc",">scribble/Miscellaneous.html#(def._((lib._scribble/manual..rkt)._etc))",[0,[2,"etc"]],["scribble/manual"]],
["eternal",">foreign/foreign_pointer-funcs.html#(idx._(gentag._9._(lib._scribblings/foreign/foreign..scrbl)))",[7,"'eternal"],false],
["eu-currency-formats",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._eu-currency-formats))",[0,[2,"eu-currency-formats"]],["plot"]],
["eu-currency-scales",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._eu-currency-scales))",[0,[2,"eu-currency-scales"]],["plot"]],
["eval",">guide/eval.html",[0,[2,"eval"]],false],
["eval",">reference/eval.html#(def._((quote._~23~25kernel)._eval))",[0,[2,"eval"]],["racket/base","racket"]],
["eval",">r5rs-std/r5rs-Z-H-9.html#%_idx_600",[0,[2,"eval"]],["r5rs"]],
["eval",">r6rs-lib-std/r6rs-lib-Z-H-17.html#node_idx_1266",[0,[2,"eval"]],["rnrs/eval-6"]],
["eval com method",">mzcom/index.html#(idx._(gentag._1._(lib._mzcom/mzcom..scrbl)))",[[6,"Eval"]," COM method"],false],
["eval-compile-time-part-of-top-level",">syntax/toplevel.html#(def._((lib._syntax/toplevel..rkt)._eval-compile-time-part-of-top-level))",[0,[2,"eval-compile-time-part-of-top-level"]],["syntax/toplevel"]],
["eval-compile-time-part-of-top-level/compile",">syntax/toplevel.html#(def._((lib._syntax/toplevel..rkt)._eval-compile-time-part-of-top-level/compile))",[0,[2,"eval-compile-time-part-of-top-level/compile"]],["syntax/toplevel"]],
["eval-jit-enabled",">reference/eval.html#(def._((quote._~23~25kernel)._eval-jit-enabled))",[0,[2,"eval-jit-enabled"]],["racket/base","racket"]],
["eval-racket-string",">browser/index.html#(meth._(((lib._browser/browser..rkt)._hyper-text-mixin)._eval-racket-string))",[[0,[2,"eval-racket-string"]],[14,[" (method of ",[0,[2,"hyper-text-mixin"]],")"]]],["browser/browser","browser"]],
["eval-string",">mzlib/mzlib_string.html#(def._((lib._mzlib/string..rkt)._eval-string))",[0,[2,"eval-string"]],["mzlib/string"]],
["eval-syntax",">reference/eval.html#(def._((quote._~23~25kernel)._eval-syntax))",[0,[2,"eval-syntax"]],["racket/base","racket"]],
["eval:alts",">scribble/eval.html#(idx._(gentag._6._(lib._scribblings/scribble/scribble..scrbl)))",[0,"eval:alts"],false],
["eval:check",">scribble/eval.html#(idx._(gentag._7._(lib._scribblings/scribble/scribble..scrbl)))",[0,"eval:check"],false],
["eval:result",">scribble/eval.html#(idx._(gentag._8._(lib._scribblings/scribble/scribble..scrbl)))",[0,"eval:result"],false],
["eval:results",">scribble/eval.html#(idx._(gentag._9._(lib._scribblings/scribble/scribble..scrbl)))",[0,"eval:results"],false],
["evaluate-from-port",">tools/drracket_rep.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3arep~3atext~25)._evaluate-from-port))",[[0,[2,"evaluate-from-port"]],[14,[" (method of ",[0,[2,"drracket:rep:text%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["evaluating expressions",">drracket/interactions-window.html#(idx._(gentag._24._(lib._scribblings/drracket/drracket..scrbl)))","evaluating expressions",false],
["evaluation",">drracket/Keyboard_Shortcuts.html#(part._.Evaluation)","Evaluation",false],
["evaluation",">inside/Evaluation.html","Evaluation",false],
["evaluation and compilation",">reference/eval.html","Evaluation and Compilation",false],
["evaluation and examples",">scribble/eval.html","Evaluation and Examples",false],
["evaluation functions",">inside/Evaluation.html#(part._.Evaluation_.Functions)","Evaluation Functions",false],
["evaluation handler",">reference/eval.html#(tech._evaluation._handler)","<span style=\"font-style: italic\">evaluation handler</span>",false],
["evaluation model",">reference/eval-model.html","Evaluation Model",false],
["evaluation order",">reference/application.html","evaluation order",false],
["evaluation order and arity",">guide/application.html#(part._.Evaluation_.Order_and_.Arity)","Evaluation Order and Arity",false],
["evaluation thread",">mzcom/index.html#(part._.Evaluation_thread)","Evaluation thread",false],
["evaluator-alive?",">reference/Sandboxed_Evaluation.html#(def._((lib._racket/sandbox..rkt)._evaluator-alive~3f))",[0,[2,"evaluator-alive?"]],["racket/sandbox"]],
["evcase",">mzlib/mzlib_etc.html#(form._((lib._mzlib/etc..rkt)._evcase))",[0,[1,"evcase"]],["mzlib/etc"]],
["even?",">reference/number-types.html#(def._((quote._~23~25kernel)._even~3f))",[0,[2,"even?"]],["racket/base","racket"]],
["even?",">r5rs-std/r5rs-Z-H-9.html#%_idx_276",[0,[2,"even?"]],["r5rs"]],
["even?",">r6rs-std/r6rs-Z-H-14.html#node_idx_482",[0,[2,"even?"]],["rnrs/base-6"]],
["even?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._even~3f))",[0,[2,"even?"]],["lang/htdp-advanced"]],
["even?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._even~3f))",[0,[2,"even?"]],["lang/htdp-beginner"]],
["even?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._even~3f))",[0,[2,"even?"]],["lang/htdp-beginner-abbr"]],
["even?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._even~3f))",[0,[2,"even?"]],["lang/htdp-intermediate"]],
["even?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._even~3f))",[0,[2,"even?"]],["lang/htdp-intermediate-lambda"]],
["even?",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._even~3f))",[0,[2,"even?"]],["deinprogramm/DMdA-advanced"]],
["even?",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._even~3f))",[0,[2,"even?"]],["deinprogramm/DMdA-assignments"]],
["even?",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._even~3f))",[0,[2,"even?"]],["deinprogramm/DMdA-beginner"]],
["even?",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._even~3f))",[0,[2,"even?"]],["deinprogramm/DMdA-vanilla"]],
["even?",">plai/mutator.html#(form._((lib._plai/mutator..rkt)._even~3f))",[0,[2,"even?"]],["plai/mutator"]],
["event dispatch handler",">gui/windowing-overview.html#(tech._event._dispatch._handler)","<span style=\"font-style: italic\">event dispatch handler</span>",false],
["event dispatching and eventspaces",">gui/windowing-overview.html#(part._eventspaceinfo)","Event Dispatching and Eventspaces",false],
["event queue",">gui/windowing-overview.html#(tech._event._queue)","<span style=\"font-style: italic\">event queue</span>",false],
["event types and priorities",">gui/windowing-overview.html#(part._.Event_.Types_and_.Priorities)","Event Types and Priorities",false],
["event%",">gui/event_.html",[0,[2,"event%"]],["racket/gui/base","racket/gui"]],
["event-container<%>",">reference/distributed-places.html#(def._((lib._racket/place/distributed..rkt)._event-container~3c~25~3e))",[0,[2,"event-container<%>"]],["racket/place/distributed"]],
["event-dispatch-handler",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._event-dispatch-handler))",[0,[2,"event-dispatch-handler"]],["racket/gui/base","racket/gui"]],
["event-receiver",">frtime/index.html#(def._((lib._frtime/main..rkt)._event-receiver))",[0,[2,"event-receiver"]],["frtime"]],
["event?",">frtime/index.html#(def._((lib._frtime/main..rkt)._event~3f))",[0,[2,"event?"]],["frtime"]],
["events timer",">gui/windowing-overview.html#(idx._(gentag._12._(lib._scribblings/gui/gui..scrbl)))","events, timer",false],
["events explicitly queued",">gui/windowing-overview.html#(idx._(gentag._11._(lib._scribblings/gui/gui..scrbl)))","events, explicitly queued",false],
["events dispatching",">gui/windowing-overview.html#(idx._(gentag._9._(lib._scribblings/gui/gui..scrbl)))","events, dispatching",false],
["events delivery",">gui/windowing-overview.html#(idx._(gentag._7._(lib._scribblings/gui/gui..scrbl)))","events, delivery",false],
["events",">mzcom/index.html#(part._.Events)","Events",false],
["events",">reference/sync.html","Events",false],
["eventspace",">gui/windowing-overview.html#(tech._eventspace)","<span style=\"font-style: italic\">eventspace</span>",false],
["eventspace-event-evt",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._eventspace-event-evt))",[0,[2,"eventspace-event-evt"]],["racket/gui/base","racket/gui"]],
["eventspace-handler-thread",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._eventspace-handler-thread))",[0,[2,"eventspace-handler-thread"]],["racket/gui/base","racket/gui"]],
["eventspace-shutdown?",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._eventspace-shutdown~3f))",[0,[2,"eventspace-shutdown?"]],["racket/gui/base","racket/gui"]],
["eventspace?",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._eventspace~3f))",[0,[2,"eventspace?"]],["racket/gui/base","racket/gui"]],
["eventspaces",">gui/Windowing_Functions.html#(part._eventspace-funcs)","Eventspaces",false],
["eventspaces and threads",">gui/windowing-overview.html#(part._espacethreads)","Eventspaces and Threads",false],
["every",">srfi-std/srfi-1.html#every",[0,[2,"every"]],["srfi/1"]],
["every-seconds",">reference/distributed-places.html#(form._((lib._racket/place/distributed..rkt)._every-seconds))",[0,[1,"every-seconds"]],["racket/place/distributed"]],
["every?-ec",">srfi-std/srfi-42.html#every?-ec",[0,[1,"every?-ec"]],["srfi/42"]],
["evt?",">reference/sync.html#(def._((quote._~23~25kernel)._evt~3f))",[0,[2,"evt?"]],["racket/base","racket"]],
["exact",">r6rs-std/r6rs-Z-H-14.html#node_idx_462",[0,[2,"exact"]],["rnrs/base-6"]],
["exact",">reference/subprocess.html#(idx._(gentag._294._(lib._scribblings/reference/reference..scrbl)))",[7,"'exact"],false],
["exact number",">reference/numbers.html#(tech._exact._number)","<span style=\"font-style: italic\">exact number</span>",false],
["exact->inexact",">reference/number-types.html#(def._((quote._~23~25kernel)._exact-~3einexact))",[0,[2,"exact->inexact"]],["racket/base","racket"]],
["exact->inexact",">r5rs-std/r5rs-Z-H-9.html#%_idx_360",[0,[2,"exact->inexact"]],["r5rs"]],
["exact->inexact",">r6rs-lib-std/r6rs-lib-Z-H-20.html#node_idx_1286",[0,[2,"exact->inexact"]],["rnrs/r5rs-6"]],
["exact->inexact",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._exact-~3einexact))",[0,[2,"exact->inexact"]],["lang/htdp-advanced"]],
["exact->inexact",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._exact-~3einexact))",[0,[2,"exact->inexact"]],["lang/htdp-beginner"]],
["exact->inexact",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._exact-~3einexact))",[0,[2,"exact->inexact"]],["lang/htdp-beginner-abbr"]],
["exact->inexact",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._exact-~3einexact))",[0,[2,"exact->inexact"]],["lang/htdp-intermediate"]],
["exact->inexact",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._exact-~3einexact))",[0,[2,"exact->inexact"]],["lang/htdp-intermediate-lambda"]],
["exact->inexact",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._exact-~3einexact))",[0,[2,"exact->inexact"]],["deinprogramm/DMdA-advanced"]],
["exact->inexact",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._exact-~3einexact))",[0,[2,"exact->inexact"]],["deinprogramm/DMdA-assignments"]],
["exact->inexact",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._exact-~3einexact))",[0,[2,"exact->inexact"]],["deinprogramm/DMdA-beginner"]],
["exact->inexact",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._exact-~3einexact))",[0,[2,"exact->inexact"]],["deinprogramm/DMdA-vanilla"]],
["exact-ceiling",">reference/generic-numbers.html#(def._((lib._racket/math..rkt)._exact-ceiling))",[0,[2,"exact-ceiling"]],["racket/math","racket"]],
["exact-floor",">reference/generic-numbers.html#(def._((lib._racket/math..rkt)._exact-floor))",[0,[2,"exact-floor"]],["racket/math","racket"]],
["exact-integer",">syntax/Library_Syntax_Classes_and_Literal_Sets.html#(form._((lib._syntax/parse..rkt)._exact-integer))",[0,[1,"exact-integer"]],["syntax/parse"]],
["exact-integer-sqrt",">r6rs-std/r6rs-Z-H-14.html#node_idx_562",[0,[2,"exact-integer-sqrt"]],["rnrs/base-6"]],
["exact-integer?",">reference/number-types.html#(def._((quote._~23~25kernel)._exact-integer~3f))",[0,[2,"exact-integer?"]],["racket/base","racket"]],
["exact-nonnegative-integer",">syntax/Library_Syntax_Classes_and_Literal_Sets.html#(form._((lib._syntax/parse..rkt)._exact-nonnegative-integer))",[0,[1,"exact-nonnegative-integer"]],["syntax/parse"]],
["exact-nonnegative-integer",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Exact-.Nonnegative-.Integer))",[0,[1,"Exact-Nonnegative-Integer"]],["typed/racket/base","typed/racket"]],
["exact-nonnegative-integer?",">reference/number-types.html#(def._((quote._~23~25kernel)._exact-nonnegative-integer~3f))",[0,[2,"exact-nonnegative-integer?"]],["racket/base","racket"]],
["exact-number",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Exact-.Number))",[0,[1,"Exact-Number"]],["typed/racket/base","typed/racket"]],
["exact-positive-integer",">syntax/Library_Syntax_Classes_and_Literal_Sets.html#(form._((lib._syntax/parse..rkt)._exact-positive-integer))",[0,[1,"exact-positive-integer"]],["syntax/parse"]],
["exact-positive-integer",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Exact-.Positive-.Integer))",[0,[1,"Exact-Positive-Integer"]],["typed/racket/base","typed/racket"]],
["exact-positive-integer?",">reference/number-types.html#(def._((quote._~23~25kernel)._exact-positive-integer~3f))",[0,[2,"exact-positive-integer?"]],["racket/base","racket"]],
["exact-rational",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Exact-.Rational))",[0,[1,"Exact-Rational"]],["typed/racket/base","typed/racket"]],
["exact-round",">reference/generic-numbers.html#(def._((lib._racket/math..rkt)._exact-round))",[0,[2,"exact-round"]],["racket/math","racket"]],
["exact-truncate",">reference/generic-numbers.html#(def._((lib._racket/math..rkt)._exact-truncate))",[0,[2,"exact-truncate"]],["racket/math","racket"]],
["exact?",">reference/number-types.html#(def._((quote._~23~25kernel)._exact~3f))",[0,[2,"exact?"]],["racket/base","racket"]],
["exact?",">r5rs-std/r5rs-Z-H-9.html#%_idx_254",[0,[2,"exact?"]],["r5rs"]],
["exact?",">r6rs-std/r6rs-Z-H-14.html#node_idx_456",[0,[2,"exact?"]],["rnrs/base-6"]],
["exact?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._exact~3f))",[0,[2,"exact?"]],["lang/htdp-advanced"]],
["exact?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._exact~3f))",[0,[2,"exact?"]],["lang/htdp-beginner"]],
["exact?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._exact~3f))",[0,[2,"exact?"]],["lang/htdp-beginner-abbr"]],
["exact?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._exact~3f))",[0,[2,"exact?"]],["lang/htdp-intermediate"]],
["exact?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._exact~3f))",[0,[2,"exact?"]],["lang/htdp-intermediate-lambda"]],
["exact?",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._exact~3f))",[0,[2,"exact?"]],["deinprogramm/DMdA-advanced"]],
["exact?",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._exact~3f))",[0,[2,"exact?"]],["deinprogramm/DMdA-assignments"]],
["exact?",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._exact~3f))",[0,[2,"exact?"]],["deinprogramm/DMdA-beginner"]],
["exact?",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._exact~3f))",[0,[2,"exact?"]],["deinprogramm/DMdA-vanilla"]],
["example",">html/index.html#(part._.Example)","Example",false],
["example",">net/websocket.html#(part._.Example)","Example",false],
["example session",">net/pop3.html#(part._.Example_.Session)","Example Session",false],
["examples",">turtles/Traditional_Turtles.html#(part._.Examples)","Examples",false],
["examples",">turtles/Value_Turtles.html#(part._value-examples)","Examples",false],
["examples",">net/cookie.html#(part._cookie-examples)","Examples",false],
["examples",">scribble/reference-style.html#(part._examples-style)","Examples",false],
["examples",">syntax/stxparse-examples.html","Examples",false],
["examples",">unstable/Automata__Compiling_State_Machines.html#(part._re-ex)","Examples",false],
["examples",">web-server/run.html#(part._.Examples)","Examples",false],
["examples",">scribble/eval.html#(form._((lib._scribble/eval..rkt)._examples))",[0,[1,"examples"]],["scribble/eval"]],
["examples using the gui toolbox",">scriblib/gui-eval.html","Examples Using the GUI Toolbox",false],
["except",">reference/creatingunits.html#(form._((lib._mzlib/unit..rkt)._except))",[0,[1,"except"]],["racket/unit","racket"]],
["except-in",">reference/require.html#(form._((lib._racket/private/base..rkt)._except-in))",[0,[1,"except-in"]],["racket/base","racket"]],
["except-out",">reference/require.html#(form._((lib._racket/private/base..rkt)._except-out))",[0,[1,"except-out"]],["racket/base","racket"]],
["exception",">guide/exns.html#(tech._exception)","<span style=\"font-style: italic\">exception</span>",false],
["exception functions",">inside/exceptions.html#(part._.Exception_.Functions)","Exception Functions",false],
["exception handler",">reference/eval-model.html#(tech._exception._handler)","<span style=\"font-style: italic\">exception handler</span>",false],
["exceptions",">net/nntp.html#(part._.Exceptions)","Exceptions",false],
["exceptions",">net/mime.html#(part._mime-exns)","Exceptions",false],
["exceptions",">net/pop3.html#(part._pop3-exns)","Exceptions",false],
["exceptions",">net/qp.html#(part._qp-exn)","Exceptions",false],
["exceptions",">guide/exns.html","Exceptions",false],
["exceptions",">reference/eval-model.html#(part._exn-model)","Exceptions",false],
["exceptions",">reference/exns.html","Exceptions",false],
["exceptions",">reference/eval-model.html#(tech._exception)","<span style=\"font-style: italic\">Exceptions</span>",false],
["exceptions and control",">guide/control.html","Exceptions and Control",false],
["exceptions and escape continuations",">inside/exceptions.html","Exceptions and Escape Continuations",false],
["exec",">scribble/doc-strings.html#(def._((lib._scribble/manual..rkt)._exec))",[0,[2,"exec"]],["scribble/manual"]],
["exec-file",">reference/Filesystem.html#(idx._(gentag._285._(lib._scribblings/reference/reference..scrbl)))",[7,"'exec-file"],false],
["executable creation signature",">raco/exe.html#(part._.Executable_.Creation_.Signature)","Executable Creation Signature",false],
["executable creation unit",">raco/exe.html#(part._.Executable_.Creation_.Unit)","Executable Creation Unit",false],
["executable-yield-handler",">reference/Exiting.html#(def._((quote._~23~25kernel)._executable-yield-handler))",[0,[2,"executable-yield-handler"]],["racket/base","racket"]],
["execute",">reference/securityguards.html#(idx._(gentag._229._(lib._scribblings/reference/reference..scrbl)))",[7,"'execute"],false],
["execute",">reference/Filesystem.html#(idx._(gentag._292._(lib._scribblings/reference/reference..scrbl)))",[7,"'execute"],false],
["execute",">gui/key-event_.html#(idx._(gentag._59._(lib._scribblings/gui/gui..scrbl)))",[7,"'execute"],false],
["execute-callback",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aframe~25)._execute-callback))",[[0,[2,"execute-callback"]],[14,[" (method of ",[0,[2,"drracket:unit:frame%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["execute-counts-enabled",">errortrace/using-errortrace.html#(def._((lib._errortrace/errortrace-lib..rkt)._execute-counts-enabled))",[0,[2,"execute-counts-enabled"]],["errortrace"]],
["execution timeline",">reference/futures-visualizer.html#(part._future-visualizer-timeline)","Execution Timeline",false],
["execution timeline",">reference/futures-visualizer.html#(tech._execution._timeline)","<span style=\"font-style: italic\">execution timeline</span>",false],
["exists",">r6rs-lib-std/r6rs-lib-Z-H-4.html#node_idx_206",[0,[2,"exists"]],["rnrs/lists-6"]],
["exists",">reference/securityguards.html#(idx._(gentag._231._(lib._scribblings/reference/reference..scrbl)))",[7,"'exists"],false],
["exists contracts and predicates",">guide/contracts-gotchas.html#(part._contracts-exists-gotcha)","Exists Contracts and Predicates",false],
["exists-binding?",">continue/index.html#(def._((lib._web-server/servlet..rkt)._exists-binding~3f))",[0,[2,"exists-binding?"]],[]],
["exists-binding?",">web-server/http.html#(def._((lib._web-server/http/bindings..rkt)._exists-binding~3f))",[0,[2,"exists-binding?"]],["web-server/http/bindings"]],
["exit",">framework/Exit.html","Exit",false],
["exit",">reference/Exiting.html#(def._((quote._~23~25kernel)._exit))",[0,[2,"exit"]],["racket/base","racket"]],
["exit",">r6rs-lib-std/r6rs-lib-Z-H-11.html#node_idx_846",[0,[2,"exit"]],["rnrs/programs-6"]],
["exit",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._exit))",[0,[2,"exit"]],["lang/htdp-advanced"]],
["exit",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._exit))",[0,[2,"exit"]],["lang/htdp-beginner"]],
["exit",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._exit))",[0,[2,"exit"]],["lang/htdp-beginner-abbr"]],
["exit",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._exit))",[0,[2,"exit"]],["lang/htdp-intermediate"]],
["exit",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._exit))",[0,[2,"exit"]],["lang/htdp-intermediate-lambda"]],
["exit handler",">reference/Exiting.html#(tech._exit._handler)","<span style=\"font-style: italic\">exit handler</span>",false],
["exit status",">reference/running-sa.html#(part._exit-status)","Exit Status",false],
["exit-handler",">reference/Exiting.html#(def._((quote._~23~25kernel)._exit-handler))",[0,[2,"exit-handler"]],["racket/base","racket"]],
["exit:can-exit?",">framework/Exit.html#(def._((lib._framework/main..rkt)._exit~3acan-exit~3f))",[0,[2,"exit:can-exit?"]],["framework"]],
["exit:exit",">framework/Exit.html#(def._((lib._framework/main..rkt)._exit~3aexit))",[0,[2,"exit:exit"]],["framework"]],
["exit:exiting?",">framework/Exit.html#(def._((lib._framework/main..rkt)._exit~3aexiting~3f))",[0,[2,"exit:exiting?"]],["framework"]],
["exit:insert-can?-callback",">framework/Exit.html#(def._((lib._framework/main..rkt)._exit~3ainsert-can~3f-callback))",[0,[2,"exit:insert-can?-callback"]],["framework"]],
["exit:insert-on-callback",">framework/Exit.html#(def._((lib._framework/main..rkt)._exit~3ainsert-on-callback))",[0,[2,"exit:insert-on-callback"]],["framework"]],
["exit:on-exit",">framework/Exit.html#(def._((lib._framework/main..rkt)._exit~3aon-exit))",[0,[2,"exit:on-exit"]],["framework"]],
["exit:set-exiting",">framework/Exit.html#(def._((lib._framework/main..rkt)._exit~3aset-exiting))",[0,[2,"exit:set-exiting"]],["framework"]],
["exit:user-oks-exit",">framework/Exit.html#(def._((lib._framework/main..rkt)._exit~3auser-oks-exit))",[0,[2,"exit:user-oks-exit"]],["framework"]],
["exiting",">reference/Exiting.html","Exiting",false],
["exn",">reference/exns.html#(def._((lib._racket/private/base..rkt)._exn))",[0,[2,"exn"]],["racket/base","racket"]],
["exn->string",">web-server-internal/misc-util.html#(def._((lib._web-server/private/util..rkt)._exn-~3estring))",[0,[2,"exn->string"]],["web-server/private/util"]],
["exn-continuation-marks",">reference/exns.html#(def._((quote._~23~25kernel)._exn-continuation-marks))",[0,[2,"exn-continuation-marks"]],["racket/base","racket"]],
["exn-message",">reference/exns.html#(def._((quote._~23~25kernel)._exn-message))",[0,[2,"exn-message"]],["racket/base","racket"]],
["exn:break",">reference/exns.html#(def._((lib._racket/private/base..rkt)._exn~3abreak))",[0,[2,"exn:break"]],["racket/base","racket"]],
["exn:break-continuation",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3abreak-continuation))",[0,[2,"exn:break-continuation"]],["racket/base","racket"]],
["exn:break?",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3abreak~3f))",[0,[2,"exn:break?"]],["racket/base","racket"]],
["exn:cancelled",">browser/index.html#(def._((lib._browser/browser..rkt)._exn~3acancelled))",[0,[2,"exn:cancelled"]],["browser/browser","browser"]],
["exn:cancelled?",">browser/index.html#(def._((lib._browser/browser..rkt)._exn~3acancelled~3f))",[0,[2,"exn:cancelled?"]],["browser/browser","browser"]],
["exn:dispatcher",">web-server-internal/dispatch.html#(def._((lib._web-server/dispatchers/dispatch..rkt)._exn~3adispatcher))",[0,[2,"exn:dispatcher"]],["web-server/dispatchers/dispatch"]],
["exn:dispatcher?",">web-server-internal/dispatch.html#(def._((lib._web-server/dispatchers/dispatch..rkt)._exn~3adispatcher~3f))",[0,[2,"exn:dispatcher?"]],["web-server/dispatchers/dispatch"]],
["exn:fail",">reference/exns.html#(def._((lib._racket/private/base..rkt)._exn~3afail))",[0,[2,"exn:fail"]],["racket/base","racket"]],
["exn:fail:contract",">reference/exns.html#(def._((lib._racket/private/base..rkt)._exn~3afail~3acontract))",[0,[2,"exn:fail:contract"]],["racket/base","racket"]],
["exn:fail:contract:arity",">reference/exns.html#(def._((lib._racket/private/base..rkt)._exn~3afail~3acontract~3aarity))",[0,[2,"exn:fail:contract:arity"]],["racket/base","racket"]],
["exn:fail:contract:arity?",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3acontract~3aarity~3f))",[0,[2,"exn:fail:contract:arity?"]],["racket/base","racket"]],
["exn:fail:contract:blame",">reference/Building_New_Contract_Combinators.html#(def._((lib._racket/contract/private/blame..rkt)._exn~3afail~3acontract~3ablame))",[0,[2,"exn:fail:contract:blame"]],["racket/contract/combinator","racket/contract","racket"]],
["exn:fail:contract:blame-object",">reference/Building_New_Contract_Combinators.html#(def._((lib._racket/contract/private/blame..rkt)._exn~3afail~3acontract~3ablame-object))",[0,[2,"exn:fail:contract:blame-object"]],["racket/contract/combinator","racket/contract","racket"]],
["exn:fail:contract:blame?",">reference/Building_New_Contract_Combinators.html#(def._((lib._racket/contract/private/blame..rkt)._exn~3afail~3acontract~3ablame~3f))",[0,[2,"exn:fail:contract:blame?"]],["racket/contract/combinator","racket/contract","racket"]],
["exn:fail:contract:continuation",">reference/exns.html#(def._((lib._racket/private/base..rkt)._exn~3afail~3acontract~3acontinuation))",[0,[2,"exn:fail:contract:continuation"]],["racket/base","racket"]],
["exn:fail:contract:continuation?",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3acontract~3acontinuation~3f))",[0,[2,"exn:fail:contract:continuation?"]],["racket/base","racket"]],
["exn:fail:contract:divide-by-zero",">reference/exns.html#(def._((lib._racket/private/base..rkt)._exn~3afail~3acontract~3adivide-by-zero))",[0,[2,"exn:fail:contract:divide-by-zero"]],["racket/base","racket"]],
["exn:fail:contract:divide-by-zero?",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3acontract~3adivide-by-zero~3f))",[0,[2,"exn:fail:contract:divide-by-zero?"]],["racket/base","racket"]],
["exn:fail:contract:non-fixnum-result",">reference/exns.html#(def._((lib._racket/private/base..rkt)._exn~3afail~3acontract~3anon-fixnum-result))",[0,[2,"exn:fail:contract:non-fixnum-result"]],["racket/base","racket"]],
["exn:fail:contract:non-fixnum-result?",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3acontract~3anon-fixnum-result~3f))",[0,[2,"exn:fail:contract:non-fixnum-result?"]],["racket/base","racket"]],
["exn:fail:contract:variable",">reference/exns.html#(def._((lib._racket/private/base..rkt)._exn~3afail~3acontract~3avariable))",[0,[2,"exn:fail:contract:variable"]],["racket/base","racket"]],
["exn:fail:contract:variable-id",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3acontract~3avariable-id))",[0,[2,"exn:fail:contract:variable-id"]],["racket/base","racket"]],
["exn:fail:contract:variable?",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3acontract~3avariable~3f))",[0,[2,"exn:fail:contract:variable?"]],["racket/base","racket"]],
["exn:fail:contract?",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3acontract~3f))",[0,[2,"exn:fail:contract?"]],["racket/base","racket"]],
["exn:fail:filesystem",">reference/exns.html#(def._((lib._racket/private/base..rkt)._exn~3afail~3afilesystem))",[0,[2,"exn:fail:filesystem"]],["racket/base","racket"]],
["exn:fail:filesystem:exists",">reference/exns.html#(def._((lib._racket/private/base..rkt)._exn~3afail~3afilesystem~3aexists))",[0,[2,"exn:fail:filesystem:exists"]],["racket/base","racket"]],
["exn:fail:filesystem:exists?",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3afilesystem~3aexists~3f))",[0,[2,"exn:fail:filesystem:exists?"]],["racket/base","racket"]],
["exn:fail:filesystem:version",">reference/exns.html#(def._((lib._racket/private/base..rkt)._exn~3afail~3afilesystem~3aversion))",[0,[2,"exn:fail:filesystem:version"]],["racket/base","racket"]],
["exn:fail:filesystem:version?",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3afilesystem~3aversion~3f))",[0,[2,"exn:fail:filesystem:version?"]],["racket/base","racket"]],
["exn:fail:filesystem?",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3afilesystem~3f))",[0,[2,"exn:fail:filesystem?"]],["racket/base","racket"]],
["exn:fail:make",">make/make.html#(def._((lib._make/main..rkt)._exn~3afail~3amake))",[0,[2,"exn:fail:make"]],["make"]],
["exn:fail:make-orig-exn",">make/make.html#(def._((lib._make/main..rkt)._exn~3afail~3amake-orig-exn))",[0,[2,"exn:fail:make-orig-exn"]],["make"]],
["exn:fail:make-targets",">make/make.html#(def._((lib._make/main..rkt)._exn~3afail~3amake-targets))",[0,[2,"exn:fail:make-targets"]],["make"]],
["exn:fail:make?",">make/make.html#(def._((lib._make/main..rkt)._exn~3afail~3amake~3f))",[0,[2,"exn:fail:make?"]],["make"]],
["exn:fail:network",">reference/exns.html#(def._((lib._racket/private/base..rkt)._exn~3afail~3anetwork))",[0,[2,"exn:fail:network"]],["racket/base","racket"]],
["exn:fail:network?",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3anetwork~3f))",[0,[2,"exn:fail:network?"]],["racket/base","racket"]],
["exn:fail:object",">reference/objectutils.html#(def._((lib._racket/private/class-internal..rkt)._exn~3afail~3aobject))",[0,[2,"exn:fail:object"]],["racket/class","racket"]],
["exn:fail:object?",">reference/objectutils.html#(def._((lib._racket/private/class-internal..rkt)._exn~3afail~3aobject~3f))",[0,[2,"exn:fail:object?"]],["racket/class","racket"]],
["exn:fail:out-of-memory",">reference/exns.html#(def._((lib._racket/private/base..rkt)._exn~3afail~3aout-of-memory))",[0,[2,"exn:fail:out-of-memory"]],["racket/base","racket"]],
["exn:fail:out-of-memory?",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3aout-of-memory~3f))",[0,[2,"exn:fail:out-of-memory?"]],["racket/base","racket"]],
["exn:fail:planet",">planet/Utility_Libraries.html#(def._((lib._planet/util..rkt)._exn~3afail~3aplanet))",[0,[2,"exn:fail:planet"]],["planet/util"]],
["exn:fail:planet-continuation-marks",">planet/Utility_Libraries.html#(def._((lib._planet/util..rkt)._exn~3afail~3aplanet-continuation-marks))",[0,[2,"exn:fail:planet-continuation-marks"]],["planet/util"]],
["exn:fail:planet-message",">planet/Utility_Libraries.html#(def._((lib._planet/util..rkt)._exn~3afail~3aplanet-message))",[0,[2,"exn:fail:planet-message"]],["planet/util"]],
["exn:fail:planet?",">planet/Utility_Libraries.html#(def._((lib._planet/util..rkt)._exn~3afail~3aplanet~3f))",[0,[2,"exn:fail:planet?"]],["planet/util"]],
["exn:fail:read",">reference/exns.html#(def._((lib._racket/private/base..rkt)._exn~3afail~3aread))",[0,[2,"exn:fail:read"]],["racket/base","racket"]],
["exn:fail:read-srclocs",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3aread-srclocs))",[0,[2,"exn:fail:read-srclocs"]],["racket/base","racket"]],
["exn:fail:read:eof",">reference/exns.html#(def._((lib._racket/private/base..rkt)._exn~3afail~3aread~3aeof))",[0,[2,"exn:fail:read:eof"]],["racket/base","racket"]],
["exn:fail:read:eof?",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3aread~3aeof~3f))",[0,[2,"exn:fail:read:eof?"]],["racket/base","racket"]],
["exn:fail:read:non-char",">reference/exns.html#(def._((lib._racket/private/base..rkt)._exn~3afail~3aread~3anon-char))",[0,[2,"exn:fail:read:non-char"]],["racket/base","racket"]],
["exn:fail:read:non-char?",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3aread~3anon-char~3f))",[0,[2,"exn:fail:read:non-char?"]],["racket/base","racket"]],
["exn:fail:read?",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3aread~3f))",[0,[2,"exn:fail:read?"]],["racket/base","racket"]],
["exn:fail:redex:generation-failure?",">redex/The_Redex_Reference.html#(def._((lib._redex/reduction-semantics..rkt)._exn~3afail~3aredex~3ageneration-failure~3f))",[0,[2,"exn:fail:redex:generation-failure?"]],["redex/reduction-semantics","redex"]],
["exn:fail:redex:test",">redex/The_Redex_Reference.html#(def._((lib._redex/reduction-semantics..rkt)._exn~3afail~3aredex~3atest))",[0,[2,"exn:fail:redex:test"]],["redex/reduction-semantics","redex"]],
["exn:fail:redex:test-source",">redex/The_Redex_Reference.html#(def._((lib._redex/reduction-semantics..rkt)._exn~3afail~3aredex~3atest-source))",[0,[2,"exn:fail:redex:test-source"]],["redex/reduction-semantics","redex"]],
["exn:fail:redex:test-term",">redex/The_Redex_Reference.html#(def._((lib._redex/reduction-semantics..rkt)._exn~3afail~3aredex~3atest-term))",[0,[2,"exn:fail:redex:test-term"]],["redex/reduction-semantics","redex"]],
["exn:fail:redex:test?",">redex/The_Redex_Reference.html#(def._((lib._redex/reduction-semantics..rkt)._exn~3afail~3aredex~3atest~3f))",[0,[2,"exn:fail:redex:test?"]],["redex/reduction-semantics","redex"]],
["exn:fail:redex?",">redex/The_Redex_Reference.html#(def._((lib._redex/reduction-semantics..rkt)._exn~3afail~3aredex~3f))",[0,[2,"exn:fail:redex?"]],["redex/reduction-semantics","redex"]],
["exn:fail:resource-resource",">reference/Sandboxed_Evaluation.html#(def._((lib._racket/sandbox..rkt)._exn~3afail~3aresource-resource))",[0,[2,"exn:fail:resource-resource"]],["racket/sandbox"]],
["exn:fail:resource?",">reference/Sandboxed_Evaluation.html#(def._((lib._racket/sandbox..rkt)._exn~3afail~3aresource~3f))",[0,[2,"exn:fail:resource?"]],["racket/sandbox"]],
["exn:fail:sandbox-terminated-reason",">reference/Sandboxed_Evaluation.html#(def._((lib._racket/sandbox..rkt)._exn~3afail~3asandbox-terminated-reason))",[0,[2,"exn:fail:sandbox-terminated-reason"]],["racket/sandbox"]],
["exn:fail:sandbox-terminated?",">reference/Sandboxed_Evaluation.html#(def._((lib._racket/sandbox..rkt)._exn~3afail~3asandbox-terminated~3f))",[0,[2,"exn:fail:sandbox-terminated?"]],["racket/sandbox"]],
["exn:fail:servlet-manager:no-continuation",">web-server/servlet.html#(def._((lib._web-server/managers/manager..rkt)._exn~3afail~3aservlet-manager~3ano-continuation))",[0,[2,"exn:fail:servlet-manager:no-continuation"]],["web-server/managers/manager"]],
["exn:fail:servlet-manager:no-continuation-expiration-handler",">web-server/servlet.html#(def._((lib._web-server/managers/manager..rkt)._exn~3afail~3aservlet-manager~3ano-continuation-expiration-handler))",[0,[2,"exn:fail:servlet-manager:no-continuation-expiration-handler"]],["web-server/managers/manager"]],
["exn:fail:servlet-manager:no-continuation?",">web-server/servlet.html#(def._((lib._web-server/managers/manager..rkt)._exn~3afail~3aservlet-manager~3ano-continuation~3f))",[0,[2,"exn:fail:servlet-manager:no-continuation?"]],["web-server/managers/manager"]],
["exn:fail:servlet-manager:no-instance",">web-server/servlet.html#(def._((lib._web-server/managers/manager..rkt)._exn~3afail~3aservlet-manager~3ano-instance))",[0,[2,"exn:fail:servlet-manager:no-instance"]],["web-server/managers/manager"]],
["exn:fail:servlet-manager:no-instance-expiration-handler",">web-server/servlet.html#(def._((lib._web-server/managers/manager..rkt)._exn~3afail~3aservlet-manager~3ano-instance-expiration-handler))",[0,[2,"exn:fail:servlet-manager:no-instance-expiration-handler"]],["web-server/managers/manager"]],
["exn:fail:servlet-manager:no-instance?",">web-server/servlet.html#(def._((lib._web-server/managers/manager..rkt)._exn~3afail~3aservlet-manager~3ano-instance~3f))",[0,[2,"exn:fail:servlet-manager:no-instance?"]],["web-server/managers/manager"]],
["exn:fail:sql",">db/query-api.html#(def._((lib._db/base..rkt)._exn~3afail~3asql))",[0,[2,"exn:fail:sql"]],["db","db/base"]],
["exn:fail:sql-info",">db/query-api.html#(def._((lib._db/base..rkt)._exn~3afail~3asql-info))",[0,[2,"exn:fail:sql-info"]],["db","db/base"]],
["exn:fail:sql-sqlstate",">db/query-api.html#(def._((lib._db/base..rkt)._exn~3afail~3asql-sqlstate))",[0,[2,"exn:fail:sql-sqlstate"]],["db","db/base"]],
["exn:fail:sql?",">db/query-api.html#(def._((lib._db/base..rkt)._exn~3afail~3asql~3f))",[0,[2,"exn:fail:sql?"]],["db","db/base"]],
["exn:fail:syntax",">reference/exns.html#(def._((lib._racket/private/base..rkt)._exn~3afail~3asyntax))",[0,[2,"exn:fail:syntax"]],["racket/base","racket"]],
["exn:fail:syntax-exprs",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3asyntax-exprs))",[0,[2,"exn:fail:syntax-exprs"]],["racket/base","racket"]],
["exn:fail:syntax:unbound",">reference/exns.html#(def._((lib._racket/private/base..rkt)._exn~3afail~3asyntax~3aunbound))",[0,[2,"exn:fail:syntax:unbound"]],["racket/base","racket"]],
["exn:fail:syntax:unbound?",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3asyntax~3aunbound~3f))",[0,[2,"exn:fail:syntax:unbound?"]],["racket/base","racket"]],
["exn:fail:syntax?",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3asyntax~3f))",[0,[2,"exn:fail:syntax?"]],["racket/base","racket"]],
["exn:fail:unsupported",">reference/exns.html#(def._((lib._racket/private/base..rkt)._exn~3afail~3aunsupported))",[0,[2,"exn:fail:unsupported"]],["racket/base","racket"]],
["exn:fail:unsupported?",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3aunsupported~3f))",[0,[2,"exn:fail:unsupported?"]],["racket/base","racket"]],
["exn:fail:user",">reference/exns.html#(def._((lib._racket/private/base..rkt)._exn~3afail~3auser))",[0,[2,"exn:fail:user"]],["racket/base","racket"]],
["exn:fail:user?",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3auser~3f))",[0,[2,"exn:fail:user?"]],["racket/base","racket"]],
["exn:fail:wish",">htdp/index.html#(def._((lib._test-engine/racket-tests..rkt)._exn~3afail~3awish))",[0,[2,"exn:fail:wish"]],["htdp/testing"]],
["exn:fail?",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3f))",[0,[2,"exn:fail?"]],["racket/base","racket"]],
["exn:file-saved-instead",">browser/index.html#(def._((lib._browser/browser..rkt)._exn~3afile-saved-instead))",[0,[2,"exn:file-saved-instead"]],["browser/browser","browser"]],
["exn:file-saved-instead-pathname",">browser/index.html#(def._((lib._browser/browser..rkt)._exn~3afile-saved-instead-pathname))",[0,[2,"exn:file-saved-instead-pathname"]],["browser/browser","browser"]],
["exn:file-saved-instead?",">browser/index.html#(def._((lib._browser/browser..rkt)._exn~3afile-saved-instead~3f))",[0,[2,"exn:file-saved-instead?"]],["browser/browser","browser"]],
["exn:get-module-code",">syntax/module-helpers.html#(def._((lib._syntax/modcode..rkt)._exn~3aget-module-code))",[0,[2,"exn:get-module-code"]],["syntax/modcode"]],
["exn:get-module-code-path",">syntax/module-helpers.html#(def._((lib._syntax/modcode..rkt)._exn~3aget-module-code-path))",[0,[2,"exn:get-module-code-path"]],["syntax/modcode"]],
["exn:get-module-code?",">syntax/module-helpers.html#(def._((lib._syntax/modcode..rkt)._exn~3aget-module-code~3f))",[0,[2,"exn:get-module-code?"]],["syntax/modcode"]],
["exn:invalid-xexpr",">xml/index.html#(def._((lib._xml/main..rkt)._exn~3ainvalid-xexpr))",[0,[2,"exn:invalid-xexpr"]],["xml"]],
["exn:invalid-xexpr-code",">xml/index.html#(def._((lib._xml/main..rkt)._exn~3ainvalid-xexpr-code))",[0,[2,"exn:invalid-xexpr-code"]],["xml"]],
["exn:invalid-xexpr?",">xml/index.html#(def._((lib._xml/main..rkt)._exn~3ainvalid-xexpr~3f))",[0,[2,"exn:invalid-xexpr?"]],["xml"]],
["exn:make-unknown-preference",">framework/Preferences__Textual.html#(def._((lib._framework/preferences..rkt)._exn~3amake-unknown-preference))",[0,[2,"exn:make-unknown-preference"]],["framework/preferences","framework"]],
["exn:misc:match?",">reference/match.html#(def._((lib._racket/match..rkt)._exn~3amisc~3amatch~3f))",[0,[2,"exn:misc:match?"]],["racket/match","racket"]],
["exn:srclocs-accessor",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3asrclocs-accessor))",[0,[2,"exn:srclocs-accessor"]],["racket/base","racket"]],
["exn:srclocs?",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3asrclocs~3f))",[0,[2,"exn:srclocs?"]],["racket/base","racket"]],
["exn:struct:unknown-preference",">framework/Preferences__Textual.html#(def._((lib._framework/preferences..rkt)._exn~3astruct~3aunknown-preference))",[0,[2,"exn:struct:unknown-preference"]],["framework/preferences","framework"]],
["exn:test",">rackunit/internals.html#(def._((lib._rackunit/main..rkt)._exn~3atest))",[0,[2,"exn:test"]],["rackunit"]],
["exn:test:check",">rackunit/internals.html#(def._((lib._rackunit/main..rkt)._exn~3atest~3acheck))",[0,[2,"exn:test:check"]],["rackunit"]],
["exn:test:check-stack",">rackunit/internals.html#(def._((lib._rackunit/main..rkt)._exn~3atest~3acheck-stack))",[0,[2,"exn:test:check-stack"]],["rackunit"]],
["exn:test:check?",">rackunit/internals.html#(def._((lib._rackunit/main..rkt)._exn~3atest~3acheck~3f))",[0,[2,"exn:test:check?"]],["rackunit"]],
["exn:test?",">rackunit/internals.html#(def._((lib._rackunit/main..rkt)._exn~3atest~3f))",[0,[2,"exn:test?"]],["rackunit"]],
["exn:unknown-preference?",">framework/Preferences__Textual.html#(def._((lib._framework/preferences..rkt)._exn~3aunknown-preference~3f))",[0,[2,"exn:unknown-preference?"]],["framework/preferences","framework"]],
["exn:xml",">xml/index.html#(def._((lib._xml/main..rkt)._exn~3axml))",[0,[2,"exn:xml"]],["xml"]],
["exn:xml?",">xml/index.html#(def._((lib._xml/main..rkt)._exn~3axml~3f))",[0,[2,"exn:xml?"]],["xml"]],
["exn?",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3f))",[0,[2,"exn?"]],["racket/base","racket"]],
["exp",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._exp))",[0,[2,"exp"]],["racket/base","racket"]],
["exp",">r5rs-std/r5rs-Z-H-9.html#%_idx_326",[0,[2,"exp"]],["r5rs"]],
["exp",">r6rs-std/r6rs-Z-H-14.html#node_idx_540",[0,[2,"exp"]],["rnrs/base-6"]],
["exp",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._exp))",[0,[2,"exp"]],["lang/htdp-advanced"]],
["exp",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._exp))",[0,[2,"exp"]],["lang/htdp-beginner"]],
["exp",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._exp))",[0,[2,"exp"]],["lang/htdp-beginner-abbr"]],
["exp",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._exp))",[0,[2,"exp"]],["lang/htdp-intermediate"]],
["exp",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._exp))",[0,[2,"exp"]],["lang/htdp-intermediate-lambda"]],
["exp",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._exp))",[0,[2,"exp"]],["deinprogramm/DMdA-advanced"]],
["exp",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._exp))",[0,[2,"exp"]],["deinprogramm/DMdA-assignments"]],
["exp",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._exp))",[0,[2,"exp"]],["deinprogramm/DMdA-beginner"]],
["exp",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._exp))",[0,[2,"exp"]],["deinprogramm/DMdA-vanilla"]],
["expand",">reference/Expanding_Top-Level_Forms.html#(def._((quote._~23~25kernel)._expand))",[0,[2,"expand"]],["racket/base","racket"]],
["expand",">reference/syntax-model.html#(tech._expand)","<span style=\"font-style: italic\">expand</span>",false],
["expand-export",">reference/stxtrans.html#(def._((lib._racket/provide-transform..rkt)._expand-export))",[0,[2,"expand-export"]],["racket/provide-transform"]],
["expand-for-compile-variant",">dynext/Compilation.html#(def._((lib._dynext/compile..rkt)._expand-for-compile-variant))",[0,[2,"expand-for-compile-variant"]],["dynext/compile"]],
["expand-for-link-variant",">dynext/Linking.html#(def._((lib._dynext/link..rkt)._expand-for-link-variant))",[0,[2,"expand-for-link-variant"]],["dynext/link"]],
["expand-import",">reference/stxtrans.html#(def._((lib._racket/require-transform..rkt)._expand-import))",[0,[2,"expand-import"]],["racket/require-transform"]],
["expand-module/step",">macro-debugger/index.html#(def._((lib._macro-debugger/stepper..rkt)._expand-module/step))",[0,[2,"expand-module/step"]],["macro-debugger/stepper"]],
["expand-once",">reference/Expanding_Top-Level_Forms.html#(def._((quote._~23~25kernel)._expand-once))",[0,[2,"expand-once"]],["racket/base","racket"]],
["expand-only",">macro-debugger/index.html#(def._((lib._macro-debugger/expand..rkt)._expand-only))",[0,[2,"expand-only"]],["macro-debugger/expand"]],
["expand-path",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..rkt)._expand-path))",[0,[2,"expand-path"]],["mzscheme"]],
["expand-syntax",">reference/Expanding_Top-Level_Forms.html#(def._((quote._~23~25kernel)._expand-syntax))",[0,[2,"expand-syntax"]],["racket/base","racket"]],
["expand-syntax-once",">reference/Expanding_Top-Level_Forms.html#(def._((quote._~23~25kernel)._expand-syntax-once))",[0,[2,"expand-syntax-once"]],["racket/base","racket"]],
["expand-syntax-to-top-form",">reference/Expanding_Top-Level_Forms.html#(def._((quote._~23~25kernel)._expand-syntax-to-top-form))",[0,[2,"expand-syntax-to-top-form"]],["racket/base","racket"]],
["expand-syntax-top-level-with-compile-time-evals",">syntax/toplevel.html#(def._((lib._syntax/toplevel..rkt)._expand-syntax-top-level-with-compile-time-evals))",[0,[2,"expand-syntax-top-level-with-compile-time-evals"]],["syntax/toplevel"]],
["expand-syntax-top-level-with-compile-time-evals/flatten",">syntax/toplevel.html#(def._((lib._syntax/toplevel..rkt)._expand-syntax-top-level-with-compile-time-evals/flatten))",[0,[2,"expand-syntax-top-level-with-compile-time-evals/flatten"]],["syntax/toplevel"]],
["expand-to-top-form",">reference/Expanding_Top-Level_Forms.html#(def._((quote._~23~25kernel)._expand-to-top-form))",[0,[2,"expand-to-top-form"]],["racket/base","racket"]],
["expand-top-level-with-compile-time-evals",">syntax/toplevel.html#(def._((lib._syntax/toplevel..rkt)._expand-top-level-with-compile-time-evals))",[0,[2,"expand-top-level-with-compile-time-evals"]],["syntax/toplevel"]],
["expand-user-path",">reference/Manipulating_Paths.html#(def._((quote._~23~25kernel)._expand-user-path))",[0,[2,"expand-user-path"]],["racket/base","racket"]],
["expand-vec3",">deinprogramm/line3d.html#(def._((lib._teachpack/deinprogramm/line3d..rkt)._expand-vec3))",[0,[2,"expand-vec3"]],["teachpack/deinprogramm/line3d"]],
["expand/hide",">macro-debugger/index.html#(def._((lib._macro-debugger/expand..rkt)._expand/hide))",[0,[2,"expand/hide"]],["macro-debugger/expand"]],
["expand/show-predicate",">macro-debugger/index.html#(def._((lib._macro-debugger/expand..rkt)._expand/show-predicate))",[0,[2,"expand/show-predicate"]],["macro-debugger/expand"]],
["expand/step",">macro-debugger/index.html#(def._((lib._macro-debugger/stepper..rkt)._expand/step))",[0,[2,"expand/step"]],["macro-debugger/stepper"]],
["expand/step-text",">macro-debugger/index.html#(def._((lib._macro-debugger/stepper-text..rkt)._expand/step-text))",[0,[2,"expand/step-text"]],["macro-debugger/stepper-text"]],
["expander",">guide/Pairs__Lists__and_Racket_Syntax.html#(tech._expander)","<span style=\"font-style: italic\">expander</span>",false],
["expanding define-struct-like forms",">syntax/transformer-helpers.html#(part._struct)",["Expanding ",[0,[1,"define-struct"]],"-like Forms"],false],
["expanding the user's program text and breaking",">tools/Expanding_and_Breaking.html","Expanding the User&rsquo;s Program Text and Breaking",false],
["expanding top-level forms",">reference/Expanding_Top-Level_Forms.html","Expanding Top-Level Forms",false],
["expanding user programs",">tools/Expanding_and_Breaking.html#(idx._(gentag._23._(lib._scribblings/tools/tools..scrbl)))","expanding user programs",false],
["expands",">guide/macros.html#(tech._expand)","<span style=\"font-style: italic\">expands</span>",false],
["expansion",">reference/syntax-model.html#(tech._expansion)","<span style=\"font-style: italic\">Expansion</span>",false],
["expansion (parsing)",">reference/syntax-model.html#(part._expansion)","Expansion (Parsing)",false],
["expansion context",">reference/syntax-model.html#(part._expand-context-model)","Expansion Context",false],
["expansion steps",">reference/syntax-model.html#(part._expand-steps)","Expansion Steps",false],
["expect",">deinprogramm/Eigenschaften.html#(form._((lib._deinprogramm/.D.Md.A..rkt)._expect))",[0,[1,"expect"]],["deinprogramm/DMdA-beginner"]],
["expect-member-of",">deinprogramm/Eigenschaften.html#(form._((lib._deinprogramm/.D.Md.A..rkt)._expect-member-of))",[0,[1,"expect-member-of"]],["deinprogramm/DMdA-beginner"]],
["expect-range",">deinprogramm/Eigenschaften.html#(form._((lib._deinprogramm/.D.Md.A..rkt)._expect-range))",[0,[1,"expect-range"]],["deinprogramm/DMdA-beginner"]],
["expect-within",">deinprogramm/Eigenschaften.html#(form._((lib._deinprogramm/.D.Md.A..rkt)._expect-within))",[0,[1,"expect-within"]],["deinprogramm/DMdA-beginner"]],
["experimental",">syntax/Experimental.html","Experimental",false],
["experimental features",">ts-reference/Experimental_Features.html","Experimental Features",false],
["experimenting with contracts and modules",">guide/contract-boundaries.html#(part._.Experimenting_with_.Contracts_and_.Modules)","Experimenting with Contracts and Modules",false],
["explicitly queued events",">gui/windowing-overview.html#(tech._explicitly._queued._event)","<span style=\"font-style: italic\">Explicitly queued events</span>",false],
["explode",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._explode))",[0,[2,"explode"]],["lang/htdp-advanced"]],
["explode",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._explode))",[0,[2,"explode"]],["lang/htdp-beginner"]],
["explode",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._explode))",[0,[2,"explode"]],["lang/htdp-beginner-abbr"]],
["explode",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._explode))",[0,[2,"explode"]],["lang/htdp-intermediate"]],
["explode",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._explode))",[0,[2,"explode"]],["lang/htdp-intermediate-lambda"]],
["explode-module-path-index",">unstable/syntax.html#(def._((lib._unstable/syntax..rkt)._explode-module-path-index))",[0,[2,"explode-module-path-index"]],["unstable/syntax"]],
["explode-path",">reference/More_Path_Utilities.html#(def._((lib._racket/path..rkt)._explode-path))",[0,[2,"explode-path"]],["racket/path","racket"]],
["explode-path*",">web-server-internal/misc-util.html#(def._((lib._web-server/private/util..rkt)._explode-path*))",[0,[2,"explode-path*"]],["web-server/private/util"]],
["exploring a universe",">teachpack/2htdpuniverse.html#(part._.Exploring_a_.Universe)","Exploring a Universe",false],
["export",">reference/stxtrans.html#(def._((lib._racket/provide-transform..rkt)._export))",[0,[2,"export"]],["racket/provide-transform"]],
["export",">reference/creatingunits.html#(form._((lib._mzlib/unit..rkt)._export))",[0,[1,"export"]],["racket/unit","racket"]],
["export-local-id",">reference/stxtrans.html#(def._((lib._racket/provide-transform..rkt)._export-local-id))",[0,[2,"export-local-id"]],["racket/provide-transform"]],
["export-mode",">reference/stxtrans.html#(def._((lib._racket/provide-transform..rkt)._export-mode))",[0,[2,"export-mode"]],["racket/provide-transform"]],
["export-orig-stx",">reference/stxtrans.html#(def._((lib._racket/provide-transform..rkt)._export-orig-stx))",[0,[2,"export-orig-stx"]],["racket/provide-transform"]],
["export-out-sym",">reference/stxtrans.html#(def._((lib._racket/provide-transform..rkt)._export-out-sym))",[0,[2,"export-out-sym"]],["racket/provide-transform"]],
["export-protect?",">reference/stxtrans.html#(def._((lib._racket/provide-transform..rkt)._export-protect~3f))",[0,[2,"export-protect?"]],["racket/provide-transform"]],
["export?",">reference/stxtrans.html#(def._((lib._racket/provide-transform..rkt)._export~3f))",[0,[2,"export?"]],["racket/provide-transform"]],
["exported-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..rkt)._exported-index-desc))",[0,[2,"exported-index-desc"]],["scribble/manual-struct"]],
["exported-index-desc-from-libs",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..rkt)._exported-index-desc-from-libs))",[0,[2,"exported-index-desc-from-libs"]],["scribble/manual-struct"]],
["exported-index-desc-name",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..rkt)._exported-index-desc-name))",[0,[2,"exported-index-desc-name"]],["scribble/manual-struct"]],
["exported-index-desc?",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..rkt)._exported-index-desc~3f))",[0,[2,"exported-index-desc?"]],["scribble/manual-struct"]],
["exported-module-binding",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._exported-module-binding))",[0,[2,"exported-module-binding"]],["compiler/zo-structs"]],
["exported-module-binding-export-name",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._exported-module-binding-export-name))",[0,[2,"exported-module-binding-export-name"]],["compiler/zo-structs"]],
["exported-module-binding-path",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._exported-module-binding-path))",[0,[2,"exported-module-binding-path"]],["compiler/zo-structs"]],
["exported-module-binding?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._exported-module-binding~3f))",[0,[2,"exported-module-binding?"]],["compiler/zo-structs"]],
["exported-nominal-module-binding",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._exported-nominal-module-binding))",[0,[2,"exported-nominal-module-binding"]],["compiler/zo-structs"]],
["exported-nominal-module-binding-export-name",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._exported-nominal-module-binding-export-name))",[0,[2,"exported-nominal-module-binding-export-name"]],["compiler/zo-structs"]],
["exported-nominal-module-binding-nominal-export-name",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._exported-nominal-module-binding-nominal-export-name))",[0,[2,"exported-nominal-module-binding-nominal-export-name"]],["compiler/zo-structs"]],
["exported-nominal-module-binding-nominal-path",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._exported-nominal-module-binding-nominal-path))",[0,[2,"exported-nominal-module-binding-nominal-path"]],["compiler/zo-structs"]],
["exported-nominal-module-binding-path",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._exported-nominal-module-binding-path))",[0,[2,"exported-nominal-module-binding-path"]],["compiler/zo-structs"]],
["exported-nominal-module-binding?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._exported-nominal-module-binding~3f))",[0,[2,"exported-nominal-module-binding?"]],["compiler/zo-structs"]],
["exporting images to disk",">teachpack/2htdpimage.html#(part._.Exporting_.Images_to_.Disk)","Exporting Images to Disk",false],
["exports: provide",">guide/module-provide.html",["Exports: ",[0,[1,"provide"]]],false],
["expr",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._expr))",[0,[2,"expr"]],["compiler/zo-structs"]],
["expr",">syntax/Library_Syntax_Classes_and_Literal_Sets.html#(form._((lib._syntax/parse..rkt)._expr))",[0,[1,"expr"]],["syntax/parse"]],
["expr->string",">mzlib/mzlib_string.html#(def._((lib._mzlib/string..rkt)._expr-~3estring))",[0,[2,"expr->string"]],["mzlib/string"]],
["expr/c",">syntax/Library_Syntax_Classes_and_Literal_Sets.html#(def._((lib._syntax/parse..rkt)._expr/c))",[0,[2,"expr/c"]],["syntax/parse"]],
["expr?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._expr~3f))",[0,[2,"expr?"]],["compiler/zo-structs"]],
["expression context",">reference/syntax-model.html#(tech._expression._context)","<span style=\"font-style: italic\">expression context</span>",false],
["expression wrapper: #%expression",">reference/__expression.html",["Expression Wrapper: ",[0,[1,"#%expression"]]],false],
["expressions",">raco/decompile.html#(part._.Expressions)","Expressions",false],
["expressions and definitions",">guide/scheme-forms.html","Expressions and Definitions",false],
["expt",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._expt))",[0,[2,"expt"]],["racket/base","racket"]],
["expt",">r5rs-std/r5rs-Z-H-9.html#%_idx_346",[0,[2,"expt"]],["r5rs"]],
["expt",">r6rs-std/r6rs-Z-H-14.html#node_idx_564",[0,[2,"expt"]],["rnrs/base-6"]],
["expt",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._expt))",[0,[2,"expt"]],["lang/htdp-advanced"]],
["expt",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._expt))",[0,[2,"expt"]],["lang/htdp-beginner"]],
["expt",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._expt))",[0,[2,"expt"]],["lang/htdp-beginner-abbr"]],
["expt",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._expt))",[0,[2,"expt"]],["lang/htdp-intermediate"]],
["expt",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._expt))",[0,[2,"expt"]],["lang/htdp-intermediate-lambda"]],
["expt",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._expt))",[0,[2,"expt"]],["deinprogramm/DMdA-advanced"]],
["expt",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._expt))",[0,[2,"expt"]],["deinprogramm/DMdA-assignments"]],
["expt",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._expt))",[0,[2,"expt"]],["deinprogramm/DMdA-beginner"]],
["expt",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._expt))",[0,[2,"expt"]],["deinprogramm/DMdA-vanilla"]],
["extend",">unstable/list.html#(def._((lib._unstable/list..rkt)._extend))",[0,[2,"extend"]],["unstable/list"]],
["extend",">reference/mzlib_class.html#(tech._extend)","<span style=\"font-style: italic\">extend</span>",false],
["extend-language-show-union",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._extend-language-show-union))",[0,[2,"extend-language-show-union"]],["redex/pict","redex"]],
["extend-position",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._extend-position))",[[0,[2,"extend-position"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["extend-reduction-relation",">redex/The_Redex_Reference.html#(form._((lib._redex/reduction-semantics..rkt)._extend-reduction-relation))",[0,[1,"extend-reduction-relation"]],["redex/reduction-semantics","redex"]],
["extended",">gui/Windowing_Functions.html#(idx._(gentag._145._(lib._scribblings/gui/gui..scrbl)))",[7,"'extended"],false],
["extended example: call-by-reference functions",">guide/pattern-macros.html#(part._pattern-macro-example)","Extended Example: Call-by-Reference Functions",false],
["extended-format",">web-server-internal/dispatch-log.html#(def._((lib._web-server/dispatchers/dispatch-log..rkt)._extended-format))",[0,[2,"extended-format"]],["web-server/dispatchers/dispatch-log"]],
["extending and configuring scribble output",">scribble/config.html","Extending and Configuring Scribble Output",false],
["extending drracket",">drracket/extending-drracket.html","Extending DrRacket",false],
["extending match",">reference/match.html#(part._.Extending_match)",["Extending ",[0,[1,"match"]]],false],
["extending racket",">inside/overview.html#(idx._(gentag._2._(lib._scribblings/inside/inside..scrbl)))","extending Racket",false],
["extending the existing drracket classes",">tools/Extending_the_Existing_DrRacket_Classes.html","Extending the Existing DrRacket Classes",false],
["extending the model",">continue/index.html#(part._.Extending_the_.Model)","Extending the Model",false],
["extending the syntax of signatures",">reference/define-sig-form.html","Extending the Syntax of Signatures",false],
["extending web-server/dispatch",">web-server/dispatch.html#(part._.Extending_web-server_dispatch)",["Extending ",[9,[0,"web-server/dispatch"]]],false],
["extends",">reference/creatingunits.html#(form._((lib._mzlib/unit..rkt)._extends))",[0,[1,"extends"]],["racket/unit","racket"]],
["extension-load handler",">reference/eval.html#(tech._extension._load._handler)","<span style=\"font-style: italic\">extension-load handler</span>",false],
["extensions",">unstable/Automata__Compiling_State_Machines.html#(part._re-ext)","Extensions",false],
["external class contracts",">guide/classes.html#(part._.External_.Class_.Contracts)","External Class Contracts",false],
["external-browser",">net/sendurl.html#(def._((lib._net/sendurl..rkt)._external-browser))",[0,[2,"external-browser"]],["net/sendurl"]],
["external-dtd",">xml/index.html#(def._((lib._xml/main..rkt)._external-dtd))",[0,[2,"external-dtd"]],["xml"]],
["external-dtd-system",">xml/index.html#(def._((lib._xml/main..rkt)._external-dtd-system))",[0,[2,"external-dtd-system"]],["xml"]],
["external-dtd/public",">xml/index.html#(def._((lib._xml/main..rkt)._external-dtd/public))",[0,[2,"external-dtd/public"]],["xml"]],
["external-dtd/public-public",">xml/index.html#(def._((lib._xml/main..rkt)._external-dtd/public-public))",[0,[2,"external-dtd/public-public"]],["xml"]],
["external-dtd/public?",">xml/index.html#(def._((lib._xml/main..rkt)._external-dtd/public~3f))",[0,[2,"external-dtd/public?"]],["xml"]],
["external-dtd/system",">xml/index.html#(def._((lib._xml/main..rkt)._external-dtd/system))",[0,[2,"external-dtd/system"]],["xml"]],
["external-dtd/system?",">xml/index.html#(def._((lib._xml/main..rkt)._external-dtd/system~3f))",[0,[2,"external-dtd/system?"]],["xml"]],
["external-dtd?",">xml/index.html#(def._((lib._xml/main..rkt)._external-dtd~3f))",[0,[2,"external-dtd?"]],["xml"]],
["externalizable<%>",">reference/objectserialize.html#(def._((lib._racket/private/class-internal..rkt)._externalizable~3c~25~3e))",[0,[2,"externalizable<%>"]],["racket/class","racket"]],
["extra and format-specific files",">scribble/running.html#(part._.Extra_and_.Format-.Specific_.Files)","Extra and Format-Specific Files",false],
["extra constants and functions",">reference/generic-numbers.html#(part._.Extra_.Constants_and_.Functions)","Extra Constants and Functions",false],
["extra libraries",">mzscheme/Extra_Libraries.html","Extra Libraries",false],
["extra-repl-information",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3alanguage~3c~25~3e)._extra-repl-information))",[[0,[2,"extra-repl-information"]],[14,[" (method of ",[0,[2,"drracket:language:language<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["extract-addresses",">net/head.html#(def._((lib._net/head..rkt)._extract-addresses))",[0,[2,"extract-addresses"]],["net/head"]],
["extract-all-fields",">net/head.html#(def._((lib._net/head..rkt)._extract-all-fields))",[0,[2,"extract-all-fields"]],["net/head"]],
["extract-aux-from-path",">raco/exe.html#(def._((lib._launcher/launcher..rkt)._extract-aux-from-path))",[0,[2,"extract-aux-from-path"]],["launcher/launcher"]],
["extract-base-filename/c",">dynext/Filenames.html#(def._((lib._dynext/file..rkt)._extract-base-filename/c))",[0,[2,"extract-base-filename/c"]],["dynext/file"]],
["extract-base-filename/ext",">dynext/Filenames.html#(def._((lib._dynext/file..rkt)._extract-base-filename/ext))",[0,[2,"extract-base-filename/ext"]],["dynext/file"]],
["extract-base-filename/kp",">dynext/Filenames.html#(def._((lib._dynext/file..rkt)._extract-base-filename/kp))",[0,[2,"extract-base-filename/kp"]],["dynext/file"]],
["extract-base-filename/o",">dynext/Filenames.html#(def._((lib._dynext/file..rkt)._extract-base-filename/o))",[0,[2,"extract-base-filename/o"]],["dynext/file"]],
["extract-base-filename/ss",">dynext/Filenames.html#(def._((lib._dynext/file..rkt)._extract-base-filename/ss))",[0,[2,"extract-base-filename/ss"]],["dynext/file"]],
["extract-binding/single",">continue/index.html#(def._((lib._web-server/servlet..rkt)._extract-binding/single))",[0,[2,"extract-binding/single"]],[]],
["extract-binding/single",">net/cgi.html#(def._((lib._net/cgi..rkt)._extract-binding/single))",[0,[2,"extract-binding/single"]],["net/cgi"]],
["extract-binding/single",">web-server/http.html#(def._((lib._web-server/http/bindings..rkt)._extract-binding/single))",[0,[2,"extract-binding/single"]],["web-server/http/bindings"]],
["extract-bindings",">net/cgi.html#(def._((lib._net/cgi..rkt)._extract-bindings))",[0,[2,"extract-bindings"]],["net/cgi"]],
["extract-bindings",">web-server/http.html#(def._((lib._web-server/http/bindings..rkt)._extract-bindings))",[0,[2,"extract-bindings"]],["web-server/http/bindings"]],
["extract-desired-headers",">net/nntp.html#(def._((lib._net/nntp..rkt)._extract-desired-headers))",[0,[2,"extract-desired-headers"]],["net/nntp"]],
["extract-desired-headers",">net/pop3.html#(def._((lib._net/pop3..rkt)._extract-desired-headers))",[0,[2,"extract-desired-headers"]],["net/pop3"]],
["extract-field",">net/head.html#(def._((lib._net/head..rkt)._extract-field))",[0,[2,"extract-field"]],["net/head"]],
["extract-param",">web-server-internal/url-param.html#(def._((lib._web-server/private/url-param..rkt)._extract-param))",[0,[2,"extract-param"]],["web-server/private/url-param"]],
["extract-struct-info",">reference/structinfo.html#(def._((lib._racket/struct-info..rkt)._extract-struct-info))",[0,[2,"extract-struct-info"]],["racket/struct-info"]],
["extract-used-classes",">gui/WXME_Decoding.html#(def._((lib._wxme/main..rkt)._extract-used-classes))",[0,[2,"extract-used-classes"]],["wxme"]],
["extracting cookies",">web-server/http.html#(part._cookie-parse)","Extracting Cookies",false],
["extracting documentation from source",">scribble/srcdoc.html#(part._.Extracting_.Documentation_from_.Source)","Extracting Documentation from Source",false],
["extracting inferred names",">syntax/transformer-helpers.html#(part._name)","Extracting Inferred Names",false],
["f1",">gui/key-event_.html#(idx._(gentag._80._(lib._scribblings/gui/gui..scrbl)))",[7,"'f1"],false],
["f10",">gui/key-event_.html#(idx._(gentag._89._(lib._scribblings/gui/gui..scrbl)))",[7,"'f10"],false],
["f11",">gui/key-event_.html#(idx._(gentag._90._(lib._scribblings/gui/gui..scrbl)))",[7,"'f11"],false],
["f12",">gui/key-event_.html#(idx._(gentag._91._(lib._scribblings/gui/gui..scrbl)))",[7,"'f12"],false],
["f13",">gui/key-event_.html#(idx._(gentag._92._(lib._scribblings/gui/gui..scrbl)))",[7,"'f13"],false],
["f14",">gui/key-event_.html#(idx._(gentag._93._(lib._scribblings/gui/gui..scrbl)))",[7,"'f14"],false],
["f15",">gui/key-event_.html#(idx._(gentag._94._(lib._scribblings/gui/gui..scrbl)))",[7,"'f15"],false],
["f16",">gui/key-event_.html#(idx._(gentag._95._(lib._scribblings/gui/gui..scrbl)))",[7,"'f16"],false],
["f17",">gui/key-event_.html#(idx._(gentag._96._(lib._scribblings/gui/gui..scrbl)))",[7,"'f17"],false],
["f18",">gui/key-event_.html#(idx._(gentag._97._(lib._scribblings/gui/gui..scrbl)))",[7,"'f18"],false],
["f19",">gui/key-event_.html#(idx._(gentag._98._(lib._scribblings/gui/gui..scrbl)))",[7,"'f19"],false],
["f2",">gui/key-event_.html#(idx._(gentag._81._(lib._scribblings/gui/gui..scrbl)))",[7,"'f2"],false],
["f20",">gui/key-event_.html#(idx._(gentag._99._(lib._scribblings/gui/gui..scrbl)))",[7,"'f20"],false],
["f21",">gui/key-event_.html#(idx._(gentag._100._(lib._scribblings/gui/gui..scrbl)))",[7,"'f21"],false],
["f22",">gui/key-event_.html#(idx._(gentag._101._(lib._scribblings/gui/gui..scrbl)))",[7,"'f22"],false],
["f23",">gui/key-event_.html#(idx._(gentag._102._(lib._scribblings/gui/gui..scrbl)))",[7,"'f23"],false],
["f24",">gui/key-event_.html#(idx._(gentag._103._(lib._scribblings/gui/gui..scrbl)))",[7,"'f24"],false],
["f3",">gui/key-event_.html#(idx._(gentag._82._(lib._scribblings/gui/gui..scrbl)))",[7,"'f3"],false],
["f32vector",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._f32vector))",[0,[2,"f32vector"]],["ffi/vector"]],
["f32vector",">srfi-std/srfi-4.html#f32vector",[0,[2,"f32vector"]],["srfi/4"]],
["f32vector->cpointer",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._f32vector-~3ecpointer))",[0,[2,"f32vector->cpointer"]],["ffi/vector"]],
["f32vector->list",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._f32vector-~3elist))",[0,[2,"f32vector->list"]],["ffi/vector"]],
["f32vector-length",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._f32vector-length))",[0,[2,"f32vector-length"]],["ffi/vector"]],
["f32vector-ref",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._f32vector-ref))",[0,[2,"f32vector-ref"]],["ffi/vector"]],
["f32vector-set!",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._f32vector-set!))",[0,[2,"f32vector-set!"]],["ffi/vector"]],
["f32vector?",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._f32vector~3f))",[0,[2,"f32vector?"]],["ffi/vector"]],
["f4",">gui/key-event_.html#(idx._(gentag._83._(lib._scribblings/gui/gui..scrbl)))",[7,"'f4"],false],
["f5",">gui/key-event_.html#(idx._(gentag._84._(lib._scribblings/gui/gui..scrbl)))",[7,"'f5"],false],
["f5 keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._213._(lib._scribblings/drracket/drracket..scrbl)))","F5 keybinding",false],
["f6",">gui/key-event_.html#(idx._(gentag._85._(lib._scribblings/gui/gui..scrbl)))",[7,"'f6"],false],
["f64vector",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._f64vector))",[0,[2,"f64vector"]],["ffi/vector"]],
["f64vector",">srfi-std/srfi-4.html#f64vector",[0,[2,"f64vector"]],["srfi/4"]],
["f64vector->cpointer",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._f64vector-~3ecpointer))",[0,[2,"f64vector->cpointer"]],["ffi/vector"]],
["f64vector->list",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._f64vector-~3elist))",[0,[2,"f64vector->list"]],["ffi/vector"]],
["f64vector-length",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._f64vector-length))",[0,[2,"f64vector-length"]],["ffi/vector"]],
["f64vector-ref",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._f64vector-ref))",[0,[2,"f64vector-ref"]],["ffi/vector"]],
["f64vector-set!",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._f64vector-set!))",[0,[2,"f64vector-set!"]],["ffi/vector"]],
["f64vector?",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._f64vector~3f))",[0,[2,"f64vector?"]],["ffi/vector"]],
["f7",">gui/key-event_.html#(idx._(gentag._86._(lib._scribblings/gui/gui..scrbl)))",[7,"'f7"],false],
["f8",">gui/key-event_.html#(idx._(gentag._87._(lib._scribblings/gui/gui..scrbl)))",[7,"'f8"],false],
["f9",">gui/key-event_.html#(idx._(gentag._88._(lib._scribblings/gui/gui..scrbl)))",[7,"'f9"],false],
["face",">slideshow/More_Pict_Constructors.html#(part._.Face)","Face",false],
["face",">slideshow/More_Pict_Constructors.html#(def._((lib._slideshow/face..rkt)._face))",[0,[2,"face"]],["slideshow/face"]],
["face*",">slideshow/More_Pict_Constructors.html#(def._((lib._slideshow/face..rkt)._face*))",[0,[2,"face*"]],["slideshow/face"]],
["face-down",">cards/index.html#(meth._(((lib._games/cards..rkt)._card~3c~25~3e)._face-down))",[[0,[2,"face-down"]],[14,[" (method of ",[0,[2,"card<%>"]],")"]]],["games/cards"]],
["face-down?",">cards/index.html#(meth._(((lib._games/cards..rkt)._card~3c~25~3e)._face-down~3f))",[[0,[2,"face-down?"]],[14,[" (method of ",[0,[2,"card<%>"]],")"]]],["games/cards"]],
["face-up",">cards/index.html#(meth._(((lib._games/cards..rkt)._card~3c~25~3e)._face-up))",[[0,[2,"face-up"]],[14,[" (method of ",[0,[2,"card<%>"]],")"]]],["games/cards"]],
["fact",">datalog/datalog.html#(tech._fact)","<span style=\"font-style: italic\">fact</span>",false],
["fade-around-pict",">slideshow/play.html#(def._((lib._slideshow/play..rkt)._fade-around-pict))",[0,[2,"fade-around-pict"]],["slideshow/play"]],
["fade-pict",">slideshow/play.html#(def._((lib._slideshow/play..rkt)._fade-pict))",[0,[2,"fade-pict"]],["slideshow/play"]],
["fail",">rackunit/api.html#(def._((lib._rackunit/main..rkt)._fail))",[0,[2,"fail"]],["rackunit"]],
["fail-check",">rackunit/api.html#(form._((lib._rackunit/main..rkt)._fail-check))",[0,[1,"fail-check"]],["rackunit"]],
["failok",">foreign/foreign_pointer-funcs.html#(idx._(gentag._13._(lib._scribblings/foreign/foreign..scrbl)))",[7,"'failok"],false],
["failure-result/c",">unstable/contract.html#(def._((lib._unstable/contract..rkt)._failure-result/c))",[0,[2,"failure-result/c"]],["unstable/contract"]],
["fallunterscheidung",">deinprogramm/Konstruktionsanleitungen_1_bis_10.html#(part._.Fallunterscheidung)","Fallunterscheidung",false],
["false",">reference/booleans.html#(def._((lib._racket/bool..rkt)._false))",[0,[2,"false"]],["racket/bool","racket"]],
["false",">htdp-langs/advanced.html#(def._((lib._lang/htdp-advanced..rkt)._false))",[0,[2,"false"]],["lang/htdp-advanced"]],
["false",">htdp-langs/beginner.html#(def._((lib._lang/htdp-beginner..rkt)._false))",[0,[2,"false"]],["lang/htdp-beginner"]],
["false",">htdp-langs/beginner-abbr.html#(def._((lib._lang/htdp-beginner-abbr..rkt)._false))",[0,[2,"false"]],["lang/htdp-beginner-abbr"]],
["false",">htdp-langs/intermediate.html#(def._((lib._lang/htdp-intermediate..rkt)._false))",[0,[2,"false"]],["lang/htdp-intermediate"]],
["false",">htdp-langs/intermediate-lam.html#(def._((lib._lang/htdp-intermediate-lambda..rkt)._false))",[0,[2,"false"]],["lang/htdp-intermediate-lambda"]],
["false",">deinprogramm/Signaturen.html#(form._((lib._deinprogramm/.D.Md.A..rkt)._false))",[0,[1,"false"]],["deinprogramm/DMdA-beginner"]],
["false",">lazy/index.html#(def._((lib._lazy/main..rkt)._false))",[0,[2,"false"]],["lazy"]],
["false",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.False))",[0,[1,"False"]],["typed/racket/base","typed/racket"]],
["false->sql-null",">db/sql-types.html#(def._((lib._db/base..rkt)._false-~3esql-null))",[0,[2,"false->sql-null"]],["db","db/base"]],
["false/c",">reference/data-structure-contracts.html#(def._((lib._racket/contract/private/misc..rkt)._false/c))",[0,[2,"false/c"]],["racket/contract/base","racket/contract","racket"]],
["false?",">reference/booleans.html#(def._((lib._racket/bool..rkt)._false~3f))",[0,[2,"false?"]],["racket/bool","racket"]],
["false?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._false~3f))",[0,[2,"false?"]],["lang/htdp-advanced"]],
["false?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._false~3f))",[0,[2,"false?"]],["lang/htdp-beginner"]],
["false?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._false~3f))",[0,[2,"false?"]],["lang/htdp-beginner-abbr"]],
["false?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._false~3f))",[0,[2,"false?"]],["lang/htdp-intermediate"]],
["false?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._false~3f))",[0,[2,"false?"]],["lang/htdp-intermediate-lambda"]],
["false?",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._false~3f))",[0,[2,"false?"]],["deinprogramm/DMdA-advanced"]],
["false?",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._false~3f))",[0,[2,"false?"]],["deinprogramm/DMdA-assignments"]],
["false?",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._false~3f))",[0,[2,"false?"]],["deinprogramm/DMdA-beginner"]],
["false?",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._false~3f))",[0,[2,"false?"]],["deinprogramm/DMdA-vanilla"]],
["farbe",">deinprogramm/image.html#(tech._farbe)","<span style=\"font-style: italic\">Farbe</span>",false],
["fasl->s-exp",">reference/fasl.html#(def._((lib._racket/fasl..rkt)._fasl-~3es-exp))",[0,[2,"fasl->s-exp"]],["racket/fasl"]],
["fast-edges",">slideshow/play.html#(def._((lib._slideshow/play..rkt)._fast-edges))",[0,[2,"fast-edges"]],["slideshow/play"]],
["fast-end",">slideshow/play.html#(def._((lib._slideshow/play..rkt)._fast-end))",[0,[2,"fast-end"]],["slideshow/play"]],
["fast-forward-icon",">images/Icons.html#(def._((lib._images/icons/control..rkt)._fast-forward-icon))",[0,[2,"fast-forward-icon"]],["images/icons/control"]],
["fast-load serialization",">reference/fasl.html","Fast-Load Serialization",false],
["fast-middle",">slideshow/play.html#(def._((lib._slideshow/play..rkt)._fast-middle))",[0,[2,"fast-middle"]],["slideshow/play"]],
["fast-start",">slideshow/play.html#(def._((lib._slideshow/play..rkt)._fast-start))",[0,[2,"fast-start"]],["slideshow/play"]],
["fcontrol",">reference/cont.html#(def._((lib._racket/control..rkt)._fcontrol))",[0,[2,"fcontrol"]],["racket/control"]],
["fdiagonal-hatch",">draw/brush_.html#(idx._(gentag._19._(lib._scribblings/draw/draw..scrbl)))",[7,"'fdiagonal-hatch"],false],
["features",">swindle/index.html#(part._.Features)","Features",false],
["feedback-buffer->gl-float-vector",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._feedback-buffer-~3egl-float-vector))",[0,[2,"feedback-buffer->gl-float-vector"]],["sgl/gl"]],
["fern fractal",">turtles/Traditional_Turtles.html#(idx._(gentag._5._(lib._graphics/scribblings/turtles..scrbl)))","fern fractal",false],
["fern-size",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtle-examples..rkt)._fern-size))",[0,[2,"fern-size"]],["graphics/turtle-examples"]],
["fern1",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtle-examples..rkt)._fern1))",[0,[2,"fern1"]],["graphics/turtle-examples"]],
["fern2",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtle-examples..rkt)._fern2))",[0,[2,"fern2"]],["graphics/turtle-examples"]],
["fetch",">planet/cmdline.html#(part._fetch)",[6,"fetch"],false],
["ffi",">foreign/index.html#(tech._ffi)","<span style=\"font-style: italic\">FFI</span>",false],
["ffi types and constants",">foreign/Objective-C_FFI.html#(part._.F.F.I_.Types_and_.Constants)","FFI Types and Constants",false],
["ffi-based connections",">db/connect.html#(tech._ffi._based._connection)","<span style=\"font-style: italic\">FFI-based\nconnections</span>",false],
["ffi-based connections and concurrency",">db/notes.html#(part._ffi-concurrency)","FFI-Based Connections and Concurrency",false],
["ffi-call",">foreign/foreign_c-only.html#(def._((quote._~23~25foreign)._ffi-call))",[0,[2,"ffi-call"]],["'#%foreign"]],
["ffi-callback",">foreign/foreign_c-only.html#(def._((quote._~23~25foreign)._ffi-callback))",[0,[2,"ffi-callback"]],["'#%foreign"]],
["ffi-callback?",">foreign/foreign_c-only.html#(def._((quote._~23~25foreign)._ffi-callback~3f))",[0,[2,"ffi-callback?"]],["'#%foreign"]],
["ffi-lib",">foreign/Loading_Foreign_Libraries.html#(def._((lib._ffi/unsafe..rkt)._ffi-lib))",[0,[2,"ffi-lib"]],["ffi/unsafe"]],
["ffi-lib?",">foreign/Loading_Foreign_Libraries.html#(def._((quote._~23~25foreign)._ffi-lib~3f))",[0,[2,"ffi-lib?"]],["ffi/unsafe"]],
["ffi-obj",">foreign/foreign_c-only.html#(def._((quote._~23~25foreign)._ffi-obj))",[0,[2,"ffi-obj"]],["'#%foreign"]],
["ffi-obj-lib",">foreign/foreign_c-only.html#(def._((quote._~23~25foreign)._ffi-obj-lib))",[0,[2,"ffi-obj-lib"]],["'#%foreign"]],
["ffi-obj-name",">foreign/foreign_c-only.html#(def._((quote._~23~25foreign)._ffi-obj-name))",[0,[2,"ffi-obj-name"]],["'#%foreign"]],
["ffi-obj-ref",">foreign/Loading_Foreign_Libraries.html#(def._((lib._ffi/unsafe..rkt)._ffi-obj-ref))",[0,[2,"ffi-obj-ref"]],["ffi/unsafe"]],
["ffi-obj?",">foreign/foreign_c-only.html#(def._((quote._~23~25foreign)._ffi-obj~3f))",[0,[2,"ffi-obj?"]],["'#%foreign"]],
["ffi/com",">foreign/com-auto.html",[9,[0,"ffi/com"]],"module"],
["ffi/com-registry",">foreign/com-auto.html#(mod-path._ffi/com-registry)",[9,[0,"ffi/com-registry"]],"module"],
["ffi/cvector",">foreign/foreign_cvector.html",[9,[0,"ffi/cvector"]],"module"],
["ffi/file",">foreign/file-security-guard-checks.html",[9,[0,"ffi/file"]],"module"],
["ffi/objc",">foreign/Objective-C_FFI.html#(mod-path._ffi/objc)",[9,[0,"ffi/objc"]],"module"],
["ffi/unsafe",">foreign/index.html",[9,[0,"ffi/unsafe"]],"module"],
["ffi/unsafe/alloc",">foreign/Allocation_and_Finalization.html",[9,[0,"ffi/unsafe/alloc"]],"module"],
["ffi/unsafe/atomic",">foreign/Atomic_Execution.html",[9,[0,"ffi/unsafe/atomic"]],"module"],
["ffi/unsafe/com",">foreign/com-intf.html",[9,[0,"ffi/unsafe/com"]],"module"],
["ffi/unsafe/cvector",">foreign/foreign_cvector.html",[9,[0,"ffi/unsafe/cvector"]],"module"],
["ffi/unsafe/define",">foreign/Defining_Bindings.html",[9,[0,"ffi/unsafe/define"]],"module"],
["ffi/unsafe/objc",">foreign/Objective-C_FFI.html",[9,[0,"ffi/unsafe/objc"]],"module"],
["ffi/unsafe/try-atomic",">foreign/Speculatively_Atomic_Execution.html",[9,[0,"ffi/unsafe/try-atomic"]],"module"],
["ffi/vector",">foreign/homogeneous-vectors.html",[9,[0,"ffi/vector"]],"module"],
["ffi/winapi",">foreign/winapi.html",[9,[0,"ffi/winapi"]],"module"],
["field",">reference/createclass.html#(form._((lib._racket/private/class-internal..rkt)._field))",[0,[1,"field"]],["racket/class","racket"]],
["field and method access",">reference/ivaraccess.html","Field and Method Access",false],
["field-bound?",">reference/ivaraccess.html#(form._((lib._racket/private/class-internal..rkt)._field-bound~3f))",[0,[1,"field-bound?"]],["racket/class","racket"]],
["field-names",">reference/objectutils.html#(def._((lib._racket/private/class-internal..rkt)._field-names))",[0,[2,"field-names"]],["racket/class","racket"]],
["fields",">reference/ivaraccess.html#(part._.Fields)","Fields",false],
["fields",">reference/createclass.html#(part._clfields)","Fields",false],
["fields",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_290",[0,[1,"fields"]],["rnrs/records/syntactic-6"]],
["fieldset",">html/index.html#(def._((lib._html/main..rkt)._fieldset))",[0,[2,"fieldset"]],["html"]],
["fieldset?",">html/index.html#(def._((lib._html/main..rkt)._fieldset~3f))",[0,[2,"fieldset?"]],["html"]],
["fifth",">reference/pairs.html#(def._((lib._racket/list..rkt)._fifth))",[0,[2,"fifth"]],["racket/list","racket"]],
["fifth",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._fifth))",[0,[2,"fifth"]],["lang/htdp-advanced"]],
["fifth",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._fifth))",[0,[2,"fifth"]],["lang/htdp-beginner"]],
["fifth",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._fifth))",[0,[2,"fifth"]],["lang/htdp-beginner-abbr"]],
["fifth",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._fifth))",[0,[2,"fifth"]],["lang/htdp-intermediate"]],
["fifth",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._fifth))",[0,[2,"fifth"]],["lang/htdp-intermediate-lambda"]],
["fifth",">lazy/index.html#(def._((lib._lazy/main..rkt)._fifth))",[0,[2,"fifth"]],["lazy"]],
["fifth",">mzlib/mzlib_list.html#(def._((lib._mzlib/list..rkt)._fifth))",[0,[2,"fifth"]],["mzlib/list"]],
["fifth",">srfi-std/srfi-1.html#fifth",[0,[2,"fifth"]],["srfi/1"]],
["figure",">scriblib/figure.html#(def._((lib._scriblib/figure..rkt)._figure))",[0,[2,"figure"]],["scriblib/figure"]],
["figure*",">scriblib/figure.html#(def._((lib._scriblib/figure..rkt)._figure*))",[0,[2,"figure*"]],["scriblib/figure"]],
["figure**",">scriblib/figure.html#(def._((lib._scriblib/figure..rkt)._figure**))",[0,[2,"figure**"]],["scriblib/figure"]],
["figure-here",">scriblib/figure.html#(def._((lib._scriblib/figure..rkt)._figure-here))",[0,[2,"figure-here"]],["scriblib/figure"]],
["figure-ref",">scriblib/figure.html#(def._((lib._scriblib/figure..rkt)._.Figure-ref))",[0,[2,"Figure-ref"]],["scriblib/figure"]],
["figure-ref",">scriblib/figure.html#(def._((lib._scriblib/figure..rkt)._figure-ref))",[0,[2,"figure-ref"]],["scriblib/figure"]],
["figure-target",">scriblib/figure.html#(def._((lib._scriblib/figure..rkt)._.Figure-target))",[0,[2,"Figure-target"]],["scriblib/figure"]],
["figures",">scriblib/figure.html","Figures",false],
["file",">drracket/Menus.html#(part._.File)","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">File</span>",false],
["file",">reference/require.html#(form._((lib._racket/private/base..rkt)._file))",[0,[1,"file"]],["racket/base","racket"]],
["file",">teachpack/dir.html#(def._((lib._htdp/dir..rkt)._file))",[0,[2,"file"]],["htdp/dir"]],
["file boxes",">web-server/stateless.html#(part._lang/file-box)","File Boxes",false],
["file extension",">drracket/drracket-files.html#(idx._(gentag._368._(lib._scribblings/drracket/drracket..scrbl)))","file extension",false],
["file format",">gui/editor-overview.html#(part._editorfileformat)","File Format",false],
["file icons",">images/Icons.html#(part._file)","File Icons",false],
["file inclusion",">reference/include.html","File Inclusion",false],
["file operations",">drracket/Keyboard_Shortcuts.html#(part._.File_.Operations)","File Operations",false],
["file ports",">reference/file-ports.html","File Ports",false],
["file security-guard checks",">foreign/file-security-guard-checks.html","File Security-Guard Checks",false],
["file->bytes",">reference/Filesystem.html#(def._((lib._racket/file..rkt)._file-~3ebytes))",[0,[2,"file->bytes"]],["racket/file","racket"]],
["file->bytes-lines",">reference/Filesystem.html#(def._((lib._racket/file..rkt)._file-~3ebytes-lines))",[0,[2,"file->bytes-lines"]],["racket/file","racket"]],
["file->lines",">reference/Filesystem.html#(def._((lib._racket/file..rkt)._file-~3elines))",[0,[2,"file->lines"]],["racket/file","racket"]],
["file->list",">reference/Filesystem.html#(def._((lib._racket/file..rkt)._file-~3elist))",[0,[2,"file->list"]],["racket/file","racket"]],
["file->string",">reference/Filesystem.html#(def._((lib._racket/file..rkt)._file-~3estring))",[0,[2,"file->string"]],["racket/file","racket"]],
["file->value",">reference/Filesystem.html#(def._((lib._racket/file..rkt)._file-~3evalue))",[0,[2,"file->value"]],["racket/file","racket"]],
["file-base-connection-timeout",">web-server-internal/Web_Servers.html#(idx._(gentag._22._(lib._web-server/scribblings/web-server-internal..scrbl)))","file-base-connection-timeout",false],
["file-box",">web-server/stateless.html#(def._((lib._web-server/lang/file-box..rkt)._file-box))",[0,[2,"file-box"]],["web-server/lang/file-box"]],
["file-box-set!",">web-server/stateless.html#(def._((lib._web-server/lang/file-box..rkt)._file-box-set!))",[0,[2,"file-box-set!"]],["web-server/lang/file-box"]],
["file-box-set?",">web-server/stateless.html#(def._((lib._web-server/lang/file-box..rkt)._file-box-set~3f))",[0,[2,"file-box-set?"]],["web-server/lang/file-box"]],
["file-box?",">web-server/stateless.html#(def._((lib._web-server/lang/file-box..rkt)._file-box~3f))",[0,[2,"file-box?"]],["web-server/lang/file-box"]],
["file-content",">teachpack/dir.html#(def._((lib._htdp/dir..rkt)._file-content))",[0,[2,"file-content"]],["htdp/dir"]],
["file-creator-and-type",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._file-creator-and-type))",[0,[2,"file-creator-and-type"]],["racket/gui/base","racket/gui"]],
["file-exists?",">reference/Filesystem.html#(def._((quote._~23~25kernel)._file-exists~3f))",[0,[2,"file-exists?"]],["racket/base","racket"]],
["file-exists?",">r6rs-lib-std/r6rs-lib-Z-H-10.html#node_idx_838",[0,[2,"file-exists?"]],["rnrs/files-6"]],
["file-icon",">slideshow/More_Pict_Constructors.html#(def._((lib._slideshow/pict..rkt)._file-icon))",[0,[2,"file-icon"]],["slideshow/pict","slideshow"]],
["file-menu:after-quit",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3aafter-quit))",[[0,[2,"file-menu:after-quit"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:between-close-and-quit",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3abetween-close-and-quit))",[[0,[2,"file-menu:between-close-and-quit"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:between-new-and-open",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3abetween-new-and-open))",[[0,[2,"file-menu:between-new-and-open"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:between-open-and-revert",">tools/drracket_frame.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aframe~3abasics-mixin)._file-menu~3abetween-open-and-revert))",[[0,[2,"file-menu:between-open-and-revert"]],[14,[" (method of ",[0,[2,"drracket:frame:basics-mixin"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["file-menu:between-open-and-revert",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aframe~25)._file-menu~3abetween-open-and-revert))",[[0,[2,"file-menu:between-open-and-revert"]],[14,[" (method of ",[0,[2,"drracket:unit:frame%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["file-menu:between-open-and-revert",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3abetween-open-and-revert))",[[0,[2,"file-menu:between-open-and-revert"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:between-print-and-close",">tools/drracket_frame.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aframe~3abasics-mixin)._file-menu~3abetween-print-and-close))",[[0,[2,"file-menu:between-print-and-close"]],[14,[" (method of ",[0,[2,"drracket:frame:basics-mixin"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["file-menu:between-print-and-close",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aframe~25)._file-menu~3abetween-print-and-close))",[[0,[2,"file-menu:between-print-and-close"]],[14,[" (method of ",[0,[2,"drracket:unit:frame%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["file-menu:between-print-and-close",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3abetween-print-and-close))",[[0,[2,"file-menu:between-print-and-close"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:between-revert-and-save",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3abetween-revert-and-save))",[[0,[2,"file-menu:between-revert-and-save"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:between-save-as-and-print",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aframe~25)._file-menu~3abetween-save-as-and-print))",[[0,[2,"file-menu:between-save-as-and-print"]],[14,[" (method of ",[0,[2,"drracket:unit:frame%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["file-menu:between-save-as-and-print",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3aeditor-mixin)._file-menu~3abetween-save-as-and-print))",[[0,[2,"file-menu:between-save-as-and-print"]],[14,[" (method of ",[0,[2,"frame:editor-mixin"]],")"]]],["framework"]],
["file-menu:between-save-as-and-print",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3abetween-save-as-and-print))",[[0,[2,"file-menu:between-save-as-and-print"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:close-callback",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3aclose-callback))",[[0,[2,"file-menu:close-callback"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:close-help-string",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3aclose-help-string))",[[0,[2,"file-menu:close-help-string"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:close-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3aclose-on-demand))",[[0,[2,"file-menu:close-on-demand"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:close-string",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3aclose-string))",[[0,[2,"file-menu:close-string"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:create-close?",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3acreate-close~3f))",[[0,[2,"file-menu:create-close?"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:create-new?",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3acreate-new~3f))",[[0,[2,"file-menu:create-new?"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:create-open-recent?",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3acreate-open-recent~3f))",[[0,[2,"file-menu:create-open-recent?"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:create-open?",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3acreate-open~3f))",[[0,[2,"file-menu:create-open?"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:create-print?",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3aeditor-mixin)._file-menu~3acreate-print~3f))",[[0,[2,"file-menu:create-print?"]],[14,[" (method of ",[0,[2,"frame:editor-mixin"]],")"]]],["framework"]],
["file-menu:create-print?",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3acreate-print~3f))",[[0,[2,"file-menu:create-print?"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:create-quit?",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3acreate-quit~3f))",[[0,[2,"file-menu:create-quit?"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:create-revert?",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3aeditor-mixin)._file-menu~3acreate-revert~3f))",[[0,[2,"file-menu:create-revert?"]],[14,[" (method of ",[0,[2,"frame:editor-mixin"]],")"]]],["framework"]],
["file-menu:create-revert?",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3acreate-revert~3f))",[[0,[2,"file-menu:create-revert?"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:create-save-as?",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3aeditor-mixin)._file-menu~3acreate-save-as~3f))",[[0,[2,"file-menu:create-save-as?"]],[14,[" (method of ",[0,[2,"frame:editor-mixin"]],")"]]],["framework"]],
["file-menu:create-save-as?",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3acreate-save-as~3f))",[[0,[2,"file-menu:create-save-as?"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:create-save?",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3aeditor-mixin)._file-menu~3acreate-save~3f))",[[0,[2,"file-menu:create-save?"]],[14,[" (method of ",[0,[2,"frame:editor-mixin"]],")"]]],["framework"]],
["file-menu:create-save?",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3acreate-save~3f))",[[0,[2,"file-menu:create-save?"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:get-close-item",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3aget-close-item))",[[0,[2,"file-menu:get-close-item"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:get-new-item",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3aget-new-item))",[[0,[2,"file-menu:get-new-item"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:get-open-item",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3aget-open-item))",[[0,[2,"file-menu:get-open-item"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:get-open-recent-item",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3aget-open-recent-item))",[[0,[2,"file-menu:get-open-recent-item"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:get-print-item",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3aget-print-item))",[[0,[2,"file-menu:get-print-item"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:get-quit-item",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3aget-quit-item))",[[0,[2,"file-menu:get-quit-item"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:get-revert-item",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3aget-revert-item))",[[0,[2,"file-menu:get-revert-item"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:get-save-as-item",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3aget-save-as-item))",[[0,[2,"file-menu:get-save-as-item"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:get-save-item",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3aget-save-item))",[[0,[2,"file-menu:get-save-item"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:new-callback",">tools/drracket_frame.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aframe~3abasics-mixin)._file-menu~3anew-callback))",[[0,[2,"file-menu:new-callback"]],[14,[" (method of ",[0,[2,"drracket:frame:basics-mixin"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["file-menu:new-callback",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3anew-callback))",[[0,[2,"file-menu:new-callback"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:new-help-string",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3anew-help-string))",[[0,[2,"file-menu:new-help-string"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:new-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3anew-on-demand))",[[0,[2,"file-menu:new-on-demand"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:new-string",">tools/drracket_frame.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aframe~3abasics-mixin)._file-menu~3anew-string))",[[0,[2,"file-menu:new-string"]],[14,[" (method of ",[0,[2,"drracket:frame:basics-mixin"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["file-menu:new-string",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3anew-string))",[[0,[2,"file-menu:new-string"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:open-callback",">tools/drracket_frame.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aframe~3abasics-mixin)._file-menu~3aopen-callback))",[[0,[2,"file-menu:open-callback"]],[14,[" (method of ",[0,[2,"drracket:frame:basics-mixin"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["file-menu:open-callback",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3aeditor-mixin)._file-menu~3aopen-callback))",[[0,[2,"file-menu:open-callback"]],[14,[" (method of ",[0,[2,"frame:editor-mixin"]],")"]]],["framework"]],
["file-menu:open-callback",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3aopen-callback))",[[0,[2,"file-menu:open-callback"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:open-help-string",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3aopen-help-string))",[[0,[2,"file-menu:open-help-string"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:open-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3aopen-on-demand))",[[0,[2,"file-menu:open-on-demand"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:open-recent-callback",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3aopen-recent-callback))",[[0,[2,"file-menu:open-recent-callback"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:open-recent-help-string",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3aopen-recent-help-string))",[[0,[2,"file-menu:open-recent-help-string"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:open-recent-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3aopen-recent-on-demand))",[[0,[2,"file-menu:open-recent-on-demand"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:open-recent-string",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3aopen-recent-string))",[[0,[2,"file-menu:open-recent-string"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:open-string",">tools/drracket_frame.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aframe~3abasics-mixin)._file-menu~3aopen-string))",[[0,[2,"file-menu:open-string"]],[14,[" (method of ",[0,[2,"drracket:frame:basics-mixin"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["file-menu:open-string",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3aopen-string))",[[0,[2,"file-menu:open-string"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:print-callback",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3aeditor-mixin)._file-menu~3aprint-callback))",[[0,[2,"file-menu:print-callback"]],[14,[" (method of ",[0,[2,"frame:editor-mixin"]],")"]]],["framework"]],
["file-menu:print-callback",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3aprint-callback))",[[0,[2,"file-menu:print-callback"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:print-help-string",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3aprint-help-string))",[[0,[2,"file-menu:print-help-string"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:print-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3aprint-on-demand))",[[0,[2,"file-menu:print-on-demand"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:print-string",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aframe~25)._file-menu~3aprint-string))",[[0,[2,"file-menu:print-string"]],[14,[" (method of ",[0,[2,"drracket:unit:frame%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["file-menu:print-string",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3aprint-string))",[[0,[2,"file-menu:print-string"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:quit-callback",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3aquit-callback))",[[0,[2,"file-menu:quit-callback"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:quit-help-string",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3aquit-help-string))",[[0,[2,"file-menu:quit-help-string"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:quit-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3aquit-on-demand))",[[0,[2,"file-menu:quit-on-demand"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:quit-string",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3aquit-string))",[[0,[2,"file-menu:quit-string"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:revert-callback",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3aeditor-mixin)._file-menu~3arevert-callback))",[[0,[2,"file-menu:revert-callback"]],[14,[" (method of ",[0,[2,"frame:editor-mixin"]],")"]]],["framework"]],
["file-menu:revert-callback",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3arevert-callback))",[[0,[2,"file-menu:revert-callback"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:revert-help-string",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3arevert-help-string))",[[0,[2,"file-menu:revert-help-string"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:revert-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3aeditor-mixin)._file-menu~3arevert-on-demand))",[[0,[2,"file-menu:revert-on-demand"]],[14,[" (method of ",[0,[2,"frame:editor-mixin"]],")"]]],["framework"]],
["file-menu:revert-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3arevert-on-demand))",[[0,[2,"file-menu:revert-on-demand"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:revert-string",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3arevert-string))",[[0,[2,"file-menu:revert-string"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:save-as-callback",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3aeditor-mixin)._file-menu~3asave-as-callback))",[[0,[2,"file-menu:save-as-callback"]],[14,[" (method of ",[0,[2,"frame:editor-mixin"]],")"]]],["framework"]],
["file-menu:save-as-callback",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3asave-as-callback))",[[0,[2,"file-menu:save-as-callback"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:save-as-help-string",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3asave-as-help-string))",[[0,[2,"file-menu:save-as-help-string"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:save-as-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3asave-as-on-demand))",[[0,[2,"file-menu:save-as-on-demand"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:save-as-string",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aframe~25)._file-menu~3asave-as-string))",[[0,[2,"file-menu:save-as-string"]],[14,[" (method of ",[0,[2,"drracket:unit:frame%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["file-menu:save-as-string",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3asave-as-string))",[[0,[2,"file-menu:save-as-string"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:save-callback",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3aeditor-mixin)._file-menu~3asave-callback))",[[0,[2,"file-menu:save-callback"]],[14,[" (method of ",[0,[2,"frame:editor-mixin"]],")"]]],["framework"]],
["file-menu:save-callback",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3asave-callback))",[[0,[2,"file-menu:save-callback"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:save-help-string",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3asave-help-string))",[[0,[2,"file-menu:save-help-string"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:save-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3asave-on-demand))",[[0,[2,"file-menu:save-on-demand"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-menu:save-string",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aframe~25)._file-menu~3asave-string))",[[0,[2,"file-menu:save-string"]],[14,[" (method of ",[0,[2,"drracket:unit:frame%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["file-menu:save-string",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._file-menu~3asave-string))",[[0,[2,"file-menu:save-string"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["file-name",">teachpack/dir.html#(def._((lib._htdp/dir..rkt)._file-name))",[0,[2,"file-name"]],["htdp/dir"]],
["file-name-from-path",">reference/More_Path_Utilities.html#(def._((lib._racket/path..rkt)._file-name-from-path))",[0,[2,"file-name-from-path"]],["racket/path","racket"]],
["file-not-found-message",">web-server-internal/Web_Servers.html#(idx._(gentag._14._(lib._web-server/scribblings/web-server-internal..scrbl)))","file-not-found-message",false],
["file-options",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_574",[0,[1,"file-options"]],["rnrs/io/ports-6"]],
["file-or-directory-identity",">reference/Filesystem.html#(def._((quote._~23~25kernel)._file-or-directory-identity))",[0,[2,"file-or-directory-identity"]],["racket/base","racket"]],
["file-or-directory-modify-seconds",">reference/Filesystem.html#(def._((quote._~23~25kernel)._file-or-directory-modify-seconds))",[0,[2,"file-or-directory-modify-seconds"]],["racket/base","racket"]],
["file-or-directory-permissions",">reference/Filesystem.html#(def._((quote._~23~25kernel)._file-or-directory-permissions))",[0,[2,"file-or-directory-permissions"]],["racket/base","racket"]],
["file-path",">parser-tools/Lexers.html#(def._((lib._parser-tools/lex..rkt)._file-path))",[0,[2,"file-path"]],["parser-tools/lex"]],
["file-per-byte-connection-timeout",">web-server-internal/Web_Servers.html#(idx._(gentag._21._(lib._web-server/scribblings/web-server-internal..scrbl)))","file-per-byte-connection-timeout",false],
["file-position",">reference/port-buffers.html#(def._((quote._~23~25kernel)._file-position))",[0,[2,"file-position"]],["racket/base","racket"]],
["file-response",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/responders..rkt)._file-response))",[0,[2,"file-response"]],["web-server/configuration/responders"]],
["file-root",">web-server-internal/Web_Servers.html#(idx._(gentag._27._(lib._web-server/scribblings/web-server-internal..scrbl)))","file-root",false],
["file-size",">reference/Filesystem.html#(def._((quote._~23~25kernel)._file-size))",[0,[2,"file-size"]],["racket/base","racket"]],
["file-size",">teachpack/dir.html#(def._((lib._htdp/dir..rkt)._file-size))",[0,[2,"file-size"]],["htdp/dir"]],
["file-stamp-in-collection",">raco/make.html#(def._((lib._compiler/cm..rkt)._file-stamp-in-collection))",[0,[2,"file-stamp-in-collection"]],["compiler/cm"]],
["file-stamp-in-paths",">raco/make.html#(def._((lib._compiler/cm..rkt)._file-stamp-in-paths))",[0,[2,"file-stamp-in-paths"]],["compiler/cm"]],
["file-stream port",">reference/file-ports.html#(tech._file._stream._port)","<span style=\"font-style: italic\">file-stream\nport</span>",false],
["file-stream-buffer-mode",">reference/port-buffers.html#(def._((quote._~23~25kernel)._file-stream-buffer-mode))",[0,[2,"file-stream-buffer-mode"]],["racket/base","racket"]],
["file-stream-port?",">reference/port-ops.html#(def._((quote._~23~25kernel)._file-stream-port~3f))",[0,[2,"file-stream-port?"]],["racket/base","racket"]],
["file-unbox",">web-server/stateless.html#(def._((lib._web-server/lang/file-box..rkt)._file-unbox))",[0,[2,"file-unbox"]],["web-server/lang/file-box"]],
["file-upload",">web-server/formlets.html#(def._((lib._web-server/formlets/input..rkt)._file-upload))",[0,[2,"file-upload"]],["web-server/formlets/input"]],
["file-url-path-convention-type",">net/url.html#(def._((lib._net/url..rkt)._file-url-path-convention-type))",[0,[2,"file-url-path-convention-type"]],["net/url"]],
["file/convertible",">file/convertible.html",[9,[0,"file/convertible"]],"module"],
["file/gif",">file/gif.html",[9,[0,"file/gif"]],"module"],
["file/gunzip",">file/gunzip.html",[9,[0,"file/gunzip"]],"module"],
["file/gzip",">file/gzip.html",[9,[0,"file/gzip"]],"module"],
["file/ico",">file/ico.html",[9,[0,"file/ico"]],"module"],
["file/md5",">file/md5.html",[9,[0,"file/md5"]],"module"],
["file/resource",">file/resource.html",[9,[0,"file/resource"]],"module"],
["file/sha1",">file/sha1b.html",[9,[0,"file/sha1"]],"module"],
["file/tar",">file/tar.html",[9,[0,"file/tar"]],"module"],
["file/zip",">file/zip.html",[9,[0,"file/zip"]],"module"],
["file: racket file format libraries",">file/index.html","File: Racket File Format Libraries",false],
["file?",">teachpack/dir.html#(def._((lib._htdp/dir..rkt)._file~3f))",[0,[2,"file?"]],["htdp/dir"]],
["filebox",">scribble/Miscellaneous.html#(def._((lib._scribble/manual..rkt)._filebox))",[0,[2,"filebox"]],["scribble/manual"]],
["fileinject",">planet/cmdline.html#(part._fileinject)",[6,"fileinject"],false],
["filename button",">drracket/buttons.html#(idx._(gentag._1._(lib._scribblings/drracket/drracket..scrbl)))","filename button",false],
["filename->latex-filename",">slatex-wrap/index.html#(def._((lib._slatex/slatex-wrapper..rkt)._filename-~3elatex-filename))",[0,[2,"filename->latex-filename"]],["slatex/slatex-wrapper"]],
["filename-extension",">reference/More_Path_Utilities.html#(def._((lib._racket/path..rkt)._filename-extension))",[0,[2,"filename-extension"]],["racket/path","racket"]],
["filenames",">dynext/Filenames.html","Filenames",false],
["filepath",">scribble/doc-strings.html#(def._((lib._scribble/manual..rkt)._filepath))",[0,[2,"filepath"]],["scribble/manual"]],
["files",">reference/Filesystem.html#(part._fileutils)","Files",false],
["filesystem",">reference/Filesystem.html","Filesystem",false],
["filesystem",">unstable/file.html","Filesystem",false],
["filesystem-root-list",">reference/Filesystem.html#(def._((quote._~23~25kernel)._filesystem-root-list))",[0,[2,"filesystem-root-list"]],["racket/base","racket"]],
["fill",">unstable/pict.html#(def._((lib._unstable/gui/pict..rkt)._fill))",[0,[2,"fill"]],["unstable/gui/pict"]],
["fill-popup",">mrlib/Name_Message.html#(meth._(((lib._mrlib/name-message..rkt)._name-message~25)._fill-popup))",[[0,[2,"fill-popup"]],[14,[" (method of ",[0,[2,"name-message%"]],")"]]],["mrlib/name-message"]],
["filled-ellipse",">slideshow/Basic_Pict_Constructors.html#(def._((lib._slideshow/pict..rkt)._filled-ellipse))",[0,[2,"filled-ellipse"]],["slideshow/pict","slideshow"]],
["filled-flash",">slideshow/More_Pict_Constructors.html#(def._((lib._slideshow/flash..rkt)._filled-flash))",[0,[2,"filled-flash"]],["slideshow/flash"]],
["filled-rectangle",">slideshow/Basic_Pict_Constructors.html#(def._((lib._slideshow/pict..rkt)._filled-rectangle))",[0,[2,"filled-rectangle"]],["slideshow/pict","slideshow"]],
["filled-rounded-rectangle",">slideshow/Basic_Pict_Constructors.html#(def._((lib._slideshow/pict..rkt)._filled-rounded-rectangle))",[0,[2,"filled-rounded-rectangle"]],["slideshow/pict","slideshow"]],
["filter",">reference/pairs.html#(def._((lib._racket/private/list..rkt)._filter))",[0,[2,"filter"]],["racket/base","racket"]],
["filter",">r6rs-lib-std/r6rs-lib-Z-H-4.html#node_idx_208",[0,[2,"filter"]],["rnrs/lists-6"]],
["filter",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._filter))",[0,[2,"filter"]],["lang/htdp-advanced"]],
["filter",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._filter))",[0,[2,"filter"]],["lang/htdp-intermediate"]],
["filter",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._filter))",[0,[2,"filter"]],["lang/htdp-intermediate-lambda"]],
["filter",">lazy/index.html#(def._((lib._lazy/main..rkt)._filter))",[0,[2,"filter"]],["lazy"]],
["filter",">srfi-std/srfi-1.html#filter",[0,[2,"filter"]],["srfi/1"]],
["filter!",">srfi-std/srfi-1.html#filter!",[0,[2,"filter!"]],["srfi/1"]],
["filter-e",">frtime/index.html#(def._((lib._frtime/main..rkt)._filter-e))",[0,[2,"filter-e"]],["frtime"]],
["filter-map",">reference/pairs.html#(def._((lib._racket/list..rkt)._filter-map))",[0,[2,"filter-map"]],["racket/list","racket"]],
["filter-map",">srfi-std/srfi-1.html#filter-map",[0,[2,"filter-map"]],["srfi/1"]],
["filter-multiple",">unstable/list.html#(def._((lib._unstable/list..rkt)._filter-multiple))",[0,[2,"filter-multiple"]],["unstable/list"]],
["filter-not",">reference/pairs.html#(def._((lib._racket/list..rkt)._filter-not))",[0,[2,"filter-not"]],["racket/list","racket"]],
["filter-notes",">browser/index.html#(meth._(((lib._browser/browser..rkt)._hyper-panel-mixin)._filter-notes))",[[0,[2,"filter-notes"]],[14,[" (method of ",[0,[2,"hyper-panel-mixin"]],")"]]],["browser/browser","browser"]],
["filter-read-input-port",">reference/port-lib.html#(def._((lib._racket/port..rkt)._filter-read-input-port))",[0,[2,"filter-read-input-port"]],["racket/port","racket"]],
["filter-url->path",">web-server-internal/filesystem-map.html#(def._((lib._web-server/dispatchers/filesystem-map..rkt)._filter-url-~3epath))",[0,[2,"filter-url->path"]],["web-server/dispatchers/filesystem-map"]],
["filtered-in",">reference/require.html#(form._((lib._racket/require..rkt)._filtered-in))",[0,[1,"filtered-in"]],["racket/require"]],
["filtered-out",">reference/require.html#(form._((lib._racket/provide..rkt)._filtered-out))",[0,[1,"filtered-out"]],["racket/provide"]],
["filtering requests",">web-server-internal/dispatch-filter.html","Filtering Requests",false],
["final, augment, and inner",">guide/classes.html#(part._inner)","Final, Augment, and Inner",false],
["finalizers",">reference/willexecutor.html#(tech._finalizer)","<span style=\"font-style: italic\">finalizers</span>",false],
["find",">unstable/find.html","Find",false],
["find",">gui/editor-data-class-list___.html#(meth._(((lib._mred/main..rkt)._editor-data-class-list~3c~25~3e)._find))",[[0,[2,"find"]],[14,[" (method of ",[0,[2,"editor-data-class-list<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["find",">gui/snip-class-list___.html#(meth._(((lib._racket/snip..rkt)._snip-class-list~3c~25~3e)._find))",[[0,[2,"find"]],[14,[" (method of ",[0,[2,"snip-class-list<%>"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["find",">r6rs-lib-std/r6rs-lib-Z-H-4.html#node_idx_202",[0,[2,"find"]],["rnrs/lists-6"]],
["find",">srfi-std/srfi-1.html#find",[0,[2,"find"]],["srfi/1"]],
["find",">unstable/find.html#(def._((lib._unstable/find..rkt)._find))",[0,[2,"find"]],["unstable/find"]],
["find again backwards menu item",">drracket/Menus.html#(idx._(gentag._82._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Find Again Backwards</span> menu item",false],
["find again menu item",">drracket/Menus.html#(idx._(gentag._81._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Find Again</span> menu item",false],
["find case sensitive menu item",">drracket/Menus.html#(idx._(gentag._86._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Find Case Sensitive</span> menu item",false],
["find-collects-dir",">raco/dirs.html#(def._((lib._setup/dirs..rkt)._find-collects-dir))",[0,[2,"find-collects-dir"]],["setup/dirs"]],
["find-color",">draw/color-database___.html#(meth._(((lib._racket/draw..rkt)._color-database~3c~25~3e)._find-color))",[[0,[2,"find-color"]],[14,[" (method of ",[0,[2,"color-database<%>"]],")"]]],["racket/draw"]],
["find-console-bin-dir",">raco/dirs.html#(def._((lib._setup/dirs..rkt)._find-console-bin-dir))",[0,[2,"find-console-bin-dir"]],["setup/dirs"]],
["find-dll-dir",">raco/dirs.html#(def._((lib._setup/dirs..rkt)._find-dll-dir))",[0,[2,"find-dll-dir"]],["setup/dirs"]],
["find-doc-dir",">raco/dirs.html#(def._((lib._setup/dirs..rkt)._find-doc-dir))",[0,[2,"find-doc-dir"]],["setup/dirs"]],
["find-down-sexp",">framework/Racket.html#(meth._(((lib._framework/main..rkt)._racket~3atext~3c~25~3e)._find-down-sexp))",[[0,[2,"find-down-sexp"]],[14,[" (method of ",[0,[2,"racket:text<%>"]],")"]]],["framework"]],
["find-exe",">raco/exe.html#(def._((lib._compiler/find-exe..rkt)._find-exe))",[0,[2,"find-exe"]],["compiler/find-exe"]],
["find-executable-path",">reference/Filesystem.html#(def._((lib._racket/private/misc..rkt)._find-executable-path))",[0,[2,"find-executable-path"]],["racket/base","racket"]],
["find-family-default-font-id",">draw/font-name-directory___.html#(meth._(((lib._racket/draw..rkt)._font-name-directory~3c~25~3e)._find-family-default-font-id))",[[0,[2,"find-family-default-font-id"]],[14,[" (method of ",[0,[2,"font-name-directory<%>"]],")"]]],["racket/draw"]],
["find-files",">reference/Filesystem.html#(def._((lib._racket/file..rkt)._find-files))",[0,[2,"find-files"]],["racket/file","racket"]],
["find-first",">unstable/find.html#(def._((lib._unstable/find..rkt)._find-first))",[0,[2,"find-first"]],["unstable/find"]],
["find-first-snip",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._find-first-snip))",[[0,[2,"find-first-snip"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["find-graphical-system-path",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._find-graphical-system-path))",[0,[2,"find-graphical-system-path"]],["racket/gui/base","racket/gui"]],
["find-gui-bin-dir",">raco/dirs.html#(def._((lib._setup/dirs..rkt)._find-gui-bin-dir))",[0,[2,"find-gui-bin-dir"]],["setup/dirs"]],
["find-heap-values",">plai/mutator.html#(def._((lib._plai/random-mutator..rkt)._find-heap-values))",[0,[2,"find-heap-values"]],["plai/random-mutator"]],
["find-help",">scribble/Connecting_to__racket_.html#(def._((lib._help/help-utils..rkt)._find-help))",[0,"find-help"],["help/help-utils"]],
["find-help/lib",">scribble/Connecting_to__racket_.html#(def._((lib._help/help-utils..rkt)._find-help/lib))",[0,"find-help/lib"],["help/help-utils"]],
["find-image",">teachpack/image.html#(def._((lib._htdp/image..rkt)._find-image))",[0,[2,"find-image"]],["htdp/image"]],
["find-image",">deinprogramm/image.html#(def._((lib._deinprogramm/image..rkt)._find-image))",[0,[2,"find-image"]],["teachpack/deinprogramm/image"]],
["find-include-dir",">raco/dirs.html#(def._((lib._setup/dirs..rkt)._find-include-dir))",[0,[2,"find-include-dir"]],["setup/dirs"]],
["find-lib-dir",">raco/dirs.html#(def._((lib._setup/dirs..rkt)._find-lib-dir))",[0,[2,"find-lib-dir"]],["setup/dirs"]],
["find-library-collection-paths",">reference/collects.html#(def._((lib._racket/private/misc..rkt)._find-library-collection-paths))",[0,[2,"find-library-collection-paths"]],["racket/base","racket"]],
["find-line",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._find-line))",[[0,[2,"find-line"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["find-named-style",">gui/style-list_.html#(meth._(((lib._racket/snip..rkt)._style-list~25)._find-named-style))",[[0,[2,"find-named-style"]],[14,[" (method of ",[0,[2,"style-list%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["find-newline",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._find-newline))",[[0,[2,"find-newline"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["find-next-non-string-snip",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._find-next-non-string-snip))",[[0,[2,"find-next-non-string-snip"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["find-next-selected-snip",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._find-next-selected-snip))",[[0,[2,"find-next-selected-snip"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["find-non",">htdp/index.html#(def._((lib._htdp/error..rkt)._find-non))",[0,[2,"find-non"]],["htdp/error"]],
["find-or-create-brush",">draw/brush-list_.html#(meth._(((lib._racket/draw..rkt)._brush-list~25)._find-or-create-brush))",[[0,[2,"find-or-create-brush"]],[14,[" (method of ",[0,[2,"brush-list%"]],")"]]],["racket/draw"]],
["find-or-create-font",">draw/font-list_.html#(meth._(((lib._racket/draw..rkt)._font-list~25)._find-or-create-font))",[[0,[2,"find-or-create-font"]],[14,[" (method of ",[0,[2,"font-list%"]],")"]]],["racket/draw"]],
["find-or-create-font-id",">draw/font-name-directory___.html#(meth._(((lib._racket/draw..rkt)._font-name-directory~3c~25~3e)._find-or-create-font-id))",[[0,[2,"find-or-create-font-id"]],[14,[" (method of ",[0,[2,"font-name-directory<%>"]],")"]]],["racket/draw"]],
["find-or-create-join-style",">gui/style-list_.html#(meth._(((lib._racket/snip..rkt)._style-list~25)._find-or-create-join-style))",[[0,[2,"find-or-create-join-style"]],[14,[" (method of ",[0,[2,"style-list%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["find-or-create-pen",">draw/pen-list_.html#(meth._(((lib._racket/draw..rkt)._pen-list~25)._find-or-create-pen))",[[0,[2,"find-or-create-pen"]],[14,[" (method of ",[0,[2,"pen-list%"]],")"]]],["racket/draw"]],
["find-or-create-style",">gui/style-list_.html#(meth._(((lib._racket/snip..rkt)._style-list~25)._find-or-create-style))",[[0,[2,"find-or-create-style"]],[14,[" (method of ",[0,[2,"style-list%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["find-position",">gui/editor-data-class-list___.html#(meth._(((lib._mred/main..rkt)._editor-data-class-list~3c~25~3e)._find-position))",[[0,[2,"find-position"]],[14,[" (method of ",[0,[2,"editor-data-class-list<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["find-position",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._find-position))",[[0,[2,"find-position"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["find-position",">gui/snip-class-list___.html#(meth._(((lib._racket/snip..rkt)._snip-class-list~3c~25~3e)._find-position))",[[0,[2,"find-position"]],[14,[" (method of ",[0,[2,"snip-class-list<%>"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["find-position-in-line",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._find-position-in-line))",[[0,[2,"find-position-in-line"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["find-relative-path",">reference/More_Path_Utilities.html#(def._((lib._racket/path..rkt)._find-relative-path))",[0,[2,"find-relative-path"]],["racket/path","racket"]],
["find-relevant-directories",">raco/getinfo.html#(def._((lib._setup/getinfo..rkt)._find-relevant-directories))",[0,[2,"find-relevant-directories"]],["setup/getinfo"]],
["find-relevant-directory-records",">raco/getinfo.html#(def._((lib._setup/getinfo..rkt)._find-relevant-directory-records))",[0,[2,"find-relevant-directory-records"]],["setup/getinfo"]],
["find-scroll-line",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._find-scroll-line))",[[0,[2,"find-scroll-line"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["find-scroll-step",">gui/snip_.html#(meth._(((lib._racket/snip..rkt)._snip~25)._find-scroll-step))",[[0,[2,"find-scroll-step"]],[14,[" (method of ",[0,[2,"snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["find-seconds",">reference/time.html#(def._((lib._racket/date..rkt)._find-seconds))",[0,[2,"find-seconds"]],["racket/date"]],
["find-snip",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._find-snip))",[[0,[2,"find-snip"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["find-snip",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._find-snip))",[[0,[2,"find-snip"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["find-string",">gui/list-control___.html#(meth._(((lib._mred/main..rkt)._list-control~3c~25~3e)._find-string))",[[0,[2,"find-string"]],[14,[" (method of ",[0,[2,"list-control<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["find-string",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._find-string))",[[0,[2,"find-string"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["find-string",">framework/Keymap.html#(idx._(gentag._12._(lib._scribblings/framework/framework..scrbl)))","find-string",false],
["find-string-all",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._find-string-all))",[[0,[2,"find-string-all"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["find-string-replace",">framework/Keymap.html#(idx._(gentag._14._(lib._scribblings/framework/framework..scrbl)))","find-string-replace",false],
["find-string-reverse",">framework/Keymap.html#(idx._(gentag._13._(lib._scribblings/framework/framework..scrbl)))","find-string-reverse",false],
["find-system-path",">reference/Filesystem.html#(def._((quote._~23~25kernel)._find-system-path))",[0,[2,"find-system-path"]],["racket/base","racket"]],
["find-tag",">browser/index.html#(meth._(((lib._browser/browser..rkt)._hyper-text-mixin)._find-tag))",[[0,[2,"find-tag"]],[14,[" (method of ",[0,[2,"hyper-text-mixin"]],")"]]],["browser/browser","browser"]],
["find-tag",">unstable/pict.html#(def._((lib._unstable/gui/pict..rkt)._find-tag))",[0,[2,"find-tag"]],["unstable/gui/pict"]],
["find-tag*",">unstable/pict.html#(def._((lib._unstable/gui/pict..rkt)._find-tag*))",[0,[2,"find-tag*"]],["unstable/gui/pict"]],
["find-tail",">srfi-std/srfi-1.html#find-tail",[0,[2,"find-tail"]],["srfi/1"]],
["find-up-sexp",">framework/Racket.html#(meth._(((lib._framework/main..rkt)._racket~3atext~3c~25~3e)._find-up-sexp))",[[0,[2,"find-up-sexp"]],[14,[" (method of ",[0,[2,"racket:text<%>"]],")"]]],["framework"]],
["find-user-collects-dir",">raco/dirs.html#(def._((lib._setup/dirs..rkt)._find-user-collects-dir))",[0,[2,"find-user-collects-dir"]],["setup/dirs"]],
["find-user-doc-dir",">raco/dirs.html#(def._((lib._setup/dirs..rkt)._find-user-doc-dir))",[0,[2,"find-user-doc-dir"]],["setup/dirs"]],
["find-user-include-dir",">raco/dirs.html#(def._((lib._setup/dirs..rkt)._find-user-include-dir))",[0,[2,"find-user-include-dir"]],["setup/dirs"]],
["find-user-lib-dir",">raco/dirs.html#(def._((lib._setup/dirs..rkt)._find-user-lib-dir))",[0,[2,"find-user-lib-dir"]],["setup/dirs"]],
["find-wordbreak",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._find-wordbreak))",[[0,[2,"find-wordbreak"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["find... menu item",">drracket/Menus.html#(idx._(gentag._80._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Find...</span> menu item",false],
["finder",">framework/Finder.html","Finder",false],
["finder:common-get-file",">framework/Finder.html#(def._((lib._framework/main..rkt)._finder~3acommon-get-file))",[0,[2,"finder:common-get-file"]],["framework"]],
["finder:common-get-file-list",">framework/Finder.html#(def._((lib._framework/main..rkt)._finder~3acommon-get-file-list))",[0,[2,"finder:common-get-file-list"]],["framework"]],
["finder:common-put-file",">framework/Finder.html#(def._((lib._framework/main..rkt)._finder~3acommon-put-file))",[0,[2,"finder:common-put-file"]],["framework"]],
["finder:default-extension",">framework/Finder.html#(def._((lib._framework/main..rkt)._finder~3adefault-extension))",[0,[2,"finder:default-extension"]],["framework"]],
["finder:default-filters",">framework/Finder.html#(def._((lib._framework/main..rkt)._finder~3adefault-filters))",[0,[2,"finder:default-filters"]],["framework"]],
["finder:dialog-parent-parameter",">framework/Finder.html#(def._((lib._framework/main..rkt)._finder~3adialog-parent-parameter))",[0,[2,"finder:dialog-parent-parameter"]],["framework"]],
["finder:get-file",">framework/Finder.html#(def._((lib._framework/main..rkt)._finder~3aget-file))",[0,[2,"finder:get-file"]],["framework"]],
["finder:open-file",">framework/Keymap.html#(idx._(gentag._11._(lib._scribblings/framework/framework..scrbl)))","finder:open-file",false],
["finder:put-file",">framework/Finder.html#(def._((lib._framework/main..rkt)._finder~3aput-file))",[0,[2,"finder:put-file"]],["framework"]],
["finder:put-file",">framework/Keymap.html#(idx._(gentag._7._(lib._scribblings/framework/framework..scrbl)))","finder:put-file",false],
["finder:put-file",">framework/Keymap.html#(idx._(gentag._9._(lib._scribblings/framework/framework..scrbl)))","finder:put-file",false],
["finder:std-get-file",">framework/Finder.html#(def._((lib._framework/main..rkt)._finder~3astd-get-file))",[0,[2,"finder:std-get-file"]],["framework"]],
["finder:std-put-file",">framework/Finder.html#(def._((lib._framework/main..rkt)._finder~3astd-put-file))",[0,[2,"finder:std-put-file"]],["framework"]],
["findf",">reference/pairs.html#(def._((lib._racket/private/list..rkt)._findf))",[0,[2,"findf"]],["racket/base","racket"]],
["finding a package",">planet/Using_PLaneT.html#(part._finding-a-package)","Finding a Package",false],
["finding the racket executable",">raco/exe.html#(part._.Finding_the_.Racket_.Executable)","Finding the Racket Executable",false],
["finding useless requires",">macro-debugger/index.html#(part._.Finding_.Useless_requires)",["Finding Useless ",[0,[1,"require"]],"s"],false],
["fine-grained control over package imports",">planet/Using_PLaneT.html#(part._.Fine-.Grained_.Control_.Over_.Package_.Imports)","Fine-Grained Control Over Package Imports",false],
["finite?",">r6rs-std/r6rs-Z-H-14.html#node_idx_484",[0,[2,"finite?"]],["rnrs/base-6"]],
["first",">reference/pairs.html#(def._((lib._racket/list..rkt)._first))",[0,[2,"first"]],["racket/list","racket"]],
["first",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._first))",[0,[2,"first"]],["lang/htdp-advanced"]],
["first",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._first))",[0,[2,"first"]],["lang/htdp-beginner"]],
["first",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._first))",[0,[2,"first"]],["lang/htdp-beginner-abbr"]],
["first",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._first))",[0,[2,"first"]],["lang/htdp-intermediate"]],
["first",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._first))",[0,[2,"first"]],["lang/htdp-intermediate-lambda"]],
["first",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._first))",[0,[2,"first"]],["deinprogramm/DMdA-advanced"]],
["first",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._first))",[0,[2,"first"]],["deinprogramm/DMdA-assignments"]],
["first",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._first))",[0,[2,"first"]],["deinprogramm/DMdA-vanilla"]],
["first",">lazy/index.html#(def._((lib._lazy/main..rkt)._first))",[0,[2,"first"]],["lazy"]],
["first",">mzlib/mzlib_list.html#(def._((lib._mzlib/list..rkt)._first))",[0,[2,"first"]],["mzlib/list"]],
["first",">plai/mutator.html#(def._((lib._plai/mutator..rkt)._first))",[0,[2,"first"]],["plai/mutator"]],
["first",">srfi-std/srfi-1.html#first",[0,[2,"first"]],["srfi/1"]],
["first-class units",">guide/firstclassunits.html","First-Class Units",false],
["first-ec",">srfi-std/srfi-42.html#first-ec",[0,[1,"first-ec"]],["srfi/42"]],
["first-line-currently-drawn-specially?",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3afirst-line~3c~25~3e)._first-line-currently-drawn-specially~3f))",[[0,[2,"first-line-currently-drawn-specially?"]],[14,[" (method of ",[0,[2,"text:first-line<%>"]],")"]]],["framework"]],
["first-opened",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3alanguage~3c~25~3e)._first-opened))",[[0,[2,"first-opened"]],[14,[" (method of ",[0,[2,"drracket:language:language<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["first-order->higher-order",">htdp/index.html#(form._((lib._lang/prim..rkt)._first-order-~3ehigher-order))",[0,[1,"first-order->higher-order"]],["lang/prim"]],
["fixed auto-converting string types",">foreign/String_Types.html#(part._.Fixed_.Auto-.Converting_.String_.Types)","Fixed Auto-Converting String Types",false],
["fixed but statically unknown arities",">guide/contracts-general-functions.html#(part._contracts-no-domain)","Fixed but Statically Unknown Arities",false],
["fixed-width-label-snip",">embedded-gui/Helpers.html#(def._((lib._embedded-gui/main..rkt)._fixed-width-label-snip))",[0,[2,"fixed-width-label-snip"]],["embedded-gui"]],
["fixing broken calls to points",">plot/porting.html#(part._.Fixing_.Broken_.Calls_to_points)",["Fixing Broken Calls to ",[0,[2,"points"]]],false],
["fixnum",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Fixnum))",[0,[1,"Fixnum"]],["typed/racket/base","typed/racket"]],
["fixnum",">guide/performance.html#(tech._fixnum)","<span style=\"font-style: italic\">fixnum</span>",false],
["fixnum",">reference/numbers.html#(tech._fixnum)","<span style=\"font-style: italic\">fixnum</span>",false],
["fixnum and flonum optimizations",">guide/performance.html#(part._fixnums+flonums)","Fixnum and Flonum Optimizations",false],
["fixnum arithmetic",">reference/fixnums.html#(part._.Fixnum_.Arithmetic)","Fixnum Arithmetic",false],
["fixnum vectors",">reference/fixnums.html#(part._.Fixnum_.Vectors)","Fixnum Vectors",false],
["fixnum->flonum",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1060",[0,[2,"fixnum->flonum"]],["rnrs/arithmetic/flonums-6"]],
["fixnum-width",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_858",[0,[2,"fixnum-width"]],["rnrs/arithmetic/fixnums-6"]],
["fixnum?",">reference/number-types.html#(def._((quote._~23~25kernel)._fixnum~3f))",[0,[2,"fixnum?"]],["racket/base","racket"]],
["fixnum?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_856",[0,[2,"fixnum?"]],["rnrs/arithmetic/fixnums-6"]],
["fixnums",">reference/fixnums.html","Fixnums",false],
["fl*",">reference/flonums.html#(def._((lib._racket/flonum..rkt)._fl*))",[0,[2,"fl*"]],["racket/flonum"]],
["fl*",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_988",[0,[2,"fl*"]],["rnrs/arithmetic/flonums-6"]],
["fl+",">reference/flonums.html#(def._((lib._racket/flonum..rkt)._fl+))",[0,[2,"fl+"]],["racket/flonum"]],
["fl+",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_986",[0,[2,"fl+"]],["rnrs/arithmetic/flonums-6"]],
["fl-",">reference/flonums.html#(def._((lib._racket/flonum..rkt)._fl-))",[0,[2,"fl-"]],["racket/flonum"]],
["fl-",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_990",[0,[2,"fl-"]],["rnrs/arithmetic/flonums-6"]],
["fl->exact-integer",">reference/flonums.html#(def._((lib._racket/flonum..rkt)._fl-~3eexact-integer))",[0,[2,"fl->exact-integer"]],["racket/flonum"]],
["fl->fx",">reference/fixnums.html#(def._((lib._racket/fixnum..rkt)._fl-~3efx))",[0,[2,"fl->fx"]],["racket/fixnum"]],
["fl/",">reference/flonums.html#(def._((lib._racket/flonum..rkt)._fl/))",[0,[2,"fl/"]],["racket/flonum"]],
["fl/",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_994",[0,[2,"fl/"]],["rnrs/arithmetic/flonums-6"]],
["fl<",">reference/flonums.html#(def._((lib._racket/flonum..rkt)._fl~3c))",[0,[2,"fl<"]],["racket/flonum"]],
["fl<=",">reference/flonums.html#(def._((lib._racket/flonum..rkt)._fl~3c~3d))",[0,[2,"fl<="]],["racket/flonum"]],
["fl<=?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_958",[0,[2,"fl<=?"]],["rnrs/arithmetic/flonums-6"]],
["fl<?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_956",[0,[2,"fl<?"]],["rnrs/arithmetic/flonums-6"]],
["fl=",">reference/flonums.html#(def._((lib._racket/flonum..rkt)._fl~3d))",[0,[2,"fl="]],["racket/flonum"]],
["fl=?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_954",[0,[2,"fl=?"]],["rnrs/arithmetic/flonums-6"]],
["fl>",">reference/flonums.html#(def._((lib._racket/flonum..rkt)._fl~3e))",[0,[2,"fl>"]],["racket/flonum"]],
["fl>=",">reference/flonums.html#(def._((lib._racket/flonum..rkt)._fl~3e~3d))",[0,[2,"fl>="]],["racket/flonum"]],
["fl>=?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_962",[0,[2,"fl>=?"]],["rnrs/arithmetic/flonums-6"]],
["fl>?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_960",[0,[2,"fl>?"]],["rnrs/arithmetic/flonums-6"]],
["flabs",">reference/flonums.html#(def._((lib._racket/flonum..rkt)._flabs))",[0,[2,"flabs"]],["racket/flonum"]],
["flabs",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_998",[0,[2,"flabs"]],["rnrs/arithmetic/flonums-6"]],
["flacos",">reference/flonums.html#(def._((lib._racket/flonum..rkt)._flacos))",[0,[2,"flacos"]],["racket/flonum"]],
["flacos",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1038",[0,[2,"flacos"]],["rnrs/arithmetic/flonums-6"]],
["flag",">scribble/doc-strings.html#(def._((lib._scribble/manual..rkt)._.Flag))",[0,[2,"Flag"]],["scribble/manual"]],
["flags and hooks",">inside/Flags_and_Hooks.html","Flags and Hooks",false],
["flash",">slideshow/More_Pict_Constructors.html#(part._.Flash)","Flash",false],
["flash-backward-sexp",">framework/Racket.html#(meth._(((lib._framework/main..rkt)._racket~3atext~3c~25~3e)._flash-backward-sexp))",[[0,[2,"flash-backward-sexp"]],[14,[" (method of ",[0,[2,"racket:text<%>"]],")"]]],["framework"]],
["flash-forward-sexp",">framework/Racket.html#(meth._(((lib._framework/main..rkt)._racket~3atext~3c~25~3e)._flash-forward-sexp))",[[0,[2,"flash-forward-sexp"]],[14,[" (method of ",[0,[2,"racket:text<%>"]],")"]]],["framework"]],
["flash-off",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._flash-off))",[[0,[2,"flash-off"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["flash-on",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._flash-on))",[[0,[2,"flash-on"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["flashing parenthesis matches",">drracket/editor.html#(idx._(gentag._17._(lib._scribblings/drracket/drracket..scrbl)))","flashing parenthesis matches",false],
["flasin",">reference/flonums.html#(def._((lib._racket/flonum..rkt)._flasin))",[0,[2,"flasin"]],["racket/flonum"]],
["flasin",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1036",[0,[2,"flasin"]],["rnrs/arithmetic/flonums-6"]],
["flat contract",">reference/data-structure-contracts.html#(tech._flat._contract)","<span style=\"font-style: italic\">flat contract</span>",false],
["flat contract property",">reference/Building_New_Contract_Combinators.html#(tech._flat._contract._property)","<span style=\"font-style: italic\">flat contract property</span>",false],
["flat named contracts",">guide/contract-func.html#(tech._flat._named._contract)","<span style=\"font-style: italic\">flat named\ncontracts</span>",false],
["flat-contract",">reference/data-structure-contracts.html#(def._((lib._racket/contract/private/misc..rkt)._flat-contract))",[0,[2,"flat-contract"]],["racket/contract/base","racket/contract","racket"]],
["flat-contract-predicate",">reference/contract-utilities.html#(def._((lib._racket/contract/private/misc..rkt)._flat-contract-predicate))",[0,[2,"flat-contract-predicate"]],["racket/contract/base","racket/contract","racket"]],
["flat-contract-property?",">reference/Building_New_Contract_Combinators.html#(def._((lib._racket/contract/private/prop..rkt)._flat-contract-property~3f))",[0,[2,"flat-contract-property?"]],["racket/contract/combinator","racket/contract","racket"]],
["flat-contract?",">reference/contract-utilities.html#(def._((lib._racket/contract/private/misc..rkt)._flat-contract~3f))",[0,[2,"flat-contract?"]],["racket/contract/base","racket/contract","racket"]],
["flat-murec-contract",">reference/data-structure-contracts.html#(form._((lib._racket/contract/private/misc..rkt)._flat-murec-contract))",[0,[1,"flat-murec-contract"]],["racket/contract/base","racket/contract","racket"]],
["flat-named-contract",">reference/data-structure-contracts.html#(def._((lib._racket/contract/private/misc..rkt)._flat-named-contract))",[0,[2,"flat-named-contract"]],["racket/contract/base","racket/contract","racket"]],
["flat-rec-contract",">reference/data-structure-contracts.html#(form._((lib._racket/contract/private/misc..rkt)._flat-rec-contract))",[0,[1,"flat-rec-contract"]],["racket/contract/base","racket/contract","racket"]],
["flatan",">reference/flonums.html#(def._((lib._racket/flonum..rkt)._flatan))",[0,[2,"flatan"]],["racket/flonum"]],
["flatan",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1040",[0,[2,"flatan"]],["rnrs/arithmetic/flonums-6"]],
["flatten",">reference/pairs.html#(def._((lib._racket/list..rkt)._flatten))",[0,[2,"flatten"]],["racket/list","racket"]],
["flatten-begin",">syntax/transformer-helpers.html#(def._((lib._syntax/flatten-begin..rkt)._flatten-begin))",[0,[2,"flatten-begin"]],["syntax/flatten-begin"]],
["flatten-bitmap",">mrlib/Cache-image_Snip.html#(def._((lib._mrlib/cache-image-snip..rkt)._flatten-bitmap))",[0,[2,"flatten-bitmap"]],["mrlib/cache-image-snip"]],
["flattened text",">gui/editor-overview.html#(part._editorflattened)","Flattened Text",false],
["flattened text",">gui/editor-overview.html#(tech._flattened._text)","<span style=\"font-style: italic\">Flattened text</span>",false],
["flattening begin forms",">syntax/transformer-helpers.html#(part._flatten-begin)",["Flattening ",[0,[1,"begin"]]," Forms"],false],
["flceiling",">reference/flonums.html#(def._((lib._racket/flonum..rkt)._flceiling))",[0,[2,"flceiling"]],["racket/flonum"]],
["flceiling",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1018",[0,[2,"flceiling"]],["rnrs/arithmetic/flonums-6"]],
["flcos",">reference/flonums.html#(def._((lib._racket/flonum..rkt)._flcos))",[0,[2,"flcos"]],["racket/flonum"]],
["flcos",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1032",[0,[2,"flcos"]],["rnrs/arithmetic/flonums-6"]],
["fldenominator",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1014",[0,[2,"fldenominator"]],["rnrs/arithmetic/flonums-6"]],
["fldiv",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1002",[0,[2,"fldiv"]],["rnrs/arithmetic/flonums-6"]],
["fldiv-and-mod",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1000",[0,[2,"fldiv-and-mod"]],["rnrs/arithmetic/flonums-6"]],
["fldiv0",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1008",[0,[2,"fldiv0"]],["rnrs/arithmetic/flonums-6"]],
["fldiv0-and-mod0",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1006",[0,[2,"fldiv0-and-mod0"]],["rnrs/arithmetic/flonums-6"]],
["fleven?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_974",[0,[2,"fleven?"]],["rnrs/arithmetic/flonums-6"]],
["flexible fill",">draw/region_.html#(tech._flexible._fill)","<span style=\"font-style: italic\">flexible fill</span>",false],
["flexp",">reference/flonums.html#(def._((lib._racket/flonum..rkt)._flexp))",[0,[2,"flexp"]],["racket/flonum"]],
["flexp",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1024",[0,[2,"flexp"]],["rnrs/arithmetic/flonums-6"]],
["flexpt",">reference/flonums.html#(def._((lib._racket/flonum..rkt)._flexpt))",[0,[2,"flexpt"]],["racket/flonum"]],
["flexpt",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1046",[0,[2,"flexpt"]],["rnrs/arithmetic/flonums-6"]],
["flfinite?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_976",[0,[2,"flfinite?"]],["rnrs/arithmetic/flonums-6"]],
["flfloor",">reference/flonums.html#(def._((lib._racket/flonum..rkt)._flfloor))",[0,[2,"flfloor"]],["racket/flonum"]],
["flfloor",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1016",[0,[2,"flfloor"]],["rnrs/arithmetic/flonums-6"]],
["flimag-part",">reference/flonums.html#(def._((lib._racket/flonum..rkt)._flimag-part))",[0,[2,"flimag-part"]],["racket/flonum"]],
["flinfinite?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_978",[0,[2,"flinfinite?"]],["rnrs/arithmetic/flonums-6"]],
["flinteger?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_964",[0,[2,"flinteger?"]],["rnrs/arithmetic/flonums-6"]],
["flip",">cards/index.html#(meth._(((lib._games/cards..rkt)._card~3c~25~3e)._flip))",[[0,[2,"flip"]],[14,[" (method of ",[0,[2,"card<%>"]],")"]]],["games/cards"]],
["flip-card",">cards/index.html#(meth._(((lib._games/cards..rkt)._table~3c~25~3e)._flip-card))",[[0,[2,"flip-card"]],[14,[" (method of ",[0,[2,"table<%>"]],")"]]],["games/cards"]],
["flip-cards",">cards/index.html#(meth._(((lib._games/cards..rkt)._table~3c~25~3e)._flip-cards))",[[0,[2,"flip-cards"]],[14,[" (method of ",[0,[2,"table<%>"]],")"]]],["games/cards"]],
["flip-ellipse",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..rkt)._flip-ellipse))",[0,[2,"flip-ellipse"]],["graphics/graphics"]],
["flip-horizontal",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._flip-horizontal))",[0,[2,"flip-horizontal"]],["2htdp/image"]],
["flip-line",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..rkt)._flip-line))",[0,[2,"flip-line"]],["graphics/graphics"]],
["flip-main",">picturing-programs/index.html#(def._((lib._picturing-programs/private/tiles..rkt)._flip-main))",[0,[2,"flip-main"]],["picturing-programs/private/tiles","picturing-programs"]],
["flip-other",">picturing-programs/index.html#(def._((lib._picturing-programs/private/tiles..rkt)._flip-other))",[0,[2,"flip-other"]],["picturing-programs/private/tiles","picturing-programs"]],
["flip-pixel",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..rkt)._flip-pixel))",[0,[2,"flip-pixel"]],["graphics/graphics"]],
["flip-polygon",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..rkt)._flip-polygon))",[0,[2,"flip-polygon"]],["graphics/graphics"]],
["flip-rectangle",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..rkt)._flip-rectangle))",[0,[2,"flip-rectangle"]],["graphics/graphics"]],
["flip-solid-ellipse",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..rkt)._flip-solid-ellipse))",[0,[2,"flip-solid-ellipse"]],["graphics/graphics"]],
["flip-solid-polygon",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..rkt)._flip-solid-polygon))",[0,[2,"flip-solid-polygon"]],["graphics/graphics"]],
["flip-solid-rectangle",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..rkt)._flip-solid-rectangle))",[0,[2,"flip-solid-rectangle"]],["graphics/graphics"]],
["flip-string",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..rkt)._flip-string))",[0,[2,"flip-string"]],["graphics/graphics"]],
["flip-vertical",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._flip-vertical))",[0,[2,"flip-vertical"]],["2htdp/image"]],
["flip-viewport",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..rkt)._flip-viewport))",[0,[2,"flip-viewport"]],["graphics/graphics"]],
["fllog",">reference/flonums.html#(def._((lib._racket/flonum..rkt)._fllog))",[0,[2,"fllog"]],["racket/flonum"]],
["fllog",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1026",[0,[2,"fllog"]],["rnrs/arithmetic/flonums-6"]],
["flmax",">reference/flonums.html#(def._((lib._racket/flonum..rkt)._flmax))",[0,[2,"flmax"]],["racket/flonum"]],
["flmax",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_982",[0,[2,"flmax"]],["rnrs/arithmetic/flonums-6"]],
["flmin",">reference/flonums.html#(def._((lib._racket/flonum..rkt)._flmin))",[0,[2,"flmin"]],["racket/flonum"]],
["flmin",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_984",[0,[2,"flmin"]],["rnrs/arithmetic/flonums-6"]],
["flmod",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1004",[0,[2,"flmod"]],["rnrs/arithmetic/flonums-6"]],
["flmod0",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1010",[0,[2,"flmod0"]],["rnrs/arithmetic/flonums-6"]],
["flnan?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_980",[0,[2,"flnan?"]],["rnrs/arithmetic/flonums-6"]],
["flnegative?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_970",[0,[2,"flnegative?"]],["rnrs/arithmetic/flonums-6"]],
["flnext",">unstable/flonum.html#(def._((lib._unstable/flonum..rkt)._flnext))",[0,[2,"flnext"]],["unstable/flonum"]],
["flnumerator",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1012",[0,[2,"flnumerator"]],["rnrs/arithmetic/flonums-6"]],
["float",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Float))",[0,[1,"Float"]],["typed/racket/base","typed/racket"]],
["float-complex",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Float-.Complex))",[0,[1,"Float-Complex"]],["typed/racket/base","typed/racket"]],
["float-nan",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Float-.Nan))",[0,[1,"Float-Nan"]],["typed/racket/base","typed/racket"]],
["float-negative-zero",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Float-.Negative-.Zero))",[0,[1,"Float-Negative-Zero"]],["typed/racket/base","typed/racket"]],
["float-positive-zero",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Float-.Positive-.Zero))",[0,[1,"Float-Positive-Zero"]],["typed/racket/base","typed/racket"]],
["float-zero",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Float-.Zero))",[0,[1,"Float-Zero"]],["typed/racket/base","typed/racket"]],
["floating-point bitmaps",">images/flomap_title.html","Floating-Point Bitmaps",false],
["floating-point-bytes->real",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._floating-point-bytes-~3ereal))",[0,[2,"floating-point-bytes->real"]],["racket/base","racket"]],
["flodd?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_972",[0,[2,"flodd?"]],["rnrs/arithmetic/flonums-6"]],
["flomap",">images/Struct_Type_and_Accessors.html#(def._((lib._images/flomap..rkt)._flomap))",[0,[2,"flomap"]],["images/flomap"]],
["flomap-2d-mapping",">images/Spatial_Transformations.html#(def._((lib._images/flomap..rkt)._flomap-2d-mapping))",[0,[2,"flomap-2d-mapping"]],["images/flomap"]],
["flomap-2d-mapping-bounded-by",">images/Spatial_Transformations.html#(def._((lib._images/flomap..rkt)._flomap-2d-mapping-bounded-by))",[0,[2,"flomap-2d-mapping-bounded-by"]],["images/flomap"]],
["flomap-2d-mapping-fun",">images/Spatial_Transformations.html#(def._((lib._images/flomap..rkt)._flomap-2d-mapping-fun))",[0,[2,"flomap-2d-mapping-fun"]],["images/flomap"]],
["flomap-2d-mapping-inv",">images/Spatial_Transformations.html#(def._((lib._images/flomap..rkt)._flomap-2d-mapping-inv))",[0,[2,"flomap-2d-mapping-inv"]],["images/flomap"]],
["flomap-2d-mapping?",">images/Spatial_Transformations.html#(def._((lib._images/flomap..rkt)._flomap-2d-mapping~3f))",[0,[2,"flomap-2d-mapping?"]],["images/flomap"]],
["flomap->bitmap",">images/Conversion_and_Construction.html#(def._((lib._images/flomap..rkt)._flomap-~3ebitmap))",[0,[2,"flomap->bitmap"]],["images/flomap"]],
["flomap-append-components",">images/Component_Operations.html#(def._((lib._images/flomap..rkt)._flomap-append-components))",[0,[2,"flomap-append-components"]],["images/flomap"]],
["flomap-bilinear-ref",">images/Struct_Type_and_Accessors.html#(def._((lib._images/flomap..rkt)._flomap-bilinear-ref))",[0,[2,"flomap-bilinear-ref"]],["images/flomap"]],
["flomap-bilinear-ref*",">images/Struct_Type_and_Accessors.html#(def._((lib._images/flomap..rkt)._flomap-bilinear-ref*))",[0,[2,"flomap-bilinear-ref*"]],["images/flomap"]],
["flomap-blur",">images/Blur.html#(def._((lib._images/flomap..rkt)._flomap-blur))",[0,[2,"flomap-blur"]],["images/flomap"]],
["flomap-blur-x",">images/Blur.html#(def._((lib._images/flomap..rkt)._flomap-blur-x))",[0,[2,"flomap-blur-x"]],["images/flomap"]],
["flomap-blur-y",">images/Blur.html#(def._((lib._images/flomap..rkt)._flomap-blur-y))",[0,[2,"flomap-blur-y"]],["images/flomap"]],
["flomap-box-blur",">images/Blur.html#(def._((lib._images/flomap..rkt)._flomap-box-blur))",[0,[2,"flomap-box-blur"]],["images/flomap"]],
["flomap-box-blur-x",">images/Blur.html#(def._((lib._images/flomap..rkt)._flomap-box-blur-x))",[0,[2,"flomap-box-blur-x"]],["images/flomap"]],
["flomap-box-blur-y",">images/Blur.html#(def._((lib._images/flomap..rkt)._flomap-box-blur-y))",[0,[2,"flomap-box-blur-y"]],["images/flomap"]],
["flomap-cb-crop",">images/Resizing.html#(def._((lib._images/flomap..rkt)._flomap-cb-crop))",[0,[2,"flomap-cb-crop"]],["images/flomap"]],
["flomap-cb-superimpose",">images/Compositing.html#(def._((lib._images/flomap..rkt)._flomap-cb-superimpose))",[0,[2,"flomap-cb-superimpose"]],["images/flomap"]],
["flomap-cc-crop",">images/Resizing.html#(def._((lib._images/flomap..rkt)._flomap-cc-crop))",[0,[2,"flomap-cc-crop"]],["images/flomap"]],
["flomap-cc-superimpose",">images/Compositing.html#(def._((lib._images/flomap..rkt)._flomap-cc-superimpose))",[0,[2,"flomap-cc-superimpose"]],["images/flomap"]],
["flomap-ccw-rotate",">images/Spatial_Transformations.html#(def._((lib._images/flomap..rkt)._flomap-ccw-rotate))",[0,[2,"flomap-ccw-rotate"]],["images/flomap"]],
["flomap-components",">images/Struct_Type_and_Accessors.html#(def._((lib._images/flomap..rkt)._flomap-components))",[0,[2,"flomap-components"]],["images/flomap"]],
["flomap-copy",">images/Resizing.html#(def._((lib._images/flomap..rkt)._flomap-copy))",[0,[2,"flomap-copy"]],["images/flomap"]],
["flomap-crop",">images/Resizing.html#(def._((lib._images/flomap..rkt)._flomap-crop))",[0,[2,"flomap-crop"]],["images/flomap"]],
["flomap-ct-crop",">images/Resizing.html#(def._((lib._images/flomap..rkt)._flomap-ct-crop))",[0,[2,"flomap-ct-crop"]],["images/flomap"]],
["flomap-ct-superimpose",">images/Compositing.html#(def._((lib._images/flomap..rkt)._flomap-ct-superimpose))",[0,[2,"flomap-ct-superimpose"]],["images/flomap"]],
["flomap-cw-rotate",">images/Spatial_Transformations.html#(def._((lib._images/flomap..rkt)._flomap-cw-rotate))",[0,[2,"flomap-cw-rotate"]],["images/flomap"]],
["flomap-divide-alpha",">images/Conversion_and_Construction.html#(def._((lib._images/flomap..rkt)._flomap-divide-alpha))",[0,[2,"flomap-divide-alpha"]],["images/flomap"]],
["flomap-drop-components",">images/Component_Operations.html#(def._((lib._images/flomap..rkt)._flomap-drop-components))",[0,[2,"flomap-drop-components"]],["images/flomap"]],
["flomap-extreme-values",">images/Struct_Type_and_Accessors.html#(def._((lib._images/flomap..rkt)._flomap-extreme-values))",[0,[2,"flomap-extreme-values"]],["images/flomap"]],
["flomap-fisheye-transform",">images/Spatial_Transformations.html#(def._((lib._images/flomap..rkt)._flomap-fisheye-transform))",[0,[2,"flomap-fisheye-transform"]],["images/flomap"]],
["flomap-flip-horizontal",">images/Spatial_Transformations.html#(def._((lib._images/flomap..rkt)._flomap-flip-horizontal))",[0,[2,"flomap-flip-horizontal"]],["images/flomap"]],
["flomap-flip-vertical",">images/Spatial_Transformations.html#(def._((lib._images/flomap..rkt)._flomap-flip-vertical))",[0,[2,"flomap-flip-vertical"]],["images/flomap"]],
["flomap-gaussian-blur",">images/Blur.html#(def._((lib._images/flomap..rkt)._flomap-gaussian-blur))",[0,[2,"flomap-gaussian-blur"]],["images/flomap"]],
["flomap-gaussian-blur-x",">images/Blur.html#(def._((lib._images/flomap..rkt)._flomap-gaussian-blur-x))",[0,[2,"flomap-gaussian-blur-x"]],["images/flomap"]],
["flomap-gaussian-blur-y",">images/Blur.html#(def._((lib._images/flomap..rkt)._flomap-gaussian-blur-y))",[0,[2,"flomap-gaussian-blur-y"]],["images/flomap"]],
["flomap-gradient",">images/Gradients_and_Normals.html#(def._((lib._images/flomap..rkt)._flomap-gradient))",[0,[2,"flomap-gradient"]],["images/flomap"]],
["flomap-gradient-normal",">images/Gradients_and_Normals.html#(def._((lib._images/flomap..rkt)._flomap-gradient-normal))",[0,[2,"flomap-gradient-normal"]],["images/flomap"]],
["flomap-gradient-x",">images/Gradients_and_Normals.html#(def._((lib._images/flomap..rkt)._flomap-gradient-x))",[0,[2,"flomap-gradient-x"]],["images/flomap"]],
["flomap-gradient-y",">images/Gradients_and_Normals.html#(def._((lib._images/flomap..rkt)._flomap-gradient-y))",[0,[2,"flomap-gradient-y"]],["images/flomap"]],
["flomap-hb-append",">images/Compositing.html#(def._((lib._images/flomap..rkt)._flomap-hb-append))",[0,[2,"flomap-hb-append"]],["images/flomap"]],
["flomap-hc-append",">images/Compositing.html#(def._((lib._images/flomap..rkt)._flomap-hc-append))",[0,[2,"flomap-hc-append"]],["images/flomap"]],
["flomap-height",">images/Struct_Type_and_Accessors.html#(def._((lib._images/flomap..rkt)._flomap-height))",[0,[2,"flomap-height"]],["images/flomap"]],
["flomap-ht-append",">images/Compositing.html#(def._((lib._images/flomap..rkt)._flomap-ht-append))",[0,[2,"flomap-ht-append"]],["images/flomap"]],
["flomap-id-transform",">images/Spatial_Transformations.html#(def._((lib._images/flomap..rkt)._flomap-id-transform))",[0,[2,"flomap-id-transform"]],["images/flomap"]],
["flomap-inset",">images/Resizing.html#(def._((lib._images/flomap..rkt)._flomap-inset))",[0,[2,"flomap-inset"]],["images/flomap"]],
["flomap-lb-crop",">images/Resizing.html#(def._((lib._images/flomap..rkt)._flomap-lb-crop))",[0,[2,"flomap-lb-crop"]],["images/flomap"]],
["flomap-lb-superimpose",">images/Compositing.html#(def._((lib._images/flomap..rkt)._flomap-lb-superimpose))",[0,[2,"flomap-lb-superimpose"]],["images/flomap"]],
["flomap-lc-crop",">images/Resizing.html#(def._((lib._images/flomap..rkt)._flomap-lc-crop))",[0,[2,"flomap-lc-crop"]],["images/flomap"]],
["flomap-lc-superimpose",">images/Compositing.html#(def._((lib._images/flomap..rkt)._flomap-lc-superimpose))",[0,[2,"flomap-lc-superimpose"]],["images/flomap"]],
["flomap-lift",">images/Pointwise_Operations.html#(def._((lib._images/flomap..rkt)._flomap-lift))",[0,[2,"flomap-lift"]],["images/flomap"]],
["flomap-lift2",">images/Pointwise_Operations.html#(def._((lib._images/flomap..rkt)._flomap-lift2))",[0,[2,"flomap-lift2"]],["images/flomap"]],
["flomap-lt-crop",">images/Resizing.html#(def._((lib._images/flomap..rkt)._flomap-lt-crop))",[0,[2,"flomap-lt-crop"]],["images/flomap"]],
["flomap-lt-superimpose",">images/Compositing.html#(def._((lib._images/flomap..rkt)._flomap-lt-superimpose))",[0,[2,"flomap-lt-superimpose"]],["images/flomap"]],
["flomap-max-value",">images/Struct_Type_and_Accessors.html#(def._((lib._images/flomap..rkt)._flomap-max-value))",[0,[2,"flomap-max-value"]],["images/flomap"]],
["flomap-min-value",">images/Struct_Type_and_Accessors.html#(def._((lib._images/flomap..rkt)._flomap-min-value))",[0,[2,"flomap-min-value"]],["images/flomap"]],
["flomap-multiply-alpha",">images/Conversion_and_Construction.html#(def._((lib._images/flomap..rkt)._flomap-multiply-alpha))",[0,[2,"flomap-multiply-alpha"]],["images/flomap"]],
["flomap-nonzero-rect",">images/Struct_Type_and_Accessors.html#(def._((lib._images/flomap..rkt)._flomap-nonzero-rect))",[0,[2,"flomap-nonzero-rect"]],["images/flomap"]],
["flomap-normalize",">images/Pointwise_Operations.html#(def._((lib._images/flomap..rkt)._flomap-normalize))",[0,[2,"flomap-normalize"]],["images/flomap"]],
["flomap-outline",">images/Effects.html#(def._((lib._images/flomap..rkt)._flomap-outline))",[0,[2,"flomap-outline"]],["images/flomap"]],
["flomap-pin",">images/Compositing.html#(def._((lib._images/flomap..rkt)._flomap-pin))",[0,[2,"flomap-pin"]],["images/flomap"]],
["flomap-pin*",">images/Compositing.html#(def._((lib._images/flomap..rkt)._flomap-pin*))",[0,[2,"flomap-pin*"]],["images/flomap"]],
["flomap-projection-transform",">images/Spatial_Transformations.html#(def._((lib._images/flomap..rkt)._flomap-projection-transform))",[0,[2,"flomap-projection-transform"]],["images/flomap"]],
["flomap-rb-crop",">images/Resizing.html#(def._((lib._images/flomap..rkt)._flomap-rb-crop))",[0,[2,"flomap-rb-crop"]],["images/flomap"]],
["flomap-rb-superimpose",">images/Compositing.html#(def._((lib._images/flomap..rkt)._flomap-rb-superimpose))",[0,[2,"flomap-rb-superimpose"]],["images/flomap"]],
["flomap-rc-crop",">images/Resizing.html#(def._((lib._images/flomap..rkt)._flomap-rc-crop))",[0,[2,"flomap-rc-crop"]],["images/flomap"]],
["flomap-rc-superimpose",">images/Compositing.html#(def._((lib._images/flomap..rkt)._flomap-rc-superimpose))",[0,[2,"flomap-rc-superimpose"]],["images/flomap"]],
["flomap-ref",">images/Struct_Type_and_Accessors.html#(def._((lib._images/flomap..rkt)._flomap-ref))",[0,[2,"flomap-ref"]],["images/flomap"]],
["flomap-ref*",">images/Struct_Type_and_Accessors.html#(def._((lib._images/flomap..rkt)._flomap-ref*))",[0,[2,"flomap-ref*"]],["images/flomap"]],
["flomap-ref-component",">images/Component_Operations.html#(def._((lib._images/flomap..rkt)._flomap-ref-component))",[0,[2,"flomap-ref-component"]],["images/flomap"]],
["flomap-resize",">images/Resizing.html#(def._((lib._images/flomap..rkt)._flomap-resize))",[0,[2,"flomap-resize"]],["images/flomap"]],
["flomap-rotate",">images/Spatial_Transformations.html#(def._((lib._images/flomap..rkt)._flomap-rotate))",[0,[2,"flomap-rotate"]],["images/flomap"]],
["flomap-rotate-transform",">images/Spatial_Transformations.html#(def._((lib._images/flomap..rkt)._flomap-rotate-transform))",[0,[2,"flomap-rotate-transform"]],["images/flomap"]],
["flomap-rt-crop",">images/Resizing.html#(def._((lib._images/flomap..rkt)._flomap-rt-crop))",[0,[2,"flomap-rt-crop"]],["images/flomap"]],
["flomap-rt-superimpose",">images/Compositing.html#(def._((lib._images/flomap..rkt)._flomap-rt-superimpose))",[0,[2,"flomap-rt-superimpose"]],["images/flomap"]],
["flomap-scale",">images/Resizing.html#(def._((lib._images/flomap..rkt)._flomap-scale))",[0,[2,"flomap-scale"]],["images/flomap"]],
["flomap-scale-transform",">images/Spatial_Transformations.html#(def._((lib._images/flomap..rkt)._flomap-scale-transform))",[0,[2,"flomap-scale-transform"]],["images/flomap"]],
["flomap-shadow",">images/Effects.html#(def._((lib._images/flomap..rkt)._flomap-shadow))",[0,[2,"flomap-shadow"]],["images/flomap"]],
["flomap-size",">images/Struct_Type_and_Accessors.html#(def._((lib._images/flomap..rkt)._flomap-size))",[0,[2,"flomap-size"]],["images/flomap"]],
["flomap-take-components",">images/Component_Operations.html#(def._((lib._images/flomap..rkt)._flomap-take-components))",[0,[2,"flomap-take-components"]],["images/flomap"]],
["flomap-transform",">images/Spatial_Transformations.html#(form._((lib._images/flomap..rkt)._.Flomap-.Transform))",[0,[1,"Flomap-Transform"]],["images/flomap"]],
["flomap-transform",">images/Spatial_Transformations.html#(def._((lib._images/flomap..rkt)._flomap-transform))",[0,[2,"flomap-transform"]],["images/flomap"]],
["flomap-transform-bounds",">images/Spatial_Transformations.html#(def._((lib._images/flomap..rkt)._flomap-transform-bounds))",[0,[2,"flomap-transform-bounds"]],["images/flomap"]],
["flomap-transform-compose",">images/Spatial_Transformations.html#(def._((lib._images/flomap..rkt)._flomap-transform-compose))",[0,[2,"flomap-transform-compose"]],["images/flomap"]],
["flomap-transpose",">images/Spatial_Transformations.html#(def._((lib._images/flomap..rkt)._flomap-transpose))",[0,[2,"flomap-transpose"]],["images/flomap"]],
["flomap-trim",">images/Resizing.html#(def._((lib._images/flomap..rkt)._flomap-trim))",[0,[2,"flomap-trim"]],["images/flomap"]],
["flomap-values",">images/Struct_Type_and_Accessors.html#(def._((lib._images/flomap..rkt)._flomap-values))",[0,[2,"flomap-values"]],["images/flomap"]],
["flomap-vc-append",">images/Compositing.html#(def._((lib._images/flomap..rkt)._flomap-vc-append))",[0,[2,"flomap-vc-append"]],["images/flomap"]],
["flomap-vl-append",">images/Compositing.html#(def._((lib._images/flomap..rkt)._flomap-vl-append))",[0,[2,"flomap-vl-append"]],["images/flomap"]],
["flomap-vr-append",">images/Compositing.html#(def._((lib._images/flomap..rkt)._flomap-vr-append))",[0,[2,"flomap-vr-append"]],["images/flomap"]],
["flomap-whirl-transform",">images/Spatial_Transformations.html#(def._((lib._images/flomap..rkt)._flomap-whirl-transform))",[0,[2,"flomap-whirl-transform"]],["images/flomap"]],
["flomap-width",">images/Struct_Type_and_Accessors.html#(def._((lib._images/flomap..rkt)._flomap-width))",[0,[2,"flomap-width"]],["images/flomap"]],
["flomap?",">images/Struct_Type_and_Accessors.html#(def._((lib._images/flomap..rkt)._flomap~3f))",[0,[2,"flomap?"]],["images/flomap"]],
["flonum",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Flonum))",[0,[1,"Flonum"]],["typed/racket/base","typed/racket"]],
["flonum",">guide/performance.html#(tech._flonum)","<span style=\"font-style: italic\">flonum</span>",false],
["flonum arithmetic",">reference/flonums.html#(part._.Flonum_.Arithmetic)","Flonum Arithmetic",false],
["flonum vectors",">reference/flonums.html#(part._.Flonum_.Vectors)","Flonum Vectors",false],
["flonum->bit-field",">unstable/flonum.html#(def._((lib._unstable/flonum..rkt)._flonum-~3ebit-field))",[0,[2,"flonum->bit-field"]],["unstable/flonum"]],
["flonum->ordinal",">unstable/flonum.html#(def._((lib._unstable/flonum..rkt)._flonum-~3eordinal))",[0,[2,"flonum->ordinal"]],["unstable/flonum"]],
["flonum-nan",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Flonum-.Nan))",[0,[1,"Flonum-Nan"]],["typed/racket/base","typed/racket"]],
["flonum-negative-zero",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Flonum-.Negative-.Zero))",[0,[1,"Flonum-Negative-Zero"]],["typed/racket/base","typed/racket"]],
["flonum-positive-zero",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Flonum-.Positive-.Zero))",[0,[1,"Flonum-Positive-Zero"]],["typed/racket/base","typed/racket"]],
["flonum-zero",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Flonum-.Zero))",[0,[1,"Flonum-Zero"]],["typed/racket/base","typed/racket"]],
["flonum?",">reference/number-types.html#(def._((quote._~23~25kernel)._flonum~3f))",[0,[2,"flonum?"]],["racket/base","racket"]],
["flonum?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_950",[0,[2,"flonum?"]],["rnrs/arithmetic/flonums-6"]],
["flonums",">reference/flonums.html","Flonums",false],
["flonums",">unstable/flonum.html","Flonums",false],
["flonums",">reference/numbers.html#(tech._flonum)","<span style=\"font-style: italic\">flonums</span>",false],
["flonums-between",">unstable/flonum.html#(def._((lib._unstable/flonum..rkt)._flonums-between))",[0,[2,"flonums-between"]],["unstable/flonum"]],
["floor",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._floor))",[0,[2,"floor"]],["racket/base","racket"]],
["floor",">r5rs-std/r5rs-Z-H-9.html#%_idx_314",[0,[2,"floor"]],["r5rs"]],
["floor",">r6rs-std/r6rs-Z-H-14.html#node_idx_528",[0,[2,"floor"]],["rnrs/base-6"]],
["floor",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._floor))",[0,[2,"floor"]],["lang/htdp-advanced"]],
["floor",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._floor))",[0,[2,"floor"]],["lang/htdp-beginner"]],
["floor",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._floor))",[0,[2,"floor"]],["lang/htdp-beginner-abbr"]],
["floor",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._floor))",[0,[2,"floor"]],["lang/htdp-intermediate"]],
["floor",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._floor))",[0,[2,"floor"]],["lang/htdp-intermediate-lambda"]],
["floor",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._floor))",[0,[2,"floor"]],["deinprogramm/DMdA-advanced"]],
["floor",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._floor))",[0,[2,"floor"]],["deinprogramm/DMdA-assignments"]],
["floor",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._floor))",[0,[2,"floor"]],["deinprogramm/DMdA-beginner"]],
["floor",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._floor))",[0,[2,"floor"]],["deinprogramm/DMdA-vanilla"]],
["floor-log/base",">plot/utils.html#(def._((lib._plot/utils..rkt)._floor-log/base))",[0,[2,"floor-log/base"]],["plot/utils"]],
["floppy-disk-icon",">images/Icons.html#(def._((lib._images/icons/file..rkt)._floppy-disk-icon))",[0,[2,"floppy-disk-icon"]],["images/icons/file"]],
["flow",">scribble/core.html#(tech._flow)","<span style=\"font-style: italic\">flow</span>",false],
["flpositive?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_968",[0,[2,"flpositive?"]],["rnrs/arithmetic/flonums-6"]],
["flprev",">unstable/flonum.html#(def._((lib._unstable/flonum..rkt)._flprev))",[0,[2,"flprev"]],["unstable/flonum"]],
["flreal-part",">reference/flonums.html#(def._((lib._racket/flonum..rkt)._flreal-part))",[0,[2,"flreal-part"]],["racket/flonum"]],
["flround",">reference/flonums.html#(def._((lib._racket/flonum..rkt)._flround))",[0,[2,"flround"]],["racket/flonum"]],
["flround",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1022",[0,[2,"flround"]],["rnrs/arithmetic/flonums-6"]],
["flsin",">reference/flonums.html#(def._((lib._racket/flonum..rkt)._flsin))",[0,[2,"flsin"]],["racket/flonum"]],
["flsin",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1030",[0,[2,"flsin"]],["rnrs/arithmetic/flonums-6"]],
["flsqrt",">reference/flonums.html#(def._((lib._racket/flonum..rkt)._flsqrt))",[0,[2,"flsqrt"]],["racket/flonum"]],
["flsqrt",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1044",[0,[2,"flsqrt"]],["rnrs/arithmetic/flonums-6"]],
["flstep",">unstable/flonum.html#(def._((lib._unstable/flonum..rkt)._flstep))",[0,[2,"flstep"]],["unstable/flonum"]],
["fltan",">reference/flonums.html#(def._((lib._racket/flonum..rkt)._fltan))",[0,[2,"fltan"]],["racket/flonum"]],
["fltan",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1034",[0,[2,"fltan"]],["rnrs/arithmetic/flonums-6"]],
["fltruncate",">reference/flonums.html#(def._((lib._racket/flonum..rkt)._fltruncate))",[0,[2,"fltruncate"]],["racket/flonum"]],
["fltruncate",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1020",[0,[2,"fltruncate"]],["rnrs/arithmetic/flonums-6"]],
["fluid-let",">mzscheme/Old_Syntactic_Forms.html#(form._((lib._mzscheme/main..rkt)._fluid-let))",[0,[1,"fluid-let"]],["mzscheme"]],
["flush",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._flush))",[[0,[2,"flush"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["flush",">gui/canvas___.html#(meth._(((lib._mred/main..rkt)._canvas~3c~25~3e)._flush))",[[0,[2,"flush"]],[14,[" (method of ",[0,[2,"canvas<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["flush-display",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._flush-display))",[0,[2,"flush-display"]],["racket/gui/base","racket/gui"]],
["flush-output",">reference/port-buffers.html#(def._((quote._~23~25kernel)._flush-output))",[0,[2,"flush-output"]],["racket/base","racket"]],
["flush-output-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_712",[0,[2,"flush-output-port"]],["rnrs/io/ports-6"]],
["flush-output-port",">mzlib/mzlib_compat.html#(def._((lib._mzlib/compat..rkt)._flush-output-port))",[0,[2,"flush-output-port"]],["mzlib/compat"]],
["flushing",">graphics/Flushing.html","Flushing",false],
["flvector",">reference/flonums.html#(def._((lib._racket/flonum..rkt)._flvector))",[0,[2,"flvector"]],["racket/flonum"]],
["flvector",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Fl.Vector))",[0,[1,"FlVector"]],["typed/racket/base","typed/racket"]],
["flvector",">reference/flonums.html#(tech._flvector)","<span style=\"font-style: italic\">flvector</span>",false],
["flvector->cpointer",">foreign/Miscellaneous_Support.html#(def._((quote._~23~25foreign)._flvector-~3ecpointer))",[0,[2,"flvector->cpointer"]],["ffi/unsafe"]],
["flvector-copy",">reference/flonums.html#(def._((lib._racket/flonum..rkt)._flvector-copy))",[0,[2,"flvector-copy"]],["racket/flonum"]],
["flvector-length",">reference/flonums.html#(def._((lib._racket/flonum..rkt)._flvector-length))",[0,[2,"flvector-length"]],["racket/flonum"]],
["flvector-ref",">reference/flonums.html#(def._((lib._racket/flonum..rkt)._flvector-ref))",[0,[2,"flvector-ref"]],["racket/flonum"]],
["flvector-set!",">reference/flonums.html#(def._((lib._racket/flonum..rkt)._flvector-set!))",[0,[2,"flvector-set!"]],["racket/flonum"]],
["flvector?",">reference/flonums.html#(def._((lib._racket/flonum..rkt)._flvector~3f))",[0,[2,"flvector?"]],["racket/flonum"]],
["flzero?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_966",[0,[2,"flzero?"]],["rnrs/arithmetic/flonums-6"]],
["fm*",">images/Pointwise_Operations.html#(def._((lib._images/flomap..rkt)._fm*))",[0,[2,"fm*"]],["images/flomap"]],
["fm+",">images/Pointwise_Operations.html#(def._((lib._images/flomap..rkt)._fm+))",[0,[2,"fm+"]],["images/flomap"]],
["fm-",">images/Pointwise_Operations.html#(def._((lib._images/flomap..rkt)._fm-))",[0,[2,"fm-"]],["images/flomap"]],
["fm/",">images/Pointwise_Operations.html#(def._((lib._images/flomap..rkt)._fm/))",[0,[2,"fm/"]],["images/flomap"]],
["fmmax",">images/Pointwise_Operations.html#(def._((lib._images/flomap..rkt)._fmmax))",[0,[2,"fmmax"]],["images/flomap"]],
["fmmin",">images/Pointwise_Operations.html#(def._((lib._images/flomap..rkt)._fmmin))",[0,[2,"fmmin"]],["images/flomap"]],
["fmsqr",">images/Pointwise_Operations.html#(def._((lib._images/flomap..rkt)._fmsqr))",[0,[2,"fmsqr"]],["images/flomap"]],
["fmsqrt",">images/Pointwise_Operations.html#(def._((lib._images/flomap..rkt)._fmsqrt))",[0,[2,"fmsqrt"]],["images/flomap"]],
["focus",">gui/window___.html#(meth._(((lib._mred/main..rkt)._window~3c~25~3e)._focus))",[[0,[2,"focus"]],[14,[" (method of ",[0,[2,"window<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["fold",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._fold))",[0,[2,"fold"]],["deinprogramm/DMdA-advanced"]],
["fold",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._fold))",[0,[2,"fold"]],["deinprogramm/DMdA-assignments"]],
["fold",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._fold))",[0,[2,"fold"]],["deinprogramm/DMdA-vanilla"]],
["fold",">srfi-std/srfi-1.html#fold",[0,[2,"fold"]],["srfi/1"]],
["fold-ec",">srfi-std/srfi-42.html#fold-ec",[0,[1,"fold-ec"]],["srfi/42"]],
["fold-files",">reference/Filesystem.html#(def._((lib._racket/file..rkt)._fold-files))",[0,[2,"fold-files"]],["racket/file","racket"]],
["fold-image",">picturing-programs/index.html#(def._((lib._picturing-programs/private/map-image..rkt)._fold-image))",[0,[2,"fold-image"]],["picturing-programs/private/map-image","picturing-programs"]],
["fold-image/extra",">picturing-programs/index.html#(def._((lib._picturing-programs/private/map-image..rkt)._fold-image/extra))",[0,[2,"fold-image/extra"]],["picturing-programs/private/map-image","picturing-programs"]],
["fold-left",">r6rs-lib-std/r6rs-lib-Z-H-4.html#node_idx_212",[0,[2,"fold-left"]],["rnrs/lists-6"]],
["fold-plt-archive",">raco/unpack.html#(def._((lib._setup/unpack..rkt)._fold-plt-archive))",[0,[2,"fold-plt-archive"]],["setup/unpack"]],
["fold-right",">r6rs-lib-std/r6rs-lib-Z-H-4.html#node_idx_214",[0,[2,"fold-right"]],["rnrs/lists-6"]],
["fold-right",">srfi-std/srfi-1.html#fold-right",[0,[2,"fold-right"]],["srfi/1"]],
["fold-snip",">embedded-gui/snip-related-functions.html#(def._((lib._embedded-gui/main..rkt)._fold-snip))",[0,[2,"fold-snip"]],["embedded-gui"]],
["fold-test-results",">rackunit/internals.html#(def._((lib._rackunit/main..rkt)._fold-test-results))",[0,[2,"fold-test-results"]],["rackunit"]],
["fold3-ec",">srfi-std/srfi-42.html#fold3-ec",[0,[1,"fold3-ec"]],["srfi/42"]],
["foldl",">reference/pairs.html#(def._((lib._racket/private/list..rkt)._foldl))",[0,[2,"foldl"]],["racket/base","racket"]],
["foldl",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._foldl))",[0,[2,"foldl"]],["lang/htdp-advanced"]],
["foldl",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._foldl))",[0,[2,"foldl"]],["lang/htdp-intermediate"]],
["foldl",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._foldl))",[0,[2,"foldl"]],["lang/htdp-intermediate-lambda"]],
["foldl",">lazy/index.html#(def._((lib._lazy/main..rkt)._foldl))",[0,[2,"foldl"]],["lazy"]],
["foldr",">reference/pairs.html#(def._((lib._racket/private/list..rkt)._foldr))",[0,[2,"foldr"]],["racket/base","racket"]],
["foldr",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._foldr))",[0,[2,"foldr"]],["lang/htdp-advanced"]],
["foldr",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._foldr))",[0,[2,"foldr"]],["lang/htdp-intermediate"]],
["foldr",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._foldr))",[0,[2,"foldr"]],["lang/htdp-intermediate-lambda"]],
["foldr",">lazy/index.html#(def._((lib._lazy/main..rkt)._foldr))",[0,[2,"foldr"]],["lazy"]],
["foldr",">mzlib/mzlib_integer-set.html#(def._((lib._mzlib/integer-set..rkt)._foldr))",[0,[2,"foldr"]],["mzlib/integer-set"]],
["foldts-test-suite",">rackunit/internals.html#(def._((lib._rackunit/main..rkt)._foldts-test-suite))",[0,[2,"foldts-test-suite"]],["rackunit"]],
["font",">drracket/prefs-explanation.html#(part._.Font)","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Font</span>",false],
["font",">html/index.html#(def._((lib._html/main..rkt)._font))",[0,[2,"font"]],["html"]],
["font%",">draw/font_.html",[0,[2,"font%"]],["racket/draw"]],
["font-family/c",">plot/contracts.html#(def._((lib._plot/utils..rkt)._font-family/c))",[0,[2,"font-family/c"]],["plot/utils"]],
["font-list%",">draw/font-list_.html",[0,[2,"font-list%"]],["racket/draw"]],
["font-name-directory<%>",">draw/font-name-directory___.html",[0,[2,"font-name-directory<%>"]],["racket/draw"]],
["font?",">html/index.html#(def._((lib._html/main..rkt)._font~3f))",[0,[2,"font?"]],["html"]],
["fonts",">gui/Windowing_Functions.html#(part._.Fonts)","Fonts",false],
["foot-icon",">images/Icons.html#(def._((lib._images/icons/misc..rkt)._foot-icon))",[0,[2,"foot-icon"]],["images/icons/misc"]],
["footnotes",">scriblib/footnotes.html","Footnotes",false],
["for",">reference/for.html#(form._((lib._racket/private/base..rkt)._for))",[0,[1,"for"]],["racket/base","racket"]],
["for",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._for))",[0,[1,"for"]],["typed/racket/base","typed/racket"]],
["for and for*",">guide/for.html#(part._for_and_for_)",[[0,[1,"for"]]," and ",[0,[1,"for*"]]],false],
["for*",">reference/for.html#(form._((lib._racket/private/base..rkt)._for*))",[0,[1,"for*"]],["racket/base","racket"]],
["for*",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._for*))",[0,[1,"for*"]],["typed/racket/base","typed/racket"]],
["for*/and",">reference/for.html#(form._((lib._racket/private/base..rkt)._for*/and))",[0,[1,"for*/and"]],["racket/base","racket"]],
["for*/and:",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._for*/and~3a))",[0,[1,"for*/and:"]],["typed/racket/base","typed/racket"]],
["for*/async",">unstable/future.html#(form._((lib._unstable/future..rkt)._for*/async))",[0,[1,"for*/async"]],["unstable/future"]],
["for*/first",">reference/for.html#(form._((lib._racket/private/base..rkt)._for*/first))",[0,[1,"for*/first"]],["racket/base","racket"]],
["for*/first:",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._for*/first~3a))",[0,[1,"for*/first:"]],["typed/racket/base","typed/racket"]],
["for*/flvector",">reference/flonums.html#(form._((lib._racket/flonum..rkt)._for*/flvector))",[0,[1,"for*/flvector"]],["racket/flonum"]],
["for*/flvector:",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._for*/flvector~3a))",[0,[1,"for*/flvector:"]],["typed/racket/base","typed/racket"]],
["for*/fold",">reference/for.html#(form._((lib._racket/private/base..rkt)._for*/fold))",[0,[1,"for*/fold"]],["racket/base","racket"]],
["for*/fold/derived",">reference/for.html#(form._((lib._racket/private/base..rkt)._for*/fold/derived))",[0,[1,"for*/fold/derived"]],["racket/base","racket"]],
["for*/fold:",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._for*/fold~3a))",[0,[1,"for*/fold:"]],["typed/racket/base","typed/racket"]],
["for*/fxvector",">reference/fixnums.html#(form._((lib._racket/fixnum..rkt)._for*/fxvector))",[0,[1,"for*/fxvector"]],["racket/fixnum"]],
["for*/gvector",">data/gvector.html#(form._((lib._data/gvector..rkt)._for*/gvector))",[0,[1,"for*/gvector"]],["data/gvector"]],
["for*/hash",">reference/for.html#(form._((lib._racket/private/base..rkt)._for*/hash))",[0,[1,"for*/hash"]],["racket/base","racket"]],
["for*/hash:",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._for*/hash~3a))",[0,[1,"for*/hash:"]],["typed/racket/base","typed/racket"]],
["for*/hasheq",">reference/for.html#(form._((lib._racket/private/base..rkt)._for*/hasheq))",[0,[1,"for*/hasheq"]],["racket/base","racket"]],
["for*/hasheq:",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._for*/hasheq~3a))",[0,[1,"for*/hasheq:"]],["typed/racket/base","typed/racket"]],
["for*/hasheqv",">reference/for.html#(form._((lib._racket/private/base..rkt)._for*/hasheqv))",[0,[1,"for*/hasheqv"]],["racket/base","racket"]],
["for*/hasheqv:",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._for*/hasheqv~3a))",[0,[1,"for*/hasheqv:"]],["typed/racket/base","typed/racket"]],
["for*/last",">reference/for.html#(form._((lib._racket/private/base..rkt)._for*/last))",[0,[1,"for*/last"]],["racket/base","racket"]],
["for*/last:",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._for*/last~3a))",[0,[1,"for*/last:"]],["typed/racket/base","typed/racket"]],
["for*/list",">reference/for.html#(form._((lib._racket/private/base..rkt)._for*/list))",[0,[1,"for*/list"]],["racket/base","racket"]],
["for*/list:",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._for*/list~3a))",[0,[1,"for*/list:"]],["typed/racket/base","typed/racket"]],
["for*/lists",">reference/for.html#(form._((lib._racket/private/base..rkt)._for*/lists))",[0,[1,"for*/lists"]],["racket/base","racket"]],
["for*/lists:",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._for*/lists~3a))",[0,[1,"for*/lists:"]],["typed/racket/base","typed/racket"]],
["for*/or",">reference/for.html#(form._((lib._racket/private/base..rkt)._for*/or))",[0,[1,"for*/or"]],["racket/base","racket"]],
["for*/or:",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._for*/or~3a))",[0,[1,"for*/or:"]],["typed/racket/base","typed/racket"]],
["for*/product",">reference/for.html#(form._((lib._racket/private/base..rkt)._for*/product))",[0,[1,"for*/product"]],["racket/base","racket"]],
["for*/product:",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._for*/product~3a))",[0,[1,"for*/product:"]],["typed/racket/base","typed/racket"]],
["for*/set",">reference/sets.html#(form._((lib._racket/set..rkt)._for*/set))",[0,[1,"for*/set"]],["racket/set","racket"]],
["for*/seteq",">reference/sets.html#(form._((lib._racket/set..rkt)._for*/seteq))",[0,[1,"for*/seteq"]],["racket/set","racket"]],
["for*/seteqv",">reference/sets.html#(form._((lib._racket/set..rkt)._for*/seteqv))",[0,[1,"for*/seteqv"]],["racket/set","racket"]],
["for*/sum",">reference/for.html#(form._((lib._racket/private/base..rkt)._for*/sum))",[0,[1,"for*/sum"]],["racket/base","racket"]],
["for*/sum:",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._for*/sum~3a))",[0,[1,"for*/sum:"]],["typed/racket/base","typed/racket"]],
["for*/vector",">reference/for.html#(form._((lib._racket/private/base..rkt)._for*/vector))",[0,[1,"for*/vector"]],["racket/base","racket"]],
["for*/vector:",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._for*/vector~3a))",[0,[1,"for*/vector:"]],["typed/racket/base","typed/racket"]],
["for*:",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._for*~3a))",[0,[1,"for*:"]],["typed/racket/base","typed/racket"]],
["for-all",">r6rs-lib-std/r6rs-lib-Z-H-4.html#node_idx_204",[0,[2,"for-all"]],["rnrs/lists-6"]],
["for-all",">deinprogramm/Eigenschaften.html#(form._((lib._deinprogramm/.D.Md.A..rkt)._for-all))",[0,[1,"for-all"]],["deinprogramm/DMdA-beginner"]],
["for-clause-syntax-protect",">reference/for.html#(def._((lib._racket/private/base..rkt)._for-clause-syntax-protect))",[0,[2,"for-clause-syntax-protect"]],["racket/base","racket"]],
["for-doc",">scribble/srcdoc.html#(form._((lib._scribble/srcdoc..rkt)._for-doc))",[0,[1,"for-doc"]],["scribble/srcdoc"]],
["for-each",">reference/pairs.html#(def._((lib._racket/private/map..rkt)._for-each))",[0,[2,"for-each"]],["racket/base","racket"]],
["for-each",">r5rs-std/r5rs-Z-H-9.html#%_idx_582",[0,[2,"for-each"]],["r5rs"]],
["for-each",">r6rs-std/r6rs-Z-H-14.html#node_idx_644",[0,[2,"for-each"]],["rnrs/base-6"]],
["for-each",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._for-each))",[0,[2,"for-each"]],["lang/htdp-advanced"]],
["for-each",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._for-each))",[0,[2,"for-each"]],["lang/htdp-intermediate"]],
["for-each",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._for-each))",[0,[2,"for-each"]],["lang/htdp-intermediate-lambda"]],
["for-each",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._for-each))",[0,[2,"for-each"]],["deinprogramm/DMdA-advanced"]],
["for-each",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._for-each))",[0,[2,"for-each"]],["deinprogramm/DMdA-assignments"]],
["for-each",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._for-each))",[0,[2,"for-each"]],["deinprogramm/DMdA-vanilla"]],
["for-each",">embedded-gui/dllist___.html#(meth._(((lib._embedded-gui/main..rkt)._dllist~3c~25~3e)._for-each))",[[0,[2,"for-each"]],[14,[" (method of ",[0,[2,"dllist<%>"]],")"]]],["embedded-gui"]],
["for-each",">lazy/index.html#(def._((lib._lazy/main..rkt)._for-each))",[0,[2,"for-each"]],["lazy"]],
["for-each",">srfi-std/srfi-1.html#srfi-1.html",[0,[2,"for-each"]],["srfi/1"]],
["for-each-frame",">framework/Group.html#(meth._(((lib._framework/main..rkt)._group~3a~25)._for-each-frame))",[[0,[2,"for-each-frame"]],[14,[" (method of ",[0,[2,"group:%"]],")"]]],["framework"]],
["for-each-snip",">embedded-gui/snip-related-functions.html#(def._((lib._embedded-gui/main..rkt)._for-each-snip))",[0,[2,"for-each-snip"]],["embedded-gui"]],
["for-label",">reference/require.html#(form._((lib._racket/private/base..rkt)._for-label))",[0,[1,"for-label"]],["racket/base","racket"]],
["for-meta",">reference/require.html#(form._((lib._racket/private/base..rkt)._for-meta))",[0,[1,"for-meta"]],["racket/base","racket"]],
["for-syntax",">reference/require.html#(form._((lib._racket/private/base..rkt)._for-syntax))",[0,[1,"for-syntax"]],["racket/base","racket"]],
["for-template",">reference/require.html#(form._((lib._racket/private/base..rkt)._for-template))",[0,[1,"for-template"]],["racket/base","racket"]],
["for/and",">reference/for.html#(form._((lib._racket/private/base..rkt)._for/and))",[0,[1,"for/and"]],["racket/base","racket"]],
["for/and and for/or",">guide/for.html#(part._for_and_and_for_or)",[[0,[1,"for/and"]]," and ",[0,[1,"for/or"]]],false],
["for/and:",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._for/and~3a))",[0,[1,"for/and:"]],["typed/racket/base","typed/racket"]],
["for/async",">unstable/future.html#(form._((lib._unstable/future..rkt)._for/async))",[0,[1,"for/async"]],["unstable/future"]],
["for/first",">reference/for.html#(form._((lib._racket/private/base..rkt)._for/first))",[0,[1,"for/first"]],["racket/base","racket"]],
["for/first and for/last",">guide/for.html#(part._for_first_and_for_last)",[[0,[1,"for/first"]]," and ",[0,[1,"for/last"]]],false],
["for/first:",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._for/first~3a))",[0,[1,"for/first:"]],["typed/racket/base","typed/racket"]],
["for/flvector",">reference/flonums.html#(form._((lib._racket/flonum..rkt)._for/flvector))",[0,[1,"for/flvector"]],["racket/flonum"]],
["for/flvector:",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._for/flvector~3a))",[0,[1,"for/flvector:"]],["typed/racket/base","typed/racket"]],
["for/fold",">reference/for.html#(form._((lib._racket/private/base..rkt)._for/fold))",[0,[1,"for/fold"]],["racket/base","racket"]],
["for/fold and for*/fold",">guide/for.html#(part._for/fold)",[[0,[1,"for/fold"]]," and ",[0,[1,"for*/fold"]]],false],
["for/fold/derived",">reference/for.html#(form._((lib._racket/private/base..rkt)._for/fold/derived))",[0,[1,"for/fold/derived"]],["racket/base","racket"]],
["for/fold:",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._for/fold~3a))",[0,[1,"for/fold:"]],["typed/racket/base","typed/racket"]],
["for/fxvector",">reference/fixnums.html#(form._((lib._racket/fixnum..rkt)._for/fxvector))",[0,[1,"for/fxvector"]],["racket/fixnum"]],
["for/gvector",">data/gvector.html#(form._((lib._data/gvector..rkt)._for/gvector))",[0,[1,"for/gvector"]],["data/gvector"]],
["for/hash",">reference/for.html#(form._((lib._racket/private/base..rkt)._for/hash))",[0,[1,"for/hash"]],["racket/base","racket"]],
["for/hash:",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._for/hash~3a))",[0,[1,"for/hash:"]],["typed/racket/base","typed/racket"]],
["for/hasheq",">reference/for.html#(form._((lib._racket/private/base..rkt)._for/hasheq))",[0,[1,"for/hasheq"]],["racket/base","racket"]],
["for/hasheq:",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._for/hasheq~3a))",[0,[1,"for/hasheq:"]],["typed/racket/base","typed/racket"]],
["for/hasheqv",">reference/for.html#(form._((lib._racket/private/base..rkt)._for/hasheqv))",[0,[1,"for/hasheqv"]],["racket/base","racket"]],
["for/hasheqv:",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._for/hasheqv~3a))",[0,[1,"for/hasheqv:"]],["typed/racket/base","typed/racket"]],
["for/last",">reference/for.html#(form._((lib._racket/private/base..rkt)._for/last))",[0,[1,"for/last"]],["racket/base","racket"]],
["for/last:",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._for/last~3a))",[0,[1,"for/last:"]],["typed/racket/base","typed/racket"]],
["for/list",">reference/for.html#(form._((lib._racket/private/base..rkt)._for/list))",[0,[1,"for/list"]],["racket/base","racket"]],
["for/list and for*/list",">guide/for.html#(part._for_list_and_for__list)",[[0,[1,"for/list"]]," and ",[0,[1,"for*/list"]]],false],
["for/list:",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._for/list~3a))",[0,[1,"for/list:"]],["typed/racket/base","typed/racket"]],
["for/lists",">reference/for.html#(form._((lib._racket/private/base..rkt)._for/lists))",[0,[1,"for/lists"]],["racket/base","racket"]],
["for/lists:",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._for/lists~3a))",[0,[1,"for/lists:"]],["typed/racket/base","typed/racket"]],
["for/or",">reference/for.html#(form._((lib._racket/private/base..rkt)._for/or))",[0,[1,"for/or"]],["racket/base","racket"]],
["for/or:",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._for/or~3a))",[0,[1,"for/or:"]],["typed/racket/base","typed/racket"]],
["for/product",">reference/for.html#(form._((lib._racket/private/base..rkt)._for/product))",[0,[1,"for/product"]],["racket/base","racket"]],
["for/product:",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._for/product~3a))",[0,[1,"for/product:"]],["typed/racket/base","typed/racket"]],
["for/set",">reference/sets.html#(form._((lib._racket/set..rkt)._for/set))",[0,[1,"for/set"]],["racket/set","racket"]],
["for/seteq",">reference/sets.html#(form._((lib._racket/set..rkt)._for/seteq))",[0,[1,"for/seteq"]],["racket/set","racket"]],
["for/seteqv",">reference/sets.html#(form._((lib._racket/set..rkt)._for/seteqv))",[0,[1,"for/seteqv"]],["racket/set","racket"]],
["for/sum",">reference/for.html#(form._((lib._racket/private/base..rkt)._for/sum))",[0,[1,"for/sum"]],["racket/base","racket"]],
["for/sum:",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._for/sum~3a))",[0,[1,"for/sum:"]],["typed/racket/base","typed/racket"]],
["for/vector",">reference/for.html#(form._((lib._racket/private/base..rkt)._for/vector))",[0,[1,"for/vector"]],["racket/base","racket"]],
["for/vector and for*/vector",">guide/for.html#(part._for_vector_and_for__vector)",[[0,[1,"for/vector"]]," and ",[0,[1,"for*/vector"]]],false],
["for/vector:",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._for/vector~3a))",[0,[1,"for/vector:"]],["typed/racket/base","typed/racket"]],
["for:",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._for~3a))",[0,[1,"for:"]],["typed/racket/base","typed/racket"]],
["force",">reference/Delayed_Evaluation.html#(def._((lib._racket/promise..rkt)._force))",[0,[2,"force"]],["racket/promise","racket"]],
["force",">r5rs-std/r5rs-Z-H-9.html#%_idx_584",[0,[2,"force"]],["r5rs"]],
["force",">r6rs-lib-std/r6rs-lib-Z-H-20.html#node_idx_1304",[0,[2,"force"]],["rnrs/r5rs-6"]],
["force",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._force))",[0,[2,"force"]],["lang/htdp-advanced"]],
["force",">srfi-std/srfi-45.html#force",[0,[2,"force"]],["srfi/45"]],
["force-display-focus",">gui/editor-canvas_.html#(meth._(((lib._mred/main..rkt)._editor-canvas~25)._force-display-focus))",[[0,[2,"force-display-focus"]],[14,[" (method of ",[0,[2,"editor-canvas%"]],")"]]],["racket/gui/base","racket/gui"]],
["force-package-building?",">planet/Utility_Libraries.html#(def._((lib._planet/util..rkt)._force-package-building~3f))",[0,[2,"force-package-building?"]],["planet/util"]],
["force-stop-colorer",">framework/Color.html#(meth._(((lib._framework/main..rkt)._color~3atext~3c~25~3e)._force-stop-colorer))",[[0,[2,"force-stop-colorer"]],[14,[" (method of ",[0,[2,"color:text<%>"]],")"]]],["framework"]],
["force-unpacks",">raco/setup-plt-plt.html#(sig-val._((lib._setup/option-sig..rkt)._setup-option~5e._force-unpacks))",[0,[2,"force-unpacks"]],["setup/option-sig"]],
["forcing values",">lazy/index.html#(part._forcing)","Forcing Values",false],
["foreign-library value",">foreign/Loading_Foreign_Libraries.html#(tech._foreign._library._value)","<span style=\"font-style: italic\">foreign-library value</span>",false],
["forever",">gui/editor___.html#(idx._(gentag._208._(lib._scribblings/gui/gui..scrbl)))",[7,"'forever"],false],
["forget-notification",">gui/style-list_.html#(meth._(((lib._racket/snip..rkt)._style-list~25)._forget-notification))",[[0,[2,"forget-notification"]],[14,[" (method of ",[0,[2,"style-list%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["form",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._form))",[0,[2,"form"]],["compiler/zo-structs"]],
["form",">html/index.html#(def._((lib._html/main..rkt)._form))",[0,[2,"form"]],["html"]],
["form-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..rkt)._form-index-desc))",[0,[2,"form-index-desc"]],["scribble/manual-struct"]],
["form-index-desc?",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..rkt)._form-index-desc~3f))",[0,[2,"form-index-desc?"]],["scribble/manual-struct"]],
["form-urlencoded->alist",">net/uri-codec.html#(def._((lib._net/uri-codec..rkt)._form-urlencoded-~3ealist))",[0,[2,"form-urlencoded->alist"]],["net/uri-codec"]],
["form-urlencoded-decode",">net/uri-codec.html#(def._((lib._net/uri-codec..rkt)._form-urlencoded-decode))",[0,[2,"form-urlencoded-decode"]],["net/uri-codec"]],
["form-urlencoded-encode",">net/uri-codec.html#(def._((lib._net/uri-codec..rkt)._form-urlencoded-encode))",[0,[2,"form-urlencoded-encode"]],["net/uri-codec"]],
["form?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._form~3f))",[0,[2,"form?"]],["compiler/zo-structs"]],
["form?",">html/index.html#(def._((lib._html/main..rkt)._form~3f))",[0,[2,"form?"]],["html"]],
["format",">reference/Writing.html#(def._((quote._~23~25kernel)._format))",[0,[2,"format"]],["racket/base","racket"]],
["format",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._format))",[0,[2,"format"]],["lang/htdp-advanced"]],
["format",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._format))",[0,[2,"format"]],["lang/htdp-beginner"]],
["format",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._format))",[0,[2,"format"]],["lang/htdp-beginner-abbr"]],
["format",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._format))",[0,[2,"format"]],["lang/htdp-intermediate"]],
["format",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._format))",[0,[2,"format"]],["lang/htdp-intermediate-lambda"]],
["format",">srfi-std/srfi-28.html#format",[0,[2,"format"]],["srfi/28"]],
["format",">srfi-std/srfi-48.html#format",[0,[2,"format"]],["srfi/48"]],
["format of \".plt\" archives",">raco/plt.html#(part._format-of-..plt-archives)",["Format of ",[6,"\".plt\""]," Archives"],false],
["format-id",">reference/syntax-util.html#(def._((lib._racket/syntax..rkt)._format-id))",[0,[2,"format-id"]],["racket/syntax"]],
["format-req/c",">web-server-internal/dispatch-log.html#(def._((lib._web-server/dispatchers/dispatch-log..rkt)._format-req/c))",[0,[2,"format-req/c"]],["web-server/dispatchers/dispatch-log"]],
["format-symbol",">reference/syntax-util.html#(def._((lib._racket/syntax..rkt)._format-symbol))",[0,[2,"format-symbol"]],["racket/syntax"]],
["format-unique-id",">unstable/syntax.html#(def._((lib._unstable/syntax..rkt)._format-unique-id))",[0,[2,"format-unique-id"]],["unstable/syntax"]],
["formatting",">plot/utils.html#(part._.Formatting)","Formatting",false],
["formatting racket code",">drracket/editor.html#(idx._(gentag._19._(lib._scribblings/drracket/drracket..scrbl)))","formatting Racket code",false],
["formlet",">web-server/formlets.html#(form._((lib._web-server/formlets/syntax..rkt)._formlet))",[0,[1,"formlet"]],["web-server/formlets/syntax"]],
["formlet",">web-server/formlets.html#(tech._formlet)","<span style=\"font-style: italic\">formlet</span>",false],
["formlet*",">web-server/formlets.html#(form._((lib._web-server/formlets/dyn-syntax..rkt)._formlet*))",[0,[1,"formlet*"]],["web-server/formlets/dyn-syntax"]],
["formlet*/c",">web-server/formlets.html#(def._((lib._web-server/formlets/lib..rkt)._formlet*/c))",[0,[2,"formlet*/c"]],["web-server/formlets/lib"]],
["formlet-display",">web-server/formlets.html#(def._((lib._web-server/formlets/lib..rkt)._formlet-display))",[0,[2,"formlet-display"]],["web-server/formlets/lib"]],
["formlet-process",">web-server/formlets.html#(def._((lib._web-server/formlets/lib..rkt)._formlet-process))",[0,[2,"formlet-process"]],["web-server/formlets/lib"]],
["formlet/c",">web-server/formlets.html#(def._((lib._web-server/formlets/lib..rkt)._formlet/c))",[0,[2,"formlet/c"]],["web-server/formlets/lib"]],
["formlets: functional form abstraction",">web-server/formlets.html","Formlets: Functional Form Abstraction",false],
["forms",">raco/decompile.html#(part._.Forms)","Forms",false],
["forward",">browser/index.html#(meth._(((lib._browser/browser..rkt)._hyper-panel-mixin)._forward))",[[0,[2,"forward"]],[14,[" (method of ",[0,[2,"hyper-panel-mixin"]],")"]]],["browser/browser","browser"]],
["forward-match",">framework/Color.html#(meth._(((lib._framework/main..rkt)._color~3atext~3c~25~3e)._forward-match))",[[0,[2,"forward-match"]],[14,[" (method of ",[0,[2,"color:text<%>"]],")"]]],["framework"]],
["forward-sexp",">framework/Racket.html#(meth._(((lib._framework/main..rkt)._racket~3atext~3c~25~3e)._forward-sexp))",[[0,[2,"forward-sexp"]],[14,[" (method of ",[0,[2,"racket:text<%>"]],")"]]],["framework"]],
["fourth",">reference/pairs.html#(def._((lib._racket/list..rkt)._fourth))",[0,[2,"fourth"]],["racket/list","racket"]],
["fourth",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._fourth))",[0,[2,"fourth"]],["lang/htdp-advanced"]],
["fourth",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._fourth))",[0,[2,"fourth"]],["lang/htdp-beginner"]],
["fourth",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._fourth))",[0,[2,"fourth"]],["lang/htdp-beginner-abbr"]],
["fourth",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._fourth))",[0,[2,"fourth"]],["lang/htdp-intermediate"]],
["fourth",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._fourth))",[0,[2,"fourth"]],["lang/htdp-intermediate-lambda"]],
["fourth",">lazy/index.html#(def._((lib._lazy/main..rkt)._fourth))",[0,[2,"fourth"]],["lazy"]],
["fourth",">mzlib/mzlib_list.html#(def._((lib._mzlib/list..rkt)._fourth))",[0,[2,"fourth"]],["mzlib/list"]],
["fourth",">srfi-std/srfi-1.html#fourth",[0,[2,"fourth"]],["srfi/1"]],
["fprintf",">reference/Writing.html#(def._((quote._~23~25kernel)._fprintf))",[0,[2,"fprintf"]],["racket/base","racket"]],
["fprintf",">lazy/index.html#(def._((lib._lazy/main..rkt)._fprintf))",[0,[2,"fprintf"]],["lazy"]],
["fraction-ticks",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._fraction-ticks))",[0,[2,"fraction-ticks"]],["plot"]],
["fraction-ticks-format",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._fraction-ticks-format))",[0,[2,"fraction-ticks-format"]],["plot"]],
["frame",">framework/Frame.html","Frame",false],
["frame",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._frame))",[0,[2,"frame"]],["2htdp/image"]],
["frame",">slideshow/Basic_Pict_Constructors.html#(def._((lib._slideshow/pict..rkt)._frame))",[0,[2,"frame"]],["slideshow/pict","slideshow"]],
["frame",">gui/windowing-overview.html#(tech._frame)","<span style=\"font-style: italic\">frame</span>",false],
["frame%",">gui/frame_.html",[0,[2,"frame%"]],["racket/gui/base","racket/gui"]],
["frame-label-changed",">framework/Group.html#(meth._(((lib._framework/main..rkt)._group~3a~25)._frame-label-changed))",[[0,[2,"frame-label-changed"]],[14,[" (method of ",[0,[2,"group:%"]],")"]]],["framework"]],
["frame-shown/hidden",">framework/Group.html#(meth._(((lib._framework/main..rkt)._group~3a~25)._frame-shown/hidden))",[[0,[2,"frame-shown/hidden"]],[14,[" (method of ",[0,[2,"group:%"]],")"]]],["framework"]],
["frame:add-snip-menu-items",">framework/Frame.html#(def._((lib._framework/main..rkt)._frame~3aadd-snip-menu-items))",[0,[2,"frame:add-snip-menu-items"]],["framework"]],
["frame:basic%",">framework/Frame.html#(def._((lib._framework/main..rkt)._frame~3abasic~25))",[0,[2,"frame:basic%"]],["framework"]],
["frame:basic-mixin",">framework/Frame.html#(def._((lib._framework/main..rkt)._frame~3abasic-mixin))",[0,[2,"frame:basic-mixin"]],["framework"]],
["frame:basic<%>",">framework/Frame.html#(def._((lib._framework/main..rkt)._frame~3abasic~3c~25~3e))",[0,[2,"frame:basic<%>"]],["framework"]],
["frame:current-icon",">framework/Frame.html#(def._((lib._framework/main..rkt)._frame~3acurrent-icon))",[0,[2,"frame:current-icon"]],["framework"]],
["frame:delegate%",">framework/Frame.html#(def._((lib._framework/main..rkt)._frame~3adelegate~25))",[0,[2,"frame:delegate%"]],["framework"]],
["frame:delegate-mixin",">framework/Frame.html#(def._((lib._framework/main..rkt)._frame~3adelegate-mixin))",[0,[2,"frame:delegate-mixin"]],["framework"]],
["frame:delegate<%>",">framework/Frame.html#(def._((lib._framework/main..rkt)._frame~3adelegate~3c~25~3e))",[0,[2,"frame:delegate<%>"]],["framework"]],
["frame:editor%",">framework/Frame.html#(def._((lib._framework/main..rkt)._frame~3aeditor~25))",[0,[2,"frame:editor%"]],["framework"]],
["frame:editor-mixin",">framework/Frame.html#(def._((lib._framework/main..rkt)._frame~3aeditor-mixin))",[0,[2,"frame:editor-mixin"]],["framework"]],
["frame:editor<%>",">framework/Frame.html#(def._((lib._framework/main..rkt)._frame~3aeditor~3c~25~3e))",[0,[2,"frame:editor<%>"]],["framework"]],
["frame:focus-table-mixin",">framework/Frame.html#(def._((lib._framework/main..rkt)._frame~3afocus-table-mixin))",[0,[2,"frame:focus-table-mixin"]],["framework"]],
["frame:focus-table<%>",">framework/Frame.html#(def._((lib._framework/main..rkt)._frame~3afocus-table~3c~25~3e))",[0,[2,"frame:focus-table<%>"]],["framework"]],
["frame:info%",">framework/Frame.html#(def._((lib._framework/main..rkt)._frame~3ainfo~25))",[0,[2,"frame:info%"]],["framework"]],
["frame:info-mixin",">framework/Frame.html#(def._((lib._framework/main..rkt)._frame~3ainfo-mixin))",[0,[2,"frame:info-mixin"]],["framework"]],
["frame:info<%>",">framework/Frame.html#(def._((lib._framework/main..rkt)._frame~3ainfo~3c~25~3e))",[0,[2,"frame:info<%>"]],["framework"]],
["frame:lookup-focus-table",">framework/Frame.html#(def._((lib._framework/main..rkt)._frame~3alookup-focus-table))",[0,[2,"frame:lookup-focus-table"]],["framework"]],
["frame:pasteboard%",">framework/Frame.html#(def._((lib._framework/main..rkt)._frame~3apasteboard~25))",[0,[2,"frame:pasteboard%"]],["framework"]],
["frame:pasteboard-info%",">framework/Frame.html#(def._((lib._framework/main..rkt)._frame~3apasteboard-info~25))",[0,[2,"frame:pasteboard-info%"]],["framework"]],
["frame:pasteboard-info-mixin",">framework/Frame.html#(def._((lib._framework/main..rkt)._frame~3apasteboard-info-mixin))",[0,[2,"frame:pasteboard-info-mixin"]],["framework"]],
["frame:pasteboard-info<%>",">framework/Frame.html#(def._((lib._framework/main..rkt)._frame~3apasteboard-info~3c~25~3e))",[0,[2,"frame:pasteboard-info<%>"]],["framework"]],
["frame:pasteboard-mixin",">framework/Frame.html#(def._((lib._framework/main..rkt)._frame~3apasteboard-mixin))",[0,[2,"frame:pasteboard-mixin"]],["framework"]],
["frame:pasteboard<%>",">framework/Frame.html#(def._((lib._framework/main..rkt)._frame~3apasteboard~3c~25~3e))",[0,[2,"frame:pasteboard<%>"]],["framework"]],
["frame:register-group-mixin",">framework/Frame.html#(def._((lib._framework/main..rkt)._frame~3aregister-group-mixin))",[0,[2,"frame:register-group-mixin"]],["framework"]],
["frame:register-group<%>",">framework/Frame.html#(def._((lib._framework/main..rkt)._frame~3aregister-group~3c~25~3e))",[0,[2,"frame:register-group<%>"]],["framework"]],
["frame:remove-empty-menus",">framework/Frame.html#(def._((lib._framework/main..rkt)._frame~3aremove-empty-menus))",[0,[2,"frame:remove-empty-menus"]],["framework"]],
["frame:reorder-menus",">framework/Frame.html#(def._((lib._framework/main..rkt)._frame~3areorder-menus))",[0,[2,"frame:reorder-menus"]],["framework"]],
["frame:searchable%",">framework/Frame.html#(def._((lib._framework/main..rkt)._frame~3asearchable~25))",[0,[2,"frame:searchable%"]],["framework"]],
["frame:searchable-mixin",">framework/Frame.html#(def._((lib._framework/main..rkt)._frame~3asearchable-mixin))",[0,[2,"frame:searchable-mixin"]],["framework"]],
["frame:searchable-text-mixin",">framework/Frame.html#(def._((lib._framework/main..rkt)._frame~3asearchable-text-mixin))",[0,[2,"frame:searchable-text-mixin"]],["framework"]],
["frame:searchable-text<%>",">framework/Frame.html#(def._((lib._framework/main..rkt)._frame~3asearchable-text~3c~25~3e))",[0,[2,"frame:searchable-text<%>"]],["framework"]],
["frame:searchable<%>",">framework/Frame.html#(def._((lib._framework/main..rkt)._frame~3asearchable~3c~25~3e))",[0,[2,"frame:searchable<%>"]],["framework"]],
["frame:setup-size-pref",">framework/Frame.html#(def._((lib._framework/main..rkt)._frame~3asetup-size-pref))",[0,[2,"frame:setup-size-pref"]],["framework"]],
["frame:size-pref%",">framework/Frame.html#(def._((lib._framework/main..rkt)._frame~3asize-pref~25))",[0,[2,"frame:size-pref%"]],["framework"]],
["frame:size-pref-mixin",">framework/Frame.html#(def._((lib._framework/main..rkt)._frame~3asize-pref-mixin))",[0,[2,"frame:size-pref-mixin"]],["framework"]],
["frame:size-pref<%>",">framework/Frame.html#(def._((lib._framework/main..rkt)._frame~3asize-pref~3c~25~3e))",[0,[2,"frame:size-pref<%>"]],["framework"]],
["frame:standard-menus%",">framework/Frame.html#(def._((lib._framework/main..rkt)._frame~3astandard-menus~25))",[0,[2,"frame:standard-menus%"]],["framework"]],
["frame:standard-menus-mixin",">framework/Frame.html#(def._((lib._framework/main..rkt)._frame~3astandard-menus-mixin))",[0,[2,"frame:standard-menus-mixin"]],["framework"]],
["frame:standard-menus<%>",">framework/Frame.html#(def._((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e))",[0,[2,"frame:standard-menus<%>"]],["framework"]],
["frame:status-line%",">framework/Frame.html#(def._((lib._framework/main..rkt)._frame~3astatus-line~25))",[0,[2,"frame:status-line%"]],["framework"]],
["frame:status-line-mixin",">framework/Frame.html#(def._((lib._framework/main..rkt)._frame~3astatus-line-mixin))",[0,[2,"frame:status-line-mixin"]],["framework"]],
["frame:status-line<%>",">framework/Frame.html#(def._((lib._framework/main..rkt)._frame~3astatus-line~3c~25~3e))",[0,[2,"frame:status-line<%>"]],["framework"]],
["frame:text%",">framework/Frame.html#(def._((lib._framework/main..rkt)._frame~3atext~25))",[0,[2,"frame:text%"]],["framework"]],
["frame:text-info%",">framework/Frame.html#(def._((lib._framework/main..rkt)._frame~3atext-info~25))",[0,[2,"frame:text-info%"]],["framework"]],
["frame:text-info-mixin",">framework/Frame.html#(def._((lib._framework/main..rkt)._frame~3atext-info-mixin))",[0,[2,"frame:text-info-mixin"]],["framework"]],
["frame:text-info<%>",">framework/Frame.html#(def._((lib._framework/main..rkt)._frame~3atext-info~3c~25~3e))",[0,[2,"frame:text-info<%>"]],["framework"]],
["frame:text-mixin",">framework/Frame.html#(def._((lib._framework/main..rkt)._frame~3atext-mixin))",[0,[2,"frame:text-mixin"]],["framework"]],
["frame:text<%>",">framework/Frame.html#(def._((lib._framework/main..rkt)._frame~3atext~3c~25~3e))",[0,[2,"frame:text<%>"]],["framework"]],
["framework",">framework/index.html",[9,[0,"framework"]],"module"],
["framework",">reference/runtime.html#(idx._(gentag._334._(lib._scribblings/reference/reference..scrbl)))",[7,"'framework"],false],
["framework libraries overview",">framework/Framework_Libraries_Overview.html","Framework Libraries Overview",false],
["framework-class^",">framework/Signatures.html#(form._((lib._framework/framework-sig..rkt)._framework-class~5e))",[0,"framework-class^"],["framework/framework-sig"]],
["framework/decorated-editor-snip",">framework/Decorated_Editor_Snip.html",[9,[0,"framework/decorated-editor-snip"]],"module"],
["framework/framework-sig",">framework/Signatures.html",[9,[0,"framework/framework-sig"]],"module"],
["framework/framework-unit",">framework/Unit.html",[9,[0,"framework/framework-unit"]],"module"],
["framework/gui-utils",">framework/GUI_Utilities.html",[9,[0,"framework/gui-utils"]],"module"],
["framework/preferences",">framework/Preferences__Textual.html",[9,[0,"framework/preferences"]],"module"],
["framework/splash",">framework/Splash.html",[9,[0,"framework/splash"]],"module"],
["framework/test",">framework/Test.html",[9,[0,"framework/test"]],"module"],
["framework: racket gui application framework",">framework/index.html","Framework: Racket GUI Application Framework",false],
["framework@",">framework/Unit.html#(def._((lib._framework/framework-unit..rkt)._framework~40))",[0,[2,"framework@"]],["framework/framework-unit"]],
["framework^",">framework/Signatures.html#(form._((lib._framework/framework-sig..rkt)._framework~5e))",[0,[1,"framework^"]],["framework/framework-sig"]],
["framing-mode",">net/websocket.html#(def._((lib._net/websocket/conn..rkt)._framing-mode))",[0,[2,"framing-mode"]],["net/websocket/conn"]],
["fred: functional reactive wrapper around gracket",">frtime/index.html#(part._fred)","Fred: Functional Reactive Wrapper around GRacket",false],
["free",">foreign/foreign_pointer-funcs.html#(def._((quote._~23~25foreign)._free))",[0,[2,"free"]],["ffi/unsafe"]],
["free-id-info",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._free-id-info))",[0,[2,"free-id-info"]],["compiler/zo-structs"]],
["free-id-info-path0",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._free-id-info-path0))",[0,[2,"free-id-info-path0"]],["compiler/zo-structs"]],
["free-id-info-path1",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._free-id-info-path1))",[0,[2,"free-id-info-path1"]],["compiler/zo-structs"]],
["free-id-info-phase0",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._free-id-info-phase0))",[0,[2,"free-id-info-phase0"]],["compiler/zo-structs"]],
["free-id-info-phase1",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._free-id-info-phase1))",[0,[2,"free-id-info-phase1"]],["compiler/zo-structs"]],
["free-id-info-phase2",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._free-id-info-phase2))",[0,[2,"free-id-info-phase2"]],["compiler/zo-structs"]],
["free-id-info-symbol0",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._free-id-info-symbol0))",[0,[2,"free-id-info-symbol0"]],["compiler/zo-structs"]],
["free-id-info-symbol1",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._free-id-info-symbol1))",[0,[2,"free-id-info-symbol1"]],["compiler/zo-structs"]],
["free-id-info-use-current-inspector?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._free-id-info-use-current-inspector~3f))",[0,[2,"free-id-info-use-current-inspector?"]],["compiler/zo-structs"]],
["free-id-info?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._free-id-info~3f))",[0,[2,"free-id-info?"]],["compiler/zo-structs"]],
["free-id-table-count",">syntax/syntax-helpers.html#(def._((lib._syntax/id-table..rkt)._free-id-table-count))",[0,[2,"free-id-table-count"]],["syntax/id-table"]],
["free-id-table-for-each",">syntax/syntax-helpers.html#(def._((lib._syntax/id-table..rkt)._free-id-table-for-each))",[0,[2,"free-id-table-for-each"]],["syntax/id-table"]],
["free-id-table-iterate-first",">syntax/syntax-helpers.html#(def._((lib._syntax/id-table..rkt)._free-id-table-iterate-first))",[0,[2,"free-id-table-iterate-first"]],["syntax/id-table"]],
["free-id-table-iterate-key",">syntax/syntax-helpers.html#(def._((lib._syntax/id-table..rkt)._free-id-table-iterate-key))",[0,[2,"free-id-table-iterate-key"]],["syntax/id-table"]],
["free-id-table-iterate-next",">syntax/syntax-helpers.html#(def._((lib._syntax/id-table..rkt)._free-id-table-iterate-next))",[0,[2,"free-id-table-iterate-next"]],["syntax/id-table"]],
["free-id-table-iterate-value",">syntax/syntax-helpers.html#(def._((lib._syntax/id-table..rkt)._free-id-table-iterate-value))",[0,[2,"free-id-table-iterate-value"]],["syntax/id-table"]],
["free-id-table-map",">syntax/syntax-helpers.html#(def._((lib._syntax/id-table..rkt)._free-id-table-map))",[0,[2,"free-id-table-map"]],["syntax/id-table"]],
["free-id-table-ref",">syntax/syntax-helpers.html#(def._((lib._syntax/id-table..rkt)._free-id-table-ref))",[0,[2,"free-id-table-ref"]],["syntax/id-table"]],
["free-id-table-remove",">syntax/syntax-helpers.html#(def._((lib._syntax/id-table..rkt)._free-id-table-remove))",[0,[2,"free-id-table-remove"]],["syntax/id-table"]],
["free-id-table-remove!",">syntax/syntax-helpers.html#(def._((lib._syntax/id-table..rkt)._free-id-table-remove!))",[0,[2,"free-id-table-remove!"]],["syntax/id-table"]],
["free-id-table-set",">syntax/syntax-helpers.html#(def._((lib._syntax/id-table..rkt)._free-id-table-set))",[0,[2,"free-id-table-set"]],["syntax/id-table"]],
["free-id-table-set!",">syntax/syntax-helpers.html#(def._((lib._syntax/id-table..rkt)._free-id-table-set!))",[0,[2,"free-id-table-set!"]],["syntax/id-table"]],
["free-id-table?",">syntax/syntax-helpers.html#(def._((lib._syntax/id-table..rkt)._free-id-table~3f))",[0,[2,"free-id-table?"]],["syntax/id-table"]],
["free-identifier-mapping-for-each",">syntax/syntax-helpers.html#(def._((lib._syntax/boundmap..rkt)._free-identifier-mapping-for-each))",[0,[2,"free-identifier-mapping-for-each"]],["syntax/boundmap"]],
["free-identifier-mapping-get",">syntax/syntax-helpers.html#(def._((lib._syntax/boundmap..rkt)._free-identifier-mapping-get))",[0,[2,"free-identifier-mapping-get"]],["syntax/boundmap"]],
["free-identifier-mapping-map",">syntax/syntax-helpers.html#(def._((lib._syntax/boundmap..rkt)._free-identifier-mapping-map))",[0,[2,"free-identifier-mapping-map"]],["syntax/boundmap"]],
["free-identifier-mapping-put!",">syntax/syntax-helpers.html#(def._((lib._syntax/boundmap..rkt)._free-identifier-mapping-put!))",[0,[2,"free-identifier-mapping-put!"]],["syntax/boundmap"]],
["free-identifier-mapping?",">syntax/syntax-helpers.html#(def._((lib._syntax/boundmap..rkt)._free-identifier-mapping~3f))",[0,[2,"free-identifier-mapping?"]],["syntax/boundmap"]],
["free-identifier=?",">reference/stxcmp.html#(def._((quote._~23~25kernel)._free-identifier~3d~3f))",[0,[2,"free-identifier=?"]],["racket/base","racket"]],
["free-identifier=?",">r6rs-lib-std/r6rs-lib-Z-H-13.html#node_idx_1142",[0,[2,"free-identifier=?"]],["rnrs/syntax-case-6"]],
["free-identifier=?",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..rkt)._free-identifier~3d~3f))",[0,[2,"free-identifier=?"]],["mzscheme"]],
["free-immobile-cell",">foreign/foreign_pointer-funcs.html#(def._((quote._~23~25foreign)._free-immobile-cell))",[0,[2,"free-immobile-cell"]],["ffi/unsafe"]],
["free-label-identifier=?",">reference/stxcmp.html#(def._((quote._~23~25kernel)._free-label-identifier~3d~3f))",[0,[2,"free-label-identifier=?"]],["racket/base","racket"]],
["free-template-identifier=?",">reference/stxcmp.html#(def._((quote._~23~25kernel)._free-template-identifier~3d~3f))",[0,[2,"free-template-identifier=?"]],["racket/base","racket"]],
["free-transformer-identifier=?",">reference/stxcmp.html#(def._((quote._~23~25kernel)._free-transformer-identifier~3d~3f))",[0,[2,"free-transformer-identifier=?"]],["racket/base","racket"]],
["free-vars",">syntax/syntax-helpers.html#(def._((lib._syntax/free-vars..rkt)._free-vars))",[0,[2,"free-vars"]],["syntax/free-vars"]],
["freeze",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._freeze))",[0,[2,"freeze"]],["2htdp/image"]],
["freeze-colorer",">framework/Color.html#(meth._(((lib._framework/main..rkt)._color~3atext~3c~25~3e)._freeze-colorer))",[[0,[2,"freeze-colorer"]],[14,[" (method of ",[0,[2,"color:text<%>"]],")"]]],["framework"]],
["fresh",">redex/The_Redex_Reference.html#(form._((lib._redex/reduction-semantics..rkt)._fresh))",[0,[1,"fresh"]],["redex/reduction-semantics","redex"]],
["front-end/complete-program",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3alanguage~3c~25~3e)._front-end/complete-program))",[[0,[2,"front-end/complete-program"]],[14,[" (method of ",[0,[2,"drracket:language:language<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["front-end/complete-program",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3amodule-based-language-~3elanguage-mixin)._front-end/complete-program))",[[0,[2,"front-end/complete-program"]],[14,[" (method of ",[0,[2,"drracket:language:module-based-language->language-mixin"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["front-end/finished-complete-program",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3alanguage~3c~25~3e)._front-end/finished-complete-program))",[[0,[2,"front-end/finished-complete-program"]],[14,[" (method of ",[0,[2,"drracket:language:language<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["front-end/interaction",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3alanguage~3c~25~3e)._front-end/interaction))",[[0,[2,"front-end/interaction"]],[14,[" (method of ",[0,[2,"drracket:language:language<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["front-end/interaction",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3amodule-based-language-~3elanguage-mixin)._front-end/interaction))",[[0,[2,"front-end/interaction"]],[14,[" (method of ",[0,[2,"drracket:language:module-based-language->language-mixin"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["frtime",">frtime/index.html",[9,[0,"frtime"]],"module"],
["frtime/gui/fred",">frtime/index.html#(mod-path._frtime/gui/fred)",[9,[0,"frtime/gui/fred"]],"module"],
["frtime: a language for reactive programs",">frtime/index.html","FrTime: A Language for Reactive Programs",false],
["fsemaphore-count",">reference/futures.html#(def._((lib._racket/future..rkt)._fsemaphore-count))",[0,[2,"fsemaphore-count"]],["racket/future","racket"]],
["fsemaphore-post",">reference/futures.html#(def._((lib._racket/future..rkt)._fsemaphore-post))",[0,[2,"fsemaphore-post"]],["racket/future","racket"]],
["fsemaphore-try-wait?",">reference/futures.html#(def._((lib._racket/future..rkt)._fsemaphore-try-wait~3f))",[0,[2,"fsemaphore-try-wait?"]],["racket/future","racket"]],
["fsemaphore-wait",">reference/futures.html#(def._((lib._racket/future..rkt)._fsemaphore-wait))",[0,[2,"fsemaphore-wait"]],["racket/future","racket"]],
["fsemaphore?",">reference/futures.html#(def._((lib._racket/future..rkt)._fsemaphore~3f))",[0,[2,"fsemaphore?"]],["racket/future","racket"]],
["ft-button%",">frtime/index.html#(def._((lib._frtime/gui/fred..rkt)._ft-button~25))",[0,[2,"ft-button%"]],["frtime/gui/fred"]],
["ft-check-box%",">frtime/index.html#(def._((lib._frtime/gui/fred..rkt)._ft-check-box~25))",[0,[2,"ft-check-box%"]],["frtime/gui/fred"]],
["ft-choice%",">frtime/index.html#(def._((lib._frtime/gui/fred..rkt)._ft-choice~25))",[0,[2,"ft-choice%"]],["frtime/gui/fred"]],
["ft-frame%",">frtime/index.html#(def._((lib._frtime/gui/fred..rkt)._ft-frame~25))",[0,[2,"ft-frame%"]],["frtime/gui/fred"]],
["ft-list-box%",">frtime/index.html#(def._((lib._frtime/gui/fred..rkt)._ft-list-box~25))",[0,[2,"ft-list-box%"]],["frtime/gui/fred"]],
["ft-message%",">frtime/index.html#(def._((lib._frtime/gui/fred..rkt)._ft-message~25))",[0,[2,"ft-message%"]],["frtime/gui/fred"]],
["ft-radio-box%",">frtime/index.html#(def._((lib._frtime/gui/fred..rkt)._ft-radio-box~25))",[0,[2,"ft-radio-box%"]],["frtime/gui/fred"]],
["ft-slider%",">frtime/index.html#(def._((lib._frtime/gui/fred..rkt)._ft-slider~25))",[0,[2,"ft-slider%"]],["frtime/gui/fred"]],
["ft-text-field%",">frtime/index.html#(def._((lib._frtime/gui/fred..rkt)._ft-text-field~25))",[0,[2,"ft-text-field%"]],["frtime/gui/fred"]],
["ftp signature",">net/ftp.html#(part._.F.T.P_.Signature)","FTP Signature",false],
["ftp unit",">net/ftp.html#(part._.F.T.P_.Unit)","FTP Unit",false],
["ftp-cd",">net/ftp.html#(def._((lib._net/ftp..rkt)._ftp-cd))",[0,[2,"ftp-cd"]],["net/ftp"]],
["ftp-close-connection",">net/ftp.html#(def._((lib._net/ftp..rkt)._ftp-close-connection))",[0,[2,"ftp-close-connection"]],["net/ftp"]],
["ftp-connection?",">net/ftp.html#(def._((lib._net/ftp..rkt)._ftp-connection~3f))",[0,[2,"ftp-connection?"]],["net/ftp"]],
["ftp-directory-list",">net/ftp.html#(def._((lib._net/ftp..rkt)._ftp-directory-list))",[0,[2,"ftp-directory-list"]],["net/ftp"]],
["ftp-download-file",">net/ftp.html#(def._((lib._net/ftp..rkt)._ftp-download-file))",[0,[2,"ftp-download-file"]],["net/ftp"]],
["ftp-establish-connection",">net/ftp.html#(def._((lib._net/ftp..rkt)._ftp-establish-connection))",[0,[2,"ftp-establish-connection"]],["net/ftp"]],
["ftp-make-file-seconds",">net/ftp.html#(def._((lib._net/ftp..rkt)._ftp-make-file-seconds))",[0,[2,"ftp-make-file-seconds"]],["net/ftp"]],
["ftp: client downloading",">net/ftp.html","FTP: Client Downloading",false],
["ftp@",">net/ftp.html#(def._((lib._net/ftp-unit..rkt)._ftp~40))",[0,[2,"ftp@"]],["net/ftp-unit"]],
["ftp^",">net/ftp.html#(form._((lib._net/ftp-sig..rkt)._ftp~5e))",[0,[1,"ftp^"]],["net/ftp-sig"]],
["full api",">web-server/run.html#(part._.Full_.A.P.I)","Full API",false],
["full-page",">slideshow/Constants_and_Layout_Variables.html#(form._((lib._slideshow/base..rkt)._full-page))",[0,[1,"full-page"]],["slideshow/base","slideshow"]],
["fully expanded programs",">reference/syntax-model.html#(part._fully-expanded)","Fully Expanded Programs",false],
["fully-expanded",">reference/syntax-model.html#(tech._fully._expanded)","<span style=\"font-style: italic\">fully-expanded</span>",false],
["function",">plot/renderer2d.html#(def._((lib._plot/main..rkt)._function))",[0,[2,"function"]],["plot"]],
["function calls (procedure applications)",">guide/syntax-overview.html#(part._.Function_.Calls__.Procedure_.Applications_)","Function Calls (Procedure Applications)",false],
["function calls (procedure applications)",">guide/application.html","Function Calls (Procedure Applications)",false],
["function calls, again",">guide/syntax-overview.html#(part._.Function_.Calls__.Again)","Function Calls, Again",false],
["function contract",">reference/function-contracts.html#(tech._function._contract)","<span style=\"font-style: italic\">function contract</span>",false],
["function contracts",">reference/function-contracts.html","Function Contracts",false],
["function shorthand",">guide/define.html#(part._.Function_.Shorthand)","Function Shorthand",false],
["function types",">foreign/foreign_procedures.html","Function Types",false],
["function types",">ts-guide/types.html#(part._.Function_.Types)","Function Types",false],
["function-call optimizations",">guide/performance.html#(part._func-call-performance)","Function-Call Optimizations",false],
["function-interval",">plot/renderer2d.html#(def._((lib._plot/main..rkt)._function-interval))",[0,[2,"function-interval"]],["plot"]],
["function-label",">plot/renderer2d.html#(def._((lib._plot/main..rkt)._function-label))",[0,[2,"function-label"]],["plot"]],
["function-ptr",">foreign/foreign_procedures.html#(def._((lib._ffi/unsafe..rkt)._function-ptr))",[0,[2,"function-ptr"]],["ffi/unsafe"]],
["function-type bells and whistles",">foreign/intro.html#(part._.Function-.Type_.Bells_and_.Whistles)","Function-Type Bells and Whistles",false],
["functional update",">guide/define-struct.html#(tech._functional._update)","<span style=\"font-style: italic\">functional update</span>",false],
["functional usage",">web-server/formlets.html#(part._.Functional_.Usage)","Functional Usage",false],
["functions",">net/head.html#(part._.Functions)","Functions",false],
["functions",">net/base64.html#(part._base64-procs)","Functions",false],
["functions",">net/cookie.html#(part._cookie-procs)","Functions",false],
["functions",">net/dns.html#(part._dns-proc)","Functions",false],
["functions",">net/ftp.html#(part._ftp-procs)","Functions",false],
["functions",">net/qp.html#(part._qp-procs)","Functions",false],
["functions",">net/uri-codec.html#(part._uri-codec-proc)","Functions",false],
["functions",">unstable/Functions.html","Functions",false],
["functions (procedures): lambda",">guide/lambda.html",["Functions (Procedures): ",[0,[1,"lambda"]]],false],
["functions are values",">quick/index.html#(part._.Functions_are_.Values)","Functions are Values",false],
["functions from 2htdp/image and 2htdp/universe",">picturing-programs/index.html#(part._.Functions_from_2htdp_image_and_2htdp_universe)",["Functions from ",[9,[0,"2htdp/image"]]," and ",[9,[0,"2htdp/universe"]]],false],
["functions to run tests",">rackunit/internals.html#(part._.Functions_to_.Run_.Tests)","Functions to Run Tests",false],
["future",">reference/futures.html#(def._((lib._racket/future..rkt)._future))",[0,[2,"future"]],["racket/future","racket"]],
["future",">reference/futures.html#(tech._future)","<span style=\"font-style: italic\">future</span>",false],
["future creation tree",">reference/futures-visualizer.html#(part._future-visualizer-tree)","Future Creation Tree",false],
["future performance logging",">reference/futures-trace.html#(part._future-logging)","Future Performance Logging",false],
["future semaphore",">reference/futures.html#(tech._future._semaphore)","<span style=\"font-style: italic\">future semaphore</span>",false],
["future-event",">reference/futures-trace.html#(def._((lib._future-visualizer/trace..rkt)._future-event))",[0,[2,"future-event"]],["future-visualizer/trace"]],
["future-event-action",">reference/futures-trace.html#(def._((lib._future-visualizer/trace..rkt)._future-event-action))",[0,[2,"future-event-action"]],["future-visualizer/trace"]],
["future-event-future-id",">reference/futures-trace.html#(def._((lib._future-visualizer/trace..rkt)._future-event-future-id))",[0,[2,"future-event-future-id"]],["future-visualizer/trace"]],
["future-event-prim-name",">reference/futures-trace.html#(def._((lib._future-visualizer/trace..rkt)._future-event-prim-name))",[0,[2,"future-event-prim-name"]],["future-visualizer/trace"]],
["future-event-proc-id",">reference/futures-trace.html#(def._((lib._future-visualizer/trace..rkt)._future-event-proc-id))",[0,[2,"future-event-proc-id"]],["future-visualizer/trace"]],
["future-event-time-id",">reference/futures-trace.html#(def._((lib._future-visualizer/trace..rkt)._future-event-time-id))",[0,[2,"future-event-time-id"]],["future-visualizer/trace"]],
["future-event-user-data",">reference/futures-trace.html#(def._((lib._future-visualizer/trace..rkt)._future-event-user-data))",[0,[2,"future-event-user-data"]],["future-visualizer/trace"]],
["future-event?",">reference/futures-trace.html#(def._((lib._future-visualizer/trace..rkt)._future-event~3f))",[0,[2,"future-event?"]],["future-visualizer/trace"]],
["future-visualizer",">reference/futures-visualizer.html",[9,[0,"future-visualizer"]],"module"],
["future-visualizer/trace",">reference/futures-trace.html",[9,[0,"future-visualizer/trace"]],"module"],
["future?",">reference/futures.html#(def._((lib._racket/future..rkt)._future~3f))",[0,[2,"future?"]],["racket/future","racket"]],
["futureof",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Futureof))",[0,[1,"Futureof"]],["typed/racket/base","typed/racket"]],
["futures",">reference/futures.html","Futures",false],
["futures",">unstable/future.html","Futures",false],
["futures trace",">reference/futures-trace.html#(tech._futures._trace)","<span style=\"font-style: italic\">futures trace</span>",false],
["futures tracing",">reference/futures-trace.html","Futures Tracing",false],
["futures visualizer",">reference/futures-visualizer.html","Futures Visualizer",false],
["futures visualizer",">reference/futures-visualizer.html#(tech._futures._visualizer)","<span style=\"font-style: italic\">futures visualizer</span>",false],
["futures-enabled?",">reference/futures.html#(def._((lib._racket/future..rkt)._futures-enabled~3f))",[0,[2,"futures-enabled?"]],["racket/future","racket"]],
["fx*",">reference/fixnums.html#(def._((lib._racket/fixnum..rkt)._fx*))",[0,[2,"fx*"]],["racket/fixnum"]],
["fx*",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_890",[0,[2,"fx*"]],["rnrs/arithmetic/fixnums-6"]],
["fx*/carry",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_912",[0,[2,"fx*/carry"]],["rnrs/arithmetic/fixnums-6"]],
["fx+",">reference/fixnums.html#(def._((lib._racket/fixnum..rkt)._fx+))",[0,[2,"fx+"]],["racket/fixnum"]],
["fx+",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_888",[0,[2,"fx+"]],["rnrs/arithmetic/fixnums-6"]],
["fx+/carry",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_908",[0,[2,"fx+/carry"]],["rnrs/arithmetic/fixnums-6"]],
["fx-",">reference/fixnums.html#(def._((lib._racket/fixnum..rkt)._fx-))",[0,[2,"fx-"]],["racket/fixnum"]],
["fx-",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_892",[0,[2,"fx-"]],["rnrs/arithmetic/fixnums-6"]],
["fx-/carry",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_910",[0,[2,"fx-/carry"]],["rnrs/arithmetic/fixnums-6"]],
["fx->fl",">reference/fixnums.html#(def._((lib._racket/fixnum..rkt)._fx-~3efl))",[0,[2,"fx->fl"]],["racket/fixnum"]],
["fx<",">reference/fixnums.html#(def._((lib._racket/fixnum..rkt)._fx~3c))",[0,[2,"fx<"]],["racket/fixnum"]],
["fx<=",">reference/fixnums.html#(def._((lib._racket/fixnum..rkt)._fx~3c~3d))",[0,[2,"fx<="]],["racket/fixnum"]],
["fx<=?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_872",[0,[2,"fx<=?"]],["rnrs/arithmetic/fixnums-6"]],
["fx<?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_868",[0,[2,"fx<?"]],["rnrs/arithmetic/fixnums-6"]],
["fx=",">reference/fixnums.html#(def._((lib._racket/fixnum..rkt)._fx~3d))",[0,[2,"fx="]],["racket/fixnum"]],
["fx=?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_864",[0,[2,"fx=?"]],["rnrs/arithmetic/fixnums-6"]],
["fx>",">reference/fixnums.html#(def._((lib._racket/fixnum..rkt)._fx~3e))",[0,[2,"fx>"]],["racket/fixnum"]],
["fx>=",">reference/fixnums.html#(def._((lib._racket/fixnum..rkt)._fx~3e~3d))",[0,[2,"fx>="]],["racket/fixnum"]],
["fx>=?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_870",[0,[2,"fx>=?"]],["rnrs/arithmetic/fixnums-6"]],
["fx>?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_866",[0,[2,"fx>?"]],["rnrs/arithmetic/fixnums-6"]],
["fxabs",">reference/fixnums.html#(def._((lib._racket/fixnum..rkt)._fxabs))",[0,[2,"fxabs"]],["racket/fixnum"]],
["fxand",">reference/fixnums.html#(def._((lib._racket/fixnum..rkt)._fxand))",[0,[2,"fxand"]],["racket/fixnum"]],
["fxand",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_916",[0,[2,"fxand"]],["rnrs/arithmetic/fixnums-6"]],
["fxarithmetic-shift",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_938",[0,[2,"fxarithmetic-shift"]],["rnrs/arithmetic/fixnums-6"]],
["fxarithmetic-shift-left",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_940",[0,[2,"fxarithmetic-shift-left"]],["rnrs/arithmetic/fixnums-6"]],
["fxarithmetic-shift-right",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_942",[0,[2,"fxarithmetic-shift-right"]],["rnrs/arithmetic/fixnums-6"]],
["fxbit-count",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_924",[0,[2,"fxbit-count"]],["rnrs/arithmetic/fixnums-6"]],
["fxbit-field",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_934",[0,[2,"fxbit-field"]],["rnrs/arithmetic/fixnums-6"]],
["fxbit-set?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_930",[0,[2,"fxbit-set?"]],["rnrs/arithmetic/fixnums-6"]],
["fxcopy-bit",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_932",[0,[2,"fxcopy-bit"]],["rnrs/arithmetic/fixnums-6"]],
["fxcopy-bit-field",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_936",[0,[2,"fxcopy-bit-field"]],["rnrs/arithmetic/fixnums-6"]],
["fxdiv",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_898",[0,[2,"fxdiv"]],["rnrs/arithmetic/fixnums-6"]],
["fxdiv-and-mod",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_896",[0,[2,"fxdiv-and-mod"]],["rnrs/arithmetic/fixnums-6"]],
["fxdiv0",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_904",[0,[2,"fxdiv0"]],["rnrs/arithmetic/fixnums-6"]],
["fxdiv0-and-mod0",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_902",[0,[2,"fxdiv0-and-mod0"]],["rnrs/arithmetic/fixnums-6"]],
["fxeven?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_882",[0,[2,"fxeven?"]],["rnrs/arithmetic/fixnums-6"]],
["fxfirst-bit-set",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_928",[0,[2,"fxfirst-bit-set"]],["rnrs/arithmetic/fixnums-6"]],
["fxif",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_922",[0,[2,"fxif"]],["rnrs/arithmetic/fixnums-6"]],
["fxior",">reference/fixnums.html#(def._((lib._racket/fixnum..rkt)._fxior))",[0,[2,"fxior"]],["racket/fixnum"]],
["fxior",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_918",[0,[2,"fxior"]],["rnrs/arithmetic/fixnums-6"]],
["fxlength",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_926",[0,[2,"fxlength"]],["rnrs/arithmetic/fixnums-6"]],
["fxlshift",">reference/fixnums.html#(def._((lib._racket/fixnum..rkt)._fxlshift))",[0,[2,"fxlshift"]],["racket/fixnum"]],
["fxmax",">reference/fixnums.html#(def._((lib._racket/fixnum..rkt)._fxmax))",[0,[2,"fxmax"]],["racket/fixnum"]],
["fxmax",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_884",[0,[2,"fxmax"]],["rnrs/arithmetic/fixnums-6"]],
["fxmin",">reference/fixnums.html#(def._((lib._racket/fixnum..rkt)._fxmin))",[0,[2,"fxmin"]],["racket/fixnum"]],
["fxmin",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_886",[0,[2,"fxmin"]],["rnrs/arithmetic/fixnums-6"]],
["fxmod",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_900",[0,[2,"fxmod"]],["rnrs/arithmetic/fixnums-6"]],
["fxmod0",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_906",[0,[2,"fxmod0"]],["rnrs/arithmetic/fixnums-6"]],
["fxmodulo",">reference/fixnums.html#(def._((lib._racket/fixnum..rkt)._fxmodulo))",[0,[2,"fxmodulo"]],["racket/fixnum"]],
["fxnegative?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_878",[0,[2,"fxnegative?"]],["rnrs/arithmetic/fixnums-6"]],
["fxnot",">reference/fixnums.html#(def._((lib._racket/fixnum..rkt)._fxnot))",[0,[2,"fxnot"]],["racket/fixnum"]],
["fxnot",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_914",[0,[2,"fxnot"]],["rnrs/arithmetic/fixnums-6"]],
["fxodd?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_880",[0,[2,"fxodd?"]],["rnrs/arithmetic/fixnums-6"]],
["fxpositive?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_876",[0,[2,"fxpositive?"]],["rnrs/arithmetic/fixnums-6"]],
["fxquotient",">reference/fixnums.html#(def._((lib._racket/fixnum..rkt)._fxquotient))",[0,[2,"fxquotient"]],["racket/fixnum"]],
["fxremainder",">reference/fixnums.html#(def._((lib._racket/fixnum..rkt)._fxremainder))",[0,[2,"fxremainder"]],["racket/fixnum"]],
["fxreverse-bit-field",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_946",[0,[2,"fxreverse-bit-field"]],["rnrs/arithmetic/fixnums-6"]],
["fxrotate-bit-field",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_944",[0,[2,"fxrotate-bit-field"]],["rnrs/arithmetic/fixnums-6"]],
["fxrshift",">reference/fixnums.html#(def._((lib._racket/fixnum..rkt)._fxrshift))",[0,[2,"fxrshift"]],["racket/fixnum"]],
["fxvector",">reference/fixnums.html#(def._((lib._racket/fixnum..rkt)._fxvector))",[0,[2,"fxvector"]],["racket/fixnum"]],
["fxvector",">reference/fixnums.html#(tech._fxvector)","<span style=\"font-style: italic\">fxvector</span>",false],
["fxvector-copy",">reference/fixnums.html#(def._((lib._racket/fixnum..rkt)._fxvector-copy))",[0,[2,"fxvector-copy"]],["racket/fixnum"]],
["fxvector-length",">reference/fixnums.html#(def._((lib._racket/fixnum..rkt)._fxvector-length))",[0,[2,"fxvector-length"]],["racket/fixnum"]],
["fxvector-ref",">reference/fixnums.html#(def._((lib._racket/fixnum..rkt)._fxvector-ref))",[0,[2,"fxvector-ref"]],["racket/fixnum"]],
["fxvector-set!",">reference/fixnums.html#(def._((lib._racket/fixnum..rkt)._fxvector-set!))",[0,[2,"fxvector-set!"]],["racket/fixnum"]],
["fxvector?",">reference/fixnums.html#(def._((lib._racket/fixnum..rkt)._fxvector~3f))",[0,[2,"fxvector?"]],["racket/fixnum"]],
["fxxor",">reference/fixnums.html#(def._((lib._racket/fixnum..rkt)._fxxor))",[0,[2,"fxxor"]],["racket/fixnum"]],
["fxxor",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_920",[0,[2,"fxxor"]],["rnrs/arithmetic/fixnums-6"]],
["fxzero?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_874",[0,[2,"fxzero?"]],["rnrs/arithmetic/fixnums-6"]],
["game rules",">games/gobblet.html#(part._.Game_.Rules)","Game Rules",false],
["games/cards",">cards/index.html",[9,[0,"games/cards"]],"module"],
["games/gl-board-game",">gl-board-game/index.html",[9,[0,"games/gl-board-game"]],"module"],
["games/show-help",">games/Showing_Text_Help.html",[9,[0,"games/show-help"]],"module"],
["games/show-scribbling",">games/Showing_Scribbled_Help.html",[9,[0,"games/show-scribbling"]],"module"],
["games: fun examples",">games/index.html","Games: Fun Examples",false],
["gamma correction",">draw/bitmap_.html#(idx._(gentag._5._(lib._scribblings/draw/draw..scrbl)))","gamma correction",false],
["gao/coclass",">mysterx/methprop.html#(def._((lib._mysterx/main..rkt)._gao/coclass))",[0,[2,"gao/coclass"]],["mysterx"]],
["gap-size",">slideshow/Constants_and_Layout_Variables.html#(def._((lib._slideshow/base..rkt)._gap-size))",[0,[2,"gap-size"]],["slideshow/base","slideshow"]],
["gapped-lines",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtle-examples..rkt)._gapped-lines))",[0,[2,"gapped-lines"]],["graphics/turtle-examples"]],
["garbage collection",">reference/garbagecollection.html","Garbage Collection",false],
["garbage collection",">reference/eval-model.html#(part._gc-model)","Garbage Collection",false],
["garbage collection",">inside/im_memoryalloc.html","garbage collection",false],
["garbage collection",">reference/eval-model.html#(tech._garbage._collection)","<span style=\"font-style: italic\">garbage\ncollection</span>",false],
["garbage collector exports",">plai/collector.html#(part._.Garbage_.Collector_.Exports)","Garbage Collector Exports",false],
["garbage collector interface",">plai/collector.html#(part._.Garbage_.Collector_.Interface)","Garbage Collector Interface",false],
["gauge",">gui/windowing-overview.html#(tech._gauge)","<span style=\"font-style: italic\">gauge</span>",false],
["gauge%",">gui/gauge_.html",[0,[2,"gauge%"]],["racket/gui/base","racket/gui"]],
["gc",">reference/runtime.html#(idx._(gentag._327._(lib._scribblings/reference/reference..scrbl)))",[7,"'gc"],false],
["gc collector scheme",">plai/collector.html","GC Collector Scheme",false],
["gc mutator scheme",">plai/mutator.html","GC Mutator Scheme",false],
["gc-info",">reference/garbagecollection.html#(idx._(gentag._341._(lib._scribblings/reference/reference..scrbl)))",[0,"gc-info"],false],
["gc:alloc-flat",">plai/collector.html#(def._((lib._plai/scribblings/fake-collector..rkt)._gc~3aalloc-flat))",[0,[2,"gc:alloc-flat"]],[]],
["gc:cons",">plai/collector.html#(def._((lib._plai/scribblings/fake-collector..rkt)._gc~3acons))",[0,[2,"gc:cons"]],[]],
["gc:cons?",">plai/collector.html#(def._((lib._plai/scribblings/fake-collector..rkt)._gc~3acons~3f))",[0,[2,"gc:cons?"]],[]],
["gc:deref",">plai/collector.html#(def._((lib._plai/scribblings/fake-collector..rkt)._gc~3aderef))",[0,[2,"gc:deref"]],[]],
["gc:first",">plai/collector.html#(def._((lib._plai/scribblings/fake-collector..rkt)._gc~3afirst))",[0,[2,"gc:first"]],[]],
["gc:flat?",">plai/collector.html#(def._((lib._plai/scribblings/fake-collector..rkt)._gc~3aflat~3f))",[0,[2,"gc:flat?"]],[]],
["gc:rest",">plai/collector.html#(def._((lib._plai/scribblings/fake-collector..rkt)._gc~3arest))",[0,[2,"gc:rest"]],[]],
["gc:set-first!",">plai/collector.html#(def._((lib._plai/scribblings/fake-collector..rkt)._gc~3aset-first!))",[0,[2,"gc:set-first!"]],[]],
["gc:set-rest!",">plai/collector.html#(def._((lib._plai/scribblings/fake-collector..rkt)._gc~3aset-rest!))",[0,[2,"gc:set-rest!"]],[]],
["gc_fixup_self",">inside/im_memoryalloc.html#(idx._(gentag._269._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"GC_fixup_self"]],false],
["gc_register_traversers",">inside/im_memoryalloc.html#(idx._(gentag._267._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"GC_register_traversers"]],false],
["gc_resolve",">inside/im_memoryalloc.html#(idx._(gentag._268._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"GC_resolve"]],false],
["gcalc --- visual \u03bb-calculus",">games/gcalc.html",[[15,"<img src=\"gcalc.png\" alt=\"\" />"]," ","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">GCalc</span>"," ","&#8212;","<wbr></wbr>"," Visual ","&#955;","-Calculus"],false],
["gcd",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._gcd))",[0,[2,"gcd"]],["racket/base","racket"]],
["gcd",">r5rs-std/r5rs-Z-H-9.html#%_idx_306",[0,[2,"gcd"]],["r5rs"]],
["gcd",">r6rs-std/r6rs-Z-H-14.html#node_idx_520",[0,[2,"gcd"]],["rnrs/base-6"]],
["gcd",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._gcd))",[0,[2,"gcd"]],["lang/htdp-advanced"]],
["gcd",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._gcd))",[0,[2,"gcd"]],["lang/htdp-beginner"]],
["gcd",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._gcd))",[0,[2,"gcd"]],["lang/htdp-beginner-abbr"]],
["gcd",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._gcd))",[0,[2,"gcd"]],["lang/htdp-intermediate"]],
["gcd",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._gcd))",[0,[2,"gcd"]],["lang/htdp-intermediate-lambda"]],
["gcd",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._gcd))",[0,[2,"gcd"]],["deinprogramm/DMdA-advanced"]],
["gcd",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._gcd))",[0,[2,"gcd"]],["deinprogramm/DMdA-assignments"]],
["gcd",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._gcd))",[0,[2,"gcd"]],["deinprogramm/DMdA-beginner"]],
["gcd",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._gcd))",[0,[2,"gcd"]],["deinprogramm/DMdA-vanilla"]],
["gekapselter zustand",">deinprogramm/Konstruktionsanleitungen_1_bis_10.html#(part._gekapselter_.Zustand)","gekapselter Zustand",false],
["gem-blue",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._gem-blue))",[0,[2,"gem-blue"]],["2htdp/planetcute"]],
["gem-green",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._gem-green))",[0,[2,"gem-green"]],["2htdp/planetcute"]],
["gem-orange",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._gem-orange))",[0,[2,"gem-orange"]],["2htdp/planetcute"]],
["gemischte daten",">deinprogramm/Konstruktionsanleitungen_1_bis_10.html#(part._gemischte_.Daten)","gemischte Daten",false],
["gen-authentication-responder",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/responders..rkt)._gen-authentication-responder))",[0,[2,"gen-authentication-responder"]],["web-server/configuration/responders"]],
["gen-collect-garbage-responder",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/responders..rkt)._gen-collect-garbage-responder))",[0,[2,"gen-collect-garbage-responder"]],["web-server/configuration/responders"]],
["gen-file-not-found-responder",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/responders..rkt)._gen-file-not-found-responder))",[0,[2,"gen-file-not-found-responder"]],["web-server/configuration/responders"]],
["gen-passwords-refreshed",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/responders..rkt)._gen-passwords-refreshed))",[0,[2,"gen-passwords-refreshed"]],["web-server/configuration/responders"]],
["gen-protocol-responder",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/responders..rkt)._gen-protocol-responder))",[0,[2,"gen-protocol-responder"]],["web-server/configuration/responders"]],
["gen-servlet-not-found",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/responders..rkt)._gen-servlet-not-found))",[0,[2,"gen-servlet-not-found"]],["web-server/configuration/responders"]],
["gen-servlet-responder",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/responders..rkt)._gen-servlet-responder))",[0,[2,"gen-servlet-responder"]],["web-server/configuration/responders"]],
["gen-servlets-refreshed",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/responders..rkt)._gen-servlets-refreshed))",[0,[2,"gen-servlets-refreshed"]],["web-server/configuration/responders"]],
["gen:custom-write",">reference/Printer_Extension.html#(def._((lib._racket/private/base..rkt)._gen~3acustom-write))",[0,[2,"gen:custom-write"]],["racket/base","racket"]],
["gen:dict",">reference/dicts.html#(def._((lib._racket/dict..rkt)._gen~3adict))",[0,[2,"gen:dict"]],["racket/dict","racket"]],
["gen:equal+hash",">reference/booleans.html#(def._((lib._racket/private/base..rkt)._gen~3aequal+hash))",[0,[2,"gen:equal+hash"]],["racket/base","racket"]],
["gen:ordered-dict",">data/Orders_and_Ordered_Dictionaries.html#(def._((lib._data/order..rkt)._gen~3aordered-dict))",[0,[2,"gen:ordered-dict"]],["data/order"]],
["gen:stream",">reference/streams.html#(def._((lib._racket/stream..rkt)._gen~3astream))",[0,[2,"gen:stream"]],["racket/stream","racket"]],
["general",">drracket/prefs-explanation.html#(part._.General)","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">General</span>",false],
["general",">web-server-internal/dispatch.html","General",false],
["general",">web-server/servlet.html#(part._manager)","General",false],
["general appearance",">plot/params.html#(part._.General_.Appearance)","General Appearance",false],
["general guidelines",">htdp/index.html#(part._.General_.Guidelines)","General Guidelines",false],
["general macro transformers",">guide/proc-macros.html","General Macro Transformers",false],
["general phase levels",">guide/phases.html","General Phase Levels",false],
["general query support",">db/query-api.html#(part._.General_.Query_.Support)","General Query Support",false],
["general transformations",">images/Spatial_Transformations.html#(part._.General_.Transformations)","General Transformations",false],
["general vocabulary guidelines",">htdp/index.html#(part._.General_.Vocabulary_.Guidelines)","General Vocabulary Guidelines",false],
["generate-delayed-documents",">scribble/srcdoc.html#(form._((lib._scribble/srcdoc..rkt)._generate-delayed-documents))",[0,[1,"generate-delayed-documents"]],["scribble/srcdoc"]],
["generate-error-output",">net/cgi.html#(def._((lib._net/cgi..rkt)._generate-error-output))",[0,[2,"generate-error-output"]],["net/cgi"]],
["generate-expand-context",">syntax/transformer-helpers.html#(def._((lib._syntax/context..rkt)._generate-expand-context))",[0,[2,"generate-expand-context"]],["syntax/context"]],
["generate-html-output",">net/cgi.html#(def._((lib._net/cgi..rkt)._generate-html-output))",[0,[2,"generate-html-output"]],["net/cgi"]],
["generate-link-text",">net/cgi.html#(def._((lib._net/cgi..rkt)._generate-link-text))",[0,[2,"generate-link-text"]],["net/cgi"]],
["generate-member-key",">reference/createclass.html#(def._((lib._racket/private/class-internal..rkt)._generate-member-key))",[0,[2,"generate-member-key"]],["racket/class","racket"]],
["generate-report",">htdp/index.html#(def._((lib._htdp/testing..rkt)._generate-report))",[0,[2,"generate-report"]],["htdp/testing"]],
["generate-struct-declaration",">syntax/transformer-helpers.html#(def._((lib._syntax/struct..rkt)._generate-struct-declaration))",[0,[2,"generate-struct-declaration"]],["syntax/struct"]],
["generate-temporaries",">reference/stxops.html#(def._((lib._racket/private/stxcase-scheme..rkt)._generate-temporaries))",[0,[2,"generate-temporaries"]],["racket/base","racket"]],
["generate-temporaries",">r6rs-lib-std/r6rs-lib-Z-H-13.html#node_idx_1150",[0,[2,"generate-temporaries"]],["rnrs/syntax-case-6"]],
["generate-temporary",">reference/syntax-util.html#(def._((lib._racket/syntax..rkt)._generate-temporary))",[0,[2,"generate-temporary"]],["racket/syntax"]],
["generate-term",">redex/The_Redex_Reference.html#(form._((lib._redex/reduction-semantics..rkt)._generate-term))",[0,[1,"generate-term"]],["redex/reduction-semantics","redex"]],
["generated-tag",">scribble/core.html#(def._((lib._scribble/core..rkt)._generated-tag))",[0,[2,"generated-tag"]],["scribble/core"]],
["generated-tag?",">scribble/core.html#(def._((lib._scribble/core..rkt)._generated-tag~3f))",[0,[2,"generated-tag?"]],["scribble/core"]],
["generating a unit from context",">reference/Generating_A_Unit_from_Context.html","Generating A Unit from Context",false],
["generating animated slides",">slideshow/play.html#(part._.Generating_.Animated_.Slides)","Generating Animated Slides",false],
["generating json text from js-expressions",">json/index.html#(part._.Generating_.J.S.O.N_.Text_from_.J.S-.Expressions)","Generating JSON Text from JS-Expressions",false],
["generating predicates automatically",">ts-reference/special-forms.html#(part._.Generating_.Predicates_.Automatically)","Generating Predicates Automatically",false],
["generating random mutators",">plai/mutator.html#(part._.Generating_.Random_.Mutators)","Generating Random Mutators",false],
["generational garbage collector",">guide/performance.html#(tech._generational._garbage._collector)","<span style=\"font-style: italic\">generational garbage collector</span>",false],
["generator",">reference/Generators.html#(form._((lib._racket/generator..rkt)._generator))",[0,[1,"generator"]],["racket/generator"]],
["generator",">srfi-std/srfi-42.html#generator",[0,[1,"generator"]],["srfi/42"]],
["generator",">reference/Generators.html#(tech._generator)","<span style=\"font-style: italic\">generator</span>",false],
["generator-state",">reference/Generators.html#(def._((lib._racket/generator..rkt)._generator-state))",[0,[2,"generator-state"]],["racket/generator"]],
["generator?",">reference/Generators.html#(def._((lib._racket/generator..rkt)._generator~3f))",[0,[2,"generator?"]],["racket/generator"]],
["generators",">reference/Generators.html","Generators",false],
["generic",">reference/ivaraccess.html#(form._((lib._racket/private/class-internal..rkt)._generic))",[0,[1,"generic"]],["racket/class","racket"]],
["generic",">reference/ivaraccess.html#(tech._generic)","<span style=\"font-style: italic\">generic</span>",false],
["generic commands",">xrepl/index.html#(part._.Generic_.Commands)","Generic Commands",false],
["generic interface",">reference/struct-generics.html#(tech._generic._interface)","<span style=\"font-style: italic\">generic interface</span>",false],
["generic interfaces",">reference/struct-generics.html","Generic Interfaces",false],
["generic numerics",">reference/generic-numbers.html","Generic Numerics",false],
["generic-message-command",">net/nntp.html#(def._((lib._net/nntp..rkt)._generic-message-command))",[0,[2,"generic-message-command"]],["net/nntp"]],
["generic?",">reference/objectutils.html#(def._((lib._racket/private/class-internal..rkt)._generic~3f))",[0,[2,"generic?"]],["racket/class","racket"]],
["generics",">reference/ivaraccess.html#(part._.Generics)","Generics",false],
["gensym",">reference/symbols.html#(def._((quote._~23~25kernel)._gensym))",[0,[2,"gensym"]],["racket/base","racket"]],
["gensym",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._gensym))",[0,[2,"gensym"]],["lang/htdp-advanced"]],
["gentmp",">mzlib/mzlib_compat.html#(def._((lib._mzlib/compat..rkt)._gentmp))",[0,"gentmp"],["mzlib/compat"]],
["geometric types",">db/util.html#(part._geometry)","Geometric Types",false],
["geometry management",">gui/windowing-overview.html#(part._containeroverview)","Geometry Management",false],
["geometry->wkb",">db/util.html#(def._((lib._db/util/geometry..rkt)._geometry-~3ewkb))",[0,[2,"geometry->wkb"]],["db/util/geometry"]],
["geometry-collection",">db/util.html#(def._((lib._db/util/geometry..rkt)._geometry-collection))",[0,[2,"geometry-collection"]],["db/util/geometry"]],
["geometry-collection-elements",">db/util.html#(def._((lib._db/util/geometry..rkt)._geometry-collection-elements))",[0,[2,"geometry-collection-elements"]],["db/util/geometry"]],
["geometry-collection?",">db/util.html#(def._((lib._db/util/geometry..rkt)._geometry-collection~3f))",[0,[2,"geometry-collection?"]],["db/util/geometry"]],
["geometry2d?",">db/util.html#(def._((lib._db/util/geometry..rkt)._geometry2d~3f))",[0,[2,"geometry2d?"]],["db/util/geometry"]],
["get",">gui/editor-stream-in_.html#(meth._(((lib._mred/main..rkt)._editor-stream-in~25)._get))",[[0,[2,"get"]],[14,[" (method of ",[0,[2,"editor-stream-in%"]],")"]]],["racket/gui/base","racket/gui"]],
["get",">reference/distributed-places.html#(meth._(((lib._racket/place/distributed..rkt)._named-place-typed-channel~25)._get))",[[0,[2,"get"]],[14,[" (method of ",[0,[2,"named-place-typed-channel%"]],")"]]],["racket/place/distributed"]],
["get",">gui/add-color___.html#(meth._(((lib._racket/snip..rkt)._add-color~3c~25~3e)._get))",[[0,[2,"get"]],[14,[" (method of ",[0,[2,"add-color<%>"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get",">gui/mult-color___.html#(meth._(((lib._racket/snip..rkt)._mult-color~3c~25~3e)._get))",[[0,[2,"get"]],[14,[" (method of ",[0,[2,"mult-color<%>"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get",">unstable/gui-notify.html#(meth._(((lib._unstable/gui/notify..rkt)._notify-box~25)._get))",[[0,[2,"get"]],[14,[" (method of ",[0,[2,"notify-box%"]],")"]]],["unstable/gui/notify"]],
["get-accum-size",">draw/gl-config_.html#(meth._(((lib._racket/draw..rkt)._gl-config~25)._get-accum-size))",[[0,[2,"get-accum-size"]],[14,[" (method of ",[0,[2,"gl-config%"]],")"]]],["racket/draw"]],
["get-active-canvas",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._get-active-canvas))",[[0,[2,"get-active-canvas"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-active-frame",">framework/Group.html#(meth._(((lib._framework/main..rkt)._group~3a~25)._get-active-frame))",[[0,[2,"get-active-frame"]],[14,[" (method of ",[0,[2,"group:%"]],")"]]],["framework"]],
["get-additional-important-urls",">tools/drracket_frame.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aframe~3abasics-mixin)._get-additional-important-urls))",[[0,[2,"get-additional-important-urls"]],[14,[" (method of ",[0,[2,"drracket:frame:basics-mixin"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-admin",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._get-admin))",[[0,[2,"get-admin"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-admin",">gui/snip_.html#(meth._(((lib._racket/snip..rkt)._snip~25)._get-admin))",[[0,[2,"get-admin"]],[14,[" (method of ",[0,[2,"snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-align-top-line",">gui/editor-snip_.html#(meth._(((lib._mred/main..rkt)._editor-snip~25)._get-align-top-line))",[[0,[2,"get-align-top-line"]],[14,[" (method of ",[0,[2,"editor-snip%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-aligned-min-height",">embedded-gui/stretchable-snip___.html#(meth._(((lib._embedded-gui/main..rkt)._stretchable-snip~3c~25~3e)._get-aligned-min-height))",[[0,[2,"get-aligned-min-height"]],[14,[" (method of ",[0,[2,"stretchable-snip<%>"]],")"]]],["embedded-gui"]],
["get-aligned-min-height",">mrlib/aligned-pasteboard___.html#(meth._(((lib._mrlib/aligned-pasteboard..rkt)._aligned-pasteboard~3c~25~3e)._get-aligned-min-height))",[[0,[2,"get-aligned-min-height"]],[14,[" (method of ",[0,[2,"aligned-pasteboard<%>"]],")"]]],["mrlib/aligned-pasteboard"]],
["get-aligned-min-height",">mrlib/stretchable-snip___.html#(meth._(((lib._mrlib/aligned-pasteboard..rkt)._stretchable-snip~3c~25~3e)._get-aligned-min-height))",[[0,[2,"get-aligned-min-height"]],[14,[" (method of ",[0,[2,"stretchable-snip<%>"]],")"]]],["mrlib/aligned-pasteboard"]],
["get-aligned-min-width",">embedded-gui/stretchable-snip___.html#(meth._(((lib._embedded-gui/main..rkt)._stretchable-snip~3c~25~3e)._get-aligned-min-width))",[[0,[2,"get-aligned-min-width"]],[14,[" (method of ",[0,[2,"stretchable-snip<%>"]],")"]]],["embedded-gui"]],
["get-aligned-min-width",">mrlib/aligned-pasteboard___.html#(meth._(((lib._mrlib/aligned-pasteboard..rkt)._aligned-pasteboard~3c~25~3e)._get-aligned-min-width))",[[0,[2,"get-aligned-min-width"]],[14,[" (method of ",[0,[2,"aligned-pasteboard<%>"]],")"]]],["mrlib/aligned-pasteboard"]],
["get-aligned-min-width",">mrlib/stretchable-snip___.html#(meth._(((lib._mrlib/aligned-pasteboard..rkt)._stretchable-snip~3c~25~3e)._get-aligned-min-width))",[[0,[2,"get-aligned-min-width"]],[14,[" (method of ",[0,[2,"stretchable-snip<%>"]],")"]]],["mrlib/aligned-pasteboard"]],
["get-alignment",">gui/area-container___.html#(meth._(((lib._mred/main..rkt)._area-container~3c~25~3e)._get-alignment))",[[0,[2,"get-alignment"]],[14,[" (method of ",[0,[2,"area-container<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-alignment",">gui/style___.html#(meth._(((lib._racket/snip..rkt)._style~3c~25~3e)._get-alignment))",[[0,[2,"get-alignment"]],[14,[" (method of ",[0,[2,"style<%>"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-alignment-off",">gui/style-delta_.html#(meth._(((lib._racket/snip..rkt)._style-delta~25)._get-alignment-off))",[[0,[2,"get-alignment-off"]],[14,[" (method of ",[0,[2,"style-delta%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-alignment-on",">gui/style-delta_.html#(meth._(((lib._racket/snip..rkt)._style-delta~25)._get-alignment-on))",[[0,[2,"get-alignment-on"]],[14,[" (method of ",[0,[2,"style-delta%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-all-planet-packages",">planet/Utility_Libraries.html#(def._((lib._planet/planet-archives..rkt)._get-all-planet-packages))",[0,"get-all-planet-packages"],["planet/planet-archives"]],
["get-all-words",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3aautocomplete~3c~25~3e)._get-all-words))",[[0,[2,"get-all-words"]],[14,[" (method of ",[0,[2,"text:autocomplete<%>"]],")"]]],["framework"]],
["get-allow-edits",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3aports~3c~25~3e)._get-allow-edits))",[[0,[2,"get-allow-edits"]],[14,[" (method of ",[0,[2,"text:ports<%>"]],")"]]],["framework"]],
["get-allow-selection?",">mrlib/hierarchical-list-item___.html#(meth._(((lib._mrlib/hierlist..rkt)._hierarchical-list-item~3c~25~3e)._get-allow-selection~3f))",[[0,[2,"get-allow-selection?"]],[14,[" (method of ",[0,[2,"hierarchical-list-item<%>"]],")"]]],["mrlib/hierlist"]],
["get-alpha",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._get-alpha))",[[0,[2,"get-alpha"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["get-alt-down",">gui/key-event_.html#(meth._(((lib._mred/main..rkt)._key-event~25)._get-alt-down))",[[0,[2,"get-alt-down"]],[14,[" (method of ",[0,[2,"key-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-alt-down",">gui/mouse-event_.html#(meth._(((lib._mred/main..rkt)._mouse-event~25)._get-alt-down))",[[0,[2,"get-alt-down"]],[14,[" (method of ",[0,[2,"mouse-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-anchor",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._get-anchor))",[[0,[2,"get-anchor"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-area-container",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3abasic~3c~25~3e)._get-area-container))",[[0,[2,"get-area-container"]],[14,[" (method of ",[0,[2,"frame:basic<%>"]],")"]]],["framework"]],
["get-area-container%",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3abasic~3c~25~3e)._get-area-container~25))",[[0,[2,"get-area-container%"]],[14,[" (method of ",[0,[2,"frame:basic<%>"]],")"]]],["framework"]],
["get-arg",">preprocessor/mztext.html#(def._((lib._preprocessor/mztext..rkt)._get-arg))",[0,[2,"get-arg"]],["preprocessor/mztext"]],
["get-arg*",">preprocessor/mztext.html#(def._((lib._preprocessor/mztext..rkt)._get-arg*))",[0,[2,"get-arg*"]],["preprocessor/mztext"]],
["get-arg-reads-word?",">preprocessor/mztext.html#(def._((lib._preprocessor/mztext..rkt)._get-arg-reads-word~3f))",[0,[2,"get-arg-reads-word?"]],["preprocessor/mztext"]],
["get-argb",">mrlib/Cache-image_Snip.html#(meth._(((lib._mrlib/cache-image-snip..rkt)._cache-image-snip~25)._get-argb))",[[0,[2,"get-argb"]],[14,[" (method of ",[0,[2,"cache-image-snip%"]],")"]]],["mrlib/cache-image-snip"]],
["get-argb",">gui/WXME_Decoding.html#(meth._(((lib._wxme/cache-image..rkt)._cache-image~25)._get-argb))",[[0,[2,"get-argb"]],[14,[" (method of ",[0,[2,"cache-image%"]],")"]]],["wxme/cache-image"]],
["get-argb-pixels",">draw/bitmap_.html#(meth._(((lib._racket/draw..rkt)._bitmap~25)._get-argb-pixels))",[[0,[2,"get-argb-pixels"]],[14,[" (method of ",[0,[2,"bitmap%"]],")"]]],["racket/draw"]],
["get-argb-pixels",">draw/bitmap-dc_.html#(meth._(((lib._racket/draw..rkt)._bitmap-dc~25)._get-argb-pixels))",[[0,[2,"get-argb-pixels"]],[14,[" (method of ",[0,[2,"bitmap-dc%"]],")"]]],["racket/draw"]],
["get-argb-proc",">mrlib/Cache-image_Snip.html#(meth._(((lib._mrlib/cache-image-snip..rkt)._cache-image-snip~25)._get-argb-proc))",[[0,[2,"get-argb-proc"]],[14,[" (method of ",[0,[2,"cache-image-snip%"]],")"]]],["mrlib/cache-image-snip"]],
["get-argb/no-compute",">mrlib/Cache-image_Snip.html#(meth._(((lib._mrlib/cache-image-snip..rkt)._cache-image-snip~25)._get-argb/no-compute))",[[0,[2,"get-argb/no-compute"]],[14,[" (method of ",[0,[2,"cache-image-snip%"]],")"]]],["mrlib/cache-image-snip"]],
["get-arrow-snip",">mrlib/hierarchical-list-compound-item___.html#(meth._(((lib._mrlib/hierlist..rkt)._hierarchical-list-compound-item~3c~25~3e)._get-arrow-snip))",[[0,[2,"get-arrow-snip"]],[14,[" (method of ",[0,[2,"hierarchical-list-compound-item<%>"]],")"]]],["mrlib/hierlist"]],
["get-arrowhead-params",">mrlib/graph-pasteboard___.html#(meth._(((lib._mrlib/graph..rkt)._graph-pasteboard~3c~25~3e)._get-arrowhead-params))",[[0,[2,"get-arrowhead-params"]],[14,[" (method of ",[0,[2,"graph-pasteboard<%>"]],")"]]],["mrlib/graph"]],
["get-autocomplete-background-color",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3aautocomplete~3c~25~3e)._get-autocomplete-background-color))",[[0,[2,"get-autocomplete-background-color"]],[14,[" (method of ",[0,[2,"text:autocomplete<%>"]],")"]]],["framework"]],
["get-autocomplete-border-color",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3aautocomplete~3c~25~3e)._get-autocomplete-border-color))",[[0,[2,"get-autocomplete-border-color"]],[14,[" (method of ",[0,[2,"text:autocomplete<%>"]],")"]]],["framework"]],
["get-autocomplete-selected-color",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3aautocomplete~3c~25~3e)._get-autocomplete-selected-color))",[[0,[2,"get-autocomplete-selected-color"]],[14,[" (method of ",[0,[2,"text:autocomplete<%>"]],")"]]],["framework"]],
["get-b",">gui/add-color___.html#(meth._(((lib._racket/snip..rkt)._add-color~3c~25~3e)._get-b))",[[0,[2,"get-b"]],[14,[" (method of ",[0,[2,"add-color<%>"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-b",">gui/mult-color___.html#(meth._(((lib._racket/snip..rkt)._mult-color~3c~25~3e)._get-b))",[[0,[2,"get-b"]],[14,[" (method of ",[0,[2,"mult-color<%>"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-background",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._get-background))",[[0,[2,"get-background"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["get-background",">gui/style___.html#(meth._(((lib._racket/snip..rkt)._style~3c~25~3e)._get-background))",[[0,[2,"get-background"]],[14,[" (method of ",[0,[2,"style<%>"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-background-add",">gui/style-delta_.html#(meth._(((lib._racket/snip..rkt)._style-delta~25)._get-background-add))",[[0,[2,"get-background-add"]],[14,[" (method of ",[0,[2,"style-delta%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-background-color",">mrlib/Name_Message.html#(meth._(((lib._mrlib/name-message..rkt)._name-message~25)._get-background-color))",[[0,[2,"get-background-color"]],[14,[" (method of ",[0,[2,"name-message%"]],")"]]],["mrlib/name-message"]],
["get-background-mult",">gui/style-delta_.html#(meth._(((lib._racket/snip..rkt)._style-delta~25)._get-background-mult))",[[0,[2,"get-background-mult"]],[14,[" (method of ",[0,[2,"style-delta%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-backward-sexp",">framework/Racket.html#(meth._(((lib._framework/main..rkt)._racket~3atext~3c~25~3e)._get-backward-sexp))",[[0,[2,"get-backward-sexp"]],[14,[" (method of ",[0,[2,"racket:text<%>"]],")"]]],["framework"]],
["get-base-style",">gui/style___.html#(meth._(((lib._racket/snip..rkt)._style~3c~25~3e)._get-base-style))",[[0,[2,"get-base-style"]],[14,[" (method of ",[0,[2,"style<%>"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-between-threshold",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._get-between-threshold))",[[0,[2,"get-between-threshold"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-binding",">web-server/page.html#(def._((lib._web-server/page..rkt)._get-binding))",[0,[2,"get-binding"]],["web-server/page"]],
["get-bindings",">net/cgi.html#(def._((lib._net/cgi..rkt)._get-bindings))",[0,[2,"get-bindings"]],["net/cgi"]],
["get-bindings",">web-server/page.html#(def._((lib._web-server/page..rkt)._get-bindings))",[0,[2,"get-bindings"]],["web-server/page"]],
["get-bindings/get",">net/cgi.html#(def._((lib._net/cgi..rkt)._get-bindings/get))",[0,[2,"get-bindings/get"]],["net/cgi"]],
["get-bindings/post",">net/cgi.html#(def._((lib._net/cgi..rkt)._get-bindings/post))",[0,[2,"get-bindings/post"]],["net/cgi"]],
["get-bitmap",">draw/bitmap-dc_.html#(meth._(((lib._racket/draw..rkt)._bitmap-dc~25)._get-bitmap))",[[0,[2,"get-bitmap"]],[14,[" (method of ",[0,[2,"bitmap-dc%"]],")"]]],["racket/draw"]],
["get-bitmap",">gui/image-snip_.html#(meth._(((lib._racket/snip..rkt)._image-snip~25)._get-bitmap))",[[0,[2,"get-bitmap"]],[14,[" (method of ",[0,[2,"image-snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-bitmap",">mrlib/Cache-image_Snip.html#(meth._(((lib._mrlib/cache-image-snip..rkt)._cache-image-snip~25)._get-bitmap))",[[0,[2,"get-bitmap"]],[14,[" (method of ",[0,[2,"cache-image-snip%"]],")"]]],["mrlib/cache-image-snip"]],
["get-bitmap-mask",">gui/image-snip_.html#(meth._(((lib._racket/snip..rkt)._image-snip~25)._get-bitmap-mask))",[[0,[2,"get-bitmap-mask"]],[14,[" (method of ",[0,[2,"image-snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-bounding-box",">draw/dc-path_.html#(meth._(((lib._racket/draw..rkt)._dc-path~25)._get-bounding-box))",[[0,[2,"get-bounding-box"]],[14,[" (method of ",[0,[2,"dc-path%"]],")"]]],["racket/draw"]],
["get-bounding-box",">draw/region_.html#(meth._(((lib._racket/draw..rkt)._region~25)._get-bounding-box))",[[0,[2,"get-bounding-box"]],[14,[" (method of ",[0,[2,"region%"]],")"]]],["racket/draw"]],
["get-box-input-editor-snip%",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3aports~3c~25~3e)._get-box-input-editor-snip~25))",[[0,[2,"get-box-input-editor-snip%"]],[14,[" (method of ",[0,[2,"text:ports<%>"]],")"]]],["framework"]],
["get-box-input-text%",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3aports~3c~25~3e)._get-box-input-text~25))",[[0,[2,"get-box-input-text%"]],[14,[" (method of ",[0,[2,"text:ports<%>"]],")"]]],["framework"]],
["get-break-button",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aframe~25)._get-break-button))",[[0,[2,"get-break-button"]],[14,[" (method of ",[0,[2,"drracket:unit:frame%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-breakables",">tools/drracket_rep.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3arep~3acontext~3c~25~3e)._get-breakables))",[[0,[2,"get-breakables"]],[14,[" (method of ",[0,[2,"drracket:rep:context<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-breakables",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3atab~3c~25~3e)._get-breakables))",[[0,[2,"get-breakables"]],[14,[" (method of ",[0,[2,"drracket:unit:tab<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-brush",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._get-brush))",[[0,[2,"get-brush"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["get-button-label",">mrlib/Switchable_Button.html#(meth._(((lib._mrlib/switchable-button..rkt)._switchable-button~25)._get-button-label))",[[0,[2,"get-button-label"]],[14,[" (method of ",[0,[2,"switchable-button%"]],")"]]],["mrlib/switchable-button"]],
["get-button-panel",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aframe~25)._get-button-panel))",[[0,[2,"get-button-panel"]],[14,[" (method of ",[0,[2,"drracket:unit:frame%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-bytes",">gui/editor-stream-in_.html#(meth._(((lib._mred/main..rkt)._editor-stream-in~25)._get-bytes))",[[0,[2,"get-bytes"]],[14,[" (method of ",[0,[2,"editor-stream-in%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-bytes",">gui/editor-stream-out-bytes-base_.html#(meth._(((lib._mred/main..rkt)._editor-stream-out-bytes-base~25)._get-bytes))",[[0,[2,"get-bytes"]],[14,[" (method of ",[0,[2,"editor-stream-out-bytes-base%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-bytevector-all",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_694",[0,[2,"get-bytevector-all"]],["rnrs/io/ports-6"]],
["get-bytevector-n",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_688",[0,[2,"get-bytevector-n"]],["rnrs/io/ports-6"]],
["get-bytevector-n!",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_690",[0,[2,"get-bytevector-n!"]],["rnrs/io/ports-6"]],
["get-bytevector-some",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_692",[0,[2,"get-bytevector-some"]],["rnrs/io/ports-6"]],
["get-can-close-parent",">framework/Editor.html#(meth._(((lib._framework/main..rkt)._editor~3afile~3c~25~3e)._get-can-close-parent))",[[0,[2,"get-can-close-parent"]],[14,[" (method of ",[0,[2,"editor:file<%>"]],")"]]],["framework"]],
["get-canvas",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._get-canvas))",[[0,[2,"get-canvas"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-canvas",">browser/index.html#(meth._(((lib._browser/browser..rkt)._hyper-panel-mixin)._get-canvas))",[[0,[2,"get-canvas"]],[14,[" (method of ",[0,[2,"hyper-panel-mixin"]],")"]]],["browser/browser","browser"]],
["get-canvas",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aframe~25)._get-canvas))",[[0,[2,"get-canvas"]],[14,[" (method of ",[0,[2,"drracket:unit:frame%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-canvas",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3aeditor~3c~25~3e)._get-canvas))",[[0,[2,"get-canvas"]],[14,[" (method of ",[0,[2,"frame:editor<%>"]],")"]]],["framework"]],
["get-canvas%",">browser/index.html#(meth._(((lib._browser/browser..rkt)._hyper-panel-mixin)._get-canvas~25))",[[0,[2,"get-canvas%"]],[14,[" (method of ",[0,[2,"hyper-panel-mixin"]],")"]]],["browser/browser","browser"]],
["get-canvas%",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aframe~25)._get-canvas~25))",[[0,[2,"get-canvas%"]],[14,[" (method of ",[0,[2,"drracket:unit:frame%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-canvas%",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3aeditor~3c~25~3e)._get-canvas~25))",[[0,[2,"get-canvas%"]],[14,[" (method of ",[0,[2,"frame:editor<%>"]],")"]]],["framework"]],
["get-canvas-background",">gui/canvas___.html#(meth._(((lib._mred/main..rkt)._canvas~3c~25~3e)._get-canvas-background))",[[0,[2,"get-canvas-background"]],[14,[" (method of ",[0,[2,"canvas<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-canvas<%>",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3aeditor~3c~25~3e)._get-canvas~3c~25~3e))",[[0,[2,"get-canvas<%>"]],[14,[" (method of ",[0,[2,"frame:editor<%>"]],")"]]],["framework"]],
["get-canvases",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._get-canvases))",[[0,[2,"get-canvases"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-cap",">draw/pen_.html#(meth._(((lib._racket/draw..rkt)._pen~25)._get-cap))",[[0,[2,"get-cap"]],[14,[" (method of ",[0,[2,"pen%"]],")"]]],["racket/draw"]],
["get-caps-down",">gui/key-event_.html#(meth._(((lib._mred/main..rkt)._key-event~25)._get-caps-down))",[[0,[2,"get-caps-down"]],[14,[" (method of ",[0,[2,"key-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-caps-down",">gui/mouse-event_.html#(meth._(((lib._mred/main..rkt)._mouse-event~25)._get-caps-down))",[[0,[2,"get-caps-down"]],[14,[" (method of ",[0,[2,"mouse-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-case-sensitive-search?",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3asearchable~3c~25~3e)._get-case-sensitive-search~3f))",[[0,[2,"get-case-sensitive-search?"]],[14,[" (method of ",[0,[2,"frame:searchable<%>"]],")"]]],["framework"]],
["get-center",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._get-center))",[[0,[2,"get-center"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-cgi-method",">net/cgi.html#(def._((lib._net/cgi..rkt)._get-cgi-method))",[0,[2,"get-cgi-method"]],["net/cgi"]],
["get-chained-keymaps",">framework/Keymap.html#(meth._(((lib._framework/main..rkt)._keymap~3aaug-keymap~3c~25~3e)._get-chained-keymaps))",[[0,[2,"get-chained-keymaps"]],[14,[" (method of ",[0,[2,"keymap:aug-keymap<%>"]],")"]]],["framework"]],
["get-char",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_696",[0,[2,"get-char"]],["rnrs/io/ports-6"]],
["get-char-height",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._get-char-height))",[[0,[2,"get-char-height"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["get-char-width",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._get-char-width))",[[0,[2,"get-char-width"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["get-character",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._get-character))",[[0,[2,"get-character"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-checkable-menu-item%",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._get-checkable-menu-item~25))",[[0,[2,"get-checkable-menu-item%"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["get-children",">gui/area-container___.html#(meth._(((lib._mred/main..rkt)._area-container~3c~25~3e)._get-children))",[[0,[2,"get-children"]],[14,[" (method of ",[0,[2,"area-container<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-children",">mrlib/graph-snip___.html#(meth._(((lib._mrlib/graph..rkt)._graph-snip~3c~25~3e)._get-children))",[[0,[2,"get-children"]],[14,[" (method of ",[0,[2,"graph-snip<%>"]],")"]]],["mrlib/graph"]],
["get-choices-from-user",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._get-choices-from-user))",[0,[2,"get-choices-from-user"]],["racket/gui/base","racket/gui"]],
["get-circles",">draw/radial-gradient_.html#(meth._(((lib._racket/draw..rkt)._radial-gradient~25)._get-circles))",[[0,[2,"get-circles"]],[14,[" (method of ",[0,[2,"radial-gradient%"]],")"]]],["racket/draw"]],
["get-classname",">gui/editor-data-class_.html#(meth._(((lib._mred/main..rkt)._editor-data-class~25)._get-classname))",[[0,[2,"get-classname"]],[14,[" (method of ",[0,[2,"editor-data-class%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-classname",">gui/snip-class_.html#(meth._(((lib._racket/snip..rkt)._snip-class~25)._get-classname))",[[0,[2,"get-classname"]],[14,[" (method of ",[0,[2,"snip-class%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-clickable-snip",">mrlib/hierarchical-list-item___.html#(meth._(((lib._mrlib/hierlist..rkt)._hierarchical-list-item~3c~25~3e)._get-clickable-snip))",[[0,[2,"get-clickable-snip"]],[14,[" (method of ",[0,[2,"hierarchical-list-item<%>"]],")"]]],["mrlib/hierlist"]],
["get-client-handle",">gui/window___.html#(meth._(((lib._mred/main..rkt)._window~3c~25~3e)._get-client-handle))",[[0,[2,"get-client-handle"]],[14,[" (method of ",[0,[2,"window<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-client-size",">gui/window___.html#(meth._(((lib._mred/main..rkt)._window~3c~25~3e)._get-client-size))",[[0,[2,"get-client-size"]],[14,[" (method of ",[0,[2,"window<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-clipboard-bitmap",">gui/clipboard___.html#(meth._(((lib._mred/main..rkt)._clipboard~3c~25~3e)._get-clipboard-bitmap))",[[0,[2,"get-clipboard-bitmap"]],[14,[" (method of ",[0,[2,"clipboard<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-clipboard-data",">gui/clipboard___.html#(meth._(((lib._mred/main..rkt)._clipboard~3c~25~3e)._get-clipboard-data))",[[0,[2,"get-clipboard-data"]],[14,[" (method of ",[0,[2,"clipboard<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-clipboard-string",">gui/clipboard___.html#(meth._(((lib._mred/main..rkt)._clipboard~3c~25~3e)._get-clipboard-string))",[[0,[2,"get-clipboard-string"]],[14,[" (method of ",[0,[2,"clipboard<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-clipping-region",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._get-clipping-region))",[[0,[2,"get-clipping-region"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["get-collapsed?",">gui/WXME_Decoding.html#(meth._(((lib._wxme/test-case..rkt)._test-case~25)._get-collapsed~3f))",[[0,[2,"get-collapsed?"]],[14,[" (method of ",[0,[2,"test-case%"]],")"]]],["wxme/test-case"]],
["get-collects-search-dirs",">raco/dirs.html#(def._((lib._setup/dirs..rkt)._get-collects-search-dirs))",[0,[2,"get-collects-search-dirs"]],["setup/dirs"]],
["get-color",">draw/brush_.html#(meth._(((lib._racket/draw..rkt)._brush~25)._get-color))",[[0,[2,"get-color"]],[14,[" (method of ",[0,[2,"brush%"]],")"]]],["racket/draw"]],
["get-color",">draw/pen_.html#(meth._(((lib._racket/draw..rkt)._pen~25)._get-color))",[[0,[2,"get-color"]],[14,[" (method of ",[0,[2,"pen%"]],")"]]],["racket/draw"]],
["get-color",">framework/editor-snip.html#(meth._(((lib._framework/main..rkt)._editor-snip~3adecorated-mixin)._get-color))",[[0,[2,"get-color"]],[14,[" (method of ",[0,[2,"editor-snip:decorated-mixin"]],")"]]],["framework"]],
["get-color",">framework/editor-snip.html#(meth._(((lib._framework/main..rkt)._editor-snip~3adecorated~3c~25~3e)._get-color))",[[0,[2,"get-color"]],[14,[" (method of ",[0,[2,"editor-snip:decorated<%>"]],")"]]],["framework"]],
["get-color-from-user",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._get-color-from-user))",[0,[2,"get-color-from-user"]],["racket/gui/base","racket/gui"]],
["get-color-pixel",">graphics/posn.html#(def._((lib._graphics/graphics..rkt)._get-color-pixel))",[0,[2,"get-color-pixel"]],["graphics/graphics"]],
["get-column",">gui/column-control-event_.html#(meth._(((lib._mred/main..rkt)._column-control-event~25)._get-column))",[[0,[2,"get-column"]],[14,[" (method of ",[0,[2,"column-control-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-column-labels",">gui/list-box_.html#(meth._(((lib._mred/main..rkt)._list-box~25)._get-column-labels))",[[0,[2,"get-column-labels"]],[14,[" (method of ",[0,[2,"list-box%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-column-order",">gui/list-box_.html#(meth._(((lib._mred/main..rkt)._list-box~25)._get-column-order))",[[0,[2,"get-column-order"]],[14,[" (method of ",[0,[2,"list-box%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-column-width",">gui/list-box_.html#(meth._(((lib._mred/main..rkt)._list-box~25)._get-column-width))",[[0,[2,"get-column-width"]],[14,[" (method of ",[0,[2,"list-box%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-command",">draw/ps-setup_.html#(meth._(((lib._racket/draw..rkt)._ps-setup~25)._get-command))",[[0,[2,"get-command"]],[14,[" (method of ",[0,[2,"ps-setup%"]],")"]]],["racket/draw"]],
["get-comment",">gui/WXME_Decoding.html#(meth._(((lib._wxme/test-case..rkt)._test-case~25)._get-comment))",[[0,[2,"get-comment"]],[14,[" (method of ",[0,[2,"test-case%"]],")"]]],["wxme/test-case"]],
["get-comment-character",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3alanguage~3c~25~3e)._get-comment-character))",[[0,[2,"get-comment-character"]],[14,[" (method of ",[0,[2,"drracket:language:language<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-compiled-file-sha1",">raco/make.html#(def._((lib._compiler/cm..rkt)._get-compiled-file-sha1))",[0,[2,"get-compiled-file-sha1"]],["compiler/cm"]],
["get-content-buffer",">mrlib/Snips_in_a_hierarchical-list__Instance.html#(meth._(((lib._mrlib/hierlist..rkt)._hierarchical-list-snip~25)._get-content-buffer))",[[0,[2,"get-content-buffer"]],[14,[" (method of ",[0,[2,"hierarchical-list-snip%"]],")"]]],["mrlib/hierlist"]],
["get-content-port",">gui/WXME_Decoding.html#(meth._(((lib._wxme/editor..rkt)._editor~25)._get-content-port))",[[0,[2,"get-content-port"]],[14,[" (method of ",[0,[2,"editor%"]],")"]]],["wxme/editor"]],
["get-control-down",">gui/key-event_.html#(meth._(((lib._mred/main..rkt)._key-event~25)._get-control-down))",[[0,[2,"get-control-down"]],[14,[" (method of ",[0,[2,"key-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-control-down",">gui/mouse-event_.html#(meth._(((lib._mred/main..rkt)._mouse-event~25)._get-control-down))",[[0,[2,"get-control-down"]],[14,[" (method of ",[0,[2,"mouse-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-cookie",">net/cookie.html#(def._((lib._net/cookie..rkt)._get-cookie))",[0,[2,"get-cookie"]],["net/cookie"]],
["get-cookie/single",">net/cookie.html#(def._((lib._net/cookie..rkt)._get-cookie/single))",[0,[2,"get-cookie/single"]],["net/cookie"]],
["get-corner-bitmap",">framework/Comment_Box.html#(meth._(((lib._framework/main..rkt)._comment-box~3asnip~25)._get-corner-bitmap))",[[0,[2,"get-corner-bitmap"]],[14,[" (method of ",[0,[2,"comment-box:snip%"]],")"]]],["framework"]],
["get-corner-bitmap",">framework/editor-snip.html#(meth._(((lib._framework/main..rkt)._editor-snip~3adecorated-mixin)._get-corner-bitmap))",[[0,[2,"get-corner-bitmap"]],[14,[" (method of ",[0,[2,"editor-snip:decorated-mixin"]],")"]]],["framework"]],
["get-corner-bitmap",">framework/editor-snip.html#(meth._(((lib._framework/main..rkt)._editor-snip~3adecorated~3c~25~3e)._get-corner-bitmap))",[[0,[2,"get-corner-bitmap"]],[14,[" (method of ",[0,[2,"editor-snip:decorated<%>"]],")"]]],["framework"]],
["get-count",">gui/snip_.html#(meth._(((lib._racket/snip..rkt)._snip~25)._get-count))",[[0,[2,"get-count"]],[14,[" (method of ",[0,[2,"snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-coverage",">errortrace/using-errortrace.html#(def._((lib._errortrace/errortrace-lib..rkt)._get-coverage))",[0,[2,"get-coverage"]],["errortrace"]],
["get-current-tab",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aframe~3c~25~3e)._get-current-tab))",[[0,[2,"get-current-tab"]],[14,[" (method of ",[0,[2,"drracket:unit:frame<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-cursor",">gui/window___.html#(meth._(((lib._mred/main..rkt)._window~3c~25~3e)._get-cursor))",[[0,[2,"get-cursor"]],[14,[" (method of ",[0,[2,"window<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-data",">gui/clipboard-client_.html#(meth._(((lib._mred/main..rkt)._clipboard-client~25)._get-data))",[[0,[2,"get-data"]],[14,[" (method of ",[0,[2,"clipboard-client%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-data",">gui/list-box_.html#(meth._(((lib._mred/main..rkt)._list-box~25)._get-data))",[[0,[2,"get-data"]],[14,[" (method of ",[0,[2,"list-box%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-data",">gui/WXME_Decoding.html#(meth._(((lib._wxme/comment..rkt)._comment-editor~25)._get-data))",[[0,[2,"get-data"]],[14,[" (method of ",[0,[2,"comment-editor%"]],")"]]],["wxme/comment"]],
["get-data",">gui/WXME_Decoding.html#(meth._(((lib._wxme/image..rkt)._image~25)._get-data))",[[0,[2,"get-data"]],[14,[" (method of ",[0,[2,"image%"]],")"]]],["wxme/image"]],
["get-data",">gui/WXME_Decoding.html#(meth._(((lib._wxme/scheme..rkt)._racket-editor~25)._get-data))",["get-data",[14,[" (method of ",[0,[2,"racket-editor%"]],")"]]],["wxme/scheme"]],
["get-data",">gui/WXME_Decoding.html#(meth._(((lib._wxme/text..rkt)._text-editor~25)._get-data))",[[0,[2,"get-data"]],[14,[" (method of ",[0,[2,"text-editor%"]],")"]]],["wxme/text"]],
["get-data",">gui/WXME_Decoding.html#(meth._(((lib._wxme/xml..rkt)._xml-editor~25)._get-data))",[[0,[2,"get-data"]],[14,[" (method of ",[0,[2,"xml-editor%"]],")"]]],["wxme/xml"]],
["get-dataclass",">gui/editor-data_.html#(meth._(((lib._mred/main..rkt)._editor-data~25)._get-dataclass))",[[0,[2,"get-dataclass"]],[14,[" (method of ",[0,[2,"editor-data%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-datum",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_708",[0,[2,"get-datum"]],["rnrs/io/ports-6"]],
["get-dc",">draw/region_.html#(meth._(((lib._racket/draw..rkt)._region~25)._get-dc))",[[0,[2,"get-dc"]],[14,[" (method of ",[0,[2,"region%"]],")"]]],["racket/draw"]],
["get-dc",">gui/canvas___.html#(meth._(((lib._mred/main..rkt)._canvas~3c~25~3e)._get-dc))",[[0,[2,"get-dc"]],[14,[" (method of ",[0,[2,"canvas<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-dc",">gui/editor-admin_.html#(meth._(((lib._mred/main..rkt)._editor-admin~25)._get-dc))",[[0,[2,"get-dc"]],[14,[" (method of ",[0,[2,"editor-admin%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-dc",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._get-dc))",[[0,[2,"get-dc"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-dc",">gui/snip-admin_.html#(meth._(((lib._racket/snip..rkt)._snip-admin~25)._get-dc))",[[0,[2,"get-dc"]],[14,[" (method of ",[0,[2,"snip-admin%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-dc-proc",">mrlib/Cache-image_Snip.html#(meth._(((lib._mrlib/cache-image-snip..rkt)._cache-image-snip~25)._get-dc-proc))",[[0,[2,"get-dc-proc"]],[14,[" (method of ",[0,[2,"cache-image-snip%"]],")"]]],["mrlib/cache-image-snip"]],
["get-default-percentages",">framework/Panel.html#(meth._(((lib._framework/main..rkt)._panel~3adragable~3c~25~3e)._get-default-percentages))",[[0,[2,"get-default-percentages"]],[14,[" (method of ",[0,[2,"panel:dragable<%>"]],")"]]],["framework"]],
["get-default-shortcut-prefix",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._get-default-shortcut-prefix))",[0,[2,"get-default-shortcut-prefix"]],["racket/gui/base","racket/gui"]],
["get-defined",">scribble/renderer.html#(meth._(((lib._scribble/base-render..rkt)._render~25)._get-defined))",[[0,[2,"get-defined"]],[14,[" (method of ",[0,[2,"render%"]],")"]]],["scribble/base-render"]],
["get-definitions-canvas",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aframe~3c~25~3e)._get-definitions-canvas))",[[0,[2,"get-definitions-canvas"]],[14,[" (method of ",[0,[2,"drracket:unit:frame<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-definitions-text",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aframe~3c~25~3e)._get-definitions-text))",[[0,[2,"get-definitions-text"]],[14,[" (method of ",[0,[2,"drracket:unit:frame<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-definitions/interactions-panel-parent",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aframe~25)._get-definitions/interactions-panel-parent))",[[0,[2,"get-definitions/interactions-panel-parent"]],[14,[" (method of ",[0,[2,"drracket:unit:frame%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-defs",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3atab~3c~25~3e)._get-defs))",[[0,[2,"get-defs"]],[14,[" (method of ",[0,[2,"drracket:unit:tab<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-delegate",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3adelegate~3c~25~3e)._get-delegate))",[[0,[2,"get-delegate"]],[14,[" (method of ",[0,[2,"text:delegate<%>"]],")"]]],["framework"]],
["get-delegated-text",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3adelegate~3c~25~3e)._get-delegated-text))",[[0,[2,"get-delegated-text"]],[14,[" (method of ",[0,[2,"frame:delegate<%>"]],")"]]],["framework"]],
["get-delta",">gui/style___.html#(meth._(((lib._racket/snip..rkt)._style~3c~25~3e)._get-delta))",[[0,[2,"get-delta"]],[14,[" (method of ",[0,[2,"style<%>"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-dependencies",">macro-debugger/index.html#(def._((lib._macro-debugger/analysis/show-dependencies..rkt)._get-dependencies))",[0,[2,"get-dependencies"]],["macro-debugger/analysis/show-dependencies"]],
["get-depth",">draw/bitmap_.html#(meth._(((lib._racket/draw..rkt)._bitmap~25)._get-depth))",[[0,[2,"get-depth"]],[14,[" (method of ",[0,[2,"bitmap%"]],")"]]],["racket/draw"]],
["get-depth-size",">draw/gl-config_.html#(meth._(((lib._racket/draw..rkt)._gl-config~25)._get-depth-size))",[[0,[2,"get-depth-size"]],[14,[" (method of ",[0,[2,"gl-config%"]],")"]]],["racket/draw"]],
["get-descent",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._get-descent))",[[0,[2,"get-descent"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-device-scale",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._get-device-scale))",[[0,[2,"get-device-scale"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["get-direction",">gui/scroll-event_.html#(meth._(((lib._mred/main..rkt)._scroll-event~25)._get-direction))",[[0,[2,"get-direction"]],[14,[" (method of ",[0,[2,"scroll-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-directory",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._get-directory))",[0,[2,"get-directory"]],["racket/gui/base","racket/gui"]],
["get-directory",">tools/drracket_rep.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3arep~3acontext~3c~25~3e)._get-directory))",[[0,[2,"get-directory"]],[14,[" (method of ",[0,[2,"drracket:rep:context<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-directory",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3atab~3c~25~3e)._get-directory))",[[0,[2,"get-directory"]],[14,[" (method of ",[0,[2,"drracket:unit:tab<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-display-count",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._get-display-count))",[0,[2,"get-display-count"]],["racket/gui/base","racket/gui"]],
["get-display-depth",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._get-display-depth))",[0,[2,"get-display-depth"]],["racket/gui/base","racket/gui"]],
["get-display-left-top-inset",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._get-display-left-top-inset))",[0,[2,"get-display-left-top-inset"]],["racket/gui/base","racket/gui"]],
["get-display-size",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._get-display-size))",[0,[2,"get-display-size"]],["racket/gui/base","racket/gui"]],
["get-doc-search-dirs",">raco/dirs.html#(def._((lib._setup/dirs..rkt)._get-doc-search-dirs))",[0,[2,"get-doc-search-dirs"]],["setup/dirs"]],
["get-double-buffered",">draw/gl-config_.html#(meth._(((lib._racket/draw..rkt)._gl-config~25)._get-double-buffered))",[[0,[2,"get-double-buffered"]],[14,[" (method of ",[0,[2,"gl-config%"]],")"]]],["racket/draw"]],
["get-double-click-interval",">gui/keymap_.html#(meth._(((lib._mred/main..rkt)._keymap~25)._get-double-click-interval))",[[0,[2,"get-double-click-interval"]],[14,[" (method of ",[0,[2,"keymap%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-dragable",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._get-dragable))",[[0,[2,"get-dragable"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-dsn",">db/connect.html#(def._((lib._db/base..rkt)._get-dsn))",[0,[2,"get-dsn"]],["db","db/base"]],
["get-dx",">gui/WXME_Decoding.html#(meth._(((lib._wxme/image..rkt)._image~25)._get-dx))",[[0,[2,"get-dx"]],[14,[" (method of ",[0,[2,"image%"]],")"]]],["wxme/image"]],
["get-dy",">gui/WXME_Decoding.html#(meth._(((lib._wxme/image..rkt)._image~25)._get-dy))",[[0,[2,"get-dy"]],[14,[" (method of ",[0,[2,"image%"]],")"]]],["wxme/image"]],
["get-edit-menu",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._get-edit-menu))",[[0,[2,"get-edit-menu"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["get-edit-target-object",">gui/top-level-window___.html#(meth._(((lib._mred/main..rkt)._top-level-window~3c~25~3e)._get-edit-target-object))",[[0,[2,"get-edit-target-object"]],[14,[" (method of ",[0,[2,"top-level-window<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-edit-target-window",">gui/top-level-window___.html#(meth._(((lib._mred/main..rkt)._top-level-window~3c~25~3e)._get-edit-target-window))",[[0,[2,"get-edit-target-window"]],[14,[" (method of ",[0,[2,"top-level-window<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-edition-number",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3abasic~3c~25~3e)._get-edition-number))",[[0,[2,"get-edition-number"]],[14,[" (method of ",[0,[2,"text:basic<%>"]],")"]]],["framework"]],
["get-editor",">gui/editor-canvas_.html#(meth._(((lib._mred/main..rkt)._editor-canvas~25)._get-editor))",[[0,[2,"get-editor"]],[14,[" (method of ",[0,[2,"editor-canvas%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-editor",">gui/editor-snip_.html#(meth._(((lib._mred/main..rkt)._editor-snip~25)._get-editor))",[[0,[2,"get-editor"]],[14,[" (method of ",[0,[2,"editor-snip%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-editor",">gui/text-field_.html#(meth._(((lib._mred/main..rkt)._text-field~25)._get-editor))",[[0,[2,"get-editor"]],[14,[" (method of ",[0,[2,"text-field%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-editor",">gui/snip-admin_.html#(meth._(((lib._racket/snip..rkt)._snip-admin~25)._get-editor))",[[0,[2,"get-editor"]],[14,[" (method of ",[0,[2,"snip-admin%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-editor",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aframe~25)._get-editor))",[[0,[2,"get-editor"]],[14,[" (method of ",[0,[2,"drracket:unit:frame%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-editor",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3aeditor~3c~25~3e)._get-editor))",[[0,[2,"get-editor"]],[14,[" (method of ",[0,[2,"frame:editor<%>"]],")"]]],["framework"]],
["get-editor",">mrlib/hierarchical-list-item___.html#(meth._(((lib._mrlib/hierlist..rkt)._hierarchical-list-item~3c~25~3e)._get-editor))",[[0,[2,"get-editor"]],[14,[" (method of ",[0,[2,"hierarchical-list-item<%>"]],")"]]],["mrlib/hierlist"]],
["get-editor%",">browser/index.html#(meth._(((lib._browser/browser..rkt)._hyper-canvas-mixin)._get-editor~25))",[[0,[2,"get-editor%"]],[14,[" (method of ",[0,[2,"hyper-canvas-mixin"]],")"]]],["browser/browser","browser"]],
["get-editor%",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aframe~25)._get-editor~25))",[[0,[2,"get-editor%"]],[14,[" (method of ",[0,[2,"drracket:unit:frame%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-editor%",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3adelegate-mixin)._get-editor~25))",[[0,[2,"get-editor%"]],[14,[" (method of ",[0,[2,"frame:delegate-mixin"]],")"]]],["framework"]],
["get-editor%",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3aeditor~3c~25~3e)._get-editor~25))",[[0,[2,"get-editor%"]],[14,[" (method of ",[0,[2,"frame:editor<%>"]],")"]]],["framework"]],
["get-editor%",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3asearchable-text-mixin)._get-editor~25))",[[0,[2,"get-editor%"]],[14,[" (method of ",[0,[2,"frame:searchable-text-mixin"]],")"]]],["framework"]],
["get-editor-margin",">draw/ps-setup_.html#(meth._(((lib._racket/draw..rkt)._ps-setup~25)._get-editor-margin))",[[0,[2,"get-editor-margin"]],[14,[" (method of ",[0,[2,"ps-setup%"]],")"]]],["racket/draw"]],
["get-editor<%>",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3adelegate-mixin)._get-editor~3c~25~3e))",[[0,[2,"get-editor<%>"]],[14,[" (method of ",[0,[2,"frame:delegate-mixin"]],")"]]],["framework"]],
["get-editor<%>",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3aeditor~3c~25~3e)._get-editor~3c~25~3e))",[[0,[2,"get-editor<%>"]],[14,[" (method of ",[0,[2,"frame:editor<%>"]],")"]]],["framework"]],
["get-editor<%>",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3apasteboard-mixin)._get-editor~3c~25~3e))",[[0,[2,"get-editor<%>"]],[14,[" (method of ",[0,[2,"frame:pasteboard-mixin"]],")"]]],["framework"]],
["get-editor<%>",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3asearchable-text-mixin)._get-editor~3c~25~3e))",[[0,[2,"get-editor<%>"]],[14,[" (method of ",[0,[2,"frame:searchable-text-mixin"]],")"]]],["framework"]],
["get-editor<%>",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3atext-mixin)._get-editor~3c~25~3e))",[[0,[2,"get-editor<%>"]],[14,[" (method of ",[0,[2,"frame:text-mixin"]],")"]]],["framework"]],
["get-enabled",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3atab~3c~25~3e)._get-enabled))",[[0,[2,"get-enabled"]],[14,[" (method of ",[0,[2,"drracket:unit:tab<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-enabled?",">gui/WXME_Decoding.html#(meth._(((lib._wxme/test-case..rkt)._test-case~25)._get-enabled~3f))",[[0,[2,"get-enabled?"]],[14,[" (method of ",[0,[2,"test-case%"]],")"]]],["wxme/test-case"]],
["get-end-position",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._get-end-position))",[[0,[2,"get-end-position"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-entire-label",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3aeditor~3c~25~3e)._get-entire-label))",[[0,[2,"get-entire-label"]],[14,[" (method of ",[0,[2,"frame:editor<%>"]],")"]]],["framework"]],
["get-environment-variable",">srfi-std/srfi-98.html#get-environment-variable",[0,[2,"get-environment-variable"]],["srfi/98"]],
["get-environment-variables",">srfi-std/srfi-98.html#get-environment-variables",[0,[2,"get-environment-variables"]],["srfi/98"]],
["get-err-port",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3aports~3c~25~3e)._get-err-port))",[[0,[2,"get-err-port"]],[14,[" (method of ",[0,[2,"text:ports<%>"]],")"]]],["framework"]],
["get-err-style-delta",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3aports~3c~25~3e)._get-err-style-delta))",[[0,[2,"get-err-style-delta"]],[14,[" (method of ",[0,[2,"text:ports<%>"]],")"]]],["framework"]],
["get-error-box?",">gui/WXME_Decoding.html#(meth._(((lib._wxme/test-case..rkt)._test-case~25)._get-error-box~3f))",[[0,[2,"get-error-box?"]],[14,[" (method of ",[0,[2,"test-case%"]],")"]]],["wxme/test-case"]],
["get-error-message",">gui/WXME_Decoding.html#(meth._(((lib._wxme/test-case..rkt)._test-case~25)._get-error-message))",[[0,[2,"get-error-message"]],[14,[" (method of ",[0,[2,"test-case%"]],")"]]],["wxme/test-case"]],
["get-error-output",">reference/Sandboxed_Evaluation.html#(def._((lib._racket/sandbox..rkt)._get-error-output))",[0,[2,"get-error-output"]],["racket/sandbox"]],
["get-error-range",">tools/drracket_rep.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3arep~3atext~25)._get-error-range))",[[0,[2,"get-error-range"]],[14,[" (method of ",[0,[2,"drracket:rep:text%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-event-type",">gui/control-event_.html#(meth._(((lib._mred/main..rkt)._control-event~25)._get-event-type))",[[0,[2,"get-event-type"]],[14,[" (method of ",[0,[2,"control-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-event-type",">gui/mouse-event_.html#(meth._(((lib._mred/main..rkt)._mouse-event~25)._get-event-type))",[[0,[2,"get-event-type"]],[14,[" (method of ",[0,[2,"mouse-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-event-type",">gui/scroll-event_.html#(meth._(((lib._mred/main..rkt)._scroll-event~25)._get-event-type))",[[0,[2,"get-event-type"]],[14,[" (method of ",[0,[2,"scroll-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-eventspace",">gui/top-level-window___.html#(meth._(((lib._mred/main..rkt)._top-level-window~3c~25~3e)._get-eventspace))",[[0,[2,"get-eventspace"]],[14,[" (method of ",[0,[2,"top-level-window<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-exact",">gui/editor-stream-in_.html#(meth._(((lib._mred/main..rkt)._editor-stream-in~25)._get-exact))",[[0,[2,"get-exact"]],[14,[" (method of ",[0,[2,"editor-stream-in%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-execute-button",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aframe~25)._get-execute-button))",[[0,[2,"get-execute-button"]],[14,[" (method of ",[0,[2,"drracket:unit:frame%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-execute-counts",">errortrace/using-errortrace.html#(def._((lib._errortrace/errortrace-lib..rkt)._get-execute-counts))",[0,[2,"get-execute-counts"]],["errortrace"]],
["get-expected",">gui/WXME_Decoding.html#(meth._(((lib._wxme/test-case..rkt)._test-case~25)._get-expected))",[[0,[2,"get-expected"]],[14,[" (method of ",[0,[2,"test-case%"]],")"]]],["wxme/test-case"]],
["get-extend-end-position",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._get-extend-end-position))",[[0,[2,"get-extend-end-position"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-extend-start-position",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._get-extend-start-position))",[[0,[2,"get-extend-start-position"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-extent",">gui/editor-snip_.html#(meth._(((lib._mred/main..rkt)._editor-snip~25)._get-extent))",[[0,[2,"get-extent"]],[14,[" (method of ",[0,[2,"editor-snip%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-extent",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._get-extent))",[[0,[2,"get-extent"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-extent",">gui/snip_.html#(meth._(((lib._racket/snip..rkt)._snip~25)._get-extent))",[[0,[2,"get-extent"]],[14,[" (method of ",[0,[2,"snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-extent",">framework/Racket.html#(meth._(((lib._framework/main..rkt)._racket~3asexp-snip~25)._get-extent))",[[0,[2,"get-extent"]],[14,[" (method of ",[0,[2,"racket:sexp-snip%"]],")"]]],["framework"]],
["get-extent",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3a1-pixel-string-snip~25)._get-extent))",[[0,[2,"get-extent"]],[14,[" (method of ",[0,[2,"text:1-pixel-string-snip%"]],")"]]],["framework"]],
["get-extent",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3a1-pixel-tab-snip~25)._get-extent))",[[0,[2,"get-extent"]],[14,[" (method of ",[0,[2,"text:1-pixel-tab-snip%"]],")"]]],["framework"]],
["get-external",">scribble/renderer.html#(meth._(((lib._scribble/base-render..rkt)._render~25)._get-external))",[[0,[2,"get-external"]],[14,[" (method of ",[0,[2,"render%"]],")"]]],["scribble/base-render"]],
["get-face",">draw/font_.html#(meth._(((lib._racket/draw..rkt)._font~25)._get-face))",[[0,[2,"get-face"]],[14,[" (method of ",[0,[2,"font%"]],")"]]],["racket/draw"]],
["get-face",">gui/style-delta_.html#(meth._(((lib._racket/snip..rkt)._style-delta~25)._get-face))",[[0,[2,"get-face"]],[14,[" (method of ",[0,[2,"style-delta%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-face",">gui/style___.html#(meth._(((lib._racket/snip..rkt)._style~3c~25~3e)._get-face))",[[0,[2,"get-face"]],[14,[" (method of ",[0,[2,"style<%>"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-face-list",">draw/Drawing_Functions.html#(def._((lib._racket/draw..rkt)._get-face-list))",[0,[2,"get-face-list"]],["racket/draw"]],
["get-face-name",">draw/font-name-directory___.html#(meth._(((lib._racket/draw..rkt)._font-name-directory~3c~25~3e)._get-face-name))",[[0,[2,"get-face-name"]],[14,[" (method of ",[0,[2,"font-name-directory<%>"]],")"]]],["racket/draw"]],
["get-family",">draw/font_.html#(meth._(((lib._racket/draw..rkt)._font~25)._get-family))",[[0,[2,"get-family"]],[14,[" (method of ",[0,[2,"font%"]],")"]]],["racket/draw"]],
["get-family",">draw/font-name-directory___.html#(meth._(((lib._racket/draw..rkt)._font-name-directory~3c~25~3e)._get-family))",[[0,[2,"get-family"]],[14,[" (method of ",[0,[2,"font-name-directory<%>"]],")"]]],["racket/draw"]],
["get-family",">gui/style-delta_.html#(meth._(((lib._racket/snip..rkt)._style-delta~25)._get-family))",[[0,[2,"get-family"]],[14,[" (method of ",[0,[2,"style-delta%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-family",">gui/style___.html#(meth._(((lib._racket/snip..rkt)._style~3c~25~3e)._get-family))",[[0,[2,"get-family"]],[14,[" (method of ",[0,[2,"style<%>"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-family-builtin-face",">draw/Drawing_Functions.html#(def._((lib._racket/draw..rkt)._get-family-builtin-face))",[0,[2,"get-family-builtin-face"]],["racket/draw"]],
["get-ffi-obj",">foreign/Loading_Foreign_Libraries.html#(def._((lib._ffi/unsafe..rkt)._get-ffi-obj))",[0,[2,"get-ffi-obj"]],["ffi/unsafe"]],
["get-field",">reference/ivaraccess.html#(form._((lib._racket/private/class-internal..rkt)._get-field))",[0,[1,"get-field"]],["racket/class","racket"]],
["get-field-background",">gui/text-field_.html#(meth._(((lib._mred/main..rkt)._text-field~25)._get-field-background))",[[0,[2,"get-field-background"]],[14,[" (method of ",[0,[2,"text-field%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-file",">draw/ps-setup_.html#(meth._(((lib._racket/draw..rkt)._ps-setup~25)._get-file))",[[0,[2,"get-file"]],[14,[" (method of ",[0,[2,"ps-setup%"]],")"]]],["racket/draw"]],
["get-file",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._get-file))",[0,[2,"get-file"]],["racket/gui/base","racket/gui"]],
["get-file",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._get-file))",[[0,[2,"get-file"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-file",">framework/Editor.html#(meth._(((lib._framework/main..rkt)._editor~3abasic-mixin)._get-file))",[[0,[2,"get-file"]],[14,[" (method of ",[0,[2,"editor:basic-mixin"]],")"]]],["framework"]],
["get-file-format",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._get-file-format))",[[0,[2,"get-file-format"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-file-list",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._get-file-list))",[0,[2,"get-file-list"]],["racket/gui/base","racket/gui"]],
["get-file-menu",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._get-file-menu))",[[0,[2,"get-file-menu"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["get-file-sha1",">raco/make.html#(def._((lib._compiler/cm..rkt)._get-file-sha1))",[0,[2,"get-file-sha1"]],["compiler/cm"]],
["get-filename",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._get-filename))",[[0,[2,"get-filename"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-filename",">gui/image-snip_.html#(meth._(((lib._racket/snip..rkt)._image-snip~25)._get-filename))",[[0,[2,"get-filename"]],[14,[" (method of ",[0,[2,"image-snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-filename",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3abasic~3c~25~3e)._get-filename))",[[0,[2,"get-filename"]],[14,[" (method of ",[0,[2,"frame:basic<%>"]],")"]]],["framework"]],
["get-filename",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3aeditor-mixin)._get-filename))",[[0,[2,"get-filename"]],[14,[" (method of ",[0,[2,"frame:editor-mixin"]],")"]]],["framework"]],
["get-filename/untitled-name",">framework/Editor.html#(meth._(((lib._framework/main..rkt)._editor~3abasic~3c~25~3e)._get-filename/untitled-name))",[[0,[2,"get-filename/untitled-name"]],[14,[" (method of ",[0,[2,"editor:basic<%>"]],")"]]],["framework"]],
["get-filetype",">gui/image-snip_.html#(meth._(((lib._racket/snip..rkt)._image-snip~25)._get-filetype))",[[0,[2,"get-filetype"]],[14,[" (method of ",[0,[2,"image-snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-first-line-height",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3afirst-line~3c~25~3e)._get-first-line-height))",[[0,[2,"get-first-line-height"]],[14,[" (method of ",[0,[2,"text:first-line<%>"]],")"]]],["framework"]],
["get-first-place",">reference/distributed-places.html#(meth._(((lib._racket/place/distributed..rkt)._remote-node~25)._get-first-place))",[[0,[2,"get-first-place"]],[14,[" (method of ",[0,[2,"remote-node%"]],")"]]],["racket/place/distributed"]],
["get-first-place-channel",">reference/distributed-places.html#(meth._(((lib._racket/place/distributed..rkt)._remote-node~25)._get-first-place-channel))",[[0,[2,"get-first-place-channel"]],[14,[" (method of ",[0,[2,"remote-node%"]],")"]]],["racket/place/distributed"]],
["get-first-visible-item",">gui/list-box_.html#(meth._(((lib._mred/main..rkt)._list-box~25)._get-first-visible-item))",[[0,[2,"get-first-visible-item"]],[14,[" (method of ",[0,[2,"list-box%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-fixed",">gui/editor-stream-in_.html#(meth._(((lib._mred/main..rkt)._editor-stream-in~25)._get-fixed))",[[0,[2,"get-fixed"]],[14,[" (method of ",[0,[2,"editor-stream-in%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-fixed-exact",">gui/editor-stream-in_.html#(meth._(((lib._mred/main..rkt)._editor-stream-in~25)._get-fixed-exact))",[[0,[2,"get-fixed-exact"]],[14,[" (method of ",[0,[2,"editor-stream-in%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-fixed-style",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3abasic~3c~25~3e)._get-fixed-style))",[[0,[2,"get-fixed-style"]],[14,[" (method of ",[0,[2,"text:basic<%>"]],")"]]],["framework"]],
["get-fixed-style",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3aforeground-color-mixin)._get-fixed-style))",[[0,[2,"get-fixed-style"]],[14,[" (method of ",[0,[2,"text:foreground-color-mixin"]],")"]]],["framework"]],
["get-flags",">gui/snip_.html#(meth._(((lib._racket/snip..rkt)._snip~25)._get-flags))",[[0,[2,"get-flags"]],[14,[" (method of ",[0,[2,"snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-flattened-text",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._get-flattened-text))",[[0,[2,"get-flattened-text"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-focus-object",">gui/top-level-window___.html#(meth._(((lib._mred/main..rkt)._top-level-window~3c~25~3e)._get-focus-object))",[[0,[2,"get-focus-object"]],[14,[" (method of ",[0,[2,"top-level-window<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-focus-snip",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._get-focus-snip))",[[0,[2,"get-focus-snip"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-focus-window",">gui/top-level-window___.html#(meth._(((lib._mred/main..rkt)._top-level-window~3c~25~3e)._get-focus-window))",[[0,[2,"get-focus-window"]],[14,[" (method of ",[0,[2,"top-level-window<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-font",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._get-font))",[[0,[2,"get-font"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["get-font",">gui/popup-menu_.html#(meth._(((lib._mred/main..rkt)._popup-menu~25)._get-font))",[[0,[2,"get-font"]],[14,[" (method of ",[0,[2,"popup-menu%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-font",">gui/style___.html#(meth._(((lib._racket/snip..rkt)._style~3c~25~3e)._get-font))",[[0,[2,"get-font"]],[14,[" (method of ",[0,[2,"style<%>"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-font-from-user",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._get-font-from-user))",[0,[2,"get-font-from-user"]],["racket/gui/base","racket/gui"]],
["get-font-id",">draw/font_.html#(meth._(((lib._racket/draw..rkt)._font~25)._get-font-id))",[[0,[2,"get-font-id"]],[14,[" (method of ",[0,[2,"font%"]],")"]]],["racket/draw"]],
["get-font-id",">draw/font-name-directory___.html#(meth._(((lib._racket/draw..rkt)._font-name-directory~3c~25~3e)._get-font-id))",[[0,[2,"get-font-id"]],[14,[" (method of ",[0,[2,"font-name-directory<%>"]],")"]]],["racket/draw"]],
["get-foreground",">gui/style___.html#(meth._(((lib._racket/snip..rkt)._style~3c~25~3e)._get-foreground))",[[0,[2,"get-foreground"]],[14,[" (method of ",[0,[2,"style<%>"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-foreground-add",">gui/style-delta_.html#(meth._(((lib._racket/snip..rkt)._style-delta~25)._get-foreground-add))",[[0,[2,"get-foreground-add"]],[14,[" (method of ",[0,[2,"style-delta%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-foreground-mult",">gui/style-delta_.html#(meth._(((lib._racket/snip..rkt)._style-delta~25)._get-foreground-mult))",[[0,[2,"get-foreground-mult"]],[14,[" (method of ",[0,[2,"style-delta%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-forward-sexp",">framework/Racket.html#(meth._(((lib._framework/main..rkt)._racket~3atext~3c~25~3e)._get-forward-sexp))",[[0,[2,"get-forward-sexp"]],[14,[" (method of ",[0,[2,"racket:text<%>"]],")"]]],["framework"]],
["get-frame",">gui/menu-bar_.html#(meth._(((lib._mred/main..rkt)._menu-bar~25)._get-frame))",[[0,[2,"get-frame"]],[14,[" (method of ",[0,[2,"menu-bar%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-frame",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3atab~3c~25~3e)._get-frame))",[[0,[2,"get-frame"]],[14,[" (method of ",[0,[2,"drracket:unit:tab<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-frames",">framework/Group.html#(meth._(((lib._framework/main..rkt)._group~3a~25)._get-frames))",[[0,[2,"get-frames"]],[14,[" (method of ",[0,[2,"group:%"]],")"]]],["framework"]],
["get-g",">gui/add-color___.html#(meth._(((lib._racket/snip..rkt)._add-color~3c~25~3e)._get-g))",[[0,[2,"get-g"]],[14,[" (method of ",[0,[2,"add-color<%>"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-g",">gui/mult-color___.html#(meth._(((lib._racket/snip..rkt)._mult-color~3c~25~3e)._get-g))",[[0,[2,"get-g"]],[14,[" (method of ",[0,[2,"mult-color<%>"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-gl-context",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._get-gl-context))",[[0,[2,"get-gl-context"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["get-gradient",">draw/brush_.html#(meth._(((lib._racket/draw..rkt)._brush~25)._get-gradient))",[[0,[2,"get-gradient"]],[14,[" (method of ",[0,[2,"brush%"]],")"]]],["racket/draw"]],
["get-graphical-min-size",">gui/area___.html#(meth._(((lib._mred/main..rkt)._area~3c~25~3e)._get-graphical-min-size))",[[0,[2,"get-graphical-min-size"]],[14,[" (method of ",[0,[2,"area<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-h",">gui/WXME_Decoding.html#(meth._(((lib._wxme/image..rkt)._image~25)._get-h))",[[0,[2,"get-h"]],[14,[" (method of ",[0,[2,"image%"]],")"]]],["wxme/image"]],
["get-handle",">draw/bitmap_.html#(meth._(((lib._racket/draw..rkt)._bitmap~25)._get-handle))",[[0,[2,"get-handle"]],[14,[" (method of ",[0,[2,"bitmap%"]],")"]]],["racket/draw"]],
["get-handle",">draw/brush_.html#(meth._(((lib._racket/draw..rkt)._brush~25)._get-handle))",[[0,[2,"get-handle"]],[14,[" (method of ",[0,[2,"brush%"]],")"]]],["racket/draw"]],
["get-handle",">gui/window___.html#(meth._(((lib._mred/main..rkt)._window~3c~25~3e)._get-handle))",[[0,[2,"get-handle"]],[14,[" (method of ",[0,[2,"window<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-hard-linked-packages",">planet/Utility_Libraries.html#(def._((lib._planet/planet-archives..rkt)._get-hard-linked-packages))",[0,[2,"get-hard-linked-packages"]],["planet/planet-archives"]],
["get-heads-up",">gl-board-game/index.html#(meth._(((lib._games/gl-board-game..rkt)._gl-board~25)._get-heads-up))",[[0,[2,"get-heads-up"]],[14,[" (method of ",[0,[2,"gl-board%"]],")"]]],["games/gl-board-game"]],
["get-height",">draw/bitmap_.html#(meth._(((lib._racket/draw..rkt)._bitmap~25)._get-height))",[[0,[2,"get-height"]],[14,[" (method of ",[0,[2,"bitmap%"]],")"]]],["racket/draw"]],
["get-height",">gui/window___.html#(meth._(((lib._mred/main..rkt)._window~3c~25~3e)._get-height))",[[0,[2,"get-height"]],[14,[" (method of ",[0,[2,"window<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-height",">gui/WXME_Decoding.html#(meth._(((lib._wxme/cache-image..rkt)._cache-image~25)._get-height))",[[0,[2,"get-height"]],[14,[" (method of ",[0,[2,"cache-image%"]],")"]]],["wxme/cache-image"]],
["get-help-menu",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._get-help-menu))",[[0,[2,"get-help-menu"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["get-help-string",">gui/labelled-menu-item___.html#(meth._(((lib._mred/main..rkt)._labelled-menu-item~3c~25~3e)._get-help-string))",[[0,[2,"get-help-string"]],[14,[" (method of ",[0,[2,"labelled-menu-item<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-highlight-background-color",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._get-highlight-background-color))",[0,[2,"get-highlight-background-color"]],["racket/gui/base","racket/gui"]],
["get-highlight-text-color",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._get-highlight-text-color))",[0,[2,"get-highlight-text-color"]],["racket/gui/base","racket/gui"]],
["get-highlighted-ranges",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3abasic~3c~25~3e)._get-highlighted-ranges))",[[0,[2,"get-highlighted-ranges"]],[14,[" (method of ",[0,[2,"text:basic<%>"]],")"]]],["framework"]],
["get-hinting",">draw/font_.html#(meth._(((lib._racket/draw..rkt)._font~25)._get-hinting))",[[0,[2,"get-hinting"]],[14,[" (method of ",[0,[2,"font%"]],")"]]],["racket/draw"]],
["get-hyper-keymap",">browser/index.html#(meth._(((lib._browser/browser..rkt)._hyper-text-mixin)._get-hyper-keymap))",[[0,[2,"get-hyper-keymap"]],[14,[" (method of ",[0,[2,"hyper-text-mixin"]],")"]]],["browser/browser","browser"]],
["get-hyper-panel",">browser/index.html#(meth._(((lib._browser/browser..rkt)._hyper-frame~3c~25~3e)._get-hyper-panel))",[[0,[2,"get-hyper-panel"]],[14,[" (method of ",[0,[2,"hyper-frame<%>"]],")"]]],["browser/browser","browser"]],
["get-hyper-panel%",">browser/index.html#(meth._(((lib._browser/browser..rkt)._hyper-frame~3c~25~3e)._get-hyper-panel~25))",[[0,[2,"get-hyper-panel%"]],[14,[" (method of ",[0,[2,"hyper-frame<%>"]],")"]]],["browser/browser","browser"]],
["get-impure-port",">net/url.html#(def._((lib._net/url..rkt)._get-impure-port))",[0,[2,"get-impure-port"]],["net/url"]],
["get-in-box-port",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3aports~3c~25~3e)._get-in-box-port))",[[0,[2,"get-in-box-port"]],[14,[" (method of ",[0,[2,"text:ports<%>"]],")"]]],["framework"]],
["get-in-port",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3aports~3c~25~3e)._get-in-port))",[[0,[2,"get-in-port"]],[14,[" (method of ",[0,[2,"text:ports<%>"]],")"]]],["framework"]],
["get-inactive-caret-threshold",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._get-inactive-caret-threshold))",[[0,[2,"get-inactive-caret-threshold"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-include-search-dirs",">raco/dirs.html#(def._((lib._setup/dirs..rkt)._get-include-search-dirs))",[0,[2,"get-include-search-dirs"]],["setup/dirs"]],
["get-inexact",">gui/editor-stream-in_.html#(meth._(((lib._mred/main..rkt)._editor-stream-in~25)._get-inexact))",[[0,[2,"get-inexact"]],[14,[" (method of ",[0,[2,"editor-stream-in%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-info",">raco/getinfo.html#(def._((lib._setup/getinfo..rkt)._get-info))",[0,[2,"get-info"]],["setup/getinfo"]],
["get-info-canvas",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3ainfo~3c~25~3e)._get-info-canvas))",[[0,[2,"get-info-canvas"]],[14,[" (method of ",[0,[2,"frame:info<%>"]],")"]]],["framework"]],
["get-info-editor",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3ainfo~3c~25~3e)._get-info-editor))",[[0,[2,"get-info-editor"]],[14,[" (method of ",[0,[2,"frame:info<%>"]],")"]]],["framework"]],
["get-info-panel",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3ainfo~3c~25~3e)._get-info-panel))",[[0,[2,"get-info-panel"]],[14,[" (method of ",[0,[2,"frame:info<%>"]],")"]]],["framework"]],
["get-info/full",">raco/getinfo.html#(def._((lib._setup/getinfo..rkt)._get-info/full))",[0,[2,"get-info/full"]],["setup/getinfo"]],
["get-init-code",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3amodule-based-language~3c~25~3e)._get-init-code))",[[0,[2,"get-init-code"]],[14,[" (method of ",[0,[2,"drracket:language:module-based-language<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-init-code",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3asimple-module-based-language-~3emodule-based-language-mixin)._get-init-code))",[[0,[2,"get-init-code"]],[14,[" (method of ",[0,[2,"drracket:language:simple-module-based-language->module-based-language-mixin"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-initial-matrix",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._get-initial-matrix))",[[0,[2,"get-initial-matrix"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["get-insert-menu",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aframe~3c~25~3e)._get-insert-menu))",[[0,[2,"get-insert-menu"]],[14,[" (method of ",[0,[2,"drracket:unit:frame<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-insertion-point",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3aports~3c~25~3e)._get-insertion-point))",[[0,[2,"get-insertion-point"]],[14,[" (method of ",[0,[2,"text:ports<%>"]],")"]]],["framework"]],
["get-inset",">gui/editor-snip_.html#(meth._(((lib._mred/main..rkt)._editor-snip~25)._get-inset))",[[0,[2,"get-inset"]],[14,[" (method of ",[0,[2,"editor-snip%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-installed-planet-archives",">planet/Utility_Libraries.html#(def._((lib._planet/planet-archives..rkt)._get-installed-planet-archives))",[0,[2,"get-installed-planet-archives"]],["planet/planet-archives"]],
["get-integer",">mzlib/mzlib_integer-set.html#(def._((lib._mzlib/integer-set..rkt)._get-integer))",[0,[2,"get-integer"]],["mzlib/integer-set"]],
["get-interactions-canvas",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aframe~3c~25~3e)._get-interactions-canvas))",[[0,[2,"get-interactions-canvas"]],[14,[" (method of ",[0,[2,"drracket:unit:frame<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-interactions-text",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aframe~3c~25~3e)._get-interactions-text))",[[0,[2,"get-interactions-text"]],[14,[" (method of ",[0,[2,"drracket:unit:frame<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-ints",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3atab~3c~25~3e)._get-ints))",[[0,[2,"get-ints"]],[14,[" (method of ",[0,[2,"drracket:unit:tab<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-item",">mrlib/Snips_in_a_hierarchical-list__Instance.html#(meth._(((lib._mrlib/hierlist..rkt)._hierarchical-item-snip~25)._get-item))",[[0,[2,"get-item"]],[14,[" (method of ",[0,[2,"hierarchical-item-snip%"]],")"]]],["mrlib/hierlist"]],
["get-item",">mrlib/Snips_in_a_hierarchical-list__Instance.html#(meth._(((lib._mrlib/hierlist..rkt)._hierarchical-list-snip~25)._get-item))",[[0,[2,"get-item"]],[14,[" (method of ",[0,[2,"hierarchical-list-snip%"]],")"]]],["mrlib/hierlist"]],
["get-item-label",">gui/radio-box_.html#(meth._(((lib._mred/main..rkt)._radio-box~25)._get-item-label))",[[0,[2,"get-item-label"]],[14,[" (method of ",[0,[2,"radio-box%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-item-label",">gui/tab-panel_.html#(meth._(((lib._mred/main..rkt)._tab-panel~25)._get-item-label))",[[0,[2,"get-item-label"]],[14,[" (method of ",[0,[2,"tab-panel%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-item-plain-label",">gui/radio-box_.html#(meth._(((lib._mred/main..rkt)._radio-box~25)._get-item-plain-label))",[[0,[2,"get-item-plain-label"]],[14,[" (method of ",[0,[2,"radio-box%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-items",">gui/menu-item-container___.html#(meth._(((lib._mred/main..rkt)._menu-item-container~3c~25~3e)._get-items))",[[0,[2,"get-items"]],[14,[" (method of ",[0,[2,"menu-item-container<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-items",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..rkt)._hierarchical-list~25)._get-items))",[[0,[2,"get-items"]],[14,[" (method of ",[0,[2,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["get-items",">mrlib/hierarchical-list-compound-item___.html#(meth._(((lib._mrlib/hierlist..rkt)._hierarchical-list-compound-item~3c~25~3e)._get-items))",[[0,[2,"get-items"]],[14,[" (method of ",[0,[2,"hierarchical-list-compound-item<%>"]],")"]]],["mrlib/hierlist"]],
["get-ivar",">foreign/Objective-C_FFI.html#(form._((lib._ffi/unsafe/objc..rkt)._get-ivar))",[0,[1,"get-ivar"]],["ffi/unsafe/objc"]],
["get-join",">draw/pen_.html#(meth._(((lib._racket/draw..rkt)._pen~25)._get-join))",[[0,[2,"get-join"]],[14,[" (method of ",[0,[2,"pen%"]],")"]]],["racket/draw"]],
["get-key",">browser/index.html#(meth._(((lib._browser/browser..rkt)._image-map-snip~25)._get-key))",[[0,[2,"get-key"]],[14,[" (method of ",[0,[2,"image-map-snip%"]],")"]]],["browser/browser","browser"]],
["get-key-code",">gui/key-event_.html#(meth._(((lib._mred/main..rkt)._key-event~25)._get-key-code))",[[0,[2,"get-key-code"]],[14,[" (method of ",[0,[2,"key-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-key-event",">teachpack/draw.html#(def._((lib._htdp/big-draw..rkt)._get-key-event))",[0,[2,"get-key-event"]],["htdp/draw"]],
["get-key-press",">graphics/Keyboard_Operations.html#(def._((lib._graphics/graphics..rkt)._get-key-press))",[0,[2,"get-key-press"]],["graphics/graphics"]],
["get-key-release-code",">gui/key-event_.html#(meth._(((lib._mred/main..rkt)._key-event~25)._get-key-release-code))",[[0,[2,"get-key-release-code"]],[14,[" (method of ",[0,[2,"key-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-keymap",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._get-keymap))",[[0,[2,"get-keymap"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-keymaps",">tools/drracket_rep.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3arep~3adrs-bindings-keymap-mixin)._get-keymaps))",[[0,[2,"get-keymaps"]],[14,[" (method of ",[0,[2,"drracket:rep:drs-bindings-keymap-mixin"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-keymaps",">framework/Editor.html#(meth._(((lib._framework/main..rkt)._editor~3afile-mixin)._get-keymaps))",[[0,[2,"get-keymaps"]],[14,[" (method of ",[0,[2,"editor:file-mixin"]],")"]]],["framework"]],
["get-keymaps",">framework/Editor.html#(meth._(((lib._framework/main..rkt)._editor~3akeymap~3c~25~3e)._get-keymaps))",[[0,[2,"get-keymaps"]],[14,[" (method of ",[0,[2,"editor:keymap<%>"]],")"]]],["framework"]],
["get-keymaps",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3asearching-mixin)._get-keymaps))",[[0,[2,"get-keymaps"]],[14,[" (method of ",[0,[2,"text:searching-mixin"]],")"]]],["framework"]],
["get-label",">gui/labelled-menu-item___.html#(meth._(((lib._mred/main..rkt)._labelled-menu-item~3c~25~3e)._get-label))",[[0,[2,"get-label"]],[14,[" (method of ",[0,[2,"labelled-menu-item<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-label",">gui/window___.html#(meth._(((lib._mred/main..rkt)._window~3c~25~3e)._get-label))",[[0,[2,"get-label"]],[14,[" (method of ",[0,[2,"window<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-label",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3aeditor-mixin)._get-label))",[[0,[2,"get-label"]],[14,[" (method of ",[0,[2,"frame:editor-mixin"]],")"]]],["framework"]],
["get-label-font",">gui/list-box_.html#(meth._(((lib._mred/main..rkt)._list-box~25)._get-label-font))",[[0,[2,"get-label-font"]],[14,[" (method of ",[0,[2,"list-box%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-label-prefix",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3aeditor~3c~25~3e)._get-label-prefix))",[[0,[2,"get-label-prefix"]],[14,[" (method of ",[0,[2,"frame:editor<%>"]],")"]]],["framework"]],
["get-language-menu",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aframe~3c~25~3e)._get-language-menu))",[[0,[2,"get-language-menu"]],[14,[" (method of ",[0,[2,"drracket:unit:frame<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-language-name",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3alanguage~3c~25~3e)._get-language-name))",[[0,[2,"get-language-name"]],[14,[" (method of ",[0,[2,"drracket:language:language<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-language-name",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3amodule-based-language-~3elanguage-mixin)._get-language-name))",[[0,[2,"get-language-name"]],[14,[" (method of ",[0,[2,"drracket:language:module-based-language->language-mixin"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-language-numbers",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3alanguage~3c~25~3e)._get-language-numbers))",[[0,[2,"get-language-numbers"]],[14,[" (method of ",[0,[2,"drracket:language:language<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-language-numbers",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3amodule-based-language~3c~25~3e)._get-language-numbers))",[[0,[2,"get-language-numbers"]],[14,[" (method of ",[0,[2,"drracket:language:module-based-language<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-language-numbers",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3asimple-module-based-language~25)._get-language-numbers))",[[0,[2,"get-language-numbers"]],[14,[" (method of ",[0,[2,"drracket:language:simple-module-based-language%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-language-numbers",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3asimple-module-based-language~3c~25~3e)._get-language-numbers))",[[0,[2,"get-language-numbers"]],[14,[" (method of ",[0,[2,"drracket:language:simple-module-based-language<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-language-position",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3alanguage~3c~25~3e)._get-language-position))",[[0,[2,"get-language-position"]],[14,[" (method of ",[0,[2,"drracket:language:language<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-language-position",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3amodule-based-language~3c~25~3e)._get-language-position))",[[0,[2,"get-language-position"]],[14,[" (method of ",[0,[2,"drracket:language:module-based-language<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-language-position",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3asimple-module-based-language~25)._get-language-position))",[[0,[2,"get-language-position"]],[14,[" (method of ",[0,[2,"drracket:language:simple-module-based-language%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-language-position",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3asimple-module-based-language~3c~25~3e)._get-language-position))",[[0,[2,"get-language-position"]],[14,[" (method of ",[0,[2,"drracket:language:simple-module-based-language<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-language-url",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3alanguage~3c~25~3e)._get-language-url))",[[0,[2,"get-language-url"]],[14,[" (method of ",[0,[2,"drracket:language:language<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-left-down",">gui/mouse-event_.html#(meth._(((lib._mred/main..rkt)._mouse-event~25)._get-left-down))",[[0,[2,"get-left-down"]],[14,[" (method of ",[0,[2,"mouse-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-level-2",">draw/ps-setup_.html#(meth._(((lib._racket/draw..rkt)._ps-setup~25)._get-level-2))",[[0,[2,"get-level-2"]],[14,[" (method of ",[0,[2,"ps-setup%"]],")"]]],["racket/draw"]],
["get-lib-search-dirs",">raco/dirs.html#(def._((lib._setup/dirs..rkt)._get-lib-search-dirs))",[0,[2,"get-lib-search-dirs"]],["setup/dirs"]],
["get-limit",">framework/Racket.html#(meth._(((lib._framework/main..rkt)._racket~3atext~3c~25~3e)._get-limit))",[[0,[2,"get-limit"]],[14,[" (method of ",[0,[2,"racket:text<%>"]],")"]]],["framework"]],
["get-line",">draw/linear-gradient_.html#(meth._(((lib._racket/draw..rkt)._linear-gradient~25)._get-line))",[[0,[2,"get-line"]],[14,[" (method of ",[0,[2,"linear-gradient%"]],")"]]],["racket/draw"]],
["get-line",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_706",[0,[2,"get-line"]],["rnrs/io/ports-6"]],
["get-line-count",">gui/editor-canvas_.html#(meth._(((lib._mred/main..rkt)._editor-canvas~25)._get-line-count))",[[0,[2,"get-line-count"]],[14,[" (method of ",[0,[2,"editor-canvas%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-line-spacing",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._get-line-spacing))",[[0,[2,"get-line-spacing"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-line-spacing",">gui/snip-admin_.html#(meth._(((lib._racket/snip..rkt)._snip-admin~25)._get-line-spacing))",[[0,[2,"get-line-spacing"]],[14,[" (method of ",[0,[2,"snip-admin%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-load-overwrites-styles",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._get-load-overwrites-styles))",[[0,[2,"get-load-overwrites-styles"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-loaded-mask",">draw/bitmap_.html#(meth._(((lib._racket/draw..rkt)._bitmap~25)._get-loaded-mask))",[[0,[2,"get-loaded-mask"]],[14,[" (method of ",[0,[2,"bitmap%"]],")"]]],["racket/draw"]],
["get-log-prefix",">reference/distributed-places.html#(meth._(((lib._racket/place/distributed..rkt)._remote-node~25)._get-log-prefix))",[[0,[2,"get-log-prefix"]],[14,[" (method of ",[0,[2,"remote-node%"]],")"]]],["racket/place/distributed"]],
["get-mailbox-status",">net/pop3.html#(def._((lib._net/pop3..rkt)._get-mailbox-status))",[0,[2,"get-mailbox-status"]],["net/pop3"]],
["get-map",">gui/editor-wordbreak-map_.html#(meth._(((lib._mred/main..rkt)._editor-wordbreak-map~25)._get-map))",[[0,[2,"get-map"]],[14,[" (method of ",[0,[2,"editor-wordbreak-map%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-map-function-table",">framework/Keymap.html#(meth._(((lib._framework/main..rkt)._keymap~3aaug-keymap~3c~25~3e)._get-map-function-table))",[[0,[2,"get-map-function-table"]],[14,[" (method of ",[0,[2,"keymap:aug-keymap<%>"]],")"]]],["framework"]],
["get-map-function-table/ht",">framework/Keymap.html#(meth._(((lib._framework/main..rkt)._keymap~3aaug-keymap~3c~25~3e)._get-map-function-table/ht))",[[0,[2,"get-map-function-table/ht"]],[14,[" (method of ",[0,[2,"keymap:aug-keymap<%>"]],")"]]],["framework"]],
["get-margin",">draw/ps-setup_.html#(meth._(((lib._racket/draw..rkt)._ps-setup~25)._get-margin))",[[0,[2,"get-margin"]],[14,[" (method of ",[0,[2,"ps-setup%"]],")"]]],["racket/draw"]],
["get-margin",">gui/editor-snip_.html#(meth._(((lib._mred/main..rkt)._editor-snip~25)._get-margin))",[[0,[2,"get-margin"]],[14,[" (method of ",[0,[2,"editor-snip%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-max-height",">gui/editor-snip_.html#(meth._(((lib._mred/main..rkt)._editor-snip~25)._get-max-height))",[[0,[2,"get-max-height"]],[14,[" (method of ",[0,[2,"editor-snip%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-max-height",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._get-max-height))",[[0,[2,"get-max-height"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-max-undo-history",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._get-max-undo-history))",[[0,[2,"get-max-undo-history"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-max-view",">gui/editor-admin_.html#(meth._(((lib._mred/main..rkt)._editor-admin~25)._get-max-view))",[[0,[2,"get-max-view"]],[14,[" (method of ",[0,[2,"editor-admin%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-max-view-size",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._get-max-view-size))",[[0,[2,"get-max-view-size"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-max-width",">gui/editor-snip_.html#(meth._(((lib._mred/main..rkt)._editor-snip~25)._get-max-width))",[[0,[2,"get-max-width"]],[14,[" (method of ",[0,[2,"editor-snip%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-max-width",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._get-max-width))",[[0,[2,"get-max-width"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-mdi-parent",">framework/Group.html#(meth._(((lib._framework/main..rkt)._group~3a~25)._get-mdi-parent))",[[0,[2,"get-mdi-parent"]],[14,[" (method of ",[0,[2,"group:%"]],")"]]],["framework"]],
["get-menu",">gui/combo-field_.html#(meth._(((lib._mred/main..rkt)._combo-field~25)._get-menu))",[[0,[2,"get-menu"]],[14,[" (method of ",[0,[2,"combo-field%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-menu",">framework/Comment_Box.html#(meth._(((lib._framework/main..rkt)._comment-box~3asnip~25)._get-menu))",[[0,[2,"get-menu"]],[14,[" (method of ",[0,[2,"comment-box:snip%"]],")"]]],["framework"]],
["get-menu",">framework/editor-snip.html#(meth._(((lib._framework/main..rkt)._editor-snip~3adecorated-mixin)._get-menu))",[[0,[2,"get-menu"]],[14,[" (method of ",[0,[2,"editor-snip:decorated-mixin"]],")"]]],["framework"]],
["get-menu",">framework/editor-snip.html#(meth._(((lib._framework/main..rkt)._editor-snip~3adecorated~3c~25~3e)._get-menu))",[[0,[2,"get-menu"]],[14,[" (method of ",[0,[2,"editor-snip:decorated<%>"]],")"]]],["framework"]],
["get-menu%",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._get-menu~25))",[[0,[2,"get-menu%"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["get-menu-bar",">gui/frame_.html#(meth._(((lib._mred/main..rkt)._frame~25)._get-menu-bar))",[[0,[2,"get-menu-bar"]],[14,[" (method of ",[0,[2,"frame%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-menu-bar%",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3abasic~3c~25~3e)._get-menu-bar~25))",[[0,[2,"get-menu-bar%"]],[14,[" (method of ",[0,[2,"frame:basic<%>"]],")"]]],["framework"]],
["get-menu-item%",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._get-menu-item~25))",[[0,[2,"get-menu-item%"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["get-message/body",">net/pop3.html#(def._((lib._net/pop3..rkt)._get-message/body))",[0,[2,"get-message/body"]],["net/pop3"]],
["get-message/complete",">net/pop3.html#(def._((lib._net/pop3..rkt)._get-message/complete))",[0,[2,"get-message/complete"]],["net/pop3"]],
["get-message/headers",">net/pop3.html#(def._((lib._net/pop3..rkt)._get-message/headers))",[0,[2,"get-message/headers"]],["net/pop3"]],
["get-meta-down",">gui/key-event_.html#(meth._(((lib._mred/main..rkt)._key-event~25)._get-meta-down))",[[0,[2,"get-meta-down"]],[14,[" (method of ",[0,[2,"key-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-meta-down",">gui/mouse-event_.html#(meth._(((lib._mred/main..rkt)._mouse-event~25)._get-meta-down))",[[0,[2,"get-meta-down"]],[14,[" (method of ",[0,[2,"mouse-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-metadata",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3alanguage~3c~25~3e)._get-metadata))",[[0,[2,"get-metadata"]],[14,[" (method of ",[0,[2,"drracket:language:language<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-metadata-lines",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3alanguage~3c~25~3e)._get-metadata-lines))",[[0,[2,"get-metadata-lines"]],[14,[" (method of ",[0,[2,"drracket:language:language<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-middle-down",">gui/mouse-event_.html#(meth._(((lib._mred/main..rkt)._mouse-event~25)._get-middle-down))",[[0,[2,"get-middle-down"]],[14,[" (method of ",[0,[2,"mouse-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-min-height",">gui/editor-snip_.html#(meth._(((lib._mred/main..rkt)._editor-snip~25)._get-min-height))",[[0,[2,"get-min-height"]],[14,[" (method of ",[0,[2,"editor-snip%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-min-height",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._get-min-height))",[[0,[2,"get-min-height"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-min-height",">embedded-gui/alignment___.html#(meth._(((lib._embedded-gui/main..rkt)._alignment~3c~25~3e)._get-min-height))",[[0,[2,"get-min-height"]],[14,[" (method of ",[0,[2,"alignment<%>"]],")"]]],["embedded-gui"]],
["get-min-width",">gui/editor-snip_.html#(meth._(((lib._mred/main..rkt)._editor-snip~25)._get-min-width))",[[0,[2,"get-min-width"]],[14,[" (method of ",[0,[2,"editor-snip%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-min-width",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._get-min-width))",[[0,[2,"get-min-width"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-min-width",">embedded-gui/alignment___.html#(meth._(((lib._embedded-gui/main..rkt)._alignment~3c~25~3e)._get-min-width))",[[0,[2,"get-min-width"]],[14,[" (method of ",[0,[2,"alignment<%>"]],")"]]],["embedded-gui"]],
["get-mode",">draw/ps-setup_.html#(meth._(((lib._racket/draw..rkt)._ps-setup~25)._get-mode))",[[0,[2,"get-mode"]],[14,[" (method of ",[0,[2,"ps-setup%"]],")"]]],["racket/draw"]],
["get-module",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3amodule-based-language~3c~25~3e)._get-module))",[[0,[2,"get-module"]],[14,[" (method of ",[0,[2,"drracket:language:module-based-language<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-module",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3asimple-module-based-language~25)._get-module))",[[0,[2,"get-module"]],[14,[" (method of ",[0,[2,"drracket:language:simple-module-based-language%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-module",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3asimple-module-based-language~3c~25~3e)._get-module))",[[0,[2,"get-module"]],[14,[" (method of ",[0,[2,"drracket:language:simple-module-based-language<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-module-code",">syntax/module-helpers.html#(def._((lib._syntax/modcode..rkt)._get-module-code))",[0,[2,"get-module-code"]],["syntax/modcode"]],
["get-mouse-click",">graphics/Mouse_Operations.html#(def._((lib._graphics/graphics..rkt)._get-mouse-click))",[0,[2,"get-mouse-click"]],["graphics/graphics"]],
["get-multisample-size",">draw/gl-config_.html#(meth._(((lib._racket/draw..rkt)._gl-config~25)._get-multisample-size))",[[0,[2,"get-multisample-size"]],[14,[" (method of ",[0,[2,"gl-config%"]],")"]]],["racket/draw"]],
["get-name",">gui/style___.html#(meth._(((lib._racket/snip..rkt)._style~3c~25~3e)._get-name))",[[0,[2,"get-name"]],[14,[" (method of ",[0,[2,"style<%>"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-names",">draw/color-database___.html#(meth._(((lib._racket/draw..rkt)._color-database~3c~25~3e)._get-names))",[[0,[2,"get-names"]],[14,[" (method of ",[0,[2,"color-database<%>"]],")"]]],["racket/draw"]],
["get-next",">gui/editor-data_.html#(meth._(((lib._mred/main..rkt)._editor-data~25)._get-next))",[[0,[2,"get-next"]],[14,[" (method of ",[0,[2,"editor-data%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-next-settings",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3adefinitions-text~3c~25~3e)._get-next-settings))",[[0,[2,"get-next-settings"]],[14,[" (method of ",[0,[2,"drracket:unit:definitions-text<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-num-scroll-steps",">gui/snip_.html#(meth._(((lib._racket/snip..rkt)._snip~25)._get-num-scroll-steps))",[[0,[2,"get-num-scroll-steps"]],[14,[" (method of ",[0,[2,"snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-number",">gui/list-control___.html#(meth._(((lib._mred/main..rkt)._list-control~3c~25~3e)._get-number))",[[0,[2,"get-number"]],[14,[" (method of ",[0,[2,"list-control<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-number",">gui/radio-box_.html#(meth._(((lib._mred/main..rkt)._radio-box~25)._get-number))",[[0,[2,"get-number"]],[14,[" (method of ",[0,[2,"radio-box%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-number",">gui/tab-panel_.html#(meth._(((lib._mred/main..rkt)._tab-panel~25)._get-number))",[[0,[2,"get-number"]],[14,[" (method of ",[0,[2,"tab-panel%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-one-line-summary",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3alanguage~3c~25~3e)._get-one-line-summary))",[[0,[2,"get-one-line-summary"]],[14,[" (method of ",[0,[2,"drracket:language:language<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-one-line-summary",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3amodule-based-language~3c~25~3e)._get-one-line-summary))",[[0,[2,"get-one-line-summary"]],[14,[" (method of ",[0,[2,"drracket:language:module-based-language<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-one-line-summary",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3asimple-module-based-language~25)._get-one-line-summary))",[[0,[2,"get-one-line-summary"]],[14,[" (method of ",[0,[2,"drracket:language:simple-module-based-language%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-one-line-summary",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3asimple-module-based-language~3c~25~3e)._get-one-line-summary))",[[0,[2,"get-one-line-summary"]],[14,[" (method of ",[0,[2,"drracket:language:simple-module-based-language<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-orientation",">draw/ps-setup_.html#(meth._(((lib._racket/draw..rkt)._ps-setup~25)._get-orientation))",[[0,[2,"get-orientation"]],[14,[" (method of ",[0,[2,"ps-setup%"]],")"]]],["racket/draw"]],
["get-orientation",">gui/horizontal-panel_.html#(meth._(((lib._mred/main..rkt)._horizontal-panel~25)._get-orientation))",[[0,[2,"get-orientation"]],[14,[" (method of ",[0,[2,"horizontal-panel%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-orientation",">gui/vertical-panel_.html#(meth._(((lib._mred/main..rkt)._vertical-panel~25)._get-orientation))",[[0,[2,"get-orientation"]],[14,[" (method of ",[0,[2,"vertical-panel%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-origin",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._get-origin))",[[0,[2,"get-origin"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["get-other-altgr-key-code",">gui/key-event_.html#(meth._(((lib._mred/main..rkt)._key-event~25)._get-other-altgr-key-code))",[[0,[2,"get-other-altgr-key-code"]],[14,[" (method of ",[0,[2,"key-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-other-caps-key-code",">gui/key-event_.html#(meth._(((lib._mred/main..rkt)._key-event~25)._get-other-caps-key-code))",[[0,[2,"get-other-caps-key-code"]],[14,[" (method of ",[0,[2,"key-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-other-shift-altgr-key-code",">gui/key-event_.html#(meth._(((lib._mred/main..rkt)._key-event~25)._get-other-shift-altgr-key-code))",[[0,[2,"get-other-shift-altgr-key-code"]],[14,[" (method of ",[0,[2,"key-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-other-shift-key-code",">gui/key-event_.html#(meth._(((lib._mred/main..rkt)._key-event~25)._get-other-shift-key-code))",[[0,[2,"get-other-shift-key-code"]],[14,[" (method of ",[0,[2,"key-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-out-port",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3aports~3c~25~3e)._get-out-port))",[[0,[2,"get-out-port"]],[14,[" (method of ",[0,[2,"text:ports<%>"]],")"]]],["framework"]],
["get-out-style-delta",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3aports~3c~25~3e)._get-out-style-delta))",[[0,[2,"get-out-style-delta"]],[14,[" (method of ",[0,[2,"text:ports<%>"]],")"]]],["framework"]],
["get-output",">reference/Sandboxed_Evaluation.html#(def._((lib._racket/sandbox..rkt)._get-output))",[0,[2,"get-output"]],["racket/sandbox"]],
["get-output-bytes",">reference/stringport.html#(def._((quote._~23~25kernel)._get-output-bytes))",[0,[2,"get-output-bytes"]],["racket/base","racket"]],
["get-output-string",">reference/stringport.html#(def._((quote._~23~25kernel)._get-output-string))",[0,[2,"get-output-string"]],["racket/base","racket"]],
["get-output-string",">srfi-std/srfi-6.html#get-output-string",[0,[2,"get-output-string"]],["srfi/6"]],
["get-overwrite-mode",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._get-overwrite-mode))",[[0,[2,"get-overwrite-mode"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-package-from-cache",">planet/Utility_Libraries.html#(def._((lib._planet/util..rkt)._get-package-from-cache))",[0,[2,"get-package-from-cache"]],["planet/util"]],
["get-package-spec",">planet/Utility_Libraries.html#(def._((lib._planet/util..rkt)._get-package-spec))",[0,[2,"get-package-spec"]],["planet/util"]],
["get-padding",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._get-padding))",[[0,[2,"get-padding"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-page-setup-from-user",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._get-page-setup-from-user))",[0,[2,"get-page-setup-from-user"]],["racket/gui/base","racket/gui"]],
["get-panel-background",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._get-panel-background))",[0,[2,"get-panel-background"]],["racket/gui/base","racket/gui"]],
["get-paper-name",">draw/ps-setup_.html#(meth._(((lib._racket/draw..rkt)._ps-setup~25)._get-paper-name))",[[0,[2,"get-paper-name"]],[14,[" (method of ",[0,[2,"ps-setup%"]],")"]]],["racket/draw"]],
["get-parent",">gui/area___.html#(meth._(((lib._mred/main..rkt)._area~3c~25~3e)._get-parent))",[[0,[2,"get-parent"]],[14,[" (method of ",[0,[2,"area<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-parent",">gui/menu-item___.html#(meth._(((lib._mred/main..rkt)._menu-item~3c~25~3e)._get-parent))",[[0,[2,"get-parent"]],[14,[" (method of ",[0,[2,"menu-item<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-parent",">embedded-gui/alignment___.html#(meth._(((lib._embedded-gui/main..rkt)._alignment~3c~25~3e)._get-parent))",[[0,[2,"get-parent"]],[14,[" (method of ",[0,[2,"alignment<%>"]],")"]]],["embedded-gui"]],
["get-parent",">mrlib/hierarchical-list-item___.html#(meth._(((lib._mrlib/hierlist..rkt)._hierarchical-list-item~3c~25~3e)._get-parent))",[[0,[2,"get-parent"]],[14,[" (method of ",[0,[2,"hierarchical-list-item<%>"]],")"]]],["mrlib/hierlist"]],
["get-parents",">mrlib/graph-snip___.html#(meth._(((lib._mrlib/graph..rkt)._graph-snip~3c~25~3e)._get-parents))",[[0,[2,"get-parents"]],[14,[" (method of ",[0,[2,"graph-snip<%>"]],")"]]],["mrlib/graph"]],
["get-paste-text-only",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._get-paste-text-only))",[[0,[2,"get-paste-text-only"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-pasteboard",">embedded-gui/alignment-parent___.html#(meth._(((lib._embedded-gui/main..rkt)._alignment-parent~3c~25~3e)._get-pasteboard))",[[0,[2,"get-pasteboard"]],[14,[" (method of ",[0,[2,"alignment-parent<%>"]],")"]]],["embedded-gui"]],
["get-pen",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._get-pen))",[[0,[2,"get-pen"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["get-percentages",">framework/Panel.html#(meth._(((lib._framework/main..rkt)._panel~3adragable~3c~25~3e)._get-percentages))",[[0,[2,"get-percentages"]],[14,[" (method of ",[0,[2,"panel:dragable<%>"]],")"]]],["framework"]],
["get-pid",">reference/distributed-places.html#(meth._(((lib._racket/place/distributed..rkt)._spawned-process~25)._get-pid))",[[0,[2,"get-pid"]],[14,[" (method of ",[0,[2,"spawned-process%"]],")"]]],["racket/place/distributed"]],
["get-pieces",">gl-board-game/index.html#(meth._(((lib._games/gl-board-game..rkt)._gl-board~25)._get-pieces))",[[0,[2,"get-pieces"]],[14,[" (method of ",[0,[2,"gl-board%"]],")"]]],["games/gl-board-game"]],
["get-pin-x",">gui/WXME_Decoding.html#(meth._(((lib._wxme/cache-image..rkt)._cache-image~25)._get-pin-x))",[[0,[2,"get-pin-x"]],[14,[" (method of ",[0,[2,"cache-image%"]],")"]]],["wxme/cache-image"]],
["get-pin-y",">gui/WXME_Decoding.html#(meth._(((lib._wxme/cache-image..rkt)._cache-image~25)._get-pin-y))",[[0,[2,"get-pin-y"]],[14,[" (method of ",[0,[2,"cache-image%"]],")"]]],["wxme/cache-image"]],
["get-pinhole",">mrlib/Cache-image_Snip.html#(meth._(((lib._mrlib/cache-image-snip..rkt)._cache-image-snip~25)._get-pinhole))",[[0,[2,"get-pinhole"]],[14,[" (method of ",[0,[2,"cache-image-snip%"]],")"]]],["mrlib/cache-image-snip"]],
["get-pixel",">draw/bitmap-dc_.html#(meth._(((lib._racket/draw..rkt)._bitmap-dc~25)._get-pixel))",[[0,[2,"get-pixel"]],[14,[" (method of ",[0,[2,"bitmap-dc%"]],")"]]],["racket/draw"]],
["get-pixel",">graphics/posn.html#(def._((lib._graphics/graphics..rkt)._get-pixel))",[0,[2,"get-pixel"]],["graphics/graphics"]],
["get-pixel-color",">picturing-programs/index.html#(def._((lib._picturing-programs/private/map-image..rkt)._get-pixel-color))",[0,[2,"get-pixel-color"]],["picturing-programs/private/map-image","picturing-programs"]],
["get-plain-label",">gui/labelled-menu-item___.html#(meth._(((lib._mred/main..rkt)._labelled-menu-item~3c~25~3e)._get-plain-label))",[[0,[2,"get-plain-label"]],[14,[" (method of ",[0,[2,"labelled-menu-item<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-plain-label",">gui/window___.html#(meth._(((lib._mred/main..rkt)._window~3c~25~3e)._get-plain-label))",[[0,[2,"get-plain-label"]],[14,[" (method of ",[0,[2,"window<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-planet-cache-path",">planet/Utility_Libraries.html#(def._((lib._planet/cachepath..rkt)._get-planet-cache-path))",[0,"get-planet-cache-path"],["planet/cachepath"]],
["get-planet-module-path/pkg",">planet/Utility_Libraries.html#(def._((lib._planet/resolver..rkt)._get-planet-module-path/pkg))",[0,[2,"get-planet-module-path/pkg"]],["planet/resolver"]],
["get-point-size",">draw/font_.html#(meth._(((lib._racket/draw..rkt)._font~25)._get-point-size))",[[0,[2,"get-point-size"]],[14,[" (method of ",[0,[2,"font%"]],")"]]],["racket/draw"]],
["get-popup-target",">gui/popup-menu_.html#(meth._(((lib._mred/main..rkt)._popup-menu~25)._get-popup-target))",[[0,[2,"get-popup-target"]],[14,[" (method of ",[0,[2,"popup-menu%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-port-name",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3abasic~3c~25~3e)._get-port-name))",[[0,[2,"get-port-name"]],[14,[" (method of ",[0,[2,"text:basic<%>"]],")"]]],["framework"]],
["get-pos/text",">framework/Editor.html#(meth._(((lib._framework/main..rkt)._editor~3abasic~3c~25~3e)._get-pos/text))",[[0,[2,"get-pos/text"]],[14,[" (method of ",[0,[2,"editor:basic<%>"]],")"]]],["framework"]],
["get-pos/text-dc-location",">framework/Editor.html#(meth._(((lib._framework/main..rkt)._editor~3abasic~3c~25~3e)._get-pos/text-dc-location))",[[0,[2,"get-pos/text-dc-location"]],[14,[" (method of ",[0,[2,"editor:basic<%>"]],")"]]],["framework"]],
["get-position",">gui/scroll-event_.html#(meth._(((lib._mred/main..rkt)._scroll-event~25)._get-position))",[[0,[2,"get-position"]],[14,[" (method of ",[0,[2,"scroll-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-position",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._get-position))",[[0,[2,"get-position"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-position",">framework/Comment_Box.html#(meth._(((lib._framework/main..rkt)._comment-box~3asnip~25)._get-position))",[[0,[2,"get-position"]],[14,[" (method of ",[0,[2,"comment-box:snip%"]],")"]]],["framework"]],
["get-position",">framework/editor-snip.html#(meth._(((lib._framework/main..rkt)._editor-snip~3adecorated-mixin)._get-position))",[[0,[2,"get-position"]],[14,[" (method of ",[0,[2,"editor-snip:decorated-mixin"]],")"]]],["framework"]],
["get-position",">framework/editor-snip.html#(meth._(((lib._framework/main..rkt)._editor-snip~3adecorated~3c~25~3e)._get-position))",[[0,[2,"get-position"]],[14,[" (method of ",[0,[2,"editor-snip:decorated<%>"]],")"]]],["framework"]],
["get-post-script-name",">draw/font-name-directory___.html#(meth._(((lib._racket/draw..rkt)._font-name-directory~3c~25~3e)._get-post-script-name))",[[0,[2,"get-post-script-name"]],[14,[" (method of ",[0,[2,"font-name-directory<%>"]],")"]]],["racket/draw"]],
["get-preference",">reference/Filesystem.html#(def._((lib._racket/file..rkt)._get-preference))",[0,[2,"get-preference"]],["racket/file","racket"]],
["get-preview-command",">draw/ps-setup_.html#(meth._(((lib._racket/draw..rkt)._ps-setup~25)._get-preview-command))",[[0,[2,"get-preview-command"]],[14,[" (method of ",[0,[2,"ps-setup%"]],")"]]],["racket/draw"]],
["get-profile-results",">errortrace/using-errortrace.html#(def._((lib._errortrace/errortrace-lib..rkt)._get-profile-results))",[0,[2,"get-profile-results"]],["errortrace"]],
["get-ps-setup-from-user",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._get-ps-setup-from-user))",[0,[2,"get-ps-setup-from-user"]],["racket/gui/base","racket/gui"]],
["get-pure-port",">net/url.html#(def._((lib._net/url..rkt)._get-pure-port))",[0,[2,"get-pure-port"]],["net/url"]],
["get-pure-port/headers",">net/url.html#(def._((lib._net/url..rkt)._get-pure-port/headers))",[0,[2,"get-pure-port/headers"]],["net/url"]],
["get-r",">gui/add-color___.html#(meth._(((lib._racket/snip..rkt)._add-color~3c~25~3e)._get-r))",[[0,[2,"get-r"]],[14,[" (method of ",[0,[2,"add-color<%>"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-r",">gui/mult-color___.html#(meth._(((lib._racket/snip..rkt)._mult-color~3c~25~3e)._get-r))",[[0,[2,"get-r"]],[14,[" (method of ",[0,[2,"mult-color<%>"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-range",">gui/gauge_.html#(meth._(((lib._mred/main..rkt)._gauge~25)._get-range))",[[0,[2,"get-range"]],[14,[" (method of ",[0,[2,"gauge%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-read-write?",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3afile~3c~25~3e)._get-read-write~3f))",[[0,[2,"get-read-write?"]],[14,[" (method of ",[0,[2,"text:file<%>"]],")"]]],["framework"]],
["get-reader",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3amodule-based-language~3c~25~3e)._get-reader))",[[0,[2,"get-reader"]],[14,[" (method of ",[0,[2,"drracket:language:module-based-language<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-reader",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3asimple-module-based-language~25)._get-reader))",[[0,[2,"get-reader"]],[14,[" (method of ",[0,[2,"drracket:language:simple-module-based-language%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-reader",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3asimple-module-based-language~3c~25~3e)._get-reader))",[[0,[2,"get-reader"]],[14,[" (method of ",[0,[2,"drracket:language:simple-module-based-language<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-reader-module",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3alanguage~3c~25~3e)._get-reader-module))",[[0,[2,"get-reader-module"]],[14,[" (method of ",[0,[2,"drracket:language:language<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-recorded-datum",">draw/record-dc_.html#(meth._(((lib._racket/draw..rkt)._record-dc~25)._get-recorded-datum))",[[0,[2,"get-recorded-datum"]],[14,[" (method of ",[0,[2,"record-dc%"]],")"]]],["racket/draw"]],
["get-recorded-procedure",">draw/record-dc_.html#(meth._(((lib._racket/draw..rkt)._record-dc~25)._get-recorded-procedure))",[[0,[2,"get-recorded-procedure"]],[14,[" (method of ",[0,[2,"record-dc%"]],")"]]],["racket/draw"]],
["get-region-data",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._get-region-data))",[[0,[2,"get-region-data"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-regions",">framework/Color.html#(meth._(((lib._framework/main..rkt)._color~3atext~3c~25~3e)._get-regions))",[[0,[2,"get-regions"]],[14,[" (method of ",[0,[2,"color:text<%>"]],")"]]],["framework"]],
["get-replace-search-hit",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3asearching~3c~25~3e)._get-replace-search-hit))",[[0,[2,"get-replace-search-hit"]],[14,[" (method of ",[0,[2,"text:searching<%>"]],")"]]],["framework"]],
["get-resource",">file/resource.html#(def._((lib._file/resource..rkt)._get-resource))",[0,[2,"get-resource"]],["file/resource"]],
["get-revision-number",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._get-revision-number))",[[0,[2,"get-revision-number"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-right-down",">gui/mouse-event_.html#(meth._(((lib._mred/main..rkt)._mouse-event~25)._get-right-down))",[[0,[2,"get-right-down"]],[14,[" (method of ",[0,[2,"mouse-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-root",">syntax-color/index.html#(meth._(((lib._syntax-color/token-tree..rkt)._token-tree~25)._get-root))",[[0,[2,"get-root"]],[14,[" (method of ",[0,[2,"token-tree%"]],")"]]],["syntax-color/token-tree"]],
["get-root-set",">plai/collector.html#(form._((lib._plai/collector..rkt)._get-root-set))",[0,[1,"get-root-set"]],["plai/collector"]],
["get-rotation",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._get-rotation))",[[0,[2,"get-rotation"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["get-saved-snips",">framework/Racket.html#(meth._(((lib._framework/main..rkt)._racket~3asexp-snip~3c~25~3e)._get-saved-snips))",[[0,[2,"get-saved-snips"]],[14,[" (method of ",[0,[2,"racket:sexp-snip<%>"]],")"]]],["framework"]],
["get-sc-id",">reference/distributed-places.html#(meth._(((lib._racket/place/distributed..rkt)._place-socket-bridge~25)._get-sc-id))",[[0,[2,"get-sc-id"]],[14,[" (method of ",[0,[2,"place-socket-bridge%"]],")"]]],["racket/place/distributed"]],
["get-scale",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._get-scale))",[[0,[2,"get-scale"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["get-scaling",">draw/ps-setup_.html#(meth._(((lib._racket/draw..rkt)._ps-setup~25)._get-scaling))",[[0,[2,"get-scaling"]],[14,[" (method of ",[0,[2,"ps-setup%"]],")"]]],["racket/draw"]],
["get-screen-name",">draw/font-name-directory___.html#(meth._(((lib._racket/draw..rkt)._font-name-directory~3c~25~3e)._get-screen-name))",[[0,[2,"get-screen-name"]],[14,[" (method of ",[0,[2,"font-name-directory<%>"]],")"]]],["racket/draw"]],
["get-scroll-page",">gui/canvas_.html#(meth._(((lib._mred/main..rkt)._canvas~25)._get-scroll-page))",[[0,[2,"get-scroll-page"]],[14,[" (method of ",[0,[2,"canvas%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-scroll-pos",">gui/canvas_.html#(meth._(((lib._mred/main..rkt)._canvas~25)._get-scroll-pos))",[[0,[2,"get-scroll-pos"]],[14,[" (method of ",[0,[2,"canvas%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-scroll-range",">gui/canvas_.html#(meth._(((lib._mred/main..rkt)._canvas~25)._get-scroll-range))",[[0,[2,"get-scroll-range"]],[14,[" (method of ",[0,[2,"canvas%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-scroll-step",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._get-scroll-step))",[[0,[2,"get-scroll-step"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-scroll-step-offset",">gui/snip_.html#(meth._(((lib._racket/snip..rkt)._snip~25)._get-scroll-step-offset))",[[0,[2,"get-scroll-step-offset"]],[14,[" (method of ",[0,[2,"snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-search-bubbles",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3asearching~3c~25~3e)._get-search-bubbles))",[[0,[2,"get-search-bubbles"]],[14,[" (method of ",[0,[2,"text:searching<%>"]],")"]]],["framework"]],
["get-search-hit-count",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3asearching~3c~25~3e)._get-search-hit-count))",[[0,[2,"get-search-hit-count"]],[14,[" (method of ",[0,[2,"text:searching<%>"]],")"]]],["framework"]],
["get-selected",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..rkt)._hierarchical-list~25)._get-selected))",[[0,[2,"get-selected"]],[14,[" (method of ",[0,[2,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["get-selected-text-color",">gui/snip-admin_.html#(meth._(((lib._racket/snip..rkt)._snip-admin~25)._get-selected-text-color))",[[0,[2,"get-selected-text-color"]],[14,[" (method of ",[0,[2,"snip-admin%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-selection",">gui/list-control___.html#(meth._(((lib._mred/main..rkt)._list-control~3c~25~3e)._get-selection))",[[0,[2,"get-selection"]],[14,[" (method of ",[0,[2,"list-control<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-selection",">gui/radio-box_.html#(meth._(((lib._mred/main..rkt)._radio-box~25)._get-selection))",[[0,[2,"get-selection"]],[14,[" (method of ",[0,[2,"radio-box%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-selection",">gui/tab-panel_.html#(meth._(((lib._mred/main..rkt)._tab-panel~25)._get-selection))",[[0,[2,"get-selection"]],[14,[" (method of ",[0,[2,"tab-panel%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-selection-b",">frtime/index.html#(meth._(((lib._frtime/gui/fred..rkt)._ft-choice~25)._get-selection-b))",[[0,[2,"get-selection-b"]],[14,[" (method of ",[0,[2,"ft-choice%"]],")"]]],["frtime/gui/fred"]],
["get-selection-b",">frtime/index.html#(meth._(((lib._frtime/gui/fred..rkt)._ft-list-box~25)._get-selection-b))",[[0,[2,"get-selection-b"]],[14,[" (method of ",[0,[2,"ft-list-box%"]],")"]]],["frtime/gui/fred"]],
["get-selection-b",">frtime/index.html#(meth._(((lib._frtime/gui/fred..rkt)._ft-radio-box~25)._get-selection-b))",[[0,[2,"get-selection-b"]],[14,[" (method of ",[0,[2,"ft-radio-box%"]],")"]]],["frtime/gui/fred"]],
["get-selection-visible",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._get-selection-visible))",[[0,[2,"get-selection-visible"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-selections",">gui/list-box_.html#(meth._(((lib._mred/main..rkt)._list-box~25)._get-selections))",[[0,[2,"get-selections"]],[14,[" (method of ",[0,[2,"list-box%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-selections-b",">frtime/index.html#(meth._(((lib._frtime/gui/fred..rkt)._ft-list-box~25)._get-selections-b))",[[0,[2,"get-selections-b"]],[14,[" (method of ",[0,[2,"ft-list-box%"]],")"]]],["frtime/gui/fred"]],
["get-shared",">mzlib/mzlib_pconvert.html#(def._((lib._mzlib/pconvert..rkt)._get-shared))",[0,[2,"get-shared"]],["mzlib/pconvert"]],
["get-shift-down",">gui/key-event_.html#(meth._(((lib._mred/main..rkt)._key-event~25)._get-shift-down))",[[0,[2,"get-shift-down"]],[14,[" (method of ",[0,[2,"key-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-shift-down",">gui/mouse-event_.html#(meth._(((lib._mred/main..rkt)._mouse-event~25)._get-shift-down))",[[0,[2,"get-shift-down"]],[14,[" (method of ",[0,[2,"mouse-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-shift-style",">gui/style___.html#(meth._(((lib._racket/snip..rkt)._style~3c~25~3e)._get-shift-style))",[[0,[2,"get-shift-style"]],[14,[" (method of ",[0,[2,"style<%>"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-shortcut",">gui/selectable-menu-item___.html#(meth._(((lib._mred/main..rkt)._selectable-menu-item~3c~25~3e)._get-shortcut))",[[0,[2,"get-shortcut"]],[14,[" (method of ",[0,[2,"selectable-menu-item<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-shortcut-prefix",">gui/selectable-menu-item___.html#(meth._(((lib._mred/main..rkt)._selectable-menu-item~3c~25~3e)._get-shortcut-prefix))",[[0,[2,"get-shortcut-prefix"]],[14,[" (method of ",[0,[2,"selectable-menu-item<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-should-raise",">gui/WXME_Decoding.html#(meth._(((lib._wxme/test-case..rkt)._test-case~25)._get-should-raise))",[[0,[2,"get-should-raise"]],[14,[" (method of ",[0,[2,"test-case%"]],")"]]],["wxme/test-case"]],
["get-show-menu",">tools/drracket_frame.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aframe~3a~3c~25~3e)._get-show-menu))",[[0,[2,"get-show-menu"]],[14,[" (method of ",[0,[2,"drracket:frame:<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-size",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._get-size))",[[0,[2,"get-size"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["get-size",">gui/window___.html#(meth._(((lib._mred/main..rkt)._window~3c~25~3e)._get-size))",[[0,[2,"get-size"]],[14,[" (method of ",[0,[2,"window<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-size",">gui/style___.html#(meth._(((lib._racket/snip..rkt)._style~3c~25~3e)._get-size))",[[0,[2,"get-size"]],[14,[" (method of ",[0,[2,"style<%>"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-size",">mrlib/Cache-image_Snip.html#(meth._(((lib._mrlib/cache-image-snip..rkt)._cache-image-snip~25)._get-size))",[[0,[2,"get-size"]],[14,[" (method of ",[0,[2,"cache-image-snip%"]],")"]]],["mrlib/cache-image-snip"]],
["get-size-add",">gui/style-delta_.html#(meth._(((lib._racket/snip..rkt)._style-delta~25)._get-size-add))",[[0,[2,"get-size-add"]],[14,[" (method of ",[0,[2,"style-delta%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-size-in-pixels",">draw/font_.html#(meth._(((lib._racket/draw..rkt)._font~25)._get-size-in-pixels))",[[0,[2,"get-size-in-pixels"]],[14,[" (method of ",[0,[2,"font%"]],")"]]],["racket/draw"]],
["get-size-in-pixels",">gui/style___.html#(meth._(((lib._racket/snip..rkt)._style~3c~25~3e)._get-size-in-pixels))",[[0,[2,"get-size-in-pixels"]],[14,[" (method of ",[0,[2,"style<%>"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-size-in-pixels-off",">gui/style-delta_.html#(meth._(((lib._racket/snip..rkt)._style-delta~25)._get-size-in-pixels-off))",[[0,[2,"get-size-in-pixels-off"]],[14,[" (method of ",[0,[2,"style-delta%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-size-in-pixels-on",">gui/style-delta_.html#(meth._(((lib._racket/snip..rkt)._style-delta~25)._get-size-in-pixels-on))",[[0,[2,"get-size-in-pixels-on"]],[14,[" (method of ",[0,[2,"style-delta%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-size-mult",">gui/style-delta_.html#(meth._(((lib._racket/snip..rkt)._style-delta~25)._get-size-mult))",[[0,[2,"get-size-mult"]],[14,[" (method of ",[0,[2,"style-delta%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-slides-as-picts",">slideshow/Slides_to_Picts.html#(def._((lib._slideshow/slides-to-picts..rkt)._get-slides-as-picts))",[0,[2,"get-slides-as-picts"]],["slideshow/slides-to-picts"]],
["get-smoothing",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._get-smoothing))",[[0,[2,"get-smoothing"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["get-smoothing",">draw/font_.html#(meth._(((lib._racket/draw..rkt)._font~25)._get-smoothing))",[[0,[2,"get-smoothing"]],[14,[" (method of ",[0,[2,"font%"]],")"]]],["racket/draw"]],
["get-smoothing",">gui/style___.html#(meth._(((lib._racket/snip..rkt)._style~3c~25~3e)._get-smoothing))",[[0,[2,"get-smoothing"]],[14,[" (method of ",[0,[2,"style<%>"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-smoothing-off",">gui/style-delta_.html#(meth._(((lib._racket/snip..rkt)._style-delta~25)._get-smoothing-off))",[[0,[2,"get-smoothing-off"]],[14,[" (method of ",[0,[2,"style-delta%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-smoothing-on",">gui/style-delta_.html#(meth._(((lib._racket/snip..rkt)._style-delta~25)._get-smoothing-on))",[[0,[2,"get-smoothing-on"]],[14,[" (method of ",[0,[2,"style-delta%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-snip",">gui/editor-snip-editor-admin___.html#(meth._(((lib._mred/main..rkt)._editor-snip-editor-admin~3c~25~3e)._get-snip))",[[0,[2,"get-snip"]],[14,[" (method of ",[0,[2,"editor-snip-editor-admin<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-snip",">unstable/snip.html#(meth._(((lib._unstable/gui/snip..rkt)._snip-canvas~25)._get-snip))",[[0,[2,"get-snip"]],[14,[" (method of ",[0,[2,"snip-canvas%"]],")"]]],["unstable/gui/snip"]],
["get-snip-data",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._get-snip-data))",[[0,[2,"get-snip-data"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-snip-location",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._get-snip-location))",[[0,[2,"get-snip-location"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-snip-position",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._get-snip-position))",[[0,[2,"get-snip-position"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-snip-position-and-location",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._get-snip-position-and-location))",[[0,[2,"get-snip-position-and-location"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-snipclass",">gui/snip_.html#(meth._(((lib._racket/snip..rkt)._snip~25)._get-snipclass))",[[0,[2,"get-snipclass"]],[14,[" (method of ",[0,[2,"snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-space",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._get-space))",[[0,[2,"get-space"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-spaces",">gl-board-game/index.html#(meth._(((lib._games/gl-board-game..rkt)._gl-board~25)._get-spaces))",[[0,[2,"get-spaces"]],[14,[" (method of ",[0,[2,"gl-board%"]],")"]]],["games/gl-board-game"]],
["get-splash-bitmap",">framework/Splash.html#(def._((lib._framework/splash..rkt)._get-splash-bitmap))",[0,[2,"get-splash-bitmap"]],["framework/splash"]],
["get-splash-canvas",">framework/Splash.html#(def._((lib._framework/splash..rkt)._get-splash-canvas))",[0,[2,"get-splash-canvas"]],["framework/splash"]],
["get-splash-event-callback",">framework/Splash.html#(def._((lib._framework/splash..rkt)._get-splash-event-callback))",[0,[2,"get-splash-event-callback"]],["framework/splash"]],
["get-splash-eventspace",">framework/Splash.html#(def._((lib._framework/splash..rkt)._get-splash-eventspace))",[0,[2,"get-splash-eventspace"]],["framework/splash"]],
["get-splash-height",">framework/Splash.html#(def._((lib._framework/splash..rkt)._get-splash-height))",[0,[2,"get-splash-height"]],["framework/splash"]],
["get-splash-paint-callback",">framework/Splash.html#(def._((lib._framework/splash..rkt)._get-splash-paint-callback))",[0,[2,"get-splash-paint-callback"]],["framework/splash"]],
["get-splash-width",">framework/Splash.html#(def._((lib._framework/splash..rkt)._get-splash-width))",[0,[2,"get-splash-width"]],["framework/splash"]],
["get-standard-compilers",">dynext/Compilation.html#(def._((lib._dynext/compile..rkt)._get-standard-compilers))",[0,[2,"get-standard-compilers"]],["dynext/compile"]],
["get-start-of-line",">framework/Racket.html#(meth._(((lib._framework/main..rkt)._racket~3atext-mixin)._get-start-of-line))",[[0,[2,"get-start-of-line"]],[14,[" (method of ",[0,[2,"racket:text-mixin"]],")"]]],["framework"]],
["get-start-of-line",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3abasic~3c~25~3e)._get-start-of-line))",[[0,[2,"get-start-of-line"]],[14,[" (method of ",[0,[2,"text:basic<%>"]],")"]]],["framework"]],
["get-start-position",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._get-start-position))",[[0,[2,"get-start-position"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-stencil-size",">draw/gl-config_.html#(meth._(((lib._racket/draw..rkt)._gl-config~25)._get-stencil-size))",[[0,[2,"get-stencil-size"]],[14,[" (method of ",[0,[2,"gl-config%"]],")"]]],["racket/draw"]],
["get-stereo",">draw/gl-config_.html#(meth._(((lib._racket/draw..rkt)._gl-config~25)._get-stereo))",[[0,[2,"get-stereo"]],[14,[" (method of ",[0,[2,"gl-config%"]],")"]]],["racket/draw"]],
["get-stipple",">draw/brush_.html#(meth._(((lib._racket/draw..rkt)._brush~25)._get-stipple))",[[0,[2,"get-stipple"]],[14,[" (method of ",[0,[2,"brush%"]],")"]]],["racket/draw"]],
["get-stipple",">draw/pen_.html#(meth._(((lib._racket/draw..rkt)._pen~25)._get-stipple))",[[0,[2,"get-stipple"]],[14,[" (method of ",[0,[2,"pen%"]],")"]]],["racket/draw"]],
["get-stops",">draw/linear-gradient_.html#(meth._(((lib._racket/draw..rkt)._linear-gradient~25)._get-stops))",[[0,[2,"get-stops"]],[14,[" (method of ",[0,[2,"linear-gradient%"]],")"]]],["racket/draw"]],
["get-stops",">draw/radial-gradient_.html#(meth._(((lib._racket/draw..rkt)._radial-gradient~25)._get-stops))",[[0,[2,"get-stops"]],[14,[" (method of ",[0,[2,"radial-gradient%"]],")"]]],["racket/draw"]],
["get-string",">gui/list-control___.html#(meth._(((lib._mred/main..rkt)._list-control~3c~25~3e)._get-string))",[[0,[2,"get-string"]],[14,[" (method of ",[0,[2,"list-control<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-string-all",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_704",[0,[2,"get-string-all"]],["rnrs/io/ports-6"]],
["get-string-n",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_700",[0,[2,"get-string-n"]],["rnrs/io/ports-6"]],
["get-string-n!",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_702",[0,[2,"get-string-n!"]],["rnrs/io/ports-6"]],
["get-string-selection",">gui/list-control___.html#(meth._(((lib._mred/main..rkt)._list-control~3c~25~3e)._get-string-selection))",[[0,[2,"get-string-selection"]],[14,[" (method of ",[0,[2,"list-control<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-string-size",">graphics/Miscellaneous_Operations.html#(def._((lib._graphics/graphics..rkt)._get-string-size))",[0,[2,"get-string-size"]],["graphics/graphics"]],
["get-style",">draw/brush_.html#(meth._(((lib._racket/draw..rkt)._brush~25)._get-style))",[[0,[2,"get-style"]],[14,[" (method of ",[0,[2,"brush%"]],")"]]],["racket/draw"]],
["get-style",">draw/font_.html#(meth._(((lib._racket/draw..rkt)._font~25)._get-style))",[[0,[2,"get-style"]],[14,[" (method of ",[0,[2,"font%"]],")"]]],["racket/draw"]],
["get-style",">draw/pen_.html#(meth._(((lib._racket/draw..rkt)._pen~25)._get-style))",[[0,[2,"get-style"]],[14,[" (method of ",[0,[2,"pen%"]],")"]]],["racket/draw"]],
["get-style",">gui/snip_.html#(meth._(((lib._racket/snip..rkt)._snip~25)._get-style))",[[0,[2,"get-style"]],[14,[" (method of ",[0,[2,"snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-style",">gui/style___.html#(meth._(((lib._racket/snip..rkt)._style~3c~25~3e)._get-style))",[[0,[2,"get-style"]],[14,[" (method of ",[0,[2,"style<%>"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-style-delta",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3alanguage~3c~25~3e)._get-style-delta))",[[0,[2,"get-style-delta"]],[14,[" (method of ",[0,[2,"drracket:language:language<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-style-list",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._get-style-list))",[[0,[2,"get-style-list"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-style-off",">gui/style-delta_.html#(meth._(((lib._racket/snip..rkt)._style-delta~25)._get-style-off))",[[0,[2,"get-style-off"]],[14,[" (method of ",[0,[2,"style-delta%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-style-on",">gui/style-delta_.html#(meth._(((lib._racket/snip..rkt)._style-delta~25)._get-style-on))",[[0,[2,"get-style-on"]],[14,[" (method of ",[0,[2,"style-delta%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-styles-fixed",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3abasic~3c~25~3e)._get-styles-fixed))",[[0,[2,"get-styles-fixed"]],[14,[" (method of ",[0,[2,"text:basic<%>"]],")"]]],["framework"]],
["get-styles-sticky",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._get-styles-sticky))",[[0,[2,"get-styles-sticky"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-suit",">cards/index.html#(meth._(((lib._games/cards..rkt)._card~3c~25~3e)._get-suit))",[[0,[2,"get-suit"]],[14,[" (method of ",[0,[2,"card<%>"]],")"]]],["games/cards"]],
["get-suit-id",">cards/index.html#(meth._(((lib._games/cards..rkt)._card~3c~25~3e)._get-suit-id))",[[0,[2,"get-suit-id"]],[14,[" (method of ",[0,[2,"card<%>"]],")"]]],["games/cards"]],
["get-surrogate",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3ahost-text~3c~25~3e)._get-surrogate))",[[0,[2,"get-surrogate"]],[14,[" (method of ",[0,[2,"mode:host-text<%>"]],")"]]],["framework"]],
["get-tab",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3adefinitions-text~3c~25~3e)._get-tab))",[[0,[2,"get-tab"]],[14,[" (method of ",[0,[2,"drracket:unit:definitions-text<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-tab-count",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aframe~3c~25~3e)._get-tab-count))",[[0,[2,"get-tab-count"]],[14,[" (method of ",[0,[2,"drracket:unit:frame<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-tab-filename",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aframe~3c~25~3e)._get-tab-filename))",[[0,[2,"get-tab-filename"]],[14,[" (method of ",[0,[2,"drracket:unit:frame<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-tab-size",">framework/Racket.html#(meth._(((lib._framework/main..rkt)._racket~3atext~3c~25~3e)._get-tab-size))",[[0,[2,"get-tab-size"]],[14,[" (method of ",[0,[2,"racket:text<%>"]],")"]]],["framework"]],
["get-tabs",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._get-tabs))",[[0,[2,"get-tabs"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-tabs",">gui/snip-admin_.html#(meth._(((lib._racket/snip..rkt)._snip-admin~25)._get-tabs))",[[0,[2,"get-tabs"]],[14,[" (method of ",[0,[2,"snip-admin%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-tabs",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aframe~3c~25~3e)._get-tabs))",[[0,[2,"get-tabs"]],[14,[" (method of ",[0,[2,"drracket:unit:frame<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-test",">gui/WXME_Decoding.html#(meth._(((lib._wxme/test-case..rkt)._test-case~25)._get-test))",[[0,[2,"get-test"]],[14,[" (method of ",[0,[2,"test-case%"]],")"]]],["wxme/test-case"]],
["get-test-engine",">htdp/index.html#(def._((lib._test-engine/racket-tests..rkt)._get-test-engine))",[0,[2,"get-test-engine"]],["htdp/testing"]],
["get-text",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._get-text))",[[0,[2,"get-text"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-text",">gui/snip_.html#(meth._(((lib._racket/snip..rkt)._snip~25)._get-text))",[[0,[2,"get-text"]],[14,[" (method of ",[0,[2,"snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-text",">framework/Comment_Box.html#(meth._(((lib._framework/main..rkt)._comment-box~3asnip~25)._get-text))",[[0,[2,"get-text"]],[14,[" (method of ",[0,[2,"comment-box:snip%"]],")"]]],["framework"]],
["get-text",">framework/Racket.html#(meth._(((lib._framework/main..rkt)._racket~3asexp-snip~25)._get-text))",[[0,[2,"get-text"]],[14,[" (method of ",[0,[2,"racket:sexp-snip%"]],")"]]],["framework"]],
["get-text!",">gui/snip_.html#(meth._(((lib._racket/snip..rkt)._snip~25)._get-text!))",[[0,[2,"get-text!"]],[14,[" (method of ",[0,[2,"snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-text-background",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._get-text-background))",[[0,[2,"get-text-background"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["get-text-descent",">gui/style___.html#(meth._(((lib._racket/snip..rkt)._style~3c~25~3e)._get-text-descent))",[[0,[2,"get-text-descent"]],[14,[" (method of ",[0,[2,"style<%>"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-text-extent",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._get-text-extent))",[[0,[2,"get-text-extent"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["get-text-foreground",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._get-text-foreground))",[[0,[2,"get-text-foreground"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["get-text-from-user",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._get-text-from-user))",[0,[2,"get-text-from-user"]],["racket/gui/base","racket/gui"]],
["get-text-height",">gui/style___.html#(meth._(((lib._racket/snip..rkt)._style~3c~25~3e)._get-text-height))",[[0,[2,"get-text-height"]],[14,[" (method of ",[0,[2,"style<%>"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-text-mode",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._get-text-mode))",[[0,[2,"get-text-mode"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["get-text-space",">gui/style___.html#(meth._(((lib._racket/snip..rkt)._style~3c~25~3e)._get-text-space))",[[0,[2,"get-text-space"]],[14,[" (method of ",[0,[2,"style<%>"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-text-to-search",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aframe~25)._get-text-to-search))",[[0,[2,"get-text-to-search"]],[14,[" (method of ",[0,[2,"drracket:unit:frame%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-text-to-search",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3asearchable-text-mixin)._get-text-to-search))",[[0,[2,"get-text-to-search"]],[14,[" (method of ",[0,[2,"frame:searchable-text-mixin"]],")"]]],["framework"]],
["get-text-to-search",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3asearchable~3c~25~3e)._get-text-to-search))",[[0,[2,"get-text-to-search"]],[14,[" (method of ",[0,[2,"frame:searchable<%>"]],")"]]],["framework"]],
["get-text-width",">gui/style___.html#(meth._(((lib._racket/snip..rkt)._style~3c~25~3e)._get-text-width))",[[0,[2,"get-text-width"]],[14,[" (method of ",[0,[2,"style<%>"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-the-editor-data-class-list",">gui/Editor_Functions.html#(def._((lib._mred/main..rkt)._get-the-editor-data-class-list))",[0,[2,"get-the-editor-data-class-list"]],["racket/gui/base","racket/gui"]],
["get-the-snip-class-list",">gui/Editor_Functions.html#(def._((lib._mred/main..rkt)._get-the-snip-class-list))",[0,[2,"get-the-snip-class-list"]],["racket/gui/base","racket/gui"]],
["get-tight-text-fit",">gui/editor-snip_.html#(meth._(((lib._mred/main..rkt)._editor-snip~25)._get-tight-text-fit))",[[0,[2,"get-tight-text-fit"]],[14,[" (method of ",[0,[2,"editor-snip%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-time-stamp",">gui/event_.html#(meth._(((lib._mred/main..rkt)._event~25)._get-time-stamp))",[[0,[2,"get-time-stamp"]],[14,[" (method of ",[0,[2,"event%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-title",">browser/index.html#(meth._(((lib._browser/browser..rkt)._hyper-text-mixin)._get-title))",[[0,[2,"get-title"]],[14,[" (method of ",[0,[2,"hyper-text-mixin"]],")"]]],["browser/browser","browser"]],
["get-token-range",">framework/Color.html#(meth._(((lib._framework/main..rkt)._color~3atext~3c~25~3e)._get-token-range))",[[0,[2,"get-token-range"]],[14,[" (method of ",[0,[2,"color:text<%>"]],")"]]],["framework"]],
["get-top-level-edit-target-window",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._get-top-level-edit-target-window))",[0,[2,"get-top-level-edit-target-window"]],["racket/gui/base","racket/gui"]],
["get-top-level-focus-window",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._get-top-level-focus-window))",[0,[2,"get-top-level-focus-window"]],["racket/gui/base","racket/gui"]],
["get-top-level-window",">gui/area___.html#(meth._(((lib._mred/main..rkt)._area~3c~25~3e)._get-top-level-window))",[[0,[2,"get-top-level-window"]],[14,[" (method of ",[0,[2,"area<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-top-level-window",">framework/Editor.html#(meth._(((lib._framework/main..rkt)._editor~3abasic~3c~25~3e)._get-top-level-window))",[[0,[2,"get-top-level-window"]],[14,[" (method of ",[0,[2,"editor:basic<%>"]],")"]]],["framework"]],
["get-top-level-windows",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._get-top-level-windows))",[0,[2,"get-top-level-windows"]],["racket/gui/base","racket/gui"]],
["get-top-line-base",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._get-top-line-base))",[[0,[2,"get-top-line-base"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-transformation",">draw/brush_.html#(meth._(((lib._racket/draw..rkt)._brush~25)._get-transformation))",[[0,[2,"get-transformation"]],[14,[" (method of ",[0,[2,"brush%"]],")"]]],["racket/draw"]],
["get-transformation",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._get-transformation))",[[0,[2,"get-transformation"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["get-transformer-module",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3amodule-based-language~3c~25~3e)._get-transformer-module))",[[0,[2,"get-transformer-module"]],[14,[" (method of ",[0,[2,"drracket:language:module-based-language<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-transformer-module",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3asimple-module-based-language-~3emodule-based-language-mixin)._get-transformer-module))",[[0,[2,"get-transformer-module"]],[14,[" (method of ",[0,[2,"drracket:language:simple-module-based-language->module-based-language-mixin"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-translation",">draw/ps-setup_.html#(meth._(((lib._racket/draw..rkt)._ps-setup~25)._get-translation))",[[0,[2,"get-translation"]],[14,[" (method of ",[0,[2,"ps-setup%"]],")"]]],["racket/draw"]],
["get-transparent-text-backing",">gui/style___.html#(meth._(((lib._racket/snip..rkt)._style~3c~25~3e)._get-transparent-text-backing))",[[0,[2,"get-transparent-text-backing"]],[14,[" (method of ",[0,[2,"style<%>"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-transparent-text-backing-off",">gui/style-delta_.html#(meth._(((lib._racket/snip..rkt)._style-delta~25)._get-transparent-text-backing-off))",[[0,[2,"get-transparent-text-backing-off"]],[14,[" (method of ",[0,[2,"style-delta%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-transparent-text-backing-on",">gui/style-delta_.html#(meth._(((lib._racket/snip..rkt)._style-delta~25)._get-transparent-text-backing-on))",[[0,[2,"get-transparent-text-backing-on"]],[14,[" (method of ",[0,[2,"style-delta%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-types",">gui/clipboard-client_.html#(meth._(((lib._mred/main..rkt)._clipboard-client~25)._get-types))",[[0,[2,"get-types"]],[14,[" (method of ",[0,[2,"clipboard-client%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-u8",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_684",[0,[2,"get-u8"]],["rnrs/io/ports-6"]],
["get-uncovered-expressions",">reference/Sandboxed_Evaluation.html#(def._((lib._racket/sandbox..rkt)._get-uncovered-expressions))",[0,[2,"get-uncovered-expressions"]],["racket/sandbox"]],
["get-undefined",">scribble/renderer.html#(meth._(((lib._scribble/base-render..rkt)._render~25)._get-undefined))",[[0,[2,"get-undefined"]],[14,[" (method of ",[0,[2,"render%"]],")"]]],["scribble/base-render"]],
["get-underlined",">draw/font_.html#(meth._(((lib._racket/draw..rkt)._font~25)._get-underlined))",[[0,[2,"get-underlined"]],[14,[" (method of ",[0,[2,"font%"]],")"]]],["racket/draw"]],
["get-underlined",">gui/style___.html#(meth._(((lib._racket/snip..rkt)._style~3c~25~3e)._get-underlined))",[[0,[2,"get-underlined"]],[14,[" (method of ",[0,[2,"style<%>"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-underlined-off",">gui/style-delta_.html#(meth._(((lib._racket/snip..rkt)._style-delta~25)._get-underlined-off))",[[0,[2,"get-underlined-off"]],[14,[" (method of ",[0,[2,"style-delta%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-underlined-on",">gui/style-delta_.html#(meth._(((lib._racket/snip..rkt)._style-delta~25)._get-underlined-on))",[[0,[2,"get-underlined-on"]],[14,[" (method of ",[0,[2,"style-delta%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-unique-id/all",">net/pop3.html#(def._((lib._net/pop3..rkt)._get-unique-id/all))",[0,[2,"get-unique-id/all"]],["net/pop3"]],
["get-unique-id/single",">net/pop3.html#(def._((lib._net/pop3..rkt)._get-unique-id/single))",[0,[2,"get-unique-id/single"]],["net/pop3"]],
["get-unread-start-point",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3aports~3c~25~3e)._get-unread-start-point))",[[0,[2,"get-unread-start-point"]],[14,[" (method of ",[0,[2,"text:ports<%>"]],")"]]],["framework"]],
["get-unterminated-bytes",">gui/editor-stream-in_.html#(meth._(((lib._mred/main..rkt)._editor-stream-in~25)._get-unterminated-bytes))",[[0,[2,"get-unterminated-bytes"]],[14,[" (method of ",[0,[2,"editor-stream-in%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-url",">browser/index.html#(meth._(((lib._browser/browser..rkt)._hyper-text-mixin)._get-url))",[[0,[2,"get-url"]],[14,[" (method of ",[0,[2,"hyper-text-mixin"]],")"]]],["browser/browser","browser"]],
["get-url",">browser/index.html#(meth._(((lib._browser/htmltext..rkt)._html-text~3c~25~3e)._get-url))",[[0,[2,"get-url"]],[14,[" (method of ",[0,[2,"html-text<%>"]],")"]]],["browser/htmltext"]],
["get-user-custodian",">reference/Sandboxed_Evaluation.html#(def._((lib._racket/sandbox..rkt)._get-user-custodian))",[0,[2,"get-user-custodian"]],["racket/sandbox"]],
["get-user-custodian",">tools/drracket_rep.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3arep~3atext~25)._get-user-custodian))",[[0,[2,"get-user-custodian"]],[14,[" (method of ",[0,[2,"drracket:rep:text%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-user-eventspace",">tools/drracket_rep.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3arep~3atext~25)._get-user-eventspace))",[[0,[2,"get-user-eventspace"]],[14,[" (method of ",[0,[2,"drracket:rep:text%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-user-language-settings",">tools/drracket_rep.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3arep~3atext~25)._get-user-language-settings))",[[0,[2,"get-user-language-settings"]],[14,[" (method of ",[0,[2,"drracket:rep:text%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-user-namespace",">tools/drracket_rep.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3arep~3atext~25)._get-user-namespace))",[[0,[2,"get-user-namespace"]],[14,[" (method of ",[0,[2,"drracket:rep:text%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-user-thread",">tools/drracket_rep.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3arep~3atext~25)._get-user-thread))",[[0,[2,"get-user-thread"]],[14,[" (method of ",[0,[2,"drracket:rep:text%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-users-language-name",">tools/drracket_module-language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3amodule-language~3c~25~3e)._get-users-language-name))",["get-users-language-name",[14,[" (method of ",[0,[2,"drracket:language:module-language<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["get-value",">gui/check-box_.html#(meth._(((lib._mred/main..rkt)._check-box~25)._get-value))",[[0,[2,"get-value"]],[14,[" (method of ",[0,[2,"check-box%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-value",">gui/gauge_.html#(meth._(((lib._mred/main..rkt)._gauge~25)._get-value))",[[0,[2,"get-value"]],[14,[" (method of ",[0,[2,"gauge%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-value",">gui/slider_.html#(meth._(((lib._mred/main..rkt)._slider~25)._get-value))",[[0,[2,"get-value"]],[14,[" (method of ",[0,[2,"slider%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-value",">gui/text-field_.html#(meth._(((lib._mred/main..rkt)._text-field~25)._get-value))",[[0,[2,"get-value"]],[14,[" (method of ",[0,[2,"text-field%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-value",">cards/index.html#(meth._(((lib._games/cards..rkt)._card~3c~25~3e)._get-value))",[[0,[2,"get-value"]],[14,[" (method of ",[0,[2,"card<%>"]],")"]]],["games/cards"]],
["get-value-b",">frtime/index.html#(meth._(((lib._frtime/gui/fred..rkt)._ft-check-box~25)._get-value-b))",[[0,[2,"get-value-b"]],[14,[" (method of ",[0,[2,"ft-check-box%"]],")"]]],["frtime/gui/fred"]],
["get-value-b",">frtime/index.html#(meth._(((lib._frtime/gui/fred..rkt)._ft-slider~25)._get-value-b))",[[0,[2,"get-value-b"]],[14,[" (method of ",[0,[2,"ft-slider%"]],")"]]],["frtime/gui/fred"]],
["get-value-b",">frtime/index.html#(meth._(((lib._frtime/gui/fred..rkt)._ft-text-field~25)._get-value-b))",[[0,[2,"get-value-b"]],[14,[" (method of ",[0,[2,"ft-text-field%"]],")"]]],["frtime/gui/fred"]],
["get-value-e",">frtime/index.html#(meth._(((lib._frtime/gui/fred..rkt)._ft-button~25)._get-value-e))",[[0,[2,"get-value-e"]],[14,[" (method of ",[0,[2,"ft-button%"]],")"]]],["frtime/gui/fred"]],
["get-value-port",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3aports~3c~25~3e)._get-value-port))",[[0,[2,"get-value-port"]],[14,[" (method of ",[0,[2,"text:ports<%>"]],")"]]],["framework"]],
["get-value-style-delta",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3aports~3c~25~3e)._get-value-style-delta))",[[0,[2,"get-value-style-delta"]],[14,[" (method of ",[0,[2,"text:ports<%>"]],")"]]],["framework"]],
["get-version",">gui/snip-class_.html#(meth._(((lib._racket/snip..rkt)._snip-class~25)._get-version))",[[0,[2,"get-version"]],[14,[" (method of ",[0,[2,"snip-class%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-vertical?",">framework/Panel.html#(meth._(((lib._framework/main..rkt)._panel~3adragable~3c~25~3e)._get-vertical~3f))",[[0,[2,"get-vertical?"]],[14,[" (method of ",[0,[2,"panel:dragable<%>"]],")"]]],["framework"]],
["get-vertical?",">framework/Panel.html#(meth._(((lib._framework/main..rkt)._panel~3ahorizontal-dragable-mixin)._get-vertical~3f))",[[0,[2,"get-vertical?"]],[14,[" (method of ",[0,[2,"panel:horizontal-dragable-mixin"]],")"]]],["framework"]],
["get-vertical?",">framework/Panel.html#(meth._(((lib._framework/main..rkt)._panel~3avertical-dragable-mixin)._get-vertical~3f))",[[0,[2,"get-vertical?"]],[14,[" (method of ",[0,[2,"panel:vertical-dragable-mixin"]],")"]]],["framework"]],
["get-view",">gui/editor-admin_.html#(meth._(((lib._mred/main..rkt)._editor-admin~25)._get-view))",[[0,[2,"get-view"]],[14,[" (method of ",[0,[2,"editor-admin%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-view",">gui/snip-admin_.html#(meth._(((lib._racket/snip..rkt)._snip-admin~25)._get-view))",[[0,[2,"get-view"]],[14,[" (method of ",[0,[2,"snip-admin%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-view-size",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._get-view-size))",[[0,[2,"get-view-size"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-view-size",">gui/snip-admin_.html#(meth._(((lib._racket/snip..rkt)._snip-admin~25)._get-view-size))",[[0,[2,"get-view-size"]],[14,[" (method of ",[0,[2,"snip-admin%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-view-start",">gui/canvas_.html#(meth._(((lib._mred/main..rkt)._canvas~25)._get-view-start))",[[0,[2,"get-view-start"]],[14,[" (method of ",[0,[2,"canvas%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-virtual-size",">gui/canvas_.html#(meth._(((lib._mred/main..rkt)._canvas~25)._get-virtual-size))",[[0,[2,"get-virtual-size"]],[14,[" (method of ",[0,[2,"canvas%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-visible-line-range",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._get-visible-line-range))",[[0,[2,"get-visible-line-range"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-visible-position-range",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._get-visible-position-range))",[[0,[2,"get-visible-position-range"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-w",">gui/WXME_Decoding.html#(meth._(((lib._wxme/image..rkt)._image~25)._get-w))",[[0,[2,"get-w"]],[14,[" (method of ",[0,[2,"image%"]],")"]]],["wxme/image"]],
["get-weight",">draw/font_.html#(meth._(((lib._racket/draw..rkt)._font~25)._get-weight))",[[0,[2,"get-weight"]],[14,[" (method of ",[0,[2,"font%"]],")"]]],["racket/draw"]],
["get-weight",">gui/style___.html#(meth._(((lib._racket/snip..rkt)._style~3c~25~3e)._get-weight))",[[0,[2,"get-weight"]],[14,[" (method of ",[0,[2,"style<%>"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-weight-off",">gui/style-delta_.html#(meth._(((lib._racket/snip..rkt)._style-delta~25)._get-weight-off))",[[0,[2,"get-weight-off"]],[14,[" (method of ",[0,[2,"style-delta%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-weight-on",">gui/style-delta_.html#(meth._(((lib._racket/snip..rkt)._style-delta~25)._get-weight-on))",[[0,[2,"get-weight-on"]],[14,[" (method of ",[0,[2,"style-delta%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["get-width",">draw/bitmap_.html#(meth._(((lib._racket/draw..rkt)._bitmap~25)._get-width))",[[0,[2,"get-width"]],[14,[" (method of ",[0,[2,"bitmap%"]],")"]]],["racket/draw"]],
["get-width",">draw/pen_.html#(meth._(((lib._racket/draw..rkt)._pen~25)._get-width))",[[0,[2,"get-width"]],[14,[" (method of ",[0,[2,"pen%"]],")"]]],["racket/draw"]],
["get-width",">gui/window___.html#(meth._(((lib._mred/main..rkt)._window~3c~25~3e)._get-width))",[[0,[2,"get-width"]],[14,[" (method of ",[0,[2,"window<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-width",">gui/WXME_Decoding.html#(meth._(((lib._wxme/cache-image..rkt)._cache-image~25)._get-width))",[[0,[2,"get-width"]],[14,[" (method of ",[0,[2,"cache-image%"]],")"]]],["wxme/cache-image"]],
["get-window-text-extent",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._get-window-text-extent))",[0,[2,"get-window-text-extent"]],["racket/gui/base","racket/gui"]],
["get-word-at",">framework/Racket.html#(meth._(((lib._framework/main..rkt)._racket~3atext-mixin)._get-word-at))",[[0,[2,"get-word-at"]],[14,[" (method of ",[0,[2,"racket:text-mixin"]],")"]]],["framework"]],
["get-word-at",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3aautocomplete~3c~25~3e)._get-word-at))",[[0,[2,"get-word-at"]],[14,[" (method of ",[0,[2,"text:autocomplete<%>"]],")"]]],["framework"]],
["get-wordbreak-map",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._get-wordbreak-map))",[[0,[2,"get-wordbreak-map"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-x",">draw/point_.html#(meth._(((lib._racket/draw..rkt)._point~25)._get-x))",[[0,[2,"get-x"]],[14,[" (method of ",[0,[2,"point%"]],")"]]],["racket/draw"]],
["get-x",">gui/key-event_.html#(meth._(((lib._mred/main..rkt)._key-event~25)._get-x))",[[0,[2,"get-x"]],[14,[" (method of ",[0,[2,"key-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-x",">gui/mouse-event_.html#(meth._(((lib._mred/main..rkt)._mouse-event~25)._get-x))",[[0,[2,"get-x"]],[14,[" (method of ",[0,[2,"mouse-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-x",">gui/window___.html#(meth._(((lib._mred/main..rkt)._window~3c~25~3e)._get-x))",[[0,[2,"get-x"]],[14,[" (method of ",[0,[2,"window<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["get-y",">draw/point_.html#(meth._(((lib._racket/draw..rkt)._point~25)._get-y))",[[0,[2,"get-y"]],[14,[" (method of ",[0,[2,"point%"]],")"]]],["racket/draw"]],
["get-y",">gui/key-event_.html#(meth._(((lib._mred/main..rkt)._key-event~25)._get-y))",[[0,[2,"get-y"]],[14,[" (method of ",[0,[2,"key-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-y",">gui/mouse-event_.html#(meth._(((lib._mred/main..rkt)._mouse-event~25)._get-y))",[[0,[2,"get-y"]],[14,[" (method of ",[0,[2,"mouse-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["get-y",">gui/window___.html#(meth._(((lib._mred/main..rkt)._window~3c~25~3e)._get-y))",[[0,[2,"get-y"]],[14,[" (method of ",[0,[2,"window<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["getenv",">reference/runtime.html#(def._((quote._~23~25kernel)._getenv))",[0,[2,"getenv"]],["racket/base","racket"]],
["gethostname",">mzlib/mzlib_os.html#(def._((lib._mzlib/os..rkt)._gethostname))",[0,[2,"gethostname"]],["mzlib/os"]],
["getlasterror",">foreign/foreign_procedures.html#(idx._(gentag._4._(lib._scribblings/foreign/foreign..scrbl)))",[6,"GetLastError"],false],
["getpid",">mzlib/mzlib_os.html#(def._((lib._mzlib/os..rkt)._getpid))",[0,[2,"getpid"]],["mzlib/os"]],
["getprop",">mzlib/mzlib_compat.html#(def._((lib._mzlib/compat..rkt)._getprop))",[0,[2,"getprop"]],["mzlib/compat"]],
["getter-with-setter",">srfi-std/srfi-17.html#getter-with-setter",[0,[2,"getter-with-setter"]],["srfi/17"]],
["getting module compiled code",">syntax/module-helpers.html#(part._modcode)","Getting Module Compiled Code",false],
["getting started",">scribble/getting-started.html","Getting Started",false],
["getting started",">continue/index.html#(part._.Getting_.Started)","Getting Started",false],
["getting started with documentation",">scribble/how-to-doc.html","Getting Started with Documentation",false],
["getting started with racket",">getting-started/index.html","Getting Started with Racket",false],
["getting the most out of the optimizer",">ts-guide/optimization.html#(part._.Getting_the_most_out_of_the_optimizer)","Getting the most out of the optimizer",false],
["gfclampf",">sgl/gl.html#(idx._(gentag._13._(lib._sgl/scribblings/sgl..scrbl)))",[6,"GFclampf"],false],
["gffloat",">sgl/gl.html#(idx._(gentag._11._(lib._sgl/scribblings/sgl..scrbl)))",[6,"GFfloat"],false],
["ghost",">slideshow/Pict_Drawing_Adjusters.html#(def._((lib._slideshow/pict..rkt)._ghost))",[0,[2,"ghost"]],["slideshow/pict","slideshow"]],
["gif",">draw/bitmap_.html#(idx._(gentag._0._(lib._scribblings/draw/draw..scrbl)))","GIF",false],
["gif and animated gif writing",">mrlib/GIF_and_Animated_GIF_Writing.html","GIF and Animated GIF Writing",false],
["gif file writing",">file/gif.html","GIF File Writing",false],
["gif-add-comment",">file/gif.html#(def._((lib._file/gif..rkt)._gif-add-comment))",[0,[2,"gif-add-comment"]],["file/gif"]],
["gif-add-control",">file/gif.html#(def._((lib._file/gif..rkt)._gif-add-control))",[0,[2,"gif-add-control"]],["file/gif"]],
["gif-add-image",">file/gif.html#(def._((lib._file/gif..rkt)._gif-add-image))",[0,[2,"gif-add-image"]],["file/gif"]],
["gif-add-loop-control",">file/gif.html#(def._((lib._file/gif..rkt)._gif-add-loop-control))",[0,[2,"gif-add-loop-control"]],["file/gif"]],
["gif-colormap?",">file/gif.html#(def._((lib._file/gif..rkt)._gif-colormap~3f))",[0,[2,"gif-colormap?"]],["file/gif"]],
["gif-end",">file/gif.html#(def._((lib._file/gif..rkt)._gif-end))",[0,[2,"gif-end"]],["file/gif"]],
["gif-start",">file/gif.html#(def._((lib._file/gif..rkt)._gif-start))",[0,[2,"gif-start"]],["file/gif"]],
["gif-state",">file/gif.html#(def._((lib._file/gif..rkt)._gif-state))",[0,[2,"gif-state"]],["file/gif"]],
["gif-stream?",">file/gif.html#(def._((lib._file/gif..rkt)._gif-stream~3f))",[0,[2,"gif-stream?"]],["file/gif"]],
["gl board game: 3-d game support",">gl-board-game/index.html","GL Board Game: 3-D Game Support",false],
["gl-accum",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-accum))",[0,[2,"gl-accum"]],["sgl"]],
["gl-active-texture",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-active-texture))",[0,[2,"gl-active-texture"]],["sgl"]],
["gl-alpha-func",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-alpha-func))",[0,[2,"gl-alpha-func"]],["sgl"]],
["gl-begin",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-begin))",[0,[2,"gl-begin"]],["sgl"]],
["gl-begin-query",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-begin-query))",[0,[2,"gl-begin-query"]],["sgl"]],
["gl-blend-color",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-blend-color))",[0,[2,"gl-blend-color"]],["sgl"]],
["gl-blend-equation",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-blend-equation))",[0,[2,"gl-blend-equation"]],["sgl"]],
["gl-blend-func",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-blend-func))",[0,[2,"gl-blend-func"]],["sgl"]],
["gl-blend-func-separate",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-blend-func-separate))",[0,[2,"gl-blend-func-separate"]],["sgl"]],
["gl-board%",">gl-board-game/index.html#(def._((lib._games/gl-board-game..rkt)._gl-board~25))",[0,[2,"gl-board%"]],["games/gl-board-game"]],
["gl-boolean-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._gl-boolean-vector))",[0,[2,"gl-boolean-vector"]],["sgl/gl-vectors"]],
["gl-boolean-vector*",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._gl-boolean-vector*))",[0,[2,"gl-boolean-vector*"]],["sgl/gl-vectors"]],
["gl-boolean-vector+",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._gl-boolean-vector+))",[0,[2,"gl-boolean-vector+"]],["sgl/gl-vectors"]],
["gl-boolean-vector-",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._gl-boolean-vector-))",[0,[2,"gl-boolean-vector-"]],["sgl/gl-vectors"]],
["gl-boolean-vector?",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._gl-boolean-vector~3f))",[0,[2,"gl-boolean-vector?"]],["sgl/gl-vectors"]],
["gl-byte-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._gl-byte-vector))",[0,[2,"gl-byte-vector"]],["sgl/gl-vectors"]],
["gl-byte-vector*",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._gl-byte-vector*))",[0,[2,"gl-byte-vector*"]],["sgl/gl-vectors"]],
["gl-byte-vector+",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._gl-byte-vector+))",[0,[2,"gl-byte-vector+"]],["sgl/gl-vectors"]],
["gl-byte-vector-",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._gl-byte-vector-))",[0,[2,"gl-byte-vector-"]],["sgl/gl-vectors"]],
["gl-byte-vector?",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._gl-byte-vector~3f))",[0,[2,"gl-byte-vector?"]],["sgl/gl-vectors"]],
["gl-call-list",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-call-list))",[0,[2,"gl-call-list"]],["sgl"]],
["gl-check-extension",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-check-extension))",[0,[2,"gl-check-extension"]],["sgl"]],
["gl-clear",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-clear))",[0,[2,"gl-clear"]],["sgl"]],
["gl-clear-accum",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-clear-accum))",[0,[2,"gl-clear-accum"]],["sgl"]],
["gl-clear-color",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-clear-color))",[0,[2,"gl-clear-color"]],["sgl"]],
["gl-clear-depth",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-clear-depth))",[0,[2,"gl-clear-depth"]],["sgl"]],
["gl-clear-index",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-clear-index))",[0,[2,"gl-clear-index"]],["sgl"]],
["gl-clear-stencil",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-clear-stencil))",[0,[2,"gl-clear-stencil"]],["sgl"]],
["gl-clip-plane",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-clip-plane))",[0,[2,"gl-clip-plane"]],["sgl"]],
["gl-color",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-color))",[0,[2,"gl-color"]],["sgl"]],
["gl-color-mask",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-color-mask))",[0,[2,"gl-color-mask"]],["sgl"]],
["gl-color-material",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-color-material))",[0,[2,"gl-color-material"]],["sgl"]],
["gl-color-v",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-color-v))",[0,[2,"gl-color-v"]],["sgl"]],
["gl-config%",">draw/gl-config_.html",[0,[2,"gl-config%"]],["racket/draw"]],
["gl-context<%>",">draw/gl-context___.html",[0,[2,"gl-context<%>"]],["racket/draw"]],
["gl-copy-pixels",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-copy-pixels))",[0,[2,"gl-copy-pixels"]],["sgl"]],
["gl-cull-face",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-cull-face))",[0,[2,"gl-cull-face"]],["sgl"]],
["gl-cylinder",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-cylinder))",[0,[2,"gl-cylinder"]],["sgl"]],
["gl-delete-lists",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-delete-lists))",[0,[2,"gl-delete-lists"]],["sgl"]],
["gl-delete-queries",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-delete-queries))",[0,[2,"gl-delete-queries"]],["sgl"]],
["gl-depth-func",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-depth-func))",[0,[2,"gl-depth-func"]],["sgl"]],
["gl-depth-mask",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-depth-mask))",[0,[2,"gl-depth-mask"]],["sgl"]],
["gl-depth-range",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-depth-range))",[0,[2,"gl-depth-range"]],["sgl"]],
["gl-disable",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-disable))",[0,[2,"gl-disable"]],["sgl"]],
["gl-disk",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-disk))",[0,[2,"gl-disk"]],["sgl"]],
["gl-double-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._gl-double-vector))",[0,[2,"gl-double-vector"]],["sgl/gl-vectors"]],
["gl-double-vector*",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._gl-double-vector*))",[0,[2,"gl-double-vector*"]],["sgl/gl-vectors"]],
["gl-double-vector+",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._gl-double-vector+))",[0,[2,"gl-double-vector+"]],["sgl/gl-vectors"]],
["gl-double-vector-",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._gl-double-vector-))",[0,[2,"gl-double-vector-"]],["sgl/gl-vectors"]],
["gl-double-vector?",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._gl-double-vector~3f))",[0,[2,"gl-double-vector?"]],["sgl/gl-vectors"]],
["gl-edge-flag",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-edge-flag))",[0,[2,"gl-edge-flag"]],["sgl"]],
["gl-enable",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-enable))",[0,[2,"gl-enable"]],["sgl"]],
["gl-end",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-end))",[0,[2,"gl-end"]],["sgl"]],
["gl-end-list",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-end-list))",[0,[2,"gl-end-list"]],["sgl"]],
["gl-end-query",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-end-query))",[0,[2,"gl-end-query"]],["sgl"]],
["gl-eval-coord",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-eval-coord))",[0,[2,"gl-eval-coord"]],["sgl"]],
["gl-eval-coord-v",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-eval-coord-v))",[0,[2,"gl-eval-coord-v"]],["sgl"]],
["gl-eval-mesh",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-eval-mesh))",[0,[2,"gl-eval-mesh"]],["sgl"]],
["gl-eval-point",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-eval-point))",[0,[2,"gl-eval-point"]],["sgl"]],
["gl-feedback-buffer->gl-float-vector",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-feedback-buffer-~3egl-float-vector))",[0,[2,"gl-feedback-buffer->gl-float-vector"]],["sgl"]],
["gl-finish",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-finish))",[0,[2,"gl-finish"]],["sgl"]],
["gl-float-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._gl-float-vector))",[0,[2,"gl-float-vector"]],["sgl/gl-vectors"]],
["gl-float-vector*",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._gl-float-vector*))",[0,[2,"gl-float-vector*"]],["sgl/gl-vectors"]],
["gl-float-vector+",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._gl-float-vector+))",[0,[2,"gl-float-vector+"]],["sgl/gl-vectors"]],
["gl-float-vector-",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._gl-float-vector-))",[0,[2,"gl-float-vector-"]],["sgl/gl-vectors"]],
["gl-float-vector?",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._gl-float-vector~3f))",[0,[2,"gl-float-vector?"]],["sgl/gl-vectors"]],
["gl-flush",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-flush))",[0,[2,"gl-flush"]],["sgl"]],
["gl-front-face",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-front-face))",[0,[2,"gl-front-face"]],["sgl"]],
["gl-frustum",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-frustum))",[0,[2,"gl-frustum"]],["sgl"]],
["gl-gen-lists",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-gen-lists))",[0,[2,"gl-gen-lists"]],["sgl"]],
["gl-gen-queries",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-gen-queries))",[0,[2,"gl-gen-queries"]],["sgl"]],
["gl-get-error",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-get-error))",[0,[2,"gl-get-error"]],["sgl"]],
["gl-get-gl-version-number",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-get-gl-version-number))",[0,[2,"gl-get-gl-version-number"]],["sgl"]],
["gl-get-glu-version-number",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-get-glu-version-number))",[0,[2,"gl-get-glu-version-number"]],["sgl"]],
["gl-get-string",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-get-string))",[0,[2,"gl-get-string"]],["sgl"]],
["gl-hint",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-hint))",[0,[2,"gl-hint"]],["sgl"]],
["gl-index",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-index))",[0,[2,"gl-index"]],["sgl"]],
["gl-index-mask",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-index-mask))",[0,[2,"gl-index-mask"]],["sgl"]],
["gl-index-v",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-index-v))",[0,[2,"gl-index-v"]],["sgl"]],
["gl-init-names",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-init-names))",[0,[2,"gl-init-names"]],["sgl"]],
["gl-int-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._gl-int-vector))",[0,[2,"gl-int-vector"]],["sgl/gl-vectors"]],
["gl-int-vector*",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._gl-int-vector*))",[0,[2,"gl-int-vector*"]],["sgl/gl-vectors"]],
["gl-int-vector+",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._gl-int-vector+))",[0,[2,"gl-int-vector+"]],["sgl/gl-vectors"]],
["gl-int-vector-",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._gl-int-vector-))",[0,[2,"gl-int-vector-"]],["sgl/gl-vectors"]],
["gl-int-vector?",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._gl-int-vector~3f))",[0,[2,"gl-int-vector?"]],["sgl/gl-vectors"]],
["gl-is-buffer",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-is-buffer))",[0,[2,"gl-is-buffer"]],["sgl"]],
["gl-is-enabled",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-is-enabled))",[0,[2,"gl-is-enabled"]],["sgl"]],
["gl-is-list",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-is-list))",[0,[2,"gl-is-list"]],["sgl"]],
["gl-is-query",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-is-query))",[0,[2,"gl-is-query"]],["sgl"]],
["gl-light",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-light))",[0,[2,"gl-light"]],["sgl"]],
["gl-light-model",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-light-model))",[0,[2,"gl-light-model"]],["sgl"]],
["gl-light-model-v",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-light-model-v))",[0,[2,"gl-light-model-v"]],["sgl"]],
["gl-light-v",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-light-v))",[0,[2,"gl-light-v"]],["sgl"]],
["gl-line-stipple",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-line-stipple))",[0,[2,"gl-line-stipple"]],["sgl"]],
["gl-line-width",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-line-width))",[0,[2,"gl-line-width"]],["sgl"]],
["gl-list-base",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-list-base))",[0,[2,"gl-list-base"]],["sgl"]],
["gl-load-identity",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-load-identity))",[0,[2,"gl-load-identity"]],["sgl"]],
["gl-load-matrix",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-load-matrix))",[0,[2,"gl-load-matrix"]],["sgl"]],
["gl-load-name",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-load-name))",[0,[2,"gl-load-name"]],["sgl"]],
["gl-load-transpose-matrix",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-load-transpose-matrix))",[0,[2,"gl-load-transpose-matrix"]],["sgl"]],
["gl-look-at",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-look-at))",[0,[2,"gl-look-at"]],["sgl"]],
["gl-map-grid",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-map-grid))",[0,[2,"gl-map-grid"]],["sgl"]],
["gl-material",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-material))",[0,[2,"gl-material"]],["sgl"]],
["gl-material-v",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-material-v))",[0,[2,"gl-material-v"]],["sgl"]],
["gl-matrix-mode",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-matrix-mode))",[0,[2,"gl-matrix-mode"]],["sgl"]],
["gl-mult-matrix",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-mult-matrix))",[0,[2,"gl-mult-matrix"]],["sgl"]],
["gl-mult-transpose-matrix",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-mult-transpose-matrix))",[0,[2,"gl-mult-transpose-matrix"]],["sgl"]],
["gl-multi-tex-coord",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-multi-tex-coord))",[0,[2,"gl-multi-tex-coord"]],["sgl"]],
["gl-multi-tex-coord-v",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-multi-tex-coord-v))",[0,[2,"gl-multi-tex-coord-v"]],["sgl"]],
["gl-new-list",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-new-list))",[0,[2,"gl-new-list"]],["sgl"]],
["gl-new-quadric",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-new-quadric))",[0,[2,"gl-new-quadric"]],["sgl"]],
["gl-normal",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-normal))",[0,[2,"gl-normal"]],["sgl"]],
["gl-normal-v",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-normal-v))",[0,[2,"gl-normal-v"]],["sgl"]],
["gl-ortho",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-ortho))",[0,[2,"gl-ortho"]],["sgl"]],
["gl-ortho-2d",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-ortho-2d))",[0,[2,"gl-ortho-2d"]],["sgl"]],
["gl-partial-disk",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-partial-disk))",[0,[2,"gl-partial-disk"]],["sgl"]],
["gl-pass-through",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-pass-through))",[0,[2,"gl-pass-through"]],["sgl"]],
["gl-perspective",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-perspective))",[0,[2,"gl-perspective"]],["sgl"]],
["gl-pick-matrix",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-pick-matrix))",[0,[2,"gl-pick-matrix"]],["sgl"]],
["gl-pixel-store",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-pixel-store))",[0,[2,"gl-pixel-store"]],["sgl"]],
["gl-point-parameter",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-point-parameter))",[0,[2,"gl-point-parameter"]],["sgl"]],
["gl-point-parameter-v",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-point-parameter-v))",[0,[2,"gl-point-parameter-v"]],["sgl"]],
["gl-point-size",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-point-size))",[0,[2,"gl-point-size"]],["sgl"]],
["gl-polygon-mode",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-polygon-mode))",[0,[2,"gl-polygon-mode"]],["sgl"]],
["gl-polygon-offset",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-polygon-offset))",[0,[2,"gl-polygon-offset"]],["sgl"]],
["gl-pop-attrib",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-pop-attrib))",[0,[2,"gl-pop-attrib"]],["sgl"]],
["gl-pop-client-attrib",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-pop-client-attrib))",[0,[2,"gl-pop-client-attrib"]],["sgl"]],
["gl-pop-matrix",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-pop-matrix))",[0,[2,"gl-pop-matrix"]],["sgl"]],
["gl-pop-name",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-pop-name))",[0,[2,"gl-pop-name"]],["sgl"]],
["gl-process-selection",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-process-selection))",[0,[2,"gl-process-selection"]],["sgl"]],
["gl-project",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-project))",[0,[2,"gl-project"]],["sgl"]],
["gl-push-matrix",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-push-matrix))",[0,[2,"gl-push-matrix"]],["sgl"]],
["gl-push-name",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-push-name))",[0,[2,"gl-push-name"]],["sgl"]],
["gl-quadric-draw-style",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-quadric-draw-style))",[0,[2,"gl-quadric-draw-style"]],["sgl"]],
["gl-quadric-normals",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-quadric-normals))",[0,[2,"gl-quadric-normals"]],["sgl"]],
["gl-quadric-orientation",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-quadric-orientation))",[0,[2,"gl-quadric-orientation"]],["sgl"]],
["gl-quadric-texture",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-quadric-texture))",[0,[2,"gl-quadric-texture"]],["sgl"]],
["gl-raster-pos",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-raster-pos))",[0,[2,"gl-raster-pos"]],["sgl"]],
["gl-raster-pos-v",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-raster-pos-v))",[0,[2,"gl-raster-pos-v"]],["sgl"]],
["gl-rect",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-rect))",[0,[2,"gl-rect"]],["sgl"]],
["gl-rect-v",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-rect-v))",[0,[2,"gl-rect-v"]],["sgl"]],
["gl-render-mode",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-render-mode))",[0,[2,"gl-render-mode"]],["sgl"]],
["gl-rotate",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-rotate))",[0,[2,"gl-rotate"]],["sgl"]],
["gl-sample-coverage",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-sample-coverage))",[0,[2,"gl-sample-coverage"]],["sgl"]],
["gl-scale",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-scale))",[0,[2,"gl-scale"]],["sgl"]],
["gl-scissor",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-scissor))",[0,[2,"gl-scissor"]],["sgl"]],
["gl-secondary-color",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-secondary-color))",[0,[2,"gl-secondary-color"]],["sgl"]],
["gl-secondary-color-v",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-secondary-color-v))",[0,[2,"gl-secondary-color-v"]],["sgl"]],
["gl-select-buffer->gl-uint-vector",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-select-buffer-~3egl-uint-vector))",[0,[2,"gl-select-buffer->gl-uint-vector"]],["sgl"]],
["gl-selection-record",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-selection-record))",[0,[2,"gl-selection-record"]],["sgl"]],
["gl-selection-record-max-z",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-selection-record-max-z))",[0,[2,"gl-selection-record-max-z"]],["sgl"]],
["gl-selection-record-min-z",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-selection-record-min-z))",[0,[2,"gl-selection-record-min-z"]],["sgl"]],
["gl-selection-record-stack",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-selection-record-stack))",[0,[2,"gl-selection-record-stack"]],["sgl"]],
["gl-selection-record?",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-selection-record~3f))",[0,[2,"gl-selection-record?"]],["sgl"]],
["gl-shade-model",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-shade-model))",[0,[2,"gl-shade-model"]],["sgl"]],
["gl-short-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._gl-short-vector))",[0,[2,"gl-short-vector"]],["sgl/gl-vectors"]],
["gl-short-vector*",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._gl-short-vector*))",[0,[2,"gl-short-vector*"]],["sgl/gl-vectors"]],
["gl-short-vector+",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._gl-short-vector+))",[0,[2,"gl-short-vector+"]],["sgl/gl-vectors"]],
["gl-short-vector-",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._gl-short-vector-))",[0,[2,"gl-short-vector-"]],["sgl/gl-vectors"]],
["gl-short-vector?",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._gl-short-vector~3f))",[0,[2,"gl-short-vector?"]],["sgl/gl-vectors"]],
["gl-sphere",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-sphere))",[0,[2,"gl-sphere"]],["sgl"]],
["gl-stencil-func",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-stencil-func))",[0,[2,"gl-stencil-func"]],["sgl"]],
["gl-stencil-mask",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-stencil-mask))",[0,[2,"gl-stencil-mask"]],["sgl"]],
["gl-stencil-op",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-stencil-op))",[0,[2,"gl-stencil-op"]],["sgl"]],
["gl-tex-coord",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-tex-coord))",[0,[2,"gl-tex-coord"]],["sgl"]],
["gl-tex-coord-v",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-tex-coord-v))",[0,[2,"gl-tex-coord-v"]],["sgl"]],
["gl-tex-gen",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-tex-gen))",[0,[2,"gl-tex-gen"]],["sgl"]],
["gl-tex-gen-v",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-tex-gen-v))",[0,[2,"gl-tex-gen-v"]],["sgl"]],
["gl-translate",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-translate))",[0,[2,"gl-translate"]],["sgl"]],
["gl-u-get-string",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-u-get-string))",[0,[2,"gl-u-get-string"]],["sgl"]],
["gl-ubyte-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._gl-ubyte-vector))",[0,[2,"gl-ubyte-vector"]],["sgl/gl-vectors"]],
["gl-ubyte-vector*",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._gl-ubyte-vector*))",[0,[2,"gl-ubyte-vector*"]],["sgl/gl-vectors"]],
["gl-ubyte-vector+",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._gl-ubyte-vector+))",[0,[2,"gl-ubyte-vector+"]],["sgl/gl-vectors"]],
["gl-ubyte-vector-",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._gl-ubyte-vector-))",[0,[2,"gl-ubyte-vector-"]],["sgl/gl-vectors"]],
["gl-ubyte-vector?",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._gl-ubyte-vector~3f))",[0,[2,"gl-ubyte-vector?"]],["sgl/gl-vectors"]],
["gl-uint-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._gl-uint-vector))",[0,[2,"gl-uint-vector"]],["sgl/gl-vectors"]],
["gl-uint-vector*",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._gl-uint-vector*))",[0,[2,"gl-uint-vector*"]],["sgl/gl-vectors"]],
["gl-uint-vector+",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._gl-uint-vector+))",[0,[2,"gl-uint-vector+"]],["sgl/gl-vectors"]],
["gl-uint-vector-",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._gl-uint-vector-))",[0,[2,"gl-uint-vector-"]],["sgl/gl-vectors"]],
["gl-uint-vector?",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._gl-uint-vector~3f))",[0,[2,"gl-uint-vector?"]],["sgl/gl-vectors"]],
["gl-un-project",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-un-project))",[0,[2,"gl-un-project"]],["sgl"]],
["gl-un-project4",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-un-project4))",[0,[2,"gl-un-project4"]],["sgl"]],
["gl-ushort-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._gl-ushort-vector))",[0,[2,"gl-ushort-vector"]],["sgl/gl-vectors"]],
["gl-ushort-vector*",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._gl-ushort-vector*))",[0,[2,"gl-ushort-vector*"]],["sgl/gl-vectors"]],
["gl-ushort-vector+",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._gl-ushort-vector+))",[0,[2,"gl-ushort-vector+"]],["sgl/gl-vectors"]],
["gl-ushort-vector-",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._gl-ushort-vector-))",[0,[2,"gl-ushort-vector-"]],["sgl/gl-vectors"]],
["gl-ushort-vector?",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._gl-ushort-vector~3f))",[0,[2,"gl-ushort-vector?"]],["sgl/gl-vectors"]],
["gl-vector->list",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._gl-vector-~3elist))",[0,[2,"gl-vector->list"]],["sgl/gl-vectors"]],
["gl-vector->vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._gl-vector-~3evector))",[0,[2,"gl-vector->vector"]],["sgl/gl-vectors"]],
["gl-vector-length",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._gl-vector-length))",[0,[2,"gl-vector-length"]],["sgl/gl-vectors"]],
["gl-vector-norm",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._gl-vector-norm))",[0,[2,"gl-vector-norm"]],["sgl/gl-vectors"]],
["gl-vector-ref",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._gl-vector-ref))",[0,[2,"gl-vector-ref"]],["sgl/gl-vectors"]],
["gl-vector-set!",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._gl-vector-set!))",[0,[2,"gl-vector-set!"]],["sgl/gl-vectors"]],
["gl-vector?",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._gl-vector~3f))",[0,[2,"gl-vector?"]],["sgl/gl-vectors"]],
["gl-vertex",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-vertex))",[0,[2,"gl-vertex"]],["sgl"]],
["gl-vertex-v",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-vertex-v))",[0,[2,"gl-vertex-v"]],["sgl"]],
["gl-viewport",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-viewport))",[0,[2,"gl-viewport"]],["sgl"]],
["gl-window-pos",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-window-pos))",[0,[2,"gl-window-pos"]],["sgl"]],
["gl-window-pos-v",">sgl/main.html#(def._((lib._sgl/main..rkt)._gl-window-pos-v))",[0,[2,"gl-window-pos-v"]],["sgl"]],
["gl: 3-d graphics",">sgl/index.html","GL: 3-D Graphics",false],
["gl_2_bytes",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_2_.B.Y.T.E.S))",[0,[2,"GL_2_BYTES"]],["sgl/gl"]],
["gl_2d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_2.D))",[0,[2,"GL_2D"]],["sgl/gl"]],
["gl_3_bytes",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_3_.B.Y.T.E.S))",[0,[2,"GL_3_BYTES"]],["sgl/gl"]],
["gl_3d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_3.D))",[0,[2,"GL_3D"]],["sgl/gl"]],
["gl_3d_color",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_3.D_.C.O.L.O.R))",[0,[2,"GL_3D_COLOR"]],["sgl/gl"]],
["gl_3d_color_texture",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_3.D_.C.O.L.O.R_.T.E.X.T.U.R.E))",[0,[2,"GL_3D_COLOR_TEXTURE"]],["sgl/gl"]],
["gl_4_bytes",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_4_.B.Y.T.E.S))",[0,[2,"GL_4_BYTES"]],["sgl/gl"]],
["gl_4d_color_texture",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_4.D_.C.O.L.O.R_.T.E.X.T.U.R.E))",[0,[2,"GL_4D_COLOR_TEXTURE"]],["sgl/gl"]],
["gl_accum",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.A.C.C.U.M))",[0,[2,"GL_ACCUM"]],["sgl/gl"]],
["gl_accum_alpha_bits",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.A.C.C.U.M_.A.L.P.H.A_.B.I.T.S))",[0,[2,"GL_ACCUM_ALPHA_BITS"]],["sgl/gl"]],
["gl_accum_blue_bits",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.A.C.C.U.M_.B.L.U.E_.B.I.T.S))",[0,[2,"GL_ACCUM_BLUE_BITS"]],["sgl/gl"]],
["gl_accum_buffer_bit",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.A.C.C.U.M_.B.U.F.F.E.R_.B.I.T))",[0,[2,"GL_ACCUM_BUFFER_BIT"]],["sgl/gl"]],
["gl_accum_clear_value",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.A.C.C.U.M_.C.L.E.A.R_.V.A.L.U.E))",[0,[2,"GL_ACCUM_CLEAR_VALUE"]],["sgl/gl"]],
["gl_accum_green_bits",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.A.C.C.U.M_.G.R.E.E.N_.B.I.T.S))",[0,[2,"GL_ACCUM_GREEN_BITS"]],["sgl/gl"]],
["gl_accum_red_bits",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.A.C.C.U.M_.R.E.D_.B.I.T.S))",[0,[2,"GL_ACCUM_RED_BITS"]],["sgl/gl"]],
["gl_active_texture",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.A.C.T.I.V.E_.T.E.X.T.U.R.E))",[0,[2,"GL_ACTIVE_TEXTURE"]],["sgl/gl"]],
["gl_add",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.A.D.D))",[0,[2,"GL_ADD"]],["sgl/gl"]],
["gl_add_signed",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.A.D.D_.S.I.G.N.E.D))",[0,[2,"GL_ADD_SIGNED"]],["sgl/gl"]],
["gl_aliased_line_width_range",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.A.L.I.A.S.E.D_.L.I.N.E_.W.I.D.T.H_.R.A.N.G.E))",[0,[2,"GL_ALIASED_LINE_WIDTH_RANGE"]],["sgl/gl"]],
["gl_aliased_point_size_range",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.A.L.I.A.S.E.D_.P.O.I.N.T_.S.I.Z.E_.R.A.N.G.E))",[0,[2,"GL_ALIASED_POINT_SIZE_RANGE"]],["sgl/gl"]],
["gl_all_attrib_bits",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.A.L.L_.A.T.T.R.I.B_.B.I.T.S))",[0,[2,"GL_ALL_ATTRIB_BITS"]],["sgl/gl"]],
["gl_all_client_attrib_bits",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.A.L.L_.C.L.I.E.N.T_.A.T.T.R.I.B_.B.I.T.S))",[0,[2,"GL_ALL_CLIENT_ATTRIB_BITS"]],["sgl/gl"]],
["gl_alpha",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.A.L.P.H.A))",[0,[2,"GL_ALPHA"]],["sgl/gl"]],
["gl_alpha12",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.A.L.P.H.A12))",[0,[2,"GL_ALPHA12"]],["sgl/gl"]],
["gl_alpha16",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.A.L.P.H.A16))",[0,[2,"GL_ALPHA16"]],["sgl/gl"]],
["gl_alpha4",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.A.L.P.H.A4))",[0,[2,"GL_ALPHA4"]],["sgl/gl"]],
["gl_alpha8",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.A.L.P.H.A8))",[0,[2,"GL_ALPHA8"]],["sgl/gl"]],
["gl_alpha_bias",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.A.L.P.H.A_.B.I.A.S))",[0,[2,"GL_ALPHA_BIAS"]],["sgl/gl"]],
["gl_alpha_bits",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.A.L.P.H.A_.B.I.T.S))",[0,[2,"GL_ALPHA_BITS"]],["sgl/gl"]],
["gl_alpha_scale",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.A.L.P.H.A_.S.C.A.L.E))",[0,[2,"GL_ALPHA_SCALE"]],["sgl/gl"]],
["gl_alpha_test",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.A.L.P.H.A_.T.E.S.T))",[0,[2,"GL_ALPHA_TEST"]],["sgl/gl"]],
["gl_alpha_test_func",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.A.L.P.H.A_.T.E.S.T_.F.U.N.C))",[0,[2,"GL_ALPHA_TEST_FUNC"]],["sgl/gl"]],
["gl_alpha_test_ref",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.A.L.P.H.A_.T.E.S.T_.R.E.F))",[0,[2,"GL_ALPHA_TEST_REF"]],["sgl/gl"]],
["gl_always",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.A.L.W.A.Y.S))",[0,[2,"GL_ALWAYS"]],["sgl/gl"]],
["gl_ambient",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.A.M.B.I.E.N.T))",[0,[2,"GL_AMBIENT"]],["sgl/gl"]],
["gl_ambient_and_diffuse",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.A.M.B.I.E.N.T_.A.N.D_.D.I.F.F.U.S.E))",[0,[2,"GL_AMBIENT_AND_DIFFUSE"]],["sgl/gl"]],
["gl_and",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.A.N.D))",[0,[2,"GL_AND"]],["sgl/gl"]],
["gl_and_inverted",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.A.N.D_.I.N.V.E.R.T.E.D))",[0,[2,"GL_AND_INVERTED"]],["sgl/gl"]],
["gl_and_reverse",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.A.N.D_.R.E.V.E.R.S.E))",[0,[2,"GL_AND_REVERSE"]],["sgl/gl"]],
["gl_array_buffer",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.A.R.R.A.Y_.B.U.F.F.E.R))",[0,[2,"GL_ARRAY_BUFFER"]],["sgl/gl"]],
["gl_array_buffer_binding",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.A.R.R.A.Y_.B.U.F.F.E.R_.B.I.N.D.I.N.G))",[0,[2,"GL_ARRAY_BUFFER_BINDING"]],["sgl/gl"]],
["gl_attrib_stack_depth",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.A.T.T.R.I.B_.S.T.A.C.K_.D.E.P.T.H))",[0,[2,"GL_ATTRIB_STACK_DEPTH"]],["sgl/gl"]],
["gl_auto_normal",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.A.U.T.O_.N.O.R.M.A.L))",[0,[2,"GL_AUTO_NORMAL"]],["sgl/gl"]],
["gl_aux0",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.A.U.X0))",[0,[2,"GL_AUX0"]],["sgl/gl"]],
["gl_aux1",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.A.U.X1))",[0,[2,"GL_AUX1"]],["sgl/gl"]],
["gl_aux2",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.A.U.X2))",[0,[2,"GL_AUX2"]],["sgl/gl"]],
["gl_aux3",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.A.U.X3))",[0,[2,"GL_AUX3"]],["sgl/gl"]],
["gl_aux_buffers",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.A.U.X_.B.U.F.F.E.R.S))",[0,[2,"GL_AUX_BUFFERS"]],["sgl/gl"]],
["gl_back",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.B.A.C.K))",[0,[2,"GL_BACK"]],["sgl/gl"]],
["gl_back_left",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.B.A.C.K_.L.E.F.T))",[0,[2,"GL_BACK_LEFT"]],["sgl/gl"]],
["gl_back_right",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.B.A.C.K_.R.I.G.H.T))",[0,[2,"GL_BACK_RIGHT"]],["sgl/gl"]],
["gl_bgr",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.B.G.R))",[0,[2,"GL_BGR"]],["sgl/gl"]],
["gl_bgra",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.B.G.R.A))",[0,[2,"GL_BGRA"]],["sgl/gl"]],
["gl_bitmap",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.B.I.T.M.A.P))",[0,[2,"GL_BITMAP"]],["sgl/gl"]],
["gl_bitmap_token",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.B.I.T.M.A.P_.T.O.K.E.N))",[0,[2,"GL_BITMAP_TOKEN"]],["sgl/gl"]],
["gl_blend",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.B.L.E.N.D))",[0,[2,"GL_BLEND"]],["sgl/gl"]],
["gl_blend_color",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.B.L.E.N.D_.C.O.L.O.R))",[0,[2,"GL_BLEND_COLOR"]],["sgl/gl"]],
["gl_blend_dst",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.B.L.E.N.D_.D.S.T))",[0,[2,"GL_BLEND_DST"]],["sgl/gl"]],
["gl_blend_dst_alpha",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.B.L.E.N.D_.D.S.T_.A.L.P.H.A))",[0,[2,"GL_BLEND_DST_ALPHA"]],["sgl/gl"]],
["gl_blend_dst_rgb",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.B.L.E.N.D_.D.S.T_.R.G.B))",[0,[2,"GL_BLEND_DST_RGB"]],["sgl/gl"]],
["gl_blend_equation",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.B.L.E.N.D_.E.Q.U.A.T.I.O.N))",[0,[2,"GL_BLEND_EQUATION"]],["sgl/gl"]],
["gl_blend_src",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.B.L.E.N.D_.S.R.C))",[0,[2,"GL_BLEND_SRC"]],["sgl/gl"]],
["gl_blend_src_alpha",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.B.L.E.N.D_.S.R.C_.A.L.P.H.A))",[0,[2,"GL_BLEND_SRC_ALPHA"]],["sgl/gl"]],
["gl_blend_src_rgb",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.B.L.E.N.D_.S.R.C_.R.G.B))",[0,[2,"GL_BLEND_SRC_RGB"]],["sgl/gl"]],
["gl_blue",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.B.L.U.E))",[0,[2,"GL_BLUE"]],["sgl/gl"]],
["gl_blue_bias",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.B.L.U.E_.B.I.A.S))",[0,[2,"GL_BLUE_BIAS"]],["sgl/gl"]],
["gl_blue_bits",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.B.L.U.E_.B.I.T.S))",[0,[2,"GL_BLUE_BITS"]],["sgl/gl"]],
["gl_blue_scale",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.B.L.U.E_.S.C.A.L.E))",[0,[2,"GL_BLUE_SCALE"]],["sgl/gl"]],
["gl_buffer_access",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.B.U.F.F.E.R_.A.C.C.E.S.S))",[0,[2,"GL_BUFFER_ACCESS"]],["sgl/gl"]],
["gl_buffer_map_pointer",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.B.U.F.F.E.R_.M.A.P_.P.O.I.N.T.E.R))",[0,[2,"GL_BUFFER_MAP_POINTER"]],["sgl/gl"]],
["gl_buffer_mapped",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.B.U.F.F.E.R_.M.A.P.P.E.D))",[0,[2,"GL_BUFFER_MAPPED"]],["sgl/gl"]],
["gl_buffer_size",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.B.U.F.F.E.R_.S.I.Z.E))",[0,[2,"GL_BUFFER_SIZE"]],["sgl/gl"]],
["gl_buffer_usage",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.B.U.F.F.E.R_.U.S.A.G.E))",[0,[2,"GL_BUFFER_USAGE"]],["sgl/gl"]],
["gl_byte",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.B.Y.T.E))",[0,[2,"GL_BYTE"]],["sgl/gl"]],
["gl_c3f_v3f",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C3.F_.V3.F))",[0,[2,"GL_C3F_V3F"]],["sgl/gl"]],
["gl_c4f_n3f_v3f",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C4.F_.N3.F_.V3.F))",[0,[2,"GL_C4F_N3F_V3F"]],["sgl/gl"]],
["gl_c4ub_v2f",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C4.U.B_.V2.F))",[0,[2,"GL_C4UB_V2F"]],["sgl/gl"]],
["gl_c4ub_v3f",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C4.U.B_.V3.F))",[0,[2,"GL_C4UB_V3F"]],["sgl/gl"]],
["gl_ccw",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.C.W))",[0,[2,"GL_CCW"]],["sgl/gl"]],
["gl_clamp",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.L.A.M.P))",[0,[2,"GL_CLAMP"]],["sgl/gl"]],
["gl_clamp_to_border",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.L.A.M.P_.T.O_.B.O.R.D.E.R))",[0,[2,"GL_CLAMP_TO_BORDER"]],["sgl/gl"]],
["gl_clamp_to_edge",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.L.A.M.P_.T.O_.E.D.G.E))",[0,[2,"GL_CLAMP_TO_EDGE"]],["sgl/gl"]],
["gl_clear",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.L.E.A.R))",[0,[2,"GL_CLEAR"]],["sgl/gl"]],
["gl_client_active_texture",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.L.I.E.N.T_.A.C.T.I.V.E_.T.E.X.T.U.R.E))",[0,[2,"GL_CLIENT_ACTIVE_TEXTURE"]],["sgl/gl"]],
["gl_client_all_attrib_bits",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.L.I.E.N.T_.A.L.L_.A.T.T.R.I.B_.B.I.T.S))",[0,[2,"GL_CLIENT_ALL_ATTRIB_BITS"]],["sgl/gl"]],
["gl_client_attrib_stack_depth",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.L.I.E.N.T_.A.T.T.R.I.B_.S.T.A.C.K_.D.E.P.T.H))",[0,[2,"GL_CLIENT_ATTRIB_STACK_DEPTH"]],["sgl/gl"]],
["gl_client_pixel_store_bit",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.L.I.E.N.T_.P.I.X.E.L_.S.T.O.R.E_.B.I.T))",[0,[2,"GL_CLIENT_PIXEL_STORE_BIT"]],["sgl/gl"]],
["gl_client_vertex_array_bit",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.L.I.E.N.T_.V.E.R.T.E.X_.A.R.R.A.Y_.B.I.T))",[0,[2,"GL_CLIENT_VERTEX_ARRAY_BIT"]],["sgl/gl"]],
["gl_clip_plane0",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.L.I.P_.P.L.A.N.E0))",[0,[2,"GL_CLIP_PLANE0"]],["sgl/gl"]],
["gl_clip_plane1",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.L.I.P_.P.L.A.N.E1))",[0,[2,"GL_CLIP_PLANE1"]],["sgl/gl"]],
["gl_clip_plane2",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.L.I.P_.P.L.A.N.E2))",[0,[2,"GL_CLIP_PLANE2"]],["sgl/gl"]],
["gl_clip_plane3",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.L.I.P_.P.L.A.N.E3))",[0,[2,"GL_CLIP_PLANE3"]],["sgl/gl"]],
["gl_clip_plane4",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.L.I.P_.P.L.A.N.E4))",[0,[2,"GL_CLIP_PLANE4"]],["sgl/gl"]],
["gl_clip_plane5",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.L.I.P_.P.L.A.N.E5))",[0,[2,"GL_CLIP_PLANE5"]],["sgl/gl"]],
["gl_coeff",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.E.F.F))",[0,[2,"GL_COEFF"]],["sgl/gl"]],
["gl_color",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.L.O.R))",[0,[2,"GL_COLOR"]],["sgl/gl"]],
["gl_color_array",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.L.O.R_.A.R.R.A.Y))",[0,[2,"GL_COLOR_ARRAY"]],["sgl/gl"]],
["gl_color_array_buffer_binding",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.L.O.R_.A.R.R.A.Y_.B.U.F.F.E.R_.B.I.N.D.I.N.G))",[0,[2,"GL_COLOR_ARRAY_BUFFER_BINDING"]],["sgl/gl"]],
["gl_color_array_pointer",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.L.O.R_.A.R.R.A.Y_.P.O.I.N.T.E.R))",[0,[2,"GL_COLOR_ARRAY_POINTER"]],["sgl/gl"]],
["gl_color_array_size",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.L.O.R_.A.R.R.A.Y_.S.I.Z.E))",[0,[2,"GL_COLOR_ARRAY_SIZE"]],["sgl/gl"]],
["gl_color_array_stride",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.L.O.R_.A.R.R.A.Y_.S.T.R.I.D.E))",[0,[2,"GL_COLOR_ARRAY_STRIDE"]],["sgl/gl"]],
["gl_color_array_type",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.L.O.R_.A.R.R.A.Y_.T.Y.P.E))",[0,[2,"GL_COLOR_ARRAY_TYPE"]],["sgl/gl"]],
["gl_color_buffer_bit",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.L.O.R_.B.U.F.F.E.R_.B.I.T))",[0,[2,"GL_COLOR_BUFFER_BIT"]],["sgl/gl"]],
["gl_color_clear_value",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.L.O.R_.C.L.E.A.R_.V.A.L.U.E))",[0,[2,"GL_COLOR_CLEAR_VALUE"]],["sgl/gl"]],
["gl_color_index",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.L.O.R_.I.N.D.E.X))",[0,[2,"GL_COLOR_INDEX"]],["sgl/gl"]],
["gl_color_indexes",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.L.O.R_.I.N.D.E.X.E.S))",[0,[2,"GL_COLOR_INDEXES"]],["sgl/gl"]],
["gl_color_logic_op",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.L.O.R_.L.O.G.I.C_.O.P))",[0,[2,"GL_COLOR_LOGIC_OP"]],["sgl/gl"]],
["gl_color_material",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.L.O.R_.M.A.T.E.R.I.A.L))",[0,[2,"GL_COLOR_MATERIAL"]],["sgl/gl"]],
["gl_color_material_face",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.L.O.R_.M.A.T.E.R.I.A.L_.F.A.C.E))",[0,[2,"GL_COLOR_MATERIAL_FACE"]],["sgl/gl"]],
["gl_color_material_parameter",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.L.O.R_.M.A.T.E.R.I.A.L_.P.A.R.A.M.E.T.E.R))",[0,[2,"GL_COLOR_MATERIAL_PARAMETER"]],["sgl/gl"]],
["gl_color_matrix",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.L.O.R_.M.A.T.R.I.X))",[0,[2,"GL_COLOR_MATRIX"]],["sgl/gl"]],
["gl_color_matrix_stack_depth",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.L.O.R_.M.A.T.R.I.X_.S.T.A.C.K_.D.E.P.T.H))",[0,[2,"GL_COLOR_MATRIX_STACK_DEPTH"]],["sgl/gl"]],
["gl_color_sum",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.L.O.R_.S.U.M))",[0,[2,"GL_COLOR_SUM"]],["sgl/gl"]],
["gl_color_table",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.L.O.R_.T.A.B.L.E))",[0,[2,"GL_COLOR_TABLE"]],["sgl/gl"]],
["gl_color_table_alpha_size",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.L.O.R_.T.A.B.L.E_.A.L.P.H.A_.S.I.Z.E))",[0,[2,"GL_COLOR_TABLE_ALPHA_SIZE"]],["sgl/gl"]],
["gl_color_table_bias",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.L.O.R_.T.A.B.L.E_.B.I.A.S))",[0,[2,"GL_COLOR_TABLE_BIAS"]],["sgl/gl"]],
["gl_color_table_blue_size",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.L.O.R_.T.A.B.L.E_.B.L.U.E_.S.I.Z.E))",[0,[2,"GL_COLOR_TABLE_BLUE_SIZE"]],["sgl/gl"]],
["gl_color_table_format",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.L.O.R_.T.A.B.L.E_.F.O.R.M.A.T))",[0,[2,"GL_COLOR_TABLE_FORMAT"]],["sgl/gl"]],
["gl_color_table_green_size",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.L.O.R_.T.A.B.L.E_.G.R.E.E.N_.S.I.Z.E))",[0,[2,"GL_COLOR_TABLE_GREEN_SIZE"]],["sgl/gl"]],
["gl_color_table_intensity_size",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.L.O.R_.T.A.B.L.E_.I.N.T.E.N.S.I.T.Y_.S.I.Z.E))",[0,[2,"GL_COLOR_TABLE_INTENSITY_SIZE"]],["sgl/gl"]],
["gl_color_table_luminance_size",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.L.O.R_.T.A.B.L.E_.L.U.M.I.N.A.N.C.E_.S.I.Z.E))",[0,[2,"GL_COLOR_TABLE_LUMINANCE_SIZE"]],["sgl/gl"]],
["gl_color_table_red_size",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.L.O.R_.T.A.B.L.E_.R.E.D_.S.I.Z.E))",[0,[2,"GL_COLOR_TABLE_RED_SIZE"]],["sgl/gl"]],
["gl_color_table_scale",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.L.O.R_.T.A.B.L.E_.S.C.A.L.E))",[0,[2,"GL_COLOR_TABLE_SCALE"]],["sgl/gl"]],
["gl_color_table_width",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.L.O.R_.T.A.B.L.E_.W.I.D.T.H))",[0,[2,"GL_COLOR_TABLE_WIDTH"]],["sgl/gl"]],
["gl_color_writemask",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.L.O.R_.W.R.I.T.E.M.A.S.K))",[0,[2,"GL_COLOR_WRITEMASK"]],["sgl/gl"]],
["gl_combine",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.M.B.I.N.E))",[0,[2,"GL_COMBINE"]],["sgl/gl"]],
["gl_combine_alpha",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.M.B.I.N.E_.A.L.P.H.A))",[0,[2,"GL_COMBINE_ALPHA"]],["sgl/gl"]],
["gl_combine_rgb",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.M.B.I.N.E_.R.G.B))",[0,[2,"GL_COMBINE_RGB"]],["sgl/gl"]],
["gl_compare_r_to_texture",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.M.P.A.R.E_.R_.T.O_.T.E.X.T.U.R.E))",[0,[2,"GL_COMPARE_R_TO_TEXTURE"]],["sgl/gl"]],
["gl_compile",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.M.P.I.L.E))",[0,[2,"GL_COMPILE"]],["sgl/gl"]],
["gl_compile_and_execute",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.M.P.I.L.E_.A.N.D_.E.X.E.C.U.T.E))",[0,[2,"GL_COMPILE_AND_EXECUTE"]],["sgl/gl"]],
["gl_compressed_alpha",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.M.P.R.E.S.S.E.D_.A.L.P.H.A))",[0,[2,"GL_COMPRESSED_ALPHA"]],["sgl/gl"]],
["gl_compressed_intensity",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.M.P.R.E.S.S.E.D_.I.N.T.E.N.S.I.T.Y))",[0,[2,"GL_COMPRESSED_INTENSITY"]],["sgl/gl"]],
["gl_compressed_luminance",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.M.P.R.E.S.S.E.D_.L.U.M.I.N.A.N.C.E))",[0,[2,"GL_COMPRESSED_LUMINANCE"]],["sgl/gl"]],
["gl_compressed_luminance_alpha",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.M.P.R.E.S.S.E.D_.L.U.M.I.N.A.N.C.E_.A.L.P.H.A))",[0,[2,"GL_COMPRESSED_LUMINANCE_ALPHA"]],["sgl/gl"]],
["gl_compressed_rgb",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.M.P.R.E.S.S.E.D_.R.G.B))",[0,[2,"GL_COMPRESSED_RGB"]],["sgl/gl"]],
["gl_compressed_rgba",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.M.P.R.E.S.S.E.D_.R.G.B.A))",[0,[2,"GL_COMPRESSED_RGBA"]],["sgl/gl"]],
["gl_compressed_texture_formats",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.M.P.R.E.S.S.E.D_.T.E.X.T.U.R.E_.F.O.R.M.A.T.S))",[0,[2,"GL_COMPRESSED_TEXTURE_FORMATS"]],["sgl/gl"]],
["gl_constant",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.N.S.T.A.N.T))",[0,[2,"GL_CONSTANT"]],["sgl/gl"]],
["gl_constant_alpha",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.N.S.T.A.N.T_.A.L.P.H.A))",[0,[2,"GL_CONSTANT_ALPHA"]],["sgl/gl"]],
["gl_constant_attenuation",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.N.S.T.A.N.T_.A.T.T.E.N.U.A.T.I.O.N))",[0,[2,"GL_CONSTANT_ATTENUATION"]],["sgl/gl"]],
["gl_constant_border",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.N.S.T.A.N.T_.B.O.R.D.E.R))",[0,[2,"GL_CONSTANT_BORDER"]],["sgl/gl"]],
["gl_constant_color",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.N.S.T.A.N.T_.C.O.L.O.R))",[0,[2,"GL_CONSTANT_COLOR"]],["sgl/gl"]],
["gl_convolution_1d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.N.V.O.L.U.T.I.O.N_1.D))",[0,[2,"GL_CONVOLUTION_1D"]],["sgl/gl"]],
["gl_convolution_2d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.N.V.O.L.U.T.I.O.N_2.D))",[0,[2,"GL_CONVOLUTION_2D"]],["sgl/gl"]],
["gl_convolution_border_color",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.N.V.O.L.U.T.I.O.N_.B.O.R.D.E.R_.C.O.L.O.R))",[0,[2,"GL_CONVOLUTION_BORDER_COLOR"]],["sgl/gl"]],
["gl_convolution_border_mode",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.N.V.O.L.U.T.I.O.N_.B.O.R.D.E.R_.M.O.D.E))",[0,[2,"GL_CONVOLUTION_BORDER_MODE"]],["sgl/gl"]],
["gl_convolution_filter_bias",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.N.V.O.L.U.T.I.O.N_.F.I.L.T.E.R_.B.I.A.S))",[0,[2,"GL_CONVOLUTION_FILTER_BIAS"]],["sgl/gl"]],
["gl_convolution_filter_scale",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.N.V.O.L.U.T.I.O.N_.F.I.L.T.E.R_.S.C.A.L.E))",[0,[2,"GL_CONVOLUTION_FILTER_SCALE"]],["sgl/gl"]],
["gl_convolution_format",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.N.V.O.L.U.T.I.O.N_.F.O.R.M.A.T))",[0,[2,"GL_CONVOLUTION_FORMAT"]],["sgl/gl"]],
["gl_convolution_height",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.N.V.O.L.U.T.I.O.N_.H.E.I.G.H.T))",[0,[2,"GL_CONVOLUTION_HEIGHT"]],["sgl/gl"]],
["gl_convolution_width",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.N.V.O.L.U.T.I.O.N_.W.I.D.T.H))",[0,[2,"GL_CONVOLUTION_WIDTH"]],["sgl/gl"]],
["gl_copy",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.P.Y))",[0,[2,"GL_COPY"]],["sgl/gl"]],
["gl_copy_inverted",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.P.Y_.I.N.V.E.R.T.E.D))",[0,[2,"GL_COPY_INVERTED"]],["sgl/gl"]],
["gl_copy_pixel_token",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.O.P.Y_.P.I.X.E.L_.T.O.K.E.N))",[0,[2,"GL_COPY_PIXEL_TOKEN"]],["sgl/gl"]],
["gl_cull_face",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.U.L.L_.F.A.C.E))",[0,[2,"GL_CULL_FACE"]],["sgl/gl"]],
["gl_cull_face_mode",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.U.L.L_.F.A.C.E_.M.O.D.E))",[0,[2,"GL_CULL_FACE_MODE"]],["sgl/gl"]],
["gl_current_bit",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.U.R.R.E.N.T_.B.I.T))",[0,[2,"GL_CURRENT_BIT"]],["sgl/gl"]],
["gl_current_color",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.U.R.R.E.N.T_.C.O.L.O.R))",[0,[2,"GL_CURRENT_COLOR"]],["sgl/gl"]],
["gl_current_fog_coord",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.U.R.R.E.N.T_.F.O.G_.C.O.O.R.D))",[0,[2,"GL_CURRENT_FOG_COORD"]],["sgl/gl"]],
["gl_current_fog_coordinate",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.U.R.R.E.N.T_.F.O.G_.C.O.O.R.D.I.N.A.T.E))",[0,[2,"GL_CURRENT_FOG_COORDINATE"]],["sgl/gl"]],
["gl_current_index",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.U.R.R.E.N.T_.I.N.D.E.X))",[0,[2,"GL_CURRENT_INDEX"]],["sgl/gl"]],
["gl_current_normal",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.U.R.R.E.N.T_.N.O.R.M.A.L))",[0,[2,"GL_CURRENT_NORMAL"]],["sgl/gl"]],
["gl_current_query",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.U.R.R.E.N.T_.Q.U.E.R.Y))",[0,[2,"GL_CURRENT_QUERY"]],["sgl/gl"]],
["gl_current_raster_color",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.U.R.R.E.N.T_.R.A.S.T.E.R_.C.O.L.O.R))",[0,[2,"GL_CURRENT_RASTER_COLOR"]],["sgl/gl"]],
["gl_current_raster_distance",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.U.R.R.E.N.T_.R.A.S.T.E.R_.D.I.S.T.A.N.C.E))",[0,[2,"GL_CURRENT_RASTER_DISTANCE"]],["sgl/gl"]],
["gl_current_raster_index",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.U.R.R.E.N.T_.R.A.S.T.E.R_.I.N.D.E.X))",[0,[2,"GL_CURRENT_RASTER_INDEX"]],["sgl/gl"]],
["gl_current_raster_position",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.U.R.R.E.N.T_.R.A.S.T.E.R_.P.O.S.I.T.I.O.N))",[0,[2,"GL_CURRENT_RASTER_POSITION"]],["sgl/gl"]],
["gl_current_raster_position_valid",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.U.R.R.E.N.T_.R.A.S.T.E.R_.P.O.S.I.T.I.O.N_.V.A.L.I.D))",[0,[2,"GL_CURRENT_RASTER_POSITION_VALID"]],["sgl/gl"]],
["gl_current_raster_texture_coords",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.U.R.R.E.N.T_.R.A.S.T.E.R_.T.E.X.T.U.R.E_.C.O.O.R.D.S))",[0,[2,"GL_CURRENT_RASTER_TEXTURE_COORDS"]],["sgl/gl"]],
["gl_current_secondary_color",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.U.R.R.E.N.T_.S.E.C.O.N.D.A.R.Y_.C.O.L.O.R))",[0,[2,"GL_CURRENT_SECONDARY_COLOR"]],["sgl/gl"]],
["gl_current_texture_coords",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.U.R.R.E.N.T_.T.E.X.T.U.R.E_.C.O.O.R.D.S))",[0,[2,"GL_CURRENT_TEXTURE_COORDS"]],["sgl/gl"]],
["gl_cw",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.C.W))",[0,[2,"GL_CW"]],["sgl/gl"]],
["gl_decal",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.D.E.C.A.L))",[0,[2,"GL_DECAL"]],["sgl/gl"]],
["gl_decr",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.D.E.C.R))",[0,[2,"GL_DECR"]],["sgl/gl"]],
["gl_decr_wrap",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.D.E.C.R_.W.R.A.P))",[0,[2,"GL_DECR_WRAP"]],["sgl/gl"]],
["gl_depth",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.D.E.P.T.H))",[0,[2,"GL_DEPTH"]],["sgl/gl"]],
["gl_depth_bias",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.D.E.P.T.H_.B.I.A.S))",[0,[2,"GL_DEPTH_BIAS"]],["sgl/gl"]],
["gl_depth_bits",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.D.E.P.T.H_.B.I.T.S))",[0,[2,"GL_DEPTH_BITS"]],["sgl/gl"]],
["gl_depth_buffer_bit",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.D.E.P.T.H_.B.U.F.F.E.R_.B.I.T))",[0,[2,"GL_DEPTH_BUFFER_BIT"]],["sgl/gl"]],
["gl_depth_clear_value",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.D.E.P.T.H_.C.L.E.A.R_.V.A.L.U.E))",[0,[2,"GL_DEPTH_CLEAR_VALUE"]],["sgl/gl"]],
["gl_depth_component",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.D.E.P.T.H_.C.O.M.P.O.N.E.N.T))",[0,[2,"GL_DEPTH_COMPONENT"]],["sgl/gl"]],
["gl_depth_component16",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.D.E.P.T.H_.C.O.M.P.O.N.E.N.T16))",[0,[2,"GL_DEPTH_COMPONENT16"]],["sgl/gl"]],
["gl_depth_component24",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.D.E.P.T.H_.C.O.M.P.O.N.E.N.T24))",[0,[2,"GL_DEPTH_COMPONENT24"]],["sgl/gl"]],
["gl_depth_component32",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.D.E.P.T.H_.C.O.M.P.O.N.E.N.T32))",[0,[2,"GL_DEPTH_COMPONENT32"]],["sgl/gl"]],
["gl_depth_func",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.D.E.P.T.H_.F.U.N.C))",[0,[2,"GL_DEPTH_FUNC"]],["sgl/gl"]],
["gl_depth_range",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.D.E.P.T.H_.R.A.N.G.E))",[0,[2,"GL_DEPTH_RANGE"]],["sgl/gl"]],
["gl_depth_scale",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.D.E.P.T.H_.S.C.A.L.E))",[0,[2,"GL_DEPTH_SCALE"]],["sgl/gl"]],
["gl_depth_test",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.D.E.P.T.H_.T.E.S.T))",[0,[2,"GL_DEPTH_TEST"]],["sgl/gl"]],
["gl_depth_texture_mode",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.D.E.P.T.H_.T.E.X.T.U.R.E_.M.O.D.E))",[0,[2,"GL_DEPTH_TEXTURE_MODE"]],["sgl/gl"]],
["gl_depth_writemask",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.D.E.P.T.H_.W.R.I.T.E.M.A.S.K))",[0,[2,"GL_DEPTH_WRITEMASK"]],["sgl/gl"]],
["gl_diffuse",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.D.I.F.F.U.S.E))",[0,[2,"GL_DIFFUSE"]],["sgl/gl"]],
["gl_dither",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.D.I.T.H.E.R))",[0,[2,"GL_DITHER"]],["sgl/gl"]],
["gl_domain",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.D.O.M.A.I.N))",[0,[2,"GL_DOMAIN"]],["sgl/gl"]],
["gl_dont_care",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.D.O.N.T_.C.A.R.E))",[0,[2,"GL_DONT_CARE"]],["sgl/gl"]],
["gl_dot3_rgb",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.D.O.T3_.R.G.B))",[0,[2,"GL_DOT3_RGB"]],["sgl/gl"]],
["gl_dot3_rgba",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.D.O.T3_.R.G.B.A))",[0,[2,"GL_DOT3_RGBA"]],["sgl/gl"]],
["gl_double",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.D.O.U.B.L.E))",[0,[2,"GL_DOUBLE"]],["sgl/gl"]],
["gl_doublebuffer",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.D.O.U.B.L.E.B.U.F.F.E.R))",[0,[2,"GL_DOUBLEBUFFER"]],["sgl/gl"]],
["gl_draw_buffer",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.D.R.A.W_.B.U.F.F.E.R))",[0,[2,"GL_DRAW_BUFFER"]],["sgl/gl"]],
["gl_draw_pixel_token",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.D.R.A.W_.P.I.X.E.L_.T.O.K.E.N))",[0,[2,"GL_DRAW_PIXEL_TOKEN"]],["sgl/gl"]],
["gl_dst_alpha",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.D.S.T_.A.L.P.H.A))",[0,[2,"GL_DST_ALPHA"]],["sgl/gl"]],
["gl_dst_color",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.D.S.T_.C.O.L.O.R))",[0,[2,"GL_DST_COLOR"]],["sgl/gl"]],
["gl_dynamic_copy",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.D.Y.N.A.M.I.C_.C.O.P.Y))",[0,[2,"GL_DYNAMIC_COPY"]],["sgl/gl"]],
["gl_dynamic_draw",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.D.Y.N.A.M.I.C_.D.R.A.W))",[0,[2,"GL_DYNAMIC_DRAW"]],["sgl/gl"]],
["gl_dynamic_read",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.D.Y.N.A.M.I.C_.R.E.A.D))",[0,[2,"GL_DYNAMIC_READ"]],["sgl/gl"]],
["gl_edge_flag",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.E.D.G.E_.F.L.A.G))",[0,[2,"GL_EDGE_FLAG"]],["sgl/gl"]],
["gl_edge_flag_array",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.E.D.G.E_.F.L.A.G_.A.R.R.A.Y))",[0,[2,"GL_EDGE_FLAG_ARRAY"]],["sgl/gl"]],
["gl_edge_flag_array_buffer_binding",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.E.D.G.E_.F.L.A.G_.A.R.R.A.Y_.B.U.F.F.E.R_.B.I.N.D.I.N.G))",[0,[2,"GL_EDGE_FLAG_ARRAY_BUFFER_BINDING"]],["sgl/gl"]],
["gl_edge_flag_array_pointer",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.E.D.G.E_.F.L.A.G_.A.R.R.A.Y_.P.O.I.N.T.E.R))",[0,[2,"GL_EDGE_FLAG_ARRAY_POINTER"]],["sgl/gl"]],
["gl_edge_flag_array_stride",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.E.D.G.E_.F.L.A.G_.A.R.R.A.Y_.S.T.R.I.D.E))",[0,[2,"GL_EDGE_FLAG_ARRAY_STRIDE"]],["sgl/gl"]],
["gl_element_array_buffer",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.E.L.E.M.E.N.T_.A.R.R.A.Y_.B.U.F.F.E.R))",[0,[2,"GL_ELEMENT_ARRAY_BUFFER"]],["sgl/gl"]],
["gl_element_array_buffer_binding",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.E.L.E.M.E.N.T_.A.R.R.A.Y_.B.U.F.F.E.R_.B.I.N.D.I.N.G))",[0,[2,"GL_ELEMENT_ARRAY_BUFFER_BINDING"]],["sgl/gl"]],
["gl_emission",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.E.M.I.S.S.I.O.N))",[0,[2,"GL_EMISSION"]],["sgl/gl"]],
["gl_enable_bit",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.E.N.A.B.L.E_.B.I.T))",[0,[2,"GL_ENABLE_BIT"]],["sgl/gl"]],
["gl_equal",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.E.Q.U.A.L))",[0,[2,"GL_EQUAL"]],["sgl/gl"]],
["gl_equiv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.E.Q.U.I.V))",[0,[2,"GL_EQUIV"]],["sgl/gl"]],
["gl_eval_bit",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.E.V.A.L_.B.I.T))",[0,[2,"GL_EVAL_BIT"]],["sgl/gl"]],
["gl_exp",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.E.X.P))",[0,[2,"GL_EXP"]],["sgl/gl"]],
["gl_exp2",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.E.X.P2))",[0,[2,"GL_EXP2"]],["sgl/gl"]],
["gl_extensions",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.E.X.T.E.N.S.I.O.N.S))",[0,[2,"GL_EXTENSIONS"]],["sgl/gl"]],
["gl_eye_linear",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.E.Y.E_.L.I.N.E.A.R))",[0,[2,"GL_EYE_LINEAR"]],["sgl/gl"]],
["gl_eye_plane",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.E.Y.E_.P.L.A.N.E))",[0,[2,"GL_EYE_PLANE"]],["sgl/gl"]],
["gl_false",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.F.A.L.S.E))",[0,[2,"GL_FALSE"]],["sgl/gl"]],
["gl_false",">sgl/gl.html#(idx._(gentag._16._(lib._sgl/scribblings/sgl..scrbl)))",[6,"GL_FALSE"],false],
["gl_fastest",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.F.A.S.T.E.S.T))",[0,[2,"GL_FASTEST"]],["sgl/gl"]],
["gl_feedback",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.F.E.E.D.B.A.C.K))",[0,[2,"GL_FEEDBACK"]],["sgl/gl"]],
["gl_feedback_buffer_pointer",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.F.E.E.D.B.A.C.K_.B.U.F.F.E.R_.P.O.I.N.T.E.R))",[0,[2,"GL_FEEDBACK_BUFFER_POINTER"]],["sgl/gl"]],
["gl_feedback_buffer_size",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.F.E.E.D.B.A.C.K_.B.U.F.F.E.R_.S.I.Z.E))",[0,[2,"GL_FEEDBACK_BUFFER_SIZE"]],["sgl/gl"]],
["gl_feedback_buffer_type",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.F.E.E.D.B.A.C.K_.B.U.F.F.E.R_.T.Y.P.E))",[0,[2,"GL_FEEDBACK_BUFFER_TYPE"]],["sgl/gl"]],
["gl_fill",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.F.I.L.L))",[0,[2,"GL_FILL"]],["sgl/gl"]],
["gl_flat",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.F.L.A.T))",[0,[2,"GL_FLAT"]],["sgl/gl"]],
["gl_float",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.F.L.O.A.T))",[0,[2,"GL_FLOAT"]],["sgl/gl"]],
["gl_fog",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.F.O.G))",[0,[2,"GL_FOG"]],["sgl/gl"]],
["gl_fog_bit",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.F.O.G_.B.I.T))",[0,[2,"GL_FOG_BIT"]],["sgl/gl"]],
["gl_fog_color",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.F.O.G_.C.O.L.O.R))",[0,[2,"GL_FOG_COLOR"]],["sgl/gl"]],
["gl_fog_coord",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.F.O.G_.C.O.O.R.D))",[0,[2,"GL_FOG_COORD"]],["sgl/gl"]],
["gl_fog_coord_array",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.F.O.G_.C.O.O.R.D_.A.R.R.A.Y))",[0,[2,"GL_FOG_COORD_ARRAY"]],["sgl/gl"]],
["gl_fog_coord_array_buffer_binding",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.F.O.G_.C.O.O.R.D_.A.R.R.A.Y_.B.U.F.F.E.R_.B.I.N.D.I.N.G))",[0,[2,"GL_FOG_COORD_ARRAY_BUFFER_BINDING"]],["sgl/gl"]],
["gl_fog_coord_array_pointer",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.F.O.G_.C.O.O.R.D_.A.R.R.A.Y_.P.O.I.N.T.E.R))",[0,[2,"GL_FOG_COORD_ARRAY_POINTER"]],["sgl/gl"]],
["gl_fog_coord_array_stride",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.F.O.G_.C.O.O.R.D_.A.R.R.A.Y_.S.T.R.I.D.E))",[0,[2,"GL_FOG_COORD_ARRAY_STRIDE"]],["sgl/gl"]],
["gl_fog_coord_array_type",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.F.O.G_.C.O.O.R.D_.A.R.R.A.Y_.T.Y.P.E))",[0,[2,"GL_FOG_COORD_ARRAY_TYPE"]],["sgl/gl"]],
["gl_fog_coord_src",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.F.O.G_.C.O.O.R.D_.S.R.C))",[0,[2,"GL_FOG_COORD_SRC"]],["sgl/gl"]],
["gl_fog_coordinate",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.F.O.G_.C.O.O.R.D.I.N.A.T.E))",[0,[2,"GL_FOG_COORDINATE"]],["sgl/gl"]],
["gl_fog_coordinate_array",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.F.O.G_.C.O.O.R.D.I.N.A.T.E_.A.R.R.A.Y))",[0,[2,"GL_FOG_COORDINATE_ARRAY"]],["sgl/gl"]],
["gl_fog_coordinate_array_buffer_binding",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.F.O.G_.C.O.O.R.D.I.N.A.T.E_.A.R.R.A.Y_.B.U.F.F.E.R_.B.I.N.D.I.N.G))",[0,[2,"GL_FOG_COORDINATE_ARRAY_BUFFER_BINDING"]],["sgl/gl"]],
["gl_fog_coordinate_array_pointer",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.F.O.G_.C.O.O.R.D.I.N.A.T.E_.A.R.R.A.Y_.P.O.I.N.T.E.R))",[0,[2,"GL_FOG_COORDINATE_ARRAY_POINTER"]],["sgl/gl"]],
["gl_fog_coordinate_array_stride",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.F.O.G_.C.O.O.R.D.I.N.A.T.E_.A.R.R.A.Y_.S.T.R.I.D.E))",[0,[2,"GL_FOG_COORDINATE_ARRAY_STRIDE"]],["sgl/gl"]],
["gl_fog_coordinate_array_type",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.F.O.G_.C.O.O.R.D.I.N.A.T.E_.A.R.R.A.Y_.T.Y.P.E))",[0,[2,"GL_FOG_COORDINATE_ARRAY_TYPE"]],["sgl/gl"]],
["gl_fog_coordinate_source",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.F.O.G_.C.O.O.R.D.I.N.A.T.E_.S.O.U.R.C.E))",[0,[2,"GL_FOG_COORDINATE_SOURCE"]],["sgl/gl"]],
["gl_fog_density",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.F.O.G_.D.E.N.S.I.T.Y))",[0,[2,"GL_FOG_DENSITY"]],["sgl/gl"]],
["gl_fog_end",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.F.O.G_.E.N.D))",[0,[2,"GL_FOG_END"]],["sgl/gl"]],
["gl_fog_hint",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.F.O.G_.H.I.N.T))",[0,[2,"GL_FOG_HINT"]],["sgl/gl"]],
["gl_fog_index",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.F.O.G_.I.N.D.E.X))",[0,[2,"GL_FOG_INDEX"]],["sgl/gl"]],
["gl_fog_mode",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.F.O.G_.M.O.D.E))",[0,[2,"GL_FOG_MODE"]],["sgl/gl"]],
["gl_fog_start",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.F.O.G_.S.T.A.R.T))",[0,[2,"GL_FOG_START"]],["sgl/gl"]],
["gl_fragment_depth",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.F.R.A.G.M.E.N.T_.D.E.P.T.H))",[0,[2,"GL_FRAGMENT_DEPTH"]],["sgl/gl"]],
["gl_front",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.F.R.O.N.T))",[0,[2,"GL_FRONT"]],["sgl/gl"]],
["gl_front_and_back",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.F.R.O.N.T_.A.N.D_.B.A.C.K))",[0,[2,"GL_FRONT_AND_BACK"]],["sgl/gl"]],
["gl_front_face",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.F.R.O.N.T_.F.A.C.E))",[0,[2,"GL_FRONT_FACE"]],["sgl/gl"]],
["gl_front_left",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.F.R.O.N.T_.L.E.F.T))",[0,[2,"GL_FRONT_LEFT"]],["sgl/gl"]],
["gl_front_right",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.F.R.O.N.T_.R.I.G.H.T))",[0,[2,"GL_FRONT_RIGHT"]],["sgl/gl"]],
["gl_func_add",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.F.U.N.C_.A.D.D))",[0,[2,"GL_FUNC_ADD"]],["sgl/gl"]],
["gl_func_reverse_subtract",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.F.U.N.C_.R.E.V.E.R.S.E_.S.U.B.T.R.A.C.T))",[0,[2,"GL_FUNC_REVERSE_SUBTRACT"]],["sgl/gl"]],
["gl_func_subtract",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.F.U.N.C_.S.U.B.T.R.A.C.T))",[0,[2,"GL_FUNC_SUBTRACT"]],["sgl/gl"]],
["gl_generate_mipmap",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.G.E.N.E.R.A.T.E_.M.I.P.M.A.P))",[0,[2,"GL_GENERATE_MIPMAP"]],["sgl/gl"]],
["gl_generate_mipmap_hint",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.G.E.N.E.R.A.T.E_.M.I.P.M.A.P_.H.I.N.T))",[0,[2,"GL_GENERATE_MIPMAP_HINT"]],["sgl/gl"]],
["gl_gequal",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.G.E.Q.U.A.L))",[0,[2,"GL_GEQUAL"]],["sgl/gl"]],
["gl_greater",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.G.R.E.A.T.E.R))",[0,[2,"GL_GREATER"]],["sgl/gl"]],
["gl_green",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.G.R.E.E.N))",[0,[2,"GL_GREEN"]],["sgl/gl"]],
["gl_green_bias",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.G.R.E.E.N_.B.I.A.S))",[0,[2,"GL_GREEN_BIAS"]],["sgl/gl"]],
["gl_green_bits",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.G.R.E.E.N_.B.I.T.S))",[0,[2,"GL_GREEN_BITS"]],["sgl/gl"]],
["gl_green_scale",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.G.R.E.E.N_.S.C.A.L.E))",[0,[2,"GL_GREEN_SCALE"]],["sgl/gl"]],
["gl_hint_bit",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.H.I.N.T_.B.I.T))",[0,[2,"GL_HINT_BIT"]],["sgl/gl"]],
["gl_histogram",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.H.I.S.T.O.G.R.A.M))",[0,[2,"GL_HISTOGRAM"]],["sgl/gl"]],
["gl_histogram_alpha_size",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.H.I.S.T.O.G.R.A.M_.A.L.P.H.A_.S.I.Z.E))",[0,[2,"GL_HISTOGRAM_ALPHA_SIZE"]],["sgl/gl"]],
["gl_histogram_blue_size",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.H.I.S.T.O.G.R.A.M_.B.L.U.E_.S.I.Z.E))",[0,[2,"GL_HISTOGRAM_BLUE_SIZE"]],["sgl/gl"]],
["gl_histogram_format",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.H.I.S.T.O.G.R.A.M_.F.O.R.M.A.T))",[0,[2,"GL_HISTOGRAM_FORMAT"]],["sgl/gl"]],
["gl_histogram_green_size",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.H.I.S.T.O.G.R.A.M_.G.R.E.E.N_.S.I.Z.E))",[0,[2,"GL_HISTOGRAM_GREEN_SIZE"]],["sgl/gl"]],
["gl_histogram_luminance_size",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.H.I.S.T.O.G.R.A.M_.L.U.M.I.N.A.N.C.E_.S.I.Z.E))",[0,[2,"GL_HISTOGRAM_LUMINANCE_SIZE"]],["sgl/gl"]],
["gl_histogram_red_size",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.H.I.S.T.O.G.R.A.M_.R.E.D_.S.I.Z.E))",[0,[2,"GL_HISTOGRAM_RED_SIZE"]],["sgl/gl"]],
["gl_histogram_sink",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.H.I.S.T.O.G.R.A.M_.S.I.N.K))",[0,[2,"GL_HISTOGRAM_SINK"]],["sgl/gl"]],
["gl_histogram_width",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.H.I.S.T.O.G.R.A.M_.W.I.D.T.H))",[0,[2,"GL_HISTOGRAM_WIDTH"]],["sgl/gl"]],
["gl_incr",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.I.N.C.R))",[0,[2,"GL_INCR"]],["sgl/gl"]],
["gl_incr_wrap",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.I.N.C.R_.W.R.A.P))",[0,[2,"GL_INCR_WRAP"]],["sgl/gl"]],
["gl_index_array",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.I.N.D.E.X_.A.R.R.A.Y))",[0,[2,"GL_INDEX_ARRAY"]],["sgl/gl"]],
["gl_index_array_buffer_binding",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.I.N.D.E.X_.A.R.R.A.Y_.B.U.F.F.E.R_.B.I.N.D.I.N.G))",[0,[2,"GL_INDEX_ARRAY_BUFFER_BINDING"]],["sgl/gl"]],
["gl_index_array_pointer",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.I.N.D.E.X_.A.R.R.A.Y_.P.O.I.N.T.E.R))",[0,[2,"GL_INDEX_ARRAY_POINTER"]],["sgl/gl"]],
["gl_index_array_stride",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.I.N.D.E.X_.A.R.R.A.Y_.S.T.R.I.D.E))",[0,[2,"GL_INDEX_ARRAY_STRIDE"]],["sgl/gl"]],
["gl_index_array_type",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.I.N.D.E.X_.A.R.R.A.Y_.T.Y.P.E))",[0,[2,"GL_INDEX_ARRAY_TYPE"]],["sgl/gl"]],
["gl_index_bits",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.I.N.D.E.X_.B.I.T.S))",[0,[2,"GL_INDEX_BITS"]],["sgl/gl"]],
["gl_index_clear_value",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.I.N.D.E.X_.C.L.E.A.R_.V.A.L.U.E))",[0,[2,"GL_INDEX_CLEAR_VALUE"]],["sgl/gl"]],
["gl_index_logic_op",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.I.N.D.E.X_.L.O.G.I.C_.O.P))",[0,[2,"GL_INDEX_LOGIC_OP"]],["sgl/gl"]],
["gl_index_mode",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.I.N.D.E.X_.M.O.D.E))",[0,[2,"GL_INDEX_MODE"]],["sgl/gl"]],
["gl_index_offset",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.I.N.D.E.X_.O.F.F.S.E.T))",[0,[2,"GL_INDEX_OFFSET"]],["sgl/gl"]],
["gl_index_shift",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.I.N.D.E.X_.S.H.I.F.T))",[0,[2,"GL_INDEX_SHIFT"]],["sgl/gl"]],
["gl_index_writemask",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.I.N.D.E.X_.W.R.I.T.E.M.A.S.K))",[0,[2,"GL_INDEX_WRITEMASK"]],["sgl/gl"]],
["gl_int",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.I.N.T))",[0,[2,"GL_INT"]],["sgl/gl"]],
["gl_intensity",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.I.N.T.E.N.S.I.T.Y))",[0,[2,"GL_INTENSITY"]],["sgl/gl"]],
["gl_intensity12",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.I.N.T.E.N.S.I.T.Y12))",[0,[2,"GL_INTENSITY12"]],["sgl/gl"]],
["gl_intensity16",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.I.N.T.E.N.S.I.T.Y16))",[0,[2,"GL_INTENSITY16"]],["sgl/gl"]],
["gl_intensity4",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.I.N.T.E.N.S.I.T.Y4))",[0,[2,"GL_INTENSITY4"]],["sgl/gl"]],
["gl_intensity8",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.I.N.T.E.N.S.I.T.Y8))",[0,[2,"GL_INTENSITY8"]],["sgl/gl"]],
["gl_interpolate",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.I.N.T.E.R.P.O.L.A.T.E))",[0,[2,"GL_INTERPOLATE"]],["sgl/gl"]],
["gl_invalid_enum",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.I.N.V.A.L.I.D_.E.N.U.M))",[0,[2,"GL_INVALID_ENUM"]],["sgl/gl"]],
["gl_invalid_operation",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.I.N.V.A.L.I.D_.O.P.E.R.A.T.I.O.N))",[0,[2,"GL_INVALID_OPERATION"]],["sgl/gl"]],
["gl_invalid_value",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.I.N.V.A.L.I.D_.V.A.L.U.E))",[0,[2,"GL_INVALID_VALUE"]],["sgl/gl"]],
["gl_invert",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.I.N.V.E.R.T))",[0,[2,"GL_INVERT"]],["sgl/gl"]],
["gl_keep",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.K.E.E.P))",[0,[2,"GL_KEEP"]],["sgl/gl"]],
["gl_left",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.E.F.T))",[0,[2,"GL_LEFT"]],["sgl/gl"]],
["gl_lequal",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.E.Q.U.A.L))",[0,[2,"GL_LEQUAL"]],["sgl/gl"]],
["gl_less",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.E.S.S))",[0,[2,"GL_LESS"]],["sgl/gl"]],
["gl_light0",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.I.G.H.T0))",[0,[2,"GL_LIGHT0"]],["sgl/gl"]],
["gl_light1",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.I.G.H.T1))",[0,[2,"GL_LIGHT1"]],["sgl/gl"]],
["gl_light2",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.I.G.H.T2))",[0,[2,"GL_LIGHT2"]],["sgl/gl"]],
["gl_light3",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.I.G.H.T3))",[0,[2,"GL_LIGHT3"]],["sgl/gl"]],
["gl_light4",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.I.G.H.T4))",[0,[2,"GL_LIGHT4"]],["sgl/gl"]],
["gl_light5",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.I.G.H.T5))",[0,[2,"GL_LIGHT5"]],["sgl/gl"]],
["gl_light6",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.I.G.H.T6))",[0,[2,"GL_LIGHT6"]],["sgl/gl"]],
["gl_light7",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.I.G.H.T7))",[0,[2,"GL_LIGHT7"]],["sgl/gl"]],
["gl_light_model_ambient",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.I.G.H.T_.M.O.D.E.L_.A.M.B.I.E.N.T))",[0,[2,"GL_LIGHT_MODEL_AMBIENT"]],["sgl/gl"]],
["gl_light_model_color_control",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.I.G.H.T_.M.O.D.E.L_.C.O.L.O.R_.C.O.N.T.R.O.L))",[0,[2,"GL_LIGHT_MODEL_COLOR_CONTROL"]],["sgl/gl"]],
["gl_light_model_local_viewer",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.I.G.H.T_.M.O.D.E.L_.L.O.C.A.L_.V.I.E.W.E.R))",[0,[2,"GL_LIGHT_MODEL_LOCAL_VIEWER"]],["sgl/gl"]],
["gl_light_model_two_side",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.I.G.H.T_.M.O.D.E.L_.T.W.O_.S.I.D.E))",[0,[2,"GL_LIGHT_MODEL_TWO_SIDE"]],["sgl/gl"]],
["gl_lighting",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.I.G.H.T.I.N.G))",[0,[2,"GL_LIGHTING"]],["sgl/gl"]],
["gl_lighting_bit",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.I.G.H.T.I.N.G_.B.I.T))",[0,[2,"GL_LIGHTING_BIT"]],["sgl/gl"]],
["gl_line",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.I.N.E))",[0,[2,"GL_LINE"]],["sgl/gl"]],
["gl_line_bit",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.I.N.E_.B.I.T))",[0,[2,"GL_LINE_BIT"]],["sgl/gl"]],
["gl_line_loop",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.I.N.E_.L.O.O.P))",[0,[2,"GL_LINE_LOOP"]],["sgl/gl"]],
["gl_line_reset_token",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.I.N.E_.R.E.S.E.T_.T.O.K.E.N))",[0,[2,"GL_LINE_RESET_TOKEN"]],["sgl/gl"]],
["gl_line_smooth",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.I.N.E_.S.M.O.O.T.H))",[0,[2,"GL_LINE_SMOOTH"]],["sgl/gl"]],
["gl_line_smooth_hint",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.I.N.E_.S.M.O.O.T.H_.H.I.N.T))",[0,[2,"GL_LINE_SMOOTH_HINT"]],["sgl/gl"]],
["gl_line_stipple",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.I.N.E_.S.T.I.P.P.L.E))",[0,[2,"GL_LINE_STIPPLE"]],["sgl/gl"]],
["gl_line_stipple_pattern",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.I.N.E_.S.T.I.P.P.L.E_.P.A.T.T.E.R.N))",[0,[2,"GL_LINE_STIPPLE_PATTERN"]],["sgl/gl"]],
["gl_line_stipple_repeat",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.I.N.E_.S.T.I.P.P.L.E_.R.E.P.E.A.T))",[0,[2,"GL_LINE_STIPPLE_REPEAT"]],["sgl/gl"]],
["gl_line_strip",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.I.N.E_.S.T.R.I.P))",[0,[2,"GL_LINE_STRIP"]],["sgl/gl"]],
["gl_line_token",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.I.N.E_.T.O.K.E.N))",[0,[2,"GL_LINE_TOKEN"]],["sgl/gl"]],
["gl_line_width",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.I.N.E_.W.I.D.T.H))",[0,[2,"GL_LINE_WIDTH"]],["sgl/gl"]],
["gl_line_width_granularity",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.I.N.E_.W.I.D.T.H_.G.R.A.N.U.L.A.R.I.T.Y))",[0,[2,"GL_LINE_WIDTH_GRANULARITY"]],["sgl/gl"]],
["gl_line_width_range",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.I.N.E_.W.I.D.T.H_.R.A.N.G.E))",[0,[2,"GL_LINE_WIDTH_RANGE"]],["sgl/gl"]],
["gl_linear",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.I.N.E.A.R))",[0,[2,"GL_LINEAR"]],["sgl/gl"]],
["gl_linear_attenuation",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.I.N.E.A.R_.A.T.T.E.N.U.A.T.I.O.N))",[0,[2,"GL_LINEAR_ATTENUATION"]],["sgl/gl"]],
["gl_linear_mipmap_linear",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.I.N.E.A.R_.M.I.P.M.A.P_.L.I.N.E.A.R))",[0,[2,"GL_LINEAR_MIPMAP_LINEAR"]],["sgl/gl"]],
["gl_linear_mipmap_nearest",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.I.N.E.A.R_.M.I.P.M.A.P_.N.E.A.R.E.S.T))",[0,[2,"GL_LINEAR_MIPMAP_NEAREST"]],["sgl/gl"]],
["gl_lines",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.I.N.E.S))",[0,[2,"GL_LINES"]],["sgl/gl"]],
["gl_list_base",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.I.S.T_.B.A.S.E))",[0,[2,"GL_LIST_BASE"]],["sgl/gl"]],
["gl_list_bit",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.I.S.T_.B.I.T))",[0,[2,"GL_LIST_BIT"]],["sgl/gl"]],
["gl_list_index",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.I.S.T_.I.N.D.E.X))",[0,[2,"GL_LIST_INDEX"]],["sgl/gl"]],
["gl_list_mode",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.I.S.T_.M.O.D.E))",[0,[2,"GL_LIST_MODE"]],["sgl/gl"]],
["gl_load",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.O.A.D))",[0,[2,"GL_LOAD"]],["sgl/gl"]],
["gl_logic_op",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.O.G.I.C_.O.P))",[0,[2,"GL_LOGIC_OP"]],["sgl/gl"]],
["gl_logic_op_mode",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.O.G.I.C_.O.P_.M.O.D.E))",[0,[2,"GL_LOGIC_OP_MODE"]],["sgl/gl"]],
["gl_luminance",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.U.M.I.N.A.N.C.E))",[0,[2,"GL_LUMINANCE"]],["sgl/gl"]],
["gl_luminance12",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.U.M.I.N.A.N.C.E12))",[0,[2,"GL_LUMINANCE12"]],["sgl/gl"]],
["gl_luminance12_alpha12",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.U.M.I.N.A.N.C.E12_.A.L.P.H.A12))",[0,[2,"GL_LUMINANCE12_ALPHA12"]],["sgl/gl"]],
["gl_luminance12_alpha4",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.U.M.I.N.A.N.C.E12_.A.L.P.H.A4))",[0,[2,"GL_LUMINANCE12_ALPHA4"]],["sgl/gl"]],
["gl_luminance16",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.U.M.I.N.A.N.C.E16))",[0,[2,"GL_LUMINANCE16"]],["sgl/gl"]],
["gl_luminance16_alpha16",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.U.M.I.N.A.N.C.E16_.A.L.P.H.A16))",[0,[2,"GL_LUMINANCE16_ALPHA16"]],["sgl/gl"]],
["gl_luminance4",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.U.M.I.N.A.N.C.E4))",[0,[2,"GL_LUMINANCE4"]],["sgl/gl"]],
["gl_luminance4_alpha4",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.U.M.I.N.A.N.C.E4_.A.L.P.H.A4))",[0,[2,"GL_LUMINANCE4_ALPHA4"]],["sgl/gl"]],
["gl_luminance6_alpha2",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.U.M.I.N.A.N.C.E6_.A.L.P.H.A2))",[0,[2,"GL_LUMINANCE6_ALPHA2"]],["sgl/gl"]],
["gl_luminance8",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.U.M.I.N.A.N.C.E8))",[0,[2,"GL_LUMINANCE8"]],["sgl/gl"]],
["gl_luminance8_alpha8",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.U.M.I.N.A.N.C.E8_.A.L.P.H.A8))",[0,[2,"GL_LUMINANCE8_ALPHA8"]],["sgl/gl"]],
["gl_luminance_alpha",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.L.U.M.I.N.A.N.C.E_.A.L.P.H.A))",[0,[2,"GL_LUMINANCE_ALPHA"]],["sgl/gl"]],
["gl_map1_color_4",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.A.P1_.C.O.L.O.R_4))",[0,[2,"GL_MAP1_COLOR_4"]],["sgl/gl"]],
["gl_map1_grid_domain",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.A.P1_.G.R.I.D_.D.O.M.A.I.N))",[0,[2,"GL_MAP1_GRID_DOMAIN"]],["sgl/gl"]],
["gl_map1_grid_segments",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.A.P1_.G.R.I.D_.S.E.G.M.E.N.T.S))",[0,[2,"GL_MAP1_GRID_SEGMENTS"]],["sgl/gl"]],
["gl_map1_index",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.A.P1_.I.N.D.E.X))",[0,[2,"GL_MAP1_INDEX"]],["sgl/gl"]],
["gl_map1_normal",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.A.P1_.N.O.R.M.A.L))",[0,[2,"GL_MAP1_NORMAL"]],["sgl/gl"]],
["gl_map1_texture_coord_1",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.A.P1_.T.E.X.T.U.R.E_.C.O.O.R.D_1))",[0,[2,"GL_MAP1_TEXTURE_COORD_1"]],["sgl/gl"]],
["gl_map1_texture_coord_2",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.A.P1_.T.E.X.T.U.R.E_.C.O.O.R.D_2))",[0,[2,"GL_MAP1_TEXTURE_COORD_2"]],["sgl/gl"]],
["gl_map1_texture_coord_3",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.A.P1_.T.E.X.T.U.R.E_.C.O.O.R.D_3))",[0,[2,"GL_MAP1_TEXTURE_COORD_3"]],["sgl/gl"]],
["gl_map1_texture_coord_4",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.A.P1_.T.E.X.T.U.R.E_.C.O.O.R.D_4))",[0,[2,"GL_MAP1_TEXTURE_COORD_4"]],["sgl/gl"]],
["gl_map1_vertex_3",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.A.P1_.V.E.R.T.E.X_3))",[0,[2,"GL_MAP1_VERTEX_3"]],["sgl/gl"]],
["gl_map1_vertex_4",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.A.P1_.V.E.R.T.E.X_4))",[0,[2,"GL_MAP1_VERTEX_4"]],["sgl/gl"]],
["gl_map2_color_4",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.A.P2_.C.O.L.O.R_4))",[0,[2,"GL_MAP2_COLOR_4"]],["sgl/gl"]],
["gl_map2_grid_domain",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.A.P2_.G.R.I.D_.D.O.M.A.I.N))",[0,[2,"GL_MAP2_GRID_DOMAIN"]],["sgl/gl"]],
["gl_map2_grid_segments",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.A.P2_.G.R.I.D_.S.E.G.M.E.N.T.S))",[0,[2,"GL_MAP2_GRID_SEGMENTS"]],["sgl/gl"]],
["gl_map2_index",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.A.P2_.I.N.D.E.X))",[0,[2,"GL_MAP2_INDEX"]],["sgl/gl"]],
["gl_map2_normal",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.A.P2_.N.O.R.M.A.L))",[0,[2,"GL_MAP2_NORMAL"]],["sgl/gl"]],
["gl_map2_texture_coord_1",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.A.P2_.T.E.X.T.U.R.E_.C.O.O.R.D_1))",[0,[2,"GL_MAP2_TEXTURE_COORD_1"]],["sgl/gl"]],
["gl_map2_texture_coord_2",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.A.P2_.T.E.X.T.U.R.E_.C.O.O.R.D_2))",[0,[2,"GL_MAP2_TEXTURE_COORD_2"]],["sgl/gl"]],
["gl_map2_texture_coord_3",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.A.P2_.T.E.X.T.U.R.E_.C.O.O.R.D_3))",[0,[2,"GL_MAP2_TEXTURE_COORD_3"]],["sgl/gl"]],
["gl_map2_texture_coord_4",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.A.P2_.T.E.X.T.U.R.E_.C.O.O.R.D_4))",[0,[2,"GL_MAP2_TEXTURE_COORD_4"]],["sgl/gl"]],
["gl_map2_vertex_3",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.A.P2_.V.E.R.T.E.X_3))",[0,[2,"GL_MAP2_VERTEX_3"]],["sgl/gl"]],
["gl_map2_vertex_4",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.A.P2_.V.E.R.T.E.X_4))",[0,[2,"GL_MAP2_VERTEX_4"]],["sgl/gl"]],
["gl_map_color",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.A.P_.C.O.L.O.R))",[0,[2,"GL_MAP_COLOR"]],["sgl/gl"]],
["gl_map_stencil",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.A.P_.S.T.E.N.C.I.L))",[0,[2,"GL_MAP_STENCIL"]],["sgl/gl"]],
["gl_matrix_mode",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.A.T.R.I.X_.M.O.D.E))",[0,[2,"GL_MATRIX_MODE"]],["sgl/gl"]],
["gl_max",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.A.X))",[0,[2,"GL_MAX"]],["sgl/gl"]],
["gl_max_3d_texture_size",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.A.X_3.D_.T.E.X.T.U.R.E_.S.I.Z.E))",[0,[2,"GL_MAX_3D_TEXTURE_SIZE"]],["sgl/gl"]],
["gl_max_attrib_stack_depth",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.A.X_.A.T.T.R.I.B_.S.T.A.C.K_.D.E.P.T.H))",[0,[2,"GL_MAX_ATTRIB_STACK_DEPTH"]],["sgl/gl"]],
["gl_max_client_attrib_stack_depth",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.A.X_.C.L.I.E.N.T_.A.T.T.R.I.B_.S.T.A.C.K_.D.E.P.T.H))",[0,[2,"GL_MAX_CLIENT_ATTRIB_STACK_DEPTH"]],["sgl/gl"]],
["gl_max_clip_planes",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.A.X_.C.L.I.P_.P.L.A.N.E.S))",[0,[2,"GL_MAX_CLIP_PLANES"]],["sgl/gl"]],
["gl_max_color_matrix_stack_depth",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.A.X_.C.O.L.O.R_.M.A.T.R.I.X_.S.T.A.C.K_.D.E.P.T.H))",[0,[2,"GL_MAX_COLOR_MATRIX_STACK_DEPTH"]],["sgl/gl"]],
["gl_max_convolution_height",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.A.X_.C.O.N.V.O.L.U.T.I.O.N_.H.E.I.G.H.T))",[0,[2,"GL_MAX_CONVOLUTION_HEIGHT"]],["sgl/gl"]],
["gl_max_convolution_width",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.A.X_.C.O.N.V.O.L.U.T.I.O.N_.W.I.D.T.H))",[0,[2,"GL_MAX_CONVOLUTION_WIDTH"]],["sgl/gl"]],
["gl_max_cube_map_texture_size",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.A.X_.C.U.B.E_.M.A.P_.T.E.X.T.U.R.E_.S.I.Z.E))",[0,[2,"GL_MAX_CUBE_MAP_TEXTURE_SIZE"]],["sgl/gl"]],
["gl_max_elements_indices",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.A.X_.E.L.E.M.E.N.T.S_.I.N.D.I.C.E.S))",[0,[2,"GL_MAX_ELEMENTS_INDICES"]],["sgl/gl"]],
["gl_max_elements_vertices",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.A.X_.E.L.E.M.E.N.T.S_.V.E.R.T.I.C.E.S))",[0,[2,"GL_MAX_ELEMENTS_VERTICES"]],["sgl/gl"]],
["gl_max_eval_order",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.A.X_.E.V.A.L_.O.R.D.E.R))",[0,[2,"GL_MAX_EVAL_ORDER"]],["sgl/gl"]],
["gl_max_lights",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.A.X_.L.I.G.H.T.S))",[0,[2,"GL_MAX_LIGHTS"]],["sgl/gl"]],
["gl_max_list_nesting",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.A.X_.L.I.S.T_.N.E.S.T.I.N.G))",[0,[2,"GL_MAX_LIST_NESTING"]],["sgl/gl"]],
["gl_max_modelview_stack_depth",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.A.X_.M.O.D.E.L.V.I.E.W_.S.T.A.C.K_.D.E.P.T.H))",[0,[2,"GL_MAX_MODELVIEW_STACK_DEPTH"]],["sgl/gl"]],
["gl_max_name_stack_depth",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.A.X_.N.A.M.E_.S.T.A.C.K_.D.E.P.T.H))",[0,[2,"GL_MAX_NAME_STACK_DEPTH"]],["sgl/gl"]],
["gl_max_pixel_map_table",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.A.X_.P.I.X.E.L_.M.A.P_.T.A.B.L.E))",[0,[2,"GL_MAX_PIXEL_MAP_TABLE"]],["sgl/gl"]],
["gl_max_projection_stack_depth",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.A.X_.P.R.O.J.E.C.T.I.O.N_.S.T.A.C.K_.D.E.P.T.H))",[0,[2,"GL_MAX_PROJECTION_STACK_DEPTH"]],["sgl/gl"]],
["gl_max_texture_lod_bias",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.A.X_.T.E.X.T.U.R.E_.L.O.D_.B.I.A.S))",[0,[2,"GL_MAX_TEXTURE_LOD_BIAS"]],["sgl/gl"]],
["gl_max_texture_size",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.A.X_.T.E.X.T.U.R.E_.S.I.Z.E))",[0,[2,"GL_MAX_TEXTURE_SIZE"]],["sgl/gl"]],
["gl_max_texture_stack_depth",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.A.X_.T.E.X.T.U.R.E_.S.T.A.C.K_.D.E.P.T.H))",[0,[2,"GL_MAX_TEXTURE_STACK_DEPTH"]],["sgl/gl"]],
["gl_max_texture_units",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.A.X_.T.E.X.T.U.R.E_.U.N.I.T.S))",[0,[2,"GL_MAX_TEXTURE_UNITS"]],["sgl/gl"]],
["gl_max_viewport_dims",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.A.X_.V.I.E.W.P.O.R.T_.D.I.M.S))",[0,[2,"GL_MAX_VIEWPORT_DIMS"]],["sgl/gl"]],
["gl_min",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.I.N))",[0,[2,"GL_MIN"]],["sgl/gl"]],
["gl_minmax",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.I.N.M.A.X))",[0,[2,"GL_MINMAX"]],["sgl/gl"]],
["gl_minmax_format",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.I.N.M.A.X_.F.O.R.M.A.T))",[0,[2,"GL_MINMAX_FORMAT"]],["sgl/gl"]],
["gl_minmax_sink",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.I.N.M.A.X_.S.I.N.K))",[0,[2,"GL_MINMAX_SINK"]],["sgl/gl"]],
["gl_mirrored_repeat",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.I.R.R.O.R.E.D_.R.E.P.E.A.T))",[0,[2,"GL_MIRRORED_REPEAT"]],["sgl/gl"]],
["gl_modelview",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.O.D.E.L.V.I.E.W))",[0,[2,"GL_MODELVIEW"]],["sgl/gl"]],
["gl_modelview_matrix",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.O.D.E.L.V.I.E.W_.M.A.T.R.I.X))",[0,[2,"GL_MODELVIEW_MATRIX"]],["sgl/gl"]],
["gl_modelview_stack_depth",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.O.D.E.L.V.I.E.W_.S.T.A.C.K_.D.E.P.T.H))",[0,[2,"GL_MODELVIEW_STACK_DEPTH"]],["sgl/gl"]],
["gl_modulate",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.O.D.U.L.A.T.E))",[0,[2,"GL_MODULATE"]],["sgl/gl"]],
["gl_mult",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.U.L.T))",[0,[2,"GL_MULT"]],["sgl/gl"]],
["gl_multisample",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.U.L.T.I.S.A.M.P.L.E))",[0,[2,"GL_MULTISAMPLE"]],["sgl/gl"]],
["gl_multisample_bit",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.M.U.L.T.I.S.A.M.P.L.E_.B.I.T))",[0,[2,"GL_MULTISAMPLE_BIT"]],["sgl/gl"]],
["gl_n3f_v3f",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.N3.F_.V3.F))",[0,[2,"GL_N3F_V3F"]],["sgl/gl"]],
["gl_name_stack_depth",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.N.A.M.E_.S.T.A.C.K_.D.E.P.T.H))",[0,[2,"GL_NAME_STACK_DEPTH"]],["sgl/gl"]],
["gl_nand",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.N.A.N.D))",[0,[2,"GL_NAND"]],["sgl/gl"]],
["gl_nearest",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.N.E.A.R.E.S.T))",[0,[2,"GL_NEAREST"]],["sgl/gl"]],
["gl_nearest_mipmap_linear",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.N.E.A.R.E.S.T_.M.I.P.M.A.P_.L.I.N.E.A.R))",[0,[2,"GL_NEAREST_MIPMAP_LINEAR"]],["sgl/gl"]],
["gl_nearest_mipmap_nearest",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.N.E.A.R.E.S.T_.M.I.P.M.A.P_.N.E.A.R.E.S.T))",[0,[2,"GL_NEAREST_MIPMAP_NEAREST"]],["sgl/gl"]],
["gl_never",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.N.E.V.E.R))",[0,[2,"GL_NEVER"]],["sgl/gl"]],
["gl_nicest",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.N.I.C.E.S.T))",[0,[2,"GL_NICEST"]],["sgl/gl"]],
["gl_no_error",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.N.O_.E.R.R.O.R))",[0,[2,"GL_NO_ERROR"]],["sgl/gl"]],
["gl_none",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.N.O.N.E))",[0,[2,"GL_NONE"]],["sgl/gl"]],
["gl_noop",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.N.O.O.P))",[0,[2,"GL_NOOP"]],["sgl/gl"]],
["gl_nor",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.N.O.R))",[0,[2,"GL_NOR"]],["sgl/gl"]],
["gl_normal_array",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.N.O.R.M.A.L_.A.R.R.A.Y))",[0,[2,"GL_NORMAL_ARRAY"]],["sgl/gl"]],
["gl_normal_array_buffer_binding",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.N.O.R.M.A.L_.A.R.R.A.Y_.B.U.F.F.E.R_.B.I.N.D.I.N.G))",[0,[2,"GL_NORMAL_ARRAY_BUFFER_BINDING"]],["sgl/gl"]],
["gl_normal_array_pointer",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.N.O.R.M.A.L_.A.R.R.A.Y_.P.O.I.N.T.E.R))",[0,[2,"GL_NORMAL_ARRAY_POINTER"]],["sgl/gl"]],
["gl_normal_array_stride",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.N.O.R.M.A.L_.A.R.R.A.Y_.S.T.R.I.D.E))",[0,[2,"GL_NORMAL_ARRAY_STRIDE"]],["sgl/gl"]],
["gl_normal_array_type",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.N.O.R.M.A.L_.A.R.R.A.Y_.T.Y.P.E))",[0,[2,"GL_NORMAL_ARRAY_TYPE"]],["sgl/gl"]],
["gl_normal_map",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.N.O.R.M.A.L_.M.A.P))",[0,[2,"GL_NORMAL_MAP"]],["sgl/gl"]],
["gl_normalize",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.N.O.R.M.A.L.I.Z.E))",[0,[2,"GL_NORMALIZE"]],["sgl/gl"]],
["gl_notequal",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.N.O.T.E.Q.U.A.L))",[0,[2,"GL_NOTEQUAL"]],["sgl/gl"]],
["gl_num_compressed_texture_formats",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.N.U.M_.C.O.M.P.R.E.S.S.E.D_.T.E.X.T.U.R.E_.F.O.R.M.A.T.S))",[0,[2,"GL_NUM_COMPRESSED_TEXTURE_FORMATS"]],["sgl/gl"]],
["gl_object_linear",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.O.B.J.E.C.T_.L.I.N.E.A.R))",[0,[2,"GL_OBJECT_LINEAR"]],["sgl/gl"]],
["gl_object_plane",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.O.B.J.E.C.T_.P.L.A.N.E))",[0,[2,"GL_OBJECT_PLANE"]],["sgl/gl"]],
["gl_one",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.O.N.E))",[0,[2,"GL_ONE"]],["sgl/gl"]],
["gl_one_minus_constant_alpha",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.O.N.E_.M.I.N.U.S_.C.O.N.S.T.A.N.T_.A.L.P.H.A))",[0,[2,"GL_ONE_MINUS_CONSTANT_ALPHA"]],["sgl/gl"]],
["gl_one_minus_constant_color",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.O.N.E_.M.I.N.U.S_.C.O.N.S.T.A.N.T_.C.O.L.O.R))",[0,[2,"GL_ONE_MINUS_CONSTANT_COLOR"]],["sgl/gl"]],
["gl_one_minus_dst_alpha",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.O.N.E_.M.I.N.U.S_.D.S.T_.A.L.P.H.A))",[0,[2,"GL_ONE_MINUS_DST_ALPHA"]],["sgl/gl"]],
["gl_one_minus_dst_color",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.O.N.E_.M.I.N.U.S_.D.S.T_.C.O.L.O.R))",[0,[2,"GL_ONE_MINUS_DST_COLOR"]],["sgl/gl"]],
["gl_one_minus_src_alpha",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.O.N.E_.M.I.N.U.S_.S.R.C_.A.L.P.H.A))",[0,[2,"GL_ONE_MINUS_SRC_ALPHA"]],["sgl/gl"]],
["gl_one_minus_src_color",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.O.N.E_.M.I.N.U.S_.S.R.C_.C.O.L.O.R))",[0,[2,"GL_ONE_MINUS_SRC_COLOR"]],["sgl/gl"]],
["gl_operand0_alpha",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.O.P.E.R.A.N.D0_.A.L.P.H.A))",[0,[2,"GL_OPERAND0_ALPHA"]],["sgl/gl"]],
["gl_operand0_rgb",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.O.P.E.R.A.N.D0_.R.G.B))",[0,[2,"GL_OPERAND0_RGB"]],["sgl/gl"]],
["gl_operand1_alpha",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.O.P.E.R.A.N.D1_.A.L.P.H.A))",[0,[2,"GL_OPERAND1_ALPHA"]],["sgl/gl"]],
["gl_operand1_rgb",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.O.P.E.R.A.N.D1_.R.G.B))",[0,[2,"GL_OPERAND1_RGB"]],["sgl/gl"]],
["gl_operand2_alpha",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.O.P.E.R.A.N.D2_.A.L.P.H.A))",[0,[2,"GL_OPERAND2_ALPHA"]],["sgl/gl"]],
["gl_operand2_rgb",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.O.P.E.R.A.N.D2_.R.G.B))",[0,[2,"GL_OPERAND2_RGB"]],["sgl/gl"]],
["gl_or",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.O.R))",[0,[2,"GL_OR"]],["sgl/gl"]],
["gl_or_inverted",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.O.R_.I.N.V.E.R.T.E.D))",[0,[2,"GL_OR_INVERTED"]],["sgl/gl"]],
["gl_or_reverse",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.O.R_.R.E.V.E.R.S.E))",[0,[2,"GL_OR_REVERSE"]],["sgl/gl"]],
["gl_order",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.O.R.D.E.R))",[0,[2,"GL_ORDER"]],["sgl/gl"]],
["gl_out_of_memory",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.O.U.T_.O.F_.M.E.M.O.R.Y))",[0,[2,"GL_OUT_OF_MEMORY"]],["sgl/gl"]],
["gl_pack_alignment",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.A.C.K_.A.L.I.G.N.M.E.N.T))",[0,[2,"GL_PACK_ALIGNMENT"]],["sgl/gl"]],
["gl_pack_image_height",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.A.C.K_.I.M.A.G.E_.H.E.I.G.H.T))",[0,[2,"GL_PACK_IMAGE_HEIGHT"]],["sgl/gl"]],
["gl_pack_lsb_first",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.A.C.K_.L.S.B_.F.I.R.S.T))",[0,[2,"GL_PACK_LSB_FIRST"]],["sgl/gl"]],
["gl_pack_row_length",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.A.C.K_.R.O.W_.L.E.N.G.T.H))",[0,[2,"GL_PACK_ROW_LENGTH"]],["sgl/gl"]],
["gl_pack_skip_images",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.A.C.K_.S.K.I.P_.I.M.A.G.E.S))",[0,[2,"GL_PACK_SKIP_IMAGES"]],["sgl/gl"]],
["gl_pack_skip_pixels",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.A.C.K_.S.K.I.P_.P.I.X.E.L.S))",[0,[2,"GL_PACK_SKIP_PIXELS"]],["sgl/gl"]],
["gl_pack_skip_rows",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.A.C.K_.S.K.I.P_.R.O.W.S))",[0,[2,"GL_PACK_SKIP_ROWS"]],["sgl/gl"]],
["gl_pack_swap_bytes",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.A.C.K_.S.W.A.P_.B.Y.T.E.S))",[0,[2,"GL_PACK_SWAP_BYTES"]],["sgl/gl"]],
["gl_pass_through_token",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.A.S.S_.T.H.R.O.U.G.H_.T.O.K.E.N))",[0,[2,"GL_PASS_THROUGH_TOKEN"]],["sgl/gl"]],
["gl_perspective_correction_hint",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.E.R.S.P.E.C.T.I.V.E_.C.O.R.R.E.C.T.I.O.N_.H.I.N.T))",[0,[2,"GL_PERSPECTIVE_CORRECTION_HINT"]],["sgl/gl"]],
["gl_pixel_map_a_to_a",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.I.X.E.L_.M.A.P_.A_.T.O_.A))",[0,[2,"GL_PIXEL_MAP_A_TO_A"]],["sgl/gl"]],
["gl_pixel_map_a_to_a_size",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.I.X.E.L_.M.A.P_.A_.T.O_.A_.S.I.Z.E))",[0,[2,"GL_PIXEL_MAP_A_TO_A_SIZE"]],["sgl/gl"]],
["gl_pixel_map_b_to_b",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.I.X.E.L_.M.A.P_.B_.T.O_.B))",[0,[2,"GL_PIXEL_MAP_B_TO_B"]],["sgl/gl"]],
["gl_pixel_map_b_to_b_size",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.I.X.E.L_.M.A.P_.B_.T.O_.B_.S.I.Z.E))",[0,[2,"GL_PIXEL_MAP_B_TO_B_SIZE"]],["sgl/gl"]],
["gl_pixel_map_g_to_g",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.I.X.E.L_.M.A.P_.G_.T.O_.G))",[0,[2,"GL_PIXEL_MAP_G_TO_G"]],["sgl/gl"]],
["gl_pixel_map_g_to_g_size",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.I.X.E.L_.M.A.P_.G_.T.O_.G_.S.I.Z.E))",[0,[2,"GL_PIXEL_MAP_G_TO_G_SIZE"]],["sgl/gl"]],
["gl_pixel_map_i_to_a",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.I.X.E.L_.M.A.P_.I_.T.O_.A))",[0,[2,"GL_PIXEL_MAP_I_TO_A"]],["sgl/gl"]],
["gl_pixel_map_i_to_a_size",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.I.X.E.L_.M.A.P_.I_.T.O_.A_.S.I.Z.E))",[0,[2,"GL_PIXEL_MAP_I_TO_A_SIZE"]],["sgl/gl"]],
["gl_pixel_map_i_to_b",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.I.X.E.L_.M.A.P_.I_.T.O_.B))",[0,[2,"GL_PIXEL_MAP_I_TO_B"]],["sgl/gl"]],
["gl_pixel_map_i_to_b_size",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.I.X.E.L_.M.A.P_.I_.T.O_.B_.S.I.Z.E))",[0,[2,"GL_PIXEL_MAP_I_TO_B_SIZE"]],["sgl/gl"]],
["gl_pixel_map_i_to_g",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.I.X.E.L_.M.A.P_.I_.T.O_.G))",[0,[2,"GL_PIXEL_MAP_I_TO_G"]],["sgl/gl"]],
["gl_pixel_map_i_to_g_size",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.I.X.E.L_.M.A.P_.I_.T.O_.G_.S.I.Z.E))",[0,[2,"GL_PIXEL_MAP_I_TO_G_SIZE"]],["sgl/gl"]],
["gl_pixel_map_i_to_i",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.I.X.E.L_.M.A.P_.I_.T.O_.I))",[0,[2,"GL_PIXEL_MAP_I_TO_I"]],["sgl/gl"]],
["gl_pixel_map_i_to_i_size",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.I.X.E.L_.M.A.P_.I_.T.O_.I_.S.I.Z.E))",[0,[2,"GL_PIXEL_MAP_I_TO_I_SIZE"]],["sgl/gl"]],
["gl_pixel_map_i_to_r",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.I.X.E.L_.M.A.P_.I_.T.O_.R))",[0,[2,"GL_PIXEL_MAP_I_TO_R"]],["sgl/gl"]],
["gl_pixel_map_i_to_r_size",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.I.X.E.L_.M.A.P_.I_.T.O_.R_.S.I.Z.E))",[0,[2,"GL_PIXEL_MAP_I_TO_R_SIZE"]],["sgl/gl"]],
["gl_pixel_map_r_to_r",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.I.X.E.L_.M.A.P_.R_.T.O_.R))",[0,[2,"GL_PIXEL_MAP_R_TO_R"]],["sgl/gl"]],
["gl_pixel_map_r_to_r_size",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.I.X.E.L_.M.A.P_.R_.T.O_.R_.S.I.Z.E))",[0,[2,"GL_PIXEL_MAP_R_TO_R_SIZE"]],["sgl/gl"]],
["gl_pixel_map_s_to_s",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.I.X.E.L_.M.A.P_.S_.T.O_.S))",[0,[2,"GL_PIXEL_MAP_S_TO_S"]],["sgl/gl"]],
["gl_pixel_map_s_to_s_size",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.I.X.E.L_.M.A.P_.S_.T.O_.S_.S.I.Z.E))",[0,[2,"GL_PIXEL_MAP_S_TO_S_SIZE"]],["sgl/gl"]],
["gl_pixel_mode_bit",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.I.X.E.L_.M.O.D.E_.B.I.T))",[0,[2,"GL_PIXEL_MODE_BIT"]],["sgl/gl"]],
["gl_point",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.O.I.N.T))",[0,[2,"GL_POINT"]],["sgl/gl"]],
["gl_point_bit",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.O.I.N.T_.B.I.T))",[0,[2,"GL_POINT_BIT"]],["sgl/gl"]],
["gl_point_distance_attenuation",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.O.I.N.T_.D.I.S.T.A.N.C.E_.A.T.T.E.N.U.A.T.I.O.N))",[0,[2,"GL_POINT_DISTANCE_ATTENUATION"]],["sgl/gl"]],
["gl_point_fade_threshold_size",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.O.I.N.T_.F.A.D.E_.T.H.R.E.S.H.O.L.D_.S.I.Z.E))",[0,[2,"GL_POINT_FADE_THRESHOLD_SIZE"]],["sgl/gl"]],
["gl_point_size",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.O.I.N.T_.S.I.Z.E))",[0,[2,"GL_POINT_SIZE"]],["sgl/gl"]],
["gl_point_size_granularity",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.O.I.N.T_.S.I.Z.E_.G.R.A.N.U.L.A.R.I.T.Y))",[0,[2,"GL_POINT_SIZE_GRANULARITY"]],["sgl/gl"]],
["gl_point_size_max",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.O.I.N.T_.S.I.Z.E_.M.A.X))",[0,[2,"GL_POINT_SIZE_MAX"]],["sgl/gl"]],
["gl_point_size_min",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.O.I.N.T_.S.I.Z.E_.M.I.N))",[0,[2,"GL_POINT_SIZE_MIN"]],["sgl/gl"]],
["gl_point_size_range",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.O.I.N.T_.S.I.Z.E_.R.A.N.G.E))",[0,[2,"GL_POINT_SIZE_RANGE"]],["sgl/gl"]],
["gl_point_smooth",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.O.I.N.T_.S.M.O.O.T.H))",[0,[2,"GL_POINT_SMOOTH"]],["sgl/gl"]],
["gl_point_smooth_hint",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.O.I.N.T_.S.M.O.O.T.H_.H.I.N.T))",[0,[2,"GL_POINT_SMOOTH_HINT"]],["sgl/gl"]],
["gl_point_token",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.O.I.N.T_.T.O.K.E.N))",[0,[2,"GL_POINT_TOKEN"]],["sgl/gl"]],
["gl_points",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.O.I.N.T.S))",[0,[2,"GL_POINTS"]],["sgl/gl"]],
["gl_polygon",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.O.L.Y.G.O.N))",[0,[2,"GL_POLYGON"]],["sgl/gl"]],
["gl_polygon_bit",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.O.L.Y.G.O.N_.B.I.T))",[0,[2,"GL_POLYGON_BIT"]],["sgl/gl"]],
["gl_polygon_mode",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.O.L.Y.G.O.N_.M.O.D.E))",[0,[2,"GL_POLYGON_MODE"]],["sgl/gl"]],
["gl_polygon_offset_factor",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.O.L.Y.G.O.N_.O.F.F.S.E.T_.F.A.C.T.O.R))",[0,[2,"GL_POLYGON_OFFSET_FACTOR"]],["sgl/gl"]],
["gl_polygon_offset_fill",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.O.L.Y.G.O.N_.O.F.F.S.E.T_.F.I.L.L))",[0,[2,"GL_POLYGON_OFFSET_FILL"]],["sgl/gl"]],
["gl_polygon_offset_line",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.O.L.Y.G.O.N_.O.F.F.S.E.T_.L.I.N.E))",[0,[2,"GL_POLYGON_OFFSET_LINE"]],["sgl/gl"]],
["gl_polygon_offset_point",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.O.L.Y.G.O.N_.O.F.F.S.E.T_.P.O.I.N.T))",[0,[2,"GL_POLYGON_OFFSET_POINT"]],["sgl/gl"]],
["gl_polygon_offset_units",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.O.L.Y.G.O.N_.O.F.F.S.E.T_.U.N.I.T.S))",[0,[2,"GL_POLYGON_OFFSET_UNITS"]],["sgl/gl"]],
["gl_polygon_smooth",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.O.L.Y.G.O.N_.S.M.O.O.T.H))",[0,[2,"GL_POLYGON_SMOOTH"]],["sgl/gl"]],
["gl_polygon_smooth_hint",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.O.L.Y.G.O.N_.S.M.O.O.T.H_.H.I.N.T))",[0,[2,"GL_POLYGON_SMOOTH_HINT"]],["sgl/gl"]],
["gl_polygon_stipple",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.O.L.Y.G.O.N_.S.T.I.P.P.L.E))",[0,[2,"GL_POLYGON_STIPPLE"]],["sgl/gl"]],
["gl_polygon_stipple_bit",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.O.L.Y.G.O.N_.S.T.I.P.P.L.E_.B.I.T))",[0,[2,"GL_POLYGON_STIPPLE_BIT"]],["sgl/gl"]],
["gl_polygon_token",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.O.L.Y.G.O.N_.T.O.K.E.N))",[0,[2,"GL_POLYGON_TOKEN"]],["sgl/gl"]],
["gl_position",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.O.S.I.T.I.O.N))",[0,[2,"GL_POSITION"]],["sgl/gl"]],
["gl_post_color_matrix_alpha_bias",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.O.S.T_.C.O.L.O.R_.M.A.T.R.I.X_.A.L.P.H.A_.B.I.A.S))",[0,[2,"GL_POST_COLOR_MATRIX_ALPHA_BIAS"]],["sgl/gl"]],
["gl_post_color_matrix_alpha_scale",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.O.S.T_.C.O.L.O.R_.M.A.T.R.I.X_.A.L.P.H.A_.S.C.A.L.E))",[0,[2,"GL_POST_COLOR_MATRIX_ALPHA_SCALE"]],["sgl/gl"]],
["gl_post_color_matrix_blue_bias",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.O.S.T_.C.O.L.O.R_.M.A.T.R.I.X_.B.L.U.E_.B.I.A.S))",[0,[2,"GL_POST_COLOR_MATRIX_BLUE_BIAS"]],["sgl/gl"]],
["gl_post_color_matrix_blue_scale",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.O.S.T_.C.O.L.O.R_.M.A.T.R.I.X_.B.L.U.E_.S.C.A.L.E))",[0,[2,"GL_POST_COLOR_MATRIX_BLUE_SCALE"]],["sgl/gl"]],
["gl_post_color_matrix_color_table",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.O.S.T_.C.O.L.O.R_.M.A.T.R.I.X_.C.O.L.O.R_.T.A.B.L.E))",[0,[2,"GL_POST_COLOR_MATRIX_COLOR_TABLE"]],["sgl/gl"]],
["gl_post_color_matrix_green_bias",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.O.S.T_.C.O.L.O.R_.M.A.T.R.I.X_.G.R.E.E.N_.B.I.A.S))",[0,[2,"GL_POST_COLOR_MATRIX_GREEN_BIAS"]],["sgl/gl"]],
["gl_post_color_matrix_green_scale",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.O.S.T_.C.O.L.O.R_.M.A.T.R.I.X_.G.R.E.E.N_.S.C.A.L.E))",[0,[2,"GL_POST_COLOR_MATRIX_GREEN_SCALE"]],["sgl/gl"]],
["gl_post_color_matrix_red_bias",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.O.S.T_.C.O.L.O.R_.M.A.T.R.I.X_.R.E.D_.B.I.A.S))",[0,[2,"GL_POST_COLOR_MATRIX_RED_BIAS"]],["sgl/gl"]],
["gl_post_color_matrix_red_scale",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.O.S.T_.C.O.L.O.R_.M.A.T.R.I.X_.R.E.D_.S.C.A.L.E))",[0,[2,"GL_POST_COLOR_MATRIX_RED_SCALE"]],["sgl/gl"]],
["gl_post_convolution_alpha_bias",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.O.S.T_.C.O.N.V.O.L.U.T.I.O.N_.A.L.P.H.A_.B.I.A.S))",[0,[2,"GL_POST_CONVOLUTION_ALPHA_BIAS"]],["sgl/gl"]],
["gl_post_convolution_alpha_scale",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.O.S.T_.C.O.N.V.O.L.U.T.I.O.N_.A.L.P.H.A_.S.C.A.L.E))",[0,[2,"GL_POST_CONVOLUTION_ALPHA_SCALE"]],["sgl/gl"]],
["gl_post_convolution_blue_bias",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.O.S.T_.C.O.N.V.O.L.U.T.I.O.N_.B.L.U.E_.B.I.A.S))",[0,[2,"GL_POST_CONVOLUTION_BLUE_BIAS"]],["sgl/gl"]],
["gl_post_convolution_blue_scale",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.O.S.T_.C.O.N.V.O.L.U.T.I.O.N_.B.L.U.E_.S.C.A.L.E))",[0,[2,"GL_POST_CONVOLUTION_BLUE_SCALE"]],["sgl/gl"]],
["gl_post_convolution_color_table",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.O.S.T_.C.O.N.V.O.L.U.T.I.O.N_.C.O.L.O.R_.T.A.B.L.E))",[0,[2,"GL_POST_CONVOLUTION_COLOR_TABLE"]],["sgl/gl"]],
["gl_post_convolution_green_bias",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.O.S.T_.C.O.N.V.O.L.U.T.I.O.N_.G.R.E.E.N_.B.I.A.S))",[0,[2,"GL_POST_CONVOLUTION_GREEN_BIAS"]],["sgl/gl"]],
["gl_post_convolution_green_scale",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.O.S.T_.C.O.N.V.O.L.U.T.I.O.N_.G.R.E.E.N_.S.C.A.L.E))",[0,[2,"GL_POST_CONVOLUTION_GREEN_SCALE"]],["sgl/gl"]],
["gl_post_convolution_red_bias",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.O.S.T_.C.O.N.V.O.L.U.T.I.O.N_.R.E.D_.B.I.A.S))",[0,[2,"GL_POST_CONVOLUTION_RED_BIAS"]],["sgl/gl"]],
["gl_post_convolution_red_scale",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.O.S.T_.C.O.N.V.O.L.U.T.I.O.N_.R.E.D_.S.C.A.L.E))",[0,[2,"GL_POST_CONVOLUTION_RED_SCALE"]],["sgl/gl"]],
["gl_previous",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.R.E.V.I.O.U.S))",[0,[2,"GL_PREVIOUS"]],["sgl/gl"]],
["gl_primary_color",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.R.I.M.A.R.Y_.C.O.L.O.R))",[0,[2,"GL_PRIMARY_COLOR"]],["sgl/gl"]],
["gl_projection",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.R.O.J.E.C.T.I.O.N))",[0,[2,"GL_PROJECTION"]],["sgl/gl"]],
["gl_projection_matrix",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.R.O.J.E.C.T.I.O.N_.M.A.T.R.I.X))",[0,[2,"GL_PROJECTION_MATRIX"]],["sgl/gl"]],
["gl_projection_stack_depth",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.R.O.J.E.C.T.I.O.N_.S.T.A.C.K_.D.E.P.T.H))",[0,[2,"GL_PROJECTION_STACK_DEPTH"]],["sgl/gl"]],
["gl_proxy_color_table",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.R.O.X.Y_.C.O.L.O.R_.T.A.B.L.E))",[0,[2,"GL_PROXY_COLOR_TABLE"]],["sgl/gl"]],
["gl_proxy_histogram",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.R.O.X.Y_.H.I.S.T.O.G.R.A.M))",[0,[2,"GL_PROXY_HISTOGRAM"]],["sgl/gl"]],
["gl_proxy_post_color_matrix_color_table",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.R.O.X.Y_.P.O.S.T_.C.O.L.O.R_.M.A.T.R.I.X_.C.O.L.O.R_.T.A.B.L.E))",[0,[2,"GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE"]],["sgl/gl"]],
["gl_proxy_post_convolution_color_table",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.R.O.X.Y_.P.O.S.T_.C.O.N.V.O.L.U.T.I.O.N_.C.O.L.O.R_.T.A.B.L.E))",[0,[2,"GL_PROXY_POST_CONVOLUTION_COLOR_TABLE"]],["sgl/gl"]],
["gl_proxy_texture_1d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.R.O.X.Y_.T.E.X.T.U.R.E_1.D))",[0,[2,"GL_PROXY_TEXTURE_1D"]],["sgl/gl"]],
["gl_proxy_texture_2d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.R.O.X.Y_.T.E.X.T.U.R.E_2.D))",[0,[2,"GL_PROXY_TEXTURE_2D"]],["sgl/gl"]],
["gl_proxy_texture_3d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.R.O.X.Y_.T.E.X.T.U.R.E_3.D))",[0,[2,"GL_PROXY_TEXTURE_3D"]],["sgl/gl"]],
["gl_proxy_texture_cube_map",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.P.R.O.X.Y_.T.E.X.T.U.R.E_.C.U.B.E_.M.A.P))",[0,[2,"GL_PROXY_TEXTURE_CUBE_MAP"]],["sgl/gl"]],
["gl_q",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.Q))",[0,[2,"GL_Q"]],["sgl/gl"]],
["gl_quad_strip",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.Q.U.A.D_.S.T.R.I.P))",[0,[2,"GL_QUAD_STRIP"]],["sgl/gl"]],
["gl_quadratic_attenuation",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.Q.U.A.D.R.A.T.I.C_.A.T.T.E.N.U.A.T.I.O.N))",[0,[2,"GL_QUADRATIC_ATTENUATION"]],["sgl/gl"]],
["gl_quads",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.Q.U.A.D.S))",[0,[2,"GL_QUADS"]],["sgl/gl"]],
["gl_query_counter_bits",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.Q.U.E.R.Y_.C.O.U.N.T.E.R_.B.I.T.S))",[0,[2,"GL_QUERY_COUNTER_BITS"]],["sgl/gl"]],
["gl_query_result",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.Q.U.E.R.Y_.R.E.S.U.L.T))",[0,[2,"GL_QUERY_RESULT"]],["sgl/gl"]],
["gl_query_result_available",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.Q.U.E.R.Y_.R.E.S.U.L.T_.A.V.A.I.L.A.B.L.E))",[0,[2,"GL_QUERY_RESULT_AVAILABLE"]],["sgl/gl"]],
["gl_r",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.R))",[0,[2,"GL_R"]],["sgl/gl"]],
["gl_r3_g3_b2",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.R3_.G3_.B2))",[0,[2,"GL_R3_G3_B2"]],["sgl/gl"]],
["gl_read_buffer",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.R.E.A.D_.B.U.F.F.E.R))",[0,[2,"GL_READ_BUFFER"]],["sgl/gl"]],
["gl_read_only",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.R.E.A.D_.O.N.L.Y))",[0,[2,"GL_READ_ONLY"]],["sgl/gl"]],
["gl_read_write",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.R.E.A.D_.W.R.I.T.E))",[0,[2,"GL_READ_WRITE"]],["sgl/gl"]],
["gl_red",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.R.E.D))",[0,[2,"GL_RED"]],["sgl/gl"]],
["gl_red_bias",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.R.E.D_.B.I.A.S))",[0,[2,"GL_RED_BIAS"]],["sgl/gl"]],
["gl_red_bits",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.R.E.D_.B.I.T.S))",[0,[2,"GL_RED_BITS"]],["sgl/gl"]],
["gl_red_scale",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.R.E.D_.S.C.A.L.E))",[0,[2,"GL_RED_SCALE"]],["sgl/gl"]],
["gl_reduce",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.R.E.D.U.C.E))",[0,[2,"GL_REDUCE"]],["sgl/gl"]],
["gl_reflection_map",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.R.E.F.L.E.C.T.I.O.N_.M.A.P))",[0,[2,"GL_REFLECTION_MAP"]],["sgl/gl"]],
["gl_render",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.R.E.N.D.E.R))",[0,[2,"GL_RENDER"]],["sgl/gl"]],
["gl_render_mode",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.R.E.N.D.E.R_.M.O.D.E))",[0,[2,"GL_RENDER_MODE"]],["sgl/gl"]],
["gl_renderer",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.R.E.N.D.E.R.E.R))",[0,[2,"GL_RENDERER"]],["sgl/gl"]],
["gl_repeat",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.R.E.P.E.A.T))",[0,[2,"GL_REPEAT"]],["sgl/gl"]],
["gl_replace",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.R.E.P.L.A.C.E))",[0,[2,"GL_REPLACE"]],["sgl/gl"]],
["gl_replicate_border",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.R.E.P.L.I.C.A.T.E_.B.O.R.D.E.R))",[0,[2,"GL_REPLICATE_BORDER"]],["sgl/gl"]],
["gl_rescale_normal",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.R.E.S.C.A.L.E_.N.O.R.M.A.L))",[0,[2,"GL_RESCALE_NORMAL"]],["sgl/gl"]],
["gl_return",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.R.E.T.U.R.N))",[0,[2,"GL_RETURN"]],["sgl/gl"]],
["gl_rgb",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.R.G.B))",[0,[2,"GL_RGB"]],["sgl/gl"]],
["gl_rgb10",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.R.G.B10))",[0,[2,"GL_RGB10"]],["sgl/gl"]],
["gl_rgb10_a2",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.R.G.B10_.A2))",[0,[2,"GL_RGB10_A2"]],["sgl/gl"]],
["gl_rgb12",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.R.G.B12))",[0,[2,"GL_RGB12"]],["sgl/gl"]],
["gl_rgb16",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.R.G.B16))",[0,[2,"GL_RGB16"]],["sgl/gl"]],
["gl_rgb4",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.R.G.B4))",[0,[2,"GL_RGB4"]],["sgl/gl"]],
["gl_rgb5",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.R.G.B5))",[0,[2,"GL_RGB5"]],["sgl/gl"]],
["gl_rgb5_a1",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.R.G.B5_.A1))",[0,[2,"GL_RGB5_A1"]],["sgl/gl"]],
["gl_rgb8",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.R.G.B8))",[0,[2,"GL_RGB8"]],["sgl/gl"]],
["gl_rgb_scale",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.R.G.B_.S.C.A.L.E))",[0,[2,"GL_RGB_SCALE"]],["sgl/gl"]],
["gl_rgba",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.R.G.B.A))",[0,[2,"GL_RGBA"]],["sgl/gl"]],
["gl_rgba12",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.R.G.B.A12))",[0,[2,"GL_RGBA12"]],["sgl/gl"]],
["gl_rgba16",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.R.G.B.A16))",[0,[2,"GL_RGBA16"]],["sgl/gl"]],
["gl_rgba2",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.R.G.B.A2))",[0,[2,"GL_RGBA2"]],["sgl/gl"]],
["gl_rgba4",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.R.G.B.A4))",[0,[2,"GL_RGBA4"]],["sgl/gl"]],
["gl_rgba8",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.R.G.B.A8))",[0,[2,"GL_RGBA8"]],["sgl/gl"]],
["gl_rgba_mode",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.R.G.B.A_.M.O.D.E))",[0,[2,"GL_RGBA_MODE"]],["sgl/gl"]],
["gl_right",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.R.I.G.H.T))",[0,[2,"GL_RIGHT"]],["sgl/gl"]],
["gl_s",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S))",[0,[2,"GL_S"]],["sgl/gl"]],
["gl_sample_alpha_to_coverage",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.A.M.P.L.E_.A.L.P.H.A_.T.O_.C.O.V.E.R.A.G.E))",[0,[2,"GL_SAMPLE_ALPHA_TO_COVERAGE"]],["sgl/gl"]],
["gl_sample_alpha_to_one",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.A.M.P.L.E_.A.L.P.H.A_.T.O_.O.N.E))",[0,[2,"GL_SAMPLE_ALPHA_TO_ONE"]],["sgl/gl"]],
["gl_sample_buffers",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.A.M.P.L.E_.B.U.F.F.E.R.S))",[0,[2,"GL_SAMPLE_BUFFERS"]],["sgl/gl"]],
["gl_sample_coverage",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.A.M.P.L.E_.C.O.V.E.R.A.G.E))",[0,[2,"GL_SAMPLE_COVERAGE"]],["sgl/gl"]],
["gl_sample_coverage_invert",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.A.M.P.L.E_.C.O.V.E.R.A.G.E_.I.N.V.E.R.T))",[0,[2,"GL_SAMPLE_COVERAGE_INVERT"]],["sgl/gl"]],
["gl_sample_coverage_value",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.A.M.P.L.E_.C.O.V.E.R.A.G.E_.V.A.L.U.E))",[0,[2,"GL_SAMPLE_COVERAGE_VALUE"]],["sgl/gl"]],
["gl_samples",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.A.M.P.L.E.S))",[0,[2,"GL_SAMPLES"]],["sgl/gl"]],
["gl_samples_passed",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.A.M.P.L.E.S_.P.A.S.S.E.D))",[0,[2,"GL_SAMPLES_PASSED"]],["sgl/gl"]],
["gl_scissor_bit",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.C.I.S.S.O.R_.B.I.T))",[0,[2,"GL_SCISSOR_BIT"]],["sgl/gl"]],
["gl_scissor_box",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.C.I.S.S.O.R_.B.O.X))",[0,[2,"GL_SCISSOR_BOX"]],["sgl/gl"]],
["gl_scissor_test",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.C.I.S.S.O.R_.T.E.S.T))",[0,[2,"GL_SCISSOR_TEST"]],["sgl/gl"]],
["gl_secondary_color_array",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.E.C.O.N.D.A.R.Y_.C.O.L.O.R_.A.R.R.A.Y))",[0,[2,"GL_SECONDARY_COLOR_ARRAY"]],["sgl/gl"]],
["gl_secondary_color_array_buffer_binding",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.E.C.O.N.D.A.R.Y_.C.O.L.O.R_.A.R.R.A.Y_.B.U.F.F.E.R_.B.I.N.D.I.N.G))",[0,[2,"GL_SECONDARY_COLOR_ARRAY_BUFFER_BINDING"]],["sgl/gl"]],
["gl_secondary_color_array_pointer",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.E.C.O.N.D.A.R.Y_.C.O.L.O.R_.A.R.R.A.Y_.P.O.I.N.T.E.R))",[0,[2,"GL_SECONDARY_COLOR_ARRAY_POINTER"]],["sgl/gl"]],
["gl_secondary_color_array_size",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.E.C.O.N.D.A.R.Y_.C.O.L.O.R_.A.R.R.A.Y_.S.I.Z.E))",[0,[2,"GL_SECONDARY_COLOR_ARRAY_SIZE"]],["sgl/gl"]],
["gl_secondary_color_array_stride",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.E.C.O.N.D.A.R.Y_.C.O.L.O.R_.A.R.R.A.Y_.S.T.R.I.D.E))",[0,[2,"GL_SECONDARY_COLOR_ARRAY_STRIDE"]],["sgl/gl"]],
["gl_secondary_color_array_type",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.E.C.O.N.D.A.R.Y_.C.O.L.O.R_.A.R.R.A.Y_.T.Y.P.E))",[0,[2,"GL_SECONDARY_COLOR_ARRAY_TYPE"]],["sgl/gl"]],
["gl_select",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.E.L.E.C.T))",[0,[2,"GL_SELECT"]],["sgl/gl"]],
["gl_selection_buffer_pointer",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.E.L.E.C.T.I.O.N_.B.U.F.F.E.R_.P.O.I.N.T.E.R))",[0,[2,"GL_SELECTION_BUFFER_POINTER"]],["sgl/gl"]],
["gl_selection_buffer_size",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.E.L.E.C.T.I.O.N_.B.U.F.F.E.R_.S.I.Z.E))",[0,[2,"GL_SELECTION_BUFFER_SIZE"]],["sgl/gl"]],
["gl_separable_2d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.E.P.A.R.A.B.L.E_2.D))",[0,[2,"GL_SEPARABLE_2D"]],["sgl/gl"]],
["gl_separate_specular_color",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.E.P.A.R.A.T.E_.S.P.E.C.U.L.A.R_.C.O.L.O.R))",[0,[2,"GL_SEPARATE_SPECULAR_COLOR"]],["sgl/gl"]],
["gl_set",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.E.T))",[0,[2,"GL_SET"]],["sgl/gl"]],
["gl_shade_model",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.H.A.D.E_.M.O.D.E.L))",[0,[2,"GL_SHADE_MODEL"]],["sgl/gl"]],
["gl_shininess",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.H.I.N.I.N.E.S.S))",[0,[2,"GL_SHININESS"]],["sgl/gl"]],
["gl_short",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.H.O.R.T))",[0,[2,"GL_SHORT"]],["sgl/gl"]],
["gl_single_color",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.I.N.G.L.E_.C.O.L.O.R))",[0,[2,"GL_SINGLE_COLOR"]],["sgl/gl"]],
["gl_smooth",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.M.O.O.T.H))",[0,[2,"GL_SMOOTH"]],["sgl/gl"]],
["gl_smooth_line_width_granularity",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.M.O.O.T.H_.L.I.N.E_.W.I.D.T.H_.G.R.A.N.U.L.A.R.I.T.Y))",[0,[2,"GL_SMOOTH_LINE_WIDTH_GRANULARITY"]],["sgl/gl"]],
["gl_smooth_line_width_range",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.M.O.O.T.H_.L.I.N.E_.W.I.D.T.H_.R.A.N.G.E))",[0,[2,"GL_SMOOTH_LINE_WIDTH_RANGE"]],["sgl/gl"]],
["gl_smooth_point_size_granularity",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.M.O.O.T.H_.P.O.I.N.T_.S.I.Z.E_.G.R.A.N.U.L.A.R.I.T.Y))",[0,[2,"GL_SMOOTH_POINT_SIZE_GRANULARITY"]],["sgl/gl"]],
["gl_smooth_point_size_range",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.M.O.O.T.H_.P.O.I.N.T_.S.I.Z.E_.R.A.N.G.E))",[0,[2,"GL_SMOOTH_POINT_SIZE_RANGE"]],["sgl/gl"]],
["gl_source0_alpha",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.O.U.R.C.E0_.A.L.P.H.A))",[0,[2,"GL_SOURCE0_ALPHA"]],["sgl/gl"]],
["gl_source0_rgb",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.O.U.R.C.E0_.R.G.B))",[0,[2,"GL_SOURCE0_RGB"]],["sgl/gl"]],
["gl_source1_alpha",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.O.U.R.C.E1_.A.L.P.H.A))",[0,[2,"GL_SOURCE1_ALPHA"]],["sgl/gl"]],
["gl_source1_rgb",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.O.U.R.C.E1_.R.G.B))",[0,[2,"GL_SOURCE1_RGB"]],["sgl/gl"]],
["gl_source2_alpha",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.O.U.R.C.E2_.A.L.P.H.A))",[0,[2,"GL_SOURCE2_ALPHA"]],["sgl/gl"]],
["gl_source2_rgb",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.O.U.R.C.E2_.R.G.B))",[0,[2,"GL_SOURCE2_RGB"]],["sgl/gl"]],
["gl_specular",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.P.E.C.U.L.A.R))",[0,[2,"GL_SPECULAR"]],["sgl/gl"]],
["gl_sphere_map",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.P.H.E.R.E_.M.A.P))",[0,[2,"GL_SPHERE_MAP"]],["sgl/gl"]],
["gl_spot_cutoff",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.P.O.T_.C.U.T.O.F.F))",[0,[2,"GL_SPOT_CUTOFF"]],["sgl/gl"]],
["gl_spot_direction",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.P.O.T_.D.I.R.E.C.T.I.O.N))",[0,[2,"GL_SPOT_DIRECTION"]],["sgl/gl"]],
["gl_spot_exponent",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.P.O.T_.E.X.P.O.N.E.N.T))",[0,[2,"GL_SPOT_EXPONENT"]],["sgl/gl"]],
["gl_src0_alpha",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.R.C0_.A.L.P.H.A))",[0,[2,"GL_SRC0_ALPHA"]],["sgl/gl"]],
["gl_src0_rgb",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.R.C0_.R.G.B))",[0,[2,"GL_SRC0_RGB"]],["sgl/gl"]],
["gl_src1_alpha",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.R.C1_.A.L.P.H.A))",[0,[2,"GL_SRC1_ALPHA"]],["sgl/gl"]],
["gl_src1_rgb",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.R.C1_.R.G.B))",[0,[2,"GL_SRC1_RGB"]],["sgl/gl"]],
["gl_src2_alpha",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.R.C2_.A.L.P.H.A))",[0,[2,"GL_SRC2_ALPHA"]],["sgl/gl"]],
["gl_src2_rgb",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.R.C2_.R.G.B))",[0,[2,"GL_SRC2_RGB"]],["sgl/gl"]],
["gl_src_alpha",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.R.C_.A.L.P.H.A))",[0,[2,"GL_SRC_ALPHA"]],["sgl/gl"]],
["gl_src_alpha_saturate",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.R.C_.A.L.P.H.A_.S.A.T.U.R.A.T.E))",[0,[2,"GL_SRC_ALPHA_SATURATE"]],["sgl/gl"]],
["gl_src_color",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.R.C_.C.O.L.O.R))",[0,[2,"GL_SRC_COLOR"]],["sgl/gl"]],
["gl_stack_overflow",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.T.A.C.K_.O.V.E.R.F.L.O.W))",[0,[2,"GL_STACK_OVERFLOW"]],["sgl/gl"]],
["gl_stack_underflow",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.T.A.C.K_.U.N.D.E.R.F.L.O.W))",[0,[2,"GL_STACK_UNDERFLOW"]],["sgl/gl"]],
["gl_static_copy",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.T.A.T.I.C_.C.O.P.Y))",[0,[2,"GL_STATIC_COPY"]],["sgl/gl"]],
["gl_static_draw",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.T.A.T.I.C_.D.R.A.W))",[0,[2,"GL_STATIC_DRAW"]],["sgl/gl"]],
["gl_static_read",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.T.A.T.I.C_.R.E.A.D))",[0,[2,"GL_STATIC_READ"]],["sgl/gl"]],
["gl_stencil",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.T.E.N.C.I.L))",[0,[2,"GL_STENCIL"]],["sgl/gl"]],
["gl_stencil_bits",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.T.E.N.C.I.L_.B.I.T.S))",[0,[2,"GL_STENCIL_BITS"]],["sgl/gl"]],
["gl_stencil_buffer_bit",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.T.E.N.C.I.L_.B.U.F.F.E.R_.B.I.T))",[0,[2,"GL_STENCIL_BUFFER_BIT"]],["sgl/gl"]],
["gl_stencil_clear_value",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.T.E.N.C.I.L_.C.L.E.A.R_.V.A.L.U.E))",[0,[2,"GL_STENCIL_CLEAR_VALUE"]],["sgl/gl"]],
["gl_stencil_fail",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.T.E.N.C.I.L_.F.A.I.L))",[0,[2,"GL_STENCIL_FAIL"]],["sgl/gl"]],
["gl_stencil_func",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.T.E.N.C.I.L_.F.U.N.C))",[0,[2,"GL_STENCIL_FUNC"]],["sgl/gl"]],
["gl_stencil_index",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.T.E.N.C.I.L_.I.N.D.E.X))",[0,[2,"GL_STENCIL_INDEX"]],["sgl/gl"]],
["gl_stencil_pass_depth_fail",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.T.E.N.C.I.L_.P.A.S.S_.D.E.P.T.H_.F.A.I.L))",[0,[2,"GL_STENCIL_PASS_DEPTH_FAIL"]],["sgl/gl"]],
["gl_stencil_pass_depth_pass",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.T.E.N.C.I.L_.P.A.S.S_.D.E.P.T.H_.P.A.S.S))",[0,[2,"GL_STENCIL_PASS_DEPTH_PASS"]],["sgl/gl"]],
["gl_stencil_ref",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.T.E.N.C.I.L_.R.E.F))",[0,[2,"GL_STENCIL_REF"]],["sgl/gl"]],
["gl_stencil_test",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.T.E.N.C.I.L_.T.E.S.T))",[0,[2,"GL_STENCIL_TEST"]],["sgl/gl"]],
["gl_stencil_value_mask",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.T.E.N.C.I.L_.V.A.L.U.E_.M.A.S.K))",[0,[2,"GL_STENCIL_VALUE_MASK"]],["sgl/gl"]],
["gl_stencil_writemask",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.T.E.N.C.I.L_.W.R.I.T.E.M.A.S.K))",[0,[2,"GL_STENCIL_WRITEMASK"]],["sgl/gl"]],
["gl_stereo",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.T.E.R.E.O))",[0,[2,"GL_STEREO"]],["sgl/gl"]],
["gl_stream_copy",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.T.R.E.A.M_.C.O.P.Y))",[0,[2,"GL_STREAM_COPY"]],["sgl/gl"]],
["gl_stream_draw",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.T.R.E.A.M_.D.R.A.W))",[0,[2,"GL_STREAM_DRAW"]],["sgl/gl"]],
["gl_stream_read",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.T.R.E.A.M_.R.E.A.D))",[0,[2,"GL_STREAM_READ"]],["sgl/gl"]],
["gl_subpixel_bits",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.U.B.P.I.X.E.L_.B.I.T.S))",[0,[2,"GL_SUBPIXEL_BITS"]],["sgl/gl"]],
["gl_subtract",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.S.U.B.T.R.A.C.T))",[0,[2,"GL_SUBTRACT"]],["sgl/gl"]],
["gl_t",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T))",[0,[2,"GL_T"]],["sgl/gl"]],
["gl_t2f_c3f_v3f",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T2.F_.C3.F_.V3.F))",[0,[2,"GL_T2F_C3F_V3F"]],["sgl/gl"]],
["gl_t2f_c4f_n3f_v3f",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T2.F_.C4.F_.N3.F_.V3.F))",[0,[2,"GL_T2F_C4F_N3F_V3F"]],["sgl/gl"]],
["gl_t2f_c4ub_v3f",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T2.F_.C4.U.B_.V3.F))",[0,[2,"GL_T2F_C4UB_V3F"]],["sgl/gl"]],
["gl_t2f_n3f_v3f",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T2.F_.N3.F_.V3.F))",[0,[2,"GL_T2F_N3F_V3F"]],["sgl/gl"]],
["gl_t2f_v3f",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T2.F_.V3.F))",[0,[2,"GL_T2F_V3F"]],["sgl/gl"]],
["gl_t4f_c4f_n3f_v4f",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T4.F_.C4.F_.N3.F_.V4.F))",[0,[2,"GL_T4F_C4F_N3F_V4F"]],["sgl/gl"]],
["gl_t4f_v4f",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T4.F_.V4.F))",[0,[2,"GL_T4F_V4F"]],["sgl/gl"]],
["gl_table_too_large",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.A.B.L.E_.T.O.O_.L.A.R.G.E))",[0,[2,"GL_TABLE_TOO_LARGE"]],["sgl/gl"]],
["gl_texture",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E))",[0,[2,"GL_TEXTURE"]],["sgl/gl"]],
["gl_texture0",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E0))",[0,[2,"GL_TEXTURE0"]],["sgl/gl"]],
["gl_texture1",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E1))",[0,[2,"GL_TEXTURE1"]],["sgl/gl"]],
["gl_texture10",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E10))",[0,[2,"GL_TEXTURE10"]],["sgl/gl"]],
["gl_texture11",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E11))",[0,[2,"GL_TEXTURE11"]],["sgl/gl"]],
["gl_texture12",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E12))",[0,[2,"GL_TEXTURE12"]],["sgl/gl"]],
["gl_texture13",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E13))",[0,[2,"GL_TEXTURE13"]],["sgl/gl"]],
["gl_texture14",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E14))",[0,[2,"GL_TEXTURE14"]],["sgl/gl"]],
["gl_texture15",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E15))",[0,[2,"GL_TEXTURE15"]],["sgl/gl"]],
["gl_texture16",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E16))",[0,[2,"GL_TEXTURE16"]],["sgl/gl"]],
["gl_texture17",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E17))",[0,[2,"GL_TEXTURE17"]],["sgl/gl"]],
["gl_texture18",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E18))",[0,[2,"GL_TEXTURE18"]],["sgl/gl"]],
["gl_texture19",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E19))",[0,[2,"GL_TEXTURE19"]],["sgl/gl"]],
["gl_texture2",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E2))",[0,[2,"GL_TEXTURE2"]],["sgl/gl"]],
["gl_texture20",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E20))",[0,[2,"GL_TEXTURE20"]],["sgl/gl"]],
["gl_texture21",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E21))",[0,[2,"GL_TEXTURE21"]],["sgl/gl"]],
["gl_texture22",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E22))",[0,[2,"GL_TEXTURE22"]],["sgl/gl"]],
["gl_texture23",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E23))",[0,[2,"GL_TEXTURE23"]],["sgl/gl"]],
["gl_texture24",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E24))",[0,[2,"GL_TEXTURE24"]],["sgl/gl"]],
["gl_texture25",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E25))",[0,[2,"GL_TEXTURE25"]],["sgl/gl"]],
["gl_texture26",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E26))",[0,[2,"GL_TEXTURE26"]],["sgl/gl"]],
["gl_texture27",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E27))",[0,[2,"GL_TEXTURE27"]],["sgl/gl"]],
["gl_texture28",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E28))",[0,[2,"GL_TEXTURE28"]],["sgl/gl"]],
["gl_texture29",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E29))",[0,[2,"GL_TEXTURE29"]],["sgl/gl"]],
["gl_texture3",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E3))",[0,[2,"GL_TEXTURE3"]],["sgl/gl"]],
["gl_texture30",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E30))",[0,[2,"GL_TEXTURE30"]],["sgl/gl"]],
["gl_texture31",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E31))",[0,[2,"GL_TEXTURE31"]],["sgl/gl"]],
["gl_texture4",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E4))",[0,[2,"GL_TEXTURE4"]],["sgl/gl"]],
["gl_texture5",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E5))",[0,[2,"GL_TEXTURE5"]],["sgl/gl"]],
["gl_texture6",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E6))",[0,[2,"GL_TEXTURE6"]],["sgl/gl"]],
["gl_texture7",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E7))",[0,[2,"GL_TEXTURE7"]],["sgl/gl"]],
["gl_texture8",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E8))",[0,[2,"GL_TEXTURE8"]],["sgl/gl"]],
["gl_texture9",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E9))",[0,[2,"GL_TEXTURE9"]],["sgl/gl"]],
["gl_texture_1d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_1.D))",[0,[2,"GL_TEXTURE_1D"]],["sgl/gl"]],
["gl_texture_2d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_2.D))",[0,[2,"GL_TEXTURE_2D"]],["sgl/gl"]],
["gl_texture_3d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_3.D))",[0,[2,"GL_TEXTURE_3D"]],["sgl/gl"]],
["gl_texture_alpha_size",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.A.L.P.H.A_.S.I.Z.E))",[0,[2,"GL_TEXTURE_ALPHA_SIZE"]],["sgl/gl"]],
["gl_texture_base_level",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.B.A.S.E_.L.E.V.E.L))",[0,[2,"GL_TEXTURE_BASE_LEVEL"]],["sgl/gl"]],
["gl_texture_binding_1d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.B.I.N.D.I.N.G_1.D))",[0,[2,"GL_TEXTURE_BINDING_1D"]],["sgl/gl"]],
["gl_texture_binding_2d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.B.I.N.D.I.N.G_2.D))",[0,[2,"GL_TEXTURE_BINDING_2D"]],["sgl/gl"]],
["gl_texture_binding_3d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.B.I.N.D.I.N.G_3.D))",[0,[2,"GL_TEXTURE_BINDING_3D"]],["sgl/gl"]],
["gl_texture_binding_cube_map",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.B.I.N.D.I.N.G_.C.U.B.E_.M.A.P))",[0,[2,"GL_TEXTURE_BINDING_CUBE_MAP"]],["sgl/gl"]],
["gl_texture_bit",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.B.I.T))",[0,[2,"GL_TEXTURE_BIT"]],["sgl/gl"]],
["gl_texture_blue_size",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.B.L.U.E_.S.I.Z.E))",[0,[2,"GL_TEXTURE_BLUE_SIZE"]],["sgl/gl"]],
["gl_texture_border",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.B.O.R.D.E.R))",[0,[2,"GL_TEXTURE_BORDER"]],["sgl/gl"]],
["gl_texture_border_color",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.B.O.R.D.E.R_.C.O.L.O.R))",[0,[2,"GL_TEXTURE_BORDER_COLOR"]],["sgl/gl"]],
["gl_texture_compare_func",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.C.O.M.P.A.R.E_.F.U.N.C))",[0,[2,"GL_TEXTURE_COMPARE_FUNC"]],["sgl/gl"]],
["gl_texture_compare_mode",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.C.O.M.P.A.R.E_.M.O.D.E))",[0,[2,"GL_TEXTURE_COMPARE_MODE"]],["sgl/gl"]],
["gl_texture_components",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.C.O.M.P.O.N.E.N.T.S))",[0,[2,"GL_TEXTURE_COMPONENTS"]],["sgl/gl"]],
["gl_texture_compressed",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.C.O.M.P.R.E.S.S.E.D))",[0,[2,"GL_TEXTURE_COMPRESSED"]],["sgl/gl"]],
["gl_texture_compressed_image_size",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.C.O.M.P.R.E.S.S.E.D_.I.M.A.G.E_.S.I.Z.E))",[0,[2,"GL_TEXTURE_COMPRESSED_IMAGE_SIZE"]],["sgl/gl"]],
["gl_texture_compression_hint",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.C.O.M.P.R.E.S.S.I.O.N_.H.I.N.T))",[0,[2,"GL_TEXTURE_COMPRESSION_HINT"]],["sgl/gl"]],
["gl_texture_coord_array",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.C.O.O.R.D_.A.R.R.A.Y))",[0,[2,"GL_TEXTURE_COORD_ARRAY"]],["sgl/gl"]],
["gl_texture_coord_array_buffer_binding",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.C.O.O.R.D_.A.R.R.A.Y_.B.U.F.F.E.R_.B.I.N.D.I.N.G))",[0,[2,"GL_TEXTURE_COORD_ARRAY_BUFFER_BINDING"]],["sgl/gl"]],
["gl_texture_coord_array_pointer",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.C.O.O.R.D_.A.R.R.A.Y_.P.O.I.N.T.E.R))",[0,[2,"GL_TEXTURE_COORD_ARRAY_POINTER"]],["sgl/gl"]],
["gl_texture_coord_array_size",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.C.O.O.R.D_.A.R.R.A.Y_.S.I.Z.E))",[0,[2,"GL_TEXTURE_COORD_ARRAY_SIZE"]],["sgl/gl"]],
["gl_texture_coord_array_stride",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.C.O.O.R.D_.A.R.R.A.Y_.S.T.R.I.D.E))",[0,[2,"GL_TEXTURE_COORD_ARRAY_STRIDE"]],["sgl/gl"]],
["gl_texture_coord_array_type",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.C.O.O.R.D_.A.R.R.A.Y_.T.Y.P.E))",[0,[2,"GL_TEXTURE_COORD_ARRAY_TYPE"]],["sgl/gl"]],
["gl_texture_cube_map",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.C.U.B.E_.M.A.P))",[0,[2,"GL_TEXTURE_CUBE_MAP"]],["sgl/gl"]],
["gl_texture_cube_map_negative_x",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.C.U.B.E_.M.A.P_.N.E.G.A.T.I.V.E_.X))",[0,[2,"GL_TEXTURE_CUBE_MAP_NEGATIVE_X"]],["sgl/gl"]],
["gl_texture_cube_map_negative_y",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.C.U.B.E_.M.A.P_.N.E.G.A.T.I.V.E_.Y))",[0,[2,"GL_TEXTURE_CUBE_MAP_NEGATIVE_Y"]],["sgl/gl"]],
["gl_texture_cube_map_negative_z",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.C.U.B.E_.M.A.P_.N.E.G.A.T.I.V.E_.Z))",[0,[2,"GL_TEXTURE_CUBE_MAP_NEGATIVE_Z"]],["sgl/gl"]],
["gl_texture_cube_map_positive_x",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.C.U.B.E_.M.A.P_.P.O.S.I.T.I.V.E_.X))",[0,[2,"GL_TEXTURE_CUBE_MAP_POSITIVE_X"]],["sgl/gl"]],
["gl_texture_cube_map_positive_y",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.C.U.B.E_.M.A.P_.P.O.S.I.T.I.V.E_.Y))",[0,[2,"GL_TEXTURE_CUBE_MAP_POSITIVE_Y"]],["sgl/gl"]],
["gl_texture_cube_map_positive_z",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.C.U.B.E_.M.A.P_.P.O.S.I.T.I.V.E_.Z))",[0,[2,"GL_TEXTURE_CUBE_MAP_POSITIVE_Z"]],["sgl/gl"]],
["gl_texture_depth",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.D.E.P.T.H))",[0,[2,"GL_TEXTURE_DEPTH"]],["sgl/gl"]],
["gl_texture_depth_size",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.D.E.P.T.H_.S.I.Z.E))",[0,[2,"GL_TEXTURE_DEPTH_SIZE"]],["sgl/gl"]],
["gl_texture_env",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.E.N.V))",[0,[2,"GL_TEXTURE_ENV"]],["sgl/gl"]],
["gl_texture_env_color",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.E.N.V_.C.O.L.O.R))",[0,[2,"GL_TEXTURE_ENV_COLOR"]],["sgl/gl"]],
["gl_texture_env_mode",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.E.N.V_.M.O.D.E))",[0,[2,"GL_TEXTURE_ENV_MODE"]],["sgl/gl"]],
["gl_texture_filter_control",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.F.I.L.T.E.R_.C.O.N.T.R.O.L))",[0,[2,"GL_TEXTURE_FILTER_CONTROL"]],["sgl/gl"]],
["gl_texture_gen_mode",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.G.E.N_.M.O.D.E))",[0,[2,"GL_TEXTURE_GEN_MODE"]],["sgl/gl"]],
["gl_texture_gen_q",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.G.E.N_.Q))",[0,[2,"GL_TEXTURE_GEN_Q"]],["sgl/gl"]],
["gl_texture_gen_r",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.G.E.N_.R))",[0,[2,"GL_TEXTURE_GEN_R"]],["sgl/gl"]],
["gl_texture_gen_s",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.G.E.N_.S))",[0,[2,"GL_TEXTURE_GEN_S"]],["sgl/gl"]],
["gl_texture_gen_t",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.G.E.N_.T))",[0,[2,"GL_TEXTURE_GEN_T"]],["sgl/gl"]],
["gl_texture_green_size",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.G.R.E.E.N_.S.I.Z.E))",[0,[2,"GL_TEXTURE_GREEN_SIZE"]],["sgl/gl"]],
["gl_texture_height",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.H.E.I.G.H.T))",[0,[2,"GL_TEXTURE_HEIGHT"]],["sgl/gl"]],
["gl_texture_intensity_size",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.I.N.T.E.N.S.I.T.Y_.S.I.Z.E))",[0,[2,"GL_TEXTURE_INTENSITY_SIZE"]],["sgl/gl"]],
["gl_texture_internal_format",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.I.N.T.E.R.N.A.L_.F.O.R.M.A.T))",[0,[2,"GL_TEXTURE_INTERNAL_FORMAT"]],["sgl/gl"]],
["gl_texture_lod_bias",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.L.O.D_.B.I.A.S))",[0,[2,"GL_TEXTURE_LOD_BIAS"]],["sgl/gl"]],
["gl_texture_luminance_size",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.L.U.M.I.N.A.N.C.E_.S.I.Z.E))",[0,[2,"GL_TEXTURE_LUMINANCE_SIZE"]],["sgl/gl"]],
["gl_texture_mag_filter",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.M.A.G_.F.I.L.T.E.R))",[0,[2,"GL_TEXTURE_MAG_FILTER"]],["sgl/gl"]],
["gl_texture_matrix",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.M.A.T.R.I.X))",[0,[2,"GL_TEXTURE_MATRIX"]],["sgl/gl"]],
["gl_texture_max_level",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.M.A.X_.L.E.V.E.L))",[0,[2,"GL_TEXTURE_MAX_LEVEL"]],["sgl/gl"]],
["gl_texture_max_lod",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.M.A.X_.L.O.D))",[0,[2,"GL_TEXTURE_MAX_LOD"]],["sgl/gl"]],
["gl_texture_min_filter",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.M.I.N_.F.I.L.T.E.R))",[0,[2,"GL_TEXTURE_MIN_FILTER"]],["sgl/gl"]],
["gl_texture_min_lod",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.M.I.N_.L.O.D))",[0,[2,"GL_TEXTURE_MIN_LOD"]],["sgl/gl"]],
["gl_texture_priority",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.P.R.I.O.R.I.T.Y))",[0,[2,"GL_TEXTURE_PRIORITY"]],["sgl/gl"]],
["gl_texture_red_size",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.R.E.D_.S.I.Z.E))",[0,[2,"GL_TEXTURE_RED_SIZE"]],["sgl/gl"]],
["gl_texture_resident",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.R.E.S.I.D.E.N.T))",[0,[2,"GL_TEXTURE_RESIDENT"]],["sgl/gl"]],
["gl_texture_stack_depth",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.S.T.A.C.K_.D.E.P.T.H))",[0,[2,"GL_TEXTURE_STACK_DEPTH"]],["sgl/gl"]],
["gl_texture_width",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.W.I.D.T.H))",[0,[2,"GL_TEXTURE_WIDTH"]],["sgl/gl"]],
["gl_texture_wrap_r",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.W.R.A.P_.R))",[0,[2,"GL_TEXTURE_WRAP_R"]],["sgl/gl"]],
["gl_texture_wrap_s",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.W.R.A.P_.S))",[0,[2,"GL_TEXTURE_WRAP_S"]],["sgl/gl"]],
["gl_texture_wrap_t",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.E.X.T.U.R.E_.W.R.A.P_.T))",[0,[2,"GL_TEXTURE_WRAP_T"]],["sgl/gl"]],
["gl_transform_bit",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.R.A.N.S.F.O.R.M_.B.I.T))",[0,[2,"GL_TRANSFORM_BIT"]],["sgl/gl"]],
["gl_transpose_color_matrix",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.R.A.N.S.P.O.S.E_.C.O.L.O.R_.M.A.T.R.I.X))",[0,[2,"GL_TRANSPOSE_COLOR_MATRIX"]],["sgl/gl"]],
["gl_transpose_modelview_matrix",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.R.A.N.S.P.O.S.E_.M.O.D.E.L.V.I.E.W_.M.A.T.R.I.X))",[0,[2,"GL_TRANSPOSE_MODELVIEW_MATRIX"]],["sgl/gl"]],
["gl_transpose_projection_matrix",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.R.A.N.S.P.O.S.E_.P.R.O.J.E.C.T.I.O.N_.M.A.T.R.I.X))",[0,[2,"GL_TRANSPOSE_PROJECTION_MATRIX"]],["sgl/gl"]],
["gl_transpose_texture_matrix",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.R.A.N.S.P.O.S.E_.T.E.X.T.U.R.E_.M.A.T.R.I.X))",[0,[2,"GL_TRANSPOSE_TEXTURE_MATRIX"]],["sgl/gl"]],
["gl_triangle_fan",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.R.I.A.N.G.L.E_.F.A.N))",[0,[2,"GL_TRIANGLE_FAN"]],["sgl/gl"]],
["gl_triangle_strip",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.R.I.A.N.G.L.E_.S.T.R.I.P))",[0,[2,"GL_TRIANGLE_STRIP"]],["sgl/gl"]],
["gl_triangles",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.R.I.A.N.G.L.E.S))",[0,[2,"GL_TRIANGLES"]],["sgl/gl"]],
["gl_true",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.T.R.U.E))",[0,[2,"GL_TRUE"]],["sgl/gl"]],
["gl_true",">sgl/gl.html#(idx._(gentag._17._(lib._sgl/scribblings/sgl..scrbl)))",[6,"GL_TRUE"],false],
["gl_unpack_alignment",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.U.N.P.A.C.K_.A.L.I.G.N.M.E.N.T))",[0,[2,"GL_UNPACK_ALIGNMENT"]],["sgl/gl"]],
["gl_unpack_image_height",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.U.N.P.A.C.K_.I.M.A.G.E_.H.E.I.G.H.T))",[0,[2,"GL_UNPACK_IMAGE_HEIGHT"]],["sgl/gl"]],
["gl_unpack_lsb_first",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.U.N.P.A.C.K_.L.S.B_.F.I.R.S.T))",[0,[2,"GL_UNPACK_LSB_FIRST"]],["sgl/gl"]],
["gl_unpack_row_length",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.U.N.P.A.C.K_.R.O.W_.L.E.N.G.T.H))",[0,[2,"GL_UNPACK_ROW_LENGTH"]],["sgl/gl"]],
["gl_unpack_skip_images",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.U.N.P.A.C.K_.S.K.I.P_.I.M.A.G.E.S))",[0,[2,"GL_UNPACK_SKIP_IMAGES"]],["sgl/gl"]],
["gl_unpack_skip_pixels",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.U.N.P.A.C.K_.S.K.I.P_.P.I.X.E.L.S))",[0,[2,"GL_UNPACK_SKIP_PIXELS"]],["sgl/gl"]],
["gl_unpack_skip_rows",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.U.N.P.A.C.K_.S.K.I.P_.R.O.W.S))",[0,[2,"GL_UNPACK_SKIP_ROWS"]],["sgl/gl"]],
["gl_unpack_swap_bytes",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.U.N.P.A.C.K_.S.W.A.P_.B.Y.T.E.S))",[0,[2,"GL_UNPACK_SWAP_BYTES"]],["sgl/gl"]],
["gl_unsigned_byte",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.U.N.S.I.G.N.E.D_.B.Y.T.E))",[0,[2,"GL_UNSIGNED_BYTE"]],["sgl/gl"]],
["gl_unsigned_byte_2_3_3_rev",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.U.N.S.I.G.N.E.D_.B.Y.T.E_2_3_3_.R.E.V))",[0,[2,"GL_UNSIGNED_BYTE_2_3_3_REV"]],["sgl/gl"]],
["gl_unsigned_byte_3_3_2",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.U.N.S.I.G.N.E.D_.B.Y.T.E_3_3_2))",[0,[2,"GL_UNSIGNED_BYTE_3_3_2"]],["sgl/gl"]],
["gl_unsigned_int",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.U.N.S.I.G.N.E.D_.I.N.T))",[0,[2,"GL_UNSIGNED_INT"]],["sgl/gl"]],
["gl_unsigned_int_10_10_10_2",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.U.N.S.I.G.N.E.D_.I.N.T_10_10_10_2))",[0,[2,"GL_UNSIGNED_INT_10_10_10_2"]],["sgl/gl"]],
["gl_unsigned_int_2_10_10_10_rev",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.U.N.S.I.G.N.E.D_.I.N.T_2_10_10_10_.R.E.V))",[0,[2,"GL_UNSIGNED_INT_2_10_10_10_REV"]],["sgl/gl"]],
["gl_unsigned_int_8_8_8_8",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.U.N.S.I.G.N.E.D_.I.N.T_8_8_8_8))",[0,[2,"GL_UNSIGNED_INT_8_8_8_8"]],["sgl/gl"]],
["gl_unsigned_int_8_8_8_8_rev",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.U.N.S.I.G.N.E.D_.I.N.T_8_8_8_8_.R.E.V))",[0,[2,"GL_UNSIGNED_INT_8_8_8_8_REV"]],["sgl/gl"]],
["gl_unsigned_short",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.U.N.S.I.G.N.E.D_.S.H.O.R.T))",[0,[2,"GL_UNSIGNED_SHORT"]],["sgl/gl"]],
["gl_unsigned_short_1_5_5_5_rev",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.U.N.S.I.G.N.E.D_.S.H.O.R.T_1_5_5_5_.R.E.V))",[0,[2,"GL_UNSIGNED_SHORT_1_5_5_5_REV"]],["sgl/gl"]],
["gl_unsigned_short_4_4_4_4",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.U.N.S.I.G.N.E.D_.S.H.O.R.T_4_4_4_4))",[0,[2,"GL_UNSIGNED_SHORT_4_4_4_4"]],["sgl/gl"]],
["gl_unsigned_short_4_4_4_4_rev",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.U.N.S.I.G.N.E.D_.S.H.O.R.T_4_4_4_4_.R.E.V))",[0,[2,"GL_UNSIGNED_SHORT_4_4_4_4_REV"]],["sgl/gl"]],
["gl_unsigned_short_5_5_5_1",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.U.N.S.I.G.N.E.D_.S.H.O.R.T_5_5_5_1))",[0,[2,"GL_UNSIGNED_SHORT_5_5_5_1"]],["sgl/gl"]],
["gl_unsigned_short_5_6_5",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.U.N.S.I.G.N.E.D_.S.H.O.R.T_5_6_5))",[0,[2,"GL_UNSIGNED_SHORT_5_6_5"]],["sgl/gl"]],
["gl_unsigned_short_5_6_5_rev",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.U.N.S.I.G.N.E.D_.S.H.O.R.T_5_6_5_.R.E.V))",[0,[2,"GL_UNSIGNED_SHORT_5_6_5_REV"]],["sgl/gl"]],
["gl_v2f",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.V2.F))",[0,[2,"GL_V2F"]],["sgl/gl"]],
["gl_v3f",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.V3.F))",[0,[2,"GL_V3F"]],["sgl/gl"]],
["gl_vendor",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.V.E.N.D.O.R))",[0,[2,"GL_VENDOR"]],["sgl/gl"]],
["gl_version",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.V.E.R.S.I.O.N))",[0,[2,"GL_VERSION"]],["sgl/gl"]],
["gl_vertex_array",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.V.E.R.T.E.X_.A.R.R.A.Y))",[0,[2,"GL_VERTEX_ARRAY"]],["sgl/gl"]],
["gl_vertex_array_buffer_binding",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.V.E.R.T.E.X_.A.R.R.A.Y_.B.U.F.F.E.R_.B.I.N.D.I.N.G))",[0,[2,"GL_VERTEX_ARRAY_BUFFER_BINDING"]],["sgl/gl"]],
["gl_vertex_array_pointer",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.V.E.R.T.E.X_.A.R.R.A.Y_.P.O.I.N.T.E.R))",[0,[2,"GL_VERTEX_ARRAY_POINTER"]],["sgl/gl"]],
["gl_vertex_array_size",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.V.E.R.T.E.X_.A.R.R.A.Y_.S.I.Z.E))",[0,[2,"GL_VERTEX_ARRAY_SIZE"]],["sgl/gl"]],
["gl_vertex_array_stride",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.V.E.R.T.E.X_.A.R.R.A.Y_.S.T.R.I.D.E))",[0,[2,"GL_VERTEX_ARRAY_STRIDE"]],["sgl/gl"]],
["gl_vertex_array_type",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.V.E.R.T.E.X_.A.R.R.A.Y_.T.Y.P.E))",[0,[2,"GL_VERTEX_ARRAY_TYPE"]],["sgl/gl"]],
["gl_vertex_attrib_array_buffer_binding",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.V.E.R.T.E.X_.A.T.T.R.I.B_.A.R.R.A.Y_.B.U.F.F.E.R_.B.I.N.D.I.N.G))",[0,[2,"GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING"]],["sgl/gl"]],
["gl_viewport",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.V.I.E.W.P.O.R.T))",[0,[2,"GL_VIEWPORT"]],["sgl/gl"]],
["gl_viewport_bit",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.V.I.E.W.P.O.R.T_.B.I.T))",[0,[2,"GL_VIEWPORT_BIT"]],["sgl/gl"]],
["gl_weight_array_buffer_binding",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.W.E.I.G.H.T_.A.R.R.A.Y_.B.U.F.F.E.R_.B.I.N.D.I.N.G))",[0,[2,"GL_WEIGHT_ARRAY_BUFFER_BINDING"]],["sgl/gl"]],
["gl_write_only",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.W.R.I.T.E_.O.N.L.Y))",[0,[2,"GL_WRITE_ONLY"]],["sgl/gl"]],
["gl_xor",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.X.O.R))",[0,[2,"GL_XOR"]],["sgl/gl"]],
["gl_zero",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.Z.E.R.O))",[0,[2,"GL_ZERO"]],["sgl/gl"]],
["gl_zoom_x",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.Z.O.O.M_.X))",[0,[2,"GL_ZOOM_X"]],["sgl/gl"]],
["gl_zoom_y",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L_.Z.O.O.M_.Y))",[0,[2,"GL_ZOOM_Y"]],["sgl/gl"]],
["glaccum",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Accum))",[0,[2,"glAccum"]],["sgl/gl"]],
["glactivetexture",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Active.Texture))",[0,[2,"glActiveTexture"]],["sgl/gl"]],
["glalphafunc",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Alpha.Func))",[0,[2,"glAlphaFunc"]],["sgl/gl"]],
["glaretexturesresident",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Are.Textures.Resident))",[0,[2,"glAreTexturesResident"]],["sgl/gl"]],
["glass-icon-material",">images/Icons.html#(def._((lib._images/icons/style..rkt)._glass-icon-material))",[0,[2,"glass-icon-material"]],["images/icons/style"]],
["glbegin",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Begin))",[0,[2,"glBegin"]],["sgl/gl"]],
["glbeginquery",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Begin.Query))",[0,[2,"glBeginQuery"]],["sgl/gl"]],
["glbindtexture",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Bind.Texture))",[0,[2,"glBindTexture"]],["sgl/gl"]],
["glbitfield",">sgl/gl.html#(idx._(gentag._10._(lib._sgl/scribblings/sgl..scrbl)))",[6,"GLbitfield"],false],
["glbitmap",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Bitmap))",[0,[2,"glBitmap"]],["sgl/gl"]],
["glblendcolor",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Blend.Color))",[0,[2,"glBlendColor"]],["sgl/gl"]],
["glblendequation",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Blend.Equation))",[0,[2,"glBlendEquation"]],["sgl/gl"]],
["glblendfunc",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Blend.Func))",[0,[2,"glBlendFunc"]],["sgl/gl"]],
["glblendfuncseparate",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Blend.Func.Separate))",[0,[2,"glBlendFuncSeparate"]],["sgl/gl"]],
["glboolean",">sgl/gl.html#(idx._(gentag._15._(lib._sgl/scribblings/sgl..scrbl)))",[6,"GLboolean"],false],
["glbyte",">sgl/gl.html#(idx._(gentag._2._(lib._sgl/scribblings/sgl..scrbl)))",[6,"GLbyte"],false],
["glcalllist",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Call.List))",[0,[2,"glCallList"]],["sgl/gl"]],
["glcalllists",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Call.Lists))",[0,[2,"glCallLists"]],["sgl/gl"]],
["glclampd",">sgl/gl.html#(idx._(gentag._14._(lib._sgl/scribblings/sgl..scrbl)))",[6,"GLclampd"],false],
["glclear",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Clear))",[0,[2,"glClear"]],["sgl/gl"]],
["glclearaccum",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Clear.Accum))",[0,[2,"glClearAccum"]],["sgl/gl"]],
["glclearcolor",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Clear.Color))",[0,[2,"glClearColor"]],["sgl/gl"]],
["glcleardepth",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Clear.Depth))",[0,[2,"glClearDepth"]],["sgl/gl"]],
["glclearindex",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Clear.Index))",[0,[2,"glClearIndex"]],["sgl/gl"]],
["glclearstencil",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Clear.Stencil))",[0,[2,"glClearStencil"]],["sgl/gl"]],
["glclipplane",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Clip.Plane))",[0,[2,"glClipPlane"]],["sgl/gl"]],
["glcolor3b",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Color3b))",[0,[2,"glColor3b"]],["sgl/gl"]],
["glcolor3bv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Color3bv))",[0,[2,"glColor3bv"]],["sgl/gl"]],
["glcolor3d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Color3d))",[0,[2,"glColor3d"]],["sgl/gl"]],
["glcolor3dv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Color3dv))",[0,[2,"glColor3dv"]],["sgl/gl"]],
["glcolor3f",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Color3f))",[0,[2,"glColor3f"]],["sgl/gl"]],
["glcolor3fv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Color3fv))",[0,[2,"glColor3fv"]],["sgl/gl"]],
["glcolor3i",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Color3i))",[0,[2,"glColor3i"]],["sgl/gl"]],
["glcolor3iv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Color3iv))",[0,[2,"glColor3iv"]],["sgl/gl"]],
["glcolor3s",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Color3s))",[0,[2,"glColor3s"]],["sgl/gl"]],
["glcolor3sv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Color3sv))",[0,[2,"glColor3sv"]],["sgl/gl"]],
["glcolor3ub",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Color3ub))",[0,[2,"glColor3ub"]],["sgl/gl"]],
["glcolor3ubv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Color3ubv))",[0,[2,"glColor3ubv"]],["sgl/gl"]],
["glcolor3ui",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Color3ui))",[0,[2,"glColor3ui"]],["sgl/gl"]],
["glcolor3uiv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Color3uiv))",[0,[2,"glColor3uiv"]],["sgl/gl"]],
["glcolor3us",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Color3us))",[0,[2,"glColor3us"]],["sgl/gl"]],
["glcolor3usv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Color3usv))",[0,[2,"glColor3usv"]],["sgl/gl"]],
["glcolor4b",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Color4b))",[0,[2,"glColor4b"]],["sgl/gl"]],
["glcolor4bv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Color4bv))",[0,[2,"glColor4bv"]],["sgl/gl"]],
["glcolor4d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Color4d))",[0,[2,"glColor4d"]],["sgl/gl"]],
["glcolor4dv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Color4dv))",[0,[2,"glColor4dv"]],["sgl/gl"]],
["glcolor4f",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Color4f))",[0,[2,"glColor4f"]],["sgl/gl"]],
["glcolor4fv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Color4fv))",[0,[2,"glColor4fv"]],["sgl/gl"]],
["glcolor4i",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Color4i))",[0,[2,"glColor4i"]],["sgl/gl"]],
["glcolor4iv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Color4iv))",[0,[2,"glColor4iv"]],["sgl/gl"]],
["glcolor4s",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Color4s))",[0,[2,"glColor4s"]],["sgl/gl"]],
["glcolor4sv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Color4sv))",[0,[2,"glColor4sv"]],["sgl/gl"]],
["glcolor4ub",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Color4ub))",[0,[2,"glColor4ub"]],["sgl/gl"]],
["glcolor4ubv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Color4ubv))",[0,[2,"glColor4ubv"]],["sgl/gl"]],
["glcolor4ui",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Color4ui))",[0,[2,"glColor4ui"]],["sgl/gl"]],
["glcolor4uiv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Color4uiv))",[0,[2,"glColor4uiv"]],["sgl/gl"]],
["glcolor4us",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Color4us))",[0,[2,"glColor4us"]],["sgl/gl"]],
["glcolor4usv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Color4usv))",[0,[2,"glColor4usv"]],["sgl/gl"]],
["glcolormask",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Color.Mask))",[0,[2,"glColorMask"]],["sgl/gl"]],
["glcolormaterial",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Color.Material))",[0,[2,"glColorMaterial"]],["sgl/gl"]],
["glcolorsubtable",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Color.Sub.Table))",[0,[2,"glColorSubTable"]],["sgl/gl"]],
["glcolortable",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Color.Table))",[0,[2,"glColorTable"]],["sgl/gl"]],
["glcolortableparameterfv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Color.Table.Parameterfv))",[0,[2,"glColorTableParameterfv"]],["sgl/gl"]],
["glcolortableparameteriv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Color.Table.Parameteriv))",[0,[2,"glColorTableParameteriv"]],["sgl/gl"]],
["glcompressedteximage1d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Compressed.Tex.Image1.D))",[0,[2,"glCompressedTexImage1D"]],["sgl/gl"]],
["glcompressedteximage2d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Compressed.Tex.Image2.D))",[0,[2,"glCompressedTexImage2D"]],["sgl/gl"]],
["glcompressedteximage3d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Compressed.Tex.Image3.D))",[0,[2,"glCompressedTexImage3D"]],["sgl/gl"]],
["glcompressedtexsubimage1d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Compressed.Tex.Sub.Image1.D))",[0,[2,"glCompressedTexSubImage1D"]],["sgl/gl"]],
["glcompressedtexsubimage2d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Compressed.Tex.Sub.Image2.D))",[0,[2,"glCompressedTexSubImage2D"]],["sgl/gl"]],
["glcompressedtexsubimage3d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Compressed.Tex.Sub.Image3.D))",[0,[2,"glCompressedTexSubImage3D"]],["sgl/gl"]],
["glconvolutionfilter1d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Convolution.Filter1.D))",[0,[2,"glConvolutionFilter1D"]],["sgl/gl"]],
["glconvolutionfilter2d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Convolution.Filter2.D))",[0,[2,"glConvolutionFilter2D"]],["sgl/gl"]],
["glconvolutionparameterf",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Convolution.Parameterf))",[0,[2,"glConvolutionParameterf"]],["sgl/gl"]],
["glconvolutionparameterfv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Convolution.Parameterfv))",[0,[2,"glConvolutionParameterfv"]],["sgl/gl"]],
["glconvolutionparameteri",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Convolution.Parameteri))",[0,[2,"glConvolutionParameteri"]],["sgl/gl"]],
["glconvolutionparameteriv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Convolution.Parameteriv))",[0,[2,"glConvolutionParameteriv"]],["sgl/gl"]],
["glcopycolorsubtable",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Copy.Color.Sub.Table))",[0,[2,"glCopyColorSubTable"]],["sgl/gl"]],
["glcopycolortable",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Copy.Color.Table))",[0,[2,"glCopyColorTable"]],["sgl/gl"]],
["glcopyconvolutionfilter1d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Copy.Convolution.Filter1.D))",[0,[2,"glCopyConvolutionFilter1D"]],["sgl/gl"]],
["glcopyconvolutionfilter2d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Copy.Convolution.Filter2.D))",[0,[2,"glCopyConvolutionFilter2D"]],["sgl/gl"]],
["glcopypixels",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Copy.Pixels))",[0,[2,"glCopyPixels"]],["sgl/gl"]],
["glcopyteximage1d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Copy.Tex.Image1.D))",[0,[2,"glCopyTexImage1D"]],["sgl/gl"]],
["glcopyteximage2d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Copy.Tex.Image2.D))",[0,[2,"glCopyTexImage2D"]],["sgl/gl"]],
["glcopytexsubimage1d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Copy.Tex.Sub.Image1.D))",[0,[2,"glCopyTexSubImage1D"]],["sgl/gl"]],
["glcopytexsubimage2d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Copy.Tex.Sub.Image2.D))",[0,[2,"glCopyTexSubImage2D"]],["sgl/gl"]],
["glcopytexsubimage3d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Copy.Tex.Sub.Image3.D))",[0,[2,"glCopyTexSubImage3D"]],["sgl/gl"]],
["glcullface",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Cull.Face))",[0,[2,"glCullFace"]],["sgl/gl"]],
["gldeletelists",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Delete.Lists))",[0,[2,"glDeleteLists"]],["sgl/gl"]],
["gldeletequeries",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Delete.Queries))",[0,[2,"glDeleteQueries"]],["sgl/gl"]],
["gldeletetextures",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Delete.Textures))",[0,[2,"glDeleteTextures"]],["sgl/gl"]],
["gldepthfunc",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Depth.Func))",[0,[2,"glDepthFunc"]],["sgl/gl"]],
["gldepthmask",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Depth.Mask))",[0,[2,"glDepthMask"]],["sgl/gl"]],
["gldepthrange",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Depth.Range))",[0,[2,"glDepthRange"]],["sgl/gl"]],
["gldisable",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Disable))",[0,[2,"glDisable"]],["sgl/gl"]],
["gldouble",">sgl/gl.html#(idx._(gentag._12._(lib._sgl/scribblings/sgl..scrbl)))",[6,"GLdouble"],false],
["gldrawbuffer",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Draw.Buffer))",[0,[2,"glDrawBuffer"]],["sgl/gl"]],
["gldrawpixels",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Draw.Pixels))",[0,[2,"glDrawPixels"]],["sgl/gl"]],
["gledgeflag",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Edge.Flag))",[0,[2,"glEdgeFlag"]],["sgl/gl"]],
["gledgeflagv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Edge.Flagv))",[0,[2,"glEdgeFlagv"]],["sgl/gl"]],
["glenable",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Enable))",[0,[2,"glEnable"]],["sgl/gl"]],
["glend",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.End))",[0,[2,"glEnd"]],["sgl/gl"]],
["glendlist",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.End.List))",[0,[2,"glEndList"]],["sgl/gl"]],
["glendquery",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.End.Query))",[0,[2,"glEndQuery"]],["sgl/gl"]],
["glenum",">sgl/gl.html#(idx._(gentag._9._(lib._sgl/scribblings/sgl..scrbl)))",[6,"GLenum"],false],
["glevalcoord1d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Eval.Coord1d))",[0,[2,"glEvalCoord1d"]],["sgl/gl"]],
["glevalcoord1dv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Eval.Coord1dv))",[0,[2,"glEvalCoord1dv"]],["sgl/gl"]],
["glevalcoord1f",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Eval.Coord1f))",[0,[2,"glEvalCoord1f"]],["sgl/gl"]],
["glevalcoord1fv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Eval.Coord1fv))",[0,[2,"glEvalCoord1fv"]],["sgl/gl"]],
["glevalcoord2d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Eval.Coord2d))",[0,[2,"glEvalCoord2d"]],["sgl/gl"]],
["glevalcoord2dv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Eval.Coord2dv))",[0,[2,"glEvalCoord2dv"]],["sgl/gl"]],
["glevalcoord2f",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Eval.Coord2f))",[0,[2,"glEvalCoord2f"]],["sgl/gl"]],
["glevalcoord2fv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Eval.Coord2fv))",[0,[2,"glEvalCoord2fv"]],["sgl/gl"]],
["glevalmesh1",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Eval.Mesh1))",[0,[2,"glEvalMesh1"]],["sgl/gl"]],
["glevalmesh2",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Eval.Mesh2))",[0,[2,"glEvalMesh2"]],["sgl/gl"]],
["glevalpoint1",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Eval.Point1))",[0,[2,"glEvalPoint1"]],["sgl/gl"]],
["glevalpoint2",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Eval.Point2))",[0,[2,"glEvalPoint2"]],["sgl/gl"]],
["glfeedbackbuffer",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Feedback.Buffer))",[0,[2,"glFeedbackBuffer"]],["sgl/gl"]],
["glfinish",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Finish))",[0,[2,"glFinish"]],["sgl/gl"]],
["glflush",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Flush))",[0,[2,"glFlush"]],["sgl/gl"]],
["glfogcoordd",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Fog.Coordd))",[0,[2,"glFogCoordd"]],["sgl/gl"]],
["glfogcoorddv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Fog.Coorddv))",[0,[2,"glFogCoorddv"]],["sgl/gl"]],
["glfogcoordf",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Fog.Coordf))",[0,[2,"glFogCoordf"]],["sgl/gl"]],
["glfogcoordfv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Fog.Coordfv))",[0,[2,"glFogCoordfv"]],["sgl/gl"]],
["glfogf",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Fogf))",[0,[2,"glFogf"]],["sgl/gl"]],
["glfogfv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Fogfv))",[0,[2,"glFogfv"]],["sgl/gl"]],
["glfogi",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Fogi))",[0,[2,"glFogi"]],["sgl/gl"]],
["glfogiv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Fogiv))",[0,[2,"glFogiv"]],["sgl/gl"]],
["glfrontface",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Front.Face))",[0,[2,"glFrontFace"]],["sgl/gl"]],
["glfrustum",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Frustum))",[0,[2,"glFrustum"]],["sgl/gl"]],
["glgenlists",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Gen.Lists))",[0,[2,"glGenLists"]],["sgl/gl"]],
["glgenqueries",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Gen.Queries))",[0,[2,"glGenQueries"]],["sgl/gl"]],
["glgentextures",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Gen.Textures))",[0,[2,"glGenTextures"]],["sgl/gl"]],
["glgetbooleanv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Get.Booleanv))",[0,[2,"glGetBooleanv"]],["sgl/gl"]],
["glgetbufferparameteriv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Get.Buffer.Parameteriv))",[0,[2,"glGetBufferParameteriv"]],["sgl/gl"]],
["glgetclipplane",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Get.Clip.Plane))",[0,[2,"glGetClipPlane"]],["sgl/gl"]],
["glgetcolortable",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Get.Color.Table))",[0,[2,"glGetColorTable"]],["sgl/gl"]],
["glgetcompressedteximage",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Get.Compressed.Tex.Image))",[0,[2,"glGetCompressedTexImage"]],["sgl/gl"]],
["glgetconvolutionfilter",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Get.Convolution.Filter))",[0,[2,"glGetConvolutionFilter"]],["sgl/gl"]],
["glgetconvolutionparameterfv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Get.Convolution.Parameterfv))",[0,[2,"glGetConvolutionParameterfv"]],["sgl/gl"]],
["glgetconvolutionparameteriv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Get.Convolution.Parameteriv))",[0,[2,"glGetConvolutionParameteriv"]],["sgl/gl"]],
["glgetdoublev",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Get.Doublev))",[0,[2,"glGetDoublev"]],["sgl/gl"]],
["glgeterror",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Get.Error))",[0,[2,"glGetError"]],["sgl/gl"]],
["glgetfloatv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Get.Floatv))",[0,[2,"glGetFloatv"]],["sgl/gl"]],
["glgethistogram",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Get.Histogram))",[0,[2,"glGetHistogram"]],["sgl/gl"]],
["glgethistogramparameterfv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Get.Histogram.Parameterfv))",[0,[2,"glGetHistogramParameterfv"]],["sgl/gl"]],
["glgethistogramparameteriv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Get.Histogram.Parameteriv))",[0,[2,"glGetHistogramParameteriv"]],["sgl/gl"]],
["glgetintegerv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Get.Integerv))",[0,[2,"glGetIntegerv"]],["sgl/gl"]],
["glgetlightfv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Get.Lightfv))",[0,[2,"glGetLightfv"]],["sgl/gl"]],
["glgetlightiv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Get.Lightiv))",[0,[2,"glGetLightiv"]],["sgl/gl"]],
["glgetmapdv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Get.Mapdv))",[0,[2,"glGetMapdv"]],["sgl/gl"]],
["glgetmapfv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Get.Mapfv))",[0,[2,"glGetMapfv"]],["sgl/gl"]],
["glgetmapiv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Get.Mapiv))",[0,[2,"glGetMapiv"]],["sgl/gl"]],
["glgetmaterialfv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Get.Materialfv))",[0,[2,"glGetMaterialfv"]],["sgl/gl"]],
["glgetmaterialiv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Get.Materialiv))",[0,[2,"glGetMaterialiv"]],["sgl/gl"]],
["glgetminmax",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Get.Minmax))",[0,[2,"glGetMinmax"]],["sgl/gl"]],
["glgetminmaxparameterfv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Get.Minmax.Parameterfv))",[0,[2,"glGetMinmaxParameterfv"]],["sgl/gl"]],
["glgetminmaxparameteriv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Get.Minmax.Parameteriv))",[0,[2,"glGetMinmaxParameteriv"]],["sgl/gl"]],
["glgetpixelmapfv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Get.Pixel.Mapfv))",[0,[2,"glGetPixelMapfv"]],["sgl/gl"]],
["glgetpixelmapuiv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Get.Pixel.Mapuiv))",[0,[2,"glGetPixelMapuiv"]],["sgl/gl"]],
["glgetpixelmapusv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Get.Pixel.Mapusv))",[0,[2,"glGetPixelMapusv"]],["sgl/gl"]],
["glgetpolygonstipple",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Get.Polygon.Stipple))",[0,[2,"glGetPolygonStipple"]],["sgl/gl"]],
["glgetqueryiv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Get.Queryiv))",[0,[2,"glGetQueryiv"]],["sgl/gl"]],
["glgetqueryobjectiv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Get.Query.Objectiv))",[0,[2,"glGetQueryObjectiv"]],["sgl/gl"]],
["glgetqueryobjectuiv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Get.Query.Objectuiv))",[0,[2,"glGetQueryObjectuiv"]],["sgl/gl"]],
["glgetseparablefilter",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Get.Separable.Filter))",[0,[2,"glGetSeparableFilter"]],["sgl/gl"]],
["glgetstring",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Get.String))",[0,[2,"glGetString"]],["sgl/gl"]],
["glgettexenvfv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Get.Tex.Envfv))",[0,[2,"glGetTexEnvfv"]],["sgl/gl"]],
["glgettexenviv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Get.Tex.Enviv))",[0,[2,"glGetTexEnviv"]],["sgl/gl"]],
["glgettexgendv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Get.Tex.Gendv))",[0,[2,"glGetTexGendv"]],["sgl/gl"]],
["glgettexgenfv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Get.Tex.Genfv))",[0,[2,"glGetTexGenfv"]],["sgl/gl"]],
["glgettexgeniv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Get.Tex.Geniv))",[0,[2,"glGetTexGeniv"]],["sgl/gl"]],
["glgetteximage",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Get.Tex.Image))",[0,[2,"glGetTexImage"]],["sgl/gl"]],
["glgettexlevelparameterfv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Get.Tex.Level.Parameterfv))",[0,[2,"glGetTexLevelParameterfv"]],["sgl/gl"]],
["glgettexlevelparameteriv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Get.Tex.Level.Parameteriv))",[0,[2,"glGetTexLevelParameteriv"]],["sgl/gl"]],
["glgettexparameterfv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Get.Tex.Parameterfv))",[0,[2,"glGetTexParameterfv"]],["sgl/gl"]],
["glgettexparameteriv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Get.Tex.Parameteriv))",[0,[2,"glGetTexParameteriv"]],["sgl/gl"]],
["glhint",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Hint))",[0,[2,"glHint"]],["sgl/gl"]],
["glhistogram",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Histogram))",[0,[2,"glHistogram"]],["sgl/gl"]],
["glindexd",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Indexd))",[0,[2,"glIndexd"]],["sgl/gl"]],
["glindexdv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Indexdv))",[0,[2,"glIndexdv"]],["sgl/gl"]],
["glindexf",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Indexf))",[0,[2,"glIndexf"]],["sgl/gl"]],
["glindexfv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Indexfv))",[0,[2,"glIndexfv"]],["sgl/gl"]],
["glindexi",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Indexi))",[0,[2,"glIndexi"]],["sgl/gl"]],
["glindexiv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Indexiv))",[0,[2,"glIndexiv"]],["sgl/gl"]],
["glindexmask",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Index.Mask))",[0,[2,"glIndexMask"]],["sgl/gl"]],
["glindexs",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Indexs))",[0,[2,"glIndexs"]],["sgl/gl"]],
["glindexsv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Indexsv))",[0,[2,"glIndexsv"]],["sgl/gl"]],
["glindexub",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Indexub))",[0,[2,"glIndexub"]],["sgl/gl"]],
["glindexubv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Indexubv))",[0,[2,"glIndexubv"]],["sgl/gl"]],
["glinitnames",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Init.Names))",[0,[2,"glInitNames"]],["sgl/gl"]],
["glint",">sgl/gl.html#(idx._(gentag._4._(lib._sgl/scribblings/sgl..scrbl)))",[6,"GLint"],false],
["glisbuffer",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Is.Buffer))",[0,[2,"glIsBuffer"]],["sgl/gl"]],
["glisenabled",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Is.Enabled))",[0,[2,"glIsEnabled"]],["sgl/gl"]],
["glislist",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Is.List))",[0,[2,"glIsList"]],["sgl/gl"]],
["glisquery",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Is.Query))",[0,[2,"glIsQuery"]],["sgl/gl"]],
["glistexture",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Is.Texture))",[0,[2,"glIsTexture"]],["sgl/gl"]],
["gllightf",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Lightf))",[0,[2,"glLightf"]],["sgl/gl"]],
["gllightfv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Lightfv))",[0,[2,"glLightfv"]],["sgl/gl"]],
["gllighti",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Lighti))",[0,[2,"glLighti"]],["sgl/gl"]],
["gllightiv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Lightiv))",[0,[2,"glLightiv"]],["sgl/gl"]],
["gllightmodelf",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Light.Modelf))",[0,[2,"glLightModelf"]],["sgl/gl"]],
["gllightmodelfv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Light.Modelfv))",[0,[2,"glLightModelfv"]],["sgl/gl"]],
["gllightmodeli",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Light.Modeli))",[0,[2,"glLightModeli"]],["sgl/gl"]],
["gllightmodeliv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Light.Modeliv))",[0,[2,"glLightModeliv"]],["sgl/gl"]],
["gllinestipple",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Line.Stipple))",[0,[2,"glLineStipple"]],["sgl/gl"]],
["gllinewidth",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Line.Width))",[0,[2,"glLineWidth"]],["sgl/gl"]],
["gllistbase",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.List.Base))",[0,[2,"glListBase"]],["sgl/gl"]],
["glloadidentity",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Load.Identity))",[0,[2,"glLoadIdentity"]],["sgl/gl"]],
["glloadmatrixd",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Load.Matrixd))",[0,[2,"glLoadMatrixd"]],["sgl/gl"]],
["glloadmatrixf",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Load.Matrixf))",[0,[2,"glLoadMatrixf"]],["sgl/gl"]],
["glloadname",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Load.Name))",[0,[2,"glLoadName"]],["sgl/gl"]],
["glloadtransposematrixd",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Load.Transpose.Matrixd))",[0,[2,"glLoadTransposeMatrixd"]],["sgl/gl"]],
["glloadtransposematrixf",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Load.Transpose.Matrixf))",[0,[2,"glLoadTransposeMatrixf"]],["sgl/gl"]],
["gllogicop",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Logic.Op))",[0,[2,"glLogicOp"]],["sgl/gl"]],
["glmap1d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Map1d))",[0,[2,"glMap1d"]],["sgl/gl"]],
["glmap1f",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Map1f))",[0,[2,"glMap1f"]],["sgl/gl"]],
["glmap2d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Map2d))",[0,[2,"glMap2d"]],["sgl/gl"]],
["glmap2f",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Map2f))",[0,[2,"glMap2f"]],["sgl/gl"]],
["glmapgrid1d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Map.Grid1d))",[0,[2,"glMapGrid1d"]],["sgl/gl"]],
["glmapgrid1f",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Map.Grid1f))",[0,[2,"glMapGrid1f"]],["sgl/gl"]],
["glmapgrid2d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Map.Grid2d))",[0,[2,"glMapGrid2d"]],["sgl/gl"]],
["glmapgrid2f",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Map.Grid2f))",[0,[2,"glMapGrid2f"]],["sgl/gl"]],
["glmaterialf",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Materialf))",[0,[2,"glMaterialf"]],["sgl/gl"]],
["glmaterialfv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Materialfv))",[0,[2,"glMaterialfv"]],["sgl/gl"]],
["glmateriali",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Materiali))",[0,[2,"glMateriali"]],["sgl/gl"]],
["glmaterialiv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Materialiv))",[0,[2,"glMaterialiv"]],["sgl/gl"]],
["glmatrixmode",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Matrix.Mode))",[0,[2,"glMatrixMode"]],["sgl/gl"]],
["glminmax",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Minmax))",[0,[2,"glMinmax"]],["sgl/gl"]],
["glmultitexcoord1d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Multi.Tex.Coord1d))",[0,[2,"glMultiTexCoord1d"]],["sgl/gl"]],
["glmultitexcoord1dv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Multi.Tex.Coord1dv))",[0,[2,"glMultiTexCoord1dv"]],["sgl/gl"]],
["glmultitexcoord1f",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Multi.Tex.Coord1f))",[0,[2,"glMultiTexCoord1f"]],["sgl/gl"]],
["glmultitexcoord1fv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Multi.Tex.Coord1fv))",[0,[2,"glMultiTexCoord1fv"]],["sgl/gl"]],
["glmultitexcoord1i",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Multi.Tex.Coord1i))",[0,[2,"glMultiTexCoord1i"]],["sgl/gl"]],
["glmultitexcoord1iv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Multi.Tex.Coord1iv))",[0,[2,"glMultiTexCoord1iv"]],["sgl/gl"]],
["glmultitexcoord1s",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Multi.Tex.Coord1s))",[0,[2,"glMultiTexCoord1s"]],["sgl/gl"]],
["glmultitexcoord1sv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Multi.Tex.Coord1sv))",[0,[2,"glMultiTexCoord1sv"]],["sgl/gl"]],
["glmultitexcoord2d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Multi.Tex.Coord2d))",[0,[2,"glMultiTexCoord2d"]],["sgl/gl"]],
["glmultitexcoord2dv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Multi.Tex.Coord2dv))",[0,[2,"glMultiTexCoord2dv"]],["sgl/gl"]],
["glmultitexcoord2f",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Multi.Tex.Coord2f))",[0,[2,"glMultiTexCoord2f"]],["sgl/gl"]],
["glmultitexcoord2fv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Multi.Tex.Coord2fv))",[0,[2,"glMultiTexCoord2fv"]],["sgl/gl"]],
["glmultitexcoord2i",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Multi.Tex.Coord2i))",[0,[2,"glMultiTexCoord2i"]],["sgl/gl"]],
["glmultitexcoord2iv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Multi.Tex.Coord2iv))",[0,[2,"glMultiTexCoord2iv"]],["sgl/gl"]],
["glmultitexcoord2s",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Multi.Tex.Coord2s))",[0,[2,"glMultiTexCoord2s"]],["sgl/gl"]],
["glmultitexcoord2sv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Multi.Tex.Coord2sv))",[0,[2,"glMultiTexCoord2sv"]],["sgl/gl"]],
["glmultitexcoord3d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Multi.Tex.Coord3d))",[0,[2,"glMultiTexCoord3d"]],["sgl/gl"]],
["glmultitexcoord3dv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Multi.Tex.Coord3dv))",[0,[2,"glMultiTexCoord3dv"]],["sgl/gl"]],
["glmultitexcoord3f",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Multi.Tex.Coord3f))",[0,[2,"glMultiTexCoord3f"]],["sgl/gl"]],
["glmultitexcoord3fv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Multi.Tex.Coord3fv))",[0,[2,"glMultiTexCoord3fv"]],["sgl/gl"]],
["glmultitexcoord3i",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Multi.Tex.Coord3i))",[0,[2,"glMultiTexCoord3i"]],["sgl/gl"]],
["glmultitexcoord3iv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Multi.Tex.Coord3iv))",[0,[2,"glMultiTexCoord3iv"]],["sgl/gl"]],
["glmultitexcoord3s",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Multi.Tex.Coord3s))",[0,[2,"glMultiTexCoord3s"]],["sgl/gl"]],
["glmultitexcoord3sv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Multi.Tex.Coord3sv))",[0,[2,"glMultiTexCoord3sv"]],["sgl/gl"]],
["glmultitexcoord4d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Multi.Tex.Coord4d))",[0,[2,"glMultiTexCoord4d"]],["sgl/gl"]],
["glmultitexcoord4dv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Multi.Tex.Coord4dv))",[0,[2,"glMultiTexCoord4dv"]],["sgl/gl"]],
["glmultitexcoord4f",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Multi.Tex.Coord4f))",[0,[2,"glMultiTexCoord4f"]],["sgl/gl"]],
["glmultitexcoord4fv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Multi.Tex.Coord4fv))",[0,[2,"glMultiTexCoord4fv"]],["sgl/gl"]],
["glmultitexcoord4i",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Multi.Tex.Coord4i))",[0,[2,"glMultiTexCoord4i"]],["sgl/gl"]],
["glmultitexcoord4iv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Multi.Tex.Coord4iv))",[0,[2,"glMultiTexCoord4iv"]],["sgl/gl"]],
["glmultitexcoord4s",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Multi.Tex.Coord4s))",[0,[2,"glMultiTexCoord4s"]],["sgl/gl"]],
["glmultitexcoord4sv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Multi.Tex.Coord4sv))",[0,[2,"glMultiTexCoord4sv"]],["sgl/gl"]],
["glmultmatrixd",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Mult.Matrixd))",[0,[2,"glMultMatrixd"]],["sgl/gl"]],
["glmultmatrixf",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Mult.Matrixf))",[0,[2,"glMultMatrixf"]],["sgl/gl"]],
["glmulttransposematrixd",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Mult.Transpose.Matrixd))",[0,[2,"glMultTransposeMatrixd"]],["sgl/gl"]],
["glmulttransposematrixf",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Mult.Transpose.Matrixf))",[0,[2,"glMultTransposeMatrixf"]],["sgl/gl"]],
["glnewlist",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.New.List))",[0,[2,"glNewList"]],["sgl/gl"]],
["glnormal3b",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Normal3b))",[0,[2,"glNormal3b"]],["sgl/gl"]],
["glnormal3bv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Normal3bv))",[0,[2,"glNormal3bv"]],["sgl/gl"]],
["glnormal3d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Normal3d))",[0,[2,"glNormal3d"]],["sgl/gl"]],
["glnormal3dv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Normal3dv))",[0,[2,"glNormal3dv"]],["sgl/gl"]],
["glnormal3f",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Normal3f))",[0,[2,"glNormal3f"]],["sgl/gl"]],
["glnormal3fv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Normal3fv))",[0,[2,"glNormal3fv"]],["sgl/gl"]],
["glnormal3i",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Normal3i))",[0,[2,"glNormal3i"]],["sgl/gl"]],
["glnormal3iv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Normal3iv))",[0,[2,"glNormal3iv"]],["sgl/gl"]],
["glnormal3s",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Normal3s))",[0,[2,"glNormal3s"]],["sgl/gl"]],
["glnormal3sv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Normal3sv))",[0,[2,"glNormal3sv"]],["sgl/gl"]],
["glob->regexp",">mzlib/mzlib_string.html#(def._((lib._mzlib/string..rkt)._glob-~3eregexp))",[0,[2,"glob->regexp"]],["mzlib/string"]],
["global constants",">inside/im_values_types.html#(part._.Global_.Constants)","Global Constants",false],
["global coordinates",">gui/window___.html#(idx._(gentag._138._(lib._scribblings/gui/gui..scrbl)))","global coordinates",false],
["global coordinates",">gui/window___.html#(idx._(gentag._142._(lib._scribblings/gui/gui..scrbl)))","global coordinates",false],
["global data: headers and footers",">gui/editor-overview.html#(part._globaleditordata)","Global Data: Headers and Footers",false],
["global graphics",">gui/Windowing_Functions.html#(part._.Global_.Graphics)","Global Graphics",false],
["global port print handler",">reference/Writing.html#(tech._global._port._print._handler)","<span style=\"font-style: italic\">global port print handler</span>",false],
["global-bucket",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._global-bucket))",[0,[2,"global-bucket"]],["compiler/zo-structs"]],
["global-bucket-name",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._global-bucket-name))",[0,[2,"global-bucket-name"]],["compiler/zo-structs"]],
["global-bucket?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._global-bucket~3f))",[0,[2,"global-bucket?"]],["compiler/zo-structs"]],
["global-port-print-handler",">reference/Writing.html#(def._((quote._~23~25kernel)._global-port-print-handler))",[0,[2,"global-port-print-handler"]],["racket/base","racket"]],
["global-to-local",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._global-to-local))",[[0,[2,"global-to-local"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["globals in extension code",">inside/im_memoryalloc.html#(idx._(gentag._212._(lib._scribblings/inside/inside..scrbl)))","globals, in extension code",false],
["globals",">inside/im_env.html#(idx._(gentag._272._(lib._scribblings/inside/inside..scrbl)))","globals",false],
["glortho",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Ortho))",[0,[2,"glOrtho"]],["sgl/gl"]],
["glossary of racklog primitives",">racklog/glossary.html","Glossary of Racklog Primitives",false],
["glpassthrough",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Pass.Through))",[0,[2,"glPassThrough"]],["sgl/gl"]],
["glpixelmapfv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Pixel.Mapfv))",[0,[2,"glPixelMapfv"]],["sgl/gl"]],
["glpixelmapuiv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Pixel.Mapuiv))",[0,[2,"glPixelMapuiv"]],["sgl/gl"]],
["glpixelmapusv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Pixel.Mapusv))",[0,[2,"glPixelMapusv"]],["sgl/gl"]],
["glpixelstoref",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Pixel.Storef))",[0,[2,"glPixelStoref"]],["sgl/gl"]],
["glpixelstorei",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Pixel.Storei))",[0,[2,"glPixelStorei"]],["sgl/gl"]],
["glpixeltransferf",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Pixel.Transferf))",[0,[2,"glPixelTransferf"]],["sgl/gl"]],
["glpixeltransferi",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Pixel.Transferi))",[0,[2,"glPixelTransferi"]],["sgl/gl"]],
["glpixelzoom",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Pixel.Zoom))",[0,[2,"glPixelZoom"]],["sgl/gl"]],
["glpointparameterf",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Point.Parameterf))",[0,[2,"glPointParameterf"]],["sgl/gl"]],
["glpointparameterfv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Point.Parameterfv))",[0,[2,"glPointParameterfv"]],["sgl/gl"]],
["glpointparameteri",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Point.Parameteri))",[0,[2,"glPointParameteri"]],["sgl/gl"]],
["glpointparameteriv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Point.Parameteriv))",[0,[2,"glPointParameteriv"]],["sgl/gl"]],
["glpointsize",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Point.Size))",[0,[2,"glPointSize"]],["sgl/gl"]],
["glpolygonmode",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Polygon.Mode))",[0,[2,"glPolygonMode"]],["sgl/gl"]],
["glpolygonoffset",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Polygon.Offset))",[0,[2,"glPolygonOffset"]],["sgl/gl"]],
["glpolygonstipple",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Polygon.Stipple))",[0,[2,"glPolygonStipple"]],["sgl/gl"]],
["glpopattrib",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Pop.Attrib))",[0,[2,"glPopAttrib"]],["sgl/gl"]],
["glpopclientattrib",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Pop.Client.Attrib))",[0,[2,"glPopClientAttrib"]],["sgl/gl"]],
["glpopmatrix",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Pop.Matrix))",[0,[2,"glPopMatrix"]],["sgl/gl"]],
["glpopname",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Pop.Name))",[0,[2,"glPopName"]],["sgl/gl"]],
["glpushattrib",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Push.Attrib))",[0,[2,"glPushAttrib"]],["sgl/gl"]],
["glpushclientattrib",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Push.Client.Attrib))",[0,[2,"glPushClientAttrib"]],["sgl/gl"]],
["glpushmatrix",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Push.Matrix))",[0,[2,"glPushMatrix"]],["sgl/gl"]],
["glpushname",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Push.Name))",[0,[2,"glPushName"]],["sgl/gl"]],
["glrasterpos2d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Raster.Pos2d))",[0,[2,"glRasterPos2d"]],["sgl/gl"]],
["glrasterpos2dv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Raster.Pos2dv))",[0,[2,"glRasterPos2dv"]],["sgl/gl"]],
["glrasterpos2f",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Raster.Pos2f))",[0,[2,"glRasterPos2f"]],["sgl/gl"]],
["glrasterpos2fv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Raster.Pos2fv))",[0,[2,"glRasterPos2fv"]],["sgl/gl"]],
["glrasterpos2i",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Raster.Pos2i))",[0,[2,"glRasterPos2i"]],["sgl/gl"]],
["glrasterpos2iv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Raster.Pos2iv))",[0,[2,"glRasterPos2iv"]],["sgl/gl"]],
["glrasterpos2s",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Raster.Pos2s))",[0,[2,"glRasterPos2s"]],["sgl/gl"]],
["glrasterpos2sv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Raster.Pos2sv))",[0,[2,"glRasterPos2sv"]],["sgl/gl"]],
["glrasterpos3d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Raster.Pos3d))",[0,[2,"glRasterPos3d"]],["sgl/gl"]],
["glrasterpos3dv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Raster.Pos3dv))",[0,[2,"glRasterPos3dv"]],["sgl/gl"]],
["glrasterpos3f",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Raster.Pos3f))",[0,[2,"glRasterPos3f"]],["sgl/gl"]],
["glrasterpos3fv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Raster.Pos3fv))",[0,[2,"glRasterPos3fv"]],["sgl/gl"]],
["glrasterpos3i",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Raster.Pos3i))",[0,[2,"glRasterPos3i"]],["sgl/gl"]],
["glrasterpos3iv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Raster.Pos3iv))",[0,[2,"glRasterPos3iv"]],["sgl/gl"]],
["glrasterpos3s",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Raster.Pos3s))",[0,[2,"glRasterPos3s"]],["sgl/gl"]],
["glrasterpos3sv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Raster.Pos3sv))",[0,[2,"glRasterPos3sv"]],["sgl/gl"]],
["glrasterpos4d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Raster.Pos4d))",[0,[2,"glRasterPos4d"]],["sgl/gl"]],
["glrasterpos4dv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Raster.Pos4dv))",[0,[2,"glRasterPos4dv"]],["sgl/gl"]],
["glrasterpos4f",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Raster.Pos4f))",[0,[2,"glRasterPos4f"]],["sgl/gl"]],
["glrasterpos4fv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Raster.Pos4fv))",[0,[2,"glRasterPos4fv"]],["sgl/gl"]],
["glrasterpos4i",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Raster.Pos4i))",[0,[2,"glRasterPos4i"]],["sgl/gl"]],
["glrasterpos4iv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Raster.Pos4iv))",[0,[2,"glRasterPos4iv"]],["sgl/gl"]],
["glrasterpos4s",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Raster.Pos4s))",[0,[2,"glRasterPos4s"]],["sgl/gl"]],
["glrasterpos4sv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Raster.Pos4sv))",[0,[2,"glRasterPos4sv"]],["sgl/gl"]],
["glreadbuffer",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Read.Buffer))",[0,[2,"glReadBuffer"]],["sgl/gl"]],
["glreadpixels",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Read.Pixels))",[0,[2,"glReadPixels"]],["sgl/gl"]],
["glrectd",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Rectd))",[0,[2,"glRectd"]],["sgl/gl"]],
["glrectdv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Rectdv))",[0,[2,"glRectdv"]],["sgl/gl"]],
["glrectf",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Rectf))",[0,[2,"glRectf"]],["sgl/gl"]],
["glrectfv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Rectfv))",[0,[2,"glRectfv"]],["sgl/gl"]],
["glrecti",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Recti))",[0,[2,"glRecti"]],["sgl/gl"]],
["glrectiv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Rectiv))",[0,[2,"glRectiv"]],["sgl/gl"]],
["glrects",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Rects))",[0,[2,"glRects"]],["sgl/gl"]],
["glrectsv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Rectsv))",[0,[2,"glRectsv"]],["sgl/gl"]],
["glrendermode",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Render.Mode))",[0,[2,"glRenderMode"]],["sgl/gl"]],
["glresethistogram",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Reset.Histogram))",[0,[2,"glResetHistogram"]],["sgl/gl"]],
["glresetminmax",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Reset.Minmax))",[0,[2,"glResetMinmax"]],["sgl/gl"]],
["glrotated",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Rotated))",[0,[2,"glRotated"]],["sgl/gl"]],
["glrotatef",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Rotatef))",[0,[2,"glRotatef"]],["sgl/gl"]],
["glsamplecoverage",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Sample.Coverage))",[0,[2,"glSampleCoverage"]],["sgl/gl"]],
["glscaled",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Scaled))",[0,[2,"glScaled"]],["sgl/gl"]],
["glscalef",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Scalef))",[0,[2,"glScalef"]],["sgl/gl"]],
["glscissor",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Scissor))",[0,[2,"glScissor"]],["sgl/gl"]],
["glsecondarycolor3b",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Secondary.Color3b))",[0,[2,"glSecondaryColor3b"]],["sgl/gl"]],
["glsecondarycolor3bv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Secondary.Color3bv))",[0,[2,"glSecondaryColor3bv"]],["sgl/gl"]],
["glsecondarycolor3d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Secondary.Color3d))",[0,[2,"glSecondaryColor3d"]],["sgl/gl"]],
["glsecondarycolor3dv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Secondary.Color3dv))",[0,[2,"glSecondaryColor3dv"]],["sgl/gl"]],
["glsecondarycolor3f",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Secondary.Color3f))",[0,[2,"glSecondaryColor3f"]],["sgl/gl"]],
["glsecondarycolor3fv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Secondary.Color3fv))",[0,[2,"glSecondaryColor3fv"]],["sgl/gl"]],
["glsecondarycolor3i",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Secondary.Color3i))",[0,[2,"glSecondaryColor3i"]],["sgl/gl"]],
["glsecondarycolor3iv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Secondary.Color3iv))",[0,[2,"glSecondaryColor3iv"]],["sgl/gl"]],
["glsecondarycolor3s",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Secondary.Color3s))",[0,[2,"glSecondaryColor3s"]],["sgl/gl"]],
["glsecondarycolor3sv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Secondary.Color3sv))",[0,[2,"glSecondaryColor3sv"]],["sgl/gl"]],
["glsecondarycolor3ub",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Secondary.Color3ub))",[0,[2,"glSecondaryColor3ub"]],["sgl/gl"]],
["glsecondarycolor3ubv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Secondary.Color3ubv))",[0,[2,"glSecondaryColor3ubv"]],["sgl/gl"]],
["glsecondarycolor3ui",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Secondary.Color3ui))",[0,[2,"glSecondaryColor3ui"]],["sgl/gl"]],
["glsecondarycolor3uiv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Secondary.Color3uiv))",[0,[2,"glSecondaryColor3uiv"]],["sgl/gl"]],
["glsecondarycolor3us",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Secondary.Color3us))",[0,[2,"glSecondaryColor3us"]],["sgl/gl"]],
["glsecondarycolor3usv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Secondary.Color3usv))",[0,[2,"glSecondaryColor3usv"]],["sgl/gl"]],
["glselectbuffer",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Select.Buffer))",[0,[2,"glSelectBuffer"]],["sgl/gl"]],
["glseparablefilter2d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Separable.Filter2.D))",[0,[2,"glSeparableFilter2D"]],["sgl/gl"]],
["glshademodel",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Shade.Model))",[0,[2,"glShadeModel"]],["sgl/gl"]],
["glshort",">sgl/gl.html#(idx._(gentag._3._(lib._sgl/scribblings/sgl..scrbl)))",[6,"GLshort"],false],
["glsizei",">sgl/gl.html#(idx._(gentag._8._(lib._sgl/scribblings/sgl..scrbl)))",[6,"GLsizei"],false],
["glstencilfunc",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Stencil.Func))",[0,[2,"glStencilFunc"]],["sgl/gl"]],
["glstencilmask",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Stencil.Mask))",[0,[2,"glStencilMask"]],["sgl/gl"]],
["glstencilop",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Stencil.Op))",[0,[2,"glStencilOp"]],["sgl/gl"]],
["gltexcoord1d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Tex.Coord1d))",[0,[2,"glTexCoord1d"]],["sgl/gl"]],
["gltexcoord1dv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Tex.Coord1dv))",[0,[2,"glTexCoord1dv"]],["sgl/gl"]],
["gltexcoord1f",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Tex.Coord1f))",[0,[2,"glTexCoord1f"]],["sgl/gl"]],
["gltexcoord1fv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Tex.Coord1fv))",[0,[2,"glTexCoord1fv"]],["sgl/gl"]],
["gltexcoord1i",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Tex.Coord1i))",[0,[2,"glTexCoord1i"]],["sgl/gl"]],
["gltexcoord1iv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Tex.Coord1iv))",[0,[2,"glTexCoord1iv"]],["sgl/gl"]],
["gltexcoord1s",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Tex.Coord1s))",[0,[2,"glTexCoord1s"]],["sgl/gl"]],
["gltexcoord1sv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Tex.Coord1sv))",[0,[2,"glTexCoord1sv"]],["sgl/gl"]],
["gltexcoord2d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Tex.Coord2d))",[0,[2,"glTexCoord2d"]],["sgl/gl"]],
["gltexcoord2dv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Tex.Coord2dv))",[0,[2,"glTexCoord2dv"]],["sgl/gl"]],
["gltexcoord2f",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Tex.Coord2f))",[0,[2,"glTexCoord2f"]],["sgl/gl"]],
["gltexcoord2fv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Tex.Coord2fv))",[0,[2,"glTexCoord2fv"]],["sgl/gl"]],
["gltexcoord2i",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Tex.Coord2i))",[0,[2,"glTexCoord2i"]],["sgl/gl"]],
["gltexcoord2iv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Tex.Coord2iv))",[0,[2,"glTexCoord2iv"]],["sgl/gl"]],
["gltexcoord2s",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Tex.Coord2s))",[0,[2,"glTexCoord2s"]],["sgl/gl"]],
["gltexcoord2sv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Tex.Coord2sv))",[0,[2,"glTexCoord2sv"]],["sgl/gl"]],
["gltexcoord3d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Tex.Coord3d))",[0,[2,"glTexCoord3d"]],["sgl/gl"]],
["gltexcoord3dv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Tex.Coord3dv))",[0,[2,"glTexCoord3dv"]],["sgl/gl"]],
["gltexcoord3f",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Tex.Coord3f))",[0,[2,"glTexCoord3f"]],["sgl/gl"]],
["gltexcoord3fv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Tex.Coord3fv))",[0,[2,"glTexCoord3fv"]],["sgl/gl"]],
["gltexcoord3i",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Tex.Coord3i))",[0,[2,"glTexCoord3i"]],["sgl/gl"]],
["gltexcoord3iv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Tex.Coord3iv))",[0,[2,"glTexCoord3iv"]],["sgl/gl"]],
["gltexcoord3s",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Tex.Coord3s))",[0,[2,"glTexCoord3s"]],["sgl/gl"]],
["gltexcoord3sv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Tex.Coord3sv))",[0,[2,"glTexCoord3sv"]],["sgl/gl"]],
["gltexcoord4d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Tex.Coord4d))",[0,[2,"glTexCoord4d"]],["sgl/gl"]],
["gltexcoord4dv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Tex.Coord4dv))",[0,[2,"glTexCoord4dv"]],["sgl/gl"]],
["gltexcoord4f",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Tex.Coord4f))",[0,[2,"glTexCoord4f"]],["sgl/gl"]],
["gltexcoord4fv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Tex.Coord4fv))",[0,[2,"glTexCoord4fv"]],["sgl/gl"]],
["gltexcoord4i",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Tex.Coord4i))",[0,[2,"glTexCoord4i"]],["sgl/gl"]],
["gltexcoord4iv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Tex.Coord4iv))",[0,[2,"glTexCoord4iv"]],["sgl/gl"]],
["gltexcoord4s",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Tex.Coord4s))",[0,[2,"glTexCoord4s"]],["sgl/gl"]],
["gltexcoord4sv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Tex.Coord4sv))",[0,[2,"glTexCoord4sv"]],["sgl/gl"]],
["gltexenvf",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Tex.Envf))",[0,[2,"glTexEnvf"]],["sgl/gl"]],
["gltexenvfv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Tex.Envfv))",[0,[2,"glTexEnvfv"]],["sgl/gl"]],
["gltexenvi",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Tex.Envi))",[0,[2,"glTexEnvi"]],["sgl/gl"]],
["gltexenviv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Tex.Enviv))",[0,[2,"glTexEnviv"]],["sgl/gl"]],
["gltexgend",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Tex.Gend))",[0,[2,"glTexGend"]],["sgl/gl"]],
["gltexgendv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Tex.Gendv))",[0,[2,"glTexGendv"]],["sgl/gl"]],
["gltexgenf",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Tex.Genf))",[0,[2,"glTexGenf"]],["sgl/gl"]],
["gltexgenfv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Tex.Genfv))",[0,[2,"glTexGenfv"]],["sgl/gl"]],
["gltexgeni",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Tex.Geni))",[0,[2,"glTexGeni"]],["sgl/gl"]],
["gltexgeniv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Tex.Geniv))",[0,[2,"glTexGeniv"]],["sgl/gl"]],
["glteximage1d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Tex.Image1.D))",[0,[2,"glTexImage1D"]],["sgl/gl"]],
["glteximage2d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Tex.Image2.D))",[0,[2,"glTexImage2D"]],["sgl/gl"]],
["glteximage3d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Tex.Image3.D))",[0,[2,"glTexImage3D"]],["sgl/gl"]],
["gltexparameterf",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Tex.Parameterf))",[0,[2,"glTexParameterf"]],["sgl/gl"]],
["gltexparameterfv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Tex.Parameterfv))",[0,[2,"glTexParameterfv"]],["sgl/gl"]],
["gltexparameteri",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Tex.Parameteri))",[0,[2,"glTexParameteri"]],["sgl/gl"]],
["gltexparameteriv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Tex.Parameteriv))",[0,[2,"glTexParameteriv"]],["sgl/gl"]],
["gltexsubimage1d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Tex.Sub.Image1.D))",[0,[2,"glTexSubImage1D"]],["sgl/gl"]],
["gltexsubimage2d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Tex.Sub.Image2.D))",[0,[2,"glTexSubImage2D"]],["sgl/gl"]],
["gltexsubimage3d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Tex.Sub.Image3.D))",[0,[2,"glTexSubImage3D"]],["sgl/gl"]],
["gltranslated",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Translated))",[0,[2,"glTranslated"]],["sgl/gl"]],
["gltranslatef",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Translatef))",[0,[2,"glTranslatef"]],["sgl/gl"]],
["glu",">sgl/index.html#(idx._(gentag._1._(lib._sgl/scribblings/sgl..scrbl)))","GLU",false],
["glu_auto_load_matrix",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.A.U.T.O_.L.O.A.D_.M.A.T.R.I.X))",[0,[2,"GLU_AUTO_LOAD_MATRIX"]],["sgl/gl"]],
["glu_begin",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.B.E.G.I.N))",[0,[2,"GLU_BEGIN"]],["sgl/gl"]],
["glu_ccw",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.C.C.W))",[0,[2,"GLU_CCW"]],["sgl/gl"]],
["glu_culling",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.C.U.L.L.I.N.G))",[0,[2,"GLU_CULLING"]],["sgl/gl"]],
["glu_cw",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.C.W))",[0,[2,"GLU_CW"]],["sgl/gl"]],
["glu_display_mode",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.D.I.S.P.L.A.Y_.M.O.D.E))",[0,[2,"GLU_DISPLAY_MODE"]],["sgl/gl"]],
["glu_domain_distance",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.D.O.M.A.I.N_.D.I.S.T.A.N.C.E))",[0,[2,"GLU_DOMAIN_DISTANCE"]],["sgl/gl"]],
["glu_edge_flag",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.E.D.G.E_.F.L.A.G))",[0,[2,"GLU_EDGE_FLAG"]],["sgl/gl"]],
["glu_end",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.E.N.D))",[0,[2,"GLU_END"]],["sgl/gl"]],
["glu_error",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.E.R.R.O.R))",[0,[2,"GLU_ERROR"]],["sgl/gl"]],
["glu_extensions",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.E.X.T.E.N.S.I.O.N.S))",[0,[2,"GLU_EXTENSIONS"]],["sgl/gl"]],
["glu_exterior",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.E.X.T.E.R.I.O.R))",[0,[2,"GLU_EXTERIOR"]],["sgl/gl"]],
["glu_false",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.F.A.L.S.E))",[0,[2,"GLU_FALSE"]],["sgl/gl"]],
["glu_fill",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.F.I.L.L))",[0,[2,"GLU_FILL"]],["sgl/gl"]],
["glu_flat",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.F.L.A.T))",[0,[2,"GLU_FLAT"]],["sgl/gl"]],
["glu_inside",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.I.N.S.I.D.E))",[0,[2,"GLU_INSIDE"]],["sgl/gl"]],
["glu_interior",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.I.N.T.E.R.I.O.R))",[0,[2,"GLU_INTERIOR"]],["sgl/gl"]],
["glu_invalid_enum",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.I.N.V.A.L.I.D_.E.N.U.M))",[0,[2,"GLU_INVALID_ENUM"]],["sgl/gl"]],
["glu_invalid_operation",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.I.N.V.A.L.I.D_.O.P.E.R.A.T.I.O.N))",[0,[2,"GLU_INVALID_OPERATION"]],["sgl/gl"]],
["glu_invalid_value",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.I.N.V.A.L.I.D_.V.A.L.U.E))",[0,[2,"GLU_INVALID_VALUE"]],["sgl/gl"]],
["glu_line",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.L.I.N.E))",[0,[2,"GLU_LINE"]],["sgl/gl"]],
["glu_map1_trim_2",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.M.A.P1_.T.R.I.M_2))",[0,[2,"GLU_MAP1_TRIM_2"]],["sgl/gl"]],
["glu_map1_trim_3",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.M.A.P1_.T.R.I.M_3))",[0,[2,"GLU_MAP1_TRIM_3"]],["sgl/gl"]],
["glu_none",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.O.N.E))",[0,[2,"GLU_NONE"]],["sgl/gl"]],
["glu_nurbs_begin",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.B.E.G.I.N))",[0,[2,"GLU_NURBS_BEGIN"]],["sgl/gl"]],
["glu_nurbs_begin_data",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.B.E.G.I.N_.D.A.T.A))",[0,[2,"GLU_NURBS_BEGIN_DATA"]],["sgl/gl"]],
["glu_nurbs_begin_data_ext",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.B.E.G.I.N_.D.A.T.A_.E.X.T))",[0,[2,"GLU_NURBS_BEGIN_DATA_EXT"]],["sgl/gl"]],
["glu_nurbs_begin_ext",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.B.E.G.I.N_.E.X.T))",[0,[2,"GLU_NURBS_BEGIN_EXT"]],["sgl/gl"]],
["glu_nurbs_color",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.C.O.L.O.R))",[0,[2,"GLU_NURBS_COLOR"]],["sgl/gl"]],
["glu_nurbs_color_data",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.C.O.L.O.R_.D.A.T.A))",[0,[2,"GLU_NURBS_COLOR_DATA"]],["sgl/gl"]],
["glu_nurbs_color_data_ext",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.C.O.L.O.R_.D.A.T.A_.E.X.T))",[0,[2,"GLU_NURBS_COLOR_DATA_EXT"]],["sgl/gl"]],
["glu_nurbs_color_ext",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.C.O.L.O.R_.E.X.T))",[0,[2,"GLU_NURBS_COLOR_EXT"]],["sgl/gl"]],
["glu_nurbs_end",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.E.N.D))",[0,[2,"GLU_NURBS_END"]],["sgl/gl"]],
["glu_nurbs_end_data",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.E.N.D_.D.A.T.A))",[0,[2,"GLU_NURBS_END_DATA"]],["sgl/gl"]],
["glu_nurbs_end_data_ext",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.E.N.D_.D.A.T.A_.E.X.T))",[0,[2,"GLU_NURBS_END_DATA_EXT"]],["sgl/gl"]],
["glu_nurbs_end_ext",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.E.N.D_.E.X.T))",[0,[2,"GLU_NURBS_END_EXT"]],["sgl/gl"]],
["glu_nurbs_error",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R))",[0,[2,"GLU_NURBS_ERROR"]],["sgl/gl"]],
["glu_nurbs_error1",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R1))",[0,[2,"GLU_NURBS_ERROR1"]],["sgl/gl"]],
["glu_nurbs_error10",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R10))",[0,[2,"GLU_NURBS_ERROR10"]],["sgl/gl"]],
["glu_nurbs_error11",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R11))",[0,[2,"GLU_NURBS_ERROR11"]],["sgl/gl"]],
["glu_nurbs_error12",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R12))",[0,[2,"GLU_NURBS_ERROR12"]],["sgl/gl"]],
["glu_nurbs_error13",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R13))",[0,[2,"GLU_NURBS_ERROR13"]],["sgl/gl"]],
["glu_nurbs_error14",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R14))",[0,[2,"GLU_NURBS_ERROR14"]],["sgl/gl"]],
["glu_nurbs_error15",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R15))",[0,[2,"GLU_NURBS_ERROR15"]],["sgl/gl"]],
["glu_nurbs_error16",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R16))",[0,[2,"GLU_NURBS_ERROR16"]],["sgl/gl"]],
["glu_nurbs_error17",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R17))",[0,[2,"GLU_NURBS_ERROR17"]],["sgl/gl"]],
["glu_nurbs_error18",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R18))",[0,[2,"GLU_NURBS_ERROR18"]],["sgl/gl"]],
["glu_nurbs_error19",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R19))",[0,[2,"GLU_NURBS_ERROR19"]],["sgl/gl"]],
["glu_nurbs_error2",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R2))",[0,[2,"GLU_NURBS_ERROR2"]],["sgl/gl"]],
["glu_nurbs_error20",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R20))",[0,[2,"GLU_NURBS_ERROR20"]],["sgl/gl"]],
["glu_nurbs_error21",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R21))",[0,[2,"GLU_NURBS_ERROR21"]],["sgl/gl"]],
["glu_nurbs_error22",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R22))",[0,[2,"GLU_NURBS_ERROR22"]],["sgl/gl"]],
["glu_nurbs_error23",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R23))",[0,[2,"GLU_NURBS_ERROR23"]],["sgl/gl"]],
["glu_nurbs_error24",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R24))",[0,[2,"GLU_NURBS_ERROR24"]],["sgl/gl"]],
["glu_nurbs_error25",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R25))",[0,[2,"GLU_NURBS_ERROR25"]],["sgl/gl"]],
["glu_nurbs_error26",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R26))",[0,[2,"GLU_NURBS_ERROR26"]],["sgl/gl"]],
["glu_nurbs_error27",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R27))",[0,[2,"GLU_NURBS_ERROR27"]],["sgl/gl"]],
["glu_nurbs_error28",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R28))",[0,[2,"GLU_NURBS_ERROR28"]],["sgl/gl"]],
["glu_nurbs_error29",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R29))",[0,[2,"GLU_NURBS_ERROR29"]],["sgl/gl"]],
["glu_nurbs_error3",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R3))",[0,[2,"GLU_NURBS_ERROR3"]],["sgl/gl"]],
["glu_nurbs_error30",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R30))",[0,[2,"GLU_NURBS_ERROR30"]],["sgl/gl"]],
["glu_nurbs_error31",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R31))",[0,[2,"GLU_NURBS_ERROR31"]],["sgl/gl"]],
["glu_nurbs_error32",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R32))",[0,[2,"GLU_NURBS_ERROR32"]],["sgl/gl"]],
["glu_nurbs_error33",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R33))",[0,[2,"GLU_NURBS_ERROR33"]],["sgl/gl"]],
["glu_nurbs_error34",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R34))",[0,[2,"GLU_NURBS_ERROR34"]],["sgl/gl"]],
["glu_nurbs_error35",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R35))",[0,[2,"GLU_NURBS_ERROR35"]],["sgl/gl"]],
["glu_nurbs_error36",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R36))",[0,[2,"GLU_NURBS_ERROR36"]],["sgl/gl"]],
["glu_nurbs_error37",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R37))",[0,[2,"GLU_NURBS_ERROR37"]],["sgl/gl"]],
["glu_nurbs_error4",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R4))",[0,[2,"GLU_NURBS_ERROR4"]],["sgl/gl"]],
["glu_nurbs_error5",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R5))",[0,[2,"GLU_NURBS_ERROR5"]],["sgl/gl"]],
["glu_nurbs_error6",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R6))",[0,[2,"GLU_NURBS_ERROR6"]],["sgl/gl"]],
["glu_nurbs_error7",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R7))",[0,[2,"GLU_NURBS_ERROR7"]],["sgl/gl"]],
["glu_nurbs_error8",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R8))",[0,[2,"GLU_NURBS_ERROR8"]],["sgl/gl"]],
["glu_nurbs_error9",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R9))",[0,[2,"GLU_NURBS_ERROR9"]],["sgl/gl"]],
["glu_nurbs_mode",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.M.O.D.E))",[0,[2,"GLU_NURBS_MODE"]],["sgl/gl"]],
["glu_nurbs_mode_ext",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.M.O.D.E_.E.X.T))",[0,[2,"GLU_NURBS_MODE_EXT"]],["sgl/gl"]],
["glu_nurbs_normal",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.N.O.R.M.A.L))",[0,[2,"GLU_NURBS_NORMAL"]],["sgl/gl"]],
["glu_nurbs_normal_data",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.N.O.R.M.A.L_.D.A.T.A))",[0,[2,"GLU_NURBS_NORMAL_DATA"]],["sgl/gl"]],
["glu_nurbs_normal_data_ext",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.N.O.R.M.A.L_.D.A.T.A_.E.X.T))",[0,[2,"GLU_NURBS_NORMAL_DATA_EXT"]],["sgl/gl"]],
["glu_nurbs_normal_ext",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.N.O.R.M.A.L_.E.X.T))",[0,[2,"GLU_NURBS_NORMAL_EXT"]],["sgl/gl"]],
["glu_nurbs_renderer",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.R.E.N.D.E.R.E.R))",[0,[2,"GLU_NURBS_RENDERER"]],["sgl/gl"]],
["glu_nurbs_renderer_ext",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.R.E.N.D.E.R.E.R_.E.X.T))",[0,[2,"GLU_NURBS_RENDERER_EXT"]],["sgl/gl"]],
["glu_nurbs_tessellator",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.T.E.S.S.E.L.L.A.T.O.R))",[0,[2,"GLU_NURBS_TESSELLATOR"]],["sgl/gl"]],
["glu_nurbs_tessellator_ext",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.T.E.S.S.E.L.L.A.T.O.R_.E.X.T))",[0,[2,"GLU_NURBS_TESSELLATOR_EXT"]],["sgl/gl"]],
["glu_nurbs_tex_coord_data_ext",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.T.E.X_.C.O.O.R.D_.D.A.T.A_.E.X.T))",[0,[2,"GLU_NURBS_TEX_COORD_DATA_EXT"]],["sgl/gl"]],
["glu_nurbs_tex_coord_ext",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.T.E.X_.C.O.O.R.D_.E.X.T))",[0,[2,"GLU_NURBS_TEX_COORD_EXT"]],["sgl/gl"]],
["glu_nurbs_texture_coord",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.T.E.X.T.U.R.E_.C.O.O.R.D))",[0,[2,"GLU_NURBS_TEXTURE_COORD"]],["sgl/gl"]],
["glu_nurbs_texture_coord_data",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.T.E.X.T.U.R.E_.C.O.O.R.D_.D.A.T.A))",[0,[2,"GLU_NURBS_TEXTURE_COORD_DATA"]],["sgl/gl"]],
["glu_nurbs_vertex",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.V.E.R.T.E.X))",[0,[2,"GLU_NURBS_VERTEX"]],["sgl/gl"]],
["glu_nurbs_vertex_data",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.V.E.R.T.E.X_.D.A.T.A))",[0,[2,"GLU_NURBS_VERTEX_DATA"]],["sgl/gl"]],
["glu_nurbs_vertex_data_ext",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.V.E.R.T.E.X_.D.A.T.A_.E.X.T))",[0,[2,"GLU_NURBS_VERTEX_DATA_EXT"]],["sgl/gl"]],
["glu_nurbs_vertex_ext",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.N.U.R.B.S_.V.E.R.T.E.X_.E.X.T))",[0,[2,"GLU_NURBS_VERTEX_EXT"]],["sgl/gl"]],
["glu_object_parametric_error",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.O.B.J.E.C.T_.P.A.R.A.M.E.T.R.I.C_.E.R.R.O.R))",[0,[2,"GLU_OBJECT_PARAMETRIC_ERROR"]],["sgl/gl"]],
["glu_object_parametric_error_ext",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.O.B.J.E.C.T_.P.A.R.A.M.E.T.R.I.C_.E.R.R.O.R_.E.X.T))",[0,[2,"GLU_OBJECT_PARAMETRIC_ERROR_EXT"]],["sgl/gl"]],
["glu_object_path_length",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.O.B.J.E.C.T_.P.A.T.H_.L.E.N.G.T.H))",[0,[2,"GLU_OBJECT_PATH_LENGTH"]],["sgl/gl"]],
["glu_object_path_length_ext",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.O.B.J.E.C.T_.P.A.T.H_.L.E.N.G.T.H_.E.X.T))",[0,[2,"GLU_OBJECT_PATH_LENGTH_EXT"]],["sgl/gl"]],
["glu_out_of_memory",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.O.U.T_.O.F_.M.E.M.O.R.Y))",[0,[2,"GLU_OUT_OF_MEMORY"]],["sgl/gl"]],
["glu_outline_patch",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.O.U.T.L.I.N.E_.P.A.T.C.H))",[0,[2,"GLU_OUTLINE_PATCH"]],["sgl/gl"]],
["glu_outline_polygon",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.O.U.T.L.I.N.E_.P.O.L.Y.G.O.N))",[0,[2,"GLU_OUTLINE_POLYGON"]],["sgl/gl"]],
["glu_outside",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.O.U.T.S.I.D.E))",[0,[2,"GLU_OUTSIDE"]],["sgl/gl"]],
["glu_parametric_error",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.P.A.R.A.M.E.T.R.I.C_.E.R.R.O.R))",[0,[2,"GLU_PARAMETRIC_ERROR"]],["sgl/gl"]],
["glu_parametric_tolerance",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.P.A.R.A.M.E.T.R.I.C_.T.O.L.E.R.A.N.C.E))",[0,[2,"GLU_PARAMETRIC_TOLERANCE"]],["sgl/gl"]],
["glu_path_length",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.P.A.T.H_.L.E.N.G.T.H))",[0,[2,"GLU_PATH_LENGTH"]],["sgl/gl"]],
["glu_point",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.P.O.I.N.T))",[0,[2,"GLU_POINT"]],["sgl/gl"]],
["glu_sampling_method",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.S.A.M.P.L.I.N.G_.M.E.T.H.O.D))",[0,[2,"GLU_SAMPLING_METHOD"]],["sgl/gl"]],
["glu_sampling_tolerance",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.S.A.M.P.L.I.N.G_.T.O.L.E.R.A.N.C.E))",[0,[2,"GLU_SAMPLING_TOLERANCE"]],["sgl/gl"]],
["glu_silhouette",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.S.I.L.H.O.U.E.T.T.E))",[0,[2,"GLU_SILHOUETTE"]],["sgl/gl"]],
["glu_smooth",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.S.M.O.O.T.H))",[0,[2,"GLU_SMOOTH"]],["sgl/gl"]],
["glu_tess_begin",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.T.E.S.S_.B.E.G.I.N))",[0,[2,"GLU_TESS_BEGIN"]],["sgl/gl"]],
["glu_tess_begin_data",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.T.E.S.S_.B.E.G.I.N_.D.A.T.A))",[0,[2,"GLU_TESS_BEGIN_DATA"]],["sgl/gl"]],
["glu_tess_boundary_only",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.T.E.S.S_.B.O.U.N.D.A.R.Y_.O.N.L.Y))",[0,[2,"GLU_TESS_BOUNDARY_ONLY"]],["sgl/gl"]],
["glu_tess_combine",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.T.E.S.S_.C.O.M.B.I.N.E))",[0,[2,"GLU_TESS_COMBINE"]],["sgl/gl"]],
["glu_tess_combine_data",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.T.E.S.S_.C.O.M.B.I.N.E_.D.A.T.A))",[0,[2,"GLU_TESS_COMBINE_DATA"]],["sgl/gl"]],
["glu_tess_coord_too_large",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.T.E.S.S_.C.O.O.R.D_.T.O.O_.L.A.R.G.E))",[0,[2,"GLU_TESS_COORD_TOO_LARGE"]],["sgl/gl"]],
["glu_tess_edge_flag",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.T.E.S.S_.E.D.G.E_.F.L.A.G))",[0,[2,"GLU_TESS_EDGE_FLAG"]],["sgl/gl"]],
["glu_tess_edge_flag_data",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.T.E.S.S_.E.D.G.E_.F.L.A.G_.D.A.T.A))",[0,[2,"GLU_TESS_EDGE_FLAG_DATA"]],["sgl/gl"]],
["glu_tess_end",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.T.E.S.S_.E.N.D))",[0,[2,"GLU_TESS_END"]],["sgl/gl"]],
["glu_tess_end_data",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.T.E.S.S_.E.N.D_.D.A.T.A))",[0,[2,"GLU_TESS_END_DATA"]],["sgl/gl"]],
["glu_tess_error",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.T.E.S.S_.E.R.R.O.R))",[0,[2,"GLU_TESS_ERROR"]],["sgl/gl"]],
["glu_tess_error1",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.T.E.S.S_.E.R.R.O.R1))",[0,[2,"GLU_TESS_ERROR1"]],["sgl/gl"]],
["glu_tess_error2",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.T.E.S.S_.E.R.R.O.R2))",[0,[2,"GLU_TESS_ERROR2"]],["sgl/gl"]],
["glu_tess_error3",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.T.E.S.S_.E.R.R.O.R3))",[0,[2,"GLU_TESS_ERROR3"]],["sgl/gl"]],
["glu_tess_error4",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.T.E.S.S_.E.R.R.O.R4))",[0,[2,"GLU_TESS_ERROR4"]],["sgl/gl"]],
["glu_tess_error5",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.T.E.S.S_.E.R.R.O.R5))",[0,[2,"GLU_TESS_ERROR5"]],["sgl/gl"]],
["glu_tess_error6",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.T.E.S.S_.E.R.R.O.R6))",[0,[2,"GLU_TESS_ERROR6"]],["sgl/gl"]],
["glu_tess_error7",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.T.E.S.S_.E.R.R.O.R7))",[0,[2,"GLU_TESS_ERROR7"]],["sgl/gl"]],
["glu_tess_error8",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.T.E.S.S_.E.R.R.O.R8))",[0,[2,"GLU_TESS_ERROR8"]],["sgl/gl"]],
["glu_tess_error_data",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.T.E.S.S_.E.R.R.O.R_.D.A.T.A))",[0,[2,"GLU_TESS_ERROR_DATA"]],["sgl/gl"]],
["glu_tess_max_coord",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.T.E.S.S_.M.A.X_.C.O.O.R.D))",[0,[2,"GLU_TESS_MAX_COORD"]],["sgl/gl"]],
["glu_tess_missing_begin_contour",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.T.E.S.S_.M.I.S.S.I.N.G_.B.E.G.I.N_.C.O.N.T.O.U.R))",[0,[2,"GLU_TESS_MISSING_BEGIN_CONTOUR"]],["sgl/gl"]],
["glu_tess_missing_begin_polygon",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.T.E.S.S_.M.I.S.S.I.N.G_.B.E.G.I.N_.P.O.L.Y.G.O.N))",[0,[2,"GLU_TESS_MISSING_BEGIN_POLYGON"]],["sgl/gl"]],
["glu_tess_missing_end_contour",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.T.E.S.S_.M.I.S.S.I.N.G_.E.N.D_.C.O.N.T.O.U.R))",[0,[2,"GLU_TESS_MISSING_END_CONTOUR"]],["sgl/gl"]],
["glu_tess_missing_end_polygon",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.T.E.S.S_.M.I.S.S.I.N.G_.E.N.D_.P.O.L.Y.G.O.N))",[0,[2,"GLU_TESS_MISSING_END_POLYGON"]],["sgl/gl"]],
["glu_tess_need_combine_callback",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.T.E.S.S_.N.E.E.D_.C.O.M.B.I.N.E_.C.A.L.L.B.A.C.K))",[0,[2,"GLU_TESS_NEED_COMBINE_CALLBACK"]],["sgl/gl"]],
["glu_tess_tolerance",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.T.E.S.S_.T.O.L.E.R.A.N.C.E))",[0,[2,"GLU_TESS_TOLERANCE"]],["sgl/gl"]],
["glu_tess_vertex",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.T.E.S.S_.V.E.R.T.E.X))",[0,[2,"GLU_TESS_VERTEX"]],["sgl/gl"]],
["glu_tess_vertex_data",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.T.E.S.S_.V.E.R.T.E.X_.D.A.T.A))",[0,[2,"GLU_TESS_VERTEX_DATA"]],["sgl/gl"]],
["glu_tess_winding_abs_geq_two",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.T.E.S.S_.W.I.N.D.I.N.G_.A.B.S_.G.E.Q_.T.W.O))",[0,[2,"GLU_TESS_WINDING_ABS_GEQ_TWO"]],["sgl/gl"]],
["glu_tess_winding_negative",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.T.E.S.S_.W.I.N.D.I.N.G_.N.E.G.A.T.I.V.E))",[0,[2,"GLU_TESS_WINDING_NEGATIVE"]],["sgl/gl"]],
["glu_tess_winding_nonzero",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.T.E.S.S_.W.I.N.D.I.N.G_.N.O.N.Z.E.R.O))",[0,[2,"GLU_TESS_WINDING_NONZERO"]],["sgl/gl"]],
["glu_tess_winding_odd",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.T.E.S.S_.W.I.N.D.I.N.G_.O.D.D))",[0,[2,"GLU_TESS_WINDING_ODD"]],["sgl/gl"]],
["glu_tess_winding_positive",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.T.E.S.S_.W.I.N.D.I.N.G_.P.O.S.I.T.I.V.E))",[0,[2,"GLU_TESS_WINDING_POSITIVE"]],["sgl/gl"]],
["glu_tess_winding_rule",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.T.E.S.S_.W.I.N.D.I.N.G_.R.U.L.E))",[0,[2,"GLU_TESS_WINDING_RULE"]],["sgl/gl"]],
["glu_true",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.T.R.U.E))",[0,[2,"GLU_TRUE"]],["sgl/gl"]],
["glu_u_step",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.U_.S.T.E.P))",[0,[2,"GLU_U_STEP"]],["sgl/gl"]],
["glu_unknown",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.U.N.K.N.O.W.N))",[0,[2,"GLU_UNKNOWN"]],["sgl/gl"]],
["glu_v_step",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.V_.S.T.E.P))",[0,[2,"GLU_V_STEP"]],["sgl/gl"]],
["glu_version",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.V.E.R.S.I.O.N))",[0,[2,"GLU_VERSION"]],["sgl/gl"]],
["glu_vertex",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._.G.L.U_.V.E.R.T.E.X))",[0,[2,"GLU_VERTEX"]],["sgl/gl"]],
["glubuild1dmipmaplevels",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._glu.Build1.D.Mipmap.Levels))",[0,[2,"gluBuild1DMipmapLevels"]],["sgl/gl"]],
["glubuild1dmipmaps",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._glu.Build1.D.Mipmaps))",[0,[2,"gluBuild1DMipmaps"]],["sgl/gl"]],
["glubuild2dmipmaplevels",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._glu.Build2.D.Mipmap.Levels))",[0,[2,"gluBuild2DMipmapLevels"]],["sgl/gl"]],
["glubuild2dmipmaps",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._glu.Build2.D.Mipmaps))",[0,[2,"gluBuild2DMipmaps"]],["sgl/gl"]],
["glubuild3dmipmaplevels",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._glu.Build3.D.Mipmap.Levels))",[0,[2,"gluBuild3DMipmapLevels"]],["sgl/gl"]],
["glubuild3dmipmaps",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._glu.Build3.D.Mipmaps))",[0,[2,"gluBuild3DMipmaps"]],["sgl/gl"]],
["glubyte",">sgl/gl.html#(idx._(gentag._5._(lib._sgl/scribblings/sgl..scrbl)))",[6,"GLubyte"],false],
["glucheckextension",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._glu.Check.Extension))",[0,[2,"gluCheckExtension"]],["sgl/gl"]],
["glucylinder",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._glu.Cylinder))",[0,[2,"gluCylinder"]],["sgl/gl"]],
["gludisk",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._glu.Disk))",[0,[2,"gluDisk"]],["sgl/gl"]],
["gluerrorstring",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._glu.Error.String))",[0,[2,"gluErrorString"]],["sgl/gl"]],
["glugetstring",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._glu.Get.String))",[0,[2,"gluGetString"]],["sgl/gl"]],
["gluint",">sgl/gl.html#(idx._(gentag._7._(lib._sgl/scribblings/sgl..scrbl)))",[6,"GLuint"],false],
["glulookat",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._glu.Look.At))",[0,[2,"gluLookAt"]],["sgl/gl"]],
["glunewquadric",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._glu.New.Quadric))",[0,[2,"gluNewQuadric"]],["sgl/gl"]],
["gluortho2d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._glu.Ortho2.D))",[0,[2,"gluOrtho2D"]],["sgl/gl"]],
["glupartialdisk",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._glu.Partial.Disk))",[0,[2,"gluPartialDisk"]],["sgl/gl"]],
["gluperspective",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._glu.Perspective))",[0,[2,"gluPerspective"]],["sgl/gl"]],
["glupickmatrix",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._glu.Pick.Matrix))",[0,[2,"gluPickMatrix"]],["sgl/gl"]],
["gluproject",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._glu.Project))",[0,[2,"gluProject"]],["sgl/gl"]],
["gluquadricdrawstyle",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._glu.Quadric.Draw.Style))",[0,[2,"gluQuadricDrawStyle"]],["sgl/gl"]],
["gluquadricnormals",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._glu.Quadric.Normals))",[0,[2,"gluQuadricNormals"]],["sgl/gl"]],
["gluquadricorientation",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._glu.Quadric.Orientation))",[0,[2,"gluQuadricOrientation"]],["sgl/gl"]],
["gluquadrictexture",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._glu.Quadric.Texture))",[0,[2,"gluQuadricTexture"]],["sgl/gl"]],
["gluscaleimage",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._glu.Scale.Image))",[0,[2,"gluScaleImage"]],["sgl/gl"]],
["glushort",">sgl/gl.html#(idx._(gentag._6._(lib._sgl/scribblings/sgl..scrbl)))",[6,"GLushort"],false],
["glusphere",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._glu.Sphere))",[0,[2,"gluSphere"]],["sgl/gl"]],
["gluunproject",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._glu.Un.Project))",[0,[2,"gluUnProject"]],["sgl/gl"]],
["gluunproject4",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._glu.Un.Project4))",[0,[2,"gluUnProject4"]],["sgl/gl"]],
["glvertex2d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Vertex2d))",[0,[2,"glVertex2d"]],["sgl/gl"]],
["glvertex2dv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Vertex2dv))",[0,[2,"glVertex2dv"]],["sgl/gl"]],
["glvertex2f",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Vertex2f))",[0,[2,"glVertex2f"]],["sgl/gl"]],
["glvertex2fv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Vertex2fv))",[0,[2,"glVertex2fv"]],["sgl/gl"]],
["glvertex2i",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Vertex2i))",[0,[2,"glVertex2i"]],["sgl/gl"]],
["glvertex2iv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Vertex2iv))",[0,[2,"glVertex2iv"]],["sgl/gl"]],
["glvertex2s",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Vertex2s))",[0,[2,"glVertex2s"]],["sgl/gl"]],
["glvertex2sv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Vertex2sv))",[0,[2,"glVertex2sv"]],["sgl/gl"]],
["glvertex3d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Vertex3d))",[0,[2,"glVertex3d"]],["sgl/gl"]],
["glvertex3dv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Vertex3dv))",[0,[2,"glVertex3dv"]],["sgl/gl"]],
["glvertex3f",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Vertex3f))",[0,[2,"glVertex3f"]],["sgl/gl"]],
["glvertex3fv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Vertex3fv))",[0,[2,"glVertex3fv"]],["sgl/gl"]],
["glvertex3i",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Vertex3i))",[0,[2,"glVertex3i"]],["sgl/gl"]],
["glvertex3iv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Vertex3iv))",[0,[2,"glVertex3iv"]],["sgl/gl"]],
["glvertex3s",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Vertex3s))",[0,[2,"glVertex3s"]],["sgl/gl"]],
["glvertex3sv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Vertex3sv))",[0,[2,"glVertex3sv"]],["sgl/gl"]],
["glvertex4d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Vertex4d))",[0,[2,"glVertex4d"]],["sgl/gl"]],
["glvertex4dv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Vertex4dv))",[0,[2,"glVertex4dv"]],["sgl/gl"]],
["glvertex4f",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Vertex4f))",[0,[2,"glVertex4f"]],["sgl/gl"]],
["glvertex4fv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Vertex4fv))",[0,[2,"glVertex4fv"]],["sgl/gl"]],
["glvertex4i",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Vertex4i))",[0,[2,"glVertex4i"]],["sgl/gl"]],
["glvertex4iv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Vertex4iv))",[0,[2,"glVertex4iv"]],["sgl/gl"]],
["glvertex4s",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Vertex4s))",[0,[2,"glVertex4s"]],["sgl/gl"]],
["glvertex4sv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Vertex4sv))",[0,[2,"glVertex4sv"]],["sgl/gl"]],
["glviewport",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Viewport))",[0,[2,"glViewport"]],["sgl/gl"]],
["glwindowpos2d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Window.Pos2d))",[0,[2,"glWindowPos2d"]],["sgl/gl"]],
["glwindowpos2dv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Window.Pos2dv))",[0,[2,"glWindowPos2dv"]],["sgl/gl"]],
["glwindowpos2f",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Window.Pos2f))",[0,[2,"glWindowPos2f"]],["sgl/gl"]],
["glwindowpos2fv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Window.Pos2fv))",[0,[2,"glWindowPos2fv"]],["sgl/gl"]],
["glwindowpos2i",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Window.Pos2i))",[0,[2,"glWindowPos2i"]],["sgl/gl"]],
["glwindowpos2iv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Window.Pos2iv))",[0,[2,"glWindowPos2iv"]],["sgl/gl"]],
["glwindowpos2s",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Window.Pos2s))",[0,[2,"glWindowPos2s"]],["sgl/gl"]],
["glwindowpos2sv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Window.Pos2sv))",[0,[2,"glWindowPos2sv"]],["sgl/gl"]],
["glwindowpos3d",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Window.Pos3d))",[0,[2,"glWindowPos3d"]],["sgl/gl"]],
["glwindowpos3dv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Window.Pos3dv))",[0,[2,"glWindowPos3dv"]],["sgl/gl"]],
["glwindowpos3f",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Window.Pos3f))",[0,[2,"glWindowPos3f"]],["sgl/gl"]],
["glwindowpos3fv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Window.Pos3fv))",[0,[2,"glWindowPos3fv"]],["sgl/gl"]],
["glwindowpos3i",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Window.Pos3i))",[0,[2,"glWindowPos3i"]],["sgl/gl"]],
["glwindowpos3iv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Window.Pos3iv))",[0,[2,"glWindowPos3iv"]],["sgl/gl"]],
["glwindowpos3s",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Window.Pos3s))",[0,[2,"glWindowPos3s"]],["sgl/gl"]],
["glwindowpos3sv",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._gl.Window.Pos3sv))",[0,[2,"glWindowPos3sv"]],["sgl/gl"]],
["glyph-exists?",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._glyph-exists~3f))",[[0,[2,"glyph-exists?"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["go",">teachpack/hangman-play.html#(def._((lib._htdp/hangman-play..rkt)._go))",[0,"go"],["htdp/hangman-play"]],
["go",">teachpack/master-play.html#(def._((lib._htdp/master-play..rkt)._go))",[0,"go"],["htdp/master-play"]],
["go button",">drracket/debugger.html#(idx._(gentag._34._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Go</span> button",false],
["go fish --- kid's card game",">games/gofish.html",[[15,"<img src=\"gofish.png\" alt=\"\" />"]," ","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Go Fish</span>"," ","&#8212;","<wbr></wbr>"," Kid","&rsquo;","s Card Game"],false],
["go!",">more/index.html#(part._.Go_)","Go!",false],
["go!",">quick/index.html#(part._.Go_)","Go!",false],
["go-to-main-page",">scribble/Connecting_to__racket_.html#(def._((lib._help/help-utils..rkt)._go-to-main-page))",[0,"go-to-main-page"],["help/help-utils"]],
["goal/c",">racklog/glossary.html#(def._((lib._racklog/main..rkt)._goal/c))",[0,[2,"goal/c"]],["racklog"]],
["gobblet --- strategy game",">games/gobblet.html",[[15,"<img src=\"gobblet.png\" alt=\"\" />"]," ","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Gobblet</span>"," ","&#8212;","<wbr></wbr>"," Strategy Game"],false],
["gotchas",">guide/contracts-gotchas.html","Gotchas",false],
["gotchas",">web-server/templates.html#(part._.Gotchas)","Gotchas",false],
["goto-line",">framework/Keymap.html#(idx._(gentag._28._(lib._scribblings/framework/framework..scrbl)))","goto-line",false],
["goto-position",">framework/Keymap.html#(idx._(gentag._29._(lib._scribblings/framework/framework..scrbl)))","goto-position",false],
["goto-url",">browser/index.html#(meth._(((lib._browser/browser..rkt)._hyper-canvas-mixin)._goto-url))",[[0,[2,"goto-url"]],[14,[" (method of ",[0,[2,"hyper-canvas-mixin"]],")"]]],["browser/browser","browser"]],
["grab-caret",">gui/editor-admin_.html#(meth._(((lib._mred/main..rkt)._editor-admin~25)._grab-caret))",[[0,[2,"grab-caret"]],[14,[" (method of ",[0,[2,"editor-admin%"]],")"]]],["racket/gui/base","racket/gui"]],
["gracket",">reference/running-sa.html#(idx._(gentag._344._(lib._scribblings/reference/reference..scrbl)))",[6,"gracket"],false],
["gracket-launcher-add-suffix",">raco/exe.html#(def._((lib._launcher/launcher..rkt)._gracket-launcher-add-suffix))",[0,[2,"gracket-launcher-add-suffix"]],["launcher/launcher"]],
["gracket-launcher-is-actually-directory?",">raco/exe.html#(def._((lib._launcher/launcher..rkt)._gracket-launcher-is-actually-directory~3f))",[0,[2,"gracket-launcher-is-actually-directory?"]],["launcher/launcher"]],
["gracket-launcher-is-directory?",">raco/exe.html#(def._((lib._launcher/launcher..rkt)._gracket-launcher-is-directory~3f))",[0,[2,"gracket-launcher-is-directory?"]],["launcher/launcher"]],
["gracket-launcher-put-file-extension+style+filters",">raco/exe.html#(def._((lib._launcher/launcher..rkt)._gracket-launcher-put-file-extension+style+filters))",[0,[2,"gracket-launcher-put-file-extension+style+filters"]],["launcher/launcher"]],
["gracket-launcher-up-to-date?",">raco/exe.html#(def._((lib._launcher/launcher..rkt)._gracket-launcher-up-to-date~3f))",[0,[2,"gracket-launcher-up-to-date?"]],["launcher/launcher"]],
["gracket-program-launcher-path",">raco/exe.html#(def._((lib._launcher/launcher..rkt)._gracket-program-launcher-path))",[0,[2,"gracket-program-launcher-path"]],["launcher/launcher"]],
["gracket.app",">reference/running-sa.html#(idx._(gentag._346._(lib._scribblings/reference/reference..scrbl)))",[6,"GRacket.app"],false],
["gracket.exe",">reference/running-sa.html#(idx._(gentag._345._(lib._scribblings/reference/reference..scrbl)))",[6,"GRacket.exe"],false],
["gracket:default-font-size preference",">gui/style-list_.html#(idx._(gentag._204._(lib._scribblings/gui/gui..scrbl)))",[[7,"'GRacket:default-font-size"],"\npreference"],false],
["gracket:default-font-size preference",">gui/mredprefs.html#(idx._(gentag._219._(lib._scribblings/gui/gui..scrbl)))",[[7,"'GRacket:default-font-size"],"\npreference"],false],
["gracket:defaultmenuprefix preference",">gui/mredprefs.html#(idx._(gentag._220._(lib._scribblings/gui/gui..scrbl)))",[[7,"'GRacket:defaultMenuPrefix"],"\npreference"],false],
["gracket:doubleclicktime preference",">gui/keymap_.html#(idx._(gentag._217._(lib._scribblings/gui/gui..scrbl)))",[[7,"'GRacket:doubleClickTime"],"\npreference"],false],
["gracket:doubleclicktime preference",">gui/mredprefs.html#(idx._(gentag._225._(lib._scribblings/gui/gui..scrbl)))",[[7,"'GRacket:doubleClickTime"],"\npreference"],false],
["gracket:emacs-undo preference",">gui/mredprefs.html#(idx._(gentag._221._(lib._scribblings/gui/gui..scrbl)))",[[7,"'GRacket:emacs-undo"],"\npreference"],false],
["gracket:outline-inactive-selection preference",">gui/mredprefs.html#(idx._(gentag._223._(lib._scribblings/gui/gui..scrbl)))",[[7,"'GRacket:outline-inactive-selection"],"\npreference"],false],
["gracket:playcmd preference",">gui/Windowing_Functions.html#(idx._(gentag._150._(lib._scribblings/gui/gui..scrbl)))",[[7,"'GRacket:playcmd"],"\npreference"],false],
["gracket:playcmd preference",">gui/mredprefs.html#(idx._(gentag._224._(lib._scribblings/gui/gui..scrbl)))",[[7,"'GRacket:playcmd"],"\npreference"],false],
["gracket:selectionasclipboard preference",">gui/clipboard___.html#(idx._(gentag._33._(lib._scribblings/gui/gui..scrbl)))",[[7,"'GRacket:selectionAsClipboard"],"\npreference"],false],
["gracket:wheelstep preference",">gui/editor-canvas_.html#(idx._(gentag._210._(lib._scribblings/gui/gui..scrbl)))",[[7,"'GRacket:wheelStep"],"\npreference"],false],
["gracket:wheelstep preference",">gui/mredprefs.html#(idx._(gentag._222._(lib._scribblings/gui/gui..scrbl)))",[[7,"'GRacket:wheelStep"],"\npreference"],false],
["gracketrc.rktl",">gui/Windowing_Functions.html#(idx._(gentag._149._(lib._scribblings/gui/gui..scrbl)))",[6,"\"gracketrc.rktl\""],false],
["gradient",">plot/compat.html#(def._((lib._plot/compat..rkt)._gradient))",[0,[2,"gradient"]],["plot/compat"]],
["gradient",">draw/brush_.html#(tech._gradient)","<span style=\"font-style: italic\">gradient</span>",false],
["gradients and normals",">images/Gradients_and_Normals.html","Gradients and Normals",false],
["grammar-style",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._grammar-style))",[0,[2,"grammar-style"]],["redex/pict","redex"]],
["graph",">plot/renderer2d.html#(tech._graph)","<span style=\"font-style: italic\">graph</span>",false],
["graph functions",">mrlib/Graph_Functions.html","Graph Functions",false],
["graph rendering",">profile/index.html#(part._.Graph_.Rendering)","Graph Rendering",false],
["graph-fun",">teachpack/graphing.html#(def._((lib._htdp/graphing..rkt)._graph-fun))",[0,[2,"graph-fun"]],["htdp/graphing"]],
["graph-line",">teachpack/graphing.html#(def._((lib._htdp/graphing..rkt)._graph-line))",[0,[2,"graph-line"]],["htdp/graphing"]],
["graph-pasteboard-mixin",">mrlib/graph-pasteboard-mixin.html",[0,[2,"graph-pasteboard-mixin"]],["mrlib/graph"]],
["graph-pasteboard<%>",">mrlib/graph-pasteboard___.html",[0,[2,"graph-pasteboard<%>"]],["mrlib/graph"]],
["graph-snip-mixin",">mrlib/graph-snip-mixin.html",[0,[2,"graph-snip-mixin"]],["mrlib/graph"]],
["graph-snip<%>",">mrlib/graph-snip___.html",[0,[2,"graph-snip<%>"]],["mrlib/graph"]],
["graphic",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex..rkt)._graphic))",[0,[1,"graphic"]],["parser-tools/lex"]],
["graphical debugging interface",">drracket/debugger.html","Graphical Debugging Interface",false],
["graphical demo programs",">frtime/index.html#(part._.Graphical_.Demo_.Programs)","Graphical Demo Programs",false],
["graphical minimum height",">gui/windowing-overview.html#(tech._graphical._minimum._height)","<span style=\"font-style: italic\">graphical minimum height</span>",false],
["graphical minimum size",">gui/windowing-overview.html#(tech._graphical._minimum._size)","<span style=\"font-style: italic\">graphical minimum size</span>",false],
["graphical minimum width",">gui/windowing-overview.html#(tech._graphical._minimum._width)","<span style=\"font-style: italic\">graphical minimum width</span>",false],
["graphical syntax",">drracket/Graphical_Syntax.html","Graphical Syntax",false],
["graphical user interface",">rackunit/api.html#(part._.Graphical_.User_.Interface)","Graphical User Interface",false],
["graphical-read-eval-print-loop",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._graphical-read-eval-print-loop))",[0,[2,"graphical-read-eval-print-loop"]],["racket/gui/base","racket/gui"]],
["graphics and guis",">guide/More_Libraries.html#(part._graphics)","Graphics and GUIs",false],
["graphics library as a unit",">graphics/Graphics_Library_as_a_Unit.html","Graphics Library as a Unit",false],
["graphics-bexam",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtle-examples..rkt)._graphics-bexam))",[0,[2,"graphics-bexam"]],["graphics/turtle-examples"]],
["graphics-open?",">graphics/Basic_Commands.html#(def._((lib._graphics/graphics..rkt)._graphics-open~3f))",[0,[2,"graphics-open?"]],["graphics/graphics"]],
["graphics-posn-less@",">graphics/Graphics_Library_as_a_Unit.html#(def._((lib._graphics/graphics-posn-less-unit..rkt)._graphics-posn-less~40))",[0,[2,"graphics-posn-less@"]],["graphics/graphics-posn-less-unit"]],
["graphics/graphics",">graphics/index.html",[9,[0,"graphics/graphics"]],"module"],
["graphics/graphics-posn-less-unit",">graphics/Graphics_Library_as_a_Unit.html#(mod-path._graphics/graphics-posn-less-unit)",[9,[0,"graphics/graphics-posn-less-unit"]],"module"],
["graphics/graphics-sig",">graphics/Graphics_Library_as_a_Unit.html#(mod-path._graphics/graphics-sig)",[9,[0,"graphics/graphics-sig"]],"module"],
["graphics/graphics-unit",">graphics/Graphics_Library_as_a_Unit.html#(mod-path._graphics/graphics-unit)",[9,[0,"graphics/graphics-unit"]],"module"],
["graphics/turtle-examples",">turtles/Traditional_Turtles.html#(mod-path._graphics/turtle-examples)",[9,[0,"graphics/turtle-examples"]],"module"],
["graphics/turtles",">turtles/Traditional_Turtles.html",[9,[0,"graphics/turtles"]],"module"],
["graphics/value-turtles",">turtles/Value_Turtles.html",[9,[0,"graphics/value-turtles"]],"module"],
["graphics/value-turtles-examples",">turtles/Value_Turtles.html#(mod-path._graphics/value-turtles-examples)",[9,[0,"graphics/value-turtles-examples"]],"module"],
["graphics: legacy library",">graphics/index.html","Graphics: Legacy Library",false],
["graphics:posn^",">graphics/Graphics_Library_as_a_Unit.html#(form._((lib._graphics/graphics-sig..rkt)._graphics~3aposn~5e))",[0,[1,"graphics:posn^"]],["graphics/graphics-sig"]],
["graphics@",">graphics/Graphics_Library_as_a_Unit.html#(def._((lib._graphics/graphics-unit..rkt)._graphics~40))",[0,[2,"graphics@"]],["graphics/graphics-unit"]],
["graphics^",">graphics/Graphics_Library_as_a_Unit.html#(form._((lib._graphics/graphics-sig..rkt)._graphics~5e))",[0,[1,"graphics^"]],["graphics/graphics-sig"]],
["graphing functions: \"graphing.ss\"",">teachpack/graphing.html",["Graphing Functions: ",[6,"\"graphing.ss\""],"<a name=\"(idx._(gentag._12._(lib._teachpack/teachpack..scrbl)))\"></a>"],false],
["graphing teachpack",">teachpack/graphing.html#(idx._(gentag._12._(lib._teachpack/teachpack..scrbl)))","graphing teachpack",false],
["graphs",">mrlib/Graphs.html","Graphs",false],
["grass-block",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._grass-block))",[0,[2,"grass-block"]],["2htdp/planetcute"]],
["gray",">unstable/pict.html#(def._((lib._unstable/gui/pict..rkt)._gray))",[0,[2,"gray"]],["unstable/gui/pict"]],
["gray highlight regions",">drracket/editor.html#(idx._(gentag._18._(lib._scribblings/drracket/drracket..scrbl)))","gray highlight\nregions",false],
["greatest common divisor",">reference/generic-numbers.html#(idx._(gentag._100._(lib._scribblings/reference/reference..scrbl)))","greatest common divisor",false],
["greatest-fixnum",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_862",[0,[2,"greatest-fixnum"]],["rnrs/arithmetic/fixnums-6"]],
["greedy",">guide/regexp-quant.html#(tech._greedy)","<span style=\"font-style: italic\">greedy</span>",false],
["green",">draw/color_.html#(meth._(((lib._racket/draw..rkt)._color~25)._green))",[[0,[2,"green"]],[14,[" (method of ",[0,[2,"color%"]],")"]]],["racket/draw"]],
["green",">unstable/pict.html#(def._((lib._unstable/gui/pict..rkt)._green))",[0,[2,"green"]],["unstable/gui/pict"]],
["grey-editor-mixin",">embedded-gui/Helpers.html#(def._((lib._embedded-gui/main..rkt)._grey-editor-mixin))",[0,[2,"grey-editor-mixin"]],["embedded-gui"]],
["grey-editor-snip-mixin",">embedded-gui/Helpers.html#(def._((lib._embedded-gui/main..rkt)._grey-editor-snip-mixin))",[0,[2,"grey-editor-snip-mixin"]],["embedded-gui"]],
["grid",">unstable/ppict.html#(def._((lib._unstable/gui/ppict..rkt)._grid))",[0,[2,"grid"]],["unstable/gui/ppict"]],
["group",">framework/Group.html","Group",false],
["group-box-panel%",">gui/group-box-panel_.html",[0,[2,"group-box-panel%"]],["racket/gui/base","racket/gui"]],
["group-by",">unstable/list.html#(def._((lib._unstable/list..rkt)._group-by))",[0,[2,"group-by"]],["unstable/list"]],
["group-execute-bit",">reference/Filesystem.html#(def._((lib._racket/file..rkt)._group-execute-bit))",[0,[2,"group-execute-bit"]],["racket/file","racket"]],
["group-read-bit",">reference/Filesystem.html#(def._((lib._racket/file..rkt)._group-read-bit))",[0,[2,"group-read-bit"]],["racket/file","racket"]],
["group-rows",">db/query-api.html#(def._((lib._db/base..rkt)._group-rows))",[0,[2,"group-rows"]],["db","db/base"]],
["group-write-bit",">reference/Filesystem.html#(def._((lib._racket/file..rkt)._group-write-bit))",[0,[2,"group-write-bit"]],["racket/file","racket"]],
["group:%",">framework/Group.html#(def._((lib._framework/main..rkt)._group~3a~25))",[0,[2,"group:%"]],["framework"]],
["group:add-to-windows-menu",">framework/Group.html#(def._((lib._framework/main..rkt)._group~3aadd-to-windows-menu))",[0,[2,"group:add-to-windows-menu"]],["framework"]],
["group:can-close-check",">framework/Group.html#(def._((lib._framework/main..rkt)._group~3acan-close-check))",[0,[2,"group:can-close-check"]],["framework"]],
["group:get-the-frame-group",">framework/Group.html#(def._((lib._framework/main..rkt)._group~3aget-the-frame-group))",[0,[2,"group:get-the-frame-group"]],["framework"]],
["group:on-close-action",">framework/Group.html#(def._((lib._framework/main..rkt)._group~3aon-close-action))",[0,[2,"group:on-close-action"]],["framework"]],
["grow-box-spacer-pane%",">gui/grow-box-spacer-pane_.html",[0,[2,"grow-box-spacer-pane%"]],["racket/gui/base","racket/gui"]],
["growable vectors",">data/gvector.html","Growable Vectors",false],
["guarantees for a specific value",">guide/contracts-struct.html#(part._contracts-single-struct)","Guarantees for a Specific Value",false],
["guarantees for all values",">guide/contracts-struct.html#(part._contracts-define-struct)","Guarantees for All Values",false],
["guard",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_370",[0,[1,"guard"]],["rnrs/exceptions-6"]],
["guard",">srfi-std/srfi-34.html#guard",[0,[1,"guard"]],["srfi/34"]],
["guard-evt",">reference/sync.html#(def._((lib._racket/private/misc..rkt)._guard-evt))",[0,[2,"guard-evt"]],["racket/base","racket"]],
["guarded evaluation: when and unless",">reference/when_unless.html",["Guarded Evaluation: ",[0,[1,"when"]]," and ",[0,[1,"unless"]]],false],
["guess gui: \"guess-gui.ss\"",">teachpack/guess-gui.html",["Guess GUI: ",[6,"\"guess-gui.ss\""],"<a name=\"(idx._(gentag._17._(lib._teachpack/teachpack..scrbl)))\"></a>"],false],
["guess teachpack",">teachpack/guess.html#(idx._(gentag._3._(lib._teachpack/teachpack..scrbl)))","guess teachpack",false],
["guess-gui teachpack",">teachpack/guess-gui.html#(idx._(gentag._17._(lib._teachpack/teachpack..scrbl)))","guess-gui teachpack",false],
["guess-with-gui",">teachpack/guess.html#(def._((lib._htdp/guess..rkt)._guess-with-gui))",[0,[2,"guess-with-gui"]],["htdp/guess"]],
["guess-with-gui-3",">teachpack/guess.html#(def._((lib._htdp/guess..rkt)._guess-with-gui-3))",[0,[2,"guess-with-gui-3"]],["htdp/guess"]],
["guess-with-gui-list",">teachpack/guess.html#(def._((lib._htdp/guess..rkt)._guess-with-gui-list))",[0,[2,"guess-with-gui-list"]],["htdp/guess"]],
["guessing numbers: \"guess.ss\"",">teachpack/guess.html",["Guessing Numbers: ",[6,"\"guess.ss\""],"<a name=\"(idx._(gentag._3._(lib._teachpack/teachpack..scrbl)))\"></a>"],false],
["gui",">redex/The_Redex_Reference.html#(part._.G.U.I)","GUI",false],
["gui installer",">raco/_plt-archives.html#(part._gui-unpacking)","GUI Installer",false],
["gui interface",">test-engine/index.html#(part._.G.U.I_.Interface)","GUI Interface",false],
["gui libraries",">unstable/unstable-gui.html","GUI Libraries",false],
["gui teachpack",">teachpack/gui.html#(idx._(gentag._13._(lib._teachpack/teachpack..scrbl)))","gui teachpack",false],
["gui unpacking signature",">raco/_plt-archives.html#(part._.G.U.I_.Unpacking_.Signature)","GUI Unpacking Signature",false],
["gui unpacking unit",">raco/_plt-archives.html#(part._.G.U.I_.Unpacking_.Unit)","GUI Unpacking Unit",false],
["gui utilities",">framework/GUI_Utilities.html","GUI Utilities",false],
["gui-available?",">gui/Dynamic_Loading.html#(def._((lib._racket/gui/dynamic..rkt)._gui-available~3f))",[0,[2,"gui-available?"]],["racket/gui/dynamic"]],
["gui-def+int",">scriblib/gui-eval.html#(form._((lib._scriblib/gui-eval..rkt)._gui-def+int))",[0,[1,"gui-def+int"]],["scriblib/gui-eval"]],
["gui-defs+int",">scriblib/gui-eval.html#(form._((lib._scriblib/gui-eval..rkt)._gui-defs+int))",[0,[1,"gui-defs+int"]],["scriblib/gui-eval"]],
["gui-dynamic-require",">gui/Dynamic_Loading.html#(def._((lib._racket/gui/dynamic..rkt)._gui-dynamic-require))",[0,[2,"gui-dynamic-require"]],["racket/gui/dynamic"]],
["gui-interaction",">scriblib/gui-eval.html#(form._((lib._scriblib/gui-eval..rkt)._gui-interaction))",[0,[1,"gui-interaction"]],["scriblib/gui-eval"]],
["gui-interaction-eval",">scriblib/gui-eval.html#(form._((lib._scriblib/gui-eval..rkt)._gui-interaction-eval))",[0,[1,"gui-interaction-eval"]],["scriblib/gui-eval"]],
["gui-interaction-eval-show",">scriblib/gui-eval.html#(form._((lib._scriblib/gui-eval..rkt)._gui-interaction-eval-show))",[0,[1,"gui-interaction-eval-show"]],["scriblib/gui-eval"]],
["gui-item",">teachpack/gui.html#(tech._gui._item)","<span style=\"font-style: italic\">GUI-ITEM</span>",false],
["gui-racketblock+eval",">scriblib/gui-eval.html#(form._((lib._scriblib/gui-eval..rkt)._gui-racketblock+eval))",[0,[1,"gui-racketblock+eval"]],["scriblib/gui-eval"]],
["gui-racketmod+eval",">scriblib/gui-eval.html#(form._((lib._scriblib/gui-eval..rkt)._gui-racketmod+eval))",[0,[1,"gui-racketmod+eval"]],["scriblib/gui-eval"]],
["gui-utils:cancel-on-right?",">framework/GUI_Utilities.html#(def._((lib._framework/gui-utils..rkt)._gui-utils~3acancel-on-right~3f))",[0,[2,"gui-utils:cancel-on-right?"]],["framework/gui-utils","framework"]],
["gui-utils:cursor-delay",">framework/GUI_Utilities.html#(def._((lib._framework/gui-utils..rkt)._gui-utils~3acursor-delay))",[0,[2,"gui-utils:cursor-delay"]],["framework/gui-utils","framework"]],
["gui-utils:delay-action",">framework/GUI_Utilities.html#(def._((lib._framework/gui-utils..rkt)._gui-utils~3adelay-action))",[0,[2,"gui-utils:delay-action"]],["framework/gui-utils","framework"]],
["gui-utils:format-literal-label",">framework/GUI_Utilities.html#(def._((lib._framework/gui-utils..rkt)._gui-utils~3aformat-literal-label))",[0,[2,"gui-utils:format-literal-label"]],["framework/gui-utils","framework"]],
["gui-utils:get-choice",">framework/GUI_Utilities.html#(def._((lib._framework/gui-utils..rkt)._gui-utils~3aget-choice))",[0,[2,"gui-utils:get-choice"]],["framework/gui-utils","framework"]],
["gui-utils:get-clickback-delta",">framework/GUI_Utilities.html#(def._((lib._framework/gui-utils..rkt)._gui-utils~3aget-clickback-delta))",[0,[2,"gui-utils:get-clickback-delta"]],["framework/gui-utils","framework"]],
["gui-utils:get-clicked-clickback-delta",">framework/GUI_Utilities.html#(def._((lib._framework/gui-utils..rkt)._gui-utils~3aget-clicked-clickback-delta))",[0,[2,"gui-utils:get-clicked-clickback-delta"]],["framework/gui-utils","framework"]],
["gui-utils:local-busy-cursor",">framework/GUI_Utilities.html#(def._((lib._framework/gui-utils..rkt)._gui-utils~3alocal-busy-cursor))",[0,[2,"gui-utils:local-busy-cursor"]],["framework/gui-utils","framework"]],
["gui-utils:next-untitled-name",">framework/GUI_Utilities.html#(def._((lib._framework/gui-utils..rkt)._gui-utils~3anext-untitled-name))",[0,[2,"gui-utils:next-untitled-name"]],["framework/gui-utils","framework"]],
["gui-utils:ok/cancel-buttons",">framework/GUI_Utilities.html#(def._((lib._framework/gui-utils..rkt)._gui-utils~3aok/cancel-buttons))",[0,[2,"gui-utils:ok/cancel-buttons"]],["framework/gui-utils","framework"]],
["gui-utils:quote-literal-label",">framework/GUI_Utilities.html#(def._((lib._framework/gui-utils..rkt)._gui-utils~3aquote-literal-label))",[0,[2,"gui-utils:quote-literal-label"]],["framework/gui-utils","framework"]],
["gui-utils:show-busy-cursor",">framework/GUI_Utilities.html#(def._((lib._framework/gui-utils..rkt)._gui-utils~3ashow-busy-cursor))",[0,[2,"gui-utils:show-busy-cursor"]],["framework/gui-utils","framework"]],
["gui-utils:trim-string",">framework/GUI_Utilities.html#(def._((lib._framework/gui-utils..rkt)._gui-utils~3atrim-string))",[0,[2,"gui-utils:trim-string"]],["framework/gui-utils","framework"]],
["gui-utils:unsaved-warning",">framework/GUI_Utilities.html#(def._((lib._framework/gui-utils..rkt)._gui-utils~3aunsaved-warning))",[0,[2,"gui-utils:unsaved-warning"]],["framework/gui-utils","framework"]],
["gui?",">reference/Sandboxed_Evaluation.html#(def._((lib._racket/sandbox..rkt)._gui~3f))",[0,[2,"gui?"]],["racket/sandbox"]],
["guid",">foreign/com.html#(tech._guid)","<span style=\"font-style: italic\">GUID</span>",false],
["guid->string",">foreign/com-auto.html#(def._((lib._ffi/unsafe/com..rkt)._guid-~3estring))",[0,[2,"guid->string"]],["ffi/com"]],
["guid=?",">foreign/com-auto.html#(def._((lib._ffi/unsafe/com..rkt)._guid~3d~3f))",[0,[2,"guid=?"]],["ffi/com"]],
["guid?",">foreign/com-auto.html#(def._((lib._ffi/unsafe/com..rkt)._guid~3f))",[0,[2,"guid?"]],["ffi/com"]],
["guidelines for developing unstable libraries",">unstable/guidelines.html",["Guidelines for Developing ",[0,"unstable"]," Libraries"],false],
["guidelines for using assignment",">guide/set_.html#(part._using-set!)","Guidelines for Using Assignment",false],
["guiding raco ctool --xform",">inside/im_memoryalloc.html#(part._im~3a3m~3amacros)",["Guiding ",[6,"raco ctool"]," ",[11,[6,"--xform"]]],false],
["guids",">mzcom/index.html#(part._guids)","GUIDs",false],
["guids, clsids, iids, and progids",">foreign/com-auto.html#(part._.G.U.I.Ds__.C.L.S.I.Ds__.I.I.Ds__and_.Prog.I.Ds)","GUIDs, CLSIDs, IIDs, and ProgIDs",false],
["gunzip",">file/gunzip.html#(def._((lib._file/gunzip..rkt)._gunzip))",[0,[2,"gunzip"]],["file/gunzip"]],
["gunzip-through-ports",">file/gunzip.html#(def._((lib._file/gunzip..rkt)._gunzip-through-ports))",[0,[2,"gunzip-through-ports"]],["file/gunzip"]],
["gunzip/bytes",">web-server-internal/gzip.html#(def._((lib._web-server/private/gzip..rkt)._gunzip/bytes))",[0,[2,"gunzip/bytes"]],["web-server/private/gzip"]],
["gvector",">data/gvector.html#(def._((lib._data/gvector..rkt)._gvector))",[0,[2,"gvector"]],["data/gvector"]],
["gvector->vector",">data/gvector.html#(def._((lib._data/gvector..rkt)._gvector-~3evector))",[0,[2,"gvector->vector"]],["data/gvector"]],
["gvector-add!",">data/gvector.html#(def._((lib._data/gvector..rkt)._gvector-add!))",[0,[2,"gvector-add!"]],["data/gvector"]],
["gvector-count",">data/gvector.html#(def._((lib._data/gvector..rkt)._gvector-count))",[0,[2,"gvector-count"]],["data/gvector"]],
["gvector-ref",">data/gvector.html#(def._((lib._data/gvector..rkt)._gvector-ref))",[0,[2,"gvector-ref"]],["data/gvector"]],
["gvector-remove!",">data/gvector.html#(def._((lib._data/gvector..rkt)._gvector-remove!))",[0,[2,"gvector-remove!"]],["data/gvector"]],
["gvector-remove-last!",">data/gvector.html#(def._((lib._data/gvector..rkt)._gvector-remove-last!))",[0,[2,"gvector-remove-last!"]],["data/gvector"]],
["gvector-set!",">data/gvector.html#(def._((lib._data/gvector..rkt)._gvector-set!))",[0,[2,"gvector-set!"]],["data/gvector"]],
["gvector?",">data/gvector.html#(def._((lib._data/gvector..rkt)._gvector~3f))",[0,[2,"gvector?"]],["data/gvector"]],
["gzip",">web-server-internal/gzip.html","GZip",false],
["gzip",">file/gzip.html#(def._((lib._file/gzip..rkt)._gzip))",[0,[2,"gzip"]],["file/gzip"]],
["gzip compression",">web-server/stateless.html#(part._.G.Zip_.Compression)","GZip Compression",false],
["gzip compression and file creation",">file/gzip.html",[[6,"gzip"]," Compression and File Creation"],false],
["gzip decompression",">file/gunzip.html",[[6,"gzip"]," Decompression"],false],
["gzip-stuffer",">web-server/stateless.html#(def._((lib._web-server/stuffers/gzip..rkt)._gzip-stuffer))",[0,[2,"gzip-stuffer"]],["web-server/stuffers/gzip"]],
["gzip-through-ports",">file/gzip.html#(def._((lib._file/gzip..rkt)._gzip-through-ports))",[0,[2,"gzip-through-ports"]],["file/gzip"]],
["gzip/bytes",">web-server-internal/gzip.html#(def._((lib._web-server/private/gzip..rkt)._gzip/bytes))",[0,[2,"gzip/bytes"]],["web-server/private/gzip"]],
["h-mode",">deinprogramm/image.html#(def._((lib._deinprogramm/image..rkt)._h-mode))",[0,[2,"h-mode"]],["teachpack/deinprogramm/image"]],
["h-place",">deinprogramm/image.html#(def._((lib._deinprogramm/image..rkt)._h-place))",[0,[2,"h-place"]],["teachpack/deinprogramm/image"]],
["h1",">html/index.html#(def._((lib._html/main..rkt)._h1))",[0,[2,"h1"]],["html"]],
["h1?",">html/index.html#(def._((lib._html/main..rkt)._h1~3f))",[0,[2,"h1?"]],["html"]],
["h2",">html/index.html#(def._((lib._html/main..rkt)._h2))",[0,[2,"h2"]],["html"]],
["h2?",">html/index.html#(def._((lib._html/main..rkt)._h2~3f))",[0,[2,"h2?"]],["html"]],
["h3",">html/index.html#(def._((lib._html/main..rkt)._h3))",[0,[2,"h3"]],["html"]],
["h3?",">html/index.html#(def._((lib._html/main..rkt)._h3~3f))",[0,[2,"h3?"]],["html"]],
["h4",">html/index.html#(def._((lib._html/main..rkt)._h4))",[0,[2,"h4"]],["html"]],
["h4?",">html/index.html#(def._((lib._html/main..rkt)._h4~3f))",[0,[2,"h4?"]],["html"]],
["h5",">html/index.html#(def._((lib._html/main..rkt)._h5))",[0,[2,"h5"]],["html"]],
["h5?",">html/index.html#(def._((lib._html/main..rkt)._h5~3f))",[0,[2,"h5?"]],["html"]],
["h6",">html/index.html#(def._((lib._html/main..rkt)._h6))",[0,[2,"h6"]],["html"]],
["h6?",">html/index.html#(def._((lib._html/main..rkt)._h6~3f))",[0,[2,"h6?"]],["html"]],
["hacking xrepl",">xrepl/index.html#(part._.Hacking_.X.R.E.P.L)","Hacking XREPL",false],
["halt-icon-color",">images/Icons.html#(def._((lib._images/icons/style..rkt)._halt-icon-color))",[0,[2,"halt-icon-color"]],["images/icons/style"]],
["halt-on-errors",">plai/plai-scheme.html#(def._((lib._plai/main..rkt)._halt-on-errors))",[0,[2,"halt-on-errors"]],["plai"]],
["halt-on-errors",">plai/mutator.html#(form._((lib._plai/mutator..rkt)._halt-on-errors))",[0,[2,"halt-on-errors"]],["plai/mutator"]],
["hand-drawn-transform",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._hand-drawn-transform))",[0,[2,"hand-drawn-transform"]],["plot"]],
["handle brushes",">draw/unsafe.html#(part._.Handle_.Brushes)","Handle Brushes",false],
["handle-evt",">reference/sync.html#(def._((quote._~23~25kernel)._handle-evt))",[0,[2,"handle-evt"]],["racket/base","racket"]],
["handle-evt?",">reference/sync.html#(def._((quote._~23~25kernel)._handle-evt~3f))",[0,[2,"handle-evt?"]],["racket/base","racket"]],
["handle-key-event",">gui/keymap_.html#(meth._(((lib._mred/main..rkt)._keymap~25)._handle-key-event))",[[0,[2,"handle-key-event"]],[14,[" (method of ",[0,[2,"keymap%"]],")"]]],["racket/gui/base","racket/gui"]],
["handle-mouse-event",">gui/keymap_.html#(meth._(((lib._mred/main..rkt)._keymap~25)._handle-mouse-event))",[[0,[2,"handle-mouse-event"]],[14,[" (method of ",[0,[2,"keymap%"]],")"]]],["racket/gui/base","racket/gui"]],
["handler",">framework/Handler.html","Handler",false],
["handler thread",">gui/windowing-overview.html#(tech._handler._thread)","<span style=\"font-style: italic\">handler thread</span>",false],
["handler:add-to-recent",">framework/Handler.html#(def._((lib._framework/main..rkt)._handler~3aadd-to-recent))",[0,[2,"handler:add-to-recent"]],["framework"]],
["handler:current-create-new-window",">framework/Handler.html#(def._((lib._framework/main..rkt)._handler~3acurrent-create-new-window))",[0,[2,"handler:current-create-new-window"]],["framework"]],
["handler:edit-file",">framework/Handler.html#(def._((lib._framework/main..rkt)._handler~3aedit-file))",[0,[2,"handler:edit-file"]],["framework"]],
["handler:find-format-handler",">framework/Handler.html#(def._((lib._framework/main..rkt)._handler~3afind-format-handler))",[0,[2,"handler:find-format-handler"]],["framework"]],
["handler:find-named-format-handler",">framework/Handler.html#(def._((lib._framework/main..rkt)._handler~3afind-named-format-handler))",[0,[2,"handler:find-named-format-handler"]],["framework"]],
["handler:handler-extension",">framework/Handler.html#(def._((lib._framework/main..rkt)._handler~3ahandler-extension))",[0,[2,"handler:handler-extension"]],["framework"]],
["handler:handler-handler",">framework/Handler.html#(def._((lib._framework/main..rkt)._handler~3ahandler-handler))",[0,[2,"handler:handler-handler"]],["framework"]],
["handler:handler-name",">framework/Handler.html#(def._((lib._framework/main..rkt)._handler~3ahandler-name))",[0,[2,"handler:handler-name"]],["framework"]],
["handler:handler?",">framework/Handler.html#(def._((lib._framework/main..rkt)._handler~3ahandler~3f))",[0,[2,"handler:handler?"]],["framework"]],
["handler:insert-format-handler",">framework/Handler.html#(def._((lib._framework/main..rkt)._handler~3ainsert-format-handler))",[0,[2,"handler:insert-format-handler"]],["framework"]],
["handler:install-recent-items",">framework/Handler.html#(def._((lib._framework/main..rkt)._handler~3ainstall-recent-items))",[0,[2,"handler:install-recent-items"]],["framework"]],
["handler:open-file",">framework/Handler.html#(def._((lib._framework/main..rkt)._handler~3aopen-file))",[0,[2,"handler:open-file"]],["framework"]],
["handler:set-recent-items-frame-superclass",">framework/Handler.html#(def._((lib._framework/main..rkt)._handler~3aset-recent-items-frame-superclass))",[0,[2,"handler:set-recent-items-frame-superclass"]],["framework"]],
["handler:set-recent-position",">framework/Handler.html#(def._((lib._framework/main..rkt)._handler~3aset-recent-position))",[0,[2,"handler:set-recent-position"]],["framework"]],
["handler:size-recently-opened-files",">framework/Handler.html#(def._((lib._framework/main..rkt)._handler~3asize-recently-opened-files))",[0,[2,"handler:size-recently-opened-files"]],["framework"]],
["handles-all-mouse-events",">gui/snip_.html#(idx._(gentag._166._(lib._scribblings/gui/gui..scrbl)))",[7,"'handles-all-mouse-events"],false],
["handles-events",">gui/snip_.html#(idx._(gentag._165._(lib._scribblings/gui/gui..scrbl)))",[7,"'handles-events"],false],
["handles-events",">gui/snip_.html#(idx._(gentag._173._(lib._scribblings/gui/gui..scrbl)))",[7,"'handles-events"],false],
["handles-events",">gui/snip_.html#(idx._(gentag._174._(lib._scribblings/gui/gui..scrbl)))",[7,"'handles-events"],false],
["handling cross-references",">scribble/running.html#(part._xref-flags)","Handling Cross-References",false],
["handling exceptions",">reference/exns.html#(part._.Handling_.Exceptions)","Handling Exceptions",false],
["handling input",">games/Handling_Input.html","Handling Input",false],
["hangman",">teachpack/hangman.html#(def._((lib._htdp/hangman..rkt)._hangman))",[0,[2,"hangman"]],["htdp/hangman"]],
["hangman teachpack",">teachpack/hangman.html#(idx._(gentag._7._(lib._teachpack/teachpack..scrbl)))","hangman teachpack",false],
["hangman-list",">teachpack/hangman.html#(def._((lib._htdp/hangman..rkt)._hangman-list))",[0,[2,"hangman-list"]],["htdp/hangman"]],
["hangman-play teachpack",">teachpack/hangman-play.html#(idx._(gentag._8._(lib._teachpack/teachpack..scrbl)))","hangman-play teachpack",false],
["hangman: \"hangman.ss\"",">teachpack/hangman.html",["Hangman: ",[6,"\"hangman.ss\""],"<a name=\"(idx._(gentag._7._(lib._teachpack/teachpack..scrbl)))\"></a>"],false],
["hard-link-file",">planet/Utility_Libraries.html#(def._((lib._planet/config..rkt)._.H.A.R.D-.L.I.N.K-.F.I.L.E))",[0,[2,"HARD-LINK-FILE"]],["planet/config"]],
["hard-newline",">gui/snip_.html#(idx._(gentag._163._(lib._scribblings/gui/gui..scrbl)))",[7,"'hard-newline"],false],
["has-alpha-channel?",">draw/bitmap_.html#(meth._(((lib._racket/draw..rkt)._bitmap~25)._has-alpha-channel~3f))",[[0,[2,"has-alpha-channel?"]],[14,[" (method of ",[0,[2,"bitmap%"]],")"]]],["racket/draw"]],
["has-contract?",">reference/contract-utilities.html#(def._((lib._racket/contract/private/guts..rkt)._has-contract~3f))",[0,[2,"has-contract?"]],["racket/contract/base","racket/contract","racket"]],
["has-focus?",">gui/window___.html#(meth._(((lib._mred/main..rkt)._window~3c~25~3e)._has-focus~3f))",[[0,[2,"has-focus?"]],[14,[" (method of ",[0,[2,"window<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["has-focus?",">framework/Editor.html#(meth._(((lib._framework/main..rkt)._editor~3abasic~3c~25~3e)._has-focus~3f))",[[0,[2,"has-focus?"]],[14,[" (method of ",[0,[2,"editor:basic<%>"]],")"]]],["framework"]],
["has-status-line?",">gui/frame_.html#(meth._(((lib._mred/main..rkt)._frame~25)._has-status-line~3f))",[[0,[2,"has-status-line?"]],[14,[" (method of ",[0,[2,"frame%"]],")"]]],["racket/gui/base","racket/gui"]],
["hash",">reference/hashtables.html#(def._((quote._~23~25kernel)._hash))",[0,[2,"hash"]],["racket/base","racket"]],
["hash",">reference/hashtables.html#(tech._hash)","<span style=\"font-style: italic\">hash</span>",false],
["hash table",">guide/hash-tables.html#(tech._hash._table)","<span style=\"font-style: italic\">hash table</span>",false],
["hash table",">reference/hashtables.html#(tech._hash._table)","<span style=\"font-style: italic\">hash table</span>",false],
["hash tables",">guide/hash-tables.html","Hash Tables",false],
["hash tables",">htdp-langs/advanced.html#(part._htdp-advanced._.Hash_.Tables)","Hash Tables",false],
["hash tables",">reference/hashtables.html","Hash Tables",false],
["hash tables",">unstable/Hash_Tables.html","Hash Tables",false],
["hash->list",">reference/hashtables.html#(def._((lib._racket/private/base..rkt)._hash-~3elist))",[0,[2,"hash->list"]],["racket/base","racket"]],
["hash-addressed storage",">web-server/stateless.html#(part._.Hash-addressed_.Storage)","Hash-addressed Storage",false],
["hash-copy",">reference/hashtables.html#(def._((quote._~23~25kernel)._hash-copy))",[0,[2,"hash-copy"]],["racket/base","racket"]],
["hash-copy",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._hash-copy))",[0,[2,"hash-copy"]],["lang/htdp-advanced"]],
["hash-count",">reference/hashtables.html#(def._((quote._~23~25kernel)._hash-count))",[0,[2,"hash-count"]],["racket/base","racket"]],
["hash-count",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._hash-count))",[0,[2,"hash-count"]],["lang/htdp-advanced"]],
["hash-eq?",">reference/hashtables.html#(def._((quote._~23~25kernel)._hash-eq~3f))",[0,[2,"hash-eq?"]],["racket/base","racket"]],
["hash-eq?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._hash-eq~3f))",[0,[2,"hash-eq?"]],["lang/htdp-advanced"]],
["hash-equal?",">reference/hashtables.html#(def._((quote._~23~25kernel)._hash-equal~3f))",[0,[2,"hash-equal?"]],["racket/base","racket"]],
["hash-equal?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._hash-equal~3f))",[0,[2,"hash-equal?"]],["lang/htdp-advanced"]],
["hash-eqv?",">reference/hashtables.html#(def._((quote._~23~25kernel)._hash-eqv~3f))",[0,[2,"hash-eqv?"]],["racket/base","racket"]],
["hash-eqv?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._hash-eqv~3f))",[0,[2,"hash-eqv?"]],["lang/htdp-advanced"]],
["hash-for-each",">reference/hashtables.html#(def._((quote._~23~25kernel)._hash-for-each))",[0,[2,"hash-for-each"]],["racket/base","racket"]],
["hash-for-each",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._hash-for-each))",[0,[2,"hash-for-each"]],["lang/htdp-advanced"]],
["hash-fun/c",">web-server/stateless.html#(def._((lib._web-server/stuffers/hash..rkt)._hash-fun/c))",[0,[2,"hash-fun/c"]],["web-server/stuffers/hash"]],
["hash-has-key?",">reference/hashtables.html#(def._((lib._racket/private/more-scheme..rkt)._hash-has-key~3f))",[0,[2,"hash-has-key?"]],["racket/base","racket"]],
["hash-has-key?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._hash-has-key~3f))",[0,[2,"hash-has-key?"]],["lang/htdp-advanced"]],
["hash-iterate-first",">reference/hashtables.html#(def._((quote._~23~25kernel)._hash-iterate-first))",[0,[2,"hash-iterate-first"]],["racket/base","racket"]],
["hash-iterate-key",">reference/hashtables.html#(def._((quote._~23~25kernel)._hash-iterate-key))",[0,[2,"hash-iterate-key"]],["racket/base","racket"]],
["hash-iterate-next",">reference/hashtables.html#(def._((quote._~23~25kernel)._hash-iterate-next))",[0,[2,"hash-iterate-next"]],["racket/base","racket"]],
["hash-iterate-value",">reference/hashtables.html#(def._((quote._~23~25kernel)._hash-iterate-value))",[0,[2,"hash-iterate-value"]],["racket/base","racket"]],
["hash-keys",">reference/hashtables.html#(def._((lib._racket/private/base..rkt)._hash-keys))",[0,[2,"hash-keys"]],["racket/base","racket"]],
["hash-lang",">scribble/Miscellaneous.html#(def._((lib._scribble/manual..rkt)._hash-lang))",[0,[2,"hash-lang"]],["scribble/manual"]],
["hash-map",">reference/hashtables.html#(def._((quote._~23~25kernel)._hash-map))",[0,[2,"hash-map"]],["racket/base","racket"]],
["hash-map",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._hash-map))",[0,[2,"hash-map"]],["lang/htdp-advanced"]],
["hash-placeholder?",">reference/pairs.html#(def._((quote._~23~25kernel)._hash-placeholder~3f))",[0,[2,"hash-placeholder?"]],["racket/base","racket"]],
["hash-quote-icon",">images/Icons.html#(def._((lib._images/icons/symbol..rkt)._hash-quote-icon))",[0,[2,"hash-quote-icon"]],["images/icons/symbol"]],
["hash-ref",">reference/hashtables.html#(def._((quote._~23~25kernel)._hash-ref))",[0,[2,"hash-ref"]],["racket/base","racket"]],
["hash-ref",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._hash-ref))",[0,[2,"hash-ref"]],["lang/htdp-advanced"]],
["hash-ref!",">reference/hashtables.html#(def._((lib._racket/private/more-scheme..rkt)._hash-ref!))",[0,[2,"hash-ref!"]],["racket/base","racket"]],
["hash-ref!",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._hash-ref!))",[0,[2,"hash-ref!"]],["lang/htdp-advanced"]],
["hash-remove",">reference/hashtables.html#(def._((quote._~23~25kernel)._hash-remove))",[0,[2,"hash-remove"]],["racket/base","racket"]],
["hash-remove",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._hash-remove))",[0,[2,"hash-remove"]],["lang/htdp-advanced"]],
["hash-remove!",">reference/hashtables.html#(def._((quote._~23~25kernel)._hash-remove!))",[0,[2,"hash-remove!"]],["racket/base","racket"]],
["hash-remove!",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._hash-remove!))",[0,[2,"hash-remove!"]],["lang/htdp-advanced"]],
["hash-set",">reference/hashtables.html#(def._((quote._~23~25kernel)._hash-set))",[0,[2,"hash-set"]],["racket/base","racket"]],
["hash-set",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._hash-set))",[0,[2,"hash-set"]],["lang/htdp-advanced"]],
["hash-set!",">reference/hashtables.html#(def._((quote._~23~25kernel)._hash-set!))",[0,[2,"hash-set!"]],["racket/base","racket"]],
["hash-set!",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._hash-set!))",[0,[2,"hash-set!"]],["lang/htdp-advanced"]],
["hash-set*",">reference/hashtables.html#(def._((lib._racket/private/base..rkt)._hash-set*))",[0,[2,"hash-set*"]],["racket/base","racket"]],
["hash-set*!",">reference/hashtables.html#(def._((lib._racket/private/base..rkt)._hash-set*!))",[0,[2,"hash-set*!"]],["racket/base","racket"]],
["hash-stuffer",">web-server/stateless.html#(def._((lib._web-server/stuffers/hash..rkt)._hash-stuffer))",[0,[2,"hash-stuffer"]],["web-server/stuffers/hash"]],
["hash-table",">mzlib/mzlib_etc.html#(form._((lib._mzlib/etc..rkt)._hash-table))",[0,[1,"hash-table"]],["mzlib/etc"]],
["hash-table-copy",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..rkt)._hash-table-copy))",[0,[2,"hash-table-copy"]],["mzscheme"]],
["hash-table-count",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..rkt)._hash-table-count))",[0,[2,"hash-table-count"]],["mzscheme"]],
["hash-table-for-each",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..rkt)._hash-table-for-each))",[0,[2,"hash-table-for-each"]],["mzscheme"]],
["hash-table-get",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..rkt)._hash-table-get))",[0,[2,"hash-table-get"]],["mzscheme"]],
["hash-table-iterate-first",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..rkt)._hash-table-iterate-first))",[0,[2,"hash-table-iterate-first"]],["mzscheme"]],
["hash-table-iterate-key",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..rkt)._hash-table-iterate-key))",[0,[2,"hash-table-iterate-key"]],["mzscheme"]],
["hash-table-iterate-next",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..rkt)._hash-table-iterate-next))",[0,[2,"hash-table-iterate-next"]],["mzscheme"]],
["hash-table-iterate-value",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..rkt)._hash-table-iterate-value))",[0,[2,"hash-table-iterate-value"]],["mzscheme"]],
["hash-table-map",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..rkt)._hash-table-map))",[0,[2,"hash-table-map"]],["mzscheme"]],
["hash-table-put!",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..rkt)._hash-table-put!))",[0,[2,"hash-table-put!"]],["mzscheme"]],
["hash-table-remove!",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..rkt)._hash-table-remove!))",[0,[2,"hash-table-remove!"]],["mzscheme"]],
["hash-table?",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..rkt)._hash-table~3f))",[0,[2,"hash-table?"]],["mzscheme"]],
["hash-union",">unstable/Hash_Tables.html#(def._((lib._unstable/hash..rkt)._hash-union))",[0,[2,"hash-union"]],["unstable/hash"]],
["hash-union!",">unstable/Hash_Tables.html#(def._((lib._unstable/hash..rkt)._hash-union!))",[0,[2,"hash-union!"]],["unstable/hash"]],
["hash-update",">reference/hashtables.html#(def._((lib._racket/private/more-scheme..rkt)._hash-update))",[0,[2,"hash-update"]],["racket/base","racket"]],
["hash-update",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._hash-update))",[0,[2,"hash-update"]],["lang/htdp-advanced"]],
["hash-update!",">reference/hashtables.html#(def._((lib._racket/private/more-scheme..rkt)._hash-update!))",[0,[2,"hash-update!"]],["racket/base","racket"]],
["hash-update!",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._hash-update!))",[0,[2,"hash-update!"]],["lang/htdp-advanced"]],
["hash-values",">reference/hashtables.html#(def._((lib._racket/private/base..rkt)._hash-values))",[0,[2,"hash-values"]],["racket/base","racket"]],
["hash-weak?",">reference/hashtables.html#(def._((quote._~23~25kernel)._hash-weak~3f))",[0,[2,"hash-weak?"]],["racket/base","racket"]],
["hash/c",">reference/data-structure-contracts.html#(def._((lib._racket/contract/private/hash..rkt)._hash/c))",[0,[2,"hash/c"]],["racket/contract/base","racket/contract","racket"]],
["hash?",">reference/hashtables.html#(def._((quote._~23~25kernel)._hash~3f))",[0,[2,"hash?"]],["racket/base","racket"]],
["hash?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._hash~3f))",[0,[2,"hash?"]],["lang/htdp-advanced"]],
["hasheq",">reference/hashtables.html#(def._((quote._~23~25kernel)._hasheq))",[0,[2,"hasheq"]],["racket/base","racket"]],
["hasheqv",">reference/hashtables.html#(def._((quote._~23~25kernel)._hasheqv))",[0,[2,"hasheqv"]],["racket/base","racket"]],
["hashing on bound-identifier=? and free-identifier=?",">syntax/syntax-helpers.html#(part._boundmap)",["Hashing on ",[0,[2,"bound-identifier=?"]]," and ",[0,[2,"free-identifier=?"]]],false],
["hashtable",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Hash.Table))",[0,[1,"HashTable"]],["typed/racket/base","typed/racket"]],
["hashtable-clear!",">r6rs-lib-std/r6rs-lib-Z-H-14.html#node_idx_1204",[0,[2,"hashtable-clear!"]],["rnrs/hashtables-6"]],
["hashtable-contains?",">r6rs-lib-std/r6rs-lib-Z-H-14.html#node_idx_1196",[0,[2,"hashtable-contains?"]],["rnrs/hashtables-6"]],
["hashtable-copy",">r6rs-lib-std/r6rs-lib-Z-H-14.html#node_idx_1200",[0,[2,"hashtable-copy"]],["rnrs/hashtables-6"]],
["hashtable-delete!",">r6rs-lib-std/r6rs-lib-Z-H-14.html#node_idx_1194",[0,[2,"hashtable-delete!"]],["rnrs/hashtables-6"]],
["hashtable-entries",">r6rs-lib-std/r6rs-lib-Z-H-14.html#node_idx_1210",[0,[2,"hashtable-entries"]],["rnrs/hashtables-6"]],
["hashtable-equivalence-function",">r6rs-lib-std/r6rs-lib-Z-H-14.html#node_idx_1212",[0,[2,"hashtable-equivalence-function"]],["rnrs/hashtables-6"]],
["hashtable-hash-function",">r6rs-lib-std/r6rs-lib-Z-H-14.html#node_idx_1214",[0,[2,"hashtable-hash-function"]],["rnrs/hashtables-6"]],
["hashtable-keys",">r6rs-lib-std/r6rs-lib-Z-H-14.html#node_idx_1208",[0,[2,"hashtable-keys"]],["rnrs/hashtables-6"]],
["hashtable-mutable?",">r6rs-lib-std/r6rs-lib-Z-H-14.html#node_idx_1216",[0,[2,"hashtable-mutable?"]],["rnrs/hashtables-6"]],
["hashtable-ref",">r6rs-lib-std/r6rs-lib-Z-H-14.html#node_idx_1190",[0,[2,"hashtable-ref"]],["rnrs/hashtables-6"]],
["hashtable-set!",">r6rs-lib-std/r6rs-lib-Z-H-14.html#node_idx_1192",[0,[2,"hashtable-set!"]],["rnrs/hashtables-6"]],
["hashtable-size",">r6rs-lib-std/r6rs-lib-Z-H-14.html#node_idx_1188",[0,[2,"hashtable-size"]],["rnrs/hashtables-6"]],
["hashtable-update!",">r6rs-lib-std/r6rs-lib-Z-H-14.html#node_idx_1198",[0,[2,"hashtable-update!"]],["rnrs/hashtables-6"]],
["hashtable?",">r6rs-lib-std/r6rs-lib-Z-H-14.html#node_idx_1186",[0,[2,"hashtable?"]],["rnrs/hashtables-6"]],
["hb-append",">slideshow/Pict_Combiners.html#(def._((lib._slideshow/pict..rkt)._hb-append))",[0,[2,"hb-append"]],["slideshow/pict","slideshow"]],
["hbl-append",">slideshow/Pict_Combiners.html#(def._((lib._slideshow/pict..rkt)._hbl-append))",[0,[2,"hbl-append"]],["slideshow/pict","slideshow"]],
["hc-append",">slideshow/Pict_Combiners.html#(def._((lib._slideshow/pict..rkt)._hc-append))",[0,[2,"hc-append"]],["slideshow/pict","slideshow"]],
["head",">html/index.html#(def._((lib._html/main..rkt)._head))",[0,[2,"head"]],["html"]],
["head pattern",">syntax/stxparse-patterns.html#(tech._head._pattern)","<span style=\"font-style: italic\">head pattern</span>",false],
["head patterns",">syntax/stxparse-patterns.html#(part._.Head_.Patterns)","Head Patterns",false],
["head-impure-port",">net/url.html#(def._((lib._net/url..rkt)._head-impure-port))",[0,[2,"head-impure-port"]],["net/url"]],
["head-of-message",">net/nntp.html#(def._((lib._net/nntp..rkt)._head-of-message))",[0,[2,"head-of-message"]],["net/nntp"]],
["head-pure-port",">net/url.html#(def._((lib._net/url..rkt)._head-pure-port))",[0,[2,"head-pure-port"]],["net/url"]],
["head?",">html/index.html#(def._((lib._html/main..rkt)._head~3f))",[0,[2,"head?"]],["html"]],
["head@",">net/head.html#(def._((lib._net/head-unit..rkt)._head~40))",[0,[2,"head@"]],["net/head-unit"]],
["head^",">net/head.html#(form._((lib._net/head-sig..rkt)._head~5e))",[0,[1,"head^"]],["net/head-sig"]],
["header",">web-server/http.html#(def._((lib._web-server/http/request-structs..rkt)._header))",[0,[2,"header"]],["web-server/http/request-structs"]],
["header",">net/head.html#(tech._header)","<span style=\"font-style: italic\">header</span>",false],
["header files",">inside/overview.html#(idx._(gentag._3._(lib._scribblings/inside/inside..scrbl)))","header files",false],
["header signature",">net/head.html#(part._.Header_.Signature)","Header Signature",false],
["header unit",">net/head.html#(part._.Header_.Unit)","Header Unit",false],
["header-field",">web-server/http.html#(def._((lib._web-server/http/request-structs..rkt)._header-field))",[0,[2,"header-field"]],["web-server/http/request-structs"]],
["header-value",">web-server/http.html#(def._((lib._web-server/http/request-structs..rkt)._header-value))",[0,[2,"header-value"]],["web-server/http/request-structs"]],
["header?",">web-server/http.html#(def._((lib._web-server/http/request-structs..rkt)._header~3f))",[0,[2,"header?"]],["web-server/http/request-structs"]],
["headers-assq",">web-server/http.html#(def._((lib._web-server/http/request-structs..rkt)._headers-assq))",[0,[2,"headers-assq"]],["web-server/http/request-structs"]],
["headers-assq*",">web-server/http.html#(def._((lib._web-server/http/request-structs..rkt)._headers-assq*))",[0,[2,"headers-assq*"]],["web-server/http/request-structs"]],
["headers: parsing and constructing",">net/head.html","Headers: Parsing and Constructing",false],
["heap->vector",">data/Binary_Heaps.html#(def._((lib._data/heap..rkt)._heap-~3evector))",[0,[2,"heap->vector"]],["data/heap"]],
["heap-add!",">data/Binary_Heaps.html#(def._((lib._data/heap..rkt)._heap-add!))",[0,[2,"heap-add!"]],["data/heap"]],
["heap-add-all!",">data/Binary_Heaps.html#(def._((lib._data/heap..rkt)._heap-add-all!))",[0,[2,"heap-add-all!"]],["data/heap"]],
["heap-copy",">data/Binary_Heaps.html#(def._((lib._data/heap..rkt)._heap-copy))",[0,[2,"heap-copy"]],["data/heap"]],
["heap-count",">data/Binary_Heaps.html#(def._((lib._data/heap..rkt)._heap-count))",[0,[2,"heap-count"]],["data/heap"]],
["heap-min",">data/Binary_Heaps.html#(def._((lib._data/heap..rkt)._heap-min))",[0,[2,"heap-min"]],["data/heap"]],
["heap-ref",">plai/collector.html#(def._((lib._plai/collector..rkt)._heap-ref))",[0,[2,"heap-ref"]],["plai/collector"]],
["heap-remove-min!",">data/Binary_Heaps.html#(def._((lib._data/heap..rkt)._heap-remove-min!))",[0,[2,"heap-remove-min!"]],["data/heap"]],
["heap-set!",">plai/collector.html#(def._((lib._plai/collector..rkt)._heap-set!))",[0,[2,"heap-set!"]],["plai/collector"]],
["heap-size",">plai/collector.html#(def._((lib._plai/collector..rkt)._heap-size))",[0,[2,"heap-size"]],["plai/collector"]],
["heap-sort!",">data/Binary_Heaps.html#(def._((lib._data/heap..rkt)._heap-sort!))",[0,[2,"heap-sort!"]],["data/heap"]],
["heap-value?",">plai/collector.html#(def._((lib._plai/collector..rkt)._heap-value~3f))",[0,[2,"heap-value?"]],["plai/collector"]],
["heap?",">data/Binary_Heaps.html#(def._((lib._data/heap..rkt)._heap~3f))",[0,[2,"heap?"]],["data/heap"]],
["heart",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._heart))",[0,[2,"heart"]],["2htdp/planetcute"]],
["height-depends-on-x",">gui/snip_.html#(idx._(gentag._170._(lib._scribblings/gui/gui..scrbl)))",[7,"'height-depends-on-x"],false],
["height-depends-on-y",">gui/snip_.html#(idx._(gentag._168._(lib._scribblings/gui/gui..scrbl)))",[7,"'height-depends-on-y"],false],
["help",">drracket/Menus.html#(part._.Help)","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Help</span>",false],
["help",">reference/Interactive_Help.html#(form._((lib._racket/help..rkt)._help))",[0,[1,"help"]],["racket/help","racket/init"]],
["help",">gui/key-event_.html#(idx._(gentag._62._(lib._scribblings/gui/gui..scrbl)))",[7,"'help"],false],
["help desk menu item",">drracket/Menus.html#(idx._(gentag._147._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Help Desk</span> menu item",false],
["help-desk:report-bug",">tools/Documentation_Utilities.html#(def._((lib._help/bug-report..rkt)._help-desk~3areport-bug))",[0,"help-desk:report-bug"],["help/bug-report"]],
["help-menu:about-callback",">tools/drracket_frame.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aframe~3abasics-mixin)._help-menu~3aabout-callback))",[[0,[2,"help-menu:about-callback"]],[14,[" (method of ",[0,[2,"drracket:frame:basics-mixin"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["help-menu:about-callback",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3aeditor-mixin)._help-menu~3aabout-callback))",[[0,[2,"help-menu:about-callback"]],[14,[" (method of ",[0,[2,"frame:editor-mixin"]],")"]]],["framework"]],
["help-menu:about-callback",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._help-menu~3aabout-callback))",[[0,[2,"help-menu:about-callback"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["help-menu:about-help-string",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._help-menu~3aabout-help-string))",[[0,[2,"help-menu:about-help-string"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["help-menu:about-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._help-menu~3aabout-on-demand))",[[0,[2,"help-menu:about-on-demand"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["help-menu:about-string",">tools/drracket_frame.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aframe~3abasics-mixin)._help-menu~3aabout-string))",[[0,[2,"help-menu:about-string"]],[14,[" (method of ",[0,[2,"drracket:frame:basics-mixin"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["help-menu:about-string",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3aeditor-mixin)._help-menu~3aabout-string))",[[0,[2,"help-menu:about-string"]],[14,[" (method of ",[0,[2,"frame:editor-mixin"]],")"]]],["framework"]],
["help-menu:about-string",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._help-menu~3aabout-string))",[[0,[2,"help-menu:about-string"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["help-menu:after-about",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._help-menu~3aafter-about))",[[0,[2,"help-menu:after-about"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["help-menu:before-about",">tools/drracket_frame.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aframe~3abasics-mixin)._help-menu~3abefore-about))",[[0,[2,"help-menu:before-about"]],[14,[" (method of ",[0,[2,"drracket:frame:basics-mixin"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["help-menu:before-about",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._help-menu~3abefore-about))",[[0,[2,"help-menu:before-about"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["help-menu:create-about?",">tools/drracket_frame.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aframe~3abasics-mixin)._help-menu~3acreate-about~3f))",[[0,[2,"help-menu:create-about?"]],[14,[" (method of ",[0,[2,"drracket:frame:basics-mixin"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["help-menu:create-about?",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3aeditor-mixin)._help-menu~3acreate-about~3f))",[[0,[2,"help-menu:create-about?"]],[14,[" (method of ",[0,[2,"frame:editor-mixin"]],")"]]],["framework"]],
["help-menu:create-about?",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._help-menu~3acreate-about~3f))",[[0,[2,"help-menu:create-about?"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["help-menu:get-about-item",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._help-menu~3aget-about-item))",[[0,[2,"help-menu:get-about-item"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["help/bug-report",">tools/Documentation_Utilities.html#(mod-path._help/bug-report)",[9,[0,"help/bug-report"]],"module"],
["help/help-utils",">scribble/Connecting_to__racket_.html",[9,[0,"help/help-utils"]],"module"],
["help/search",">tools/Documentation_Utilities.html#(mod-path._help/search)",[9,[0,"help/search"]],"module"],
["helper functions",">dynext/Linking.html#(part._.Helper_.Functions)","Helper Functions",false],
["helper functions",">dynext/Compilation.html#(part._.Helper_functions)","Helper functions",false],
["helpers",">embedded-gui/Helpers.html","Helpers",false],
["helpers",">web-server/stateless.html#(part._.Helpers)","Helpers",false],
["helpers for processing keyword syntax",">syntax/syntax-helpers.html#(part._stxkeyword)","Helpers for Processing Keyword Syntax",false],
["here strings",">reference/reader.html#(idx._(gentag._54._(lib._scribblings/reference/reference..scrbl)))","here strings",false],
["heredoc",">reference/reader.html#(idx._(gentag._31._(lib._scribblings/reference/reference..scrbl)))","heredoc",false],
["hidden",">web-server/formlets.html#(def._((lib._web-server/formlets/input..rkt)._hidden))",[0,[2,"hidden"]],["web-server/formlets/input"]],
["hidden",">gui/windowing-overview.html#(tech._hidden)","<span style=\"font-style: italic\">hidden</span>",false],
["hide",">unstable/pict.html#(def._((lib._unstable/gui/pict..rkt)._hide))",[0,[2,"hide"]],["unstable/gui/pict"]],
["hide definitions menu item",">drracket/Menus.html#(idx._(gentag._100._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Hide Definitions</span> menu item",false],
["hide interactions menu item",">drracket/Menus.html#(idx._(gentag._102._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Hide Interactions</span> menu item",false],
["hide line numbers menu item",">drracket/Menus.html#(idx._(gentag._114._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Hide Line Numbers</span> menu item",false],
["hide log menu item",">drracket/Menus.html#(idx._(gentag._106._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Hide Log</span> menu item",false],
["hide module browser menu item",">drracket/Menus.html#(idx._(gentag._116._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Hide Module Browser</span> menu item",false],
["hide optimization coach menu item",">drracket/Menus.html#(idx._(gentag._118._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Hide Optimization Coach</span> menu item",false],
["hide profile menu item",">drracket/Menus.html#(idx._(gentag._110._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Hide Profile</span> menu item",false],
["hide program contour menu item",">drracket/Menus.html#(idx._(gentag._112._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Hide Program Contour</span> menu item",false],
["hide tracing menu item",">drracket/Menus.html#(idx._(gentag._108._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Hide Tracing</span> menu item",false],
["hide-caret",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._hide-caret))",[[0,[2,"hide-caret"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["hide-cursor-until-moved",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._hide-cursor-until-moved))",[0,[2,"hide-cursor-until-moved"]],["racket/gui/base","racket/gui"]],
["hide-delegated-text",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3adelegate~3c~25~3e)._hide-delegated-text))",[[0,[2,"hide-delegated-text"]],[14,[" (method of ",[0,[2,"frame:delegate<%>"]],")"]]],["framework"]],
["hide-hole",">redex/The_Redex_Reference.html#(tech._hide._hole)",[0,"hide-hole"],false],
["hide-info",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3ainfo~3c~25~3e)._hide-info))",[[0,[2,"hide-info"]],[14,[" (method of ",[0,[2,"frame:info<%>"]],")"]]],["framework"]],
["hide-search",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3asearchable~3c~25~3e)._hide-search))",[[0,[2,"hide-search"]],[14,[" (method of ",[0,[2,"frame:searchable<%>"]],")"]]],["framework"]],
["hide-window",">teachpack/gui.html#(def._((lib._htdp/gui..rkt)._hide-window))",[0,[2,"hide-window"]],["htdp/gui"]],
["hierarchical list control",">mrlib/Hierarchical_List_Control.html","Hierarchical List Control",false],
["hierarchical-item-snip%",">mrlib/Snips_in_a_hierarchical-list__Instance.html#(def._((lib._mrlib/hierlist..rkt)._hierarchical-item-snip~25))",[0,[2,"hierarchical-item-snip%"]],["mrlib/hierlist"]],
["hierarchical-list%",">mrlib/hierarchical-list_.html",[0,[2,"hierarchical-list%"]],["mrlib/hierlist"]],
["hierarchical-list-compound-item<%>",">mrlib/hierarchical-list-compound-item___.html",[0,[2,"hierarchical-list-compound-item<%>"]],["mrlib/hierlist"]],
["hierarchical-list-item<%>",">mrlib/hierarchical-list-item___.html",[0,[2,"hierarchical-list-item<%>"]],["mrlib/hierlist"]],
["hierarchical-list-snip%",">mrlib/Snips_in_a_hierarchical-list__Instance.html#(def._((lib._mrlib/hierlist..rkt)._hierarchical-list-snip~25))",[0,[2,"hierarchical-list-snip%"]],["mrlib/hierlist"]],
["high-latency-connection",">db/util.html#(def._((lib._db/util/testing..rkt)._high-latency-connection))",[0,[2,"high-latency-connection"]],["db/util/testing"]],
["high-level scribble api",">scribble/generic-prose.html","High-Level Scribble API",false],
["higher order predicates",">unstable/Functions.html#(part._.Higher_.Order_.Predicates)","Higher Order Predicates",false],
["higher-order functions",">htdp-langs/advanced.html#(part._htdp-advanced._.Higher-.Order_.Functions)","Higher-Order Functions",false],
["higher-order functions",">htdp-langs/intermediate.html#(part._htdp-intermediate._.Higher-.Order_.Functions)","Higher-Order Functions",false],
["higher-order functions",">htdp-langs/intermediate-lam.html#(part._htdp-intermediate-lambda._.Higher-.Order_.Functions)","Higher-Order Functions",false],
["highlight-errors",">tools/drracket_rep.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3arep~3atext~25)._highlight-errors))",[[0,[2,"highlight-errors"]],[14,[" (method of ",[0,[2,"drracket:rep:text%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["highlight-errors/exn",">tools/drracket_rep.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3arep~3atext~25)._highlight-errors/exn))",[[0,[2,"highlight-errors/exn"]],[14,[" (method of ",[0,[2,"drracket:rep:text%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["highlight-first-line",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3afirst-line~3c~25~3e)._highlight-first-line))",[[0,[2,"highlight-first-line"]],[14,[" (method of ",[0,[2,"text:first-line<%>"]],")"]]],["framework"]],
["highlight-range",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3abasic~3c~25~3e)._highlight-range))",[[0,[2,"highlight-range"]],[14,[" (method of ",[0,[2,"text:basic<%>"]],")"]]],["framework"]],
["highlight-range",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3adelegate-mixin)._highlight-range))",[[0,[2,"highlight-range"]],[14,[" (method of ",[0,[2,"text:delegate-mixin"]],")"]]],["framework"]],
["highlighted-color",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._highlighted-color))",[0,[2,"highlighted-color"]],["scribble/racket","scribble/scheme"]],
["hilite",">draw/brush_.html#(idx._(gentag._15._(lib._scribblings/draw/draw..scrbl)))",[7,"'hilite"],false],
["hilite",">draw/pen_.html#(idx._(gentag._55._(lib._scribblings/draw/draw..scrbl)))",[7,"'hilite"],false],
["hilite-region",">cards/index.html#(meth._(((lib._games/cards..rkt)._table~3c~25~3e)._hilite-region))",[[0,[2,"hilite-region"]],[14,[" (method of ",[0,[2,"table<%>"]],")"]]],["games/cards"]],
["hints on designing universes",">teachpack/2htdpuniverse.html#(part._.Hints_on_.Designing_.Universes)","Hints on Designing Universes",false],
["hints on designing worlds",">teachpack/2htdpuniverse.html#(part._.Hints_on_.Designing_.Worlds)","Hints on Designing Worlds",false],
["historical context",">rackunit/philosophy.html#(part._.Historical_.Context)","Historical Context",false],
["history-delete",">readline/index.html#(def._((lib._readline/readline..rkt)._history-delete))",[0,[2,"history-delete"]],["readline/readline"]],
["history-get",">readline/index.html#(def._((lib._readline/readline..rkt)._history-get))",[0,[2,"history-get"]],["readline/readline"]],
["history-length",">readline/index.html#(def._((lib._readline/readline..rkt)._history-length))",[0,[2,"history-length"]],["readline/readline"]],
["hkey_classes_root",">file/resource.html#(idx._(gentag._0._(lib._file/scribblings/file..scrbl)))",[7,"\"HKEY_CLASSES_ROOT\""],false],
["hkey_current_config",">file/resource.html#(idx._(gentag._1._(lib._file/scribblings/file..scrbl)))",[7,"\"HKEY_CURRENT_CONFIG\""],false],
["hkey_current_user",">file/resource.html#(idx._(gentag._2._(lib._file/scribblings/file..scrbl)))",[7,"\"HKEY_CURRENT_USER\""],false],
["hkey_local_machine",">file/resource.html#(idx._(gentag._3._(lib._file/scribblings/file..scrbl)))",[7,"\"HKEY_LOCAL_MACHINE\""],false],
["hkey_users",">file/resource.html#(idx._(gentag._4._(lib._file/scribblings/file..scrbl)))",[7,"\"HKEY_USERS\""],false],
["hline",">slideshow/Basic_Pict_Constructors.html#(def._((lib._slideshow/pict..rkt)._hline))",[0,[2,"hline"]],["slideshow/pict","slideshow"]],
["hline%",">embedded-gui/hline_.html",[0,[2,"hline%"]],["embedded-gui"]],
["hmac-sha1",">web-server/stateless.html#(def._((lib._web-server/stuffers/hmac-sha1..rkt)._.H.M.A.C-.S.H.A1))",[0,[2,"HMAC-SHA1"]],["web-server/stuffers/hmac-sha1"]],
["hmac-sha1 signing",">web-server/stateless.html#(part._.H.M.A.C-.S.H.A1_.Signing)","HMAC-SHA1 Signing",false],
["hmac-sha1-stuffer",">web-server/stateless.html#(def._((lib._web-server/stuffers/hmac-sha1..rkt)._.H.M.A.C-.S.H.A1-stuffer))",[0,[2,"HMAC-SHA1-stuffer"]],["web-server/stuffers/hmac-sha1"]],
["hold",">frtime/index.html#(def._((lib._frtime/main..rkt)._hold))",[0,[2,"hold"]],["frtime"]],
["hole",">redex/The_Redex_Reference.html#(form._((lib._redex/reduction-semantics..rkt)._hole))",[0,[1,"hole"]],["redex/reduction-semantics","redex"]],
["hole",">redex/The_Redex_Reference.html#(tech._hole)",[0,[1,"hole"]],false],
["home",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtles..rkt)._home))",[0,[2,"home"]],["graphics/turtles"]],
["home",">reference/Filesystem.html#(idx._(gentag._262._(lib._scribblings/reference/reference..scrbl)))",[6,"HOME"],false],
["home",">gui/key-event_.html#(idx._(gentag._51._(lib._scribblings/gui/gui..scrbl)))",[7,"'home"],false],
["home-dir",">reference/Filesystem.html#(idx._(gentag._261._(lib._scribblings/reference/reference..scrbl)))",[7,"'home-dir"],false],
["home-region",">cards/index.html#(meth._(((lib._games/cards..rkt)._card~3c~25~3e)._home-region))",[[0,[2,"home-region"]],[14,[" (method of ",[0,[2,"card<%>"]],")"]]],["games/cards"]],
["home-vicinity",">srfi-std/srfi-59.html#home-vicinity",[0,[2,"home-vicinity"]],["srfi/59"]],
["homedrive",">reference/Filesystem.html#(idx._(gentag._266._(lib._scribblings/reference/reference..scrbl)))",[6,"HOMEDRIVE"],false],
["homepage",">planet/Developing_Packages_for_PLaneT.html#(idx._(gentag._21._(lib._planet/planet..scrbl)))",[7,"'homepage"],false],
["homepath",">reference/Filesystem.html#(idx._(gentag._267._(lib._scribblings/reference/reference..scrbl)))",[6,"HOMEPATH"],false],
["horiz-margin",">gui/subarea___.html#(meth._(((lib._mred/main..rkt)._subarea~3c~25~3e)._horiz-margin))",[[0,[2,"horiz-margin"]],[14,[" (method of ",[0,[2,"subarea<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["horiz-margin",">gui/subarea___.html#(idx._(gentag._125._(lib._scribblings/gui/gui..scrbl)))",[0,"horiz-margin"],false],
["horizontal-alignment%",">embedded-gui/horizontal-alignment_.html",[0,[2,"horizontal-alignment%"]],["embedded-gui"]],
["horizontal-bar-spacing",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._horizontal-bar-spacing))",[0,[2,"horizontal-bar-spacing"]],["redex/pict","redex"]],
["horizontal-hatch",">draw/brush_.html#(idx._(gentag._21._(lib._scribblings/draw/draw..scrbl)))",[7,"'horizontal-hatch"],false],
["horizontal-inset",">gui/editor-canvas_.html#(meth._(((lib._mred/main..rkt)._editor-canvas~25)._horizontal-inset))",[[0,[2,"horizontal-inset"]],[14,[" (method of ",[0,[2,"editor-canvas%"]],")"]]],["racket/gui/base","racket/gui"]],
["horizontal-pane%",">gui/horizontal-pane_.html",[0,[2,"horizontal-pane%"]],["racket/gui/base","racket/gui"]],
["horizontal-panel%",">gui/horizontal-panel_.html",[0,[2,"horizontal-panel%"]],["racket/gui/base","racket/gui"]],
["horizontal-pasteboard%",">mrlib/horizontal-pasteboard_.html",[0,[2,"horizontal-pasteboard%"]],["mrlib/aligned-pasteboard"]],
["horizontale justierungsangabe",">deinprogramm/image.html#(tech._horizontale._justierungsangabe)","<span style=\"font-style: italic\">horizontale Justierungsangabe</span>",false],
["horizontale positionsangabe",">deinprogramm/image.html#(tech._horizontale._positionsangabe)","<span style=\"font-style: italic\">horizontale Positionsangabe</span>",false],
["host",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._host))",[0,[2,"host"]],["web-server/configuration/configuration-table-structs"]],
["host-indices",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._host-indices))",[0,[2,"host-indices"]],["web-server/configuration/configuration-table-structs"]],
["host-log-format",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._host-log-format))",[0,[2,"host-log-format"]],["web-server/configuration/configuration-table-structs"]],
["host-log-path",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._host-log-path))",[0,[2,"host-log-path"]],["web-server/configuration/configuration-table-structs"]],
["host-passwords",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._host-passwords))",[0,[2,"host-passwords"]],["web-server/configuration/configuration-table-structs"]],
["host-paths",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._host-paths))",[0,[2,"host-paths"]],["web-server/configuration/configuration-table-structs"]],
["host-responders",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._host-responders))",[0,[2,"host-responders"]],["web-server/configuration/configuration-table-structs"]],
["host-root",">web-server-internal/Web_Servers.html#(idx._(gentag._25._(lib._web-server/scribblings/web-server-internal..scrbl)))","host-root",false],
["host-table",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._host-table))",[0,[2,"host-table"]],["web-server/configuration/configuration-table-structs"]],
["host-table",">web-server-internal/Web_Servers.html#(idx._(gentag._6._(lib._web-server/scribblings/web-server-internal..scrbl)))","host-table",false],
["host-table-indices",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._host-table-indices))",[0,[2,"host-table-indices"]],["web-server/configuration/configuration-table-structs"]],
["host-table-log-format",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._host-table-log-format))",[0,[2,"host-table-log-format"]],["web-server/configuration/configuration-table-structs"]],
["host-table-messages",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._host-table-messages))",[0,[2,"host-table-messages"]],["web-server/configuration/configuration-table-structs"]],
["host-table-paths",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._host-table-paths))",[0,[2,"host-table-paths"]],["web-server/configuration/configuration-table-structs"]],
["host-table-timeouts",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._host-table-timeouts))",[0,[2,"host-table-timeouts"]],["web-server/configuration/configuration-table-structs"]],
["host-table?",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._host-table~3f))",[0,[2,"host-table?"]],["web-server/configuration/configuration-table-structs"]],
["host-timeouts",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._host-timeouts))",[0,[2,"host-timeouts"]],["web-server/configuration/configuration-table-structs"]],
["host?",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._host~3f))",[0,[2,"host?"]],["web-server/configuration/configuration-table-structs"]],
["hover-property",">scribble/core.html#(def._((lib._scribble/html-properties..rkt)._hover-property))",[0,[2,"hover-property"]],["scribble/html-properties"]],
["hover-property-text",">scribble/core.html#(def._((lib._scribble/html-properties..rkt)._hover-property-text))",[0,[2,"hover-property-text"]],["scribble/html-properties"]],
["hover-property?",">scribble/core.html#(def._((lib._scribble/html-properties..rkt)._hover-property~3f))",[0,[2,"hover-property?"]],["scribble/html-properties"]],
["how are stateless servlets different from stateful servlets vis a vis refreshing?",">web-server/faq.html#(part._.How_are_stateless_servlets_different_from_stateful_servlets_vis_a_vis_refreshing_)","How are stateless servlets different from stateful servlets vis a vis refreshing?",false],
["how do i limit the number of requests serviced at once by the web server?",">web-server-internal/Troubleshooting_and_Tips.html#(part._.How_do_.I_limit_the_number_of_requests_serviced_at_once_by_the_.Web_.Server_)","How do I limit the number of requests serviced at once by the Web Server?",false],
["how do i set up the server to use https?",">web-server-internal/Troubleshooting_and_Tips.html#(part._faq~3ahttps)","How do I set up the server to use HTTPS?",false],
["how do i use apache with the racket web server?",">web-server-internal/Troubleshooting_and_Tips.html#(part._.How_do_.I_use_.Apache_with_the_.Racket_.Web_.Server_)","How do I use Apache with the Racket Web Server?",false],
["how do i use templates \"dynamically\"?",">web-server/faq.html#(part._.How_do_.I_use_templates__dynamically__)","How do I use templates &ldquo;dynamically\"?",false],
["how do i use the stepper?",">stepper/index.html#(part._.How_do_.I_use_the_.Stepper_)","How do I use the Stepper?",false],
["how does the stepper work?",">stepper/index.html#(part._.How_.Does_the_.Stepper_work_)","How Does the Stepper work?",false],
["how to design programs languages",">htdp-langs/index.html","<span style=\"font-style: italic\">How to Design Programs</span> Languages",false],
["how to design programs teaching languages",">drracket/htdp-langs.html","<span style=\"font-style: italic\">How to Design Programs</span> Teaching Languages",false],
["how to design programs teachpacks",">teachpack/index.html","<span style=\"font-style: italic\">How to Design Programs</span> Teachpacks",false],
["hr",">html/index.html#(def._((lib._html/main..rkt)._hr))",[0,[2,"hr"]],["html"]],
["hr?",">html/index.html#(def._((lib._html/main..rkt)._hr~3f))",[0,[2,"hr?"]],["html"]],
["hscroll",">gui/canvas_.html#(idx._(gentag._24._(lib._scribblings/gui/gui..scrbl)))",[7,"'hscroll"],false],
["hscroll",">gui/canvas_.html#(idx._(gentag._26._(lib._scribblings/gui/gui..scrbl)))",[7,"'hscroll"],false],
["hspace",">scribble/base.html#(def._((lib._scribble/base..rkt)._hspace))",[0,[2,"hspace"]],["scribble/base"]],
["ht-append",">slideshow/Pict_Combiners.html#(def._((lib._slideshow/pict..rkt)._ht-append))",[0,[2,"ht-append"]],["slideshow/pict","slideshow"]],
["htdp advanced student",">htdp/index.html#(part._.Ht.D.P_.Advanced_.Student)","<span style=\"font-style: italic\">HtDP</span> Advanced Student",false],
["htdp beginning student",">htdp/index.html#(part._.Ht.D.P_.Beginning_.Student)","<span style=\"font-style: italic\">HtDP</span> Beginning Student",false],
["htdp beginning student with abbreviations",">htdp/index.html#(part._.Ht.D.P_.Beginning_.Student_with_.Abbreviations)","<span style=\"font-style: italic\">HtDP</span> Beginning Student with Abbreviations",false],
["htdp intermediate student",">htdp/index.html#(part._.Ht.D.P_.Intermediate_.Student)","<span style=\"font-style: italic\">HtDP</span> Intermediate Student",false],
["htdp intermediate student with lambda",">htdp/index.html#(part._.Ht.D.P_.Intermediate_.Student_with_.Lambda)","<span style=\"font-style: italic\">HtDP</span> Intermediate Student with Lambda",false],
["htdp languages as libraries",">htdp/index.html#(part._.Ht.D.P_.Languages_as_.Libraries)","HtDP Languages as Libraries",false],
["htdp teachpacks",">teachpack/htdp.html","HtDP Teachpacks",false],
["htdp-file-prefix?",">tools/Teaching_Languages.html#(def._((lib._lang/htdp-langs-save-file-prefix..rkt)._htdp-file-prefix~3f))",[0,"htdp-file-prefix?"],["lang/htdp-langs-save-file-prefix"]],
["htdp-save-file-prefix",">tools/Teaching_Languages.html#(def._((lib._lang/htdp-langs-save-file-prefix..rkt)._htdp-save-file-prefix))",[0,"htdp-save-file-prefix"],["lang/htdp-langs-save-file-prefix"]],
["htdp/2e teachpacks",">teachpack/2htdp2htdp.html","HtDP/2e Teachpacks",false],
["htdp/arrow",">teachpack/arrow.html",[9,[0,"htdp/arrow"]],"module"],
["htdp/arrow-gui",">teachpack/arrow-gui.html",[9,[0,"htdp/arrow-gui"]],"module"],
["htdp/color-structs",">htdp/index.html#(mod-path._htdp/color-structs)",[9,[0,"htdp/color-structs"]],"module"],
["htdp/convert",">teachpack/convert.html",[9,[0,"htdp/convert"]],"module"],
["htdp/dir",">teachpack/dir.html",[9,[0,"htdp/dir"]],"module"],
["htdp/docs",">teachpack/docs.html",[9,[0,"htdp/docs"]],"module"],
["htdp/draw",">teachpack/draw.html",[9,[0,"htdp/draw"]],"module"],
["htdp/elevator",">teachpack/elevator.html",[9,[0,"htdp/elevator"]],"module"],
["htdp/error",">htdp/index.html#(mod-path._htdp/error)",[9,[0,"htdp/error"]],"module"],
["htdp/graphing",">teachpack/graphing.html",[9,[0,"htdp/graphing"]],"module"],
["htdp/guess",">teachpack/guess.html",[9,[0,"htdp/guess"]],"module"],
["htdp/guess-gui",">teachpack/guess-gui.html",[9,[0,"htdp/guess-gui"]],"module"],
["htdp/gui",">teachpack/gui.html",[9,[0,"htdp/gui"]],"module"],
["htdp/hangman",">teachpack/hangman.html",[9,[0,"htdp/hangman"]],"module"],
["htdp/hangman-play",">teachpack/hangman-play.html",[9,[0,"htdp/hangman-play"]],"module"],
["htdp/image",">teachpack/image.html",[9,[0,"htdp/image"]],"module"],
["htdp/lkup-gui",">teachpack/lkup-gui.html",[9,[0,"htdp/lkup-gui"]],"module"],
["htdp/master",">teachpack/master.html",[9,[0,"htdp/master"]],"module"],
["htdp/master-play",">teachpack/master-play.html",[9,[0,"htdp/master-play"]],"module"],
["htdp/matrix",">teachpack/matrix.html",[9,[0,"htdp/matrix"]],"module"],
["htdp/show-queen",">teachpack/show-queen.html",[9,[0,"htdp/show-queen"]],"module"],
["htdp/testing",">htdp/index.html#(mod-path._htdp/testing)",[9,[0,"htdp/testing"]],"module"],
["htdp/world",">teachpack/world.html",[9,[0,"htdp/world"]],"module"],
["htl-append",">slideshow/Pict_Combiners.html#(def._((lib._slideshow/pict..rkt)._htl-append))",[0,[2,"htl-append"]],["slideshow/pict","slideshow"]],
["html",">html/index.html",[9,[0,"html"]],"module"],
["html",">html/index.html#(def._((lib._html/main..rkt)._html))",[0,[2,"html"]],["html"]],
["html as text editor",">browser/index.html#(part._html-text)","HTML As Text Editor",false],
["html renderer",">scribble/renderer.html#(part._.H.T.M.L_.Renderer)","HTML Renderer",false],
["html structures",">html/index.html#(part._.H.T.M.L_.Structures)","HTML Structures",false],
["html style properties",">scribble/core.html#(part._.H.T.M.L_.Style_.Properties)","HTML Style Properties",false],
["html-content/c",">html/index.html#(def._((lib._html/main..rkt)._html-content/c))",[0,[2,"html-content/c"]],["html"]],
["html-defaults",">scribble/core.html#(def._((lib._scribble/html-properties..rkt)._html-defaults))",[0,[2,"html-defaults"]],["scribble/html-properties"]],
["html-defaults-extra-files",">scribble/core.html#(def._((lib._scribble/html-properties..rkt)._html-defaults-extra-files))",[0,[2,"html-defaults-extra-files"]],["scribble/html-properties"]],
["html-defaults-prefix",">scribble/core.html#(def._((lib._scribble/html-properties..rkt)._html-defaults-prefix))",[0,[2,"html-defaults-prefix"]],["scribble/html-properties"]],
["html-defaults-style",">scribble/core.html#(def._((lib._scribble/html-properties..rkt)._html-defaults-style))",[0,[2,"html-defaults-style"]],["scribble/html-properties"]],
["html-defaults?",">scribble/core.html#(def._((lib._scribble/html-properties..rkt)._html-defaults~3f))",[0,[2,"html-defaults?"]],["scribble/html-properties"]],
["html-element",">html/index.html#(def._((lib._html/main..rkt)._html-element))",[0,[2,"html-element"]],["html"]],
["html-element-attributes",">html/index.html#(def._((lib._html/main..rkt)._html-element-attributes))",[0,[2,"html-element-attributes"]],["html"]],
["html-element?",">html/index.html#(def._((lib._html/main..rkt)._html-element~3f))",[0,[2,"html-element?"]],["html"]],
["html-empty-tags",">xml/index.html#(def._((lib._xml/main..rkt)._html-empty-tags))",[0,[2,"html-empty-tags"]],["xml"]],
["html-eval-ok",">browser/index.html#(def._((lib._browser/browser..rkt)._html-eval-ok))",[0,[2,"html-eval-ok"]],["browser/browser","browser"]],
["html-full",">html/index.html#(def._((lib._html/main..rkt)._html-full))",[0,[2,"html-full"]],["html"]],
["html-full-content",">html/index.html#(def._((lib._html/main..rkt)._html-full-content))",[0,[2,"html-full-content"]],["html"]],
["html-full?",">html/index.html#(def._((lib._html/main..rkt)._html-full~3f))",[0,[2,"html-full?"]],["html"]],
["html-img-ok",">browser/index.html#(def._((lib._browser/browser..rkt)._html-img-ok))",[0,[2,"html-img-ok"]],["browser/browser","browser"]],
["html-text-mixin",">browser/index.html#(def._((lib._browser/htmltext..rkt)._html-text-mixin))",[0,[2,"html-text-mixin"]],["browser/htmltext"]],
["html-text<%>",">browser/index.html#(def._((lib._browser/htmltext..rkt)._html-text~3c~25~3e))",[0,[2,"html-text<%>"]],["browser/htmltext"]],
["html: parsing library",">html/index.html","HTML: Parsing Library",false],
["html?",">html/index.html#(def._((lib._html/main..rkt)._html~3f))",[0,[2,"html?"]],["html"]],
["http responses",">web-server/templates.html#(part._.H.T.T.P_.Responses)","HTTP Responses",false],
["http-download-servlet-url",">planet/Utility_Libraries.html#(def._((lib._planet/config..rkt)._.H.T.T.P-.D.O.W.N.L.O.A.D-.S.E.R.V.L.E.T-.U.R.L))",[0,[2,"HTTP-DOWNLOAD-SERVLET-URL"]],["planet/config"]],
["http: hypertext transfer protocol",">web-server/http.html","HTTP: Hypertext Transfer Protocol",false],
["hyper-canvas%",">browser/index.html#(def._((lib._browser/browser..rkt)._hyper-canvas~25))",[0,[2,"hyper-canvas%"]],["browser/browser","browser"]],
["hyper-canvas-mixin",">browser/index.html#(def._((lib._browser/browser..rkt)._hyper-canvas-mixin))",[0,[2,"hyper-canvas-mixin"]],["browser/browser","browser"]],
["hyper-delta",">browser/index.html#(meth._(((lib._browser/browser..rkt)._hyper-text-mixin)._hyper-delta))",[[0,[2,"hyper-delta"]],[14,[" (method of ",[0,[2,"hyper-text-mixin"]],")"]]],["browser/browser","browser"]],
["hyper-frame%",">browser/index.html#(def._((lib._browser/browser..rkt)._hyper-frame~25))",[0,[2,"hyper-frame%"]],["browser/browser","browser"]],
["hyper-frame-mixin",">browser/index.html#(def._((lib._browser/browser..rkt)._hyper-frame-mixin))",[0,[2,"hyper-frame-mixin"]],["browser/browser","browser"]],
["hyper-frame<%>",">browser/index.html#(def._((lib._browser/browser..rkt)._hyper-frame~3c~25~3e))",[0,[2,"hyper-frame<%>"]],["browser/browser","browser"]],
["hyper-no-show-frame%",">browser/index.html#(def._((lib._browser/browser..rkt)._hyper-no-show-frame~25))",[0,[2,"hyper-no-show-frame%"]],["browser/browser","browser"]],
["hyper-no-show-frame-mixin",">browser/index.html#(def._((lib._browser/browser..rkt)._hyper-no-show-frame-mixin))",[0,[2,"hyper-no-show-frame-mixin"]],["browser/browser","browser"]],
["hyper-panel%",">browser/index.html#(def._((lib._browser/browser..rkt)._hyper-panel~25))",[0,[2,"hyper-panel%"]],["browser/browser","browser"]],
["hyper-panel-mixin",">browser/index.html#(def._((lib._browser/browser..rkt)._hyper-panel-mixin))",[0,[2,"hyper-panel-mixin"]],["browser/browser","browser"]],
["hyper-panel<%>",">browser/index.html#(def._((lib._browser/browser..rkt)._hyper-panel~3c~25~3e))",[0,[2,"hyper-panel<%>"]],["browser/browser","browser"]],
["hyper-text%",">browser/index.html#(def._((lib._browser/browser..rkt)._hyper-text~25))",[0,[2,"hyper-text%"]],["browser/browser","browser"]],
["hyper-text-mixin",">browser/index.html#(def._((lib._browser/browser..rkt)._hyper-text-mixin))",[0,[2,"hyper-text-mixin"]],["browser/browser","browser"]],
["hyper-text<%>",">browser/index.html#(def._((lib._browser/browser..rkt)._hyper-text~3c~25~3e))",[0,[2,"hyper-text<%>"]],["browser/browser","browser"]],
["hyperlink",">scribble/base.html#(def._((lib._scribble/base..rkt)._hyperlink))",[0,[2,"hyperlink"]],["scribble/base"]],
["hyperlinkize",">slideshow/Miscellaneous.html#(def._((lib._slideshow/pict..rkt)._hyperlinkize))",[0,[2,"hyperlinkize"]],["slideshow/pict","slideshow"]],
["i",">html/index.html#(def._((lib._html/main..rkt)._i))",[0,[2,"i"]],["html"]],
["i",">redex/The_Redex_Reference.html#(form._((lib._redex/reduction-semantics..rkt)._.I))",[0,[1,"I"]],["redex/reduction-semantics","redex"]],
["i/o",">drracket/interactions-window.html#(idx._(gentag._28._(lib._scribblings/drracket/drracket..scrbl)))","I/O",false],
["i/o patterns",">guide/io-patterns.html","I/O Patterns",false],
["i/o-decoding-error?",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_604",[0,[2,"i/o-decoding-error?"]],["rnrs/io/ports-6"]],
["i/o-encoding-error-char",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_612",[0,[2,"i/o-encoding-error-char"]],["rnrs/io/ports-6"]],
["i/o-encoding-error?",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_610",[0,[2,"i/o-encoding-error?"]],["rnrs/io/ports-6"]],
["i/o-error-filename",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_526",[0,[2,"i/o-error-filename"]],["rnrs/io/ports-6"]],
["i/o-error-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_558",[0,[2,"i/o-error-port"]],["rnrs/io/ports-6"]],
["i/o-error-position",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_518",[0,[2,"i/o-error-position"]],["rnrs/io/ports-6"]],
["i/o-error?",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_498",[0,[2,"i/o-error?"]],["rnrs/io/ports-6"]],
["i/o-file-already-exists-error?",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_544",[0,[2,"i/o-file-already-exists-error?"]],["rnrs/io/ports-6"]],
["i/o-file-does-not-exist-error?",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_550",[0,[2,"i/o-file-does-not-exist-error?"]],["rnrs/io/ports-6"]],
["i/o-file-is-read-only-error?",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_538",[0,[2,"i/o-file-is-read-only-error?"]],["rnrs/io/ports-6"]],
["i/o-file-protection-error?",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_532",[0,[2,"i/o-file-protection-error?"]],["rnrs/io/ports-6"]],
["i/o-filename-error?",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_524",[0,[2,"i/o-filename-error?"]],["rnrs/io/ports-6"]],
["i/o-invalid-position-error?",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_516",[0,[2,"i/o-invalid-position-error?"]],["rnrs/io/ports-6"]],
["i/o-port-error?",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_556",[0,[2,"i/o-port-error?"]],["rnrs/io/ports-6"]],
["i/o-read-error?",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_504",[0,[2,"i/o-read-error?"]],["rnrs/io/ports-6"]],
["i/o-write-error?",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_510",[0,[2,"i/o-write-error?"]],["rnrs/io/ports-6"]],
["i?",">html/index.html#(def._((lib._html/main..rkt)._i~3f))",[0,[2,"i?"]],["html"]],
["ico file reading and writing",">file/ico.html","ICO File Reading and Writing",false],
["ico->argb",">file/ico.html#(def._((lib._file/ico..rkt)._ico-~3eargb))",[0,[2,"ico->argb"]],["file/ico"]],
["ico-depth",">file/ico.html#(def._((lib._file/ico..rkt)._ico-depth))",[0,[2,"ico-depth"]],["file/ico"]],
["ico-height",">file/ico.html#(def._((lib._file/ico..rkt)._ico-height))",[0,[2,"ico-height"]],["file/ico"]],
["ico-width",">file/ico.html#(def._((lib._file/ico..rkt)._ico-width))",[0,[2,"ico-width"]],["file/ico"]],
["ico?",">file/ico.html#(def._((lib._file/ico..rkt)._ico~3f))",[0,[2,"ico?"]],["file/ico"]],
["icon",">framework/Icon.html","Icon",false],
["icon style",">images/Icons.html#(part._.Icon_.Style)","Icon Style",false],
["icon-color->outline-color",">images/Icons.html#(def._((lib._images/icons/style..rkt)._icon-color-~3eoutline-color))",[0,[2,"icon-color->outline-color"]],["images/icons/style"]],
["icon:get-anchor-bitmap",">framework/Icon.html#(def._((lib._framework/main..rkt)._icon~3aget-anchor-bitmap))",[0,[2,"icon:get-anchor-bitmap"]],["framework"]],
["icon:get-autowrap-bitmap",">framework/Icon.html#(def._((lib._framework/main..rkt)._icon~3aget-autowrap-bitmap))",[0,[2,"icon:get-autowrap-bitmap"]],["framework"]],
["icon:get-eof-bitmap",">framework/Icon.html#(def._((lib._framework/main..rkt)._icon~3aget-eof-bitmap))",[0,[2,"icon:get-eof-bitmap"]],["framework"]],
["icon:get-gc-off-bitmap",">framework/Icon.html#(def._((lib._framework/main..rkt)._icon~3aget-gc-off-bitmap))",[0,[2,"icon:get-gc-off-bitmap"]],["framework"]],
["icon:get-gc-on-bitmap",">framework/Icon.html#(def._((lib._framework/main..rkt)._icon~3aget-gc-on-bitmap))",[0,[2,"icon:get-gc-on-bitmap"]],["framework"]],
["icon:get-left/right-cursor",">framework/Icon.html#(def._((lib._framework/main..rkt)._icon~3aget-left/right-cursor))",[0,[2,"icon:get-left/right-cursor"]],["framework"]],
["icon:get-lock-bitmap",">framework/Icon.html#(def._((lib._framework/main..rkt)._icon~3aget-lock-bitmap))",[0,[2,"icon:get-lock-bitmap"]],["framework"]],
["icon:get-paren-highlight-bitmap",">framework/Icon.html#(def._((lib._framework/main..rkt)._icon~3aget-paren-highlight-bitmap))",[0,[2,"icon:get-paren-highlight-bitmap"]],["framework"]],
["icon:get-unlock-bitmap",">framework/Icon.html#(def._((lib._framework/main..rkt)._icon~3aget-unlock-bitmap))",[0,[2,"icon:get-unlock-bitmap"]],["framework"]],
["icon:get-up/down-cursor",">framework/Icon.html#(def._((lib._framework/main..rkt)._icon~3aget-up/down-cursor))",[0,[2,"icon:get-up/down-cursor"]],["framework"]],
["iconize",">gui/frame_.html#(meth._(((lib._mred/main..rkt)._frame~25)._iconize))",[[0,[2,"iconize"]],[14,[" (method of ",[0,[2,"frame%"]],")"]]],["racket/gui/base","racket/gui"]],
["icons",">images/Icons.html","Icons",false],
["id",">syntax/Library_Syntax_Classes_and_Literal_Sets.html#(form._((lib._syntax/parse..rkt)._id))",[0,[1,"id"]],["syntax/parse"]],
["id-color",">slideshow/Typesetting_Racket_Code.html#(def._((lib._slideshow/code..rkt)._id-color))",[0,[2,"id-color"]],["slideshow/code"]],
["id-function",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._id-function))",[0,[2,"id-function"]],["plot"]],
["id-stuffer",">web-server/stateless.html#(def._((lib._web-server/stuffers/stuffer..rkt)._id-stuffer))",[0,[2,"id-stuffer"]],["web-server/stuffers/stuffer"]],
["id-table-iter?",">syntax/syntax-helpers.html#(def._((lib._syntax/id-table..rkt)._id-table-iter~3f))",[0,[2,"id-table-iter?"]],["syntax/id-table"]],
["id-transform",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._id-transform))",[0,[2,"id-transform"]],["plot"]],
["idefterm",">scribble/manual-indexing.html#(def._((lib._scribble/manual..rkt)._idefterm))",[0,[2,"idefterm"]],["scribble/manual"]],
["identifier",">syntax/Library_Syntax_Classes_and_Literal_Sets.html#(form._((lib._syntax/parse..rkt)._identifier))",[0,[1,"identifier"]],["syntax/parse"]],
["identifier",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Identifier))",[0,[1,"Identifier"]],["typed/racket/base","typed/racket"]],
["identifier",">reference/syntax-model.html#(tech._identifier)","<span style=\"font-style: italic\">identifier</span>",false],
["identifier macro",">guide/pattern-macros.html#(tech._identifier._macro)","<span style=\"font-style: italic\">identifier macro</span>",false],
["identifier macros",">guide/pattern-macros.html#(part._.Identifier_.Macros)","Identifier Macros",false],
["identifier syntax object",">guide/stx-obj.html#(tech._identifier._syntax._object)","<span style=\"font-style: italic\">identifier\nsyntax object</span>",false],
["identifier tables",">syntax/syntax-helpers.html#(tech._identifier._table)","<span style=\"font-style: italic\">identifier tables</span>",false],
["identifier-binding",">reference/stxcmp.html#(def._((quote._~23~25kernel)._identifier-binding))",[0,[2,"identifier-binding"]],["racket/base","racket"]],
["identifier-label-binding",">reference/stxcmp.html#(def._((quote._~23~25kernel)._identifier-label-binding))",[0,[2,"identifier-label-binding"]],["racket/base","racket"]],
["identifier-prune-lexical-context",">reference/stxops.html#(def._((quote._~23~25kernel)._identifier-prune-lexical-context))",[0,[2,"identifier-prune-lexical-context"]],["racket/base","racket"]],
["identifier-prune-to-source-module",">reference/stxops.html#(def._((quote._~23~25kernel)._identifier-prune-to-source-module))",[0,[2,"identifier-prune-to-source-module"]],["racket/base","racket"]],
["identifier-remove-from-definition-context",">reference/stxtrans.html#(def._((quote._~23~25kernel)._identifier-remove-from-definition-context))",[0,[2,"identifier-remove-from-definition-context"]],["racket/base","racket"]],
["identifier-syntax",">r6rs-std/r6rs-Z-H-14.html#node_idx_796",[0,[1,"identifier-syntax"]],["r6rs/private/base-for-syntax"]],
["identifier-template-binding",">reference/stxcmp.html#(def._((quote._~23~25kernel)._identifier-template-binding))",[0,[2,"identifier-template-binding"]],["racket/base","racket"]],
["identifier-transformer-binding",">reference/stxcmp.html#(def._((quote._~23~25kernel)._identifier-transformer-binding))",[0,[2,"identifier-transformer-binding"]],["racket/base","racket"]],
["identifier?",">reference/stxops.html#(def._((lib._racket/private/stx..rkt)._identifier~3f))",[0,[2,"identifier?"]],["racket/base","racket"]],
["identifier?",">r6rs-lib-std/r6rs-lib-Z-H-13.html#node_idx_1138",[0,[2,"identifier?"]],["rnrs/syntax-case-6"]],
["identifiers",">guide/syntax-overview.html#(part._.Identifiers)","Identifiers",false],
["identifiers and binding",">guide/binding.html","Identifiers and Binding",false],
["identifiers and binding",">reference/syntax-model.html#(part._id-model)","Identifiers and Binding",false],
["identity",">reference/procedures.html#(def._((lib._racket/function..rkt)._identity))",[0,[2,"identity"]],["racket/function","racket"]],
["identity",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._identity))",[0,[2,"identity"]],["lang/htdp-advanced"]],
["identity",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._identity))",[0,[2,"identity"]],["lang/htdp-beginner"]],
["identity",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._identity))",[0,[2,"identity"]],["lang/htdp-beginner-abbr"]],
["identity",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._identity))",[0,[2,"identity"]],["lang/htdp-intermediate"]],
["identity",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._identity))",[0,[2,"identity"]],["lang/htdp-intermediate-lambda"]],
["identity",">lazy/index.html#(def._((lib._lazy/main..rkt)._identity))",[0,[2,"identity"]],["lazy"]],
["identity",">mzlib/mzlib_etc.html#(def._((lib._mzlib/etc..rkt)._identity))",[0,[2,"identity"]],["mzlib/etc"]],
["idispatch",">foreign/com-auto.html#(idx._(gentag._14._(lib._scribblings/foreign/foreign..scrbl)))",[6,"IDispatch"],false],
["ieee floating-point numbers",">reference/numbers.html#(idx._(gentag._98._(lib._scribblings/reference/reference..scrbl)))","IEEE floating-point numbers",false],
["if",">deinprogramm/if.html",[0,[1,"if"]],false],
["if",">reference/if.html#(form._((quote._~23~25kernel)._if))",[0,[1,"if"]],["racket/base","racket"]],
["if",">r5rs-std/r5rs-Z-H-7.html#%_idx_98",[0,[1,"if"]],["r5rs"]],
["if",">r6rs-std/r6rs-Z-H-14.html#node_idx_366",[0,[1,"if"]],["rnrs/base-6"]],
["if",">htdp-langs/advanced.html#(form._((lib._lang/htdp-advanced..rkt)._if))",[0,[1,"if"]],["lang/htdp-advanced"]],
["if",">htdp-langs/beginner.html#(form._((lib._lang/htdp-beginner..rkt)._if))",[0,[1,"if"]],["lang/htdp-beginner"]],
["if",">htdp-langs/beginner-abbr.html#(form._((lib._lang/htdp-beginner-abbr..rkt)._if))",[0,[1,"if"]],["lang/htdp-beginner-abbr"]],
["if",">htdp-langs/intermediate.html#(form._((lib._lang/htdp-intermediate..rkt)._if))",[0,[1,"if"]],["lang/htdp-intermediate"]],
["if",">htdp-langs/intermediate-lam.html#(form._((lib._lang/htdp-intermediate-lambda..rkt)._if))",[0,[1,"if"]],["lang/htdp-intermediate-lambda"]],
["if",">deinprogramm/if.html#(form._((lib._deinprogramm/.D.Md.A..rkt)._if))",[0,[1,"if"]],["deinprogramm/DMdA-beginner"]],
["if",">lazy/index.html#(form._((lib._lazy/main..rkt)._if))",[0,[1,"if"]],["lazy"]],
["if",">mzscheme/Old_Syntactic_Forms.html#(form._((lib._mzscheme/main..rkt)._if))",[0,[1,"if"]],["mzscheme"]],
["if",">plai/mutator.html#(form._((lib._plai/mutator..rkt)._if))",[0,[1,"if"]],["plai/mutator"]],
["if",">srfi-std/srfi-42.html#if",[0,[1,"if"]],["srfi/42"]],
["if/c",">unstable/contract.html#(def._((lib._unstable/contract..rkt)._if/c))",[0,[2,"if/c"]],["unstable/contract"]],
["iframe",">html/index.html#(def._((lib._html/main..rkt)._iframe))",[0,[2,"iframe"]],["html"]],
["iframe?",">html/index.html#(def._((lib._html/main..rkt)._iframe~3f))",[0,[2,"iframe?"]],["html"]],
["iid",">foreign/com.html#(tech._iid)","<span style=\"font-style: italic\">IID</span>",false],
["iid?",">foreign/com-auto.html#(def._((lib._ffi/unsafe/com..rkt)._iid~3f))",[0,[2,"iid?"]],["ffi/com"]],
["iid_iunknown",">foreign/com-intf.html#(def._((lib._ffi/unsafe/com..rkt)._.I.I.D_.I.Unknown))",[0,[2,"IID_IUnknown"]],["ffi/unsafe/com"]],
["iid_null",">foreign/com-intf.html#(def._((lib._ffi/unsafe/com..rkt)._.I.I.D_.N.U.L.L))",[0,[2,"IID_NULL"]],["ffi/unsafe/com"]],
["illegal-message-number",">net/pop3.html#(def._((lib._net/pop3..rkt)._illegal-message-number))",[0,[2,"illegal-message-number"]],["net/pop3"]],
["illegal-message-number-communicator",">net/pop3.html#(def._((lib._net/pop3..rkt)._illegal-message-number-communicator))",[0,[2,"illegal-message-number-communicator"]],["net/pop3"]],
["illegal-message-number-message",">net/pop3.html#(def._((lib._net/pop3..rkt)._illegal-message-number-message))",[0,[2,"illegal-message-number-message"]],["net/pop3"]],
["illegal-message-number?",">net/pop3.html#(def._((lib._net/pop3..rkt)._illegal-message-number~3f))",[0,[2,"illegal-message-number?"]],["net/pop3"]],
["imag-part",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._imag-part))",[0,[2,"imag-part"]],["racket/base","racket"]],
["imag-part",">r5rs-std/r5rs-Z-H-9.html#%_idx_354",[0,[2,"imag-part"]],["r5rs"]],
["imag-part",">r6rs-std/r6rs-Z-H-14.html#node_idx_572",[0,[2,"imag-part"]],["rnrs/base-6"]],
["imag-part",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._imag-part))",[0,[2,"imag-part"]],["lang/htdp-advanced"]],
["imag-part",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._imag-part))",[0,[2,"imag-part"]],["lang/htdp-beginner"]],
["imag-part",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._imag-part))",[0,[2,"imag-part"]],["lang/htdp-beginner-abbr"]],
["imag-part",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._imag-part))",[0,[2,"imag-part"]],["lang/htdp-intermediate"]],
["imag-part",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._imag-part))",[0,[2,"imag-part"]],["lang/htdp-intermediate-lambda"]],
["imag-part",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._imag-part))",[0,[2,"imag-part"]],["deinprogramm/DMdA-advanced"]],
["imag-part",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._imag-part))",[0,[2,"imag-part"]],["deinprogramm/DMdA-assignments"]],
["imag-part",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._imag-part))",[0,[2,"imag-part"]],["deinprogramm/DMdA-beginner"]],
["imag-part",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._imag-part))",[0,[2,"imag-part"]],["deinprogramm/DMdA-vanilla"]],
["image",">scribble/base.html#(def._((lib._scribble/base..rkt)._image))",[0,[2,"image"]],["scribble/base"]],
["image",">deinprogramm/image.html#(def._((lib._deinprogramm/image..rkt)._image))",[0,[2,"image"]],["teachpack/deinprogramm/image"]],
["image core",">mrlib/Image_Core.html","Image Core",false],
["image equality in htdp languages",">htdp/index.html#(part._.Image_.Equality_in_.Ht.D.P_.Languages)","Image Equality in <span style=\"font-style: italic\">HtDP</span> Languages",false],
["image guide",">teachpack/2htdpimage-guide.html","Image Guide",false],
["image predicates",">teachpack/2htdpimage.html#(part._.Image_.Predicates)","Image Predicates",false],
["image properties",">teachpack/2htdpimage.html#(part._.Image_.Properties)","Image Properties",false],
["image teachpack",">teachpack/image.html#(idx._(gentag._0._(lib._teachpack/teachpack..scrbl)))","image teachpack",false],
["image teachpack",">teachpack/2htdpimage.html#(idx._(gentag._21._(lib._teachpack/teachpack..scrbl)._2htdp))","image teachpack",false],
["image%",">gui/WXME_Decoding.html#(def._((lib._wxme/image..rkt)._image~25))",[0,[2,"image%"]],["wxme/image"]],
["image->alpha-color-list",">teachpack/image.html#(def._((lib._htdp/image..rkt)._image-~3ealpha-color-list))",[0,[2,"image->alpha-color-list"]],["htdp/image"]],
["image->alpha-color-list",">deinprogramm/image.html#(def._((lib._deinprogramm/image..rkt)._image-~3ealpha-color-list))",[0,[2,"image->alpha-color-list"]],["teachpack/deinprogramm/image"]],
["image->color-list",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._image-~3ecolor-list))",[0,[2,"image->color-list"]],["2htdp/image"]],
["image->color-list",">teachpack/image.html#(def._((lib._htdp/image..rkt)._image-~3ecolor-list))",[0,[2,"image->color-list"]],["htdp/image"]],
["image->color-list",">deinprogramm/image.html#(def._((lib._deinprogramm/image..rkt)._image-~3ecolor-list))",[0,[2,"image->color-list"]],["teachpack/deinprogramm/image"]],
["image-baseline",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._image-baseline))",[0,[2,"image-baseline"]],["2htdp/image"]],
["image-color",">deinprogramm/image.html#(def._((lib._deinprogramm/image..rkt)._image-color))",[0,[2,"image-color"]],["teachpack/deinprogramm/image"]],
["image-color?",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._image-color~3f))",[0,[2,"image-color?"]],["2htdp/image"]],
["image-color?",">teachpack/image.html#(def._((lib._htdp/image..rkt)._image-color~3f))",[0,[2,"image-color?"]],["htdp/image"]],
["image-color?",">deinprogramm/image.html#(def._((lib._deinprogramm/image..rkt)._image-color~3f))",[0,[2,"image-color?"]],["teachpack/deinprogramm/image"]],
["image-element",">scribble/core.html#(def._((lib._scribble/core..rkt)._image-element))",[0,[2,"image-element"]],["scribble/core"]],
["image-element-path",">scribble/core.html#(def._((lib._scribble/core..rkt)._image-element-path))",[0,[2,"image-element-path"]],["scribble/core"]],
["image-element-scale",">scribble/core.html#(def._((lib._scribble/core..rkt)._image-element-scale))",[0,[2,"image-element-scale"]],["scribble/core"]],
["image-element-suffixes",">scribble/core.html#(def._((lib._scribble/core..rkt)._image-element-suffixes))",[0,[2,"image-element-suffixes"]],["scribble/core"]],
["image-element?",">scribble/core.html#(def._((lib._scribble/core..rkt)._image-element~3f))",[0,[2,"image-element?"]],["scribble/core"]],
["image-file",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._image-file))",[0,[2,"image-file"]],["scribble/struct"]],
["image-file-path",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._image-file-path))",[0,[2,"image-file-path"]],["scribble/struct"]],
["image-file-scale",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._image-file-scale))",[0,[2,"image-file-scale"]],["scribble/struct"]],
["image-file?",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._image-file~3f))",[0,[2,"image-file?"]],["scribble/struct"]],
["image-height",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._image-height))",[0,[2,"image-height"]],["2htdp/image"]],
["image-height",">teachpack/image.html#(def._((lib._htdp/image..rkt)._image-height))",[0,[2,"image-height"]],["htdp/image"]],
["image-height",">deinprogramm/image.html#(def._((lib._deinprogramm/image..rkt)._image-height))",[0,[2,"image-height"]],["teachpack/deinprogramm/image"]],
["image-inside?",">teachpack/image.html#(def._((lib._htdp/image..rkt)._image-inside~3f))",[0,[2,"image-inside?"]],["htdp/image"]],
["image-inside?",">deinprogramm/image.html#(def._((lib._deinprogramm/image..rkt)._image-inside~3f))",[0,[2,"image-inside?"]],["teachpack/deinprogramm/image"]],
["image-map-snip%",">browser/index.html#(def._((lib._browser/browser..rkt)._image-map-snip~25))",[0,[2,"image-map-snip%"]],["browser/browser","browser"]],
["image-or-control-ready-gif-stream?",">file/gif.html#(def._((lib._file/gif..rkt)._image-or-control-ready-gif-stream~3f))",[0,[2,"image-or-control-ready-gif-stream?"]],["file/gif"]],
["image-ready-gif-stream?",">file/gif.html#(def._((lib._file/gif..rkt)._image-ready-gif-stream~3f))",[0,[2,"image-ready-gif-stream?"]],["file/gif"]],
["image-snip%",">gui/image-snip_.html",[0,[2,"image-snip%"]],["racket/snip","racket/gui/base","racket/gui"]],
["image-teachpack",">deinprogramm/image.html#(idx._(gentag._2._(lib._deinprogramm/scribblings/deinprogramm..scrbl)))","image-Teachpack",false],
["image-width",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._image-width))",[0,[2,"image-width"]],["2htdp/image"]],
["image-width",">teachpack/image.html#(def._((lib._htdp/image..rkt)._image-width))",[0,[2,"image-width"]],["htdp/image"]],
["image-width",">deinprogramm/image.html#(def._((lib._deinprogramm/image..rkt)._image-width))",[0,[2,"image-width"]],["teachpack/deinprogramm/image"]],
["image/plain",">scribble/manual-images.html#(def._((lib._scribble/manual..rkt)._image/plain))",[0,[2,"image/plain"]],["scribble/manual"]],
["image=?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._image~3d~3f))",[0,[2,"image=?"]],["lang/htdp-advanced"]],
["image=?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._image~3d~3f))",[0,[2,"image=?"]],["lang/htdp-beginner"]],
["image=?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._image~3d~3f))",[0,[2,"image=?"]],["lang/htdp-beginner-abbr"]],
["image=?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._image~3d~3f))",[0,[2,"image=?"]],["lang/htdp-intermediate"]],
["image=?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._image~3d~3f))",[0,[2,"image=?"]],["lang/htdp-intermediate-lambda"]],
["image=?",">htdp/index.html#(def._((lib._lang/imageeq..rkt)._image~3d~3f))",[0,[2,"image=?"]],["lang/imageeq"]],
["image=?",">teachpack/image.html#(def._((lib._htdp/image..rkt)._image~3d~3f))",[0,[2,"image=?"]],["htdp/image"]],
["image?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._image~3f))",[0,[2,"image?"]],["lang/htdp-advanced"]],
["image?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._image~3f))",[0,[2,"image?"]],["lang/htdp-beginner"]],
["image?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._image~3f))",[0,[2,"image?"]],["lang/htdp-beginner-abbr"]],
["image?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._image~3f))",[0,[2,"image?"]],["lang/htdp-intermediate"]],
["image?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._image~3f))",[0,[2,"image?"]],["lang/htdp-intermediate-lambda"]],
["image?",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._image~3f))",[0,[2,"image?"]],["2htdp/image"]],
["image?",">teachpack/image.html#(def._((lib._htdp/image..rkt)._image~3f))",[0,[2,"image?"]],["htdp/image"]],
["image?",">mrlib/Image_Core.html#(def._((lib._mrlib/image-core..rkt)._image~3f))",[0,[2,"image?"]],["mrlib/image-core"]],
["image?",">deinprogramm/image.html#(def._((lib._deinprogramm/image..rkt)._image~3f))",[0,[2,"image?"]],["teachpack/deinprogramm/image"]],
["images",">images/index.html","Images",false],
["images",">drracket/Graphical_Syntax.html#(part._images)","Images",false],
["images",">gui/WXME_Decoding.html#(part._.Images)","Images",false],
["images",">htdp-langs/advanced.html#(part._htdp-advanced._.Images)","Images",false],
["images",">htdp-langs/beginner.html#(part._htdp-beginner._.Images)","Images",false],
["images",">htdp-langs/beginner-abbr.html#(part._htdp-beginner-abbr._.Images)","Images",false],
["images",">htdp-langs/intermediate.html#(part._htdp-intermediate._.Images)","Images",false],
["images",">htdp-langs/intermediate-lam.html#(part._htdp-intermediate-lambda._.Images)","Images",false],
["images",">scribble/manual-images.html","Images",false],
["images",">teachpack/image.html#(part._.Images)","Images",false],
["images/compile-time",">images/Embedding_Bitmaps_in_Compiled_Files.html",[9,[0,"images/compile-time"]],"module"],
["images/flomap",">images/flomap_title.html",[9,[0,"images/flomap"]],"module"],
["images/icons/arrow",">images/Icons.html#(mod-path._images/icons/arrow)",[9,[0,"images/icons/arrow"]],"module"],
["images/icons/control",">images/Icons.html#(mod-path._images/icons/control)",[9,[0,"images/icons/control"]],"module"],
["images/icons/file",">images/Icons.html#(mod-path._images/icons/file)",[9,[0,"images/icons/file"]],"module"],
["images/icons/misc",">images/Icons.html#(mod-path._images/icons/misc)",[9,[0,"images/icons/misc"]],"module"],
["images/icons/stickman",">images/Icons.html#(mod-path._images/icons/stickman)",[9,[0,"images/icons/stickman"]],"module"],
["images/icons/style",">images/Icons.html#(mod-path._images/icons/style)",[9,[0,"images/icons/style"]],"module"],
["images/icons/symbol",">images/Icons.html#(mod-path._images/icons/symbol)",[9,[0,"images/icons/symbol"]],"module"],
["images/icons/tool",">images/Icons.html#(mod-path._images/icons/tool)",[9,[0,"images/icons/tool"]],"module"],
["images/logos",">images/Logos.html",[9,[0,"images/logos"]],"module"],
["images: \"image.ss\"",">teachpack/2htdpimage.html",["Images: ",[6,"\"image.ss\""],"<a name=\"(idx._(gentag._21._(lib._teachpack/teachpack..scrbl)._2htdp))\"></a>"],false],
["imap signature",">net/imap.html#(part._.I.M.A.P_.Signature)","IMAP Signature",false],
["imap unit",">net/imap.html#(part._.I.M.A.P_.Unit)","IMAP Unit",false],
["imap-append",">net/imap.html#(def._((lib._net/imap..rkt)._imap-append))",[0,[2,"imap-append"]],["net/imap"]],
["imap-connect",">net/imap.html#(def._((lib._net/imap..rkt)._imap-connect))",[0,[2,"imap-connect"]],["net/imap"]],
["imap-connect*",">net/imap.html#(def._((lib._net/imap..rkt)._imap-connect*))",[0,[2,"imap-connect*"]],["net/imap"]],
["imap-connection?",">net/imap.html#(def._((lib._net/imap..rkt)._imap-connection~3f))",[0,[2,"imap-connection?"]],["net/imap"]],
["imap-copy",">net/imap.html#(def._((lib._net/imap..rkt)._imap-copy))",[0,[2,"imap-copy"]],["net/imap"]],
["imap-create-mailbox",">net/imap.html#(def._((lib._net/imap..rkt)._imap-create-mailbox))",[0,[2,"imap-create-mailbox"]],["net/imap"]],
["imap-disconnect",">net/imap.html#(def._((lib._net/imap..rkt)._imap-disconnect))",[0,[2,"imap-disconnect"]],["net/imap"]],
["imap-examine",">net/imap.html#(def._((lib._net/imap..rkt)._imap-examine))",[0,[2,"imap-examine"]],["net/imap"]],
["imap-expunge",">net/imap.html#(def._((lib._net/imap..rkt)._imap-expunge))",[0,[2,"imap-expunge"]],["net/imap"]],
["imap-flag->symbol",">net/imap.html#(def._((lib._net/imap..rkt)._imap-flag-~3esymbol))",[0,[2,"imap-flag->symbol"]],["net/imap"]],
["imap-force-disconnect",">net/imap.html#(def._((lib._net/imap..rkt)._imap-force-disconnect))",[0,[2,"imap-force-disconnect"]],["net/imap"]],
["imap-get-expunges",">net/imap.html#(def._((lib._net/imap..rkt)._imap-get-expunges))",[0,[2,"imap-get-expunges"]],["net/imap"]],
["imap-get-hierarchy-delimiter",">net/imap.html#(def._((lib._net/imap..rkt)._imap-get-hierarchy-delimiter))",[0,[2,"imap-get-hierarchy-delimiter"]],["net/imap"]],
["imap-get-messages",">net/imap.html#(def._((lib._net/imap..rkt)._imap-get-messages))",[0,[2,"imap-get-messages"]],["net/imap"]],
["imap-get-updates",">net/imap.html#(def._((lib._net/imap..rkt)._imap-get-updates))",[0,[2,"imap-get-updates"]],["net/imap"]],
["imap-list-child-mailboxes",">net/imap.html#(def._((lib._net/imap..rkt)._imap-list-child-mailboxes))",[0,[2,"imap-list-child-mailboxes"]],["net/imap"]],
["imap-mailbox-exists?",">net/imap.html#(def._((lib._net/imap..rkt)._imap-mailbox-exists~3f))",[0,[2,"imap-mailbox-exists?"]],["net/imap"]],
["imap-mailbox-flags",">net/imap.html#(def._((lib._net/imap..rkt)._imap-mailbox-flags))",[0,[2,"imap-mailbox-flags"]],["net/imap"]],
["imap-messages",">net/imap.html#(def._((lib._net/imap..rkt)._imap-messages))",[0,[2,"imap-messages"]],["net/imap"]],
["imap-new?",">net/imap.html#(def._((lib._net/imap..rkt)._imap-new~3f))",[0,[2,"imap-new?"]],["net/imap"]],
["imap-noop",">net/imap.html#(def._((lib._net/imap..rkt)._imap-noop))",[0,[2,"imap-noop"]],["net/imap"]],
["imap-pending-expunges?",">net/imap.html#(def._((lib._net/imap..rkt)._imap-pending-expunges~3f))",[0,[2,"imap-pending-expunges?"]],["net/imap"]],
["imap-pending-updates?",">net/imap.html#(def._((lib._net/imap..rkt)._imap-pending-updates~3f))",[0,[2,"imap-pending-updates?"]],["net/imap"]],
["imap-poll",">net/imap.html#(def._((lib._net/imap..rkt)._imap-poll))",[0,[2,"imap-poll"]],["net/imap"]],
["imap-port-number",">net/imap.html#(def._((lib._net/imap..rkt)._imap-port-number))",[0,[2,"imap-port-number"]],["net/imap"]],
["imap-recent",">net/imap.html#(def._((lib._net/imap..rkt)._imap-recent))",[0,[2,"imap-recent"]],["net/imap"]],
["imap-reselect",">net/imap.html#(def._((lib._net/imap..rkt)._imap-reselect))",[0,[2,"imap-reselect"]],["net/imap"]],
["imap-reset-new!",">net/imap.html#(def._((lib._net/imap..rkt)._imap-reset-new!))",[0,[2,"imap-reset-new!"]],["net/imap"]],
["imap-status",">net/imap.html#(def._((lib._net/imap..rkt)._imap-status))",[0,[2,"imap-status"]],["net/imap"]],
["imap-store",">net/imap.html#(def._((lib._net/imap..rkt)._imap-store))",[0,[2,"imap-store"]],["net/imap"]],
["imap-uidnext",">net/imap.html#(def._((lib._net/imap..rkt)._imap-uidnext))",[0,[2,"imap-uidnext"]],["net/imap"]],
["imap-uidvalidity",">net/imap.html#(def._((lib._net/imap..rkt)._imap-uidvalidity))",[0,[2,"imap-uidvalidity"]],["net/imap"]],
["imap-unseen",">net/imap.html#(def._((lib._net/imap..rkt)._imap-unseen))",[0,[2,"imap-unseen"]],["net/imap"]],
["imap: reading mail",">net/imap.html","IMAP: Reading Mail",false],
["imap@",">net/imap.html#(def._((lib._net/imap-unit..rkt)._imap~40))",[0,[2,"imap@"]],["net/imap-unit"]],
["imap^",">net/imap.html#(form._((lib._net/imap-sig..rkt)._imap~5e))",[0,[1,"imap^"]],["net/imap-sig"]],
["img",">html/index.html#(def._((lib._html/main..rkt)._img))",[0,[2,"img"]],["html"]],
["img",">web-server/formlets.html#(def._((lib._web-server/formlets/input..rkt)._img))",[0,[2,"img"]],["web-server/formlets/input"]],
["img?",">html/index.html#(def._((lib._html/main..rkt)._img~3f))",[0,[2,"img?"]],["html"]],
["immutable",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_294",[0,[1,"immutable"]],["rnrs/records/syntactic-6"]],
["immutable cyclic data",">reference/pairs.html#(part._.Immutable_.Cyclic_.Data)","Immutable Cyclic Data",false],
["immutable-bound-id-table?",">syntax/syntax-helpers.html#(def._((lib._syntax/id-table..rkt)._immutable-bound-id-table~3f))",[0,[2,"immutable-bound-id-table?"]],["syntax/id-table"]],
["immutable-free-id-table?",">syntax/syntax-helpers.html#(def._((lib._syntax/id-table..rkt)._immutable-free-id-table~3f))",[0,[2,"immutable-free-id-table?"]],["syntax/id-table"]],
["immutable?",">reference/booleans.html#(def._((quote._~23~25kernel)._immutable~3f))",[0,[2,"immutable?"]],["racket/base","racket"]],
["imperative dispatch containers",">web-server/dispatch.html#(part._.Imperative_.Dispatch_.Containers)","Imperative Dispatch Containers",false],
["imperative queues",">data/Imperative_Queues.html","Imperative Queues",false],
["impersonate-box",">reference/chaperones.html#(def._((quote._~23~25kernel)._impersonate-box))",[0,[2,"impersonate-box"]],["racket/base","racket"]],
["impersonate-continuation-mark-key",">reference/chaperones.html#(def._((quote._~23~25kernel)._impersonate-continuation-mark-key))",[0,[2,"impersonate-continuation-mark-key"]],["racket/base","racket"]],
["impersonate-hash",">reference/chaperones.html#(def._((quote._~23~25kernel)._impersonate-hash))",[0,[2,"impersonate-hash"]],["racket/base","racket"]],
["impersonate-procedure",">reference/chaperones.html#(def._((lib._racket/private/base..rkt)._impersonate-procedure))",[0,[2,"impersonate-procedure"]],["racket/base","racket"]],
["impersonate-prompt-tag",">reference/chaperones.html#(def._((quote._~23~25kernel)._impersonate-prompt-tag))",[0,[2,"impersonate-prompt-tag"]],["racket/base","racket"]],
["impersonate-struct",">reference/chaperones.html#(def._((quote._~23~25kernel)._impersonate-struct))",[0,[2,"impersonate-struct"]],["racket/base","racket"]],
["impersonate-vector",">reference/chaperones.html#(def._((quote._~23~25kernel)._impersonate-vector))",[0,[2,"impersonate-vector"]],["racket/base","racket"]],
["impersonator",">reference/chaperones.html#(tech._impersonator)","<span style=\"font-style: italic\">impersonator</span>",false],
["impersonator constructors",">reference/chaperones.html#(part._.Impersonator_.Constructors)","Impersonator Constructors",false],
["impersonator properties",">reference/chaperones.html#(part._.Impersonator_.Properties)","Impersonator Properties",false],
["impersonator properties",">reference/chaperones.html#(tech._impersonator._property)","<span style=\"font-style: italic\">impersonator properties</span>",false],
["impersonator property accessor",">reference/chaperones.html#(tech._impersonator._property._accessor)","<span style=\"font-style: italic\">impersonator property accessor</span>",false],
["impersonator property descriptor",">reference/chaperones.html#(tech._impersonator._property._descriptor)","<span style=\"font-style: italic\">impersonator property descriptor</span>",false],
["impersonator property predicate",">reference/chaperones.html#(tech._impersonator._property._predicate)","<span style=\"font-style: italic\">impersonator property predicate</span>",false],
["impersonator-contract?",">reference/contract-utilities.html#(def._((lib._racket/contract/private/misc..rkt)._impersonator-contract~3f))",[0,[2,"impersonator-contract?"]],["racket/contract/base","racket/contract","racket"]],
["impersonator-of?",">reference/chaperones.html#(def._((quote._~23~25kernel)._impersonator-of~3f))",[0,[2,"impersonator-of?"]],["racket/base","racket"]],
["impersonator-prop:application-mark",">reference/chaperones.html#(def._((quote._~23~25kernel)._impersonator-prop~3aapplication-mark))",[0,[2,"impersonator-prop:application-mark"]],["racket/base","racket"]],
["impersonator-prop:contracted",">reference/Building_New_Contract_Combinators.html#(def._((lib._racket/contract/private/guts..rkt)._impersonator-prop~3acontracted))",[0,[2,"impersonator-prop:contracted"]],["racket/contract/combinator","racket/contract","racket"]],
["impersonator-property",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Impersonator-.Property))",[0,[1,"Impersonator-Property"]],["typed/racket/base","typed/racket"]],
["impersonator-property-accessor-procedure?",">reference/chaperones.html#(def._((quote._~23~25kernel)._impersonator-property-accessor-procedure~3f))",[0,[2,"impersonator-property-accessor-procedure?"]],["racket/base","racket"]],
["impersonator-property?",">reference/chaperones.html#(def._((quote._~23~25kernel)._impersonator-property~3f))",[0,[2,"impersonator-property?"]],["racket/base","racket"]],
["impersonator?",">reference/chaperones.html#(def._((quote._~23~25kernel)._impersonator~3f))",[0,[2,"impersonator?"]],["racket/base","racket"]],
["impersonators and chaperones",">reference/chaperones.html","Impersonators and Chaperones",false],
["implementation",">algol60/index.html#(part._.Implementation)","Implementation",false],
["implementation notes",">openssl/index.html#(part._.Implementation_.Notes)","Implementation Notes",false],
["implementation-restriction-violation?",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_470",[0,[2,"implementation-restriction-violation?"]],["rnrs/conditions-6"]],
["implementation-vicinity",">srfi-std/srfi-59.html#implementation-vicinity",[0,[2,"implementation-vicinity"]],["srfi/59"]],
["implementation?",">reference/objectutils.html#(def._((lib._racket/private/class-internal..rkt)._implementation~3f))",[0,[2,"implementation?"]],["racket/class","racket"]],
["implementation?/c",">reference/Object_and_Class_Contracts.html#(def._((lib._racket/class..rkt)._implementation~3f/c))",[0,[2,"implementation?/c"]],["racket/class","racket"]],
["implementing drracket plugins",">tools/implementing-tools.html","Implementing DrRacket Plugins",false],
["implementing htdp teachpacks, libraries, and customized teaching languages",">htdp/index.html","Implementing HtDP Teachpacks, Libraries, and Customized Teaching Languages",false],
["implementing new games",">games/new-games.html","Implementing New Games",false],
["implementing styles",">scribble/config.html#(part._extra-style)","Implementing Styles",false],
["implements",">reference/mzlib_class.html#(tech._implement)","<span style=\"font-style: italic\">implements</span>",false],
["implicit form bindings",">guide/module-languages.html#(part._implicit-forms)","Implicit Form Bindings",false],
["implies",">reference/booleans.html#(form._((lib._racket/bool..rkt)._implies))",[0,[1,"implies"]],["racket/bool","racket"]],
["implode",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._implode))",[0,[2,"implode"]],["lang/htdp-advanced"]],
["implode",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._implode))",[0,[2,"implode"]],["lang/htdp-beginner"]],
["implode",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._implode))",[0,[2,"implode"]],["lang/htdp-beginner-abbr"]],
["implode",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._implode))",[0,[2,"implode"]],["lang/htdp-intermediate"]],
["implode",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._implode))",[0,[2,"implode"]],["lang/htdp-intermediate-lambda"]],
["import",">reference/stxtrans.html#(def._((lib._racket/require-transform..rkt)._import))",[0,[2,"import"]],["racket/require-transform"]],
["import",">reference/creatingunits.html#(form._((lib._mzlib/unit..rkt)._import))",[0,[1,"import"]],["racket/unit","racket"]],
["import-class",">foreign/Objective-C_FFI.html#(form._((lib._ffi/unsafe/objc..rkt)._import-class))",[0,[1,"import-class"]],["ffi/unsafe/objc"]],
["import-local-id",">reference/stxtrans.html#(def._((lib._racket/require-transform..rkt)._import-local-id))",[0,[2,"import-local-id"]],["racket/require-transform"]],
["import-mode",">reference/stxtrans.html#(def._((lib._racket/require-transform..rkt)._import-mode))",[0,[2,"import-mode"]],["racket/require-transform"]],
["import-orig-mode",">reference/stxtrans.html#(def._((lib._racket/require-transform..rkt)._import-orig-mode))",[0,[2,"import-orig-mode"]],["racket/require-transform"]],
["import-orig-stx",">reference/stxtrans.html#(def._((lib._racket/require-transform..rkt)._import-orig-stx))",[0,[2,"import-orig-stx"]],["racket/require-transform"]],
["import-primitives",">plai/mutator.html#(form._((lib._plai/mutator..rkt)._import-primitives))",[0,[1,"import-primitives"]],["plai/mutator"]],
["import-protocol",">foreign/Objective-C_FFI.html#(form._((lib._ffi/unsafe/objc..rkt)._import-protocol))",[0,[1,"import-protocol"]],["ffi/unsafe/objc"]],
["import-req-mode",">reference/stxtrans.html#(def._((lib._racket/require-transform..rkt)._import-req-mode))",[0,[2,"import-req-mode"]],["racket/require-transform"]],
["import-source",">reference/stxtrans.html#(def._((lib._racket/require-transform..rkt)._import-source))",[0,[2,"import-source"]],["racket/require-transform"]],
["import-source-mod-path-stx",">reference/stxtrans.html#(def._((lib._racket/require-transform..rkt)._import-source-mod-path-stx))",[0,[2,"import-source-mod-path-stx"]],["racket/require-transform"]],
["import-source-mode",">reference/stxtrans.html#(def._((lib._racket/require-transform..rkt)._import-source-mode))",[0,[2,"import-source-mode"]],["racket/require-transform"]],
["import-source?",">reference/stxtrans.html#(def._((lib._racket/require-transform..rkt)._import-source~3f))",[0,[2,"import-source?"]],["racket/require-transform"]],
["import-src-mod-path",">reference/stxtrans.html#(def._((lib._racket/require-transform..rkt)._import-src-mod-path))",[0,[2,"import-src-mod-path"]],["racket/require-transform"]],
["import-src-sym",">reference/stxtrans.html#(def._((lib._racket/require-transform..rkt)._import-src-sym))",[0,[2,"import-src-sym"]],["racket/require-transform"]],
["import?",">reference/stxtrans.html#(def._((lib._racket/require-transform..rkt)._import~3f))",[0,[2,"import?"]],["racket/require-transform"]],
["imported-nominal-path",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._imported-nominal-path))",[0,[2,"imported-nominal-path"]],["compiler/zo-structs"]],
["imported-nominal-path-import-phase",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._imported-nominal-path-import-phase))",[0,[2,"imported-nominal-path-import-phase"]],["compiler/zo-structs"]],
["imported-nominal-path-value",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._imported-nominal-path-value))",[0,[2,"imported-nominal-path-value"]],["compiler/zo-structs"]],
["imported-nominal-path?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._imported-nominal-path~3f))",[0,[2,"imported-nominal-path?"]],["compiler/zo-structs"]],
["importing and exporting: require and provide",">reference/require.html",["Importing and Exporting: ",[0,[1,"require"]]," and ",[0,[1,"provide"]]],false],
["imports: require",">guide/module-require.html",["Imports: ",[0,[1,"require"]]],false],
["impure port",">net/url.html#(tech._impure._port)","<span style=\"font-style: italic\">impure port</span>",false],
["in",">web-server/templates.html#(form._((lib._web-server/templates..rkt)._in))",[0,[1,"in"]],["web-server/templates"]],
["in-bib",">scriblib/autobib.html#(def._((lib._scriblib/autobib..rkt)._in-bib))",[0,[2,"in-bib"]],["scriblib/autobib"]],
["in-bytes",">reference/sequences.html#(def._((lib._racket/private/base..rkt)._in-bytes))",[0,[2,"in-bytes"]],["racket/base","racket"]],
["in-bytes-lines",">reference/sequences.html#(def._((lib._racket/private/base..rkt)._in-bytes-lines))",[0,[2,"in-bytes-lines"]],["racket/base","racket"]],
["in-cycle",">reference/sequences.html#(def._((lib._racket/private/base..rkt)._in-cycle))",[0,[2,"in-cycle"]],["racket/base","racket"]],
["in-dict",">reference/dicts.html#(def._((lib._racket/dict..rkt)._in-dict))",[0,[2,"in-dict"]],["racket/dict","racket"]],
["in-dict-keys",">reference/dicts.html#(def._((lib._racket/dict..rkt)._in-dict-keys))",[0,[2,"in-dict-keys"]],["racket/dict","racket"]],
["in-dict-pairs",">reference/dicts.html#(def._((lib._racket/dict..rkt)._in-dict-pairs))",[0,[2,"in-dict-pairs"]],["racket/dict","racket"]],
["in-dict-values",">reference/dicts.html#(def._((lib._racket/dict..rkt)._in-dict-values))",[0,[2,"in-dict-values"]],["racket/dict","racket"]],
["in-directory",">reference/sequences.html#(def._((lib._racket/private/base..rkt)._in-directory))",[0,[2,"in-directory"]],["racket/base","racket"]],
["in-domain?",">redex/The_Redex_Reference.html#(form._((lib._redex/reduction-semantics..rkt)._in-domain~3f))",[0,[1,"in-domain?"]],["redex/reduction-semantics","redex"]],
["in-edit-sequence?",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._in-edit-sequence~3f))",[[0,[2,"in-edit-sequence?"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["in-flvector",">reference/flonums.html#(def._((lib._racket/flonum..rkt)._in-flvector))",[0,[2,"in-flvector"]],["racket/flonum"]],
["in-fxvector",">reference/fixnums.html#(def._((lib._racket/fixnum..rkt)._in-fxvector))",[0,[2,"in-fxvector"]],["racket/fixnum"]],
["in-generator",">reference/Generators.html#(form._((lib._racket/generator..rkt)._in-generator))",[0,[1,"in-generator"]],["racket/generator"]],
["in-gvector",">data/gvector.html#(def._((lib._data/gvector..rkt)._in-gvector))",[0,[2,"in-gvector"]],["data/gvector"]],
["in-hash",">reference/sequences.html#(def._((lib._racket/private/base..rkt)._in-hash))",[0,[2,"in-hash"]],["racket/base","racket"]],
["in-hash-keys",">reference/sequences.html#(def._((lib._racket/private/base..rkt)._in-hash-keys))",[0,[2,"in-hash-keys"]],["racket/base","racket"]],
["in-hash-pairs",">reference/sequences.html#(def._((lib._racket/private/base..rkt)._in-hash-pairs))",[0,[2,"in-hash-pairs"]],["racket/base","racket"]],
["in-hash-values",">reference/sequences.html#(def._((lib._racket/private/base..rkt)._in-hash-values))",[0,[2,"in-hash-values"]],["racket/base","racket"]],
["in-hole",">redex/The_Redex_Reference.html#(form._((lib._redex/reduction-semantics..rkt)._in-hole))",[0,[1,"in-hole"]],["redex/reduction-semantics","redex"]],
["in-hole",">redex/The_Redex_Reference.html#(tech._in._hole)",[0,[1,"in-hole"]],false],
["in-indexed",">reference/sequences.html#(def._((lib._racket/private/base..rkt)._in-indexed))",[0,[2,"in-indexed"]],["racket/base","racket"]],
["in-input-port-bytes",">reference/sequences.html#(def._((lib._racket/private/base..rkt)._in-input-port-bytes))",[0,[2,"in-input-port-bytes"]],["racket/base","racket"]],
["in-input-port-chars",">reference/sequences.html#(def._((lib._racket/private/base..rkt)._in-input-port-chars))",[0,[2,"in-input-port-chars"]],["racket/base","racket"]],
["in-lines",">reference/sequences.html#(def._((lib._racket/private/base..rkt)._in-lines))",[0,[2,"in-lines"]],["racket/base","racket"]],
["in-list",">reference/sequences.html#(def._((lib._racket/private/base..rkt)._in-list))",[0,[2,"in-list"]],["racket/base","racket"]],
["in-mlist",">reference/sequences.html#(def._((lib._racket/private/base..rkt)._in-mlist))",[0,[2,"in-mlist"]],["racket/base","racket"]],
["in-naturals",">reference/sequences.html#(def._((lib._racket/private/base..rkt)._in-naturals))",[0,[2,"in-naturals"]],["racket/base","racket"]],
["in-pairs",">unstable/sequence.html#(def._((lib._unstable/sequence..rkt)._in-pairs))",[0,[2,"in-pairs"]],["unstable/sequence"]],
["in-parallel",">reference/sequences.html#(def._((lib._racket/private/base..rkt)._in-parallel))",[0,[2,"in-parallel"]],["racket/base","racket"]],
["in-phase1",">unstable/Definitions.html#(form._((lib._unstable/define..rkt)._in-phase1))",[0,[1,"in-phase1"]],["unstable/define"]],
["in-phase1/pass2",">unstable/Definitions.html#(form._((lib._unstable/define..rkt)._in-phase1/pass2))",[0,[1,"in-phase1/pass2"]],["unstable/define"]],
["in-port",">reference/sequences.html#(def._((lib._racket/private/base..rkt)._in-port))",[0,[2,"in-port"]],["racket/base","racket"]],
["in-producer",">reference/sequences.html#(def._((lib._racket/private/base..rkt)._in-producer))",[0,[2,"in-producer"]],["racket/base","racket"]],
["in-query",">db/query-api.html#(def._((lib._db/base..rkt)._in-query))",[0,[2,"in-query"]],["db","db/base"]],
["in-queue",">data/Imperative_Queues.html#(def._((lib._data/queue..rkt)._in-queue))",[0,[2,"in-queue"]],["data/queue"]],
["in-range",">reference/sequences.html#(def._((lib._racket/private/base..rkt)._in-range))",[0,[2,"in-range"]],["racket/base","racket"]],
["in-region?",">draw/region_.html#(meth._(((lib._racket/draw..rkt)._region~25)._in-region~3f))",[[0,[2,"in-region?"]],[14,[" (method of ",[0,[2,"region%"]],")"]]],["racket/draw"]],
["in-sequence-forever",">unstable/sequence.html#(def._((lib._unstable/sequence..rkt)._in-sequence-forever))",[0,[2,"in-sequence-forever"]],["unstable/sequence"]],
["in-sequences",">reference/sequences.html#(def._((lib._racket/private/base..rkt)._in-sequences))",[0,[2,"in-sequences"]],["racket/base","racket"]],
["in-set",">reference/sets.html#(def._((lib._racket/set..rkt)._in-set))",[0,[2,"in-set"]],["racket/set","racket"]],
["in-slice",">unstable/sequence.html#(def._((lib._unstable/sequence..rkt)._in-slice))",[0,[2,"in-slice"]],["unstable/sequence"]],
["in-source documentation",">scribble/srcdoc.html","In-Source Documentation",false],
["in-stream",">reference/streams.html#(def._((lib._racket/stream..rkt)._in-stream))",[0,[2,"in-stream"]],["racket/stream","racket"]],
["in-string",">reference/sequences.html#(def._((lib._racket/private/base..rkt)._in-string))",[0,[2,"in-string"]],["racket/base","racket"]],
["in-syntax",">unstable/sequence.html#(def._((lib._unstable/sequence..rkt)._in-syntax))",[0,[2,"in-syntax"]],["unstable/sequence"]],
["in-transaction?",">db/query-api.html#(def._((lib._db/base..rkt)._in-transaction~3f))",[0,[2,"in-transaction?"]],["db","db/base"]],
["in-value",">reference/sequences.html#(def._((lib._racket/private/base..rkt)._in-value))",[0,[2,"in-value"]],["racket/base","racket"]],
["in-values*-sequence",">reference/sequences.html#(def._((lib._racket/private/base..rkt)._in-values*-sequence))",[0,[2,"in-values*-sequence"]],["racket/base","racket"]],
["in-values-sequence",">reference/sequences.html#(def._((lib._racket/private/base..rkt)._in-values-sequence))",[0,[2,"in-values-sequence"]],["racket/base","racket"]],
["in-vector",">reference/sequences.html#(def._((lib._racket/private/base..rkt)._in-vector))",[0,[2,"in-vector"]],["racket/base","racket"]],
["in-vicinity",">srfi-std/srfi-59.html#in-vicinity",[0,[2,"in-vicinity"]],["srfi/59"]],
["include",">reference/include.html#(form._((lib._racket/include..rkt)._include))",[0,[1,"include"]],["racket/include","racket"]],
["include",">mzlib/mzlib_include.html#(form._((lib._mzlib/include..rkt)._include))",[0,[1,"include"]],["mzlib/include"]],
["include",">preprocessor/mzpp.html#(def._((lib._preprocessor/mzpp..rkt)._include))",[0,[2,"include"]],["preprocessor/mzpp"]],
["include",">preprocessor/mztext.html#(def._((lib._preprocessor/mztext..rkt)._include))",[0,[2,"include"]],["preprocessor/mztext"]],
["include bitmap",">mrlib/Include_Bitmap.html","Include Bitmap",false],
["include-abstract",">scribble/JFP_Paper_Format.html#(form._((lib._scribble/jfp..rkt)._include-abstract))",[0,[1,"include-abstract"]],["scribble/jfp"]],
["include-abstract",">scribble/LNCS_Paper_Format.html#(form._((lib._scribble/lncs/lang..rkt)._include-abstract))",[0,[1,"include-abstract"]],["scribble/lncs"]],
["include-abstract",">scribble/SIGPLAN_Paper_Format.html#(form._((lib._scribble/sigplan..rkt)._include-abstract))",[0,[1,"include-abstract"]],["scribble/sigplan"]],
["include-algol",">algol60/index.html#(form._((lib._algol60/algol60..rkt)._include-algol))",[0,[1,"include-algol"]],["algol60/algol60"]],
["include-at/relative-to",">reference/include.html#(form._((lib._racket/include..rkt)._include-at/relative-to))",[0,[1,"include-at/relative-to"]],["racket/include","racket"]],
["include-at/relative-to",">mzlib/mzlib_include.html#(form._((lib._mzlib/include..rkt)._include-at/relative-to))",[0,[1,"include-at/relative-to"]],["mzlib/include"]],
["include-at/relative-to/reader",">reference/include.html#(form._((lib._racket/include..rkt)._include-at/relative-to/reader))",[0,[1,"include-at/relative-to/reader"]],["racket/include","racket"]],
["include-at/relative-to/reader",">mzlib/mzlib_include.html#(form._((lib._mzlib/include..rkt)._include-at/relative-to/reader))",[0,[1,"include-at/relative-to/reader"]],["mzlib/include"]],
["include-bitmap",">mrlib/Include_Bitmap.html#(form._((lib._mrlib/include-bitmap..rkt)._include-bitmap))",[0,[1,"include-bitmap"]],["mrlib/include-bitmap"]],
["include-bitmap/relative-to",">mrlib/Include_Bitmap.html#(form._((lib._mrlib/include-bitmap..rkt)._include-bitmap/relative-to))",[0,[1,"include-bitmap/relative-to"]],["mrlib/include-bitmap"]],
["include-dir",">config/index.html#(def._((lib._config/main..rkt)._include-dir))",[0,[2,"include-dir"]],["config"]],
["include-extracted",">scribble/srcdoc.html#(form._((lib._scribble/extract..rkt)._include-extracted))",[0,[1,"include-extracted"]],["scribble/extract"]],
["include-previously-extracted",">scribble/srcdoc.html#(form._((lib._scribble/extract..rkt)._include-previously-extracted))",[0,[1,"include-previously-extracted"]],["scribble/extract"]],
["include-search-dirs",">config/index.html#(def._((lib._config/main..rkt)._include-search-dirs))",[0,[2,"include-search-dirs"]],["config"]],
["include-section",">scribble/base.html#(form._((lib._scribble/base..rkt)._include-section))",[0,[1,"include-section"]],["scribble/base"]],
["include-template",">web-server/templates.html#(form._((lib._web-server/templates..rkt)._include-template))",[0,[1,"include-template"]],["web-server/templates"]],
["include/reader",">reference/include.html#(form._((lib._racket/include..rkt)._include/reader))",[0,[1,"include/reader"]],["racket/include","racket"]],
["include/reader",">mzlib/mzlib_include.html#(form._((lib._mzlib/include..rkt)._include/reader))",[0,[1,"include/reader"]],["mzlib/include"]],
["including algol 60 programs",">algol60/index.html#(part._.Including_.Algol_60_.Programs)","Including Algol 60 Programs",false],
["incompatibility",">syntax/syntax-helpers.html#(tech._incompatibility)","<span style=\"font-style: italic\">incompatibility</span>",false],
["increment-timer!",">web-server-internal/timer.html#(def._((lib._web-server/private/timer..rkt)._increment-timer!))",[0,[2,"increment-timer!"]],["web-server/private/timer"]],
["indentation in preprocessed output",">scribble/text.html#(part._.Indentation_in_.Preprocessed_output)","Indentation in Preprocessed output",false],
["indenting racket code",">drracket/editor.html#(idx._(gentag._20._(lib._scribblings/drracket/drracket..scrbl)))","indenting Racket\ncode",false],
["index",">scribble/base.html#(def._((lib._scribble/base..rkt)._index))",[0,[2,"index"]],["scribble/base"]],
["index",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Index))",[0,[1,"Index"]],["typed/racket/base","typed/racket"]],
["index pairs",">guide/regexp-match.html#(tech._index._pair)","<span style=\"font-style: italic\">index pairs</span>",false],
["index*",">scribble/base.html#(def._((lib._scribble/base..rkt)._index*))",[0,[2,"index*"]],["scribble/base"]],
["index-element",">scribble/core.html#(def._((lib._scribble/core..rkt)._index-element))",[0,[2,"index-element"]],["scribble/core"]],
["index-element-desc",">scribble/core.html#(def._((lib._scribble/core..rkt)._index-element-desc))",[0,[2,"index-element-desc"]],["scribble/core"]],
["index-element-entry-seq",">scribble/core.html#(def._((lib._scribble/core..rkt)._index-element-entry-seq))",[0,[2,"index-element-entry-seq"]],["scribble/core"]],
["index-element-plain-seq",">scribble/core.html#(def._((lib._scribble/core..rkt)._index-element-plain-seq))",[0,[2,"index-element-plain-seq"]],["scribble/core"]],
["index-element-tag",">scribble/core.html#(def._((lib._scribble/core..rkt)._index-element-tag))",[0,[2,"index-element-tag"]],["scribble/core"]],
["index-element?",">scribble/core.html#(def._((lib._scribble/core..rkt)._index-element~3f))",[0,[2,"index-element?"]],["scribble/core"]],
["index-entry descriptions",">scribble/index-entries.html","Index-Entry Descriptions",false],
["index-section",">scribble/base.html#(def._((lib._scribble/base..rkt)._index-section))",[0,[2,"index-section"]],["scribble/base"]],
["index-to-style",">gui/style-list_.html#(meth._(((lib._racket/snip..rkt)._style-list~25)._index-to-style))",[[0,[2,"index-to-style"]],[14,[" (method of ",[0,[2,"style-list%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["index?",">ts-reference/Utilities.html#(def._((lib._typed-racket/base-env/prims..rkt)._index~3f))",[0,[2,"index?"]],["typed/racket/base","typed/racket"]],
["indexed-envvar",">scribble/manual-indexing.html#(def._((lib._scribble/manual..rkt)._indexed-envvar))",[0,[2,"indexed-envvar"]],["scribble/manual"]],
["indexed-file",">scribble/manual-indexing.html#(def._((lib._scribble/manual..rkt)._indexed-file))",[0,[2,"indexed-file"]],["scribble/manual"]],
["indexed-future-event",">reference/futures-trace.html#(def._((lib._future-visualizer/trace..rkt)._indexed-future-event))",[0,[2,"indexed-future-event"]],["future-visualizer/trace"]],
["indexed-future-event-event",">reference/futures-trace.html#(def._((lib._future-visualizer/trace..rkt)._indexed-future-event-event))",[0,[2,"indexed-future-event-event"]],["future-visualizer/trace"]],
["indexed-future-event-index",">reference/futures-trace.html#(def._((lib._future-visualizer/trace..rkt)._indexed-future-event-index))",[0,[2,"indexed-future-event-index"]],["future-visualizer/trace"]],
["indexed-future-event?",">reference/futures-trace.html#(def._((lib._future-visualizer/trace..rkt)._indexed-future-event~3f))",[0,[2,"indexed-future-event?"]],["future-visualizer/trace"]],
["indexed-racket",">scribble/manual-indexing.html#(form._((lib._scribble/manual..rkt)._indexed-racket))",[0,[1,"indexed-racket"]],["scribble/manual"]],
["indexed-scheme",">scribble/manual-indexing.html#(form._((lib._scribble/manual..rkt)._indexed-scheme))",[0,[1,"indexed-scheme"]],["scribble/manual"]],
["indexing",">scribble/reference-style.html#(part._.Indexing)","Indexing",false],
["indexing",">scribble/base.html#(part._base-indexing)","Indexing",false],
["indexing",">scribble/manual-indexing.html","Indexing",false],
["inexact",">r6rs-std/r6rs-Z-H-14.html#node_idx_460",[0,[2,"inexact"]],["rnrs/base-6"]],
["inexact number",">reference/numbers.html#(tech._inexact._number)","<span style=\"font-style: italic\">inexact number</span>",false],
["inexact->exact",">reference/number-types.html#(def._((quote._~23~25kernel)._inexact-~3eexact))",[0,[2,"inexact->exact"]],["racket/base","racket"]],
["inexact->exact",">r5rs-std/r5rs-Z-H-9.html#%_idx_362",[0,[2,"inexact->exact"]],["r5rs"]],
["inexact->exact",">r6rs-lib-std/r6rs-lib-Z-H-20.html#node_idx_1288",[0,[2,"inexact->exact"]],["rnrs/r5rs-6"]],
["inexact->exact",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._inexact-~3eexact))",[0,[2,"inexact->exact"]],["lang/htdp-advanced"]],
["inexact->exact",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._inexact-~3eexact))",[0,[2,"inexact->exact"]],["lang/htdp-beginner"]],
["inexact->exact",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._inexact-~3eexact))",[0,[2,"inexact->exact"]],["lang/htdp-beginner-abbr"]],
["inexact->exact",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._inexact-~3eexact))",[0,[2,"inexact->exact"]],["lang/htdp-intermediate"]],
["inexact->exact",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._inexact-~3eexact))",[0,[2,"inexact->exact"]],["lang/htdp-intermediate-lambda"]],
["inexact->exact",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._inexact-~3eexact))",[0,[2,"inexact->exact"]],["deinprogramm/DMdA-advanced"]],
["inexact->exact",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._inexact-~3eexact))",[0,[2,"inexact->exact"]],["deinprogramm/DMdA-assignments"]],
["inexact->exact",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._inexact-~3eexact))",[0,[2,"inexact->exact"]],["deinprogramm/DMdA-beginner"]],
["inexact->exact",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._inexact-~3eexact))",[0,[2,"inexact->exact"]],["deinprogramm/DMdA-vanilla"]],
["inexact-complex",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Inexact-.Complex))",[0,[1,"Inexact-Complex"]],["typed/racket/base","typed/racket"]],
["inexact-real",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Inexact-.Real))",[0,[1,"Inexact-Real"]],["typed/racket/base","typed/racket"]],
["inexact-real-nan",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Inexact-.Real-.Nan))",[0,[1,"Inexact-Real-Nan"]],["typed/racket/base","typed/racket"]],
["inexact-real-negative-zero",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Inexact-.Real-.Negative-.Zero))",[0,[1,"Inexact-Real-Negative-Zero"]],["typed/racket/base","typed/racket"]],
["inexact-real-positive-zero",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Inexact-.Real-.Positive-.Zero))",[0,[1,"Inexact-Real-Positive-Zero"]],["typed/racket/base","typed/racket"]],
["inexact-real-zero",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Inexact-.Real-.Zero))",[0,[1,"Inexact-Real-Zero"]],["typed/racket/base","typed/racket"]],
["inexact-real?",">reference/number-types.html#(def._((quote._~23~25kernel)._inexact-real~3f))",[0,[2,"inexact-real?"]],["racket/base","racket"]],
["inexact?",">reference/number-types.html#(def._((quote._~23~25kernel)._inexact~3f))",[0,[2,"inexact?"]],["racket/base","racket"]],
["inexact?",">r5rs-std/r5rs-Z-H-9.html#%_idx_256",[0,[2,"inexact?"]],["r5rs"]],
["inexact?",">r6rs-std/r6rs-Z-H-14.html#node_idx_458",[0,[2,"inexact?"]],["rnrs/base-6"]],
["inexact?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._inexact~3f))",[0,[2,"inexact?"]],["lang/htdp-advanced"]],
["inexact?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._inexact~3f))",[0,[2,"inexact?"]],["lang/htdp-beginner"]],
["inexact?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._inexact~3f))",[0,[2,"inexact?"]],["lang/htdp-beginner-abbr"]],
["inexact?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._inexact~3f))",[0,[2,"inexact?"]],["lang/htdp-intermediate"]],
["inexact?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._inexact~3f))",[0,[2,"inexact?"]],["lang/htdp-intermediate-lambda"]],
["inexact?",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._inexact~3f))",[0,[2,"inexact?"]],["deinprogramm/DMdA-advanced"]],
["inexact?",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._inexact~3f))",[0,[2,"inexact?"]],["deinprogramm/DMdA-assignments"]],
["inexact?",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._inexact~3f))",[0,[2,"inexact?"]],["deinprogramm/DMdA-beginner"]],
["inexact?",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._inexact~3f))",[0,[2,"inexact?"]],["deinprogramm/DMdA-vanilla"]],
["inferred linking",">reference/linkinference.html","Inferred Linking",false],
["inferred value names",">reference/syntax-model.html#(part._infernames)","Inferred Value Names",false],
["inferred-name",">reference/syntax-model.html#(idx._(gentag._1._(lib._scribblings/reference/reference..scrbl)))",[7,"'inferred-name"],false],
["infinite-generator",">reference/Generators.html#(form._((lib._racket/generator..rkt)._infinite-generator))",[0,[1,"infinite-generator"]],["racket/generator"]],
["infinite?",">reference/generic-numbers.html#(def._((lib._racket/math..rkt)._infinite~3f))",[0,[2,"infinite?"]],["racket/math","racket"]],
["infinite?",">r6rs-std/r6rs-Z-H-14.html#node_idx_486",[0,[2,"infinite?"]],["rnrs/base-6"]],
["infinity",">reference/numbers.html#(idx._(gentag._91._(lib._scribblings/reference/reference..scrbl)))","infinity",false],
["infix",">reference/reader.html#(idx._(gentag._29._(lib._scribblings/reference/reference..scrbl)))","infix",false],
["inflate",">file/gunzip.html#(def._((lib._file/gunzip..rkt)._inflate))",[0,[2,"inflate"]],["file/gunzip"]],
["info key",">scribble/core.html#(tech._info._key)","<span style=\"font-style: italic\">info key</span>",false],
["info-key?",">scribble/core.html#(def._((lib._scribble/core..rkt)._info-key~3f))",[0,[2,"info-key?"]],["scribble/core"]],
["information on expanded modules",">reference/Expanding_Top-Level_Forms.html#(part._modinfo)","Information on Expanded Modules",false],
["inherit",">reference/createclass.html#(form._((lib._racket/private/class-internal..rkt)._inherit))",[0,[1,"inherit"]],["racket/class","racket"]],
["inherit and super in traits",">guide/classes.html#(part._.Inherit_and_.Super_in_.Traits)","Inherit and Super in Traits",false],
["inherit-field",">reference/createclass.html#(form._((lib._racket/private/class-internal..rkt)._inherit-field))",[0,[1,"inherit-field"]],["racket/class","racket"]],
["inherit/inner",">reference/createclass.html#(form._((lib._racket/private/class-internal..rkt)._inherit/inner))",[0,[1,"inherit/inner"]],["racket/class","racket"]],
["inherit/super",">reference/createclass.html#(form._((lib._racket/private/class-internal..rkt)._inherit/super))",[0,[1,"inherit/super"]],["racket/class","racket"]],
["inheritance",">reference/mzlib_class.html#(tech._inheritance)","<span style=\"font-style: italic\">inheritance</span>",false],
["inherited and superclass methods",">reference/createclass.html#(part._classinherit)","Inherited and Superclass Methods",false],
["init",">reference/createclass.html#(form._((lib._racket/private/class-internal..rkt)._init))",[0,[1,"init"]],["racket/class","racket"]],
["init libraries",">reference/running-sa.html#(part._.Init_.Libraries)","Init Libraries",false],
["init-allocator",">plai/collector.html#(def._((lib._plai/scribblings/fake-collector..rkt)._init-allocator))",[0,[2,"init-allocator"]],[]],
["init-auto-scrollbars",">gui/canvas_.html#(meth._(((lib._mred/main..rkt)._canvas~25)._init-auto-scrollbars))",[[0,[2,"init-auto-scrollbars"]],[14,[" (method of ",[0,[2,"canvas%"]],")"]]],["racket/gui/base","racket/gui"]],
["init-depend",">reference/creatingunits.html#(form._((lib._mzlib/unit..rkt)._init-depend))",[0,[1,"init-depend"]],["racket/unit","racket"]],
["init-dir",">reference/Filesystem.html#(idx._(gentag._274._(lib._scribblings/reference/reference..scrbl)))",[7,"'init-dir"],false],
["init-field",">reference/createclass.html#(form._((lib._racket/private/class-internal..rkt)._init-field))",[0,[1,"init-field"]],["racket/class","racket"]],
["init-field/i",">unstable/class-iop.html#(form._((lib._unstable/class-iop..rkt)._init-field/i))",[0,[1,"init-field/i"]],["unstable/class-iop"]],
["init-file",">reference/Filesystem.html#(idx._(gentag._275._(lib._scribblings/reference/reference..scrbl)))",[7,"'init-file"],false],
["init-manual-scrollbars",">gui/canvas_.html#(meth._(((lib._mred/main..rkt)._canvas~25)._init-manual-scrollbars))",[[0,[2,"init-manual-scrollbars"]],[14,[" (method of ",[0,[2,"canvas%"]],")"]]],["racket/gui/base","racket/gui"]],
["init-private/i",">unstable/class-iop.html#(form._((lib._unstable/class-iop..rkt)._init-private/i))",[0,[1,"init-private/i"]],["unstable/class-iop"]],
["init-rest",">reference/createclass.html#(form._((lib._racket/private/class-internal..rkt)._init-rest))",[0,[1,"init-rest"]],["racket/class","racket"]],
["init-world",">graphics/World_Operations.html#(def._((lib._graphics/graphics..rkt)._init-world))",[0,[2,"init-world"]],["graphics/graphics"]],
["init/i",">unstable/class-iop.html#(form._((lib._unstable/class-iop..rkt)._init/i))",[0,[1,"init/i"]],["unstable/class-iop"]],
["initial-autowrap-bitmap",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3abasic~3c~25~3e)._initial-autowrap-bitmap))",[[0,[2,"initial-autowrap-bitmap"]],[14,[" (method of ",[0,[2,"text:basic<%>"]],")"]]],["framework"]],
["initial-char-width",">redex/The_Redex_Reference.html#(def._((lib._redex/gui..rkt)._initial-char-width))",[0,[2,"initial-char-width"]],["redex/gui","redex"]],
["initial-connection-timeout",">web-server-internal/dispatch-server-unit.html#(sig-val._((lib._web-server/private/dispatch-server-sig..rkt)._dispatch-server-config~5e._initial-connection-timeout))",[0,[2,"initial-connection-timeout"]],["web-server/private/dispatch-server-sig"]],
["initial-connection-timeout",">web-server-internal/Web_Servers.html#(sig-val._web-config._((lib._web-server/web-config-sig..rkt)._web-config~5e._initial-connection-timeout))",[0,[2,"initial-connection-timeout"]],["web-server/web-config-sig"]],
["initial-connection-timeout",">web-server-internal/Web_Servers.html#(idx._(gentag._3._(lib._web-server/scribblings/web-server-internal..scrbl)))","initial-connection-timeout",false],
["initial-font-size",">redex/The_Redex_Reference.html#(def._((lib._redex/gui..rkt)._initial-font-size))",[0,[2,"initial-font-size"]],["redex/gui","redex"]],
["initialization",">reference/running-sa.html#(part._init-actions)","Initialization",false],
["initialization",">sgl/init.html","Initialization",false],
["initialization arguments",">guide/classes.html#(part._initargs)","Initialization Arguments",false],
["initialization variables",">reference/createclass.html#(part._clinitvars)","Initialization Variables",false],
["initialize-console",">tools/drracket_rep.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3arep~3atext~25)._initialize-console))",[[0,[2,"initialize-console"]],[14,[" (method of ",[0,[2,"drracket:rep:text%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["initialize-profile-point",">errortrace/stacktrace.html#(sig-val._((lib._errortrace/stacktrace..rkt)._stacktrace-imports~5e._initialize-profile-point))",[0,[2,"initialize-profile-point"]],["errortrace/stacktrace"]],
["initialize-test-coverage-point",">errortrace/stacktrace.html#(sig-val._((lib._errortrace/stacktrace..rkt)._stacktrace-imports~5e._initialize-test-coverage-point))",[0,[2,"initialize-test-coverage-point"]],["errortrace/stacktrace"]],
["initiate",">reference/sequences.html#(tech._initiate)","<span style=\"font-style: italic\">initiate</span>",false],
["inline-build-flomap",">images/Conversion_and_Construction.html#(form._((lib._images/flomap..rkt)._inline-build-flomap))",[0,[1,"inline-build-flomap"]],["images/flomap"]],
["inline-build-flomap*",">images/Conversion_and_Construction.html#(form._((lib._images/flomap..rkt)._inline-build-flomap*))",[0,[1,"inline-build-flomap*"]],["images/flomap"]],
["inline-flomap-lift",">images/Pointwise_Operations.html#(form._((lib._images/flomap..rkt)._inline-flomap-lift))",[0,[1,"inline-flomap-lift"]],["images/flomap"]],
["inline-flomap-lift2",">images/Pointwise_Operations.html#(form._((lib._images/flomap..rkt)._inline-flomap-lift2))",[0,[1,"inline-flomap-lift2"]],["images/flomap"]],
["inline-variant",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._inline-variant))",[0,[2,"inline-variant"]],["compiler/zo-structs"]],
["inline-variant-direct",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._inline-variant-direct))",[0,[2,"inline-variant-direct"]],["compiler/zo-structs"]],
["inline-variant-inline",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._inline-variant-inline))",[0,[2,"inline-variant-inline"]],["compiler/zo-structs"]],
["inline-variant?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._inline-variant~3f))",[0,[2,"inline-variant?"]],["compiler/zo-structs"]],
["inner",">reference/createclass.html#(form._((lib._racket/private/class-internal..rkt)._inner))",[0,[1,"inner"]],["racket/class","racket"]],
["inode",">reference/file-ports.html#(idx._(gentag._211._(lib._scribblings/reference/reference..scrbl)))","inode",false],
["inode",">reference/Filesystem.html#(idx._(gentag._293._(lib._scribblings/reference/reference..scrbl)))","inode",false],
["input",">html/index.html#(def._((lib._html/main..rkt)._input))",[0,[2,"input"]],["html"]],
["input and output",">picturing-programs/index.html#(part._.Input_and_.Output)","Input and Output",false],
["input and output",">drracket/interactions-window.html#(part._.Input_and_.Output)","Input and Output",false],
["input and output",">guide/i_o.html","Input and Output",false],
["input and output",">reference/input-and-output.html","Input and Output",false],
["input ports pattern matching",">reference/regexp.html","input ports, pattern matching",false],
["input-background-color",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._input-background-color))",[0,[2,"input-background-color"]],["scribble/racket","scribble/scheme"]],
["input-color",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._input-color))",[0,[2,"input-color"]],["scribble/racket","scribble/scheme"]],
["input-int",">web-server/formlets.html#(def._((lib._web-server/formlets/input..rkt)._input-int))",[0,[2,"input-int"]],["web-server/formlets/input"]],
["input-port",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex..rkt)._input-port))",[0,[1,"input-port"]],["parser-tools/lex"]],
["input-port",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Input-.Port))",[0,[1,"Input-Port"]],["typed/racket/base","typed/racket"]],
["input-port-append",">reference/port-lib.html#(def._((lib._racket/port..rkt)._input-port-append))",[0,[2,"input-port-append"]],["racket/port","racket"]],
["input-port?",">reference/port-ops.html#(def._((quote._~23~25kernel)._input-port~3f))",[0,[2,"input-port?"]],["racket/base","racket"]],
["input-port?",">r5rs-std/r5rs-Z-H-9.html#%_idx_614",[0,[2,"input-port?"]],["r5rs"]],
["input-port?",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_664",[0,[2,"input-port?"]],["rnrs/io/ports-6"]],
["input-string",">web-server/formlets.html#(def._((lib._web-server/formlets/input..rkt)._input-string))",[0,[2,"input-string"]],["web-server/formlets/input"]],
["input-symbol",">web-server/formlets.html#(def._((lib._web-server/formlets/input..rkt)._input-symbol))",[0,[2,"input-symbol"]],["web-server/formlets/input"]],
["input?",">html/index.html#(def._((lib._html/main..rkt)._input~3f))",[0,[2,"input?"]],["html"]],
["ins",">html/index.html#(def._((lib._html/main..rkt)._ins))",[0,[2,"ins"]],["html"]],
["ins?",">html/index.html#(def._((lib._html/main..rkt)._ins~3f))",[0,[2,"ins?"]],["html"]],
["insert",">drracket/Menus.html#(part._.Insert)","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Insert</span>",false],
["insert",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._insert))",[[0,[2,"insert"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["insert",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._insert))",[[0,[2,"insert"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["insert",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._insert))",[[0,[2,"insert"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["insert",">gui/string-snip_.html#(meth._(((lib._racket/snip..rkt)._string-snip~25)._insert))",[[0,[2,"insert"]],[14,[" (method of ",[0,[2,"string-snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["insert",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3a1-pixel-string-snip~25)._insert))",[[0,[2,"insert"]],[14,[" (method of ",[0,[2,"text:1-pixel-string-snip%"]],")"]]],["framework"]],
["insert",">gui/key-event_.html#(idx._(gentag._61._(lib._scribblings/gui/gui..scrbl)))",[7,"'insert"],false],
["insert comment box menu item",">drracket/Menus.html#(idx._(gentag._137._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Insert Comment Box</span> menu item",false],
["insert fraction... menu item",">drracket/Menus.html#(idx._(gentag._139._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Insert Fraction...</span> menu item",false],
["insert image... menu item",">drracket/Menus.html#(idx._(gentag._138._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Insert Image...</span> menu item",false],
["insert large letters... menu item",">drracket/Menus.html#(idx._(gentag._140._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Insert Large Letters...</span> menu item",false],
["insert racket box menu item",">drracket/Menus.html#(idx._(gentag._143._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Insert Racket Box</span> menu item",false],
["insert racket splice box menu item",">drracket/Menus.html#(idx._(gentag._144._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Insert Racket Splice Box</span> menu item",false],
["insert xml box menu item",">drracket/Menus.html#(idx._(gentag._142._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Insert XML Box</span> menu item",false],
["insert \u03bb menu item",">drracket/Menus.html#(idx._(gentag._141._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Insert &#955;</span> menu item",false],
["insert-before",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3aports~3c~25~3e)._insert-before))",[[0,[2,"insert-before"]],[14,[" (method of ",[0,[2,"text:ports<%>"]],")"]]],["framework"]],
["insert-between",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3aports~3c~25~3e)._insert-between))",[[0,[2,"insert-between"]],[14,[" (method of ",[0,[2,"text:ports<%>"]],")"]]],["framework"]],
["insert-box",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._insert-box))",[[0,[2,"insert-box"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["insert-close-paren",">framework/Color.html#(meth._(((lib._framework/main..rkt)._color~3atext~3c~25~3e)._insert-close-paren))",[[0,[2,"insert-close-paren"]],[14,[" (method of ",[0,[2,"color:text<%>"]],")"]]],["framework"]],
["insert-field",">net/head.html#(def._((lib._net/head..rkt)._insert-field))",[0,[2,"insert-field"]],["net/head"]],
["insert-file",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._insert-file))",[[0,[2,"insert-file"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["insert-first!",">syntax-color/index.html#(def._((lib._syntax-color/token-tree..rkt)._insert-first!))",[0,[2,"insert-first!"]],["syntax-color/token-tree"]],
["insert-frame",">framework/Group.html#(meth._(((lib._framework/main..rkt)._group~3a~25)._insert-frame))",[[0,[2,"insert-frame"]],[14,[" (method of ",[0,[2,"group:%"]],")"]]],["framework"]],
["insert-image",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._insert-image))",[[0,[2,"insert-image"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["insert-last!",">syntax-color/index.html#(def._((lib._syntax-color/token-tree..rkt)._insert-last!))",[0,[2,"insert-last!"]],["syntax-color/token-tree"]],
["insert-last-spec!",">syntax-color/index.html#(def._((lib._syntax-color/token-tree..rkt)._insert-last-spec!))",[0,[2,"insert-last-spec!"]],["syntax-color/token-tree"]],
["insert-param",">web-server-internal/url-param.html#(def._((lib._web-server/private/url-param..rkt)._insert-param))",[0,[2,"insert-param"]],["web-server/private/url-param"]],
["insert-port",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._insert-port))",[[0,[2,"insert-port"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["insert-prompt",">tools/drracket_rep.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3arep~3atext~25)._insert-prompt))",[[0,[2,"insert-prompt"]],[14,[" (method of ",[0,[2,"drracket:rep:text%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["insert-return",">framework/Racket.html#(meth._(((lib._framework/main..rkt)._racket~3atext~3c~25~3e)._insert-return))",[[0,[2,"insert-return"]],[14,[" (method of ",[0,[2,"racket:text<%>"]],")"]]],["framework"]],
["inset",">slideshow/Bounding_Box_Adjusters.html#(def._((lib._slideshow/pict..rkt)._inset))",[0,[2,"inset"]],["slideshow/pict","slideshow"]],
["inset/clip",">slideshow/Pict_Drawing_Adjusters.html#(def._((lib._slideshow/pict..rkt)._inset/clip))",[0,[2,"inset/clip"]],["slideshow/pict","slideshow"]],
["inside: racket c api",">inside/index.html","Inside: Racket C API",false],
["inspect",">reference/createclass.html#(form._((lib._racket/private/class-internal..rkt)._inspect))",[0,[1,"inspect"]],["racket/class","racket"]],
["inspecting modules and module dependencies",">syntax/module-helpers.html#(part._moddep)","Inspecting Modules and Module Dependencies",false],
["inspecting requests",">continue/index.html#(part._.Inspecting_.Requests)","Inspecting Requests",false],
["inspector",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Inspector))",[0,[1,"Inspector"]],["typed/racket/base","typed/racket"]],
["inspector",">reference/inspectors.html#(tech._inspector)","<span style=\"font-style: italic\">inspector</span>",false],
["inspector?",">reference/inspectors.html#(def._((quote._~23~25kernel)._inspector~3f))",[0,[2,"inspector?"]],["racket/base","racket"]],
["inst",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._inst))",[0,[1,"inst"]],["typed/racket/base","typed/racket"]],
["install",">planet/cmdline.html#(part._install)",[6,"install"],false],
["install plt file... menu item",">drracket/Menus.html#(idx._(gentag._57._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Install PLT File...</span> menu item",false],
["install-converting-printer",">mzlib/mzlib_pconvert.html#(def._((lib._mzlib/pconvert..rkt)._install-converting-printer))",[0,[2,"install-converting-printer"]],["mzlib/pconvert"]],
["install-eopl-exception-handler",">eopl/index.html#(def._((lib._eopl/eopl..rkt)._install-eopl-exception-handler))",[0,[2,"install-eopl-exception-handler"]],["eopl"]],
["install-gracket-program-launcher",">raco/exe.html#(def._((lib._launcher/launcher..rkt)._install-gracket-program-launcher))",[0,[2,"install-gracket-program-launcher"]],["launcher/launcher"]],
["install-help-browser-preference-panel",">browser/index.html#(def._((lib._browser/external..rkt)._install-help-browser-preference-panel))",[0,[2,"install-help-browser-preference-panel"]],["browser/external"]],
["install-mred-program-launcher",">raco/exe.html#(def._((lib._launcher/launcher..rkt)._install-mred-program-launcher))",[0,[2,"install-mred-program-launcher"]],["launcher/launcher"]],
["install-mzscheme-program-launcher",">raco/exe.html#(def._((lib._launcher/launcher..rkt)._install-mzscheme-program-launcher))",[0,[2,"install-mzscheme-program-launcher"]],["launcher/launcher"]],
["install-pkg",">planet/Utility_Libraries.html#(def._((lib._planet/util..rkt)._install-pkg))",[0,[2,"install-pkg"]],["planet/util"]],
["install-planet-package",">raco/_plt-archives.html#(def._((lib._setup/plt-single-installer..rkt)._install-planet-package))",[0,[2,"install-planet-package"]],["setup/plt-single-installer"]],
["install-racket-program-launcher",">raco/exe.html#(def._((lib._launcher/launcher..rkt)._install-racket-program-launcher))",[0,[2,"install-racket-program-launcher"]],["launcher/launcher"]],
["install-readline!",">readline/index.html#(def._((lib._readline/main..rkt)._install-readline!))",[0,[2,"install-readline!"]],["readline","readline/rep-start"]],
["install-value",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._install-value))",[0,[2,"install-value"]],["compiler/zo-structs"]],
["install-value-body",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._install-value-body))",[0,[2,"install-value-body"]],["compiler/zo-structs"]],
["install-value-boxes?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._install-value-boxes~3f))",[0,[2,"install-value-boxes?"]],["compiler/zo-structs"]],
["install-value-count",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._install-value-count))",[0,[2,"install-value-count"]],["compiler/zo-structs"]],
["install-value-pos",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._install-value-pos))",[0,[2,"install-value-pos"]],["compiler/zo-structs"]],
["install-value-rhs",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._install-value-rhs))",[0,[2,"install-value-rhs"]],["compiler/zo-structs"]],
["install-value?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._install-value~3f))",[0,[2,"install-value?"]],["compiler/zo-structs"]],
["install?",">planet/Utility_Libraries.html#(def._((lib._planet/resolver..rkt)._install~3f))",[0,[2,"install?"]],["planet/resolver"]],
["installation",">picturing-programs/index.html#(part._.Installation)","Installation",false],
["installation-specific launchers",">raco/exe.html#(part._launcher)","Installation-Specific Launchers",false],
["installed patch level",">version/index.html#(part._.Installed_.Patch_.Level)","Installed Patch Level",false],
["installing a language",">guide/language-collection.html","Installing a Language",false],
["installing calltrace",">trace/index.html#(part._.Installing_.Calltrace)","Installing Calltrace",false],
["installing errortrace",">errortrace/installing-errortrace.html","Installing Errortrace",false],
["installing libraries",">r6rs/Installing_Libraries.html","Installing Libraries",false],
["installing xrepl",">xrepl/index.html#(part._.Installing_.X.R.E.P.L)","Installing XREPL",false],
["instance",">ts-reference/Experimental_Features.html#(form._((lib._typed-racket/base-env/base-types-extra..rkt)._.Instance))",[0,[1,"Instance"]],["typed/racket/base","typed/racket"]],
["instanceof/c",">reference/Object_and_Class_Contracts.html#(def._((lib._racket/private/class-internal..rkt)._instanceof/c))",[0,[2,"instanceof/c"]],["racket/class","racket"]],
["instant servlets",">web-server/run.html#(part._insta)","Instant Servlets",false],
["instantiate",">reference/objcreation.html#(form._((lib._racket/private/class-internal..rkt)._instantiate))",[0,[1,"instantiate"]],["racket/class","racket"]],
["instantiates",">guide/module-require.html#(tech._instantiate)","<span style=\"font-style: italic\">instantiates</span>",false],
["instantiates",">reference/eval-model.html#(tech._instantiate)","<span style=\"font-style: italic\">instantiates</span>",false],
["instantiation",">reference/eval-model.html#(tech._instantiation)","<span style=\"font-style: italic\">instantiation</span>",false],
["institute",">scribble/LNCS_Paper_Format.html#(form._((lib._scribble/lncs/lang..rkt)._institute))",[0,[1,"institute"]],["scribble/lncs"]],
["institutes",">scribble/LNCS_Paper_Format.html#(form._((lib._scribble/lncs/lang..rkt)._institutes))",[0,[1,"institutes"]],["scribble/lncs"]],
["instrumentation and profiling",">errortrace/using-errortrace.html#(part._instrumentation-and-profiling)","Instrumentation and Profiling",false],
["instrumenting-enabled",">errortrace/using-errortrace.html#(def._((lib._errortrace/errortrace-lib..rkt)._instrumenting-enabled))",[0,[2,"instrumenting-enabled"]],["errortrace"]],
["instrumenting-enabled",">trace/index.html#(def._((lib._trace/calltrace-lib..rkt)._instrumenting-enabled))",[0,[2,"instrumenting-enabled"]],["trace/calltrace-lib"]],
["int->string",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._int-~3estring))",[0,[2,"int->string"]],["lang/htdp-advanced"]],
["int->string",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._int-~3estring))",[0,[2,"int->string"]],["lang/htdp-beginner"]],
["int->string",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._int-~3estring))",[0,[2,"int->string"]],["lang/htdp-beginner-abbr"]],
["int->string",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._int-~3estring))",[0,[2,"int->string"]],["lang/htdp-intermediate"]],
["int->string",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._int-~3estring))",[0,[2,"int->string"]],["lang/htdp-intermediate-lambda"]],
["integer",">deinprogramm/Signaturen.html#(form._((lib._deinprogramm/.D.Md.A..rkt)._integer))",[0,[1,"integer"]],["deinprogramm/DMdA-beginner"]],
["integer",">syntax/Library_Syntax_Classes_and_Literal_Sets.html#(form._((lib._syntax/parse..rkt)._integer))",[0,[1,"integer"]],["syntax/parse"]],
["integer",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Integer))",[0,[1,"Integer"]],["typed/racket/base","typed/racket"]],
["integer",">redex/The_Redex_Reference.html#(tech._integer)",[0,"integer"],false],
["integer",">guide/numbers.html#(tech._integer)","<span style=\"font-style: italic\">integer</span>",false],
["integer->char",">reference/characters.html#(def._((quote._~23~25kernel)._integer-~3echar))",[0,[2,"integer->char"]],["racket/base","racket"]],
["integer->char",">r5rs-std/r5rs-Z-H-9.html#%_idx_500",[0,[2,"integer->char"]],["r5rs"]],
["integer->char",">r6rs-std/r6rs-Z-H-14.html#node_idx_672",[0,[2,"integer->char"]],["rnrs/base-6"]],
["integer->char",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._integer-~3echar))",[0,[2,"integer->char"]],["lang/htdp-advanced"]],
["integer->char",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._integer-~3echar))",[0,[2,"integer->char"]],["lang/htdp-beginner"]],
["integer->char",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._integer-~3echar))",[0,[2,"integer->char"]],["lang/htdp-beginner-abbr"]],
["integer->char",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._integer-~3echar))",[0,[2,"integer->char"]],["lang/htdp-intermediate"]],
["integer->char",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._integer-~3echar))",[0,[2,"integer->char"]],["lang/htdp-intermediate-lambda"]],
["integer->integer-bytes",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._integer-~3einteger-bytes))",[0,[2,"integer->integer-bytes"]],["racket/base","racket"]],
["integer->superscript",">plot/utils.html#(def._((lib._plot/utils..rkt)._integer-~3esuperscript))",[0,[2,"integer->superscript"]],["plot/utils"]],
["integer-arg",">web-server/dispatch.html#(form._((lib._web-server/dispatch..rkt)._integer-arg))",[0,[1,"integer-arg"]],["web-server/dispatch"]],
["integer-bytes->integer",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._integer-bytes-~3einteger))",[0,[2,"integer-bytes->integer"]],["racket/base","racket"]],
["integer-in",">reference/data-structure-contracts.html#(def._((lib._racket/contract/private/misc..rkt)._integer-in))",[0,[2,"integer-in"]],["racket/contract/base","racket/contract","racket"]],
["integer-length",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._integer-length))",[0,[2,"integer-length"]],["racket/base","racket"]],
["integer-set-contents",">mzlib/mzlib_integer-set.html#(def._((lib._mzlib/integer-set..rkt)._integer-set-contents))",[0,[2,"integer-set-contents"]],["mzlib/integer-set"]],
["integer-set?",">mzlib/mzlib_integer-set.html#(def._((lib._mzlib/integer-set..rkt)._integer-set~3f))",[0,[2,"integer-set?"]],["mzlib/integer-set"]],
["integer-sqrt",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._integer-sqrt))",[0,[2,"integer-sqrt"]],["racket/base","racket"]],
["integer-sqrt",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._integer-sqrt))",[0,[2,"integer-sqrt"]],["lang/htdp-advanced"]],
["integer-sqrt",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._integer-sqrt))",[0,[2,"integer-sqrt"]],["lang/htdp-beginner"]],
["integer-sqrt",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._integer-sqrt))",[0,[2,"integer-sqrt"]],["lang/htdp-beginner-abbr"]],
["integer-sqrt",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._integer-sqrt))",[0,[2,"integer-sqrt"]],["lang/htdp-intermediate"]],
["integer-sqrt",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._integer-sqrt))",[0,[2,"integer-sqrt"]],["lang/htdp-intermediate-lambda"]],
["integer-sqrt/remainder",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._integer-sqrt/remainder))",[0,[2,"integer-sqrt/remainder"]],["racket/base","racket"]],
["integer-valued?",">r6rs-std/r6rs-Z-H-14.html#node_idx_454",[0,[2,"integer-valued?"]],["rnrs/base-6"]],
["integer?",">reference/number-types.html#(def._((quote._~23~25kernel)._integer~3f))",[0,[2,"integer?"]],["racket/base","racket"]],
["integer?",">r5rs-std/r5rs-Z-H-9.html#%_idx_252",[0,[2,"integer?"]],["r5rs"]],
["integer?",">r6rs-std/r6rs-Z-H-14.html#node_idx_448",[0,[2,"integer?"]],["rnrs/base-6"]],
["integer?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._integer~3f))",[0,[2,"integer?"]],["lang/htdp-advanced"]],
["integer?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._integer~3f))",[0,[2,"integer?"]],["lang/htdp-beginner"]],
["integer?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._integer~3f))",[0,[2,"integer?"]],["lang/htdp-beginner-abbr"]],
["integer?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._integer~3f))",[0,[2,"integer?"]],["lang/htdp-intermediate"]],
["integer?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._integer~3f))",[0,[2,"integer?"]],["lang/htdp-intermediate-lambda"]],
["integer?",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._integer~3f))",[0,[2,"integer?"]],["deinprogramm/DMdA-advanced"]],
["integer?",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._integer~3f))",[0,[2,"integer?"]],["deinprogramm/DMdA-assignments"]],
["integer?",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._integer~3f))",[0,[2,"integer?"]],["deinprogramm/DMdA-beginner"]],
["integer?",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._integer~3f))",[0,[2,"integer?"]],["deinprogramm/DMdA-vanilla"]],
["integers",">inside/overview.html#(part._im~3aintsize)","Integers",false],
["integers",">reference/numbers.html#(tech._integer)","<span style=\"font-style: italic\">integers</span>",false],
["integral",">frtime/index.html#(def._((lib._frtime/main..rkt)._integral))",[0,[2,"integral"]],["frtime"]],
["integrating languages with test engine",">test-engine/index.html#(part._.Integrating_languages_with_.Test_.Engine)","Integrating languages with Test Engine",false],
["integration with threads",">inside/threads.html#(part._.Integration_with_.Threads)","Integration with Threads",false],
["interact with drracket in english menu item",">drracket/Menus.html#(idx._(gentag._151._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Interact with DrRacket in English</span> menu item",false],
["interacting with evaluators",">reference/Sandboxed_Evaluation.html#(part._.Interacting_with_.Evaluators)","Interacting with Evaluators",false],
["interacting with racket",">guide/intro.html#(part._.Interacting_with_.Racket)","Interacting with Racket",false],
["interacting with the readline-enabled input port",">readline/index.html#(part._.Interacting_with_the_.Readline-.Enabled_.Input_.Port_)","Interacting with the Readline-Enabled Input Port ",false],
["interaction",">scribble/eval.html#(form._((lib._scribble/eval..rkt)._interaction))",[0,[1,"interaction"]],["scribble/eval"]],
["interaction port handler",">reference/eval.html#(tech._interaction._port._handler)","<span style=\"font-style: italic\">interaction port handler</span>",false],
["interaction wrapper: #%top-interaction",">reference/__top-interaction.html",["Interaction Wrapper: ",[0,[1,"#%top-interaction"]]],false],
["interaction-environment",">r5rs-std/r5rs-Z-H-9.html#%_idx_606",[0,[2,"interaction-environment"]],["r5rs"]],
["interaction-eval",">scribble/eval.html#(form._((lib._scribble/eval..rkt)._interaction-eval))",[0,[1,"interaction-eval"]],["scribble/eval"]],
["interaction-eval-show",">scribble/eval.html#(form._((lib._scribble/eval..rkt)._interaction-eval-show))",[0,[1,"interaction-eval-show"]],["scribble/eval"]],
["interaction0",">scribble/eval.html#(form._((lib._scribble/eval..rkt)._interaction0))",[0,[1,"interaction0"]],["scribble/eval"]],
["interactions",">drracket/Keyboard_Shortcuts.html#(part._.Interactions)","Interactions",false],
["interactions",">teachpack/2htdpuniverse.html#(part._interactive)","Interactions",false],
["interactions",">teachpack/world.html#(part._interactive)","Interactions",false],
["interactions window",">drracket/interface-essentials.html#(tech._interactions._window)","<span style=\"font-style: italic\">interactions window</span>",false],
["interactions with canvas",">teachpack/draw.html#(part._interaction)","Interactions with Canvas",false],
["interactive evaluation: xrepl",">guide/cmdline-tools.html#(part._.Interactive_evaluation__.X.R.E.P.L)","Interactive evaluation: XREPL",false],
["interactive help",">reference/Interactive_Help.html","Interactive Help",false],
["interactive mode",">guide/racket.html#(part._start-interactive-mode)","Interactive Mode",false],
["interactive module loading",">reference/enter.html","Interactive Module Loading",false],
["interactive value port",">mrlib/Interactive_Value_Port.html","Interactive Value Port",false],
["interactive-adjust-mouse",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._interactive-adjust-mouse))",[[0,[2,"interactive-adjust-mouse"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["interactive-adjust-move",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._interactive-adjust-move))",[[0,[2,"interactive-adjust-move"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["interactive-adjust-resize",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._interactive-adjust-resize))",[[0,[2,"interactive-adjust-resize"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["interface",">scribble/reader-internals.html#(part._.Interface)","Interface",false],
["interface",">reference/createinterface.html#(form._((lib._racket/private/class-internal..rkt)._interface))",[0,[1,"interface"]],["racket/class","racket"]],
["interface",">reference/mzlib_class.html#(tech._interface)","<span style=\"font-style: italic\">interface</span>",false],
["interface essentials",">drracket/interface-essentials.html","Interface Essentials",false],
["interface pointers",">foreign/com-auto.html#(part._.Interface_.Pointers)","Interface Pointers",false],
["interface reference",">drracket/Interface_Reference.html","Interface Reference",false],
["interface*",">reference/createinterface.html#(form._((lib._racket/private/class-internal..rkt)._interface*))",[0,[1,"interface*"]],["racket/class","racket"]],
["interface->method-names",">reference/objectutils.html#(def._((lib._racket/private/class-internal..rkt)._interface-~3emethod-names))",[0,[2,"interface->method-names"]],["racket/class","racket"]],
["interface-extension?",">reference/objectutils.html#(def._((lib._racket/private/class-internal..rkt)._interface-extension~3f))",[0,[2,"interface-extension?"]],["racket/class","racket"]],
["interface-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..rkt)._interface-index-desc))",[0,[2,"interface-index-desc"]],["scribble/manual-struct"]],
["interface-index-desc?",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..rkt)._interface-index-desc~3f))",[0,[2,"interface-index-desc?"]],["scribble/manual-struct"]],
["interface-oriented programming for classes",">unstable/class-iop.html","Interface-Oriented Programming for Classes",false],
["interface-version",">web-server/stateless.html#(def._((lib._web-server/scribblings/dummy-stateless-servlet..rkt)._interface-version))",[0,[2,"interface-version"]],[]],
["interface-version",">web-server/servlet.html#(def._((lib._web-server/scribblings/dummy-v2-servlet..rkt)._interface-version))",[0,[2,"interface-version"]],[]],
["interface?",">reference/objectutils.html#(def._((lib._racket/private/class-internal..rkt)._interface~3f))",[0,[2,"interface?"]],["racket/class","racket"]],
["interfaces",">guide/classes.html#(part._.Interfaces)","Interfaces",false],
["interior",">foreign/foreign_pointer-funcs.html#(idx._(gentag._10._(lib._scribblings/foreign/foreign..scrbl)))",[7,"'interior"],false],
["intermediate student",">htdp-langs/intermediate.html","Intermediate Student",false],
["intermediate student language",">drracket/htdp-langs.html#(idx._(gentag._45._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Intermediate Student</span> language",false],
["intermediate student with lambda",">htdp-langs/intermediate-lam.html","Intermediate Student with Lambda",false],
["intermediate student with lambda language",">drracket/htdp-langs.html#(idx._(gentag._46._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Intermediate Student with Lambda</span>\nlanguage",false],
["internal and external names",">guide/classes.html#(part._intnames)","Internal and External Names",false],
["internal and external names",">reference/createclass.html#(part._extnames)","Internal and External Names",false],
["internal apis",">web-server-internal/private.html","Internal APIs",false],
["internal class contracts",">guide/classes.html#(part._.Internal_.Class_.Contracts)","Internal Class Contracts",false],
["internal definitions",">guide/define.html#(part._intdefs)","Internal Definitions",false],
["internal definitions",">reference/syntax-model.html#(part._intdef-body)","Internal Definitions",false],
["internal editor locks",">gui/editor-overview.html#(part._lockinfo)","Internal Editor Locks",false],
["internal servlet representation",">web-server-internal/dispatch-servlets.html#(part._.Internal_.Servlet_.Representation)","Internal Servlet Representation",false],
["internal-definition context",">reference/syntax-model.html#(tech._internal._definition._context)","<span style=\"font-style: italic\">internal-definition context</span>",false],
["internal-definition limiting: #%stratified-body",">reference/stratified-body.html",["Internal-Definition Limiting: ",[0,[1,"#%stratified-body"]]],false],
["internal-definition-context",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Internal-.Definition-.Context))",[0,[1,"Internal-Definition-Context"]],["typed/racket/base","typed/racket"]],
["internal-definition-context-apply",">reference/syntax-util.html#(def._((lib._racket/syntax..rkt)._internal-definition-context-apply))",[0,[2,"internal-definition-context-apply"]],["racket/syntax"]],
["internal-definition-context-seal",">reference/stxtrans.html#(def._((quote._~23~25kernel)._internal-definition-context-seal))",[0,[2,"internal-definition-context-seal"]],["racket/base","racket"]],
["internal-definition-context?",">reference/stxtrans.html#(def._((quote._~23~25kernel)._internal-definition-context~3f))",[0,[2,"internal-definition-context?"]],["racket/base","racket"]],
["interned",">reference/reader.html#(tech._interned)","<span style=\"font-style: italic\">interned</span>",false],
["interpreting syntax",">macro-debugger/index.html#(part._.Interpreting_.Syntax)","Interpreting Syntax",false],
["intersect",">draw/region_.html#(meth._(((lib._racket/draw..rkt)._region~25)._intersect))",[[0,[2,"intersect"]],[14,[" (method of ",[0,[2,"region%"]],")"]]],["racket/draw"]],
["intersect",">mzlib/mzlib_integer-set.html#(def._((lib._mzlib/integer-set..rkt)._intersect))",[0,[2,"intersect"]],["mzlib/integer-set"]],
["intersection",">unstable/Automata__Compiling_State_Machines.html#(form._((lib._unstable/automata/re-ext..rkt)._intersection))",[0,[1,"intersection"]],["unstable/automata/re-ext"]],
["interval",">gui/timer_.html#(meth._(((lib._mred/main..rkt)._timer~25)._interval))",[[0,[2,"interval"]],[14,[" (method of ",[0,[2,"timer%"]],")"]]],["racket/gui/base","racket/gui"]],
["interval maps",">data/interval-map.html","Interval Maps",false],
["interval-alpha",">plot/params.html#(def._((lib._plot/main..rkt)._interval-alpha))",[0,[2,"interval-alpha"]],["plot"]],
["interval-color",">plot/params.html#(def._((lib._plot/main..rkt)._interval-color))",[0,[2,"interval-color"]],["plot"]],
["interval-line1-color",">plot/params.html#(def._((lib._plot/main..rkt)._interval-line1-color))",[0,[2,"interval-line1-color"]],["plot"]],
["interval-line1-style",">plot/params.html#(def._((lib._plot/main..rkt)._interval-line1-style))",[0,[2,"interval-line1-style"]],["plot"]],
["interval-line1-width",">plot/params.html#(def._((lib._plot/main..rkt)._interval-line1-width))",[0,[2,"interval-line1-width"]],["plot"]],
["interval-line2-color",">plot/params.html#(def._((lib._plot/main..rkt)._interval-line2-color))",[0,[2,"interval-line2-color"]],["plot"]],
["interval-line2-style",">plot/params.html#(def._((lib._plot/main..rkt)._interval-line2-style))",[0,[2,"interval-line2-style"]],["plot"]],
["interval-line2-width",">plot/params.html#(def._((lib._plot/main..rkt)._interval-line2-width))",[0,[2,"interval-line2-width"]],["plot"]],
["interval-map-cons*!",">data/interval-map.html#(def._((lib._data/interval-map..rkt)._interval-map-cons*!))",[0,[2,"interval-map-cons*!"]],["data/interval-map"]],
["interval-map-contract!",">data/interval-map.html#(def._((lib._data/interval-map..rkt)._interval-map-contract!))",[0,[2,"interval-map-contract!"]],["data/interval-map"]],
["interval-map-expand!",">data/interval-map.html#(def._((lib._data/interval-map..rkt)._interval-map-expand!))",[0,[2,"interval-map-expand!"]],["data/interval-map"]],
["interval-map-iter?",">data/interval-map.html#(def._((lib._data/interval-map..rkt)._interval-map-iter~3f))",[0,[2,"interval-map-iter?"]],["data/interval-map"]],
["interval-map-iterate-first",">data/interval-map.html#(def._((lib._data/interval-map..rkt)._interval-map-iterate-first))",[0,[2,"interval-map-iterate-first"]],["data/interval-map"]],
["interval-map-iterate-key",">data/interval-map.html#(def._((lib._data/interval-map..rkt)._interval-map-iterate-key))",[0,[2,"interval-map-iterate-key"]],["data/interval-map"]],
["interval-map-iterate-next",">data/interval-map.html#(def._((lib._data/interval-map..rkt)._interval-map-iterate-next))",[0,[2,"interval-map-iterate-next"]],["data/interval-map"]],
["interval-map-iterate-value",">data/interval-map.html#(def._((lib._data/interval-map..rkt)._interval-map-iterate-value))",[0,[2,"interval-map-iterate-value"]],["data/interval-map"]],
["interval-map-ref",">data/interval-map.html#(def._((lib._data/interval-map..rkt)._interval-map-ref))",[0,[2,"interval-map-ref"]],["data/interval-map"]],
["interval-map-remove!",">data/interval-map.html#(def._((lib._data/interval-map..rkt)._interval-map-remove!))",[0,[2,"interval-map-remove!"]],["data/interval-map"]],
["interval-map-set!",">data/interval-map.html#(def._((lib._data/interval-map..rkt)._interval-map-set!))",[0,[2,"interval-map-set!"]],["data/interval-map"]],
["interval-map-update*!",">data/interval-map.html#(def._((lib._data/interval-map..rkt)._interval-map-update*!))",[0,[2,"interval-map-update*!"]],["data/interval-map"]],
["interval-map?",">data/interval-map.html#(def._((lib._data/interval-map..rkt)._interval-map~3f))",[0,[2,"interval-map?"]],["data/interval-map"]],
["interval-style",">plot/params.html#(def._((lib._plot/main..rkt)._interval-style))",[0,[2,"interval-style"]],["plot"]],
["intervals",">plot/params.html#(part._.Intervals)","Intervals",false],
["intervals and interval functions",">plot/utils.html#(part._math..intervals)","Intervals and Interval Functions",false],
["introduce-let-ans",">framework/Racket.html#(meth._(((lib._framework/main..rkt)._racket~3atext~3c~25~3e)._introduce-let-ans))",[[0,[2,"introduce-let-ans"]],[14,[" (method of ",[0,[2,"racket:text<%>"]],")"]]],["framework"]],
["introducing bindings",">reference/syntax-model.html#(part._intro-binding)","Introducing Bindings",false],
["introduction",">plot/intro.html","Introduction",false],
["introduction",">syntax/stxparse-intro.html","Introduction",false],
["introduction to using database connections",">db/using-db.html#(part._intro-basic)","Introduction to Using Database Connections",false],
["invalid transaction",">db/query-api.html#(tech._invalid._transaction)","<span style=\"font-style: italic\">invalid transaction</span>",false],
["invalidate-bitmap-cache",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._invalidate-bitmap-cache))",[[0,[2,"invalidate-bitmap-cache"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["inverse",">plot/renderer2d.html#(def._((lib._plot/main..rkt)._inverse))",[0,[2,"inverse"]],["plot"]],
["inverse-interval",">plot/renderer2d.html#(def._((lib._plot/main..rkt)._inverse-interval))",[0,[2,"inverse-interval"]],["plot"]],
["inverse-label",">plot/renderer2d.html#(def._((lib._plot/main..rkt)._inverse-label))",[0,[2,"inverse-label"]],["plot"]],
["invert",">graphics/Draw__Clear__and_Flip_Operations.html#(tech._invert)","<span style=\"font-style: italic\">invert</span>",false],
["inverted point",">slideshow/Pict_Datatype.html#(tech._inverted._point)","<span style=\"font-style: italic\">inverted\npoint</span>",false],
["invertible functions",">plot/ticks_and_transforms.html#(part._invertible)","Invertible Functions",false],
["invertible-compose",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._invertible-compose))",[0,[2,"invertible-compose"]],["plot"]],
["invertible-function",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._invertible-function))",[0,[2,"invertible-function"]],["plot"]],
["invertible-function-f",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._invertible-function-f))",[0,[2,"invertible-function-f"]],["plot"]],
["invertible-function-g",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._invertible-function-g))",[0,[2,"invertible-function-g"]],["plot"]],
["invertible-function?",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._invertible-function~3f))",[0,[2,"invertible-function?"]],["plot"]],
["invertible-inverse",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._invertible-inverse))",[0,[2,"invertible-inverse"]],["plot"]],
["invisible",">gui/snip_.html#(idx._(gentag._162._(lib._scribblings/gui/gui..scrbl)))",[7,"'invisible"],false],
["invisible",">gui/snip_.html#(tech._invisible)","<span style=\"font-style: italic\">invisible</span>",false],
["invisible-rect",">plot/nonrenderer.html#(def._((lib._plot/main..rkt)._invisible-rect))",[0,[2,"invisible-rect"]],["plot"]],
["invisible-rect3d",">plot/nonrenderer.html#(def._((lib._plot/main..rkt)._invisible-rect3d))",[0,[2,"invisible-rect3d"]],["plot"]],
["invoke-unit",">reference/invokingunits.html#(form._((lib._mzlib/unit..rkt)._invoke-unit))",[0,[1,"invoke-unit"]],["racket/unit","racket"]],
["invoke-unit/infer",">reference/linkinference.html#(form._((lib._mzlib/unit..rkt)._invoke-unit/infer))",[0,[1,"invoke-unit/infer"]],["racket/unit","racket"]],
["invoked",">guide/units.html#(tech._invoked)","<span style=\"font-style: italic\">invoked</span>",false],
["invoked",">reference/mzlib_unit.html#(tech._invoked)","<span style=\"font-style: italic\">invoked</span>",false],
["invoking mzpp",">preprocessor/mzpp.html#(part._.Invoking_mzpp)","Invoking mzpp",false],
["invoking mztext",">preprocessor/mztext.html#(part._.Invoking_mztext)","Invoking mztext",false],
["invoking units",">guide/Invoking_Units.html","Invoking Units",false],
["invoking units",">reference/invokingunits.html","Invoking Units",false],
["io",">planet/Developing_Packages_for_PLaneT.html#(idx._(gentag._9._(lib._planet/planet..scrbl)))",[7,"'io"],false],
["io functions",">teachpack/2htdpbatch-io.html#(part._.I.O_.Functions)","IO Functions",false],
["iota",">srfi-std/srfi-1.html#iota",[0,[2,"iota"]],["srfi/1"]],
["ip",">teachpack/2htdpuniverse.html#(tech._ip)","<span style=\"font-style: italic\">IP</span>",false],
["irritants-condition?",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_448",[0,[2,"irritants-condition?"]],["rnrs/conditions-6"]],
["is-a?",">reference/objectutils.html#(def._((lib._racket/private/class-internal..rkt)._is-a~3f))",[0,[2,"is-a?"]],["racket/class","racket"]],
["is-a?/c",">reference/Object_and_Class_Contracts.html#(def._((lib._racket/class..rkt)._is-a~3f/c))",[0,[2,"is-a?/c"]],["racket/class","racket"]],
["is-busy?",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._is-busy~3f))",[0,[2,"is-busy?"]],["racket/gui/base","racket/gui"]],
["is-checked?",">gui/checkable-menu-item_.html#(meth._(((lib._mred/main..rkt)._checkable-menu-item~25)._is-checked~3f))",[[0,[2,"is-checked?"]],[14,[" (method of ",[0,[2,"checkable-menu-item%"]],")"]]],["racket/gui/base","racket/gui"]],
["is-color-display?",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._is-color-display~3f))",[0,[2,"is-color-display?"]],["racket/gui/base","racket/gui"]],
["is-color?",">draw/bitmap_.html#(meth._(((lib._racket/draw..rkt)._bitmap~25)._is-color~3f))",[[0,[2,"is-color?"]],[14,[" (method of ",[0,[2,"bitmap%"]],")"]]],["racket/draw"]],
["is-current-tab?",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3atab~3c~25~3e)._is-current-tab~3f))",[[0,[2,"is-current-tab?"]],[14,[" (method of ",[0,[2,"drracket:unit:tab<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["is-deleted?",">gui/menu-item___.html#(meth._(((lib._mred/main..rkt)._menu-item~3c~25~3e)._is-deleted~3f))",[[0,[2,"is-deleted?"]],[14,[" (method of ",[0,[2,"menu-item<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["is-empty?",">draw/region_.html#(meth._(((lib._racket/draw..rkt)._region~25)._is-empty~3f))",[[0,[2,"is-empty?"]],[14,[" (method of ",[0,[2,"region%"]],")"]]],["racket/draw"]],
["is-enabled?",">gui/labelled-menu-item___.html#(meth._(((lib._mred/main..rkt)._labelled-menu-item~3c~25~3e)._is-enabled~3f))",[[0,[2,"is-enabled?"]],[14,[" (method of ",[0,[2,"labelled-menu-item<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["is-enabled?",">gui/menu-bar_.html#(meth._(((lib._mred/main..rkt)._menu-bar~25)._is-enabled~3f))",[[0,[2,"is-enabled?"]],[14,[" (method of ",[0,[2,"menu-bar%"]],")"]]],["racket/gui/base","racket/gui"]],
["is-enabled?",">gui/radio-box_.html#(meth._(((lib._mred/main..rkt)._radio-box~25)._is-enabled~3f))",[[0,[2,"is-enabled?"]],[14,[" (method of ",[0,[2,"radio-box%"]],")"]]],["racket/gui/base","racket/gui"]],
["is-enabled?",">gui/window___.html#(meth._(((lib._mred/main..rkt)._window~3c~25~3e)._is-enabled~3f))",[[0,[2,"is-enabled?"]],[14,[" (method of ",[0,[2,"window<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["is-frozen?",">framework/Color.html#(meth._(((lib._framework/main..rkt)._color~3atext~3c~25~3e)._is-frozen~3f))",[[0,[2,"is-frozen?"]],[14,[" (method of ",[0,[2,"color:text<%>"]],")"]]],["framework"]],
["is-iconized?",">gui/frame_.html#(meth._(((lib._mred/main..rkt)._frame~25)._is-iconized~3f))",[[0,[2,"is-iconized?"]],[14,[" (method of ",[0,[2,"frame%"]],")"]]],["racket/gui/base","racket/gui"]],
["is-immutable?",">draw/brush_.html#(meth._(((lib._racket/draw..rkt)._brush~25)._is-immutable~3f))",[[0,[2,"is-immutable?"]],[14,[" (method of ",[0,[2,"brush%"]],")"]]],["racket/draw"]],
["is-immutable?",">draw/color_.html#(meth._(((lib._racket/draw..rkt)._color~25)._is-immutable~3f))",[[0,[2,"is-immutable?"]],[14,[" (method of ",[0,[2,"color%"]],")"]]],["racket/draw"]],
["is-immutable?",">draw/pen_.html#(meth._(((lib._racket/draw..rkt)._pen~25)._is-immutable~3f))",[[0,[2,"is-immutable?"]],[14,[" (method of ",[0,[2,"pen%"]],")"]]],["racket/draw"]],
["is-info-hidden?",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3ainfo~3c~25~3e)._is-info-hidden~3f))",[[0,[2,"is-info-hidden?"]],[14,[" (method of ",[0,[2,"frame:info<%>"]],")"]]],["framework"]],
["is-join?",">gui/style___.html#(meth._(((lib._racket/snip..rkt)._style~3c~25~3e)._is-join~3f))",[[0,[2,"is-join?"]],[14,[" (method of ",[0,[2,"style<%>"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["is-lexer-valid?",">framework/Color.html#(meth._(((lib._framework/main..rkt)._color~3atext~3c~25~3e)._is-lexer-valid~3f))",[[0,[2,"is-lexer-valid?"]],[14,[" (method of ",[0,[2,"color:text<%>"]],")"]]],["framework"]],
["is-locked?",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._is-locked~3f))",[[0,[2,"is-locked?"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["is-maximized?",">gui/frame_.html#(meth._(((lib._mred/main..rkt)._frame~25)._is-maximized~3f))",[[0,[2,"is-maximized?"]],[14,[" (method of ",[0,[2,"frame%"]],")"]]],["racket/gui/base","racket/gui"]],
["is-modified?",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._is-modified~3f))",[[0,[2,"is-modified?"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["is-open?",">mrlib/hierarchical-list-compound-item___.html#(meth._(((lib._mrlib/hierlist..rkt)._hierarchical-list-compound-item~3c~25~3e)._is-open~3f))",[[0,[2,"is-open?"]],[14,[" (method of ",[0,[2,"hierarchical-list-compound-item<%>"]],")"]]],["mrlib/hierlist"]],
["is-owned?",">gui/snip_.html#(meth._(((lib._racket/snip..rkt)._snip~25)._is-owned~3f))",[[0,[2,"is-owned?"]],[14,[" (method of ",[0,[2,"snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["is-printing?",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._is-printing~3f))",[[0,[2,"is-printing?"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["is-running?",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3atab~3c~25~3e)._is-running~3f))",[[0,[2,"is-running?"]],[14,[" (method of ",[0,[2,"drracket:unit:tab<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["is-selected?",">gui/list-box_.html#(meth._(((lib._mred/main..rkt)._list-box~25)._is-selected~3f))",[[0,[2,"is-selected?"]],[14,[" (method of ",[0,[2,"list-box%"]],")"]]],["racket/gui/base","racket/gui"]],
["is-selected?",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._is-selected~3f))",[[0,[2,"is-selected?"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["is-selected?",">mrlib/hierarchical-list-item___.html#(meth._(((lib._mrlib/hierlist..rkt)._hierarchical-list-item~3c~25~3e)._is-selected~3f))",[[0,[2,"is-selected?"]],[14,[" (method of ",[0,[2,"hierarchical-list-item<%>"]],")"]]],["mrlib/hierlist"]],
["is-shown?",">gui/window___.html#(meth._(((lib._mred/main..rkt)._window~3c~25~3e)._is-shown~3f))",[[0,[2,"is-shown?"]],[14,[" (method of ",[0,[2,"window<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["is-shown?",">embedded-gui/alignment-parent___.html#(meth._(((lib._embedded-gui/main..rkt)._alignment-parent~3c~25~3e)._is-shown~3f))",[[0,[2,"is-shown?"]],[14,[" (method of ",[0,[2,"alignment-parent<%>"]],")"]]],["embedded-gui"]],
["is-special-first-line?",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3afirst-line~3c~25~3e)._is-special-first-line~3f))",[[0,[2,"is-special-first-line?"]],[14,[" (method of ",[0,[2,"text:first-line<%>"]],")"]]],["framework"]],
["is-stopped?",">framework/Color.html#(meth._(((lib._framework/main..rkt)._color~3atext~3c~25~3e)._is-stopped~3f))",[[0,[2,"is-stopped?"]],[14,[" (method of ",[0,[2,"color:text<%>"]],")"]]],["framework"]],
["is-text",">gui/snip_.html#(idx._(gentag._160._(lib._scribblings/gui/gui..scrbl)))",[7,"'is-text"],false],
["is-url-too-big?",">web-server/stateless.html#(def._((lib._web-server/lang/stuff-url..rkt)._is-url-too-big~3f))",[0,[2,"is-url-too-big?"]],["web-server/lang/stuff-url"]],
["is-wxme-stream?",">gui/WXME_Decoding.html#(def._((lib._wxme/main..rkt)._is-wxme-stream~3f))",[0,[2,"is-wxme-stream?"]],["wxme"]],
["isindex",">html/index.html#(def._((lib._html/main..rkt)._isindex))",[0,[2,"isindex"]],["html"]],
["isindex?",">html/index.html#(def._((lib._html/main..rkt)._isindex~3f))",[0,[2,"isindex?"]],["html"]],
["iso-control",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex..rkt)._iso-control))",[0,[1,"iso-control"]],["parser-tools/lex"]],
["isoline",">plot/renderer2d.html#(def._((lib._plot/main..rkt)._isoline))",[0,[2,"isoline"]],["plot"]],
["isoline3d",">plot/renderer3d.html#(def._((lib._plot/main..rkt)._isoline3d))",[0,[2,"isoline3d"]],["plot"]],
["isosceles-triangle",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._isosceles-triangle))",[0,[2,"isosceles-triangle"]],["2htdp/image"]],
["isosurface-alphas",">plot/params.html#(def._((lib._plot/main..rkt)._isosurface-alphas))",[0,[2,"isosurface-alphas"]],["plot"]],
["isosurface-colors",">plot/params.html#(def._((lib._plot/main..rkt)._isosurface-colors))",[0,[2,"isosurface-colors"]],["plot"]],
["isosurface-levels",">plot/params.html#(def._((lib._plot/main..rkt)._isosurface-levels))",[0,[2,"isosurface-levels"]],["plot"]],
["isosurface-line-colors",">plot/params.html#(def._((lib._plot/main..rkt)._isosurface-line-colors))",[0,[2,"isosurface-line-colors"]],["plot"]],
["isosurface-line-styles",">plot/params.html#(def._((lib._plot/main..rkt)._isosurface-line-styles))",[0,[2,"isosurface-line-styles"]],["plot"]],
["isosurface-line-widths",">plot/params.html#(def._((lib._plot/main..rkt)._isosurface-line-widths))",[0,[2,"isosurface-line-widths"]],["plot"]],
["isosurface-styles",">plot/params.html#(def._((lib._plot/main..rkt)._isosurface-styles))",[0,[2,"isosurface-styles"]],["plot"]],
["isosurface3d",">plot/renderer3d.html#(def._((lib._plot/main..rkt)._isosurface3d))",[0,[2,"isosurface3d"]],["plot"]],
["isosurfaces",">plot/params.html#(part._.Isosurfaces)","Isosurfaces",false],
["isosurfaces3d",">plot/renderer3d.html#(def._((lib._plot/main..rkt)._isosurfaces3d))",[0,[2,"isosurfaces3d"]],["plot"]],
["it",">slideshow/Primary_Slide_Functions.html#(def._((lib._slideshow/base..rkt)._it))",[0,[2,"it"]],["slideshow/base","slideshow"]],
["italic",">scribble/base.html#(def._((lib._scribble/base..rkt)._italic))",[0,[2,"italic"]],["scribble/base"]],
["italic",">unstable/Slideshow_Presentations.html#(form._((lib._unstable/gui/slideshow..rkt)._italic))",[0,[1,"italic"]],["unstable/gui/slideshow"]],
["italic",">gui/style-delta_.html#(idx._(gentag._181._(lib._scribblings/gui/gui..scrbl)))",[7,"'italic"],false],
["italic",">draw/font_.html#(idx._(gentag._38._(lib._scribblings/draw/draw..scrbl)))",[7,"'italic"],false],
["item",">scribble/base.html#(def._((lib._scribble/base..rkt)._item))",[0,[2,"item"]],["scribble/base"]],
["item",">slideshow/Primary_Slide_Functions.html#(def._((lib._slideshow/base..rkt)._item))",[0,[2,"item"]],["slideshow/base","slideshow"]],
["item",">gui/editor-overview.html#(tech._item)","<span style=\"font-style: italic\">item</span>",false],
["item?",">scribble/base.html#(def._((lib._scribble/base..rkt)._item~3f))",[0,[2,"item?"]],["scribble/base"]],
["itemization",">scribble/core.html#(def._((lib._scribble/core..rkt)._itemization))",[0,[2,"itemization"]],["scribble/core"]],
["itemization",">scribble/core.html#(tech._itemization)","<span style=\"font-style: italic\">itemization</span>",false],
["itemization-blockss",">scribble/core.html#(def._((lib._scribble/core..rkt)._itemization-blockss))",[0,[2,"itemization-blockss"]],["scribble/core"]],
["itemization-style",">scribble/core.html#(def._((lib._scribble/core..rkt)._itemization-style))",[0,[2,"itemization-style"]],["scribble/core"]],
["itemization?",">scribble/core.html#(def._((lib._scribble/core..rkt)._itemization~3f))",[0,[2,"itemization?"]],["scribble/core"]],
["itemize",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/basic..rkt)._itemize))",[0,[2,"itemize"]],["scribble/basic"]],
["itemlist",">scribble/base.html#(def._((lib._scribble/base..rkt)._itemlist))",[0,[2,"itemlist"]],["scribble/base"]],
["items",">teachpack/2htdpPlanet_Cute_Images.html#(part._pc~3a.Items)","Items",false],
["iteration and comprehension forms",">reference/for.html#(part._.Iteration_and_.Comprehension_.Forms)","Iteration and Comprehension Forms",false],
["iteration performance",">guide/for.html#(part._for-performance)","Iteration Performance",false],
["iterations and comprehensions",">guide/for.html","Iterations and Comprehensions",false],
["iterations and comprehensions: for, for/list, ...",">reference/for.html",["Iterations and Comprehensions: ",[0,[1,"for"]],", ",[0,[1,"for/list"]],", ..."],false],
["iterator",">reference/sequences.html#(tech._iterator)","<span style=\"font-style: italic\">iterator</span>",false],
["ivl",">plot/utils.html#(def._((lib._plot/utils..rkt)._ivl))",[0,[2,"ivl"]],["plot/utils"]],
["ivl->plot-label",">plot/utils.html#(def._((lib._plot/utils..rkt)._ivl-~3eplot-label))",[0,[2,"ivl->plot-label"]],["plot/utils"]],
["ivl-max",">plot/utils.html#(def._((lib._plot/utils..rkt)._ivl-max))",[0,[2,"ivl-max"]],["plot/utils"]],
["ivl-min",">plot/utils.html#(def._((lib._plot/utils..rkt)._ivl-min))",[0,[2,"ivl-min"]],["plot/utils"]],
["ivl?",">plot/utils.html#(def._((lib._plot/utils..rkt)._ivl~3f))",[0,[2,"ivl?"]],["plot/utils"]],
["iworld-name",">teachpack/2htdpuniverse.html#(def._((lib._2htdp/universe..rkt)._iworld-name))",[0,[2,"iworld-name"]],["2htdp/universe"]],
["iworld1",">teachpack/2htdpuniverse.html#(def._((lib._2htdp/universe..rkt)._iworld1))",[0,[2,"iworld1"]],["2htdp/universe"]],
["iworld2",">teachpack/2htdpuniverse.html#(def._((lib._2htdp/universe..rkt)._iworld2))",[0,[2,"iworld2"]],["2htdp/universe"]],
["iworld3",">teachpack/2htdpuniverse.html#(def._((lib._2htdp/universe..rkt)._iworld3))",[0,[2,"iworld3"]],["2htdp/universe"]],
["iworld=?",">teachpack/2htdpuniverse.html#(def._((lib._2htdp/universe..rkt)._iworld~3d~3f))",[0,[2,"iworld=?"]],["2htdp/universe"]],
["iworld?",">teachpack/2htdpuniverse.html#(def._((lib._2htdp/universe..rkt)._iworld~3f))",[0,[2,"iworld?"]],["2htdp/universe"]],
["jack-o-lantern",">slideshow/More_Pict_Constructors.html#(def._((lib._slideshow/pict..rkt)._jack-o-lantern))",[0,[2,"jack-o-lantern"]],["slideshow/pict","slideshow"]],
["javadoc",">scribble/srcdoc.html#(idx._(gentag._10._(lib._scribblings/scribble/scribble..scrbl)))","JavaDoc",false],
["jewel --- 3-d skill game",">games/jewel.html",[[15,"<img src=\"jewel.png\" alt=\"\" />"]," ","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Jewel</span>"," ","&#8212;","<wbr></wbr>"," 3-D Skill Game"],false],
["jfp paper format",">scribble/JFP_Paper_Format.html","JFP Paper Format",false],
["jit",">guide/performance.html#(tech._jit)","<span style=\"font-style: italic\">JIT</span>",false],
["jit",">reference/eval.html#(tech._jit)","<span style=\"font-style: italic\">JIT</span>",false],
["join style",">draw/pen_.html#(tech._join._style)","<span style=\"font-style: italic\">join style</span>",false],
["join style",">gui/editor-overview.html#(tech._join._style)","<span style=\"font-style: italic\">join style</span>",false],
["journal-location",">scriblib/autobib.html#(def._((lib._scriblib/autobib..rkt)._journal-location))",[0,[2,"journal-location"]],["scriblib/autobib"]],
["jpeg",">draw/bitmap_.html#(idx._(gentag._1._(lib._scribblings/draw/draw..scrbl)))","JPEG",false],
["jpeg",">draw/bitmap_.html#(idx._(gentag._8._(lib._scribblings/draw/draw..scrbl)))","JPEG",false],
["js-expression",">json/index.html#(tech._js._expression)","<span style=\"font-style: italic\">JS-Expression</span>",false],
["js-expressions",">json/index.html#(part._.J.S-.Expressions)","JS-Expressions",false],
["jsexpr",">json/index.html#(tech._jsexpr)","<span style=\"font-style: italic\">jsexpr</span>",false],
["jsexpr->bytes",">json/index.html#(def._((lib._json/main..rkt)._jsexpr-~3ebytes))",[0,[2,"jsexpr->bytes"]],["json"]],
["jsexpr->string",">json/index.html#(def._((lib._json/main..rkt)._jsexpr-~3estring))",[0,[2,"jsexpr->string"]],["json"]],
["jsexpr?",">json/index.html#(def._((lib._json/main..rkt)._jsexpr~3f))",[0,[2,"jsexpr?"]],["json"]],
["json",">json/index.html","JSON",false],
["json",">json/index.html",[9,[0,"json"]],"module"],
["json-null",">json/index.html#(def._((lib._json/main..rkt)._json-null))",[0,[2,"json-null"]],["json"]],
["judgment-form->pict",">redex/The_Redex_Reference.html#(form._((lib._redex/pict..rkt)._judgment-form-~3epict))",[0,[1,"judgment-form->pict"]],["redex/pict","redex"]],
["judgment-holds",">redex/The_Redex_Reference.html#(form._((lib._redex/reduction-semantics..rkt)._judgment-holds))",[0,[1,"judgment-holds"]],["redex/reduction-semantics","redex"]],
["julian-day->date",">srfi-std/srfi-19.html#julian-day->date",[0,[2,"julian-day->date"]],["srfi/19"]],
["julian-day->time-monotonic",">srfi-std/srfi-19.html#julian-day->time-monotonic",[0,[2,"julian-day->time-monotonic"]],["srfi/19"]],
["julian-day->time-tai",">srfi-std/srfi-19.html#julian-day->time-tai",[0,[2,"julian-day->time-tai"]],["srfi/19"]],
["julian-day->time-utc",">srfi-std/srfi-19.html#julian-day->time-utc",[0,[2,"julian-day->time-utc"]],["srfi/19"]],
["julian/scalinger->string",">reference/time.html#(def._((lib._racket/date..rkt)._julian/scalinger-~3estring))",[0,[2,"julian/scalinger->string"]],["racket/date"]],
["jump-to",">gui/editor-stream-in_.html#(meth._(((lib._mred/main..rkt)._editor-stream-in~25)._jump-to))",[[0,[2,"jump-to"]],[14,[" (method of ",[0,[2,"editor-stream-in%"]],")"]]],["racket/gui/base","racket/gui"]],
["jump-to",">gui/editor-stream-out_.html#(meth._(((lib._mred/main..rkt)._editor-stream-out~25)._jump-to))",[[0,[2,"jump-to"]],[14,[" (method of ",[0,[2,"editor-stream-out%"]],")"]]],["racket/gui/base","racket/gui"]],
["just-after",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._just-after))",[0,[2,"just-after"]],["redex/pict","redex"]],
["just-before",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._just-before))",[0,[2,"just-before"]],["redex/pict","redex"]],
["just-context",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._just-context))",[0,[2,"just-context"]],["scribble/racket","scribble/scheme"]],
["just-context-context",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._just-context-context))",[0,[2,"just-context-context"]],["scribble/racket","scribble/scheme"]],
["just-context-val",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._just-context-val))",[0,[2,"just-context-val"]],["scribble/racket","scribble/scheme"]],
["just-context?",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._just-context~3f))",[0,[2,"just-context?"]],["scribble/racket","scribble/scheme"]],
["just-in-time",">guide/performance.html#(tech._just._in._time)","<span style=\"font-style: italic\">just-in-time</span>",false],
["kbd",">html/index.html#(def._((lib._html/main..rkt)._kbd))",[0,[2,"kbd"]],["html"]],
["kbd?",">html/index.html#(def._((lib._html/main..rkt)._kbd~3f))",[0,[2,"kbd?"]],["html"]],
["kde",">plot/utils.html#(def._((lib._plot/utils..rkt)._kde))",[0,[2,"kde"]],["plot/utils"]],
["keep-blanks",">readline/index.html#(def._((lib._readline/pread..rkt)._keep-blanks))",[0,[2,"keep-blanks"]],["readline/pread"]],
["keep-duplicates",">readline/index.html#(def._((lib._readline/pread..rkt)._keep-duplicates))",[0,[2,"keep-duplicates"]],["readline/pread"]],
["kernel-form-identifier-list",">syntax/syntax-helpers.html#(def._((lib._syntax/kerncase..rkt)._kernel-form-identifier-list))",[0,[2,"kernel-form-identifier-list"]],["syntax/kerncase"]],
["kernel-literals",">syntax/Library_Syntax_Classes_and_Literal_Sets.html#(form._((lib._syntax/parse..rkt)._kernel-literals))",[0,[1,"kernel-literals"]],["syntax/parse"]],
["kernel-syntax-case",">syntax/syntax-helpers.html#(form._((lib._syntax/kerncase..rkt)._kernel-syntax-case))",[0,[1,"kernel-syntax-case"]],["syntax/kerncase"]],
["kernel-syntax-case*",">syntax/syntax-helpers.html#(form._((lib._syntax/kerncase..rkt)._kernel-syntax-case*))",[0,[1,"kernel-syntax-case*"]],["syntax/kerncase"]],
["kernel-syntax-case*/phase",">syntax/syntax-helpers.html#(form._((lib._syntax/kerncase..rkt)._kernel-syntax-case*/phase))",[0,[1,"kernel-syntax-case*/phase"]],["syntax/kerncase"]],
["kernel-syntax-case/phase",">syntax/syntax-helpers.html#(form._((lib._syntax/kerncase..rkt)._kernel-syntax-case/phase))",[0,[1,"kernel-syntax-case/phase"]],["syntax/kerncase"]],
["key",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._key))",[0,[2,"key"]],["2htdp/planetcute"]],
["key-code-symbol?",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._key-code-symbol~3f))",[0,[2,"key-code-symbol?"]],["racket/gui/base","racket/gui"]],
["key-event%",">gui/key-event_.html",[0,[2,"key-event%"]],["racket/gui/base","racket/gui"]],
["key-event?",">teachpack/2htdpuniverse.html#(def._((lib._2htdp/universe..rkt)._key-event~3f))",[0,[2,"key-event?"]],["2htdp/universe"]],
["key-event?",">teachpack/world.html#(def._((lib._htdp/world..rkt)._key-event~3f))",[0,[2,"key-event?"]],["htdp/world"]],
["key-value",">graphics/Keyboard_Operations.html#(def._((lib._graphics/graphics..rkt)._key-value))",[0,[2,"key-value"]],["graphics/graphics"]],
["key/value storage",">web-server/stateless.html#(part._.Key_.Value_.Storage)","Key/Value Storage",false],
["key=?",">teachpack/2htdpuniverse.html#(def._((lib._2htdp/universe..rkt)._key~3d~3f))",[0,[2,"key=?"]],["2htdp/universe"]],
["key=?",">teachpack/world.html#(def._((lib._htdp/world..rkt)._key~3d~3f))",[0,[2,"key=?"]],["htdp/world"]],
["keybindings",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._154._(lib._scribblings/drracket/drracket..scrbl)))","keybindings",false],
["keybindings menu item",">drracket/Menus.html#(idx._(gentag._87._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Keybindings</span> menu item",false],
["keyboard events overview",">gui/windowing-overview.html#(idx._(gentag._4._(lib._scribblings/gui/gui..scrbl)))","keyboard\n events, overview",false],
["keyboard focus snips",">gui/editor___.html#(idx._(gentag._205._(lib._scribblings/gui/gui..scrbl)))","keyboard focus, snips",false],
["keyboard focus setting",">gui/window___.html#(idx._(gentag._139._(lib._scribblings/gui/gui..scrbl)))","keyboard focus, setting",false],
["keyboard focus overview",">gui/windowing-overview.html#(idx._(gentag._3._(lib._scribblings/gui/gui..scrbl)))","keyboard focus, overview",false],
["keyboard focus notification",">gui/window___.html#(idx._(gentag._141._(lib._scribblings/gui/gui..scrbl)))","keyboard focus, notification",false],
["keyboard focus notification",">gui/editor___.html#(idx._(gentag._207._(lib._scribblings/gui/gui..scrbl)))","keyboard focus, notification",false],
["keyboard focus navigation",">gui/top-level-window___.html#(idx._(gentag._135._(lib._scribblings/gui/gui..scrbl)))","keyboard focus, navigation",false],
["keyboard focus navigation",">gui/canvas___.html#(idx._(gentag._21._(lib._scribblings/gui/gui..scrbl)))","keyboard focus, navigation",false],
["keyboard focus navigation",">gui/editor-canvas_.html#(idx._(gentag._211._(lib._scribblings/gui/gui..scrbl)))","keyboard focus, navigation",false],
["keyboard focus navigation",">gui/windowing-overview.html#(idx._(gentag._8._(lib._scribblings/gui/gui..scrbl)))","keyboard focus, navigation",false],
["keyboard focus last active",">gui/top-level-window___.html#(idx._(gentag._130._(lib._scribblings/gui/gui..scrbl)))","keyboard focus, last active",false],
["keyboard focus last active",">gui/top-level-window___.html#(idx._(gentag._131._(lib._scribblings/gui/gui..scrbl)))","keyboard focus, last active",false],
["keyboard focus",">gui/top-level-window___.html#(idx._(gentag._132._(lib._scribblings/gui/gui..scrbl)))","keyboard focus",false],
["keyboard focus",">gui/top-level-window___.html#(idx._(gentag._133._(lib._scribblings/gui/gui..scrbl)))","keyboard focus",false],
["keyboard focus",">gui/windowing-overview.html#(tech._keyboard._focu)","<span style=\"font-style: italic\">keyboard focus</span>",false],
["keyboard operations",">graphics/Keyboard_Operations.html","Keyboard Operations",false],
["keyboard shortcuts",">drracket/Keyboard_Shortcuts.html","Keyboard Shortcuts",false],
["keyevent",">teachpack/2htdpuniverse.html#(tech._keyevent)","<span style=\"font-style: italic\">KeyEvent</span>",false],
["keyevent",">teachpack/world.html#(tech._keyevent)","<span style=\"font-style: italic\">KeyEvent</span>",false],
["keymap",">framework/Keymap.html","Keymap",false],
["keymap%",">gui/keymap_.html",[0,[2,"keymap%"]],["racket/gui/base","racket/gui"]],
["keymap:add-to-right-button-menu",">framework/Keymap.html#(def._((lib._framework/main..rkt)._keymap~3aadd-to-right-button-menu))",[0,[2,"keymap:add-to-right-button-menu"]],["framework"]],
["keymap:add-to-right-button-menu/before",">framework/Keymap.html#(def._((lib._framework/main..rkt)._keymap~3aadd-to-right-button-menu/before))",[0,[2,"keymap:add-to-right-button-menu/before"]],["framework"]],
["keymap:add-user-keybindings-file",">framework/Keymap.html#(def._((lib._framework/main..rkt)._keymap~3aadd-user-keybindings-file))",[0,[2,"keymap:add-user-keybindings-file"]],["framework"]],
["keymap:aug-keymap%",">framework/Keymap.html#(def._((lib._framework/main..rkt)._keymap~3aaug-keymap~25))",[0,[2,"keymap:aug-keymap%"]],["framework"]],
["keymap:aug-keymap-mixin",">framework/Keymap.html#(def._((lib._framework/main..rkt)._keymap~3aaug-keymap-mixin))",[0,[2,"keymap:aug-keymap-mixin"]],["framework"]],
["keymap:aug-keymap<%>",">framework/Keymap.html#(def._((lib._framework/main..rkt)._keymap~3aaug-keymap~3c~25~3e))",[0,[2,"keymap:aug-keymap<%>"]],["framework"]],
["keymap:call/text-keymap-initializer",">framework/Keymap.html#(def._((lib._framework/main..rkt)._keymap~3acall/text-keymap-initializer))",[0,[2,"keymap:call/text-keymap-initializer"]],["framework"]],
["keymap:canonicalize-keybinding-string",">framework/Keymap.html#(def._((lib._framework/main..rkt)._keymap~3acanonicalize-keybinding-string))",[0,[2,"keymap:canonicalize-keybinding-string"]],["framework"]],
["keymap:get-editor",">framework/Keymap.html#(def._((lib._framework/main..rkt)._keymap~3aget-editor))",[0,[2,"keymap:get-editor"]],["framework"]],
["keymap:get-file",">framework/Keymap.html#(def._((lib._framework/main..rkt)._keymap~3aget-file))",[0,[2,"keymap:get-file"]],["framework"]],
["keymap:get-global",">framework/Keymap.html#(def._((lib._framework/main..rkt)._keymap~3aget-global))",[0,[2,"keymap:get-global"]],["framework"]],
["keymap:get-search",">framework/Keymap.html#(def._((lib._framework/main..rkt)._keymap~3aget-search))",[0,[2,"keymap:get-search"]],["framework"]],
["keymap:get-user",">framework/Keymap.html#(def._((lib._framework/main..rkt)._keymap~3aget-user))",[0,[2,"keymap:get-user"]],["framework"]],
["keymap:make-meta-prefix-list",">framework/Keymap.html#(def._((lib._framework/main..rkt)._keymap~3amake-meta-prefix-list))",[0,[2,"keymap:make-meta-prefix-list"]],["framework"]],
["keymap:region-click",">framework/Keymap.html#(def._((lib._framework/main..rkt)._keymap~3aregion-click))",[0,[2,"keymap:region-click"]],["framework"]],
["keymap:remove-chained-keymap",">framework/Keymap.html#(def._((lib._framework/main..rkt)._keymap~3aremove-chained-keymap))",[0,[2,"keymap:remove-chained-keymap"]],["framework"]],
["keymap:remove-user-keybindings-file",">framework/Keymap.html#(def._((lib._framework/main..rkt)._keymap~3aremove-user-keybindings-file))",[0,[2,"keymap:remove-user-keybindings-file"]],["framework"]],
["keymap:send-map-function-meta",">framework/Keymap.html#(def._((lib._framework/main..rkt)._keymap~3asend-map-function-meta))",[0,[2,"keymap:send-map-function-meta"]],["framework"]],
["keymap:set-chained-keymaps",">framework/Keymap.html#(def._((lib._framework/main..rkt)._keymap~3aset-chained-keymaps))",[0,[2,"keymap:set-chained-keymaps"]],["framework"]],
["keymap:setup-editor",">framework/Keymap.html#(def._((lib._framework/main..rkt)._keymap~3asetup-editor))",[0,[2,"keymap:setup-editor"]],["framework"]],
["keymap:setup-file",">framework/Keymap.html#(def._((lib._framework/main..rkt)._keymap~3asetup-file))",[0,[2,"keymap:setup-file"]],["framework"]],
["keymap:setup-global",">framework/Keymap.html#(def._((lib._framework/main..rkt)._keymap~3asetup-global))",[0,[2,"keymap:setup-global"]],["framework"]],
["keymap:setup-search",">framework/Keymap.html#(def._((lib._framework/main..rkt)._keymap~3asetup-search))",[0,[2,"keymap:setup-search"]],["framework"]],
["keyword",">syntax/Library_Syntax_Classes_and_Literal_Sets.html#(form._((lib._syntax/parse..rkt)._keyword))",[0,[1,"keyword"]],["syntax/parse"]],
["keyword",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Keyword))",[0,[1,"Keyword"]],["typed/racket/base","typed/racket"]],
["keyword",">tools/adding-languages.html#(idx._(gentag._10._(lib._scribblings/tools/tools..scrbl)))",[7,"'keyword"],false],
["keyword",">guide/keywords.html#(tech._keyword)","<span style=\"font-style: italic\">keyword</span>",false],
["keyword",">reference/keywords.html#(tech._keyword)","<span style=\"font-style: italic\">keyword</span>",false],
["keyword arguments",">mzlib/mzlib_kw.html#(part._.Keyword_.Arguments)","Keyword Arguments",false],
["keyword arguments",">guide/contracts-general-functions.html#(part._contracts-keywords)","Keyword Arguments",false],
["keyword arguments",">guide/application.html#(part._keyword-args)","Keyword Arguments",false],
["keyword->string",">reference/keywords.html#(def._((quote._~23~25kernel)._keyword-~3estring))",[0,[2,"keyword->string"]],["racket/base","racket"]],
["keyword-apply",">reference/procedures.html#(def._((lib._racket/private/base..rkt)._keyword-apply))",[0,[2,"keyword-apply"]],["racket/base","racket"]],
["keyword-argument conversion introspection",">reference/stxtrans.html#(part._keyword-trans)","Keyword-Argument Conversion Introspection",false],
["keyword-color",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._keyword-color))",[0,[2,"keyword-color"]],["scribble/racket","scribble/scheme"]],
["keyword-color",">slideshow/Typesetting_Racket_Code.html#(def._((lib._slideshow/code..rkt)._keyword-color))",[0,[2,"keyword-color"]],["slideshow/code"]],
["keyword-get",">mzlib/mzlib_kw.html#(def._((lib._mzlib/kw..rkt)._keyword-get))",[0,[2,"keyword-get"]],["mzlib/kw"]],
["keyword-table",">syntax/syntax-helpers.html#(tech._keyword._table)","<span style=\"font-style: italic\">keyword-table</span>",false],
["keyword<?",">reference/keywords.html#(def._((quote._~23~25kernel)._keyword~3c~3f))",[0,[2,"keyword<?"]],["racket/base","racket"]],
["keyword?",">reference/keywords.html#(def._((quote._~23~25kernel)._keyword~3f))",[0,[2,"keyword?"]],["racket/base","racket"]],
["keywords",">guide/keywords.html","Keywords",false],
["keywords",">reference/keywords.html","Keywords",false],
["keywords",">scribble/SIGPLAN_Paper_Format.html#(def._((lib._scribble/sigplan..rkt)._keywords))",[0,[2,"keywords"]],["scribble/sigplan"]],
["keywords and arity",">reference/procedures.html#(part._.Keywords_and_.Arity)","Keywords and Arity",false],
["kill",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._kill))",[[0,[2,"kill"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["kill",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._kill))",[[0,[2,"kill"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["kill menu item",">drracket/Menus.html#(idx._(gentag._124._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Kill</span> menu item",false],
["kill-connection!",">web-server-internal/connection-manager.html#(def._((lib._web-server/private/connection-manager..rkt)._kill-connection!))",[0,[2,"kill-connection!"]],["web-server/private/connection-manager"]],
["kill-evaluation",">tools/drracket_rep.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3arep~3atext~25)._kill-evaluation))",[[0,[2,"kill-evaluation"]],[14,[" (method of ",[0,[2,"drracket:rep:text%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["kill-evaluator",">reference/Sandboxed_Evaluation.html#(def._((lib._racket/sandbox..rkt)._kill-evaluator))",[0,[2,"kill-evaluator"]],["racket/sandbox"]],
["kill-safe connections",">db/connect.html#(part._kill-safe)","Kill-safe Connections",false],
["kill-safe-connection",">db/connect.html#(def._((lib._db/base..rkt)._kill-safe-connection))",[0,[2,"kill-safe-connection"]],["db","db/base"]],
["kill-thread",">reference/threads.html#(def._((quote._~23~25kernel)._kill-thread))",[0,[2,"kill-thread"]],["racket/base","racket"]],
["kill-word",">framework/Keymap.html#(idx._(gentag._26._(lib._scribblings/framework/framework..scrbl)))","kill-word",false],
["kleeneplus",">scribble/bnf.html#(def._((lib._scribble/bnf..rkt)._kleeneplus))",[0,[2,"kleeneplus"]],["scribble/bnf"]],
["kleenerange",">scribble/bnf.html#(def._((lib._scribble/bnf..rkt)._kleenerange))",[0,[2,"kleenerange"]],["scribble/bnf"]],
["kleenestar",">scribble/bnf.html#(def._((lib._scribble/bnf..rkt)._kleenestar))",[0,[2,"kleenestar"]],["scribble/bnf"]],
["kmp-step",">srfi-std/srfi-13.html#kmp-step",[0,[2,"kmp-step"]],["srfi/13"]],
["known-point-symbols",">plot/contracts.html#(def._((lib._plot/utils..rkt)._known-point-symbols))",[0,[2,"known-point-symbols"]],["plot/utils"]],
["koch snowflake",">turtles/Traditional_Turtles.html#(idx._(gentag._1._(lib._graphics/scribblings/turtles..scrbl)))","Koch snowflake",false],
["koch-draw",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtle-examples..rkt)._koch-draw))",[0,[2,"koch-draw"]],["graphics/turtle-examples"]],
["koch-size",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtle-examples..rkt)._koch-size))",[0,[2,"koch-size"]],["graphics/turtle-examples"]],
["koch-split",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtle-examples..rkt)._koch-split))",[0,[2,"koch-split"]],["graphics/turtle-examples"]],
["konstruktion von prozeduren",">deinprogramm/Konstruktionsanleitungen_1_bis_10.html#(part._.Konstruktion_von_.Prozeduren)","Konstruktion von Prozeduren",false],
["konstruktionsanleitungen 1 bis 10",">deinprogramm/Konstruktionsanleitungen_1_bis_10.html","Konstruktionsanleitungen 1 bis 10",false],
["label",">html/index.html#(def._((lib._html/main..rkt)._label))",[0,[2,"label"]],["html"]],
["label",">unstable/temp-c.html#(form._((lib._unstable/temp-c/dsl..rkt)._label))",[0,[1,"label"]],["unstable/temp-c/dsl"]],
["label phase level",">reference/syntax-model.html#(tech._label._phase._level)","<span style=\"font-style: italic\">label phase level</span>",false],
["label->plain-label",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._label-~3eplain-label))",[0,[2,"label->plain-label"]],["racket/gui/base","racket/gui"]],
["label-alpha",">plot/params.html#(def._((lib._plot/main..rkt)._label-alpha))",[0,[2,"label-alpha"]],["plot"]],
["label-anchor",">plot/params.html#(def._((lib._plot/main..rkt)._label-anchor))",[0,[2,"label-anchor"]],["plot"]],
["label-angle",">plot/params.html#(def._((lib._plot/main..rkt)._label-angle))",[0,[2,"label-angle"]],["plot"]],
["label-font-size",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._label-font-size))",[0,[2,"label-font-size"]],["redex/pict","redex"]],
["label-point-size",">plot/params.html#(def._((lib._plot/main..rkt)._label-point-size))",[0,[2,"label-point-size"]],["plot"]],
["label-space",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._label-space))",[0,[2,"label-space"]],["redex/pict","redex"]],
["label-string?",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._label-string~3f))",[0,[2,"label-string?"]],["racket/gui/base","racket/gui"]],
["label-style",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._label-style))",[0,[2,"label-style"]],["redex/pict","redex"]],
["label?",">html/index.html#(def._((lib._html/main..rkt)._label~3f))",[0,[2,"label?"]],["html"]],
["labelled-menu-item<%>",">gui/labelled-menu-item___.html",[0,[2,"labelled-menu-item<%>"]],["racket/gui/base","racket/gui"]],
["labels/c",">plot/contracts.html#(def._((lib._plot/utils..rkt)._labels/c))",[0,[2,"labels/c"]],["plot/utils"]],
["lam",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._lam))",[0,[2,"lam"]],["compiler/zo-structs"]],
["lam-body",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._lam-body))",[0,[2,"lam-body"]],["compiler/zo-structs"]],
["lam-closure-map",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._lam-closure-map))",[0,[2,"lam-closure-map"]],["compiler/zo-structs"]],
["lam-closure-types",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._lam-closure-types))",[0,[2,"lam-closure-types"]],["compiler/zo-structs"]],
["lam-flags",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._lam-flags))",[0,[2,"lam-flags"]],["compiler/zo-structs"]],
["lam-max-let-depth",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._lam-max-let-depth))",[0,[2,"lam-max-let-depth"]],["compiler/zo-structs"]],
["lam-name",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._lam-name))",[0,[2,"lam-name"]],["compiler/zo-structs"]],
["lam-num-params",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._lam-num-params))",[0,[2,"lam-num-params"]],["compiler/zo-structs"]],
["lam-param-types",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._lam-param-types))",[0,[2,"lam-param-types"]],["compiler/zo-structs"]],
["lam-rest?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._lam-rest~3f))",[0,[2,"lam-rest?"]],["compiler/zo-structs"]],
["lam-toplevel-map",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._lam-toplevel-map))",[0,[2,"lam-toplevel-map"]],["compiler/zo-structs"]],
["lam?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._lam~3f))",[0,[2,"lam?"]],["compiler/zo-structs"]],
["lambda",">deinprogramm/advanced-lambda.html",[0,[1,"lambda"]],false],
["lambda",">deinprogramm/lambda.html",[0,[1,"lambda"]],false],
["lambda",">reference/lambda.html#(form._((lib._racket/private/base..rkt)._lambda))",[0,[1,"lambda"]],["racket/base","racket"]],
["lambda",">r5rs-std/r5rs-Z-H-7.html#%_idx_96",[0,[1,"lambda"]],["r5rs"]],
["lambda",">r6rs-std/r6rs-Z-H-14.html#node_idx_364",[0,[1,"lambda"]],["rnrs/base-6"]],
["lambda",">htdp-langs/advanced.html#(form._((lib._lang/htdp-advanced..rkt)._lambda))",[0,[1,"lambda"]],["lang/htdp-advanced"]],
["lambda",">htdp-langs/beginner.html#(form._((lib._lang/htdp-beginner..rkt)._lambda))",[0,[1,"lambda"]],["lang/htdp-beginner"]],
["lambda",">htdp-langs/beginner-abbr.html#(form._((lib._lang/htdp-beginner-abbr..rkt)._lambda))",[0,[1,"lambda"]],["lang/htdp-beginner-abbr"]],
["lambda",">htdp-langs/intermediate.html#(form._((lib._lang/htdp-intermediate..rkt)._lambda))",[0,[1,"lambda"]],["lang/htdp-intermediate"]],
["lambda",">htdp-langs/intermediate-lam.html#(form._((lib._lang/htdp-intermediate-lambda..rkt)._lambda))",[0,[1,"lambda"]],["lang/htdp-intermediate-lambda"]],
["lambda",">deinprogramm/lambda.html#(form._((lib._deinprogramm/.D.Md.A..rkt)._lambda))",[0,[1,"lambda"]],["deinprogramm/DMdA-beginner"]],
["lambda",">deinprogramm/advanced-lambda.html#(form._((lib._deinprogramm/.D.Md.A-deflam..rkt)._lambda))",[0,[1,"lambda"]],["deinprogramm/DMdA-deflam"]],
["lambda",">lazy/index.html#(form._((lib._lazy/main..rkt)._lambda))",[0,[1,"lambda"]],["lazy"]],
["lambda",">mzscheme/Old_Syntactic_Forms.html#(form._((lib._mzscheme/main..rkt)._lambda))",[0,[1,"lambda"]],["mzscheme"]],
["lambda",">plai/mutator.html#(form._((lib._plai/mutator..rkt)._lambda))",[0,[1,"lambda"]],["plai/mutator"]],
["lambda",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._lambda))",[0,[1,"lambda"]],["typed/racket/base","typed/racket"]],
["lambda-icon",">images/Icons.html#(def._((lib._images/icons/symbol..rkt)._lambda-icon))",[0,[2,"lambda-icon"]],["images/icons/symbol"]],
["lambda/kw",">mzlib/mzlib_kw.html#(form._((lib._mzlib/kw..rkt)._lambda/kw))",[0,[1,"lambda/kw"]],["mzlib/kw"]],
["lambda/page",">web-server/page.html#(form._((lib._web-server/page..rkt)._lambda/page))",[0,[1,"lambda/page"]],["web-server/page"]],
["lambda:",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._lambda~3a))",[0,[1,"lambda:"]],["typed/racket/base","typed/racket"]],
["lang",">reference/runtime.html#(idx._(gentag._339._(lib._scribblings/reference/reference..scrbl)))",[6,"LANG"],false],
["lang/htdp-advanced",">htdp/index.html#(mod-path._lang/htdp-advanced)",[9,[0,"lang/htdp-advanced"]],"module"],
["lang/htdp-beginner",">htdp/index.html#(mod-path._lang/htdp-beginner)",[9,[0,"lang/htdp-beginner"]],"module"],
["lang/htdp-beginner-abbr",">htdp/index.html#(mod-path._lang/htdp-beginner-abbr)",[9,[0,"lang/htdp-beginner-abbr"]],"module"],
["lang/htdp-intermediate",">htdp/index.html#(mod-path._lang/htdp-intermediate)",[9,[0,"lang/htdp-intermediate"]],"module"],
["lang/htdp-intermediate-lambda",">htdp/index.html#(mod-path._lang/htdp-intermediate-lambda)",[9,[0,"lang/htdp-intermediate-lambda"]],"module"],
["lang/htdp-langs-save-file-prefix",">tools/Teaching_Languages.html",[9,[0,"lang/htdp-langs-save-file-prefix"]],"module"],
["lang/imageeq",">htdp/index.html#(mod-path._lang/imageeq)",[9,[0,"lang/imageeq"]],"module"],
["lang/plt-pretty-big",">htdp/index.html#(mod-path._lang/plt-pretty-big)",[9,[0,"lang/plt-pretty-big"]],"module"],
["lang/plt-pretty-big-text",">htdp/index.html#(mod-path._lang/plt-pretty-big-text)",[9,[0,"lang/plt-pretty-big-text"]],"module"],
["lang/posn",">htdp/index.html#(mod-path._lang/posn)",[9,[0,"lang/posn"]],"module"],
["lang/prim",">htdp/index.html#(mod-path._lang/prim)",[9,[0,"lang/prim"]],"module"],
["language",">algol60/index.html#(part._.Language)","Language",false],
["language",">drracket/Menus.html#(part._.Language)","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Language</span>",false],
["language declared in source",">drracket/module.html","Language Declared in Source",false],
["language environment variables",">string-constants/index.html#(part._.Language_.Environment_.Variables)","Language Environment Variables",false],
["language extensions",">tools/adding-languages.html#(part._.Language_.Extensions)","Language Extensions",false],
["language interoperability",">r6rs/Language_Interoperability.html","Language Interoperability",false],
["language levels",">drracket/choose-language.html","language levels",false],
["language model",">reference/model.html","Language Model",false],
["language run-time configuration",">reference/running-sa.html#(part._configure-runtime)","Language Run-Time Configuration",false],
["language->pict",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._language-~3epict))",[0,[2,"language->pict"]],["redex/pict","redex"]],
["language-nts",">redex/The_Redex_Reference.html#(def._((lib._redex/reduction-semantics..rkt)._language-nts))",[0,[2,"language-nts"]],["redex/reduction-semantics","redex"]],
["language-specific capabilities",">tools/Language-specific_capabilities.html","Language-specific capabilities",false],
["languages extending",">drracket/extending-drracket.html#(idx._(gentag._383._(lib._scribblings/drracket/drracket..scrbl)))","languages, extending",false],
["languages",">redex/The_Redex_Reference.html#(part._.Languages)","Languages",false],
["languages",">drracket/languages.html","Languages",false],
["larger",">scribble/base.html#(def._((lib._scribble/base..rkt)._larger))",[0,[2,"larger"]],["scribble/base"]],
["last",">reference/pairs.html#(def._((lib._racket/list..rkt)._last))",[0,[2,"last"]],["racket/list","racket"]],
["last",">srfi-std/srfi-1.html#last",[0,[2,"last"]],["srfi/1"]],
["last-ec",">srfi-std/srfi-42.html#last-ec",[0,[1,"last-ec"]],["srfi/42"]],
["last-line",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._last-line))",[[0,[2,"last-line"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["last-pair",">reference/pairs.html#(def._((lib._racket/list..rkt)._last-pair))",[0,[2,"last-pair"]],["racket/list","racket"]],
["last-pair",">lazy/index.html#(def._((lib._lazy/main..rkt)._last-pair))",[0,[2,"last-pair"]],["lazy"]],
["last-pair",">mzlib/mzlib_list.html#(def._((lib._mzlib/list..rkt)._last-pair))",[0,[2,"last-pair"]],["mzlib/list"]],
["last-pair",">srfi-std/srfi-1.html#last-pair",[0,[2,"last-pair"]],["srfi/1"]],
["last-paragraph",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._last-paragraph))",[[0,[2,"last-paragraph"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["last-position",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._last-position))",[[0,[2,"last-position"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["latex",">slatex-wrap/index.html#(def._((lib._slatex/slatex-wrapper..rkt)._latex))",[0,[2,"latex"]],["slatex/slatex-wrapper"]],
["latex",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._217._(lib._scribblings/drracket/drracket..scrbl)))","LaTeX",false],
["latex and tex inspired keybindings",">drracket/Keyboard_Shortcuts.html#(part._.La.Te.X_and_.Te.X_inspired_keybindings)","LaTeX and TeX inspired keybindings",false],
["latex renderer",">scribble/renderer.html#(part._.Latex_.Renderer)","Latex Renderer",false],
["latex style properties",">scribble/core.html#(part._.Latex_.Style_.Properties)","Latex Style Properties",false],
["latex-auto-extra-files",">scribble/core.html#(def._((lib._scribble/latex-properties..rkt)._latex-auto-extra-files))",[0,[2,"latex-auto-extra-files"]],["scribble/latex-properties"]],
["latex-auto-extra-files-paths",">scribble/core.html#(def._((lib._scribble/latex-properties..rkt)._latex-auto-extra-files-paths))",[0,[2,"latex-auto-extra-files-paths"]],["scribble/latex-properties"]],
["latex-auto-extra-files?",">scribble/core.html#(def._((lib._scribble/latex-properties..rkt)._latex-auto-extra-files~3f))",[0,[2,"latex-auto-extra-files?"]],["scribble/latex-properties"]],
["latex-defaults",">scribble/core.html#(def._((lib._scribble/latex-properties..rkt)._latex-defaults))",[0,[2,"latex-defaults"]],["scribble/latex-properties"]],
["latex-defaults-extra-files",">scribble/core.html#(def._((lib._scribble/latex-properties..rkt)._latex-defaults-extra-files))",[0,[2,"latex-defaults-extra-files"]],["scribble/latex-properties"]],
["latex-defaults-prefix",">scribble/core.html#(def._((lib._scribble/latex-properties..rkt)._latex-defaults-prefix))",[0,[2,"latex-defaults-prefix"]],["scribble/latex-properties"]],
["latex-defaults-style",">scribble/core.html#(def._((lib._scribble/latex-properties..rkt)._latex-defaults-style))",[0,[2,"latex-defaults-style"]],["scribble/latex-properties"]],
["latex-defaults?",">scribble/core.html#(def._((lib._scribble/latex-properties..rkt)._latex-defaults~3f))",[0,[2,"latex-defaults?"]],["scribble/latex-properties"]],
["latin-1-codec",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_590",[0,[2,"latin-1-codec"]],["rnrs/io/ports-6"]],
["launch-many-worlds",">teachpack/2htdpuniverse.html#(form._((lib._2htdp/universe..rkt)._launch-many-worlds))",[0,[1,"launch-many-worlds"]],["2htdp/universe"]],
["launch-many-worlds/proc",">teachpack/2htdpuniverse.html#(def._((lib._2htdp/universe..rkt)._launch-many-worlds/proc))",[0,[2,"launch-many-worlds/proc"]],["2htdp/universe"]],
["launch-place",">reference/distributed-places.html#(meth._(((lib._racket/place/distributed..rkt)._remote-node~25)._launch-place))",[[0,[2,"launch-place"]],[14,[" (method of ",[0,[2,"remote-node%"]],")"]]],["racket/place/distributed"]],
["launcher",">raco/exe.html#(tech._launcher)","<span style=\"font-style: italic\">launcher</span>",false],
["launcher configuration",">raco/exe.html#(part._.Launcher_.Configuration)","Launcher Configuration",false],
["launcher creation signature",">raco/exe.html#(part._.Launcher_.Creation_.Signature)","Launcher Creation Signature",false],
["launcher creation unit",">raco/exe.html#(part._.Launcher_.Creation_.Unit)","Launcher Creation Unit",false],
["launcher executable",">drracket/create-exe.html#(tech._launcher._executable)","<span style=\"font-style: italic\">launcher executable</span>",false],
["launcher path and platform conventions",">raco/exe.html#(part._.Launcher_.Path_and_.Platform_.Conventions)","Launcher Path and Platform Conventions",false],
["launcher/launcher",">raco/exe.html#(mod-path._launcher/launcher)",[9,[0,"launcher/launcher"]],"module"],
["launcher/launcher-sig",">raco/exe.html#(mod-path._launcher/launcher-sig)",[9,[0,"launcher/launcher-sig"]],"module"],
["launcher/launcher-unit",">raco/exe.html#(mod-path._launcher/launcher-unit)",[9,[0,"launcher/launcher-unit"]],"module"],
["launcher@",">raco/exe.html#(def._((lib._launcher/launcher-unit..rkt)._launcher~40))",[0,[2,"launcher@"]],["launcher/launcher-unit"]],
["launcher^",">raco/exe.html#(form._((lib._launcher/launcher-sig..rkt)._launcher~5e))",[0,[1,"launcher^"]],["launcher/launcher-sig"]],
["launching an external browser",">browser/index.html#(part._external)","Launching an External Browser",false],
["launching servers",">web-server-internal/web-server.html","Launching Servers",false],
["launder",">slideshow/Pict_Finders.html#(def._((lib._slideshow/pict..rkt)._launder))",[0,[2,"launder"]],["slideshow/pict","slideshow"]],
["layer roadmap",">scribble/layers.html#(part._.Layer_.Roadmap)","Layer Roadmap",false],
["lazy",">lazy/index.html",[9,[0,"lazy"]],"module"],
["lazy",">reference/Delayed_Evaluation.html#(form._((lib._racket/promise..rkt)._lazy))",[0,[1,"lazy"]],["racket/promise","racket"]],
["lazy",">srfi-std/srfi-45.html#lazy",[0,[1,"lazy"]],["srfi/45"]],
["lazy data-structure contracts",">reference/Lazy_Data-structure_Contracts.html","Lazy Data-structure Contracts",false],
["lazy forms and functions",">lazy/index.html#(part._.Lazy_.Forms_and_.Functions)","Lazy Forms and Functions",false],
["lazy racket",">lazy/index.html","Lazy Racket",false],
["lazy require",">unstable/lazy-require.html","Lazy Require",false],
["lazy-refresh",">gui/editor-canvas_.html#(meth._(((lib._mred/main..rkt)._editor-canvas~25)._lazy-refresh))",[[0,[2,"lazy-refresh"]],[14,[" (method of ",[0,[2,"editor-canvas%"]],")"]]],["racket/gui/base","racket/gui"]],
["lazy-require",">unstable/lazy-require.html#(form._((lib._unstable/lazy-require..rkt)._lazy-require))",[0,[1,"lazy-require"]],["unstable/lazy-require"]],
["lazy/force",">lazy/index.html#(mod-path._lazy/force)",[9,[0,"lazy/force"]],"module"],
["lb-find",">slideshow/Pict_Finders.html#(def._((lib._slideshow/pict..rkt)._lb-find))",[0,[2,"lb-find"]],["slideshow/pict","slideshow"]],
["lb-superimpose",">slideshow/Pict_Combiners.html#(def._((lib._slideshow/pict..rkt)._lb-superimpose))",[0,[2,"lb-superimpose"]],["slideshow/pict","slideshow"]],
["lbl-find",">slideshow/Pict_Finders.html#(def._((lib._slideshow/pict..rkt)._lbl-find))",[0,[2,"lbl-find"]],["slideshow/pict","slideshow"]],
["lbl-superimpose",">slideshow/Pict_Combiners.html#(def._((lib._slideshow/pict..rkt)._lbl-superimpose))",[0,[2,"lbl-superimpose"]],["slideshow/pict","slideshow"]],
["lc-find",">slideshow/Pict_Finders.html#(def._((lib._slideshow/pict..rkt)._lc-find))",[0,[2,"lc-find"]],["slideshow/pict","slideshow"]],
["lc-lang",">redex/The_Redex_Reference.html#(tech._lc._lang)","<span style=\"font-style: italic\"><span class=\"RktSym\">lc-lang</span></span>",false],
["lc-superimpose",">slideshow/Pict_Combiners.html#(def._((lib._slideshow/pict..rkt)._lc-superimpose))",[0,[2,"lc-superimpose"]],["slideshow/pict","slideshow"]],
["lc_all",">reference/runtime.html#(idx._(gentag._337._(lib._scribblings/reference/reference..scrbl)))",[6,"LC_ALL"],false],
["lc_type",">reference/runtime.html#(idx._(gentag._338._(lib._scribblings/reference/reference..scrbl)))",[6,"LC_TYPE"],false],
["lcm",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._lcm))",[0,[2,"lcm"]],["racket/base","racket"]],
["lcm",">r5rs-std/r5rs-Z-H-9.html#%_idx_308",[0,[2,"lcm"]],["r5rs"]],
["lcm",">r6rs-std/r6rs-Z-H-14.html#node_idx_522",[0,[2,"lcm"]],["rnrs/base-6"]],
["lcm",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._lcm))",[0,[2,"lcm"]],["lang/htdp-advanced"]],
["lcm",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._lcm))",[0,[2,"lcm"]],["lang/htdp-beginner"]],
["lcm",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._lcm))",[0,[2,"lcm"]],["lang/htdp-beginner-abbr"]],
["lcm",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._lcm))",[0,[2,"lcm"]],["lang/htdp-intermediate"]],
["lcm",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._lcm))",[0,[2,"lcm"]],["lang/htdp-intermediate-lambda"]],
["lcm",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._lcm))",[0,[2,"lcm"]],["deinprogramm/DMdA-advanced"]],
["lcm",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._lcm))",[0,[2,"lcm"]],["deinprogramm/DMdA-assignments"]],
["lcm",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._lcm))",[0,[2,"lcm"]],["deinprogramm/DMdA-beginner"]],
["lcm",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._lcm))",[0,[2,"lcm"]],["deinprogramm/DMdA-vanilla"]],
["least common multiple",">reference/generic-numbers.html#(idx._(gentag._101._(lib._scribblings/reference/reference..scrbl)))","least common multiple",false],
["least-fixnum",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_860",[0,[2,"least-fixnum"]],["rnrs/arithmetic/fixnums-6"]],
["leaving drracket",">continue/index.html#(part._.Leaving_.Dr.Racket)","Leaving DrRacket",false],
["leaving-page",">browser/index.html#(meth._(((lib._browser/browser..rkt)._hyper-panel-mixin)._leaving-page))",[[0,[2,"leaving-page"]],[14,[" (method of ",[0,[2,"hyper-panel-mixin"]],")"]]],["browser/browser","browser"]],
["leaving?",">gui/mouse-event_.html#(meth._(((lib._mred/main..rkt)._mouse-event~25)._leaving~3f))",[[0,[2,"leaving?"]],[14,[" (method of ",[0,[2,"mouse-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["left",">teachpack/2htdpuniverse.html#(form._((lib._2htdp/universe..rkt)._left))",[0,[1,"left"]],["2htdp/universe"]],
["left",">scriblib/figure.html#(def._((lib._scriblib/figure..rkt)._left))",[0,[2,"left"]],["scriblib/figure"]],
["left",">gui/windowing-overview.html#(idx._(gentag._0._(lib._scribblings/gui/gui..scrbl)))",[7,"'left"],false],
["left",">gui/key-event_.html#(idx._(gentag._52._(lib._scribblings/gui/gui..scrbl)))",[7,"'left"],false],
["left-arrow-icon",">images/Icons.html#(def._((lib._images/icons/arrow..rkt)._left-arrow-icon))",[0,[2,"left-arrow-icon"]],["images/icons/arrow"]],
["left-bomb-icon",">images/Icons.html#(def._((lib._images/icons/misc..rkt)._left-bomb-icon))",[0,[2,"left-bomb-icon"]],["images/icons/misc"]],
["left-magnifying-glass-icon",">images/Icons.html#(def._((lib._images/icons/misc..rkt)._left-magnifying-glass-icon))",[0,[2,"left-magnifying-glass-icon"]],["images/icons/misc"]],
["left-mouse-click?",">graphics/Mouse_Operations.html#(def._((lib._graphics/graphics..rkt)._left-mouse-click~3f))",[0,[2,"left-mouse-click?"]],["graphics/graphics"]],
["left-over-arrow-icon",">images/Icons.html#(def._((lib._images/icons/arrow..rkt)._left-over-arrow-icon))",[0,[2,"left-over-arrow-icon"]],["images/icons/arrow"]],
["left-under-arrow-icon",">images/Icons.html#(def._((lib._images/icons/arrow..rkt)._left-under-arrow-icon))",[0,[2,"left-under-arrow-icon"]],["images/icons/arrow"]],
["legacy contracts",">reference/Legacy_Contracts.html","Legacy Contracts",false],
["legacy forms",">ts-reference/Legacy_Forms.html","Legacy Forms",false],
["legacy languages",">drracket/legacy.html","Legacy Languages",false],
["legacy library",">foreign/Objective-C_FFI.html#(part._.Legacy_.Library)","Legacy Library",false],
["legend",">html/index.html#(def._((lib._html/main..rkt)._legend))",[0,[2,"legend"]],["html"]],
["legend?",">html/index.html#(def._((lib._html/main..rkt)._legend~3f))",[0,[2,"legend?"]],["html"]],
["length",">reference/pairs.html#(def._((quote._~23~25kernel)._length))",[0,[2,"length"]],["racket/base","racket"]],
["length",">r5rs-std/r5rs-Z-H-9.html#%_idx_436",[0,[2,"length"]],["r5rs"]],
["length",">r6rs-std/r6rs-Z-H-14.html#node_idx_632",[0,[2,"length"]],["rnrs/base-6"]],
["length",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._length))",[0,[2,"length"]],["lang/htdp-advanced"]],
["length",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._length))",[0,[2,"length"]],["lang/htdp-beginner"]],
["length",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._length))",[0,[2,"length"]],["lang/htdp-beginner-abbr"]],
["length",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._length))",[0,[2,"length"]],["lang/htdp-intermediate"]],
["length",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._length))",[0,[2,"length"]],["lang/htdp-intermediate-lambda"]],
["length",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._length))",[0,[2,"length"]],["deinprogramm/DMdA-advanced"]],
["length",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._length))",[0,[2,"length"]],["deinprogramm/DMdA-assignments"]],
["length",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._length))",[0,[2,"length"]],["deinprogramm/DMdA-vanilla"]],
["length",">lazy/index.html#(def._((lib._lazy/main..rkt)._length))",[0,[2,"length"]],["lazy"]],
["length",">srfi-std/srfi-1.html#length",[0,[2,"length"]],["srfi/1"]],
["length+",">srfi-std/srfi-1.html#length+",[0,[2,"length+"]],["srfi/1"]],
["lens projection and correction",">images/Spatial_Transformations.html#(part._.Lens_.Projection_and_.Correction)","Lens Projection and Correction",false],
["let",">reference/let.html#(form._((lib._racket/private/letstx-scheme..rkt)._let))",[0,[1,"let"]],["racket/base","racket"]],
["let",">r5rs-std/r5rs-Z-H-7.html#%_idx_126",[0,[1,"let"]],["r5rs"]],
["let",">r6rs-std/r6rs-Z-H-14.html#node_idx_394",[0,[1,"let"]],["rnrs/base-6"]],
["let",">htdp-langs/advanced.html#(form._((lib._lang/htdp-advanced..rkt)._let))",[0,[1,"let"]],["lang/htdp-advanced"]],
["let",">htdp-langs/intermediate.html#(form._((lib._lang/htdp-intermediate..rkt)._let))",[0,[1,"let"]],["lang/htdp-intermediate"]],
["let",">htdp-langs/intermediate-lam.html#(form._((lib._lang/htdp-intermediate-lambda..rkt)._let))",[0,[1,"let"]],["lang/htdp-intermediate-lambda"]],
["let",">deinprogramm/let__letrec_und_let_.html#(form._((lib._deinprogramm/.D.Md.A..rkt)._let))",[0,[1,"let"]],["deinprogramm/DMdA-vanilla"]],
["let",">lazy/index.html#(form._((lib._lazy/main..rkt)._let))",[0,[1,"let"]],["lazy"]],
["let",">plai/mutator.html#(form._((lib._plai/mutator..rkt)._let))",[0,[1,"let"]],["plai/mutator"]],
["let",">srfi-std/srfi-5.html#unnamed",[0,[1,"let"]],["srfi/5"]],
["let*",">reference/let.html#(form._((lib._racket/private/letstx-scheme..rkt)._let*))",[0,[1,"let*"]],["racket/base","racket"]],
["let*",">r5rs-std/r5rs-Z-H-7.html#%_idx_130",[0,[1,"let*"]],["r5rs"]],
["let*",">r6rs-std/r6rs-Z-H-14.html#node_idx_398",[0,[1,"let*"]],["rnrs/base-6"]],
["let*",">htdp-langs/advanced.html#(form._((lib._lang/htdp-advanced..rkt)._let*))",[0,[1,"let*"]],["lang/htdp-advanced"]],
["let*",">htdp-langs/intermediate.html#(form._((lib._lang/htdp-intermediate..rkt)._let*))",[0,[1,"let*"]],["lang/htdp-intermediate"]],
["let*",">htdp-langs/intermediate-lam.html#(form._((lib._lang/htdp-intermediate-lambda..rkt)._let*))",[0,[1,"let*"]],["lang/htdp-intermediate-lambda"]],
["let*",">deinprogramm/let__letrec_und_let_.html#(form._((lib._deinprogramm/.D.Md.A..rkt)._let*))",[0,[1,"let*"]],["deinprogramm/DMdA-vanilla"]],
["let*",">lazy/index.html#(form._((lib._lazy/main..rkt)._let*))",[0,[1,"let*"]],["lazy"]],
["let*",">plai/mutator.html#(form._((lib._plai/mutator..rkt)._let*))",[0,[1,"let*"]],["plai/mutator"]],
["let*-values",">reference/let.html#(form._((quote._~23~25kernel)._let*-values))",[0,[1,"let*-values"]],["racket/base","racket"]],
["let*-values",">r6rs-std/r6rs-Z-H-14.html#node_idx_414",[0,[1,"let*-values"]],["rnrs/base-6"]],
["let*-values",">lazy/index.html#(form._((lib._lazy/main..rkt)._let*-values))",[0,[1,"let*-values"]],["lazy"]],
["let*-values",">srfi-std/srfi-11.html#let*-values",[0,[1,"let*-values"]],["srfi/11"]],
["let*-values/debug",">unstable/Debugging.html#(form._((lib._unstable/debug..rkt)._let*-values/debug))",[0,[1,"let*-values/debug"]],["unstable/debug"]],
["let*-values:",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._let*-values~3a))",[0,[1,"let*-values:"]],["typed/racket/base","typed/racket"]],
["let*/debug",">unstable/Debugging.html#(form._((lib._unstable/debug..rkt)._let*/debug))",[0,[1,"let*/debug"]],["unstable/debug"]],
["let*:",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._let*~3a))",[0,[1,"let*:"]],["typed/racket/base","typed/racket"]],
["let+",">mzlib/mzlib_etc.html#(form._((lib._mzlib/etc..rkt)._let+))",[0,[1,"let+"]],["mzlib/etc"]],
["let, letrec und let*",">deinprogramm/let__letrec_und_let_.html",[[0,[1,"let"]],", ",[0,[1,"letrec"]]," und ",[0,[1,"let*"]]],false],
["let-one",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._let-one))",[0,[2,"let-one"]],["compiler/zo-structs"]],
["let-one-body",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._let-one-body))",[0,[2,"let-one-body"]],["compiler/zo-structs"]],
["let-one-flonum?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._let-one-flonum~3f))",[0,[2,"let-one-flonum?"]],["compiler/zo-structs"]],
["let-one-rhs",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._let-one-rhs))",[0,[2,"let-one-rhs"]],["compiler/zo-structs"]],
["let-one-unused?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._let-one-unused~3f))",[0,[2,"let-one-unused?"]],["compiler/zo-structs"]],
["let-one?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._let-one~3f))",[0,[2,"let-one?"]],["compiler/zo-structs"]],
["let-rec",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._let-rec))",[0,[2,"let-rec"]],["compiler/zo-structs"]],
["let-rec-body",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._let-rec-body))",[0,[2,"let-rec-body"]],["compiler/zo-structs"]],
["let-rec-procs",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._let-rec-procs))",[0,[2,"let-rec-procs"]],["compiler/zo-structs"]],
["let-rec?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._let-rec~3f))",[0,[2,"let-rec?"]],["compiler/zo-structs"]],
["let-string-start+end",">srfi-std/srfi-13.html#let-string-start+end",[0,[2,"let-string-start+end"]],["srfi/13"]],
["let-struct",">mzscheme/Old_Syntactic_Forms.html#(form._((lib._mzscheme/main..rkt)._let-struct))",[0,[1,"let-struct"]],["mzscheme"]],
["let-syntax",">reference/let.html#(form._((lib._racket/private/letstx-scheme..rkt)._let-syntax))",[0,[1,"let-syntax"]],["racket/base","racket"]],
["let-syntax",">r5rs-std/r5rs-Z-H-7.html#%_idx_184",[0,[1,"let-syntax"]],["r5rs"]],
["let-syntax",">r6rs-std/r6rs-Z-H-14.html#node_idx_776",[0,[1,"let-syntax"]],["rnrs/base-6"]],
["let-syntaxes",">reference/let.html#(form._((lib._racket/private/letstx-scheme..rkt)._let-syntaxes))",[0,[1,"let-syntaxes"]],["racket/base","racket"]],
["let-values",">reference/let.html#(form._((quote._~23~25kernel)._let-values))",[0,[1,"let-values"]],["racket/base","racket"]],
["let-values",">r6rs-std/r6rs-Z-H-14.html#node_idx_410",[0,[1,"let-values"]],["rnrs/base-6"]],
["let-values",">lazy/index.html#(form._((lib._lazy/main..rkt)._let-values))",[0,[1,"let-values"]],["lazy"]],
["let-values",">plai/mutator.html#(form._((lib._plai/mutator..rkt)._let-values))",[0,[1,"let-values"]],["plai/mutator"]],
["let-values",">srfi-std/srfi-11.html#let-values",[0,[1,"let-values"]],["srfi/11"]],
["let-values/debug",">unstable/Debugging.html#(form._((lib._unstable/debug..rkt)._let-values/debug))",[0,[1,"let-values/debug"]],["unstable/debug"]],
["let-values:",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._let-values~3a))",[0,[1,"let-values:"]],["typed/racket/base","typed/racket"]],
["let-void",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._let-void))",[0,[2,"let-void"]],["compiler/zo-structs"]],
["let-void-body",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._let-void-body))",[0,[2,"let-void-body"]],["compiler/zo-structs"]],
["let-void-boxes?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._let-void-boxes~3f))",[0,[2,"let-void-boxes?"]],["compiler/zo-structs"]],
["let-void-count",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._let-void-count))",[0,[2,"let-void-count"]],["compiler/zo-structs"]],
["let-void?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._let-void~3f))",[0,[2,"let-void?"]],["compiler/zo-structs"]],
["let/cc",">reference/cont.html#(form._((lib._racket/private/more-scheme..rkt)._let/cc))",[0,[1,"let/cc"]],["racket/base","racket"]],
["let/cc:",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._let/cc~3a))",[0,[1,"let/cc:"]],["typed/racket/base","typed/racket"]],
["let/debug",">unstable/Debugging.html#(form._((lib._unstable/debug..rkt)._let/debug))",[0,[1,"let/debug"]],["unstable/debug"]],
["let/ec",">reference/cont.html#(form._((lib._racket/private/letstx-scheme..rkt)._let/ec))",[0,[1,"let/ec"]],["racket/base","racket"]],
["let/ec:",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._let/ec~3a))",[0,[1,"let/ec:"]],["typed/racket/base","typed/racket"]],
["let:",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._let~3a))",[0,[1,"let:"]],["typed/racket/base","typed/racket"]],
["letrec",">reference/let.html#(form._((lib._racket/private/letstx-scheme..rkt)._letrec))",[0,[1,"letrec"]],["racket/base","racket"]],
["letrec",">r5rs-std/r5rs-Z-H-7.html#%_idx_134",[0,[1,"letrec"]],["r5rs"]],
["letrec",">r6rs-std/r6rs-Z-H-14.html#node_idx_402",[0,[1,"letrec"]],["rnrs/base-6"]],
["letrec",">htdp-langs/advanced.html#(form._((lib._lang/htdp-advanced..rkt)._letrec))",[0,[1,"letrec"]],["lang/htdp-advanced"]],
["letrec",">htdp-langs/intermediate.html#(form._((lib._lang/htdp-intermediate..rkt)._letrec))",[0,[1,"letrec"]],["lang/htdp-intermediate"]],
["letrec",">htdp-langs/intermediate-lam.html#(form._((lib._lang/htdp-intermediate-lambda..rkt)._letrec))",[0,[1,"letrec"]],["lang/htdp-intermediate-lambda"]],
["letrec",">deinprogramm/let__letrec_und_let_.html#(form._((lib._deinprogramm/.D.Md.A..rkt)._letrec))",[0,[1,"letrec"]],["deinprogramm/DMdA-vanilla"]],
["letrec",">lazy/index.html#(form._((lib._lazy/main..rkt)._letrec))",[0,[1,"letrec"]],["lazy"]],
["letrec performance",">guide/performance.html#(part._letrec-performance)",[[0,[1,"letrec"]]," Performance"],false],
["letrec*",">r6rs-std/r6rs-Z-H-14.html#node_idx_406",[0,[1,"letrec*"]],["rnrs/base-6"]],
["letrec-syntax",">reference/let.html#(form._((lib._racket/private/letstx-scheme..rkt)._letrec-syntax))",[0,[1,"letrec-syntax"]],["racket/base","racket"]],
["letrec-syntax",">r5rs-std/r5rs-Z-H-7.html#%_idx_186",[0,[1,"letrec-syntax"]],["r5rs"]],
["letrec-syntax",">r6rs-std/r6rs-Z-H-14.html#node_idx_782",[0,[1,"letrec-syntax"]],["rnrs/base-6"]],
["letrec-syntaxes",">reference/let.html#(form._((lib._racket/private/letstx-scheme..rkt)._letrec-syntaxes))",[0,[1,"letrec-syntaxes"]],["racket/base","racket"]],
["letrec-syntaxes+values",">reference/let.html#(form._((quote._~23~25kernel)._letrec-syntaxes+values))",[0,[1,"letrec-syntaxes+values"]],["racket/base","racket"]],
["letrec-values",">reference/let.html#(form._((quote._~23~25kernel)._letrec-values))",[0,[1,"letrec-values"]],["racket/base","racket"]],
["letrec-values",">lazy/index.html#(form._((lib._lazy/main..rkt)._letrec-values))",[0,[1,"letrec-values"]],["lazy"]],
["letrec-values/debug",">unstable/Debugging.html#(form._((lib._unstable/debug..rkt)._letrec-values/debug))",[0,[1,"letrec-values/debug"]],["unstable/debug"]],
["letrec-values:",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._letrec-values~3a))",[0,[1,"letrec-values:"]],["typed/racket/base","typed/racket"]],
["letrec/debug",">unstable/Debugging.html#(form._((lib._unstable/debug..rkt)._letrec/debug))",[0,[1,"letrec/debug"]],["unstable/debug"]],
["letrec:",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._letrec~3a))",[0,[1,"letrec:"]],["typed/racket/base","typed/racket"]],
["lex",">parser-tools/Lexers.html","lex",false],
["lexeme",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex..rkt)._lexeme))",[0,[1,"lexeme"]],["parser-tools/lex"]],
["lexer",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex..rkt)._lexer))",[0,[1,"lexer"]],["parser-tools/lex"]],
["lexer abbreviation",">parser-tools/Lexers.html#(tech._lexer._abbreviation)","<span style=\"font-style: italic\">lexer abbreviation</span>",false],
["lexer abbreviations and macros",">parser-tools/Lexers.html#(part._.Lexer_.Abbreviations_and_.Macros)","Lexer Abbreviations and Macros",false],
["lexer legacy operators",">parser-tools/Lexers.html#(part._.Lexer_.Legacy_.Operators)","Lexer Legacy Operators",false],
["lexer macro",">parser-tools/Lexers.html#(tech._lexer._macro)","<span style=\"font-style: italic\">lexer macro</span>",false],
["lexer sre operators",">parser-tools/Lexers.html#(part._.Lexer_.S.R.E_.Operators)","Lexer SRE Operators",false],
["lexer-src-pos",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex..rkt)._lexer-src-pos))",[0,[1,"lexer-src-pos"]],["parser-tools/lex"]],
["lexers",">parser-tools/Lexers.html","Lexers",false],
["lexical",">reference/stxcmp.html#(idx._(gentag._171._(lib._scribblings/reference/reference..scrbl)))",[7,"'lexical"],false],
["lexical information",">reference/syntax-model.html#(tech._lexical._information)","<span style=\"font-style: italic\">lexical information</span>",false],
["lexical scope",">guide/pattern-macros.html#(part._.Lexical_.Scope)","Lexical Scope",false],
["lexical scope",">quick/index.html#(part._.Lexical_.Scope)","Lexical Scope",false],
["lexical scoping",">racklog/racket-w-logic.html#(part._lexical-scoping)","Lexical Scoping",false],
["lexical scoping",">reference/eval-model.html#(tech._lexical._scoping)","<span style=\"font-style: italic\">lexical scoping</span>",false],
["lexical-rename",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._lexical-rename))",[0,[2,"lexical-rename"]],["compiler/zo-structs"]],
["lexical-rename-alist",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._lexical-rename-alist))",[0,[2,"lexical-rename-alist"]],["compiler/zo-structs"]],
["lexical-rename-bool2",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._lexical-rename-bool2))",[0,[2,"lexical-rename-bool2"]],["compiler/zo-structs"]],
["lexical-rename-has-free-id-info?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._lexical-rename-has-free-id-info~3f))",[0,[2,"lexical-rename-has-free-id-info?"]],["compiler/zo-structs"]],
["lexical-rename?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._lexical-rename~3f))",[0,[2,"lexical-rename?"]],["compiler/zo-structs"]],
["lexical-violation?",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_476",[0,[2,"lexical-violation?"]],["rnrs/conditions-6"]],
["li",">html/index.html#(def._((lib._html/main..rkt)._li))",[0,[2,"li"]],["html"]],
["li?",">html/index.html#(def._((lib._html/main..rkt)._li~3f))",[0,[2,"li?"]],["html"]],
["lib",">reference/require.html#(form._((lib._racket/private/base..rkt)._lib))",[0,[1,"lib"]],["racket/base","racket"]],
["lib-dir",">config/index.html#(def._((lib._config/main..rkt)._lib-dir))",[0,[2,"lib-dir"]],["config"]],
["lib-search-dirs",">config/index.html#(def._((lib._config/main..rkt)._lib-search-dirs))",[0,[2,"lib-search-dirs"]],["config"]],
["liberal expansion",">reference/stxtrans.html#(tech._liberal._expansion)","<span style=\"font-style: italic\">liberal expansion</span>",false],
["liberal-define-context?",">reference/stxtrans.html#(def._((quote._~23~25kernel)._liberal-define-context~3f))",[0,[2,"liberal-define-context?"]],["racket/base","racket"]],
["libraries",">swindle/index.html#(part._.Libraries)","Libraries",false],
["libraries and collections",">r6rs/libpaths.html","Libraries and Collections",false],
["libraries and collections",">reference/collects.html","Libraries and Collections",false],
["libraries provided with typed racket",">ts-reference/Libraries_Provided_With_Typed_Racket.html","Libraries Provided With Typed Racket",false],
["libraries, c types, and objects",">foreign/intro.html#(part._.Libraries__.C_.Types__and_.Objects)","Libraries, C Types, and Objects",false],
["library",">reference/collects.html#(tech._library)","<span style=\"font-style: italic\">library</span>",false],
["library collections",">guide/module-basics.html#(part._.Library_.Collections)","Library Collections",false],
["library extensions",">reference/match.html#(part._.Library_.Extensions)","Library Extensions",false],
["library syntax classes and literal sets",">syntax/Library_Syntax_Classes_and_Literal_Sets.html","Library Syntax Classes and Literal Sets",false],
["library-vicinity",">srfi-std/srfi-59.html#library-vicinity",[0,[2,"library-vicinity"]],["srfi/59"]],
["license",">license/index.html","License",false],
["license issues",">readline/index.html#(part._readline-license)","License Issues",false],
["license issues",">xrepl/index.html#(part._.License_.Issues)","License Issues",false],
["lift-above-baseline",">slideshow/Bounding_Box_Adjusters.html#(def._((lib._slideshow/pict..rkt)._lift-above-baseline))",[0,[2,"lift-above-baseline"]],["slideshow/pict","slideshow"]],
["lift-strict",">frtime/index.html#(def._((lib._frtime/main..rkt)._lift-strict))",[0,[2,"lift-strict"]],["frtime"]],
["lifting procedures",">web-server-internal/dispatch-lift.html","Lifting Procedures",false],
["light",">unstable/pict.html#(def._((lib._unstable/gui/pict..rkt)._light))",[0,[2,"light"]],["unstable/gui/pict"]],
["light",">gui/style-delta_.html#(idx._(gentag._191._(lib._scribblings/gui/gui..scrbl)))",[7,"'light"],false],
["light",">draw/font_.html#(idx._(gentag._40._(lib._scribblings/draw/draw..scrbl)))",[7,"'light"],false],
["light-brush-color",">redex/The_Redex_Reference.html#(def._((lib._redex/gui..rkt)._light-brush-color))",[0,[2,"light-brush-color"]],["redex/gui","redex"]],
["light-metal-icon-color",">images/Icons.html#(def._((lib._images/icons/style..rkt)._light-metal-icon-color))",[0,[2,"light-metal-icon-color"]],["images/icons/style"]],
["light-pen-color",">redex/The_Redex_Reference.html#(def._((lib._redex/gui..rkt)._light-pen-color))",[0,[2,"light-pen-color"]],["redex/gui","redex"]],
["light-text-color",">redex/The_Redex_Reference.html#(def._((lib._redex/gui..rkt)._light-text-color))",[0,[2,"light-text-color"]],["redex/gui","redex"]],
["lights out --- logic game",">games/lights-out.html",[[15,"<img src=\"lights-out.png\" alt=\"\" />"]," ","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Lights Out</span>"," ","&#8212;","<wbr></wbr>"," Logic Game"],false],
["limit memory... menu item",">drracket/Menus.html#(idx._(gentag._125._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Limit Memory...</span> menu item",false],
["limiting memory use",">more/index.html#(part._.Limiting_.Memory_.Use)","Limiting Memory Use",false],
["limiting requests",">web-server-internal/limit.html","Limiting Requests",false],
["limiting scope: define-package, open-package, ...",">reference/package.html",["Limiting Scope: ",[0,[1,"define-package"]],", ",[0,[1,"open-package"]],", ..."],false],
["line",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._line))",[0,[2,"line"]],["2htdp/image"]],
["line",">teachpack/image.html#(def._((lib._htdp/image..rkt)._line))",[0,[2,"line"]],["htdp/image"]],
["line",">plot/porting.html#(def._((lib._plot/main..rkt)._line))",[0,[2,"line"]],["plot"]],
["line",">plot/compat.html#(def._((lib._plot/compat..rkt)._line))",[0,[2,"line"]],["plot/compat"]],
["line",">deinprogramm/image.html#(def._((lib._deinprogramm/image..rkt)._line))",[0,[2,"line"]],["teachpack/deinprogramm/image"]],
["line",">reference/port-buffers.html#(idx._(gentag._196._(lib._scribblings/reference/reference..scrbl)))",[7,"'line"],false],
["line",">gui/editor-wordbreak-map_.html#(idx._(gentag._213._(lib._scribblings/gui/gui..scrbl)))",[7,"'line"],false],
["line locations",">reference/linecol.html#(tech._line._location)","<span style=\"font-style: italic\">line locations</span>",false],
["line numbers",">reference/linecol.html","line numbers",false],
["line-alpha",">plot/params.html#(def._((lib._plot/main..rkt)._line-alpha))",[0,[2,"line-alpha"]],["plot"]],
["line-color",">plot/params.html#(def._((lib._plot/main..rkt)._line-color))",[0,[2,"line-color"]],["plot"]],
["line-end-position",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._line-end-position))",[[0,[2,"line-end-position"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["line-length",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._line-length))",[[0,[2,"line-length"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["line-location",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._line-location))",[[0,[2,"line-location"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["line-output hook",">reference/pretty-print.html#(part._.Line-.Output_.Hook)","Line-Output Hook",false],
["line-paragraph",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._line-paragraph))",[[0,[2,"line-paragraph"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["line-samples",">plot/params.html#(def._((lib._plot/main..rkt)._line-samples))",[0,[2,"line-samples"]],["plot"]],
["line-start-position",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._line-start-position))",[[0,[2,"line-start-position"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["line-string",">db/util.html#(def._((lib._db/util/geometry..rkt)._line-string))",[0,[2,"line-string"]],["db/util/geometry"]],
["line-string-points",">db/util.html#(def._((lib._db/util/geometry..rkt)._line-string-points))",[0,[2,"line-string-points"]],["db/util/geometry"]],
["line-string?",">db/util.html#(def._((lib._db/util/geometry..rkt)._line-string~3f))",[0,[2,"line-string?"]],["db/util/geometry"]],
["line-style",">plot/params.html#(def._((lib._plot/main..rkt)._line-style))",[0,[2,"line-style"]],["plot"]],
["line-to",">draw/dc-path_.html#(meth._(((lib._racket/draw..rkt)._dc-path~25)._line-to))",[[0,[2,"line-to"]],[14,[" (method of ",[0,[2,"dc-path%"]],")"]]],["racket/draw"]],
["line-width",">plot/params.html#(def._((lib._plot/main..rkt)._line-width))",[0,[2,"line-width"]],["plot"]],
["line3d",">deinprogramm/line3d.html#(def._((lib._teachpack/deinprogramm/line3d..rkt)._line3d))",[0,"line3d"],["teachpack/deinprogramm/line3d"]],
["line3d-a",">deinprogramm/line3d.html#(def._((lib._teachpack/deinprogramm/line3d..rkt)._line3d-a))",[0,[2,"line3d-a"]],["teachpack/deinprogramm/line3d"]],
["line3d-b",">deinprogramm/line3d.html#(def._((lib._teachpack/deinprogramm/line3d..rkt)._line3d-b))",[0,[2,"line3d-b"]],["teachpack/deinprogramm/line3d"]],
["line3d-color",">deinprogramm/line3d.html#(def._((lib._teachpack/deinprogramm/line3d..rkt)._line3d-color))",[0,[2,"line3d-color"]],["teachpack/deinprogramm/line3d"]],
["line3d-teachpack",">deinprogramm/line3d.html#(idx._(gentag._6._(lib._deinprogramm/scribblings/deinprogramm..scrbl)))","line3d-Teachpack",false],
["line?",">db/util.html#(def._((lib._db/util/geometry..rkt)._line~3f))",[0,[2,"line?"]],["db/util/geometry"]],
["linear gradient",">draw/linear-gradient_.html#(tech._linear._gradient)","<span style=\"font-style: italic\">linear gradient</span>",false],
["linear ticks",">plot/ticks_and_transforms.html#(part._.Linear_.Ticks)","Linear Ticks",false],
["linear-gradient%",">draw/linear-gradient_.html",[0,[2,"linear-gradient%"]],["racket/draw"]],
["linear-projection",">images/Spatial_Transformations.html#(def._((lib._images/flomap..rkt)._linear-projection))",[0,[2,"linear-projection"]],["images/flomap"]],
["linear-ring?",">db/util.html#(def._((lib._db/util/geometry..rkt)._linear-ring~3f))",[0,[2,"linear-ring?"]],["db/util/geometry"]],
["linear-scale",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._linear-scale))",[0,[2,"linear-scale"]],["plot"]],
["linear-seq",">plot/utils.html#(def._((lib._plot/utils..rkt)._linear-seq))",[0,[2,"linear-seq"]],["plot/utils"]],
["linear-seq*",">plot/utils.html#(def._((lib._plot/utils..rkt)._linear-seq*))",[0,[2,"linear-seq*"]],["plot/utils"]],
["linear-ticks",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._linear-ticks))",[0,[2,"linear-ticks"]],["plot"]],
["linear-ticks-format",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._linear-ticks-format))",[0,[2,"linear-ticks-format"]],["plot"]],
["linear-ticks-layout",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._linear-ticks-layout))",[0,[2,"linear-ticks-layout"]],["plot"]],
["linebreak",">scribble/base.html#(def._((lib._scribble/base..rkt)._linebreak))",[0,[2,"linebreak"]],["scribble/base"]],
["linebreaks",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._linebreaks))",[0,[2,"linebreaks"]],["redex/pict","redex"]],
["linefeed",">reference/Byte_and_String_Input.html#(idx._(gentag._213._(lib._scribblings/reference/reference..scrbl)))",[7,"'linefeed"],false],
["lines",">graphics/Draw__Clear__and_Flip_Operations.html#(part._.Lines)","Lines",false],
["lines",">plot/params.html#(part._.Lines)","Lines",false],
["lines",">draw/dc-path_.html#(meth._(((lib._racket/draw..rkt)._dc-path~25)._lines))",[[0,[2,"lines"]],[14,[" (method of ",[0,[2,"dc-path%"]],")"]]],["racket/draw"]],
["lines",">plot/renderer2d.html#(def._((lib._plot/main..rkt)._lines))",[0,[2,"lines"]],["plot"]],
["lines and simple shapes",">draw/overview.html#(part._.Lines_and_.Simple_.Shapes)","Lines and Simple Shapes",false],
["lines with labels",">unstable/pict.html#(part._.Lines_with_.Labels)","Lines with Labels",false],
["lines-interval",">plot/renderer2d.html#(def._((lib._plot/main..rkt)._lines-interval))",[0,[2,"lines-interval"]],["plot"]],
["lines3d",">plot/renderer3d.html#(def._((lib._plot/main..rkt)._lines3d))",[0,[2,"lines3d"]],["plot"]],
["linestyle",">slideshow/Pict_Drawing_Adjusters.html#(def._((lib._slideshow/pict..rkt)._linestyle))",[0,[2,"linestyle"]],["slideshow/pict","slideshow"]],
["linewidth",">slideshow/Pict_Drawing_Adjusters.html#(def._((lib._slideshow/pict..rkt)._linewidth))",[0,[2,"linewidth"]],["slideshow/pict","slideshow"]],
["link",">planet/cmdline.html#(part._link)",[6,"link"],false],
["link",">reference/creatingunits.html#(form._((lib._mzlib/unit..rkt)._link))",[0,[1,"link"]],["racket/unit","racket"]],
["link",">scribble/section-links.html#(def._((lib._scribble/manual..rkt)._link))",[0,[2,"link"]],["scribble/manual"]],
["link",">reference/runtime.html#(idx._(gentag._330._(lib._scribblings/reference/reference..scrbl)))",[7,"'link"],false],
["link",">guide/Linking_Units.html#(tech._link)","<span style=\"font-style: italic\">link</span>",false],
["link-element",">scribble/core.html#(def._((lib._scribble/core..rkt)._link-element))",[0,[2,"link-element"]],["scribble/core"]],
["link-element-tag",">scribble/core.html#(def._((lib._scribble/core..rkt)._link-element-tag))",[0,[2,"link-element-tag"]],["scribble/core"]],
["link-element?",">scribble/core.html#(def._((lib._scribble/core..rkt)._link-element~3f))",[0,[2,"link-element?"]],["scribble/core"]],
["link-exists?",">reference/Filesystem.html#(def._((quote._~23~25kernel)._link-exists~3f))",[0,[2,"link-exists?"]],["racket/base","racket"]],
["link-extension",">dynext/Linking.html#(def._((lib._dynext/link..rkt)._link-extension))",[0,[2,"link-extension"]],["dynext/link"]],
["link-variant",">dynext/Linking.html#(def._((lib._dynext/link..rkt)._link-variant))",[0,[2,"link-variant"]],["dynext/link"]],
["linkage-file",">planet/Utility_Libraries.html#(def._((lib._planet/config..rkt)._.L.I.N.K.A.G.E-.F.I.L.E))",[0,[2,"LINKAGE-FILE"]],["planet/config"]],
["linked",">reference/mzlib_unit.html#(tech._linked)","<span style=\"font-style: italic\">linked</span>",false],
["linking",">dynext/Linking.html","Linking",false],
["linking parameters",">dynext/Linking.html#(part._link-params)","Linking Parameters",false],
["linking units",">guide/Linking_Units.html","Linking Units",false],
["linking units and creating compound units",">reference/compoundunits.html","Linking Units and Creating Compound Units",false],
["links",">scribble/base.html#(part._base-links)","Links",false],
["links",">scribble/section-links.html","Links",false],
["links",">raco/link.html#(def._((lib._setup/link..rkt)._links))",[0,"links"],["setup/link"]],
["links-file",">reference/Filesystem.html#(idx._(gentag._278._(lib._scribblings/reference/reference..scrbl)))",[7,"'links-file"],false],
["list",">reference/pairs.html#(def._((quote._~23~25kernel)._list))",[0,[2,"list"]],["racket/base","racket"]],
["list",">r5rs-std/r5rs-Z-H-9.html#%_idx_434",[0,[2,"list"]],["r5rs"]],
["list",">r6rs-std/r6rs-Z-H-14.html#node_idx_630",[0,[2,"list"]],["rnrs/base-6"]],
["list",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._list))",[0,[2,"list"]],["lang/htdp-advanced"]],
["list",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._list))",[0,[2,"list"]],["lang/htdp-beginner"]],
["list",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._list))",[0,[2,"list"]],["lang/htdp-beginner-abbr"]],
["list",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._list))",[0,[2,"list"]],["lang/htdp-intermediate"]],
["list",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._list))",[0,[2,"list"]],["lang/htdp-intermediate-lambda"]],
["list",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._list))",[0,[2,"list"]],["deinprogramm/DMdA-advanced"]],
["list",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._list))",[0,[2,"list"]],["deinprogramm/DMdA-assignments"]],
["list",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._list))",[0,[2,"list"]],["deinprogramm/DMdA-vanilla"]],
["list",">lazy/index.html#(def._((lib._lazy/main..rkt)._list))",[0,[2,"list"]],["lazy"]],
["list",">srfi-std/srfi-1.html#list",[0,[2,"list"]],["srfi/1"]],
["list",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types-extra..rkt)._.List))",[0,[1,"List"]],["typed/racket/base","typed/racket"]],
["list",">guide/pairs.html#(tech._list)","<span style=\"font-style: italic\">list</span>",false],
["list",">reference/pairs.html#(tech._list)","<span style=\"font-style: italic\">list</span>",false],
["list box",">gui/windowing-overview.html#(tech._list._box)","<span style=\"font-style: italic\">list box</span>",false],
["list filtering",">reference/pairs.html#(part._.List_.Filtering)","List Filtering",false],
["list iteration",">reference/pairs.html#(part._.List_.Iteration)","List Iteration",false],
["list iteration from scratch",">guide/Lists__Iteration__and_Recursion.html#(part._.List_.Iteration_from_.Scratch)","List Iteration from Scratch",false],
["list operations",">reference/pairs.html#(part._.List_.Operations)","List Operations",false],
["list patterns",">syntax/stxparse-patterns.html#(tech._list._pattern)","<span style=\"font-style: italic\">list patterns</span>",false],
["list predicates",">racklog/glossary.html#(part._.List_.Predicates)","List Predicates",false],
["list searching",">reference/pairs.html#(part._.List_.Searching)","List Searching",false],
["list*",">reference/pairs.html#(def._((quote._~23~25kernel)._list*))",[0,[2,"list*"]],["racket/base","racket"]],
["list*",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._list*))",[0,[2,"list*"]],["lang/htdp-advanced"]],
["list*",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._list*))",[0,[2,"list*"]],["lang/htdp-beginner"]],
["list*",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._list*))",[0,[2,"list*"]],["lang/htdp-beginner-abbr"]],
["list*",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._list*))",[0,[2,"list*"]],["lang/htdp-intermediate"]],
["list*",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._list*))",[0,[2,"list*"]],["lang/htdp-intermediate-lambda"]],
["list*",">lazy/index.html#(def._((lib._lazy/main..rkt)._list*))",[0,[2,"list*"]],["lazy"]],
["list*",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types-extra..rkt)._.List*))",[0,[1,"List*"]],["typed/racket/base","typed/racket"]],
["list->bytes",">reference/bytestrings.html#(def._((quote._~23~25kernel)._list-~3ebytes))",[0,[2,"list->bytes"]],["racket/base","racket"]],
["list->cblock",">foreign/Miscellaneous_Support.html#(def._((lib._ffi/unsafe..rkt)._list-~3ecblock))",[0,[2,"list->cblock"]],["ffi/unsafe"]],
["list->char-set",">srfi-std/srfi-14.html#list->char-set",[0,[2,"list->char-set"]],["srfi/14"]],
["list->char-set!",">srfi-std/srfi-14.html#list->char-set!",[0,[2,"list->char-set!"]],["srfi/14"]],
["list->cvector",">foreign/foreign_cvector.html#(def._((lib._ffi/unsafe/cvector..rkt)._list-~3ecvector))",[0,[2,"list->cvector"]],["ffi/cvector","ffi/unsafe/cvector"]],
["list->f32vector",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._list-~3ef32vector))",[0,[2,"list->f32vector"]],["ffi/vector"]],
["list->f64vector",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._list-~3ef64vector))",[0,[2,"list->f64vector"]],["ffi/vector"]],
["list->gl-boolean-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._list-~3egl-boolean-vector))",[0,[2,"list->gl-boolean-vector"]],["sgl/gl-vectors"]],
["list->gl-byte-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._list-~3egl-byte-vector))",[0,[2,"list->gl-byte-vector"]],["sgl/gl-vectors"]],
["list->gl-double-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._list-~3egl-double-vector))",[0,[2,"list->gl-double-vector"]],["sgl/gl-vectors"]],
["list->gl-float-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._list-~3egl-float-vector))",[0,[2,"list->gl-float-vector"]],["sgl/gl-vectors"]],
["list->gl-int-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._list-~3egl-int-vector))",[0,[2,"list->gl-int-vector"]],["sgl/gl-vectors"]],
["list->gl-short-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._list-~3egl-short-vector))",[0,[2,"list->gl-short-vector"]],["sgl/gl-vectors"]],
["list->gl-ubyte-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._list-~3egl-ubyte-vector))",[0,[2,"list->gl-ubyte-vector"]],["sgl/gl-vectors"]],
["list->gl-uint-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._list-~3egl-uint-vector))",[0,[2,"list->gl-uint-vector"]],["sgl/gl-vectors"]],
["list->gl-ushort-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._list-~3egl-ushort-vector))",[0,[2,"list->gl-ushort-vector"]],["sgl/gl-vectors"]],
["list->mlist",">reference/mpairs.html#(def._((lib._racket/mpair..rkt)._list-~3emlist))",[0,[2,"list->mlist"]],["racket/mpair"]],
["list->pg-array",">db/util.html#(def._((lib._db/util/postgresql..rkt)._list-~3epg-array))",[0,[2,"list->pg-array"]],["db/util/postgresql"]],
["list->s16vector",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._list-~3es16vector))",[0,[2,"list->s16vector"]],["ffi/vector"]],
["list->s32vector",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._list-~3es32vector))",[0,[2,"list->s32vector"]],["ffi/vector"]],
["list->s64vector",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._list-~3es64vector))",[0,[2,"list->s64vector"]],["ffi/vector"]],
["list->s8vector",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._list-~3es8vector))",[0,[2,"list->s8vector"]],["ffi/vector"]],
["list->set",">reference/sets.html#(def._((lib._racket/set..rkt)._list-~3eset))",[0,[2,"list->set"]],["racket/set","racket"]],
["list->seteq",">reference/sets.html#(def._((lib._racket/set..rkt)._list-~3eseteq))",[0,[2,"list->seteq"]],["racket/set","racket"]],
["list->seteqv",">reference/sets.html#(def._((lib._racket/set..rkt)._list-~3eseteqv))",[0,[2,"list->seteqv"]],["racket/set","racket"]],
["list->sql-bits",">db/sql-types.html#(def._((lib._db/base..rkt)._list-~3esql-bits))",[0,[2,"list->sql-bits"]],["db","db/base"]],
["list->stream",">srfi-std/srfi-41/srfi-41.html#list-to-stream",[0,[2,"list->stream"]],["srfi/41"]],
["list->string",">reference/strings.html#(def._((quote._~23~25kernel)._list-~3estring))",[0,[2,"list->string"]],["racket/base","racket"]],
["list->string",">r5rs-std/r5rs-Z-H-9.html#%_idx_548",[0,[2,"list->string"]],["r5rs"]],
["list->string",">r6rs-std/r6rs-Z-H-14.html#node_idx_714",[0,[2,"list->string"]],["rnrs/base-6"]],
["list->string",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._list-~3estring))",[0,[2,"list->string"]],["lang/htdp-advanced"]],
["list->string",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._list-~3estring))",[0,[2,"list->string"]],["lang/htdp-beginner"]],
["list->string",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._list-~3estring))",[0,[2,"list->string"]],["lang/htdp-beginner-abbr"]],
["list->string",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._list-~3estring))",[0,[2,"list->string"]],["lang/htdp-intermediate"]],
["list->string",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._list-~3estring))",[0,[2,"list->string"]],["lang/htdp-intermediate-lambda"]],
["list->string",">srfi-std/srfi-13.html#list2string",[0,[2,"list->string"]],["srfi/13"]],
["list->u16vector",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._list-~3eu16vector))",[0,[2,"list->u16vector"]],["ffi/vector"]],
["list->u32vector",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._list-~3eu32vector))",[0,[2,"list->u32vector"]],["ffi/vector"]],
["list->u64vector",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._list-~3eu64vector))",[0,[2,"list->u64vector"]],["ffi/vector"]],
["list->u8vector",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._list-~3eu8vector))",[0,[2,"list->u8vector"]],["ffi/vector"]],
["list->vector",">reference/vectors.html#(def._((quote._~23~25kernel)._list-~3evector))",[0,[2,"list->vector"]],["racket/base","racket"]],
["list->vector",">r5rs-std/r5rs-Z-H-9.html#%_idx_572",[0,[2,"list->vector"]],["r5rs"]],
["list->vector",">r6rs-std/r6rs-Z-H-14.html#node_idx_738",[0,[2,"list->vector"]],["rnrs/base-6"]],
["list->vector",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._list-~3evector))",[0,[2,"list->vector"]],["lang/htdp-advanced"]],
["list->vector",">srfi-std/srfi-43.html#list->vector",[0,[2,"list->vector"]],["srfi/43"]],
["list-box",">gui/list-box_.html#(idx._(gentag._114._(lib._scribblings/gui/gui..scrbl)))",[7,"'list-box"],false],
["list-box%",">gui/list-box_.html",[0,[2,"list-box%"]],["racket/gui/base","racket/gui"]],
["list-box-column",">gui/list-box_.html#(idx._(gentag._115._(lib._scribblings/gui/gui..scrbl)))",[7,"'list-box-column"],false],
["list-box-dclick",">gui/list-box_.html#(idx._(gentag._113._(lib._scribblings/gui/gui..scrbl)))",[7,"'list-box-dclick"],false],
["list-control<%>",">gui/list-control___.html",[0,[2,"list-control<%>"]],["racket/gui/base","racket/gui"]],
["list-copy",">srfi-std/srfi-1.html#list-copy",[0,[2,"list-copy"]],["srfi/1"]],
["list-ec",">srfi-std/srfi-42.html#list-ec",[0,[1,"list-ec"]],["srfi/42"]],
["list-immutable",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..rkt)._list-immutable))",[0,[2,"list-immutable"]],["mzscheme"]],
["list-index",">srfi-std/srfi-1.html#list-index",[0,[2,"list-index"]],["srfi/1"]],
["list-of",">deinprogramm/signatures-vanilla.html#(part._list-of)",[0,[1,"list-of"]],false],
["list-of",">deinprogramm/signatures-vanilla.html#(form._((lib._deinprogramm/.D.Md.A..rkt)._list-of))",[0,[1,"list-of"]],["deinprogramm/DMdA-vanilla"]],
["list-of",">eopl/index.html#(def._((lib._eopl/eopl..rkt)._list-of))",[0,[2,"list-of"]],["eopl"]],
["list-of-color",">teachpack/image.html#(def._((lib._htdp/image..rkt)._.List-of-color))",[0,"List-of-color"],["htdp/image"]],
["list-prefix?",">unstable/list.html#(def._((lib._unstable/list..rkt)._list-prefix~3f))",[0,[2,"list-prefix?"]],["unstable/list"]],
["list-ref",">reference/pairs.html#(def._((quote._~23~25kernel)._list-ref))",[0,[2,"list-ref"]],["racket/base","racket"]],
["list-ref",">r5rs-std/r5rs-Z-H-9.html#%_idx_444",[0,[2,"list-ref"]],["r5rs"]],
["list-ref",">r6rs-std/r6rs-Z-H-14.html#node_idx_640",[0,[2,"list-ref"]],["rnrs/base-6"]],
["list-ref",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._list-ref))",[0,[2,"list-ref"]],["lang/htdp-advanced"]],
["list-ref",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._list-ref))",[0,[2,"list-ref"]],["lang/htdp-beginner"]],
["list-ref",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._list-ref))",[0,[2,"list-ref"]],["lang/htdp-beginner-abbr"]],
["list-ref",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._list-ref))",[0,[2,"list-ref"]],["lang/htdp-intermediate"]],
["list-ref",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._list-ref))",[0,[2,"list-ref"]],["lang/htdp-intermediate-lambda"]],
["list-ref",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._list-ref))",[0,[2,"list-ref"]],["deinprogramm/DMdA-advanced"]],
["list-ref",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._list-ref))",[0,[2,"list-ref"]],["deinprogramm/DMdA-assignments"]],
["list-ref",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._list-ref))",[0,[2,"list-ref"]],["deinprogramm/DMdA-vanilla"]],
["list-ref",">lazy/index.html#(def._((lib._lazy/main..rkt)._list-ref))",[0,[2,"list-ref"]],["lazy"]],
["list-ref",">srfi-std/srfi-1.html#list-ref",[0,[2,"list-ref"]],["srfi/1"]],
["list-sort",">r6rs-lib-std/r6rs-lib-Z-H-5.html#node_idx_246",[0,[2,"list-sort"]],["rnrs/sorting-6"]],
["list-tables",">db/query-api.html#(def._((lib._db/base..rkt)._list-tables))",[0,[2,"list-tables"]],["db","db/base"]],
["list-tabulate",">srfi-std/srfi-1.html#list-tabulate",[0,[2,"list-tabulate"]],["srfi/1"]],
["list-tail",">reference/pairs.html#(def._((quote._~23~25kernel)._list-tail))",[0,[2,"list-tail"]],["racket/base","racket"]],
["list-tail",">r5rs-std/r5rs-Z-H-9.html#%_idx_442",[0,[2,"list-tail"]],["r5rs"]],
["list-tail",">r6rs-std/r6rs-Z-H-14.html#node_idx_638",[0,[2,"list-tail"]],["rnrs/base-6"]],
["list-tail",">lazy/index.html#(def._((lib._lazy/main..rkt)._list-tail))",[0,[2,"list-tail"]],["lazy"]],
["list/c",">reference/data-structure-contracts.html#(def._((lib._racket/contract/private/misc..rkt)._list/c))",[0,[2,"list/c"]],["racket/contract/base","racket/contract","racket"]],
["list?",">reference/pairs.html#(def._((quote._~23~25kernel)._list~3f))",[0,[2,"list?"]],["racket/base","racket"]],
["list?",">r5rs-std/r5rs-Z-H-9.html#%_idx_432",[0,[2,"list?"]],["r5rs"]],
["list?",">r6rs-std/r6rs-Z-H-14.html#node_idx_628",[0,[2,"list?"]],["rnrs/base-6"]],
["list?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._list~3f))",[0,[2,"list?"]],["lang/htdp-advanced"]],
["list?",">lazy/index.html#(def._((lib._lazy/main..rkt)._list~3f))",[0,[2,"list?"]],["lazy"]],
["listen",">deinprogramm/Konstruktionsanleitungen_1_bis_10.html#(part._.Listen)","Listen",false],
["listen",">unstable/gui-notify.html#(meth._(((lib._unstable/gui/notify..rkt)._notify-box~25)._listen))",[[0,[2,"listen"]],[14,[" (method of ",[0,[2,"notify-box%"]],")"]]],["unstable/gui/notify"]],
["listen-ip",">web-server-internal/dispatch-server-unit.html#(sig-val._((lib._web-server/private/dispatch-server-sig..rkt)._dispatch-server-config~5e._listen-ip))",[0,[2,"listen-ip"]],["web-server/private/dispatch-server-sig"]],
["listen-ip",">web-server-internal/Web_Servers.html#(sig-val._web-config._((lib._web-server/web-config-sig..rkt)._web-config~5e._listen-ip))",[0,[2,"listen-ip"]],["web-server/web-config-sig"]],
["listof",">reference/data-structure-contracts.html#(def._((lib._racket/contract/private/misc..rkt)._listof))",[0,[2,"listof"]],["racket/contract/base","racket/contract","racket"]],
["listof",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Listof))",[0,[1,"Listof"]],["typed/racket/base","typed/racket"]],
["lists",">htdp-langs/advanced.html#(part._htdp-advanced._.Lists)","Lists",false],
["lists",">htdp-langs/beginner.html#(part._htdp-beginner._.Lists)","Lists",false],
["lists",">htdp-langs/beginner-abbr.html#(part._htdp-beginner-abbr._.Lists)","Lists",false],
["lists",">htdp-langs/intermediate.html#(part._htdp-intermediate._.Lists)","Lists",false],
["lists",">htdp-langs/intermediate-lam.html#(part._htdp-intermediate-lambda._.Lists)","Lists",false],
["lists",">quick/index.html#(part._.Lists)","Lists",false],
["lists",">ts-guide/optimization.html#(part._.Lists)","Lists",false],
["lists",">unstable/list.html","Lists",false],
["lists and racket syntax",">guide/Pairs__Lists__and_Racket_Syntax.html#(part._lists-and-syntax)","Lists and Racket Syntax",false],
["lists, iteration, and recursion",">guide/Lists__Iteration__and_Recursion.html","Lists, Iteration, and Recursion",false],
["litchar",">scribble/scribble_manual_code.html#(def._((lib._scribble/manual..rkt)._litchar))",[0,[2,"litchar"]],["scribble/manual"]],
["literal",">scribble/base.html#(def._((lib._scribble/base..rkt)._literal))",[0,[2,"literal"]],["scribble/base"]],
["literal",">syntax/stxparse-patterns.html#(tech._literal)","<span style=\"font-style: italic\">literal</span>",false],
["literal sets",">syntax/Library_Syntax_Classes_and_Literal_Sets.html#(part._.Literal_.Sets)","Literal Sets",false],
["literal sets",">syntax/Literal_Sets_and_Conventions.html#(tech._literal._set)","<span style=\"font-style: italic\">literal\nsets</span>",false],
["literal sets and conventions",">syntax/Literal_Sets_and_Conventions.html","Literal Sets and Conventions",false],
["literal-algol",">algol60/index.html#(form._((lib._algol60/algol60..rkt)._literal-algol))",[0,[1,"literal-algol"]],["algol60/algol60"]],
["literal-color",">slideshow/Typesetting_Racket_Code.html#(def._((lib._slideshow/code..rkt)._literal-color))",[0,[2,"literal-color"]],["slideshow/code"]],
["literal-set->predicate",">syntax/Literal_Sets_and_Conventions.html#(form._((lib._syntax/parse..rkt)._literal-set-~3epredicate))",[0,[1,"literal-set->predicate"]],["syntax/parse"]],
["literal-style",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._literal-style))",[0,[2,"literal-style"]],["redex/pict","redex"]],
["literal-syntax",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._literal-syntax))",[0,[2,"literal-syntax"]],["scribble/racket","scribble/scheme"]],
["literal-syntax-stx",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._literal-syntax-stx))",[0,[2,"literal-syntax-stx"]],["scribble/racket","scribble/scheme"]],
["literal-syntax?",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._literal-syntax~3f))",[0,[2,"literal-syntax?"]],["scribble/racket","scribble/scheme"]],
["literals: quote and #%datum",">reference/quote.html",["Literals: ",[0,[1,"quote"]]," and ",[0,[1,"#%datum"]]],false],
["literate programming",">scribble/lp.html","Literate Programming",false],
["lkup-gui teachpack",">teachpack/lkup-gui.html#(idx._(gentag._16._(lib._teachpack/teachpack..scrbl)))","lkup-gui teachpack",false],
["ll",">reference/characters.html#(idx._(gentag._124._(lib._scribblings/reference/reference..scrbl)))",[7,"'ll"],false],
["lm",">reference/characters.html#(idx._(gentag._126._(lib._scribblings/reference/reference..scrbl)))",[7,"'lm"],false],
["lncs paper format",">scribble/LNCS_Paper_Format.html","LNCS Paper Format",false],
["lo",">reference/characters.html#(idx._(gentag._127._(lib._scribblings/reference/reference..scrbl)))",[7,"'lo"],false],
["load",">reference/eval.html#(def._((quote._~23~25kernel)._load))",[0,[2,"load"]],["racket/base","racket"]],
["load",">r5rs-std/r5rs-Z-H-9.html#%_idx_668",[0,[2,"load"]],["r5rs"]],
["load handler",">reference/eval.html#(tech._load._handler)","<span style=\"font-style: italic\">load handler</span>",false],
["load mode",">guide/racket.html#(part._start-load-mode)","Load Mode",false],
["load-bundle!",">srfi-std/srfi-29.html#load-bundle!",[0,[2,"load-bundle!"]],["srfi/29"]],
["load-collections-xref",">raco/xref.html#(def._((lib._setup/xref..rkt)._load-collections-xref))",[0,[2,"load-collections-xref"]],["setup/xref"]],
["load-extension",">reference/eval.html#(def._((quote._~23~25kernel)._load-extension))",[0,[2,"load-extension"]],["racket/base","racket"]],
["load-file",">draw/bitmap_.html#(meth._(((lib._racket/draw..rkt)._bitmap~25)._load-file))",[[0,[2,"load-file"]],[14,[" (method of ",[0,[2,"bitmap%"]],")"]]],["racket/draw"]],
["load-file",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._load-file))",[[0,[2,"load-file"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["load-file",">gui/image-snip_.html#(meth._(((lib._racket/snip..rkt)._image-snip~25)._load-file))",[[0,[2,"load-file"]],[14,[" (method of ",[0,[2,"image-snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["load-file",">framework/Keymap.html#(idx._(gentag._10._(lib._scribblings/framework/framework..scrbl)))","load-file",false],
["load-file/gui-error",">framework/Editor.html#(meth._(((lib._framework/main..rkt)._editor~3abasic~3c~25~3e)._load-file/gui-error))",[[0,[2,"load-file/gui-error"]],[14,[" (method of ",[0,[2,"editor:basic<%>"]],")"]]],["framework"]],
["load-icon",">images/Icons.html#(def._((lib._images/icons/file..rkt)._load-icon))",[0,[2,"load-icon"]],["images/icons/file"]],
["load-on-demand-enabled",">reference/eval.html#(def._((quote._~23~25kernel)._load-on-demand-enabled))",[0,[2,"load-on-demand-enabled"]],["racket/base","racket"]],
["load-relative",">reference/eval.html#(def._((lib._racket/private/misc..rkt)._load-relative))",[0,[2,"load-relative"]],["racket/base","racket"]],
["load-relative-extension",">reference/eval.html#(def._((lib._racket/private/misc..rkt)._load-relative-extension))",[0,[2,"load-relative-extension"]],["racket/base","racket"]],
["load-xref",">scribble/xref.html#(def._((lib._scribble/xref..rkt)._load-xref))",[0,[2,"load-xref"]],["scribble/xref"]],
["load/cd",">reference/eval.html#(def._((lib._racket/private/misc..rkt)._load/cd))",[0,[2,"load/cd"]],["racket/base","racket"]],
["load/use-compiled",">reference/eval.html#(def._((lib._racket/private/misc..rkt)._load/use-compiled))",[0,[2,"load/use-compiled"]],["racket/base","racket"]],
["loading compiler support",">raco/API_for_Raw_Compilation.html#(part._api~3aloading)","Loading Compiler Support",false],
["loading foreign libraries",">foreign/Loading_Foreign_Libraries.html","Loading Foreign Libraries",false],
["loading mzcom",">mzcom/index.html#(part._.Loading_.Mz.C.O.M)","Loading MzCOM",false],
["local",">reference/local.html#(form._((lib._racket/local..rkt)._local))",[0,[1,"local"]],["racket/local","racket"]],
["local",">htdp-langs/advanced.html#(form._((lib._lang/htdp-advanced..rkt)._local))",[0,[1,"local"]],["lang/htdp-advanced"]],
["local",">htdp-langs/intermediate.html#(form._((lib._lang/htdp-intermediate..rkt)._local))",[0,[1,"local"]],["lang/htdp-intermediate"]],
["local",">htdp-langs/intermediate-lam.html#(form._((lib._lang/htdp-intermediate-lambda..rkt)._local))",[0,[1,"local"]],["lang/htdp-intermediate-lambda"]],
["local binding",">guide/let.html","Local Binding",false],
["local binding",">quick/index.html#(part._.Local_.Binding)","Local Binding",false],
["local binding with define, let, and let*",">guide/syntax-overview.html#(part._local-binding-intro)",["Local Binding with\n",[0,[1,"define"]],", ",[0,[1,"let"]],", and ",[0,[1,"let*"]]],false],
["local binding with splicing body",">reference/splicing.html","Local Binding with Splicing Body",false],
["local binding: let, let*, letrec, ...",">reference/let.html",["Local Binding: ",[0,[1,"let"]],", ",[0,[1,"let*"]],", ",[0,[1,"letrec"]],", ..."],false],
["local bindings",">reference/syntax-model.html#(tech._local._binding)","<span style=\"font-style: italic\">local bindings</span>",false],
["local definitions: local",">reference/local.html",["Local Definitions: ",[0,[1,"local"]]],false],
["local pointers",">inside/im_memoryalloc.html#(part._im~3a3m~3astack)","Local Pointers",false],
["local pointers and raco ctool --xform",">inside/im_memoryalloc.html#(part._im~3a3m~3amzc)",["Local Pointers and ",[6,"raco ctool"]," ",[11,[6,"--xform"]]],false],
["local scopes",">guide/eval.html#(part._.Local_.Scopes)","Local Scopes",false],
["local sockets for postgresql and mysql servers",">db/notes.html#(part._connecting-to-server)","Local Sockets for PostgreSQL and MySQL Servers",false],
["local variable",">reference/eval-model.html#(tech._local._variable)","<span style=\"font-style: italic\">local variable</span>",false],
["local variables",">racklog/predicates.html#(part._local-vars)","Local Variables",false],
["local-edit-sequence?",">framework/Editor.html#(meth._(((lib._framework/main..rkt)._editor~3abasic~3c~25~3e)._local-edit-sequence~3f))",[[0,[2,"local-edit-sequence?"]],[14,[" (method of ",[0,[2,"editor:basic<%>"]],")"]]],["framework"]],
["local-expand",">reference/stxtrans.html#(def._((quote._~23~25kernel)._local-expand))",[0,[2,"local-expand"]],["racket/base","racket"]],
["local-expand/capture-lifts",">reference/stxtrans.html#(def._((quote._~23~25kernel)._local-expand/capture-lifts))",[0,[2,"local-expand/capture-lifts"]],["racket/base","racket"]],
["local-require",">reference/require.html#(form._((lib._racket/private/base..rkt)._local-require))",[0,[1,"local-require"]],["racket/base","racket"]],
["local-table-of-contents",">scribble/base.html#(def._((lib._scribble/base..rkt)._local-table-of-contents))",[0,[2,"local-table-of-contents"]],["scribble/base"]],
["local-to-global",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._local-to-global))",[[0,[2,"local-to-global"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["local-transformer-expand",">reference/stxtrans.html#(def._((quote._~23~25kernel)._local-transformer-expand))",[0,[2,"local-transformer-expand"]],["racket/base","racket"]],
["local-transformer-expand/capture-lifts",">reference/stxtrans.html#(def._((quote._~23~25kernel)._local-transformer-expand/capture-lifts))",[0,[2,"local-transformer-expand/capture-lifts"]],["racket/base","racket"]],
["locale",">reference/encodings.html#(tech._locale)","<span style=\"font-style: italic\">locale</span>",false],
["locale-specific string operations",">reference/strings.html#(part._.Locale-.Specific_.String_.Operations)","Locale-Specific String Operations",false],
["locale-string-encoding",">reference/bytestrings.html#(def._((quote._~23~25kernel)._locale-string-encoding))",[0,[2,"locale-string-encoding"]],["racket/base","racket"]],
["locale_system_default",">foreign/com-intf.html#(def._((lib._ffi/unsafe/com..rkt)._.L.O.C.A.L.E_.S.Y.S.T.E.M_.D.E.F.A.U.L.T))",[0,[2,"LOCALE_SYSTEM_DEFAULT"]],["ffi/unsafe/com"]],
["localhost",">teachpack/2htdpuniverse.html#(def._((lib._2htdp/universe..rkt)._.L.O.C.A.L.H.O.S.T))",[0,[2,"LOCALHOST"]],["2htdp/universe"]],
["localized-template",">srfi-std/srfi-29.html#localized-template",[0,[2,"localized-template"]],["srfi/29"]],
["localref",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._localref))",[0,[2,"localref"]],["compiler/zo-structs"]],
["localref-clear?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._localref-clear~3f))",[0,[2,"localref-clear?"]],["compiler/zo-structs"]],
["localref-flonum?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._localref-flonum~3f))",[0,[2,"localref-flonum?"]],["compiler/zo-structs"]],
["localref-other-clears?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._localref-other-clears~3f))",[0,[2,"localref-other-clears?"]],["compiler/zo-structs"]],
["localref-pos",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._localref-pos))",[0,[2,"localref-pos"]],["compiler/zo-structs"]],
["localref-unbox?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._localref-unbox~3f))",[0,[2,"localref-unbox?"]],["compiler/zo-structs"]],
["localref?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._localref~3f))",[0,[2,"localref?"]],["compiler/zo-structs"]],
["locate-file",">framework/Group.html#(meth._(((lib._framework/main..rkt)._group~3a~25)._locate-file))",[[0,[2,"locate-file"]],[14,[" (method of ",[0,[2,"group:%"]],")"]]],["framework"]],
["locating paths",">reference/Filesystem.html#(part._findpaths)","Locating Paths",false],
["location",">xml/index.html#(def._((lib._xml/main..rkt)._location))",[0,[2,"location"]],["xml"]],
["location",">gui/editor-overview.html#(tech._location)","<span style=\"font-style: italic\">location</span>",false],
["location",">reference/eval-model.html#(tech._location)","<span style=\"font-style: italic\">location</span>",false],
["location-char",">xml/index.html#(def._((lib._xml/main..rkt)._location-char))",[0,[2,"location-char"]],["xml"]],
["location-line",">xml/index.html#(def._((lib._xml/main..rkt)._location-line))",[0,[2,"location-line"]],["xml"]],
["location-offset",">xml/index.html#(def._((lib._xml/main..rkt)._location-offset))",[0,[2,"location-offset"]],["xml"]],
["location/c",">xml/index.html#(def._((lib._xml/main..rkt)._location/c))",[0,[2,"location/c"]],["xml"]],
["location?",">plai/collector.html#(def._((lib._plai/collector..rkt)._location~3f))",[0,[2,"location?"]],["plai/collector"]],
["location?",">xml/index.html#(def._((lib._xml/main..rkt)._location~3f))",[0,[2,"location?"]],["xml"]],
["locations-computed?",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._locations-computed~3f))",[[0,[2,"locations-computed?"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["locations: #%variable-reference",">reference/Locations____variable-reference.html",["Locations: ",[0,[1,"#%variable-reference"]]],false],
["lock",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._lock))",[[0,[2,"lock"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["lock",">framework/Color.html#(meth._(((lib._framework/main..rkt)._color~3atext-mixin)._lock))",[[0,[2,"lock"]],[14,[" (method of ",[0,[2,"color:text-mixin"]],")"]]],["framework"]],
["lock",">framework/Editor.html#(meth._(((lib._framework/main..rkt)._editor~3ainfo-mixin)._lock))",[[0,[2,"lock"]],[14,[" (method of ",[0,[2,"editor:info-mixin"]],")"]]],["framework"]],
["lock-icon",">images/Icons.html#(def._((lib._images/icons/misc..rkt)._lock-icon))",[0,[2,"lock-icon"]],["images/icons/misc"]],
["lock-status-changed",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3ainfo~3c~25~3e)._lock-status-changed))",[[0,[2,"lock-status-changed"]],[14,[" (method of ",[0,[2,"frame:info<%>"]],")"]]],["framework"]],
["locked-for-flow?",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._locked-for-flow~3f))",[[0,[2,"locked-for-flow?"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["locked-for-read?",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._locked-for-read~3f))",[[0,[2,"locked-for-read?"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["locked-for-write?",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._locked-for-write~3f))",[[0,[2,"locked-for-write?"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["log",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._log))",[0,[2,"log"]],["racket/base","racket"]],
["log",">r5rs-std/r5rs-Z-H-9.html#%_idx_328",[0,[2,"log"]],["r5rs"]],
["log",">r6rs-std/r6rs-Z-H-14.html#node_idx_542",[0,[2,"log"]],["rnrs/base-6"]],
["log",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._log))",[0,[2,"log"]],["lang/htdp-advanced"]],
["log",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._log))",[0,[2,"log"]],["lang/htdp-beginner"]],
["log",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._log))",[0,[2,"log"]],["lang/htdp-beginner-abbr"]],
["log",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._log))",[0,[2,"log"]],["lang/htdp-intermediate"]],
["log",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._log))",[0,[2,"log"]],["lang/htdp-intermediate-lambda"]],
["log",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._log))",[0,[2,"log"]],["deinprogramm/DMdA-advanced"]],
["log",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._log))",[0,[2,"log"]],["deinprogramm/DMdA-assignments"]],
["log",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._log))",[0,[2,"log"]],["deinprogramm/DMdA-beginner"]],
["log",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._log))",[0,[2,"log"]],["deinprogramm/DMdA-vanilla"]],
["log definitions and interactions... menu item",">drracket/Menus.html#(idx._(gentag._66._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Log Definitions and Interactions...</span> menu item",false],
["log receiver",">reference/logging.html#(tech._log._receiver)","<span style=\"font-style: italic\">log receiver</span>",false],
["log ticks",">plot/ticks_and_transforms.html#(part._.Log_.Ticks)","Log Ticks",false],
["log-debug",">reference/logging.html#(form._((lib._racket/private/more-scheme..rkt)._log-debug))",[0,[1,"log-debug"]],["racket/base","racket"]],
["log-error",">reference/logging.html#(form._((lib._racket/private/more-scheme..rkt)._log-error))",[0,[1,"log-error"]],["racket/base","racket"]],
["log-fatal",">reference/logging.html#(form._((lib._racket/private/more-scheme..rkt)._log-fatal))",[0,[1,"log-fatal"]],["racket/base","racket"]],
["log-file",">planet/Utility_Libraries.html#(def._((lib._planet/config..rkt)._.L.O.G-.F.I.L.E))",[0,[2,"LOG-FILE"]],["planet/config"]],
["log-file-path",">web-server-internal/Web_Servers.html#(idx._(gentag._26._(lib._web-server/scribblings/web-server-internal..scrbl)))","log-file-path",false],
["log-format",">web-server-internal/Web_Servers.html#(idx._(gentag._8._(lib._web-server/scribblings/web-server-internal..scrbl)))","log-format",false],
["log-format->format",">web-server-internal/dispatch-log.html#(def._((lib._web-server/dispatchers/dispatch-log..rkt)._log-format-~3eformat))",[0,[2,"log-format->format"]],["web-server/dispatchers/dispatch-log"]],
["log-format/c",">web-server-internal/dispatch-log.html#(def._((lib._web-server/dispatchers/dispatch-log..rkt)._log-format/c))",[0,[2,"log-format/c"]],["web-server/dispatchers/dispatch-log"]],
["log-info",">reference/logging.html#(form._((lib._racket/private/more-scheme..rkt)._log-info))",[0,[1,"log-info"]],["racket/base","racket"]],
["log-level",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Log-.Level))",[0,[1,"Log-Level"]],["typed/racket/base","typed/racket"]],
["log-level?",">reference/logging.html#(def._((quote._~23~25kernel)._log-level~3f))",[0,[2,"log-level?"]],["racket/base","racket"]],
["log-max-level",">reference/logging.html#(def._((quote._~23~25kernel)._log-max-level))",[0,[2,"log-max-level"]],["racket/base","racket"]],
["log-message",">reference/logging.html#(def._((quote._~23~25kernel)._log-message))",[0,[2,"log-message"]],["racket/base","racket"]],
["log-message",">reference/distributed-places.html#(def._((lib._racket/place/distributed..rkt)._log-message))",[0,[2,"log-message"]],["racket/place/distributed"]],
["log-receiver",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Log-.Receiver))",[0,[1,"Log-Receiver"]],["typed/racket/base","typed/racket"]],
["log-receiver?",">reference/logging.html#(def._((quote._~23~25kernel)._log-receiver~3f))",[0,[2,"log-receiver?"]],["racket/base","racket"]],
["log-ticks",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._log-ticks))",[0,[2,"log-ticks"]],["plot"]],
["log-ticks-format",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._log-ticks-format))",[0,[2,"log-ticks-format"]],["plot"]],
["log-ticks-layout",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._log-ticks-layout))",[0,[2,"log-ticks-layout"]],["plot"]],
["log-to-parent",">reference/distributed-places.html#(def._((lib._racket/place/define-remote-server..rkt)._log-to-parent))",[0,[2,"log-to-parent"]],["racket/place/define-remote-server"]],
["log-transform",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._log-transform))",[0,[2,"log-transform"]],["plot"]],
["log-warning",">reference/logging.html#(form._((lib._racket/private/more-scheme..rkt)._log-warning))",[0,[1,"log-warning"]],["racket/base","racket"]],
["logger",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Logger))",[0,[1,"Logger"]],["typed/racket/base","typed/racket"]],
["logger",">reference/logging.html#(tech._logger)","<span style=\"font-style: italic\">logger</span>",false],
["logger-name",">reference/logging.html#(def._((quote._~23~25kernel)._logger-name))",[0,[2,"logger-name"]],["racket/base","racket"]],
["logger?",">reference/logging.html#(def._((quote._~23~25kernel)._logger~3f))",[0,[2,"logger?"]],["racket/base","racket"]],
["logging",">reference/logging.html","Logging",false],
["logging",">unstable/Logging.html","Logging",false],
["logging",">web-server-internal/dispatch-log.html","Logging",false],
["logging events",">reference/logging.html#(part._.Logging_.Events)","Logging Events",false],
["logic-var?",">racklog/glossary.html#(def._((lib._racklog/main..rkt)._logic-var~3f))",[0,[2,"logic-var?"]],["racklog"]],
["logical operators",">reference/generic-numbers.html#(idx._(gentag._103._(lib._scribblings/reference/reference..scrbl)))","logical operators",false],
["logname",">reference/Filesystem.html#(idx._(gentag._264._(lib._scribblings/reference/reference..scrbl)))",[6,"LOGNAME"],false],
["logos",">images/Logos.html","Logos",false],
["long-boolean",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._long-boolean))",[0,[2,"long-boolean"]],["scribble/racket","scribble/scheme"]],
["long-boolean-val",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._long-boolean-val))",[0,[2,"long-boolean-val"]],["scribble/racket","scribble/scheme"]],
["long-boolean?",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._long-boolean~3f))",[0,[2,"long-boolean?"]],["scribble/racket","scribble/scheme"]],
["long-dash",">draw/pen_.html#(idx._(gentag._57._(lib._scribblings/draw/draw..scrbl)))",[7,"'long-dash"],false],
["lookahead",">guide/Looking_Ahead_and_Behind.html#(part._.Lookahead)","Lookahead",false],
["lookahead-char",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_698",[0,[2,"lookahead-char"]],["rnrs/io/ports-6"]],
["lookahead-u8",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_686",[0,[2,"lookahead-u8"]],["rnrs/io/ports-6"]],
["lookbehind",">guide/Looking_Ahead_and_Behind.html#(part._.Lookbehind)","Lookbehind",false],
["looking ahead and behind",">guide/Looking_Ahead_and_Behind.html","Looking Ahead and Behind",false],
["lookup gui: \"lkup-gui.ss\"",">teachpack/lkup-gui.html",["Lookup GUI: ",[6,"\"lkup-gui.ss\""],"<a name=\"(idx._(gentag._16._(lib._teachpack/teachpack..scrbl)))\"></a>"],false],
["lookup-documentation",">syntax/docprovide.html#(def._((lib._syntax/docprovide..rkt)._lookup-documentation))",[0,[2,"lookup-documentation"]],["syntax/docprovide"]],
["lookup-errno",">foreign/Miscellaneous_Support.html#(def._((quote._~23~25foreign)._lookup-errno))",[0,[2,"lookup-errno"]],["ffi/unsafe"]],
["lookup-package-by-keys",">planet/Utility_Libraries.html#(def._((lib._planet/util..rkt)._lookup-package-by-keys))",[0,[2,"lookup-package-by-keys"]],["planet/util"]],
["loop-until",">mzlib/mzlib_etc.html#(def._((lib._mzlib/etc..rkt)._loop-until))",[0,[2,"loop-until"]],["mzlib/etc"]],
["loops",">ts-reference/special-forms.html#(part._.Loops)","Loops",false],
["lorenz",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtle-examples..rkt)._lorenz))",[0,[2,"lorenz"]],["graphics/turtle-examples"]],
["lorenz attractor",">turtles/Traditional_Turtles.html#(idx._(gentag._2._(lib._graphics/scribblings/turtles..scrbl)))","Lorenz attractor",false],
["lorenz1",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtle-examples..rkt)._lorenz1))",[0,[2,"lorenz1"]],["graphics/turtle-examples"]],
["low-level contract boundaries",">reference/attaching-contracts-to-values.html#(part._.Low-level_.Contract_.Boundaries)","Low-level Contract Boundaries",false],
["low-level scribble api",">scribble/internals.html","Low-Level Scribble API",false],
["lower",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._lower))",[[0,[2,"lower"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["lower-case",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex..rkt)._lower-case))",[0,[1,"lower-case"]],["parser-tools/lex"]],
["lp-include",">scribble/lp.html#(form._((lib._scribble/lp-include..rkt)._lp-include))",[0,[1,"lp-include"]],["scribble/lp-include"]],
["lpt1",">reference/windowspaths.html#(idx._(gentag._252._(lib._scribblings/reference/reference..scrbl)))",[6,"\"LPT1\""],false],
["lpt2",">reference/windowspaths.html#(idx._(gentag._253._(lib._scribblings/reference/reference..scrbl)))",[6,"\"LPT2\""],false],
["lpt3",">reference/windowspaths.html#(idx._(gentag._254._(lib._scribblings/reference/reference..scrbl)))",[6,"\"LPT3\""],false],
["lpt4",">reference/windowspaths.html#(idx._(gentag._255._(lib._scribblings/reference/reference..scrbl)))",[6,"\"LPT4\""],false],
["lpt5",">reference/windowspaths.html#(idx._(gentag._256._(lib._scribblings/reference/reference..scrbl)))",[6,"\"LPT5\""],false],
["lpt6",">reference/windowspaths.html#(idx._(gentag._257._(lib._scribblings/reference/reference..scrbl)))",[6,"\"LPT6\""],false],
["lpt7",">reference/windowspaths.html#(idx._(gentag._258._(lib._scribblings/reference/reference..scrbl)))",[6,"\"LPT7\""],false],
["lpt8",">reference/windowspaths.html#(idx._(gentag._259._(lib._scribblings/reference/reference..scrbl)))",[6,"\"LPT8\""],false],
["lpt9",">reference/windowspaths.html#(idx._(gentag._260._(lib._scribblings/reference/reference..scrbl)))",[6,"\"LPT9\""],false],
["lru",">web-server/servlet.html#(part._lru)","LRU",false],
["lset",">srfi-std/srfi-1.html#lset",[0,[2,"lset"]],["srfi/1"]],
["lset-adjoin",">srfi-std/srfi-1.html#lset-adjoin",[0,[2,"lset-adjoin"]],["srfi/1"]],
["lset-diff+intersection",">srfi-std/srfi-1.html#lset-diff+intersection",[0,[2,"lset-diff+intersection"]],["srfi/1"]],
["lset-diff+intersection!",">srfi-std/srfi-1.html#lset-diff+intersection!",[0,[2,"lset-diff+intersection!"]],["srfi/1"]],
["lset-difference",">srfi-std/srfi-1.html#lset-difference",[0,[2,"lset-difference"]],["srfi/1"]],
["lset-difference!",">srfi-std/srfi-1.html#lset-difference!",[0,[2,"lset-difference!"]],["srfi/1"]],
["lset-intersection",">srfi-std/srfi-1.html#lset-intersection",[0,[2,"lset-intersection"]],["srfi/1"]],
["lset-intersection!",">srfi-std/srfi-1.html#lset-intersection!",[0,[2,"lset-intersection!"]],["srfi/1"]],
["lset-union",">srfi-std/srfi-1.html#lset-union",[0,[2,"lset-union"]],["srfi/1"]],
["lset-union!",">srfi-std/srfi-1.html#lset-union!",[0,[2,"lset-union!"]],["srfi/1"]],
["lset-xor",">srfi-std/srfi-1.html#lset-xor",[0,[2,"lset-xor"]],["srfi/1"]],
["lset-xor!",">srfi-std/srfi-1.html#lset-xor!",[0,[2,"lset-xor!"]],["srfi/1"]],
["lset=",">srfi-std/srfi-1.html#lset=",[0,[2,"lset="]],["srfi/1"]],
["lt",">reference/characters.html#(idx._(gentag._125._(lib._scribblings/reference/reference..scrbl)))",[7,"'lt"],false],
["lt-find",">slideshow/Pict_Finders.html#(def._((lib._slideshow/pict..rkt)._lt-find))",[0,[2,"lt-find"]],["slideshow/pict","slideshow"]],
["lt-superimpose",">slideshow/Pict_Combiners.html#(def._((lib._slideshow/pict..rkt)._lt-superimpose))",[0,[2,"lt-superimpose"]],["slideshow/pict","slideshow"]],
["ltl-find",">slideshow/Pict_Finders.html#(def._((lib._slideshow/pict..rkt)._ltl-find))",[0,[2,"ltl-find"]],["slideshow/pict","slideshow"]],
["ltl-superimpose",">slideshow/Pict_Combiners.html#(def._((lib._slideshow/pict..rkt)._ltl-superimpose))",[0,[2,"ltl-superimpose"]],["slideshow/pict","slideshow"]],
["lu",">reference/characters.html#(idx._(gentag._123._(lib._scribblings/reference/reference..scrbl)))",[7,"'lu"],false],
["lw",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._lw))",[0,[2,"lw"]],["redex/pict","redex"]],
["lw->pict",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._lw-~3epict))",[0,[2,"lw->pict"]],["redex/pict","redex"]],
["lw-column",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._lw-column))",[0,[2,"lw-column"]],["redex/pict","redex"]],
["lw-column-span",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._lw-column-span))",[0,[2,"lw-column-span"]],["redex/pict","redex"]],
["lw-e",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._lw-e))",[0,[2,"lw-e"]],["redex/pict","redex"]],
["lw-line",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._lw-line))",[0,[2,"lw-line"]],["redex/pict","redex"]],
["lw-line-span",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._lw-line-span))",[0,[2,"lw-line-span"]],["redex/pict","redex"]],
["lw-metafunction?",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._lw-metafunction~3f))",[0,[2,"lw-metafunction?"]],["redex/pict","redex"]],
["lw-unq?",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._lw-unq~3f))",[0,[2,"lw-unq?"]],["redex/pict","redex"]],
["lw?",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._lw~3f))",[0,[2,"lw?"]],["redex/pict","redex"]],
["m-( keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._200._(lib._scribblings/drracket/drracket..scrbl)))","M-( keybinding",false],
["m-< keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._162._(lib._scribblings/drracket/drracket..scrbl)))","M-< keybinding",false],
["m-> keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._163._(lib._scribblings/drracket/drracket..scrbl)))","M-> keybinding",false],
["m-[ keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._201._(lib._scribblings/drracket/drracket..scrbl)))","M-[ keybinding",false],
["m-b keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._159._(lib._scribblings/drracket/drracket..scrbl)))","M-b keybinding",false],
["m-c-b keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._169._(lib._scribblings/drracket/drracket..scrbl)))","M-C-b keybinding",false],
["m-c-d keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._171._(lib._scribblings/drracket/drracket..scrbl)))","M-C-d keybinding",false],
["m-c-down keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._180._(lib._scribblings/drracket/drracket..scrbl)))","M-C-down keybinding",false],
["m-c-f keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._168._(lib._scribblings/drracket/drracket..scrbl)))","M-C-f keybinding",false],
["m-c-k keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._191._(lib._scribblings/drracket/drracket..scrbl)))","M-C-k keybinding",false],
["m-c-k keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._199._(lib._scribblings/drracket/drracket..scrbl)))","M-C-k keybinding",false],
["m-c-left keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._174._(lib._scribblings/drracket/drracket..scrbl)))","M-C-left keybinding",false],
["m-c-m keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._198._(lib._scribblings/drracket/drracket..scrbl)))","M-C-m keybinding",false],
["m-c-p keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._173._(lib._scribblings/drracket/drracket..scrbl)))","M-C-p keybinding",false],
["m-c-right keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._176._(lib._scribblings/drracket/drracket..scrbl)))","M-C-right keybinding",false],
["m-c-space keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._172._(lib._scribblings/drracket/drracket..scrbl)))","M-C-SPACE keybinding",false],
["m-c-t keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._197._(lib._scribblings/drracket/drracket..scrbl)))","M-C-t keybinding",false],
["m-c-u keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._170._(lib._scribblings/drracket/drracket..scrbl)))","M-C-u keybinding",false],
["m-c-up keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._178._(lib._scribblings/drracket/drracket..scrbl)))","M-C-up keybinding",false],
["m-d keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._188._(lib._scribblings/drracket/drracket..scrbl)))","M-d keybinding",false],
["m-del keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._189._(lib._scribblings/drracket/drracket..scrbl)))","M-DEL keybinding",false],
["m-f keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._158._(lib._scribblings/drracket/drracket..scrbl)))","M-f keybinding",false],
["m-n keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._215._(lib._scribblings/drracket/drracket..scrbl)))","M-n keybinding",false],
["m-o keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._207._(lib._scribblings/drracket/drracket..scrbl)))","M-o keybinding",false],
["m-p keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._214._(lib._scribblings/drracket/drracket..scrbl)))","M-p keybinding",false],
["m-s-l keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._203._(lib._scribblings/drracket/drracket..scrbl)))","M-S-L keybinding",false],
["m-t keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._196._(lib._scribblings/drracket/drracket..scrbl)))","M-t keybinding",false],
["m-v keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._161._(lib._scribblings/drracket/drracket..scrbl)))","M-v keybinding",false],
["m-w keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._192._(lib._scribblings/drracket/drracket..scrbl)))","M-w keybinding",false],
["m-{ keybinding",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._202._(lib._scribblings/drracket/drracket..scrbl)))","M-{ keybinding",false],
["machine",">unstable/Automata__Compiling_State_Machines.html#(def._((lib._unstable/automata/machine..rkt)._machine))",[0,[2,"machine"]],["unstable/automata/machine"]],
["machine",">reference/runtime.html#(idx._(gentag._336._(lib._scribblings/reference/reference..scrbl)))",[7,"'machine"],false],
["machine-accepting",">unstable/Automata__Compiling_State_Machines.html#(def._((lib._unstable/automata/machine..rkt)._machine-accepting))",[0,[2,"machine-accepting"]],["unstable/automata/machine"]],
["machine-accepting-next",">unstable/Automata__Compiling_State_Machines.html#(def._((lib._unstable/automata/machine..rkt)._machine-accepting-next))",[0,[2,"machine-accepting-next"]],["unstable/automata/machine"]],
["machine-accepting?",">unstable/Automata__Compiling_State_Machines.html#(def._((lib._unstable/automata/machine..rkt)._machine-accepting~3f))",[0,[2,"machine-accepting?"]],["unstable/automata/machine"]],
["machine-accepts?",">unstable/Automata__Compiling_State_Machines.html#(def._((lib._unstable/automata/machine..rkt)._machine-accepts~3f))",[0,[2,"machine-accepts?"]],["unstable/automata/machine"]],
["machine-accepts?/prefix-closed",">unstable/Automata__Compiling_State_Machines.html#(def._((lib._unstable/automata/machine..rkt)._machine-accepts~3f/prefix-closed))",[0,[2,"machine-accepts?/prefix-closed"]],["unstable/automata/machine"]],
["machine-complement",">unstable/Automata__Compiling_State_Machines.html#(def._((lib._unstable/automata/machine..rkt)._machine-complement))",[0,[2,"machine-complement"]],["unstable/automata/machine"]],
["machine-epsilon",">unstable/Automata__Compiling_State_Machines.html#(def._((lib._unstable/automata/machine..rkt)._machine-epsilon))",[0,[2,"machine-epsilon"]],["unstable/automata/machine"]],
["machine-intersect",">unstable/Automata__Compiling_State_Machines.html#(def._((lib._unstable/automata/machine..rkt)._machine-intersect))",[0,[2,"machine-intersect"]],["unstable/automata/machine"]],
["machine-next",">unstable/Automata__Compiling_State_Machines.html#(def._((lib._unstable/automata/machine..rkt)._machine-next))",[0,[2,"machine-next"]],["unstable/automata/machine"]],
["machine-null",">unstable/Automata__Compiling_State_Machines.html#(def._((lib._unstable/automata/machine..rkt)._machine-null))",[0,[2,"machine-null"]],["unstable/automata/machine"]],
["machine-seq",">unstable/Automata__Compiling_State_Machines.html#(def._((lib._unstable/automata/machine..rkt)._machine-seq))",[0,[2,"machine-seq"]],["unstable/automata/machine"]],
["machine-seq*",">unstable/Automata__Compiling_State_Machines.html#(def._((lib._unstable/automata/machine..rkt)._machine-seq*))",[0,[2,"machine-seq*"]],["unstable/automata/machine"]],
["machine-sigma*",">unstable/Automata__Compiling_State_Machines.html#(def._((lib._unstable/automata/machine..rkt)._machine-sigma*))",[0,[2,"machine-sigma*"]],["unstable/automata/machine"]],
["machine-star",">unstable/Automata__Compiling_State_Machines.html#(def._((lib._unstable/automata/machine..rkt)._machine-star))",[0,[2,"machine-star"]],["unstable/automata/machine"]],
["machine-union",">unstable/Automata__Compiling_State_Machines.html#(def._((lib._unstable/automata/machine..rkt)._machine-union))",[0,[2,"machine-union"]],["unstable/automata/machine"]],
["machine?",">unstable/Automata__Compiling_State_Machines.html#(def._((lib._unstable/automata/machine..rkt)._machine~3f))",[0,[2,"machine?"]],["unstable/automata/machine"]],
["machines",">unstable/Automata__Compiling_State_Machines.html#(part._machine)","Machines",false],
["macosx",">reference/runtime.html#(idx._(gentag._326._(lib._scribblings/reference/reference..scrbl)))",[7,"'macosx"],false],
["macro",">guide/macros.html#(tech._macro)","<span style=\"font-style: italic\">macro</span>",false],
["macro",">reference/syntax-model.html#(tech._macro)","<span style=\"font-style: italic\">macro</span>",false],
["macro debugger: inspecting macro expansion",">macro-debugger/index.html","Macro Debugger: Inspecting Macro Expansion",false],
["macro expansion tools",">macro-debugger/index.html#(part._.Macro_.Expansion_.Tools)","Macro Expansion Tools",false],
["macro hiding",">macro-debugger/index.html#(part._.Macro_.Hiding)","Macro Hiding",false],
["macro pattern variables",">guide/pattern-macros.html#(tech._macro._pattern._variable)","<span style=\"font-style: italic\">macro pattern\nvariables</span>",false],
["macro stepper",">macro-debugger/index.html#(part._.Macro_.Stepper)","Macro Stepper",false],
["macro stepper api for macros",">macro-debugger/index.html#(part._.Macro_.Stepper_.A.P.I_for_.Macros)","Macro Stepper API for Macros",false],
["macro stepper text interface",">macro-debugger/index.html#(part._.Macro_.Stepper_.Text_.Interface)","Macro Stepper Text Interface",false],
["macro transformer",">guide/proc-macros.html#(tech._macro._transformer)","<span style=\"font-style: italic\">macro transformer</span>",false],
["macro transformer helpers",">syntax/transformer-helpers.html","Macro Transformer Helpers",false],
["macro-debugger/analysis/check-requires",">macro-debugger/index.html#(mod-path._macro-debugger/analysis/check-requires)",[9,[0,"macro-debugger/analysis/check-requires"]],"module"],
["macro-debugger/analysis/show-dependencies",">macro-debugger/index.html#(mod-path._macro-debugger/analysis/show-dependencies)",[9,[0,"macro-debugger/analysis/show-dependencies"]],"module"],
["macro-debugger/emit",">macro-debugger/index.html#(mod-path._macro-debugger/emit)",[9,[0,"macro-debugger/emit"]],"module"],
["macro-debugger/expand",">macro-debugger/index.html#(mod-path._macro-debugger/expand)",[9,[0,"macro-debugger/expand"]],"module"],
["macro-debugger/stepper",">macro-debugger/index.html#(mod-path._macro-debugger/stepper)",[9,[0,"macro-debugger/stepper"]],"module"],
["macro-debugger/stepper-text",">macro-debugger/index.html#(mod-path._macro-debugger/stepper-text)",[9,[0,"macro-debugger/stepper-text"]],"module"],
["macro-debugger/syntax-browser",">macro-debugger/index.html#(mod-path._macro-debugger/syntax-browser)",[9,[0,"macro-debugger/syntax-browser"]],"module"],
["macro-generating macro",">guide/pattern-macros.html#(tech._macro._generating._macro)","<span style=\"font-style: italic\">macro-generating\nmacro</span>",false],
["macro-generating macros",">guide/pattern-macros.html#(part._.Macro-.Generating_.Macros)","Macro-Generating Macros",false],
["macro-introduced bindings",">reference/syntax-model.html#(part._macro-introduced-bindings)","Macro-Introduced Bindings",false],
["macro-stepper-hash-color",">images/Icons.html#(def._((lib._images/icons/tool..rkt)._macro-stepper-hash-color))",[0,[2,"macro-stepper-hash-color"]],["images/icons/tool"]],
["macro-stepper-icon",">images/Icons.html#(def._((lib._images/icons/tool..rkt)._macro-stepper-icon))",[0,[2,"macro-stepper-icon"]],["images/icons/tool"]],
["macro-stepper-logo",">images/Logos.html#(def._((lib._images/logos..rkt)._macro-stepper-logo))",[0,[2,"macro-stepper-logo"]],["images/logos"]],
["macros",">guide/macros.html","Macros",false],
["macros",">quick/index.html#(part._.Macros)","Macros",false],
["macros",">reference/Macros.html","Macros",false],
["macros and syntax objects",">planet/Utility_Libraries.html#(part._syntax..rkt)","Macros and Syntax Objects",false],
["magenta",">unstable/pict.html#(def._((lib._unstable/gui/pict..rkt)._magenta))",[0,[2,"magenta"]],["unstable/gui/pict"]],
["magnifying-glass-icon",">images/Icons.html#(def._((lib._images/icons/misc..rkt)._magnifying-glass-icon))",[0,[2,"magnifying-glass-icon"]],["images/icons/misc"]],
["magnitude",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._magnitude))",[0,[2,"magnitude"]],["racket/base","racket"]],
["magnitude",">r5rs-std/r5rs-Z-H-9.html#%_idx_356",[0,[2,"magnitude"]],["r5rs"]],
["magnitude",">r6rs-std/r6rs-Z-H-14.html#node_idx_574",[0,[2,"magnitude"]],["rnrs/base-6"]],
["magnitude",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._magnitude))",[0,[2,"magnitude"]],["lang/htdp-advanced"]],
["magnitude",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._magnitude))",[0,[2,"magnitude"]],["lang/htdp-beginner"]],
["magnitude",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._magnitude))",[0,[2,"magnitude"]],["lang/htdp-beginner-abbr"]],
["magnitude",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._magnitude))",[0,[2,"magnitude"]],["lang/htdp-intermediate"]],
["magnitude",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._magnitude))",[0,[2,"magnitude"]],["lang/htdp-intermediate-lambda"]],
["magnitude",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._magnitude))",[0,[2,"magnitude"]],["deinprogramm/DMdA-advanced"]],
["magnitude",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._magnitude))",[0,[2,"magnitude"]],["deinprogramm/DMdA-assignments"]],
["magnitude",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._magnitude))",[0,[2,"magnitude"]],["deinprogramm/DMdA-beginner"]],
["magnitude",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._magnitude))",[0,[2,"magnitude"]],["deinprogramm/DMdA-vanilla"]],
["mail?",">teachpack/2htdpuniverse.html#(def._((lib._2htdp/universe..rkt)._mail~3f))",[0,[2,"mail?"]],["2htdp/universe"]],
["main and test submodules",">guide/Module_Syntax.html#(part._main-and-test)","Main and Test Submodules",false],
["main compiler unit",">raco/API_for_Raw_Compilation.html#(part._.Main_.Compiler_.Unit)","Main Compiler Unit",false],
["main submodule",">guide/Module_Syntax.html#(idx._(gentag._1._(lib._scribblings/guide/guide..scrbl)))",[[0,"main"]," submodule"],false],
["main-collects-relative->path",">raco/relative-paths.html#(def._((lib._setup/main-collects..rkt)._main-collects-relative-~3epath))",[0,[2,"main-collects-relative->path"]],["setup/main-collects"]],
["major modes",">guide/Emacs.html#(part._.Major_.Modes)","Major Modes",false],
["major ticks",">plot/ticks_and_transforms.html#(tech._major._tick)","<span style=\"font-style: italic\">Major ticks</span>",false],
["make",">make/make.html",[9,[0,"make"]],"module"],
["make",">make/make.html#(form._((lib._make/main..rkt)._make))",[0,[1,"make"]],["make"]],
["make",">unstable/struct.html#(form._((lib._unstable/struct..rkt)._make))",[0,[1,"make"]],["unstable/struct"]],
["make",">web-server-internal/dispatch-files.html#(def._((lib._web-server/dispatchers/dispatch-files..rkt)._make))",[0,[2,"make"]],["web-server/dispatchers/dispatch-files"]],
["make",">web-server-internal/dispatch-filter.html#(def._((lib._web-server/dispatchers/dispatch-filter..rkt)._make))",[0,[2,"make"]],["web-server/dispatchers/dispatch-filter"]],
["make",">web-server-internal/dispatch-host.html#(def._((lib._web-server/dispatchers/dispatch-host..rkt)._make))",[0,[2,"make"]],["web-server/dispatchers/dispatch-host"]],
["make",">web-server-internal/dispatch-lift.html#(def._((lib._web-server/dispatchers/dispatch-lift..rkt)._make))",[0,[2,"make"]],["web-server/dispatchers/dispatch-lift"]],
["make",">web-server-internal/dispatch-log.html#(def._((lib._web-server/dispatchers/dispatch-log..rkt)._make))",[0,[2,"make"]],["web-server/dispatchers/dispatch-log"]],
["make",">web-server-internal/dispatch-passwords.html#(def._((lib._web-server/dispatchers/dispatch-passwords..rkt)._make))",[0,[2,"make"]],["web-server/dispatchers/dispatch-passwords"]],
["make",">web-server-internal/dispatch-pathprocedure.html#(def._((lib._web-server/dispatchers/dispatch-pathprocedure..rkt)._make))",[0,[2,"make"]],["web-server/dispatchers/dispatch-pathprocedure"]],
["make",">web-server-internal/dispatch-sequencer.html#(def._((lib._web-server/dispatchers/dispatch-sequencer..rkt)._make))",[0,[2,"make"]],["web-server/dispatchers/dispatch-sequencer"]],
["make",">web-server-internal/dispatch-servlets.html#(def._((lib._web-server/dispatchers/dispatch-servlets..rkt)._make))",[0,[2,"make"]],["web-server/dispatchers/dispatch-servlets"]],
["make",">web-server-internal/dispatch-stat.html#(def._((lib._web-server/dispatchers/dispatch-stat..rkt)._make))",[0,[2,"make"]],["web-server/dispatchers/dispatch-stat"]],
["make",">web-server-internal/dispatch-timeout.html#(def._((lib._web-server/dispatchers/dispatch-timeout..rkt)._make))",[0,[2,"make"]],["web-server/dispatchers/dispatch-timeout"]],
["make",">web-server-internal/limit.html#(def._((lib._web-server/dispatchers/limit..rkt)._make))",[0,[2,"make"]],["web-server/dispatchers/limit"]],
["make from dependencies",">make/make.html","Make from Dependencies",false],
["make-->vector",">mzlib/mzlib_struct.html#(form._((lib._mzlib/struct..rkt)._make--~3evector))",[0,[1,"make-->vector"]],["mzlib/struct"]],
["make--map",">html/index.html#(def._((lib._html/main..rkt)._make--map))",[0,[2,"make--map"]],["html"]],
["make-a",">html/index.html#(def._((lib._html/main..rkt)._make-a))",[0,[2,"make-a"]],["html"]],
["make-abbr",">html/index.html#(def._((lib._html/main..rkt)._make-abbr))",[0,[2,"make-abbr"]],["html"]],
["make-acronym",">html/index.html#(def._((lib._html/main..rkt)._make-acronym))",[0,[2,"make-acronym"]],["html"]],
["make-address",">html/index.html#(def._((lib._html/main..rkt)._make-address))",[0,[2,"make-address"]],["html"]],
["make-adjustable-skip-list",">data/skip-list.html#(def._((lib._data/skip-list..rkt)._make-adjustable-skip-list))",[0,[2,"make-adjustable-skip-list"]],["data/skip-list"]],
["make-adjustable-splay-tree",">data/Splay_Trees.html#(def._((lib._data/splay-tree..rkt)._make-adjustable-splay-tree))",[0,[2,"make-adjustable-splay-tree"]],["data/splay-tree"]],
["make-alink",">html/index.html#(def._((lib._html/main..rkt)._make-alink))",[0,[2,"make-alink"]],["html"]],
["make-all-from-module",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-all-from-module))",[0,[2,"make-all-from-module"]],["compiler/zo-structs"]],
["make-alpha-color",">htdp/index.html#(def._((lib._htdp/color-structs..rkt)._make-alpha-color))",[0,[2,"make-alpha-color"]],["htdp/color-structs"]],
["make-alpha-color",">teachpack/image.html#(def._((lib._htdp/image..rkt)._make-alpha-color))",[0,[2,"make-alpha-color"]],["htdp/image"]],
["make-alpha-color",">deinprogramm/image.html#(def._((lib._deinprogramm/image..rkt)._make-alpha-color))",[0,[2,"make-alpha-color"]],["teachpack/deinprogramm/image"]],
["make-alt-tag",">scribble/core.html#(def._((lib._scribble/html-properties..rkt)._make-alt-tag))",[0,[2,"make-alt-tag"]],["scribble/html-properties"]],
["make-applet",">html/index.html#(def._((lib._html/main..rkt)._make-applet))",[0,[2,"make-applet"]],["html"]],
["make-application",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-application))",[0,[2,"make-application"]],["compiler/zo-structs"]],
["make-apply-values",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-apply-values))",[0,[2,"make-apply-values"]],["compiler/zo-structs"]],
["make-area",">html/index.html#(def._((lib._html/main..rkt)._make-area))",[0,[2,"make-area"]],["html"]],
["make-argb",">mrlib/Cache-image_Snip.html#(def._((lib._mrlib/cache-image-snip..rkt)._make-argb))",[0,[2,"make-argb"]],["mrlib/cache-image-snip"]],
["make-arity-at-least",">reference/procedures.html#(def._((lib._racket/private/base..rkt)._make-arity-at-least))",[0,[2,"make-arity-at-least"]],["racket/base","racket"]],
["make-array",">srfi-std/srfi-25.html#make-array",[0,[2,"make-array"]],["srfi/25"]],
["make-array-type",">foreign/C_Array_Types.html#(def._((quote._~23~25foreign)._make-array-type))",[0,[2,"make-array-type"]],["ffi/unsafe"]],
["make-article-not-found",">net/nntp.html#(def._((lib._net/nntp..rkt)._make-article-not-found))",[0,[2,"make-article-not-found"]],["net/nntp"]],
["make-article-not-in-group",">net/nntp.html#(def._((lib._net/nntp..rkt)._make-article-not-in-group))",[0,[2,"make-article-not-in-group"]],["net/nntp"]],
["make-assertion-violation",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_440",[0,[2,"make-assertion-violation"]],["rnrs/conditions-6"]],
["make-assign",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-assign))",[0,[2,"make-assign"]],["compiler/zo-structs"]],
["make-async-bi-channel",">reference/distributed-places.html#(def._((lib._racket/place/private/async-bi-channel..rkt)._make-async-bi-channel))",[0,[2,"make-async-bi-channel"]],["racket/place/private/async-bi-channel"]],
["make-async-channel",">reference/async-channel.html#(def._((lib._racket/async-channel..rkt)._make-async-channel))",[0,[2,"make-async-channel"]],["racket/async-channel"]],
["make-at-reader",">scribble/reader-internals.html#(def._((lib._scribble/reader..rkt)._make-at-reader))",[0,[2,"make-at-reader"]],["scribble/reader"]],
["make-at-readtable",">scribble/reader-internals.html#(def._((lib._scribble/reader..rkt)._make-at-readtable))",[0,[2,"make-at-readtable"]],["scribble/reader"]],
["make-attribute",">xml/index.html#(def._((lib._xml/main..rkt)._make-attribute))",[0,[2,"make-attribute"]],["xml"]],
["make-attributes",">scribble/core.html#(def._((lib._scribble/html-properties..rkt)._make-attributes))",[0,[2,"make-attributes"]],["scribble/html-properties"]],
["make-authentication-rejected",">net/nntp.html#(def._((lib._net/nntp..rkt)._make-authentication-rejected))",[0,[2,"make-authentication-rejected"]],["net/nntp"]],
["make-aux-element",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._make-aux-element))",[0,[2,"make-aux-element"]],["scribble/struct"]],
["make-auxiliary-table",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._make-auxiliary-table))",[0,[2,"make-auxiliary-table"]],["scribble/struct"]],
["make-axis-transform",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._make-axis-transform))",[0,[2,"make-axis-transform"]],["plot"]],
["make-b",">html/index.html#(def._((lib._html/main..rkt)._make-b))",[0,[2,"make-b"]],["html"]],
["make-background-color-property",">scribble/core.html#(def._((lib._scribble/core..rkt)._make-background-color-property))",[0,[2,"make-background-color-property"]],["scribble/core"]],
["make-background-region",">cards/index.html#(def._((lib._games/cards..rkt)._make-background-region))",[0,[2,"make-background-region"]],["games/cards"]],
["make-bad-newsgroup-line",">net/nntp.html#(def._((lib._net/nntp..rkt)._make-bad-newsgroup-line))",[0,[2,"make-bad-newsgroup-line"]],["net/nntp"]],
["make-bad-status-line",">net/nntp.html#(def._((lib._net/nntp..rkt)._make-bad-status-line))",[0,[2,"make-bad-status-line"]],["net/nntp"]],
["make-balloon",">slideshow/More_Pict_Constructors.html#(def._((lib._slideshow/balloon..rkt)._make-balloon))",[0,[2,"make-balloon"]],["slideshow/balloon"]],
["make-base",">html/index.html#(def._((lib._html/main..rkt)._make-base))",[0,[2,"make-base"]],["html"]],
["make-base-empty-namespace",">reference/Namespaces.html#(def._((lib._racket/private/base..rkt)._make-base-empty-namespace))",[0,[2,"make-base-empty-namespace"]],["racket/base","racket"]],
["make-base-empty-namespace",">scheme/scheme_base.html#(def._((lib._scheme/base..rkt)._make-base-empty-namespace))",[0,[2,"make-base-empty-namespace"]],["scheme/base"]],
["make-base-eval",">scribble/eval.html#(def._((lib._scribble/eval..rkt)._make-base-eval))",[0,[2,"make-base-eval"]],["scribble/eval"]],
["make-base-eval-factory",">scribble/eval.html#(def._((lib._scribble/eval..rkt)._make-base-eval-factory))",[0,[2,"make-base-eval-factory"]],["scribble/eval"]],
["make-base-namespace",">reference/Namespaces.html#(def._((lib._racket/private/base..rkt)._make-base-namespace))",[0,[2,"make-base-namespace"]],["racket/base","racket"]],
["make-base-namespace",">scheme/scheme_base.html#(def._((lib._scheme/base..rkt)._make-base-namespace))",[0,[2,"make-base-namespace"]],["scheme/base"]],
["make-basefont",">html/index.html#(def._((lib._html/main..rkt)._make-basefont))",[0,[2,"make-basefont"]],["html"]],
["make-basic-auth-header",">web-server/http.html#(def._((lib._web-server/http/basic-auth..rkt)._make-basic-auth-header))",[0,[2,"make-basic-auth-header"]],["web-server/http/basic-auth"]],
["make-basic-denied?/path",">web-server-internal/dispatch-passwords.html#(def._((lib._web-server/dispatchers/dispatch-passwords..rkt)._make-basic-denied~3f/path))",[0,[2,"make-basic-denied?/path"]],["web-server/dispatchers/dispatch-passwords"]],
["make-bdo",">html/index.html#(def._((lib._html/main..rkt)._make-bdo))",[0,[2,"make-bdo"]],["html"]],
["make-beg0",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-beg0))",[0,[2,"make-beg0"]],["compiler/zo-structs"]],
["make-bib",">scriblib/autobib.html#(def._((lib._scriblib/autobib..rkt)._make-bib))",[0,[2,"make-bib"]],["scriblib/autobib"]],
["make-big",">html/index.html#(def._((lib._html/main..rkt)._make-big))",[0,[2,"make-big"]],["html"]],
["make-bind",">redex/The_Redex_Reference.html#(def._((lib._redex/reduction-semantics..rkt)._make-bind))",[0,[2,"make-bind"]],["redex/reduction-semantics","redex"]],
["make-binding",">web-server/http.html#(def._((lib._web-server/http/request-structs..rkt)._make-binding))",[0,[2,"make-binding"]],["web-server/http/request-structs"]],
["make-binding:file",">web-server/http.html#(def._((lib._web-server/http/request-structs..rkt)._make-binding~3afile))",[0,[2,"make-binding:file"]],["web-server/http/request-structs"]],
["make-binding:form",">web-server/http.html#(def._((lib._web-server/http/request-structs..rkt)._make-binding~3aform))",[0,[2,"make-binding:form"]],["web-server/http/request-structs"]],
["make-bitmap",">draw/Drawing_Functions.html#(def._((lib._racket/draw..rkt)._make-bitmap))",[0,[2,"make-bitmap"]],["racket/draw"]],
["make-bitmap",">gui/canvas_.html#(meth._(((lib._mred/main..rkt)._canvas~25)._make-bitmap))",[[0,[2,"make-bitmap"]],[14,[" (method of ",[0,[2,"canvas%"]],")"]]],["racket/gui/base","racket/gui"]],
["make-bitmap-label",">mrlib/Bitmap_Label.html#(def._((lib._mrlib/bitmap-label..rkt)._make-bitmap-label))",[0,[2,"make-bitmap-label"]],["mrlib/bitmap-label"]],
["make-blockquote",">html/index.html#(def._((lib._html/main..rkt)._make-blockquote))",[0,[2,"make-blockquote"]],["html"]],
["make-blockquote",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._make-blockquote))",[0,[2,"make-blockquote"]],["scribble/struct"]],
["make-body",">html/index.html#(def._((lib._html/main..rkt)._make-body))",[0,[2,"make-body"]],["html"]],
["make-body-id",">scribble/core.html#(def._((lib._scribble/html-properties..rkt)._make-body-id))",[0,[2,"make-body-id"]],["scribble/html-properties"]],
["make-bound-id-table",">syntax/syntax-helpers.html#(def._((lib._syntax/id-table..rkt)._make-bound-id-table))",[0,[2,"make-bound-id-table"]],["syntax/id-table"]],
["make-bound-identifier-mapping",">syntax/syntax-helpers.html#(def._((lib._syntax/boundmap..rkt)._make-bound-identifier-mapping))",[0,[2,"make-bound-identifier-mapping"]],["syntax/boundmap"]],
["make-box-mode",">scribble/core.html#(def._((lib._scribble/core..rkt)._make-box-mode))",[0,[2,"make-box-mode"]],["scribble/core"]],
["make-boxenv",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-boxenv))",[0,[2,"make-boxenv"]],["compiler/zo-structs"]],
["make-br",">html/index.html#(def._((lib._html/main..rkt)._make-br))",[0,[2,"make-br"]],["html"]],
["make-branch",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-branch))",[0,[2,"make-branch"]],["compiler/zo-structs"]],
["make-brinfo",">tools/Documentation_Utilities.html#(def._((lib._help/bug-report..rkt)._make-brinfo))",[0,[2,"make-brinfo"]],["help/bug-report"]],
["make-brush",">draw/Drawing_Functions.html#(def._((lib._racket/draw..rkt)._make-brush))",[0,[2,"make-brush"]],["racket/draw"]],
["make-bundle",">teachpack/2htdpuniverse.html#(def._((lib._2htdp/universe..rkt)._make-bundle))",[0,[2,"make-bundle"]],["2htdp/universe"]],
["make-button",">teachpack/gui.html#(def._((lib._htdp/gui..rkt)._make-button))",[0,[2,"make-button"]],["htdp/gui"]],
["make-button",">html/index.html#(def._((lib._html/main..rkt)._make-button))",[0,[2,"make-button"]],["html"]],
["make-button-region",">cards/index.html#(def._((lib._games/cards..rkt)._make-button-region))",[0,[2,"make-button-region"]],["games/cards"]],
["make-bytes",">reference/bytestrings.html#(def._((quote._~23~25kernel)._make-bytes))",[0,[2,"make-bytes"]],["racket/base","racket"]],
["make-bytevector",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_82",[0,[2,"make-bytevector"]],["rnrs/bytevectors-6"]],
["make-c-parameter",">foreign/Loading_Foreign_Libraries.html#(def._((lib._ffi/unsafe..rkt)._make-c-parameter))",[0,[2,"make-c-parameter"]],["ffi/unsafe"]],
["make-cache-table",">web-server-internal/cache-table.html#(def._((lib._web-server/private/cache-table..rkt)._make-cache-table))",[0,[2,"make-cache-table"]],["web-server/private/cache-table"]],
["make-cached-url->servlet",">web-server-internal/dispatch-servlets.html#(def._((lib._web-server/dispatchers/dispatch-servlets..rkt)._make-cached-url-~3eservlet))",[0,[2,"make-cached-url->servlet"]],["web-server/dispatchers/dispatch-servlets"]],
["make-caching-managed-compile-zo",">raco/make.html#(def._((lib._compiler/cm..rkt)._make-caching-managed-compile-zo))",[0,[2,"make-caching-managed-compile-zo"]],["compiler/cm"]],
["make-cannot-connect",">net/pop3.html#(def._((lib._net/pop3..rkt)._make-cannot-connect))",[0,[2,"make-cannot-connect"]],["net/pop3"]],
["make-cannot-delete-message",">net/pop3.html#(def._((lib._net/pop3..rkt)._make-cannot-delete-message))",[0,[2,"make-cannot-delete-message"]],["net/pop3"]],
["make-canvas",">browser/index.html#(meth._(((lib._browser/browser..rkt)._hyper-panel-mixin)._make-canvas))",[[0,[2,"make-canvas"]],[14,[" (method of ",[0,[2,"hyper-panel-mixin"]],")"]]],["browser/browser","browser"]],
["make-caption",">html/index.html#(def._((lib._html/main..rkt)._make-caption))",[0,[2,"make-caption"]],["html"]],
["make-card",">cards/index.html#(def._((lib._games/cards..rkt)._make-card))",[0,[2,"make-card"]],["games/cards"]],
["make-case-lam",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-case-lam))",[0,[2,"make-case-lam"]],["compiler/zo-structs"]],
["make-cdata",">xml/index.html#(def._((lib._xml/main..rkt)._make-cdata))",[0,[2,"make-cdata"]],["xml"]],
["make-center",">html/index.html#(def._((lib._html/main..rkt)._make-center))",[0,[2,"make-center"]],["html"]],
["make-channel",">reference/channel.html#(def._((quote._~23~25kernel)._make-channel))",[0,[2,"make-channel"]],["racket/base","racket"]],
["make-chaperone-contract",">reference/Building_New_Contract_Combinators.html#(def._((lib._racket/contract/private/prop..rkt)._make-chaperone-contract))",[0,[2,"make-chaperone-contract"]],["racket/contract/combinator","racket/contract","racket"]],
["make-check-actual",">rackunit/api.html#(def._((lib._rackunit/main..rkt)._make-check-actual))",[0,[2,"make-check-actual"]],["rackunit"]],
["make-check-digest-credentials",">web-server/http.html#(def._((lib._web-server/http/digest-auth..rkt)._make-check-digest-credentials))",[0,[2,"make-check-digest-credentials"]],["web-server/http/digest-auth"]],
["make-check-expected",">rackunit/api.html#(def._((lib._rackunit/main..rkt)._make-check-expected))",[0,[2,"make-check-expected"]],["rackunit"]],
["make-check-expression",">rackunit/api.html#(def._((lib._rackunit/main..rkt)._make-check-expression))",[0,[2,"make-check-expression"]],["rackunit"]],
["make-check-info",">rackunit/api.html#(def._((lib._rackunit/main..rkt)._make-check-info))",[0,[2,"make-check-info"]],["rackunit"]],
["make-check-location",">rackunit/api.html#(def._((lib._rackunit/main..rkt)._make-check-location))",[0,[2,"make-check-location"]],["rackunit"]],
["make-check-message",">rackunit/api.html#(def._((lib._rackunit/main..rkt)._make-check-message))",[0,[2,"make-check-message"]],["rackunit"]],
["make-check-name",">rackunit/api.html#(def._((lib._rackunit/main..rkt)._make-check-name))",[0,[2,"make-check-name"]],["rackunit"]],
["make-check-params",">rackunit/api.html#(def._((lib._rackunit/main..rkt)._make-check-params))",[0,[2,"make-check-params"]],["rackunit"]],
["make-child",">slideshow/Pict_Datatype.html#(def._((lib._slideshow/pict..rkt)._make-child))",[0,[2,"make-child"]],["slideshow/pict","slideshow"]],
["make-chocolate-cookie",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._make-chocolate-cookie))",[0,[2,"make-chocolate-cookie"]],["deinprogramm/DMdA-advanced"]],
["make-chocolate-cookie",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._make-chocolate-cookie))",[0,[2,"make-chocolate-cookie"]],["deinprogramm/DMdA-assignments"]],
["make-chocolate-cookie",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._make-chocolate-cookie))",[0,[2,"make-chocolate-cookie"]],["deinprogramm/DMdA-beginner"]],
["make-chocolate-cookie",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._make-chocolate-cookie))",[0,[2,"make-chocolate-cookie"]],["deinprogramm/DMdA-vanilla"]],
["make-choice",">teachpack/gui.html#(def._((lib._htdp/gui..rkt)._make-choice))",[0,[2,"make-choice"]],["htdp/gui"]],
["make-cite",">html/index.html#(def._((lib._html/main..rkt)._make-cite))",[0,[2,"make-cite"]],["html"]],
["make-class-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..rkt)._make-class-index-desc))",[0,[2,"make-class-index-desc"]],["scribble/manual-struct"]],
["make-client-cookie",">web-server/http.html#(def._((lib._web-server/http/cookie-parse..rkt)._make-client-cookie))",[0,[2,"make-client-cookie"]],["web-server/http/cookie-parse"]],
["make-closure",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-closure))",[0,[2,"make-closure"]],["compiler/zo-structs"]],
["make-code",">html/index.html#(def._((lib._html/main..rkt)._make-code))",[0,[2,"make-code"]],["html"]],
["make-coerce-safe?",">web-server/dispatch.html#(def._((lib._web-server/dispatch/extend..rkt)._make-coerce-safe~3f))",[0,[2,"make-coerce-safe?"]],["web-server/dispatch/extend"]],
["make-col",">html/index.html#(def._((lib._html/main..rkt)._make-col))",[0,[2,"make-col"]],["html"]],
["make-colgroup",">html/index.html#(def._((lib._html/main..rkt)._make-colgroup))",[0,[2,"make-colgroup"]],["html"]],
["make-collect-element",">scribble/core.html#(def._((lib._scribble/core..rkt)._make-collect-element))",[0,[2,"make-collect-element"]],["scribble/core"]],
["make-collect-info",">scribble/core.html#(def._((lib._scribble/core..rkt)._make-collect-info))",[0,[2,"make-collect-info"]],["scribble/core"]],
["make-collected-info",">scribble/core.html#(def._((lib._scribble/core..rkt)._make-collected-info))",[0,[2,"make-collected-info"]],["scribble/core"]],
["make-collection",">make/collection.html#(def._((lib._make/collection..rkt)._make-collection))",[0,[2,"make-collection"]],["make/collection"]],
["make-color",">draw/Drawing_Functions.html#(def._((lib._racket/draw..rkt)._make-color))",[0,[2,"make-color"]],["racket/draw"]],
["make-color",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._make-color))",[0,[2,"make-color"]],["2htdp/image"]],
["make-color",">htdp/index.html#(def._((lib._htdp/color-structs..rkt)._make-color))",[0,[2,"make-color"]],["htdp/color-structs"]],
["make-color",">teachpack/image.html#(def._((lib._htdp/image..rkt)._make-color))",[0,[2,"make-color"]],["htdp/image"]],
["make-color",">deinprogramm/image.html#(def._((lib._deinprogramm/image..rkt)._make-color))",[0,[2,"make-color"]],["teachpack/deinprogramm/image"]],
["make-color-property",">scribble/core.html#(def._((lib._scribble/core..rkt)._make-color-property))",[0,[2,"make-color-property"]],["scribble/core"]],
["make-column-attributes",">scribble/core.html#(def._((lib._scribble/html-properties..rkt)._make-column-attributes))",[0,[2,"make-column-attributes"]],["scribble/html-properties"]],
["make-com-object",">foreign/com-intf.html#(def._((lib._ffi/unsafe/com..rkt)._make-com-object))",[0,[2,"make-com-object"]],["ffi/unsafe/com"]],
["make-comment",">xml/index.html#(def._((lib._xml/main..rkt)._make-comment))",[0,[2,"make-comment"]],["xml"]],
["make-communicator",">net/nntp.html#(def._((lib._net/nntp..rkt)._make-communicator))",[0,[2,"make-communicator"]],["net/nntp"]],
["make-communicator",">net/pop3.html#(def._((lib._net/pop3..rkt)._make-communicator))",[0,[2,"make-communicator"]],["net/pop3"]],
["make-compilation-manager-load/use-compiled-handler",">raco/make.html#(def._((lib._compiler/cm..rkt)._make-compilation-manager-load/use-compiled-handler))",[0,[2,"make-compilation-manager-load/use-compiled-handler"]],["compiler/cm"]],
["make-compilation-top",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-compilation-top))",[0,[2,"make-compilation-top"]],["compiler/zo-structs"]],
["make-compile-lock",">raco/make.html#(def._((lib._compiler/cm..rkt)._make-compile-lock))",[0,[2,"make-compile-lock"]],["compiler/cm"]],
["make-composite-input",">preprocessor/mztext.html#(def._((lib._preprocessor/mztext..rkt)._make-composite-input))",[0,[2,"make-composite-input"]],["preprocessor/mztext"]],
["make-compound-paragraph",">scribble/core.html#(def._((lib._scribble/core..rkt)._make-compound-paragraph))",[0,[2,"make-compound-paragraph"]],["scribble/core"]],
["make-compound-paragraph",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._make-compound-paragraph))",[0,[2,"make-compound-paragraph"]],["scribble/struct"]],
["make-computer",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._make-computer))",[0,[2,"make-computer"]],["deinprogramm/DMdA-advanced"]],
["make-computer",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._make-computer))",[0,[2,"make-computer"]],["deinprogramm/DMdA-assignments"]],
["make-computer",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._make-computer))",[0,[2,"make-computer"]],["deinprogramm/DMdA-beginner"]],
["make-computer",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._make-computer))",[0,[2,"make-computer"]],["deinprogramm/DMdA-vanilla"]],
["make-configuration-table",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._make-configuration-table))",[0,[2,"make-configuration-table"]],["web-server/configuration/configuration-table-structs"]],
["make-connection",">web-server-internal/connection-manager.html#(def._((lib._web-server/private/connection-manager..rkt)._make-connection))",[0,[2,"make-connection"]],["web-server/private/connection-manager"]],
["make-continuation-mark-key",">reference/contmarks.html#(def._((quote._~23~25kernel)._make-continuation-mark-key))",[0,[2,"make-continuation-mark-key"]],["racket/base","racket"]],
["make-continuation-prompt-tag",">reference/cont.html#(def._((quote._~23~25kernel)._make-continuation-prompt-tag))",[0,[2,"make-continuation-prompt-tag"]],["racket/base","racket"]],
["make-contract",">reference/Building_New_Contract_Combinators.html#(def._((lib._racket/contract/private/prop..rkt)._make-contract))",[0,[2,"make-contract"]],["racket/contract/combinator","racket/contract","racket"]],
["make-control-bar-panel",">browser/index.html#(meth._(((lib._browser/browser..rkt)._hyper-panel-mixin)._make-control-bar-panel))",[[0,[2,"make-control-bar-panel"]],[14,[" (method of ",[0,[2,"hyper-panel-mixin"]],")"]]],["browser/browser","browser"]],
["make-cookie",">web-server/http.html#(def._((lib._web-server/http/cookie..rkt)._make-cookie))",[0,[2,"make-cookie"]],["web-server/http/cookie"]],
["make-cookie-error",">net/cookie.html#(def._((lib._net/cookie..rkt)._make-cookie-error))",[0,[2,"make-cookie-error"]],["net/cookie"]],
["make-counterexample",">redex/The_Redex_Reference.html#(def._((lib._redex/reduction-semantics..rkt)._make-counterexample))",[0,[2,"make-counterexample"]],["redex/reduction-semantics","redex"]],
["make-coverage",">redex/The_Redex_Reference.html#(form._((lib._redex/reduction-semantics..rkt)._make-coverage))",[0,[1,"make-coverage"]],["redex/reduction-semantics","redex"]],
["make-css-addition",">scribble/core.html#(def._((lib._scribble/html-properties..rkt)._make-css-addition))",[0,[2,"make-css-addition"]],["scribble/html-properties"]],
["make-cstruct-type",">foreign/C_Struct_Types.html#(def._((quote._~23~25foreign)._make-cstruct-type))",[0,[2,"make-cstruct-type"]],["ffi/unsafe"]],
["make-ctype",">foreign/ctype.html#(def._((quote._~23~25foreign)._make-ctype))",[0,[2,"make-ctype"]],["ffi/unsafe"]],
["make-custodian",">reference/custodians.html#(def._((quote._~23~25kernel)._make-custodian))",[0,[2,"make-custodian"]],["racket/base","racket"]],
["make-custodian-box",">reference/custodians.html#(def._((quote._~23~25kernel)._make-custodian-box))",[0,[2,"make-custodian-box"]],["racket/base","racket"]],
["make-custom-binary-input-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_680",[0,[2,"make-custom-binary-input-port"]],["rnrs/io/ports-6"]],
["make-custom-binary-input/output-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_762",[0,[2,"make-custom-binary-input/output-port"]],["rnrs/io/ports-6"]],
["make-custom-binary-output-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_738",[0,[2,"make-custom-binary-output-port"]],["rnrs/io/ports-6"]],
["make-custom-hash",">reference/dicts.html#(def._((lib._racket/dict..rkt)._make-custom-hash))",[0,[2,"make-custom-hash"]],["racket/dict","racket"]],
["make-custom-textual-input-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_682",[0,[2,"make-custom-textual-input-port"]],["rnrs/io/ports-6"]],
["make-custom-textual-input/output-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_764",[0,[2,"make-custom-textual-input/output-port"]],["rnrs/io/ports-6"]],
["make-custom-textual-output-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_740",[0,[2,"make-custom-textual-output-port"]],["rnrs/io/ports-6"]],
["make-cvector",">foreign/foreign_cvector.html#(def._((lib._ffi/unsafe/cvector..rkt)._make-cvector))",[0,[2,"make-cvector"]],["ffi/cvector","ffi/unsafe/cvector"]],
["make-cvector*",">foreign/foreign_cvector.html#(def._((lib._ffi/unsafe/cvector..rkt)._make-cvector*))",[0,[2,"make-cvector*"]],["ffi/cvector","ffi/unsafe/cvector"]],
["make-data-set",">mrlib/Plot.html#(def._((lib._mrlib/plot..rkt)._make-data-set))",[0,[2,"make-data-set"]],["mrlib/plot"]],
["make-date",">reference/time.html#(def._((lib._racket/private/base..rkt)._make-date))",[0,[2,"make-date"]],["racket/base","racket"]],
["make-date",">srfi-std/srfi-19.html#make-date",[0,[2,"make-date"]],["srfi/19"]],
["make-date*",">reference/time.html#(def._((lib._racket/private/base..rkt)._make-date*))",[0,[2,"make-date*"]],["racket/base","racket"]],
["make-dd",">html/index.html#(def._((lib._html/main..rkt)._make-dd))",[0,[2,"make-dd"]],["html"]],
["make-deck",">cards/index.html#(def._((lib._games/cards..rkt)._make-deck))",[0,[2,"make-deck"]],["games/cards"]],
["make-def-syntaxes",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-def-syntaxes))",[0,[2,"make-def-syntaxes"]],["compiler/zo-structs"]],
["make-def-values",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-def-values))",[0,[2,"make-def-values"]],["compiler/zo-structs"]],
["make-default-path->servlet",">web-server-internal/dispatch-servlets.html#(def._((lib._web-server/servlet/setup..rkt)._make-default-path-~3eservlet))",[0,[2,"make-default-path->servlet"]],["web-server/servlet/setup"]],
["make-default-stuffer",">web-server/stateless.html#(def._((lib._web-server/lang/stuff-url..rkt)._make-default-stuffer))",[0,[2,"make-default-stuffer"]],["web-server/lang/stuff-url"]],
["make-del",">html/index.html#(def._((lib._html/main..rkt)._make-del))",[0,[2,"make-del"]],["html"]],
["make-delayed-block",">scribble/core.html#(def._((lib._scribble/core..rkt)._make-delayed-block))",[0,[2,"make-delayed-block"]],["scribble/core"]],
["make-delayed-element",">scribble/core.html#(def._((lib._scribble/core..rkt)._make-delayed-element))",[0,[2,"make-delayed-element"]],["scribble/core"]],
["make-derived-parameter",">reference/parameters.html#(def._((quote._~23~25kernel)._make-derived-parameter))",[0,[2,"make-derived-parameter"]],["racket/base","racket"]],
["make-deserialize-info",">reference/serialization.html#(def._((lib._racket/private/serialize..rkt)._make-deserialize-info))",[0,[2,"make-deserialize-info"]],["racket/serialize"]],
["make-desired-header",">net/nntp.html#(def._((lib._net/nntp..rkt)._make-desired-header))",[0,[2,"make-desired-header"]],["net/nntp"]],
["make-desired-header",">net/pop3.html#(def._((lib._net/pop3..rkt)._make-desired-header))",[0,[2,"make-desired-header"]],["net/pop3"]],
["make-dfn",">html/index.html#(def._((lib._html/main..rkt)._make-dfn))",[0,[2,"make-dfn"]],["html"]],
["make-digest-auth-header",">web-server/http.html#(def._((lib._web-server/http/digest-auth..rkt)._make-digest-auth-header))",[0,[2,"make-digest-auth-header"]],["web-server/http/digest-auth"]],
["make-dir",">teachpack/dir.html#(def._((lib._htdp/dir..rkt)._make-dir))",[0,[2,"make-dir"]],["htdp/dir"]],
["make-dir",">html/index.html#(def._((lib._html/main..rkt)._make-dir))",[0,[2,"make-dir"]],["html"]],
["make-directory",">reference/Filesystem.html#(def._((quote._~23~25kernel)._make-directory))",[0,[2,"make-directory"]],["racket/base","racket"]],
["make-directory*",">reference/Filesystem.html#(def._((lib._racket/file..rkt)._make-directory*))",[0,[2,"make-directory*"]],["racket/file","racket"]],
["make-directory*/ignore-exists-exn",">unstable/file.html#(def._((lib._unstable/file..rkt)._make-directory*/ignore-exists-exn))",[0,[2,"make-directory*/ignore-exists-exn"]],["unstable/file"]],
["make-directory-record",">raco/getinfo.html#(def._((lib._setup/getinfo..rkt)._make-directory-record))",[0,[2,"make-directory-record"]],["setup/getinfo"]],
["make-disconnect-not-quiet",">net/pop3.html#(def._((lib._net/pop3..rkt)._make-disconnect-not-quiet))",[0,[2,"make-disconnect-not-quiet"]],["net/pop3"]],
["make-disposition",">net/mime.html#(def._((lib._net/mime..rkt)._make-disposition))",[0,[2,"make-disposition"]],["net/mime"]],
["make-div",">html/index.html#(def._((lib._html/main..rkt)._make-div))",[0,[2,"make-div"]],["html"]],
["make-dl",">html/index.html#(def._((lib._html/main..rkt)._make-dl))",[0,[2,"make-dl"]],["html"]],
["make-do-sequence",">reference/sequences.html#(def._((lib._racket/private/base..rkt)._make-do-sequence))",[0,[2,"make-do-sequence"]],["racket/base","racket"]],
["make-docs",">raco/setup-plt-plt.html#(sig-val._((lib._setup/option-sig..rkt)._setup-option~5e._make-docs))",[0,[2,"make-docs"]],["setup/option-sig"]],
["make-document",">xml/index.html#(def._((lib._xml/main..rkt)._make-document))",[0,[2,"make-document"]],["xml"]],
["make-document-date",">scribble/core.html#(def._((lib._scribble/core..rkt)._make-document-date))",[0,[2,"make-document-date"]],["scribble/core"]],
["make-document-type",">xml/index.html#(def._((lib._xml/main..rkt)._make-document-type))",[0,[2,"make-document-type"]],["xml"]],
["make-document-version",">scribble/core.html#(def._((lib._scribble/core..rkt)._make-document-version))",[0,[2,"make-document-version"]],["scribble/core"]],
["make-dt",">html/index.html#(def._((lib._html/main..rkt)._make-dt))",[0,[2,"make-dt"]],["html"]],
["make-editor",">framework/Comment_Box.html#(meth._(((lib._framework/main..rkt)._comment-box~3asnip~25)._make-editor))",[[0,[2,"make-editor"]],[14,[" (method of ",[0,[2,"comment-box:snip%"]],")"]]],["framework"]],
["make-editor",">framework/editor-snip.html#(meth._(((lib._framework/main..rkt)._editor-snip~3adecorated~25)._make-editor))",[[0,[2,"make-editor"]],[14,[" (method of ",[0,[2,"editor-snip:decorated%"]],")"]]],["framework"]],
["make-editor",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3aeditor~3c~25~3e)._make-editor))",[[0,[2,"make-editor"]],[14,[" (method of ",[0,[2,"frame:editor<%>"]],")"]]],["framework"]],
["make-element",">scribble/core.html#(def._((lib._scribble/core..rkt)._make-element))",[0,[2,"make-element"]],["scribble/core"]],
["make-element",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._make-element))",[0,[2,"make-element"]],["scribble/struct"]],
["make-element",">xml/index.html#(def._((lib._xml/main..rkt)._make-element))",[0,[2,"make-element"]],["xml"]],
["make-element-id-transformer",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._make-element-id-transformer))",[0,[2,"make-element-id-transformer"]],["scribble/racket","scribble/scheme"]],
["make-em",">html/index.html#(def._((lib._html/main..rkt)._make-em))",[0,[2,"make-em"]],["html"]],
["make-embedding-executable",">raco/exe.html#(def._((lib._compiler/embed..rkt)._make-embedding-executable))",[0,[2,"make-embedding-executable"]],["compiler/embed"]],
["make-empty-disposition-type",">net/mime.html#(def._((lib._net/mime..rkt)._make-empty-disposition-type))",[0,[2,"make-empty-disposition-type"]],["net/mime"]],
["make-empty-mechanism",">net/mime.html#(def._((lib._net/mime..rkt)._make-empty-mechanism))",[0,[2,"make-empty-mechanism"]],["net/mime"]],
["make-empty-namespace",">reference/Namespaces.html#(def._((quote._~23~25kernel)._make-empty-namespace))",[0,[2,"make-empty-namespace"]],["racket/base","racket"]],
["make-empty-subtype",">net/mime.html#(def._((lib._net/mime..rkt)._make-empty-subtype))",[0,[2,"make-empty-subtype"]],["net/mime"]],
["make-empty-type",">net/mime.html#(def._((lib._net/mime..rkt)._make-empty-type))",[0,[2,"make-empty-type"]],["net/mime"]],
["make-entity",">net/mime.html#(def._((lib._net/mime..rkt)._make-entity))",[0,[2,"make-entity"]],["net/mime"]],
["make-entity",">xml/index.html#(def._((lib._xml/main..rkt)._make-entity))",[0,[2,"make-entity"]],["xml"]],
["make-entry",">scribble/xref.html#(def._((lib._scribble/xref..rkt)._make-entry))",[0,[2,"make-entry"]],["scribble/xref"]],
["make-enumeration",">r6rs-lib-std/r6rs-lib-Z-H-15.html#node_idx_1236",[0,[2,"make-enumeration"]],["rnrs/enums-6"]],
["make-ephemeron",">reference/ephemerons.html#(def._((quote._~23~25kernel)._make-ephemeron))",[0,[2,"make-ephemeron"]],["racket/base","racket"]],
["make-eq-hashtable",">r6rs-lib-std/r6rs-lib-Z-H-14.html#node_idx_1174",[0,[2,"make-eq-hashtable"]],["rnrs/hashtables-6"]],
["make-eqv-hashtable",">r6rs-lib-std/r6rs-lib-Z-H-14.html#node_idx_1178",[0,[2,"make-eqv-hashtable"]],["rnrs/hashtables-6"]],
["make-error",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_428",[0,[2,"make-error"]],["rnrs/conditions-6"]],
["make-errortrace-compile-handler",">errortrace/errortrace-library.html#(def._((lib._errortrace/errortrace-lib..rkt)._make-errortrace-compile-handler))",[0,[2,"make-errortrace-compile-handler"]],["errortrace/errortrace-lib"]],
["make-eval-factory",">scribble/eval.html#(def._((lib._scribble/eval..rkt)._make-eval-factory))",[0,[2,"make-eval-factory"]],["scribble/eval"]],
["make-evaluator",">reference/Sandboxed_Evaluation.html#(def._((lib._racket/sandbox..rkt)._make-evaluator))",[0,[2,"make-evaluator"]],["racket/sandbox"]],
["make-evaluator",">mzlib/mzlib_sandbox.html#(def._((lib._mzlib/sandbox..rkt)._make-evaluator))",[0,[2,"make-evaluator"]],["mzlib/sandbox"]],
["make-evaluator",">scheme/scheme_sandbox.html#(def._((lib._scheme/sandbox..rkt)._make-evaluator))",[0,[2,"make-evaluator"]],["scheme/sandbox"]],
["make-eventspace",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._make-eventspace))",[0,[2,"make-eventspace"]],["racket/gui/base","racket/gui"]],
["make-exn",">reference/exns.html#(def._((lib._racket/private/base..rkt)._make-exn))",[0,[2,"make-exn"]],["racket/base","racket"]],
["make-exn:break",">reference/exns.html#(def._((lib._racket/private/base..rkt)._make-exn~3abreak))",[0,[2,"make-exn:break"]],["racket/base","racket"]],
["make-exn:cancelled",">browser/index.html#(def._((lib._browser/browser..rkt)._make-exn~3acancelled))",[0,[2,"make-exn:cancelled"]],["browser/browser","browser"]],
["make-exn:dispatcher",">web-server-internal/dispatch.html#(def._((lib._web-server/dispatchers/dispatch..rkt)._make-exn~3adispatcher))",[0,[2,"make-exn:dispatcher"]],["web-server/dispatchers/dispatch"]],
["make-exn:fail",">reference/exns.html#(def._((lib._racket/private/base..rkt)._make-exn~3afail))",[0,[2,"make-exn:fail"]],["racket/base","racket"]],
["make-exn:fail:contract",">reference/exns.html#(def._((lib._racket/private/base..rkt)._make-exn~3afail~3acontract))",[0,[2,"make-exn:fail:contract"]],["racket/base","racket"]],
["make-exn:fail:contract:arity",">reference/exns.html#(def._((lib._racket/private/base..rkt)._make-exn~3afail~3acontract~3aarity))",[0,[2,"make-exn:fail:contract:arity"]],["racket/base","racket"]],
["make-exn:fail:contract:blame",">reference/Building_New_Contract_Combinators.html#(def._((lib._racket/contract/private/blame..rkt)._make-exn~3afail~3acontract~3ablame))",[0,[2,"make-exn:fail:contract:blame"]],["racket/contract/combinator","racket/contract","racket"]],
["make-exn:fail:contract:continuation",">reference/exns.html#(def._((lib._racket/private/base..rkt)._make-exn~3afail~3acontract~3acontinuation))",[0,[2,"make-exn:fail:contract:continuation"]],["racket/base","racket"]],
["make-exn:fail:contract:divide-by-zero",">reference/exns.html#(def._((lib._racket/private/base..rkt)._make-exn~3afail~3acontract~3adivide-by-zero))",[0,[2,"make-exn:fail:contract:divide-by-zero"]],["racket/base","racket"]],
["make-exn:fail:contract:non-fixnum-result",">reference/exns.html#(def._((lib._racket/private/base..rkt)._make-exn~3afail~3acontract~3anon-fixnum-result))",[0,[2,"make-exn:fail:contract:non-fixnum-result"]],["racket/base","racket"]],
["make-exn:fail:contract:variable",">reference/exns.html#(def._((lib._racket/private/base..rkt)._make-exn~3afail~3acontract~3avariable))",[0,[2,"make-exn:fail:contract:variable"]],["racket/base","racket"]],
["make-exn:fail:filesystem",">reference/exns.html#(def._((lib._racket/private/base..rkt)._make-exn~3afail~3afilesystem))",[0,[2,"make-exn:fail:filesystem"]],["racket/base","racket"]],
["make-exn:fail:filesystem:exists",">reference/exns.html#(def._((lib._racket/private/base..rkt)._make-exn~3afail~3afilesystem~3aexists))",[0,[2,"make-exn:fail:filesystem:exists"]],["racket/base","racket"]],
["make-exn:fail:filesystem:version",">reference/exns.html#(def._((lib._racket/private/base..rkt)._make-exn~3afail~3afilesystem~3aversion))",[0,[2,"make-exn:fail:filesystem:version"]],["racket/base","racket"]],
["make-exn:fail:make",">make/make.html#(def._((lib._make/main..rkt)._make-exn~3afail~3amake))",[0,[2,"make-exn:fail:make"]],["make"]],
["make-exn:fail:network",">reference/exns.html#(def._((lib._racket/private/base..rkt)._make-exn~3afail~3anetwork))",[0,[2,"make-exn:fail:network"]],["racket/base","racket"]],
["make-exn:fail:object",">reference/objectutils.html#(def._((lib._racket/private/class-internal..rkt)._make-exn~3afail~3aobject))",[0,[2,"make-exn:fail:object"]],["racket/class","racket"]],
["make-exn:fail:out-of-memory",">reference/exns.html#(def._((lib._racket/private/base..rkt)._make-exn~3afail~3aout-of-memory))",[0,[2,"make-exn:fail:out-of-memory"]],["racket/base","racket"]],
["make-exn:fail:planet",">planet/Utility_Libraries.html#(def._((lib._planet/util..rkt)._make-exn~3afail~3aplanet))",[0,[2,"make-exn:fail:planet"]],["planet/util"]],
["make-exn:fail:read",">reference/exns.html#(def._((lib._racket/private/base..rkt)._make-exn~3afail~3aread))",[0,[2,"make-exn:fail:read"]],["racket/base","racket"]],
["make-exn:fail:read:eof",">reference/exns.html#(def._((lib._racket/private/base..rkt)._make-exn~3afail~3aread~3aeof))",[0,[2,"make-exn:fail:read:eof"]],["racket/base","racket"]],
["make-exn:fail:read:non-char",">reference/exns.html#(def._((lib._racket/private/base..rkt)._make-exn~3afail~3aread~3anon-char))",[0,[2,"make-exn:fail:read:non-char"]],["racket/base","racket"]],
["make-exn:fail:redex:test",">redex/The_Redex_Reference.html#(def._((lib._redex/reduction-semantics..rkt)._make-exn~3afail~3aredex~3atest))",[0,[2,"make-exn:fail:redex:test"]],["redex/reduction-semantics","redex"]],
["make-exn:fail:servlet-manager:no-continuation",">web-server/servlet.html#(def._((lib._web-server/managers/manager..rkt)._make-exn~3afail~3aservlet-manager~3ano-continuation))",[0,[2,"make-exn:fail:servlet-manager:no-continuation"]],["web-server/managers/manager"]],
["make-exn:fail:servlet-manager:no-instance",">web-server/servlet.html#(def._((lib._web-server/managers/manager..rkt)._make-exn~3afail~3aservlet-manager~3ano-instance))",[0,[2,"make-exn:fail:servlet-manager:no-instance"]],["web-server/managers/manager"]],
["make-exn:fail:sql",">db/query-api.html#(def._((lib._db/base..rkt)._make-exn~3afail~3asql))",[0,[2,"make-exn:fail:sql"]],["db","db/base"]],
["make-exn:fail:syntax",">reference/exns.html#(def._((lib._racket/private/base..rkt)._make-exn~3afail~3asyntax))",[0,[2,"make-exn:fail:syntax"]],["racket/base","racket"]],
["make-exn:fail:syntax:unbound",">reference/exns.html#(def._((lib._racket/private/base..rkt)._make-exn~3afail~3asyntax~3aunbound))",[0,[2,"make-exn:fail:syntax:unbound"]],["racket/base","racket"]],
["make-exn:fail:unsupported",">reference/exns.html#(def._((lib._racket/private/base..rkt)._make-exn~3afail~3aunsupported))",[0,[2,"make-exn:fail:unsupported"]],["racket/base","racket"]],
["make-exn:fail:user",">reference/exns.html#(def._((lib._racket/private/base..rkt)._make-exn~3afail~3auser))",[0,[2,"make-exn:fail:user"]],["racket/base","racket"]],
["make-exn:file-saved-instead",">browser/index.html#(def._((lib._browser/browser..rkt)._make-exn~3afile-saved-instead))",[0,[2,"make-exn:file-saved-instead"]],["browser/browser","browser"]],
["make-exn:get-module-code",">syntax/module-helpers.html#(def._((lib._syntax/modcode..rkt)._make-exn~3aget-module-code))",[0,[2,"make-exn:get-module-code"]],["syntax/modcode"]],
["make-exn:invalid-xexpr",">xml/index.html#(def._((lib._xml/main..rkt)._make-exn~3ainvalid-xexpr))",[0,[2,"make-exn:invalid-xexpr"]],["xml"]],
["make-exn:test",">rackunit/internals.html#(def._((lib._rackunit/main..rkt)._make-exn~3atest))",[0,[2,"make-exn:test"]],["rackunit"]],
["make-exn:test:check",">rackunit/internals.html#(def._((lib._rackunit/main..rkt)._make-exn~3atest~3acheck))",[0,[2,"make-exn:test:check"]],["rackunit"]],
["make-exn:xml",">xml/index.html#(def._((lib._xml/main..rkt)._make-exn~3axml))",[0,[2,"make-exn:xml"]],["xml"]],
["make-export",">reference/stxtrans.html#(def._((lib._racket/provide-transform..rkt)._make-export))",[0,[2,"make-export"]],["racket/provide-transform"]],
["make-exported-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..rkt)._make-exported-index-desc))",[0,[2,"make-exported-index-desc"]],["scribble/manual-struct"]],
["make-exported-module-binding",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-exported-module-binding))",[0,[2,"make-exported-module-binding"]],["compiler/zo-structs"]],
["make-exported-nominal-module-binding",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-exported-nominal-module-binding))",[0,[2,"make-exported-nominal-module-binding"]],["compiler/zo-structs"]],
["make-expr",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-expr))",[0,[2,"make-expr"]],["compiler/zo-structs"]],
["make-external-dtd",">xml/index.html#(def._((lib._xml/main..rkt)._make-external-dtd))",[0,[2,"make-external-dtd"]],["xml"]],
["make-external-dtd/public",">xml/index.html#(def._((lib._xml/main..rkt)._make-external-dtd/public))",[0,[2,"make-external-dtd/public"]],["xml"]],
["make-external-dtd/system",">xml/index.html#(def._((lib._xml/main..rkt)._make-external-dtd/system))",[0,[2,"make-external-dtd/system"]],["xml"]],
["make-f32vector",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._make-f32vector))",[0,[2,"make-f32vector"]],["ffi/vector"]],
["make-f64vector",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._make-f64vector))",[0,[2,"make-f64vector"]],["ffi/vector"]],
["make-fieldset",">html/index.html#(def._((lib._html/main..rkt)._make-fieldset))",[0,[2,"make-fieldset"]],["html"]],
["make-file",">teachpack/dir.html#(def._((lib._htdp/dir..rkt)._make-file))",[0,[2,"make-file"]],["htdp/dir"]],
["make-file-or-directory-link",">reference/Filesystem.html#(def._((quote._~23~25kernel)._make-file-or-directory-link))",[0,[2,"make-file-or-directory-link"]],["racket/base","racket"]],
["make-flat-contract",">reference/Building_New_Contract_Combinators.html#(def._((lib._racket/contract/private/prop..rkt)._make-flat-contract))",[0,[2,"make-flat-contract"]],["racket/contract/combinator","racket/contract","racket"]],
["make-flomap",">images/Conversion_and_Construction.html#(def._((lib._images/flomap..rkt)._make-flomap))",[0,[2,"make-flomap"]],["images/flomap"]],
["make-flomap*",">images/Conversion_and_Construction.html#(def._((lib._images/flomap..rkt)._make-flomap*))",[0,[2,"make-flomap*"]],["images/flomap"]],
["make-flomap-2d-mapping",">images/Spatial_Transformations.html#(def._((lib._images/flomap..rkt)._make-flomap-2d-mapping))",[0,[2,"make-flomap-2d-mapping"]],["images/flomap"]],
["make-flrectangular",">reference/flonums.html#(def._((lib._racket/flonum..rkt)._make-flrectangular))",[0,[2,"make-flrectangular"]],["racket/flonum"]],
["make-flvector",">reference/flonums.html#(def._((lib._racket/flonum..rkt)._make-flvector))",[0,[2,"make-flvector"]],["racket/flonum"]],
["make-font",">draw/Drawing_Functions.html#(def._((lib._racket/draw..rkt)._make-font))",[0,[2,"make-font"]],["racket/draw"]],
["make-font",">html/index.html#(def._((lib._html/main..rkt)._make-font))",[0,[2,"make-font"]],["html"]],
["make-form",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-form))",[0,[2,"make-form"]],["compiler/zo-structs"]],
["make-form",">html/index.html#(def._((lib._html/main..rkt)._make-form))",[0,[2,"make-form"]],["html"]],
["make-form-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..rkt)._make-form-index-desc))",[0,[2,"make-form-index-desc"]],["scribble/manual-struct"]],
["make-free-id-info",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-free-id-info))",[0,[2,"make-free-id-info"]],["compiler/zo-structs"]],
["make-free-id-table",">syntax/syntax-helpers.html#(def._((lib._syntax/id-table..rkt)._make-free-id-table))",[0,[2,"make-free-id-table"]],["syntax/id-table"]],
["make-free-identifier-mapping",">syntax/syntax-helpers.html#(def._((lib._syntax/boundmap..rkt)._make-free-identifier-mapping))",[0,[2,"make-free-identifier-mapping"]],["syntax/boundmap"]],
["make-fsemaphore",">reference/futures.html#(def._((lib._racket/future..rkt)._make-fsemaphore))",[0,[2,"make-fsemaphore"]],["racket/future","racket"]],
["make-future-event",">reference/futures-trace.html#(def._((lib._future-visualizer/trace..rkt)._make-future-event))",[0,[2,"make-future-event"]],["future-visualizer/trace"]],
["make-fxvector",">reference/fixnums.html#(def._((lib._racket/fixnum..rkt)._make-fxvector))",[0,[2,"make-fxvector"]],["racket/fixnum"]],
["make-gc-thread",">web-server-internal/dispatch-stat.html#(def._((lib._web-server/dispatchers/dispatch-stat..rkt)._make-gc-thread))",[0,[2,"make-gc-thread"]],["web-server/dispatchers/dispatch-stat"]],
["make-generated-tag",">scribble/core.html#(def._((lib._scribble/core..rkt)._make-generated-tag))",[0,[2,"make-generated-tag"]],["scribble/core"]],
["make-generic",">reference/ivaraccess.html#(def._((lib._racket/private/class-internal..rkt)._make-generic))",[0,[2,"make-generic"]],["racket/class","racket"]],
["make-gl-bitmap",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._make-gl-bitmap))",[0,[2,"make-gl-bitmap"]],["racket/gui/base","racket/gui"]],
["make-gl-boolean-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._make-gl-boolean-vector))",[0,[2,"make-gl-boolean-vector"]],["sgl/gl-vectors"]],
["make-gl-byte-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._make-gl-byte-vector))",[0,[2,"make-gl-byte-vector"]],["sgl/gl-vectors"]],
["make-gl-double-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._make-gl-double-vector))",[0,[2,"make-gl-double-vector"]],["sgl/gl-vectors"]],
["make-gl-float-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._make-gl-float-vector))",[0,[2,"make-gl-float-vector"]],["sgl/gl-vectors"]],
["make-gl-int-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._make-gl-int-vector))",[0,[2,"make-gl-int-vector"]],["sgl/gl-vectors"]],
["make-gl-selection-record",">sgl/main.html#(def._((lib._sgl/main..rkt)._make-gl-selection-record))",[0,[2,"make-gl-selection-record"]],["sgl"]],
["make-gl-short-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._make-gl-short-vector))",[0,[2,"make-gl-short-vector"]],["sgl/gl-vectors"]],
["make-gl-ubyte-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._make-gl-ubyte-vector))",[0,[2,"make-gl-ubyte-vector"]],["sgl/gl-vectors"]],
["make-gl-uint-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._make-gl-uint-vector))",[0,[2,"make-gl-uint-vector"]],["sgl/gl-vectors"]],
["make-gl-ushort-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._make-gl-ushort-vector))",[0,[2,"make-gl-ushort-vector"]],["sgl/gl-vectors"]],
["make-global-bucket",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-global-bucket))",[0,[2,"make-global-bucket"]],["compiler/zo-structs"]],
["make-gracket-launcher",">raco/exe.html#(def._((lib._launcher/launcher..rkt)._make-gracket-launcher))",[0,[2,"make-gracket-launcher"]],["launcher/launcher"]],
["make-gracket-program-launcher",">raco/exe.html#(def._((lib._launcher/launcher..rkt)._make-gracket-program-launcher))",[0,[2,"make-gracket-program-launcher"]],["launcher/launcher"]],
["make-gui-empty-namespace",">gui/Windowing_Functions.html#(def._((lib._racket/gui/base..rkt)._make-gui-empty-namespace))",[0,[2,"make-gui-empty-namespace"]],["racket/gui/base","racket/gui"]],
["make-gui-empty-namespace",">scheme/scheme_gui_base.html#(def._((lib._scheme/gui/base..rkt)._make-gui-empty-namespace))",[0,[2,"make-gui-empty-namespace"]],["scheme/gui/base"]],
["make-gui-namespace",">gui/Windowing_Functions.html#(def._((lib._racket/gui/base..rkt)._make-gui-namespace))",[0,[2,"make-gui-namespace"]],["racket/gui/base","racket/gui"]],
["make-gui-namespace",">scheme/scheme_gui_base.html#(def._((lib._scheme/gui/base..rkt)._make-gui-namespace))",[0,[2,"make-gui-namespace"]],["scheme/gui/base"]],
["make-gui-runner",">rackunit/api.html#(def._((lib._rackunit/gui..rkt)._make-gui-runner))",[0,[2,"make-gui-runner"]],["rackunit/gui"]],
["make-gvector",">data/gvector.html#(def._((lib._data/gvector..rkt)._make-gvector))",[0,[2,"make-gvector"]],["data/gvector"]],
["make-h1",">html/index.html#(def._((lib._html/main..rkt)._make-h1))",[0,[2,"make-h1"]],["html"]],
["make-h2",">html/index.html#(def._((lib._html/main..rkt)._make-h2))",[0,[2,"make-h2"]],["html"]],
["make-h3",">html/index.html#(def._((lib._html/main..rkt)._make-h3))",[0,[2,"make-h3"]],["html"]],
["make-h4",">html/index.html#(def._((lib._html/main..rkt)._make-h4))",[0,[2,"make-h4"]],["html"]],
["make-h5",">html/index.html#(def._((lib._html/main..rkt)._make-h5))",[0,[2,"make-h5"]],["html"]],
["make-h6",">html/index.html#(def._((lib._html/main..rkt)._make-h6))",[0,[2,"make-h6"]],["html"]],
["make-handle-brush",">draw/unsafe.html#(def._((lib._racket/draw/unsafe/brush..rkt)._make-handle-brush))",[0,[2,"make-handle-brush"]],["racket/draw/unsafe/brush"]],
["make-handle-get-preference-locked",">reference/Filesystem.html#(def._((lib._racket/file..rkt)._make-handle-get-preference-locked))",[0,[2,"make-handle-get-preference-locked"]],["racket/file","racket"]],
["make-hash",">reference/hashtables.html#(def._((quote._~23~25kernel)._make-hash))",[0,[2,"make-hash"]],["racket/base","racket"]],
["make-hash",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._make-hash))",[0,[2,"make-hash"]],["lang/htdp-advanced"]],
["make-hash-placeholder",">reference/pairs.html#(def._((quote._~23~25kernel)._make-hash-placeholder))",[0,[2,"make-hash-placeholder"]],["racket/base","racket"]],
["make-hash-table",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..rkt)._make-hash-table))",[0,[2,"make-hash-table"]],["mzscheme"]],
["make-hasheq",">reference/hashtables.html#(def._((quote._~23~25kernel)._make-hasheq))",[0,[2,"make-hasheq"]],["racket/base","racket"]],
["make-hasheq",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._make-hasheq))",[0,[2,"make-hasheq"]],["lang/htdp-advanced"]],
["make-hasheq-placeholder",">reference/pairs.html#(def._((quote._~23~25kernel)._make-hasheq-placeholder))",[0,[2,"make-hasheq-placeholder"]],["racket/base","racket"]],
["make-hasheqv",">reference/hashtables.html#(def._((quote._~23~25kernel)._make-hasheqv))",[0,[2,"make-hasheqv"]],["racket/base","racket"]],
["make-hasheqv",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._make-hasheqv))",[0,[2,"make-hasheqv"]],["lang/htdp-advanced"]],
["make-hasheqv-placeholder",">reference/pairs.html#(def._((quote._~23~25kernel)._make-hasheqv-placeholder))",[0,[2,"make-hasheqv-placeholder"]],["racket/base","racket"]],
["make-hashtable",">r6rs-lib-std/r6rs-lib-Z-H-14.html#node_idx_1182",[0,[2,"make-hashtable"]],["rnrs/hashtables-6"]],
["make-head",">html/index.html#(def._((lib._html/main..rkt)._make-head))",[0,[2,"make-head"]],["html"]],
["make-header",">web-server/http.html#(def._((lib._web-server/http/request-structs..rkt)._make-header))",[0,[2,"make-header"]],["web-server/http/request-structs"]],
["make-heap",">data/Binary_Heaps.html#(def._((lib._data/heap..rkt)._make-heap))",[0,[2,"make-heap"]],["data/heap"]],
["make-host",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._make-host))",[0,[2,"make-host"]],["web-server/configuration/configuration-table-structs"]],
["make-host-table",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._make-host-table))",[0,[2,"make-host-table"]],["web-server/configuration/configuration-table-structs"]],
["make-hover-element",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._make-hover-element))",[0,[2,"make-hover-element"]],["scribble/struct"]],
["make-hover-property",">scribble/core.html#(def._((lib._scribble/html-properties..rkt)._make-hover-property))",[0,[2,"make-hover-property"]],["scribble/html-properties"]],
["make-hr",">html/index.html#(def._((lib._html/main..rkt)._make-hr))",[0,[2,"make-hr"]],["html"]],
["make-html",">html/index.html#(def._((lib._html/main..rkt)._make-html))",[0,[2,"make-html"]],["html"]],
["make-html-defaults",">scribble/core.html#(def._((lib._scribble/html-properties..rkt)._make-html-defaults))",[0,[2,"make-html-defaults"]],["scribble/html-properties"]],
["make-html-element",">html/index.html#(def._((lib._html/main..rkt)._make-html-element))",[0,[2,"make-html-element"]],["html"]],
["make-html-full",">html/index.html#(def._((lib._html/main..rkt)._make-html-full))",[0,[2,"make-html-full"]],["html"]],
["make-i",">html/index.html#(def._((lib._html/main..rkt)._make-i))",[0,[2,"make-i"]],["html"]],
["make-i/o-decoding-error",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_602",[0,[2,"make-i/o-decoding-error"]],["rnrs/io/ports-6"]],
["make-i/o-encoding-error",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_608",[0,[2,"make-i/o-encoding-error"]],["rnrs/io/ports-6"]],
["make-i/o-error",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_496",[0,[2,"make-i/o-error"]],["rnrs/io/ports-6"]],
["make-i/o-file-already-exists-error",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_542",[0,[2,"make-i/o-file-already-exists-error"]],["rnrs/io/ports-6"]],
["make-i/o-file-does-not-exist-error",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_548",[0,[2,"make-i/o-file-does-not-exist-error"]],["rnrs/io/ports-6"]],
["make-i/o-file-is-read-only-error",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_536",[0,[2,"make-i/o-file-is-read-only-error"]],["rnrs/io/ports-6"]],
["make-i/o-file-protection-error",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_530",[0,[2,"make-i/o-file-protection-error"]],["rnrs/io/ports-6"]],
["make-i/o-filename-error",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_522",[0,[2,"make-i/o-filename-error"]],["rnrs/io/ports-6"]],
["make-i/o-invalid-position-error",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_514",[0,[2,"make-i/o-invalid-position-error"]],["rnrs/io/ports-6"]],
["make-i/o-port-error",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_554",[0,[2,"make-i/o-port-error"]],["rnrs/io/ports-6"]],
["make-i/o-read-error",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_502",[0,[2,"make-i/o-read-error"]],["rnrs/io/ports-6"]],
["make-i/o-write-error",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_508",[0,[2,"make-i/o-write-error"]],["rnrs/io/ports-6"]],
["make-iframe",">html/index.html#(def._((lib._html/main..rkt)._make-iframe))",[0,[2,"make-iframe"]],["html"]],
["make-illegal-message-number",">net/pop3.html#(def._((lib._net/pop3..rkt)._make-illegal-message-number))",[0,[2,"make-illegal-message-number"]],["net/pop3"]],
["make-image-element",">scribble/core.html#(def._((lib._scribble/core..rkt)._make-image-element))",[0,[2,"make-image-element"]],["scribble/core"]],
["make-image-file",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._make-image-file))",[0,[2,"make-image-file"]],["scribble/struct"]],
["make-img",">html/index.html#(def._((lib._html/main..rkt)._make-img))",[0,[2,"make-img"]],["html"]],
["make-immutable-bound-id-table",">syntax/syntax-helpers.html#(def._((lib._syntax/id-table..rkt)._make-immutable-bound-id-table))",[0,[2,"make-immutable-bound-id-table"]],["syntax/id-table"]],
["make-immutable-custom-hash",">reference/dicts.html#(def._((lib._racket/dict..rkt)._make-immutable-custom-hash))",[0,[2,"make-immutable-custom-hash"]],["racket/dict","racket"]],
["make-immutable-free-id-table",">syntax/syntax-helpers.html#(def._((lib._syntax/id-table..rkt)._make-immutable-free-id-table))",[0,[2,"make-immutable-free-id-table"]],["syntax/id-table"]],
["make-immutable-hash",">reference/hashtables.html#(def._((quote._~23~25kernel)._make-immutable-hash))",[0,[2,"make-immutable-hash"]],["racket/base","racket"]],
["make-immutable-hash",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._make-immutable-hash))",[0,[2,"make-immutable-hash"]],["lang/htdp-advanced"]],
["make-immutable-hash-table",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..rkt)._make-immutable-hash-table))",[0,[2,"make-immutable-hash-table"]],["mzscheme"]],
["make-immutable-hasheq",">reference/hashtables.html#(def._((quote._~23~25kernel)._make-immutable-hasheq))",[0,[2,"make-immutable-hasheq"]],["racket/base","racket"]],
["make-immutable-hasheq",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._make-immutable-hasheq))",[0,[2,"make-immutable-hasheq"]],["lang/htdp-advanced"]],
["make-immutable-hasheqv",">reference/hashtables.html#(def._((quote._~23~25kernel)._make-immutable-hasheqv))",[0,[2,"make-immutable-hasheqv"]],["racket/base","racket"]],
["make-immutable-hasheqv",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._make-immutable-hasheqv))",[0,[2,"make-immutable-hasheqv"]],["lang/htdp-advanced"]],
["make-impersonator-property",">reference/chaperones.html#(def._((quote._~23~25kernel)._make-impersonator-property))",[0,[2,"make-impersonator-property"]],["racket/base","racket"]],
["make-implementation-restriction-violation",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_468",[0,[2,"make-implementation-restriction-violation"]],["rnrs/conditions-6"]],
["make-import",">reference/stxtrans.html#(def._((lib._racket/require-transform..rkt)._make-import))",[0,[2,"make-import"]],["racket/require-transform"]],
["make-import-source",">reference/stxtrans.html#(def._((lib._racket/require-transform..rkt)._make-import-source))",[0,[2,"make-import-source"]],["racket/require-transform"]],
["make-imported-nominal-path",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-imported-nominal-path))",[0,[2,"make-imported-nominal-path"]],["compiler/zo-structs"]],
["make-index-element",">scribble/core.html#(def._((lib._scribble/core..rkt)._make-index-element))",[0,[2,"make-index-element"]],["scribble/core"]],
["make-index-element",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._make-index-element))",[0,[2,"make-index-element"]],["scribble/struct"]],
["make-indexed-future-event",">reference/futures-trace.html#(def._((lib._future-visualizer/trace..rkt)._make-indexed-future-event))",[0,[2,"make-indexed-future-event"]],["future-visualizer/trace"]],
["make-info-domain",">raco/setup-plt-plt.html#(sig-val._((lib._setup/option-sig..rkt)._setup-option~5e._make-info-domain))",[0,[2,"make-info-domain"]],["setup/option-sig"]],
["make-inline-variant",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-inline-variant))",[0,[2,"make-inline-variant"]],["compiler/zo-structs"]],
["make-input",">html/index.html#(def._((lib._html/main..rkt)._make-input))",[0,[2,"make-input"]],["html"]],
["make-input",">web-server/formlets.html#(def._((lib._web-server/formlets/input..rkt)._make-input))",[0,[2,"make-input"]],["web-server/formlets/input"]],
["make-input*",">web-server/formlets.html#(def._((lib._web-server/formlets/input..rkt)._make-input*))",[0,[2,"make-input*"]],["web-server/formlets/input"]],
["make-input-port",">reference/customport.html#(def._((quote._~23~25kernel)._make-input-port))",[0,[2,"make-input-port"]],["racket/base","racket"]],
["make-input-port/read-to-peek",">reference/port-lib.html#(def._((lib._racket/port..rkt)._make-input-port/read-to-peek))",[0,[2,"make-input-port/read-to-peek"]],["racket/port","racket"]],
["make-ins",">html/index.html#(def._((lib._html/main..rkt)._make-ins))",[0,[2,"make-ins"]],["html"]],
["make-inspector",">reference/inspectors.html#(def._((quote._~23~25kernel)._make-inspector))",[0,[2,"make-inspector"]],["racket/base","racket"]],
["make-install-value",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-install-value))",[0,[2,"make-install-value"]],["compiler/zo-structs"]],
["make-integer-set",">mzlib/mzlib_integer-set.html#(def._((lib._mzlib/integer-set..rkt)._make-integer-set))",[0,[2,"make-integer-set"]],["mzlib/integer-set"]],
["make-interface-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..rkt)._make-interface-index-desc))",[0,[2,"make-interface-index-desc"]],["scribble/manual-struct"]],
["make-interval-map",">data/interval-map.html#(def._((lib._data/interval-map..rkt)._make-interval-map))",[0,[2,"make-interval-map"]],["data/interval-map"]],
["make-invertible-function",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._make-invertible-function))",[0,[2,"make-invertible-function"]],["plot"]],
["make-irritants-condition",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_446",[0,[2,"make-irritants-condition"]],["rnrs/conditions-6"]],
["make-isindex",">html/index.html#(def._((lib._html/main..rkt)._make-isindex))",[0,[2,"make-isindex"]],["html"]],
["make-itemization",">scribble/core.html#(def._((lib._scribble/core..rkt)._make-itemization))",[0,[2,"make-itemization"]],["scribble/core"]],
["make-itemization",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._make-itemization))",[0,[2,"make-itemization"]],["scribble/struct"]],
["make-ivl",">plot/utils.html#(def._((lib._plot/utils..rkt)._make-ivl))",[0,[2,"make-ivl"]],["plot/utils"]],
["make-just-context",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._make-just-context))",[0,[2,"make-just-context"]],["scribble/racket","scribble/scheme"]],
["make-kbd",">html/index.html#(def._((lib._html/main..rkt)._make-kbd))",[0,[2,"make-kbd"]],["html"]],
["make-keyword-procedure",">reference/procedures.html#(def._((lib._racket/private/base..rkt)._make-keyword-procedure))",[0,[2,"make-keyword-procedure"]],["racket/base","racket"]],
["make-kmp-restart-vector",">srfi-std/srfi-13.html#make-kmp-restart-vector",[0,[2,"make-kmp-restart-vector"]],["srfi/13"]],
["make-known-char-range-list",">reference/characters.html#(def._((quote._~23~25kernel)._make-known-char-range-list))",[0,[2,"make-known-char-range-list"]],["racket/base","racket"]],
["make-label",">html/index.html#(def._((lib._html/main..rkt)._make-label))",[0,[2,"make-label"]],["html"]],
["make-lam",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-lam))",[0,[2,"make-lam"]],["compiler/zo-structs"]],
["make-latex-auto-extra-files",">scribble/core.html#(def._((lib._scribble/latex-properties..rkt)._make-latex-auto-extra-files))",[0,[2,"make-latex-auto-extra-files"]],["scribble/latex-properties"]],
["make-latex-defaults",">scribble/core.html#(def._((lib._scribble/latex-properties..rkt)._make-latex-defaults))",[0,[2,"make-latex-defaults"]],["scribble/latex-properties"]],
["make-launchers",">raco/setup-plt-plt.html#(sig-val._((lib._setup/option-sig..rkt)._setup-option~5e._make-launchers))",[0,[2,"make-launchers"]],["setup/option-sig"]],
["make-legend",">html/index.html#(def._((lib._html/main..rkt)._make-legend))",[0,[2,"make-legend"]],["html"]],
["make-let-one",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-let-one))",[0,[2,"make-let-one"]],["compiler/zo-structs"]],
["make-let-rec",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-let-rec))",[0,[2,"make-let-rec"]],["compiler/zo-structs"]],
["make-let-void",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-let-void))",[0,[2,"make-let-void"]],["compiler/zo-structs"]],
["make-lexical-rename",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-lexical-rename))",[0,[2,"make-lexical-rename"]],["compiler/zo-structs"]],
["make-lexical-violation",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_474",[0,[2,"make-lexical-violation"]],["rnrs/conditions-6"]],
["make-li",">html/index.html#(def._((lib._html/main..rkt)._make-li))",[0,[2,"make-li"]],["html"]],
["make-limited-input-port",">reference/port-lib.html#(def._((lib._racket/port..rkt)._make-limited-input-port))",[0,[2,"make-limited-input-port"]],["racket/port","racket"]],
["make-line3d",">deinprogramm/line3d.html#(def._((lib._teachpack/deinprogramm/line3d..rkt)._make-line3d))",[0,[2,"make-line3d"]],["teachpack/deinprogramm/line3d"]],
["make-link-element",">scribble/core.html#(def._((lib._scribble/core..rkt)._make-link-element))",[0,[2,"make-link-element"]],["scribble/core"]],
["make-link-element",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._make-link-element))",[0,[2,"make-link-element"]],["scribble/struct"]],
["make-link-style",">browser/index.html#(meth._(((lib._browser/browser..rkt)._hyper-text-mixin)._make-link-style))",[[0,[2,"make-link-style"]],[14,[" (method of ",[0,[2,"hyper-text-mixin"]],")"]]],["browser/browser","browser"]],
["make-link-style",">browser/index.html#(meth._(((lib._browser/htmltext..rkt)._html-text~3c~25~3e)._make-link-style))",[[0,[2,"make-link-style"]],[14,[" (method of ",[0,[2,"html-text<%>"]],")"]]],["browser/htmltext"]],
["make-list",">reference/pairs.html#(def._((lib._racket/list..rkt)._make-list))",[0,[2,"make-list"]],["racket/list","racket"]],
["make-list",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._make-list))",[0,[2,"make-list"]],["lang/htdp-advanced"]],
["make-list",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._make-list))",[0,[2,"make-list"]],["lang/htdp-beginner"]],
["make-list",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._make-list))",[0,[2,"make-list"]],["lang/htdp-beginner-abbr"]],
["make-list",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._make-list))",[0,[2,"make-list"]],["lang/htdp-intermediate"]],
["make-list",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._make-list))",[0,[2,"make-list"]],["lang/htdp-intermediate-lambda"]],
["make-list",">srfi-std/srfi-1.html#make-list",[0,[2,"make-list"]],["srfi/1"]],
["make-literal-syntax",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._make-literal-syntax))",[0,[2,"make-literal-syntax"]],["scribble/racket","scribble/scheme"]],
["make-localref",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-localref))",[0,[2,"make-localref"]],["compiler/zo-structs"]],
["make-location",">xml/index.html#(def._((lib._xml/main..rkt)._make-location))",[0,[2,"make-location"]],["xml"]],
["make-lock-file-name",">reference/Filesystem.html#(def._((lib._racket/file..rkt)._make-lock-file-name))",[0,[2,"make-lock-file-name"]],["racket/file","racket"]],
["make-log-receiver",">reference/logging.html#(def._((quote._~23~25kernel)._make-log-receiver))",[0,[2,"make-log-receiver"]],["racket/base","racket"]],
["make-logger",">reference/logging.html#(def._((quote._~23~25kernel)._make-logger))",[0,[2,"make-logger"]],["racket/base","racket"]],
["make-long-boolean",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._make-long-boolean))",[0,[2,"make-long-boolean"]],["scribble/racket","scribble/scheme"]],
["make-lw",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._make-lw))",[0,[2,"make-lw"]],["redex/pict","redex"]],
["make-mail",">teachpack/2htdpuniverse.html#(def._((lib._2htdp/universe..rkt)._make-mail))",[0,[2,"make-mail"]],["2htdp/universe"]],
["make-make-servlet-namespace",">web-server-internal/dispatch-servlets.html#(def._((lib._web-server/configuration/namespace..rkt)._make-make-servlet-namespace))",[0,[2,"make-make-servlet-namespace"]],["web-server/configuration/namespace"]],
["make-malformed-multipart-entity",">net/mime.html#(def._((lib._net/mime..rkt)._make-malformed-multipart-entity))",[0,[2,"make-malformed-multipart-entity"]],["net/mime"]],
["make-malformed-server-response",">net/pop3.html#(def._((lib._net/pop3..rkt)._make-malformed-server-response))",[0,[2,"make-malformed-server-response"]],["net/pop3"]],
["make-manager",">web-server/servlet.html#(def._((lib._web-server/managers/manager..rkt)._make-manager))",[0,[2,"make-manager"]],["web-server/managers/manager"]],
["make-mapped-function",">plot/utils.html#(def._((lib._plot/utils..rkt)._make-mapped-function))",[0,[2,"make-mapped-function"]],["plot/utils"]],
["make-mark-barrier",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-mark-barrier))",[0,[2,"make-mark-barrier"]],["compiler/zo-structs"]],
["make-matrix",">teachpack/matrix.html#(def._((lib._htdp/matrix..rkt)._make-matrix))",[0,[2,"make-matrix"]],["htdp/matrix"]],
["make-matrix4x4",">deinprogramm/line3d.html#(def._((lib._teachpack/deinprogramm/line3d..rkt)._make-matrix4x4))",[0,[2,"make-matrix4x4"]],["teachpack/deinprogramm/line3d"]],
["make-menu",">html/index.html#(def._((lib._html/main..rkt)._make-menu))",[0,[2,"make-menu"]],["html"]],
["make-message",">teachpack/gui.html#(def._((lib._htdp/gui..rkt)._make-message))",[0,[2,"make-message"]],["htdp/gui"]],
["make-message",">net/mime.html#(def._((lib._net/mime..rkt)._make-message))",[0,[2,"make-message"]],["net/mime"]],
["make-message-condition",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_408",[0,[2,"make-message-condition"]],["rnrs/conditions-6"]],
["make-messages",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._make-messages))",[0,[2,"make-messages"]],["web-server/configuration/configuration-table-structs"]],
["make-meta",">html/index.html#(def._((lib._html/main..rkt)._make-meta))",[0,[2,"make-meta"]],["html"]],
["make-meta-reader",">syntax/reader-helpers.html#(def._((lib._syntax/module-reader..rkt)._make-meta-reader))",[0,[2,"make-meta-reader"]],["syntax/module-reader"]],
["make-method-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..rkt)._make-method-index-desc))",[0,[2,"make-method-index-desc"]],["scribble/manual-struct"]],
["make-mime-error",">net/mime.html#(def._((lib._net/mime..rkt)._make-mime-error))",[0,[2,"make-mime-error"]],["net/mime"]],
["make-missing-multipart-boundary-parameter",">net/mime.html#(def._((lib._net/mime..rkt)._make-missing-multipart-boundary-parameter))",[0,[2,"make-missing-multipart-boundary-parameter"]],["net/mime"]],
["make-mixin-contract",">reference/Object_and_Class_Contracts.html#(def._((lib._racket/class..rkt)._make-mixin-contract))",[0,[2,"make-mixin-contract"]],["racket/class","racket"]],
["make-mixin-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..rkt)._make-mixin-index-desc))",[0,[2,"make-mixin-index-desc"]],["scribble/manual-struct"]],
["make-mod",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-mod))",[0,[2,"make-mod"]],["compiler/zo-structs"]],
["make-module-binding",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-module-binding))",[0,[2,"make-module-binding"]],["compiler/zo-structs"]],
["make-module-evaluator",">reference/Sandboxed_Evaluation.html#(def._((lib._racket/sandbox..rkt)._make-module-evaluator))",[0,[2,"make-module-evaluator"]],["racket/sandbox"]],
["make-module-evaluator",">scheme/scheme_sandbox.html#(def._((lib._scheme/sandbox..rkt)._make-module-evaluator))",[0,[2,"make-module-evaluator"]],["scheme/sandbox"]],
["make-module-identifier-mapping",">syntax/syntax-helpers.html#(def._((lib._syntax/boundmap..rkt)._make-module-identifier-mapping))",[0,[2,"make-module-identifier-mapping"]],["syntax/boundmap"]],
["make-module-path-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..rkt)._make-module-path-index-desc))",[0,[2,"make-module-path-index-desc"]],["scribble/manual-struct"]],
["make-module-rename",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-module-rename))",[0,[2,"make-module-rename"]],["compiler/zo-structs"]],
["make-module-variable",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-module-variable))",[0,[2,"make-module-variable"]],["compiler/zo-structs"]],
["make-monochrome-bitmap",">draw/Drawing_Functions.html#(def._((lib._racket/draw..rkt)._make-monochrome-bitmap))",[0,[2,"make-monochrome-bitmap"]],["racket/draw"]],
["make-mred-launcher",">raco/exe.html#(def._((lib._launcher/launcher..rkt)._make-mred-launcher))",[0,[2,"make-mred-launcher"]],["launcher/launcher"]],
["make-mred-program-launcher",">raco/exe.html#(def._((lib._launcher/launcher..rkt)._make-mred-program-launcher))",[0,[2,"make-mred-program-launcher"]],["launcher/launcher"]],
["make-multiarg-element",">scribble/core.html#(def._((lib._scribble/core..rkt)._make-multiarg-element))",[0,[2,"make-multiarg-element"]],["scribble/core"]],
["make-mzscheme",">html/index.html#(def._((lib._html/main..rkt)._make-mzscheme))",[0,[2,"make-mzscheme"]],["html"]],
["make-mzscheme-launcher",">raco/exe.html#(def._((lib._launcher/launcher..rkt)._make-mzscheme-launcher))",[0,[2,"make-mzscheme-launcher"]],["launcher/launcher"]],
["make-mzscheme-program-launcher",">raco/exe.html#(def._((lib._launcher/launcher..rkt)._make-mzscheme-program-launcher))",[0,[2,"make-mzscheme-program-launcher"]],["launcher/launcher"]],
["make-namespace",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..rkt)._make-namespace))",[0,[2,"make-namespace"]],["mzscheme"]],
["make-nested-flow",">scribble/core.html#(def._((lib._scribble/core..rkt)._make-nested-flow))",[0,[2,"make-nested-flow"]],["scribble/core"]],
["make-nntp",">net/nntp.html#(def._((lib._net/nntp..rkt)._make-nntp))",[0,[2,"make-nntp"]],["net/nntp"]],
["make-no-group-selected",">net/nntp.html#(def._((lib._net/nntp..rkt)._make-no-group-selected))",[0,[2,"make-no-group-selected"]],["net/nntp"]],
["make-no-infinities-violation",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1050",[0,[2,"make-no-infinities-violation"]],["rnrs/arithmetic/flonums-6"]],
["make-no-nans-violation",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1056",[0,[2,"make-no-nans-violation"]],["rnrs/arithmetic/flonums-6"]],
["make-noframes",">html/index.html#(def._((lib._html/main..rkt)._make-noframes))",[0,[2,"make-noframes"]],["html"]],
["make-nominal-module-binding",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-nominal-module-binding))",[0,[2,"make-nominal-module-binding"]],["compiler/zo-structs"]],
["make-nominal-path",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-nominal-path))",[0,[2,"make-nominal-path"]],["compiler/zo-structs"]],
["make-non-continuable-violation",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_462",[0,[2,"make-non-continuable-violation"]],["rnrs/conditions-6"]],
["make-non-existent-group",">net/nntp.html#(def._((lib._net/nntp..rkt)._make-non-existent-group))",[0,[2,"make-non-existent-group"]],["net/nntp"]],
["make-none/c",">reference/contract-utilities.html#(def._((lib._racket/contract/private/misc..rkt)._make-none/c))",[0,[2,"make-none/c"]],["racket/contract/base","racket/contract","racket"]],
["make-noscript",">html/index.html#(def._((lib._html/main..rkt)._make-noscript))",[0,[2,"make-noscript"]],["html"]],
["make-not-available",">foreign/Defining_Bindings.html#(def._((lib._ffi/unsafe/define..rkt)._make-not-available))",[0,[2,"make-not-available"]],["ffi/unsafe/define"]],
["make-not-given-headers",">net/pop3.html#(def._((lib._net/pop3..rkt)._make-not-given-headers))",[0,[2,"make-not-given-headers"]],["net/pop3"]],
["make-not-ready-for-transaction",">net/pop3.html#(def._((lib._net/pop3..rkt)._make-not-ready-for-transaction))",[0,[2,"make-not-ready-for-transaction"]],["net/pop3"]],
["make-objc_super",">foreign/Objective-C_FFI.html#(def._((lib._ffi/unsafe/objc..rkt)._make-objc_super))",[0,[2,"make-objc_super"]],["ffi/unsafe/objc"]],
["make-object",">reference/objcreation.html#(def._((lib._racket/private/class-internal..rkt)._make-object))",[0,[2,"make-object"]],["racket/class","racket"]],
["make-object",">html/index.html#(def._((lib._html/main..rkt)._make-object))",[0,[2,"make-object"]],["html"]],
["make-ol",">html/index.html#(def._((lib._html/main..rkt)._make-ol))",[0,[2,"make-ol"]],["html"]],
["make-omitable-paragraph",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._make-omitable-paragraph))",[0,[2,"make-omitable-paragraph"]],["scribble/struct"]],
["make-optgroup",">html/index.html#(def._((lib._html/main..rkt)._make-optgroup))",[0,[2,"make-optgroup"]],["html"]],
["make-option",">html/index.html#(def._((lib._html/main..rkt)._make-option))",[0,[2,"make-option"]],["html"]],
["make-outline",">slideshow/Primary_Slide_Functions.html#(def._((lib._slideshow/base..rkt)._make-outline))",[0,[2,"make-outline"]],["slideshow/base","slideshow"]],
["make-output-port",">reference/customport.html#(def._((quote._~23~25kernel)._make-output-port))",[0,[2,"make-output-port"]],["racket/base","racket"]],
["make-p",">html/index.html#(def._((lib._html/main..rkt)._make-p))",[0,[2,"make-p"]],["html"]],
["make-p-i",">xml/index.html#(def._((lib._xml/main..rkt)._make-p-i))",[0,[2,"make-p-i"]],["xml"]],
["make-package",">teachpack/2htdpuniverse.html#(def._((lib._2htdp/universe..rkt)._make-package))",[0,[2,"make-package"]],["2htdp/universe"]],
["make-page-target-element",">scribble/core.html#(def._((lib._scribble/core..rkt)._make-page-target-element))",[0,[2,"make-page-target-element"]],["scribble/core"]],
["make-page-target-element",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._make-page-target-element))",[0,[2,"make-page-target-element"]],["scribble/struct"]],
["make-pair",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._make-pair))",[0,[2,"make-pair"]],["deinprogramm/DMdA-advanced"]],
["make-pair",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._make-pair))",[0,[2,"make-pair"]],["deinprogramm/DMdA-assignments"]],
["make-pair",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._make-pair))",[0,[2,"make-pair"]],["deinprogramm/DMdA-vanilla"]],
["make-paragraph",">scribble/core.html#(def._((lib._scribble/core..rkt)._make-paragraph))",[0,[2,"make-paragraph"]],["scribble/core"]],
["make-paragraph",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._make-paragraph))",[0,[2,"make-paragraph"]],["scribble/struct"]],
["make-param",">html/index.html#(def._((lib._html/main..rkt)._make-param))",[0,[2,"make-param"]],["html"]],
["make-parameter",">reference/parameters.html#(def._((quote._~23~25kernel)._make-parameter))",[0,[2,"make-parameter"]],["racket/base","racket"]],
["make-parameter",">srfi-std/srfi-39.html#make-parameter",[0,[2,"make-parameter"]],["srfi/39"]],
["make-parameter-rename-transformer",">reference/stxparam.html#(def._((lib._racket/stxparam-exptime..rkt)._make-parameter-rename-transformer))",[0,[2,"make-parameter-rename-transformer"]],["racket/stxparam-exptime","racket/stxparam"]],
["make-part",">scribble/core.html#(def._((lib._scribble/core..rkt)._make-part))",[0,[2,"make-part"]],["scribble/core"]],
["make-part",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._make-part))",[0,[2,"make-part"]],["scribble/struct"]],
["make-part-collect-decl",">scribble/decode.html#(def._((lib._scribble/decode..rkt)._make-part-collect-decl))",[0,[2,"make-part-collect-decl"]],["scribble/decode"]],
["make-part-index-decl",">scribble/decode.html#(def._((lib._scribble/decode..rkt)._make-part-index-decl))",[0,[2,"make-part-index-decl"]],["scribble/decode"]],
["make-part-relative-element",">scribble/core.html#(def._((lib._scribble/core..rkt)._make-part-relative-element))",[0,[2,"make-part-relative-element"]],["scribble/core"]],
["make-part-start",">scribble/decode.html#(def._((lib._scribble/decode..rkt)._make-part-start))",[0,[2,"make-part-start"]],["scribble/decode"]],
["make-part-tag-decl",">scribble/decode.html#(def._((lib._scribble/decode..rkt)._make-part-tag-decl))",[0,[2,"make-part-tag-decl"]],["scribble/decode"]],
["make-password-rejected",">net/pop3.html#(def._((lib._net/pop3..rkt)._make-password-rejected))",[0,[2,"make-password-rejected"]],["net/pop3"]],
["make-path->mime-type",">web-server-internal/mime-types.html#(def._((lib._web-server/private/mime-types..rkt)._make-path-~3emime-type))",[0,[2,"make-path->mime-type"]],["web-server/private/mime-types"]],
["make-path->relative-string",">raco/relative-paths.html#(def._((lib._setup/path-to-relative..rkt)._make-path-~3erelative-string))",[0,[2,"make-path->relative-string"]],["setup/path-to-relative"]],
["make-path/param",">net/url.html#(def._((lib._net/url-structs..rkt)._make-path/param))",[0,[2,"make-path/param"]],["net/url-structs","net/url"]],
["make-paths",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._make-paths))",[0,[2,"make-paths"]],["web-server/configuration/configuration-table-structs"]],
["make-pcdata",">xml/index.html#(def._((lib._xml/main..rkt)._make-pcdata))",[0,[2,"make-pcdata"]],["xml"]],
["make-pen",">draw/Drawing_Functions.html#(def._((lib._racket/draw..rkt)._make-pen))",[0,[2,"make-pen"]],["racket/draw"]],
["make-pen",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._make-pen))",[0,[2,"make-pen"]],["2htdp/image"]],
["make-phase-shift",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-phase-shift))",[0,[2,"make-phase-shift"]],["compiler/zo-structs"]],
["make-phased-module-binding",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-phased-module-binding))",[0,[2,"make-phased-module-binding"]],["compiler/zo-structs"]],
["make-phased-nominal-path",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-phased-nominal-path))",[0,[2,"make-phased-nominal-path"]],["compiler/zo-structs"]],
["make-pict",">slideshow/Pict_Datatype.html#(def._((lib._slideshow/pict..rkt)._make-pict))",[0,[2,"make-pict"]],["slideshow/pict","slideshow"]],
["make-pict-drawer",">slideshow/Rendering.html#(def._((lib._slideshow/pict..rkt)._make-pict-drawer))",[0,[2,"make-pict-drawer"]],["slideshow/pict","slideshow"]],
["make-pipe",">reference/pipeports.html#(def._((quote._~23~25kernel)._make-pipe))",[0,[2,"make-pipe"]],["racket/base","racket"]],
["make-pipe-with-specials",">reference/port-lib.html#(def._((lib._racket/port..rkt)._make-pipe-with-specials))",[0,[2,"make-pipe-with-specials"]],["racket/port","racket"]],
["make-placeholder",">reference/pairs.html#(def._((quote._~23~25kernel)._make-placeholder))",[0,[2,"make-placeholder"]],["racket/base","racket"]],
["make-planet",">raco/setup-plt-plt.html#(sig-val._((lib._setup/option-sig..rkt)._setup-option~5e._make-planet))",[0,[2,"make-planet"]],["setup/option-sig"]],
["make-planet-archive",">planet/Utility_Libraries.html#(def._((lib._planet/util..rkt)._make-planet-archive))",[0,[2,"make-planet-archive"]],["planet/util"]],
["make-planet-require-spec",">planet/Utility_Libraries.html#(def._((lib._planet/syntax..rkt)._make-planet-require-spec))",[0,[2,"make-planet-require-spec"]],["planet/syntax"]],
["make-planet-symbol",">planet/Utility_Libraries.html#(def._((lib._planet/private/version..rkt)._make-planet-symbol))",[0,[2,"make-planet-symbol"]],["planet/version"]],
["make-platform-bitmap",">draw/Drawing_Functions.html#(def._((lib._racket/draw..rkt)._make-platform-bitmap))",[0,[2,"make-platform-bitmap"]],["racket/draw"]],
["make-plot-setup",">mrlib/Plot.html#(def._((lib._mrlib/plot..rkt)._make-plot-setup))",[0,[2,"make-plot-setup"]],["mrlib/plot"]],
["make-plot-time",">plot/utils.html#(def._((lib._plot/utils..rkt)._make-plot-time))",[0,[2,"make-plot-time"]],["plot/utils"]],
["make-polar",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._make-polar))",[0,[2,"make-polar"]],["racket/base","racket"]],
["make-polar",">r5rs-std/r5rs-Z-H-9.html#%_idx_350",[0,[2,"make-polar"]],["r5rs"]],
["make-polar",">r6rs-std/r6rs-Z-H-14.html#node_idx_568",[0,[2,"make-polar"]],["rnrs/base-6"]],
["make-polar",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._make-polar))",[0,[2,"make-polar"]],["lang/htdp-advanced"]],
["make-polar",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._make-polar))",[0,[2,"make-polar"]],["lang/htdp-beginner"]],
["make-polar",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._make-polar))",[0,[2,"make-polar"]],["lang/htdp-beginner-abbr"]],
["make-polar",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._make-polar))",[0,[2,"make-polar"]],["lang/htdp-intermediate"]],
["make-polar",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._make-polar))",[0,[2,"make-polar"]],["lang/htdp-intermediate-lambda"]],
["make-polar",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._make-polar))",[0,[2,"make-polar"]],["deinprogramm/DMdA-advanced"]],
["make-polar",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._make-polar))",[0,[2,"make-polar"]],["deinprogramm/DMdA-assignments"]],
["make-polar",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._make-polar))",[0,[2,"make-polar"]],["deinprogramm/DMdA-beginner"]],
["make-polar",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._make-polar))",[0,[2,"make-polar"]],["deinprogramm/DMdA-vanilla"]],
["make-pop3",">net/pop3.html#(def._((lib._net/pop3..rkt)._make-pop3))",[0,[2,"make-pop3"]],["net/pop3"]],
["make-position",">parser-tools/Lexers.html#(def._((lib._parser-tools/lex..rkt)._make-position))",[0,[2,"make-position"]],["parser-tools/lex"]],
["make-position-token",">parser-tools/Lexers.html#(def._((lib._parser-tools/lex..rkt)._make-position-token))",[0,[2,"make-position-token"]],["parser-tools/lex"]],
["make-posn",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._make-posn))",[0,[2,"make-posn"]],["lang/htdp-advanced"]],
["make-posn",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._make-posn))",[0,[2,"make-posn"]],["lang/htdp-beginner"]],
["make-posn",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._make-posn))",[0,[2,"make-posn"]],["lang/htdp-beginner-abbr"]],
["make-posn",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._make-posn))",[0,[2,"make-posn"]],["lang/htdp-intermediate"]],
["make-posn",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._make-posn))",[0,[2,"make-posn"]],["lang/htdp-intermediate-lambda"]],
["make-posn",">htdp/index.html#(def._((lib._lang/posn..rkt)._make-posn))",[0,[2,"make-posn"]],["lang/posn"]],
["make-posn",">graphics/posn.html#(def._((lib._graphics/graphics..rkt)._make-posn))",[0,[2,"make-posn"]],["graphics/graphics"]],
["make-pre",">html/index.html#(def._((lib._html/main..rkt)._make-pre))",[0,[2,"make-pre"]],["html"]],
["make-pre-tick",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._make-pre-tick))",[0,[2,"make-pre-tick"]],["plot"]],
["make-prefab-struct",">reference/structutils.html#(def._((quote._~23~25kernel)._make-prefab-struct))",[0,[2,"make-prefab-struct"]],["racket/base","racket"]],
["make-prefix",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-prefix))",[0,[2,"make-prefix"]],["compiler/zo-structs"]],
["make-premature-close",">net/nntp.html#(def._((lib._net/nntp..rkt)._make-premature-close))",[0,[2,"make-premature-close"]],["net/nntp"]],
["make-primval",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-primval))",[0,[2,"make-primval"]],["compiler/zo-structs"]],
["make-print-checking",">make/make.html#(def._((lib._make/main..rkt)._make-print-checking))",[0,[2,"make-print-checking"]],["make"]],
["make-print-dep-no-line",">make/make.html#(def._((lib._make/main..rkt)._make-print-dep-no-line))",[0,[2,"make-print-dep-no-line"]],["make"]],
["make-print-reasons",">make/make.html#(def._((lib._make/main..rkt)._make-print-reasons))",[0,[2,"make-print-reasons"]],["make"]],
["make-procedure-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..rkt)._make-procedure-index-desc))",[0,[2,"make-procedure-index-desc"]],["scribble/manual-struct"]],
["make-proj-contract",">reference/Legacy_Contracts.html#(def._((lib._racket/contract..rkt)._make-proj-contract))",[0,[2,"make-proj-contract"]],["racket/contract","racket"]],
["make-prolog",">xml/index.html#(def._((lib._xml/main..rkt)._make-prolog))",[0,[2,"make-prolog"]],["xml"]],
["make-provide-pre-transformer",">reference/stxtrans.html#(def._((lib._racket/provide-transform..rkt)._make-provide-pre-transformer))",[0,[2,"make-provide-pre-transformer"]],["racket/provide-transform"]],
["make-provide-transformer",">reference/stxtrans.html#(def._((lib._racket/provide-transform..rkt)._make-provide-transformer))",[0,[2,"make-provide-transformer"]],["racket/provide-transform"]],
["make-provided",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-provided))",[0,[2,"make-provided"]],["compiler/zo-structs"]],
["make-pseudo-random-generator",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._make-pseudo-random-generator))",[0,[2,"make-pseudo-random-generator"]],["racket/base","racket"]],
["make-q",">html/index.html#(def._((lib._html/main..rkt)._make-q))",[0,[2,"make-q"]],["html"]],
["make-qp-error",">net/qp.html#(def._((lib._net/qp..rkt)._make-qp-error))",[0,[2,"make-qp-error"]],["net/qp"]],
["make-qp-wrong-input",">net/qp.html#(def._((lib._net/qp..rkt)._make-qp-wrong-input))",[0,[2,"make-qp-wrong-input"]],["net/qp"]],
["make-qp-wrong-line-size",">net/qp.html#(def._((lib._net/qp..rkt)._make-qp-wrong-line-size))",[0,[2,"make-qp-wrong-line-size"]],["net/qp"]],
["make-queue",">data/Imperative_Queues.html#(def._((lib._data/queue..rkt)._make-queue))",[0,[2,"make-queue"]],["data/queue"]],
["make-racket-launcher",">raco/exe.html#(def._((lib._launcher/launcher..rkt)._make-racket-launcher))",[0,[2,"make-racket-launcher"]],["launcher/launcher"]],
["make-racket-program-launcher",">raco/exe.html#(def._((lib._launcher/launcher..rkt)._make-racket-program-launcher))",[0,[2,"make-racket-program-launcher"]],["launcher/launcher"]],
["make-random-source",">srfi-std/srfi-27.html#make-random-source",[0,[2,"make-random-source"]],["srfi/27"]],
["make-range",">mzlib/mzlib_integer-set.html#(def._((lib._mzlib/integer-set..rkt)._make-range))",[0,[2,"make-range"]],["mzlib/integer-set"]],
["make-reader-graph",">reference/pairs.html#(def._((quote._~23~25kernel)._make-reader-graph))",[0,[2,"make-reader-graph"]],["racket/base","racket"]],
["make-readtable",">reference/readtables.html#(def._((quote._~23~25kernel)._make-readtable))",[0,[2,"make-readtable"]],["racket/base","racket"]],
["make-record-constructor-descriptor",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_322",[0,[2,"make-record-constructor-descriptor"]],["rnrs/records/procedural-6"]],
["make-record-type-descriptor",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_314",[0,[2,"make-record-type-descriptor"]],["rnrs/records/procedural-6"]],
["make-rectangular",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._make-rectangular))",[0,[2,"make-rectangular"]],["racket/base","racket"]],
["make-rectangular",">r5rs-std/r5rs-Z-H-9.html#%_idx_348",[0,[2,"make-rectangular"]],["r5rs"]],
["make-rectangular",">r6rs-std/r6rs-Z-H-14.html#node_idx_566",[0,[2,"make-rectangular"]],["rnrs/base-6"]],
["make-rectangular",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._make-rectangular))",[0,[2,"make-rectangular"]],["lang/htdp-advanced"]],
["make-rectangular",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._make-rectangular))",[0,[2,"make-rectangular"]],["lang/htdp-beginner"]],
["make-rectangular",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._make-rectangular))",[0,[2,"make-rectangular"]],["lang/htdp-beginner-abbr"]],
["make-rectangular",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._make-rectangular))",[0,[2,"make-rectangular"]],["lang/htdp-intermediate"]],
["make-rectangular",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._make-rectangular))",[0,[2,"make-rectangular"]],["lang/htdp-intermediate-lambda"]],
["make-redirect-target-element",">scribble/core.html#(def._((lib._scribble/core..rkt)._make-redirect-target-element))",[0,[2,"make-redirect-target-element"]],["scribble/core"]],
["make-redirect-target-element",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._make-redirect-target-element))",[0,[2,"make-redirect-target-element"]],["scribble/struct"]],
["make-region",">cards/index.html#(def._((lib._games/cards..rkt)._make-region))",[0,[2,"make-region"]],["games/cards"]],
["make-rename-transformer",">reference/stxtrans.html#(def._((quote._~23~25kernel)._make-rename-transformer))",[0,[2,"make-rename-transformer"]],["racket/base","racket"]],
["make-render-element",">scribble/core.html#(def._((lib._scribble/core..rkt)._make-render-element))",[0,[2,"make-render-element"]],["scribble/core"]],
["make-req",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-req))",[0,[2,"make-req"]],["compiler/zo-structs"]],
["make-request",">web-server/http.html#(def._((lib._web-server/http/request-structs..rkt)._make-request))",[0,[2,"make-request"]],["web-server/http/request-structs"]],
["make-require-transformer",">reference/stxtrans.html#(def._((lib._racket/require-transform..rkt)._make-require-transformer))",[0,[2,"make-require-transformer"]],["racket/require-transform"]],
["make-resolve-info",">scribble/core.html#(def._((lib._scribble/core..rkt)._make-resolve-info))",[0,[2,"make-resolve-info"]],["scribble/core"]],
["make-resolved-module-path",">reference/Module_Names_and_Loading.html#(def._((quote._~23~25kernel)._make-resolved-module-path))",[0,[2,"make-resolved-module-path"]],["racket/base","racket"]],
["make-responders",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._make-responders))",[0,[2,"make-responders"]],["web-server/configuration/configuration-table-structs"]],
["make-rgb",">graphics/Color_Operations.html#(def._((lib._graphics/graphics..rkt)._make-rgb))",[0,[2,"make-rgb"]],["graphics/graphics"]],
["make-root-area-container",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3abasic~3c~25~3e)._make-root-area-container))",[[0,[2,"make-root-area-container"]],[14,[" (method of ",[0,[2,"frame:basic<%>"]],")"]]],["framework"]],
["make-root-area-container",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3adelegate-mixin)._make-root-area-container))",[[0,[2,"make-root-area-container"]],[14,[" (method of ",[0,[2,"frame:delegate-mixin"]],")"]]],["framework"]],
["make-root-area-container",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3ainfo-mixin)._make-root-area-container))",[[0,[2,"make-root-area-container"]],[14,[" (method of ",[0,[2,"frame:info-mixin"]],")"]]],["framework"]],
["make-root-area-container",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3asearchable-mixin)._make-root-area-container))",[[0,[2,"make-root-area-container"]],[14,[" (method of ",[0,[2,"frame:searchable-mixin"]],")"]]],["framework"]],
["make-root-area-container",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astatus-line-mixin)._make-root-area-container))",[[0,[2,"make-root-area-container"]],[14,[" (method of ",[0,[2,"frame:status-line-mixin"]],")"]]],["framework"]],
["make-s",">html/index.html#(def._((lib._html/main..rkt)._make-s))",[0,[2,"make-s"]],["html"]],
["make-s16vector",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._make-s16vector))",[0,[2,"make-s16vector"]],["ffi/vector"]],
["make-s32vector",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._make-s32vector))",[0,[2,"make-s32vector"]],["ffi/vector"]],
["make-s64vector",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._make-s64vector))",[0,[2,"make-s64vector"]],["ffi/vector"]],
["make-s8vector",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._make-s8vector))",[0,[2,"make-s8vector"]],["ffi/vector"]],
["make-samp",">html/index.html#(def._((lib._html/main..rkt)._make-samp))",[0,[2,"make-samp"]],["html"]],
["make-screen-bitmap",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._make-screen-bitmap))",[0,[2,"make-screen-bitmap"]],["racket/gui/base","racket/gui"]],
["make-script",">html/index.html#(def._((lib._html/main..rkt)._make-script))",[0,[2,"make-script"]],["html"]],
["make-script-element",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._make-script-element))",[0,[2,"make-script-element"]],["scribble/struct"]],
["make-script-property",">scribble/core.html#(def._((lib._scribble/html-properties..rkt)._make-script-property))",[0,[2,"make-script-property"]],["scribble/html-properties"]],
["make-searchable",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aframe~25)._make-searchable))",[[0,[2,"make-searchable"]],[14,[" (method of ",[0,[2,"drracket:unit:frame%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["make-security-guard",">reference/securityguards.html#(def._((quote._~23~25kernel)._make-security-guard))",[0,[2,"make-security-guard"]],["racket/base","racket"]],
["make-select",">html/index.html#(def._((lib._html/main..rkt)._make-select))",[0,[2,"make-select"]],["html"]],
["make-semaphore",">reference/semaphore.html#(def._((quote._~23~25kernel)._make-semaphore))",[0,[2,"make-semaphore"]],["racket/base","racket"]],
["make-seq",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-seq))",[0,[2,"make-seq"]],["compiler/zo-structs"]],
["make-seq-for-syntax",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-seq-for-syntax))",[0,[2,"make-seq-for-syntax"]],["compiler/zo-structs"]],
["make-serialize-info",">reference/serialization.html#(def._((lib._racket/private/serialize..rkt)._make-serialize-info))",[0,[2,"make-serialize-info"]],["racket/serialize"]],
["make-serious-condition",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_422",[0,[2,"make-serious-condition"]],["rnrs/conditions-6"]],
["make-servlet",">web-server-internal/dispatch-servlets.html#(def._((lib._web-server/private/servlet..rkt)._make-servlet))",[0,[2,"make-servlet"]],["web-server/private/servlet"]],
["make-servlet-namespace",">web-server-internal/Web_Servers.html#(sig-val._web-config._((lib._web-server/web-config-sig..rkt)._web-config~5e._make-servlet-namespace))",[0,[2,"make-servlet-namespace"]],["web-server/web-config-sig"]],
["make-servlet-namespace/c",">web-server-internal/dispatch-servlets.html#(def._((lib._web-server/configuration/namespace..rkt)._make-servlet-namespace/c))",[0,[2,"make-servlet-namespace/c"]],["web-server/configuration/namespace"]],
["make-servlet-tester",">web-server/test.html#(def._((lib._web-server/test..rkt)._make-servlet-tester))",[0,[2,"make-servlet-tester"]],["web-server/test"]],
["make-set!-transformer",">reference/stxtrans.html#(def._((quote._~23~25kernel)._make-set!-transformer))",[0,[2,"make-set!-transformer"]],["racket/base","racket"]],
["make-shaped-parens",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._make-shaped-parens))",[0,[2,"make-shaped-parens"]],["scribble/racket","scribble/scheme"]],
["make-shared-bytes",">reference/bytestrings.html#(def._((quote._~23~25kernel)._make-shared-bytes))",[0,[2,"make-shared-bytes"]],["racket/base","racket"]],
["make-shared-flvector",">reference/flonums.html#(def._((lib._racket/flonum..rkt)._make-shared-flvector))",[0,[2,"make-shared-flvector"]],["racket/flonum"]],
["make-shared-fxvector",">reference/fixnums.html#(def._((lib._racket/fixnum..rkt)._make-shared-fxvector))",[0,[2,"make-shared-fxvector"]],["racket/fixnum"]],
["make-sibling-inspector",">reference/inspectors.html#(def._((quote._~23~25kernel)._make-sibling-inspector))",[0,[2,"make-sibling-inspector"]],["racket/base","racket"]],
["make-simple-module-binding",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-simple-module-binding))",[0,[2,"make-simple-module-binding"]],["compiler/zo-structs"]],
["make-simple-nominal-path",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-simple-nominal-path))",[0,[2,"make-simple-nominal-path"]],["compiler/zo-structs"]],
["make-sized-byte-string",">foreign/foreign_pointer-funcs.html#(def._((quote._~23~25foreign)._make-sized-byte-string))",[0,[2,"make-sized-byte-string"]],["ffi/unsafe"]],
["make-skip-list",">data/skip-list.html#(def._((lib._data/skip-list..rkt)._make-skip-list))",[0,[2,"make-skip-list"]],["data/skip-list"]],
["make-slide-inset",">slideshow/Configuration.html#(def._((lib._slideshow/base..rkt)._make-slide-inset))",[0,[2,"make-slide-inset"]],["slideshow/base","slideshow"]],
["make-small",">html/index.html#(def._((lib._html/main..rkt)._make-small))",[0,[2,"make-small"]],["html"]],
["make-snip",">framework/Comment_Box.html#(meth._(((lib._framework/main..rkt)._comment-box~3asnip~25)._make-snip))",[[0,[2,"make-snip"]],[14,[" (method of ",[0,[2,"comment-box:snip%"]],")"]]],["framework"]],
["make-snip",">framework/editor-snip.html#(meth._(((lib._framework/main..rkt)._editor-snip~3adecorated~25)._make-snip))",[[0,[2,"make-snip"]],[14,[" (method of ",[0,[2,"editor-snip:decorated%"]],")"]]],["framework"]],
["make-snip",">framework/editor-snip.html#(meth._(((lib._framework/main..rkt)._editor-snip~3adecorated-snipclass~25)._make-snip))",[[0,[2,"make-snip"]],[14,[" (method of ",[0,[2,"editor-snip:decorated-snipclass%"]],")"]]],["framework"]],
["make-soft-state",">web-server/stateless.html#(def._((lib._web-server/lang/soft..rkt)._make-soft-state))",[0,[2,"make-soft-state"]],["web-server/lang/soft"]],
["make-source",">xml/index.html#(def._((lib._xml/main..rkt)._make-source))",[0,[2,"make-source"]],["xml"]],
["make-span",">html/index.html#(def._((lib._html/main..rkt)._make-span))",[0,[2,"make-span"]],["html"]],
["make-special-comment",">reference/special-comments.html#(def._((quote._~23~25kernel)._make-special-comment))",[0,[2,"make-special-comment"]],["racket/base","racket"]],
["make-splay-tree",">data/Splay_Trees.html#(def._((lib._data/splay-tree..rkt)._make-splay-tree))",[0,[2,"make-splay-tree"]],["data/splay-tree"]],
["make-splice",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-splice))",[0,[2,"make-splice"]],["compiler/zo-structs"]],
["make-splice",">scribble/decode.html#(def._((lib._scribble/decode..rkt)._make-splice))",[0,[2,"make-splice"]],["scribble/decode"]],
["make-sql-bits",">db/sql-types.html#(def._((lib._db/base..rkt)._make-sql-bits))",[0,[2,"make-sql-bits"]],["db","db/base"]],
["make-srcloc",">reference/exns.html#(def._((lib._racket/private/base..rkt)._make-srcloc))",[0,[2,"make-srcloc"]],["racket/base","racket"]],
["make-ssl-tcp@",">net/ssl-tcp-unit.html#(def._((lib._net/ssl-tcp-unit..rkt)._make-ssl-tcp~40))",[0,[2,"make-ssl-tcp@"]],["net/ssl-tcp-unit"]],
["make-st-mark",">errortrace/stacktrace.html#(sig-val._((lib._errortrace/stacktrace..rkt)._stacktrace~5e._make-st-mark))",[0,[2,"make-st-mark"]],["errortrace/stacktrace"]],
["make-stateless.servlet",">web-server-internal/dispatch-servlets.html#(def._((lib._web-server/servlet/setup..rkt)._make-stateless..servlet))",[0,[2,"make-stateless.servlet"]],["web-server/servlet/setup"]],
["make-store",">web-server/stateless.html#(def._((lib._web-server/stuffers/store..rkt)._make-store))",[0,[2,"make-store"]],["web-server/stuffers/store"]],
["make-strike",">html/index.html#(def._((lib._html/main..rkt)._make-strike))",[0,[2,"make-strike"]],["html"]],
["make-string",">reference/strings.html#(def._((quote._~23~25kernel)._make-string))",[0,[2,"make-string"]],["racket/base","racket"]],
["make-string",">r5rs-std/r5rs-Z-H-9.html#%_idx_512",[0,[2,"make-string"]],["r5rs"]],
["make-string",">r6rs-std/r6rs-Z-H-14.html#node_idx_688",[0,[2,"make-string"]],["rnrs/base-6"]],
["make-string",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._make-string))",[0,[2,"make-string"]],["lang/htdp-advanced"]],
["make-string",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._make-string))",[0,[2,"make-string"]],["lang/htdp-beginner"]],
["make-string",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._make-string))",[0,[2,"make-string"]],["lang/htdp-beginner-abbr"]],
["make-string",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._make-string))",[0,[2,"make-string"]],["lang/htdp-intermediate"]],
["make-string",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._make-string))",[0,[2,"make-string"]],["lang/htdp-intermediate-lambda"]],
["make-string",">srfi-std/srfi-13.html#make-string",[0,[2,"make-string"]],["srfi/13"]],
["make-strong",">html/index.html#(def._((lib._html/main..rkt)._make-strong))",[0,[2,"make-strong"]],["html"]],
["make-struct-field-accessor",">reference/creatingmorestructs.html#(def._((quote._~23~25kernel)._make-struct-field-accessor))",[0,[2,"make-struct-field-accessor"]],["racket/base","racket"]],
["make-struct-field-mutator",">reference/creatingmorestructs.html#(def._((quote._~23~25kernel)._make-struct-field-mutator))",[0,[2,"make-struct-field-mutator"]],["racket/base","racket"]],
["make-struct-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..rkt)._make-struct-index-desc))",[0,[2,"make-struct-index-desc"]],["scribble/manual-struct"]],
["make-struct-info",">reference/structinfo.html#(def._((lib._racket/struct-info..rkt)._make-struct-info))",[0,[2,"make-struct-info"]],["racket/struct-info"]],
["make-struct-type",">reference/creatingmorestructs.html#(def._((quote._~23~25kernel)._make-struct-type))",[0,[2,"make-struct-type"]],["racket/base","racket"]],
["make-struct-type",">lazy/index.html#(def._((lib._lazy/main..rkt)._make-struct-type))",[0,[2,"make-struct-type"]],["lazy"]],
["make-struct-type-property",">reference/structprops.html#(def._((quote._~23~25kernel)._make-struct-type-property))",[0,[2,"make-struct-type-property"]],["racket/base","racket"]],
["make-stuffer",">web-server/stateless.html#(def._((lib._web-server/stuffers/stuffer..rkt)._make-stuffer))",[0,[2,"make-stuffer"]],["web-server/stuffers/stuffer"]],
["make-stx",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-stx))",[0,[2,"make-stx"]],["compiler/zo-structs"]],
["make-style",">html/index.html#(def._((lib._html/main..rkt)._make-style))",[0,[2,"make-style"]],["html"]],
["make-style",">scribble/core.html#(def._((lib._scribble/core..rkt)._make-style))",[0,[2,"make-style"]],["scribble/core"]],
["make-styled-itemization",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._make-styled-itemization))",[0,[2,"make-styled-itemization"]],["scribble/struct"]],
["make-styled-paragraph",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._make-styled-paragraph))",[0,[2,"make-styled-paragraph"]],["scribble/struct"]],
["make-sub",">html/index.html#(def._((lib._html/main..rkt)._make-sub))",[0,[2,"make-sub"]],["html"]],
["make-sup",">html/index.html#(def._((lib._html/main..rkt)._make-sup))",[0,[2,"make-sup"]],["html"]],
["make-syntax-delta-introducer",">reference/stxtrans.html#(def._((quote._~23~25kernel)._make-syntax-delta-introducer))",[0,[2,"make-syntax-delta-introducer"]],["racket/base","racket"]],
["make-syntax-introducer",">reference/stxtrans.html#(def._((quote._~23~25kernel)._make-syntax-introducer))",[0,[2,"make-syntax-introducer"]],["racket/base","racket"]],
["make-syntax-violation",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_480",[0,[2,"make-syntax-violation"]],["rnrs/conditions-6"]],
["make-table",">cards/index.html#(def._((lib._games/cards..rkt)._make-table))",[0,[2,"make-table"]],["games/cards"]],
["make-table",">html/index.html#(def._((lib._html/main..rkt)._make-table))",[0,[2,"make-table"]],["html"]],
["make-table",">scribble/core.html#(def._((lib._scribble/core..rkt)._make-table))",[0,[2,"make-table"]],["scribble/core"]],
["make-table",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._make-table))",[0,[2,"make-table"]],["scribble/struct"]],
["make-table-cells",">scribble/core.html#(def._((lib._scribble/core..rkt)._make-table-cells))",[0,[2,"make-table-cells"]],["scribble/core"]],
["make-table-columns",">scribble/core.html#(def._((lib._scribble/core..rkt)._make-table-columns))",[0,[2,"make-table-columns"]],["scribble/core"]],
["make-target-element",">scribble/core.html#(def._((lib._scribble/core..rkt)._make-target-element))",[0,[2,"make-target-element"]],["scribble/core"]],
["make-target-element",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._make-target-element))",[0,[2,"make-target-element"]],["scribble/struct"]],
["make-target-url",">scribble/core.html#(def._((lib._scribble/core..rkt)._make-target-url))",[0,[2,"make-target-url"]],["scribble/core"]],
["make-target-url",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._make-target-url))",[0,[2,"make-target-url"]],["scribble/struct"]],
["make-tbody",">html/index.html#(def._((lib._html/main..rkt)._make-tbody))",[0,[2,"make-tbody"]],["html"]],
["make-td",">html/index.html#(def._((lib._html/main..rkt)._make-td))",[0,[2,"make-td"]],["html"]],
["make-temporary-file",">reference/Filesystem.html#(def._((lib._racket/file..rkt)._make-temporary-file))",[0,[2,"make-temporary-file"]],["racket/file","racket"]],
["make-tentative-pretty-print-output-port",">reference/pretty-print.html#(def._((lib._racket/pretty..rkt)._make-tentative-pretty-print-output-port))",[0,[2,"make-tentative-pretty-print-output-port"]],["racket/pretty","racket"]],
["make-test-error",">rackunit/internals.html#(def._((lib._rackunit/main..rkt)._make-test-error))",[0,[2,"make-test-error"]],["rackunit"]],
["make-test-failure",">rackunit/internals.html#(def._((lib._rackunit/main..rkt)._make-test-failure))",[0,[2,"make-test-failure"]],["rackunit"]],
["make-test-result",">rackunit/internals.html#(def._((lib._rackunit/main..rkt)._make-test-result))",[0,[2,"make-test-result"]],["rackunit"]],
["make-test-success",">rackunit/internals.html#(def._((lib._rackunit/main..rkt)._make-test-success))",[0,[2,"make-test-success"]],["rackunit"]],
["make-test-suite",">rackunit/api.html#(def._((lib._rackunit/main..rkt)._make-test-suite))",[0,[2,"make-test-suite"]],["rackunit"]],
["make-tex-addition",">scribble/core.html#(def._((lib._scribble/latex-properties..rkt)._make-tex-addition))",[0,[2,"make-tex-addition"]],["scribble/latex-properties"]],
["make-text",">teachpack/gui.html#(def._((lib._htdp/gui..rkt)._make-text))",[0,[2,"make-text"]],["htdp/gui"]],
["make-textarea",">html/index.html#(def._((lib._html/main..rkt)._make-textarea))",[0,[2,"make-textarea"]],["html"]],
["make-tfoot",">html/index.html#(def._((lib._html/main..rkt)._make-tfoot))",[0,[2,"make-tfoot"]],["html"]],
["make-th",">html/index.html#(def._((lib._html/main..rkt)._make-th))",[0,[2,"make-th"]],["html"]],
["make-thead",">html/index.html#(def._((lib._html/main..rkt)._make-thead))",[0,[2,"make-thead"]],["html"]],
["make-theory",">datalog/interop.html#(def._((lib._datalog/main..rkt)._make-theory))",[0,[2,"make-theory"]],["datalog"]],
["make-thing-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..rkt)._make-thing-index-desc))",[0,[2,"make-thing-index-desc"]],["scribble/manual-struct"]],
["make-thread-cell",">reference/threadcells.html#(def._((quote._~23~25kernel)._make-thread-cell))",[0,[2,"make-thread-cell"]],["racket/base","racket"]],
["make-thread-group",">reference/threadgroups.html#(def._((quote._~23~25kernel)._make-thread-group))",[0,[2,"make-thread-group"]],["racket/base","racket"]],
["make-threshold-lru-manager",">web-server/servlet.html#(def._((lib._web-server/managers/lru..rkt)._make-threshold-.L.R.U-manager))",[0,[2,"make-threshold-LRU-manager"]],["web-server/managers/lru"]],
["make-tick",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._make-tick))",[0,[2,"make-tick"]],["plot"]],
["make-ticks",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._make-ticks))",[0,[2,"make-ticks"]],["plot"]],
["make-time",">srfi-std/srfi-19.html#make-time",[0,[2,"make-time"]],["srfi/19"]],
["make-timeouts",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._make-timeouts))",[0,[2,"make-timeouts"]],["web-server/configuration/configuration-table-structs"]],
["make-timer",">web-server-internal/timer.html#(def._((lib._web-server/private/timer..rkt)._make-timer))",[0,[2,"make-timer"]],["web-server/private/timer"]],
["make-title",">html/index.html#(def._((lib._html/main..rkt)._make-title))",[0,[2,"make-title"]],["html"]],
["make-title-decl",">scribble/decode.html#(def._((lib._scribble/decode..rkt)._make-title-decl))",[0,[2,"make-title-decl"]],["scribble/decode"]],
["make-toc-element",">scribble/core.html#(def._((lib._scribble/core..rkt)._make-toc-element))",[0,[2,"make-toc-element"]],["scribble/core"]],
["make-toc-element",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._make-toc-element))",[0,[2,"make-toc-element"]],["scribble/struct"]],
["make-toc-target-element",">scribble/core.html#(def._((lib._scribble/core..rkt)._make-toc-target-element))",[0,[2,"make-toc-target-element"]],["scribble/core"]],
["make-toc-target-element",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._make-toc-target-element))",[0,[2,"make-toc-target-element"]],["scribble/struct"]],
["make-top-level-rename",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-top-level-rename))",[0,[2,"make-top-level-rename"]],["compiler/zo-structs"]],
["make-toplevel",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-toplevel))",[0,[2,"make-toplevel"]],["compiler/zo-structs"]],
["make-topsyntax",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-topsyntax))",[0,[2,"make-topsyntax"]],["compiler/zo-structs"]],
["make-tr",">html/index.html#(def._((lib._html/main..rkt)._make-tr))",[0,[2,"make-tr"]],["html"]],
["make-transcoder",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_616",[0,[2,"make-transcoder"]],["rnrs/io/ports-6"]],
["make-traversal",">tools/Check_Syntax.html#(def._((lib._drracket/check-syntax..rkt)._make-traversal))",[0,[2,"make-traversal"]],["drracket/check-syntax"]],
["make-traverse-block",">scribble/core.html#(def._((lib._scribble/core..rkt)._make-traverse-block))",[0,[2,"make-traverse-block"]],["scribble/core"]],
["make-traverse-element",">scribble/core.html#(def._((lib._scribble/core..rkt)._make-traverse-element))",[0,[2,"make-traverse-element"]],["scribble/core"]],
["make-tt",">html/index.html#(def._((lib._html/main..rkt)._make-tt))",[0,[2,"make-tt"]],["html"]],
["make-u",">html/index.html#(def._((lib._html/main..rkt)._make-u))",[0,[2,"make-u"]],["html"]],
["make-u16vector",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._make-u16vector))",[0,[2,"make-u16vector"]],["ffi/vector"]],
["make-u32vector",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._make-u32vector))",[0,[2,"make-u32vector"]],["ffi/vector"]],
["make-u64vector",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._make-u64vector))",[0,[2,"make-u64vector"]],["ffi/vector"]],
["make-u8vector",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._make-u8vector))",[0,[2,"make-u8vector"]],["ffi/vector"]],
["make-ul",">html/index.html#(def._((lib._html/main..rkt)._make-ul))",[0,[2,"make-ul"]],["html"]],
["make-undefined-violation",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_490",[0,[2,"make-undefined-violation"]],["rnrs/conditions-6"]],
["make-unexpected-response",">net/nntp.html#(def._((lib._net/nntp..rkt)._make-unexpected-response))",[0,[2,"make-unexpected-response"]],["net/nntp"]],
["make-unexpected-termination",">net/mime.html#(def._((lib._net/mime..rkt)._make-unexpected-termination))",[0,[2,"make-unexpected-termination"]],["net/mime"]],
["make-union-type",">foreign/C_Union_Types.html#(def._((quote._~23~25foreign)._make-union-type))",[0,[2,"make-union-type"]],["ffi/unsafe"]],
["make-unnumbered-part",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._make-unnumbered-part))",[0,[2,"make-unnumbered-part"]],["scribble/struct"]],
["make-url",">net/url.html#(def._((lib._net/url-structs..rkt)._make-url))",[0,[2,"make-url"]],["net/url-structs","net/url"]],
["make-url->path",">web-server-internal/filesystem-map.html#(def._((lib._web-server/dispatchers/filesystem-map..rkt)._make-url-~3epath))",[0,[2,"make-url->path"]],["web-server/dispatchers/filesystem-map"]],
["make-url->valid-path",">web-server-internal/filesystem-map.html#(def._((lib._web-server/dispatchers/filesystem-map..rkt)._make-url-~3evalid-path))",[0,[2,"make-url->valid-path"]],["web-server/dispatchers/filesystem-map"]],
["make-url-anchor",">scribble/core.html#(def._((lib._scribble/html-properties..rkt)._make-url-anchor))",[0,[2,"make-url-anchor"]],["scribble/html-properties"]],
["make-user",">raco/setup-plt-plt.html#(sig-val._((lib._setup/option-sig..rkt)._setup-option~5e._make-user))",[0,[2,"make-user"]],["setup/option-sig"]],
["make-username-rejected",">net/pop3.html#(def._((lib._net/pop3..rkt)._make-username-rejected))",[0,[2,"make-username-rejected"]],["net/pop3"]],
["make-v1.servlet",">web-server-internal/dispatch-servlets.html#(def._((lib._web-server/servlet/setup..rkt)._make-v1..servlet))",[0,[2,"make-v1.servlet"]],["web-server/servlet/setup"]],
["make-v2.servlet",">web-server-internal/dispatch-servlets.html#(def._((lib._web-server/servlet/setup..rkt)._make-v2..servlet))",[0,[2,"make-v2.servlet"]],["web-server/servlet/setup"]],
["make-var",">html/index.html#(def._((lib._html/main..rkt)._make-var))",[0,[2,"make-var"]],["html"]],
["make-var-id",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._make-var-id))",[0,[2,"make-var-id"]],["scribble/racket","scribble/scheme"]],
["make-variable-id",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._make-variable-id))",[0,[2,"make-variable-id"]],["scribble/racket","scribble/scheme"]],
["make-variable-transformer",">r6rs-lib-std/r6rs-lib-Z-H-13.html#node_idx_1120",[0,[2,"make-variable-transformer"]],["rnrs/syntax-case-6"]],
["make-varref",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-varref))",[0,[2,"make-varref"]],["compiler/zo-structs"]],
["make-vec",">plot/compat.html#(def._((lib._plot/compat..rkt)._make-vec))",[0,[2,"make-vec"]],["plot/compat"]],
["make-vec3",">deinprogramm/line3d.html#(def._((lib._teachpack/deinprogramm/line3d..rkt)._make-vec3))",[0,[2,"make-vec3"]],["teachpack/deinprogramm/line3d"]],
["make-vec4",">deinprogramm/line3d.html#(def._((lib._teachpack/deinprogramm/line3d..rkt)._make-vec4))",[0,[2,"make-vec4"]],["teachpack/deinprogramm/line3d"]],
["make-vector",">reference/vectors.html#(def._((quote._~23~25kernel)._make-vector))",[0,[2,"make-vector"]],["racket/base","racket"]],
["make-vector",">r5rs-std/r5rs-Z-H-9.html#%_idx_560",[0,[2,"make-vector"]],["r5rs"]],
["make-vector",">r6rs-std/r6rs-Z-H-14.html#node_idx_724",[0,[2,"make-vector"]],["rnrs/base-6"]],
["make-vector",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._make-vector))",[0,[2,"make-vector"]],["lang/htdp-advanced"]],
["make-vector",">srfi-std/srfi-43.html#make-vector",[0,[2,"make-vector"]],["srfi/43"]],
["make-verbose",">raco/setup-plt-plt.html#(sig-val._((lib._setup/option-sig..rkt)._setup-option~5e._make-verbose))",[0,[2,"make-verbose"]],["setup/option-sig"]],
["make-versioned-part",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._make-versioned-part))",[0,[2,"make-versioned-part"]],["scribble/struct"]],
["make-vicinity",">srfi-std/srfi-59.html#make-vicinity",[0,[2,"make-vicinity"]],["srfi/59"]],
["make-violation",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_434",[0,[2,"make-violation"]],["rnrs/conditions-6"]],
["make-visible",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3abasic~3c~25~3e)._make-visible))",[[0,[2,"make-visible"]],[14,[" (method of ",[0,[2,"frame:basic<%>"]],")"]]],["framework"]],
["make-warning",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_416",[0,[2,"make-warning"]],["rnrs/conditions-6"]],
["make-weak-box",">reference/weakbox.html#(def._((quote._~23~25kernel)._make-weak-box))",[0,[2,"make-weak-box"]],["racket/base","racket"]],
["make-weak-custom-hash",">reference/dicts.html#(def._((lib._racket/dict..rkt)._make-weak-custom-hash))",[0,[2,"make-weak-custom-hash"]],["racket/dict","racket"]],
["make-weak-hash",">reference/hashtables.html#(def._((quote._~23~25kernel)._make-weak-hash))",[0,[2,"make-weak-hash"]],["racket/base","racket"]],
["make-weak-hasheq",">reference/hashtables.html#(def._((quote._~23~25kernel)._make-weak-hasheq))",[0,[2,"make-weak-hasheq"]],["racket/base","racket"]],
["make-weak-hasheqv",">reference/hashtables.html#(def._((quote._~23~25kernel)._make-weak-hasheqv))",[0,[2,"make-weak-hasheqv"]],["racket/base","racket"]],
["make-web-cell",">web-server/stateless.html#(form._((lib._web-server/lang/web-cells..rkt)._make-web-cell))",[0,[1,"make-web-cell"]],["web-server/lang/web-cells"]],
["make-web-cell",">web-server/servlet.html#(def._((lib._web-server/servlet/web-cells..rkt)._make-web-cell))",[0,[2,"make-web-cell"]],["web-server/servlet/web-cells"]],
["make-web-parameter",">web-server/stateless.html#(form._((lib._web-server/lang/web-param..rkt)._make-web-parameter))",[0,[1,"make-web-parameter"]],["web-server/lang/web-param"]],
["make-who-condition",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_454",[0,[2,"make-who-condition"]],["rnrs/conditions-6"]],
["make-will-executor",">reference/willexecutor.html#(def._((quote._~23~25kernel)._make-will-executor))",[0,[2,"make-will-executor"]],["racket/base","racket"]],
["make-with-attributes",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._make-with-attributes))",[0,[2,"make-with-attributes"]],["scribble/struct"]],
["make-with-cont-mark",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-with-cont-mark))",[0,[2,"make-with-cont-mark"]],["compiler/zo-structs"]],
["make-wrap",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-wrap))",[0,[2,"make-wrap"]],["compiler/zo-structs"]],
["make-wrapped",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-wrapped))",[0,[2,"make-wrapped"]],["compiler/zo-structs"]],
["make-zo",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._make-zo))",[0,[2,"make-zo"]],["compiler/zo-structs"]],
["make-zo",">raco/setup-plt-plt.html#(sig-val._((lib._setup/option-sig..rkt)._setup-option~5e._make-zo))",[0,[2,"make-zo"]],["setup/option-sig"]],
["make/collection",">make/collection.html",[9,[0,"make/collection"]],"module"],
["make/collection-sig",">make/collection.html#(mod-path._make/collection-sig)",[9,[0,"make/collection-sig"]],"module"],
["make/collection-unit",">make/collection.html#(mod-path._make/collection-unit)",[9,[0,"make/collection-unit"]],"module"],
["make/make-sig",">make/make.html#(mod-path._make/make-sig)",[9,[0,"make/make-sig"]],"module"],
["make/make-unit",">make/make.html#(mod-path._make/make-unit)",[9,[0,"make/make-unit"]],"module"],
["make/proc",">make/make.html#(def._((lib._make/main..rkt)._make/proc))",[0,[2,"make/proc"]],["make"]],
["make/setup-extension",">make/setup-extension.html",[9,[0,"make/setup-extension"]],"module"],
["make: dependency manager",">make/index.html","Make: Dependency Manager",false],
["make:collection@",">make/collection.html#(def._((lib._make/collection-unit..rkt)._make~3acollection~40))",[0,[2,"make:collection@"]],["make/collection-unit"]],
["make:collection^",">make/collection.html#(form._((lib._make/collection-sig..rkt)._make~3acollection~5e))",[0,[1,"make:collection^"]],["make/collection-sig"]],
["make@",">make/make.html#(def._((lib._make/make-unit..rkt)._make~40))",[0,[2,"make@"]],["make/make-unit"]],
["make^",">make/make.html#(form._((lib._make/make-sig..rkt)._make~5e))",[0,[1,"make^"]],["make/make-sig"]],
["making collections",">make/collection.html","Making Collections",false],
["making pictures",">slideshow/Making_Pictures.html","Making Pictures",false],
["making slides",">slideshow/Making_Slides.html","Making Slides",false],
["malformed-multipart-entity",">net/mime.html#(def._((lib._net/mime..rkt)._malformed-multipart-entity))",[0,[2,"malformed-multipart-entity"]],["net/mime"]],
["malformed-multipart-entity-msg",">net/mime.html#(def._((lib._net/mime..rkt)._malformed-multipart-entity-msg))",[0,[2,"malformed-multipart-entity-msg"]],["net/mime"]],
["malformed-multipart-entity?",">net/mime.html#(def._((lib._net/mime..rkt)._malformed-multipart-entity~3f))",[0,[2,"malformed-multipart-entity?"]],["net/mime"]],
["malformed-server-response",">net/pop3.html#(def._((lib._net/pop3..rkt)._malformed-server-response))",[0,[2,"malformed-server-response"]],["net/pop3"]],
["malformed-server-response-communicator",">net/pop3.html#(def._((lib._net/pop3..rkt)._malformed-server-response-communicator))",[0,[2,"malformed-server-response-communicator"]],["net/pop3"]],
["malformed-server-response?",">net/pop3.html#(def._((lib._net/pop3..rkt)._malformed-server-response~3f))",[0,[2,"malformed-server-response?"]],["net/pop3"]],
["malloc",">foreign/foreign_pointer-funcs.html#(def._((quote._~23~25foreign)._malloc))",[0,[2,"malloc"]],["ffi/unsafe"]],
["malloc-immobile-cell",">foreign/foreign_pointer-funcs.html#(def._((quote._~23~25foreign)._malloc-immobile-cell))",[0,[2,"malloc-immobile-cell"]],["ffi/unsafe"]],
["managed transaction",">db/query-api.html#(tech._managed._transaction)","<span style=\"font-style: italic\">managed transaction</span>",false],
["managed-compile-zo",">raco/make.html#(def._((lib._compiler/cm..rkt)._managed-compile-zo))",[0,[2,"managed-compile-zo"]],["compiler/cm"]],
["manager",">web-server/stateless.html#(def._((lib._web-server/scribblings/dummy-stateless-servlet..rkt)._manager))",[0,[2,"manager"]],[]],
["manager",">web-server/servlet.html#(def._((lib._web-server/scribblings/dummy-v2-servlet..rkt)._manager))",[0,[2,"manager"]],[]],
["manager",">web-server/servlet.html#(def._((lib._web-server/managers/manager..rkt)._manager))",[0,[2,"manager"]],["web-server/managers/manager"]],
["manager-adjust-timeout!",">web-server/servlet.html#(def._((lib._web-server/managers/manager..rkt)._manager-adjust-timeout!))",[0,[2,"manager-adjust-timeout!"]],["web-server/managers/manager"]],
["manager-clear-continuations!",">web-server/servlet.html#(def._((lib._web-server/managers/manager..rkt)._manager-clear-continuations!))",[0,[2,"manager-clear-continuations!"]],["web-server/managers/manager"]],
["manager-compile-notify-handler",">raco/make.html#(def._((lib._compiler/cm..rkt)._manager-compile-notify-handler))",[0,[2,"manager-compile-notify-handler"]],["compiler/cm"]],
["manager-continuation-lookup",">web-server/servlet.html#(def._((lib._web-server/managers/manager..rkt)._manager-continuation-lookup))",[0,[2,"manager-continuation-lookup"]],["web-server/managers/manager"]],
["manager-continuation-peek",">web-server/servlet.html#(def._((lib._web-server/managers/manager..rkt)._manager-continuation-peek))",[0,[2,"manager-continuation-peek"]],["web-server/managers/manager"]],
["manager-continuation-store!",">web-server/servlet.html#(def._((lib._web-server/managers/manager..rkt)._manager-continuation-store!))",[0,[2,"manager-continuation-store!"]],["web-server/managers/manager"]],
["manager-create-instance",">web-server/servlet.html#(def._((lib._web-server/managers/manager..rkt)._manager-create-instance))",[0,[2,"manager-create-instance"]],["web-server/managers/manager"]],
["manager-skip-file-handler",">raco/make.html#(def._((lib._compiler/cm..rkt)._manager-skip-file-handler))",[0,[2,"manager-skip-file-handler"]],["compiler/cm"]],
["manager-trace-handler",">raco/make.html#(def._((lib._compiler/cm..rkt)._manager-trace-handler))",[0,[2,"manager-trace-handler"]],["compiler/cm"]],
["manager?",">web-server/servlet.html#(def._((lib._web-server/managers/manager..rkt)._manager~3f))",[0,[2,"manager?"]],["web-server/managers/manager"]],
["managing connections",">db/connect.html#(part._managing-connections)","Managing Connections",false],
["managing control arrows: \"arrow.ss\"",">teachpack/arrow.html",["Managing Control Arrows: ",[6,"\"arrow.ss\""],"<a name=\"(idx._(gentag._9._(lib._teachpack/teachpack..scrbl)))\"></a>"],false],
["managing ports",">reference/port-ops.html","Managing Ports",false],
["manipulating images",">teachpack/image.html#(part._manipulation)","Manipulating Images",false],
["manipulating images: \"image.ss\"",">teachpack/image.html",["Manipulating Images: ",[6,"\"image.ss\""],"<a name=\"(idx._(gentag._0._(lib._teachpack/teachpack..scrbl)))\"></a>"],false],
["manipulating messages",">net/imap.html#(part._.Manipulating_.Messages)","Manipulating Messages",false],
["manipulating namespaces",">guide/mk-namespace.html","Manipulating Namespaces",false],
["manipulating paths",">reference/Manipulating_Paths.html","Manipulating Paths",false],
["manipulating racklog variables",">racklog/lv-manip.html","Manipulating Racklog Variables",false],
["manipulating simple html documents: \"docs.ss\"",">teachpack/docs.html",["Manipulating Simple HTML Documents: ",[6,"\"docs.ss\""],"<a name=\"(idx._(gentag._10._(lib._teachpack/teachpack..scrbl)))\"></a>"],false],
["manual forms",">scribble/manual.html","Manual Forms",false],
["map",">reference/pairs.html#(def._((lib._racket/private/map..rkt)._map))",[0,[2,"map"]],["racket/base","racket"]],
["map",">r5rs-std/r5rs-Z-H-9.html#%_idx_580",[0,[2,"map"]],["r5rs"]],
["map",">r6rs-std/r6rs-Z-H-14.html#node_idx_642",[0,[2,"map"]],["rnrs/base-6"]],
["map",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._map))",[0,[2,"map"]],["lang/htdp-advanced"]],
["map",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._map))",[0,[2,"map"]],["lang/htdp-intermediate"]],
["map",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._map))",[0,[2,"map"]],["lang/htdp-intermediate-lambda"]],
["map",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._map))",[0,[2,"map"]],["deinprogramm/DMdA-advanced"]],
["map",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._map))",[0,[2,"map"]],["deinprogramm/DMdA-assignments"]],
["map",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._map))",[0,[2,"map"]],["deinprogramm/DMdA-vanilla"]],
["map",">lazy/index.html#(def._((lib._lazy/main..rkt)._map))",[0,[2,"map"]],["lazy"]],
["map",">srfi-std/srfi-1.html#map",[0,[2,"map"]],["srfi/1"]],
["map!",">srfi-std/srfi-1.html#map!",[0,[2,"map!"]],["srfi/1"]],
["map-command-as-meta-key",">gui/Editor_Functions.html#(def._((lib._mred/main..rkt)._map-command-as-meta-key))",[0,[2,"map-command-as-meta-key"]],["racket/gui/base","racket/gui"]],
["map-e",">frtime/index.html#(def._((lib._frtime/main..rkt)._map-e))",[0,[2,"map-e"]],["frtime"]],
["map-function",">gui/keymap_.html#(meth._(((lib._mred/main..rkt)._keymap~25)._map-function))",[[0,[2,"map-function"]],[14,[" (method of ",[0,[2,"keymap%"]],")"]]],["racket/gui/base","racket/gui"]],
["map-function",">framework/Keymap.html#(meth._(((lib._framework/main..rkt)._keymap~3aaug-keymap-mixin)._map-function))",[[0,[2,"map-function"]],[14,[" (method of ",[0,[2,"keymap:aug-keymap-mixin"]],")"]]],["framework"]],
["map-image",">picturing-programs/index.html#(def._((lib._picturing-programs/private/map-image..rkt)._map-image))",[0,[2,"map-image"]],["picturing-programs/private/map-image","picturing-programs"]],
["map-image/extra",">picturing-programs/index.html#(def._((lib._picturing-programs/private/map-image..rkt)._map-image/extra))",[0,[2,"map-image/extra"]],["picturing-programs/private/map-image","picturing-programs"]],
["map-in-order",">srfi-std/srfi-1.html#map-in-order",[0,[2,"map-in-order"]],["srfi/1"]],
["map-shift-style",">browser/index.html#(meth._(((lib._browser/browser..rkt)._hyper-text-mixin)._map-shift-style))",[[0,[2,"map-shift-style"]],[14,[" (method of ",[0,[2,"hyper-text-mixin"]],")"]]],["browser/browser","browser"]],
["map-snip",">embedded-gui/snip-related-functions.html#(def._((lib._embedded-gui/main..rkt)._map-snip))",[0,[2,"map-snip"]],["embedded-gui"]],
["map-to-list",">embedded-gui/dllist___.html#(meth._(((lib._embedded-gui/main..rkt)._dllist~3c~25~3e)._map-to-list))",[[0,[2,"map-to-list"]],[14,[" (method of ",[0,[2,"dllist<%>"]],")"]]],["embedded-gui"]],
["map/values",">unstable/list.html#(def._((lib._unstable/list..rkt)._map/values))",[0,[2,"map/values"]],["unstable/list"]],
["map2",">unstable/list.html#(def._((lib._unstable/list..rkt)._map2))",[0,[2,"map2"]],["unstable/list"]],
["map3-image",">picturing-programs/index.html#(def._((lib._picturing-programs/private/map-image..rkt)._map3-image))",[0,[2,"map3-image"]],["picturing-programs/private/map-image","picturing-programs"]],
["map4-image",">picturing-programs/index.html#(def._((lib._picturing-programs/private/map-image..rkt)._map4-image))",[0,[2,"map4-image"]],["picturing-programs/private/map-image","picturing-programs"]],
["mapped-function",">plot/utils.html#(def._((lib._plot/utils..rkt)._mapped-function))",[0,[2,"mapped-function"]],["plot/utils"]],
["mapped-function-f",">plot/utils.html#(def._((lib._plot/utils..rkt)._mapped-function-f))",[0,[2,"mapped-function-f"]],["plot/utils"]],
["mapped-function-fmap",">plot/utils.html#(def._((lib._plot/utils..rkt)._mapped-function-fmap))",[0,[2,"mapped-function-fmap"]],["plot/utils"]],
["mapped-function?",">plot/utils.html#(def._((lib._plot/utils..rkt)._mapped-function~3f))",[0,[2,"mapped-function?"]],["plot/utils"]],
["mappend",">reference/mpairs.html#(def._((lib._racket/mpair..rkt)._mappend))",[0,[2,"mappend"]],["racket/mpair"]],
["mappend!",">reference/mpairs.html#(def._((lib._racket/mpair..rkt)._mappend!))",[0,[2,"mappend!"]],["racket/mpair"]],
["mapping urls to paths",">web-server-internal/filesystem-map.html","Mapping URLs to Paths",false],
["margin",">slideshow/Constants_and_Layout_Variables.html#(form._((lib._slideshow/base..rkt)._margin))",[0,[1,"margin"]],["slideshow/base","slideshow"]],
["margin",">gui/windowing-overview.html#(tech._margin)","<span style=\"font-style: italic\">margin</span>",false],
["margin-note",">scribble/base.html#(def._((lib._scribble/base..rkt)._margin-note))",[0,[2,"margin-note"]],["scribble/base"]],
["margin-note*",">scribble/base.html#(def._((lib._scribble/base..rkt)._margin-note*))",[0,[2,"margin-note*"]],["scribble/base"]],
["mark parameters",">unstable/Mark_Parameters.html","Mark Parameters",false],
["mark-barrier",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._mark-barrier))",[0,[2,"mark-barrier"]],["compiler/zo-structs"]],
["mark-barrier-value",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._mark-barrier-value))",[0,[2,"mark-barrier-value"]],["compiler/zo-structs"]],
["mark-barrier?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._mark-barrier~3f))",[0,[2,"mark-barrier?"]],["compiler/zo-structs"]],
["mark-matching-parenthesis",">framework/Racket.html#(meth._(((lib._framework/main..rkt)._racket~3atext~3c~25~3e)._mark-matching-parenthesis))",[[0,[2,"mark-matching-parenthesis"]],[14,[" (method of ",[0,[2,"racket:text<%>"]],")"]]],["framework"]],
["mark-parameter",">unstable/Mark_Parameters.html#(def._((lib._unstable/markparam..rkt)._mark-parameter))",[0,[2,"mark-parameter"]],["unstable/markparam"]],
["mark-parameter-all",">unstable/Mark_Parameters.html#(def._((lib._unstable/markparam..rkt)._mark-parameter-all))",[0,[2,"mark-parameter-all"]],["unstable/markparam"]],
["mark-parameter-first",">unstable/Mark_Parameters.html#(def._((lib._unstable/markparam..rkt)._mark-parameter-first))",[0,[2,"mark-parameter-first"]],["unstable/markparam"]],
["mark-parameter?",">unstable/Mark_Parameters.html#(def._((lib._unstable/markparam..rkt)._mark-parameter~3f))",[0,[2,"mark-parameter?"]],["unstable/markparam"]],
["mark-parameterize",">unstable/Mark_Parameters.html#(form._((lib._unstable/markparam..rkt)._mark-parameterize))",[0,[1,"mark-parameterize"]],["unstable/markparam"]],
["mark-parameters-all",">unstable/Mark_Parameters.html#(def._((lib._unstable/markparam..rkt)._mark-parameters-all))",[0,[2,"mark-parameters-all"]],["unstable/markparam"]],
["marshall-settings",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3alanguage~3c~25~3e)._marshall-settings))",[[0,[2,"marshall-settings"]],[14,[" (method of ",[0,[2,"drracket:language:language<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["marshall-settings",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3amodule-based-language~3c~25~3e)._marshall-settings))",[[0,[2,"marshall-settings"]],[14,[" (method of ",[0,[2,"drracket:language:module-based-language<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["marshall-settings",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3asimple-module-based-language-~3emodule-based-language-mixin)._marshall-settings))",[[0,[2,"marshall-settings"]],[14,[" (method of ",[0,[2,"drracket:language:simple-module-based-language->module-based-language-mixin"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["massoc",">reference/mpairs.html#(def._((lib._racket/mpair..rkt)._massoc))",[0,[2,"massoc"]],["racket/mpair"]],
["massq",">reference/mpairs.html#(def._((lib._racket/mpair..rkt)._massq))",[0,[2,"massq"]],["racket/mpair"]],
["massv",">reference/mpairs.html#(def._((lib._racket/mpair..rkt)._massv))",[0,[2,"massv"]],["racket/mpair"]],
["master",">teachpack/master.html#(def._((lib._htdp/master..rkt)._master))",[0,[2,"master"]],["htdp/master"]],
["master",">inside/im_memoryalloc.html#(tech._master)","<span style=\"font-style: italic\">master</span>",false],
["master teachpack",">teachpack/master.html#(idx._(gentag._4._(lib._teachpack/teachpack..scrbl)))","master teachpack",false],
["master-play teachpack",">teachpack/master-play.html#(idx._(gentag._5._(lib._teachpack/teachpack..scrbl)))","master-play teachpack",false],
["masterminding: \"master.ss\"",">teachpack/master.html",["MasterMinding: ",[6,"\"master.ss\""],"<a name=\"(idx._(gentag._4._(lib._teachpack/teachpack..scrbl)))\"></a>"],false],
["match",">unstable/match.html","Match",false],
["match",">reference/match.html#(form._((lib._racket/match..rkt)._match))",[0,[1,"match"]],["racket/match","racket"]],
["match",">htdp-langs/advanced.html#(form._((lib._lang/htdp-advanced..rkt)._match))",[0,[1,"match"]],["lang/htdp-advanced"]],
["match",">mzlib/mzlib_match.html#(form._((lib._mzlib/match..rkt)._match))",[0,[1,"match"]],["mzlib/match"]],
["match expander",">reference/match.html#(tech._match._expander)","<span style=\"font-style: italic\">match expander</span>",false],
["match*",">reference/match.html#(form._((lib._racket/match..rkt)._match*))",[0,[1,"match*"]],["racket/match","racket"]],
["match*/derived",">reference/match.html#(form._((lib._racket/match..rkt)._match*/derived))",[0,[1,"match*/derived"]],["racket/match","racket"]],
["match-bindings",">redex/The_Redex_Reference.html#(def._((lib._redex/reduction-semantics..rkt)._match-bindings))",[0,[2,"match-bindings"]],["redex/reduction-semantics","redex"]],
["match-define",">reference/match.html#(form._((lib._racket/match..rkt)._match-define))",[0,[1,"match-define"]],["racket/match","racket"]],
["match-define",">mzlib/mzlib_match.html#(form._((lib._mzlib/match..rkt)._match-define))",[0,[1,"match-define"]],["mzlib/match"]],
["match-define-values",">reference/match.html#(form._((lib._racket/match..rkt)._match-define-values))",[0,[1,"match-define-values"]],["racket/match","racket"]],
["match-equality-test",">reference/match.html#(def._((lib._racket/match..rkt)._match-equality-test))",[0,[2,"match-equality-test"]],["racket/match","racket"]],
["match-equality-test",">mzlib/mzlib_match.html#(def._((lib._mzlib/match..rkt)._match-equality-test))",[0,[2,"match-equality-test"]],["mzlib/match"]],
["match-lambda",">reference/match.html#(form._((lib._racket/match..rkt)._match-lambda))",[0,[1,"match-lambda"]],["racket/match","racket"]],
["match-lambda",">mzlib/mzlib_match.html#(form._((lib._mzlib/match..rkt)._match-lambda))",[0,[1,"match-lambda"]],["mzlib/match"]],
["match-lambda*",">reference/match.html#(form._((lib._racket/match..rkt)._match-lambda*))",[0,[1,"match-lambda*"]],["racket/match","racket"]],
["match-lambda*",">mzlib/mzlib_match.html#(form._((lib._mzlib/match..rkt)._match-lambda*))",[0,[1,"match-lambda*"]],["mzlib/match"]],
["match-lambda**",">reference/match.html#(form._((lib._racket/match..rkt)._match-lambda**))",[0,[1,"match-lambda**"]],["racket/match","racket"]],
["match-let",">reference/match.html#(form._((lib._racket/match..rkt)._match-let))",[0,[1,"match-let"]],["racket/match","racket"]],
["match-let",">mzlib/mzlib_match.html#(form._((lib._mzlib/match..rkt)._match-let))",[0,[1,"match-let"]],["mzlib/match"]],
["match-let*",">reference/match.html#(form._((lib._racket/match..rkt)._match-let*))",[0,[1,"match-let*"]],["racket/match","racket"]],
["match-let*",">mzlib/mzlib_match.html#(form._((lib._mzlib/match..rkt)._match-let*))",[0,[1,"match-let*"]],["mzlib/match"]],
["match-let*-values",">reference/match.html#(form._((lib._racket/match..rkt)._match-let*-values))",[0,[1,"match-let*-values"]],["racket/match","racket"]],
["match-let-values",">reference/match.html#(form._((lib._racket/match..rkt)._match-let-values))",[0,[1,"match-let-values"]],["racket/match","racket"]],
["match-letrec",">reference/match.html#(form._((lib._racket/match..rkt)._match-letrec))",[0,[1,"match-letrec"]],["racket/match","racket"]],
["match-letrec",">mzlib/mzlib_match.html#(form._((lib._mzlib/match..rkt)._match-letrec))",[0,[1,"match-letrec"]],["mzlib/match"]],
["match/derived",">reference/match.html#(form._((lib._racket/match..rkt)._match/derived))",[0,[1,"match/derived"]],["racket/match","racket"]],
["match/values",">reference/match.html#(form._((lib._racket/match..rkt)._match/values))",[0,[1,"match/values"]],["racket/match","racket"]],
["match:end",">mzlib/mzlib_awk.html#(def._((lib._mzlib/awk..rkt)._match~3aend))",[0,[2,"match:end"]],["mzlib/awk"]],
["match:start",">mzlib/mzlib_awk.html#(def._((lib._mzlib/awk..rkt)._match~3astart))",[0,[2,"match:start"]],["mzlib/awk"]],
["match:substring",">mzlib/mzlib_awk.html#(def._((lib._mzlib/awk..rkt)._match~3asubstring))",[0,[2,"match:substring"]],["mzlib/awk"]],
["match?",">gui/snip_.html#(meth._(((lib._racket/snip..rkt)._snip~25)._match~3f))",[[0,[2,"match?"]],[14,[" (method of ",[0,[2,"snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["match?",">redex/The_Redex_Reference.html#(def._((lib._redex/reduction-semantics..rkt)._match~3f))",[0,[2,"match?"]],["redex/reduction-semantics","redex"]],
["match?",">unstable/match.html#(form._((lib._unstable/match..rkt)._match~3f))",[0,[1,"match?"]],["unstable/match"]],
["matching fully-expanded expressions",">syntax/syntax-helpers.html#(part._kerncase)","Matching Fully-Expanded Expressions",false],
["matching regexp patterns",">guide/regexp-match.html","Matching Regexp Patterns",false],
["matching sequences",">guide/pattern-macros.html#(part._.Matching_.Sequences)","Matching Sequences",false],
["matching-identifiers-in",">reference/require.html#(form._((lib._racket/require..rkt)._matching-identifiers-in))",[0,[1,"matching-identifiers-in"]],["racket/require"]],
["matching-identifiers-out",">reference/require.html#(form._((lib._racket/provide..rkt)._matching-identifiers-out))",[0,[1,"matching-identifiers-out"]],["racket/provide"]],
["math",">scribble/Miscellaneous.html#(def._((lib._scribble/manual..rkt)._math))",[0,[2,"math"]],["scribble/manual"]],
["matrix",">deinprogramm/line3d.html#(tech._matrix)","<span style=\"font-style: italic\">Matrix</span>",false],
["matrix functions: \"matrix.ss\"",">teachpack/matrix.html",["Matrix Functions: ",[6,"\"matrix.ss\""],"<a name=\"(idx._(gentag._19._(lib._teachpack/teachpack..scrbl)))\"></a>"],false],
["matrix snip",">mrlib/Matrix_Snip.html","Matrix Snip",false],
["matrix teachpack",">teachpack/matrix.html#(idx._(gentag._19._(lib._teachpack/teachpack..scrbl)))","matrix teachpack",false],
["matrix->rectangle",">teachpack/matrix.html#(def._((lib._htdp/matrix..rkt)._matrix-~3erectangle))",[0,[2,"matrix->rectangle"]],["htdp/matrix"]],
["matrix-cols",">teachpack/matrix.html#(def._((lib._htdp/matrix..rkt)._matrix-cols))",[0,[2,"matrix-cols"]],["htdp/matrix"]],
["matrix-minor",">teachpack/matrix.html#(def._((lib._htdp/matrix..rkt)._matrix-minor))",[0,[2,"matrix-minor"]],["htdp/matrix"]],
["matrix-ref",">teachpack/matrix.html#(def._((lib._htdp/matrix..rkt)._matrix-ref))",[0,[2,"matrix-ref"]],["htdp/matrix"]],
["matrix-render",">teachpack/matrix.html#(def._((lib._htdp/matrix..rkt)._matrix-render))",[0,[2,"matrix-render"]],["htdp/matrix"]],
["matrix-rows",">teachpack/matrix.html#(def._((lib._htdp/matrix..rkt)._matrix-rows))",[0,[2,"matrix-rows"]],["htdp/matrix"]],
["matrix-set",">teachpack/matrix.html#(def._((lib._htdp/matrix..rkt)._matrix-set))",[0,[2,"matrix-set"]],["htdp/matrix"]],
["matrix-set!",">teachpack/matrix.html#(def._((lib._htdp/matrix..rkt)._matrix-set!))",[0,"matrix-set!"],["htdp/matrix"]],
["matrix-where?",">teachpack/matrix.html#(def._((lib._htdp/matrix..rkt)._matrix-where~3f))",[0,[2,"matrix-where?"]],["htdp/matrix"]],
["matrix4x4",">deinprogramm/line3d.html#(def._((lib._teachpack/deinprogramm/line3d..rkt)._matrix4x4))",[0,"matrix4x4"],["teachpack/deinprogramm/line3d"]],
["matrix?",">teachpack/matrix.html#(def._((lib._htdp/matrix..rkt)._matrix~3f))",[0,[2,"matrix?"]],["htdp/matrix"]],
["mausereignis-art",">deinprogramm/world.html#(tech._mausereignis._art)","<span style=\"font-style: italic\">Mausereignis-Art</span>",false],
["max",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._max))",[0,[2,"max"]],["racket/base","racket"]],
["max",">r5rs-std/r5rs-Z-H-9.html#%_idx_278",[0,[2,"max"]],["r5rs"]],
["max",">r6rs-std/r6rs-Z-H-14.html#node_idx_490",[0,[2,"max"]],["rnrs/base-6"]],
["max",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._max))",[0,[2,"max"]],["lang/htdp-advanced"]],
["max",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._max))",[0,[2,"max"]],["lang/htdp-beginner"]],
["max",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._max))",[0,[2,"max"]],["lang/htdp-beginner-abbr"]],
["max",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._max))",[0,[2,"max"]],["lang/htdp-intermediate"]],
["max",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._max))",[0,[2,"max"]],["lang/htdp-intermediate-lambda"]],
["max",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._max))",[0,[2,"max"]],["deinprogramm/DMdA-advanced"]],
["max",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._max))",[0,[2,"max"]],["deinprogramm/DMdA-assignments"]],
["max",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._max))",[0,[2,"max"]],["deinprogramm/DMdA-beginner"]],
["max",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._max))",[0,[2,"max"]],["deinprogramm/DMdA-vanilla"]],
["max-ec",">srfi-std/srfi-42.html#max-ec",[0,[1,"max-ec"]],["srfi/42"]],
["max-history",">readline/index.html#(def._((lib._readline/pread..rkt)._max-history))",[0,[2,"max-history"]],["readline/pread"]],
["max-waiting",">web-server-internal/dispatch-server-unit.html#(sig-val._((lib._web-server/private/dispatch-server-sig..rkt)._dispatch-server-config~5e._max-waiting))",[0,[2,"max-waiting"]],["web-server/private/dispatch-server-sig"]],
["max-waiting",">web-server-internal/Web_Servers.html#(sig-val._web-config._((lib._web-server/web-config-sig..rkt)._web-config~5e._max-waiting))",[0,[2,"max-waiting"]],["web-server/web-config-sig"]],
["max-waiting",">web-server-internal/Web_Servers.html#(idx._(gentag._2._(lib._web-server/scribblings/web-server-internal..scrbl)))","max-waiting",false],
["maximize",">gui/frame_.html#(meth._(((lib._mred/main..rkt)._frame~25)._maximize))",[[0,[2,"maximize"]],[14,[" (method of ",[0,[2,"frame%"]],")"]]],["racket/gui/base","racket/gui"]],
["maximum",">htdp-langs/beginner-abbr.html#(idx._htdp-beginner-abbr._(gentag._23._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-beginner-abbr))","maximum",false],
["maximum",">htdp-langs/intermediate.html#(idx._htdp-intermediate._(gentag._32._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-intermediate))","maximum",false],
["maximum",">htdp-langs/intermediate-lam.html#(idx._htdp-intermediate-lambda._(gentag._41._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-intermediate-lambda))","maximum",false],
["maximum",">htdp-langs/advanced.html#(idx._htdp-advanced._(gentag._50._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-advanced))","maximum",false],
["maximum",">htdp-langs/beginner.html#(idx._htdp-beginner._(gentag._8._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-beginner))","maximum",false],
["maybe",">eopl/index.html#(def._((lib._eopl/eopl..rkt)._maybe))",[0,[2,"maybe"]],["eopl"]],
["maybe-apply",">plot/contracts.html#(def._((lib._plot/utils..rkt)._maybe-apply))",[0,[2,"maybe-apply"]],["plot/utils"]],
["maybe-function/c",">plot/contracts.html#(def._((lib._plot/utils..rkt)._maybe-function/c))",[0,[2,"maybe-function/c"]],["plot/utils"]],
["maybe-inexact->exact",">plot/utils.html#(def._((lib._plot/utils..rkt)._maybe-inexact-~3eexact))",[0,[2,"maybe-inexact->exact"]],["plot/utils"]],
["mc",">reference/characters.html#(idx._(gentag._129._(lib._scribblings/reference/reference..scrbl)))",[7,"'mc"],false],
["mcar",">reference/mpairs.html#(def._((quote._~23~25kernel)._mcar))",[0,[2,"mcar"]],["racket/base","racket"]],
["mcdr",">reference/mpairs.html#(def._((quote._~23~25kernel)._mcdr))",[0,[2,"mcdr"]],["racket/base","racket"]],
["mcons",">reference/mpairs.html#(def._((quote._~23~25kernel)._mcons))",[0,[2,"mcons"]],["racket/base","racket"]],
["md5",">file/md5.html#(def._((lib._file/md5..rkt)._md5))",[0,[2,"md5"]],["file/md5"]],
["md5 message digest",">file/md5.html","MD5 Message Digest",false],
["md5-stuffer",">web-server/stateless.html#(def._((lib._web-server/stuffers/hash..rkt)._md5-stuffer))",[0,[2,"md5-stuffer"]],["web-server/stuffers/hash"]],
["me",">reference/characters.html#(idx._(gentag._130._(lib._scribblings/reference/reference..scrbl)))",[7,"'me"],false],
["media",">planet/Developing_Packages_for_PLaneT.html#(idx._(gentag._6._(lib._planet/planet..scrbl)))",[7,"'media"],false],
["member",">reference/pairs.html#(def._((lib._racket/private/list..rkt)._member))",[0,[2,"member"]],["racket/base","racket"]],
["member",">r5rs-std/r5rs-Z-H-9.html#%_idx_450",[0,[2,"member"]],["r5rs"]],
["member",">r6rs-lib-std/r6rs-lib-Z-H-4.html#node_idx_226",[0,[2,"member"]],["rnrs/lists-6"]],
["member",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._member))",[0,[2,"member"]],["lang/htdp-advanced"]],
["member",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._member))",[0,[2,"member"]],["lang/htdp-beginner"]],
["member",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._member))",[0,[2,"member"]],["lang/htdp-beginner-abbr"]],
["member",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._member))",[0,[2,"member"]],["lang/htdp-intermediate"]],
["member",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._member))",[0,[2,"member"]],["lang/htdp-intermediate-lambda"]],
["member",">lazy/index.html#(def._((lib._lazy/main..rkt)._member))",[0,[2,"member"]],["lazy"]],
["member",">srfi-std/srfi-1.html#member",[0,[2,"member"]],["srfi/1"]],
["member-name-key",">reference/createclass.html#(form._((lib._racket/private/class-internal..rkt)._member-name-key))",[0,[1,"member-name-key"]],["racket/class","racket"]],
["member-name-key-hash-code",">reference/createclass.html#(def._((lib._racket/private/class-internal..rkt)._member-name-key-hash-code))",[0,[2,"member-name-key-hash-code"]],["racket/class","racket"]],
["member-name-key=?",">reference/createclass.html#(def._((lib._racket/private/class-internal..rkt)._member-name-key~3d~3f))",[0,[2,"member-name-key=?"]],["racket/class","racket"]],
["member-name-key?",">reference/createclass.html#(def._((lib._racket/private/class-internal..rkt)._member-name-key~3f))",[0,[2,"member-name-key?"]],["racket/class","racket"]],
["member?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._member~3f))",[0,[2,"member?"]],["lang/htdp-advanced"]],
["member?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._member~3f))",[0,[2,"member?"]],["lang/htdp-beginner"]],
["member?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._member~3f))",[0,[2,"member?"]],["lang/htdp-beginner-abbr"]],
["member?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._member~3f))",[0,[2,"member?"]],["lang/htdp-intermediate"]],
["member?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._member~3f))",[0,[2,"member?"]],["lang/htdp-intermediate-lambda"]],
["member?",">mzlib/mzlib_integer-set.html#(def._((lib._mzlib/integer-set..rkt)._member~3f))",[0,[2,"member?"]],["mzlib/integer-set"]],
["memcpy",">foreign/foreign_pointer-funcs.html#(def._((quote._~23~25foreign)._memcpy))",[0,[2,"memcpy"]],["ffi/unsafe"]],
["memf",">reference/pairs.html#(def._((lib._racket/private/list..rkt)._memf))",[0,[2,"memf"]],["racket/base","racket"]],
["memf",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._memf))",[0,[2,"memf"]],["lang/htdp-advanced"]],
["memf",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._memf))",[0,[2,"memf"]],["lang/htdp-intermediate"]],
["memf",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._memf))",[0,[2,"memf"]],["lang/htdp-intermediate-lambda"]],
["memf",">lazy/index.html#(def._((lib._lazy/main..rkt)._memf))",[0,[2,"memf"]],["lazy"]],
["memmove",">foreign/foreign_pointer-funcs.html#(def._((quote._~23~25foreign)._memmove))",[0,[2,"memmove"]],["ffi/unsafe"]],
["memory",">inside/im_memoryalloc.html","memory",false],
["memory --- kid's game",">games/memory.html",[[15,"<img src=\"memory.png\" alt=\"\" />"]," ","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Memory</span>"," ","&#8212;","<wbr></wbr>"," Kid","&rsquo;","s Game"],false],
["memory allocation",">inside/im_memoryalloc.html","Memory Allocation",false],
["memory functions",">inside/im_memoryalloc.html#(part._.Memory_.Functions)","Memory Functions",false],
["memory management",">foreign/foreign_pointer-funcs.html#(part._.Memory_.Management)","Memory Management",false],
["memory management",">guide/performance.html#(part._gc-perf)","Memory Management",false],
["memory management",">reference/memory.html","Memory Management",false],
["memp",">r6rs-lib-std/r6rs-lib-Z-H-4.html#node_idx_224",[0,[2,"memp"]],["rnrs/lists-6"]],
["memq",">reference/pairs.html#(def._((lib._racket/private/list..rkt)._memq))",[0,[2,"memq"]],["racket/base","racket"]],
["memq",">r5rs-std/r5rs-Z-H-9.html#%_idx_446",[0,[2,"memq"]],["r5rs"]],
["memq",">r6rs-lib-std/r6rs-lib-Z-H-4.html#node_idx_230",[0,[2,"memq"]],["rnrs/lists-6"]],
["memq",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._memq))",[0,[2,"memq"]],["lang/htdp-advanced"]],
["memq",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._memq))",[0,[2,"memq"]],["lang/htdp-beginner"]],
["memq",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._memq))",[0,[2,"memq"]],["lang/htdp-beginner-abbr"]],
["memq",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._memq))",[0,[2,"memq"]],["lang/htdp-intermediate"]],
["memq",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._memq))",[0,[2,"memq"]],["lang/htdp-intermediate-lambda"]],
["memq",">lazy/index.html#(def._((lib._lazy/main..rkt)._memq))",[0,[2,"memq"]],["lazy"]],
["memq",">srfi-std/srfi-1.html#memq",[0,[2,"memq"]],["srfi/1"]],
["memset",">foreign/foreign_pointer-funcs.html#(def._((quote._~23~25foreign)._memset))",[0,[2,"memset"]],["ffi/unsafe"]],
["memv",">reference/pairs.html#(def._((lib._racket/private/list..rkt)._memv))",[0,[2,"memv"]],["racket/base","racket"]],
["memv",">r5rs-std/r5rs-Z-H-9.html#%_idx_448",[0,[2,"memv"]],["r5rs"]],
["memv",">r6rs-lib-std/r6rs-lib-Z-H-4.html#node_idx_228",[0,[2,"memv"]],["rnrs/lists-6"]],
["memv",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._memv))",[0,[2,"memv"]],["lang/htdp-advanced"]],
["memv",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._memv))",[0,[2,"memv"]],["lang/htdp-beginner"]],
["memv",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._memv))",[0,[2,"memv"]],["lang/htdp-beginner-abbr"]],
["memv",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._memv))",[0,[2,"memv"]],["lang/htdp-intermediate"]],
["memv",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._memv))",[0,[2,"memv"]],["lang/htdp-intermediate-lambda"]],
["memv",">lazy/index.html#(def._((lib._lazy/main..rkt)._memv))",[0,[2,"memv"]],["lazy"]],
["memv",">srfi-std/srfi-1.html#memv",[0,[2,"memv"]],["srfi/1"]],
["menu",">framework/Menu.html","Menu",false],
["menu",">html/index.html#(def._((lib._html/main..rkt)._menu))",[0,[2,"menu"]],["html"]],
["menu",">gui/menu-item_.html#(idx._(gentag._117._(lib._scribblings/gui/gui..scrbl)))",[7,"'menu"],false],
["menu",">gui/checkable-menu-item_.html#(idx._(gentag._29._(lib._scribblings/gui/gui..scrbl)))",[7,"'menu"],false],
["menu",">gui/key-event_.html#(idx._(gentag._45._(lib._scribblings/gui/gui..scrbl)))",[7,"'menu"],false],
["menu",">gui/windowing-overview.html#(tech._menu)","<span style=\"font-style: italic\">menu</span>",false],
["menu bar",">gui/windowing-overview.html#(tech._menu._bar)","<span style=\"font-style: italic\">menu bar</span>",false],
["menu item containers",">gui/windowing-overview.html#(tech._menu._item._container)","<span style=\"font-style: italic\">Menu Item Containers</span>",false],
["menu items",">gui/windowing-overview.html#(tech._menu._item)","<span style=\"font-style: italic\">Menu Items</span>",false],
["menu%",">gui/menu_.html",[0,[2,"menu%"]],["racket/gui/base","racket/gui"]],
["menu-bar%",">gui/menu-bar_.html",[0,[2,"menu-bar%"]],["racket/gui/base","racket/gui"]],
["menu-control-font",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._menu-control-font))",[0,[2,"menu-control-font"]],["racket/gui/base","racket/gui"]],
["menu-group/notify-box",">unstable/gui-notify.html#(def._((lib._unstable/gui/notify..rkt)._menu-group/notify-box))",[0,[2,"menu-group/notify-box"]],["unstable/gui/notify"]],
["menu-item%",">gui/menu-item_.html",[0,[2,"menu-item%"]],["racket/gui/base","racket/gui"]],
["menu-item-container<%>",">gui/menu-item-container___.html",[0,[2,"menu-item-container<%>"]],["racket/gui/base","racket/gui"]],
["menu-item<%>",">gui/menu-item___.html",[0,[2,"menu-item<%>"]],["racket/gui/base","racket/gui"]],
["menu-option/notify-box",">unstable/gui-notify.html#(def._((lib._unstable/gui/notify..rkt)._menu-option/notify-box))",[0,[2,"menu-option/notify-box"]],["unstable/gui/notify"]],
["menu-popdown",">gui/popup-menu_.html#(idx._(gentag._122._(lib._scribblings/gui/gui..scrbl)))",[7,"'menu-popdown"],false],
["menu-popdown-none",">gui/popup-menu_.html#(idx._(gentag._121._(lib._scribblings/gui/gui..scrbl)))",[7,"'menu-popdown-none"],false],
["menu:can-restore-checkable-menu-item%",">framework/Menu.html#(def._((lib._framework/main..rkt)._menu~3acan-restore-checkable-menu-item~25))",[0,[2,"menu:can-restore-checkable-menu-item%"]],["framework"]],
["menu:can-restore-menu-item%",">framework/Menu.html#(def._((lib._framework/main..rkt)._menu~3acan-restore-menu-item~25))",[0,[2,"menu:can-restore-menu-item%"]],["framework"]],
["menu:can-restore-mixin",">framework/Menu.html#(def._((lib._framework/main..rkt)._menu~3acan-restore-mixin))",[0,[2,"menu:can-restore-mixin"]],["framework"]],
["menu:can-restore-underscore-menu%",">framework/Menu.html#(def._((lib._framework/main..rkt)._menu~3acan-restore-underscore-menu~25))",[0,[2,"menu:can-restore-underscore-menu%"]],["framework"]],
["menu:can-restore-underscore-mixin",">framework/Menu.html#(def._((lib._framework/main..rkt)._menu~3acan-restore-underscore-mixin))",[0,[2,"menu:can-restore-underscore-mixin"]],["framework"]],
["menu:can-restore-underscore<%>",">framework/Menu.html#(def._((lib._framework/main..rkt)._menu~3acan-restore-underscore~3c~25~3e))",[0,[2,"menu:can-restore-underscore<%>"]],["framework"]],
["menu:can-restore<%>",">framework/Menu.html#(def._((lib._framework/main..rkt)._menu~3acan-restore~3c~25~3e))",[0,[2,"menu:can-restore<%>"]],["framework"]],
["menu?",">html/index.html#(def._((lib._html/main..rkt)._menu~3f))",[0,[2,"menu?"]],["html"]],
["menuitem",">scribble/doc-strings.html#(def._((lib._scribble/manual..rkt)._menuitem))",[0,[2,"menuitem"]],["scribble/manual"]],
["menus",">drracket/Menus.html","Menus",false],
["merge",">turtles/Value_Turtles.html#(def._((lib._graphics/value-turtles..rkt)._merge))",[0,[2,"merge"]],["graphics/value-turtles"]],
["merge-e",">frtime/index.html#(def._((lib._frtime/main..rkt)._merge-e))",[0,[2,"merge-e"]],["frtime"]],
["merge-input",">reference/port-lib.html#(def._((lib._racket/port..rkt)._merge-input))",[0,[2,"merge-input"]],["racket/port","racket"]],
["merge-refpoints",">unstable/ppict.html#(def._((lib._unstable/gui/ppict..rkt)._merge-refpoints))",[0,[2,"merge-refpoints"]],["unstable/gui/ppict"]],
["merge-sorted-lists",">mzlib/mzlib_list.html#(def._((lib._mzlib/list..rkt)._merge-sorted-lists))",[0,[2,"merge-sorted-lists"]],["mzlib/list"]],
["merge-with",">gui/snip_.html#(meth._(((lib._racket/snip..rkt)._snip~25)._merge-with))",[[0,[2,"merge-with"]],[14,[" (method of ",[0,[2,"snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["mergesort",">mzlib/mzlib_list.html#(def._((lib._mzlib/list..rkt)._mergesort))",[0,[2,"mergesort"]],["mzlib/list"]],
["merging animations",">slideshow/play.html#(part._.Merging_.Animations)","Merging Animations",false],
["message",">net/mime.html#(def._((lib._net/mime..rkt)._message))",[0,[2,"message"]],["net/mime"]],
["message",">gui/windowing-overview.html#(tech._message)","<span style=\"font-style: italic\">message</span>",false],
["message decoding",">net/mime.html#(part._.Message_.Decoding)","Message Decoding",false],
["message router",">reference/distributed-places.html#(tech._message._router)","<span style=\"font-style: italic\">message router</span>",false],
["message structure and form",">htdp/index.html#(part._.Message_.Structure_and_.Form)","Message Structure and Form",false],
["message%",">gui/message_.html",[0,[2,"message%"]],["racket/gui/base","racket/gui"]],
["message+check-box",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._message+check-box))",[0,[2,"message+check-box"]],["racket/gui/base","racket/gui"]],
["message+check-box/custom",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._message+check-box/custom))",[0,[2,"message+check-box/custom"]],["racket/gui/base","racket/gui"]],
["message-box",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._message-box))",[0,[2,"message-box"]],["racket/gui/base","racket/gui"]],
["message-box/custom",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._message-box/custom))",[0,[2,"message-box/custom"]],["racket/gui/base","racket/gui"]],
["message-condition?",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_410",[0,[2,"message-condition?"]],["rnrs/conditions-6"]],
["message-entity",">net/mime.html#(def._((lib._net/mime..rkt)._message-entity))",[0,[2,"message-entity"]],["net/mime"]],
["message-fields",">net/mime.html#(def._((lib._net/mime..rkt)._message-fields))",[0,[2,"message-fields"]],["net/mime"]],
["message-router",">reference/distributed-places.html#(def._((lib._racket/place/distributed..rkt)._message-router))",[0,[2,"message-router"]],["racket/place/distributed"]],
["message-version",">net/mime.html#(def._((lib._net/mime..rkt)._message-version))",[0,[2,"message-version"]],["net/mime"]],
["message?",">net/mime.html#(def._((lib._net/mime..rkt)._message~3f))",[0,[2,"message?"]],["net/mime"]],
["messages",">teachpack/2htdpuniverse.html#(part._.Messages)","Messages",false],
["messages",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._messages))",[0,[2,"messages"]],["web-server/configuration/configuration-table-structs"]],
["messages",">web-server-internal/Web_Servers.html#(idx._(gentag._9._(lib._web-server/scribblings/web-server-internal..scrbl)))","messages",false],
["messages-authentication",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._messages-authentication))",[0,[2,"messages-authentication"]],["web-server/configuration/configuration-table-structs"]],
["messages-collect-garbage",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._messages-collect-garbage))",[0,[2,"messages-collect-garbage"]],["web-server/configuration/configuration-table-structs"]],
["messages-file-not-found",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._messages-file-not-found))",[0,[2,"messages-file-not-found"]],["web-server/configuration/configuration-table-structs"]],
["messages-passwords-refreshed",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._messages-passwords-refreshed))",[0,[2,"messages-passwords-refreshed"]],["web-server/configuration/configuration-table-structs"]],
["messages-protocol",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._messages-protocol))",[0,[2,"messages-protocol"]],["web-server/configuration/configuration-table-structs"]],
["messages-servlet",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._messages-servlet))",[0,[2,"messages-servlet"]],["web-server/configuration/configuration-table-structs"]],
["messages-servlets-refreshed",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._messages-servlets-refreshed))",[0,[2,"messages-servlets-refreshed"]],["web-server/configuration/configuration-table-structs"]],
["messages?",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._messages~3f))",[0,[2,"messages?"]],["web-server/configuration/configuration-table-structs"]],
["meta",">html/index.html#(def._((lib._html/main..rkt)._meta))",[0,[2,"meta"]],["html"]],
["meta",">framework/Keymap.html#(idx._(gentag._4._(lib._scribblings/framework/framework..scrbl)))","Meta",false],
["meta repl commands",">xrepl/index.html#(part._.Meta_.R.E.P.L_.Commands)","Meta REPL Commands",false],
["meta-color",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._meta-color))",[0,[2,"meta-color"]],["scribble/racket","scribble/scheme"]],
["meta-compile phase level",">guide/stx-phases.html#(tech._meta._compile._phase._level)","<span style=\"font-style: italic\">meta-compile phase level</span>",false],
["meta?",">html/index.html#(def._((lib._html/main..rkt)._meta~3f))",[0,[2,"meta?"]],["html"]],
["metacharacters",">guide/regexp-intro.html#(tech._metacharacter)","<span style=\"font-style: italic\">metacharacters</span>",false],
["metadata->settings",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3alanguage~3c~25~3e)._metadata-~3esettings))",[[0,[2,"metadata->settings"]],[14,[" (method of ",[0,[2,"drracket:language:language<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["metafunction->pict",">redex/The_Redex_Reference.html#(form._((lib._redex/pict..rkt)._metafunction-~3epict))",[0,[1,"metafunction->pict"]],["redex/pict","redex"]],
["metafunction-cases",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._metafunction-cases))",[0,[2,"metafunction-cases"]],["redex/pict","redex"]],
["metafunction-font-size",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._metafunction-font-size))",[0,[2,"metafunction-font-size"]],["redex/pict","redex"]],
["metafunction-pict-style",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._metafunction-pict-style))",[0,[2,"metafunction-pict-style"]],["redex/pict","redex"]],
["metafunction-style",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._metafunction-style))",[0,[2,"metafunction-style"]],["redex/pict","redex"]],
["metafunctions->pict",">redex/The_Redex_Reference.html#(form._((lib._redex/pict..rkt)._metafunctions-~3epict))",[0,[1,"metafunctions->pict"]],["redex/pict","redex"]],
["metal-icon-color",">images/Icons.html#(def._((lib._images/icons/style..rkt)._metal-icon-color))",[0,[2,"metal-icon-color"]],["images/icons/style"]],
["metal-icon-material",">images/Icons.html#(def._((lib._images/icons/style..rkt)._metal-icon-material))",[0,[2,"metal-icon-material"]],["images/icons/style"]],
["metaprogramming",">planet/Developing_Packages_for_PLaneT.html#(idx._(gentag._13._(lib._planet/planet..scrbl)))",[7,"'metaprogramming"],false],
["metasequences",">guide/regexp-intro.html#(tech._metasequence)","<span style=\"font-style: italic\">metasequences</span>",false],
["method",">scribble/doc-classes.html#(form._((lib._scribble/manual..rkt)._method))",[0,[1,"method"]],["scribble/manual"]],
["method definitions",">reference/createclass.html#(part._clmethoddefs)","Method Definitions",false],
["method-arity-error",">reference/procedures.html#(idx._(gentag._159._(lib._scribblings/reference/reference..scrbl)))",[7,"'method-arity-error"],false],
["method-arity-error",">reference/lambda.html#(idx._(gentag._88._(lib._scribblings/reference/reference..scrbl)))",[7,"'method-arity-error"],false],
["method-in-interface?",">reference/objectutils.html#(def._((lib._racket/private/class-internal..rkt)._method-in-interface~3f))",[0,[2,"method-in-interface?"]],["racket/class","racket"]],
["method-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..rkt)._method-index-desc))",[0,[2,"method-index-desc"]],["scribble/manual-struct"]],
["method-index-desc-class-tag",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..rkt)._method-index-desc-class-tag))",[0,[2,"method-index-desc-class-tag"]],["scribble/manual-struct"]],
["method-index-desc-method-name",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..rkt)._method-index-desc-method-name))",[0,[2,"method-index-desc-method-name"]],["scribble/manual-struct"]],
["method-index-desc?",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..rkt)._method-index-desc~3f))",[0,[2,"method-index-desc?"]],["scribble/manual-struct"]],
["methods",">mzcom/index.html#(part._.Methods)","Methods",false],
["methods",">guide/classes.html#(part._methods)","Methods",false],
["methods",">reference/createclass.html#(part._clmethods)","Methods",false],
["methods",">reference/ivaraccess.html#(part._methodcalls)","Methods",false],
["mfor-each",">reference/mpairs.html#(def._((lib._racket/mpair..rkt)._mfor-each))",[0,[2,"mfor-each"]],["racket/mpair"]],
["middle-mouse-click?",">graphics/Mouse_Operations.html#(def._((lib._graphics/graphics..rkt)._middle-mouse-click~3f))",[0,[2,"middle-mouse-click?"]],["graphics/graphics"]],
["milliseconds",">frtime/index.html#(def._((lib._frtime/main..rkt)._milliseconds))",[0,[2,"milliseconds"]],["frtime"]],
["mime signature",">net/mime.html#(part._.M.I.M.E_.Signature)","MIME Signature",false],
["mime types",">web-server-internal/mime-types.html","MIME Types",false],
["mime unit",">net/mime.html#(part._.M.I.M.E_.Unit)","MIME Unit",false],
["mime-analyze",">net/mime.html#(def._((lib._net/mime..rkt)._mime-analyze))",[0,[2,"mime-analyze"]],["net/mime"]],
["mime-error",">net/mime.html#(def._((lib._net/mime..rkt)._mime-error))",[0,[2,"mime-error"]],["net/mime"]],
["mime-error?",">net/mime.html#(def._((lib._net/mime..rkt)._mime-error~3f))",[0,[2,"mime-error?"]],["net/mime"]],
["mime-types",">web-server-internal/Web_Servers.html#(idx._(gentag._29._(lib._web-server/scribblings/web-server-internal..scrbl)))","mime-types",false],
["mime: decoding internet data",">net/mime.html","MIME: Decoding Internet Data",false],
["mime@",">net/mime.html#(def._((lib._net/mime-unit..rkt)._mime~40))",[0,[2,"mime@"]],["net/mime-unit"]],
["mime^",">net/mime.html#(form._((lib._net/mime-sig..rkt)._mime~5e))",[0,[1,"mime^"]],["net/mime-sig"]],
["min",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._min))",[0,[2,"min"]],["racket/base","racket"]],
["min",">r5rs-std/r5rs-Z-H-9.html#%_idx_280",[0,[2,"min"]],["r5rs"]],
["min",">r6rs-std/r6rs-Z-H-14.html#node_idx_492",[0,[2,"min"]],["rnrs/base-6"]],
["min",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._min))",[0,[2,"min"]],["lang/htdp-advanced"]],
["min",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._min))",[0,[2,"min"]],["lang/htdp-beginner"]],
["min",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._min))",[0,[2,"min"]],["lang/htdp-beginner-abbr"]],
["min",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._min))",[0,[2,"min"]],["lang/htdp-intermediate"]],
["min",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._min))",[0,[2,"min"]],["lang/htdp-intermediate-lambda"]],
["min",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._min))",[0,[2,"min"]],["deinprogramm/DMdA-advanced"]],
["min",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._min))",[0,[2,"min"]],["deinprogramm/DMdA-assignments"]],
["min",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._min))",[0,[2,"min"]],["deinprogramm/DMdA-beginner"]],
["min",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._min))",[0,[2,"min"]],["deinprogramm/DMdA-vanilla"]],
["min-client-height",">gui/canvas___.html#(meth._(((lib._mred/main..rkt)._canvas~3c~25~3e)._min-client-height))",[[0,[2,"min-client-height"]],[14,[" (method of ",[0,[2,"canvas<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["min-client-width",">gui/canvas___.html#(meth._(((lib._mred/main..rkt)._canvas~3c~25~3e)._min-client-width))",[[0,[2,"min-client-width"]],[14,[" (method of ",[0,[2,"canvas<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["min-ec",">srfi-std/srfi-42.html#min-ec",[0,[1,"min-ec"]],["srfi/42"]],
["min-height",">gui/area___.html#(meth._(((lib._mred/main..rkt)._area~3c~25~3e)._min-height))",[[0,[2,"min-height"]],[14,[" (method of ",[0,[2,"area<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["min-height",">gui/area___.html#(idx._(gentag._14._(lib._scribblings/gui/gui..scrbl)))",[0,"min-height"],false],
["min-width",">gui/area___.html#(meth._(((lib._mred/main..rkt)._area~3c~25~3e)._min-width))",[[0,[2,"min-width"]],[14,[" (method of ",[0,[2,"area<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["min-width",">gui/area___.html#(idx._(gentag._13._(lib._scribblings/gui/gui..scrbl)))",[0,"min-width"],false],
["minesweeper --- logic game",">games/mines.html",[[15,"<img src=\"mines.png\" alt=\"\" />"]," ","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Minesweeper</span>"," ","&#8212;","<wbr></wbr>"," Logic Game"],false],
["mini-slide",">unstable/Slideshow_Presentations.html#(def._((lib._unstable/gui/slideshow..rkt)._mini-slide))",[0,[2,"mini-slide"]],["unstable/gui/slideshow"]],
["minimizes",">gui/frame_.html#(idx._(gentag._36._(lib._scribblings/gui/gui..scrbl)))","minimizes",false],
["minimum",">htdp-langs/beginner-abbr.html#(idx._htdp-beginner-abbr._(gentag._24._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-beginner-abbr))","minimum",false],
["minimum",">htdp-langs/intermediate.html#(idx._htdp-intermediate._(gentag._33._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-intermediate))","minimum",false],
["minimum",">htdp-langs/intermediate-lam.html#(idx._htdp-intermediate-lambda._(gentag._42._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-intermediate-lambda))","minimum",false],
["minimum",">htdp-langs/advanced.html#(idx._htdp-advanced._(gentag._51._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-advanced))","minimum",false],
["minimum",">htdp-langs/beginner.html#(idx._htdp-beginner._(gentag._9._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-beginner))","minimum",false],
["minor modes",">guide/Emacs.html#(part._.Minor_.Modes)","Minor Modes",false],
["minor ticks",">plot/ticks_and_transforms.html#(tech._minor._tick)","<span style=\"font-style: italic\">minor ticks</span>",false],
["misc",">htdp-langs/advanced.html#(part._htdp-advanced._.Misc)","Misc",false],
["misc",">htdp-langs/beginner.html#(part._htdp-beginner._.Misc)","Misc",false],
["misc",">htdp-langs/beginner-abbr.html#(part._htdp-beginner-abbr._.Misc)","Misc",false],
["misc",">htdp-langs/intermediate.html#(part._htdp-intermediate._.Misc)","Misc",false],
["misc",">htdp-langs/intermediate-lam.html#(part._htdp-intermediate-lambda._.Misc)","Misc",false],
["misc",">planet/Developing_Packages_for_PLaneT.html#(idx._(gentag._15._(lib._planet/planet..scrbl)))",[7,"'misc"],false],
["misc/c",">xml/index.html#(def._((lib._xml/main..rkt)._misc/c))",[0,[2,"misc/c"]],["xml"]],
["miscellaneous",">gui/Windowing_Functions.html#(part._.Miscellaneous)","Miscellaneous",false],
["miscellaneous",">reference/Sandboxed_Evaluation.html#(part._.Miscellaneous)","Miscellaneous",false],
["miscellaneous",">scribble/Miscellaneous.html","Miscellaneous",false],
["miscellaneous",">slideshow/Miscellaneous.html","Miscellaneous",false],
["miscellaneous commands",">xrepl/index.html#(part._.Miscellaneous_.Commands)","Miscellaneous Commands",false],
["miscellaneous functions",">plot/compat.html#(part._.Miscellaneous_.Functions)","Miscellaneous Functions",false],
["miscellaneous icons",">images/Icons.html#(part._misc)","Miscellaneous Icons",false],
["miscellaneous image manipulation and creation",">teachpack/image.html#(part._pixel-lists)","Miscellaneous Image Manipulation and Creation",false],
["miscellaneous operations",">graphics/Miscellaneous_Operations.html","Miscellaneous Operations",false],
["miscellaneous slide utilities",">unstable/Slideshow_Presentations.html#(part._.Miscellaneous_.Slide_.Utilities)","Miscellaneous Slide Utilities",false],
["miscellaneous support",">foreign/Miscellaneous_Support.html","Miscellaneous Support",false],
["miscellaneous utilities",">rackunit/api.html#(part._.Miscellaneous_.Utilities)","Miscellaneous Utilities",false],
["miscellaneous utilities",">inside/Miscellaneous_Utilities.html","Miscellaneous Utilities",false],
["miscellaneous utilities",">web-server-internal/misc-util.html","Miscellaneous Utilities",false],
["miscellaneous utilities",">reference/syntax-util.html#(part._.Miscellaneous_utilities)","Miscellaneous utilities",false],
["missing-multipart-boundary-parameter",">net/mime.html#(def._((lib._net/mime..rkt)._missing-multipart-boundary-parameter))",[0,[2,"missing-multipart-boundary-parameter"]],["net/mime"]],
["missing-multipart-boundary-parameter?",">net/mime.html#(def._((lib._net/mime..rkt)._missing-multipart-boundary-parameter~3f))",[0,[2,"missing-multipart-boundary-parameter?"]],["net/mime"]],
["mix",">plot/porting.html#(def._((lib._plot/main..rkt)._mix))",[0,[2,"mix"]],["plot"]],
["mix",">plot/compat.html#(def._((lib._plot/compat..rkt)._mix))",[0,[2,"mix"]],["plot/compat"]],
["mixed",">deinprogramm/Signaturen.html#(part._mixed)",[0,[1,"mixed"]],false],
["mixed",">deinprogramm/Signaturen.html#(form._((lib._deinprogramm/.D.Md.A..rkt)._mixed))",[0,[1,"mixed"]],["deinprogramm/DMdA-beginner"]],
["mixin",">reference/mixins.html#(form._((lib._racket/private/class-internal..rkt)._mixin))",[0,[1,"mixin"]],["racket/class","racket"]],
["mixin",">guide/classes.html#(tech._mixin)","<span style=\"font-style: italic\">mixin</span>",false],
["mixin",">reference/mixins.html#(tech._mixin)","<span style=\"font-style: italic\">mixin</span>",false],
["mixin-contract",">reference/Object_and_Class_Contracts.html#(def._((lib._racket/class..rkt)._mixin-contract))",[0,[2,"mixin-contract"]],["racket/class","racket"]],
["mixin-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..rkt)._mixin-index-desc))",[0,[2,"mixin-index-desc"]],["scribble/manual-struct"]],
["mixin-index-desc?",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..rkt)._mixin-index-desc~3f))",[0,[2,"mixin-index-desc?"]],["scribble/manual-struct"]],
["mixing patterns and expressions: syntax-case",">guide/syntax-case.html",["Mixing Patterns and Expressions: ",[0,[1,"syntax-case"]]],false],
["mixing set! and contract-out",">guide/contracts-gotchas.html#(part._.Mixing_set__and_contract-out)",["Mixing ",[0,[1,"set!"]]," and ",[0,[1,"contract-out"]]],false],
["mixins",">guide/classes.html#(part._.Mixins)","Mixins",false],
["mixins",">reference/mixins.html","Mixins",false],
["mixins and interfaces",">guide/classes.html#(part._.Mixins_and_.Interfaces)","Mixins and Interfaces",false],
["mlength",">reference/mpairs.html#(def._((lib._racket/mpair..rkt)._mlength))",[0,[2,"mlength"]],["racket/mpair"]],
["mlist",">reference/mpairs.html#(def._((lib._racket/mpair..rkt)._mlist))",[0,[2,"mlist"]],["racket/mpair"]],
["mlist->list",">reference/mpairs.html#(def._((lib._racket/mpair..rkt)._mlist-~3elist))",[0,[2,"mlist->list"]],["racket/mpair"]],
["mlist-ref",">reference/mpairs.html#(def._((lib._racket/mpair..rkt)._mlist-ref))",[0,[2,"mlist-ref"]],["racket/mpair"]],
["mlist-tail",">reference/mpairs.html#(def._((lib._racket/mpair..rkt)._mlist-tail))",[0,[2,"mlist-tail"]],["racket/mpair"]],
["mlist?",">reference/mpairs.html#(def._((lib._racket/mpair..rkt)._mlist~3f))",[0,[2,"mlist?"]],["racket/mpair"]],
["mlistof",">reference/mpairs.html#(def._((lib._racket/mpair..rkt)._mlistof))",[0,[2,"mlistof"]],["racket/mpair"]],
["mlistof",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.M.Listof))",[0,[1,"MListof"]],["typed/racket/base","typed/racket"]],
["mmap",">reference/mpairs.html#(def._((lib._racket/mpair..rkt)._mmap))",[0,[2,"mmap"]],["racket/mpair"]],
["mmember",">reference/mpairs.html#(def._((lib._racket/mpair..rkt)._mmember))",[0,[2,"mmember"]],["racket/mpair"]],
["mmemq",">reference/mpairs.html#(def._((lib._racket/mpair..rkt)._mmemq))",[0,[2,"mmemq"]],["racket/mpair"]],
["mmemv",">reference/mpairs.html#(def._((lib._racket/mpair..rkt)._mmemv))",[0,[2,"mmemv"]],["racket/mpair"]],
["mn",">reference/characters.html#(idx._(gentag._128._(lib._scribblings/reference/reference..scrbl)))",[7,"'mn"],false],
["mod",">r6rs-std/r6rs-Z-H-14.html#node_idx_512",[0,[2,"mod"]],["rnrs/base-6"]],
["mod",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._mod))",[0,[2,"mod"]],["compiler/zo-structs"]],
["mod-body",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._mod-body))",[0,[2,"mod-body"]],["compiler/zo-structs"]],
["mod-dummy",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._mod-dummy))",[0,[2,"mod-dummy"]],["compiler/zo-structs"]],
["mod-internal-context",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._mod-internal-context))",[0,[2,"mod-internal-context"]],["compiler/zo-structs"]],
["mod-lang-info",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._mod-lang-info))",[0,[2,"mod-lang-info"]],["compiler/zo-structs"]],
["mod-max-let-depth",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._mod-max-let-depth))",[0,[2,"mod-max-let-depth"]],["compiler/zo-structs"]],
["mod-name",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._mod-name))",[0,[2,"mod-name"]],["compiler/zo-structs"]],
["mod-post-submodules",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._mod-post-submodules))",[0,[2,"mod-post-submodules"]],["compiler/zo-structs"]],
["mod-pre-submodules",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._mod-pre-submodules))",[0,[2,"mod-pre-submodules"]],["compiler/zo-structs"]],
["mod-prefix",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._mod-prefix))",[0,[2,"mod-prefix"]],["compiler/zo-structs"]],
["mod-provides",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._mod-provides))",[0,[2,"mod-provides"]],["compiler/zo-structs"]],
["mod-requires",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._mod-requires))",[0,[2,"mod-requires"]],["compiler/zo-structs"]],
["mod-self-modidx",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._mod-self-modidx))",[0,[2,"mod-self-modidx"]],["compiler/zo-structs"]],
["mod-srcname",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._mod-srcname))",[0,[2,"mod-srcname"]],["compiler/zo-structs"]],
["mod-syntax-bodies",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._mod-syntax-bodies))",[0,[2,"mod-syntax-bodies"]],["compiler/zo-structs"]],
["mod-unexported",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._mod-unexported))",[0,[2,"mod-unexported"]],["compiler/zo-structs"]],
["mod0",">r6rs-std/r6rs-Z-H-14.html#node_idx_518",[0,[2,"mod0"]],["rnrs/base-6"]],
["mod?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._mod~3f))",[0,[2,"mod?"]],["compiler/zo-structs"]],
["moddep-current-open-input-file",">syntax/module-helpers.html#(def._((lib._syntax/modcode..rkt)._moddep-current-open-input-file))",[0,[2,"moddep-current-open-input-file"]],["syntax/modcode"]],
["mode",">framework/Mode.html","Mode",false],
["mode",">deinprogramm/image.html#(def._((lib._deinprogramm/image..rkt)._mode))",[0,[2,"mode"]],["teachpack/deinprogramm/image"]],
["mode",">teachpack/image.html#(tech._mode)","<span style=\"font-style: italic\">Mode</span>",false],
["mode keywords",">mzlib/mzlib_kw.html#(part._mode-keywords)","Mode Keywords",false],
["mode:host-text-mixin",">framework/Mode.html#(def._((lib._framework/main..rkt)._mode~3ahost-text-mixin))",[0,[2,"mode:host-text-mixin"]],["framework"]],
["mode:host-text<%>",">framework/Mode.html#(def._((lib._framework/main..rkt)._mode~3ahost-text~3c~25~3e))",[0,[2,"mode:host-text<%>"]],["framework"]],
["mode:surrogate-text%",">framework/Mode.html#(def._((lib._framework/main..rkt)._mode~3asurrogate-text~25))",[0,[2,"mode:surrogate-text%"]],["framework"]],
["mode:surrogate-text<%>",">framework/Mode.html#(def._((lib._framework/main..rkt)._mode~3asurrogate-text~3c~25~3e))",[0,[2,"mode:surrogate-text<%>"]],["framework"]],
["mode?",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._mode~3f))",[0,[2,"mode?"]],["2htdp/image"]],
["modelt",">teachpack/arrow-gui.html#(tech._modelt)","<span style=\"font-style: italic\">modelT</span>",false],
["modern",">gui/style-delta_.html#(idx._(gentag._200._(lib._scribblings/gui/gui..scrbl)))",[7,"'modern"],false],
["modern",">draw/font_.html#(idx._(gentag._33._(lib._scribblings/draw/draw..scrbl)))",[7,"'modern"],false],
["modes",">tools/Editor_Modes.html#(idx._(gentag._26._(lib._scribblings/tools/tools..scrbl)))","modes",false],
["modes and colors",">teachpack/image.html#(part._modes-colors)","Modes and Colors",false],
["modi und farben",">deinprogramm/image.html#(part._modes-colors)","Modi und Farben",false],
["modified",">gui/editor-admin_.html#(meth._(((lib._mred/main..rkt)._editor-admin~25)._modified))",[[0,[2,"modified"]],[14,[" (method of ",[0,[2,"editor-admin%"]],")"]]],["racket/gui/base","racket/gui"]],
["modified",">gui/frame_.html#(meth._(((lib._mred/main..rkt)._frame~25)._modified))",[[0,[2,"modified"]],[14,[" (method of ",[0,[2,"frame%"]],")"]]],["racket/gui/base","racket/gui"]],
["modified",">gui/snip-admin_.html#(meth._(((lib._racket/snip..rkt)._snip-admin~25)._modified))",[[0,[2,"modified"]],[14,[" (method of ",[0,[2,"snip-admin%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["modified-julian-day->date",">srfi-std/srfi-19.html#modified-julian-day->date",[0,[2,"modified-julian-day->date"]],["srfi/19"]],
["modified-julian-day->time-monotonic",">srfi-std/srfi-19.html#modified-julian-day->time-monotonic",[0,[2,"modified-julian-day->time-monotonic"]],["srfi/19"]],
["modified-julian-day->time-tai",">srfi-std/srfi-19.html#modified-julian-day->time-tai",[0,[2,"modified-julian-day->time-tai"]],["srfi/19"]],
["modified-julian-day->time-utc",">srfi-std/srfi-19.html#modified-julian-day->time-utc",[0,[2,"modified-julian-day->time-utc"]],["srfi/19"]],
["module",">reference/module.html#(form._((quote._~23~25kernel)._module))",[0,[1,"module"]],["racket/base","racket"]],
["module",">inside/im_env.html#(idx._(gentag._273._(lib._scribblings/inside/inside..scrbl)))","module",false],
["module basics",">guide/module-basics.html","Module Basics",false],
["module binding",">reference/syntax-model.html#(tech._module._binding)","<span style=\"font-style: italic\">module binding</span>",false],
["module browser on file menu item",">drracket/Menus.html#(idx._(gentag._129._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Module Browser on <span style=\"font-style: italic\">file</span></span> menu item",false],
["module browser... menu item",">drracket/Menus.html#(idx._(gentag._128._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Module Browser...</span> menu item",false],
["module context",">reference/syntax-model.html#(tech._module._context)","<span style=\"font-style: italic\">module context</span>",false],
["module language",">guide/module-languages.html#(tech._module._language)","<span style=\"font-style: italic\">module language</span>",false],
["module languages",">guide/module-languages.html","Module Languages",false],
["module lexer",">syntax-color/index.html#(part._.Module_.Lexer)","Module Lexer",false],
["module mode",">guide/racket.html#(part._start-module-mode)","Module Mode",false],
["module name resolver",">reference/Module_Names_and_Loading.html#(tech._module._name._resolver)","<span style=\"font-style: italic\">module name\nresolver</span>",false],
["module names and loading",">reference/Module_Names_and_Loading.html","Module Names and Loading",false],
["module path",">guide/module-paths.html#(tech._module._path)","<span style=\"font-style: italic\">module path</span>",false],
["module path",">reference/Module_Names_and_Loading.html#(tech._module._path)","<span style=\"font-style: italic\">module path</span>",false],
["module path index",">reference/Module_Names_and_Loading.html#(tech._module._path._index)","<span style=\"font-style: italic\">module path index</span>",false],
["module path resolver",">reference/Module_Names_and_Loading.html#(tech._module._path._resolver)","<span style=\"font-style: italic\">module path resolver</span>",false],
["module paths",">guide/module-paths.html","Module Paths",false],
["module phases and visits",">reference/syntax-model.html#(part._mod-parse)","Module Phases and Visits",false],
["module re-declarations",">reference/eval-model.html#(part._module-redeclare)","Module Re-declarations",false],
["module reader",">syntax/reader-helpers.html#(part._module-reader)","Module Reader",false],
["module registry",">reference/syntax-model.html#(tech._module._registry)","<span style=\"font-style: italic\">module registry</span>",false],
["module syntax",">guide/Module_Syntax.html","Module Syntax",false],
["module*",">reference/module.html#(form._((quote._~23~25kernel)._module*))",[0,[1,"module*"]],["racket/base","racket"]],
["module+",">reference/module.html#(form._((lib._racket/private/base..rkt)._module+))",[0,[1,"module+"]],["racket/base","racket"]],
["module->exports",">reference/Module_Names_and_Loading.html#(def._((quote._~23~25kernel)._module-~3eexports))",[0,[2,"module->exports"]],["racket/base","racket"]],
["module->imports",">reference/Module_Names_and_Loading.html#(def._((quote._~23~25kernel)._module-~3eimports))",[0,[2,"module->imports"]],["racket/base","racket"]],
["module->language-info",">reference/Module_Names_and_Loading.html#(def._((quote._~23~25kernel)._module-~3elanguage-info))",[0,[2,"module->language-info"]],["racket/base","racket"]],
["module->namespace",">reference/Namespaces.html#(def._((quote._~23~25kernel)._module-~3enamespace))",[0,[2,"module->namespace"]],["racket/base","racket"]],
["module-begin context",">reference/syntax-model.html#(tech._module._begin._context)","<span style=\"font-style: italic\">module-begin context</span>",false],
["module-binding",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._module-binding))",[0,[2,"module-binding"]],["compiler/zo-structs"]],
["module-binding?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._module-binding~3f))",[0,[2,"module-binding?"]],["compiler/zo-structs"]],
["module-color",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._module-color))",[0,[2,"module-color"]],["scribble/racket","scribble/scheme"]],
["module-compiled-exports",">reference/Module_Names_and_Loading.html#(def._((quote._~23~25kernel)._module-compiled-exports))",[0,[2,"module-compiled-exports"]],["racket/base","racket"]],
["module-compiled-imports",">reference/Module_Names_and_Loading.html#(def._((quote._~23~25kernel)._module-compiled-imports))",[0,[2,"module-compiled-imports"]],["racket/base","racket"]],
["module-compiled-language-info",">reference/Module_Names_and_Loading.html#(def._((quote._~23~25kernel)._module-compiled-language-info))",[0,[2,"module-compiled-language-info"]],["racket/base","racket"]],
["module-compiled-name",">reference/Module_Names_and_Loading.html#(def._((quote._~23~25kernel)._module-compiled-name))",[0,[2,"module-compiled-name"]],["racket/base","racket"]],
["module-compiled-submodules",">reference/Module_Names_and_Loading.html#(def._((quote._~23~25kernel)._module-compiled-submodules))",[0,[2,"module-compiled-submodules"]],["racket/base","racket"]],
["module-declared?",">reference/Module_Names_and_Loading.html#(def._((quote._~23~25kernel)._module-declared~3f))",[0,[2,"module-declared?"]],["racket/base","racket"]],
["module-direct-for-syntax-requires",">reference/Expanding_Top-Level_Forms.html#(idx._(gentag._189._(lib._scribblings/reference/reference..scrbl)))",[7,"'module-direct-for-syntax-requires"],false],
["module-direct-for-template-requires",">reference/Expanding_Top-Level_Forms.html#(idx._(gentag._190._(lib._scribblings/reference/reference..scrbl)))",[7,"'module-direct-for-template-requires"],false],
["module-direct-requires",">reference/Expanding_Top-Level_Forms.html#(idx._(gentag._188._(lib._scribblings/reference/reference..scrbl)))",[7,"'module-direct-requires"],false],
["module-handling configuration",">guide/module-runtime-config.html","Module-Handling Configuration",false],
["module-identifier-mapping-for-each",">syntax/syntax-helpers.html#(def._((lib._syntax/boundmap..rkt)._module-identifier-mapping-for-each))",[0,[2,"module-identifier-mapping-for-each"]],["syntax/boundmap"]],
["module-identifier-mapping-get",">syntax/syntax-helpers.html#(def._((lib._syntax/boundmap..rkt)._module-identifier-mapping-get))",[0,[2,"module-identifier-mapping-get"]],["syntax/boundmap"]],
["module-identifier-mapping-map",">syntax/syntax-helpers.html#(def._((lib._syntax/boundmap..rkt)._module-identifier-mapping-map))",[0,[2,"module-identifier-mapping-map"]],["syntax/boundmap"]],
["module-identifier-mapping-put!",">syntax/syntax-helpers.html#(def._((lib._syntax/boundmap..rkt)._module-identifier-mapping-put!))",[0,[2,"module-identifier-mapping-put!"]],["syntax/boundmap"]],
["module-identifier-mapping?",">syntax/syntax-helpers.html#(def._((lib._syntax/boundmap..rkt)._module-identifier-mapping~3f))",[0,[2,"module-identifier-mapping?"]],["syntax/boundmap"]],
["module-identifier=?",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..rkt)._module-identifier~3d~3f))",[0,[2,"module-identifier=?"]],["mzscheme"]],
["module-indirect-provides",">reference/Expanding_Top-Level_Forms.html#(idx._(gentag._193._(lib._scribblings/reference/reference..scrbl)))",[7,"'module-indirect-provides"],false],
["module-label-identifier=?",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..rkt)._module-label-identifier~3d~3f))",[0,[2,"module-label-identifier=?"]],["mzscheme"]],
["module-language",">reference/Module_Names_and_Loading.html#(idx._(gentag._226._(lib._scribblings/reference/reference..scrbl)))",[7,"'module-language"],false],
["module-language",">reference/module.html#(idx._(gentag._82._(lib._scribblings/reference/reference..scrbl)))",[7,"'module-language"],false],
["module-level variable",">reference/eval-model.html#(tech._module._level._variable)","<span style=\"font-style: italic\">module-level\nvariable</span>",false],
["module-lexer",">syntax-color/index.html#(def._((lib._syntax-color/module-lexer..rkt)._module-lexer))",[0,[2,"module-lexer"]],["syntax-color/module-lexer"]],
["module-link-color",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._module-link-color))",[0,[2,"module-link-color"]],["scribble/racket","scribble/scheme"]],
["module-or-top-identifier=?",">syntax/syntax-helpers.html#(def._((lib._syntax/stx..rkt)._module-or-top-identifier~3d~3f))",[0,[2,"module-or-top-identifier=?"]],["syntax/stx"]],
["module-path",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Module-.Path))",[0,[1,"Module-Path"]],["typed/racket/base","typed/racket"]],
["module-path-index",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Module-.Path-.Index))",[0,[1,"Module-Path-Index"]],["typed/racket/base","typed/racket"]],
["module-path-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..rkt)._module-path-index-desc))",[0,[2,"module-path-index-desc"]],["scribble/manual-struct"]],
["module-path-index-desc?",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..rkt)._module-path-index-desc~3f))",[0,[2,"module-path-index-desc?"]],["scribble/manual-struct"]],
["module-path-index-join",">reference/Module_Names_and_Loading.html#(def._((quote._~23~25kernel)._module-path-index-join))",[0,[2,"module-path-index-join"]],["racket/base","racket"]],
["module-path-index-resolve",">reference/Module_Names_and_Loading.html#(def._((quote._~23~25kernel)._module-path-index-resolve))",[0,[2,"module-path-index-resolve"]],["racket/base","racket"]],
["module-path-index-split",">reference/Module_Names_and_Loading.html#(def._((quote._~23~25kernel)._module-path-index-split))",[0,[2,"module-path-index-split"]],["racket/base","racket"]],
["module-path-index-submodule",">reference/Module_Names_and_Loading.html#(def._((quote._~23~25kernel)._module-path-index-submodule))",[0,[2,"module-path-index-submodule"]],["racket/base","racket"]],
["module-path-index?",">reference/Module_Names_and_Loading.html#(def._((quote._~23~25kernel)._module-path-index~3f))",[0,[2,"module-path-index?"]],["racket/base","racket"]],
["module-path-prefix->string",">scribble/base.html#(def._((lib._scribble/base..rkt)._module-path-prefix-~3estring))",[0,[2,"module-path-prefix->string"]],["scribble/base"]],
["module-path?",">reference/Module_Names_and_Loading.html#(def._((quote._~23~25kernel)._module-path~3f))",[0,[2,"module-path?"]],["racket/base","racket"]],
["module-predefined?",">reference/Module_Names_and_Loading.html#(def._((quote._~23~25kernel)._module-predefined~3f))",[0,[2,"module-predefined?"]],["racket/base","racket"]],
["module-processing helpers",">syntax/module-helpers.html","Module-Processing Helpers",false],
["module-provide-protected?",">reference/Namespaces.html#(def._((quote._~23~25kernel)._module-provide-protected~3f))",[0,[2,"module-provide-protected?"]],["racket/base","racket"]],
["module-rename",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._module-rename))",[0,[2,"module-rename"]],["compiler/zo-structs"]],
["module-rename-kind",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._module-rename-kind))",[0,[2,"module-rename-kind"]],["compiler/zo-structs"]],
["module-rename-mark-renames",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._module-rename-mark-renames))",[0,[2,"module-rename-mark-renames"]],["compiler/zo-structs"]],
["module-rename-phase",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._module-rename-phase))",[0,[2,"module-rename-phase"]],["compiler/zo-structs"]],
["module-rename-plus-kern?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._module-rename-plus-kern~3f))",[0,[2,"module-rename-plus-kern?"]],["compiler/zo-structs"]],
["module-rename-renames",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._module-rename-renames))",[0,[2,"module-rename-renames"]],["compiler/zo-structs"]],
["module-rename-set-id",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._module-rename-set-id))",[0,[2,"module-rename-set-id"]],["compiler/zo-structs"]],
["module-rename-unmarshals",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._module-rename-unmarshals))",[0,[2,"module-rename-unmarshals"]],["compiler/zo-structs"]],
["module-rename?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._module-rename~3f))",[0,[2,"module-rename?"]],["compiler/zo-structs"]],
["module-syntax-provides",">reference/Expanding_Top-Level_Forms.html#(idx._(gentag._192._(lib._scribblings/reference/reference..scrbl)))",[7,"'module-syntax-provides"],false],
["module-template-identifier=?",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..rkt)._module-template-identifier~3d~3f))",[0,[2,"module-template-identifier=?"]],["mzscheme"]],
["module-transformer-identifier=?",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..rkt)._module-transformer-identifier~3d~3f))",[0,[2,"module-transformer-identifier=?"]],["mzscheme"]],
["module-variable",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._module-variable))",[0,[2,"module-variable"]],["compiler/zo-structs"]],
["module-variable-modidx",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._module-variable-modidx))",[0,[2,"module-variable-modidx"]],["compiler/zo-structs"]],
["module-variable-phase",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._module-variable-phase))",[0,[2,"module-variable-phase"]],["compiler/zo-structs"]],
["module-variable-pos",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._module-variable-pos))",[0,[2,"module-variable-pos"]],["compiler/zo-structs"]],
["module-variable-provides",">reference/Expanding_Top-Level_Forms.html#(idx._(gentag._191._(lib._scribblings/reference/reference..scrbl)))",[7,"'module-variable-provides"],false],
["module-variable-sym",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._module-variable-sym))",[0,[2,"module-variable-sym"]],["compiler/zo-structs"]],
["module-variable?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._module-variable~3f))",[0,[2,"module-variable?"]],["compiler/zo-structs"]],
["modules re-define",">reference/eval-model.html#(idx._(gentag._0._(lib._scribblings/reference/reference..scrbl)))","modules, re-define",false],
["modules imports",">reference/require.html","modules, imports",false],
["modules exports",">reference/require.html","modules, exports",false],
["modules",">guide/modules.html","Modules",false],
["modules",">quick/index.html#(part._.Modules)","Modules",false],
["modules and module-level variables",">reference/eval-model.html#(part._module-eval-model)","Modules and Module-Level Variables",false],
["modules and performance",">guide/performance.html#(part._modules-performance)","Modules and Performance",false],
["modules: module, module*, ...",">reference/module.html",["Modules: ",[0,[1,"module"]],", ",[0,[1,"module*"]],", ..."],false],
["modulo",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._modulo))",[0,[2,"modulo"]],["racket/base","racket"]],
["modulo",">r5rs-std/r5rs-Z-H-9.html#%_idx_304",[0,[2,"modulo"]],["r5rs"]],
["modulo",">r6rs-lib-std/r6rs-lib-Z-H-20.html#node_idx_1294",[0,[2,"modulo"]],["rnrs/r5rs-6"]],
["modulo",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._modulo))",[0,[2,"modulo"]],["lang/htdp-advanced"]],
["modulo",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._modulo))",[0,[2,"modulo"]],["lang/htdp-beginner"]],
["modulo",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._modulo))",[0,[2,"modulo"]],["lang/htdp-beginner-abbr"]],
["modulo",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._modulo))",[0,[2,"modulo"]],["lang/htdp-intermediate"]],
["modulo",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._modulo))",[0,[2,"modulo"]],["lang/htdp-intermediate-lambda"]],
["modulo",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._modulo))",[0,[2,"modulo"]],["deinprogramm/DMdA-advanced"]],
["modulo",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._modulo))",[0,[2,"modulo"]],["deinprogramm/DMdA-assignments"]],
["modulo",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._modulo))",[0,[2,"modulo"]],["deinprogramm/DMdA-beginner"]],
["modulo",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._modulo))",[0,[2,"modulo"]],["deinprogramm/DMdA-vanilla"]],
["monitor",">unstable/temp-c.html#(def._((lib._unstable/temp-c/monitor..rkt)._monitor))",[0,[2,"monitor"]],["unstable/temp-c/monitor"]],
["monitor-label",">unstable/temp-c.html#(def._((lib._unstable/temp-c/monitor..rkt)._monitor-label))",[0,[2,"monitor-label"]],["unstable/temp-c/monitor"]],
["monitor/c",">unstable/temp-c.html#(def._((lib._unstable/temp-c/monitor..rkt)._monitor/c))",[0,[2,"monitor/c"]],["unstable/temp-c/monitor"]],
["monitor:call",">unstable/temp-c.html#(def._((lib._unstable/temp-c/monitor..rkt)._monitor~3acall))",[0,[2,"monitor:call"]],["unstable/temp-c/monitor"]],
["monitor:call-app-label",">unstable/temp-c.html#(def._((lib._unstable/temp-c/monitor..rkt)._monitor~3acall-app-label))",[0,[2,"monitor:call-app-label"]],["unstable/temp-c/monitor"]],
["monitor:call-args",">unstable/temp-c.html#(def._((lib._unstable/temp-c/monitor..rkt)._monitor~3acall-args))",[0,[2,"monitor:call-args"]],["unstable/temp-c/monitor"]],
["monitor:call-f",">unstable/temp-c.html#(def._((lib._unstable/temp-c/monitor..rkt)._monitor~3acall-f))",[0,[2,"monitor:call-f"]],["unstable/temp-c/monitor"]],
["monitor:call-kw-args",">unstable/temp-c.html#(def._((lib._unstable/temp-c/monitor..rkt)._monitor~3acall-kw-args))",[0,[2,"monitor:call-kw-args"]],["unstable/temp-c/monitor"]],
["monitor:call-kws",">unstable/temp-c.html#(def._((lib._unstable/temp-c/monitor..rkt)._monitor~3acall-kws))",[0,[2,"monitor:call-kws"]],["unstable/temp-c/monitor"]],
["monitor:call-label",">unstable/temp-c.html#(def._((lib._unstable/temp-c/monitor..rkt)._monitor~3acall-label))",[0,[2,"monitor:call-label"]],["unstable/temp-c/monitor"]],
["monitor:call-proj-label",">unstable/temp-c.html#(def._((lib._unstable/temp-c/monitor..rkt)._monitor~3acall-proj-label))",[0,[2,"monitor:call-proj-label"]],["unstable/temp-c/monitor"]],
["monitor:call?",">unstable/temp-c.html#(def._((lib._unstable/temp-c/monitor..rkt)._monitor~3acall~3f))",[0,[2,"monitor:call?"]],["unstable/temp-c/monitor"]],
["monitor:proj",">unstable/temp-c.html#(def._((lib._unstable/temp-c/monitor..rkt)._monitor~3aproj))",[0,[2,"monitor:proj"]],["unstable/temp-c/monitor"]],
["monitor:proj-label",">unstable/temp-c.html#(def._((lib._unstable/temp-c/monitor..rkt)._monitor~3aproj-label))",[0,[2,"monitor:proj-label"]],["unstable/temp-c/monitor"]],
["monitor:proj-proj-label",">unstable/temp-c.html#(def._((lib._unstable/temp-c/monitor..rkt)._monitor~3aproj-proj-label))",[0,[2,"monitor:proj-proj-label"]],["unstable/temp-c/monitor"]],
["monitor:proj-v",">unstable/temp-c.html#(def._((lib._unstable/temp-c/monitor..rkt)._monitor~3aproj-v))",[0,[2,"monitor:proj-v"]],["unstable/temp-c/monitor"]],
["monitor:proj?",">unstable/temp-c.html#(def._((lib._unstable/temp-c/monitor..rkt)._monitor~3aproj~3f))",[0,[2,"monitor:proj?"]],["unstable/temp-c/monitor"]],
["monitor:return",">unstable/temp-c.html#(def._((lib._unstable/temp-c/monitor..rkt)._monitor~3areturn))",[0,[2,"monitor:return"]],["unstable/temp-c/monitor"]],
["monitor:return-app-label",">unstable/temp-c.html#(def._((lib._unstable/temp-c/monitor..rkt)._monitor~3areturn-app-label))",[0,[2,"monitor:return-app-label"]],["unstable/temp-c/monitor"]],
["monitor:return-args",">unstable/temp-c.html#(def._((lib._unstable/temp-c/monitor..rkt)._monitor~3areturn-args))",[0,[2,"monitor:return-args"]],["unstable/temp-c/monitor"]],
["monitor:return-f",">unstable/temp-c.html#(def._((lib._unstable/temp-c/monitor..rkt)._monitor~3areturn-f))",[0,[2,"monitor:return-f"]],["unstable/temp-c/monitor"]],
["monitor:return-kw-args",">unstable/temp-c.html#(def._((lib._unstable/temp-c/monitor..rkt)._monitor~3areturn-kw-args))",[0,[2,"monitor:return-kw-args"]],["unstable/temp-c/monitor"]],
["monitor:return-kws",">unstable/temp-c.html#(def._((lib._unstable/temp-c/monitor..rkt)._monitor~3areturn-kws))",[0,[2,"monitor:return-kws"]],["unstable/temp-c/monitor"]],
["monitor:return-label",">unstable/temp-c.html#(def._((lib._unstable/temp-c/monitor..rkt)._monitor~3areturn-label))",[0,[2,"monitor:return-label"]],["unstable/temp-c/monitor"]],
["monitor:return-proj-label",">unstable/temp-c.html#(def._((lib._unstable/temp-c/monitor..rkt)._monitor~3areturn-proj-label))",[0,[2,"monitor:return-proj-label"]],["unstable/temp-c/monitor"]],
["monitor:return-rets",">unstable/temp-c.html#(def._((lib._unstable/temp-c/monitor..rkt)._monitor~3areturn-rets))",[0,[2,"monitor:return-rets"]],["unstable/temp-c/monitor"]],
["monitor:return?",">unstable/temp-c.html#(def._((lib._unstable/temp-c/monitor..rkt)._monitor~3areturn~3f))",[0,[2,"monitor:return?"]],["unstable/temp-c/monitor"]],
["monitor?",">unstable/temp-c.html#(def._((lib._unstable/temp-c/monitor..rkt)._monitor~3f))",[0,[2,"monitor?"]],["unstable/temp-c/monitor"]],
["monitoring planet's progress",">planet/Using_PLaneT.html#(part._.Monitoring_.P.Lane.T_s_progress)","Monitoring PLaneT&rsquo;s progress",false],
["monitors",">unstable/temp-c.html#(part._monitor)","Monitors",false],
["more examples",">foreign/intro.html#(part._.More_.Examples)","More Examples",false],
["more file and directory utilities",">reference/Filesystem.html#(part._file-lib)","More File and Directory Utilities",false],
["more functions",">scribble/getting-started.html#(part._.More_.Functions)","More Functions",false],
["more keyword arguments",">syntax/More_Keyword_Arguments.html","More Keyword Arguments",false],
["more libraries",">guide/More_Libraries.html","More Libraries",false],
["more path utilities",">reference/More_Path_Utilities.html","More Path Utilities",false],
["more pict constructors",">slideshow/More_Pict_Constructors.html","More Pict Constructors",false],
["more port constructors, procedures, and events",">reference/port-lib.html","More Port Constructors, Procedures, and Events",false],
["more rackets",">guide/more-hash-lang.html","More Rackets",false],
["more structure type options",">guide/define-struct.html#(part._struct-options)","More Structure Type Options",false],
["more: systems programming with racket",">more/index.html","More: Systems Programming with Racket",false],
["most recent window menu item",">drracket/Menus.html#(idx._(gentag._146._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Most Recent Window</span> menu item",false],
["most-recent-slide",">slideshow/Slide_Registration.html#(def._((lib._slideshow/base..rkt)._most-recent-slide))",[0,[2,"most-recent-slide"]],["slideshow/base","slideshow"]],
["motivation",">images/Overview.html#(part._.Motivation)","Motivation",false],
["mouse and keyboard events",">gui/windowing-overview.html#(part._mouseandkey)","Mouse and Keyboard Events",false],
["mouse events overview",">gui/windowing-overview.html#(idx._(gentag._2._(lib._scribblings/gui/gui..scrbl)))","mouse events, overview",false],
["mouse operations",">graphics/Mouse_Operations.html","Mouse Operations",false],
["mouse-click-posn",">graphics/Mouse_Operations.html#(def._((lib._graphics/graphics..rkt)._mouse-click-posn))",[0,[2,"mouse-click-posn"]],["graphics/graphics"]],
["mouse-event%",">gui/mouse-event_.html",[0,[2,"mouse-event%"]],["racket/gui/base","racket/gui"]],
["mouse-event-kind",">deinprogramm/world.html#(def._((lib._deinprogramm/world..rkt)._mouse-event-kind))",[0,[2,"mouse-event-kind"]],["teachpack/deinprogramm/world"]],
["mouse-event?",">teachpack/2htdpuniverse.html#(def._((lib._2htdp/universe..rkt)._mouse-event~3f))",[0,[2,"mouse-event?"]],["2htdp/universe"]],
["mouse=?",">teachpack/2htdpuniverse.html#(def._((lib._2htdp/universe..rkt)._mouse~3d~3f))",[0,[2,"mouse=?"]],["2htdp/universe"]],
["mouseevent",">teachpack/2htdpuniverse.html#(tech._mouseevent)","<span style=\"font-style: italic\">MouseEvent</span>",false],
["mouseevent",">teachpack/world.html#(tech._mouseevent)","<span style=\"font-style: italic\">MouseEvent</span>",false],
["move",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._move))",[[0,[2,"move"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["move",">gui/top-level-window___.html#(meth._(((lib._mred/main..rkt)._top-level-window~3c~25~3e)._move))",[[0,[2,"move"]],[14,[" (method of ",[0,[2,"top-level-window<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["move",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtles..rkt)._move))",[0,[2,"move"]],["graphics/turtles"]],
["move",">turtles/Value_Turtles.html#(def._((lib._graphics/value-turtles..rkt)._move))",[0,[2,"move"]],["graphics/value-turtles"]],
["move",">deinprogramm/turtle.html#(def._((lib._teachpack/deinprogramm/turtle..rkt)._move))",[0,[2,"move"]],["teachpack/deinprogramm/turtle"]],
["move-card",">cards/index.html#(meth._(((lib._games/cards..rkt)._table~3c~25~3e)._move-card))",[[0,[2,"move-card"]],[14,[" (method of ",[0,[2,"table<%>"]],")"]]],["games/cards"]],
["move-cards",">cards/index.html#(meth._(((lib._games/cards..rkt)._table~3c~25~3e)._move-cards))",[[0,[2,"move-cards"]],[14,[" (method of ",[0,[2,"table<%>"]],")"]]],["games/cards"]],
["move-cards-to-region",">cards/index.html#(meth._(((lib._games/cards..rkt)._table~3c~25~3e)._move-cards-to-region))",[[0,[2,"move-cards-to-region"]],[14,[" (method of ",[0,[2,"table<%>"]],")"]]],["games/cards"]],
["move-offset",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtles..rkt)._move-offset))",[0,[2,"move-offset"]],["graphics/turtles"]],
["move-offset",">turtles/Value_Turtles.html#(def._((lib._graphics/value-turtles..rkt)._move-offset))",[0,"move-offset"],["graphics/value-turtles"]],
["move-pinhole",">teachpack/image.html#(def._((lib._htdp/image..rkt)._move-pinhole))",[0,[2,"move-pinhole"]],["htdp/image"]],
["move-position",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._move-position))",[[0,[2,"move-position"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["move-sexp-out",">framework/Racket.html#(meth._(((lib._framework/main..rkt)._racket~3atext~3c~25~3e)._move-sexp-out))",[[0,[2,"move-sexp-out"]],[14,[" (method of ",[0,[2,"racket:text<%>"]],")"]]],["framework"]],
["move-to",">draw/dc-path_.html#(meth._(((lib._racket/draw..rkt)._dc-path~25)._move-to))",[[0,[2,"move-to"]],[14,[" (method of ",[0,[2,"dc-path%"]],")"]]],["racket/draw"]],
["move-to",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._move-to))",[[0,[2,"move-to"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["move/copy-to-edit",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3abasic~3c~25~3e)._move/copy-to-edit))",[[0,[2,"move/copy-to-edit"]],[14,[" (method of ",[0,[2,"text:basic<%>"]],")"]]],["framework"]],
["moving around",">drracket/Keyboard_Shortcuts.html#(part._.Moving_.Around)","Moving Around",false],
["moving forward",">continue/index.html#(part._.Moving_.Forward)","Moving Forward",false],
["moving?",">gui/mouse-event_.html#(meth._(((lib._mred/main..rkt)._mouse-event~25)._moving~3f))",[[0,[2,"moving?"]],[14,[" (method of ",[0,[2,"mouse-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["mpair?",">reference/mpairs.html#(def._((quote._~23~25kernel)._mpair~3f))",[0,[2,"mpair?"]],["racket/base","racket"]],
["mpairof",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.M.Pairof))",[0,[1,"MPairof"]],["typed/racket/base","typed/racket"]],
["mr-connect-to",">reference/distributed-places.html#(def._((lib._racket/place/distributed..rkt)._mr-connect-to))",[0,[2,"mr-connect-to"]],["racket/place/distributed"]],
["mr-spawn-remote-node",">reference/distributed-places.html#(def._((lib._racket/place/distributed..rkt)._mr-spawn-remote-node))",[0,[2,"mr-spawn-remote-node"]],["racket/place/distributed"]],
["mr-supervise-named-dynamic-place-at",">reference/distributed-places.html#(def._((lib._racket/place/distributed..rkt)._mr-supervise-named-dynamic-place-at))",[0,[2,"mr-supervise-named-dynamic-place-at"]],["racket/place/distributed"]],
["mr. potatohead",">slideshow/More_Pict_Constructors.html#(idx._(gentag._0._(lib._scribblings/slideshow/slideshow..scrbl)))","Mr. Potatohead",false],
["mred",">scheme/mred.html",[9,[0,"mred"]],false],
["mred",">scheme/mred.html",[9,[0,"mred"]],"module"],
["mred",">scheme/compat-exe.html#(idx._(gentag._1._(lib._scribblings/scheme/scheme..scrbl)))",[6,"mred"],false],
["mred-launcher-add-suffix",">raco/exe.html#(def._((lib._launcher/launcher..rkt)._mred-launcher-add-suffix))",[0,[2,"mred-launcher-add-suffix"]],["launcher/launcher"]],
["mred-launcher-is-actually-directory?",">raco/exe.html#(def._((lib._launcher/launcher..rkt)._mred-launcher-is-actually-directory~3f))",[0,[2,"mred-launcher-is-actually-directory?"]],["launcher/launcher"]],
["mred-launcher-is-directory?",">raco/exe.html#(def._((lib._launcher/launcher..rkt)._mred-launcher-is-directory~3f))",[0,[2,"mred-launcher-is-directory?"]],["launcher/launcher"]],
["mred-launcher-put-file-extension+style+filters",">raco/exe.html#(def._((lib._launcher/launcher..rkt)._mred-launcher-put-file-extension+style+filters))",[0,[2,"mred-launcher-put-file-extension+style+filters"]],["launcher/launcher"]],
["mred-launcher-up-to-date?",">raco/exe.html#(def._((lib._launcher/launcher..rkt)._mred-launcher-up-to-date~3f))",[0,[2,"mred-launcher-up-to-date?"]],["launcher/launcher"]],
["mred-program-launcher-path",">raco/exe.html#(def._((lib._launcher/launcher..rkt)._mred-program-launcher-path))",[0,[2,"mred-program-launcher-path"]],["launcher/launcher"]],
["mred/mred",">scheme/mred.html",[9,[0,"mred/mred"]],"module"],
["mreverse",">reference/mpairs.html#(def._((lib._racket/mpair..rkt)._mreverse))",[0,[2,"mreverse"]],["racket/mpair"]],
["mreverse!",">reference/mpairs.html#(def._((lib._racket/mpair..rkt)._mreverse!))",[0,[2,"mreverse!"]],["racket/mpair"]],
["mrlib/aligned-pasteboard",">mrlib/Aligned_Pasteboard.html",[9,[0,"mrlib/aligned-pasteboard"]],"module"],
["mrlib/bitmap-label",">mrlib/Bitmap_Label.html",[9,[0,"mrlib/bitmap-label"]],"module"],
["mrlib/cache-image-snip",">mrlib/Cache-image_Snip.html",[9,[0,"mrlib/cache-image-snip"]],"module"],
["mrlib/close-icon",">mrlib/Close_Icon.html",[9,[0,"mrlib/close-icon"]],"module"],
["mrlib/gif",">mrlib/GIF_and_Animated_GIF_Writing.html",[9,[0,"mrlib/gif"]],"module"],
["mrlib/graph",">mrlib/Graphs.html",[9,[0,"mrlib/graph"]],"module"],
["mrlib/hierlist",">mrlib/Hierarchical_List_Control.html",[9,[0,"mrlib/hierlist"]],"module"],
["mrlib/image-core",">mrlib/Image_Core.html",[9,[0,"mrlib/image-core"]],"module"],
["mrlib/include-bitmap",">mrlib/Include_Bitmap.html",[9,[0,"mrlib/include-bitmap"]],"module"],
["mrlib/interactive-value-port",">mrlib/Interactive_Value_Port.html",[9,[0,"mrlib/interactive-value-port"]],"module"],
["mrlib/matrix-snip",">mrlib/Matrix_Snip.html",[9,[0,"mrlib/matrix-snip"]],"module"],
["mrlib/name-message",">mrlib/Name_Message.html",[9,[0,"mrlib/name-message"]],"module"],
["mrlib/path-dialog",">mrlib/Path_Dialog.html",[9,[0,"mrlib/path-dialog"]],"module"],
["mrlib/plot",">mrlib/Plot.html",[9,[0,"mrlib/plot"]],"module"],
["mrlib/switchable-button",">mrlib/Switchable_Button.html",[9,[0,"mrlib/switchable-button"]],"module"],
["mrlib/tex-table",">mrlib/TeX_Table.html",[9,[0,"mrlib/tex-table"]],"module"],
["mrlib: extra gui libraries",">mrlib/index.html","MrLib: Extra GUI Libraries",false],
["mu",">ts-reference/Legacy_Forms.html#(form._((lib._typed-racket/base-env/base-types-extra..rkt)._mu))",[0,[1,"mu"]],["typed/racket/base","typed/racket"]],
["mult-color<%>",">gui/mult-color___.html",[0,[2,"mult-color<%>"]],["racket/snip","racket/gui/base","racket/gui"]],
["mult-vec3",">deinprogramm/line3d.html#(def._((lib._teachpack/deinprogramm/line3d..rkt)._mult-vec3))",[0,[2,"mult-vec3"]],["teachpack/deinprogramm/line3d"]],
["mult-vec4",">deinprogramm/line3d.html#(def._((lib._teachpack/deinprogramm/line3d..rkt)._mult-vec4))",[0,[2,"mult-vec4"]],["teachpack/deinprogramm/line3d"]],
["multi-in",">reference/require.html#(form._((lib._racket/require..rkt)._multi-in))",[0,[1,"multi-in"]],["racket/require"]],
["multi-line mode",">guide/regexp-clusters.html#(tech._multi._line._mode)","<span style=\"font-style: italic\">multi-line mode</span>",false],
["multi-line-string",">db/util.html#(def._((lib._db/util/geometry..rkt)._multi-line-string))",[0,[2,"multi-line-string"]],["db/util/geometry"]],
["multi-line-string-elements",">db/util.html#(def._((lib._db/util/geometry..rkt)._multi-line-string-elements))",[0,[2,"multi-line-string-elements"]],["db/util/geometry"]],
["multi-line-string?",">db/util.html#(def._((lib._db/util/geometry..rkt)._multi-line-string~3f))",[0,[2,"multi-line-string?"]],["db/util/geometry"]],
["multi-page sections",">scribble/how-to-doc.html#(part._.Multi-.Page_.Sections)","Multi-Page Sections",false],
["multi-point",">db/util.html#(def._((lib._db/util/geometry..rkt)._multi-point))",[0,[2,"multi-point"]],["db/util/geometry"]],
["multi-point-elements",">db/util.html#(def._((lib._db/util/geometry..rkt)._multi-point-elements))",[0,[2,"multi-point-elements"]],["db/util/geometry"]],
["multi-point?",">db/util.html#(def._((lib._db/util/geometry..rkt)._multi-point~3f))",[0,[2,"multi-point?"]],["db/util/geometry"]],
["multi-polygon",">db/util.html#(def._((lib._db/util/geometry..rkt)._multi-polygon))",[0,[2,"multi-polygon"]],["db/util/geometry"]],
["multi-polygon-elements",">db/util.html#(def._((lib._db/util/geometry..rkt)._multi-polygon-elements))",[0,[2,"multi-polygon-elements"]],["db/util/geometry"]],
["multi-polygon?",">db/util.html#(def._((lib._db/util/geometry..rkt)._multi-polygon~3f))",[0,[2,"multi-polygon?"]],["db/util/geometry"]],
["multiarg-element",">scribble/core.html#(def._((lib._scribble/core..rkt)._multiarg-element))",[0,[2,"multiarg-element"]],["scribble/core"]],
["multiarg-element-contents",">scribble/core.html#(def._((lib._scribble/core..rkt)._multiarg-element-contents))",[0,[2,"multiarg-element-contents"]],["scribble/core"]],
["multiarg-element-style",">scribble/core.html#(def._((lib._scribble/core..rkt)._multiarg-element-style))",[0,[2,"multiarg-element-style"]],["scribble/core"]],
["multiarg-element?",">scribble/core.html#(def._((lib._scribble/core..rkt)._multiarg-element~3f))",[0,[2,"multiarg-element?"]],["scribble/core"]],
["multimedia file format",">drracket/drracket-files.html#(tech._multimedia._file._format)","<span style=\"font-style: italic\">Multimedia file format</span>",false],
["multiple",">gui/Windowing_Functions.html#(idx._(gentag._144._(lib._scribblings/gui/gui..scrbl)))",[7,"'multiple"],false],
["multiple columns",">unstable/Slideshow_Presentations.html#(part._.Multiple_.Columns)","Multiple Columns",false],
["multiple result values",">guide/contracts-general-functions.html#(part._contracts-multiple)","Multiple Result Values",false],
["multiple return values",">reference/eval-model.html#(part._values-model)","Multiple Return Values",false],
["multiple sections",">scribble/getting-started.html#(part._.Multiple_.Sections)","Multiple Sections",false],
["multiple values",">inside/Evaluation.html#(part._multiple)","Multiple Values",false],
["multiple values",">reference/values.html","Multiple Values",false],
["multiple values",">reference/eval-model.html#(tech._multiple._value)","<span style=\"font-style: italic\">multiple values</span>",false],
["multiple values and define-values",">guide/define.html#(part._multiple-values)",["Multiple Values and ",[0,[1,"define-values"]]],false],
["multiple values: let-values, let*-values, letrec-values",">guide/let.html#(part._.Multiple_.Values__let-values__let_-values__letrec-values)",["Multiple Values: ",[0,[1,"let-values"]],", ",[0,[1,"let*-values"]],", ",[0,[1,"letrec-values"]]],false],
["multiple values: set!-values",">guide/set_.html#(part._.Multiple_.Values__set_-values)",["Multiple Values: ",[0,[1,"set!-values"]]],false],
["multiple-valued sequences",">guide/for.html#(part._.Multiple-.Valued_.Sequences)","Multiple-Valued Sequences",false],
["multiply",">htdp-langs/beginner-abbr.html#(idx._htdp-beginner-abbr._(gentag._17._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-beginner-abbr))","multiply",false],
["multiply",">htdp-langs/beginner.html#(idx._htdp-beginner._(gentag._2._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-beginner))","multiply",false],
["multiply",">gui/key-event_.html#(idx._(gentag._74._(lib._scribblings/gui/gui..scrbl)))",[7,"'multiply"],false],
["multiply-matrix",">deinprogramm/line3d.html#(def._((lib._teachpack/deinprogramm/line3d..rkt)._multiply-matrix))",[0,[2,"multiply-matrix"]],["teachpack/deinprogramm/line3d"]],
["multiply-matrix-vec4",">deinprogramm/line3d.html#(def._((lib._teachpack/deinprogramm/line3d..rkt)._multiply-matrix-vec4))",[0,[2,"multiply-matrix-vec4"]],["teachpack/deinprogramm/line3d"]],
["multiselect-input",">web-server/formlets.html#(def._((lib._web-server/formlets/input..rkt)._multiselect-input))",[0,[2,"multiselect-input"]],["web-server/formlets/input"]],
["must-truncate",">reference/file-ports.html#(idx._(gentag._206._(lib._scribblings/reference/reference..scrbl)))",[7,"'must-truncate"],false],
["mutable",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_292",[0,[1,"mutable"]],["rnrs/records/syntactic-6"]],
["mutable list",">reference/mpairs.html#(tech._mutable._list)","<span style=\"font-style: italic\">mutable list</span>",false],
["mutable list functions",">reference/mpairs.html#(part._.Mutable_.List_.Functions)","Mutable List Functions",false],
["mutable pair",">guide/pairs.html#(tech._mutable._pair)","<span style=\"font-style: italic\">mutable pair</span>",false],
["mutable pair",">reference/mpairs.html#(tech._mutable._pair)","<span style=\"font-style: italic\">mutable pair</span>",false],
["mutable pair constructors and selectors",">reference/mpairs.html#(part._.Mutable_.Pair_.Constructors_and_.Selectors)","Mutable Pair Constructors and Selectors",false],
["mutable pairs and lists",">reference/mpairs.html","Mutable Pairs and Lists",false],
["mutable-bound-id-table?",">syntax/syntax-helpers.html#(def._((lib._syntax/id-table..rkt)._mutable-bound-id-table~3f))",[0,[2,"mutable-bound-id-table?"]],["syntax/id-table"]],
["mutable-free-id-table?",">syntax/syntax-helpers.html#(def._((lib._syntax/id-table..rkt)._mutable-free-id-table~3f))",[0,[2,"mutable-free-id-table?"]],["syntax/id-table"]],
["mutation and performance",">guide/performance.html#(part._.Mutation_and_.Performance)","Mutation and Performance",false],
["mutator",">guide/define-struct.html#(tech._mutator)","<span style=\"font-style: italic\">mutator</span>",false],
["mutator",">reference/define-struct.html#(tech._mutator)","<span style=\"font-style: italic\">mutator</span>",false],
["mutator api",">plai/mutator.html#(part._.Mutator_.A.P.I)","Mutator API",false],
["mx-any",">mysterx/com-types.html#(idx._(gentag._1._(lib._mysterx/scribblings/mysterx..scrbl)))",[7,"'mx-any"],false],
["mx-version",">mysterx/version.html#(def._((lib._mysterx/main..rkt)._mx-version))",[0,[2,"mx-version"]],["mysterx"]],
["my browser displays my page strangely: my css is ignored, sections are missing, etc.",">web-server/faq.html#(part._.My_browser_displays_my_page_strangely__my_.C.S.S_is_ignored__sections_are_missing__etc_)","My browser displays my page strangely: my CSS is ignored, sections are missing, etc.",false],
["mysql",">db/index.html#(idx._(gentag._2._(lib._db/scribblings/db..scrbl)))","MySQL",false],
["mysql authentication",">db/notes.html#(part._.My.S.Q.L_.Authentication)","MySQL Authentication",false],
["mysql types",">db/sql-types.html#(part._mysql-types)","MySQL Types",false],
["mysql-connect",">db/connect.html#(def._((lib._db/main..rkt)._mysql-connect))",[0,[2,"mysql-connect"]],["db"]],
["mysql-data-source",">db/connect.html#(def._((lib._db/base..rkt)._mysql-data-source))",[0,[2,"mysql-data-source"]],["db","db/base"]],
["mysql-guess-socket-path",">db/connect.html#(def._((lib._db/main..rkt)._mysql-guess-socket-path))",[0,[2,"mysql-guess-socket-path"]],["db"]],
["mysterx",">mysterx/index.html",[9,[0,"mysterx"]],"module"],
["mysterx",">foreign/com-auto.html#(tech._mysterx)","<span style=\"font-style: italic\">MysterX</span>",false],
["mysterx: legacy support for windows com",">mysterx/index.html","MysterX: Legacy Support for Windows COM",false],
["mz_gc_array_var_in_reg",">inside/im_memoryalloc.html#(idx._(gentag._215._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"MZ_GC_ARRAY_VAR_IN_REG"]],false],
["mz_gc_decl_reg",">inside/im_memoryalloc.html#(idx._(gentag._214._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"MZ_GC_DECL_REG"]],false],
["mz_gc_no_var_in_reg",">inside/im_memoryalloc.html#(idx._(gentag._218._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"MZ_GC_NO_VAR_IN_REG"]],false],
["mz_gc_reg",">inside/im_memoryalloc.html#(idx._(gentag._217._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"MZ_GC_REG"]],false],
["mz_gc_unreg",">inside/im_memoryalloc.html#(idx._(gentag._213._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"MZ_GC_UNREG"]],false],
["mz_gc_var_in_reg",">inside/im_memoryalloc.html#(idx._(gentag._216._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"MZ_GC_VAR_IN_REG"]],false],
["mzc",">scheme/compat-exe.html#(idx._(gentag._3._(lib._scribblings/scheme/scheme..scrbl)))",[6,"mzc"],false],
["mzcom: racket as a windows com object",">mzcom/index.html","MzCOM: Racket as a Windows COM Object",false],
["mzconfig_allow_set_undefined",">inside/config.html#(idx._(gentag._391._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"MZCONFIG_ALLOW_SET_UNDEFINED"]],false],
["mzconfig_can_read_box",">inside/config.html#(idx._(gentag._382._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"MZCONFIG_CAN_READ_BOX"]],false],
["mzconfig_can_read_compiled",">inside/config.html#(idx._(gentag._381._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"MZCONFIG_CAN_READ_COMPILED"]],false],
["mzconfig_can_read_graph",">inside/config.html#(idx._(gentag._380._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"MZCONFIG_CAN_READ_GRAPH"]],false],
["mzconfig_can_read_pipe_quote",">inside/config.html#(idx._(gentag._383._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"MZCONFIG_CAN_READ_PIPE_QUOTE"]],false],
["mzconfig_case_sens",">inside/config.html#(idx._(gentag._387._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"MZCONFIG_CASE_SENS"]],false],
["mzconfig_collection_paths",">inside/config.html#(idx._(gentag._395._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"MZCONFIG_COLLECTION_PATHS"]],false],
["mzconfig_curly_braces_are_parens",">inside/config.html#(idx._(gentag._389._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"MZCONFIG_CURLY_BRACES_ARE_PARENS"]],false],
["mzconfig_custodian",">inside/config.html#(idx._(gentag._392._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"MZCONFIG_CUSTODIAN"]],false],
["mzconfig_env",">inside/config.html#(idx._(gentag._368._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"MZCONFIG_ENV"]],false],
["mzconfig_error_display_handler",">inside/config.html#(idx._(gentag._372._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"MZCONFIG_ERROR_DISPLAY_HANDLER"]],false],
["mzconfig_error_port",">inside/config.html#(idx._(gentag._371._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"MZCONFIG_ERROR_PORT"]],false],
["mzconfig_error_print_value_handler",">inside/config.html#(idx._(gentag._373._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"MZCONFIG_ERROR_PRINT_VALUE_HANDLER"]],false],
["mzconfig_error_print_width",">inside/config.html#(idx._(gentag._390._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"MZCONFIG_ERROR_PRINT_WIDTH"]],false],
["mzconfig_eval_handler",">inside/config.html#(idx._(gentag._376._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"MZCONFIG_EVAL_HANDLER"]],false],
["mzconfig_exit_handler",">inside/config.html#(idx._(gentag._374._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"MZCONFIG_EXIT_HANDLER"]],false],
["mzconfig_init_exn_handler",">inside/config.html#(idx._(gentag._375._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"MZCONFIG_INIT_EXN_HANDLER"]],false],
["mzconfig_input_port",">inside/config.html#(idx._(gentag._369._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"MZCONFIG_INPUT_PORT"]],false],
["mzconfig_load_directory",">inside/config.html#(idx._(gentag._394._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"MZCONFIG_LOAD_DIRECTORY"]],false],
["mzconfig_load_extension_handler",">inside/config.html#(idx._(gentag._397._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"MZCONFIG_LOAD_EXTENSION_HANDLER"]],false],
["mzconfig_load_handler",">inside/config.html#(idx._(gentag._377._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"MZCONFIG_LOAD_HANDLER"]],false],
["mzconfig_output_port",">inside/config.html#(idx._(gentag._370._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"MZCONFIG_OUTPUT_PORT"]],false],
["mzconfig_port_print_handler",">inside/config.html#(idx._(gentag._396._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"MZCONFIG_PORT_PRINT_HANDLER"]],false],
["mzconfig_print_box",">inside/config.html#(idx._(gentag._386._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"MZCONFIG_PRINT_BOX"]],false],
["mzconfig_print_graph",">inside/config.html#(idx._(gentag._384._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"MZCONFIG_PRINT_GRAPH"]],false],
["mzconfig_print_handler",">inside/config.html#(idx._(gentag._378._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"MZCONFIG_PRINT_HANDLER"]],false],
["mzconfig_print_struct",">inside/config.html#(idx._(gentag._385._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"MZCONFIG_PRINT_STRUCT"]],false],
["mzconfig_prompt_read_handler",">inside/config.html#(idx._(gentag._379._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"MZCONFIG_PROMPT_READ_HANDLER"]],false],
["mzconfig_square_brackets_are_parens",">inside/config.html#(idx._(gentag._388._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"MZCONFIG_SQUARE_BRACKETS_ARE_PARENS"]],false],
["mzconfig_use_compiled_kind",">inside/config.html#(idx._(gentag._393._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"MZCONFIG_USE_COMPILED_KIND"]],false],
["mzlib/a-signature",">mzlib/mzlib_a-signature.html",[9,[0,"mzlib/a-signature"]],"module"],
["mzlib/a-unit",">mzlib/mzlib_a-unit.html",[9,[0,"mzlib/a-unit"]],"module"],
["mzlib/async-channel",">mzlib/mzlib_async-channel.html",[9,[0,"mzlib/async-channel"]],"module"],
["mzlib/awk",">mzlib/mzlib_awk.html",[9,[0,"mzlib/awk"]],"module"],
["mzlib/class",">mzlib/mzlib_class.html",[9,[0,"mzlib/class"]],"module"],
["mzlib/class100",">mzlib/mzlib_class100.html",[9,[0,"mzlib/class100"]],"module"],
["mzlib/cm",">mzlib/mzlib_cm.html",[9,[0,"mzlib/cm"]],"module"],
["mzlib/cm-accomplice",">mzlib/mzlib_cm-accomplice.html",[9,[0,"mzlib/cm-accomplice"]],"module"],
["mzlib/cmdline",">mzlib/mzlib_cmdline.html",[9,[0,"mzlib/cmdline"]],"module"],
["mzlib/cml",">mzlib/mzlib_cml.html",[9,[0,"mzlib/cml"]],"module"],
["mzlib/compat",">mzlib/mzlib_compat.html",[9,[0,"mzlib/compat"]],"module"],
["mzlib/compile",">mzlib/mzlib_compile.html",[9,[0,"mzlib/compile"]],"module"],
["mzlib/contract",">mzlib/mzlib_contract.html",[9,[0,"mzlib/contract"]],"module"],
["mzlib/control",">mzlib/mzlib_control.html",[9,[0,"mzlib/control"]],"module"],
["mzlib/date",">mzlib/mzlib_date.html",[9,[0,"mzlib/date"]],"module"],
["mzlib/deflate",">mzlib/mzlib_deflate.html",[9,[0,"mzlib/deflate"]],"module"],
["mzlib/defmacro",">mzlib/mzlib_defmacro.html",[9,[0,"mzlib/defmacro"]],"module"],
["mzlib/etc",">mzlib/mzlib_etc.html",[9,[0,"mzlib/etc"]],"module"],
["mzlib/file",">mzlib/mzlib_file.html",[9,[0,"mzlib/file"]],"module"],
["mzlib/for",">mzlib/mzlib_for.html",[9,[0,"mzlib/for"]],"module"],
["mzlib/foreign",">mzlib/mzlib_foreign.html",[9,[0,"mzlib/foreign"]],"module"],
["mzlib/include",">mzlib/mzlib_include.html",[9,[0,"mzlib/include"]],"module"],
["mzlib/inflate",">mzlib/mzlib_inflate.html",[9,[0,"mzlib/inflate"]],"module"],
["mzlib/integer-set",">mzlib/mzlib_integer-set.html",[9,[0,"mzlib/integer-set"]],"module"],
["mzlib/kw",">mzlib/mzlib_kw.html",[9,[0,"mzlib/kw"]],"module"],
["mzlib/list",">mzlib/mzlib_list.html",[9,[0,"mzlib/list"]],"module"],
["mzlib/match",">mzlib/mzlib_match.html",[9,[0,"mzlib/match"]],"module"],
["mzlib/math",">mzlib/mzlib_math.html",[9,[0,"mzlib/math"]],"module"],
["mzlib/md5",">mzlib/mzlib_md5.html",[9,[0,"mzlib/md5"]],"module"],
["mzlib/os",">mzlib/mzlib_os.html",[9,[0,"mzlib/os"]],"module"],
["mzlib/pconvert",">mzlib/mzlib_pconvert.html",[9,[0,"mzlib/pconvert"]],"module"],
["mzlib/pconvert-prop",">mzlib/mzlib_pconvert-prop.html",[9,[0,"mzlib/pconvert-prop"]],"module"],
["mzlib/plt-match",">mzlib/mzlib_plt-match.html",[9,[0,"mzlib/plt-match"]],"module"],
["mzlib/port",">mzlib/mzlib_port.html",[9,[0,"mzlib/port"]],"module"],
["mzlib/pregexp",">mzlib/mzlib_pregexp.html",[9,[0,"mzlib/pregexp"]],"module"],
["mzlib/pretty",">mzlib/mzlib_pretty.html",[9,[0,"mzlib/pretty"]],"module"],
["mzlib/process",">mzlib/mzlib_process.html",[9,[0,"mzlib/process"]],"module"],
["mzlib/restart",">mzlib/mzlib_restart.html",[9,[0,"mzlib/restart"]],"module"],
["mzlib/runtime-path",">mzlib/mzlib_runtime-path.html",[9,[0,"mzlib/runtime-path"]],"module"],
["mzlib/sandbox",">mzlib/mzlib_sandbox.html",[9,[0,"mzlib/sandbox"]],"module"],
["mzlib/sendevent",">mzlib/mzlib_sendevent.html",[9,[0,"mzlib/sendevent"]],"module"],
["mzlib/serialize",">mzlib/mzlib_serialize.html",[9,[0,"mzlib/serialize"]],"module"],
["mzlib/shared",">mzlib/mzlib_shared.html",[9,[0,"mzlib/shared"]],"module"],
["mzlib/string",">mzlib/mzlib_string.html",[9,[0,"mzlib/string"]],"module"],
["mzlib/struct",">mzlib/mzlib_struct.html",[9,[0,"mzlib/struct"]],"module"],
["mzlib/stxparam",">mzlib/mzlib_stxparam.html",[9,[0,"mzlib/stxparam"]],"module"],
["mzlib/surrogate",">mzlib/mzlib_surrogate.html",[9,[0,"mzlib/surrogate"]],"module"],
["mzlib/tar",">mzlib/mzlib_tar.html",[9,[0,"mzlib/tar"]],"module"],
["mzlib/thread",">mzlib/mzlib_thread.html",[9,[0,"mzlib/thread"]],"module"],
["mzlib/trace",">mzlib/mzlib_trace.html",[9,[0,"mzlib/trace"]],"module"],
["mzlib/traceld",">mzlib/mzlib_traceld.html",[9,[0,"mzlib/traceld"]],"module"],
["mzlib/trait",">mzlib/mzlib_trait.html",[9,[0,"mzlib/trait"]],"module"],
["mzlib/transcr",">mzlib/mzlib_transcr.html",[9,[0,"mzlib/transcr"]],"module"],
["mzlib/unit",">mzlib/mzlib_unit.html",[9,[0,"mzlib/unit"]],"module"],
["mzlib/unit-exptime",">mzlib/mzlib_unit-exptime.html",[9,[0,"mzlib/unit-exptime"]],"module"],
["mzlib/unit200",">mzlib/mzlib_unit200.html",[9,[0,"mzlib/unit200"]],"module"],
["mzlib/unitsig200",">mzlib/mzlib_unitsig200.html",[9,[0,"mzlib/unitsig200"]],"module"],
["mzlib/zip",">mzlib/mzlib_zip.html",[9,[0,"mzlib/zip"]],"module"],
["mzlib: legacy libraries",">mzlib/index.html","MzLib: Legacy Libraries",false],
["mzpp",">preprocessor/mzpp.html",[6,"mzpp"],false],
["mzpp and mztext: preprocessors",">preprocessor/index.html",[[6,"mzpp"]," and ",[6,"mztext"],": Preprocessors"],false],
["mzpp files",">preprocessor/mzpp.html#(part._mzpp_files)","mzpp files",false],
["mzscheme",">mzscheme/index.html",[9,[0,"mzscheme"]],"module"],
["mzscheme",">html/index.html#(def._((lib._html/main..rkt)._mzscheme))",[0,[2,"mzscheme"]],["html"]],
["mzscheme",">scheme/compat-exe.html#(idx._(gentag._0._(lib._scribblings/scheme/scheme..scrbl)))",[6,"mzscheme"],false],
["mzscheme-const-list",">slideshow/Typesetting_Racket_Code.html#(def._((lib._slideshow/code..rkt)._mzscheme-const-list))",[0,[2,"mzscheme-const-list"]],["slideshow/code"]],
["mzscheme-launcher-add-suffix",">raco/exe.html#(def._((lib._launcher/launcher..rkt)._mzscheme-launcher-add-suffix))",[0,[2,"mzscheme-launcher-add-suffix"]],["launcher/launcher"]],
["mzscheme-launcher-is-actually-directory?",">raco/exe.html#(def._((lib._launcher/launcher..rkt)._mzscheme-launcher-is-actually-directory~3f))",[0,[2,"mzscheme-launcher-is-actually-directory?"]],["launcher/launcher"]],
["mzscheme-launcher-is-directory?",">raco/exe.html#(def._((lib._launcher/launcher..rkt)._mzscheme-launcher-is-directory~3f))",[0,[2,"mzscheme-launcher-is-directory?"]],["launcher/launcher"]],
["mzscheme-launcher-put-file-extension+style+filters",">raco/exe.html#(def._((lib._launcher/launcher..rkt)._mzscheme-launcher-put-file-extension+style+filters))",[0,[2,"mzscheme-launcher-put-file-extension+style+filters"]],["launcher/launcher"]],
["mzscheme-launcher-up-to-date?",">raco/exe.html#(def._((lib._launcher/launcher..rkt)._mzscheme-launcher-up-to-date~3f))",[0,[2,"mzscheme-launcher-up-to-date?"]],["launcher/launcher"]],
["mzscheme-program-launcher-path",">raco/exe.html#(def._((lib._launcher/launcher..rkt)._mzscheme-program-launcher-path))",[0,[2,"mzscheme-program-launcher-path"]],["launcher/launcher"]],
["mzscheme: legacy language",">mzscheme/index.html","MzScheme: Legacy Language",false],
["mzscheme?",">html/index.html#(def._((lib._html/main..rkt)._mzscheme~3f))",[0,[2,"mzscheme?"]],["html"]],
["mztar",">raco/plt.html#(def._((lib._setup/pack..rkt)._mztar))",[0,[2,"mztar"]],["setup/pack"]],
["mztext",">preprocessor/mztext.html",[6,"mztext"],false],
["mztext processing: the standard command dispatcher",">preprocessor/mztext.html#(part._mztext_processing__the_standard_command_dispatcher)","mztext processing: the standard command dispatcher",false],
["nack-guard-evt",">reference/sync.html#(def._((quote._~23~25kernel)._nack-guard-evt))",[0,[2,"nack-guard-evt"]],["racket/base","racket"]],
["name",">teachpack/2htdpuniverse.html#(form._((lib._2htdp/universe..rkt)._name))",[0,[1,"name"]],["2htdp/universe"]],
["name",">planet/Developing_Packages_for_PLaneT.html#(idx._(gentag._26._(lib._planet/planet..scrbl)))",[7,"'name"],false],
["name",">raco/API_for_Raw_Compilation.html#(idx._(gentag._31._(lib._scribblings/raco/raco..scrbl)))",[0,"name"],false],
["name",">redex/The_Redex_Reference.html#(tech._name)",[0,"name"],false],
["name message",">mrlib/Name_Message.html","Name Message",false],
["name->color",">picturing-programs/index.html#(def._((lib._picturing-programs/private/map-image..rkt)._name-~3ecolor))",[0,[2,"name->color"]],["picturing-programs/private/map-image","picturing-programs"]],
["name-message%",">mrlib/Name_Message.html#(def._((lib._mrlib/name-message..rkt)._name-message~25))",[0,[2,"name-message%"]],["mrlib/name-message"]],
["named let",">guide/let.html#(part._.Named_let)",["Named ",[0,[1,"let"]]],false],
["named-place-typed-channel%",">reference/distributed-places.html#(def._((lib._racket/place/distributed..rkt)._named-place-typed-channel~25))",[0,[2,"named-place-typed-channel%"]],["racket/place/distributed"]],
["named/undefined-handler",">mzlib/mzlib_pconvert.html#(def._((lib._mzlib/pconvert..rkt)._named/undefined-handler))",[0,[2,"named/undefined-handler"]],["mzlib/pconvert"]],
["names for types",">ts-reference/special-forms.html#(part._.Names_for_.Types)","Names for Types",false],
["namespace",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Namespace))",[0,[1,"Namespace"]],["typed/racket/base","typed/racket"]],
["namespace",">guide/eval.html#(tech._namespace)","<span style=\"font-style: italic\">namespace</span>",false],
["namespace",">reference/syntax-model.html#(tech._namespace)","<span style=\"font-style: italic\">namespace</span>",false],
["namespace-anchor",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Namespace-.Anchor))",[0,[1,"Namespace-Anchor"]],["typed/racket/base","typed/racket"]],
["namespace-anchor->empty-namespace",">reference/Namespaces.html#(def._((lib._racket/private/base..rkt)._namespace-anchor-~3eempty-namespace))",[0,[2,"namespace-anchor->empty-namespace"]],["racket/base","racket"]],
["namespace-anchor->namespace",">reference/Namespaces.html#(def._((lib._racket/private/base..rkt)._namespace-anchor-~3enamespace))",[0,[2,"namespace-anchor->namespace"]],["racket/base","racket"]],
["namespace-anchor?",">reference/Namespaces.html#(def._((lib._racket/private/base..rkt)._namespace-anchor~3f))",[0,[2,"namespace-anchor?"]],["racket/base","racket"]],
["namespace-attach-module",">reference/Namespaces.html#(def._((quote._~23~25kernel)._namespace-attach-module))",[0,[2,"namespace-attach-module"]],["racket/base","racket"]],
["namespace-attach-module-declaration",">reference/Namespaces.html#(def._((quote._~23~25kernel)._namespace-attach-module-declaration))",[0,[2,"namespace-attach-module-declaration"]],["racket/base","racket"]],
["namespace-base-phase",">reference/Namespaces.html#(def._((quote._~23~25kernel)._namespace-base-phase))",[0,[2,"namespace-base-phase"]],["racket/base","racket"]],
["namespace-defined?",">mzlib/mzlib_etc.html#(def._((lib._mzlib/etc..rkt)._namespace-defined~3f))",[0,[2,"namespace-defined?"]],["mzlib/etc"]],
["namespace-mapped-symbols",">reference/Namespaces.html#(def._((quote._~23~25kernel)._namespace-mapped-symbols))",[0,[2,"namespace-mapped-symbols"]],["racket/base","racket"]],
["namespace-module-identifier",">reference/Namespaces.html#(def._((quote._~23~25kernel)._namespace-module-identifier))",[0,[2,"namespace-module-identifier"]],["racket/base","racket"]],
["namespace-module-registry",">reference/Namespaces.html#(def._((quote._~23~25kernel)._namespace-module-registry))",[0,[2,"namespace-module-registry"]],["racket/base","racket"]],
["namespace-require",">reference/Namespaces.html#(def._((quote._~23~25kernel)._namespace-require))",[0,[2,"namespace-require"]],["racket/base","racket"]],
["namespace-require/constant",">reference/Namespaces.html#(def._((quote._~23~25kernel)._namespace-require/constant))",[0,[2,"namespace-require/constant"]],["racket/base","racket"]],
["namespace-require/copy",">reference/Namespaces.html#(def._((quote._~23~25kernel)._namespace-require/copy))",[0,[2,"namespace-require/copy"]],["racket/base","racket"]],
["namespace-require/expansion-time",">reference/Namespaces.html#(def._((quote._~23~25kernel)._namespace-require/expansion-time))",[0,[2,"namespace-require/expansion-time"]],["racket/base","racket"]],
["namespace-set-variable-value!",">reference/Namespaces.html#(def._((quote._~23~25kernel)._namespace-set-variable-value!))",[0,[2,"namespace-set-variable-value!"]],["racket/base","racket"]],
["namespace-symbol->identifier",">reference/Namespaces.html#(def._((quote._~23~25kernel)._namespace-symbol-~3eidentifier))",[0,[2,"namespace-symbol->identifier"]],["racket/base","racket"]],
["namespace-syntax-introduce",">reference/Namespaces.html#(def._((quote._~23~25kernel)._namespace-syntax-introduce))",[0,[2,"namespace-syntax-introduce"]],["racket/base","racket"]],
["namespace-transformer-require",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..rkt)._namespace-transformer-require))",[0,[2,"namespace-transformer-require"]],["mzscheme"]],
["namespace-undefine-variable!",">reference/Namespaces.html#(def._((quote._~23~25kernel)._namespace-undefine-variable!))",[0,[2,"namespace-undefine-variable!"]],["racket/base","racket"]],
["namespace-unprotect-module",">reference/Namespaces.html#(def._((quote._~23~25kernel)._namespace-unprotect-module))",[0,[2,"namespace-unprotect-module"]],["racket/base","racket"]],
["namespace-variable-value",">reference/Namespaces.html#(def._((quote._~23~25kernel)._namespace-variable-value))",[0,[2,"namespace-variable-value"]],["racket/base","racket"]],
["namespace?",">reference/Namespaces.html#(def._((quote._~23~25kernel)._namespace~3f))",[0,[2,"namespace?"]],["racket/base","racket"]],
["namespaces",">guide/eval.html#(part._namespaces)","Namespaces",false],
["namespaces",">reference/Namespaces.html","Namespaces",false],
["namespaces",">reference/syntax-model.html#(part._namespace-model)","Namespaces",false],
["namespaces and modules",">guide/eval.html#(part._.Namespaces_and_.Modules)","Namespaces and Modules",false],
["namespaces and modules",">inside/im_env.html","Namespaces and Modules",false],
["naming conventions",">json/index.html#(part._.Naming_.Conventions)","Naming Conventions",false],
["nan?",">reference/generic-numbers.html#(def._((lib._racket/math..rkt)._nan~3f))",[0,[2,"nan?"]],["racket/math","racket"]],
["nan?",">r6rs-std/r6rs-Z-H-14.html#node_idx_488",[0,[2,"nan?"]],["rnrs/base-6"]],
["nand",">reference/booleans.html#(form._((lib._racket/bool..rkt)._nand))",[0,[1,"nand"]],["racket/bool","racket"]],
["nand",">mzlib/mzlib_etc.html#(form._((lib._mzlib/etc..rkt)._nand))",[0,[1,"nand"]],["mzlib/etc"]],
["nat",">syntax/Library_Syntax_Classes_and_Literal_Sets.html#(form._((lib._syntax/parse..rkt)._nat))",[0,[1,"nat"]],["syntax/parse"]],
["native interfaces",">web-server/stateless.html#(part._.Native_.Interfaces)","Native Interfaces",false],
["native->serial",">web-server/stateless.html#(form._((lib._web-server/lang/abort-resume..rkt)._native-~3eserial))",[0,[1,"native->serial"]],["web-server/lang/abort-resume"]],
["native-endianness",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_78",[0,[2,"native-endianness"]],["rnrs/bytevectors-6"]],
["native-eol-style",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_598",[0,[2,"native-eol-style"]],["rnrs/io/ports-6"]],
["native-transcoder",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_622",[0,[2,"native-transcoder"]],["rnrs/io/ports-6"]],
["natural",">deinprogramm/Signaturen.html#(form._((lib._deinprogramm/.D.Md.A..rkt)._natural))",[0,[1,"natural"]],["deinprogramm/DMdA-beginner"]],
["natural",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Natural))",[0,[1,"Natural"]],["typed/racket/base","typed/racket"]],
["natural",">redex/The_Redex_Reference.html#(tech._natural)",[0,"natural"],false],
["natural-number/c",">reference/data-structure-contracts.html#(def._((lib._racket/contract/private/misc..rkt)._natural-number/c))",[0,[2,"natural-number/c"]],["racket/contract/base","racket/contract","racket"]],
["natural?",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._natural~3f))",[0,[2,"natural?"]],["deinprogramm/DMdA-advanced"]],
["natural?",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._natural~3f))",[0,[2,"natural?"]],["deinprogramm/DMdA-assignments"]],
["natural?",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._natural~3f))",[0,[2,"natural?"]],["deinprogramm/DMdA-beginner"]],
["natural?",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._natural~3f))",[0,[2,"natural?"]],["deinprogramm/DMdA-vanilla"]],
["natural?",">htdp/index.html#(def._((lib._htdp/error..rkt)._natural~3f))",[0,[2,"natural?"]],["htdp/error"]],
["nat\u00fcrliche zahlen",">deinprogramm/Konstruktionsanleitungen_1_bis_10.html#(part._nat_rliche_.Zahlen)","nat&#252;rliche Zahlen",false],
["navigation",">macro-debugger/index.html#(part._.Navigation)","Navigation",false],
["nd",">reference/characters.html#(idx._(gentag._131._(lib._scribblings/reference/reference..scrbl)))",[7,"'nd"],false],
["neato",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtle-examples..rkt)._neato))",[0,[2,"neato"]],["graphics/turtle-examples"]],
["neato",">turtles/Value_Turtles.html#(def._((lib._graphics/value-turtles-examples..rkt)._neato))",[0,"neato"],["graphics/value-turtles-examples"]],
["needs-execution",">tools/drracket_rep.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3arep~3acontext~3c~25~3e)._needs-execution))",[[0,[2,"needs-execution"]],[14,[" (method of ",[0,[2,"drracket:rep:context<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["needs-rollback?",">db/query-api.html#(def._((lib._db/base..rkt)._needs-rollback~3f))",[0,[2,"needs-rollback?"]],["db","db/base"]],
["needs-update",">gui/editor-admin_.html#(meth._(((lib._mred/main..rkt)._editor-admin~25)._needs-update))",[[0,[2,"needs-update"]],[14,[" (method of ",[0,[2,"editor-admin%"]],")"]]],["racket/gui/base","racket/gui"]],
["needs-update",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._needs-update))",[[0,[2,"needs-update"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["needs-update",">gui/snip-admin_.html#(meth._(((lib._racket/snip..rkt)._snip-admin~25)._needs-update))",[[0,[2,"needs-update"]],[14,[" (method of ",[0,[2,"snip-admin%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["negate",">reference/procedures.html#(def._((lib._racket/function..rkt)._negate))",[0,[2,"negate"]],["racket/function","racket"]],
["negation as failure",">racklog/cut.html#(part._not)","Negation as Failure",false],
["negative-exact-rational",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Negative-.Exact-.Rational))",[0,[1,"Negative-Exact-Rational"]],["typed/racket/base","typed/racket"]],
["negative-fixnum",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Negative-.Fixnum))",[0,[1,"Negative-Fixnum"]],["typed/racket/base","typed/racket"]],
["negative-float",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Negative-.Float))",[0,[1,"Negative-Float"]],["typed/racket/base","typed/racket"]],
["negative-flonum",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Negative-.Flonum))",[0,[1,"Negative-Flonum"]],["typed/racket/base","typed/racket"]],
["negative-inexact-real",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Negative-.Inexact-.Real))",[0,[1,"Negative-Inexact-Real"]],["typed/racket/base","typed/racket"]],
["negative-integer",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Negative-.Integer))",[0,[1,"Negative-Integer"]],["typed/racket/base","typed/racket"]],
["negative-real",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Negative-.Real))",[0,[1,"Negative-Real"]],["typed/racket/base","typed/racket"]],
["negative-single-flonum",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Negative-.Single-.Flonum))",[0,[1,"Negative-Single-Flonum"]],["typed/racket/base","typed/racket"]],
["negative?",">reference/number-types.html#(def._((quote._~23~25kernel)._negative~3f))",[0,[2,"negative?"]],["racket/base","racket"]],
["negative?",">r5rs-std/r5rs-Z-H-9.html#%_idx_272",[0,[2,"negative?"]],["r5rs"]],
["negative?",">r6rs-std/r6rs-Z-H-14.html#node_idx_478",[0,[2,"negative?"]],["rnrs/base-6"]],
["negative?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._negative~3f))",[0,[2,"negative?"]],["lang/htdp-advanced"]],
["negative?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._negative~3f))",[0,[2,"negative?"]],["lang/htdp-beginner"]],
["negative?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._negative~3f))",[0,[2,"negative?"]],["lang/htdp-beginner-abbr"]],
["negative?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._negative~3f))",[0,[2,"negative?"]],["lang/htdp-intermediate"]],
["negative?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._negative~3f))",[0,[2,"negative?"]],["lang/htdp-intermediate-lambda"]],
["negative?",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._negative~3f))",[0,[2,"negative?"]],["deinprogramm/DMdA-advanced"]],
["negative?",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._negative~3f))",[0,[2,"negative?"]],["deinprogramm/DMdA-assignments"]],
["negative?",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._negative~3f))",[0,[2,"negative?"]],["deinprogramm/DMdA-beginner"]],
["negative?",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._negative~3f))",[0,[2,"negative?"]],["deinprogramm/DMdA-vanilla"]],
["nest",">scheme/nest.html#(form._((lib._scheme/nest..rkt)._nest))",[0,"nest"],["scheme/nest"]],
["nested",">scribble/base.html#(def._((lib._scribble/base..rkt)._nested))",[0,[2,"nested"]],["scribble/base"]],
["nested",">srfi-std/srfi-42.html#nested",[0,[1,"nested"]],["srfi/42"]],
["nested attributes",">syntax/stxparse-patterns.html#(tech._nested._attribute)","<span style=\"font-style: italic\">nested attributes</span>",false],
["nested contract boundaries",">reference/attaching-contracts-to-values.html#(part._.Nested_.Contract_.Boundaries)","Nested Contract Boundaries",false],
["nested editors",">gui/WXME_Decoding.html#(part._.Nested_.Editors)","Nested Editors",false],
["nested flow",">scribble/core.html#(tech._nested._flow)","<span style=\"font-style: italic\">nested flow</span>",false],
["nested transaction",">db/query-api.html#(tech._nested._transaction)","<span style=\"font-style: italic\">nested transaction</span>",false],
["nested-flow",">scribble/core.html#(def._((lib._scribble/core..rkt)._nested-flow))",[0,[2,"nested-flow"]],["scribble/core"]],
["nested-flow-blocks",">scribble/core.html#(def._((lib._scribble/core..rkt)._nested-flow-blocks))",[0,[2,"nested-flow-blocks"]],["scribble/core"]],
["nested-flow-style",">scribble/core.html#(def._((lib._scribble/core..rkt)._nested-flow-style))",[0,[2,"nested-flow-style"]],["scribble/core"]],
["nested-flow?",">scribble/core.html#(def._((lib._scribble/core..rkt)._nested-flow~3f))",[0,[2,"nested-flow?"]],["scribble/core"]],
["net",">planet/Developing_Packages_for_PLaneT.html#(idx._(gentag._5._(lib._planet/planet..scrbl)))",[7,"'net"],false],
["net/base64",">net/base64.html",[9,[0,"net/base64"]],"module"],
["net/base64-sig",">net/base64.html#(mod-path._net/base64-sig)",[9,[0,"net/base64-sig"]],"module"],
["net/base64-unit",">net/base64.html#(mod-path._net/base64-unit)",[9,[0,"net/base64-unit"]],"module"],
["net/cgi",">net/cgi.html",[9,[0,"net/cgi"]],"module"],
["net/cgi-sig",">net/cgi.html#(mod-path._net/cgi-sig)",[9,[0,"net/cgi-sig"]],"module"],
["net/cgi-unit",">net/cgi.html#(mod-path._net/cgi-unit)",[9,[0,"net/cgi-unit"]],"module"],
["net/cookie",">net/cookie.html",[9,[0,"net/cookie"]],"module"],
["net/cookie-sig",">net/cookie.html#(mod-path._net/cookie-sig)",[9,[0,"net/cookie-sig"]],"module"],
["net/cookie-unit",">net/cookie.html#(mod-path._net/cookie-unit)",[9,[0,"net/cookie-unit"]],"module"],
["net/dns",">net/dns.html",[9,[0,"net/dns"]],"module"],
["net/dns-sig",">net/dns.html#(mod-path._net/dns-sig)",[9,[0,"net/dns-sig"]],"module"],
["net/dns-unit",">net/dns.html#(mod-path._net/dns-unit)",[9,[0,"net/dns-unit"]],"module"],
["net/ftp",">net/ftp.html",[9,[0,"net/ftp"]],"module"],
["net/ftp-sig",">net/ftp.html#(mod-path._net/ftp-sig)",[9,[0,"net/ftp-sig"]],"module"],
["net/ftp-unit",">net/ftp.html#(mod-path._net/ftp-unit)",[9,[0,"net/ftp-unit"]],"module"],
["net/head",">net/head.html",[9,[0,"net/head"]],"module"],
["net/head-sig",">net/head.html#(mod-path._net/head-sig)",[9,[0,"net/head-sig"]],"module"],
["net/head-unit",">net/head.html#(mod-path._net/head-unit)",[9,[0,"net/head-unit"]],"module"],
["net/imap",">net/imap.html",[9,[0,"net/imap"]],"module"],
["net/imap-sig",">net/imap.html#(mod-path._net/imap-sig)",[9,[0,"net/imap-sig"]],"module"],
["net/imap-unit",">net/imap.html#(mod-path._net/imap-unit)",[9,[0,"net/imap-unit"]],"module"],
["net/mime",">net/mime.html",[9,[0,"net/mime"]],"module"],
["net/mime-sig",">net/mime.html#(mod-path._net/mime-sig)",[9,[0,"net/mime-sig"]],"module"],
["net/mime-unit",">net/mime.html#(mod-path._net/mime-unit)",[9,[0,"net/mime-unit"]],"module"],
["net/nntp",">net/nntp.html",[9,[0,"net/nntp"]],"module"],
["net/nntp-sig",">net/nntp.html#(mod-path._net/nntp-sig)",[9,[0,"net/nntp-sig"]],"module"],
["net/nntp-unit",">net/nntp.html#(mod-path._net/nntp-unit)",[9,[0,"net/nntp-unit"]],"module"],
["net/pop3",">net/pop3.html",[9,[0,"net/pop3"]],"module"],
["net/pop3-sig",">net/pop3.html#(mod-path._net/pop3-sig)",[9,[0,"net/pop3-sig"]],"module"],
["net/pop3-unit",">net/pop3.html#(mod-path._net/pop3-unit)",[9,[0,"net/pop3-unit"]],"module"],
["net/qp",">net/qp.html",[9,[0,"net/qp"]],"module"],
["net/qp-sig",">net/qp.html#(mod-path._net/qp-sig)",[9,[0,"net/qp-sig"]],"module"],
["net/qp-unit",">net/qp.html#(mod-path._net/qp-unit)",[9,[0,"net/qp-unit"]],"module"],
["net/sendmail",">net/sendmail.html",[9,[0,"net/sendmail"]],"module"],
["net/sendmail-sig",">net/sendmail.html#(mod-path._net/sendmail-sig)",[9,[0,"net/sendmail-sig"]],"module"],
["net/sendmail-unit",">net/sendmail.html#(mod-path._net/sendmail-unit)",[9,[0,"net/sendmail-unit"]],"module"],
["net/sendurl",">net/sendurl.html",[9,[0,"net/sendurl"]],"module"],
["net/smtp",">net/smtp.html",[9,[0,"net/smtp"]],"module"],
["net/smtp-sig",">net/smtp.html#(mod-path._net/smtp-sig)",[9,[0,"net/smtp-sig"]],"module"],
["net/smtp-unit",">net/smtp.html#(mod-path._net/smtp-unit)",[9,[0,"net/smtp-unit"]],"module"],
["net/ssl-tcp-unit",">net/ssl-tcp-unit.html",[9,[0,"net/ssl-tcp-unit"]],"module"],
["net/tcp-redirect",">net/tcp-redirect.html",[9,[0,"net/tcp-redirect"]],"module"],
["net/tcp-sig",">net/tcp.html#(mod-path._net/tcp-sig)",[9,[0,"net/tcp-sig"]],"module"],
["net/tcp-unit",">net/tcp.html#(mod-path._net/tcp-unit)",[9,[0,"net/tcp-unit"]],"module"],
["net/uri-codec",">net/uri-codec.html",[9,[0,"net/uri-codec"]],"module"],
["net/uri-codec-sig",">net/uri-codec.html#(mod-path._net/uri-codec-sig)",[9,[0,"net/uri-codec-sig"]],"module"],
["net/uri-codec-unit",">net/uri-codec.html#(mod-path._net/uri-codec-unit)",[9,[0,"net/uri-codec-unit"]],"module"],
["net/url",">net/url.html",[9,[0,"net/url"]],"module"],
["net/url-connect",">net/url.html#(mod-path._net/url-connect)",[9,[0,"net/url-connect"]],"module"],
["net/url-sig",">net/url.html#(mod-path._net/url-sig)",[9,[0,"net/url-sig"]],"module"],
["net/url-structs",">net/url.html#(mod-path._net/url-structs)",[9,[0,"net/url-structs"]],"module"],
["net/url-unit",">net/url.html#(mod-path._net/url-unit)",[9,[0,"net/url-unit"]],"module"],
["net/websocket",">net/websocket.html",[9,[0,"net/websocket"]],"module"],
["net/websocket/client",">net/websocket.html#(mod-path._net/websocket/client)",[9,[0,"net/websocket/client"]],"module"],
["net/websocket/conn",">net/websocket.html#(mod-path._net/websocket/conn)",[9,[0,"net/websocket/conn"]],"module"],
["net/websocket/server",">net/websocket.html#(mod-path._net/websocket/server)",[9,[0,"net/websocket/server"]],"module"],
["net: networking libraries",">net/index.html","Net: Networking Libraries",false],
["netscape/string->url",">net/url.html#(def._((lib._net/url..rkt)._netscape/string-~3eurl))",[0,[2,"netscape/string->url"]],["net/url"]],
["network-error",">web-server-internal/misc-util.html#(def._((lib._web-server/private/util..rkt)._network-error))",[0,[2,"network-error"]],["web-server/private/util"]],
["networking",">reference/networking.html","Networking",false],
["networking troubles",">planet/Using_PLaneT.html#(part._.Networking_troubles)","Networking troubles",false],
["never-e",">frtime/index.html#(def._((lib._frtime/main..rkt)._never-e))",[0,[2,"never-e"]],["frtime"]],
["never-evt",">reference/sync.html#(def._((quote._~23~25kernel)._never-evt))",[0,[2,"never-evt"]],["racket/base","racket"]],
["new",">reference/objcreation.html#(form._((lib._racket/private/class-internal..rkt)._new))",[0,[1,"new"]],["racket/class","racket"]],
["new image functions",">picturing-programs/index.html#(part._.New_image_functions)","New image functions",false],
["new menu item",">drracket/Menus.html#(idx._(gentag._53._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">New</span> menu item",false],
["new tab menu item",">drracket/Menus.html#(idx._(gentag._54._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">New Tab</span> menu item",false],
["new type names",">ts-guide/more.html#(part._.New_.Type_.Names)","New Type Names",false],
["new-cafe",">mzlib/mzlib_compat.html#(def._((lib._mzlib/compat..rkt)._new-cafe))",[0,[2,"new-cafe"]],["mzlib/compat"]],
["new-cell",">frtime/index.html#(def._((lib._frtime/main..rkt)._new-cell))",[0,[2,"new-cell"]],["frtime"]],
["new-connection",">web-server-internal/connection-manager.html#(def._((lib._web-server/private/connection-manager..rkt)._new-connection))",[0,[2,"new-connection"]],["web-server/private/connection-manager"]],
["new-item",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..rkt)._hierarchical-list~25)._new-item))",[[0,[2,"new-item"]],[14,[" (method of ",[0,[2,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["new-item",">mrlib/hierarchical-list-compound-item___.html#(meth._(((lib._mrlib/hierlist..rkt)._hierarchical-list-compound-item~3c~25~3e)._new-item))",[[0,[2,"new-item"]],[14,[" (method of ",[0,[2,"hierarchical-list-compound-item<%>"]],")"]]],["mrlib/hierlist"]],
["new-list",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..rkt)._hierarchical-list~25)._new-list))",[[0,[2,"new-list"]],[14,[" (method of ",[0,[2,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["new-list",">mrlib/hierarchical-list-compound-item___.html#(meth._(((lib._mrlib/hierlist..rkt)._hierarchical-list-compound-item~3c~25~3e)._new-list))",[[0,[2,"new-list"]],[14,[" (method of ",[0,[2,"hierarchical-list-compound-item<%>"]],")"]]],["mrlib/hierlist"]],
["new-named-style",">gui/style-list_.html#(meth._(((lib._racket/snip..rkt)._style-list~25)._new-named-style))",[[0,[2,"new-named-style"]],[14,[" (method of ",[0,[2,"style-list%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["new-prompt",">reference/cont.html#(def._((lib._racket/control..rkt)._new-prompt))",[0,[2,"new-prompt"]],["racket/control"]],
["new-\u2200/c",">reference/parametric-contracts.html#(def._((lib._racket/contract/parametric..rkt)._new-~e2~88~80/c))",[0,[2,"new-&#8704;/c"]],["racket/contract/parametric","racket/contract","racket"]],
["new-\u2203/c",">reference/parametric-contracts.html#(def._((lib._racket/contract/parametric..rkt)._new-~e2~88~83/c))",[0,[2,"new-&#8707;/c"]],["racket/contract/parametric","racket/contract","racket"]],
["newline",">reference/Byte_and_String_Output.html#(def._((quote._~23~25kernel)._newline))",[0,[2,"newline"]],["racket/base","racket"]],
["newline",">r5rs-std/r5rs-Z-H-9.html#%_idx_662",[0,[2,"newline"]],["r5rs"]],
["newline",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_824",[0,[2,"newline"]],["rnrs/io/simple-6"]],
["newline",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._newline))",[0,[2,"newline"]],["lang/htdp-advanced"]],
["newline",">gui/snip_.html#(idx._(gentag._164._(lib._scribblings/gui/gui..scrbl)))",[7,"'newline"],false],
["newline*",">preprocessor/mzpp.html#(def._((lib._preprocessor/mzpp..rkt)._newline*))",[0,[2,"newline*"]],["preprocessor/mzpp"]],
["newnews-since",">net/nntp.html#(def._((lib._net/nntp..rkt)._newnews-since))",[0,[2,"newnews-since"]],["net/nntp"]],
["next",">gui/snip_.html#(meth._(((lib._racket/snip..rkt)._snip~25)._next))",[[0,[2,"next"]],[14,[" (method of ",[0,[2,"snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["next",">embedded-gui/dllist___.html#(meth._(((lib._embedded-gui/main..rkt)._dllist~3c~25~3e)._next))",[[0,[2,"next"]],[14,[" (method of ",[0,[2,"dllist<%>"]],")"]]],["embedded-gui"]],
["next",">gui/key-event_.html#(idx._(gentag._49._(lib._scribblings/gui/gui..scrbl)))",[7,"'next"],false],
["next steps",">scribble/getting-started.html#(part._roadmap)","Next Steps",false],
["next-dispatcher",">web-server-internal/dispatch.html#(def._((lib._web-server/dispatchers/dispatch..rkt)._next-dispatcher))",[0,[2,"next-dispatcher"]],["web-server/dispatchers/dispatch"]],
["next-tab",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aframe~3c~25~3e)._next-tab))",[[0,[2,"next-tab"]],[14,[" (method of ",[0,[2,"drracket:unit:frame<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["nfa",">unstable/Automata__Compiling_State_Machines.html#(form._((lib._unstable/automata/nfa..rkt)._nfa))",[0,[1,"nfa"]],["unstable/automata/nfa"]],
["nfa/ep",">unstable/Automata__Compiling_State_Machines.html#(form._((lib._unstable/automata/nfa-ep..rkt)._nfa/ep))",[0,[1,"nfa/ep"]],["unstable/automata/nfa-ep"]],
["ninth",">reference/pairs.html#(def._((lib._racket/list..rkt)._ninth))",[0,[2,"ninth"]],["racket/list","racket"]],
["ninth",">srfi-std/srfi-1.html#ninth",[0,[2,"ninth"]],["srfi/1"]],
["nl",">reference/characters.html#(idx._(gentag._132._(lib._scribblings/reference/reference..scrbl)))",[7,"'nl"],false],
["nntp",">net/nntp.html#(def._((lib._net/nntp..rkt)._nntp))",[0,[2,"nntp"]],["net/nntp"]],
["nntp signature",">net/nntp.html#(part._.N.N.T.P_.Signature)","NNTP Signature",false],
["nntp unit",">net/nntp.html#(part._.N.N.T.P_.Unit)","NNTP Unit",false],
["nntp: newsgroup protocol",">net/nntp.html","NNTP: Newsgroup Protocol",false],
["nntp?",">net/nntp.html#(def._((lib._net/nntp..rkt)._nntp~3f))",[0,[2,"nntp?"]],["net/nntp"]],
["nntp@",">net/nntp.html#(def._((lib._net/nntp-unit..rkt)._nntp~40))",[0,[2,"nntp@"]],["net/nntp-unit"]],
["nntp^",">net/nntp.html#(form._((lib._net/nntp-sig..rkt)._nntp~5e))",[0,[1,"nntp^"]],["net/nntp-sig"]],
["no",">foreign/Objective-C_FFI.html#(def._((lib._ffi/unsafe/objc..rkt)._.N.O))",[0,[2,"NO"]],["ffi/unsafe/objc"]],
["no",">reference/characters.html#(idx._(gentag._133._(lib._scribblings/reference/reference..scrbl)))",[7,"'no"],false],
["no continuations",">web-server/servlet.html#(part._none)","No Continuations",false],
["no-caret",">gui/editor-overview.html#(idx._(gentag._157._(lib._scribblings/gui/gui..scrbl)))",[7,"'no-caret"],false],
["no-color",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._no-color))",[0,[2,"no-color"]],["scribble/racket","scribble/scheme"]],
["no-group-selected",">net/nntp.html#(def._((lib._net/nntp..rkt)._no-group-selected))",[0,[2,"no-group-selected"]],["net/nntp"]],
["no-group-selected?",">net/nntp.html#(def._((lib._net/nntp..rkt)._no-group-selected~3f))",[0,[2,"no-group-selected?"]],["net/nntp"]],
["no-infinities-violation?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1052",[0,[2,"no-infinities-violation?"]],["rnrs/arithmetic/flonums-6"]],
["no-nans-violation?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1058",[0,[2,"no-nans-violation?"]],["rnrs/arithmetic/flonums-6"]],
["no-selected",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._no-selected))",[[0,[2,"no-selected"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["no-spaces?",">preprocessor/mzpp.html#(def._((lib._preprocessor/mzpp..rkt)._no-spaces~3f))",[0,[2,"no-spaces?"]],["preprocessor/mzpp"]],
["no-ticks",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._no-ticks))",[0,[2,"no-ticks"]],["plot"]],
["no-ticks-format",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._no-ticks-format))",[0,[2,"no-ticks-format"]],["plot"]],
["no-ticks-layout",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._no-ticks-layout))",[0,[2,"no-ticks-layout"]],["plot"]],
["no-web-browser",">web-server/run.html#(def._((lib._web-server/insta/insta..rkt)._no-web-browser))",[0,[2,"no-web-browser"]],["web-server/insta"]],
["nocopyright",">scribble/SIGPLAN_Paper_Format.html#(form._((lib._scribble/sigplan..rkt)._nocopyright))",[0,[1,"nocopyright"]],["scribble/sigplan"]],
["node",">profile/index.html#(def._((lib._profile/analyzer..rkt)._node))",[0,[2,"node"]],["profile/analyzer"]],
["node%",">reference/distributed-places.html#(def._((lib._racket/place/distributed..rkt)._node~25))",[0,[2,"node%"]],["racket/place/distributed"]],
["node-callees",">profile/index.html#(def._((lib._profile/analyzer..rkt)._node-callees))",[0,[2,"node-callees"]],["profile/analyzer"]],
["node-callers",">profile/index.html#(def._((lib._profile/analyzer..rkt)._node-callers))",[0,[2,"node-callers"]],["profile/analyzer"]],
["node-get-first-place",">reference/distributed-places.html#(def._((lib._racket/place/distributed..rkt)._node-get-first-place))",[0,[2,"node-get-first-place"]],["racket/place/distributed"]],
["node-id",">profile/index.html#(def._((lib._profile/analyzer..rkt)._node-id))",[0,[2,"node-id"]],["profile/analyzer"]],
["node-left",">syntax-color/index.html#(def._((lib._syntax-color/token-tree..rkt)._node-left))",[0,[2,"node-left"]],["syntax-color/token-tree"]],
["node-left-subtree-length",">syntax-color/index.html#(def._((lib._syntax-color/token-tree..rkt)._node-left-subtree-length))",[0,[2,"node-left-subtree-length"]],["syntax-color/token-tree"]],
["node-right",">syntax-color/index.html#(def._((lib._syntax-color/token-tree..rkt)._node-right))",[0,[2,"node-right"]],["syntax-color/token-tree"]],
["node-self",">profile/index.html#(def._((lib._profile/analyzer..rkt)._node-self))",[0,[2,"node-self"]],["profile/analyzer"]],
["node-send-exit",">reference/distributed-places.html#(def._((lib._racket/place/distributed..rkt)._node-send-exit))",[0,[2,"node-send-exit"]],["racket/place/distributed"]],
["node-src",">profile/index.html#(def._((lib._profile/analyzer..rkt)._node-src))",[0,[2,"node-src"]],["profile/analyzer"]],
["node-thread-ids",">profile/index.html#(def._((lib._profile/analyzer..rkt)._node-thread-ids))",[0,[2,"node-thread-ids"]],["profile/analyzer"]],
["node-token-data",">syntax-color/index.html#(def._((lib._syntax-color/token-tree..rkt)._node-token-data))",[0,[2,"node-token-data"]],["syntax-color/token-tree"]],
["node-token-length",">syntax-color/index.html#(def._((lib._syntax-color/token-tree..rkt)._node-token-length))",[0,[2,"node-token-length"]],["syntax-color/token-tree"]],
["node-total",">profile/index.html#(def._((lib._profile/analyzer..rkt)._node-total))",[0,[2,"node-total"]],["profile/analyzer"]],
["node?",">profile/index.html#(def._((lib._profile/analyzer..rkt)._node~3f))",[0,[2,"node?"]],["profile/analyzer"]],
["node?",">syntax-color/index.html#(def._((lib._syntax-color/token-tree..rkt)._node~3f))",[0,[2,"node?"]],["syntax-color/token-tree"]],
["nodes",">reference/distributed-places.html#(tech._node)","<span style=\"font-style: italic\">nodes</span>",false],
["noframes",">html/index.html#(def._((lib._html/main..rkt)._noframes))",[0,[2,"noframes"]],["html"]],
["noframes?",">html/index.html#(def._((lib._html/main..rkt)._noframes~3f))",[0,[2,"noframes?"]],["html"]],
["nominal-id",">reference/stxtrans.html#(idx._(gentag._174._(lib._scribblings/reference/reference..scrbl)))",[7,"'nominal-id"],false],
["nominal-module-binding",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._nominal-module-binding))",[0,[2,"nominal-module-binding"]],["compiler/zo-structs"]],
["nominal-module-binding-nominal-path",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._nominal-module-binding-nominal-path))",[0,[2,"nominal-module-binding-nominal-path"]],["compiler/zo-structs"]],
["nominal-module-binding-path",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._nominal-module-binding-path))",[0,[2,"nominal-module-binding-path"]],["compiler/zo-structs"]],
["nominal-module-binding?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._nominal-module-binding~3f))",[0,[2,"nominal-module-binding?"]],["compiler/zo-structs"]],
["nominal-path",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._nominal-path))",[0,[2,"nominal-path"]],["compiler/zo-structs"]],
["nominal-path?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._nominal-path~3f))",[0,[2,"nominal-path?"]],["compiler/zo-structs"]],
["non-capturing",">guide/regexp-clusters.html#(tech._non._capturing)","<span style=\"font-style: italic\">non-capturing</span>",false],
["non-capturing clusters",">guide/regexp-clusters.html#(part._.Non-capturing_.Clusters)","Non-capturing Clusters",false],
["non-continuable-violation?",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_464",[0,[2,"non-continuable-violation?"]],["rnrs/conditions-6"]],
["non-deterministic finite automata",">unstable/Automata__Compiling_State_Machines.html#(part._nfa)","Non-Deterministic Finite Automata",false],
["non-deterministic finite automata (with epsilon transitions)",">unstable/Automata__Compiling_State_Machines.html#(part._nfa-ep)","Non-Deterministic Finite Automata (with epsilon transitions)",false],
["non-empty-listof",">reference/data-structure-contracts.html#(def._((lib._racket/contract/private/misc..rkt)._non-empty-listof))",[0,[2,"non-empty-listof"]],["racket/contract/base","racket/contract","racket"]],
["non-empty-string?",">unstable/contract.html#(def._((lib._unstable/contract..rkt)._non-empty-string~3f))",[0,[2,"non-empty-string?"]],["unstable/contract"]],
["non-existent-group",">net/nntp.html#(def._((lib._net/nntp..rkt)._non-existent-group))",[0,[2,"non-existent-group"]],["net/nntp"]],
["non-existent-group-group",">net/nntp.html#(def._((lib._net/nntp..rkt)._non-existent-group-group))",[0,[2,"non-existent-group-group"]],["net/nntp"]],
["non-existent-group?",">net/nntp.html#(def._((lib._net/nntp..rkt)._non-existent-group~3f))",[0,[2,"non-existent-group?"]],["net/nntp"]],
["non-greedy",">guide/regexp-quant.html#(tech._non._greedy)","<span style=\"font-style: italic\">non-greedy</span>",false],
["non-gui installer",">raco/_plt-archives.html#(part._.Non-.G.U.I_.Installer)","Non-GUI Installer",false],
["non-module compilation and expansion",">syntax/toplevel.html","Non-Module Compilation And Expansion",false],
["non-r5rs bindings from r5rs",">r5rs/r5rs-mod.html#(part._.Non-.R5.R.S_.Bindings_from_r5rs)",["Non-R","<span style=\"vertical-align: super; font-size: 80%\">5</span>","RS Bindings from ",[9,[0,"r5rs"]]],false],
["non-syntax-valued attributes",">syntax/varied-meanings.html#(part._.Non-syntax-valued_.Attributes)","Non-syntax-valued Attributes",false],
["non-terminal-style",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._non-terminal-style))",[0,[2,"non-terminal-style"]],["redex/pict","redex"]],
["non-terminal-subscript-style",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._non-terminal-subscript-style))",[0,[2,"non-terminal-subscript-style"]],["redex/pict","redex"]],
["non-terminal-superscript-style",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._non-terminal-superscript-style))",[0,[2,"non-terminal-superscript-style"]],["redex/pict","redex"]],
["non-terminating-macro",">reference/readtables.html#(idx._(gentag._221._(lib._scribblings/reference/reference..scrbl)))",[7,"'non-terminating-macro"],false],
["non-terminating-macro",">reference/readtables.html#(idx._(gentag._223._(lib._scribblings/reference/reference..scrbl)))",[7,"'non-terminating-macro"],false],
["non-uniform variable-arity functions",">ts-guide/types.html#(part._.Non-.Uniform_.Variable-.Arity_.Functions)","Non-Uniform Variable-Arity Functions",false],
["non-windows",">gui/windowing-overview.html#(tech._non._window)","<span style=\"font-style: italic\">non-windows</span>",false],
["nonatomic",">foreign/foreign_pointer-funcs.html#(idx._(gentag._5._(lib._scribblings/foreign/foreign..scrbl)))",[7,"'nonatomic"],false],
["nonbreaking",">scribble/base.html#(def._((lib._scribble/base..rkt)._nonbreaking))",[0,[2,"nonbreaking"]],["scribble/base"]],
["none",">planet/Developing_Packages_for_PLaneT.html#(idx._(gentag._18._(lib._planet/planet..scrbl)))",[7,"'none"],false],
["none",">reference/stxcerts.html#(idx._(gentag._184._(lib._scribblings/reference/reference..scrbl)))",[7,"'none"],false],
["none",">planet/Developing_Packages_for_PLaneT.html#(idx._(gentag._19._(lib._planet/planet..scrbl)))",[7,"'none"],false],
["none",">reference/port-buffers.html#(idx._(gentag._195._(lib._scribblings/reference/reference..scrbl)))",[7,"'none"],false],
["none/c",">reference/data-structure-contracts.html#(def._((lib._racket/contract/private/misc..rkt)._none/c))",[0,[2,"none/c"]],["racket/contract/base","racket/contract","racket"]],
["nonempty-queue/c",">data/Imperative_Queues.html#(def._((lib._data/queue..rkt)._nonempty-queue/c))",[0,[2,"nonempty-queue/c"]],["data/queue"]],
["nongenerative",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_304",[0,[1,"nongenerative"]],["rnrs/records/syntactic-6"]],
["nonlinear-seq",">plot/utils.html#(def._((lib._plot/utils..rkt)._nonlinear-seq))",[0,[2,"nonlinear-seq"]],["plot/utils"]],
["nonnegative-exact-rational",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Nonnegative-.Exact-.Rational))",[0,[1,"Nonnegative-Exact-Rational"]],["typed/racket/base","typed/racket"]],
["nonnegative-fixnum",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Nonnegative-.Fixnum))",[0,[1,"Nonnegative-Fixnum"]],["typed/racket/base","typed/racket"]],
["nonnegative-float",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Nonnegative-.Float))",[0,[1,"Nonnegative-Float"]],["typed/racket/base","typed/racket"]],
["nonnegative-flonum",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Nonnegative-.Flonum))",[0,[1,"Nonnegative-Flonum"]],["typed/racket/base","typed/racket"]],
["nonnegative-inexact-real",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Nonnegative-.Inexact-.Real))",[0,[1,"Nonnegative-Inexact-Real"]],["typed/racket/base","typed/racket"]],
["nonnegative-integer",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Nonnegative-.Integer))",[0,[1,"Nonnegative-Integer"]],["typed/racket/base","typed/racket"]],
["nonnegative-real",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Nonnegative-.Real))",[0,[1,"Nonnegative-Real"]],["typed/racket/base","typed/racket"]],
["nonnegative-single-flonum",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Nonnegative-.Single-.Flonum))",[0,[1,"Nonnegative-Single-Flonum"]],["typed/racket/base","typed/racket"]],
["nonpositive-exact-rational",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Nonpositive-.Exact-.Rational))",[0,[1,"Nonpositive-Exact-Rational"]],["typed/racket/base","typed/racket"]],
["nonpositive-fixnum",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Nonpositive-.Fixnum))",[0,[1,"Nonpositive-Fixnum"]],["typed/racket/base","typed/racket"]],
["nonpositive-float",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Nonpositive-.Float))",[0,[1,"Nonpositive-Float"]],["typed/racket/base","typed/racket"]],
["nonpositive-flonum",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Nonpositive-.Flonum))",[0,[1,"Nonpositive-Flonum"]],["typed/racket/base","typed/racket"]],
["nonpositive-inexact-real",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Nonpositive-.Inexact-.Real))",[0,[1,"Nonpositive-Inexact-Real"]],["typed/racket/base","typed/racket"]],
["nonpositive-integer",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Nonpositive-.Integer))",[0,[1,"Nonpositive-Integer"]],["typed/racket/base","typed/racket"]],
["nonpositive-real",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Nonpositive-.Real))",[0,[1,"Nonpositive-Real"]],["typed/racket/base","typed/racket"]],
["nonpositive-single-flonum",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Nonpositive-.Single-.Flonum))",[0,[1,"Nonpositive-Single-Flonum"]],["typed/racket/base","typed/racket"]],
["nonrenderer?",">plot/contracts.html#(def._((lib._plot/utils..rkt)._nonrenderer~3f))",[0,[2,"nonrenderer?"]],["plot/utils"]],
["nonrenderers",">plot/nonrenderer.html","Nonrenderers",false],
["nonrenderers",">plot/nonrenderer.html#(tech._nonrenderer)","<span style=\"font-style: italic\">nonrenderers</span>",false],
["nonterm",">scribble/bnf.html#(def._((lib._scribble/bnf..rkt)._nonterm))",[0,[2,"nonterm"]],["scribble/bnf"]],
["noqcourier",">scribble/SIGPLAN_Paper_Format.html#(form._((lib._scribble/sigplan..rkt)._noqcourier))",[0,[1,"noqcourier"]],["scribble/sigplan"]],
["nor",">reference/booleans.html#(form._((lib._racket/bool..rkt)._nor))",[0,[1,"nor"]],["racket/bool","racket"]],
["nor",">mzlib/mzlib_etc.html#(form._((lib._mzlib/etc..rkt)._nor))",[0,[1,"nor"]],["mzlib/etc"]],
["norm-vec3",">deinprogramm/line3d.html#(def._((lib._teachpack/deinprogramm/line3d..rkt)._norm-vec3))",[0,[2,"norm-vec3"]],["teachpack/deinprogramm/line3d"]],
["norm-vec4",">deinprogramm/line3d.html#(def._((lib._teachpack/deinprogramm/line3d..rkt)._norm-vec4))",[0,[2,"norm-vec4"]],["teachpack/deinprogramm/line3d"]],
["normal",">gui/style-delta_.html#(idx._(gentag._180._(lib._scribblings/gui/gui..scrbl)))",[7,"'normal"],false],
["normal",">gui/style-delta_.html#(idx._(gentag._189._(lib._scribblings/gui/gui..scrbl)))",[7,"'normal"],false],
["normal",">draw/font_.html#(idx._(gentag._36._(lib._scribblings/draw/draw..scrbl)))",[7,"'normal"],false],
["normal",">draw/font_.html#(idx._(gentag._39._(lib._scribblings/draw/draw..scrbl)))",[7,"'normal"],false],
["normal use of readline",">readline/index.html#(part._.Normal_.Use_of_.Readline)","Normal Use of Readline",false],
["normal-case-path",">reference/Manipulating_Paths.html#(def._((lib._racket/private/misc..rkt)._normal-case-path))",[0,[2,"normal-case-path"]],["racket/base","racket"]],
["normal-control-font",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._normal-control-font))",[0,[2,"normal-control-font"]],["racket/gui/base","racket/gui"]],
["normalize-definition",">syntax/transformer-helpers.html#(def._((lib._syntax/define..rkt)._normalize-definition))",[0,[2,"normalize-definition"]],["syntax/define"]],
["normalize-path",">reference/More_Path_Utilities.html#(def._((lib._racket/path..rkt)._normalize-path))",[0,[2,"normalize-path"]],["racket/path","racket"]],
["normalize-vec3",">deinprogramm/line3d.html#(def._((lib._teachpack/deinprogramm/line3d..rkt)._normalize-vec3))",[0,[2,"normalize-vec3"]],["teachpack/deinprogramm/line3d"]],
["normalize-vec4",">deinprogramm/line3d.html#(def._((lib._teachpack/deinprogramm/line3d..rkt)._normalize-vec4))",[0,[2,"normalize-vec4"]],["teachpack/deinprogramm/line3d"]],
["normquad-vec3",">deinprogramm/line3d.html#(def._((lib._teachpack/deinprogramm/line3d..rkt)._norm.Quad-vec3))",[0,"normQuad-vec3"],["teachpack/deinprogramm/line3d"]],
["normquad-vec4",">deinprogramm/line3d.html#(def._((lib._teachpack/deinprogramm/line3d..rkt)._norm.Quad-vec4))",[0,"normQuad-vec4"],["teachpack/deinprogramm/line3d"]],
["noscript",">html/index.html#(def._((lib._html/main..rkt)._noscript))",[0,[2,"noscript"]],["html"]],
["noscript?",">html/index.html#(def._((lib._html/main..rkt)._noscript~3f))",[0,[2,"noscript?"]],["html"]],
["not",">reference/booleans.html#(def._((quote._~23~25kernel)._not))",[0,[2,"not"]],["racket/base","racket"]],
["not",">r5rs-std/r5rs-Z-H-9.html#%_idx_386",[0,[2,"not"]],["r5rs"]],
["not",">r6rs-std/r6rs-Z-H-14.html#node_idx_594",[0,[2,"not"]],["rnrs/base-6"]],
["not",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._not))",[0,[2,"not"]],["lang/htdp-advanced"]],
["not",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._not))",[0,[2,"not"]],["lang/htdp-beginner"]],
["not",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._not))",[0,[2,"not"]],["lang/htdp-beginner-abbr"]],
["not",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._not))",[0,[2,"not"]],["lang/htdp-intermediate"]],
["not",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._not))",[0,[2,"not"]],["lang/htdp-intermediate-lambda"]],
["not",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._not))",[0,[2,"not"]],["deinprogramm/DMdA-advanced"]],
["not",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._not))",[0,[2,"not"]],["deinprogramm/DMdA-assignments"]],
["not",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._not))",[0,[2,"not"]],["deinprogramm/DMdA-beginner"]],
["not",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._not))",[0,[2,"not"]],["deinprogramm/DMdA-vanilla"]],
["not",">srfi-std/srfi-42.html#not",[0,[1,"not"]],["srfi/42"]],
["not-a-number",">reference/numbers.html#(idx._(gentag._96._(lib._scribblings/reference/reference..scrbl)))","not-a-number",false],
["not-free-identifier=?",">reference/stxtrans.html#(idx._(gentag._172._(lib._scribblings/reference/reference..scrbl)))",[7,"'not-free-identifier=?"],false],
["not-free-identifier=?",">reference/stxtrans.html#(idx._(gentag._173._(lib._scribblings/reference/reference..scrbl)))",[7,"'not-free-identifier=?"],false],
["not-given-headers",">net/pop3.html#(def._((lib._net/pop3..rkt)._not-given-headers))",[0,[2,"not-given-headers"]],["net/pop3"]],
["not-given-headers-communicator",">net/pop3.html#(def._((lib._net/pop3..rkt)._not-given-headers-communicator))",[0,[2,"not-given-headers-communicator"]],["net/pop3"]],
["not-given-headers-message",">net/pop3.html#(def._((lib._net/pop3..rkt)._not-given-headers-message))",[0,[2,"not-given-headers-message"]],["net/pop3"]],
["not-given-headers?",">net/pop3.html#(def._((lib._net/pop3..rkt)._not-given-headers~3f))",[0,[2,"not-given-headers?"]],["net/pop3"]],
["not-pair?",">srfi-std/srfi-1.html#not-pair-p",[0,[2,"not-pair?"]],["srfi/1"]],
["not-provide-all-defined",">reference/stxtrans.html#(idx._(gentag._175._(lib._scribblings/reference/reference..scrbl)))",[7,"'not-provide-all-defined"],false],
["not-ready-for-transaction",">net/pop3.html#(def._((lib._net/pop3..rkt)._not-ready-for-transaction))",[0,[2,"not-ready-for-transaction"]],["net/pop3"]],
["not-ready-for-transaction-communicator",">net/pop3.html#(def._((lib._net/pop3..rkt)._not-ready-for-transaction-communicator))",[0,[2,"not-ready-for-transaction-communicator"]],["net/pop3"]],
["not-ready-for-transaction?",">net/pop3.html#(def._((lib._net/pop3..rkt)._not-ready-for-transaction~3f))",[0,[2,"not-ready-for-transaction?"]],["net/pop3"]],
["not-running",">tools/drracket_frame.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aframe~3a~3c~25~3e)._not-running))",[[0,[2,"not-running"]],[14,[" (method of ",[0,[2,"drracket:frame:<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["not/c",">reference/data-structure-contracts.html#(def._((lib._racket/contract/private/misc..rkt)._not/c))",[0,[2,"not/c"]],["racket/contract/base","racket/contract","racket"]],
["notation",">guide/syntax-notation.html","Notation",false],
["note",">scriblib/footnotes.html#(def._((lib._scriblib/footnote..rkt)._note))",[0,[2,"note"]],["scriblib/footnote"]],
["notes",">db/notes.html","Notes",false],
["notes on r5rs functions",">r5rs/r5rs-mod.html#(part._.Notes_on_.R5.R.S_.Functions)","Notes on R<span style=\"vertical-align: super; font-size: 80%\">5</span>RS Functions",false],
["nothing",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex..rkt)._nothing))",[0,[1,"nothing"]],["parser-tools/lex"]],
["nothing",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Nothing))",[0,[1,"Nothing"]],["typed/racket/base","typed/racket"]],
["notify",">gui/timer_.html#(meth._(((lib._mred/main..rkt)._timer~25)._notify))",[[0,[2,"notify"]],[14,[" (method of ",[0,[2,"timer%"]],")"]]],["racket/gui/base","racket/gui"]],
["notify-box%",">unstable/gui-notify.html#(def._((lib._unstable/gui/notify..rkt)._notify-box~25))",[0,[2,"notify-box%"]],["unstable/gui/notify"]],
["notify-box/pref",">unstable/gui-notify.html#(def._((lib._unstable/gui/notify..rkt)._notify-box/pref))",[0,[2,"notify-box/pref"]],["unstable/gui/notify"]],
["notify-boxes",">unstable/gui-notify.html","Notify-boxes",false],
["notify-on-change",">gui/style-list_.html#(meth._(((lib._racket/snip..rkt)._style-list~25)._notify-on-change))",[[0,[2,"notify-on-change"]],[14,[" (method of ",[0,[2,"style-list%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["notimes",">scribble/SIGPLAN_Paper_Format.html#(form._((lib._scribble/sigplan..rkt)._notimes))",[0,[1,"notimes"]],["scribble/sigplan"]],
["nth",">gui/editor-data-class-list___.html#(meth._(((lib._mred/main..rkt)._editor-data-class-list~3c~25~3e)._nth))",[[0,[2,"nth"]],[14,[" (method of ",[0,[2,"editor-data-class-list<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["nth",">gui/snip-class-list___.html#(meth._(((lib._racket/snip..rkt)._snip-class-list~3c~25~3e)._nth))",[[0,[2,"nth"]],[14,[" (method of ",[0,[2,"snip-class-list<%>"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["nul",">reference/windowspaths.html#(idx._(gentag._239._(lib._scribblings/reference/reference..scrbl)))",[6,"\"NUL\""],false],
["null",">reference/pairs.html#(def._((quote._~23~25kernel)._null))",[0,[2,"null"]],["racket/base","racket"]],
["null",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._null))",[0,[2,"null"]],["lang/htdp-advanced"]],
["null",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._null))",[0,[2,"null"]],["lang/htdp-beginner"]],
["null",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._null))",[0,[2,"null"]],["lang/htdp-beginner-abbr"]],
["null",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._null))",[0,[2,"null"]],["lang/htdp-intermediate"]],
["null",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._null))",[0,[2,"null"]],["lang/htdp-intermediate-lambda"]],
["null",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Null))",[0,[1,"Null"]],["typed/racket/base","typed/racket"]],
["null-environment",">r5rs-std/r5rs-Z-H-9.html#%_idx_604",[0,[2,"null-environment"]],["r5rs"]],
["null-environment",">r6rs-lib-std/r6rs-lib-Z-H-20.html#node_idx_1306",[0,[2,"null-environment"]],["rnrs/r5rs-6"]],
["null-list?",">srfi-std/srfi-1.html#null-list-p",[0,[2,"null-list?"]],["srfi/1"]],
["null?",">reference/pairs.html#(def._((quote._~23~25kernel)._null~3f))",[0,[2,"null?"]],["racket/base","racket"]],
["null?",">r5rs-std/r5rs-Z-H-9.html#%_idx_428",[0,[2,"null?"]],["r5rs"]],
["null?",">r6rs-std/r6rs-Z-H-14.html#node_idx_624",[0,[2,"null?"]],["rnrs/base-6"]],
["null?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._null~3f))",[0,[2,"null?"]],["lang/htdp-advanced"]],
["null?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._null~3f))",[0,[2,"null?"]],["lang/htdp-beginner"]],
["null?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._null~3f))",[0,[2,"null?"]],["lang/htdp-beginner-abbr"]],
["null?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._null~3f))",[0,[2,"null?"]],["lang/htdp-intermediate"]],
["null?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._null~3f))",[0,[2,"null?"]],["lang/htdp-intermediate-lambda"]],
["null?",">srfi-std/srfi-1.html#null-p",[0,[2,"null?"]],["srfi/1"]],
["nullset",">unstable/Automata__Compiling_State_Machines.html#(form._((lib._unstable/automata/re..rkt)._nullset))",[0,[1,"nullset"]],["unstable/automata/re"]],
["num-scroll-lines",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._num-scroll-lines))",[[0,[2,"num-scroll-lines"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["number",">gui/editor-data-class-list___.html#(meth._(((lib._mred/main..rkt)._editor-data-class-list~3c~25~3e)._number))",[[0,[2,"number"]],[14,[" (method of ",[0,[2,"editor-data-class-list<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["number",">gui/snip-class-list___.html#(meth._(((lib._racket/snip..rkt)._snip-class-list~3c~25~3e)._number))",[[0,[2,"number"]],[14,[" (method of ",[0,[2,"snip-class-list<%>"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["number",">gui/style-list_.html#(meth._(((lib._racket/snip..rkt)._style-list~25)._number))",[[0,[2,"number"]],[14,[" (method of ",[0,[2,"style-list%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["number",">deinprogramm/Signaturen.html#(form._((lib._deinprogramm/.D.Md.A..rkt)._number))",[0,[1,"number"]],["deinprogramm/DMdA-beginner"]],
["number",">syntax/Library_Syntax_Classes_and_Literal_Sets.html#(form._((lib._syntax/parse..rkt)._number))",[0,[1,"number"]],["syntax/parse"]],
["number",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Number))",[0,[1,"Number"]],["typed/racket/base","typed/racket"]],
["number",">redex/The_Redex_Reference.html#(tech._number)",[0,"number"],false],
["number",">guide/numbers.html#(tech._number)","<span style=\"font-style: italic\">number</span>",false],
["number comparison",">reference/generic-numbers.html#(part._.Number_.Comparison)","Number Comparison",false],
["number snip",">framework/Number_Snip.html","Number Snip",false],
["number types",">reference/number-types.html","Number Types",false],
["number--string conversions",">reference/generic-numbers.html#(part._.Number--.String_.Conversions)","Number&ndash;String Conversions",false],
["number->com-currency",">mysterx/com-types.html#(def._((lib._mysterx/main..rkt)._number-~3ecom-currency))",[0,[2,"number->com-currency"]],["mysterx"]],
["number->com-scode",">mysterx/com-types.html#(def._((lib._mysterx/main..rkt)._number-~3ecom-scode))",[0,[2,"number->com-scode"]],["mysterx"]],
["number->ord",">htdp/index.html#(def._((lib._htdp/error..rkt)._number-~3eord))",[0,[2,"number->ord"]],["htdp/error"]],
["number->string",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._number-~3estring))",[0,[2,"number->string"]],["racket/base","racket"]],
["number->string",">r5rs-std/r5rs-Z-H-9.html#%_idx_366",[0,[2,"number->string"]],["r5rs"]],
["number->string",">r6rs-std/r6rs-Z-H-14.html#node_idx_578",[0,[2,"number->string"]],["rnrs/base-6"]],
["number->string",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._number-~3estring))",[0,[2,"number->string"]],["lang/htdp-advanced"]],
["number->string",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._number-~3estring))",[0,[2,"number->string"]],["lang/htdp-beginner"]],
["number->string",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._number-~3estring))",[0,[2,"number->string"]],["lang/htdp-beginner-abbr"]],
["number->string",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._number-~3estring))",[0,[2,"number->string"]],["lang/htdp-intermediate"]],
["number->string",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._number-~3estring))",[0,[2,"number->string"]],["lang/htdp-intermediate-lambda"]],
["number->string",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._number-~3estring))",[0,[2,"number->string"]],["deinprogramm/DMdA-advanced"]],
["number->string",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._number-~3estring))",[0,[2,"number->string"]],["deinprogramm/DMdA-assignments"]],
["number->string",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._number-~3estring))",[0,[2,"number->string"]],["deinprogramm/DMdA-beginner"]],
["number->string",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._number-~3estring))",[0,[2,"number->string"]],["deinprogramm/DMdA-vanilla"]],
["number-arg",">web-server/dispatch.html#(form._((lib._web-server/dispatch..rkt)._number-arg))",[0,[1,"number-arg"]],["web-server/dispatch"]],
["number-of-visible-items",">gui/list-box_.html#(meth._(((lib._mred/main..rkt)._list-box~25)._number-of-visible-items))",[[0,[2,"number-of-visible-items"]],[14,[" (method of ",[0,[2,"list-box%"]],")"]]],["racket/gui/base","racket/gui"]],
["number-snip:make-fraction-snip",">framework/Number_Snip.html#(def._((lib._framework/main..rkt)._number-snip~3amake-fraction-snip))",[0,[2,"number-snip:make-fraction-snip"]],["framework"]],
["number-snip:make-repeating-decimal-snip",">framework/Number_Snip.html#(def._((lib._framework/main..rkt)._number-snip~3amake-repeating-decimal-snip))",[0,[2,"number-snip:make-repeating-decimal-snip"]],["framework"]],
["number-snip:snip-class%",">framework/Number_Snip.html#(def._((lib._framework/main..rkt)._number-snip~3asnip-class~25))",[0,[2,"number-snip:snip-class%"]],["framework"]],
["number-style",">scriblib/autobib.html#(def._((lib._scriblib/autobib..rkt)._number-style))",[0,[2,"number-style"]],["scriblib/autobib"]],
["number?",">reference/number-types.html#(def._((quote._~23~25kernel)._number~3f))",[0,[2,"number?"]],["racket/base","racket"]],
["number?",">r5rs-std/r5rs-Z-H-9.html#%_idx_244",[0,[2,"number?"]],["r5rs"]],
["number?",">r6rs-std/r6rs-Z-H-14.html#node_idx_440",[0,[2,"number?"]],["rnrs/base-6"]],
["number?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._number~3f))",[0,[2,"number?"]],["lang/htdp-advanced"]],
["number?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._number~3f))",[0,[2,"number?"]],["lang/htdp-beginner"]],
["number?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._number~3f))",[0,[2,"number?"]],["lang/htdp-beginner-abbr"]],
["number?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._number~3f))",[0,[2,"number?"]],["lang/htdp-intermediate"]],
["number?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._number~3f))",[0,[2,"number?"]],["lang/htdp-intermediate-lambda"]],
["number?",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._number~3f))",[0,[2,"number?"]],["deinprogramm/DMdA-advanced"]],
["number?",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._number~3f))",[0,[2,"number?"]],["deinprogramm/DMdA-assignments"]],
["number?",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._number~3f))",[0,[2,"number?"]],["deinprogramm/DMdA-beginner"]],
["number?",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._number~3f))",[0,[2,"number?"]],["deinprogramm/DMdA-vanilla"]],
["number?",">plai/mutator.html#(form._((lib._plai/mutator..rkt)._number~3f))",[0,[2,"number?"]],["plai/mutator"]],
["numbers parsing",">reference/reader.html#(idx._(gentag._9._(lib._scribblings/reference/reference..scrbl)))","numbers, parsing",false],
["numbers machine representations",">reference/generic-numbers.html#(idx._(gentag._108._(lib._scribblings/reference/reference..scrbl)))","numbers, machine representations",false],
["numbers little-endian",">reference/generic-numbers.html#(idx._(gentag._105._(lib._scribblings/reference/reference..scrbl)))","numbers, little-endian",false],
["numbers floating-point",">reference/generic-numbers.html#(idx._(gentag._107._(lib._scribblings/reference/reference..scrbl)))","numbers, floating-point",false],
["numbers converting",">reference/generic-numbers.html#(idx._(gentag._104._(lib._scribblings/reference/reference..scrbl)))","numbers, converting",false],
["numbers big-endian",">reference/generic-numbers.html#(idx._(gentag._106._(lib._scribblings/reference/reference..scrbl)))","numbers, big-endian",false],
["numbers",">guide/numbers.html","Numbers",false],
["numbers",">reference/numbers.html","Numbers",false],
["numbers",">reference/numbers.html#(tech._number)","<span style=\"font-style: italic\">numbers</span>",false],
["numbers (relaxed conditions)",">htdp-langs/advanced.html#(part._htdp-advanced._.Numbers__relaxed_conditions_)","Numbers (relaxed conditions)",false],
["numbers (relaxed conditions)",">htdp-langs/intermediate.html#(part._htdp-intermediate._.Numbers__relaxed_conditions_)","Numbers (relaxed conditions)",false],
["numbers (relaxed conditions)",">htdp-langs/intermediate-lam.html#(part._htdp-intermediate-lambda._.Numbers__relaxed_conditions_)","Numbers (relaxed conditions)",false],
["numbers: integers, rationals, reals, complex, exacts, inexacts",">htdp-langs/advanced.html#(part._htdp-advanced._.Numbers__.Integers__.Rationals__.Reals__.Complex__.Exacts__.Inexacts)","Numbers: Integers, Rationals, Reals, Complex, Exacts, Inexacts",false],
["numbers: integers, rationals, reals, complex, exacts, inexacts",">htdp-langs/beginner.html#(part._htdp-beginner._.Numbers__.Integers__.Rationals__.Reals__.Complex__.Exacts__.Inexacts)","Numbers: Integers, Rationals, Reals, Complex, Exacts, Inexacts",false],
["numbers: integers, rationals, reals, complex, exacts, inexacts",">htdp-langs/beginner-abbr.html#(part._htdp-beginner-abbr._.Numbers__.Integers__.Rationals__.Reals__.Complex__.Exacts__.Inexacts)","Numbers: Integers, Rationals, Reals, Complex, Exacts, Inexacts",false],
["numbers: integers, rationals, reals, complex, exacts, inexacts",">htdp-langs/intermediate.html#(part._htdp-intermediate._.Numbers__.Integers__.Rationals__.Reals__.Complex__.Exacts__.Inexacts)","Numbers: Integers, Rationals, Reals, Complex, Exacts, Inexacts",false],
["numbers: integers, rationals, reals, complex, exacts, inexacts",">htdp-langs/intermediate-lam.html#(part._htdp-intermediate-lambda._.Numbers__.Integers__.Rationals__.Reals__.Complex__.Exacts__.Inexacts)","Numbers: Integers, Rationals, Reals, Complex, Exacts, Inexacts",false],
["numerator",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._numerator))",[0,[2,"numerator"]],["racket/base","racket"]],
["numerator",">r5rs-std/r5rs-Z-H-9.html#%_idx_310",[0,[2,"numerator"]],["r5rs"]],
["numerator",">r6rs-std/r6rs-Z-H-14.html#node_idx_524",[0,[2,"numerator"]],["rnrs/base-6"]],
["numerator",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._numerator))",[0,[2,"numerator"]],["lang/htdp-advanced"]],
["numerator",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._numerator))",[0,[2,"numerator"]],["lang/htdp-beginner"]],
["numerator",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._numerator))",[0,[2,"numerator"]],["lang/htdp-beginner-abbr"]],
["numerator",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._numerator))",[0,[2,"numerator"]],["lang/htdp-intermediate"]],
["numerator",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._numerator))",[0,[2,"numerator"]],["lang/htdp-intermediate-lambda"]],
["numerator",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._numerator))",[0,[2,"numerator"]],["deinprogramm/DMdA-advanced"]],
["numerator",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._numerator))",[0,[2,"numerator"]],["deinprogramm/DMdA-assignments"]],
["numerator",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._numerator))",[0,[2,"numerator"]],["deinprogramm/DMdA-beginner"]],
["numerator",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._numerator))",[0,[2,"numerator"]],["deinprogramm/DMdA-vanilla"]],
["numeric",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex..rkt)._numeric))",[0,[1,"numeric"]],["parser-tools/lex"]],
["numeric predicates",">racklog/glossary.html#(part._.Numeric_.Predicates)","Numeric Predicates",false],
["numeric types",">foreign/Numeric_Types.html","Numeric Types",false],
["numeric types",">ts-reference/type-ref.html#(part._.Numeric_.Types)","Numeric Types",false],
["numeric types",">ts-guide/optimization.html#(part._.Numeric_types)","Numeric types",false],
["numlock",">gui/key-event_.html#(idx._(gentag._104._(lib._scribblings/gui/gui..scrbl)))",[7,"'numlock"],false],
["numpad-enter",">gui/key-event_.html#(idx._(gentag._73._(lib._scribblings/gui/gui..scrbl)))",[7,"'numpad-enter"],false],
["numpad0",">gui/key-event_.html#(idx._(gentag._63._(lib._scribblings/gui/gui..scrbl)))",[7,"'numpad0"],false],
["numpad1",">gui/key-event_.html#(idx._(gentag._64._(lib._scribblings/gui/gui..scrbl)))",[7,"'numpad1"],false],
["numpad2",">gui/key-event_.html#(idx._(gentag._65._(lib._scribblings/gui/gui..scrbl)))",[7,"'numpad2"],false],
["numpad3",">gui/key-event_.html#(idx._(gentag._66._(lib._scribblings/gui/gui..scrbl)))",[7,"'numpad3"],false],
["numpad4",">gui/key-event_.html#(idx._(gentag._67._(lib._scribblings/gui/gui..scrbl)))",[7,"'numpad4"],false],
["numpad5",">gui/key-event_.html#(idx._(gentag._68._(lib._scribblings/gui/gui..scrbl)))",[7,"'numpad5"],false],
["numpad6",">gui/key-event_.html#(idx._(gentag._69._(lib._scribblings/gui/gui..scrbl)))",[7,"'numpad6"],false],
["numpad7",">gui/key-event_.html#(idx._(gentag._70._(lib._scribblings/gui/gui..scrbl)))",[7,"'numpad7"],false],
["numpad8",">gui/key-event_.html#(idx._(gentag._71._(lib._scribblings/gui/gui..scrbl)))",[7,"'numpad8"],false],
["numpad9",">gui/key-event_.html#(idx._(gentag._72._(lib._scribblings/gui/gui..scrbl)))",[7,"'numpad9"],false],
["nw:rectangle",">teachpack/image.html#(def._((lib._htdp/image..rkt)._nw~3arectangle))",[0,[2,"nw:rectangle"]],["htdp/image"]],
["o",">redex/The_Redex_Reference.html#(form._((lib._redex/reduction-semantics..rkt)._.O))",[0,[1,"O"]],["redex/reduction-semantics","redex"]],
["o-bullet",">slideshow/Constants_and_Layout_Variables.html#(def._((lib._slideshow/base..rkt)._o-bullet))",[0,[2,"o-bullet"]],["slideshow/base","slideshow"]],
["objc-is-a?",">foreign/Objective-C_FFI.html#(def._((lib._ffi/unsafe/objc..rkt)._objc-is-a~3f))",[0,[2,"objc-is-a?"]],["ffi/unsafe/objc"]],
["objc-unsafe!",">foreign/Objective-C_FFI.html#(form._((lib._ffi/objc..rkt)._objc-unsafe!))",[0,[1,"objc-unsafe!"]],["ffi/objc"]],
["objc_allocateclasspair",">foreign/Objective-C_FFI.html#(def._((lib._ffi/unsafe/objc..rkt)._objc_allocate.Class.Pair))",[0,[2,"objc_allocateClassPair"]],["ffi/unsafe/objc"]],
["objc_getprotocol",">foreign/Objective-C_FFI.html#(def._((lib._ffi/unsafe/objc..rkt)._objc_get.Protocol))",[0,[2,"objc_getProtocol"]],["ffi/unsafe/objc"]],
["objc_lookupclass",">foreign/Objective-C_FFI.html#(def._((lib._ffi/unsafe/objc..rkt)._objc_look.Up.Class))",[0,[2,"objc_lookUpClass"]],["ffi/unsafe/objc"]],
["objc_msgsend/typed",">foreign/Objective-C_FFI.html#(def._((lib._ffi/unsafe/objc..rkt)._objc_msg.Send/typed))",[0,[2,"objc_msgSend/typed"]],["ffi/unsafe/objc"]],
["objc_msgsendsuper/typed",">foreign/Objective-C_FFI.html#(def._((lib._ffi/unsafe/objc..rkt)._objc_msg.Send.Super/typed))",[0,[2,"objc_msgSendSuper/typed"]],["ffi/unsafe/objc"]],
["objc_registerclasspair",">foreign/Objective-C_FFI.html#(def._((lib._ffi/unsafe/objc..rkt)._objc_register.Class.Pair))",[0,[2,"objc_registerClassPair"]],["ffi/unsafe/objc"]],
["object",">html/index.html#(def._((lib._html/main..rkt)._object))",[0,[2,"object"]],["html"]],
["object",">unstable/match.html#(form._((lib._unstable/match..rkt)._object))",[0,[1,"object"]],["unstable/match"]],
["object and class contracts",">reference/Object_and_Class_Contracts.html","Object and Class Contracts",false],
["object equality and hashing",">reference/objectequality.html","Object Equality and Hashing",false],
["object identity and comparisons",">reference/eval-model.html#(part._model-eq)","Object Identity and Comparisons",false],
["object printing",">reference/objectprinting.html","Object Printing",false],
["object serialization",">reference/objectserialize.html","Object Serialization",false],
["object%",">reference/createclass.html#(def._((lib._racket/private/class-internal..rkt)._object~25))",[0,[2,"object%"]],["racket/class","racket"]],
["object, class, and interface utilities",">reference/objectutils.html","Object, Class, and Interface Utilities",false],
["object->vector",">reference/objectutils.html#(def._((lib._racket/private/class-internal..rkt)._object-~3evector))",[0,[2,"object->vector"]],["racket/class","racket"]],
["object-contract",">reference/Object_and_Class_Contracts.html#(form._((lib._racket/class..rkt)._object-contract))",[0,[1,"object-contract"]],["racket/class","racket"]],
["object-contract",">mzlib/mzlib_contract.html#(form._((lib._mzlib/contract..rkt)._object-contract))",[0,[1,"object-contract"]],["mzlib/contract"]],
["object-info",">reference/objectutils.html#(def._((lib._racket/private/class-internal..rkt)._object-info))",[0,[2,"object-info"]],["racket/class","racket"]],
["object-interface",">reference/objectutils.html#(def._((lib._racket/private/class-internal..rkt)._object-interface))",[0,[2,"object-interface"]],["racket/class","racket"]],
["object-method-arity-includes?",">reference/objectutils.html#(def._((lib._racket/private/class-internal..rkt)._object-method-arity-includes~3f))",[0,[2,"object-method-arity-includes?"]],["racket/class","racket"]],
["object-name",">reference/inspectors.html#(def._((quote._~23~25kernel)._object-name))",[0,[2,"object-name"]],["racket/base","racket"]],
["object/c",">reference/Object_and_Class_Contracts.html#(form._((lib._racket/private/class-internal..rkt)._object/c))",[0,[1,"object/c"]],["racket/class","racket"]],
["object=?",">reference/objectutils.html#(def._((lib._racket/private/class-internal..rkt)._object~3d~3f))",[0,[2,"object=?"]],["racket/class","racket"]],
["object?",">reference/objectutils.html#(def._((lib._racket/private/class-internal..rkt)._object~3f))",[0,[2,"object?"]],["racket/class","racket"]],
["object?",">html/index.html#(def._((lib._html/main..rkt)._object~3f))",[0,[2,"object?"]],["html"]],
["object_getclass",">foreign/Objective-C_FFI.html#(def._((lib._ffi/unsafe/objc..rkt)._object_get.Class))",[0,[2,"object_getClass"]],["ffi/unsafe/objc"]],
["object_getinstancevariable",">foreign/Objective-C_FFI.html#(def._((lib._ffi/unsafe/objc..rkt)._object_get.Instance.Variable))",[0,[2,"object_getInstanceVariable"]],["ffi/unsafe/objc"]],
["object_setinstancevariable",">foreign/Objective-C_FFI.html#(def._((lib._ffi/unsafe/objc..rkt)._object_set.Instance.Variable))",[0,[2,"object_setInstanceVariable"]],["ffi/unsafe/objc"]],
["objective-c ffi",">foreign/Objective-C_FFI.html","Objective-C FFI",false],
["objects",">quick/index.html#(part._.Objects)","Objects",false],
["objects",">reference/eval-model.html#(tech._object)","<span style=\"font-style: italic\">objects</span>",false],
["objects and imperative update",">reference/eval-model.html#(part._.Objects_and_.Imperative_.Update)","Objects and Imperative Update",false],
["obligation information in check syntax",">reference/Building_New_Contract_Combinators.html#(part._.Obligation_.Information_in_.Check_.Syntax)","Obligation Information in Check Syntax",false],
["obtaining com interface references",">foreign/com-intf.html#(part._.Obtaining_.C.O.M_.Interface_.References)","Obtaining COM Interface References",false],
["occurs check",">racklog/unification.html#(tech._occurs._check)","<span style=\"font-style: italic\">occurs check</span>",false],
["octet",">deinprogramm/image.html#(def._((lib._deinprogramm/image..rkt)._octet))",[0,[2,"octet"]],["teachpack/deinprogramm/image"]],
["odbc",">db/index.html#(idx._(gentag._4._(lib._db/scribblings/db..scrbl)))","ODBC",false],
["odbc requirements",">db/notes.html#(part._odbc-requirements)","ODBC Requirements",false],
["odbc status",">db/notes.html#(part._odbc-status)","ODBC Status",false],
["odbc types",">db/sql-types.html#(part._odbc-types)","ODBC Types",false],
["odbc-connect",">db/connect.html#(def._((lib._db/main..rkt)._odbc-connect))",[0,[2,"odbc-connect"]],["db"]],
["odbc-data-source",">db/connect.html#(def._((lib._db/base..rkt)._odbc-data-source))",[0,[2,"odbc-data-source"]],["db","db/base"]],
["odbc-data-sources",">db/connect.html#(def._((lib._db/main..rkt)._odbc-data-sources))",[0,[2,"odbc-data-sources"]],["db"]],
["odbc-driver-connect",">db/connect.html#(def._((lib._db/main..rkt)._odbc-driver-connect))",[0,[2,"odbc-driver-connect"]],["db"]],
["odbc-drivers",">db/connect.html#(def._((lib._db/main..rkt)._odbc-drivers))",[0,[2,"odbc-drivers"]],["db"]],
["odd?",">reference/number-types.html#(def._((quote._~23~25kernel)._odd~3f))",[0,[2,"odd?"]],["racket/base","racket"]],
["odd?",">r5rs-std/r5rs-Z-H-9.html#%_idx_274",[0,[2,"odd?"]],["r5rs"]],
["odd?",">r6rs-std/r6rs-Z-H-14.html#node_idx_480",[0,[2,"odd?"]],["rnrs/base-6"]],
["odd?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._odd~3f))",[0,[2,"odd?"]],["lang/htdp-advanced"]],
["odd?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._odd~3f))",[0,[2,"odd?"]],["lang/htdp-beginner"]],
["odd?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._odd~3f))",[0,[2,"odd?"]],["lang/htdp-beginner-abbr"]],
["odd?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._odd~3f))",[0,[2,"odd?"]],["lang/htdp-intermediate"]],
["odd?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._odd~3f))",[0,[2,"odd?"]],["lang/htdp-intermediate-lambda"]],
["odd?",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._odd~3f))",[0,[2,"odd?"]],["deinprogramm/DMdA-advanced"]],
["odd?",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._odd~3f))",[0,[2,"odd?"]],["deinprogramm/DMdA-assignments"]],
["odd?",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._odd~3f))",[0,[2,"odd?"]],["deinprogramm/DMdA-beginner"]],
["odd?",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._odd~3f))",[0,[2,"odd?"]],["deinprogramm/DMdA-vanilla"]],
["odd?",">plai/mutator.html#(form._((lib._plai/mutator..rkt)._odd~3f))",[0,[2,"odd?"]],["plai/mutator"]],
["offset-ptr?",">foreign/foreign_pointer-funcs.html#(def._((quote._~23~25foreign)._offset-ptr~3f))",[0,[2,"offset-ptr?"]],["ffi/unsafe"]],
["ok?",">draw/bitmap_.html#(meth._(((lib._racket/draw..rkt)._bitmap~25)._ok~3f))",[[0,[2,"ok?"]],[14,[" (method of ",[0,[2,"bitmap%"]],")"]]],["racket/draw"]],
["ok?",">draw/color_.html#(meth._(((lib._racket/draw..rkt)._color~25)._ok~3f))",[[0,[2,"ok?"]],[14,[" (method of ",[0,[2,"color%"]],")"]]],["racket/draw"]],
["ok?",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._ok~3f))",[[0,[2,"ok?"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["ok?",">draw/gl-context___.html#(meth._(((lib._racket/draw..rkt)._gl-context~3c~25~3e)._ok~3f))",[[0,[2,"ok?"]],[14,[" (method of ",[0,[2,"gl-context<%>"]],")"]]],["racket/draw"]],
["ok?",">gui/cursor_.html#(meth._(((lib._mred/main..rkt)._cursor~25)._ok~3f))",[[0,[2,"ok?"]],[14,[" (method of ",[0,[2,"cursor%"]],")"]]],["racket/gui/base","racket/gui"]],
["ok?",">gui/editor-stream-in_.html#(meth._(((lib._mred/main..rkt)._editor-stream-in~25)._ok~3f))",[[0,[2,"ok?"]],[14,[" (method of ",[0,[2,"editor-stream-in%"]],")"]]],["racket/gui/base","racket/gui"]],
["ok?",">gui/editor-stream-out_.html#(meth._(((lib._mred/main..rkt)._editor-stream-out~25)._ok~3f))",[[0,[2,"ok?"]],[14,[" (method of ",[0,[2,"editor-stream-out%"]],")"]]],["racket/gui/base","racket/gui"]],
["ol",">html/index.html#(def._((lib._html/main..rkt)._ol))",[0,[2,"ol"]],["html"]],
["ol?",">html/index.html#(def._((lib._html/main..rkt)._ol~3f))",[0,[2,"ol?"]],["html"]],
["old functions",">mzscheme/Old_Functions.html","Old Functions",false],
["old syntactic forms",">mzscheme/Old_Syntactic_Forms.html","Old Syntactic Forms",false],
["omitable-paragraph?",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._omitable-paragraph~3f))",[0,[2,"omitable-paragraph?"]],["scribble/struct"]],
["omitted forms and functions",">mzscheme/Omitted_Forms_and_Functions.html","Omitted Forms and Functions",false],
["on-activate",">gui/top-level-window___.html#(meth._(((lib._mred/main..rkt)._top-level-window~3c~25~3e)._on-activate))",[[0,[2,"on-activate"]],[14,[" (method of ",[0,[2,"top-level-window<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["on-activate",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3aregister-group-mixin)._on-activate))",[[0,[2,"on-activate"]],[14,[" (method of ",[0,[2,"frame:register-group-mixin"]],")"]]],["framework"]],
["on-change",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._on-change))",[[0,[2,"on-change"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["on-change",">framework/Editor.html#(meth._(((lib._framework/main..rkt)._editor~3abackup-autosave-mixin)._on-change))",[[0,[2,"on-change"]],[14,[" (method of ",[0,[2,"editor:backup-autosave-mixin"]],")"]]],["framework"]],
["on-change",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3ahost-text-mixin)._on-change))",[[0,[2,"on-change"]],[14,[" (method of ",[0,[2,"mode:host-text-mixin"]],")"]]],["framework"]],
["on-change",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3asurrogate-text~25)._on-change))",[[0,[2,"on-change"]],[14,[" (method of ",[0,[2,"mode:surrogate-text%"]],")"]]],["framework"]],
["on-change-style",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._on-change-style))",[[0,[2,"on-change-style"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["on-change-style",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3ahost-text-mixin)._on-change-style))",[[0,[2,"on-change-style"]],[14,[" (method of ",[0,[2,"mode:host-text-mixin"]],")"]]],["framework"]],
["on-change-style",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3asurrogate-text~25)._on-change-style))",[[0,[2,"on-change-style"]],[14,[" (method of ",[0,[2,"mode:surrogate-text%"]],")"]]],["framework"]],
["on-char",">gui/canvas___.html#(meth._(((lib._mred/main..rkt)._canvas~3c~25~3e)._on-char))",[[0,[2,"on-char"]],[14,[" (method of ",[0,[2,"canvas<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["on-char",">gui/editor-canvas_.html#(meth._(((lib._mred/main..rkt)._editor-canvas~25)._on-char))",[[0,[2,"on-char"]],[14,[" (method of ",[0,[2,"editor-canvas%"]],")"]]],["racket/gui/base","racket/gui"]],
["on-char",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._on-char))",[[0,[2,"on-char"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["on-char",">gui/snip_.html#(meth._(((lib._racket/snip..rkt)._snip~25)._on-char))",[[0,[2,"on-char"]],[14,[" (method of ",[0,[2,"snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["on-char",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3ahost-text-mixin)._on-char))",[[0,[2,"on-char"]],[14,[" (method of ",[0,[2,"mode:host-text-mixin"]],")"]]],["framework"]],
["on-char",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3asurrogate-text~25)._on-char))",[[0,[2,"on-char"]],[14,[" (method of ",[0,[2,"mode:surrogate-text%"]],")"]]],["framework"]],
["on-char",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3aautocomplete-mixin)._on-char))",[[0,[2,"on-char"]],[14,[" (method of ",[0,[2,"text:autocomplete-mixin"]],")"]]],["framework"]],
["on-choose-directory",">mrlib/Name_Message.html#(meth._(((lib._mrlib/name-message..rkt)._name-message~25)._on-choose-directory))",[[0,[2,"on-choose-directory"]],[14,[" (method of ",[0,[2,"name-message%"]],")"]]],["mrlib/name-message"]],
["on-click",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..rkt)._hierarchical-list~25)._on-click))",[[0,[2,"on-click"]],[14,[" (method of ",[0,[2,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["on-click-always",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..rkt)._hierarchical-list~25)._on-click-always))",[[0,[2,"on-click-always"]],[14,[" (method of ",[0,[2,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["on-close",">gui/top-level-window___.html#(meth._(((lib._mred/main..rkt)._top-level-window~3c~25~3e)._on-close))",[[0,[2,"on-close"]],[14,[" (method of ",[0,[2,"top-level-window<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["on-close",">tools/drracket_rep.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3arep~3atext~25)._on-close))",[[0,[2,"on-close"]],[14,[" (method of ",[0,[2,"drracket:rep:text%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["on-close",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aframe~25)._on-close))",[[0,[2,"on-close"]],[14,[" (method of ",[0,[2,"drracket:unit:frame%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["on-close",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3atab~3c~25~3e)._on-close))",[[0,[2,"on-close"]],[14,[" (method of ",[0,[2,"drracket:unit:tab<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["on-close",">framework/Editor.html#(meth._(((lib._framework/main..rkt)._editor~3abackup-autosave-mixin)._on-close))",[[0,[2,"on-close"]],[14,[" (method of ",[0,[2,"editor:backup-autosave-mixin"]],")"]]],["framework"]],
["on-close",">framework/Editor.html#(meth._(((lib._framework/main..rkt)._editor~3abasic~3c~25~3e)._on-close))",[[0,[2,"on-close"]],[14,[" (method of ",[0,[2,"editor:basic<%>"]],")"]]],["framework"]],
["on-close",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3aeditor-mixin)._on-close))",[[0,[2,"on-close"]],[14,[" (method of ",[0,[2,"frame:editor-mixin"]],")"]]],["framework"]],
["on-close",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3afocus-table-mixin)._on-close))",[[0,[2,"on-close"]],[14,[" (method of ",[0,[2,"frame:focus-table-mixin"]],")"]]],["framework"]],
["on-close",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3ainfo-mixin)._on-close))",[[0,[2,"on-close"]],[14,[" (method of ",[0,[2,"frame:info-mixin"]],")"]]],["framework"]],
["on-close",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3aregister-group-mixin)._on-close))",[[0,[2,"on-close"]],[14,[" (method of ",[0,[2,"frame:register-group-mixin"]],")"]]],["framework"]],
["on-close",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3asearchable-mixin)._on-close))",[[0,[2,"on-close"]],[14,[" (method of ",[0,[2,"frame:searchable-mixin"]],")"]]],["framework"]],
["on-close",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus-mixin)._on-close))",[[0,[2,"on-close"]],[14,[" (method of ",[0,[2,"frame:standard-menus-mixin"]],")"]]],["framework"]],
["on-close",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astandard-menus~3c~25~3e)._on-close))",[[0,[2,"on-close"]],[14,[" (method of ",[0,[2,"frame:standard-menus<%>"]],")"]]],["framework"]],
["on-close",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3atext-info-mixin)._on-close))",[[0,[2,"on-close"]],[14,[" (method of ",[0,[2,"frame:text-info-mixin"]],")"]]],["framework"]],
["on-close-all",">framework/Group.html#(meth._(((lib._framework/main..rkt)._group~3a~25)._on-close-all))",[[0,[2,"on-close-all"]],[14,[" (method of ",[0,[2,"group:%"]],")"]]],["framework"]],
["on-default-char",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._on-default-char))",[[0,[2,"on-default-char"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["on-default-char",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._on-default-char))",[[0,[2,"on-default-char"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["on-default-char",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3ahost-text-mixin)._on-default-char))",[[0,[2,"on-default-char"]],[14,[" (method of ",[0,[2,"mode:host-text-mixin"]],")"]]],["framework"]],
["on-default-char",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3asurrogate-text~25)._on-default-char))",[[0,[2,"on-default-char"]],[14,[" (method of ",[0,[2,"mode:surrogate-text%"]],")"]]],["framework"]],
["on-default-char",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3ainput-box-mixin)._on-default-char))",[[0,[2,"on-default-char"]],[14,[" (method of ",[0,[2,"text:input-box-mixin"]],")"]]],["framework"]],
["on-default-event",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._on-default-event))",[[0,[2,"on-default-event"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["on-default-event",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._on-default-event))",[[0,[2,"on-default-event"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["on-default-event",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._on-default-event))",[[0,[2,"on-default-event"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["on-default-event",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3ahost-text-mixin)._on-default-event))",[[0,[2,"on-default-event"]],[14,[" (method of ",[0,[2,"mode:host-text-mixin"]],")"]]],["framework"]],
["on-default-event",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3asurrogate-text~25)._on-default-event))",[[0,[2,"on-default-event"]],[14,[" (method of ",[0,[2,"mode:surrogate-text%"]],")"]]],["framework"]],
["on-delete",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._on-delete))",[[0,[2,"on-delete"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["on-delete",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._on-delete))",[[0,[2,"on-delete"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["on-delete",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3ahost-text-mixin)._on-delete))",[[0,[2,"on-delete"]],[14,[" (method of ",[0,[2,"mode:host-text-mixin"]],")"]]],["framework"]],
["on-delete",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3asurrogate-text~25)._on-delete))",[[0,[2,"on-delete"]],[14,[" (method of ",[0,[2,"mode:surrogate-text%"]],")"]]],["framework"]],
["on-demand",">gui/labelled-menu-item___.html#(meth._(((lib._mred/main..rkt)._labelled-menu-item~3c~25~3e)._on-demand))",[[0,[2,"on-demand"]],[14,[" (method of ",[0,[2,"labelled-menu-item<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["on-demand",">gui/menu-item-container___.html#(meth._(((lib._mred/main..rkt)._menu-item-container~3c~25~3e)._on-demand))",[[0,[2,"on-demand"]],[14,[" (method of ",[0,[2,"menu-item-container<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["on-disable-surrogate",">framework/Color.html#(meth._(((lib._framework/main..rkt)._color~3atext-mode-mixin)._on-disable-surrogate))",[[0,[2,"on-disable-surrogate"]],[14,[" (method of ",[0,[2,"color:text-mode-mixin"]],")"]]],["framework"]],
["on-disable-surrogate",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3asurrogate-text~3c~25~3e)._on-disable-surrogate))",[[0,[2,"on-disable-surrogate"]],[14,[" (method of ",[0,[2,"mode:surrogate-text<%>"]],")"]]],["framework"]],
["on-disable-surrogate",">framework/Racket.html#(meth._(((lib._framework/main..rkt)._racket~3atext-mode-mixin)._on-disable-surrogate))",[[0,[2,"on-disable-surrogate"]],[14,[" (method of ",[0,[2,"racket:text-mode-mixin"]],")"]]],["framework"]],
["on-disconnect",">teachpack/2htdpuniverse.html#(form._((lib._2htdp/universe..rkt)._on-disconnect))",[0,[1,"on-disconnect"]],["2htdp/universe"]],
["on-display-size",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._on-display-size))",[[0,[2,"on-display-size"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["on-display-size",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3ahost-text-mixin)._on-display-size))",[[0,[2,"on-display-size"]],[14,[" (method of ",[0,[2,"mode:host-text-mixin"]],")"]]],["framework"]],
["on-display-size",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3asurrogate-text~25)._on-display-size))",[[0,[2,"on-display-size"]],[14,[" (method of ",[0,[2,"mode:surrogate-text%"]],")"]]],["framework"]],
["on-display-size",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3aports-mixin)._on-display-size))",[[0,[2,"on-display-size"]],[14,[" (method of ",[0,[2,"text:ports-mixin"]],")"]]],["framework"]],
["on-display-size-when-ready",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._on-display-size-when-ready))",[[0,[2,"on-display-size-when-ready"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["on-double-click",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._on-double-click))",[[0,[2,"on-double-click"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["on-double-select",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..rkt)._hierarchical-list~25)._on-double-select))",[[0,[2,"on-double-select"]],[14,[" (method of ",[0,[2,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["on-draw",">teachpack/2htdpuniverse.html#(form._((lib._2htdp/universe..rkt)._on-draw))",[0,[1,"on-draw"]],["2htdp/universe"]],
["on-drop-file",">gui/window___.html#(meth._(((lib._mred/main..rkt)._window~3c~25~3e)._on-drop-file))",[[0,[2,"on-drop-file"]],[14,[" (method of ",[0,[2,"window<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["on-drop-file",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3abasic-mixin)._on-drop-file))",[[0,[2,"on-drop-file"]],[14,[" (method of ",[0,[2,"frame:basic-mixin"]],")"]]],["framework"]],
["on-edit-sequence",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._on-edit-sequence))",[[0,[2,"on-edit-sequence"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["on-edit-sequence",">framework/Editor.html#(meth._(((lib._framework/main..rkt)._editor~3abasic-mixin)._on-edit-sequence))",[[0,[2,"on-edit-sequence"]],[14,[" (method of ",[0,[2,"editor:basic-mixin"]],")"]]],["framework"]],
["on-edit-sequence",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3ahost-text-mixin)._on-edit-sequence))",[[0,[2,"on-edit-sequence"]],[14,[" (method of ",[0,[2,"mode:host-text-mixin"]],")"]]],["framework"]],
["on-edit-sequence",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3asurrogate-text~25)._on-edit-sequence))",[[0,[2,"on-edit-sequence"]],[14,[" (method of ",[0,[2,"mode:surrogate-text%"]],")"]]],["framework"]],
["on-edit-sequence",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3adelegate-mixin)._on-edit-sequence))",[[0,[2,"on-edit-sequence"]],[14,[" (method of ",[0,[2,"text:delegate-mixin"]],")"]]],["framework"]],
["on-enable-surrogate",">framework/Color.html#(meth._(((lib._framework/main..rkt)._color~3atext-mode-mixin)._on-enable-surrogate))",[[0,[2,"on-enable-surrogate"]],[14,[" (method of ",[0,[2,"color:text-mode-mixin"]],")"]]],["framework"]],
["on-enable-surrogate",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3asurrogate-text~3c~25~3e)._on-enable-surrogate))",[[0,[2,"on-enable-surrogate"]],[14,[" (method of ",[0,[2,"mode:surrogate-text<%>"]],")"]]],["framework"]],
["on-enable-surrogate",">framework/Racket.html#(meth._(((lib._framework/main..rkt)._racket~3atext-mode-mixin)._on-enable-surrogate))",[[0,[2,"on-enable-surrogate"]],[14,[" (method of ",[0,[2,"racket:text-mode-mixin"]],")"]]],["framework"]],
["on-event",">gui/canvas___.html#(meth._(((lib._mred/main..rkt)._canvas~3c~25~3e)._on-event))",[[0,[2,"on-event"]],[14,[" (method of ",[0,[2,"canvas<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["on-event",">gui/editor-canvas_.html#(meth._(((lib._mred/main..rkt)._editor-canvas~25)._on-event))",[[0,[2,"on-event"]],[14,[" (method of ",[0,[2,"editor-canvas%"]],")"]]],["racket/gui/base","racket/gui"]],
["on-event",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._on-event))",[[0,[2,"on-event"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["on-event",">gui/snip_.html#(meth._(((lib._racket/snip..rkt)._snip~25)._on-event))",[[0,[2,"on-event"]],[14,[" (method of ",[0,[2,"snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["on-event",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3ahost-text-mixin)._on-event))",[[0,[2,"on-event"]],[14,[" (method of ",[0,[2,"mode:host-text-mixin"]],")"]]],["framework"]],
["on-event",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3asurrogate-text~25)._on-event))",[[0,[2,"on-event"]],[14,[" (method of ",[0,[2,"mode:surrogate-text%"]],")"]]],["framework"]],
["on-event",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3aautocomplete-mixin)._on-event))",[[0,[2,"on-event"]],[14,[" (method of ",[0,[2,"text:autocomplete-mixin"]],")"]]],["framework"]],
["on-event",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3afirst-line-mixin)._on-event))",[[0,[2,"on-event"]],[14,[" (method of ",[0,[2,"text:first-line-mixin"]],")"]]],["framework"]],
["on-event",">mrlib/Name_Message.html#(meth._(((lib._mrlib/name-message..rkt)._name-message~25)._on-event))",[[0,[2,"on-event"]],[14,[" (method of ",[0,[2,"name-message%"]],")"]]],["mrlib/name-message"]],
["on-execute",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3alanguage~3c~25~3e)._on-execute))",[[0,[2,"on-execute"]],[14,[" (method of ",[0,[2,"drracket:language:language<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["on-execute",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3amodule-based-language-~3elanguage-mixin)._on-execute))",[[0,[2,"on-execute"]],[14,[" (method of ",[0,[2,"drracket:language:module-based-language->language-mixin"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["on-execute",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3amodule-based-language~3c~25~3e)._on-execute))",[[0,[2,"on-execute"]],[14,[" (method of ",[0,[2,"drracket:language:module-based-language<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["on-execute",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3asimple-module-based-language-~3emodule-based-language-mixin)._on-execute))",[[0,[2,"on-execute"]],[14,[" (method of ",[0,[2,"drracket:language:simple-module-based-language->module-based-language-mixin"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["on-execute",">tools/drracket_rep.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3arep~3atext~25)._on-execute))",[[0,[2,"on-execute"]],[14,[" (method of ",[0,[2,"drracket:rep:text%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["on-exit",">gui/top-level-window___.html#(meth._(((lib._mred/main..rkt)._top-level-window~3c~25~3e)._on-exit))",[[0,[2,"on-exit"]],[14,[" (method of ",[0,[2,"top-level-window<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["on-exit",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3abasic-mixin)._on-exit))",[[0,[2,"on-exit"]],[14,[" (method of ",[0,[2,"frame:basic-mixin"]],")"]]],["framework"]],
["on-focus",">gui/editor-canvas_.html#(meth._(((lib._mred/main..rkt)._editor-canvas~25)._on-focus))",[[0,[2,"on-focus"]],[14,[" (method of ",[0,[2,"editor-canvas%"]],")"]]],["racket/gui/base","racket/gui"]],
["on-focus",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._on-focus))",[[0,[2,"on-focus"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["on-focus",">gui/window___.html#(meth._(((lib._mred/main..rkt)._window~3c~25~3e)._on-focus))",[[0,[2,"on-focus"]],[14,[" (method of ",[0,[2,"window<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["on-focus",">framework/Canvas.html#(meth._(((lib._framework/main..rkt)._canvas~3ainfo-mixin)._on-focus))",[[0,[2,"on-focus"]],[14,[" (method of ",[0,[2,"canvas:info-mixin"]],")"]]],["framework"]],
["on-focus",">framework/Color.html#(meth._(((lib._framework/main..rkt)._color~3atext-mixin)._on-focus))",[[0,[2,"on-focus"]],[14,[" (method of ",[0,[2,"color:text-mixin"]],")"]]],["framework"]],
["on-focus",">framework/Editor.html#(meth._(((lib._framework/main..rkt)._editor~3abasic-mixin)._on-focus))",[[0,[2,"on-focus"]],[14,[" (method of ",[0,[2,"editor:basic-mixin"]],")"]]],["framework"]],
["on-focus",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3ahost-text-mixin)._on-focus))",[[0,[2,"on-focus"]],[14,[" (method of ",[0,[2,"mode:host-text-mixin"]],")"]]],["framework"]],
["on-focus",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3asurrogate-text~25)._on-focus))",[[0,[2,"on-focus"]],[14,[" (method of ",[0,[2,"mode:surrogate-text%"]],")"]]],["framework"]],
["on-focus",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3asearching-mixin)._on-focus))",[[0,[2,"on-focus"]],[14,[" (method of ",[0,[2,"text:searching-mixin"]],")"]]],["framework"]],
["on-insert",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._on-insert))",[[0,[2,"on-insert"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["on-insert",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._on-insert))",[[0,[2,"on-insert"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["on-insert",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3ahost-text-mixin)._on-insert))",[[0,[2,"on-insert"]],[14,[" (method of ",[0,[2,"mode:host-text-mixin"]],")"]]],["framework"]],
["on-insert",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3asurrogate-text~25)._on-insert))",[[0,[2,"on-insert"]],[14,[" (method of ",[0,[2,"mode:surrogate-text%"]],")"]]],["framework"]],
["on-insert",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3abasic-mixin)._on-insert))",[[0,[2,"on-insert"]],[14,[" (method of ",[0,[2,"text:basic-mixin"]],")"]]],["framework"]],
["on-insert",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3anbsp-~3espace-mixin)._on-insert))",[[0,[2,"on-insert"]],[14,[" (method of ",[0,[2,"text:nbsp->space-mixin"]],")"]]],["framework"]],
["on-insert",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3anormalize-paste-mixin)._on-insert))",[[0,[2,"on-insert"]],[14,[" (method of ",[0,[2,"text:normalize-paste-mixin"]],")"]]],["framework"]],
["on-installer-run",">raco/_plt-archives.html#(def._((lib._setup/plt-installer..rkt)._on-installer-run))",[0,[2,"on-installer-run"]],["setup/plt-installer"]],
["on-interactive-move",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._on-interactive-move))",[[0,[2,"on-interactive-move"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["on-interactive-resize",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._on-interactive-resize))",[[0,[2,"on-interactive-resize"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["on-item-closed",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..rkt)._hierarchical-list~25)._on-item-closed))",[[0,[2,"on-item-closed"]],[14,[" (method of ",[0,[2,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["on-item-opened",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..rkt)._hierarchical-list~25)._on-item-opened))",[[0,[2,"on-item-opened"]],[14,[" (method of ",[0,[2,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["on-key",">teachpack/2htdpuniverse.html#(form._((lib._2htdp/universe..rkt)._on-key))",[0,[1,"on-key"]],["2htdp/universe"]],
["on-key-event",">teachpack/draw.html#(def._((lib._htdp/big-draw..rkt)._on-key-event))",[0,[2,"on-key-event"]],["htdp/draw"]],
["on-key-event",">teachpack/world.html#(def._((lib._htdp/world..rkt)._on-key-event))",[0,[2,"on-key-event"]],["htdp/world"]],
["on-key-event",">deinprogramm/world.html#(def._((lib._deinprogramm/world..rkt)._on-key-event))",[0,[2,"on-key-event"]],["teachpack/deinprogramm/world"]],
["on-lexer-valid",">framework/Color.html#(meth._(((lib._framework/main..rkt)._color~3atext~3c~25~3e)._on-lexer-valid))",[[0,[2,"on-lexer-valid"]],[14,[" (method of ",[0,[2,"color:text<%>"]],")"]]],["framework"]],
["on-load-file",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._on-load-file))",[[0,[2,"on-load-file"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["on-load-file",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3ahost-text-mixin)._on-load-file))",[[0,[2,"on-load-file"]],[14,[" (method of ",[0,[2,"mode:host-text-mixin"]],")"]]],["framework"]],
["on-load-file",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3asurrogate-text~25)._on-load-file))",[[0,[2,"on-load-file"]],[14,[" (method of ",[0,[2,"mode:surrogate-text%"]],")"]]],["framework"]],
["on-load-file",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3adelegate-mixin)._on-load-file))",[[0,[2,"on-load-file"]],[14,[" (method of ",[0,[2,"text:delegate-mixin"]],")"]]],["framework"]],
["on-local-char",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._on-local-char))",[[0,[2,"on-local-char"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["on-local-char",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3ahost-text-mixin)._on-local-char))",[[0,[2,"on-local-char"]],[14,[" (method of ",[0,[2,"mode:host-text-mixin"]],")"]]],["framework"]],
["on-local-char",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3asurrogate-text~25)._on-local-char))",[[0,[2,"on-local-char"]],[14,[" (method of ",[0,[2,"mode:surrogate-text%"]],")"]]],["framework"]],
["on-local-char",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3aports-mixin)._on-local-char))",[[0,[2,"on-local-char"]],[14,[" (method of ",[0,[2,"text:ports-mixin"]],")"]]],["framework"]],
["on-local-char",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3areturn-mixin)._on-local-char))",[[0,[2,"on-local-char"]],[14,[" (method of ",[0,[2,"text:return-mixin"]],")"]]],["framework"]],
["on-local-event",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._on-local-event))",[[0,[2,"on-local-event"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["on-local-event",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3ahost-text-mixin)._on-local-event))",[[0,[2,"on-local-event"]],[14,[" (method of ",[0,[2,"mode:host-text-mixin"]],")"]]],["framework"]],
["on-local-event",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3asurrogate-text~25)._on-local-event))",[[0,[2,"on-local-event"]],[14,[" (method of ",[0,[2,"mode:surrogate-text%"]],")"]]],["framework"]],
["on-menu-char",">gui/frame_.html#(meth._(((lib._mred/main..rkt)._frame~25)._on-menu-char))",[[0,[2,"on-menu-char"]],[14,[" (method of ",[0,[2,"frame%"]],")"]]],["racket/gui/base","racket/gui"]],
["on-message",">gui/top-level-window___.html#(meth._(((lib._mred/main..rkt)._top-level-window~3c~25~3e)._on-message))",[[0,[2,"on-message"]],[14,[" (method of ",[0,[2,"top-level-window<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["on-mouse",">teachpack/2htdpuniverse.html#(form._((lib._2htdp/universe..rkt)._on-mouse))",[0,[1,"on-mouse"]],["2htdp/universe"]],
["on-mouse-event",">teachpack/world.html#(def._((lib._htdp/world..rkt)._on-mouse-event))",[0,[2,"on-mouse-event"]],["htdp/world"]],
["on-mouse-event",">deinprogramm/world.html#(def._((lib._deinprogramm/world..rkt)._on-mouse-event))",[0,[2,"on-mouse-event"]],["teachpack/deinprogramm/world"]],
["on-mouse-over-snips",">mrlib/graph-pasteboard___.html#(meth._(((lib._mrlib/graph..rkt)._graph-pasteboard~3c~25~3e)._on-mouse-over-snips))",[[0,[2,"on-mouse-over-snips"]],[14,[" (method of ",[0,[2,"graph-pasteboard<%>"]],")"]]],["mrlib/graph"]],
["on-move",">gui/window___.html#(meth._(((lib._mred/main..rkt)._window~3c~25~3e)._on-move))",[[0,[2,"on-move"]],[14,[" (method of ",[0,[2,"window<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["on-move-to",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._on-move-to))",[[0,[2,"on-move-to"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["on-msg",">teachpack/2htdpuniverse.html#(form._((lib._2htdp/universe..rkt)._on-msg))",[0,[1,"on-msg"]],["2htdp/universe"]],
["on-navigate",">browser/index.html#(meth._(((lib._browser/browser..rkt)._hyper-panel-mixin)._on-navigate))",[[0,[2,"on-navigate"]],[14,[" (method of ",[0,[2,"hyper-panel-mixin"]],")"]]],["browser/browser","browser"]],
["on-new",">teachpack/2htdpuniverse.html#(form._((lib._2htdp/universe..rkt)._on-new))",[0,[1,"on-new"]],["2htdp/universe"]],
["on-new-box",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._on-new-box))",[[0,[2,"on-new-box"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["on-new-box",">framework/Editor.html#(meth._(((lib._framework/main..rkt)._editor~3abasic-mixin)._on-new-box))",[[0,[2,"on-new-box"]],[14,[" (method of ",[0,[2,"editor:basic-mixin"]],")"]]],["framework"]],
["on-new-box",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3ahost-text-mixin)._on-new-box))",[[0,[2,"on-new-box"]],[14,[" (method of ",[0,[2,"mode:host-text-mixin"]],")"]]],["framework"]],
["on-new-box",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3asurrogate-text~25)._on-new-box))",[[0,[2,"on-new-box"]],[14,[" (method of ",[0,[2,"mode:surrogate-text%"]],")"]]],["framework"]],
["on-new-image-snip",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._on-new-image-snip))",[[0,[2,"on-new-image-snip"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["on-new-image-snip",">framework/Editor.html#(meth._(((lib._framework/main..rkt)._editor~3abasic-mixin)._on-new-image-snip))",[[0,[2,"on-new-image-snip"]],[14,[" (method of ",[0,[2,"editor:basic-mixin"]],")"]]],["framework"]],
["on-new-image-snip",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3ahost-text-mixin)._on-new-image-snip))",[[0,[2,"on-new-image-snip"]],[14,[" (method of ",[0,[2,"mode:host-text-mixin"]],")"]]],["framework"]],
["on-new-image-snip",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3asurrogate-text~25)._on-new-image-snip))",[[0,[2,"on-new-image-snip"]],[14,[" (method of ",[0,[2,"mode:surrogate-text%"]],")"]]],["framework"]],
["on-new-string-snip",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._on-new-string-snip))",[[0,[2,"on-new-string-snip"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["on-new-string-snip",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3ahost-text-mixin)._on-new-string-snip))",[[0,[2,"on-new-string-snip"]],[14,[" (method of ",[0,[2,"mode:host-text-mixin"]],")"]]],["framework"]],
["on-new-string-snip",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3asurrogate-text~25)._on-new-string-snip))",[[0,[2,"on-new-string-snip"]],[14,[" (method of ",[0,[2,"mode:surrogate-text%"]],")"]]],["framework"]],
["on-new-tab-snip",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._on-new-tab-snip))",[[0,[2,"on-new-tab-snip"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["on-new-tab-snip",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3ahost-text-mixin)._on-new-tab-snip))",[[0,[2,"on-new-tab-snip"]],[14,[" (method of ",[0,[2,"mode:host-text-mixin"]],")"]]],["framework"]],
["on-new-tab-snip",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3asurrogate-text~25)._on-new-tab-snip))",[[0,[2,"on-new-tab-snip"]],[14,[" (method of ",[0,[2,"mode:surrogate-text%"]],")"]]],["framework"]],
["on-pad",">teachpack/2htdpuniverse.html#(form._((lib._2htdp/universe..rkt)._on-pad))",[0,[1,"on-pad"]],["2htdp/universe"]],
["on-paint",">gui/canvas_.html#(meth._(((lib._mred/main..rkt)._canvas~25)._on-paint))",[[0,[2,"on-paint"]],[14,[" (method of ",[0,[2,"canvas%"]],")"]]],["racket/gui/base","racket/gui"]],
["on-paint",">gui/canvas___.html#(meth._(((lib._mred/main..rkt)._canvas~3c~25~3e)._on-paint))",[[0,[2,"on-paint"]],[14,[" (method of ",[0,[2,"canvas<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["on-paint",">gui/editor-canvas_.html#(meth._(((lib._mred/main..rkt)._editor-canvas~25)._on-paint))",[[0,[2,"on-paint"]],[14,[" (method of ",[0,[2,"editor-canvas%"]],")"]]],["racket/gui/base","racket/gui"]],
["on-paint",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._on-paint))",[[0,[2,"on-paint"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["on-paint",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3ahost-text-mixin)._on-paint))",[[0,[2,"on-paint"]],[14,[" (method of ",[0,[2,"mode:host-text-mixin"]],")"]]],["framework"]],
["on-paint",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3asurrogate-text~25)._on-paint))",[[0,[2,"on-paint"]],[14,[" (method of ",[0,[2,"mode:surrogate-text%"]],")"]]],["framework"]],
["on-paint",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3aautocomplete-mixin)._on-paint))",[[0,[2,"on-paint"]],[14,[" (method of ",[0,[2,"text:autocomplete-mixin"]],")"]]],["framework"]],
["on-paint",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3abasic-mixin)._on-paint))",[[0,[2,"on-paint"]],[14,[" (method of ",[0,[2,"text:basic-mixin"]],")"]]],["framework"]],
["on-paint",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3adelegate-mixin)._on-paint))",[[0,[2,"on-paint"]],[14,[" (method of ",[0,[2,"text:delegate-mixin"]],")"]]],["framework"]],
["on-paint",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3afirst-line-mixin)._on-paint))",[[0,[2,"on-paint"]],[14,[" (method of ",[0,[2,"text:first-line-mixin"]],")"]]],["framework"]],
["on-paint",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3aline-numbers-mixin)._on-paint))",[[0,[2,"on-paint"]],[14,[" (method of ",[0,[2,"text:line-numbers-mixin"]],")"]]],["framework"]],
["on-paint",">mrlib/Name_Message.html#(meth._(((lib._mrlib/name-message..rkt)._name-message~25)._on-paint))",[[0,[2,"on-paint"]],[14,[" (method of ",[0,[2,"name-message%"]],")"]]],["mrlib/name-message"]],
["on-popup",">gui/combo-field_.html#(meth._(((lib._mred/main..rkt)._combo-field~25)._on-popup))",[[0,[2,"on-popup"]],[14,[" (method of ",[0,[2,"combo-field%"]],")"]]],["racket/gui/base","racket/gui"]],
["on-receive",">teachpack/2htdpuniverse.html#(form._((lib._2htdp/universe..rkt)._on-receive))",[0,[1,"on-receive"]],["2htdp/universe"]],
["on-redraw",">teachpack/world.html#(def._((lib._htdp/world..rkt)._on-redraw))",[0,[2,"on-redraw"]],["htdp/world"]],
["on-redraw",">deinprogramm/world.html#(def._((lib._deinprogramm/world..rkt)._on-redraw))",[0,[2,"on-redraw"]],["teachpack/deinprogramm/world"]],
["on-reflow",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._on-reflow))",[[0,[2,"on-reflow"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["on-release",">teachpack/2htdpuniverse.html#(form._((lib._2htdp/universe..rkt)._on-release))",[0,[1,"on-release"]],["2htdp/universe"]],
["on-reorder",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._on-reorder))",[[0,[2,"on-reorder"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["on-replaced",">gui/clipboard-client_.html#(meth._(((lib._mred/main..rkt)._clipboard-client~25)._on-replaced))",[[0,[2,"on-replaced"]],[14,[" (method of ",[0,[2,"clipboard-client%"]],")"]]],["racket/gui/base","racket/gui"]],
["on-resize",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._on-resize))",[[0,[2,"on-resize"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["on-save-file",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._on-save-file))",[[0,[2,"on-save-file"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["on-save-file",">framework/Editor.html#(meth._(((lib._framework/main..rkt)._editor~3abackup-autosave-mixin)._on-save-file))",[[0,[2,"on-save-file"]],[14,[" (method of ",[0,[2,"editor:backup-autosave-mixin"]],")"]]],["framework"]],
["on-save-file",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3ahost-text-mixin)._on-save-file))",[[0,[2,"on-save-file"]],[14,[" (method of ",[0,[2,"mode:host-text-mixin"]],")"]]],["framework"]],
["on-save-file",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3asurrogate-text~25)._on-save-file))",[[0,[2,"on-save-file"]],[14,[" (method of ",[0,[2,"mode:surrogate-text%"]],")"]]],["framework"]],
["on-save-file",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3aclever-file-format-mixin)._on-save-file))",[[0,[2,"on-save-file"]],[14,[" (method of ",[0,[2,"text:clever-file-format-mixin"]],")"]]],["framework"]],
["on-scroll",">gui/canvas_.html#(meth._(((lib._mred/main..rkt)._canvas~25)._on-scroll))",[[0,[2,"on-scroll"]],[14,[" (method of ",[0,[2,"canvas%"]],")"]]],["racket/gui/base","racket/gui"]],
["on-select",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._on-select))",[[0,[2,"on-select"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["on-select",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..rkt)._hierarchical-list~25)._on-select))",[[0,[2,"on-select"]],[14,[" (method of ",[0,[2,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["on-select-always",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..rkt)._hierarchical-list~25)._on-select-always))",[[0,[2,"on-select-always"]],[14,[" (method of ",[0,[2,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["on-set-size-constraint",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._on-set-size-constraint))",[[0,[2,"on-set-size-constraint"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["on-set-size-constraint",">framework/Color.html#(meth._(((lib._framework/main..rkt)._color~3atext-mixin)._on-set-size-constraint))",[[0,[2,"on-set-size-constraint"]],[14,[" (method of ",[0,[2,"color:text-mixin"]],")"]]],["framework"]],
["on-set-size-constraint",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3ahost-text-mixin)._on-set-size-constraint))",[[0,[2,"on-set-size-constraint"]],[14,[" (method of ",[0,[2,"mode:host-text-mixin"]],")"]]],["framework"]],
["on-set-size-constraint",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3asurrogate-text~25)._on-set-size-constraint))",[[0,[2,"on-set-size-constraint"]],[14,[" (method of ",[0,[2,"mode:surrogate-text%"]],")"]]],["framework"]],
["on-size",">gui/editor-canvas_.html#(meth._(((lib._mred/main..rkt)._editor-canvas~25)._on-size))",[[0,[2,"on-size"]],[14,[" (method of ",[0,[2,"editor-canvas%"]],")"]]],["racket/gui/base","racket/gui"]],
["on-size",">gui/window___.html#(meth._(((lib._mred/main..rkt)._window~3c~25~3e)._on-size))",[[0,[2,"on-size"]],[14,[" (method of ",[0,[2,"window<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["on-size",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aframe~25)._on-size))",[[0,[2,"on-size"]],[14,[" (method of ",[0,[2,"drracket:unit:frame%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["on-size",">framework/Canvas.html#(meth._(((lib._framework/main..rkt)._canvas~3awide-snip-mixin)._on-size))",[[0,[2,"on-size"]],[14,[" (method of ",[0,[2,"canvas:wide-snip-mixin"]],")"]]],["framework"]],
["on-size",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3asize-pref-mixin)._on-size))",[[0,[2,"on-size"]],[14,[" (method of ",[0,[2,"frame:size-pref-mixin"]],")"]]],["framework"]],
["on-size",">unstable/snip.html#(meth._(((lib._unstable/gui/snip..rkt)._snip-canvas~25)._on-size))",[[0,[2,"on-size"]],[14,[" (method of ",[0,[2,"snip-canvas%"]],")"]]],["unstable/gui/snip"]],
["on-snip-modified",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._on-snip-modified))",[[0,[2,"on-snip-modified"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["on-snip-modified",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3ahost-text-mixin)._on-snip-modified))",[[0,[2,"on-snip-modified"]],[14,[" (method of ",[0,[2,"mode:host-text-mixin"]],")"]]],["framework"]],
["on-snip-modified",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3asurrogate-text~25)._on-snip-modified))",[[0,[2,"on-snip-modified"]],[14,[" (method of ",[0,[2,"mode:surrogate-text%"]],")"]]],["framework"]],
["on-submit",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3aports~3c~25~3e)._on-submit))",[[0,[2,"on-submit"]],[14,[" (method of ",[0,[2,"text:ports<%>"]],")"]]],["framework"]],
["on-subwindow-char",">gui/dialog_.html#(meth._(((lib._mred/main..rkt)._dialog~25)._on-subwindow-char))",[[0,[2,"on-subwindow-char"]],[14,[" (method of ",[0,[2,"dialog%"]],")"]]],["racket/gui/base","racket/gui"]],
["on-subwindow-char",">gui/frame_.html#(meth._(((lib._mred/main..rkt)._frame~25)._on-subwindow-char))",[[0,[2,"on-subwindow-char"]],[14,[" (method of ",[0,[2,"frame%"]],")"]]],["racket/gui/base","racket/gui"]],
["on-subwindow-char",">gui/window___.html#(meth._(((lib._mred/main..rkt)._window~3c~25~3e)._on-subwindow-char))",[[0,[2,"on-subwindow-char"]],[14,[" (method of ",[0,[2,"window<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["on-subwindow-event",">gui/window___.html#(meth._(((lib._mred/main..rkt)._window~3c~25~3e)._on-subwindow-event))",[[0,[2,"on-subwindow-event"]],[14,[" (method of ",[0,[2,"window<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["on-subwindow-event",">framework/Panel.html#(meth._(((lib._framework/main..rkt)._panel~3adragable-mixin)._on-subwindow-event))",[[0,[2,"on-subwindow-event"]],[14,[" (method of ",[0,[2,"panel:dragable-mixin"]],")"]]],["framework"]],
["on-subwindow-focus",">gui/window___.html#(meth._(((lib._mred/main..rkt)._window~3c~25~3e)._on-subwindow-focus))",[[0,[2,"on-subwindow-focus"]],[14,[" (method of ",[0,[2,"window<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["on-superwindow-enable",">gui/window___.html#(meth._(((lib._mred/main..rkt)._window~3c~25~3e)._on-superwindow-enable))",[[0,[2,"on-superwindow-enable"]],[14,[" (method of ",[0,[2,"window<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["on-superwindow-show",">gui/window___.html#(meth._(((lib._mred/main..rkt)._window~3c~25~3e)._on-superwindow-show))",[[0,[2,"on-superwindow-show"]],[14,[" (method of ",[0,[2,"window<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["on-superwindow-show",">framework/Canvas.html#(meth._(((lib._framework/main..rkt)._canvas~3adelegate-mixin)._on-superwindow-show))",[[0,[2,"on-superwindow-show"]],[14,[" (method of ",[0,[2,"canvas:delegate-mixin"]],")"]]],["framework"]],
["on-superwindow-show",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3abasic-mixin)._on-superwindow-show))",[[0,[2,"on-superwindow-show"]],[14,[" (method of ",[0,[2,"frame:basic-mixin"]],")"]]],["framework"]],
["on-system-menu-char",">gui/top-level-window___.html#(meth._(((lib._mred/main..rkt)._top-level-window~3c~25~3e)._on-system-menu-char))",[[0,[2,"on-system-menu-char"]],[14,[" (method of ",[0,[2,"top-level-window<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["on-tab-change",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aframe~3c~25~3e)._on-tab-change))",[[0,[2,"on-tab-change"]],[14,[" (method of ",[0,[2,"drracket:unit:frame<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["on-tab-in",">gui/canvas___.html#(meth._(((lib._mred/main..rkt)._canvas~3c~25~3e)._on-tab-in))",[[0,[2,"on-tab-in"]],[14,[" (method of ",[0,[2,"canvas<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["on-tick",">teachpack/2htdpuniverse.html#(form._((lib._2htdp/universe..rkt)._on-tick))",[0,[1,"on-tick"]],["2htdp/universe"]],
["on-tick-event",">teachpack/draw.html#(def._((lib._htdp/big-draw..rkt)._on-tick-event))",[0,[2,"on-tick-event"]],["htdp/draw"]],
["on-tick-event",">teachpack/world.html#(def._((lib._htdp/world..rkt)._on-tick-event))",[0,[2,"on-tick-event"]],["htdp/world"]],
["on-tick-event",">deinprogramm/world.html#(def._((lib._deinprogramm/world..rkt)._on-tick-event))",[0,[2,"on-tick-event"]],["teachpack/deinprogramm/world"]],
["on-toolbar-button-click",">gui/frame_.html#(meth._(((lib._mred/main..rkt)._frame~25)._on-toolbar-button-click))",[[0,[2,"on-toolbar-button-click"]],[14,[" (method of ",[0,[2,"frame%"]],")"]]],["racket/gui/base","racket/gui"]],
["on-traverse-char",">gui/top-level-window___.html#(meth._(((lib._mred/main..rkt)._top-level-window~3c~25~3e)._on-traverse-char))",[[0,[2,"on-traverse-char"]],[14,[" (method of ",[0,[2,"top-level-window<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["once-e",">frtime/index.html#(def._((lib._frtime/main..rkt)._once-e))",[0,[2,"once-e"]],["frtime"]],
["one",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.One))",[0,[1,"One"]],["typed/racket/base","typed/racket"]],
["one-of",">deinprogramm/Signaturen.html#(part._one-of)",[0,[1,"one-of"]],false],
["one-of",">deinprogramm/Signaturen.html#(form._((lib._deinprogramm/.D.Md.A..rkt)._one-of))",[0,[1,"one-of"]],["deinprogramm/DMdA-beginner"]],
["one-of/c",">reference/data-structure-contracts.html#(def._((lib._racket/contract/private/misc..rkt)._one-of/c))",[0,[2,"one-of/c"]],["racket/contract/base","racket/contract","racket"]],
["onecolumn",">scribble/SIGPLAN_Paper_Format.html#(form._((lib._scribble/sigplan..rkt)._onecolumn))",[0,[1,"onecolumn"]],["scribble/sigplan"]],
["only",">reference/creatingunits.html#(form._((lib._mzlib/unit..rkt)._only))",[0,[1,"only"]],["racket/unit","racket"]],
["only-in",">reference/require.html#(form._((lib._racket/private/base..rkt)._only-in))",[0,[1,"only-in"]],["racket/base","racket"]],
["only-meta-in",">reference/require.html#(form._((lib._racket/private/base..rkt)._only-meta-in))",[0,[1,"only-meta-in"]],["racket/base","racket"]],
["onscreen",">scribble/doc-strings.html#(def._((lib._scribble/manual..rkt)._onscreen))",[0,[2,"onscreen"]],["scribble/manual"]],
["opacity (alpha components)",">images/Overview.html#(part._flomap~3aopacity)","Opacity (Alpha Components)",false],
["opaque",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_302",[0,[1,"opaque"]],["rnrs/records/syntactic-6"]],
["opaque",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types-extra..rkt)._.Opaque))",[0,[1,"Opaque"]],["typed/racket/base","typed/racket"]],
["opaque",">ts-reference/special-forms.html#(idx._(gentag._1._(lib._typed-racket/scribblings/ts-reference..scrbl)))","opaque",false],
["opaque",">draw/brush_.html#(idx._(gentag._13._(lib._scribblings/draw/draw..scrbl)))",[7,"'opaque"],false],
["opaque",">reference/stxcerts.html#(idx._(gentag._182._(lib._scribblings/reference/reference..scrbl)))",[7,"'opaque"],false],
["opaque",">guide/define-struct.html#(tech._opaque)","<span style=\"font-style: italic\">opaque</span>",false],
["opaque versus transparent structure types",">guide/define-struct.html#(part._trans-struct)","Opaque versus Transparent Structure Types",false],
["open",">planet/cmdline.html#(part._open)",[6,"open"],false],
["open",">reference/creatingunits.html#(form._((lib._mzlib/unit..rkt)._open))",[0,[1,"open"]],["racket/unit","racket"]],
["open",">mrlib/hierarchical-list-compound-item___.html#(meth._(((lib._mrlib/hierlist..rkt)._hierarchical-list-compound-item~3c~25~3e)._open))",[[0,[2,"open"]],[14,[" (method of ",[0,[2,"hierarchical-list-compound-item<%>"]],")"]]],["mrlib/hierlist"]],
["open recent menu item",">drracket/Menus.html#(idx._(gentag._56._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Open Recent</span> menu item",false],
["open sub-path",">draw/dc-path_.html#(tech._open._sub._path)","<span style=\"font-style: italic\">open sub-path</span>",false],
["open*-package",">reference/package.html#(form._((lib._racket/package..rkt)._open*-package))",[0,[1,"open*-package"]],["racket/package"]],
["open-bytevector-input-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_672",[0,[2,"open-bytevector-input-port"]],["rnrs/io/ports-6"]],
["open-bytevector-output-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_720",[0,[2,"open-bytevector-output-port"]],["rnrs/io/ports-6"]],
["open-file-input-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_668",[0,[2,"open-file-input-port"]],["rnrs/io/ports-6"]],
["open-file-input/output-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_758",[0,[2,"open-file-input/output-port"]],["rnrs/io/ports-6"]],
["open-file-output-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_716",[0,[2,"open-file-output-port"]],["rnrs/io/ports-6"]],
["open-graphics",">graphics/Basic_Commands.html#(def._((lib._graphics/graphics..rkt)._open-graphics))",[0,[2,"open-graphics"]],["graphics/graphics"]],
["open-in-new-tab",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aframe~3c~25~3e)._open-in-new-tab))",[[0,[2,"open-in-new-tab"]],[14,[" (method of ",[0,[2,"drracket:unit:frame<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["open-input-bytes",">reference/stringport.html#(def._((quote._~23~25kernel)._open-input-bytes))",[0,[2,"open-input-bytes"]],["racket/base","racket"]],
["open-input-file",">reference/file-ports.html#(def._((lib._racket/private/base..rkt)._open-input-file))",[0,[2,"open-input-file"]],["racket/base","racket"]],
["open-input-file",">r5rs-std/r5rs-Z-H-9.html#%_idx_626",[0,[2,"open-input-file"]],["r5rs"]],
["open-input-file",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_800",[0,[2,"open-input-file"]],["rnrs/io/simple-6"]],
["open-input-file",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..rkt)._open-input-file))",[0,[2,"open-input-file"]],["mzscheme"]],
["open-input-graphical-file",">gui/Editor_Functions.html#(def._((lib._mred/main..rkt)._open-input-graphical-file))",[0,[2,"open-input-graphical-file"]],["racket/gui/base","racket/gui"]],
["open-input-output-file",">reference/file-ports.html#(def._((lib._racket/private/base..rkt)._open-input-output-file))",[0,[2,"open-input-output-file"]],["racket/base","racket"]],
["open-input-output-file",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..rkt)._open-input-output-file))",[0,[2,"open-input-output-file"]],["mzscheme"]],
["open-input-string",">reference/stringport.html#(def._((quote._~23~25kernel)._open-input-string))",[0,[2,"open-input-string"]],["racket/base","racket"]],
["open-input-string",">srfi-std/srfi-6.html#open-input-string",[0,[2,"open-input-string"]],["srfi/6"]],
["open-input-text-editor",">gui/Editor_Functions.html#(def._((lib._mred/main..rkt)._open-input-text-editor))",[0,[2,"open-input-text-editor"]],["racket/gui/base","racket/gui"]],
["open-line",">framework/Keymap.html#(idx._(gentag._20._(lib._scribblings/framework/framework..scrbl)))","open-line",false],
["open-news-group",">net/nntp.html#(def._((lib._net/nntp..rkt)._open-news-group))",[0,[2,"open-news-group"]],["net/nntp"]],
["open-output-bytes",">reference/stringport.html#(def._((quote._~23~25kernel)._open-output-bytes))",[0,[2,"open-output-bytes"]],["racket/base","racket"]],
["open-output-file",">reference/file-ports.html#(def._((lib._racket/private/base..rkt)._open-output-file))",[0,[2,"open-output-file"]],["racket/base","racket"]],
["open-output-file",">r5rs-std/r5rs-Z-H-9.html#%_idx_628",[0,[2,"open-output-file"]],["r5rs"]],
["open-output-file",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_802",[0,[2,"open-output-file"]],["rnrs/io/simple-6"]],
["open-output-file",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..rkt)._open-output-file))",[0,[2,"open-output-file"]],["mzscheme"]],
["open-output-nowhere",">reference/port-lib.html#(def._((lib._racket/port..rkt)._open-output-nowhere))",[0,[2,"open-output-nowhere"]],["racket/port","racket"]],
["open-output-string",">reference/stringport.html#(def._((quote._~23~25kernel)._open-output-string))",[0,[2,"open-output-string"]],["racket/base","racket"]],
["open-output-string",">srfi-std/srfi-6.html#open-output-string",[0,[2,"open-output-string"]],["srfi/6"]],
["open-output-text-editor",">gui/Editor_Functions.html#(def._((lib._mred/main..rkt)._open-output-text-editor))",[0,[2,"open-output-text-editor"]],["racket/gui/base","racket/gui"]],
["open-package",">reference/package.html#(form._((lib._racket/package..rkt)._open-package))",[0,[1,"open-package"]],["racket/package"]],
["open-pixmap",">graphics/Basic_Commands.html#(def._((lib._graphics/graphics..rkt)._open-pixmap))",[0,[2,"open-pixmap"]],["graphics/graphics"]],
["open-status-line",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astatus-line~3c~25~3e)._open-status-line))",[[0,[2,"open-status-line"]],[14,[" (method of ",[0,[2,"frame:status-line<%>"]],")"]]],["framework"]],
["open-string-input-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_674",[0,[2,"open-string-input-port"]],["rnrs/io/ports-6"]],
["open-string-output-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_726",[0,[2,"open-string-output-port"]],["rnrs/io/ports-6"]],
["open-url",">browser/index.html#(def._((lib._browser/browser..rkt)._open-url))",[0,[2,"open-url"]],["browser/browser","browser"]],
["open-viewport",">graphics/Basic_Commands.html#(def._((lib._graphics/graphics..rkt)._open-viewport))",[0,[2,"open-viewport"]],["graphics/graphics"]],
["open-ws-conn?",">net/websocket.html#(def._((lib._net/websocket/conn..rkt)._open-ws-conn~3f))",[0,[2,"open-ws-conn?"]],["net/websocket/conn"]],
["open... menu item",">drracket/Menus.html#(idx._(gentag._55._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Open...</span> menu item",false],
["open?",">draw/dc-path_.html#(meth._(((lib._racket/draw..rkt)._dc-path~25)._open~3f))",[[0,[2,"open?"]],[14,[" (method of ",[0,[2,"dc-path%"]],")"]]],["racket/draw"]],
["opengl",">sgl/index.html#(idx._(gentag._0._(lib._sgl/scribblings/sgl..scrbl)))","OpenGL",false],
["opengl",">draw/gl-context___.html#(idx._(gentag._51._(lib._scribblings/draw/draw..scrbl)))","OpenGL",false],
["opengl vectors",">sgl/gl-vectors.html","OpenGL Vectors",false],
["openssl",">openssl/index.html",[9,[0,"openssl"]],"module"],
["openssl/sha1",">openssl/index.html#(mod-path._openssl/sha1)",[9,[0,"openssl/sha1"]],"module"],
["openssl: secure communication",">openssl/index.html","OpenSSL: Secure Communication",false],
["operating system",">reference/os.html","Operating System",false],
["opt",">unstable/Automata__Compiling_State_Machines.html#(form._((lib._unstable/automata/re-ext..rkt)._opt))",[0,[1,"opt"]],["unstable/automata/re-ext"]],
["opt->",">mzlib/mzlib_contract.html#(form._((lib._mzlib/contract..rkt)._opt-~3e))",[0,[1,"opt->"]],["mzlib/contract"]],
["opt->*",">mzlib/mzlib_contract.html#(form._((lib._mzlib/contract..rkt)._opt-~3e*))",[0,[1,"opt->*"]],["mzlib/contract"]],
["opt-color",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._opt-color))",[0,[2,"opt-color"]],["scribble/racket","scribble/scheme"]],
["opt-lambda",">mzlib/mzlib_etc.html#(form._((lib._mzlib/etc..rkt)._opt-lambda))",[0,[1,"opt-lambda"]],["mzlib/etc"]],
["opt-lambda:",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._opt-lambda~3a))",[0,[1,"opt-lambda:"]],["typed/racket/base","typed/racket"]],
["opt/c",">reference/contract-utilities.html#(form._((lib._racket/contract/private/opt..rkt)._opt/c))",[0,[1,"opt/c"]],["racket/contract/base","racket/contract","racket"]],
["optgroup",">html/index.html#(def._((lib._html/main..rkt)._optgroup))",[0,[2,"optgroup"]],["html"]],
["optgroup?",">html/index.html#(def._((lib._html/main..rkt)._optgroup~3f))",[0,[2,"optgroup?"]],["html"]],
["optimization coach",">ts-guide/optimization.html#(tech._optimization._coach)","<span style=\"font-style: italic\">Optimization Coach</span>",false],
["optimization coaching",">ts-guide/optimization.html#(part._optimization-coach)","Optimization Coaching",false],
["optimization in typed racket",">ts-guide/optimization.html","Optimization in Typed Racket",false],
["optimization in typed racket",">ts-reference/Optimization_in_Typed_Racket.html","Optimization in Typed Racket",false],
["option",">html/index.html#(def._((lib._html/main..rkt)._option))",[0,[2,"option"]],["html"]],
["option",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Option))",[0,[1,"Option"]],["typed/racket/base","typed/racket"]],
["option/c",">unstable/contract.html#(def._((lib._unstable/contract..rkt)._option/c))",[0,[2,"option/c"]],["unstable/contract"]],
["option?",">html/index.html#(def._((lib._html/main..rkt)._option~3f))",[0,[2,"option?"]],["html"]],
["optional",">scribble/bnf.html#(def._((lib._scribble/bnf..rkt)._optional))",[0,[2,"optional"]],["scribble/bnf"]],
["optional arguments",">mzlib/mzlib_kw.html#(part._.Optional_.Arguments)","Optional Arguments",false],
["optional arguments",">guide/contracts-general-functions.html#(part._contracts-optional)","Optional Arguments",false],
["optional keyword arguments",">guide/contracts-general-functions.html#(part._contracts-optional-keywords)","Optional Keyword Arguments",false],
["optional keyword arguments",">syntax/Optional_Keyword_Arguments.html","Optional Keyword Arguments",false],
["options",">syntax/syntax-helpers.html#(tech._option)","<span style=\"font-style: italic\">options</span>",false],
["options for the compiler",">raco/API_for_Raw_Compilation.html#(part._api~3aoptions)","Options for the Compiler",false],
["options signature",">raco/setup-plt-plt.html#(part._.Options_.Signature)","Options Signature",false],
["options unit",">raco/API_for_Raw_Compilation.html#(part._.Options_.Unit)","Options Unit",false],
["options unit",">raco/setup-plt-plt.html#(part._setup-plt-options)","Options Unit",false],
["options-select",">syntax/syntax-helpers.html#(def._((lib._syntax/keyword..rkt)._options-select))",[0,[2,"options-select"]],["syntax/keyword"]],
["options-select-row",">syntax/syntax-helpers.html#(def._((lib._syntax/keyword..rkt)._options-select-row))",[0,[2,"options-select-row"]],["syntax/keyword"]],
["options-select-value",">syntax/syntax-helpers.html#(def._((lib._syntax/keyword..rkt)._options-select-value))",[0,[2,"options-select-value"]],["syntax/keyword"]],
["or",">deinprogramm/or.html",[0,[1,"or"]],false],
["or",">reference/if.html#(form._((lib._racket/private/letstx-scheme..rkt)._or))",[0,[1,"or"]],["racket/base","racket"]],
["or",">r5rs-std/r5rs-Z-H-7.html#%_idx_122",[0,[1,"or"]],["r5rs"]],
["or",">r6rs-std/r6rs-Z-H-14.html#node_idx_390",[0,[1,"or"]],["rnrs/base-6"]],
["or",">htdp-langs/advanced.html#(form._((lib._lang/htdp-advanced..rkt)._or))",[0,[1,"or"]],["lang/htdp-advanced"]],
["or",">htdp-langs/beginner.html#(form._((lib._lang/htdp-beginner..rkt)._or))",[0,[1,"or"]],["lang/htdp-beginner"]],
["or",">htdp-langs/beginner-abbr.html#(form._((lib._lang/htdp-beginner-abbr..rkt)._or))",[0,[1,"or"]],["lang/htdp-beginner-abbr"]],
["or",">htdp-langs/intermediate.html#(form._((lib._lang/htdp-intermediate..rkt)._or))",[0,[1,"or"]],["lang/htdp-intermediate"]],
["or",">htdp-langs/intermediate-lam.html#(form._((lib._lang/htdp-intermediate-lambda..rkt)._or))",[0,[1,"or"]],["lang/htdp-intermediate-lambda"]],
["or",">deinprogramm/or.html#(form._((lib._deinprogramm/.D.Md.A..rkt)._or))",[0,[1,"or"]],["deinprogramm/DMdA-beginner"]],
["or",">lazy/index.html#(def._((lib._lazy/main..rkt)._or))",[0,[2,"or"]],["lazy"]],
["or",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex-sre..rkt)._or))",[0,[1,"or"]],["parser-tools/lex-sre"]],
["or",">plai/mutator.html#(form._((lib._plai/mutator..rkt)._or))",[0,[1,"or"]],["plai/mutator"]],
["or",">srfi-std/srfi-42.html#or",[0,[1,"or"]],["srfi/42"]],
["or/c",">reference/data-structure-contracts.html#(def._((lib._racket/contract/private/misc..rkt)._or/c))",[0,[2,"or/c"]],["racket/contract/base","racket/contract","racket"]],
["oracle",">db/index.html#(idx._(gentag._6._(lib._db/scribblings/db..scrbl)))","Oracle",false],
["oracle odbc driver",">db/notes.html#(part._.Oracle_.O.D.B.C_.Driver)","Oracle ODBC Driver",false],
["orange",">unstable/pict.html#(def._((lib._unstable/gui/pict..rkt)._orange))",[0,[2,"orange"]],["unstable/gui/pict"]],
["order",">data/Orders_and_Ordered_Dictionaries.html#(def._((lib._data/order..rkt)._order))",[0,[2,"order"]],["data/order"]],
["order-<?",">data/Orders_and_Ordered_Dictionaries.html#(def._((lib._data/order..rkt)._order-~3c~3f))",[0,[2,"order-<?"]],["data/order"]],
["order-=?",">data/Orders_and_Ordered_Dictionaries.html#(def._((lib._data/order..rkt)._order-~3d~3f))",[0,[2,"order-=?"]],["data/order"]],
["order-comparator",">data/Orders_and_Ordered_Dictionaries.html#(def._((lib._data/order..rkt)._order-comparator))",[0,[2,"order-comparator"]],["data/order"]],
["order-domain-contract",">data/Orders_and_Ordered_Dictionaries.html#(def._((lib._data/order..rkt)._order-domain-contract))",[0,[2,"order-domain-contract"]],["data/order"]],
["order-manuals",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3alanguage~3c~25~3e)._order-manuals))",[[0,[2,"order-manuals"]],[14,[" (method of ",[0,[2,"drracket:language:language<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["order-of-magnitude",">reference/generic-numbers.html#(def._((lib._racket/math..rkt)._order-of-magnitude))",[0,[2,"order-of-magnitude"]],["racket/math","racket"]],
["order?",">data/Orders_and_Ordered_Dictionaries.html#(def._((lib._data/order..rkt)._order~3f))",[0,[2,"order?"]],["data/order"]],
["ordered dictionary",">data/Orders_and_Ordered_Dictionaries.html#(tech._ordered._dictionary)","<span style=\"font-style: italic\">ordered\ndictionary</span>",false],
["ordered-dict?",">data/Orders_and_Ordered_Dictionaries.html#(def._((lib._data/order..rkt)._ordered-dict~3f))",[0,[2,"ordered-dict?"]],["data/order"]],
["ordering/c",">data/Orders_and_Ordered_Dictionaries.html#(def._((lib._data/order..rkt)._ordering/c))",[0,[2,"ordering/c"]],["data/order"]],
["orders",">data/Orders_and_Ordered_Dictionaries.html#(tech._order)","<span style=\"font-style: italic\">orders</span>",false],
["orders and ordered dictionaries",">data/Orders_and_Ordered_Dictionaries.html","Orders and Ordered Dictionaries",false],
["ordinal->flonum",">unstable/flonum.html#(def._((lib._unstable/flonum..rkt)._ordinal-~3eflonum))",[0,[2,"ordinal->flonum"]],["unstable/flonum"]],
["org-author-name",">scriblib/autobib.html#(def._((lib._scriblib/autobib..rkt)._org-author-name))",[0,[2,"org-author-name"]],["scriblib/autobib"]],
["org.racket-lang.prefs.rktd",">drracket/drracket-files.html#(idx._(gentag._378._(lib._scribblings/drracket/drracket..scrbl)))",[6,"\"org.racket-lang.prefs.rktd\""],false],
["organizing modules",">guide/module-basics.html#(part._module-org)","Organizing Modules",false],
["orientation",">cards/index.html#(meth._(((lib._games/cards..rkt)._card~3c~25~3e)._orientation))",[[0,[2,"orientation"]],[14,[" (method of ",[0,[2,"card<%>"]],")"]]],["games/cards"]],
["orig-dir",">reference/Filesystem.html#(idx._(gentag._288._(lib._scribblings/reference/reference..scrbl)))",[7,"'orig-dir"],false],
["origin",">reference/stxprops.html#(idx._(gentag._177._(lib._scribblings/reference/reference..scrbl)))",[7,"'origin"],false],
["ormap",">reference/pairs.html#(def._((lib._racket/private/map..rkt)._ormap))",[0,[2,"ormap"]],["racket/base","racket"]],
["ormap",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._ormap))",[0,[2,"ormap"]],["lang/htdp-advanced"]],
["ormap",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._ormap))",[0,[2,"ormap"]],["lang/htdp-intermediate"]],
["ormap",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._ormap))",[0,[2,"ormap"]],["lang/htdp-intermediate-lambda"]],
["ormap",">lazy/index.html#(def._((lib._lazy/main..rkt)._ormap))",[0,[2,"ormap"]],["lazy"]],
["orthographic-projection",">images/Spatial_Transformations.html#(def._((lib._images/flomap..rkt)._orthographic-projection))",[0,[2,"orthographic-projection"]],["images/flomap"]],
["os",">reference/runtime.html#(idx._(gentag._323._(lib._scribblings/reference/reference..scrbl)))",[7,"'os"],false],
["other",">tools/adding-languages.html#(idx._(gentag._16._(lib._scribblings/tools/tools..scrbl)))",[7,"'other"],false],
["other atomic types",">foreign/Other_Atomic_Types.html","Other Atomic Types",false],
["other base types",">ts-reference/type-ref.html#(part._.Other_.Base_.Types)","Other Base Types",false],
["other errortrace bindings",">errortrace/using-errortrace.html#(part._other-errortrace-bindings)","Other Errortrace Bindings",false],
["other experimental languages",">drracket/experimental-langs.html","Other Experimental Languages",false],
["other forms",">ts-reference/special-forms.html#(part._.Other_.Forms)","Other Forms",false],
["other relations",">redex/The_Redex_Reference.html#(part._.Other_.Relations)","Other Relations",false],
["other string types",">foreign/String_Types.html#(part._.Other_.String_.Types)","Other String Types",false],
["other ticks",">plot/ticks_and_transforms.html#(part._.Other_.Ticks)","Other Ticks",false],
["other type constructors",">ts-reference/type-ref.html#(part._.Other_.Type_.Constructors)","Other Type Constructors",false],
["other types",">ts-reference/type-ref.html#(part._.Other_.Types)","Other Types",false],
["other-authors",">scriblib/autobib.html#(def._((lib._scriblib/autobib..rkt)._other-authors))",[0,[2,"other-authors"]],["scriblib/autobib"]],
["other-doc",">scribble/base.html#(def._((lib._scribble/base..rkt)._other-doc))",[0,[2,"other-doc"]],["scribble/base"]],
["other-equal-to?",">gui/image-snip_.html#(meth._(((lib._racket/snip..rkt)._image-snip~25)._other-equal-to~3f))",[[0,[2,"other-equal-to?"]],[14,[" (method of ",[0,[2,"image-snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["other-equal-to?",">gui/snip_.html#(meth._(((lib._racket/snip..rkt)._snip~25)._other-equal-to~3f))",[[0,[2,"other-equal-to?"]],[14,[" (method of ",[0,[2,"snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["other-equal-to?",">mrlib/Cache-image_Snip.html#(meth._(((lib._mrlib/cache-image-snip..rkt)._cache-image-snip~25)._other-equal-to~3f))",[[0,[2,"other-equal-to?"]],[14,[" (method of ",[0,[2,"cache-image-snip%"]],")"]]],["mrlib/cache-image-snip"]],
["other-execute-bit",">reference/Filesystem.html#(def._((lib._racket/file..rkt)._other-execute-bit))",[0,[2,"other-execute-bit"]],["racket/file","racket"]],
["other-manual",">scribble/section-links.html#(def._((lib._scribble/manual..rkt)._other-manual))",[0,[2,"other-manual"]],["scribble/manual"]],
["other-read-bit",">reference/Filesystem.html#(def._((lib._racket/file..rkt)._other-read-bit))",[0,[2,"other-read-bit"]],["racket/file","racket"]],
["other-write-bit",">reference/Filesystem.html#(def._((lib._racket/file..rkt)._other-write-bit))",[0,[2,"other-write-bit"]],["racket/file","racket"]],
["out button",">drracket/debugger.html#(idx._(gentag._37._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Out</span> button",false],
["outline-flash",">slideshow/More_Pict_Constructors.html#(def._((lib._slideshow/flash..rkt)._outline-flash))",[0,[2,"outline-flash"]],["slideshow/flash"]],
["output",">plot/params.html#(part._.Output)","Output",false],
["output printing styles",">drracket/output-syntax.html","Output Printing Styles",false],
["output-color",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._output-color))",[0,[2,"output-color"]],["scribble/racket","scribble/scheme"]],
["output-http-headers",">net/cgi.html#(def._((lib._net/cgi..rkt)._output-http-headers))",[0,[2,"output-http-headers"]],["net/cgi"]],
["output-port",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Output-.Port))",[0,[1,"Output-Port"]],["typed/racket/base","typed/racket"]],
["output-port-buffer-mode",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_714",[0,[2,"output-port-buffer-mode"]],["rnrs/io/ports-6"]],
["output-port?",">reference/port-ops.html#(def._((quote._~23~25kernel)._output-port~3f))",[0,[2,"output-port?"]],["racket/base","racket"]],
["output-port?",">r5rs-std/r5rs-Z-H-9.html#%_idx_616",[0,[2,"output-port?"]],["r5rs"]],
["output-port?",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_710",[0,[2,"output-port?"]],["rnrs/io/ports-6"]],
["output-profile-results",">errortrace/using-errortrace.html#(def._((lib._errortrace/errortrace-lib..rkt)._output-profile-results))",[0,[2,"output-profile-results"]],["errortrace"]],
["over button",">drracket/debugger.html#(idx._(gentag._36._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Over</span> button",false],
["overlay",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._overlay))",[0,[2,"overlay"]],["2htdp/image"]],
["overlay",">teachpack/image.html#(def._((lib._htdp/image..rkt)._overlay))",[0,[2,"overlay"]],["htdp/image"]],
["overlay",">deinprogramm/image.html#(def._((lib._deinprogramm/image..rkt)._overlay))",[0,[2,"overlay"]],["teachpack/deinprogramm/image"]],
["overlay-bitmap",">mrlib/Cache-image_Snip.html#(def._((lib._mrlib/cache-image-snip..rkt)._overlay-bitmap))",[0,[2,"overlay-bitmap"]],["mrlib/cache-image-snip"]],
["overlay/align",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._overlay/align))",[0,[2,"overlay/align"]],["2htdp/image"]],
["overlay/align/offset",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._overlay/align/offset))",[0,[2,"overlay/align/offset"]],["2htdp/image"]],
["overlay/offset",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._overlay/offset))",[0,[2,"overlay/offset"]],["2htdp/image"]],
["overlay/pinhole",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._overlay/pinhole))",[0,[2,"overlay/pinhole"]],["2htdp/image"]],
["overlay/xy",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._overlay/xy))",[0,[2,"overlay/xy"]],["2htdp/image"]],
["overlay/xy",">teachpack/image.html#(def._((lib._htdp/image..rkt)._overlay/xy))",[0,[2,"overlay/xy"]],["htdp/image"]],
["overlaying images",">teachpack/2htdpimage.html#(part._.Overlaying_.Images)","Overlaying Images",false],
["overment",">reference/createclass.html#(form._((lib._racket/private/class-internal..rkt)._overment))",[0,[1,"overment"]],["racket/class","racket"]],
["overment*",">reference/createclass.html#(form._((lib._racket/private/class-internal..rkt)._overment*))",[0,[1,"overment*"]],["racket/class","racket"]],
["override",">reference/createclass.html#(form._((lib._racket/private/class-internal..rkt)._override))",[0,[1,"override"]],["racket/class","racket"]],
["override*",">reference/createclass.html#(form._((lib._racket/private/class-internal..rkt)._override*))",[0,[1,"override*"]],["racket/class","racket"]],
["override-final",">reference/createclass.html#(form._((lib._racket/private/class-internal..rkt)._override-final))",[0,[1,"override-final"]],["racket/class","racket"]],
["override-final*",">reference/createclass.html#(form._((lib._racket/private/class-internal..rkt)._override-final*))",[0,[1,"override-final*"]],["racket/class","racket"]],
["overriding",">reference/mzlib_class.html#(tech._overriding)","<span style=\"font-style: italic\">overriding</span>",false],
["overriding the installation's configuration",">config/index.html#(part._.Overriding_the_.Installation_s_.Configuration)","Overriding the Installation&rsquo;s Configuration",false],
["overview",">games/Overview.html","Overview",false],
["overview",">images/Overview.html","Overview",false],
["overview",">make/overview.html","Overview",false],
["overview",">preprocessor/overview.html","Overview",false],
["overview",">draw/overview.html","Overview",false],
["overview",">foreign/intro.html","Overview",false],
["overview",">inside/overview.html","Overview",false],
["overview of rackunit",">rackunit/api.html#(part._.Overview_of_.Rack.Unit)","Overview of RackUnit",false],
["overwrite mode",">drracket/Keyboard_Shortcuts.html#(idx._(gentag._208._(lib._scribblings/drracket/drracket..scrbl)))","overwrite mode",false],
["overwrite-status-changed",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3atext-info~3c~25~3e)._overwrite-status-changed))",[[0,[2,"overwrite-status-changed"]],[14,[" (method of ",[0,[2,"frame:text-info<%>"]],")"]]],["framework"]],
["own-caret",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._own-caret))",[[0,[2,"own-caret"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["own-caret",">gui/snip_.html#(meth._(((lib._racket/snip..rkt)._snip~25)._own-caret))",[[0,[2,"own-caret"]],[14,[" (method of ",[0,[2,"snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["p",">html/index.html#(def._((lib._html/main..rkt)._p))",[0,[2,"p"]],["html"]],
["p-i",">xml/index.html#(def._((lib._xml/main..rkt)._p-i))",[0,[2,"p-i"]],["xml"]],
["p-i-instruction",">xml/index.html#(def._((lib._xml/main..rkt)._p-i-instruction))",[0,[2,"p-i-instruction"]],["xml"]],
["p-i-target-name",">xml/index.html#(def._((lib._xml/main..rkt)._p-i-target-name))",[0,[2,"p-i-target-name"]],["xml"]],
["p-i?",">xml/index.html#(def._((lib._xml/main..rkt)._p-i~3f))",[0,[2,"p-i?"]],["xml"]],
["p?",">html/index.html#(def._((lib._html/main..rkt)._p~3f))",[0,[2,"p?"]],["html"]],
["pack",">raco/plt.html#(def._((lib._setup/pack..rkt)._pack))",[0,[2,"pack"]],["setup/pack"]],
["pack-collections",">raco/plt.html#(def._((lib._setup/pack..rkt)._pack-collections))",[0,[2,"pack-collections"]],["setup/pack"]],
["pack-collections-plt",">raco/plt.html#(def._((lib._setup/pack..rkt)._pack-collections-plt))",[0,[2,"pack-collections-plt"]],["setup/pack"]],
["pack-plt",">raco/plt.html#(def._((lib._setup/pack..rkt)._pack-plt))",[0,[2,"pack-plt"]],["setup/pack"]],
["package",">teachpack/2htdpuniverse.html#(tech._package)","<span style=\"font-style: italic\">Package</span>",false],
["package archives",">planet/Utility_Libraries.html#(part._.Package_.Archives)","Package Archives",false],
["package utils",">planet/Utility_Libraries.html#(part._util..rkt)","Package Utils",false],
["package version",">planet/Utility_Libraries.html#(part._version..rkt)","Package Version",false],
["package-begin",">reference/package.html#(form._((lib._racket/package..rkt)._package-begin))",[0,[1,"package-begin"]],["racket/package"]],
["package-exported-identifiers",">reference/package.html#(def._((lib._racket/package..rkt)._package-exported-identifiers))",[0,[2,"package-exported-identifiers"]],["racket/package"]],
["package-original-identifiers",">reference/package.html#(def._((lib._racket/package..rkt)._package-original-identifiers))",[0,[2,"package-original-identifiers"]],["racket/package"]],
["package-version->symbol",">planet/Utility_Libraries.html#(def._((lib._planet/private/version..rkt)._package-version-~3esymbol))",[0,[2,"package-version->symbol"]],["planet/version"]],
["package?",">reference/package.html#(def._((lib._racket/package..rkt)._package~3f))",[0,[2,"package?"]],["racket/package"]],
["package?",">teachpack/2htdpuniverse.html#(def._((lib._2htdp/universe..rkt)._package~3f))",[0,[2,"package?"]],["2htdp/universe"]],
["pad",">deinprogramm/image.html#(def._((lib._deinprogramm/image..rkt)._pad))",[0,[2,"pad"]],["teachpack/deinprogramm/image"]],
["pad-event?",">teachpack/2htdpuniverse.html#(def._((lib._2htdp/universe..rkt)._pad-event~3f))",[0,[2,"pad-event?"]],["2htdp/universe"]],
["pad-handler",">teachpack/2htdpuniverse.html#(form._((lib._2htdp/universe..rkt)._pad-handler))",[0,[1,"pad-handler"]],["2htdp/universe"]],
["pad-xywh",">mrlib/Name_Message.html#(def._((lib._mrlib/name-message..rkt)._pad-xywh))",[0,[2,"pad-xywh"]],["mrlib/name-message"]],
["pad=?",">teachpack/2htdpuniverse.html#(def._((lib._2htdp/universe..rkt)._pad~3d~3f))",[0,[2,"pad=?"]],["2htdp/universe"]],
["padevent",">teachpack/2htdpuniverse.html#(tech._padevent)","<span style=\"font-style: italic\">PadEvent</span>",false],
["page",">web-server/page.html#(form._((lib._web-server/page..rkt)._page))",[0,[1,"page"]],["web-server/page"]],
["page->editor",">browser/index.html#(def._((lib._browser/browser..rkt)._page-~3eeditor))",[0,[2,"page->editor"]],["browser/browser","browser"]],
["page-down",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..rkt)._hierarchical-list~25)._page-down))",[[0,[2,"page-down"]],[14,[" (method of ",[0,[2,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["page-target-element",">scribble/core.html#(def._((lib._scribble/core..rkt)._page-target-element))",[0,[2,"page-target-element"]],["scribble/core"]],
["page-target-element?",">scribble/core.html#(def._((lib._scribble/core..rkt)._page-target-element~3f))",[0,[2,"page-target-element?"]],["scribble/core"]],
["page-up",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..rkt)._hierarchical-list~25)._page-up))",[[0,[2,"page-up"]],[14,[" (method of ",[0,[2,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["page: short-hand for common patterns",">web-server/page.html","Page: Short-hand for Common Patterns",false],
["paint by numbers --- logic game",">games/paint-by-numbers.html",[[15,"<img src=\"paint-by-numbers.png\" alt=\"\" />"]," ","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Paint By Numbers</span>"," ","&#8212;","<wbr></wbr>"," Logic Game"],false],
["pair",">ts-reference/Legacy_Forms.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Pair))",[0,[1,"Pair"]],["typed/racket/base","typed/racket"]],
["pair",">guide/pairs.html#(tech._pair)","<span style=\"font-style: italic\">pair</span>",false],
["pair",">reference/pairs.html#(tech._pair)","<span style=\"font-style: italic\">pair</span>",false],
["pair accessor shorthands",">reference/pairs.html#(part._.Pair_.Accessor_.Shorthands)","Pair Accessor Shorthands",false],
["pair constructors and selectors",">reference/pairs.html#(part._.Pair_.Constructors_and_.Selectors)","Pair Constructors and Selectors",false],
["pair-fold",">srfi-std/srfi-1.html#pair-fold",[0,[2,"pair-fold"]],["srfi/1"]],
["pair-fold-right",">srfi-std/srfi-1.html#pair-fold-right",[0,[2,"pair-fold-right"]],["srfi/1"]],
["pair-for-each",">srfi-std/srfi-1.html#pair-for-each",[0,[2,"pair-for-each"]],["srfi/1"]],
["pair?",">reference/pairs.html#(def._((quote._~23~25kernel)._pair~3f))",[0,[2,"pair?"]],["racket/base","racket"]],
["pair?",">r5rs-std/r5rs-Z-H-9.html#%_idx_406",[0,[2,"pair?"]],["r5rs"]],
["pair?",">r6rs-std/r6rs-Z-H-14.html#node_idx_608",[0,[2,"pair?"]],["rnrs/base-6"]],
["pair?",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._pair~3f))",[0,[2,"pair?"]],["deinprogramm/DMdA-advanced"]],
["pair?",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._pair~3f))",[0,[2,"pair?"]],["deinprogramm/DMdA-assignments"]],
["pair?",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._pair~3f))",[0,[2,"pair?"]],["deinprogramm/DMdA-vanilla"]],
["pair?",">srfi-std/srfi-1.html#pair-p",[0,[2,"pair?"]],["srfi/1"]],
["pairof",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Pairof))",[0,[1,"Pairof"]],["typed/racket/base","typed/racket"]],
["pairs and lists",">guide/pairs.html","Pairs and Lists",false],
["pairs and lists",">reference/pairs.html","Pairs and Lists",false],
["pairs, lists, and racket syntax",">guide/Pairs__Lists__and_Racket_Syntax.html","Pairs, Lists, and Racket Syntax",false],
["pane",">gui/windowing-overview.html#(tech._pane)","<span style=\"font-style: italic\">pane</span>",false],
["pane%",">gui/pane_.html",[0,[2,"pane%"]],["racket/gui/base","racket/gui"]],
["panel",">framework/Panel.html","Panel",false],
["panel",">draw/brush_.html#(idx._(gentag._16._(lib._scribblings/draw/draw..scrbl)))",[7,"'panel"],false],
["panel",">gui/windowing-overview.html#(tech._panel)","<span style=\"font-style: italic\">panel</span>",false],
["panel%",">gui/panel_.html",[0,[2,"panel%"]],["racket/gui/base","racket/gui"]],
["panel:dragable-container-size",">framework/Panel.html#(def._((lib._framework/main..rkt)._panel~3adragable-container-size))",[0,[2,"panel:dragable-container-size"]],["framework"]],
["panel:dragable-mixin",">framework/Panel.html#(def._((lib._framework/main..rkt)._panel~3adragable-mixin))",[0,[2,"panel:dragable-mixin"]],["framework"]],
["panel:dragable-place-children",">framework/Panel.html#(def._((lib._framework/main..rkt)._panel~3adragable-place-children))",[0,[2,"panel:dragable-place-children"]],["framework"]],
["panel:dragable<%>",">framework/Panel.html#(def._((lib._framework/main..rkt)._panel~3adragable~3c~25~3e))",[0,[2,"panel:dragable<%>"]],["framework"]],
["panel:horizontal-dragable%",">framework/Panel.html#(def._((lib._framework/main..rkt)._panel~3ahorizontal-dragable~25))",[0,[2,"panel:horizontal-dragable%"]],["framework"]],
["panel:horizontal-dragable-mixin",">framework/Panel.html#(def._((lib._framework/main..rkt)._panel~3ahorizontal-dragable-mixin))",[0,[2,"panel:horizontal-dragable-mixin"]],["framework"]],
["panel:horizontal-dragable<%>",">framework/Panel.html#(def._((lib._framework/main..rkt)._panel~3ahorizontal-dragable~3c~25~3e))",[0,[2,"panel:horizontal-dragable<%>"]],["framework"]],
["panel:single%",">framework/Panel.html#(def._((lib._framework/main..rkt)._panel~3asingle~25))",[0,[2,"panel:single%"]],["framework"]],
["panel:single-mixin",">framework/Panel.html#(def._((lib._framework/main..rkt)._panel~3asingle-mixin))",[0,[2,"panel:single-mixin"]],["framework"]],
["panel:single-pane%",">framework/Panel.html#(def._((lib._framework/main..rkt)._panel~3asingle-pane~25))",[0,[2,"panel:single-pane%"]],["framework"]],
["panel:single-window-mixin",">framework/Panel.html#(def._((lib._framework/main..rkt)._panel~3asingle-window-mixin))",[0,[2,"panel:single-window-mixin"]],["framework"]],
["panel:single-window<%>",">framework/Panel.html#(def._((lib._framework/main..rkt)._panel~3asingle-window~3c~25~3e))",[0,[2,"panel:single-window<%>"]],["framework"]],
["panel:single<%>",">framework/Panel.html#(def._((lib._framework/main..rkt)._panel~3asingle~3c~25~3e))",[0,[2,"panel:single<%>"]],["framework"]],
["panel:splitter-mixin",">framework/Panel.html#(def._((lib._framework/main..rkt)._panel~3asplitter-mixin))",[0,[2,"panel:splitter-mixin"]],["framework"]],
["panel:splitter<%>",">framework/Panel.html#(def._((lib._framework/main..rkt)._panel~3asplitter~3c~25~3e))",[0,[2,"panel:splitter<%>"]],["framework"]],
["panel:vertical-dragable%",">framework/Panel.html#(def._((lib._framework/main..rkt)._panel~3avertical-dragable~25))",[0,[2,"panel:vertical-dragable%"]],["framework"]],
["panel:vertical-dragable-mixin",">framework/Panel.html#(def._((lib._framework/main..rkt)._panel~3avertical-dragable-mixin))",[0,[2,"panel:vertical-dragable-mixin"]],["framework"]],
["panel:vertical-dragable<%>",">framework/Panel.html#(def._((lib._framework/main..rkt)._panel~3avertical-dragable~3c~25~3e))",[0,[2,"panel:vertical-dragable<%>"]],["framework"]],
["panorama",">slideshow/Bounding_Box_Adjusters.html#(def._((lib._slideshow/pict..rkt)._panorama))",[0,[2,"panorama"]],["slideshow/pict","slideshow"]],
["para",">scribble/base.html#(def._((lib._scribble/base..rkt)._para))",[0,[2,"para"]],["scribble/base"]],
["para",">slideshow/Primary_Slide_Functions.html#(def._((lib._slideshow/base..rkt)._para))",[0,[2,"para"]],["slideshow/base","slideshow"]],
["paragraph",">scribble/core.html#(def._((lib._scribble/core..rkt)._paragraph))",[0,[2,"paragraph"]],["scribble/core"]],
["paragraph",">scribble/core.html#(tech._paragraph)","<span style=\"font-style: italic\">paragraph</span>",false],
["paragraph-content",">scribble/core.html#(def._((lib._scribble/core..rkt)._paragraph-content))",[0,[2,"paragraph-content"]],["scribble/core"]],
["paragraph-content",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._paragraph-content))",[0,[2,"paragraph-content"]],["scribble/struct"]],
["paragraph-end-line",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._paragraph-end-line))",[[0,[2,"paragraph-end-line"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["paragraph-end-position",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._paragraph-end-position))",[[0,[2,"paragraph-end-position"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["paragraph-start-line",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._paragraph-start-line))",[[0,[2,"paragraph-start-line"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["paragraph-start-position",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._paragraph-start-position))",[[0,[2,"paragraph-start-position"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["paragraph-style",">scribble/core.html#(def._((lib._scribble/core..rkt)._paragraph-style))",[0,[2,"paragraph-style"]],["scribble/core"]],
["paragraph?",">scribble/core.html#(def._((lib._scribble/core..rkt)._paragraph~3f))",[0,[2,"paragraph?"]],["scribble/core"]],
["parallel binding: let",">guide/let.html#(part._.Parallel_.Binding__let)",["Parallel Binding: ",[0,[1,"let"]]],false],
["parallel-compile",">raco/make.html#(def._((lib._setup/parallel-build..rkt)._parallel-compile))",[0,[2,"parallel-compile"]],["setup/parallel-build"]],
["parallel-compile-files",">raco/make.html#(def._((lib._setup/parallel-build..rkt)._parallel-compile-files))",[0,[2,"parallel-compile-files"]],["setup/parallel-build"]],
["parallel-lock-client",">raco/make.html#(def._((lib._compiler/cm..rkt)._parallel-lock-client))",[0,[2,"parallel-lock-client"]],["compiler/cm"]],
["parallel-workers",">raco/setup-plt-plt.html#(sig-val._((lib._setup/option-sig..rkt)._setup-option~5e._parallel-workers))",[0,[2,"parallel-workers"]],["setup/option-sig"]],
["parallelism with futures",">guide/performance.html#(part._effective-futures)","Parallelism with Futures",false],
["parallelism with places",">guide/performance.html#(part._effective-places)","Parallelism with Places",false],
["param",">html/index.html#(def._((lib._html/main..rkt)._param))",[0,[2,"param"]],["html"]],
["param?",">html/index.html#(def._((lib._html/main..rkt)._param~3f))",[0,[2,"param?"]],["html"]],
["parameter",">ts-reference/Legacy_Forms.html#(form._((lib._typed-racket/base-env/base-types-extra..rkt)._.Parameter))",[0,[1,"Parameter"]],["typed/racket/base","typed/racket"]],
["parameter",">guide/parameterize.html#(tech._parameter)","<span style=\"font-style: italic\">parameter</span>",false],
["parameter groups",">unstable/Parameter_Groups.html","Parameter Groups",false],
["parameter procedure",">reference/eval-model.html#(tech._parameter._procedure)","<span style=\"font-style: italic\">parameter procedure</span>",false],
["parameter-doc",">scribble/srcdoc.html#(form._((lib._scribble/srcdoc..rkt)._parameter-doc))",[0,[1,"parameter-doc"]],["scribble/srcdoc"]],
["parameter-group?",">unstable/Parameter_Groups.html#(def._((lib._unstable/parameter-group..rkt)._parameter-group~3f))",[0,[2,"parameter-group?"]],["unstable/parameter-group"]],
["parameter-procedure=?",">reference/parameters.html#(def._((quote._~23~25kernel)._parameter-procedure~3d~3f))",[0,[2,"parameter-procedure=?"]],["racket/base","racket"]],
["parameter/c",">reference/data-structure-contracts.html#(def._((lib._racket/contract/private/misc..rkt)._parameter/c))",[0,[2,"parameter/c"]],["racket/contract/base","racket/contract","racket"]],
["parameter?",">reference/parameters.html#(def._((quote._~23~25kernel)._parameter~3f))",[0,[2,"parameter?"]],["racket/base","racket"]],
["parameterization",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Parameterization))",[0,[1,"Parameterization"]],["typed/racket/base","typed/racket"]],
["parameterization",">reference/eval-model.html#(tech._parameterization)","<span style=\"font-style: italic\">parameterization</span>",false],
["parameterization?",">reference/parameters.html#(def._((quote._~23~25kernel)._parameterization~3f))",[0,[2,"parameterization?"]],["racket/base","racket"]],
["parameterizations",">inside/config.html","Parameterizations",false],
["parameterize",">reference/parameters.html#(form._((lib._racket/private/more-scheme..rkt)._parameterize))",[0,[1,"parameterize"]],["racket/base","racket"]],
["parameterize",">lazy/index.html#(form._((lib._lazy/main..rkt)._parameterize))",[0,[1,"parameterize"]],["lazy"]],
["parameterize",">srfi-std/srfi-39.html#parameterize",[0,[1,"parameterize"]],["srfi/39"]],
["parameterize*",">reference/parameters.html#(form._((lib._racket/private/more-scheme..rkt)._parameterize*))",[0,[1,"parameterize*"]],["racket/base","racket"]],
["parameterize*/group",">unstable/Parameter_Groups.html#(form._((lib._unstable/parameter-group..rkt)._parameterize*/group))",[0,[1,"parameterize*/group"]],["unstable/parameter-group"]],
["parameterize-break",">reference/breakhandler.html#(form._((lib._racket/private/more-scheme..rkt)._parameterize-break))",[0,[1,"parameterize-break"]],["racket/base","racket"]],
["parameterize/debug",">unstable/Debugging.html#(form._((lib._unstable/debug..rkt)._parameterize/debug))",[0,[1,"parameterize/debug"]],["unstable/debug"]],
["parameterize/group",">unstable/Parameter_Groups.html#(form._((lib._unstable/parameter-group..rkt)._parameterize/group))",[0,[1,"parameterize/group"]],["unstable/parameter-group"]],
["parameterized mixins",">guide/classes.html#(part._parammixins)","Parameterized Mixins",false],
["parameterized queries",">db/query-api.html#(tech._parameterized._query)","<span style=\"font-style: italic\">parameterized\nqueries</span>",false],
["parameterof",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types-extra..rkt)._.Parameterof))",[0,[1,"Parameterof"]],["typed/racket/base","typed/racket"]],
["parameters",">reference/eval-model.html#(part._parameter-model)","Parameters",false],
["parameters",">reference/parameters.html","Parameters",false],
["parameters",">xml/index.html#(part._.Parameters)","Parameters",false],
["parameters",">reference/eval-model.html#(tech._parameter)","<span style=\"font-style: italic\">Parameters</span>",false],
["parametric",">plot/renderer2d.html#(def._((lib._plot/main..rkt)._parametric))",[0,[2,"parametric"]],["plot"]],
["parametric contracts",">reference/parametric-contracts.html","Parametric Contracts",false],
["parametric->/c",">reference/parametric-contracts.html#(form._((lib._racket/contract/parametric..rkt)._parametric-~3e/c))",[0,[1,"parametric->/c"]],["racket/contract/parametric","racket/contract","racket"]],
["parametric-interval",">plot/renderer2d.html#(def._((lib._plot/main..rkt)._parametric-interval))",[0,[2,"parametric-interval"]],["plot"]],
["parametric-label",">plot/renderer2d.html#(def._((lib._plot/main..rkt)._parametric-label))",[0,[2,"parametric-label"]],["plot"]],
["parametric3d",">plot/renderer3d.html#(def._((lib._plot/main..rkt)._parametric3d))",[0,[2,"parametric3d"]],["plot"]],
["parametrische record-typ-definitionen",">deinprogramm/Parametrische_Record-Typ-Definitionen.html","Parametrische Record-Typ-Definitionen",false],
["parcheesi --- board game",">games/parcheesi.html",[[15,"<img src=\"parcheesi.png\" alt=\"\" />"]," ","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Parcheesi</span>"," ","&#8212;","<wbr></wbr>"," Board Game"],false],
["paren-color",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._paren-color))",[0,[2,"paren-color"]],["scribble/racket","scribble/scheme"]],
["paren-format",">web-server-internal/dispatch-log.html#(def._((lib._web-server/dispatchers/dispatch-log..rkt)._paren-format))",[0,[2,"paren-format"]],["web-server/dispatchers/dispatch-log"]],
["paren-pairs",">preprocessor/mztext.html#(def._((lib._preprocessor/mztext..rkt)._paren-pairs))",[0,[2,"paren-pairs"]],["preprocessor/mztext"]],
["paren-shape",">reference/reader.html#(idx._(gentag._30._(lib._scribblings/reference/reference..scrbl)))",[7,"'paren-shape"],false],
["paren-style",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._paren-style))",[0,[2,"paren-style"]],["redex/pict","redex"]],
["paren-tree%",">syntax-color/index.html#(def._((lib._syntax-color/paren-tree..rkt)._paren-tree~25))",[0,[2,"paren-tree%"]],["syntax-color/paren-tree"]],
["parent",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_296",[0,[1,"parent"]],["rnrs/records/syntactic-6"]],
["parent-rtd",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_306",[0,[1,"parent-rtd"]],["rnrs/records/syntactic-6"]],
["parenthesis",">tools/adding-languages.html#(idx._(gentag._14._(lib._scribblings/tools/tools..scrbl)))",[7,"'parenthesis"],false],
["parenthesis matching",">syntax-color/index.html#(part._.Parenthesis_.Matching)","Parenthesis Matching",false],
["parenthetical datalog module language",">datalog/Parenthetical_Datalog_Module_Language.html","Parenthetical Datalog Module Language",false],
["parse",">reference/syntax-model.html#(tech._parse)","<span style=\"font-style: italic\">parse</span>",false],
["parse-command-line",">reference/Command-Line_Parsing.html#(def._((lib._racket/cmdline..rkt)._parse-command-line))",[0,[2,"parse-command-line"]],["racket/cmdline","racket"]],
["parse-define-struct",">syntax/transformer-helpers.html#(def._((lib._syntax/struct..rkt)._parse-define-struct))",[0,[2,"parse-define-struct"]],["syntax/struct"]],
["parse-keyword-options",">syntax/syntax-helpers.html#(def._((lib._syntax/keyword..rkt)._parse-keyword-options))",[0,[2,"parse-keyword-options"]],["syntax/keyword"]],
["parse-keyword-options/eol",">syntax/syntax-helpers.html#(def._((lib._syntax/keyword..rkt)._parse-keyword-options/eol))",[0,[2,"parse-keyword-options/eol"]],["syntax/keyword"]],
["parse-post",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-2..rkt)._parse-post))",[0,"parse-post"],[]],
["parsed",">reference/syntax-model.html#(tech._parsed)","<span style=\"font-style: italic\">parsed</span>",false],
["parser",">parser-tools/Parsers.html#(form._((lib._parser-tools/yacc..rkt)._parser))",[0,[1,"parser"]],["parser-tools/yacc"]],
["parser tools: lex and yacc-style parsing",">parser-tools/index.html",["Parser Tools: ",[6,"lex"]," and ",[6,"yacc"],"-style Parsing"],false],
["parser-tools/lex",">parser-tools/Lexers.html",[9,[0,"parser-tools/lex"]],"module"],
["parser-tools/lex-plt-v200",">parser-tools/Lexers.html#(mod-path._parser-tools/lex-plt-v200)",[9,[0,"parser-tools/lex-plt-v200"]],"module"],
["parser-tools/lex-sre",">parser-tools/Lexers.html#(mod-path._parser-tools/lex-sre)",[9,[0,"parser-tools/lex-sre"]],"module"],
["parser-tools/yacc",">parser-tools/Parsers.html",[9,[0,"parser-tools/yacc"]],"module"],
["parser-tools/yacc-to-scheme",">parser-tools/Converting_yacc_or_bison_Grammars.html",[9,[0,"parser-tools/yacc-to-scheme"]],"module"],
["parsers",">parser-tools/Parsers.html","Parsers",false],
["parsing a cookie",">net/cookie.html#(part._.Parsing_a_cookie)","Parsing a cookie",false],
["parsing and specifying syntax",">syntax/stxparse.html","Parsing and Specifying Syntax",false],
["parsing define-like forms",">syntax/transformer-helpers.html#(part._define)",["Parsing ",[0,[1,"define"]],"-like Forms"],false],
["parsing json text into js-expressions",">json/index.html#(part._.Parsing_.J.S.O.N_.Text_into_.J.S-.Expressions)","Parsing JSON Text into JS-Expressions",false],
["parsing syntax",">syntax/Parsing_Syntax.html","Parsing Syntax",false],
["part",">scribble/core.html#(def._((lib._scribble/core..rkt)._part))",[0,[2,"part"]],["scribble/core"]],
["part",">scribble/core.html#(tech._part)","<span style=\"font-style: italic\">part</span>",false],
["part-blocks",">scribble/core.html#(def._((lib._scribble/core..rkt)._part-blocks))",[0,[2,"part-blocks"]],["scribble/core"]],
["part-collect-decl",">scribble/decode.html#(def._((lib._scribble/decode..rkt)._part-collect-decl))",[0,[2,"part-collect-decl"]],["scribble/decode"]],
["part-collect-decl-element",">scribble/decode.html#(def._((lib._scribble/decode..rkt)._part-collect-decl-element))",[0,[2,"part-collect-decl-element"]],["scribble/decode"]],
["part-collect-decl?",">scribble/decode.html#(def._((lib._scribble/decode..rkt)._part-collect-decl~3f))",[0,[2,"part-collect-decl?"]],["scribble/decode"]],
["part-collected-info",">scribble/core.html#(def._((lib._scribble/core..rkt)._part-collected-info))",[0,[2,"part-collected-info"]],["scribble/core"]],
["part-flow",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._part-flow))",[0,[2,"part-flow"]],["scribble/struct"]],
["part-index-decl",">scribble/decode.html#(def._((lib._scribble/decode..rkt)._part-index-decl))",[0,[2,"part-index-decl"]],["scribble/decode"]],
["part-index-decl-entry-seq",">scribble/decode.html#(def._((lib._scribble/decode..rkt)._part-index-decl-entry-seq))",[0,[2,"part-index-decl-entry-seq"]],["scribble/decode"]],
["part-index-decl-plain-seq",">scribble/decode.html#(def._((lib._scribble/decode..rkt)._part-index-decl-plain-seq))",[0,[2,"part-index-decl-plain-seq"]],["scribble/decode"]],
["part-index-decl?",">scribble/decode.html#(def._((lib._scribble/decode..rkt)._part-index-decl~3f))",[0,[2,"part-index-decl?"]],["scribble/decode"]],
["part-parts",">scribble/core.html#(def._((lib._scribble/core..rkt)._part-parts))",[0,[2,"part-parts"]],["scribble/core"]],
["part-relative element",">scribble/core.html#(tech._part._relative._element)","<span style=\"font-style: italic\">part-relative element</span>",false],
["part-relative-element",">scribble/core.html#(def._((lib._scribble/core..rkt)._part-relative-element))",[0,[2,"part-relative-element"]],["scribble/core"]],
["part-relative-element-plain",">scribble/core.html#(def._((lib._scribble/core..rkt)._part-relative-element-plain))",[0,[2,"part-relative-element-plain"]],["scribble/core"]],
["part-relative-element-resolve",">scribble/core.html#(def._((lib._scribble/core..rkt)._part-relative-element-resolve))",[0,[2,"part-relative-element-resolve"]],["scribble/core"]],
["part-relative-element-sizer",">scribble/core.html#(def._((lib._scribble/core..rkt)._part-relative-element-sizer))",[0,[2,"part-relative-element-sizer"]],["scribble/core"]],
["part-relative-element?",">scribble/core.html#(def._((lib._scribble/core..rkt)._part-relative-element~3f))",[0,[2,"part-relative-element?"]],["scribble/core"]],
["part-start",">scribble/decode.html#(def._((lib._scribble/decode..rkt)._part-start))",[0,[2,"part-start"]],["scribble/decode"]],
["part-start-depth",">scribble/decode.html#(def._((lib._scribble/decode..rkt)._part-start-depth))",[0,[2,"part-start-depth"]],["scribble/decode"]],
["part-start-style",">scribble/decode.html#(def._((lib._scribble/decode..rkt)._part-start-style))",[0,[2,"part-start-style"]],["scribble/decode"]],
["part-start-tag-prefix",">scribble/decode.html#(def._((lib._scribble/decode..rkt)._part-start-tag-prefix))",[0,[2,"part-start-tag-prefix"]],["scribble/decode"]],
["part-start-tags",">scribble/decode.html#(def._((lib._scribble/decode..rkt)._part-start-tags))",[0,[2,"part-start-tags"]],["scribble/decode"]],
["part-start-title",">scribble/decode.html#(def._((lib._scribble/decode..rkt)._part-start-title))",[0,[2,"part-start-title"]],["scribble/decode"]],
["part-start?",">scribble/decode.html#(def._((lib._scribble/decode..rkt)._part-start~3f))",[0,[2,"part-start?"]],["scribble/decode"]],
["part-style",">scribble/core.html#(def._((lib._scribble/core..rkt)._part-style))",[0,[2,"part-style"]],["scribble/core"]],
["part-tag-decl",">scribble/decode.html#(def._((lib._scribble/decode..rkt)._part-tag-decl))",[0,[2,"part-tag-decl"]],["scribble/decode"]],
["part-tag-decl-tag",">scribble/decode.html#(def._((lib._scribble/decode..rkt)._part-tag-decl-tag))",[0,[2,"part-tag-decl-tag"]],["scribble/decode"]],
["part-tag-decl?",">scribble/decode.html#(def._((lib._scribble/decode..rkt)._part-tag-decl~3f))",[0,[2,"part-tag-decl?"]],["scribble/decode"]],
["part-tag-prefix",">scribble/core.html#(def._((lib._scribble/core..rkt)._part-tag-prefix))",[0,[2,"part-tag-prefix"]],["scribble/core"]],
["part-tags",">scribble/core.html#(def._((lib._scribble/core..rkt)._part-tags))",[0,[2,"part-tags"]],["scribble/core"]],
["part-title-content",">scribble/core.html#(def._((lib._scribble/core..rkt)._part-title-content))",[0,[2,"part-title-content"]],["scribble/core"]],
["part-title-content",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._part-title-content))",[0,[2,"part-title-content"]],["scribble/struct"]],
["part-to-collect",">scribble/core.html#(def._((lib._scribble/core..rkt)._part-to-collect))",[0,[2,"part-to-collect"]],["scribble/core"]],
["part?",">scribble/core.html#(def._((lib._scribble/core..rkt)._part~3f))",[0,[2,"part?"]],["scribble/core"]],
["partial expansion",">reference/syntax-model.html#(part._partial-expansion)","Partial Expansion",false],
["partial expansion",">reference/syntax-model.html#(tech._partial._expansion)","<span style=\"font-style: italic\">partial expansion</span>",false],
["partial-offset",">gui/snip_.html#(meth._(((lib._racket/snip..rkt)._snip~25)._partial-offset))",[[0,[2,"partial-offset"]],[14,[" (method of ",[0,[2,"snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["partition",">reference/pairs.html#(def._((lib._racket/list..rkt)._partition))",[0,[2,"partition"]],["racket/list","racket"]],
["partition",">r6rs-lib-std/r6rs-lib-Z-H-4.html#node_idx_210",[0,[2,"partition"]],["rnrs/lists-6"]],
["partition",">mzlib/mzlib_integer-set.html#(def._((lib._mzlib/integer-set..rkt)._partition))",[0,[2,"partition"]],["mzlib/integer-set"]],
["partition",">srfi-std/srfi-1.html#partition",[0,[2,"partition"]],["srfi/1"]],
["partition!",">srfi-std/srfi-1.html#partition!",[0,[2,"partition!"]],["srfi/1"]],
["partly-smoothed",">gui/style-delta_.html#(idx._(gentag._185._(lib._scribblings/gui/gui..scrbl)))",[7,"'partly-smoothed"],false],
["partly-smoothed",">draw/font_.html#(idx._(gentag._43._(lib._scribblings/draw/draw..scrbl)))",[7,"'partly-smoothed"],false],
["parts, flows, blocks, and paragraphs",">scribble/core.html#(part._parts)","Parts, Flows, Blocks, and Paragraphs",false],
["password protection",">web-server-internal/dispatch-passwords.html","Password Protection",false],
["password->digest-ha1",">web-server/http.html#(def._((lib._web-server/http/digest-auth..rkt)._password-~3edigest-.H.A1))",[0,[2,"password->digest-HA1"]],["web-server/http/digest-auth"]],
["password-authentication",">web-server-internal/Web_Servers.html#(idx._(gentag._30._(lib._web-server/scribblings/web-server-internal..scrbl)))","password-authentication",false],
["password-connection-timeout",">web-server-internal/Web_Servers.html#(idx._(gentag._19._(lib._web-server/scribblings/web-server-internal..scrbl)))","password-connection-timeout",false],
["password-file->authorized?",">web-server-internal/dispatch-passwords.html#(def._((lib._web-server/dispatchers/dispatch-passwords..rkt)._password-file-~3eauthorized~3f))",[0,[2,"password-file->authorized?"]],["web-server/dispatchers/dispatch-passwords"]],
["password-input",">web-server/formlets.html#(def._((lib._web-server/formlets/input..rkt)._password-input))",[0,[2,"password-input"]],["web-server/formlets/input"]],
["password-rejected",">net/pop3.html#(def._((lib._net/pop3..rkt)._password-rejected))",[0,[2,"password-rejected"]],["net/pop3"]],
["password-rejected?",">net/pop3.html#(def._((lib._net/pop3..rkt)._password-rejected~3f))",[0,[2,"password-rejected?"]],["net/pop3"]],
["passwords-refreshed",">web-server-internal/Web_Servers.html#(idx._(gentag._13._(lib._web-server/scribblings/web-server-internal..scrbl)))","passwords-refreshed",false],
["past evaluation results",">xrepl/index.html#(part._past-vals)","Past Evaluation Results",false],
["paste",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._paste))",[[0,[2,"paste"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["paste",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._paste))",[[0,[2,"paste"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["paste menu item",">drracket/Menus.html#(idx._(gentag._75._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Paste</span> menu item",false],
["paste-click-region",">framework/Keymap.html#(idx._(gentag._35._(lib._scribblings/framework/framework..scrbl)))","paste-click-region",false],
["paste-clipboard",">framework/Keymap.html#(idx._(gentag._32._(lib._scribblings/framework/framework..scrbl)))","paste-clipboard",false],
["paste-next",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._paste-next))",[[0,[2,"paste-next"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["paste-x-selection",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._paste-x-selection))",[[0,[2,"paste-x-selection"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["paste-x-selection",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._paste-x-selection))",[[0,[2,"paste-x-selection"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["pasteboard",">framework/Pasteboard.html","Pasteboard",false],
["pasteboard editor",">gui/editor-overview.html#(tech._pasteboard._editor)","<span style=\"font-style: italic\">pasteboard editor</span>",false],
["pasteboard%",">gui/pasteboard_.html",[0,[2,"pasteboard%"]],["racket/gui/base","racket/gui"]],
["pasteboard:backup-autosave%",">framework/Pasteboard.html#(def._((lib._framework/main..rkt)._pasteboard~3abackup-autosave~25))",[0,[2,"pasteboard:backup-autosave%"]],["framework"]],
["pasteboard:basic%",">framework/Pasteboard.html#(def._((lib._framework/main..rkt)._pasteboard~3abasic~25))",[0,[2,"pasteboard:basic%"]],["framework"]],
["pasteboard:file%",">framework/Pasteboard.html#(def._((lib._framework/main..rkt)._pasteboard~3afile~25))",[0,[2,"pasteboard:file%"]],["framework"]],
["pasteboard:info%",">framework/Pasteboard.html#(def._((lib._framework/main..rkt)._pasteboard~3ainfo~25))",[0,[2,"pasteboard:info%"]],["framework"]],
["pasteboard:keymap%",">framework/Pasteboard.html#(def._((lib._framework/main..rkt)._pasteboard~3akeymap~25))",[0,[2,"pasteboard:keymap%"]],["framework"]],
["pasteboard:standard-style-list%",">framework/Pasteboard.html#(def._((lib._framework/main..rkt)._pasteboard~3astandard-style-list~25))",[0,[2,"pasteboard:standard-style-list%"]],["framework"]],
["patchlevel",">version/index.html#(def._((lib._version/patchlevel..rkt)._patchlevel))",[0,[2,"patchlevel"]],["version/patchlevel"]],
["path",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Path))",[0,[1,"Path"]],["typed/racket/base","typed/racket"]],
["path",">reference/Filesystem.html#(idx._(gentag._289._(lib._scribblings/reference/reference..scrbl)))",[6,"PATH"],false],
["path",">draw/overview.html#(tech._path)","<span style=\"font-style: italic\">path</span>",false],
["path",">reference/pathutils.html#(tech._path)","<span style=\"font-style: italic\">path</span>",false],
["path dialog",">mrlib/Path_Dialog.html","Path Dialog",false],
["path element",">reference/More_Path_Utilities.html#(tech._path._element)","<span style=\"font-style: italic\">path element</span>",false],
["path utils",">framework/Path_Utils.html","Path Utils",false],
["path->bibdb",">scriblib/bibtex.html#(def._((lib._scriblib/bibtex..rkt)._path-~3ebibdb))",[0,[2,"path->bibdb"]],["scriblib/bibtex"]],
["path->bytes",">reference/Manipulating_Paths.html#(def._((quote._~23~25kernel)._path-~3ebytes))",[0,[2,"path->bytes"]],["racket/base","racket"]],
["path->complete-path",">reference/Manipulating_Paths.html#(def._((quote._~23~25kernel)._path-~3ecomplete-path))",[0,[2,"path->complete-path"]],["racket/base","racket"]],
["path->directory-path",">reference/Manipulating_Paths.html#(def._((quote._~23~25kernel)._path-~3edirectory-path))",[0,[2,"path->directory-path"]],["racket/base","racket"]],
["path->main-collects-relative",">raco/relative-paths.html#(def._((lib._setup/main-collects..rkt)._path-~3emain-collects-relative))",[0,[2,"path->main-collects-relative"]],["setup/main-collects"]],
["path->package-version",">planet/Utility_Libraries.html#(def._((lib._planet/util..rkt)._path-~3epackage-version))",[0,[2,"path->package-version"]],["planet/util"]],
["path->relative-string/library",">raco/relative-paths.html#(def._((lib._setup/path-to-relative..rkt)._path-~3erelative-string/library))",[0,[2,"path->relative-string/library"]],["setup/path-to-relative"]],
["path->relative-string/setup",">raco/relative-paths.html#(def._((lib._setup/path-to-relative..rkt)._path-~3erelative-string/setup))",[0,[2,"path->relative-string/setup"]],["setup/path-to-relative"]],
["path->servlet/c",">web-server-internal/dispatch-servlets.html#(def._((lib._web-server/servlet/setup..rkt)._path-~3eservlet/c))",[0,[2,"path->servlet/c"]],["web-server/servlet/setup"]],
["path->string",">reference/Manipulating_Paths.html#(def._((quote._~23~25kernel)._path-~3estring))",[0,[2,"path->string"]],["racket/base","racket"]],
["path->url",">net/url.html#(def._((lib._net/url..rkt)._path-~3eurl))",[0,[2,"path->url"]],["net/url"]],
["path-add-suffix",">reference/Manipulating_Paths.html#(def._((lib._racket/private/misc..rkt)._path-add-suffix))",[0,[2,"path-add-suffix"]],["racket/base","racket"]],
["path-convention-type",">reference/Manipulating_Paths.html#(def._((quote._~23~25kernel)._path-convention-type))",[0,[2,"path-convention-type"]],["racket/base","racket"]],
["path-dialog%",">mrlib/Path_Dialog.html#(def._((lib._mrlib/path-dialog..rkt)._path-dialog~25))",[0,[2,"path-dialog%"]],["mrlib/path-dialog"]],
["path-element->bytes",">reference/Manipulating_Paths.html#(def._((quote._~23~25kernel)._path-element-~3ebytes))",[0,[2,"path-element->bytes"]],["racket/base","racket"]],
["path-element->string",">reference/Manipulating_Paths.html#(def._((quote._~23~25kernel)._path-element-~3estring))",[0,[2,"path-element->string"]],["racket/base","racket"]],
["path-element?",">reference/More_Path_Utilities.html#(def._((lib._racket/path..rkt)._path-element~3f))",[0,[2,"path-element?"]],["racket/path","racket"]],
["path-for-some-system",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Path-.For-.Some-.System))",[0,[1,"Path-For-Some-System"]],["typed/racket/base","typed/racket"]],
["path-for-some-system?",">reference/Manipulating_Paths.html#(def._((quote._~23~25kernel)._path-for-some-system~3f))",[0,[2,"path-for-some-system?"]],["racket/base","racket"]],
["path-list-string->path-list",">reference/Filesystem.html#(def._((lib._racket/private/misc..rkt)._path-list-string-~3epath-list))",[0,[2,"path-list-string->path-list"]],["racket/base","racket"]],
["path-only",">reference/More_Path_Utilities.html#(def._((lib._racket/path..rkt)._path-only))",[0,[2,"path-only"]],["racket/path","racket"]],
["path-piece?",">unstable/contract.html#(def._((lib._unstable/contract..rkt)._path-piece~3f))",[0,[2,"path-piece?"]],["unstable/contract"]],
["path-replace-suffix",">reference/Manipulating_Paths.html#(def._((lib._racket/private/misc..rkt)._path-replace-suffix))",[0,[2,"path-replace-suffix"]],["racket/base","racket"]],
["path-string",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Path-.String))",[0,[1,"Path-String"]],["typed/racket/base","typed/racket"]],
["path-string?",">reference/Manipulating_Paths.html#(def._((lib._racket/private/misc..rkt)._path-string~3f))",[0,[2,"path-string?"]],["racket/base","racket"]],
["path-up",">reference/require.html#(form._((lib._racket/require..rkt)._path-up))",[0,[1,"path-up"]],["racket/require"]],
["path-utils:generate-autosave-name",">framework/Path_Utils.html#(def._((lib._framework/main..rkt)._path-utils~3agenerate-autosave-name))",[0,[2,"path-utils:generate-autosave-name"]],["framework"]],
["path-utils:generate-backup-name",">framework/Path_Utils.html#(def._((lib._framework/main..rkt)._path-utils~3agenerate-backup-name))",[0,[2,"path-utils:generate-backup-name"]],["framework"]],
["path-without-base",">web-server-internal/misc-util.html#(def._((lib._web-server/private/util..rkt)._path-without-base))",[0,[2,"path-without-base"]],["web-server/private/util"]],
["path/param",">net/url.html#(def._((lib._net/url-structs..rkt)._path/param))",[0,[2,"path/param"]],["net/url-structs","net/url"]],
["path/param-param",">net/url.html#(def._((lib._net/url-structs..rkt)._path/param-param))",[0,[2,"path/param-param"]],["net/url-structs","net/url"]],
["path/param-path",">net/url.html#(def._((lib._net/url-structs..rkt)._path/param-path))",[0,[2,"path/param-path"]],["net/url-structs","net/url"]],
["path/param?",">net/url.html#(def._((lib._net/url-structs..rkt)._path/param~3f))",[0,[2,"path/param?"]],["net/url-structs","net/url"]],
["path?",">reference/Manipulating_Paths.html#(def._((quote._~23~25kernel)._path~3f))",[0,[2,"path?"]],["racket/base","racket"]],
["pathlist-closure",">reference/Filesystem.html#(def._((lib._racket/file..rkt)._pathlist-closure))",[0,[2,"pathlist-closure"]],["racket/file","racket"]],
["pathname->vicinity",">srfi-std/srfi-59.html#pathname-to-vicinity",[0,[2,"pathname->vicinity"]],["srfi/59"]],
["paths flipping",">draw/dc-path_.html#(idx._(gentag._27._(lib._scribblings/draw/draw..scrbl)))","paths, flipping",false],
["paths",">reference/pathutils.html","Paths",false],
["paths",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._paths))",[0,[2,"paths"]],["web-server/configuration/configuration-table-structs"]],
["paths",">web-server-internal/Web_Servers.html#(idx._(gentag._23._(lib._web-server/scribblings/web-server-internal..scrbl)))","paths",false],
["paths-conf",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._paths-conf))",[0,[2,"paths-conf"]],["web-server/configuration/configuration-table-structs"]],
["paths-host-base",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._paths-host-base))",[0,[2,"paths-host-base"]],["web-server/configuration/configuration-table-structs"]],
["paths-htdocs",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._paths-htdocs))",[0,[2,"paths-htdocs"]],["web-server/configuration/configuration-table-structs"]],
["paths-log",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._paths-log))",[0,[2,"paths-log"]],["web-server/configuration/configuration-table-structs"]],
["paths-mime-types",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._paths-mime-types))",[0,[2,"paths-mime-types"]],["web-server/configuration/configuration-table-structs"]],
["paths-passwords",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._paths-passwords))",[0,[2,"paths-passwords"]],["web-server/configuration/configuration-table-structs"]],
["paths-servlet",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._paths-servlet))",[0,[2,"paths-servlet"]],["web-server/configuration/configuration-table-structs"]],
["paths?",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._paths~3f))",[0,[2,"paths?"]],["web-server/configuration/configuration-table-structs"]],
["pattern",">syntax/stxparse-specifying.html#(form._((lib._syntax/parse..rkt)._pattern))",[0,[1,"pattern"]],["syntax/parse"]],
["pattern",">redex/The_Redex_Reference.html#(tech._pattern)","<span style=\"font-style: italic\">pattern</span>",false],
["pattern directives",">syntax/stxparse-specifying.html#(part._.Pattern_.Directives)","Pattern Directives",false],
["pattern directives",">syntax/stxparse-specifying.html#(tech._pattern._directive)","<span style=\"font-style: italic\">pattern directives</span>",false],
["pattern matching",">guide/match.html","Pattern Matching",false],
["pattern matching",">reference/match.html","Pattern Matching",false],
["pattern matching",">reference/regexp.html","pattern matching",false],
["pattern variable",">reference/stx-patterns.html#(tech._pattern._variable)","<span style=\"font-style: italic\">pattern variable</span>",false],
["pattern variable",">syntax/stxparse-patterns.html#(tech._pattern._variable)","<span style=\"font-style: italic\">pattern variable</span>",false],
["pattern variables",">reference/syntax-util.html#(part._.Pattern_variables)","Pattern variables",false],
["pattern variables",">guide/match.html#(tech._pattern._variable)","<span style=\"font-style: italic\">pattern variables</span>",false],
["pattern variables and attributes",">syntax/stxparse-specifying.html#(part._.Pattern_.Variables_and_.Attributes)","Pattern Variables and Attributes",false],
["pattern-based macro",">guide/pattern-macros.html#(tech._pattern._based._macro)","<span style=\"font-style: italic\">pattern-based macro</span>",false],
["pattern-based macros",">guide/pattern-macros.html","Pattern-Based Macros",false],
["pattern-based syntax matching",">reference/stx-patterns.html","Pattern-Based Syntax Matching",false],
["pattern-directive",">syntax/stxparse-specifying.html#(idx._(gentag._0._(lib._syntax/scribblings/syntax..scrbl)))","pattern-directive",false],
["pattern-sequence",">redex/The_Redex_Reference.html#(tech._pattern._sequence)",[0,"pattern-sequence"],false],
["patterns",">redex/The_Redex_Reference.html#(part._.Patterns)","Patterns",false],
["pause",">cards/index.html#(meth._(((lib._games/cards..rkt)._table~3c~25~3e)._pause))",[[0,[2,"pause"]],[14,[" (method of ",[0,[2,"table<%>"]],")"]]],["games/cards"]],
["pause",">drracket/debugger.html#(idx._(gentag._38._(lib._scribblings/drracket/drracket..scrbl)))","Pause",false],
["pause",">gui/key-event_.html#(idx._(gentag._46._(lib._scribblings/gui/gui..scrbl)))",[7,"'pause"],false],
["pause-icon",">images/Icons.html#(def._((lib._images/icons/control..rkt)._pause-icon))",[0,[2,"pause-icon"]],["images/icons/control"]],
["pause-on-errors",">raco/setup-plt-plt.html#(sig-val._((lib._setup/option-sig..rkt)._setup-option~5e._pause-on-errors))",[0,[2,"pause-on-errors"]],["setup/option-sig"]],
["pc",">reference/characters.html#(idx._(gentag._139._(lib._scribblings/reference/reference..scrbl)))",[7,"'pc"],false],
["pcase-lambda:",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._pcase-lambda~3a))",[0,[1,"pcase-lambda:"]],["typed/racket/base","typed/racket"]],
["pcdata",">xml/index.html#(def._((lib._xml/main..rkt)._pcdata))",[0,[2,"pcdata"]],["xml"]],
["pcdata-string",">xml/index.html#(def._((lib._xml/main..rkt)._pcdata-string))",[0,[2,"pcdata-string"]],["xml"]],
["pcdata?",">xml/index.html#(def._((lib._xml/main..rkt)._pcdata~3f))",[0,[2,"pcdata?"]],["xml"]],
["pd",">reference/characters.html#(idx._(gentag._138._(lib._scribblings/reference/reference..scrbl)))",[7,"'pd"],false],
["pdefine:",">ts-reference/Legacy_Forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._pdefine~3a))",[0,[1,"pdefine:"]],["typed/racket/base","typed/racket"]],
["pdf renderer",">scribble/renderer.html#(part._.P.D.F_.Renderer)","PDF Renderer",false],
["pdf-dc%",">draw/pdf-dc_.html",[0,[2,"pdf-dc%"]],["racket/draw"]],
["pdf-latex",">slatex-wrap/index.html#(def._((lib._slatex/slatex-wrapper..rkt)._pdf-latex))",[0,[2,"pdf-latex"]],["slatex/slatex-wrapper"]],
["pdf-slatex",">slatex-wrap/index.html#(def._((lib._slatex/slatex-wrapper..rkt)._pdf-slatex))",[0,[2,"pdf-slatex"]],["slatex/slatex-wrapper"]],
["pe",">reference/characters.html#(idx._(gentag._135._(lib._scribblings/reference/reference..scrbl)))",[7,"'pe"],false],
["peano",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtle-examples..rkt)._peano))",[0,[2,"peano"]],["graphics/turtle-examples"]],
["peano space-filling curve",">turtles/Traditional_Turtles.html#(idx._(gentag._4._(lib._graphics/scribblings/turtles..scrbl)))","Peano space-filling curve",false],
["peano-position-turtle",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtle-examples..rkt)._peano-position-turtle))",[0,[2,"peano-position-turtle"]],["graphics/turtle-examples"]],
["peano-size",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtle-examples..rkt)._peano-size))",[0,[2,"peano-size"]],["graphics/turtle-examples"]],
["peek-byte",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._peek-byte))",[0,[2,"peek-byte"]],["racket/base","racket"]],
["peek-byte-or-special",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._peek-byte-or-special))",[0,[2,"peek-byte-or-special"]],["racket/base","racket"]],
["peek-bytes",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._peek-bytes))",[0,[2,"peek-bytes"]],["racket/base","racket"]],
["peek-bytes!",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._peek-bytes!))",[0,[2,"peek-bytes!"]],["racket/base","racket"]],
["peek-bytes!-evt",">reference/port-lib.html#(def._((lib._racket/port..rkt)._peek-bytes!-evt))",[0,[2,"peek-bytes!-evt"]],["racket/port","racket"]],
["peek-bytes-avail!",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._peek-bytes-avail!))",[0,[2,"peek-bytes-avail!"]],["racket/base","racket"]],
["peek-bytes-avail!*",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._peek-bytes-avail!*))",[0,[2,"peek-bytes-avail!*"]],["racket/base","racket"]],
["peek-bytes-avail!-evt",">reference/port-lib.html#(def._((lib._racket/port..rkt)._peek-bytes-avail!-evt))",[0,[2,"peek-bytes-avail!-evt"]],["racket/port","racket"]],
["peek-bytes-avail!/enable-break",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._peek-bytes-avail!/enable-break))",[0,[2,"peek-bytes-avail!/enable-break"]],["racket/base","racket"]],
["peek-bytes-evt",">reference/port-lib.html#(def._((lib._racket/port..rkt)._peek-bytes-evt))",[0,[2,"peek-bytes-evt"]],["racket/port","racket"]],
["peek-char",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._peek-char))",[0,[2,"peek-char"]],["racket/base","racket"]],
["peek-char",">r5rs-std/r5rs-Z-H-9.html#%_idx_644",[0,[2,"peek-char"]],["r5rs"]],
["peek-char",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_814",[0,[2,"peek-char"]],["rnrs/io/simple-6"]],
["peek-char-or-special",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._peek-char-or-special))",[0,[2,"peek-char-or-special"]],["racket/base","racket"]],
["peek-string",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._peek-string))",[0,[2,"peek-string"]],["racket/base","racket"]],
["peek-string!",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._peek-string!))",[0,[2,"peek-string!"]],["racket/base","racket"]],
["peek-string!-evt",">reference/port-lib.html#(def._((lib._racket/port..rkt)._peek-string!-evt))",[0,[2,"peek-string!-evt"]],["racket/port","racket"]],
["peek-string-evt",">reference/port-lib.html#(def._((lib._racket/port..rkt)._peek-string-evt))",[0,[2,"peek-string-evt"]],["racket/port","racket"]],
["peeking-input-port",">reference/port-lib.html#(def._((lib._racket/port..rkt)._peeking-input-port))",[0,[2,"peeking-input-port"]],["racket/port","racket"]],
["peer verification",">openssl/index.html#(part._peer-verif)","Peer Verification",false],
["pen",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._pen))",[0,[2,"pen"]],["2htdp/image"]],
["pen stipple",">draw/pen_.html#(tech._pen._stipple)","<span style=\"font-style: italic\">pen stipple</span>",false],
["pen style",">draw/pen_.html#(tech._pen._style)","<span style=\"font-style: italic\">pen style</span>",false],
["pen%",">draw/pen_.html",[0,[2,"pen%"]],["racket/draw"]],
["pen, brush, and color objects",">draw/overview.html#(part._.Pen__.Brush__and_.Color_.Objects)","Pen, Brush, and Color Objects",false],
["pen-cap",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._pen-cap))",[0,[2,"pen-cap"]],["2htdp/image"]],
["pen-cap?",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._pen-cap~3f))",[0,[2,"pen-cap?"]],["2htdp/image"]],
["pen-color",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._pen-color))",[0,[2,"pen-color"]],["2htdp/image"]],
["pen-join",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._pen-join))",[0,[2,"pen-join"]],["2htdp/image"]],
["pen-join?",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._pen-join~3f))",[0,[2,"pen-join?"]],["2htdp/image"]],
["pen-list%",">draw/pen-list_.html",[0,[2,"pen-list%"]],["racket/draw"]],
["pen-style",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._pen-style))",[0,[2,"pen-style"]],["2htdp/image"]],
["pen-style?",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._pen-style~3f))",[0,[2,"pen-style?"]],["2htdp/image"]],
["pen-width",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._pen-width))",[0,[2,"pen-width"]],["2htdp/image"]],
["pen-widths/c",">plot/contracts.html#(def._((lib._plot/utils..rkt)._pen-widths/c))",[0,[2,"pen-widths/c"]],["plot/utils"]],
["pen?",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._pen~3f))",[0,[2,"pen?"]],["2htdp/image"]],
["per-symbol special printing",">reference/pretty-print.html#(part._.Per-.Symbol_.Special_.Printing)","Per-Symbol Special Printing",false],
["perform-search",">tools/Documentation_Utilities.html#(def._((lib._help/search..rkt)._perform-search))",[0,"perform-search"],["help/search"]],
["performance",">guide/performance.html","Performance",false],
["performance hints: begin-encourage-inline",">reference/performance-hint.html",["Performance Hints: ",[0,[1,"begin-encourage-inline"]]],false],
["performance in drracket",">guide/performance.html#(part._.Dr.Racket-perf)","Performance in DrRacket",false],
["permanently",">web-server/http.html#(def._((lib._web-server/http/redirect..rkt)._permanently))",[0,[2,"permanently"]],["web-server/http/redirect"]],
["permissive-xexprs",">xml/index.html#(def._((lib._xml/main..rkt)._permissive-xexprs))",[0,[2,"permissive-xexprs"]],["xml"]],
["permissive/c",">xml/index.html#(def._((lib._xml/main..rkt)._permissive/c))",[0,[2,"permissive/c"]],["xml"]],
["perspective-projection",">images/Spatial_Transformations.html#(def._((lib._images/flomap..rkt)._perspective-projection))",[0,[2,"perspective-projection"]],["images/flomap"]],
["pf",">reference/characters.html#(idx._(gentag._137._(lib._scribblings/reference/reference..scrbl)))",[7,"'pf"],false],
["pflag",">scribble/doc-strings.html#(def._((lib._scribble/manual..rkt)._.P.Flag))",[0,[2,"PFlag"]],["scribble/manual"]],
["pg-array",">db/util.html#(def._((lib._db/util/postgresql..rkt)._pg-array))",[0,[2,"pg-array"]],["db/util/postgresql"]],
["pg-array->list",">db/util.html#(def._((lib._db/util/postgresql..rkt)._pg-array-~3elist))",[0,[2,"pg-array->list"]],["db/util/postgresql"]],
["pg-array-contents",">db/util.html#(def._((lib._db/util/postgresql..rkt)._pg-array-contents))",[0,[2,"pg-array-contents"]],["db/util/postgresql"]],
["pg-array-dimension-lengths",">db/util.html#(def._((lib._db/util/postgresql..rkt)._pg-array-dimension-lengths))",[0,[2,"pg-array-dimension-lengths"]],["db/util/postgresql"]],
["pg-array-dimension-lower-bounds",">db/util.html#(def._((lib._db/util/postgresql..rkt)._pg-array-dimension-lower-bounds))",[0,[2,"pg-array-dimension-lower-bounds"]],["db/util/postgresql"]],
["pg-array-dimensions",">db/util.html#(def._((lib._db/util/postgresql..rkt)._pg-array-dimensions))",[0,[2,"pg-array-dimensions"]],["db/util/postgresql"]],
["pg-array-ref",">db/util.html#(def._((lib._db/util/postgresql..rkt)._pg-array-ref))",[0,[2,"pg-array-ref"]],["db/util/postgresql"]],
["pg-array?",">db/util.html#(def._((lib._db/util/postgresql..rkt)._pg-array~3f))",[0,[2,"pg-array?"]],["db/util/postgresql"]],
["pg-box",">db/util.html#(def._((lib._db/util/postgresql..rkt)._pg-box))",[0,[2,"pg-box"]],["db/util/postgresql"]],
["pg-box-ne",">db/util.html#(def._((lib._db/util/postgresql..rkt)._pg-box-ne))",[0,[2,"pg-box-ne"]],["db/util/postgresql"]],
["pg-box-sw",">db/util.html#(def._((lib._db/util/postgresql..rkt)._pg-box-sw))",[0,[2,"pg-box-sw"]],["db/util/postgresql"]],
["pg-box?",">db/util.html#(def._((lib._db/util/postgresql..rkt)._pg-box~3f))",[0,[2,"pg-box?"]],["db/util/postgresql"]],
["pg-circle",">db/util.html#(def._((lib._db/util/postgresql..rkt)._pg-circle))",[0,[2,"pg-circle"]],["db/util/postgresql"]],
["pg-circle-center",">db/util.html#(def._((lib._db/util/postgresql..rkt)._pg-circle-center))",[0,[2,"pg-circle-center"]],["db/util/postgresql"]],
["pg-circle-radius",">db/util.html#(def._((lib._db/util/postgresql..rkt)._pg-circle-radius))",[0,[2,"pg-circle-radius"]],["db/util/postgresql"]],
["pg-circle?",">db/util.html#(def._((lib._db/util/postgresql..rkt)._pg-circle~3f))",[0,[2,"pg-circle?"]],["db/util/postgresql"]],
["pg-path",">db/util.html#(def._((lib._db/util/postgresql..rkt)._pg-path))",[0,[2,"pg-path"]],["db/util/postgresql"]],
["pg-path-closed?",">db/util.html#(def._((lib._db/util/postgresql..rkt)._pg-path-closed~3f))",[0,[2,"pg-path-closed?"]],["db/util/postgresql"]],
["pg-path-points",">db/util.html#(def._((lib._db/util/postgresql..rkt)._pg-path-points))",[0,[2,"pg-path-points"]],["db/util/postgresql"]],
["pg-path?",">db/util.html#(def._((lib._db/util/postgresql..rkt)._pg-path~3f))",[0,[2,"pg-path?"]],["db/util/postgresql"]],
["phase",">guide/phases.html#(tech._phase)","<span style=\"font-style: italic\">phase</span>",false],
["phase level",">guide/phases.html#(tech._phase._level)","<span style=\"font-style: italic\">phase level</span>",false],
["phase level",">reference/syntax-model.html#(tech._phase._level)","<span style=\"font-style: italic\">phase level</span>",false],
["phase level -1",">guide/stx-phases.html#(tech._phase._level._1)","<span style=\"font-style: italic\">phase level\n-1</span>",false],
["phase level 2",">guide/stx-phases.html#(tech._phase._level._2)","<span style=\"font-style: italic\">phase level\n2</span>",false],
["phase-of-enclosing-module",">unstable/syntax.html#(form._((lib._unstable/syntax..rkt)._phase-of-enclosing-module))",[0,[1,"phase-of-enclosing-module"]],["unstable/syntax"]],
["phase-shift",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._phase-shift))",[0,[2,"phase-shift"]],["compiler/zo-structs"]],
["phase-shift-amt",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._phase-shift-amt))",[0,[2,"phase-shift-amt"]],["compiler/zo-structs"]],
["phase-shift-cancel-id",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._phase-shift-cancel-id))",[0,[2,"phase-shift-cancel-id"]],["compiler/zo-structs"]],
["phase-shift-dest",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._phase-shift-dest))",[0,[2,"phase-shift-dest"]],["compiler/zo-structs"]],
["phase-shift-src",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._phase-shift-src))",[0,[2,"phase-shift-src"]],["compiler/zo-structs"]],
["phase-shift?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._phase-shift~3f))",[0,[2,"phase-shift?"]],["compiler/zo-structs"]],
["phase1",">tools/implementing-tools.html#(idx._(gentag._4._(lib._scribblings/tools/tools..scrbl)))","phase1",false],
["phase2",">tools/implementing-tools.html#(idx._(gentag._5._(lib._scribblings/tools/tools..scrbl)))","phase2",false],
["phased-module-binding",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._phased-module-binding))",[0,[2,"phased-module-binding"]],["compiler/zo-structs"]],
["phased-module-binding-export-name",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._phased-module-binding-export-name))",[0,[2,"phased-module-binding-export-name"]],["compiler/zo-structs"]],
["phased-module-binding-nominal-export-name",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._phased-module-binding-nominal-export-name))",[0,[2,"phased-module-binding-nominal-export-name"]],["compiler/zo-structs"]],
["phased-module-binding-nominal-path",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._phased-module-binding-nominal-path))",[0,[2,"phased-module-binding-nominal-path"]],["compiler/zo-structs"]],
["phased-module-binding-path",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._phased-module-binding-path))",[0,[2,"phased-module-binding-path"]],["compiler/zo-structs"]],
["phased-module-binding-phase",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._phased-module-binding-phase))",[0,[2,"phased-module-binding-phase"]],["compiler/zo-structs"]],
["phased-module-binding?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._phased-module-binding~3f))",[0,[2,"phased-module-binding?"]],["compiler/zo-structs"]],
["phased-nominal-path",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._phased-nominal-path))",[0,[2,"phased-nominal-path"]],["compiler/zo-structs"]],
["phased-nominal-path-import-phase",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._phased-nominal-path-import-phase))",[0,[2,"phased-nominal-path-import-phase"]],["compiler/zo-structs"]],
["phased-nominal-path-phase",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._phased-nominal-path-phase))",[0,[2,"phased-nominal-path-phase"]],["compiler/zo-structs"]],
["phased-nominal-path-value",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._phased-nominal-path-value))",[0,[2,"phased-nominal-path-value"]],["compiler/zo-structs"]],
["phased-nominal-path?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._phased-nominal-path~3f))",[0,[2,"phased-nominal-path?"]],["compiler/zo-structs"]],
["phases",">reference/eval-model.html#(part._module-phase)","Phases",false],
["phases",">reference/eval-model.html#(tech._phase)","<span style=\"font-style: italic\">phases</span>",false],
["phases and bindings",">guide/phases.html#(part._.Phases_and_.Bindings)","Phases and Bindings",false],
["phases and modules",">guide/phases.html#(part._.Phases_and_.Modules)","Phases and Modules",false],
["phases and reusable syntax classes",">syntax/Phases_and_Reusable_Syntax_Classes.html","Phases and Reusable Syntax Classes",false],
["pi",">reference/generic-numbers.html#(def._((lib._racket/math..rkt)._pi))",[0,[2,"pi"]],["racket/math","racket"]],
["pi",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._pi))",[0,[2,"pi"]],["lang/htdp-advanced"]],
["pi",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._pi))",[0,[2,"pi"]],["lang/htdp-beginner"]],
["pi",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._pi))",[0,[2,"pi"]],["lang/htdp-beginner-abbr"]],
["pi",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._pi))",[0,[2,"pi"]],["lang/htdp-intermediate"]],
["pi",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._pi))",[0,[2,"pi"]],["lang/htdp-intermediate-lambda"]],
["pi",">reference/characters.html#(idx._(gentag._136._(lib._scribblings/reference/reference..scrbl)))",[7,"'pi"],false],
["pi.f",">reference/generic-numbers.html#(def._((lib._racket/math..rkt)._pi..f))",[0,[2,"pi.f"]],["racket/math","racket"]],
["pic:bloch",">picturing-programs/index.html#(def._((lib._picturing-programs/private/book-pictures..rkt)._pic~3abloch))",[0,[2,"pic:bloch"]],["picturing-programs/private/book-pictures","picturing-programs"]],
["pic:book",">picturing-programs/index.html#(def._((lib._picturing-programs/private/book-pictures..rkt)._pic~3abook))",[0,[2,"pic:book"]],["picturing-programs/private/book-pictures","picturing-programs"]],
["pic:calendar",">picturing-programs/index.html#(def._((lib._picturing-programs/private/book-pictures..rkt)._pic~3acalendar))",[0,[2,"pic:calendar"]],["picturing-programs/private/book-pictures","picturing-programs"]],
["pic:hacker",">picturing-programs/index.html#(def._((lib._picturing-programs/private/book-pictures..rkt)._pic~3ahacker))",[0,[2,"pic:hacker"]],["picturing-programs/private/book-pictures","picturing-programs"]],
["pic:hieroglyphics",">picturing-programs/index.html#(def._((lib._picturing-programs/private/book-pictures..rkt)._pic~3ahieroglyphics))",[0,[2,"pic:hieroglyphics"]],["picturing-programs/private/book-pictures","picturing-programs"]],
["pic:scheme-logo",">picturing-programs/index.html#(def._((lib._picturing-programs/private/book-pictures..rkt)._pic~3ascheme-logo))",[0,[2,"pic:scheme-logo"]],["picturing-programs/private/book-pictures","picturing-programs"]],
["pic:stick-figure",">picturing-programs/index.html#(def._((lib._picturing-programs/private/book-pictures..rkt)._pic~3astick-figure))",[0,[2,"pic:stick-figure"]],["picturing-programs/private/book-pictures","picturing-programs"]],
["pict",">slideshow/Pict_Datatype.html#(def._((lib._slideshow/pict..rkt)._pict))",[0,[2,"pict"]],["slideshow/pict","slideshow"]],
["pict",">slideshow/Pict_Datatype.html#(tech._pict)","<span style=\"font-style: italic\">pict</span>",false],
["pict colors",">unstable/pict.html#(part._.Pict_.Colors)","Pict Colors",false],
["pict combiners",">slideshow/Pict_Combiners.html","Pict Combiners",false],
["pict datatype",">slideshow/Pict_Datatype.html","Pict Datatype",false],
["pict drawing adjusters",">slideshow/Pict_Drawing_Adjusters.html","Pict Drawing Adjusters",false],
["pict finders",">slideshow/Pict_Finders.html","Pict Finders",false],
["pict manipulation",">unstable/pict.html#(part._.Pict_.Manipulation)","Pict Manipulation",false],
["pict utilities",">unstable/pict.html","Pict Utilities",false],
["pict->bitmap",">slideshow/Rendering.html#(def._((lib._slideshow/pict..rkt)._pict-~3ebitmap))",[0,[2,"pict->bitmap"]],["slideshow/pict","slideshow"]],
["pict->code-pict",">slideshow/Typesetting_Racket_Code.html#(def._((lib._slideshow/code..rkt)._pict-~3ecode-pict))",[0,[2,"pict->code-pict"]],["slideshow/code"]],
["pict-ascent",">slideshow/Pict_Datatype.html#(def._((lib._slideshow/pict..rkt)._pict-ascent))",[0,[2,"pict-ascent"]],["slideshow/pict","slideshow"]],
["pict-case",">unstable/pict.html#(form._((lib._unstable/gui/pict..rkt)._pict-case))",[0,[1,"pict-case"]],["unstable/gui/pict"]],
["pict-children",">slideshow/Pict_Datatype.html#(def._((lib._slideshow/pict..rkt)._pict-children))",[0,[2,"pict-children"]],["slideshow/pict","slideshow"]],
["pict-combine",">unstable/pict.html#(form._((lib._unstable/gui/pict..rkt)._pict-combine))",[0,[1,"pict-combine"]],["unstable/gui/pict"]],
["pict-cond",">unstable/pict.html#(form._((lib._unstable/gui/pict..rkt)._pict-cond))",[0,[1,"pict-cond"]],["unstable/gui/pict"]],
["pict-convert",">slideshow/Conversion_to_Picts.html#(def._((lib._slideshow/pict-convert..rkt)._pict-convert))",[0,[2,"pict-convert"]],["slideshow/pict-convert"]],
["pict-convertible?",">slideshow/Conversion_to_Picts.html#(def._((lib._slideshow/pict-convert..rkt)._pict-convertible~3f))",[0,[2,"pict-convertible?"]],["slideshow/pict-convert"]],
["pict-descent",">slideshow/Pict_Datatype.html#(def._((lib._slideshow/pict..rkt)._pict-descent))",[0,[2,"pict-descent"]],["slideshow/pict","slideshow"]],
["pict-draw",">slideshow/Pict_Datatype.html#(def._((lib._slideshow/pict..rkt)._pict-draw))",[0,[2,"pict-draw"]],["slideshow/pict","slideshow"]],
["pict-height",">slideshow/Pict_Datatype.html#(def._((lib._slideshow/pict..rkt)._pict-height))",[0,[2,"pict-height"]],["slideshow/pict","slideshow"]],
["pict-if",">unstable/pict.html#(form._((lib._unstable/gui/pict..rkt)._pict-if))",[0,[1,"pict-if"]],["unstable/gui/pict"]],
["pict-last",">slideshow/Pict_Datatype.html#(def._((lib._slideshow/pict..rkt)._pict-last))",[0,[2,"pict-last"]],["slideshow/pict","slideshow"]],
["pict-match",">unstable/pict.html#(form._((lib._unstable/gui/pict..rkt)._pict-match))",[0,[1,"pict-match"]],["unstable/gui/pict"]],
["pict-panbox",">slideshow/Pict_Datatype.html#(def._((lib._slideshow/pict..rkt)._pict-panbox))",[0,[2,"pict-panbox"]],["slideshow/pict","slideshow"]],
["pict-path?",">slideshow/Pict_Finders.html#(def._((lib._slideshow/pict..rkt)._pict-path~3f))",[0,[2,"pict-path?"]],["slideshow/pict","slideshow"]],
["pict-staging helper",">slideshow/Pict-Staging_Helper.html","Pict-Staging Helper",false],
["pict-width",">slideshow/Pict_Datatype.html#(def._((lib._slideshow/pict..rkt)._pict-width))",[0,[2,"pict-width"]],["slideshow/pict","slideshow"]],
["pict?",">slideshow/Pict_Datatype.html#(def._((lib._slideshow/pict..rkt)._pict~3f))",[0,[2,"pict?"]],["slideshow/pict","slideshow"]],
["picts, pdf, & postscript",">redex/The_Redex_Reference.html#(part._.Picts__.P.D.F____.Post.Script)","Picts, PDF, & PostScript",false],
["picturing programs teachpack",">picturing-programs/index.html","<span style=\"font-style: italic\">Picturing Programs</span> Teachpack",false],
["picturing-programs",">picturing-programs/index.html",[9,[0,"picturing-programs"]],"module"],
["pidefterm",">scribble/manual-indexing.html#(def._((lib._scribble/manual..rkt)._pidefterm))",[0,[2,"pidefterm"]],["scribble/manual"]],
["pin-arrow-label-line",">unstable/pict.html#(def._((lib._unstable/gui/pict..rkt)._pin-arrow-label-line))",[0,[2,"pin-arrow-label-line"]],["unstable/gui/pict"]],
["pin-arrow-line",">slideshow/Basic_Pict_Constructors.html#(def._((lib._slideshow/pict..rkt)._pin-arrow-line))",[0,[2,"pin-arrow-line"]],["slideshow/pict","slideshow"]],
["pin-arrows-label-line",">unstable/pict.html#(def._((lib._unstable/gui/pict..rkt)._pin-arrows-label-line))",[0,[2,"pin-arrows-label-line"]],["unstable/gui/pict"]],
["pin-arrows-line",">slideshow/Basic_Pict_Constructors.html#(def._((lib._slideshow/pict..rkt)._pin-arrows-line))",[0,[2,"pin-arrows-line"]],["slideshow/pict","slideshow"]],
["pin-balloon",">slideshow/More_Pict_Constructors.html#(def._((lib._slideshow/balloon..rkt)._pin-balloon))",[0,[2,"pin-balloon"]],["slideshow/balloon"]],
["pin-label-line",">unstable/pict.html#(def._((lib._unstable/gui/pict..rkt)._pin-label-line))",[0,[2,"pin-label-line"]],["unstable/gui/pict"]],
["pin-line",">slideshow/Basic_Pict_Constructors.html#(def._((lib._slideshow/pict..rkt)._pin-line))",[0,[2,"pin-line"]],["slideshow/pict","slideshow"]],
["pin-over",">slideshow/Pict_Combiners.html#(def._((lib._slideshow/pict..rkt)._pin-over))",[0,[2,"pin-over"]],["slideshow/pict","slideshow"]],
["pin-under",">slideshow/Pict_Combiners.html#(def._((lib._slideshow/pict..rkt)._pin-under))",[0,[2,"pin-under"]],["slideshow/pict","slideshow"]],
["pinhole-x",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._pinhole-x))",[0,[2,"pinhole-x"]],["2htdp/image"]],
["pinhole-x",">teachpack/image.html#(def._((lib._htdp/image..rkt)._pinhole-x))",[0,[2,"pinhole-x"]],["htdp/image"]],
["pinhole-y",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._pinhole-y))",[0,[2,"pinhole-y"]],["2htdp/image"]],
["pinhole-y",">teachpack/image.html#(def._((lib._htdp/image..rkt)._pinhole-y))",[0,[2,"pinhole-y"]],["htdp/image"]],
["pinholes",">teachpack/2htdpimage.html#(part._pinholes)","Pinholes",false],
["pip-arrow-line",">slideshow/Basic_Pict_Constructors.html#(def._((lib._slideshow/pict..rkt)._pip-arrow-line))",[0,[2,"pip-arrow-line"]],["slideshow/pict","slideshow"]],
["pip-arrows-line",">slideshow/Basic_Pict_Constructors.html#(def._((lib._slideshow/pict..rkt)._pip-arrows-line))",[0,[2,"pip-arrows-line"]],["slideshow/pict","slideshow"]],
["pip-line",">slideshow/Basic_Pict_Constructors.html#(def._((lib._slideshow/pict..rkt)._pip-line))",[0,[2,"pip-line"]],["slideshow/pict","slideshow"]],
["pip-wrap-balloon",">slideshow/More_Pict_Constructors.html#(def._((lib._slideshow/balloon..rkt)._pip-wrap-balloon))",[0,[2,"pip-wrap-balloon"]],["slideshow/balloon"]],
["pipe",">reference/pipeports.html#(tech._pipe)","<span style=\"font-style: italic\">pipe</span>",false],
["pipe-content-length",">reference/pipeports.html#(def._((quote._~23~25kernel)._pipe-content-length))",[0,[2,"pipe-content-length"]],["racket/base","racket"]],
["pipes",">reference/pipeports.html","Pipes",false],
["pixel functions",">picturing-programs/index.html#(part._.Pixel_functions)","Pixel functions",false],
["pixels",">graphics/Draw__Clear__and_Flip_Operations.html#(part._.Pixels)","Pixels",false],
["pixmaps",">graphics/Draw__Clear__and_Flip_Operations.html#(part._.Pixmaps)","Pixmaps",false],
["pkg->download-url",">planet/Utility_Libraries.html#(def._((lib._planet/util..rkt)._pkg-~3edownload-url))",[0,[2,"pkg->download-url"]],["planet/util"]],
["pkg-spec?",">planet/Utility_Libraries.html#(def._((lib._planet/util..rkt)._pkg-spec~3f))",[0,[2,"pkg-spec?"]],["planet/util"]],
["pkg?",">planet/Utility_Libraries.html#(def._((lib._planet/util..rkt)._pkg~3f))",[0,[2,"pkg?"]],["planet/util"]],
["place",">reference/places.html#(form._((lib._racket/place..rkt)._place))",[0,[1,"place"]],["racket/place","racket"]],
["place",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Place))",[0,[1,"Place"]],["typed/racket/base","typed/racket"]],
["place",">guide/performance.html#(tech._place)","<span style=\"font-style: italic\">place</span>",false],
["place",">reference/places.html#(tech._place)","<span style=\"font-style: italic\">place</span>",false],
["place channel",">guide/performance.html#(tech._place._channel)","<span style=\"font-style: italic\">place\nchannel</span>",false],
["place channels",">reference/places.html#(tech._place._channel)","<span style=\"font-style: italic\">place channels</span>",false],
["place descriptor",">reference/places.html#(tech._place._descriptor)","<span style=\"font-style: italic\">place descriptor</span>",false],
["place%",">reference/distributed-places.html#(def._((lib._racket/place/distributed..rkt)._place~25))",[0,[2,"place%"]],["racket/place/distributed"]],
["place*",">reference/places.html#(form._((lib._racket/place..rkt)._place*))",[0,[1,"place*"]],["racket/place","racket"]],
["place-break",">reference/places.html#(def._((lib._racket/place..rkt)._place-break))",[0,[2,"place-break"]],["racket/place","racket"]],
["place-channel",">reference/places.html#(def._((lib._racket/place..rkt)._place-channel))",[0,[2,"place-channel"]],["racket/place","racket"]],
["place-channel",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Place-.Channel))",[0,[1,"Place-Channel"]],["typed/racket/base","typed/racket"]],
["place-channel-get",">reference/places.html#(def._((lib._racket/place..rkt)._place-channel-get))",[0,[2,"place-channel-get"]],["racket/place","racket"]],
["place-channel-put",">reference/places.html#(def._((lib._racket/place..rkt)._place-channel-put))",[0,[2,"place-channel-put"]],["racket/place","racket"]],
["place-channel-put/get",">reference/places.html#(def._((lib._racket/place..rkt)._place-channel-put/get))",[0,[2,"place-channel-put/get"]],["racket/place","racket"]],
["place-channel?",">reference/places.html#(def._((lib._racket/place..rkt)._place-channel~3f))",[0,[2,"place-channel?"]],["racket/place","racket"]],
["place-children",">gui/area-container___.html#(meth._(((lib._mred/main..rkt)._area-container~3c~25~3e)._place-children))",[[0,[2,"place-children"]],[14,[" (method of ",[0,[2,"area-container<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["place-children",">framework/Panel.html#(meth._(((lib._framework/main..rkt)._panel~3adragable-mixin)._place-children))",[[0,[2,"place-children"]],[14,[" (method of ",[0,[2,"panel:dragable-mixin"]],")"]]],["framework"]],
["place-children",">framework/Panel.html#(meth._(((lib._framework/main..rkt)._panel~3asingle-mixin)._place-children))",[[0,[2,"place-children"]],[14,[" (method of ",[0,[2,"panel:single-mixin"]],")"]]],["framework"]],
["place-dead-evt",">reference/places.html#(def._((lib._racket/place..rkt)._place-dead-evt))",[0,[2,"place-dead-evt"]],["racket/place","racket"]],
["place-enabled?",">reference/places.html#(def._((lib._racket/place..rkt)._place-enabled~3f))",[0,[2,"place-enabled?"]],["racket/place","racket"]],
["place-image",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._place-image))",[0,[2,"place-image"]],["2htdp/image"]],
["place-image",">teachpack/image.html#(def._((lib._htdp/image..rkt)._place-image))",[0,[2,"place-image"]],["htdp/image"]],
["place-image/align",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._place-image/align))",[0,[2,"place-image/align"]],["2htdp/image"]],
["place-kill",">reference/places.html#(def._((lib._racket/place..rkt)._place-kill))",[0,[2,"place-kill"]],["racket/place","racket"]],
["place-message-allowed?",">reference/places.html#(def._((lib._racket/place..rkt)._place-message-allowed~3f))",[0,[2,"place-message-allowed?"]],["racket/place","racket"]],
["place-socket-bridge%",">reference/distributed-places.html#(def._((lib._racket/place/distributed..rkt)._place-socket-bridge~25))",[0,[2,"place-socket-bridge%"]],["racket/place/distributed"]],
["place-wait",">reference/places.html#(def._((lib._racket/place..rkt)._place-wait))",[0,[2,"place-wait"]],["racket/place","racket"]],
["place?",">reference/places.html#(def._((lib._racket/place..rkt)._place~3f))",[0,[2,"place?"]],["racket/place","racket"]],
["placeholder-get",">reference/pairs.html#(def._((quote._~23~25kernel)._placeholder-get))",[0,[2,"placeholder-get"]],["racket/base","racket"]],
["placeholder-set!",">reference/pairs.html#(def._((quote._~23~25kernel)._placeholder-set!))",[0,[2,"placeholder-set!"]],["racket/base","racket"]],
["placeholder?",">reference/pairs.html#(def._((quote._~23~25kernel)._placeholder~3f))",[0,[2,"placeholder?"]],["racket/base","racket"]],
["placer?",">unstable/ppict.html#(def._((lib._unstable/gui/ppict..rkt)._placer~3f))",[0,[2,"placer?"]],["unstable/gui/ppict"]],
["places",">reference/places.html","Places",false],
["places and garbage collector instances",">inside/im_memoryalloc.html#(part._im~3a3m~3aplaces)","Places and Garbage Collector Instances",false],
["placing cookies",">web-server/http.html#(part._cookie)","Placing Cookies",false],
["placing images & scenes",">teachpack/2htdpimage.html#(part._.Placing_.Images___.Scenes)","Placing Images & Scenes",false],
["plai",">plai/plai-scheme.html",[9,[0,"plai"]],"module"],
["plai scheme",">plai/plai-scheme.html","PLAI Scheme",false],
["plai-all-test-results",">plai/plai-scheme.html#(form._((lib._plai/main..rkt)._plai-all-test-results))",[0,[1,"plai-all-test-results"]],["plai"]],
["plai-catch-test-exn",">plai/plai-scheme.html#(def._((lib._plai/main..rkt)._plai-catch-test-exn))",[0,[2,"plai-catch-test-exn"]],["plai"]],
["plai-ignore-exn-strings",">plai/plai-scheme.html#(def._((lib._plai/main..rkt)._plai-ignore-exn-strings))",[0,[2,"plai-ignore-exn-strings"]],["plai"]],
["plai/collector",">plai/collector.html",[9,[0,"plai/collector"]],"module"],
["plai/mutator",">plai/mutator.html",[9,[0,"plai/mutator"]],"module"],
["plai/random-mutator",">plai/mutator.html#(mod-path._plai/random-mutator)",[9,[0,"plai/random-mutator"]],"module"],
["plai/web",">plai/web.html",[9,[0,"plai/web"]],"module"],
["plain",">scribble/core.html#(def._((lib._scribble/core..rkt)._plain))",[0,[2,"plain"]],["scribble/core"]],
["plain menu item",">gui/windowing-overview.html#(tech._plain._menu._item)","<span style=\"font-style: italic\">plain menu item</span>",false],
["plain-block",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._plain-block))",[0,[2,"plain-block"]],["2htdp/planetcute"]],
["plain-text file format",">drracket/drracket-files.html#(tech._plain._text._file._format)","<span style=\"font-style: italic\">Plain-text file format</span>",false],
["plambda:",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._plambda~3a))",[0,[1,"plambda:"]],["typed/racket/base","typed/racket"]],
["planet",">planet/hash-lang-planet.html",[9,[0,"planet"]],"module"],
["planet",">reference/require.html#(form._((lib._racket/private/base..rkt)._planet))",[0,[1,"planet"]],["racket/base","racket"]],
["planet",">scribble/Miscellaneous.html#(def._((lib._scribble/manual..rkt)._.P.Lane.T))",[0,[2,"PLaneT"]],["scribble/manual"]],
["planet",">planet/Developing_Packages_for_PLaneT.html#(idx._(gentag._14._(lib._planet/planet..scrbl)))",[7,"'planet"],false],
["planet cute images",">teachpack/2htdpPlanet_Cute_Images.html","Planet Cute Images",false],
["planet-archive-filter",">planet/Utility_Libraries.html#(def._((lib._planet/config..rkt)._.P.L.A.N.E.T-.A.R.C.H.I.V.E-.F.I.L.T.E.R))",[0,[2,"PLANET-ARCHIVE-FILTER"]],["planet/config"]],
["planet-base-dir",">planet/Utility_Libraries.html#(def._((lib._planet/config..rkt)._.P.L.A.N.E.T-.B.A.S.E-.D.I.R))",[0,[2,"PLANET-BASE-DIR"]],["planet/config"]],
["planet-code-version",">planet/Utility_Libraries.html#(def._((lib._planet/config..rkt)._.P.L.A.N.E.T-.C.O.D.E-.V.E.R.S.I.O.N))",[0,[2,"PLANET-CODE-VERSION"]],["planet/config"]],
["planet-dir",">planet/Utility_Libraries.html#(def._((lib._planet/config..rkt)._.P.L.A.N.E.T-.D.I.R))",[0,[2,"PLANET-DIR"]],["planet/config"]],
["planet-logo",">images/Logos.html#(def._((lib._images/logos..rkt)._planet-logo))",[0,[2,"planet-logo"]],["images/logos"]],
["planet-module-name-resolver",">planet/Utility_Libraries.html#(def._((lib._planet/resolver..rkt)._planet-module-name-resolver))",[0,[2,"planet-module-name-resolver"]],["planet/resolver"]],
["planet-server-name",">planet/Utility_Libraries.html#(def._((lib._planet/config..rkt)._.P.L.A.N.E.T-.S.E.R.V.E.R-.N.A.M.E))",[0,[2,"PLANET-SERVER-NAME"]],["planet/config"]],
["planet-server-port",">planet/Utility_Libraries.html#(def._((lib._planet/config..rkt)._.P.L.A.N.E.T-.S.E.R.V.E.R-.P.O.R.T))",[0,[2,"PLANET-SERVER-PORT"]],["planet/config"]],
["planet-terse-log",">planet/Utility_Libraries.html#(def._((lib._planet/terse-info..rkt)._planet-terse-log))",[0,"planet-terse-log"],["planet/terse-info"]],
["planet-terse-register",">planet/Utility_Libraries.html#(def._((lib._planet/terse-info..rkt)._planet-terse-register))",[0,"planet-terse-register"],["planet/terse-info"]],
["planet-terse-set-key",">planet/Utility_Libraries.html#(def._((lib._planet/terse-info..rkt)._planet-terse-set-key))",[0,"planet-terse-set-key"],["planet/terse-info"]],
["planet/cachepath",">planet/Utility_Libraries.html#(mod-path._planet/cachepath)",[9,[0,"planet/cachepath"]],"module"],
["planet/config",">planet/Utility_Libraries.html#(mod-path._planet/config)",[9,[0,"planet/config"]],"module"],
["planet/planet-archives",">planet/Utility_Libraries.html#(mod-path._planet/planet-archives)",[9,[0,"planet/planet-archives"]],"module"],
["planet/resolver",">planet/Utility_Libraries.html#(mod-path._planet/resolver)",[9,[0,"planet/resolver"]],"module"],
["planet/scribble",">planet/Utility_Libraries.html#(mod-path._planet/scribble)",[9,[0,"planet/scribble"]],"module"],
["planet/syntax",">planet/Utility_Libraries.html#(mod-path._planet/syntax)",[9,[0,"planet/syntax"]],"module"],
["planet/terse-info",">planet/Utility_Libraries.html#(mod-path._planet/terse-info)",[9,[0,"planet/terse-info"]],"module"],
["planet/util",">planet/Utility_Libraries.html#(mod-path._planet/util)",[9,[0,"planet/util"]],"module"],
["planet/version",">planet/Utility_Libraries.html#(mod-path._planet/version)",[9,[0,"planet/version"]],"module"],
["planet: automatic package distribution",">planet/index.html","PLaneT: Automatic Package Distribution",false],
["plastic-icon-material",">images/Icons.html#(def._((lib._images/icons/style..rkt)._plastic-icon-material))",[0,[2,"plastic-icon-material"]],["images/icons/style"]],
["platform dependencies",">draw/libs.html","Platform Dependencies",false],
["platform dependencies",">gui/libs.html","Platform Dependencies",false],
["play",">slideshow/play.html#(def._((lib._slideshow/play..rkt)._play))",[0,[2,"play"]],["slideshow/play"]],
["play-icon",">images/Icons.html#(def._((lib._images/icons/control..rkt)._play-icon))",[0,[2,"play-icon"]],["images/icons/control"]],
["play-n",">slideshow/play.html#(def._((lib._slideshow/play..rkt)._play-n))",[0,[2,"play-n"]],["slideshow/play"]],
["play-sound",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._play-sound))",[0,[2,"play-sound"]],["racket/gui/base","racket/gui"]],
["play-sound-file",">deinprogramm/sound.html#(def._((lib._teachpack/deinprogramm/sound..rkt)._play-sound-file))",[0,[2,"play-sound-file"]],["teachpack/deinprogramm/sound"]],
["playing hangman: \"hangman-play.ss\"",">teachpack/hangman-play.html",["Playing Hangman: ",[6,"\"hangman-play.ss\""],"<a name=\"(idx._(gentag._8._(lib._teachpack/teachpack..scrbl)))\"></a>"],false],
["playing mastermind: \"master-play.ss\"",">teachpack/master-play.html",["Playing MasterMind: ",[6,"\"master-play.ss\""],"<a name=\"(idx._(gentag._5._(lib._teachpack/teachpack..scrbl)))\"></a>"],false],
["plist dictionary",">xml/index.html#(tech._plist._dictionary)","<span style=\"font-style: italic\">plist dictionary</span>",false],
["plist library",">xml/index.html#(part._.P.List_.Library)","PList Library",false],
["plist value",">xml/index.html#(tech._plist._value)","<span style=\"font-style: italic\">plist value</span>",false],
["plist-dict?",">xml/index.html#(def._((lib._xml/plist..rkt)._plist-dict~3f))",[0,[2,"plist-dict?"]],["xml/plist"]],
["plist-value?",">xml/index.html#(def._((lib._xml/plist..rkt)._plist-value~3f))",[0,[2,"plist-value?"]],["xml/plist"]],
["plot",">mrlib/Plot.html","Plot",false],
["plot",">plot/index.html",[9,[0,"plot"]],"module"],
["plot",">mrlib/Plot.html#(def._((lib._mrlib/plot..rkt)._plot))",[0,[2,"plot"]],["mrlib/plot"]],
["plot",">plot/plot2d.html#(def._((lib._plot/main..rkt)._plot))",[0,[2,"plot"]],["plot"]],
["plot",">plot/compat.html#(def._((lib._plot/compat..rkt)._plot))",[0,[2,"plot"]],["plot/compat"]],
["plot and renderer parameters",">plot/params.html","Plot and Renderer Parameters",false],
["plot area",">plot/intro.html#(tech._plot._area)","<span style=\"font-style: italic\">plot area</span>",false],
["plot colors and styles",">plot/utils.html#(part._.Plot_.Colors_and_.Styles)","Plot Colors and Styles",false],
["plot contracts",">plot/contracts.html","Plot Contracts",false],
["plot element contracts",">plot/contracts.html#(part._.Plot_.Element_.Contracts)","Plot Element Contracts",false],
["plot utilities",">plot/utils.html","Plot Utilities",false],
["plot-animating?",">plot/params.html#(def._((lib._plot/main..rkt)._plot-animating~3f))",[0,[2,"plot-animating?"]],["plot"]],
["plot-background",">plot/params.html#(def._((lib._plot/main..rkt)._plot-background))",[0,[2,"plot-background"]],["plot"]],
["plot-background-alpha",">plot/params.html#(def._((lib._plot/main..rkt)._plot-background-alpha))",[0,[2,"plot-background-alpha"]],["plot"]],
["plot-bitmap",">plot/plot2d.html#(def._((lib._plot/main..rkt)._plot-bitmap))",[0,[2,"plot-bitmap"]],["plot"]],
["plot-brush-style/c",">plot/contracts.html#(def._((lib._plot/utils..rkt)._plot-brush-style/c))",[0,[2,"plot-brush-style/c"]],["plot/utils"]],
["plot-brush-styles/c",">plot/contracts.html#(def._((lib._plot/utils..rkt)._plot-brush-styles/c))",[0,[2,"plot-brush-styles/c"]],["plot/utils"]],
["plot-color/c",">plot/contracts.html#(def._((lib._plot/utils..rkt)._plot-color/c))",[0,[2,"plot-color/c"]],["plot/utils"]],
["plot-color?",">plot/compat.html#(def._((lib._plot/compat..rkt)._plot-color~3f))",[0,[2,"plot-color?"]],["plot/compat"]],
["plot-colors/c",">plot/contracts.html#(def._((lib._plot/utils..rkt)._plot-colors/c))",[0,[2,"plot-colors/c"]],["plot/utils"]],
["plot-d-ticks",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._plot-d-ticks))",[0,[2,"plot-d-ticks"]],["plot"]],
["plot-decorations?",">plot/params.html#(def._((lib._plot/main..rkt)._plot-decorations~3f))",[0,[2,"plot-decorations?"]],["plot"]],
["plot-deprecation-warnings?",">plot/params.html#(def._((lib._plot/main..rkt)._plot-deprecation-warnings~3f))",[0,[2,"plot-deprecation-warnings?"]],["plot"]],
["plot-file",">plot/plot2d.html#(def._((lib._plot/main..rkt)._plot-file))",[0,[2,"plot-file"]],["plot"]],
["plot-font-family",">plot/params.html#(def._((lib._plot/main..rkt)._plot-font-family))",[0,[2,"plot-font-family"]],["plot"]],
["plot-font-size",">plot/params.html#(def._((lib._plot/main..rkt)._plot-font-size))",[0,[2,"plot-font-size"]],["plot"]],
["plot-foreground",">plot/params.html#(def._((lib._plot/main..rkt)._plot-foreground))",[0,[2,"plot-foreground"]],["plot"]],
["plot-foreground-alpha",">plot/params.html#(def._((lib._plot/main..rkt)._plot-foreground-alpha))",[0,[2,"plot-foreground-alpha"]],["plot"]],
["plot-frame",">plot/plot2d.html#(def._((lib._plot/main..rkt)._plot-frame))",[0,[2,"plot-frame"]],["plot"]],
["plot-height",">plot/params.html#(def._((lib._plot/main..rkt)._plot-height))",[0,[2,"plot-height"]],["plot"]],
["plot-jpeg-quality",">plot/params.html#(def._((lib._plot/main..rkt)._plot-jpeg-quality))",[0,[2,"plot-jpeg-quality"]],["plot"]],
["plot-legend-anchor",">plot/params.html#(def._((lib._plot/main..rkt)._plot-legend-anchor))",[0,[2,"plot-legend-anchor"]],["plot"]],
["plot-legend-box-alpha",">plot/params.html#(def._((lib._plot/main..rkt)._plot-legend-box-alpha))",[0,[2,"plot-legend-box-alpha"]],["plot"]],
["plot-line-width",">plot/params.html#(def._((lib._plot/main..rkt)._plot-line-width))",[0,[2,"plot-line-width"]],["plot"]],
["plot-new-window?",">plot/params.html#(def._((lib._plot/main..rkt)._plot-new-window~3f))",[0,[2,"plot-new-window?"]],["plot"]],
["plot-pen-style/c",">plot/contracts.html#(def._((lib._plot/utils..rkt)._plot-pen-style/c))",[0,[2,"plot-pen-style/c"]],["plot/utils"]],
["plot-pen-styles/c",">plot/contracts.html#(def._((lib._plot/utils..rkt)._plot-pen-styles/c))",[0,[2,"plot-pen-styles/c"]],["plot/utils"]],
["plot-pict",">plot/plot2d.html#(def._((lib._plot/main..rkt)._plot-pict))",[0,[2,"plot-pict"]],["plot"]],
["plot-ps/pdf-interactive?",">plot/params.html#(def._((lib._plot/main..rkt)._plot-ps/pdf-interactive~3f))",[0,[2,"plot-ps/pdf-interactive?"]],["plot"]],
["plot-r-ticks",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._plot-r-ticks))",[0,[2,"plot-r-ticks"]],["plot"]],
["plot-setup",">mrlib/Plot.html#(def._((lib._mrlib/plot..rkt)._plot-setup))",[0,[2,"plot-setup"]],["mrlib/plot"]],
["plot-setup-axis-label-font",">mrlib/Plot.html#(def._((lib._mrlib/plot..rkt)._plot-setup-axis-label-font))",[0,[2,"plot-setup-axis-label-font"]],["mrlib/plot"]],
["plot-setup-axis-number-font",">mrlib/Plot.html#(def._((lib._mrlib/plot..rkt)._plot-setup-axis-number-font))",[0,[2,"plot-setup-axis-number-font"]],["mrlib/plot"]],
["plot-setup-axis-pen",">mrlib/Plot.html#(def._((lib._mrlib/plot..rkt)._plot-setup-axis-pen))",[0,[2,"plot-setup-axis-pen"]],["mrlib/plot"]],
["plot-setup-grid-pen",">mrlib/Plot.html#(def._((lib._mrlib/plot..rkt)._plot-setup-grid-pen))",[0,[2,"plot-setup-grid-pen"]],["mrlib/plot"]],
["plot-setup-grid?",">mrlib/Plot.html#(def._((lib._mrlib/plot..rkt)._plot-setup-grid~3f))",[0,[2,"plot-setup-grid?"]],["mrlib/plot"]],
["plot-setup-x-axis-label",">mrlib/Plot.html#(def._((lib._mrlib/plot..rkt)._plot-setup-x-axis-label))",[0,[2,"plot-setup-x-axis-label"]],["mrlib/plot"]],
["plot-setup-x-axis-marking",">mrlib/Plot.html#(def._((lib._mrlib/plot..rkt)._plot-setup-x-axis-marking))",[0,[2,"plot-setup-x-axis-marking"]],["mrlib/plot"]],
["plot-setup-y-axis-label",">mrlib/Plot.html#(def._((lib._mrlib/plot..rkt)._plot-setup-y-axis-label))",[0,[2,"plot-setup-y-axis-label"]],["mrlib/plot"]],
["plot-setup-y-axis-marking",">mrlib/Plot.html#(def._((lib._mrlib/plot..rkt)._plot-setup-y-axis-marking))",[0,[2,"plot-setup-y-axis-marking"]],["mrlib/plot"]],
["plot-setup?",">mrlib/Plot.html#(def._((lib._mrlib/plot..rkt)._plot-setup~3f))",[0,[2,"plot-setup?"]],["mrlib/plot"]],
["plot-snip",">plot/plot2d.html#(def._((lib._plot/main..rkt)._plot-snip))",[0,[2,"plot-snip"]],["plot"]],
["plot-specific math",">plot/utils.html#(part._.Plot-.Specific_.Math)","Plot-Specific Math",false],
["plot-tick-size",">plot/params.html#(def._((lib._plot/main..rkt)._plot-tick-size))",[0,[2,"plot-tick-size"]],["plot"]],
["plot-time",">plot/utils.html#(def._((lib._plot/utils..rkt)._plot-time))",[0,[2,"plot-time"]],["plot/utils"]],
["plot-time->seconds",">plot/utils.html#(def._((lib._plot/utils..rkt)._plot-time-~3eseconds))",[0,[2,"plot-time->seconds"]],["plot/utils"]],
["plot-time-day",">plot/utils.html#(def._((lib._plot/utils..rkt)._plot-time-day))",[0,[2,"plot-time-day"]],["plot/utils"]],
["plot-time-hour",">plot/utils.html#(def._((lib._plot/utils..rkt)._plot-time-hour))",[0,[2,"plot-time-hour"]],["plot/utils"]],
["plot-time-minute",">plot/utils.html#(def._((lib._plot/utils..rkt)._plot-time-minute))",[0,[2,"plot-time-minute"]],["plot/utils"]],
["plot-time-second",">plot/utils.html#(def._((lib._plot/utils..rkt)._plot-time-second))",[0,[2,"plot-time-second"]],["plot/utils"]],
["plot-time?",">plot/utils.html#(def._((lib._plot/utils..rkt)._plot-time~3f))",[0,[2,"plot-time?"]],["plot/utils"]],
["plot-title",">plot/params.html#(def._((lib._plot/main..rkt)._plot-title))",[0,[2,"plot-title"]],["plot"]],
["plot-width",">plot/params.html#(def._((lib._plot/main..rkt)._plot-width))",[0,[2,"plot-width"]],["plot"]],
["plot-x-axis?",">plot/params.html#(def._((lib._plot/main..rkt)._plot-x-axis~3f))",[0,[2,"plot-x-axis?"]],["plot"]],
["plot-x-far-axis?",">plot/params.html#(def._((lib._plot/main..rkt)._plot-x-far-axis~3f))",[0,[2,"plot-x-far-axis?"]],["plot"]],
["plot-x-far-label",">plot/params.html#(def._((lib._plot/main..rkt)._plot-x-far-label))",[0,[2,"plot-x-far-label"]],["plot"]],
["plot-x-far-tick-label-anchor",">plot/params.html#(def._((lib._plot/main..rkt)._plot-x-far-tick-label-anchor))",[0,[2,"plot-x-far-tick-label-anchor"]],["plot"]],
["plot-x-far-tick-label-angle",">plot/params.html#(def._((lib._plot/main..rkt)._plot-x-far-tick-label-angle))",[0,[2,"plot-x-far-tick-label-angle"]],["plot"]],
["plot-x-far-ticks",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._plot-x-far-ticks))",[0,[2,"plot-x-far-ticks"]],["plot"]],
["plot-x-label",">plot/params.html#(def._((lib._plot/main..rkt)._plot-x-label))",[0,[2,"plot-x-label"]],["plot"]],
["plot-x-tick-label-anchor",">plot/params.html#(def._((lib._plot/main..rkt)._plot-x-tick-label-anchor))",[0,[2,"plot-x-tick-label-anchor"]],["plot"]],
["plot-x-tick-label-angle",">plot/params.html#(def._((lib._plot/main..rkt)._plot-x-tick-label-angle))",[0,[2,"plot-x-tick-label-angle"]],["plot"]],
["plot-x-ticks",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._plot-x-ticks))",[0,[2,"plot-x-ticks"]],["plot"]],
["plot-x-transform",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._plot-x-transform))",[0,[2,"plot-x-transform"]],["plot"]],
["plot-y-axis?",">plot/params.html#(def._((lib._plot/main..rkt)._plot-y-axis~3f))",[0,[2,"plot-y-axis?"]],["plot"]],
["plot-y-far-axis?",">plot/params.html#(def._((lib._plot/main..rkt)._plot-y-far-axis~3f))",[0,[2,"plot-y-far-axis?"]],["plot"]],
["plot-y-far-label",">plot/params.html#(def._((lib._plot/main..rkt)._plot-y-far-label))",[0,[2,"plot-y-far-label"]],["plot"]],
["plot-y-far-tick-label-anchor",">plot/params.html#(def._((lib._plot/main..rkt)._plot-y-far-tick-label-anchor))",[0,[2,"plot-y-far-tick-label-anchor"]],["plot"]],
["plot-y-far-tick-label-angle",">plot/params.html#(def._((lib._plot/main..rkt)._plot-y-far-tick-label-angle))",[0,[2,"plot-y-far-tick-label-angle"]],["plot"]],
["plot-y-far-ticks",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._plot-y-far-ticks))",[0,[2,"plot-y-far-ticks"]],["plot"]],
["plot-y-label",">plot/params.html#(def._((lib._plot/main..rkt)._plot-y-label))",[0,[2,"plot-y-label"]],["plot"]],
["plot-y-tick-label-anchor",">plot/params.html#(def._((lib._plot/main..rkt)._plot-y-tick-label-anchor))",[0,[2,"plot-y-tick-label-anchor"]],["plot"]],
["plot-y-tick-label-angle",">plot/params.html#(def._((lib._plot/main..rkt)._plot-y-tick-label-angle))",[0,[2,"plot-y-tick-label-angle"]],["plot"]],
["plot-y-ticks",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._plot-y-ticks))",[0,[2,"plot-y-ticks"]],["plot"]],
["plot-y-transform",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._plot-y-transform))",[0,[2,"plot-y-transform"]],["plot"]],
["plot-z-axis?",">plot/params.html#(def._((lib._plot/main..rkt)._plot-z-axis~3f))",[0,[2,"plot-z-axis?"]],["plot"]],
["plot-z-far-axis?",">plot/params.html#(def._((lib._plot/main..rkt)._plot-z-far-axis~3f))",[0,[2,"plot-z-far-axis?"]],["plot"]],
["plot-z-far-label",">plot/params.html#(def._((lib._plot/main..rkt)._plot-z-far-label))",[0,[2,"plot-z-far-label"]],["plot"]],
["plot-z-far-ticks",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._plot-z-far-ticks))",[0,[2,"plot-z-far-ticks"]],["plot"]],
["plot-z-label",">plot/params.html#(def._((lib._plot/main..rkt)._plot-z-label))",[0,[2,"plot-z-label"]],["plot"]],
["plot-z-ticks",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._plot-z-ticks))",[0,[2,"plot-z-ticks"]],["plot"]],
["plot-z-transform",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._plot-z-transform))",[0,[2,"plot-z-transform"]],["plot"]],
["plot/compat",">plot/compat.html",[9,[0,"plot/compat"]],"module"],
["plot/dc",">plot/plot2d.html#(def._((lib._plot/main..rkt)._plot/dc))",[0,[2,"plot/dc"]],["plot"]],
["plot/utils",">plot/utils.html",[9,[0,"plot/utils"]],"module"],
["plot3d",">plot/plot3d.html#(def._((lib._plot/main..rkt)._plot3d))",[0,[2,"plot3d"]],["plot"]],
["plot3d",">plot/compat.html#(def._((lib._plot/compat..rkt)._plot3d))",[0,[2,"plot3d"]],["plot/compat"]],
["plot3d-altitude",">plot/params.html#(def._((lib._plot/main..rkt)._plot3d-altitude))",[0,[2,"plot3d-altitude"]],["plot"]],
["plot3d-ambient-light",">plot/params.html#(def._((lib._plot/main..rkt)._plot3d-ambient-light))",[0,[2,"plot3d-ambient-light"]],["plot"]],
["plot3d-angle",">plot/params.html#(def._((lib._plot/main..rkt)._plot3d-angle))",[0,[2,"plot3d-angle"]],["plot"]],
["plot3d-bitmap",">plot/plot3d.html#(def._((lib._plot/main..rkt)._plot3d-bitmap))",[0,[2,"plot3d-bitmap"]],["plot"]],
["plot3d-diffuse-light?",">plot/params.html#(def._((lib._plot/main..rkt)._plot3d-diffuse-light~3f))",[0,[2,"plot3d-diffuse-light?"]],["plot"]],
["plot3d-file",">plot/plot3d.html#(def._((lib._plot/main..rkt)._plot3d-file))",[0,[2,"plot3d-file"]],["plot"]],
["plot3d-frame",">plot/plot3d.html#(def._((lib._plot/main..rkt)._plot3d-frame))",[0,[2,"plot3d-frame"]],["plot"]],
["plot3d-pict",">plot/plot3d.html#(def._((lib._plot/main..rkt)._plot3d-pict))",[0,[2,"plot3d-pict"]],["plot"]],
["plot3d-samples",">plot/params.html#(def._((lib._plot/main..rkt)._plot3d-samples))",[0,[2,"plot3d-samples"]],["plot"]],
["plot3d-snip",">plot/plot3d.html#(def._((lib._plot/main..rkt)._plot3d-snip))",[0,[2,"plot3d-snip"]],["plot"]],
["plot3d-specular-light?",">plot/params.html#(def._((lib._plot/main..rkt)._plot3d-specular-light~3f))",[0,[2,"plot3d-specular-light?"]],["plot"]],
["plot3d/dc",">plot/plot3d.html#(def._((lib._plot/main..rkt)._plot3d/dc))",[0,[2,"plot3d/dc"]],["plot"]],
["plot: graph plotting",">plot/index.html","PLoT: Graph Plotting",false],
["plotting",">plot/compat.html#(part._plot)","Plotting",false],
["plotting 2d graphs",">plot/intro.html#(part._.Plotting_2.D_.Graphs)","Plotting 2D Graphs",false],
["plotting 3d graphs",">plot/intro.html#(part._.Plotting_3.D_.Graphs)","Plotting 3D Graphs",false],
["plotting multiple 2d renderers",">plot/intro.html#(part._.Plotting_.Multiple_2.D_.Renderers)","Plotting Multiple 2D Renderers",false],
["plotting multiple 3d renderers",">plot/intro.html#(part._.Plotting_.Multiple_3.D_.Renderers)","Plotting Multiple 3D Renderers",false],
["plotting to files",">plot/intro.html#(part._.Plotting_to_.Files)","Plotting to Files",false],
["plt pretty big language",">drracket/legacy.html#(idx._(gentag._41._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-style: italic\">PLT Pretty Big</span> language",false],
["plt-help",">scheme/compat-exe.html#(idx._(gentag._4._(lib._scribblings/scheme/scheme..scrbl)))",[6,"plt-help"],false],
["plt-logo",">images/Logos.html#(def._((lib._images/logos..rkt)._plt-logo))",[0,[2,"plt-logo"]],["images/logos"]],
["plt-r5rs",">r5rs/plt-r5rs.html",[6,"plt-r5rs"],false],
["plt-web-server",">web-server/run.html#(idx._(gentag._0._(lib._web-server/scribblings/web-server..scrbl)))","plt-web-server",false],
["plt_delay_from_zo",">reference/Reading.html#(idx._(gentag._218._(lib._scribblings/reference/reference..scrbl)))",[6,"PLT_DELAY_FROM_ZO"],false],
["plt_extension_lib_paths",">make/setup-extension.html#(idx._(gentag._0._(lib._make/make..scrbl)))",[6,"PLT_EXTENSION_LIB_PATHS"],false],
["plt_setup_options",">raco/running.html#(idx._(gentag._10._(lib._scribblings/raco/raco..scrbl)))",[6,"PLT_SETUP_OPTIONS"],false],
["plt_validate_compile",">reference/eval.html#(idx._(gentag._224._(lib._scribblings/reference/reference..scrbl)))",[6,"PLT_VALIDATE_COMPILE"],false],
["pltaddondir",">reference/Filesystem.html#(idx._(gentag._281._(lib._scribblings/reference/reference..scrbl)))",[6,"PLTADDONDIR"],false],
["pltcollects",">reference/collects.html#(idx._(gentag._431._(lib._scribblings/reference/reference..scrbl)))",[6,"PLTCOLLECTS"],false],
["pltdisablegc",">reference/garbagecollection.html#(idx._(gentag._340._(lib._scribblings/reference/reference..scrbl)))",[6,"PLTDISABLEGC"],false],
["pltdrbreak",">drracket/extending-drracket.html#(idx._(gentag._391._(lib._scribblings/drracket/drracket..scrbl)))",[6,"PLTDRBREAK"],false],
["pltdrcm",">drracket/extending-drracket.html#(idx._(gentag._387._(lib._scribblings/drracket/drracket..scrbl)))",[6,"PLTDRCM"],false],
["pltdrdebug",">drracket/extending-drracket.html#(idx._(gentag._389._(lib._scribblings/drracket/drracket..scrbl)))",[6,"PLTDRDEBUG"],false],
["pltdreasterseconds",">drracket/extending-drracket.html#(idx._(gentag._394._(lib._scribblings/drracket/drracket..scrbl)))",[6,"PLTDREASTERSECONDS"],false],
["pltdrpar",">drracket/extending-drracket.html#(idx._(gentag._388._(lib._scribblings/drracket/drracket..scrbl)))",[6,"PLTDRPAR"],false],
["pltdrprofile",">drracket/extending-drracket.html#(idx._(gentag._390._(lib._scribblings/drracket/drracket..scrbl)))",[6,"PLTDRPROFILE"],false],
["pltdrxrefdelay",">drracket/extending-drracket.html#(idx._(gentag._393._(lib._scribblings/drracket/drracket..scrbl)))",[6,"PLTDRXREFDELAY"],false],
["pltlinksfile",">reference/Filesystem.html#(idx._(gentag._279._(lib._scribblings/reference/reference..scrbl)))",[6,"PLTLINKSFILE"],false],
["pltnomzjit",">reference/eval.html#(idx._(gentag._225._(lib._scribblings/reference/reference..scrbl)))",[6,"PLTNOMZJIT"],false],
["pltnotools",">drracket/extending-drracket.html#(idx._(gentag._385._(lib._scribblings/drracket/drracket..scrbl)))",[6,"PLTNOTOOLS"],false],
["pltonlytool",">drracket/extending-drracket.html#(idx._(gentag._386._(lib._scribblings/drracket/drracket..scrbl)))",[6,"PLTONLYTOOL"],false],
["pltplaneturl",">planet/Utility_Libraries.html#(idx._(gentag._0._(lib._planet/planet..scrbl)))",[6,"PLTPLANETURL"],false],
["pltstderr",">reference/logging.html#(idx._(gentag._321._(lib._scribblings/reference/reference..scrbl)))",[6,"PLTSTDERR"],false],
["pltstringconstants",">string-constants/index.html#(idx._(gentag._0._(lib._string-constants/string-constants..scrbl)))",[6,"PLTSTRINGCONSTANTS"],false],
["pltstringconstants",">drracket/extending-drracket.html#(idx._(gentag._392._(lib._scribblings/drracket/drracket..scrbl)))",[6,"PLTSTRINGCONSTANTS"],false],
["pltsyslog",">reference/logging.html#(idx._(gentag._322._(lib._scribblings/reference/reference..scrbl)))",[6,"PLTSYSLOG"],false],
["plug",">redex/The_Redex_Reference.html#(def._((lib._redex/reduction-semantics..rkt)._plug))",[0,[2,"plug"]],["redex/reduction-semantics","redex"]],
["plus",">unstable/Automata__Compiling_State_Machines.html#(form._((lib._unstable/automata/re-ext..rkt)._plus))",[0,[1,"plus"]],["unstable/automata/re-ext"]],
["plus",">htdp-langs/beginner-abbr.html#(idx._htdp-beginner-abbr._(gentag._18._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-beginner-abbr))","plus",false],
["plus",">htdp-langs/beginner.html#(idx._htdp-beginner._(gentag._3._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-beginner))","plus",false],
["png",">draw/bitmap_.html#(idx._(gentag._2._(lib._scribblings/draw/draw..scrbl)))","PNG",false],
["png",">draw/bitmap_.html#(idx._(gentag._7._(lib._scribblings/draw/draw..scrbl)))","PNG",false],
["po",">reference/characters.html#(idx._(gentag._140._(lib._scribblings/reference/reference..scrbl)))",[7,"'po"],false],
["point",">db/util.html#(def._((lib._db/util/geometry..rkt)._point))",[0,[2,"point"]],["db/util/geometry"]],
["point%",">draw/point_.html",[0,[2,"point%"]],["racket/draw"]],
["point-alpha",">plot/params.html#(def._((lib._plot/main..rkt)._point-alpha))",[0,[2,"point-alpha"]],["plot"]],
["point-color",">plot/params.html#(def._((lib._plot/main..rkt)._point-color))",[0,[2,"point-color"]],["plot"]],
["point-label",">plot/renderer2d.html#(def._((lib._plot/main..rkt)._point-label))",[0,[2,"point-label"]],["plot"]],
["point-line-width",">plot/params.html#(def._((lib._plot/main..rkt)._point-line-width))",[0,[2,"point-line-width"]],["plot"]],
["point-size",">plot/params.html#(def._((lib._plot/main..rkt)._point-size))",[0,[2,"point-size"]],["plot"]],
["point-sym",">plot/params.html#(def._((lib._plot/main..rkt)._point-sym))",[0,[2,"point-sym"]],["plot"]],
["point-sym/c",">plot/contracts.html#(def._((lib._plot/utils..rkt)._point-sym/c))",[0,[2,"point-sym/c"]],["plot/utils"]],
["point-x",">db/util.html#(def._((lib._db/util/geometry..rkt)._point-x))",[0,[2,"point-x"]],["db/util/geometry"]],
["point-y",">db/util.html#(def._((lib._db/util/geometry..rkt)._point-y))",[0,[2,"point-y"]],["db/util/geometry"]],
["point?",">db/util.html#(def._((lib._db/util/geometry..rkt)._point~3f))",[0,[2,"point?"]],["db/util/geometry"]],
["pointer dereferencing",">foreign/foreign_pointer-funcs.html#(part._.Pointer_.Dereferencing)","Pointer Dereferencing",false],
["pointer functions",">foreign/foreign_pointer-funcs.html","Pointer Functions",false],
["pointer structure property",">foreign/foreign_pointer-funcs.html#(part._.Pointer_.Structure_.Property)","Pointer Structure Property",false],
["pointer types",">foreign/Pointer_Types.html","Pointer Types",false],
["pointers and gc-managed allocation",">foreign/intro.html#(part._.Pointers_and_.G.C-.Managed_.Allocation)","Pointers and GC-Managed Allocation",false],
["pointers and manual allocation",">foreign/intro.html#(part._.Pointers_and_.Manual_.Allocation)","Pointers and Manual Allocation",false],
["points",">plot/params.html#(part._.Points)","Points",false],
["points",">plot/renderer2d.html#(def._((lib._plot/main..rkt)._points))",[0,[2,"points"]],["plot"]],
["points",">plot/compat.html#(def._((lib._plot/compat..rkt)._points))",[0,[2,"points"]],["plot/compat"]],
["points3d",">plot/renderer3d.html#(def._((lib._plot/main..rkt)._points3d))",[0,[2,"points3d"]],["plot"]],
["pointwise operations",">images/Pointwise_Operations.html","Pointwise Operations",false],
["polar",">plot/renderer2d.html#(def._((lib._plot/main..rkt)._polar))",[0,[2,"polar"]],["plot"]],
["polar->cartesian",">plot/utils.html#(def._((lib._plot/utils..rkt)._polar-~3ecartesian))",[0,[2,"polar->cartesian"]],["plot/utils"]],
["polar-axes",">plot/renderer2d.html#(def._((lib._plot/main..rkt)._polar-axes))",[0,[2,"polar-axes"]],["plot"]],
["polar-axes-alpha",">plot/params.html#(def._((lib._plot/main..rkt)._polar-axes-alpha))",[0,[2,"polar-axes-alpha"]],["plot"]],
["polar-axes-labels?",">plot/params.html#(def._((lib._plot/main..rkt)._polar-axes-labels~3f))",[0,[2,"polar-axes-labels?"]],["plot"]],
["polar-axes-number",">plot/params.html#(def._((lib._plot/main..rkt)._polar-axes-number))",[0,[2,"polar-axes-number"]],["plot"]],
["polar-axes-ticks?",">plot/params.html#(def._((lib._plot/main..rkt)._polar-axes-ticks~3f))",[0,[2,"polar-axes-ticks?"]],["plot"]],
["polar-interval",">plot/renderer2d.html#(def._((lib._plot/main..rkt)._polar-interval))",[0,[2,"polar-interval"]],["plot"]],
["polar-label",">plot/renderer2d.html#(def._((lib._plot/main..rkt)._polar-label))",[0,[2,"polar-label"]],["plot"]],
["polar3d",">plot/renderer3d.html#(def._((lib._plot/main..rkt)._polar3d))",[0,[2,"polar3d"]],["plot"]],
["poll",">reference/sync.html","poll",false],
["poll-guard-evt",">reference/sync.html#(def._((quote._~23~25kernel)._poll-guard-evt))",[0,[2,"poll-guard-evt"]],["racket/base","racket"]],
["polygon",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._polygon))",[0,[2,"polygon"]],["2htdp/image"]],
["polygon",">db/util.html#(def._((lib._db/util/geometry..rkt)._polygon))",[0,[2,"polygon"]],["db/util/geometry"]],
["polygon-exterior",">db/util.html#(def._((lib._db/util/geometry..rkt)._polygon-exterior))",[0,[2,"polygon-exterior"]],["db/util/geometry"]],
["polygon-interior",">db/util.html#(def._((lib._db/util/geometry..rkt)._polygon-interior))",[0,[2,"polygon-interior"]],["db/util/geometry"]],
["polygon?",">db/util.html#(def._((lib._db/util/geometry..rkt)._polygon~3f))",[0,[2,"polygon?"]],["db/util/geometry"]],
["polygons",">graphics/Draw__Clear__and_Flip_Operations.html#(part._.Polygons)","Polygons",false],
["polygons",">teachpack/2htdpimage.html#(part._.Polygons)","Polygons",false],
["polymorphic data structures",">ts-guide/types.html#(part._.Polymorphic_.Data_.Structures)","Polymorphic Data Structures",false],
["polymorphic functions",">ts-guide/types.html#(part._.Polymorphic_.Functions)","Polymorphic Functions",false],
["polymorphism",">ts-guide/types.html#(part._.Polymorphism)","Polymorphism",false],
["pop-indentation",">preprocessor/mzpp.html#(def._((lib._preprocessor/mzpp..rkt)._pop-indentation))",[0,[2,"pop-indentation"]],["preprocessor/mzpp"]],
["pop3",">net/pop3.html#(def._((lib._net/pop3..rkt)._pop3))",[0,[2,"pop3"]],["net/pop3"]],
["pop3 signature",">net/pop3.html#(part._.P.O.P3_.Signature)","POP3 Signature",false],
["pop3 unit",">net/pop3.html#(part._.P.O.P3_.Unit)","POP3 Unit",false],
["pop3: reading mail",">net/pop3.html","POP3: Reading Mail",false],
["pop3?",">net/pop3.html#(def._((lib._net/pop3..rkt)._pop3~3f))",[0,[2,"pop3?"]],["net/pop3"]],
["pop3@",">net/pop3.html#(def._((lib._net/pop3-unit..rkt)._pop3~40))",[0,[2,"pop3@"]],["net/pop3-unit"]],
["pop3^",">net/pop3.html#(form._((lib._net/pop3-sig..rkt)._pop3~5e))",[0,[1,"pop3^"]],["net/pop3-sig"]],
["popt-lambda:",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._popt-lambda~3a))",[0,[1,"popt-lambda:"]],["typed/racket/base","typed/racket"]],
["popup menu",">gui/windowing-overview.html#(tech._popup._menu)","<span style=\"font-style: italic\">popup menu</span>",false],
["popup-menu",">gui/editor-admin_.html#(meth._(((lib._mred/main..rkt)._editor-admin~25)._popup-menu))",[[0,[2,"popup-menu"]],[14,[" (method of ",[0,[2,"editor-admin%"]],")"]]],["racket/gui/base","racket/gui"]],
["popup-menu",">gui/window___.html#(meth._(((lib._mred/main..rkt)._window~3c~25~3e)._popup-menu))",[[0,[2,"popup-menu"]],[14,[" (method of ",[0,[2,"window<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["popup-menu",">gui/snip-admin_.html#(meth._(((lib._racket/snip..rkt)._snip-admin~25)._popup-menu))",[[0,[2,"popup-menu"]],[14,[" (method of ",[0,[2,"snip-admin%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["popup-menu%",">gui/popup-menu_.html",[0,[2,"popup-menu%"]],["racket/gui/base","racket/gui"]],
["port",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Port))",[0,[1,"Port"]],["typed/racket/base","typed/racket"]],
["port",">web-server-internal/dispatch-server-unit.html#(sig-val._((lib._web-server/private/dispatch-server-sig..rkt)._dispatch-server-config~5e._port))",[0,[2,"port"]],["web-server/private/dispatch-server-sig"]],
["port",">web-server-internal/Web_Servers.html#(sig-val._web-config._((lib._web-server/web-config-sig..rkt)._web-config~5e._port))",[0,[2,"port"]],["web-server/web-config-sig"]],
["port",">web-server-internal/Web_Servers.html#(idx._(gentag._1._(lib._web-server/scribblings/web-server-internal..scrbl)))","port",false],
["port",">guide/i_o.html#(tech._port)","<span style=\"font-style: italic\">port</span>",false],
["port buffers and positions",">reference/port-buffers.html","Port Buffers and Positions",false],
["port display handler",">reference/Writing.html#(tech._port._display._handler)","<span style=\"font-style: italic\">port display\nhandler</span>",false],
["port events",">reference/port-lib.html#(part._.Port_.Events)","Port Events",false],
["port positions",">reference/linecol.html","port positions",false],
["port print handler",">reference/Writing.html#(tech._port._print._handler)","<span style=\"font-style: italic\">port print handler</span>",false],
["port read handler",">reference/Reading.html#(tech._port._read._handler)","<span style=\"font-style: italic\">port read handler</span>",false],
["port string and list conversions",">reference/port-lib.html#(part._.Port_.String_and_.List_.Conversions)","Port String and List Conversions",false],
["port write handler",">reference/Writing.html#(tech._port._write._handler)","<span style=\"font-style: italic\">port write handler</span>",false],
["port->bytes",">reference/port-lib.html#(def._((lib._racket/port..rkt)._port-~3ebytes))",[0,[2,"port->bytes"]],["racket/port","racket"]],
["port->bytes-lines",">reference/port-lib.html#(def._((lib._racket/port..rkt)._port-~3ebytes-lines))",[0,[2,"port->bytes-lines"]],["racket/port","racket"]],
["port->lines",">reference/port-lib.html#(def._((lib._racket/port..rkt)._port-~3elines))",[0,[2,"port->lines"]],["racket/port","racket"]],
["port->list",">reference/port-lib.html#(def._((lib._racket/port..rkt)._port-~3elist))",[0,[2,"port->list"]],["racket/port","racket"]],
["port->stream",">srfi-std/srfi-41/srfi-41.html#port-to-stream",[0,[2,"port->stream"]],["srfi/41"]],
["port->string",">reference/port-lib.html#(def._((lib._racket/port..rkt)._port-~3estring))",[0,[2,"port->string"]],["racket/port","racket"]],
["port-closed-evt",">reference/port-ops.html#(def._((quote._~23~25kernel)._port-closed-evt))",[0,[2,"port-closed-evt"]],["racket/base","racket"]],
["port-closed?",">reference/port-ops.html#(def._((quote._~23~25kernel)._port-closed~3f))",[0,[2,"port-closed?"]],["racket/base","racket"]],
["port-commit-peeked",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._port-commit-peeked))",[0,[2,"port-commit-peeked"]],["racket/base","racket"]],
["port-count-lines!",">reference/linecol.html#(def._((quote._~23~25kernel)._port-count-lines!))",[0,[2,"port-count-lines!"]],["racket/base","racket"]],
["port-count-lines-enabled",">reference/linecol.html#(def._((quote._~23~25kernel)._port-count-lines-enabled))",[0,[2,"port-count-lines-enabled"]],["racket/base","racket"]],
["port-display-handler",">reference/Writing.html#(def._((quote._~23~25kernel)._port-display-handler))",[0,[2,"port-display-handler"]],["racket/base","racket"]],
["port-eof?",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_666",[0,[2,"port-eof?"]],["rnrs/io/ports-6"]],
["port-file-identity",">reference/file-ports.html#(def._((quote._~23~25kernel)._port-file-identity))",[0,[2,"port-file-identity"]],["racket/base","racket"]],
["port-file-unlock",">reference/file-ports.html#(def._((quote._~23~25kernel)._port-file-unlock))",[0,[2,"port-file-unlock"]],["racket/base","racket"]],
["port-has-port-position?",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_652",[0,[2,"port-has-port-position?"]],["rnrs/io/ports-6"]],
["port-has-set-port-position!?",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_656",[0,[2,"port-has-set-port-position!?"]],["rnrs/io/ports-6"]],
["port-name-matches?",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3abasic~3c~25~3e)._port-name-matches~3f))",[[0,[2,"port-name-matches?"]],[14,[" (method of ",[0,[2,"text:basic<%>"]],")"]]],["framework"]],
["port-next-location",">reference/linecol.html#(def._((quote._~23~25kernel)._port-next-location))",[0,[2,"port-next-location"]],["racket/base","racket"]],
["port-no?",">reference/distributed-places.html#(def._((lib._racket/place/distributed..rkt)._port-no~3f))",[0,[2,"port-no?"]],["racket/place/distributed"]],
["port-number?",">unstable/contract.html#(def._((lib._unstable/contract..rkt)._port-number~3f))",[0,[2,"port-number?"]],["unstable/contract"]],
["port-position",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_654",[0,[2,"port-position"]],["rnrs/io/ports-6"]],
["port-print-handler",">reference/Writing.html#(def._((quote._~23~25kernel)._port-print-handler))",[0,[2,"port-print-handler"]],["racket/base","racket"]],
["port-progress-evt",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._port-progress-evt))",[0,[2,"port-progress-evt"]],["racket/base","racket"]],
["port-provides-progress-evts?",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._port-provides-progress-evts~3f))",[0,[2,"port-provides-progress-evts?"]],["racket/base","racket"]],
["port-read-handler",">reference/Reading.html#(def._((quote._~23~25kernel)._port-read-handler))",[0,[2,"port-read-handler"]],["racket/base","racket"]],
["port-transcoder",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_644",[0,[2,"port-transcoder"]],["rnrs/io/ports-6"]],
["port-try-file-lock?",">reference/file-ports.html#(def._((quote._~23~25kernel)._port-try-file-lock~3f))",[0,[2,"port-try-file-lock?"]],["racket/base","racket"]],
["port-write-handler",">reference/Writing.html#(def._((quote._~23~25kernel)._port-write-handler))",[0,[2,"port-write-handler"]],["racket/base","racket"]],
["port-writes-atomic?",">reference/Byte_and_String_Output.html#(def._((quote._~23~25kernel)._port-writes-atomic~3f))",[0,[2,"port-writes-atomic?"]],["racket/base","racket"]],
["port-writes-special?",">reference/Byte_and_String_Output.html#(def._((quote._~23~25kernel)._port-writes-special~3f))",[0,[2,"port-writes-special?"]],["racket/base","racket"]],
["port?",">reference/port-ops.html#(def._((lib._racket/private/misc..rkt)._port~3f))",[0,[2,"port?"]],["racket/base","racket"]],
["port?",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_642",[0,[2,"port?"]],["rnrs/io/ports-6"]],
["portability and bitmap variants",">draw/overview.html#(part._.Portability)","Portability and Bitmap Variants",false],
["porting from plot <= 5.1.3",">plot/porting.html","Porting From PLoT <= 5.1.3",false],
["porting image programs",">teachpack/2htdphtdp-port.html#(part._.Porting_.Image_.Programs)","Porting Image Programs",false],
["porting world programs",">teachpack/2htdphtdp-port.html#(part._.Porting_.World_.Programs)","Porting World Programs",false],
["porting world programs to universe",">teachpack/2htdphtdp-port.html","Porting World Programs to Universe",false],
["ports flushing",">reference/port-buffers.html#(idx._(gentag._194._(lib._scribblings/reference/reference..scrbl)))","ports, flushing",false],
["ports",">reference/ports.html","Ports",false],
["ports",">reference/ports.html#(tech._port)","<span style=\"font-style: italic\">Ports</span>",false],
["ports and the filesystem",">inside/Ports_and_the_Filesystem.html","Ports and the Filesystem",false],
["ports->ssl-ports",">openssl/index.html#(def._((lib._openssl/main..rkt)._ports-~3essl-ports))",[0,[2,"ports->ssl-ports"]],["openssl"]],
["position",">parser-tools/Lexers.html#(def._((lib._parser-tools/lex..rkt)._position))",[0,[2,"position"]],["parser-tools/lex"]],
["position",">gui/editor-overview.html#(tech._position)","<span style=\"font-style: italic\">position</span>",false],
["position",">reference/linecol.html#(tech._position)","<span style=\"font-style: italic\">position</span>",false],
["position operations",">graphics/posn.html","Position Operations",false],
["position-col",">parser-tools/Lexers.html#(def._((lib._parser-tools/lex..rkt)._position-col))",[0,[2,"position-col"]],["parser-tools/lex"]],
["position-line",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._position-line))",[[0,[2,"position-line"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["position-line",">parser-tools/Lexers.html#(def._((lib._parser-tools/lex..rkt)._position-line))",[0,[2,"position-line"]],["parser-tools/lex"]],
["position-location",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._position-location))",[[0,[2,"position-location"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["position-locations",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._position-locations))",[[0,[2,"position-locations"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["position-offset",">parser-tools/Lexers.html#(def._((lib._parser-tools/lex..rkt)._position-offset))",[0,[2,"position-offset"]],["parser-tools/lex"]],
["position-paragraph",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._position-paragraph))",[[0,[2,"position-paragraph"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["position-token",">parser-tools/Lexers.html#(def._((lib._parser-tools/lex..rkt)._position-token))",[0,[2,"position-token"]],["parser-tools/lex"]],
["position-token-end-pos",">parser-tools/Lexers.html#(def._((lib._parser-tools/lex..rkt)._position-token-end-pos))",[0,[2,"position-token-end-pos"]],["parser-tools/lex"]],
["position-token-start-pos",">parser-tools/Lexers.html#(def._((lib._parser-tools/lex..rkt)._position-token-start-pos))",[0,[2,"position-token-start-pos"]],["parser-tools/lex"]],
["position-token-token",">parser-tools/Lexers.html#(def._((lib._parser-tools/lex..rkt)._position-token-token))",[0,[2,"position-token-token"]],["parser-tools/lex"]],
["position-token?",">parser-tools/Lexers.html#(def._((lib._parser-tools/lex..rkt)._position-token~3f))",[0,[2,"position-token?"]],["parser-tools/lex"]],
["position?",">parser-tools/Lexers.html#(def._((lib._parser-tools/lex..rkt)._position~3f))",[0,[2,"position?"]],["parser-tools/lex"]],
["positive-byte",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Positive-.Byte))",[0,[1,"Positive-Byte"]],["typed/racket/base","typed/racket"]],
["positive-exact-rational",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Positive-.Exact-.Rational))",[0,[1,"Positive-Exact-Rational"]],["typed/racket/base","typed/racket"]],
["positive-fixnum",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Positive-.Fixnum))",[0,[1,"Positive-Fixnum"]],["typed/racket/base","typed/racket"]],
["positive-float",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Positive-.Float))",[0,[1,"Positive-Float"]],["typed/racket/base","typed/racket"]],
["positive-flonum",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Positive-.Flonum))",[0,[1,"Positive-Flonum"]],["typed/racket/base","typed/racket"]],
["positive-index",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Positive-.Index))",[0,[1,"Positive-Index"]],["typed/racket/base","typed/racket"]],
["positive-inexact-real",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Positive-.Inexact-.Real))",[0,[1,"Positive-Inexact-Real"]],["typed/racket/base","typed/racket"]],
["positive-integer",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Positive-.Integer))",[0,[1,"Positive-Integer"]],["typed/racket/base","typed/racket"]],
["positive-real",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Positive-.Real))",[0,[1,"Positive-Real"]],["typed/racket/base","typed/racket"]],
["positive-single-flonum",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Positive-.Single-.Flonum))",[0,[1,"Positive-Single-Flonum"]],["typed/racket/base","typed/racket"]],
["positive?",">reference/number-types.html#(def._((quote._~23~25kernel)._positive~3f))",[0,[2,"positive?"]],["racket/base","racket"]],
["positive?",">r5rs-std/r5rs-Z-H-9.html#%_idx_270",[0,[2,"positive?"]],["r5rs"]],
["positive?",">r6rs-std/r6rs-Z-H-14.html#node_idx_476",[0,[2,"positive?"]],["rnrs/base-6"]],
["positive?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._positive~3f))",[0,[2,"positive?"]],["lang/htdp-advanced"]],
["positive?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._positive~3f))",[0,[2,"positive?"]],["lang/htdp-beginner"]],
["positive?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._positive~3f))",[0,[2,"positive?"]],["lang/htdp-beginner-abbr"]],
["positive?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._positive~3f))",[0,[2,"positive?"]],["lang/htdp-intermediate"]],
["positive?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._positive~3f))",[0,[2,"positive?"]],["lang/htdp-intermediate-lambda"]],
["positive?",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._positive~3f))",[0,[2,"positive?"]],["deinprogramm/DMdA-advanced"]],
["positive?",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._positive~3f))",[0,[2,"positive?"]],["deinprogramm/DMdA-assignments"]],
["positive?",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._positive~3f))",[0,[2,"positive?"]],["deinprogramm/DMdA-beginner"]],
["positive?",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._positive~3f))",[0,[2,"positive?"]],["deinprogramm/DMdA-vanilla"]],
["posix character class",">guide/regexp-chars.html#(tech._posix._character._clas)","<span style=\"font-style: italic\">POSIX character class</span>",false],
["posix character classes",">guide/regexp-chars.html#(part._.P.O.S.I.X_character_classes)","POSIX character classes",false],
["posn",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._posn))",[0,[2,"posn"]],["lang/htdp-advanced"]],
["posn",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._posn))",[0,[2,"posn"]],["lang/htdp-beginner"]],
["posn",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._posn))",[0,[2,"posn"]],["lang/htdp-beginner-abbr"]],
["posn",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._posn))",[0,[2,"posn"]],["lang/htdp-intermediate"]],
["posn",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._posn))",[0,[2,"posn"]],["lang/htdp-intermediate-lambda"]],
["posn",">htdp/index.html#(def._((lib._lang/posn..rkt)._posn))",[0,[2,"posn"]],["lang/posn"]],
["posn",">graphics/posn.html#(def._((lib._graphics/graphics..rkt)._posn))",[0,[2,"posn"]],["graphics/graphics"]],
["posn-x",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._posn-x))",[0,[2,"posn-x"]],["lang/htdp-advanced"]],
["posn-x",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._posn-x))",[0,[2,"posn-x"]],["lang/htdp-beginner"]],
["posn-x",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._posn-x))",[0,[2,"posn-x"]],["lang/htdp-beginner-abbr"]],
["posn-x",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._posn-x))",[0,[2,"posn-x"]],["lang/htdp-intermediate"]],
["posn-x",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._posn-x))",[0,[2,"posn-x"]],["lang/htdp-intermediate-lambda"]],
["posn-x",">htdp/index.html#(def._((lib._lang/posn..rkt)._posn-x))",[0,[2,"posn-x"]],["lang/posn"]],
["posn-x",">graphics/posn.html#(def._((lib._graphics/graphics..rkt)._posn-x))",[0,[2,"posn-x"]],["graphics/graphics"]],
["posn-y",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._posn-y))",[0,[2,"posn-y"]],["lang/htdp-advanced"]],
["posn-y",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._posn-y))",[0,[2,"posn-y"]],["lang/htdp-beginner"]],
["posn-y",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._posn-y))",[0,[2,"posn-y"]],["lang/htdp-beginner-abbr"]],
["posn-y",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._posn-y))",[0,[2,"posn-y"]],["lang/htdp-intermediate"]],
["posn-y",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._posn-y))",[0,[2,"posn-y"]],["lang/htdp-intermediate-lambda"]],
["posn-y",">htdp/index.html#(def._((lib._lang/posn..rkt)._posn-y))",[0,[2,"posn-y"]],["lang/posn"]],
["posn-y",">graphics/posn.html#(def._((lib._graphics/graphics..rkt)._posn-y))",[0,[2,"posn-y"]],["graphics/graphics"]],
["posn?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._posn~3f))",[0,[2,"posn?"]],["lang/htdp-advanced"]],
["posn?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._posn~3f))",[0,[2,"posn?"]],["lang/htdp-beginner"]],
["posn?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._posn~3f))",[0,[2,"posn?"]],["lang/htdp-beginner-abbr"]],
["posn?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._posn~3f))",[0,[2,"posn?"]],["lang/htdp-intermediate"]],
["posn?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._posn~3f))",[0,[2,"posn?"]],["lang/htdp-intermediate-lambda"]],
["posn?",">htdp/index.html#(def._((lib._lang/posn..rkt)._posn~3f))",[0,[2,"posn?"]],["lang/posn"]],
["posn?",">graphics/posn.html#(def._((lib._graphics/graphics..rkt)._posn~3f))",[0,[2,"posn?"]],["graphics/graphics"]],
["posns",">htdp-langs/advanced.html#(part._htdp-advanced._.Posns)","Posns",false],
["posns",">htdp-langs/beginner.html#(part._htdp-beginner._.Posns)","Posns",false],
["posns",">htdp-langs/beginner-abbr.html#(part._htdp-beginner-abbr._.Posns)","Posns",false],
["posns",">htdp-langs/intermediate.html#(part._htdp-intermediate._.Posns)","Posns",false],
["posns",">htdp-langs/intermediate-lam.html#(part._htdp-intermediate-lambda._.Posns)","Posns",false],
["posns in htdp languages",">htdp/index.html#(part._posns_in_.Ht.D.P_.Languages)",[[0,[2,"posn"]],"s in ","<span style=\"font-style: italic\">HtDP</span>"," Languages"],false],
["post",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/dummy-10..rkt)._post))",[0,[2,"post"]],[]],
["post",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-1..rkt)._post))",[0,[2,"post"]],[]],
["post",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-5..rkt)._post))",[0,[2,"post"]],[]],
["post-add-comment!",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-5..rkt)._post-add-comment!))",[0,"post-add-comment!"],[]],
["post-blog",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/dummy-10..rkt)._post-blog))",[0,[2,"post-blog"]],[]],
["post-body",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-1..rkt)._post-body))",[0,[2,"post-body"]],[]],
["post-body",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-5..rkt)._post-body))",[0,[2,"post-body"]],[]],
["post-comments",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-5..rkt)._post-comments))",[0,[2,"post-comments"]],[]],
["post-id",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/dummy-10..rkt)._post-id))",[0,[2,"post-id"]],[]],
["post-impure-port",">net/url.html#(def._((lib._net/url..rkt)._post-impure-port))",[0,[2,"post-impure-port"]],["net/url"]],
["post-insert-comment!",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-9..rkt)._post-insert-comment!))",[0,"post-insert-comment!"],[]],
["post-pure-port",">net/url.html#(def._((lib._net/url..rkt)._post-pure-port))",[0,[2,"post-pure-port"]],["net/url"]],
["post-script-dc%",">draw/post-script-dc_.html",[0,[2,"post-script-dc%"]],["racket/draw"]],
["post-title",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-1..rkt)._post-title))",[0,[2,"post-title"]],[]],
["post-title",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-5..rkt)._post-title))",[0,[2,"post-title"]],[]],
["post-url",">browser/index.html#(meth._(((lib._browser/browser..rkt)._hyper-text-mixin)._post-url))",[[0,[2,"post-url"]],[14,[" (method of ",[0,[2,"hyper-text-mixin"]],")"]]],["browser/browser","browser"]],
["post-url",">browser/index.html#(meth._(((lib._browser/htmltext..rkt)._html-text~3c~25~3e)._post-url))",[[0,[2,"post-url"]],[14,[" (method of ",[0,[2,"html-text<%>"]],")"]]],["browser/htmltext"]],
["post?",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/dummy-10..rkt)._post~3f))",[0,[2,"post?"]],[]],
["post?",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-1..rkt)._post~3f))",[0,[2,"post?"]],[]],
["post?",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-5..rkt)._post~3f))",[0,[2,"post?"]],[]],
["postdoc",">scribble/config.html#(idx._(gentag._18._(lib._scribblings/scribble/scribble..scrbl)))","postDoc",false],
["postgis",">db/util.html#(idx._(gentag._8._(lib._db/scribblings/db..scrbl)))","PostGIS",false],
["postgresql",">db/index.html#(idx._(gentag._1._(lib._db/scribblings/db..scrbl)))","PostgreSQL",false],
["postgresql authentication",">db/notes.html#(part._.Postgre.S.Q.L_.Authentication)","PostgreSQL Authentication",false],
["postgresql database character encoding",">db/notes.html#(part._.Postgre.S.Q.L_.Database_.Character_.Encoding)","PostgreSQL Database Character Encoding",false],
["postgresql types",">db/sql-types.html#(part._postgresql-types)","PostgreSQL Types",false],
["postgresql-connect",">db/connect.html#(def._((lib._db/main..rkt)._postgresql-connect))",[0,[2,"postgresql-connect"]],["db"]],
["postgresql-data-source",">db/connect.html#(def._((lib._db/base..rkt)._postgresql-data-source))",[0,[2,"postgresql-data-source"]],["db","db/base"]],
["postgresql-guess-socket-path",">db/connect.html#(def._((lib._db/main..rkt)._postgresql-guess-socket-path))",[0,[2,"postgresql-guess-socket-path"]],["db"]],
["postgresql-specific types",">db/util.html#(part._postgresql-ext)","PostgreSQL-specific Types",false],
["pousse --- tic-tac-toe-like game",">games/pousse.html",[[15,"<img src=\"pousse.png\" alt=\"\" />"]," ","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Pousse</span>"," ","&#8212;","<wbr></wbr>"," Tic-Tac-Toe-like Game"],false],
["powers and roots",">reference/generic-numbers.html#(part._.Powers_and_.Roots)","Powers and Roots",false],
["ppict-add",">unstable/ppict.html#(def._((lib._unstable/gui/ppict..rkt)._ppict-add))",[0,[2,"ppict-add"]],["unstable/gui/ppict"]],
["ppict-add*",">unstable/ppict.html#(def._((lib._unstable/gui/ppict..rkt)._ppict-add*))",[0,[2,"ppict-add*"]],["unstable/gui/ppict"]],
["ppict-do",">unstable/ppict.html#(form._((lib._unstable/gui/ppict..rkt)._ppict-do))",[0,[1,"ppict-do"]],["unstable/gui/ppict"]],
["ppict-do*",">unstable/ppict.html#(form._((lib._unstable/gui/ppict..rkt)._ppict-do*))",[0,[1,"ppict-do*"]],["unstable/gui/ppict"]],
["ppict-do-state",">unstable/ppict.html#(form._((lib._unstable/gui/ppict..rkt)._ppict-do-state))",[0,[1,"ppict-do-state"]],["unstable/gui/ppict"]],
["ppict-go",">unstable/ppict.html#(def._((lib._unstable/gui/ppict..rkt)._ppict-go))",[0,[2,"ppict-go"]],["unstable/gui/ppict"]],
["ppict?",">unstable/ppict.html#(def._((lib._unstable/gui/ppict..rkt)._ppict~3f))",[0,[2,"ppict?"]],["unstable/gui/ppict"]],
["pre",">html/index.html#(def._((lib._html/main..rkt)._pre))",[0,[2,"pre"]],["html"]],
["pre-content",">scribble/decode.html#(tech._pre._content)","<span style=\"font-style: italic\">pre-content</span>",false],
["pre-content?",">scribble/decode.html#(def._((lib._scribble/decode..rkt)._pre-content~3f))",[0,[2,"pre-content?"]],["scribble/decode"]],
["pre-defined functions",">htdp-langs/advanced.html#(part._advanced-pre-defined)","Pre-Defined Functions",false],
["pre-defined functions",">htdp-langs/beginner-abbr.html#(part._beginner-abbr-pre-defined)","Pre-defined Functions",false],
["pre-defined functions",">htdp-langs/beginner.html#(part._beginner-pre-defined)","Pre-defined Functions",false],
["pre-defined functions",">htdp-langs/intermediate.html#(part._intermediate-pre-defined)","Pre-defined Functions",false],
["pre-defined functions",">htdp-langs/intermediate-lam.html#(part._intm-w-lambda-pre-defined)","Pre-defined Functions",false],
["pre-defined variables",">htdp-langs/advanced.html#(part._advanced._.Pre-.Defined._.Variables)","Pre-Defined Variables",false],
["pre-defined variables",">htdp-langs/beginner.html#(part._beginner._.Pre-.Defined._.Variables)","Pre-Defined Variables",false],
["pre-defined variables",">htdp-langs/beginner-abbr.html#(part._beginner-abbr._.Pre-.Defined._.Variables)","Pre-Defined Variables",false],
["pre-defined variables",">htdp-langs/intermediate.html#(part._intermediate._.Pre-.Defined._.Variables)","Pre-Defined Variables",false],
["pre-defined variables",">htdp-langs/intermediate-lam.html#(part._intm-w-lambda._.Pre-.Defined._.Variables)","Pre-Defined Variables",false],
["pre-expand-export",">reference/stxtrans.html#(def._((lib._racket/provide-transform..rkt)._pre-expand-export))",[0,[2,"pre-expand-export"]],["racket/provide-transform"]],
["pre-flow",">scribble/decode.html#(tech._pre._flow)","<span style=\"font-style: italic\">pre-flow</span>",false],
["pre-flow?",">scribble/decode.html#(def._((lib._scribble/decode..rkt)._pre-flow~3f))",[0,[2,"pre-flow?"]],["scribble/decode"]],
["pre-install",">make/setup-extension.html#(def._((lib._make/setup-extension..rkt)._pre-install))",[0,"pre-install"],["make/setup-extension"]],
["pre-part",">scribble/decode.html#(tech._pre._part)","<span style=\"font-style: italic\">pre-part</span>",false],
["pre-part?",">scribble/decode.html#(def._((lib._scribble/decode..rkt)._pre-part~3f))",[0,[2,"pre-part?"]],["scribble/decode"]],
["pre-tick",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._pre-tick))",[0,[2,"pre-tick"]],["plot"]],
["pre-tick-major?",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._pre-tick-major~3f))",[0,[2,"pre-tick-major?"]],["plot"]],
["pre-tick-value",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._pre-tick-value))",[0,[2,"pre-tick-value"]],["plot"]],
["pre-tick?",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._pre-tick~3f))",[0,[2,"pre-tick?"]],["plot"]],
["pre?",">html/index.html#(def._((lib._html/main..rkt)._pre~3f))",[0,[2,"pre?"]],["html"]],
["pred",">ts-reference/Legacy_Forms.html#(form._((lib._typed-racket/base-env/base-types-extra..rkt)._pred))",[0,[1,"pred"]],["typed/racket/base","typed/racket"]],
["predefined formlets",">web-server/formlets.html#(part._input-formlets)","Predefined Formlets",false],
["predefined latex macros",">scribble/config.html#(part._builtin-latex)","Predefined Latex Macros",false],
["predefined list loops",">guide/Lists__Iteration__and_Recursion.html#(part._.Predefined_.List_.Loops)","Predefined List Loops",false],
["predicate",">deinprogramm/Signaturen.html#(part._predicate)",[0,[1,"predicate"]],false],
["predicate",">deinprogramm/Signaturen.html#(form._((lib._deinprogramm/.D.Md.A..rkt)._predicate))",[0,[1,"predicate"]],["deinprogramm/DMdA-beginner"]],
["predicate",">guide/define-struct.html#(tech._predicate)","<span style=\"font-style: italic\">predicate</span>",false],
["predicate",">reference/define-struct.html#(tech._predicate)","<span style=\"font-style: italic\">predicate</span>",false],
["predicate/c",">reference/function-contracts.html#(def._((lib._racket/contract/base..rkt)._predicate/c))",[0,[2,"predicate/c"]],["racket/contract/base","racket/contract","racket"]],
["predicates",">racklog/predicates.html","Predicates",false],
["predicates introducing facts",">racklog/predicates.html#(part._facts)","Predicates Introducing Facts",false],
["predicates with rules",">racklog/predicates.html#(part._rules)","Predicates with Rules",false],
["predoc",">scribble/config.html#(idx._(gentag._17._(lib._scribblings/scribble/scribble..scrbl)))","preDoc",false],
["pref-dir",">reference/Filesystem.html#(idx._(gentag._268._(lib._scribblings/reference/reference..scrbl)))",[7,"'pref-dir"],false],
["pref-file",">gui/mredprefs.html#(idx._(gentag._218._(lib._scribblings/gui/gui..scrbl)))",[7,"'pref-file"],false],
["pref-file",">reference/Filesystem.html#(idx._(gentag._269._(lib._scribblings/reference/reference..scrbl)))",[7,"'pref-file"],false],
["pref:get/set",">unstable/gui-prefs.html#(def._((lib._unstable/gui/prefs..rkt)._pref~3aget/set))",[0,[2,"pref:get/set"]],["unstable/gui/prefs"]],
["prefab",">guide/define-struct.html#(tech._prefab)","<span style=\"font-style: italic\">prefab</span>",false],
["prefab",">reference/structures.html#(tech._prefab)","<span style=\"font-style: italic\">prefab</span>",false],
["prefab structure types",">guide/define-struct.html#(part._prefab-struct)","Prefab Structure Types",false],
["prefab-key->struct-type",">reference/structutils.html#(def._((quote._~23~25kernel)._prefab-key-~3estruct-type))",[0,[2,"prefab-key->struct-type"]],["racket/base","racket"]],
["prefab-key?",">reference/structutils.html#(def._((quote._~23~25kernel)._prefab-key~3f))",[0,[2,"prefab-key?"]],["racket/base","racket"]],
["prefab-struct-key",">reference/structutils.html#(def._((quote._~23~25kernel)._prefab-struct-key))",[0,[2,"prefab-struct-key"]],["racket/base","racket"]],
["preference files",">drracket/drracket-files.html#(part._.Preference_.Files)","Preference Files",false],
["preferences",">drracket/prefs-explanation.html","Preferences",false],
["preferences",">framework/Preferences.html","Preferences",false],
["preferences",">gui/mredprefs.html","Preferences",false],
["preferences",">unstable/gui-prefs.html","Preferences",false],
["preferences, textual",">framework/Preferences__Textual.html","Preferences, Textual",false],
["preferences-lock-file-mode",">reference/Filesystem.html#(def._((lib._racket/file..rkt)._preferences-lock-file-mode))",[0,[2,"preferences-lock-file-mode"]],["racket/file","racket"]],
["preferences... menu item",">drracket/Menus.html#(idx._(gentag._91._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Preferences...</span> menu item",false],
["preferences:add-callback",">framework/Preferences__Textual.html#(def._((lib._framework/preferences..rkt)._preferences~3aadd-callback))",[0,[2,"preferences:add-callback"]],["framework/preferences","framework"]],
["preferences:add-can-close-dialog-callback",">framework/Preferences.html#(def._((lib._framework/main..rkt)._preferences~3aadd-can-close-dialog-callback))",[0,[2,"preferences:add-can-close-dialog-callback"]],["framework"]],
["preferences:add-editor-checkbox-panel",">framework/Preferences.html#(def._((lib._framework/main..rkt)._preferences~3aadd-editor-checkbox-panel))",[0,[2,"preferences:add-editor-checkbox-panel"]],["framework"]],
["preferences:add-font-panel",">framework/Preferences.html#(def._((lib._framework/main..rkt)._preferences~3aadd-font-panel))",[0,[2,"preferences:add-font-panel"]],["framework"]],
["preferences:add-general-checkbox-panel",">framework/Preferences.html#(def._((lib._framework/main..rkt)._preferences~3aadd-general-checkbox-panel))",[0,[2,"preferences:add-general-checkbox-panel"]],["framework"]],
["preferences:add-on-close-dialog-callback",">framework/Preferences.html#(def._((lib._framework/main..rkt)._preferences~3aadd-on-close-dialog-callback))",[0,[2,"preferences:add-on-close-dialog-callback"]],["framework"]],
["preferences:add-panel",">framework/Preferences.html#(def._((lib._framework/main..rkt)._preferences~3aadd-panel))",[0,[2,"preferences:add-panel"]],["framework"]],
["preferences:add-scheme-checkbox-panel",">framework/Preferences.html#(def._((lib._framework/main..rkt)._preferences~3aadd-scheme-checkbox-panel))",[0,[2,"preferences:add-scheme-checkbox-panel"]],["framework"]],
["preferences:add-to-editor-checkbox-panel",">framework/Preferences.html#(def._((lib._framework/main..rkt)._preferences~3aadd-to-editor-checkbox-panel))",[0,[2,"preferences:add-to-editor-checkbox-panel"]],["framework"]],
["preferences:add-to-general-checkbox-panel",">framework/Preferences.html#(def._((lib._framework/main..rkt)._preferences~3aadd-to-general-checkbox-panel))",[0,[2,"preferences:add-to-general-checkbox-panel"]],["framework"]],
["preferences:add-to-scheme-checkbox-panel",">framework/Preferences.html#(def._((lib._framework/main..rkt)._preferences~3aadd-to-scheme-checkbox-panel))",[0,[2,"preferences:add-to-scheme-checkbox-panel"]],["framework"]],
["preferences:add-to-warnings-checkbox-panel",">framework/Preferences.html#(def._((lib._framework/main..rkt)._preferences~3aadd-to-warnings-checkbox-panel))",[0,[2,"preferences:add-to-warnings-checkbox-panel"]],["framework"]],
["preferences:add-warnings-checkbox-panel",">framework/Preferences.html#(def._((lib._framework/main..rkt)._preferences~3aadd-warnings-checkbox-panel))",[0,[2,"preferences:add-warnings-checkbox-panel"]],["framework"]],
["preferences:get",">framework/Preferences__Textual.html#(def._((lib._framework/preferences..rkt)._preferences~3aget))",[0,[2,"preferences:get"]],["framework/preferences","framework"]],
["preferences:get-preference/gui",">framework/Preferences.html#(def._((lib._framework/main..rkt)._preferences~3aget-preference/gui))",[0,[2,"preferences:get-preference/gui"]],["framework"]],
["preferences:get-prefs-snapshot",">framework/Preferences__Textual.html#(def._((lib._framework/preferences..rkt)._preferences~3aget-prefs-snapshot))",[0,[2,"preferences:get-prefs-snapshot"]],["framework/preferences","framework"]],
["preferences:hide-dialog",">framework/Preferences.html#(def._((lib._framework/main..rkt)._preferences~3ahide-dialog))",[0,[2,"preferences:hide-dialog"]],["framework"]],
["preferences:low-level-get-preference",">framework/Preferences__Textual.html#(def._((lib._framework/preferences..rkt)._preferences~3alow-level-get-preference))",[0,[2,"preferences:low-level-get-preference"]],["framework/preferences","framework"]],
["preferences:low-level-put-preferences",">framework/Preferences__Textual.html#(def._((lib._framework/preferences..rkt)._preferences~3alow-level-put-preferences))",[0,[2,"preferences:low-level-put-preferences"]],["framework/preferences","framework"]],
["preferences:put-preferences/gui",">framework/Preferences.html#(def._((lib._framework/main..rkt)._preferences~3aput-preferences/gui))",[0,[2,"preferences:put-preferences/gui"]],["framework"]],
["preferences:register-save-callback",">framework/Preferences__Textual.html#(def._((lib._framework/preferences..rkt)._preferences~3aregister-save-callback))",[0,[2,"preferences:register-save-callback"]],["framework/preferences","framework"]],
["preferences:restore-defaults",">framework/Preferences__Textual.html#(def._((lib._framework/preferences..rkt)._preferences~3arestore-defaults))",[0,[2,"preferences:restore-defaults"]],["framework/preferences","framework"]],
["preferences:restore-prefs-snapshot",">framework/Preferences__Textual.html#(def._((lib._framework/preferences..rkt)._preferences~3arestore-prefs-snapshot))",[0,[2,"preferences:restore-prefs-snapshot"]],["framework/preferences","framework"]],
["preferences:set",">framework/Preferences__Textual.html#(def._((lib._framework/preferences..rkt)._preferences~3aset))",[0,[2,"preferences:set"]],["framework/preferences","framework"]],
["preferences:set-default",">framework/Preferences__Textual.html#(def._((lib._framework/preferences..rkt)._preferences~3aset-default))",[0,[2,"preferences:set-default"]],["framework/preferences","framework"]],
["preferences:set-un/marshall",">framework/Preferences__Textual.html#(def._((lib._framework/preferences..rkt)._preferences~3aset-un/marshall))",[0,[2,"preferences:set-un/marshall"]],["framework/preferences","framework"]],
["preferences:show-dialog",">framework/Preferences.html#(def._((lib._framework/main..rkt)._preferences~3ashow-dialog))",[0,[2,"preferences:show-dialog"]],["framework"]],
["preferences:snapshot?",">framework/Preferences__Textual.html#(def._((lib._framework/preferences..rkt)._preferences~3asnapshot~3f))",[0,[2,"preferences:snapshot?"]],["framework/preferences","framework"]],
["preferences:unregister-save-callback",">framework/Preferences__Textual.html#(def._((lib._framework/preferences..rkt)._preferences~3aunregister-save-callback))",[0,[2,"preferences:unregister-save-callback"]],["framework/preferences","framework"]],
["prefix",">raco/decompile.html#(part._.Prefix)","Prefix",false],
["prefix",">reference/creatingunits.html#(form._((lib._mzlib/unit..rkt)._prefix))",[0,[1,"prefix"]],["racket/unit","racket"]],
["prefix",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._prefix))",[0,[2,"prefix"]],["compiler/zo-structs"]],
["prefix file",">scribble/config.html#(tech._prefix._file)","<span style=\"font-style: italic\">prefix file</span>",false],
["prefix-in",">reference/require.html#(form._((lib._racket/private/base..rkt)._prefix-in))",[0,[1,"prefix-in"]],["racket/base","racket"]],
["prefix-num-lifts",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._prefix-num-lifts))",[0,[2,"prefix-num-lifts"]],["compiler/zo-structs"]],
["prefix-out",">reference/require.html#(form._((lib._racket/private/base..rkt)._prefix-out))",[0,[1,"prefix-out"]],["racket/base","racket"]],
["prefix-stxs",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._prefix-stxs))",[0,[2,"prefix-stxs"]],["compiler/zo-structs"]],
["prefix-toplevels",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._prefix-toplevels))",[0,[2,"prefix-toplevels"]],["compiler/zo-structs"]],
["prefix?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._prefix~3f))",[0,[2,"prefix?"]],["compiler/zo-structs"]],
["pregexp",">reference/regexp.html#(def._((quote._~23~25kernel)._pregexp))",[0,[2,"pregexp"]],["racket/base","racket"]],
["pregexp",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.P.Regexp))",[0,[1,"PRegexp"]],["typed/racket/base","typed/racket"]],
["pregexp-match",">mzlib/mzlib_pregexp.html#(def._((lib._mzlib/pregexp..rkt)._pregexp-match))",[0,[2,"pregexp-match"]],["mzlib/pregexp"]],
["pregexp-match-positions",">mzlib/mzlib_pregexp.html#(def._((lib._mzlib/pregexp..rkt)._pregexp-match-positions))",[0,[2,"pregexp-match-positions"]],["mzlib/pregexp"]],
["pregexp-replace",">mzlib/mzlib_pregexp.html#(def._((lib._mzlib/pregexp..rkt)._pregexp-replace))",[0,[2,"pregexp-replace"]],["mzlib/pregexp"]],
["pregexp-replace*",">mzlib/mzlib_pregexp.html#(def._((lib._mzlib/pregexp..rkt)._pregexp-replace*))",[0,[2,"pregexp-replace*"]],["mzlib/pregexp"]],
["pregexp-split",">mzlib/mzlib_pregexp.html#(def._((lib._mzlib/pregexp..rkt)._pregexp-split))",[0,[2,"pregexp-split"]],["mzlib/pregexp"]],
["pregexp?",">reference/regexp.html#(def._((quote._~23~25kernel)._pregexp~3f))",[0,[2,"pregexp?"]],["racket/base","racket"]],
["premature-close",">net/nntp.html#(def._((lib._net/nntp..rkt)._premature-close))",[0,[2,"premature-close"]],["net/nntp"]],
["premature-close-communicator",">net/nntp.html#(def._((lib._net/nntp..rkt)._premature-close-communicator))",[0,[2,"premature-close-communicator"]],["net/nntp"]],
["premature-close?",">net/nntp.html#(def._((lib._net/nntp..rkt)._premature-close~3f))",[0,[2,"premature-close?"]],["net/nntp"]],
["prepare",">db/query-api.html#(def._((lib._db/base..rkt)._prepare))",[0,[2,"prepare"]],["db","db/base"]],
["prepare your distribution",">planet/Developing_Packages_for_PLaneT.html#(part._.Prepare_.Your_.Distribution)","Prepare Your Distribution",false],
["prepared statement",">db/query-api.html#(tech._prepared._statement)","<span style=\"font-style: italic\">prepared statement</span>",false],
["prepared statements",">db/query-api.html#(part._.Prepared_.Statements)","Prepared Statements",false],
["prepared-statement-parameter-types",">db/query-api.html#(def._((lib._db/base..rkt)._prepared-statement-parameter-types))",[0,[2,"prepared-statement-parameter-types"]],["db","db/base"]],
["prepared-statement-result-types",">db/query-api.html#(def._((lib._db/base..rkt)._prepared-statement-result-types))",[0,[2,"prepared-statement-result-types"]],["db","db/base"]],
["prepared-statement?",">db/query-api.html#(def._((lib._db/base..rkt)._prepared-statement~3f))",[0,[2,"prepared-statement?"]],["db","db/base"]],
["preprint",">scribble/SIGPLAN_Paper_Format.html#(form._((lib._scribble/sigplan..rkt)._preprint))",[0,[1,"preprint"]],["scribble/sigplan"]],
["preprocess",">preprocessor/mzpp.html#(def._((lib._preprocessor/mzpp..rkt)._preprocess))",[0,[2,"preprocess"]],["preprocessor/mzpp"]],
["preprocess",">preprocessor/mztext.html#(def._((lib._preprocessor/mztext..rkt)._preprocess))",[0,[2,"preprocess"]],["preprocessor/mztext"]],
["preprocessor",">scribble/text.html","Preprocessor",false],
["preprocessor/mzpp",">preprocessor/mzpp.html#(mod-path._preprocessor/mzpp)",[9,[0,"preprocessor/mzpp"]],"module"],
["preprocessor/mztext",">preprocessor/mztext.html#(mod-path._preprocessor/mztext)",[9,[0,"preprocessor/mztext"]],"module"],
["preprocessor/pp-run",">preprocessor/overview.html",[9,[0,"preprocessor/pp-run"]],"module"],
["preserved",">reference/eval-model.html#(tech._preserved)","<span style=\"font-style: italic\">preserved</span>",false],
["preserving comments",">scribble/scribble_manual_code.html#(part._.Preserving_.Comments)","Preserving Comments",false],
["preserving source locations",">syntax/Preserving_Source_Locations.html","Preserving Source Locations",false],
["preserving variables",">racklog/lv-manip.html#(part._freeze)","Preserving Variables",false],
["press",">gui/key-event_.html#(idx._(gentag._112._(lib._scribblings/gui/gui..scrbl)))",[7,"'press"],false],
["pretty big (legacy language)",">htdp/index.html#(part._.Pretty_.Big__.Legacy_.Language_)","Pretty Big (Legacy Language)",false],
["pretty big text (legacy language)",">htdp/index.html#(part._.Pretty_.Big_.Text__.Legacy_.Language_)","Pretty Big Text (Legacy Language)",false],
["pretty printing",">reference/pretty-print.html","Pretty Printing",false],
["pretty-display",">reference/pretty-print.html#(def._((lib._racket/pretty..rkt)._pretty-display))",[0,[2,"pretty-display"]],["racket/pretty","racket"]],
["pretty-finish",">gui/editor-stream-out_.html#(meth._(((lib._mred/main..rkt)._editor-stream-out~25)._pretty-finish))",[[0,[2,"pretty-finish"]],[14,[" (method of ",[0,[2,"editor-stream-out%"]],")"]]],["racket/gui/base","racket/gui"]],
["pretty-format",">reference/pretty-print.html#(def._((lib._racket/pretty..rkt)._pretty-format))",[0,[2,"pretty-format"]],["racket/pretty","racket"]],
["pretty-format/display",">unstable/Pretty-Printing.html#(def._((lib._unstable/pretty..rkt)._pretty-format/display))",[0,[2,"pretty-format/display"]],["unstable/pretty"]],
["pretty-format/print",">unstable/Pretty-Printing.html#(def._((lib._unstable/pretty..rkt)._pretty-format/print))",[0,[2,"pretty-format/print"]],["unstable/pretty"]],
["pretty-format/write",">unstable/Pretty-Printing.html#(def._((lib._unstable/pretty..rkt)._pretty-format/write))",[0,[2,"pretty-format/write"]],["unstable/pretty"]],
["pretty-print",">reference/pretty-print.html#(def._((lib._racket/pretty..rkt)._pretty-print))",[0,[2,"pretty-print"]],["racket/pretty","racket"]],
["pretty-print",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._pretty-print))",[0,[2,"pretty-print"]],["lang/htdp-advanced"]],
["pretty-print",">scheme/scheme_pretty.html#(def._((lib._scheme/pretty..rkt)._pretty-print))",[0,[2,"pretty-print"]],["scheme/pretty"]],
["pretty-print-.-symbol-without-bars",">reference/pretty-print.html#(def._((lib._racket/pretty..rkt)._pretty-print-..-symbol-without-bars))",[0,[2,"pretty-print-.-symbol-without-bars"]],["racket/pretty","racket"]],
["pretty-print-abbreviate-read-macros",">reference/pretty-print.html#(def._((lib._racket/pretty..rkt)._pretty-print-abbreviate-read-macros))",[0,[2,"pretty-print-abbreviate-read-macros"]],["racket/pretty","racket"]],
["pretty-print-columns",">reference/pretty-print.html#(def._((lib._racket/pretty..rkt)._pretty-print-columns))",[0,[2,"pretty-print-columns"]],["racket/pretty","racket"]],
["pretty-print-current-style-table",">reference/pretty-print.html#(def._((lib._racket/pretty..rkt)._pretty-print-current-style-table))",[0,[2,"pretty-print-current-style-table"]],["racket/pretty","racket"]],
["pretty-print-depth",">reference/pretty-print.html#(def._((lib._racket/pretty..rkt)._pretty-print-depth))",[0,[2,"pretty-print-depth"]],["racket/pretty","racket"]],
["pretty-print-exact-as-decimal",">reference/pretty-print.html#(def._((lib._racket/pretty..rkt)._pretty-print-exact-as-decimal))",[0,[2,"pretty-print-exact-as-decimal"]],["racket/pretty","racket"]],
["pretty-print-extend-style-table",">reference/pretty-print.html#(def._((lib._racket/pretty..rkt)._pretty-print-extend-style-table))",[0,[2,"pretty-print-extend-style-table"]],["racket/pretty","racket"]],
["pretty-print-handler",">reference/pretty-print.html#(def._((lib._racket/pretty..rkt)._pretty-print-handler))",[0,[2,"pretty-print-handler"]],["racket/pretty","racket"]],
["pretty-print-newline",">reference/pretty-print.html#(def._((lib._racket/pretty..rkt)._pretty-print-newline))",[0,[2,"pretty-print-newline"]],["racket/pretty","racket"]],
["pretty-print-parameters",">redex/The_Redex_Reference.html#(def._((lib._redex/gui..rkt)._pretty-print-parameters))",[0,[2,"pretty-print-parameters"]],["redex/gui","redex"]],
["pretty-print-post-print-hook",">reference/pretty-print.html#(def._((lib._racket/pretty..rkt)._pretty-print-post-print-hook))",[0,[2,"pretty-print-post-print-hook"]],["racket/pretty","racket"]],
["pretty-print-pre-print-hook",">reference/pretty-print.html#(def._((lib._racket/pretty..rkt)._pretty-print-pre-print-hook))",[0,[2,"pretty-print-pre-print-hook"]],["racket/pretty","racket"]],
["pretty-print-print-hook",">reference/pretty-print.html#(def._((lib._racket/pretty..rkt)._pretty-print-print-hook))",[0,[2,"pretty-print-print-hook"]],["racket/pretty","racket"]],
["pretty-print-print-line",">reference/pretty-print.html#(def._((lib._racket/pretty..rkt)._pretty-print-print-line))",[0,[2,"pretty-print-print-line"]],["racket/pretty","racket"]],
["pretty-print-remap-stylable",">reference/pretty-print.html#(def._((lib._racket/pretty..rkt)._pretty-print-remap-stylable))",[0,[2,"pretty-print-remap-stylable"]],["racket/pretty","racket"]],
["pretty-print-show-inexactness",">reference/pretty-print.html#(def._((lib._racket/pretty..rkt)._pretty-print-show-inexactness))",[0,[2,"pretty-print-show-inexactness"]],["racket/pretty","racket"]],
["pretty-print-size-hook",">reference/pretty-print.html#(def._((lib._racket/pretty..rkt)._pretty-print-size-hook))",[0,[2,"pretty-print-size-hook"]],["racket/pretty","racket"]],
["pretty-print-style-table",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Pretty-.Print-.Style-.Table))",[0,[1,"Pretty-Print-Style-Table"]],["typed/racket/base","typed/racket"]],
["pretty-print-style-table?",">reference/pretty-print.html#(def._((lib._racket/pretty..rkt)._pretty-print-style-table~3f))",[0,[2,"pretty-print-style-table?"]],["racket/pretty","racket"]],
["pretty-printing",">unstable/Pretty-Printing.html","Pretty-Printing",false],
["pretty-printing",">reference/pretty-print.html#(def._((lib._racket/pretty..rkt)._pretty-printing))",[0,[2,"pretty-printing"]],["racket/pretty","racket"]],
["pretty-start",">gui/editor-stream-out_.html#(meth._(((lib._mred/main..rkt)._editor-stream-out~25)._pretty-start))",[[0,[2,"pretty-start"]],[14,[" (method of ",[0,[2,"editor-stream-out%"]],")"]]],["racket/gui/base","racket/gui"]],
["pretty-write",">reference/pretty-print.html#(def._((lib._racket/pretty..rkt)._pretty-write))",[0,[2,"pretty-write"]],["racket/pretty","racket"]],
["prev",">embedded-gui/dllist___.html#(meth._(((lib._embedded-gui/main..rkt)._dllist~3c~25~3e)._prev))",[[0,[2,"prev"]],[14,[" (method of ",[0,[2,"dllist<%>"]],")"]]],["embedded-gui"]],
["prev-tab",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aframe~3c~25~3e)._prev-tab))",[[0,[2,"prev-tab"]],[14,[" (method of ",[0,[2,"drracket:unit:frame<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["previous",">gui/snip_.html#(meth._(((lib._racket/snip..rkt)._snip~25)._previous))",[[0,[2,"previous"]],[14,[" (method of ",[0,[2,"snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["previous expression",">drracket/interactions-window.html#(idx._(gentag._25._(lib._scribblings/drracket/drracket..scrbl)))","previous expression",false],
["previous linkage",">planet/search-order.html#(part._.Previous_.Linkage)","Previous Linkage",false],
["primary partition",">macro-debugger/index.html#(part._.Primary_.Partition)","Primary Partition",false],
["primary slide functions",">slideshow/Primary_Slide_Functions.html","Primary Slide Functions",false],
["primary-file",">planet/Developing_Packages_for_PLaneT.html#(idx._(gentag._22._(lib._planet/planet..scrbl)))",[7,"'primary-file"],false],
["primitive operationen",">deinprogramm/advanced-prim-op.html","Primitive Operationen",false],
["primitive operationen",">deinprogramm/assignments-prim-op.html","Primitive Operationen",false],
["primitive operationen",">deinprogramm/beginner-prim-ops.html","Primitive Operationen",false],
["primitive operationen",">deinprogramm/vanilla-prim-op.html","Primitive Operationen",false],
["primitive string types",">foreign/String_Types.html#(part._.Primitive_.String_.Types)","Primitive String Types",false],
["primitive-closure?",">reference/procedures.html#(def._((quote._~23~25kernel)._primitive-closure~3f))",[0,[2,"primitive-closure?"]],["racket/base","racket"]],
["primitive-result-arity",">reference/procedures.html#(def._((quote._~23~25kernel)._primitive-result-arity))",[0,[2,"primitive-result-arity"]],["racket/base","racket"]],
["primitive?",">reference/procedures.html#(def._((quote._~23~25kernel)._primitive~3f))",[0,[2,"primitive?"]],["racket/base","racket"]],
["primitives",">frtime/index.html#(part._.Primitives)","Primitives",false],
["primitives in htdp beginner",">htdp/index.html#(part._.Primitives_in_.Ht.D.P_.Beginner)","Primitives in <span style=\"font-style: italic\">HtDP</span> Beginner",false],
["primval",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._primval))",[0,[2,"primval"]],["compiler/zo-structs"]],
["primval-id",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._primval-id))",[0,[2,"primval-id"]],["compiler/zo-structs"]],
["primval?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._primval~3f))",[0,[2,"primval?"]],["compiler/zo-structs"]],
["print",">planet/cmdline.html#(part._print)",[6,"print"],false],
["print",">reference/Writing.html#(def._((quote._~23~25kernel)._print))",[0,[2,"print"]],["racket/base","racket"]],
["print",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._print))",[[0,[2,"print"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["print",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._print))",[0,[2,"print"]],["lang/htdp-advanced"]],
["print",">lazy/index.html#(def._((lib._lazy/main..rkt)._print))",[0,[2,"print"]],["lazy"]],
["print",">gui/key-event_.html#(idx._(gentag._58._(lib._scribblings/gui/gui..scrbl)))",[7,"'print"],false],
["print definitions... menu item",">drracket/Menus.html#(idx._(gentag._67._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Print Definitions...</span> menu item",false],
["print handler",">reference/eval.html#(tech._print._handler)","<span style=\"font-style: italic\">print handler</span>",false],
["print interactions... menu item",">drracket/Menus.html#(idx._(gentag._68._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Print Interactions...</span> menu item",false],
["print output",">drracket/output-syntax.html#(idx._(gentag._52._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">print</span> output",false],
["print-as-expression",">reference/Writing.html#(def._((quote._~23~25kernel)._print-as-expression))",[0,[2,"print-as-expression"]],["racket/base","racket"]],
["print-boolean-long-form",">reference/Writing.html#(def._((quote._~23~25kernel)._print-boolean-long-form))",[0,[2,"print-boolean-long-form"]],["racket/base","racket"]],
["print-box",">reference/Writing.html#(def._((quote._~23~25kernel)._print-box))",[0,[2,"print-box"]],["racket/base","racket"]],
["print-convert",">mzlib/mzlib_pconvert.html#(def._((lib._mzlib/pconvert..rkt)._print-convert))",[0,[2,"print-convert"]],["mzlib/pconvert"]],
["print-convert-constructor-name",">mzlib/mzlib_pconvert-prop.html#(def._((lib._mzlib/pconvert-prop..rkt)._print-convert-constructor-name))",[0,[2,"print-convert-constructor-name"]],["mzlib/pconvert-prop"]],
["print-convert-expr",">mzlib/mzlib_pconvert.html#(def._((lib._mzlib/pconvert..rkt)._print-convert-expr))",[0,[2,"print-convert-expr"]],["mzlib/pconvert"]],
["print-convert-named-constructor?",">mzlib/mzlib_pconvert-prop.html#(def._((lib._mzlib/pconvert-prop..rkt)._print-convert-named-constructor~3f))",[0,[2,"print-convert-named-constructor?"]],["mzlib/pconvert-prop"]],
["print-converter-proc",">mzlib/mzlib_pconvert-prop.html#(def._((lib._mzlib/pconvert-prop..rkt)._print-converter-proc))",[0,[2,"print-converter-proc"]],["mzlib/pconvert-prop"]],
["print-converter?",">mzlib/mzlib_pconvert-prop.html#(def._((lib._mzlib/pconvert-prop..rkt)._print-converter~3f))",[0,[2,"print-converter?"]],["mzlib/pconvert-prop"]],
["print-cookie",">net/cookie.html#(def._((lib._net/cookie..rkt)._print-cookie))",[0,[2,"print-cookie"]],["net/cookie"]],
["print-error-trace",">errortrace/using-errortrace.html#(def._((lib._errortrace/errortrace-lib..rkt)._print-error-trace))",[0,[2,"print-error-trace"]],["errortrace"]],
["print-graph",">reference/Writing.html#(def._((quote._~23~25kernel)._print-graph))",[0,[2,"print-graph"]],["racket/base","racket"]],
["print-hash-table",">reference/Writing.html#(def._((quote._~23~25kernel)._print-hash-table))",[0,[2,"print-hash-table"]],["racket/base","racket"]],
["print-mpair-curly-braces",">reference/Writing.html#(def._((quote._~23~25kernel)._print-mpair-curly-braces))",[0,[2,"print-mpair-curly-braces"]],["racket/base","racket"]],
["print-only-errors",">plai/plai-scheme.html#(def._((lib._plai/main..rkt)._print-only-errors))",[0,[2,"print-only-errors"]],["plai"]],
["print-only-errors",">plai/mutator.html#(form._((lib._plai/mutator..rkt)._print-only-errors))",[0,[2,"print-only-errors"]],["plai/mutator"]],
["print-pair-curly-braces",">reference/Writing.html#(def._((quote._~23~25kernel)._print-pair-curly-braces))",[0,[2,"print-pair-curly-braces"]],["racket/base","racket"]],
["print-reader-abbreviations",">reference/Writing.html#(def._((quote._~23~25kernel)._print-reader-abbreviations))",[0,[2,"print-reader-abbreviations"]],["racket/base","racket"]],
["print-struct",">reference/Writing.html#(def._((quote._~23~25kernel)._print-struct))",[0,[2,"print-struct"]],["racket/base","racket"]],
["print-syntax-width",">reference/Writing.html#(def._((quote._~23~25kernel)._print-syntax-width))",[0,[2,"print-syntax-width"]],["racket/base","racket"]],
["print-to-dc",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._print-to-dc))",[[0,[2,"print-to-dc"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["print-unreadable",">reference/Writing.html#(def._((quote._~23~25kernel)._print-unreadable))",[0,[2,"print-unreadable"]],["racket/base","racket"]],
["print-vector-length",">reference/Writing.html#(def._((quote._~23~25kernel)._print-vector-length))",[0,[2,"print-vector-length"]],["racket/base","racket"]],
["printable/c",">reference/data-structure-contracts.html#(def._((lib._racket/contract/private/misc..rkt)._printable/c))",[0,[2,"printable/c"]],["racket/contract/base","racket/contract","racket"]],
["printable<%>",">reference/objectprinting.html#(def._((lib._racket/private/class-internal..rkt)._printable~3c~25~3e))",[0,[2,"printable<%>"]],["racket/class","racket"]],
["printable<%>",">scheme/scheme_class.html#(def._((lib._scheme/class..rkt)._printable~3c~25~3e))",[0,[2,"printable<%>"]],["scheme/class"]],
["printer extension",">reference/Printer_Extension.html","Printer Extension",false],
["printer-dc%",">gui/printer-dc_.html",[0,[2,"printer-dc%"]],["racket/gui/base","racket/gui"]],
["printf",">reference/Writing.html#(def._((quote._~23~25kernel)._printf))",[0,[2,"printf"]],["racket/base","racket"]],
["printf",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._printf))",[0,[2,"printf"]],["lang/htdp-advanced"]],
["printf",">lazy/index.html#(def._((lib._lazy/main..rkt)._printf))",[0,[2,"printf"]],["lazy"]],
["printf",">plai/mutator.html#(form._((lib._plai/mutator..rkt)._printf))",[0,[1,"printf"]],["plai/mutator"]],
["printf/f",">reference/distributed-places.html#(def._((lib._racket/place/distributed..rkt)._printf/f))",[0,[2,"printf/f"]],["racket/place/distributed"]],
["printing",">slideshow/Creating_Slide_Presentations.html#(part._.Printing)","Printing",false],
["printing booleans",">reference/printing.html#(part._print-booleans)","Printing Booleans",false],
["printing boxes",">reference/printing.html#(part._print-box)","Printing Boxes",false],
["printing characters",">reference/printing.html#(part._print-character)","Printing Characters",false],
["printing compiled code",">reference/printing.html#(part._print-compiled)","Printing Compiled Code",false],
["printing format",">drracket/output-syntax.html","printing format",false],
["printing hash tables",">reference/printing.html#(part._print-hashtable)","Printing Hash Tables",false],
["printing keywords",">reference/printing.html#(part._print-keyword)","Printing Keywords",false],
["printing numbers",">reference/printing.html#(part._print-number)","Printing Numbers",false],
["printing pairs and lists",">reference/printing.html#(part._print-pairs)","Printing Pairs and Lists",false],
["printing paths",">reference/printing.html#(part._print-path)","Printing Paths",false],
["printing regular expressions",">reference/printing.html#(part._print-regexp)","Printing Regular Expressions",false],
["printing strings",">reference/printing.html#(part._print-string)","Printing Strings",false],
["printing structures",">reference/printing.html#(part._print-structure)","Printing Structures",false],
["printing symbols",">reference/printing.html#(part._print-symbol)","Printing Symbols",false],
["printing unreadable values",">reference/printing.html#(part._print-unreadable)","Printing Unreadable Values",false],
["printing vectors",">reference/printing.html#(part._print-vectors)","Printing Vectors",false],
["printing?",">slideshow/Constants_and_Layout_Variables.html#(def._((lib._slideshow/base..rkt)._printing~3f))",[0,[2,"printing?"]],["slideshow/base","slideshow"]],
["println",">reference/Writing.html#(idx._(gentag._219._(lib._scribblings/reference/reference..scrbl)))",[6,"println"],false],
["prior",">gui/key-event_.html#(idx._(gentag._48._(lib._scribblings/gui/gui..scrbl)))",[7,"'prior"],false],
["private",">reference/createclass.html#(form._((lib._racket/private/class-internal..rkt)._private))",[0,[1,"private"]],["racket/class","racket"]],
["private*",">reference/createclass.html#(form._((lib._racket/private/class-internal..rkt)._private*))",[0,[1,"private*"]],["racket/class","racket"]],
["prn",">reference/windowspaths.html#(idx._(gentag._241._(lib._scribblings/reference/reference..scrbl)))",[6,"\"PRN\""],false],
["proc-doc",">scribble/srcdoc.html#(form._((lib._scribble/srcdoc..rkt)._proc-doc))",[0,[1,"proc-doc"]],["scribble/srcdoc"]],
["proc-doc/names",">scribble/srcdoc.html#(form._((lib._scribble/srcdoc..rkt)._proc-doc/names))",[0,[1,"proc-doc/names"]],["scribble/srcdoc"]],
["procedural splicing syntax classes",">syntax/Experimental.html#(part._.Procedural_.Splicing_.Syntax_.Classes)","Procedural Splicing Syntax Classes",false],
["procedure",">scribble/scribble_manual_code.html#(def._((lib._scribble/manual..rkt)._procedure))",[0,[2,"procedure"]],["scribble/manual"]],
["procedure",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Procedure))",[0,[1,"Procedure"]],["typed/racket/base","typed/racket"]],
["procedure applications and #%app",">reference/application.html",["Procedure Applications and ",[0,[1,"#%app"]]],false],
["procedure applications and local variables",">reference/eval-model.html#(part._.Procedure_.Applications_and_.Local_.Variables)","Procedure Applications and Local Variables",false],
["procedure expressions: lambda and case-lambda",">reference/lambda.html",["Procedure Expressions: ",[0,[1,"lambda"]]," and ",[0,[1,"case-lambda"]]],false],
["procedure invocation upon request",">web-server-internal/dispatch-pathprocedure.html","Procedure Invocation upon Request",false],
["procedure->method",">reference/procedures.html#(def._((lib._racket/private/base..rkt)._procedure-~3emethod))",[0,[2,"procedure->method"]],["racket/base","racket"]],
["procedure-arity",">reference/procedures.html#(def._((lib._racket/private/base..rkt)._procedure-arity))",[0,[2,"procedure-arity"]],["racket/base","racket"]],
["procedure-arity-includes/c",">reference/data-structure-contracts.html#(def._((lib._racket/contract/private/misc..rkt)._procedure-arity-includes/c))",[0,[2,"procedure-arity-includes/c"]],["racket/contract/base","racket/contract","racket"]],
["procedure-arity-includes?",">reference/procedures.html#(def._((quote._~23~25kernel)._procedure-arity-includes~3f))",[0,[2,"procedure-arity-includes?"]],["racket/base","racket"]],
["procedure-arity?",">reference/procedures.html#(def._((quote._~23~25kernel)._procedure-arity~3f))",[0,[2,"procedure-arity?"]],["racket/base","racket"]],
["procedure-extract-target",">reference/procedures.html#(def._((quote._~23~25kernel)._procedure-extract-target))",[0,[2,"procedure-extract-target"]],["racket/base","racket"]],
["procedure-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..rkt)._procedure-index-desc))",[0,[2,"procedure-index-desc"]],["scribble/manual-struct"]],
["procedure-index-desc?",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..rkt)._procedure-index-desc~3f))",[0,[2,"procedure-index-desc?"]],["scribble/manual-struct"]],
["procedure-keywords",">reference/procedures.html#(def._((lib._racket/private/base..rkt)._procedure-keywords))",[0,[2,"procedure-keywords"]],["racket/base","racket"]],
["procedure-reduce-arity",">reference/procedures.html#(def._((lib._racket/private/base..rkt)._procedure-reduce-arity))",[0,[2,"procedure-reduce-arity"]],["racket/base","racket"]],
["procedure-reduce-keyword-arity",">reference/procedures.html#(def._((lib._racket/private/base..rkt)._procedure-reduce-keyword-arity))",[0,[2,"procedure-reduce-keyword-arity"]],["racket/base","racket"]],
["procedure-rename",">reference/procedures.html#(def._((lib._racket/private/base..rkt)._procedure-rename))",[0,[2,"procedure-rename"]],["racket/base","racket"]],
["procedure-roots",">plai/collector.html#(def._((lib._plai/collector..rkt)._procedure-roots))",[0,[2,"procedure-roots"]],["plai/collector"]],
["procedure-struct-type?",">reference/procedures.html#(def._((quote._~23~25kernel)._procedure-struct-type~3f))",[0,[2,"procedure-struct-type?"]],["racket/base","racket"]],
["procedure?",">reference/procedures.html#(def._((quote._~23~25kernel)._procedure~3f))",[0,[2,"procedure?"]],["racket/base","racket"]],
["procedure?",">r5rs-std/r5rs-Z-H-9.html#%_idx_576",[0,[2,"procedure?"]],["r5rs"]],
["procedure?",">r6rs-std/r6rs-Z-H-14.html#node_idx_342",[0,[2,"procedure?"]],["rnrs/base-6"]],
["procedure?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._procedure~3f))",[0,[2,"procedure?"]],["lang/htdp-advanced"]],
["procedure?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._procedure~3f))",[0,[2,"procedure?"]],["lang/htdp-intermediate"]],
["procedure?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._procedure~3f))",[0,[2,"procedure?"]],["lang/htdp-intermediate-lambda"]],
["procedures",">inside/Procedures.html","Procedures",false],
["procedures",">reference/procedures.html","Procedures",false],
["proceedings-location",">scriblib/autobib.html#(def._((lib._scriblib/autobib..rkt)._proceedings-location))",[0,[2,"proceedings-location"]],["scriblib/autobib"]],
["process",">reference/subprocess.html#(def._((lib._racket/system..rkt)._process))",[0,[2,"process"]],["racket/system","racket"]],
["process*",">reference/subprocess.html#(def._((lib._racket/system..rkt)._process*))",[0,[2,"process*"]],["racket/system","racket"]],
["process*/ports",">reference/subprocess.html#(def._((lib._racket/system..rkt)._process*/ports))",[0,[2,"process*/ports"]],["racket/system","racket"]],
["process/ports",">reference/subprocess.html#(def._((lib._racket/system..rkt)._process/ports))",[0,[2,"process/ports"]],["racket/system","racket"]],
["processes",">reference/subprocess.html","Processes",false],
["processes",">reference/futures-visualizer.html#(tech._processe)","<span style=\"font-style: italic\">processes</span>",false],
["processor-count",">reference/futures.html#(def._((lib._racket/future..rkt)._processor-count))",[0,[2,"processor-count"]],["racket/future","racket"]],
["product",">htdp-langs/beginner.html#(idx._htdp-beginner._(gentag._1._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-beginner))","product",false],
["product",">htdp-langs/beginner-abbr.html#(idx._htdp-beginner-abbr._(gentag._16._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-beginner-abbr))","product",false],
["product-ec",">srfi-std/srfi-42.html#product-ec",[0,[1,"product-ec"]],["srfi/42"]],
["profile",">profile/index.html#(mod-path._profile)",[9,[0,"profile"]],"module"],
["profile",">profile/index.html#(form._((lib._profile/main..rkt)._profile))",[0,[1,"profile"]],["profile"]],
["profile",">profile/index.html#(def._((lib._profile/analyzer..rkt)._profile))",[0,[2,"profile"]],["profile/analyzer"]],
["profile renderers",">profile/index.html#(part._renderers)","Profile Renderers",false],
["profile-*-node",">profile/index.html#(def._((lib._profile/analyzer..rkt)._profile-*-node))",[0,[2,"profile-*-node"]],["profile/analyzer"]],
["profile-cpu-time",">profile/index.html#(def._((lib._profile/analyzer..rkt)._profile-cpu-time))",[0,[2,"profile-cpu-time"]],["profile/analyzer"]],
["profile-key",">errortrace/stacktrace.html#(sig-val._((lib._errortrace/stacktrace..rkt)._stacktrace-imports~5e._profile-key))",[0,[2,"profile-key"]],["errortrace/stacktrace"]],
["profile-nodes",">profile/index.html#(def._((lib._profile/analyzer..rkt)._profile-nodes))",[0,[2,"profile-nodes"]],["profile/analyzer"]],
["profile-paths-enabled",">errortrace/using-errortrace.html#(def._((lib._errortrace/errortrace-lib..rkt)._profile-paths-enabled))",[0,[2,"profile-paths-enabled"]],["errortrace"]],
["profile-sample-number",">profile/index.html#(def._((lib._profile/analyzer..rkt)._profile-sample-number))",[0,[2,"profile-sample-number"]],["profile/analyzer"]],
["profile-thread-times",">profile/index.html#(def._((lib._profile/analyzer..rkt)._profile-thread-times))",[0,[2,"profile-thread-times"]],["profile/analyzer"]],
["profile-thunk",">profile/index.html#(def._((lib._profile/main..rkt)._profile-thunk))",[0,[2,"profile-thunk"]],["profile"]],
["profile-total-time",">profile/index.html#(def._((lib._profile/analyzer..rkt)._profile-total-time))",[0,[2,"profile-total-time"]],["profile/analyzer"]],
["profile/analyzer",">profile/index.html#(mod-path._profile/analyzer)",[9,[0,"profile/analyzer"]],"module"],
["profile/render-graphviz",">profile/index.html#(mod-path._profile/render-graphviz)",[9,[0,"profile/render-graphviz"]],"module"],
["profile/render-text",">profile/index.html#(mod-path._profile/render-text)",[9,[0,"profile/render-text"]],"module"],
["profile/sampler",">profile/index.html#(mod-path._profile/sampler)",[9,[0,"profile/sampler"]],"module"],
["profile: statistical profiler",">profile/index.html","Profile: Statistical Profiler",false],
["profile?",">profile/index.html#(def._((lib._profile/analyzer..rkt)._profile~3f))",[0,[2,"profile?"]],["profile/analyzer"]],
["profiling",">drracket/prefs-explanation.html#(part._.Profiling)","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Profiling</span>",false],
["profiling-enabled",">errortrace/using-errortrace.html#(def._((lib._errortrace/errortrace-lib..rkt)._profiling-enabled))",[0,[2,"profiling-enabled"]],["errortrace"]],
["profiling-enabled",">errortrace/stacktrace.html#(sig-val._((lib._errortrace/stacktrace..rkt)._stacktrace-imports~5e._profiling-enabled))",[0,[2,"profiling-enabled"]],["errortrace/stacktrace"]],
["profiling-record-enabled",">errortrace/using-errortrace.html#(def._((lib._errortrace/errortrace-lib..rkt)._profiling-record-enabled))",[0,[2,"profiling-record-enabled"]],["errortrace"]],
["progid",">mysterx/methprop.html#(def._((lib._mysterx/main..rkt)._progid))",[0,[2,"progid"]],["mysterx"]],
["progid",">foreign/com.html#(tech._progid)","<span style=\"font-style: italic\">ProgID</span>",false],
["progid->clsid",">foreign/com-auto.html#(def._((lib._ffi/unsafe/com..rkt)._progid-~3eclsid))",[0,[2,"progid->clsid"]],["ffi/com"]],
["program",">srfi-std/srfi-7.html#program",[0,[1,"program"]],["srfi/7"]],
["program files",">drracket/drracket-files.html#(part._drracket-file-formats)","Program Files",false],
["program+command-name",">raco/command.html#(def._((lib._raco/command-name..rkt)._program+command-name))",[0,[2,"program+command-name"]],["raco/command-name"]],
["program-vicinity",">srfi-std/srfi-59.html#program-vicinity",[0,[2,"program-vicinity"]],["srfi/59"]],
["programmatically running tests and inspecting results",">rackunit/internals.html#(part._running)","Programmatically Running Tests and Inspecting Results",false],
["programmer-defined datatypes",">guide/define-struct.html","Programmer-Defined Datatypes",false],
["programming languages: application and interpretation",">plai/index.html","<span style=\"font-style: italic\">Programming Languages: Application and Interpretation</span>",false],
["progress-evt?",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._progress-evt~3f))",[0,[2,"progress-evt?"]],["racket/base","racket"]],
["progressive pict",">unstable/ppict.html#(tech._progressive._pict)","<span style=\"font-style: italic\">progressive pict</span>",false],
["progressive picts",">unstable/ppict.html#(part._ppicts)","Progressive Picts",false],
["progressive picts and slides",">unstable/ppict.html","Progressive Picts and Slides",false],
["progressive slides",">unstable/ppict.html#(part._pslide)","Progressive Slides",false],
["prohibited words",">htdp/index.html#(part._.Prohibited_.Words)","Prohibited Words",false],
["projection",">images/Spatial_Transformations.html#(form._((lib._images/flomap..rkt)._.Projection))",[0,[1,"Projection"]],["images/flomap"]],
["projection-mapping",">images/Spatial_Transformations.html#(def._((lib._images/flomap..rkt)._projection-mapping))",[0,[2,"projection-mapping"]],["images/flomap"]],
["projection-mapping-fun",">images/Spatial_Transformations.html#(def._((lib._images/flomap..rkt)._projection-mapping-fun))",[0,[2,"projection-mapping-fun"]],["images/flomap"]],
["projection-mapping-inv",">images/Spatial_Transformations.html#(def._((lib._images/flomap..rkt)._projection-mapping-inv))",[0,[2,"projection-mapping-inv"]],["images/flomap"]],
["projection-mapping?",">images/Spatial_Transformations.html#(def._((lib._images/flomap..rkt)._projection-mapping~3f))",[0,[2,"projection-mapping?"]],["images/flomap"]],
["prolog",">xml/index.html#(def._((lib._xml/main..rkt)._prolog))",[0,[2,"prolog"]],["xml"]],
["prolog-dtd",">xml/index.html#(def._((lib._xml/main..rkt)._prolog-dtd))",[0,[2,"prolog-dtd"]],["xml"]],
["prolog-misc",">xml/index.html#(def._((lib._xml/main..rkt)._prolog-misc))",[0,[2,"prolog-misc"]],["xml"]],
["prolog-misc2",">xml/index.html#(def._((lib._xml/main..rkt)._prolog-misc2))",[0,[2,"prolog-misc2"]],["xml"]],
["prolog?",">xml/index.html#(def._((lib._xml/main..rkt)._prolog~3f))",[0,[2,"prolog?"]],["xml"]],
["promise",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Promise))",[0,[1,"Promise"]],["typed/racket/base","typed/racket"]],
["promise",">reference/Delayed_Evaluation.html#(tech._promise)","<span style=\"font-style: italic\">promise</span>",false],
["promise-forced?",">reference/Delayed_Evaluation.html#(def._((lib._racket/promise..rkt)._promise-forced~3f))",[0,[2,"promise-forced?"]],["racket/promise","racket"]],
["promise-running?",">reference/Delayed_Evaluation.html#(def._((lib._racket/promise..rkt)._promise-running~3f))",[0,[2,"promise-running?"]],["racket/promise","racket"]],
["promise/c",">reference/data-structure-contracts.html#(form._((lib._racket/contract/private/misc..rkt)._promise/c))",[0,[1,"promise/c"]],["racket/contract/base","racket/contract","racket"]],
["promise?",">reference/Delayed_Evaluation.html#(def._((lib._racket/promise..rkt)._promise~3f))",[0,[2,"promise?"]],["racket/promise","racket"]],
["promise?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._promise~3f))",[0,[2,"promise?"]],["lang/htdp-advanced"]],
["promise?",">srfi/srfi-45.html#(def._((lib._srfi/45..rkt)._promise~3f))",[0,"promise?"],["srfi/45"]],
["prompt",">reference/cont.html#(form._((lib._racket/control..rkt)._prompt))",[0,[1,"prompt"]],["racket/control"]],
["prompt",">guide/prompt.html#(tech._prompt)","<span style=\"font-style: italic\">prompt</span>",false],
["prompt",">reference/eval-model.html#(tech._prompt)","<span style=\"font-style: italic\">prompt</span>",false],
["prompt read handler",">reference/eval.html#(tech._prompt._read._handler)","<span style=\"font-style: italic\">prompt read handler</span>",false],
["prompt tag",">guide/prompt.html#(tech._prompt._tag)","<span style=\"font-style: italic\">prompt tag</span>",false],
["prompt tag",">reference/eval-model.html#(tech._prompt._tag)","<span style=\"font-style: italic\">prompt tag</span>",false],
["prompt-at",">reference/cont.html#(form._((lib._racket/control..rkt)._prompt-at))",[0,[1,"prompt-at"]],["racket/control"]],
["prompt-tag",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Prompt-.Tag))",[0,[1,"Prompt-Tag"]],["typed/racket/base","typed/racket"]],
["prompt-tag/c",">reference/data-structure-contracts.html#(def._((lib._racket/contract/private/misc..rkt)._prompt-tag/c))",[0,[2,"prompt-tag/c"]],["racket/contract/base","racket/contract","racket"]],
["prompt0",">reference/cont.html#(form._((lib._racket/control..rkt)._prompt0))",[0,[1,"prompt0"]],["racket/control"]],
["prompt0-at",">reference/cont.html#(form._((lib._racket/control..rkt)._prompt0-at))",[0,[1,"prompt0-at"]],["racket/control"]],
["prompts and aborts",">guide/prompt.html","Prompts and Aborts",false],
["prompts, delimited continuations, and barriers",">reference/eval-model.html#(part._prompt-model)","Prompts, Delimited Continuations, and Barriers",false],
["prop:arity-string",">reference/procedures.html#(def._((quote._~23~25kernel)._prop~3aarity-string))",[0,[2,"prop:arity-string"]],["racket/base","racket"]],
["prop:chaperone-contract",">reference/Building_New_Contract_Combinators.html#(def._((lib._racket/contract/private/prop..rkt)._prop~3achaperone-contract))",[0,[2,"prop:chaperone-contract"]],["racket/contract/combinator","racket/contract","racket"]],
["prop:checked-procedure",">reference/procedures.html#(def._((quote._~23~25kernel)._prop~3achecked-procedure))",[0,[2,"prop:checked-procedure"]],["racket/base","racket"]],
["prop:contract",">reference/Building_New_Contract_Combinators.html#(def._((lib._racket/contract/private/prop..rkt)._prop~3acontract))",[0,[2,"prop:contract"]],["racket/contract/combinator","racket/contract","racket"]],
["prop:contracted",">reference/Building_New_Contract_Combinators.html#(def._((lib._racket/contract/private/guts..rkt)._prop~3acontracted))",[0,[2,"prop:contracted"]],["racket/contract/combinator","racket/contract","racket"]],
["prop:convertible",">file/convertible.html#(def._((lib._file/convertible..rkt)._prop~3aconvertible))",[0,[2,"prop:convertible"]],["file/convertible"]],
["prop:cpointer",">foreign/foreign_pointer-funcs.html#(def._((quote._~23~25foreign)._prop~3acpointer))",[0,[2,"prop:cpointer"]],["ffi/unsafe"]],
["prop:custom-print-quotable",">reference/Printer_Extension.html#(def._((quote._~23~25kernel)._prop~3acustom-print-quotable))",[0,[2,"prop:custom-print-quotable"]],["racket/base","racket"]],
["prop:custom-write",">reference/Printer_Extension.html#(def._((quote._~23~25kernel)._prop~3acustom-write))",[0,[2,"prop:custom-write"]],["racket/base","racket"]],
["prop:dict",">reference/dicts.html#(def._((lib._racket/dict..rkt)._prop~3adict))",[0,[2,"prop:dict"]],["racket/dict","racket"]],
["prop:dict/contract",">reference/dicts.html#(def._((lib._racket/dict..rkt)._prop~3adict/contract))",[0,[2,"prop:dict/contract"]],["racket/dict","racket"]],
["prop:equal+hash",">reference/booleans.html#(def._((quote._~23~25kernel)._prop~3aequal+hash))",[0,[2,"prop:equal+hash"]],["racket/base","racket"]],
["prop:evt",">reference/sync.html#(def._((quote._~23~25kernel)._prop~3aevt))",[0,[2,"prop:evt"]],["racket/base","racket"]],
["prop:exn:srclocs",">reference/exns.html#(def._((quote._~23~25kernel)._prop~3aexn~3asrclocs))",[0,[2,"prop:exn:srclocs"]],["racket/base","racket"]],
["prop:flat-contract",">reference/Building_New_Contract_Combinators.html#(def._((lib._racket/contract/private/prop..rkt)._prop~3aflat-contract))",[0,[2,"prop:flat-contract"]],["racket/contract/combinator","racket/contract","racket"]],
["prop:impersonator-of",">reference/chaperones.html#(def._((quote._~23~25kernel)._prop~3aimpersonator-of))",[0,[2,"prop:impersonator-of"]],["racket/base","racket"]],
["prop:input-port",">reference/portstructs.html#(def._((quote._~23~25kernel)._prop~3ainput-port))",[0,[2,"prop:input-port"]],["racket/base","racket"]],
["prop:legacy-match-expander",">reference/match.html#(def._((lib._racket/match..rkt)._prop~3alegacy-match-expander))",[0,[2,"prop:legacy-match-expander"]],["racket/match","racket"]],
["prop:liberal-define-context",">reference/stxtrans.html#(def._((quote._~23~25kernel)._prop~3aliberal-define-context))",[0,[2,"prop:liberal-define-context"]],["racket/base","racket"]],
["prop:match-expander",">reference/match.html#(def._((lib._racket/match..rkt)._prop~3amatch-expander))",[0,[2,"prop:match-expander"]],["racket/match","racket"]],
["prop:ordered-dict",">data/Orders_and_Ordered_Dictionaries.html#(def._((lib._data/order..rkt)._prop~3aordered-dict))",[0,[2,"prop:ordered-dict"]],["data/order"]],
["prop:output-port",">reference/portstructs.html#(def._((quote._~23~25kernel)._prop~3aoutput-port))",[0,[2,"prop:output-port"]],["racket/base","racket"]],
["prop:pict-convertible",">slideshow/Conversion_to_Picts.html#(def._((lib._slideshow/pict-convert..rkt)._prop~3apict-convertible))",[0,[2,"prop:pict-convertible"]],["slideshow/pict-convert"]],
["prop:pict-convertible?",">slideshow/Conversion_to_Picts.html#(def._((lib._slideshow/pict-convert..rkt)._prop~3apict-convertible~3f))",[0,[2,"prop:pict-convertible?"]],["slideshow/pict-convert"]],
["prop:print-convert-constructor-name",">mzlib/mzlib_pconvert-prop.html#(def._((lib._mzlib/pconvert-prop..rkt)._prop~3aprint-convert-constructor-name))",[0,[2,"prop:print-convert-constructor-name"]],["mzlib/pconvert-prop"]],
["prop:print-converter",">mzlib/mzlib_pconvert-prop.html#(def._((lib._mzlib/pconvert-prop..rkt)._prop~3aprint-converter))",[0,[2,"prop:print-converter"]],["mzlib/pconvert-prop"]],
["prop:procedure",">reference/procedures.html#(def._((lib._racket/private/base..rkt)._prop~3aprocedure))",[0,[2,"prop:procedure"]],["racket/base","racket"]],
["prop:procedure",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..rkt)._prop~3aprocedure))",[0,[2,"prop:procedure"]],["mzscheme"]],
["prop:provide-pre-transformer",">reference/stxtrans.html#(def._((lib._racket/provide-transform..rkt)._prop~3aprovide-pre-transformer))",[0,[2,"prop:provide-pre-transformer"]],["racket/provide-transform"]],
["prop:provide-transformer",">reference/stxtrans.html#(def._((lib._racket/provide-transform..rkt)._prop~3aprovide-transformer))",[0,[2,"prop:provide-transformer"]],["racket/provide-transform"]],
["prop:rename-transformer",">reference/stxtrans.html#(def._((quote._~23~25kernel)._prop~3arename-transformer))",[0,[2,"prop:rename-transformer"]],["racket/base","racket"]],
["prop:require-transformer",">reference/stxtrans.html#(def._((lib._racket/require-transform..rkt)._prop~3arequire-transformer))",[0,[2,"prop:require-transformer"]],["racket/require-transform"]],
["prop:sequence",">reference/sequences.html#(def._((lib._racket/private/base..rkt)._prop~3asequence))",[0,[2,"prop:sequence"]],["racket/base","racket"]],
["prop:serializable",">reference/serialization.html#(def._((lib._racket/private/serialize..rkt)._prop~3aserializable))",[0,[2,"prop:serializable"]],["racket/serialize"]],
["prop:set!-transformer",">reference/stxtrans.html#(def._((quote._~23~25kernel)._prop~3aset!-transformer))",[0,[2,"prop:set!-transformer"]],["racket/base","racket"]],
["prop:statement",">db/query-api.html#(def._((lib._db/base..rkt)._prop~3astatement))",[0,[2,"prop:statement"]],["db","db/base"]],
["prop:stream",">reference/streams.html#(def._((lib._racket/stream..rkt)._prop~3astream))",[0,[2,"prop:stream"]],["racket/stream","racket"]],
["prop:struct-auto-info",">reference/structinfo.html#(def._((lib._racket/struct-info..rkt)._prop~3astruct-auto-info))",[0,[2,"prop:struct-auto-info"]],["racket/struct-info"]],
["prop:struct-info",">reference/structinfo.html#(def._((lib._racket/struct-info..rkt)._prop~3astruct-info))",[0,[2,"prop:struct-info"]],["racket/struct-info"]],
["proper head pattern",">syntax/stxparse-patterns.html#(tech._proper._head._pattern)","<span style=\"font-style: italic\">proper head pattern</span>",false],
["proper single-term pattern",">syntax/stxparse-patterns.html#(tech._proper._single._term._pattern)","<span style=\"font-style: italic\">proper single-term pattern</span>",false],
["proper-list?",">srfi-std/srfi-1.html#proper-list-p",[0,[2,"proper-list?"]],["srfi/1"]],
["proper-subset?",">reference/sets.html#(def._((lib._racket/set..rkt)._proper-subset~3f))",[0,[2,"proper-subset?"]],["racket/set","racket"]],
["properties",">macro-debugger/index.html#(part._.Properties)","Properties",false],
["property",">deinprogramm/Signaturen.html#(form._((lib._deinprogramm/.D.Md.A..rkt)._property))",[0,[1,"property"]],["deinprogramm/DMdA-beginner"]],
["property",">guide/define-struct.html#(tech._property)","<span style=\"font-style: italic\">property</span>",false],
["property accessor",">reference/structprops.html#(tech._property._accessor)","<span style=\"font-style: italic\">property accessor</span>",false],
["property lists",">mzlib/mzlib_kw.html#(part._keyword-get)","Property Lists",false],
["property predicate",">reference/structprops.html#(tech._property._predicate)","<span style=\"font-style: italic\">property predicate</span>",false],
["prose and terminology",">scribble/reference-style.html#(part._.Prose_and_.Terminology)","Prose and Terminology",false],
["protect-out",">reference/require.html#(form._((lib._racket/private/base..rkt)._protect-out))",[0,[1,"protect-out"]],["racket/base","racket"]],
["protected",">reference/stxprops.html#(idx._(gentag._180._(lib._scribblings/reference/reference..scrbl)))",[7,"'protected"],false],
["protected",">guide/stx-certs.html#(tech._protected)","<span style=\"font-style: italic\">protected</span>",false],
["protected exports",">guide/stx-certs.html#(part._code-inspectors+protect)","Protected Exports",false],
["protected method",">guide/classes.html#(idx._(gentag._3._(lib._scribblings/guide/guide..scrbl)))","protected method",false],
["protecting graphics operations",">graphics/Protecting_Graphics_Operations.html","Protecting Graphics Operations",false],
["protocol",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_298",[0,[1,"protocol"]],["rnrs/records/syntactic-6"]],
["protocol-message",">web-server-internal/Web_Servers.html#(idx._(gentag._15._(lib._web-server/scribblings/web-server-internal..scrbl)))","protocol-message",false],
["provide",">reference/require.html#(form._((lib._racket/private/base..rkt)._provide))",[0,[1,"provide"]],["racket/base","racket"]],
["provide",">eopl/index.html#(form._((lib._eopl/eopl..rkt)._provide))",[0,[1,"provide"]],["eopl"]],
["provide",">mzscheme/Old_Syntactic_Forms.html#(form._((lib._mzscheme/main..rkt)._provide))",[0,[1,"provide"]],["mzscheme"]],
["provide macros",">reference/define.html#(part._provide-syntax)",[[0,[1,"provide"]]," Macros"],false],
["provide pre-transformer",">reference/stxtrans.html#(tech._provide._pre._transformer)","<span style=\"font-style: italic\">provide\npre-transformer</span>",false],
["provide transformer",">reference/stxtrans.html#(tech._provide._transformer)","<span style=\"font-style: italic\">provide transformer</span>",false],
["provide transformers",">reference/stxtrans.html#(part._provide-trans)",[[0,[1,"provide"]]," Transformers"],false],
["provide*",">scheme/scheme_foreign.html#(form._((lib._scheme/foreign..rkt)._provide*))",[0,[1,"provide*"]],["scheme/foreign"]],
["provide-and-document",">syntax/docprovide.html#(form._((lib._syntax/docprovide..rkt)._provide-and-document))",[0,[1,"provide-and-document"]],["syntax/docprovide"]],
["provide-extracted",">scribble/srcdoc.html#(form._((lib._scribble/extract..rkt)._provide-extracted))",[0,[1,"provide-extracted"]],["scribble/extract"]],
["provide-for-label",">mzscheme/Old_Syntactic_Forms.html#(form._((lib._mzscheme/main..rkt)._provide-for-label))",[0,[1,"provide-for-label"]],["mzscheme"]],
["provide-for-syntax",">mzscheme/Old_Syntactic_Forms.html#(form._((lib._mzscheme/main..rkt)._provide-for-syntax))",[0,[1,"provide-for-syntax"]],["mzscheme"]],
["provide-higher-order-primitive",">htdp/index.html#(form._((lib._lang/prim..rkt)._provide-higher-order-primitive))",[0,[1,"provide-higher-order-primitive"]],["lang/prim"]],
["provide-pre-transformer?",">reference/stxtrans.html#(def._((lib._racket/provide-transform..rkt)._provide-pre-transformer~3f))",[0,[2,"provide-pre-transformer?"]],["racket/provide-transform"]],
["provide-primitive",">htdp/index.html#(form._((lib._lang/prim..rkt)._provide-primitive))",[0,[1,"provide-primitive"]],["lang/prim"]],
["provide-primitives",">htdp/index.html#(form._((lib._lang/prim..rkt)._provide-primitives))",[0,[1,"provide-primitives"]],["lang/prim"]],
["provide-protected",">foreign/Defining_Bindings.html#(form._((lib._ffi/unsafe/define..rkt)._provide-protected))",[0,[1,"provide-protected"]],["ffi/unsafe/define"]],
["provide-signature-elements",">reference/Unit_Utilities.html#(form._((lib._mzlib/unit..rkt)._provide-signature-elements))",[0,[1,"provide-signature-elements"]],["racket/unit","racket"]],
["provide-syntax-class/contract",">syntax/Experimental.html#(form._((lib._syntax/parse/experimental/provide..rkt)._provide-syntax-class/contract))",[0,[1,"provide-syntax-class/contract"]],["syntax/parse/experimental/provide"]],
["provide-transformer?",">reference/stxtrans.html#(def._((lib._racket/provide-transform..rkt)._provide-transformer~3f))",[0,[2,"provide-transformer?"]],["racket/provide-transform"]],
["provide/contract",">reference/attaching-contracts-to-values.html#(form._((lib._racket/contract/private/provide..rkt)._provide/contract))",[0,[1,"provide/contract"]],["racket/contract/base","racket/contract","racket"]],
["provide/doc",">scribble/srcdoc.html#(form._((lib._scribble/srcdoc..rkt)._provide/doc))",[0,[1,"provide/doc"]],["scribble/srcdoc"]],
["provide:",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._provide~3a))",[0,[1,"provide:"]],["typed/racket/base","typed/racket"]],
["provided",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._provided))",[0,[2,"provided"]],["compiler/zo-structs"]],
["provided bindings",">preprocessor/mzpp.html#(part._mzpp-lib)","Provided bindings",false],
["provided bindings",">preprocessor/mztext.html#(part._mztext-lib)","Provided bindings",false],
["provided transformations",">images/Spatial_Transformations.html#(part._.Provided_.Transformations)","Provided Transformations",false],
["provided-name",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._provided-name))",[0,[2,"provided-name"]],["compiler/zo-structs"]],
["provided-nom-src",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._provided-nom-src))",[0,[2,"provided-nom-src"]],["compiler/zo-structs"]],
["provided-protected?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._provided-protected~3f))",[0,[2,"provided-protected?"]],["compiler/zo-structs"]],
["provided-src",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._provided-src))",[0,[2,"provided-src"]],["compiler/zo-structs"]],
["provided-src-name",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._provided-src-name))",[0,[2,"provided-src-name"]],["compiler/zo-structs"]],
["provided-src-phase",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._provided-src-phase))",[0,[2,"provided-src-phase"]],["compiler/zo-structs"]],
["provided?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._provided~3f))",[0,[2,"provided?"]],["compiler/zo-structs"]],
["proxy design pattern",">reference/Surrogates.html#(tech._proxy._design._pattern)","<span style=\"font-style: italic\">proxy design pattern</span>",false],
["prozedur-signatur",">deinprogramm/Signaturen.html#(part._proc-signature)","Prozedur-Signatur",false],
["prozedurapplikation",">deinprogramm/application.html","Prozedurapplikation",false],
["prozeduren",">deinprogramm/turtle.html#(part._.Prozeduren)","Prozeduren",false],
["prozeduren mit akkumulatoren",">deinprogramm/Konstruktionsanleitungen_1_bis_10.html#(part._.Prozeduren_mit_.Akkumulatoren)","Prozeduren mit Akkumulatoren",false],
["ps",">reference/characters.html#(idx._(gentag._134._(lib._scribblings/reference/reference..scrbl)))",[7,"'ps"],false],
["ps-setup%",">draw/ps-setup_.html",[0,[2,"ps-setup%"]],["racket/draw"]],
["pseudo-random-generator",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Pseudo-.Random-.Generator))",[0,[1,"Pseudo-Random-Generator"]],["typed/racket/base","typed/racket"]],
["pseudo-random-generator->vector",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._pseudo-random-generator-~3evector))",[0,[2,"pseudo-random-generator->vector"]],["racket/base","racket"]],
["pseudo-random-generator-vector?",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._pseudo-random-generator-vector~3f))",[0,[2,"pseudo-random-generator-vector?"]],["racket/base","racket"]],
["pseudo-random-generator?",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._pseudo-random-generator~3f))",[0,[2,"pseudo-random-generator?"]],["racket/base","racket"]],
["pslide",">unstable/ppict.html#(form._((lib._unstable/gui/pslide..rkt)._pslide))",[0,[1,"pslide"]],["unstable/gui/pslide"]],
["pslide-base-pict",">unstable/ppict.html#(def._((lib._unstable/gui/pslide..rkt)._pslide-base-pict))",[0,[2,"pslide-base-pict"]],["unstable/gui/pslide"]],
["pslide-default-placer",">unstable/ppict.html#(def._((lib._unstable/gui/pslide..rkt)._pslide-default-placer))",[0,[2,"pslide-default-placer"]],["unstable/gui/pslide"]],
["ptr-add",">foreign/foreign_pointer-funcs.html#(def._((quote._~23~25foreign)._ptr-add))",[0,[2,"ptr-add"]],["ffi/unsafe"]],
["ptr-add!",">foreign/foreign_pointer-funcs.html#(def._((quote._~23~25foreign)._ptr-add!))",[0,[2,"ptr-add!"]],["ffi/unsafe"]],
["ptr-equal?",">foreign/foreign_pointer-funcs.html#(def._((quote._~23~25foreign)._ptr-equal~3f))",[0,[2,"ptr-equal?"]],["ffi/unsafe"]],
["ptr-offset",">foreign/foreign_pointer-funcs.html#(def._((quote._~23~25foreign)._ptr-offset))",[0,[2,"ptr-offset"]],["ffi/unsafe"]],
["ptr-ref",">foreign/foreign_pointer-funcs.html#(def._((quote._~23~25foreign)._ptr-ref))",[0,[2,"ptr-ref"]],["ffi/unsafe"]],
["ptr-set!",">foreign/foreign_pointer-funcs.html#(def._((quote._~23~25foreign)._ptr-set!))",[0,[2,"ptr-set!"]],["ffi/unsafe"]],
["public",">reference/createclass.html#(form._((lib._racket/private/class-internal..rkt)._public))",[0,[1,"public"]],["racket/class","racket"]],
["public*",">reference/createclass.html#(form._((lib._racket/private/class-internal..rkt)._public*))",[0,[1,"public*"]],["racket/class","racket"]],
["public-final",">reference/createclass.html#(form._((lib._racket/private/class-internal..rkt)._public-final))",[0,[1,"public-final"]],["racket/class","racket"]],
["public-final*",">reference/createclass.html#(form._((lib._racket/private/class-internal..rkt)._public-final*))",[0,[1,"public-final*"]],["racket/class","racket"]],
["pubment",">reference/createclass.html#(form._((lib._racket/private/class-internal..rkt)._pubment))",[0,[1,"pubment"]],["racket/class","racket"]],
["pubment*",">reference/createclass.html#(form._((lib._racket/private/class-internal..rkt)._pubment*))",[0,[1,"pubment*"]],["racket/class","racket"]],
["punctuation",">htdp/index.html#(part._.Punctuation)","Punctuation",false],
["punctuation",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex..rkt)._punctuation))",[0,[1,"punctuation"]],["parser-tools/lex"]],
["pure",">web-server/formlets.html#(def._((lib._web-server/formlets/lib..rkt)._pure))",[0,[2,"pure"]],["web-server/formlets/lib"]],
["pure port",">net/url.html#(tech._pure._port)","<span style=\"font-style: italic\">pure port</span>",false],
["purify-port",">net/url.html#(def._((lib._net/url..rkt)._purify-port))",[0,[2,"purify-port"]],["net/url"]],
["purple",">unstable/pict.html#(def._((lib._unstable/gui/pict..rkt)._purple))",[0,[2,"purple"]],["unstable/gui/pict"]],
["push-indentation",">preprocessor/mzpp.html#(def._((lib._preprocessor/mzpp..rkt)._push-indentation))",[0,[2,"push-indentation"]],["preprocessor/mzpp"]],
["put",">gui/editor-stream-out_.html#(meth._(((lib._mred/main..rkt)._editor-stream-out~25)._put))",[[0,[2,"put"]],[14,[" (method of ",[0,[2,"editor-stream-out%"]],")"]]],["racket/gui/base","racket/gui"]],
["put-bytevector",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_744",[0,[2,"put-bytevector"]],["rnrs/io/ports-6"]],
["put-char",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_748",[0,[2,"put-char"]],["rnrs/io/ports-6"]],
["put-datum",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_756",[0,[2,"put-datum"]],["rnrs/io/ports-6"]],
["put-dsn",">db/connect.html#(def._((lib._db/base..rkt)._put-dsn))",[0,[2,"put-dsn"]],["db","db/base"]],
["put-file",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._put-file))",[0,[2,"put-file"]],["racket/gui/base","racket/gui"]],
["put-file",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._put-file))",[[0,[2,"put-file"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["put-file",">framework/Editor.html#(meth._(((lib._framework/main..rkt)._editor~3abasic-mixin)._put-file))",[[0,[2,"put-file"]],[14,[" (method of ",[0,[2,"editor:basic-mixin"]],")"]]],["framework"]],
["put-file",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3ahost-text-mixin)._put-file))",[[0,[2,"put-file"]],[14,[" (method of ",[0,[2,"mode:host-text-mixin"]],")"]]],["framework"]],
["put-file",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3asurrogate-text~25)._put-file))",[[0,[2,"put-file"]],[14,[" (method of ",[0,[2,"mode:surrogate-text%"]],")"]]],["framework"]],
["put-file",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3abasic-mixin)._put-file))",[[0,[2,"put-file"]],[14,[" (method of ",[0,[2,"text:basic-mixin"]],")"]]],["framework"]],
["put-fixed",">gui/editor-stream-out_.html#(meth._(((lib._mred/main..rkt)._editor-stream-out~25)._put-fixed))",[[0,[2,"put-fixed"]],[14,[" (method of ",[0,[2,"editor-stream-out%"]],")"]]],["racket/gui/base","racket/gui"]],
["put-impure-port",">net/url.html#(def._((lib._net/url..rkt)._put-impure-port))",[0,[2,"put-impure-port"]],["net/url"]],
["put-input",">reference/Sandboxed_Evaluation.html#(def._((lib._racket/sandbox..rkt)._put-input))",[0,[2,"put-input"]],["racket/sandbox"]],
["put-pinhole",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._put-pinhole))",[0,[2,"put-pinhole"]],["2htdp/image"]],
["put-pinhole",">teachpack/image.html#(def._((lib._htdp/image..rkt)._put-pinhole))",[0,[2,"put-pinhole"]],["htdp/image"]],
["put-preferences",">reference/Filesystem.html#(def._((lib._racket/file..rkt)._put-preferences))",[0,[2,"put-preferences"]],["racket/file","racket"]],
["put-pure-port",">net/url.html#(def._((lib._net/url..rkt)._put-pure-port))",[0,[2,"put-pure-port"]],["net/url"]],
["put-string",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_750",[0,[2,"put-string"]],["rnrs/io/ports-6"]],
["put-u8",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_742",[0,[2,"put-u8"]],["rnrs/io/ports-6"]],
["put-unterminated",">gui/editor-stream-out_.html#(meth._(((lib._mred/main..rkt)._editor-stream-out~25)._put-unterminated))",[[0,[2,"put-unterminated"]],[14,[" (method of ",[0,[2,"editor-stream-out%"]],")"]]],["racket/gui/base","racket/gui"]],
["putenv",">reference/runtime.html#(def._((quote._~23~25kernel)._putenv))",[0,[2,"putenv"]],["racket/base","racket"]],
["putprop",">mzlib/mzlib_compat.html#(def._((lib._mzlib/compat..rkt)._putprop))",[0,[2,"putprop"]],["mzlib/compat"]],
["q",">html/index.html#(def._((lib._html/main..rkt)._q))",[0,[2,"q"]],["html"]],
["q?",">html/index.html#(def._((lib._html/main..rkt)._q~3f))",[0,[2,"q?"]],["html"]],
["qp-decode",">net/qp.html#(def._((lib._net/qp..rkt)._qp-decode))",[0,[2,"qp-decode"]],["net/qp"]],
["qp-decode-stream",">net/qp.html#(def._((lib._net/qp..rkt)._qp-decode-stream))",[0,[2,"qp-decode-stream"]],["net/qp"]],
["qp-encode",">net/qp.html#(def._((lib._net/qp..rkt)._qp-encode))",[0,[2,"qp-encode"]],["net/qp"]],
["qp-encode-stream",">net/qp.html#(def._((lib._net/qp..rkt)._qp-encode-stream))",[0,[2,"qp-encode-stream"]],["net/qp"]],
["qp-error",">net/qp.html#(def._((lib._net/qp..rkt)._qp-error))",[0,[2,"qp-error"]],["net/qp"]],
["qp-error?",">net/qp.html#(def._((lib._net/qp..rkt)._qp-error~3f))",[0,[2,"qp-error?"]],["net/qp"]],
["qp-wrong-input",">net/qp.html#(def._((lib._net/qp..rkt)._qp-wrong-input))",[0,[2,"qp-wrong-input"]],["net/qp"]],
["qp-wrong-input?",">net/qp.html#(def._((lib._net/qp..rkt)._qp-wrong-input~3f))",[0,[2,"qp-wrong-input?"]],["net/qp"]],
["qp-wrong-line-size",">net/qp.html#(def._((lib._net/qp..rkt)._qp-wrong-line-size))",[0,[2,"qp-wrong-line-size"]],["net/qp"]],
["qp-wrong-line-size?",">net/qp.html#(def._((lib._net/qp..rkt)._qp-wrong-line-size~3f))",[0,[2,"qp-wrong-line-size?"]],["net/qp"]],
["qp@",">net/qp.html#(def._((lib._net/qp-unit..rkt)._qp~40))",[0,[2,"qp@"]],["net/qp-unit"]],
["qp^",">net/qp.html#(form._((lib._net/qp-sig..rkt)._qp~5e))",[0,[1,"qp^"]],["net/qp-sig"]],
["quantifiers",">guide/regexp-quant.html","Quantifiers",false],
["quantifiers",">guide/regexp-quant.html#(tech._quantifier)","<span style=\"font-style: italic\">quantifiers</span>",false],
["quantifiziert",">deinprogramm/Eigenschaften.html#(tech._quantifiziert)","<span style=\"font-style: italic\">quantifiziert</span>",false],
["quantize",">file/gif.html#(def._((lib._file/gif..rkt)._quantize))",[0,[2,"quantize"]],["file/gif"]],
["quasi-read-style-printing",">mzlib/mzlib_pconvert.html#(def._((lib._mzlib/pconvert..rkt)._quasi-read-style-printing))",[0,[2,"quasi-read-style-printing"]],["mzlib/pconvert"]],
["quasidatum",">syntax/Datum_Pattern_Matching.html#(form._((lib._syntax/datum..rkt)._quasidatum))",[0,[1,"quasidatum"]],["syntax/datum"]],
["quasiquote",">reference/quasiquote.html#(form._((lib._racket/private/letstx-scheme..rkt)._quasiquote))",[0,[1,"quasiquote"]],["racket/base","racket"]],
["quasiquote",">r5rs-std/r5rs-Z-H-7.html#%_idx_154",[0,[1,"quasiquote"]],["r5rs"]],
["quasiquote",">r6rs-std/r6rs-Z-H-14.html#node_idx_768",[0,[1,"quasiquote"]],["rnrs/base-6"]],
["quasiquote",">htdp-langs/beginner-abbr.html#(form._((lib._lang/htdp-beginner-abbr..rkt)._quasiquote))",[0,[1,"quasiquote"]],["lang/htdp-beginner-abbr"]],
["quasiquote",">htdp-langs/intermediate.html#(form._((lib._lang/htdp-intermediate..rkt)._quasiquote))",[0,[1,"quasiquote"]],["lang/htdp-intermediate"]],
["quasiquote",">htdp-langs/intermediate-lam.html#(form._((lib._lang/htdp-intermediate-lambda..rkt)._quasiquote))",[0,[1,"quasiquote"]],["lang/htdp-intermediate-lambda"]],
["quasiquote output",">drracket/output-syntax.html#(idx._(gentag._50._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Quasiquote</span> output",false],
["quasiquoting: quasiquote and `",">guide/qq.html",["Quasiquoting: ",[0,[1,"quasiquote"]]," and ",[7,"`"]],false],
["quasiquoting: quasiquote, unquote, and unquote-splicing",">reference/quasiquote.html",["Quasiquoting: ",[0,[1,"quasiquote"]],", ",[0,[1,"unquote"]],", and ",[0,[1,"unquote-splicing"]]],false],
["quasisyntax",">reference/stx-patterns.html#(form._((lib._racket/private/qqstx..rkt)._quasisyntax))",[0,[1,"quasisyntax"]],["racket/base","racket"]],
["quasisyntax",">r6rs-lib-std/r6rs-lib-Z-H-13.html#node_idx_1154",[0,[1,"quasisyntax"]],["rnrs/syntax-case-6"]],
["quasisyntax/loc",">reference/stx-patterns.html#(form._((lib._racket/private/qqstx..rkt)._quasisyntax/loc))",[0,[1,"quasisyntax/loc"]],["racket/base","racket"]],
["queens: \"show-queen.ss\"",">teachpack/show-queen.html",["Queens: ",[6,"\"show-queen.ss\""],"<a name=\"(idx._(gentag._18._(lib._teachpack/teachpack..scrbl)))\"></a>"],false],
["queries",">db/query-api.html","Queries",false],
["query",">db/query-api.html#(def._((lib._db/base..rkt)._query))",[0,[2,"query"]],["db","db/base"]],
["query-exec",">db/query-api.html#(def._((lib._db/base..rkt)._query-exec))",[0,[2,"query-exec"]],["db","db/base"]],
["query-list",">db/query-api.html#(def._((lib._db/base..rkt)._query-list))",[0,[2,"query-list"]],["db","db/base"]],
["query-maybe-row",">db/query-api.html#(def._((lib._db/base..rkt)._query-maybe-row))",[0,[2,"query-maybe-row"]],["db","db/base"]],
["query-maybe-value",">db/query-api.html#(def._((lib._db/base..rkt)._query-maybe-value))",[0,[2,"query-maybe-value"]],["db","db/base"]],
["query-mouse-posn",">graphics/Mouse_Operations.html#(def._((lib._graphics/graphics..rkt)._query-mouse-posn))",[0,[2,"query-mouse-posn"]],["graphics/graphics"]],
["query-row",">db/query-api.html#(def._((lib._db/base..rkt)._query-row))",[0,[2,"query-row"]],["db","db/base"]],
["query-rows",">db/query-api.html#(def._((lib._db/base..rkt)._query-rows))",[0,[2,"query-rows"]],["db","db/base"]],
["query-value",">db/query-api.html#(def._((lib._db/base..rkt)._query-value))",[0,[2,"query-value"]],["db","db/base"]],
["querying and changing (other) mailboxes",">net/imap.html#(part._.Querying_and_.Changing__.Other__.Mailboxes)","Querying and Changing (Other) Mailboxes",false],
["queryinterface",">foreign/com-intf.html#(def._((lib._ffi/unsafe/com..rkt)._.Query.Interface))",[0,[2,"QueryInterface"]],["ffi/unsafe/com"]],
["queue->list",">data/Imperative_Queues.html#(def._((lib._data/queue..rkt)._queue-~3elist))",[0,[2,"queue->list"]],["data/queue"]],
["queue-callback",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._queue-callback))",[0,[2,"queue-callback"]],["racket/gui/base","racket/gui"]],
["queue-empty?",">data/Imperative_Queues.html#(def._((lib._data/queue..rkt)._queue-empty~3f))",[0,[2,"queue-empty?"]],["data/queue"]],
["queue-length",">data/Imperative_Queues.html#(def._((lib._data/queue..rkt)._queue-length))",[0,[2,"queue-length"]],["data/queue"]],
["queue-output",">tools/drracket_rep.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3arep~3atext~25)._queue-output))",[[0,[2,"queue-output"]],[14,[" (method of ",[0,[2,"drracket:rep:text%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["queue/c",">data/Imperative_Queues.html#(def._((lib._data/queue..rkt)._queue/c))",[0,[2,"queue/c"]],["data/queue"]],
["queue?",">data/Imperative_Queues.html#(def._((lib._data/queue..rkt)._queue~3f))",[0,[2,"queue?"]],["data/queue"]],
["quick instructions",">errortrace/quick-instructions.html","Quick Instructions",false],
["quick instructions",">trace/index.html#(part._quick-instructions)","Quick Instructions",false],
["quick start",">ts-guide/quick.html","Quick Start",false],
["quick start guide for rackunit",">rackunit/quick-start.html","Quick Start Guide for RackUnit",false],
["quick: an introduction to racket with pictures",">quick/index.html","Quick: An Introduction to Racket with Pictures",false],
["quicksort",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._quicksort))",[0,[2,"quicksort"]],["lang/htdp-advanced"]],
["quicksort",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._quicksort))",[0,[2,"quicksort"]],["lang/htdp-intermediate"]],
["quicksort",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._quicksort))",[0,[2,"quicksort"]],["lang/htdp-intermediate-lambda"]],
["quicksort",">mzlib/mzlib_list.html#(def._((lib._mzlib/list..rkt)._quicksort))",[0,[2,"quicksort"]],["mzlib/list"]],
["quotable",">reference/printing.html#(tech._quotable)","<span style=\"font-style: italic\">quotable</span>",false],
["quote",">reference/quote.html#(form._((quote._~23~25kernel)._quote))",[0,[1,"quote"]],["racket/base","racket"]],
["quote",">r5rs-std/r5rs-Z-H-7.html#%_idx_86",[0,[1,"quote"]],["r5rs"]],
["quote",">r6rs-std/r6rs-Z-H-14.html#node_idx_362",[0,[1,"quote"]],["rnrs/base-6"]],
["quote",">htdp-langs/beginner.html#(form._((lib._lang/htdp-beginner..rkt)._quote))",[0,[1,"quote"]],["lang/htdp-beginner"]],
["quote",">htdp-langs/beginner-abbr.html#(form._((lib._lang/htdp-beginner-abbr..rkt)._quote))",[0,[1,"quote"]],["lang/htdp-beginner-abbr"]],
["quote",">htdp-langs/intermediate.html#(form._((lib._lang/htdp-intermediate..rkt)._quote))",[0,[1,"quote"]],["lang/htdp-intermediate"]],
["quote",">htdp-langs/intermediate-lam.html#(form._((lib._lang/htdp-intermediate-lambda..rkt)._quote))",[0,[1,"quote"]],["lang/htdp-intermediate-lambda"]],
["quote",">deinprogramm/advanced-quote.html#(form._((lib._deinprogramm/.D.Md.A-advanced..rkt)._quote))",[0,"quote"],["deinprogramm/DMdA-advanced"]],
["quote",">plai/mutator.html#(form._((lib._plai/mutator..rkt)._quote))",[0,[1,"quote"]],["plai/mutator"]],
["quote-character-position",">syntax/Source_Locations.html#(form._((lib._syntax/location..rkt)._quote-character-position))",[0,[1,"quote-character-position"]],["syntax/location"]],
["quote-character-span",">syntax/Source_Locations.html#(form._((lib._syntax/location..rkt)._quote-character-span))",[0,[1,"quote-character-span"]],["syntax/location"]],
["quote-column-number",">syntax/Source_Locations.html#(form._((lib._syntax/location..rkt)._quote-column-number))",[0,[1,"quote-column-number"]],["syntax/location"]],
["quote-line-number",">syntax/Source_Locations.html#(form._((lib._syntax/location..rkt)._quote-line-number))",[0,[1,"quote-line-number"]],["syntax/location"]],
["quote-literal",">deinprogramm/advanced-quote.html","Quote-Literal",false],
["quote-module-name",">syntax/Source_Locations.html#(form._((lib._syntax/location..rkt)._quote-module-name))",[0,[1,"quote-module-name"]],["syntax/location"]],
["quote-module-path",">syntax/Source_Locations.html#(form._((lib._syntax/location..rkt)._quote-module-path))",[0,[1,"quote-module-path"]],["syntax/location"]],
["quote-source-file",">syntax/Source_Locations.html#(form._((lib._syntax/location..rkt)._quote-source-file))",[0,[1,"quote-source-file"]],["syntax/location"]],
["quote-srcloc",">syntax/Source_Locations.html#(form._((lib._syntax/location..rkt)._quote-srcloc))",[0,[1,"quote-srcloc"]],["syntax/location"]],
["quote-syntax",">reference/Syntax_Quoting__quote-syntax.html#(form._((quote._~23~25kernel)._quote-syntax))",[0,[1,"quote-syntax"]],["racket/base","racket"]],
["quote-syntax/keep-srcloc",">syntax/Preserving_Source_Locations.html#(form._((lib._syntax/quote..rkt)._quote-syntax/keep-srcloc))",[0,[1,"quote-syntax/keep-srcloc"]],["syntax/quote"]],
["quote-syntax/prune",">reference/stx-patterns.html#(form._((lib._racket/private/stxcase-scheme..rkt)._quote-syntax/prune))",[0,[1,"quote-syntax/prune"]],["racket/base","racket"]],
["quoted-printable unit",">net/qp.html#(part._.Quoted-.Printable_.Unit)","Quoted-Printable Unit",false],
["quoted-printable: encoding and decoding",">net/qp.html","Quoted-Printable: Encoding and Decoding",false],
["quotient",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._quotient))",[0,[2,"quotient"]],["racket/base","racket"]],
["quotient",">r5rs-std/r5rs-Z-H-9.html#%_idx_300",[0,[2,"quotient"]],["r5rs"]],
["quotient",">r6rs-lib-std/r6rs-lib-Z-H-20.html#node_idx_1290",[0,[2,"quotient"]],["rnrs/r5rs-6"]],
["quotient",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._quotient))",[0,[2,"quotient"]],["lang/htdp-advanced"]],
["quotient",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._quotient))",[0,[2,"quotient"]],["lang/htdp-beginner"]],
["quotient",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._quotient))",[0,[2,"quotient"]],["lang/htdp-beginner-abbr"]],
["quotient",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._quotient))",[0,[2,"quotient"]],["lang/htdp-intermediate"]],
["quotient",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._quotient))",[0,[2,"quotient"]],["lang/htdp-intermediate-lambda"]],
["quotient",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._quotient))",[0,[2,"quotient"]],["deinprogramm/DMdA-advanced"]],
["quotient",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._quotient))",[0,[2,"quotient"]],["deinprogramm/DMdA-assignments"]],
["quotient",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._quotient))",[0,[2,"quotient"]],["deinprogramm/DMdA-beginner"]],
["quotient",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._quotient))",[0,[2,"quotient"]],["deinprogramm/DMdA-vanilla"]],
["quotient/remainder",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._quotient/remainder))",[0,[2,"quotient/remainder"]],["racket/base","racket"]],
["quoting",">syntax/Source_Locations.html#(part._location)","Quoting",false],
["quoting depth",">reference/printing.html#(tech._quoting._depth)","<span style=\"font-style: italic\">quoting\ndepth</span>",false],
["quoting pairs and symbols with quote",">guide/Pairs__Lists__and_Racket_Syntax.html#(part._quoting-lists)",["Quoting Pairs and Symbols with ",[0,[1,"quote"]]],false],
["quoting: quote and '",">guide/quote.html",["Quoting: ",[0,[1,"quote"]]," and ",[7,"'"]],false],
["r5rs",">guide/standards.html#(part._r5rs)","R<span style=\"vertical-align: super; font-size: 80%\">5</span>RS",false],
["r5rs",">r5rs/r5rs-mod.html",[9,[0,"r5rs"]],"module"],
["r5rs initialization library",">r5rs/r5rs_init-mod.html","R<span style=\"vertical-align: super; font-size: 80%\">5</span>RS Initialization Library",false],
["r5rs language",">drracket/legacy.html#(idx._(gentag._40._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">R5RS</span> language",false],
["r5rs module language",">r5rs/r5rs-mod.html","R<span style=\"vertical-align: super; font-size: 80%\">5</span>RS Module Language",false],
["r5rs/init",">r5rs/r5rs_init-mod.html",[9,[0,"r5rs/init"]],"module"],
["r5rs: legacy scheme",">r5rs/index.html","R5RS: Legacy Scheme",false],
["r6rs",">guide/standards.html#(part._.R6.R.S)","R<span style=\"vertical-align: super; font-size: 80%\">6</span>RS",false],
["r6rs",">r6rs/r6rs-mod.html",[9,[0,"r6rs"]],"module"],
["r6rs conformance",">r6rs/conformance.html","R<span style=\"vertical-align: super; font-size: 80%\">6</span>RS Conformance",false],
["r6rs libraries",">r6rs/R6RS_Libraries.html","R<span style=\"vertical-align: super; font-size: 80%\">6</span>RS Libraries",false],
["r6rs module language",">r6rs/r6rs-mod.html","R<span style=\"vertical-align: super; font-size: 80%\">6</span>RS Module Language",false],
["r6rs: scheme",">r6rs/index.html","R6RS: Scheme",false],
["racket",">drracket/Menus.html#(part._menu~3aracket)","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Racket</span>",false],
["racket",">framework/Racket.html","Racket",false],
["racket",">scribble/scheme.html","Racket",false],
["racket",">reference/index.html",[9,[0,"racket"]],"module"],
["racket",">scribble/scribble_manual_code.html#(form._((lib._scribble/manual..rkt)._.R.A.C.K.E.T))",[0,[1,"RACKET"]],["scribble/manual"]],
["racket",">scribble/scribble_manual_code.html#(form._((lib._scribble/manual..rkt)._racket))",[0,[1,"racket"]],["scribble/manual"]],
["racket",">drracket/drracket-files.html#(idx._(gentag._376._(lib._scribblings/drracket/drracket..scrbl)))",[6,"\"Racket\""],false],
["racket",">reference/running-sa.html#(idx._(gentag._342._(lib._scribblings/reference/reference..scrbl)))",[6,"racket"],false],
["racket and places",">inside/overview.html#(part._places)","Racket and Places",false],
["racket and threads",">inside/overview.html#(part._.Racket_and_.Threads)","Racket and Threads",false],
["racket code",">scribble/scribble_manual_code.html#(part._racket-code)","Racket Code",false],
["racket essentials",">guide/to-scheme.html","Racket Essentials",false],
["racket expression escapes",">scribble/reader.html#(part._.Racket_.Expression_.Escapes)","Racket Expression Escapes",false],
["racket interoperability",">datalog/interop.html","Racket Interoperability",false],
["racket manual format",">scribble/Racket_Manual_Format.html","Racket Manual Format",false],
["racket mode",">tools/Editor_Modes.html#(idx._(gentag._28._(lib._scribblings/tools/tools..scrbl)))","racket mode",false],
["racket predicates",">racklog/glossary.html#(part._.Racket_.Predicates)","Racket Predicates",false],
["racket typesetting and hyperlinks",">scribble/how-to-doc.html#(part._racket-hyperlinks)","Racket Typesetting and Hyperlinks",false],
["racket, unicode, characters, and strings",">inside/overview.html#(part._im~3aunicode)","Racket, Unicode, Characters, and Strings",false],
["racket-editor%",">gui/WXME_Decoding.html#(def._((lib._wxme/scheme..rkt)._racket-editor~25))",[0,"racket-editor%"],["wxme/scheme"]],
["racket-launcher-add-suffix",">raco/exe.html#(def._((lib._launcher/launcher..rkt)._racket-launcher-add-suffix))",[0,[2,"racket-launcher-add-suffix"]],["launcher/launcher"]],
["racket-launcher-is-actually-directory?",">raco/exe.html#(def._((lib._launcher/launcher..rkt)._racket-launcher-is-actually-directory~3f))",[0,[2,"racket-launcher-is-actually-directory?"]],["launcher/launcher"]],
["racket-launcher-is-directory?",">raco/exe.html#(def._((lib._launcher/launcher..rkt)._racket-launcher-is-directory~3f))",[0,[2,"racket-launcher-is-directory?"]],["launcher/launcher"]],
["racket-launcher-put-file-extension+style+filters",">raco/exe.html#(def._((lib._launcher/launcher..rkt)._racket-launcher-put-file-extension+style+filters))",[0,[2,"racket-launcher-put-file-extension+style+filters"]],["launcher/launcher"]],
["racket-launcher-up-to-date?",">raco/exe.html#(def._((lib._launcher/launcher..rkt)._racket-launcher-up-to-date~3f))",[0,[2,"racket-launcher-up-to-date?"]],["launcher/launcher"]],
["racket-path",">reference/distributed-places.html#(def._((lib._racket/place/distributed..rkt)._racket-path))",[0,[2,"racket-path"]],["racket/place/distributed"]],
["racket-prefs.rktd",">drracket/drracket-files.html#(idx._(gentag._374._(lib._scribblings/drracket/drracket..scrbl)))",[6,"\"racket-prefs.rktd\""],false],
["racket-prefs.rktd",">drracket/drracket-files.html#(idx._(gentag._375._(lib._scribblings/drracket/drracket..scrbl)))",[6,"\"racket-prefs.rktd\""],false],
["racket-prefs.rktd",">drracket/drracket-files.html#(idx._(gentag._382._(lib._scribblings/drracket/drracket..scrbl)))",[6,"\"racket-prefs.rktd\""],false],
["racket-program-launcher-path",">raco/exe.html#(def._((lib._launcher/launcher..rkt)._racket-program-launcher-path))",[0,[2,"racket-program-launcher-path"]],["launcher/launcher"]],
["racket-style opengl",">sgl/main.html","Racket-Style OpenGL",false],
["racket.exe",">reference/running-sa.html#(idx._(gentag._343._(lib._scribblings/reference/reference..scrbl)))",[6,"Racket.exe"],false],
["racket/async-channel",">reference/async-channel.html",[9,[0,"racket/async-channel"]],"module"],
["racket/base",">reference/index.html",[9,[0,"racket/base"]],"module"],
["racket/base-const-list",">slideshow/Typesetting_Racket_Code.html#(def._((lib._slideshow/code..rkt)._racket/base-const-list))",[0,[2,"racket/base-const-list"]],["slideshow/code"]],
["racket/block",">reference/block.html",[9,[0,"racket/block"]],"module"],
["racket/bool",">reference/booleans.html#(mod-path._racket/bool)",[9,[0,"racket/bool"]],"module"],
["racket/bytes",">reference/bytestrings.html#(mod-path._racket/bytes)",[9,[0,"racket/bytes"]],"module"],
["racket/class",">reference/mzlib_class.html",[9,[0,"racket/class"]],"module"],
["racket/cmdline",">reference/Command-Line_Parsing.html",[9,[0,"racket/cmdline"]],"module"],
["racket/contract",">reference/contracts.html",[9,[0,"racket/contract"]],"module"],
["racket/contract/base",">reference/racket_contract_base.html",[9,[0,"racket/contract/base"]],false],
["racket/contract/base",">reference/racket_contract_base.html",[9,[0,"racket/contract/base"]],"module"],
["racket/contract/combinator",">reference/Building_New_Contract_Combinators.html",[9,[0,"racket/contract/combinator"]],"module"],
["racket/contract/parametric",">reference/parametric-contracts.html",[9,[0,"racket/contract/parametric"]],"module"],
["racket/contract/region",">reference/attaching-contracts-to-values.html#(mod-path._racket/contract/region)",[9,[0,"racket/contract/region"]],"module"],
["racket/control",">reference/cont.html#(mod-path._racket/control)",[9,[0,"racket/control"]],"module"],
["racket/date",">reference/time.html#(mod-path._racket/date)",[9,[0,"racket/date"]],"module"],
["racket/dict",">reference/dicts.html",[9,[0,"racket/dict"]],"module"],
["racket/draw",">draw/index.html",[9,[0,"racket/draw"]],"module"],
["racket/draw/draw-sig",">draw/Signature_and_Unit.html#(mod-path._racket/draw/draw-sig)",[9,[0,"racket/draw/draw-sig"]],"module"],
["racket/draw/draw-unit",">draw/Signature_and_Unit.html#(mod-path._racket/draw/draw-unit)",[9,[0,"racket/draw/draw-unit"]],"module"],
["racket/draw/unsafe/brush",">draw/unsafe.html#(mod-path._racket/draw/unsafe/brush)",[9,[0,"racket/draw/unsafe/brush"]],"module"],
["racket/draw/unsafe/cairo-lib",">draw/unsafe.html#(mod-path._racket/draw/unsafe/cairo-lib)",[9,[0,"racket/draw/unsafe/cairo-lib"]],"module"],
["racket/enter",">reference/enter.html",[9,[0,"racket/enter"]],"module"],
["racket/exists",">guide/contracts-gotchas.html#(mod-path._racket/exists)",[9,[0,"racket/exists"]],"module"],
["racket/fasl",">reference/fasl.html",[9,[0,"racket/fasl"]],"module"],
["racket/file",">reference/Filesystem.html#(mod-path._racket/file)",[9,[0,"racket/file"]],"module"],
["racket/fixnum",">reference/fixnums.html",[9,[0,"racket/fixnum"]],"module"],
["racket/flonum",">reference/flonums.html",[9,[0,"racket/flonum"]],"module"],
["racket/function",">reference/procedures.html#(mod-path._racket/function)",[9,[0,"racket/function"]],"module"],
["racket/future",">reference/futures.html",[9,[0,"racket/future"]],"module"],
["racket/generator",">reference/Generators.html",[9,[0,"racket/generator"]],"module"],
["racket/generic",">reference/struct-generics.html",[9,[0,"racket/generic"]],"module"],
["racket/gui",">gui/index.html",[9,[0,"racket/gui"]],"module"],
["racket/gui/base",">gui/index.html",[9,[0,"racket/gui/base"]],"module"],
["racket/gui/dynamic",">gui/Dynamic_Loading.html",[9,[0,"racket/gui/dynamic"]],"module"],
["racket/gui/init",">reference/running-sa.html#(mod-path._racket/gui/init)",[9,[0,"racket/gui/init"]],"module"],
["racket/help",">reference/Interactive_Help.html",[9,[0,"racket/help"]],"module"],
["racket/include",">reference/include.html",[9,[0,"racket/include"]],"module"],
["racket/init",">reference/running-sa.html#(mod-path._racket/init)",[9,[0,"racket/init"]],"module"],
["racket/kernel",">reference/running-sa.html#(mod-path._racket/kernel)",[9,[0,"racket/kernel"]],"module"],
["racket/keyword-transform",">reference/stxtrans.html#(mod-path._racket/keyword-transform)",[9,[0,"racket/keyword-transform"]],"module"],
["racket/language-info",">reference/running-sa.html#(mod-path._racket/language-info)",[9,[0,"racket/language-info"]],"module"],
["racket/list",">reference/pairs.html#(mod-path._racket/list)",[9,[0,"racket/list"]],"module"],
["racket/load",">reference/load-lang.html",[9,[0,"racket/load"]],"module"],
["racket/local",">reference/local.html",[9,[0,"racket/local"]],"module"],
["racket/match",">reference/match.html",[9,[0,"racket/match"]],"module"],
["racket/math",">reference/generic-numbers.html#(mod-path._racket/math)",[9,[0,"racket/math"]],"module"],
["racket/mpair",">reference/mpairs.html#(mod-path._racket/mpair)",[9,[0,"racket/mpair"]],"module"],
["racket/package",">reference/package.html",[9,[0,"racket/package"]],"module"],
["racket/path",">reference/More_Path_Utilities.html",[9,[0,"racket/path"]],"module"],
["racket/performance-hint",">reference/performance-hint.html",[9,[0,"racket/performance-hint"]],"module"],
["racket/place",">reference/places.html",[9,[0,"racket/place"]],"module"],
["racket/place/define-remote-server",">reference/distributed-places.html#(mod-path._racket/place/define-remote-server)",[9,[0,"racket/place/define-remote-server"]],"module"],
["racket/place/distributed",">reference/distributed-places.html",[9,[0,"racket/place/distributed"]],"module"],
["racket/place/distributed/rmpi",">reference/distributed-places.html#(mod-path._racket/place/distributed/rmpi)",[9,[0,"racket/place/distributed/rmpi"]],"module"],
["racket/place/private/async-bi-channel",">reference/distributed-places.html#(mod-path._racket/place/private/async-bi-channel)",[9,[0,"racket/place/private/async-bi-channel"]],"module"],
["racket/port",">reference/port-lib.html",[9,[0,"racket/port"]],"module"],
["racket/pretty",">reference/pretty-print.html",[9,[0,"racket/pretty"]],"module"],
["racket/promise",">reference/Delayed_Evaluation.html",[9,[0,"racket/promise"]],"module"],
["racket/provide",">reference/require.html#(mod-path._racket/provide)",[9,[0,"racket/provide"]],"module"],
["racket/provide-syntax",">reference/define.html#(mod-path._racket/provide-syntax)",[9,[0,"racket/provide-syntax"]],"module"],
["racket/provide-transform",">reference/stxtrans.html#(mod-path._racket/provide-transform)",[9,[0,"racket/provide-transform"]],"module"],
["racket/require",">reference/require.html#(mod-path._racket/require)",[9,[0,"racket/require"]],"module"],
["racket/require-syntax",">reference/define.html#(mod-path._racket/require-syntax)",[9,[0,"racket/require-syntax"]],"module"],
["racket/require-transform",">reference/stxtrans.html#(mod-path._racket/require-transform)",[9,[0,"racket/require-transform"]],"module"],
["racket/runtime-config",">reference/running-sa.html#(mod-path._racket/runtime-config)",[9,[0,"racket/runtime-config"]],"module"],
["racket/runtime-path",">reference/Filesystem.html#(mod-path._racket/runtime-path)",[9,[0,"racket/runtime-path"]],"module"],
["racket/sandbox",">reference/Sandboxed_Evaluation.html",[9,[0,"racket/sandbox"]],"module"],
["racket/sequence",">reference/sequences.html#(mod-path._racket/sequence)",[9,[0,"racket/sequence"]],"module"],
["racket/serialize",">reference/serialization.html",[9,[0,"racket/serialize"]],"module"],
["racket/set",">reference/sets.html",[9,[0,"racket/set"]],"module"],
["racket/shared",">reference/shared.html",[9,[0,"racket/shared"]],"module"],
["racket/signature",">reference/Single-Signature_Modules.html",[9,[0,"racket/signature"]],"module"],
["racket/snip",">gui/Snip_and_Style_Classes.html",[9,[0,"racket/snip"]],"module"],
["racket/splicing",">reference/splicing.html",[9,[0,"racket/splicing"]],"module"],
["racket/stream",">reference/streams.html",[9,[0,"racket/stream"]],"module"],
["racket/string",">reference/strings.html#(mod-path._racket/string)",[9,[0,"racket/string"]],"module"],
["racket/struct-info",">reference/structinfo.html",[9,[0,"racket/struct-info"]],"module"],
["racket/stxparam",">reference/stxparam.html",[9,[0,"racket/stxparam"]],"module"],
["racket/stxparam-exptime",">reference/stxparam.html#(mod-path._racket/stxparam-exptime)",[9,[0,"racket/stxparam-exptime"]],"module"],
["racket/surrogate",">reference/Surrogates.html",[9,[0,"racket/surrogate"]],"module"],
["racket/syntax",">reference/syntax-util.html",[9,[0,"racket/syntax"]],"module"],
["racket/system",">reference/subprocess.html#(mod-path._racket/system)",[9,[0,"racket/system"]],"module"],
["racket/tcp",">reference/tcp.html",[9,[0,"racket/tcp"]],"module"],
["racket/trace",">reference/debugging.html#(mod-path._racket/trace)",[9,[0,"racket/trace"]],"module"],
["racket/trait",">reference/trait.html",[9,[0,"racket/trait"]],"module"],
["racket/udp",">reference/udp.html",[9,[0,"racket/udp"]],"module"],
["racket/unit",">reference/mzlib_unit.html",[9,[0,"racket/unit"]],"module"],
["racket/unit-exptime",">reference/Transformer_Helpers.html",[9,[0,"racket/unit-exptime"]],"module"],
["racket/unsafe/ops",">reference/unsafe.html",[9,[0,"racket/unsafe/ops"]],"module"],
["racket/vector",">reference/vectors.html#(mod-path._racket/vector)",[9,[0,"racket/vector"]],"module"],
["racket:add-coloring-preferences-panel",">framework/Racket.html#(def._((lib._framework/main..rkt)._racket~3aadd-coloring-preferences-panel))",[0,[2,"racket:add-coloring-preferences-panel"]],["framework"]],
["racket:add-preferences-panel",">framework/Racket.html#(def._((lib._framework/main..rkt)._racket~3aadd-preferences-panel))",[0,[2,"racket:add-preferences-panel"]],["framework"]],
["racket:get-color-prefs-table",">framework/Racket.html#(def._((lib._framework/main..rkt)._racket~3aget-color-prefs-table))",[0,[2,"racket:get-color-prefs-table"]],["framework"]],
["racket:get-keymap",">framework/Racket.html#(def._((lib._framework/main..rkt)._racket~3aget-keymap))",[0,[2,"racket:get-keymap"]],["framework"]],
["racket:get-white-on-black-color-prefs-table",">framework/Racket.html#(def._((lib._framework/main..rkt)._racket~3aget-white-on-black-color-prefs-table))",[0,[2,"racket:get-white-on-black-color-prefs-table"]],["framework"]],
["racket:get-wordbreak-map",">framework/Racket.html#(def._((lib._framework/main..rkt)._racket~3aget-wordbreak-map))",[0,[2,"racket:get-wordbreak-map"]],["framework"]],
["racket:init-wordbreak-map",">framework/Racket.html#(def._((lib._framework/main..rkt)._racket~3ainit-wordbreak-map))",[0,[2,"racket:init-wordbreak-map"]],["framework"]],
["racket:set-mode-mixin",">framework/Racket.html#(def._((lib._framework/main..rkt)._racket~3aset-mode-mixin))",[0,[2,"racket:set-mode-mixin"]],["framework"]],
["racket:setup-keymap",">framework/Racket.html#(def._((lib._framework/main..rkt)._racket~3asetup-keymap))",[0,[2,"racket:setup-keymap"]],["framework"]],
["racket:sexp-snip%",">framework/Racket.html#(def._((lib._framework/main..rkt)._racket~3asexp-snip~25))",[0,[2,"racket:sexp-snip%"]],["framework"]],
["racket:sexp-snip<%>",">framework/Racket.html#(def._((lib._framework/main..rkt)._racket~3asexp-snip~3c~25~3e))",[0,[2,"racket:sexp-snip<%>"]],["framework"]],
["racket:short-sym->pref-name",">framework/Racket.html#(def._((lib._framework/main..rkt)._racket~3ashort-sym-~3epref-name))",[0,[2,"racket:short-sym->pref-name"]],["framework"]],
["racket:short-sym->style-name",">framework/Racket.html#(def._((lib._framework/main..rkt)._racket~3ashort-sym-~3estyle-name))",[0,[2,"racket:short-sym->style-name"]],["framework"]],
["racket:text%",">framework/Racket.html#(def._((lib._framework/main..rkt)._racket~3atext~25))",[0,[2,"racket:text%"]],["framework"]],
["racket:text-balanced?",">framework/Racket.html#(def._((lib._framework/main..rkt)._racket~3atext-balanced~3f))",[0,[2,"racket:text-balanced?"]],["framework"]],
["racket:text-mixin",">framework/Racket.html#(def._((lib._framework/main..rkt)._racket~3atext-mixin))",[0,[2,"racket:text-mixin"]],["framework"]],
["racket:text-mode%",">framework/Racket.html#(def._((lib._framework/main..rkt)._racket~3atext-mode~25))",[0,[2,"racket:text-mode%"]],["framework"]],
["racket:text-mode-mixin",">framework/Racket.html#(def._((lib._framework/main..rkt)._racket~3atext-mode-mixin))",[0,[2,"racket:text-mode-mixin"]],["framework"]],
["racket:text-mode<%>",">framework/Racket.html#(def._((lib._framework/main..rkt)._racket~3atext-mode~3c~25~3e))",[0,[2,"racket:text-mode<%>"]],["framework"]],
["racket:text<%>",">framework/Racket.html#(def._((lib._framework/main..rkt)._racket~3atext~3c~25~3e))",[0,[2,"racket:text<%>"]],["framework"]],
["racketblock",">scribble/scribble_manual_code.html#(form._((lib._scribble/manual..rkt)._.R.A.C.K.E.T.B.L.O.C.K))",[0,[1,"RACKETBLOCK"]],["scribble/manual"]],
["racketblock",">scribble/scribble_manual_code.html#(form._((lib._scribble/manual..rkt)._racketblock))",[0,[1,"racketblock"]],["scribble/manual"]],
["racketblock+eval",">scribble/eval.html#(form._((lib._scribble/eval..rkt)._racketblock+eval))",[0,[1,"racketblock+eval"]],["scribble/eval"]],
["racketblock0",">scribble/scribble_manual_code.html#(form._((lib._scribble/manual..rkt)._.R.A.C.K.E.T.B.L.O.C.K0))",[0,[1,"RACKETBLOCK0"]],["scribble/manual"]],
["racketblock0",">scribble/scribble_manual_code.html#(form._((lib._scribble/manual..rkt)._racketblock0))",[0,[1,"racketblock0"]],["scribble/manual"]],
["racketblock0+eval",">scribble/eval.html#(form._((lib._scribble/eval..rkt)._racketblock0+eval))",[0,[1,"racketblock0+eval"]],["scribble/eval"]],
["racketcommentfont",">scribble/scribble_manual_code.html#(def._((lib._scribble/manual..rkt)._racketcommentfont))",[0,[2,"racketcommentfont"]],["scribble/manual"]],
["racketerror",">scribble/scribble_manual_code.html#(def._((lib._scribble/manual..rkt)._racketerror))",[0,[2,"racketerror"]],["scribble/manual"]],
["racketfont",">scribble/scribble_manual_code.html#(def._((lib._scribble/manual..rkt)._racketfont))",[0,[2,"racketfont"]],["scribble/manual"]],
["racketgrammar",">scribble/doc-forms.html#(form._((lib._scribble/manual..rkt)._racketgrammar))",[0,[1,"racketgrammar"]],["scribble/manual"]],
["racketgrammar*",">scribble/doc-forms.html#(form._((lib._scribble/manual..rkt)._racketgrammar*))",[0,[1,"racketgrammar*"]],["scribble/manual"]],
["racketid",">scribble/scribble_manual_code.html#(form._((lib._scribble/manual..rkt)._racketid))",[0,[1,"racketid"]],["scribble/manual"]],
["racketidfont",">scribble/scribble_manual_code.html#(def._((lib._scribble/manual..rkt)._racketidfont))",[0,[2,"racketidfont"]],["scribble/manual"]],
["racketinput",">scribble/scribble_manual_code.html#(form._((lib._scribble/manual..rkt)._.R.A.C.K.E.T.I.N.P.U.T))",[0,[1,"RACKETINPUT"]],["scribble/manual"]],
["racketinput",">scribble/scribble_manual_code.html#(form._((lib._scribble/manual..rkt)._racketinput))",[0,[1,"racketinput"]],["scribble/manual"]],
["racketinput0",">scribble/scribble_manual_code.html#(form._((lib._scribble/manual..rkt)._.R.A.C.K.E.T.I.N.P.U.T0))",[0,[1,"RACKETINPUT0"]],["scribble/manual"]],
["racketinput0",">scribble/scribble_manual_code.html#(form._((lib._scribble/manual..rkt)._racketinput0))",[0,[1,"racketinput0"]],["scribble/manual"]],
["racketkeywordfont",">scribble/scribble_manual_code.html#(def._((lib._scribble/manual..rkt)._racketkeywordfont))",[0,[2,"racketkeywordfont"]],["scribble/manual"]],
["racketlink",">scribble/section-links.html#(form._((lib._scribble/manual..rkt)._racketlink))",[0,[1,"racketlink"]],["scribble/manual"]],
["racketmetafont",">scribble/scribble_manual_code.html#(def._((lib._scribble/manual..rkt)._racketmetafont))",[0,[2,"racketmetafont"]],["scribble/manual"]],
["racketmod",">scribble/scribble_manual_code.html#(form._((lib._scribble/manual..rkt)._racketmod))",[0,[1,"racketmod"]],["scribble/manual"]],
["racketmod+eval",">scribble/eval.html#(form._((lib._scribble/eval..rkt)._racketmod+eval))",[0,[1,"racketmod+eval"]],["scribble/eval"]],
["racketmod/this-package",">planet/Utility_Libraries.html#(form._((lib._planet/scribble..rkt)._racketmod/this-package))",[0,[1,"racketmod/this-package"]],["planet/scribble"]],
["racketmod0",">scribble/scribble_manual_code.html#(form._((lib._scribble/manual..rkt)._racketmod0))",[0,[1,"racketmod0"]],["scribble/manual"]],
["racketmodfont",">scribble/scribble_manual_code.html#(def._((lib._scribble/manual..rkt)._racketmodfont))",[0,[2,"racketmodfont"]],["scribble/manual"]],
["racketmodlink",">scribble/scribble_manual_code.html#(form._((lib._scribble/manual..rkt)._racketmodlink))",[0,[1,"racketmodlink"]],["scribble/manual"]],
["racketmodlink/this-package",">planet/Utility_Libraries.html#(form._((lib._planet/scribble..rkt)._racketmodlink/this-package))",[0,[1,"racketmodlink/this-package"]],["planet/scribble"]],
["racketmodname",">scribble/scribble_manual_code.html#(form._((lib._scribble/manual..rkt)._racketmodname))",[0,[1,"racketmodname"]],["scribble/manual"]],
["racketmodname/this-package",">planet/Utility_Libraries.html#(form._((lib._planet/scribble..rkt)._racketmodname/this-package))",[0,[1,"racketmodname/this-package"]],["planet/scribble"]],
["racketoutput",">scribble/scribble_manual_code.html#(def._((lib._scribble/manual..rkt)._racketoutput))",[0,[2,"racketoutput"]],["scribble/manual"]],
["racketparenfont",">scribble/scribble_manual_code.html#(def._((lib._scribble/manual..rkt)._racketparenfont))",[0,[2,"racketparenfont"]],["scribble/manual"]],
["racketrc.rktl",">reference/Filesystem.html#(idx._(gentag._277._(lib._scribblings/reference/reference..scrbl)))",[6,"\"racketrc.rktl\""],false],
["racketresult",">scribble/scribble_manual_code.html#(form._((lib._scribble/manual..rkt)._racketresult))",[0,[1,"racketresult"]],["scribble/manual"]],
["racketresultblock",">scribble/scribble_manual_code.html#(form._((lib._scribble/manual..rkt)._.R.A.C.K.E.T.R.E.S.U.L.T.B.L.O.C.K))",[0,[1,"RACKETRESULTBLOCK"]],["scribble/manual"]],
["racketresultblock",">scribble/scribble_manual_code.html#(form._((lib._scribble/manual..rkt)._racketresultblock))",[0,[1,"racketresultblock"]],["scribble/manual"]],
["racketresultblock0",">scribble/scribble_manual_code.html#(form._((lib._scribble/manual..rkt)._.R.A.C.K.E.T.R.E.S.U.L.T.B.L.O.C.K0))",[0,[1,"RACKETRESULTBLOCK0"]],["scribble/manual"]],
["racketresultblock0",">scribble/scribble_manual_code.html#(form._((lib._scribble/manual..rkt)._racketresultblock0))",[0,[1,"racketresultblock0"]],["scribble/manual"]],
["racketresultfont",">scribble/scribble_manual_code.html#(def._((lib._scribble/manual..rkt)._racketresultfont))",[0,[2,"racketresultfont"]],["scribble/manual"]],
["racketvalfont",">scribble/scribble_manual_code.html#(def._((lib._scribble/manual..rkt)._racketvalfont))",[0,[2,"racketvalfont"]],["scribble/manual"]],
["racketvarfont",">scribble/scribble_manual_code.html#(def._((lib._scribble/manual..rkt)._racketvarfont))",[0,[2,"racketvarfont"]],["scribble/manual"]],
["racklog",">racklog/index.html",[9,[0,"racklog"]],"module"],
["racklog",">racklog/Racklog_Module_Language.html",[9,[0,"racklog"]],"module"],
["racklog module language",">racklog/Racklog_Module_Language.html","Racklog Module Language",false],
["racklog operators",">racklog/glossary.html#(part._.Racklog_.Operators)","Racklog Operators",false],
["racklog predicates",">racklog/glossary.html#(part._.Racklog_.Predicates)","Racklog Predicates",false],
["racklog variable manipulation",">racklog/glossary.html#(part._.Racklog_.Variable_.Manipulation)","Racklog Variable Manipulation",false],
["racklog variables",">racklog/glossary.html#(part._.Racklog_.Variables)","Racklog Variables",false],
["racklog: prolog-style logic programming",">racklog/index.html","Racklog: Prolog-Style Logic Programming",false],
["rackunit",">rackunit/api.html",[9,[0,"rackunit"]],"module"],
["rackunit api",">rackunit/api.html","RackUnit API",false],
["rackunit internals and extension api",">rackunit/internals.html","RackUnit Internals and Extension API",false],
["rackunit/docs-complete",">rackunit/Testing_Utilities.html#(mod-path._rackunit/docs-complete)",[9,[0,"rackunit/docs-complete"]],"module"],
["rackunit/gui",">rackunit/api.html#(mod-path._rackunit/gui)",[9,[0,"rackunit/gui"]],"module"],
["rackunit/text-ui",">rackunit/api.html#(mod-path._rackunit/text-ui)",[9,[0,"rackunit/text-ui"]],"module"],
["rackunit: unit testing",">rackunit/index.html","RackUnit: Unit Testing",false],
["raco ctool",">inside/overview.html#(idx._(gentag._5._(lib._scribblings/inside/inside..scrbl)))",[6,"raco ctool"],false],
["raco ctool: working with c code",">raco/ctool.html",[[6,"raco ctool"],": Working with C Code"],false],
["raco decompile: decompiling bytecode",">raco/decompile.html",[[6,"raco decompile"],": Decompiling Bytecode"],false],
["raco demod: demodularizing programs",">raco/demod.html",[[6,"raco demod"],": Demodularizing Programs"],false],
["raco distribute: sharing stand-alone executables",">raco/exe-dist.html",[[6,"raco distribute"],": Sharing Stand-Alone Executables"],false],
["raco exe: creating stand-alone executables",">raco/exe.html",[[6,"raco exe"],": Creating Stand-Alone Executables"],false],
["raco link: library collection links",">raco/link.html",[[6,"raco link"],": Library Collection Links"],false],
["raco make: compiling source to bytecode",">raco/make.html",[[6,"raco make"],": Compiling Source to Bytecode"],false],
["raco pack: packing library collections",">raco/plt.html",[[6,"raco pack"],": Packing Library Collections"],false],
["raco planet: automatic package distribution",">raco/planet.html",[[6,"raco planet"],": Automatic Package Distribution"],false],
["raco setup unit",">raco/setup-plt-plt.html#(part._raco_setup_.Unit)",[[6,"raco setup"]," Unit"],false],
["raco setup: installation management",">raco/setup.html",[[6,"raco setup"],": Installation Management"],false],
["raco test: run tests",">raco/test.html",[[6,"raco test"],": Run tests"],false],
["raco unpack: unpacking library collections",">raco/unpack.html",[[6,"raco unpack"],": Unpacking Library Collections"],false],
["raco-commands",">raco/command.html#(idx._(gentag._35._(lib._scribblings/raco/raco..scrbl)))",[0,"raco-commands"],false],
["raco/command-name",">raco/command.html#(mod-path._raco/command-name)",[9,[0,"raco/command-name"]],"module"],
["raco: racket command-line tools",">raco/index.html",[[6,"raco"],": Racket Command-Line Tools"],false],
["radial gradient",">draw/radial-gradient_.html#(tech._radial._gradient)","<span style=\"font-style: italic\">radial gradient</span>",false],
["radial-gradient%",">draw/radial-gradient_.html",[0,[2,"radial-gradient%"]],["racket/draw"]],
["radial-star",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._radial-star))",[0,[2,"radial-star"]],["2htdp/image"]],
["radial-turtles",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtle-examples..rkt)._radial-turtles))",[0,[2,"radial-turtles"]],["graphics/turtle-examples"]],
["radial-turtles",">turtles/Value_Turtles.html#(def._((lib._graphics/value-turtles-examples..rkt)._radial-turtles))",[0,"radial-turtles"],["graphics/value-turtles-examples"]],
["radians->degrees",">reference/generic-numbers.html#(def._((lib._racket/math..rkt)._radians-~3edegrees))",[0,[2,"radians->degrees"]],["racket/math","racket"]],
["radio",">web-server/formlets.html#(def._((lib._web-server/formlets/input..rkt)._radio))",[0,[2,"radio"]],["web-server/formlets/input"]],
["radio box",">gui/windowing-overview.html#(tech._radio._box)","<span style=\"font-style: italic\">radio box</span>",false],
["radio buttons",">gui/windowing-overview.html#(tech._radio._button)","<span style=\"font-style: italic\">radio buttons</span>",false],
["radio-box",">gui/radio-box_.html#(idx._(gentag._123._(lib._scribblings/gui/gui..scrbl)))",[7,"'radio-box"],false],
["radio-box%",">gui/radio-box_.html",[0,[2,"radio-box%"]],["racket/gui/base","racket/gui"]],
["radio-group",">web-server/formlets.html#(def._((lib._web-server/formlets/input..rkt)._radio-group))",[0,[2,"radio-group"]],["web-server/formlets/input"]],
["raise",">reference/exns.html#(def._((quote._~23~25kernel)._raise))",[0,[2,"raise"]],["racket/base","racket"]],
["raise",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._raise))",[[0,[2,"raise"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["raise",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_376",[0,[2,"raise"]],["rnrs/exceptions-6"]],
["raise",">srfi-std/srfi-34.html#raise",[0,[2,"raise"]],["srfi/34"]],
["raise-argument-error",">reference/exns.html#(def._((quote._~23~25kernel)._raise-argument-error))",[0,[2,"raise-argument-error"]],["racket/base","racket"]],
["raise-arguments-error",">reference/exns.html#(def._((quote._~23~25kernel)._raise-arguments-error))",[0,[2,"raise-arguments-error"]],["racket/base","racket"]],
["raise-arity-error",">reference/exns.html#(def._((lib._racket/private/base..rkt)._raise-arity-error))",[0,[2,"raise-arity-error"]],["racket/base","racket"]],
["raise-blame-error",">reference/Building_New_Contract_Combinators.html#(def._((lib._racket/contract/private/blame..rkt)._raise-blame-error))",[0,[2,"raise-blame-error"]],["racket/contract/combinator","racket/contract","racket"]],
["raise-continuable",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_378",[0,[2,"raise-continuable"]],["rnrs/exceptions-6"]],
["raise-contract-error",">reference/Legacy_Contracts.html#(def._((lib._racket/contract..rkt)._raise-contract-error))",[0,[2,"raise-contract-error"]],["racket/contract","racket"]],
["raise-mismatch-error",">reference/exns.html#(def._((quote._~23~25kernel)._raise-mismatch-error))",[0,[2,"raise-mismatch-error"]],["racket/base","racket"]],
["raise-range-error",">reference/exns.html#(def._((quote._~23~25kernel)._raise-range-error))",[0,[2,"raise-range-error"]],["racket/base","racket"]],
["raise-read-eof-error",">syntax/reader-helpers.html#(def._((lib._syntax/readerr..rkt)._raise-read-eof-error))",[0,[2,"raise-read-eof-error"]],["syntax/readerr"]],
["raise-read-error",">syntax/reader-helpers.html#(def._((lib._syntax/readerr..rkt)._raise-read-error))",[0,[2,"raise-read-error"]],["syntax/readerr"]],
["raise-result-error",">reference/exns.html#(def._((quote._~23~25kernel)._raise-result-error))",[0,[2,"raise-result-error"]],["racket/base","racket"]],
["raise-syntax-error",">reference/exns.html#(def._((quote._~23~25kernel)._raise-syntax-error))",[0,[2,"raise-syntax-error"]],["racket/base","racket"]],
["raise-type-error",">reference/exns.html#(def._((quote._~23~25kernel)._raise-type-error))",[0,[2,"raise-type-error"]],["racket/base","racket"]],
["raise-user-error",">reference/exns.html#(def._((quote._~23~25kernel)._raise-user-error))",[0,[2,"raise-user-error"]],["racket/base","racket"]],
["raising exceptions",">reference/exns.html#(part._errorproc)","Raising Exceptions",false],
["raising exn:fail:read",">syntax/reader-helpers.html#(part._readerr)",["Raising ",[0,[2,"exn:fail:read"]]],false],
["ramp-east",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._ramp-east))",[0,[2,"ramp-east"]],["2htdp/planetcute"]],
["ramp-north",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._ramp-north))",[0,[2,"ramp-north"]],["2htdp/planetcute"]],
["ramp-south",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._ramp-south))",[0,[2,"ramp-south"]],["2htdp/planetcute"]],
["ramp-west",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._ramp-west))",[0,[2,"ramp-west"]],["2htdp/planetcute"]],
["ramps",">teachpack/2htdpPlanet_Cute_Images.html#(part._pc~3a.Ramps)","Ramps",false],
["random",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._random))",[0,[2,"random"]],["racket/base","racket"]],
["random",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._random))",[0,[2,"random"]],["lang/htdp-advanced"]],
["random",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._random))",[0,[2,"random"]],["lang/htdp-beginner"]],
["random",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._random))",[0,[2,"random"]],["lang/htdp-beginner-abbr"]],
["random",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._random))",[0,[2,"random"]],["lang/htdp-intermediate"]],
["random",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._random))",[0,[2,"random"]],["lang/htdp-intermediate-lambda"]],
["random",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._random))",[0,[2,"random"]],["deinprogramm/DMdA-advanced"]],
["random",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._random))",[0,[2,"random"]],["deinprogramm/DMdA-assignments"]],
["random",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._random))",[0,[2,"random"]],["deinprogramm/DMdA-beginner"]],
["random",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._random))",[0,[2,"random"]],["deinprogramm/DMdA-vanilla"]],
["random generation",">reference/Random_generation.html","Random generation",false],
["random numbers",">reference/generic-numbers.html#(part._.Random_.Numbers)","Random Numbers",false],
["random testing",">redex/tutorial.html#(part._.Random_.Testing)","Random Testing",false],
["random-integer",">srfi-std/srfi-27.html#random-integer",[0,[2,"random-integer"]],["srfi/27"]],
["random-real",">srfi-std/srfi-27.html#random-real",[0,[2,"random-real"]],["srfi/27"]],
["random-seed",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._random-seed))",[0,[2,"random-seed"]],["racket/base","racket"]],
["random-source-make-integers",">srfi-std/srfi-27.html#random-source-make-integers",[0,[2,"random-source-make-integers"]],["srfi/27"]],
["random-source-make-reals",">srfi-std/srfi-27.html#random-source-make-reals",[0,[2,"random-source-make-reals"]],["srfi/27"]],
["random-source-pseudo-randomize!",">srfi-std/srfi-27.html#random-source-pseudo-randomize!",[0,[2,"random-source-pseudo-randomize!"]],["srfi/27"]],
["random-source-randomize!",">srfi-std/srfi-27.html#random-source-randomize!",[0,[2,"random-source-randomize!"]],["srfi/27"]],
["random-source-state-ref",">srfi-std/srfi-27.html#random-source-state-ref",[0,[2,"random-source-state-ref"]],["srfi/27"]],
["random-source-state-ref!",">srfi-std/srfi-27.html#random-source-state-ref",[0,[2,"random-source-state-ref!"]],["srfi/27"]],
["random-source?",">srfi-std/srfi-27.html#random-source-p",[0,[2,"random-source?"]],["srfi/27"]],
["range",">reference/pairs.html#(def._((lib._racket/list..rkt)._range))",[0,[2,"range"]],["racket/list","racket"]],
["range",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._range))",[0,[2,"range"]],["lang/htdp-advanced"]],
["range",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._range))",[0,[2,"range"]],["lang/htdp-beginner"]],
["range",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._range))",[0,[2,"range"]],["lang/htdp-beginner-abbr"]],
["range",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._range))",[0,[2,"range"]],["lang/htdp-intermediate"]],
["range",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._range))",[0,[2,"range"]],["lang/htdp-intermediate-lambda"]],
["range",">guide/contract-func.html#(tech._range)","<span style=\"font-style: italic\">range</span>",false],
["rational",">deinprogramm/Signaturen.html#(form._((lib._deinprogramm/.D.Md.A..rkt)._rational))",[0,[1,"rational"]],["deinprogramm/DMdA-beginner"]],
["rational",">guide/numbers.html#(tech._rational)","<span style=\"font-style: italic\">rational</span>",false],
["rational numbers",">reference/numbers.html#(tech._rational._number)","<span style=\"font-style: italic\">rational numbers</span>",false],
["rational-ivl?",">plot/utils.html#(def._((lib._plot/utils..rkt)._rational-ivl~3f))",[0,[2,"rational-ivl?"]],["plot/utils"]],
["rational-valued?",">r6rs-std/r6rs-Z-H-14.html#node_idx_452",[0,[2,"rational-valued?"]],["rnrs/base-6"]],
["rational?",">reference/number-types.html#(def._((quote._~23~25kernel)._rational~3f))",[0,[2,"rational?"]],["racket/base","racket"]],
["rational?",">r5rs-std/r5rs-Z-H-9.html#%_idx_250",[0,[2,"rational?"]],["r5rs"]],
["rational?",">r6rs-std/r6rs-Z-H-14.html#node_idx_446",[0,[2,"rational?"]],["rnrs/base-6"]],
["rational?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._rational~3f))",[0,[2,"rational?"]],["lang/htdp-advanced"]],
["rational?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._rational~3f))",[0,[2,"rational?"]],["lang/htdp-beginner"]],
["rational?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._rational~3f))",[0,[2,"rational?"]],["lang/htdp-beginner-abbr"]],
["rational?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._rational~3f))",[0,[2,"rational?"]],["lang/htdp-intermediate"]],
["rational?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._rational~3f))",[0,[2,"rational?"]],["lang/htdp-intermediate-lambda"]],
["rational?",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._rational~3f))",[0,[2,"rational?"]],["deinprogramm/DMdA-advanced"]],
["rational?",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._rational~3f))",[0,[2,"rational?"]],["deinprogramm/DMdA-assignments"]],
["rational?",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._rational~3f))",[0,[2,"rational?"]],["deinprogramm/DMdA-beginner"]],
["rational?",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._rational~3f))",[0,[2,"rational?"]],["deinprogramm/DMdA-vanilla"]],
["rationalize",">reference/generic-numbers.html#(def._((lib._racket/private/misc..rkt)._rationalize))",[0,[2,"rationalize"]],["racket/base","racket"]],
["rationalize",">r5rs-std/r5rs-Z-H-9.html#%_idx_322",[0,[2,"rationalize"]],["r5rs"]],
["rationalize",">r6rs-std/r6rs-Z-H-14.html#node_idx_536",[0,[2,"rationalize"]],["rnrs/base-6"]],
["raw",">foreign/foreign_pointer-funcs.html#(idx._(gentag._12._(lib._scribblings/foreign/foreign..scrbl)))",[7,"'raw"],false],
["raw preprocessing directives",">preprocessor/mzpp.html#(part._.Raw_preprocessing_directives)","Raw preprocessing directives",false],
["raw runtime functions",">foreign/Objective-C_FFI.html#(part._.Raw_.Runtime_.Functions)","Raw Runtime Functions",false],
["rb-find",">slideshow/Pict_Finders.html#(def._((lib._slideshow/pict..rkt)._rb-find))",[0,[2,"rb-find"]],["slideshow/pict","slideshow"]],
["rb-superimpose",">slideshow/Pict_Combiners.html#(def._((lib._slideshow/pict..rkt)._rb-superimpose))",[0,[2,"rb-superimpose"]],["slideshow/pict","slideshow"]],
["rbl-find",">slideshow/Pict_Finders.html#(def._((lib._slideshow/pict..rkt)._rbl-find))",[0,[2,"rbl-find"]],["slideshow/pict","slideshow"]],
["rbl-superimpose",">slideshow/Pict_Combiners.html#(def._((lib._slideshow/pict..rkt)._rbl-superimpose))",[0,[2,"rbl-superimpose"]],["slideshow/pict","slideshow"]],
["rc-find",">slideshow/Pict_Finders.html#(def._((lib._slideshow/pict..rkt)._rc-find))",[0,[2,"rc-find"]],["slideshow/pict","slideshow"]],
["rc-superimpose",">slideshow/Pict_Combiners.html#(def._((lib._slideshow/pict..rkt)._rc-superimpose))",[0,[2,"rc-superimpose"]],["slideshow/pict","slideshow"]],
["rcontrol",">gui/key-event_.html#(idx._(gentag._44._(lib._scribblings/gui/gui..scrbl)))",[7,"'rcontrol"],false],
["re",">unstable/Automata__Compiling_State_Machines.html#(form._((lib._unstable/automata/re..rkt)._re))",[0,[1,"re"]],["unstable/automata/re"]],
["re-slide",">slideshow/Slide_Registration.html#(def._((lib._slideshow/base..rkt)._re-slide))",[0,[2,"re-slide"]],["slideshow/base","slideshow"]],
["re-using errortrace stack tracing",">errortrace/stacktrace.html","Re-using Errortrace Stack Tracing",false],
["read",">reference/Reading.html#(def._((quote._~23~25kernel)._read))",[0,[2,"read"]],["racket/base","racket"]],
["read",">gui/editor-data-class_.html#(meth._(((lib._mred/main..rkt)._editor-data-class~25)._read))",[[0,[2,"read"]],[14,[" (method of ",[0,[2,"editor-data-class%"]],")"]]],["racket/gui/base","racket/gui"]],
["read",">gui/editor-stream-in-base_.html#(meth._(((lib._mred/main..rkt)._editor-stream-in-base~25)._read))",[[0,[2,"read"]],[14,[" (method of ",[0,[2,"editor-stream-in-base%"]],")"]]],["racket/gui/base","racket/gui"]],
["read",">gui/snip-class_.html#(meth._(((lib._racket/snip..rkt)._snip-class~25)._read))",[[0,[2,"read"]],[14,[" (method of ",[0,[2,"snip-class%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["read",">gui/string-snip_.html#(meth._(((lib._racket/snip..rkt)._string-snip~25)._read))",[[0,[2,"read"]],[14,[" (method of ",[0,[2,"string-snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["read",">r5rs-std/r5rs-Z-H-9.html#%_idx_636",[0,[2,"read"]],["r5rs"]],
["read",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_816",[0,[2,"read"]],["rnrs/io/simple-6"]],
["read",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._read))",[0,[2,"read"]],["lang/htdp-advanced"]],
["read",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._read))",[0,[2,"read"]],["deinprogramm/DMdA-advanced"]],
["read",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._read))",[0,[2,"read"]],["deinprogramm/DMdA-assignments"]],
["read",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._read))",[0,[2,"read"]],["deinprogramm/DMdA-beginner"]],
["read",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._read))",[0,[2,"read"]],["deinprogramm/DMdA-vanilla"]],
["read",">framework/editor-snip.html#(meth._(((lib._framework/main..rkt)._editor-snip~3adecorated-snipclass~25)._read))",[[0,[2,"read"]],[14,[" (method of ",[0,[2,"editor-snip:decorated-snipclass%"]],")"]]],["framework"]],
["read",">framework/Number_Snip.html#(meth._(((lib._framework/main..rkt)._number-snip~3asnip-class~25)._read))",[[0,[2,"read"]],[14,[" (method of ",[0,[2,"number-snip:snip-class%"]],")"]]],["framework"]],
["read",">scribble/reader-internals.html#(def._((lib._scribble/reader..rkt)._read))",[0,[2,"read"]],["scribble/reader"]],
["read",">reference/securityguards.html#(idx._(gentag._227._(lib._scribblings/reference/reference..scrbl)))",[7,"'read"],false],
["read",">reference/Filesystem.html#(idx._(gentag._290._(lib._scribblings/reference/reference..scrbl)))",[7,"'read"],false],
["read",">drracket/interactions-window.html#(idx._(gentag._31._(lib._scribblings/drracket/drracket..scrbl)))",[0,[2,"read"]],false],
["read",">reference/syntax-model.html#(tech._read)","<span style=\"font-style: italic\">read</span>",false],
["read interaction handler",">reference/eval.html#(tech._read._interaction._handler)","<span style=\"font-style: italic\">read interaction\nhandler</span>",false],
["read-1strings",">teachpack/2htdpbatch-io.html#(def._((lib._2htdp/batch-io..rkt)._read-1strings))",[0,[2,"read-1strings"]],["2htdp/batch-io"]],
["read-accept-bar-quote",">reference/Reading.html#(def._((quote._~23~25kernel)._read-accept-bar-quote))",[0,[2,"read-accept-bar-quote"]],["racket/base","racket"]],
["read-accept-box",">reference/Reading.html#(def._((quote._~23~25kernel)._read-accept-box))",[0,[2,"read-accept-box"]],["racket/base","racket"]],
["read-accept-compiled",">reference/Reading.html#(def._((quote._~23~25kernel)._read-accept-compiled))",[0,[2,"read-accept-compiled"]],["racket/base","racket"]],
["read-accept-dot",">reference/Reading.html#(def._((quote._~23~25kernel)._read-accept-dot))",[0,[2,"read-accept-dot"]],["racket/base","racket"]],
["read-accept-graph",">reference/Reading.html#(def._((quote._~23~25kernel)._read-accept-graph))",[0,[2,"read-accept-graph"]],["racket/base","racket"]],
["read-accept-infix-dot",">reference/Reading.html#(def._((quote._~23~25kernel)._read-accept-infix-dot))",[0,[2,"read-accept-infix-dot"]],["racket/base","racket"]],
["read-accept-lang",">reference/Reading.html#(def._((quote._~23~25kernel)._read-accept-lang))",[0,[2,"read-accept-lang"]],["racket/base","racket"]],
["read-accept-quasiquote",">reference/Reading.html#(def._((quote._~23~25kernel)._read-accept-quasiquote))",[0,[2,"read-accept-quasiquote"]],["racket/base","racket"]],
["read-accept-reader",">reference/Reading.html#(def._((quote._~23~25kernel)._read-accept-reader))",[0,[2,"read-accept-reader"]],["racket/base","racket"]],
["read-bitmap",">draw/Drawing_Functions.html#(def._((lib._racket/draw..rkt)._read-bitmap))",[0,[2,"read-bitmap"]],["racket/draw"]],
["read-byte",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._read-byte))",[0,[2,"read-byte"]],["racket/base","racket"]],
["read-byte",">gui/editor-stream-in-base_.html#(meth._(((lib._mred/main..rkt)._editor-stream-in-base~25)._read-byte))",[[0,[2,"read-byte"]],[14,[" (method of ",[0,[2,"editor-stream-in-base%"]],")"]]],["racket/gui/base","racket/gui"]],
["read-byte-or-special",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._read-byte-or-special))",[0,[2,"read-byte-or-special"]],["racket/base","racket"]],
["read-bytes",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._read-bytes))",[0,[2,"read-bytes"]],["racket/base","racket"]],
["read-bytes",">gui/editor-stream-in-base_.html#(meth._(((lib._mred/main..rkt)._editor-stream-in-base~25)._read-bytes))",[[0,[2,"read-bytes"]],[14,[" (method of ",[0,[2,"editor-stream-in-base%"]],")"]]],["racket/gui/base","racket/gui"]],
["read-bytes",">gui/WXME_Decoding.html#(meth._(((lib._wxme/main..rkt)._stream~3c~25~3e)._read-bytes))",[[0,[2,"read-bytes"]],[14,[" (method of ",[0,[2,"stream<%>"]],")"]]],["wxme"]],
["read-bytes!",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._read-bytes!))",[0,[2,"read-bytes!"]],["racket/base","racket"]],
["read-bytes!-evt",">reference/port-lib.html#(def._((lib._racket/port..rkt)._read-bytes!-evt))",[0,[2,"read-bytes!-evt"]],["racket/port","racket"]],
["read-bytes-avail!",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._read-bytes-avail!))",[0,[2,"read-bytes-avail!"]],["racket/base","racket"]],
["read-bytes-avail!*",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._read-bytes-avail!*))",[0,[2,"read-bytes-avail!*"]],["racket/base","racket"]],
["read-bytes-avail!-evt",">reference/port-lib.html#(def._((lib._racket/port..rkt)._read-bytes-avail!-evt))",[0,[2,"read-bytes-avail!-evt"]],["racket/port","racket"]],
["read-bytes-avail!/enable-break",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._read-bytes-avail!/enable-break))",[0,[2,"read-bytes-avail!/enable-break"]],["racket/base","racket"]],
["read-bytes-evt",">reference/port-lib.html#(def._((lib._racket/port..rkt)._read-bytes-evt))",[0,[2,"read-bytes-evt"]],["racket/port","racket"]],
["read-bytes-line",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._read-bytes-line))",[0,[2,"read-bytes-line"]],["racket/base","racket"]],
["read-bytes-line-evt",">reference/port-lib.html#(def._((lib._racket/port..rkt)._read-bytes-line-evt))",[0,[2,"read-bytes-line-evt"]],["racket/port","racket"]],
["read-case-sensitive",">reference/Reading.html#(def._((quote._~23~25kernel)._read-case-sensitive))",[0,[2,"read-case-sensitive"]],["racket/base","racket"]],
["read-char",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._read-char))",[0,[2,"read-char"]],["racket/base","racket"]],
["read-char",">r5rs-std/r5rs-Z-H-9.html#%_idx_640",[0,[2,"read-char"]],["r5rs"]],
["read-char",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_808",[0,[2,"read-char"]],["rnrs/io/simple-6"]],
["read-char",">drracket/interactions-window.html#(idx._(gentag._32._(lib._scribblings/drracket/drracket..scrbl)))",[0,[2,"read-char"]],false],
["read-char-or-special",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._read-char-or-special))",[0,[2,"read-char-or-special"]],["racket/base","racket"]],
["read-comments",">xml/index.html#(def._((lib._xml/main..rkt)._read-comments))",[0,[2,"read-comments"]],["xml"]],
["read-configuration-table",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table..rkt)._read-configuration-table))",[0,[2,"read-configuration-table"]],["web-server/configuration/configuration-table"]],
["read-csv-file",">teachpack/2htdpbatch-io.html#(def._((lib._2htdp/batch-io..rkt)._read-csv-file))",[0,[2,"read-csv-file"]],["2htdp/batch-io"]],
["read-csv-file/rows",">teachpack/2htdpbatch-io.html#(def._((lib._2htdp/batch-io..rkt)._read-csv-file/rows))",[0,[2,"read-csv-file/rows"]],["2htdp/batch-io"]],
["read-curly-brace-as-paren",">reference/Reading.html#(def._((quote._~23~25kernel)._read-curly-brace-as-paren))",[0,[2,"read-curly-brace-as-paren"]],["racket/base","racket"]],
["read-decimal-as-inexact",">reference/Reading.html#(def._((quote._~23~25kernel)._read-decimal-as-inexact))",[0,[2,"read-decimal-as-inexact"]],["racket/base","racket"]],
["read-editor",">gui/WXME_Decoding.html#(meth._(((lib._wxme/main..rkt)._stream~3c~25~3e)._read-editor))",[[0,[2,"read-editor"]],[14,[" (method of ",[0,[2,"stream<%>"]],")"]]],["wxme"]],
["read-editor-global-footer",">gui/Editor_Functions.html#(def._((lib._mred/main..rkt)._read-editor-global-footer))",[0,[2,"read-editor-global-footer"]],["racket/gui/base","racket/gui"]],
["read-editor-global-header",">gui/Editor_Functions.html#(def._((lib._mred/main..rkt)._read-editor-global-header))",[0,[2,"read-editor-global-header"]],["racket/gui/base","racket/gui"]],
["read-editor-version",">gui/Editor_Functions.html#(def._((lib._mred/main..rkt)._read-editor-version))",[0,[2,"read-editor-version"]],["racket/gui/base","racket/gui"]],
["read-eval-print-loop",">reference/eval.html#(def._((lib._racket/private/misc..rkt)._read-eval-print-loop))",[0,[2,"read-eval-print-loop"]],["racket/base","racket"]],
["read-file",">teachpack/2htdpbatch-io.html#(def._((lib._2htdp/batch-io..rkt)._read-file))",[0,[2,"read-file"]],["2htdp/batch-io"]],
["read-fixed-integer",">gui/WXME_Decoding.html#(meth._(((lib._wxme/main..rkt)._stream~3c~25~3e)._read-fixed-integer))",[[0,[2,"read-fixed-integer"]],[14,[" (method of ",[0,[2,"stream<%>"]],")"]]],["wxme"]],
["read-footer-from-file",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._read-footer-from-file))",[[0,[2,"read-footer-from-file"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["read-from-file",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._read-from-file))",[[0,[2,"read-from-file"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["read-from-file",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._read-from-file))",[[0,[2,"read-from-file"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["read-from-string",">mzlib/mzlib_string.html#(def._((lib._mzlib/string..rkt)._read-from-string))",[0,[2,"read-from-string"]],["mzlib/string"]],
["read-from-string-all",">mzlib/mzlib_string.html#(def._((lib._mzlib/string..rkt)._read-from-string-all))",[0,[2,"read-from-string-all"]],["mzlib/string"]],
["read-header",">gui/snip-class_.html#(meth._(((lib._racket/snip..rkt)._snip-class~25)._read-header))",[[0,[2,"read-header"]],[14,[" (method of ",[0,[2,"snip-class%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["read-header",">gui/WXME_Decoding.html#(meth._(((lib._wxme/main..rkt)._snip-reader~3c~25~3e)._read-header))",[[0,[2,"read-header"]],[14,[" (method of ",[0,[2,"snip-reader<%>"]],")"]]],["wxme"]],
["read-header-from-file",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._read-header-from-file))",[[0,[2,"read-header-from-file"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["read-html",">html/index.html#(def._((lib._html/main..rkt)._read-html))",[0,[2,"read-html"]],["html"]],
["read-html-as-xml",">html/index.html#(def._((lib._html/main..rkt)._read-html-as-xml))",[0,[2,"read-html-as-xml"]],["html"]],
["read-html-comments",">html/index.html#(def._((lib._html/main..rkt)._read-html-comments))",[0,[2,"read-html-comments"]],["html"]],
["read-icos",">file/ico.html#(def._((lib._file/ico..rkt)._read-icos))",[0,[2,"read-icos"]],["file/ico"]],
["read-icos-from-exe",">file/ico.html#(def._((lib._file/ico..rkt)._read-icos-from-exe))",[0,[2,"read-icos-from-exe"]],["file/ico"]],
["read-inexact",">gui/WXME_Decoding.html#(meth._(((lib._wxme/main..rkt)._stream~3c~25~3e)._read-inexact))",[[0,[2,"read-inexact"]],[14,[" (method of ",[0,[2,"stream<%>"]],")"]]],["wxme"]],
["read-inside",">scribble/reader-internals.html#(def._((lib._scribble/reader..rkt)._read-inside))",[0,[2,"read-inside"]],["scribble/reader"]],
["read-integer",">gui/WXME_Decoding.html#(meth._(((lib._wxme/main..rkt)._stream~3c~25~3e)._read-integer))",[[0,[2,"read-integer"]],[14,[" (method of ",[0,[2,"stream<%>"]],")"]]],["wxme"]],
["read-json",">json/index.html#(def._((lib._json/main..rkt)._read-json))",[0,[2,"read-json"]],["json"]],
["read-language",">reference/Reading.html#(def._((quote._~23~25kernel)._read-language))",[0,[2,"read-language"]],["racket/base","racket"]],
["read-line",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._read-line))",[0,[2,"read-line"]],["racket/base","racket"]],
["read-line-evt",">reference/port-lib.html#(def._((lib._racket/port..rkt)._read-line-evt))",[0,[2,"read-line-evt"]],["racket/port","racket"]],
["read-lines",">teachpack/2htdpbatch-io.html#(def._((lib._2htdp/batch-io..rkt)._read-lines))",[0,[2,"read-lines"]],["2htdp/batch-io"]],
["read-mime-types",">web-server-internal/mime-types.html#(def._((lib._web-server/private/mime-types..rkt)._read-mime-types))",[0,[2,"read-mime-types"]],["web-server/private/mime-types"]],
["read-on-demand-source",">reference/Reading.html#(def._((quote._~23~25kernel)._read-on-demand-source))",[0,[2,"read-on-demand-source"]],["racket/base","racket"]],
["read-plist",">xml/index.html#(def._((lib._xml/plist..rkt)._read-plist))",[0,[2,"read-plist"]],["xml/plist"]],
["read-raw-bytes",">gui/WXME_Decoding.html#(meth._(((lib._wxme/main..rkt)._stream~3c~25~3e)._read-raw-bytes))",[[0,[2,"read-raw-bytes"]],[14,[" (method of ",[0,[2,"stream<%>"]],")"]]],["wxme"]],
["read-request",">web-server-internal/dispatch-server-unit.html#(sig-val._((lib._web-server/private/dispatch-server-sig..rkt)._dispatch-server-config~5e._read-request))",[0,[2,"read-request"]],["web-server/private/dispatch-server-sig"]],
["read-root",">plai/collector.html#(def._((lib._plai/collector..rkt)._read-root))",[0,[2,"read-root"]],["plai/collector"]],
["read-snip",">gui/WXME_Decoding.html#(meth._(((lib._wxme/main..rkt)._snip-reader~3c~25~3e)._read-snip))",[[0,[2,"read-snip"]],[14,[" (method of ",[0,[2,"snip-reader<%>"]],")"]]],["wxme"]],
["read-snip-from-port",">gui/WXME_Decoding.html#(def._((lib._wxme/main..rkt)._read-snip-from-port))",[0,[2,"read-snip-from-port"]],["wxme"]],
["read-special",">gui/readable-snip___.html#(meth._(((lib._racket/snip..rkt)._readable-snip~3c~25~3e)._read-special))",[[0,[2,"read-special"]],[14,[" (method of ",[0,[2,"readable-snip<%>"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["read-special",">gui/WXME_Decoding.html#(meth._(((lib._wxme/main..rkt)._readable~3c~25~3e)._read-special))",[[0,[2,"read-special"]],[14,[" (method of ",[0,[2,"readable<%>"]],")"]]],["wxme"]],
["read-special",">gui/WXME_Decoding.html#(meth._(((lib._wxme/comment..rkt)._comment-editor~25)._read-special))",[[0,[2,"read-special"]],[14,[" (method of ",[0,[2,"comment-editor%"]],")"]]],["wxme/comment"]],
["read-special",">gui/WXME_Decoding.html#(meth._(((lib._wxme/scheme..rkt)._racket-editor~25)._read-special))",["read-special",[14,[" (method of ",[0,[2,"racket-editor%"]],")"]]],["wxme/scheme"]],
["read-special",">gui/WXME_Decoding.html#(meth._(((lib._wxme/text..rkt)._text-editor~25)._read-special))",[[0,[2,"read-special"]],[14,[" (method of ",[0,[2,"text-editor%"]],")"]]],["wxme/text"]],
["read-special",">gui/WXME_Decoding.html#(meth._(((lib._wxme/xml..rkt)._xml-editor~25)._read-special))",[[0,[2,"read-special"]],[14,[" (method of ",[0,[2,"xml-editor%"]],")"]]],["wxme/xml"]],
["read-square-bracket-as-paren",">reference/Reading.html#(def._((quote._~23~25kernel)._read-square-bracket-as-paren))",[0,[2,"read-square-bracket-as-paren"]],["racket/base","racket"]],
["read-string",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._read-string))",[0,[2,"read-string"]],["racket/base","racket"]],
["read-string!",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._read-string!))",[0,[2,"read-string!"]],["racket/base","racket"]],
["read-string!-evt",">reference/port-lib.html#(def._((lib._racket/port..rkt)._read-string!-evt))",[0,[2,"read-string!-evt"]],["racket/port","racket"]],
["read-string-evt",">reference/port-lib.html#(def._((lib._racket/port..rkt)._read-string-evt))",[0,[2,"read-string-evt"]],["racket/port","racket"]],
["read-syntax",">reference/Reading.html#(def._((quote._~23~25kernel)._read-syntax))",[0,[2,"read-syntax"]],["racket/base","racket"]],
["read-syntax",">scribble/reader-internals.html#(def._((lib._scribble/reader..rkt)._read-syntax))",[0,[2,"read-syntax"]],["scribble/reader"]],
["read-syntax-inside",">scribble/reader-internals.html#(def._((lib._scribble/reader..rkt)._read-syntax-inside))",[0,[2,"read-syntax-inside"]],["scribble/reader"]],
["read-syntax/recursive",">reference/Reading.html#(def._((quote._~23~25kernel)._read-syntax/recursive))",[0,[2,"read-syntax/recursive"]],["racket/base","racket"]],
["read-table",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Read-.Table))",[0,[1,"Read-Table"]],["typed/racket/base","typed/racket"]],
["read-theory",">datalog/interop.html#(def._((lib._datalog/main..rkt)._read-theory))",[0,[2,"read-theory"]],["datalog"]],
["read-with-shared-structure",">srfi-std/srfi-38.html#read-with-shared-structure",[0,[2,"read-with-shared-structure"]],["srfi/38"]],
["read-words",">teachpack/2htdpbatch-io.html#(def._((lib._2htdp/batch-io..rkt)._read-words))",[0,[2,"read-words"]],["2htdp/batch-io"]],
["read-words/line",">teachpack/2htdpbatch-io.html#(def._((lib._2htdp/batch-io..rkt)._read-words/line))",[0,[2,"read-words/line"]],["2htdp/batch-io"]],
["read-xhtml",">html/index.html#(def._((lib._html/main..rkt)._read-xhtml))",[0,[2,"read-xhtml"]],["html"]],
["read-xml",">xml/index.html#(def._((lib._xml/main..rkt)._read-xml))",[0,[2,"read-xml"]],["xml"]],
["read-xml/document",">xml/index.html#(def._((lib._xml/main..rkt)._read-xml/document))",[0,[2,"read-xml/document"]],["xml"]],
["read-xml/element",">xml/index.html#(def._((lib._xml/main..rkt)._read-xml/element))",[0,[2,"read-xml/element"]],["xml"]],
["read/bytes",">unstable/bytes.html#(def._((lib._unstable/bytes..rkt)._read/bytes))",[0,[2,"read/bytes"]],["unstable/bytes"]],
["read/recursive",">reference/Reading.html#(def._((quote._~23~25kernel)._read/recursive))",[0,[2,"read/recursive"]],["racket/base","racket"]],
["readable-snip<%>",">gui/readable-snip___.html",[0,[2,"readable-snip<%>"]],["racket/snip","racket/gui/base","racket/gui"]],
["readable<%>",">gui/WXME_Decoding.html#(def._((lib._wxme/main..rkt)._readable~3c~25~3e))",[0,[2,"readable<%>"]],["wxme"]],
["reader",">reference/reader.html#(mod-path._reader)",[9,[0,"reader"]],"module"],
["reader",">gui/WXME_Decoding.html#(def._((lib._wxme/cache-image..rkt)._reader))",[0,[2,"reader"]],["wxme/cache-image"]],
["reader",">gui/WXME_Decoding.html#(def._((lib._wxme/comment..rkt)._reader))",[0,[2,"reader"]],["wxme/comment"]],
["reader",">gui/WXME_Decoding.html#(def._((lib._wxme/number..rkt)._reader))",[0,[2,"reader"]],["wxme/number"]],
["reader",">gui/WXME_Decoding.html#(def._((lib._wxme/scheme..rkt)._reader))",[0,[2,"reader"]],["wxme/scheme"]],
["reader",">gui/WXME_Decoding.html#(def._((lib._wxme/test-case..rkt)._reader))",[0,[2,"reader"]],["wxme/test-case"]],
["reader",">gui/WXME_Decoding.html#(def._((lib._wxme/text..rkt)._reader))",[0,[2,"reader"]],["wxme/text"]],
["reader",">gui/WXME_Decoding.html#(def._((lib._wxme/xml..rkt)._reader))",[0,[2,"reader"]],["wxme/xml"]],
["reader",">guide/Pairs__Lists__and_Racket_Syntax.html#(tech._reader)","<span style=\"font-style: italic\">reader</span>",false],
["reader extension",">reference/Reader_Extension.html","Reader Extension",false],
["reader extension procedures",">reference/Reader_Extension.html#(tech._reader._extension._procedure)","<span style=\"font-style: italic\">reader\nextension procedures</span>",false],
["reader extensions",">guide/hash-reader.html","Reader Extensions",false],
["reader helpers",">syntax/reader-helpers.html","Reader Helpers",false],
["reader language",">reference/Reading.html#(tech._reader._language)","<span style=\"font-style: italic\">reader language</span>",false],
["reader macro",">reference/readtables.html#(tech._reader._macro)","<span style=\"font-style: italic\">reader macro</span>",false],
["reader-color",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._reader-color))",[0,[2,"reader-color"]],["scribble/racket","scribble/scheme"]],
["reader-extension procedures",">reference/reader-procs.html","Reader-Extension Procedures",false],
["reading",">reference/Reading.html","Reading",false],
["reading and printing",">htdp-langs/advanced.html#(part._htdp-advanced._.Reading_and_.Printing)","Reading and Printing",false],
["reading and writing racket data",">guide/read-write.html","Reading and Writing Racket Data",false],
["reading and writing xml",">xml/index.html#(part._.Reading_and_.Writing_.X.M.L)","Reading and Writing XML",false],
["reading booleans",">reference/reader.html#(part._parse-boolean)","Reading Booleans",false],
["reading boxes",">reference/reader.html#(part._parse-box)","Reading Boxes",false],
["reading characters",">reference/reader.html#(part._parse-character)","Reading Characters",false],
["reading comments",">reference/reader.html#(part._parse-comment)","Reading Comments",false],
["reading graph structure",">reference/reader.html#(part._parse-graph)","Reading Graph Structure",false],
["reading hash tables",">reference/reader.html#(part._parse-hashtable)","Reading Hash Tables",false],
["reading keywords",">reference/reader.html#(part._parse-keyword)","Reading Keywords",false],
["reading module source code",">syntax/module-helpers.html#(part._modread)","Reading Module Source Code",false],
["reading numbers",">reference/reader.html#(part._parse-number)","Reading Numbers",false],
["reading pairs and lists",">reference/reader.html#(part._parse-pair)","Reading Pairs and Lists",false],
["reading quotes",">reference/reader.html#(part._parse-quote)","Reading Quotes",false],
["reading regular expressions",">reference/reader.html#(part._parse-regexp)","Reading Regular Expressions",false],
["reading strings",">reference/reader.html#(part._parse-string)","Reading Strings",false],
["reading structures",">reference/reader.html#(part._parse-structure)","Reading Structures",false],
["reading symbols",">reference/reader.html#(part._parse-symbol)","Reading Symbols",false],
["reading vectors",">reference/reader.html#(part._parse-vector)","Reading Vectors",false],
["reading via an extension",">reference/reader.html#(part._parse-reader)","Reading via an Extension",false],
["reading-version",">gui/snip-class_.html#(meth._(((lib._racket/snip..rkt)._snip-class~25)._reading-version))",[[0,[2,"reading-version"]],[14,[" (method of ",[0,[2,"snip-class%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["readline",">readline/index.html#(mod-path._readline)",[9,[0,"readline"]],"module"],
["readline",">readline/index.html#(def._((lib._readline/readline..rkt)._readline))",[0,[2,"readline"]],["readline/readline"]],
["readline-bytes",">readline/index.html#(def._((lib._readline/readline..rkt)._readline-bytes))",[0,[2,"readline-bytes"]],["readline/readline"]],
["readline-prompt",">readline/index.html#(def._((lib._readline/pread..rkt)._readline-prompt))",[0,[2,"readline-prompt"]],["readline/pread"]],
["readline/pread",">readline/index.html#(mod-path._readline/pread)",[9,[0,"readline/pread"]],"module"],
["readline/readline",">readline/index.html#(mod-path._readline/readline)",[9,[0,"readline/readline"]],"module"],
["readline/rep-start",">readline/index.html#(mod-path._readline/rep-start)",[9,[0,"readline/rep-start"]],"module"],
["readline: terminal interaction",">readline/index.html","Readline: Terminal Interaction",false],
["readtable",">guide/hash-reader.html#(tech._readtable)","<span style=\"font-style: italic\">readtable</span>",false],
["readtable",">reference/readtables.html#(tech._readtable)","<span style=\"font-style: italic\">readtable</span>",false],
["readtable-mapping",">reference/readtables.html#(def._((quote._~23~25kernel)._readtable-mapping))",[0,[2,"readtable-mapping"]],["racket/base","racket"]],
["readtable?",">reference/readtables.html#(def._((quote._~23~25kernel)._readtable~3f))",[0,[2,"readtable?"]],["racket/base","racket"]],
["readtables",">guide/hash-reader.html#(part._readtable)","Readtables",false],
["readtables",">reference/readtables.html","Readtables",false],
["ready-key-press",">graphics/Keyboard_Operations.html#(def._((lib._graphics/graphics..rkt)._ready-key-press))",[0,[2,"ready-key-press"]],["graphics/graphics"]],
["ready-mouse-click",">graphics/Mouse_Operations.html#(def._((lib._graphics/graphics..rkt)._ready-mouse-click))",[0,[2,"ready-mouse-click"]],["graphics/graphics"]],
["ready-mouse-release",">graphics/Mouse_Operations.html#(def._((lib._graphics/graphics..rkt)._ready-mouse-release))",[0,[2,"ready-mouse-release"]],["graphics/graphics"]],
["ready...",">more/index.html#(part._.Ready___)","Ready...",false],
["ready...",">quick/index.html#(part._.Ready___)","Ready...",false],
["real",">deinprogramm/Signaturen.html#(form._((lib._deinprogramm/.D.Md.A..rkt)._real))",[0,[1,"real"]],["deinprogramm/DMdA-beginner"]],
["real",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Real))",[0,[1,"Real"]],["typed/racket/base","typed/racket"]],
["real",">redex/The_Redex_Reference.html#(tech._real)",[0,"real"],false],
["real",">guide/numbers.html#(tech._real)","<span style=\"font-style: italic\">real</span>",false],
["real functions",">plot/utils.html#(part._.Real_.Functions)","Real Functions",false],
["real numbers",">reference/numbers.html#(tech._real._number)","<span style=\"font-style: italic\">real numbers</span>",false],
["real->decimal-string",">reference/generic-numbers.html#(def._((lib._racket/private/base..rkt)._real-~3edecimal-string))",[0,[2,"real->decimal-string"]],["racket/base","racket"]],
["real->decimal-string*",">plot/utils.html#(def._((lib._plot/utils..rkt)._real-~3edecimal-string*))",[0,[2,"real->decimal-string*"]],["plot/utils"]],
["real->double-flonum",">reference/number-types.html#(def._((quote._~23~25kernel)._real-~3edouble-flonum))",[0,[2,"real->double-flonum"]],["racket/base","racket"]],
["real->floating-point-bytes",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._real-~3efloating-point-bytes))",[0,[2,"real->floating-point-bytes"]],["racket/base","racket"]],
["real->flonum",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_952",[0,[2,"real->flonum"]],["rnrs/arithmetic/flonums-6"]],
["real->int",">picturing-programs/index.html#(def._((lib._picturing-programs/private/map-image..rkt)._real-~3eint))",[0,[2,"real->int"]],["picturing-programs/private/map-image","picturing-programs"]],
["real->plot-label",">plot/utils.html#(def._((lib._plot/utils..rkt)._real-~3eplot-label))",[0,[2,"real->plot-label"]],["plot/utils"]],
["real->single-flonum",">reference/number-types.html#(def._((quote._~23~25kernel)._real-~3esingle-flonum))",[0,[2,"real->single-flonum"]],["racket/base","racket"]],
["real->string/trunc",">plot/utils.html#(def._((lib._plot/utils..rkt)._real-~3estring/trunc))",[0,[2,"real->string/trunc"]],["plot/utils"]],
["real-arg",">web-server/dispatch.html#(form._((lib._web-server/dispatch..rkt)._real-arg))",[0,[1,"real-arg"]],["web-server/dispatch"]],
["real-in",">reference/data-structure-contracts.html#(def._((lib._racket/contract/private/misc..rkt)._real-in))",[0,[2,"real-in"]],["racket/contract/base","racket/contract","racket"]],
["real-order",">data/Orders_and_Ordered_Dictionaries.html#(def._((lib._data/order..rkt)._real-order))",[0,[2,"real-order"]],["data/order"]],
["real-part",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._real-part))",[0,[2,"real-part"]],["racket/base","racket"]],
["real-part",">r5rs-std/r5rs-Z-H-9.html#%_idx_352",[0,[2,"real-part"]],["r5rs"]],
["real-part",">r6rs-std/r6rs-Z-H-14.html#node_idx_570",[0,[2,"real-part"]],["rnrs/base-6"]],
["real-part",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._real-part))",[0,[2,"real-part"]],["lang/htdp-advanced"]],
["real-part",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._real-part))",[0,[2,"real-part"]],["lang/htdp-beginner"]],
["real-part",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._real-part))",[0,[2,"real-part"]],["lang/htdp-beginner-abbr"]],
["real-part",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._real-part))",[0,[2,"real-part"]],["lang/htdp-intermediate"]],
["real-part",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._real-part))",[0,[2,"real-part"]],["lang/htdp-intermediate-lambda"]],
["real-part",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._real-part))",[0,[2,"real-part"]],["deinprogramm/DMdA-advanced"]],
["real-part",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._real-part))",[0,[2,"real-part"]],["deinprogramm/DMdA-assignments"]],
["real-part",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._real-part))",[0,[2,"real-part"]],["deinprogramm/DMdA-beginner"]],
["real-part",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._real-part))",[0,[2,"real-part"]],["deinprogramm/DMdA-vanilla"]],
["real-time",">mzlib/mzlib_compat.html#(def._((lib._mzlib/compat..rkt)._real-time))",[0,[2,"real-time"]],["mzlib/compat"]],
["real-valued-posn?",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._real-valued-posn~3f))",[0,[2,"real-valued-posn?"]],["2htdp/image"]],
["real-valued?",">r6rs-std/r6rs-Z-H-14.html#node_idx_450",[0,[2,"real-valued?"]],["rnrs/base-6"]],
["real-zero",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Real-.Zero))",[0,[1,"Real-Zero"]],["typed/racket/base","typed/racket"]],
["real?",">reference/number-types.html#(def._((quote._~23~25kernel)._real~3f))",[0,[2,"real?"]],["racket/base","racket"]],
["real?",">r5rs-std/r5rs-Z-H-9.html#%_idx_248",[0,[2,"real?"]],["r5rs"]],
["real?",">r6rs-std/r6rs-Z-H-14.html#node_idx_444",[0,[2,"real?"]],["rnrs/base-6"]],
["real?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._real~3f))",[0,[2,"real?"]],["lang/htdp-advanced"]],
["real?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._real~3f))",[0,[2,"real?"]],["lang/htdp-beginner"]],
["real?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._real~3f))",[0,[2,"real?"]],["lang/htdp-beginner-abbr"]],
["real?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._real~3f))",[0,[2,"real?"]],["lang/htdp-intermediate"]],
["real?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._real~3f))",[0,[2,"real?"]],["lang/htdp-intermediate-lambda"]],
["real?",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._real~3f))",[0,[2,"real?"]],["deinprogramm/DMdA-advanced"]],
["real?",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._real~3f))",[0,[2,"real?"]],["deinprogramm/DMdA-assignments"]],
["real?",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._real~3f))",[0,[2,"real?"]],["deinprogramm/DMdA-beginner"]],
["real?",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._real~3f))",[0,[2,"real?"]],["deinprogramm/DMdA-vanilla"]],
["realign",">mrlib/aligned-pasteboard___.html#(meth._(((lib._mrlib/aligned-pasteboard..rkt)._aligned-pasteboard~3c~25~3e)._realign))",[[0,[2,"realign"]],[14,[" (method of ",[0,[2,"aligned-pasteboard<%>"]],")"]]],["mrlib/aligned-pasteboard"]],
["rearm",">reference/stxcerts.html#(tech._rearm)","<span style=\"font-style: italic\">rearm</span>",false],
["rec",">mzlib/mzlib_etc.html#(form._((lib._mzlib/etc..rkt)._rec))",[0,[1,"rec"]],["mzlib/etc"]],
["rec",">srfi-std/srfi-31.html#rec",[0,[1,"rec"]],["srfi/31"]],
["rec",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types-extra..rkt)._.Rec))",[0,[1,"Rec"]],["typed/racket/base","typed/racket"]],
["rec",">unstable/Automata__Compiling_State_Machines.html#(form._((lib._unstable/automata/re..rkt)._rec))",[0,[1,"rec"]],["unstable/automata/re"]],
["recalc-snips",">framework/Canvas.html#(meth._(((lib._framework/main..rkt)._canvas~3awide-snip~3c~25~3e)._recalc-snips))",[[0,[2,"recalc-snips"]],[14,[" (method of ",[0,[2,"canvas:wide-snip<%>"]],")"]]],["framework"]],
["receive",">srfi-std/srfi-8.html#receive",[0,[1,"receive"]],["srfi/8"]],
["receiving logged events",">reference/logging.html#(part._receiving-logged-events)","Receiving Logged Events",false],
["receiving messages",">teachpack/2htdpuniverse.html#(part._.Receiving_.Messages)","Receiving Messages",false],
["record-accessor",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_336",[0,[2,"record-accessor"]],["rnrs/records/procedural-6"]],
["record-constructor",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_332",[0,[2,"record-constructor"]],["rnrs/records/procedural-6"]],
["record-constructor-descriptor",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_310",[0,[1,"record-constructor-descriptor"]],["rnrs/records/syntactic-6"]],
["record-dc%",">draw/record-dc_.html",[0,[2,"record-dc%"]],["racket/draw"]],
["record-disappeared-uses",">reference/syntax-util.html#(def._((lib._racket/syntax..rkt)._record-disappeared-uses))",[0,[2,"record-disappeared-uses"]],["racket/syntax"]],
["record-field-mutable?",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_360",[0,[2,"record-field-mutable?"]],["rnrs/records/inspection-6"]],
["record-icon",">images/Icons.html#(def._((lib._images/icons/control..rkt)._record-icon))",[0,[2,"record-icon"]],["images/icons/control"]],
["record-mutator",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_338",[0,[2,"record-mutator"]],["rnrs/records/procedural-6"]],
["record-predicate",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_334",[0,[2,"record-predicate"]],["rnrs/records/procedural-6"]],
["record-rtd",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_344",[0,[2,"record-rtd"]],["rnrs/records/inspection-6"]],
["record-typ-definitionen",">deinprogramm/Record-Typ-Definitionen.html","Record-Typ-Definitionen",false],
["record-type-descriptor",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_308",[0,[1,"record-type-descriptor"]],["rnrs/records/syntactic-6"]],
["record-type-descriptor?",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_320",[0,[2,"record-type-descriptor?"]],["rnrs/records/procedural-6"]],
["record-type-field-names",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_358",[0,[2,"record-type-field-names"]],["rnrs/records/inspection-6"]],
["record-type-generative?",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_352",[0,[2,"record-type-generative?"]],["rnrs/records/inspection-6"]],
["record-type-name",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_346",[0,[2,"record-type-name"]],["rnrs/records/inspection-6"]],
["record-type-opaque?",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_356",[0,[2,"record-type-opaque?"]],["rnrs/records/inspection-6"]],
["record-type-parent",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_348",[0,[2,"record-type-parent"]],["rnrs/records/inspection-6"]],
["record-type-sealed?",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_354",[0,[2,"record-type-sealed?"]],["rnrs/records/inspection-6"]],
["record-type-uid",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_350",[0,[2,"record-type-uid"]],["rnrs/records/inspection-6"]],
["record?",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_342",[0,[2,"record?"]],["rnrs/records/inspection-6"]],
["record?",">teachpack/2htdpuniverse.html#(form._((lib._2htdp/universe..rkt)._record~3f))",[0,[1,"record?"]],["2htdp/universe"]],
["recorded-datum->procedure",">draw/Drawing_Functions.html#(def._((lib._racket/draw..rkt)._recorded-datum-~3eprocedure))",[0,[2,"recorded-datum->procedure"]],["racket/draw"]],
["recording disappeared uses",">reference/syntax-util.html#(part._.Recording_disappeared_uses)","Recording disappeared uses",false],
["recounted",">gui/snip-admin_.html#(meth._(((lib._racket/snip..rkt)._snip-admin~25)._recounted))",[[0,[2,"recounted"]],[14,[" (method of ",[0,[2,"snip-admin%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["rectangle",">draw/dc-path_.html#(meth._(((lib._racket/draw..rkt)._dc-path~25)._rectangle))",[[0,[2,"rectangle"]],[14,[" (method of ",[0,[2,"dc-path%"]],")"]]],["racket/draw"]],
["rectangle",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._rectangle))",[0,[2,"rectangle"]],["2htdp/image"]],
["rectangle",">teachpack/image.html#(def._((lib._htdp/image..rkt)._rectangle))",[0,[2,"rectangle"]],["htdp/image"]],
["rectangle",">slideshow/Basic_Pict_Constructors.html#(def._((lib._slideshow/pict..rkt)._rectangle))",[0,[2,"rectangle"]],["slideshow/pict","slideshow"]],
["rectangle",">deinprogramm/image.html#(def._((lib._deinprogramm/image..rkt)._rectangle))",[0,[2,"rectangle"]],["teachpack/deinprogramm/image"]],
["rectangle",">teachpack/matrix.html#(tech._rectangle)","<span style=\"font-style: italic\">Rectangle</span>",false],
["rectangle->matrix",">teachpack/matrix.html#(def._((lib._htdp/matrix..rkt)._rectangle-~3ematrix))",[0,[2,"rectangle->matrix"]],["htdp/matrix"]],
["rectangle-alpha",">plot/params.html#(def._((lib._plot/main..rkt)._rectangle-alpha))",[0,[2,"rectangle-alpha"]],["plot"]],
["rectangle-color",">plot/params.html#(def._((lib._plot/main..rkt)._rectangle-color))",[0,[2,"rectangle-color"]],["plot"]],
["rectangle-line-color",">plot/params.html#(def._((lib._plot/main..rkt)._rectangle-line-color))",[0,[2,"rectangle-line-color"]],["plot"]],
["rectangle-line-style",">plot/params.html#(def._((lib._plot/main..rkt)._rectangle-line-style))",[0,[2,"rectangle-line-style"]],["plot"]],
["rectangle-line-width",">plot/params.html#(def._((lib._plot/main..rkt)._rectangle-line-width))",[0,[2,"rectangle-line-width"]],["plot"]],
["rectangle-style",">plot/params.html#(def._((lib._plot/main..rkt)._rectangle-style))",[0,[2,"rectangle-style"]],["plot"]],
["rectangle/border",">unstable/pict.html#(def._((lib._unstable/gui/pict..rkt)._rectangle/border))",[0,[2,"rectangle/border"]],["unstable/gui/pict"]],
["rectangle3d-line-width",">plot/params.html#(def._((lib._plot/main..rkt)._rectangle3d-line-width))",[0,[2,"rectangle3d-line-width"]],["plot"]],
["rectangles",">graphics/Draw__Clear__and_Flip_Operations.html#(part._.Rectangles)","Rectangles",false],
["rectangles",">plot/params.html#(part._.Rectangles)","Rectangles",false],
["rectangles",">plot/renderer2d.html#(def._((lib._plot/main..rkt)._rectangles))",[0,[2,"rectangles"]],["plot"]],
["rectangles3d",">plot/renderer3d.html#(def._((lib._plot/main..rkt)._rectangles3d))",[0,[2,"rectangles3d"]],["plot"]],
["recur",">htdp-langs/advanced.html#(form._((lib._lang/htdp-advanced..rkt)._recur))",[0,[1,"recur"]],["lang/htdp-advanced"]],
["recur",">mzlib/mzlib_etc.html#(form._((lib._mzlib/etc..rkt)._recur))",[0,[1,"recur"]],["mzlib/etc"]],
["recursion versus iteration",">guide/Lists__Iteration__and_Recursion.html#(part._.Recursion_versus_.Iteration)","Recursion versus Iteration",false],
["recursive binding: letrec",">guide/let.html#(part._.Recursive_.Binding__letrec)",["Recursive Binding: ",[0,[1,"letrec"]]],false],
["recursive types",">ts-guide/types.html#(part._.Recursive_.Types)","Recursive Types",false],
["recursive types",">ts-guide/types.html#(tech._recursive._type)","<span style=\"font-style: italic\">Recursive types</span>",false],
["recursive-contract",">reference/contract-utilities.html#(form._((lib._racket/contract/private/base..rkt)._recursive-contract))",[0,[1,"recursive-contract"]],["racket/contract/base","racket/contract","racket"]],
["recycle-icon",">images/Icons.html#(def._((lib._images/icons/symbol..rkt)._recycle-icon))",[0,[2,"recycle-icon"]],["images/icons/symbol"]],
["recycling icon",">drracket/interface-essentials.html#(idx._(gentag._0._(lib._scribblings/drracket/drracket..scrbl)))","recycling icon",false],
["red",">draw/color_.html#(meth._(((lib._racket/draw..rkt)._color~25)._red))",[[0,[2,"red"]],[14,[" (method of ",[0,[2,"color%"]],")"]]],["racket/draw"]],
["red",">unstable/pict.html#(def._((lib._unstable/gui/pict..rkt)._red))",[0,[2,"red"]],["unstable/gui/pict"]],
["redex",">redex/The_Redex_Reference.html",[9,[0,"redex"]],"module"],
["redex",">reference/eval-model.html#(tech._redex)","<span style=\"font-style: italic\">redex</span>",false],
["redex pattern variable-prefix",">redex/The_Redex_Reference.html#(idx._(gentag._8._(lib._redex/redex..scrbl)))","Redex Pattern, variable-prefix",false],
["redex pattern variable-not-otherwise-mentioned",">redex/The_Redex_Reference.html#(idx._(gentag._9._(lib._redex/redex..scrbl)))","Redex Pattern, variable-not-otherwise-mentioned",false],
["redex pattern variable-except",">redex/The_Redex_Reference.html#(idx._(gentag._7._(lib._redex/redex..scrbl)))","Redex Pattern, variable-except",false],
["redex pattern variable",">redex/The_Redex_Reference.html#(idx._(gentag._6._(lib._redex/redex..scrbl)))","Redex Pattern, variable",false],
["redex pattern symbol",">redex/The_Redex_Reference.html#(idx._(gentag._11._(lib._redex/redex..scrbl)))","Redex Pattern, symbol",false],
["redex pattern string",">redex/The_Redex_Reference.html#(idx._(gentag._5._(lib._redex/redex..scrbl)))","Redex Pattern, string",false],
["redex pattern side-condition",">redex/The_Redex_Reference.html#(idx._(gentag._15._(lib._redex/redex..scrbl)))","Redex Pattern, side-condition",false],
["redex pattern real",">redex/The_Redex_Reference.html#(idx._(gentag._4._(lib._redex/redex..scrbl)))","Redex Pattern, real",false],
["redex pattern pattern-sequence",">redex/The_Redex_Reference.html#(idx._(gentag._17._(lib._redex/redex..scrbl)))","Redex Pattern, pattern-sequence",false],
["redex pattern number",">redex/The_Redex_Reference.html#(idx._(gentag._1._(lib._redex/redex..scrbl)))","Redex Pattern, number",false],
["redex pattern natural",">redex/The_Redex_Reference.html#(idx._(gentag._2._(lib._redex/redex..scrbl)))","Redex Pattern, natural",false],
["redex pattern name",">redex/The_Redex_Reference.html#(idx._(gentag._12._(lib._redex/redex..scrbl)))","Redex Pattern, name",false],
["redex pattern integer",">redex/The_Redex_Reference.html#(idx._(gentag._3._(lib._redex/redex..scrbl)))","Redex Pattern, integer",false],
["redex pattern in-hole",">redex/The_Redex_Reference.html#(idx._(gentag._13._(lib._redex/redex..scrbl)))","Redex Pattern, in-hole",false],
["redex pattern hole",">redex/The_Redex_Reference.html#(idx._(gentag._10._(lib._redex/redex..scrbl)))","Redex Pattern, hole",false],
["redex pattern hide-hole",">redex/The_Redex_Reference.html#(idx._(gentag._14._(lib._redex/redex..scrbl)))","Redex Pattern, hide-hole",false],
["redex pattern cross",">redex/The_Redex_Reference.html#(idx._(gentag._16._(lib._redex/redex..scrbl)))","Redex Pattern, cross",false],
["redex pattern any",">redex/The_Redex_Reference.html#(idx._(gentag._0._(lib._redex/redex..scrbl)))","Redex Pattern, any",false],
["redex-check",">redex/The_Redex_Reference.html#(form._((lib._redex/reduction-semantics..rkt)._redex-check))",[0,[1,"redex-check"]],["redex/reduction-semantics","redex"]],
["redex-let",">redex/The_Redex_Reference.html#(form._((lib._redex/reduction-semantics..rkt)._redex-let))",[0,[1,"redex-let"]],["redex/reduction-semantics","redex"]],
["redex-let*",">redex/The_Redex_Reference.html#(form._((lib._redex/reduction-semantics..rkt)._redex-let*))",[0,[1,"redex-let*"]],["redex/reduction-semantics","redex"]],
["redex-match",">redex/The_Redex_Reference.html#(form._((lib._redex/reduction-semantics..rkt)._redex-match))",[0,[1,"redex-match"]],["redex/reduction-semantics","redex"]],
["redex-match?",">redex/The_Redex_Reference.html#(form._((lib._redex/reduction-semantics..rkt)._redex-match~3f))",[0,[1,"redex-match?"]],["redex/reduction-semantics","redex"]],
["redex-pseudo-random-generator",">redex/The_Redex_Reference.html#(def._((lib._redex/reduction-semantics..rkt)._redex-pseudo-random-generator))",[0,[2,"redex-pseudo-random-generator"]],["redex/reduction-semantics","redex"]],
["redex/gui",">redex/The_Redex_Reference.html#(mod-path._redex/gui)",[9,[0,"redex/gui"]],"module"],
["redex/pict",">redex/The_Redex_Reference.html#(mod-path._redex/pict)",[9,[0,"redex/pict"]],"module"],
["redex/reduction-semantics",">redex/The_Redex_Reference.html#(mod-path._redex/reduction-semantics)",[9,[0,"redex/reduction-semantics"]],"module"],
["redex: practical semantics engineering",">redex/index.html","Redex: Practical Semantics Engineering",false],
["redirect",">web-server/http.html#(part._redirect)","Redirect",false],
["redirect-target-element",">scribble/core.html#(def._((lib._scribble/core..rkt)._redirect-target-element))",[0,[2,"redirect-target-element"]],["scribble/core"]],
["redirect-target-element-alt-anchor",">scribble/core.html#(def._((lib._scribble/core..rkt)._redirect-target-element-alt-anchor))",[0,[2,"redirect-target-element-alt-anchor"]],["scribble/core"]],
["redirect-target-element-alt-path",">scribble/core.html#(def._((lib._scribble/core..rkt)._redirect-target-element-alt-path))",[0,[2,"redirect-target-element-alt-path"]],["scribble/core"]],
["redirect-target-element?",">scribble/core.html#(def._((lib._scribble/core..rkt)._redirect-target-element~3f))",[0,[2,"redirect-target-element?"]],["scribble/core"]],
["redirect-to",">web-server/http.html#(def._((lib._web-server/http/redirect..rkt)._redirect-to))",[0,[2,"redirect-to"]],["web-server/http/redirect"]],
["redirect/get",">continue/index.html#(def._((lib._web-server/servlet..rkt)._redirect/get))",[0,[2,"redirect/get"]],[]],
["redirect/get",">web-server/stateless.html#(def._((lib._web-server/lang/web..rkt)._redirect/get))",[0,[2,"redirect/get"]],["web-server/lang/web"]],
["redirect/get",">web-server/servlet.html#(def._((lib._web-server/servlet/web..rkt)._redirect/get))",[0,[2,"redirect/get"]],["web-server/servlet/web"]],
["redirect/get/forget",">web-server/servlet.html#(def._((lib._web-server/servlet/web..rkt)._redirect/get/forget))",[0,[2,"redirect/get/forget"]],["web-server/servlet/web"]],
["redirection-status?",">web-server/http.html#(def._((lib._web-server/http/redirect..rkt)._redirection-status~3f))",[0,[2,"redirection-status?"]],["web-server/http/redirect"]],
["redo",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._redo))",[[0,[2,"redo"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["redo menu item",">drracket/Menus.html#(idx._(gentag._72._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Redo</span> menu item",false],
["reduce",">srfi-std/srfi-1.html#reduce",[0,[2,"reduce"]],["srfi/1"]],
["reduce-right",">srfi-std/srfi-1.html#reduce-right",[0,[2,"reduce-right"]],["srfi/1"]],
["reduction relations",">redex/The_Redex_Reference.html#(part._.Reduction_.Relations)","Reduction Relations",false],
["reduction-relation",">redex/The_Redex_Reference.html#(form._((lib._redex/reduction-semantics..rkt)._reduction-relation))",[0,[1,"reduction-relation"]],["redex/reduction-semantics","redex"]],
["reduction-relation->pict",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._reduction-relation-~3epict))",[0,[2,"reduction-relation->pict"]],["redex/pict","redex"]],
["reduction-relation->rule-names",">redex/The_Redex_Reference.html#(def._((lib._redex/reduction-semantics..rkt)._reduction-relation-~3erule-names))",[0,[2,"reduction-relation->rule-names"]],["redex/reduction-semantics","redex"]],
["reduction-relation-rule-separation",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._reduction-relation-rule-separation))",[0,[2,"reduction-relation-rule-separation"]],["redex/pict","redex"]],
["reduction-relation?",">redex/The_Redex_Reference.html#(def._((lib._redex/reduction-semantics..rkt)._reduction-relation~3f))",[0,[2,"reduction-relation?"]],["redex/reduction-semantics","redex"]],
["reduction-rule-style/c",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._reduction-rule-style/c))",[0,[2,"reduction-rule-style/c"]],["redex/pict","redex"]],
["reduction-steps-cutoff",">redex/The_Redex_Reference.html#(def._((lib._redex/gui..rkt)._reduction-steps-cutoff))",[0,[2,"reduction-steps-cutoff"]],["redex/gui","redex"]],
["reencode-input-port",">reference/port-lib.html#(def._((lib._racket/port..rkt)._reencode-input-port))",[0,[2,"reencode-input-port"]],["racket/port","racket"]],
["reencode-output-port",">reference/port-lib.html#(def._((lib._racket/port..rkt)._reencode-output-port))",[0,[2,"reencode-output-port"]],["racket/port","racket"]],
["refinement",">ts-reference/Experimental_Features.html#(form._((lib._typed-racket/base-env/base-types-extra..rkt)._.Refinement))",[0,[1,"Refinement"]],["typed/racket/base","typed/racket"]],
["reflect-horiz",">picturing-programs/index.html#(def._((lib._picturing-programs/private/tiles..rkt)._reflect-horiz))",[0,[2,"reflect-horiz"]],["picturing-programs/private/tiles","picturing-programs"]],
["reflect-main-diag",">picturing-programs/index.html#(def._((lib._picturing-programs/private/tiles..rkt)._reflect-main-diag))",[0,[2,"reflect-main-diag"]],["picturing-programs/private/tiles","picturing-programs"]],
["reflect-other-diag",">picturing-programs/index.html#(def._((lib._picturing-programs/private/tiles..rkt)._reflect-other-diag))",[0,[2,"reflect-other-diag"]],["picturing-programs/private/tiles","picturing-programs"]],
["reflect-vert",">picturing-programs/index.html#(def._((lib._picturing-programs/private/tiles..rkt)._reflect-vert))",[0,[2,"reflect-vert"]],["picturing-programs/private/tiles","picturing-programs"]],
["reflecting on primitives",">reference/procedures.html#(part._.Reflecting_on_.Primitives)","Reflecting on Primitives",false],
["reflection",">syntax/Experimental.html#(part._.Reflection)","Reflection",false],
["reflection and dynamic evaluation",">guide/reflection.html","Reflection and Dynamic Evaluation",false],
["reflection and security",">reference/security.html","Reflection and Security",false],
["reflow-container",">gui/area-container___.html#(meth._(((lib._mred/main..rkt)._area-container~3c~25~3e)._reflow-container))",[[0,[2,"reflow-container"]],[14,[" (method of ",[0,[2,"area-container<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["refocus",">slideshow/Bounding_Box_Adjusters.html#(def._((lib._slideshow/pict..rkt)._refocus))",[0,[2,"refocus"]],["slideshow/pict","slideshow"]],
["refpoint-placer?",">unstable/ppict.html#(def._((lib._unstable/gui/ppict..rkt)._refpoint-placer~3f))",[0,[2,"refpoint-placer?"]],["unstable/gui/ppict"]],
["refresh",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._refresh))",[[0,[2,"refresh"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["refresh",">gui/window___.html#(meth._(((lib._mred/main..rkt)._window~3c~25~3e)._refresh))",[[0,[2,"refresh"]],[14,[" (method of ",[0,[2,"window<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["refresh-delayed?",">gui/editor-admin_.html#(meth._(((lib._mred/main..rkt)._editor-admin~25)._refresh-delayed~3f))",[[0,[2,"refresh-delayed?"]],[14,[" (method of ",[0,[2,"editor-admin%"]],")"]]],["racket/gui/base","racket/gui"]],
["refresh-delayed?",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._refresh-delayed~3f))",[[0,[2,"refresh-delayed?"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["refresh-now",">gui/canvas_.html#(meth._(((lib._mred/main..rkt)._canvas~25)._refresh-now))",[[0,[2,"refresh-now"]],[14,[" (method of ",[0,[2,"canvas%"]],")"]]],["racket/gui/base","racket/gui"]],
["refresh-splash",">framework/Splash.html#(def._((lib._framework/splash..rkt)._refresh-splash))",[0,[2,"refresh-splash"]],["framework/splash"]],
["regexp",">reference/regexp.html#(def._((quote._~23~25kernel)._regexp))",[0,[2,"regexp"]],["racket/base","racket"]],
["regexp",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Regexp))",[0,[1,"Regexp"]],["typed/racket/base","typed/racket"]],
["regexp",">guide/regexp.html#(tech._regexp)","<span style=\"font-style: italic\">regexp</span>",false],
["regexp constructors",">reference/regexp.html#(part._.Regexp_.Constructors)","Regexp Constructors",false],
["regexp matching",">reference/regexp.html#(part._.Regexp_.Matching)","Regexp Matching",false],
["regexp splitting",">reference/regexp.html#(part._.Regexp_.Splitting)","Regexp Splitting",false],
["regexp substitution",">reference/regexp.html#(part._.Regexp_.Substitution)","Regexp Substitution",false],
["regexp syntax",">reference/regexp.html#(part._regexp-syntax)","Regexp Syntax",false],
["regexp value",">reference/regexp.html#(tech._regexp._value)","<span style=\"font-style: italic\">regexp value</span>",false],
["regexp-exec",">mzlib/mzlib_awk.html#(def._((lib._mzlib/awk..rkt)._regexp-exec))",[0,[2,"regexp-exec"]],["mzlib/awk"]],
["regexp-filter",">unstable/string.html#(def._((lib._unstable/string..rkt)._regexp-filter))",[0,[2,"regexp-filter"]],["unstable/string"]],
["regexp-match",">reference/regexp.html#(def._((quote._~23~25kernel)._regexp-match))",[0,[2,"regexp-match"]],["racket/base","racket"]],
["regexp-match*",">reference/regexp.html#(def._((lib._racket/private/base..rkt)._regexp-match*))",[0,[2,"regexp-match*"]],["racket/base","racket"]],
["regexp-match-evt",">reference/port-lib.html#(def._((lib._racket/port..rkt)._regexp-match-evt))",[0,[2,"regexp-match-evt"]],["racket/port","racket"]],
["regexp-match-exact?",">reference/regexp.html#(def._((lib._racket/private/base..rkt)._regexp-match-exact~3f))",[0,[2,"regexp-match-exact?"]],["racket/base","racket"]],
["regexp-match-peek",">reference/regexp.html#(def._((quote._~23~25kernel)._regexp-match-peek))",[0,[2,"regexp-match-peek"]],["racket/base","racket"]],
["regexp-match-peek-immediate",">reference/regexp.html#(def._((quote._~23~25kernel)._regexp-match-peek-immediate))",[0,[2,"regexp-match-peek-immediate"]],["racket/base","racket"]],
["regexp-match-peek-positions",">reference/regexp.html#(def._((quote._~23~25kernel)._regexp-match-peek-positions))",[0,[2,"regexp-match-peek-positions"]],["racket/base","racket"]],
["regexp-match-peek-positions*",">reference/regexp.html#(def._((lib._racket/private/base..rkt)._regexp-match-peek-positions*))",[0,[2,"regexp-match-peek-positions*"]],["racket/base","racket"]],
["regexp-match-peek-positions-immediate",">reference/regexp.html#(def._((quote._~23~25kernel)._regexp-match-peek-positions-immediate))",[0,[2,"regexp-match-peek-positions-immediate"]],["racket/base","racket"]],
["regexp-match-peek-positions-immediate/end",">reference/regexp.html#(def._((quote._~23~25kernel)._regexp-match-peek-positions-immediate/end))",[0,[2,"regexp-match-peek-positions-immediate/end"]],["racket/base","racket"]],
["regexp-match-peek-positions/end",">reference/regexp.html#(def._((quote._~23~25kernel)._regexp-match-peek-positions/end))",[0,[2,"regexp-match-peek-positions/end"]],["racket/base","racket"]],
["regexp-match-positions",">reference/regexp.html#(def._((quote._~23~25kernel)._regexp-match-positions))",[0,[2,"regexp-match-positions"]],["racket/base","racket"]],
["regexp-match-positions*",">reference/regexp.html#(def._((lib._racket/private/base..rkt)._regexp-match-positions*))",[0,[2,"regexp-match-positions*"]],["racket/base","racket"]],
["regexp-match-positions/end",">reference/regexp.html#(def._((quote._~23~25kernel)._regexp-match-positions/end))",[0,[2,"regexp-match-positions/end"]],["racket/base","racket"]],
["regexp-match/end",">reference/regexp.html#(def._((quote._~23~25kernel)._regexp-match/end))",[0,[2,"regexp-match/end"]],["racket/base","racket"]],
["regexp-match?",">reference/regexp.html#(def._((quote._~23~25kernel)._regexp-match~3f))",[0,[2,"regexp-match?"]],["racket/base","racket"]],
["regexp-max-lookbehind",">reference/regexp.html#(def._((quote._~23~25kernel)._regexp-max-lookbehind))",[0,[2,"regexp-max-lookbehind"]],["racket/base","racket"]],
["regexp-quote",">reference/regexp.html#(def._((lib._racket/private/base..rkt)._regexp-quote))",[0,[2,"regexp-quote"]],["racket/base","racket"]],
["regexp-replace",">reference/regexp.html#(def._((quote._~23~25kernel)._regexp-replace))",[0,[2,"regexp-replace"]],["racket/base","racket"]],
["regexp-replace*",">reference/regexp.html#(def._((lib._racket/private/base..rkt)._regexp-replace*))",[0,[2,"regexp-replace*"]],["racket/base","racket"]],
["regexp-replace-quote",">reference/regexp.html#(def._((lib._racket/private/base..rkt)._regexp-replace-quote))",[0,[2,"regexp-replace-quote"]],["racket/base","racket"]],
["regexp-replaces",">reference/regexp.html#(def._((lib._racket/private/base..rkt)._regexp-replaces))",[0,[2,"regexp-replaces"]],["racket/base","racket"]],
["regexp-split",">reference/regexp.html#(def._((lib._racket/private/base..rkt)._regexp-split))",[0,[2,"regexp-split"]],["racket/base","racket"]],
["regexp-try-match",">reference/regexp.html#(def._((lib._racket/private/base..rkt)._regexp-try-match))",[0,[2,"regexp-try-match"]],["racket/base","racket"]],
["regexp?",">reference/regexp.html#(def._((quote._~23~25kernel)._regexp~3f))",[0,[2,"regexp?"]],["racket/base","racket"]],
["regexps",">reference/regexp.html","regexps",false],
["region",">cards/index.html#(def._((lib._games/cards..rkt)._region))",[0,[2,"region"]],["games/cards"]],
["region%",">draw/region_.html",[0,[2,"region%"]],["racket/draw"]],
["region-callback",">cards/index.html#(def._((lib._games/cards..rkt)._region-callback))",[0,[2,"region-callback"]],["games/cards"]],
["region-h",">cards/index.html#(def._((lib._games/cards..rkt)._region-h))",[0,[2,"region-h"]],["games/cards"]],
["region-interactive-callback",">cards/index.html#(def._((lib._games/cards..rkt)._region-interactive-callback))",[0,[2,"region-interactive-callback"]],["games/cards"]],
["region-label",">cards/index.html#(def._((lib._games/cards..rkt)._region-label))",[0,[2,"region-label"]],["games/cards"]],
["region-w",">cards/index.html#(def._((lib._games/cards..rkt)._region-w))",[0,[2,"region-w"]],["games/cards"]],
["region-x",">cards/index.html#(def._((lib._games/cards..rkt)._region-x))",[0,[2,"region-x"]],["games/cards"]],
["region-y",">cards/index.html#(def._((lib._games/cards..rkt)._region-y))",[0,[2,"region-y"]],["games/cards"]],
["region?",">cards/index.html#(def._((lib._games/cards..rkt)._region~3f))",[0,[2,"region?"]],["games/cards"]],
["regions and buttons",">cards/index.html#(part._.Regions_and_.Buttons)","Regions and Buttons",false],
["register",">reference/distributed-places.html#(meth._(((lib._racket/place/distributed..rkt)._event-container~3c~25~3e)._register))",[[0,[2,"register"]],[14,[" (method of ",[0,[2,"event-container<%>"]],")"]]],["racket/place/distributed"]],
["register",">teachpack/2htdpuniverse.html#(form._((lib._2htdp/universe..rkt)._register))",[0,[1,"register"]],["2htdp/universe"]],
["register-capability-menu-item",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aframe~3c~25~3e)._register-capability-menu-item))",[[0,[2,"register-capability-menu-item"]],[14,[" (method of ",[0,[2,"drracket:unit:frame<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["register-collecting-blit",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._register-collecting-blit))",[0,[2,"register-collecting-blit"]],["racket/gui/base","racket/gui"]],
["register-external-file",">raco/make.html#(def._((lib._compiler/cm-accomplice..rkt)._register-external-file))",[0,[2,"register-external-file"]],["compiler/cm-accomplice"]],
["register-finalizer",">foreign/foreign_pointer-funcs.html#(def._((lib._ffi/unsafe..rkt)._register-finalizer))",[0,[2,"register-finalizer"]],["ffi/unsafe"]],
["register-lib-mapping!",">gui/WXME_Decoding.html#(def._((lib._wxme/main..rkt)._register-lib-mapping!))",[0,[2,"register-lib-mapping!"]],["wxme"]],
["register-profile-done",">errortrace/stacktrace.html#(sig-val._((lib._errortrace/stacktrace..rkt)._stacktrace-imports~5e._register-profile-done))",[0,[2,"register-profile-done"]],["errortrace/stacktrace"]],
["register-profile-start",">errortrace/stacktrace.html#(sig-val._((lib._errortrace/stacktrace..rkt)._stacktrace-imports~5e._register-profile-start))",[0,[2,"register-profile-start"]],["errortrace/stacktrace"]],
["register-toolbar-button",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aframe~3c~25~3e)._register-toolbar-button))",[[0,[2,"register-toolbar-button"]],[14,[" (method of ",[0,[2,"drracket:unit:frame<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["register-toolbar-buttons",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aframe~3c~25~3e)._register-toolbar-buttons))",[[0,[2,"register-toolbar-buttons"]],[14,[" (method of ",[0,[2,"drracket:unit:frame<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["regular expressions",">guide/regexp.html","Regular Expressions",false],
["regular expressions",">reference/regexp.html","Regular Expressions",false],
["regular expressions",">unstable/Automata__Compiling_State_Machines.html#(part._re)","Regular Expressions",false],
["regular expressions",">reference/regexp.html#(tech._regular._expression)","<span style=\"font-style: italic\">Regular expressions</span>",false],
["regular-poly",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtle-examples..rkt)._regular-poly))",[0,[2,"regular-poly"]],["graphics/turtle-examples"]],
["regular-poly",">turtles/Value_Turtles.html#(def._((lib._graphics/value-turtles-examples..rkt)._regular-poly))",[0,"regular-poly"],["graphics/value-turtles-examples"]],
["regular-polygon",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._regular-polygon))",[0,[2,"regular-polygon"]],["2htdp/image"]],
["regular-polygon",">teachpack/image.html#(def._((lib._htdp/image..rkt)._regular-polygon))",[0,[2,"regular-polygon"]],["htdp/image"]],
["regular-polygon-icon",">images/Icons.html#(def._((lib._images/icons/misc..rkt)._regular-polygon-icon))",[0,[2,"regular-polygon-icon"]],["images/icons/misc"]],
["regular-polys",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtle-examples..rkt)._regular-polys))",[0,[2,"regular-polys"]],["graphics/turtle-examples"]],
["regular-polys",">turtles/Value_Turtles.html#(def._((lib._graphics/value-turtles-examples..rkt)._regular-polys))",[0,"regular-polys"],["graphics/value-turtles-examples"]],
["reified-splicing-syntax-class?",">syntax/Experimental.html#(def._((lib._syntax/parse/experimental/reflect..rkt)._reified-splicing-syntax-class~3f))",[0,[2,"reified-splicing-syntax-class?"]],["syntax/parse/experimental/reflect"]],
["reified-syntax-class-arity",">syntax/Experimental.html#(def._((lib._syntax/parse/experimental/reflect..rkt)._reified-syntax-class-arity))",[0,[2,"reified-syntax-class-arity"]],["syntax/parse/experimental/reflect"]],
["reified-syntax-class-attributes",">syntax/Experimental.html#(def._((lib._syntax/parse/experimental/reflect..rkt)._reified-syntax-class-attributes))",[0,[2,"reified-syntax-class-attributes"]],["syntax/parse/experimental/reflect"]],
["reified-syntax-class-curry",">syntax/Experimental.html#(def._((lib._syntax/parse/experimental/reflect..rkt)._reified-syntax-class-curry))",[0,[2,"reified-syntax-class-curry"]],["syntax/parse/experimental/reflect"]],
["reified-syntax-class-keywords",">syntax/Experimental.html#(def._((lib._syntax/parse/experimental/reflect..rkt)._reified-syntax-class-keywords))",[0,[2,"reified-syntax-class-keywords"]],["syntax/parse/experimental/reflect"]],
["reified-syntax-class?",">syntax/Experimental.html#(def._((lib._syntax/parse/experimental/reflect..rkt)._reified-syntax-class~3f))",[0,[2,"reified-syntax-class?"]],["syntax/parse/experimental/reflect"]],
["reify-syntax-class",">syntax/Experimental.html#(form._((lib._syntax/parse/experimental/reflect..rkt)._reify-syntax-class))",[0,[1,"reify-syntax-class"]],["syntax/parse/experimental/reflect"]],
["reindent all menu item",">drracket/Menus.html#(idx._(gentag._131._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Reindent All</span> menu item",false],
["reindent menu item",">drracket/Menus.html#(idx._(gentag._130._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Reindent</span> menu item",false],
["reindex-user-documentation",">raco/_plt-archives.html#(def._((lib._setup/plt-single-installer..rkt)._reindex-user-documentation))",[0,[2,"reindex-user-documentation"]],["setup/plt-single-installer"]],
["related web sites menu item",">drracket/Menus.html#(idx._(gentag._149._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Related Web Sites</span> menu item",false],
["relation->pict",">redex/The_Redex_Reference.html#(form._((lib._redex/pict..rkt)._relation-~3epict))",[0,[1,"relation->pict"]],["redex/pict","redex"]],
["relation-clauses-combine",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._relation-clauses-combine))",[0,[2,"relation-clauses-combine"]],["redex/pict","redex"]],
["relation-coverage",">redex/The_Redex_Reference.html#(def._((lib._redex/reduction-semantics..rkt)._relation-coverage))",[0,[2,"relation-coverage"]],["redex/reduction-semantics","redex"]],
["relations",">racklog/glossary.html#(part._.Relations)","Relations",false],
["relative",">reference/Manipulating_Paths.html#(idx._(gentag._238._(lib._scribblings/reference/reference..scrbl)))",[7,"'relative"],false],
["relative-in",">reference/require.html#(form._((lib._racket/private/base..rkt)._relative-in))",[0,[1,"relative-in"]],["racket/base","racket"]],
["relative-path?",">reference/Manipulating_Paths.html#(def._((quote._~23~25kernel)._relative-path~3f))",[0,[2,"relative-path?"]],["racket/base","racket"]],
["release",">foreign/com-intf.html#(def._((lib._ffi/unsafe/com..rkt)._.Release))",[0,[2,"Release"]],["ffi/unsafe/com"]],
["release",">gui/key-event_.html#(idx._(gentag._111._(lib._scribblings/gui/gui..scrbl)))",[7,"'release"],false],
["release notes",">rackunit/Release_Notes.html","Release Notes",false],
["release notes",">release/index.html","Release Notes",false],
["release-from-owner",">gui/snip_.html#(meth._(((lib._racket/snip..rkt)._snip~25)._release-from-owner))",[[0,[2,"release-from-owner"]],[14,[" (method of ",[0,[2,"snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["release-notes",">planet/Developing_Packages_for_PLaneT.html#(idx._(gentag._2._(lib._planet/planet..scrbl)))",[7,"'release-notes"],false],
["release-snip",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._release-snip))",[[0,[2,"release-snip"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["release-snip",">gui/snip-admin_.html#(meth._(((lib._racket/snip..rkt)._snip-admin~25)._release-snip))",[[0,[2,"release-snip"]],[14,[" (method of ",[0,[2,"snip-admin%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["releaser",">foreign/Allocation_and_Finalization.html#(def._((lib._ffi/unsafe/alloc..rkt)._releaser))",[0,[2,"releaser"]],["ffi/unsafe/alloc"]],
["reliable release of resources",">foreign/intro.html#(part._.Reliable_.Release_of_.Resources)","Reliable Release of Resources",false],
["reload",">browser/index.html#(meth._(((lib._browser/browser..rkt)._hyper-panel-mixin)._reload))",[[0,[2,"reload"]],[14,[" (method of ",[0,[2,"hyper-panel-mixin"]],")"]]],["browser/browser","browser"]],
["reload",">browser/index.html#(meth._(((lib._browser/browser..rkt)._hyper-text-mixin)._reload))",[[0,[2,"reload"]],[14,[" (method of ",[0,[2,"hyper-text-mixin"]],")"]]],["browser/browser","browser"]],
["relocate-input-port",">reference/port-lib.html#(def._((lib._racket/port..rkt)._relocate-input-port))",[0,[2,"relocate-input-port"]],["racket/port","racket"]],
["relocate-output-port",">reference/port-lib.html#(def._((lib._racket/port..rkt)._relocate-output-port))",[0,[2,"relocate-output-port"]],["racket/port","racket"]],
["remainder",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._remainder))",[0,[2,"remainder"]],["racket/base","racket"]],
["remainder",">r5rs-std/r5rs-Z-H-9.html#%_idx_302",[0,[2,"remainder"]],["r5rs"]],
["remainder",">r6rs-lib-std/r6rs-lib-Z-H-20.html#node_idx_1292",[0,[2,"remainder"]],["rnrs/r5rs-6"]],
["remainder",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._remainder))",[0,[2,"remainder"]],["lang/htdp-advanced"]],
["remainder",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._remainder))",[0,[2,"remainder"]],["lang/htdp-beginner"]],
["remainder",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._remainder))",[0,[2,"remainder"]],["lang/htdp-beginner-abbr"]],
["remainder",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._remainder))",[0,[2,"remainder"]],["lang/htdp-intermediate"]],
["remainder",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._remainder))",[0,[2,"remainder"]],["lang/htdp-intermediate-lambda"]],
["remainder",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._remainder))",[0,[2,"remainder"]],["deinprogramm/DMdA-advanced"]],
["remainder",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._remainder))",[0,[2,"remainder"]],["deinprogramm/DMdA-assignments"]],
["remainder",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._remainder))",[0,[2,"remainder"]],["deinprogramm/DMdA-beginner"]],
["remainder",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._remainder))",[0,[2,"remainder"]],["deinprogramm/DMdA-vanilla"]],
["remap-url",">browser/index.html#(meth._(((lib._browser/browser..rkt)._hyper-text-mixin)._remap-url))",[[0,[2,"remap-url"]],[14,[" (method of ",[0,[2,"hyper-text-mixin"]],")"]]],["browser/browser","browser"]],
["remf",">unstable/list.html#(def._((lib._unstable/list..rkt)._remf))",[0,[2,"remf"]],["unstable/list"]],
["remote com servers (dcom)",">foreign/com-auto.html#(part._remote)","Remote COM servers (DCOM)",false],
["remote-connect",">reference/distributed-places.html#(meth._(((lib._racket/place/distributed..rkt)._remote-node~25)._remote-connect))",[[0,[2,"remote-connect"]],[14,[" (method of ",[0,[2,"remote-node%"]],")"]]],["racket/place/distributed"]],
["remote-connection%",">reference/distributed-places.html#(def._((lib._racket/place/distributed..rkt)._remote-connection~25))",[0,[2,"remote-connection%"]],["racket/place/distributed"]],
["remote-node%",">reference/distributed-places.html#(def._((lib._racket/place/distributed..rkt)._remote-node~25))",[0,[2,"remote-node%"]],["racket/place/distributed"]],
["remove",">planet/cmdline.html#(part._remove)",[6,"remove"],false],
["remove",">reference/pairs.html#(def._((lib._racket/private/list..rkt)._remove))",[0,[2,"remove"]],["racket/base","racket"]],
["remove",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._remove))",[[0,[2,"remove"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["remove",">r6rs-lib-std/r6rs-lib-Z-H-4.html#node_idx_218",[0,[2,"remove"]],["rnrs/lists-6"]],
["remove",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._remove))",[0,[2,"remove"]],["lang/htdp-advanced"]],
["remove",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._remove))",[0,[2,"remove"]],["lang/htdp-beginner"]],
["remove",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._remove))",[0,[2,"remove"]],["lang/htdp-beginner-abbr"]],
["remove",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._remove))",[0,[2,"remove"]],["lang/htdp-intermediate"]],
["remove",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._remove))",[0,[2,"remove"]],["lang/htdp-intermediate-lambda"]],
["remove",">lazy/index.html#(def._((lib._lazy/main..rkt)._remove))",[0,[2,"remove"]],["lazy"]],
["remove",">srfi-std/srfi-1.html#remove",[0,[2,"remove"]],["srfi/1"]],
["remove!",">srfi-std/srfi-1.html#remove!",[0,[2,"remove!"]],["srfi/1"]],
["remove*",">reference/pairs.html#(def._((lib._racket/private/list..rkt)._remove*))",[0,[2,"remove*"]],["racket/base","racket"]],
["remove*",">lazy/index.html#(def._((lib._lazy/main..rkt)._remove*))",[0,[2,"remove*"]],["lazy"]],
["remove-all-listeners",">unstable/gui-notify.html#(meth._(((lib._unstable/gui/notify..rkt)._notify-box~25)._remove-all-listeners))",[[0,[2,"remove-all-listeners"]],[14,[" (method of ",[0,[2,"notify-box%"]],")"]]],["unstable/gui/notify"]],
["remove-autosave",">framework/Editor.html#(meth._(((lib._framework/main..rkt)._editor~3abackup-autosave~3c~25~3e)._remove-autosave))",[[0,[2,"remove-autosave"]],[14,[" (method of ",[0,[2,"editor:backup-autosave<%>"]],")"]]],["framework"]],
["remove-bkg-running-color",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3atab~3c~25~3e)._remove-bkg-running-color))",[[0,[2,"remove-bkg-running-color"]],[14,[" (method of ",[0,[2,"drracket:unit:tab<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["remove-boundary",">gui/editor-stream-in_.html#(meth._(((lib._mred/main..rkt)._editor-stream-in~25)._remove-boundary))",[[0,[2,"remove-boundary"]],[14,[" (method of ",[0,[2,"editor-stream-in%"]],")"]]],["racket/gui/base","racket/gui"]],
["remove-canvas",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._remove-canvas))",[[0,[2,"remove-canvas"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["remove-card",">cards/index.html#(meth._(((lib._games/cards..rkt)._table~3c~25~3e)._remove-card))",[[0,[2,"remove-card"]],[14,[" (method of ",[0,[2,"table<%>"]],")"]]],["games/cards"]],
["remove-cards",">cards/index.html#(meth._(((lib._games/cards..rkt)._table~3c~25~3e)._remove-cards))",[[0,[2,"remove-cards"]],[14,[" (method of ",[0,[2,"table<%>"]],")"]]],["games/cards"]],
["remove-chained-keymap",">gui/keymap_.html#(meth._(((lib._mred/main..rkt)._keymap~25)._remove-chained-keymap))",[[0,[2,"remove-chained-keymap"]],[14,[" (method of ",[0,[2,"keymap%"]],")"]]],["racket/gui/base","racket/gui"]],
["remove-chained-keymap",">framework/Keymap.html#(meth._(((lib._framework/main..rkt)._keymap~3aaug-keymap-mixin)._remove-chained-keymap))",[[0,[2,"remove-chained-keymap"]],[14,[" (method of ",[0,[2,"keymap:aug-keymap-mixin"]],")"]]],["framework"]],
["remove-child",">mrlib/graph-snip___.html#(meth._(((lib._mrlib/graph..rkt)._graph-snip~3c~25~3e)._remove-child))",[[0,[2,"remove-child"]],[14,[" (method of ",[0,[2,"graph-snip<%>"]],")"]]],["mrlib/graph"]],
["remove-clickback",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._remove-clickback))",[[0,[2,"remove-clickback"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["remove-duplicates",">reference/pairs.html#(def._((lib._racket/list..rkt)._remove-duplicates))",[0,[2,"remove-duplicates"]],["racket/list","racket"]],
["remove-field",">net/head.html#(def._((lib._net/head..rkt)._remove-field))",[0,[2,"remove-field"]],["net/head"]],
["remove-frame",">framework/Group.html#(meth._(((lib._framework/main..rkt)._group~3a~25)._remove-frame))",[[0,[2,"remove-frame"]],[14,[" (method of ",[0,[2,"group:%"]],")"]]],["framework"]],
["remove-grab-key-function",">gui/keymap_.html#(meth._(((lib._mred/main..rkt)._keymap~25)._remove-grab-key-function))",[[0,[2,"remove-grab-key-function"]],[14,[" (method of ",[0,[2,"keymap%"]],")"]]],["racket/gui/base","racket/gui"]],
["remove-grab-mouse-function",">gui/keymap_.html#(meth._(((lib._mred/main..rkt)._keymap~25)._remove-grab-mouse-function))",[[0,[2,"remove-grab-mouse-function"]],[14,[" (method of ",[0,[2,"keymap%"]],")"]]],["racket/gui/base","racket/gui"]],
["remove-hard-link",">planet/Utility_Libraries.html#(def._((lib._planet/util..rkt)._remove-hard-link))",[0,[2,"remove-hard-link"]],["planet/util"]],
["remove-heads-up",">gl-board-game/index.html#(meth._(((lib._games/gl-board-game..rkt)._gl-board~25)._remove-heads-up))",[[0,[2,"remove-heads-up"]],[14,[" (method of ",[0,[2,"gl-board%"]],")"]]],["games/gl-board-game"]],
["remove-links",">mrlib/Graph_Functions.html#(def._((lib._mrlib/graph..rkt)._remove-links))",[0,[2,"remove-links"]],["mrlib/graph"]],
["remove-listener",">unstable/gui-notify.html#(meth._(((lib._unstable/gui/notify..rkt)._notify-box~25)._remove-listener))",[[0,[2,"remove-listener"]],[14,[" (method of ",[0,[2,"notify-box%"]],")"]]],["unstable/gui/notify"]],
["remove-parens-forward",">framework/Racket.html#(meth._(((lib._framework/main..rkt)._racket~3atext~3c~25~3e)._remove-parens-forward))",[[0,[2,"remove-parens-forward"]],[14,[" (method of ",[0,[2,"racket:text<%>"]],")"]]],["framework"]],
["remove-parent",">mrlib/graph-snip___.html#(meth._(((lib._mrlib/graph..rkt)._graph-snip~3c~25~3e)._remove-parent))",[[0,[2,"remove-parent"]],[14,[" (method of ",[0,[2,"graph-snip<%>"]],")"]]],["mrlib/graph"]],
["remove-piece",">gl-board-game/index.html#(meth._(((lib._games/gl-board-game..rkt)._gl-board~25)._remove-piece))",[[0,[2,"remove-piece"]],[14,[" (method of ",[0,[2,"gl-board%"]],")"]]],["games/gl-board-game"]],
["remove-pkg",">planet/Utility_Libraries.html#(def._((lib._planet/util..rkt)._remove-pkg))",[0,[2,"remove-pkg"]],["planet/util"]],
["remove-region",">cards/index.html#(meth._(((lib._games/cards..rkt)._table~3c~25~3e)._remove-region))",[[0,[2,"remove-region"]],[14,[" (method of ",[0,[2,"table<%>"]],")"]]],["games/cards"]],
["remove-selected",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._remove-selected))",[[0,[2,"remove-selected"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["remove-sexp",">framework/Racket.html#(meth._(((lib._framework/main..rkt)._racket~3atext~3c~25~3e)._remove-sexp))",[[0,[2,"remove-sexp"]],[14,[" (method of ",[0,[2,"racket:text<%>"]],")"]]],["framework"]],
["remove-space",">framework/Keymap.html#(idx._(gentag._18._(lib._scribblings/framework/framework..scrbl)))","remove-space",false],
["remove-tag",">browser/index.html#(meth._(((lib._browser/browser..rkt)._hyper-text-mixin)._remove-tag))",[[0,[2,"remove-tag"]],[14,[" (method of ",[0,[2,"hyper-text-mixin"]],")"]]],["browser/browser","browser"]],
["removing the pink background",">redex/The_Redex_Reference.html#(part._pink)","Removing the Pink Background",false],
["remp",">r6rs-lib-std/r6rs-lib-Z-H-4.html#node_idx_216",[0,[2,"remp"]],["rnrs/lists-6"]],
["remq",">reference/pairs.html#(def._((lib._racket/private/list..rkt)._remq))",[0,[2,"remq"]],["racket/base","racket"]],
["remq",">r6rs-lib-std/r6rs-lib-Z-H-4.html#node_idx_222",[0,[2,"remq"]],["rnrs/lists-6"]],
["remq",">lazy/index.html#(def._((lib._lazy/main..rkt)._remq))",[0,[2,"remq"]],["lazy"]],
["remq*",">reference/pairs.html#(def._((lib._racket/private/list..rkt)._remq*))",[0,[2,"remq*"]],["racket/base","racket"]],
["remq*",">lazy/index.html#(def._((lib._lazy/main..rkt)._remq*))",[0,[2,"remq*"]],["lazy"]],
["remv",">reference/pairs.html#(def._((lib._racket/private/list..rkt)._remv))",[0,[2,"remv"]],["racket/base","racket"]],
["remv",">r6rs-lib-std/r6rs-lib-Z-H-4.html#node_idx_220",[0,[2,"remv"]],["rnrs/lists-6"]],
["remv",">lazy/index.html#(def._((lib._lazy/main..rkt)._remv))",[0,[2,"remv"]],["lazy"]],
["remv*",">reference/pairs.html#(def._((lib._racket/private/list..rkt)._remv*))",[0,[2,"remv*"]],["racket/base","racket"]],
["remv*",">lazy/index.html#(def._((lib._lazy/main..rkt)._remv*))",[0,[2,"remv*"]],["lazy"]],
["rename",">reference/creatingunits.html#(form._((lib._mzlib/unit..rkt)._rename))",[0,[1,"rename"]],["racket/unit","racket"]],
["rename transformer",">reference/syntax-model.html#(tech._rename._transformer)","<span style=\"font-style: italic\">rename transformer</span>",false],
["rename-contract",">unstable/contract.html#(def._((lib._unstable/contract..rkt)._rename-contract))",[0,[2,"rename-contract"]],["unstable/contract"]],
["rename-file-or-directory",">reference/Filesystem.html#(def._((quote._~23~25kernel)._rename-file-or-directory))",[0,[2,"rename-file-or-directory"]],["racket/base","racket"]],
["rename-in",">reference/require.html#(form._((lib._racket/private/base..rkt)._rename-in))",[0,[1,"rename-in"]],["racket/base","racket"]],
["rename-inner",">reference/createclass.html#(form._((lib._racket/private/class-internal..rkt)._rename-inner))",[0,[1,"rename-inner"]],["racket/class","racket"]],
["rename-out",">reference/require.html#(form._((lib._racket/private/base..rkt)._rename-out))",[0,[1,"rename-out"]],["racket/base","racket"]],
["rename-super",">reference/createclass.html#(form._((lib._racket/private/class-internal..rkt)._rename-super))",[0,[1,"rename-super"]],["racket/class","racket"]],
["rename-transformer-target",">reference/stxtrans.html#(def._((quote._~23~25kernel)._rename-transformer-target))",[0,[2,"rename-transformer-target"]],["racket/base","racket"]],
["rename-transformer?",">reference/stxtrans.html#(def._((quote._~23~25kernel)._rename-transformer~3f))",[0,[2,"rename-transformer?"]],["racket/base","racket"]],
["render",">profile/index.html#(def._((lib._profile/render-graphviz..rkt)._render))",[0,"render"],["profile/render-graphviz"]],
["render",">profile/index.html#(def._((lib._profile/render-text..rkt)._render))",[0,"render"],["profile/render-text"]],
["render",">scribble/renderer.html#(meth._(((lib._scribble/base-render..rkt)._render~25)._render))",[[0,[2,"render"]],[14,[" (method of ",[0,[2,"render%"]],")"]]],["scribble/base-render"]],
["render",">scribble/renderer.html#(def._((lib._scribble/render..rkt)._render))",[0,[2,"render"]],["scribble/render"]],
["render pass",">scribble/core.html#(tech._render._pas)","<span style=\"font-style: italic\">render pass</span>",false],
["render%",">scribble/renderer.html#(def._((lib._scribble/base-render..rkt)._render~25))",[0,[2,"render%"]],["scribble/base-render"]],
["render-element",">scribble/core.html#(def._((lib._scribble/core..rkt)._render-element))",[0,[2,"render-element"]],["scribble/core"]],
["render-element-render",">scribble/core.html#(def._((lib._scribble/core..rkt)._render-element-render))",[0,[2,"render-element-render"]],["scribble/core"]],
["render-element?",">scribble/core.html#(def._((lib._scribble/core..rkt)._render-element~3f))",[0,[2,"render-element?"]],["scribble/core"]],
["render-html-to-text",">browser/index.html#(def._((lib._browser/htmltext..rkt)._render-html-to-text))",[0,[2,"render-html-to-text"]],["browser/htmltext"]],
["render-image",">mrlib/Image_Core.html#(def._((lib._mrlib/image-core..rkt)._render-image))",[0,[2,"render-image"]],["mrlib/image-core"]],
["render-judgment-form",">redex/The_Redex_Reference.html#(form._((lib._redex/pict..rkt)._render-judgment-form))",[0,[1,"render-judgment-form"]],["redex/pict","redex"]],
["render-language",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._render-language))",[0,[2,"render-language"]],["redex/pict","redex"]],
["render-language-nts",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._render-language-nts))",[0,[2,"render-language-nts"]],["redex/pict","redex"]],
["render-lw",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._render-lw))",[0,[2,"render-lw"]],["redex/pict","redex"]],
["render-metafunction",">redex/The_Redex_Reference.html#(form._((lib._redex/pict..rkt)._render-metafunction))",[0,[1,"render-metafunction"]],["redex/pict","redex"]],
["render-metafunctions",">redex/The_Redex_Reference.html#(form._((lib._redex/pict..rkt)._render-metafunctions))",[0,[1,"render-metafunctions"]],["redex/pict","redex"]],
["render-mixin",">scribble/renderer.html#(def._((lib._scribble/html-render..rkt)._render-mixin))",[0,[2,"render-mixin"]],["scribble/html-render"]],
["render-mixin",">scribble/renderer.html#(def._((lib._scribble/latex-render..rkt)._render-mixin))",[0,[2,"render-mixin"]],["scribble/latex-render"]],
["render-mixin",">scribble/renderer.html#(def._((lib._scribble/pdf-render..rkt)._render-mixin))",[0,[2,"render-mixin"]],["scribble/pdf-render"]],
["render-mixin",">scribble/renderer.html#(def._((lib._scribble/text-render..rkt)._render-mixin))",[0,[2,"render-mixin"]],["scribble/text-render"]],
["render-multi-mixin",">scribble/renderer.html#(def._((lib._scribble/html-render..rkt)._render-multi-mixin))",[0,[2,"render-multi-mixin"]],["scribble/html-render"]],
["render-post",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-1..rkt)._render-post))",[0,"render-post"],[]],
["render-posts",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-1..rkt)._render-posts))",[0,"render-posts"],[]],
["render-reduction-relation",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._render-reduction-relation))",[0,[2,"render-reduction-relation"]],["redex/pict","redex"]],
["render-reduction-relation-rules",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._render-reduction-relation-rules))",[0,[2,"render-reduction-relation-rules"]],["redex/pict","redex"]],
["render-relation",">redex/The_Redex_Reference.html#(form._((lib._redex/pict..rkt)._render-relation))",[0,[1,"render-relation"]],["redex/pict","redex"]],
["render-scene",">deinprogramm/line3d.html#(def._((lib._teachpack/deinprogramm/line3d..rkt)._render-scene))",[0,[2,"render-scene"]],["teachpack/deinprogramm/line3d"]],
["render-term",">redex/The_Redex_Reference.html#(form._((lib._redex/pict..rkt)._render-term))",[0,[1,"render-term"]],["redex/pict","redex"]],
["render-value",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3alanguage~3c~25~3e)._render-value))",[[0,[2,"render-value"]],[14,[" (method of ",[0,[2,"drracket:language:language<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["render-value",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3amodule-based-language~3c~25~3e)._render-value))",[[0,[2,"render-value"]],[14,[" (method of ",[0,[2,"drracket:language:module-based-language<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["render-value",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3asimple-module-based-language-~3emodule-based-language-mixin)._render-value))",[[0,[2,"render-value"]],[14,[" (method of ",[0,[2,"drracket:language:simple-module-based-language->module-based-language-mixin"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["render-value/format",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3alanguage~3c~25~3e)._render-value/format))",[[0,[2,"render-value/format"]],[14,[" (method of ",[0,[2,"drracket:language:language<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["render-value/format",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3amodule-based-language~3c~25~3e)._render-value/format))",[[0,[2,"render-value/format"]],[14,[" (method of ",[0,[2,"drracket:language:module-based-language<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["render-value/format",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3asimple-module-based-language-~3emodule-based-language-mixin)._render-value/format))",[[0,[2,"render-value/format"]],[14,[" (method of ",[0,[2,"drracket:language:simple-module-based-language->module-based-language-mixin"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["renderer",">plot/intro.html#(tech._renderer)","<span style=\"font-style: italic\">renderer</span>",false],
["renderer and plot bounds",">plot/intro.html#(part._.Renderer_and_.Plot_.Bounds)","Renderer and Plot Bounds",false],
["renderer2d?",">plot/contracts.html#(def._((lib._plot/utils..rkt)._renderer2d~3f))",[0,[2,"renderer2d?"]],["plot/utils"]],
["renderer3d?",">plot/contracts.html#(def._((lib._plot/utils..rkt)._renderer3d~3f))",[0,[2,"renderer3d?"]],["plot/utils"]],
["renderers",">scribble/renderer.html","Renderers",false],
["rendering",">slideshow/Rendering.html","Rendering",false],
["rendering driver",">scribble/renderer.html#(part._.Rendering_.Driver)","Rendering Driver",false],
["rendering html",">continue/index.html#(part._.Rendering_.H.T.M.L)","Rendering HTML",false],
["rendering syntax objects with formatting",">syntax/syntax-helpers.html#(part._to-string)","Rendering Syntax Objects with Formatting",false],
["rep",">unstable/Automata__Compiling_State_Machines.html#(form._((lib._unstable/automata/re-ext..rkt)._rep))",[0,[1,"rep"]],["unstable/automata/re-ext"]],
["reparent",">gui/subwindow___.html#(meth._(((lib._mred/main..rkt)._subwindow~3c~25~3e)._reparent))",[[0,[2,"reparent"]],[14,[" (method of ",[0,[2,"subwindow<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["repl",">guide/intro.html#(tech._repl)","<span style=\"font-style: italic\">REPL</span>",false],
["repl",">reference/eval.html#(tech._repl)","<span style=\"font-style: italic\">REPL</span>",false],
["replace",">reference/file-ports.html#(idx._(gentag._204._(lib._scribblings/reference/reference..scrbl)))",[7,"'replace"],false],
["replace & find again backwards menu item",">drracket/Menus.html#(idx._(gentag._84._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Replace &amp; Find Again Backwards</span> menu item",false],
["replace & find again menu item",">drracket/Menus.html#(idx._(gentag._83._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Replace &amp; Find Again</span> menu item",false],
["replace all menu item",">drracket/Menus.html#(idx._(gentag._85._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Replace All</span> menu item",false],
["replace-all",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3asearchable~3c~25~3e)._replace-all))",[[0,[2,"replace-all"]],[14,[" (method of ",[0,[2,"frame:searchable<%>"]],")"]]],["framework"]],
["replace-context",">syntax/syntax-helpers.html#(def._((lib._syntax/strip-context..rkt)._replace-context))",[0,[2,"replace-context"]],["syntax/strip-context"]],
["replace-icos",">file/ico.html#(def._((lib._file/ico..rkt)._replace-icos))",[0,[2,"replace-icos"]],["file/ico"]],
["replace-named-style",">gui/style-list_.html#(meth._(((lib._racket/snip..rkt)._style-list~25)._replace-named-style))",[[0,[2,"replace-named-style"]],[14,[" (method of ",[0,[2,"style-list%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["replaces-field",">net/head.html#(def._((lib._net/head..rkt)._replaces-field))",[0,"replaces-field"],["net/head"]],
["replacing deprecated functions",">plot/porting.html#(part._.Replacing_.Deprecated_.Functions)","Replacing Deprecated Functions",false],
["replacing lexical context",">syntax/syntax-helpers.html#(part._strip-context)","Replacing Lexical Context",false],
["replacing uses of plot-extend",">plot/porting.html#(part._.Replacing_.Uses_of_plot-extend)",["Replacing Uses of ",[0,"plot-extend"]],false],
["replicate",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._replicate))",[0,[2,"replicate"]],["lang/htdp-advanced"]],
["replicate",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._replicate))",[0,[2,"replicate"]],["lang/htdp-beginner"]],
["replicate",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._replicate))",[0,[2,"replicate"]],["lang/htdp-beginner-abbr"]],
["replicate",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._replicate))",[0,[2,"replicate"]],["lang/htdp-intermediate"]],
["replicate",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._replicate))",[0,[2,"replicate"]],["lang/htdp-intermediate-lambda"]],
["repositories",">planet/Developing_Packages_for_PLaneT.html#(idx._(gentag._25._(lib._planet/planet..scrbl)))",[7,"'repositories"],false],
["representations",">syntax/Source_Locations.html#(part._srcloc)","Representations",false],
["representing paths relative to \"collects\"",">raco/relative-paths.html#(part._.Representing_paths_relative_to__collects_)",["Representing paths relative to ",[6,"\"collects\""]],false],
["req",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._req))",[0,[2,"req"]],["compiler/zo-structs"]],
["req-dummy",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._req-dummy))",[0,[2,"req-dummy"]],["compiler/zo-structs"]],
["req-reqs",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._req-reqs))",[0,[2,"req-reqs"]],["compiler/zo-structs"]],
["req?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._req~3f))",[0,[2,"req?"]],["compiler/zo-structs"]],
["request",">web-server/http.html#(def._((lib._web-server/http/request-structs..rkt)._request))",[0,[2,"request"]],["web-server/http/request-structs"]],
["request->basic-credentials",">web-server/http.html#(def._((lib._web-server/http/basic-auth..rkt)._request-~3ebasic-credentials))",[0,[2,"request->basic-credentials"]],["web-server/http/basic-auth"]],
["request->digest-credentials",">web-server/http.html#(def._((lib._web-server/http/digest-auth..rkt)._request-~3edigest-credentials))",[0,[2,"request->digest-credentials"]],["web-server/http/digest-auth"]],
["request-bindings",">continue/index.html#(def._((lib._web-server/servlet..rkt)._request-bindings))",[0,[2,"request-bindings"]],[]],
["request-bindings",">web-server/http.html#(def._((lib._web-server/http/bindings..rkt)._request-bindings))",[0,[2,"request-bindings"]],["web-server/http/bindings"]],
["request-bindings/raw",">web-server/http.html#(def._((lib._web-server/http/request-structs..rkt)._request-bindings/raw))",[0,[2,"request-bindings/raw"]],["web-server/http/request-structs"]],
["request-bindings/raw-promise",">web-server/http.html#(def._((lib._web-server/http/request-structs..rkt)._request-bindings/raw-promise))",[0,[2,"request-bindings/raw-promise"]],["web-server/http/request-structs"]],
["request-client-ip",">web-server/http.html#(def._((lib._web-server/http/request-structs..rkt)._request-client-ip))",[0,[2,"request-client-ip"]],["web-server/http/request-structs"]],
["request-cookies",">web-server/http.html#(def._((lib._web-server/http/cookie-parse..rkt)._request-cookies))",[0,[2,"request-cookies"]],["web-server/http/cookie-parse"]],
["request-headers",">web-server/http.html#(def._((lib._web-server/http/bindings..rkt)._request-headers))",[0,[2,"request-headers"]],["web-server/http/bindings"]],
["request-headers/raw",">web-server/http.html#(def._((lib._web-server/http/request-structs..rkt)._request-headers/raw))",[0,[2,"request-headers/raw"]],["web-server/http/request-structs"]],
["request-host-ip",">web-server/http.html#(def._((lib._web-server/http/request-structs..rkt)._request-host-ip))",[0,[2,"request-host-ip"]],["web-server/http/request-structs"]],
["request-host-port",">web-server/http.html#(def._((lib._web-server/http/request-structs..rkt)._request-host-port))",[0,[2,"request-host-port"]],["web-server/http/request-structs"]],
["request-method",">web-server/http.html#(def._((lib._web-server/http/request-structs..rkt)._request-method))",[0,[2,"request-method"]],["web-server/http/request-structs"]],
["request-post-data/raw",">web-server/http.html#(def._((lib._web-server/http/request-structs..rkt)._request-post-data/raw))",[0,[2,"request-post-data/raw"]],["web-server/http/request-structs"]],
["request-uri",">web-server/http.html#(def._((lib._web-server/http/request-structs..rkt)._request-uri))",[0,[2,"request-uri"]],["web-server/http/request-structs"]],
["request?",">web-server/http.html#(def._((lib._web-server/http/request-structs..rkt)._request~3f))",[0,[2,"request?"]],["web-server/http/request-structs"]],
["requested minimum height",">gui/windowing-overview.html#(tech._requested._minimum._height)","<span style=\"font-style: italic\">requested minimum height</span>",false],
["requested minimum size",">gui/windowing-overview.html#(tech._requested._minimum._size)","<span style=\"font-style: italic\">requested minimum size</span>",false],
["requested minimum width",">gui/windowing-overview.html#(tech._requested._minimum._width)","<span style=\"font-style: italic\">requested minimum width</span>",false],
["requests",">web-server/http.html#(part._request-structs)","Requests",false],
["require",">ts-reference/special-forms.html#(part._.Require)","Require",false],
["require",">reference/require.html#(form._((lib._racket/private/base..rkt)._require))",[0,[1,"require"]],["racket/base","racket"]],
["require",">htdp-langs/advanced.html#(form._((lib._lang/htdp-advanced..rkt)._require))",[0,[1,"require"]],["lang/htdp-advanced"]],
["require",">htdp-langs/beginner.html#(form._((lib._lang/htdp-beginner..rkt)._require))",[0,[1,"require"]],["lang/htdp-beginner"]],
["require",">htdp-langs/beginner-abbr.html#(form._((lib._lang/htdp-beginner-abbr..rkt)._require))",[0,[1,"require"]],["lang/htdp-beginner-abbr"]],
["require",">htdp-langs/intermediate.html#(form._((lib._lang/htdp-intermediate..rkt)._require))",[0,[1,"require"]],["lang/htdp-intermediate"]],
["require",">htdp-langs/intermediate-lam.html#(form._((lib._lang/htdp-intermediate-lambda..rkt)._require))",[0,[1,"require"]],["lang/htdp-intermediate-lambda"]],
["require",">mzscheme/Old_Syntactic_Forms.html#(form._((lib._mzscheme/main..rkt)._require))",[0,[1,"require"]],["mzscheme"]],
["require",">raco/info_rkt.html#(form._((lib._setup/infotab..rkt)._require))",[0,[1,"require"]],["setup/infotab"]],
["require macros",">reference/define.html#(part._require-syntax)",[[0,[1,"require"]]," Macros"],false],
["require transformer",">reference/stxtrans.html#(tech._require._transformer)","<span style=\"font-style: italic\">require\ntransformer</span>",false],
["require transformers",">reference/stxtrans.html#(part._require-trans)",[[0,[1,"require"]]," Transformers"],false],
["require-for-label",">mzscheme/Old_Syntactic_Forms.html#(form._((lib._mzscheme/main..rkt)._require-for-label))",[0,[1,"require-for-label"]],["mzscheme"]],
["require-for-syntax",">mzscheme/Old_Syntactic_Forms.html#(form._((lib._mzscheme/main..rkt)._require-for-syntax))",[0,[1,"require-for-syntax"]],["mzscheme"]],
["require-for-template",">mzscheme/Old_Syntactic_Forms.html#(form._((lib._mzscheme/main..rkt)._require-for-template))",[0,[1,"require-for-template"]],["mzscheme"]],
["require-transformer?",">reference/stxtrans.html#(def._((lib._racket/require-transform..rkt)._require-transformer~3f))",[0,[2,"require-transformer?"]],["racket/require-transform"]],
["require-typed-struct",">ts-reference/Legacy_Forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._require-typed-struct))",[0,[1,"require-typed-struct"]],["typed/racket/base","typed/racket"]],
["require-typed-struct",">ts-reference/Compatibility_Languages.html#(form._((lib._typed/scheme/base..rkt)._require-typed-struct))",[0,[1,"require-typed-struct"]],["typed/scheme/base","typed/scheme","typed-scheme"]],
["require-typed-struct/provide",">ts-reference/Legacy_Forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._require-typed-struct/provide))",[0,[1,"require-typed-struct/provide"]],["typed/racket/base","typed/racket"]],
["require/doc",">scribble/srcdoc.html#(form._((lib._scribble/srcdoc..rkt)._require/doc))",[0,[1,"require/doc"]],["scribble/srcdoc"]],
["require/expose",">rackunit/api.html#(form._((lib._rackunit/main..rkt)._require/expose))",[0,[1,"require/expose"]],["rackunit"]],
["require/opaque-type",">ts-reference/Legacy_Forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._require/opaque-type))",[0,[1,"require/opaque-type"]],["typed/racket/base","typed/racket"]],
["require/typed",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._require/typed))",[0,[1,"require/typed"]],["typed/racket/base","typed/racket"]],
["require/typed",">ts-reference/Compatibility_Languages.html#(form._((lib._typed/scheme/base..rkt)._require/typed))",[0,[1,"require/typed"]],["typed/scheme/base","typed/scheme","typed-scheme"]],
["require/typed/provide",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._require/typed/provide))",[0,[1,"require/typed/provide"]],["typed/racket/base","typed/racket"]],
["required",">web-server/formlets.html#(def._((lib._web-server/formlets/input..rkt)._required))",[0,[2,"required"]],["web-server/formlets/input"]],
["required arguments",">mzlib/mzlib_kw.html#(part._.Required_.Arguments)","Required Arguments",false],
["required-core-version",">planet/Developing_Packages_for_PLaneT.html#(idx._(gentag._23._(lib._planet/planet..scrbl)))",[7,"'required-core-version"],false],
["requiring and loading files",">xrepl/index.html#(part._.Requiring_and_.Loading_.Files)","Requiring and Loading Files",false],
["reset",">reference/cont.html#(form._((lib._racket/control..rkt)._reset))",[0,[1,"reset"]],["racket/control"]],
["reset",">draw/dc-path_.html#(meth._(((lib._racket/draw..rkt)._dc-path~25)._reset))",[[0,[2,"reset"]],[14,[" (method of ",[0,[2,"dc-path%"]],")"]]],["racket/draw"]],
["reset",">web-server/formlets.html#(def._((lib._web-server/formlets/input..rkt)._reset))",[0,[2,"reset"]],["web-server/formlets/input"]],
["reset com method",">mzcom/index.html#(idx._(gentag._2._(lib._mzcom/mzcom..scrbl)))",[[6,"Reset"]," COM method"],false],
["reset-at",">reference/cont.html#(form._((lib._racket/control..rkt)._reset-at))",[0,[1,"reset-at"]],["racket/control"]],
["reset-console",">tools/drracket_rep.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3arep~3atext~25)._reset-console))",[[0,[2,"reset-console"]],[14,[" (method of ",[0,[2,"drracket:rep:text%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["reset-highlighting",">tools/drracket_rep.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3arep~3atext~25)._reset-highlighting))",[[0,[2,"reset-highlighting"]],[14,[" (method of ",[0,[2,"drracket:rep:text%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["reset-input-box",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3aports~3c~25~3e)._reset-input-box))",[[0,[2,"reset-input-box"]],[14,[" (method of ",[0,[2,"text:ports<%>"]],")"]]],["framework"]],
["reset-min-sizes",">framework/editor-snip.html#(meth._(((lib._framework/main..rkt)._editor-snip~3adecorated~3c~25~3e)._reset-min-sizes))",[[0,[2,"reset-min-sizes"]],[14,[" (method of ",[0,[2,"editor-snip:decorated<%>"]],")"]]],["framework"]],
["reset-offer-kill",">tools/drracket_rep.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3arep~3acontext~3c~25~3e)._reset-offer-kill))",[[0,[2,"reset-offer-kill"]],[14,[" (method of ",[0,[2,"drracket:rep:context<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["reset-offer-kill",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3atab~3c~25~3e)._reset-offer-kill))",[[0,[2,"reset-offer-kill"]],[14,[" (method of ",[0,[2,"drracket:unit:tab<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["reset-region",">framework/Color.html#(meth._(((lib._framework/main..rkt)._color~3atext~3c~25~3e)._reset-region))",[[0,[2,"reset-region"]],[14,[" (method of ",[0,[2,"color:text<%>"]],")"]]],["framework"]],
["reset-regions",">framework/Color.html#(meth._(((lib._framework/main..rkt)._color~3atext~3c~25~3e)._reset-regions))",[[0,[2,"reset-regions"]],[14,[" (method of ",[0,[2,"color:text<%>"]],")"]]],["framework"]],
["reset-relevant-directories-state!",">raco/getinfo.html#(def._((lib._setup/getinfo..rkt)._reset-relevant-directories-state!))",[0,[2,"reset-relevant-directories-state!"]],["setup/getinfo"]],
["reset-tests",">htdp/index.html#(def._((lib._test-engine/racket-tests..rkt)._reset-tests))",[0,[2,"reset-tests"]],["htdp/testing"]],
["reset-timer!",">web-server-internal/timer.html#(def._((lib._web-server/private/timer..rkt)._reset-timer!))",[0,[2,"reset-timer!"]],["web-server/private/timer"]],
["reset0",">reference/cont.html#(form._((lib._racket/control..rkt)._reset0))",[0,[1,"reset0"]],["racket/control"]],
["reset0-at",">reference/cont.html#(form._((lib._racket/control..rkt)._reset0-at))",[0,[1,"reset0-at"]],["racket/control"]],
["resize",">gui/editor-snip_.html#(meth._(((lib._mred/main..rkt)._editor-snip~25)._resize))",[[0,[2,"resize"]],[14,[" (method of ",[0,[2,"editor-snip%"]],")"]]],["racket/gui/base","racket/gui"]],
["resize",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._resize))",[[0,[2,"resize"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["resize",">gui/top-level-window___.html#(meth._(((lib._mred/main..rkt)._top-level-window~3c~25~3e)._resize))",[[0,[2,"resize"]],[14,[" (method of ",[0,[2,"top-level-window<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["resize",">gui/image-snip_.html#(meth._(((lib._racket/snip..rkt)._image-snip~25)._resize))",[[0,[2,"resize"]],[14,[" (method of ",[0,[2,"image-snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["resize",">gui/snip_.html#(meth._(((lib._racket/snip..rkt)._snip~25)._resize))",[[0,[2,"resize"]],[14,[" (method of ",[0,[2,"snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["resized",">gui/editor-admin_.html#(meth._(((lib._mred/main..rkt)._editor-admin~25)._resized))",[[0,[2,"resized"]],[14,[" (method of ",[0,[2,"editor-admin%"]],")"]]],["racket/gui/base","racket/gui"]],
["resized",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._resized))",[[0,[2,"resized"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["resized",">gui/snip-admin_.html#(meth._(((lib._racket/snip..rkt)._snip-admin~25)._resized))",[[0,[2,"resized"]],[14,[" (method of ",[0,[2,"snip-admin%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["resized",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3adelegate-mixin)._resized))",[[0,[2,"resized"]],[14,[" (method of ",[0,[2,"text:delegate-mixin"]],")"]]],["framework"]],
["resized",">mrlib/horizontal-pasteboard_.html#(meth._(((lib._mrlib/aligned-pasteboard..rkt)._horizontal-pasteboard~25)._resized))",[[0,[2,"resized"]],[14,[" (method of ",[0,[2,"horizontal-pasteboard%"]],")"]]],["mrlib/aligned-pasteboard"]],
["resized",">mrlib/vertical-pasteboard_.html#(meth._(((lib._mrlib/aligned-pasteboard..rkt)._vertical-pasteboard~25)._resized))",[[0,[2,"resized"]],[14,[" (method of ",[0,[2,"vertical-pasteboard%"]],")"]]],["mrlib/aligned-pasteboard"]],
["resizing",">images/Resizing.html","Resizing",false],
["resolve",">scribble/renderer.html#(meth._(((lib._scribble/base-render..rkt)._render~25)._resolve))",[[0,[2,"resolve"]],[14,[" (method of ",[0,[2,"render%"]],")"]]],["scribble/base-render"]],
["resolve pass",">scribble/core.html#(tech._resolve._pas)","<span style=\"font-style: italic\">resolve pass</span>",false],
["resolve-get",">scribble/core.html#(def._((lib._scribble/core..rkt)._resolve-get))",[0,[2,"resolve-get"]],["scribble/core"]],
["resolve-get-keys",">scribble/core.html#(def._((lib._scribble/core..rkt)._resolve-get-keys))",[0,[2,"resolve-get-keys"]],["scribble/core"]],
["resolve-get/ext?",">scribble/core.html#(def._((lib._scribble/core..rkt)._resolve-get/ext~3f))",[0,[2,"resolve-get/ext?"]],["scribble/core"]],
["resolve-get/tentative",">scribble/core.html#(def._((lib._scribble/core..rkt)._resolve-get/tentative))",[0,[2,"resolve-get/tentative"]],["scribble/core"]],
["resolve-info",">scribble/core.html#(def._((lib._scribble/core..rkt)._resolve-info))",[0,[2,"resolve-info"]],["scribble/core"]],
["resolve-info-ci",">scribble/core.html#(def._((lib._scribble/core..rkt)._resolve-info-ci))",[0,[2,"resolve-info-ci"]],["scribble/core"]],
["resolve-info-delays",">scribble/core.html#(def._((lib._scribble/core..rkt)._resolve-info-delays))",[0,[2,"resolve-info-delays"]],["scribble/core"]],
["resolve-info-undef",">scribble/core.html#(def._((lib._scribble/core..rkt)._resolve-info-undef))",[0,[2,"resolve-info-undef"]],["scribble/core"]],
["resolve-info?",">scribble/core.html#(def._((lib._scribble/core..rkt)._resolve-info~3f))",[0,[2,"resolve-info?"]],["scribble/core"]],
["resolve-module-path",">syntax/module-helpers.html#(def._((lib._syntax/modresolve..rkt)._resolve-module-path))",[0,[2,"resolve-module-path"]],["syntax/modresolve"]],
["resolve-module-path-index",">syntax/module-helpers.html#(def._((lib._syntax/modresolve..rkt)._resolve-module-path-index))",[0,[2,"resolve-module-path-index"]],["syntax/modresolve"]],
["resolve-path",">reference/Manipulating_Paths.html#(def._((quote._~23~25kernel)._resolve-path))",[0,[2,"resolve-path"]],["racket/base","racket"]],
["resolve-path-spec",">syntax/transformer-helpers.html#(def._((lib._syntax/path-spec..rkt)._resolve-path-spec))",[0,[2,"resolve-path-spec"]],["syntax/path-spec"]],
["resolve-planet-path",">planet/Utility_Libraries.html#(def._((lib._planet/resolver..rkt)._resolve-planet-path))",[0,[2,"resolve-planet-path"]],["planet/resolver"]],
["resolve-planet-path",">planet/Utility_Libraries.html#(def._((lib._planet/util..rkt)._resolve-planet-path))",[0,[2,"resolve-planet-path"]],["planet/util"]],
["resolve-search",">scribble/core.html#(def._((lib._scribble/core..rkt)._resolve-search))",[0,[2,"resolve-search"]],["scribble/core"]],
["resolved",">reference/Module_Names_and_Loading.html#(tech._resolved)","<span style=\"font-style: italic\">resolved</span>",false],
["resolved module path",">reference/Module_Names_and_Loading.html#(tech._resolved._module._path)","<span style=\"font-style: italic\">resolved\nmodule path</span>",false],
["resolved-module-path",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Resolved-.Module-.Path))",[0,[1,"Resolved-Module-Path"]],["typed/racket/base","typed/racket"]],
["resolved-module-path-name",">reference/Module_Names_and_Loading.html#(def._((quote._~23~25kernel)._resolved-module-path-name))",[0,[2,"resolved-module-path-name"]],["racket/base","racket"]],
["resolved-module-path?",">reference/Module_Names_and_Loading.html#(def._((quote._~23~25kernel)._resolved-module-path~3f))",[0,[2,"resolved-module-path?"]],["racket/base","racket"]],
["resolver",">planet/Utility_Libraries.html#(part._.Resolver)","Resolver",false],
["resolver file locking",">planet/Utility_Libraries.html#(part._.Resolver_file_locking)","Resolver file locking",false],
["resolving include-like paths",">syntax/transformer-helpers.html#(part._path-spec)",["Resolving ",[0,"include"],"-like Paths"],false],
["resolving module names",">reference/Module_Names_and_Loading.html#(part._modnameresolver)","Resolving Module Names",false],
["resolving module paths to file paths",">syntax/module-helpers.html#(part._.Resolving_.Module_.Paths_to_.File_.Paths)","Resolving Module Paths to File Paths",false],
["respawn-and-fire%",">reference/distributed-places.html#(def._((lib._racket/place/distributed..rkt)._respawn-and-fire~25))",[0,[2,"respawn-and-fire%"]],["racket/place/distributed"]],
["responders",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._responders))",[0,[2,"responders"]],["web-server/configuration/configuration-table-structs"]],
["responders-authentication",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._responders-authentication))",[0,[2,"responders-authentication"]],["web-server/configuration/configuration-table-structs"]],
["responders-collect-garbage",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._responders-collect-garbage))",[0,[2,"responders-collect-garbage"]],["web-server/configuration/configuration-table-structs"]],
["responders-file-not-found",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._responders-file-not-found))",[0,[2,"responders-file-not-found"]],["web-server/configuration/configuration-table-structs"]],
["responders-passwords-refreshed",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._responders-passwords-refreshed))",[0,[2,"responders-passwords-refreshed"]],["web-server/configuration/configuration-table-structs"]],
["responders-protocol",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._responders-protocol))",[0,[2,"responders-protocol"]],["web-server/configuration/configuration-table-structs"]],
["responders-servlet",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._responders-servlet))",[0,[2,"responders-servlet"]],["web-server/configuration/configuration-table-structs"]],
["responders-servlet-loading",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._responders-servlet-loading))",[0,[2,"responders-servlet-loading"]],["web-server/configuration/configuration-table-structs"]],
["responders-servlets-refreshed",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._responders-servlets-refreshed))",[0,[2,"responders-servlets-refreshed"]],["web-server/configuration/configuration-table-structs"]],
["responders?",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._responders~3f))",[0,[2,"responders?"]],["web-server/configuration/configuration-table-structs"]],
["response",">web-server/http.html#(def._((lib._web-server/http/response-structs..rkt)._response))",[0,[2,"response"]],["web-server/http/response-structs"]],
["response-code",">web-server/http.html#(def._((lib._web-server/http/response-structs..rkt)._response-code))",[0,[2,"response-code"]],["web-server/http/response-structs"]],
["response-headers",">web-server/http.html#(def._((lib._web-server/http/response-structs..rkt)._response-headers))",[0,[2,"response-headers"]],["web-server/http/response-structs"]],
["response-message",">web-server/http.html#(def._((lib._web-server/http/response-structs..rkt)._response-message))",[0,[2,"response-message"]],["web-server/http/response-structs"]],
["response-mime",">web-server/http.html#(def._((lib._web-server/http/response-structs..rkt)._response-mime))",[0,[2,"response-mime"]],["web-server/http/response-structs"]],
["response-output",">web-server/http.html#(def._((lib._web-server/http/response-structs..rkt)._response-output))",[0,[2,"response-output"]],["web-server/http/response-structs"]],
["response-seconds",">web-server/http.html#(def._((lib._web-server/http/response-structs..rkt)._response-seconds))",[0,[2,"response-seconds"]],["web-server/http/response-structs"]],
["response/full",">web-server/http.html#(def._((lib._web-server/http/response-structs..rkt)._response/full))",[0,[2,"response/full"]],["web-server/http/response-structs"]],
["response/xexpr",">web-server/http.html#(def._((lib._web-server/http/xexpr..rkt)._response/xexpr))",[0,[2,"response/xexpr"]],["web-server/http/xexpr","web-server"]],
["response?",">web-server/http.html#(def._((lib._web-server/http/response-structs..rkt)._response~3f))",[0,[2,"response?"]],["web-server/http/response-structs"]],
["responses",">web-server/http.html#(part._response-structs)","Responses",false],
["responses",">web-server/servlet.html#(part._servlet-structs)","Responses",false],
["rest",">reference/pairs.html#(def._((lib._racket/list..rkt)._rest))",[0,[2,"rest"]],["racket/list","racket"]],
["rest",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._rest))",[0,[2,"rest"]],["lang/htdp-advanced"]],
["rest",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._rest))",[0,[2,"rest"]],["lang/htdp-beginner"]],
["rest",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._rest))",[0,[2,"rest"]],["lang/htdp-beginner-abbr"]],
["rest",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._rest))",[0,[2,"rest"]],["lang/htdp-intermediate"]],
["rest",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._rest))",[0,[2,"rest"]],["lang/htdp-intermediate-lambda"]],
["rest",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._rest))",[0,[2,"rest"]],["deinprogramm/DMdA-advanced"]],
["rest",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._rest))",[0,[2,"rest"]],["deinprogramm/DMdA-assignments"]],
["rest",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._rest))",[0,[2,"rest"]],["deinprogramm/DMdA-vanilla"]],
["rest",">lazy/index.html#(def._((lib._lazy/main..rkt)._rest))",[0,[2,"rest"]],["lazy"]],
["rest",">mzlib/mzlib_list.html#(def._((lib._mzlib/list..rkt)._rest))",[0,[2,"rest"]],["mzlib/list"]],
["rest",">plai/mutator.html#(def._((lib._plai/mutator..rkt)._rest))",[0,[2,"rest"]],["plai/mutator"]],
["rest and rest-like arguments",">mzlib/mzlib_kw.html#(part._.Rest_and_.Rest-like_.Arguments)","Rest and Rest-like Arguments",false],
["rest arguments",">guide/contracts-general-functions.html#(part._contracts-rest-args)","Rest Arguments",false],
["restart-every",">reference/distributed-places.html#(def._((lib._racket/place/distributed..rkt)._restart-every))",[0,[2,"restart-every"]],["racket/place/distributed"]],
["restart-mzscheme",">mzlib/mzlib_restart.html#(def._((lib._mzlib/restart..rkt)._restart-mzscheme))",[0,[2,"restart-mzscheme"]],["mzlib/restart"]],
["restarter%",">reference/distributed-places.html#(def._((lib._racket/place/distributed..rkt)._restarter~25))",[0,[2,"restarter%"]],["racket/place/distributed"]],
["restore",">gui/menu-item___.html#(meth._(((lib._mred/main..rkt)._menu-item~3c~25~3e)._restore))",[[0,[2,"restore"]],[14,[" (method of ",[0,[2,"menu-item<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["restore-keybinding",">framework/Menu.html#(meth._(((lib._framework/main..rkt)._menu~3acan-restore~3c~25~3e)._restore-keybinding))",[[0,[2,"restore-keybinding"]],[14,[" (method of ",[0,[2,"menu:can-restore<%>"]],")"]]],["framework"]],
["restore-underscores",">framework/Menu.html#(meth._(((lib._framework/main..rkt)._menu~3acan-restore-underscore~3c~25~3e)._restore-underscores))",[[0,[2,"restore-underscores"]],[14,[" (method of ",[0,[2,"menu:can-restore-underscore<%>"]],")"]]],["framework"]],
["result types",">rackunit/internals.html#(part._.Result_.Types)","Result Types",false],
["result-color",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._result-color))",[0,[2,"result-color"]],["scribble/racket","scribble/scheme"]],
["resume-flush",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._resume-flush))",[[0,[2,"resume-flush"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["resume-flush",">gui/canvas___.html#(meth._(((lib._mred/main..rkt)._canvas~3c~25~3e)._resume-flush))",[[0,[2,"resume-flush"]],[14,[" (method of ",[0,[2,"canvas<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["ret",">unstable/temp-c.html#(form._((lib._unstable/temp-c/dsl..rkt)._ret))",[0,[1,"ret"]],["unstable/temp-c/dsl"]],
["retainer",">foreign/Allocation_and_Finalization.html#(def._((lib._ffi/unsafe/alloc..rkt)._retainer))",[0,[2,"retainer"]],["ffi/unsafe/alloc"]],
["retract-most-recent-slide",">slideshow/Slide_Registration.html#(def._((lib._slideshow/base..rkt)._retract-most-recent-slide))",[0,[2,"retract-most-recent-slide"]],["slideshow/base","slideshow"]],
["return",">reference/Byte_and_String_Input.html#(idx._(gentag._214._(lib._scribblings/reference/reference..scrbl)))",[7,"'return"],false],
["return-linefeed",">reference/Byte_and_String_Input.html#(idx._(gentag._215._(lib._scribblings/reference/reference..scrbl)))",[7,"'return-linefeed"],false],
["return-without-pos",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex..rkt)._return-without-pos))",[0,[1,"return-without-pos"]],["parser-tools/lex"]],
["reverse",">reference/pairs.html#(def._((lib._racket/private/list..rkt)._reverse))",[0,[2,"reverse"]],["racket/base","racket"]],
["reverse",">draw/dc-path_.html#(meth._(((lib._racket/draw..rkt)._dc-path~25)._reverse))",[[0,[2,"reverse"]],[14,[" (method of ",[0,[2,"dc-path%"]],")"]]],["racket/draw"]],
["reverse",">r5rs-std/r5rs-Z-H-9.html#%_idx_440",[0,[2,"reverse"]],["r5rs"]],
["reverse",">r6rs-std/r6rs-Z-H-14.html#node_idx_636",[0,[2,"reverse"]],["rnrs/base-6"]],
["reverse",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._reverse))",[0,[2,"reverse"]],["lang/htdp-advanced"]],
["reverse",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._reverse))",[0,[2,"reverse"]],["lang/htdp-beginner"]],
["reverse",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._reverse))",[0,[2,"reverse"]],["lang/htdp-beginner-abbr"]],
["reverse",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._reverse))",[0,[2,"reverse"]],["lang/htdp-intermediate"]],
["reverse",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._reverse))",[0,[2,"reverse"]],["lang/htdp-intermediate-lambda"]],
["reverse",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._reverse))",[0,[2,"reverse"]],["deinprogramm/DMdA-advanced"]],
["reverse",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._reverse))",[0,[2,"reverse"]],["deinprogramm/DMdA-assignments"]],
["reverse",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._reverse))",[0,[2,"reverse"]],["deinprogramm/DMdA-vanilla"]],
["reverse",">lazy/index.html#(def._((lib._lazy/main..rkt)._reverse))",[0,[2,"reverse"]],["lazy"]],
["reverse",">srfi-std/srfi-1.html#reverse",[0,[2,"reverse"]],["srfi/1"]],
["reverse!",">srfi-std/srfi-1.html#srfi-1.html",[0,[2,"reverse!"]],["srfi/1"]],
["reverse-animations",">slideshow/play.html#(def._((lib._slideshow/play..rkt)._reverse-animations))",[0,[2,"reverse-animations"]],["slideshow/play"]],
["reverse-list->string",">srfi-std/srfi-13.html#reverse-list2string",[0,[2,"reverse-list->string"]],["srfi/13"]],
["reverse-list->vector",">srfi-std/srfi-43.html#reverse-list->vector",[0,[2,"reverse-list->vector"]],["srfi/43"]],
["reverse-vector->list",">srfi-std/srfi-43.html#reverse-vector->list",[0,[2,"reverse-vector->list"]],["srfi/43"]],
["revert",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3aeditor~3c~25~3e)._revert))",[[0,[2,"revert"]],[14,[" (method of ",[0,[2,"frame:editor<%>"]],")"]]],["framework"]],
["revert menu item",">drracket/Menus.html#(idx._(gentag._58._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Revert</span> menu item",false],
["rewind",">browser/index.html#(meth._(((lib._browser/browser..rkt)._hyper-panel-mixin)._rewind))",[[0,[2,"rewind"]],[14,[" (method of ",[0,[2,"hyper-panel-mixin"]],")"]]],["browser/browser","browser"]],
["rewind-icon",">images/Icons.html#(def._((lib._images/icons/control..rkt)._rewind-icon))",[0,[2,"rewind-icon"]],["images/icons/control"]],
["rgb",">graphics/Color_Operations.html#(def._((lib._graphics/graphics..rkt)._rgb))",[0,[2,"rgb"]],["graphics/graphics"]],
["rgb",">teachpack/image.html#(tech._rgb)","<span style=\"font-style: italic\">RGB</span>",false],
["rgb-blue",">graphics/Color_Operations.html#(def._((lib._graphics/graphics..rkt)._rgb-blue))",[0,[2,"rgb-blue"]],["graphics/graphics"]],
["rgb-color",">deinprogramm/image.html#(def._((lib._deinprogramm/image..rkt)._rgb-color))",[0,[2,"rgb-color"]],["teachpack/deinprogramm/image"]],
["rgb-farbe",">deinprogramm/image.html#(tech._rgb._farbe)","<span style=\"font-style: italic\">RGB-Farbe</span>",false],
["rgb-green",">graphics/Color_Operations.html#(def._((lib._graphics/graphics..rkt)._rgb-green))",[0,[2,"rgb-green"]],["graphics/graphics"]],
["rgb-red",">graphics/Color_Operations.html#(def._((lib._graphics/graphics..rkt)._rgb-red))",[0,[2,"rgb-red"]],["graphics/graphics"]],
["rgb?",">graphics/Color_Operations.html#(def._((lib._graphics/graphics..rkt)._rgb~3f))",[0,[2,"rgb?"]],["graphics/graphics"]],
["rhombus",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._rhombus))",[0,[2,"rhombus"]],["2htdp/image"]],
["right",">teachpack/2htdpuniverse.html#(form._((lib._2htdp/universe..rkt)._right))",[0,[1,"right"]],["2htdp/universe"]],
["right",">gui/key-event_.html#(idx._(gentag._54._(lib._scribblings/gui/gui..scrbl)))",[7,"'right"],false],
["right-arrow-icon",">images/Icons.html#(def._((lib._images/icons/arrow..rkt)._right-arrow-icon))",[0,[2,"right-arrow-icon"]],["images/icons/arrow"]],
["right-click-in-gap",">framework/Panel.html#(meth._(((lib._framework/main..rkt)._panel~3adragable~3c~25~3e)._right-click-in-gap))",[[0,[2,"right-click-in-gap"]],[14,[" (method of ",[0,[2,"panel:dragable<%>"]],")"]]],["framework"]],
["right-mouse-click?",">graphics/Mouse_Operations.html#(def._((lib._graphics/graphics..rkt)._right-mouse-click~3f))",[0,[2,"right-mouse-click?"]],["graphics/graphics"]],
["right-over-arrow-icon",">images/Icons.html#(def._((lib._images/icons/arrow..rkt)._right-over-arrow-icon))",[0,[2,"right-over-arrow-icon"]],["images/icons/arrow"]],
["right-triangle",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._right-triangle))",[0,[2,"right-triangle"]],["2htdp/image"]],
["right-under-arrow-icon",">images/Icons.html#(def._((lib._images/icons/arrow..rkt)._right-under-arrow-icon))",[0,[2,"right-under-arrow-icon"]],["images/icons/arrow"]],
["ring-bell",">framework/Keymap.html#(idx._(gentag._5._(lib._scribblings/framework/framework..scrbl)))","ring-bell",false],
["rmpi-allreduce",">reference/distributed-places.html#(def._((lib._racket/place/distributed/rmpi..rkt)._rmpi-allreduce))",[0,[2,"rmpi-allreduce"]],["racket/place/distributed/rmpi"]],
["rmpi-barrier",">reference/distributed-places.html#(def._((lib._racket/place/distributed/rmpi..rkt)._rmpi-barrier))",[0,[2,"rmpi-barrier"]],["racket/place/distributed/rmpi"]],
["rmpi-broadcast",">reference/distributed-places.html#(def._((lib._racket/place/distributed/rmpi..rkt)._rmpi-broadcast))",[0,[2,"rmpi-broadcast"]],["racket/place/distributed/rmpi"]],
["rmpi-build-default-config",">reference/distributed-places.html#(def._((lib._racket/place/distributed/rmpi..rkt)._rmpi-build-default-config))",[0,[2,"rmpi-build-default-config"]],["racket/place/distributed/rmpi"]],
["rmpi-cnt",">reference/distributed-places.html#(def._((lib._racket/place/distributed/rmpi..rkt)._rmpi-cnt))",[0,[2,"rmpi-cnt"]],["racket/place/distributed/rmpi"]],
["rmpi-comm",">reference/distributed-places.html#(def._((lib._racket/place/distributed/rmpi..rkt)._rmpi-comm))",[0,[2,"rmpi-comm"]],["racket/place/distributed/rmpi"]],
["rmpi-comm-channels",">reference/distributed-places.html#(def._((lib._racket/place/distributed/rmpi..rkt)._rmpi-comm-channels))",[0,[2,"rmpi-comm-channels"]],["racket/place/distributed/rmpi"]],
["rmpi-comm-cnt",">reference/distributed-places.html#(def._((lib._racket/place/distributed/rmpi..rkt)._rmpi-comm-cnt))",[0,[2,"rmpi-comm-cnt"]],["racket/place/distributed/rmpi"]],
["rmpi-comm-id",">reference/distributed-places.html#(def._((lib._racket/place/distributed/rmpi..rkt)._rmpi-comm-id))",[0,[2,"rmpi-comm-id"]],["racket/place/distributed/rmpi"]],
["rmpi-comm?",">reference/distributed-places.html#(def._((lib._racket/place/distributed/rmpi..rkt)._rmpi-comm~3f))",[0,[2,"rmpi-comm?"]],["racket/place/distributed/rmpi"]],
["rmpi-finish",">reference/distributed-places.html#(def._((lib._racket/place/distributed/rmpi..rkt)._rmpi-finish))",[0,[2,"rmpi-finish"]],["racket/place/distributed/rmpi"]],
["rmpi-id",">reference/distributed-places.html#(def._((lib._racket/place/distributed/rmpi..rkt)._rmpi-id))",[0,[2,"rmpi-id"]],["racket/place/distributed/rmpi"]],
["rmpi-init",">reference/distributed-places.html#(def._((lib._racket/place/distributed/rmpi..rkt)._rmpi-init))",[0,[2,"rmpi-init"]],["racket/place/distributed/rmpi"]],
["rmpi-launch",">reference/distributed-places.html#(def._((lib._racket/place/distributed/rmpi..rkt)._rmpi-launch))",[0,[2,"rmpi-launch"]],["racket/place/distributed/rmpi"]],
["rmpi-partition",">reference/distributed-places.html#(def._((lib._racket/place/distributed/rmpi..rkt)._rmpi-partition))",[0,[2,"rmpi-partition"]],["racket/place/distributed/rmpi"]],
["rmpi-recv",">reference/distributed-places.html#(def._((lib._racket/place/distributed/rmpi..rkt)._rmpi-recv))",[0,[2,"rmpi-recv"]],["racket/place/distributed/rmpi"]],
["rmpi-reduce",">reference/distributed-places.html#(def._((lib._racket/place/distributed/rmpi..rkt)._rmpi-reduce))",[0,[2,"rmpi-reduce"]],["racket/place/distributed/rmpi"]],
["rmpi-send",">reference/distributed-places.html#(def._((lib._racket/place/distributed/rmpi..rkt)._rmpi-send))",[0,[2,"rmpi-send"]],["racket/place/distributed/rmpi"]],
["rnrs/arithmetic/bitwise-6",">r6rs/R6RS_Libraries.html#(mod-path._rnrs/arithmetic/bitwise-6)",[9,[0,"rnrs/arithmetic/bitwise-6"]],"module"],
["rnrs/arithmetic/fixnums-6",">r6rs/R6RS_Libraries.html#(mod-path._rnrs/arithmetic/fixnums-6)",[9,[0,"rnrs/arithmetic/fixnums-6"]],"module"],
["rnrs/arithmetic/flonums-6",">r6rs/R6RS_Libraries.html#(mod-path._rnrs/arithmetic/flonums-6)",[9,[0,"rnrs/arithmetic/flonums-6"]],"module"],
["rnrs/base-6",">r6rs/R6RS_Libraries.html#(mod-path._rnrs/base-6)",[9,[0,"rnrs/base-6"]],"module"],
["rnrs/bytevectors-6",">r6rs/R6RS_Libraries.html#(mod-path._rnrs/bytevectors-6)",[9,[0,"rnrs/bytevectors-6"]],"module"],
["rnrs/conditions-6",">r6rs/R6RS_Libraries.html#(mod-path._rnrs/conditions-6)",[9,[0,"rnrs/conditions-6"]],"module"],
["rnrs/control-6",">r6rs/R6RS_Libraries.html#(mod-path._rnrs/control-6)",[9,[0,"rnrs/control-6"]],"module"],
["rnrs/enums-6",">r6rs/R6RS_Libraries.html#(mod-path._rnrs/enums-6)",[9,[0,"rnrs/enums-6"]],"module"],
["rnrs/eval-6",">r6rs/R6RS_Libraries.html#(mod-path._rnrs/eval-6)",[9,[0,"rnrs/eval-6"]],"module"],
["rnrs/exceptions-6",">r6rs/R6RS_Libraries.html#(mod-path._rnrs/exceptions-6)",[9,[0,"rnrs/exceptions-6"]],"module"],
["rnrs/files-6",">r6rs/R6RS_Libraries.html#(mod-path._rnrs/files-6)",[9,[0,"rnrs/files-6"]],"module"],
["rnrs/hashtables-6",">r6rs/R6RS_Libraries.html#(mod-path._rnrs/hashtables-6)",[9,[0,"rnrs/hashtables-6"]],"module"],
["rnrs/io/ports-6",">r6rs/R6RS_Libraries.html#(mod-path._rnrs/io/ports-6)",[9,[0,"rnrs/io/ports-6"]],"module"],
["rnrs/io/simple-6",">r6rs/R6RS_Libraries.html#(mod-path._rnrs/io/simple-6)",[9,[0,"rnrs/io/simple-6"]],"module"],
["rnrs/lists-6",">r6rs/R6RS_Libraries.html#(mod-path._rnrs/lists-6)",[9,[0,"rnrs/lists-6"]],"module"],
["rnrs/mutable-pairs-6",">r6rs/R6RS_Libraries.html#(mod-path._rnrs/mutable-pairs-6)",[9,[0,"rnrs/mutable-pairs-6"]],"module"],
["rnrs/mutable-strings-6",">r6rs/R6RS_Libraries.html#(mod-path._rnrs/mutable-strings-6)",[9,[0,"rnrs/mutable-strings-6"]],"module"],
["rnrs/programs-6",">r6rs/R6RS_Libraries.html#(mod-path._rnrs/programs-6)",[9,[0,"rnrs/programs-6"]],"module"],
["rnrs/r5rs-6",">r6rs/R6RS_Libraries.html#(mod-path._rnrs/r5rs-6)",[9,[0,"rnrs/r5rs-6"]],"module"],
["rnrs/records/inspection-6",">r6rs/R6RS_Libraries.html#(mod-path._rnrs/records/inspection-6)",[9,[0,"rnrs/records/inspection-6"]],"module"],
["rnrs/records/procedural-6",">r6rs/R6RS_Libraries.html#(mod-path._rnrs/records/procedural-6)",[9,[0,"rnrs/records/procedural-6"]],"module"],
["rnrs/records/syntactic-6",">r6rs/R6RS_Libraries.html#(mod-path._rnrs/records/syntactic-6)",[9,[0,"rnrs/records/syntactic-6"]],"module"],
["rnrs/sorting-6",">r6rs/R6RS_Libraries.html#(mod-path._rnrs/sorting-6)",[9,[0,"rnrs/sorting-6"]],"module"],
["rnrs/syntax-case-6",">r6rs/R6RS_Libraries.html#(mod-path._rnrs/syntax-case-6)",[9,[0,"rnrs/syntax-case-6"]],"module"],
["rnrs/unicode-6",">r6rs/R6RS_Libraries.html#(mod-path._rnrs/unicode-6)",[9,[0,"rnrs/unicode-6"]],"module"],
["rock",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._rock))",[0,[2,"rock"]],["2htdp/planetcute"]],
["rollback-transaction",">db/query-api.html#(def._((lib._db/base..rkt)._rollback-transaction))",[0,[2,"rollback-transaction"]],["db","db/base"]],
["rolling your own contracts",">guide/contract-func.html#(part._contracts-own)","Rolling Your Own Contracts",false],
["roman",">gui/style-delta_.html#(idx._(gentag._197._(lib._scribblings/gui/gui..scrbl)))",[7,"'roman"],false],
["roman",">draw/font_.html#(idx._(gentag._30._(lib._scribblings/draw/draw..scrbl)))",[7,"'roman"],false],
["roof-east",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._roof-east))",[0,[2,"roof-east"]],["2htdp/planetcute"]],
["roof-north",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._roof-north))",[0,[2,"roof-north"]],["2htdp/planetcute"]],
["roof-north-east",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._roof-north-east))",[0,[2,"roof-north-east"]],["2htdp/planetcute"]],
["roof-north-west",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._roof-north-west))",[0,[2,"roof-north-west"]],["2htdp/planetcute"]],
["roof-south",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._roof-south))",[0,[2,"roof-south"]],["2htdp/planetcute"]],
["roof-south-east",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._roof-south-east))",[0,[2,"roof-south-east"]],["2htdp/planetcute"]],
["roof-south-west",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._roof-south-west))",[0,[2,"roof-south-west"]],["2htdp/planetcute"]],
["roof-west",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._roof-west))",[0,[2,"roof-west"]],["2htdp/planetcute"]],
["root",">gui/menu-bar_.html#(idx._(gentag._116._(lib._scribblings/gui/gui..scrbl)))",[7,"'root"],false],
["root style",">gui/editor-overview.html#(tech._root._style)","<span style=\"font-style: italic\">root style</span>",false],
["root?",">plai/collector.html#(def._((lib._plai/collector..rkt)._root~3f))",[0,[2,"root?"]],["plai/collector"]],
["rotate",">draw/dc-path_.html#(meth._(((lib._racket/draw..rkt)._dc-path~25)._rotate))",[[0,[2,"rotate"]],[14,[" (method of ",[0,[2,"dc-path%"]],")"]]],["racket/draw"]],
["rotate",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._rotate))",[[0,[2,"rotate"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["rotate",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._rotate))",[0,[2,"rotate"]],["2htdp/image"]],
["rotate",">cards/index.html#(meth._(((lib._games/cards..rkt)._card~3c~25~3e)._rotate))",[[0,[2,"rotate"]],[14,[" (method of ",[0,[2,"card<%>"]],")"]]],["games/cards"]],
["rotate",">slideshow/Pict_Drawing_Adjusters.html#(def._((lib._slideshow/pict..rkt)._rotate))",[0,[2,"rotate"]],["slideshow/pict","slideshow"]],
["rotate-180",">picturing-programs/index.html#(def._((lib._picturing-programs/private/tiles..rkt)._rotate-180))",[0,[2,"rotate-180"]],["picturing-programs/private/tiles","picturing-programs"]],
["rotate-card",">cards/index.html#(meth._(((lib._games/cards..rkt)._table~3c~25~3e)._rotate-card))",[[0,[2,"rotate-card"]],[14,[" (method of ",[0,[2,"table<%>"]],")"]]],["games/cards"]],
["rotate-cards",">cards/index.html#(meth._(((lib._games/cards..rkt)._table~3c~25~3e)._rotate-cards))",[[0,[2,"rotate-cards"]],[14,[" (method of ",[0,[2,"table<%>"]],")"]]],["games/cards"]],
["rotate-ccw",">picturing-programs/index.html#(def._((lib._picturing-programs/private/tiles..rkt)._rotate-ccw))",[0,[2,"rotate-ccw"]],["picturing-programs/private/tiles","picturing-programs"]],
["rotate-cw",">picturing-programs/index.html#(def._((lib._picturing-programs/private/tiles..rkt)._rotate-cw))",[0,[2,"rotate-cw"]],["picturing-programs/private/tiles","picturing-programs"]],
["rotating, scaling, flipping, cropping, and framing images",">teachpack/2htdpimage.html#(part._.Rotating__.Scaling__.Flipping__.Cropping__and_.Framing_.Images)","Rotating, Scaling, Flipping, Cropping, and Framing Images",false],
["round",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._round))",[0,[2,"round"]],["racket/base","racket"]],
["round",">r5rs-std/r5rs-Z-H-9.html#%_idx_320",[0,[2,"round"]],["r5rs"]],
["round",">r6rs-std/r6rs-Z-H-14.html#node_idx_534",[0,[2,"round"]],["rnrs/base-6"]],
["round",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._round))",[0,[2,"round"]],["lang/htdp-advanced"]],
["round",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._round))",[0,[2,"round"]],["lang/htdp-beginner"]],
["round",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._round))",[0,[2,"round"]],["lang/htdp-beginner-abbr"]],
["round",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._round))",[0,[2,"round"]],["lang/htdp-intermediate"]],
["round",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._round))",[0,[2,"round"]],["lang/htdp-intermediate-lambda"]],
["round",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._round))",[0,[2,"round"]],["deinprogramm/DMdA-advanced"]],
["round",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._round))",[0,[2,"round"]],["deinprogramm/DMdA-assignments"]],
["round",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._round))",[0,[2,"round"]],["deinprogramm/DMdA-beginner"]],
["round",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._round))",[0,[2,"round"]],["deinprogramm/DMdA-vanilla"]],
["rounded-rectangle",">draw/dc-path_.html#(meth._(((lib._racket/draw..rkt)._dc-path~25)._rounded-rectangle))",[[0,[2,"rounded-rectangle"]],[14,[" (method of ",[0,[2,"dc-path%"]],")"]]],["racket/draw"]],
["rounded-rectangle",">slideshow/Basic_Pict_Constructors.html#(def._((lib._slideshow/pict..rkt)._rounded-rectangle))",[0,[2,"rounded-rectangle"]],["slideshow/pict","slideshow"]],
["rounded-rectangle/border",">unstable/pict.html#(def._((lib._unstable/gui/pict..rkt)._rounded-rectangle/border))",[0,[2,"rounded-rectangle/border"]],["unstable/gui/pict"]],
["rows->dict",">db/query-api.html#(def._((lib._db/base..rkt)._rows-~3edict))",[0,[2,"rows->dict"]],["db","db/base"]],
["rows-result",">db/query-api.html#(def._((lib._db/base..rkt)._rows-result))",[0,[2,"rows-result"]],["db","db/base"]],
["rows-result-headers",">db/query-api.html#(def._((lib._db/base..rkt)._rows-result-headers))",[0,[2,"rows-result-headers"]],["db","db/base"]],
["rows-result-rows",">db/query-api.html#(def._((lib._db/base..rkt)._rows-result-rows))",[0,[2,"rows-result-rows"]],["db","db/base"]],
["rows-result?",">db/query-api.html#(def._((lib._db/base..rkt)._rows-result~3f))",[0,[2,"rows-result?"]],["db","db/base"]],
["rshift",">gui/key-event_.html#(idx._(gentag._42._(lib._scribblings/gui/gui..scrbl)))",[7,"'rshift"],false],
["rt",">slideshow/Primary_Slide_Functions.html#(def._((lib._slideshow/base..rkt)._rt))",[0,[2,"rt"]],["slideshow/base","slideshow"]],
["rt-find",">slideshow/Pict_Finders.html#(def._((lib._slideshow/pict..rkt)._rt-find))",[0,[2,"rt-find"]],["slideshow/pict","slideshow"]],
["rt-superimpose",">slideshow/Pict_Combiners.html#(def._((lib._slideshow/pict..rkt)._rt-superimpose))",[0,[2,"rt-superimpose"]],["slideshow/pict","slideshow"]],
["rtl-find",">slideshow/Pict_Finders.html#(def._((lib._slideshow/pict..rkt)._rtl-find))",[0,[2,"rtl-find"]],["slideshow/pict","slideshow"]],
["rtl-superimpose",">slideshow/Pict_Combiners.html#(def._((lib._slideshow/pict..rkt)._rtl-superimpose))",[0,[2,"rtl-superimpose"]],["slideshow/pict","slideshow"]],
["rtt",">reference/futures-visualizer.html#(tech._rtt)","<span style=\"font-style: italic\">RTT</span>",false],
["rubber-icon-material",">images/Icons.html#(def._((lib._images/icons/style..rkt)._rubber-icon-material))",[0,[2,"rubber-icon-material"]],["images/icons/style"]],
["rule-pict-style",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._rule-pict-style))",[0,[2,"rule-pict-style"]],["redex/pict","redex"]],
["rummy --- card game",">games/ginrummy.html",[[15,"<img src=\"ginrummy.png\" alt=\"\" />"]," ","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Rummy</span>"," ","&#8212;","<wbr></wbr>"," Card Game"],false],
["run",">teachpack/elevator.html#(def._((lib._htdp/elevator..rkt)._run))",[0,[2,"run"]],["htdp/elevator"]],
["run",">mrlib/Path_Dialog.html#(meth._(((lib._mrlib/path-dialog..rkt)._path-dialog~25)._run))",[[0,[2,"run"]],[14,[" (method of ",[0,[2,"path-dialog%"]],")"]]],["mrlib/path-dialog"]],
["run",">deinprogramm/turtle.html#(def._((lib._teachpack/deinprogramm/turtle..rkt)._run))",[0,[2,"run"]],["teachpack/deinprogramm/turtle"]],
["run button",">drracket/buttons.html#(idx._(gentag._14._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Run</span> button",false],
["run menu item",">drracket/Menus.html#(idx._(gentag._122._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Run</span> menu item",false],
["run, program, run",">games/Run__program__run.html","Run, program, run",false],
["run-after-edit-sequence",">framework/Editor.html#(meth._(((lib._framework/main..rkt)._editor~3abasic~3c~25~3e)._run-after-edit-sequence))",[[0,[2,"run-after-edit-sequence"]],[14,[" (method of ",[0,[2,"editor:basic<%>"]],")"]]],["framework"]],
["run-file",">reference/Filesystem.html#(idx._(gentag._286._(lib._scribblings/reference/reference..scrbl)))",[7,"'run-file"],false],
["run-icon-color",">images/Icons.html#(def._((lib._images/icons/style..rkt)._run-icon-color))",[0,[2,"run-icon-color"]],["images/icons/style"]],
["run-in-evaluation-thread",">tools/drracket_rep.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3arep~3atext~25)._run-in-evaluation-thread))",[[0,[2,"run-in-evaluation-thread"]],[14,[" (method of ",[0,[2,"drracket:rep:text%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["run-installer",">raco/_plt-archives.html#(def._((lib._setup/plt-installer..rkt)._run-installer))",[0,[2,"run-installer"]],["setup/plt-installer"]],
["run-movie",">teachpack/2htdpuniverse.html#(def._((lib._2htdp/universe..rkt)._run-movie))",[0,[2,"run-movie"]],["2htdp/universe"]],
["run-movie",">teachpack/world.html#(def._((lib._htdp/world..rkt)._run-movie))",[0,[2,"run-movie"]],["htdp/world"]],
["run-server",">mzlib/mzlib_thread.html#(def._((lib._mzlib/thread..rkt)._run-server))",[0,[2,"run-server"]],["mzlib/thread"]],
["run-simulation",">teachpack/2htdpuniverse.html#(def._((lib._2htdp/universe..rkt)._run-simulation))",[0,[2,"run-simulation"]],["2htdp/universe"]],
["run-simulation",">teachpack/world.html#(def._((lib._htdp/world..rkt)._run-simulation))",[0,[2,"run-simulation"]],["htdp/world"]],
["run-single-installer",">raco/_plt-archives.html#(def._((lib._setup/plt-installer..rkt)._run-single-installer))",[0,[2,"run-single-installer"]],["setup/plt-installer"]],
["run-single-installer",">raco/_plt-archives.html#(def._((lib._setup/plt-single-installer..rkt)._run-single-installer))",[0,[2,"run-single-installer"]],["setup/plt-single-installer"]],
["run-test",">rackunit/internals.html#(def._((lib._rackunit/main..rkt)._run-test))",[0,[2,"run-test"]],["rackunit"]],
["run-test-case",">rackunit/internals.html#(def._((lib._rackunit/main..rkt)._run-test-case))",[0,[2,"run-test-case"]],["rackunit"]],
["run-tests",">htdp/index.html#(def._((lib._test-engine/racket-tests..rkt)._run-tests))",[0,[2,"run-tests"]],["htdp/testing"]],
["run-tests",">rackunit/api.html#(def._((lib._rackunit/text-ui..rkt)._run-tests))",[0,[2,"run-tests"]],["rackunit/text-ui"]],
["running",">tools/drracket_frame.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aframe~3a~3c~25~3e)._running))",[[0,[2,"running"]],[14,[" (method of ",[0,[2,"drracket:frame:<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["running",">reference/subprocess.html#(idx._(gentag._295._(lib._scribblings/reference/reference..scrbl)))",[7,"'running"],false],
["running and creating executables",">guide/running.html","Running and Creating Executables",false],
["running r5rs programs",">r5rs/running.html","Running R<span style=\"vertical-align: super; font-size: 80%\">5</span>RS Programs",false],
["running racket",">reference/running.html","Running Racket",false],
["running racket and gracket",">guide/racket.html",["Running ",[6,"racket"]," and ",[6,"gracket"]],false],
["running racket or gracket",">reference/running-sa.html","Running Racket or GRacket",false],
["running raco setup",">raco/running.html",["Running ",[6,"raco setup"]],false],
["running scribble",">scribble/running.html",["Running ",[6,"scribble"]],false],
["running top-level programs",">r6rs/Running_Top-Level_Programs.html","Running Top-Level Programs",false],
["running web servlets",">web-server/run.html","Running Web Servlets",false],
["running-stickman-icon",">images/Icons.html#(def._((lib._images/icons/stickman..rkt)._running-stickman-icon))",[0,[2,"running-stickman-icon"]],["images/icons/stickman"]],
["runtime-paths",">reference/Filesystem.html#(form._((lib._racket/runtime-path..rkt)._runtime-paths))",[0,[1,"runtime-paths"]],["racket/runtime-path"]],
["s",">html/index.html#(def._((lib._html/main..rkt)._s))",[0,[2,"s"]],["html"]],
["s-exp",">reference/reader.html#(mod-path._s-exp)",[9,[0,"s-exp"]],"module"],
["s-exp->fasl",">reference/fasl.html#(def._((lib._racket/fasl..rkt)._s-exp-~3efasl))",[0,[2,"s-exp->fasl"]],["racket/fasl"]],
["s-expression",">guide/module-languages.html#(idx._(gentag._4._(lib._scribblings/guide/guide..scrbl)))","S-expression",false],
["s-expression",">teachpack/2htdpuniverse.html#(tech._s._expression)","<span style=\"font-style: italic\">S-expression</span>",false],
["s-expression reader language",">reference/reader.html#(part._.S-.Expression_.Reader_.Language)","S-Expression Reader Language",false],
["s16vector",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._s16vector))",[0,[2,"s16vector"]],["ffi/vector"]],
["s16vector",">srfi-std/srfi-4.html#s8vector",[0,[2,"s16vector"]],["srfi/4"]],
["s16vector->cpointer",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._s16vector-~3ecpointer))",[0,[2,"s16vector->cpointer"]],["ffi/vector"]],
["s16vector->list",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._s16vector-~3elist))",[0,[2,"s16vector->list"]],["ffi/vector"]],
["s16vector-length",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._s16vector-length))",[0,[2,"s16vector-length"]],["ffi/vector"]],
["s16vector-ref",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._s16vector-ref))",[0,[2,"s16vector-ref"]],["ffi/vector"]],
["s16vector-set!",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._s16vector-set!))",[0,[2,"s16vector-set!"]],["ffi/vector"]],
["s16vector?",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._s16vector~3f))",[0,[2,"s16vector?"]],["ffi/vector"]],
["s2w",">teachpack/2htdpuniverse.html#(tech._s2w)","<span style=\"font-style: italic\">S2W</span>",false],
["s32vector",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._s32vector))",[0,[2,"s32vector"]],["ffi/vector"]],
["s32vector",">srfi-std/srfi-4.html#s16vector",[0,[2,"s32vector"]],["srfi/4"]],
["s32vector->cpointer",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._s32vector-~3ecpointer))",[0,[2,"s32vector->cpointer"]],["ffi/vector"]],
["s32vector->list",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._s32vector-~3elist))",[0,[2,"s32vector->list"]],["ffi/vector"]],
["s32vector-length",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._s32vector-length))",[0,[2,"s32vector-length"]],["ffi/vector"]],
["s32vector-ref",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._s32vector-ref))",[0,[2,"s32vector-ref"]],["ffi/vector"]],
["s32vector-set!",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._s32vector-set!))",[0,[2,"s32vector-set!"]],["ffi/vector"]],
["s32vector?",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._s32vector~3f))",[0,[2,"s32vector?"]],["ffi/vector"]],
["s64vector",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._s64vector))",[0,[2,"s64vector"]],["ffi/vector"]],
["s64vector",">srfi-std/srfi-4.html#s64vector",[0,[2,"s64vector"]],["srfi/4"]],
["s64vector->cpointer",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._s64vector-~3ecpointer))",[0,[2,"s64vector->cpointer"]],["ffi/vector"]],
["s64vector->list",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._s64vector-~3elist))",[0,[2,"s64vector->list"]],["ffi/vector"]],
["s64vector-length",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._s64vector-length))",[0,[2,"s64vector-length"]],["ffi/vector"]],
["s64vector-ref",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._s64vector-ref))",[0,[2,"s64vector-ref"]],["ffi/vector"]],
["s64vector-set!",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._s64vector-set!))",[0,[2,"s64vector-set!"]],["ffi/vector"]],
["s64vector?",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._s64vector~3f))",[0,[2,"s64vector?"]],["ffi/vector"]],
["s8vector",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._s8vector))",[0,[2,"s8vector"]],["ffi/vector"]],
["s8vector",">srfi-std/srfi-4.html#s8vector",[0,[2,"s8vector"]],["srfi/4"]],
["s8vector->cpointer",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._s8vector-~3ecpointer))",[0,[2,"s8vector->cpointer"]],["ffi/vector"]],
["s8vector->list",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._s8vector-~3elist))",[0,[2,"s8vector->list"]],["ffi/vector"]],
["s8vector-length",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._s8vector-length))",[0,[2,"s8vector-length"]],["ffi/vector"]],
["s8vector-ref",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._s8vector-ref))",[0,[2,"s8vector-ref"]],["ffi/vector"]],
["s8vector-set!",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._s8vector-set!))",[0,[2,"s8vector-set!"]],["ffi/vector"]],
["s8vector?",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._s8vector~3f))",[0,[2,"s8vector?"]],["ffi/vector"]],
["s?",">html/index.html#(def._((lib._html/main..rkt)._s~3f))",[0,[2,"s?"]],["html"]],
["safe c vectors",">foreign/foreign_cvector.html","Safe C Vectors",false],
["safe homogenous vectors",">foreign/homogeneous-vectors.html","Safe Homogenous Vectors",false],
["same",">reference/Manipulating_Paths.html#(idx._(gentag._237._(lib._scribblings/reference/reference..scrbl)))",[7,"'same"],false],
["same --- dot-removing game",">games/same.html",[[15,"<img src=\"same.png\" alt=\"\" />"]," ","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Same</span>"," ","&#8212;","<wbr></wbr>"," Dot-Removing Game"],false],
["same-clipboard-client?",">gui/clipboard___.html#(meth._(((lib._mred/main..rkt)._clipboard~3c~25~3e)._same-clipboard-client~3f))",[[0,[2,"same-clipboard-client?"]],[14,[" (method of ",[0,[2,"clipboard<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["samp",">html/index.html#(def._((lib._html/main..rkt)._samp))",[0,[2,"samp"]],["html"]],
["samp?",">html/index.html#(def._((lib._html/main..rkt)._samp~3f))",[0,[2,"samp?"]],["html"]],
["sampling",">plot/utils.html#(part._.Sampling)","Sampling",false],
["sandbox-coverage-enabled",">reference/Sandboxed_Evaluation.html#(def._((lib._racket/sandbox..rkt)._sandbox-coverage-enabled))",[0,[2,"sandbox-coverage-enabled"]],["racket/sandbox"]],
["sandbox-error-output",">reference/Sandboxed_Evaluation.html#(def._((lib._racket/sandbox..rkt)._sandbox-error-output))",[0,[2,"sandbox-error-output"]],["racket/sandbox"]],
["sandbox-eval-handlers",">reference/Sandboxed_Evaluation.html#(def._((lib._racket/sandbox..rkt)._sandbox-eval-handlers))",[0,[2,"sandbox-eval-handlers"]],["racket/sandbox"]],
["sandbox-eval-limits",">reference/Sandboxed_Evaluation.html#(def._((lib._racket/sandbox..rkt)._sandbox-eval-limits))",[0,[2,"sandbox-eval-limits"]],["racket/sandbox"]],
["sandbox-exit-handler",">reference/Sandboxed_Evaluation.html#(def._((lib._racket/sandbox..rkt)._sandbox-exit-handler))",[0,[2,"sandbox-exit-handler"]],["racket/sandbox"]],
["sandbox-gui-available",">reference/Sandboxed_Evaluation.html#(def._((lib._racket/sandbox..rkt)._sandbox-gui-available))",[0,[2,"sandbox-gui-available"]],["racket/sandbox"]],
["sandbox-init-hook",">reference/Sandboxed_Evaluation.html#(def._((lib._racket/sandbox..rkt)._sandbox-init-hook))",[0,[2,"sandbox-init-hook"]],["racket/sandbox"]],
["sandbox-input",">reference/Sandboxed_Evaluation.html#(def._((lib._racket/sandbox..rkt)._sandbox-input))",[0,[2,"sandbox-input"]],["racket/sandbox"]],
["sandbox-make-code-inspector",">reference/Sandboxed_Evaluation.html#(def._((lib._racket/sandbox..rkt)._sandbox-make-code-inspector))",[0,[2,"sandbox-make-code-inspector"]],["racket/sandbox"]],
["sandbox-make-inspector",">reference/Sandboxed_Evaluation.html#(def._((lib._racket/sandbox..rkt)._sandbox-make-inspector))",[0,[2,"sandbox-make-inspector"]],["racket/sandbox"]],
["sandbox-make-logger",">reference/Sandboxed_Evaluation.html#(def._((lib._racket/sandbox..rkt)._sandbox-make-logger))",[0,[2,"sandbox-make-logger"]],["racket/sandbox"]],
["sandbox-make-namespace",">reference/Sandboxed_Evaluation.html#(def._((lib._racket/sandbox..rkt)._sandbox-make-namespace))",[0,[2,"sandbox-make-namespace"]],["racket/sandbox"]],
["sandbox-memory-limit",">reference/Sandboxed_Evaluation.html#(def._((lib._racket/sandbox..rkt)._sandbox-memory-limit))",[0,[2,"sandbox-memory-limit"]],["racket/sandbox"]],
["sandbox-namespace-specs",">reference/Sandboxed_Evaluation.html#(def._((lib._racket/sandbox..rkt)._sandbox-namespace-specs))",[0,[2,"sandbox-namespace-specs"]],["racket/sandbox"]],
["sandbox-namespace-specs",">scheme/scheme_sandbox.html#(def._((lib._scheme/sandbox..rkt)._sandbox-namespace-specs))",[0,[2,"sandbox-namespace-specs"]],["scheme/sandbox"]],
["sandbox-network-guard",">reference/Sandboxed_Evaluation.html#(def._((lib._racket/sandbox..rkt)._sandbox-network-guard))",[0,[2,"sandbox-network-guard"]],["racket/sandbox"]],
["sandbox-output",">reference/Sandboxed_Evaluation.html#(def._((lib._racket/sandbox..rkt)._sandbox-output))",[0,[2,"sandbox-output"]],["racket/sandbox"]],
["sandbox-override-collection-paths",">reference/Sandboxed_Evaluation.html#(def._((lib._racket/sandbox..rkt)._sandbox-override-collection-paths))",[0,[2,"sandbox-override-collection-paths"]],["racket/sandbox"]],
["sandbox-path-permissions",">reference/Sandboxed_Evaluation.html#(def._((lib._racket/sandbox..rkt)._sandbox-path-permissions))",[0,[2,"sandbox-path-permissions"]],["racket/sandbox"]],
["sandbox-propagate-breaks",">reference/Sandboxed_Evaluation.html#(def._((lib._racket/sandbox..rkt)._sandbox-propagate-breaks))",[0,[2,"sandbox-propagate-breaks"]],["racket/sandbox"]],
["sandbox-propagate-exceptions",">reference/Sandboxed_Evaluation.html#(def._((lib._racket/sandbox..rkt)._sandbox-propagate-exceptions))",[0,[2,"sandbox-propagate-exceptions"]],["racket/sandbox"]],
["sandbox-reader",">reference/Sandboxed_Evaluation.html#(def._((lib._racket/sandbox..rkt)._sandbox-reader))",[0,[2,"sandbox-reader"]],["racket/sandbox"]],
["sandbox-security-guard",">reference/Sandboxed_Evaluation.html#(def._((lib._racket/sandbox..rkt)._sandbox-security-guard))",[0,[2,"sandbox-security-guard"]],["racket/sandbox"]],
["sandboxed evaluation",">reference/Sandboxed_Evaluation.html","Sandboxed Evaluation",false],
["save",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3aeditor~3c~25~3e)._save))",[[0,[2,"save"]],[14,[" (method of ",[0,[2,"frame:editor<%>"]],")"]]],["framework"]],
["save button",">drracket/buttons.html#(idx._(gentag._3._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Save</span> button",false],
["save definitions as text... menu item",">drracket/Menus.html#(idx._(gentag._62._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Save Definitions As Text...</span> menu item",false],
["save definitions as... menu item",">drracket/Menus.html#(idx._(gentag._60._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Save Definitions As...</span> menu item",false],
["save definitions menu item",">drracket/Menus.html#(idx._(gentag._59._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Save Definitions</span> menu item",false],
["save interactions as text... menu item",">drracket/Menus.html#(idx._(gentag._65._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Save Interactions As Text...</span> menu item",false],
["save interactions as... menu item",">drracket/Menus.html#(idx._(gentag._64._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Save Interactions As...</span> menu item",false],
["save interactions menu item",">drracket/Menus.html#(idx._(gentag._63._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Save Interactions</span> menu item",false],
["save other menu item",">drracket/Menus.html#(idx._(gentag._61._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Save Other</span> menu item",false],
["save-as",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3aeditor~3c~25~3e)._save-as))",[[0,[2,"save-as"]],[14,[" (method of ",[0,[2,"frame:editor<%>"]],")"]]],["framework"]],
["save-file",">draw/bitmap_.html#(meth._(((lib._racket/draw..rkt)._bitmap~25)._save-file))",[[0,[2,"save-file"]],[14,[" (method of ",[0,[2,"bitmap%"]],")"]]],["racket/draw"]],
["save-file",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._save-file))",[[0,[2,"save-file"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["save-file",">framework/Keymap.html#(idx._(gentag._6._(lib._scribblings/framework/framework..scrbl)))","save-file",false],
["save-file-as",">framework/Keymap.html#(idx._(gentag._8._(lib._scribblings/framework/framework..scrbl)))","save-file-as",false],
["save-file-out-of-date?",">framework/Editor.html#(meth._(((lib._framework/main..rkt)._editor~3abasic~3c~25~3e)._save-file-out-of-date~3f))",[[0,[2,"save-file-out-of-date?"]],[14,[" (method of ",[0,[2,"editor:basic<%>"]],")"]]],["framework"]],
["save-file/gui-error",">framework/Editor.html#(meth._(((lib._framework/main..rkt)._editor~3abasic~3c~25~3e)._save-file/gui-error))",[[0,[2,"save-file/gui-error"]],[14,[" (method of ",[0,[2,"editor:basic<%>"]],")"]]],["framework"]],
["save-icon",">images/Icons.html#(def._((lib._images/icons/file..rkt)._save-icon))",[0,[2,"save-icon"]],["images/icons/file"]],
["save-image",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._save-image))",[0,[2,"save-image"]],["2htdp/image"]],
["save-pixmap",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..rkt)._save-pixmap))",[0,[2,"save-pixmap"]],["graphics/graphics"]],
["save-port",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._save-port))",[[0,[2,"save-port"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["save-random-mutator",">plai/mutator.html#(def._((lib._plai/random-mutator..rkt)._save-random-mutator))",[0,[2,"save-random-mutator"]],["plai/random-mutator"]],
["save-svg-image",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._save-svg-image))",[0,[2,"save-svg-image"]],["2htdp/image"]],
["save-turtle-bitmap",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtles..rkt)._save-turtle-bitmap))",[0,[2,"save-turtle-bitmap"]],["graphics/turtles"]],
["saved-bug-report-titles/ids",">tools/Documentation_Utilities.html#(def._((lib._help/bug-report..rkt)._saved-bug-report-titles/ids))",[0,"saved-bug-report-titles/ids"],["help/bug-report"]],
["saved-errno",">foreign/Miscellaneous_Support.html#(def._((quote._~23~25foreign)._saved-errno))",[0,[2,"saved-errno"]],["ffi/unsafe"]],
["sc",">reference/characters.html#(idx._(gentag._141._(lib._scribblings/reference/reference..scrbl)))",[7,"'sc"],false],
["scalar value",">reference/characters.html#(idx._(gentag._121._(lib._scribblings/reference/reference..scrbl)))","scalar value",false],
["scale",">draw/dc-path_.html#(meth._(((lib._racket/draw..rkt)._dc-path~25)._scale))",[[0,[2,"scale"]],[14,[" (method of ",[0,[2,"dc-path%"]],")"]]],["racket/draw"]],
["scale",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._scale))",[[0,[2,"scale"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["scale",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._scale))",[0,[2,"scale"]],["2htdp/image"]],
["scale",">slideshow/Pict_Drawing_Adjusters.html#(def._((lib._slideshow/pict..rkt)._scale))",[0,[2,"scale"]],["slideshow/pict","slideshow"]],
["scale-color",">slideshow/Miscellaneous.html#(def._((lib._slideshow/pict..rkt)._scale-color))",[0,[2,"scale-color"]],["slideshow/pict","slideshow"]],
["scale-to",">unstable/pict.html#(def._((lib._unstable/gui/pict..rkt)._scale-to))",[0,[2,"scale-to"]],["unstable/gui/pict"]],
["scale/improve-new-text",">slideshow/Pict_Drawing_Adjusters.html#(form._((lib._slideshow/pict..rkt)._scale/improve-new-text))",[0,[1,"scale/improve-new-text"]],["slideshow/pict","slideshow"]],
["scale/xy",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._scale/xy))",[0,[2,"scale/xy"]],["2htdp/image"]],
["scanner",">parser-tools/Lexers.html","scanner",false],
["scanning",">parser-tools/Lexers.html","scanning",false],
["scene",">teachpack/image.html#(tech._scene)","<span style=\"font-style: italic\">scene</span>",false],
["scene+curve",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._scene+curve))",[0,[2,"scene+curve"]],["2htdp/image"]],
["scene+line",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._scene+line))",[0,[2,"scene+line"]],["2htdp/image"]],
["scene+line",">teachpack/image.html#(def._((lib._htdp/image..rkt)._scene+line))",[0,[2,"scene+line"]],["htdp/image"]],
["scene?",">teachpack/image.html#(def._((lib._htdp/image..rkt)._scene~3f))",[0,[2,"scene?"]],["htdp/image"]],
["scenes",">teachpack/image.html#(part._scenes)","Scenes",false],
["scheme",">scheme/scheme.html",[9,[0,"scheme"]],false],
["scheme",">scheme/scheme.html",[9,[0,"scheme"]],"module"],
["scheme",">scribble/scribble_manual_code.html#(form._((lib._scribble/manual..rkt)._.S.C.H.E.M.E))",[0,[1,"SCHEME"]],["scribble/manual"]],
["scheme",">scribble/scribble_manual_code.html#(form._((lib._scribble/manual..rkt)._scheme))",[0,[1,"scheme"]],["scribble/manual"]],
["scheme lexer",">syntax-color/index.html#(part._.Scheme_.Lexer)","Scheme Lexer",false],
["scheme mode",">tools/Editor_Modes.html#(idx._(gentag._27._(lib._scribblings/tools/tools..scrbl)))","scheme mode",false],
["scheme-lexer",">syntax-color/index.html#(def._((lib._syntax-color/scheme-lexer..rkt)._scheme-lexer))",[0,[2,"scheme-lexer"]],["syntax-color/scheme-lexer"]],
["scheme-lexer/status",">syntax-color/index.html#(def._((lib._syntax-color/scheme-lexer..rkt)._scheme-lexer/status))",[0,[2,"scheme-lexer/status"]],["syntax-color/scheme-lexer"]],
["scheme-nobar-lexer/status",">syntax-color/index.html#(def._((lib._syntax-color/scheme-lexer..rkt)._scheme-nobar-lexer/status))",[0,[2,"scheme-nobar-lexer/status"]],["syntax-color/scheme-lexer"]],
["scheme-report-environment",">r5rs-std/r5rs-Z-H-9.html#%_idx_602",[0,[2,"scheme-report-environment"]],["r5rs"]],
["scheme-report-environment",">r6rs-lib-std/r6rs-lib-Z-H-20.html#node_idx_1308",[0,[2,"scheme-report-environment"]],["rnrs/r5rs-6"]],
["scheme-test-data",">htdp/index.html#(def._((lib._test-engine/racket-tests..rkt)._scheme-test-data))",[0,[2,"scheme-test-data"]],["htdp/testing"]],
["scheme/async-channel",">scheme/scheme_async-channel.html",[9,[0,"scheme/async-channel"]],false],
["scheme/async-channel",">scheme/scheme_async-channel.html",[9,[0,"scheme/async-channel"]],"module"],
["scheme/base",">scheme/scheme_base.html",[9,[0,"scheme/base"]],false],
["scheme/base",">scheme/scheme_base.html",[9,[0,"scheme/base"]],"module"],
["scheme/bool",">scheme/scheme_bool.html",[9,[0,"scheme/bool"]],false],
["scheme/bool",">scheme/scheme_bool.html",[9,[0,"scheme/bool"]],"module"],
["scheme/class",">scheme/scheme_class.html",[9,[0,"scheme/class"]],false],
["scheme/class",">scheme/scheme_class.html",[9,[0,"scheme/class"]],"module"],
["scheme/cmdline",">scheme/scheme_cmdline.html",[9,[0,"scheme/cmdline"]],false],
["scheme/cmdline",">scheme/scheme_cmdline.html",[9,[0,"scheme/cmdline"]],"module"],
["scheme/contract",">scheme/scheme_contract.html",[9,[0,"scheme/contract"]],false],
["scheme/contract",">scheme/scheme_contract.html",[9,[0,"scheme/contract"]],"module"],
["scheme/control",">scheme/scheme_control.html",[9,[0,"scheme/control"]],false],
["scheme/control",">scheme/scheme_control.html",[9,[0,"scheme/control"]],"module"],
["scheme/date",">scheme/scheme_date.html",[9,[0,"scheme/date"]],false],
["scheme/date",">scheme/scheme_date.html",[9,[0,"scheme/date"]],"module"],
["scheme/dict",">scheme/scheme_dict.html",[9,[0,"scheme/dict"]],false],
["scheme/dict",">scheme/scheme_dict.html",[9,[0,"scheme/dict"]],"module"],
["scheme/file",">scheme/scheme_file.html",[9,[0,"scheme/file"]],false],
["scheme/file",">scheme/scheme_file.html",[9,[0,"scheme/file"]],"module"],
["scheme/fixnum",">scheme/scheme_fixnum.html",[9,[0,"scheme/fixnum"]],false],
["scheme/fixnum",">scheme/scheme_fixnum.html",[9,[0,"scheme/fixnum"]],"module"],
["scheme/flonum",">scheme/scheme_flonum.html",[9,[0,"scheme/flonum"]],false],
["scheme/flonum",">scheme/scheme_flonum.html",[9,[0,"scheme/flonum"]],"module"],
["scheme/foreign",">scheme/scheme_foreign.html",[9,[0,"scheme/foreign"]],false],
["scheme/foreign",">scheme/scheme_foreign.html",[9,[0,"scheme/foreign"]],"module"],
["scheme/function",">scheme/scheme_function.html",[9,[0,"scheme/function"]],false],
["scheme/function",">scheme/scheme_function.html",[9,[0,"scheme/function"]],"module"],
["scheme/future",">scheme/scheme_future.html",[9,[0,"scheme/future"]],false],
["scheme/future",">scheme/scheme_future.html",[9,[0,"scheme/future"]],"module"],
["scheme/generator",">scheme/scheme_generator.html",[9,[0,"scheme/generator"]],false],
["scheme/generator",">scheme/scheme_generator.html",[9,[0,"scheme/generator"]],"module"],
["scheme/gui",">scheme/scheme_gui.html",[9,[0,"scheme/gui"]],false],
["scheme/gui",">scheme/scheme_gui.html",[9,[0,"scheme/gui"]],"module"],
["scheme/gui/base",">scheme/scheme_gui_base.html",[9,[0,"scheme/gui/base"]],false],
["scheme/gui/base",">scheme/scheme_gui_base.html",[9,[0,"scheme/gui/base"]],"module"],
["scheme/gui/dynamic",">scheme/scheme_gui_dynamic.html",[9,[0,"scheme/gui/dynamic"]],false],
["scheme/gui/dynamic",">scheme/scheme_gui_dynamic.html",[9,[0,"scheme/gui/dynamic"]],"module"],
["scheme/help",">scheme/scheme_help.html",[9,[0,"scheme/help"]],false],
["scheme/help",">scheme/scheme_help.html",[9,[0,"scheme/help"]],"module"],
["scheme/include",">scheme/scheme_include.html",[9,[0,"scheme/include"]],false],
["scheme/include",">scheme/scheme_include.html",[9,[0,"scheme/include"]],"module"],
["scheme/init",">scheme/scheme_init.html",[9,[0,"scheme/init"]],false],
["scheme/init",">scheme/scheme_init.html",[9,[0,"scheme/init"]],"module"],
["scheme/language-info",">scheme/scheme_language-info.html",[9,[0,"scheme/language-info"]],false],
["scheme/language-info",">scheme/scheme_language-info.html",[9,[0,"scheme/language-info"]],"module"],
["scheme/list",">scheme/scheme_list.html",[9,[0,"scheme/list"]],false],
["scheme/list",">scheme/scheme_list.html",[9,[0,"scheme/list"]],"module"],
["scheme/load",">scheme/scheme_load.html",[9,[0,"scheme/load"]],false],
["scheme/load",">scheme/scheme_load.html",[9,[0,"scheme/load"]],"module"],
["scheme/local",">scheme/scheme_local.html",[9,[0,"scheme/local"]],false],
["scheme/local",">scheme/scheme_local.html",[9,[0,"scheme/local"]],"module"],
["scheme/match",">scheme/scheme_match.html",[9,[0,"scheme/match"]],false],
["scheme/match",">scheme/scheme_match.html",[9,[0,"scheme/match"]],"module"],
["scheme/math",">scheme/scheme_math.html",[9,[0,"scheme/math"]],false],
["scheme/math",">scheme/scheme_math.html",[9,[0,"scheme/math"]],"module"],
["scheme/mpair",">scheme/scheme_mpair.html",[9,[0,"scheme/mpair"]],false],
["scheme/mpair",">scheme/scheme_mpair.html",[9,[0,"scheme/mpair"]],"module"],
["scheme/nest",">scheme/nest.html",[9,[0,"scheme/nest"]],false],
["scheme/nest",">scheme/nest.html",[9,[0,"scheme/nest"]],"module"],
["scheme/package",">scheme/scheme_package.html",[9,[0,"scheme/package"]],false],
["scheme/package",">scheme/scheme_package.html",[9,[0,"scheme/package"]],"module"],
["scheme/path",">scheme/scheme_path.html",[9,[0,"scheme/path"]],false],
["scheme/path",">scheme/scheme_path.html",[9,[0,"scheme/path"]],"module"],
["scheme/port",">scheme/scheme_port.html",[9,[0,"scheme/port"]],false],
["scheme/port",">scheme/scheme_port.html",[9,[0,"scheme/port"]],"module"],
["scheme/pretty",">scheme/scheme_pretty.html",[9,[0,"scheme/pretty"]],false],
["scheme/pretty",">scheme/scheme_pretty.html",[9,[0,"scheme/pretty"]],"module"],
["scheme/promise",">scheme/scheme_promise.html",[9,[0,"scheme/promise"]],false],
["scheme/promise",">scheme/scheme_promise.html",[9,[0,"scheme/promise"]],"module"],
["scheme/provide",">scheme/scheme_provide.html",[9,[0,"scheme/provide"]],false],
["scheme/provide",">scheme/scheme_provide.html",[9,[0,"scheme/provide"]],"module"],
["scheme/provide-syntax",">scheme/scheme_provide-syntax.html",[9,[0,"scheme/provide-syntax"]],false],
["scheme/provide-syntax",">scheme/scheme_provide-syntax.html",[9,[0,"scheme/provide-syntax"]],"module"],
["scheme/provide-transform",">scheme/scheme_provide-transform.html",[9,[0,"scheme/provide-transform"]],false],
["scheme/provide-transform",">scheme/scheme_provide-transform.html",[9,[0,"scheme/provide-transform"]],"module"],
["scheme/require",">scheme/scheme_require.html",[9,[0,"scheme/require"]],false],
["scheme/require",">scheme/scheme_require.html",[9,[0,"scheme/require"]],"module"],
["scheme/require-syntax",">scheme/scheme_require-syntax.html",[9,[0,"scheme/require-syntax"]],false],
["scheme/require-syntax",">scheme/scheme_require-syntax.html",[9,[0,"scheme/require-syntax"]],"module"],
["scheme/require-transform",">scheme/scheme_require-transform.html",[9,[0,"scheme/require-transform"]],false],
["scheme/require-transform",">scheme/scheme_require-transform.html",[9,[0,"scheme/require-transform"]],"module"],
["scheme/runtime-config",">scheme/scheme_runtime-config.html",[9,[0,"scheme/runtime-config"]],false],
["scheme/runtime-config",">scheme/scheme_runtime-config.html",[9,[0,"scheme/runtime-config"]],"module"],
["scheme/runtime-path",">scheme/scheme_runtime-path.html",[9,[0,"scheme/runtime-path"]],false],
["scheme/runtime-path",">scheme/scheme_runtime-path.html",[9,[0,"scheme/runtime-path"]],"module"],
["scheme/sandbox",">scheme/scheme_sandbox.html",[9,[0,"scheme/sandbox"]],false],
["scheme/sandbox",">scheme/scheme_sandbox.html",[9,[0,"scheme/sandbox"]],"module"],
["scheme/serialize",">scheme/scheme_serialize.html",[9,[0,"scheme/serialize"]],false],
["scheme/serialize",">scheme/scheme_serialize.html",[9,[0,"scheme/serialize"]],"module"],
["scheme/set",">scheme/scheme_set.html",[9,[0,"scheme/set"]],false],
["scheme/set",">scheme/scheme_set.html",[9,[0,"scheme/set"]],"module"],
["scheme/shared",">scheme/scheme_shared.html",[9,[0,"scheme/shared"]],false],
["scheme/shared",">scheme/scheme_shared.html",[9,[0,"scheme/shared"]],"module"],
["scheme/signature",">scheme/scheme_signature.html",[9,[0,"scheme/signature"]],false],
["scheme/signature",">scheme/scheme_signature.html",[9,[0,"scheme/signature"]],"module"],
["scheme/splicing",">scheme/scheme_splicing.html",[9,[0,"scheme/splicing"]],false],
["scheme/splicing",">scheme/scheme_splicing.html",[9,[0,"scheme/splicing"]],"module"],
["scheme/string",">scheme/scheme_string.html",[9,[0,"scheme/string"]],false],
["scheme/string",">scheme/scheme_string.html",[9,[0,"scheme/string"]],"module"],
["scheme/struct-info",">scheme/scheme_struct-info.html",[9,[0,"scheme/struct-info"]],false],
["scheme/struct-info",">scheme/scheme_struct-info.html",[9,[0,"scheme/struct-info"]],"module"],
["scheme/stxparam",">scheme/scheme_stxparam.html",[9,[0,"scheme/stxparam"]],false],
["scheme/stxparam",">scheme/scheme_stxparam.html",[9,[0,"scheme/stxparam"]],"module"],
["scheme/stxparam-exptime",">scheme/scheme_stxparam-exptime.html",[9,[0,"scheme/stxparam-exptime"]],false],
["scheme/stxparam-exptime",">scheme/scheme_stxparam-exptime.html",[9,[0,"scheme/stxparam-exptime"]],"module"],
["scheme/surrogate",">scheme/scheme_surrogate.html",[9,[0,"scheme/surrogate"]],false],
["scheme/surrogate",">scheme/scheme_surrogate.html",[9,[0,"scheme/surrogate"]],"module"],
["scheme/system",">scheme/scheme_system.html",[9,[0,"scheme/system"]],false],
["scheme/system",">scheme/scheme_system.html",[9,[0,"scheme/system"]],"module"],
["scheme/tcp",">scheme/scheme_tcp.html",[9,[0,"scheme/tcp"]],false],
["scheme/tcp",">scheme/scheme_tcp.html",[9,[0,"scheme/tcp"]],"module"],
["scheme/trait",">scheme/scheme_trait.html",[9,[0,"scheme/trait"]],false],
["scheme/trait",">scheme/scheme_trait.html",[9,[0,"scheme/trait"]],"module"],
["scheme/udp",">scheme/scheme_udp.html",[9,[0,"scheme/udp"]],false],
["scheme/udp",">scheme/scheme_udp.html",[9,[0,"scheme/udp"]],"module"],
["scheme/unit",">scheme/scheme_unit.html",[9,[0,"scheme/unit"]],false],
["scheme/unit",">scheme/scheme_unit.html",[9,[0,"scheme/unit"]],"module"],
["scheme/unit-exptime",">scheme/scheme_unit-exptime.html",[9,[0,"scheme/unit-exptime"]],false],
["scheme/unit-exptime",">scheme/scheme_unit-exptime.html",[9,[0,"scheme/unit-exptime"]],"module"],
["scheme/unsafe/ops",">scheme/scheme_unsafe_ops.html",[9,[0,"scheme/unsafe/ops"]],false],
["scheme/unsafe/ops",">scheme/scheme_unsafe_ops.html",[9,[0,"scheme/unsafe/ops"]],"module"],
["scheme/vector",">scheme/scheme_vector.html",[9,[0,"scheme/vector"]],false],
["scheme/vector",">scheme/scheme_vector.html",[9,[0,"scheme/vector"]],"module"],
["scheme: compatibility libraries and executables",">scheme/index.html","Scheme: Compatibility Libraries and Executables",false],
["scheme:add-coloring-preferences-panel",">framework/Backwards_Compatibility.html#(form._((lib._framework/main..rkt)._scheme~3aadd-coloring-preferences-panel))",[0,[1,"scheme:add-coloring-preferences-panel"]],["framework"]],
["scheme:add-preferences-panel",">framework/Backwards_Compatibility.html#(form._((lib._framework/main..rkt)._scheme~3aadd-preferences-panel))",[0,[1,"scheme:add-preferences-panel"]],["framework"]],
["scheme:get-color-prefs-table",">framework/Backwards_Compatibility.html#(form._((lib._framework/main..rkt)._scheme~3aget-color-prefs-table))",[0,[1,"scheme:get-color-prefs-table"]],["framework"]],
["scheme:get-keymap",">framework/Backwards_Compatibility.html#(form._((lib._framework/main..rkt)._scheme~3aget-keymap))",[0,[1,"scheme:get-keymap"]],["framework"]],
["scheme:get-white-on-black-color-prefs-table",">framework/Backwards_Compatibility.html#(form._((lib._framework/main..rkt)._scheme~3aget-white-on-black-color-prefs-table))",[0,[1,"scheme:get-white-on-black-color-prefs-table"]],["framework"]],
["scheme:get-wordbreak-map",">framework/Backwards_Compatibility.html#(form._((lib._framework/main..rkt)._scheme~3aget-wordbreak-map))",[0,[1,"scheme:get-wordbreak-map"]],["framework"]],
["scheme:init-wordbreak-map",">framework/Backwards_Compatibility.html#(form._((lib._framework/main..rkt)._scheme~3ainit-wordbreak-map))",[0,[1,"scheme:init-wordbreak-map"]],["framework"]],
["scheme:set-mode-mixin",">framework/Backwards_Compatibility.html#(form._((lib._framework/main..rkt)._scheme~3aset-mode-mixin))",[0,[1,"scheme:set-mode-mixin"]],["framework"]],
["scheme:setup-keymap",">framework/Backwards_Compatibility.html#(form._((lib._framework/main..rkt)._scheme~3asetup-keymap))",[0,[1,"scheme:setup-keymap"]],["framework"]],
["scheme:sexp-snip%",">framework/Backwards_Compatibility.html#(form._((lib._framework/main..rkt)._scheme~3asexp-snip~25))",[0,[1,"scheme:sexp-snip%"]],["framework"]],
["scheme:sexp-snip<%>",">framework/Backwards_Compatibility.html#(form._((lib._framework/main..rkt)._scheme~3asexp-snip~3c~25~3e))",[0,[1,"scheme:sexp-snip<%>"]],["framework"]],
["scheme:short-sym->pref-name",">framework/Backwards_Compatibility.html#(form._((lib._framework/main..rkt)._scheme~3ashort-sym-~3epref-name))",[0,[1,"scheme:short-sym->pref-name"]],["framework"]],
["scheme:short-sym->style-name",">framework/Backwards_Compatibility.html#(form._((lib._framework/main..rkt)._scheme~3ashort-sym-~3estyle-name))",[0,[1,"scheme:short-sym->style-name"]],["framework"]],
["scheme:text%",">framework/Backwards_Compatibility.html#(form._((lib._framework/main..rkt)._scheme~3atext~25))",[0,[1,"scheme:text%"]],["framework"]],
["scheme:text-balanced?",">framework/Backwards_Compatibility.html#(form._((lib._framework/main..rkt)._scheme~3atext-balanced~3f))",[0,[1,"scheme:text-balanced?"]],["framework"]],
["scheme:text-mixin",">framework/Backwards_Compatibility.html#(form._((lib._framework/main..rkt)._scheme~3atext-mixin))",[0,[1,"scheme:text-mixin"]],["framework"]],
["scheme:text-mode%",">framework/Backwards_Compatibility.html#(form._((lib._framework/main..rkt)._scheme~3atext-mode~25))",[0,[1,"scheme:text-mode%"]],["framework"]],
["scheme:text-mode-mixin",">framework/Backwards_Compatibility.html#(form._((lib._framework/main..rkt)._scheme~3atext-mode-mixin))",[0,[1,"scheme:text-mode-mixin"]],["framework"]],
["scheme:text-mode<%>",">framework/Backwards_Compatibility.html#(form._((lib._framework/main..rkt)._scheme~3atext-mode~3c~25~3e))",[0,[1,"scheme:text-mode<%>"]],["framework"]],
["scheme:text<%>",">framework/Backwards_Compatibility.html#(form._((lib._framework/main..rkt)._scheme~3atext~3c~25~3e))",[0,[1,"scheme:text<%>"]],["framework"]],
["scheme_add_atexit_closer",">inside/Custodians.html#(idx._(gentag._539._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_add_atexit_closer"]],false],
["scheme_add_evt",">inside/threads.html#(idx._(gentag._356._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_add_evt"]],false],
["scheme_add_evt_through_sema",">inside/threads.html#(idx._(gentag._357._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_add_evt_through_sema"]],false],
["scheme_add_fd_eventmask",">inside/threads.html#(idx._(gentag._355._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_add_fd_eventmask"]],false],
["scheme_add_fd_handle",">inside/threads.html#(idx._(gentag._354._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_add_fd_handle"]],false],
["scheme_add_finalizer",">inside/im_memoryalloc.html#(idx._(gentag._257._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_add_finalizer"]],false],
["scheme_add_finalizer_once",">inside/im_memoryalloc.html#(idx._(gentag._259._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_add_finalizer_once"]],false],
["scheme_add_gc_callback",">inside/im_memoryalloc.html#(idx._(gentag._270._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_add_gc_callback"]],false],
["scheme_add_global",">inside/im_env.html#(idx._(gentag._275._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_add_global"]],false],
["scheme_add_global_symbol",">inside/im_env.html#(idx._(gentag._276._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_add_global_symbol"]],false],
["scheme_add_managed",">inside/Custodians.html#(idx._(gentag._535._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_add_managed"]],false],
["scheme_add_scheme_finalizer",">inside/im_memoryalloc.html#(idx._(gentag._258._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_add_scheme_finalizer"]],false],
["scheme_add_scheme_finalizer_once",">inside/im_memoryalloc.html#(idx._(gentag._260._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_add_scheme_finalizer_once"]],false],
["scheme_add_swap_callback",">inside/threads.html#(idx._(gentag._366._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_add_swap_callback"]],false],
["scheme_add_swap_out_callback",">inside/threads.html#(idx._(gentag._367._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_add_swap_out_callback"]],false],
["scheme_add_to_table",">inside/Miscellaneous_Utilities.html#(idx._(gentag._569._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_add_to_table"]],false],
["scheme_alloc_byte_string",">inside/im_values_types.html#(idx._(gentag._173._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_alloc_byte_string"]],false],
["scheme_alloc_char_string",">inside/im_values_types.html#(idx._(gentag._183._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_alloc_char_string"]],false],
["scheme_alloc_flvector",">inside/im_values_types.html#(idx._(gentag._197._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_alloc_flvector"]],false],
["scheme_alloc_fxvector",">inside/im_values_types.html#(idx._(gentag._198._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_alloc_fxvector"]],false],
["scheme_allow_set_undefined",">inside/Flags_and_Hooks.html#(idx._(gentag._589._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_allow_set_undefined"]],false],
["scheme_append",">inside/Miscellaneous_Utilities.html#(idx._(gentag._557._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_append"]],false],
["scheme_append_byte_string",">inside/im_values_types.html#(idx._(gentag._174._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_append_byte_string"]],false],
["scheme_append_char_string",">inside/im_values_types.html#(idx._(gentag._184._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_append_char_string"]],false],
["scheme_apply",">inside/Evaluation.html#(idx._(gentag._301._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_apply"]],false],
["scheme_apply_multi",">inside/Evaluation.html#(idx._(gentag._302._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_apply_multi"]],false],
["scheme_apply_to_list",">inside/Evaluation.html#(idx._(gentag._305._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_apply_to_list"]],false],
["scheme_banner",">inside/Miscellaneous_Utilities.html#(idx._(gentag._576._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_banner"]],false],
["scheme_basic_env",">inside/Evaluation.html#(idx._(gentag._299._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_basic_env"]],false],
["scheme_bignum_from_double",">inside/Bignums__Rationals__and_Complex_Numbers.html#(idx._(gentag._430._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_bignum_from_double"]],false],
["scheme_bignum_from_float",">inside/Bignums__Rationals__and_Complex_Numbers.html#(idx._(gentag._431._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_bignum_from_float"]],false],
["scheme_bignum_normalize",">inside/Bignums__Rationals__and_Complex_Numbers.html#(idx._(gentag._435._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_bignum_normalize"]],false],
["scheme_bignum_to_double",">inside/Bignums__Rationals__and_Complex_Numbers.html#(idx._(gentag._428._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_bignum_to_double"]],false],
["scheme_bignum_to_float",">inside/Bignums__Rationals__and_Complex_Numbers.html#(idx._(gentag._429._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_bignum_to_float"]],false],
["scheme_bignum_to_string",">inside/Bignums__Rationals__and_Complex_Numbers.html#(idx._(gentag._432._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_bignum_to_string"]],false],
["scheme_bignum_type",">inside/im_values_types.html#(idx._(gentag._45._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_bignum_type"]],false],
["scheme_bignump",">inside/im_values_types.html#(idx._(gentag._46._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_BIGNUMP"]],false],
["scheme_block_until",">inside/threads.html#(idx._(gentag._347._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_block_until"]],false],
["scheme_block_until_enable_break",">inside/threads.html#(idx._(gentag._348._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_block_until_enable_break"]],false],
["scheme_block_until_unless",">inside/threads.html#(idx._(gentag._349._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_block_until_unless"]],false],
["scheme_bool_type",">inside/im_values_types.html#(idx._(gentag._30._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_bool_type"]],false],
["scheme_boolp",">inside/im_values_types.html#(idx._(gentag._31._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_BOOLP"]],false],
["scheme_box",">inside/im_values_types.html#(idx._(gentag._199._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_box"]],false],
["scheme_box_type",">inside/im_values_types.html#(idx._(gentag._75._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_box_type"]],false],
["scheme_box_val",">inside/im_values_types.html#(idx._(gentag._76._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_BOX_VAL"]],false],
["scheme_boxp",">inside/im_values_types.html#(idx._(gentag._77._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_BOXP"]],false],
["scheme_break_thread",">inside/threads.html#(idx._(gentag._345._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_break_thread"]],false],
["scheme_break_waiting",">inside/threads.html#(idx._(gentag._346._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_break_waiting"]],false],
["scheme_bucket_from_table",">inside/Miscellaneous_Utilities.html#(idx._(gentag._572._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_bucket_from_table"]],false],
["scheme_bucket_table_type",">inside/im_values_types.html#(idx._(gentag._115._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_bucket_table_type"]],false],
["scheme_bucktp",">inside/im_values_types.html#(idx._(gentag._116._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_BUCKTP"]],false],
["scheme_build_list",">inside/Miscellaneous_Utilities.html#(idx._(gentag._548._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_build_list"]],false],
["scheme_build_mac_filename",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._515._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_build_mac_filename"]],false],
["scheme_builtin_value",">inside/im_env.html#(idx._(gentag._281._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_builtin_value"]],false],
["scheme_byte_ready",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._471._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_byte_ready"]],false],
["scheme_byte_str_val",">inside/im_values_types.html#(idx._(gentag._59._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_BYTE_STR_VAL"]],false],
["scheme_byte_string_to_char_string",">inside/im_values_types.html#(idx._(gentag._186._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_byte_string_to_char_string"]],false],
["scheme_byte_string_to_char_string_locale",">inside/im_values_types.html#(idx._(gentag._188._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_byte_string_to_char_string_locale"]],false],
["scheme_byte_string_type",">inside/im_values_types.html#(idx._(gentag._58._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_byte_string_type"]],false],
["scheme_byte_stringp",">inside/im_values_types.html#(idx._(gentag._61._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_BYTE_STRINGP"]],false],
["scheme_byte_strlen_val",">inside/im_values_types.html#(idx._(gentag._60._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_BYTE_STRLEN_VAL"]],false],
["scheme_caddr",">inside/Miscellaneous_Utilities.html#(idx._(gentag._554._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_caddr"]],false],
["scheme_cadr",">inside/Miscellaneous_Utilities.html#(idx._(gentag._553._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_cadr"]],false],
["scheme_call_enable_break",">inside/threads.html#(idx._(gentag._362._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_call_enable_break"]],false],
["scheme_calloc",">inside/im_memoryalloc.html#(idx._(gentag._234._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_calloc"]],false],
["scheme_car",">inside/im_values_types.html#(idx._(gentag._79._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_CAR"]],false],
["scheme_car",">inside/Miscellaneous_Utilities.html#(idx._(gentag._551._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_car"]],false],
["scheme_case_closure_type",">inside/im_values_types.html#(idx._(gentag._131._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_case_closure_type"]],false],
["scheme_case_sensitive",">inside/Flags_and_Hooks.html#(idx._(gentag._588._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_case_sensitive"]],false],
["scheme_cdr",">inside/im_values_types.html#(idx._(gentag._80._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_CDR"]],false],
["scheme_cdr",">inside/Miscellaneous_Utilities.html#(idx._(gentag._552._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_cdr"]],false],
["scheme_change_in_table",">inside/Miscellaneous_Utilities.html#(idx._(gentag._570._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_change_in_table"]],false],
["scheme_char_ready",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._472._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_char_ready"]],false],
["scheme_char_str_val",">inside/im_values_types.html#(idx._(gentag._55._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_CHAR_STR_VAL"]],false],
["scheme_char_string_to_byte_string",">inside/im_values_types.html#(idx._(gentag._185._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_char_string_to_byte_string"]],false],
["scheme_char_string_to_byte_string_locale",">inside/im_values_types.html#(idx._(gentag._187._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_char_string_to_byte_string_locale"]],false],
["scheme_char_string_to_path",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._509._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_char_string_to_path"]],false],
["scheme_char_string_type",">inside/im_values_types.html#(idx._(gentag._53._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_char_string_type"]],false],
["scheme_char_stringp",">inside/im_values_types.html#(idx._(gentag._57._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_CHAR_STRINGP"]],false],
["scheme_char_strlen_val",">inside/im_values_types.html#(idx._(gentag._56._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_CHAR_STRLEN_VAL"]],false],
["scheme_char_type",">inside/im_values_types.html#(idx._(gentag._32._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_char_type"]],false],
["scheme_char_val",">inside/im_values_types.html#(idx._(gentag._33._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_CHAR_VAL"]],false],
["scheme_charp",">inside/im_values_types.html#(idx._(gentag._34._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_CHARP"]],false],
["scheme_check_for_break",">inside/Flags_and_Hooks.html#(idx._(gentag._587._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_check_for_break"]],false],
["scheme_check_proc_arity",">inside/exceptions.html#(idx._(gentag._328._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_check_proc_arity"]],false],
["scheme_check_threads",">inside/threads.html#(idx._(gentag._351._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_check_threads"]],false],
["scheme_clear_escape",">inside/exceptions.html#(idx._(gentag._330._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_clear_escape"]],false],
["scheme_close_input_port",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._478._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_close_input_port"]],false],
["scheme_close_managed",">inside/Custodians.html#(idx._(gentag._538._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_close_managed"]],false],
["scheme_close_output_port",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._479._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_close_output_port"]],false],
["scheme_close_should_force_port_closed",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._524._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_close_should_force_port_closed"]],false],
["scheme_closed_prim_type",">inside/im_values_types.html#(idx._(gentag._127._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_closed_prim_type"]],false],
["scheme_collect_garbage",">inside/im_memoryalloc.html#(idx._(gentag._265._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_collect_garbage"]],false],
["scheme_compile",">inside/Evaluation.html#(idx._(gentag._312._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_compile"]],false],
["scheme_compiled_closure_type",">inside/im_values_types.html#(idx._(gentag._128._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_compiled_closure_type"]],false],
["scheme_complex_imaginary_part",">inside/Bignums__Rationals__and_Complex_Numbers.html#(idx._(gentag._445._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_complex_imaginary_part"]],false],
["scheme_complex_izi_type",">inside/im_values_types.html#(idx._(gentag._51._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_complex_izi_type"]],false],
["scheme_complex_izip",">inside/im_values_types.html#(idx._(gentag._52._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_COMPLEX_IZIP"]],false],
["scheme_complex_real_part",">inside/Bignums__Rationals__and_Complex_Numbers.html#(idx._(gentag._444._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_complex_real_part"]],false],
["scheme_complex_type",">inside/im_values_types.html#(idx._(gentag._49._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_complex_type"]],false],
["scheme_complexp",">inside/im_values_types.html#(idx._(gentag._50._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_COMPLEXP"]],false],
["scheme_console_output",">inside/Flags_and_Hooks.html#(idx._(gentag._586._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_console_output"]],false],
["scheme_console_printf",">inside/Flags_and_Hooks.html#(idx._(gentag._590._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_console_printf"]],false],
["scheme_cont_type",">inside/im_values_types.html#(idx._(gentag._129._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_cont_type"]],false],
["scheme_contract_error",">inside/exceptions.html#(idx._(gentag._324._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_contract_error"]],false],
["scheme_count_lines",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._476._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_count_lines"]],false],
["scheme_cpointer_type",">inside/im_values_types.html#(idx._(gentag._122._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_cpointer_type"]],false],
["scheme_cptr_type",">inside/im_values_types.html#(idx._(gentag._124._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_CPTR_TYPE"]],false],
["scheme_cptr_val",">inside/im_values_types.html#(idx._(gentag._123._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_CPTR_VAL"]],false],
["scheme_cptrp",">inside/im_values_types.html#(idx._(gentag._125._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_CPTRP"]],false],
["scheme_current_argument_stack",">inside/Procedures.html#(idx._(gentag._292._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_current_argument_stack"]],false],
["scheme_current_continuation_marks",">inside/exceptions.html#(idx._(gentag._334._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_current_continuation_marks"]],false],
["scheme_custodian_check_available",">inside/Custodians.html#(idx._(gentag._536._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_custodian_check_available"]],false],
["scheme_dbl_val",">inside/im_values_types.html#(idx._(gentag._40._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_DBL_VAL"]],false],
["scheme_dblp",">inside/im_values_types.html#(idx._(gentag._41._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_DBLP"]],false],
["scheme_debug_print",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._459._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_debug_print"]],false],
["scheme_detach_multiple_array",">inside/Evaluation.html#(idx._(gentag._315._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_detach_multiple_array"]],false],
["scheme_directory_exists",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._506._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_directory_exists"]],false],
["scheme_display",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._449._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_display"]],false],
["scheme_display_to_string",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._457._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_display_to_string"]],false],
["scheme_display_to_string_w_max",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._458._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_display_to_string_w_max"]],false],
["scheme_display_w_max",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._450._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_display_w_max"]],false],
["scheme_dont_gc_ptr",">inside/im_memoryalloc.html#(idx._(gentag._263._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_dont_gc_ptr"]],false],
["scheme_double_to_int",">inside/Miscellaneous_Utilities.html#(idx._(gentag._573._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_double_to_int"]],false],
["scheme_double_type",">inside/im_values_types.html#(idx._(gentag._38._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_double_type"]],false],
["scheme_dynamic_require",">inside/Miscellaneous_Utilities.html#(idx._(gentag._560._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_dynamic_require"]],false],
["scheme_dynamic_wind",">inside/exceptions.html#(idx._(gentag._329._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_dynamic_wind"]],false],
["scheme_enable_garbage_collection",">inside/im_memoryalloc.html#(idx._(gentag._266._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_enable_garbage_collection"]],false],
["scheme_end_atomic",">inside/threads.html#(idx._(gentag._364._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_end_atomic"]],false],
["scheme_end_atomic_no_swap",">inside/threads.html#(idx._(gentag._365._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_end_atomic_no_swap"]],false],
["scheme_end_stubborn_change",">inside/im_memoryalloc.html#(idx._(gentag._239._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_end_stubborn_change"]],false],
["scheme_eof",">inside/im_values_types.html#(idx._(gentag._141._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_eof"]],false],
["scheme_eofp",">inside/im_values_types.html#(idx._(gentag._142._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_EOFP"]],false],
["scheme_eq",">inside/Miscellaneous_Utilities.html#(idx._(gentag._540._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_eq"]],false],
["scheme_equal",">inside/Miscellaneous_Utilities.html#(idx._(gentag._542._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_equal"]],false],
["scheme_equal_hash_key",">inside/Miscellaneous_Utilities.html#(idx._(gentag._544._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_equal_hash_key"]],false],
["scheme_equal_hash_key2",">inside/Miscellaneous_Utilities.html#(idx._(gentag._545._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_equal_hash_key2"]],false],
["scheme_eqv",">inside/Miscellaneous_Utilities.html#(idx._(gentag._541._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_eqv"]],false],
["scheme_escaping_cont_type",">inside/im_values_types.html#(idx._(gentag._130._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_escaping_cont_type"]],false],
["scheme_eval",">inside/Evaluation.html#(idx._(gentag._294._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_eval"]],false],
["scheme_eval_compiled",">inside/Evaluation.html#(idx._(gentag._295._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_eval_compiled"]],false],
["scheme_eval_compiled_multi",">inside/Evaluation.html#(idx._(gentag._296._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_eval_compiled_multi"]],false],
["scheme_eval_string",">inside/Evaluation.html#(idx._(gentag._306._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_eval_string"]],false],
["scheme_eval_string_all",">inside/Evaluation.html#(idx._(gentag._308._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_eval_string_all"]],false],
["scheme_eval_string_multi",">inside/Evaluation.html#(idx._(gentag._307._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_eval_string_multi"]],false],
["scheme_exact_integerp",">inside/im_values_types.html#(idx._(gentag._136._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_EXACT_INTEGERP"]],false],
["scheme_exact_realp",">inside/im_values_types.html#(idx._(gentag._137._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_EXACT_REALP"]],false],
["scheme_exit",">inside/Flags_and_Hooks.html#(idx._(gentag._582._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_exit"]],false],
["scheme_expand",">inside/Evaluation.html#(idx._(gentag._313._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_expand"]],false],
["scheme_expand_filename",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._507._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_expand_filename"]],false],
["scheme_expand_string_filename",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._508._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_expand_string_filename"]],false],
["scheme_extend_config",">inside/config.html#(idx._(gentag._402._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_extend_config"]],false],
["scheme_false",">inside/im_values_types.html#(idx._(gentag._144._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_false"]],false],
["scheme_falsep",">inside/im_values_types.html#(idx._(gentag._145._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_FALSEP"]],false],
["scheme_file_exists",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._505._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_file_exists"]],false],
["scheme_finish_primitive_module",">inside/im_env.html#(idx._(gentag._284._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_finish_primitive_module"]],false],
["scheme_float_type",">inside/im_values_types.html#(idx._(gentag._42._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_float_type"]],false],
["scheme_float_val",">inside/im_values_types.html#(idx._(gentag._39._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_FLOAT_VAL"]],false],
["scheme_floatp",">inside/im_values_types.html#(idx._(gentag._138._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_FLOATP"]],false],
["scheme_flt_val",">inside/im_values_types.html#(idx._(gentag._43._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_FLT_VAL"]],false],
["scheme_fltp",">inside/im_values_types.html#(idx._(gentag._44._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_FLTP"]],false],
["scheme_flush_output",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._460._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_flush_output"]],false],
["scheme_flvec_els",">inside/im_values_types.html#(idx._(gentag._92._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_FLVEC_ELS"]],false],
["scheme_flvec_size",">inside/im_values_types.html#(idx._(gentag._91._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_FLVEC_SIZE"]],false],
["scheme_flvector_type",">inside/im_values_types.html#(idx._(gentag._90._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_flvector_type"]],false],
["scheme_flvectorp",">inside/im_values_types.html#(idx._(gentag._93._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_FLVECTORP"]],false],
["scheme_format",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._520._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_format"]],false],
["scheme_format_utf8",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._522._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_format_utf8"]],false],
["scheme_free_code",">inside/im_memoryalloc.html#(idx._(gentag._246._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_free_code"]],false],
["scheme_free_immobile_box",">inside/im_memoryalloc.html#(idx._(gentag._244._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_free_immobile_box"]],false],
["scheme_free_key",">inside/Miscellaneous_Utilities.html#(idx._(gentag._580._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_free_key"]],false],
["scheme_fxvector_type",">inside/im_values_types.html#(idx._(gentag._94._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_fxvector_type"]],false],
["scheme_fxvectorp",">inside/im_values_types.html#(idx._(gentag._95._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_FXVECTORP"]],false],
["scheme_gc_ptr_ok",">inside/im_memoryalloc.html#(idx._(gentag._264._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_gc_ptr_ok"]],false],
["scheme_get_byte",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._461._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_get_byte"]],false],
["scheme_get_byte_string",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._467._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_get_byte_string"]],false],
["scheme_get_byte_string_output",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._499._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_get_byte_string_output"]],false],
["scheme_get_bytes",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._469._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_get_bytes"]],false],
["scheme_get_char_string",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._468._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_get_char_string"]],false],
["scheme_get_env",">inside/im_env.html#(idx._(gentag._282._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_get_env"]],false],
["scheme_get_fdset",">inside/threads.html#(idx._(gentag._353._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_get_fdset"]],false],
["scheme_get_int_val",">inside/im_values_types.html#(idx._(gentag._161._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_get_int_val"]],false],
["scheme_get_long_long_val",">inside/im_values_types.html#(idx._(gentag._163._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_get_long_long_val"]],false],
["scheme_get_milliseconds",">inside/Miscellaneous_Utilities.html#(idx._(gentag._574._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_get_milliseconds"]],false],
["scheme_get_param",">inside/config.html#(idx._(gentag._398._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_get_param"]],false],
["scheme_get_place_table",">inside/Miscellaneous_Utilities.html#(idx._(gentag._578._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_get_place_table"]],false],
["scheme_get_port_fd",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._481._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_get_port_fd"]],false],
["scheme_get_port_file_descriptor",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._480._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_get_port_file_descriptor"]],false],
["scheme_get_port_socket",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._482._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_get_port_socket"]],false],
["scheme_get_process_milliseconds",">inside/Miscellaneous_Utilities.html#(idx._(gentag._575._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_get_process_milliseconds"]],false],
["scheme_get_sized_byte_string_output",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._500._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_get_sized_byte_string_output"]],false],
["scheme_get_thread_param",">inside/config.html#(idx._(gentag._400._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_get_thread_param"]],false],
["scheme_get_unsigned_int_val",">inside/im_values_types.html#(idx._(gentag._162._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_get_unsigned_int_val"]],false],
["scheme_get_unsigned_long_long_val",">inside/im_values_types.html#(idx._(gentag._164._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_get_unsigned_long_long_val"]],false],
["scheme_getc",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._462._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_getc"]],false],
["scheme_global_bucket",">inside/im_env.html#(idx._(gentag._278._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_global_bucket"]],false],
["scheme_hash_get",">inside/Miscellaneous_Utilities.html#(idx._(gentag._567._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_hash_get"]],false],
["scheme_hash_set",">inside/Miscellaneous_Utilities.html#(idx._(gentag._566._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_hash_set"]],false],
["scheme_hash_table_type",">inside/im_values_types.html#(idx._(gentag._113._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_hash_table_type"]],false],
["scheme_hashtp",">inside/im_values_types.html#(idx._(gentag._114._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_HASHTP"]],false],
["scheme_inherit_cells",">inside/config.html#(idx._(gentag._404._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_inherit_cells"]],false],
["scheme_init_collection_paths",">inside/Flags_and_Hooks.html#(idx._(gentag._594._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_init_collection_paths"]],false],
["scheme_init_collection_paths_post",">inside/Flags_and_Hooks.html#(idx._(gentag._593._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_init_collection_paths_post"]],false],
["scheme_inport_val",">inside/im_values_types.html#(idx._(gentag._102._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_INPORT_VAL"]],false],
["scheme_inportp",">inside/im_values_types.html#(idx._(gentag._103._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_INPORTP"]],false],
["scheme_input_port_record",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._503._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_input_port_record"]],false],
["scheme_input_port_type",">inside/im_values_types.html#(idx._(gentag._101._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_input_port_type"]],false],
["scheme_input_portp",">inside/im_values_types.html#(idx._(gentag._104._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_INPUT_PORTP"]],false],
["scheme_install_config",">inside/config.html#(idx._(gentag._403._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_install_config"]],false],
["scheme_int_val",">inside/im_values_types.html#(idx._(gentag._36._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_INT_VAL"]],false],
["scheme_integer_type",">inside/im_values_types.html#(idx._(gentag._35._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_integer_type"]],false],
["scheme_intern_exact_char_keyword",">inside/im_values_types.html#(idx._(gentag._195._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_intern_exact_char_keyword"]],false],
["scheme_intern_exact_char_symbol",">inside/im_values_types.html#(idx._(gentag._191._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_intern_exact_char_symbol"]],false],
["scheme_intern_exact_keyword",">inside/im_values_types.html#(idx._(gentag._194._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_intern_exact_keyword"]],false],
["scheme_intern_exact_symbol",">inside/im_values_types.html#(idx._(gentag._190._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_intern_exact_symbol"]],false],
["scheme_intern_symbol",">inside/im_values_types.html#(idx._(gentag._189._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_intern_symbol"]],false],
["scheme_intp",">inside/im_values_types.html#(idx._(gentag._37._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_INTP"]],false],
["scheme_is_exact",">inside/Bignums__Rationals__and_Complex_Numbers.html#(idx._(gentag._424._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_is_exact"]],false],
["scheme_is_inexact",">inside/Bignums__Rationals__and_Complex_Numbers.html#(idx._(gentag._425._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_is_inexact"]],false],
["scheme_is_struct_instance",">inside/Structures.html#(idx._(gentag._529._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_is_struct_instance"]],false],
["scheme_keyword_len",">inside/im_values_types.html#(idx._(gentag._73._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_KEYWORD_LEN"]],false],
["scheme_keyword_type",">inside/im_values_types.html#(idx._(gentag._71._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_keyword_type"]],false],
["scheme_keyword_val",">inside/im_values_types.html#(idx._(gentag._72._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_KEYWORD_VAL"]],false],
["scheme_keywordp",">inside/im_values_types.html#(idx._(gentag._74._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_KEYWORDP"]],false],
["scheme_list_length",">inside/Miscellaneous_Utilities.html#(idx._(gentag._549._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_list_length"]],false],
["scheme_list_to_vector",">inside/Miscellaneous_Utilities.html#(idx._(gentag._556._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_list_to_vector"]],false],
["scheme_load",">inside/Miscellaneous_Utilities.html#(idx._(gentag._562._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_load"]],false],
["scheme_load_extension",">inside/Miscellaneous_Utilities.html#(idx._(gentag._563._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_load_extension"]],false],
["scheme_lookup_global",">inside/im_env.html#(idx._(gentag._277._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_lookup_global"]],false],
["scheme_lookup_in_table",">inside/Miscellaneous_Utilities.html#(idx._(gentag._571._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_lookup_in_table"]],false],
["scheme_mac_path_to_spec",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._516._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_mac_path_to_spec"]],false],
["scheme_main_setup",">inside/im_memoryalloc.html#(idx._(gentag._248._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_main_setup"]],false],
["scheme_main_stack_setup",">inside/im_memoryalloc.html#(idx._(gentag._249._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_main_stack_setup"]],false],
["scheme_make_arg_lines_string",">inside/exceptions.html#(idx._(gentag._326._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_arg_lines_string"]],false],
["scheme_make_args_string",">inside/exceptions.html#(idx._(gentag._327._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_args_string"]],false],
["scheme_make_ascii_character",">inside/im_values_types.html#(idx._(gentag._153._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_ascii_character"]],false],
["scheme_make_bignum",">inside/Bignums__Rationals__and_Complex_Numbers.html#(idx._(gentag._426._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_bignum"]],false],
["scheme_make_bignum_from_unsigned",">inside/Bignums__Rationals__and_Complex_Numbers.html#(idx._(gentag._427._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_bignum_from_unsigned"]],false],
["scheme_make_bucket_table",">inside/Miscellaneous_Utilities.html#(idx._(gentag._568._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_bucket_table"]],false],
["scheme_make_byte_string",">inside/im_values_types.html#(idx._(gentag._169._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_byte_string"]],false],
["scheme_make_byte_string_input_port",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._497._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_byte_string_input_port"]],false],
["scheme_make_byte_string_output_port",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._498._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_byte_string_output_port"]],false],
["scheme_make_byte_string_without_copying",">inside/im_values_types.html#(idx._(gentag._170._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_byte_string_without_copying"]],false],
["scheme_make_char",">inside/im_values_types.html#(idx._(gentag._150._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_char"]],false],
["scheme_make_char_or_null",">inside/im_values_types.html#(idx._(gentag._151._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_char_or_null"]],false],
["scheme_make_char_string",">inside/im_values_types.html#(idx._(gentag._179._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_char_string"]],false],
["scheme_make_char_string_without_copying",">inside/im_values_types.html#(idx._(gentag._180._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_char_string_without_copying"]],false],
["scheme_make_character",">inside/im_values_types.html#(idx._(gentag._152._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_character"]],false],
["scheme_make_closed_prim",">inside/Procedures.html#(idx._(gentag._291._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_closed_prim"]],false],
["scheme_make_closed_prim_w_arity",">inside/Procedures.html#(idx._(gentag._290._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_closed_prim_w_arity"]],false],
["scheme_make_complex",">inside/Bignums__Rationals__and_Complex_Numbers.html#(idx._(gentag._443._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_complex"]],false],
["scheme_make_cptr",">inside/im_values_types.html#(idx._(gentag._202._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_cptr"]],false],
["scheme_make_custodian",">inside/Custodians.html#(idx._(gentag._534._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_custodian"]],false],
["scheme_make_double",">inside/im_values_types.html#(idx._(gentag._165._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_double"]],false],
["scheme_make_exact_symbol",">inside/im_values_types.html#(idx._(gentag._193._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_exact_symbol"]],false],
["scheme_make_external_cptr",">inside/im_values_types.html#(idx._(gentag._203._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_external_cptr"]],false],
["scheme_make_fd_input_port",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._494._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_fd_input_port"]],false],
["scheme_make_fd_output_port",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._495._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_fd_output_port"]],false],
["scheme_make_file_input_port",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._489._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_file_input_port"]],false],
["scheme_make_file_output_port",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._493._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_file_output_port"]],false],
["scheme_make_float",">inside/im_values_types.html#(idx._(gentag._166._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_float"]],false],
["scheme_make_folding_prim",">inside/Procedures.html#(idx._(gentag._287._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_folding_prim"]],false],
["scheme_make_hash_table",">inside/Miscellaneous_Utilities.html#(idx._(gentag._564._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_hash_table"]],false],
["scheme_make_hash_table_equal",">inside/Miscellaneous_Utilities.html#(idx._(gentag._565._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_hash_table_equal"]],false],
["scheme_make_input_port",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._484._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_input_port"]],false],
["scheme_make_integer",">inside/im_values_types.html#(idx._(gentag._154._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_integer"]],false],
["scheme_make_integer_value",">inside/im_values_types.html#(idx._(gentag._155._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_integer_value"]],false],
["scheme_make_integer_value_from_long_halves",">inside/im_values_types.html#(idx._(gentag._159._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_integer_value_from_long_halves"]],false],
["scheme_make_integer_value_from_long_long",">inside/im_values_types.html#(idx._(gentag._157._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_integer_value_from_long_long"]],false],
["scheme_make_integer_value_from_unsigned",">inside/im_values_types.html#(idx._(gentag._156._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_integer_value_from_unsigned"]],false],
["scheme_make_integer_value_from_unsigned_long_halves",">inside/im_values_types.html#(idx._(gentag._160._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_integer_value_from_unsigned_long_halves"]],false],
["scheme_make_integer_value_from_unsigned_long_long",">inside/im_values_types.html#(idx._(gentag._158._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_integer_value_from_unsigned_long_long"]],false],
["scheme_make_locale_string",">inside/im_values_types.html#(idx._(gentag._175._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_locale_string"]],false],
["scheme_make_named_file_input_port",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._491._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_named_file_input_port"]],false],
["scheme_make_namespace",">inside/Evaluation.html#(idx._(gentag._300._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_namespace"]],false],
["scheme_make_offset_cptr",">inside/im_values_types.html#(idx._(gentag._204._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_offset_cptr"]],false],
["scheme_make_offset_external_cptr",">inside/im_values_types.html#(idx._(gentag._205._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_offset_external_cptr"]],false],
["scheme_make_output_port",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._485._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_output_port"]],false],
["scheme_make_pair",">inside/im_values_types.html#(idx._(gentag._168._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_pair"]],false],
["scheme_make_path",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._511._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_path"]],false],
["scheme_make_path_without_copying",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._512._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_path_without_copying"]],false],
["scheme_make_port_type",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._483._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_port_type"]],false],
["scheme_make_prim",">inside/Procedures.html#(idx._(gentag._288._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_prim"]],false],
["scheme_make_prim_closure_w_arity",">inside/Procedures.html#(idx._(gentag._289._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_prim_closure_w_arity"]],false],
["scheme_make_prim_w_arity",">inside/Procedures.html#(idx._(gentag._285._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_prim_w_arity"]],false],
["scheme_make_provided_string",">inside/exceptions.html#(idx._(gentag._325._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_provided_string"]],false],
["scheme_make_rational",">inside/Bignums__Rationals__and_Complex_Numbers.html#(idx._(gentag._436._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_rational"]],false],
["scheme_make_sema",">inside/threads.html#(idx._(gentag._339._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_sema"]],false],
["scheme_make_sized_byte_string",">inside/im_values_types.html#(idx._(gentag._171._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_sized_byte_string"]],false],
["scheme_make_sized_char_string",">inside/im_values_types.html#(idx._(gentag._181._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_sized_char_string"]],false],
["scheme_make_sized_offset_byte_string",">inside/im_values_types.html#(idx._(gentag._172._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_sized_offset_byte_string"]],false],
["scheme_make_sized_offset_char_string",">inside/im_values_types.html#(idx._(gentag._182._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_sized_offset_char_string"]],false],
["scheme_make_sized_offset_path",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._514._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_sized_offset_path"]],false],
["scheme_make_sized_offset_utf8_string",">inside/im_values_types.html#(idx._(gentag._178._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_sized_offset_utf8_string"]],false],
["scheme_make_sized_path",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._513._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_sized_path"]],false],
["scheme_make_sized_utf8_string",">inside/im_values_types.html#(idx._(gentag._177._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_sized_utf8_string"]],false],
["scheme_make_stderr",">inside/Flags_and_Hooks.html#(idx._(gentag._585._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_stderr"]],false],
["scheme_make_stdin",">inside/Flags_and_Hooks.html#(idx._(gentag._583._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_stdin"]],false],
["scheme_make_stdout",">inside/Flags_and_Hooks.html#(idx._(gentag._584._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_stdout"]],false],
["scheme_make_struct_instance",">inside/Structures.html#(idx._(gentag._528._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_struct_instance"]],false],
["scheme_make_struct_names",">inside/Structures.html#(idx._(gentag._526._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_struct_names"]],false],
["scheme_make_struct_type",">inside/Structures.html#(idx._(gentag._525._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_struct_type"]],false],
["scheme_make_struct_values",">inside/Structures.html#(idx._(gentag._527._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_struct_values"]],false],
["scheme_make_symbol",">inside/im_values_types.html#(idx._(gentag._192._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_symbol"]],false],
["scheme_make_thread_cell",">inside/threads.html#(idx._(gentag._363._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_thread_cell"]],false],
["scheme_make_type",">inside/im_values_types.html#(idx._(gentag._201._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_type"]],false],
["scheme_make_utf8_string",">inside/im_values_types.html#(idx._(gentag._176._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_utf8_string"]],false],
["scheme_make_vector",">inside/im_values_types.html#(idx._(gentag._196._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_vector"]],false],
["scheme_make_weak_box",">inside/im_values_types.html#(idx._(gentag._200._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_make_weak_box"]],false],
["scheme_making_progress",">inside/threads.html#(idx._(gentag._358._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_making_progress"]],false],
["scheme_malloc",">inside/im_memoryalloc.html#(idx._(gentag._230._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_malloc"]],false],
["scheme_malloc_allow_interior",">inside/im_memoryalloc.html#(idx._(gentag._236._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_malloc_allow_interior"]],false],
["scheme_malloc_atomic",">inside/im_memoryalloc.html#(idx._(gentag._231._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_malloc_atomic"]],false],
["scheme_malloc_atomic_allow_interior",">inside/im_memoryalloc.html#(idx._(gentag._237._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_malloc_atomic_allow_interior"]],false],
["scheme_malloc_code",">inside/im_memoryalloc.html#(idx._(gentag._245._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_malloc_code"]],false],
["scheme_malloc_eternal",">inside/im_memoryalloc.html#(idx._(gentag._233._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_malloc_eternal"]],false],
["scheme_malloc_fail_ok",">inside/im_memoryalloc.html#(idx._(gentag._242._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_malloc_fail_ok"]],false],
["scheme_malloc_immobile_box",">inside/im_memoryalloc.html#(idx._(gentag._243._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_malloc_immobile_box"]],false],
["scheme_malloc_key",">inside/Miscellaneous_Utilities.html#(idx._(gentag._579._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_malloc_key"]],false],
["scheme_malloc_stubborn",">inside/im_memoryalloc.html#(idx._(gentag._238._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_malloc_stubborn"]],false],
["scheme_malloc_tagged",">inside/im_memoryalloc.html#(idx._(gentag._235._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_malloc_tagged"]],false],
["scheme_malloc_uncollectable",">inside/im_memoryalloc.html#(idx._(gentag._232._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_malloc_uncollectable"]],false],
["scheme_mcar",">inside/im_values_types.html#(idx._(gentag._83._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_MCAR"]],false],
["scheme_mcdr",">inside/im_values_types.html#(idx._(gentag._84._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_MCDR"]],false],
["scheme_module_bucket",">inside/im_env.html#(idx._(gentag._279._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_module_bucket"]],false],
["scheme_mpairp",">inside/im_values_types.html#(idx._(gentag._85._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_MPAIRP"]],false],
["scheme_mutable_pair_type",">inside/im_values_types.html#(idx._(gentag._82._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_mutable_pair_type"]],false],
["scheme_namespace_require",">inside/Miscellaneous_Utilities.html#(idx._(gentag._561._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_namespace_require"]],false],
["scheme_namespace_type",">inside/im_values_types.html#(idx._(gentag._120._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_namespace_type"]],false],
["scheme_namespacep",">inside/im_values_types.html#(idx._(gentag._121._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_NAMESPACEP"]],false],
["scheme_native_closure_type",">inside/im_values_types.html#(idx._(gentag._132._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_native_closure_type"]],false],
["scheme_need_wakeup",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._473._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_need_wakeup"]],false],
["scheme_new_param",">inside/config.html#(idx._(gentag._405._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_new_param"]],false],
["scheme_null",">inside/im_values_types.html#(idx._(gentag._139._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_null"]],false],
["scheme_nullp",">inside/im_values_types.html#(idx._(gentag._140._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_NULLP"]],false],
["scheme_numberp",">inside/im_values_types.html#(idx._(gentag._134._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_NUMBERP"]],false],
["scheme_open_input_file",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._490._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_open_input_file"]],false],
["scheme_open_output_file",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._492._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_open_output_file"]],false],
["scheme_os_getcwd",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._517._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_os_getcwd"]],false],
["scheme_os_setcwd",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._519._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_os_setcwd"]],false],
["scheme_outport_val",">inside/im_values_types.html#(idx._(gentag._106._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_OUTPORT_VAL"]],false],
["scheme_outportp",">inside/im_values_types.html#(idx._(gentag._107._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_OUTPORTP"]],false],
["scheme_output_port_record",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._504._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_output_port_record"]],false],
["scheme_output_port_type",">inside/im_values_types.html#(idx._(gentag._105._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_output_port_type"]],false],
["scheme_output_portp",">inside/im_values_types.html#(idx._(gentag._108._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_OUTPUT_PORTP"]],false],
["scheme_pair_type",">inside/im_values_types.html#(idx._(gentag._78._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_pair_type"]],false],
["scheme_pairp",">inside/im_values_types.html#(idx._(gentag._81._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_PAIRP"]],false],
["scheme_param_config",">inside/config.html#(idx._(gentag._407._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_param_config"]],false],
["scheme_path_len",">inside/im_values_types.html#(idx._(gentag._65._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_PATH_LEN"]],false],
["scheme_path_to_char_string",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._510._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_path_to_char_string"]],false],
["scheme_path_type",">inside/im_values_types.html#(idx._(gentag._62._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_path_type"]],false],
["scheme_path_val",">inside/im_values_types.html#(idx._(gentag._64._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_PATH_VAL"]],false],
["scheme_pathp",">inside/im_values_types.html#(idx._(gentag._66._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_PATHP"]],false],
["scheme_peek_byte",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._463._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_peek_byte"]],false],
["scheme_peek_byte_skip",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._465._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_peek_byte_skip"]],false],
["scheme_peekc",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._464._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_peekc"]],false],
["scheme_peekc_skip",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._466._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_peekc_skip"]],false],
["scheme_pipe",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._501._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_pipe"]],false],
["scheme_pipe_with_limit",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._502._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_pipe_with_limit"]],false],
["scheme_pop_break_enable",">inside/exceptions.html#(idx._(gentag._333._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_pop_break_enable"]],false],
["scheme_pop_continuation_frame",">inside/contmarks.html#(idx._(gentag._410._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_pop_continuation_frame"]],false],
["scheme_port_count_lines",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._488._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_port_count_lines"]],false],
["scheme_post_sema",">inside/threads.html#(idx._(gentag._340._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_post_sema"]],false],
["scheme_prim_type",">inside/im_values_types.html#(idx._(gentag._126._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_prim_type"]],false],
["scheme_primitive_module",">inside/im_env.html#(idx._(gentag._283._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_primitive_module"]],false],
["scheme_print_bytes",">inside/im_values_types.html#(idx._(gentag._207._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_print_bytes"]],false],
["scheme_print_string",">inside/im_values_types.html#(idx._(gentag._208._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_print_string"]],false],
["scheme_printf",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._521._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_printf"]],false],
["scheme_printf_utf8",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._523._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_printf_utf8"]],false],
["scheme_procp",">inside/im_values_types.html#(idx._(gentag._133._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_PROCP"]],false],
["scheme_proper_list_length",">inside/Miscellaneous_Utilities.html#(idx._(gentag._550._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_proper_list_length"]],false],
["scheme_push_break_enable",">inside/exceptions.html#(idx._(gentag._332._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_push_break_enable"]],false],
["scheme_push_continuation_frame",">inside/contmarks.html#(idx._(gentag._409._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_push_continuation_frame"]],false],
["scheme_put_byte_string",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._453._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_put_byte_string"]],false],
["scheme_put_char_string",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._454._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_put_char_string"]],false],
["scheme_raise_exn",">inside/exceptions.html#(idx._(gentag._318._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_raise_exn"]],false],
["scheme_rational_denominator",">inside/Bignums__Rationals__and_Complex_Numbers.html#(idx._(gentag._440._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_rational_denominator"]],false],
["scheme_rational_from_double",">inside/Bignums__Rationals__and_Complex_Numbers.html#(idx._(gentag._441._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_rational_from_double"]],false],
["scheme_rational_from_float",">inside/Bignums__Rationals__and_Complex_Numbers.html#(idx._(gentag._442._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_rational_from_float"]],false],
["scheme_rational_numerator",">inside/Bignums__Rationals__and_Complex_Numbers.html#(idx._(gentag._439._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_rational_numerator"]],false],
["scheme_rational_to_double",">inside/Bignums__Rationals__and_Complex_Numbers.html#(idx._(gentag._437._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_rational_to_double"]],false],
["scheme_rational_to_float",">inside/Bignums__Rationals__and_Complex_Numbers.html#(idx._(gentag._438._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_rational_to_float"]],false],
["scheme_rational_type",">inside/im_values_types.html#(idx._(gentag._47._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_rational_type"]],false],
["scheme_rationalp",">inside/im_values_types.html#(idx._(gentag._48._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_RATIONALP"]],false],
["scheme_read",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._446._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_read"]],false],
["scheme_read_bignum",">inside/Bignums__Rationals__and_Complex_Numbers.html#(idx._(gentag._433._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_read_bignum"]],false],
["scheme_read_bignum_bytes",">inside/Bignums__Rationals__and_Complex_Numbers.html#(idx._(gentag._434._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_read_bignum_bytes"]],false],
["scheme_real_to_double",">inside/im_values_types.html#(idx._(gentag._167._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_real_to_double"]],false],
["scheme_realp",">inside/im_values_types.html#(idx._(gentag._135._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_REALP"]],false],
["scheme_recur_equal",">inside/Miscellaneous_Utilities.html#(idx._(gentag._543._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_recur_equal"]],false],
["scheme_recur_equal_hash_key",">inside/Miscellaneous_Utilities.html#(idx._(gentag._546._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_recur_equal_hash_key"]],false],
["scheme_recur_equal_hash_key2",">inside/Miscellaneous_Utilities.html#(idx._(gentag._547._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_recur_equal_hash_key2"]],false],
["scheme_register_extension_global",">inside/im_memoryalloc.html#(idx._(gentag._247._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_register_extension_global"]],false],
["scheme_register_finalizer",">inside/im_memoryalloc.html#(idx._(gentag._256._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_register_finalizer"]],false],
["scheme_register_parameter",">inside/config.html#(idx._(gentag._406._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_register_parameter"]],false],
["scheme_register_process_global",">inside/Miscellaneous_Utilities.html#(idx._(gentag._581._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_register_process_global"]],false],
["scheme_register_static",">inside/im_memoryalloc.html#(idx._(gentag._253._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_register_static"]],false],
["scheme_register_tls_space",">inside/im_memoryalloc.html#(idx._(gentag._252._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_register_tls_space"]],false],
["scheme_remove_all_finalization",">inside/im_memoryalloc.html#(idx._(gentag._262._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_remove_all_finalization"]],false],
["scheme_remove_gc_callback",">inside/im_memoryalloc.html#(idx._(gentag._271._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_remove_gc_callback"]],false],
["scheme_remove_managed",">inside/Custodians.html#(idx._(gentag._537._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_remove_managed"]],false],
["scheme_seal_parameters",">inside/Flags_and_Hooks.html#(idx._(gentag._595._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_seal_parameters"]],false],
["scheme_security_check_file",">inside/security.html#(idx._(gentag._532._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_security_check_file"]],false],
["scheme_security_check_network",">inside/security.html#(idx._(gentag._533._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_security_check_network"]],false],
["scheme_sema_type",">inside/im_values_types.html#(idx._(gentag._111._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_sema_type"]],false],
["scheme_semap",">inside/im_values_types.html#(idx._(gentag._112._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_SEMAP"]],false],
["scheme_set_addon_path",">inside/Flags_and_Hooks.html#(idx._(gentag._592._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_set_addon_path"]],false],
["scheme_set_box",">inside/Miscellaneous_Utilities.html#(idx._(gentag._559._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_set_box"]],false],
["scheme_set_can_break",">inside/exceptions.html#(idx._(gentag._331._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_set_can_break"]],false],
["scheme_set_collects_path",">inside/Flags_and_Hooks.html#(idx._(gentag._591._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_set_collects_path"]],false],
["scheme_set_cont_mark",">inside/contmarks.html#(idx._(gentag._408._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_set_cont_mark"]],false],
["scheme_set_file_position",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._477._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_set_file_position"]],false],
["scheme_set_global_bucket",">inside/im_env.html#(idx._(gentag._280._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_set_global_bucket"]],false],
["scheme_set_param",">inside/config.html#(idx._(gentag._399._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_set_param"]],false],
["scheme_set_port_count_lines_fun",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._487._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_set_port_count_lines_fun"]],false],
["scheme_set_port_location_fun",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._486._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_set_port_location_fun"]],false],
["scheme_set_stack_base",">inside/im_memoryalloc.html#(idx._(gentag._250._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_set_stack_base"]],false],
["scheme_set_stack_bounds",">inside/im_memoryalloc.html#(idx._(gentag._251._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_set_stack_bounds"]],false],
["scheme_set_thread_param",">inside/config.html#(idx._(gentag._401._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_set_thread_param"]],false],
["scheme_set_type_equality",">inside/im_values_types.html#(idx._(gentag._209._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_set_type_equality"]],false],
["scheme_set_type_printer",">inside/im_values_types.html#(idx._(gentag._206._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_set_type_printer"]],false],
["scheme_signal_error",">inside/exceptions.html#(idx._(gentag._317._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_signal_error"]],false],
["scheme_signal_received",">inside/threads.html#(idx._(gentag._350._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_signal_received"]],false],
["scheme_socket_to_ports",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._496._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_socket_to_ports"]],false],
["scheme_strdup",">inside/im_memoryalloc.html#(idx._(gentag._240._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_strdup"]],false],
["scheme_strdup_eternal",">inside/im_memoryalloc.html#(idx._(gentag._241._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_strdup_eternal"]],false],
["scheme_struct_property_type",">inside/im_values_types.html#(idx._(gentag._100._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_struct_property_type"]],false],
["scheme_struct_ref",">inside/Structures.html#(idx._(gentag._530._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_struct_ref"]],false],
["scheme_struct_set",">inside/Structures.html#(idx._(gentag._531._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_struct_set"]],false],
["scheme_struct_type_type",">inside/im_values_types.html#(idx._(gentag._98._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_struct_type_type"]],false],
["scheme_struct_typep",">inside/im_values_types.html#(idx._(gentag._99._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_STRUCT_TYPEP"]],false],
["scheme_structp",">inside/im_values_types.html#(idx._(gentag._97._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_STRUCTP"]],false],
["scheme_structure_type",">inside/im_values_types.html#(idx._(gentag._96._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_structure_type"]],false],
["scheme_subtract_finalizer",">inside/im_memoryalloc.html#(idx._(gentag._261._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_subtract_finalizer"]],false],
["scheme_swap_thread",">inside/threads.html#(idx._(gentag._344._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_swap_thread"]],false],
["scheme_sym_len",">inside/im_values_types.html#(idx._(gentag._69._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_SYM_LEN"]],false],
["scheme_sym_val",">inside/im_values_types.html#(idx._(gentag._68._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_SYM_VAL"]],false],
["scheme_symbol_type",">inside/im_values_types.html#(idx._(gentag._67._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_symbol_type"]],false],
["scheme_symbolp",">inside/im_values_types.html#(idx._(gentag._70._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_SYMBOLP"]],false],
["scheme_tail_apply",">inside/Evaluation.html#(idx._(gentag._309._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_tail_apply"]],false],
["scheme_tail_apply_no_copy",">inside/Evaluation.html#(idx._(gentag._310._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_tail_apply_no_copy"]],false],
["scheme_tail_apply_to_list",">inside/Evaluation.html#(idx._(gentag._311._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_tail_apply_to_list"]],false],
["scheme_tell",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._474._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_tell"]],false],
["scheme_tell_line",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._475._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_tell_line"]],false],
["scheme_thread",">inside/threads.html#(idx._(gentag._337._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_thread"]],false],
["scheme_thread_block",">inside/threads.html#(idx._(gentag._342._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_thread_block"]],false],
["scheme_thread_block_enable_break",">inside/threads.html#(idx._(gentag._343._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_thread_block_enable_break"]],false],
["scheme_thread_type",">inside/im_values_types.html#(idx._(gentag._109._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_thread_type"]],false],
["scheme_thread_w_details",">inside/threads.html#(idx._(gentag._338._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_thread_w_details"]],false],
["scheme_threadp",">inside/im_values_types.html#(idx._(gentag._110._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_THREADP"]],false],
["scheme_tls_allocate",">inside/threads.html#(idx._(gentag._359._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_tls_allocate"]],false],
["scheme_tls_get",">inside/threads.html#(idx._(gentag._361._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_tls_get"]],false],
["scheme_tls_set",">inside/threads.html#(idx._(gentag._360._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_tls_set"]],false],
["scheme_true",">inside/im_values_types.html#(idx._(gentag._143._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_true"]],false],
["scheme_truep",">inside/im_values_types.html#(idx._(gentag._146._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_TRUEP"]],false],
["scheme_type",">inside/im_values_types.html#(idx._(gentag._28._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_TYPE"]],false],
["scheme_ucs4_to_utf16",">inside/im_encodings.html#(idx._(gentag._422._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_ucs4_to_utf16"]],false],
["scheme_unbound_global",">inside/exceptions.html#(idx._(gentag._323._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_unbound_global"]],false],
["scheme_unbox",">inside/Miscellaneous_Utilities.html#(idx._(gentag._558._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_unbox"]],false],
["scheme_undefined",">inside/im_values_types.html#(idx._(gentag._149._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_undefined"]],false],
["scheme_ungetc",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._470._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_ungetc"]],false],
["scheme_utf16_to_ucs4",">inside/im_encodings.html#(idx._(gentag._423._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_utf16_to_ucs4"]],false],
["scheme_utf8_decode",">inside/im_encodings.html#(idx._(gentag._411._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_utf8_decode"]],false],
["scheme_utf8_decode_all",">inside/im_encodings.html#(idx._(gentag._413._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_utf8_decode_all"]],false],
["scheme_utf8_decode_as_prefix",">inside/im_encodings.html#(idx._(gentag._412._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_utf8_decode_as_prefix"]],false],
["scheme_utf8_decode_count",">inside/im_encodings.html#(idx._(gentag._417._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_utf8_decode_count"]],false],
["scheme_utf8_decode_prefix",">inside/im_encodings.html#(idx._(gentag._414._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_utf8_decode_prefix"]],false],
["scheme_utf8_decode_to_buffer",">inside/im_encodings.html#(idx._(gentag._415._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_utf8_decode_to_buffer"]],false],
["scheme_utf8_decode_to_buffer_len",">inside/im_encodings.html#(idx._(gentag._416._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_utf8_decode_to_buffer_len"]],false],
["scheme_utf8_encode",">inside/im_encodings.html#(idx._(gentag._418._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_utf8_encode"]],false],
["scheme_utf8_encode_all",">inside/im_encodings.html#(idx._(gentag._419._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_utf8_encode_all"]],false],
["scheme_utf8_encode_to_buffer",">inside/im_encodings.html#(idx._(gentag._420._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_utf8_encode_to_buffer"]],false],
["scheme_utf8_encode_to_buffer_len",">inside/im_encodings.html#(idx._(gentag._421._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_utf8_encode_to_buffer_len"]],false],
["scheme_values",">inside/Evaluation.html#(idx._(gentag._314._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_values"]],false],
["scheme_vec_els",">inside/im_values_types.html#(idx._(gentag._88._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_VEC_ELS"]],false],
["scheme_vec_size",">inside/im_values_types.html#(idx._(gentag._87._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_VEC_SIZE"]],false],
["scheme_vector_to_list",">inside/Miscellaneous_Utilities.html#(idx._(gentag._555._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_vector_to_list"]],false],
["scheme_vector_type",">inside/im_values_types.html#(idx._(gentag._86._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_vector_type"]],false],
["scheme_vectorp",">inside/im_values_types.html#(idx._(gentag._89._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_VECTORP"]],false],
["scheme_version",">inside/Miscellaneous_Utilities.html#(idx._(gentag._577._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_version"]],false],
["scheme_void",">inside/im_values_types.html#(idx._(gentag._147._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_void"]],false],
["scheme_voidp",">inside/im_values_types.html#(idx._(gentag._148._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_VOIDP"]],false],
["scheme_wait_sema",">inside/threads.html#(idx._(gentag._341._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_wait_sema"]],false],
["scheme_wake_up",">inside/threads.html#(idx._(gentag._352._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_wake_up"]],false],
["scheme_warning",">inside/exceptions.html#(idx._(gentag._335._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_warning"]],false],
["scheme_weak_box_type",">inside/im_values_types.html#(idx._(gentag._117._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_weak_box_type"]],false],
["scheme_weak_ptr",">inside/im_values_types.html#(idx._(gentag._119._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_WEAK_PTR"]],false],
["scheme_weak_reference",">inside/im_memoryalloc.html#(idx._(gentag._254._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_weak_reference"]],false],
["scheme_weak_reference_indirect",">inside/im_memoryalloc.html#(idx._(gentag._255._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_weak_reference_indirect"]],false],
["scheme_weakp",">inside/im_values_types.html#(idx._(gentag._118._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"SCHEME_WEAKP"]],false],
["scheme_write",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._447._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_write"]],false],
["scheme_write_byte_string",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._451._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_write_byte_string"]],false],
["scheme_write_char_string",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._452._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_write_char_string"]],false],
["scheme_write_to_string",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._455._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_write_to_string"]],false],
["scheme_write_to_string_w_max",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._456._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_write_to_string_w_max"]],false],
["scheme_write_w_max",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._448._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_write_w_max"]],false],
["scheme_wrong_contract",">inside/exceptions.html#(idx._(gentag._320._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_wrong_contract"]],false],
["scheme_wrong_count",">inside/exceptions.html#(idx._(gentag._319._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_wrong_count"]],false],
["scheme_wrong_return_arity",">inside/exceptions.html#(idx._(gentag._322._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_wrong_return_arity"]],false],
["scheme_wrong_type",">inside/exceptions.html#(idx._(gentag._321._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"scheme_wrong_type"]],false],
["schemeblock",">scribble/scribble_manual_code.html#(form._((lib._scribble/manual..rkt)._.S.C.H.E.M.E.B.L.O.C.K))",[0,[1,"SCHEMEBLOCK"]],["scribble/manual"]],
["schemeblock",">scribble/scribble_manual_code.html#(form._((lib._scribble/manual..rkt)._schemeblock))",[0,[1,"schemeblock"]],["scribble/manual"]],
["schemeblock0",">scribble/scribble_manual_code.html#(form._((lib._scribble/manual..rkt)._.S.C.H.E.M.E.B.L.O.C.K0))",[0,[1,"SCHEMEBLOCK0"]],["scribble/manual"]],
["schemeblock0",">scribble/scribble_manual_code.html#(form._((lib._scribble/manual..rkt)._schemeblock0))",[0,[1,"schemeblock0"]],["scribble/manual"]],
["schemeerror",">scribble/scribble_manual_code.html#(def._((lib._scribble/manual..rkt)._schemeerror))",[0,[2,"schemeerror"]],["scribble/manual"]],
["schemeerror com event",">mzcom/index.html#(idx._(gentag._3._(lib._mzcom/mzcom..scrbl)))",[[6,"SchemeError"]," COM event"],false],
["schemefont",">scribble/scribble_manual_code.html#(def._((lib._scribble/manual..rkt)._schemefont))",[0,[2,"schemefont"]],["scribble/manual"]],
["schemegrammar",">scribble/doc-forms.html#(form._((lib._scribble/manual..rkt)._schemegrammar))",[0,[1,"schemegrammar"]],["scribble/manual"]],
["schemegrammar*",">scribble/doc-forms.html#(form._((lib._scribble/manual..rkt)._schemegrammar*))",[0,[1,"schemegrammar*"]],["scribble/manual"]],
["schemeid",">scribble/scribble_manual_code.html#(form._((lib._scribble/manual..rkt)._schemeid))",[0,[1,"schemeid"]],["scribble/manual"]],
["schemeidfont",">scribble/scribble_manual_code.html#(def._((lib._scribble/manual..rkt)._schemeidfont))",[0,[2,"schemeidfont"]],["scribble/manual"]],
["schemeinput",">scribble/scribble_manual_code.html#(form._((lib._scribble/manual..rkt)._schemeinput))",[0,[1,"schemeinput"]],["scribble/manual"]],
["schemekeywordfont",">scribble/scribble_manual_code.html#(def._((lib._scribble/manual..rkt)._schemekeywordfont))",[0,[2,"schemekeywordfont"]],["scribble/manual"]],
["schemelink",">scribble/section-links.html#(form._((lib._scribble/manual..rkt)._schemelink))",[0,[1,"schemelink"]],["scribble/manual"]],
["schememetafont",">scribble/scribble_manual_code.html#(def._((lib._scribble/manual..rkt)._schememetafont))",[0,[2,"schememetafont"]],["scribble/manual"]],
["schememod",">scribble/scribble_manual_code.html#(form._((lib._scribble/manual..rkt)._schememod))",[0,[1,"schememod"]],["scribble/manual"]],
["schememodfont",">scribble/scribble_manual_code.html#(def._((lib._scribble/manual..rkt)._schememodfont))",[0,[2,"schememodfont"]],["scribble/manual"]],
["schememodlink",">scribble/scribble_manual_code.html#(form._((lib._scribble/manual..rkt)._schememodlink))",[0,[1,"schememodlink"]],["scribble/manual"]],
["schememodname",">scribble/scribble_manual_code.html#(form._((lib._scribble/manual..rkt)._schememodname))",[0,[1,"schememodname"]],["scribble/manual"]],
["schemeoutput",">scribble/scribble_manual_code.html#(def._((lib._scribble/manual..rkt)._schemeoutput))",[0,[2,"schemeoutput"]],["scribble/manual"]],
["schemeparenfont",">scribble/scribble_manual_code.html#(def._((lib._scribble/manual..rkt)._schemeparenfont))",[0,[2,"schemeparenfont"]],["scribble/manual"]],
["schemeresult",">scribble/scribble_manual_code.html#(form._((lib._scribble/manual..rkt)._schemeresult))",[0,[1,"schemeresult"]],["scribble/manual"]],
["schemeresultfont",">scribble/scribble_manual_code.html#(def._((lib._scribble/manual..rkt)._schemeresultfont))",[0,[2,"schemeresultfont"]],["scribble/manual"]],
["schemevalfont",">scribble/scribble_manual_code.html#(def._((lib._scribble/manual..rkt)._schemevalfont))",[0,[2,"schemevalfont"]],["scribble/manual"]],
["schemevarfont",">scribble/scribble_manual_code.html#(def._((lib._scribble/manual..rkt)._schemevarfont))",[0,[2,"schemevarfont"]],["scribble/manual"]],
["scientific",">planet/Developing_Packages_for_PLaneT.html#(idx._(gentag._10._(lib._planet/planet..scrbl)))",[7,"'scientific"],false],
["scope",">reference/syntax-model.html#(tech._scope)","<span style=\"font-style: italic\">scope</span>",false],
["scoring",">games/same.html#(part._.Scoring)","Scoring",false],
["screen resolution",">gui/Windowing_Functions.html#(idx._(gentag._147._(lib._scribblings/gui/gui..scrbl)))","screen resolution",false],
["screen->client",">gui/window___.html#(meth._(((lib._mred/main..rkt)._window~3c~25~3e)._screen-~3eclient))",[[0,[2,"screen->client"]],[14,[" (method of ",[0,[2,"window<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["screen-glyph-exists?",">draw/font_.html#(meth._(((lib._racket/draw..rkt)._font~25)._screen-glyph-exists~3f))",[[0,[2,"screen-glyph-exists?"]],[14,[" (method of ",[0,[2,"font%"]],")"]]],["racket/draw"]],
["screen_gamma",">draw/bitmap_.html#(idx._(gentag._6._(lib._scribblings/draw/draw..scrbl)))",[6,"SCREEN_GAMMA"],false],
["scribble documentation",">planet/Utility_Libraries.html#(part._scribble..rkt)","Scribble Documentation",false],
["scribble layers",">scribble/layers.html","Scribble Layers",false],
["scribble lexer",">syntax-color/index.html#(part._.Scribble_.Lexer)","Scribble Lexer",false],
["scribble-eval-handler",">scribble/eval.html#(def._((lib._scribble/eval..rkt)._scribble-eval-handler))",[0,[2,"scribble-eval-handler"]],["scribble/eval"]],
["scribble-inside-lexer",">syntax-color/index.html#(def._((lib._syntax-color/scribble-lexer..rkt)._scribble-inside-lexer))",[0,[2,"scribble-inside-lexer"]],["syntax-color/scribble-lexer"]],
["scribble-lexer",">syntax-color/index.html#(def._((lib._syntax-color/scribble-lexer..rkt)._scribble-lexer))",[0,[2,"scribble-lexer"]],["syntax-color/scribble-lexer"]],
["scribble/base",">scribble/base.html",[9,[0,"scribble/base"]],"module"],
["scribble/base-render",">scribble/renderer.html#(mod-path._scribble/base-render)",[9,[0,"scribble/base-render"]],"module"],
["scribble/basic",">scribble/Compatibility_Libraries.html#(mod-path._scribble/basic)",[9,[0,"scribble/basic"]],"module"],
["scribble/bnf",">scribble/bnf.html",[9,[0,"scribble/bnf"]],"module"],
["scribble/comment-reader",">scribble/scribble_manual_code.html#(mod-path._scribble/comment-reader)",[9,[0,"scribble/comment-reader"]],"module"],
["scribble/core",">scribble/core.html",[9,[0,"scribble/core"]],"module"],
["scribble/decode",">scribble/decode.html",[9,[0,"scribble/decode"]],"module"],
["scribble/doc",">scribble/docreader.html",[9,[0,"scribble/doc"]],"module"],
["scribble/doclang",">scribble/doclang.html",[9,[0,"scribble/doclang"]],"module"],
["scribble/eval",">scribble/eval.html",[9,[0,"scribble/eval"]],"module"],
["scribble/extract",">scribble/srcdoc.html#(mod-path._scribble/extract)",[9,[0,"scribble/extract"]],"module"],
["scribble/html-properties",">scribble/core.html#(mod-path._scribble/html-properties)",[9,[0,"scribble/html-properties"]],"module"],
["scribble/html-render",">scribble/renderer.html#(mod-path._scribble/html-render)",[9,[0,"scribble/html-render"]],"module"],
["scribble/jfp",">scribble/JFP_Paper_Format.html",[9,[0,"scribble/jfp"]],"module"],
["scribble/latex-properties",">scribble/core.html#(mod-path._scribble/latex-properties)",[9,[0,"scribble/latex-properties"]],"module"],
["scribble/latex-render",">scribble/renderer.html#(mod-path._scribble/latex-render)",[9,[0,"scribble/latex-render"]],"module"],
["scribble/lncs",">scribble/LNCS_Paper_Format.html",[9,[0,"scribble/lncs"]],"module"],
["scribble/lp",">scribble/lp.html#(mod-path._scribble/lp)",[9,[0,"scribble/lp"]],"module"],
["scribble/lp language",">scribble/lp.html#(part._scribble_lp_.Language)",[[9,[0,"scribble/lp"]]," Language"],false],
["scribble/lp-include",">scribble/lp.html#(mod-path._scribble/lp-include)",[9,[0,"scribble/lp-include"]],"module"],
["scribble/lp-include module",">scribble/lp.html#(part._scribble_lp-include_.Module)",[[9,[0,"scribble/lp-include"]]," Module"],false],
["scribble/manual",">scribble/manual.html",[9,[0,"scribble/manual"]],"module"],
["scribble/manual-struct",">scribble/index-entries.html",[9,[0,"scribble/manual-struct"]],"module"],
["scribble/pdf-render",">scribble/renderer.html#(mod-path._scribble/pdf-render)",[9,[0,"scribble/pdf-render"]],"module"],
["scribble/racket",">scribble/scheme.html",[9,[0,"scribble/racket"]],"module"],
["scribble/reader",">scribble/reader-internals.html#(mod-path._scribble/reader)",[9,[0,"scribble/reader"]],"module"],
["scribble/render",">scribble/renderer.html#(mod-path._scribble/render)",[9,[0,"scribble/render"]],"module"],
["scribble/scheme",">scribble/scheme.html",[9,[0,"scribble/scheme"]],"module"],
["scribble/sigplan",">scribble/SIGPLAN_Paper_Format.html",[9,[0,"scribble/sigplan"]],"module"],
["scribble/srcdoc",">scribble/srcdoc.html#(mod-path._scribble/srcdoc)",[9,[0,"scribble/srcdoc"]],"module"],
["scribble/struct",">scribble/Compatibility_Libraries.html#(mod-path._scribble/struct)",[9,[0,"scribble/struct"]],"module"],
["scribble/text",">scribble/text.html",[9,[0,"scribble/text"]],"module"],
["scribble/text-render",">scribble/renderer.html#(mod-path._scribble/text-render)",[9,[0,"scribble/text-render"]],"module"],
["scribble/xref",">scribble/xref.html",[9,[0,"scribble/xref"]],"module"],
["scribble: the racket documentation tool",">scribble/index.html","Scribble: The Racket Documentation Tool",false],
["scribble:current-render-mode",">scribble/core.html#(idx._(gentag._12._(lib._scribblings/scribble/scribble..scrbl)))",[7,"'scribble:current-render-mode"],false],
["scribbling documentation",">scribble/plt-manuals.html","Scribbling Documentation",false],
["scribblings",">raco/running.html#(idx._(gentag._11._(lib._scribblings/raco/raco..scrbl)))",[0,"scribblings"],false],
["scribblings",">raco/API_for_Raw_Compilation.html#(idx._(gentag._34._(lib._scribblings/raco/raco..scrbl)))",[0,"scribblings"],false],
["scriblib/autobib",">scriblib/autobib.html",[9,[0,"scriblib/autobib"]],"module"],
["scriblib/bibtex",">scriblib/bibtex.html",[9,[0,"scriblib/bibtex"]],"module"],
["scriblib/figure",">scriblib/figure.html",[9,[0,"scriblib/figure"]],"module"],
["scriblib/footnote",">scriblib/footnotes.html",[9,[0,"scriblib/footnote"]],"module"],
["scriblib/gui-eval",">scriblib/gui-eval.html",[9,[0,"scriblib/gui-eval"]],"module"],
["scriblib/render-cond",">scriblib/render-cond.html",[9,[0,"scriblib/render-cond"]],"module"],
["scriblib: extra scribble libraries",">scriblib/index.html","Scriblib: Extra Scribble Libraries",false],
["script",">html/index.html#(def._((lib._html/main..rkt)._script))",[0,[2,"script"]],["html"]],
["script",">gui/style-delta_.html#(idx._(gentag._198._(lib._scribblings/gui/gui..scrbl)))",[7,"'script"],false],
["script",">draw/font_.html#(idx._(gentag._31._(lib._scribblings/draw/draw..scrbl)))",[7,"'script"],false],
["script-property",">scribble/core.html#(def._((lib._scribble/html-properties..rkt)._script-property))",[0,[2,"script-property"]],["scribble/html-properties"]],
["script-property-script",">scribble/core.html#(def._((lib._scribble/html-properties..rkt)._script-property-script))",[0,[2,"script-property-script"]],["scribble/html-properties"]],
["script-property-type",">scribble/core.html#(def._((lib._scribble/html-properties..rkt)._script-property-type))",[0,[2,"script-property-type"]],["scribble/html-properties"]],
["script-property?",">scribble/core.html#(def._((lib._scribble/html-properties..rkt)._script-property~3f))",[0,[2,"script-property?"]],["scribble/html-properties"]],
["script?",">html/index.html#(def._((lib._html/main..rkt)._script~3f))",[0,[2,"script?"]],["html"]],
["scripting evaluation and using load",">guide/load.html",["Scripting Evaluation and Using ",[0,[2,"load"]]],false],
["scripts",">guide/scripts.html","Scripts",false],
["scroll",">gui/canvas_.html#(meth._(((lib._mred/main..rkt)._canvas~25)._scroll))",[[0,[2,"scroll"]],[14,[" (method of ",[0,[2,"canvas%"]],")"]]],["racket/gui/base","racket/gui"]],
["scroll",">gui/key-event_.html#(idx._(gentag._105._(lib._scribblings/gui/gui..scrbl)))",[7,"'scroll"],false],
["scroll-editor-to",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._scroll-editor-to))",[[0,[2,"scroll-editor-to"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["scroll-editor-to",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3afirst-line-mixin)._scroll-editor-to))",[[0,[2,"scroll-editor-to"]],[14,[" (method of ",[0,[2,"text:first-line-mixin"]],")"]]],["framework"]],
["scroll-event%",">gui/scroll-event_.html",[0,[2,"scroll-event%"]],["racket/gui/base","racket/gui"]],
["scroll-line-location",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._scroll-line-location))",[[0,[2,"scroll-line-location"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["scroll-to",">gui/editor-admin_.html#(meth._(((lib._mred/main..rkt)._editor-admin~25)._scroll-to))",[[0,[2,"scroll-to"]],[14,[" (method of ",[0,[2,"editor-admin%"]],")"]]],["racket/gui/base","racket/gui"]],
["scroll-to",">gui/editor-canvas_.html#(meth._(((lib._mred/main..rkt)._editor-canvas~25)._scroll-to))",[[0,[2,"scroll-to"]],[14,[" (method of ",[0,[2,"editor-canvas%"]],")"]]],["racket/gui/base","racket/gui"]],
["scroll-to",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._scroll-to))",[[0,[2,"scroll-to"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["scroll-to",">gui/snip-admin_.html#(meth._(((lib._racket/snip..rkt)._snip-admin~25)._scroll-to))",[[0,[2,"scroll-to"]],[14,[" (method of ",[0,[2,"snip-admin%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["scroll-to-position",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._scroll-to-position))",[[0,[2,"scroll-to-position"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["scroll-with-bottom-base",">gui/editor-canvas_.html#(meth._(((lib._mred/main..rkt)._editor-canvas~25)._scroll-with-bottom-base))",[[0,[2,"scroll-with-bottom-base"]],[14,[" (method of ",[0,[2,"editor-canvas%"]],")"]]],["racket/gui/base","racket/gui"]],
["sd",">teachpack/world.html#(tech._sd)","<span style=\"font-style: italic\">SD</span>",false],
["se-path*",">xml/index.html#(def._((lib._xml/path..rkt)._se-path*))",[0,[2,"se-path*"]],["xml/path"]],
["se-path*/list",">xml/index.html#(def._((lib._xml/path..rkt)._se-path*/list))",[0,[2,"se-path*/list"]],["xml/path"]],
["se-path?",">xml/index.html#(def._((lib._xml/path..rkt)._se-path~3f))",[0,[2,"se-path?"]],["xml/path"]],
["sealed",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_300",[0,[1,"sealed"]],["rnrs/records/syntactic-6"]],
["search",">drracket/Keyboard_Shortcuts.html#(part._.Search)","Search",false],
["search",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3asearchable~3c~25~3e)._search))",[[0,[2,"search"]],[14,[" (method of ",[0,[2,"frame:searchable<%>"]],")"]]],["framework"]],
["search anchor",">drracket/Searching.html#(tech._search._anchor)","<span style=\"font-style: italic\">search anchor</span>",false],
["search in files... menu item",">drracket/Menus.html#(idx._(gentag._69._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Search in Files...</span> menu item",false],
["search!",">syntax-color/index.html#(meth._(((lib._syntax-color/token-tree..rkt)._token-tree~25)._search!))",[[0,[2,"search!"]],[14,[" (method of ",[0,[2,"token-tree%"]],")"]]],["syntax-color/token-tree"]],
["search-backward-icon",">images/Icons.html#(def._((lib._images/icons/control..rkt)._search-backward-icon))",[0,[2,"search-backward-icon"]],["images/icons/control"]],
["search-for",">scribble/Connecting_to__racket_.html#(def._((lib._help/help-utils..rkt)._search-for))",[0,"search-for"],["help/help-utils"]],
["search-forward-icon",">images/Icons.html#(def._((lib._images/icons/control..rkt)._search-forward-icon))",[0,[2,"search-forward-icon"]],["images/icons/control"]],
["search-hidden?",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3asearchable~3c~25~3e)._search-hidden~3f))",[[0,[2,"search-hidden?"]],[14,[" (method of ",[0,[2,"frame:searchable<%>"]],")"]]],["framework"]],
["search-hits-changed",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3asearchable~3c~25~3e)._search-hits-changed))",[[0,[2,"search-hits-changed"]],[14,[" (method of ",[0,[2,"frame:searchable<%>"]],")"]]],["framework"]],
["search-replace",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3asearchable~3c~25~3e)._search-replace))",[[0,[2,"search-replace"]],[14,[" (method of ",[0,[2,"frame:searchable<%>"]],")"]]],["framework"]],
["searching",">drracket/Searching.html","Searching",false],
["searching in the docs",">tools/Documentation_Utilities.html#(part._.Searching_in_the_.Docs)","Searching in the Docs",false],
["seclink",">scribble/base.html#(def._((lib._scribble/base..rkt)._seclink))",[0,[2,"seclink"]],["scribble/base"]],
["second",">reference/pairs.html#(def._((lib._racket/list..rkt)._second))",[0,[2,"second"]],["racket/list","racket"]],
["second",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._second))",[0,[2,"second"]],["lang/htdp-advanced"]],
["second",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._second))",[0,[2,"second"]],["lang/htdp-beginner"]],
["second",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._second))",[0,[2,"second"]],["lang/htdp-beginner-abbr"]],
["second",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._second))",[0,[2,"second"]],["lang/htdp-intermediate"]],
["second",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._second))",[0,[2,"second"]],["lang/htdp-intermediate-lambda"]],
["second",">lazy/index.html#(def._((lib._lazy/main..rkt)._second))",[0,[2,"second"]],["lazy"]],
["second",">mzlib/mzlib_list.html#(def._((lib._mzlib/list..rkt)._second))",[0,[2,"second"]],["mzlib/list"]],
["second",">srfi-std/srfi-1.html#second",[0,[2,"second"]],["srfi/1"]],
["secondary partitioning",">macro-debugger/index.html#(part._.Secondary_.Partitioning)","Secondary Partitioning",false],
["seconds",">frtime/index.html#(def._((lib._frtime/main..rkt)._seconds))",[0,[2,"seconds"]],["frtime"]],
["seconds->date",">reference/time.html#(def._((quote._~23~25kernel)._seconds-~3edate))",[0,[2,"seconds->date"]],["racket/base","racket"]],
["seconds->plot-time",">plot/utils.html#(def._((lib._plot/utils..rkt)._seconds-~3eplot-time))",[0,[2,"seconds->plot-time"]],["plot/utils"]],
["secref",">scribble/base.html#(def._((lib._scribble/base..rkt)._.Secref))",[0,[2,"Secref"]],["scribble/base"]],
["secref",">scribble/base.html#(def._((lib._scribble/base..rkt)._secref))",[0,[2,"secref"]],["scribble/base"]],
["secref",">scribble/config.html#(idx._(gentag._20._(lib._scribblings/scribble/scribble..scrbl)))","SecRef",false],
["secrefuc",">scribble/config.html#(idx._(gentag._23._(lib._scribblings/scribble/scribble..scrbl)))","SecRefUC",false],
["secrefuc",">scribble/config.html#(idx._(gentag._25._(lib._scribblings/scribble/scribble..scrbl)))","SecRefUC",false],
["section",">scribble/base.html#(def._((lib._scribble/base..rkt)._section))",[0,[2,"section"]],["scribble/base"]],
["section hyperlinks",">scribble/how-to-doc.html#(part._section-hyperlinks)","Section Hyperlinks",false],
["section titles",">scribble/reference-style.html#(part._.Section_.Titles)","Section Titles",false],
["section-index",">scribble/base.html#(def._((lib._scribble/base..rkt)._section-index))",[0,[2,"section-index"]],["scribble/base"]],
["sectionnewpage",">scribble/config.html#(idx._(gentag._19._(lib._scribblings/scribble/scribble..scrbl)))","sectionNewpage",false],
["security guard",">reference/securityguards.html#(tech._security._guard)","<span style=\"font-style: italic\">security guard</span>",false],
["security guards",">inside/security.html","Security Guards",false],
["security guards",">reference/securityguards.html","Security Guards",false],
["security-guard",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Security-.Guard))",[0,[1,"Security-Guard"]],["typed/racket/base","typed/racket"]],
["security-guard-check-file",">foreign/file-security-guard-checks.html#(def._((lib._ffi/file..rkt)._security-guard-check-file))",[0,[2,"security-guard-check-file"]],["ffi/file"]],
["security-guard?",">reference/securityguards.html#(def._((quote._~23~25kernel)._security-guard~3f))",[0,[2,"security-guard?"]],["racket/base","racket"]],
["see-other",">web-server/http.html#(def._((lib._web-server/http/redirect..rkt)._see-other))",[0,[2,"see-other"]],["web-server/http/redirect"]],
["seek",">gui/editor-stream-in-base_.html#(meth._(((lib._mred/main..rkt)._editor-stream-in-base~25)._seek))",[[0,[2,"seek"]],[14,[" (method of ",[0,[2,"editor-stream-in-base%"]],")"]]],["racket/gui/base","racket/gui"]],
["seek",">gui/editor-stream-out-base_.html#(meth._(((lib._mred/main..rkt)._editor-stream-out-base~25)._seek))",[[0,[2,"seek"]],[14,[" (method of ",[0,[2,"editor-stream-out-base%"]],")"]]],["racket/gui/base","racket/gui"]],
["sel_registername",">foreign/Objective-C_FFI.html#(def._((lib._ffi/unsafe/objc..rkt)._sel_register.Name))",[0,[2,"sel_registerName"]],["ffi/unsafe/objc"]],
["select",">gui/list-box_.html#(meth._(((lib._mred/main..rkt)._list-box~25)._select))",[[0,[2,"select"]],[14,[" (method of ",[0,[2,"list-box%"]],")"]]],["racket/gui/base","racket/gui"]],
["select",">html/index.html#(def._((lib._html/main..rkt)._select))",[0,[2,"select"]],["html"]],
["select",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..rkt)._hierarchical-list~25)._select))",[[0,[2,"select"]],[14,[" (method of ",[0,[2,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["select",">mrlib/hierarchical-list-item___.html#(meth._(((lib._mrlib/hierlist..rkt)._hierarchical-list-item~3c~25~3e)._select))",[[0,[2,"select"]],[14,[" (method of ",[0,[2,"hierarchical-list-item<%>"]],")"]]],["mrlib/hierlist"]],
["select",">reference/sync.html","select",false],
["select",">gui/key-event_.html#(idx._(gentag._57._(lib._scribblings/gui/gui..scrbl)))",[7,"'select"],false],
["select all menu item",">drracket/Menus.html#(idx._(gentag._78._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Select All</span> menu item",false],
["select-all",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._select-all))",[[0,[2,"select-all"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["select-backward-sexp",">framework/Racket.html#(meth._(((lib._framework/main..rkt)._racket~3atext~3c~25~3e)._select-backward-sexp))",[[0,[2,"select-backward-sexp"]],[14,[" (method of ",[0,[2,"racket:text<%>"]],")"]]],["framework"]],
["select-buffer->gl-uint-vector",">sgl/gl.html#(def._((lib._sgl/gl..rkt)._select-buffer-~3egl-uint-vector))",[0,[2,"select-buffer->gl-uint-vector"]],["sgl/gl"]],
["select-click-line",">framework/Keymap.html#(idx._(gentag._37._(lib._scribblings/framework/framework..scrbl)))","select-click-line",false],
["select-click-word",">framework/Keymap.html#(idx._(gentag._36._(lib._scribblings/framework/framework..scrbl)))","select-click-word",false],
["select-down-sexp",">framework/Racket.html#(meth._(((lib._framework/main..rkt)._racket~3atext~3c~25~3e)._select-down-sexp))",[[0,[2,"select-down-sexp"]],[14,[" (method of ",[0,[2,"racket:text<%>"]],")"]]],["framework"]],
["select-first",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..rkt)._hierarchical-list~25)._select-first))",[[0,[2,"select-first"]],[14,[" (method of ",[0,[2,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["select-forward-sexp",">framework/Racket.html#(meth._(((lib._framework/main..rkt)._racket~3atext~3c~25~3e)._select-forward-sexp))",[[0,[2,"select-forward-sexp"]],[14,[" (method of ",[0,[2,"racket:text<%>"]],")"]]],["framework"]],
["select-in",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..rkt)._hierarchical-list~25)._select-in))",[[0,[2,"select-in"]],[14,[" (method of ",[0,[2,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["select-input",">web-server/formlets.html#(def._((lib._web-server/formlets/input..rkt)._select-input))",[0,[2,"select-input"]],["web-server/formlets/input"]],
["select-last",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..rkt)._hierarchical-list~25)._select-last))",[[0,[2,"select-last"]],[14,[" (method of ",[0,[2,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["select-next",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..rkt)._hierarchical-list~25)._select-next))",[[0,[2,"select-next"]],[14,[" (method of ",[0,[2,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["select-out",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..rkt)._hierarchical-list~25)._select-out))",[[0,[2,"select-out"]],[14,[" (method of ",[0,[2,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["select-prev",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..rkt)._hierarchical-list~25)._select-prev))",[[0,[2,"select-prev"]],[14,[" (method of ",[0,[2,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["select-up-sexp",">framework/Racket.html#(meth._(((lib._framework/main..rkt)._racket~3atext~3c~25~3e)._select-up-sexp))",[[0,[2,"select-up-sexp"]],[14,[" (method of ",[0,[2,"racket:text<%>"]],")"]]],["framework"]],
["select?",">html/index.html#(def._((lib._html/main..rkt)._select~3f))",[0,[2,"select?"]],["html"]],
["selectable",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..rkt)._hierarchical-list~25)._selectable))",[[0,[2,"selectable"]],[14,[" (method of ",[0,[2,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["selectable-menu-item<%>",">gui/selectable-menu-item___.html",[0,[2,"selectable-menu-item<%>"]],["racket/gui/base","racket/gui"]],
["selected mailbox state",">net/imap.html#(part._.Selected_.Mailbox_.State)","Selected Mailbox State",false],
["selection",">macro-debugger/index.html#(part._.Selection)","Selection",false],
["selection",">gui/editor-wordbreak-map_.html#(idx._(gentag._214._(lib._scribblings/gui/gui..scrbl)))",[7,"'selection"],false],
["selector",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._selector))",[0,[2,"selector"]],["2htdp/planetcute"]],
["selector",">foreign/Objective-C_FFI.html#(form._((lib._ffi/unsafe/objc..rkt)._selector))",[0,[1,"selector"]],["ffi/unsafe/objc"]],
["self",">foreign/Objective-C_FFI.html#(form._((lib._ffi/unsafe/objc..rkt)._self))",[0,[1,"self"]],["ffi/unsafe/objc"]],
["self",">reference/createclass.html#(idx._(gentag._163._(lib._scribblings/reference/reference..scrbl)))","self",false],
["semaphore",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Semaphore))",[0,[1,"Semaphore"]],["typed/racket/base","typed/racket"]],
["semaphore",">reference/semaphore.html#(tech._semaphore)","<span style=\"font-style: italic\">semaphore</span>",false],
["semaphore-peek-evt",">reference/semaphore.html#(def._((quote._~23~25kernel)._semaphore-peek-evt))",[0,[2,"semaphore-peek-evt"]],["racket/base","racket"]],
["semaphore-peek-evt?",">reference/semaphore.html#(def._((quote._~23~25kernel)._semaphore-peek-evt~3f))",[0,[2,"semaphore-peek-evt?"]],["racket/base","racket"]],
["semaphore-post",">reference/semaphore.html#(def._((quote._~23~25kernel)._semaphore-post))",[0,[2,"semaphore-post"]],["racket/base","racket"]],
["semaphore-try-wait?",">reference/semaphore.html#(def._((quote._~23~25kernel)._semaphore-try-wait~3f))",[0,[2,"semaphore-try-wait?"]],["racket/base","racket"]],
["semaphore-wait",">reference/semaphore.html#(def._((quote._~23~25kernel)._semaphore-wait))",[0,[2,"semaphore-wait"]],["racket/base","racket"]],
["semaphore-wait/enable-break",">reference/semaphore.html#(def._((quote._~23~25kernel)._semaphore-wait/enable-break))",[0,[2,"semaphore-wait/enable-break"]],["racket/base","racket"]],
["semaphore?",">reference/semaphore.html#(def._((quote._~23~25kernel)._semaphore~3f))",[0,[2,"semaphore?"]],["racket/base","racket"]],
["semaphores",">reference/semaphore.html","Semaphores",false],
["send",">reference/ivaraccess.html#(form._((lib._racket/private/class-internal..rkt)._send))",[0,[1,"send"]],["racket/class","racket"]],
["send url: opening a web browser",">net/sendurl.html","Send URL: Opening a Web Browser",false],
["send*",">reference/ivaraccess.html#(form._((lib._racket/private/class-internal..rkt)._send*))",[0,[1,"send*"]],["racket/class","racket"]],
["send*/i",">unstable/class-iop.html#(form._((lib._unstable/class-iop..rkt)._send*/i))",[0,[1,"send*/i"]],["unstable/class-iop"]],
["send+",">reference/ivaraccess.html#(form._((lib._racket/private/class-internal..rkt)._send+))",[0,[1,"send+"]],["racket/class","racket"]],
["send-eof-to-box-in-port",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3aports~3c~25~3e)._send-eof-to-box-in-port))",[[0,[2,"send-eof-to-box-in-port"]],[14,[" (method of ",[0,[2,"text:ports<%>"]],")"]]],["framework"]],
["send-eof-to-in-port",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3aports~3c~25~3e)._send-eof-to-in-port))",[[0,[2,"send-eof-to-in-port"]],[14,[" (method of ",[0,[2,"text:ports<%>"]],")"]]],["framework"]],
["send-event",">frtime/index.html#(def._((lib._frtime/main..rkt)._send-event))",[0,[2,"send-event"]],["frtime"]],
["send-event",">mzlib/mzlib_sendevent.html#(def._((lib._mzlib/sendevent..rkt)._send-event))",[0,[2,"send-event"]],["mzlib/sendevent"]],
["send-exit",">reference/distributed-places.html#(meth._(((lib._racket/place/distributed..rkt)._remote-node~25)._send-exit))",[[0,[2,"send-exit"]],[14,[" (method of ",[0,[2,"remote-node%"]],")"]]],["racket/place/distributed"]],
["send-generic",">reference/ivaraccess.html#(form._((lib._racket/private/class-internal..rkt)._send-generic))",[0,[1,"send-generic"]],["racket/class","racket"]],
["send-mail-message",">net/sendmail.html#(def._((lib._net/sendmail..rkt)._send-mail-message))",[0,[2,"send-mail-message"]],["net/sendmail"]],
["send-mail-message/port",">net/sendmail.html#(def._((lib._net/sendmail..rkt)._send-mail-message/port))",[0,[2,"send-mail-message/port"]],["net/sendmail"]],
["send-main-page",">tools/Documentation_Utilities.html#(def._((lib._help/search..rkt)._send-main-page))",[0,"send-main-page"],["help/search"]],
["send-message-to-window",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._send-message-to-window))",[0,[2,"send-message-to-window"]],["racket/gui/base","racket/gui"]],
["send-new-place-channel-to-named-dest",">reference/distributed-places.html#(def._((lib._racket/place/distributed..rkt)._send-new-place-channel-to-named-dest))",[0,[2,"send-new-place-channel-to-named-dest"]],["racket/place/distributed"]],
["send-url",">browser/index.html#(def._((lib._browser/external..rkt)._send-url))",[0,[2,"send-url"]],["browser/external"]],
["send-url",">net/sendurl.html#(def._((lib._net/sendurl..rkt)._send-url))",[0,[2,"send-url"]],["net/sendurl"]],
["send-url/contents",">net/sendurl.html#(def._((lib._net/sendurl..rkt)._send-url/contents))",[0,[2,"send-url/contents"]],["net/sendurl"]],
["send-url/file",">net/sendurl.html#(def._((lib._net/sendurl..rkt)._send-url/file))",[0,[2,"send-url/file"]],["net/sendurl"]],
["send/apply",">reference/ivaraccess.html#(form._((lib._racket/private/class-internal..rkt)._send/apply))",[0,[1,"send/apply"]],["racket/class","racket"]],
["send/apply/i",">unstable/class-iop.html#(form._((lib._unstable/class-iop..rkt)._send/apply/i))",[0,[1,"send/apply/i"]],["unstable/class-iop"]],
["send/back",">web-server/servlet.html#(def._((lib._web-server/servlet/web..rkt)._send/back))",[0,[2,"send/back"]],["web-server/servlet/web"]],
["send/finish",">web-server/servlet.html#(def._((lib._web-server/servlet/web..rkt)._send/finish))",[0,[2,"send/finish"]],["web-server/servlet/web"]],
["send/formlet",">web-server/formlets.html#(def._((lib._web-server/formlets/servlet..rkt)._send/formlet))",[0,[2,"send/formlet"]],["web-server/formlets/servlet"]],
["send/forward",">web-server/servlet.html#(def._((lib._web-server/servlet/web..rkt)._send/forward))",[0,[2,"send/forward"]],["web-server/servlet/web"]],
["send/i",">unstable/class-iop.html#(form._((lib._unstable/class-iop..rkt)._send/i))",[0,[1,"send/i"]],["unstable/class-iop"]],
["send/keyword-apply",">reference/ivaraccess.html#(form._((lib._racket/private/class-internal..rkt)._send/keyword-apply))",[0,[1,"send/keyword-apply"]],["racket/class","racket"]],
["send/suspend",">web-server/stateless.html#(def._((lib._web-server/lang/web..rkt)._send/suspend))",[0,[2,"send/suspend"]],["web-server/lang/web"]],
["send/suspend",">web-server/servlet.html#(def._((lib._web-server/servlet/web..rkt)._send/suspend))",[0,[2,"send/suspend"]],["web-server/servlet/web"]],
["send/suspend/dispatch",">web-server/stateless.html#(def._((lib._web-server/lang/web..rkt)._send/suspend/dispatch))",[0,[2,"send/suspend/dispatch"]],["web-server/lang/web"]],
["send/suspend/dispatch",">web-server/servlet.html#(def._((lib._web-server/servlet/web..rkt)._send/suspend/dispatch))",[0,[2,"send/suspend/dispatch"]],["web-server/servlet/web"]],
["send/suspend/hidden",">web-server/stateless.html#(def._((lib._web-server/lang/web..rkt)._send/suspend/hidden))",[0,[2,"send/suspend/hidden"]],["web-server/lang/web"]],
["send/suspend/url",">web-server/stateless.html#(def._((lib._web-server/lang/web..rkt)._send/suspend/url))",[0,[2,"send/suspend/url"]],["web-server/lang/web"]],
["send/suspend/url",">web-server/servlet.html#(def._((lib._web-server/servlet/web..rkt)._send/suspend/url))",[0,[2,"send/suspend/url"]],["web-server/servlet/web"]],
["send/suspend/url/dispatch",">web-server/stateless.html#(def._((lib._web-server/lang/web..rkt)._send/suspend/url/dispatch))",[0,[2,"send/suspend/url/dispatch"]],["web-server/lang/web"]],
["send/suspend/url/dispatch",">web-server/servlet.html#(def._((lib._web-server/servlet/web..rkt)._send/suspend/url/dispatch))",[0,[2,"send/suspend/url/dispatch"]],["web-server/servlet/web"]],
["sending messages",">teachpack/2htdpuniverse.html#(part._.Sending_.Messages)","Sending Messages",false],
["sending program fragments to the repl",">drracket/Keyboard_Shortcuts.html#(part._.Sending_.Program_.Fragments_to_the_.R.E.P.L)","Sending Program Fragments to the REPL",false],
["sendmail functions",">net/sendmail.html#(part._.Sendmail_.Functions)","Sendmail Functions",false],
["sendmail signature",">net/sendmail.html#(part._.Sendmail_.Signature)","Sendmail Signature",false],
["sendmail unit",">net/sendmail.html#(part._.Sendmail_.Unit)","Sendmail Unit",false],
["sendmail: sending e-mail",">net/sendmail.html",[[6,"sendmail"],": Sending E-Mail"],false],
["sendmail@",">net/sendmail.html#(def._((lib._net/sendmail-unit..rkt)._sendmail~40))",[0,[2,"sendmail@"]],["net/sendmail-unit"]],
["sendmail^",">net/sendmail.html#(form._((lib._net/sendmail-sig..rkt)._sendmail~5e))",[0,[1,"sendmail^"]],["net/sendmail-sig"]],
["separator",">gui/key-event_.html#(idx._(gentag._76._(lib._scribblings/gui/gui..scrbl)))",[7,"'separator"],false],
["separator",">gui/windowing-overview.html#(tech._separator)","<span style=\"font-style: italic\">separator</span>",false],
["separator-menu-item%",">gui/separator-menu-item_.html",[0,[2,"separator-menu-item%"]],["racket/gui/base","racket/gui"]],
["seq",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._seq))",[0,[2,"seq"]],["compiler/zo-structs"]],
["seq",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex-sre..rkt)._seq))",[0,[1,"seq"]],["parser-tools/lex-sre"]],
["seq",">unstable/Automata__Compiling_State_Machines.html#(form._((lib._unstable/automata/re..rkt)._seq))",[0,[1,"seq"]],["unstable/automata/re"]],
["seq-for-syntax",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._seq-for-syntax))",[0,[2,"seq-for-syntax"]],["compiler/zo-structs"]],
["seq-for-syntax-dummy",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._seq-for-syntax-dummy))",[0,[2,"seq-for-syntax-dummy"]],["compiler/zo-structs"]],
["seq-for-syntax-forms",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._seq-for-syntax-forms))",[0,[2,"seq-for-syntax-forms"]],["compiler/zo-structs"]],
["seq-for-syntax-max-let-depth",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._seq-for-syntax-max-let-depth))",[0,[2,"seq-for-syntax-max-let-depth"]],["compiler/zo-structs"]],
["seq-for-syntax-prefix",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._seq-for-syntax-prefix))",[0,[2,"seq-for-syntax-prefix"]],["compiler/zo-structs"]],
["seq-for-syntax?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._seq-for-syntax~3f))",[0,[2,"seq-for-syntax?"]],["compiler/zo-structs"]],
["seq-forms",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._seq-forms))",[0,[2,"seq-forms"]],["compiler/zo-structs"]],
["seq/close",">unstable/Automata__Compiling_State_Machines.html#(form._((lib._unstable/automata/re-ext..rkt)._seq/close))",[0,[1,"seq/close"]],["unstable/automata/re-ext"]],
["seq?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._seq~3f))",[0,[2,"seq?"]],["compiler/zo-structs"]],
["sequence",">deinprogramm/turtle.html#(def._((lib._teachpack/deinprogramm/turtle..rkt)._sequence))",[0,[2,"sequence"]],["teachpack/deinprogramm/turtle"]],
["sequence",">games/spider.html#(tech._sequence)","<span style=\"font-style: italic\">Sequence</span>",false],
["sequence",">reference/sequences.html#(tech._sequence)","<span style=\"font-style: italic\">sequence</span>",false],
["sequence combinations",">reference/sequences.html#(part._more-sequences)","Sequence Combinations",false],
["sequence constructors",">guide/for.html#(part._sequences)","Sequence Constructors",false],
["sequence conversion",">reference/sequences.html#(part._.Sequence_.Conversion)","Sequence Conversion",false],
["sequence predicate and constructors",">reference/sequences.html#(part._.Sequence_.Predicate_and_.Constructors)","Sequence Predicate and Constructors",false],
["sequence->generator",">reference/Generators.html#(def._((lib._racket/generator..rkt)._sequence-~3egenerator))",[0,[2,"sequence->generator"]],["racket/generator"]],
["sequence->list",">reference/sequences.html#(def._((lib._racket/sequence..rkt)._sequence-~3elist))",[0,[2,"sequence->list"]],["racket/sequence","racket"]],
["sequence->repeated-generator",">reference/Generators.html#(def._((lib._racket/generator..rkt)._sequence-~3erepeated-generator))",[0,[2,"sequence->repeated-generator"]],["racket/generator"]],
["sequence->stream",">reference/sequences.html#(def._((lib._racket/private/base..rkt)._sequence-~3estream))",[0,[2,"sequence->stream"]],["racket/base","racket"]],
["sequence-add-between",">reference/sequences.html#(def._((lib._racket/sequence..rkt)._sequence-add-between))",[0,[2,"sequence-add-between"]],["racket/sequence","racket"]],
["sequence-andmap",">reference/sequences.html#(def._((lib._racket/sequence..rkt)._sequence-andmap))",[0,[2,"sequence-andmap"]],["racket/sequence","racket"]],
["sequence-animations",">slideshow/play.html#(def._((lib._slideshow/play..rkt)._sequence-animations))",[0,[2,"sequence-animations"]],["slideshow/play"]],
["sequence-append",">reference/sequences.html#(def._((lib._racket/sequence..rkt)._sequence-append))",[0,[2,"sequence-append"]],["racket/sequence","racket"]],
["sequence-count",">reference/sequences.html#(def._((lib._racket/sequence..rkt)._sequence-count))",[0,[2,"sequence-count"]],["racket/sequence","racket"]],
["sequence-filter",">reference/sequences.html#(def._((lib._racket/sequence..rkt)._sequence-filter))",[0,[2,"sequence-filter"]],["racket/sequence","racket"]],
["sequence-fold",">reference/sequences.html#(def._((lib._racket/sequence..rkt)._sequence-fold))",[0,[2,"sequence-fold"]],["racket/sequence","racket"]],
["sequence-for-each",">reference/sequences.html#(def._((lib._racket/sequence..rkt)._sequence-for-each))",[0,[2,"sequence-for-each"]],["racket/sequence","racket"]],
["sequence-generate",">reference/sequences.html#(def._((lib._racket/private/base..rkt)._sequence-generate))",[0,[2,"sequence-generate"]],["racket/base","racket"]],
["sequence-generate*",">reference/sequences.html#(def._((lib._racket/private/base..rkt)._sequence-generate*))",[0,[2,"sequence-generate*"]],["racket/base","racket"]],
["sequence-length",">reference/sequences.html#(def._((lib._racket/sequence..rkt)._sequence-length))",[0,[2,"sequence-length"]],["racket/sequence","racket"]],
["sequence-lift",">unstable/sequence.html#(def._((lib._unstable/sequence..rkt)._sequence-lift))",[0,[2,"sequence-lift"]],["unstable/sequence"]],
["sequence-map",">reference/sequences.html#(def._((lib._racket/sequence..rkt)._sequence-map))",[0,[2,"sequence-map"]],["racket/sequence","racket"]],
["sequence-ormap",">reference/sequences.html#(def._((lib._racket/sequence..rkt)._sequence-ormap))",[0,[2,"sequence-ormap"]],["racket/sequence","racket"]],
["sequence-ref",">reference/sequences.html#(def._((lib._racket/sequence..rkt)._sequence-ref))",[0,[2,"sequence-ref"]],["racket/sequence","racket"]],
["sequence-tail",">reference/sequences.html#(def._((lib._racket/sequence..rkt)._sequence-tail))",[0,[2,"sequence-tail"]],["racket/sequence","racket"]],
["sequence/c",">unstable/contract.html#(def._((lib._unstable/contract..rkt)._sequence/c))",[0,[2,"sequence/c"]],["unstable/contract"]],
["sequence?",">reference/sequences.html#(def._((lib._racket/private/base..rkt)._sequence~3f))",[0,[2,"sequence?"]],["racket/base","racket"]],
["sequenceof",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Sequenceof))",[0,[1,"Sequenceof"]],["typed/racket/base","typed/racket"]],
["sequences",">reference/sequences.html","Sequences",false],
["sequences",">unstable/sequence.html","Sequences",false],
["sequences and streams",">reference/sequences_streams.html","Sequences and Streams",false],
["sequencing",">guide/begin.html","Sequencing",false],
["sequencing",">web-server-internal/dispatch-sequencer.html","Sequencing",false],
["sequencing: begin, begin0, and begin-for-syntax",">reference/begin.html",["Sequencing: ",[0,[1,"begin"]],", ",[0,[1,"begin0"]],", and ",[0,[1,"begin-for-syntax"]]],false],
["sequential binding: let*",">guide/let.html#(part._.Sequential_.Binding__let_)",["Sequential Binding: ",[0,[1,"let*"]]],false],
["serial->native",">web-server/stateless.html#(form._((lib._web-server/lang/abort-resume..rkt)._serial-~3enative))",[0,[1,"serial->native"]],["web-server/lang/abort-resume"]],
["serial-case-lambda",">web-server-internal/closure.html#(form._((lib._web-server/lang/serial-lambda..rkt)._serial-case-lambda))",[0,[1,"serial-case-lambda"]],["web-server/lang/serial-lambda"]],
["serial-lambda",">web-server-internal/closure.html#(form._((lib._web-server/lang/serial-lambda..rkt)._serial-lambda))",[0,[1,"serial-lambda"]],["web-server/lang/serial-lambda"]],
["serializable closures",">web-server-internal/closure.html","Serializable Closures",false],
["serializable continuations",">web-server/stateless.html#(part._.Serializable_.Continuations)","Serializable Continuations",false],
["serializable-struct",">reference/serialization.html#(form._((lib._racket/serialize..rkt)._serializable-struct))",[0,[1,"serializable-struct"]],["racket/serialize"]],
["serializable-struct/versions",">reference/serialization.html#(form._((lib._racket/serialize..rkt)._serializable-struct/versions))",[0,[1,"serializable-struct/versions"]],["racket/serialize"]],
["serializable?",">reference/serialization.html#(def._((lib._racket/private/serialize..rkt)._serializable~3f))",[0,[2,"serializable?"]],["racket/serialize"]],
["serialization",">reference/serialization.html","Serialization",false],
["serialization",">web-server/stateless.html#(part._.Serialization)","Serialization",false],
["serialization",">guide/serialization.html#(tech._serialization)","<span style=\"font-style: italic\">serialization</span>",false],
["serialization utilities",">web-server-internal/mod-map.html","Serialization Utilities",false],
["serialize",">reference/serialization.html#(def._((lib._racket/private/serialize..rkt)._serialize))",[0,[2,"serialize"]],["racket/serialize"]],
["serialize-info",">scribble/renderer.html#(meth._(((lib._scribble/base-render..rkt)._render~25)._serialize-info))",[[0,[2,"serialize-info"]],[14,[" (method of ",[0,[2,"render%"]],")"]]],["scribble/base-render"]],
["serialize-stuffer",">web-server/stateless.html#(def._((lib._web-server/stuffers/serialize..rkt)._serialize-stuffer))",[0,[2,"serialize-stuffer"]],["web-server/stuffers/serialize"]],
["serialized=?",">reference/serialization.html#(def._((lib._racket/private/serialize..rkt)._serialized~3d~3f))",[0,[2,"serialized=?"]],["racket/serialize"]],
["serious-condition?",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_424",[0,[2,"serious-condition?"]],["rnrs/conditions-6"]],
["serve",">web-server-internal/dispatch-server-unit.html#(sig-val._((lib._web-server/private/dispatch-server-sig..rkt)._dispatch-server~5e._serve))",[0,[2,"serve"]],["web-server/private/dispatch-server-sig"]],
["serve",">web-server-internal/web-server.html#(def._((lib._web-server/web-server..rkt)._serve))",[0,[2,"serve"]],["web-server/web-server"]],
["serve",">web-server-internal/Web_Servers.html#(sig-val._((lib._web-server/web-server-sig..rkt)._web-server~5e._serve))",[0,[2,"serve"]],["web-server/web-server-sig"]],
["serve-ports",">web-server-internal/dispatch-server-unit.html#(sig-val._((lib._web-server/private/dispatch-server-sig..rkt)._dispatch-server~5e._serve-ports))",[0,[2,"serve-ports"]],["web-server/private/dispatch-server-sig"]],
["serve-ports",">web-server-internal/Web_Servers.html#(sig-val._((lib._web-server/web-server-sig..rkt)._web-server~5e._serve-ports))",[0,[2,"serve-ports"]],["web-server/web-server-sig"]],
["serve/dispatch",">web-server/dispatch.html#(def._((lib._web-server/dispatch..rkt)._serve/dispatch))",[0,[2,"serve/dispatch"]],["web-server/dispatch"]],
["serve/ips+ports",">web-server-internal/web-server.html#(def._((lib._web-server/web-server..rkt)._serve/ips+ports))",[0,[2,"serve/ips+ports"]],["web-server/web-server"]],
["serve/launch/wait",">web-server-internal/web-server.html#(def._((lib._web-server/servlet-dispatch..rkt)._serve/launch/wait))",[0,[2,"serve/launch/wait"]],["web-server/servlet-dispatch"]],
["serve/ports",">web-server-internal/web-server.html#(def._((lib._web-server/web-server..rkt)._serve/ports))",[0,[2,"serve/ports"]],["web-server/web-server"]],
["serve/servlet",">web-server/run.html#(def._((lib._web-server/servlet-env..rkt)._serve/servlet))",[0,[2,"serve/servlet"]],["web-server/servlet-env"]],
["serve/web-config@",">web-server-internal/web-server.html#(def._((lib._web-server/web-server..rkt)._serve/web-config~40))",[0,[2,"serve/web-config@"]],["web-server/web-server"]],
["server",">reference/securityguards.html#(idx._(gentag._233._(lib._scribblings/reference/reference..scrbl)))",[7,"'server"],false],
["server",">teachpack/2htdpuniverse.html#(tech._server)","<span style=\"font-style: italic\">server</span>",false],
["server api",">net/websocket.html#(part._.Server_.A.P.I)","Server API",false],
["server thread",">more/index.html#(part._.Server_.Thread)","Server Thread",false],
["server units",">web-server-internal/Web_Servers.html#(part._web-server-unit)","Server Units",false],
["serving files",">web-server-internal/dispatch-files.html","Serving Files",false],
["serving servlets",">web-server-internal/dispatch-servlets.html","Serving Servlets",false],
["servlet",">web-server-internal/dispatch-servlets.html#(def._((lib._web-server/private/servlet..rkt)._servlet))",[0,[2,"servlet"]],["web-server/private/servlet"]],
["servlet namespaces",">web-server-internal/dispatch-servlets.html#(part._namespace)","Servlet Namespaces",false],
["servlet-connection-timeout",">web-server-internal/Web_Servers.html#(idx._(gentag._20._(lib._web-server/scribblings/web-server-internal..scrbl)))","servlet-connection-timeout",false],
["servlet-custodian",">web-server-internal/dispatch-servlets.html#(def._((lib._web-server/private/servlet..rkt)._servlet-custodian))",[0,[2,"servlet-custodian"]],["web-server/private/servlet"]],
["servlet-directory",">web-server-internal/dispatch-servlets.html#(def._((lib._web-server/private/servlet..rkt)._servlet-directory))",[0,[2,"servlet-directory"]],["web-server/private/servlet"]],
["servlet-error-responder",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/responders..rkt)._servlet-error-responder))",[0,[2,"servlet-error-responder"]],["web-server/configuration/responders"]],
["servlet-handler",">web-server-internal/dispatch-servlets.html#(def._((lib._web-server/private/servlet..rkt)._servlet-handler))",[0,[2,"servlet-handler"]],["web-server/private/servlet"]],
["servlet-loading-responder",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/responders..rkt)._servlet-loading-responder))",[0,[2,"servlet-loading-responder"]],["web-server/configuration/responders"]],
["servlet-manager",">web-server-internal/dispatch-servlets.html#(def._((lib._web-server/private/servlet..rkt)._servlet-manager))",[0,[2,"servlet-manager"]],["web-server/private/servlet"]],
["servlet-message",">web-server-internal/Web_Servers.html#(idx._(gentag._10._(lib._web-server/scribblings/web-server-internal..scrbl)))","servlet-message",false],
["servlet-namespace",">web-server-internal/dispatch-servlets.html#(def._((lib._web-server/private/servlet..rkt)._servlet-namespace))",[0,[2,"servlet-namespace"]],["web-server/private/servlet"]],
["servlet-prompt",">web-server/servlet.html#(def._((lib._web-server/servlet/web..rkt)._servlet-prompt))",[0,[2,"servlet-prompt"]],["web-server/servlet/web"]],
["servlet-root",">web-server-internal/Web_Servers.html#(idx._(gentag._28._(lib._web-server/scribblings/web-server-internal..scrbl)))","servlet-root",false],
["servlet?",">web-server-internal/dispatch-servlets.html#(def._((lib._web-server/private/servlet..rkt)._servlet~3f))",[0,[2,"servlet?"]],["web-server/private/servlet"]],
["servlets and sessions",">more/index.html#(part._.Servlets_and_.Sessions)","Servlets and Sessions",false],
["servlets-refreshed",">web-server-internal/Web_Servers.html#(idx._(gentag._12._(lib._web-server/scribblings/web-server-internal..scrbl)))","servlets-refreshed",false],
["set",">reference/cont.html#(form._((lib._racket/control..rkt)._set))",[0,[1,"set"]],["racket/control"]],
["set",">draw/color_.html#(meth._(((lib._racket/draw..rkt)._color~25)._set))",[[0,[2,"set"]],[14,[" (method of ",[0,[2,"color%"]],")"]]],["racket/draw"]],
["set",">gui/list-box_.html#(meth._(((lib._mred/main..rkt)._list-box~25)._set))",[[0,[2,"set"]],[14,[" (method of ",[0,[2,"list-box%"]],")"]]],["racket/gui/base","racket/gui"]],
["set",">gui/tab-panel_.html#(meth._(((lib._mred/main..rkt)._tab-panel~25)._set))",[[0,[2,"set"]],[14,[" (method of ",[0,[2,"tab-panel%"]],")"]]],["racket/gui/base","racket/gui"]],
["set",">reference/sets.html#(def._((lib._racket/set..rkt)._set))",[0,[2,"set"]],["racket/set","racket"]],
["set",">gui/add-color___.html#(meth._(((lib._racket/snip..rkt)._add-color~3c~25~3e)._set))",[[0,[2,"set"]],[14,[" (method of ",[0,[2,"add-color<%>"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["set",">gui/mult-color___.html#(meth._(((lib._racket/snip..rkt)._mult-color~3c~25~3e)._set))",[[0,[2,"set"]],[14,[" (method of ",[0,[2,"mult-color<%>"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["set",">unstable/gui-notify.html#(meth._(((lib._unstable/gui/notify..rkt)._notify-box~25)._set))",[[0,[2,"set"]],[14,[" (method of ",[0,[2,"notify-box%"]],")"]]],["unstable/gui/notify"]],
["set",">reference/sets.html#(tech._set)","<span style=\"font-style: italic\">set</span>",false],
["set predicates",">racklog/glossary.html#(part._.Set_.Predicates)","Set Predicates",false],
["set predicates",">racklog/set-of.html","Set Predicates",false],
["set!",">deinprogramm/set_.html",[0,[1,"set!"]],false],
["set!",">reference/set_.html#(form._((quote._~23~25kernel)._set!))",[0,[1,"set!"]],["racket/base","racket"]],
["set!",">r5rs-std/r5rs-Z-H-7.html#%_idx_104",[0,[1,"set!"]],["r5rs"]],
["set!",">r6rs-std/r6rs-Z-H-14.html#node_idx_372",[0,[2,"set!"]],["rnrs/base-6"]],
["set!",">htdp-langs/advanced.html#(form._((lib._lang/htdp-advanced..rkt)._set!))",[0,[1,"set!"]],["lang/htdp-advanced"]],
["set!",">deinprogramm/set_.html#(form._((lib._deinprogramm/.D.Md.A..rkt)._set!))",[0,[1,"set!"]],["deinprogramm/DMdA"]],
["set!",">lazy/index.html#(form._((lib._lazy/main..rkt)._set!))",[0,[1,"set!"]],["lazy"]],
["set!",">plai/mutator.html#(form._((lib._plai/mutator..rkt)._set!))",[0,[1,"set!"]],["plai/mutator"]],
["set!",">srfi-std/srfi-17.html#set!",[0,[1,"set!"]],["srfi/17"]],
["set!-transformer-procedure",">reference/stxtrans.html#(def._((quote._~23~25kernel)._set!-transformer-procedure))",[0,[2,"set!-transformer-procedure"]],["racket/base","racket"]],
["set!-transformer?",">reference/stxtrans.html#(def._((quote._~23~25kernel)._set!-transformer~3f))",[0,[2,"set!-transformer?"]],["racket/base","racket"]],
["set!-values",">reference/set_.html#(form._((lib._racket/private/more-scheme..rkt)._set!-values))",[0,[1,"set!-values"]],["racket/base","racket"]],
["set->list",">reference/sets.html#(def._((lib._racket/set..rkt)._set-~3elist))",[0,[2,"set->list"]],["racket/set","racket"]],
["set-accum-size",">draw/gl-config_.html#(meth._(((lib._racket/draw..rkt)._gl-config~25)._set-accum-size))",[[0,[2,"set-accum-size"]],[14,[" (method of ",[0,[2,"gl-config%"]],")"]]],["racket/draw"]],
["set-active-canvas",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._set-active-canvas))",[[0,[2,"set-active-canvas"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["set-active-frame",">framework/Group.html#(meth._(((lib._framework/main..rkt)._group~3a~25)._set-active-frame))",[[0,[2,"set-active-frame"]],[14,[" (method of ",[0,[2,"group:%"]],")"]]],["framework"]],
["set-add",">reference/sets.html#(def._((lib._racket/set..rkt)._set-add))",[0,[2,"set-add"]],["racket/set","racket"]],
["set-admin",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._set-admin))",[[0,[2,"set-admin"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["set-admin",">gui/snip_.html#(meth._(((lib._racket/snip..rkt)._snip~25)._set-admin))",[[0,[2,"set-admin"]],[14,[" (method of ",[0,[2,"snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["set-after",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._set-after))",[[0,[2,"set-after"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-ahead",">embedded-gui/Helpers.html#(meth._(((lib._embedded-gui/main..rkt)._tabbable-text~3c~25~3e)._set-ahead))",[[0,[2,"set-ahead"]],[14,[" (method of ",[0,[2,"tabbable-text<%>"]],")"]]],["embedded-gui"]],
["set-align-top-line",">gui/editor-snip_.html#(meth._(((lib._mred/main..rkt)._editor-snip~25)._set-align-top-line))",[[0,[2,"set-align-top-line"]],[14,[" (method of ",[0,[2,"editor-snip%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-aligned-min-sizes",">mrlib/aligned-pasteboard-parent___.html#(meth._(((lib._mrlib/aligned-pasteboard..rkt)._aligned-pasteboard-parent~3c~25~3e)._set-aligned-min-sizes))",[[0,[2,"set-aligned-min-sizes"]],[14,[" (method of ",[0,[2,"aligned-pasteboard-parent<%>"]],")"]]],["mrlib/aligned-pasteboard"]],
["set-aligned-min-sizes",">mrlib/aligned-pasteboard___.html#(meth._(((lib._mrlib/aligned-pasteboard..rkt)._aligned-pasteboard~3c~25~3e)._set-aligned-min-sizes))",[[0,[2,"set-aligned-min-sizes"]],[14,[" (method of ",[0,[2,"aligned-pasteboard<%>"]],")"]]],["mrlib/aligned-pasteboard"]],
["set-alignment",">gui/area-container___.html#(meth._(((lib._mred/main..rkt)._area-container~3c~25~3e)._set-alignment))",[[0,[2,"set-alignment"]],[14,[" (method of ",[0,[2,"area-container<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["set-alignment-off",">gui/style-delta_.html#(meth._(((lib._racket/snip..rkt)._style-delta~25)._set-alignment-off))",[[0,[2,"set-alignment-off"]],[14,[" (method of ",[0,[2,"style-delta%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["set-alignment-on",">gui/style-delta_.html#(meth._(((lib._racket/snip..rkt)._style-delta~25)._set-alignment-on))",[[0,[2,"set-alignment-on"]],[14,[" (method of ",[0,[2,"style-delta%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["set-allow-edits",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3aports~3c~25~3e)._set-allow-edits))",[[0,[2,"set-allow-edits"]],[14,[" (method of ",[0,[2,"text:ports<%>"]],")"]]],["framework"]],
["set-allow-selection",">mrlib/hierarchical-list-item___.html#(meth._(((lib._mrlib/hierlist..rkt)._hierarchical-list-item~3c~25~3e)._set-allow-selection))",[[0,[2,"set-allow-selection"]],[14,[" (method of ",[0,[2,"hierarchical-list-item<%>"]],")"]]],["mrlib/hierlist"]],
["set-allow-shrinking",">mrlib/Name_Message.html#(meth._(((lib._mrlib/name-message..rkt)._name-message~25)._set-allow-shrinking))",[[0,[2,"set-allow-shrinking"]],[14,[" (method of ",[0,[2,"name-message%"]],")"]]],["mrlib/name-message"]],
["set-alpha",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._set-alpha))",[[0,[2,"set-alpha"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["set-alt-down",">gui/key-event_.html#(meth._(((lib._mred/main..rkt)._key-event~25)._set-alt-down))",[[0,[2,"set-alt-down"]],[14,[" (method of ",[0,[2,"key-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-alt-down",">gui/mouse-event_.html#(meth._(((lib._mred/main..rkt)._mouse-event~25)._set-alt-down))",[[0,[2,"set-alt-down"]],[14,[" (method of ",[0,[2,"mouse-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-anchor",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._set-anchor))",[[0,[2,"set-anchor"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-anchor",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3ainfo-mixin)._set-anchor))",[[0,[2,"set-anchor"]],[14,[" (method of ",[0,[2,"text:info-mixin"]],")"]]],["framework"]],
["set-any->response!",">web-server/servlet.html#(def._((lib._web-server/servlet/servlet-structs..rkt)._set-any-~3eresponse!))",[0,[2,"set-any->response!"]],["web-server/servlet/servlet-structs"]],
["set-arc",">draw/region_.html#(meth._(((lib._racket/draw..rkt)._region~25)._set-arc))",[[0,[2,"set-arc"]],[14,[" (method of ",[0,[2,"region%"]],")"]]],["racket/draw"]],
["set-argb-pixels",">draw/bitmap_.html#(meth._(((lib._racket/draw..rkt)._bitmap~25)._set-argb-pixels))",[[0,[2,"set-argb-pixels"]],[14,[" (method of ",[0,[2,"bitmap%"]],")"]]],["racket/draw"]],
["set-argb-pixels",">draw/bitmap-dc_.html#(meth._(((lib._racket/draw..rkt)._bitmap-dc~25)._set-argb-pixels))",[[0,[2,"set-argb-pixels"]],[14,[" (method of ",[0,[2,"bitmap-dc%"]],")"]]],["racket/draw"]],
["set-arrow-pict!",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._set-arrow-pict!))",[0,[2,"set-arrow-pict!"]],["redex/pict","redex"]],
["set-arrowhead-params",">mrlib/graph-pasteboard___.html#(meth._(((lib._mrlib/graph..rkt)._graph-pasteboard~3c~25~3e)._set-arrowhead-params))",[[0,[2,"set-arrowhead-params"]],[14,[" (method of ",[0,[2,"graph-pasteboard<%>"]],")"]]],["mrlib/graph"]],
["set-autowrap-bitmap",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._set-autowrap-bitmap))",[[0,[2,"set-autowrap-bitmap"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-b",">gui/add-color___.html#(meth._(((lib._racket/snip..rkt)._add-color~3c~25~3e)._set-b))",[[0,[2,"set-b"]],[14,[" (method of ",[0,[2,"add-color<%>"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["set-b",">gui/mult-color___.html#(meth._(((lib._racket/snip..rkt)._mult-color~3c~25~3e)._set-b))",[[0,[2,"set-b"]],[14,[" (method of ",[0,[2,"mult-color<%>"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["set-back",">embedded-gui/Helpers.html#(meth._(((lib._embedded-gui/main..rkt)._tabbable-text~3c~25~3e)._set-back))",[[0,[2,"set-back"]],[14,[" (method of ",[0,[2,"tabbable-text<%>"]],")"]]],["embedded-gui"]],
["set-background",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._set-background))",[[0,[2,"set-background"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["set-base-style",">gui/style___.html#(meth._(((lib._racket/snip..rkt)._style~3c~25~3e)._set-base-style))",[[0,[2,"set-base-style"]],[14,[" (method of ",[0,[2,"style<%>"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["set-before",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._set-before))",[[0,[2,"set-before"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-between-threshold",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._set-between-threshold))",[[0,[2,"set-between-threshold"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-bitmap",">draw/bitmap-dc_.html#(meth._(((lib._racket/draw..rkt)._bitmap-dc~25)._set-bitmap))",[[0,[2,"set-bitmap"]],[14,[" (method of ",[0,[2,"bitmap-dc%"]],")"]]],["racket/draw"]],
["set-bitmap",">gui/image-snip_.html#(meth._(((lib._racket/snip..rkt)._image-snip~25)._set-bitmap))",[[0,[2,"set-bitmap"]],[14,[" (method of ",[0,[2,"image-snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["set-blog-home!",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-9..rkt)._set-blog-home!))",[0,[2,"set-blog-home!"]],[]],
["set-blog-posts!",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-4..rkt)._set-blog-posts!))",[0,"set-blog-posts!"],[]],
["set-blog-posts!",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-9..rkt)._set-blog-posts!))",[0,[2,"set-blog-posts!"]],[]],
["set-boundary",">gui/editor-stream-in_.html#(meth._(((lib._mred/main..rkt)._editor-stream-in~25)._set-boundary))",[[0,[2,"set-boundary"]],[14,[" (method of ",[0,[2,"editor-stream-in%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-box!",">reference/boxes.html#(def._((quote._~23~25kernel)._set-box!))",[0,[2,"set-box!"]],["racket/base","racket"]],
["set-box!",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._set-box!))",[0,[2,"set-box!"]],["lang/htdp-advanced"]],
["set-box!",">lazy/index.html#(def._((lib._lazy/main..rkt)._set-box!))",[0,[2,"set-box!"]],["lazy"]],
["set-break-sequence-callback",">gui/keymap_.html#(meth._(((lib._mred/main..rkt)._keymap~25)._set-break-sequence-callback))",[[0,[2,"set-break-sequence-callback"]],[14,[" (method of ",[0,[2,"keymap%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-breakables",">tools/drracket_rep.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3arep~3acontext~3c~25~3e)._set-breakables))",[[0,[2,"set-breakables"]],[14,[" (method of ",[0,[2,"drracket:rep:context<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["set-breakables",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3atab~3c~25~3e)._set-breakables))",[[0,[2,"set-breakables"]],[14,[" (method of ",[0,[2,"drracket:unit:tab<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["set-brush",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._set-brush))",[[0,[2,"set-brush"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["set-button-action",">cards/index.html#(meth._(((lib._games/cards..rkt)._table~3c~25~3e)._set-button-action))",[[0,[2,"set-button-action"]],[14,[" (method of ",[0,[2,"table<%>"]],")"]]],["games/cards"]],
["set-cache-size!",">redex/The_Redex_Reference.html#(def._((lib._redex/reduction-semantics..rkt)._set-cache-size!))",[0,[2,"set-cache-size!"]],["redex/reduction-semantics","redex"]],
["set-canvas-background",">gui/canvas___.html#(meth._(((lib._mred/main..rkt)._canvas~3c~25~3e)._set-canvas-background))",[[0,[2,"set-canvas-background"]],[14,[" (method of ",[0,[2,"canvas<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["set-cap",">draw/pen_.html#(meth._(((lib._racket/draw..rkt)._pen~25)._set-cap))",[[0,[2,"set-cap"]],[14,[" (method of ",[0,[2,"pen%"]],")"]]],["racket/draw"]],
["set-caps-down",">gui/key-event_.html#(meth._(((lib._mred/main..rkt)._key-event~25)._set-caps-down))",[[0,[2,"set-caps-down"]],[14,[" (method of ",[0,[2,"key-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-caps-down",">gui/mouse-event_.html#(meth._(((lib._mred/main..rkt)._mouse-event~25)._set-caps-down))",[[0,[2,"set-caps-down"]],[14,[" (method of ",[0,[2,"mouse-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-car!",">r5rs-std/r5rs-Z-H-9.html#%_idx_416",[0,[2,"set-car!"]],["r5rs"]],
["set-car!",">r6rs-lib-std/r6rs-lib-Z-H-18.html#node_idx_1274",[0,[2,"set-car!"]],["rnrs/mutable-pairs-6"]],
["set-caret-owner",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._set-caret-owner))",[[0,[2,"set-caret-owner"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["set-caret-owner",">gui/snip-admin_.html#(meth._(((lib._racket/snip..rkt)._snip-admin~25)._set-caret-owner))",[[0,[2,"set-caret-owner"]],[14,[" (method of ",[0,[2,"snip-admin%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["set-caret-owner",">embedded-gui/Helpers.html#(meth._(((lib._embedded-gui/main..rkt)._tabbable-text~3c~25~3e)._set-caret-owner))",[[0,[2,"set-caret-owner"]],[14,[" (method of ",[0,[2,"tabbable-text<%>"]],")"]]],["embedded-gui"]],
["set-cdr!",">r5rs-std/r5rs-Z-H-9.html#%_idx_418",[0,[2,"set-cdr!"]],["r5rs"]],
["set-cdr!",">r6rs-lib-std/r6rs-lib-Z-H-18.html#node_idx_1276",[0,[2,"set-cdr!"]],["rnrs/mutable-pairs-6"]],
["set-cell!",">frtime/index.html#(def._((lib._frtime/main..rkt)._set-cell!))",[0,[2,"set-cell!"]],["frtime"]],
["set-classname",">gui/editor-data-class_.html#(meth._(((lib._mred/main..rkt)._editor-data-class~25)._set-classname))",[[0,[2,"set-classname"]],[14,[" (method of ",[0,[2,"editor-data-class%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-classname",">gui/snip-class_.html#(meth._(((lib._racket/snip..rkt)._snip-class~25)._set-classname))",[[0,[2,"set-classname"]],[14,[" (method of ",[0,[2,"snip-class%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["set-clickback",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._set-clickback))",[[0,[2,"set-clickback"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-clipboard-bitmap",">gui/clipboard___.html#(meth._(((lib._mred/main..rkt)._clipboard~3c~25~3e)._set-clipboard-bitmap))",[[0,[2,"set-clipboard-bitmap"]],[14,[" (method of ",[0,[2,"clipboard<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["set-clipboard-client",">gui/clipboard___.html#(meth._(((lib._mred/main..rkt)._clipboard~3c~25~3e)._set-clipboard-client))",[[0,[2,"set-clipboard-client"]],[14,[" (method of ",[0,[2,"clipboard<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["set-clipboard-string",">gui/clipboard___.html#(meth._(((lib._mred/main..rkt)._clipboard~3c~25~3e)._set-clipboard-string))",[[0,[2,"set-clipboard-string"]],[14,[" (method of ",[0,[2,"clipboard<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["set-clipping-rect",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._set-clipping-rect))",[[0,[2,"set-clipping-rect"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["set-clipping-region",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._set-clipping-region))",[[0,[2,"set-clipping-region"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["set-coclass!",">mysterx/methprop.html#(def._((lib._mysterx/main..rkt)._set-coclass!))",[0,[2,"set-coclass!"]],["mysterx"]],
["set-coclass-from-progid!",">mysterx/methprop.html#(def._((lib._mysterx/main..rkt)._set-coclass-from-progid!))",[0,[2,"set-coclass-from-progid!"]],["mysterx"]],
["set-color",">draw/brush_.html#(meth._(((lib._racket/draw..rkt)._brush~25)._set-color))",[[0,[2,"set-color"]],[14,[" (method of ",[0,[2,"brush%"]],")"]]],["racket/draw"]],
["set-color",">draw/pen_.html#(meth._(((lib._racket/draw..rkt)._pen~25)._set-color))",[[0,[2,"set-color"]],[14,[" (method of ",[0,[2,"pen%"]],")"]]],["racket/draw"]],
["set-color",">deinprogramm/turtle.html#(def._((lib._teachpack/deinprogramm/turtle..rkt)._set-color))",[0,[2,"set-color"]],["teachpack/deinprogramm/turtle"]],
["set-column",">gui/column-control-event_.html#(meth._(((lib._mred/main..rkt)._column-control-event~25)._set-column))",[[0,[2,"set-column"]],[14,[" (method of ",[0,[2,"column-control-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-column-label",">gui/list-box_.html#(meth._(((lib._mred/main..rkt)._list-box~25)._set-column-label))",[[0,[2,"set-column-label"]],[14,[" (method of ",[0,[2,"list-box%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-column-order",">gui/list-box_.html#(meth._(((lib._mred/main..rkt)._list-box~25)._set-column-order))",[[0,[2,"set-column-order"]],[14,[" (method of ",[0,[2,"list-box%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-column-width",">gui/list-box_.html#(meth._(((lib._mred/main..rkt)._list-box~25)._set-column-width))",[[0,[2,"set-column-width"]],[14,[" (method of ",[0,[2,"list-box%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-command",">draw/ps-setup_.html#(meth._(((lib._racket/draw..rkt)._ps-setup~25)._set-command))",[[0,[2,"set-command"]],[14,[" (method of ",[0,[2,"ps-setup%"]],")"]]],["racket/draw"]],
["set-completion-function!",">readline/index.html#(def._((lib._readline/readline..rkt)._set-completion-function!))",[0,[2,"set-completion-function!"]],["readline/readline"]],
["set-control-down",">gui/key-event_.html#(meth._(((lib._mred/main..rkt)._key-event~25)._set-control-down))",[[0,[2,"set-control-down"]],[14,[" (method of ",[0,[2,"key-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-control-down",">gui/mouse-event_.html#(meth._(((lib._mred/main..rkt)._mouse-event~25)._set-control-down))",[[0,[2,"set-control-down"]],[14,[" (method of ",[0,[2,"mouse-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-cookie",">net/cookie.html#(def._((lib._net/cookie..rkt)._set-cookie))",[0,[2,"set-cookie"]],["net/cookie"]],
["set-count",">reference/sets.html#(def._((lib._racket/set..rkt)._set-count))",[0,[2,"set-count"]],["racket/set","racket"]],
["set-count",">gui/snip_.html#(meth._(((lib._racket/snip..rkt)._snip~25)._set-count))",[[0,[2,"set-count"]],[14,[" (method of ",[0,[2,"snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["set-cpointer-tag!",">foreign/foreign_pointer-funcs.html#(def._((quote._~23~25foreign)._set-cpointer-tag!))",[0,[2,"set-cpointer-tag!"]],["ffi/unsafe"]],
["set-cursor",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._set-cursor))",[[0,[2,"set-cursor"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["set-cursor",">gui/window___.html#(meth._(((lib._mred/main..rkt)._window~3c~25~3e)._set-cursor))",[[0,[2,"set-cursor"]],[14,[" (method of ",[0,[2,"window<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["set-data",">gui/list-box_.html#(meth._(((lib._mred/main..rkt)._list-box~25)._set-data))",[[0,[2,"set-data"]],[14,[" (method of ",[0,[2,"list-box%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-data-source-args!",">db/connect.html#(def._((lib._db/base..rkt)._set-data-source-args!))",[0,[2,"set-data-source-args!"]],["db","db/base"]],
["set-data-source-connector!",">db/connect.html#(def._((lib._db/base..rkt)._set-data-source-connector!))",[0,[2,"set-data-source-connector!"]],["db","db/base"]],
["set-data-source-extensions!",">db/connect.html#(def._((lib._db/base..rkt)._set-data-source-extensions!))",[0,[2,"set-data-source-extensions!"]],["db","db/base"]],
["set-dataclass",">gui/editor-data_.html#(meth._(((lib._mred/main..rkt)._editor-data~25)._set-dataclass))",[[0,[2,"set-dataclass"]],[14,[" (method of ",[0,[2,"editor-data%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-delegate",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3adelegate~3c~25~3e)._set-delegate))",[[0,[2,"set-delegate"]],[14,[" (method of ",[0,[2,"text:delegate<%>"]],")"]]],["framework"]],
["set-delta",">gui/style-delta_.html#(meth._(((lib._racket/snip..rkt)._style-delta~25)._set-delta))",[[0,[2,"set-delta"]],[14,[" (method of ",[0,[2,"style-delta%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["set-delta",">gui/style___.html#(meth._(((lib._racket/snip..rkt)._style~3c~25~3e)._set-delta))",[[0,[2,"set-delta"]],[14,[" (method of ",[0,[2,"style<%>"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["set-delta-background",">gui/style-delta_.html#(meth._(((lib._racket/snip..rkt)._style-delta~25)._set-delta-background))",[[0,[2,"set-delta-background"]],[14,[" (method of ",[0,[2,"style-delta%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["set-delta-face",">gui/style-delta_.html#(meth._(((lib._racket/snip..rkt)._style-delta~25)._set-delta-face))",[[0,[2,"set-delta-face"]],[14,[" (method of ",[0,[2,"style-delta%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["set-delta-foreground",">gui/style-delta_.html#(meth._(((lib._racket/snip..rkt)._style-delta~25)._set-delta-foreground))",[[0,[2,"set-delta-foreground"]],[14,[" (method of ",[0,[2,"style-delta%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["set-depth-size",">draw/gl-config_.html#(meth._(((lib._racket/draw..rkt)._gl-config~25)._set-depth-size))",[[0,[2,"set-depth-size"]],[14,[" (method of ",[0,[2,"gl-config%"]],")"]]],["racket/draw"]],
["set-direction",">gui/scroll-event_.html#(meth._(((lib._mred/main..rkt)._scroll-event~25)._set-direction))",[[0,[2,"set-direction"]],[14,[" (method of ",[0,[2,"scroll-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-double-buffered",">draw/gl-config_.html#(meth._(((lib._racket/draw..rkt)._gl-config~25)._set-double-buffered))",[[0,[2,"set-double-buffered"]],[14,[" (method of ",[0,[2,"gl-config%"]],")"]]],["racket/draw"]],
["set-double-click-action",">cards/index.html#(meth._(((lib._games/cards..rkt)._table~3c~25~3e)._set-double-click-action))",[[0,[2,"set-double-click-action"]],[14,[" (method of ",[0,[2,"table<%>"]],")"]]],["games/cards"]],
["set-double-click-interval",">gui/keymap_.html#(meth._(((lib._mred/main..rkt)._keymap~25)._set-double-click-interval))",[[0,[2,"set-double-click-interval"]],[14,[" (method of ",[0,[2,"keymap%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-dragable",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._set-dragable))",[[0,[2,"set-dragable"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-draw-arrow-heads?",">mrlib/graph-pasteboard___.html#(meth._(((lib._mrlib/graph..rkt)._graph-pasteboard~3c~25~3e)._set-draw-arrow-heads~3f))",[[0,[2,"set-draw-arrow-heads?"]],[14,[" (method of ",[0,[2,"graph-pasteboard<%>"]],")"]]],["mrlib/graph"]],
["set-editor",">gui/editor-canvas_.html#(meth._(((lib._mred/main..rkt)._editor-canvas~25)._set-editor))",[[0,[2,"set-editor"]],[14,[" (method of ",[0,[2,"editor-canvas%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-editor",">gui/editor-snip_.html#(meth._(((lib._mred/main..rkt)._editor-snip~25)._set-editor))",[[0,[2,"set-editor"]],[14,[" (method of ",[0,[2,"editor-snip%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-editor",">framework/Canvas.html#(meth._(((lib._framework/main..rkt)._canvas~3ainfo-mixin)._set-editor))",[[0,[2,"set-editor"]],[14,[" (method of ",[0,[2,"canvas:info-mixin"]],")"]]],["framework"]],
["set-editor-margin",">draw/ps-setup_.html#(meth._(((lib._racket/draw..rkt)._ps-setup~25)._set-editor-margin))",[[0,[2,"set-editor-margin"]],[14,[" (method of ",[0,[2,"ps-setup%"]],")"]]],["racket/draw"]],
["set-ellipse",">draw/region_.html#(meth._(((lib._racket/draw..rkt)._region~25)._set-ellipse))",[[0,[2,"set-ellipse"]],[14,[" (method of ",[0,[2,"region%"]],")"]]],["racket/draw"]],
["set-empty?",">reference/sets.html#(def._((lib._racket/set..rkt)._set-empty~3f))",[0,[2,"set-empty?"]],["racket/set","racket"]],
["set-eq?",">reference/sets.html#(def._((lib._racket/set..rkt)._set-eq~3f))",[0,[2,"set-eq?"]],["racket/set","racket"]],
["set-equal?",">reference/sets.html#(def._((lib._racket/set..rkt)._set-equal~3f))",[0,[2,"set-equal?"]],["racket/set","racket"]],
["set-eqv?",">reference/sets.html#(def._((lib._racket/set..rkt)._set-eqv~3f))",[0,[2,"set-eqv?"]],["racket/set","racket"]],
["set-eval-handler",">reference/Sandboxed_Evaluation.html#(def._((lib._racket/sandbox..rkt)._set-eval-handler))",[0,[2,"set-eval-handler"]],["racket/sandbox"]],
["set-eval-limits",">reference/Sandboxed_Evaluation.html#(def._((lib._racket/sandbox..rkt)._set-eval-limits))",[0,[2,"set-eval-limits"]],["racket/sandbox"]],
["set-event-type",">gui/control-event_.html#(meth._(((lib._mred/main..rkt)._control-event~25)._set-event-type))",[[0,[2,"set-event-type"]],[14,[" (method of ",[0,[2,"control-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-event-type",">gui/mouse-event_.html#(meth._(((lib._mred/main..rkt)._mouse-event~25)._set-event-type))",[[0,[2,"set-event-type"]],[14,[" (method of ",[0,[2,"mouse-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-event-type",">gui/scroll-event_.html#(meth._(((lib._mred/main..rkt)._scroll-event~25)._set-event-type))",[[0,[2,"set-event-type"]],[14,[" (method of ",[0,[2,"scroll-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-external-root-url",">scribble/renderer.html#(meth._(((lib._scribble/html-render..rkt)._render-mixin)._set-external-root-url))",[[0,[2,"set-external-root-url"]],[14,[" (method of ",[0,[2,"render-mixin"]],")"]]],["scribble/html-render"]],
["set-external-tag-path",">scribble/renderer.html#(meth._(((lib._scribble/html-render..rkt)._render-mixin)._set-external-tag-path))",[[0,[2,"set-external-tag-path"]],[14,[" (method of ",[0,[2,"render-mixin"]],")"]]],["scribble/html-render"]],
["set-face",">gui/style-delta_.html#(meth._(((lib._racket/snip..rkt)._style-delta~25)._set-face))",[[0,[2,"set-face"]],[14,[" (method of ",[0,[2,"style-delta%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["set-family",">gui/style-delta_.html#(meth._(((lib._racket/snip..rkt)._style-delta~25)._set-family))",[[0,[2,"set-family"]],[14,[" (method of ",[0,[2,"style-delta%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["set-ffi-obj!",">foreign/Loading_Foreign_Libraries.html#(def._((lib._ffi/unsafe..rkt)._set-ffi-obj!))",[0,[2,"set-ffi-obj!"]],["ffi/unsafe"]],
["set-field!",">reference/ivaraccess.html#(form._((lib._racket/private/class-internal..rkt)._set-field!))",[0,[1,"set-field!"]],["racket/class","racket"]],
["set-field-background",">gui/text-field_.html#(meth._(((lib._mred/main..rkt)._text-field~25)._set-field-background))",[[0,[2,"set-field-background"]],[14,[" (method of ",[0,[2,"text-field%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-file",">draw/ps-setup_.html#(meth._(((lib._racket/draw..rkt)._ps-setup~25)._set-file))",[[0,[2,"set-file"]],[14,[" (method of ",[0,[2,"ps-setup%"]],")"]]],["racket/draw"]],
["set-file-format",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._set-file-format))",[[0,[2,"set-file-format"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-filename",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._set-filename))",[[0,[2,"set-filename"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["set-filename",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3adefinitions-text~25)._set-filename))",["set-filename",[14,[" (method of ",[0,[2,"drracket:unit:definitions-text%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["set-filename",">framework/Editor.html#(meth._(((lib._framework/main..rkt)._editor~3afile-mixin)._set-filename))",[[0,[2,"set-filename"]],[14,[" (method of ",[0,[2,"editor:file-mixin"]],")"]]],["framework"]],
["set-first!",">plai/mutator.html#(def._((lib._plai/mutator..rkt)._set-first!))",[0,[2,"set-first!"]],["plai/mutator"]],
["set-first-visible-item",">gui/list-box_.html#(meth._(((lib._mred/main..rkt)._list-box~25)._set-first-visible-item))",[[0,[2,"set-first-visible-item"]],[14,[" (method of ",[0,[2,"list-box%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-flags",">gui/snip_.html#(meth._(((lib._racket/snip..rkt)._snip~25)._set-flags))",[[0,[2,"set-flags"]],[14,[" (method of ",[0,[2,"snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["set-flip-labels?",">mrlib/graph-pasteboard___.html#(meth._(((lib._mrlib/graph..rkt)._graph-pasteboard~3c~25~3e)._set-flip-labels~3f))",[[0,[2,"set-flip-labels?"]],[14,[" (method of ",[0,[2,"graph-pasteboard<%>"]],")"]]],["mrlib/graph"]],
["set-font",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._set-font))",[[0,[2,"set-font"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["set-for-each",">reference/sets.html#(def._((lib._racket/set..rkt)._set-for-each))",[0,[2,"set-for-each"]],["racket/set","racket"]],
["set-g",">gui/add-color___.html#(meth._(((lib._racket/snip..rkt)._add-color~3c~25~3e)._set-g))",[[0,[2,"set-g"]],[14,[" (method of ",[0,[2,"add-color<%>"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["set-g",">gui/mult-color___.html#(meth._(((lib._racket/snip..rkt)._mult-color~3c~25~3e)._set-g))",[[0,[2,"set-g"]],[14,[" (method of ",[0,[2,"mult-color<%>"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["set-grab-key-function",">gui/keymap_.html#(meth._(((lib._mred/main..rkt)._keymap~25)._set-grab-key-function))",[[0,[2,"set-grab-key-function"]],[14,[" (method of ",[0,[2,"keymap%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-grab-mouse-function",">gui/keymap_.html#(meth._(((lib._mred/main..rkt)._keymap~25)._set-grab-mouse-function))",[[0,[2,"set-grab-mouse-function"]],[14,[" (method of ",[0,[2,"keymap%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-help-string",">gui/labelled-menu-item___.html#(meth._(((lib._mred/main..rkt)._labelled-menu-item~3c~25~3e)._set-help-string))",[[0,[2,"set-help-string"]],[14,[" (method of ",[0,[2,"labelled-menu-item<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["set-hidden?",">mrlib/Name_Message.html#(meth._(((lib._mrlib/name-message..rkt)._name-message~25)._set-hidden~3f))",[[0,[2,"set-hidden?"]],[14,[" (method of ",[0,[2,"name-message%"]],")"]]],["mrlib/name-message"]],
["set-icon",">gui/top-level-window___.html#(meth._(((lib._mred/main..rkt)._top-level-window~3c~25~3e)._set-icon))",[[0,[2,"set-icon"]],[14,[" (method of ",[0,[2,"top-level-window<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["set-inactive-caret-threshold",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._set-inactive-caret-threshold))",[[0,[2,"set-inactive-caret-threshold"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["set-info-canvas",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3ainfo~3c~25~3e)._set-info-canvas))",[[0,[2,"set-info-canvas"]],[14,[" (method of ",[0,[2,"frame:info<%>"]],")"]]],["framework"]],
["set-initial-matrix",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._set-initial-matrix))",[[0,[2,"set-initial-matrix"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["set-insertion-point",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3aports~3c~25~3e)._set-insertion-point))",[[0,[2,"set-insertion-point"]],[14,[" (method of ",[0,[2,"text:ports<%>"]],")"]]],["framework"]],
["set-inset",">gui/editor-snip_.html#(meth._(((lib._mred/main..rkt)._editor-snip~25)._set-inset))",[[0,[2,"set-inset"]],[14,[" (method of ",[0,[2,"editor-snip%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-integer-set-contents!",">mzlib/mzlib_integer-set.html#(def._((lib._mzlib/integer-set..rkt)._set-integer-set-contents!))",[0,[2,"set-integer-set-contents!"]],["mzlib/integer-set"]],
["set-interactive-display-handler",">mrlib/Interactive_Value_Port.html#(def._((lib._mrlib/interactive-value-port..rkt)._set-interactive-display-handler))",[0,[2,"set-interactive-display-handler"]],["mrlib/interactive-value-port"]],
["set-interactive-print-handler",">mrlib/Interactive_Value_Port.html#(def._((lib._mrlib/interactive-value-port..rkt)._set-interactive-print-handler))",[0,[2,"set-interactive-print-handler"]],["mrlib/interactive-value-port"]],
["set-interactive-write-handler",">mrlib/Interactive_Value_Port.html#(def._((lib._mrlib/interactive-value-port..rkt)._set-interactive-write-handler))",[0,[2,"set-interactive-write-handler"]],["mrlib/interactive-value-port"]],
["set-intersect",">reference/sets.html#(def._((lib._racket/set..rkt)._set-intersect))",[0,[2,"set-intersect"]],["racket/set","racket"]],
["set-item-label",">gui/tab-panel_.html#(meth._(((lib._mred/main..rkt)._tab-panel~25)._set-item-label))",[[0,[2,"set-item-label"]],[14,[" (method of ",[0,[2,"tab-panel%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-ivar!",">foreign/Objective-C_FFI.html#(form._((lib._ffi/unsafe/objc..rkt)._set-ivar!))",[0,[1,"set-ivar!"]],["ffi/unsafe/objc"]],
["set-join",">draw/pen_.html#(meth._(((lib._racket/draw..rkt)._pen~25)._set-join))",[[0,[2,"set-join"]],[14,[" (method of ",[0,[2,"pen%"]],")"]]],["racket/draw"]],
["set-key",">browser/index.html#(meth._(((lib._browser/browser..rkt)._image-map-snip~25)._set-key))",[[0,[2,"set-key"]],[14,[" (method of ",[0,[2,"image-map-snip%"]],")"]]],["browser/browser","browser"]],
["set-key-code",">gui/key-event_.html#(meth._(((lib._mred/main..rkt)._key-event~25)._set-key-code))",[[0,[2,"set-key-code"]],[14,[" (method of ",[0,[2,"key-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-key-release-code",">gui/key-event_.html#(meth._(((lib._mred/main..rkt)._key-event~25)._set-key-release-code))",[[0,[2,"set-key-release-code"]],[14,[" (method of ",[0,[2,"key-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-keymap",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._set-keymap))",[[0,[2,"set-keymap"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["set-label",">gui/button_.html#(meth._(((lib._mred/main..rkt)._button~25)._set-label))",[[0,[2,"set-label"]],[14,[" (method of ",[0,[2,"button%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-label",">gui/check-box_.html#(meth._(((lib._mred/main..rkt)._check-box~25)._set-label))",[[0,[2,"set-label"]],[14,[" (method of ",[0,[2,"check-box%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-label",">gui/labelled-menu-item___.html#(meth._(((lib._mred/main..rkt)._labelled-menu-item~3c~25~3e)._set-label))",[[0,[2,"set-label"]],[14,[" (method of ",[0,[2,"labelled-menu-item<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["set-label",">gui/message_.html#(meth._(((lib._mred/main..rkt)._message~25)._set-label))",[[0,[2,"set-label"]],[14,[" (method of ",[0,[2,"message%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-label",">gui/window___.html#(meth._(((lib._mred/main..rkt)._window~3c~25~3e)._set-label))",[[0,[2,"set-label"]],[14,[" (method of ",[0,[2,"window<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["set-label",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3aeditor-mixin)._set-label))",[[0,[2,"set-label"]],[14,[" (method of ",[0,[2,"frame:editor-mixin"]],")"]]],["framework"]],
["set-label-prefix",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3aeditor~3c~25~3e)._set-label-prefix))",[[0,[2,"set-label-prefix"]],[14,[" (method of ",[0,[2,"frame:editor<%>"]],")"]]],["framework"]],
["set-label-visible",">mrlib/Switchable_Button.html#(meth._(((lib._mrlib/switchable-button..rkt)._switchable-button~25)._set-label-visible))",[[0,[2,"set-label-visible"]],[14,[" (method of ",[0,[2,"switchable-button%"]],")"]]],["mrlib/switchable-button"]],
["set-language-pref",">string-constants/index.html#(def._((lib._string-constants/string-constant..rkt)._set-language-pref))",[0,[2,"set-language-pref"]],["string-constants/string-constant","string-constants"]],
["set-left-down",">gui/mouse-event_.html#(meth._(((lib._mred/main..rkt)._mouse-event~25)._set-left-down))",[[0,[2,"set-left-down"]],[14,[" (method of ",[0,[2,"mouse-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-level-2",">draw/ps-setup_.html#(meth._(((lib._racket/draw..rkt)._ps-setup~25)._set-level-2))",[[0,[2,"set-level-2"]],[14,[" (method of ",[0,[2,"ps-setup%"]],")"]]],["racket/draw"]],
["set-line-count",">gui/editor-canvas_.html#(meth._(((lib._mred/main..rkt)._editor-canvas~25)._set-line-count))",[[0,[2,"set-line-count"]],[14,[" (method of ",[0,[2,"editor-canvas%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-line-numbers-color",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3aline-numbers-mixin)._set-line-numbers-color))",[[0,[2,"set-line-numbers-color"]],[14,[" (method of ",[0,[2,"text:line-numbers-mixin"]],")"]]],["framework"]],
["set-line-numbers-color",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3aline-numbers~3c~25~3e)._set-line-numbers-color))",[[0,[2,"set-line-numbers-color"]],[14,[" (method of ",[0,[2,"text:line-numbers<%>"]],")"]]],["framework"]],
["set-line-spacing",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._set-line-spacing))",[[0,[2,"set-line-spacing"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-link-label",">mrlib/Graph_Functions.html#(def._((lib._mrlib/graph..rkt)._set-link-label))",[0,[2,"set-link-label"]],["mrlib/graph"]],
["set-load-overwrites-styles",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._set-load-overwrites-styles))",[[0,[2,"set-load-overwrites-styles"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["set-loaded-mask",">draw/bitmap_.html#(meth._(((lib._racket/draw..rkt)._bitmap~25)._set-loaded-mask))",[[0,[2,"set-loaded-mask"]],[14,[" (method of ",[0,[2,"bitmap%"]],")"]]],["racket/draw"]],
["set-lw-column!",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._set-lw-column!))",[0,[2,"set-lw-column!"]],["redex/pict","redex"]],
["set-lw-column-span!",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._set-lw-column-span!))",[0,[2,"set-lw-column-span!"]],["redex/pict","redex"]],
["set-lw-e!",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._set-lw-e!))",[0,[2,"set-lw-e!"]],["redex/pict","redex"]],
["set-lw-line!",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._set-lw-line!))",[0,[2,"set-lw-line!"]],["redex/pict","redex"]],
["set-lw-line-span!",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._set-lw-line-span!))",[0,[2,"set-lw-line-span!"]],["redex/pict","redex"]],
["set-lw-metafunction?!",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._set-lw-metafunction~3f!))",[0,[2,"set-lw-metafunction?!"]],["redex/pict","redex"]],
["set-lw-unq?!",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._set-lw-unq~3f!))",[0,[2,"set-lw-unq?!"]],["redex/pict","redex"]],
["set-macro-recording",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3atext-info~3c~25~3e)._set-macro-recording))",[[0,[2,"set-macro-recording"]],[14,[" (method of ",[0,[2,"frame:text-info<%>"]],")"]]],["framework"]],
["set-map",">gui/editor-wordbreak-map_.html#(meth._(((lib._mred/main..rkt)._editor-wordbreak-map~25)._set-map))",[[0,[2,"set-map"]],[14,[" (method of ",[0,[2,"editor-wordbreak-map%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-map",">reference/sets.html#(def._((lib._racket/set..rkt)._set-map))",[0,[2,"set-map"]],["racket/set","racket"]],
["set-margin",">draw/ps-setup_.html#(meth._(((lib._racket/draw..rkt)._ps-setup~25)._set-margin))",[[0,[2,"set-margin"]],[14,[" (method of ",[0,[2,"ps-setup%"]],")"]]],["racket/draw"]],
["set-margin",">gui/editor-snip_.html#(meth._(((lib._mred/main..rkt)._editor-snip~25)._set-margin))",[[0,[2,"set-margin"]],[14,[" (method of ",[0,[2,"editor-snip%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-margin!",">slideshow/Configuration.html#(def._((lib._slideshow/base..rkt)._set-margin!))",[0,[2,"set-margin!"]],["slideshow/base","slideshow"]],
["set-max-height",">gui/editor-snip_.html#(meth._(((lib._mred/main..rkt)._editor-snip~25)._set-max-height))",[[0,[2,"set-max-height"]],[14,[" (method of ",[0,[2,"editor-snip%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-max-height",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._set-max-height))",[[0,[2,"set-max-height"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["set-max-undo-history",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._set-max-undo-history))",[[0,[2,"set-max-undo-history"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["set-max-width",">gui/editor-snip_.html#(meth._(((lib._mred/main..rkt)._editor-snip~25)._set-max-width))",[[0,[2,"set-max-width"]],[14,[" (method of ",[0,[2,"editor-snip%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-max-width",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._set-max-width))",[[0,[2,"set-max-width"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["set-mcar!",">reference/mpairs.html#(def._((quote._~23~25kernel)._set-mcar!))",[0,[2,"set-mcar!"]],["racket/base","racket"]],
["set-mcar!",">lazy/index.html#(def._((lib._lazy/main..rkt)._set-mcar!))",[0,[2,"set-mcar!"]],["lazy"]],
["set-mcdr!",">reference/mpairs.html#(def._((quote._~23~25kernel)._set-mcdr!))",[0,[2,"set-mcdr!"]],["racket/base","racket"]],
["set-mcdr!",">lazy/index.html#(def._((lib._lazy/main..rkt)._set-mcdr!))",[0,[2,"set-mcdr!"]],["lazy"]],
["set-member?",">reference/sets.html#(def._((lib._racket/set..rkt)._set-member~3f))",[0,[2,"set-member?"]],["racket/set","racket"]],
["set-message",">tools/drracket_frame.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aframe~3aname-message~25)._set-message))",["set-message",[14,[" (method of ",[0,[2,"drracket:frame:name-message%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["set-message",">mrlib/Name_Message.html#(meth._(((lib._mrlib/name-message..rkt)._name-message~25)._set-message))",[[0,[2,"set-message"]],[14,[" (method of ",[0,[2,"name-message%"]],")"]]],["mrlib/name-message"]],
["set-meta-down",">gui/key-event_.html#(meth._(((lib._mred/main..rkt)._key-event~25)._set-meta-down))",[[0,[2,"set-meta-down"]],[14,[" (method of ",[0,[2,"key-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-meta-down",">gui/mouse-event_.html#(meth._(((lib._mred/main..rkt)._mouse-event~25)._set-meta-down))",[[0,[2,"set-meta-down"]],[14,[" (method of ",[0,[2,"mouse-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-middle-down",">gui/mouse-event_.html#(meth._(((lib._mred/main..rkt)._mouse-event~25)._set-middle-down))",[[0,[2,"set-middle-down"]],[14,[" (method of ",[0,[2,"mouse-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-min-height",">gui/editor-snip_.html#(meth._(((lib._mred/main..rkt)._editor-snip~25)._set-min-height))",[[0,[2,"set-min-height"]],[14,[" (method of ",[0,[2,"editor-snip%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-min-height",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._set-min-height))",[[0,[2,"set-min-height"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["set-min-sizes",">embedded-gui/alignment___.html#(meth._(((lib._embedded-gui/main..rkt)._alignment~3c~25~3e)._set-min-sizes))",[[0,[2,"set-min-sizes"]],[14,[" (method of ",[0,[2,"alignment<%>"]],")"]]],["embedded-gui"]],
["set-min-width",">gui/editor-snip_.html#(meth._(((lib._mred/main..rkt)._editor-snip~25)._set-min-width))",[[0,[2,"set-min-width"]],[14,[" (method of ",[0,[2,"editor-snip%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-min-width",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._set-min-width))",[[0,[2,"set-min-width"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["set-min-width",">gui/popup-menu_.html#(meth._(((lib._mred/main..rkt)._popup-menu~25)._set-min-width))",[[0,[2,"set-min-width"]],[14,[" (method of ",[0,[2,"popup-menu%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-mode",">draw/ps-setup_.html#(meth._(((lib._racket/draw..rkt)._ps-setup~25)._set-mode))",[[0,[2,"set-mode"]],[14,[" (method of ",[0,[2,"ps-setup%"]],")"]]],["racket/draw"]],
["set-modified",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._set-modified))",[[0,[2,"set-modified"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["set-modified",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3adefinitions-text~25)._set-modified))",["set-modified",[14,[" (method of ",[0,[2,"drracket:unit:definitions-text%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["set-modified",">framework/Editor.html#(meth._(((lib._framework/main..rkt)._editor~3abackup-autosave-mixin)._set-modified))",[[0,[2,"set-modified"]],[14,[" (method of ",[0,[2,"editor:backup-autosave-mixin"]],")"]]],["framework"]],
["set-multisample-size",">draw/gl-config_.html#(meth._(((lib._racket/draw..rkt)._gl-config~25)._set-multisample-size))",[[0,[2,"set-multisample-size"]],[14,[" (method of ",[0,[2,"gl-config%"]],")"]]],["racket/draw"]],
["set-needs-execution-message",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3adefinitions-text~3c~25~3e)._set-needs-execution-message))",[[0,[2,"set-needs-execution-message"]],[14,[" (method of ",[0,[2,"drracket:unit:definitions-text<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["set-next",">gui/editor-data_.html#(meth._(((lib._mred/main..rkt)._editor-data~25)._set-next))",[[0,[2,"set-next"]],[14,[" (method of ",[0,[2,"editor-data%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-next-settings",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3adefinitions-text~3c~25~3e)._set-next-settings))",[[0,[2,"set-next-settings"]],[14,[" (method of ",[0,[2,"drracket:unit:definitions-text<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["set-no-sublists",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..rkt)._hierarchical-list~25)._set-no-sublists))",[[0,[2,"set-no-sublists"]],[14,[" (method of ",[0,[2,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["set-no-sublists",">mrlib/hierarchical-list-compound-item___.html#(meth._(((lib._mrlib/hierlist..rkt)._hierarchical-list-compound-item~3c~25~3e)._set-no-sublists))",[[0,[2,"set-no-sublists"]],[14,[" (method of ",[0,[2,"hierarchical-list-compound-item<%>"]],")"]]],["mrlib/hierlist"]],
["set-offset",">gui/image-snip_.html#(meth._(((lib._racket/snip..rkt)._image-snip~25)._set-offset))",[[0,[2,"set-offset"]],[14,[" (method of ",[0,[2,"image-snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["set-on-channel!",">reference/distributed-places.html#(meth._(((lib._racket/place/distributed..rkt)._remote-connection~25)._set-on-channel!))",[[0,[2,"set-on-channel!"]],[14,[" (method of ",[0,[2,"remote-connection%"]],")"]]],["racket/place/distributed"]],
["set-on-key-event",">graphics/World_Operations.html#(def._((lib._graphics/graphics..rkt)._set-on-key-event))",[0,[2,"set-on-key-event"]],["graphics/graphics"]],
["set-on-tick-event",">graphics/World_Operations.html#(def._((lib._graphics/graphics..rkt)._set-on-tick-event))",[0,[2,"set-on-tick-event"]],["graphics/graphics"]],
["set-orientation",">draw/ps-setup_.html#(meth._(((lib._racket/draw..rkt)._ps-setup~25)._set-orientation))",[[0,[2,"set-orientation"]],[14,[" (method of ",[0,[2,"ps-setup%"]],")"]]],["racket/draw"]],
["set-orientation",">gui/horizontal-panel_.html#(meth._(((lib._mred/main..rkt)._horizontal-panel~25)._set-orientation))",[[0,[2,"set-orientation"]],[14,[" (method of ",[0,[2,"horizontal-panel%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-orientation",">gui/vertical-panel_.html#(meth._(((lib._mred/main..rkt)._vertical-panel~25)._set-orientation))",[[0,[2,"set-orientation"]],[14,[" (method of ",[0,[2,"vertical-panel%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-orientation",">framework/Panel.html#(meth._(((lib._framework/main..rkt)._panel~3adragable~3c~25~3e)._set-orientation))",[[0,[2,"set-orientation"]],[14,[" (method of ",[0,[2,"panel:dragable<%>"]],")"]]],["framework"]],
["set-origin",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._set-origin))",[[0,[2,"set-origin"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["set-other-altgr-key-code",">gui/key-event_.html#(meth._(((lib._mred/main..rkt)._key-event~25)._set-other-altgr-key-code))",[[0,[2,"set-other-altgr-key-code"]],[14,[" (method of ",[0,[2,"key-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-other-caps-key-code",">gui/key-event_.html#(meth._(((lib._mred/main..rkt)._key-event~25)._set-other-caps-key-code))",[[0,[2,"set-other-caps-key-code"]],[14,[" (method of ",[0,[2,"key-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-other-shift-altgr-key-code",">gui/key-event_.html#(meth._(((lib._mred/main..rkt)._key-event~25)._set-other-shift-altgr-key-code))",[[0,[2,"set-other-shift-altgr-key-code"]],[14,[" (method of ",[0,[2,"key-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-other-shift-key-code",">gui/key-event_.html#(meth._(((lib._mred/main..rkt)._key-event~25)._set-other-shift-key-code))",[[0,[2,"set-other-shift-key-code"]],[14,[" (method of ",[0,[2,"key-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-overwrite-mode",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._set-overwrite-mode))",[[0,[2,"set-overwrite-mode"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-overwrite-mode",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3ainfo-mixin)._set-overwrite-mode))",[[0,[2,"set-overwrite-mode"]],[14,[" (method of ",[0,[2,"text:info-mixin"]],")"]]],["framework"]],
["set-padding",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._set-padding))",[[0,[2,"set-padding"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-page",">browser/index.html#(meth._(((lib._browser/browser..rkt)._hyper-canvas-mixin)._set-page))",[[0,[2,"set-page"]],[14,[" (method of ",[0,[2,"hyper-canvas-mixin"]],")"]]],["browser/browser","browser"]],
["set-page-numbers-visible!",">slideshow/Viewer_Control.html#(def._((lib._slideshow/base..rkt)._set-page-numbers-visible!))",[0,[2,"set-page-numbers-visible!"]],["slideshow/base","slideshow"]],
["set-paper-name",">draw/ps-setup_.html#(meth._(((lib._racket/draw..rkt)._ps-setup~25)._set-paper-name))",[[0,[2,"set-paper-name"]],[14,[" (method of ",[0,[2,"ps-setup%"]],")"]]],["racket/draw"]],
["set-paragraph-alignment",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._set-paragraph-alignment))",[[0,[2,"set-paragraph-alignment"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-paragraph-margins",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._set-paragraph-margins))",[[0,[2,"set-paragraph-margins"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-parent-link-label",">mrlib/graph-snip___.html#(meth._(((lib._mrlib/graph..rkt)._graph-snip~3c~25~3e)._set-parent-link-label))",[[0,[2,"set-parent-link-label"]],[14,[" (method of ",[0,[2,"graph-snip<%>"]],")"]]],["mrlib/graph"]],
["set-paste-text-only",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._set-paste-text-only))",[[0,[2,"set-paste-text-only"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["set-path",">draw/region_.html#(meth._(((lib._racket/draw..rkt)._region~25)._set-path))",[[0,[2,"set-path"]],[14,[" (method of ",[0,[2,"region%"]],")"]]],["racket/draw"]],
["set-pen",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._set-pen))",[[0,[2,"set-pen"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["set-percentages",">framework/Panel.html#(meth._(((lib._framework/main..rkt)._panel~3adragable~3c~25~3e)._set-percentages))",[[0,[2,"set-percentages"]],[14,[" (method of ",[0,[2,"panel:dragable<%>"]],")"]]],["framework"]],
["set-piece-draw",">gl-board-game/index.html#(meth._(((lib._games/gl-board-game..rkt)._gl-board~25)._set-piece-draw))",[[0,[2,"set-piece-draw"]],[14,[" (method of ",[0,[2,"gl-board%"]],")"]]],["games/gl-board-game"]],
["set-pixel",">draw/bitmap-dc_.html#(meth._(((lib._racket/draw..rkt)._bitmap-dc~25)._set-pixel))",[[0,[2,"set-pixel"]],[14,[" (method of ",[0,[2,"bitmap-dc%"]],")"]]],["racket/draw"]],
["set-polygon",">draw/region_.html#(meth._(((lib._racket/draw..rkt)._region~25)._set-polygon))",[[0,[2,"set-polygon"]],[14,[" (method of ",[0,[2,"region%"]],")"]]],["racket/draw"]],
["set-port-next-location!",">reference/linecol.html#(def._((quote._~23~25kernel)._set-port-next-location!))",[0,[2,"set-port-next-location!"]],["racket/base","racket"]],
["set-port-position!",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_658",[0,[2,"set-port-position!"]],["rnrs/io/ports-6"]],
["set-position",">gui/scroll-event_.html#(meth._(((lib._mred/main..rkt)._scroll-event~25)._set-position))",[[0,[2,"set-position"]],[14,[" (method of ",[0,[2,"scroll-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-position",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._set-position))",[[0,[2,"set-position"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-position-bias-scroll",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._set-position-bias-scroll))",[[0,[2,"set-position-bias-scroll"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-posn-x!",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._set-posn-x!))",[0,[2,"set-posn-x!"]],["lang/htdp-advanced"]],
["set-posn-y!",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._set-posn-y!))",[0,[2,"set-posn-y!"]],["lang/htdp-advanced"]],
["set-post-body!",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-5..rkt)._set-post-body!))",[0,[2,"set-post-body!"]],[]],
["set-post-comments!",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-5..rkt)._set-post-comments!))",[0,[2,"set-post-comments!"]],[]],
["set-post-script-name",">draw/font-name-directory___.html#(meth._(((lib._racket/draw..rkt)._font-name-directory~3c~25~3e)._set-post-script-name))",[[0,[2,"set-post-script-name"]],[14,[" (method of ",[0,[2,"font-name-directory<%>"]],")"]]],["racket/draw"]],
["set-post-title!",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-5..rkt)._set-post-title!))",[0,[2,"set-post-title!"]],[]],
["set-preview-command",">draw/ps-setup_.html#(meth._(((lib._racket/draw..rkt)._ps-setup~25)._set-preview-command))",[[0,[2,"set-preview-command"]],[14,[" (method of ",[0,[2,"ps-setup%"]],")"]]],["racket/draw"]],
["set-ptr-offset!",">foreign/foreign_pointer-funcs.html#(def._((quote._~23~25foreign)._set-ptr-offset!))",[0,[2,"set-ptr-offset!"]],["ffi/unsafe"]],
["set-r",">gui/add-color___.html#(meth._(((lib._racket/snip..rkt)._add-color~3c~25~3e)._set-r))",[[0,[2,"set-r"]],[14,[" (method of ",[0,[2,"add-color<%>"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["set-r",">gui/mult-color___.html#(meth._(((lib._racket/snip..rkt)._mult-color~3c~25~3e)._set-r))",[[0,[2,"set-r"]],[14,[" (method of ",[0,[2,"mult-color<%>"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["set-range",">gui/gauge_.html#(meth._(((lib._mred/main..rkt)._gauge~25)._set-range))",[[0,[2,"set-range"]],[14,[" (method of ",[0,[2,"gauge%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-rectangle",">draw/region_.html#(meth._(((lib._racket/draw..rkt)._region~25)._set-rectangle))",[[0,[2,"set-rectangle"]],[14,[" (method of ",[0,[2,"region%"]],")"]]],["racket/draw"]],
["set-refresh-splash-on-gauge-change?!",">framework/Splash.html#(def._((lib._framework/splash..rkt)._set-refresh-splash-on-gauge-change~3f!))",[0,[2,"set-refresh-splash-on-gauge-change?!"]],["framework/splash"]],
["set-region-callback!",">cards/index.html#(def._((lib._games/cards..rkt)._set-region-callback!))",[0,[2,"set-region-callback!"]],["games/cards"]],
["set-region-data",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._set-region-data))",[[0,[2,"set-region-data"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-region-interactive-callback!",">cards/index.html#(def._((lib._games/cards..rkt)._set-region-interactive-callback!))",[0,[2,"set-region-interactive-callback!"]],["games/cards"]],
["set-remove",">reference/sets.html#(def._((lib._racket/set..rkt)._set-remove))",[0,[2,"set-remove"]],["racket/set","racket"]],
["set-replace-start",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3asearching~3c~25~3e)._set-replace-start))",[[0,[2,"set-replace-start"]],[14,[" (method of ",[0,[2,"text:searching<%>"]],")"]]],["framework"]],
["set-resize-corner",">gui/canvas___.html#(meth._(((lib._mred/main..rkt)._canvas~3c~25~3e)._set-resize-corner))",[[0,[2,"set-resize-corner"]],[14,[" (method of ",[0,[2,"canvas<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["set-rest!",">plai/mutator.html#(def._((lib._plai/mutator..rkt)._set-rest!))",[0,[2,"set-rest!"]],["plai/mutator"]],
["set-right-down",">gui/mouse-event_.html#(meth._(((lib._mred/main..rkt)._mouse-event~25)._set-right-down))",[[0,[2,"set-right-down"]],[14,[" (method of ",[0,[2,"mouse-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-root!",">plai/collector.html#(def._((lib._plai/collector..rkt)._set-root!))",[0,[2,"set-root!"]],["plai/collector"]],
["set-rotation",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._set-rotation))",[[0,[2,"set-rotation"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["set-rounded-rectangle",">draw/region_.html#(meth._(((lib._racket/draw..rkt)._region~25)._set-rounded-rectangle))",[[0,[2,"set-rounded-rectangle"]],[14,[" (method of ",[0,[2,"region%"]],")"]]],["racket/draw"]],
["set-scale",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._set-scale))",[[0,[2,"set-scale"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["set-scaling",">draw/ps-setup_.html#(meth._(((lib._racket/draw..rkt)._ps-setup~25)._set-scaling))",[[0,[2,"set-scaling"]],[14,[" (method of ",[0,[2,"ps-setup%"]],")"]]],["racket/draw"]],
["set-screen-name",">draw/font-name-directory___.html#(meth._(((lib._racket/draw..rkt)._font-name-directory~3c~25~3e)._set-screen-name))",[[0,[2,"set-screen-name"]],[14,[" (method of ",[0,[2,"font-name-directory<%>"]],")"]]],["racket/draw"]],
["set-scroll-page",">gui/canvas_.html#(meth._(((lib._mred/main..rkt)._canvas~25)._set-scroll-page))",[[0,[2,"set-scroll-page"]],[14,[" (method of ",[0,[2,"canvas%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-scroll-pos",">gui/canvas_.html#(meth._(((lib._mred/main..rkt)._canvas~25)._set-scroll-pos))",[[0,[2,"set-scroll-pos"]],[14,[" (method of ",[0,[2,"canvas%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-scroll-range",">gui/canvas_.html#(meth._(((lib._mred/main..rkt)._canvas~25)._set-scroll-range))",[[0,[2,"set-scroll-range"]],[14,[" (method of ",[0,[2,"canvas%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-scroll-step",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._set-scroll-step))",[[0,[2,"set-scroll-step"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-search-anchor",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3asearching~3c~25~3e)._set-search-anchor))",[[0,[2,"set-search-anchor"]],[14,[" (method of ",[0,[2,"text:searching<%>"]],")"]]],["framework"]],
["set-searching-state",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3asearching~3c~25~3e)._set-searching-state))",[[0,[2,"set-searching-state"]],[14,[" (method of ",[0,[2,"text:searching<%>"]],")"]]],["framework"]],
["set-selected",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._set-selected))",[[0,[2,"set-selected"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-selection",">gui/list-control___.html#(meth._(((lib._mred/main..rkt)._list-control~3c~25~3e)._set-selection))",[[0,[2,"set-selection"]],[14,[" (method of ",[0,[2,"list-control<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["set-selection",">gui/radio-box_.html#(meth._(((lib._mred/main..rkt)._radio-box~25)._set-selection))",[[0,[2,"set-selection"]],[14,[" (method of ",[0,[2,"radio-box%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-selection",">gui/tab-panel_.html#(meth._(((lib._mred/main..rkt)._tab-panel~25)._set-selection))",[[0,[2,"set-selection"]],[14,[" (method of ",[0,[2,"tab-panel%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-selection-visible",">gui/pasteboard_.html#(meth._(((lib._mred/main..rkt)._pasteboard~25)._set-selection-visible))",[[0,[2,"set-selection-visible"]],[14,[" (method of ",[0,[2,"pasteboard%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-servlet-custodian!",">web-server-internal/dispatch-servlets.html#(def._((lib._web-server/private/servlet..rkt)._set-servlet-custodian!))",[0,[2,"set-servlet-custodian!"]],["web-server/private/servlet"]],
["set-servlet-directory!",">web-server-internal/dispatch-servlets.html#(def._((lib._web-server/private/servlet..rkt)._set-servlet-directory!))",[0,[2,"set-servlet-directory!"]],["web-server/private/servlet"]],
["set-servlet-handler!",">web-server-internal/dispatch-servlets.html#(def._((lib._web-server/private/servlet..rkt)._set-servlet-handler!))",[0,[2,"set-servlet-handler!"]],["web-server/private/servlet"]],
["set-servlet-manager!",">web-server-internal/dispatch-servlets.html#(def._((lib._web-server/private/servlet..rkt)._set-servlet-manager!))",[0,[2,"set-servlet-manager!"]],["web-server/private/servlet"]],
["set-servlet-namespace!",">web-server-internal/dispatch-servlets.html#(def._((lib._web-server/private/servlet..rkt)._set-servlet-namespace!))",[0,[2,"set-servlet-namespace!"]],["web-server/private/servlet"]],
["set-shift-down",">gui/key-event_.html#(meth._(((lib._mred/main..rkt)._key-event~25)._set-shift-down))",[[0,[2,"set-shift-down"]],[14,[" (method of ",[0,[2,"key-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-shift-down",">gui/mouse-event_.html#(meth._(((lib._mred/main..rkt)._mouse-event~25)._set-shift-down))",[[0,[2,"set-shift-down"]],[14,[" (method of ",[0,[2,"mouse-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-shift-style",">gui/style___.html#(meth._(((lib._racket/snip..rkt)._style~3c~25~3e)._set-shift-style))",[[0,[2,"set-shift-style"]],[14,[" (method of ",[0,[2,"style<%>"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["set-short-title",">mrlib/Name_Message.html#(meth._(((lib._mrlib/name-message..rkt)._name-message~25)._set-short-title))",[[0,[2,"set-short-title"]],[14,[" (method of ",[0,[2,"name-message%"]],")"]]],["mrlib/name-message"]],
["set-shortcut",">gui/selectable-menu-item___.html#(meth._(((lib._mred/main..rkt)._selectable-menu-item~3c~25~3e)._set-shortcut))",[[0,[2,"set-shortcut"]],[14,[" (method of ",[0,[2,"selectable-menu-item<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["set-shortcut-prefix",">gui/selectable-menu-item___.html#(meth._(((lib._mred/main..rkt)._selectable-menu-item~3c~25~3e)._set-shortcut-prefix))",[[0,[2,"set-shortcut-prefix"]],[14,[" (method of ",[0,[2,"selectable-menu-item<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["set-show-menu-sort-key",">tools/drracket_frame.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aframe~3a~3c~25~3e)._set-show-menu-sort-key))",[[0,[2,"set-show-menu-sort-key"]],[14,[" (method of ",[0,[2,"drracket:frame:<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["set-single-click-action",">cards/index.html#(meth._(((lib._games/cards..rkt)._table~3c~25~3e)._set-single-click-action))",[[0,[2,"set-single-click-action"]],[14,[" (method of ",[0,[2,"table<%>"]],")"]]],["games/cards"]],
["set-size-add",">gui/style-delta_.html#(meth._(((lib._racket/snip..rkt)._style-delta~25)._set-size-add))",[[0,[2,"set-size-add"]],[14,[" (method of ",[0,[2,"style-delta%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["set-size-in-pixels-off",">gui/style-delta_.html#(meth._(((lib._racket/snip..rkt)._style-delta~25)._set-size-in-pixels-off))",[[0,[2,"set-size-in-pixels-off"]],[14,[" (method of ",[0,[2,"style-delta%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["set-size-in-pixels-on",">gui/style-delta_.html#(meth._(((lib._racket/snip..rkt)._style-delta~25)._set-size-in-pixels-on))",[[0,[2,"set-size-in-pixels-on"]],[14,[" (method of ",[0,[2,"style-delta%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["set-size-mult",">gui/style-delta_.html#(meth._(((lib._racket/snip..rkt)._style-delta~25)._set-size-mult))",[[0,[2,"set-size-mult"]],[14,[" (method of ",[0,[2,"style-delta%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["set-smoothing",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._set-smoothing))",[[0,[2,"set-smoothing"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["set-smoothing-off",">gui/style-delta_.html#(meth._(((lib._racket/snip..rkt)._style-delta~25)._set-smoothing-off))",[[0,[2,"set-smoothing-off"]],[14,[" (method of ",[0,[2,"style-delta%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["set-smoothing-on",">gui/style-delta_.html#(meth._(((lib._racket/snip..rkt)._style-delta~25)._set-smoothing-on))",[[0,[2,"set-smoothing-on"]],[14,[" (method of ",[0,[2,"style-delta%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["set-snip-data",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._set-snip-data))",[[0,[2,"set-snip-data"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["set-snipclass",">gui/snip_.html#(meth._(((lib._racket/snip..rkt)._snip~25)._set-snipclass))",[[0,[2,"set-snipclass"]],[14,[" (method of ",[0,[2,"snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["set-space-draw",">gl-board-game/index.html#(meth._(((lib._games/gl-board-game..rkt)._gl-board~25)._set-space-draw))",[[0,[2,"set-space-draw"]],[14,[" (method of ",[0,[2,"gl-board%"]],")"]]],["games/gl-board-game"]],
["set-splash-bitmap",">framework/Splash.html#(def._((lib._framework/splash..rkt)._set-splash-bitmap))",[0,[2,"set-splash-bitmap"]],["framework/splash"]],
["set-splash-char-observer",">framework/Splash.html#(def._((lib._framework/splash..rkt)._set-splash-char-observer))",[0,[2,"set-splash-char-observer"]],["framework/splash"]],
["set-splash-event-callback",">framework/Splash.html#(def._((lib._framework/splash..rkt)._set-splash-event-callback))",[0,[2,"set-splash-event-callback"]],["framework/splash"]],
["set-splash-paint-callback",">framework/Splash.html#(def._((lib._framework/splash..rkt)._set-splash-paint-callback))",[0,[2,"set-splash-paint-callback"]],["framework/splash"]],
["set-splash-progress-bar?!",">framework/Splash.html#(def._((lib._framework/splash..rkt)._set-splash-progress-bar~3f!))",[0,[2,"set-splash-progress-bar?!"]],["framework/splash"]],
["set-status",">cards/index.html#(meth._(((lib._games/cards..rkt)._table~3c~25~3e)._set-status))",[[0,[2,"set-status"]],[14,[" (method of ",[0,[2,"table<%>"]],")"]]],["games/cards"]],
["set-status-text",">gui/frame_.html#(meth._(((lib._mred/main..rkt)._frame~25)._set-status-text))",[[0,[2,"set-status-text"]],[14,[" (method of ",[0,[2,"frame%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-stencil-size",">draw/gl-config_.html#(meth._(((lib._racket/draw..rkt)._gl-config~25)._set-stencil-size))",[[0,[2,"set-stencil-size"]],[14,[" (method of ",[0,[2,"gl-config%"]],")"]]],["racket/draw"]],
["set-stereo",">draw/gl-config_.html#(meth._(((lib._racket/draw..rkt)._gl-config~25)._set-stereo))",[[0,[2,"set-stereo"]],[14,[" (method of ",[0,[2,"gl-config%"]],")"]]],["racket/draw"]],
["set-stipple",">draw/brush_.html#(meth._(((lib._racket/draw..rkt)._brush~25)._set-stipple))",[[0,[2,"set-stipple"]],[14,[" (method of ",[0,[2,"brush%"]],")"]]],["racket/draw"]],
["set-stipple",">draw/pen_.html#(meth._(((lib._racket/draw..rkt)._pen~25)._set-stipple))",[[0,[2,"set-stipple"]],[14,[" (method of ",[0,[2,"pen%"]],")"]]],["racket/draw"]],
["set-string",">gui/list-box_.html#(meth._(((lib._mred/main..rkt)._list-box~25)._set-string))",[[0,[2,"set-string"]],[14,[" (method of ",[0,[2,"list-box%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-string-selection",">gui/list-control___.html#(meth._(((lib._mred/main..rkt)._list-control~3c~25~3e)._set-string-selection))",[[0,[2,"set-string-selection"]],[14,[" (method of ",[0,[2,"list-control<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["set-style",">draw/brush_.html#(meth._(((lib._racket/draw..rkt)._brush~25)._set-style))",[[0,[2,"set-style"]],[14,[" (method of ",[0,[2,"brush%"]],")"]]],["racket/draw"]],
["set-style",">draw/pen_.html#(meth._(((lib._racket/draw..rkt)._pen~25)._set-style))",[[0,[2,"set-style"]],[14,[" (method of ",[0,[2,"pen%"]],")"]]],["racket/draw"]],
["set-style",">gui/snip_.html#(meth._(((lib._racket/snip..rkt)._snip~25)._set-style))",[[0,[2,"set-style"]],[14,[" (method of ",[0,[2,"snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["set-style-list",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._set-style-list))",[[0,[2,"set-style-list"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["set-style-off",">gui/style-delta_.html#(meth._(((lib._racket/snip..rkt)._style-delta~25)._set-style-off))",[[0,[2,"set-style-off"]],[14,[" (method of ",[0,[2,"style-delta%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["set-style-on",">gui/style-delta_.html#(meth._(((lib._racket/snip..rkt)._style-delta~25)._set-style-on))",[[0,[2,"set-style-on"]],[14,[" (method of ",[0,[2,"style-delta%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["set-styles-fixed",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3abasic~3c~25~3e)._set-styles-fixed))",[[0,[2,"set-styles-fixed"]],[14,[" (method of ",[0,[2,"text:basic<%>"]],")"]]],["framework"]],
["set-styles-sticky",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._set-styles-sticky))",[[0,[2,"set-styles-sticky"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-subtract",">reference/sets.html#(def._((lib._racket/set..rkt)._set-subtract))",[0,[2,"set-subtract"]],["racket/set","racket"]],
["set-surrogate",">framework/Mode.html#(meth._(((lib._framework/main..rkt)._mode~3ahost-text~3c~25~3e)._set-surrogate))",[[0,[2,"set-surrogate"]],[14,[" (method of ",[0,[2,"mode:host-text<%>"]],")"]]],["framework"]],
["set-symmetric-difference",">reference/sets.html#(def._((lib._racket/set..rkt)._set-symmetric-difference))",[0,[2,"set-symmetric-difference"]],["racket/set","racket"]],
["set-tab-size",">framework/Racket.html#(meth._(((lib._framework/main..rkt)._racket~3atext~3c~25~3e)._set-tab-size))",[[0,[2,"set-tab-size"]],[14,[" (method of ",[0,[2,"racket:text<%>"]],")"]]],["framework"]],
["set-tabbing",">embedded-gui/Helpers.html#(def._((lib._embedded-gui/main..rkt)._set-tabbing))",[0,[2,"set-tabbing"]],["embedded-gui"]],
["set-tabs",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._set-tabs))",[[0,[2,"set-tabs"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-text-background",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._set-text-background))",[[0,[2,"set-text-background"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["set-text-foreground",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._set-text-foreground))",[[0,[2,"set-text-foreground"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["set-text-mode",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._set-text-mode))",[[0,[2,"set-text-mode"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["set-text-to-search",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3asearchable~3c~25~3e)._set-text-to-search))",[[0,[2,"set-text-to-search"]],[14,[" (method of ",[0,[2,"frame:searchable<%>"]],")"]]],["framework"]],
["set-tight-text-fit",">gui/editor-snip_.html#(meth._(((lib._mred/main..rkt)._editor-snip~25)._set-tight-text-fit))",[[0,[2,"set-tight-text-fit"]],[14,[" (method of ",[0,[2,"editor-snip%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-time-nanosecond!",">srfi-std/srfi-19.html#set-time-nanosecond!",[0,[2,"set-time-nanosecond!"]],["srfi/19"]],
["set-time-second!",">srfi-std/srfi-19.html#set-time-second!",[0,[2,"set-time-second!"]],["srfi/19"]],
["set-time-stamp",">gui/event_.html#(meth._(((lib._mred/main..rkt)._event~25)._set-time-stamp))",[[0,[2,"set-time-stamp"]],[14,[" (method of ",[0,[2,"event%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-time-type!",">srfi-std/srfi-19.html#set-time-type!",[0,[2,"set-time-type!"]],["srfi/19"]],
["set-title",">browser/index.html#(meth._(((lib._browser/browser..rkt)._hyper-text-mixin)._set-title))",[[0,[2,"set-title"]],[14,[" (method of ",[0,[2,"hyper-text-mixin"]],")"]]],["browser/browser","browser"]],
["set-title",">browser/index.html#(meth._(((lib._browser/htmltext..rkt)._html-text~3c~25~3e)._set-title))",[[0,[2,"set-title"]],[14,[" (method of ",[0,[2,"html-text<%>"]],")"]]],["browser/htmltext"]],
["set-title-h!",">slideshow/Configuration.html#(def._((lib._slideshow/base..rkt)._set-title-h!))",[0,[2,"set-title-h!"]],["slideshow/base","slideshow"]],
["set-transformation",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._set-transformation))",[[0,[2,"set-transformation"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["set-translation",">draw/ps-setup_.html#(meth._(((lib._racket/draw..rkt)._ps-setup~25)._set-translation))",[[0,[2,"set-translation"]],[14,[" (method of ",[0,[2,"ps-setup%"]],")"]]],["racket/draw"]],
["set-transparent-text-backing-off",">gui/style-delta_.html#(meth._(((lib._racket/snip..rkt)._style-delta~25)._set-transparent-text-backing-off))",[[0,[2,"set-transparent-text-backing-off"]],[14,[" (method of ",[0,[2,"style-delta%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["set-transparent-text-backing-on",">gui/style-delta_.html#(meth._(((lib._racket/snip..rkt)._style-delta~25)._set-transparent-text-backing-on))",[[0,[2,"set-transparent-text-backing-on"]],[14,[" (method of ",[0,[2,"style-delta%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["set-underlined-off",">gui/style-delta_.html#(meth._(((lib._racket/snip..rkt)._style-delta~25)._set-underlined-off))",[[0,[2,"set-underlined-off"]],[14,[" (method of ",[0,[2,"style-delta%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["set-underlined-on",">gui/style-delta_.html#(meth._(((lib._racket/snip..rkt)._style-delta~25)._set-underlined-on))",[[0,[2,"set-underlined-on"]],[14,[" (method of ",[0,[2,"style-delta%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["set-union",">reference/sets.html#(def._((lib._racket/set..rkt)._set-union))",[0,[2,"set-union"]],["racket/set","racket"]],
["set-unmodified",">gui/snip_.html#(meth._(((lib._racket/snip..rkt)._snip~25)._set-unmodified))",[[0,[2,"set-unmodified"]],[14,[" (method of ",[0,[2,"snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["set-unread-start-point",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3aports~3c~25~3e)._set-unread-start-point))",[[0,[2,"set-unread-start-point"]],[14,[" (method of ",[0,[2,"text:ports<%>"]],")"]]],["framework"]],
["set-use-background-frame!",">slideshow/Viewer_Control.html#(def._((lib._slideshow/base..rkt)._set-use-background-frame!))",[0,[2,"set-use-background-frame!"]],["slideshow/base","slideshow"]],
["set-value",">gui/check-box_.html#(meth._(((lib._mred/main..rkt)._check-box~25)._set-value))",[[0,[2,"set-value"]],[14,[" (method of ",[0,[2,"check-box%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-value",">gui/gauge_.html#(meth._(((lib._mred/main..rkt)._gauge~25)._set-value))",[[0,[2,"set-value"]],[14,[" (method of ",[0,[2,"gauge%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-value",">gui/slider_.html#(meth._(((lib._mred/main..rkt)._slider~25)._set-value))",[[0,[2,"set-value"]],[14,[" (method of ",[0,[2,"slider%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-value",">gui/text-field_.html#(meth._(((lib._mred/main..rkt)._text-field~25)._set-value))",[[0,[2,"set-value"]],[14,[" (method of ",[0,[2,"text-field%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-version",">gui/snip-class_.html#(meth._(((lib._racket/snip..rkt)._snip-class~25)._set-version))",[[0,[2,"set-version"]],[14,[" (method of ",[0,[2,"snip-class%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["set-weight-off",">gui/style-delta_.html#(meth._(((lib._racket/snip..rkt)._style-delta~25)._set-weight-off))",[[0,[2,"set-weight-off"]],[14,[" (method of ",[0,[2,"style-delta%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["set-weight-on",">gui/style-delta_.html#(meth._(((lib._racket/snip..rkt)._style-delta~25)._set-weight-on))",[[0,[2,"set-weight-on"]],[14,[" (method of ",[0,[2,"style-delta%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["set-width",">draw/pen_.html#(meth._(((lib._racket/draw..rkt)._pen~25)._set-width))",[[0,[2,"set-width"]],[14,[" (method of ",[0,[2,"pen%"]],")"]]],["racket/draw"]],
["set-wordbreak-func",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._set-wordbreak-func))",[[0,[2,"set-wordbreak-func"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-wordbreak-map",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._set-wordbreak-map))",[[0,[2,"set-wordbreak-map"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-x",">draw/point_.html#(meth._(((lib._racket/draw..rkt)._point~25)._set-x))",[[0,[2,"set-x"]],[14,[" (method of ",[0,[2,"point%"]],")"]]],["racket/draw"]],
["set-x",">gui/key-event_.html#(meth._(((lib._mred/main..rkt)._key-event~25)._set-x))",[[0,[2,"set-x"]],[14,[" (method of ",[0,[2,"key-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-x",">gui/mouse-event_.html#(meth._(((lib._mred/main..rkt)._mouse-event~25)._set-x))",[[0,[2,"set-x"]],[14,[" (method of ",[0,[2,"mouse-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-y",">draw/point_.html#(meth._(((lib._racket/draw..rkt)._point~25)._set-y))",[[0,[2,"set-y"]],[14,[" (method of ",[0,[2,"point%"]],")"]]],["racket/draw"]],
["set-y",">gui/key-event_.html#(meth._(((lib._mred/main..rkt)._key-event~25)._set-y))",[[0,[2,"set-y"]],[14,[" (method of ",[0,[2,"key-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["set-y",">gui/mouse-event_.html#(meth._(((lib._mred/main..rkt)._mouse-event~25)._set-y))",[[0,[2,"set-y"]],[14,[" (method of ",[0,[2,"mouse-event%"]],")"]]],["racket/gui/base","racket/gui"]],
["set...",">more/index.html#(part._.Set___)","Set...",false],
["set...",">quick/index.html#(part._.Set___)","Set...",false],
["set/c",">reference/sets.html#(def._((lib._racket/set..rkt)._set/c))",[0,[2,"set/c"]],["racket/set","racket"]],
["set=?",">reference/sets.html#(def._((lib._racket/set..rkt)._set~3d~3f))",[0,[2,"set=?"]],["racket/set","racket"]],
["set?",">reference/sets.html#(def._((lib._racket/set..rkt)._set~3f))",[0,[2,"set?"]],["racket/set","racket"]],
["seteq",">reference/sets.html#(def._((lib._racket/set..rkt)._seteq))",[0,[2,"seteq"]],["racket/set","racket"]],
["seteqv",">reference/sets.html#(def._((lib._racket/set..rkt)._seteqv))",[0,[2,"seteqv"]],["racket/set","racket"]],
["setof",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Setof))",[0,[1,"Setof"]],["typed/racket/base","typed/racket"]],
["sets",">reference/sets.html","Sets",false],
["setting up library documentation",">scribble/how-to-doc.html#(part._setting-up)","Setting Up Library Documentation",false],
["setting up servlets",">web-server-internal/dispatch-servlets.html#(part._setup)","Setting Up Servlets",false],
["setup-option^",">raco/setup-plt-plt.html#(form._((lib._setup/option-sig..rkt)._setup-option~5e))",[0,[1,"setup-option^"]],["setup/option-sig"]],
["setup-program-name",">raco/setup-plt-plt.html#(sig-val._((lib._setup/option-sig..rkt)._setup-option~5e._setup-program-name))",[0,[2,"setup-program-name"]],["setup/option-sig"]],
["setup/configtab",">config/index.html#(mod-path._setup/configtab)",[9,[0,"setup/configtab"]],"module"],
["setup/dirs",">raco/dirs.html",[9,[0,"setup/dirs"]],"module"],
["setup/getinfo",">raco/getinfo.html",[9,[0,"setup/getinfo"]],"module"],
["setup/infotab",">raco/info_rkt.html",[9,[0,"setup/infotab"]],"module"],
["setup/link",">raco/link.html#(mod-path._setup/link)",[9,[0,"setup/link"]],"module"],
["setup/main-collects",">raco/relative-paths.html#(mod-path._setup/main-collects)",[9,[0,"setup/main-collects"]],"module"],
["setup/option-sig",">raco/setup-plt-plt.html#(mod-path._setup/option-sig)",[9,[0,"setup/option-sig"]],"module"],
["setup/option-unit",">raco/setup-plt-plt.html#(mod-path._setup/option-unit)",[9,[0,"setup/option-unit"]],"module"],
["setup/pack",">raco/plt.html#(mod-path._setup/pack)",[9,[0,"setup/pack"]],"module"],
["setup/parallel-build",">raco/make.html#(mod-path._setup/parallel-build)",[9,[0,"setup/parallel-build"]],"module"],
["setup/path-to-relative",">raco/relative-paths.html#(mod-path._setup/path-to-relative)",[9,[0,"setup/path-to-relative"]],"module"],
["setup/plt-installer",">raco/_plt-archives.html#(mod-path._setup/plt-installer)",[9,[0,"setup/plt-installer"]],"module"],
["setup/plt-installer-sig",">raco/_plt-archives.html#(mod-path._setup/plt-installer-sig)",[9,[0,"setup/plt-installer-sig"]],"module"],
["setup/plt-installer-unit",">raco/_plt-archives.html#(mod-path._setup/plt-installer-unit)",[9,[0,"setup/plt-installer-unit"]],"module"],
["setup/plt-single-installer",">raco/_plt-archives.html#(mod-path._setup/plt-single-installer)",[9,[0,"setup/plt-single-installer"]],"module"],
["setup/setup-unit",">raco/setup-plt-plt.html#(mod-path._setup/setup-unit)",[9,[0,"setup/setup-unit"]],"module"],
["setup/unpack",">raco/unpack.html#(mod-path._setup/unpack)",[9,[0,"setup/unpack"]],"module"],
["setup/xref",">raco/xref.html",[9,[0,"setup/xref"]],"module"],
["setup:option@",">raco/setup-plt-plt.html#(def._((lib._setup/option-unit..rkt)._setup~3aoption~40))",[0,[2,"setup:option@"]],["setup/option-unit"]],
["setup:plt-installer^",">raco/_plt-archives.html#(form._((lib._setup/plt-installer-sig..rkt)._setup~3aplt-installer~5e))",[0,[1,"setup:plt-installer^"]],["setup/plt-installer-sig"]],
["setup@",">raco/setup-plt-plt.html#(def._((lib._setup/setup-unit..rkt)._setup~40))",[0,[2,"setup@"]],["setup/setup-unit"]],
["seventh",">reference/pairs.html#(def._((lib._racket/list..rkt)._seventh))",[0,[2,"seventh"]],["racket/list","racket"]],
["seventh",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._seventh))",[0,[2,"seventh"]],["lang/htdp-advanced"]],
["seventh",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._seventh))",[0,[2,"seventh"]],["lang/htdp-beginner"]],
["seventh",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._seventh))",[0,[2,"seventh"]],["lang/htdp-beginner-abbr"]],
["seventh",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._seventh))",[0,[2,"seventh"]],["lang/htdp-intermediate"]],
["seventh",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._seventh))",[0,[2,"seventh"]],["lang/htdp-intermediate-lambda"]],
["seventh",">lazy/index.html#(def._((lib._lazy/main..rkt)._seventh))",[0,[2,"seventh"]],["lazy"]],
["seventh",">mzlib/mzlib_list.html#(def._((lib._mzlib/list..rkt)._seventh))",[0,[2,"seventh"]],["mzlib/list"]],
["seventh",">srfi-std/srfi-1.html#seventh",[0,[2,"seventh"]],["srfi/1"]],
["sexp",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Sexp))",[0,[1,"Sexp"]],["typed/racket/base","typed/racket"]],
["sexp?",">teachpack/2htdpuniverse.html#(def._((lib._2htdp/universe..rkt)._sexp~3f))",[0,[2,"sexp?"]],["2htdp/universe"]],
["sexpof",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Sexpof))",[0,[1,"Sexpof"]],["typed/racket/base","typed/racket"]],
["sexpr->configuration-table",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table..rkt)._sexpr-~3econfiguration-table))",[0,[2,"sexpr->configuration-table"]],["web-server/configuration/configuration-table"]],
["sgl",">sgl/main.html",[9,[0,"sgl"]],"module"],
["sgl/bitmap",">sgl/bitmaps.html",[9,[0,"sgl/bitmap"]],"module"],
["sgl/gl",">sgl/gl.html",[9,[0,"sgl/gl"]],"module"],
["sgl/gl-vectors",">sgl/gl-vectors.html",[9,[0,"sgl/gl-vectors"]],"module"],
["sgl/init",">sgl/init.html",[9,[0,"sgl/init"]],"module"],
["sgn",">reference/generic-numbers.html#(def._((lib._racket/math..rkt)._sgn))",[0,[2,"sgn"]],["racket/math","racket"]],
["sgn",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._sgn))",[0,[2,"sgn"]],["lang/htdp-advanced"]],
["sgn",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._sgn))",[0,[2,"sgn"]],["lang/htdp-beginner"]],
["sgn",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._sgn))",[0,[2,"sgn"]],["lang/htdp-beginner-abbr"]],
["sgn",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._sgn))",[0,[2,"sgn"]],["lang/htdp-intermediate"]],
["sgn",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._sgn))",[0,[2,"sgn"]],["lang/htdp-intermediate-lambda"]],
["sha-1 hashing",">openssl/index.html#(part._.S.H.A-1_.Hashing)","SHA-1 Hashing",false],
["sha1",">file/sha1b.html#(def._((lib._file/sha1..rkt)._sha1))",[0,[2,"sha1"]],["file/sha1"]],
["sha1",">openssl/index.html#(def._((lib._openssl/sha1..rkt)._sha1))",[0,[2,"sha1"]],["openssl/sha1"]],
["sha1 message digest",">file/sha1b.html","SHA1 Message Digest",false],
["sha1-bytes",">file/sha1b.html#(def._((lib._file/sha1..rkt)._sha1-bytes))",[0,[2,"sha1-bytes"]],["file/sha1"]],
["sha1-bytes",">openssl/index.html#(def._((lib._openssl/sha1..rkt)._sha1-bytes))",[0,[2,"sha1-bytes"]],["openssl/sha1"]],
["shade",">plot/porting.html#(def._((lib._plot/main..rkt)._shade))",[0,[2,"shade"]],["plot"]],
["shade",">plot/compat.html#(def._((lib._plot/compat..rkt)._shade))",[0,[2,"shade"]],["plot/compat"]],
["shade",">unstable/pict.html#(def._((lib._unstable/gui/pict..rkt)._shade))",[0,[2,"shade"]],["unstable/gui/pict"]],
["shadow",">unstable/pict.html#(def._((lib._unstable/gui/pict..rkt)._shadow))",[0,[2,"shadow"]],["unstable/gui/pict"]],
["shadow frames",">unstable/pict.html#(part._.Shadow_.Frames)","Shadow Frames",false],
["shadow-east",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._shadow-east))",[0,[2,"shadow-east"]],["2htdp/planetcute"]],
["shadow-frame",">unstable/pict.html#(def._((lib._unstable/gui/pict..rkt)._shadow-frame))",[0,[2,"shadow-frame"]],["unstable/gui/pict"]],
["shadow-north",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._shadow-north))",[0,[2,"shadow-north"]],["2htdp/planetcute"]],
["shadow-north-east",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._shadow-north-east))",[0,[2,"shadow-north-east"]],["2htdp/planetcute"]],
["shadow-north-west",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._shadow-north-west))",[0,[2,"shadow-north-west"]],["2htdp/planetcute"]],
["shadow-side-west",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._shadow-side-west))",[0,[2,"shadow-side-west"]],["2htdp/planetcute"]],
["shadow-south",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._shadow-south))",[0,[2,"shadow-south"]],["2htdp/planetcute"]],
["shadow-south-east",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._shadow-south-east))",[0,[2,"shadow-south-east"]],["2htdp/planetcute"]],
["shadow-south-west",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._shadow-south-west))",[0,[2,"shadow-south-west"]],["2htdp/planetcute"]],
["shadow-west",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._shadow-west))",[0,[2,"shadow-west"]],["2htdp/planetcute"]],
["shadowing",">reference/syntax-model.html#(tech._shadowing)","<span style=\"font-style: italic\">shadowing</span>",false],
["shadows",">teachpack/2htdpPlanet_Cute_Images.html#(part._pc~3a.Shadows)","Shadows",false],
["shadows",">guide/binding.html#(tech._shadow)","<span style=\"font-style: italic\">shadows</span>",false],
["shadows",">reference/syntax-model.html#(tech._shadow)","<span style=\"font-style: italic\">shadows</span>",false],
["shape",">srfi-std/srfi-25.html#shape",[0,[2,"shape"]],["srfi/25"]],
["shaped-parens",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._shaped-parens))",[0,[2,"shaped-parens"]],["scribble/racket","scribble/scheme"]],
["shaped-parens-shape",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._shaped-parens-shape))",[0,[2,"shaped-parens-shape"]],["scribble/racket","scribble/scheme"]],
["shaped-parens-val",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._shaped-parens-val))",[0,[2,"shaped-parens-val"]],["scribble/racket","scribble/scheme"]],
["shaped-parens?",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._shaped-parens~3f))",[0,[2,"shaped-parens?"]],["scribble/racket","scribble/scheme"]],
["shapes with borders",">unstable/pict.html#(part._.Shapes_with_.Borders)","Shapes with Borders",false],
["share and share alike",">continue/index.html#(part._.Share_and_.Share_.Alike)","Share and Share Alike",false],
["share-array",">srfi-std/srfi-25.html#share-array",[0,[2,"share-array"]],["srfi/25"]],
["shared",">reference/shared.html#(form._((lib._racket/shared..rkt)._shared))",[0,[1,"shared"]],["racket/shared","racket"]],
["shared",">htdp-langs/advanced.html#(form._((lib._lang/htdp-advanced..rkt)._shared))",[0,[1,"shared"]],["lang/htdp-advanced"]],
["shared",">reference/runtime.html#(idx._(gentag._332._(lib._scribblings/reference/reference..scrbl)))",[7,"'shared"],false],
["shared libraries",">foreign/Loading_Foreign_Libraries.html#(idx._(gentag._1._(lib._scribblings/foreign/foreign..scrbl)))","shared\nlibraries",false],
["shared memory space",">reference/places.html#(tech._shared._memory._space)","<span style=\"font-style: italic\">shared memory space</span>",false],
["shared objects",">foreign/Loading_Foreign_Libraries.html#(idx._(gentag._0._(lib._scribblings/foreign/foreign..scrbl)))","shared objects",false],
["shared-bytes",">reference/bytestrings.html#(def._((quote._~23~25kernel)._shared-bytes))",[0,[2,"shared-bytes"]],["racket/base","racket"]],
["shared-flvector",">reference/flonums.html#(def._((lib._racket/flonum..rkt)._shared-flvector))",[0,[2,"shared-flvector"]],["racket/flonum"]],
["shared-fxvector",">reference/fixnums.html#(def._((lib._racket/fixnum..rkt)._shared-fxvector))",[0,[2,"shared-fxvector"]],["racket/fixnum"]],
["sharing data and code across namespaces",">guide/mk-namespace.html#(part._.Sharing_.Data_and_.Code_.Across_.Namespaces)","Sharing Data and Code Across Namespaces",false],
["shell-execute",">reference/subprocess.html#(def._((quote._~23~25kernel)._shell-execute))",[0,[2,"shell-execute"]],["racket/base","racket"]],
["shellexecute",">reference/subprocess.html#(idx._(gentag._296._(lib._scribblings/reference/reference..scrbl)))","ShellExecute",false],
["shift",">reference/cont.html#(form._((lib._racket/control..rkt)._shift))",[0,[1,"shift"]],["racket/control"]],
["shift",">teachpack/2htdpuniverse.html#(form._((lib._2htdp/universe..rkt)._shift))",[0,[1,"shift"]],["2htdp/universe"]],
["shift",">gui/key-event_.html#(idx._(gentag._41._(lib._scribblings/gui/gui..scrbl)))",[7,"'shift"],false],
["shift style",">gui/editor-overview.html#(tech._shift._style)","<span style=\"font-style: italic\">shift style</span>",false],
["shift-at",">reference/cont.html#(form._((lib._racket/control..rkt)._shift-at))",[0,[1,"shift-at"]],["racket/control"]],
["shift0",">reference/cont.html#(form._((lib._racket/control..rkt)._shift0))",[0,[1,"shift0"]],["racket/control"]],
["shift0-at",">reference/cont.html#(form._((lib._racket/control..rkt)._shift0-at))",[0,[1,"shift0-at"]],["racket/control"]],
["short-dash",">draw/pen_.html#(idx._(gentag._58._(lib._scribblings/draw/draw..scrbl)))",[7,"'short-dash"],false],
["short-program+command-name",">raco/command.html#(def._((lib._raco/command-name..rkt)._short-program+command-name))",[0,[2,"short-program+command-name"]],["raco/command-name"]],
["short-stethoscope-icon",">images/Icons.html#(def._((lib._images/icons/misc..rkt)._short-stethoscope-icon))",[0,[2,"short-stethoscope-icon"]],["images/icons/misc"]],
["shortcuts for defining test cases",">rackunit/api.html#(part._.Shortcuts_for_.Defining_.Test_.Cases)","Shortcuts for Defining Test Cases",false],
["shorthand syntax",">planet/Using_PLaneT.html#(part._.Shorthand_.Syntax)","Shorthand Syntax",false],
["show",">planet/cmdline.html#(part._show)",[6,"show"],false],
["show",">gui/dialog_.html#(meth._(((lib._mred/main..rkt)._dialog~25)._show))",[[0,[2,"show"]],[14,[" (method of ",[0,[2,"dialog%"]],")"]]],["racket/gui/base","racket/gui"]],
["show",">gui/top-level-window___.html#(meth._(((lib._mred/main..rkt)._top-level-window~3c~25~3e)._show))",[[0,[2,"show"]],[14,[" (method of ",[0,[2,"top-level-window<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["show",">gui/window___.html#(meth._(((lib._mred/main..rkt)._window~3c~25~3e)._show))",[[0,[2,"show"]],[14,[" (method of ",[0,[2,"window<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["show",">embedded-gui/alignment___.html#(meth._(((lib._embedded-gui/main..rkt)._alignment~3c~25~3e)._show))",[[0,[2,"show"]],[14,[" (method of ",[0,[2,"alignment<%>"]],")"]]],["embedded-gui"]],
["show",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3abasic-mixin)._show))",[[0,[2,"show"]],[14,[" (method of ",[0,[2,"frame:basic-mixin"]],")"]]],["framework"]],
["show",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3afocus-table-mixin)._show))",[[0,[2,"show"]],[14,[" (method of ",[0,[2,"frame:focus-table-mixin"]],")"]]],["framework"]],
["show",">preprocessor/mzpp.html#(def._((lib._preprocessor/mzpp..rkt)._show))",[0,[2,"show"]],["preprocessor/mzpp"]],
["show",">unstable/pict.html#(def._((lib._unstable/gui/pict..rkt)._show))",[0,[2,"show"]],["unstable/gui/pict"]],
["show active keybindings menu item",">drracket/Menus.html#(idx._(gentag._88._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Show Active Keybindings</span> menu item",false],
["show definitions menu item",">drracket/Menus.html#(idx._(gentag._99._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Show Definitions</span> menu item",false],
["show interactions menu item",">drracket/Menus.html#(idx._(gentag._101._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Show Interactions</span> menu item",false],
["show line numbers menu item",">drracket/Menus.html#(idx._(gentag._113._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Show Line Numbers</span> menu item",false],
["show log menu item",">drracket/Menus.html#(idx._(gentag._105._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Show Log</span> menu item",false],
["show module browser menu item",">drracket/Menus.html#(idx._(gentag._115._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Show Module Browser</span> menu item",false],
["show optimization coach menu item",">drracket/Menus.html#(idx._(gentag._117._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Show Optimization Coach</span> menu item",false],
["show profile menu item",">drracket/Menus.html#(idx._(gentag._109._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Show Profile</span> menu item",false],
["show program contour menu item",">drracket/Menus.html#(idx._(gentag._111._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Show Program Contour</span> menu item",false],
["show tracing menu item",">drracket/Menus.html#(idx._(gentag._107._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Show Tracing</span> menu item",false],
["show-border",">gui/editor-snip_.html#(meth._(((lib._mred/main..rkt)._editor-snip~25)._show-border))",[[0,[2,"show-border"]],[14,[" (method of ",[0,[2,"editor-snip%"]],")"]]],["racket/gui/base","racket/gui"]],
["show-caret",">gui/editor-overview.html#(idx._(gentag._159._(lib._scribblings/gui/gui..scrbl)))",[7,"'show-caret"],false],
["show-caret",">gui/editor___.html#(idx._(gentag._206._(lib._scribblings/gui/gui..scrbl)))",[7,"'show-caret"],false],
["show-delegated-text",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3adelegate~3c~25~3e)._show-delegated-text))",[[0,[2,"show-delegated-text"]],[14,[" (method of ",[0,[2,"frame:delegate<%>"]],")"]]],["framework"]],
["show-dependencies",">macro-debugger/index.html#(def._((lib._macro-debugger/analysis/show-dependencies..rkt)._show-dependencies))",[0,[2,"show-dependencies"]],["macro-debugger/analysis/show-dependencies"]],
["show-dependencies",">macro-debugger/index.html#(idx._(gentag._1._(lib._macro-debugger/macro-debugger..scrbl)))","show-dependencies",false],
["show-help",">games/Showing_Text_Help.html#(def._((lib._games/show-help..rkt)._show-help))",[0,[2,"show-help"]],["games/show-help"]],
["show-import-tree",">syntax/module-helpers.html#(def._((lib._syntax/moddep..rkt)._show-import-tree))",[0,[2,"show-import-tree"]],["syntax/moddep"]],
["show-inactive-caret",">gui/editor-overview.html#(idx._(gentag._158._(lib._scribblings/gui/gui..scrbl)))",[7,"'show-inactive-caret"],false],
["show-info",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3ainfo~3c~25~3e)._show-info))",[[0,[2,"show-info"]],[14,[" (method of ",[0,[2,"frame:info<%>"]],")"]]],["framework"]],
["show-it",">picturing-programs/index.html#(def._((lib._picturing-programs/main..rkt)._show-it))",[0,[2,"show-it"]],["picturing-programs"]],
["show-line-numbers!",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3aline-numbers-mixin)._show-line-numbers!))",[[0,[2,"show-line-numbers!"]],[14,[" (method of ",[0,[2,"text:line-numbers-mixin"]],")"]]],["framework"]],
["show-line-numbers!",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3aline-numbers~3c~25~3e)._show-line-numbers!))",[[0,[2,"show-line-numbers!"]],[14,[" (method of ",[0,[2,"text:line-numbers<%>"]],")"]]],["framework"]],
["show-line-numbers?",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3aline-numbers-mixin)._show-line-numbers~3f))",[[0,[2,"show-line-numbers?"]],[14,[" (method of ",[0,[2,"text:line-numbers-mixin"]],")"]]],["framework"]],
["show-line-numbers?",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3aline-numbers~3c~25~3e)._show-line-numbers~3f))",[[0,[2,"show-line-numbers?"]],[14,[" (method of ",[0,[2,"text:line-numbers<%>"]],")"]]],["framework"]],
["show-pict",">slideshow/Rendering.html#(def._((lib._slideshow/pict..rkt)._show-pict))",[0,[2,"show-pict"]],["slideshow/pict","slideshow"]],
["show-queen",">teachpack/show-queen.html#(def._((lib._htdp/show-queen..rkt)._show-queen))",[0,[2,"show-queen"]],["htdp/show-queen"]],
["show-queen teachpack",">teachpack/show-queen.html#(idx._(gentag._18._(lib._teachpack/teachpack..scrbl)))","show-queen teachpack",false],
["show-requires",">macro-debugger/index.html#(def._((lib._macro-debugger/analysis/check-requires..rkt)._show-requires))",[0,[2,"show-requires"]],["macro-debugger/analysis/check-requires"]],
["show-scribbling",">games/Showing_Scribbled_Help.html#(def._((lib._games/show-scribbling..rkt)._show-scribbling))",[0,[2,"show-scribbling"]],["games/show-scribbling"]],
["show-scrollbars",">gui/canvas_.html#(meth._(((lib._mred/main..rkt)._canvas~25)._show-scrollbars))",[[0,[2,"show-scrollbars"]],[14,[" (method of ",[0,[2,"canvas%"]],")"]]],["racket/gui/base","racket/gui"]],
["show-sharing",">mzlib/mzlib_pconvert.html#(def._((lib._mzlib/pconvert..rkt)._show-sharing))",[0,[2,"show-sharing"]],["mzlib/pconvert"]],
["show-visualizer",">reference/futures-visualizer.html#(def._((lib._future-visualizer/main..rkt)._show-visualizer))",[0,"show-visualizer"],["future-visualizer"]],
["show-window",">teachpack/gui.html#(def._((lib._htdp/gui..rkt)._show-window))",[0,[2,"show-window"]],["htdp/gui"]],
["show-without-yield",">gui/dialog_.html#(meth._(((lib._mred/main..rkt)._dialog~25)._show-without-yield))",[[0,[2,"show-without-yield"]],[14,[" (method of ",[0,[2,"dialog%"]],")"]]],["racket/gui/base","racket/gui"]],
["show/hide",">embedded-gui/alignment___.html#(meth._(((lib._embedded-gui/main..rkt)._alignment~3c~25~3e)._show/hide))",[[0,[2,"show/hide"]],[14,[" (method of ",[0,[2,"alignment<%>"]],")"]]],["embedded-gui"]],
["showing module dependencies",">macro-debugger/index.html#(part._.Showing_.Module_.Dependencies)","Showing Module Dependencies",false],
["showing racket examples",">scribble/how-to-doc.html#(part._.Showing_.Racket_.Examples)","Showing Racket Examples",false],
["showing scribbled help",">games/Showing_Scribbled_Help.html","Showing Scribbled Help",false],
["showing text help",">games/Showing_Text_Help.html","Showing Text Help",false],
["shrink",">teachpack/image.html#(def._((lib._htdp/image..rkt)._shrink))",[0,[2,"shrink"]],["htdp/image"]],
["shrink-bl",">teachpack/image.html#(def._((lib._htdp/image..rkt)._shrink-bl))",[0,[2,"shrink-bl"]],["htdp/image"]],
["shrink-br",">teachpack/image.html#(def._((lib._htdp/image..rkt)._shrink-br))",[0,[2,"shrink-br"]],["htdp/image"]],
["shrink-tl",">teachpack/image.html#(def._((lib._htdp/image..rkt)._shrink-tl))",[0,[2,"shrink-tl"]],["htdp/image"]],
["shrink-tr",">teachpack/image.html#(def._((lib._htdp/image..rkt)._shrink-tr))",[0,[2,"shrink-tr"]],["htdp/image"]],
["shuffle",">reference/pairs.html#(def._((lib._racket/list..rkt)._shuffle))",[0,[2,"shuffle"]],["racket/list","racket"]],
["shuffle-list",">cards/index.html#(def._((lib._games/cards..rkt)._shuffle-list))",[0,[2,"shuffle-list"]],["games/cards"]],
["shutdown",">tools/drracket_rep.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3arep~3atext~25)._shutdown))",[[0,[2,"shutdown"]],[14,[" (method of ",[0,[2,"drracket:rep:text%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["shutdown-splash",">framework/Splash.html#(def._((lib._framework/splash..rkt)._shutdown-splash))",[0,[2,"shutdown-splash"]],["framework/splash"]],
["side-condition",">redex/The_Redex_Reference.html#(tech._side._condition)",[0,"side-condition"],false],
["side-condition clause",">redex/The_Redex_Reference.html#(idx._(gentag._18._(lib._redex/redex..scrbl)))",[[0,"side-condition"]," clause"],false],
["side-condition/hidden clause",">redex/The_Redex_Reference.html#(idx._(gentag._19._(lib._redex/redex..scrbl)))",[[16,"side-condition/hidden"]," clause"],false],
["side-count?",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._side-count~3f))",[0,[2,"side-count?"]],["2htdp/image"]],
["sierp",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtle-examples..rkt)._sierp))",[0,[2,"sierp"]],["graphics/turtle-examples"]],
["sierp-nosplit",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtle-examples..rkt)._sierp-nosplit))",[0,[2,"sierp-nosplit"]],["graphics/turtle-examples"]],
["sierp-size",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtle-examples..rkt)._sierp-size))",[0,[2,"sierp-size"]],["graphics/turtle-examples"]],
["sierpinski triangle",">turtles/Traditional_Turtles.html#(idx._(gentag._0._(lib._graphics/scribblings/turtles..scrbl)))","Sierpinski triangle",false],
["sigelem",">scribble/doc-signatures.html#(form._((lib._scribble/manual..rkt)._sigelem))",[0,[1,"sigelem"]],["scribble/manual"]],
["signal-processing procedures",">frtime/index.html#(part._.Signal-.Processing_.Procedures)","Signal-Processing Procedures",false],
["signal?",">frtime/index.html#(def._((lib._frtime/main..rkt)._signal~3f))",[0,[2,"signal?"]],["frtime"]],
["signatur-variablen",">deinprogramm/Signaturen.html#(part._signature-variable)","Signatur-Variablen",false],
["signaturdeklaration",">deinprogramm/Signaturen.html#(part._.Signaturdeklaration)","Signaturdeklaration",false],
["signature",">dynext/Compilation.html#(part._compile-sig)","Signature",false],
["signature",">dynext/Filenames.html#(part._file-sig)","Signature",false],
["signature",">dynext/Linking.html#(part._link-sig)","Signature",false],
["signature",">make/collection.html#(part._.Signature)","Signature",false],
["signature",">make/make.html#(part._make-signature)","Signature",false],
["signature",">deinprogramm/Signaturen.html#(part._signature)",[0,[1,"signature"]],false],
["signature",">deinprogramm/Signaturen.html#(form._((lib._deinprogramm/.D.Md.A..rkt)._signature))",[0,[1,"signature"]],["deinprogramm/DMdA-beginner"]],
["signature",">reference/mzlib_unit.html#(tech._signature)","<span style=\"font-style: italic\">signature</span>",false],
["signature and unit",">draw/Signature_and_Unit.html","Signature and Unit",false],
["signature-desc",">scribble/doc-signatures.html#(def._((lib._scribble/manual..rkt)._signature-desc))",[0,[2,"signature-desc"]],["scribble/manual"]],
["signature-members",">reference/Transformer_Helpers.html#(def._((lib._mzlib/unit-exptime..rkt)._signature-members))",[0,[2,"signature-members"]],["racket/unit-exptime"]],
["signature-test-info%",">htdp/index.html#(def._((lib._test-engine/racket-tests..rkt)._signature-test-info~25))",[0,[2,"signature-test-info%"]],["htdp/testing"]],
["signaturen",">deinprogramm/Signaturen.html","Signaturen",false],
["signaturen",">deinprogramm/advanced-signatures.html","Signaturen",false],
["signaturen",">deinprogramm/assignments-signatures.html","Signaturen",false],
["signaturen",">deinprogramm/signatures-vanilla.html","Signaturen",false],
["signatures",">graphics/Graphics_Library_as_a_Unit.html#(part._.Signatures)","Signatures",false],
["signatures",">framework/Signatures.html","Signatures",false],
["signatures",">raco/API_for_Raw_Compilation.html#(part._.Signatures)","Signatures",false],
["signatures",">guide/Signatures_and_Units.html#(tech._signature)","<span style=\"font-style: italic\">signatures</span>",false],
["signatures and units",">guide/Signatures_and_Units.html","Signatures and Units",false],
["sigplan paper format",">scribble/SIGPLAN_Paper_Format.html","SIGPLAN Paper Format",false],
["simple branching: if",">guide/conditionals.html#(part._.Simple_.Branching__if)",["Simple Branching: ",[0,[1,"if"]]],false],
["simple contracts on functions",">guide/contract-func.html","Simple Contracts on Functions",false],
["simple definitions and expressions",">guide/syntax-overview.html","Simple Definitions and Expressions",false],
["simple dispatch: case",">guide/case.html",["Simple Dispatch: ",[0,[1,"case"]]],false],
["simple drawing: \"draw.ss\"",">teachpack/draw.html",["Simple Drawing: ",[6,"\"draw.ss\""],"<a name=\"(idx._(gentag._6._(lib._teachpack/teachpack..scrbl)))\"></a>"],false],
["simple goals and queries",">racklog/simple.html","Simple Goals and Queries",false],
["simple graphical user interfaces: \"gui.ss\"",">teachpack/gui.html",["Simple Graphical User Interfaces: ",[6,"\"gui.ss\""],"<a name=\"(idx._(gentag._13._(lib._teachpack/teachpack..scrbl)))\"></a>"],false],
["simple queries",">db/query-api.html#(part._.Simple_.Queries)","Simple Queries",false],
["simple simulations",">teachpack/2htdpuniverse.html#(part._simulations)","Simple Simulations",false],
["simple simulations",">teachpack/world.html#(part._simulations)","Simple Simulations",false],
["simple single servlet servers",">web-server-internal/web-server.html#(part._.Simple_.Single_.Servlet_.Servers)","Simple Single Servlet Servers",false],
["simple single servlet servers",">web-server/run.html#(part._servlet-env)","Simple Single Servlet Servers",false],
["simple structure types: struct",">guide/define-struct.html#(part._.Simple_.Structure_.Types__struct)",["Simple Structure Types: ",[0,[1,"struct"]]],false],
["simple subprocesses",">reference/subprocess.html#(part._.Simple_.Subprocesses)","Simple Subprocesses",false],
["simple text",">gui/editor-overview.html#(tech._simple._text)","<span style=\"font-style: italic\">Simple text</span>",false],
["simple values",">guide/Simple_Values.html","Simple Values",false],
["simple x-expression path queries",">xml/index.html#(part._.Simple_.X-expression_.Path_.Queries)","Simple X-expression Path Queries",false],
["simple-conditions",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_396",[0,[2,"simple-conditions"]],["rnrs/conditions-6"]],
["simple-form-path",">reference/More_Path_Utilities.html#(def._((lib._racket/path..rkt)._simple-form-path))",[0,[2,"simple-form-path"]],["racket/path","racket"]],
["simple-module-binding",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._simple-module-binding))",[0,[2,"simple-module-binding"]],["compiler/zo-structs"]],
["simple-module-binding-path",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._simple-module-binding-path))",[0,[2,"simple-module-binding-path"]],["compiler/zo-structs"]],
["simple-module-binding?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._simple-module-binding~3f))",[0,[2,"simple-module-binding?"]],["compiler/zo-structs"]],
["simple-nominal-path",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._simple-nominal-path))",[0,[2,"simple-nominal-path"]],["compiler/zo-structs"]],
["simple-nominal-path-value",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._simple-nominal-path-value))",[0,[2,"simple-nominal-path-value"]],["compiler/zo-structs"]],
["simple-nominal-path?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._simple-nominal-path~3f))",[0,[2,"simple-nominal-path?"]],["compiler/zo-structs"]],
["simple-result",">db/query-api.html#(def._((lib._db/base..rkt)._simple-result))",[0,[2,"simple-result"]],["db","db/base"]],
["simple-result-info",">db/query-api.html#(def._((lib._db/base..rkt)._simple-result-info))",[0,[2,"simple-result-info"]],["db","db/base"]],
["simple-result?",">db/query-api.html#(def._((lib._db/base..rkt)._simple-result~3f))",[0,[2,"simple-result?"]],["db","db/base"]],
["simplify-path",">reference/Manipulating_Paths.html#(def._((quote._~23~25kernel)._simplify-path))",[0,[2,"simplify-path"]],["racket/base","racket"]],
["simplifying module paths",">syntax/module-helpers.html#(part._modcollapse)","Simplifying Module Paths",false],
["simulate-file",">teachpack/2htdpbatch-io.html#(form._((lib._2htdp/batch-io..rkt)._simulate-file))",[0,[1,"simulate-file"]],["2htdp/batch-io"]],
["simulating a door: data",">teachpack/world.html#(part._.Simulating_a_.Door__.Data)","Simulating a Door: Data",false],
["simulating a door: functions",">teachpack/world.html#(part._.Simulating_a_.Door__.Functions)","Simulating a Door: Functions",false],
["simulations and animations: \"world.ss\"",">teachpack/world.html",["Simulations and Animations: ",[6,"\"world.ss\""],"<a name=\"(idx._(gentag._1._(lib._teachpack/teachpack..scrbl)))\"></a>"],false],
["simulations of the world",">teachpack/world.html#(part._.Simulations_of_the_.World)","Simulations of the World",false],
["sin",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._sin))",[0,[2,"sin"]],["racket/base","racket"]],
["sin",">r5rs-std/r5rs-Z-H-9.html#%_idx_330",[0,[2,"sin"]],["r5rs"]],
["sin",">r6rs-std/r6rs-Z-H-14.html#node_idx_546",[0,[2,"sin"]],["rnrs/base-6"]],
["sin",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._sin))",[0,[2,"sin"]],["lang/htdp-advanced"]],
["sin",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._sin))",[0,[2,"sin"]],["lang/htdp-beginner"]],
["sin",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._sin))",[0,[2,"sin"]],["lang/htdp-beginner-abbr"]],
["sin",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._sin))",[0,[2,"sin"]],["lang/htdp-intermediate"]],
["sin",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._sin))",[0,[2,"sin"]],["lang/htdp-intermediate-lambda"]],
["sin",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._sin))",[0,[2,"sin"]],["deinprogramm/DMdA-advanced"]],
["sin",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._sin))",[0,[2,"sin"]],["deinprogramm/DMdA-assignments"]],
["sin",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._sin))",[0,[2,"sin"]],["deinprogramm/DMdA-beginner"]],
["sin",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._sin))",[0,[2,"sin"]],["deinprogramm/DMdA-vanilla"]],
["sine",">htdp-langs/beginner.html#(idx._htdp-beginner._(gentag._12._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-beginner))","sine",false],
["sine",">htdp-langs/beginner-abbr.html#(idx._htdp-beginner-abbr._(gentag._27._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-beginner-abbr))","sine",false],
["sine",">htdp-langs/intermediate.html#(idx._htdp-intermediate._(gentag._36._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-intermediate))","sine",false],
["sine",">htdp-langs/intermediate-lam.html#(idx._htdp-intermediate-lambda._(gentag._45._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-intermediate-lambda))","sine",false],
["sine",">htdp-langs/advanced.html#(idx._htdp-advanced._(gentag._54._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-advanced))","sine",false],
["single",">gui/Windowing_Functions.html#(idx._(gentag._143._(lib._scribblings/gui/gui..scrbl)))",[7,"'single"],false],
["single-flonum",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Single-.Flonum))",[0,[1,"Single-Flonum"]],["typed/racket/base","typed/racket"]],
["single-flonum-complex",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Single-.Flonum-.Complex))",[0,[1,"Single-Flonum-Complex"]],["typed/racket/base","typed/racket"]],
["single-flonum-nan",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Single-.Flonum-.Nan))",[0,[1,"Single-Flonum-Nan"]],["typed/racket/base","typed/racket"]],
["single-flonum-negative-zero",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Single-.Flonum-.Negative-.Zero))",[0,[1,"Single-Flonum-Negative-Zero"]],["typed/racket/base","typed/racket"]],
["single-flonum-positive-zero",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Single-.Flonum-.Positive-.Zero))",[0,[1,"Single-Flonum-Positive-Zero"]],["typed/racket/base","typed/racket"]],
["single-flonum-zero",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Single-.Flonum-.Zero))",[0,[1,"Single-Flonum-Zero"]],["typed/racket/base","typed/racket"]],
["single-flonum?",">reference/number-types.html#(def._((quote._~23~25kernel)._single-flonum~3f))",[0,[2,"single-flonum?"]],["racket/base","racket"]],
["single-line-text-mixin",">embedded-gui/Helpers.html#(def._((lib._embedded-gui/main..rkt)._single-line-text-mixin))",[0,[2,"single-line-text-mixin"]],["embedded-gui"]],
["single-signature modules",">reference/Single-Signature_Modules.html","Single-Signature Modules",false],
["single-term pattern",">syntax/stxparse-patterns.html#(tech._single._term._pattern)","<span style=\"font-style: italic\">single-term pattern</span>",false],
["single-term patterns",">syntax/stxparse-patterns.html#(part._.Single-term_.Patterns)","Single-term Patterns",false],
["single-unit modules",">reference/single-unit.html","Single-Unit Modules",false],
["singleton types",">ts-reference/type-ref.html#(part._.Singleton_.Types)","Singleton Types",false],
["sinh",">reference/generic-numbers.html#(def._((lib._racket/math..rkt)._sinh))",[0,[2,"sinh"]],["racket/math","racket"]],
["sinh",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._sinh))",[0,[2,"sinh"]],["lang/htdp-advanced"]],
["sinh",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._sinh))",[0,[2,"sinh"]],["lang/htdp-beginner"]],
["sinh",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._sinh))",[0,[2,"sinh"]],["lang/htdp-beginner-abbr"]],
["sinh",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._sinh))",[0,[2,"sinh"]],["lang/htdp-intermediate"]],
["sinh",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._sinh))",[0,[2,"sinh"]],["lang/htdp-intermediate-lambda"]],
["sint-list->bytevector",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_122",[0,[2,"sint-list->bytevector"]],["rnrs/bytevectors-6"]],
["sixth",">reference/pairs.html#(def._((lib._racket/list..rkt)._sixth))",[0,[2,"sixth"]],["racket/list","racket"]],
["sixth",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._sixth))",[0,[2,"sixth"]],["lang/htdp-advanced"]],
["sixth",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._sixth))",[0,[2,"sixth"]],["lang/htdp-beginner"]],
["sixth",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._sixth))",[0,[2,"sixth"]],["lang/htdp-beginner-abbr"]],
["sixth",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._sixth))",[0,[2,"sixth"]],["lang/htdp-intermediate"]],
["sixth",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._sixth))",[0,[2,"sixth"]],["lang/htdp-intermediate-lambda"]],
["sixth",">lazy/index.html#(def._((lib._lazy/main..rkt)._sixth))",[0,[2,"sixth"]],["lazy"]],
["sixth",">mzlib/mzlib_list.html#(def._((lib._mzlib/list..rkt)._sixth))",[0,[2,"sixth"]],["mzlib/list"]],
["sixth",">srfi-std/srfi-1.html#sixth",[0,[2,"sixth"]],["srfi/1"]],
["size-cache-invalid",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._size-cache-invalid))",[[0,[2,"size-cache-invalid"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["size-cache-invalid",">gui/snip_.html#(meth._(((lib._racket/snip..rkt)._snip~25)._size-cache-invalid))",[[0,[2,"size-cache-invalid"]],[14,[" (method of ",[0,[2,"snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["size-in-pixels",">slideshow/Primary_Slide_Functions.html#(def._((lib._slideshow/base..rkt)._size-in-pixels))",[0,[2,"size-in-pixels"]],["slideshow/base","slideshow"]],
["sk",">reference/characters.html#(idx._(gentag._143._(lib._scribblings/reference/reference..scrbl)))",[7,"'sk"],false],
["skip",">gui/editor-stream-in_.html#(meth._(((lib._mred/main..rkt)._editor-stream-in~25)._skip))",[[0,[2,"skip"]],[14,[" (method of ",[0,[2,"editor-stream-in%"]],")"]]],["racket/gui/base","racket/gui"]],
["skip",">gui/editor-stream-in-base_.html#(meth._(((lib._mred/main..rkt)._editor-stream-in-base~25)._skip))",[[0,[2,"skip"]],[14,[" (method of ",[0,[2,"editor-stream-in-base%"]],")"]]],["racket/gui/base","racket/gui"]],
["skip lists",">data/skip-list.html","Skip Lists",false],
["skip-list->list",">data/skip-list.html#(def._((lib._data/skip-list..rkt)._skip-list-~3elist))",[0,[2,"skip-list->list"]],["data/skip-list"]],
["skip-list-contract!",">data/skip-list.html#(def._((lib._data/skip-list..rkt)._skip-list-contract!))",[0,[2,"skip-list-contract!"]],["data/skip-list"]],
["skip-list-count",">data/skip-list.html#(def._((lib._data/skip-list..rkt)._skip-list-count))",[0,[2,"skip-list-count"]],["data/skip-list"]],
["skip-list-expand!",">data/skip-list.html#(def._((lib._data/skip-list..rkt)._skip-list-expand!))",[0,[2,"skip-list-expand!"]],["data/skip-list"]],
["skip-list-iter?",">data/skip-list.html#(def._((lib._data/skip-list..rkt)._skip-list-iter~3f))",[0,[2,"skip-list-iter?"]],["data/skip-list"]],
["skip-list-iterate-first",">data/skip-list.html#(def._((lib._data/skip-list..rkt)._skip-list-iterate-first))",[0,[2,"skip-list-iterate-first"]],["data/skip-list"]],
["skip-list-iterate-greatest",">data/skip-list.html#(def._((lib._data/skip-list..rkt)._skip-list-iterate-greatest))",[0,[2,"skip-list-iterate-greatest"]],["data/skip-list"]],
["skip-list-iterate-greatest/<=?",">data/skip-list.html#(def._((lib._data/skip-list..rkt)._skip-list-iterate-greatest/~3c~3d~3f))",[0,[2,"skip-list-iterate-greatest/<=?"]],["data/skip-list"]],
["skip-list-iterate-greatest/<?",">data/skip-list.html#(def._((lib._data/skip-list..rkt)._skip-list-iterate-greatest/~3c~3f))",[0,[2,"skip-list-iterate-greatest/<?"]],["data/skip-list"]],
["skip-list-iterate-key",">data/skip-list.html#(def._((lib._data/skip-list..rkt)._skip-list-iterate-key))",[0,[2,"skip-list-iterate-key"]],["data/skip-list"]],
["skip-list-iterate-least",">data/skip-list.html#(def._((lib._data/skip-list..rkt)._skip-list-iterate-least))",[0,[2,"skip-list-iterate-least"]],["data/skip-list"]],
["skip-list-iterate-least/>=?",">data/skip-list.html#(def._((lib._data/skip-list..rkt)._skip-list-iterate-least/~3e~3d~3f))",[0,[2,"skip-list-iterate-least/>=?"]],["data/skip-list"]],
["skip-list-iterate-least/>?",">data/skip-list.html#(def._((lib._data/skip-list..rkt)._skip-list-iterate-least/~3e~3f))",[0,[2,"skip-list-iterate-least/>?"]],["data/skip-list"]],
["skip-list-iterate-next",">data/skip-list.html#(def._((lib._data/skip-list..rkt)._skip-list-iterate-next))",[0,[2,"skip-list-iterate-next"]],["data/skip-list"]],
["skip-list-iterate-value",">data/skip-list.html#(def._((lib._data/skip-list..rkt)._skip-list-iterate-value))",[0,[2,"skip-list-iterate-value"]],["data/skip-list"]],
["skip-list-ref",">data/skip-list.html#(def._((lib._data/skip-list..rkt)._skip-list-ref))",[0,[2,"skip-list-ref"]],["data/skip-list"]],
["skip-list-remove!",">data/skip-list.html#(def._((lib._data/skip-list..rkt)._skip-list-remove!))",[0,[2,"skip-list-remove!"]],["data/skip-list"]],
["skip-list-remove-range!",">data/skip-list.html#(def._((lib._data/skip-list..rkt)._skip-list-remove-range!))",[0,[2,"skip-list-remove-range!"]],["data/skip-list"]],
["skip-list-set!",">data/skip-list.html#(def._((lib._data/skip-list..rkt)._skip-list-set!))",[0,[2,"skip-list-set!"]],["data/skip-list"]],
["skip-list?",">data/skip-list.html#(def._((lib._data/skip-list..rkt)._skip-list~3f))",[0,[2,"skip-list?"]],["data/skip-list"]],
["skip-to",">preprocessor/mzpp.html#(def._((lib._preprocessor/mzpp..rkt)._skip-to))",[0,[2,"skip-to"]],["preprocessor/mzpp"]],
["skip-whitespace",">framework/Color.html#(meth._(((lib._framework/main..rkt)._color~3atext~3c~25~3e)._skip-whitespace))",[[0,[2,"skip-whitespace"]],[14,[" (method of ",[0,[2,"color:text<%>"]],")"]]],["framework"]],
["slant",">gui/style-delta_.html#(idx._(gentag._182._(lib._scribblings/gui/gui..scrbl)))",[7,"'slant"],false],
["slant",">draw/font_.html#(idx._(gentag._37._(lib._scribblings/draw/draw..scrbl)))",[7,"'slant"],false],
["slatex",">slatex-wrap/index.html#(def._((lib._slatex/slatex-wrapper..rkt)._slatex))",[0,[2,"slatex"]],["slatex/slatex-wrapper"]],
["slatex wrapper",">slatex-wrap/index.html","SLaTeX Wrapper",false],
["slatex/no-latex",">slatex-wrap/index.html#(def._((lib._slatex/slatex-wrapper..rkt)._slatex/no-latex))",[0,[2,"slatex/no-latex"]],["slatex/slatex-wrapper"]],
["slatex/slatex-wrapper",">slatex-wrap/index.html",[9,[0,"slatex/slatex-wrapper"]],"module"],
["sleep",">reference/threads.html#(def._((quote._~23~25kernel)._sleep))",[0,[2,"sleep"]],["racket/base","racket"]],
["sleep",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._sleep))",[0,[2,"sleep"]],["lang/htdp-advanced"]],
["sleep-for-a-while",">teachpack/draw.html#(def._((lib._htdp/big-draw..rkt)._sleep-for-a-while))",[0,[2,"sleep-for-a-while"]],["htdp/draw"]],
["sleep/yield",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._sleep/yield))",[0,[2,"sleep/yield"]],["racket/gui/base","racket/gui"]],
["sleeping by embedded racket",">inside/threads.html#(part._sleeping)","Sleeping by Embedded Racket",false],
["slide",">slideshow/Primary_Slide_Functions.html#(def._((lib._slideshow/base..rkt)._slide))",[0,[2,"slide"]],["slideshow/base","slideshow"]],
["slide basics",">slideshow/Creating_Slide_Presentations.html#(part._.Slide_.Basics)","Slide Basics",false],
["slide registration",">slideshow/Slide_Registration.html","Slide Registration",false],
["slide->pict",">slideshow/Slide_Registration.html#(def._((lib._slideshow/base..rkt)._slide-~3epict))",[0,[2,"slide->pict"]],["slideshow/base","slideshow"]],
["slide-inset?",">slideshow/Configuration.html#(def._((lib._slideshow/base..rkt)._slide-inset~3f))",[0,[2,"slide-inset?"]],["slideshow/base","slideshow"]],
["slide-pict",">slideshow/play.html#(def._((lib._slideshow/play..rkt)._slide-pict))",[0,[2,"slide-pict"]],["slideshow/play"]],
["slide/staged",">unstable/Slideshow_Presentations.html#(form._((lib._unstable/gui/slideshow..rkt)._slide/staged))",[0,[1,"slide/staged"]],["unstable/gui/slideshow"]],
["slide?",">slideshow/Slide_Registration.html#(def._((lib._slideshow/base..rkt)._slide~3f))",[0,[2,"slide?"]],["slideshow/base","slideshow"]],
["slider",">gui/slider_.html#(idx._(gentag._124._(lib._scribblings/gui/gui..scrbl)))",[7,"'slider"],false],
["slider",">gui/windowing-overview.html#(tech._slider)","<span style=\"font-style: italic\">slider</span>",false],
["slider%",">gui/slider_.html",[0,[2,"slider%"]],["racket/gui/base","racket/gui"]],
["slides to picts",">slideshow/Slides_to_Picts.html","Slides to Picts",false],
["slideshow",">slideshow/index.html",[9,[0,"slideshow"]],"module"],
["slideshow presentations",">unstable/Slideshow_Presentations.html","Slideshow Presentations",false],
["slideshow/balloon",">slideshow/More_Pict_Constructors.html#(mod-path._slideshow/balloon)",[9,[0,"slideshow/balloon"]],"module"],
["slideshow/base",">slideshow/Making_Slides.html",[9,[0,"slideshow/base"]],"module"],
["slideshow/code",">slideshow/Typesetting_Racket_Code.html",[9,[0,"slideshow/code"]],"module"],
["slideshow/face",">slideshow/More_Pict_Constructors.html#(mod-path._slideshow/face)",[9,[0,"slideshow/face"]],"module"],
["slideshow/flash",">slideshow/More_Pict_Constructors.html#(mod-path._slideshow/flash)",[9,[0,"slideshow/flash"]],"module"],
["slideshow/pict",">slideshow/Making_Pictures.html",[9,[0,"slideshow/pict"]],"module"],
["slideshow/pict-convert",">slideshow/Conversion_to_Picts.html",[9,[0,"slideshow/pict-convert"]],"module"],
["slideshow/play",">slideshow/play.html",[9,[0,"slideshow/play"]],"module"],
["slideshow/slides-to-picts",">slideshow/Slides_to_Picts.html",[9,[0,"slideshow/slides-to-picts"]],"module"],
["slideshow/start",">slideshow/Creating_Slide_Presentations.html#(mod-path._slideshow/start)",[9,[0,"slideshow/start"]],"module"],
["slideshow/step",">slideshow/Pict-Staging_Helper.html",[9,[0,"slideshow/step"]],"module"],
["slideshow: figure and presentation tools",">slideshow/index.html","Slideshow: Figure and Presentation Tools",false],
["slidey --- picture puzzle",">games/slidey.html",[[15,"<img src=\"slidey.png\" alt=\"\" />"]," ","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Slidey</span>"," ","&#8212;","<wbr></wbr>"," Picture Puzzle"],false],
["sllgen:list-define-datatypes",">eopl/index.html#(form._((lib._eopl/eopl..rkt)._sllgen~3alist-define-datatypes))",[0,[1,"sllgen:list-define-datatypes"]],["eopl"]],
["sllgen:make-define-datatypes",">eopl/index.html#(form._((lib._eopl/eopl..rkt)._sllgen~3amake-define-datatypes))",[0,[1,"sllgen:make-define-datatypes"]],["eopl"]],
["sllgen:make-rep-loop",">eopl/index.html#(def._((lib._eopl/eopl..rkt)._sllgen~3amake-rep-loop))",[0,[2,"sllgen:make-rep-loop"]],["eopl"]],
["sllgen:make-stream-parser",">eopl/index.html#(form._((lib._eopl/eopl..rkt)._sllgen~3amake-stream-parser))",[0,[1,"sllgen:make-stream-parser"]],["eopl"]],
["sllgen:make-string-parser",">eopl/index.html#(form._((lib._eopl/eopl..rkt)._sllgen~3amake-string-parser))",[0,[1,"sllgen:make-string-parser"]],["eopl"]],
["sllgen:make-string-scanner",">eopl/index.html#(form._((lib._eopl/eopl..rkt)._sllgen~3amake-string-scanner))",[0,[1,"sllgen:make-string-scanner"]],["eopl"]],
["sllgen:show-define-datatypes",">eopl/index.html#(form._((lib._eopl/eopl..rkt)._sllgen~3ashow-define-datatypes))",[0,[1,"sllgen:show-define-datatypes"]],["eopl"]],
["sm",">reference/characters.html#(idx._(gentag._142._(lib._scribblings/reference/reference..scrbl)))",[7,"'sm"],false],
["small",">html/index.html#(def._((lib._html/main..rkt)._small))",[0,[2,"small"]],["html"]],
["small",">unstable/Slideshow_Presentations.html#(form._((lib._unstable/gui/slideshow..rkt)._small))",[0,[1,"small"]],["unstable/gui/slideshow"]],
["small-check-syntax-icon",">images/Icons.html#(def._((lib._images/icons/tool..rkt)._small-check-syntax-icon))",[0,[2,"small-check-syntax-icon"]],["images/icons/tool"]],
["small-control-font",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._small-control-font))",[0,[2,"small-control-font"]],["racket/gui/base","racket/gui"]],
["small-debugger-icon",">images/Icons.html#(def._((lib._images/icons/tool..rkt)._small-debugger-icon))",[0,[2,"small-debugger-icon"]],["images/icons/tool"]],
["small-load-icon",">images/Icons.html#(def._((lib._images/icons/file..rkt)._small-load-icon))",[0,[2,"small-load-icon"]],["images/icons/file"]],
["small-macro-stepper-hash-color",">images/Icons.html#(def._((lib._images/icons/tool..rkt)._small-macro-stepper-hash-color))",[0,[2,"small-macro-stepper-hash-color"]],["images/icons/tool"]],
["small-macro-stepper-icon",">images/Icons.html#(def._((lib._images/icons/tool..rkt)._small-macro-stepper-icon))",[0,[2,"small-macro-stepper-icon"]],["images/icons/tool"]],
["small-save-icon",">images/Icons.html#(def._((lib._images/icons/file..rkt)._small-save-icon))",[0,[2,"small-save-icon"]],["images/icons/file"]],
["small?",">html/index.html#(def._((lib._html/main..rkt)._small~3f))",[0,[2,"small?"]],["html"]],
["smaller",">scribble/base.html#(def._((lib._scribble/base..rkt)._smaller))",[0,[2,"smaller"]],["scribble/base"]],
["smoothed",">gui/style-delta_.html#(idx._(gentag._186._(lib._scribblings/gui/gui..scrbl)))",[7,"'smoothed"],false],
["smoothed",">draw/font_.html#(idx._(gentag._44._(lib._scribblings/draw/draw..scrbl)))",[7,"'smoothed"],false],
["smtp functions",">net/smtp.html#(part._.S.M.T.P_.Functions)","SMTP Functions",false],
["smtp signature",">net/smtp.html#(part._.S.M.T.P_.Signature)","SMTP Signature",false],
["smtp unit",">net/smtp.html#(part._.S.M.T.P_.Unit)","SMTP Unit",false],
["smtp-send-message",">net/smtp.html#(def._((lib._net/smtp..rkt)._smtp-send-message))",[0,[2,"smtp-send-message"]],["net/smtp"]],
["smtp-sending-end-of-message",">net/smtp.html#(def._((lib._net/smtp..rkt)._smtp-sending-end-of-message))",[0,[2,"smtp-sending-end-of-message"]],["net/smtp"]],
["smtp: sending e-mail",">net/smtp.html","SMTP: Sending E-Mail",false],
["smtp@",">net/smtp.html#(def._((lib._net/smtp-unit..rkt)._smtp~40))",[0,[2,"smtp@"]],["net/smtp-unit"]],
["smtp^",">net/smtp.html#(form._((lib._net/smtp-sig..rkt)._smtp~5e))",[0,[1,"smtp^"]],["net/smtp-sig"]],
["snap-back-after-move",">cards/index.html#(meth._(((lib._games/cards..rkt)._card~3c~25~3e)._snap-back-after-move))",[[0,[2,"snap-back-after-move"]],[14,[" (method of ",[0,[2,"card<%>"]],")"]]],["games/cards"]],
["snapshot",">gui/key-event_.html#(idx._(gentag._60._(lib._scribblings/gui/gui..scrbl)))",[7,"'snapshot"],false],
["snip",">gui/editor-overview.html#(tech._snip)","<span style=\"font-style: italic\">snip</span>",false],
["snip administrator",">gui/editor-overview.html#(tech._snip._administrator)","<span style=\"font-style: italic\">snip administrator</span>",false],
["snip and style classes",">gui/Snip_and_Style_Classes.html","Snip and Style Classes",false],
["snip class",">gui/editor-overview.html#(tech._snip._clas)","<span style=\"font-style: italic\">snip class</span>",false],
["snip class list",">gui/editor-overview.html#(tech._snip._class._list)","<span style=\"font-style: italic\">snip class list</span>",false],
["snip class mapping",">gui/WXME_Decoding.html#(part._snipclassmapping)","Snip Class Mapping",false],
["snip classes",">gui/editor-overview.html#(part._editorsnipclasses)","Snip Classes",false],
["snip functions",">embedded-gui/snip-related-functions.html","Snip Functions",false],
["snip utilities",">unstable/snip.html","Snip Utilities",false],
["snip%",">gui/snip_.html",[0,[2,"snip%"]],["racket/snip","racket/gui/base","racket/gui"]],
["snip-admin%",">gui/snip-admin_.html",[0,[2,"snip-admin%"]],["racket/snip","racket/gui/base","racket/gui"]],
["snip-canvas%",">unstable/snip.html#(def._((lib._unstable/gui/snip..rkt)._snip-canvas~25))",[0,[2,"snip-canvas%"]],["unstable/gui/snip"]],
["snip-class",">mrlib/Cache-image_Snip.html#(def._((lib._mrlib/cache-image-snip..rkt)._snip-class))",[0,[2,"snip-class"]],["mrlib/cache-image-snip"]],
["snip-class%",">gui/snip-class_.html",[0,[2,"snip-class%"]],["racket/snip","racket/gui/base","racket/gui"]],
["snip-class-list<%>",">gui/snip-class-list___.html",[0,[2,"snip-class-list<%>"]],["racket/snip","racket/gui/base","racket/gui"]],
["snip-height",">embedded-gui/snip-related-functions.html#(def._((lib._embedded-gui/main..rkt)._snip-height))",[0,[2,"snip-height"]],["embedded-gui"]],
["snip-min-height",">embedded-gui/snip-related-functions.html#(def._((lib._embedded-gui/main..rkt)._snip-min-height))",[0,[2,"snip-min-height"]],["embedded-gui"]],
["snip-min-width",">embedded-gui/snip-related-functions.html#(def._((lib._embedded-gui/main..rkt)._snip-min-width))",[0,[2,"snip-min-width"]],["embedded-gui"]],
["snip-parent",">embedded-gui/snip-related-functions.html#(def._((lib._embedded-gui/main..rkt)._snip-parent))",[0,[2,"snip-parent"]],["embedded-gui"]],
["snip-reader<%>",">gui/WXME_Decoding.html#(def._((lib._wxme/main..rkt)._snip-reader~3c~25~3e))",[0,[2,"snip-reader<%>"]],["wxme"]],
["snip-width",">embedded-gui/snip-related-functions.html#(def._((lib._embedded-gui/main..rkt)._snip-width))",[0,[2,"snip-width"]],["embedded-gui"]],
["snip-wrapper%",">embedded-gui/snip-wrapper_.html",[0,[2,"snip-wrapper%"]],["embedded-gui"]],
["snips saving",">gui/editor-overview.html#(idx._(gentag._155._(lib._scribblings/gui/gui..scrbl)))","snips, saving",false],
["snips cut and paste",">gui/editor-overview.html#(idx._(gentag._156._(lib._scribblings/gui/gui..scrbl)))","snips, cut and paste",false],
["snips in a hierarchical-list% instance",">mrlib/Snips_in_a_hierarchical-list__Instance.html",["Snips in a ",[0,[2,"hierarchical-list%"]]," Instance"],false],
["so",">reference/characters.html#(idx._(gentag._144._(lib._scribblings/reference/reference..scrbl)))",[7,"'so"],false],
["so-suffix",">reference/runtime.html#(idx._(gentag._335._(lib._scribblings/reference/reference..scrbl)))",[7,"'so-suffix"],false],
["socket-connection%",">reference/distributed-places.html#(def._((lib._racket/place/distributed..rkt)._socket-connection~25))",[0,[2,"socket-connection%"]],["racket/place/distributed"]],
["soft state",">web-server/stateless.html#(part._.Soft_.State)","Soft State",false],
["soft-state",">web-server/stateless.html#(form._((lib._web-server/lang/soft..rkt)._soft-state))",[0,[1,"soft-state"]],["web-server/lang/soft"]],
["soft-state-ref",">web-server/stateless.html#(def._((lib._web-server/lang/soft..rkt)._soft-state-ref))",[0,[2,"soft-state-ref"]],["web-server/lang/soft"]],
["soft-state?",">web-server/stateless.html#(def._((lib._web-server/lang/soft..rkt)._soft-state~3f))",[0,[2,"soft-state?"]],["web-server/lang/soft"]],
["solid",">draw/brush_.html#(idx._(gentag._12._(lib._scribblings/draw/draw..scrbl)))",[7,"'solid"],false],
["solid",">draw/pen_.html#(idx._(gentag._53._(lib._scribblings/draw/draw..scrbl)))",[7,"'solid"],false],
["solving goals",">racklog/predicates.html#(part._solving-goals)","Solving Goals",false],
["some frequently used character classes",">guide/regexp-chars.html#(part._.Some_.Frequently_.Used_.Character_.Classes)","Some Frequently Used Character Classes",false],
["some-system-path->string",">reference/More_Path_Utilities.html#(def._((lib._racket/path..rkt)._some-system-path-~3estring))",[0,[2,"some-system-path->string"]],["racket/path","racket"]],
["somewhat-verbose",">raco/API_for_Raw_Compilation.html#(def._((lib._compiler/option..rkt)._somewhat-verbose))",[0,[2,"somewhat-verbose"]],["compiler/option"]],
["sort",">reference/pairs.html#(def._((lib._racket/private/list..rkt)._sort))",[0,[2,"sort"]],["racket/base","racket"]],
["sort",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._sort))",[0,[2,"sort"]],["lang/htdp-advanced"]],
["sort",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._sort))",[0,[2,"sort"]],["lang/htdp-intermediate"]],
["sort",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._sort))",[0,[2,"sort"]],["lang/htdp-intermediate-lambda"]],
["sort",">lazy/index.html#(def._((lib._lazy/main..rkt)._sort))",[0,[2,"sort"]],["lazy"]],
["sort",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..rkt)._hierarchical-list~25)._sort))",[[0,[2,"sort"]],[14,[" (method of ",[0,[2,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["sort-toolbar-buttons-panel",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aframe~3c~25~3e)._sort-toolbar-buttons-panel))",[[0,[2,"sort-toolbar-buttons-panel"]],[14,[" (method of ",[0,[2,"drracket:unit:frame<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["sound-teachpack",">deinprogramm/sound.html#(idx._(gentag._5._(lib._deinprogramm/scribblings/deinprogramm..scrbl)))","sound-Teachpack",false],
["source",">xml/index.html#(def._((lib._xml/main..rkt)._source))",[0,[2,"source"]],["xml"]],
["source annotations for documentation",">scribble/srcdoc.html#(part._.Source_.Annotations_for_.Documentation)","Source Annotations for Documentation",false],
["source locations",">guide/hash-reader.html#(part._.Source_.Locations)","Source Locations",false],
["source locations",">syntax/Source_Locations.html","Source Locations",false],
["source-handling configuration",">guide/language-get-info.html","Source-Handling Configuration",false],
["source-location->prefix",">syntax/Source_Locations.html#(def._((lib._syntax/srcloc..rkt)._source-location-~3eprefix))",[0,[2,"source-location->prefix"]],["syntax/srcloc"]],
["source-location->string",">syntax/Source_Locations.html#(def._((lib._syntax/srcloc..rkt)._source-location-~3estring))",[0,[2,"source-location->string"]],["syntax/srcloc"]],
["source-location-column",">syntax/Source_Locations.html#(def._((lib._syntax/srcloc..rkt)._source-location-column))",[0,[2,"source-location-column"]],["syntax/srcloc"]],
["source-location-end",">syntax/Source_Locations.html#(def._((lib._syntax/srcloc..rkt)._source-location-end))",[0,[2,"source-location-end"]],["syntax/srcloc"]],
["source-location-known?",">syntax/Source_Locations.html#(def._((lib._syntax/srcloc..rkt)._source-location-known~3f))",[0,[2,"source-location-known?"]],["syntax/srcloc"]],
["source-location-line",">syntax/Source_Locations.html#(def._((lib._syntax/srcloc..rkt)._source-location-line))",[0,[2,"source-location-line"]],["syntax/srcloc"]],
["source-location-list?",">syntax/Source_Locations.html#(def._((lib._syntax/srcloc..rkt)._source-location-list~3f))",[0,[2,"source-location-list?"]],["syntax/srcloc"]],
["source-location-position",">syntax/Source_Locations.html#(def._((lib._syntax/srcloc..rkt)._source-location-position))",[0,[2,"source-location-position"]],["syntax/srcloc"]],
["source-location-source",">syntax/Source_Locations.html#(def._((lib._syntax/srcloc..rkt)._source-location-source))",[0,[2,"source-location-source"]],["syntax/srcloc"]],
["source-location-span",">syntax/Source_Locations.html#(def._((lib._syntax/srcloc..rkt)._source-location-span))",[0,[2,"source-location-span"]],["syntax/srcloc"]],
["source-location-vector?",">syntax/Source_Locations.html#(def._((lib._syntax/srcloc..rkt)._source-location-vector~3f))",[0,[2,"source-location-vector?"]],["syntax/srcloc"]],
["source-location?",">syntax/Source_Locations.html#(def._((lib._syntax/srcloc..rkt)._source-location~3f))",[0,[2,"source-location?"]],["syntax/srcloc"]],
["source-start",">xml/index.html#(def._((lib._xml/main..rkt)._source-start))",[0,[2,"source-start"]],["xml"]],
["source-stop",">xml/index.html#(def._((lib._xml/main..rkt)._source-stop))",[0,[2,"source-stop"]],["xml"]],
["source?",">xml/index.html#(def._((lib._xml/main..rkt)._source~3f))",[0,[2,"source?"]],["xml"]],
["space",">teachpack/2htdpuniverse.html#(form._((lib._2htdp/universe..rkt)._space))",[0,[1,"space"]],["2htdp/universe"]],
["spaced-turtles",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtle-examples..rkt)._spaced-turtles))",[0,[2,"spaced-turtles"]],["graphics/turtle-examples"]],
["spaced-turtles",">turtles/Value_Turtles.html#(def._((lib._graphics/value-turtles-examples..rkt)._spaced-turtles))",[0,"spaced-turtles"],["graphics/value-turtles-examples"]],
["spaces, newlines, and indentation",">scribble/reader.html#(part._.Spaces__.Newlines__and_.Indentation)","Spaces, Newlines, and Indentation",false],
["spacing",">scribble/base.html#(part._spacing)","Spacing",false],
["spacing",">gui/area-container___.html#(meth._(((lib._mred/main..rkt)._area-container~3c~25~3e)._spacing))",[[0,[2,"spacing"]],[14,[" (method of ",[0,[2,"area-container<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["spacing",">gui/area-container___.html#(idx._(gentag._18._(lib._scribblings/gui/gui..scrbl)))",[0,"spacing"],false],
["span",">html/index.html#(def._((lib._html/main..rkt)._span))",[0,[2,"span"]],["html"]],
["span",">srfi-std/srfi-1.html#span",[0,[2,"span"]],["srfi/1"]],
["span!",">srfi-std/srfi-1.html#span!",[0,[2,"span!"]],["srfi/1"]],
["span-class",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/basic..rkt)._span-class))",[0,[2,"span-class"]],["scribble/basic"]],
["span?",">html/index.html#(def._((lib._html/main..rkt)._span~3f))",[0,[2,"span?"]],["html"]],
["spatial transformations",">images/Spatial_Transformations.html","Spatial Transformations",false],
["spawn",">reference/cont.html#(def._((lib._racket/control..rkt)._spawn))",[0,[2,"spawn"]],["racket/control"]],
["spawn",">mzlib/mzlib_cml.html#(def._((lib._mzlib/cml..rkt)._spawn))",[0,[2,"spawn"]],["mzlib/cml"]],
["spawn-node-at",">reference/distributed-places.html#(def._((lib._racket/place/distributed..rkt)._spawn-node-at))",[0,[2,"spawn-node-at"]],["racket/place/distributed"]],
["spawn-node-supervise-dynamic-place-at",">reference/distributed-places.html#(def._((lib._racket/place/distributed..rkt)._spawn-node-supervise-dynamic-place-at))",[0,[2,"spawn-node-supervise-dynamic-place-at"]],["racket/place/distributed"]],
["spawn-node-supervise-place-thunk-at",">reference/distributed-places.html#(def._((lib._racket/place/distributed..rkt)._spawn-node-supervise-place-thunk-at))",[0,[2,"spawn-node-supervise-place-thunk-at"]],["racket/place/distributed"]],
["spawn-node-with-dynamic-place-at",">reference/distributed-places.html#(def._((lib._racket/place/distributed..rkt)._spawn-node-with-dynamic-place-at))",[0,[2,"spawn-node-with-dynamic-place-at"]],["racket/place/distributed"]],
["spawn-node-with-place-thunk-at",">reference/distributed-places.html#(def._((lib._racket/place/distributed..rkt)._spawn-node-with-place-thunk-at))",[0,[2,"spawn-node-with-place-thunk-at"]],["racket/place/distributed"]],
["spawn-nodes/join",">reference/distributed-places.html#(def._((lib._racket/place/distributed..rkt)._spawn-nodes/join))",[0,[2,"spawn-nodes/join"]],["racket/place/distributed"]],
["spawn-remote-racket-node",">reference/distributed-places.html#(def._((lib._racket/place/distributed..rkt)._spawn-remote-racket-node))",[0,[2,"spawn-remote-racket-node"]],["racket/place/distributed"]],
["spawned-process%",">reference/distributed-places.html#(def._((lib._racket/place/distributed..rkt)._spawned-process~25))",[0,[2,"spawned-process%"]],["racket/place/distributed"]],
["specform",">scribble/doc-forms.html#(form._((lib._scribble/manual..rkt)._specform))",[0,[1,"specform"]],["scribble/manual"]],
["special comments",">reference/special-comments.html","Special Comments",false],
["special form reference",">ts-reference/special-forms.html","Special Form Reference",false],
["special-comment",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Special-.Comment))",[0,[1,"Special-Comment"]],["typed/racket/base","typed/racket"]],
["special-comment-value",">reference/special-comments.html#(def._((quote._~23~25kernel)._special-comment-value))",[0,[2,"special-comment-value"]],["racket/base","racket"]],
["special-comment?",">reference/special-comments.html#(def._((quote._~23~25kernel)._special-comment~3f))",[0,[2,"special-comment?"]],["racket/base","racket"]],
["special-control-key",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._special-control-key))",[0,[2,"special-control-key"]],["racket/gui/base","racket/gui"]],
["special-filter-input-port",">reference/port-lib.html#(def._((lib._racket/port..rkt)._special-filter-input-port))",[0,[2,"special-filter-input-port"]],["racket/port","racket"]],
["special-option-key",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._special-option-key))",[0,[2,"special-option-key"]],["racket/gui/base","racket/gui"]],
["specific-collections",">raco/setup-plt-plt.html#(sig-val._((lib._setup/option-sig..rkt)._setup-option~5e._specific-collections))",[0,[2,"specific-collections"]],["setup/option-sig"]],
["specific-planet-dirs",">raco/setup-plt-plt.html#(sig-val._((lib._setup/option-sig..rkt)._setup-option~5e._specific-planet-dirs))",[0,[2,"specific-planet-dirs"]],["setup/option-sig"]],
["specifying syntax with syntax classes",">syntax/stxparse-specifying.html","Specifying Syntax with Syntax Classes",false],
["specifying the color of each pixel of an image",">picturing-programs/index.html#(part._.Specifying_the_color_of_each_pixel_of_an_image)","Specifying the color of each pixel of an image",false],
["specifying types",">ts-guide/more.html","Specifying Types",false],
["specspecsubform",">scribble/doc-forms.html#(form._((lib._scribble/manual..rkt)._specspecsubform))",[0,[1,"specspecsubform"]],["scribble/manual"]],
["specspecsubform/subs",">scribble/doc-forms.html#(form._((lib._scribble/manual..rkt)._specspecsubform/subs))",[0,[1,"specspecsubform/subs"]],["scribble/manual"]],
["specsubform",">scribble/doc-forms.html#(form._((lib._scribble/manual..rkt)._specsubform))",[0,[1,"specsubform"]],["scribble/manual"]],
["specsubform/subs",">scribble/doc-forms.html#(form._((lib._scribble/manual..rkt)._specsubform/subs))",[0,[1,"specsubform/subs"]],["scribble/manual"]],
["speculatively atomic execution",">foreign/Speculatively_Atomic_Execution.html","Speculatively Atomic Execution",false],
["speech-bubble",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._speech-bubble))",[0,[2,"speech-bubble"]],["2htdp/planetcute"]],
["speed",">guide/performance.html","speed",false],
["spider --- solitaire card game",">games/spider.html",[[15,"<img src=\"spider.png\" alt=\"\" />"]," ","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Spider</span>"," ","&#8212;","<wbr></wbr>"," Solitaire Card Game"],false],
["splash",">framework/Splash.html","Splash",false],
["splay tree for tokenization",">syntax-color/index.html#(part._.Splay_.Tree_for_.Tokenization)","Splay Tree for Tokenization",false],
["splay trees",">data/Splay_Trees.html","Splay Trees",false],
["splay-tree->list",">data/Splay_Trees.html#(def._((lib._data/splay-tree..rkt)._splay-tree-~3elist))",[0,[2,"splay-tree->list"]],["data/splay-tree"]],
["splay-tree-contract!",">data/Splay_Trees.html#(def._((lib._data/splay-tree..rkt)._splay-tree-contract!))",[0,[2,"splay-tree-contract!"]],["data/splay-tree"]],
["splay-tree-count",">data/Splay_Trees.html#(def._((lib._data/splay-tree..rkt)._splay-tree-count))",[0,[2,"splay-tree-count"]],["data/splay-tree"]],
["splay-tree-expand!",">data/Splay_Trees.html#(def._((lib._data/splay-tree..rkt)._splay-tree-expand!))",[0,[2,"splay-tree-expand!"]],["data/splay-tree"]],
["splay-tree-iter?",">data/Splay_Trees.html#(def._((lib._data/splay-tree..rkt)._splay-tree-iter~3f))",[0,[2,"splay-tree-iter?"]],["data/splay-tree"]],
["splay-tree-iterate-first",">data/Splay_Trees.html#(def._((lib._data/splay-tree..rkt)._splay-tree-iterate-first))",[0,[2,"splay-tree-iterate-first"]],["data/splay-tree"]],
["splay-tree-iterate-greatest",">data/Splay_Trees.html#(def._((lib._data/splay-tree..rkt)._splay-tree-iterate-greatest))",[0,[2,"splay-tree-iterate-greatest"]],["data/splay-tree"]],
["splay-tree-iterate-greatest/<=?",">data/Splay_Trees.html#(def._((lib._data/splay-tree..rkt)._splay-tree-iterate-greatest/~3c~3d~3f))",[0,[2,"splay-tree-iterate-greatest/<=?"]],["data/splay-tree"]],
["splay-tree-iterate-greatest/<?",">data/Splay_Trees.html#(def._((lib._data/splay-tree..rkt)._splay-tree-iterate-greatest/~3c~3f))",[0,[2,"splay-tree-iterate-greatest/<?"]],["data/splay-tree"]],
["splay-tree-iterate-key",">data/Splay_Trees.html#(def._((lib._data/splay-tree..rkt)._splay-tree-iterate-key))",[0,[2,"splay-tree-iterate-key"]],["data/splay-tree"]],
["splay-tree-iterate-least",">data/Splay_Trees.html#(def._((lib._data/splay-tree..rkt)._splay-tree-iterate-least))",[0,[2,"splay-tree-iterate-least"]],["data/splay-tree"]],
["splay-tree-iterate-least/>=?",">data/Splay_Trees.html#(def._((lib._data/splay-tree..rkt)._splay-tree-iterate-least/~3e~3d~3f))",[0,[2,"splay-tree-iterate-least/>=?"]],["data/splay-tree"]],
["splay-tree-iterate-least/>?",">data/Splay_Trees.html#(def._((lib._data/splay-tree..rkt)._splay-tree-iterate-least/~3e~3f))",[0,[2,"splay-tree-iterate-least/>?"]],["data/splay-tree"]],
["splay-tree-iterate-next",">data/Splay_Trees.html#(def._((lib._data/splay-tree..rkt)._splay-tree-iterate-next))",[0,[2,"splay-tree-iterate-next"]],["data/splay-tree"]],
["splay-tree-iterate-value",">data/Splay_Trees.html#(def._((lib._data/splay-tree..rkt)._splay-tree-iterate-value))",[0,[2,"splay-tree-iterate-value"]],["data/splay-tree"]],
["splay-tree-ref",">data/Splay_Trees.html#(def._((lib._data/splay-tree..rkt)._splay-tree-ref))",[0,[2,"splay-tree-ref"]],["data/splay-tree"]],
["splay-tree-remove!",">data/Splay_Trees.html#(def._((lib._data/splay-tree..rkt)._splay-tree-remove!))",[0,[2,"splay-tree-remove!"]],["data/splay-tree"]],
["splay-tree-remove-range!",">data/Splay_Trees.html#(def._((lib._data/splay-tree..rkt)._splay-tree-remove-range!))",[0,[2,"splay-tree-remove-range!"]],["data/splay-tree"]],
["splay-tree-set!",">data/Splay_Trees.html#(def._((lib._data/splay-tree..rkt)._splay-tree-set!))",[0,[2,"splay-tree-set!"]],["data/splay-tree"]],
["splay-tree?",">data/Splay_Trees.html#(def._((lib._data/splay-tree..rkt)._splay-tree~3f))",[0,[2,"splay-tree?"]],["data/splay-tree"]],
["splice",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._splice))",[0,[2,"splice"]],["compiler/zo-structs"]],
["splice",">scribble/decode.html#(def._((lib._scribble/decode..rkt)._splice))",[0,[2,"splice"]],["scribble/decode"]],
["splice-forms",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._splice-forms))",[0,[2,"splice-forms"]],["compiler/zo-structs"]],
["splice-run",">scribble/decode.html#(def._((lib._scribble/decode..rkt)._splice-run))",[0,[2,"splice-run"]],["scribble/decode"]],
["splice?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._splice~3f))",[0,[2,"splice?"]],["compiler/zo-structs"]],
["splice?",">scribble/decode.html#(def._((lib._scribble/decode..rkt)._splice~3f))",[0,[2,"splice?"]],["scribble/decode"]],
["splicing syntax class",">syntax/stxparse-specifying.html#(tech._splicing._syntax._clas)","<span style=\"font-style: italic\">splicing syntax class</span>",false],
["splicing-let",">reference/splicing.html#(form._((lib._racket/splicing..rkt)._splicing-let))",[0,[1,"splicing-let"]],["racket/splicing"]],
["splicing-let-syntax",">reference/splicing.html#(form._((lib._racket/splicing..rkt)._splicing-let-syntax))",[0,[1,"splicing-let-syntax"]],["racket/splicing"]],
["splicing-let-syntaxes",">reference/splicing.html#(form._((lib._racket/splicing..rkt)._splicing-let-syntaxes))",[0,[1,"splicing-let-syntaxes"]],["racket/splicing"]],
["splicing-let-values",">reference/splicing.html#(form._((lib._racket/splicing..rkt)._splicing-let-values))",[0,[1,"splicing-let-values"]],["racket/splicing"]],
["splicing-letrec",">reference/splicing.html#(form._((lib._racket/splicing..rkt)._splicing-letrec))",[0,[1,"splicing-letrec"]],["racket/splicing"]],
["splicing-letrec-syntax",">reference/splicing.html#(form._((lib._racket/splicing..rkt)._splicing-letrec-syntax))",[0,[1,"splicing-letrec-syntax"]],["racket/splicing"]],
["splicing-letrec-syntaxes",">reference/splicing.html#(form._((lib._racket/splicing..rkt)._splicing-letrec-syntaxes))",[0,[1,"splicing-letrec-syntaxes"]],["racket/splicing"]],
["splicing-letrec-syntaxes+values",">reference/splicing.html#(form._((lib._racket/splicing..rkt)._splicing-letrec-syntaxes+values))",[0,[1,"splicing-letrec-syntaxes+values"]],["racket/splicing"]],
["splicing-letrec-values",">reference/splicing.html#(form._((lib._racket/splicing..rkt)._splicing-letrec-values))",[0,[1,"splicing-letrec-values"]],["racket/splicing"]],
["splicing-local",">reference/splicing.html#(form._((lib._racket/splicing..rkt)._splicing-local))",[0,[1,"splicing-local"]],["racket/splicing"]],
["splicing-syntax-parameterize",">reference/splicing.html#(form._((lib._racket/splicing..rkt)._splicing-syntax-parameterize))",[0,[1,"splicing-syntax-parameterize"]],["racket/splicing"]],
["split",">gui/snip_.html#(meth._(((lib._racket/snip..rkt)._snip~25)._split))",[[0,[2,"split"]],[14,[" (method of ",[0,[2,"snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["split",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3a1-pixel-string-snip~25)._split))",[[0,[2,"split"]],[14,[" (method of ",[0,[2,"text:1-pixel-string-snip%"]],")"]]],["framework"]],
["split",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3a1-pixel-tab-snip~25)._split))",[[0,[2,"split"]],[14,[" (method of ",[0,[2,"text:1-pixel-tab-snip%"]],")"]]],["framework"]],
["split",">turtles/Traditional_Turtles.html#(form._((lib._graphics/turtles..rkt)._split))",[0,[1,"split"]],["graphics/turtles"]],
["split",">mzlib/mzlib_integer-set.html#(def._((lib._mzlib/integer-set..rkt)._split))",[0,[2,"split"]],["mzlib/integer-set"]],
["split menu item",">drracket/Menus.html#(idx._(gentag._97._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Split</span> menu item",false],
["split*",">turtles/Traditional_Turtles.html#(form._((lib._graphics/turtles..rkt)._split*))",[0,[1,"split*"]],["graphics/turtles"]],
["split-at",">reference/pairs.html#(def._((lib._racket/list..rkt)._split-at))",[0,[2,"split-at"]],["racket/list","racket"]],
["split-at",">srfi-std/srfi-1.html#split-at",[0,[2,"split-at"]],["srfi/1"]],
["split-at!",">srfi-std/srfi-1.html#split-at!",[0,[2,"split-at!"]],["srfi/1"]],
["split-at-right",">reference/pairs.html#(def._((lib._racket/list..rkt)._split-at-right))",[0,[2,"split-at-right"]],["racket/list","racket"]],
["split-common-prefix",">unstable/list.html#(def._((lib._unstable/list..rkt)._split-common-prefix))",[0,[2,"split-common-prefix"]],["unstable/list"]],
["split-horizontal",">framework/Panel.html#(meth._(((lib._framework/main..rkt)._panel~3asplitter-mixin)._split-horizontal))",[[0,[2,"split-horizontal"]],[14,[" (method of ",[0,[2,"panel:splitter-mixin"]],")"]]],["framework"]],
["split-path",">reference/Manipulating_Paths.html#(def._((quote._~23~25kernel)._split-path))",[0,[2,"split-path"]],["racket/base","racket"]],
["split-phase",">slideshow/play.html#(def._((lib._slideshow/play..rkt)._split-phase))",[0,[2,"split-phase"]],["slideshow/play"]],
["split-snip",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._split-snip))",[[0,[2,"split-snip"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["split-vertical",">framework/Panel.html#(meth._(((lib._framework/main..rkt)._panel~3asplitter-mixin)._split-vertical))",[[0,[2,"split-vertical"]],[14,[" (method of ",[0,[2,"panel:splitter-mixin"]],")"]]],["framework"]],
["splitter",">reference/cont.html#(def._((lib._racket/control..rkt)._splitter))",[0,[2,"splitter"]],["racket/control"]],
["splitting the document source",">scribble/getting-started.html#(part._.Splitting_the_.Document_.Source)","Splitting the Document Source",false],
["spokes",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtle-examples..rkt)._spokes))",[0,[2,"spokes"]],["graphics/turtle-examples"]],
["spokes",">turtles/Value_Turtles.html#(def._((lib._graphics/value-turtles-examples..rkt)._spokes))",[0,"spokes"],["graphics/value-turtles-examples"]],
["sprachebenen und material zu die macht der abstraktion",">deinprogramm/index.html","Sprachebenen und Material zu <span style=\"font-style: italic\">Die Macht der Abstraktion</span>",false],
["spyro-gyra",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtle-examples..rkt)._spyro-gyra))",[0,[2,"spyro-gyra"]],["graphics/turtle-examples"]],
["spyro-gyra",">turtles/Value_Turtles.html#(def._((lib._graphics/value-turtles-examples..rkt)._spyro-gyra))",[0,"spyro-gyra"],["graphics/value-turtles-examples"]],
["sql data",">db/sql-types.html#(part._sql-data)","SQL Data",false],
["sql errors",">db/query-api.html#(part._.S.Q.L_.Errors)","SQL Errors",false],
["sql injection",">db/using-db.html#(part._dbsec-sql-injection)","SQL Injection",false],
["sql null",">db/sql-types.html#(part._.S.Q.L_.N.U.L.L)","SQL NULL",false],
["sql server",">db/index.html#(idx._(gentag._7._(lib._db/scribblings/db..scrbl)))","SQL Server",false],
["sql server odbc driver",">db/notes.html#(part._.S.Q.L_.Server_.O.D.B.C_.Driver)","SQL Server ODBC Driver",false],
["sql type conversions",">db/sql-types.html#(part._db-types)","SQL Type Conversions",false],
["sql types and conversions",">db/sql-types.html","SQL Types and Conversions",false],
["sql-bits->list",">db/sql-types.html#(def._((lib._db/base..rkt)._sql-bits-~3elist))",[0,[2,"sql-bits->list"]],["db","db/base"]],
["sql-bits->string",">db/sql-types.html#(def._((lib._db/base..rkt)._sql-bits-~3estring))",[0,[2,"sql-bits->string"]],["db","db/base"]],
["sql-bits-length",">db/sql-types.html#(def._((lib._db/base..rkt)._sql-bits-length))",[0,[2,"sql-bits-length"]],["db","db/base"]],
["sql-bits-ref",">db/sql-types.html#(def._((lib._db/base..rkt)._sql-bits-ref))",[0,[2,"sql-bits-ref"]],["db","db/base"]],
["sql-bits-set!",">db/sql-types.html#(def._((lib._db/base..rkt)._sql-bits-set!))",[0,[2,"sql-bits-set!"]],["db","db/base"]],
["sql-bits?",">db/sql-types.html#(def._((lib._db/base..rkt)._sql-bits~3f))",[0,[2,"sql-bits?"]],["db","db/base"]],
["sql-date",">db/sql-types.html#(def._((lib._db/base..rkt)._sql-date))",[0,[2,"sql-date"]],["db","db/base"]],
["sql-date-day",">db/sql-types.html#(def._((lib._db/base..rkt)._sql-date-day))",[0,[2,"sql-date-day"]],["db","db/base"]],
["sql-date-month",">db/sql-types.html#(def._((lib._db/base..rkt)._sql-date-month))",[0,[2,"sql-date-month"]],["db","db/base"]],
["sql-date-year",">db/sql-types.html#(def._((lib._db/base..rkt)._sql-date-year))",[0,[2,"sql-date-year"]],["db","db/base"]],
["sql-date?",">db/sql-types.html#(def._((lib._db/base..rkt)._sql-date~3f))",[0,[2,"sql-date?"]],["db","db/base"]],
["sql-datetime->srfi-date",">db/util.html#(def._((lib._db/util/datetime..rkt)._sql-datetime-~3esrfi-date))",[0,[2,"sql-datetime->srfi-date"]],["db/util/datetime"]],
["sql-day-time-interval->seconds",">db/util.html#(def._((lib._db/util/datetime..rkt)._sql-day-time-interval-~3eseconds))",[0,[2,"sql-day-time-interval->seconds"]],["db/util/datetime"]],
["sql-day-time-interval?",">db/sql-types.html#(def._((lib._db/base..rkt)._sql-day-time-interval~3f))",[0,[2,"sql-day-time-interval?"]],["db","db/base"]],
["sql-interval",">db/sql-types.html#(def._((lib._db/base..rkt)._sql-interval))",[0,[2,"sql-interval"]],["db","db/base"]],
["sql-interval->sql-time",">db/sql-types.html#(def._((lib._db/base..rkt)._sql-interval-~3esql-time))",[0,[2,"sql-interval->sql-time"]],["db","db/base"]],
["sql-interval-days",">db/sql-types.html#(def._((lib._db/base..rkt)._sql-interval-days))",[0,[2,"sql-interval-days"]],["db","db/base"]],
["sql-interval-hours",">db/sql-types.html#(def._((lib._db/base..rkt)._sql-interval-hours))",[0,[2,"sql-interval-hours"]],["db","db/base"]],
["sql-interval-minutes",">db/sql-types.html#(def._((lib._db/base..rkt)._sql-interval-minutes))",[0,[2,"sql-interval-minutes"]],["db","db/base"]],
["sql-interval-months",">db/sql-types.html#(def._((lib._db/base..rkt)._sql-interval-months))",[0,[2,"sql-interval-months"]],["db","db/base"]],
["sql-interval-nanoseconds",">db/sql-types.html#(def._((lib._db/base..rkt)._sql-interval-nanoseconds))",[0,[2,"sql-interval-nanoseconds"]],["db","db/base"]],
["sql-interval-seconds",">db/sql-types.html#(def._((lib._db/base..rkt)._sql-interval-seconds))",[0,[2,"sql-interval-seconds"]],["db","db/base"]],
["sql-interval-years",">db/sql-types.html#(def._((lib._db/base..rkt)._sql-interval-years))",[0,[2,"sql-interval-years"]],["db","db/base"]],
["sql-interval?",">db/sql-types.html#(def._((lib._db/base..rkt)._sql-interval~3f))",[0,[2,"sql-interval?"]],["db","db/base"]],
["sql-null",">db/sql-types.html#(def._((lib._db/base..rkt)._sql-null))",[0,[2,"sql-null"]],["db","db/base"]],
["sql-null->false",">db/sql-types.html#(def._((lib._db/base..rkt)._sql-null-~3efalse))",[0,[2,"sql-null->false"]],["db","db/base"]],
["sql-null?",">db/sql-types.html#(def._((lib._db/base..rkt)._sql-null~3f))",[0,[2,"sql-null?"]],["db","db/base"]],
["sql-time",">db/sql-types.html#(def._((lib._db/base..rkt)._sql-time))",[0,[2,"sql-time"]],["db","db/base"]],
["sql-time->sql-interval",">db/sql-types.html#(def._((lib._db/base..rkt)._sql-time-~3esql-interval))",[0,[2,"sql-time->sql-interval"]],["db","db/base"]],
["sql-time-hour",">db/sql-types.html#(def._((lib._db/base..rkt)._sql-time-hour))",[0,[2,"sql-time-hour"]],["db","db/base"]],
["sql-time-minute",">db/sql-types.html#(def._((lib._db/base..rkt)._sql-time-minute))",[0,[2,"sql-time-minute"]],["db","db/base"]],
["sql-time-nanosecond",">db/sql-types.html#(def._((lib._db/base..rkt)._sql-time-nanosecond))",[0,[2,"sql-time-nanosecond"]],["db","db/base"]],
["sql-time-second",">db/sql-types.html#(def._((lib._db/base..rkt)._sql-time-second))",[0,[2,"sql-time-second"]],["db","db/base"]],
["sql-time-tz",">db/sql-types.html#(def._((lib._db/base..rkt)._sql-time-tz))",[0,[2,"sql-time-tz"]],["db","db/base"]],
["sql-time?",">db/sql-types.html#(def._((lib._db/base..rkt)._sql-time~3f))",[0,[2,"sql-time?"]],["db","db/base"]],
["sql-timestamp",">db/sql-types.html#(def._((lib._db/base..rkt)._sql-timestamp))",[0,[2,"sql-timestamp"]],["db","db/base"]],
["sql-timestamp-day",">db/sql-types.html#(def._((lib._db/base..rkt)._sql-timestamp-day))",[0,[2,"sql-timestamp-day"]],["db","db/base"]],
["sql-timestamp-hour",">db/sql-types.html#(def._((lib._db/base..rkt)._sql-timestamp-hour))",[0,[2,"sql-timestamp-hour"]],["db","db/base"]],
["sql-timestamp-minute",">db/sql-types.html#(def._((lib._db/base..rkt)._sql-timestamp-minute))",[0,[2,"sql-timestamp-minute"]],["db","db/base"]],
["sql-timestamp-month",">db/sql-types.html#(def._((lib._db/base..rkt)._sql-timestamp-month))",[0,[2,"sql-timestamp-month"]],["db","db/base"]],
["sql-timestamp-nanosecond",">db/sql-types.html#(def._((lib._db/base..rkt)._sql-timestamp-nanosecond))",[0,[2,"sql-timestamp-nanosecond"]],["db","db/base"]],
["sql-timestamp-second",">db/sql-types.html#(def._((lib._db/base..rkt)._sql-timestamp-second))",[0,[2,"sql-timestamp-second"]],["db","db/base"]],
["sql-timestamp-tz",">db/sql-types.html#(def._((lib._db/base..rkt)._sql-timestamp-tz))",[0,[2,"sql-timestamp-tz"]],["db","db/base"]],
["sql-timestamp-year",">db/sql-types.html#(def._((lib._db/base..rkt)._sql-timestamp-year))",[0,[2,"sql-timestamp-year"]],["db","db/base"]],
["sql-timestamp?",">db/sql-types.html#(def._((lib._db/base..rkt)._sql-timestamp~3f))",[0,[2,"sql-timestamp?"]],["db","db/base"]],
["sql-year-month-interval?",">db/sql-types.html#(def._((lib._db/base..rkt)._sql-year-month-interval~3f))",[0,[2,"sql-year-month-interval?"]],["db","db/base"]],
["sqlite",">db/index.html#(idx._(gentag._3._(lib._db/scribblings/db..scrbl)))","SQLite",false],
["sqlite requirements",">db/notes.html#(part._sqlite3-requirements)","SQLite Requirements",false],
["sqlite types",">db/sql-types.html#(part._sqlite-types)","SQLite Types",false],
["sqlite3-connect",">db/connect.html#(def._((lib._db/main..rkt)._sqlite3-connect))",[0,[2,"sqlite3-connect"]],["db"]],
["sqlite3-data-source",">db/connect.html#(def._((lib._db/base..rkt)._sqlite3-data-source))",[0,[2,"sqlite3-data-source"]],["db","db/base"]],
["sqr",">reference/generic-numbers.html#(def._((lib._racket/math..rkt)._sqr))",[0,[2,"sqr"]],["racket/math","racket"]],
["sqr",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._sqr))",[0,[2,"sqr"]],["lang/htdp-advanced"]],
["sqr",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._sqr))",[0,[2,"sqr"]],["lang/htdp-beginner"]],
["sqr",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._sqr))",[0,[2,"sqr"]],["lang/htdp-beginner-abbr"]],
["sqr",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._sqr))",[0,[2,"sqr"]],["lang/htdp-intermediate"]],
["sqr",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._sqr))",[0,[2,"sqr"]],["lang/htdp-intermediate-lambda"]],
["sqrt",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._sqrt))",[0,[2,"sqrt"]],["racket/base","racket"]],
["sqrt",">r5rs-std/r5rs-Z-H-9.html#%_idx_344",[0,[2,"sqrt"]],["r5rs"]],
["sqrt",">r6rs-std/r6rs-Z-H-14.html#node_idx_560",[0,[2,"sqrt"]],["rnrs/base-6"]],
["sqrt",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._sqrt))",[0,[2,"sqrt"]],["lang/htdp-advanced"]],
["sqrt",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._sqrt))",[0,[2,"sqrt"]],["lang/htdp-beginner"]],
["sqrt",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._sqrt))",[0,[2,"sqrt"]],["lang/htdp-beginner-abbr"]],
["sqrt",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._sqrt))",[0,[2,"sqrt"]],["lang/htdp-intermediate"]],
["sqrt",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._sqrt))",[0,[2,"sqrt"]],["lang/htdp-intermediate-lambda"]],
["sqrt",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._sqrt))",[0,[2,"sqrt"]],["deinprogramm/DMdA-advanced"]],
["sqrt",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._sqrt))",[0,[2,"sqrt"]],["deinprogramm/DMdA-assignments"]],
["sqrt",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._sqrt))",[0,[2,"sqrt"]],["deinprogramm/DMdA-beginner"]],
["sqrt",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._sqrt))",[0,[2,"sqrt"]],["deinprogramm/DMdA-vanilla"]],
["square",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._square))",[0,[2,"square"]],["2htdp/image"]],
["square",">htdp-langs/beginner.html#(idx._htdp-beginner._(gentag._13._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-beginner))","square",false],
["square",">htdp-langs/beginner-abbr.html#(idx._htdp-beginner-abbr._(gentag._28._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-beginner-abbr))","square",false],
["square",">htdp-langs/intermediate.html#(idx._htdp-intermediate._(gentag._37._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-intermediate))","square",false],
["square",">htdp-langs/intermediate-lam.html#(idx._htdp-intermediate-lambda._(gentag._46._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-intermediate-lambda))","square",false],
["square",">htdp-langs/advanced.html#(idx._htdp-advanced._(gentag._55._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-advanced))","square",false],
["square root",">reference/generic-numbers.html#(idx._(gentag._102._(lib._scribblings/reference/reference..scrbl)))","square root",false],
["srcloc",">reference/exns.html#(def._((lib._racket/private/base..rkt)._srcloc))",[0,[2,"srcloc"]],["racket/base","racket"]],
["srcloc-column",">reference/exns.html#(def._((quote._~23~25kernel)._srcloc-column))",[0,[2,"srcloc-column"]],["racket/base","racket"]],
["srcloc-line",">reference/exns.html#(def._((quote._~23~25kernel)._srcloc-line))",[0,[2,"srcloc-line"]],["racket/base","racket"]],
["srcloc-position",">reference/exns.html#(def._((quote._~23~25kernel)._srcloc-position))",[0,[2,"srcloc-position"]],["racket/base","racket"]],
["srcloc-source",">reference/exns.html#(def._((quote._~23~25kernel)._srcloc-source))",[0,[2,"srcloc-source"]],["racket/base","racket"]],
["srcloc-span",">reference/exns.html#(def._((quote._~23~25kernel)._srcloc-span))",[0,[2,"srcloc-span"]],["racket/base","racket"]],
["srcloc?",">reference/exns.html#(def._((quote._~23~25kernel)._srcloc~3f))",[0,[2,"srcloc?"]],["racket/base","racket"]],
["srfi",">srfi/index.html#(tech._srfi)","<span style=\"font-style: italic\">SRFI</span>",false],
["srfi 11: syntax for receiving multiple values",">srfi/srfi-11.html","SRFI 11: Syntax for receiving multiple values",false],
["srfi 13: string libraries",">srfi/srfi-13.html","SRFI 13: String Libraries",false],
["srfi 14: character-set library",">srfi/srfi-14.html","SRFI 14: Character-set Library",false],
["srfi 16: syntax for procedures of variable arity",">srfi/srfi-16.html","SRFI 16: Syntax for procedures of variable arity",false],
["srfi 17: generalized set!",">srfi/srfi-17.html","SRFI 17: Generalized set!",false],
["srfi 19: time data types and procedures",">srfi/srfi-19.html","SRFI 19: Time Data Types and Procedures",false],
["srfi 1: list library",">srfi/srfi-1.html","SRFI 1: List Library",false],
["srfi 23: error reporting mechanism",">srfi/srfi-23.html","SRFI 23: Error reporting mechanism",false],
["srfi 25: multi-dimensional array primitives",">srfi/srfi-25.html","SRFI 25: Multi-dimensional Array Primitives",false],
["srfi 26: notation for specializing parameters without currying",">srfi/srfi-26.html","SRFI 26: Notation for Specializing Parameters without Currying",false],
["srfi 27: sources of random bits",">srfi/srfi-27.html","SRFI 27: Sources of Random Bits",false],
["srfi 28: basic format strings",">srfi/srfi-28.html","SRFI 28: Basic Format Strings",false],
["srfi 29: localization",">srfi/srfi-29.html","SRFI 29: Localization",false],
["srfi 2: and-let*: an and with local bindings...",">srfi/srfi-2.html","SRFI 2: AND-LET*: an AND with local bindings...",false],
["srfi 30: nested multi-line comments",">srfi/srfi-30.html","SRFI 30: Nested Multi-line Comments",false],
["srfi 31: a special form rec for recursive evaluation",">srfi/srfi-31.html","SRFI 31: A special form rec for recursive evaluation",false],
["srfi 34: exception handling for programs",">srfi/srfi-34.html","SRFI 34: Exception Handling for Programs",false],
["srfi 35: conditions",">srfi/srfi-35.html","SRFI 35: Conditions",false],
["srfi 38: external representation for data with shared structure",">srfi/srfi-38.html","SRFI 38: External Representation for Data With Shared Structure",false],
["srfi 39: parameter objects",">srfi/srfi-39.html","SRFI 39: Parameter objects",false],
["srfi 40: a library of streams",">srfi/srfi-40.html","SRFI 40: A Library of Streams",false],
["srfi 41: streams",">srfi/srfi-41.html","SRFI 41: Streams",false],
["srfi 42: eager comprehensions",">srfi/srfi-42.html","SRFI 42: Eager Comprehensions",false],
["srfi 43: vector library",">srfi/srfi-43.html","SRFI 43: Vector Library",false],
["srfi 45: primitives for expressing iterative lazy algorithms",">srfi/srfi-45.html","SRFI 45: Primitives for Expressing Iterative Lazy Algorithms",false],
["srfi 48: intermediate format strings",">srfi/srfi-48.html","SRFI 48: Intermediate Format Strings",false],
["srfi 4: homogeneous numeric vector datatypes",">srfi/srfi-4.html","SRFI 4: Homogeneous numeric vector datatypes",false],
["srfi 54: formatting",">srfi/srfi-54.html","SRFI 54: Formatting",false],
["srfi 57: records",">srfi/srfi-57.html","SRFI 57: Records",false],
["srfi 59: vicinity",">srfi/srfi-59.html","SRFI 59: Vicinity",false],
["srfi 5: a compatible let form with signatures and rest arguments",">srfi/srfi-5.html","SRFI 5: A compatible let form with signatures and rest arguments",false],
["srfi 60: integers as bits",">srfi/srfi-60.html","SRFI 60: Integers as Bits",false],
["srfi 61: a more general cond clause",">srfi/srfi-61.html","SRFI 61: A more general cond clause",false],
["srfi 62: s-expression comments",">srfi/srfi-62.html","SRFI 62: S-expression comments",false],
["srfi 63: homogeneous and heterogeneous arrays",">srfi/srfi-63.html","SRFI 63: Homogeneous and Heterogeneous Arrays",false],
["srfi 64: a scheme api for test suites",">srfi/srfi-64.html","SRFI 64: A Scheme API for test suites",false],
["srfi 66: octet vectors",">srfi/srfi-66.html","SRFI 66: Octet Vectors",false],
["srfi 67: compare procedures",">srfi/srfi-67.html","SRFI 67: Compare Procedures",false],
["srfi 69: basic hash tables",">srfi/srfi-69.html","SRFI 69: Basic hash tables",false],
["srfi 6: basic string ports",">srfi/srfi-6.html","SRFI 6: Basic String Ports",false],
["srfi 71: extended let-syntax for multiple values",">srfi/srfi-71.html","SRFI 71: Extended LET-syntax for multiple values",false],
["srfi 74: octet-addressed binary blocks",">srfi/srfi-74.html","SRFI 74: Octet-Addressed Binary Blocks",false],
["srfi 78: lightweight testing",">srfi/srfi-78.html","SRFI 78: Lightweight testing",false],
["srfi 7: feature-based program configuration language",">srfi/srfi-7.html","SRFI 7: Feature-based program configuration language",false],
["srfi 86: mu & nu simulating values & call-with-values...",">srfi/srfi-86.html","SRFI 86: MU & NU simulating VALUES & CALL-WITH-VALUES...",false],
["srfi 87: => in case clauses",">srfi/srfi-87.html","SRFI 87: => in case clauses",false],
["srfi 8: receive: binding to multiple values",">srfi/srfi-8.html","SRFI 8: RECEIVE: Binding to multiple values",false],
["srfi 98: an interface to access environment variables",">srfi/srfi-98.html","SRFI 98: An interface to access environment variables",false],
["srfi 9: defining record types",">srfi/srfi-9.html","SRFI 9: Defining Record Types",false],
["srfi-date->sql-date",">db/util.html#(def._((lib._db/util/datetime..rkt)._srfi-date-~3esql-date))",[0,[2,"srfi-date->sql-date"]],["db/util/datetime"]],
["srfi-date->sql-time",">db/util.html#(def._((lib._db/util/datetime..rkt)._srfi-date-~3esql-time))",[0,[2,"srfi-date->sql-time"]],["db/util/datetime"]],
["srfi-date->sql-time-tz",">db/util.html#(def._((lib._db/util/datetime..rkt)._srfi-date-~3esql-time-tz))",[0,[2,"srfi-date->sql-time-tz"]],["db/util/datetime"]],
["srfi-date->sql-timestamp",">db/util.html#(def._((lib._db/util/datetime..rkt)._srfi-date-~3esql-timestamp))",[0,[2,"srfi-date->sql-timestamp"]],["db/util/datetime"]],
["srfi-date->sql-timestamp-tz",">db/util.html#(def._((lib._db/util/datetime..rkt)._srfi-date-~3esql-timestamp-tz))",[0,[2,"srfi-date->sql-timestamp-tz"]],["db/util/datetime"]],
["srfi/1",">srfi/srfi-1.html",[9,[0,"srfi/1"]],"module"],
["srfi/11",">srfi/srfi-11.html",[9,[0,"srfi/11"]],"module"],
["srfi/13",">srfi/srfi-13.html",[9,[0,"srfi/13"]],"module"],
["srfi/14",">srfi/srfi-14.html",[9,[0,"srfi/14"]],"module"],
["srfi/16",">srfi/srfi-16.html",[9,[0,"srfi/16"]],"module"],
["srfi/17",">srfi/srfi-17.html",[9,[0,"srfi/17"]],"module"],
["srfi/19",">srfi/srfi-19.html",[9,[0,"srfi/19"]],"module"],
["srfi/2",">srfi/srfi-2.html",[9,[0,"srfi/2"]],"module"],
["srfi/23",">srfi/srfi-23.html",[9,[0,"srfi/23"]],"module"],
["srfi/25",">srfi/srfi-25.html",[9,[0,"srfi/25"]],"module"],
["srfi/26",">srfi/srfi-26.html",[9,[0,"srfi/26"]],"module"],
["srfi/27",">srfi/srfi-27.html",[9,[0,"srfi/27"]],"module"],
["srfi/28",">srfi/srfi-28.html",[9,[0,"srfi/28"]],"module"],
["srfi/29",">srfi/srfi-29.html",[9,[0,"srfi/29"]],"module"],
["srfi/30",">srfi/srfi-30.html",[9,[0,"srfi/30"]],"module"],
["srfi/31",">srfi/srfi-31.html",[9,[0,"srfi/31"]],"module"],
["srfi/34",">srfi/srfi-34.html",[9,[0,"srfi/34"]],"module"],
["srfi/35",">srfi/srfi-35.html",[9,[0,"srfi/35"]],"module"],
["srfi/38",">srfi/srfi-38.html",[9,[0,"srfi/38"]],"module"],
["srfi/39",">srfi/srfi-39.html",[9,[0,"srfi/39"]],"module"],
["srfi/4",">srfi/srfi-4.html",[9,[0,"srfi/4"]],"module"],
["srfi/40",">srfi/srfi-40.html",[9,[0,"srfi/40"]],"module"],
["srfi/41",">srfi/srfi-41.html",[9,[0,"srfi/41"]],"module"],
["srfi/42",">srfi/srfi-42.html",[9,[0,"srfi/42"]],"module"],
["srfi/43",">srfi/srfi-43.html",[9,[0,"srfi/43"]],"module"],
["srfi/45",">srfi/srfi-45.html",[9,[0,"srfi/45"]],"module"],
["srfi/48",">srfi/srfi-48.html",[9,[0,"srfi/48"]],"module"],
["srfi/5",">srfi/srfi-5.html",[9,[0,"srfi/5"]],"module"],
["srfi/54",">srfi/srfi-54.html",[9,[0,"srfi/54"]],"module"],
["srfi/57",">srfi/srfi-57.html",[9,[0,"srfi/57"]],"module"],
["srfi/59",">srfi/srfi-59.html",[9,[0,"srfi/59"]],"module"],
["srfi/6",">srfi/srfi-6.html",[9,[0,"srfi/6"]],"module"],
["srfi/60",">srfi/srfi-60.html",[9,[0,"srfi/60"]],"module"],
["srfi/61",">srfi/srfi-61.html",[9,[0,"srfi/61"]],"module"],
["srfi/63",">srfi/srfi-63.html",[9,[0,"srfi/63"]],"module"],
["srfi/64",">srfi/srfi-64.html",[9,[0,"srfi/64"]],"module"],
["srfi/66",">srfi/srfi-66.html",[9,[0,"srfi/66"]],"module"],
["srfi/67",">srfi/srfi-67.html",[9,[0,"srfi/67"]],"module"],
["srfi/69",">srfi/srfi-69.html",[9,[0,"srfi/69"]],"module"],
["srfi/7",">srfi/srfi-7.html",[9,[0,"srfi/7"]],"module"],
["srfi/71",">srfi/srfi-71.html",[9,[0,"srfi/71"]],"module"],
["srfi/74",">srfi/srfi-74.html",[9,[0,"srfi/74"]],"module"],
["srfi/78",">srfi/srfi-78.html",[9,[0,"srfi/78"]],"module"],
["srfi/8",">srfi/srfi-8.html",[9,[0,"srfi/8"]],"module"],
["srfi/86",">srfi/srfi-86.html",[9,[0,"srfi/86"]],"module"],
["srfi/87",">srfi/srfi-87.html",[9,[0,"srfi/87"]],"module"],
["srfi/9",">srfi/srfi-9.html",[9,[0,"srfi/9"]],"module"],
["srfi/98",">srfi/srfi-98.html",[9,[0,"srfi/98"]],"module"],
["srfis: libraries",">srfi/index.html","SRFIs: Libraries",false],
["ssh-bin-path",">reference/distributed-places.html#(def._((lib._racket/place/distributed..rkt)._ssh-bin-path))",[0,[2,"ssh-bin-path"]],["racket/place/distributed"]],
["ssl unit: tcp^ via ssl",">net/ssl-tcp-unit.html",["SSL Unit: ",[0,[1,"tcp^"]]," via SSL"],false],
["ssl-abandon-port",">openssl/index.html#(def._((lib._openssl/main..rkt)._ssl-abandon-port))",[0,[2,"ssl-abandon-port"]],["openssl"]],
["ssl-accept",">openssl/index.html#(def._((lib._openssl/main..rkt)._ssl-accept))",[0,[2,"ssl-accept"]],["openssl"]],
["ssl-accept/enable-break",">openssl/index.html#(def._((lib._openssl/main..rkt)._ssl-accept/enable-break))",[0,[2,"ssl-accept/enable-break"]],["openssl"]],
["ssl-addresses",">openssl/index.html#(def._((lib._openssl/main..rkt)._ssl-addresses))",[0,[2,"ssl-addresses"]],["openssl"]],
["ssl-available?",">openssl/index.html#(def._((lib._openssl/main..rkt)._ssl-available~3f))",[0,[2,"ssl-available?"]],["openssl"]],
["ssl-client-context?",">openssl/index.html#(def._((lib._openssl/main..rkt)._ssl-client-context~3f))",[0,[2,"ssl-client-context?"]],["openssl"]],
["ssl-close",">openssl/index.html#(def._((lib._openssl/main..rkt)._ssl-close))",[0,[2,"ssl-close"]],["openssl"]],
["ssl-connect",">openssl/index.html#(def._((lib._openssl/main..rkt)._ssl-connect))",[0,[2,"ssl-connect"]],["openssl"]],
["ssl-connect/enable-break",">openssl/index.html#(def._((lib._openssl/main..rkt)._ssl-connect/enable-break))",[0,[2,"ssl-connect/enable-break"]],["openssl"]],
["ssl-listen",">openssl/index.html#(def._((lib._openssl/main..rkt)._ssl-listen))",[0,[2,"ssl-listen"]],["openssl"]],
["ssl-listener?",">openssl/index.html#(def._((lib._openssl/main..rkt)._ssl-listener~3f))",[0,[2,"ssl-listener?"]],["openssl"]],
["ssl-load-certificate-chain!",">openssl/index.html#(def._((lib._openssl/main..rkt)._ssl-load-certificate-chain!))",[0,[2,"ssl-load-certificate-chain!"]],["openssl"]],
["ssl-load-fail-reason",">openssl/index.html#(def._((lib._openssl/main..rkt)._ssl-load-fail-reason))",[0,[2,"ssl-load-fail-reason"]],["openssl"]],
["ssl-load-private-key!",">openssl/index.html#(def._((lib._openssl/main..rkt)._ssl-load-private-key!))",[0,[2,"ssl-load-private-key!"]],["openssl"]],
["ssl-load-suggested-certificate-authorities!",">openssl/index.html#(def._((lib._openssl/main..rkt)._ssl-load-suggested-certificate-authorities!))",[0,[2,"ssl-load-suggested-certificate-authorities!"]],["openssl"]],
["ssl-load-verify-root-certificates!",">openssl/index.html#(def._((lib._openssl/main..rkt)._ssl-load-verify-root-certificates!))",[0,[2,"ssl-load-verify-root-certificates!"]],["openssl"]],
["ssl-make-client-context",">openssl/index.html#(def._((lib._openssl/main..rkt)._ssl-make-client-context))",[0,[2,"ssl-make-client-context"]],["openssl"]],
["ssl-make-server-context",">openssl/index.html#(def._((lib._openssl/main..rkt)._ssl-make-server-context))",[0,[2,"ssl-make-server-context"]],["openssl"]],
["ssl-peer-issuer-name",">openssl/index.html#(def._((lib._openssl/main..rkt)._ssl-peer-issuer-name))",[0,[2,"ssl-peer-issuer-name"]],["openssl"]],
["ssl-peer-subject-name",">openssl/index.html#(def._((lib._openssl/main..rkt)._ssl-peer-subject-name))",[0,[2,"ssl-peer-subject-name"]],["openssl"]],
["ssl-peer-verified?",">openssl/index.html#(def._((lib._openssl/main..rkt)._ssl-peer-verified~3f))",[0,[2,"ssl-peer-verified?"]],["openssl"]],
["ssl-port?",">openssl/index.html#(def._((lib._openssl/main..rkt)._ssl-port~3f))",[0,[2,"ssl-port?"]],["openssl"]],
["ssl-server-context?",">openssl/index.html#(def._((lib._openssl/main..rkt)._ssl-server-context~3f))",[0,[2,"ssl-server-context?"]],["openssl"]],
["ssl-set-verify!",">openssl/index.html#(def._((lib._openssl/main..rkt)._ssl-set-verify!))",[0,[2,"ssl-set-verify!"]],["openssl"]],
["ssl-try-verify!",">openssl/index.html#(def._((lib._openssl/main..rkt)._ssl-try-verify!))",[0,[2,"ssl-try-verify!"]],["openssl"]],
["ssl-wrapper interface",">openssl/index.html#(part._.S.S.L-wrapper_.Interface)","SSL-wrapper Interface",false],
["st-mark-bindings",">errortrace/stacktrace.html#(sig-val._((lib._errortrace/stacktrace..rkt)._stacktrace~5e._st-mark-bindings))",[0,[2,"st-mark-bindings"]],["errortrace/stacktrace"]],
["st-mark-source",">errortrace/stacktrace.html#(sig-val._((lib._errortrace/stacktrace..rkt)._stacktrace~5e._st-mark-source))",[0,[2,"st-mark-source"]],["errortrace/stacktrace"]],
["stack dump",">reference/contmarks.html#(idx._(gentag._164._(lib._scribblings/reference/reference..scrbl)))","stack\ndump",false],
["stack trace",">reference/contmarks.html#(idx._(gentag._165._(lib._scribblings/reference/reference..scrbl)))","stack trace",false],
["stack view pane",">drracket/debugger.html#(part._.Stack_.View_.Pane)","Stack View Pane",false],
["stack-cards",">cards/index.html#(meth._(((lib._games/cards..rkt)._table~3c~25~3e)._stack-cards))",[[0,[2,"stack-cards"]],[14,[" (method of ",[0,[2,"table<%>"]],")"]]],["games/cards"]],
["stacked-histogram",">plot/renderer2d.html#(def._((lib._plot/main..rkt)._stacked-histogram))",[0,[2,"stacked-histogram"]],["plot"]],
["stacked-histogram-alphas",">plot/params.html#(def._((lib._plot/main..rkt)._stacked-histogram-alphas))",[0,[2,"stacked-histogram-alphas"]],["plot"]],
["stacked-histogram-colors",">plot/params.html#(def._((lib._plot/main..rkt)._stacked-histogram-colors))",[0,[2,"stacked-histogram-colors"]],["plot"]],
["stacked-histogram-line-colors",">plot/params.html#(def._((lib._plot/main..rkt)._stacked-histogram-line-colors))",[0,[2,"stacked-histogram-line-colors"]],["plot"]],
["stacked-histogram-line-styles",">plot/params.html#(def._((lib._plot/main..rkt)._stacked-histogram-line-styles))",[0,[2,"stacked-histogram-line-styles"]],["plot"]],
["stacked-histogram-line-widths",">plot/params.html#(def._((lib._plot/main..rkt)._stacked-histogram-line-widths))",[0,[2,"stacked-histogram-line-widths"]],["plot"]],
["stacked-histogram-styles",">plot/params.html#(def._((lib._plot/main..rkt)._stacked-histogram-styles))",[0,[2,"stacked-histogram-styles"]],["plot"]],
["stacked-histogram3d",">plot/renderer3d.html#(def._((lib._plot/main..rkt)._stacked-histogram3d))",[0,[2,"stacked-histogram3d"]],["plot"]],
["stacktrace-imports^",">errortrace/stacktrace.html#(form._((lib._errortrace/stacktrace..rkt)._stacktrace-imports~5e))",[0,[1,"stacktrace-imports^"]],["errortrace/stacktrace"]],
["stacktrace@",">errortrace/stacktrace.html#(def._((lib._errortrace/stacktrace..rkt)._stacktrace~40))",[0,[2,"stacktrace@"]],["errortrace/stacktrace"]],
["stacktrace^",">errortrace/stacktrace.html#(form._((lib._errortrace/stacktrace..rkt)._stacktrace~5e))",[0,[1,"stacktrace^"]],["errortrace/stacktrace"]],
["stage",">unstable/Slideshow_Presentations.html#(form._((lib._unstable/gui/slideshow..rkt)._stage))",[0,[1,"stage"]],["unstable/gui/slideshow"]],
["stage-name",">unstable/Slideshow_Presentations.html#(form._((lib._unstable/gui/slideshow..rkt)._stage-name))",[0,[1,"stage-name"]],["unstable/gui/slideshow"]],
["staged",">unstable/Slideshow_Presentations.html#(form._((lib._unstable/gui/slideshow..rkt)._staged))",[0,[1,"staged"]],["unstable/gui/slideshow"]],
["staged slides",">unstable/Slideshow_Presentations.html#(part._.Staged_.Slides)","Staged Slides",false],
["staging slides",">slideshow/Creating_Slide_Presentations.html#(part._staging)","Staging Slides",false],
["stand-alone executable",">drracket/create-exe.html#(tech._stand._alone._executable)","<span style=\"font-style: italic\">stand-alone executable</span>",false],
["standard responders",">web-server-internal/Web_Servers.html#(part._responders)","Standard Responders",false],
["standard style",">gui/editor-overview.html#(idx._(gentag._154._(lib._scribblings/gui/gui..scrbl)))",[[7,"\"Standard\""],"\nstyle"],false],
["standard types",">inside/im_values_types.html#(part._im~3astdtypes)","Standard Types",false],
["standard-error-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_732",[0,[2,"standard-error-port"]],["rnrs/io/ports-6"]],
["standard-fish",">slideshow/More_Pict_Constructors.html#(def._((lib._slideshow/pict..rkt)._standard-fish))",[0,[2,"standard-fish"]],["slideshow/pict","slideshow"]],
["standard-input-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_676",[0,[2,"standard-input-port"]],["rnrs/io/ports-6"]],
["standard-message-header",">net/head.html#(def._((lib._net/head..rkt)._standard-message-header))",[0,[2,"standard-message-header"]],["net/head"]],
["standard-output-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_730",[0,[2,"standard-output-port"]],["rnrs/io/ports-6"]],
["standards",">guide/standards.html","Standards",false],
["standing-stickman-icon",">images/Icons.html#(def._((lib._images/icons/stickman..rkt)._standing-stickman-icon))",[0,[2,"standing-stickman-icon"]],["images/icons/stickman"]],
["star",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._star))",[0,[2,"star"]],["2htdp/image"]],
["star",">teachpack/image.html#(def._((lib._htdp/image..rkt)._star))",[0,[2,"star"]],["htdp/image"]],
["star",">unstable/Automata__Compiling_State_Machines.html#(form._((lib._unstable/automata/re..rkt)._star))",[0,[1,"star"]],["unstable/automata/re"]],
["star-polygon",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._star-polygon))",[0,[2,"star-polygon"]],["2htdp/image"]],
["start",">plai/web.html#(def._((lib._plai/scribblings/fake-web..rkt)._start))",[0,[2,"start"]],[]],
["start",">web-server/stateless.html#(def._((lib._web-server/scribblings/dummy-stateless-servlet..rkt)._start))",[0,[2,"start"]],[]],
["start",">web-server/servlet.html#(def._((lib._web-server/scribblings/dummy-v2-servlet..rkt)._start))",[0,[2,"start"]],[]],
["start",">gui/timer_.html#(meth._(((lib._mred/main..rkt)._timer~25)._start))",[[0,[2,"start"]],[14,[" (method of ",[0,[2,"timer%"]],")"]]],["racket/gui/base","racket/gui"]],
["start",">teachpack/draw.html#(def._((lib._htdp/big-draw..rkt)._start))",[0,[2,"start"]],["htdp/draw"]],
["start",">gui/key-event_.html#(idx._(gentag._38._(lib._scribblings/gui/gui..scrbl)))",[7,"'start"],false],
["start-at-recent-slide",">slideshow/Viewer_Control.html#(def._((lib._slideshow/base..rkt)._start-at-recent-slide))",[0,[2,"start-at-recent-slide"]],["slideshow/base","slideshow"]],
["start-atomic",">foreign/Atomic_Execution.html#(def._((lib._ffi/unsafe/atomic..rkt)._start-atomic))",[0,[2,"start-atomic"]],["ffi/unsafe/atomic"]],
["start-breakable-atomic",">foreign/Atomic_Execution.html#(def._((lib._ffi/unsafe/atomic..rkt)._start-breakable-atomic))",[0,[2,"start-breakable-atomic"]],["ffi/unsafe/atomic"]],
["start-colorer",">framework/Color.html#(meth._(((lib._framework/main..rkt)._color~3atext~3c~25~3e)._start-colorer))",[[0,[2,"start-colorer"]],[14,[" (method of ",[0,[2,"color:text<%>"]],")"]]],["framework"]],
["start-connection-manager",">web-server-internal/connection-manager.html#(def._((lib._web-server/private/connection-manager..rkt)._start-connection-manager))",[0,[2,"start-connection-manager"]],["web-server/private/connection-manager"]],
["start-doc",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._start-doc))",[[0,[2,"start-doc"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["start-future-tracing!",">reference/futures-trace.html#(def._((lib._future-visualizer/trace..rkt)._start-future-tracing!))",[0,[2,"start-future-tracing!"]],["future-visualizer/trace"]],
["start-macro",">framework/Keymap.html#(idx._(gentag._38._(lib._scribblings/framework/framework..scrbl)))","start-macro",false],
["start-message-router/thread",">reference/distributed-places.html#(def._((lib._racket/place/distributed..rkt)._start-message-router/thread))",[0,[2,"start-message-router/thread"]],["racket/place/distributed"]],
["start-page",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._start-page))",[[0,[2,"start-page"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["start-pos",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex..rkt)._start-pos))",[0,[1,"start-pos"]],["parser-tools/lex"]],
["start-recording",">unstable/Logging.html#(def._((lib._unstable/logging..rkt)._start-recording))",[0,[2,"start-recording"]],["unstable/logging"]],
["start-splash",">framework/Splash.html#(def._((lib._framework/splash..rkt)._start-splash))",[0,[2,"start-splash"]],["framework/splash"]],
["start-timer",">web-server-internal/timer.html#(def._((lib._web-server/private/timer..rkt)._start-timer))",[0,[2,"start-timer"]],["web-server/private/timer"]],
["start-timer-manager",">web-server-internal/timer.html#(def._((lib._web-server/private/timer..rkt)._start-timer-manager))",[0,[2,"start-timer-manager"]],["web-server/private/timer"]],
["start-transaction",">db/query-api.html#(def._((lib._db/base..rkt)._start-transaction))",[0,[2,"start-transaction"]],["db","db/base"]],
["start/cartesian-plane",">teachpack/draw.html#(def._((lib._htdp/big-draw..rkt)._start/cartesian-plane))",[0,[2,"start/cartesian-plane"]],["htdp/draw"]],
["startup actions",">gui/Startup_Actions.html","Startup Actions",false],
["state",">teachpack/2htdpuniverse.html#(form._((lib._2htdp/universe..rkt)._state))",[0,[1,"state"]],["2htdp/universe"]],
["stateful servlets",">web-server/servlet.html","Stateful Servlets",false],
["stateless servlets",">web-server/run.html#(part._.Stateless_.Servlets)","Stateless Servlets",false],
["stateless servlets",">web-server/stateless.html","Stateless Servlets",false],
["stateless web cells",">web-server/stateless.html#(part._lang/web-cells)","Stateless Web Cells",false],
["stateless web interaction",">web-server/stateless.html#(part._lang/web)","Stateless Web Interaction",false],
["stateless web parameters",">web-server/stateless.html#(part._lang/web-param)","Stateless Web Parameters",false],
["statement",">db/query-api.html#(tech._statement)","<span style=\"font-style: italic\">statement</span>",false],
["statement caching",">db/using-db.html#(part._dbperf-pstcache)","Statement Caching",false],
["statement-binding?",">db/query-api.html#(def._((lib._db/base..rkt)._statement-binding~3f))",[0,[2,"statement-binding?"]],["db","db/base"]],
["statement?",">db/query-api.html#(def._((lib._db/base..rkt)._statement~3f))",[0,[2,"statement?"]],["db","db/base"]],
["statements",">db/query-api.html#(part._.Statements)","Statements",false],
["static",">web-server/templates.html#(part._.Static)","Static",false],
["static",">syntax/Library_Syntax_Classes_and_Literal_Sets.html#(def._((lib._syntax/parse..rkt)._static))",[0,[2,"static"]],["syntax/parse"]],
["static",">reference/runtime.html#(idx._(gentag._331._(lib._scribblings/reference/reference..scrbl)))",[7,"'static"],false],
["static syntactic shorthand",">web-server/formlets.html#(part._.Static_.Syntactic_.Shorthand)","Static Syntactic Shorthand",false],
["static-files-path",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-7..rkt)._static-files-path))",[0,"static-files-path"],[]],
["static-files-path",">web-server/run.html#(def._((lib._web-server/insta/insta..rkt)._static-files-path))",[0,[2,"static-files-path"]],["web-server/insta"]],
["statistics",">web-server-internal/dispatch-stat.html","Statistics",false],
["status line",">drracket/interface-essentials.html#(tech._status._line)","<span style=\"font-style: italic\">status line</span>",false],
["stay-in-region",">cards/index.html#(meth._(((lib._games/cards..rkt)._card~3c~25~3e)._stay-in-region))",[[0,[2,"stay-in-region"]],[14,[" (method of ",[0,[2,"card<%>"]],")"]]],["games/cards"]],
["std-filter",">raco/plt.html#(def._((lib._setup/pack..rkt)._std-filter))",[0,[2,"std-filter"]],["setup/pack"]],
["stderr",">preprocessor/mzpp.html#(def._((lib._preprocessor/mzpp..rkt)._stderr))",[0,[2,"stderr"]],["preprocessor/mzpp"]],
["stderr",">preprocessor/mztext.html#(def._((lib._preprocessor/mztext..rkt)._stderr))",[0,[2,"stderr"]],["preprocessor/mztext"]],
["stdin",">preprocessor/mzpp.html#(def._((lib._preprocessor/mzpp..rkt)._stdin))",[0,[2,"stdin"]],["preprocessor/mzpp"]],
["stdin",">preprocessor/mztext.html#(def._((lib._preprocessor/mztext..rkt)._stdin))",[0,[2,"stdin"]],["preprocessor/mztext"]],
["stdout",">preprocessor/mzpp.html#(def._((lib._preprocessor/mzpp..rkt)._stdout))",[0,[2,"stdout"]],["preprocessor/mzpp"]],
["stdout",">preprocessor/mztext.html#(def._((lib._preprocessor/mztext..rkt)._stdout))",[0,[2,"stdout"]],["preprocessor/mztext"]],
["step button",">drracket/debugger.html#(idx._(gentag._35._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Step</span> button",false],
["step button",">drracket/buttons.html#(idx._(gentag._4._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Step</span> button",false],
["step-back-icon",">images/Icons.html#(def._((lib._images/icons/control..rkt)._step-back-icon))",[0,[2,"step-back-icon"]],["images/icons/control"]],
["step-count?",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._step-count~3f))",[0,[2,"step-count?"]],["2htdp/image"]],
["step-icon",">images/Icons.html#(def._((lib._images/icons/control..rkt)._step-icon))",[0,[2,"step-icon"]],["images/icons/control"]],
["stepper",">redex/The_Redex_Reference.html#(def._((lib._redex/gui..rkt)._stepper))",[0,[2,"stepper"]],["redex/gui","redex"]],
["stepper",">drracket/buttons.html#(idx._(gentag._5._(lib._scribblings/drracket/drracket..scrbl)))","Stepper",false],
["stepper-logo",">images/Logos.html#(def._((lib._images/logos..rkt)._stepper-logo))",[0,[2,"stepper-logo"]],["images/logos"]],
["stepper-text",">macro-debugger/index.html#(def._((lib._macro-debugger/stepper-text..rkt)._stepper-text))",[0,[2,"stepper-text"]],["macro-debugger/stepper-text"]],
["stepper/seed",">redex/The_Redex_Reference.html#(def._((lib._redex/gui..rkt)._stepper/seed))",[0,[2,"stepper/seed"]],["redex/gui","redex"]],
["stereographic-projection",">images/Spatial_Transformations.html#(def._((lib._images/flomap..rkt)._stereographic-projection))",[0,[2,"stereographic-projection"]],["images/flomap"]],
["stethoscope-icon",">images/Icons.html#(def._((lib._images/icons/misc..rkt)._stethoscope-icon))",[0,[2,"stethoscope-icon"]],["images/icons/misc"]],
["stickman icons",">images/Icons.html#(part._stickman)","Stickman Icons",false],
["still-untouched?",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aframe~25)._still-untouched~3f))",[[0,[2,"still-untouched?"]],[14,[" (method of ",[0,[2,"drracket:unit:frame%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["stipple",">draw/overview.html#(tech._stipple)","<span style=\"font-style: italic\">stipple</span>",false],
["stone-block",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._stone-block))",[0,[2,"stone-block"]],["2htdp/planetcute"]],
["stone-block-tall",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._stone-block-tall))",[0,[2,"stone-block-tall"]],["2htdp/planetcute"]],
["stop",">gui/timer_.html#(meth._(((lib._mred/main..rkt)._timer~25)._stop))",[[0,[2,"stop"]],[14,[" (method of ",[0,[2,"timer%"]],")"]]],["racket/gui/base","racket/gui"]],
["stop",">teachpack/draw.html#(def._((lib._htdp/big-draw..rkt)._stop))",[0,[2,"stop"]],["htdp/draw"]],
["stop",">gui/message_.html#(idx._(gentag._120._(lib._scribblings/gui/gui..scrbl)))",[7,"'stop"],false],
["stop-after",">reference/sequences.html#(def._((lib._racket/private/base..rkt)._stop-after))",[0,[2,"stop-after"]],["racket/base","racket"]],
["stop-before",">reference/sequences.html#(def._((lib._racket/private/base..rkt)._stop-before))",[0,[2,"stop-before"]],["racket/base","racket"]],
["stop-colorer",">framework/Color.html#(meth._(((lib._framework/main..rkt)._color~3atext~3c~25~3e)._stop-colorer))",[[0,[2,"stop-colorer"]],[14,[" (method of ",[0,[2,"color:text<%>"]],")"]]],["framework"]],
["stop-future-tracing!",">reference/futures-trace.html#(def._((lib._future-visualizer/trace..rkt)._stop-future-tracing!))",[0,[2,"stop-future-tracing!"]],["future-visualizer/trace"]],
["stop-icon",">images/Icons.html#(def._((lib._images/icons/control..rkt)._stop-icon))",[0,[2,"stop-icon"]],["images/icons/control"]],
["stop-recording",">unstable/Logging.html#(def._((lib._unstable/logging..rkt)._stop-recording))",[0,[2,"stop-recording"]],["unstable/logging"]],
["stop-sign-icon",">images/Icons.html#(def._((lib._images/icons/misc..rkt)._stop-sign-icon))",[0,[2,"stop-sign-icon"]],["images/icons/misc"]],
["stop-signs-icon",">images/Icons.html#(def._((lib._images/icons/misc..rkt)._stop-signs-icon))",[0,[2,"stop-signs-icon"]],["images/icons/misc"]],
["stop-tick",">graphics/World_Operations.html#(def._((lib._graphics/graphics..rkt)._stop-tick))",[0,[2,"stop-tick"]],["graphics/graphics"]],
["stop-when",">teachpack/2htdpuniverse.html#(form._((lib._2htdp/universe..rkt)._stop-when))",[0,[1,"stop-when"]],["2htdp/universe"]],
["stop-when",">teachpack/world.html#(def._((lib._htdp/world..rkt)._stop-when))",[0,[2,"stop-when"]],["htdp/world"]],
["stop-with",">teachpack/2htdpuniverse.html#(def._((lib._2htdp/universe..rkt)._stop-with))",[0,[2,"stop-with"]],["2htdp/universe"]],
["stop-with-w",">teachpack/2htdpuniverse.html#(def._((lib._teachpack/2htdp/image..rkt)._stop-with-w))",[0,[2,"stop-with-w"]],["2htdp/universe"]],
["stop-with?",">teachpack/2htdpuniverse.html#(def._((lib._teachpack/2htdp/image..rkt)._stop-with~3f))",[0,[2,"stop-with?"]],["2htdp/universe"]],
["stopwatch-icon",">images/Icons.html#(def._((lib._images/icons/misc..rkt)._stopwatch-icon))",[0,[2,"stopwatch-icon"]],["images/icons/misc"]],
["store",">web-server/stateless.html#(def._((lib._web-server/stuffers/store..rkt)._store))",[0,[2,"store"]],["web-server/stuffers/store"]],
["store-bundle",">srfi-std/srfi-29.html#store-bundle",[0,[2,"store-bundle"]],["srfi/29"]],
["store-read",">web-server/stateless.html#(def._((lib._web-server/stuffers/store..rkt)._store-read))",[0,[2,"store-read"]],["web-server/stuffers/store"]],
["store-write",">web-server/stateless.html#(def._((lib._web-server/stuffers/store..rkt)._store-write))",[0,[2,"store-write"]],["web-server/stuffers/store"]],
["store?",">web-server/stateless.html#(def._((lib._web-server/stuffers/store..rkt)._store~3f))",[0,[2,"store?"]],["web-server/stuffers/store"]],
["str",">syntax/Library_Syntax_Classes_and_Literal_Sets.html#(form._((lib._syntax/parse..rkt)._str))",[0,[1,"str"]],["syntax/parse"]],
["stream",">reference/streams.html#(form._((lib._racket/stream..rkt)._stream))",[0,[1,"stream"]],["racket/stream","racket"]],
["stream",">srfi-std/srfi-40.html#stream",[0,[2,"stream"]],["srfi/40"]],
["stream",">srfi-std/srfi-41/srfi-41.html#stream",[0,[1,"stream"]],["srfi/41"]],
["stream",">reference/streams.html#(tech._stream)","<span style=\"font-style: italic\">stream</span>",false],
["stream->list",">reference/streams.html#(def._((lib._racket/stream..rkt)._stream-~3elist))",[0,[2,"stream->list"]],["racket/stream","racket"]],
["stream->list",">srfi-std/srfi-41/srfi-41.html#stream-to-list",[0,[2,"stream->list"]],["srfi/41"]],
["stream-add-between",">reference/streams.html#(def._((lib._racket/stream..rkt)._stream-add-between))",[0,[2,"stream-add-between"]],["racket/stream","racket"]],
["stream-andmap",">reference/streams.html#(def._((lib._racket/stream..rkt)._stream-andmap))",[0,[2,"stream-andmap"]],["racket/stream","racket"]],
["stream-append",">reference/streams.html#(def._((lib._racket/stream..rkt)._stream-append))",[0,[2,"stream-append"]],["racket/stream","racket"]],
["stream-append",">srfi-std/srfi-41/srfi-41.html#stream-append",[0,[2,"stream-append"]],["srfi/41"]],
["stream-car",">srfi-std/srfi-40.html#stream-car",[0,[2,"stream-car"]],["srfi/40"]],
["stream-car",">srfi-std/srfi-41/srfi-41.html#stream-car",[0,[2,"stream-car"]],["srfi/41"]],
["stream-cdr",">srfi-std/srfi-40.html#stream-cdr",[0,[2,"stream-cdr"]],["srfi/40"]],
["stream-cdr",">srfi-std/srfi-41/srfi-41.html#stream-cdr",[0,[2,"stream-cdr"]],["srfi/41"]],
["stream-concat",">srfi-std/srfi-41/srfi-41.html#stream-concat",[0,[2,"stream-concat"]],["srfi/41"]],
["stream-cons",">reference/streams.html#(form._((lib._racket/stream..rkt)._stream-cons))",[0,[1,"stream-cons"]],["racket/stream","racket"]],
["stream-cons",">srfi-std/srfi-40.html#stream-cons",[0,[1,"stream-cons"]],["srfi/40"]],
["stream-cons",">srfi-std/srfi-41/srfi-41.html#stream-cons",[0,[1,"stream-cons"]],["srfi/41"]],
["stream-constant",">srfi-std/srfi-41/srfi-41.html#stream-constant",[0,[2,"stream-constant"]],["srfi/41"]],
["stream-count",">reference/streams.html#(def._((lib._racket/stream..rkt)._stream-count))",[0,[2,"stream-count"]],["racket/stream","racket"]],
["stream-delay",">srfi-std/srfi-40.html#stream-delay",[0,[1,"stream-delay"]],["srfi/40"]],
["stream-drop",">srfi-std/srfi-41/srfi-41.html#stream-drop",[0,[2,"stream-drop"]],["srfi/41"]],
["stream-drop-while",">srfi-std/srfi-41/srfi-41.html#stream-drop-while",[0,[2,"stream-drop-while"]],["srfi/41"]],
["stream-empty?",">reference/streams.html#(def._((lib._racket/stream..rkt)._stream-empty~3f))",[0,[2,"stream-empty?"]],["racket/stream","racket"]],
["stream-filter",">reference/streams.html#(def._((lib._racket/stream..rkt)._stream-filter))",[0,[2,"stream-filter"]],["racket/stream","racket"]],
["stream-filter",">srfi-std/srfi-40.html#stream-filter",[0,[2,"stream-filter"]],["srfi/40"]],
["stream-filter",">srfi-std/srfi-41/srfi-41.html#stream-filter",[0,[2,"stream-filter"]],["srfi/41"]],
["stream-first",">reference/streams.html#(def._((lib._racket/stream..rkt)._stream-first))",[0,[2,"stream-first"]],["racket/stream","racket"]],
["stream-fold",">reference/streams.html#(def._((lib._racket/stream..rkt)._stream-fold))",[0,[2,"stream-fold"]],["racket/stream","racket"]],
["stream-fold",">srfi-std/srfi-41/srfi-41.html#stream-fold",[0,[2,"stream-fold"]],["srfi/41"]],
["stream-for-each",">reference/streams.html#(def._((lib._racket/stream..rkt)._stream-for-each))",[0,[2,"stream-for-each"]],["racket/stream","racket"]],
["stream-for-each",">srfi-std/srfi-40.html#stream-for-each",[0,[2,"stream-for-each"]],["srfi/40"]],
["stream-for-each",">srfi-std/srfi-41/srfi-41.html#stream-for-each",[0,[2,"stream-for-each"]],["srfi/41"]],
["stream-from",">srfi-std/srfi-41/srfi-41.html#stream-from",[0,[2,"stream-from"]],["srfi/41"]],
["stream-iterate",">srfi-std/srfi-41/srfi-41.html#stream-iterate",[0,[2,"stream-iterate"]],["srfi/41"]],
["stream-lambda",">srfi-std/srfi-41/srfi-41.html#stream-lambda",[0,[1,"stream-lambda"]],["srfi/41"]],
["stream-length",">reference/streams.html#(def._((lib._racket/stream..rkt)._stream-length))",[0,[2,"stream-length"]],["racket/stream","racket"]],
["stream-length",">srfi-std/srfi-41/srfi-41.html#stream-length",[0,[2,"stream-length"]],["srfi/41"]],
["stream-let",">srfi-std/srfi-41/srfi-41.html#stream-let",[0,[1,"stream-let"]],["srfi/41"]],
["stream-map",">reference/streams.html#(def._((lib._racket/stream..rkt)._stream-map))",[0,[2,"stream-map"]],["racket/stream","racket"]],
["stream-map",">srfi-std/srfi-40.html#stream-map",[0,[2,"stream-map"]],["srfi/40"]],
["stream-map",">srfi-std/srfi-41/srfi-41.html#stream-map",[0,[2,"stream-map"]],["srfi/41"]],
["stream-match",">srfi-std/srfi-41/srfi-41.html#stream-match",[0,[1,"stream-match"]],["srfi/41"]],
["stream-null",">srfi-std/srfi-40.html#stream-null",[0,[2,"stream-null"]],["srfi/40"]],
["stream-null",">srfi-std/srfi-41/srfi-41.html#stream-null",[0,[2,"stream-null"]],["srfi/41"]],
["stream-null?",">srfi-std/srfi-40.html#stream-null?",[0,[2,"stream-null?"]],["srfi/40"]],
["stream-null?",">srfi-std/srfi-41/srfi-41.html#stream-null?",[0,[2,"stream-null?"]],["srfi/41"]],
["stream-of",">srfi-std/srfi-41/srfi-41.html#stream-of",[0,[1,"stream-of"]],["srfi/41"]],
["stream-ormap",">reference/streams.html#(def._((lib._racket/stream..rkt)._stream-ormap))",[0,[2,"stream-ormap"]],["racket/stream","racket"]],
["stream-pair?",">srfi-std/srfi-41/srfi-41.html#stream-pair?",[0,[2,"stream-pair?"]],["srfi/41"]],
["stream-range",">srfi-std/srfi-41/srfi-41.html#stream-range",[0,[2,"stream-range"]],["srfi/41"]],
["stream-ref",">reference/streams.html#(def._((lib._racket/stream..rkt)._stream-ref))",[0,[2,"stream-ref"]],["racket/stream","racket"]],
["stream-ref",">srfi-std/srfi-41/srfi-41.html#stream-ref",[0,[2,"stream-ref"]],["srfi/41"]],
["stream-rest",">reference/streams.html#(def._((lib._racket/stream..rkt)._stream-rest))",[0,[2,"stream-rest"]],["racket/stream","racket"]],
["stream-reverse",">srfi-std/srfi-41/srfi-41.html#stream-reverse",[0,[2,"stream-reverse"]],["srfi/41"]],
["stream-scan",">srfi-std/srfi-41/srfi-41.html#stream-scan",[0,[2,"stream-scan"]],["srfi/41"]],
["stream-tail",">reference/streams.html#(def._((lib._racket/stream..rkt)._stream-tail))",[0,[2,"stream-tail"]],["racket/stream","racket"]],
["stream-take",">srfi-std/srfi-41/srfi-41.html#stream-take",[0,[2,"stream-take"]],["srfi/41"]],
["stream-take-while",">srfi-std/srfi-41/srfi-41.html#stream-take-while",[0,[2,"stream-take-while"]],["srfi/41"]],
["stream-unfold",">srfi-std/srfi-41/srfi-41.html#stream-unfold",[0,[2,"stream-unfold"]],["srfi/41"]],
["stream-unfoldn",">srfi-std/srfi-40.html#stream-unfoldn",[0,[2,"stream-unfoldn"]],["srfi/40"]],
["stream-zip",">srfi-std/srfi-41/srfi-41.html#stream-zip",[0,[2,"stream-zip"]],["srfi/41"]],
["stream<%>",">gui/WXME_Decoding.html#(def._((lib._wxme/main..rkt)._stream~3c~25~3e))",[0,[2,"stream<%>"]],["wxme"]],
["stream?",">reference/streams.html#(def._((lib._racket/stream..rkt)._stream~3f))",[0,[2,"stream?"]],["racket/stream","racket"]],
["stream?",">srfi-std/srfi-40.html#stream?",[0,[2,"stream?"]],["srfi/40"]],
["stream?",">srfi-std/srfi-41/srfi-41.html#stream?",[0,[2,"stream?"]],["srfi/41"]],
["streams",">reference/streams.html","Streams",false],
["stretch-transform",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._stretch-transform))",[0,[2,"stretch-transform"]],["plot"]],
["stretchability",">gui/windowing-overview.html#(tech._stretchability)","<span style=\"font-style: italic\">stretchability</span>",false],
["stretchable-editor-snip%",">embedded-gui/Helpers.html#(def._((lib._embedded-gui/main..rkt)._stretchable-editor-snip~25))",[0,[2,"stretchable-editor-snip%"]],["embedded-gui"]],
["stretchable-editor-snip-mixin",">embedded-gui/Helpers.html#(def._((lib._embedded-gui/main..rkt)._stretchable-editor-snip-mixin))",[0,[2,"stretchable-editor-snip-mixin"]],["embedded-gui"]],
["stretchable-height",">gui/area___.html#(meth._(((lib._mred/main..rkt)._area~3c~25~3e)._stretchable-height))",[[0,[2,"stretchable-height"]],[14,[" (method of ",[0,[2,"area<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["stretchable-height",">embedded-gui/alignment___.html#(meth._(((lib._embedded-gui/main..rkt)._alignment~3c~25~3e)._stretchable-height))",[[0,[2,"stretchable-height"]],[14,[" (method of ",[0,[2,"alignment<%>"]],")"]]],["embedded-gui"]],
["stretchable-height",">embedded-gui/stretchable-snip___.html#(meth._(((lib._embedded-gui/main..rkt)._stretchable-snip~3c~25~3e)._stretchable-height))",[[0,[2,"stretchable-height"]],[14,[" (method of ",[0,[2,"stretchable-snip<%>"]],")"]]],["embedded-gui"]],
["stretchable-height",">mrlib/stretchable-snip___.html#(meth._(((lib._mrlib/aligned-pasteboard..rkt)._stretchable-snip~3c~25~3e)._stretchable-height))",[[0,[2,"stretchable-height"]],[14,[" (method of ",[0,[2,"stretchable-snip<%>"]],")"]]],["mrlib/aligned-pasteboard"]],
["stretchable-height",">gui/area___.html#(idx._(gentag._16._(lib._scribblings/gui/gui..scrbl)))",[0,"stretchable-height"],false],
["stretchable-height?",">embedded-gui/snip-related-functions.html#(def._((lib._embedded-gui/main..rkt)._stretchable-height~3f))",[0,[2,"stretchable-height?"]],["embedded-gui"]],
["stretchable-snip<%>",">embedded-gui/stretchable-snip___.html",[0,[2,"stretchable-snip<%>"]],["embedded-gui"]],
["stretchable-snip<%>",">mrlib/stretchable-snip___.html",[0,[2,"stretchable-snip<%>"]],["mrlib/aligned-pasteboard"]],
["stretchable-width",">gui/area___.html#(meth._(((lib._mred/main..rkt)._area~3c~25~3e)._stretchable-width))",[[0,[2,"stretchable-width"]],[14,[" (method of ",[0,[2,"area<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["stretchable-width",">embedded-gui/alignment___.html#(meth._(((lib._embedded-gui/main..rkt)._alignment~3c~25~3e)._stretchable-width))",[[0,[2,"stretchable-width"]],[14,[" (method of ",[0,[2,"alignment<%>"]],")"]]],["embedded-gui"]],
["stretchable-width",">embedded-gui/stretchable-snip___.html#(meth._(((lib._embedded-gui/main..rkt)._stretchable-snip~3c~25~3e)._stretchable-width))",[[0,[2,"stretchable-width"]],[14,[" (method of ",[0,[2,"stretchable-snip<%>"]],")"]]],["embedded-gui"]],
["stretchable-width",">mrlib/stretchable-snip___.html#(meth._(((lib._mrlib/aligned-pasteboard..rkt)._stretchable-snip~3c~25~3e)._stretchable-width))",[[0,[2,"stretchable-width"]],[14,[" (method of ",[0,[2,"stretchable-snip<%>"]],")"]]],["mrlib/aligned-pasteboard"]],
["stretchable-width",">gui/area___.html#(idx._(gentag._15._(lib._scribblings/gui/gui..scrbl)))",[0,"stretchable-width"],false],
["stretchable-width?",">embedded-gui/snip-related-functions.html#(def._((lib._embedded-gui/main..rkt)._stretchable-width~3f))",[0,[2,"stretchable-width?"]],["embedded-gui"]],
["stretching and squashing time",">slideshow/play.html#(part._.Stretching_and_.Squashing_.Time)","Stretching and Squashing Time",false],
["strike",">html/index.html#(def._((lib._html/main..rkt)._strike))",[0,[2,"strike"]],["html"]],
["strike",">unstable/pict.html#(def._((lib._unstable/gui/pict..rkt)._strike))",[0,[2,"strike"]],["unstable/gui/pict"]],
["strike?",">html/index.html#(def._((lib._html/main..rkt)._strike~3f))",[0,[2,"strike?"]],["html"]],
["string",">reference/strings.html#(def._((quote._~23~25kernel)._string))",[0,[2,"string"]],["racket/base","racket"]],
["string",">r5rs-std/r5rs-Z-H-9.html#%_idx_514",[0,[2,"string"]],["r5rs"]],
["string",">r6rs-std/r6rs-Z-H-14.html#node_idx_692",[0,[2,"string"]],["rnrs/base-6"]],
["string",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._string))",[0,[2,"string"]],["lang/htdp-advanced"]],
["string",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._string))",[0,[2,"string"]],["lang/htdp-beginner"]],
["string",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._string))",[0,[2,"string"]],["lang/htdp-beginner-abbr"]],
["string",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._string))",[0,[2,"string"]],["lang/htdp-intermediate"]],
["string",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._string))",[0,[2,"string"]],["lang/htdp-intermediate-lambda"]],
["string",">deinprogramm/Signaturen.html#(form._((lib._deinprogramm/.D.Md.A..rkt)._string))",[0,[1,"string"]],["deinprogramm/DMdA-beginner"]],
["string",">srfi-std/srfi-13.html#string",[0,[2,"string"]],["srfi/13"]],
["string",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.String))",[0,[1,"String"]],["typed/racket/base","typed/racket"]],
["string",">tools/adding-languages.html#(idx._(gentag._12._(lib._scribblings/tools/tools..scrbl)))",[7,"'string"],false],
["string",">redex/The_Redex_Reference.html#(tech._string)",[0,[2,"string"]],false],
["string",">guide/strings.html#(tech._string)","<span style=\"font-style: italic\">string</span>",false],
["string",">reference/strings.html#(tech._string)","<span style=\"font-style: italic\">string</span>",false],
["string comparisons",">reference/strings.html#(part._.String_.Comparisons)","String Comparisons",false],
["string constants: gui internationalization",">string-constants/index.html","String Constants: GUI Internationalization",false],
["string constructors, selectors, and mutators",">reference/strings.html#(part._.String_.Constructors__.Selectors__and_.Mutators)","String Constructors, Selectors, and Mutators",false],
["string conversions",">reference/strings.html#(part._.String_.Conversions)","String Conversions",false],
["string encodings",">inside/im_encodings.html","String Encodings",false],
["string port",">reference/stringport.html#(tech._string._port)","<span style=\"font-style: italic\">string port</span>",false],
["string ports",">reference/stringport.html","String Ports",false],
["string types",">foreign/String_Types.html","String Types",false],
["string->bytes/latin-1",">reference/bytestrings.html#(def._((quote._~23~25kernel)._string-~3ebytes/latin-1))",[0,[2,"string->bytes/latin-1"]],["racket/base","racket"]],
["string->bytes/locale",">reference/bytestrings.html#(def._((quote._~23~25kernel)._string-~3ebytes/locale))",[0,[2,"string->bytes/locale"]],["racket/base","racket"]],
["string->bytes/utf-8",">reference/bytestrings.html#(def._((quote._~23~25kernel)._string-~3ebytes/utf-8))",[0,[2,"string->bytes/utf-8"]],["racket/base","racket"]],
["string->bytevector",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_632",[0,[2,"string->bytevector"]],["rnrs/io/ports-6"]],
["string->char-set",">srfi-std/srfi-14.html#string->char-set",[0,[2,"string->char-set"]],["srfi/14"]],
["string->char-set!",">srfi-std/srfi-14.html#string->char-set!",[0,[2,"string->char-set!"]],["srfi/14"]],
["string->clsid",">foreign/com-auto.html#(def._((lib._ffi/unsafe/com..rkt)._string-~3eclsid))",[0,[2,"string->clsid"]],["ffi/com"]],
["string->date",">srfi-std/srfi-19.html#string->date",[0,[2,"string->date"]],["srfi/19"]],
["string->guid",">foreign/com-auto.html#(def._((lib._ffi/unsafe/com..rkt)._string-~3eguid))",[0,[2,"string->guid"]],["ffi/com"]],
["string->html",">net/cgi.html#(def._((lib._net/cgi..rkt)._string-~3ehtml))",[0,[2,"string->html"]],["net/cgi"]],
["string->iid",">foreign/com-auto.html#(def._((lib._ffi/unsafe/com..rkt)._string-~3eiid))",[0,[2,"string->iid"]],["ffi/com"]],
["string->immutable-string",">reference/strings.html#(def._((quote._~23~25kernel)._string-~3eimmutable-string))",[0,[2,"string->immutable-string"]],["racket/base","racket"]],
["string->int",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._string-~3eint))",[0,[2,"string->int"]],["lang/htdp-advanced"]],
["string->int",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._string-~3eint))",[0,[2,"string->int"]],["lang/htdp-beginner"]],
["string->int",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._string-~3eint))",[0,[2,"string->int"]],["lang/htdp-beginner-abbr"]],
["string->int",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._string-~3eint))",[0,[2,"string->int"]],["lang/htdp-intermediate"]],
["string->int",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._string-~3eint))",[0,[2,"string->int"]],["lang/htdp-intermediate-lambda"]],
["string->jsexpr",">json/index.html#(def._((lib._json/main..rkt)._string-~3ejsexpr))",[0,[2,"string->jsexpr"]],["json"]],
["string->keyword",">reference/keywords.html#(def._((quote._~23~25kernel)._string-~3ekeyword))",[0,[2,"string->keyword"]],["racket/base","racket"]],
["string->lib-path",">gui/WXME_Decoding.html#(def._((lib._wxme/main..rkt)._string-~3elib-path))",[0,[2,"string->lib-path"]],["wxme"]],
["string->list",">reference/strings.html#(def._((quote._~23~25kernel)._string-~3elist))",[0,[2,"string->list"]],["racket/base","racket"]],
["string->list",">r5rs-std/r5rs-Z-H-9.html#%_idx_546",[0,[2,"string->list"]],["r5rs"]],
["string->list",">r6rs-std/r6rs-Z-H-14.html#node_idx_712",[0,[2,"string->list"]],["rnrs/base-6"]],
["string->list",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._string-~3elist))",[0,[2,"string->list"]],["lang/htdp-advanced"]],
["string->list",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._string-~3elist))",[0,[2,"string->list"]],["lang/htdp-beginner"]],
["string->list",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._string-~3elist))",[0,[2,"string->list"]],["lang/htdp-beginner-abbr"]],
["string->list",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._string-~3elist))",[0,[2,"string->list"]],["lang/htdp-intermediate"]],
["string->list",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._string-~3elist))",[0,[2,"string->list"]],["lang/htdp-intermediate-lambda"]],
["string->list",">srfi-std/srfi-13.html#string2list",[0,[2,"string->list"]],["srfi/13"]],
["string->number",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._string-~3enumber))",[0,[2,"string->number"]],["racket/base","racket"]],
["string->number",">r5rs-std/r5rs-Z-H-9.html#%_idx_370",[0,[2,"string->number"]],["r5rs"]],
["string->number",">r6rs-std/r6rs-Z-H-14.html#node_idx_584",[0,[2,"string->number"]],["rnrs/base-6"]],
["string->number",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._string-~3enumber))",[0,[2,"string->number"]],["lang/htdp-advanced"]],
["string->number",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._string-~3enumber))",[0,[2,"string->number"]],["lang/htdp-beginner"]],
["string->number",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._string-~3enumber))",[0,[2,"string->number"]],["lang/htdp-beginner-abbr"]],
["string->number",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._string-~3enumber))",[0,[2,"string->number"]],["lang/htdp-intermediate"]],
["string->number",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._string-~3enumber))",[0,[2,"string->number"]],["lang/htdp-intermediate-lambda"]],
["string->number",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._string-~3enumber))",[0,[2,"string->number"]],["deinprogramm/DMdA-advanced"]],
["string->number",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._string-~3enumber))",[0,[2,"string->number"]],["deinprogramm/DMdA-assignments"]],
["string->number",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._string-~3enumber))",[0,[2,"string->number"]],["deinprogramm/DMdA-beginner"]],
["string->number",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._string-~3enumber))",[0,[2,"string->number"]],["deinprogramm/DMdA-vanilla"]],
["string->path",">reference/Manipulating_Paths.html#(def._((quote._~23~25kernel)._string-~3epath))",[0,[2,"string->path"]],["racket/base","racket"]],
["string->path-element",">reference/Manipulating_Paths.html#(def._((quote._~23~25kernel)._string-~3epath-element))",[0,[2,"string->path-element"]],["racket/base","racket"]],
["string->some-system-path",">reference/More_Path_Utilities.html#(def._((lib._racket/path..rkt)._string-~3esome-system-path))",[0,[2,"string->some-system-path"]],["racket/path","racket"]],
["string->sql-bits",">db/sql-types.html#(def._((lib._db/base..rkt)._string-~3esql-bits))",[0,[2,"string->sql-bits"]],["db","db/base"]],
["string->strings-list",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._string-~3estrings-list))",[0,[2,"string->strings-list"]],["deinprogramm/DMdA-advanced"]],
["string->strings-list",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._string-~3estrings-list))",[0,[2,"string->strings-list"]],["deinprogramm/DMdA-assignments"]],
["string->strings-list",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._string-~3estrings-list))",[0,[2,"string->strings-list"]],["deinprogramm/DMdA-beginner"]],
["string->strings-list",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._string-~3estrings-list))",[0,[2,"string->strings-list"]],["deinprogramm/DMdA-vanilla"]],
["string->symbol",">reference/symbols.html#(def._((quote._~23~25kernel)._string-~3esymbol))",[0,[2,"string->symbol"]],["racket/base","racket"]],
["string->symbol",">r5rs-std/r5rs-Z-H-9.html#%_idx_464",[0,[2,"string->symbol"]],["r5rs"]],
["string->symbol",">r6rs-std/r6rs-Z-H-14.html#node_idx_652",[0,[2,"string->symbol"]],["rnrs/base-6"]],
["string->symbol",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._string-~3esymbol))",[0,[2,"string->symbol"]],["lang/htdp-advanced"]],
["string->symbol",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._string-~3esymbol))",[0,[2,"string->symbol"]],["lang/htdp-beginner"]],
["string->symbol",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._string-~3esymbol))",[0,[2,"string->symbol"]],["lang/htdp-beginner-abbr"]],
["string->symbol",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._string-~3esymbol))",[0,[2,"string->symbol"]],["lang/htdp-intermediate"]],
["string->symbol",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._string-~3esymbol))",[0,[2,"string->symbol"]],["lang/htdp-intermediate-lambda"]],
["string->symbol",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._string-~3esymbol))",[0,"string->symbol"],["deinprogramm/DMdA-advanced"]],
["string->uninterned-symbol",">reference/symbols.html#(def._((quote._~23~25kernel)._string-~3euninterned-symbol))",[0,[2,"string->uninterned-symbol"]],["racket/base","racket"]],
["string->unreadable-symbol",">reference/symbols.html#(def._((quote._~23~25kernel)._string-~3eunreadable-symbol))",[0,[2,"string->unreadable-symbol"]],["racket/base","racket"]],
["string->url",">net/url.html#(def._((lib._net/url..rkt)._string-~3eurl))",[0,[2,"string->url"]],["net/url"]],
["string->utf16",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_186",[0,[2,"string->utf16"]],["rnrs/bytevectors-6"]],
["string->utf32",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_190",[0,[2,"string->utf32"]],["rnrs/bytevectors-6"]],
["string->utf8",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_184",[0,[2,"string->utf8"]],["rnrs/bytevectors-6"]],
["string->xexpr",">xml/index.html#(def._((lib._xml/main..rkt)._string-~3exexpr))",[0,[2,"string->xexpr"]],["xml"]],
["string-alphabetic?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._string-alphabetic~3f))",[0,[2,"string-alphabetic?"]],["lang/htdp-advanced"]],
["string-alphabetic?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._string-alphabetic~3f))",[0,[2,"string-alphabetic?"]],["lang/htdp-beginner"]],
["string-alphabetic?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._string-alphabetic~3f))",[0,[2,"string-alphabetic?"]],["lang/htdp-beginner-abbr"]],
["string-alphabetic?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._string-alphabetic~3f))",[0,[2,"string-alphabetic?"]],["lang/htdp-intermediate"]],
["string-alphabetic?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._string-alphabetic~3f))",[0,[2,"string-alphabetic?"]],["lang/htdp-intermediate-lambda"]],
["string-any",">srfi-std/srfi-13.html#string-any",[0,[2,"string-any"]],["srfi/13"]],
["string-append",">reference/strings.html#(def._((quote._~23~25kernel)._string-append))",[0,[2,"string-append"]],["racket/base","racket"]],
["string-append",">r5rs-std/r5rs-Z-H-9.html#%_idx_544",[0,[2,"string-append"]],["r5rs"]],
["string-append",">r6rs-std/r6rs-Z-H-14.html#node_idx_710",[0,[2,"string-append"]],["rnrs/base-6"]],
["string-append",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._string-append))",[0,[2,"string-append"]],["lang/htdp-advanced"]],
["string-append",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._string-append))",[0,[2,"string-append"]],["lang/htdp-beginner"]],
["string-append",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._string-append))",[0,[2,"string-append"]],["lang/htdp-beginner-abbr"]],
["string-append",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._string-append))",[0,[2,"string-append"]],["lang/htdp-intermediate"]],
["string-append",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._string-append))",[0,[2,"string-append"]],["lang/htdp-intermediate-lambda"]],
["string-append",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._string-append))",[0,[2,"string-append"]],["deinprogramm/DMdA-advanced"]],
["string-append",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._string-append))",[0,[2,"string-append"]],["deinprogramm/DMdA-assignments"]],
["string-append",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._string-append))",[0,[2,"string-append"]],["deinprogramm/DMdA-beginner"]],
["string-append",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._string-append))",[0,[2,"string-append"]],["deinprogramm/DMdA-vanilla"]],
["string-append",">srfi-std/srfi-13.html#string-append",[0,[2,"string-append"]],["srfi/13"]],
["string-append*",">reference/strings.html#(def._((lib._racket/string..rkt)._string-append*))",[0,[2,"string-append*"]],["racket/string","racket"]],
["string-append-ec",">srfi-std/srfi-42.html#string-append-ec",[0,[1,"string-append-ec"]],["srfi/42"]],
["string-append/shared",">srfi-std/srfi-13.html#string-append/shared",[0,[2,"string-append/shared"]],["srfi/13"]],
["string-arg",">web-server/dispatch.html#(form._((lib._web-server/dispatch..rkt)._string-arg))",[0,[1,"string-arg"]],["web-server/dispatch"]],
["string-ci-hash",">r6rs-lib-std/r6rs-lib-Z-H-14.html#node_idx_1222",[0,[2,"string-ci-hash"]],["rnrs/hashtables-6"]],
["string-ci<",">srfi-std/srfi-13.html#string-ci<",[0,[2,"string-ci<"]],["srfi/13"]],
["string-ci<=",">srfi-std/srfi-13.html#string-ci<=",[0,[2,"string-ci<="]],["srfi/13"]],
["string-ci<=?",">reference/strings.html#(def._((quote._~23~25kernel)._string-ci~3c~3d~3f))",[0,[2,"string-ci<=?"]],["racket/base","racket"]],
["string-ci<=?",">r5rs-std/r5rs-Z-H-9.html#%_idx_538",[0,[2,"string-ci<=?"]],["r5rs"]],
["string-ci<=?",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_50",[0,[2,"string-ci<=?"]],["rnrs/unicode-6"]],
["string-ci<=?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._string-ci~3c~3d~3f))",[0,[2,"string-ci<=?"]],["lang/htdp-advanced"]],
["string-ci<=?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._string-ci~3c~3d~3f))",[0,[2,"string-ci<=?"]],["lang/htdp-beginner"]],
["string-ci<=?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._string-ci~3c~3d~3f))",[0,[2,"string-ci<=?"]],["lang/htdp-beginner-abbr"]],
["string-ci<=?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._string-ci~3c~3d~3f))",[0,[2,"string-ci<=?"]],["lang/htdp-intermediate"]],
["string-ci<=?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._string-ci~3c~3d~3f))",[0,[2,"string-ci<=?"]],["lang/htdp-intermediate-lambda"]],
["string-ci<>",">srfi-std/srfi-13.html#string-ci<>",[0,[2,"string-ci<>"]],["srfi/13"]],
["string-ci<?",">reference/strings.html#(def._((quote._~23~25kernel)._string-ci~3c~3f))",[0,[2,"string-ci<?"]],["racket/base","racket"]],
["string-ci<?",">r5rs-std/r5rs-Z-H-9.html#%_idx_534",[0,[2,"string-ci<?"]],["r5rs"]],
["string-ci<?",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_46",[0,[2,"string-ci<?"]],["rnrs/unicode-6"]],
["string-ci<?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._string-ci~3c~3f))",[0,[2,"string-ci<?"]],["lang/htdp-advanced"]],
["string-ci<?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._string-ci~3c~3f))",[0,[2,"string-ci<?"]],["lang/htdp-beginner"]],
["string-ci<?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._string-ci~3c~3f))",[0,[2,"string-ci<?"]],["lang/htdp-beginner-abbr"]],
["string-ci<?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._string-ci~3c~3f))",[0,[2,"string-ci<?"]],["lang/htdp-intermediate"]],
["string-ci<?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._string-ci~3c~3f))",[0,[2,"string-ci<?"]],["lang/htdp-intermediate-lambda"]],
["string-ci=",">srfi-std/srfi-13.html#string-ci=",[0,[2,"string-ci="]],["srfi/13"]],
["string-ci=?",">reference/strings.html#(def._((quote._~23~25kernel)._string-ci~3d~3f))",[0,[2,"string-ci=?"]],["racket/base","racket"]],
["string-ci=?",">r5rs-std/r5rs-Z-H-9.html#%_idx_524",[0,[2,"string-ci=?"]],["r5rs"]],
["string-ci=?",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_44",[0,[2,"string-ci=?"]],["rnrs/unicode-6"]],
["string-ci=?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._string-ci~3d~3f))",[0,[2,"string-ci=?"]],["lang/htdp-advanced"]],
["string-ci=?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._string-ci~3d~3f))",[0,[2,"string-ci=?"]],["lang/htdp-beginner"]],
["string-ci=?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._string-ci~3d~3f))",[0,[2,"string-ci=?"]],["lang/htdp-beginner-abbr"]],
["string-ci=?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._string-ci~3d~3f))",[0,[2,"string-ci=?"]],["lang/htdp-intermediate"]],
["string-ci=?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._string-ci~3d~3f))",[0,[2,"string-ci=?"]],["lang/htdp-intermediate-lambda"]],
["string-ci>",">srfi-std/srfi-13.html#string-ci>",[0,[2,"string-ci>"]],["srfi/13"]],
["string-ci>=",">srfi-std/srfi-13.html#string-ci>=",[0,[2,"string-ci>="]],["srfi/13"]],
["string-ci>=?",">reference/strings.html#(def._((quote._~23~25kernel)._string-ci~3e~3d~3f))",[0,[2,"string-ci>=?"]],["racket/base","racket"]],
["string-ci>=?",">r5rs-std/r5rs-Z-H-9.html#%_idx_540",[0,[2,"string-ci>=?"]],["r5rs"]],
["string-ci>=?",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_52",[0,[2,"string-ci>=?"]],["rnrs/unicode-6"]],
["string-ci>=?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._string-ci~3e~3d~3f))",[0,[2,"string-ci>=?"]],["lang/htdp-advanced"]],
["string-ci>=?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._string-ci~3e~3d~3f))",[0,[2,"string-ci>=?"]],["lang/htdp-beginner"]],
["string-ci>=?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._string-ci~3e~3d~3f))",[0,[2,"string-ci>=?"]],["lang/htdp-beginner-abbr"]],
["string-ci>=?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._string-ci~3e~3d~3f))",[0,[2,"string-ci>=?"]],["lang/htdp-intermediate"]],
["string-ci>=?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._string-ci~3e~3d~3f))",[0,[2,"string-ci>=?"]],["lang/htdp-intermediate-lambda"]],
["string-ci>?",">reference/strings.html#(def._((quote._~23~25kernel)._string-ci~3e~3f))",[0,[2,"string-ci>?"]],["racket/base","racket"]],
["string-ci>?",">r5rs-std/r5rs-Z-H-9.html#%_idx_536",[0,[2,"string-ci>?"]],["r5rs"]],
["string-ci>?",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_48",[0,[2,"string-ci>?"]],["rnrs/unicode-6"]],
["string-ci>?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._string-ci~3e~3f))",[0,[2,"string-ci>?"]],["lang/htdp-advanced"]],
["string-ci>?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._string-ci~3e~3f))",[0,[2,"string-ci>?"]],["lang/htdp-beginner"]],
["string-ci>?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._string-ci~3e~3f))",[0,[2,"string-ci>?"]],["lang/htdp-beginner-abbr"]],
["string-ci>?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._string-ci~3e~3f))",[0,[2,"string-ci>?"]],["lang/htdp-intermediate"]],
["string-ci>?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._string-ci~3e~3f))",[0,[2,"string-ci>?"]],["lang/htdp-intermediate-lambda"]],
["string-compare",">srfi-std/srfi-13.html#string-compare",[0,[2,"string-compare"]],["srfi/13"]],
["string-compare-ci",">srfi-std/srfi-13.html#string-compare-ci",[0,[2,"string-compare-ci"]],["srfi/13"]],
["string-concatenate",">srfi-std/srfi-13.html#string-concatenate",[0,[2,"string-concatenate"]],["srfi/13"]],
["string-concatenate-reverse",">srfi-std/srfi-13.html#string-concatenate-reverse",[0,[2,"string-concatenate-reverse"]],["srfi/13"]],
["string-concatenate-reverse/shared",">srfi-std/srfi-13.html#string-concatenate-reverse/shared",[0,[2,"string-concatenate-reverse/shared"]],["srfi/13"]],
["string-concatenate/shared",">srfi-std/srfi-13.html#string-concatenate/shared",[0,[2,"string-concatenate/shared"]],["srfi/13"]],
["string-constant",">string-constants/index.html#(form._((lib._string-constants/string-constant..rkt)._string-constant))",[0,[1,"string-constant"]],["string-constants/string-constant","string-constants"]],
["string-constants",">string-constants/index.html#(mod-path._string-constants)",[9,[0,"string-constants"]],"module"],
["string-constants",">string-constants/index.html#(form._((lib._string-constants/string-constant..rkt)._string-constants))",[0,[1,"string-constants"]],["string-constants/string-constant","string-constants"]],
["string-contains",">srfi-std/srfi-13.html#string-contains",[0,[2,"string-contains"]],["srfi/13"]],
["string-contains-ci",">srfi-std/srfi-13.html#string-contains-ci",[0,[2,"string-contains-ci"]],["srfi/13"]],
["string-contains?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._string-contains~3f))",[0,[2,"string-contains?"]],["lang/htdp-advanced"]],
["string-contains?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._string-contains~3f))",[0,[2,"string-contains?"]],["lang/htdp-beginner"]],
["string-contains?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._string-contains~3f))",[0,[2,"string-contains?"]],["lang/htdp-beginner-abbr"]],
["string-contains?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._string-contains~3f))",[0,[2,"string-contains?"]],["lang/htdp-intermediate"]],
["string-contains?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._string-contains~3f))",[0,[2,"string-contains?"]],["lang/htdp-intermediate-lambda"]],
["string-copy",">reference/strings.html#(def._((quote._~23~25kernel)._string-copy))",[0,[2,"string-copy"]],["racket/base","racket"]],
["string-copy",">r5rs-std/r5rs-Z-H-9.html#%_idx_550",[0,[2,"string-copy"]],["r5rs"]],
["string-copy",">r6rs-std/r6rs-Z-H-14.html#node_idx_718",[0,[2,"string-copy"]],["rnrs/base-6"]],
["string-copy",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._string-copy))",[0,[2,"string-copy"]],["lang/htdp-advanced"]],
["string-copy",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._string-copy))",[0,[2,"string-copy"]],["lang/htdp-beginner"]],
["string-copy",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._string-copy))",[0,[2,"string-copy"]],["lang/htdp-beginner-abbr"]],
["string-copy",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._string-copy))",[0,[2,"string-copy"]],["lang/htdp-intermediate"]],
["string-copy",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._string-copy))",[0,[2,"string-copy"]],["lang/htdp-intermediate-lambda"]],
["string-copy",">srfi-std/srfi-13.html#string-copy",[0,[2,"string-copy"]],["srfi/13"]],
["string-copy!",">reference/strings.html#(def._((quote._~23~25kernel)._string-copy!))",[0,[2,"string-copy!"]],["racket/base","racket"]],
["string-copy!",">srfi-std/srfi-13.html#string-copy!",[0,[2,"string-copy!"]],["srfi/13"]],
["string-count",">srfi-std/srfi-13.html#string-count",[0,[2,"string-count"]],["srfi/13"]],
["string-delete",">srfi-std/srfi-13.html#string-delete",[0,[2,"string-delete"]],["srfi/13"]],
["string-downcase",">reference/strings.html#(def._((quote._~23~25kernel)._string-downcase))",[0,[2,"string-downcase"]],["racket/base","racket"]],
["string-downcase",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_38",[0,[2,"string-downcase"]],["rnrs/unicode-6"]],
["string-downcase",">srfi-std/srfi-13.html#string-downcase",[0,[2,"string-downcase"]],["srfi/13"]],
["string-downcase!",">srfi-std/srfi-13.html#string-downcase!",[0,[2,"string-downcase!"]],["srfi/13"]],
["string-drop",">srfi-std/srfi-13.html#string-drop",[0,[2,"string-drop"]],["srfi/13"]],
["string-drop-right",">srfi-std/srfi-13.html#string-drop-right",[0,[2,"string-drop-right"]],["srfi/13"]],
["string-ec",">srfi-std/srfi-42.html#string-ec",[0,[1,"string-ec"]],["srfi/42"]],
["string-every",">srfi-std/srfi-13.html#string-every",[0,[2,"string-every"]],["srfi/13"]],
["string-fill!",">reference/strings.html#(def._((quote._~23~25kernel)._string-fill!))",[0,[2,"string-fill!"]],["racket/base","racket"]],
["string-fill!",">r5rs-std/r5rs-Z-H-9.html#%_idx_552",[0,[2,"string-fill!"]],["r5rs"]],
["string-fill!",">r6rs-lib-std/r6rs-lib-Z-H-19.html#node_idx_1282",[0,[2,"string-fill!"]],["rnrs/mutable-strings-6"]],
["string-fill!",">srfi-std/srfi-13.html#string-fill!",[0,[2,"string-fill!"]],["srfi/13"]],
["string-filter",">srfi-std/srfi-13.html#string-filter",[0,[2,"string-filter"]],["srfi/13"]],
["string-fold",">srfi-std/srfi-13.html#string-fold",[0,[2,"string-fold"]],["srfi/13"]],
["string-fold-right",">srfi-std/srfi-13.html#string-fold-right",[0,[2,"string-fold-right"]],["srfi/13"]],
["string-foldcase",">reference/strings.html#(def._((quote._~23~25kernel)._string-foldcase))",[0,[2,"string-foldcase"]],["racket/base","racket"]],
["string-foldcase",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_42",[0,[2,"string-foldcase"]],["rnrs/unicode-6"]],
["string-for-each",">r6rs-std/r6rs-Z-H-14.html#node_idx_716",[0,[2,"string-for-each"]],["rnrs/base-6"]],
["string-for-each",">srfi-std/srfi-13.html#string-for-each",[0,[2,"string-for-each"]],["srfi/13"]],
["string-for-each-index",">srfi-std/srfi-13.html#string-for-each-index",[0,[2,"string-for-each-index"]],["srfi/13"]],
["string-hash",">r6rs-lib-std/r6rs-lib-Z-H-14.html#node_idx_1220",[0,[2,"string-hash"]],["rnrs/hashtables-6"]],
["string-hash",">srfi-std/srfi-13.html#string-hash",[0,[2,"string-hash"]],["srfi/13"]],
["string-hash-ci",">srfi-std/srfi-13.html#string-hash-ci",[0,[2,"string-hash-ci"]],["srfi/13"]],
["string-index",">srfi-std/srfi-13.html#string-index",[0,[2,"string-index"]],["srfi/13"]],
["string-index-right",">srfi-std/srfi-13.html#string-index-right",[0,[2,"string-index-right"]],["srfi/13"]],
["string-ith",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._string-ith))",[0,[2,"string-ith"]],["lang/htdp-advanced"]],
["string-ith",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._string-ith))",[0,[2,"string-ith"]],["lang/htdp-beginner"]],
["string-ith",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._string-ith))",[0,[2,"string-ith"]],["lang/htdp-beginner-abbr"]],
["string-ith",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._string-ith))",[0,[2,"string-ith"]],["lang/htdp-intermediate"]],
["string-ith",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._string-ith))",[0,[2,"string-ith"]],["lang/htdp-intermediate-lambda"]],
["string-join",">reference/strings.html#(def._((lib._racket/string..rkt)._string-join))",[0,[2,"string-join"]],["racket/string","racket"]],
["string-join",">srfi-std/srfi-13.html#string-join",[0,[2,"string-join"]],["srfi/13"]],
["string-kmp-partial-search",">srfi-std/srfi-13.html#string-kmp-partial-search",[0,[2,"string-kmp-partial-search"]],["srfi/13"]],
["string-len/c",">reference/data-structure-contracts.html#(def._((lib._racket/contract/private/misc..rkt)._string-len/c))",[0,[2,"string-len/c"]],["racket/contract/base","racket/contract","racket"]],
["string-length",">reference/strings.html#(def._((quote._~23~25kernel)._string-length))",[0,[2,"string-length"]],["racket/base","racket"]],
["string-length",">r5rs-std/r5rs-Z-H-9.html#%_idx_516",[0,[2,"string-length"]],["r5rs"]],
["string-length",">r6rs-std/r6rs-Z-H-14.html#node_idx_694",[0,[2,"string-length"]],["rnrs/base-6"]],
["string-length",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._string-length))",[0,[2,"string-length"]],["lang/htdp-advanced"]],
["string-length",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._string-length))",[0,[2,"string-length"]],["lang/htdp-beginner"]],
["string-length",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._string-length))",[0,[2,"string-length"]],["lang/htdp-beginner-abbr"]],
["string-length",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._string-length))",[0,[2,"string-length"]],["lang/htdp-intermediate"]],
["string-length",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._string-length))",[0,[2,"string-length"]],["lang/htdp-intermediate-lambda"]],
["string-length",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._string-length))",[0,[2,"string-length"]],["deinprogramm/DMdA-advanced"]],
["string-length",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._string-length))",[0,[2,"string-length"]],["deinprogramm/DMdA-assignments"]],
["string-length",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._string-length))",[0,[2,"string-length"]],["deinprogramm/DMdA-beginner"]],
["string-length",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._string-length))",[0,[2,"string-length"]],["deinprogramm/DMdA-vanilla"]],
["string-length",">srfi-std/srfi-13.html#string-length",[0,[2,"string-length"]],["srfi/13"]],
["string-locale-ci<?",">reference/strings.html#(def._((quote._~23~25kernel)._string-locale-ci~3c~3f))",[0,[2,"string-locale-ci<?"]],["racket/base","racket"]],
["string-locale-ci=?",">reference/strings.html#(def._((quote._~23~25kernel)._string-locale-ci~3d~3f))",[0,[2,"string-locale-ci=?"]],["racket/base","racket"]],
["string-locale-ci>?",">reference/strings.html#(def._((quote._~23~25kernel)._string-locale-ci~3e~3f))",[0,[2,"string-locale-ci>?"]],["racket/base","racket"]],
["string-locale-downcase",">reference/strings.html#(def._((quote._~23~25kernel)._string-locale-downcase))",[0,[2,"string-locale-downcase"]],["racket/base","racket"]],
["string-locale-upcase",">reference/strings.html#(def._((quote._~23~25kernel)._string-locale-upcase))",[0,[2,"string-locale-upcase"]],["racket/base","racket"]],
["string-locale<?",">reference/strings.html#(def._((quote._~23~25kernel)._string-locale~3c~3f))",[0,[2,"string-locale<?"]],["racket/base","racket"]],
["string-locale=?",">reference/strings.html#(def._((quote._~23~25kernel)._string-locale~3d~3f))",[0,[2,"string-locale=?"]],["racket/base","racket"]],
["string-locale>?",">reference/strings.html#(def._((quote._~23~25kernel)._string-locale~3e~3f))",[0,[2,"string-locale>?"]],["racket/base","racket"]],
["string-lower-case?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._string-lower-case~3f))",[0,[2,"string-lower-case?"]],["lang/htdp-advanced"]],
["string-lower-case?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._string-lower-case~3f))",[0,[2,"string-lower-case?"]],["lang/htdp-beginner"]],
["string-lower-case?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._string-lower-case~3f))",[0,[2,"string-lower-case?"]],["lang/htdp-beginner-abbr"]],
["string-lower-case?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._string-lower-case~3f))",[0,[2,"string-lower-case?"]],["lang/htdp-intermediate"]],
["string-lower-case?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._string-lower-case~3f))",[0,[2,"string-lower-case?"]],["lang/htdp-intermediate-lambda"]],
["string-lowercase!",">mzlib/mzlib_string.html#(def._((lib._mzlib/string..rkt)._string-lowercase!))",[0,[2,"string-lowercase!"]],["mzlib/string"]],
["string-map",">srfi-std/srfi-13.html#string-map",[0,[2,"string-map"]],["srfi/13"]],
["string-map!",">srfi-std/srfi-13.html#string-map!",[0,[2,"string-map!"]],["srfi/13"]],
["string-no-nuls?",">reference/subprocess.html#(def._((lib._racket/system..rkt)._string-no-nuls~3f))",[0,[2,"string-no-nuls?"]],["racket/system","racket"]],
["string-normalize",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3anormalize-paste~3c~25~3e)._string-normalize))",[[0,[2,"string-normalize"]],[14,[" (method of ",[0,[2,"text:normalize-paste<%>"]],")"]]],["framework"]],
["string-normalize-nfc",">reference/strings.html#(def._((quote._~23~25kernel)._string-normalize-nfc))",[0,[2,"string-normalize-nfc"]],["racket/base","racket"]],
["string-normalize-nfc",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_58",[0,[2,"string-normalize-nfc"]],["rnrs/unicode-6"]],
["string-normalize-nfd",">reference/strings.html#(def._((quote._~23~25kernel)._string-normalize-nfd))",[0,[2,"string-normalize-nfd"]],["racket/base","racket"]],
["string-normalize-nfd",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_54",[0,[2,"string-normalize-nfd"]],["rnrs/unicode-6"]],
["string-normalize-nfkc",">reference/strings.html#(def._((quote._~23~25kernel)._string-normalize-nfkc))",[0,[2,"string-normalize-nfkc"]],["racket/base","racket"]],
["string-normalize-nfkc",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_60",[0,[2,"string-normalize-nfkc"]],["rnrs/unicode-6"]],
["string-normalize-nfkd",">reference/strings.html#(def._((quote._~23~25kernel)._string-normalize-nfkd))",[0,[2,"string-normalize-nfkd"]],["racket/base","racket"]],
["string-normalize-nfkd",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_56",[0,[2,"string-normalize-nfkd"]],["rnrs/unicode-6"]],
["string-normalize-spaces",">reference/strings.html#(def._((lib._racket/string..rkt)._string-normalize-spaces))",[0,[2,"string-normalize-spaces"]],["racket/string","racket"]],
["string-null?",">srfi-std/srfi-13.html#string-null-p",[0,[2,"string-null?"]],["srfi/13"]],
["string-numeric?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._string-numeric~3f))",[0,[2,"string-numeric?"]],["lang/htdp-advanced"]],
["string-numeric?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._string-numeric~3f))",[0,[2,"string-numeric?"]],["lang/htdp-beginner"]],
["string-numeric?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._string-numeric~3f))",[0,[2,"string-numeric?"]],["lang/htdp-beginner-abbr"]],
["string-numeric?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._string-numeric~3f))",[0,[2,"string-numeric?"]],["lang/htdp-intermediate"]],
["string-numeric?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._string-numeric~3f))",[0,[2,"string-numeric?"]],["lang/htdp-intermediate-lambda"]],
["string-pad",">srfi-std/srfi-13.html#string-pad",[0,[2,"string-pad"]],["srfi/13"]],
["string-pad-right",">srfi-std/srfi-13.html#string-pad-right",[0,[2,"string-pad-right"]],["srfi/13"]],
["string-parse-final-start+end",">srfi-std/srfi-13.html#string-parse-final-start+end",[0,[2,"string-parse-final-start+end"]],["srfi/13"]],
["string-parse-start+end",">srfi-std/srfi-13.html#string-parse-start+end",[0,[2,"string-parse-start+end"]],["srfi/13"]],
["string-prefix-ci?",">srfi-std/srfi-13.html#string-prefix-ci-p",[0,[2,"string-prefix-ci?"]],["srfi/13"]],
["string-prefix-length",">srfi-std/srfi-13.html#string-prefix-length",[0,[2,"string-prefix-length"]],["srfi/13"]],
["string-prefix-length-ci",">srfi-std/srfi-13.html#string-prefix-length-ci",[0,[2,"string-prefix-length-ci"]],["srfi/13"]],
["string-prefix?",">srfi-std/srfi-13.html#string-prefix-p",[0,[2,"string-prefix?"]],["srfi/13"]],
["string-ref",">reference/strings.html#(def._((quote._~23~25kernel)._string-ref))",[0,[2,"string-ref"]],["racket/base","racket"]],
["string-ref",">r5rs-std/r5rs-Z-H-9.html#%_idx_518",[0,[2,"string-ref"]],["r5rs"]],
["string-ref",">r6rs-std/r6rs-Z-H-14.html#node_idx_696",[0,[2,"string-ref"]],["rnrs/base-6"]],
["string-ref",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._string-ref))",[0,[2,"string-ref"]],["lang/htdp-advanced"]],
["string-ref",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._string-ref))",[0,[2,"string-ref"]],["lang/htdp-beginner"]],
["string-ref",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._string-ref))",[0,[2,"string-ref"]],["lang/htdp-beginner-abbr"]],
["string-ref",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._string-ref))",[0,[2,"string-ref"]],["lang/htdp-intermediate"]],
["string-ref",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._string-ref))",[0,[2,"string-ref"]],["lang/htdp-intermediate-lambda"]],
["string-ref",">srfi-std/srfi-13.html#string-ref",[0,[2,"string-ref"]],["srfi/13"]],
["string-replace",">reference/strings.html#(def._((lib._racket/string..rkt)._string-replace))",[0,[2,"string-replace"]],["racket/string","racket"]],
["string-replace",">srfi-std/srfi-13.html#string-replace",[0,[2,"string-replace"]],["srfi/13"]],
["string-reverse",">srfi-std/srfi-13.html#string-reverse",[0,[2,"string-reverse"]],["srfi/13"]],
["string-reverse!",">srfi-std/srfi-13.html#string-reverse!",[0,[2,"string-reverse!"]],["srfi/13"]],
["string-set!",">reference/strings.html#(def._((quote._~23~25kernel)._string-set!))",[0,[2,"string-set!"]],["racket/base","racket"]],
["string-set!",">r5rs-std/r5rs-Z-H-9.html#%_idx_520",[0,[2,"string-set!"]],["r5rs"]],
["string-set!",">r6rs-lib-std/r6rs-lib-Z-H-19.html#node_idx_1280",[0,[2,"string-set!"]],["rnrs/mutable-strings-6"]],
["string-set!",">srfi-std/srfi-13.html#string-set!",[0,[2,"string-set!"]],["srfi/13"]],
["string-skip",">srfi-std/srfi-13.html#string-skip",[0,[2,"string-skip"]],["srfi/13"]],
["string-skip-right",">srfi-std/srfi-13.html#string-skip-right",[0,[2,"string-skip-right"]],["srfi/13"]],
["string-snip%",">gui/string-snip_.html",[0,[2,"string-snip%"]],["racket/snip","racket/gui/base","racket/gui"]],
["string-split",">reference/strings.html#(def._((lib._racket/string..rkt)._string-split))",[0,[2,"string-split"]],["racket/string","racket"]],
["string-suffix-ci?",">srfi-std/srfi-13.html#string-suffix-ci-p",[0,[2,"string-suffix-ci?"]],["srfi/13"]],
["string-suffix-length",">srfi-std/srfi-13.html#string-suffix-length",[0,[2,"string-suffix-length"]],["srfi/13"]],
["string-suffix-length-ci",">srfi-std/srfi-13.html#string-suffix-length-ci",[0,[2,"string-suffix-length-ci"]],["srfi/13"]],
["string-suffix?",">srfi-std/srfi-13.html#string-suffix-p",[0,[2,"string-suffix?"]],["srfi/13"]],
["string-tabulate",">srfi-std/srfi-13.html#string-tabulate",[0,[2,"string-tabulate"]],["srfi/13"]],
["string-take",">srfi-std/srfi-13.html#string-take",[0,[2,"string-take"]],["srfi/13"]],
["string-take-right",">srfi-std/srfi-13.html#string-take-right",[0,[2,"string-take-right"]],["srfi/13"]],
["string-titlecase",">reference/strings.html#(def._((quote._~23~25kernel)._string-titlecase))",[0,[2,"string-titlecase"]],["racket/base","racket"]],
["string-titlecase",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_40",[0,[2,"string-titlecase"]],["rnrs/unicode-6"]],
["string-titlecase",">srfi-std/srfi-13.html#string-titlecase",[0,[2,"string-titlecase"]],["srfi/13"]],
["string-titlecase!",">srfi-std/srfi-13.html#string-titlecase!",[0,[2,"string-titlecase!"]],["srfi/13"]],
["string-tokenize",">srfi-std/srfi-13.html#string-tokenize",[0,[2,"string-tokenize"]],["srfi/13"]],
["string-trim",">reference/strings.html#(def._((lib._racket/string..rkt)._string-trim))",[0,[2,"string-trim"]],["racket/string","racket"]],
["string-trim",">srfi-std/srfi-13.html#string-trim",[0,[2,"string-trim"]],["srfi/13"]],
["string-trim-both",">srfi-std/srfi-13.html#string-trim-both",[0,[2,"string-trim-both"]],["srfi/13"]],
["string-trim-right",">srfi-std/srfi-13.html#string-trim-right",[0,[2,"string-trim-right"]],["srfi/13"]],
["string-unfold",">srfi-std/srfi-13.html#string-unfold",[0,[2,"string-unfold"]],["srfi/13"]],
["string-unfold-right",">srfi-std/srfi-13.html#string-unfold-right",[0,[2,"string-unfold-right"]],["srfi/13"]],
["string-upcase",">reference/strings.html#(def._((quote._~23~25kernel)._string-upcase))",[0,[2,"string-upcase"]],["racket/base","racket"]],
["string-upcase",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_36",[0,[2,"string-upcase"]],["rnrs/unicode-6"]],
["string-upcase",">srfi-std/srfi-13.html#string-upcase",[0,[2,"string-upcase"]],["srfi/13"]],
["string-upcase!",">srfi-std/srfi-13.html#string-upcase!",[0,[2,"string-upcase!"]],["srfi/13"]],
["string-upper-case?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._string-upper-case~3f))",[0,[2,"string-upper-case?"]],["lang/htdp-advanced"]],
["string-upper-case?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._string-upper-case~3f))",[0,[2,"string-upper-case?"]],["lang/htdp-beginner"]],
["string-upper-case?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._string-upper-case~3f))",[0,[2,"string-upper-case?"]],["lang/htdp-beginner-abbr"]],
["string-upper-case?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._string-upper-case~3f))",[0,[2,"string-upper-case?"]],["lang/htdp-intermediate"]],
["string-upper-case?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._string-upper-case~3f))",[0,[2,"string-upper-case?"]],["lang/htdp-intermediate-lambda"]],
["string-uppercase!",">mzlib/mzlib_string.html#(def._((lib._mzlib/string..rkt)._string-uppercase!))",[0,[2,"string-uppercase!"]],["mzlib/string"]],
["string-utf-8-length",">reference/bytestrings.html#(def._((quote._~23~25kernel)._string-utf-8-length))",[0,[2,"string-utf-8-length"]],["racket/base","racket"]],
["string-whitespace?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._string-whitespace~3f))",[0,[2,"string-whitespace?"]],["lang/htdp-advanced"]],
["string-whitespace?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._string-whitespace~3f))",[0,[2,"string-whitespace?"]],["lang/htdp-beginner"]],
["string-whitespace?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._string-whitespace~3f))",[0,[2,"string-whitespace?"]],["lang/htdp-beginner-abbr"]],
["string-whitespace?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._string-whitespace~3f))",[0,[2,"string-whitespace?"]],["lang/htdp-intermediate"]],
["string-whitespace?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._string-whitespace~3f))",[0,[2,"string-whitespace?"]],["lang/htdp-intermediate-lambda"]],
["string-xcopy!",">srfi-std/srfi-13.html#string-xcopy!",[0,[2,"string-xcopy!"]],["srfi/13"]],
["string<",">srfi-std/srfi-13.html#string<",[0,[2,"string<"]],["srfi/13"]],
["string<=",">srfi-std/srfi-13.html#string<=",[0,[2,"string<="]],["srfi/13"]],
["string<=?",">reference/strings.html#(def._((quote._~23~25kernel)._string~3c~3d~3f))",[0,[2,"string<=?"]],["racket/base","racket"]],
["string<=?",">r5rs-std/r5rs-Z-H-9.html#%_idx_530",[0,[2,"string<=?"]],["r5rs"]],
["string<=?",">r6rs-std/r6rs-Z-H-14.html#node_idx_704",[0,[2,"string<=?"]],["rnrs/base-6"]],
["string<=?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._string~3c~3d~3f))",[0,[2,"string<=?"]],["lang/htdp-advanced"]],
["string<=?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._string~3c~3d~3f))",[0,[2,"string<=?"]],["lang/htdp-beginner"]],
["string<=?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._string~3c~3d~3f))",[0,[2,"string<=?"]],["lang/htdp-beginner-abbr"]],
["string<=?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._string~3c~3d~3f))",[0,[2,"string<=?"]],["lang/htdp-intermediate"]],
["string<=?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._string~3c~3d~3f))",[0,[2,"string<=?"]],["lang/htdp-intermediate-lambda"]],
["string<=?",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._string~3c~3d~3f))",[0,[2,"string<=?"]],["deinprogramm/DMdA-advanced"]],
["string<=?",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._string~3c~3d~3f))",[0,[2,"string<=?"]],["deinprogramm/DMdA-assignments"]],
["string<=?",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._string~3c~3d~3f))",[0,[2,"string<=?"]],["deinprogramm/DMdA-beginner"]],
["string<=?",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._string~3c~3d~3f))",[0,[2,"string<=?"]],["deinprogramm/DMdA-vanilla"]],
["string<>",">srfi-std/srfi-13.html#string<>",[0,[2,"string<>"]],["srfi/13"]],
["string<?",">reference/strings.html#(def._((quote._~23~25kernel)._string~3c~3f))",[0,[2,"string<?"]],["racket/base","racket"]],
["string<?",">r5rs-std/r5rs-Z-H-9.html#%_idx_526",[0,[2,"string<?"]],["r5rs"]],
["string<?",">r6rs-std/r6rs-Z-H-14.html#node_idx_700",[0,[2,"string<?"]],["rnrs/base-6"]],
["string<?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._string~3c~3f))",[0,[2,"string<?"]],["lang/htdp-advanced"]],
["string<?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._string~3c~3f))",[0,[2,"string<?"]],["lang/htdp-beginner"]],
["string<?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._string~3c~3f))",[0,[2,"string<?"]],["lang/htdp-beginner-abbr"]],
["string<?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._string~3c~3f))",[0,[2,"string<?"]],["lang/htdp-intermediate"]],
["string<?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._string~3c~3f))",[0,[2,"string<?"]],["lang/htdp-intermediate-lambda"]],
["string<?",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._string~3c~3f))",[0,[2,"string<?"]],["deinprogramm/DMdA-advanced"]],
["string<?",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._string~3c~3f))",[0,[2,"string<?"]],["deinprogramm/DMdA-assignments"]],
["string<?",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._string~3c~3f))",[0,[2,"string<?"]],["deinprogramm/DMdA-beginner"]],
["string<?",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._string~3c~3f))",[0,[2,"string<?"]],["deinprogramm/DMdA-vanilla"]],
["string=",">srfi-std/srfi-13.html#string=",[0,[2,"string="]],["srfi/13"]],
["string=?",">reference/strings.html#(def._((quote._~23~25kernel)._string~3d~3f))",[0,[2,"string=?"]],["racket/base","racket"]],
["string=?",">r5rs-std/r5rs-Z-H-9.html#%_idx_522",[0,[2,"string=?"]],["r5rs"]],
["string=?",">r6rs-std/r6rs-Z-H-14.html#node_idx_698",[0,[2,"string=?"]],["rnrs/base-6"]],
["string=?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._string~3d~3f))",[0,[2,"string=?"]],["lang/htdp-advanced"]],
["string=?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._string~3d~3f))",[0,[2,"string=?"]],["lang/htdp-beginner"]],
["string=?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._string~3d~3f))",[0,[2,"string=?"]],["lang/htdp-beginner-abbr"]],
["string=?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._string~3d~3f))",[0,[2,"string=?"]],["lang/htdp-intermediate"]],
["string=?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._string~3d~3f))",[0,[2,"string=?"]],["lang/htdp-intermediate-lambda"]],
["string=?",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._string~3d~3f))",[0,[2,"string=?"]],["deinprogramm/DMdA-advanced"]],
["string=?",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._string~3d~3f))",[0,[2,"string=?"]],["deinprogramm/DMdA-assignments"]],
["string=?",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._string~3d~3f))",[0,[2,"string=?"]],["deinprogramm/DMdA-beginner"]],
["string=?",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._string~3d~3f))",[0,[2,"string=?"]],["deinprogramm/DMdA-vanilla"]],
["string>",">srfi-std/srfi-13.html#string>",[0,[2,"string>"]],["srfi/13"]],
["string>=",">srfi-std/srfi-13.html#string>=",[0,[2,"string>="]],["srfi/13"]],
["string>=?",">reference/strings.html#(def._((quote._~23~25kernel)._string~3e~3d~3f))",[0,[2,"string>=?"]],["racket/base","racket"]],
["string>=?",">r5rs-std/r5rs-Z-H-9.html#%_idx_532",[0,[2,"string>=?"]],["r5rs"]],
["string>=?",">r6rs-std/r6rs-Z-H-14.html#node_idx_706",[0,[2,"string>=?"]],["rnrs/base-6"]],
["string>=?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._string~3e~3d~3f))",[0,[2,"string>=?"]],["lang/htdp-advanced"]],
["string>=?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._string~3e~3d~3f))",[0,[2,"string>=?"]],["lang/htdp-beginner"]],
["string>=?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._string~3e~3d~3f))",[0,[2,"string>=?"]],["lang/htdp-beginner-abbr"]],
["string>=?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._string~3e~3d~3f))",[0,[2,"string>=?"]],["lang/htdp-intermediate"]],
["string>=?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._string~3e~3d~3f))",[0,[2,"string>=?"]],["lang/htdp-intermediate-lambda"]],
["string>=?",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._string~3e~3d~3f))",[0,[2,"string>=?"]],["deinprogramm/DMdA-advanced"]],
["string>=?",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._string~3e~3d~3f))",[0,[2,"string>=?"]],["deinprogramm/DMdA-assignments"]],
["string>=?",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._string~3e~3d~3f))",[0,[2,"string>=?"]],["deinprogramm/DMdA-beginner"]],
["string>=?",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._string~3e~3d~3f))",[0,[2,"string>=?"]],["deinprogramm/DMdA-vanilla"]],
["string>?",">reference/strings.html#(def._((quote._~23~25kernel)._string~3e~3f))",[0,[2,"string>?"]],["racket/base","racket"]],
["string>?",">r5rs-std/r5rs-Z-H-9.html#%_idx_528",[0,[2,"string>?"]],["r5rs"]],
["string>?",">r6rs-std/r6rs-Z-H-14.html#node_idx_702",[0,[2,"string>?"]],["rnrs/base-6"]],
["string>?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._string~3e~3f))",[0,[2,"string>?"]],["lang/htdp-advanced"]],
["string>?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._string~3e~3f))",[0,[2,"string>?"]],["lang/htdp-beginner"]],
["string>?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._string~3e~3f))",[0,[2,"string>?"]],["lang/htdp-beginner-abbr"]],
["string>?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._string~3e~3f))",[0,[2,"string>?"]],["lang/htdp-intermediate"]],
["string>?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._string~3e~3f))",[0,[2,"string>?"]],["lang/htdp-intermediate-lambda"]],
["string>?",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._string~3e~3f))",[0,[2,"string>?"]],["deinprogramm/DMdA-advanced"]],
["string>?",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._string~3e~3f))",[0,[2,"string>?"]],["deinprogramm/DMdA-assignments"]],
["string>?",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._string~3e~3f))",[0,[2,"string>?"]],["deinprogramm/DMdA-beginner"]],
["string>?",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._string~3e~3f))",[0,[2,"string>?"]],["deinprogramm/DMdA-vanilla"]],
["string?",">reference/strings.html#(def._((quote._~23~25kernel)._string~3f))",[0,[2,"string?"]],["racket/base","racket"]],
["string?",">r5rs-std/r5rs-Z-H-9.html#%_idx_508",[0,[2,"string?"]],["r5rs"]],
["string?",">r6rs-std/r6rs-Z-H-14.html#node_idx_686",[0,[2,"string?"]],["rnrs/base-6"]],
["string?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._string~3f))",[0,[2,"string?"]],["lang/htdp-advanced"]],
["string?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._string~3f))",[0,[2,"string?"]],["lang/htdp-beginner"]],
["string?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._string~3f))",[0,[2,"string?"]],["lang/htdp-beginner-abbr"]],
["string?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._string~3f))",[0,[2,"string?"]],["lang/htdp-intermediate"]],
["string?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._string~3f))",[0,[2,"string?"]],["lang/htdp-intermediate-lambda"]],
["string?",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._string~3f))",[0,[2,"string?"]],["deinprogramm/DMdA-advanced"]],
["string?",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._string~3f))",[0,[2,"string?"]],["deinprogramm/DMdA-assignments"]],
["string?",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._string~3f))",[0,[2,"string?"]],["deinprogramm/DMdA-beginner"]],
["string?",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._string~3f))",[0,[2,"string?"]],["deinprogramm/DMdA-vanilla"]],
["string?",">srfi-std/srfi-13.html#string-p",[0,[2,"string?"]],["srfi/13"]],
["stringconstants",">string-constants/index.html#(idx._(gentag._1._(lib._string-constants/string-constants..scrbl)))",[6,"STRINGCONSTANTS"],false],
["strings pattern matching",">reference/regexp.html","strings, pattern matching",false],
["strings parsing",">reference/reader.html#(idx._(gentag._33._(lib._scribblings/reference/reference..scrbl)))","strings, parsing",false],
["strings immutable",">reference/strings.html#(idx._(gentag._109._(lib._scribblings/reference/reference..scrbl)))","strings, immutable",false],
["strings conversion to c",">inside/im_values_types.html#(idx._(gentag._54._(lib._scribblings/inside/inside..scrbl)))","strings, conversion to C",false],
["strings conversion to c",">inside/im_values_types.html#(idx._(gentag._63._(lib._scribblings/inside/inside..scrbl)))","strings, conversion to C",false],
["strings concatenate",">reference/strings.html#(idx._(gentag._110._(lib._scribblings/reference/reference..scrbl)))","strings, concatenate",false],
["strings",">graphics/Draw__Clear__and_Flip_Operations.html#(part._.Strings)","Strings",false],
["strings",">htdp-langs/advanced.html#(part._htdp-advanced._.Strings)","Strings",false],
["strings",">htdp-langs/beginner.html#(part._htdp-beginner._.Strings)","Strings",false],
["strings",">htdp-langs/beginner-abbr.html#(part._htdp-beginner-abbr._.Strings)","Strings",false],
["strings",">htdp-langs/intermediate.html#(part._htdp-intermediate._.Strings)","Strings",false],
["strings",">htdp-langs/intermediate-lam.html#(part._htdp-intermediate-lambda._.Strings)","Strings",false],
["strings",">inside/im_values_types.html#(part._im~3astrings)","Strings",false],
["strings",">reference/strings.html","Strings",false],
["strings",">unstable/string.html","Strings",false],
["strings (unicode)",">guide/strings.html","Strings (Unicode)",false],
["strings-list->string",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._strings-list-~3estring))",[0,[2,"strings-list->string"]],["deinprogramm/DMdA-advanced"]],
["strings-list->string",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._strings-list-~3estring))",[0,[2,"strings-list->string"]],["deinprogramm/DMdA-assignments"]],
["strings-list->string",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._strings-list-~3estring))",[0,[2,"strings-list->string"]],["deinprogramm/DMdA-beginner"]],
["strings-list->string",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._strings-list-~3estring))",[0,[2,"strings-list->string"]],["deinprogramm/DMdA-vanilla"]],
["strip-context",">syntax/syntax-helpers.html#(def._((lib._syntax/strip-context..rkt)._strip-context))",[0,[2,"strip-context"]],["syntax/strip-context"]],
["strip-prefix-ups",">web-server-internal/misc-util.html#(def._((lib._web-server/private/util..rkt)._strip-prefix-ups))",[0,[2,"strip-prefix-ups"]],["web-server/private/util"]],
["strip-shell-command-start",">mzlib/mzlib_port.html#(def._((lib._mzlib/port..rkt)._strip-shell-command-start))",[0,[2,"strip-shell-command-start"]],["mzlib/port"]],
["strong",">html/index.html#(def._((lib._html/main..rkt)._strong))",[0,[2,"strong"]],["html"]],
["strong?",">html/index.html#(def._((lib._html/main..rkt)._strong~3f))",[0,[2,"strong?"]],["html"]],
["struct",">reference/define-struct.html#(form._((lib._racket/private/base..rkt)._struct))",[0,[1,"struct"]],["racket/base","racket"]],
["struct",">mzlib/mzlib_unit.html#(form._((lib._mzlib/unit..rkt)._struct))",[0,[1,"struct"]],["mzlib/unit"]],
["struct",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types-extra..rkt)._.Struct))",[0,[1,"Struct"]],["typed/racket/base","typed/racket"]],
["struct",">ts-reference/special-forms.html#(idx._(gentag._0._(lib._typed-racket/scribblings/ts-reference..scrbl)))","struct",false],
["struct type and accessors",">images/Struct_Type_and_Accessors.html","Struct Type and Accessors",false],
["struct*",">reference/match.html#(form._((lib._racket/match..rkt)._struct*))",[0,[1,"struct*"]],["racket/match","racket"]],
["struct->list",">unstable/struct.html#(def._((lib._unstable/struct..rkt)._struct-~3elist))",[0,[2,"struct->list"]],["unstable/struct"]],
["struct->vector",">reference/structutils.html#(def._((quote._~23~25kernel)._struct-~3evector))",[0,[2,"struct->vector"]],["racket/base","racket"]],
["struct-accessor-procedure?",">reference/structutils.html#(def._((quote._~23~25kernel)._struct-accessor-procedure~3f))",[0,[2,"struct-accessor-procedure?"]],["racket/base","racket"]],
["struct-auto-info-lists",">reference/structinfo.html#(def._((lib._racket/struct-info..rkt)._struct-auto-info-lists))",[0,[2,"struct-auto-info-lists"]],["racket/struct-info"]],
["struct-auto-info?",">reference/structinfo.html#(def._((lib._racket/struct-info..rkt)._struct-auto-info~3f))",[0,[2,"struct-auto-info?"]],["racket/struct-info"]],
["struct-constructor-procedure?",">reference/structutils.html#(def._((quote._~23~25kernel)._struct-constructor-procedure~3f))",[0,[2,"struct-constructor-procedure?"]],["racket/base","racket"]],
["struct-copy",">reference/struct-copy.html#(form._((lib._racket/private/base..rkt)._struct-copy))",[0,[1,"struct-copy"]],["racket/base","racket"]],
["struct-declaration-info?",">syntax/transformer-helpers.html#(def._((lib._syntax/struct..rkt)._struct-declaration-info~3f))",[0,[2,"struct-declaration-info?"]],["syntax/struct"]],
["struct-field-index",">reference/define-struct.html#(form._((lib._racket/private/base..rkt)._struct-field-index))",[0,[1,"struct-field-index"]],["racket/base","racket"]],
["struct-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..rkt)._struct-index-desc))",[0,[2,"struct-index-desc"]],["scribble/manual-struct"]],
["struct-index-desc?",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..rkt)._struct-index-desc~3f))",[0,[2,"struct-index-desc?"]],["scribble/manual-struct"]],
["struct-info",">reference/inspectors.html#(def._((quote._~23~25kernel)._struct-info))",[0,[2,"struct-info"]],["racket/base","racket"]],
["struct-info?",">reference/structinfo.html#(def._((lib._racket/struct-info..rkt)._struct-info~3f))",[0,[2,"struct-info?"]],["racket/struct-info"]],
["struct-mutator-procedure?",">reference/structutils.html#(def._((quote._~23~25kernel)._struct-mutator-procedure~3f))",[0,[2,"struct-mutator-procedure?"]],["racket/base","racket"]],
["struct-out",">reference/require.html#(form._((lib._racket/private/base..rkt)._struct-out))",[0,[1,"struct-out"]],["racket/base","racket"]],
["struct-predicate-procedure?",">reference/structutils.html#(def._((quote._~23~25kernel)._struct-predicate-procedure~3f))",[0,[2,"struct-predicate-procedure?"]],["racket/base","racket"]],
["struct-type-info",">reference/inspectors.html#(def._((quote._~23~25kernel)._struct-type-info))",[0,[2,"struct-type-info"]],["racket/base","racket"]],
["struct-type-make-constructor",">reference/inspectors.html#(def._((quote._~23~25kernel)._struct-type-make-constructor))",[0,[2,"struct-type-make-constructor"]],["racket/base","racket"]],
["struct-type-make-predicate",">reference/inspectors.html#(def._((quote._~23~25kernel)._struct-type-make-predicate))",[0,[2,"struct-type-make-predicate"]],["racket/base","racket"]],
["struct-type-property",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Struct-.Type-.Property))",[0,[1,"Struct-Type-Property"]],["typed/racket/base","typed/racket"]],
["struct-type-property-accessor-procedure?",">reference/structprops.html#(def._((quote._~23~25kernel)._struct-type-property-accessor-procedure~3f))",[0,[2,"struct-type-property-accessor-procedure?"]],["racket/base","racket"]],
["struct-type-property/c",">reference/Structure_Type_Property_Contracts.html#(def._((lib._racket/contract..rkt)._struct-type-property/c))",[0,[2,"struct-type-property/c"]],["racket/contract","racket"]],
["struct-type-property?",">reference/structprops.html#(def._((quote._~23~25kernel)._struct-type-property~3f))",[0,[2,"struct-type-property?"]],["racket/base","racket"]],
["struct-type?",">reference/structutils.html#(def._((quote._~23~25kernel)._struct-type~3f))",[0,[2,"struct-type?"]],["racket/base","racket"]],
["struct/c",">reference/data-structure-contracts.html#(form._((lib._racket/contract/private/struct-dc..rkt)._struct/c))",[0,[1,"struct/c"]],["racket/contract/base","racket/contract","racket"]],
["struct/c",">mzlib/mzlib_contract.html#(form._((lib._mzlib/contract..rkt)._struct/c))",[0,[1,"struct/c"]],["mzlib/contract"]],
["struct/ctc",">reference/define-sig-form.html#(form._((lib._racket/unit..rkt)._struct/ctc))",[0,[1,"struct/ctc"]],["racket/unit","racket"]],
["struct/ctc",">mzlib/mzlib_unit.html#(form._((lib._mzlib/unit..rkt)._struct/ctc))",[0,[1,"struct/ctc"]],["mzlib/unit"]],
["struct/dc",">reference/data-structure-contracts.html#(form._((lib._racket/contract/private/struct-dc..rkt)._struct/dc))",[0,[1,"struct/dc"]],["racket/contract/base","racket/contract","racket"]],
["struct:",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._struct~3a))",[0,[1,"struct:"]],["typed/racket/base","typed/racket"]],
["struct:-map",">html/index.html#(def._((lib._html/main..rkt)._struct~3a-map))",[0,[2,"struct:-map"]],["html"]],
["struct:a",">html/index.html#(def._((lib._html/main..rkt)._struct~3aa))",[0,[2,"struct:a"]],["html"]],
["struct:abbr",">html/index.html#(def._((lib._html/main..rkt)._struct~3aabbr))",[0,[2,"struct:abbr"]],["html"]],
["struct:acronym",">html/index.html#(def._((lib._html/main..rkt)._struct~3aacronym))",[0,[2,"struct:acronym"]],["html"]],
["struct:address",">html/index.html#(def._((lib._html/main..rkt)._struct~3aaddress))",[0,[2,"struct:address"]],["html"]],
["struct:alink",">html/index.html#(def._((lib._html/main..rkt)._struct~3aalink))",[0,[2,"struct:alink"]],["html"]],
["struct:all-from-module",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3aall-from-module))",[0,[2,"struct:all-from-module"]],["compiler/zo-structs"]],
["struct:alpha-color",">htdp/index.html#(def._((lib._htdp/color-structs..rkt)._struct~3aalpha-color))",[0,[2,"struct:alpha-color"]],["htdp/color-structs"]],
["struct:alpha-color",">teachpack/image.html#(def._((lib._htdp/image..rkt)._struct~3aalpha-color))",[0,[2,"struct:alpha-color"]],["htdp/image"]],
["struct:alt-tag",">scribble/core.html#(def._((lib._scribble/html-properties..rkt)._struct~3aalt-tag))",[0,[2,"struct:alt-tag"]],["scribble/html-properties"]],
["struct:applet",">html/index.html#(def._((lib._html/main..rkt)._struct~3aapplet))",[0,[2,"struct:applet"]],["html"]],
["struct:application",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3aapplication))",[0,[2,"struct:application"]],["compiler/zo-structs"]],
["struct:apply-values",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3aapply-values))",[0,[2,"struct:apply-values"]],["compiler/zo-structs"]],
["struct:area",">html/index.html#(def._((lib._html/main..rkt)._struct~3aarea))",[0,[2,"struct:area"]],["html"]],
["struct:arity-at-least",">reference/procedures.html#(def._((quote._~23~25kernel)._struct~3aarity-at-least))",[0,[2,"struct:arity-at-least"]],["racket/base","racket"]],
["struct:article-not-found",">net/nntp.html#(def._((lib._net/nntp..rkt)._struct~3aarticle-not-found))",[0,[2,"struct:article-not-found"]],["net/nntp"]],
["struct:article-not-in-group",">net/nntp.html#(def._((lib._net/nntp..rkt)._struct~3aarticle-not-in-group))",[0,[2,"struct:article-not-in-group"]],["net/nntp"]],
["struct:assign",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3aassign))",[0,[2,"struct:assign"]],["compiler/zo-structs"]],
["struct:attribute",">xml/index.html#(def._((lib._xml/main..rkt)._struct~3aattribute))",[0,[2,"struct:attribute"]],["xml"]],
["struct:attributes",">scribble/core.html#(def._((lib._scribble/html-properties..rkt)._struct~3aattributes))",[0,[2,"struct:attributes"]],["scribble/html-properties"]],
["struct:authentication-rejected",">net/nntp.html#(def._((lib._net/nntp..rkt)._struct~3aauthentication-rejected))",[0,[2,"struct:authentication-rejected"]],["net/nntp"]],
["struct:b",">html/index.html#(def._((lib._html/main..rkt)._struct~3ab))",[0,[2,"struct:b"]],["html"]],
["struct:background-color-property",">scribble/core.html#(def._((lib._scribble/core..rkt)._struct~3abackground-color-property))",[0,[2,"struct:background-color-property"]],["scribble/core"]],
["struct:bad-newsgroup-line",">net/nntp.html#(def._((lib._net/nntp..rkt)._struct~3abad-newsgroup-line))",[0,[2,"struct:bad-newsgroup-line"]],["net/nntp"]],
["struct:bad-status-line",">net/nntp.html#(def._((lib._net/nntp..rkt)._struct~3abad-status-line))",[0,[2,"struct:bad-status-line"]],["net/nntp"]],
["struct:base",">html/index.html#(def._((lib._html/main..rkt)._struct~3abase))",[0,[2,"struct:base"]],["html"]],
["struct:basefont",">html/index.html#(def._((lib._html/main..rkt)._struct~3abasefont))",[0,[2,"struct:basefont"]],["html"]],
["struct:bdo",">html/index.html#(def._((lib._html/main..rkt)._struct~3abdo))",[0,[2,"struct:bdo"]],["html"]],
["struct:beg0",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3abeg0))",[0,[2,"struct:beg0"]],["compiler/zo-structs"]],
["struct:bibdb",">scriblib/bibtex.html#(def._((lib._scriblib/bibtex..rkt)._struct~3abibdb))",[0,[2,"struct:bibdb"]],["scriblib/bibtex"]],
["struct:big",">html/index.html#(def._((lib._html/main..rkt)._struct~3abig))",[0,[2,"struct:big"]],["html"]],
["struct:bind",">redex/The_Redex_Reference.html#(def._((lib._redex/reduction-semantics..rkt)._struct~3abind))",[0,[2,"struct:bind"]],["redex/reduction-semantics","redex"]],
["struct:binding",">web-server/http.html#(def._((lib._web-server/http/request-structs..rkt)._struct~3abinding))",[0,[2,"struct:binding"]],["web-server/http/request-structs"]],
["struct:binding:file",">web-server/http.html#(def._((lib._web-server/http/request-structs..rkt)._struct~3abinding~3afile))",[0,[2,"struct:binding:file"]],["web-server/http/request-structs"]],
["struct:binding:form",">web-server/http.html#(def._((lib._web-server/http/request-structs..rkt)._struct~3abinding~3aform))",[0,[2,"struct:binding:form"]],["web-server/http/request-structs"]],
["struct:blockquote",">html/index.html#(def._((lib._html/main..rkt)._struct~3ablockquote))",[0,[2,"struct:blockquote"]],["html"]],
["struct:blog",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/dummy-10..rkt)._struct~3ablog))",[0,[2,"struct:blog"]],[]],
["struct:blog",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-4..rkt)._struct~3ablog))",[0,[2,"struct:blog"]],[]],
["struct:blog",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-9..rkt)._struct~3ablog))",[0,[2,"struct:blog"]],[]],
["struct:body",">html/index.html#(def._((lib._html/main..rkt)._struct~3abody))",[0,[2,"struct:body"]],["html"]],
["struct:body-id",">scribble/core.html#(def._((lib._scribble/html-properties..rkt)._struct~3abody-id))",[0,[2,"struct:body-id"]],["scribble/html-properties"]],
["struct:box-mode",">scribble/core.html#(def._((lib._scribble/core..rkt)._struct~3abox-mode))",[0,[2,"struct:box-mode"]],["scribble/core"]],
["struct:boxenv",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3aboxenv))",[0,[2,"struct:boxenv"]],["compiler/zo-structs"]],
["struct:br",">html/index.html#(def._((lib._html/main..rkt)._struct~3abr))",[0,[2,"struct:br"]],["html"]],
["struct:branch",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3abranch))",[0,[2,"struct:branch"]],["compiler/zo-structs"]],
["struct:brinfo",">tools/Documentation_Utilities.html#(def._((lib._help/bug-report..rkt)._struct~3abrinfo))",[0,[2,"struct:brinfo"]],["help/bug-report"]],
["struct:button",">html/index.html#(def._((lib._html/main..rkt)._struct~3abutton))",[0,[2,"struct:button"]],["html"]],
["struct:cannot-connect",">net/pop3.html#(def._((lib._net/pop3..rkt)._struct~3acannot-connect))",[0,[2,"struct:cannot-connect"]],["net/pop3"]],
["struct:cannot-delete-message",">net/pop3.html#(def._((lib._net/pop3..rkt)._struct~3acannot-delete-message))",[0,[2,"struct:cannot-delete-message"]],["net/pop3"]],
["struct:caption",">html/index.html#(def._((lib._html/main..rkt)._struct~3acaption))",[0,[2,"struct:caption"]],["html"]],
["struct:case-lam",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3acase-lam))",[0,[2,"struct:case-lam"]],["compiler/zo-structs"]],
["struct:cdata",">xml/index.html#(def._((lib._xml/main..rkt)._struct~3acdata))",[0,[2,"struct:cdata"]],["xml"]],
["struct:center",">html/index.html#(def._((lib._html/main..rkt)._struct~3acenter))",[0,[2,"struct:center"]],["html"]],
["struct:check-info",">rackunit/api.html#(def._((lib._rackunit/main..rkt)._struct~3acheck-info))",[0,[2,"struct:check-info"]],["rackunit"]],
["struct:child",">slideshow/Pict_Datatype.html#(def._((lib._slideshow/pict..rkt)._struct~3achild))",[0,[2,"struct:child"]],["slideshow/pict","slideshow"]],
["struct:cite",">html/index.html#(def._((lib._html/main..rkt)._struct~3acite))",[0,[2,"struct:cite"]],["html"]],
["struct:class-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..rkt)._struct~3aclass-index-desc))",[0,[2,"struct:class-index-desc"]],["scribble/manual-struct"]],
["struct:client-cookie",">web-server/http.html#(def._((lib._web-server/http/cookie-parse..rkt)._struct~3aclient-cookie))",[0,[2,"struct:client-cookie"]],["web-server/http/cookie-parse"]],
["struct:closure",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3aclosure))",[0,[2,"struct:closure"]],["compiler/zo-structs"]],
["struct:code",">html/index.html#(def._((lib._html/main..rkt)._struct~3acode))",[0,[2,"struct:code"]],["html"]],
["struct:col",">html/index.html#(def._((lib._html/main..rkt)._struct~3acol))",[0,[2,"struct:col"]],["html"]],
["struct:colgroup",">html/index.html#(def._((lib._html/main..rkt)._struct~3acolgroup))",[0,[2,"struct:colgroup"]],["html"]],
["struct:collect-element",">scribble/core.html#(def._((lib._scribble/core..rkt)._struct~3acollect-element))",[0,[2,"struct:collect-element"]],["scribble/core"]],
["struct:collect-info",">scribble/core.html#(def._((lib._scribble/core..rkt)._struct~3acollect-info))",[0,[2,"struct:collect-info"]],["scribble/core"]],
["struct:collected-info",">scribble/core.html#(def._((lib._scribble/core..rkt)._struct~3acollected-info))",[0,[2,"struct:collected-info"]],["scribble/core"]],
["struct:color",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._struct~3acolor))",[0,[2,"struct:color"]],["2htdp/image"]],
["struct:color",">htdp/index.html#(def._((lib._htdp/color-structs..rkt)._struct~3acolor))",[0,[2,"struct:color"]],["htdp/color-structs"]],
["struct:color",">teachpack/image.html#(def._((lib._htdp/image..rkt)._struct~3acolor))",[0,[2,"struct:color"]],["htdp/image"]],
["struct:color-property",">scribble/core.html#(def._((lib._scribble/core..rkt)._struct~3acolor-property))",[0,[2,"struct:color-property"]],["scribble/core"]],
["struct:column-attributes",">scribble/core.html#(def._((lib._scribble/html-properties..rkt)._struct~3acolumn-attributes))",[0,[2,"struct:column-attributes"]],["scribble/html-properties"]],
["struct:comment",">xml/index.html#(def._((lib._xml/main..rkt)._struct~3acomment))",[0,[2,"struct:comment"]],["xml"]],
["struct:communicator",">net/nntp.html#(def._((lib._net/nntp..rkt)._struct~3acommunicator))",[0,[2,"struct:communicator"]],["net/nntp"]],
["struct:communicator",">net/pop3.html#(def._((lib._net/pop3..rkt)._struct~3acommunicator))",[0,[2,"struct:communicator"]],["net/pop3"]],
["struct:compilation-top",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3acompilation-top))",[0,[2,"struct:compilation-top"]],["compiler/zo-structs"]],
["struct:compound-paragraph",">scribble/core.html#(def._((lib._scribble/core..rkt)._struct~3acompound-paragraph))",[0,[2,"struct:compound-paragraph"]],["scribble/core"]],
["struct:configuration-table",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._struct~3aconfiguration-table))",[0,[2,"struct:configuration-table"]],["web-server/configuration/configuration-table-structs"]],
["struct:connection",">web-server-internal/connection-manager.html#(def._((lib._web-server/private/connection-manager..rkt)._struct~3aconnection))",[0,[2,"struct:connection"]],["web-server/private/connection-manager"]],
["struct:cookie-error",">net/cookie.html#(def._((lib._net/cookie..rkt)._struct~3acookie-error))",[0,[2,"struct:cookie-error"]],["net/cookie"]],
["struct:counterexample",">redex/The_Redex_Reference.html#(def._((lib._redex/reduction-semantics..rkt)._struct~3acounterexample))",[0,[2,"struct:counterexample"]],["redex/reduction-semantics","redex"]],
["struct:css-addition",">scribble/core.html#(def._((lib._scribble/html-properties..rkt)._struct~3acss-addition))",[0,[2,"struct:css-addition"]],["scribble/html-properties"]],
["struct:data-set",">mrlib/Plot.html#(def._((lib._mrlib/plot..rkt)._struct~3adata-set))",[0,[2,"struct:data-set"]],["mrlib/plot"]],
["struct:data-source",">db/connect.html#(def._((lib._db/base..rkt)._struct~3adata-source))",[0,[2,"struct:data-source"]],["db","db/base"]],
["struct:date",">reference/time.html#(def._((quote._~23~25kernel)._struct~3adate))",[0,[2,"struct:date"]],["racket/base","racket"]],
["struct:date*",">reference/time.html#(def._((quote._~23~25kernel)._struct~3adate*))",[0,[2,"struct:date*"]],["racket/base","racket"]],
["struct:dd",">html/index.html#(def._((lib._html/main..rkt)._struct~3add))",[0,[2,"struct:dd"]],["html"]],
["struct:def-syntaxes",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3adef-syntaxes))",[0,[2,"struct:def-syntaxes"]],["compiler/zo-structs"]],
["struct:def-values",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3adef-values))",[0,[2,"struct:def-values"]],["compiler/zo-structs"]],
["struct:del",">html/index.html#(def._((lib._html/main..rkt)._struct~3adel))",[0,[2,"struct:del"]],["html"]],
["struct:delayed-block",">scribble/core.html#(def._((lib._scribble/core..rkt)._struct~3adelayed-block))",[0,[2,"struct:delayed-block"]],["scribble/core"]],
["struct:delayed-element",">scribble/core.html#(def._((lib._scribble/core..rkt)._struct~3adelayed-element))",[0,[2,"struct:delayed-element"]],["scribble/core"]],
["struct:dfn",">html/index.html#(def._((lib._html/main..rkt)._struct~3adfn))",[0,[2,"struct:dfn"]],["html"]],
["struct:dir",">teachpack/dir.html#(def._((lib._htdp/dir..rkt)._struct~3adir))",[0,[2,"struct:dir"]],["htdp/dir"]],
["struct:dir",">html/index.html#(def._((lib._html/main..rkt)._struct~3adir))",[0,[2,"struct:dir"]],["html"]],
["struct:directory-record",">raco/getinfo.html#(def._((lib._setup/getinfo..rkt)._struct~3adirectory-record))",[0,[2,"struct:directory-record"]],["setup/getinfo"]],
["struct:disconnect-not-quiet",">net/pop3.html#(def._((lib._net/pop3..rkt)._struct~3adisconnect-not-quiet))",[0,[2,"struct:disconnect-not-quiet"]],["net/pop3"]],
["struct:disposition",">net/mime.html#(def._((lib._net/mime..rkt)._struct~3adisposition))",[0,[2,"struct:disposition"]],["net/mime"]],
["struct:div",">html/index.html#(def._((lib._html/main..rkt)._struct~3adiv))",[0,[2,"struct:div"]],["html"]],
["struct:dl",">html/index.html#(def._((lib._html/main..rkt)._struct~3adl))",[0,[2,"struct:dl"]],["html"]],
["struct:document",">xml/index.html#(def._((lib._xml/main..rkt)._struct~3adocument))",[0,[2,"struct:document"]],["xml"]],
["struct:document-date",">scribble/core.html#(def._((lib._scribble/core..rkt)._struct~3adocument-date))",[0,[2,"struct:document-date"]],["scribble/core"]],
["struct:document-type",">xml/index.html#(def._((lib._xml/main..rkt)._struct~3adocument-type))",[0,[2,"struct:document-type"]],["xml"]],
["struct:document-version",">scribble/core.html#(def._((lib._scribble/core..rkt)._struct~3adocument-version))",[0,[2,"struct:document-version"]],["scribble/core"]],
["struct:dt",">html/index.html#(def._((lib._html/main..rkt)._struct~3adt))",[0,[2,"struct:dt"]],["html"]],
["struct:edge",">profile/index.html#(def._((lib._profile/analyzer..rkt)._struct~3aedge))",[0,[2,"struct:edge"]],["profile/analyzer"]],
["struct:element",">scribble/core.html#(def._((lib._scribble/core..rkt)._struct~3aelement))",[0,[2,"struct:element"]],["scribble/core"]],
["struct:element",">xml/index.html#(def._((lib._xml/main..rkt)._struct~3aelement))",[0,[2,"struct:element"]],["xml"]],
["struct:em",">html/index.html#(def._((lib._html/main..rkt)._struct~3aem))",[0,[2,"struct:em"]],["html"]],
["struct:empty-disposition-type",">net/mime.html#(def._((lib._net/mime..rkt)._struct~3aempty-disposition-type))",[0,[2,"struct:empty-disposition-type"]],["net/mime"]],
["struct:empty-mechanism",">net/mime.html#(def._((lib._net/mime..rkt)._struct~3aempty-mechanism))",[0,[2,"struct:empty-mechanism"]],["net/mime"]],
["struct:empty-subtype",">net/mime.html#(def._((lib._net/mime..rkt)._struct~3aempty-subtype))",[0,[2,"struct:empty-subtype"]],["net/mime"]],
["struct:empty-type",">net/mime.html#(def._((lib._net/mime..rkt)._struct~3aempty-type))",[0,[2,"struct:empty-type"]],["net/mime"]],
["struct:entity",">net/mime.html#(def._((lib._net/mime..rkt)._struct~3aentity))",[0,[2,"struct:entity"]],["net/mime"]],
["struct:entity",">xml/index.html#(def._((lib._xml/main..rkt)._struct~3aentity))",[0,[2,"struct:entity"]],["xml"]],
["struct:entry",">scribble/xref.html#(def._((lib._scribble/xref..rkt)._struct~3aentry))",[0,[2,"struct:entry"]],["scribble/xref"]],
["struct:exn",">reference/exns.html#(def._((quote._~23~25kernel)._struct~3aexn))",[0,[2,"struct:exn"]],["racket/base","racket"]],
["struct:exn:break",">reference/exns.html#(def._((quote._~23~25kernel)._struct~3aexn~3abreak))",[0,[2,"struct:exn:break"]],["racket/base","racket"]],
["struct:exn:cancelled",">browser/index.html#(def._((lib._browser/browser..rkt)._struct~3aexn~3acancelled))",[0,[2,"struct:exn:cancelled"]],["browser/browser","browser"]],
["struct:exn:dispatcher",">web-server-internal/dispatch.html#(def._((lib._web-server/dispatchers/dispatch..rkt)._struct~3aexn~3adispatcher))",[0,[2,"struct:exn:dispatcher"]],["web-server/dispatchers/dispatch"]],
["struct:exn:fail",">reference/exns.html#(def._((quote._~23~25kernel)._struct~3aexn~3afail))",[0,[2,"struct:exn:fail"]],["racket/base","racket"]],
["struct:exn:fail:contract",">reference/exns.html#(def._((quote._~23~25kernel)._struct~3aexn~3afail~3acontract))",[0,[2,"struct:exn:fail:contract"]],["racket/base","racket"]],
["struct:exn:fail:contract:arity",">reference/exns.html#(def._((quote._~23~25kernel)._struct~3aexn~3afail~3acontract~3aarity))",[0,[2,"struct:exn:fail:contract:arity"]],["racket/base","racket"]],
["struct:exn:fail:contract:blame",">reference/Building_New_Contract_Combinators.html#(def._((lib._racket/contract/private/blame..rkt)._struct~3aexn~3afail~3acontract~3ablame))",[0,[2,"struct:exn:fail:contract:blame"]],["racket/contract/combinator","racket/contract","racket"]],
["struct:exn:fail:contract:continuation",">reference/exns.html#(def._((quote._~23~25kernel)._struct~3aexn~3afail~3acontract~3acontinuation))",[0,[2,"struct:exn:fail:contract:continuation"]],["racket/base","racket"]],
["struct:exn:fail:contract:divide-by-zero",">reference/exns.html#(def._((quote._~23~25kernel)._struct~3aexn~3afail~3acontract~3adivide-by-zero))",[0,[2,"struct:exn:fail:contract:divide-by-zero"]],["racket/base","racket"]],
["struct:exn:fail:contract:non-fixnum-result",">reference/exns.html#(def._((quote._~23~25kernel)._struct~3aexn~3afail~3acontract~3anon-fixnum-result))",[0,[2,"struct:exn:fail:contract:non-fixnum-result"]],["racket/base","racket"]],
["struct:exn:fail:contract:variable",">reference/exns.html#(def._((quote._~23~25kernel)._struct~3aexn~3afail~3acontract~3avariable))",[0,[2,"struct:exn:fail:contract:variable"]],["racket/base","racket"]],
["struct:exn:fail:filesystem",">reference/exns.html#(def._((quote._~23~25kernel)._struct~3aexn~3afail~3afilesystem))",[0,[2,"struct:exn:fail:filesystem"]],["racket/base","racket"]],
["struct:exn:fail:filesystem:exists",">reference/exns.html#(def._((quote._~23~25kernel)._struct~3aexn~3afail~3afilesystem~3aexists))",[0,[2,"struct:exn:fail:filesystem:exists"]],["racket/base","racket"]],
["struct:exn:fail:filesystem:version",">reference/exns.html#(def._((quote._~23~25kernel)._struct~3aexn~3afail~3afilesystem~3aversion))",[0,[2,"struct:exn:fail:filesystem:version"]],["racket/base","racket"]],
["struct:exn:fail:make",">make/make.html#(def._((lib._make/main..rkt)._struct~3aexn~3afail~3amake))",[0,[2,"struct:exn:fail:make"]],["make"]],
["struct:exn:fail:network",">reference/exns.html#(def._((quote._~23~25kernel)._struct~3aexn~3afail~3anetwork))",[0,[2,"struct:exn:fail:network"]],["racket/base","racket"]],
["struct:exn:fail:object",">reference/objectutils.html#(def._((lib._racket/private/class-internal..rkt)._struct~3aexn~3afail~3aobject))",[0,[2,"struct:exn:fail:object"]],["racket/class","racket"]],
["struct:exn:fail:out-of-memory",">reference/exns.html#(def._((quote._~23~25kernel)._struct~3aexn~3afail~3aout-of-memory))",[0,[2,"struct:exn:fail:out-of-memory"]],["racket/base","racket"]],
["struct:exn:fail:planet",">planet/Utility_Libraries.html#(def._((lib._planet/util..rkt)._struct~3aexn~3afail~3aplanet))",[0,[2,"struct:exn:fail:planet"]],["planet/util"]],
["struct:exn:fail:read",">reference/exns.html#(def._((quote._~23~25kernel)._struct~3aexn~3afail~3aread))",[0,[2,"struct:exn:fail:read"]],["racket/base","racket"]],
["struct:exn:fail:read:eof",">reference/exns.html#(def._((quote._~23~25kernel)._struct~3aexn~3afail~3aread~3aeof))",[0,[2,"struct:exn:fail:read:eof"]],["racket/base","racket"]],
["struct:exn:fail:read:non-char",">reference/exns.html#(def._((quote._~23~25kernel)._struct~3aexn~3afail~3aread~3anon-char))",[0,[2,"struct:exn:fail:read:non-char"]],["racket/base","racket"]],
["struct:exn:fail:redex:test",">redex/The_Redex_Reference.html#(def._((lib._redex/reduction-semantics..rkt)._struct~3aexn~3afail~3aredex~3atest))",[0,[2,"struct:exn:fail:redex:test"]],["redex/reduction-semantics","redex"]],
["struct:exn:fail:servlet-manager:no-continuation",">web-server/servlet.html#(def._((lib._web-server/managers/manager..rkt)._struct~3aexn~3afail~3aservlet-manager~3ano-continuation))",[0,[2,"struct:exn:fail:servlet-manager:no-continuation"]],["web-server/managers/manager"]],
["struct:exn:fail:servlet-manager:no-instance",">web-server/servlet.html#(def._((lib._web-server/managers/manager..rkt)._struct~3aexn~3afail~3aservlet-manager~3ano-instance))",[0,[2,"struct:exn:fail:servlet-manager:no-instance"]],["web-server/managers/manager"]],
["struct:exn:fail:sql",">db/query-api.html#(def._((lib._db/base..rkt)._struct~3aexn~3afail~3asql))",[0,[2,"struct:exn:fail:sql"]],["db","db/base"]],
["struct:exn:fail:syntax",">reference/exns.html#(def._((quote._~23~25kernel)._struct~3aexn~3afail~3asyntax))",[0,[2,"struct:exn:fail:syntax"]],["racket/base","racket"]],
["struct:exn:fail:syntax:unbound",">reference/exns.html#(def._((quote._~23~25kernel)._struct~3aexn~3afail~3asyntax~3aunbound))",[0,[2,"struct:exn:fail:syntax:unbound"]],["racket/base","racket"]],
["struct:exn:fail:unsupported",">reference/exns.html#(def._((quote._~23~25kernel)._struct~3aexn~3afail~3aunsupported))",[0,[2,"struct:exn:fail:unsupported"]],["racket/base","racket"]],
["struct:exn:fail:user",">reference/exns.html#(def._((quote._~23~25kernel)._struct~3aexn~3afail~3auser))",[0,[2,"struct:exn:fail:user"]],["racket/base","racket"]],
["struct:exn:file-saved-instead",">browser/index.html#(def._((lib._browser/browser..rkt)._struct~3aexn~3afile-saved-instead))",[0,[2,"struct:exn:file-saved-instead"]],["browser/browser","browser"]],
["struct:exn:get-module-code",">syntax/module-helpers.html#(def._((lib._syntax/modcode..rkt)._struct~3aexn~3aget-module-code))",[0,[2,"struct:exn:get-module-code"]],["syntax/modcode"]],
["struct:exn:invalid-xexpr",">xml/index.html#(def._((lib._xml/main..rkt)._struct~3aexn~3ainvalid-xexpr))",[0,[2,"struct:exn:invalid-xexpr"]],["xml"]],
["struct:exn:test",">rackunit/internals.html#(def._((lib._rackunit/main..rkt)._struct~3aexn~3atest))",[0,[2,"struct:exn:test"]],["rackunit"]],
["struct:exn:test:check",">rackunit/internals.html#(def._((lib._rackunit/main..rkt)._struct~3aexn~3atest~3acheck))",[0,[2,"struct:exn:test:check"]],["rackunit"]],
["struct:exn:xml",">xml/index.html#(def._((lib._xml/main..rkt)._struct~3aexn~3axml))",[0,[2,"struct:exn:xml"]],["xml"]],
["struct:export",">reference/stxtrans.html#(def._((lib._racket/provide-transform..rkt)._struct~3aexport))",[0,[2,"struct:export"]],["racket/provide-transform"]],
["struct:exported-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..rkt)._struct~3aexported-index-desc))",[0,[2,"struct:exported-index-desc"]],["scribble/manual-struct"]],
["struct:exported-module-binding",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3aexported-module-binding))",[0,[2,"struct:exported-module-binding"]],["compiler/zo-structs"]],
["struct:exported-nominal-module-binding",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3aexported-nominal-module-binding))",[0,[2,"struct:exported-nominal-module-binding"]],["compiler/zo-structs"]],
["struct:expr",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3aexpr))",[0,[2,"struct:expr"]],["compiler/zo-structs"]],
["struct:external-dtd",">xml/index.html#(def._((lib._xml/main..rkt)._struct~3aexternal-dtd))",[0,[2,"struct:external-dtd"]],["xml"]],
["struct:external-dtd/public",">xml/index.html#(def._((lib._xml/main..rkt)._struct~3aexternal-dtd/public))",[0,[2,"struct:external-dtd/public"]],["xml"]],
["struct:external-dtd/system",">xml/index.html#(def._((lib._xml/main..rkt)._struct~3aexternal-dtd/system))",[0,[2,"struct:external-dtd/system"]],["xml"]],
["struct:fieldset",">html/index.html#(def._((lib._html/main..rkt)._struct~3afieldset))",[0,[2,"struct:fieldset"]],["html"]],
["struct:file",">teachpack/dir.html#(def._((lib._htdp/dir..rkt)._struct~3afile))",[0,[2,"struct:file"]],["htdp/dir"]],
["struct:flomap",">images/Struct_Type_and_Accessors.html#(def._((lib._images/flomap..rkt)._struct~3aflomap))",[0,[2,"struct:flomap"]],["images/flomap"]],
["struct:flomap-2d-mapping",">images/Spatial_Transformations.html#(def._((lib._images/flomap..rkt)._struct~3aflomap-2d-mapping))",[0,[2,"struct:flomap-2d-mapping"]],["images/flomap"]],
["struct:font",">html/index.html#(def._((lib._html/main..rkt)._struct~3afont))",[0,[2,"struct:font"]],["html"]],
["struct:form",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3aform))",[0,[2,"struct:form"]],["compiler/zo-structs"]],
["struct:form",">html/index.html#(def._((lib._html/main..rkt)._struct~3aform))",[0,[2,"struct:form"]],["html"]],
["struct:form-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..rkt)._struct~3aform-index-desc))",[0,[2,"struct:form-index-desc"]],["scribble/manual-struct"]],
["struct:free-id-info",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3afree-id-info))",[0,[2,"struct:free-id-info"]],["compiler/zo-structs"]],
["struct:future-event",">reference/futures-trace.html#(def._((lib._future-visualizer/trace..rkt)._struct~3afuture-event))",[0,[2,"struct:future-event"]],["future-visualizer/trace"]],
["struct:generated-tag",">scribble/core.html#(def._((lib._scribble/core..rkt)._struct~3agenerated-tag))",[0,[2,"struct:generated-tag"]],["scribble/core"]],
["struct:geometry-collection",">db/util.html#(def._((lib._db/util/geometry..rkt)._struct~3ageometry-collection))",[0,[2,"struct:geometry-collection"]],["db/util/geometry"]],
["struct:gl-selection-record",">sgl/main.html#(def._((lib._sgl/main..rkt)._struct~3agl-selection-record))",[0,[2,"struct:gl-selection-record"]],["sgl"]],
["struct:global-bucket",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3aglobal-bucket))",[0,[2,"struct:global-bucket"]],["compiler/zo-structs"]],
["struct:h1",">html/index.html#(def._((lib._html/main..rkt)._struct~3ah1))",[0,[2,"struct:h1"]],["html"]],
["struct:h2",">html/index.html#(def._((lib._html/main..rkt)._struct~3ah2))",[0,[2,"struct:h2"]],["html"]],
["struct:h3",">html/index.html#(def._((lib._html/main..rkt)._struct~3ah3))",[0,[2,"struct:h3"]],["html"]],
["struct:h4",">html/index.html#(def._((lib._html/main..rkt)._struct~3ah4))",[0,[2,"struct:h4"]],["html"]],
["struct:h5",">html/index.html#(def._((lib._html/main..rkt)._struct~3ah5))",[0,[2,"struct:h5"]],["html"]],
["struct:h6",">html/index.html#(def._((lib._html/main..rkt)._struct~3ah6))",[0,[2,"struct:h6"]],["html"]],
["struct:head",">html/index.html#(def._((lib._html/main..rkt)._struct~3ahead))",[0,[2,"struct:head"]],["html"]],
["struct:header",">web-server/http.html#(def._((lib._web-server/http/request-structs..rkt)._struct~3aheader))",[0,[2,"struct:header"]],["web-server/http/request-structs"]],
["struct:host",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._struct~3ahost))",[0,[2,"struct:host"]],["web-server/configuration/configuration-table-structs"]],
["struct:host-table",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._struct~3ahost-table))",[0,[2,"struct:host-table"]],["web-server/configuration/configuration-table-structs"]],
["struct:hover-property",">scribble/core.html#(def._((lib._scribble/html-properties..rkt)._struct~3ahover-property))",[0,[2,"struct:hover-property"]],["scribble/html-properties"]],
["struct:hr",">html/index.html#(def._((lib._html/main..rkt)._struct~3ahr))",[0,[2,"struct:hr"]],["html"]],
["struct:html",">html/index.html#(def._((lib._html/main..rkt)._struct~3ahtml))",[0,[2,"struct:html"]],["html"]],
["struct:html-defaults",">scribble/core.html#(def._((lib._scribble/html-properties..rkt)._struct~3ahtml-defaults))",[0,[2,"struct:html-defaults"]],["scribble/html-properties"]],
["struct:html-element",">html/index.html#(def._((lib._html/main..rkt)._struct~3ahtml-element))",[0,[2,"struct:html-element"]],["html"]],
["struct:html-full",">html/index.html#(def._((lib._html/main..rkt)._struct~3ahtml-full))",[0,[2,"struct:html-full"]],["html"]],
["struct:i",">html/index.html#(def._((lib._html/main..rkt)._struct~3ai))",[0,[2,"struct:i"]],["html"]],
["struct:iframe",">html/index.html#(def._((lib._html/main..rkt)._struct~3aiframe))",[0,[2,"struct:iframe"]],["html"]],
["struct:illegal-message-number",">net/pop3.html#(def._((lib._net/pop3..rkt)._struct~3aillegal-message-number))",[0,[2,"struct:illegal-message-number"]],["net/pop3"]],
["struct:image-element",">scribble/core.html#(def._((lib._scribble/core..rkt)._struct~3aimage-element))",[0,[2,"struct:image-element"]],["scribble/core"]],
["struct:image-file",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._struct~3aimage-file))",[0,[2,"struct:image-file"]],["scribble/struct"]],
["struct:img",">html/index.html#(def._((lib._html/main..rkt)._struct~3aimg))",[0,[2,"struct:img"]],["html"]],
["struct:import",">reference/stxtrans.html#(def._((lib._racket/require-transform..rkt)._struct~3aimport))",[0,[2,"struct:import"]],["racket/require-transform"]],
["struct:import-source",">reference/stxtrans.html#(def._((lib._racket/require-transform..rkt)._struct~3aimport-source))",[0,[2,"struct:import-source"]],["racket/require-transform"]],
["struct:imported-nominal-path",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3aimported-nominal-path))",[0,[2,"struct:imported-nominal-path"]],["compiler/zo-structs"]],
["struct:index-element",">scribble/core.html#(def._((lib._scribble/core..rkt)._struct~3aindex-element))",[0,[2,"struct:index-element"]],["scribble/core"]],
["struct:indexed-future-event",">reference/futures-trace.html#(def._((lib._future-visualizer/trace..rkt)._struct~3aindexed-future-event))",[0,[2,"struct:indexed-future-event"]],["future-visualizer/trace"]],
["struct:inline-variant",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3ainline-variant))",[0,[2,"struct:inline-variant"]],["compiler/zo-structs"]],
["struct:input",">html/index.html#(def._((lib._html/main..rkt)._struct~3ainput))",[0,[2,"struct:input"]],["html"]],
["struct:ins",">html/index.html#(def._((lib._html/main..rkt)._struct~3ains))",[0,[2,"struct:ins"]],["html"]],
["struct:install-value",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3ainstall-value))",[0,[2,"struct:install-value"]],["compiler/zo-structs"]],
["struct:interface-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..rkt)._struct~3ainterface-index-desc))",[0,[2,"struct:interface-index-desc"]],["scribble/manual-struct"]],
["struct:invertible-function",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._struct~3ainvertible-function))",[0,[2,"struct:invertible-function"]],["plot"]],
["struct:isindex",">html/index.html#(def._((lib._html/main..rkt)._struct~3aisindex))",[0,[2,"struct:isindex"]],["html"]],
["struct:itemization",">scribble/core.html#(def._((lib._scribble/core..rkt)._struct~3aitemization))",[0,[2,"struct:itemization"]],["scribble/core"]],
["struct:ivl",">plot/utils.html#(def._((lib._plot/utils..rkt)._struct~3aivl))",[0,[2,"struct:ivl"]],["plot/utils"]],
["struct:just-context",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._struct~3ajust-context))",[0,[2,"struct:just-context"]],["scribble/racket","scribble/scheme"]],
["struct:kbd",">html/index.html#(def._((lib._html/main..rkt)._struct~3akbd))",[0,[2,"struct:kbd"]],["html"]],
["struct:label",">html/index.html#(def._((lib._html/main..rkt)._struct~3alabel))",[0,[2,"struct:label"]],["html"]],
["struct:lam",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3alam))",[0,[2,"struct:lam"]],["compiler/zo-structs"]],
["struct:latex-auto-extra-files",">scribble/core.html#(def._((lib._scribble/latex-properties..rkt)._struct~3alatex-auto-extra-files))",[0,[2,"struct:latex-auto-extra-files"]],["scribble/latex-properties"]],
["struct:latex-defaults",">scribble/core.html#(def._((lib._scribble/latex-properties..rkt)._struct~3alatex-defaults))",[0,[2,"struct:latex-defaults"]],["scribble/latex-properties"]],
["struct:legend",">html/index.html#(def._((lib._html/main..rkt)._struct~3alegend))",[0,[2,"struct:legend"]],["html"]],
["struct:let-one",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3alet-one))",[0,[2,"struct:let-one"]],["compiler/zo-structs"]],
["struct:let-rec",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3alet-rec))",[0,[2,"struct:let-rec"]],["compiler/zo-structs"]],
["struct:let-void",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3alet-void))",[0,[2,"struct:let-void"]],["compiler/zo-structs"]],
["struct:lexical-rename",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3alexical-rename))",[0,[2,"struct:lexical-rename"]],["compiler/zo-structs"]],
["struct:li",">html/index.html#(def._((lib._html/main..rkt)._struct~3ali))",[0,[2,"struct:li"]],["html"]],
["struct:line-string",">db/util.html#(def._((lib._db/util/geometry..rkt)._struct~3aline-string))",[0,[2,"struct:line-string"]],["db/util/geometry"]],
["struct:link-element",">scribble/core.html#(def._((lib._scribble/core..rkt)._struct~3alink-element))",[0,[2,"struct:link-element"]],["scribble/core"]],
["struct:literal-syntax",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._struct~3aliteral-syntax))",[0,[2,"struct:literal-syntax"]],["scribble/racket","scribble/scheme"]],
["struct:localref",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3alocalref))",[0,[2,"struct:localref"]],["compiler/zo-structs"]],
["struct:location",">xml/index.html#(def._((lib._xml/main..rkt)._struct~3alocation))",[0,[2,"struct:location"]],["xml"]],
["struct:long-boolean",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._struct~3along-boolean))",[0,[2,"struct:long-boolean"]],["scribble/racket","scribble/scheme"]],
["struct:lw",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._struct~3alw))",[0,[2,"struct:lw"]],["redex/pict","redex"]],
["struct:machine",">unstable/Automata__Compiling_State_Machines.html#(def._((lib._unstable/automata/machine..rkt)._struct~3amachine))",[0,[2,"struct:machine"]],["unstable/automata/machine"]],
["struct:machine-accepting",">unstable/Automata__Compiling_State_Machines.html#(def._((lib._unstable/automata/machine..rkt)._struct~3amachine-accepting))",[0,[2,"struct:machine-accepting"]],["unstable/automata/machine"]],
["struct:malformed-multipart-entity",">net/mime.html#(def._((lib._net/mime..rkt)._struct~3amalformed-multipart-entity))",[0,[2,"struct:malformed-multipart-entity"]],["net/mime"]],
["struct:malformed-server-response",">net/pop3.html#(def._((lib._net/pop3..rkt)._struct~3amalformed-server-response))",[0,[2,"struct:malformed-server-response"]],["net/pop3"]],
["struct:manager",">web-server/servlet.html#(def._((lib._web-server/managers/manager..rkt)._struct~3amanager))",[0,[2,"struct:manager"]],["web-server/managers/manager"]],
["struct:mapped-function",">plot/utils.html#(def._((lib._plot/utils..rkt)._struct~3amapped-function))",[0,[2,"struct:mapped-function"]],["plot/utils"]],
["struct:mark-barrier",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3amark-barrier))",[0,[2,"struct:mark-barrier"]],["compiler/zo-structs"]],
["struct:mark-parameter",">unstable/Mark_Parameters.html#(def._((lib._unstable/markparam..rkt)._struct~3amark-parameter))",[0,[2,"struct:mark-parameter"]],["unstable/markparam"]],
["struct:menu",">html/index.html#(def._((lib._html/main..rkt)._struct~3amenu))",[0,[2,"struct:menu"]],["html"]],
["struct:message",">net/mime.html#(def._((lib._net/mime..rkt)._struct~3amessage))",[0,[2,"struct:message"]],["net/mime"]],
["struct:messages",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._struct~3amessages))",[0,[2,"struct:messages"]],["web-server/configuration/configuration-table-structs"]],
["struct:meta",">html/index.html#(def._((lib._html/main..rkt)._struct~3ameta))",[0,[2,"struct:meta"]],["html"]],
["struct:method-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..rkt)._struct~3amethod-index-desc))",[0,[2,"struct:method-index-desc"]],["scribble/manual-struct"]],
["struct:mime-error",">net/mime.html#(def._((lib._net/mime..rkt)._struct~3amime-error))",[0,[2,"struct:mime-error"]],["net/mime"]],
["struct:missing-multipart-boundary-parameter",">net/mime.html#(def._((lib._net/mime..rkt)._struct~3amissing-multipart-boundary-parameter))",[0,[2,"struct:missing-multipart-boundary-parameter"]],["net/mime"]],
["struct:mixin-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..rkt)._struct~3amixin-index-desc))",[0,[2,"struct:mixin-index-desc"]],["scribble/manual-struct"]],
["struct:mod",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3amod))",[0,[2,"struct:mod"]],["compiler/zo-structs"]],
["struct:module-binding",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3amodule-binding))",[0,[2,"struct:module-binding"]],["compiler/zo-structs"]],
["struct:module-path-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..rkt)._struct~3amodule-path-index-desc))",[0,[2,"struct:module-path-index-desc"]],["scribble/manual-struct"]],
["struct:module-rename",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3amodule-rename))",[0,[2,"struct:module-rename"]],["compiler/zo-structs"]],
["struct:module-variable",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3amodule-variable))",[0,[2,"struct:module-variable"]],["compiler/zo-structs"]],
["struct:monitor",">unstable/temp-c.html#(def._((lib._unstable/temp-c/monitor..rkt)._struct~3amonitor))",[0,[2,"struct:monitor"]],["unstable/temp-c/monitor"]],
["struct:monitor:call",">unstable/temp-c.html#(def._((lib._unstable/temp-c/monitor..rkt)._struct~3amonitor~3acall))",[0,[2,"struct:monitor:call"]],["unstable/temp-c/monitor"]],
["struct:monitor:proj",">unstable/temp-c.html#(def._((lib._unstable/temp-c/monitor..rkt)._struct~3amonitor~3aproj))",[0,[2,"struct:monitor:proj"]],["unstable/temp-c/monitor"]],
["struct:monitor:return",">unstable/temp-c.html#(def._((lib._unstable/temp-c/monitor..rkt)._struct~3amonitor~3areturn))",[0,[2,"struct:monitor:return"]],["unstable/temp-c/monitor"]],
["struct:multi-line-string",">db/util.html#(def._((lib._db/util/geometry..rkt)._struct~3amulti-line-string))",[0,[2,"struct:multi-line-string"]],["db/util/geometry"]],
["struct:multi-point",">db/util.html#(def._((lib._db/util/geometry..rkt)._struct~3amulti-point))",[0,[2,"struct:multi-point"]],["db/util/geometry"]],
["struct:multi-polygon",">db/util.html#(def._((lib._db/util/geometry..rkt)._struct~3amulti-polygon))",[0,[2,"struct:multi-polygon"]],["db/util/geometry"]],
["struct:multiarg-element",">scribble/core.html#(def._((lib._scribble/core..rkt)._struct~3amultiarg-element))",[0,[2,"struct:multiarg-element"]],["scribble/core"]],
["struct:mzscheme",">html/index.html#(def._((lib._html/main..rkt)._struct~3amzscheme))",[0,[2,"struct:mzscheme"]],["html"]],
["struct:nested-flow",">scribble/core.html#(def._((lib._scribble/core..rkt)._struct~3anested-flow))",[0,[2,"struct:nested-flow"]],["scribble/core"]],
["struct:nntp",">net/nntp.html#(def._((lib._net/nntp..rkt)._struct~3anntp))",[0,[2,"struct:nntp"]],["net/nntp"]],
["struct:no-group-selected",">net/nntp.html#(def._((lib._net/nntp..rkt)._struct~3ano-group-selected))",[0,[2,"struct:no-group-selected"]],["net/nntp"]],
["struct:node",">profile/index.html#(def._((lib._profile/analyzer..rkt)._struct~3anode))",[0,[2,"struct:node"]],["profile/analyzer"]],
["struct:noframes",">html/index.html#(def._((lib._html/main..rkt)._struct~3anoframes))",[0,[2,"struct:noframes"]],["html"]],
["struct:nominal-module-binding",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3anominal-module-binding))",[0,[2,"struct:nominal-module-binding"]],["compiler/zo-structs"]],
["struct:nominal-path",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3anominal-path))",[0,[2,"struct:nominal-path"]],["compiler/zo-structs"]],
["struct:non-existent-group",">net/nntp.html#(def._((lib._net/nntp..rkt)._struct~3anon-existent-group))",[0,[2,"struct:non-existent-group"]],["net/nntp"]],
["struct:noscript",">html/index.html#(def._((lib._html/main..rkt)._struct~3anoscript))",[0,[2,"struct:noscript"]],["html"]],
["struct:not-given-headers",">net/pop3.html#(def._((lib._net/pop3..rkt)._struct~3anot-given-headers))",[0,[2,"struct:not-given-headers"]],["net/pop3"]],
["struct:not-ready-for-transaction",">net/pop3.html#(def._((lib._net/pop3..rkt)._struct~3anot-ready-for-transaction))",[0,[2,"struct:not-ready-for-transaction"]],["net/pop3"]],
["struct:object",">html/index.html#(def._((lib._html/main..rkt)._struct~3aobject))",[0,[2,"struct:object"]],["html"]],
["struct:ol",">html/index.html#(def._((lib._html/main..rkt)._struct~3aol))",[0,[2,"struct:ol"]],["html"]],
["struct:optgroup",">html/index.html#(def._((lib._html/main..rkt)._struct~3aoptgroup))",[0,[2,"struct:optgroup"]],["html"]],
["struct:option",">html/index.html#(def._((lib._html/main..rkt)._struct~3aoption))",[0,[2,"struct:option"]],["html"]],
["struct:p",">html/index.html#(def._((lib._html/main..rkt)._struct~3ap))",[0,[2,"struct:p"]],["html"]],
["struct:p-i",">xml/index.html#(def._((lib._xml/main..rkt)._struct~3ap-i))",[0,[2,"struct:p-i"]],["xml"]],
["struct:page-target-element",">scribble/core.html#(def._((lib._scribble/core..rkt)._struct~3apage-target-element))",[0,[2,"struct:page-target-element"]],["scribble/core"]],
["struct:paragraph",">scribble/core.html#(def._((lib._scribble/core..rkt)._struct~3aparagraph))",[0,[2,"struct:paragraph"]],["scribble/core"]],
["struct:param",">html/index.html#(def._((lib._html/main..rkt)._struct~3aparam))",[0,[2,"struct:param"]],["html"]],
["struct:part",">scribble/core.html#(def._((lib._scribble/core..rkt)._struct~3apart))",[0,[2,"struct:part"]],["scribble/core"]],
["struct:part-collect-decl",">scribble/decode.html#(def._((lib._scribble/decode..rkt)._struct~3apart-collect-decl))",[0,[2,"struct:part-collect-decl"]],["scribble/decode"]],
["struct:part-index-decl",">scribble/decode.html#(def._((lib._scribble/decode..rkt)._struct~3apart-index-decl))",[0,[2,"struct:part-index-decl"]],["scribble/decode"]],
["struct:part-relative-element",">scribble/core.html#(def._((lib._scribble/core..rkt)._struct~3apart-relative-element))",[0,[2,"struct:part-relative-element"]],["scribble/core"]],
["struct:part-start",">scribble/decode.html#(def._((lib._scribble/decode..rkt)._struct~3apart-start))",[0,[2,"struct:part-start"]],["scribble/decode"]],
["struct:part-tag-decl",">scribble/decode.html#(def._((lib._scribble/decode..rkt)._struct~3apart-tag-decl))",[0,[2,"struct:part-tag-decl"]],["scribble/decode"]],
["struct:password-rejected",">net/pop3.html#(def._((lib._net/pop3..rkt)._struct~3apassword-rejected))",[0,[2,"struct:password-rejected"]],["net/pop3"]],
["struct:path/param",">net/url.html#(def._((lib._net/url-structs..rkt)._struct~3apath/param))",[0,[2,"struct:path/param"]],["net/url-structs","net/url"]],
["struct:paths",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._struct~3apaths))",[0,[2,"struct:paths"]],["web-server/configuration/configuration-table-structs"]],
["struct:pcdata",">xml/index.html#(def._((lib._xml/main..rkt)._struct~3apcdata))",[0,[2,"struct:pcdata"]],["xml"]],
["struct:pen",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._struct~3apen))",[0,[2,"struct:pen"]],["2htdp/image"]],
["struct:pg-array",">db/util.html#(def._((lib._db/util/postgresql..rkt)._struct~3apg-array))",[0,[2,"struct:pg-array"]],["db/util/postgresql"]],
["struct:pg-box",">db/util.html#(def._((lib._db/util/postgresql..rkt)._struct~3apg-box))",[0,[2,"struct:pg-box"]],["db/util/postgresql"]],
["struct:pg-circle",">db/util.html#(def._((lib._db/util/postgresql..rkt)._struct~3apg-circle))",[0,[2,"struct:pg-circle"]],["db/util/postgresql"]],
["struct:pg-path",">db/util.html#(def._((lib._db/util/postgresql..rkt)._struct~3apg-path))",[0,[2,"struct:pg-path"]],["db/util/postgresql"]],
["struct:phase-shift",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3aphase-shift))",[0,[2,"struct:phase-shift"]],["compiler/zo-structs"]],
["struct:phased-module-binding",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3aphased-module-binding))",[0,[2,"struct:phased-module-binding"]],["compiler/zo-structs"]],
["struct:phased-nominal-path",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3aphased-nominal-path))",[0,[2,"struct:phased-nominal-path"]],["compiler/zo-structs"]],
["struct:pict",">slideshow/Pict_Datatype.html#(def._((lib._slideshow/pict..rkt)._struct~3apict))",[0,[2,"struct:pict"]],["slideshow/pict","slideshow"]],
["struct:plot-setup",">mrlib/Plot.html#(def._((lib._mrlib/plot..rkt)._struct~3aplot-setup))",[0,[2,"struct:plot-setup"]],["mrlib/plot"]],
["struct:plot-time",">plot/utils.html#(def._((lib._plot/utils..rkt)._struct~3aplot-time))",[0,[2,"struct:plot-time"]],["plot/utils"]],
["struct:point",">db/util.html#(def._((lib._db/util/geometry..rkt)._struct~3apoint))",[0,[2,"struct:point"]],["db/util/geometry"]],
["struct:polygon",">db/util.html#(def._((lib._db/util/geometry..rkt)._struct~3apolygon))",[0,[2,"struct:polygon"]],["db/util/geometry"]],
["struct:pop3",">net/pop3.html#(def._((lib._net/pop3..rkt)._struct~3apop3))",[0,[2,"struct:pop3"]],["net/pop3"]],
["struct:position",">parser-tools/Lexers.html#(def._((lib._parser-tools/lex..rkt)._struct~3aposition))",[0,[2,"struct:position"]],["parser-tools/lex"]],
["struct:position-token",">parser-tools/Lexers.html#(def._((lib._parser-tools/lex..rkt)._struct~3aposition-token))",[0,[2,"struct:position-token"]],["parser-tools/lex"]],
["struct:posn",">htdp/index.html#(def._((lib._lang/posn..rkt)._struct~3aposn))",[0,[2,"struct:posn"]],["lang/posn"]],
["struct:posn",">graphics/posn.html#(def._((lib._graphics/graphics..rkt)._struct~3aposn))",[0,[2,"struct:posn"]],["graphics/graphics"]],
["struct:post",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/dummy-10..rkt)._struct~3apost))",[0,[2,"struct:post"]],[]],
["struct:post",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-1..rkt)._struct~3apost))",[0,[2,"struct:post"]],[]],
["struct:post",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-5..rkt)._struct~3apost))",[0,[2,"struct:post"]],[]],
["struct:pre",">html/index.html#(def._((lib._html/main..rkt)._struct~3apre))",[0,[2,"struct:pre"]],["html"]],
["struct:pre-tick",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._struct~3apre-tick))",[0,[2,"struct:pre-tick"]],["plot"]],
["struct:prefix",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3aprefix))",[0,[2,"struct:prefix"]],["compiler/zo-structs"]],
["struct:premature-close",">net/nntp.html#(def._((lib._net/nntp..rkt)._struct~3apremature-close))",[0,[2,"struct:premature-close"]],["net/nntp"]],
["struct:primval",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3aprimval))",[0,[2,"struct:primval"]],["compiler/zo-structs"]],
["struct:procedure-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..rkt)._struct~3aprocedure-index-desc))",[0,[2,"struct:procedure-index-desc"]],["scribble/manual-struct"]],
["struct:profile",">profile/index.html#(def._((lib._profile/analyzer..rkt)._struct~3aprofile))",[0,[2,"struct:profile"]],["profile/analyzer"]],
["struct:projection-mapping",">images/Spatial_Transformations.html#(def._((lib._images/flomap..rkt)._struct~3aprojection-mapping))",[0,[2,"struct:projection-mapping"]],["images/flomap"]],
["struct:prolog",">xml/index.html#(def._((lib._xml/main..rkt)._struct~3aprolog))",[0,[2,"struct:prolog"]],["xml"]],
["struct:provided",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3aprovided))",[0,[2,"struct:provided"]],["compiler/zo-structs"]],
["struct:q",">html/index.html#(def._((lib._html/main..rkt)._struct~3aq))",[0,[2,"struct:q"]],["html"]],
["struct:qp-error",">net/qp.html#(def._((lib._net/qp..rkt)._struct~3aqp-error))",[0,[2,"struct:qp-error"]],["net/qp"]],
["struct:qp-wrong-input",">net/qp.html#(def._((lib._net/qp..rkt)._struct~3aqp-wrong-input))",[0,[2,"struct:qp-wrong-input"]],["net/qp"]],
["struct:qp-wrong-line-size",">net/qp.html#(def._((lib._net/qp..rkt)._struct~3aqp-wrong-line-size))",[0,[2,"struct:qp-wrong-line-size"]],["net/qp"]],
["struct:redirect-target-element",">scribble/core.html#(def._((lib._scribble/core..rkt)._struct~3aredirect-target-element))",[0,[2,"struct:redirect-target-element"]],["scribble/core"]],
["struct:region",">cards/index.html#(def._((lib._games/cards..rkt)._struct~3aregion))",[0,[2,"struct:region"]],["games/cards"]],
["struct:render-element",">scribble/core.html#(def._((lib._scribble/core..rkt)._struct~3arender-element))",[0,[2,"struct:render-element"]],["scribble/core"]],
["struct:req",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3areq))",[0,[2,"struct:req"]],["compiler/zo-structs"]],
["struct:request",">web-server/http.html#(def._((lib._web-server/http/request-structs..rkt)._struct~3arequest))",[0,[2,"struct:request"]],["web-server/http/request-structs"]],
["struct:resolve-info",">scribble/core.html#(def._((lib._scribble/core..rkt)._struct~3aresolve-info))",[0,[2,"struct:resolve-info"]],["scribble/core"]],
["struct:responders",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._struct~3aresponders))",[0,[2,"struct:responders"]],["web-server/configuration/configuration-table-structs"]],
["struct:response",">web-server/http.html#(def._((lib._web-server/http/response-structs..rkt)._struct~3aresponse))",[0,[2,"struct:response"]],["web-server/http/response-structs"]],
["struct:rgb",">graphics/Color_Operations.html#(def._((lib._graphics/graphics..rkt)._struct~3argb))",[0,[2,"struct:rgb"]],["graphics/graphics"]],
["struct:rmpi-comm",">reference/distributed-places.html#(def._((lib._racket/place/distributed/rmpi..rkt)._struct~3armpi-comm))",[0,[2,"struct:rmpi-comm"]],["racket/place/distributed/rmpi"]],
["struct:rows-result",">db/query-api.html#(def._((lib._db/base..rkt)._struct~3arows-result))",[0,[2,"struct:rows-result"]],["db","db/base"]],
["struct:s",">html/index.html#(def._((lib._html/main..rkt)._struct~3as))",[0,[2,"struct:s"]],["html"]],
["struct:samp",">html/index.html#(def._((lib._html/main..rkt)._struct~3asamp))",[0,[2,"struct:samp"]],["html"]],
["struct:script",">html/index.html#(def._((lib._html/main..rkt)._struct~3ascript))",[0,[2,"struct:script"]],["html"]],
["struct:script-property",">scribble/core.html#(def._((lib._scribble/html-properties..rkt)._struct~3ascript-property))",[0,[2,"struct:script-property"]],["scribble/html-properties"]],
["struct:select",">html/index.html#(def._((lib._html/main..rkt)._struct~3aselect))",[0,[2,"struct:select"]],["html"]],
["struct:seq",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3aseq))",[0,[2,"struct:seq"]],["compiler/zo-structs"]],
["struct:seq-for-syntax",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3aseq-for-syntax))",[0,[2,"struct:seq-for-syntax"]],["compiler/zo-structs"]],
["struct:servlet",">web-server-internal/dispatch-servlets.html#(def._((lib._web-server/private/servlet..rkt)._struct~3aservlet))",[0,[2,"struct:servlet"]],["web-server/private/servlet"]],
["struct:shaped-parens",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._struct~3ashaped-parens))",[0,[2,"struct:shaped-parens"]],["scribble/racket","scribble/scheme"]],
["struct:simple-module-binding",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3asimple-module-binding))",[0,[2,"struct:simple-module-binding"]],["compiler/zo-structs"]],
["struct:simple-nominal-path",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3asimple-nominal-path))",[0,[2,"struct:simple-nominal-path"]],["compiler/zo-structs"]],
["struct:simple-result",">db/query-api.html#(def._((lib._db/base..rkt)._struct~3asimple-result))",[0,[2,"struct:simple-result"]],["db","db/base"]],
["struct:small",">html/index.html#(def._((lib._html/main..rkt)._struct~3asmall))",[0,[2,"struct:small"]],["html"]],
["struct:source",">xml/index.html#(def._((lib._xml/main..rkt)._struct~3asource))",[0,[2,"struct:source"]],["xml"]],
["struct:span",">html/index.html#(def._((lib._html/main..rkt)._struct~3aspan))",[0,[2,"struct:span"]],["html"]],
["struct:splice",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3asplice))",[0,[2,"struct:splice"]],["compiler/zo-structs"]],
["struct:splice",">scribble/decode.html#(def._((lib._scribble/decode..rkt)._struct~3asplice))",[0,[2,"struct:splice"]],["scribble/decode"]],
["struct:sql-date",">db/sql-types.html#(def._((lib._db/base..rkt)._struct~3asql-date))",[0,[2,"struct:sql-date"]],["db","db/base"]],
["struct:sql-interval",">db/sql-types.html#(def._((lib._db/base..rkt)._struct~3asql-interval))",[0,[2,"struct:sql-interval"]],["db","db/base"]],
["struct:sql-time",">db/sql-types.html#(def._((lib._db/base..rkt)._struct~3asql-time))",[0,[2,"struct:sql-time"]],["db","db/base"]],
["struct:sql-timestamp",">db/sql-types.html#(def._((lib._db/base..rkt)._struct~3asql-timestamp))",[0,[2,"struct:sql-timestamp"]],["db","db/base"]],
["struct:srcloc",">reference/exns.html#(def._((quote._~23~25kernel)._struct~3asrcloc))",[0,[2,"struct:srcloc"]],["racket/base","racket"]],
["struct:stop-with",">teachpack/2htdpuniverse.html#(def._((lib._teachpack/2htdp/image..rkt)._struct~3astop-with))",[0,[2,"struct:stop-with"]],["2htdp/universe"]],
["struct:store",">web-server/stateless.html#(def._((lib._web-server/stuffers/store..rkt)._struct~3astore))",[0,[2,"struct:store"]],["web-server/stuffers/store"]],
["struct:strike",">html/index.html#(def._((lib._html/main..rkt)._struct~3astrike))",[0,[2,"struct:strike"]],["html"]],
["struct:strong",">html/index.html#(def._((lib._html/main..rkt)._struct~3astrong))",[0,[2,"struct:strong"]],["html"]],
["struct:struct-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..rkt)._struct~3astruct-index-desc))",[0,[2,"struct:struct-index-desc"]],["scribble/manual-struct"]],
["struct:struct-info",">reference/structinfo.html#(def._((lib._racket/struct-info..rkt)._struct~3astruct-info))",[0,[2,"struct:struct-info"]],["racket/struct-info"]],
["struct:stuffer",">web-server/stateless.html#(def._((lib._web-server/stuffers/stuffer..rkt)._struct~3astuffer))",[0,[2,"struct:stuffer"]],["web-server/stuffers/stuffer"]],
["struct:stx",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3astx))",[0,[2,"struct:stx"]],["compiler/zo-structs"]],
["struct:style",">html/index.html#(def._((lib._html/main..rkt)._struct~3astyle))",[0,[2,"struct:style"]],["html"]],
["struct:style",">scribble/core.html#(def._((lib._scribble/core..rkt)._struct~3astyle))",[0,[2,"struct:style"]],["scribble/core"]],
["struct:sub",">html/index.html#(def._((lib._html/main..rkt)._struct~3asub))",[0,[2,"struct:sub"]],["html"]],
["struct:sup",">html/index.html#(def._((lib._html/main..rkt)._struct~3asup))",[0,[2,"struct:sup"]],["html"]],
["struct:table",">html/index.html#(def._((lib._html/main..rkt)._struct~3atable))",[0,[2,"struct:table"]],["html"]],
["struct:table",">scribble/core.html#(def._((lib._scribble/core..rkt)._struct~3atable))",[0,[2,"struct:table"]],["scribble/core"]],
["struct:table-cells",">scribble/core.html#(def._((lib._scribble/core..rkt)._struct~3atable-cells))",[0,[2,"struct:table-cells"]],["scribble/core"]],
["struct:table-columns",">scribble/core.html#(def._((lib._scribble/core..rkt)._struct~3atable-columns))",[0,[2,"struct:table-columns"]],["scribble/core"]],
["struct:target-element",">scribble/core.html#(def._((lib._scribble/core..rkt)._struct~3atarget-element))",[0,[2,"struct:target-element"]],["scribble/core"]],
["struct:target-url",">scribble/core.html#(def._((lib._scribble/core..rkt)._struct~3atarget-url))",[0,[2,"struct:target-url"]],["scribble/core"]],
["struct:target-url",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._struct~3atarget-url))",[0,[2,"struct:target-url"]],["scribble/struct"]],
["struct:tbody",">html/index.html#(def._((lib._html/main..rkt)._struct~3atbody))",[0,[2,"struct:tbody"]],["html"]],
["struct:td",">html/index.html#(def._((lib._html/main..rkt)._struct~3atd))",[0,[2,"struct:td"]],["html"]],
["struct:test-error",">rackunit/internals.html#(def._((lib._rackunit/main..rkt)._struct~3atest-error))",[0,[2,"struct:test-error"]],["rackunit"]],
["struct:test-failure",">rackunit/internals.html#(def._((lib._rackunit/main..rkt)._struct~3atest-failure))",[0,[2,"struct:test-failure"]],["rackunit"]],
["struct:test-result",">rackunit/internals.html#(def._((lib._rackunit/main..rkt)._struct~3atest-result))",[0,[2,"struct:test-result"]],["rackunit"]],
["struct:test-success",">rackunit/internals.html#(def._((lib._rackunit/main..rkt)._struct~3atest-success))",[0,[2,"struct:test-success"]],["rackunit"]],
["struct:tex-addition",">scribble/core.html#(def._((lib._scribble/latex-properties..rkt)._struct~3atex-addition))",[0,[2,"struct:tex-addition"]],["scribble/latex-properties"]],
["struct:textarea",">html/index.html#(def._((lib._html/main..rkt)._struct~3atextarea))",[0,[2,"struct:textarea"]],["html"]],
["struct:tfoot",">html/index.html#(def._((lib._html/main..rkt)._struct~3atfoot))",[0,[2,"struct:tfoot"]],["html"]],
["struct:th",">html/index.html#(def._((lib._html/main..rkt)._struct~3ath))",[0,[2,"struct:th"]],["html"]],
["struct:thead",">html/index.html#(def._((lib._html/main..rkt)._struct~3athead))",[0,[2,"struct:thead"]],["html"]],
["struct:thing-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..rkt)._struct~3athing-index-desc))",[0,[2,"struct:thing-index-desc"]],["scribble/manual-struct"]],
["struct:tick",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._struct~3atick))",[0,[2,"struct:tick"]],["plot"]],
["struct:ticks",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._struct~3aticks))",[0,[2,"struct:ticks"]],["plot"]],
["struct:timeouts",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._struct~3atimeouts))",[0,[2,"struct:timeouts"]],["web-server/configuration/configuration-table-structs"]],
["struct:timer",">web-server-internal/timer.html#(def._((lib._web-server/private/timer..rkt)._struct~3atimer))",[0,[2,"struct:timer"]],["web-server/private/timer"]],
["struct:title",">html/index.html#(def._((lib._html/main..rkt)._struct~3atitle))",[0,[2,"struct:title"]],["html"]],
["struct:title-decl",">scribble/decode.html#(def._((lib._scribble/decode..rkt)._struct~3atitle-decl))",[0,[2,"struct:title-decl"]],["scribble/decode"]],
["struct:toc-element",">scribble/core.html#(def._((lib._scribble/core..rkt)._struct~3atoc-element))",[0,[2,"struct:toc-element"]],["scribble/core"]],
["struct:toc-target-element",">scribble/core.html#(def._((lib._scribble/core..rkt)._struct~3atoc-target-element))",[0,[2,"struct:toc-target-element"]],["scribble/core"]],
["struct:top-level-rename",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3atop-level-rename))",[0,[2,"struct:top-level-rename"]],["compiler/zo-structs"]],
["struct:toplevel",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3atoplevel))",[0,[2,"struct:toplevel"]],["compiler/zo-structs"]],
["struct:topsyntax",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3atopsyntax))",[0,[2,"struct:topsyntax"]],["compiler/zo-structs"]],
["struct:tr",">html/index.html#(def._((lib._html/main..rkt)._struct~3atr))",[0,[2,"struct:tr"]],["html"]],
["struct:traverse-block",">scribble/core.html#(def._((lib._scribble/core..rkt)._struct~3atraverse-block))",[0,[2,"struct:traverse-block"]],["scribble/core"]],
["struct:traverse-element",">scribble/core.html#(def._((lib._scribble/core..rkt)._struct~3atraverse-element))",[0,[2,"struct:traverse-element"]],["scribble/core"]],
["struct:tt",">html/index.html#(def._((lib._html/main..rkt)._struct~3att))",[0,[2,"struct:tt"]],["html"]],
["struct:u",">html/index.html#(def._((lib._html/main..rkt)._struct~3au))",[0,[2,"struct:u"]],["html"]],
["struct:ul",">html/index.html#(def._((lib._html/main..rkt)._struct~3aul))",[0,[2,"struct:ul"]],["html"]],
["struct:unexpected-response",">net/nntp.html#(def._((lib._net/nntp..rkt)._struct~3aunexpected-response))",[0,[2,"struct:unexpected-response"]],["net/nntp"]],
["struct:unexpected-termination",">net/mime.html#(def._((lib._net/mime..rkt)._struct~3aunexpected-termination))",[0,[2,"struct:unexpected-termination"]],["net/mime"]],
["struct:url",">net/url.html#(def._((lib._net/url-structs..rkt)._struct~3aurl))",[0,[2,"struct:url"]],["net/url-structs","net/url"]],
["struct:url-anchor",">scribble/core.html#(def._((lib._scribble/html-properties..rkt)._struct~3aurl-anchor))",[0,[2,"struct:url-anchor"]],["scribble/html-properties"]],
["struct:username-rejected",">net/pop3.html#(def._((lib._net/pop3..rkt)._struct~3ausername-rejected))",[0,[2,"struct:username-rejected"]],["net/pop3"]],
["struct:var",">html/index.html#(def._((lib._html/main..rkt)._struct~3avar))",[0,[2,"struct:var"]],["html"]],
["struct:var-id",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._struct~3avar-id))",[0,[2,"struct:var-id"]],["scribble/racket","scribble/scheme"]],
["struct:varref",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3avarref))",[0,[2,"struct:varref"]],["compiler/zo-structs"]],
["struct:with-attributes",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._struct~3awith-attributes))",[0,[2,"struct:with-attributes"]],["scribble/struct"]],
["struct:with-cont-mark",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3awith-cont-mark))",[0,[2,"struct:with-cont-mark"]],["compiler/zo-structs"]],
["struct:wrap",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3awrap))",[0,[2,"struct:wrap"]],["compiler/zo-structs"]],
["struct:wrapped",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3awrapped))",[0,[2,"struct:wrapped"]],["compiler/zo-structs"]],
["struct:zo",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._struct~3azo))",[0,[2,"struct:zo"]],["compiler/zo-structs"]],
["struct?",">reference/structutils.html#(def._((quote._~23~25kernel)._struct~3f))",[0,[2,"struct?"]],["racket/base","racket"]],
["struct?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._struct~3f))",[0,[2,"struct?"]],["lang/htdp-advanced"]],
["struct?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._struct~3f))",[0,[2,"struct?"]],["lang/htdp-beginner"]],
["struct?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._struct~3f))",[0,[2,"struct?"]],["lang/htdp-beginner-abbr"]],
["struct?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._struct~3f))",[0,[2,"struct?"]],["lang/htdp-intermediate"]],
["struct?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._struct~3f))",[0,[2,"struct?"]],["lang/htdp-intermediate-lambda"]],
["structs",">unstable/struct.html","Structs",false],
["structural matching",">reference/Structural_Matching.html","Structural Matching",false],
["structure",">planet/cmdline.html#(part._structure)",[6,"structure"],false],
["structure",">reference/structures.html#(tech._structure)","<span style=\"font-style: italic\">structure</span>",false],
["structure comparisons",">guide/define-struct.html#(part._struct-equal)","Structure Comparisons",false],
["structure definitions",">ts-reference/special-forms.html#(part._.Structure_.Definitions)","Structure Definitions",false],
["structure inspectors",">reference/inspectors.html","Structure Inspectors",false],
["structure reference",">scribble/core.html#(part._.Structure_.Reference)","Structure Reference",false],
["structure subtypes",">guide/define-struct.html#(part._struct-subtypes)","Structure Subtypes",false],
["structure subtypes",">reference/structures.html#(idx._(gentag._160._(lib._scribblings/reference/reference..scrbl)))","structure subtypes",false],
["structure type",">reference/structures.html#(tech._structure._type)","<span style=\"font-style: italic\">structure type</span>",false],
["structure type descriptor",">guide/define-struct.html#(tech._structure._type._descriptor)","<span style=\"font-style: italic\">structure type descriptor</span>",false],
["structure type descriptor",">reference/define-struct.html#(tech._structure._type._descriptor)","<span style=\"font-style: italic\">structure type\ndescriptor</span>",false],
["structure type generativity",">guide/define-struct.html#(part._.Structure_.Type_.Generativity)","Structure Type Generativity",false],
["structure type properties",">reference/structprops.html","Structure Type Properties",false],
["structure type property",">reference/structprops.html#(tech._structure._type._property)","<span style=\"font-style: italic\">structure type property</span>",false],
["structure type property contracts",">reference/Structure_Type_Property_Contracts.html","Structure Type Property Contracts",false],
["structure type property descriptor",">reference/structprops.html#(tech._structure._type._property._descriptor)","<span style=\"font-style: italic\">structure type property descriptor</span>",false],
["structure type transformer binding",">reference/structinfo.html","Structure Type Transformer Binding",false],
["structure types",">ts-guide/types.html#(part._.Structure_.Types)","Structure Types",false],
["structure utilities",">reference/structutils.html","Structure Utilities",false],
["structures equality",">reference/structures.html#(idx._(gentag._161._(lib._scribblings/reference/reference..scrbl)))","structures, equality",false],
["structures",">inside/Structures.html","Structures",false],
["structures",">reference/structures.html","Structures",false],
["structures and processing",">scribble/core.html","Structures And Processing",false],
["structures as ports",">reference/portstructs.html","Structures as Ports",false],
["struct~r",">mzlib/mzlib_unit.html#(form._((lib._mzlib/unit..rkt)._struct~7er))",[0,[1,"struct~r"]],["mzlib/unit"]],
["struct~r/ctc",">mzlib/mzlib_unit.html#(form._((lib._mzlib/unit..rkt)._struct~7er/ctc))",[0,[1,"struct~r/ctc"]],["mzlib/unit"]],
["struct~s",">mzlib/mzlib_unit.html#(form._((lib._mzlib/unit..rkt)._struct~7es))",[0,[1,"struct~s"]],["mzlib/unit"]],
["struct~s/ctc",">mzlib/mzlib_unit.html#(form._((lib._mzlib/unit..rkt)._struct~7es/ctc))",[0,[1,"struct~s/ctc"]],["mzlib/unit"]],
["stubborn",">foreign/foreign_pointer-funcs.html#(idx._(gentag._7._(lib._scribblings/foreign/foreign..scrbl)))",[7,"'stubborn"],false],
["stuffer",">web-server/stateless.html#(def._((lib._web-server/scribblings/dummy-stateless-servlet..rkt)._stuffer))",[0,[2,"stuffer"]],[]],
["stuffer",">web-server/stateless.html#(def._((lib._web-server/stuffers/stuffer..rkt)._stuffer))",[0,[2,"stuffer"]],["web-server/stuffers/stuffer"]],
["stuffer-chain",">web-server/stateless.html#(def._((lib._web-server/stuffers/stuffer..rkt)._stuffer-chain))",[0,[2,"stuffer-chain"]],["web-server/stuffers/stuffer"]],
["stuffer-compose",">web-server/stateless.html#(def._((lib._web-server/stuffers/stuffer..rkt)._stuffer-compose))",[0,[2,"stuffer-compose"]],["web-server/stuffers/stuffer"]],
["stuffer-if",">web-server/stateless.html#(def._((lib._web-server/stuffers/stuffer..rkt)._stuffer-if))",[0,[2,"stuffer-if"]],["web-server/stuffers/stuffer"]],
["stuffer-in",">web-server/stateless.html#(def._((lib._web-server/stuffers/stuffer..rkt)._stuffer-in))",[0,[2,"stuffer-in"]],["web-server/stuffers/stuffer"]],
["stuffer-out",">web-server/stateless.html#(def._((lib._web-server/stuffers/stuffer..rkt)._stuffer-out))",[0,[2,"stuffer-out"]],["web-server/stuffers/stuffer"]],
["stuffer-sequence",">web-server/stateless.html#(def._((lib._web-server/stuffers/stuffer..rkt)._stuffer-sequence))",[0,[2,"stuffer-sequence"]],["web-server/stuffers/stuffer"]],
["stuffer/c",">web-server/stateless.html#(def._((lib._web-server/stuffers/stuffer..rkt)._stuffer/c))",[0,[2,"stuffer/c"]],["web-server/stuffers/stuffer"]],
["stuffer?",">web-server/stateless.html#(def._((lib._web-server/stuffers/stuffer..rkt)._stuffer~3f))",[0,[2,"stuffer?"]],["web-server/stuffers/stuffer"]],
["stuffers",">web-server/stateless.html#(part._stuffers)","Stuffers",false],
["stuffers",">web-server/stateless.html#(tech._stuffer)","<span style=\"font-style: italic\">stuffers</span>",false],
["stx",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._stx))",[0,[2,"stx"]],["compiler/zo-structs"]],
["stx->list",">syntax/syntax-helpers.html#(def._((lib._syntax/stx..rkt)._stx-~3elist))",[0,[2,"stx->list"]],["syntax/stx"]],
["stx-car",">syntax/syntax-helpers.html#(def._((lib._syntax/stx..rkt)._stx-car))",[0,[2,"stx-car"]],["syntax/stx"]],
["stx-cdr",">syntax/syntax-helpers.html#(def._((lib._syntax/stx..rkt)._stx-cdr))",[0,[2,"stx-cdr"]],["syntax/stx"]],
["stx-encoded",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._stx-encoded))",[0,[2,"stx-encoded"]],["compiler/zo-structs"]],
["stx-list?",">syntax/syntax-helpers.html#(def._((lib._syntax/stx..rkt)._stx-list~3f))",[0,[2,"stx-list?"]],["syntax/stx"]],
["stx-map",">syntax/syntax-helpers.html#(def._((lib._syntax/stx..rkt)._stx-map))",[0,[2,"stx-map"]],["syntax/stx"]],
["stx-null?",">syntax/syntax-helpers.html#(def._((lib._syntax/stx..rkt)._stx-null~3f))",[0,[2,"stx-null?"]],["syntax/stx"]],
["stx-pair?",">syntax/syntax-helpers.html#(def._((lib._syntax/stx..rkt)._stx-pair~3f))",[0,[2,"stx-pair?"]],["syntax/stx"]],
["stx?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._stx~3f))",[0,[2,"stx?"]],["compiler/zo-structs"]],
["style",">html/index.html#(def._((lib._html/main..rkt)._style))",[0,[2,"style"]],["html"]],
["style",">scribble/core.html#(def._((lib._scribble/core..rkt)._style))",[0,[2,"style"]],["scribble/core"]],
["style",">gui/editor-overview.html#(tech._style)","<span style=\"font-style: italic\">style</span>",false],
["style",">scribble/core.html#(tech._style)","<span style=\"font-style: italic\">style</span>",false],
["style delta",">gui/editor-overview.html#(tech._style._delta)","<span style=\"font-style: italic\">style delta</span>",false],
["style file",">scribble/config.html#(tech._style._file)","<span style=\"font-style: italic\">style file</span>",false],
["style guide",">scribble/reference-style.html","Style Guide",false],
["style list",">gui/editor-overview.html#(tech._style._list)","<span style=\"font-style: italic\">style list</span>",false],
["style name",">scribble/core.html#(tech._style._name)","<span style=\"font-style: italic\">style name</span>",false],
["style property",">scribble/core.html#(tech._style._property)","<span style=\"font-style: italic\">style property</span>",false],
["style-background-used?",">gui/editor-snip_.html#(meth._(((lib._mred/main..rkt)._editor-snip~25)._style-background-used~3f))",[[0,[2,"style-background-used?"]],[14,[" (method of ",[0,[2,"editor-snip%"]],")"]]],["racket/gui/base","racket/gui"]],
["style-delta%",">gui/style-delta_.html",[0,[2,"style-delta%"]],["racket/snip","racket/gui/base","racket/gui"]],
["style-has-changed",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._style-has-changed))",[[0,[2,"style-has-changed"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["style-list%",">gui/style-list_.html",[0,[2,"style-list%"]],["racket/snip","racket/gui/base","racket/gui"]],
["style-name",">scribble/core.html#(def._((lib._scribble/core..rkt)._style-name))",[0,[2,"style-name"]],["scribble/core"]],
["style-properties",">scribble/core.html#(def._((lib._scribble/core..rkt)._style-properties))",[0,[2,"style-properties"]],["scribble/core"]],
["style-to-index",">gui/style-list_.html#(meth._(((lib._racket/snip..rkt)._style-list~25)._style-to-index))",[[0,[2,"style-to-index"]],[14,[" (method of ",[0,[2,"style-list%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["style<%>",">gui/style___.html",[0,[2,"style<%>"]],["racket/snip","racket/gui/base","racket/gui"]],
["style?",">html/index.html#(def._((lib._html/main..rkt)._style~3f))",[0,[2,"style?"]],["html"]],
["style?",">scribble/core.html#(def._((lib._scribble/core..rkt)._style~3f))",[0,[2,"style?"]],["scribble/core"]],
["styled-itemization-style",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._styled-itemization-style))",[0,[2,"styled-itemization-style"]],["scribble/struct"]],
["styled-itemization?",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._styled-itemization~3f))",[0,[2,"styled-itemization?"]],["scribble/struct"]],
["styled-paragraph-style",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._styled-paragraph-style))",[0,[2,"styled-paragraph-style"]],["scribble/struct"]],
["styled-paragraph?",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._styled-paragraph~3f))",[0,[2,"styled-paragraph?"]],["scribble/struct"]],
["styles",">gui/editor-overview.html#(part._editorstyles)","Styles",false],
["styles",">scribble/core.html#(part._style)","Styles",false],
["styles of ->",">guide/contract-func.html#(part._.Styles_of_-_)",["Styles of ",[0,[1,[11,"->"]]]],false],
["sub",">html/index.html#(def._((lib._html/main..rkt)._sub))",[0,[2,"sub"]],["html"]],
["sub-expression evaluation and continuations",">reference/eval-model.html#(part._cont-model)","Sub-expression Evaluation and Continuations",false],
["sub-vec3",">deinprogramm/line3d.html#(def._((lib._teachpack/deinprogramm/line3d..rkt)._sub-vec3))",[0,[2,"sub-vec3"]],["teachpack/deinprogramm/line3d"]],
["sub-vec4",">deinprogramm/line3d.html#(def._((lib._teachpack/deinprogramm/line3d..rkt)._sub-vec4))",[0,[2,"sub-vec4"]],["teachpack/deinprogramm/line3d"]],
["sub-vicinity",">srfi-std/srfi-59.html#sub-vicinity",[0,[2,"sub-vicinity"]],["srfi/59"]],
["sub1",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._sub1))",[0,[2,"sub1"]],["racket/base","racket"]],
["sub1",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._sub1))",[0,[2,"sub1"]],["lang/htdp-advanced"]],
["sub1",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._sub1))",[0,[2,"sub1"]],["lang/htdp-beginner"]],
["sub1",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._sub1))",[0,[2,"sub1"]],["lang/htdp-beginner-abbr"]],
["sub1",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._sub1))",[0,[2,"sub1"]],["lang/htdp-intermediate"]],
["sub1",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._sub1))",[0,[2,"sub1"]],["lang/htdp-intermediate-lambda"]],
["sub1",">plai/mutator.html#(form._((lib._plai/mutator..rkt)._sub1))",[0,[2,"sub1"]],["plai/mutator"]],
["sub?",">html/index.html#(def._((lib._html/main..rkt)._sub~3f))",[0,[2,"sub?"]],["html"]],
["subarea<%>",">gui/subarea___.html",[0,[2,"subarea<%>"]],["racket/gui/base","racket/gui"]],
["subbytes",">reference/bytestrings.html#(def._((quote._~23~25kernel)._subbytes))",[0,[2,"subbytes"]],["racket/base","racket"]],
["subclass?",">reference/objectutils.html#(def._((lib._racket/private/class-internal..rkt)._subclass~3f))",[0,[2,"subclass?"]],["racket/class","racket"]],
["subclass?/c",">reference/Object_and_Class_Contracts.html#(def._((lib._racket/class..rkt)._subclass~3f/c))",[0,[2,"subclass?/c"]],["racket/class","racket"]],
["subcluster",">guide/regexp-clusters.html#(tech._subcluster)","<span style=\"font-style: italic\">subcluster</span>",false],
["subflomap",">images/Resizing.html#(def._((lib._images/flomap..rkt)._subflomap))",[0,[2,"subflomap"]],["images/flomap"]],
["subitem",">slideshow/Primary_Slide_Functions.html#(def._((lib._slideshow/base..rkt)._subitem))",[0,[2,"subitem"]],["slideshow/base","slideshow"]],
["submatch",">guide/regexp-clusters.html#(tech._submatch)","<span style=\"font-style: italic\">submatch</span>",false],
["submit",">web-server/formlets.html#(def._((lib._web-server/formlets/input..rkt)._submit))",[0,[2,"submit"]],["web-server/formlets/input"]],
["submit your package",">planet/Developing_Packages_for_PLaneT.html#(part._.Submit_.Your_.Package)","Submit Your Package",false],
["submit-to-port?",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3aports~3c~25~3e)._submit-to-port~3f))",[[0,[2,"submit-to-port?"]],[14,[" (method of ",[0,[2,"text:ports<%>"]],")"]]],["framework"]],
["submod",">reference/require.html#(form._((lib._racket/private/base..rkt)._submod))",[0,[1,"submod"]],["racket/base","racket"]],
["submodule",">reference/module.html#(idx._(gentag._83._(lib._scribblings/reference/reference..scrbl)))",[7,"'submodule"],false],
["submodule",">reference/module.html#(idx._(gentag._84._(lib._scribblings/reference/reference..scrbl)))",[7,"'submodule"],false],
["submodule",">guide/Module_Syntax.html#(tech._submodule)","<span style=\"font-style: italic\">submodule</span>",false],
["submodule",">reference/eval-model.html#(tech._submodule)","<span style=\"font-style: italic\">submodule</span>",false],
["submodules",">guide/Module_Syntax.html#(part._submodules)","Submodules",false],
["submodules",">reference/eval-model.html#(part._submodules)","Submodules",false],
["subpattern",">guide/regexp-clusters.html#(tech._subpattern)","<span style=\"font-style: italic\">subpattern</span>",false],
["subprocess",">reference/subprocess.html#(def._((quote._~23~25kernel)._subprocess))",[0,[2,"subprocess"]],["racket/base","racket"]],
["subprocess",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Subprocess))",[0,[1,"Subprocess"]],["typed/racket/base","typed/racket"]],
["subprocess-group-enabled",">reference/subprocess.html#(def._((quote._~23~25kernel)._subprocess-group-enabled))",[0,[2,"subprocess-group-enabled"]],["racket/base","racket"]],
["subprocess-kill",">reference/subprocess.html#(def._((quote._~23~25kernel)._subprocess-kill))",[0,[2,"subprocess-kill"]],["racket/base","racket"]],
["subprocess-pid",">reference/subprocess.html#(def._((quote._~23~25kernel)._subprocess-pid))",[0,[2,"subprocess-pid"]],["racket/base","racket"]],
["subprocess-status",">reference/subprocess.html#(def._((quote._~23~25kernel)._subprocess-status))",[0,[2,"subprocess-status"]],["racket/base","racket"]],
["subprocess-wait",">reference/subprocess.html#(def._((quote._~23~25kernel)._subprocess-wait))",[0,[2,"subprocess-wait"]],["racket/base","racket"]],
["subprocess?",">reference/subprocess.html#(def._((quote._~23~25kernel)._subprocess~3f))",[0,[2,"subprocess?"]],["racket/base","racket"]],
["subscript",">scribble/base.html#(def._((lib._scribble/base..rkt)._subscript))",[0,[2,"subscript"]],["scribble/base"]],
["subscript",">unstable/Slideshow_Presentations.html#(form._((lib._unstable/gui/slideshow..rkt)._subscript))",[0,[1,"subscript"]],["unstable/gui/slideshow"]],
["subsection",">scribble/base.html#(def._((lib._scribble/base..rkt)._subsection))",[0,[2,"subsection"]],["scribble/base"]],
["subset?",">reference/sets.html#(def._((lib._racket/set..rkt)._subset~3f))",[0,[2,"subset?"]],["racket/set","racket"]],
["subset?",">mzlib/mzlib_integer-set.html#(def._((lib._mzlib/integer-set..rkt)._subset~3f))",[0,[2,"subset?"]],["mzlib/integer-set"]],
["substring",">reference/strings.html#(def._((quote._~23~25kernel)._substring))",[0,[2,"substring"]],["racket/base","racket"]],
["substring",">r5rs-std/r5rs-Z-H-9.html#%_idx_542",[0,[2,"substring"]],["r5rs"]],
["substring",">r6rs-std/r6rs-Z-H-14.html#node_idx_708",[0,[2,"substring"]],["rnrs/base-6"]],
["substring",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._substring))",[0,[2,"substring"]],["lang/htdp-advanced"]],
["substring",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._substring))",[0,[2,"substring"]],["lang/htdp-beginner"]],
["substring",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._substring))",[0,[2,"substring"]],["lang/htdp-beginner-abbr"]],
["substring",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._substring))",[0,[2,"substring"]],["lang/htdp-intermediate"]],
["substring",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._substring))",[0,[2,"substring"]],["lang/htdp-intermediate-lambda"]],
["substring-spec-ok?",">srfi-std/srfi-13.html#substring-spec-ok-p",[0,[2,"substring-spec-ok?"]],["srfi/13"]],
["substring/shared",">srfi-std/srfi-13.html#substring/shared",[0,[2,"substring/shared"]],["srfi/13"]],
["subsubsection",">scribble/base.html#(def._((lib._scribble/base..rkt)._subsubsection))",[0,[2,"subsubsection"]],["scribble/base"]],
["subsubsub*section",">scribble/base.html#(def._((lib._scribble/base..rkt)._subsubsub*section))",[0,[2,"subsubsub*section"]],["scribble/base"]],
["subtract",">draw/region_.html#(meth._(((lib._racket/draw..rkt)._region~25)._subtract))",[[0,[2,"subtract"]],[14,[" (method of ",[0,[2,"region%"]],")"]]],["racket/draw"]],
["subtract",">htdp-langs/beginner-abbr.html#(idx._htdp-beginner-abbr._(gentag._20._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-beginner-abbr))","subtract",false],
["subtract",">htdp-langs/intermediate.html#(idx._htdp-intermediate._(gentag._30._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-intermediate))","subtract",false],
["subtract",">htdp-langs/intermediate-lam.html#(idx._htdp-intermediate-lambda._(gentag._39._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-intermediate-lambda))","subtract",false],
["subtract",">htdp-langs/advanced.html#(idx._htdp-advanced._(gentag._48._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-advanced))","subtract",false],
["subtract",">htdp-langs/beginner.html#(idx._htdp-beginner._(gentag._5._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-beginner))","subtract",false],
["subtract",">gui/key-event_.html#(idx._(gentag._77._(lib._scribblings/gui/gui..scrbl)))",[7,"'subtract"],false],
["subtract-duration",">srfi-std/srfi-19.html#subtract-duration",[0,[2,"subtract-duration"]],["srfi/19"]],
["subtract-duration!",">srfi-std/srfi-19.html#subtract-duration!",[0,[2,"subtract-duration!"]],["srfi/19"]],
["subtract-in",">reference/require.html#(form._((lib._racket/require..rkt)._subtract-in))",[0,[1,"subtract-in"]],["racket/require"]],
["subtype",">ts-guide/types.html#(tech._subtype)","<span style=\"font-style: italic\">subtype</span>",false],
["subtyping",">ts-guide/types.html#(part._.Subtyping)","Subtyping",false],
["subwindow<%>",">gui/subwindow___.html",[0,[2,"subwindow<%>"]],["racket/gui/base","racket/gui"]],
["sum-ec",">srfi-std/srfi-42.html#sum-ec",[0,[1,"sum-ec"]],["srfi/42"]],
["sup",">html/index.html#(def._((lib._html/main..rkt)._sup))",[0,[2,"sup"]],["html"]],
["sup?",">html/index.html#(def._((lib._html/main..rkt)._sup~3f))",[0,[2,"sup?"]],["html"]],
["super",">reference/createclass.html#(form._((lib._racket/private/class-internal..rkt)._super))",[0,[1,"super"]],["racket/class","racket"]],
["super-init",">mzlib/mzlib_class100.html#(form._((lib._mzlib/class100..rkt)._super-init))",[0,[1,"super-init"]],["mzlib/class100"]],
["super-instantiate",">reference/objcreation.html#(form._((lib._racket/private/class-internal..rkt)._super-instantiate))",[0,[1,"super-instantiate"]],["racket/class","racket"]],
["super-make-object",">reference/objcreation.html#(form._((lib._racket/private/class-internal..rkt)._super-make-object))",[0,[1,"super-make-object"]],["racket/class","racket"]],
["super-new",">reference/objcreation.html#(form._((lib._racket/private/class-internal..rkt)._super-new))",[0,[1,"super-new"]],["racket/class","racket"]],
["super-tell",">foreign/Objective-C_FFI.html#(form._((lib._ffi/unsafe/objc..rkt)._super-tell))",[0,[1,"super-tell"]],["ffi/unsafe/objc"]],
["superclass",">reference/mzlib_class.html#(tech._superclas)","<span style=\"font-style: italic\">superclass</span>",false],
["superscript",">scribble/base.html#(def._((lib._scribble/base..rkt)._superscript))",[0,[2,"superscript"]],["scribble/base"]],
["superscript",">unstable/Slideshow_Presentations.html#(form._((lib._unstable/gui/slideshow..rkt)._superscript))",[0,[1,"superscript"]],["unstable/gui/slideshow"]],
["supertype",">ts-guide/types.html#(tech._supertype)","<span style=\"font-style: italic\">supertype</span>",false],
["supervise-dynamic-place-at",">reference/distributed-places.html#(def._((lib._racket/place/distributed..rkt)._supervise-dynamic-place-at))",[0,[2,"supervise-dynamic-place-at"]],["racket/place/distributed"]],
["supervise-named-dynamic-place-at",">reference/distributed-places.html#(def._((lib._racket/place/distributed..rkt)._supervise-named-dynamic-place-at))",[0,[2,"supervise-named-dynamic-place-at"]],["racket/place/distributed"]],
["supervise-named-place-thunk-at",">reference/distributed-places.html#(def._((lib._racket/place/distributed..rkt)._supervise-named-place-thunk-at))",[0,[2,"supervise-named-place-thunk-at"]],["racket/place/distributed"]],
["supervise-place-thunk-at",">reference/distributed-places.html#(def._((lib._racket/place/distributed..rkt)._supervise-place-thunk-at))",[0,[2,"supervise-place-thunk-at"]],["racket/place/distributed"]],
["supervise-process-at",">reference/distributed-places.html#(def._((lib._racket/place/distributed..rkt)._supervise-process-at))",[0,[2,"supervise-process-at"]],["racket/place/distributed"]],
["supervise-thread-at",">reference/distributed-places.html#(def._((lib._racket/place/distributed..rkt)._supervise-thread-at))",[0,[2,"supervise-thread-at"]],["racket/place/distributed"]],
["support for local-expand",">syntax/transformer-helpers.html#(part._context)",["Support for ",[0,[2,"local-expand"]]],false],
["supporting research",">htdp/index.html#(part._research)","Supporting Research",false],
["surface",">plot/porting.html#(def._((lib._plot/main..rkt)._surface))",[0,[2,"surface"]],["plot"]],
["surface",">plot/compat.html#(def._((lib._plot/compat..rkt)._surface))",[0,[2,"surface"]],["plot/compat"]],
["surface-alpha",">plot/params.html#(def._((lib._plot/main..rkt)._surface-alpha))",[0,[2,"surface-alpha"]],["plot"]],
["surface-color",">plot/params.html#(def._((lib._plot/main..rkt)._surface-color))",[0,[2,"surface-color"]],["plot"]],
["surface-line-color",">plot/params.html#(def._((lib._plot/main..rkt)._surface-line-color))",[0,[2,"surface-line-color"]],["plot"]],
["surface-line-style",">plot/params.html#(def._((lib._plot/main..rkt)._surface-line-style))",[0,[2,"surface-line-style"]],["plot"]],
["surface-line-width",">plot/params.html#(def._((lib._plot/main..rkt)._surface-line-width))",[0,[2,"surface-line-width"]],["plot"]],
["surface-style",">plot/params.html#(def._((lib._plot/main..rkt)._surface-style))",[0,[2,"surface-style"]],["plot"]],
["surface3d",">plot/renderer3d.html#(def._((lib._plot/main..rkt)._surface3d))",[0,[2,"surface3d"]],["plot"]],
["surfaces",">plot/params.html#(part._.Surfaces)","Surfaces",false],
["surrogate",">reference/Surrogates.html#(form._((lib._racket/surrogate..rkt)._surrogate))",[0,[1,"surrogate"]],["racket/surrogate"]],
["surrogates",">reference/Surrogates.html","Surrogates",false],
["suspend-flush",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._suspend-flush))",[[0,[2,"suspend-flush"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["suspend-flush",">gui/canvas___.html#(meth._(((lib._mred/main..rkt)._canvas~3c~25~3e)._suspend-flush))",[[0,[2,"suspend-flush"]],[14,[" (method of ",[0,[2,"canvas<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["suspending, resuming, and killing threads",">reference/threads.html#(part._threadkill)","Suspending, Resuming, and Killing Threads",false],
["svar",">scribble/scribble_manual_code.html#(form._((lib._scribble/manual..rkt)._svar))",[0,[1,"svar"]],["scribble/manual"]],
["svg-dc%",">draw/svg-dc_.html",[0,[2,"svg-dc%"]],["racket/draw"]],
["sw_hide",">reference/subprocess.html#(idx._(gentag._298._(lib._scribblings/reference/reference..scrbl)))",[7,"'SW_HIDE"],false],
["sw_hide",">reference/subprocess.html#(idx._(gentag._297._(lib._scribblings/reference/reference..scrbl)))",[7,"'sw_hide"],false],
["sw_maximize",">reference/subprocess.html#(idx._(gentag._300._(lib._scribblings/reference/reference..scrbl)))",[7,"'SW_MAXIMIZE"],false],
["sw_maximize",">reference/subprocess.html#(idx._(gentag._299._(lib._scribblings/reference/reference..scrbl)))",[7,"'sw_maximize"],false],
["sw_minimize",">reference/subprocess.html#(idx._(gentag._302._(lib._scribblings/reference/reference..scrbl)))",[7,"'SW_MINIMIZE"],false],
["sw_minimize",">reference/subprocess.html#(idx._(gentag._301._(lib._scribblings/reference/reference..scrbl)))",[7,"'sw_minimize"],false],
["sw_restore",">reference/subprocess.html#(idx._(gentag._304._(lib._scribblings/reference/reference..scrbl)))",[7,"'SW_RESTORE"],false],
["sw_restore",">reference/subprocess.html#(idx._(gentag._303._(lib._scribblings/reference/reference..scrbl)))",[7,"'sw_restore"],false],
["sw_show",">reference/subprocess.html#(idx._(gentag._306._(lib._scribblings/reference/reference..scrbl)))",[7,"'SW_SHOW"],false],
["sw_show",">reference/subprocess.html#(idx._(gentag._305._(lib._scribblings/reference/reference..scrbl)))",[7,"'sw_show"],false],
["sw_showdefault",">reference/subprocess.html#(idx._(gentag._308._(lib._scribblings/reference/reference..scrbl)))",[7,"'SW_SHOWDEFAULT"],false],
["sw_showdefault",">reference/subprocess.html#(idx._(gentag._307._(lib._scribblings/reference/reference..scrbl)))",[7,"'sw_showdefault"],false],
["sw_showmaximized",">reference/subprocess.html#(idx._(gentag._310._(lib._scribblings/reference/reference..scrbl)))",[7,"'SW_SHOWMAXIMIZED"],false],
["sw_showmaximized",">reference/subprocess.html#(idx._(gentag._309._(lib._scribblings/reference/reference..scrbl)))",[7,"'sw_showmaximized"],false],
["sw_showminimized",">reference/subprocess.html#(idx._(gentag._312._(lib._scribblings/reference/reference..scrbl)))",[7,"'SW_SHOWMINIMIZED"],false],
["sw_showminimized",">reference/subprocess.html#(idx._(gentag._311._(lib._scribblings/reference/reference..scrbl)))",[7,"'sw_showminimized"],false],
["sw_showminnoactive",">reference/subprocess.html#(idx._(gentag._314._(lib._scribblings/reference/reference..scrbl)))",[7,"'SW_SHOWMINNOACTIVE"],false],
["sw_showminnoactive",">reference/subprocess.html#(idx._(gentag._313._(lib._scribblings/reference/reference..scrbl)))",[7,"'sw_showminnoactive"],false],
["sw_showna",">reference/subprocess.html#(idx._(gentag._316._(lib._scribblings/reference/reference..scrbl)))",[7,"'SW_SHOWNA"],false],
["sw_showna",">reference/subprocess.html#(idx._(gentag._315._(lib._scribblings/reference/reference..scrbl)))",[7,"'sw_showna"],false],
["sw_shownoactivate",">reference/subprocess.html#(idx._(gentag._318._(lib._scribblings/reference/reference..scrbl)))",[7,"'SW_SHOWNOACTIVATE"],false],
["sw_shownoactivate",">reference/subprocess.html#(idx._(gentag._317._(lib._scribblings/reference/reference..scrbl)))",[7,"'sw_shownoactivate"],false],
["sw_shownormal",">reference/subprocess.html#(idx._(gentag._320._(lib._scribblings/reference/reference..scrbl)))",[7,"'SW_SHOWNORMAL"],false],
["sw_shownormal",">reference/subprocess.html#(idx._(gentag._319._(lib._scribblings/reference/reference..scrbl)))",[7,"'sw_shownormal"],false],
["swallow-newline",">preprocessor/mztext.html#(def._((lib._preprocessor/mztext..rkt)._swallow-newline))",[0,[2,"swallow-newline"]],["preprocessor/mztext"]],
["swap-buffers",">draw/gl-context___.html#(meth._(((lib._racket/draw..rkt)._gl-context~3c~25~3e)._swap-buffers))",[[0,[2,"swap-buffers"]],[14,[" (method of ",[0,[2,"gl-context<%>"]],")"]]],["racket/draw"]],
["swap-gl-buffers",">gui/canvas_.html#(meth._(((lib._mred/main..rkt)._canvas~25)._swap-gl-buffers))",[[0,[2,"swap-gl-buffers"]],[14,[" (method of ",[0,[2,"canvas%"]],")"]]],["racket/gui/base","racket/gui"]],
["swindle",">swindle/index.html","Swindle",false],
["swindle",">swindle/index.html",[9,[0,"swindle"]],"module"],
["swindle language",">drracket/legacy.html#(idx._(gentag._42._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Swindle</span> language",false],
["swiss",">gui/style-delta_.html#(idx._(gentag._199._(lib._scribblings/gui/gui..scrbl)))",[7,"'swiss"],false],
["swiss",">draw/font_.html#(idx._(gentag._32._(lib._scribblings/draw/draw..scrbl)))",[7,"'swiss"],false],
["switch",">frtime/index.html#(def._((lib._frtime/main..rkt)._switch))",[0,[2,"switch"]],["frtime"]],
["switch-to",">gui/style___.html#(meth._(((lib._racket/snip..rkt)._style~3c~25~3e)._switch-to))",[[0,[2,"switch-to"]],[14,[" (method of ",[0,[2,"style<%>"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["switchable button",">mrlib/Switchable_Button.html","Switchable Button",false],
["switchable-button%",">mrlib/Switchable_Button.html#(def._((lib._mrlib/switchable-button..rkt)._switchable-button~25))",[0,[2,"switchable-button%"]],["mrlib/switchable-button"]],
["symbol",">deinprogramm/advanced-signatures.html#(form._((lib._deinprogramm/.D.Md.A-advanced..rkt)._symbol))",[0,"symbol"],["deinprogramm/DMdA-advanced"]],
["symbol",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Symbol))",[0,[1,"Symbol"]],["typed/racket/base","typed/racket"]],
["symbol",">gui/style-delta_.html#(idx._(gentag._201._(lib._scribblings/gui/gui..scrbl)))",[7,"'symbol"],false],
["symbol",">draw/font_.html#(idx._(gentag._34._(lib._scribblings/draw/draw..scrbl)))",[7,"'symbol"],false],
["symbol",">tools/adding-languages.html#(idx._(gentag._9._(lib._scribblings/tools/tools..scrbl)))",[7,"'symbol"],false],
["symbol",">redex/The_Redex_Reference.html#(tech._symbol)",[0,"symbol"],false],
["symbol",">guide/symbols.html#(tech._symbol)","<span style=\"font-style: italic\">symbol</span>",false],
["symbol",">reference/symbols.html#(tech._symbol)","<span style=\"font-style: italic\">symbol</span>",false],
["symbol and text icons",">images/Icons.html#(part._symbol)","Symbol and Text Icons",false],
["symbol->imap-flag",">net/imap.html#(def._((lib._net/imap..rkt)._symbol-~3eimap-flag))",[0,[2,"symbol->imap-flag"]],["net/imap"]],
["symbol->string",">reference/symbols.html#(def._((quote._~23~25kernel)._symbol-~3estring))",[0,[2,"symbol->string"]],["racket/base","racket"]],
["symbol->string",">r5rs-std/r5rs-Z-H-9.html#%_idx_462",[0,[2,"symbol->string"]],["r5rs"]],
["symbol->string",">r6rs-std/r6rs-Z-H-14.html#node_idx_648",[0,[2,"symbol->string"]],["rnrs/base-6"]],
["symbol->string",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._symbol-~3estring))",[0,[2,"symbol->string"]],["lang/htdp-advanced"]],
["symbol->string",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._symbol-~3estring))",[0,[2,"symbol->string"]],["lang/htdp-beginner"]],
["symbol->string",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._symbol-~3estring))",[0,[2,"symbol->string"]],["lang/htdp-beginner-abbr"]],
["symbol->string",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._symbol-~3estring))",[0,[2,"symbol->string"]],["lang/htdp-intermediate"]],
["symbol->string",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._symbol-~3estring))",[0,[2,"symbol->string"]],["lang/htdp-intermediate-lambda"]],
["symbol->string",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._symbol-~3estring))",[0,"symbol->string"],["deinprogramm/DMdA-advanced"]],
["symbol-arg",">web-server/dispatch.html#(form._((lib._web-server/dispatch..rkt)._symbol-arg))",[0,[1,"symbol-arg"]],["web-server/dispatch"]],
["symbol-color",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._symbol-color))",[0,[2,"symbol-color"]],["scribble/racket","scribble/scheme"]],
["symbol-hash",">r6rs-lib-std/r6rs-lib-Z-H-14.html#node_idx_1224",[0,[2,"symbol-hash"]],["rnrs/hashtables-6"]],
["symbol-interned?",">reference/symbols.html#(def._((quote._~23~25kernel)._symbol-interned~3f))",[0,[2,"symbol-interned?"]],["racket/base","racket"]],
["symbol-unreadable?",">reference/symbols.html#(def._((quote._~23~25kernel)._symbol-unreadable~3f))",[0,[2,"symbol-unreadable?"]],["racket/base","racket"]],
["symbol=?",">reference/booleans.html#(def._((lib._racket/bool..rkt)._symbol~3d~3f))",[0,[2,"symbol=?"]],["racket/bool","racket"]],
["symbol=?",">r6rs-std/r6rs-Z-H-14.html#node_idx_650",[0,[2,"symbol=?"]],["rnrs/base-6"]],
["symbol=?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._symbol~3d~3f))",[0,[2,"symbol=?"]],["lang/htdp-advanced"]],
["symbol=?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._symbol~3d~3f))",[0,[2,"symbol=?"]],["lang/htdp-beginner"]],
["symbol=?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._symbol~3d~3f))",[0,[2,"symbol=?"]],["lang/htdp-beginner-abbr"]],
["symbol=?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._symbol~3d~3f))",[0,[2,"symbol=?"]],["lang/htdp-intermediate"]],
["symbol=?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._symbol~3d~3f))",[0,[2,"symbol=?"]],["lang/htdp-intermediate-lambda"]],
["symbol=?",">lazy/index.html#(def._((lib._lazy/main..rkt)._symbol~3d~3f))",[0,[2,"symbol=?"]],["lazy"]],
["symbol=?",">plai/mutator.html#(form._((lib._plai/mutator..rkt)._symbol~3d~3f))",[0,[2,"symbol=?"]],["plai/mutator"]],
["symbol?",">reference/symbols.html#(def._((quote._~23~25kernel)._symbol~3f))",[0,[2,"symbol?"]],["racket/base","racket"]],
["symbol?",">r5rs-std/r5rs-Z-H-9.html#%_idx_460",[0,[2,"symbol?"]],["r5rs"]],
["symbol?",">r6rs-std/r6rs-Z-H-14.html#node_idx_646",[0,[2,"symbol?"]],["rnrs/base-6"]],
["symbol?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._symbol~3f))",[0,[2,"symbol?"]],["lang/htdp-advanced"]],
["symbol?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._symbol~3f))",[0,[2,"symbol?"]],["lang/htdp-beginner"]],
["symbol?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._symbol~3f))",[0,[2,"symbol?"]],["lang/htdp-beginner-abbr"]],
["symbol?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._symbol~3f))",[0,[2,"symbol?"]],["lang/htdp-intermediate"]],
["symbol?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._symbol~3f))",[0,[2,"symbol?"]],["lang/htdp-intermediate-lambda"]],
["symbol?",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._symbol~3f))",[0,"symbol?"],["deinprogramm/DMdA-advanced"]],
["symbol?",">plai/mutator.html#(form._((lib._plai/mutator..rkt)._symbol~3f))",[0,[2,"symbol?"]],["plai/mutator"]],
["symbolic",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex..rkt)._symbolic))",[0,[1,"symbolic"]],["parser-tools/lex"]],
["symbols unique",">reference/symbols.html","symbols, unique",false],
["symbols generating",">reference/symbols.html","symbols, generating",false],
["symbols",">guide/symbols.html","Symbols",false],
["symbols",">htdp-langs/advanced.html#(part._htdp-advanced._.Symbols)","Symbols",false],
["symbols",">htdp-langs/beginner.html#(part._htdp-beginner._.Symbols)","Symbols",false],
["symbols",">htdp-langs/beginner-abbr.html#(part._htdp-beginner-abbr._.Symbols)","Symbols",false],
["symbols",">htdp-langs/intermediate.html#(part._htdp-intermediate._.Symbols)","Symbols",false],
["symbols",">htdp-langs/intermediate-lam.html#(part._htdp-intermediate-lambda._.Symbols)","Symbols",false],
["symbols",">reference/symbols.html","Symbols",false],
["symbols",">reference/data-structure-contracts.html#(def._((lib._racket/contract/private/misc..rkt)._symbols))",[0,[2,"symbols"]],["racket/contract/base","racket/contract","racket"]],
["sync",">reference/sync.html#(def._((quote._~23~25kernel)._sync))",[0,[2,"sync"]],["racket/base","racket"]],
["sync",">inside/threads.html#(idx._(gentag._336._(lib._scribblings/inside/inside..scrbl)))",[0,[2,"sync"]],false],
["sync-events",">reference/distributed-places.html#(meth._(((lib._racket/place/distributed..rkt)._node~25)._sync-events))",[[0,[2,"sync-events"]],[14,[" (method of ",[0,[2,"node%"]],")"]]],["racket/place/distributed"]],
["sync/enable-break",">reference/sync.html#(def._((quote._~23~25kernel)._sync/enable-break))",[0,[2,"sync/enable-break"]],["racket/base","racket"]],
["sync/timeout",">reference/sync.html#(def._((quote._~23~25kernel)._sync/timeout))",[0,[2,"sync/timeout"]],["racket/base","racket"]],
["sync/timeout/enable-break",">reference/sync.html#(def._((quote._~23~25kernel)._sync/timeout/enable-break))",[0,[2,"sync/timeout/enable-break"]],["racket/base","racket"]],
["syncheck-annotations<%>",">tools/Check_Syntax.html#(def._((lib._drracket/check-syntax..rkt)._syncheck-annotations~3c~25~3e))",[0,[2,"syncheck-annotations<%>"]],["drracket/check-syntax"]],
["syncheck-bitmap",">tools/Check_Syntax.html#(def._((lib._drracket/syncheck-drracket-button..rkt)._syncheck-bitmap))",[0,[2,"syncheck-bitmap"]],["drracket/syncheck-drracket-button"]],
["syncheck-drracket-button",">tools/Check_Syntax.html#(def._((lib._drracket/syncheck-drracket-button..rkt)._syncheck-drracket-button))",[0,[2,"syncheck-drracket-button"]],["drracket/syncheck-drracket-button"]],
["syncheck:add-arrow",">tools/Check_Syntax.html#(form._((lib._drracket/check-syntax..rkt)._syncheck~3aadd-arrow))",[0,[1,"syncheck:add-arrow"]],["drracket/check-syntax"]],
["syncheck:add-arrow",">tools/Check_Syntax.html#(meth._(((lib._drracket/check-syntax..rkt)._syncheck-annotations~3c~25~3e)._syncheck~3aadd-arrow))",[[0,[2,"syncheck:add-arrow"]],[14,[" (method of ",[0,[2,"syncheck-annotations<%>"]],")"]]],["drracket/check-syntax"]],
["syncheck:add-background-color",">tools/Check_Syntax.html#(form._((lib._drracket/check-syntax..rkt)._syncheck~3aadd-background-color))",[0,[1,"syncheck:add-background-color"]],["drracket/check-syntax"]],
["syncheck:add-background-color",">tools/Check_Syntax.html#(meth._(((lib._drracket/check-syntax..rkt)._syncheck-annotations~3c~25~3e)._syncheck~3aadd-background-color))",[[0,[2,"syncheck:add-background-color"]],[14,[" (method of ",[0,[2,"syncheck-annotations<%>"]],")"]]],["drracket/check-syntax"]],
["syncheck:add-docs-menu",">tools/Check_Syntax.html#(form._((lib._drracket/check-syntax..rkt)._syncheck~3aadd-docs-menu))",[0,[1,"syncheck:add-docs-menu"]],["drracket/check-syntax"]],
["syncheck:add-docs-menu",">tools/Check_Syntax.html#(meth._(((lib._drracket/check-syntax..rkt)._syncheck-annotations~3c~25~3e)._syncheck~3aadd-docs-menu))",[[0,[2,"syncheck:add-docs-menu"]],[14,[" (method of ",[0,[2,"syncheck-annotations<%>"]],")"]]],["drracket/check-syntax"]],
["syncheck:add-jump-to-definition",">tools/Check_Syntax.html#(form._((lib._drracket/check-syntax..rkt)._syncheck~3aadd-jump-to-definition))",[0,[1,"syncheck:add-jump-to-definition"]],["drracket/check-syntax"]],
["syncheck:add-jump-to-definition",">tools/Check_Syntax.html#(meth._(((lib._drracket/check-syntax..rkt)._syncheck-annotations~3c~25~3e)._syncheck~3aadd-jump-to-definition))",[[0,[2,"syncheck:add-jump-to-definition"]],[14,[" (method of ",[0,[2,"syncheck-annotations<%>"]],")"]]],["drracket/check-syntax"]],
["syncheck:add-mouse-over-status",">tools/Check_Syntax.html#(form._((lib._drracket/check-syntax..rkt)._syncheck~3aadd-mouse-over-status))",[0,[1,"syncheck:add-mouse-over-status"]],["drracket/check-syntax"]],
["syncheck:add-mouse-over-status",">tools/Check_Syntax.html#(meth._(((lib._drracket/check-syntax..rkt)._syncheck-annotations~3c~25~3e)._syncheck~3aadd-mouse-over-status))",[[0,[2,"syncheck:add-mouse-over-status"]],[14,[" (method of ",[0,[2,"syncheck-annotations<%>"]],")"]]],["drracket/check-syntax"]],
["syncheck:add-rename-menu",">tools/Check_Syntax.html#(form._((lib._drracket/check-syntax..rkt)._syncheck~3aadd-rename-menu))",[0,[1,"syncheck:add-rename-menu"]],["drracket/check-syntax"]],
["syncheck:add-rename-menu",">tools/Check_Syntax.html#(meth._(((lib._drracket/check-syntax..rkt)._syncheck-annotations~3c~25~3e)._syncheck~3aadd-rename-menu))",[[0,[2,"syncheck:add-rename-menu"]],[14,[" (method of ",[0,[2,"syncheck-annotations<%>"]],")"]]],["drracket/check-syntax"]],
["syncheck:add-require-open-menu",">tools/Check_Syntax.html#(form._((lib._drracket/check-syntax..rkt)._syncheck~3aadd-require-open-menu))",[0,[1,"syncheck:add-require-open-menu"]],["drracket/check-syntax"]],
["syncheck:add-require-open-menu",">tools/Check_Syntax.html#(meth._(((lib._drracket/check-syntax..rkt)._syncheck-annotations~3c~25~3e)._syncheck~3aadd-require-open-menu))",[[0,[2,"syncheck:add-require-open-menu"]],[14,[" (method of ",[0,[2,"syncheck-annotations<%>"]],")"]]],["drracket/check-syntax"]],
["syncheck:add-tail-arrow",">tools/Check_Syntax.html#(form._((lib._drracket/check-syntax..rkt)._syncheck~3aadd-tail-arrow))",[0,[1,"syncheck:add-tail-arrow"]],["drracket/check-syntax"]],
["syncheck:add-tail-arrow",">tools/Check_Syntax.html#(meth._(((lib._drracket/check-syntax..rkt)._syncheck-annotations~3c~25~3e)._syncheck~3aadd-tail-arrow))",[[0,[2,"syncheck:add-tail-arrow"]],[14,[" (method of ",[0,[2,"syncheck-annotations<%>"]],")"]]],["drracket/check-syntax"]],
["syncheck:button-callback",">tools/Check_Syntax.html#(form._((lib._drracket/syncheck-drracket-button..rkt)._syncheck~3abutton-callback))",[0,[1,"syncheck:button-callback"]],["drracket/syncheck-drracket-button"]],
["syncheck:color-range",">tools/Check_Syntax.html#(form._((lib._drracket/check-syntax..rkt)._syncheck~3acolor-range))",[0,[1,"syncheck:color-range"]],["drracket/check-syntax"]],
["syncheck:color-range",">tools/Check_Syntax.html#(meth._(((lib._drracket/check-syntax..rkt)._syncheck-annotations~3c~25~3e)._syncheck~3acolor-range))",[[0,[2,"syncheck:color-range"]],[14,[" (method of ",[0,[2,"syncheck-annotations<%>"]],")"]]],["drracket/check-syntax"]],
["syncheck:find-source-object",">tools/Check_Syntax.html#(form._((lib._drracket/check-syntax..rkt)._syncheck~3afind-source-object))",[0,[1,"syncheck:find-source-object"]],["drracket/check-syntax"]],
["syncheck:find-source-object",">tools/Check_Syntax.html#(meth._(((lib._drracket/check-syntax..rkt)._syncheck-annotations~3c~25~3e)._syncheck~3afind-source-object))",[[0,[2,"syncheck:find-source-object"]],[14,[" (method of ",[0,[2,"syncheck-annotations<%>"]],")"]]],["drracket/check-syntax"]],
["synchronizable event",">reference/sync.html#(tech._synchronizable._event)","<span style=\"font-style: italic\">synchronizable event</span>",false],
["synchronization",">reference/all-sync.html","Synchronization",false],
["synchronization result",">reference/sync.html#(tech._synchronization._result)","<span style=\"font-style: italic\">synchronization result</span>",false],
["synchronized",">guide/performance.html#(tech._synchronized)","<span style=\"font-style: italic\">synchronized</span>",false],
["synchronizing thread state",">reference/threads.html#(part._threadsync)","Synchronizing Thread State",false],
["syntactic form",">reference/syntax-model.html#(tech._syntactic._form)","<span style=\"font-style: italic\">syntactic form</span>",false],
["syntactic forms",">reference/syntax.html","Syntactic Forms",false],
["syntactic forms and procedures",">foreign/Objective-C_FFI.html#(part._.Syntactic_.Forms_and_.Procedures)","Syntactic Forms and Procedures",false],
["syntactic normalization",">syntax/varied-meanings.html#(part._.Syntactic_.Normalization)","Syntactic Normalization",false],
["syntax",">htdp-langs/beginner.html#(part._beginner-syntax)","Syntax",false],
["syntax",">unstable/syntax.html","Syntax",false],
["syntax",">reference/stx-patterns.html#(form._((lib._racket/private/stxcase-scheme..rkt)._syntax))",[0,[1,"syntax"]],["racket/base","racket"]],
["syntax",">r6rs-lib-std/r6rs-lib-Z-H-13.html#node_idx_1134",[0,[1,"syntax"]],["rnrs/syntax-case-6"]],
["syntax",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Syntax))",[0,[1,"Syntax"]],["typed/racket/base","typed/racket"]],
["syntax browser",">macro-debugger/index.html#(part._.Syntax_.Browser)","Syntax Browser",false],
["syntax class",">syntax/stxparse-specifying.html#(tech._syntax._clas)","<span style=\"font-style: italic\">syntax class</span>",false],
["syntax class specialization",">syntax/Experimental.html#(part._.Syntax_.Class_.Specialization)","Syntax Class Specialization",false],
["syntax classes",">syntax/Library_Syntax_Classes_and_Literal_Sets.html#(part._.Syntax_.Classes)","Syntax Classes",false],
["syntax color: utilities",">syntax-color/index.html","Syntax Color: Utilities",false],
["syntax for advanced",">htdp-langs/advanced.html#(part._advanced-syntax)","Syntax for Advanced",false],
["syntax for intermediate",">htdp-langs/intermediate.html#(part._intermediate-syntax)","Syntax for Intermediate",false],
["syntax for intermediate with lambda",">htdp-langs/intermediate-lam.html#(part._intm-w-lambda-syntax)","Syntax for Intermediate with Lambda",false],
["syntax mark",">reference/syntax-model.html#(tech._syntax._mark)","<span style=\"font-style: italic\">syntax mark</span>",false],
["syntax model",">reference/syntax-model.html","Syntax Model",false],
["syntax object",">reference/syntax-model.html#(tech._syntax._object)","<span style=\"font-style: italic\">syntax object</span>",false],
["syntax object bindings",">reference/stxcmp.html","Syntax Object Bindings",false],
["syntax object content",">reference/stxops.html","Syntax Object Content",false],
["syntax object helpers",">syntax/syntax-helpers.html","Syntax Object Helpers",false],
["syntax object properties",">reference/stxprops.html","Syntax Object Properties",false],
["syntax object source locations",">unstable/syntax.html#(part._.Syntax_.Object_.Source_.Locations)","Syntax Object Source Locations",false],
["syntax objects",">guide/stx-obj.html","Syntax Objects",false],
["syntax objects",">raco/decompile.html#(part._.Syntax_.Objects)","Syntax Objects",false],
["syntax objects",">reference/syntax-model.html#(part._stxobj-model)","Syntax Objects",false],
["syntax objects",">ts-reference/type-ref.html#(part._.Syntax_.Objects)","Syntax Objects",false],
["syntax objects",">guide/stx-obj.html#(tech._syntax._object)","<span style=\"font-style: italic\">syntax objects</span>",false],
["syntax pair",">reference/stxops.html#(tech._syntax._pair)","<span style=\"font-style: italic\">syntax pair</span>",false],
["syntax parameter",">reference/stxparam.html#(tech._syntax._parameter)","<span style=\"font-style: italic\">syntax\nparameter</span>",false],
["syntax parameter inspection",">reference/stxparam.html#(part._.Syntax_.Parameter_.Inspection)","Syntax Parameter Inspection",false],
["syntax parameters",">reference/stxparam.html","Syntax Parameters",false],
["syntax patterns",">syntax/stxparse-patterns.html","Syntax Patterns",false],
["syntax patterns",">syntax/stxparse-patterns.html#(tech._syntax._pattern)","<span style=\"font-style: italic\">syntax patterns</span>",false],
["syntax properties",">scribble/reader-internals.html#(part._.Syntax_.Properties)","Syntax Properties",false],
["syntax property",">reference/stxprops.html#(tech._syntax._property)","<span style=\"font-style: italic\">syntax property</span>",false],
["syntax quoting: quote-syntax",">reference/Syntax_Quoting__quote-syntax.html",["Syntax Quoting: ",[0,[1,"quote-syntax"]]],false],
["syntax taints",">guide/stx-certs.html","Syntax Taints",false],
["syntax taints",">reference/stxcerts.html","Syntax Taints",false],
["syntax templates",">syntax/Experimental.html#(part._.Syntax_.Templates)","Syntax Templates",false],
["syntax transformer",">reference/syntax-model.html#(tech._syntax._transformer)","<span style=\"font-style: italic\">syntax transformer</span>",false],
["syntax transformers",">reference/stxtrans.html","Syntax Transformers",false],
["syntax utilities",">reference/syntax-util.html","Syntax Utilities",false],
["syntax->datum",">reference/stxops.html#(def._((quote._~23~25kernel)._syntax-~3edatum))",[0,[2,"syntax->datum"]],["racket/base","racket"]],
["syntax->datum",">r6rs-lib-std/r6rs-lib-Z-H-13.html#node_idx_1144",[0,[2,"syntax->datum"]],["rnrs/syntax-case-6"]],
["syntax->list",">reference/stxops.html#(def._((quote._~23~25kernel)._syntax-~3elist))",[0,[2,"syntax->list"]],["racket/base","racket"]],
["syntax->string",">syntax/syntax-helpers.html#(def._((lib._syntax/to-string..rkt)._syntax-~3estring))",[0,[2,"syntax->string"]],["syntax/to-string"]],
["syntax-arm",">reference/stxcerts.html#(def._((quote._~23~25kernel)._syntax-arm))",[0,[2,"syntax-arm"]],["racket/base","racket"]],
["syntax-case",">reference/stx-patterns.html#(form._((lib._racket/private/stxcase-scheme..rkt)._syntax-case))",[0,[1,"syntax-case"]],["racket/base","racket"]],
["syntax-case",">r6rs-lib-std/r6rs-lib-Z-H-13.html#node_idx_1124",[0,[1,"syntax-case"]],["rnrs/syntax-case-6"]],
["syntax-case*",">reference/stx-patterns.html#(form._((lib._racket/private/stxcase-scheme..rkt)._syntax-case*))",[0,[1,"syntax-case*"]],["racket/base","racket"]],
["syntax-class-arity",">syntax/Debugging_and_Inspection_Tools.html#(form._((lib._syntax/parse/debug..rkt)._syntax-class-arity))",[0,[1,"syntax-class-arity"]],["syntax/parse/debug"]],
["syntax-class-attributes",">syntax/Debugging_and_Inspection_Tools.html#(form._((lib._syntax/parse/debug..rkt)._syntax-class-attributes))",[0,[1,"syntax-class-attributes"]],["syntax/parse/debug"]],
["syntax-class-keywords",">syntax/Debugging_and_Inspection_Tools.html#(form._((lib._syntax/parse/debug..rkt)._syntax-class-keywords))",[0,[1,"syntax-class-keywords"]],["syntax/parse/debug"]],
["syntax-class-parse",">syntax/Debugging_and_Inspection_Tools.html#(form._((lib._syntax/parse/debug..rkt)._syntax-class-parse))",[0,[1,"syntax-class-parse"]],["syntax/parse/debug"]],
["syntax-class/c",">syntax/Experimental.html#(form._((lib._syntax/parse/experimental/provide..rkt)._syntax-class/c))",[0,[1,"syntax-class/c"]],["syntax/parse/experimental/provide"]],
["syntax-color/default-lexer",">syntax-color/index.html#(mod-path._syntax-color/default-lexer)",[9,[0,"syntax-color/default-lexer"]],"module"],
["syntax-color/module-lexer",">syntax-color/index.html#(mod-path._syntax-color/module-lexer)",[9,[0,"syntax-color/module-lexer"]],"module"],
["syntax-color/paren-tree",">syntax-color/index.html#(mod-path._syntax-color/paren-tree)",[9,[0,"syntax-color/paren-tree"]],"module"],
["syntax-color/scheme-lexer",">syntax-color/index.html#(mod-path._syntax-color/scheme-lexer)",[9,[0,"syntax-color/scheme-lexer"]],"module"],
["syntax-color/scribble-lexer",">syntax-color/index.html#(mod-path._syntax-color/scribble-lexer)",[9,[0,"syntax-color/scribble-lexer"]],"module"],
["syntax-color/token-tree",">syntax-color/index.html#(mod-path._syntax-color/token-tree)",[9,[0,"syntax-color/token-tree"]],"module"],
["syntax-column",">reference/stxops.html#(def._((quote._~23~25kernel)._syntax-column))",[0,[2,"syntax-column"]],["racket/base","racket"]],
["syntax-disarm",">reference/stxcerts.html#(def._((quote._~23~25kernel)._syntax-disarm))",[0,[2,"syntax-disarm"]],["racket/base","racket"]],
["syntax-e",">reference/stxops.html#(def._((quote._~23~25kernel)._syntax-e))",[0,[2,"syntax-e"]],["racket/base","racket"]],
["syntax-e",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Syntax-.E))",[0,[1,"Syntax-E"]],["typed/racket/base","typed/racket"]],
["syntax-icon-color",">images/Icons.html#(def._((lib._images/icons/style..rkt)._syntax-icon-color))",[0,[2,"syntax-icon-color"]],["images/icons/style"]],
["syntax-id-rules",">reference/stx-patterns.html#(form._((lib._racket/private/stxcase-scheme..rkt)._syntax-id-rules))",[0,[1,"syntax-id-rules"]],["racket/base","racket"]],
["syntax-line",">reference/stxops.html#(def._((quote._~23~25kernel)._syntax-line))",[0,[2,"syntax-line"]],["racket/base","racket"]],
["syntax-link-color",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._syntax-link-color))",[0,[2,"syntax-link-color"]],["scribble/racket","scribble/scheme"]],
["syntax-local-bind-syntaxes",">reference/stxtrans.html#(def._((quote._~23~25kernel)._syntax-local-bind-syntaxes))",[0,[2,"syntax-local-bind-syntaxes"]],["racket/base","racket"]],
["syntax-local-certifier",">reference/stxtrans.html#(def._((lib._racket/private/base..rkt)._syntax-local-certifier))",[0,[2,"syntax-local-certifier"]],["racket/base","racket"]],
["syntax-local-context",">reference/stxtrans.html#(def._((quote._~23~25kernel)._syntax-local-context))",[0,[2,"syntax-local-context"]],["racket/base","racket"]],
["syntax-local-eval",">reference/syntax-util.html#(def._((lib._racket/syntax..rkt)._syntax-local-eval))",[0,[2,"syntax-local-eval"]],["racket/syntax"]],
["syntax-local-expand-expression",">reference/stxtrans.html#(def._((quote._~23~25kernel)._syntax-local-expand-expression))",[0,[2,"syntax-local-expand-expression"]],["racket/base","racket"]],
["syntax-local-get-shadower",">reference/stxtrans.html#(def._((quote._~23~25kernel)._syntax-local-get-shadower))",[0,[2,"syntax-local-get-shadower"]],["racket/base","racket"]],
["syntax-local-infer-name",">syntax/transformer-helpers.html#(def._((lib._syntax/name..rkt)._syntax-local-infer-name))",[0,[2,"syntax-local-infer-name"]],["syntax/name"]],
["syntax-local-introduce",">reference/stxtrans.html#(def._((quote._~23~25kernel)._syntax-local-introduce))",[0,[2,"syntax-local-introduce"]],["racket/base","racket"]],
["syntax-local-lift-context",">reference/stxtrans.html#(def._((quote._~23~25kernel)._syntax-local-lift-context))",[0,[2,"syntax-local-lift-context"]],["racket/base","racket"]],
["syntax-local-lift-expression",">reference/stxtrans.html#(def._((quote._~23~25kernel)._syntax-local-lift-expression))",[0,[2,"syntax-local-lift-expression"]],["racket/base","racket"]],
["syntax-local-lift-module-end-declaration",">reference/stxtrans.html#(def._((quote._~23~25kernel)._syntax-local-lift-module-end-declaration))",[0,[2,"syntax-local-lift-module-end-declaration"]],["racket/base","racket"]],
["syntax-local-lift-provide",">reference/stxtrans.html#(def._((quote._~23~25kernel)._syntax-local-lift-provide))",[0,[2,"syntax-local-lift-provide"]],["racket/base","racket"]],
["syntax-local-lift-require",">reference/stxtrans.html#(def._((quote._~23~25kernel)._syntax-local-lift-require))",[0,[2,"syntax-local-lift-require"]],["racket/base","racket"]],
["syntax-local-lift-values-expression",">reference/stxtrans.html#(def._((quote._~23~25kernel)._syntax-local-lift-values-expression))",[0,[2,"syntax-local-lift-values-expression"]],["racket/base","racket"]],
["syntax-local-make-definition-context",">reference/stxtrans.html#(def._((quote._~23~25kernel)._syntax-local-make-definition-context))",[0,[2,"syntax-local-make-definition-context"]],["racket/base","racket"]],
["syntax-local-make-delta-introducer",">reference/stxtrans.html#(def._((quote._~23~25kernel)._syntax-local-make-delta-introducer))",[0,[2,"syntax-local-make-delta-introducer"]],["racket/base","racket"]],
["syntax-local-module-defined-identifiers",">reference/stxtrans.html#(def._((quote._~23~25kernel)._syntax-local-module-defined-identifiers))",[0,[2,"syntax-local-module-defined-identifiers"]],["racket/base","racket"]],
["syntax-local-module-exports",">reference/stxtrans.html#(def._((quote._~23~25kernel)._syntax-local-module-exports))",[0,[2,"syntax-local-module-exports"]],["racket/base","racket"]],
["syntax-local-module-required-identifiers",">reference/stxtrans.html#(def._((quote._~23~25kernel)._syntax-local-module-required-identifiers))",[0,[2,"syntax-local-module-required-identifiers"]],["racket/base","racket"]],
["syntax-local-name",">reference/stxtrans.html#(def._((quote._~23~25kernel)._syntax-local-name))",[0,[2,"syntax-local-name"]],["racket/base","racket"]],
["syntax-local-phase-level",">reference/stxtrans.html#(def._((quote._~23~25kernel)._syntax-local-phase-level))",[0,[2,"syntax-local-phase-level"]],["racket/base","racket"]],
["syntax-local-provide-certifier",">reference/stxtrans.html#(def._((lib._racket/provide-transform..rkt)._syntax-local-provide-certifier))",[0,[2,"syntax-local-provide-certifier"]],["racket/provide-transform"]],
["syntax-local-require-certifier",">reference/stxtrans.html#(def._((lib._racket/require-transform..rkt)._syntax-local-require-certifier))",[0,[2,"syntax-local-require-certifier"]],["racket/require-transform"]],
["syntax-local-submodules",">reference/stxtrans.html#(def._((quote._~23~25kernel)._syntax-local-submodules))",[0,[2,"syntax-local-submodules"]],["racket/base","racket"]],
["syntax-local-transforming-module-provides?",">reference/stxtrans.html#(def._((quote._~23~25kernel)._syntax-local-transforming-module-provides~3f))",[0,[2,"syntax-local-transforming-module-provides?"]],["racket/base","racket"]],
["syntax-local-value",">reference/stxtrans.html#(def._((quote._~23~25kernel)._syntax-local-value))",[0,[2,"syntax-local-value"]],["racket/base","racket"]],
["syntax-local-value/immediate",">reference/stxtrans.html#(def._((quote._~23~25kernel)._syntax-local-value/immediate))",[0,[2,"syntax-local-value/immediate"]],["racket/base","racket"]],
["syntax-local-value/record",">reference/syntax-util.html#(def._((lib._racket/syntax..rkt)._syntax-local-value/record))",[0,[2,"syntax-local-value/record"]],["racket/syntax"]],
["syntax-map",">unstable/syntax.html#(def._((lib._unstable/syntax..rkt)._syntax-map))",[0,[2,"syntax-map"]],["unstable/syntax"]],
["syntax-object->datum",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..rkt)._syntax-object-~3edatum))",[0,[2,"syntax-object->datum"]],["mzscheme"]],
["syntax-original?",">reference/stxops.html#(def._((quote._~23~25kernel)._syntax-original~3f))",[0,[2,"syntax-original?"]],["racket/base","racket"]],
["syntax-parameter-value",">reference/stxparam.html#(def._((lib._racket/stxparam-exptime..rkt)._syntax-parameter-value))",[0,[2,"syntax-parameter-value"]],["racket/stxparam-exptime","racket/stxparam"]],
["syntax-parameterize",">reference/stxparam.html#(form._((lib._racket/stxparam..rkt)._syntax-parameterize))",[0,[1,"syntax-parameterize"]],["racket/stxparam"]],
["syntax-parse",">syntax/Parsing_Syntax.html#(form._((lib._syntax/parse..rkt)._syntax-parse))",[0,[1,"syntax-parse"]],["syntax/parse"]],
["syntax-parser",">syntax/Parsing_Syntax.html#(form._((lib._syntax/parse..rkt)._syntax-parser))",[0,[1,"syntax-parser"]],["syntax/parse"]],
["syntax-pattern-variable?",">reference/stx-patterns.html#(def._((lib._racket/private/stxcase-scheme..rkt)._syntax-pattern-variable~3f))",[0,[2,"syntax-pattern-variable?"]],["racket/base","racket"]],
["syntax-position",">reference/stxops.html#(def._((quote._~23~25kernel)._syntax-position))",[0,[2,"syntax-position"]],["racket/base","racket"]],
["syntax-procedure-alias-property",">reference/stxtrans.html#(def._((lib._racket/keyword-transform..rkt)._syntax-procedure-alias-property))",[0,"syntax-procedure-alias-property"],["racket/keyword-transform"]],
["syntax-procedure-converted-arguments-property",">reference/stxtrans.html#(def._((lib._racket/keyword-transform..rkt)._syntax-procedure-converted-arguments-property))",[0,"syntax-procedure-converted-arguments-property"],["racket/keyword-transform"]],
["syntax-property",">reference/stxprops.html#(def._((quote._~23~25kernel)._syntax-property))",[0,[2,"syntax-property"]],["racket/base","racket"]],
["syntax-property-symbol-keys",">reference/stxprops.html#(def._((quote._~23~25kernel)._syntax-property-symbol-keys))",[0,[2,"syntax-property-symbol-keys"]],["racket/base","racket"]],
["syntax-protect",">reference/stxcerts.html#(def._((lib._racket/private/stxcase-scheme..rkt)._syntax-protect))",[0,[2,"syntax-protect"]],["racket/base","racket"]],
["syntax-rearm",">reference/stxcerts.html#(def._((quote._~23~25kernel)._syntax-rearm))",[0,[2,"syntax-rearm"]],["racket/base","racket"]],
["syntax-recertify",">reference/stxops.html#(def._((lib._racket/private/base..rkt)._syntax-recertify))",[0,[2,"syntax-recertify"]],["racket/base","racket"]],
["syntax-rules",">reference/stx-patterns.html#(form._((lib._racket/private/stxcase-scheme..rkt)._syntax-rules))",[0,[1,"syntax-rules"]],["racket/base","racket"]],
["syntax-rules",">r6rs-std/r6rs-Z-H-14.html#node_idx_786",[0,[1,"syntax-rules"]],["r6rs/private/base-for-syntax"]],
["syntax-shift-phase-level",">reference/stxops.html#(def._((quote._~23~25kernel)._syntax-shift-phase-level))",[0,[2,"syntax-shift-phase-level"]],["racket/base","racket"]],
["syntax-source",">reference/stxops.html#(def._((quote._~23~25kernel)._syntax-source))",[0,[2,"syntax-source"]],["racket/base","racket"]],
["syntax-source-directory",">unstable/syntax.html#(def._((lib._unstable/syntax..rkt)._syntax-source-directory))",[0,[2,"syntax-source-directory"]],["unstable/syntax"]],
["syntax-source-file-name",">unstable/syntax.html#(def._((lib._unstable/syntax..rkt)._syntax-source-file-name))",[0,[2,"syntax-source-file-name"]],["unstable/syntax"]],
["syntax-source-module",">reference/stxops.html#(def._((quote._~23~25kernel)._syntax-source-module))",[0,[2,"syntax-source-module"]],["racket/base","racket"]],
["syntax-source-planet-package",">planet/Utility_Libraries.html#(def._((lib._planet/syntax..rkt)._syntax-source-planet-package))",[0,[2,"syntax-source-planet-package"]],["planet/syntax"]],
["syntax-source-planet-package-major",">planet/Utility_Libraries.html#(def._((lib._planet/syntax..rkt)._syntax-source-planet-package-major))",[0,[2,"syntax-source-planet-package-major"]],["planet/syntax"]],
["syntax-source-planet-package-minor",">planet/Utility_Libraries.html#(def._((lib._planet/syntax..rkt)._syntax-source-planet-package-minor))",[0,[2,"syntax-source-planet-package-minor"]],["planet/syntax"]],
["syntax-source-planet-package-name",">planet/Utility_Libraries.html#(def._((lib._planet/syntax..rkt)._syntax-source-planet-package-name))",[0,[2,"syntax-source-planet-package-name"]],["planet/syntax"]],
["syntax-source-planet-package-owner",">planet/Utility_Libraries.html#(def._((lib._planet/syntax..rkt)._syntax-source-planet-package-owner))",[0,[2,"syntax-source-planet-package-owner"]],["planet/syntax"]],
["syntax-source-planet-package-symbol",">planet/Utility_Libraries.html#(def._((lib._planet/syntax..rkt)._syntax-source-planet-package-symbol))",[0,[2,"syntax-source-planet-package-symbol"]],["planet/syntax"]],
["syntax-span",">reference/stxops.html#(def._((quote._~23~25kernel)._syntax-span))",[0,[2,"syntax-span"]],["racket/base","racket"]],
["syntax-taint",">reference/stxcerts.html#(def._((quote._~23~25kernel)._syntax-taint))",[0,[2,"syntax-taint"]],["racket/base","racket"]],
["syntax-tainted?",">reference/stxcerts.html#(def._((quote._~23~25kernel)._syntax-tainted~3f))",[0,[2,"syntax-tainted?"]],["racket/base","racket"]],
["syntax-track-origin",">reference/stxprops.html#(def._((quote._~23~25kernel)._syntax-track-origin))",[0,[2,"syntax-track-origin"]],["racket/base","racket"]],
["syntax-transforming-module-expression?",">reference/stxtrans.html#(def._((quote._~23~25kernel)._syntax-transforming-module-expression~3f))",[0,[2,"syntax-transforming-module-expression?"]],["racket/base","racket"]],
["syntax-transforming?",">reference/stxtrans.html#(def._((quote._~23~25kernel)._syntax-transforming~3f))",[0,[2,"syntax-transforming?"]],["racket/base","racket"]],
["syntax-violation",">r6rs-lib-std/r6rs-lib-Z-H-13.html#node_idx_1160",[0,[2,"syntax-violation"]],["rnrs/syntax-case-6"]],
["syntax-violation-form",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_484",[0,[2,"syntax-violation-form"]],["rnrs/conditions-6"]],
["syntax-violation-subform",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_486",[0,[2,"syntax-violation-subform"]],["rnrs/conditions-6"]],
["syntax-violation?",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_482",[0,[2,"syntax-violation?"]],["rnrs/conditions-6"]],
["syntax-within?",">unstable/syntax.html#(def._((lib._unstable/syntax..rkt)._syntax-within~3f))",[0,[2,"syntax-within?"]],["unstable/syntax"]],
["syntax/boundmap",">syntax/syntax-helpers.html#(mod-path._syntax/boundmap)",[9,[0,"syntax/boundmap"]],"module"],
["syntax/c",">reference/data-structure-contracts.html#(def._((lib._racket/contract/private/misc..rkt)._syntax/c))",[0,[2,"syntax/c"]],["racket/contract/base","racket/contract","racket"]],
["syntax/context",">syntax/transformer-helpers.html#(mod-path._syntax/context)",[9,[0,"syntax/context"]],"module"],
["syntax/datum",">syntax/Datum_Pattern_Matching.html",[9,[0,"syntax/datum"]],"module"],
["syntax/define",">syntax/transformer-helpers.html#(mod-path._syntax/define)",[9,[0,"syntax/define"]],"module"],
["syntax/docprovide",">syntax/docprovide.html",[9,[0,"syntax/docprovide"]],"module"],
["syntax/flatten-begin",">syntax/transformer-helpers.html#(mod-path._syntax/flatten-begin)",[9,[0,"syntax/flatten-begin"]],"module"],
["syntax/free-vars",">syntax/syntax-helpers.html#(mod-path._syntax/free-vars)",[9,[0,"syntax/free-vars"]],"module"],
["syntax/id-table",">syntax/syntax-helpers.html#(mod-path._syntax/id-table)",[9,[0,"syntax/id-table"]],"module"],
["syntax/kerncase",">syntax/syntax-helpers.html#(mod-path._syntax/kerncase)",[9,[0,"syntax/kerncase"]],"module"],
["syntax/keyword",">syntax/syntax-helpers.html#(mod-path._syntax/keyword)",[9,[0,"syntax/keyword"]],"module"],
["syntax/loc",">reference/stx-patterns.html#(form._((lib._racket/private/stxcase-scheme..rkt)._syntax/loc))",[0,[1,"syntax/loc"]],["racket/base","racket"]],
["syntax/location",">syntax/Source_Locations.html#(mod-path._syntax/location)",[9,[0,"syntax/location"]],"module"],
["syntax/modcode",">syntax/module-helpers.html#(mod-path._syntax/modcode)",[9,[0,"syntax/modcode"]],"module"],
["syntax/modcollapse",">syntax/module-helpers.html#(mod-path._syntax/modcollapse)",[9,[0,"syntax/modcollapse"]],"module"],
["syntax/moddep",">syntax/module-helpers.html#(mod-path._syntax/moddep)",[9,[0,"syntax/moddep"]],"module"],
["syntax/modread",">syntax/module-helpers.html#(mod-path._syntax/modread)",[9,[0,"syntax/modread"]],"module"],
["syntax/modresolve",">syntax/module-helpers.html#(mod-path._syntax/modresolve)",[9,[0,"syntax/modresolve"]],"module"],
["syntax/module-reader",">syntax/reader-helpers.html#(mod-path._syntax/module-reader)",[9,[0,"syntax/module-reader"]],"module"],
["syntax/name",">syntax/transformer-helpers.html#(mod-path._syntax/name)",[9,[0,"syntax/name"]],"module"],
["syntax/parse",">syntax/stxparse.html",[9,[0,"syntax/parse"]],"module"],
["syntax/parse/debug",">syntax/Debugging_and_Inspection_Tools.html",[9,[0,"syntax/parse/debug"]],"module"],
["syntax/parse/define",">syntax/Defining_Simple_Macros.html",[9,[0,"syntax/parse/define"]],"module"],
["syntax/parse/experimental/contract",">syntax/Experimental.html#(mod-path._syntax/parse/experimental/contract)",[9,[0,"syntax/parse/experimental/contract"]],"module"],
["syntax/parse/experimental/eh",">syntax/Experimental.html#(mod-path._syntax/parse/experimental/eh)",[9,[0,"syntax/parse/experimental/eh"]],"module"],
["syntax/parse/experimental/provide",">syntax/Experimental.html#(mod-path._syntax/parse/experimental/provide)",[9,[0,"syntax/parse/experimental/provide"]],"module"],
["syntax/parse/experimental/reflect",">syntax/Experimental.html#(mod-path._syntax/parse/experimental/reflect)",[9,[0,"syntax/parse/experimental/reflect"]],"module"],
["syntax/parse/experimental/specialize",">syntax/Experimental.html#(mod-path._syntax/parse/experimental/specialize)",[9,[0,"syntax/parse/experimental/specialize"]],"module"],
["syntax/parse/experimental/splicing",">syntax/Experimental.html#(mod-path._syntax/parse/experimental/splicing)",[9,[0,"syntax/parse/experimental/splicing"]],"module"],
["syntax/parse/experimental/template",">syntax/Experimental.html#(mod-path._syntax/parse/experimental/template)",[9,[0,"syntax/parse/experimental/template"]],"module"],
["syntax/path-spec",">syntax/transformer-helpers.html#(mod-path._syntax/path-spec)",[9,[0,"syntax/path-spec"]],"module"],
["syntax/quote",">syntax/Preserving_Source_Locations.html",[9,[0,"syntax/quote"]],"module"],
["syntax/readerr",">syntax/reader-helpers.html#(mod-path._syntax/readerr)",[9,[0,"syntax/readerr"]],"module"],
["syntax/srcloc",">syntax/Source_Locations.html#(mod-path._syntax/srcloc)",[9,[0,"syntax/srcloc"]],"module"],
["syntax/strip-context",">syntax/syntax-helpers.html#(mod-path._syntax/strip-context)",[9,[0,"syntax/strip-context"]],"module"],
["syntax/struct",">syntax/transformer-helpers.html#(mod-path._syntax/struct)",[9,[0,"syntax/struct"]],"module"],
["syntax/stx",">syntax/syntax-helpers.html#(mod-path._syntax/stx)",[9,[0,"syntax/stx"]],"module"],
["syntax/template",">syntax/transformer-helpers.html#(mod-path._syntax/template)",[9,[0,"syntax/template"]],"module"],
["syntax/to-string",">syntax/syntax-helpers.html#(mod-path._syntax/to-string)",[9,[0,"syntax/to-string"]],"module"],
["syntax/toplevel",">syntax/toplevel.html",[9,[0,"syntax/toplevel"]],"module"],
["syntax/trusted-xforms",">syntax/trusted-xforms.html",[9,[0,"syntax/trusted-xforms"]],"module"],
["syntax: meta-programming helpers",">syntax/index.html","Syntax: Meta-Programming Helpers",false],
["syntax:read-xml",">xml/index.html#(def._((lib._xml/main..rkt)._syntax~3aread-xml))",[0,[2,"syntax:read-xml"]],["xml"]],
["syntax:read-xml/element",">xml/index.html#(def._((lib._xml/main..rkt)._syntax~3aread-xml/element))",[0,[2,"syntax:read-xml/element"]],["xml"]],
["syntax?",">reference/stxops.html#(def._((quote._~23~25kernel)._syntax~3f))",[0,[2,"syntax?"]],["racket/base","racket"]],
["syntaxes for beginning student with list abbreviations",">htdp-langs/beginner-abbr.html#(part._beginner-abbr-syntax)","Syntaxes for Beginning Student with List Abbreviations",false],
["syntaxof",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Syntaxof))",[0,[1,"Syntaxof"]],["typed/racket/base","typed/racket"]],
["sys-dir",">reference/Filesystem.html#(idx._(gentag._284._(lib._scribblings/reference/reference..scrbl)))",[7,"'sys-dir"],false],
["sysallocstringlen",">foreign/com-intf.html#(def._((lib._ffi/unsafe/com..rkt)._.Sys.Alloc.String.Len))",[0,[2,"SysAllocStringLen"]],["ffi/unsafe/com"]],
["sysfreestring",">foreign/com-intf.html#(def._((lib._ffi/unsafe/com..rkt)._.Sys.Free.String))",[0,[2,"SysFreeString"]],["ffi/unsafe/com"]],
["system",">reference/subprocess.html#(def._((lib._racket/system..rkt)._system))",[0,[2,"system"]],["racket/system","racket"]],
["system",">planet/Developing_Packages_for_PLaneT.html#(idx._(gentag._11._(lib._planet/planet..scrbl)))",[7,"'system"],false],
["system",">gui/style-delta_.html#(idx._(gentag._202._(lib._scribblings/gui/gui..scrbl)))",[7,"'system"],false],
["system",">draw/font_.html#(idx._(gentag._35._(lib._scribblings/draw/draw..scrbl)))",[7,"'system"],false],
["system menus",">gui/Windowing_Functions.html#(part._.System_.Menus)","System Menus",false],
["system*",">reference/subprocess.html#(def._((lib._racket/system..rkt)._system*))",[0,[2,"system*"]],["racket/system","racket"]],
["system*/exit-code",">reference/subprocess.html#(def._((lib._racket/system..rkt)._system*/exit-code))",[0,[2,"system*/exit-code"]],["racket/system","racket"]],
["system-big-endian?",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._system-big-endian~3f))",[0,[2,"system-big-endian?"]],["racket/base","racket"]],
["system-idle-evt",">reference/sync.html#(def._((quote._~23~25kernel)._system-idle-evt))",[0,[2,"system-idle-evt"]],["racket/base","racket"]],
["system-language+country",">reference/runtime.html#(def._((quote._~23~25kernel)._system-language+country))",[0,[2,"system-language+country"]],["racket/base","racket"]],
["system-library-subpath",">reference/runtime.html#(def._((quote._~23~25kernel)._system-library-subpath))",[0,[2,"system-library-subpath"]],["racket/base","racket"]],
["system-path-convention-type",">reference/Manipulating_Paths.html#(def._((quote._~23~25kernel)._system-path-convention-type))",[0,[2,"system-path-convention-type"]],["racket/base","racket"]],
["system-position-ok-before-cancel?",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._system-position-ok-before-cancel~3f))",[0,[2,"system-position-ok-before-cancel?"]],["racket/gui/base","racket/gui"]],
["system-specific modules",">db/connect.html#(part._.System-specific_.Modules)","System-specific Modules",false],
["system-type",">reference/runtime.html#(def._((quote._~23~25kernel)._system-type))",[0,[2,"system-type"]],["racket/base","racket"]],
["system/exit-code",">reference/subprocess.html#(def._((lib._racket/system..rkt)._system/exit-code))",[0,[2,"system/exit-code"]],["racket/system","racket"]],
["szenen erzeugen",">deinprogramm/line3d.html#(part._rendering)","Szenen erzeugen",false],
["t",">scribble/Miscellaneous.html#(def._((lib._scribble/manual..rkt)._t))",[0,[2,"t"]],["scribble/manual"]],
["t",">slideshow/Primary_Slide_Functions.html#(def._((lib._slideshow/base..rkt)._t))",[0,[2,"t"]],["slideshow/base","slideshow"]],
["tab-panel",">gui/tab-panel_.html#(idx._(gentag._127._(lib._scribblings/gui/gui..scrbl)))",[7,"'tab-panel"],false],
["tab-panel%",">gui/tab-panel_.html",[0,[2,"tab-panel%"]],["racket/gui/base","racket/gui"]],
["tab-snip%",">gui/tab-snip_.html",[0,[2,"tab-snip%"]],["racket/snip","racket/gui/base","racket/gui"]],
["tabbable-text-mixin",">embedded-gui/Helpers.html#(def._((lib._embedded-gui/main..rkt)._tabbable-text-mixin))",[0,[2,"tabbable-text-mixin"]],["embedded-gui"]],
["tabbable-text<%>",">embedded-gui/Helpers.html#(def._((lib._embedded-gui/main..rkt)._tabbable-text~3c~25~3e))",[0,[2,"tabbable-text<%>"]],["embedded-gui"]],
["tabbed editing",">drracket/Tabbed_Editing.html","Tabbed Editing",false],
["tabify",">framework/Racket.html#(meth._(((lib._framework/main..rkt)._racket~3atext~3c~25~3e)._tabify))",[[0,[2,"tabify"]],[14,[" (method of ",[0,[2,"racket:text<%>"]],")"]]],["framework"]],
["tabify-all",">framework/Racket.html#(meth._(((lib._framework/main..rkt)._racket~3atext~3c~25~3e)._tabify-all))",[[0,[2,"tabify-all"]],[14,[" (method of ",[0,[2,"racket:text<%>"]],")"]]],["framework"]],
["tabify-on-return?",">framework/Racket.html#(meth._(((lib._framework/main..rkt)._racket~3atext~3c~25~3e)._tabify-on-return~3f))",[[0,[2,"tabify-on-return?"]],[14,[" (method of ",[0,[2,"racket:text<%>"]],")"]]],["framework"]],
["tabify-selection",">framework/Racket.html#(meth._(((lib._framework/main..rkt)._racket~3atext~3c~25~3e)._tabify-selection))",[[0,[2,"tabify-selection"]],[14,[" (method of ",[0,[2,"racket:text<%>"]],")"]]],["framework"]],
["table",">html/index.html#(def._((lib._html/main..rkt)._table))",[0,[2,"table"]],["html"]],
["table",">scribble/core.html#(def._((lib._scribble/core..rkt)._table))",[0,[2,"table"]],["scribble/core"]],
["table",">slideshow/Pict_Combiners.html#(def._((lib._slideshow/pict..rkt)._table))",[0,[2,"table"]],["slideshow/pict","slideshow"]],
["table",">scribble/core.html#(tech._table)","<span style=\"font-style: italic\">table</span>",false],
["table methods",">cards/index.html#(part._.Table_.Methods)","Table Methods",false],
["table-blockss",">scribble/core.html#(def._((lib._scribble/core..rkt)._table-blockss))",[0,[2,"table-blockss"]],["scribble/core"]],
["table-cells",">scribble/core.html#(def._((lib._scribble/core..rkt)._table-cells))",[0,[2,"table-cells"]],["scribble/core"]],
["table-cells-styless",">scribble/core.html#(def._((lib._scribble/core..rkt)._table-cells-styless))",[0,[2,"table-cells-styless"]],["scribble/core"]],
["table-cells?",">scribble/core.html#(def._((lib._scribble/core..rkt)._table-cells~3f))",[0,[2,"table-cells?"]],["scribble/core"]],
["table-columns",">scribble/core.html#(def._((lib._scribble/core..rkt)._table-columns))",[0,[2,"table-columns"]],["scribble/core"]],
["table-columns-styles",">scribble/core.html#(def._((lib._scribble/core..rkt)._table-columns-styles))",[0,[2,"table-columns-styles"]],["scribble/core"]],
["table-columns?",">scribble/core.html#(def._((lib._scribble/core..rkt)._table-columns~3f))",[0,[2,"table-columns?"]],["scribble/core"]],
["table-exists?",">db/query-api.html#(def._((lib._db/base..rkt)._table-exists~3f))",[0,[2,"table-exists?"]],["db","db/base"]],
["table-flowss",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._table-flowss))",[0,[2,"table-flowss"]],["scribble/struct"]],
["table-height",">cards/index.html#(meth._(((lib._games/cards..rkt)._table~3c~25~3e)._table-height))",[[0,[2,"table-height"]],[14,[" (method of ",[0,[2,"table<%>"]],")"]]],["games/cards"]],
["table-of-contents",">scribble/base.html#(def._((lib._scribble/base..rkt)._table-of-contents))",[0,[2,"table-of-contents"]],["scribble/base"]],
["table-style",">scribble/core.html#(def._((lib._scribble/core..rkt)._table-style))",[0,[2,"table-style"]],["scribble/core"]],
["table-width",">cards/index.html#(meth._(((lib._games/cards..rkt)._table~3c~25~3e)._table-width))",[[0,[2,"table-width"]],[14,[" (method of ",[0,[2,"table<%>"]],")"]]],["games/cards"]],
["table<%>",">cards/index.html#(def._((lib._games/cards..rkt)._table~3c~25~3e))",[0,[2,"table<%>"]],["games/cards"]],
["table?",">html/index.html#(def._((lib._html/main..rkt)._table~3f))",[0,[2,"table?"]],["html"]],
["table?",">scribble/core.html#(def._((lib._scribble/core..rkt)._table~3f))",[0,[2,"table?"]],["scribble/core"]],
["tableau",">games/spider.html#(tech._tableau)","<span style=\"font-style: italic\">Tableau</span>",false],
["tables",">unstable/Slideshow_Presentations.html#(part._.Tables)","Tables",false],
["tables of contents",">scribble/base.html#(part._.Tables_of_.Contents)","Tables of Contents",false],
["tabular",">scribble/base.html#(def._((lib._scribble/base..rkt)._tabular))",[0,[2,"tabular"]],["scribble/base"]],
["tabular",">unstable/Slideshow_Presentations.html#(def._((lib._unstable/gui/slideshow..rkt)._tabular))",[0,[2,"tabular"]],["unstable/gui/slideshow"]],
["tag",">reference/creatingunits.html#(form._((lib._mzlib/unit..rkt)._tag))",[0,[1,"tag"]],["racket/unit","racket"]],
["tag",">scribble/core.html#(tech._tag)","<span style=\"font-style: italic\">tag</span>",false],
["tag prefix",">scribble/core.html#(tech._tag._prefix)","<span style=\"font-style: italic\">tag prefix</span>",false],
["tag-key",">scribble/core.html#(def._((lib._scribble/core..rkt)._tag-key))",[0,[2,"tag-key"]],["scribble/core"]],
["tag-path?",">unstable/pict.html#(def._((lib._unstable/gui/pict..rkt)._tag-path~3f))",[0,[2,"tag-path?"]],["unstable/gui/pict"]],
["tag-pict",">unstable/pict.html#(def._((lib._unstable/gui/pict..rkt)._tag-pict))",[0,[2,"tag-pict"]],["unstable/gui/pict"]],
["tag-xexpr",">web-server/formlets.html#(def._((lib._web-server/formlets/lib..rkt)._tag-xexpr))",[0,[2,"tag-xexpr"]],["web-server/formlets/lib"]],
["tag?",">scribble/core.html#(def._((lib._scribble/core..rkt)._tag~3f))",[0,[2,"tag?"]],["scribble/core"]],
["tagged c pointer types",">foreign/foreign_tagged-pointers.html","Tagged C Pointer Types",false],
["tagged objects",">inside/im_memoryalloc.html#(part._im~3a3m~3atagged)","Tagged Objects",false],
["tagged picts",">unstable/pict.html#(part._.Tagged_.Picts)","Tagged Picts",false],
["tags",">scribble/core.html#(part._tags)","Tags",false],
["tail calls",">drracket/buttons.html#(idx._(gentag._13._(lib._scribblings/drracket/drracket..scrbl)))","tail calls",false],
["tail evaluation",">inside/Evaluation.html#(part._.Tail_.Evaluation)","Tail Evaluation",false],
["tail position",">reference/eval-model.html#(part._.Tail_.Position)","Tail Position",false],
["tail position",">guide/Lists__Iteration__and_Recursion.html#(tech._tail._position)","<span style=\"font-style: italic\">tail position</span>",false],
["tail position",">reference/eval-model.html#(tech._tail._position)","<span style=\"font-style: italic\">tail position</span>",false],
["tail recursion",">guide/Lists__Iteration__and_Recursion.html#(part._tail-recursion)","Tail Recursion",false],
["tail recursion",">inside/Evaluation.html#(idx._(gentag._293._(lib._scribblings/inside/inside..scrbl)))","tail recursion",false],
["taint-mode",">reference/stxcerts.html#(idx._(gentag._181._(lib._scribblings/reference/reference..scrbl)))",[7,"'taint-mode"],false],
["taint-mode",">reference/stxcerts.html#(idx._(gentag._183._(lib._scribblings/reference/reference..scrbl)))",[7,"'taint-mode"],false],
["tainted",">guide/stx-certs.html#(tech._tainted)","<span style=\"font-style: italic\">tainted</span>",false],
["tainted",">reference/stxcerts.html#(tech._tainted)","<span style=\"font-style: italic\">tainted</span>",false],
["tainting modes",">guide/stx-certs.html#(part._.Tainting_.Modes)","Tainting Modes",false],
["taints and code inspectors",">guide/stx-certs.html#(part._taints+code-inspectors)","Taints and Code Inspectors",false],
["take",">reference/pairs.html#(def._((lib._racket/list..rkt)._take))",[0,[2,"take"]],["racket/list","racket"]],
["take",">lazy/index.html#(def._((lib._lazy/main..rkt)._take))",[0,[2,"take"]],["lazy"]],
["take",">srfi-std/srfi-1.html#take",[0,[2,"take"]],["srfi/1"]],
["take!",">srfi-std/srfi-1.html#take!",[0,[2,"take!"]],["srfi/1"]],
["take-common-prefix",">unstable/list.html#(def._((lib._unstable/list..rkt)._take-common-prefix))",[0,[2,"take-common-prefix"]],["unstable/list"]],
["take-right",">reference/pairs.html#(def._((lib._racket/list..rkt)._take-right))",[0,[2,"take-right"]],["racket/list","racket"]],
["take-right",">srfi-std/srfi-1.html#take-right",[0,[2,"take-right"]],["srfi/1"]],
["take-while",">srfi-std/srfi-1.html#take-while",[0,[2,"take-while"]],["srfi/1"]],
["take-while!",">srfi-std/srfi-1.html#take-while!",[0,[2,"take-while!"]],["srfi/1"]],
["tamper status",">reference/stxcerts.html#(tech._tamper._statu)","<span style=\"font-style: italic\">tamper status</span>",false],
["tan",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._tan))",[0,[2,"tan"]],["racket/base","racket"]],
["tan",">r5rs-std/r5rs-Z-H-9.html#%_idx_334",[0,[2,"tan"]],["r5rs"]],
["tan",">r6rs-std/r6rs-Z-H-14.html#node_idx_550",[0,[2,"tan"]],["rnrs/base-6"]],
["tan",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._tan))",[0,[2,"tan"]],["lang/htdp-advanced"]],
["tan",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._tan))",[0,[2,"tan"]],["lang/htdp-beginner"]],
["tan",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._tan))",[0,[2,"tan"]],["lang/htdp-beginner-abbr"]],
["tan",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._tan))",[0,[2,"tan"]],["lang/htdp-intermediate"]],
["tan",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._tan))",[0,[2,"tan"]],["lang/htdp-intermediate-lambda"]],
["tan",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._tan))",[0,[2,"tan"]],["deinprogramm/DMdA-advanced"]],
["tan",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._tan))",[0,[2,"tan"]],["deinprogramm/DMdA-assignments"]],
["tan",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._tan))",[0,[2,"tan"]],["deinprogramm/DMdA-beginner"]],
["tan",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._tan))",[0,[2,"tan"]],["deinprogramm/DMdA-vanilla"]],
["tangent",">htdp-langs/beginner.html#(idx._htdp-beginner._(gentag._14._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-beginner))","tangent",false],
["tangent",">htdp-langs/beginner-abbr.html#(idx._htdp-beginner-abbr._(gentag._29._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-beginner-abbr))","tangent",false],
["tangent",">htdp-langs/intermediate.html#(idx._htdp-intermediate._(gentag._38._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-intermediate))","tangent",false],
["tangent",">htdp-langs/intermediate-lam.html#(idx._htdp-intermediate-lambda._(gentag._47._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-intermediate-lambda))","tangent",false],
["tangent",">htdp-langs/advanced.html#(idx._htdp-advanced._(gentag._56._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-advanced))","tangent",false],
["tanh",">reference/generic-numbers.html#(def._((lib._racket/math..rkt)._tanh))",[0,[2,"tanh"]],["racket/math","racket"]],
["tar",">file/tar.html#(def._((lib._file/tar..rkt)._tar))",[0,[2,"tar"]],["file/tar"]],
["tar file creation",">file/tar.html",[[6,"tar"]," File Creation"],false],
["tar->output",">file/tar.html#(def._((lib._file/tar..rkt)._tar-~3eoutput))",[0,[2,"tar->output"]],["file/tar"]],
["tar-gzip",">file/tar.html#(def._((lib._file/tar..rkt)._tar-gzip))",[0,[2,"tar-gzip"]],["file/tar"]],
["target-element",">scribble/core.html#(def._((lib._scribble/core..rkt)._target-element))",[0,[2,"target-element"]],["scribble/core"]],
["target-element-tag",">scribble/core.html#(def._((lib._scribble/core..rkt)._target-element-tag))",[0,[2,"target-element-tag"]],["scribble/core"]],
["target-element?",">scribble/core.html#(def._((lib._scribble/core..rkt)._target-element~3f))",[0,[2,"target-element?"]],["scribble/core"]],
["target-url",">scribble/core.html#(def._((lib._scribble/core..rkt)._target-url))",[0,[2,"target-url"]],["scribble/core"]],
["target-url",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._target-url))",[0,[2,"target-url"]],["scribble/struct"]],
["target-url-addr",">scribble/core.html#(def._((lib._scribble/core..rkt)._target-url-addr))",[0,[2,"target-url-addr"]],["scribble/core"]],
["target-url-addr",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._target-url-addr))",[0,[2,"target-url-addr"]],["scribble/struct"]],
["target-url-style",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._target-url-style))",[0,[2,"target-url-style"]],["scribble/struct"]],
["target-url?",">scribble/core.html#(def._((lib._scribble/core..rkt)._target-url~3f))",[0,[2,"target-url?"]],["scribble/core"]],
["target-url?",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._target-url~3f))",[0,[2,"target-url?"]],["scribble/struct"]],
["tbody",">html/index.html#(def._((lib._html/main..rkt)._tbody))",[0,[2,"tbody"]],["html"]],
["tbody?",">html/index.html#(def._((lib._html/main..rkt)._tbody~3f))",[0,[2,"tbody?"]],["html"]],
["tc-get",">reference/distributed-places.html#(def._((lib._racket/place/distributed..rkt)._tc-get))",[0,[2,"tc-get"]],["racket/place/distributed"]],
["tcp",">reference/tcp.html","TCP",false],
["tcp listener",">reference/tcp.html#(tech._tcp._listener)","<span style=\"font-style: italic\">TCP\nlistener</span>",false],
["tcp port",">reference/tcp.html#(tech._tcp._port)","<span style=\"font-style: italic\">TCP port</span>",false],
["tcp redirect: tcp^ via channels",">net/tcp-redirect.html",["TCP Redirect: ",[0,[1,"tcp^"]]," via Channels"],false],
["tcp signature",">net/tcp.html#(part._.T.C.P_.Signature)","TCP Signature",false],
["tcp unit",">net/tcp.html#(part._.T.C.P_.Unit)","TCP Unit",false],
["tcp-abandon-port",">reference/tcp.html#(def._((lib._racket/tcp..rkt)._tcp-abandon-port))",[0,[2,"tcp-abandon-port"]],["racket/tcp","racket"]],
["tcp-abandon-port",">net/tcp.html#(sig-val._((lib._net/tcp-sig..rkt)._tcp~5e._tcp-abandon-port))",[0,[2,"tcp-abandon-port"]],["net/tcp-sig"]],
["tcp-accept",">reference/tcp.html#(def._((lib._racket/tcp..rkt)._tcp-accept))",[0,[2,"tcp-accept"]],["racket/tcp","racket"]],
["tcp-accept",">net/tcp.html#(sig-val._((lib._net/tcp-sig..rkt)._tcp~5e._tcp-accept))",[0,[2,"tcp-accept"]],["net/tcp-sig"]],
["tcp-accept-evt",">reference/tcp.html#(def._((lib._racket/tcp..rkt)._tcp-accept-evt))",[0,[2,"tcp-accept-evt"]],["racket/tcp","racket"]],
["tcp-accept-ready?",">reference/tcp.html#(def._((lib._racket/tcp..rkt)._tcp-accept-ready~3f))",[0,[2,"tcp-accept-ready?"]],["racket/tcp","racket"]],
["tcp-accept-ready?",">net/tcp.html#(sig-val._((lib._net/tcp-sig..rkt)._tcp~5e._tcp-accept-ready~3f))",[0,[2,"tcp-accept-ready?"]],["net/tcp-sig"]],
["tcp-accept/enable-break",">reference/tcp.html#(def._((lib._racket/tcp..rkt)._tcp-accept/enable-break))",[0,[2,"tcp-accept/enable-break"]],["racket/tcp","racket"]],
["tcp-accept/enable-break",">net/tcp.html#(sig-val._((lib._net/tcp-sig..rkt)._tcp~5e._tcp-accept/enable-break))",[0,[2,"tcp-accept/enable-break"]],["net/tcp-sig"]],
["tcp-addresses",">reference/tcp.html#(def._((lib._racket/tcp..rkt)._tcp-addresses))",[0,[2,"tcp-addresses"]],["racket/tcp","racket"]],
["tcp-addresses",">net/tcp.html#(sig-val._((lib._net/tcp-sig..rkt)._tcp~5e._tcp-addresses))",[0,[2,"tcp-addresses"]],["net/tcp-sig"]],
["tcp-close",">reference/tcp.html#(def._((lib._racket/tcp..rkt)._tcp-close))",[0,[2,"tcp-close"]],["racket/tcp","racket"]],
["tcp-close",">net/tcp.html#(sig-val._((lib._net/tcp-sig..rkt)._tcp~5e._tcp-close))",[0,[2,"tcp-close"]],["net/tcp-sig"]],
["tcp-connect",">reference/tcp.html#(def._((lib._racket/tcp..rkt)._tcp-connect))",[0,[2,"tcp-connect"]],["racket/tcp","racket"]],
["tcp-connect",">net/tcp.html#(sig-val._((lib._net/tcp-sig..rkt)._tcp~5e._tcp-connect))",[0,[2,"tcp-connect"]],["net/tcp-sig"]],
["tcp-connect/enable-break",">reference/tcp.html#(def._((lib._racket/tcp..rkt)._tcp-connect/enable-break))",[0,[2,"tcp-connect/enable-break"]],["racket/tcp","racket"]],
["tcp-connect/enable-break",">net/tcp.html#(sig-val._((lib._net/tcp-sig..rkt)._tcp~5e._tcp-connect/enable-break))",[0,[2,"tcp-connect/enable-break"]],["net/tcp-sig"]],
["tcp-like client procedures",">openssl/index.html#(part._.T.C.P-like_.Client_.Procedures)","TCP-like Client Procedures",false],
["tcp-like server procedures",">openssl/index.html#(part._.T.C.P-like_.Server_.Procedures)","TCP-like Server Procedures",false],
["tcp-listen",">reference/tcp.html#(def._((lib._racket/tcp..rkt)._tcp-listen))",[0,[2,"tcp-listen"]],["racket/tcp","racket"]],
["tcp-listen",">net/tcp.html#(sig-val._((lib._net/tcp-sig..rkt)._tcp~5e._tcp-listen))",[0,[2,"tcp-listen"]],["net/tcp-sig"]],
["tcp-listen-port?",">unstable/contract.html#(def._((lib._unstable/contract..rkt)._tcp-listen-port~3f))",[0,[2,"tcp-listen-port?"]],["unstable/contract"]],
["tcp-listener",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.T.C.P-.Listener))",[0,[1,"TCP-Listener"]],["typed/racket/base","typed/racket"]],
["tcp-listener?",">reference/tcp.html#(def._((lib._racket/tcp..rkt)._tcp-listener~3f))",[0,[2,"tcp-listener?"]],["racket/tcp","racket"]],
["tcp-listener?",">net/tcp.html#(sig-val._((lib._net/tcp-sig..rkt)._tcp~5e._tcp-listener~3f))",[0,[2,"tcp-listener?"]],["net/tcp-sig"]],
["tcp-port?",">reference/tcp.html#(def._((lib._racket/tcp..rkt)._tcp-port~3f))",[0,[2,"tcp-port?"]],["racket/tcp","racket"]],
["tcp-redirect",">net/tcp-redirect.html#(def._((lib._net/tcp-redirect..rkt)._tcp-redirect))",[0,[2,"tcp-redirect"]],["net/tcp-redirect"]],
["tcp: unit and signature",">net/tcp.html","TCP: Unit and Signature",false],
["tcp@",">net/tcp.html#(def._((lib._net/tcp-unit..rkt)._tcp~40))",[0,[2,"tcp@"]],["net/tcp-unit"]],
["tcp^",">net/tcp.html#(form._((lib._net/tcp-sig..rkt)._tcp~5e))",[0,[1,"tcp^"]],["net/tcp-sig"]],
["td",">html/index.html#(def._((lib._html/main..rkt)._td))",[0,[2,"td"]],["html"]],
["td?",">html/index.html#(def._((lib._html/main..rkt)._td~3f))",[0,[2,"td?"]],["html"]],
["teaching",">guide/teaching-langs.html","Teaching",false],
["teaching languages",">tools/Teaching_Languages.html","Teaching Languages",false],
["teachpack",">drracket/extending-drracket.html#(tech._teachpack)","<span style=\"font-style: italic\">teachpack</span>",false],
["teachpacks",">drracket/extending-drracket.html#(part._teachpacks)","Teachpacks",false],
["tech",">scribble/section-links.html#(def._((lib._scribble/manual..rkt)._tech))",[0,[2,"tech"]],["scribble/manual"]],
["techlink",">scribble/section-links.html#(def._((lib._scribble/manual..rkt)._techlink))",[0,[2,"techlink"]],["scribble/manual"]],
["technical issues",">framework/Test.html#(part._.Technical_.Issues)","Technical Issues",false],
["techrpt-location",">scriblib/autobib.html#(def._((lib._scriblib/autobib..rkt)._techrpt-location))",[0,[2,"techrpt-location"]],["scriblib/autobib"]],
["tell",">gui/editor-stream-in_.html#(meth._(((lib._mred/main..rkt)._editor-stream-in~25)._tell))",[[0,[2,"tell"]],[14,[" (method of ",[0,[2,"editor-stream-in%"]],")"]]],["racket/gui/base","racket/gui"]],
["tell",">gui/editor-stream-in-base_.html#(meth._(((lib._mred/main..rkt)._editor-stream-in-base~25)._tell))",[[0,[2,"tell"]],[14,[" (method of ",[0,[2,"editor-stream-in-base%"]],")"]]],["racket/gui/base","racket/gui"]],
["tell",">gui/editor-stream-out_.html#(meth._(((lib._mred/main..rkt)._editor-stream-out~25)._tell))",[[0,[2,"tell"]],[14,[" (method of ",[0,[2,"editor-stream-out%"]],")"]]],["racket/gui/base","racket/gui"]],
["tell",">gui/editor-stream-out-base_.html#(meth._(((lib._mred/main..rkt)._editor-stream-out-base~25)._tell))",[[0,[2,"tell"]],[14,[" (method of ",[0,[2,"editor-stream-out-base%"]],")"]]],["racket/gui/base","racket/gui"]],
["tell",">foreign/Objective-C_FFI.html#(form._((lib._ffi/unsafe/objc..rkt)._tell))",[0,[1,"tell"]],["ffi/unsafe/objc"]],
["tellv",">foreign/Objective-C_FFI.html#(form._((lib._ffi/unsafe/objc..rkt)._tellv))",[0,[1,"tellv"]],["ffi/unsafe/objc"]],
["temp",">reference/Filesystem.html#(idx._(gentag._273._(lib._scribblings/reference/reference..scrbl)))",[6,"TEMP"],false],
["temp-dir",">reference/Filesystem.html#(idx._(gentag._270._(lib._scribblings/reference/reference..scrbl)))",[7,"'temp-dir"],false],
["template",">syntax/Experimental.html#(form._((lib._syntax/parse/experimental/template..rkt)._template))",[0,[1,"template"]],["syntax/parse/experimental/template"]],
["template",">guide/pattern-macros.html#(tech._template)","<span style=\"font-style: italic\">template</span>",false],
["template environment",">reference/syntax-model.html#(tech._template._environment)","<span style=\"font-style: italic\">template environment</span>",false],
["template metafunction",">syntax/Experimental.html#(tech._template._metafunction)","<span style=\"font-style: italic\">template\nmetafunction</span>",false],
["template phase level",">guide/stx-phases.html#(tech._template._phase._level)","<span style=\"font-style: italic\">template phase level</span>",false],
["template variables",">htdp-langs/advanced.html#(part._advanced._.Template._.Variables)","Template Variables",false],
["template variables",">htdp-langs/beginner.html#(part._beginner._.Template._.Variables)","Template Variables",false],
["template variables",">htdp-langs/beginner-abbr.html#(part._beginner-abbr._.Template._.Variables)","Template Variables",false],
["template variables",">htdp-langs/intermediate.html#(part._intermediate._.Template._.Variables)","Template Variables",false],
["template variables",">htdp-langs/intermediate-lam.html#(part._intm-w-lambda._.Template._.Variables)","Template Variables",false],
["templates: separation of view",">web-server/templates.html","Templates: Separation of View",false],
["temporal contracts: explicit contract monitors",">unstable/temp-c.html","Temporal Contracts: Explicit Contract Monitors",false],
["temporarily",">web-server/http.html#(def._((lib._web-server/http/redirect..rkt)._temporarily))",[0,[2,"temporarily"]],["web-server/http/redirect"]],
["temporarily catching error escapes",">inside/exceptions.html#(part._imz~3atempcatch)","Temporarily Catching Error Escapes",false],
["tentative-pretty-print-port-cancel",">reference/pretty-print.html#(def._((lib._racket/pretty..rkt)._tentative-pretty-print-port-cancel))",[0,[2,"tentative-pretty-print-port-cancel"]],["racket/pretty","racket"]],
["tentative-pretty-print-port-transfer",">reference/pretty-print.html#(def._((lib._racket/pretty..rkt)._tentative-pretty-print-port-transfer))",[0,[2,"tentative-pretty-print-port-transfer"]],["racket/pretty","racket"]],
["tenth",">reference/pairs.html#(def._((lib._racket/list..rkt)._tenth))",[0,[2,"tenth"]],["racket/list","racket"]],
["tenth",">srfi-std/srfi-1.html#tenth",[0,[2,"tenth"]],["srfi/1"]],
["term",">redex/The_Redex_Reference.html#(form._((lib._redex/reduction-semantics..rkt)._term))",[0,[1,"term"]],["redex/reduction-semantics","redex"]],
["term",">datalog/Tutorial.html#(tech._term)","<span style=\"font-style: italic\">term</span>",false],
["term",">redex/The_Redex_Reference.html#(tech._term)","<span style=\"font-style: italic\">term</span>",false],
["term->pict",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._term-~3epict))",[0,[2,"term->pict"]],["redex/pict","redex"]],
["term-let",">redex/The_Redex_Reference.html#(form._((lib._redex/reduction-semantics..rkt)._term-let))",[0,[1,"term-let"]],["redex/reduction-semantics","redex"]],
["term-match",">redex/The_Redex_Reference.html#(form._((lib._redex/reduction-semantics..rkt)._term-match))",[0,[1,"term-match"]],["redex/reduction-semantics","redex"]],
["term-match/single",">redex/The_Redex_Reference.html#(form._((lib._redex/reduction-semantics..rkt)._term-match/single))",[0,[1,"term-match/single"]],["redex/reduction-semantics","redex"]],
["term-node-children",">redex/The_Redex_Reference.html#(def._((lib._redex/gui..rkt)._term-node-children))",[0,[2,"term-node-children"]],["redex/gui","redex"]],
["term-node-color",">redex/The_Redex_Reference.html#(def._((lib._redex/gui..rkt)._term-node-color))",[0,[2,"term-node-color"]],["redex/gui","redex"]],
["term-node-expr",">redex/The_Redex_Reference.html#(def._((lib._redex/gui..rkt)._term-node-expr))",[0,[2,"term-node-expr"]],["redex/gui","redex"]],
["term-node-height",">redex/The_Redex_Reference.html#(def._((lib._redex/gui..rkt)._term-node-height))",[0,[2,"term-node-height"]],["redex/gui","redex"]],
["term-node-labels",">redex/The_Redex_Reference.html#(def._((lib._redex/gui..rkt)._term-node-labels))",[0,[2,"term-node-labels"]],["redex/gui","redex"]],
["term-node-parents",">redex/The_Redex_Reference.html#(def._((lib._redex/gui..rkt)._term-node-parents))",[0,[2,"term-node-parents"]],["redex/gui","redex"]],
["term-node-set-color!",">redex/The_Redex_Reference.html#(def._((lib._redex/gui..rkt)._term-node-set-color!))",[0,[2,"term-node-set-color!"]],["redex/gui","redex"]],
["term-node-set-position!",">redex/The_Redex_Reference.html#(def._((lib._redex/gui..rkt)._term-node-set-position!))",[0,[2,"term-node-set-position!"]],["redex/gui","redex"]],
["term-node-set-red!",">redex/The_Redex_Reference.html#(def._((lib._redex/gui..rkt)._term-node-set-red!))",[0,[2,"term-node-set-red!"]],["redex/gui","redex"]],
["term-node-width",">redex/The_Redex_Reference.html#(def._((lib._redex/gui..rkt)._term-node-width))",[0,[2,"term-node-width"]],["redex/gui","redex"]],
["term-node-x",">redex/The_Redex_Reference.html#(def._((lib._redex/gui..rkt)._term-node-x))",[0,[2,"term-node-x"]],["redex/gui","redex"]],
["term-node-y",">redex/The_Redex_Reference.html#(def._((lib._redex/gui..rkt)._term-node-y))",[0,[2,"term-node-y"]],["redex/gui","redex"]],
["term-node?",">redex/The_Redex_Reference.html#(def._((lib._redex/gui..rkt)._term-node~3f))",[0,[2,"term-node?"]],["redex/gui","redex"]],
["terminal-port?",">reference/port-ops.html#(def._((quote._~23~25kernel)._terminal-port~3f))",[0,[2,"terminal-port?"]],["racket/base","racket"]],
["terminating connections",">more/index.html#(part._.Terminating_.Connections)","Terminating Connections",false],
["terminating-macro",">reference/readtables.html#(idx._(gentag._220._(lib._scribblings/reference/reference..scrbl)))",[7,"'terminating-macro"],false],
["terminology",">plot/intro.html#(part._.Terminology)","Terminology",false],
["terms",">redex/The_Redex_Reference.html#(part._.Terms)","Terms",false],
["terms",">scribble/SIGPLAN_Paper_Format.html#(def._((lib._scribble/sigplan..rkt)._terms))",[0,[2,"terms"]],["scribble/sigplan"]],
["terse status updates",">planet/Utility_Libraries.html#(part._.Terse_.Status_.Updates)","Terse Status Updates",false],
["test",">framework/Test.html","Test",false],
["test",">plai/plai-scheme.html#(form._((lib._plai/main..rkt)._test))",[0,[1,"test"]],["plai"]],
["test",">test-engine/index.html#(def._((lib._test-engine/racket-tests..rkt)._test))",[0,[2,"test"]],["test-engine/racket-tests"]],
["test cases",">rackunit/api.html#(part._.Test_.Cases)","Test Cases",false],
["test control flow",">rackunit/api.html#(part._.Test_.Control_.Flow)","Test Control Flow",false],
["test flags",">plai/plai-scheme.html#(part._.Test_.Flags)","Test Flags",false],
["test functions",">framework/Test.html#(part._.Test_.Functions)","Test Functions",false],
["test suites",">rackunit/api.html#(part._.Test_.Suites)","Test Suites",false],
["test support",">test-engine/index.html","Test Support",false],
["test-->",">redex/The_Redex_Reference.html#(form._((lib._redex/reduction-semantics..rkt)._test--~3e))",[0,[1,"test-->"]],["redex/reduction-semantics","redex"]],
["test-->>",">redex/The_Redex_Reference.html#(form._((lib._redex/reduction-semantics..rkt)._test--~3e~3e))",[0,[1,"test-->>"]],["redex/reduction-semantics","redex"]],
["test-->>e",">redex/The_Redex_Reference.html#(form._((lib._redex/reduction-semantics..rkt)._test--~3e~3e.E))",[0,[1,"test-->>E"]],["redex/reduction-semantics","redex"]],
["test-->>\u2203",">redex/The_Redex_Reference.html#(form._((lib._redex/reduction-semantics..rkt)._test--~3e~3e~e2~88~83))",[0,[1,"test--&gt;&gt;&#8707;"]],["redex/reduction-semantics","redex"]],
["test-=",">rackunit/api.html#(def._((lib._rackunit/main..rkt)._test-~3d))",[0,[2,"test-="]],["rackunit"]],
["test-begin",">rackunit/api.html#(form._((lib._rackunit/main..rkt)._test-begin))",[0,[1,"test-begin"]],["rackunit"]],
["test-case",">rackunit/api.html#(form._((lib._rackunit/main..rkt)._test-case))",[0,[1,"test-case"]],["rackunit"]],
["test-case%",">gui/WXME_Decoding.html#(def._((lib._wxme/test-case..rkt)._test-case~25))",[0,[2,"test-case%"]],["wxme/test-case"]],
["test-case?",">rackunit/api.html#(def._((lib._rackunit/main..rkt)._test-case~3f))",[0,[2,"test-case?"]],["rackunit"]],
["test-check",">rackunit/api.html#(def._((lib._rackunit/main..rkt)._test-check))",[0,[2,"test-check"]],["rackunit"]],
["test-coverage-enabled",">errortrace/stacktrace.html#(sig-val._((lib._errortrace/stacktrace..rkt)._stacktrace-imports~5e._test-coverage-enabled))",[0,[2,"test-coverage-enabled"]],["errortrace/stacktrace"]],
["test-coverage-info",">errortrace/using-errortrace.html#(def._((lib._errortrace/errortrace-lib..rkt)._test-coverage-info))",[0,[2,"test-coverage-info"]],["errortrace"]],
["test-covered",">errortrace/stacktrace.html#(sig-val._((lib._errortrace/stacktrace..rkt)._stacktrace-imports~5e._test-covered))",[0,[2,"test-covered"]],["errortrace/stacktrace"]],
["test-engine/racket-gui",">test-engine/index.html#(mod-path._test-engine/racket-gui)",[9,[0,"test-engine/racket-gui"]],"module"],
["test-engine/racket-tests",">test-engine/index.html#(mod-path._test-engine/racket-tests)",[9,[0,"test-engine/racket-tests"]],"module"],
["test-eq?",">rackunit/api.html#(def._((lib._rackunit/main..rkt)._test-eq~3f))",[0,[2,"test-eq?"]],["rackunit"]],
["test-equal",">redex/The_Redex_Reference.html#(form._((lib._redex/reduction-semantics..rkt)._test-equal))",[0,[1,"test-equal"]],["redex/reduction-semantics","redex"]],
["test-equal?",">rackunit/api.html#(def._((lib._rackunit/main..rkt)._test-equal~3f))",[0,[2,"test-equal?"]],["rackunit"]],
["test-eqv?",">rackunit/api.html#(def._((lib._rackunit/main..rkt)._test-eqv~3f))",[0,[2,"test-eqv?"]],["rackunit"]],
["test-error",">rackunit/internals.html#(def._((lib._rackunit/main..rkt)._test-error))",[0,[2,"test-error"]],["rackunit"]],
["test-error-result",">rackunit/internals.html#(def._((lib._rackunit/main..rkt)._test-error-result))",[0,[2,"test-error-result"]],["rackunit"]],
["test-error?",">rackunit/internals.html#(def._((lib._rackunit/main..rkt)._test-error~3f))",[0,[2,"test-error?"]],["rackunit"]],
["test-execute",">test-engine/index.html#(def._((lib._test-engine/racket-tests..rkt)._test-execute))",[0,[2,"test-execute"]],["test-engine/racket-tests"]],
["test-exn",">rackunit/api.html#(def._((lib._rackunit/main..rkt)._test-exn))",[0,[2,"test-exn"]],["rackunit"]],
["test-failure",">rackunit/internals.html#(def._((lib._rackunit/main..rkt)._test-failure))",[0,[2,"test-failure"]],["rackunit"]],
["test-failure-result",">rackunit/internals.html#(def._((lib._rackunit/main..rkt)._test-failure-result))",[0,[2,"test-failure-result"]],["rackunit"]],
["test-failure?",">rackunit/internals.html#(def._((lib._rackunit/main..rkt)._test-failure~3f))",[0,[2,"test-failure?"]],["rackunit"]],
["test-false",">rackunit/api.html#(def._((lib._rackunit/main..rkt)._test-false))",[0,[2,"test-false"]],["rackunit"]],
["test-format",">test-engine/index.html#(def._((lib._test-engine/racket-tests..rkt)._test-format))",[0,[2,"test-format"]],["test-engine/racket-tests"]],
["test-inexact-epsilon",">plai/plai-scheme.html#(def._((lib._plai/main..rkt)._test-inexact-epsilon))",[0,[2,"test-inexact-epsilon"]],["plai"]],
["test-not-exn",">rackunit/api.html#(def._((lib._rackunit/main..rkt)._test-not-exn))",[0,[2,"test-not-exn"]],["rackunit"]],
["test-not-false",">rackunit/api.html#(def._((lib._rackunit/main..rkt)._test-not-false))",[0,[2,"test-not-false"]],["rackunit"]],
["test-pixel",">graphics/posn.html#(def._((lib._graphics/graphics..rkt)._test-pixel))",[0,[2,"test-pixel"]],["graphics/graphics"]],
["test-pred",">rackunit/api.html#(def._((lib._rackunit/main..rkt)._test-pred))",[0,[2,"test-pred"]],["rackunit"]],
["test-predicate",">redex/The_Redex_Reference.html#(form._((lib._redex/reduction-semantics..rkt)._test-predicate))",[0,[1,"test-predicate"]],["redex/reduction-semantics","redex"]],
["test-result",">rackunit/internals.html#(def._((lib._rackunit/main..rkt)._test-result))",[0,[2,"test-result"]],["rackunit"]],
["test-result-test-case-name",">rackunit/internals.html#(def._((lib._rackunit/main..rkt)._test-result-test-case-name))",[0,[2,"test-result-test-case-name"]],["rackunit"]],
["test-result?",">rackunit/internals.html#(def._((lib._rackunit/main..rkt)._test-result~3f))",[0,[2,"test-result?"]],["rackunit"]],
["test-results",">redex/The_Redex_Reference.html#(def._((lib._redex/reduction-semantics..rkt)._test-results))",[0,[2,"test-results"]],["redex/reduction-semantics","redex"]],
["test-silence",">test-engine/index.html#(def._((lib._test-engine/racket-tests..rkt)._test-silence))",[0,[2,"test-silence"]],["test-engine/racket-tests"]],
["test-success",">rackunit/internals.html#(def._((lib._rackunit/main..rkt)._test-success))",[0,[2,"test-success"]],["rackunit"]],
["test-success-result",">rackunit/internals.html#(def._((lib._rackunit/main..rkt)._test-success-result))",[0,[2,"test-success-result"]],["rackunit"]],
["test-success?",">rackunit/internals.html#(def._((lib._rackunit/main..rkt)._test-success~3f))",[0,[2,"test-success?"]],["rackunit"]],
["test-suite",">rackunit/api.html#(form._((lib._rackunit/main..rkt)._test-suite))",[0,[1,"test-suite"]],["rackunit"]],
["test-suite-check-around",">rackunit/internals.html#(def._((lib._rackunit/main..rkt)._test-suite-check-around))",[0,[2,"test-suite-check-around"]],["rackunit"]],
["test-suite-test-case-around",">rackunit/internals.html#(def._((lib._rackunit/main..rkt)._test-suite-test-case-around))",[0,[2,"test-suite-test-case-around"]],["rackunit"]],
["test-suite?",">rackunit/api.html#(def._((lib._rackunit/main..rkt)._test-suite~3f))",[0,[2,"test-suite?"]],["rackunit"]],
["test-true",">rackunit/api.html#(def._((lib._rackunit/main..rkt)._test-true))",[0,[2,"test-true"]],["rackunit"]],
["test/exn",">plai/plai-scheme.html#(form._((lib._plai/main..rkt)._test/exn))",[0,[1,"test/exn"]],["plai"]],
["test/gui",">rackunit/api.html#(def._((lib._rackunit/gui..rkt)._test/gui))",[0,[2,"test/gui"]],["rackunit/gui"]],
["test/location=?",">plai/mutator.html#(form._((lib._plai/mutator..rkt)._test/location~3d~3f))",[0,[1,"test/location=?"]],["plai/mutator"]],
["test/pred",">plai/plai-scheme.html#(form._((lib._plai/main..rkt)._test/pred))",[0,[1,"test/pred"]],["plai"]],
["test/regexp",">plai/plai-scheme.html#(form._((lib._plai/main..rkt)._test/regexp))",[0,[1,"test/regexp"]],["plai"]],
["test/value=?",">plai/mutator.html#(form._((lib._plai/mutator..rkt)._test/value~3d~3f))",[0,[1,"test/value=?"]],["plai/mutator"]],
["test:button-push",">framework/Test.html#(def._((lib._framework/test..rkt)._test~3abutton-push))",[0,[2,"test:button-push"]],["framework/test","framework"]],
["test:close-top-level-window",">framework/Test.html#(def._((lib._framework/test..rkt)._test~3aclose-top-level-window))",[0,[2,"test:close-top-level-window"]],["framework/test","framework"]],
["test:current-get-eventspaces",">framework/Test.html#(def._((lib._framework/test..rkt)._test~3acurrent-get-eventspaces))",[0,[2,"test:current-get-eventspaces"]],["framework/test","framework"]],
["test:get-active-top-level-window",">framework/Test.html#(def._((lib._framework/test..rkt)._test~3aget-active-top-level-window))",[0,[2,"test:get-active-top-level-window"]],["framework/test","framework"]],
["test:keystroke",">framework/Test.html#(def._((lib._framework/test..rkt)._test~3akeystroke))",[0,[2,"test:keystroke"]],["framework/test","framework"]],
["test:menu-select",">framework/Test.html#(def._((lib._framework/test..rkt)._test~3amenu-select))",[0,[2,"test:menu-select"]],["framework/test","framework"]],
["test:mouse-click",">framework/Test.html#(def._((lib._framework/test..rkt)._test~3amouse-click))",[0,[2,"test:mouse-click"]],["framework/test","framework"]],
["test:new-window",">framework/Test.html#(def._((lib._framework/test..rkt)._test~3anew-window))",[0,[2,"test:new-window"]],["framework/test","framework"]],
["test:number-pending-actions",">framework/Test.html#(def._((lib._framework/test..rkt)._test~3anumber-pending-actions))",[0,[2,"test:number-pending-actions"]],["framework/test","framework"]],
["test:reraise-error",">framework/Test.html#(def._((lib._framework/test..rkt)._test~3areraise-error))",[0,[2,"test:reraise-error"]],["framework/test","framework"]],
["test:run-interval",">framework/Test.html#(def._((lib._framework/test..rkt)._test~3arun-interval))",[0,[2,"test:run-interval"]],["framework/test","framework"]],
["test:run-one",">framework/Test.html#(def._((lib._framework/test..rkt)._test~3arun-one))",[0,[2,"test:run-one"]],["framework/test","framework"]],
["test:set-check-box!",">framework/Test.html#(def._((lib._framework/test..rkt)._test~3aset-check-box!))",[0,[2,"test:set-check-box!"]],["framework/test","framework"]],
["test:set-choice!",">framework/Test.html#(def._((lib._framework/test..rkt)._test~3aset-choice!))",[0,[2,"test:set-choice!"]],["framework/test","framework"]],
["test:set-list-box!",">framework/Test.html#(def._((lib._framework/test..rkt)._test~3aset-list-box!))",[0,[2,"test:set-list-box!"]],["framework/test","framework"]],
["test:set-radio-box!",">framework/Test.html#(def._((lib._framework/test..rkt)._test~3aset-radio-box!))",[0,[2,"test:set-radio-box!"]],["framework/test","framework"]],
["test:set-radio-box-item!",">framework/Test.html#(def._((lib._framework/test..rkt)._test~3aset-radio-box-item!))",[0,[2,"test:set-radio-box-item!"]],["framework/test","framework"]],
["test:top-level-focus-window-has?",">framework/Test.html#(def._((lib._framework/test..rkt)._test~3atop-level-focus-window-has~3f))",[0,[2,"test:top-level-focus-window-has?"]],["framework/test","framework"]],
["test:use-focus-table",">framework/Test.html#(def._((lib._framework/test..rkt)._test~3ause-focus-table))",[0,[2,"test:use-focus-table"]],["framework/test","framework"]],
["testf\u00e4lle",">deinprogramm/Testf_lle.html","Testf&#228;lle",false],
["testing",">htdp/index.html#(part._.Testing)","Testing",false],
["testing",">redex/The_Redex_Reference.html#(part._.Testing)","Testing",false],
["testing",">teachpack/2htdpbatch-io.html#(part._.Testing)","Testing",false],
["testing database programs",">db/util.html#(part._util-testing)","Testing Database Programs",false],
["testing infrastructure",">plai/plai-scheme.html#(part._testing)","Testing Infrastructure",false],
["testing mutators",">plai/mutator.html#(part._.Testing_.Mutators)","Testing Mutators",false],
["testing performance of database-backed programs",">db/using-db.html#(part._dbperf-testing)","Testing Performance of Database-Backed Programs",false],
["testing reduction relations",">redex/tutorial.html#(part._.Testing_.Reduction_.Relations)","Testing Reduction Relations",false],
["testing servlets",">web-server/test.html","Testing Servlets",false],
["testing typing",">redex/tutorial.html#(part._.Testing_.Typing)","Testing Typing",false],
["testing utilities",">rackunit/Testing_Utilities.html","Testing Utilities",false],
["tests",">games/Tests.html","Tests",false],
["tex table",">mrlib/TeX_Table.html","TeX Table",false],
["tex-addition",">scribble/core.html#(def._((lib._scribble/latex-properties..rkt)._tex-addition))",[0,[2,"tex-addition"]],["scribble/latex-properties"]],
["tex-addition-path",">scribble/core.html#(def._((lib._scribble/latex-properties..rkt)._tex-addition-path))",[0,[2,"tex-addition-path"]],["scribble/latex-properties"]],
["tex-addition?",">scribble/core.html#(def._((lib._scribble/latex-properties..rkt)._tex-addition~3f))",[0,[2,"tex-addition?"]],["scribble/latex-properties"]],
["tex-shortcut-table",">mrlib/TeX_Table.html#(def._((lib._mrlib/tex-table..rkt)._tex-shortcut-table))",[0,"tex-shortcut-table"],["mrlib/tex-table"]],
["text",">draw/overview.html#(part._.Text)","Text",false],
["text",">framework/Text.html","Text",false],
["text",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._text))",[0,[2,"text"]],["2htdp/image"]],
["text",">teachpack/image.html#(def._((lib._htdp/image..rkt)._text))",[0,[2,"text"]],["htdp/image"]],
["text",">slideshow/Basic_Pict_Constructors.html#(def._((lib._slideshow/pict..rkt)._text))",[0,[2,"text"]],["slideshow/pict","slideshow"]],
["text",">deinprogramm/image.html#(def._((lib._deinprogramm/image..rkt)._text))",[0,[2,"text"]],["teachpack/deinprogramm/image"]],
["text",">web-server/formlets.html#(def._((lib._web-server/formlets/lib..rkt)._text))",[0,[2,"text"]],["web-server/formlets/lib"]],
["text",">reference/file-ports.html#(idx._(gentag._202._(lib._scribblings/reference/reference..scrbl)))",[7,"'text"],false],
["text editor",">gui/editor-overview.html#(tech._text._editor)","<span style=\"font-style: italic\">text editor</span>",false],
["text field",">gui/windowing-overview.html#(tech._text._field)","<span style=\"font-style: italic\">text field</span>",false],
["text formatting",">unstable/Slideshow_Presentations.html#(part._.Text_.Formatting)","Text Formatting",false],
["text generation",">scribble/text.html","Text Generation",false],
["text mode vs. racket mode for arguments",">scribble/getting-started.html#(part._.Text_.Mode_vs__.Racket_.Mode_for_.Arguments)","Text Mode vs. Racket Mode for Arguments",false],
["text renderer",">scribble/renderer.html#(part._.Text_.Renderer)","Text Renderer",false],
["text string",">guide/regexp.html#(tech._text._string)","<span style=\"font-style: italic\">text string</span>",false],
["text styles and content",">scribble/base.html#(part._.Text_.Styles_and_.Content)","Text Styles and Content",false],
["text%",">gui/text_.html",[0,[2,"text%"]],["racket/gui/base","racket/gui"]],
["text-button-snip%",">embedded-gui/text-button-snip_.html",[0,[2,"text-button-snip%"]],["embedded-gui"]],
["text-contents",">teachpack/gui.html#(def._((lib._htdp/gui..rkt)._text-contents))",[0,[2,"text-contents"]],["htdp/gui"]],
["text-editor%",">gui/WXME_Decoding.html#(def._((lib._wxme/text..rkt)._text-editor~25))",[0,[2,"text-editor%"]],["wxme/text"]],
["text-editor-load-handler",">gui/Editor_Functions.html#(def._((lib._mred/main..rkt)._text-editor-load-handler))",[0,[2,"text-editor-load-handler"]],["racket/gui/base","racket/gui"]],
["text-field",">gui/text-field_.html#(idx._(gentag._129._(lib._scribblings/gui/gui..scrbl)))",[7,"'text-field"],false],
["text-field",">gui/combo-field_.html#(idx._(gentag._35._(lib._scribblings/gui/gui..scrbl)))",[7,"'text-field"],false],
["text-field%",">gui/text-field_.html",[0,[2,"text-field%"]],["racket/gui/base","racket/gui"]],
["text-field-enter",">gui/text-field_.html#(idx._(gentag._128._(lib._scribblings/gui/gui..scrbl)))",[7,"'text-field-enter"],false],
["text-field-enter",">gui/combo-field_.html#(idx._(gentag._34._(lib._scribblings/gui/gui..scrbl)))",[7,"'text-field-enter"],false],
["text-icon",">images/Icons.html#(def._((lib._images/icons/symbol..rkt)._text-icon))",[0,[2,"text-icon"]],["images/icons/symbol"]],
["text-input",">web-server/formlets.html#(def._((lib._web-server/formlets/input..rkt)._text-input))",[0,[2,"text-input"]],["web-server/formlets/input"]],
["text-outline",">draw/dc-path_.html#(meth._(((lib._racket/draw..rkt)._dc-path~25)._text-outline))",[[0,[2,"text-outline"]],[14,[" (method of ",[0,[2,"dc-path%"]],")"]]],["racket/draw"]],
["text-style/c",">slideshow/Basic_Pict_Constructors.html#(def._((lib._slideshow/pict..rkt)._text-style/c))",[0,[2,"text-style/c"]],["slideshow/pict","slideshow"]],
["text/font",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._text/font))",[0,[2,"text/font"]],["2htdp/image"]],
["text/html-mime-type",">web-server/http.html#(def._((lib._web-server/http/response-structs..rkt)._.T.E.X.T/.H.T.M.L-.M.I.M.E-.T.Y.P.E))",[0,[2,"TEXT/HTML-MIME-TYPE"]],["web-server/http/response-structs"]],
["text:1-pixel-string-snip%",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3a1-pixel-string-snip~25))",[0,[2,"text:1-pixel-string-snip%"]],["framework"]],
["text:1-pixel-tab-snip%",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3a1-pixel-tab-snip~25))",[0,[2,"text:1-pixel-tab-snip%"]],["framework"]],
["text:autocomplete-append-after",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3aautocomplete-append-after))",[0,[2,"text:autocomplete-append-after"]],["framework"]],
["text:autocomplete-limit",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3aautocomplete-limit))",[0,[2,"text:autocomplete-limit"]],["framework"]],
["text:autocomplete-mixin",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3aautocomplete-mixin))",[0,[2,"text:autocomplete-mixin"]],["framework"]],
["text:autocomplete<%>",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3aautocomplete~3c~25~3e))",[0,[2,"text:autocomplete<%>"]],["framework"]],
["text:autowrap%",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3aautowrap~25))",[0,[2,"text:autowrap%"]],["framework"]],
["text:backup-autosave%",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3abackup-autosave~25))",[0,[2,"text:backup-autosave%"]],["framework"]],
["text:basic%",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3abasic~25))",[0,[2,"text:basic%"]],["framework"]],
["text:basic-mixin",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3abasic-mixin))",[0,[2,"text:basic-mixin"]],["framework"]],
["text:basic<%>",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3abasic~3c~25~3e))",[0,[2,"text:basic<%>"]],["framework"]],
["text:clever-file-format%",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3aclever-file-format~25))",[0,[2,"text:clever-file-format%"]],["framework"]],
["text:clever-file-format-mixin",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3aclever-file-format-mixin))",[0,[2,"text:clever-file-format-mixin"]],["framework"]],
["text:clever-file-format<%>",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3aclever-file-format~3c~25~3e))",[0,[2,"text:clever-file-format<%>"]],["framework"]],
["text:crlf-line-endings-mixin",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3acrlf-line-endings-mixin))",[0,[2,"text:crlf-line-endings-mixin"]],["framework"]],
["text:crlf-line-endings<%>",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3acrlf-line-endings~3c~25~3e))",[0,[2,"text:crlf-line-endings<%>"]],["framework"]],
["text:delegate%",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3adelegate~25))",[0,[2,"text:delegate%"]],["framework"]],
["text:delegate-mixin",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3adelegate-mixin))",[0,[2,"text:delegate-mixin"]],["framework"]],
["text:delegate<%>",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3adelegate~3c~25~3e))",[0,[2,"text:delegate<%>"]],["framework"]],
["text:file%",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3afile~25))",[0,[2,"text:file%"]],["framework"]],
["text:file-mixin",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3afile-mixin))",[0,[2,"text:file-mixin"]],["framework"]],
["text:file<%>",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3afile~3c~25~3e))",[0,[2,"text:file<%>"]],["framework"]],
["text:first-line-mixin",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3afirst-line-mixin))",[0,[2,"text:first-line-mixin"]],["framework"]],
["text:first-line<%>",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3afirst-line~3c~25~3e))",[0,[2,"text:first-line<%>"]],["framework"]],
["text:foreground-color-mixin",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3aforeground-color-mixin))",[0,[2,"text:foreground-color-mixin"]],["framework"]],
["text:foreground-color<%>",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3aforeground-color~3c~25~3e))",[0,[2,"text:foreground-color<%>"]],["framework"]],
["text:get-completions/manuals",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3aget-completions/manuals))",[0,[2,"text:get-completions/manuals"]],["framework"]],
["text:hide-caret/selection%",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3ahide-caret/selection~25))",[0,[2,"text:hide-caret/selection%"]],["framework"]],
["text:hide-caret/selection-mixin",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3ahide-caret/selection-mixin))",[0,[2,"text:hide-caret/selection-mixin"]],["framework"]],
["text:hide-caret/selection<%>",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3ahide-caret/selection~3c~25~3e))",[0,[2,"text:hide-caret/selection<%>"]],["framework"]],
["text:info%",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3ainfo~25))",[0,[2,"text:info%"]],["framework"]],
["text:info-mixin",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3ainfo-mixin))",[0,[2,"text:info-mixin"]],["framework"]],
["text:info<%>",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3ainfo~3c~25~3e))",[0,[2,"text:info<%>"]],["framework"]],
["text:input-box%",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3ainput-box~25))",[0,[2,"text:input-box%"]],["framework"]],
["text:input-box-mixin",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3ainput-box-mixin))",[0,[2,"text:input-box-mixin"]],["framework"]],
["text:input-box<%>",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3ainput-box~3c~25~3e))",[0,[2,"text:input-box<%>"]],["framework"]],
["text:keymap%",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3akeymap~25))",[0,[2,"text:keymap%"]],["framework"]],
["text:line-numbers-mixin",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3aline-numbers-mixin))",[0,[2,"text:line-numbers-mixin"]],["framework"]],
["text:line-numbers<%>",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3aline-numbers~3c~25~3e))",[0,[2,"text:line-numbers<%>"]],["framework"]],
["text:line-spacing%",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3aline-spacing~25))",[0,[2,"text:line-spacing%"]],["framework"]],
["text:line-spacing-mixin",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3aline-spacing-mixin))",[0,[2,"text:line-spacing-mixin"]],["framework"]],
["text:line-spacing<%>",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3aline-spacing~3c~25~3e))",[0,[2,"text:line-spacing<%>"]],["framework"]],
["text:lookup-port-name",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3alookup-port-name))",[0,[2,"text:lookup-port-name"]],["framework"]],
["text:nbsp->space%",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3anbsp-~3espace~25))",[0,[2,"text:nbsp->space%"]],["framework"]],
["text:nbsp->space-mixin",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3anbsp-~3espace-mixin))",[0,[2,"text:nbsp->space-mixin"]],["framework"]],
["text:nbsp->space<%>",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3anbsp-~3espace~3c~25~3e))",[0,[2,"text:nbsp->space<%>"]],["framework"]],
["text:normalize-paste%",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3anormalize-paste~25))",[0,[2,"text:normalize-paste%"]],["framework"]],
["text:normalize-paste-mixin",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3anormalize-paste-mixin))",[0,[2,"text:normalize-paste-mixin"]],["framework"]],
["text:normalize-paste<%>",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3anormalize-paste~3c~25~3e))",[0,[2,"text:normalize-paste<%>"]],["framework"]],
["text:ports-mixin",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3aports-mixin))",[0,[2,"text:ports-mixin"]],["framework"]],
["text:ports<%>",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3aports~3c~25~3e))",[0,[2,"text:ports<%>"]],["framework"]],
["text:range-caret-space?",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3arange-caret-space~3f))",[0,[2,"text:range-caret-space?"]],["framework"]],
["text:range-color",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3arange-color))",[0,[2,"text:range-color"]],["framework"]],
["text:range-end",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3arange-end))",[0,[2,"text:range-end"]],["framework"]],
["text:range-start",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3arange-start))",[0,[2,"text:range-start"]],["framework"]],
["text:range-style",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3arange-style))",[0,[2,"text:range-style"]],["framework"]],
["text:range?",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3arange~3f))",[0,[2,"text:range?"]],["framework"]],
["text:return%",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3areturn~25))",[0,[2,"text:return%"]],["framework"]],
["text:return-mixin",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3areturn-mixin))",[0,[2,"text:return-mixin"]],["framework"]],
["text:return<%>",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3areturn~3c~25~3e))",[0,[2,"text:return<%>"]],["framework"]],
["text:searching%",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3asearching~25))",[0,[2,"text:searching%"]],["framework"]],
["text:searching-mixin",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3asearching-mixin))",[0,[2,"text:searching-mixin"]],["framework"]],
["text:searching<%>",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3asearching~3c~25~3e))",[0,[2,"text:searching<%>"]],["framework"]],
["text:standard-style-list%",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3astandard-style-list~25))",[0,[2,"text:standard-style-list%"]],["framework"]],
["text:wide-snip%",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3awide-snip~25))",[0,[2,"text:wide-snip%"]],["framework"]],
["text:wide-snip-mixin",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3awide-snip-mixin))",[0,[2,"text:wide-snip-mixin"]],["framework"]],
["text:wide-snip<%>",">framework/Text.html#(def._((lib._framework/main..rkt)._text~3awide-snip~3c~25~3e))",[0,[2,"text:wide-snip<%>"]],["framework"]],
["textarea",">html/index.html#(def._((lib._html/main..rkt)._textarea))",[0,[2,"textarea"]],["html"]],
["textarea-input",">web-server/formlets.html#(def._((lib._web-server/formlets/input..rkt)._textarea-input))",[0,[2,"textarea-input"]],["web-server/formlets/input"]],
["textarea?",">html/index.html#(def._((lib._html/main..rkt)._textarea~3f))",[0,[2,"textarea?"]],["html"]],
["textual rendering",">profile/index.html#(part._.Textual_.Rendering)","Textual Rendering",false],
["textual user interface",">rackunit/api.html#(part._.Textual_.User_.Interface)","Textual User Interface",false],
["textual-port?",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_646",[0,[2,"textual-port?"]],["rnrs/io/ports-6"]],
["textual-read-eval-print-loop",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._textual-read-eval-print-loop))",[0,[2,"textual-read-eval-print-loop"]],["racket/gui/base","racket/gui"]],
["tfoot",">html/index.html#(def._((lib._html/main..rkt)._tfoot))",[0,[2,"tfoot"]],["html"]],
["tfoot?",">html/index.html#(def._((lib._html/main..rkt)._tfoot~3f))",[0,[2,"tfoot?"]],["html"]],
["th",">html/index.html#(def._((lib._html/main..rkt)._th))",[0,[2,"th"]],["html"]],
["th?",">html/index.html#(def._((lib._html/main..rkt)._th~3f))",[0,[2,"th?"]],["html"]],
["thaw-colorer",">framework/Color.html#(meth._(((lib._framework/main..rkt)._color~3atext~3c~25~3e)._thaw-colorer))",[[0,[2,"thaw-colorer"]],[14,[" (method of ",[0,[2,"color:text<%>"]],")"]]],["framework"]],
["the #lang shorthand",">guide/Module_Syntax.html#(part._hash-lang)",["The ",[10,"#lang"]," Shorthand"],false],
["the application",">continue/index.html#(part._.The_.Application)","The Application",false],
["the apply function",">guide/application.html#(part._apply)",["The ",[0,[2,"apply"]]," Function"],false],
["the body part",">scribble/reader.html#(part._.The_.Body_.Part)","The Body Part",false],
["the bytecode and just-in-time (jit) compilers",">guide/performance.html#(part._.J.I.T)","The Bytecode and Just-in-Time (JIT) Compilers",false],
["the cache file's path",">planet/Utility_Libraries.html#(part._.The_.Cache_.File_s_.Path)","The Cache File&rsquo;s Path",false],
["the cat's path",">games/The_Cat_s_Path.html","The Cat&rsquo;s Path",false],
["the command part",">scribble/reader.html#(part._.The_.Command_.Part)","The Command Part",false],
["the compiler as a unit",">raco/API_for_Raw_Compilation.html#(part._api~3aunit)","The Compiler as a Unit",false],
["the cut (!)",">racklog/cut.html",["The Cut (",[0,[1,"!"]],")"],false],
["the datum part",">scribble/reader.html#(part._.The_.Datum_.Part)","The Datum Part",false],
["the double submit bug",">continue/index.html#(part._.The_.Double_.Submit_.Bug)","The Double Submit Bug",false],
["the implementation of r6rs",">r6rs/r6rs-mod.html#(part._.The_.Implementation_of_.R6.R.S)","The Implementation of R<span style=\"vertical-align: super; font-size: 80%\">6</span>RS",false],
["the interactions window",">drracket/interactions-window.html","The Interactions Window",false],
["the js-expression data type",">json/index.html#(part._.The_.J.S-.Expression_.Data_.Type)","The JS-Expression Data Type",false],
["the mixin form",">guide/classes.html#(part._.The_mixin_.Form)",["The ",[0,[1,"mixin"]]," Form"],false],
["the module browser",">drracket/module-browser.html","The Module Browser",false],
["the module form",">guide/Module_Syntax.html#(part._module-syntax)",["The ",[0,[1,"module"]]," Form"],false],
["the mzpp read-eval-print loop",">preprocessor/mzpp.html#(part._.The_mzpp_read-eval-print_loop)","The mzpp read-eval-print loop",false],
["the n+1 selects problem",">db/using-db.html#(part._dbperf-n+1)","The N+1 Selects Problem",false],
["the nitty gritty of pixels, pens, and lines",">teachpack/2htdpimage-guide.html#(part._nitty-gritty)","The nitty gritty of pixels, pens, and lines",false],
["the occurs check",">racklog/unification.html#(part._.The_.Occurs_.Check)","The Occurs Check",false],
["the philosophy of rackunit",">rackunit/philosophy.html","The Philosophy of RackUnit",false],
["the planet language",">planet/hash-lang-planet.html",["The ",[9,[0,"planet"]]," Language"],false],
["the planet search order",">planet/search-order.html","The PLaneT Search Order",false],
["the printer",">reference/printing.html","The Printer",false],
["the racket drawing toolkit",">draw/index.html","The Racket Drawing Toolkit",false],
["the racket foreign interface",">foreign/index.html","The Racket Foreign Interface",false],
["the racket graphical interface toolkit",">gui/index.html","The Racket Graphical Interface Toolkit",false],
["the racket guide",">guide/index.html","<span style=\"font-weight: bold\">The Racket Guide</span>",false],
["the racket reference",">reference/index.html","<span style=\"font-weight: bold\">The Racket Reference</span>",false],
["the racket/load language",">reference/load-lang.html",["The ",[9,[0,"racket/load"]]," Language"],false],
["the raco planet command-line tool",">planet/cmdline.html",["The ",[6,"raco planet"]," Command-Line Tool"],false],
["the reader",">reference/reader.html","The Reader",false],
["the redex reference",">redex/The_Redex_Reference.html","The Redex Reference",false],
["the rules",">games/same.html#(part._.The_.Rules)","The Rules",false],
["the scribble syntax at a glance",">scribble/reader.html#(part._.The_.Scribble_.Syntax_at_a_.Glance)","The Scribble Syntax at a Glance",false],
["the stepper",">stepper/index.html","The Stepper",false],
["the trait form",">guide/classes.html#(part._.The_trait_.Form)",["The ",[0,[1,"trait"]]," Form"],false],
["the typed racket guide",">ts-guide/index.html","The Typed Racket Guide",false],
["the typed racket reference",">ts-reference/index.html","The Typed Racket Reference",false],
["the universe server",">teachpack/2htdpuniverse.html#(part._universe-server)","The Universe Server",false],
["the web server",">guide/More_Libraries.html#(part._.The_.Web_.Server)","The Web Server",false],
["the window layout",">games/gcalc.html#(part._.The_.Window_.Layout)","The Window Layout",false],
["the world",">games/The_World.html","The World",false],
["the world is not enough",">teachpack/2htdphtdp-port.html#(part._.The_.World_is_.Not_.Enough)","The World is Not Enough",false],
["the world is not enough",">teachpack/2htdpuniverse.html#(part._world2)","The World is not Enough",false],
["the-brush-list",">draw/Drawing_Functions.html#(def._((lib._racket/draw..rkt)._the-brush-list))",[0,[2,"the-brush-list"]],["racket/draw"]],
["the-brush-list",">draw/brush_.html#(idx._(gentag._24._(lib._scribblings/draw/draw..scrbl)))",[0,[2,"the-brush-list"]],false],
["the-clipboard",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._the-clipboard))",[0,[2,"the-clipboard"]],["racket/gui/base","racket/gui"]],
["the-clipboard",">gui/clipboard___.html#(idx._(gentag._31._(lib._scribblings/gui/gui..scrbl)))",[0,[2,"the-clipboard"]],false],
["the-color-database",">draw/Drawing_Functions.html#(def._((lib._racket/draw..rkt)._the-color-database))",[0,[2,"the-color-database"]],["racket/draw"]],
["the-color-database",">draw/color-database___.html#(idx._(gentag._25._(lib._scribblings/draw/draw..scrbl)))",[0,[2,"the-color-database"]],false],
["the-editor-wordbreak-map",">gui/Editor_Functions.html#(def._((lib._mred/main..rkt)._the-editor-wordbreak-map))",[0,[2,"the-editor-wordbreak-map"]],["racket/gui/base","racket/gui"]],
["the-font-list",">draw/Drawing_Functions.html#(def._((lib._racket/draw..rkt)._the-font-list))",[0,[2,"the-font-list"]],["racket/draw"]],
["the-font-list",">draw/font_.html#(idx._(gentag._48._(lib._scribblings/draw/draw..scrbl)))",[0,[2,"the-font-list"]],false],
["the-font-name-directory",">draw/Drawing_Functions.html#(def._((lib._racket/draw..rkt)._the-font-name-directory))",[0,[2,"the-font-name-directory"]],["racket/draw"]],
["the-font-name-directory",">draw/font-name-directory___.html#(idx._(gentag._49._(lib._scribblings/draw/draw..scrbl)))",[0,[2,"the-font-name-directory"]],false],
["the-font-name-directory",">draw/font-name-directory___.html#(idx._(gentag._50._(lib._scribblings/draw/draw..scrbl)))",[0,[2,"the-font-name-directory"]],false],
["the-pen-list",">draw/Drawing_Functions.html#(def._((lib._racket/draw..rkt)._the-pen-list))",[0,[2,"the-pen-list"]],["racket/draw"]],
["the-pen-list",">draw/pen_.html#(idx._(gentag._64._(lib._scribblings/draw/draw..scrbl)))",[0,[2,"the-pen-list"]],false],
["the-pen-list",">draw/pen-list_.html#(idx._(gentag._65._(lib._scribblings/draw/draw..scrbl)))",[0,[2,"the-pen-list"]],false],
["the-style-list",">gui/Editor_Functions.html#(def._((lib._mred/main..rkt)._the-style-list))",[0,[2,"the-style-list"]],["racket/gui/base","racket/gui"]],
["the-style-list",">gui/editor-overview.html#(idx._(gentag._153._(lib._scribblings/gui/gui..scrbl)))",[0,[2,"the-style-list"]],false],
["the-style-list",">gui/style-list_.html#(idx._(gentag._203._(lib._scribblings/gui/gui..scrbl)))",[0,[2,"the-style-list"]],false],
["the-unsupplied-arg",">reference/function-contracts.html#(def._((lib._racket/contract/base..rkt)._the-unsupplied-arg))",[0,[2,"the-unsupplied-arg"]],["racket/contract/base","racket/contract","racket"]],
["the-x-selection-clipboard",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._the-x-selection-clipboard))",[0,[2,"the-x-selection-clipboard"]],["racket/gui/base","racket/gui"]],
["the-x-selection-clipboard",">gui/clipboard___.html#(idx._(gentag._32._(lib._scribblings/gui/gui..scrbl)))",[0,[2,"the-x-selection-clipboard"]],false],
["thead",">html/index.html#(def._((lib._html/main..rkt)._thead))",[0,[2,"thead"]],["html"]],
["thead?",">html/index.html#(def._((lib._html/main..rkt)._thead~3f))",[0,[2,"thead?"]],["html"]],
["theory/c",">datalog/interop.html#(def._((lib._datalog/main..rkt)._theory/c))",[0,[2,"theory/c"]],["datalog"]],
["thermometer",">slideshow/More_Pict_Constructors.html#(def._((lib._slideshow/pict..rkt)._thermometer))",[0,[2,"thermometer"]],["slideshow/pict","slideshow"]],
["thing-doc",">scribble/srcdoc.html#(form._((lib._scribble/srcdoc..rkt)._thing-doc))",[0,[1,"thing-doc"]],["scribble/srcdoc"]],
["thing-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..rkt)._thing-index-desc))",[0,[2,"thing-index-desc"]],["scribble/manual-struct"]],
["thing-index-desc?",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..rkt)._thing-index-desc~3f))",[0,[2,"thing-index-desc?"]],["scribble/manual-struct"]],
["third",">reference/pairs.html#(def._((lib._racket/list..rkt)._third))",[0,[2,"third"]],["racket/list","racket"]],
["third",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._third))",[0,[2,"third"]],["lang/htdp-advanced"]],
["third",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._third))",[0,[2,"third"]],["lang/htdp-beginner"]],
["third",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._third))",[0,[2,"third"]],["lang/htdp-beginner-abbr"]],
["third",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._third))",[0,[2,"third"]],["lang/htdp-intermediate"]],
["third",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._third))",[0,[2,"third"]],["lang/htdp-intermediate-lambda"]],
["third",">lazy/index.html#(def._((lib._lazy/main..rkt)._third))",[0,[2,"third"]],["lazy"]],
["third",">mzlib/mzlib_list.html#(def._((lib._mzlib/list..rkt)._third))",[0,[2,"third"]],["mzlib/list"]],
["third",">srfi-std/srfi-1.html#third",[0,[2,"third"]],["srfi/1"]],
["this",">reference/createclass.html#(form._((lib._racket/private/class-internal..rkt)._this))",[0,[1,"this"]],["racket/class","racket"]],
["this%",">reference/createclass.html#(form._((lib._racket/private/class-internal..rkt)._this~25))",[0,[1,"this%"]],["racket/class","racket"]],
["this-expression-file-name",">mzlib/mzlib_etc.html#(form._((lib._mzlib/etc..rkt)._this-expression-file-name))",[0,[1,"this-expression-file-name"]],["mzlib/etc"]],
["this-expression-source-directory",">mzlib/mzlib_etc.html#(form._((lib._mzlib/etc..rkt)._this-expression-source-directory))",[0,[1,"this-expression-source-directory"]],["mzlib/etc"]],
["this-language",">string-constants/index.html#(form._((lib._string-constants/string-constant..rkt)._this-language))",[0,[1,"this-language"]],["string-constants/string-constant","string-constants"]],
["this-obj",">scribble/doc-classes.html#(form._((lib._scribble/manual..rkt)._this-obj))",[0,[1,"this-obj"]],["scribble/manual"]],
["this-package-in",">planet/Utility_Libraries.html#(form._((lib._planet/scribble..rkt)._this-package-in))",[0,[1,"this-package-in"]],["planet/scribble"]],
["this-package-in",">planet/Utility_Libraries.html#(form._((lib._planet/version..rkt)._this-package-in))",[0,[1,"this-package-in"]],["planet/version"]],
["this-package-version",">planet/Utility_Libraries.html#(form._((lib._planet/private/version..rkt)._this-package-version))",[0,[1,"this-package-version"]],["planet/version"]],
["this-package-version-maj",">planet/Utility_Libraries.html#(form._((lib._planet/private/version..rkt)._this-package-version-maj))",[0,[1,"this-package-version-maj"]],["planet/version"]],
["this-package-version-min",">planet/Utility_Libraries.html#(form._((lib._planet/private/version..rkt)._this-package-version-min))",[0,[1,"this-package-version-min"]],["planet/version"]],
["this-package-version-name",">planet/Utility_Libraries.html#(form._((lib._planet/private/version..rkt)._this-package-version-name))",[0,[1,"this-package-version-name"]],["planet/version"]],
["this-package-version-owner",">planet/Utility_Libraries.html#(form._((lib._planet/private/version..rkt)._this-package-version-owner))",[0,[1,"this-package-version-owner"]],["planet/version"]],
["this-package-version-symbol",">planet/Utility_Libraries.html#(form._((lib._planet/private/version..rkt)._this-package-version-symbol))",[0,[1,"this-package-version-symbol"]],["planet/version"]],
["thread",">reference/threads.html#(def._((quote._~23~25kernel)._thread))",[0,[2,"thread"]],["racket/base","racket"]],
["thread",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Thread))",[0,[1,"Thread"]],["typed/racket/base","typed/racket"]],
["thread cells",">reference/threadcells.html","Thread Cells",false],
["thread cells",">reference/eval-model.html#(tech._thread._cell)","<span style=\"font-style: italic\">thread\ncells</span>",false],
["thread descriptor",">reference/threads.html#(tech._thread._descriptor)","<span style=\"font-style: italic\">thread\ndescriptor</span>",false],
["thread functions",">inside/threads.html#(part._.Thread_.Functions)","Thread Functions",false],
["thread group",">reference/threadgroups.html#(tech._thread._group)","<span style=\"font-style: italic\">thread group</span>",false],
["thread groups",">reference/threadgroups.html","Thread Groups",false],
["thread issues",">framework/Test.html#(part._.Thread_.Issues)","Thread Issues",false],
["thread mailboxes",">reference/threads.html#(part._threadmbox)","Thread Mailboxes",false],
["thread-cell-ref",">reference/threadcells.html#(def._((quote._~23~25kernel)._thread-cell-ref))",[0,[2,"thread-cell-ref"]],["racket/base","racket"]],
["thread-cell-set!",">reference/threadcells.html#(def._((quote._~23~25kernel)._thread-cell-set!))",[0,[2,"thread-cell-set!"]],["racket/base","racket"]],
["thread-cell-values?",">reference/threadcells.html#(def._((quote._~23~25kernel)._thread-cell-values~3f))",[0,[2,"thread-cell-values?"]],["racket/base","racket"]],
["thread-cell?",">reference/threadcells.html#(def._((quote._~23~25kernel)._thread-cell~3f))",[0,[2,"thread-cell?"]],["racket/base","racket"]],
["thread-cellof",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Thread-.Cellof))",[0,[1,"Thread-Cellof"]],["typed/racket/base","typed/racket"]],
["thread-dead-evt",">reference/threads.html#(def._((quote._~23~25kernel)._thread-dead-evt))",[0,[2,"thread-dead-evt"]],["racket/base","racket"]],
["thread-dead?",">reference/threads.html#(def._((quote._~23~25kernel)._thread-dead~3f))",[0,[2,"thread-dead?"]],["racket/base","racket"]],
["thread-done-evt",">mzlib/mzlib_cml.html#(def._((lib._mzlib/cml..rkt)._thread-done-evt))",[0,[2,"thread-done-evt"]],["mzlib/cml"]],
["thread-group",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Thread-.Group))",[0,[1,"Thread-Group"]],["typed/racket/base","typed/racket"]],
["thread-group?",">reference/threadgroups.html#(def._((quote._~23~25kernel)._thread-group~3f))",[0,[2,"thread-group?"]],["racket/base","racket"]],
["thread-local storage",">reference/thread-local-storage.html","Thread-Local Storage",false],
["thread-receive",">reference/threads.html#(def._((quote._~23~25kernel)._thread-receive))",[0,[2,"thread-receive"]],["racket/base","racket"]],
["thread-receive-evt",">reference/threads.html#(def._((quote._~23~25kernel)._thread-receive-evt))",[0,[2,"thread-receive-evt"]],["racket/base","racket"]],
["thread-resume",">reference/threads.html#(def._((quote._~23~25kernel)._thread-resume))",[0,[2,"thread-resume"]],["racket/base","racket"]],
["thread-resume-evt",">reference/threads.html#(def._((quote._~23~25kernel)._thread-resume-evt))",[0,[2,"thread-resume-evt"]],["racket/base","racket"]],
["thread-rewind-receive",">reference/threads.html#(def._((quote._~23~25kernel)._thread-rewind-receive))",[0,[2,"thread-rewind-receive"]],["racket/base","racket"]],
["thread-running?",">reference/threads.html#(def._((quote._~23~25kernel)._thread-running~3f))",[0,[2,"thread-running?"]],["racket/base","racket"]],
["thread-send",">reference/threads.html#(def._((quote._~23~25kernel)._thread-send))",[0,[2,"thread-send"]],["racket/base","racket"]],
["thread-suspend",">reference/threads.html#(def._((quote._~23~25kernel)._thread-suspend))",[0,[2,"thread-suspend"]],["racket/base","racket"]],
["thread-suspend-evt",">reference/threads.html#(def._((quote._~23~25kernel)._thread-suspend-evt))",[0,[2,"thread-suspend-evt"]],["racket/base","racket"]],
["thread-try-receive",">reference/threads.html#(def._((quote._~23~25kernel)._thread-try-receive))",[0,[2,"thread-try-receive"]],["racket/base","racket"]],
["thread-wait",">reference/threads.html#(def._((quote._~23~25kernel)._thread-wait))",[0,[2,"thread-wait"]],["racket/base","racket"]],
["thread/suspend-to-kill",">reference/threads.html#(def._((quote._~23~25kernel)._thread/suspend-to-kill))",[0,[2,"thread/suspend-to-kill"]],["racket/base","racket"]],
["thread?",">reference/threads.html#(def._((quote._~23~25kernel)._thread~3f))",[0,[2,"thread?"]],["racket/base","racket"]],
["threads run state",">reference/threads.html#(idx._(gentag._168._(lib._scribblings/reference/reference..scrbl)))","threads, run state",false],
["threads breaking",">reference/breakhandler.html","threads, breaking",false],
["threads breaking",">reference/threads.html#(idx._(gentag._167._(lib._scribblings/reference/reference..scrbl)))","threads, breaking",false],
["threads",">inside/threads.html","Threads",false],
["threads",">reference/eval-model.html#(part._thread-model)","Threads",false],
["threads",">reference/threads.html","Threads",false],
["threads",">reference/eval-model.html#(tech._thread)","<span style=\"font-style: italic\">threads</span>",false],
["threads and custodians",">web-server-internal/dispatch-server-unit.html#(part._.Threads_and_.Custodians)","Threads and Custodians",false],
["threads in embedded racket with event loops",">inside/threads.html#(part._threadtime)","Threads in Embedded Racket with Event Loops",false],
["thunk",">reference/procedures.html#(form._((lib._racket/function..rkt)._thunk))",[0,[1,"thunk"]],["racket/function","racket"]],
["thunk",">preprocessor/mzpp.html#(form._((lib._preprocessor/mzpp..rkt)._thunk))",[0,[1,"thunk"]],["preprocessor/mzpp"]],
["thunk*",">reference/procedures.html#(form._((lib._racket/function..rkt)._thunk*))",[0,[1,"thunk*"]],["racket/function","racket"]],
["tick",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._tick))",[0,[2,"tick"]],["plot"]],
["tick combinators",">plot/ticks_and_transforms.html#(part._.Tick_.Combinators)","Tick Combinators",false],
["tick data types and contracts",">plot/ticks_and_transforms.html#(part._.Tick_.Data_.Types_and_.Contracts)","Tick Data Types and Contracts",false],
["tick-grid",">plot/renderer2d.html#(def._((lib._plot/main..rkt)._tick-grid))",[0,[2,"tick-grid"]],["plot"]],
["tick-label",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._tick-label))",[0,[2,"tick-label"]],["plot"]],
["tick?",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._tick~3f))",[0,[2,"tick?"]],["plot"]],
["ticks",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._ticks))",[0,[2,"ticks"]],["plot"]],
["ticks-add",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._ticks-add))",[0,[2,"ticks-add"]],["plot"]],
["ticks-default-number",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._ticks-default-number))",[0,[2,"ticks-default-number"]],["plot"]],
["ticks-format",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._ticks-format))",[0,[2,"ticks-format"]],["plot"]],
["ticks-format/c",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._ticks-format/c))",[0,[2,"ticks-format/c"]],["plot"]],
["ticks-layout",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._ticks-layout))",[0,[2,"ticks-layout"]],["plot"]],
["ticks-layout/c",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._ticks-layout/c))",[0,[2,"ticks-layout/c"]],["plot"]],
["ticks-mimic",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._ticks-mimic))",[0,[2,"ticks-mimic"]],["plot"]],
["ticks-scale",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._ticks-scale))",[0,[2,"ticks-scale"]],["plot"]],
["ticks?",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._ticks~3f))",[0,[2,"ticks?"]],["plot"]],
["tile",">unstable/ppict.html#(def._((lib._unstable/gui/ppict..rkt)._tile))",[0,[2,"tile"]],["unstable/gui/ppict"]],
["time",">reference/time.html","Time",false],
["time",">reference/time.html#(form._((lib._racket/private/more-scheme..rkt)._time))",[0,[1,"time"]],["racket/base","racket"]],
["time",">htdp-langs/advanced.html#(form._((lib._lang/htdp-advanced..rkt)._time))",[0,[1,"time"]],["lang/htdp-advanced"]],
["time",">htdp-langs/intermediate.html#(form._((lib._lang/htdp-intermediate..rkt)._time))",[0,[1,"time"]],["lang/htdp-intermediate"]],
["time",">htdp-langs/intermediate-lam.html#(form._((lib._lang/htdp-intermediate-lambda..rkt)._time))",[0,[1,"time"]],["lang/htdp-intermediate-lambda"]],
["time",">eopl/index.html#(form._((lib._eopl/eopl..rkt)._time))",[0,[1,"time"]],["eopl"]],
["time ticks",">plot/ticks_and_transforms.html#(part._.Time_.Ticks)","Time Ticks",false],
["time-apply",">reference/time.html#(def._((quote._~23~25kernel)._time-apply))",[0,[2,"time-apply"]],["racket/base","racket"]],
["time-difference",">srfi-std/srfi-19.html#time-difference",[0,[2,"time-difference"]],["srfi/19"]],
["time-difference!",">srfi-std/srfi-19.html#time-difference!",[0,[2,"time-difference!"]],["srfi/19"]],
["time-duration",">srfi-std/srfi-19.html#",[0,[2,"time-duration"]],["srfi/19"]],
["time-evt",">mzlib/mzlib_cml.html#(def._((lib._mzlib/cml..rkt)._time-evt))",[0,[2,"time-evt"]],["mzlib/cml"]],
["time-monotonic",">srfi-std/srfi-19.html#time-monotonic",[0,[2,"time-monotonic"]],["srfi/19"]],
["time-monotonic->date",">srfi-std/srfi-19.html#time-monotonic->date",[0,[2,"time-monotonic->date"]],["srfi/19"]],
["time-monotonic->julian-day",">srfi-std/srfi-19.html#time-monotonic->julian-day",[0,[2,"time-monotonic->julian-day"]],["srfi/19"]],
["time-monotonic->modified-julian-day",">srfi-std/srfi-19.html#time-monotonic->modified-julian-day",[0,[2,"time-monotonic->modified-julian-day"]],["srfi/19"]],
["time-monotonic->time-tai",">srfi-std/srfi-19.html#time-monotonic->time-tai",[0,[2,"time-monotonic->time-tai"]],["srfi/19"]],
["time-monotonic->time-tai!",">srfi-std/srfi-19.html#time-monotonic->time-tai!",[0,[2,"time-monotonic->time-tai!"]],["srfi/19"]],
["time-monotonic->time-utc",">srfi-std/srfi-19.html#time-monotonic->time-utc",[0,[2,"time-monotonic->time-utc"]],["srfi/19"]],
["time-monotonic->time-utc!",">srfi-std/srfi-19.html#time-monotonic->time-utc!",[0,[2,"time-monotonic->time-utc!"]],["srfi/19"]],
["time-nanosecond",">srfi-std/srfi-19.html#time-nanosecond",[0,[2,"time-nanosecond"]],["srfi/19"]],
["time-process",">srfi-std/srfi-19.html#time-process",[0,[2,"time-process"]],["srfi/19"]],
["time-resolution",">srfi-std/srfi-19.html#time-resolution",[0,[2,"time-resolution"]],["srfi/19"]],
["time-second",">srfi-std/srfi-19.html#time-second",[0,[2,"time-second"]],["srfi/19"]],
["time-tai",">srfi-std/srfi-19.html#time-tai",[0,[2,"time-tai"]],["srfi/19"]],
["time-tai->date",">srfi-std/srfi-19.html#time-tai->date",[0,[2,"time-tai->date"]],["srfi/19"]],
["time-tai->julian-day",">srfi-std/srfi-19.html#time-tai->julian-day",[0,[2,"time-tai->julian-day"]],["srfi/19"]],
["time-tai->modified-julian-day",">srfi-std/srfi-19.html#time-tai->modified-julian-day",[0,[2,"time-tai->modified-julian-day"]],["srfi/19"]],
["time-tai->time-monotonic",">srfi-std/srfi-19.html#time-tai->time-monotonic",[0,[2,"time-tai->time-monotonic"]],["srfi/19"]],
["time-tai->time-monotonic!",">srfi-std/srfi-19.html#time-tai->time-monotonic!",[0,[2,"time-tai->time-monotonic!"]],["srfi/19"]],
["time-tai->time-utc",">srfi-std/srfi-19.html#time-tai->time-utc",[0,[2,"time-tai->time-utc"]],["srfi/19"]],
["time-tai->time-utc!",">srfi-std/srfi-19.html#time-tai->time-utc!",[0,[2,"time-tai->time-utc!"]],["srfi/19"]],
["time-thread",">srfi-std/srfi-19.html#time-thread",[0,[2,"time-thread"]],["srfi/19"]],
["time-ticks",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._time-ticks))",[0,[2,"time-ticks"]],["plot"]],
["time-ticks-format",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._time-ticks-format))",[0,[2,"time-ticks-format"]],["plot"]],
["time-ticks-formats",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._time-ticks-formats))",[0,[2,"time-ticks-formats"]],["plot"]],
["time-ticks-layout",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._time-ticks-layout))",[0,[2,"time-ticks-layout"]],["plot"]],
["time-type",">srfi-std/srfi-19.html#time-type",[0,[2,"time-type"]],["srfi/19"]],
["time-utc",">srfi-std/srfi-19.html#time-utc",[0,[2,"time-utc"]],["srfi/19"]],
["time-utc->date",">srfi-std/srfi-19.html#time-utc->date",[0,[2,"time-utc->date"]],["srfi/19"]],
["time-utc->julian-day",">srfi-std/srfi-19.html#time-utc->julian-day",[0,[2,"time-utc->julian-day"]],["srfi/19"]],
["time-utc->modified-julian-day",">srfi-std/srfi-19.html#time-utc->modified-julian-day",[0,[2,"time-utc->modified-julian-day"]],["srfi/19"]],
["time-utc->time-monotonic",">srfi-std/srfi-19.html#time-utc->time-monotonic",[0,[2,"time-utc->time-monotonic"]],["srfi/19"]],
["time-utc->time-monotonic!",">srfi-std/srfi-19.html#time-utc->time-monotonic!",[0,[2,"time-utc->time-monotonic!"]],["srfi/19"]],
["time-utc->time-tai",">srfi-std/srfi-19.html#time-utc->time-tai",[0,[2,"time-utc->time-tai"]],["srfi/19"]],
["time-utc->time-tai!",">srfi-std/srfi-19.html#time-utc->time-tai!",[0,[2,"time-utc->time-tai!"]],["srfi/19"]],
["time<=?",">srfi-std/srfi-19.html#time<=-p",[0,[2,"time<=?"]],["srfi/19"]],
["time<?",">srfi-std/srfi-19.html#time<-p",[0,[2,"time<?"]],["srfi/19"]],
["time=?",">srfi-std/srfi-19.html#time=-p",[0,[2,"time=?"]],["srfi/19"]],
["time>=?",">srfi-std/srfi-19.html#time>=-p",[0,[2,"time>=?"]],["srfi/19"]],
["time>?",">srfi-std/srfi-19.html#time>-p",[0,[2,"time>?"]],["srfi/19"]],
["time?",">srfi-std/srfi-19.html#time-p",[0,[2,"time?"]],["srfi/19"]],
["timeline-events",">reference/futures-trace.html#(def._((lib._future-visualizer/trace..rkt)._timeline-events))",[0,[2,"timeline-events"]],["future-visualizer/trace"]],
["timeline-pict",">reference/futures-visualizer.html#(def._((lib._future-visualizer/main..rkt)._timeline-pict))",[0,"timeline-pict"],["future-visualizer"]],
["timeouts",">web-server-internal/dispatch-timeout.html","Timeouts",false],
["timeouts",">web-server/servlet.html#(part._timeouts)","Timeouts",false],
["timeouts",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._timeouts))",[0,[2,"timeouts"]],["web-server/configuration/configuration-table-structs"]],
["timeouts",">web-server-internal/Web_Servers.html#(idx._(gentag._17._(lib._web-server/scribblings/web-server-internal..scrbl)))","timeouts",false],
["timeouts-default-servlet",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._timeouts-default-servlet))",[0,[2,"timeouts-default-servlet"]],["web-server/configuration/configuration-table-structs"]],
["timeouts-file-base",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._timeouts-file-base))",[0,[2,"timeouts-file-base"]],["web-server/configuration/configuration-table-structs"]],
["timeouts-file-per-byte",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._timeouts-file-per-byte))",[0,[2,"timeouts-file-per-byte"]],["web-server/configuration/configuration-table-structs"]],
["timeouts-password",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._timeouts-password))",[0,[2,"timeouts-password"]],["web-server/configuration/configuration-table-structs"]],
["timeouts-servlet-connection",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._timeouts-servlet-connection))",[0,[2,"timeouts-servlet-connection"]],["web-server/configuration/configuration-table-structs"]],
["timeouts?",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table-structs..rkt)._timeouts~3f))",[0,[2,"timeouts?"]],["web-server/configuration/configuration-table-structs"]],
["timer",">web-server-internal/timer.html#(def._((lib._web-server/private/timer..rkt)._timer))",[0,[2,"timer"]],["web-server/private/timer"]],
["timer events",">gui/windowing-overview.html#(tech._timer._event)","<span style=\"font-style: italic\">Timer events</span>",false],
["timer%",">gui/timer_.html",[0,[2,"timer%"]],["racket/gui/base","racket/gui"]],
["timer-action",">web-server-internal/timer.html#(def._((lib._web-server/private/timer..rkt)._timer-action))",[0,[2,"timer-action"]],["web-server/private/timer"]],
["timer-evt",">web-server-internal/timer.html#(def._((lib._web-server/private/timer..rkt)._timer-evt))",[0,[2,"timer-evt"]],["web-server/private/timer"]],
["timer-expire-seconds",">web-server-internal/timer.html#(def._((lib._web-server/private/timer..rkt)._timer-expire-seconds))",[0,[2,"timer-expire-seconds"]],["web-server/private/timer"]],
["timer?",">web-server-internal/timer.html#(def._((lib._web-server/private/timer..rkt)._timer~3f))",[0,[2,"timer?"]],["web-server/private/timer"]],
["timers",">web-server-internal/timer.html","Timers",false],
["times",">htdp-langs/beginner.html#(idx._htdp-beginner._(gentag._0._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-beginner))","times",false],
["times",">htdp-langs/beginner-abbr.html#(idx._htdp-beginner-abbr._(gentag._15._(lib._scribblings/htdp-langs/htdp-langs..scrbl)._htdp-beginner-abbr))","times",false],
["tiny-control-font",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._tiny-control-font))",[0,[2,"tiny-control-font"]],["racket/gui/base","racket/gui"]],
["title",">html/index.html#(def._((lib._html/main..rkt)._title))",[0,[2,"title"]],["html"]],
["title",">scribble/base.html#(def._((lib._scribble/base..rkt)._title))",[0,[2,"title"]],["scribble/base"]],
["title-case",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex..rkt)._title-case))",[0,[1,"title-case"]],["parser-tools/lex"]],
["title-decl",">scribble/decode.html#(def._((lib._scribble/decode..rkt)._title-decl))",[0,[2,"title-decl"]],["scribble/decode"]],
["title-decl-content",">scribble/decode.html#(def._((lib._scribble/decode..rkt)._title-decl-content))",[0,[2,"title-decl-content"]],["scribble/decode"]],
["title-decl-style",">scribble/decode.html#(def._((lib._scribble/decode..rkt)._title-decl-style))",[0,[2,"title-decl-style"]],["scribble/decode"]],
["title-decl-tag-prefix",">scribble/decode.html#(def._((lib._scribble/decode..rkt)._title-decl-tag-prefix))",[0,[2,"title-decl-tag-prefix"]],["scribble/decode"]],
["title-decl-tags",">scribble/decode.html#(def._((lib._scribble/decode..rkt)._title-decl-tags))",[0,[2,"title-decl-tags"]],["scribble/decode"]],
["title-decl-version",">scribble/decode.html#(def._((lib._scribble/decode..rkt)._title-decl-version))",[0,[2,"title-decl-version"]],["scribble/decode"]],
["title-decl?",">scribble/decode.html#(def._((lib._scribble/decode..rkt)._title-decl~3f))",[0,[2,"title-decl?"]],["scribble/decode"]],
["title-h",">slideshow/Constants_and_Layout_Variables.html#(form._((lib._slideshow/base..rkt)._title-h))",[0,[1,"title-h"]],["slideshow/base","slideshow"]],
["title?",">html/index.html#(def._((lib._html/main..rkt)._title~3f))",[0,[2,"title?"]],["html"]],
["titleless-page",">slideshow/Constants_and_Layout_Variables.html#(form._((lib._slideshow/base..rkt)._titleless-page))",[0,[1,"titleless-page"]],["slideshow/base","slideshow"]],
["titlet",">slideshow/Primary_Slide_Functions.html#(def._((lib._slideshow/base..rkt)._titlet))",[0,[2,"titlet"]],["slideshow/base","slideshow"]],
["tmp",">reference/Filesystem.html#(idx._(gentag._272._(lib._scribblings/reference/reference..scrbl)))",[6,"TMP"],false],
["tmpdir",">reference/Filesystem.html#(idx._(gentag._271._(lib._scribblings/reference/reference..scrbl)))",[6,"TMPDIR"],false],
["to-boolean",">web-server/formlets.html#(def._((lib._web-server/formlets/input..rkt)._to-boolean))",[0,[2,"to-boolean"]],["web-server/formlets/input"]],
["to-draw",">teachpack/2htdpuniverse.html#(form._((lib._2htdp/universe..rkt)._to-draw))",[0,[1,"to-draw"]],["2htdp/universe"]],
["to-element",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._to-element))",[0,[2,"to-element"]],["scribble/racket","scribble/scheme"]],
["to-element/no-color",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._to-element/no-color))",[0,[2,"to-element/no-color"]],["scribble/racket","scribble/scheme"]],
["to-lw",">redex/The_Redex_Reference.html#(form._((lib._redex/pict..rkt)._to-lw))",[0,[1,"to-lw"]],["redex/pict","redex"]],
["to-lw/stx",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._to-lw/stx))",[0,[2,"to-lw/stx"]],["redex/pict","redex"]],
["to-number",">web-server/formlets.html#(def._((lib._web-server/formlets/input..rkt)._to-number))",[0,[2,"to-number"]],["web-server/formlets/input"]],
["to-paragraph",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._to-paragraph))",[0,[2,"to-paragraph"]],["scribble/racket","scribble/scheme"]],
["to-paragraph/prefix",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._to-paragraph/prefix))",[0,[2,"to-paragraph/prefix"]],["scribble/racket","scribble/scheme"]],
["to-string",">teachpack/2htdpuniverse.html#(form._((lib._2htdp/universe..rkt)._to-string))",[0,[1,"to-string"]],["2htdp/universe"]],
["to-string",">web-server/formlets.html#(def._((lib._web-server/formlets/input..rkt)._to-string))",[0,[2,"to-string"]],["web-server/formlets/input"]],
["to-symbol",">web-server/formlets.html#(def._((lib._web-server/formlets/input..rkt)._to-symbol))",[0,[2,"to-symbol"]],["web-server/formlets/input"]],
["toc-element",">scribble/core.html#(def._((lib._scribble/core..rkt)._toc-element))",[0,[2,"toc-element"]],["scribble/core"]],
["toc-element-toc-content",">scribble/core.html#(def._((lib._scribble/core..rkt)._toc-element-toc-content))",[0,[2,"toc-element-toc-content"]],["scribble/core"]],
["toc-element?",">scribble/core.html#(def._((lib._scribble/core..rkt)._toc-element~3f))",[0,[2,"toc-element?"]],["scribble/core"]],
["toc-target-element",">scribble/core.html#(def._((lib._scribble/core..rkt)._toc-target-element))",[0,[2,"toc-target-element"]],["scribble/core"]],
["toc-target-element?",">scribble/core.html#(def._((lib._scribble/core..rkt)._toc-target-element~3f))",[0,[2,"toc-target-element?"]],["scribble/core"]],
["toggle-anchor",">framework/Keymap.html#(idx._(gentag._15._(lib._scribblings/framework/framework..scrbl)))","toggle-anchor",false],
["toggle-button-snip%",">embedded-gui/toggle-button-snip_.html",[0,[2,"toggle-button-snip%"]],["embedded-gui"]],
["toggle-open/closed",">mrlib/hierarchical-list-compound-item___.html#(meth._(((lib._mrlib/hierlist..rkt)._hierarchical-list-compound-item~3c~25~3e)._toggle-open/closed))",[[0,[2,"toggle-open/closed"]],[14,[" (method of ",[0,[2,"hierarchical-list-compound-item<%>"]],")"]]],["mrlib/hierlist"]],
["toggle-overwrite",">framework/Keymap.html#(idx._(gentag._41._(lib._scribblings/framework/framework..scrbl)))","toggle-overwrite",false],
["token",">parser-tools/Lexers.html#(tech._token)","<span style=\"font-style: italic\">token</span>",false],
["token-name",">parser-tools/Lexers.html#(def._((lib._parser-tools/lex..rkt)._token-name))",[0,[2,"token-name"]],["parser-tools/lex"]],
["token-tree%",">syntax-color/index.html#(def._((lib._syntax-color/token-tree..rkt)._token-tree~25))",[0,[2,"token-tree%"]],["syntax-color/token-tree"]],
["token-value",">parser-tools/Lexers.html#(def._((lib._parser-tools/lex..rkt)._token-value))",[0,[2,"token-value"]],["parser-tools/lex"]],
["token?",">parser-tools/Lexers.html#(def._((lib._parser-tools/lex..rkt)._token~3f))",[0,[2,"token?"]],["parser-tools/lex"]],
["tokens",">parser-tools/Lexers.html#(part._.Tokens)","Tokens",false],
["tool",">drracket/extending-drracket.html#(tech._tool)","<span style=\"font-style: italic\">tool</span>",false],
["tool icons",">images/Icons.html#(part._tool)","Tool Icons",false],
["tool web sites menu item",">drracket/Menus.html#(idx._(gentag._150._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Tool Web Sites</span> menu item",false],
["tool@",">browser/index.html#(def._((lib._browser/tool..rkt)._tool~40))",[0,[2,"tool@"]],["browser/tool"]],
["toolbar hidden menu item",">drracket/Menus.html#(idx._(gentag._96._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Toolbar Hidden</span> menu item",false],
["toolbar menu item",">drracket/Menus.html#(idx._(gentag._92._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Toolbar</span> menu item",false],
["toolbar on left menu item",">drracket/Menus.html#(idx._(gentag._93._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Toolbar on Left</span> menu item",false],
["toolbar on right menu item",">drracket/Menus.html#(idx._(gentag._95._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Toolbar on Right</span> menu item",false],
["toolbar on top menu item",">drracket/Menus.html#(idx._(gentag._94._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Toolbar on Top</span> menu item",false],
["toolbar-button",">gui/frame_.html#(idx._(gentag._37._(lib._scribblings/gui/gui..scrbl)))",[7,"'toolbar-button"],false],
["toolbar-icon-height",">images/Icons.html#(def._((lib._images/icons/style..rkt)._toolbar-icon-height))",[0,[2,"toolbar-icon-height"]],["images/icons/style"]],
["tools",">drracket/prefs-explanation.html#(part._.Tools)","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Tools</span>",false],
["top",">gui/style-delta_.html#(idx._(gentag._176._(lib._scribblings/gui/gui..scrbl)))",[7,"'top"],false],
["top-level binding",">reference/syntax-model.html#(tech._top._level._binding)","<span style=\"font-style: italic\">top-level binding</span>",false],
["top-level context",">reference/syntax-model.html#(tech._top._level._context)","<span style=\"font-style: italic\">top-level context</span>",false],
["top-level evaluation functions",">inside/Evaluation.html#(part._topleveleval)","Top-level Evaluation Functions",false],
["top-level variable",">reference/eval-model.html#(tech._top._level._variable)","<span style=\"font-style: italic\">top-level variable</span>",false],
["top-level variables",">reference/eval-model.html#(part._.Top-.Level_.Variables)","Top-Level Variables",false],
["top-level-rename",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._top-level-rename))",[0,[2,"top-level-rename"]],["compiler/zo-structs"]],
["top-level-rename-flag",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._top-level-rename-flag))",[0,[2,"top-level-rename-flag"]],["compiler/zo-structs"]],
["top-level-rename?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._top-level-rename~3f))",[0,[2,"top-level-rename?"]],["compiler/zo-structs"]],
["top-level-window<%>",">gui/top-level-window___.html",[0,[2,"top-level-window<%>"]],["racket/gui/base","racket/gui"]],
["toplevel",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._toplevel))",[0,[2,"toplevel"]],["compiler/zo-structs"]],
["toplevel interface",">profile/index.html#(part._.Toplevel_.Interface)","Toplevel Interface",false],
["toplevel-const?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._toplevel-const~3f))",[0,[2,"toplevel-const?"]],["compiler/zo-structs"]],
["toplevel-depth",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._toplevel-depth))",[0,[2,"toplevel-depth"]],["compiler/zo-structs"]],
["toplevel-pos",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._toplevel-pos))",[0,[2,"toplevel-pos"]],["compiler/zo-structs"]],
["toplevel-ready?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._toplevel-ready~3f))",[0,[2,"toplevel-ready?"]],["compiler/zo-structs"]],
["toplevel?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._toplevel~3f))",[0,[2,"toplevel?"]],["compiler/zo-structs"]],
["topsyntax",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._topsyntax))",[0,[2,"topsyntax"]],["compiler/zo-structs"]],
["topsyntax-depth",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._topsyntax-depth))",[0,[2,"topsyntax-depth"]],["compiler/zo-structs"]],
["topsyntax-midpt",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._topsyntax-midpt))",[0,[2,"topsyntax-midpt"]],["compiler/zo-structs"]],
["topsyntax-pos",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._topsyntax-pos))",[0,[2,"topsyntax-pos"]],["compiler/zo-structs"]],
["topsyntax?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._topsyntax~3f))",[0,[2,"topsyntax?"]],["compiler/zo-structs"]],
["touch",">reference/futures.html#(def._((lib._racket/future..rkt)._touch))",[0,[2,"touch"]],["racket/future","racket"]],
["tp-error",">htdp/index.html#(def._((lib._htdp/error..rkt)._tp-error))",[0,[2,"tp-error"]],["htdp/error"]],
["tp-exn?",">htdp/index.html#(def._((lib._htdp/error..rkt)._tp-exn~3f))",[0,[2,"tp-exn?"]],["htdp/error"]],
["tprompt",">turtles/Traditional_Turtles.html#(form._((lib._graphics/turtles..rkt)._tprompt))",[0,[1,"tprompt"]],["graphics/turtles"]],
["tr",">html/index.html#(def._((lib._html/main..rkt)._tr))",[0,[2,"tr"]],["html"]],
["tr?",">html/index.html#(def._((lib._html/main..rkt)._tr~3f))",[0,[2,"tr?"]],["html"]],
["trace",">trace/index.html#(mod-path._trace)",[9,[0,"trace"]],"module"],
["trace",">reference/debugging.html#(form._((lib._racket/trace..rkt)._trace))",[0,[1,"trace"]],["racket/trace"]],
["trace",">eopl/index.html#(form._((lib._eopl/eopl..rkt)._trace))",[0,[1,"trace"]],["eopl"]],
["trace-call",">reference/debugging.html#(def._((lib._racket/trace..rkt)._trace-call))",[0,[2,"trace-call"]],["racket/trace"]],
["trace-futures",">reference/futures-trace.html#(form._((lib._future-visualizer/trace..rkt)._trace-futures))",[0,[1,"trace-futures"]],["future-visualizer/trace"]],
["trace-futures-thunk",">reference/futures-trace.html#(def._((lib._future-visualizer/trace..rkt)._trace-futures-thunk))",[0,[2,"trace-futures-thunk"]],["future-visualizer/trace"]],
["trace/calltrace-lib",">trace/index.html#(mod-path._trace/calltrace-lib)",[9,[0,"trace/calltrace-lib"]],"module"],
["trace: instrumentation to show function calls",">trace/index.html","Trace: Instrumentation to Show Function Calls",false],
["traces",">redex/The_Redex_Reference.html#(def._((lib._redex/gui..rkt)._traces))",[0,[2,"traces"]],["redex/gui","redex"]],
["traces/ps",">redex/The_Redex_Reference.html#(def._((lib._redex/gui..rkt)._traces/ps))",[0,[2,"traces/ps"]],["redex/gui","redex"]],
["tracing",">reference/debugging.html#(part._.Tracing)","Tracing",false],
["traditional turtles",">turtles/Traditional_Turtles.html","Traditional Turtles",false],
["trait",">reference/trait.html#(form._((lib._racket/trait..rkt)._trait))",[0,"trait"],["racket/trait"]],
["trait",">reference/trait.html#(tech._trait)","<span style=\"font-style: italic\">trait</span>",false],
["trait->mixin",">reference/trait.html#(def._((lib._racket/trait..rkt)._trait-~3emixin))",[0,"trait->mixin"],["racket/trait"]],
["trait-alias",">reference/trait.html#(form._((lib._racket/trait..rkt)._trait-alias))",[0,"trait-alias"],["racket/trait"]],
["trait-exclude",">reference/trait.html#(form._((lib._racket/trait..rkt)._trait-exclude))",[0,"trait-exclude"],["racket/trait"]],
["trait-exclude-field",">reference/trait.html#(form._((lib._racket/trait..rkt)._trait-exclude-field))",[0,"trait-exclude-field"],["racket/trait"]],
["trait-rename",">reference/trait.html#(form._((lib._racket/trait..rkt)._trait-rename))",[0,"trait-rename"],["racket/trait"]],
["trait-rename-field",">reference/trait.html#(form._((lib._racket/trait..rkt)._trait-rename-field))",[0,"trait-rename-field"],["racket/trait"]],
["trait-sum",">reference/trait.html#(def._((lib._racket/trait..rkt)._trait-sum))",[0,"trait-sum"],["racket/trait"]],
["trait?",">reference/trait.html#(def._((lib._racket/trait..rkt)._trait~3f))",[0,"trait?"],["racket/trait"]],
["traits",">guide/classes.html#(part._.Traits)","Traits",false],
["traits",">reference/trait.html","Traits",false],
["traits as sets of mixins",">guide/classes.html#(part._.Traits_as_.Sets_of_.Mixins)","Traits as Sets of Mixins",false],
["trans",">parser-tools/Converting_yacc_or_bison_Grammars.html#(def._((lib._parser-tools/yacc-to-scheme..rkt)._trans))",[0,"trans"],["parser-tools/yacc-to-scheme"]],
["transactions",">db/query-api.html#(part._transactions)","Transactions",false],
["transcoded-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_650",[0,[2,"transcoded-port"]],["rnrs/io/ports-6"]],
["transcoder-codec",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_624",[0,[2,"transcoder-codec"]],["rnrs/io/ports-6"]],
["transcoder-eol-style",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_626",[0,[2,"transcoder-eol-style"]],["rnrs/io/ports-6"]],
["transcoder-error-handling-mode",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_628",[0,[2,"transcoder-error-handling-mode"]],["rnrs/io/ports-6"]],
["transcript-off",">r5rs-std/r5rs-Z-H-9.html#%_idx_672",[0,[2,"transcript-off"]],["r5rs"]],
["transcript-off",">mzlib/mzlib_transcr.html#(def._((lib._mzlib/transcr..rkt)._transcript-off))",[0,[2,"transcript-off"]],["mzlib/transcr"]],
["transcript-off",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..rkt)._transcript-off))",[0,[2,"transcript-off"]],["mzscheme"]],
["transcript-on",">r5rs-std/r5rs-Z-H-9.html#%_idx_670",[0,[2,"transcript-on"]],["r5rs"]],
["transcript-on",">mzlib/mzlib_transcr.html#(def._((lib._mzlib/transcr..rkt)._transcript-on))",[0,[2,"transcript-on"]],["mzlib/transcr"]],
["transcript-on",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..rkt)._transcript-on))",[0,[2,"transcript-on"]],["mzscheme"]],
["transform",">draw/dc-path_.html#(meth._(((lib._racket/draw..rkt)._dc-path~25)._transform))",[[0,[2,"transform"]],[14,[" (method of ",[0,[2,"dc-path%"]],")"]]],["racket/draw"]],
["transform",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._transform))",[[0,[2,"transform"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["transform-primitive-list",">deinprogramm/line3d.html#(def._((lib._teachpack/deinprogramm/line3d..rkt)._transform-primitive-list))",[0,[2,"transform-primitive-list"]],["teachpack/deinprogramm/line3d"]],
["transform-template",">syntax/transformer-helpers.html#(def._((lib._syntax/template..rkt)._transform-template))",[0,[2,"transform-template"]],["syntax/template"]],
["transform-vec3",">deinprogramm/line3d.html#(def._((lib._teachpack/deinprogramm/line3d..rkt)._transform-vec3))",[0,[2,"transform-vec3"]],["teachpack/deinprogramm/line3d"]],
["transformations",">draw/overview.html#(part._.Transformations)","Transformations",false],
["transformer",">guide/macros.html#(tech._transformer)","<span style=\"font-style: italic\">transformer</span>",false],
["transformer binding",">guide/proc-macros.html#(tech._transformer._binding)","<span style=\"font-style: italic\">transformer\nbinding</span>",false],
["transformer binding",">reference/syntax-model.html#(tech._transformer._binding)","<span style=\"font-style: italic\">transformer\nbinding</span>",false],
["transformer bindings",">reference/syntax-model.html#(part._transformer-model)","Transformer Bindings",false],
["transformer environment",">reference/syntax-model.html#(tech._transformer._environment)","<span style=\"font-style: italic\">transformer environment</span>",false],
["transformer helpers",">reference/Transformer_Helpers.html","Transformer Helpers",false],
["translate",">draw/dc-path_.html#(meth._(((lib._racket/draw..rkt)._dc-path~25)._translate))",[[0,[2,"translate"]],[14,[" (method of ",[0,[2,"dc-path%"]],")"]]],["racket/draw"]],
["translate",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._translate))",[[0,[2,"translate"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["transparent",">draw/brush_.html#(idx._(gentag._11._(lib._scribblings/draw/draw..scrbl)))",[7,"'transparent"],false],
["transparent",">reference/stxcerts.html#(idx._(gentag._185._(lib._scribblings/reference/reference..scrbl)))",[7,"'transparent"],false],
["transparent",">gui/canvas___.html#(idx._(gentag._22._(lib._scribblings/gui/gui..scrbl)))",[7,"'transparent"],false],
["transparent",">gui/canvas___.html#(idx._(gentag._23._(lib._scribblings/gui/gui..scrbl)))",[7,"'transparent"],false],
["transparent",">draw/pen_.html#(idx._(gentag._52._(lib._scribblings/draw/draw..scrbl)))",[7,"'transparent"],false],
["transparent",">guide/define-struct.html#(tech._transparent)","<span style=\"font-style: italic\">transparent</span>",false],
["transparent-binding",">reference/stxcerts.html#(idx._(gentag._186._(lib._scribblings/reference/reference..scrbl)))",[7,"'transparent-binding"],false],
["transplant-input-port",">reference/port-lib.html#(def._((lib._racket/port..rkt)._transplant-input-port))",[0,[2,"transplant-input-port"]],["racket/port","racket"]],
["transplant-output-port",">reference/port-lib.html#(def._((lib._racket/port..rkt)._transplant-output-port))",[0,[2,"transplant-output-port"]],["racket/port","racket"]],
["transpose-chars",">framework/Keymap.html#(idx._(gentag._21._(lib._scribblings/framework/framework..scrbl)))","transpose-chars",false],
["transpose-matrix4x4",">deinprogramm/line3d.html#(def._((lib._teachpack/deinprogramm/line3d..rkt)._transpose-matrix4x4))",[0,[2,"transpose-matrix4x4"]],["teachpack/deinprogramm/line3d"]],
["transpose-sexp",">framework/Racket.html#(meth._(((lib._framework/main..rkt)._racket~3atext~3c~25~3e)._transpose-sexp))",[[0,[2,"transpose-sexp"]],[14,[" (method of ",[0,[2,"racket:text<%>"]],")"]]],["framework"]],
["transpose-words",">framework/Keymap.html#(idx._(gentag._22._(lib._scribblings/framework/framework..scrbl)))","transpose-words",false],
["traverse",">scribble/renderer.html#(meth._(((lib._scribble/base-render..rkt)._render~25)._traverse))",[[0,[2,"traverse"]],[14,[" (method of ",[0,[2,"render%"]],")"]]],["scribble/base-render"]],
["traverse block",">scribble/core.html#(tech._traverse._block)","<span style=\"font-style: italic\">traverse block</span>",false],
["traverse element",">scribble/core.html#(tech._traverse._element)","<span style=\"font-style: italic\">traverse element</span>",false],
["traverse pass",">scribble/core.html#(tech._traverse._pas)","<span style=\"font-style: italic\">traverse pass</span>",false],
["traverse-block",">scribble/core.html#(def._((lib._scribble/core..rkt)._traverse-block))",[0,[2,"traverse-block"]],["scribble/core"]],
["traverse-block-block",">scribble/core.html#(def._((lib._scribble/core..rkt)._traverse-block-block))",[0,[2,"traverse-block-block"]],["scribble/core"]],
["traverse-block-traverse",">scribble/core.html#(def._((lib._scribble/core..rkt)._traverse-block-traverse))",[0,[2,"traverse-block-traverse"]],["scribble/core"]],
["traverse-block?",">scribble/core.html#(def._((lib._scribble/core..rkt)._traverse-block~3f))",[0,[2,"traverse-block?"]],["scribble/core"]],
["traverse-element",">scribble/core.html#(def._((lib._scribble/core..rkt)._traverse-element))",[0,[2,"traverse-element"]],["scribble/core"]],
["traverse-element-content",">scribble/core.html#(def._((lib._scribble/core..rkt)._traverse-element-content))",[0,[2,"traverse-element-content"]],["scribble/core"]],
["traverse-element-traverse",">scribble/core.html#(def._((lib._scribble/core..rkt)._traverse-element-traverse))",[0,[2,"traverse-element-traverse"]],["scribble/core"]],
["traverse-element?",">scribble/core.html#(def._((lib._scribble/core..rkt)._traverse-element~3f))",[0,[2,"traverse-element?"]],["scribble/core"]],
["tree-short",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._tree-short))",[0,[2,"tree-short"]],["2htdp/planetcute"]],
["tree-tall",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._tree-tall))",[0,[2,"tree-tall"]],["2htdp/planetcute"]],
["tree-ugly",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._tree-ugly))",[0,[2,"tree-ugly"]],["2htdp/planetcute"]],
["treeof",">unstable/contract.html#(def._((lib._unstable/contract..rkt)._treeof))",[0,[2,"treeof"]],["unstable/contract"]],
["triangle",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._triangle))",[0,[2,"triangle"]],["2htdp/image"]],
["triangle",">teachpack/image.html#(def._((lib._htdp/image..rkt)._triangle))",[0,[2,"triangle"]],["htdp/image"]],
["triangle",">deinprogramm/image.html#(def._((lib._deinprogramm/image..rkt)._triangle))",[0,[2,"triangle"]],["teachpack/deinprogramm/image"]],
["triangle/aas",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._triangle/aas))",[0,[2,"triangle/aas"]],["2htdp/image"]],
["triangle/asa",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._triangle/asa))",[0,[2,"triangle/asa"]],["2htdp/image"]],
["triangle/ass",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._triangle/ass))",[0,[2,"triangle/ass"]],["2htdp/image"]],
["triangle/saa",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._triangle/saa))",[0,[2,"triangle/saa"]],["2htdp/image"]],
["triangle/sas",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._triangle/sas))",[0,[2,"triangle/sas"]],["2htdp/image"]],
["triangle/ssa",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._triangle/ssa))",[0,[2,"triangle/ssa"]],["2htdp/image"]],
["triangle/sss",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._triangle/sss))",[0,[2,"triangle/sss"]],["2htdp/image"]],
["trigonometric functions",">reference/generic-numbers.html#(part._.Trigonometric_.Functions)","Trigonometric Functions",false],
["troubleshooting and tips",">web-server-internal/Troubleshooting_and_Tips.html","Troubleshooting and Tips",false],
["troubleshooting and tips",">web-server/faq.html","Troubleshooting and Tips",false],
["true",">reference/booleans.html#(def._((lib._racket/bool..rkt)._true))",[0,[2,"true"]],["racket/bool","racket"]],
["true",">htdp-langs/advanced.html#(def._((lib._lang/htdp-advanced..rkt)._true))",[0,[2,"true"]],["lang/htdp-advanced"]],
["true",">htdp-langs/beginner.html#(def._((lib._lang/htdp-beginner..rkt)._true))",[0,[2,"true"]],["lang/htdp-beginner"]],
["true",">htdp-langs/beginner-abbr.html#(def._((lib._lang/htdp-beginner-abbr..rkt)._true))",[0,[2,"true"]],["lang/htdp-beginner-abbr"]],
["true",">htdp-langs/intermediate.html#(def._((lib._lang/htdp-intermediate..rkt)._true))",[0,[2,"true"]],["lang/htdp-intermediate"]],
["true",">htdp-langs/intermediate-lam.html#(def._((lib._lang/htdp-intermediate-lambda..rkt)._true))",[0,[2,"true"]],["lang/htdp-intermediate-lambda"]],
["true",">deinprogramm/Signaturen.html#(form._((lib._deinprogramm/.D.Md.A..rkt)._true))",[0,[1,"true"]],["deinprogramm/DMdA-beginner"]],
["true",">lazy/index.html#(def._((lib._lazy/main..rkt)._true))",[0,[2,"true"]],["lazy"]],
["true",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.True))",[0,[1,"True"]],["typed/racket/base","typed/racket"]],
["true?",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._true~3f))",[0,[2,"true?"]],["deinprogramm/DMdA-advanced"]],
["true?",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._true~3f))",[0,[2,"true?"]],["deinprogramm/DMdA-assignments"]],
["true?",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._true~3f))",[0,[2,"true?"]],["deinprogramm/DMdA-beginner"]],
["true?",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._true~3f))",[0,[2,"true?"]],["deinprogramm/DMdA-vanilla"]],
["truncate",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._truncate))",[0,[2,"truncate"]],["racket/base","racket"]],
["truncate",">r5rs-std/r5rs-Z-H-9.html#%_idx_318",[0,[2,"truncate"]],["r5rs"]],
["truncate",">r6rs-std/r6rs-Z-H-14.html#node_idx_532",[0,[2,"truncate"]],["rnrs/base-6"]],
["truncate",">reference/file-ports.html#(idx._(gentag._205._(lib._scribblings/reference/reference..scrbl)))",[7,"'truncate"],false],
["truncate-file",">mzlib/mzlib_os.html#(def._((lib._mzlib/os..rkt)._truncate-file))",[0,[2,"truncate-file"]],["mzlib/os"]],
["truncate/replace",">reference/file-ports.html#(idx._(gentag._207._(lib._scribblings/reference/reference..scrbl)))",[7,"'truncate/replace"],false],
["trust-existing-zos",">raco/make.html#(def._((lib._compiler/cm..rkt)._trust-existing-zos))",[0,[2,"trust-existing-zos"]],["compiler/cm"]],
["trusting standard recertifying transformers",">syntax/trusted-xforms.html","Trusting Standard Recertifying Transformers",false],
["truth/c",">unstable/contract.html#(def._((lib._unstable/contract..rkt)._truth/c))",[0,[2,"truth/c"]],["unstable/contract"]],
["try-atomic",">foreign/Speculatively_Atomic_Execution.html#(def._((lib._ffi/unsafe/try-atomic..rkt)._try-atomic))",[0,[2,"try-atomic"]],["ffi/unsafe/try-atomic"]],
["try-color",">draw/dc___.html#(meth._(((lib._racket/draw..rkt)._dc~3c~25~3e)._try-color))",[[0,[2,"try-color"]],[14,[" (method of ",[0,[2,"dc<%>"]],")"]]],["racket/draw"]],
["tt",">html/index.html#(def._((lib._html/main..rkt)._tt))",[0,[2,"tt"]],["html"]],
["tt",">scribble/base.html#(def._((lib._scribble/base..rkt)._tt))",[0,[2,"tt"]],["scribble/base"]],
["tt",">slideshow/Primary_Slide_Functions.html#(def._((lib._slideshow/base..rkt)._tt))",[0,[2,"tt"]],["slideshow/base","slideshow"]],
["tt?",">html/index.html#(def._((lib._html/main..rkt)._tt~3f))",[0,[2,"tt?"]],["html"]],
["tuple",">ts-reference/Legacy_Forms.html#(form._((lib._typed-racket/base-env/base-types-extra..rkt)._.Tuple))",[0,[1,"Tuple"]],["typed/racket/base","typed/racket"]],
["turn",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtles..rkt)._turn))",[0,[2,"turn"]],["graphics/turtles"]],
["turn",">turtles/Value_Turtles.html#(def._((lib._graphics/value-turtles..rkt)._turn))",[0,[2,"turn"]],["graphics/value-turtles"]],
["turn",">deinprogramm/turtle.html#(def._((lib._teachpack/deinprogramm/turtle..rkt)._turn))",[0,[2,"turn"]],["teachpack/deinprogramm/turtle"]],
["turn/radians",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtles..rkt)._turn/radians))",[0,[2,"turn/radians"]],["graphics/turtles"]],
["turn/radians",">turtles/Value_Turtles.html#(def._((lib._graphics/value-turtles..rkt)._turn/radians))",[0,[2,"turn/radians"]],["graphics/value-turtles"]],
["turning the optimizer off",">ts-guide/optimization.html#(part._.Turning_the_optimizer_off)","Turning the optimizer off",false],
["turtle",">deinprogramm/turtle.html#(def._((lib._teachpack/deinprogramm/turtle..rkt)._turtle))",[0,[2,"turtle"]],["teachpack/deinprogramm/turtle"]],
["turtle graphics",">turtles/index.html","Turtle Graphics",false],
["turtle-grafik: \"turtle.ss\"",">deinprogramm/turtle.html",["Turtle-Grafik: ",[6,"\"turtle.ss\""],"<a name=\"(idx._(gentag._4._(lib._deinprogramm/scribblings/deinprogramm..scrbl)))\"></a>"],false],
["turtle-teachpack",">deinprogramm/turtle.html#(idx._(gentag._4._(lib._deinprogramm/scribblings/deinprogramm..scrbl)))","turtle-Teachpack",false],
["turtle-window-size",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtles..rkt)._turtle-window-size))",[0,[2,"turtle-window-size"]],["graphics/turtles"]],
["turtles",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtles..rkt)._turtles))",[0,[2,"turtles"]],["graphics/turtles"]],
["turtles",">turtles/Value_Turtles.html#(def._((lib._graphics/value-turtles..rkt)._turtles))",[0,[2,"turtles"]],["graphics/value-turtles"]],
["turtles?",">turtles/Value_Turtles.html#(def._((lib._graphics/value-turtles..rkt)._turtles~3f))",[0,[2,"turtles?"]],["graphics/value-turtles"]],
["tutorial",">datalog/Tutorial.html","Tutorial",false],
["tutorial",">deinprogramm/turtle.html#(part._.Tutorial)","Tutorial",false],
["two ball tossing worlds",">teachpack/2htdpuniverse.html#(part._.Two_.Ball_.Tossing_.Worlds)","Two Ball Tossing Worlds",false],
["two-columns",">unstable/Slideshow_Presentations.html#(form._((lib._unstable/gui/slideshow..rkt)._two-columns))",[0,[1,"two-columns"]],["unstable/gui/slideshow"]],
["type annotation and binding forms",">ts-guide/more.html#(part._.Type_.Annotation_and_.Binding_.Forms)","Type Annotation and Binding Forms",false],
["type annotation and instantiation",">ts-reference/special-forms.html#(part._.Type_.Annotation_and_.Instantiation)","Type Annotation and Instantiation",false],
["type constructors",">foreign/ctype.html","Type Constructors",false],
["type errors",">ts-guide/beginning.html#(part._.Type_.Errors)","Type Errors",false],
["type inference",">ts-guide/more.html#(part._.Type_.Inference)","Type Inference",false],
["type predicates",">racklog/racket-w-logic.html#(part._type-predicates)","Type Predicates",false],
["type reference",">ts-reference/type-ref.html","Type Reference",false],
["type-case",">plai/plai-scheme.html#(form._((lib._plai/main..rkt)._type-case))",[0,[1,"type-case"]],["plai"]],
["type-describe",">foreign/com-auto.html#(def._((lib._ffi/unsafe/com..rkt)._type-describe))",[0,[2,"type-describe"]],["ffi/com"]],
["type-described-description",">foreign/com-auto.html#(def._((lib._ffi/unsafe/com..rkt)._type-described-description))",[0,[2,"type-described-description"]],["ffi/com"]],
["type-described-value",">foreign/com-auto.html#(def._((lib._ffi/unsafe/com..rkt)._type-described-value))",[0,[2,"type-described-value"]],["ffi/com"]],
["type-described?",">foreign/com-auto.html#(def._((lib._ffi/unsafe/com..rkt)._type-described~3f))",[0,[2,"type-described?"]],["ffi/com"]],
["type-description?",">foreign/com-auto.html#(def._((lib._ffi/unsafe/com..rkt)._type-description~3f))",[0,[2,"type-description?"]],["ffi/com"]],
["typecheck-fail",">ts-reference/Utilities.html#(form._((lib._typed-racket/base-env/prims..rkt)._typecheck-fail))",[0,[1,"typecheck-fail"]],["typed/racket/base","typed/racket"]],
["typechecking typechecker typecheck",">ts-guide/index.html","typechecking, typechecker, typecheck",false],
["typed racket syntax without type checking",">ts-reference/Typed_Racket_Syntax_Without_Type_Checking.html","Typed Racket Syntax Without Type Checking",false],
["typed regions",">ts-reference/Typed_Regions.html","Typed Regions",false],
["typed-scheme",">ts-reference/Compatibility_Languages.html",[9,[0,"typed-scheme"]],"module"],
["typed/racket",">ts-reference/index.html",[9,[0,"typed/racket"]],"module"],
["typed/racket/base",">ts-reference/index.html",[9,[0,"typed/racket/base"]],"module"],
["typed/racket/base/no-check",">ts-reference/Typed_Racket_Syntax_Without_Type_Checking.html",[9,[0,"typed/racket/base/no-check"]],"module"],
["typed/racket/no-check",">ts-reference/Typed_Racket_Syntax_Without_Type_Checking.html",[9,[0,"typed/racket/no-check"]],"module"],
["typed/scheme",">ts-reference/Compatibility_Languages.html",[9,[0,"typed/scheme"]],"module"],
["typed/scheme/base",">ts-reference/Compatibility_Languages.html",[9,[0,"typed/scheme/base"]],"module"],
["types creating",">inside/im_values_types.html#(idx._(gentag._29._(lib._scribblings/inside/inside..scrbl)))","types, creating",false],
["types in typed racket",">ts-guide/types.html","Types in Typed Racket",false],
["typeset-code",">slideshow/Typesetting_Racket_Code.html#(def._((lib._slideshow/code..rkt)._typeset-code))",[0,[2,"typeset-code"]],["slideshow/code"]],
["typesetting",">redex/The_Redex_Reference.html#(part._.Typesetting)","Typesetting",false],
["typesetting code",">scribble/reference-style.html#(part._.Typesetting_.Code)","Typesetting Code",false],
["typesetting code",">scribble/scribble_manual_code.html","Typesetting Code",false],
["typesetting prose",">scribble/reference-style.html#(part._.Typesetting_.Prose)","Typesetting Prose",false],
["typesetting racket code",">slideshow/Typesetting_Racket_Code.html","Typesetting Racket Code",false],
["typesetting the reduction relation",">redex/tutorial.html#(part._.Typesetting_the_.Reduction_.Relation)","Typesetting the Reduction Relation",false],
["typical composition",">scribble/layers.html#(part._.Typical_.Composition)","Typical Composition",false],
["typing",">redex/tutorial.html#(part._.Typing)","Typing",false],
["u",">html/index.html#(def._((lib._html/main..rkt)._u))",[0,[2,"u"]],["html"]],
["u",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types-extra..rkt)._.U))",[0,[1,"U"]],["typed/racket/base","typed/racket"]],
["u16vector",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._u16vector))",[0,[2,"u16vector"]],["ffi/vector"]],
["u16vector",">srfi-std/srfi-4.html#u8vector",[0,[2,"u16vector"]],["srfi/4"]],
["u16vector->cpointer",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._u16vector-~3ecpointer))",[0,[2,"u16vector->cpointer"]],["ffi/vector"]],
["u16vector->list",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._u16vector-~3elist))",[0,[2,"u16vector->list"]],["ffi/vector"]],
["u16vector-length",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._u16vector-length))",[0,[2,"u16vector-length"]],["ffi/vector"]],
["u16vector-ref",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._u16vector-ref))",[0,[2,"u16vector-ref"]],["ffi/vector"]],
["u16vector-set!",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._u16vector-set!))",[0,[2,"u16vector-set!"]],["ffi/vector"]],
["u16vector?",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._u16vector~3f))",[0,[2,"u16vector?"]],["ffi/vector"]],
["u32vector",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._u32vector))",[0,[2,"u32vector"]],["ffi/vector"]],
["u32vector",">srfi-std/srfi-4.html#u16vector",[0,[2,"u32vector"]],["srfi/4"]],
["u32vector->cpointer",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._u32vector-~3ecpointer))",[0,[2,"u32vector->cpointer"]],["ffi/vector"]],
["u32vector->list",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._u32vector-~3elist))",[0,[2,"u32vector->list"]],["ffi/vector"]],
["u32vector-length",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._u32vector-length))",[0,[2,"u32vector-length"]],["ffi/vector"]],
["u32vector-ref",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._u32vector-ref))",[0,[2,"u32vector-ref"]],["ffi/vector"]],
["u32vector-set!",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._u32vector-set!))",[0,[2,"u32vector-set!"]],["ffi/vector"]],
["u32vector?",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._u32vector~3f))",[0,[2,"u32vector?"]],["ffi/vector"]],
["u64vector",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._u64vector))",[0,[2,"u64vector"]],["ffi/vector"]],
["u64vector",">srfi-std/srfi-4.html#u64vector",[0,[2,"u64vector"]],["srfi/4"]],
["u64vector->cpointer",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._u64vector-~3ecpointer))",[0,[2,"u64vector->cpointer"]],["ffi/vector"]],
["u64vector->list",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._u64vector-~3elist))",[0,[2,"u64vector->list"]],["ffi/vector"]],
["u64vector-length",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._u64vector-length))",[0,[2,"u64vector-length"]],["ffi/vector"]],
["u64vector-ref",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._u64vector-ref))",[0,[2,"u64vector-ref"]],["ffi/vector"]],
["u64vector-set!",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._u64vector-set!))",[0,[2,"u64vector-set!"]],["ffi/vector"]],
["u64vector?",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._u64vector~3f))",[0,[2,"u64vector?"]],["ffi/vector"]],
["u8-list->bytevector",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_106",[0,[2,"u8-list->bytevector"]],["rnrs/bytevectors-6"]],
["u8vector",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._u8vector))",[0,[2,"u8vector"]],["ffi/vector"]],
["u8vector",">srfi-std/srfi-4.html#s8vector",[0,[2,"u8vector"]],["srfi/4"]],
["u8vector->cpointer",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._u8vector-~3ecpointer))",[0,[2,"u8vector->cpointer"]],["ffi/vector"]],
["u8vector->list",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._u8vector-~3elist))",[0,[2,"u8vector->list"]],["ffi/vector"]],
["u8vector-length",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._u8vector-length))",[0,[2,"u8vector-length"]],["ffi/vector"]],
["u8vector-ref",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._u8vector-ref))",[0,[2,"u8vector-ref"]],["ffi/vector"]],
["u8vector-set!",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._u8vector-set!))",[0,[2,"u8vector-set!"]],["ffi/vector"]],
["u8vector?",">foreign/homogeneous-vectors.html#(def._((lib._ffi/vector..rkt)._u8vector~3f))",[0,[2,"u8vector?"]],["ffi/vector"]],
["u?",">html/index.html#(def._((lib._html/main..rkt)._u~3f))",[0,[2,"u?"]],["html"]],
["ucs-range->char-set",">srfi-std/srfi-14.html#ucs-range->char-set",[0,[2,"ucs-range->char-set"]],["srfi/14"]],
["ucs-range->char-set!",">srfi-std/srfi-14.html#ucs-range->char-set!",[0,[2,"ucs-range->char-set!"]],["srfi/14"]],
["udp",">reference/udp.html","UDP",false],
["udp socket",">reference/udp.html#(tech._udp._socket)","<span style=\"font-style: italic\">UDP socket</span>",false],
["udp-addresses",">reference/udp.html#(def._((lib._racket/udp..rkt)._udp-addresses))",[0,[2,"udp-addresses"]],["racket/udp","racket"]],
["udp-bind!",">reference/udp.html#(def._((lib._racket/udp..rkt)._udp-bind!))",[0,[2,"udp-bind!"]],["racket/udp","racket"]],
["udp-bound?",">reference/udp.html#(def._((lib._racket/udp..rkt)._udp-bound~3f))",[0,[2,"udp-bound?"]],["racket/udp","racket"]],
["udp-close",">reference/udp.html#(def._((lib._racket/udp..rkt)._udp-close))",[0,[2,"udp-close"]],["racket/udp","racket"]],
["udp-connect!",">reference/udp.html#(def._((lib._racket/udp..rkt)._udp-connect!))",[0,[2,"udp-connect!"]],["racket/udp","racket"]],
["udp-connected?",">reference/udp.html#(def._((lib._racket/udp..rkt)._udp-connected~3f))",[0,[2,"udp-connected?"]],["racket/udp","racket"]],
["udp-open-socket",">reference/udp.html#(def._((lib._racket/udp..rkt)._udp-open-socket))",[0,[2,"udp-open-socket"]],["racket/udp","racket"]],
["udp-receive!",">reference/udp.html#(def._((lib._racket/udp..rkt)._udp-receive!))",[0,[2,"udp-receive!"]],["racket/udp","racket"]],
["udp-receive!*",">reference/udp.html#(def._((lib._racket/udp..rkt)._udp-receive!*))",[0,[2,"udp-receive!*"]],["racket/udp","racket"]],
["udp-receive!-evt",">reference/udp.html#(def._((lib._racket/udp..rkt)._udp-receive!-evt))",[0,[2,"udp-receive!-evt"]],["racket/udp","racket"]],
["udp-receive!/enable-break",">reference/udp.html#(def._((lib._racket/udp..rkt)._udp-receive!/enable-break))",[0,[2,"udp-receive!/enable-break"]],["racket/udp","racket"]],
["udp-receive-ready-evt",">reference/udp.html#(def._((lib._racket/udp..rkt)._udp-receive-ready-evt))",[0,[2,"udp-receive-ready-evt"]],["racket/udp","racket"]],
["udp-send",">reference/udp.html#(def._((lib._racket/udp..rkt)._udp-send))",[0,[2,"udp-send"]],["racket/udp","racket"]],
["udp-send*",">reference/udp.html#(def._((lib._racket/udp..rkt)._udp-send*))",[0,[2,"udp-send*"]],["racket/udp","racket"]],
["udp-send-evt",">reference/udp.html#(def._((lib._racket/udp..rkt)._udp-send-evt))",[0,[2,"udp-send-evt"]],["racket/udp","racket"]],
["udp-send-ready-evt",">reference/udp.html#(def._((lib._racket/udp..rkt)._udp-send-ready-evt))",[0,[2,"udp-send-ready-evt"]],["racket/udp","racket"]],
["udp-send-to",">reference/udp.html#(def._((lib._racket/udp..rkt)._udp-send-to))",[0,[2,"udp-send-to"]],["racket/udp","racket"]],
["udp-send-to*",">reference/udp.html#(def._((lib._racket/udp..rkt)._udp-send-to*))",[0,[2,"udp-send-to*"]],["racket/udp","racket"]],
["udp-send-to-evt",">reference/udp.html#(def._((lib._racket/udp..rkt)._udp-send-to-evt))",[0,[2,"udp-send-to-evt"]],["racket/udp","racket"]],
["udp-send-to/enable-break",">reference/udp.html#(def._((lib._racket/udp..rkt)._udp-send-to/enable-break))",[0,[2,"udp-send-to/enable-break"]],["racket/udp","racket"]],
["udp-send/enable-break",">reference/udp.html#(def._((lib._racket/udp..rkt)._udp-send/enable-break))",[0,[2,"udp-send/enable-break"]],["racket/udp","racket"]],
["udp-socket",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.U.D.P-.Socket))",[0,[1,"UDP-Socket"]],["typed/racket/base","typed/racket"]],
["udp?",">reference/udp.html#(def._((lib._racket/udp..rkt)._udp~3f))",[0,[2,"udp?"]],["racket/udp","racket"]],
["ui",">planet/Developing_Packages_for_PLaneT.html#(idx._(gentag._12._(lib._planet/planet..scrbl)))",[7,"'ui"],false],
["uint-list->bytevector",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_120",[0,[2,"uint-list->bytevector"]],["rnrs/bytevectors-6"]],
["uk-currency-formats",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._uk-currency-formats))",[0,[2,"uk-currency-formats"]],["plot"]],
["uk-currency-scales",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._uk-currency-scales))",[0,[2,"uk-currency-scales"]],["plot"]],
["ul",">html/index.html#(def._((lib._html/main..rkt)._ul))",[0,[2,"ul"]],["html"]],
["ul?",">html/index.html#(def._((lib._html/main..rkt)._ul~3f))",[0,[2,"ul?"]],["html"]],
["un",">ts-reference/Legacy_Forms.html#(form._((lib._typed-racket/base-env/base-types-extra..rkt)._.Un))",[0,[1,"Un"]],["typed/racket/base","typed/racket"]],
["un/cache-image",">mrlib/Image_Core.html#(def._((lib._mrlib/image-core..rkt)._un/cache-image))",[0,[2,"un/cache-image"]],["mrlib/image-core"]],
["unaligned",">draw/font_.html#(idx._(gentag._47._(lib._scribblings/draw/draw..scrbl)))",[7,"'unaligned"],false],
["unbound",">reference/syntax-model.html#(tech._unbound)","<span style=\"font-style: italic\">unbound</span>",false],
["unbox",">reference/boxes.html#(def._((quote._~23~25kernel)._unbox))",[0,[2,"unbox"]],["racket/base","racket"]],
["unbox",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._unbox))",[0,[2,"unbox"]],["lang/htdp-advanced"]],
["uncaught-exception handler",">reference/exns.html#(tech._uncaught._exception._handler)","<span style=\"font-style: italic\">uncaught-exception handler</span>",false],
["uncaught-exception-handler",">reference/exns.html#(def._((quote._~23~25kernel)._uncaught-exception-handler))",[0,[2,"uncaught-exception-handler"]],["racket/base","racket"]],
["unchecked, unsafe operations",">guide/performance.html#(part._unchecked-unsafe)","Unchecked, Unsafe Operations",false],
["uncollectable",">foreign/foreign_pointer-funcs.html#(idx._(gentag._8._(lib._scribblings/foreign/foreign..scrbl)))",[7,"'uncollectable"],false],
["uncomment menu item",">drracket/Menus.html#(idx._(gentag._134._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Uncomment</span> menu item",false],
["uncomment-selection",">framework/Racket.html#(meth._(((lib._framework/main..rkt)._racket~3atext~3c~25~3e)._uncomment-selection))",[[0,[2,"uncomment-selection"]],[14,[" (method of ",[0,[2,"racket:text<%>"]],")"]]],["framework"]],
["unconstrained-domain->",">reference/function-contracts.html#(form._((lib._racket/contract/base..rkt)._unconstrained-domain-~3e))",[0,[1,"unconstrained-domain->"]],["racket/contract/base","racket/contract","racket"]],
["undatum",">syntax/Datum_Pattern_Matching.html#(form._((lib._syntax/datum..rkt)._undatum))",[0,[1,"undatum"]],["syntax/datum"]],
["undatum-splicing",">syntax/Datum_Pattern_Matching.html#(form._((lib._syntax/datum..rkt)._undatum-splicing))",[0,[1,"undatum-splicing"]],["syntax/datum"]],
["undefined",">frtime/index.html#(def._((lib._frtime/main..rkt)._undefined))",[0,[2,"undefined"]],["frtime"]],
["undefined",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Undefined))",[0,[1,"Undefined"]],["typed/racket/base","typed/racket"]],
["undefined-const",">scribble/Miscellaneous.html#(def._((lib._scribble/manual..rkt)._undefined-const))",[0,[2,"undefined-const"]],["scribble/manual"]],
["undefined-violation?",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_492",[0,[2,"undefined-violation?"]],["rnrs/conditions-6"]],
["undefined?",">frtime/index.html#(def._((lib._frtime/main..rkt)._undefined~3f))",[0,[2,"undefined?"]],["frtime"]],
["underlay",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._underlay))",[0,[2,"underlay"]],["2htdp/image"]],
["underlay/align",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._underlay/align))",[0,[2,"underlay/align"]],["2htdp/image"]],
["underlay/align/offset",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._underlay/align/offset))",[0,[2,"underlay/align/offset"]],["2htdp/image"]],
["underlay/offset",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._underlay/offset))",[0,[2,"underlay/offset"]],["2htdp/image"]],
["underlay/pinhole",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._underlay/pinhole))",[0,[2,"underlay/pinhole"]],["2htdp/image"]],
["underlay/xy",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._underlay/xy))",[0,[2,"underlay/xy"]],["2htdp/image"]],
["understanding a door",">teachpack/2htdpuniverse.html#(part._.Understanding_a_.Door)","Understanding a Door",false],
["understanding a door",">teachpack/world.html#(part._.Understanding_a_.Door)","Understanding a Door",false],
["undo",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._undo))",[[0,[2,"undo"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["undo menu item",">drracket/Menus.html#(idx._(gentag._71._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Undo</span> menu item",false],
["unexpected-response",">net/nntp.html#(def._((lib._net/nntp..rkt)._unexpected-response))",[0,[2,"unexpected-response"]],["net/nntp"]],
["unexpected-response-code",">net/nntp.html#(def._((lib._net/nntp..rkt)._unexpected-response-code))",[0,[2,"unexpected-response-code"]],["net/nntp"]],
["unexpected-response-text",">net/nntp.html#(def._((lib._net/nntp..rkt)._unexpected-response-text))",[0,[2,"unexpected-response-text"]],["net/nntp"]],
["unexpected-response?",">net/nntp.html#(def._((lib._net/nntp..rkt)._unexpected-response~3f))",[0,[2,"unexpected-response?"]],["net/nntp"]],
["unexpected-termination",">net/mime.html#(def._((lib._net/mime..rkt)._unexpected-termination))",[0,[2,"unexpected-termination"]],["net/mime"]],
["unexpected-termination-msg",">net/mime.html#(def._((lib._net/mime..rkt)._unexpected-termination-msg))",[0,[2,"unexpected-termination-msg"]],["net/mime"]],
["unexpected-termination?",">net/mime.html#(def._((lib._net/mime..rkt)._unexpected-termination~3f))",[0,[2,"unexpected-termination?"]],["net/mime"]],
["unexported primitive functions",">foreign/foreign_c-only.html","Unexported Primitive Functions",false],
["unfold",">srfi-std/srfi-1.html#unfold",[0,[2,"unfold"]],["srfi/1"]],
["unhide-search",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3asearchable~3c~25~3e)._unhide-search))",[[0,[2,"unhide-search"]],[14,[" (method of ",[0,[2,"frame:searchable<%>"]],")"]]],["framework"]],
["unhighlight-range",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3abasic~3c~25~3e)._unhighlight-range))",[[0,[2,"unhighlight-range"]],[14,[" (method of ",[0,[2,"text:basic<%>"]],")"]]],["framework"]],
["unhighlight-range",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3adelegate-mixin)._unhighlight-range))",[[0,[2,"unhighlight-range"]],[14,[" (method of ",[0,[2,"text:delegate-mixin"]],")"]]],["framework"]],
["unhilite-region",">cards/index.html#(meth._(((lib._games/cards..rkt)._table~3c~25~3e)._unhilite-region))",[[0,[2,"unhilite-region"]],[14,[" (method of ",[0,[2,"table<%>"]],")"]]],["games/cards"]],
["unifiable?",">racklog/glossary.html#(def._((lib._racklog/main..rkt)._unifiable~3f))",[0,[2,"unifiable?"]],["racklog"]],
["unification",">racklog/glossary.html#(part._.Unification)","Unification",false],
["unification",">racklog/unification.html","Unification",false],
["uniform type identifier",">raco/exe.html#(idx._(gentag._0._(lib._scribblings/raco/raco..scrbl)))","Uniform Type\nIdentifier",false],
["uniform variable-arity functions",">ts-guide/types.html#(part._.Uniform_.Variable-.Arity_.Functions)","Uniform Variable-Arity Functions",false],
["uninstalled-package-cache",">planet/Utility_Libraries.html#(def._((lib._planet/config..rkt)._.U.N.I.N.S.T.A.L.L.E.D-.P.A.C.K.A.G.E-.C.A.C.H.E))",[0,[2,"UNINSTALLED-PACKAGE-CACHE"]],["planet/config"]],
["uninterned",">reference/symbols.html#(tech._uninterned)","<span style=\"font-style: italic\">uninterned</span>",false],
["union",">draw/region_.html#(meth._(((lib._racket/draw..rkt)._region~25)._union))",[[0,[2,"union"]],[14,[" (method of ",[0,[2,"region%"]],")"]]],["racket/draw"]],
["union",">mzlib/mzlib_integer-set.html#(def._((lib._mzlib/integer-set..rkt)._union))",[0,[2,"union"]],["mzlib/integer-set"]],
["union",">unstable/Automata__Compiling_State_Machines.html#(form._((lib._unstable/automata/re..rkt)._union))",[0,[1,"union"]],["unstable/automata/re"]],
["union types",">ts-guide/types.html#(part._.Union_.Types)","Union Types",false],
["union-ptr",">foreign/C_Union_Types.html#(def._((lib._ffi/unsafe..rkt)._union-ptr))",[0,[2,"union-ptr"]],["ffi/unsafe"]],
["union-reduction-relations",">redex/The_Redex_Reference.html#(def._((lib._redex/reduction-semantics..rkt)._union-reduction-relations))",[0,[2,"union-reduction-relations"]],["redex/reduction-semantics","redex"]],
["union-ref",">foreign/C_Union_Types.html#(def._((lib._ffi/unsafe..rkt)._union-ref))",[0,[2,"union-ref"]],["ffi/unsafe"]],
["union-set!",">foreign/C_Union_Types.html#(def._((lib._ffi/unsafe..rkt)._union-set!))",[0,[2,"union-set!"]],["ffi/unsafe"]],
["union?",">foreign/C_Union_Types.html#(def._((lib._ffi/unsafe..rkt)._union~3f))",[0,[2,"union?"]],["ffi/unsafe"]],
["unit",">dynext/Compilation.html#(part._compile-unit)","Unit",false],
["unit",">dynext/Filenames.html#(part._file-unit)","Unit",false],
["unit",">dynext/Linking.html#(part._link-unit)","Unit",false],
["unit",">make/collection.html#(part._.Unit)","Unit",false],
["unit",">make/make.html#(part._make-unit)","Unit",false],
["unit",">framework/Unit.html","Unit",false],
["unit",">reference/creatingunits.html#(form._((lib._mzlib/unit..rkt)._unit))",[0,[1,"unit"]],["racket/unit","racket"]],
["unit contract",">reference/unitcontracts.html#(tech._unit._contract)","<span style=\"font-style: italic\">unit contract</span>",false],
["unit contracts",">reference/unitcontracts.html","Unit Contracts",false],
["unit utilities",">reference/Unit_Utilities.html","Unit Utilities",false],
["unit versus module",">guide/unit_versus_module.html",[[0,[1,"unit"]]," versus ",[0,[1,"module"]]],false],
["unit with posn",">graphics/Graphics_Library_as_a_Unit.html#(part._.Unit_with_posn)",["Unit with ",[0,[2,"posn"]]],false],
["unit without posn",">graphics/Graphics_Library_as_a_Unit.html#(part._.Unit_without_posn)",["Unit without ",[0,[2,"posn"]]],false],
["unit-from-context",">reference/Generating_A_Unit_from_Context.html#(form._((lib._mzlib/unit..rkt)._unit-from-context))",[0,[1,"unit-from-context"]],["racket/unit","racket"]],
["unit-static-signatures",">reference/Transformer_Helpers.html#(def._((lib._mzlib/unit-exptime..rkt)._unit-static-signatures))",[0,[2,"unit-static-signatures"]],["racket/unit-exptime"]],
["unit/c",">reference/unitcontracts.html#(form._((lib._mzlib/unit..rkt)._unit/c))",[0,[1,"unit/c"]],["racket/unit","racket"]],
["unit/new-import-export",">reference/Structural_Matching.html#(form._((lib._mzlib/unit..rkt)._unit/new-import-export))",[0,[1,"unit/new-import-export"]],["racket/unit","racket"]],
["unit/s",">reference/Structural_Matching.html#(form._((lib._mzlib/unit..rkt)._unit/s))",[0,[1,"unit/s"]],["racket/unit","racket"]],
["unit?",">reference/Unit_Utilities.html#(def._((lib._mzlib/unit..rkt)._unit~3f))",[0,[2,"unit?"]],["racket/unit","racket"]],
["units",">reference/mzlib_unit.html","Units",false],
["units",">guide/units.html#(tech._unit)","<span style=\"font-style: italic\">Units</span>",false],
["units",">reference/mzlib_unit.html#(tech._unit)","<span style=\"font-style: italic\">Units</span>",false],
["units (components)",">guide/units.html","Units (Components)",false],
["universe",">teachpack/2htdpuniverse.html#(form._((lib._2htdp/universe..rkt)._universe))",[0,[1,"universe"]],["2htdp/universe"]],
["universe",">teachpack/2htdpuniverse.html#(tech._universe)","<span style=\"font-style: italic\">universe</span>",false],
["universe descriptions",">teachpack/2htdpuniverse.html#(part._.Universe_.Descriptions)","Universe Descriptions",false],
["universe teachpack",">teachpack/2htdpuniverse.html#(idx._(gentag._22._(lib._teachpack/teachpack..scrbl)._2htdp))","universe teachpack",false],
["universestate",">teachpack/2htdpuniverse.html#(tech._universestate)","<span style=\"font-style: italic\">UniverseState</span>",false],
["unix",">reference/Manipulating_Paths.html#(idx._(gentag._234._(lib._scribblings/reference/reference..scrbl)))",[7,"'unix"],false],
["unix",">reference/runtime.html#(idx._(gentag._324._(lib._scribblings/reference/reference..scrbl)))",[7,"'unix"],false],
["unix and mac os x paths",">reference/unixpaths.html","Unix and Mac OS X Paths",false],
["unix scripts",">guide/scripts.html#(part._.Unix_.Scripts)","Unix Scripts",false],
["unix-browser-list",">net/sendurl.html#(def._((lib._net/sendurl..rkt)._unix-browser-list))",[0,[2,"unix-browser-list"]],["net/sendurl"]],
["unknown-extensions-skip-enabled",">gui/WXME_Decoding.html#(def._((lib._wxme/main..rkt)._unknown-extensions-skip-enabled))",[0,[2,"unknown-extensions-skip-enabled"]],["wxme"]],
["unless",">reference/when_unless.html#(form._((lib._racket/private/letstx-scheme..rkt)._unless))",[0,[1,"unless"]],["racket/base","racket"]],
["unless",">r6rs-lib-std/r6rs-lib-Z-H-6.html#node_idx_256",[0,[1,"unless"]],["rnrs/control-6"]],
["unless",">htdp-langs/advanced.html#(form._((lib._lang/htdp-advanced..rkt)._unless))",[0,[1,"unless"]],["lang/htdp-advanced"]],
["unless",">lazy/index.html#(form._((lib._lazy/main..rkt)._unless))",[0,[1,"unless"]],["lazy"]],
["unlink",">planet/cmdline.html#(part._unlink)",[6,"unlink"],false],
["unlink-all",">planet/Utility_Libraries.html#(def._((lib._planet/util..rkt)._unlink-all))",[0,[2,"unlink-all"]],["planet/util"]],
["unmanaged transaction",">db/query-api.html#(tech._unmanaged._transaction)","<span style=\"font-style: italic\">unmanaged transaction</span>",false],
["unmarshall-settings",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3alanguage~3c~25~3e)._unmarshall-settings))",[[0,[2,"unmarshall-settings"]],[14,[" (method of ",[0,[2,"drracket:language:language<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["unmarshall-settings",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3amodule-based-language~3c~25~3e)._unmarshall-settings))",[[0,[2,"unmarshall-settings"]],[14,[" (method of ",[0,[2,"drracket:language:module-based-language<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["unmarshall-settings",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3asimple-module-based-language-~3emodule-based-language-mixin)._unmarshall-settings))",[[0,[2,"unmarshall-settings"]],[14,[" (method of ",[0,[2,"drracket:language:simple-module-based-language->module-based-language-mixin"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["unnumbered-part?",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._unnumbered-part~3f))",[0,[2,"unnumbered-part?"]],["scribble/struct"]],
["unpack",">raco/unpack.html#(def._((lib._setup/unpack..rkt)._unpack))",[0,[2,"unpack"]],["setup/unpack"]],
["unpack-planet-archive",">planet/Utility_Libraries.html#(def._((lib._planet/util..rkt)._unpack-planet-archive))",[0,[2,"unpack-planet-archive"]],["planet/util"]],
["unpackable",">raco/plt.html#(tech._unpackable)","<span style=\"font-style: italic\">unpackable</span>",false],
["unpacking api",">raco/unpack.html#(part._unpacking-..plt-archives)","Unpacking API",false],
["unquote",">reference/quasiquote.html#(form._((quote._~23~25kernel)._unquote))",[0,[1,"unquote"]],["racket/base","racket"]],
["unquote",">r6rs-std/r6rs-Z-H-14.html#node_idx_770",[0,[1,"unquote"]],["rnrs/base-6"]],
["unquote",">htdp-langs/beginner-abbr.html#(form._((lib._lang/htdp-beginner-abbr..rkt)._unquote))",[0,[1,"unquote"]],["lang/htdp-beginner-abbr"]],
["unquote",">htdp-langs/intermediate.html#(form._((lib._lang/htdp-intermediate..rkt)._unquote))",[0,[1,"unquote"]],["lang/htdp-intermediate"]],
["unquote",">htdp-langs/intermediate-lam.html#(form._((lib._lang/htdp-intermediate-lambda..rkt)._unquote))",[0,[1,"unquote"]],["lang/htdp-intermediate-lambda"]],
["unquote-splicing",">reference/quasiquote.html#(form._((quote._~23~25kernel)._unquote-splicing))",[0,[1,"unquote-splicing"]],["racket/base","racket"]],
["unquote-splicing",">r6rs-std/r6rs-Z-H-14.html#node_idx_772",[0,[1,"unquote-splicing"]],["rnrs/base-6"]],
["unquote-splicing",">htdp-langs/beginner-abbr.html#(form._((lib._lang/htdp-beginner-abbr..rkt)._unquote-splicing))",[0,[1,"unquote-splicing"]],["lang/htdp-beginner-abbr"]],
["unquote-splicing",">htdp-langs/intermediate.html#(form._((lib._lang/htdp-intermediate..rkt)._unquote-splicing))",[0,[1,"unquote-splicing"]],["lang/htdp-intermediate"]],
["unquote-splicing",">htdp-langs/intermediate-lam.html#(form._((lib._lang/htdp-intermediate-lambda..rkt)._unquote-splicing))",[0,[1,"unquote-splicing"]],["lang/htdp-intermediate-lambda"]],
["unreadable symbol",">reference/symbols.html#(tech._unreadable._symbol)","<span style=\"font-style: italic\">unreadable symbol</span>",false],
["unregister-collecting-blit",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._unregister-collecting-blit))",[0,[2,"unregister-collecting-blit"]],["racket/gui/base","racket/gui"]],
["unregister-toolbar-button",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aframe~3c~25~3e)._unregister-toolbar-button))",[[0,[2,"unregister-toolbar-button"]],[14,[" (method of ",[0,[2,"drracket:unit:frame<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["unsafe",">reference/unsafe.html#(tech._unsafe)","<span style=\"font-style: italic\">unsafe</span>",false],
["unsafe data extraction",">reference/unsafe.html#(part._.Unsafe_.Data_.Extraction)","Unsafe Data Extraction",false],
["unsafe libraries",">draw/unsafe.html","Unsafe Libraries",false],
["unsafe numeric operations",">reference/unsafe.html#(part._.Unsafe_.Numeric_.Operations)","Unsafe Numeric Operations",false],
["unsafe operations",">reference/unsafe.html","Unsafe Operations",false],
["unsafe!",">scheme/scheme_foreign.html#(form._((lib._scheme/foreign..rkt)._unsafe!))",[0,[1,"unsafe!"]],["scheme/foreign"]],
["unsafe-box*-cas!",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-box*-cas!))",[0,[2,"unsafe-box*-cas!"]],["racket/unsafe/ops"]],
["unsafe-bytes-length",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-bytes-length))",[0,[2,"unsafe-bytes-length"]],["racket/unsafe/ops"]],
["unsafe-bytes-ref",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-bytes-ref))",[0,[2,"unsafe-bytes-ref"]],["racket/unsafe/ops"]],
["unsafe-bytes-set!",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-bytes-set!))",[0,[2,"unsafe-bytes-set!"]],["racket/unsafe/ops"]],
["unsafe-car",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-car))",[0,[2,"unsafe-car"]],["racket/unsafe/ops"]],
["unsafe-cdr",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-cdr))",[0,[2,"unsafe-cdr"]],["racket/unsafe/ops"]],
["unsafe-f64vector-ref",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-f64vector-ref))",[0,[2,"unsafe-f64vector-ref"]],["racket/unsafe/ops"]],
["unsafe-f64vector-set!",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-f64vector-set!))",[0,[2,"unsafe-f64vector-set!"]],["racket/unsafe/ops"]],
["unsafe-fl*",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-fl*))",[0,[2,"unsafe-fl*"]],["racket/unsafe/ops"]],
["unsafe-fl+",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-fl+))",[0,[2,"unsafe-fl+"]],["racket/unsafe/ops"]],
["unsafe-fl-",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-fl-))",[0,[2,"unsafe-fl-"]],["racket/unsafe/ops"]],
["unsafe-fl->fx",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-fl-~3efx))",[0,[2,"unsafe-fl->fx"]],["racket/unsafe/ops"]],
["unsafe-fl/",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-fl/))",[0,[2,"unsafe-fl/"]],["racket/unsafe/ops"]],
["unsafe-fl<",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-fl~3c))",[0,[2,"unsafe-fl<"]],["racket/unsafe/ops"]],
["unsafe-fl<=",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-fl~3c~3d))",[0,[2,"unsafe-fl<="]],["racket/unsafe/ops"]],
["unsafe-fl=",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-fl~3d))",[0,[2,"unsafe-fl="]],["racket/unsafe/ops"]],
["unsafe-fl>",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-fl~3e))",[0,[2,"unsafe-fl>"]],["racket/unsafe/ops"]],
["unsafe-fl>=",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-fl~3e~3d))",[0,[2,"unsafe-fl>="]],["racket/unsafe/ops"]],
["unsafe-flabs",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-flabs))",[0,[2,"unsafe-flabs"]],["racket/unsafe/ops"]],
["unsafe-flacos",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-flacos))",[0,[2,"unsafe-flacos"]],["racket/unsafe/ops"]],
["unsafe-flasin",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-flasin))",[0,[2,"unsafe-flasin"]],["racket/unsafe/ops"]],
["unsafe-flatan",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-flatan))",[0,[2,"unsafe-flatan"]],["racket/unsafe/ops"]],
["unsafe-flceiling",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-flceiling))",[0,[2,"unsafe-flceiling"]],["racket/unsafe/ops"]],
["unsafe-flcos",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-flcos))",[0,[2,"unsafe-flcos"]],["racket/unsafe/ops"]],
["unsafe-flexp",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-flexp))",[0,[2,"unsafe-flexp"]],["racket/unsafe/ops"]],
["unsafe-flexpt",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-flexpt))",[0,[2,"unsafe-flexpt"]],["racket/unsafe/ops"]],
["unsafe-flfloor",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-flfloor))",[0,[2,"unsafe-flfloor"]],["racket/unsafe/ops"]],
["unsafe-flimag-part",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-flimag-part))",[0,[2,"unsafe-flimag-part"]],["racket/unsafe/ops"]],
["unsafe-fllog",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-fllog))",[0,[2,"unsafe-fllog"]],["racket/unsafe/ops"]],
["unsafe-flmax",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-flmax))",[0,[2,"unsafe-flmax"]],["racket/unsafe/ops"]],
["unsafe-flmin",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-flmin))",[0,[2,"unsafe-flmin"]],["racket/unsafe/ops"]],
["unsafe-flomap-ref",">images/Struct_Type_and_Accessors.html#(def._((lib._images/flomap..rkt)._unsafe-flomap-ref))",[0,[2,"unsafe-flomap-ref"]],["images/flomap"]],
["unsafe-flomap-ref*",">images/Struct_Type_and_Accessors.html#(def._((lib._images/flomap..rkt)._unsafe-flomap-ref*))",[0,[2,"unsafe-flomap-ref*"]],["images/flomap"]],
["unsafe-flreal-part",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-flreal-part))",[0,[2,"unsafe-flreal-part"]],["racket/unsafe/ops"]],
["unsafe-flround",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-flround))",[0,[2,"unsafe-flround"]],["racket/unsafe/ops"]],
["unsafe-flsin",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-flsin))",[0,[2,"unsafe-flsin"]],["racket/unsafe/ops"]],
["unsafe-flsqrt",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-flsqrt))",[0,[2,"unsafe-flsqrt"]],["racket/unsafe/ops"]],
["unsafe-fltan",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-fltan))",[0,[2,"unsafe-fltan"]],["racket/unsafe/ops"]],
["unsafe-fltruncate",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-fltruncate))",[0,[2,"unsafe-fltruncate"]],["racket/unsafe/ops"]],
["unsafe-flvector-length",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-flvector-length))",[0,[2,"unsafe-flvector-length"]],["racket/unsafe/ops"]],
["unsafe-flvector-ref",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-flvector-ref))",[0,[2,"unsafe-flvector-ref"]],["racket/unsafe/ops"]],
["unsafe-flvector-set!",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-flvector-set!))",[0,[2,"unsafe-flvector-set!"]],["racket/unsafe/ops"]],
["unsafe-fx*",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-fx*))",[0,[2,"unsafe-fx*"]],["racket/unsafe/ops"]],
["unsafe-fx+",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-fx+))",[0,[2,"unsafe-fx+"]],["racket/unsafe/ops"]],
["unsafe-fx-",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-fx-))",[0,[2,"unsafe-fx-"]],["racket/unsafe/ops"]],
["unsafe-fx->fl",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-fx-~3efl))",[0,[2,"unsafe-fx->fl"]],["racket/unsafe/ops"]],
["unsafe-fx<",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-fx~3c))",[0,[2,"unsafe-fx<"]],["racket/unsafe/ops"]],
["unsafe-fx<=",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-fx~3c~3d))",[0,[2,"unsafe-fx<="]],["racket/unsafe/ops"]],
["unsafe-fx=",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-fx~3d))",[0,[2,"unsafe-fx="]],["racket/unsafe/ops"]],
["unsafe-fx>",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-fx~3e))",[0,[2,"unsafe-fx>"]],["racket/unsafe/ops"]],
["unsafe-fx>=",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-fx~3e~3d))",[0,[2,"unsafe-fx>="]],["racket/unsafe/ops"]],
["unsafe-fxabs",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-fxabs))",[0,[2,"unsafe-fxabs"]],["racket/unsafe/ops"]],
["unsafe-fxand",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-fxand))",[0,[2,"unsafe-fxand"]],["racket/unsafe/ops"]],
["unsafe-fxior",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-fxior))",[0,[2,"unsafe-fxior"]],["racket/unsafe/ops"]],
["unsafe-fxlshift",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-fxlshift))",[0,[2,"unsafe-fxlshift"]],["racket/unsafe/ops"]],
["unsafe-fxmax",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-fxmax))",[0,[2,"unsafe-fxmax"]],["racket/unsafe/ops"]],
["unsafe-fxmin",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-fxmin))",[0,[2,"unsafe-fxmin"]],["racket/unsafe/ops"]],
["unsafe-fxmodulo",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-fxmodulo))",[0,[2,"unsafe-fxmodulo"]],["racket/unsafe/ops"]],
["unsafe-fxnot",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-fxnot))",[0,[2,"unsafe-fxnot"]],["racket/unsafe/ops"]],
["unsafe-fxquotient",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-fxquotient))",[0,[2,"unsafe-fxquotient"]],["racket/unsafe/ops"]],
["unsafe-fxremainder",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-fxremainder))",[0,[2,"unsafe-fxremainder"]],["racket/unsafe/ops"]],
["unsafe-fxrshift",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-fxrshift))",[0,[2,"unsafe-fxrshift"]],["racket/unsafe/ops"]],
["unsafe-fxxor",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-fxxor))",[0,[2,"unsafe-fxxor"]],["racket/unsafe/ops"]],
["unsafe-list-ref",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-list-ref))",[0,[2,"unsafe-list-ref"]],["racket/unsafe/ops"]],
["unsafe-list-tail",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-list-tail))",[0,[2,"unsafe-list-tail"]],["racket/unsafe/ops"]],
["unsafe-make-flrectangular",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-make-flrectangular))",[0,[2,"unsafe-make-flrectangular"]],["racket/unsafe/ops"]],
["unsafe-mcar",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-mcar))",[0,[2,"unsafe-mcar"]],["racket/unsafe/ops"]],
["unsafe-mcdr",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-mcdr))",[0,[2,"unsafe-mcdr"]],["racket/unsafe/ops"]],
["unsafe-s16vector-ref",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-s16vector-ref))",[0,[2,"unsafe-s16vector-ref"]],["racket/unsafe/ops"]],
["unsafe-s16vector-set!",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-s16vector-set!))",[0,[2,"unsafe-s16vector-set!"]],["racket/unsafe/ops"]],
["unsafe-set-box!",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-set-box!))",[0,[2,"unsafe-set-box!"]],["racket/unsafe/ops"]],
["unsafe-set-box*!",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-set-box*!))",[0,[2,"unsafe-set-box*!"]],["racket/unsafe/ops"]],
["unsafe-set-mcar!",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-set-mcar!))",[0,[2,"unsafe-set-mcar!"]],["racket/unsafe/ops"]],
["unsafe-set-mcdr!",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-set-mcdr!))",[0,[2,"unsafe-set-mcdr!"]],["racket/unsafe/ops"]],
["unsafe-string-length",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-string-length))",[0,[2,"unsafe-string-length"]],["racket/unsafe/ops"]],
["unsafe-string-ref",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-string-ref))",[0,[2,"unsafe-string-ref"]],["racket/unsafe/ops"]],
["unsafe-string-set!",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-string-set!))",[0,[2,"unsafe-string-set!"]],["racket/unsafe/ops"]],
["unsafe-struct*-ref",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-struct*-ref))",[0,[2,"unsafe-struct*-ref"]],["racket/unsafe/ops"]],
["unsafe-struct*-set!",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-struct*-set!))",[0,[2,"unsafe-struct*-set!"]],["racket/unsafe/ops"]],
["unsafe-struct-ref",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-struct-ref))",[0,[2,"unsafe-struct-ref"]],["racket/unsafe/ops"]],
["unsafe-struct-set!",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-struct-set!))",[0,[2,"unsafe-struct-set!"]],["racket/unsafe/ops"]],
["unsafe-u16vector-ref",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-u16vector-ref))",[0,[2,"unsafe-u16vector-ref"]],["racket/unsafe/ops"]],
["unsafe-u16vector-set!",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-u16vector-set!))",[0,[2,"unsafe-u16vector-set!"]],["racket/unsafe/ops"]],
["unsafe-unbox",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-unbox))",[0,[2,"unsafe-unbox"]],["racket/unsafe/ops"]],
["unsafe-unbox*",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-unbox*))",[0,[2,"unsafe-unbox*"]],["racket/unsafe/ops"]],
["unsafe-vector*-length",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-vector*-length))",[0,[2,"unsafe-vector*-length"]],["racket/unsafe/ops"]],
["unsafe-vector*-ref",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-vector*-ref))",[0,[2,"unsafe-vector*-ref"]],["racket/unsafe/ops"]],
["unsafe-vector*-set!",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-vector*-set!))",[0,[2,"unsafe-vector*-set!"]],["racket/unsafe/ops"]],
["unsafe-vector-length",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-vector-length))",[0,[2,"unsafe-vector-length"]],["racket/unsafe/ops"]],
["unsafe-vector-ref",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-vector-ref))",[0,[2,"unsafe-vector-ref"]],["racket/unsafe/ops"]],
["unsafe-vector-set!",">reference/unsafe.html#(def._((lib._racket/unsafe/ops..rkt)._unsafe-vector-set!))",[0,[2,"unsafe-vector-set!"]],["racket/unsafe/ops"]],
["unshadowable",">reference/stxtrans.html#(idx._(gentag._176._(lib._scribblings/reference/reference..scrbl)))",[7,"'unshadowable"],false],
["unsmoothed",">gui/style-delta_.html#(idx._(gentag._187._(lib._scribblings/gui/gui..scrbl)))",[7,"'unsmoothed"],false],
["unsmoothed",">draw/font_.html#(idx._(gentag._45._(lib._scribblings/draw/draw..scrbl)))",[7,"'unsmoothed"],false],
["unspecific",">deinprogramm/assignments-signatures.html#(form._((lib._deinprogramm/.D.Md.A..rkt)._unspecific))",[0,[1,"unspecific"]],["deinprogramm/DMdA"]],
["unstable/automata",">unstable/Automata__Compiling_State_Machines.html",[9,[0,"unstable/automata"]],"module"],
["unstable/automata/dfa",">unstable/Automata__Compiling_State_Machines.html#(mod-path._unstable/automata/dfa)",[9,[0,"unstable/automata/dfa"]],"module"],
["unstable/automata/machine",">unstable/Automata__Compiling_State_Machines.html#(mod-path._unstable/automata/machine)",[9,[0,"unstable/automata/machine"]],"module"],
["unstable/automata/nfa",">unstable/Automata__Compiling_State_Machines.html#(mod-path._unstable/automata/nfa)",[9,[0,"unstable/automata/nfa"]],"module"],
["unstable/automata/nfa-ep",">unstable/Automata__Compiling_State_Machines.html#(mod-path._unstable/automata/nfa-ep)",[9,[0,"unstable/automata/nfa-ep"]],"module"],
["unstable/automata/re",">unstable/Automata__Compiling_State_Machines.html#(mod-path._unstable/automata/re)",[9,[0,"unstable/automata/re"]],"module"],
["unstable/automata/re-ext",">unstable/Automata__Compiling_State_Machines.html#(mod-path._unstable/automata/re-ext)",[9,[0,"unstable/automata/re-ext"]],"module"],
["unstable/bytes",">unstable/bytes.html",[9,[0,"unstable/bytes"]],"module"],
["unstable/cat",">unstable/cat.html",[9,[0,"unstable/cat"]],"module"],
["unstable/class-iop",">unstable/class-iop.html",[9,[0,"unstable/class-iop"]],"module"],
["unstable/contract",">unstable/contract.html",[9,[0,"unstable/contract"]],"module"],
["unstable/debug",">unstable/Debugging.html",[9,[0,"unstable/debug"]],"module"],
["unstable/define",">unstable/Definitions.html",[9,[0,"unstable/define"]],"module"],
["unstable/file",">unstable/file.html",[9,[0,"unstable/file"]],"module"],
["unstable/find",">unstable/find.html",[9,[0,"unstable/find"]],"module"],
["unstable/flonum",">unstable/flonum.html",[9,[0,"unstable/flonum"]],"module"],
["unstable/function",">unstable/Functions.html",[9,[0,"unstable/function"]],"module"],
["unstable/future",">unstable/future.html",[9,[0,"unstable/future"]],"module"],
["unstable/gui/notify",">unstable/gui-notify.html",[9,[0,"unstable/gui/notify"]],"module"],
["unstable/gui/pict",">unstable/pict.html",[9,[0,"unstable/gui/pict"]],"module"],
["unstable/gui/ppict",">unstable/ppict.html#(mod-path._unstable/gui/ppict)",[9,[0,"unstable/gui/ppict"]],"module"],
["unstable/gui/prefs",">unstable/gui-prefs.html",[9,[0,"unstable/gui/prefs"]],"module"],
["unstable/gui/pslide",">unstable/ppict.html#(mod-path._unstable/gui/pslide)",[9,[0,"unstable/gui/pslide"]],"module"],
["unstable/gui/slideshow",">unstable/Slideshow_Presentations.html",[9,[0,"unstable/gui/slideshow"]],"module"],
["unstable/gui/snip",">unstable/snip.html",[9,[0,"unstable/gui/snip"]],"module"],
["unstable/hash",">unstable/Hash_Tables.html",[9,[0,"unstable/hash"]],"module"],
["unstable/lazy-require",">unstable/lazy-require.html",[9,[0,"unstable/lazy-require"]],"module"],
["unstable/list",">unstable/list.html",[9,[0,"unstable/list"]],"module"],
["unstable/logging",">unstable/Logging.html",[9,[0,"unstable/logging"]],"module"],
["unstable/markparam",">unstable/Mark_Parameters.html",[9,[0,"unstable/markparam"]],"module"],
["unstable/match",">unstable/match.html",[9,[0,"unstable/match"]],"module"],
["unstable/parameter-group",">unstable/Parameter_Groups.html",[9,[0,"unstable/parameter-group"]],"module"],
["unstable/pretty",">unstable/Pretty-Printing.html",[9,[0,"unstable/pretty"]],"module"],
["unstable/sequence",">unstable/sequence.html",[9,[0,"unstable/sequence"]],"module"],
["unstable/string",">unstable/string.html",[9,[0,"unstable/string"]],"module"],
["unstable/struct",">unstable/struct.html",[9,[0,"unstable/struct"]],"module"],
["unstable/syntax",">unstable/syntax.html",[9,[0,"unstable/syntax"]],"module"],
["unstable/temp-c",">unstable/temp-c.html",[9,[0,"unstable/temp-c"]],"module"],
["unstable/temp-c/dsl",">unstable/temp-c.html#(mod-path._unstable/temp-c/dsl)",[9,[0,"unstable/temp-c/dsl"]],"module"],
["unstable/temp-c/monitor",">unstable/temp-c.html#(mod-path._unstable/temp-c/monitor)",[9,[0,"unstable/temp-c/monitor"]],"module"],
["unstable/wrapc",">unstable/wrapc.html",[9,[0,"unstable/wrapc"]],"module"],
["unstable: may change without warning",">unstable/index.html","Unstable: May Change Without Warning",false],
["unsupplied-arg?",">reference/function-contracts.html#(def._((lib._racket/contract/base..rkt)._unsupplied-arg~3f))",[0,[2,"unsupplied-arg?"]],["racket/contract/base","racket/contract","racket"]],
["unsyntax",">reference/stx-patterns.html#(form._((lib._racket/private/qqstx..rkt)._unsyntax))",[0,[1,"unsyntax"]],["racket/base","racket"]],
["unsyntax",">r6rs-lib-std/r6rs-lib-Z-H-13.html#node_idx_1156",[0,[1,"unsyntax"]],["rnrs/syntax-case-6"]],
["unsyntax-splicing",">reference/stx-patterns.html#(form._((lib._racket/private/qqstx..rkt)._unsyntax-splicing))",[0,[1,"unsyntax-splicing"]],["racket/base","racket"]],
["unsyntax-splicing",">r6rs-lib-std/r6rs-lib-Z-H-13.html#node_idx_1158",[0,[1,"unsyntax-splicing"]],["rnrs/syntax-case-6"]],
["untrace",">reference/debugging.html#(form._((lib._racket/trace..rkt)._untrace))",[0,[1,"untrace"]],["racket/trace"]],
["untrace",">eopl/index.html#(form._((lib._eopl/eopl..rkt)._untrace))",[0,[1,"untrace"]],["eopl"]],
["unzip1",">srfi-std/srfi-1.html#unzip1",[0,[2,"unzip1"]],["srfi/1"]],
["unzip2",">srfi-std/srfi-1.html#unzip2",[0,[2,"unzip2"]],["srfi/1"]],
["unzip3",">srfi-std/srfi-1.html#unzip3",[0,[2,"unzip3"]],["srfi/1"]],
["unzip4",">srfi-std/srfi-1.html#unzip4",[0,[2,"unzip4"]],["srfi/1"]],
["unzip5",">srfi-std/srfi-1.html#unzip5",[0,[2,"unzip5"]],["srfi/1"]],
["up",">teachpack/2htdpuniverse.html#(form._((lib._2htdp/universe..rkt)._up))",[0,[1,"up"]],["2htdp/universe"]],
["up",">reference/Manipulating_Paths.html#(idx._(gentag._236._(lib._scribblings/reference/reference..scrbl)))",[7,"'up"],false],
["up",">gui/key-event_.html#(idx._(gentag._53._(lib._scribblings/gui/gui..scrbl)))",[7,"'up"],false],
["up-arrow-icon",">images/Icons.html#(def._((lib._images/icons/arrow..rkt)._up-arrow-icon))",[0,[2,"up-arrow-icon"]],["images/icons/arrow"]],
["up-sexp",">framework/Racket.html#(meth._(((lib._framework/main..rkt)._racket~3atext~3c~25~3e)._up-sexp))",[[0,[2,"up-sexp"]],[14,[" (method of ",[0,[2,"racket:text<%>"]],")"]]],["framework"]],
["upcase-word",">framework/Keymap.html#(idx._(gentag._24._(lib._scribblings/framework/framework..scrbl)))","upcase-word",false],
["update",">reference/file-ports.html#(idx._(gentag._208._(lib._scribblings/reference/reference..scrbl)))",[7,"'update"],false],
["update-arrowhead-polygon",">mrlib/graph-pasteboard___.html#(meth._(((lib._mrlib/graph..rkt)._graph-pasteboard~3c~25~3e)._update-arrowhead-polygon))",[[0,[2,"update-arrowhead-polygon"]],[14,[" (method of ",[0,[2,"graph-pasteboard<%>"]],")"]]],["mrlib/graph"]],
["update-browser-preference",">browser/index.html#(def._((lib._browser/external..rkt)._update-browser-preference))",[0,[2,"update-browser-preference"]],["browser/external"]],
["update-cursor",">gui/editor-admin_.html#(meth._(((lib._mred/main..rkt)._editor-admin~25)._update-cursor))",[[0,[2,"update-cursor"]],[14,[" (method of ",[0,[2,"editor-admin%"]],")"]]],["racket/gui/base","racket/gui"]],
["update-cursor",">gui/snip-admin_.html#(meth._(((lib._racket/snip..rkt)._snip-admin~25)._update-cursor))",[[0,[2,"update-cursor"]],[14,[" (method of ",[0,[2,"snip-admin%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["update-frame-filename",">framework/Editor.html#(meth._(((lib._framework/main..rkt)._editor~3afile~3c~25~3e)._update-frame-filename))",[[0,[2,"update-frame-filename"]],[14,[" (method of ",[0,[2,"editor:file<%>"]],")"]]],["framework"]],
["update-info",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3ainfo~3c~25~3e)._update-info))",[[0,[2,"update-info"]],[14,[" (method of ",[0,[2,"frame:info<%>"]],")"]]],["framework"]],
["update-info",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3atext-info-mixin)._update-info))",[[0,[2,"update-info"]],[14,[" (method of ",[0,[2,"frame:text-info-mixin"]],")"]]],["framework"]],
["update-running",">tools/drracket_rep.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3arep~3acontext~3c~25~3e)._update-running))",[[0,[2,"update-running"]],[14,[" (method of ",[0,[2,"drracket:rep:context<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["update-save-button",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aframe~25)._update-save-button))",[[0,[2,"update-save-button"]],[14,[" (method of ",[0,[2,"drracket:unit:frame%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["update-save-message",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aframe~25)._update-save-message))",[[0,[2,"update-save-message"]],[14,[" (method of ",[0,[2,"drracket:unit:frame%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["update-shown",">tools/drracket_frame.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aframe~3a~3c~25~3e)._update-shown))",[[0,[2,"update-shown"]],[14,[" (method of ",[0,[2,"drracket:frame:<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["update-shown",">tools/drracket_unit.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3aunit~3aframe~25)._update-shown))",[[0,[2,"update-shown"]],[14,[" (method of ",[0,[2,"drracket:unit:frame%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["update-source-location",">syntax/Source_Locations.html#(def._((lib._syntax/srcloc..rkt)._update-source-location))",[0,[2,"update-source-location"]],["syntax/srcloc"]],
["update-status-line",">framework/Frame.html#(meth._(((lib._framework/main..rkt)._frame~3astatus-line~3c~25~3e)._update-status-line))",[[0,[2,"update-status-line"]],[14,[" (method of ",[0,[2,"frame:status-line<%>"]],")"]]],["framework"]],
["updates and transactions",">db/using-db.html#(part._dbperf-update-tx)","Updates and Transactions",false],
["upper-case",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex..rkt)._upper-case))",[0,[1,"upper-case"]],["parser-tools/lex"]],
["uri codec signature",">net/uri-codec.html#(part._.U.R.I_.Codec_.Signature)","URI Codec Signature",false],
["uri codec unit",">net/uri-codec.html#(part._.U.R.I_.Codec_.Unit)","URI Codec Unit",false],
["uri codec: encoding and decoding uris",">net/uri-codec.html","URI Codec: Encoding and Decoding URIs",false],
["uri-codec@",">net/uri-codec.html#(def._((lib._net/uri-codec-unit..rkt)._uri-codec~40))",[0,[2,"uri-codec@"]],["net/uri-codec-unit"]],
["uri-codec^",">net/uri-codec.html#(form._((lib._net/uri-codec-sig..rkt)._uri-codec~5e))",[0,[1,"uri-codec^"]],["net/uri-codec-sig"]],
["uri-decode",">net/uri-codec.html#(def._((lib._net/uri-codec..rkt)._uri-decode))",[0,[2,"uri-decode"]],["net/uri-codec"]],
["uri-encode",">net/uri-codec.html#(def._((lib._net/uri-codec..rkt)._uri-encode))",[0,[2,"uri-encode"]],["net/uri-codec"]],
["uri-path-segment-decode",">net/uri-codec.html#(def._((lib._net/uri-codec..rkt)._uri-path-segment-decode))",[0,[2,"uri-path-segment-decode"]],["net/uri-codec"]],
["uri-path-segment-encode",">net/uri-codec.html#(def._((lib._net/uri-codec..rkt)._uri-path-segment-encode))",[0,[2,"uri-path-segment-encode"]],["net/uri-codec"]],
["uri-userinfo-decode",">net/uri-codec.html#(def._((lib._net/uri-codec..rkt)._uri-userinfo-decode))",[0,[2,"uri-userinfo-decode"]],["net/uri-codec"]],
["uri-userinfo-encode",">net/uri-codec.html#(def._((lib._net/uri-codec..rkt)._uri-userinfo-encode))",[0,[2,"uri-userinfo-encode"]],["net/uri-codec"]],
["url",">planet/cmdline.html#(part._url)",[6,"url"],false],
["url",">net/url.html#(def._((lib._net/url-structs..rkt)._url))",[0,[2,"url"]],["net/url-structs","net/url"]],
["url",">scribble/base.html#(def._((lib._scribble/base..rkt)._url))",[0,[2,"url"]],["scribble/base"]],
["url functions",">net/url.html#(part._.U.R.L_.Functions)","URL Functions",false],
["url https mode",">net/url.html#(part._.U.R.L_.H.T.T.P.S_mode)","URL HTTPS mode",false],
["url param",">web-server-internal/url-param.html","URL Param",false],
["url signature",">net/url.html#(part._.U.R.L_.Signature)","URL Signature",false],
["url structure",">net/url.html#(part._.U.R.L_.Structure)","URL Structure",false],
["url unit",">net/url.html#(part._.U.R.L_.Unit)","URL Unit",false],
["url+scheme^",">net/url.html#(form._((lib._net/url-sig..rkt)._url+scheme~5e))",[0,[1,"url+scheme^"]],["net/url-sig"]],
["url->path",">net/url.html#(def._((lib._net/url..rkt)._url-~3epath))",[0,[2,"url->path"]],["net/url"]],
["url->path/c",">web-server-internal/filesystem-map.html#(def._((lib._web-server/dispatchers/filesystem-map..rkt)._url-~3epath/c))",[0,[2,"url->path/c"]],["web-server/dispatchers/filesystem-map"]],
["url->servlet/c",">web-server-internal/dispatch-servlets.html#(def._((lib._web-server/dispatchers/dispatch-servlets..rkt)._url-~3eservlet/c))",[0,[2,"url->servlet/c"]],["web-server/dispatchers/dispatch-servlets"]],
["url->string",">net/url.html#(def._((lib._net/url..rkt)._url-~3estring))",[0,[2,"url->string"]],["net/url"]],
["url-allows-evalling?",">browser/index.html#(meth._(((lib._browser/browser..rkt)._hyper-text~3c~25~3e)._url-allows-evalling~3f))",[[0,[2,"url-allows-evalling?"]],[14,[" (method of ",[0,[2,"hyper-text<%>"]],")"]]],["browser/browser","browser"]],
["url-anchor",">scribble/core.html#(def._((lib._scribble/html-properties..rkt)._url-anchor))",[0,[2,"url-anchor"]],["scribble/html-properties"]],
["url-anchor-name",">scribble/core.html#(def._((lib._scribble/html-properties..rkt)._url-anchor-name))",[0,[2,"url-anchor-name"]],["scribble/html-properties"]],
["url-anchor?",">scribble/core.html#(def._((lib._scribble/html-properties..rkt)._url-anchor~3f))",[0,[2,"url-anchor?"]],["scribble/html-properties"]],
["url-based dispatch",">web-server/dispatch.html","URL-Based Dispatch",false],
["url-exception?",">net/url.html#(def._((lib._net/url..rkt)._url-exception~3f))",[0,[2,"url-exception?"]],["net/url"]],
["url-fragment",">net/url.html#(def._((lib._net/url-structs..rkt)._url-fragment))",[0,[2,"url-fragment"]],["net/url-structs","net/url"]],
["url-host",">net/url.html#(def._((lib._net/url-structs..rkt)._url-host))",[0,[2,"url-host"]],["net/url-structs","net/url"]],
["url-path",">net/url.html#(def._((lib._net/url-structs..rkt)._url-path))",[0,[2,"url-path"]],["net/url-structs","net/url"]],
["url-path->string",">web-server-internal/misc-util.html#(def._((lib._web-server/private/util..rkt)._url-path-~3estring))",[0,[2,"url-path->string"]],["web-server/private/util"]],
["url-path-absolute?",">net/url.html#(def._((lib._net/url-structs..rkt)._url-path-absolute~3f))",[0,[2,"url-path-absolute?"]],["net/url-structs","net/url"]],
["url-port",">net/url.html#(def._((lib._net/url-structs..rkt)._url-port))",[0,[2,"url-port"]],["net/url-structs","net/url"]],
["url-query",">net/url.html#(def._((lib._net/url-structs..rkt)._url-query))",[0,[2,"url-query"]],["net/url-structs","net/url"]],
["url-replace-path",">web-server-internal/misc-util.html#(def._((lib._web-server/private/util..rkt)._url-replace-path))",[0,[2,"url-replace-path"]],["web-server/private/util"]],
["url-scheme",">net/url.html#(def._((lib._net/url-structs..rkt)._url-scheme))",[0,[2,"url-scheme"]],["net/url-structs","net/url"]],
["url-user",">net/url.html#(def._((lib._net/url-structs..rkt)._url-user))",[0,[2,"url-user"]],["net/url-structs","net/url"]],
["url?",">net/url.html#(def._((lib._net/url-structs..rkt)._url~3f))",[0,[2,"url?"]],["net/url-structs","net/url"]],
["url@",">net/url.html#(def._((lib._net/url-unit..rkt)._url~40))",[0,[2,"url@"]],["net/url-unit"]],
["url^",">net/url.html#(form._((lib._net/url-sig..rkt)._url~5e))",[0,[1,"url^"]],["net/url-sig"]],
["urls and http",">net/url.html","URLs and HTTP",false],
["us-currency-formats",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._us-currency-formats))",[0,[2,"us-currency-formats"]],["plot"]],
["us-currency-scales",">plot/ticks_and_transforms.html#(def._((lib._plot/main..rkt)._us-currency-scales))",[0,[2,"us-currency-scales"]],["plot"]],
["usage considerations",">web-server/stateless.html#(part._considerations)","Usage Considerations",false],
["use horizontal layout menu item",">drracket/Menus.html#(idx._(gentag._104._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Use Horizontal Layout</span> menu item",false],
["use the language declared in the source mode",">drracket/module.html#(idx._(gentag._39._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Use the language declared in the source</span> mode",false],
["use vertical layout menu item",">drracket/Menus.html#(idx._(gentag._103._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Use Vertical Layout</span> menu item",false],
["use-at-readtable",">scribble/reader-internals.html#(def._((lib._scribble/reader..rkt)._use-at-readtable))",[0,[2,"use-at-readtable"]],["scribble/reader"]],
["use-collection-link-paths",">reference/collects.html#(def._((quote._~23~25kernel)._use-collection-link-paths))",[0,[2,"use-collection-link-paths"]],["racket/base","racket"]],
["use-compiled-file-paths",">reference/eval.html#(def._((quote._~23~25kernel)._use-compiled-file-paths))",[0,[2,"use-compiled-file-paths"]],["racket/base","racket"]],
["use-file-text-mode",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._use-file-text-mode))",[[0,[2,"use-file-text-mode"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["use-html-spec",">html/index.html#(def._((lib._html/main..rkt)._use-html-spec))",[0,[2,"use-html-spec"]],["html"]],
["use-http-downloads?",">planet/Utility_Libraries.html#(def._((lib._planet/config..rkt)._.U.S.E-.H.T.T.P-.D.O.W.N.L.O.A.D.S~3f))",[0,[2,"USE-HTTP-DOWNLOADS?"]],["planet/config"]],
["use-last",">slideshow/Bounding_Box_Adjusters.html#(def._((lib._slideshow/pict..rkt)._use-last))",[0,[2,"use-last"]],["slideshow/pict","slideshow"]],
["use-last*",">slideshow/Bounding_Box_Adjusters.html#(def._((lib._slideshow/pict..rkt)._use-last*))",[0,[2,"use-last*"]],["slideshow/pict","slideshow"]],
["use-mred-launcher",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3amodule-based-language~3c~25~3e)._use-mred-launcher))",[[0,[2,"use-mred-launcher"]],[14,[" (method of ",[0,[2,"drracket:language:module-based-language<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["use-mred-launcher",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3asimple-module-based-language-~3emodule-based-language-mixin)._use-mred-launcher))",[[0,[2,"use-mred-launcher"]],[14,[" (method of ",[0,[2,"drracket:language:simple-module-based-language->module-based-language-mixin"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["use-named/undefined-handler",">mzlib/mzlib_pconvert.html#(def._((lib._mzlib/pconvert..rkt)._use-named/undefined-handler))",[0,[2,"use-named/undefined-handler"]],["mzlib/pconvert"]],
["use-namespace-require/copy?",">tools/drracket_language.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3alanguage~3amodule-based-language~3c~25~3e)._use-namespace-require/copy~3f))",[[0,[2,"use-namespace-require/copy?"]],[14,[" (method of ",[0,[2,"drracket:language:module-based-language<%>"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["use-occurs-check?",">racklog/glossary.html#(def._((lib._racklog/main..rkt)._use-occurs-check~3f))",[0,[2,"use-occurs-check?"]],["racklog"]],
["use-standard-compiler",">dynext/Compilation.html#(def._((lib._dynext/compile..rkt)._use-standard-compiler))",[0,[2,"use-standard-compiler"]],["dynext/compile"]],
["use-standard-linker",">dynext/Linking.html#(def._((lib._dynext/link..rkt)._use-standard-linker))",[0,[2,"use-standard-linker"]],["dynext/link"]],
["use-style-background",">gui/editor-snip_.html#(meth._(((lib._mred/main..rkt)._editor-snip~25)._use-style-background))",[[0,[2,"use-style-background"]],[14,[" (method of ",[0,[2,"editor-snip%"]],")"]]],["racket/gui/base","racket/gui"]],
["use-user-specific-search-paths",">reference/collects.html#(def._((quote._~23~25kernel)._use-user-specific-search-paths))",[0,[2,"use-user-specific-search-paths"]],["racket/base","racket"]],
["useless-requires",">macro-debugger/index.html#(idx._(gentag._0._(lib._macro-debugger/macro-debugger..scrbl)))","useless-requires",false],
["user",">reference/Filesystem.html#(idx._(gentag._263._(lib._scribblings/reference/reference..scrbl)))",[6,"USER"],false],
["user interaction",">games/gcalc.html#(part._.User_.Interaction)","User Interaction",false],
["user interface",">racklog/glossary.html#(part._.User_.Interface)","User Interface",false],
["user interfaces",">rackunit/api.html#(part._ui)","User Interfaces",false],
["user-can-flip",">cards/index.html#(meth._(((lib._games/cards..rkt)._card~3c~25~3e)._user-can-flip))",[[0,[2,"user-can-flip"]],[14,[" (method of ",[0,[2,"card<%>"]],")"]]],["games/cards"]],
["user-can-move",">cards/index.html#(meth._(((lib._games/cards..rkt)._card~3c~25~3e)._user-can-move))",[[0,[2,"user-can-move"]],[14,[" (method of ",[0,[2,"card<%>"]],")"]]],["games/cards"]],
["user-data",">mrlib/hierarchical-list-item___.html#(meth._(((lib._mrlib/hierlist..rkt)._hierarchical-list-item~3c~25~3e)._user-data))",[[0,[2,"user-data"]],[14,[" (method of ",[0,[2,"hierarchical-list-item<%>"]],")"]]],["mrlib/hierlist"]],
["user-execute-bit",">reference/Filesystem.html#(def._((lib._racket/file..rkt)._user-execute-bit))",[0,[2,"user-execute-bit"]],["racket/file","racket"]],
["user-read-bit",">reference/Filesystem.html#(def._((lib._racket/file..rkt)._user-read-bit))",[0,[2,"user-read-bit"]],["racket/file","racket"]],
["user-saves-or-not-modified?",">framework/Editor.html#(meth._(((lib._framework/main..rkt)._editor~3afile~3c~25~3e)._user-saves-or-not-modified~3f))",[[0,[2,"user-saves-or-not-modified?"]],[14,[" (method of ",[0,[2,"editor:file<%>"]],")"]]],["framework"]],
["user-vicinity",">srfi-std/srfi-59.html#user-vicinity",[0,[2,"user-vicinity"]],["srfi/59"]],
["user-write-bit",">reference/Filesystem.html#(def._((lib._racket/file..rkt)._user-write-bit))",[0,[2,"user-write-bit"]],["racket/file","racket"]],
["user1",">gui/editor-wordbreak-map_.html#(idx._(gentag._215._(lib._scribblings/gui/gui..scrbl)))",[7,"'user1"],false],
["user2",">gui/editor-wordbreak-map_.html#(idx._(gentag._216._(lib._scribblings/gui/gui..scrbl)))",[7,"'user2"],false],
["username*realm->digest-ha1/c",">web-server/http.html#(def._((lib._web-server/http/digest-auth..rkt)._username*realm-~3edigest-.H.A1/c))",[0,[2,"username*realm->digest-HA1/c"]],["web-server/http/digest-auth"]],
["username*realm->password/c",">web-server/http.html#(def._((lib._web-server/http/digest-auth..rkt)._username*realm-~3epassword/c))",[0,[2,"username*realm->password/c"]],["web-server/http/digest-auth"]],
["username-rejected",">net/pop3.html#(def._((lib._net/pop3..rkt)._username-rejected))",[0,[2,"username-rejected"]],["net/pop3"]],
["username-rejected?",">net/pop3.html#(def._((lib._net/pop3..rkt)._username-rejected~3f))",[0,[2,"username-rejected?"]],["net/pop3"]],
["userprofile",">reference/Filesystem.html#(idx._(gentag._265._(lib._scribblings/reference/reference..scrbl)))",[6,"USERPROFILE"],false],
["uses-editor-path",">gui/snip_.html#(idx._(gentag._171._(lib._scribblings/gui/gui..scrbl)))",[7,"'uses-editor-path"],false],
["using #lang reader",">guide/hash-lang_reader.html",["Using ",[9,[10,"#lang"]],[6," "],[9,[0,"reader"]]],false],
["using #lang s-exp",">guide/module-languages.html#(part._s-exp)",["Using ",[9,[10,"#lang"]],[6," "],[9,[0,"s-exp"]]],false],
["using #lang s-exp syntax/module-reader",">guide/syntax_module-reader.html",["Using ",[9,[10,"#lang"]],[6," "],[9,[0,"s-exp"]],[6," "],[9,[0,"syntax/module-reader"]]],false],
["using an sql database",">continue/index.html#(part._.Using_an_.S.Q.L_database)","Using an SQL database",false],
["using check forms",">test-engine/index.html#(part._.Using_.Check_.Forms)","Using Check Forms",false],
["using conventional racket expressions in racklog",">racklog/racket-w-logic.html","Using Conventional Racket Expressions in Racklog",false],
["using database connections",">db/using-db.html","Using Database Connections",false],
["using errortrace",">errortrace/using-errortrace.html","Using Errortrace",false],
["using external files",">scribble/text.html#(part._.Using_.External_.Files)","Using External Files",false],
["using foreign libraries",">guide/More_Libraries.html#(part._.Using_.Foreign_.Libraries)","Using Foreign Libraries",false],
["using formlets",">continue/index.html#(part._.Using_.Formlets)","Using Formlets",false],
["using https",">continue/index.html#(part._.Using_.H.T.T.P.S)","Using HTTPS",false],
["using opengl",">sgl/overview.html","Using OpenGL",false],
["using planet",">planet/Using_PLaneT.html","Using PLaneT",false],
["using printouts",">scribble/text.html#(part._.Using_.Printouts)","Using Printouts",false],
["using r6rs",">r6rs/r6rs-mod.html#(part._using-r6rs)","Using R<span style=\"vertical-align: super; font-size: 80%\">6</span>RS",false],
["using r6rs with drracket",">r6rs/Using_R6RS_with_DrRacket.html","Using R<span style=\"vertical-align: super; font-size: 80%\">6</span>RS with DrRacket",false],
["using string constants",">string-constants/index.html#(part._.Using_.String_.Constants)","Using String Constants",false],
["using the @ reader",">scribble/reader-internals.html#(part._.Using_the___.Reader)","Using the @ Reader",false],
["using the macro stepper",">macro-debugger/index.html#(part._.Using_the_.Macro_.Stepper)","Using the Macro Stepper",false],
["using the syntax browser",">macro-debugger/index.html#(part._.Using_the_.Syntax_.Browser)","Using the Syntax Browser",false],
["using typed racket from the racket repl",">ts-guide/quick.html#(part._.Using_.Typed_.Racket_from_the_.Racket_.R.E.P.L)","Using Typed Racket from the Racket REPL",false],
["using web-server/dispatch",">web-server/dispatch.html#(part._.Using_web-server_dispatch)",["Using ",[9,[0,"web-server/dispatch"]]],false],
["utf-16-codec",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_594",[0,[2,"utf-16-codec"]],["rnrs/io/ports-6"]],
["utf-8-codec",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_592",[0,[2,"utf-8-codec"]],["rnrs/io/ports-6"]],
["utf-8-permissive",">reference/bytestrings.html#(idx._(gentag._114._(lib._scribblings/reference/reference..scrbl)))","UTF-8-permissive",false],
["utf16->string",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_196",[0,[2,"utf16->string"]],["rnrs/bytevectors-6"]],
["utf32->string",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_198",[0,[2,"utf32->string"]],["rnrs/bytevectors-6"]],
["utf8->string",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_194",[0,[2,"utf8->string"]],["rnrs/bytevectors-6"]],
["utilities",">db/util.html","Utilities",false],
["utilities",">ts-reference/Utilities.html","Utilities",false],
["utilities",">web-server/formlets.html#(part._.Utilities)","Utilities",false],
["utilities for building new combinators",">reference/Building_New_Contract_Combinators.html#(part._.Utilities_for_.Building_.New_.Combinators)","Utilities for Building New Combinators",false],
["utilities for defining test suites",">rackunit/api.html#(part._.Utilities_for_.Defining_.Test_.Suites)","Utilities for Defining Test Suites",false],
["utility libraries",">planet/Utility_Libraries.html","Utility Libraries",false],
["v*",">plot/utils.html#(def._((lib._plot/utils..rkt)._v*))",[0,[2,"v*"]],["plot/utils"]],
["v+",">plot/utils.html#(def._((lib._plot/utils..rkt)._v+))",[0,[2,"v+"]],["plot/utils"]],
["v-",">plot/utils.html#(def._((lib._plot/utils..rkt)._v-))",[0,[2,"v-"]],["plot/utils"]],
["v-mode",">deinprogramm/image.html#(def._((lib._deinprogramm/image..rkt)._v-mode))",[0,[2,"v-mode"]],["teachpack/deinprogramm/image"]],
["v-place",">deinprogramm/image.html#(def._((lib._deinprogramm/image..rkt)._v-place))",[0,[2,"v-place"]],["teachpack/deinprogramm/image"]],
["v/",">plot/utils.html#(def._((lib._plot/utils..rkt)._v/))",[0,[2,"v/"]],["plot/utils"]],
["v=",">plot/utils.html#(def._((lib._plot/utils..rkt)._v~3d))",[0,[2,"v="]],["plot/utils"]],
["valid-char?",">xml/index.html#(def._((lib._xml/main..rkt)._valid-char~3f))",[0,[2,"valid-char?"]],["xml"]],
["valid-domain?",">net/cookie.html#(def._((lib._net/cookie..rkt)._valid-domain~3f))",[0,[2,"valid-domain?"]],["net/cookie"]],
["valid-version?",">version/index.html#(def._((lib._version/utils..rkt)._valid-version~3f))",[0,[2,"valid-version?"]],["version/utils"]],
["validate-header",">net/head.html#(def._((lib._net/head..rkt)._validate-header))",[0,[2,"validate-header"]],["net/head"]],
["validate-xexpr",">xml/index.html#(def._((lib._xml/main..rkt)._validate-xexpr))",[0,[2,"validate-xexpr"]],["xml"]],
["value",">reference/eval-model.html#(tech._value)","<span style=\"font-style: italic\">value</span>",false],
["value functions",">inside/im_values_types.html#(part._.Value_.Functions)","Value Functions",false],
["value output hook",">reference/pretty-print.html#(part._.Value_.Output_.Hook)","Value Output Hook",false],
["value turtles",">turtles/Value_Turtles.html","Value Turtles",false],
["value-color",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._value-color))",[0,[2,"value-color"]],["scribble/racket","scribble/scheme"]],
["value-contract",">reference/contract-utilities.html#(def._((lib._racket/contract/private/guts..rkt)._value-contract))",[0,[2,"value-contract"]],["racket/contract/base","racket/contract","racket"]],
["value-link-color",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._value-link-color))",[0,[2,"value-link-color"]],["scribble/racket","scribble/scheme"]],
["value-now",">frtime/index.html#(def._((lib._frtime/main..rkt)._value-now))",[0,[2,"value-now"]],["frtime"]],
["values",">reference/values.html#(def._((quote._~23~25kernel)._values))",[0,[2,"values"]],["racket/base","racket"]],
["values",">r5rs-std/r5rs-Z-H-9.html#%_idx_594",[0,[2,"values"]],["r5rs"]],
["values",">r6rs-std/r6rs-Z-H-14.html#node_idx_760",[0,[2,"values"]],["rnrs/base-6"]],
["values",">lazy/index.html#(def._((lib._lazy/main..rkt)._values))",[0,[2,"values"]],["lazy"]],
["values",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types-extra..rkt)._.Values))",[0,[1,"Values"]],["typed/racket/base","typed/racket"]],
["values",">ts-reference/Legacy_Forms.html#(form._((lib._typed/racket/base..rkt)._values))",[0,[1,"values"]],["typed/racket/base","typed/racket"]],
["values and types",">inside/im_values_types.html","Values and Types",false],
["var",">html/index.html#(def._((lib._html/main..rkt)._var))",[0,[2,"var"]],["html"]],
["var",">scribble/scribble_manual_code.html#(form._((lib._scribble/manual..rkt)._var))",[0,[1,"var"]],["scribble/manual"]],
["var-id",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._var-id))",[0,[2,"var-id"]],["scribble/racket","scribble/scheme"]],
["var-id-sym",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._var-id-sym))",[0,[2,"var-id-sym"]],["scribble/racket","scribble/scheme"]],
["var-id?",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._var-id~3f))",[0,[2,"var-id?"]],["scribble/racket","scribble/scheme"]],
["var?",">html/index.html#(def._((lib._html/main..rkt)._var~3f))",[0,[2,"var?"]],["html"]],
["variable",">redex/The_Redex_Reference.html#(tech._variable)",[0,"variable"],false],
["variable",">reference/eval-model.html#(tech._variable)","<span style=\"font-style: italic\">variable</span>",false],
["variable auto-converting string type",">foreign/String_Types.html#(part._.Variable_.Auto-.Converting_.String_.Type)","Variable Auto-Converting String Type",false],
["variable reference",">reference/Locations____variable-reference.html#(tech._variable._reference)","<span style=\"font-style: italic\">variable reference</span>",false],
["variable references and #%top",">reference/__top.html",["Variable References and ",[0,[1,"#%top"]]],false],
["variable-arity functions: programming with rest arguments",">ts-guide/types.html#(part._varargs)","Variable-Arity Functions: Programming with Rest Arguments",false],
["variable-color",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._variable-color))",[0,[2,"variable-color"]],["scribble/racket","scribble/scheme"]],
["variable-except",">redex/The_Redex_Reference.html#(tech._variable._except)",[0,"variable-except"],false],
["variable-id?",">scribble/scheme.html#(def._((lib._scribble/racket..rkt)._variable-id~3f))",[0,[2,"variable-id?"]],["scribble/racket","scribble/scheme"]],
["variable-not-in",">redex/The_Redex_Reference.html#(def._((lib._redex/reduction-semantics..rkt)._variable-not-in))",[0,[2,"variable-not-in"]],["redex/reduction-semantics","redex"]],
["variable-not-otherwise-mentioned",">redex/The_Redex_Reference.html#(tech._variable._not._otherwise._mentioned)",[0,"variable-not-otherwise-mentioned"],false],
["variable-prefix",">redex/The_Redex_Reference.html#(tech._variable._prefix)",[0,"variable-prefix"],false],
["variable-reference",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Variable-.Reference))",[0,[1,"Variable-Reference"]],["typed/racket/base","typed/racket"]],
["variable-reference->empty-namespace",">reference/Namespaces.html#(def._((quote._~23~25kernel)._variable-reference-~3eempty-namespace))",[0,[2,"variable-reference->empty-namespace"]],["racket/base","racket"]],
["variable-reference->module-base-phase",">reference/Namespaces.html#(def._((quote._~23~25kernel)._variable-reference-~3emodule-base-phase))",[0,[2,"variable-reference->module-base-phase"]],["racket/base","racket"]],
["variable-reference->module-declaration-inspector",">reference/Namespaces.html#(def._((quote._~23~25kernel)._variable-reference-~3emodule-declaration-inspector))",[0,[2,"variable-reference->module-declaration-inspector"]],["racket/base","racket"]],
["variable-reference->module-path-index",">reference/Namespaces.html#(def._((quote._~23~25kernel)._variable-reference-~3emodule-path-index))",[0,[2,"variable-reference->module-path-index"]],["racket/base","racket"]],
["variable-reference->module-source",">reference/Namespaces.html#(def._((quote._~23~25kernel)._variable-reference-~3emodule-source))",[0,[2,"variable-reference->module-source"]],["racket/base","racket"]],
["variable-reference->namespace",">reference/Namespaces.html#(def._((quote._~23~25kernel)._variable-reference-~3enamespace))",[0,[2,"variable-reference->namespace"]],["racket/base","racket"]],
["variable-reference->phase",">reference/Namespaces.html#(def._((quote._~23~25kernel)._variable-reference-~3ephase))",[0,[2,"variable-reference->phase"]],["racket/base","racket"]],
["variable-reference->resolved-module-path",">reference/Namespaces.html#(def._((quote._~23~25kernel)._variable-reference-~3eresolved-module-path))",[0,[2,"variable-reference->resolved-module-path"]],["racket/base","racket"]],
["variable-reference-constant?",">reference/Namespaces.html#(def._((quote._~23~25kernel)._variable-reference-constant~3f))",[0,[2,"variable-reference-constant?"]],["racket/base","racket"]],
["variable-reference?",">reference/Namespaces.html#(def._((quote._~23~25kernel)._variable-reference~3f))",[0,[2,"variable-reference?"]],["racket/base","racket"]],
["variables",">picturing-programs/index.html#(part._.Variables)","Variables",false],
["variables and locations",">reference/eval-model.html#(part._.Variables_and_.Locations)","Variables and Locations",false],
["variables-not-in",">redex/The_Redex_Reference.html#(def._((lib._redex/reduction-semantics..rkt)._variables-not-in))",[0,[2,"variables-not-in"]],["redex/reduction-semantics","redex"]],
["variants with uniform meanings",">syntax/uniform-meanings.html","Variants with Uniform Meanings",false],
["variants with varied meanings",">syntax/varied-meanings.html","Variants with Varied Meanings",false],
["varieties of ports",">guide/ports.html","Varieties of Ports",false],
["various string forms",">scribble/doc-strings.html","Various String Forms",false],
["varref",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._varref))",[0,[2,"varref"]],["compiler/zo-structs"]],
["varref-dummy",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._varref-dummy))",[0,[2,"varref-dummy"]],["compiler/zo-structs"]],
["varref-toplevel",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._varref-toplevel))",[0,[2,"varref-toplevel"]],["compiler/zo-structs"]],
["varref?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._varref~3f))",[0,[2,"varref?"]],["compiler/zo-structs"]],
["vc-append",">slideshow/Pict_Combiners.html#(def._((lib._slideshow/pict..rkt)._vc-append))",[0,[2,"vc-append"]],["slideshow/pict","slideshow"]],
["vcenter",">plot/utils.html#(def._((lib._plot/utils..rkt)._vcenter))",[0,[2,"vcenter"]],["plot/utils"]],
["vcross",">plot/utils.html#(def._((lib._plot/utils..rkt)._vcross))",[0,[2,"vcross"]],["plot/utils"]],
["vcross2",">plot/utils.html#(def._((lib._plot/utils..rkt)._vcross2))",[0,[2,"vcross2"]],["plot/utils"]],
["vdot",">plot/utils.html#(def._((lib._plot/utils..rkt)._vdot))",[0,[2,"vdot"]],["plot/utils"]],
["vec3",">deinprogramm/line3d.html#(def._((lib._teachpack/deinprogramm/line3d..rkt)._vec3))",[0,"vec3"],["teachpack/deinprogramm/line3d"]],
["vec4",">deinprogramm/line3d.html#(def._((lib._teachpack/deinprogramm/line3d..rkt)._vec4))",[0,"vec4"],["teachpack/deinprogramm/line3d"]],
["vector",">reference/vectors.html#(def._((quote._~23~25kernel)._vector))",[0,[2,"vector"]],["racket/base","racket"]],
["vector",">r5rs-std/r5rs-Z-H-9.html#%_idx_562",[0,[2,"vector"]],["r5rs"]],
["vector",">r6rs-std/r6rs-Z-H-14.html#node_idx_728",[0,[2,"vector"]],["rnrs/base-6"]],
["vector",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._vector))",[0,[2,"vector"]],["lang/htdp-advanced"]],
["vector",">lazy/index.html#(def._((lib._lazy/main..rkt)._vector))",[0,[2,"vector"]],["lazy"]],
["vector",">srfi-std/srfi-43.html#vector",[0,[2,"vector"]],["srfi/43"]],
["vector",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types-extra..rkt)._.Vector))",[0,[1,"Vector"]],["typed/racket/base","typed/racket"]],
["vector",">guide/vectors.html#(tech._vector)","<span style=\"font-style: italic\">vector</span>",false],
["vector",">reference/vectors.html#(tech._vector)","<span style=\"font-style: italic\">vector</span>",false],
["vector fields",">plot/params.html#(part._.Vector_.Fields)","Vector Fields",false],
["vector functions",">plot/utils.html#(part._math..vectors)","Vector Functions",false],
["vector->cblock",">foreign/Miscellaneous_Support.html#(def._((lib._ffi/unsafe..rkt)._vector-~3ecblock))",[0,[2,"vector->cblock"]],["ffi/unsafe"]],
["vector->cpointer",">foreign/Miscellaneous_Support.html#(def._((quote._~23~25foreign)._vector-~3ecpointer))",[0,[2,"vector->cpointer"]],["ffi/unsafe"]],
["vector->gl-boolean-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._vector-~3egl-boolean-vector))",[0,[2,"vector->gl-boolean-vector"]],["sgl/gl-vectors"]],
["vector->gl-byte-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._vector-~3egl-byte-vector))",[0,[2,"vector->gl-byte-vector"]],["sgl/gl-vectors"]],
["vector->gl-double-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._vector-~3egl-double-vector))",[0,[2,"vector->gl-double-vector"]],["sgl/gl-vectors"]],
["vector->gl-float-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._vector-~3egl-float-vector))",[0,[2,"vector->gl-float-vector"]],["sgl/gl-vectors"]],
["vector->gl-int-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._vector-~3egl-int-vector))",[0,[2,"vector->gl-int-vector"]],["sgl/gl-vectors"]],
["vector->gl-short-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._vector-~3egl-short-vector))",[0,[2,"vector->gl-short-vector"]],["sgl/gl-vectors"]],
["vector->gl-ubyte-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._vector-~3egl-ubyte-vector))",[0,[2,"vector->gl-ubyte-vector"]],["sgl/gl-vectors"]],
["vector->gl-uint-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._vector-~3egl-uint-vector))",[0,[2,"vector->gl-uint-vector"]],["sgl/gl-vectors"]],
["vector->gl-ushort-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..rkt)._vector-~3egl-ushort-vector))",[0,[2,"vector->gl-ushort-vector"]],["sgl/gl-vectors"]],
["vector->heap",">data/Binary_Heaps.html#(def._((lib._data/heap..rkt)._vector-~3eheap))",[0,[2,"vector->heap"]],["data/heap"]],
["vector->immutable-vector",">reference/vectors.html#(def._((quote._~23~25kernel)._vector-~3eimmutable-vector))",[0,[2,"vector->immutable-vector"]],["racket/base","racket"]],
["vector->list",">reference/vectors.html#(def._((quote._~23~25kernel)._vector-~3elist))",[0,[2,"vector->list"]],["racket/base","racket"]],
["vector->list",">r5rs-std/r5rs-Z-H-9.html#%_idx_570",[0,[2,"vector->list"]],["r5rs"]],
["vector->list",">r6rs-std/r6rs-Z-H-14.html#node_idx_736",[0,[2,"vector->list"]],["rnrs/base-6"]],
["vector->list",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._vector-~3elist))",[0,[2,"vector->list"]],["lang/htdp-advanced"]],
["vector->list",">srfi-std/srfi-43.html#vector->list",[0,[2,"vector->list"]],["srfi/43"]],
["vector->pseudo-random-generator",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._vector-~3epseudo-random-generator))",[0,[2,"vector->pseudo-random-generator"]],["racket/base","racket"]],
["vector->pseudo-random-generator!",">reference/generic-numbers.html#(def._((quote._~23~25kernel)._vector-~3epseudo-random-generator!))",[0,[2,"vector->pseudo-random-generator!"]],["racket/base","racket"]],
["vector->values",">reference/vectors.html#(def._((quote._~23~25kernel)._vector-~3evalues))",[0,[2,"vector->values"]],["racket/base","racket"]],
["vector-any",">srfi-std/srfi-43.html#vector-any",[0,[2,"vector-any"]],["srfi/43"]],
["vector-append",">reference/vectors.html#(def._((lib._racket/vector..rkt)._vector-append))",[0,[2,"vector-append"]],["racket/vector","racket"]],
["vector-append",">srfi-std/srfi-43.html#vector-append",[0,[2,"vector-append"]],["srfi/43"]],
["vector-argmax",">reference/vectors.html#(def._((lib._racket/vector..rkt)._vector-argmax))",[0,[2,"vector-argmax"]],["racket/vector","racket"]],
["vector-argmin",">reference/vectors.html#(def._((lib._racket/vector..rkt)._vector-argmin))",[0,[2,"vector-argmin"]],["racket/vector","racket"]],
["vector-binary-search",">srfi-std/srfi-43.html#vector-binary-search",[0,[2,"vector-binary-search"]],["srfi/43"]],
["vector-concatenate",">srfi-std/srfi-43.html#vector-concatenate",[0,[2,"vector-concatenate"]],["srfi/43"]],
["vector-copy",">reference/vectors.html#(def._((lib._racket/vector..rkt)._vector-copy))",[0,[2,"vector-copy"]],["racket/vector","racket"]],
["vector-copy",">srfi-std/srfi-43.html#vector-copy",[0,[2,"vector-copy"]],["srfi/43"]],
["vector-copy!",">reference/vectors.html#(def._((quote._~23~25kernel)._vector-copy!))",[0,[2,"vector-copy!"]],["racket/base","racket"]],
["vector-copy!",">srfi-std/srfi-43.html#vector-copy-bang",[0,[2,"vector-copy!"]],["srfi/43"]],
["vector-count",">reference/vectors.html#(def._((lib._racket/vector..rkt)._vector-count))",[0,[2,"vector-count"]],["racket/vector","racket"]],
["vector-count",">srfi-std/srfi-43.html#vector-count",[0,[2,"vector-count"]],["srfi/43"]],
["vector-drop",">reference/vectors.html#(def._((lib._racket/vector..rkt)._vector-drop))",[0,[2,"vector-drop"]],["racket/vector","racket"]],
["vector-drop-right",">reference/vectors.html#(def._((lib._racket/vector..rkt)._vector-drop-right))",[0,[2,"vector-drop-right"]],["racket/vector","racket"]],
["vector-ec",">srfi-std/srfi-42.html#vector-ec",[0,[1,"vector-ec"]],["srfi/42"]],
["vector-empty?",">srfi-std/srfi-43.html#vector-empty?",[0,[2,"vector-empty?"]],["srfi/43"]],
["vector-every",">srfi-std/srfi-43.html#vector-every",[0,[2,"vector-every"]],["srfi/43"]],
["vector-field",">plot/renderer2d.html#(def._((lib._plot/main..rkt)._vector-field))",[0,[2,"vector-field"]],["plot"]],
["vector-field",">plot/compat.html#(def._((lib._plot/compat..rkt)._vector-field))",[0,[2,"vector-field"]],["plot/compat"]],
["vector-field-alpha",">plot/params.html#(def._((lib._plot/main..rkt)._vector-field-alpha))",[0,[2,"vector-field-alpha"]],["plot"]],
["vector-field-color",">plot/params.html#(def._((lib._plot/main..rkt)._vector-field-color))",[0,[2,"vector-field-color"]],["plot"]],
["vector-field-line-style",">plot/params.html#(def._((lib._plot/main..rkt)._vector-field-line-style))",[0,[2,"vector-field-line-style"]],["plot"]],
["vector-field-line-width",">plot/params.html#(def._((lib._plot/main..rkt)._vector-field-line-width))",[0,[2,"vector-field-line-width"]],["plot"]],
["vector-field-samples",">plot/params.html#(def._((lib._plot/main..rkt)._vector-field-samples))",[0,[2,"vector-field-samples"]],["plot"]],
["vector-field-scale",">plot/params.html#(def._((lib._plot/main..rkt)._vector-field-scale))",[0,[2,"vector-field-scale"]],["plot"]],
["vector-field3d",">plot/renderer3d.html#(def._((lib._plot/main..rkt)._vector-field3d))",[0,[2,"vector-field3d"]],["plot"]],
["vector-field3d-samples",">plot/params.html#(def._((lib._plot/main..rkt)._vector-field3d-samples))",[0,[2,"vector-field3d-samples"]],["plot"]],
["vector-fill!",">reference/vectors.html#(def._((quote._~23~25kernel)._vector-fill!))",[0,[2,"vector-fill!"]],["racket/base","racket"]],
["vector-fill!",">r5rs-std/r5rs-Z-H-9.html#%_idx_574",[0,[2,"vector-fill!"]],["r5rs"]],
["vector-fill!",">r6rs-std/r6rs-Z-H-14.html#node_idx_740",[0,[2,"vector-fill!"]],["rnrs/base-6"]],
["vector-fill!",">srfi-std/srfi-43.html#vector-fill-bang",[0,[2,"vector-fill!"]],["srfi/43"]],
["vector-filter",">reference/vectors.html#(def._((lib._racket/vector..rkt)._vector-filter))",[0,[2,"vector-filter"]],["racket/vector","racket"]],
["vector-filter-not",">reference/vectors.html#(def._((lib._racket/vector..rkt)._vector-filter-not))",[0,[2,"vector-filter-not"]],["racket/vector","racket"]],
["vector-fold",">srfi-std/srfi-43.html#vector-fold",[0,[2,"vector-fold"]],["srfi/43"]],
["vector-fold-right",">srfi-std/srfi-43.html#vector-fold-right",[0,[2,"vector-fold-right"]],["srfi/43"]],
["vector-for-each",">r6rs-std/r6rs-Z-H-14.html#node_idx_744",[0,[2,"vector-for-each"]],["rnrs/base-6"]],
["vector-for-each",">srfi-std/srfi-43.html#vector-for-each",[0,[2,"vector-for-each"]],["srfi/43"]],
["vector-immutable",">reference/vectors.html#(def._((quote._~23~25kernel)._vector-immutable))",[0,[2,"vector-immutable"]],["racket/base","racket"]],
["vector-immutable/c",">reference/data-structure-contracts.html#(def._((lib._racket/contract/private/vector..rkt)._vector-immutable/c))",[0,[2,"vector-immutable/c"]],["racket/contract/base","racket/contract","racket"]],
["vector-immutableof",">reference/data-structure-contracts.html#(def._((lib._racket/contract/private/vector..rkt)._vector-immutableof))",[0,[2,"vector-immutableof"]],["racket/contract/base","racket/contract","racket"]],
["vector-index",">srfi-std/srfi-43.html#vector-index",[0,[2,"vector-index"]],["srfi/43"]],
["vector-index-right",">srfi-std/srfi-43.html#vector-index-right",[0,[2,"vector-index-right"]],["srfi/43"]],
["vector-length",">reference/vectors.html#(def._((quote._~23~25kernel)._vector-length))",[0,[2,"vector-length"]],["racket/base","racket"]],
["vector-length",">r5rs-std/r5rs-Z-H-9.html#%_idx_564",[0,[2,"vector-length"]],["r5rs"]],
["vector-length",">r6rs-std/r6rs-Z-H-14.html#node_idx_730",[0,[2,"vector-length"]],["rnrs/base-6"]],
["vector-length",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._vector-length))",[0,[2,"vector-length"]],["lang/htdp-advanced"]],
["vector-length",">srfi-std/srfi-43.html#vector-length",[0,[2,"vector-length"]],["srfi/43"]],
["vector-map",">reference/vectors.html#(def._((lib._racket/vector..rkt)._vector-map))",[0,[2,"vector-map"]],["racket/vector","racket"]],
["vector-map",">r6rs-std/r6rs-Z-H-14.html#node_idx_742",[0,[2,"vector-map"]],["rnrs/base-6"]],
["vector-map",">srfi-std/srfi-43.html#vector-map",[0,[2,"vector-map"]],["srfi/43"]],
["vector-map!",">reference/vectors.html#(def._((lib._racket/vector..rkt)._vector-map!))",[0,[2,"vector-map!"]],["racket/vector","racket"]],
["vector-map!",">srfi-std/srfi-43.html#vector-map-bang",[0,[2,"vector-map!"]],["srfi/43"]],
["vector-member",">reference/vectors.html#(def._((lib._racket/vector..rkt)._vector-member))",[0,[2,"vector-member"]],["racket/vector","racket"]],
["vector-memq",">reference/vectors.html#(def._((lib._racket/vector..rkt)._vector-memq))",[0,[2,"vector-memq"]],["racket/vector","racket"]],
["vector-memv",">reference/vectors.html#(def._((lib._racket/vector..rkt)._vector-memv))",[0,[2,"vector-memv"]],["racket/vector","racket"]],
["vector-of-length-ec",">srfi-std/srfi-42.html#vector-of-length-ec",[0,[1,"vector-of-length-ec"]],["srfi/42"]],
["vector-ref",">reference/vectors.html#(def._((quote._~23~25kernel)._vector-ref))",[0,[2,"vector-ref"]],["racket/base","racket"]],
["vector-ref",">r5rs-std/r5rs-Z-H-9.html#%_idx_566",[0,[2,"vector-ref"]],["r5rs"]],
["vector-ref",">r6rs-std/r6rs-Z-H-14.html#node_idx_732",[0,[2,"vector-ref"]],["rnrs/base-6"]],
["vector-ref",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._vector-ref))",[0,[2,"vector-ref"]],["lang/htdp-advanced"]],
["vector-ref",">srfi-std/srfi-43.html#vector-ref",[0,[2,"vector-ref"]],["srfi/43"]],
["vector-reverse!",">srfi-std/srfi-43.html#vector-reverse-bang",[0,[2,"vector-reverse!"]],["srfi/43"]],
["vector-reverse-copy",">srfi-std/srfi-43.html#vector-reverse-copy",[0,[2,"vector-reverse-copy"]],["srfi/43"]],
["vector-reverse-copy!",">srfi-std/srfi-43.html#vector-reverse-copy-bang",[0,[2,"vector-reverse-copy!"]],["srfi/43"]],
["vector-set!",">reference/vectors.html#(def._((quote._~23~25kernel)._vector-set!))",[0,[2,"vector-set!"]],["racket/base","racket"]],
["vector-set!",">r5rs-std/r5rs-Z-H-9.html#%_idx_568",[0,[2,"vector-set!"]],["r5rs"]],
["vector-set!",">r6rs-std/r6rs-Z-H-14.html#node_idx_734",[0,[2,"vector-set!"]],["rnrs/base-6"]],
["vector-set!",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._vector-set!))",[0,[2,"vector-set!"]],["lang/htdp-advanced"]],
["vector-set!",">lazy/index.html#(def._((lib._lazy/main..rkt)._vector-set!))",[0,[2,"vector-set!"]],["lazy"]],
["vector-set!",">srfi-std/srfi-43.html#vector-set-bang",[0,[2,"vector-set!"]],["srfi/43"]],
["vector-set*!",">reference/vectors.html#(def._((lib._racket/vector..rkt)._vector-set*!))",[0,[2,"vector-set*!"]],["racket/vector","racket"]],
["vector-set-performance-stats!",">reference/runtime.html#(def._((quote._~23~25kernel)._vector-set-performance-stats!))",[0,[2,"vector-set-performance-stats!"]],["racket/base","racket"]],
["vector-skip",">srfi-std/srfi-43.html#vector-skip",[0,[2,"vector-skip"]],["srfi/43"]],
["vector-skip-right",">srfi-std/srfi-43.html#vector-skip-right",[0,[2,"vector-skip-right"]],["srfi/43"]],
["vector-sort",">r6rs-lib-std/r6rs-lib-Z-H-5.html#node_idx_248",[0,[2,"vector-sort"]],["rnrs/sorting-6"]],
["vector-sort!",">r6rs-lib-std/r6rs-lib-Z-H-5.html#node_idx_250",[0,[2,"vector-sort!"]],["rnrs/sorting-6"]],
["vector-split-at",">reference/vectors.html#(def._((lib._racket/vector..rkt)._vector-split-at))",[0,[2,"vector-split-at"]],["racket/vector","racket"]],
["vector-split-at-right",">reference/vectors.html#(def._((lib._racket/vector..rkt)._vector-split-at-right))",[0,[2,"vector-split-at-right"]],["racket/vector","racket"]],
["vector-swap!",">srfi-std/srfi-43.html#vector-swap-bang",[0,[2,"vector-swap!"]],["srfi/43"]],
["vector-take",">reference/vectors.html#(def._((lib._racket/vector..rkt)._vector-take))",[0,[2,"vector-take"]],["racket/vector","racket"]],
["vector-take-right",">reference/vectors.html#(def._((lib._racket/vector..rkt)._vector-take-right))",[0,[2,"vector-take-right"]],["racket/vector","racket"]],
["vector-unfold",">srfi-std/srfi-43.html#vector-unfold",[0,[2,"vector-unfold"]],["srfi/43"]],
["vector-unfold-right",">srfi-std/srfi-43.html#vector-unfold-right",[0,[2,"vector-unfold-right"]],["srfi/43"]],
["vector/c",">reference/data-structure-contracts.html#(def._((lib._racket/contract/private/vector..rkt)._vector/c))",[0,[2,"vector/c"]],["racket/contract/base","racket/contract","racket"]],
["vector/c",">mzlib/mzlib_contract.html#(def._((lib._mzlib/contract..rkt)._vector/c))",[0,[2,"vector/c"]],["mzlib/contract"]],
["vector=",">srfi-std/srfi-43.html#vector-eq",[0,[2,"vector="]],["srfi/43"]],
["vector?",">reference/vectors.html#(def._((quote._~23~25kernel)._vector~3f))",[0,[2,"vector?"]],["racket/base","racket"]],
["vector?",">r5rs-std/r5rs-Z-H-9.html#%_idx_556",[0,[2,"vector?"]],["r5rs"]],
["vector?",">r6rs-std/r6rs-Z-H-14.html#node_idx_722",[0,[2,"vector?"]],["rnrs/base-6"]],
["vector?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._vector~3f))",[0,[2,"vector?"]],["lang/htdp-advanced"]],
["vector?",">srfi-std/srfi-43.html#vector-p",[0,[2,"vector?"]],["srfi/43"]],
["vectorof",">reference/data-structure-contracts.html#(def._((lib._racket/contract/private/vector..rkt)._vectorof))",[0,[2,"vectorof"]],["racket/contract/base","racket/contract","racket"]],
["vectorof",">mzlib/mzlib_contract.html#(def._((lib._mzlib/contract..rkt)._vectorof))",[0,[2,"vectorof"]],["mzlib/contract"]],
["vectorof",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Vectorof))",[0,[1,"Vectorof"]],["typed/racket/base","typed/racket"]],
["vectors",">guide/vectors.html","Vectors",false],
["vectors",">htdp-langs/advanced.html#(part._htdp-advanced._.Vectors)","Vectors",false],
["vectors",">reference/vectors.html","Vectors",false],
["vectors",">ts-guide/optimization.html#(part._.Vectors)","Vectors",false],
["verbatim",">scribble/base.html#(def._((lib._scribble/base..rkt)._verbatim))",[0,[2,"verbatim"]],["scribble/base"]],
["verbesserungen",">deinprogramm/turtle.html#(part._.Verbesserungen)","Verbesserungen",false],
["verbose",">raco/API_for_Raw_Compilation.html#(def._((lib._compiler/option..rkt)._verbose))",[0,[2,"verbose"]],["compiler/option"]],
["verbose",">raco/setup-plt-plt.html#(sig-val._((lib._setup/option-sig..rkt)._setup-option~5e._verbose))",[0,[2,"verbose"]],["setup/option-sig"]],
["version",">mysterx/version.html","Version",false],
["version",">framework/Version.html","Version",false],
["version",">reference/runtime.html#(def._((quote._~23~25kernel)._version))",[0,[2,"version"]],["racket/base","racket"]],
["version",">planet/Developing_Packages_for_PLaneT.html#(idx._(gentag._24._(lib._planet/planet..scrbl)))",[7,"'version"],false],
["version 3",">rackunit/Release_Notes.html#(part._.Version_3)","Version 3",false],
["version 3.4",">rackunit/Release_Notes.html#(part._.Version_3_4)","Version 3.4",false],
["version utilities",">version/index.html#(part._.Version_.Utilities)","Version Utilities",false],
["version->integer",">version/index.html#(def._((lib._version/utils..rkt)._version-~3einteger))",[0,[2,"version->integer"]],["version/utils"]],
["version->list",">version/index.html#(def._((lib._version/utils..rkt)._version-~3elist))",[0,[2,"version->list"]],["version/utils"]],
["version/check",">version/index.html#(mod-path._version/check)",[9,[0,"version/check"]],"module"],
["version/patchlevel",">version/index.html#(mod-path._version/patchlevel)",[9,[0,"version/patchlevel"]],"module"],
["version/tool",">version/index.html#(mod-path._version/tool)",[9,[0,"version/tool"]],"module"],
["version/utils",">version/index.html#(mod-path._version/utils)",[9,[0,"version/utils"]],"module"],
["version: racket version checking",">version/index.html","Version: Racket Version Checking",false],
["version:add-spec",">framework/Version.html#(def._((lib._framework/main..rkt)._version~3aadd-spec))",[0,[2,"version:add-spec"]],["framework"]],
["version:version",">framework/Version.html#(def._((lib._framework/main..rkt)._version~3aversion))",[0,[2,"version:version"]],["framework"]],
["version<=?",">version/index.html#(def._((lib._version/utils..rkt)._version~3c~3d~3f))",[0,[2,"version<=?"]],["version/utils"]],
["version<?",">version/index.html#(def._((lib._version/utils..rkt)._version~3c~3f))",[0,[2,"version<?"]],["version/utils"]],
["versioned-part?",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._versioned-part~3f))",[0,[2,"versioned-part?"]],["scribble/struct"]],
["vert-margin",">gui/subarea___.html#(meth._(((lib._mred/main..rkt)._subarea~3c~25~3e)._vert-margin))",[[0,[2,"vert-margin"]],[14,[" (method of ",[0,[2,"subarea<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["vert-margin",">gui/subarea___.html#(idx._(gentag._126._(lib._scribblings/gui/gui..scrbl)))",[0,"vert-margin"],false],
["vertical-alignment%",">embedded-gui/vertical-alignment_.html",[0,[2,"vertical-alignment%"]],["embedded-gui"]],
["vertical-hatch",">draw/brush_.html#(idx._(gentag._22._(lib._scribblings/draw/draw..scrbl)))",[7,"'vertical-hatch"],false],
["vertical-inset",">gui/editor-canvas_.html#(meth._(((lib._mred/main..rkt)._editor-canvas~25)._vertical-inset))",[[0,[2,"vertical-inset"]],[14,[" (method of ",[0,[2,"editor-canvas%"]],")"]]],["racket/gui/base","racket/gui"]],
["vertical-pane%",">gui/vertical-pane_.html",[0,[2,"vertical-pane%"]],["racket/gui/base","racket/gui"]],
["vertical-panel%",">gui/vertical-panel_.html",[0,[2,"vertical-panel%"]],["racket/gui/base","racket/gui"]],
["vertical-pasteboard%",">mrlib/vertical-pasteboard_.html",[0,[2,"vertical-pasteboard%"]],["mrlib/aligned-pasteboard"]],
["vertikale feld",">deinprogramm/line3d.html#(tech._vertikale._feld)","<span style=\"font-style: italic\">vertikale Feld</span>",false],
["vertikale justierungsangabe",">deinprogramm/image.html#(tech._vertikale._justierungsangabe)","<span style=\"font-style: italic\">vertikale Justierungsangabe</span>",false],
["vertikale positionsangabe",">deinprogramm/image.html#(tech._vertikale._positionsangabe)","<span style=\"font-style: italic\">vertikale Positionsangabe</span>",false],
["vicinity:suffix?",">srfi-std/srfi-59.html#vicinity:suffix-p",[0,[2,"vicinity:suffix?"]],["srfi/59"]],
["view",">drracket/Menus.html#(part._menu~3aview)","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">View</span>",false],
["view",">teachpack/arrow-gui.html#(def._((lib._htdp/arrow-gui..rkt)._view))",[0,[2,"view"]],["htdp/arrow-gui"]],
["view",">teachpack/guess-gui.html#(def._((lib._htdp/guess-gui..rkt)._view))",[0,[2,"view"]],["htdp/guess-gui"]],
["view",">teachpack/lkup-gui.html#(def._((lib._htdp/lkup-gui..rkt)._view))",[0,[2,"view"]],["htdp/lkup-gui"]],
["view menu",">tools/drracket_frame.html#(idx._(gentag._31._(lib._scribblings/tools/tools..scrbl)))","View menu",false],
["view-control-font",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._view-control-font))",[0,[2,"view-control-font"]],["racket/gui/base","racket/gui"]],
["viewer control",">slideshow/Viewer_Control.html","Viewer Control",false],
["viewport->snip",">graphics/Miscellaneous_Operations.html#(def._((lib._graphics/graphics..rkt)._viewport-~3esnip))",[0,[2,"viewport->snip"]],["graphics/graphics"]],
["viewport-buffer-dc",">graphics/Miscellaneous_Operations.html#(def._((lib._graphics/graphics..rkt)._viewport-buffer-dc))",[0,[2,"viewport-buffer-dc"]],["graphics/graphics"]],
["viewport-dc",">graphics/Miscellaneous_Operations.html#(def._((lib._graphics/graphics..rkt)._viewport-dc))",[0,[2,"viewport-dc"]],["graphics/graphics"]],
["viewport-flush-input",">graphics/Flushing.html#(def._((lib._graphics/graphics..rkt)._viewport-flush-input))",[0,[2,"viewport-flush-input"]],["graphics/graphics"]],
["viewport?",">graphics/Basic_Commands.html#(def._((lib._graphics/graphics..rkt)._viewport~3f))",[0,[2,"viewport?"]],["graphics/graphics"]],
["viewports",">graphics/Draw__Clear__and_Flip_Operations.html#(part._.Viewports)","Viewports",false],
["vim",">guide/Vim.html","Vim",false],
["violation",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._violation))",[0,[2,"violation"]],["deinprogramm/DMdA-advanced"]],
["violation",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._violation))",[0,[2,"violation"]],["deinprogramm/DMdA-assignments"]],
["violation",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._violation))",[0,[2,"violation"]],["deinprogramm/DMdA-beginner"]],
["violation",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._violation))",[0,[2,"violation"]],["deinprogramm/DMdA-vanilla"]],
["violation?",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_436",[0,[2,"violation?"]],["rnrs/conditions-6"]],
["virtual connection",">db/connect.html#(tech._virtual._connection)","<span style=\"font-style: italic\">virtual connection</span>",false],
["virtual connections",">db/connect.html#(part._.Virtual_.Connections)","Virtual Connections",false],
["virtual hosts",">web-server-internal/dispatch-host.html","Virtual Hosts",false],
["virtual statement",">db/query-api.html#(tech._virtual._statement)","<span style=\"font-style: italic\">virtual statement</span>",false],
["virtual-connection",">db/connect.html#(def._((lib._db/base..rkt)._virtual-connection))",[0,[2,"virtual-connection"]],["db","db/base"]],
["virtual-host-table",">web-server-internal/Web_Servers.html#(idx._(gentag._5._(lib._web-server/scribblings/web-server-internal..scrbl)))","virtual-host-table",false],
["virtual-hosts",">web-server-internal/Web_Servers.html#(sig-val._web-config._((lib._web-server/web-config-sig..rkt)._web-config~5e._virtual-hosts))",[0,[2,"virtual-hosts"]],["web-server/web-config-sig"]],
["virtual-statement",">db/query-api.html#(def._((lib._db/base..rkt)._virtual-statement))",[0,[2,"virtual-statement"]],["db","db/base"]],
["virtual-statement?",">db/query-api.html#(def._((lib._db/base..rkt)._virtual-statement~3f))",[0,[2,"virtual-statement?"]],["db","db/base"]],
["visible-matrix%",">mrlib/Matrix_Snip.html#(def._((lib._mrlib/matrix-snip..rkt)._visible-matrix~25))",[0,[2,"visible-matrix%"]],["mrlib/matrix-snip"]],
["visits",">reference/syntax-model.html#(tech._visit)","<span style=\"font-style: italic\">visits</span>",false],
["visualize-futures",">reference/futures-visualizer.html#(form._((lib._future-visualizer/main..rkt)._visualize-futures))",[0,"visualize-futures"],["future-visualizer"]],
["visualize-futures-thunk",">reference/futures-visualizer.html#(def._((lib._future-visualizer/main..rkt)._visualize-futures-thunk))",[0,"visualize-futures-thunk"],["future-visualizer"]],
["vl-append",">slideshow/Pict_Combiners.html#(def._((lib._slideshow/pict..rkt)._vl-append))",[0,[2,"vl-append"]],["slideshow/pict","slideshow"]],
["vline",">slideshow/Basic_Pict_Constructors.html#(def._((lib._slideshow/pict..rkt)._vline))",[0,[2,"vline"]],["slideshow/pict","slideshow"]],
["vline%",">embedded-gui/vline_.html",[0,[2,"vline%"]],["embedded-gui"]],
["vmag",">plot/utils.html#(def._((lib._plot/utils..rkt)._vmag))",[0,[2,"vmag"]],["plot/utils"]],
["vmag^2",">plot/utils.html#(def._((lib._plot/utils..rkt)._vmag~5e2))",[0,[2,"vmag^2"]],["plot/utils"]],
["vneg",">plot/utils.html#(def._((lib._plot/utils..rkt)._vneg))",[0,[2,"vneg"]],["plot/utils"]],
["vnormalize",">plot/utils.html#(def._((lib._plot/utils..rkt)._vnormalize))",[0,[2,"vnormalize"]],["plot/utils"]],
["void",">reference/void.html#(def._((quote._~23~25kernel)._void))",[0,[2,"void"]],["racket/base","racket"]],
["void",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._void))",[0,[2,"void"]],["lang/htdp-advanced"]],
["void",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Void))",[0,[1,"Void"]],["typed/racket/base","typed/racket"]],
["void and undefined",">guide/void_undefined.html","Void and Undefined",false],
["void and undefined",">reference/void.html","Void and Undefined",false],
["void-const",">scribble/Miscellaneous.html#(def._((lib._scribble/manual..rkt)._void-const))",[0,[2,"void-const"]],["scribble/manual"]],
["void?",">reference/void.html#(def._((quote._~23~25kernel)._void~3f))",[0,[2,"void?"]],["racket/base","racket"]],
["void?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._void~3f))",[0,[2,"void?"]],["lang/htdp-advanced"]],
["vr-append",">slideshow/Pict_Combiners.html#(def._((lib._slideshow/pict..rkt)._vr-append))",[0,[2,"vr-append"]],["slideshow/pict","slideshow"]],
["vrational?",">plot/utils.html#(def._((lib._plot/utils..rkt)._vrational~3f))",[0,[2,"vrational?"]],["plot/utils"]],
["vscroll",">gui/canvas_.html#(idx._(gentag._25._(lib._scribblings/gui/gui..scrbl)))",[7,"'vscroll"],false],
["vscroll",">gui/canvas_.html#(idx._(gentag._27._(lib._scribblings/gui/gui..scrbl)))",[7,"'vscroll"],false],
["w2s",">teachpack/2htdpuniverse.html#(tech._w2)","<span style=\"font-style: italic\">W2S</span>",false],
["wait",">gui/Windowing_Functions.html#(idx._(gentag._146._(lib._scribblings/gui/gui..scrbl)))",[7,"'wait"],false],
["wait-for-die",">reference/distributed-places.html#(meth._(((lib._racket/place/distributed..rkt)._place~25)._wait-for-die))",[[0,[2,"wait-for-die"]],[14,[" (method of ",[0,[2,"place%"]],")"]]],["racket/place/distributed"]],
["wait-for-io-to-complete",">tools/drracket_rep.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3arep~3atext~25)._wait-for-io-to-complete))",[[0,[2,"wait-for-io-to-complete"]],[14,[" (method of ",[0,[2,"drracket:rep:text%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["wait-for-io-to-complete/user",">tools/drracket_rep.html#(meth._(((lib._drracket/tool-lib..rkt)._drracket~3arep~3atext~25)._wait-for-io-to-complete/user))",[[0,[2,"wait-for-io-to-complete/user"]],[14,[" (method of ",[0,[2,"drracket:rep:text%"]],")"]]],["drracket/tool-lib","drscheme/tool-lib"]],
["wait-for-mouse-click",">teachpack/draw.html#(def._((lib._htdp/big-draw..rkt)._wait-for-mouse-click))",[0,[2,"wait-for-mouse-click"]],["htdp/draw"]],
["wall-block",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._wall-block))",[0,[2,"wall-block"]],["2htdp/planetcute"]],
["wall-block-tall",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._wall-block-tall))",[0,[2,"wall-block-tall"]],["2htdp/planetcute"]],
["warning! experimental!",">unstable/temp-c.html#(part._.Warning__.Experimental_)","Warning! Experimental!",false],
["warning?",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_418",[0,[2,"warning?"]],["rnrs/conditions-6"]],
["warnings",">drracket/prefs-explanation.html#(part._.Warnings)","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Warnings</span>",false],
["warp-pointer",">gui/canvas___.html#(meth._(((lib._mred/main..rkt)._canvas~3c~25~3e)._warp-pointer))",[[0,[2,"warp-pointer"]],[14,[" (method of ",[0,[2,"canvas<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["water-block",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._water-block))",[0,[2,"water-block"]],["2htdp/planetcute"]],
["weak",">mzscheme/Old_Functions.html#(idx._(gentag._0._(lib._mzscheme/mzscheme..scrbl)))",[7,"'weak"],false],
["weak box",">reference/weakbox.html#(tech._weak._box)","<span style=\"font-style: italic\">weak box</span>",false],
["weak boxes",">reference/weakbox.html","Weak Boxes",false],
["weak references",">reference/eval-model.html#(tech._weak._reference)","<span style=\"font-style: italic\">weak references</span>",false],
["weak-box-value",">reference/weakbox.html#(def._((quote._~23~25kernel)._weak-box-value))",[0,[2,"weak-box-value"]],["racket/base","racket"]],
["weak-box?",">reference/weakbox.html#(def._((quote._~23~25kernel)._weak-box~3f))",[0,[2,"weak-box?"]],["racket/base","racket"]],
["web application exports",">plai/web.html#(part._.Web_.Application_.Exports)","Web Application Exports",false],
["web application scheme",">plai/web.html","Web Application Scheme",false],
["web applications in racket",">web-server/index.html","Web Applications in Racket",false],
["web cells",">web-server/servlet.html#(part._web-cells)","Web Cells",false],
["web interaction",">web-server/servlet.html#(part._web)","Web Interaction",false],
["web server configuration table",">web-server-internal/Web_Servers.html#(idx._(gentag._0._(lib._web-server/scribblings/web-server-internal..scrbl)))","Web Server configuration table",false],
["web server: http server",">web-server-internal/index.html","Web Server: HTTP Server",false],
["web servers",">web-server-internal/Web_Servers.html","Web Servers",false],
["web-cell-ref",">web-server/stateless.html#(def._((lib._web-server/lang/web-cells..rkt)._web-cell-ref))",[0,[2,"web-cell-ref"]],["web-server/lang/web-cells"]],
["web-cell-ref",">web-server/servlet.html#(def._((lib._web-server/servlet/web-cells..rkt)._web-cell-ref))",[0,[2,"web-cell-ref"]],["web-server/servlet/web-cells"]],
["web-cell-shadow",">web-server/stateless.html#(def._((lib._web-server/lang/web-cells..rkt)._web-cell-shadow))",[0,[2,"web-cell-shadow"]],["web-server/lang/web-cells"]],
["web-cell-shadow",">web-server/servlet.html#(def._((lib._web-server/servlet/web-cells..rkt)._web-cell-shadow))",[0,[2,"web-cell-shadow"]],["web-server/servlet/web-cells"]],
["web-cell?",">web-server/stateless.html#(def._((lib._web-server/lang/web-cells..rkt)._web-cell~3f))",[0,[2,"web-cell?"]],["web-server/lang/web-cells"]],
["web-cell?",">web-server/servlet.html#(def._((lib._web-server/servlet/web-cells..rkt)._web-cell~3f))",[0,[2,"web-cell?"]],["web-server/servlet/web-cells"]],
["web-config^",">web-server-internal/Web_Servers.html#(form._web-config._((lib._web-server/web-config-sig..rkt)._web-config~5e))",[0,[1,"web-config^"]],["web-server/web-config-sig"]],
["web-parameter?",">web-server/stateless.html#(def._((lib._web-server/lang/web-param..rkt)._web-parameter~3f))",[0,[2,"web-parameter?"]],["web-server/lang/web-param"]],
["web-parameterize",">web-server/stateless.html#(form._((lib._web-server/lang/web-param..rkt)._web-parameterize))",[0,[1,"web-parameterize"]],["web-server/lang/web-param"]],
["web-server",">web-server/stateless.html",[9,[0,"web-server"]],"module"],
["web-server/base",">web-server/stateless.html",[9,[0,"web-server/base"]],"module"],
["web-server/configuration/configuration-table",">web-server-internal/Web_Servers.html#(mod-path._web-server/configuration/configuration-table)",[9,[0,"web-server/configuration/configuration-table"]],"module"],
["web-server/configuration/configuration-table-structs",">web-server-internal/Web_Servers.html#(mod-path._web-server/configuration/configuration-table-structs)",[9,[0,"web-server/configuration/configuration-table-structs"]],"module"],
["web-server/configuration/namespace",">web-server-internal/dispatch-servlets.html#(mod-path._web-server/configuration/namespace)",[9,[0,"web-server/configuration/namespace"]],"module"],
["web-server/configuration/responders",">web-server-internal/Web_Servers.html#(mod-path._web-server/configuration/responders)",[9,[0,"web-server/configuration/responders"]],"module"],
["web-server/dispatch",">web-server/dispatch.html",[9,[0,"web-server/dispatch"]],"module"],
["web-server/dispatch/extend",">web-server/dispatch.html#(mod-path._web-server/dispatch/extend)",[9,[0,"web-server/dispatch/extend"]],"module"],
["web-server/dispatchers/dispatch",">web-server-internal/dispatch.html",[9,[0,"web-server/dispatchers/dispatch"]],"module"],
["web-server/dispatchers/dispatch-files",">web-server-internal/dispatch-files.html",[9,[0,"web-server/dispatchers/dispatch-files"]],"module"],
["web-server/dispatchers/dispatch-filter",">web-server-internal/dispatch-filter.html",[9,[0,"web-server/dispatchers/dispatch-filter"]],"module"],
["web-server/dispatchers/dispatch-host",">web-server-internal/dispatch-host.html",[9,[0,"web-server/dispatchers/dispatch-host"]],"module"],
["web-server/dispatchers/dispatch-lift",">web-server-internal/dispatch-lift.html",[9,[0,"web-server/dispatchers/dispatch-lift"]],"module"],
["web-server/dispatchers/dispatch-log",">web-server-internal/dispatch-log.html",[9,[0,"web-server/dispatchers/dispatch-log"]],"module"],
["web-server/dispatchers/dispatch-passwords",">web-server-internal/dispatch-passwords.html",[9,[0,"web-server/dispatchers/dispatch-passwords"]],"module"],
["web-server/dispatchers/dispatch-pathprocedure",">web-server-internal/dispatch-pathprocedure.html",[9,[0,"web-server/dispatchers/dispatch-pathprocedure"]],"module"],
["web-server/dispatchers/dispatch-sequencer",">web-server-internal/dispatch-sequencer.html",[9,[0,"web-server/dispatchers/dispatch-sequencer"]],"module"],
["web-server/dispatchers/dispatch-servlets",">web-server-internal/dispatch-servlets.html",[9,[0,"web-server/dispatchers/dispatch-servlets"]],"module"],
["web-server/dispatchers/dispatch-stat",">web-server-internal/dispatch-stat.html",[9,[0,"web-server/dispatchers/dispatch-stat"]],"module"],
["web-server/dispatchers/dispatch-timeout",">web-server-internal/dispatch-timeout.html",[9,[0,"web-server/dispatchers/dispatch-timeout"]],"module"],
["web-server/dispatchers/filesystem-map",">web-server-internal/filesystem-map.html",[9,[0,"web-server/dispatchers/filesystem-map"]],"module"],
["web-server/dispatchers/limit",">web-server-internal/limit.html",[9,[0,"web-server/dispatchers/limit"]],"module"],
["web-server/formlets",">web-server/formlets.html",[9,[0,"web-server/formlets"]],"module"],
["web-server/formlets/dyn-syntax",">web-server/formlets.html#(mod-path._web-server/formlets/dyn-syntax)",[9,[0,"web-server/formlets/dyn-syntax"]],"module"],
["web-server/formlets/input",">web-server/formlets.html#(mod-path._web-server/formlets/input)",[9,[0,"web-server/formlets/input"]],"module"],
["web-server/formlets/lib",">web-server/formlets.html#(mod-path._web-server/formlets/lib)",[9,[0,"web-server/formlets/lib"]],"module"],
["web-server/formlets/servlet",">web-server/formlets.html#(mod-path._web-server/formlets/servlet)",[9,[0,"web-server/formlets/servlet"]],"module"],
["web-server/formlets/syntax",">web-server/formlets.html#(mod-path._web-server/formlets/syntax)",[9,[0,"web-server/formlets/syntax"]],"module"],
["web-server/http",">web-server/http.html",[9,[0,"web-server/http"]],"module"],
["web-server/http/basic-auth",">web-server/http.html#(mod-path._web-server/http/basic-auth)",[9,[0,"web-server/http/basic-auth"]],"module"],
["web-server/http/bindings",">web-server/http.html#(mod-path._web-server/http/bindings)",[9,[0,"web-server/http/bindings"]],"module"],
["web-server/http/cookie",">web-server/http.html#(mod-path._web-server/http/cookie)",[9,[0,"web-server/http/cookie"]],"module"],
["web-server/http/cookie-parse",">web-server/http.html#(mod-path._web-server/http/cookie-parse)",[9,[0,"web-server/http/cookie-parse"]],"module"],
["web-server/http/digest-auth",">web-server/http.html#(mod-path._web-server/http/digest-auth)",[9,[0,"web-server/http/digest-auth"]],"module"],
["web-server/http/redirect",">web-server/http.html#(mod-path._web-server/http/redirect)",[9,[0,"web-server/http/redirect"]],"module"],
["web-server/http/request-structs",">web-server/http.html#(mod-path._web-server/http/request-structs)",[9,[0,"web-server/http/request-structs"]],"module"],
["web-server/http/response-structs",">web-server/http.html#(mod-path._web-server/http/response-structs)",[9,[0,"web-server/http/response-structs"]],"module"],
["web-server/http/xexpr",">web-server/http.html#(mod-path._web-server/http/xexpr)",[9,[0,"web-server/http/xexpr"]],"module"],
["web-server/insta",">web-server/run.html#(mod-path._web-server/insta)",[9,[0,"web-server/insta"]],"module"],
["web-server/lang/abort-resume",">web-server/stateless.html#(mod-path._web-server/lang/abort-resume)",[9,[0,"web-server/lang/abort-resume"]],"module"],
["web-server/lang/file-box",">web-server/stateless.html#(mod-path._web-server/lang/file-box)",[9,[0,"web-server/lang/file-box"]],"module"],
["web-server/lang/native",">web-server/stateless.html#(mod-path._web-server/lang/native)",[9,[0,"web-server/lang/native"]],"module"],
["web-server/lang/serial-lambda",">web-server-internal/closure.html",[9,[0,"web-server/lang/serial-lambda"]],"module"],
["web-server/lang/soft",">web-server/stateless.html#(mod-path._web-server/lang/soft)",[9,[0,"web-server/lang/soft"]],"module"],
["web-server/lang/stuff-url",">web-server/stateless.html#(mod-path._web-server/lang/stuff-url)",[9,[0,"web-server/lang/stuff-url"]],"module"],
["web-server/lang/web",">web-server/stateless.html#(mod-path._web-server/lang/web)",[9,[0,"web-server/lang/web"]],"module"],
["web-server/lang/web-cells",">web-server/stateless.html#(mod-path._web-server/lang/web-cells)",[9,[0,"web-server/lang/web-cells"]],"module"],
["web-server/lang/web-param",">web-server/stateless.html#(mod-path._web-server/lang/web-param)",[9,[0,"web-server/lang/web-param"]],"module"],
["web-server/managers/lru",">web-server/servlet.html#(mod-path._web-server/managers/lru)",[9,[0,"web-server/managers/lru"]],"module"],
["web-server/managers/manager",">web-server/servlet.html#(mod-path._web-server/managers/manager)",[9,[0,"web-server/managers/manager"]],"module"],
["web-server/managers/none",">web-server/servlet.html#(mod-path._web-server/managers/none)",[9,[0,"web-server/managers/none"]],"module"],
["web-server/managers/timeouts",">web-server/servlet.html#(mod-path._web-server/managers/timeouts)",[9,[0,"web-server/managers/timeouts"]],"module"],
["web-server/page",">web-server/page.html",[9,[0,"web-server/page"]],"module"],
["web-server/private/cache-table",">web-server-internal/cache-table.html",[9,[0,"web-server/private/cache-table"]],"module"],
["web-server/private/connection-manager",">web-server-internal/connection-manager.html",[9,[0,"web-server/private/connection-manager"]],"module"],
["web-server/private/define-closure",">web-server-internal/closure.html#(mod-path._web-server/private/define-closure)",[9,[0,"web-server/private/define-closure"]],"module"],
["web-server/private/dispatch-server-sig",">web-server-internal/dispatch-server-unit.html#(mod-path._web-server/private/dispatch-server-sig)",[9,[0,"web-server/private/dispatch-server-sig"]],"module"],
["web-server/private/dispatch-server-unit",">web-server-internal/dispatch-server-unit.html#(mod-path._web-server/private/dispatch-server-unit)",[9,[0,"web-server/private/dispatch-server-unit"]],"module"],
["web-server/private/gzip",">web-server-internal/gzip.html",[9,[0,"web-server/private/gzip"]],"module"],
["web-server/private/mime-types",">web-server-internal/mime-types.html",[9,[0,"web-server/private/mime-types"]],"module"],
["web-server/private/mod-map",">web-server-internal/mod-map.html",[9,[0,"web-server/private/mod-map"]],"module"],
["web-server/private/servlet",">web-server-internal/dispatch-servlets.html#(mod-path._web-server/private/servlet)",[9,[0,"web-server/private/servlet"]],"module"],
["web-server/private/timer",">web-server-internal/timer.html",[9,[0,"web-server/private/timer"]],"module"],
["web-server/private/url-param",">web-server-internal/url-param.html",[9,[0,"web-server/private/url-param"]],"module"],
["web-server/private/util",">web-server-internal/misc-util.html",[9,[0,"web-server/private/util"]],"module"],
["web-server/servlet",">web-server/servlet.html",[9,[0,"web-server/servlet"]],"module"],
["web-server/servlet-dispatch",">web-server-internal/web-server.html#(mod-path._web-server/servlet-dispatch)",[9,[0,"web-server/servlet-dispatch"]],"module"],
["web-server/servlet-env",">web-server/run.html#(mod-path._web-server/servlet-env)",[9,[0,"web-server/servlet-env"]],"module"],
["web-server/servlet/servlet-structs",">web-server/servlet.html#(mod-path._web-server/servlet/servlet-structs)",[9,[0,"web-server/servlet/servlet-structs"]],"module"],
["web-server/servlet/setup",">web-server-internal/dispatch-servlets.html#(mod-path._web-server/servlet/setup)",[9,[0,"web-server/servlet/setup"]],"module"],
["web-server/servlet/web",">web-server/servlet.html#(mod-path._web-server/servlet/web)",[9,[0,"web-server/servlet/web"]],"module"],
["web-server/servlet/web-cells",">web-server/servlet.html#(mod-path._web-server/servlet/web-cells)",[9,[0,"web-server/servlet/web-cells"]],"module"],
["web-server/stuffers",">web-server/stateless.html#(mod-path._web-server/stuffers)",[9,[0,"web-server/stuffers"]],"module"],
["web-server/stuffers/base64",">web-server/stateless.html#(mod-path._web-server/stuffers/base64)",[9,[0,"web-server/stuffers/base64"]],"module"],
["web-server/stuffers/gzip",">web-server/stateless.html#(mod-path._web-server/stuffers/gzip)",[9,[0,"web-server/stuffers/gzip"]],"module"],
["web-server/stuffers/hash",">web-server/stateless.html#(mod-path._web-server/stuffers/hash)",[9,[0,"web-server/stuffers/hash"]],"module"],
["web-server/stuffers/hmac-sha1",">web-server/stateless.html#(mod-path._web-server/stuffers/hmac-sha1)",[9,[0,"web-server/stuffers/hmac-sha1"]],"module"],
["web-server/stuffers/serialize",">web-server/stateless.html#(mod-path._web-server/stuffers/serialize)",[9,[0,"web-server/stuffers/serialize"]],"module"],
["web-server/stuffers/store",">web-server/stateless.html#(mod-path._web-server/stuffers/store)",[9,[0,"web-server/stuffers/store"]],"module"],
["web-server/stuffers/stuffer",">web-server/stateless.html#(mod-path._web-server/stuffers/stuffer)",[9,[0,"web-server/stuffers/stuffer"]],"module"],
["web-server/templates",">web-server/templates.html",[9,[0,"web-server/templates"]],"module"],
["web-server/test",">web-server/test.html",[9,[0,"web-server/test"]],"module"],
["web-server/web-config-sig",">web-server-internal/Web_Servers.html#(mod-path._web-config._web-server/web-config-sig)",[9,[0,"web-server/web-config-sig"]],"module"],
["web-server/web-config-unit",">web-server-internal/Web_Servers.html#(mod-path._web-config._web-server/web-config-unit)",[9,[0,"web-server/web-config-unit"]],"module"],
["web-server/web-server",">web-server-internal/web-server.html",[9,[0,"web-server/web-server"]],"module"],
["web-server/web-server-sig",">web-server-internal/Web_Servers.html#(mod-path._web-server/web-server-sig)",[9,[0,"web-server/web-server-sig"]],"module"],
["web-server/web-server-unit",">web-server-internal/Web_Servers.html#(mod-path._web-server/web-server-unit)",[9,[0,"web-server/web-server-unit"]],"module"],
["web-server@",">web-server-internal/Web_Servers.html#(def._((lib._web-server/web-server-unit..rkt)._web-server~40))",[0,[2,"web-server@"]],["web-server/web-server-unit"]],
["web-server^",">web-server-internal/Web_Servers.html#(form._((lib._web-server/web-server-sig..rkt)._web-server~5e))",[0,[1,"web-server^"]],["web-server/web-server-sig"]],
["websocket",">net/websocket.html","WebSocket",false],
["welcome to racket",">guide/intro.html","Welcome to Racket",false],
["well-formed-set?",">mzlib/mzlib_integer-set.html#(def._((lib._mzlib/integer-set..rkt)._well-formed-set~3f))",[0,[2,"well-formed-set?"]],["mzlib/integer-set"]],
["welt",">deinprogramm/world.html#(tech._welt)","<span style=\"font-style: italic\">Welt</span>",false],
["what is an icon?",">images/Icons.html#(part._.What_is_an_icon_)","What is an icon?",false],
["what is the stepper?",">stepper/index.html#(part._.What_is_the_.Stepper_)","What is the Stepper?",false],
["what special considerations are there for security with the web server?",">web-server/faq.html#(part._.What_special_considerations_are_there_for_security_with_the_.Web_.Server_)","What special considerations are there for security with the Web Server?",false],
["wheel on mouse",">gui/key-event_.html#(idx._(gentag._107._(lib._scribblings/gui/gui..scrbl)))","wheel on mouse",false],
["wheel on mouse",">gui/editor-canvas_.html#(idx._(gentag._209._(lib._scribblings/gui/gui..scrbl)))","wheel on mouse",false],
["wheel-down",">gui/key-event_.html#(idx._(gentag._108._(lib._scribblings/gui/gui..scrbl)))",[7,"'wheel-down"],false],
["wheel-down",">gui/windowing-overview.html#(idx._(gentag._6._(lib._scribblings/gui/gui..scrbl)))",[7,"'wheel-down"],false],
["wheel-left",">gui/key-event_.html#(idx._(gentag._109._(lib._scribblings/gui/gui..scrbl)))",[7,"'wheel-left"],false],
["wheel-right",">gui/key-event_.html#(idx._(gentag._110._(lib._scribblings/gui/gui..scrbl)))",[7,"'wheel-right"],false],
["wheel-step",">gui/editor-canvas_.html#(meth._(((lib._mred/main..rkt)._editor-canvas~25)._wheel-step))",[[0,[2,"wheel-step"]],[14,[" (method of ",[0,[2,"editor-canvas%"]],")"]]],["racket/gui/base","racket/gui"]],
["wheel-up",">gui/key-event_.html#(idx._(gentag._106._(lib._scribblings/gui/gui..scrbl)))",[7,"'wheel-up"],false],
["wheel-up",">gui/windowing-overview.html#(idx._(gentag._5._(lib._scribblings/gui/gui..scrbl)))",[7,"'wheel-up"],false],
["when",">reference/when_unless.html#(form._((lib._racket/private/letstx-scheme..rkt)._when))",[0,[1,"when"]],["racket/base","racket"]],
["when",">r6rs-lib-std/r6rs-lib-Z-H-6.html#node_idx_254",[0,[1,"when"]],["rnrs/control-6"]],
["when",">htdp-langs/advanced.html#(form._((lib._lang/htdp-advanced..rkt)._when))",[0,[1,"when"]],["lang/htdp-advanced"]],
["when",">lazy/index.html#(form._((lib._lazy/main..rkt)._when))",[0,[1,"when"]],["lazy"]],
["when-e",">frtime/index.html#(def._((lib._frtime/main..rkt)._when-e))",[0,[2,"when-e"]],["frtime"]],
["where clause",">redex/The_Redex_Reference.html#(tech._where._clause)","<span style=\"font-style: italic\"><span class=\"RktSym\">where</span> clause</span>",false],
["where to go from here",">more/index.html#(part._.Where_to_.Go_.From_.Here)","Where to Go From Here",false],
["where to go from here",">quick/index.html#(part._.Where_to_.Go_.From_.Here)","Where to Go From Here",false],
["where/hidden clause",">redex/The_Redex_Reference.html#(idx._(gentag._20._(lib._redex/redex..scrbl)))",[[16,"where/hidden"]," clause"],false],
["while-unlocked",">framework/Text.html#(meth._(((lib._framework/main..rkt)._text~3afile~3c~25~3e)._while-unlocked))",[[0,[2,"while-unlocked"]],[14,[" (method of ",[0,[2,"text:file<%>"]],")"]]],["framework"]],
["white",">unstable/pict.html#(def._((lib._unstable/gui/pict..rkt)._white))",[0,[2,"white"]],["unstable/gui/pict"]],
["white-bracket-sizing",">redex/The_Redex_Reference.html#(def._((lib._redex/pict..rkt)._white-bracket-sizing))",[0,[2,"white-bracket-sizing"]],["redex/pict","redex"]],
["whitespace",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex..rkt)._whitespace))",[0,[1,"whitespace"]],["parser-tools/lex"]],
["whitespace?",">scribble/decode.html#(def._((lib._scribble/decode..rkt)._whitespace~3f))",[0,[2,"whitespace?"]],["scribble/decode"]],
["who-condition?",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_456",[0,[2,"who-condition?"]],["rnrs/conditions-6"]],
["whole-module signatures and units",">guide/Whole-module_Signatures_and_Units.html",["Whole-",[0,[1,"module"]]," Signatures and Units"],false],
["whole/fractional-exact-numbers",">mzlib/mzlib_pconvert.html#(def._((lib._mzlib/pconvert..rkt)._whole/fractional-exact-numbers))",[0,[2,"whole/fractional-exact-numbers"]],["mzlib/pconvert"]],
["why are my stateful servlets not updating on the server when i change the file on disk?",">web-server/faq.html#(part._update-servlets)","Why are my stateful servlets not updating on the server when I change the file on disk?",false],
["why are my templates not updating on the server when i change the file on disk?",">web-server/faq.html#(part._.Why_are_my_templates_not_updating_on_the_server_when_.I_change_the_file_on_disk_)","Why are my templates not updating on the server when I change the file on disk?",false],
["why are templates compiled into programs?",">web-server/faq.html#(part._.Why_are_templates_compiled_into_programs_)","Why are templates compiled into programs?",false],
["why is my servlet failing with a can-be-response? contract violation after updating racket?",">web-server/faq.html#(part._.Why_is_my_servlet_failing_with_a_can-be-response__contract_violation_after_updating_.Racket_)",["Why is my servlet failing with a ",[0,"can-be-response?"]," contract violation after updating Racket?"],false],
["why this is useful",">web-server-internal/dispatch-servlets.html#(part._.Why_this_is_useful)","Why this is useful",false],
["width-depends-on-x",">gui/snip_.html#(idx._(gentag._167._(lib._scribblings/gui/gui..scrbl)))",[7,"'width-depends-on-x"],false],
["width-depends-on-y",">gui/snip_.html#(idx._(gentag._169._(lib._scribblings/gui/gui..scrbl)))",[7,"'width-depends-on-y"],false],
["will",">reference/willexecutor.html#(tech._will)","<span style=\"font-style: italic\">will</span>",false],
["will executor",">reference/willexecutor.html#(tech._will._executor)","<span style=\"font-style: italic\">will executor</span>",false],
["will-execute",">reference/willexecutor.html#(def._((quote._~23~25kernel)._will-execute))",[0,[2,"will-execute"]],["racket/base","racket"]],
["will-executor",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Will-.Executor))",[0,[1,"Will-Executor"]],["typed/racket/base","typed/racket"]],
["will-executor?",">reference/willexecutor.html#(def._((quote._~23~25kernel)._will-executor~3f))",[0,[2,"will-executor?"]],["racket/base","racket"]],
["will-register",">reference/willexecutor.html#(def._((quote._~23~25kernel)._will-register))",[0,[2,"will-register"]],["racket/base","racket"]],
["will-try-execute",">reference/willexecutor.html#(def._((quote._~23~25kernel)._will-try-execute))",[0,[2,"will-try-execute"]],["racket/base","racket"]],
["wills and executors",">reference/willexecutor.html","Wills and Executors",false],
["win64?",">foreign/winapi.html#(def._((lib._ffi/winapi..rkt)._win64~3f))",[0,[2,"win64?"]],["ffi/winapi"]],
["winapi",">foreign/winapi.html#(def._((lib._ffi/winapi..rkt)._winapi))",[0,[2,"winapi"]],["ffi/winapi"]],
["window",">teachpack/gui.html#(tech._window)","<span style=\"font-style: italic\">Window</span>",false],
["window manager (unix only)",">framework/Test.html#(part._.Window_.Manager__.Unix_only_)","Window Manager (Unix only)",false],
["window-tall",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._window-tall))",[0,[2,"window-tall"]],["2htdp/planetcute"]],
["window<%>",">gui/window___.html",[0,[2,"window<%>"]],["racket/gui/base","racket/gui"]],
["window?",">teachpack/gui.html#(def._((lib._htdp/gui..rkt)._window~3f))",[0,[2,"window?"]],["htdp/gui"]],
["windowing",">gui/windowing-overview.html","Windowing",false],
["windowing classes",">gui/Windowing_Classes.html","Windowing Classes",false],
["windowing functions",">gui/Windowing_Functions.html","Windowing Functions",false],
["windowing toolbox",">gui/index.html#(tech._windowing._toolbox)","<span style=\"font-style: italic\">windowing toolbox</span>",false],
["windows",">drracket/Menus.html#(part._.Windows)","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Windows</span>",false],
["windows",">reference/Manipulating_Paths.html#(idx._(gentag._235._(lib._scribblings/reference/reference..scrbl)))",[7,"'windows"],false],
["windows",">reference/runtime.html#(idx._(gentag._325._(lib._scribblings/reference/reference..scrbl)))",[7,"'windows"],false],
["windows",">gui/windowing-overview.html#(tech._window)","<span style=\"font-style: italic\">windows</span>",false],
["windows api helpers",">foreign/winapi.html","Windows API Helpers",false],
["windows batch files",">guide/scripts.html#(part._.Windows_.Batch_.Files)","Windows Batch Files",false],
["windows menu",">framework/Frame.html#(idx._(gentag._3._(lib._scribblings/framework/framework..scrbl)))","Windows menu",false],
["windows path conventions",">reference/windowspaths.html","Windows Path Conventions",false],
["windows registry",">file/resource.html","Windows Registry",false],
["windows-error",">foreign/com-intf.html#(def._((lib._ffi/unsafe/com..rkt)._windows-error))",[0,[2,"windows-error"]],["ffi/unsafe/com"]],
["wire-based connections",">db/connect.html#(tech._wire._based._connection)","<span style=\"font-style: italic\">wire-based connections</span>",false],
["with",">redex/The_Redex_Reference.html#(form._((lib._redex/reduction-semantics..rkt)._with))",[0,[1,"with"]],["redex/reduction-semantics","redex"]],
["with-asserts",">ts-reference/Utilities.html#(form._((lib._typed-racket/base-env/prims..rkt)._with-asserts))",[0,[1,"with-asserts"]],["typed/racket/base","typed/racket"]],
["with-atomic-rewriter",">redex/The_Redex_Reference.html#(form._((lib._redex/pict..rkt)._with-atomic-rewriter))",[0,[1,"with-atomic-rewriter"]],["redex/pict","redex"]],
["with-attributes",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._with-attributes))",[0,[2,"with-attributes"]],["scribble/struct"]],
["with-attributes-assoc",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._with-attributes-assoc))",[0,[2,"with-attributes-assoc"]],["scribble/struct"]],
["with-attributes-style",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._with-attributes-style))",[0,[2,"with-attributes-style"]],["scribble/struct"]],
["with-attributes?",">scribble/Compatibility_Libraries.html#(def._((lib._scribble/struct..rkt)._with-attributes~3f))",[0,[2,"with-attributes?"]],["scribble/struct"]],
["with-check-info",">rackunit/api.html#(form._((lib._rackunit/main..rkt)._with-check-info))",[0,[1,"with-check-info"]],["rackunit"]],
["with-check-info*",">rackunit/api.html#(def._((lib._rackunit/main..rkt)._with-check-info*))",[0,[2,"with-check-info*"]],["rackunit"]],
["with-compile-output",">raco/make.html#(def._((lib._compiler/cm..rkt)._with-compile-output))",[0,[2,"with-compile-output"]],["compiler/cm"]],
["with-compound-rewriter",">redex/The_Redex_Reference.html#(form._((lib._redex/pict..rkt)._with-compound-rewriter))",[0,[1,"with-compound-rewriter"]],["redex/pict","redex"]],
["with-compound-rewriters",">redex/The_Redex_Reference.html#(form._((lib._redex/pict..rkt)._with-compound-rewriters))",[0,[1,"with-compound-rewriters"]],["redex/pict","redex"]],
["with-cont-mark",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._with-cont-mark))",[0,[2,"with-cont-mark"]],["compiler/zo-structs"]],
["with-cont-mark-body",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._with-cont-mark-body))",[0,[2,"with-cont-mark-body"]],["compiler/zo-structs"]],
["with-cont-mark-key",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._with-cont-mark-key))",[0,[2,"with-cont-mark-key"]],["compiler/zo-structs"]],
["with-cont-mark-val",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._with-cont-mark-val))",[0,[2,"with-cont-mark-val"]],["compiler/zo-structs"]],
["with-cont-mark?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._with-cont-mark~3f))",[0,[2,"with-cont-mark?"]],["compiler/zo-structs"]],
["with-continuation-mark",">reference/wcm.html#(form._((quote._~23~25kernel)._with-continuation-mark))",[0,[1,"with-continuation-mark"]],["racket/base","racket"]],
["with-contract",">reference/attaching-contracts-to-values.html#(form._((lib._racket/contract/region..rkt)._with-contract))",[0,[1,"with-contract"]],["racket/contract/region","racket/contract","racket"]],
["with-datum",">syntax/Datum_Pattern_Matching.html#(form._((lib._syntax/datum..rkt)._with-datum))",[0,[1,"with-datum"]],["syntax/datum"]],
["with-disappeared-uses",">reference/syntax-util.html#(form._((lib._racket/syntax..rkt)._with-disappeared-uses))",[0,[1,"with-disappeared-uses"]],["racket/syntax"]],
["with-errors-to-browser",">web-server/servlet.html#(def._((lib._web-server/servlet/web..rkt)._with-errors-to-browser))",[0,[2,"with-errors-to-browser"]],["web-server/servlet/web"]],
["with-exception-handler",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_368",[0,[2,"with-exception-handler"]],["rnrs/exceptions-6"]],
["with-exception-handler",">srfi-std/srfi-34.html#with-exception-handler",[0,[2,"with-exception-handler"]],["srfi/34"]],
["with-font",">unstable/Slideshow_Presentations.html#(form._((lib._unstable/gui/slideshow..rkt)._with-font))",[0,[1,"with-font"]],["unstable/gui/slideshow"]],
["with-gl-context",">gui/canvas_.html#(meth._(((lib._mred/main..rkt)._canvas~25)._with-gl-context))",[[0,[2,"with-gl-context"]],[14,[" (method of ",[0,[2,"canvas%"]],")"]]],["racket/gui/base","racket/gui"]],
["with-handlers",">reference/exns.html#(form._((lib._racket/private/more-scheme..rkt)._with-handlers))",[0,[1,"with-handlers"]],["racket/base","racket"]],
["with-handlers",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._with-handlers))",[0,[1,"with-handlers"]],["typed/racket/base","typed/racket"]],
["with-handlers*",">reference/exns.html#(form._((lib._racket/private/more-scheme..rkt)._with-handlers*))",[0,[1,"with-handlers*"]],["racket/base","racket"]],
["with-heap",">plai/collector.html#(form._((lib._plai/collector..rkt)._with-heap))",[0,[1,"with-heap"]],["plai/collector"]],
["with-input-from-bytes",">reference/port-lib.html#(def._((lib._racket/port..rkt)._with-input-from-bytes))",[0,[2,"with-input-from-bytes"]],["racket/port","racket"]],
["with-input-from-file",">reference/file-ports.html#(def._((lib._racket/private/base..rkt)._with-input-from-file))",[0,[2,"with-input-from-file"]],["racket/base","racket"]],
["with-input-from-file",">r5rs-std/r5rs-Z-H-9.html#%_idx_622",[0,[2,"with-input-from-file"]],["r5rs"]],
["with-input-from-file",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_796",[0,[2,"with-input-from-file"]],["rnrs/io/simple-6"]],
["with-input-from-file",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._with-input-from-file))",[0,[2,"with-input-from-file"]],["lang/htdp-advanced"]],
["with-input-from-file",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..rkt)._with-input-from-file))",[0,[2,"with-input-from-file"]],["mzscheme"]],
["with-input-from-file",">picturing-programs/index.html#(def._((lib._picturing-programs/private/io-stuff..rkt)._with-input-from-file))",[0,[2,"with-input-from-file"]],["picturing-programs/private/io-stuff","picturing-programs"]],
["with-input-from-string",">reference/port-lib.html#(def._((lib._racket/port..rkt)._with-input-from-string))",[0,[2,"with-input-from-string"]],["racket/port","racket"]],
["with-input-from-string",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._with-input-from-string))",[0,[2,"with-input-from-string"]],["lang/htdp-advanced"]],
["with-input-from-string",">picturing-programs/index.html#(def._((lib._picturing-programs/private/io-stuff..rkt)._with-input-from-string))",[0,[2,"with-input-from-string"]],["picturing-programs/private/io-stuff","picturing-programs"]],
["with-input-from-url",">picturing-programs/index.html#(def._((lib._picturing-programs/private/io-stuff..rkt)._with-input-from-url))",[0,[2,"with-input-from-url"]],["picturing-programs/private/io-stuff","picturing-programs"]],
["with-installer-window",">raco/_plt-archives.html#(def._((lib._setup/plt-installer..rkt)._with-installer-window))",[0,[2,"with-installer-window"]],["setup/plt-installer"]],
["with-intercepted-logging",">unstable/Logging.html#(def._((lib._unstable/logging..rkt)._with-intercepted-logging))",[0,[2,"with-intercepted-logging"]],["unstable/logging"]],
["with-io-strings",">picturing-programs/index.html#(def._((lib._picturing-programs/private/io-stuff..rkt)._with-io-strings))",[0,[2,"with-io-strings"]],["picturing-programs/private/io-stuff","picturing-programs"]],
["with-limits",">reference/Sandboxed_Evaluation.html#(form._((lib._racket/sandbox..rkt)._with-limits))",[0,[1,"with-limits"]],["racket/sandbox"]],
["with-logging-to-port",">unstable/Logging.html#(def._((lib._unstable/logging..rkt)._with-logging-to-port))",[0,[2,"with-logging-to-port"]],["unstable/logging"]],
["with-mark",">errortrace/stacktrace.html#(sig-val._((lib._errortrace/stacktrace..rkt)._stacktrace-imports~5e._with-mark))",[0,[2,"with-mark"]],["errortrace/stacktrace"]],
["with-method",">reference/ivaraccess.html#(form._((lib._racket/private/class-internal..rkt)._with-method))",[0,[1,"with-method"]],["racket/class","racket"]],
["with-module-reading-parameterization",">syntax/module-helpers.html#(def._((lib._syntax/modread..rkt)._with-module-reading-parameterization))",[0,[2,"with-module-reading-parameterization"]],["syntax/modread"]],
["with-monitor",">unstable/temp-c.html#(form._((lib._unstable/temp-c/dsl..rkt)._with-monitor))",[0,[1,"with-monitor"]],["unstable/temp-c/dsl"]],
["with-output-to-bytes",">reference/port-lib.html#(def._((lib._racket/port..rkt)._with-output-to-bytes))",[0,[2,"with-output-to-bytes"]],["racket/port","racket"]],
["with-output-to-file",">reference/file-ports.html#(def._((lib._racket/private/base..rkt)._with-output-to-file))",[0,[2,"with-output-to-file"]],["racket/base","racket"]],
["with-output-to-file",">r5rs-std/r5rs-Z-H-9.html#%_idx_624",[0,[2,"with-output-to-file"]],["r5rs"]],
["with-output-to-file",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_798",[0,[2,"with-output-to-file"]],["rnrs/io/simple-6"]],
["with-output-to-file",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._with-output-to-file))",[0,[2,"with-output-to-file"]],["lang/htdp-advanced"]],
["with-output-to-file",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..rkt)._with-output-to-file))",[0,[2,"with-output-to-file"]],["mzscheme"]],
["with-output-to-file",">picturing-programs/index.html#(def._((lib._picturing-programs/private/io-stuff..rkt)._with-output-to-file))",[0,[2,"with-output-to-file"]],["picturing-programs/private/io-stuff","picturing-programs"]],
["with-output-to-string",">reference/port-lib.html#(def._((lib._racket/port..rkt)._with-output-to-string))",[0,[2,"with-output-to-string"]],["racket/port","racket"]],
["with-output-to-string",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._with-output-to-string))",[0,[2,"with-output-to-string"]],["lang/htdp-advanced"]],
["with-output-to-string",">picturing-programs/index.html#(def._((lib._picturing-programs/private/io-stuff..rkt)._with-output-to-string))",[0,[2,"with-output-to-string"]],["picturing-programs/private/io-stuff","picturing-programs"]],
["with-pict-combine",">unstable/pict.html#(form._((lib._unstable/gui/pict..rkt)._with-pict-combine))",[0,[1,"with-pict-combine"]],["unstable/gui/pict"]],
["with-scale",">unstable/Slideshow_Presentations.html#(form._((lib._unstable/gui/slideshow..rkt)._with-scale))",[0,[1,"with-scale"]],["unstable/gui/slideshow"]],
["with-size",">unstable/Slideshow_Presentations.html#(form._((lib._unstable/gui/slideshow..rkt)._with-size))",[0,[1,"with-size"]],["unstable/gui/slideshow"]],
["with-steps",">slideshow/Pict-Staging_Helper.html#(form._((lib._slideshow/step..rkt)._with-steps))",[0,[1,"with-steps"]],["slideshow/step"]],
["with-steps~",">slideshow/Pict-Staging_Helper.html#(form._((lib._slideshow/step..rkt)._with-steps~7e))",[0,[1,"with-steps~"]],["slideshow/step"]],
["with-style",">unstable/Slideshow_Presentations.html#(form._((lib._unstable/gui/slideshow..rkt)._with-style))",[0,[1,"with-style"]],["unstable/gui/slideshow"]],
["with-syntax",">reference/stx-patterns.html#(form._((lib._racket/private/stxcase-scheme..rkt)._with-syntax))",[0,[1,"with-syntax"]],["racket/base","racket"]],
["with-syntax",">r6rs-lib-std/r6rs-lib-Z-H-13.html#node_idx_1152",[0,[1,"with-syntax"]],["rnrs/syntax-case-6"]],
["with-syntax and generate-temporaries",">guide/with-syntax.html",[[0,[1,"with-syntax"]]," and ",[0,[2,"generate-temporaries"]]],false],
["with-syntax*",">reference/syntax-util.html#(form._((lib._racket/syntax..rkt)._with-syntax*))",[0,[1,"with-syntax*"]],["racket/syntax"]],
["with-syntax*/debug",">unstable/Debugging.html#(form._((lib._unstable/debug..rkt)._with-syntax*/debug))",[0,[1,"with-syntax*/debug"]],["unstable/debug"]],
["with-syntax/debug",">unstable/Debugging.html#(form._((lib._unstable/debug..rkt)._with-syntax/debug))",[0,[1,"with-syntax/debug"]],["unstable/debug"]],
["with-type",">ts-reference/Typed_Regions.html#(form._((lib._typed-racket/typed-racket..rkt)._with-type))",[0,[1,"with-type"]],["typed/racket/base","typed/racket"]],
["with-unquote-rewriter",">redex/The_Redex_Reference.html#(form._((lib._redex/pict..rkt)._with-unquote-rewriter))",[0,[1,"with-unquote-rewriter"]],["redex/pict","redex"]],
["wkb->geometry",">db/util.html#(def._((lib._db/util/geometry..rkt)._wkb-~3egeometry))",[0,[2,"wkb->geometry"]],["db/util/geometry"]],
["wood-block",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._wood-block))",[0,[2,"wood-block"]],["2htdp/planetcute"]],
["words for describing code",">htdp/index.html#(part._.Words_.For_.Describing_.Code)","Words For Describing Code",false],
["words for describing runtime behavior",">htdp/index.html#(part._.Words_.For_.Describing_.Runtime_.Behavior)","Words For Describing Runtime Behavior",false],
["working with files and directories: \"dir.ss\"",">teachpack/dir.html",["Working with Files and Directories: ",[6,"\"dir.ss\""],"<a name=\"(idx._(gentag._11._(lib._teachpack/teachpack..scrbl)))\"></a>"],false],
["world",">deinprogramm/world.html#(def._((lib._deinprogramm/world..rkt)._world))",[0,"world"],["teachpack/deinprogramm/world"]],
["world",">teachpack/world.html#(tech._world)","<span style=\"font-style: italic\">World</span>",false],
["world",">teachpack/2htdpuniverse.html#(tech._world)","<span style=\"font-style: italic\">world</span>",false],
["world operations",">graphics/World_Operations.html","World Operations",false],
["world teachpack",">teachpack/world.html#(idx._(gentag._1._(lib._teachpack/teachpack..scrbl)))","world teachpack",false],
["world-teachpack",">deinprogramm/world.html#(idx._(gentag._3._(lib._deinprogramm/scribblings/deinprogramm..scrbl)))","world-Teachpack",false],
["worlds and messages",">teachpack/2htdpuniverse.html#(part._.Worlds_and_.Messages)","Worlds and Messages",false],
["worlds and the universe: \"universe.ss\"",">teachpack/2htdpuniverse.html",["Worlds and the Universe: ",[6,"\"universe.ss\""],"<a name=\"(idx._(gentag._22._(lib._teachpack/teachpack..scrbl)._2htdp))\"></a>"],false],
["worldstate",">teachpack/2htdpuniverse.html#(tech._worldstate)","<span style=\"font-style: italic\">WorldState</span>",false],
["would-be-future",">reference/futures.html#(def._((lib._racket/future..rkt)._would-be-future))",[0,[2,"would-be-future"]],["racket/future","racket"]],
["wrap",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._wrap))",[0,[2,"wrap"]],["compiler/zo-structs"]],
["wrap text menu item",">drracket/Menus.html#(idx._(gentag._79._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">Wrap Text</span> menu item",false],
["wrap-balloon",">slideshow/More_Pict_Constructors.html#(def._((lib._slideshow/balloon..rkt)._wrap-balloon))",[0,[2,"wrap-balloon"]],["slideshow/balloon"]],
["wrap-evt",">reference/sync.html#(def._((quote._~23~25kernel)._wrap-evt))",[0,[2,"wrap-evt"]],["racket/base","racket"]],
["wrap-expr/c",">unstable/wrapc.html#(def._((lib._unstable/wrapc..rkt)._wrap-expr/c))",[0,[2,"wrap-expr/c"]],["unstable/wrapc"]],
["wrap-read-all",">syntax/reader-helpers.html#(def._((lib._syntax/module-reader..rkt)._wrap-read-all))",[0,[2,"wrap-read-all"]],["syntax/module-reader"]],
["wrap?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._wrap~3f))",[0,[2,"wrap?"]],["compiler/zo-structs"]],
["wrapped",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._wrapped))",[0,[2,"wrapped"]],["compiler/zo-structs"]],
["wrapped-datum",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._wrapped-datum))",[0,[2,"wrapped-datum"]],["compiler/zo-structs"]],
["wrapped-tamper-status",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._wrapped-tamper-status))",[0,[2,"wrapped-tamper-status"]],["compiler/zo-structs"]],
["wrapped-wraps",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._wrapped-wraps))",[0,[2,"wrapped-wraps"]],["compiler/zo-structs"]],
["wrapped?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._wrapped~3f))",[0,[2,"wrapped?"]],["compiler/zo-structs"]],
["writable<%>",">reference/objectprinting.html#(def._((lib._racket/private/class-internal..rkt)._writable~3c~25~3e))",[0,[2,"writable<%>"]],["racket/class","racket"]],
["write",">reference/Writing.html#(def._((quote._~23~25kernel)._write))",[0,[2,"write"]],["racket/base","racket"]],
["write",">gui/editor-data_.html#(meth._(((lib._mred/main..rkt)._editor-data~25)._write))",[[0,[2,"write"]],[14,[" (method of ",[0,[2,"editor-data%"]],")"]]],["racket/gui/base","racket/gui"]],
["write",">gui/editor-stream-out-base_.html#(meth._(((lib._mred/main..rkt)._editor-stream-out-base~25)._write))",[[0,[2,"write"]],[14,[" (method of ",[0,[2,"editor-stream-out-base%"]],")"]]],["racket/gui/base","racket/gui"]],
["write",">gui/snip_.html#(meth._(((lib._racket/snip..rkt)._snip~25)._write))",[[0,[2,"write"]],[14,[" (method of ",[0,[2,"snip%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["write",">r5rs-std/r5rs-Z-H-9.html#%_idx_654",[0,[2,"write"]],["r5rs"]],
["write",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_832",[0,[2,"write"]],["rnrs/io/simple-6"]],
["write",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._write))",[0,[2,"write"]],["lang/htdp-advanced"]],
["write",">framework/Racket.html#(meth._(((lib._framework/main..rkt)._racket~3asexp-snip~25)._write))",[[0,[2,"write"]],[14,[" (method of ",[0,[2,"racket:sexp-snip%"]],")"]]],["framework"]],
["write",">lazy/index.html#(def._((lib._lazy/main..rkt)._write))",[0,[2,"write"]],["lazy"]],
["write",">reference/securityguards.html#(idx._(gentag._228._(lib._scribblings/reference/reference..scrbl)))",[7,"'write"],false],
["write",">drracket/interactions-window.html#(idx._(gentag._29._(lib._scribblings/drracket/drracket..scrbl)))",[0,[2,"write"]],false],
["write",">reference/Filesystem.html#(idx._(gentag._291._(lib._scribblings/reference/reference..scrbl)))",[7,"'write"],false],
["write output",">drracket/output-syntax.html#(idx._(gentag._51._(lib._scribblings/drracket/drracket..scrbl)))","<span style=\"font-family: sans-serif; font-size: 80%; font-weight: bold\">write</span> output",false],
["write your package",">planet/Developing_Packages_for_PLaneT.html#(part._.Write_.Your_.Package)","Write Your Package",false],
["write-animated-gif",">mrlib/GIF_and_Animated_GIF_Writing.html#(def._((lib._mrlib/gif..rkt)._write-animated-gif))",[0,[2,"write-animated-gif"]],["mrlib/gif"]],
["write-byte",">reference/Byte_and_String_Output.html#(def._((quote._~23~25kernel)._write-byte))",[0,[2,"write-byte"]],["racket/base","racket"]],
["write-bytes",">reference/Byte_and_String_Output.html#(def._((quote._~23~25kernel)._write-bytes))",[0,[2,"write-bytes"]],["racket/base","racket"]],
["write-bytes",">gui/editor-stream-out-base_.html#(meth._(((lib._mred/main..rkt)._editor-stream-out-base~25)._write-bytes))",[[0,[2,"write-bytes"]],[14,[" (method of ",[0,[2,"editor-stream-out-base%"]],")"]]],["racket/gui/base","racket/gui"]],
["write-bytes-avail",">reference/Byte_and_String_Output.html#(def._((quote._~23~25kernel)._write-bytes-avail))",[0,[2,"write-bytes-avail"]],["racket/base","racket"]],
["write-bytes-avail*",">reference/Byte_and_String_Output.html#(def._((quote._~23~25kernel)._write-bytes-avail*))",[0,[2,"write-bytes-avail*"]],["racket/base","racket"]],
["write-bytes-avail-evt",">reference/Byte_and_String_Output.html#(def._((quote._~23~25kernel)._write-bytes-avail-evt))",[0,[2,"write-bytes-avail-evt"]],["racket/base","racket"]],
["write-bytes-avail/enable-break",">reference/Byte_and_String_Output.html#(def._((quote._~23~25kernel)._write-bytes-avail/enable-break))",[0,[2,"write-bytes-avail/enable-break"]],["racket/base","racket"]],
["write-char",">reference/Byte_and_String_Output.html#(def._((quote._~23~25kernel)._write-char))",[0,[2,"write-char"]],["racket/base","racket"]],
["write-char",">r5rs-std/r5rs-Z-H-9.html#%_idx_666",[0,[2,"write-char"]],["r5rs"]],
["write-char",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_820",[0,[2,"write-char"]],["rnrs/io/simple-6"]],
["write-configuration-table",">web-server-internal/Web_Servers.html#(def._((lib._web-server/configuration/configuration-table..rkt)._write-configuration-table))",[0,[2,"write-configuration-table"]],["web-server/configuration/configuration-table"]],
["write-editor-global-footer",">gui/Editor_Functions.html#(def._((lib._mred/main..rkt)._write-editor-global-footer))",[0,[2,"write-editor-global-footer"]],["racket/gui/base","racket/gui"]],
["write-editor-global-header",">gui/Editor_Functions.html#(def._((lib._mred/main..rkt)._write-editor-global-header))",[0,[2,"write-editor-global-header"]],["racket/gui/base","racket/gui"]],
["write-editor-version",">gui/Editor_Functions.html#(def._((lib._mred/main..rkt)._write-editor-version))",[0,[2,"write-editor-version"]],["racket/gui/base","racket/gui"]],
["write-file",">teachpack/2htdpbatch-io.html#(def._((lib._2htdp/batch-io..rkt)._write-file))",[0,[2,"write-file"]],["2htdp/batch-io"]],
["write-file",">teachpack/docs.html#(def._((lib._htdp/docs..rkt)._write-file))",[0,[2,"write-file"]],["htdp/docs"]],
["write-flush",">reference/distributed-places.html#(def._((lib._racket/place/distributed..rkt)._write-flush))",[0,[2,"write-flush"]],["racket/place/distributed"]],
["write-footers-to-file",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._write-footers-to-file))",[[0,[2,"write-footers-to-file"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["write-gif",">mrlib/GIF_and_Animated_GIF_Writing.html#(def._((lib._mrlib/gif..rkt)._write-gif))",[0,[2,"write-gif"]],["mrlib/gif"]],
["write-header",">gui/snip-class_.html#(meth._(((lib._racket/snip..rkt)._snip-class~25)._write-header))",[[0,[2,"write-header"]],[14,[" (method of ",[0,[2,"snip-class%"]],")"]]],["racket/snip","racket/gui/base","racket/gui"]],
["write-headers-to-file",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._write-headers-to-file))",[[0,[2,"write-headers-to-file"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["write-icos",">file/ico.html#(def._((lib._file/ico..rkt)._write-icos))",[0,[2,"write-icos"]],["file/ico"]],
["write-json",">json/index.html#(def._((lib._json/main..rkt)._write-json))",[0,[2,"write-json"]],["json"]],
["write-module-bundle",">raco/exe.html#(def._((lib._compiler/embed..rkt)._write-module-bundle))",[0,[2,"write-module-bundle"]],["compiler/embed"]],
["write-newline",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._write-newline))",[0,[2,"write-newline"]],["deinprogramm/DMdA-advanced"]],
["write-newline",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._write-newline))",[0,[2,"write-newline"]],["deinprogramm/DMdA-assignments"]],
["write-newline",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._write-newline))",[0,[2,"write-newline"]],["deinprogramm/DMdA-beginner"]],
["write-newline",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._write-newline))",[0,[2,"write-newline"]],["deinprogramm/DMdA-vanilla"]],
["write-plist",">xml/index.html#(def._((lib._xml/plist..rkt)._write-plist))",[0,[2,"write-plist"]],["xml/plist"]],
["write-resource",">file/resource.html#(def._((lib._file/resource..rkt)._write-resource))",[0,[2,"write-resource"]],["file/resource"]],
["write-special",">reference/Byte_and_String_Output.html#(def._((quote._~23~25kernel)._write-special))",[0,[2,"write-special"]],["racket/base","racket"]],
["write-special-avail*",">reference/Byte_and_String_Output.html#(def._((quote._~23~25kernel)._write-special-avail*))",[0,[2,"write-special-avail*"]],["racket/base","racket"]],
["write-special-evt",">reference/Byte_and_String_Output.html#(def._((quote._~23~25kernel)._write-special-evt))",[0,[2,"write-special-evt"]],["racket/base","racket"]],
["write-string",">reference/Byte_and_String_Output.html#(def._((quote._~23~25kernel)._write-string))",[0,[2,"write-string"]],["racket/base","racket"]],
["write-string",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._write-string))",[0,[2,"write-string"]],["deinprogramm/DMdA-advanced"]],
["write-string",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._write-string))",[0,[2,"write-string"]],["deinprogramm/DMdA-assignments"]],
["write-string",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._write-string))",[0,[2,"write-string"]],["deinprogramm/DMdA-beginner"]],
["write-string",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._write-string))",[0,[2,"write-string"]],["deinprogramm/DMdA-vanilla"]],
["write-theory",">datalog/interop.html#(def._((lib._datalog/main..rkt)._write-theory))",[0,[2,"write-theory"]],["datalog"]],
["write-to-file",">reference/Filesystem.html#(def._((lib._racket/file..rkt)._write-to-file))",[0,[2,"write-to-file"]],["racket/file","racket"]],
["write-to-file",">gui/editor___.html#(meth._(((lib._mred/main..rkt)._editor~3c~25~3e)._write-to-file))",[[0,[2,"write-to-file"]],[14,[" (method of ",[0,[2,"editor<%>"]],")"]]],["racket/gui/base","racket/gui"]],
["write-to-file",">gui/text_.html#(meth._(((lib._mred/main..rkt)._text~25)._write-to-file))",[[0,[2,"write-to-file"]],[14,[" (method of ",[0,[2,"text%"]],")"]]],["racket/gui/base","racket/gui"]],
["write-with-shared-structure",">srfi-std/srfi-38.html#write-with-shared-structure",[0,[2,"write-with-shared-structure"]],["srfi/38"]],
["write-xexpr",">xml/index.html#(def._((lib._xml/main..rkt)._write-xexpr))",[0,[2,"write-xexpr"]],["xml"]],
["write-xml",">xml/index.html#(def._((lib._xml/main..rkt)._write-xml))",[0,[2,"write-xml"]],["xml"]],
["write-xml/content",">xml/index.html#(def._((lib._xml/main..rkt)._write-xml/content))",[0,[2,"write-xml/content"]],["xml"]],
["write/bytes",">unstable/bytes.html#(def._((lib._unstable/bytes..rkt)._write/bytes))",[0,[2,"write/bytes"]],["unstable/bytes"]],
["writing",">reference/Writing.html","Writing",false],
["writing racket extensions",">inside/overview.html#(part._.Writing_.Racket_.Extensions)","Writing Racket Extensions",false],
["writing regexp patterns",">guide/regexp-intro.html","Writing Regexp Patterns",false],
["writing text files",">scribble/text.html#(part._.Writing_.Text_.Files)","Writing Text Files",false],
["wrong-syntax",">reference/syntax-util.html#(def._((lib._racket/syntax..rkt)._wrong-syntax))",[0,[2,"wrong-syntax"]],["racket/syntax"]],
["ws-close!",">net/websocket.html#(def._((lib._net/websocket/conn..rkt)._ws-close!))",[0,[2,"ws-close!"]],["net/websocket/conn"]],
["ws-conn-closed?",">net/websocket.html#(def._((lib._net/websocket/conn..rkt)._ws-conn-closed~3f))",[0,[2,"ws-conn-closed?"]],["net/websocket/conn"]],
["ws-conn-headers",">net/websocket.html#(def._((lib._net/websocket/conn..rkt)._ws-conn-headers))",[0,[2,"ws-conn-headers"]],["net/websocket/conn"]],
["ws-conn-line",">net/websocket.html#(def._((lib._net/websocket/conn..rkt)._ws-conn-line))",[0,[2,"ws-conn-line"]],["net/websocket/conn"]],
["ws-conn?",">net/websocket.html#(def._((lib._net/websocket/conn..rkt)._ws-conn~3f))",[0,[2,"ws-conn?"]],["net/websocket/conn"]],
["ws-connect",">net/websocket.html#(def._((lib._net/websocket/client..rkt)._ws-connect))",[0,[2,"ws-connect"]],["net/websocket/client"]],
["ws-recv",">net/websocket.html#(def._((lib._net/websocket/conn..rkt)._ws-recv))",[0,[2,"ws-recv"]],["net/websocket/conn"]],
["ws-send!",">net/websocket.html#(def._((lib._net/websocket/conn..rkt)._ws-send!))",[0,[2,"ws-send!"]],["net/websocket/conn"]],
["ws-serve",">net/websocket.html#(def._((lib._net/websocket/server..rkt)._ws-serve))",[0,[2,"ws-serve"]],["net/websocket/server"]],
["ws-url?",">net/websocket.html#(def._((lib._net/websocket/client..rkt)._ws-url~3f))",[0,[2,"ws-url?"]],["net/websocket/client"]],
["wss-url?",">net/websocket.html#(def._((lib._net/websocket/client..rkt)._wss-url~3f))",[0,[2,"wss-url?"]],["net/websocket/client"]],
["wxme",">gui/WXME_Decoding.html",[9,[0,"wxme"]],"module"],
["wxme",">gui/editor-overview.html#(tech._wxme)","<span style=\"font-style: italic\">WXME</span>",false],
["wxme decoding",">gui/WXME_Decoding.html","WXME Decoding",false],
["wxme-port->port",">gui/WXME_Decoding.html#(def._((lib._wxme/main..rkt)._wxme-port-~3eport))",[0,[2,"wxme-port->port"]],["wxme"]],
["wxme-port->text-port",">gui/WXME_Decoding.html#(def._((lib._wxme/main..rkt)._wxme-port-~3etext-port))",[0,[2,"wxme-port->text-port"]],["wxme"]],
["wxme-read",">gui/WXME_Decoding.html#(def._((lib._wxme/main..rkt)._wxme-read))",[0,[2,"wxme-read"]],["wxme"]],
["wxme-read-syntax",">gui/WXME_Decoding.html#(def._((lib._wxme/main..rkt)._wxme-read-syntax))",[0,[2,"wxme-read-syntax"]],["wxme"]],
["wxme/cache-image",">gui/WXME_Decoding.html#(mod-path._wxme/cache-image)",[9,[0,"wxme/cache-image"]],"module"],
["wxme/comment",">gui/WXME_Decoding.html#(mod-path._wxme/comment)",[9,[0,"wxme/comment"]],"module"],
["wxme/editor",">gui/WXME_Decoding.html#(mod-path._wxme/editor)",[9,[0,"wxme/editor"]],"module"],
["wxme/image",">gui/WXME_Decoding.html#(mod-path._wxme/image)",[9,[0,"wxme/image"]],"module"],
["wxme/number",">gui/WXME_Decoding.html#(mod-path._wxme/number)",[9,[0,"wxme/number"]],"module"],
["wxme/scheme",">gui/WXME_Decoding.html#(mod-path._wxme/scheme)",[9,[0,"wxme/scheme"]],"module"],
["wxme/test-case",">gui/WXME_Decoding.html#(mod-path._wxme/test-case)",[9,[0,"wxme/test-case"]],"module"],
["wxme/text",">gui/WXME_Decoding.html#(mod-path._wxme/text)",[9,[0,"wxme/text"]],"module"],
["wxme/xml",">gui/WXME_Decoding.html#(mod-path._wxme/xml)",[9,[0,"wxme/xml"]],"module"],
["x-axis",">plot/renderer2d.html#(def._((lib._plot/main..rkt)._x-axis))",[0,[2,"x-axis"]],["plot"]],
["x-axis-alpha",">plot/params.html#(def._((lib._plot/main..rkt)._x-axis-alpha))",[0,[2,"x-axis-alpha"]],["plot"]],
["x-axis-far?",">plot/params.html#(def._((lib._plot/main..rkt)._x-axis-far~3f))",[0,[2,"x-axis-far?"]],["plot"]],
["x-axis-labels?",">plot/params.html#(def._((lib._plot/main..rkt)._x-axis-labels~3f))",[0,[2,"x-axis-labels?"]],["plot"]],
["x-axis-ticks?",">plot/params.html#(def._((lib._plot/main..rkt)._x-axis-ticks~3f))",[0,[2,"x-axis-ticks?"]],["plot"]],
["x-expression",">xml/index.html#(tech._x._expression)","<span style=\"font-style: italic\">X-expression</span>",false],
["x-expression",">drracket/Graphical_Syntax.html#(tech._x._expression)","<span style=\"font-style: italic\">x-expression</span>",false],
["x-expression support",">web-server/http.html#(part._xexpr)","X-expression Support",false],
["x-icon",">images/Icons.html#(def._((lib._images/icons/symbol..rkt)._x-icon))",[0,[2,"x-icon"]],["images/icons/symbol"]],
["x-place?",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._x-place~3f))",[0,[2,"x-place?"]],["2htdp/image"]],
["x-tick-lines",">plot/renderer2d.html#(def._((lib._plot/main..rkt)._x-tick-lines))",[0,[2,"x-tick-lines"]],["plot"]],
["x-ticks",">plot/nonrenderer.html#(def._((lib._plot/main..rkt)._x-ticks))",[0,[2,"x-ticks"]],["plot"]],
["xbm",">draw/bitmap_.html#(idx._(gentag._3._(lib._scribblings/draw/draw..scrbl)))","XBM",false],
["xbm",">draw/bitmap_.html#(idx._(gentag._9._(lib._scribblings/draw/draw..scrbl)))","XBM",false],
["xcons",">srfi-std/srfi-1.html#xcons",[0,[2,"xcons"]],["srfi/1"]],
["xexpr",">drracket/Graphical_Syntax.html#(tech._xexpr)","<span style=\"font-style: italic\">xexpr</span>",false],
["xexpr->string",">xml/index.html#(def._((lib._xml/main..rkt)._xexpr-~3estring))",[0,[2,"xexpr->string"]],["xml"]],
["xexpr->xml",">xml/index.html#(def._((lib._xml/main..rkt)._xexpr-~3exml))",[0,[2,"xexpr->xml"]],["xml"]],
["xexpr-drop-empty-attributes",">xml/index.html#(def._((lib._xml/main..rkt)._xexpr-drop-empty-attributes))",[0,[2,"xexpr-drop-empty-attributes"]],["xml"]],
["xexpr-forest/c",">web-server/formlets.html#(def._((lib._web-server/formlets/lib..rkt)._xexpr-forest/c))",[0,[2,"xexpr-forest/c"]],["web-server/formlets/lib"]],
["xexpr/c",">xml/index.html#(def._((lib._xml/main..rkt)._xexpr/c))",[0,[2,"xexpr/c"]],["xml"]],
["xexpr?",">xml/index.html#(def._((lib._xml/main..rkt)._xexpr~3f))",[0,[2,"xexpr?"]],["xml"]],
["xform",">raco/cc.html#(def._((lib._compiler/xform..rkt)._xform))",[0,[2,"xform"]],["compiler/xform"]],
["xform_can_ignore",">inside/im_memoryalloc.html#(idx._(gentag._223._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"XFORM_CAN_IGNORE"]],false],
["xform_end_skip",">inside/im_memoryalloc.html#(idx._(gentag._220._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"XFORM_END_SKIP"]],false],
["xform_end_suspend",">inside/im_memoryalloc.html#(idx._(gentag._225._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"XFORM_END_SUSPEND"]],false],
["xform_end_trust_arith",">inside/im_memoryalloc.html#(idx._(gentag._227._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"XFORM_END_TRUST_ARITH"]],false],
["xform_hide_expr",">inside/im_memoryalloc.html#(idx._(gentag._222._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"XFORM_HIDE_EXPR"]],false],
["xform_skip_proc",">inside/im_memoryalloc.html#(idx._(gentag._221._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"XFORM_SKIP_PROC"]],false],
["xform_start_skip",">inside/im_memoryalloc.html#(idx._(gentag._219._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"XFORM_START_SKIP"]],false],
["xform_start_suspend",">inside/im_memoryalloc.html#(idx._(gentag._224._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"XFORM_START_SUSPEND"]],false],
["xform_start_trust_arith",">inside/im_memoryalloc.html#(idx._(gentag._226._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"XFORM_START_TRUST_ARITH"]],false],
["xform_trust_minus",">inside/im_memoryalloc.html#(idx._(gentag._229._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"XFORM_TRUST_MINUS"]],false],
["xform_trust_plus",">inside/im_memoryalloc.html#(idx._(gentag._228._(lib._scribblings/inside/inside..scrbl)))",[1,[6,"XFORM_TRUST_PLUS"]],false],
["xmethod",">scribble/doc-classes.html#(form._((lib._scribble/manual..rkt)._xmethod))",[0,[1,"xmethod"]],["scribble/manual"]],
["xml",">xml/index.html",[9,[0,"xml"]],"module"],
["xml",">web-server/formlets.html#(def._((lib._web-server/formlets/lib..rkt)._xml))",[0,[2,"xml"]],["web-server/formlets/lib"]],
["xml",">planet/Developing_Packages_for_PLaneT.html#(idx._(gentag._7._(lib._planet/planet..scrbl)))",[7,"'xml"],false],
["xml and x-expression conversions",">xml/index.html#(part._.X.M.L_and_.X-expression_.Conversions)","XML and X-expression Conversions",false],
["xml boxes and racket boxes",">drracket/Graphical_Syntax.html#(part._xml-boxes)","XML Boxes and Racket Boxes",false],
["xml->xexpr",">xml/index.html#(def._((lib._xml/main..rkt)._xml-~3exexpr))",[0,[2,"xml->xexpr"]],["xml"]],
["xml-editor%",">gui/WXME_Decoding.html#(def._((lib._wxme/xml..rkt)._xml-editor~25))",[0,[2,"xml-editor%"]],["wxme/xml"]],
["xml-forest",">web-server/formlets.html#(def._((lib._web-server/formlets/lib..rkt)._xml-forest))",[0,[2,"xml-forest"]],["web-server/formlets/lib"]],
["xml/path",">xml/index.html#(mod-path._xml/path)",[9,[0,"xml/path"]],"module"],
["xml/plist",">xml/index.html#(mod-path._xml/plist)",[9,[0,"xml/plist"]],"module"],
["xml: parsing and writing",">xml/index.html","XML: Parsing and Writing",false],
["xor",">reference/booleans.html#(def._((lib._racket/bool..rkt)._xor))",[0,[2,"xor"]],["racket/bool","racket"]],
["xor",">draw/region_.html#(meth._(((lib._racket/draw..rkt)._region~25)._xor))",[[0,[2,"xor"]],[14,[" (method of ",[0,[2,"region%"]],")"]]],["racket/draw"]],
["xor",">mzlib/mzlib_integer-set.html#(def._((lib._mzlib/integer-set..rkt)._xor))",[0,[2,"xor"]],["mzlib/integer-set"]],
["xor",">draw/brush_.html#(idx._(gentag._14._(lib._scribblings/draw/draw..scrbl)))",[7,"'xor"],false],
["xor",">draw/pen_.html#(idx._(gentag._54._(lib._scribblings/draw/draw..scrbl)))",[7,"'xor"],false],
["xor-dot",">draw/pen_.html#(idx._(gentag._60._(lib._scribblings/draw/draw..scrbl)))",[7,"'xor-dot"],false],
["xor-dot-dash",">draw/pen_.html#(idx._(gentag._63._(lib._scribblings/draw/draw..scrbl)))",[7,"'xor-dot-dash"],false],
["xor-long-dash",">draw/pen_.html#(idx._(gentag._61._(lib._scribblings/draw/draw..scrbl)))",[7,"'xor-long-dash"],false],
["xor-short-dash",">draw/pen_.html#(idx._(gentag._62._(lib._scribblings/draw/draw..scrbl)))",[7,"'xor-short-dash"],false],
["xpm",">draw/bitmap_.html#(idx._(gentag._10._(lib._scribblings/draw/draw..scrbl)))","XPM",false],
["xpm",">draw/bitmap_.html#(idx._(gentag._4._(lib._scribblings/draw/draw..scrbl)))","XPM",false],
["xref-binding->definition-tag",">scribble/xref.html#(def._((lib._scribble/xref..rkt)._xref-binding-~3edefinition-tag))",[0,[2,"xref-binding->definition-tag"]],["scribble/xref"]],
["xref-index",">scribble/xref.html#(def._((lib._scribble/xref..rkt)._xref-index))",[0,[2,"xref-index"]],["scribble/xref"]],
["xref-render",">scribble/xref.html#(def._((lib._scribble/xref..rkt)._xref-render))",[0,[2,"xref-render"]],["scribble/xref"]],
["xref-tag->index-entry",">scribble/xref.html#(def._((lib._scribble/xref..rkt)._xref-tag-~3eindex-entry))",[0,[2,"xref-tag->index-entry"]],["scribble/xref"]],
["xref-tag->path+anchor",">scribble/xref.html#(def._((lib._scribble/xref..rkt)._xref-tag-~3epath+anchor))",[0,[2,"xref-tag->path+anchor"]],["scribble/xref"]],
["xref-transfer-info",">scribble/xref.html#(def._((lib._scribble/xref..rkt)._xref-transfer-info))",[0,[2,"xref-transfer-info"]],["scribble/xref"]],
["xref?",">scribble/xref.html#(def._((lib._scribble/xref..rkt)._xref~3f))",[0,[2,"xref?"]],["scribble/xref"]],
["xrepl",">xrepl/index.html",[9,[0,"xrepl"]],"module"],
["xrepl: extended repl",">xrepl/index.html","XREPL: eXtended REPL",false],
["xsubstring",">srfi-std/srfi-13.html#xsubstring",[0,[2,"xsubstring"]],["srfi/13"]],
["y-axis",">plot/renderer2d.html#(def._((lib._plot/main..rkt)._y-axis))",[0,[2,"y-axis"]],["plot"]],
["y-axis-alpha",">plot/params.html#(def._((lib._plot/main..rkt)._y-axis-alpha))",[0,[2,"y-axis-alpha"]],["plot"]],
["y-axis-far?",">plot/params.html#(def._((lib._plot/main..rkt)._y-axis-far~3f))",[0,[2,"y-axis-far?"]],["plot"]],
["y-axis-labels?",">plot/params.html#(def._((lib._plot/main..rkt)._y-axis-labels~3f))",[0,[2,"y-axis-labels?"]],["plot"]],
["y-axis-ticks?",">plot/params.html#(def._((lib._plot/main..rkt)._y-axis-ticks~3f))",[0,[2,"y-axis-ticks?"]],["plot"]],
["y-place?",">teachpack/2htdpimage.html#(def._((lib._2htdp/image..rkt)._y-place~3f))",[0,[2,"y-place?"]],["2htdp/image"]],
["y-tick-lines",">plot/renderer2d.html#(def._((lib._plot/main..rkt)._y-tick-lines))",[0,[2,"y-tick-lines"]],["plot"]],
["y-ticks",">plot/nonrenderer.html#(def._((lib._plot/main..rkt)._y-ticks))",[0,[2,"y-ticks"]],["plot"]],
["yacc",">parser-tools/Parsers.html","yacc",false],
["yellow",">unstable/pict.html#(def._((lib._unstable/gui/pict..rkt)._yellow))",[0,[2,"yellow"]],["unstable/gui/pict"]],
["yellow-star",">teachpack/2htdpPlanet_Cute_Images.html#(def._((lib._2htdp/planetcute..rkt)._yellow-star))",[0,[2,"yellow-star"]],["2htdp/planetcute"]],
["yes",">foreign/Objective-C_FFI.html#(def._((lib._ffi/unsafe/objc..rkt)._.Y.E.S))",[0,[2,"YES"]],["ffi/unsafe/objc"]],
["yield",">reference/Generators.html#(def._((lib._racket/generator..rkt)._yield))",[0,[2,"yield"]],["racket/generator"]],
["yield",">gui/Windowing_Functions.html#(def._((lib._mred/main..rkt)._yield))",[0,[2,"yield"]],["racket/gui/base","racket/gui"]],
["yield",">gui/windowing-overview.html#(tech._yield)","<span style=\"font-style: italic\">yield</span>",false],
["z-axis-alpha",">plot/params.html#(def._((lib._plot/main..rkt)._z-axis-alpha))",[0,[2,"z-axis-alpha"]],["plot"]],
["z-axis-far?",">plot/params.html#(def._((lib._plot/main..rkt)._z-axis-far~3f))",[0,[2,"z-axis-far?"]],["plot"]],
["z-axis-labels?",">plot/params.html#(def._((lib._plot/main..rkt)._z-axis-labels~3f))",[0,[2,"z-axis-labels?"]],["plot"]],
["z-axis-ticks?",">plot/params.html#(def._((lib._plot/main..rkt)._z-axis-ticks~3f))",[0,[2,"z-axis-ticks?"]],["plot"]],
["z-ticks",">plot/nonrenderer.html#(def._((lib._plot/main..rkt)._z-ticks))",[0,[2,"z-ticks"]],["plot"]],
["zero",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types..rkt)._.Zero))",[0,[1,"Zero"]],["typed/racket/base","typed/racket"]],
["zero?",">reference/number-types.html#(def._((quote._~23~25kernel)._zero~3f))",[0,[2,"zero?"]],["racket/base","racket"]],
["zero?",">r5rs-std/r5rs-Z-H-9.html#%_idx_268",[0,[2,"zero?"]],["r5rs"]],
["zero?",">r6rs-std/r6rs-Z-H-14.html#node_idx_474",[0,[2,"zero?"]],["rnrs/base-6"]],
["zero?",">htdp-langs/advanced.html#(def._htdp-advanced._((lib._lang/htdp-advanced..rkt)._zero~3f))",[0,[2,"zero?"]],["lang/htdp-advanced"]],
["zero?",">htdp-langs/beginner.html#(def._htdp-beginner._((lib._lang/htdp-beginner..rkt)._zero~3f))",[0,[2,"zero?"]],["lang/htdp-beginner"]],
["zero?",">htdp-langs/beginner-abbr.html#(def._htdp-beginner-abbr._((lib._lang/htdp-beginner-abbr..rkt)._zero~3f))",[0,[2,"zero?"]],["lang/htdp-beginner-abbr"]],
["zero?",">htdp-langs/intermediate.html#(def._htdp-intermediate._((lib._lang/htdp-intermediate..rkt)._zero~3f))",[0,[2,"zero?"]],["lang/htdp-intermediate"]],
["zero?",">htdp-langs/intermediate-lam.html#(def._htdp-intermediate-lambda._((lib._lang/htdp-intermediate-lambda..rkt)._zero~3f))",[0,[2,"zero?"]],["lang/htdp-intermediate-lambda"]],
["zero?",">deinprogramm/advanced-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-advanced..rkt)._zero~3f))",[0,[2,"zero?"]],["deinprogramm/DMdA-advanced"]],
["zero?",">deinprogramm/assignments-prim-op.html#(def._((lib._deinprogramm/.D.Md.A-assignments..rkt)._zero~3f))",[0,[2,"zero?"]],["deinprogramm/DMdA-assignments"]],
["zero?",">deinprogramm/beginner-prim-ops.html#(def._((lib._deinprogramm/.D.Md.A-beginner..rkt)._zero~3f))",[0,[2,"zero?"]],["deinprogramm/DMdA-beginner"]],
["zero?",">deinprogramm/vanilla-prim-op.html#(def._((lib._deinprogramm/.D.Md.A..rkt)._zero~3f))",[0,[2,"zero?"]],["deinprogramm/DMdA-vanilla"]],
["zero?",">plai/mutator.html#(form._((lib._plai/mutator..rkt)._zero~3f))",[0,[2,"zero?"]],["plai/mutator"]],
["zip",">file/zip.html#(def._((lib._file/zip..rkt)._zip))",[0,[2,"zip"]],["file/zip"]],
["zip",">srfi-std/srfi-1.html#zip",[0,[2,"zip"]],["srfi/1"]],
["zip file creation",">file/zip.html",[[6,"zip"]," File Creation"],false],
["zip->output",">file/zip.html#(def._((lib._file/zip..rkt)._zip-~3eoutput))",[0,[2,"zip->output"]],["file/zip"]],
["zip-verbose",">file/zip.html#(def._((lib._file/zip..rkt)._zip-verbose))",[0,[2,"zip-verbose"]],["file/zip"]],
["zl",">reference/characters.html#(idx._(gentag._147._(lib._scribblings/reference/reference..scrbl)))",[7,"'zl"],false],
["zo",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._zo))",[0,[2,"zo"]],["compiler/zo-structs"]],
["zo-marshal",">raco/decompile.html#(def._((lib._compiler/zo-marshal..rkt)._zo-marshal))",[0,[2,"zo-marshal"]],["compiler/zo-marshal"]],
["zo-marshal-to",">raco/decompile.html#(def._((lib._compiler/zo-marshal..rkt)._zo-marshal-to))",[0,[2,"zo-marshal-to"]],["compiler/zo-marshal"]],
["zo-parse",">raco/decompile.html#(def._((lib._compiler/zo-parse..rkt)._zo-parse))",[0,[2,"zo-parse"]],["compiler/zo-parse"]],
["zo?",">raco/decompile.html#(def._((lib._compiler/zo-structs..rkt)._zo~3f))",[0,[2,"zo?"]],["compiler/zo-structs"]],
["zp",">reference/characters.html#(idx._(gentag._146._(lib._scribblings/reference/reference..scrbl)))",[7,"'zp"],false],
["zs",">reference/characters.html#(idx._(gentag._145._(lib._scribblings/reference/reference..scrbl)))",[7,"'zs"],false],
["zusammengesetzte daten",">deinprogramm/Konstruktionsanleitungen_1_bis_10.html#(part._zusammengesetzte_.Daten)","zusammengesetzte Daten",false],
["zusammengesetzte daten als argumente",">deinprogramm/Konstruktionsanleitungen_1_bis_10.html#(part._zusammengesetzte_.Daten_als_.Argumente)","zusammengesetzte Daten als Argumente",false],
["zusammengesetzte daten als ausgabe",">deinprogramm/Konstruktionsanleitungen_1_bis_10.html#(part._zusammengesetzte_.Daten_als_.Ausgabe)","zusammengesetzte Daten als Ausgabe",false],
["{",">reference/reader.html#(idx._(gentag._24._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"{"],[4,""]]],false],
["|",">reference/reader.html#(idx._(gentag._2._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"|"],[4,""]]],false],
["}",">reference/reader.html#(idx._(gentag._27._(lib._scribblings/reference/reference..scrbl)))",[3,[[4,""],[5,"}"],[4,""]]],false],
["~",">datalog/interop.html#(form._((lib._datalog/main..rkt)._~7e))",[0,[1,"~"]],["datalog"]],
["~",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex-plt-v200..rkt)._~7e))",[0,[1,"~"]],["parser-tools/lex-plt-v200"]],
["~",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex-sre..rkt)._~7e))",[0,[1,"~"]],["parser-tools/lex-sre"]],
["~",">scribble/base.html#(def._((lib._scribble/base..rkt)._~7e))",[0,[2,"~"]],["scribble/base"]],
["~",">drracket/prefs-explanation.html#(idx._(gentag._153._(lib._scribblings/drracket/drracket..scrbl)))",[6,"\"~\""],false],
["~!",">syntax/stxparse-patterns.html#(form._((lib._syntax/parse..rkt)._~7e!))",[0,[1,"~!"]],["syntax/parse"]],
["~and",">syntax/stxparse-patterns.html#(form._((lib._syntax/parse..rkt)._~7eand))",[0,[1,"~and"]],["syntax/parse"]],
["~between",">syntax/stxparse-patterns.html#(form._((lib._syntax/parse..rkt)._~7ebetween))",[0,[1,"~between"]],["syntax/parse"]],
["~bind",">syntax/stxparse-patterns.html#(form._((lib._syntax/parse..rkt)._~7ebind))",[0,[1,"~bind"]],["syntax/parse"]],
["~commit",">syntax/stxparse-patterns.html#(form._((lib._syntax/parse..rkt)._~7ecommit))",[0,[1,"~commit"]],["syntax/parse"]],
["~datum",">syntax/stxparse-patterns.html#(form._((lib._syntax/parse..rkt)._~7edatum))",[0,[1,"~datum"]],["syntax/parse"]],
["~delimit-cut",">syntax/stxparse-patterns.html#(form._((lib._syntax/parse..rkt)._~7edelimit-cut))",[0,[1,"~delimit-cut"]],["syntax/parse"]],
["~describe",">syntax/stxparse-patterns.html#(form._((lib._syntax/parse..rkt)._~7edescribe))",[0,[1,"~describe"]],["syntax/parse"]],
["~do",">syntax/stxparse-patterns.html#(form._((lib._syntax/parse..rkt)._~7edo))",[0,[1,"~do"]],["syntax/parse"]],
["~eh-var",">syntax/Experimental.html#(form._((lib._syntax/parse/experimental/eh..rkt)._~7eeh-var))",[0,[1,"~eh-var"]],["syntax/parse/experimental/eh"]],
["~fail",">syntax/stxparse-patterns.html#(form._((lib._syntax/parse..rkt)._~7efail))",[0,[1,"~fail"]],["syntax/parse"]],
["~literal",">syntax/stxparse-patterns.html#(form._((lib._syntax/parse..rkt)._~7eliteral))",[0,[1,"~literal"]],["syntax/parse"]],
["~not",">syntax/stxparse-patterns.html#(form._((lib._syntax/parse..rkt)._~7enot))",[0,[1,"~not"]],["syntax/parse"]],
["~once",">syntax/stxparse-patterns.html#(form._((lib._syntax/parse..rkt)._~7eonce))",[0,[1,"~once"]],["syntax/parse"]],
["~optional",">syntax/stxparse-patterns.html#(form._((lib._syntax/parse..rkt)._~7eoptional))",[0,[1,"~optional"]],["syntax/parse"]],
["~or",">syntax/stxparse-patterns.html#(form._((lib._syntax/parse..rkt)._~7eor))",[0,[1,"~or"]],["syntax/parse"]],
["~parse",">syntax/stxparse-patterns.html#(form._((lib._syntax/parse..rkt)._~7eparse))",[0,[1,"~parse"]],["syntax/parse"]],
["~peek",">syntax/stxparse-patterns.html#(form._((lib._syntax/parse..rkt)._~7epeek))",[0,[1,"~peek"]],["syntax/parse"]],
["~peek-not",">syntax/stxparse-patterns.html#(form._((lib._syntax/parse..rkt)._~7epeek-not))",[0,[1,"~peek-not"]],["syntax/parse"]],
["~reflect",">syntax/Experimental.html#(form._((lib._syntax/parse/experimental/reflect..rkt)._~7ereflect))",[0,[1,"~reflect"]],["syntax/parse/experimental/reflect"]],
["~rest",">syntax/stxparse-patterns.html#(form._((lib._syntax/parse..rkt)._~7erest))",[0,[1,"~rest"]],["syntax/parse"]],
["~seq",">syntax/stxparse-patterns.html#(form._((lib._syntax/parse..rkt)._~7eseq))",[0,[1,"~seq"]],["syntax/parse"]],
["~splicing-reflect",">syntax/Experimental.html#(form._((lib._syntax/parse/experimental/reflect..rkt)._~7esplicing-reflect))",[0,[1,"~splicing-reflect"]],["syntax/parse/experimental/reflect"]],
["~var",">syntax/stxparse-patterns.html#(form._((lib._syntax/parse..rkt)._~7evar))",[0,[1,"~var"]],["syntax/parse"]],
["\u03b1-rename",">drracket/buttons.html#(idx._(gentag._12._(lib._scribblings/drracket/drracket..scrbl)))","&#945;-rename",false],
["\u03bb",">reference/lambda.html#(form._((lib._racket/private/base..rkt)._~ce~bb))",[0,[1,"&#955;"]],["racket/base","racket"]],
["\u03bb",">htdp-langs/advanced.html#(form._((lib._lang/htdp-advanced..rkt)._~ce~bb))",[0,[1,"&#955;"]],["lang/htdp-advanced"]],
["\u03bb",">htdp-langs/intermediate-lam.html#(form._((lib._lang/htdp-intermediate-lambda..rkt)._~ce~bb))",[0,[1,"&#955;"]],["lang/htdp-intermediate-lambda"]],
["\u03bb",">mzscheme/Old_Syntactic_Forms.html#(form._((lib._mzscheme/main..rkt)._~ce~bb))",[0,[1,"&#955;"]],["mzscheme"]],
["\u03bb",">plai/mutator.html#(form._((lib._plai/mutator..rkt)._~ce~bb))",[0,[1,"&#955;"]],["plai/mutator"]],
["\u03bb",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._~ce~bb))",[0,[1,"&#955;"]],["typed/racket/base","typed/racket"]],
["\u03bb:",">ts-reference/special-forms.html#(form._((lib._typed-racket/base-env/prims..rkt)._~ce~bb~3a))",[0,[1,"&#955;:"]],["typed/racket/base","typed/racket"]],
["\u2192",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types-extra..rkt)._~e2~86~92))",[0,[1,"&#8594;"]],["typed/racket/base","typed/racket"]],
["\u2200",">ts-reference/type-ref.html#(form._((lib._typed-racket/base-env/base-types-extra..rkt)._~e2~88~80))",[0,[1,"&#8704;"]],["typed/racket/base","typed/racket"]]];

// array of pointers to the previous array, for items that are manuals
plt_manual_ptrs = {
  "acks": 1037,
  "algol60": 1257,
  "browser": 2181,
  "cards": 2670,
  "config": 3908,
  "continue": 4062,
  "data": 4597,
  "datalog": 4609,
  "db": 4686,
  "tools": 5538,
  "drracket": 5553,
  "dynext": 5861,
  "embedded-gui": 6132,
  "errortrace": 6431,
  "eopl": 6435,
  "file": 7178,
  "framework": 7889,
  "frtime": 7941,
  "games": 8098,
  "getting-started": 8949,
  "gl-board-game": 8966,
  "sgl": 9166,
  "graphics": 10729,
  "htdp-langs": 11164,
  "teachpack": 11166,
  "html": 11230,
  "images": 11426,
  "htdp": 11526,
  "inside": 11810,
  "json": 12139,
  "lazy": 12388,
  "license": 12573,
  "macro-debugger": 13063,
  "make": 13942,
  "more": 14572,
  "mrlib": 14639,
  "mysterx": 14704,
  "mzcom": 14712,
  "mzlib": 14801,
  "preprocessor": 14803,
  "mzscheme": 14815,
  "net": 14984,
  "openssl": 15664,
  "parser-tools": 15959,
  "picturing-programs": 16283,
  "planet": 16389,
  "plot": 16514,
  "profile": 17090,
  "plai": 17105,
  "quick": 17347,
  "r5rs": 17399,
  "r6rs": 17405,
  "racklog": 17596,
  "rackunit": 17603,
  "raco": 17620,
  "readline": 17889,
  "redex": 18041,
  "release": 18176,
  "scheme": 18930,
  "scribble": 19523,
  "scriblib": 19534,
  "slatex-wrap": 20531,
  "slideshow": 20564,
  "deinprogramm": 20770,
  "srfi": 20967,
  "string-constants": 21231,
  "swindle": 22325,
  "syntax-color": 22436,
  "syntax": 22604,
  "test-engine": 22845,
  "draw": 23074,
  "foreign": 23075,
  "gui": 23076,
  "guide": 23077,
  "reference": 23078,
  "stepper": 23085,
  "ts-guide": 23087,
  "ts-reference": 23088,
  "trace": 23374,
  "turtles": 23496,
  "unstable": 23874,
  "version": 24256,
  "web-server": 24346,
  "web-server-internal": 24350,
  "xml": 24761,
  "xrepl": 24781};
